(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["General`Miscellaneous`",{"Global`","SpinDynamica`"}];


(* ::Input::Initialization:: *)
RToD::"usage"="RToD[rad] converts radians to degrees";


(* ::Input::Initialization:: *)
DToR::"usage"="DToR[deg] converts degrees to radians";


(* ::Input::Initialization:: *)
DeclareAsReal::"usage"="DeclareAsReal[x] declares x to be a real variable. DeclareAsReal[x,y...] declares many variables at the same time";


(* ::Input::Initialization:: *)
SimplifyRules::usage="SimplifyRules[a\[Rule]b,c\[Rule]d..] returns a list of options in which all redundant rules have been stripped out.";


(* ::Input::Initialization:: *)
ReplaceEverywhere::usage="ReplaceEverywhere[a, b->c..] is the same as ReplaceAll (/.) but works inside SparseArrays, which ReplaceAll does not.";


(* ::Input::Initialization:: *)
CurrentOptionsToPassDown::usage="CurrentOptionsToPassDown[f,g] returns a list of options from function f that are suitable for passing down to g. This augments the FilterRules routine by updating any delayed options (\":>\").";


(* ::Input::Initialization:: *)
ChopThreshold::usage="ChopThreshold is an option for several routines setting the threshold for implementations of Chop.";


(* ::Input::Initialization:: *)
DefaultChopThreshold::usage="Default value of ChopThreshold";


(* ::Input::Initialization:: *)
Validity::usage="\!\(\*
StyleBox[\"Validity\",\nFontSlant->\"Italic\"]\) is an option for several routines. If \*
StyleBox[\(V\!\(\*
StyleBox[\"alidity\",\nFontSlant->\"Italic\"]\)\)]\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\), the arguments have passed validity checks.";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
SetAttributes[RToD,Listable];


(* ::Input::Initialization:: *)
RToD[rad_]:=N[(rad *180)/\[Pi]];


(* ::Input::Initialization:: *)
SetAttributes[DToR,Listable];


(* ::Input::Initialization:: *)
DToR[deg_]:=(deg* \[Pi])/180;


(* ::Input::Initialization:: *)
SetAttributes[DeclareAsReal,Listable];


(* ::Input::Initialization:: *)
DeclareAsReal[x_,y__]:=DeclareAsReal[{x,y}];


(* ::Input::Initialization:: *)
DeclareAsReal[x_]:=(Re[x]^=x;Im[x]^=0;Conjugate[x]^=x;Message[DeclareAsReal::dec,x]);


(* ::Input::Initialization:: *)
DeclareAsReal::dec="The symbol `1` has been declared as real.";


(* ::Input::Initialization:: *)
SimplifyRules[rules:((_Rule|_RuleDelayed)...)]:=Sequence@@First/@GatherBy[{rules},First];


(* ::Input::Initialization:: *)
SimplifyRules[{rules:((_Rule|_RuleDelayed)...)}]:={SimplifyRules[rules]};


(* ::Input::Initialization:: *)
CurrentOptionsToPassDown[f_,g_]:=FilterRules[Options[f],Options[g]]/.RuleDelayed[x_,y_]:>Rule[x,y];


(* ::Input::Initialization:: *)
ReplaceEverywhere[a_,opts___Rule]:=ReplaceEverywhere[a,{opts}];


(* ::Input::Initialization:: *)
ReplaceEverywhere[a_,rules:{(_Rule|_RuleDelayed)...}]:=a/.rules/.(sa_SparseArray:>SparseArray[ArrayRules[sa]/.rules,Dimensions[sa]]);


(* ::Input::Initialization:: *)
DefaultChopThreshold=10^-10;


(* ::Input::Initialization:: *)
End[];


(* ::Input::Initialization:: *)
EndPackage[]
