(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["QM`Hilbert`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`"
}
];


(* ::Input::Initialization:: *)
SpinSystem::usage="SpinSystem[] provides the setting for the current spin system.";


(* ::Input::Initialization:: *)
SetSpinSystem::usage="\!\(\*
StyleBox[\"SetSpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Ij\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Ik\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets a spin system with labels \!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\) and spin quantum numbers \!\(\*
StyleBox[\"Ij\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"Ik\",\nFontSlant->\"Italic\"]\). For example, \!\(\*
StyleBox[\"SetSpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines two spins, with labels 1 and 2 and spin quantum numbers 1/2 and 1 respectively. Shortcuts are available, for example: S\!\(\*
StyleBox[\"etSpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"3\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets up a set of 3 spins-1/2 with default labels 1, 2 and 3.";


(* ::Input::Initialization:: *)
SpinQuantumNumber::usage ="\!\(\*
StyleBox[\"SpinQuantumNumber\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)determines the angular momentum quantum number of the spin with the given \!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\), in the current spin system.";


(* ::Input::Initialization:: *)
ValidSpinQ::usage = "\!\(\*
StyleBox[\"ValidSpinQ\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) if the spin label is valid for the current spin system.
\!\(\*
StyleBox[\"ValidSpinQ\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) if all spin labels are valid.
";


(* ::Input::Initialization:: *)
SpinsOrderedQ::usage="\!\(\*
StyleBox[\"SpinsOrderedQ\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) determines whether the spin labels are ordered, according to the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\).";


(* ::Input::Initialization:: *)
Basis::usage="\!\(\*
StyleBox[\"Basis\",\nFontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"MatrixRepresentation\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"VectorRepresentation\",\nFontSlant->\"Italic\"]\), specifying the Hilbert-space basis for these representations";


(* ::Input::Initialization:: *)
BasisLabels::usage="\!\(\*
StyleBox[\"BasisLabels\",\nFontSlant->\"Italic\"]\) is an option for the Hilbert space bases. If \!\(\*
StyleBox[\"BasisLabels\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Automatic\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)(default), the Kets and Bras may be referred to using integers running from 1 to the basis dimension. The option \!\(\*
StyleBox[\"BasisLabels\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"a\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"b\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"c\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) allows the integers or strings \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"a\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"b\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"c\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) to be used to refer to the Kets and Bras. The operation \!\(\*
StyleBox[\"BasisLabels\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) may also be used to obtain the set of state labels defined for a particular basis.";   


(* ::Input::Initialization:: *)
BasisDimension::usage = "\!\(\*
StyleBox[\"BasisDimension\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)returns the dimension of a basis. Example: \!\(\*
StyleBox[\"BasisDimension\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ZeemanBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"BasisDimension\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) refers to the current basis.";


(* ::Input::Initialization:: *)
DefineBasis::usage="\!\(\*
StyleBox[\"DefineBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"newbasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ket1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ket2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a state basis which may be used for operator matrix representations. The option \!\(\*
StyleBox[\"CheckBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) may be used to check its suitability. 
The syntax \!\(\*
StyleBox[\"DefineBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"newbasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"existingbasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\), where basis is the name of an already defined basis, sets the basis kets of \!\(\*
StyleBox[\"newbasis\",\nFontSlant->\"Italic\"]\) to be equal to the basis kets of \!\(\*
StyleBox[\"existingbasis\",\nFontSlant->\"Italic\"]\).
";


(* ::Input::Initialization:: *)
DefinedBasisQ::usage="\!\(\*
StyleBox[\"DefinedBasisQ\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) if \!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\) has been defined as a Hilbert basis.";


(* ::Input::Initialization:: *)
UndefineBasis::usage="\!\(\*
StyleBox[\"UndefineBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) removes the definitions for \!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\) so that the same symbol may be used for a different basis, if desired. ";


(* ::Input::Initialization:: *)
CheckBasis::usage="\!\(\*
StyleBox[\"CheckBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) checks a state basis for orthogonality and normalization";


(* ::Input::Initialization:: *)
SetBasis::usage="\!\(\*
StyleBox[\"SetBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets the state basis of Hilbert space.";


(* ::Input::Initialization:: *)
BasisKets::usage = "\!\(\*
StyleBox[\"BasisKets\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) returns a list of kets for the specified basis.";


(* ::Input::Initialization:: *)
BasisBras::usage = "\!\(\*
StyleBox[\"BasisBras\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) returns a list of bras for the specified basis.";


(* ::Input::Initialization:: *)
BasisTransformationMatrix::usage=
"\!\(\*
StyleBox[\"BasisTransformationMatrix\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) is the matrix that transforms the kets of \!\(\*
StyleBox[\"basis1\",\nFontSlant->\"Italic\"]\) into the kets of \!\(\*
StyleBox[\"basis2\",\nFontSlant->\"Italic\"]\).";


(* ::Input::Initialization:: *)
ZeemanBasis::usage = "\!\(\*
StyleBox[\"ZeemanBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"3\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a Zeeman product basis for spins with indices 1, 2 and 3 and spins 1/2, 1/2, 1 respectively. The list of spins must be ordered. \!\(\*
StyleBox[\"ZeemanBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)defines a Zeeman product basis for the current spin system.";


(* ::Input::Initialization:: *)
SingletTripletBasis::usage = "\!\(\*
StyleBox[\"SingletTripletBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a singlet-triplet basis for spins with indices 1 and 2. This is currently available only for 2-spin-1/2 systems.";


(* ::Input::Initialization:: *)
TransformedBasis::usage ="\!\(\*
StyleBox[\"TransformedBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a basis in which the kets are composed by applying the operator \!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\) to the kets of \!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"TransformedBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) generates a transformation of the current basis.";


(* ::Input::Initialization:: *)
Eigenbasis::usage = "\!\(\*
StyleBox[\"Eigenbasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a basis of eigenkets for the operator \!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\).";


(* ::Input::Initialization:: *)
ProductBasis::usage = "\!\(\*
StyleBox[\"ProductBasis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) defines a basis of product kets constructed from the kets of the argument bases. The kets of the product basis is ordered so that the kets of \!\(\*
StyleBox[\"basis1\",\nFontSlant->\"Italic\"]\) form the innermost loop.";


(* ::Input::Initialization:: *)
Ket::usage=
"Ket[specification,spinsystem] defines a Ket in the specified spinsystem.
If spinsystem is omitted, the current SpinSystem[] is used. Otherwise, spinsystem has the syntax {{j,Ij},{k,Ik}..} where {j,k..} are spin labels and {Ij,Ik..} are spin quantum numbers. 
specification may be:
* a single symbol, which indicates a state label in the current Basis[]. For example, if the default ZeemanBasis[] is used, the value of specification may be an integer {1,2..}, numbering the kets in the current basis;
* a string of the form \"\[Alpha]\[Alpha]..\[Beta]\" indicating magnetic quantum numbers \[PlusMinus]1/2, in the case of spins-1/2;
* a list of the form {{j,Mj},{k,Mk}..} where {j,k..} are spin labels and {Mj,Mk..} are magnetic quantum numbers. The spin labels must correspond to those specified in the spinsystem argument.
";


(* ::Input::Initialization:: *)
KetQ::usage="determines whether an expression has the form of a ket state";


(* ::Input::Initialization:: *)
Bra::usage=
"Bra[specification,spinsystem] defines a Bra in the specified spinsystem.
If spinsystem is omitted, the current SpinSystem[] is used. Otherwise, spinsystem has the syntax {{j,Ij},{k,Ik}..} where {j,k..} are spin labels and {Ij,Ik..} are spin quantum numbers. 
specification may be:
* a single symbol, which indicates a state label in the current Basis[]. For example, if the default ZeemanBasis[] is used, the value of specification may be an integer {1,2..}, numbering the bras in the current basis;
* a string of the form \"\[Alpha]\[Alpha]..\[Beta]\" indicating magnetic quantum numbers \[PlusMinus]1/2, in the case of spins-1/2;
* a list of the form {{j,Mj},{k,Mk}..} where {j,k..} are spin labels and {Mj,Mk..} are magnetic quantum numbers. The spin labels must correspond to those specified in the spinsystem argument.
";


(* ::Input::Initialization:: *)
BraQ::usage="determines whether an expression has the form of a ket state";


(* ::Input::Initialization:: *)
ProductKet::usage="ProductKet[ket1, ket2, ...] returns the direct product of the argument kets. Each of the argument kets must involve a different set of spins. If possible, the spins in the output ket are arranged according to their order in the current SpinSystem[]. ";


(* ::Input::Initialization:: *)
ProductBra::usage="ProductBra[bra1, bra2, ...] returns the direct product of the argument bras. Each of the argument bras must involve a different set of spins. If possible, the spins in the output bra are arranged according to their order in the current SpinSystem[].";


(* ::Input::Initialization:: *)
MagneticQuantumNumber::usage="MagneticQuantumNumber[ket,spins] returns the magnetic quantum number (M-value) for the specified set of spins. If spins is omitted, all spins are taken. 
The syntax MagneticQuantumNumber[ket,{spins1, spins2..}] returns the sets of magnetic quantum numbers for each specified set of spins, and returns a list of the results.";


(* ::Input::Initialization:: *)
VectorRepresentation::usage ="\*
StyleBox[\(V\!\(\*
StyleBox[\"ectorRepresentation\",\nFontSlant->\"Italic\"]\)\)]\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"state\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) provides the vector representation for a state in a given basis. The output is a \!\(\*
StyleBox[\"SparseArray\",\nFontSlant->\"Italic\"]\) and may be viewed by applying \!\(\*
StyleBox[\"MatrixForm\",\nFontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"MatrixPlot\",\nFontSlant->\"Italic\"]\). The current basis is used if \!\(\*
StyleBox[\"basis\",\nFontSlant->\"Italic\"]\) is omitted.";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Options[SpinSystem]={SpinSystem->Undefined};


(* ::Input::Initialization:: *)
SpinSystem[opts___Rule]:=SpinSystem/.{opts}/.Options[SpinSystem];


(* ::Input::Initialization:: *)
HoldPattern@SpinSystem[Plus[a_,b__]]:=
Module[{spinsystems},(
spinsystems=SpinSystem/@{a,b};
If[MatchQ[spinsystems,{spinsystem_?MatrixQ..}],
First@spinsystems,
(Message[SpinSystem::inconsist];$Failed)
]
)];


(* ::Input::Initialization:: *)
HoldPattern@SpinSystem[Times[___?NumericQ,a_,___?NumericQ]]:=SpinSystem[a];


(* ::Input::Initialization:: *)
SpinSystem[basis_?DefinedBasisQ]:=First[basis];


(* ::Input::Initialization:: *)
SpinSystem::notready="The spin system must be set by using SetSpinSystem or SetBasis.";


(* ::Input::Initialization:: *)
SpinSystem::invspin="spin index `1` is not in current spin system. Use SetSpinSystem or SetBasis to set up spin system."; 


(* ::Input::Initialization:: *)
SpinSystem::inconsist="the spin systems are inconsistent.";


(* ::Input::Initialization:: *)
SetSpinSystem[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SetSpinSystem[nspin_Integer]:=
SetSpinSystem[Range[1,nspin]]


(* ::Input::Initialization:: *)
SetSpinSystem[labels:{Except[_List]..}]:=
SetSpinSystem[{#,1/2}&/@labels]


(* ::Input::Initialization:: *)
SetSpinSystem[{{Ij:Except[_List]}}]:=SetSpinSystem[{{1,Ij}}];


(* ::Input::Initialization:: *)
SetSpinSystem[Ijvals:{{_}..}]:=
Module[{n},(
n=Length[Ijvals];
SetSpinSystem[Transpose[{Range[1,n],Flatten@Ijvals}]]
)];


(* ::Input::Initialization:: *)
SetSpinSystem[Ij:Rational[_,2]]:=SetSpinSystem[{{Ij}}];


(* ::Input::Initialization:: *)
SetSpinSystem[spinsys_?MatrixQ]/;MatchQ[Sort[First/@spinsys],{___,lab_,lab_,___}]:=
(Message[SetSpinSystem::dupspins];$Failed);


(* ::Input::Initialization:: *)
SetSpinSystem[spinsys_?MatrixQ]:=
Module[{prevspinsys,prevbasis},(
prevspinsys=SpinSystem[];
prevbasis=Basis[];
SetOptions[SpinSystem,SpinSystem->spinsys];
Message[SetSpinSystem::set,spinsys];
If[
MatchQ[Basis[],Undefined]||!MatchQ[prevspinsys,spinsys],
SetBasis[ZeemanBasis[spinsys]]
]
)
];


(* ::Input::Initialization:: *)
SetSpinSystem::set="the spin system has been set to `1`";


(* ::Input::Initialization:: *)
SetSpinSystem::noord="the spin system labels must be ordered.";


(* ::Input::Initialization:: *)
SetSpinSystem::dupspins="the spin labels must all be different."


(* ::Input::Initialization:: *)
SpinQuantumNumber[i_]:=SpinQuantumNumber[i,SpinSystem[]];


(* ::Input::Initialization:: *)
SpinQuantumNumber[i_,Undefined]:=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
SpinQuantumNumber[i_,spins_?MatrixQ]:=(Message[SpinSystem::invspin, i];$Failed)/;!ValidSpinQ[i,spins];


(* ::Input::Initialization:: *)
SpinQuantumNumber[i_,spins_?MatrixQ]:=Cases[spins,{i,_}][[1,2]]


(* ::Input::Initialization:: *)
ValidSpinQ["x"|"y"|"-x"|"-y"]=False;


(* ::Input::Initialization:: *)
ValidSpinQ[i_]:=ValidSpinQ[i,SpinSystem[]];


(* ::Input::Initialization:: *)
ValidSpinQ[i_,Undefined]:=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
ValidSpinQ[i:Except[_List],spinsys_?MatrixQ]:=ValidSpinQ[i,spinsys]=MemberQ[First/@spinsys,i];


(* ::Input::Initialization:: *)
ValidSpinQ[labels_List,spinsys_?MatrixQ]:=And@@(ValidSpinQ[#,spinsys]&/@labels);


(* ::Input::Initialization:: *)
SpinsOrderedQ[{Repeated[label_]},___]=True;


(* ::Input::Initialization:: *)
SpinsOrderedQ[labels_List]:=SpinsOrderedQ[labels,SpinSystem[]];


(* ::Input::Initialization:: *)
SpinsOrderedQ[labels_List,Undefined]:=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
SpinsOrderedQ[labels_List,spins_?MatrixQ]:=SpinsOrderedQ[labels,spins]=SpinsOrderedQ[labels,First/@spins];


(* ::Input::Initialization:: *)
SpinsOrderedQ[labels_List,spinsyslabels:{Except[_List]...}]:=OrderedQ[Position[spinsyslabels,#]&/@labels];


(* ::Input::Initialization:: *)
Options[Basis]={Basis->Undefined,BasisLabels->Automatic};


(* ::Input::Initialization:: *)
BasisUndefined:=MatchQ[Basis/.Options[Basis],Undefined];


(* ::Input::Initialization:: *)
Basis[opts___Rule]:=Basis/.{opts}/.Options[Basis]


(* ::Input::Initialization:: *)
Basis::unknown="State basis is undefined.";


(* ::Input::Initialization:: *)
Basis::default="Changing to default Zeeman basis..";


(* ::Input::Initialization:: *)
Basis::notON="basis functions are not orthonormal.";


(* ::Input::Initialization:: *)
CheckBasis[Basis->basis_List]:=CheckBasis[basis];


(* ::Input::Initialization:: *)
CheckBasis[opts___Rule]:=CheckBasis[Basis[],opts];


(* ::Input::Initialization:: *)
CheckBasis[basis:Except[_List],opts___Rule]/;CheckedBasisQ[basis]:=(Message[CheckBasis::alreadychkd];True);


(* ::Input::Initialization:: *)
CheckBasis[basis:Except[_List],opts___Rule]/;Length[BasisLabels[basis]]!=Length[BasisKets[basis]]:=(Message[CheckBasis::inapplabels];False);


(* ::Input::Initialization:: *)
CheckBasis[basis:Except[_List],opts___Rule]:=CheckBasis[BasisKets[basis],opts];


(* ::Input::Initialization:: *)
CheckBasis[basiskets_List,opts___Rule]:=CheckBasis[basiskets,Adjoint/@basiskets,opts];


(* ::Input::Initialization:: *)
CheckBasis[basiskets_List,basisbras_List,opts___Rule]:=
Module[{vecs,mat,topleft},(
vecs=VectorRepresentation[#,ZeemanBasis[SpinSystem[]]]&/@basiskets;
If[
Length[basiskets]!=(Times@@((2*SpinQuantumNumber[#]+1)&/@(First/@SpinSystem[]))),
Message[CheckBasis::incomplete]
];
mat=Chop@N@Outer[Dot,Conjugate[vecs],vecs,1];
topleft=mat[[1,1]];
Which[
OrthonormalQ[mat],
	(Message[CheckBasis::orthonormal];True),
DiagonalQ[mat]&&(And@@((#==topleft)&/@Diagonal[mat])),    (Message[CheckBasis::orthogonalsamenorm,topleft];False),
DiagonalQ[mat],
	(Message[CheckBasis::orthogonaldiffnorm,Diagonal[mat]];False),
True,
(Message[CheckBasis::notorthogonal];False)]
)];


(* ::Input::Initialization:: *)
CheckBasis::orthonormal="State basis is orthonormal.";


(* ::Input::Initialization:: *)
CheckBasis::orthogonalsamenorm="State basis is orthogonal but not orthonormal. All kets have the same norm =`1`.";


(* ::Input::Initialization:: *)
CheckBasis::orthogonaldiffnorm="State basis is orthogonal but not orthonormal. The operators have different norms: `1`";


(* ::Input::Initialization:: *)
CheckBasis::notorthogonal="Operator basis is not orthogonal.";


(* ::Input::Initialization:: *)
CheckBasis::incomplete="There are not enough kets for the specified spin system. Matrix representations may be unreliable.";


(* ::Input::Initialization:: *)
CheckBasis::inapplabels="The set of state labels is inappropriate for the given basis. The number of labels might be incorrect.";


(* ::Input::Initialization:: *)
CheckBasis::alreadychkd="no need to check this predefined basis";


(* ::Input::Initialization:: *)
CheckedBasisQ[ZeemanBasis[___]|SingletTripletBasis[___]]:=True;


(* ::Input::Initialization:: *)
CheckedBasisQ[basis:Except[ZeemanBasis[___]|SingletTripletBasis[___]]]:=False;


(* ::Input::Initialization:: *)
Options[DefineBasis]={CheckBasis->True, BasisLabels->Automatic};


(* ::Input::Initialization:: *)
DefineBasis[basis_,existingbasis_?DefinedBasisQ,opts___Rule]:=DefineBasis[basis,BasisKets[existingbasis],opts];


(* ::Input::Initialization:: *)
DefineBasis[basis_,existingbasis_,opts___Rule]/;MatchQ[existingbasis,Except[_List]]&&!DefinedBasisQ[existingbasis]:=(Message[DefineBasis::undefbasis,basis,existingbasis];$Failed);


(* ::Input::Initialization:: *)
DefineBasis[basis_,kets_List,opts___Rule]/;MatchQ[BasisLabels/.{opts}/.Options[DefineBasis],Automatic]:=
DefineBasis[basis,kets,BasisLabels->Range[1,Length[kets]],opts];


(* ::Input::Initialization:: *)
DefineBasis[basis_,kets_List,opts___Rule]/;Length[BasisLabels/.{opts}/.Options[DefineBasis]]!=Length[kets]:=
(Message[DefineBasis::inapplabels];$Failed);


(* ::Input::Initialization:: *)
DefineBasis[basis_,kets_List,opts___Rule]/;DefinedBasisQ[basis]:=(Message[DefineBasis::alreadydef,basis];
UndefineBasis[basis];
DefineBasis[basis,kets,opts]
);


(* ::Input::Initialization:: *)
DefineBasis[basis_,kets_List,opts___Rule]:=
Module[{check,basislabels},(
check=CheckBasis/.{opts}/.Options[DefineBasis];
basislabels=BasisLabels/.{opts}/.Options[DefineBasis];
BasisKets[basis]=kets;
BasisBras[basis]=Adjoint/@kets;
BasisDimension[basis]=Length[kets];
BasisLabels[basis]=basislabels;
Which[
check&&(CheckedBasisQ[basis]||CheckBasis[basis]),
	(Message[DefineBasis::defined,basis];
	DefinedBasisQ[basis]=True;
	CheckedBasisQ[basis]=True;
	SpinSystem[basis]^=SpinSystem[];
	),
check&&!CheckedBasisQ[basis]&&!CheckBasis[basis],
	(Message[DefineBasis::notdefined,basis];
	UndefineBasis[basis];
	DefinedBasisQ[basis]=False;
	$Failed
	),
True,
	(Message[DefineBasis::nocheck,basis];
	Message[DefineBasis::defined,basis];
	DefinedBasisQ[basis]=True;
	CheckedBasisQ[basis]=False;SpinSystem[basis]^=SpinSystem[];
	)
]
)];


(* ::Input::Initialization:: *)
DefineBasis::defined="The state basis `1` has been defined. To use this basis, execute SetBasis[`1`].";


(* ::Input::Initialization:: *)
DefineBasis::notdefined="The state basis `1` is defective and has not been defined.";


(* ::Input::Initialization:: *)
DefineBasis::nocheck="The basis `1` has not been checked for completeness and orthonormality.";


(* ::Input::Initialization:: *)
DefineBasis::inapplabels="The value of BasisLabels is inappropriate.";


(* ::Input::Initialization:: *)
DefineBasis::alreadydef="The basis `1` is already defined. It is now being redefined.";


(* ::Input::Initialization:: *)
DefineBasis::undefbasis="The basis `2` does not exist. The new basis `1` has not been defined.";


(* ::Input::Initialization:: *)
DefinedBasisQ[Except[_ZeemanBasis|_SingletTripletBasis|_Eigenbasis|_TransformedBasis|_ProductBasis]]:=False;


(* ::Input::Initialization:: *)
UndefineBasis[basis_]:=
Module[{btmdefs},(
BasisKets[basis]=.;
BasisBras[basis]=.;
BasisDimension[basis]=.;
BasisLabels[basis]=.;
btmdefs=Select[DownValues[BasisTransformationMatrix],FreeQ[#,basis]&];
Clear[BasisTransformationMatrix];
DownValues[BasisTransformationMatrix]=btmdefs;
DefinedBasisQ[basis]=False;
CheckedBasisQ[basis]=False;
ClearAll[basis];
Message[UndefineBasis::undefined,basis];
If[!DefinedBasisQ[Basis[]],
(Message[UndefineBasis::reset];SetBasis[ZeemanBasis[]])
];
)];


(* ::Input::Initialization:: *)
UndefineBasis::undefined="The state basis `1` has been undefined, and associated basis transformation matrices removed.";


(* ::Input::Initialization:: *)
UndefineBasis::reset="resetting current basis to Zeeman basis..";


(* ::Input::Initialization:: *)
Options[SetBasis]={CheckBasis->True};


(* ::Input::Initialization:: *)
SetBasis[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SetBasis[opts___Rule]:=SetBasis[ZeemanBasis[],opts];


(* ::Input::Initialization:: *)
SetBasis[_[Undefined,___],opts___Rule]:=(Message[SetBasis::spinsysunk];Abort[]);


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;!TrueQ[DefinedBasisQ[basis]]:=(Message[SetBasis::undefined,basis];$Failed);


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;MatchQ[Basis[],basis]:=Message[SetBasis::alreadyset,basis];


(* ::Input::Initialization:: *)
SetBasis[basisname_[spinsys_?MatrixQ,basisopts___Rule],opts___Rule]/;(!TrueQ[spinsys==SpinSystem[]]):=
Module[{basis},(
basis=basisname[spinsys,basisopts];
SetOptions[SpinSystem,SpinSystem->spinsys];
If[!MatchQ[Basis[],basis],SetBasis[basis,opts]]
)];


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;(CheckedBasisQ[basis]||(!CheckBasis/.{opts}/.Options[SetBasis])):=
(
SetOptions[Basis,Basis->basis];
Message[SetBasis::set,basis]; 
);


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;((CheckBasis/.{opts}/.Options[SetBasis])&&CheckBasis[basis]):=
(
SetOptions[Basis,Basis->basis];
Message[SetBasis::set,basis]; 
);


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;((CheckBasis/.{opts}/.Options[SetBasis])&&(!CheckBasis[basis])):=
(Message[SetBasis::unsuitable];
Abort[]);


(* ::Input::Initialization:: *)
SetBasis[basis_,opts___Rule]/;((CheckBasis/.{opts}/.Options[SetBasis])&&(!TrueQ[CheckBasis[basis]])):=
(Message[SetBasis::possunsuitable];
SetBasis[basis,CheckBasis->False,opts]);


(* ::Input::Initialization:: *)
SetBasis::unsuitable="the state basis is unsuitable.";


(* ::Input::Initialization:: *)
SetBasis::set="the state basis has been set to `1`.";


(* ::Input::Initialization:: *)
SetBasis::nocheck="the state basis has not been checked for completeness or orthonormality. Execute CheckBasis[] to check completeness and orthonormality.";


(* ::Input::Initialization:: *)
SetBasis::undefined="The state basis `1` is undefined. It must be defined first using DefineBasis[kets].";


(* ::Input::Initialization:: *)
SetBasis::spinsysunk="SetSpinSystem must be used before defining basis.";


(* ::Input::Initialization:: *)
SetBasis::possunsuitable="The suitability of the basis cannot be determined unambiguously. Proceeding anyway.";


(* ::Input::Initialization:: *)
SetBasis::alreadyset=
"The basis is already set to `1`. No action has been taken.";


(* ::Input::Initialization:: *)
BasisDimension[]:= BasisDimension[Basis[]]


(* ::Input::Initialization:: *)
BasisDimension[Undefined]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
BasisKets[]:= BasisKets[Basis[]]


(* ::Input::Initialization:: *)
BasisKets[Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
BasisKets[Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
BasisKets[opts]
);


(* ::Input::Initialization:: *)
BasisBras[]:= BasisBras[Basis[]]


(* ::Input::Initialization:: *)
BasisBras[Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
BasisBras[Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
BasisBras[opts]
);


(* ::Input::Initialization:: *)
BasisLabels[]:= BasisLabels[Basis[]]


(* ::Input::Initialization:: *)
BasisLabels[basis:type_[Except[_Rule]..,basisopts___Rule],opts___Rule]/;MatchQ[BasisLabels/.{basisopts,opts}/.Options[Basis],Automatic]:=
Range[1,BasisDimension[basis,opts]];


(* ::Input::Initialization:: *)
BasisLabels[basis:type_[Except[_Rule]..,basisopts___Rule],opts___Rule]/;!MatchQ[BasisLabels/.{basisopts,opts}/.Options[Basis],Automatic]:=BasisLabels/.{basisopts,opts}/.Options[Basis];


(* ::Input::Initialization:: *)
BasisLabels[basis_,opts___Rule]:=BasisLabels/.{opts}/.Options[Basis];


(* ::Input::Initialization:: *)
SetAttributes[ZeemanBasis,NHoldFirst]


(* ::Input::Initialization:: *)
ZeemanBasis[labels_List,opts___Rule]:=
ZeemanBasis[{#,1/2}&/@labels,opts]/;(!MatrixQ[labels])&&!MatchQ[labels,{}]


(* ::Input::Initialization:: *)
ZeemanBasis[nspin_Integer,opts___Rule]:=
ZeemanBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
ZeemanBasis[Undefined]:=(Message[SpinSystem::notready];Undefined);


(* ::Input::Initialization:: *)
ZeemanBasis[opts___Rule]:=ZeemanBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
ZeemanBasis[spinsys_?MatrixQ]:=ZeemanBasis[spinsys,BasisLabels->Automatic];


(* ::Input::Initialization:: *)
DefinedBasisQ[ZeemanBasis[spinsys_?MatrixQ,opts___Rule]]=True;


(* ::Input::Initialization:: *)
BasisDimension[ZeemanBasis[spinsys_?MatrixQ,opts___Rule]]:=Times@@((2*#+1)&/@Last[ Transpose[spinsys]]);


(* ::Input::Initialization:: *)
BasisKets[ZeemanBasis[spinsys_?MatrixQ,opts___Rule]]:=
Module[{states},(
states=Table[{First[#],m},{m,Last[#],-Last[#],-1}]&/@spinsys;
Ket[Reverse[#],spinsys,Check->False]&/@Flatten[Outer[List,Sequence@@Reverse[states],1],Length[spinsys]-1]
)];


(* ::Input::Initialization:: *)
BasisBras[ZeemanBasis[spinsys_?MatrixQ,opts___Rule]]:=
Adjoint/@BasisKets[ZeemanBasis[spinsys,opts]];


(* ::Input::Initialization:: *)
SpinSystem[ZeemanBasis[spinsys_?MatrixQ,opts___Rule]]^:=spinsys;


(* ::Input::Initialization:: *)
SetAttributes[SingletTripletBasis,NHoldFirst]


(* ::Input::Initialization:: *)
SingletTripletBasis[labels_List,opts___Rule]:=
SingletTripletBasis[{#,1/2}&/@labels,opts]/;!MatrixQ[labels]


(* ::Input::Initialization:: *)
SingletTripletBasis[nspin_Integer,opts___Rule]:=
SingletTripletBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
SingletTripletBasis[Undefined]:=(Message[SpinSystem::notready];Undefined);


(* ::Input::Initialization:: *)
SingletTripletBasis[opts___Rule]:=SingletTripletBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
SingletTripletBasis[spinsystem_?MatrixQ,opts___Rule]:=(Message[SingletTripletBasis::notspinhf];Abort[])/;!(MatchQ[Last/@spinsystem,{Repeated[1/2]}])


(* ::Input::Initialization:: *)
SingletTripletBasis[spinsystem_?MatrixQ,opts___Rule]:=(Message[SingletTripletBasis::morethantwospins];Abort[])/;Length[spinsystem]!=2


(* ::Input::Initialization:: *)
SingletTripletBasis[spinsys_?MatrixQ]:=SingletTripletBasis[spinsys,BasisLabels->Automatic];


(* ::Input::Initialization:: *)
DefinedBasisQ[SingletTripletBasis[spinsystem_?MatrixQ,opts___Rule]]/;(MatchQ[Last/@spinsystem,{Repeated[1/2]}])=True;


(* ::Input::Initialization:: *)
BasisDimension[SingletTripletBasis[spinsys_?MatrixQ,opts___Rule]]:=4/;(Length[spinsys]==2)


(* ::Input::Initialization:: *)
BasisKets[SingletTripletBasis[spinsys_?MatrixQ,opts___Rule]]:=
{2^(-1/2)*(Ket["\[Alpha]\[Beta]",spinsys,Check->False]-Ket["\[Beta]\[Alpha]",spinsys,Check->False]),
Ket["\[Alpha]\[Alpha]",spinsys,Check->False],
2^(-1/2)*(Ket["\[Alpha]\[Beta]",spinsys,Check->False]+Ket["\[Beta]\[Alpha]",spinsys,Check->False]),
Ket["\[Beta]\[Beta]",spinsys,Check->False]
};


(* ::Input::Initialization:: *)
BasisBras[SingletTripletBasis[args___]]:=
Adjoint/@BasisKets[SingletTripletBasis[args]];


(* ::Input::Initialization:: *)
SpinSystem[SingletTripletBasis[spinsys_?MatrixQ,opts___Rule]]^:=spinsys;


(* ::Input::Initialization:: *)
SingletTripletBasis::notspinhf="singlet-triplet basis is only available for spins-1/2";


(* ::Input::Initialization:: *)
SingletTripletBasis::morethantwospins="singlet-triplet basis is only available for two spins-1/2";


(* ::Input::Initialization:: *)
Options[ProductBasis]={BasisLabels->Automatic,Validity->Undefined};


(* ::Input::Initialization:: *)
ProductBasis[bases:(_?DefinedBasisQ..),more:(Except[_?DefinedBasisQ]...)]:=ProductBasis[{bases},more];


(* ::Input::Initialization:: *)
ProductBasis[bases_List,opts___Rule]:=
ProductBasis[bases,
Join@@(SpinSystem/@bases),
opts
];


(* ::Input::Initialization:: *)
ProductBasis[bases_List,spinsys_?MatrixQ,opts___Rule]/;
(!TrueQ[Validity/.{opts}/.Options[ProductBasis]]):=
Module[{spinsystems,spins,comspins,totspins},(
spinsystems=SpinSystem/@bases;
spins=First[Transpose[#]]&/@spinsystems;
comspins=Intersection@@spins;
totspins=Union@@spins;
Which[
!MatchQ[comspins,{}],
	(Message[ProductBasis::sharedspins,comspins];$Failed),
!And@@(DefinedBasisQ/@bases),
	(Message[ProductBasis::undef,Select[bases,(!DefinedBasisQ[#])&]];$Failed),
!MatchQ[Join@@spinsystems,spinsys],
	(Message[ProductBasis::invalspins];$Failed),
True,
	ProductBasis[
		bases,spinsys,
		Sequence@@FilterRules[
		{Validity->True,opts},
	Options[ProductBasis]
]
]
]
)];


(* ::Input::Initialization:: *)
DefinedBasisQ[ProductBasis[bases_List,spinsys_?MatrixQ,opts___Rule]]:=And@@(DefinedBasisQ/@bases);


(* ::Input::Initialization:: *)
BasisDimension[ProductBasis[bases_List,spinsys_?MatrixQ,opts___Rule]]:=Times@@(BasisDimension/@bases);


(* ::Input::Initialization:: *)
BasisKets[ProductBasis[bases_List,spinsys_?MatrixQ,opts___Rule]]:=
BasisKets[ProductBasis[bases,spinsys,___Rule]]=Simplify@Expand@Flatten[Transpose[Outer[ProductKet,Sequence@@(BasisKets/@bases)],Reverse@Range[Length[bases]]],Length[bases]-1];


(* ::Input::Initialization:: *)
BasisBras[prodbasis_ProductBasis]:=Adjoint/@BasisKets[prodbasis];


(* ::Input::Initialization:: *)
SpinSystem[ProductBasis[bases_List,spinsys_?MatrixQ,opts___Rule]]^:=spinsys;


(* ::Input::Initialization:: *)
ProductBasis::undef="The following argument of ProductBasis is not a defined Basis: `1`";


(* ::Input::Initialization:: *)
ProductBasis::sharedspins="Spins may not be shared between the component bases of a ProductBasis. The following spins are shared: `1`";


(* ::Input::Initialization:: *)
ProductBasis::invalspins="The set of spins comprising the bases of the ProductBasis does not conform to the requested spin system of the ProductBasis.";


(* ::Input::Initialization:: *)
BasisTransformationMatrix[basis2_?DefinedBasisQ]:=BasisTransformationMatrix[basis2,Basis[]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[basis2_?DefinedBasisQ,spinsys_?MatrixQ]:=BasisTransformationMatrix[{basis2,Basis[]},spinsys];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[basis2_?DefinedBasisQ,basis1_?DefinedBasisQ]:=BasisTransformationMatrix[{basis2,basis1}];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis2_?DefinedBasisQ,basis1_?DefinedBasisQ}]:=BasisTransformationMatrix[{basis2,basis1},SpinSystem[basis2]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis2_,basis1_},spinsys_?MatrixQ]/;!SameQ[SpinSystem[basis2],SpinSystem[basis1],spinsys]:=(Message[BasisTransformationMatrix::incompspinsys];
$Failed);


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis_,basis_},spinsys_]:=SparseArray[Band[{1,1}]->Table[1,{BasisDimension[basis]}]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis2_,basis1_},spinsys_]:=
SparseArray@Outer[Dot,BasisBras[basis2],BasisKets[basis1]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix::incompspinsys="The spin systems for the bases are inconsistent.";


(* ::Input::Initialization:: *)
Options[Ket]={Validity->Undefined};


(* ::Input::Initialization:: *)
SetAttributes[Ket,NHoldAll]


(* ::Input::Initialization:: *)
Ket[id_,opts___Rule]:=Ket[id,SpinSystem[],opts];


(* ::Input::Initialization:: *)
Ket[id_,Undefined,opts___Rule]:=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
Ket/:HoldPattern[Dot[___,Ket[___],0,___]]=0;


(* ::Input::Initialization:: *)
HoldPattern@Ket[id_String,spinsys_?MatrixQ,opts___Rule]/;
(!TrueQ[Validity/.{opts}/.Options[Ket]])&&
StringMatchQ[id,Repeated[("\[Alpha]"|"\[Beta]"),{Length[spinsys]}]]&&
MatchQ[Last/@spinsys,{1/2..}]:=
Ket[
MapThread[{#1,Switch[#2,"\[Alpha]",1/2,"\[Beta]",-1/2]}&,{First/@spinsys,Characters[id]}],
spinsys,
SimplifyRules[
Validity->True,
opts
]
];


(* ::Input::Initialization:: *)
Ket[id:Except[_List],spinsys_?MatrixQ,opts___Rule]:=Ket[{id,Basis[]},spinsys,opts];


(* ::Input::Initialization:: *)
Ket[{id:Except[_List],Undefined},spinsys_?MatrixQ,opts___Rule]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
Ket[{id:Except[_List],basis_?DefinedBasisQ},spinsys_?MatrixQ,opts___Rule]/;MemberQ[BasisLabels[basis],id]:=First@Extract[BasisKets[basis],Position[BasisLabels[basis],id]];


(* ::Input::Initialization:: *)
Ket[{id:Except[_List],basis_?DefinedBasisQ},spinsys_?MatrixQ,opts___Rule]/;!TrueQ[MemberQ[BasisLabels[basis],id]]:=(Message[Ket::inappbl];$Failed);


(* ::Input::Initialization:: *)
Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Ket]])&&!(Length[kets]==Length[spinsystem]):=
(Message[Ket::invalidnum];$Failed);


(* ::Input::Initialization:: *)
Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Ket]])&&!And@@(MemberQ[First/@spinsystem,First[#]]&/@kets):=
Module[{invalspins},(
invalspins=Select[First/@kets,!MemberQ[First/@spinsystem,#]&];
Message[Ket::invalidspins,invalspins];
$Failed
)];


(* ::Input::Initialization:: *)
Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]:=
Module[{spinlabels,ketspinlabels,perm},(
perm=SparseArray[
Inner[(List[#1,#2]->1)&,Ordering[spinlabels],Ordering[ketspinlabels],List]
];
Ket[perm.kets,spinsystem,opts]
)/;(
(!TrueQ[Validity/.{opts}/.Options[Ket]])&&(
spinlabels=First/@spinsystem;
ketspinlabels=First/@kets;
(spinlabels!=ketspinlabels)&&
(Sort[spinlabels]==Sort[ketspinlabels])
)
)];


(* ::Input::Initialization:: *)
Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Ket]])&&!Inner[MemberQ[Range[-#2,#2,1],#1]&,Last/@kets,Last/@spinsystem,And]:=
Module[{invalIjMjpairs},(
invalIjMjpairs=Select[kets,!MemberQ[Range[-SpinQuantumNumber[First[#],spinsystem],SpinQuantumNumber[First[#],spinsystem],1],Last[#]]&];
Message[Ket::invalidm,invalIjMjpairs];
$Failed
)];


(* ::Input::Initialization:: *)
Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Ket]]):=
Ket[kets,spinsystem,
SimplifyRules[Validity->True,opts]
];


(* ::Input::Initialization:: *)
Format[
HoldPattern[Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]]/;(
(First/@kets==First/@spinsystem)&&
MatchQ[Last/@spinsystem,{Repeated[1/2]}]
)
]^:=Module[{mvals},(
mvals=Last/@kets;
"\[LeftBracketingBar]"<>StringJoin@@(mvals/.{-1/2->"\[Beta]",1/2->"\[Alpha]"})<>"\[RightAngleBracket]"
)]


(* ::Input::Initialization:: *)
Format[HoldPattern[Ket[kets_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]]/;(
(First/@kets==First/@spinsystem)&&
!MatchQ[Last/@spinsystem,{Repeated[1/2]}]
)
]^:=Module[{Ivals,mvals},(
Ivals=Last/@spinsystem;
mvals=Last/@kets;
RowBox[
Flatten@{"\[LeftBracketingBar]",
Inner[
{DisplayForm@StyleBox[#1],
If[#2>0,
DisplayForm@RowBox[{"+",StyleBox[#2]}],
DisplayForm@StyleBox[#2]
]
}&,
Ivals,
mvals,
List]//.{a___,b_List,c__List}:>{a,b,",",c},
"\[RightAngleBracket]"}
]//DisplayForm
)]


(* ::Input::Initialization:: *)
HoldPattern@Adjoint[Ket[a___]]^:=Bra[a];


(* ::Input::Initialization:: *)
Adjoint/:HoldPattern@Adjoint[Times[n1___,Ket[a___],n2___]]:=ComplexExpand@Conjugate[n1*n2]*Bra[a];


(* ::Input::Initialization:: *)
SpinSystem[Ket[id_,spinsys_?MatrixQ,opts___Rule]]:=spinsys


(* ::Input::Initialization:: *)
KetQ[$Failed]=$Failed;


(* ::Input::Initialization:: *)
HoldPattern@KetQ[Times[x__]]:=Or@@(KetQ/@{x});


(* ::Input::Initialization:: *)
HoldPattern@KetQ[Plus[x__]]:=And@@(KetQ/@{x});


(* ::Input::Initialization:: *)
HoldPattern@KetQ[Ket[___]]:=True;


(* ::Input::Initialization:: *)
KetQ[x_]:=False;


(* ::Input::Initialization:: *)
Ket::invalid\[Alpha]\[Beta]="state indices \[Alpha] and \[Beta] may only be used with spins-1/2";


(* ::Input::Initialization:: *)
Ket::invalidab="indices a and b have been superseded by \[Alpha] and \[Beta]";


(* ::Input::Initialization:: *)
Ket::invalidnum="the number of spins in the Ket and in the spin system do not match.";


(* ::Input::Initialization:: *)
Ket::invalidspins="The following spins do not belong to the requested spin system: `1`";


(* ::Input::Initialization:: *)
Ket::invalidm="the following pairs of spins and magnetic quantum numbers are invalid: `1`";


(* ::Input::Initialization:: *)
Ket::dupspins="product ket must be unique for each spin";


(* ::Input::Initialization:: *)
Ket::inappid="inappropriate identifier";


(* ::Input::Initialization:: *)
Ket::inappbl="inappropriate basis label";


(* ::Input::Initialization:: *)
Options[Bra]={Validity->Undefined};


(* ::Input::Initialization:: *)
SetAttributes[Bra,NHoldAll]


(* ::Input::Initialization:: *)
Bra[id_,opts___Rule]:=Bra[id,SpinSystem[],opts];


(* ::Input::Initialization:: *)
Bra[id_,Undefined,opts___Rule]:=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[___,Bra[___],0,___]]=0;


(* ::Input::Initialization:: *)
Bra[id_String,spinsys_?MatrixQ,opts___Rule]/;
(!TrueQ[Validity/.{opts}/.Options[Bra]])&&
StringMatchQ[id,Repeated[("\[Alpha]"|"\[Beta]"),{Length[spinsys]}]]&&
MatchQ[Last/@spinsys,{1/2..}]:=
Bra[
MapThread[{#1,Switch[#2,"\[Alpha]",1/2,"\[Beta]",-1/2]}&,{First/@spinsys,Characters[id]}],
spinsys,
SimplifyRules[
Validity->True,
opts
]
];


(* ::Input::Initialization:: *)
Bra[id:Except[_List],spinsys_?MatrixQ,opts___Rule]:=Bra[{id,Basis[]},spinsys,opts];


(* ::Input::Initialization:: *)
Bra[{id:Except[_List],Undefined},spinsys_?MatrixQ,opts___Rule]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
Bra[{id:Except[_List],basis_?DefinedBasisQ},spinsys_?MatrixQ,opts___Rule]/;MemberQ[BasisLabels[basis],id]:=First@Extract[BasisBras[basis],Position[BasisLabels[basis],id]];


(* ::Input::Initialization:: *)
Bra[{id:Except[_List],basis_?DefinedBasisQ},spinsys_?MatrixQ,opts___Rule]/;!TrueQ[MemberQ[BasisLabels[basis],id]]:=(Message[Bra::inappbl];$Failed);


(* ::Input::Initialization:: *)
Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Bra]])&&!(Length[bras]==Length[spinsystem]):=
(Message[Bra::invalidnum];$Failed);


(* ::Input::Initialization:: *)
Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Bra]])&&!And@@(MemberQ[First/@spinsystem,First[#]]&/@bras):=
Module[{invalspins},(
invalspins=Select[First/@bras,!MemberQ[First/@spinsystem,#]&];
Message[Bra::invalidspins,invalspins];
$Failed
)];


(* ::Input::Initialization:: *)
Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]:=
Module[{spinlabels,braspinlabels,perm},(
perm=SparseArray[
Inner[(List[#1,#2]->1)&,Ordering[spinlabels],Ordering[braspinlabels],List]
];
Bra[perm.bras,spinsystem,opts]
)/;(
(!TrueQ[Validity/.{opts}/.Options[Bra]])&&(
spinlabels=First/@spinsystem;
braspinlabels=First/@bras;
(spinlabels!=braspinlabels)&&
(Sort[spinlabels]==Sort[braspinlabels])
)
)];


(* ::Input::Initialization:: *)
Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Bra]])&&!Inner[MemberQ[Range[-#2,#2,1],#1]&,Last/@bras,Last/@spinsystem,And]:=
Module[{invalIjMjpairs},(
invalIjMjpairs=Select[bras,!MemberQ[Range[-SpinQuantumNumber[First[#],spinsystem],SpinQuantumNumber[First[#],spinsystem],1],Last[#]]&];
Message[Bra::invalidm,invalIjMjpairs];
$Failed
)];


(* ::Input::Initialization:: *)
Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]/;(!TrueQ[Validity/.{opts}/.Options[Bra]]):=
Bra[bras,spinsystem,
SimplifyRules[Validity->True,opts]
];


(* ::Input::Initialization:: *)
Format[
HoldPattern[Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]]/;(
(First/@bras==First/@spinsystem)&&
MatchQ[Last/@spinsystem,{Repeated[1/2]}]
)
]^:=Module[{mvals},(
mvals=Last/@bras;
"<"<>StringJoin@@(mvals/.{-1/2->"\[Beta]",1/2->"\[Alpha]"})<>"|"
)]


(* ::Input::Initialization:: *)
Format[HoldPattern[Bra[bras_?MatrixQ,spinsystem_?MatrixQ,opts___Rule]]/;(
(First/@bras==First/@spinsystem)&&
!MatchQ[Last/@spinsystem,{Repeated[1/2]}]
)
]^:=Module[{Ivals,mvals},(
Ivals=Last/@spinsystem;
mvals=Last/@bras;
RowBox[
Flatten@{"<",
Inner[
{DisplayForm@StyleBox[#1],
If[#2>0,
DisplayForm@RowBox[{"+",StyleBox[#2]}],
DisplayForm@StyleBox[#2]
]
}&,
Ivals,
mvals,
List]//.{a___,b_List,c__List}:>{a,b,",",c},
"|"}
]//DisplayForm
)]


(* ::Input::Initialization:: *)
HoldPattern@Adjoint[Bra[a___]]^:=Ket[a];


(* ::Input::Initialization:: *)
Adjoint/:HoldPattern@Adjoint[Times[n1___,Bra[a___],n2___]]:=ComplexExpand@Conjugate[n1*n2]*Ket[a];


(* ::Input::Initialization:: *)
SpinSystem[Bra[id_,spinsys_?MatrixQ,opts___Rule]]:=spinsys


(* ::Input::Initialization:: *)
BraQ[$Failed]=$Failed;


(* ::Input::Initialization:: *)
HoldPattern@BraQ[Times[x__]]:=Or@@(BraQ/@{x});


(* ::Input::Initialization:: *)
HoldPattern@BraQ[Plus[x__]]:=And@@(BraQ/@{x});


(* ::Input::Initialization:: *)
HoldPattern@BraQ[Bra[___]]:=True;


(* ::Input::Initialization:: *)
BraQ[x_]:=False;


(* ::Input::Initialization:: *)
Bra::invalid\[Alpha]\[Beta]="state indices \[Alpha] and \[Beta] may only be used with spins-1/2";


(* ::Input::Initialization:: *)
Bra::invalidab="indices a and b have been superseded by \[Alpha] and \[Beta]";


(* ::Input::Initialization:: *)
Bra::invalidnum="the number of spins in the Bra and in the spin system do not match.";


(* ::Input::Initialization:: *)
Bra::invalidspins="The following spins do not belong to the requested spin system: `1`";


(* ::Input::Initialization:: *)
Bra::invalidm="the following pairs of spins and magnetic quantum numbers are invalid: `1`";


(* ::Input::Initialization:: *)
Bra::dupspins="product ket must be unique for each spin";


(* ::Input::Initialization:: *)
Bra::inappid="inappropriate identifier";


(* ::Input::Initialization:: *)
Bra::inappbl="inappropriate basis label";


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[Bra[states_,spins_,___Rule],Ket[states_,spins_,___Rule]]]=1;


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[Bra[bra_,spins_,___Rule],Ket[ket_,spins_,___Rule]]]:=0/;bra!=ket


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[Bra[___],0,Ket[___]]]=0;


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern[Dot[bra_?BraQ,ket_?KetQ]]:=
Module[{spinsys},(
spinsys=SpinSystem[ket];
Dot[VectorRepresentation[bra,ZeemanBasis[spinsys]],VectorRepresentation[ket,ZeemanBasis[spinsys]]]
)]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[Times[n1__,ket_?KetQ,n2___],bra_?BraQ]:=Times[n1,n2,Dot[ket,bra]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[Times[n1___,ket_?KetQ,n2__],bra_?BraQ]:=Times[n1,n2,Dot[ket,bra]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[ket_?KetQ,Times[n1__,bra_?BraQ,n2___]]:=Times[n1,n2,Dot[ket,bra]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[ket_?KetQ,Times[n1___,bra_?BraQ,n2__]]:=Times[n1,n2,Dot[ket,bra]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[Plus[kets__?KetQ],bra_?BraQ]:=
Plus@@(Dot[#,bra]&/@{kets})
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[ket_?KetQ,Plus[bras__?BraQ]]:=
Plus@@(Dot[ket,#]&/@{bras})
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
Dot/:HoldPattern[Dot[ket1_?KetQ,bra2_?BraQ][ket3_?KetQ]]:=Dot[ket1,Dot[bra2,ket3]]
]


(* ::Input::Initialization:: *)
ProductKet[args__]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
ProductKet[kets__?KetQ]:=ProductKet[{kets}];


(* ::Input::Initialization:: *)
ProductKet[kets__?KetQ,spinsys:Except[_?KetQ]]:=ProductKet[{kets},spinsys];


(* ::Input::Initialization:: *)
ProductKet[kets:{__?KetQ}]:=ProductKet[kets,SpinSystem[]];


(* ::Input::Initialization:: *)
ProductKet[{ket1_?KetQ,ket2_?KetQ,kets3__?KetQ},spinsys_]:=ProductKet[{ProductKet[{ket1,ket2},spinsys],kets3},spinsys];


(* ::Input::Initialization:: *)
ProductKet[{ket1:Except[_Ket],ket2_?KetQ},spinsys_]/;KetQ[ket1]:=ket1/.ket_Ket:>ProductKet[{ket,ket2},spinsys];


(* ::Input::Initialization:: *)
ProductKet[{ket1_?KetQ,ket2:Except[_Ket]},spinsys_]/;KetQ[ket2]:=ket2/.ket_Ket:>ProductKet[{ket1,ket},spinsys];


(* ::Input::Initialization:: *)
ProductKet[{ket1_Ket,ket2_Ket},spinsys_]:=
Module[{ssys1,ssys2,comspins,Mvals,ssys12,invalspins},(
ssys1=ket1[[2]];
ssys2=ket2[[2]];
comspins=Intersection[First/@ssys1,First/@ssys2];
Mvals=Join[ket1[[1]],ket2[[1]]];
ssys12=Join[ket1[[2]],ket2[[2]]];
invalspins=Complement[First/@ssys12,First/@spinsys];
Which[
!MatchQ[comspins,{}],
	(Message[ProductKet::comspins,comspins];$Failed),
!MatchQ[invalspins,{}],
	(Message[ProductKet::invalspins,invalspins,spinsys];$Failed),
MatchQ[ssys12,spinsys],
	Ket[Mvals,ssys12],
True,
	Ket[SortBy[Mvals,Position[First/@spinsys,First[#]]&],SortBy[ssys12,Position[First/@spinsys,First[#]]&]]
]
)];


(* ::Input::Initialization:: *)
ProductKet::comspins="Spins may not be shared between the arguments of ProductKet. The following shared spins have been detected: `1`"; 


(* ::Input::Initialization:: *)
ProductKet::invalspins="Spins `1` are not members of the spin system `2` of the ProductKet."; 


(* ::Input::Initialization:: *)
ProductBra[args__]:=Adjoint@ProductKet[Sequence@@(Adjoint/@{args})];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[bra_?BraQ,args___]:=MagneticQuantumNumber[Adjoint[bra],args];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket_?KetQ]:=MagneticQuantumNumber[ket,First/@SpinSystem[ket]];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket_?KetQ,spin:Except[_List]]:=MagneticQuantumNumber[ket,{spin}];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket_?KetQ,spinsets:{_List..}]:=MagneticQuantumNumber[ket,#]&/@spinsets;


(* ::Input::Initialization:: *)
MagneticQuantumNumber[Except[_?KetQ],___]:=(Message[MagneticQuantumNumber::inval];$Failed);


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket_Ket,spins:{Except[_List]..}]/;!ValidSpinQ[spins,SpinSystem[ket]]:=(Message[MagneticQuantumNumber::invalspins];$Failed);


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket_Ket,spins:{Except[_List]..}]:=
Module[{ketspins,Mvals},(
{ketspins,Mvals}=Transpose@First@ket;
Plus@@Flatten[Pick[Mvals,ketspins,#]&/@spins]
)];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[HoldPattern@Times[n1:Except[_?KetQ]...,ket_?KetQ,n2:Except[_?KetQ]..],spins_]:=MagneticQuantumNumber[ket,spins];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[HoldPattern@Times[n1:Except[_?KetQ]..,ket_?KetQ,n2:Except[_?KetQ]...],spins_]:=MagneticQuantumNumber[ket,spins];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket:HoldPattern@Plus[kets__?KetQ],spins:{Except[_List]..}]:=
Module[{Mvals,x},(
Mvals=MagneticQuantumNumber[#,spins]&/@{kets};
Switch[Mvals,{Repeated[x_]},First@Mvals,_,Union[Mvals]]
)];


(* ::Input::Initialization:: *)
MagneticQuantumNumber[ket:HoldPattern@Plus[kets__?KetQ],spinsets:{_List..}]:=
MagneticQuantumNumber[#,spinsets]&/@kets;


(* ::Input::Initialization:: *)
MagneticQuantumNumber::inval="MagneticQuantumNumber may only be applied to a ket or a bra.";


(* ::Input::Initialization:: *)
MagneticQuantumNumber::invalspins="At least one of the specified spins is not valid for the specified ket.";


(* ::Input::Initialization:: *)
Options[VectorRepresentation]={Method->Automatic};


(* ::Input::Initialization:: *)
VectorRepresentation[$Failed,___]:=$Failed;


(* ::Input::Initialization:: *)
VectorRepresentation[state_,opts___Rule]:=
VectorRepresentation[state,Basis[],opts];


(* ::Input::Initialization:: *)
VectorRepresentation[state_,Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
VectorRepresentation[state_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
VectorRepresentation[state,opts]
);


(* ::Input::Initialization:: *)
VectorRepresentation[state_,basis_,opts___Rule]/;!DefinedQ[basis]:=(Message[Basis::unknown];$Failed);


(* ::Input::Initialization:: *)
ElementaryVectorRepresentationArgumentPattern=HoldPattern[_?NumericQ|_?KetQ|_?BraQ];


(* ::Input::Initialization:: *)
PermissibleVectorRepresentationArgumentPattern=ElementaryVectorRepresentationArgumentPattern|HoldPattern@Plus[ElementaryVectorRepresentationArgumentPattern..]|
HoldPattern@Times[_?NumericQ...,ElementaryVectorRepresentationArgumentPattern,_?NumericQ...];


(* ::Input::Initialization:: *)
VectorRepresentation[arg:Except[PermissibleVectorRepresentationArgumentPattern],basis_,opts___Rule]:=Module[{fixedarg},(
VectorRepresentation[fixedarg,basis,opts]
)/;(
fixedarg=Chop[arg];
MatchQ[fixedarg,PermissibleVectorRepresentationArgumentPattern]
)];


(* ::Input::Initialization:: *)
VectorRepresentation[arg:Except[PermissibleVectorRepresentationArgumentPattern],basis_,opts___Rule]:=(Message[VectorRepresentation::badarg];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Ket[{{j_,Mj_}},{{j_,Ij_}},___Rule],ZeemanBasis[{{j_,Ij_}},___Rule],opts___Rule]:=
SparseArray[1+Ij-Mj->1,{2Ij+1}];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Ket[jMjvals:{{_,_}..},jIjvals:{{_,_}..},___Rule],basis:ZeemanBasis[jIjvals_,___Rule],opts___Rule]/;Length[jIjvals]>1:=
Flatten[
KroneckerProduct@@Reverse[
MapThread[VectorRepresentation[Ket[{#1},{#2}],ZeemanBasis[{#2}]]&,{jMjvals,jIjvals}]
]
];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Bra[{{j_,Mj_}},{{j_,Ij_}},___Rule],ZeemanBasis[{{j_,Ij_}},___Rule],opts___Rule]:=
SparseArray[1+Ij-Mj->1,{2Ij+1}];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Bra[jMjvals:{{_,_}..},jIjvals:{{_,_}..},___Rule],basis:ZeemanBasis[jIjvals_,___Rule],opts___Rule]/;Length[jIjvals]>1:=
Flatten[
KroneckerProduct@@Reverse[
MapThread[VectorRepresentation[Bra[{#1},{#2}],ZeemanBasis[{#2}]]&,{jMjvals,jIjvals}]
]
];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[ket_?KetQ,basis_?DefinedBasisQ,opts___Rule]:=Module[{ibasis},(
ibasis=ZeemanBasis[SpinSystem[]];
BasisTransformationMatrix[basis,ibasis].VectorRepresentation[ket,ibasis]
)]/;MatchQ[Method/.{opts}/.Options[VectorRepresentation],Automatic]&&!MatchQ[basis,ZeemanBasis[___]];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[bra_?BraQ,basis_?DefinedBasisQ,opts___Rule]:=Module[{ibasis},(
ibasis=ZeemanBasis[SpinSystem[]];
VectorRepresentation[bra,ibasis].BasisTransformationMatrix[ibasis,basis]
)]/;MatchQ[Method/.{opts}/.Options[VectorRepresentation],Automatic]&&!MatchQ[basis,ZeemanBasis[___]];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[ket:Ket[___],basis_?DefinedBasisQ,opts___Rule]:=
SparseArray[
Map[(#.ket)&,BasisBras[basis]]/.{
HoldPattern[Dot[___,0,___]]:>0,
HoldPattern[Dot[a__,1,b___]]:>Dot[a,b],
HoldPattern[Dot[a___,1,b__]]:>Dot[a,b]
}
]/;MatchQ[Method/.{opts}/.Options[VectorRepresentation],"Direct"]||MatchQ[basis,ZeemanBasis[___]]


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[bra:Bra[___],basis_?DefinedBasisQ,opts___Rule]:=
SparseArray[
Map[(bra.#)&,BasisKets[basis]]/.{
HoldPattern[Dot[___,0,___]]:>0,
HoldPattern[Dot[a__,1,b___]]:>Dot[a,b],
HoldPattern[Dot[a___,1,b__]]:>Dot[a,b]
}
]/;MatchQ[Method/.{opts}/.Options[VectorRepresentation],"Direct"]||MatchQ[basis,ZeemanBasis[___]];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Plus[states___],basis_,opts___Rule]:=
Map[
VectorRepresentation[#,basis,opts]&,
Plus[states]
];


(* ::Input::Initialization:: *)
VectorRepresentation[num_?NumericQ,___]/;(Chop[num]==0):=SparseArray@Table[0,{BasisDimension[]}];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Times[num1:Except[_?KetQ|_?BraQ]..,state_],basis_,opts___Rule]:=
Times[num1,VectorRepresentation[state,basis,opts]];


(* ::Input::Initialization:: *)
HoldPattern@VectorRepresentation[Times[state_,num1:Except[_?KetQ|_?BraQ]..],basis_,opts___Rule]:=
Times[num1,VectorRepresentation[state,basis,opts]];


(* ::Input::Initialization:: *)
VectorRepresentation::badarg="VectorRepresentation may only be applied to a Ket or a Bra.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];
