(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["QM`Liouville`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"QM`SpinOperators`",
"QM`Hilbert`",
"General`Matrices`",
"General`General3D`",
"General`Miscellaneous`"
}];


(* ::Input::Initialization:: *)
DefaultOperatorBasis::usage="DefaultOperatorBasis[] is the default setting for the operator basis, for the current SpinSystem[].";


(* ::Input::Initialization:: *)
OperatorBasis::usage="OperatorBasis[] returns the current operator basis.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::usage="DefineOperatorBasis[newopbasis,{op1,op2,..},opts] defines an operator basis newopbasis which may be used for superoperator matrix representations. The option CheckOperatorBasis->True may be used to check its suitability. 
The syntax DefineOperatorBasis[newopbasis,opbasis,ordering] defines an operator basis newopbasis based on an existing operator basis opbasis by reordering the basis operators. The List ordering specifies how the basis operators are reordered in the new basis. For example, if ordering is given by {2,1,3,4,5...}, then newopbasis  has the same basis operators as opbasis, but with the first two operators exchanged. 
The syntax DefineOperatorBasis[newopbasis,opbasis,superop] defines an operator basis newopbasis based on an existing operator basis opbasis by applying the superoperator superop to each of the basis operators. 
The syntax DefineOperatorBasis[newopbasis,opbasis,superop,ordering] defines an operator basis newopbasis by applying the superoperator superop to each of the basis operators of opbasis, ordered according to the list ordering. 
The definition of a new operator basis using an arbitrary set of basis operators can be computationally intensive; the options described above, which build upon a pre-existing operator basis by reordering the operators and/or applying a superoperator to each of them, are computationally more efficient. 
";


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ::usage="DefinedOperatorBasisQ[opbasis] returns True if opbasis has been defined as an operator basis.";


(* ::Input::Initialization:: *)
UndefineOperatorBasis::usage="UndefineOperatorBasis[opbasis] removes the definitions for opbasis so that the same symbol may be used for a different basis, if desired. ";


(* ::Input::Initialization:: *)
SphericalRank::usage="SphericalRank is a possible setting for the Sorted option of SphericalTensorOperatorBasis.";


(* ::Input::Initialization:: *)
CheckOperatorBasis::usage="CheckOperatorBasis[opbasis] checks an operator basis for orthogonality and normalization";


(* ::Input::Initialization:: *)
CurrentOperatorBasis::usage="CurrentOperatorBasis[] has been superseded by OperatorBasis[].";


(* ::Input::Initialization:: *)
OperatorBasisDimension::usage="OperatorBasisDimension[opbasis] gives the dimension of the specified operator basis. OperatorBasisDimension[] gives the dimension of the current operator basis.";


(* ::Input::Initialization:: *)
BasisOperators::usage="BasisOperators[opbasis] shows the basis operators for a particular operator basis. BasisOperators[] shows the basis operators for the currently active basis.";


(* ::Input::Initialization:: *)
SetOperatorBasis::usage="SetOperatorBasis[opbasis,opts] sets the default operator basis for superoperator matrix representations. The option CheckOperatorBasis->False may be used to disable the time-consuming basis checking step. User-defined bases must first be defined by using the DefineOperatorBasis command.";


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis::usage="ShiftAndPolarizationOperatorBasis[] generates a set of shift and polarization operators for the current spin system (which must have been set first using the SetSpinSystem command of the SpinOperators package). The operators are arranged in the same order as used in the Gamma package. The option Sorted\[Rule]True may be used to arrange the operators according to increasing coherence order. This basis may only be used if all nuclei are spins-1/2.";


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis::usage="CartesianProductOperatorBasis[] generates a set of Cartesian product operators for the current spin system (which must have been set first using the SetSpinSystem command of the SpinOperators package). Currently, this basis may only be used if all nuclei are spins-1/2. The option Sorted->True sorts the operators according to SpinProductRank and CoherenceOrder.";


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis::usage="ShiftAndZOperatorBasis[] generates an orthonormal set of products of shift operators and z operators for the current spin system. The option Sorted->True may be used to sort according to coherence order. This basis is defined for any combination of spin quantum numbers. The option Sorted\[Rule]CoherenceOrder may be used to arrange the operators according to coherence order.";


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis::usage="SingletTripletOperatorBasis[1] generates the direct product between the set of singlet-triplet bras and kets for a 2-spin-1/2 system. The option Sorted->True may be used to sort according to coherence order. SingletTripletOperatorBasis[2] generates the modified singlet-triplet operator basis as used in G. Pileio and M. H. Levitt, J. Chem. Phys. 130, 214501-214514 (2009). This basis is automatically organized according to coherence order.";


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis::usage="ZeemanKetBraOperatorBasis[] generates an operator basis consisting of ket.bra products where each ket and bra is a direct product of the Zeeman kets and bras for the individual spins in the defined spin system. This operator basis may be used for any spin quantum number. For the case of spins-1/2, ZeemanKetBraOperatorBasis is equivalent to ShiftAndPolarizationOperatorBasis. The option Sorted->True may be used to sort according to coherence order. The option Sorted\[Rule]\"Canonical\" generates canonical ordering with the set of Ket-Bra products arranged so that all quantum numbers for the Bras are ordered first, before the Ket quantum numbers are incremented. The option Sorted\[Rule]\"OrderBySpin\" arranges the Ket-Bra products so that all combinations of Ket-Bra quantum numbers for the first spin are completed before the quantum numbers for the second spin are incremented. 
";


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis::usage="SphericalTensorOperatorBasis[] generates an operator basis consisting of the complete set of irreducible spherical tensor operators for the defined spin system. The option Sorted->True or Sorted->{SphericalRank,CoherenceOrder} may be used to sort the basis, first according to spherical rank and then with respect to coherence order. The option Sorted->{CoherenceOrder,SphericalRank} sorts first with respect to coherence order, and then with respect to SphericalRank.";


(* ::Input::Initialization:: *)
Operator::usage=(Operator::usage)<>"
The syntax Operator[op,opbasis,basis,options] causes an operator to be stored as an OperatorVectorRepresentation in the operator basis opbasis.";


(* ::Input::Initialization:: *)
OperatorVectorRepresentation::usage="OperatorVectorRepresentation[op,OperatorBasis->basis] derives the vector representation of an operator in a given operator basis.The vector representation of an operator Q is given by {(B1|Q),(B2|Q)..} where {|B1), |B2)..} are the basis operators.";


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix::usage="OperatorBasisTransformationMatrix[opbasis2,opbasis1] is the matrix that may be applied to the basis operators of opbasis1 to transform them into the basis operators of opbasis2.";


(* ::Input::Initialization:: *)
ExpressOperator::usage="ExpressOperator[op,opbasis,options] expresses an operator as a superposition of basis operators of the specified operator basis opbasis.";


(* ::Input::Initialization:: *)
LiouvilleBracket::usage=
"LiouvilleBracket[A,B,opbasis,basis,options] calculates the bracket Tr(\!\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\).B) using the specified Hilbert basis. The operator basis opbasis and Hilbert basis basis are used: If these are missing, the current OperatorBasis[] and Basis[] are used. 
The option Normalize\[Rule]True normalizes both operators before taking the bracket. The default is Normalize->False.
LiouvilleBracket[A,sop,B,opbasis,basis,options] calculates the bracket Tr(\!\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\).sop[B]) where sop is a superoperator. The operator basis opbasis and Hilbert basis basis are used: If these are missing, the current OperatorBasis[] and Basis[] are used. The option Normalize->True normalizes both operators before taking the bracket. The default is Normalize->False.
";


(* ::Input::Initialization:: *)
OperatorAmplitude::usage=
"OperatorAmplitude[op1\[Rule]op2] provides the answer to a question of the form: \"How much of operator op2 is contained in operator op1?\".
Formally, OperatorAmplitude[op1\[Rule]op2] returns the amplitude a, such that op1\[NonBreakingSpace]=\[NonBreakingSpace]a\[Cross]op2\[NonBreakingSpace]+\[NonBreakingSpace](operators orthogonal to op2).
The amplitude is given by the following expression: a\[NonBreakingSpace]=\[NonBreakingSpace](op2|op1)/(op2|op2) where (A|B)=Tr{\!\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\)B} is a Liouville bracket.
The syntax OperatorAmplitude[op2,op1] is equivalent to OperatorAmplitude[op1\[Rule]op2].";


(* ::Input::Initialization:: *)
Superoperator::usage="Superoperator[matrep,opbasis,basis,opts] defines a spin superoperator that has the matrix representation matrep in the specified operator basis opbasis and state basis basis. The current operator basis and state basis are assumed if opbasis or basis is missing. The options may include SuperoperatorType, which may be used to define whether the operator is unitary, hermitian, etc. Superoperator may also be called with the format Superoperator[sop,opbasis,basis,opts], where sop is a superoperator expression. The routine will then calculate the matrix representation and assign the SuperoperatorType automatically.
Superoperator may also have the form Superoperator[{X,evals,Xinv},opbasis,basis,opts] where X is a matrix whose columns are the eigenvectors of the matrix representation of the superoperator in the operator basis opbasis, evals are the eigenvalues, and Xinv is the inverse of X. This form is generated by applying NDiagonalize to a superoperator.
";


(* ::Input::Initialization:: *)
SuperoperatorType::usage="SuperoperatorType is an option for Superoperator, with possible values {None, Automatic, \"Hermitian\", \"Unitary\",\"Normal\"}";


(* ::Input::Initialization:: *)
CheckSuperoperatorType::usage="CheckSuperoperatorType is an option for Superoperator, which suppresses checking of SuperoperatorType if CheckSuperoperatorType\[Rule]False";


(* ::Input::Initialization:: *)
NDiagonalize::usage=(NDiagonalize::usage)<>"\n
The syntax NDiagonalize[superop,opbasis,basis,opts] causes a superoperator to be converted into diagonalized form in the operator basis opbasis and state basis basis (explicit specification of these bases is optional). The option Assumptions may be used with NDiagonalize when it is applied to a superoperator. If Assumptions\[Rule]Automatic, the setting of SuperoperatorType determines whether assumptions of the type Assumptions\[Rule]{OrthogonalEigenvectors\[Rule]True} are used.";


(* ::Input::Initialization:: *)
SuperoperatorQ::usage="determines whether an expression has the form of a spin superoperator";


(* ::Input::Initialization:: *)
SuperoperatorType::usage="SuperoperatorType may also be applied to a superoperator to determine its type.";


(* ::Input::Initialization:: *)
UnitySuperoperator::usage="UnitySuperoperator[] is the unity superoperator";


(* ::Input::Initialization:: *)
NullSuperoperator::usage="NullSuperoperator[] is the null superoperator";


(* ::Input::Initialization:: *)
CommutationSuperoperator::usage="CommutationSuperoperator[op,opts] is the commutation superoperator for the operator op. The options opts may contain specifications such as OperatorType\[Rule]\"Hermitian\", or Assumptions\[Rule]{OperatorType\[Rule]\"Hermitian\"} which determine how the CommutationSuperoperator is treated.";


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator::usage="LeftMultiplicationSuperoperator[op,opts] is the superoperator that multiplies its operator argument from the left. The options opts may contain specifications such as OperatorType\[Rule]\"Hermitian\", or Assumptions\[Rule]{OperatorType\[Rule]\"Hermitian\"} which determine how the LeftMultiplicationSuperoperator is treated.";


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator::usage="RightMultiplicationSuperoperator[op,opts] is the superoperator that multiplies its operator argument from the right. The options opts may contain specifications such as OperatorType\[Rule]\"Hermitian\", or Assumptions\[Rule]{OperatorType\[Rule]\"Hermitian\"} which determine how the RightMultiplicationSuperoperator is treated.";


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator::usage="DoubleCommutationSuperoperator[op1,op2] is the double commutation superoperator [op1,[op2,<operand>]]";


(* ::Input::Initialization:: *)
ProjectionSuperoperator::usage="ProjectionSuperoperator[op] is the superoperator for projection onto a normalized operator op, i.e. |op)(op|";


(* ::Input::Initialization:: *)
ShiftSuperoperator::usage="ShiftSuperoperator[op2,op1] is the superoperator |op2)(op1|, where both op2 and op1 are automatically normalized before use.";


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator::usage="CoherenceOrderFiltrationSuperoperator[{order1, order2...}] is the superoperator for filtration through a set of coherence orders (all orders in the set {order1, order2...} being allowed, with other orders disallowed). 
CoherenceOrderFiltrationSuperoperator[spins,{order1, order2...}] is the superoperator for filtration through a set of coherence orders of spins (all orders of spins not included in {order1, order2...} are suppressed, while all orders for spins not included in spins are allowed).
CoherenceOrderFiltrationSuperoperator[{spins1,{order1, order2...},{spins2,{order3, order4...}..}] filters successively through {order1, order2...} for spins1, orders {order3, order4...} for spins2, etc. 
Examples: After SetSpinSystem[4], CoherenceOrderFiltrationSuperoperator[0]or CoherenceOrderFiltrationSuperoperator[{0}] suppresses all coherences which are not zero-quantum for all four spins. CoherenceOrderFiltrationSuperoperator[{1,2},0] suppresses all coherences which are not zero-quantum for spins {1,2}, but permits all coherences for spins {3,4}. CoherenceOrderFiltrationSuperoperator[{{1,2},0},{{3,4},0}] suppresses all terms that are not zero-quantum for both sets of spins {1,2} and {3,4}. 
";


(* ::Input::Initialization:: *)
RotationSuperoperator::usage="RotationSuperoperator[spins,angle] is the superoperator for rotating a single spin or a set of spins through the specified angle. If spins is absent, all spins in the current SpinSystem are rotated. The following formats for angle may be used: 1. {\[Beta],\[Phi]} indicates a rotation through \[Beta] about an axis in the xy plane with the phase \[Phi]. The phase value may either be numeric, or be specified using the text codes \"x\", \"y\", \"-x\" for the quadrature phases. A code \"z\" indicates a rotation about the z-axis. 2. The format {\[Xi],{\[Theta],\[Phi]}} indicates a rotation through the angle \[Xi] about an axis with polar angles \[Theta] and \[Phi]. 3. The format {\[Alpha],\[Beta],\[Gamma]} indicates a rotation through the specified Euler angles, using the zyz convention.";


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator::usage="SphericalComponentFiltrationSuperoperator[{\[Lambda],\[Mu]2,\[Mu]1}] is the superoperator for filtering out the spherical component of rank \[Lambda] with quantum order being transformed from \[Mu]1 to \[Mu]2.";


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator::usage="SpinPermutationSuperoperator[{j,k}] is the superoperator for exchange of spin j with spin k. SpinPermutationSuperoperator[{j,k,l,m..}] is the superoperator for a cyclic permutation of the specified spins, with j\[Rule]k,k\[Rule]l,l\[Rule]m, etc. SpinPermutationSuperoperator[{..{j2,k2..},{j1,k1..}}] is the operator for successive spin exchange operations, with the {j1,k1..} permutation preceding the {j2,k2..} permutation, and so on (i.e. right to left order of application).";


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation::usage="SuperoperatorMatrixRepresentation[superop,opbasis] derives the matrix representation of a superoperator in a given operator basis. The option Method\[Rule]Automatic (default) uses an intermediate basis in which factorization of the basis operators into ket-bra products is used to speed up the computation. Method\[Rule]\"Direct\" uses explicit matrix representations of the basis operators in the chosen basis.";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
DefaultOperatorBasis[]:=DefaultOperatorBasis[SpinSystem[]];


(* ::Input::Initialization:: *)
DefaultOperatorBasis[Undefined]:=(Message[OperatorBasis::undefspinsys];$Failed);


(* ::Input::Initialization:: *)
DefaultOperatorBasis[spinsys_?MatrixQ]:=
If[Max[Last/@spinsys]>3/2,
ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],
ShiftAndZOperatorBasis[spinsys,Sorted->CoherenceOrder]
];


(* ::Input::Initialization:: *)
Options[OperatorBasis]={OperatorBasis->Undefined};


(* ::Input::Initialization:: *)
OperatorBasisUndefined:=MatchQ[OperatorBasis/.Options[OperatorBasis],Undefined];


(* ::Input::Initialization:: *)
OperatorBasis[opts___Rule]:=
If[
MatchQ[SpinSystem[],Undefined],
(Message[OperatorBasis::undefspinsys];Undefined),
(SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorBasis[]
)]/;OperatorBasisUndefined;


(* ::Input::Initialization:: *)
OperatorBasis[opts___Rule]:=(
Message[OperatorBasis::inapprop];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorBasis[]
)/;(
(!OperatorBasisUndefined)&&
!Equal[SpinSystem@Basis[],SpinSystem[OperatorBasis/.{opts}/.Options[OperatorBasis]]]
);


(* ::Input::Initialization:: *)
OperatorBasis[opts___Rule]:=(
Message[OperatorBasis::inapprop];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorBasis[]
)/;!MatchQ[
SpinSystem[OperatorBasis/.{opts}/.Options[OperatorBasis]],
SpinSystem[]
];


(* ::Input::Initialization:: *)
OperatorBasis[opts___Rule]:=OperatorBasis/.{opts}/.Options[OperatorBasis];


(* ::Input::Initialization:: *)
OperatorBasis::unknown="Operator basis is undefined.";


(* ::Input::Initialization:: *)
OperatorBasis::inapprop="The current operator basis is inappropriate for the current spin system or the current spin state basis.";


(* ::Input::Initialization:: *)
OperatorBasis::invalidsortopt="Invalid value of Sorted. The operator basis `1` takes the following values of Sorted: `2`";


(* ::Input::Initialization:: *)
OperatorBasis::undefspinsys="The spin system is undefined. Set the spin system using SetSpinSystem[..]";


(* ::Input::Initialization:: *)
Options[DefineOperatorBasis]={CheckOperatorBasis->True};


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,args___]/;DefinedOperatorBasisQ[newopbasis]:=(Message[DefineOperatorBasis::alreadydef,newopbasis];
UndefineOperatorBasis[newopbasis];
DefineOperatorBasis[newopbasis,args]);


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,opts___Rule]:=(
BasisOperators[newopbasis]=BasisOperators[opbasis];DefinedOperatorBasisQ[newopbasis]=True;
SpinSystem[newopbasis]^=SpinSystem[opbasis];
Message[DefineOperatorBasis::defined,newopbasis];
newopbasis
);


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,ordering:{Except[_?OperatorQ]..},opts___Rule]:=DefineOperatorBasis[newopbasis,OperatorBasis[],ordering,opts];


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,ordering:{Except[_?OperatorQ]..},opts___Rule]:=
DefineOperatorBasis[newopbasis,opbasis,UnitySuperoperator[],ordering,opts];


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,sop_?SuperoperatorQ,more___]:=DefineOperatorBasis[newopbasis,OperatorBasis[],sop,more];


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,sop_?SuperoperatorQ,opts___Rule]:=DefineOperatorBasis[newopbasis,opbasis,sop,Range[1,OperatorBasisDimension[opbasis]],opts];


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_,sop_?SuperoperatorQ,ordering:{Except[_?OperatorQ]..},opts___Rule]/;!DefinedOperatorBasisQ[opbasis]:=(Message[DefineOperatorBasis::undefopbasis,opbasis];$Failed);


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,sop_?SuperoperatorQ,ordering:{Except[_?OperatorQ]..},opts___Rule]/;Sort[ordering]!=Range[1,OperatorBasisDimension[opbasis]]:=(Message[DefineOperatorBasis::badordering,OperatorBasisDimension[opbasis]];$Failed);


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,sop_?SuperoperatorQ,ordering:{Except[_?OperatorQ]..},opts___Rule]/;
(CheckOperatorBasis/.{opts}/.Options[DefineOperatorBasis])&&
!UnitaryMatrixQ@SuperoperatorMatrixRepresentation[sop,opbasis]:=(Message[DefineOperatorBasis::notUsop,sop];$Failed);


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,opbasis_?DefinedOperatorBasisQ,sop_?SuperoperatorQ,ordering:{Except[_?OperatorQ]..},opts___Rule]:=
Module[{spinsys,basis,permmat,NL},(
spinsys=SpinSystem[opbasis];
basis=ZeemanBasis[spinsys];
NL=OperatorBasisDimension[opbasis];
BasisOperators[newopbasis]=ExpressOperator[sop[#],opbasis]&/@BasisOperators[opbasis][[ordering]];
permmat=SparseArray@ReplacePart[
DiagonalMatrix[Table[0,{NL}]],
Inner[({#1,#2}->1)&,ordering,Range[1,NL],List]
];
OperatorBasisTransformationMatrix[newopbasis,opbasis,basis]=
permmat.Adjoint@SuperoperatorMatrixRepresentation[sop,opbasis,basis];
IntermediateOperatorBasis[newopbasis]=opbasis;
CheckOperatorBasis[newopbasis]=CheckOperatorBasis[opbasis]&&UnitaryMatrixQ@SuperoperatorMatrixRepresentation[sop,opbasis];
DefinedOperatorBasisQ[newopbasis]=True;
SpinSystem[newopbasis]^=SpinSystem[opbasis];
Message[DefineOperatorBasis::defined,newopbasis];
newopbasis
)];


(* ::Input::Initialization:: *)
DefineOperatorBasis[newopbasis_,basisops:{_?OperatorQ..},opts___Rule]:=
Module[{check,basischeck},(
Message[DefineOperatorBasis::maybeslow];
check=CheckOperatorBasis/.{opts}/.Options[DefineOperatorBasis];
BasisOperators[newopbasis]=basisops;
If[(check&&CheckOperatorBasis[basisops])||!check,
(
DefinedOperatorBasisQ[newopbasis]=True;
SpinSystem[newopbasis]^=SpinSystem[];
Message[DefineOperatorBasis::defined,newopbasis];
If[!check,Message[DefineOperatorBasis::nocheckwarning,newopbasis]];
newopbasis
),
(Message[DefineOperatorBasis::notdef,newopbasis];
BasisOperators[newopbasis]=.
)
]
)];


(* ::Input::Initialization:: *)
DefineOperatorBasis::defined="The operator basis `1` has been defined.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::notdef="The operator basis `1` has not been defined.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::alreadydef="The operator basis `1` is already defined.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::nocheck="The operator basis `1` has not been checked for completeness or orthonormality.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::undefopbasis="The operator basis `1` has not been defined and cannot be used to derive a new operator basis.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::badordering="The ordering list argument must contain the integers from 1 to `1`, each appearing only once.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::notUsop="The superoperator `1` is not unitary.";


(* ::Input::Initialization:: *)
DefineOperatorBasis::maybeslow="An OperatorBasis consisting of an arbitrary set of operators may be slow to set up for larger spin systems. Consider using one of the special cases of DefineOperatorBasis (execute ?DefineOperatorBasis for details).";


(* ::Input::Initialization:: *)
DefineOperatorBasis::nocheckwarning="The new operator basis `1` has not been checked for orthonormality.";


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[TransformedOperatorBasis[opbasis_,sop_,opts___Rule]]^:=DefinedOperatorBasisQ[opbasis,opts];


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[opbasis_]:=False;


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[opbasis_]:=False;


(* ::Input::Initialization:: *)
UndefineOperatorBasis[opbasis_]/;!DefinedOperatorBasisQ[opbasis]:=Message[UndefineOperatorBasis::notdef,opbasis];


(* ::Input::Initialization:: *)
UndefineOperatorBasis[opbasis_]:=
Module[{obtmdefs,iobdefs,chkobdefs},(
BasisOperators[opbasis]=.;
opbasis/:SpinSystem[opbasis]=.;
obtmdefs=Select[DownValues[OperatorBasisTransformationMatrix],FreeQ[#,opbasis]&];
	Clear[OperatorBasisTransformationMatrix];
	DownValues[OperatorBasisTransformationMatrix]=obtmdefs;
iobdefs=Select[DownValues[IntermediateOperatorBasis],FreeQ[#,opbasis]&];
	Clear[IntermediateOperatorBasis];
	DownValues[IntermediateOperatorBasis]=iobdefs;
chkobdefs=Select[DownValues[CheckOperatorBasis],FreeQ[#,opbasis]&];
	Clear[CheckOperatorBasis];
	DownValues[CheckOperatorBasis]=chkobdefs;
DefinedOperatorBasisQ[opbasis]=False;
Message[UndefineOperatorBasis::undefined,opbasis];
)];


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[opbasis_]:=False;


(* ::Input::Initialization:: *)
UndefineOperatorBasis::undefined="The operator basis `1` has been undefined, and associated operator basis transformation matrices removed.";


(* ::Input::Initialization:: *)
UndefineOperatorBasis::notdef="The operator basis `1` is not defined, so cannot be undefined. No action was taken.";


(* ::Input::Initialization:: *)
Options[SetOperatorBasis]={CheckOperatorBasis->False};


(* ::Input::Initialization:: *)
SetOperatorBasis[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SetOperatorBasis[opts___Rule]:=SetOperatorBasis[DefaultOperatorBasis[],opts];


(* ::Input::Initialization:: *)
SetOperatorBasis[opbasis_,opts___Rule]/;(!OperatorBasisUndefined)&&MatchQ[opbasis,OperatorBasis/.{opts}/.Options[OperatorBasis]]:=Message[SetOperatorBasis::alreadyset,opbasis];


(* ::Input::Initialization:: *)
SetOperatorBasis[opbasis_,opts___Rule]/;DefinedOperatorBasisQ[opbasis]&&($KernelCount==0):=
Module[{check},(
check=CheckOperatorBasis/.{opts}/.Options[SetOperatorBasis];
Which[
check,
	If[
	CheckOperatorBasis[opbasis],
		(SetOptions[OperatorBasis,OperatorBasis->opbasis];
		Message[SetOperatorBasis::set,opbasis]
		),
		(Message[SetOperatorBasis::unsuitable];$Failed)
	],
BuiltinOperatorBasisQ[opbasis],
	(
	SetOptions[OperatorBasis,OperatorBasis->opbasis];
	OperatorBasisTransformationMatrix[
		opbasis,
		ZeemanKetBraOperatorBasis[Sorted->"Canonical"]
	];
	Message[SetOperatorBasis::set,opbasis]
	),
True,
	(
	SetOptions[OperatorBasis,OperatorBasis->opbasis];
	OperatorBasisTransformationMatrix[
		opbasis,
		ZeemanKetBraOperatorBasis[Sorted->"Canonical"]
	];
	Message[SetOperatorBasis::set,opbasis];
	If[!TrueQ[CheckOperatorBasis[opbasis]],Message[SetOperatorBasis::nocheck]];
	)
]
)];


(* ::Input::Initialization:: *)
SetOperatorBasis[opbasis_,opts___Rule]/;DefinedOperatorBasisQ[opbasis]&&($KernelCount>0)&&($KernelID==0):=
Module[{check},(
check=CheckOperatorBasis/.{opts}/.Options[SetOperatorBasis];
Which[
check,
	If[
	CheckOperatorBasis[opbasis],
		(
		SetOptions[OperatorBasis,OperatorBasis->opbasis];
		Message[SetOperatorBasis::set,opbasis]
		),
		(Message[SetOperatorBasis::unsuitable];$Failed)
	],
BuiltinOperatorBasisQ[opbasis],
	(
	SetOptions[OperatorBasis,OperatorBasis->opbasis];
	OperatorBasisTransformationMatrix[
		opbasis,
		ZeemanKetBraOperatorBasis[Sorted->"Canonical"]
	];
	Message[SetOperatorBasis::set,opbasis]
	),
True,
	(
	SetOptions[OperatorBasis,OperatorBasis->opbasis];
	OperatorBasisTransformationMatrix[
		opbasis,
		ZeemanKetBraOperatorBasis[Sorted->"Canonical"]
	];
	Message[SetOperatorBasis::set,opbasis];
	If[!TrueQ[CheckOperatorBasis[opbasis]],Message[SetOperatorBasis::nocheck]]
	)
];
DistributeDefinitions[OperatorBasis,OperatorBasisTransformationMatrix]
)];


(* ::Input::Initialization:: *)
SetOperatorBasis[opbasis_,opts___Rule]/;DefinedOperatorBasisQ[opbasis]&&($KernelCount>0)&&($KernelID!=0):=
Module[{check},(
check=CheckOperatorBasis/.{opts}/.Options[SetOperatorBasis];
Which[
check,
	If[
	CheckOperatorBasis[opbasis],
		SetOptions[OperatorBasis,OperatorBasis->opbasis],
		$Failed
	],
True,
	SetOptions[OperatorBasis,OperatorBasis->opbasis]
]
)];


(* ::Input::Initialization:: *)
SetOperatorBasis[opbasis_,opts___Rule]:=(Message[SetOperatorBasis::undefined,opbasis];$Failed);


(* ::Input::Initialization:: *)
SetOperatorBasis::unsuitable="the operator basis is unsuitable.";


(* ::Input::Initialization:: *)
SetOperatorBasis::set="the operator basis has been set to `1`.";


(* ::Input::Initialization:: *)
SetOperatorBasis::nocheck="the operator basis has not been checked for completeness or orthonormality. Execute CheckOperatorBasis[] to check completeness and orthonormality.";


(* ::Input::Initialization:: *)
SetOperatorBasis::undefined="The operator basis `1` is undefined. It must be defined first using DefineOperatorBasis.";


(* ::Input::Initialization:: *)
SetOperatorBasis::alreadyset=
"The operator basis is already set to `1`. No action has been taken.";


(* ::Input::Initialization:: *)
CheckOperatorBasis[OperatorBasis->opbasis_List]:=CheckOperatorBasis[opbasis];


(* ::Input::Initialization:: *)
CheckOperatorBasis[args___]:=
(Message[Basis::unknown];$Failed)/;((Basis/.Options[Basis])==Undefined);


(* ::Input::Initialization:: *)
CheckOperatorBasis[opts___Rule]:=CheckOperatorBasis[OperatorBasis[],opts];


(* ::Input::Initialization:: *)
CheckOperatorBasis[opbasis_?BuiltInOperatorBasisQ,opts___Rule]:=True;


(* ::Input::Initialization:: *)
CheckOperatorBasis[basisops:{_?OperatorQ...},opts___Rule]:=
Module[{vecreps,umat,topleft},(
If[
Length[basisops]!=(Times@@((2*SpinQuantumNumber[#]+1)&/@(First/@SpinSystem[])))^2,
Message[CheckOperatorBasis::incomplete]
];
(*umat=Outer[LiouvilleBracket,basisops,basisops];*)
vecreps=OperatorVectorRepresentation[#,ZeemanKetBraOperatorBasis[]]&/@N@basisops;
umat=SparseArray@Chop@(Dot[Conjugate@vecreps,#]&/@vecreps);
topleft=umat[[1,1]];
Which[
OrthonormalQ[umat],
	(Message[CheckOperatorBasis::orthonormal];True),
DiagonalQ[umat]&&(And@@((#==topleft)&/@Diagonal[umat])),    (Message[CheckOperatorBasis::orthogonalsamenorm,topleft];False),
DiagonalQ[umat],
	(Message[CheckOperatorBasis::orthogonaldiffnorm,Diagonal[umat]];False),
True,
(Message[CheckOperatorBasis::notorthogonal];False)]
)];


(* ::Input::Initialization:: *)
CheckOperatorBasis[opbasis_,opts___Rule]:=
Module[{check},(
check=CheckOperatorBasis[BasisOperators[opbasis],opts];
If[check,CheckOperatorBasis[opbasis,___Rule]=True];
check)];


(* ::Input::Initialization:: *)
CheckOperatorBasis::orthonormal="Operator basis is orthonormal.";


(* ::Input::Initialization:: *)
CheckOperatorBasis::orthogonalsamenorm="Operator basis is orthogonal but not orthonormal. All operators have the same norm =`1`.";


(* ::Input::Initialization:: *)
CheckOperatorBasis::orthogonaldiffnorm="Operator basis is orthogonal but not orthonormal. The operators have different norms: `1`";


(* ::Input::Initialization:: *)
CheckOperatorBasis::notorthogonal="Operator basis is not orthogonal.";


(* ::Input::Initialization:: *)
CheckOperatorBasis::incomplete="Operator basis is incomplete for the specified spin system. Matrix representations of superoperator products may be unreliable.";


(* ::Input::Initialization:: *)
BasisOperators[___]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
BasisOperators[]:=BasisOperators[OperatorBasis[]];


(* ::Input::Initialization:: *)
BasisOperators[Undefined,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
BasisOperators[]
);


(* ::Input::Initialization:: *)
OperatorBasisDimension[___]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
OperatorBasisDimension[]:=OperatorBasisDimension[OperatorBasis[]];


(* ::Input::Initialization:: *)
OperatorBasisDimension[Undefined,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorBasisDimension[]
);


(* ::Input::Initialization:: *)
OperatorBasisDimension[opbasis_,opts___Rule]:=BasisDimension[ZeemanBasis[SpinSystem[opbasis]]]^2;


(* ::Input::Initialization:: *)
SpinSystem[opbasis_?DefinedOperatorBasisQ]:=First[opbasis];


(* ::Input::Initialization:: *)
SetAttributes[ShiftAndPolarizationOperatorBasis,NHoldFirst]


(* ::Input::Initialization:: *)
Options[ShiftAndPolarizationOperatorBasis]={Sorted->True};


(* ::Input::Initialization:: *)
AllowedSortValues[ShiftAndPolarizationOperatorBasis|ShiftAndPolarizationOperatorBasis[___]]={True,False,CoherenceOrder,"Canonical","OrderBySpin"};


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[ShiftAndPolarizationOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[ShiftAndPolarizationOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[opts___Rule]:=
ShiftAndPolarizationOperatorBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[nspin_Integer,opts___Rule]:=
ShiftAndPolarizationOperatorBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[labels:{Except[_List]..},opts___Rule]:=
ShiftAndPolarizationOperatorBasis[{#,1/2}&/@labels,opts];


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[spins:{{_,_}..},opts___Rule]:=
(Message[ShiftAndPolarizationOperatorBasis::notspinshf];$Failed)/;(Union[Last/@spins]!={1/2});


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[spins_?MatrixQ]:=ShiftAndPolarizationOperatorBasis[spins,Sorted->(Sorted/.Options[ShiftAndPolarizationOperatorBasis])];


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[spins_?MatrixQ,opts___Rule]/;(Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis]):=ShiftAndPolarizationOperatorBasis[spins,SimplifyRules[Sorted->CoherenceOrder,opts]];


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[spins_?MatrixQ,opts___Rule]/;MatchQ[Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis],False]:=
ShiftAndPolarizationOperatorBasis[spins,SimplifyRules[Sorted->"Canonical",opts]];


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis[spins_?MatrixQ,opts___Rule]:=
(
Message[OperatorBasis::invalidsortopt,ShiftAndPolarizationOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[ShiftAndPolarizationOperatorBasis]];$Failed
)/;!MemberQ[
AllowedSortValues[ShiftAndPolarizationOperatorBasis],
Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis]
];


(* ::Input::Initialization:: *)
BasisOperators[
ShiftAndPolarizationOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis],"Canonical"]:=
Module[{spinnames,spinstates,spinstateassignments},(
spinnames=First/@spins;
spinstates=Tuples[{"\[Alpha]","\[Beta]"},Length[spins]];
spinstateassignments=Flatten[Outer[Thread[spinnames-> Transpose[{#1,#2}]]&,spinstates,spinstates,1],1];
BasisOperators[
ShiftAndPolarizationOperatorBasis[spins,opts]
]=
OperatorProduct@@@(spinstateassignments/.{Rule[lab_ ,{"\[Alpha]","\[Alpha]"}]:> opI[lab,"\[Alpha]"],Rule[lab_ ,{"\[Alpha]","\[Beta]"}]:> opI[lab,"+"],Rule[lab_ ,{"\[Beta]","\[Alpha]"}]:> opI[lab,"-"],Rule[lab_ ,{"\[Beta]","\[Beta]"}]:> opI[lab,"\[Beta]"]})
)];


(* ::Input::Initialization:: *)
BasisOperators[
ShiftAndPolarizationOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis],"OrderBySpin"]:=
ShiftAndPolarizationOperatorBasis/:BasisOperators[ShiftAndPolarizationOperatorBasis[spins,opts]]=
Flatten@Outer[
OperatorProduct,
Sequence@@(
{opI[#,"\[Alpha]"],opI[#,"\[Beta]"],opI[#,"+"],opI[#,"-"]}&/@Reverse[First/@spins]
)];


(* ::Input::Initialization:: *)
BasisOperators[
ShiftAndPolarizationOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[
Sorted/.{opts}/.Options[ShiftAndPolarizationOperatorBasis],
CoherenceOrder
]:=Module[{sortfunc,g$,opts$},
sortfunc[Q_]:=Q/.{OperatorProduct-> g$}/.{g$[A___,opts$___Rule]:> g$[A]}/.{opI[j_,"\[Alpha]"]:>0,opI[j_,"\[Beta]"]:> 0,opI[j_,"+"]:> 1,opI[j_,"-"]:> -1,g$-> Plus};
SortBy[
BasisOperators[ShiftAndPolarizationOperatorBasis[spins,Sorted->"Canonical"]],
sortfunc
]
]


(* ::Input::Initialization:: *)
ResolveIntoKetsAndBras[ShiftAndPolarizationOperatorBasis[spins_,Sorted->"Canonical"]
]^:={BasisKets[ZeemanBasis[spins]],BasisBras[ZeemanBasis[spins]]};


(* ::Input::Initialization:: *)
SpinSystem[
ShiftAndPolarizationOperatorBasis[spins:{{_,_}..},opts___Rule]
]^:=spins;


(* ::Input::Initialization:: *)
ShiftAndPolarizationOperatorBasis::notspinshf="this operator basis is only available for spins-1/2";


(* ::Input::Initialization:: *)
SetAttributes[CartesianProductOperatorBasis,NHoldFirst]


(* ::Input::Initialization:: *)
Options[CartesianProductOperatorBasis]={Sorted->True};


(* ::Input::Initialization:: *)
AllowedSortValues[CartesianProductOperatorBasis|CartesianProductOperatorBasis[___]]={True,False,SpinProductRank,"OrderBySpin","Canonical"};


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[CartesianProductOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[CartesianProductOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[opts___Rule]:=
CartesianProductOperatorBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[nspin_Integer,opts___Rule]:=
CartesianProductOperatorBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[labels:{Except[_List]..},opts___Rule]:=
CartesianProductOperatorBasis[{#,1/2}&/@labels,opts];


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[spins_?MatrixQ]:=CartesianProductOperatorBasis[spins,Sorted->(Sorted/.Options[CartesianProductOperatorBasis])];


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[spins_?MatrixQ,opts___Rule]/;(Sorted/.{opts}/.Options[CartesianProductOperatorBasis]):=CartesianProductOperatorBasis[spins,SimplifyRules[Sorted->SpinProductRank,opts]];


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[spins_?MatrixQ,opts___Rule]/;MatchQ[Sorted/.{opts}/.Options[CartesianProductOperatorBasis],False|"Canonical"]:=CartesianProductOperatorBasis[spins,SimplifyRules[Sorted->"OrderBySpin",opts]
];


(* ::Input::Initialization:: *)
CartesianProductOperatorBasis[spins_?MatrixQ,opts___Rule]:=
(
Message[OperatorBasis::invalidsortopt,CartesianProductOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[CartesianProductOperatorBasis]];$Failed
)/;!MemberQ[
AllowedSortValues[CartesianProductOperatorBasis],
Sorted/.{opts}/.Options[CartesianProductOperatorBasis]
];


(* ::Input::Initialization:: *)
SingleSpinCartesianBasisOperators[{j_,1/2}]:=Sqrt[2]*{(1/2)UnityOperator[],opI[j,"x"],opI[j,"y"],opI[j,"z"]};


(* ::Input::Initialization:: *)
SingleSpinCartesianBasisOperators[{j_,Ij_}]/;Ij>1/2:=
SingleSpinCartesianBasisOperators[{j,Ij}]=
Module[{shzbops,ops,ZQnumber,dim,pmpos,pppos},(
If[Ij>3/2,PrintTemporary["Calculating a set of Cartesian basis operators can be slow for spins > 3/2. Working..."]];
shzbops=SingleSpinShiftAndZBasisOperators[{j,Ij}];
ZQnumber=2*Ij+1;
dim=(2Ij+1)(2Ij+1);
pmpos=(dim-ZQnumber)/2;
pppos=dim-pmpos+1;
Flatten@{shzbops[[pmpos+1;;pppos-1]],Transpose[{1/Sqrt[2]*(shzbops[[pppos;;]]+Reverse[shzbops[[1;;pmpos]]]),
1/(I Sqrt[2])*(shzbops[[pppos;;]]-Reverse[shzbops[[1;;pmpos]]])}
/.{
opI[j$_,"+"]:>opI[j$,"x"]+I opI[j$,"y"],
opI[j$_,"-"]:>opI[j$,"x"]-I opI[j$,"y"]
}]}//Simplify
)];


(* ::Input::Initialization:: *)
BasisOperators[
CartesianProductOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[CartesianProductOperatorBasis],"OrderBySpin"]:=
CartesianProductOperatorBasis/:BasisOperators[CartesianProductOperatorBasis[spins,opts]]=
Flatten@Outer[
OperatorProduct,
Sequence@@(
SingleSpinCartesianBasisOperators/@Reverse[spins]
)];


(* ::Input::Initialization:: *)
BasisOperators[
CartesianProductOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[
Sorted/.{opts}/.Options[CartesianProductOperatorBasis],
SpinProductRank
]:=
BasisOperators[
CartesianProductOperatorBasis[spins,opts]
]=
Flatten[
Sort/@GatherBy[
BasisOperators[CartesianProductOperatorBasis[spins,Sorted->"OrderBySpin"]
],
SpinProductRank
]
];


(* ::Input::Initialization:: *)
SpinSystem[CartesianProductOperatorBasis[spins:{{_,_}..},opts___Rule]]^:=spins;


(* ::Input::Initialization:: *)
SetAttributes[ShiftAndZOperatorBasis,NHoldFirst]


(* ::Input::Initialization:: *)
Options[ShiftAndZOperatorBasis]={Sorted->CoherenceOrder};


(* ::Input::Initialization:: *)
AllowedSortValues[ShiftAndZOperatorBasis|ShiftAndZOperatorBasis[___]]={True,False,CoherenceOrder,"Canonical","OrderBySpin"};


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[ShiftAndZOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[ShiftAndZOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[opts___Rule]:=
ShiftAndZOperatorBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[nspin_Integer,opts___Rule]:=
ShiftAndZOperatorBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[labels_List,opts___Rule]:=
ShiftAndZOperatorBasis[{#,1/2}&/@labels,opts]/;(!MatrixQ[labels])&&!MatchQ[labels,{}]


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[spins_?MatrixQ]:=ShiftAndZOperatorBasis[spins,Sorted->(Sorted/.Options[ShiftAndZOperatorBasis])];


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[spins_?MatrixQ,opts___Rule]/;(Sorted/.{opts}/.Options[ShiftAndZOperatorBasis]):=ShiftAndZOperatorBasis[spins,SimplifyRules[Sorted->CoherenceOrder,opts]];


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[spins_?MatrixQ,opts___Rule]/;MatchQ[Sorted/.{opts}/.Options[ShiftAndZOperatorBasis],False|"Canonical"]:=ShiftAndZOperatorBasis[spins,SimplifyRules[Sorted->"OrderBySpin",opts]
];


(* ::Input::Initialization:: *)
ShiftAndZOperatorBasis[spins_?MatrixQ,opts___Rule]:=
(Message[OperatorBasis::invalidsortopt,ShiftAndZOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[ShiftAndZOperatorBasis]];$Failed)/;
!MemberQ[
AllowedSortValues[ShiftAndZOperatorBasis],
Sorted/.{opts}/.Options[ShiftAndZOperatorBasis]
];


(* ::Input::Initialization:: *)
SingleSpinShiftAndZBasisOperators[{j_,Ij_}]:=Module[{d$,Iplus,Iz,Id,\[Phi],SZops,SZzreps,SZpreps,SZreps,\[Phi]vec,len,newset},
d$[k_.*p_Plus,B_]:=k*d$[#,B]&/@p;
d$[A_,k_.*p_Plus]:=k*d$[A,#]&/@p;
d$[k1_. \[Phi][m_],k2_. \[Phi][n_]]:=k1*k2*Conjugate[SZreps[[m]]].SZreps[[n]];
{Id,Iplus,Iz}={
IdentityMatrix[2Ij+1,SparseArray],
SparseArray[Band[{1,2}]->Sqrt[Ij(Ij+1)-#(#-1)]&@Range[-Ij+1,Ij,1],
{2Ij+1,2Ij+1}],
SparseArray[Band[{1,1}]->Range[+Ij,-Ij,-1]]
};
SZops=Join[SingleSpinShiftAndZBasisOperators[{j,Ij,0}],Flatten[SingleSpinShiftAndZBasisOperators[{j,Ij,#}]&/@Range[1,2*Ij]]];
SZzreps=Flatten/@SingleSpinShiftAndZBasisOperators[Id,Iz,Iplus,{j,Ij,0}];
SZpreps=Flatten/@Flatten[SingleSpinShiftAndZBasisOperators[Id,Iz,Iplus,{j,Ij,#}]&/@Range[1,2*Ij],1];
SZreps=Join[SZzreps,SZpreps];
\[Phi]vec=Array[\[Phi],Length[SZops]];
len=Length[SZzreps];
newset=(Orthogonalize[\[Phi]vec,d$])/.Thread[\[Phi]vec-> SZops];
newset=newset//Collect[#,(_opI|_OperatorProduct),Simplify]&//Simplify;
SingleSpinShiftAndZBasisOperators[{j,Ij}]=
(
If[Ij>3/2,PrintTemporary["Calculating the basis operators for ShiftAndZOperatorBasis can be slow for spins > 3/2. Working..."]];
Flatten[{Reverse[#]/.{"+"-> "-"},newset[[1;;len]],#}]&@newset[[len+1;;]]
)
];


(* ::Input::Initialization:: *)
SingleSpinShiftAndZBasisOperators[{j_,Ij_,p_}]/;p>0:=
SingleSpinShiftAndZBasisOperators[{j,Ij,p}]=
Module[{Iplusp,zops},
Iplusp=OperatorProduct@@Table[opI[j,"+"],{Abs[p]}];
zops=Table[OperatorProduct@@Join[{UnityOperator[]},Table[opI[j,"z"],{i}]],{i,0,2Ij-Abs[p]}];
((Iplusp.#)+(#.Iplusp))&/@zops
];


(* ::Input::Initialization:: *)
SingleSpinShiftAndZBasisOperators[Id_,Iz_,Ip_,{j_,Ij_,p_}]/;p>0:=
SingleSpinShiftAndZBasisOperators[Id,Iz,Ip,{j,Ij,p}]=
Module[{Iplusp,zops},
Iplusp=MatrixPower[Ip,Abs[p]];
zops=Join[{Id},MatrixPower[Iz,#]&/@Range[1,2Ij-Abs[p]]];
((Iplusp.#)+(#.Iplusp))&/@zops
];


(* ::Input::Initialization:: *)
SingleSpinShiftAndZBasisOperators[{j_,Ij_,0}]:=
SingleSpinShiftAndZBasisOperators[{j,Ij,0}]=Table[OperatorProduct@@Join[{UnityOperator[]},Table[opI[j,"z"],{i}]],{i,0,2Ij}];


(* ::Input::Initialization:: *)
SingleSpinShiftAndZBasisOperators[Id_,Iz_,Ip_,{j_,Ij_,0}]:=
SingleSpinShiftAndZBasisOperators[Id,Iz,Ip,{j,Ij,0}]=Join[{Id},MatrixPower[Iz,#]&/@Range[1,2Ij]];


(* ::Input::Initialization:: *)
BasisOperators[
ShiftAndZOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[ShiftAndZOperatorBasis],"OrderBySpin"]:=
Module[{ops,temp},(
ops=SingleSpinShiftAndZBasisOperators/@Reverse[spins];
BasisOperators[
ShiftAndZOperatorBasis[spins,opts]
]=
(Flatten@Fold[Outer[OperatorProduct,#1,#2]&,First[ops],Drop[ops,1]])
)];


(* ::Input::Initialization:: *)
BasisOperators[
ShiftAndZOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[
Sorted/.{opts}/.Options[ShiftAndZOperatorBasis],
CoherenceOrder
]:=Module[{sortfunc,g$,opts$},
sortfunc[Q_]:=ExpandAll[Q]/.{P_Plus:>First[P]}/.{k_ *A_opI:> A,k_ *A_OperatorProduct:> A}/.{OperatorProduct-> g$}/.{g$[A___,opts$___Rule]:> g$[A]}/.{opI[_,"-"]-> -1,opI[_,"z"]-> 0,opI[_,"+"]-> +1,_UnityOperator-> 0}/.{g$-> Plus};
BasisOperators[ShiftAndZOperatorBasis[spins,SimplifyRules[Sorted->CoherenceOrder,opts]]]=
SortBy[
BasisOperators[ShiftAndZOperatorBasis[spins,Sorted->"OrderBySpin",opts]],
sortfunc
]
]


(* ::Input::Initialization:: *)
SpinSystem[
ShiftAndZOperatorBasis[spins:{{_,_}..},opts___Rule]
]^:=spins;


(* ::Input::Initialization:: *)
SetAttributes[SingletTripletOperatorBasis,NHoldAll]


(* ::Input::Initialization:: *)
Options[SingletTripletOperatorBasis]={Sorted->True};


(* ::Input::Initialization:: *)
AllowedSortValues[SingletTripletOperatorBasis|SingletTripletOperatorBasis[___]]={True,False,CoherenceOrder,"Canonical"};


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[opts___Rule]:=SingletTripletOperatorBasis[1,opts];


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[SingletTripletOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[SingletTripletOperatorBasis[1|2,___]]=True;


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,opts___Rule]:=
SingletTripletOperatorBasis[type,SpinSystem[],opts];


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins:{{_,_}..},opts___Rule]:=
(Message[SingletTripletOperatorBasis::notspinshf];$Failed)/;(Union[Last/@spins]!={1/2});


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins:{{_,_}..},opts___Rule]:=
(Message[SingletTripletOperatorBasis::nottwospinshf];$Failed)/;(Length[spins]!=2);


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis::notspinshf="this operator basis is only available for spins-1/2";


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis::nottwospinshf="this operator basis is only available for two spins-1/2";


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins_?MatrixQ]:=SingletTripletOperatorBasis[type,spins,Sorted->(Sorted/.Options[SingletTripletOperatorBasis])];


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins_?MatrixQ,opts___Rule]/;(Sorted/.{opts}/.Options[SingletTripletOperatorBasis]):=SingletTripletOperatorBasis[type,spins,SimplifyRules[Sorted->CoherenceOrder,opts]];


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins_?MatrixQ,opts___Rule]/;MatchQ[Sorted/.{opts}/.Options[SingletTripletOperatorBasis],False]:=
SingletTripletOperatorBasis[type,spins,SimplifyRules[Sorted->"Canonical",opts]];


(* ::Input::Initialization:: *)
SingletTripletOperatorBasis[type_Integer,spins_?MatrixQ,opts___Rule]:=
(
Message[OperatorBasis::invalidsortopt,SingletTripletOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[SingletTripletOperatorBasis]];$Failed
)/;!MemberQ[
AllowedSortValues[SingletTripletOperatorBasis],
Sorted/.{opts}/.Options[SingletTripletOperatorBasis]
];


(* ::Input::Initialization:: *)
BasisOperators[
SingletTripletOperatorBasis[1,spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[SingletTripletOperatorBasis],"Canonical"]:=
Simplify[
Flatten[#,1]&@Outer[
Dot,
BasisKets[SingletTripletBasis@spins],BasisBras[SingletTripletBasis@spins]
]
];


(* ::Input::Initialization:: *)
BasisOperators[
SingletTripletOperatorBasis[1,spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[SingletTripletOperatorBasis],CoherenceOrder]:=
Module[{j,k,ket\[Alpha]\[Alpha],ket\[Alpha]\[Beta],ket\[Beta]\[Alpha],ket\[Beta]\[Beta],ketS0,ketT1,ketT0,ketTm1,braS0,braT1,braT0,braTm1},(
{j,k}=First/@spins;
{ket\[Alpha]\[Alpha],ket\[Alpha]\[Beta],ket\[Beta]\[Alpha],ket\[Beta]\[Beta]}=Flatten@Outer[Ket[{{j,#1},{k,#2}},Validity->True]&,{1/2,-1/2},{1/2,-1/2}];
{ketS0,ketT1,ketT0,ketTm1}={(ket\[Alpha]\[Beta]-ket\[Beta]\[Alpha])/Sqrt[2],ket\[Alpha]\[Alpha],(ket\[Alpha]\[Beta]+ket\[Beta]\[Alpha])/Sqrt[2],ket\[Beta]\[Beta]};
{braS0,braT1,braT0,braTm1}=Adjoint/@{ketS0,ketT1,ketT0,ketTm1};
BasisOperators[
SingletTripletOperatorBasis[1,spins,opts]
]=
Reverse[
{ketT1.braTm1,
ketT1.braS0,ketT1.braT0,ketS0.braTm1,ketT0.braTm1,
ketS0.braS0,ketT1.braT1,ketT0.braT0,ketTm1.braTm1,ketS0.braT0,ketT0.braS0,
ketTm1.braS0,ketTm1.braT0,ketS0.braT1,ketT0.braT1,
ketTm1.braT1}
]
)//Simplify
];


(* ::Input::Initialization:: *)
BasisOperators[
SingletTripletOperatorBasis[2,spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[SingletTripletOperatorBasis],"Canonical"]:=
Module[{j,k,ket\[Alpha]\[Alpha],ket\[Alpha]\[Beta],ket\[Beta]\[Alpha],ket\[Beta]\[Beta],ketS0,ketT1,ketT0,ketTm1,braS0,braT1,braT0,braTm1},(
{j,k}=First/@spins;
{ket\[Alpha]\[Alpha],ket\[Alpha]\[Beta],ket\[Beta]\[Alpha],ket\[Beta]\[Beta]}=Flatten@Outer[Ket[{{j,#1},{k,#2}},Validity->True]&,{1/2,-1/2},{1/2,-1/2}];
{ketS0,ketT1,ketT0,ketTm1}={(ket\[Alpha]\[Beta]-ket\[Beta]\[Alpha])/Sqrt[2],ket\[Alpha]\[Alpha],(ket\[Alpha]\[Beta]+ket\[Beta]\[Alpha])/Sqrt[2],ket\[Beta]\[Beta]};
{braS0,braT1,braT0,braTm1}=Adjoint/@{ketS0,ketT1,ketT0,ketTm1};
BasisOperators[
SingletTripletOperatorBasis[2,spins,opts]
]=
{ketT1.braTm1,
ketT1.braS0,ketT1.braT0,ketS0.braTm1,ketT0.braTm1,
(1/2)(ketS0.braS0+ketT1.braT1+ketT0.braT0+ketTm1.braTm1),
(1/(2Sqrt[3]))*(3ketS0.braS0-ketT1.braT1-ketT0.braT0-ketTm1.braTm1),
(1/Sqrt[2])(ketT1.braT1-ketTm1.braTm1),
(1/Sqrt[6])(-ketT1.braT1+2ketT0.braT0-ketTm1.braTm1),
ketS0.braT0,
ketT0.braS0,
ketTm1.braS0,ketTm1.braT0,ketS0.braT1,ketT0.braT1,
ketTm1.braT1}
)]//Simplify


(* ::Input::Initialization:: *)
BasisOperators[
SingletTripletOperatorBasis[2,spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[SingletTripletOperatorBasis],CoherenceOrder]:=
BasisOperators[
SingletTripletOperatorBasis[2,spins,opts]
]=
SortBy[
BasisOperators[
SingletTripletOperatorBasis[2,spins,SimplifyRules[Sorted->"Canonical"]
]
],
CoherenceOrder
];


(* ::Input::Initialization:: *)
SpinSystem[
SingletTripletOperatorBasis[n_Integer,spins:{{_,_}..},opts___Rule]
]^:=spins;


(* ::Input::Initialization:: *)
SetAttributes[ZeemanKetBraOperatorBasis,NHoldFirst]


(* ::Input::Initialization:: *)
Options[ZeemanKetBraOperatorBasis]={Sorted->"Canonical"};


(* ::Input::Initialization:: *)
AllowedSortValues[ZeemanKetBraOperatorBasis|ZeemanKetBraOperatorBasis[___]]={True,False,CoherenceOrder,"Canonical","OrderBySpin"};


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[ZeemanKetBraOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[ZeemanKetBraOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[opts___Rule]:=
ZeemanKetBraOperatorBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[nspin_Integer,opts___Rule]:=
ZeemanKetBraOperatorBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[labels:{Except[_List]..},opts___Rule]:=
ZeemanKetBraOperatorBasis[{#,1/2}&/@labels,opts];


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[spins_?MatrixQ]:=ZeemanKetBraOperatorBasis[spins,Sorted->(Sorted/.Options[ZeemanKetBraOperatorBasis])];


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[spins_?MatrixQ,opts___Rule]:=ZeemanKetBraOperatorBasis[spins,SimplifyRules[Sorted->CoherenceOrder,opts]]/;TrueQ[Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis]];


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[spins_?MatrixQ,opts___Rule]/;MatchQ[Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis],False]:=ZeemanKetBraOperatorBasis[spins,SimplifyRules[Sorted->"Canonical",opts]];


(* ::Input::Initialization:: *)
ZeemanKetBraOperatorBasis[spins_?MatrixQ,opts___Rule]:=
(
Message[OperatorBasis::invalidsortopt,ZeemanKetBraOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[ZeemanKetBraOperatorBasis]];$Failed
)/;!MemberQ[
AllowedSortValues[ZeemanKetBraOperatorBasis],
Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis]
];


(* ::Input::Initialization:: *)
BasisOperators[
ZeemanKetBraOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis],"Canonical"]:=
Flatten@Outer[Dot,
BasisKets[ZeemanBasis[spins]],BasisBras[ZeemanBasis[spins]]]


(* ::Input::Initialization:: *)
BasisOperators[
ZeemanKetBraOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis],"OrderBySpin"]:=
Module[{n},(
n=Length[spins];
ZeemanKetBraOperatorBasis/:
BasisOperators[
ZeemanKetBraOperatorBasis[spins,opts]
]=
ReleaseHold@Flatten@Outer[
Function[
Evaluate@Dot[
Hold[Ket][Transpose[{First/@spins,Table[Slot[i],{i,2n-1,1,-2}]}],spins,Validity->True],
Hold[Bra][Transpose[{First/@spins,Table[Slot[i],{i,2n,2,-2}]}],spins,Validity->True]
]
],
Sequence@@(Sequence@@(Table[m,{2},{m,#,-#,-1}])&/@Reverse[Last/@spins])
]
)];


(* ::Input::Initialization:: *)
BasisOperators[
ZeemanKetBraOperatorBasis[spins:{{_,_}..},opts___Rule]
]/;MatchQ[
Sorted/.{opts}/.Options[ZeemanKetBraOperatorBasis],
CoherenceOrder
]:=
BasisOperators[
ZeemanKetBraOperatorBasis[spins,opts]
]=
SortBy[
BasisOperators[ZeemanKetBraOperatorBasis[spins,Sorted->"Canonical",opts]],
CoherenceOrder
]


(* ::Input::Initialization:: *)
ResolveIntoKetsAndBras[ZeemanKetBraOperatorBasis[spins_,Sorted->"Canonical"]
]^:={BasisKets[ZeemanBasis[spins]],BasisBras[ZeemanBasis[spins]]};


(* ::Input::Initialization:: *)
SpinSystem[
ZeemanKetBraOperatorBasis[spins:{{_,_}..},opts___Rule]
]^:=spins;


(* ::Input::Initialization:: *)
SetAttributes[SphericalTensorOperatorBasis,NHoldFirst]


(* ::Input::Initialization:: *)
Options[SphericalTensorOperatorBasis]={Sorted->True};


(* ::Input::Initialization:: *)
AllowedSortValues[SphericalTensorOperatorBasis|SphericalTensorOperatorBasis[___]]={True,False,CoherenceOrder,{CoherenceOrder,SphericalRank},SphericalRank,"Canonical"}


(* ::Input::Initialization:: *)
BuiltinOperatorBasisQ[SphericalTensorOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
DefinedOperatorBasisQ[SphericalTensorOperatorBasis[___]]=True;


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[opts___Rule]:=
SphericalTensorOperatorBasis[SpinSystem[],opts];


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[nspin_Integer,opts___Rule]:=
SphericalTensorOperatorBasis[Range[1,nspin],opts]


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[labels_List,opts___Rule]:=
SphericalTensorOperatorBasis[{#,1/2}&/@labels,opts]/;(!MatrixQ[labels])&&!MatchQ[labels,{}]


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[spins_?MatrixQ]:=SphericalTensorOperatorBasis[spins,Sorted->(Sorted/.Options[SphericalTensorOperatorBasis])];


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[spins_?MatrixQ,opts___Rule]:=
SphericalTensorOperatorBasis[spins,SimplifyRules[Sorted->{CoherenceOrder,SphericalRank},opts]]/;MatchQ[
Sorted/.{opts}/.Options[SphericalTensorOperatorBasis],CoherenceOrder|SphericalRank|"Canonical"|False|True
];


(* ::Input::Initialization:: *)
SphericalTensorOperatorBasis[spins_?MatrixQ,opts___Rule]:=
(
Message[OperatorBasis::invalidsortopt,SphericalTensorOperatorBasis,ToString[#,FormatType->InputForm]&@AllowedSortValues[SphericalTensorOperatorBasis]];$Failed
)/;!MemberQ[
AllowedSortValues[SphericalTensorOperatorBasis],
Sorted/.{opts}/.Options[SphericalTensorOperatorBasis]
];


(* ::Input::Initialization:: *)
CouplingSchemes[spins_?MatrixQ]:=
Tuples[Table[{First@#,\[Lambda]},{\[Lambda],0,2*Last[#]}]&/@spins]//.{
{a___,{j_,0},b___}:>{a,b}
}


(* ::Input::Initialization:: *)
CouplingHistories[{}]:={{0}}


(* ::Input::Initialization:: *)
CouplingHistories[scheme_?MatrixQ]:=
Module[{ranks,n,\[Lambda]table},(
ranks=Last/@scheme;
n=Length@ranks;
\[Lambda]table=Table[ToExpression["\[Lambda]"<>ToString[i]],{i,1,Length[ranks]}];
Flatten[#,n-1]&@
Table[
Evaluate@\[Lambda]table,
Evaluate@Apply[Sequence,
MapThread[{#1[[2]],Abs[#1[[1]]-#2],Abs[#1[[1]]+#2]}&,{Partition[Prepend[\[Lambda]table,0],2,1],ranks}]
]
]
)]


(* ::Input::Initialization:: *)
FullSphericalTensorOperatorSpecifications[spins:{{_,_}..}]:=
Flatten[
Map[
Function[spec,
(\[Lambda]=Last@spec[[2]];
Table[
{\[Lambda],\[Mu],spec},
{\[Mu],\[Lambda],-\[Lambda],-1}
])
],
FullCouplingSpecifications[spins]
],
1]


(* ::Input::Initialization:: *)
FullCouplingSpecifications[spins:{{_,_}..}]:=
Module[{schemes,histories},(
schemes=CouplingSchemes[spins];
histories=CouplingHistories/@schemes;
Flatten[
MapThread[
(Function[h,{#1,h}]/@#2)&,
{schemes,histories}
],
1
]
)];


(* ::Input::Initialization:: *)
BasisOperators[SphericalTensorOperatorBasis[spins_?MatrixQ,opts___Rule],basisopts__Rule]:=BasisOperators[SphericalTensorOperatorBasis[spins,SimplifyRules[basisopts,opts]]]


(* ::Input::Initialization:: *)
BasisOperators[SphericalTensorOperatorBasis[spins:{{_,_}..},opts___Rule]]:=
BasisOperators[SphericalTensorOperatorBasis[spins,opts]]=
Simplify[(#/OperatorNorm[#])]&/@
UnNormalizedBasisOperators[SphericalTensorOperatorBasis[spins,opts]];


(* ::Input::Initialization:: *)
UnNormalizedBasisOperators[stob:SphericalTensorOperatorBasis[spins:{{_,_}..},opts___Rule]]:=
Module[{fullspeclist},(
fullspeclist=SortBy[FullSphericalTensorOperatorSpecifications[spins],{(#[[1]])&,(#[[2]])&}];
SphericalTensorIndices[stob]={#[[1]],#[[2]]}&/@fullspeclist;
Map[
Function[fullspec,
Module[{\[Lambda],\[Mu],spec},(
{\[Lambda],\[Mu],spec}=fullspec;
Simplify@opT[First@spec,Last@spec,{\[Lambda],\[Mu]}]
)]
],
fullspeclist
]
)]/;MatchQ[Sorted/.{opts}/.Options[SphericalTensorOperatorBasis],{SphericalRank,CoherenceOrder}];


(* ::Input::Initialization:: *)
UnNormalizedBasisOperators[stob:SphericalTensorOperatorBasis[spins:{{_,_}..},opts___Rule]]:=
Module[{fullspeclist},(
fullspeclist=SortBy[FullSphericalTensorOperatorSpecifications[spins],{(#[[2]])&,(#[[1]])&}];
SphericalTensorIndices[stob]={#[[1]],#[[2]]}&/@fullspeclist;
Map[
Function[fullspec,
Module[{\[Lambda],\[Mu],spec},(
{\[Lambda],\[Mu],spec}=fullspec;
Simplify@opT[First@spec,Last@spec,{\[Lambda],\[Mu]}]
)]
],
fullspeclist
]
)]/;MatchQ[Sorted/.{opts}/.Options[SphericalTensorOperatorBasis],{CoherenceOrder,SphericalRank}];


(* ::Input::Initialization:: *)
SpinSystem[
SphericalTensorOperatorBasis[spins:{{_,_}..},opts___Rule]
]^:=spins;


(* ::Input::Initialization:: *)
Options[OperatorBasisTransformationMatrix]={Verbose->False};


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,___]/;!DefinedOperatorBasisQ[opbasis2]:=
(Message[OperatorBasisTransformationMatrix::undefopb,opbasis2];$Failed);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,___]/;!DefinedOperatorBasisQ[opbasis1]:=
(Message[OperatorBasisTransformationMatrix::undefopb,opbasis1];$Failed);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,___]/;!TrueQ[SpinSystem[opbasis2]==SpinSystem[opbasis1]]:=
(Message[OperatorBasisTransformationMatrix::badspinsys];$Failed);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,opts___Rule]:=OperatorBasisTransformationMatrix[opbasis2,opbasis1,ZeemanBasis[SpinSystem[opbasis2]],opts];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,basis_,opts___Rule]/;OperatorBasesMatchQ[opbasis2,opbasis1]:=SparseArray@DiagonalMatrix[Table[1,{OperatorBasisDimension[opbasis1]}]];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis1_,opbasis2_,basis_,opts___Rule]/;!OperatorBasesOrderedQ[{opbasis1,opbasis2}]:=
(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["transposing order:",{opbasis2,opbasis1}]
];
Adjoint[OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,opts]]
);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:type_[___],
opbasis1:type_[___],
basis_,opts___Rule]:=
(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["using reordering of basis operators:",{opbasis2,opbasis1}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
SparseArray@ReplacePart[
DiagonalMatrix[Table[0,{OperatorBasisDimension[opbasis1]}]],
Inner[({#1,#2}->1)&,
Ordering@BasisOperators[opbasis2],
Ordering@BasisOperators[opbasis1],
List
]
]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:type2_[stuff2:Except[_Rule]..,opb2opts___Rule],opbasis1:type1_[stuff1:Except[_Rule]..,opb1opts___Rule],
basis_,opts___Rule
]/;MemberQ[AllowedSortValues[opbasis2],"OrderBySpin"]&&
MemberQ[AllowedSortValues[opbasis1],"OrderBySpin"]&&(!MatchQ[Sorted/.{opb2opts}/.Options[type2],"OrderBySpin"])&&(Length[SpinSystem[opbasis2]]>1):=
Module[{iopbasis,orderopbasis2,orderiopbasis,perm},(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["setting up OrderBySpin (1):",{opbasis2,opbasis1}]
];
iopbasis=
type2[stuff2,
SimplifyRules[Sorted->"OrderBySpin",opb2opts]
];
orderopbasis2=Ordering[BasisOperators[opbasis2]];
orderiopbasis=Ordering[BasisOperators[iopbasis]];
perm=orderiopbasis[[InversePermutation[orderopbasis2]]];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
OperatorBasisTransformationMatrix[iopbasis,opbasis1,basis,opts][[perm]]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:type2_[stuff2:Except[_Rule]..,opb2opts___Rule],opbasis1:type1_[stuff1:Except[_Rule]..,opb1opts___Rule],
basis_,opts___Rule
]/;MemberQ[AllowedSortValues[opbasis2],"OrderBySpin"]&&MemberQ[AllowedSortValues[opbasis1],"OrderBySpin"]&&(!MatchQ[Sorted/.{opb1opts}/.Options[type1],"OrderBySpin"])&&(Length[SpinSystem[opbasis1]]>1):=
Module[{iopbasis,orderopbasis1,orderiopbasis,perm},(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["setting up OrderBySpin (2):",{opbasis2,opbasis1}]
];
iopbasis=
type1[stuff1,
SimplifyRules[Sorted->"OrderBySpin",opb1opts]
];
orderopbasis1=Ordering[BasisOperators[opbasis1]];
orderiopbasis=Ordering[BasisOperators[iopbasis]];
perm=orderiopbasis[[InversePermutation[orderopbasis1]]];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
Chop[OperatorBasisTransformationMatrix[opbasis2,iopbasis,basis,opts][[All,perm]]]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:opbtype2_[type2___,spins_?MatrixQ,opb2opts___Rule],opbasis1:opbtype1_[type1___,spins_?MatrixQ,opb1opts___Rule],
basis_,opts___Rule
]/;(MatchQ[Sorted/.{opb2opts}/.Options[opbtype2],"OrderBySpin"])&&(MatchQ[Sorted/.{opb1opts}/.Options[opbtype1],"OrderBySpin"])&&(Length[spins]>1):=
Module[{temp,spin,opbtm},(
temp=PrintTemporary["setting up OperatorBasisTransformationMatrix from ",opbasis1," to ",opbasis2];
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["using OrderBySpin (2):",{opbasis2,opbasis1}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
KroneckerProduct[
Sequence@@Map[
Function[spin,
OperatorBasisTransformationMatrix[
opbtype2[type2,{spin},Sorted->"OrderBySpin"],
opbtype1[type1,{spin},Sorted->"OrderBySpin"],
ZeemanBasis[{spin}]
]
],
Reverse[spins]
]
]
];
Delete[temp];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,opts]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:opbtype2_[type2___,{{j_,Ij_}},opb2opts___Rule],opbasis1:opbtype1_[type1___,{{j_,Ij_}},opb1opts___Rule],
basis:ZeemanBasis[{{j_,Ij_}},opts___Rule]
]/;(MatchQ[Sorted/.{opb2opts}/.Options[opbtype2],"OrderBySpin"|"Canonical"])&&(MatchQ[Sorted/.{opb1opts}/.Options[opbtype1],"OrderBySpin"|"Canonical"]):=
Module[{k,reps1,reps2,OBTmat},(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["using OrderBySpin (1):",{opbasis2,opbasis1}]
];
reps1=MatrixRepresentation[#,ZeemanBasis[{{j,Ij}}]]&/@BasisOperators[opbasis1];
reps2=MatrixRepresentation[#,ZeemanBasis[{{j,Ij}}]]&/@BasisOperators[opbasis2];
OBTmat=SparseArray[Chop@Outer[Tr[Adjoint[#1].#2]&,reps2,reps1,1]];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[
opbtype2[type2,{{j,Ij}},opb2opts],
opbtype1[type1,{{j,Ij}},opb1opts],
ZeemanBasis[{{j,Ij}}],___Rule]->
OBTmat
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,basis_,opts___Rule]:=
Module[{iopbasis},(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["going through iopb (1):",iopbasis,{opbasis2,opbasis1}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
OperatorBasisTransformationMatrix[opbasis2,iopbasis,basis,opts].
OperatorBasisTransformationMatrix[iopbasis,opbasis1,basis,opts]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
)/;(
iopbasis=IntermediateOperatorBasis[opbasis1];
!MatchQ[opbasis2,iopbasis]&&!MatchQ[opbasis1,iopbasis]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[
opbasis2:type2_[stuff2:Except[_Rule]..,opb2opts___Rule],zkbop:ZeemanKetBraOperatorBasis[stuff1:Except[_Rule]..,opb1opts___Rule],
basis_,opts___Rule
]/;(MatchQ[Sorted/.{opb1opts}/.Options[type2],"Canonical"]):=
(PrintTemporary["setting up OperatorBasisTransformationMatrix from ",zkbop," to ",opbasis2];
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["setting up using canonical ordering ..",{opbasis2,zkbop}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,zkbop,basis,___Rule]->
SparseArray[
Conjugate@Flatten@MatrixRepresentation[#,ZeemanBasis[stuff1]]&/@
BasisOperators[opbasis2]
]
];
OperatorBasisTransformationMatrix[opbasis2,zkbop,basis]
);


(* ::Input::Initialization:: *)
(*SparseArray[Flatten@MatrixRepresentation[#,ZeemanBasis[stuff1]]&/@BasisOperators[opbasis2]] changed to:SparseArray[Conjugate@Flatten@MatrixRepresentation[#,ZeemanBasis[stuff1]]&/@BasisOperators[opbasis2]]*)


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,basis_,opts___Rule]:=
Module[{iopbasis},(
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["going through iopb (2):",iopbasis,{opbasis2,opbasis1}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
OperatorBasisTransformationMatrix[opbasis2,iopbasis,basis,opts].
OperatorBasisTransformationMatrix[iopbasis,opbasis1,basis,opts]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
)/;(
iopbasis=IntermediateOperatorBasis[opbasis2];
!MatchQ[opbasis2,iopbasis]&&!MatchQ[iopbasis,opbasis1]
)];


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix[opbasis2_,opbasis1_,basis_,opts___Rule]:=
(PrintTemporary["setting up OperatorBasisTransformationMatrix from ",opbasis1," to ",opbasis2];
If[Verbose/.{opts}/.Options[OperatorBasisTransformationMatrix],Print["setting up opbtm using direct procedure:" ,{opbasis2,opbasis1}]
];
PrependTo[
DownValues[OperatorBasisTransformationMatrix],
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis,___Rule]->
Module[{spinsys},(
spinsys=SpinSystem[opbasis2];
SparseArray@Outer[
LiouvilleBracket[#1,#2]&,
MatrixRepresentation[#,ZeemanBasis[spinsys]]&/@BasisOperators[opbasis2],
MatrixRepresentation[#,ZeemanBasis[spinsys]]&/@BasisOperators[opbasis1],
1
]
)]
];
OperatorBasisTransformationMatrix[opbasis2,opbasis1,basis]
);


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix::badspinsys="cannot transform between operator bases belonging to different spin systems.";


(* ::Input::Initialization:: *)
OperatorBasisTransformationMatrix::undefopb="OperatorBasis `1` is not defined.";


(* ::Input::Initialization:: *)
OperatorBasesMatchQ[{opbasis2_,opbasis1_}]:=OperatorBasesMatchQ[opbasis2,opbasis1];


(* ::Input::Initialization:: *)
OperatorBasesMatchQ[opbasis_,opbasis_]:=True;


(* ::Input::Initialization:: *)
OperatorBasesMatchQ[
opbasis2:type_[stuff:Except[_Rule]..,opb2opts___Rule],
opbasis1:type_[stuff:Except[_Rule]..,opb1opts___Rule]
]/;MatchQ[Options[type],{_Rule...}]&&
MatchQ[
(First/@Options[type])/.{opb2opts}, 
(First/@Options[type])/.{opb1opts}]:=True;


(* ::Input::Initialization:: *)
OperatorBasesMatchQ[opbasis2_,opbasis1_]:=False;


(* ::Input::Initialization:: *)
OperatorBasesOrderedQ[{opbasis2_,opbasis1_}]/;OperatorBasesMatchQ[{opbasis1,IntermediateOperatorBasis[opbasis2]}]:=True;


(* ::Input::Initialization:: *)
OperatorBasesOrderedQ[{opbasis2_,opbasis1_}]/;OperatorBasesMatchQ[{opbasis2,IntermediateOperatorBasis[opbasis1]}]:=False;


(* ::Input::Initialization:: *)
OperatorBasesOrderedQ[{opbasis2_,opbasis1_}]:=OrderedQ[{opbasis2,opbasis1}];


(* ::Input::Initialization:: *)
IntermediateOperatorBasis[opbasis_]:=ZeemanKetBraOperatorBasis[SpinSystem[opbasis],Sorted->"Canonical"];


(* ::Input::Initialization:: *)
Options[OperatorVectorRepresentation]:={Method->Automatic};


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opts___Rule]:=
OperatorVectorRepresentation[op,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,opts___Rule]:=
OperatorVectorRepresentation[op,opbasis,Basis[],opts];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,basis_,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
OperatorVectorRepresentation[op,opbasis,opts]
);


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,Undefined,basis_,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorVectorRepresentation[op,opts]
);


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,basis_,opts___Rule]/;!Equal[SpinSystem[opbasis],SpinSystem[basis]]:=
Module[{defaultopbasis},(
SetSpinSystem[SpinSystem[basis]];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
OperatorVectorRepresentation[op,defaultopbasis,basis,opts]
)];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[num_?NumericQ,more___]/;(Chop[num]==0):=OperatorVectorRepresentation[NullOperator[],more];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[num_?NumericQ,more___]:=OperatorVectorRepresentation[num*UnityOperator[],more];


(* ::Input::Initialization:: *)
HoldPattern@OperatorVectorRepresentation[op:Except[_?OperatorQ],more___]:=Module[{fixedop},(
OperatorVectorRepresentation[fixedop,more]
)/;(
fixedop=Chop[op];
MatchQ[fixedop,_?OperatorQ]
)];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,more___]:=(Message[OperatorVectorRepresentation::badop];$Failed)/;(!OperatorQ[op]);


(* ::Input::Initialization:: *)
HoldPattern@OperatorVectorRepresentation[Plus[ops___],opbasis_,basis_,opts___Rule]:=
Map[
OperatorVectorRepresentation[#,opbasis,basis,opts]&,
Plus[ops]
];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[Times[num:Except[_?OperatorQ]..,op_?OperatorQ],opbasis_,basis_,opts___Rule]:=
num*OperatorVectorRepresentation[op,opbasis,basis,opts];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[Times[op_?OperatorQ,num:Except[_?OperatorQ]..],opbasis_,basis_,opts___Rule]:=
num*OperatorVectorRepresentation[op,opbasis,basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@OperatorVectorRepresentation[
Operator[vec_?VectorQ,opbasis:Except[_Rule],vecbasis:Except[_Rule],___Rule],
opbasis_,basis_,___Rule]:=vec;


(* ::Input::Initialization:: *)
HoldPattern@OperatorVectorRepresentation[
Operator[ifunc_InterpolatingFunction[t_],opbasis:Except[_Rule],vecbasis:Except[_Rule],___Rule],
opbasis_,basis_,___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?VectorQ]):=ifunc[t];


(* ::Input::Initialization:: *)
HoldPattern@OperatorVectorRepresentation[
Operator[spec_,vecopbasis:Except[_Rule],vecbasis:Except[_Rule],___Rule],
opbasis:Except[_Rule],basis:Except[_Rule],___Rule]:=
MultiplyMatricesAndVectorInterpolationFunctions[
OperatorBasisTransformationMatrix[opbasis,vecopbasis],
spec
];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,basis_,opts___Rule]:=
Module[{spinsys},(
SparseArray@Flatten@MatrixRepresentation[op,basis]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[OperatorVectorRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,basis_,opts___Rule]:=
Module[{iopbasis,spinsys,zb},(
iopbasis=ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"];
zb=ZeemanBasis[spinsys];
SparseArray[Simplify[
OperatorBasisTransformationMatrix[opbasis,iopbasis,zb].
OperatorVectorRepresentation[op,iopbasis,zb,Method->Automatic,opts]
]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[OperatorVectorRepresentation],Automatic]&&
!MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation[op_,opbasis_,opts___Rule]:=
SparseArray[LiouvilleBracket[#1,op,opts]&/@BasisOperators[opbasis]]/;MatchQ[Method/.{opts}/.Options[OperatorVectorRepresentation],"Direct"];


(* ::Input::Initialization:: *)
Operator[op_?OperatorQ,opbasis:Except[_Rule],basis:Except[_Rule],opts___Rule]:=
Operator[
OperatorVectorRepresentation[
Operator[op,basis,opts],
opbasis,basis
],
opbasis,basis,opts
];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[
op:Operator[vec_?VectorQ,___],basis:Except[_Rule],___Rule]/;MatchQ[basis,ZeemanBasis[]]:=
Partition[
OperatorVectorRepresentation[
op,ZeemanKetBraOperatorBasis[Sorted->"Canonical"],basis
],
BasisDimension[basis]
]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[
op:Operator[ifunc_InterpolatingFunction[t_],vecopbasis:Except[_Rule],vecbasis:Except[_Rule],___Rule],
basis:Except[_Rule],___Rule]/;MatchQ[{vecopbasis,basis},{ZeemanKetBraOperatorBasis[Sorted->"Canonical"],ZeemanBasis[]}]&&((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?VectorQ]):=
Partition[
Replace[ifunc,
{v_?VectorQ:>Partition[v,BasisDimension[basis]]},{3}
][t],
BasisDimension[basis]
];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[
op:Operator[ifunc_InterpolatingFunction[t_],vecopbasis:Except[_Rule],vecbasis:Except[_Rule],___Rule],
basis:Except[_Rule],___Rule]/;MatchQ[basis,ZeemanBasis[]]&&((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?VectorQ]):=
Module[{zbasis},(
zbasis=ZeemanBasis[];
MatrixRepresentation[
Operator[op,ZeemanKetBraOperatorBasis[Sorted->"Canonical"],zbasis,CheckOperatorType->False],
zbasis
]
)];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[
op:Operator[spec_,Except[_Rule],Except[_Rule],___],
basis:Except[_Rule],___Rule]/;!MatchQ[basis,ZeemanBasis[]]:=
Module[{zbasis},(
zbasis=ZeemanBasis[];
MultiplyMatricesAndMatrixInterpolationFunctions[
BasisTransformationMatrix[basis,zbasis],
MatrixRepresentation[op,zbasis],
BasisTransformationMatrix[zbasis,basis]
]
)];


(* ::Input::Initialization:: *)
OperatorVectorRepresentation::badop="OperatorVectorRepresentation may only be applied to an operator.";


(* ::Input::Initialization:: *)
Options[ExpressOperator]={};


(* ::Input::Initialization:: *)
ExpressOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
ExpressOperator[op_,opts___Rule]:=
ExpressOperator[op,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
ExpressOperator[op_,Undefined,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
ExpressOperator[op,opts]
);


(* ::Input::Initialization:: *)
ExpressOperator[num_?NumericQ,opbasis_,opts___]:=num


(* ::Input::Initialization:: *)
ExpressOperator[op_?OperatorQ,opbasis_,opts___]:=
Chop[Inner[Times,BasisOperators[opbasis,opts],Normal@OperatorVectorRepresentation[op,opbasis],Plus]
];


(* ::Input::Initialization:: *)
Options[LiouvilleBracket]:={Method->Automatic,Normalize->False};


(* ::Input::Initialization:: *)
LiouvilleBracket[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
LiouvilleBracket[matrep1_?MatrixQ,matrep2_?MatrixQ,more:Except[_Rule]...,opts___Rule]:=
Simplify[Adjoint[Flatten[matrep1]].Flatten[matrep2]];


(* ::Input::Initialization:: *)
LiouvilleBracket[num_?NumericQ,more:Except[_Rule]...,opts___Rule]:=
num*LiouvilleBracket[UnityOperator[],more,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[args__,num_?NumericQ,more:Except[_Rule]...,opts___Rule]:=
num*LiouvilleBracket[args,UnityOperator[],more,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,op2_?OperatorQ,opts___Rule]:=
LiouvilleBracket[op1,op2,ZeemanKetBraOperatorBasis[Sorted->"Canonical"],ZeemanBasis[],opts]/;MatchQ[Method/.{opts}/.Options[LiouvilleBracket],Automatic];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,op2_?OperatorQ,opts___Rule]:=
LiouvilleBracket[op1,op2,OperatorBasis[],opts]


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,op2_?OperatorQ,opbasis_,opts___Rule]:=
LiouvilleBracket[op1,op2,opbasis,Basis[],opts]


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,sop_?SuperoperatorQ,op2_?OperatorQ,opts___Rule]:=
LiouvilleBracket[op1,sop,op2,ZeemanKetBraOperatorBasis[Sorted->"Canonical"],ZeemanBasis[],opts]/;MatchQ[Method/.{opts}/.Options[LiouvilleBracket],Automatic];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,sop_?SuperoperatorQ,op2_?OperatorQ,opts___Rule]:=
LiouvilleBracket[op1,op2,OperatorBasis[],opts]


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,sop_?SuperoperatorQ,op2_?OperatorQ,opbasis_,opts___Rule]:=
LiouvilleBracket[op1,sop,op2,opbasis,Basis[],opts]


(* ::Input::Initialization:: *)
LiouvilleBracket[Dot[ops2b___?OperatorQ,n_?NumericQ,ops2a___?OperatorQ],op1_?OperatorQ,opbasis_,basis_,opts___Rule]:=n*LiouvilleBracket[Dot[ops2b,ops2a],op1,opbasis,basis,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[op2_?OperatorQ,Dot[ops1b___?OperatorQ,n_?NumericQ,ops1a___?OperatorQ],opbasis_,basis_,opts___Rule]:=n*LiouvilleBracket[op2,Dot[ops1b,ops1a],opbasis,basis,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[Dot[ops2b___?OperatorQ,n_?NumericQ,ops2a___?OperatorQ],sop_?SuperoperatorQ,op1_?OperatorQ,opbasis_,basis_,opts___Rule]:=n*LiouvilleBracket[Dot[ops2b,ops2a],sop,op1,opbasis,basis,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[op2_?OperatorQ,sop_?SuperoperatorQ,Dot[ops1b___?OperatorQ,n_?NumericQ,ops1a___?OperatorQ],opbasis_,basis_,opts___Rule]:=n*LiouvilleBracket[op2,sop,Dot[ops1b,ops1a],opbasis,basis,opts];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,op2_?OperatorQ,opbasis_,basis_,opts___Rule]/;(Normalize/.{opts}/.Options[LiouvilleBracket]):=LiouvilleBracket[NormalizeOperator[op1],NormalizeOperator[op2],opbasis,basis,SimplifyRules[Normalize->False,opts]];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,sop_?SuperoperatorQ,op2_?OperatorQ,opbasis_,basis_,opts___Rule]/;(Normalize/.{opts}/.Options[LiouvilleBracket]):=LiouvilleBracket[NormalizeOperator[op1],sop,NormalizeOperator[op2],opbasis,basis,SimplifyRules[Normalize->False,opts]];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,op2_?OperatorQ,opbasis_,basis_,opts___Rule]/;(!Normalize/.{opts}/.Options[LiouvilleBracket]):=
Simplify[
Adjoint[OperatorVectorRepresentation[op1,opbasis,basis]].
OperatorVectorRepresentation[op2,opbasis,basis]
];


(* ::Input::Initialization:: *)
LiouvilleBracket[op1_?OperatorQ,sop_?SuperoperatorQ,op2_?OperatorQ,opbasis_,basis_,opts___Rule]/;(!Normalize/.{opts}/.Options[LiouvilleBracket]):=
Simplify[
Adjoint[OperatorVectorRepresentation[op1,opbasis,basis]].
SuperoperatorMatrixRepresentation[sop,opbasis,basis].OperatorVectorRepresentation[op2,opbasis,basis]
];


(* ::Input::Initialization:: *)
OperatorAmplitude[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
OperatorAmplitude[op1_?OperatorQ->ops2:{_?OperatorQ..},opts___Rule]:=OperatorAmplitude[#,op1,opts]&/@ops2;


(* ::Input::Initialization:: *)
OperatorAmplitude[op1_?OperatorQ->op2_?OperatorQ,opts___Rule]:=OperatorAmplitude[op2,op1,opts];


(* ::Input::Initialization:: *)
OperatorAmplitude[op2_?OperatorQ,op1_?OperatorQ,opts___Rule]:=
(OperatorAmplitude[op2,opts][op1]);


(* ::Input::Initialization:: *)
OperatorAmplitude[op2_?OperatorQ,opts___Rule]:=
Function[op1,LiouvilleBracket[op2,op1]/LiouvilleBracket[op2,op2]];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
Dot/:HoldPattern[Dot[sops__?SuperoperatorQ][op0_?OperatorQ]]:=Fold[Function[{op,sop},sop[op]],op0,Reverse[{sops}]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Plus,Infinity,
Plus/:HoldPattern[Plus[sops__?SuperoperatorQ][op_?OperatorQ]]:=(#[op])&/@Plus[sops];
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,Infinity,
Times/:HoldPattern[Times[n_,sop_?SuperoperatorQ][op_]]:=n*sop[op];
];


(* ::Input::Initialization:: *)
SuperoperatorPattern=_Superoperator|
_UnitySuperoperator|_NullSuperoperator|
_RotationSuperoperator|
_CommutationSuperoperator|
_LeftMultiplicationSuperoperator|
_RightMultiplicationSuperoperator|
_AntiCommutationSuperoperator|
_DoubleCommutationSuperoperator|
_ProjectionSuperoperator|
_ShiftSuperoperator|
_CoherenceOrderFiltrationSuperoperator|
_SphericalComponentFiltrationSuperoperator|(
ifunc_InterpolatingFunction[_]/;
(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?SuperoperatorQ]);


(* ::Input::Initialization:: *)
SuperoperatorQ[$Failed]=$Failed;


(* ::Input::Initialization:: *)
SuperoperatorQ[sop:SuperoperatorPattern]=True;


(* ::Input::Initialization:: *)
SuperoperatorQ[notsop_]/;FreeQ[notsop,SuperoperatorPattern]:=False;


(* ::Input::Initialization:: *)
SuperoperatorQ[failed_]/;!FreeQ[failed,$Failed]:=$Failed; 


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorQ[op_?OperatorQ]=False;


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorQ[Exp[x_]]:=SuperoperatorQ[x];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorQ[E^x_]:=SuperoperatorQ[x];


(* ::Input::Initialization:: *)
SuperoperatorQ[HoldPattern@Plus[_?SuperoperatorQ..]]=True;


(* ::Input::Initialization:: *)
SuperoperatorQ[HoldPattern@Dot[_?SuperoperatorQ..]]=True;


(* ::Input::Initialization:: *)
SuperoperatorQ[HoldPattern@Times[x___]]:=
Switch[Count[{x},_?SuperoperatorQ],
1,True,
0,False,
_,(Message[SuperoperatorQ::badsoptimes];False)
];


(* ::Input::Initialization:: *)
SuperoperatorQ[x_]:=False;


(* ::Input::Initialization:: *)
SuperoperatorQ::badsoptimes="An illegal Times product of superoperators has been detected.";


(* ::Input::Initialization:: *)
ValidSuperoperatorTypes={Undefined,None,"Hermitian","AntiHermitian","Unitary","Normal"};


(* ::Input::Initialization:: *)
Options[SuperoperatorType]={SuperoperatorType->Undefined};


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorType[Superoperator[args:Except[_Rule]...,sopopts___Rule]]/;MatchQ[SuperoperatorType/.{sopopts}/.Options[Superoperator],Undefined]:=
SuperoperatorType[
Superoperator[args,
SimplifyRules[
CheckSuperoperatorType->True,
sopopts
]
]
];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorType[Superoperator[args:Except[_Rule]...,sopopts___Rule]]/;!MatchQ[SuperoperatorType/.{sopopts}/.Options[Superoperator],Undefined]:=SuperoperatorType/.{sopopts}/.Options[SuperoperatorType];


(* ::Input::Initialization:: *)
SuperoperatorType[CommutationSuperoperator[op_?OperatorQ,___Rule]]:=
Switch[
OperatorType[op],
	"Hermitian","Hermitian",
	"AntiHermitian","AntiHermitian",
	"Unitary","Unitary",
	"Normal","Normal",
	_,None
];


(* ::Input::Initialization:: *)
SuperoperatorType[LeftMultiplicationSuperoperator[op_?OperatorQ,___Rule]]:=
Switch[
OperatorType[op],
	"Hermitian","Hermitian",
	"AntiHermitian","AntiHermitian",
	"Unitary","Unitary",
	"Normal","Normal",
	_,None
];


(* ::Input::Initialization:: *)
SuperoperatorType[RightMultiplicationSuperoperator[op_?OperatorQ,___Rule]]:=
Switch[
OperatorType[op],
	"Hermitian","Hermitian",
	"AntiHermitian","AntiHermitian",
	"Unitary","Unitary",
	"Normal","Normal",
	_,None
];


(* ::Input::Initialization:: *)
SuperoperatorType[sop_?SuperoperatorQ]:=SuperoperatorType[Superoperator[sop]];


(* ::Input::Initialization:: *)
SuperoperatorType[sop_]:=(Message[SuperoperatorType::notsop];$Failed);


(* ::Input::Initialization:: *)
SuperoperatorType::notsop="SuperoperatorType may only be applied to a superoperator.";


(* ::Input::Initialization:: *)
NDiagonalize[sop_?SuperoperatorQ,more___]/;!FreeQ[{sop,more},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NDiagonalize[sop_?SuperoperatorQ,opts___Rule]:=NDiagonalize[sop,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
NDiagonalize[sop_?SuperoperatorQ,opbasis_,opts___Rule]:=NDiagonalize[sop,opbasis,Basis[],opts];


(* ::Input::Initialization:: *)
NDiagonalize[Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis1_,sopopts___Rule],opbasis_,basis2_,opts___Rule]:=
Superoperator[{X,evals,Xinv},opbasis,basis2,SimplifyRules[sopopts,opts]];


(* ::Input::Initialization:: *)
NDiagonalize[Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis1_,basis1_,sopopts___Rule],opbasis2_,basis2_,opts___Rule]:=
Superoperator[
{Chop[OperatorBasisTransformationMatrix[opbasis2,opbasis1].X],
evals,
Chop[Xinv.OperatorBasisTransformationMatrix[opbasis1,opbasis2]]},
opbasis2,
basis2,
SimplifyRules[sopopts,opts]
];


(* ::Input::Initialization:: *)
NDiagonalize[
Superoperator[mat_?MatrixQ,opbasis_,basis2_,sopopts___Rule],
opbasis_,basis1_,opts___Rule
]:=
Module[{ass1,ass2},(
ass1=Assumptions/.{opts}/.Options[NDiagonalize];
ass2=Switch[
ass1,
None|False,False,
{_Rule...},ass1,
Automatic|True,
SimplifyRules[
OrthogonalEigenvectors->
Switch[
SuperoperatorType/.{sopopts}/.Options[Superoperator],
	"Hermitian"|"Unitary"|"AntiHermitian",True,
	_,False
],
Sequence@@Cases[ass1,_Rule]
],
_,None
];
Superoperator[
NDiagonalize[
mat,
SimplifyRules[
Assumptions->ass2,
opts
]
],
opbasis,
basis1,
SimplifyRules[sopopts,opts]
]
)];


(* ::Input::Initialization:: *)
NDiagonalize[
Superoperator[
csop_CommutationSuperoperator,
opbasis1_,basis1_,opts1___Rule
],
opbasis2_,basis2_,opts2___Rule
]:=NDiagonalize[csop,opbasis2,basis2,opts2];


(* ::Input::Initialization:: *)
NDiagonalize[csop_CommutationSuperoperator,opbasis_,basis_,opts___Rule]:=
Module[{X\[CapitalLambda]Xinv,X,evals,Xinv,zkbop,zb},(
X\[CapitalLambda]Xinv=If[!FreeQ[#,$Failed],$Failed,First[#]]&@
NDiagonalize[csop,zkbop,zb,opts];
If[!FreeQ[X\[CapitalLambda]Xinv,$Failed],
$Failed,
({X,evals,Xinv}=X\[CapitalLambda]Xinv;
Superoperator[
{SparseArray@Chop[OperatorBasisTransformationMatrix[opbasis,zkbop].X],
evals,
SparseArray@Chop[Xinv.OperatorBasisTransformationMatrix[zkbop,opbasis]]},
opbasis,zb,opts
]
)
]
)/;(
zkbop=ZeemanKetBraOperatorBasis[Sorted->"Canonical"];
zb=ZeemanBasis[];
(!MatchQ[opbasis,zkbop])||(!MatchQ[basis,zb])
)];


(* ::Input::Initialization:: *)
NDiagonalize[CommutationSuperoperator[op_?OperatorQ,csopopts___Rule],opbasis_,basis_,opts___Rule]:=NDiagonalize[
CommutationSuperoperator[
NDiagonalize[op,ZeemanBasis[],csopopts,opts],
csopopts
],
opbasis,basis,opts
]/;!MatchQ[op,Operator[{_?NumericMatrixQ,_List,_?NumericMatrixQ},ZeemanBasis[],___]]


(* ::Input::Initialization:: *)
NDiagonalize[
CommutationSuperoperator[op:Operator[{Xop_?NumericMatrixQ,opevals_List,Xopinv_?NumericMatrixQ},basis_,___Rule],
sopopts___Rule],
opbasis_,basis_,opts___Rule
]:=Module[{zkbop,zb,ass,opevecs,sopevecs},(
opevecs=Orthogonalize@Transpose[Xop];
sopevecs=KroneckerProduct[opevecs,ComplexExpand[Conjugate/@opevecs]];
Superoperator[
{
Chop@Transpose[sopevecs],
Chop@Flatten@Outer[(#1-Conjugate[#2])&,opevals,opevals],
Chop@Conjugate[sopevecs]
},
opbasis,basis,opts
]
)/;(
zkbop=ZeemanKetBraOperatorBasis[Sorted->"Canonical"];
zb=ZeemanBasis[];
MatchQ[opbasis,zkbop]&&
MatchQ[basis,zb]&&
(MatchQ[OperatorType/.{sopopts}/.Options[Operator],"Hermitian"]||
(ass=Assumptions/.{sopopts}/.Options[NDiagonalize];
MatchQ[ass,{_Rule...}]&&
MatchQ[OperatorType/.ass/.Options[NDiagonalize],"Hermitian"])
)
)];


(* ::Input::Initialization:: *)
NDiagonalize[
CommutationSuperoperator[op:Operator[{Xop_?NumericMatrixQ,opevals_List,Xopinv_?NumericMatrixQ},basis_,opopts___Rule],
sopopts___Rule],
opbasis_,basis_,opts___Rule
]/;MatchQ[OperatorType/.{sopopts}/.Options[Operator],"AntiHermitian"]:=
MapAt[
Times[I,#]&,
NDiagonalize[
CommutationSuperoperator[
Operator[{Xop,-I opevals,Xopinv},basis,
SimplifyRules[
OperatorType ->"Hermitian",
opopts
]
],
SimplifyRules[
OperatorType ->"Hermitian",
sopopts
]
],
opbasis,basis,opts
],
{1,2}
];


(* ::Input::Initialization:: *)
NDiagonalize[
CommutationSuperoperator[op:Operator[{Xop_?NumericMatrixQ,opevals_List,Xopinv_?NumericMatrixQ},basis_,opopts___Rule],
sopopts___Rule],
opbasis_,basis_,opts___Rule
]:=Module[{ass},(
MapAt[
Times[I,#]&,
NDiagonalize[
CommutationSuperoperator[
Operator[{Xop,-I opevals,Xopinv},basis,
SimplifyRules[
OperatorType->Undefined,
opopts]
],
SimplifyRules[
Assumptions->{OperatorType->"Hermitian"},
sopopts
]
],
opbasis,basis,opts
],
{1,2}
]
)/;(
ass=Assumptions/.{sopopts}/.Options[NDiagonalize];
MatchQ[ass,{_Rule...}]&&
MatchQ[OperatorType/.ass/.Options[NDiagonalize],"AntiHermitian"]
)
];


(* ::Input::Initialization:: *)
NDiagonalize[sop_?SuperoperatorQ,opbasis_,basis_,opts___Rule]:=
NDiagonalize[
Superoperator[
SuperoperatorMatrixRepresentation[
sop,
opbasis,basis,opts
],
opbasis,basis,opts
],
opbasis,basis,opts
];


(* ::Input::Initialization:: *)
Options[Superoperator]={SuperoperatorType->Undefined,CheckSuperoperatorType->Automatic,CheckMatrixDimensions->True};


(* ::Input::Initialization:: *)
SuperoperatorTypeCheckDisableThreshold=32;


(* ::Input::Initialization:: *)
Superoperator/:Format[Superoperator[mat_?MatrixQ,opbasis_,basis_,opts___Rule]]:=
Module[{soptype},(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
DisplayForm[RowBox[{
ToBoxes["Superoperator[<<..>>, "],
ToBoxes["SuperoperatorType\[Rule]"],
If[StringQ[soptype],
ToBoxes["\""<>soptype<>"\""],soptype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
Superoperator/:Format[Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule]]:=
Module[{soptype},(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
DisplayForm[RowBox[{
"Superoperator[DiagonalizedForm[<<..",
Dimensions[X],
ToBoxes["..>>], SuperoperatorType\[Rule]"],
If[StringQ[soptype],
ToBoxes["\""<>soptype<>"\""],soptype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
Superoperator/:Format[HoldPattern@Superoperator[CommutationSuperoperator[Operator[opspecs_,___],___],opbasis_,basis_,opts___Rule]]:=
Module[{soptype},(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
DisplayForm[RowBox[{
"Superoperator[CommutationSuperoperator[Operator[<<",
Switch[opspecs,
_?MatrixQ,
	Dimensions[opspecs],
{_?MatrixQ,_List,_?MatrixQ},
	"DiagonalizedForm["<>Dimensions[First[opspecs]]<>"]",
_,""
],
ToBoxes[">>]], SuperoperatorType\[Rule]"],
If[StringQ[soptype],
ToBoxes["\""<>soptype<>"\""],soptype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
Superoperator/:Format[HoldPattern@Superoperator[LeftMultiplicationSuperoperator[Operator[opspecs_,___],___],opbasis_,basis_,opts___Rule]]:=
Module[{soptype},(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
DisplayForm[RowBox[{
"Superoperator[LeftMultiplicationSuperoperator[Operator[<<",
Switch[opspecs,
_?MatrixQ,
	Dimensions[opspecs],
{_?MatrixQ,_List,_?MatrixQ},
	"DiagonalizedForm["<>Dimensions[First[opspecs]]<>"]",
_,""
],
ToBoxes[">>]], SuperoperatorType\[Rule]"],
If[StringQ[soptype],
ToBoxes["\""<>soptype<>"\""],soptype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
Superoperator/:Format[HoldPattern@Superoperator[RightMultiplicationSuperoperator[Operator[opspecs_,___],___],opbasis_,basis_,opts___Rule]]:=
Module[{soptype},(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
DisplayForm[RowBox[{
"Superoperator[RightMultiplicationSuperoperator[Operator[<<",
Switch[opspecs,
_?MatrixQ,
	Dimensions[opspecs],
{_?MatrixQ,_List,_?MatrixQ},
	"DiagonalizedForm["<>Dimensions[First[opspecs]]<>"]",
_,""
],
ToBoxes[">>]], SuperoperatorType\[Rule]"],
If[StringQ[soptype],
ToBoxes["\""<>soptype<>"\""],soptype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
Superoperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Superoperator[a:Except[_Rule]..,opts___Rule]:=
Module[{filterrules},(
Superoperator[a,Sequence@@filterrules]
)/;(
filterrules=FilterRules[{opts},Options[Superoperator]];
!MatchQ[filterrules,{opts}]
)];


(* ::Input::Initialization:: *)
Superoperator[sop_,opts___Rule]:=Superoperator[sop,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
Superoperator[sop_,opbasis_,opts___Rule]:=Superoperator[sop,opbasis,Basis[],opts];


(* ::Input::Initialization:: *)
Superoperator[args__,opts___Rule]:=
Module[{soptype},(Message[Superoperator::badsoptype,soptype];Superoperator[args,SimplifyRules[SuperoperatorType->None,opts]])/;(
soptype=SuperoperatorType/.{opts}/.Options[Superoperator];
!MemberQ[ValidSuperoperatorTypes,soptype]
)];


(* ::Input::Initialization:: *)
Superoperator[num_?NumericQ,opbasis_,basis_,opts___Rule]:=Superoperator[num*UnitySuperoperator[],opbasis,basis,opts];


(* ::Input::Initialization:: *)
Superoperator/:Times[n1___?NumericQ,Superoperator[sop_,opbasis_,basis_,opts___Rule],
n2___?NumericQ]:=
Superoperator[Times[n1,sop,n2],opbasis,basis,
SimplifyRules[
SuperoperatorType->Undefined,SuperoperatorType->Automatic,opts]
];


(* ::Input::Initialization:: *)
HoldPattern@Superoperator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]:=
Superoperator[
Replace[ifunc,{mat_?MatrixQ:>Times[n1,n2,mat]},{3}][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Superoperator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],{_?MatrixQ,_List,_?MatrixQ}]:=
Superoperator[
Replace[ifunc,{X_?MatrixQ,D_List,Xinv_?MatrixQ}:>{X,Times[n1,n2,D],Xinv},{3}][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Superoperator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?SuperoperatorQ]:=
Operator[
Replace[ifunc,sop_?SuperoperatorQ]:>Times[n1,n2,sop][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis_,args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?SuperoperatorQ]:=
Operator[
Replace[ifunc,{sop_?SuperoperatorQ:>SuperoperatorMatrixRepresentation[sop,opbasis,basis,args]},{3}][t],
args];


(* ::Input::Initialization:: *)
Superoperator[badsop_,opbasis_,basis_,opts___Rule]:=(Message[Superoperator::badsop];$Failed)/;
(!SuperoperatorQ[badsop])&&(!MatchQ[badsop,_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ}])&&
(!MatchQ[badsop,
ifunc_InterpolatingFunction[_]/;
(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],
_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ}]
]
);


(* ::Input::Initialization:: *)
Superoperator/:HoldPattern@ReplaceAll[Superoperator[a_,more___],rules_]:=Superoperator[ReplaceEverywhere[a,rules],more];


(* ::Input::Initialization:: *)
sop_Superoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
Superoperator[sop_?SuperoperatorQ,opbasis_,basis_,opts___Rule]:=
Superoperator[
SuperoperatorMatrixRepresentation[sop,opbasis,basis],
opbasis,basis,opts
]/;!MatchQ[sop,(_CommutationSuperoperator|_LeftMultiplicationSuperoperator|_RightMultiplicationSuperoperator)]


(* ::Input::Initialization:: *)
Superoperator[
(head:(CommutationSuperoperator|LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[op_?OperatorQ,csopopts___Rule],
opbasis_,basis_,opts___Rule]:=
Superoperator[
head[
Operator[op,basis],
csopopts
],
opbasis,basis,opts
]/;!MatchQ[op,_Operator]


(* ::Input::Initialization:: *)
Superoperator[specs_,opbasis_,basis_,opts___Rule]:=
Superoperator[
specs,opbasis,basis,
SimplifyRules[
CheckSuperoperatorType->True,
opts
]
]/;(MatchQ[{CheckSuperoperatorType,SuperoperatorType}/.{opts}/.Options[Superoperator],{Automatic,Undefined}]&&(
MatchQ[specs,_CommutationSuperoperator|_LeftMultiplicationSuperoperator|_RightMultiplicationSuperoperator]||
((OperatorBasisDimension[opbasis]<=SuperoperatorTypeCheckDisableThreshold)&&
MatchQ[specs,_?NumericMatrixQ|{_?NumericMatrixQ,_List,_?NumericMatrixQ}])
)
);


(* ::Input::Initialization:: *)
Superoperator[csop:(_CommutationSuperoperator|_LeftMultiplicationSuperoperator|_RightMultiplicationSuperoperator),opbasis_,basis_,opts___Rule]/;MatchQ[{CheckSuperoperatorType,SuperoperatorType}/.{opts}/.Options[Superoperator],{True,Undefined}]:=
Superoperator[csop,opbasis,basis,
SimplifyRules[
SuperoperatorType->SuperoperatorType[csop],
CheckSuperoperatorType->False,
opts
]
];


(* ::Input::Initialization:: *)
Superoperator[sopmat_?MatrixQ,opbasis_,basis_,opts___Rule]:=
Superoperator[
sopmat,opbasis,basis,
SimplifyRules[
SuperoperatorType->Which[
HermitianQ[sopmat],"Hermitian",
AntiHermitianQ[sopmat],"AntiHermitian",
UnitaryQ[sopmat],"Unitary",
NormalQ[sopmat],"Normal",
True,None],
opts
]
]/;(
MatchQ[{CheckSuperoperatorType,SuperoperatorType}/.{opts}/.Options[Superoperator],{True,Undefined}]&&
NumericMatrixQ[sopmat]
);


(* ::Input::Initialization:: *)
Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule]:=
Module[{orthogX},(
Superoperator[
{X,evals,Xinv},opbasis,basis,
SimplifyRules[
SuperoperatorType->Which[
And@@((Chop[Abs[#]-1]==0)&/@evals),"Unitary",
(orthogX=OrthogonalQ[X];
orthogX &&
And@@(Element[#,Reals]&/@evals)),"Hermitian",
orthogX &&
And@@(Element[Chop@N[I #],Reals]&/@evals),"AntiHermitian",
True,None],
opts
]
]/;(
MatchQ[{CheckSuperoperatorType,SuperoperatorType}/.{opts}/.Options[Superoperator],{True,Undefined}]&&
MatchQ[{X,evals,Xinv},{_?NumericMatrixQ,{_?NumericQ..},_?NumericMatrixQ}]
)
)];


(* ::Input::Initialization:: *)
Superoperator[sopmat_?MatrixQ,opbasis_,basis_,opts___Rule]/;TrueQ[CheckMatrixDimensions/.{opts}/.Options[Superoperator]]:=
Module[{n},(
n=OperatorBasisDimension[opbasis];
If[Dimensions[sopmat]=={n,n},
Superoperator[sopmat,opbasis,basis,
SimplifyRules[
CheckMatrixDimensions->False,
opts
]
],
(Message[Superoperator::baddims];$Failed)
]
)];


(* ::Input::Initialization:: *)
Superoperator[X\[CapitalLambda]Xinv:{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule]/;TrueQ[CheckMatrixDimensions/.{opts}/.Options[Superoperator]]:=
Module[{n},(
n=OperatorBasisDimension[opbasis];
If[(Dimensions[X]==Dimensions[Xinv]=={n,n})&&Length[evals]==n,
Superoperator[X\[CapitalLambda]Xinv,opbasis,basis,
SimplifyRules[
CheckMatrixDimensions->False,
opts
]
],
(Message[Superoperator::baddims];$Failed)
]
)];


(* ::Input::Initialization:: *)
HoldPattern@OperatorBasis[Superoperator[_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ},opbasis_,basis_,opts___Rule]]^:=opbasis;


(* ::Input::Initialization:: *)
HoldPattern@Basis[Superoperator[_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ},opbasis_,basis_,opts___Rule]]^:=basis;


(* ::Input::Initialization:: *)
Superoperator/:HoldPattern@Exp[Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule]]:=Superoperator[{X,Exp/@evals,Xinv},opbasis,basis,opts];


(* ::Input::Initialization:: *)
Superoperator/:HoldPattern[E^(Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule])]:=Superoperator[{X,Exp/@evals,Xinv},opbasis,basis,opts];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Exp,Infinity,
HoldPattern@Exp[Times[n1___?NumericQ,Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule],n2___?NumericQ]]:=Superoperator[{X,Exp/@(n1*n2*evals),Xinv},opbasis,basis,opts]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
HoldPattern[E^(Times[n1___?NumericQ,Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,basis_,opts___Rule],n2___?NumericQ])]:=Superoperator[{X,Exp/@(n1*n2*evals),Xinv},opbasis,basis,opts]
];


(* ::Input::Initialization:: *)
Superoperator/:Adjoint[Superoperator[mat_?MatrixQ,opbasis_,basis_,opts___Rule]]:=
Superoperator[
Switch[SuperoperatorType/.{opts}/.Options[Superoperator],
"Hermitian",mat,
_,Adjoint[mat]
],
opbasis,basis,opts
];


(* ::Input::Initialization:: *)
Superoperator/:sop_Superoperator[op_Operator]:=
Module[{opbasis,basis},(
opbasis=OperatorBasis[];basis=Basis[];
Operator[
SuperoperatorMatrixRepresentation[sop,opbasis,basis].
OperatorVectorRepresentation[op,opbasis,basis],
opbasis,
basis
]
)];


(* ::Input::Initialization:: *)
Superoperator/:sop_Superoperator[op_?OperatorQ]:=
Module[{opbasis,basis},(
opbasis=OperatorBasis[];basis=Basis[];
BasisOperators[opbasis].SuperoperatorMatrixRepresentation[sop,opbasis,basis].OperatorVectorRepresentation[op,opbasis]
)];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern[Dot[c__,sop_Superoperator,op_?OperatorQ]]:=Dot[c,sop[op]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern[Dot[c__,sop_Superoperator][op_?OperatorQ]]:=Dot[c,sop[op]]
];


(* ::Input::Initialization:: *)
Superoperator::notherm="The context requires a hermitian superoperator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Superoperator::notunitary="The context implies a unitary superoperator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Superoperator::notnormal="The context implies a normal superoperator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Superoperator::badsoptype="SuperoperatorType `1` not recognized.";


(* ::Input::Initialization:: *)
Superoperator::incompatspinsys="The Superoperator expression has been defined using a spin system incompatible with the requested operator basis.";


(* ::Input::Initialization:: *)
Superoperator::badsop="Superoperator may not be applied to a symbol that is not a superoperator, a matrix, or the diagonalized form of a matrix.";


(* ::Input::Initialization:: *)
Superoperator::assnorm="To reduce computation time, a superoperator has been assumed to be Normal. This assumption is made when the operator basis dimension is larger than `1`."; 


(* ::Input::Initialization:: *)
Superoperator::times="superoperators must be multiplied by Dot (\".\"), not with Times (\"\[Times]\")";


(* ::Input::Initialization:: *)
Superoperator::baddims="the Superoperator definition uses a matrix whose dimensions are inconsistent with the specified operator basis.";


(* ::Input::Initialization:: *)
UnitySuperoperator[][op_]:=op;


(* ::Input::Initialization:: *)
UnitySuperoperator/:Dot[a___,UnitySuperoperator[],b__]:=Dot[a,b];


(* ::Input::Initialization:: *)
UnitySuperoperator/:Dot[a__,UnitySuperoperator[],b___]:=Dot[a,b];


(* ::Input::Initialization:: *)
UnitySuperoperator/:Format[UnitySuperoperator[]]:= "\!\(\*OverscriptBox[\(\[DoubleStruckOne]\), \(^\)]\)";


(* ::Input::Initialization:: *)
UnitySuperoperator/:HoldPattern[Times[a___,_UnitySuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
UnitySuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
NullSuperoperator/:Format[NullSuperoperator[]]:="\!\(\*OverscriptBox[\(0\), \(^\)]\)";


(* ::Input::Initialization:: *)
NullSuperoperator[][op_]:=NullOperator[];


(* ::Input::Initialization:: *)
NullSuperoperator/:Dot[a___,NullSuperoperator[],b__]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
NullSuperoperator/:Dot[a__,NullSuperoperator[],b___]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
NullSuperoperator/:HoldPattern@Times[n1___?NumericQ,NullSuperoperator[],n2___?NumericQ]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
NullSuperoperator/:HoldPattern@Plus[sops2___?SuperoperatorQ,NullSuperoperator[],sops1___?SuperoperatorQ]:=Plus[sops2,sops1];


(* ::Input::Initialization:: *)
NullSuperoperator/:HoldPattern[Times[a___,_NullSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
NullSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
Options[CommutationSuperoperator]={OperatorType->Undefined,Assumptions->None}


(* ::Input::Initialization:: *)
CommutationSuperoperator/:HoldPattern[Times[a___,_CommutationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
CommutationSuperoperator/:HoldPattern@Times[(n1:Except[_?OperatorQ|_?SuperoperatorQ]...),CommutationSuperoperator[op1_?OperatorQ,opts___Rule],(n2:Except[_?OperatorQ|_?SuperoperatorQ]...)]:=CommutationSuperoperator[Times[n1,n2,op1],opts];


(* ::Input::Initialization:: *)
CommutationSuperoperator/:
HoldPattern@Plus[CommutationSuperoperator[op1_,opts1___Rule],CommutationSuperoperator[op2_,opts2___Rule],more___]:=Plus[CommutationSuperoperator[op1+op2,SimplifyRules[opts1,opts2]],more];


(* ::Input::Initialization:: *)
sop_CommutationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
CommutationSuperoperator[
Operator[op_,basis_,opopts___Rule],
opts___Rule
]:=Module[{optype,csoptype},(
CommutationSuperoperator[
Operator[op,basis,opopts],
SimplifyRules[
OperatorType->optype,
opts
]
]/;(
optype=OperatorType/.{opopts}/.Options[Operator];
csoptype=OperatorType/.{opts}/.Options[CommutationSuperoperator];
!MatchQ[optype,csoptype]
)
)];


(* ::Input::Initialization:: *)
CommutationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
CommutationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[CommutationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[CommutationSuperoperator];
MatchQ[assoptype,optype]||
MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
CommutationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
Message[CommutationSuperoperator::badass,assoptype,optype];
CommutationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[CommutationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[CommutationSuperoperator];
!MatchQ[assoptype,optype]&&
!MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
CommutationSuperoperator[0,opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
CommutationSuperoperator[NullOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
CommutationSuperoperator[UnityOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
CommutationSuperoperator[op1_][op2_]:=Commutator[op1,op2]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,CommutationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=UnitySuperoperator[]/;(Times[num1*num2]==0)
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,CommutationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=Dot[Exp[num1*num2*op1],op2,Exp[-num1*num2*op1]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:
HoldPattern[Power[E,CommutationSuperoperator[op1_,opts___Rule]][op2_]
]:=Dot[Exp[op1],op2,Exp[-op1]]
];


(* ::Input::Initialization:: *)
CommutationSuperoperator::badass="A conflict has been detected between the assumed OperatorType \"`1`\" for the argument of a CommutationSuperoperator, and the determined OperatorType \"`2`\". Proceeding with Assumptions disabled.";


(* ::Input::Initialization:: *)
Options[LeftMultiplicationSuperoperator]={OperatorType->Undefined,Assumptions->None}


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator/:HoldPattern[Times[a___,_LeftMultiplicationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator/:HoldPattern@Times[(n1:Except[_?OperatorQ|_?SuperoperatorQ]...),LeftMultiplicationSuperoperator[op1_?OperatorQ,opts___Rule],(n2:Except[_?OperatorQ|_?SuperoperatorQ]...)]:=LeftMultiplicationSuperoperator[Times[n1,n2,op1],opts];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator/:
HoldPattern@Plus[LeftMultiplicationSuperoperator[op1_,opts1___Rule],LeftMultiplicationSuperoperator[op2_,opts2___Rule],more___]:=Plus[LeftMultiplicationSuperoperator[op1+op2,SimplifyRules[opts1,opts2]],more];


(* ::Input::Initialization:: *)
sop_LeftMultiplicationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[
Operator[op_,basis_,opopts___Rule],
opts___Rule
]:=Module[{optype,csoptype},(
LeftMultiplicationSuperoperator[
Operator[op,basis,opopts],
SimplifyRules[
OperatorType->optype,
opts
]
]/;(
optype=OperatorType/.{opopts}/.Options[Operator];
csoptype=OperatorType/.{opts}/.Options[LeftMultiplicationSuperoperator];
!MatchQ[optype,csoptype]
)
)];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
LeftMultiplicationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[LeftMultiplicationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[LeftMultiplicationSuperoperator];
MatchQ[assoptype,optype]||
MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
Message[LeftMultiplicationSuperoperator::badass,assoptype,optype];
LeftMultiplicationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[LeftMultiplicationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[LeftMultiplicationSuperoperator];
!MatchQ[assoptype,optype]&&
!MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[0,opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[NullOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[UnityOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator[op1_][op2_]:=Dot[op1,op2]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,LeftMultiplicationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=UnitySuperoperator[]/;(Times[num1*num2]==0)
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,LeftMultiplicationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=Dot[Exp[num1*num2*op1],op2]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:
HoldPattern[Power[E,LeftMultiplicationSuperoperator[op1_,opts___Rule]][op2_]
]:=Dot[Exp[op1],op2]
];


(* ::Input::Initialization:: *)
LeftMultiplicationSuperoperator::badass="A conflict has been detected between the assumed OperatorType \"`1`\" for the argument of a LeftMultiplicationSuperoperator, and the determined OperatorType \"`2`\". Proceeding with Assumptions disabled.";


(* ::Input::Initialization:: *)
Options[RightMultiplicationSuperoperator]={OperatorType->Undefined,Assumptions->None}


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator/:HoldPattern[Times[a___,_RightMultiplicationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator/:HoldPattern@Times[(n1:Except[_?OperatorQ|_?SuperoperatorQ]...),RightMultiplicationSuperoperator[op1_?OperatorQ,opts___Rule],(n2:Except[_?OperatorQ|_?SuperoperatorQ]...)]:=RightMultiplicationSuperoperator[Times[n1,n2,op1],opts];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator/:
HoldPattern@Plus[RightMultiplicationSuperoperator[op1_,opts1___Rule],RightMultiplicationSuperoperator[op2_,opts2___Rule],more___]:=Plus[RightMultiplicationSuperoperator[op1+op2,SimplifyRules[opts1,opts2]],more];


(* ::Input::Initialization:: *)
sop_RightMultiplicationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[
Operator[op_,basis_,opopts___Rule],
opts___Rule
]:=Module[{optype,csoptype},(
RightMultiplicationSuperoperator[
Operator[op,basis,opopts],
SimplifyRules[
OperatorType->optype,
opts
]
]/;(
optype=OperatorType/.{opopts}/.Options[Operator];
csoptype=OperatorType/.{opts}/.Options[RightMultiplicationSuperoperator];
!MatchQ[optype,csoptype]
)
)];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
RightMultiplicationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[RightMultiplicationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[RightMultiplicationSuperoperator];
MatchQ[assoptype,optype]||
MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[op_Operator,opts___Rule]:=
Module[{ass,optype,assoptype},(
Message[RightMultiplicationSuperoperator::badass,assoptype,optype];
RightMultiplicationSuperoperator[op,
SimplifyRules[
Assumptions->None,
opts
]
]
)/;(
ass=Assumptions/.{opts};
optype=OperatorType/.{opts}/.Options[RightMultiplicationSuperoperator];
MatchQ[ass,{_Rule..}]&&
!MatchQ[optype,Undefined]&&(
assoptype=OperatorType/.ass/.Options[RightMultiplicationSuperoperator];
!MatchQ[assoptype,optype]&&
!MatchQ[{optype,assoptype},{"Hermitian"|"AntiHermitian"|"Unitary","Normal"}]
)
)
];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[0,opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[NullOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[UnityOperator[___],opts___Rule]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator[op1_][op2_]:=Dot[op2,op1]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,RightMultiplicationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=UnitySuperoperator[]/;(Times[num1*num2]==0)
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,Times[num1___,RightMultiplicationSuperoperator[op1_,opts___Rule],num2___]][op2_]
]:=Dot[op2,Exp[num1*num2*op1]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:
HoldPattern[Power[E,RightMultiplicationSuperoperator[op1_,opts___Rule]][op2_]
]:=Dot[op2,Exp[op1]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
Power/:HoldPattern[Power[E,A___,k_.*Plus[kRMSO_.*RMSO:RightMultiplicationSuperoperator[op1_,opts1___Rule],kLMSO_.*LMSO:LeftMultiplicationSuperoperator[op2_,opts2___Rule]],B___][op_]
]:=(Power[E,A,k*kRMSO*RMSO,B].Power[E,A,k*kLMSO*LMSO,B])[op]
];


(* ::Input::Initialization:: *)
RightMultiplicationSuperoperator::badass="A conflict has been detected between the assumed OperatorType \"`1`\" for the argument of a RightMultiplicationSuperoperator, and the determined OperatorType \"`2`\". Proceeding with Assumptions disabled.";


(* ::Input::Initialization:: *)
sop_DoubleCommutationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator/:HoldPattern[Times[a___,_DoubleCommutationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[0,_]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[_,0]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[NullOperator[___],op_?OperatorQ]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[op_?OperatorQ,NullOperator[___]]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[UnityOperator[___],op_?OperatorQ]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[op_?OperatorQ,UnityOperator[___]]:=NullSuperoperator[];


(* ::Input::Initialization:: *)
DoubleCommutationSuperoperator[op1_,op2_][op3_]:=CommutationSuperoperator[op1][CommutationSuperoperator[op2][op3]];


(* ::Input::Initialization:: *)
Options[ProjectionSuperoperator]={Normalize->True};


(* ::Input::Initialization:: *)
sop_ProjectionSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
ProjectionSuperoperator/:HoldPattern[Times[a___,_ProjectionSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Plus,Infinity,
HoldPattern@Plus[sops:ProjectionSuperoperator[_,___Rule]..][op_]:=
Plus@@((#[op])&/@{sops})
];


(* ::Input::Initialization:: *)
ProjectionSuperoperator[n_?NumericQ,opts___Rule]:=n *ProjectionSuperoperator[UnityOperator[],opts];


(* ::Input::Initialization:: *)
ProjectionSuperoperator[pop_?OperatorQ,opts___Rule]/;(Normalize/.{opts}/.Options[ProjectionSuperoperator]):=ProjectionSuperoperator[NormalizeOperator[pop],Normalize->False,opts];


(* ::Input::Initialization:: *)
ProjectionSuperoperator[pop_?OperatorQ,opts___Rule][op_]/;!(Normalize/.{opts}/.Options[ProjectionSuperoperator]):=
pop*LiouvilleBracket[pop,op];


(* ::Input::Initialization:: *)
Options[ShiftSuperoperator]={Normalize->True};


(* ::Input::Initialization:: *)
sop_ShiftSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
ShiftSuperoperator/:HoldPattern[Times[a___,_ShiftSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Plus,Infinity,
HoldPattern@Plus[sops:ShiftSuperoperator[__,___Rule]..][op_]:=Plus@@((#[op])&/@{sops})
];


(* ::Input::Initialization:: *)
ShiftSuperoperator[n_?NumericQ,op_?OperatorQ,opts___Rule]:=n *ShiftSuperoperator[UnityOperator[],op,opts];


(* ::Input::Initialization:: *)
ShiftSuperoperator[op_?OperatorQ,n_?NumericQ,opts___Rule]:=n *ShiftSuperoperator[op,UnityOperator[],opts];


(* ::Input::Initialization:: *)
ShiftSuperoperator[n1_?NumericQ,n2_?NumericQ,opts___Rule]:=n1 n2 *ShiftSuperoperator[UnityOperator[],UnityOperator[],opts];


(* ::Input::Initialization:: *)
ShiftSuperoperator[op2_?OperatorQ,op1_?OperatorQ,opts___Rule]/;(Normalize/.{opts}/.Options[ShiftSuperoperator]):=ShiftSuperoperator[NormalizeOperator[op2],NormalizeOperator[op1],Normalize->False,opts];


(* ::Input::Initialization:: *)
ShiftSuperoperator[op2_?OperatorQ,op1_?OperatorQ,opts___Rule][op_]/;!(Normalize/.{opts}/.Options[ShiftSuperoperator]):=
op2*LiouvilleBracket[op1,op];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator/:HoldPattern[Times[a___,_CoherenceOrderFiltrationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[opts___Rule]:=UnitySuperoperator[];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[spins___,p:Except[_List],opts___Rule]:=CoherenceOrderFiltrationSuperoperator[spins,{p},opts];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[orders:{Except[_List]..},opts___Rule]:=CoherenceOrderFiltrationSuperoperator[First/@SpinSystem[],orders,opts];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[spin:Except[_List],orders:{Except[_List]..},opts___Rule]:=CoherenceOrderFiltrationSuperoperator[{spin},orders,opts];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[spins:{Except[_List]..},orders:{Except[_List]..},opts___Rule]:=CoherenceOrderFiltrationSuperoperator[{spins,orders},opts];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[arg1___,{spins:{Except[_List]..},p:Except[_List]},arg2___,opts___Rule]:=CoherenceOrderFiltrationSuperoperator[arg1,{spins,{p}},arg2,opts];


(* ::Input::Initialization:: *)
CoherenceOrderFiltrationSuperoperator[arg1___,{spin:Except[_List],orders:{Except[_List]..}},arg2___,opts___Rule]:=CoherenceOrderFiltrationSuperoperator[arg1,{{spin},orders},arg2,opts];


(* ::Input::Initialization:: *)
sop_CoherenceOrderFiltrationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern[CoherenceOrderFiltrationSuperoperator[args___][op_?OperatorQ]]:=
BasisOperators[].SuperoperatorMatrixRepresentation[CoherenceOrderFiltrationSuperoperator[args]
].OperatorVectorRepresentation[op]


(* ::Input::Initialization:: *)
sop_SphericalComponentFiltrationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator/:HoldPattern[Times[a___,_SphericalComponentFiltrationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator[{\[Lambda]_,\[Mu]2_,\[Mu]1_}]:=(Message[SphericalComponentFiltrationSuperoperator::notspinshf];$Failed)/;!MatchQ[Last/@SpinSystem[],{(1/2)...}]


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator[{\[Lambda]_,\[Mu]2_,\[Mu]1_}]:=
Module[{nspin,\[CapitalLambda],ops2,ops1,oppairs},(
nspin=Length[SpinSystem[]];
\[CapitalLambda]=Cases[Subsets[First/@SpinSystem[],{\[Lambda],nspin}],Except[{}]];
Off[opT::multiple];
ops2=Union@Flatten[opT[#,{\[Lambda],\[Mu]2},Normalize->True]&/@\[CapitalLambda]];
ops1=Union@Flatten[opT[#,{\[Lambda],\[Mu]1},Normalize->True]&/@\[CapitalLambda]];
oppairs=Transpose[{ops2,ops1}];
On[opT::multiple];
If[
MatchQ[ops2,{}]||MatchQ[ops1,{}],
NullSuperoperator[],
Plus@@
MapThread[
ShiftSuperoperator[#1,#2]&,
{ops2,ops1}
]
]
)];


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator[args___,opts___Rule]/;!MatchQ[{args},{\[Lambda]_,\[Mu]2_,\[Mu]1_}]:=
(Message[SphericalComponentFiltrationSuperoperator::invalargs];$Failed);


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator::notspinshf="SphericalComponentFiltrationSuperoperator is currently only implemented for spins-1/2";


(* ::Input::Initialization:: *)
SphericalComponentFiltrationSuperoperator::invalargs="Invalid arguments for SphericalComponentFiltrationSuperoperator.";


(* ::Input::Initialization:: *)
RotationSuperoperator/:HoldPattern[Times[a___,_RotationSuperoperator,b___]]/;Or@@(SuperoperatorQ/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[angs_List]:=RotationSuperoperator[First/@SpinSystem[],angs];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[j:Except[_List],angs_List]:=RotationSuperoperator[{j},angs];


(* ::Input::Initialization:: *)
RotationSuperoperator[spins_,{\[Beta]_,\[Phi]_}]/;!MatchQ[\[Beta],Except[_List|_String]]:=
(Message[RotationSuperoperator::inv\[Beta]];$Failed);


(* ::Input::Initialization:: *)
RotationSuperoperator[spins_,{\[Beta]_,\[Phi]_String}]/;!MatchQ[\[Phi],"x"|"y"|"z"|"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x"|"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y"]:=(Message[RotationSuperoperator::inv\[Phi]];$Failed);


(* ::Input::Initialization:: *)
RotationSuperoperator[spins_,\[CapitalOmega]_]/;!MatchQ[
\[CapitalOmega],
{Except[_List|_String],Except[_List]}|
{Except[_List|_String],Except[_List|_String],Except[_List|_String]}|{Except[_List|_String],{Except[_List|_String],Except[_List|_String]}
}]:=
(Message[RotationSuperoperator::invangle];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{0,\[Mu]_}]:=UnitySuperoperator[];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,"-x"}]:=RotationSuperoperator[spins,{-\[Beta],"x"}];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,"-y"}]:=RotationSuperoperator[spins,{-\[Beta],"y"}];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,"-z"}]:=RotationSuperoperator[spins,{-\[Beta],"z"}];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,\[Phi]_}]:=RotationSuperoperator[spins,{\[Beta],"x"}]/;Mod[\[Phi],2\[Pi]]==0;


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,\[Phi]_}]:=RotationSuperoperator[spins,{\[Beta],"y"}]/;Mod[\[Phi],2\[Pi]]==\[Pi]/2;


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,\[Phi]_}]:=RotationSuperoperator[spins,{-\[Beta],"x"}]/;Mod[\[Phi],2\[Pi]]==\[Pi];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,\[Phi]_}]:=RotationSuperoperator[spins,{-\[Beta],"y"}]/;Mod[\[Phi],2\[Pi]]==3\[Pi]/2;


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Beta]_,\[Phi]:Except[(_List)|"x"|"y"|"z"|"-x"|"-y"|"-z"]}]:=
Dot[
RotationSuperoperator[spins,{\[Phi],"z"}],
RotationSuperoperator[spins,{\[Beta],"x"}],
RotationSuperoperator[spins,{-\[Phi],"z"}]
];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Alpha]_,\[Beta]_,\[Gamma]_}]:=RotationSuperoperator[spins,{\[Alpha],"z"}].RotationSuperoperator[spins,{\[Beta],"y"}].RotationSuperoperator[spins,{\[Gamma],"z"}];


(* ::Input::Initialization:: *)
HoldPattern@RotationSuperoperator[spins_List,{\[Xi]_,{\[Theta]_,\[Phi]_}}]:=RotationSuperoperator[spins,{\[Phi],"z"}].RotationSuperoperator[spins,{\[Theta],"y"}].RotationSuperoperator[spins,{\[Xi],"z"}].RotationSuperoperator[spins,{-\[Theta],"y"}].RotationSuperoperator[spins,{-\[Phi],"z"}];


(* ::Input::Initialization:: *)
sop_RotationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern[RotationSuperoperator[spins_List,angs_List][op_]]:=Dot[opR[spins,angs],op,Adjoint[opR[spins,angs]]];


(* ::Input::Initialization:: *)
RotationSuperoperator::inv\[Beta]="invalid flip angle for RotationSuperoperator.";


(* ::Input::Initialization:: *)
RotationSuperoperator::inv\[Phi]="invalid phase for RotationSuperoperator.";


(* ::Input::Initialization:: *)
RotationSuperoperator::invangle="invalid angle definition for RotationSuperoperator.";


(* ::Input::Initialization:: *)
sop_SpinPermutationSuperoperator[0]=NullOperator[];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator/:HoldPattern[Times[a___,_SpinPermutationSuperoperator,b___]]/;Or@@(SpinPermutationSuperoperator/@{a,b}):=(Message[Superoperator::times];$Failed);


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator[perm_]:=SpinPermutationSuperoperator[perm,SpinSystem[]];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator[perms_?MatrixQ,spinsys_?MatrixQ]:=Apply[Dot,SpinPermutationSuperoperator[#,spinsys]&/@perms];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator[perm_List,spinsys_?MatrixQ]:=
Module[{validities, invalspins},(
invalspins=Pick[perm,validities,False];
Message[SpinPermutationSuperoperator::invalspins,invalspins];
$Failed
)/;(
validities=ValidSpinQ/@perm;
!And@@validities
)];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator[perm_List,spinsys_?MatrixQ]:=
Module[{pairs,Ivals, mismatches},(
Message[SpinPermutationSuperoperator::invalpair,mismatches];
$Failed
)/;(
pairs=Partition[perm,2,1];
Ivals=Last/@spinsys;
mismatches=Select[pairs,(Pick[Ivals,First/@spinsys,First[#]]!=Pick[Ivals,First/@spinsys,Last[#]])&];
mismatches!={}
)];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator[perm_List,spinsys_]:=
Module[{spop,zbasis,zkbopbasis},(
spop=SpinPermutationOperator[perm,spinsys];
zbasis=ZeemanBasis[spinsys];
zkbopbasis=ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"];
SpinPermutationSuperoperator[perm,spinsys]=
Superoperator[
SparseArray[
KroneckerProduct[
MatrixRepresentation[spop,zbasis],
Conjugate@MatrixRepresentation[spop,zbasis]
]
],
zkbopbasis,
zbasis,
SuperoperatorType->"Unitary",
CheckSuperoperatorType->False
]
)];


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator::invalspins="The following spin labels are invalid for the current SpinSystem: `1`";


(* ::Input::Initialization:: *)
SpinPermutationSuperoperator::invalpair="The following pairs of spins cannot be exchanged since they have different spin quantum numbers:`1`"; 


(* ::Input::Initialization:: *)
Options[SuperoperatorMatrixRepresentation]:={Method->Automatic};


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,opts___Rule]:=
SuperoperatorMatrixRepresentation[superop,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,opbasis_,opts___Rule]:=
SuperoperatorMatrixRepresentation[superop,opbasis,Basis[],opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,opbasis_,basis_,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,opbasis_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
SuperoperatorMatrixRepresentation[superop,opbasis,opts]
);


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,Undefined,basis_,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[DefaultOperatorBasis[],CheckOperatorBasis->False];
SuperoperatorMatrixRepresentation[superop,opts]
);


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[superop_,opbasis_,basis_,opts___Rule]/;!Equal[SpinSystem[opbasis],SpinSystem[basis]]:=
Module[{defaultopbasis},(
SetSpinSystem[SpinSystem[basis]];
defaultopbasis=DefaultOperatorBasis[];
Message[OperatorBasis::default];
SetOperatorBasis[defaultopbasis,CheckOperatorBasis->False];
SuperoperatorMatrixRepresentation[superop,defaultopbasis,basis,opts]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[num_?NumericQ,more___]/;(Chop[num]==0):=SuperoperatorMatrixRepresentation[NullSuperoperator[],more];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[num_?NumericQ,more___]:=SuperoperatorMatrixRepresentation[num*UnitySuperoperator[],more];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[sop:Except[_?SuperoperatorQ],more___]:=Module[{fixedsop},(
SuperoperatorMatrixRepresentation[fixedsop,more]
)/;(
fixedsop=Chop[sop];
MatchQ[fixedsop,_?SuperoperatorQ]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop_,more___]:=(Message[SuperoperatorMatrixRepresentation::badsop];$Failed)/;(!SuperoperatorQ[sop]);


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Plus[sops___],opbasis_,basis_,opts___Rule]:=
CombineSuperoperatorMatrixRepresentations@@Map[
SuperoperatorMatrixRepresentation[#,opbasis,basis,opts]&,
{sops}
]


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[mat1_]:=mat1;


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[mat1_,mat2_,more__]:=CombineSuperoperatorMatrixRepresentations[CombineSuperoperatorMatrixRepresentations[mat1,mat2],more];


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[mat1_?MatrixQ,mat2_?MatrixQ]:=mat1+mat2;


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[mat_?MatrixQ,ifunc_InterpolatingFunction[t_]]:=CombineSuperoperatorMatrixRepresentations[ifunc,mat];


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[ifunc_InterpolatingFunction[t_],mat_?MatrixQ]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]:=
Replace[ifunc,{m_?MatrixQ:>m+mat},{3}][t];


(* ::Input::Initialization:: *)
CombineSuperoperatorMatrixRepresentations[ifunc1_InterpolatingFunction[t_],ifunc2_InterpolatingFunction]/;
(Depth[ifunc1]>=3)&&
MatchQ[ifunc1[ifunc1[[1,1,1]]],_?MatrixQ]&&
(Depth[ifunc2]>=3)&&
MatchQ[ifunc2[ifunc2[[1,1,1]]],_?MatrixQ]:=
Module[{interptimes},(
interptimes=Sort@Union[ifunc1[[3,1]],ifunc1[[3,2]]];
Interpolation[(ifunc1[#]+ifunc2[#])&/@interptimes]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[Times[num:Except[_?SuperoperatorQ]..,sop_?SuperoperatorQ],opbasis_,basis_,opts___Rule]:=
num*SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[Times[sop_?SuperoperatorQ,num:Except[_?SuperoperatorQ]..],opbasis_,basis_,opts___Rule]:=
num*SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[num:(_?NumericQ)|(_Symbol)|HoldPattern@Times[(_?NumericQ|_Symbol)..],opbasis_,basis_,opts___Rule]:=
num*SuperoperatorMatrixRepresentation[UnitySuperoperator[],opbasis,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Adjoint[sop_],opbasis_,basis_,opts___Rule]:=
Adjoint@SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Dot[sop1__,Exp[sop_]|Power[E,sop_],sop2___],opbasis_,basis_,opts___Rule]:=
SuperoperatorMatrixRepresentation[Dot[sop1],opbasis,basis,opts].
SuperoperatorMatrixRepresentation[Dot[Exp[sop],sop2],opbasis,basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[sop1___,Exp[sop_]|Power[E,sop_],sop2__],opbasis_,basis_,opts___Rule]:=
SuperoperatorMatrixRepresentation[Dot[sop1,Exp[sop]],opbasis,basis,opts].SuperoperatorMatrixRepresentation[Dot[sop2],opbasis,basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Exp[op_?OperatorQ]|Power[E,sop_?SuperoperatorQ],opbasis_,basis_,opts___Rule]:=
SparseArray@MatrixExp@SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts]


(* ::Input::Initialization:: *)
Superoperator/:HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[sop_?SuperoperatorQ,args___],
opbasis_,basis_,opts___Rule]:=SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[mat_?MatrixQ,opbasis_,_,___Rule],
opbasis_,_,opts___Rule]:=mat;


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,_,___Rule],opbasis_,_,opts___Rule]:=
Chop[X.SparseArray[DiagonalMatrix[evals]].Xinv];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis_,___Rule],opbasis_,_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]):=ifunc[t];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis_,___Rule],opbasis_,_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],{_?MatrixQ,_List,_?MatrixQ}]):=Replace[ifunc,{X_?MatrixQ,D_List,Xinv_?MatrixQ}:>X.DiagonalMatrix[D].Xinv,{3}][t];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis_,___Rule],opbasis_,_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?SuperoperatorQ]):=Replace[ifunc,sop_?SuperoperatorQ:>SuperoperatorMatrixRepresentation[sop,opbasis,basis],{3}][t];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Superoperator[specs_,opbasis1_,basis1_,opts1__Rule],opbasis2_,basis2_,opts2___Rule]:=
If[
Equal[SpinSystem[opbasis1],SpinSystem[opbasis2]],
MultiplyMatricesAndMatrixInterpolationFunctions[
OperatorBasisTransformationMatrix[opbasis2,opbasis1],SuperoperatorMatrixRepresentation[Superoperator[specs,opbasis1,basis1,opts1],
opbasis1,basis2,opts2
],
OperatorBasisTransformationMatrix[opbasis1,opbasis2]
],
(Message[Superoperator::incompatspinsys];$Failed)
];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:UnitySuperoperator[],opbasis_,basis_,opts___Rule]:=
SparseArray[Table[{i,i}->1,{i,1,OperatorBasisDimension[opbasis]}]];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:NullSuperoperator[],opbasis_,basis_,opts___Rule]:=
SparseArray[Table[{i,i}->0,{i,1,OperatorBasisDimension[opbasis]}]];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop_,opbasis_,basis_,opts___Rule]:=
Module[{spinsys},(
SuperoperatorMatrixRepresentation[sop,opbasis,ZeemanBasis[spinsys],Method->Automatic,opts]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
!MatchQ[basis,ZeemanBasis[spinsys]]
)]


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop_,opbasis_,basis_,opts___Rule]:=
Module[{iopbasis,spinsys},(
iopbasis=ZeemanKetBraOperatorBasis[Sorted->"Canonical"];
MultiplyMatricesAndMatrixInterpolationFunctions[
OperatorBasisTransformationMatrix[opbasis,iopbasis,basis],
SuperoperatorMatrixRepresentation[sop,iopbasis,basis,Method->Automatic,opts],
OperatorBasisTransformationMatrix[iopbasis,opbasis,basis]
]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
!MatchQ[opbasis,ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"]]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[Dot[sops:(_?SuperoperatorQ..)],opbasis_,basis_,opts___Rule]:=
Module[{matreps},(
matreps=SuperoperatorMatrixRepresentation[#,opbasis,basis,opts]&/@{sops};
If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]
]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
sop:RotationSuperoperator[args___],
opbasis_,basis_,opts___Rule
]:=
Module[{spinsys,Rmat},(
Rmat=MatrixRepresentation[RotationOperator[args],basis,opts];
SparseArray@ComplexExpand@Normal[KroneckerProduct[Rmat,Conjugate@Rmat]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
CommutationSuperoperator[op_?OperatorQ,___],opbasis_,zbasis_,opts___Rule]:=
Module[{spinsys},(
SuperoperatorMatrixRepresentation[
CommutationSuperoperator[
Operator[op,zbasis,CheckOperatorType->False]
],
opbasis,zbasis,opts
])/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&
!MatchQ[op,HoldPattern[Operator[_?MatrixQ,zbasis,___]|Operator[_InterpolatingFunction[_],zbasis,___]]]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
CommutationSuperoperator[Operator[mat_?MatrixQ,basis_,___],___],
opbasis_,basis_,opts___Rule
]:=
Module[{spinsys,Emat},(
Emat=MatrixRepresentation[UnityOperator[],basis,opts];
SparseArray[KroneckerProduct[mat,Emat]-Transpose@KroneckerProduct[Emat,mat]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
CommutationSuperoperator[Operator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],basis_,more1___],more2___],
opbasis_,basis_,opts___Rule
]:=
MultiplyMatricesAndMatrixInterpolationFunctions[
SuperoperatorMatrixRepresentation[Times[n1,n2,UnitySuperoperator[]],opbasis,basis],
SuperoperatorMatrixRepresentation[
CommutationSuperoperator[Operator[ifunc[t],basis,more1],more2],
opbasis,basis,opts]
];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
CommutationSuperoperator[Operator[ifunc_InterpolatingFunction[t_],basis_,___],___],
opbasis_,basis_,opts___Rule
]:=
Module[{spinsys,Emat},(
Emat=MatrixRepresentation[UnityOperator[],basis,opts];
Replace[ifunc,
{mat_?MatrixQ:>KroneckerProduct[mat,Emat]-Transpose@KroneckerProduct[Emat,mat]},
{3}
][t]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[CommutationSuperoperator[op_?OperatorQ,___]]|E^(CommutationSuperoperator[op_?OperatorQ,___]),opbasis_,zbasis_,opts___Rule]:=
Module[{spinsys},(
SuperoperatorMatrixRepresentation[
Exp[CommutationSuperoperator[
Operator[op,zbasis,CheckOperatorType->False]
]],
opbasis,zbasis,opts
])/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&
!MatchQ[op,HoldPattern[Operator[_?MatrixQ,zbasis,___]|Operator[_InterpolatingFunction[_]]]];
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[CommutationSuperoperator[HoldPattern@Operator[mat_?MatrixQ,zbasis_,___],___]]|E^(CommutationSuperoperator[HoldPattern@Operator[mat_?MatrixQ,zbasis_,___],___]),
opbasis_,zbasis_,opts___Rule
]:=
Module[{spinsys,Rmat,Rmatinv},(
Rmat=MatrixExp[mat];
Rmatinv=MatrixExp[-mat];
SparseArray[KroneckerProduct[Rmat,Transpose@Rmatinv]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[CommutationSuperoperator[HoldPattern@Operator[ifunc_InterpolatingFunction[t_],basis_,___],___]]|E^(CommutationSuperoperator[HoldPattern@Operator[ifunc_InterpolatingFunction[t_],basis_,___],___]),
opbasis_,basis_,opts___Rule
]:=
Module[{spinsys},(
Replace[ifunc,
{mat_?MatrixQ:>SparseArray[KroneckerProduct[MatrixExp[mat],Transpose@MatrixExp[-mat]]]},
{3}
][t]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
(head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[op_?OperatorQ,___],opbasis_,zbasis_,opts___Rule]:=
Module[{spinsys},(
SuperoperatorMatrixRepresentation[
head[
Operator[op,zbasis,CheckOperatorType->False]
],
opbasis,zbasis,opts
])/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&
!MatchQ[op,HoldPattern[Operator[_?MatrixQ,zbasis,___]]]
)];


(* ::Input::Initialization:: *)
HoldPattern@SuperoperatorMatrixRepresentation[
(head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[Operator[mat_?MatrixQ,basis_,___],___],
opbasis_,basis_,opts___Rule
]:=
Module[{spinsys,Emat},(
Emat=MatrixRepresentation[UnityOperator[],basis,opts];
If[MatchQ[head,LeftMultiplicationSuperoperator],SparseArray[KroneckerProduct[mat,Emat]],SparseArray[Transpose@KroneckerProduct[Emat,mat]]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[(head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[op_?OperatorQ,___]]|E^((head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[op_?OperatorQ,___]),opbasis_,zbasis_,opts___Rule]:=
Module[{spinsys},(
SuperoperatorMatrixRepresentation[
Exp[head[
Operator[op,zbasis,CheckOperatorType->False]
]],
opbasis,zbasis,opts
])/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]&&
!MatchQ[op,HoldPattern[Operator[_?MatrixQ,zbasis,___]]];
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[(head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[HoldPattern@Operator[mat_?MatrixQ,zbasis_,___],___]]|E^((head:(LeftMultiplicationSuperoperator|RightMultiplicationSuperoperator))[HoldPattern@Operator[mat_?MatrixQ,zbasis_,___],___]),
opbasis_,zbasis_,opts___Rule
]:=
Module[{spinsys,Emat},(
Emat=MatrixRepresentation[UnityOperator[],zbasis,opts];
If[MatchQ[head,LeftMultiplicationSuperoperator],SparseArray[KroneckerProduct[MatrixExp[mat],Emat]],SparseArray[Transpose@KroneckerProduct[MatrixExp[Emat],mat]]]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,zbasis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:DoubleCommutationSuperoperator[op1_,op2_],opbasis_,basis_,opts___Rule]:=
Module[{spinsys},(
SparseArray@Dot[
SuperoperatorMatrixRepresentation[CommutationSuperoperator[op1],opbasis,basis,opts],
SuperoperatorMatrixRepresentation[CommutationSuperoperator[op2],opbasis,basis,opts]
]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:ProjectionSuperoperator[op_,sopopts___Rule],opbasis_,basis_,opts___Rule]/;(Normalize/.{sopopts}/.Options[ProjectionSuperoperator]):=
SuperoperatorMatrixRepresentation[ProjectionSuperoperator[NormalizeOperator@op,Normalize->False],opbasis,basis,opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:ProjectionSuperoperator[op_,sopopts___Rule],opbasis_,basis_,opts___Rule]:=
Module[{matop,spinsys},(
matop=MatrixRepresentation[NormalizeOperator@op,ZeemanBasis[]];
SparseArray@Outer[Times,Flatten@matop,Conjugate@Flatten[matop]]
)/;(
spinsys=SpinSystem[opbasis];
!(Normalize/.{sopopts}/.Options[ProjectionSuperoperator])&&
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:ShiftSuperoperator[op2_,op1_,sopopts___Rule],opbasis_,basis_,opts___Rule]/;(Normalize/.{sopopts}/.Options[ShiftSuperoperator]):=
SuperoperatorMatrixRepresentation[ShiftSuperoperator[NormalizeOperator@op2,NormalizeOperator@op1,Normalize->False],opbasis,basis,opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop:ShiftSuperoperator[op2_,op1_,sopopts___Rule],opbasis_,basis_,opts___Rule]:=
Module[{matop2,matop1,spinsys},(
matop2=MatrixRepresentation[op2,ZeemanBasis[]];
matop1=MatrixRepresentation[op1,ZeemanBasis[]];
SparseArray@Outer[Times,Flatten@matop2,Conjugate@Flatten[matop1]]
)/;(
spinsys=SpinSystem[opbasis];
!(Normalize/.{sopopts}/.Options[ProjectionSuperoperator])&&
MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],Automatic]&&
MatchQ[{opbasis,basis},{ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"],ZeemanBasis[spinsys]}]
)];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
HoldPattern@CoherenceOrderFiltrationSuperoperator[{spins:{Except[_List]..},orders:{Except[_List]..}},more:Except[_Rule]..,cofsopts___Rule],
opbasis_,basis_,opts___Rule]:=
SuperoperatorMatrixRepresentation[
CoherenceOrderFiltrationSuperoperator[{spins,orders},cofsopts],
opbasis,basis,opts
].SuperoperatorMatrixRepresentation[
CoherenceOrderFiltrationSuperoperator[more,cofsopts],
opbasis,basis,opts
];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
HoldPattern@CoherenceOrderFiltrationSuperoperator[{spins:{Except[_List]..},orders:{Except[_List]..}},cofsopts___Rule],
opbasis_,basis_,opts___Rule]:=
Module[{n,pos,spinsys},(
n=OperatorBasisDimension[ZeemanKetBraOperatorBasis[Sorted->"Canonical"]];
pos=Flatten@Position[
CoherenceOrder[spins,#]&/@BasisOperators[ZeemanKetBraOperatorBasis[Sorted->"Canonical"]],Alternatives@@orders];
SparseArray[
({#,#}->1)&/@pos,{n,n}]
)/;(
spinsys=SpinSystem[opbasis];
MatchQ[opbasis,ZeemanKetBraOperatorBasis[spinsys,Sorted->"Canonical"]]
)
];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[sop_?SuperoperatorQ]|E^sop_?SuperoperatorQ,opbasis_,basis_,opts___Rule]:=
MatrixExp[
SuperoperatorMatrixRepresentation[sop,opbasis,basis,opts]
]/;!MatchQ[sop,HoldPattern@Superoperator[_InterpolatingFunction[_],___]]


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[HoldPattern@Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis1_,___]]|E^(HoldPattern@Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis1_,___]),opbasis_,basis_,opts___Rule]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]:=
Replace[ifunc,mat_?MatrixQ:>MatrixExp[mat],{3}][t];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[
Exp[HoldPattern@Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis1_,___]]|E^(HoldPattern@Superoperator[ifunc_InterpolatingFunction[t_],opbasis_,basis1_,___]),opbasis_,basis_,opts___Rule]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],{_?MatrixQ,_List,_?MatrixQ}]:=
Replace[ifunc,{X_?MatrixQ,D_List,Xinv_?MatrixQ}:>X.DiagonalMatrix[MatrixExp[D]].Xinv,{3}][t];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop_,opbasis_,basis_,opts___Rule]:=
SuperoperatorMatrixRepresentation[sop,opbasis,basis,Method->"Direct",opts];


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation[sop_,opbasis_,basis_,opts___Rule]:=
Module[{n},(
n=OperatorBasisDimension[opbasis];
If[FreeQ[#,$Failed],SparseArray[#],$Failed]&@
Table[
FixedPoint[ExpToTrig[PowerExpand[Simplify[#]]]&,
LiouvilleBracket[
BasisOperatorMatrixRepresentations[opbasis,basis][[i]],
MatrixRepresentation[sop[BasisOperators[opbasis][[j]]],basis]
]
],
{i,1,n},{j,1,n}
]
)]/;MatchQ[Method/.{opts}/.Options[SuperoperatorMatrixRepresentation],"Direct"]


(* ::Input::Initialization:: *)
BasisOperatorMatrixRepresentations[opbasis_,basis_]:=(
BasisOperatorMatrixRepresentations[opbasis,basis]=
(MatrixRepresentation[#,basis]&/@BasisOperators[opbasis])
);


(* ::Input::Initialization:: *)
SuperoperatorMatrixRepresentation::badsop="SuperoperatorMatrixRepresentation may only be applied to a superoperator.";


(* ::Input::Initialization:: *)
SphericalTensorIndices[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SphericalTensorIndices[opb_?DefinedOperatorBasisQ]/;!MatchQ[opb,_SphericalTensorOperatorBasis]:=(Message[SphericalTensorIndices::notSTOB,opb];$Failed)


(* ::Input::Initialization:: *)
SphericalTensorIndices[arg_]/;!OperatorQ[arg]&&!DefinedOperatorBasisQ[arg]&&!NumericQ[arg]:=(Message[SphericalTensorIndices::notop];$Failed);


(* ::Input::Initialization:: *)
SphericalTensorIndices[n_?NumericQ]:=SphericalTensorIndices[n*UnityOperator[]];


(* ::Input::Initialization:: *)
SphericalTensorIndices[op_?OperatorQ]:=
Module[{opvecrep,stob,stob\[Lambda]\[Mu]vals,\[Lambda]\[Mu]vals},(
stob=SphericalTensorOperatorBasis[];
stob\[Lambda]\[Mu]vals=SphericalTensorIndices[stob];
opvecrep=OperatorVectorRepresentation[op,stob];
If[Length[#]==1,First[#],#]&@
Union@Pick[stob\[Lambda]\[Mu]vals,opvecrep,_?(Chop[#]!=0&)]
)];


(* ::Input::Initialization:: *)
SphericalTensorIndices[]:=SphericalTensorIndices[OperatorBasis[]];


(* ::Input::Initialization:: *)
SphericalTensorIndices[stob_SphericalTensorOperatorBasis]:=
(BasisOperators[stob];SphericalTensorIndices[stob]);


(* ::Input::Initialization:: *)
SphericalTensorIndices::notSTOB="The operator basis `1` is not a SphericalTensorOperatorBasis.";


(* ::Input::Initialization:: *)
SphericalTensorIndices::notop="SphericalTensorIndices may only be applied to an operator or to a SphericalTensorOperatorBasis.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



