(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["QM`SpinOperators`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"QM`Hilbert`",
"Tensors`CG`",
"General`Matrices`",
"General`General3D`",
"General`Miscellaneous`"
}];



(* ::Input::Initialization:: *)
Operator::usage="Operator[matrep,basis,opts] defines a spin operator that has the matrix representation matrep in the specified basis. The current basis is assumed if basis is missing. The options may include OperatorType, which may be used to define whether the operator is unitary, hermitian, etc. Operator may also be called with the format Operator[op,basis,opts], where op is an operator expression. The routine will then calculate the matrix representation and assign the OperatorType automatically.
Operator may also have the form Operator[{X,evals,Xinv},basis,opts] where X is a matrix whose columns are the eigenvectors of the matrix representation of the operator in the basis basis, evals are the eigenvalues, and Xinv is the inverse of X. This form is generated by applying NDiagonalize to an operator. 
";


(* ::Input::Initialization:: *)
CheckOperatorType::usage="CheckOperatorType is an option for Operator, which suppresses checking of OperatorType if CheckOperatorType\[Rule]False";


(* ::Input::Initialization:: *)
CheckMatrixDimensions::usage="CheckMatrixDimensions is an option for Operator, which causes checking of matrix dimensions if True.";


(* ::Input::Initialization:: *)
NDiagonalize::usage=(NDiagonalize::usage)<>"\n
The syntax NDiagonalize[op,basis,opts] causes an operator to be converted into diagonalized form in the Hilbert basis (specification of this is optional). The option Assumptions may be used with NDiagonalize when it is applied to an operator. If Assumptions\[Rule]Automatic, the setting of OperatorType determines whether assumptions of the type Assumptions\[Rule]{OrthogonalEigenvectors\[Rule]True} are used.";


(* ::Input::Initialization:: *)
OperatorQ::usage="determines whether an expression has the form of a spin operator";


(* ::Input::Initialization:: *)
OperatorType::usage="OperatorType may be applied to an operator to determine its type.";


(* ::Input::Initialization:: *)
opI::usage="opI[spin, \[Mu]] defines an angular momentum operator for the indicated spin. If the symbol spin is a List, a sum over the spins in the list is implied, and if the symbol spin is absent, a sum over all spins in the current spin system is taken. The label \[Mu] may be a phase \[Phi] (indicating the phase angle of the spin angular momentum in the xy-plane), or may specify the polar angles {\[Theta],\[Phi]} (indicating spin angular momentum in an arbitrary direction in 3D space). The label \[Mu] may also take the values \"x\", \"y\", \"z\", indicating spin angular momentum operators along one of the Cartesian axes. Shift operators are indicated by using labels \"+\",\"-\", while polarization operators for spins-1/2 are indicated by using labels \"\[Alpha]\", \"\[Beta]\". If the label \[Mu] is absent, a vector of the three Cartesian angular momentum components is generated. Hence  opI[i].opI[j] defines the dot product of the angular momenta of spins i and j.";


(* ::Input::Initialization:: *)
AngularMomentumOperator::usage="AngularMomentumOperator is a synonym for opI";


(* ::Input::Initialization:: *)
ValidAxisSpecificationQ::usage="ValidAxisSpecificationQ[<axis>] returns True if <axis> has the valid syntax for specifying the axis of an angular momentum operator.";


(* ::Input::Initialization:: *)
SingleTransitionOperator::usage="SingleTransitionOperator[{r,s}, \[Mu]] defines a single transition operator within the current basis. Allowed values of \[Mu] are \"x\", \"y\", \"z\", \"+\",\"-\" or \"u\", \"E\", \"1\" for the Unity Operator. The state identifiers {r,s} must be members of the BasisLabels for the current basis. The most general form is SingleTransitionOperator[{{r,s},basis}, \[Mu]] which constructs a single transition operator for kets within any basis. 
";


(* ::Input::Initialization:: *)
opT::usage=
"opT[j,{1,\[Mu]}] defines a first-rank spherical tensor operator for spin j.
opT[{1,\[Mu]}] defaults to opT[1,{1,\[Mu]}].
opT[{j,k},{2,\[Mu]}] defines a second-rank spherical tensor operator for spins j and k.
opT[2,\[Mu]] defaults to opT[{1,2},{2,\[Mu]}]
opT[{{j,\!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\)},{k,\!\(\*SubscriptBox[\(\[Lambda]\), \(k\)]\)}..},{\[CapitalLambda],M}] generates a \[CapitalLambda]th rank ISTO by coupling together the interactions {{j,\!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\)},{k,\!\(\*SubscriptBox[\(\[Lambda]\), \(k\)]\)}..} where j is a symbol identifying the interaction and \!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\) is its rank.
opT[{j,k..},{\[CapitalLambda],M}] defaults to opT[{{j,1},{k,1}..},{\[CapitalLambda],M}].
The option Normalize->True may be set to generate STOs normalized in the current state basis.
In cases where there are many possible coupling paths to the requested operator, a message is issued and a list of all possible operators is returned. A single operator may be returned using the form opT[{{j,\!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\)},{k,\!\(\*SubscriptBox[\(\[Lambda]\), \(k\)]\)}..},{\[CapitalLambda],M},n], where n is an integer identifying the requested operator. 
An explicit coupling pathway may also be specified. For example, a rank-2 operator generated by coupling together the rank-1 operator for spin #1 with the rank-1 operator for spin #2, and then coupling the resulting rank-1 operator with a rank-2 operator for spin #3, may be specified as follows: opT[{{{{1,1},{2,1}},1},{3,2}},{2,M}].";


(* ::Input::Initialization:: *)
opR::usage="opR[spins,angle] is the operator for rotating a single spin or a set of spins through the specified angle. If spins is absent, all spins in the current SpinSystem are rotated. The following formats for angle may be used: 1. {\[Beta],\[Phi]} indicates a rotation through \[Beta] about an axis in the xy plane with the phase \[Phi]. The phase value may either be numeric, or be specified using the text codes \"x\", \"y\", \"-x\" for the quadrature phases. A code \"z\" indicates a rotation about the z-axis. 2. The format {\[Xi],{\[Theta],\[Phi]}} indicates a rotation through the angle \[Xi] about an axis with polar angles \[Theta] and \[Phi]. 3. The format {\[Alpha],\[Beta],\[Gamma]} indicates a rotation through the specified Euler angles, using the zyz convention.";


(* ::Input::Initialization:: *)
RotationOperator::usage="RotationOperator is a synonym for opR";


(* ::Input::Initialization:: *)
UnityOperator::usage="UnityOperator[] is the unity operator for the entire spin system. UnityOperator[j] is the unity operator for an individual spin. UnityOperator[{r,s}] is the single-transition unity operator for the pair of states with labels {r,s} in the current basis.;  UnityOperator[{{r,s},basis}] is the single-transition unity operator for the pair of states with labels {r,s} in the basis basis.";


(* ::Input::Initialization:: *)
NullOperator::usage ="NullOperator[] is the null operator.";


(* ::Input::Initialization:: *)
PopulationOperator::usage="PopulationOperator[r] is the population operator for the state with label r in the current basis.; PopulationOperator[{r,basis}] is the population operator for the state with label r in the basis basis.";


(* ::Input::Initialization:: *)
CoherenceOperator::usage="CoherenceOperator[{r,s}] is the operator |r><s| for the pair of states with labels {r,s} in the current basis.;  CoherenceOperator[{{r,s},basis}] is the operator |r><s| for the pair of states with labels {r,s} in the basis basis.";


(* ::Input::Initialization:: *)
ProjectionOperator::usage="ProjectionOperator[ket] is the operator for projection onto the specified ket, i.e. |ket><ket|. The ket is automatically normalized before use. The syntax ProjectionOperator[{{j,mj},{k,mk}..}] constructs a projection operator onto the states {mj,mk..} of a subset of spins {j,k..}. A sum is taken over the spins not included in the set {j,k..}.";


(* ::Input::Initialization:: *)
ShiftOperator::usage="ShiftOperator[ket,bra] is the operator |ket><bra|. Both ket and bra are automatically normalized before use.";


(* ::Input::Initialization:: *)
SpinPermutationOperator::usage="SpinPermutationOperator[{j,k}] is the operator for exchange of spin j with spin k. SpinPermutationOperator[{j,k,l,m..}] is the operator for a cyclic permutation of the specified spins, with j\[Rule]k,k\[Rule]l,l\[Rule]m, etc. SpinPermutationOperator[{..{j2,k2..},{j1,k1..}}] is the operator for successive spin exchange operations, with the {j1,k1..} permutation preceding the {j2,k2..} permutation, and so on (i.e. right to left order of application).";


(* ::Input::Initialization:: *)
SpinExchangeOperator::usage="SpinExchangeOperator has been superseded by SpinPermutationOperator";


(* ::Input::Initialization:: *)
MatrixRepresentation::usage ="MatrixRepresentation[op,basis] provides the matrix representation for an operator in a given basis. The output is a SparseArray and may be viewed by applying MatrixForm or MatrixPlot. The current basis is used if basis is omitted.";


(* ::Input::Initialization:: *)
ProjectedMatrixRepresentation::usage=
"ProjectedMatrixRepresentation[op1,op2,Basis->basis] gives the matrix representation of op1 in the defined basis, projected onto the eigensystem of op2. The coherences between non-degenerate eigenstates of op2 are deleted.";


(* ::Input::Initialization:: *)
OperatorProjection::usage=
"OperatorProjection[op1,op2,Basis->basis] gives the projection of op1 onto op2, using the specified basis.";


(* ::Input::Initialization:: *)
Commutator::usage=
"Commutator[a,b] gives the commutator of two operators.";


(* ::Input::Initialization:: *)
CoherenceOrder::usage=
"CoherenceOrder[op] gives the total coherence order of an operator op. CoherenceOrder[spins,op] gives the coherence order summed over the defined set of spins. CoherenceOrder[{spins1,spins2...},op] gives a list of coherence orders for each of the defined sets of spins. If an operator contains more than one coherence order, a list of the contained coherence orders is returned.
";


(* ::Input::Initialization:: *)
SpinProductRank::usage="SpinProductRank[op] gives the spin product rank of an operator op. For example, \!\(\*SubscriptBox[\(I\), \(1  x\)]\).\!\(\*SubscriptBox[\(I\), \(2  y\)]\) has a spin product rank of 2.";


(* ::Input::Initialization:: *)
OperatorTrace::usage=
"OperatorTrace[op] gives the trace of an operator matrix representation.";


(* ::Input::Initialization:: *)
OperatorNorm::usage=
"OperatorTrace[op,basis] gives the norm of an operator in the specified basis, i.e. Sqrt[Tr[Adjoint[op].op]]. OperatorNorm[op] uses the current basis.";


(* ::Input::Initialization:: *)
NormalizeOperator::usage=
"NormalizeOperator[op, norm, basis] scales an operator so that its norm is given by norm in the specified basis. If the basis specification is omitted, the current basis is used. If norm is omitted, a norm of 1 is assumed. The syntax NormalizeOperator[op1, op2, basis], where op2 is also an operator, sets the norm of op1 to equal that of op2.
";


(* ::Input::Initialization:: *)
OperatorProduct::usage=
"OperatorProduct[op1, op2,..] takes the product of one or more operators. Entering operators using the syntax op1.op2.op3.. generates terms of this form.  
";


(* ::Input::Initialization:: *)
InvolvedSpins::usage=
"InvolvedSpins[op] returns the set of spins involved in an operator.";


(* ::Input::Initialization:: *)
SphericalTensorIndices::usage="SphericalTensorIndices[op] gives the spherical rank \[Lambda] and coherence order \[Mu] of an operator op, in the form {\[Lambda],\[Mu]}. If an operator contains several different spherical tensor components, a list of the results is returned. 
The syntax SphericalTensorIndices[stopb] returns a list of the spherical tensor indices in the basis operators of stopb, in the case that stopb is a SphericalTensorOperatorBasis. 
";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Ket/:HoldPattern[op_?OperatorQ[ket:Ket[___]]]:=op.ket;


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,Infinity,
Times/:HoldPattern[op_?OperatorQ[kets:Times[___]]]:=op.kets
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Plus,Infinity,
Plus/:HoldPattern[op_?OperatorQ[kets:Plus[__?KetQ]]]:=op.kets
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[ops_?OperatorQ..,ket_?KetQ]:=Operator[OperatorProduct[ops]].ket
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
Dot/:HoldPattern@Dot[Times[n1__,op_?OperatorQ,n2___],ket_?KetQ]:=Times[n1,n2,op.ket]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
Dot/:HoldPattern@Dot[Times[n1___,op_?OperatorQ,n2__],ket_?KetQ]:=Times[n1,n2,op.ket]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
Dot/:HoldPattern@Dot[op_?OperatorQ,ket_?KetQ]:=
Module[{zb},(
zb=ZeemanBasis[];
Inner[Times,MatrixRepresentation[op,zb].VectorRepresentation[ket,zb],BasisKets[zb],Plus]
)]
];


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[bra_Bra,op_?OperatorQ]]:=Adjoint@Dot[Adjoint[op],Adjoint[bra]];


(* ::Input::Initialization:: *)
Bra/:HoldPattern[Dot[bra_Bra,op1_?OperatorQ,ops__?OperatorQ]]:=Dot[Dot[bra,op1],ops];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
HoldPattern@Dot[bra_?BraQ,ops_?OperatorQ..]:=bra.Operator[OperatorProduct[ops]]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,1,
Times/:HoldPattern@Times[args1___,op_?OperatorQ,args2___,ket_?KetQ,args3___]:=(Message[Ket::badoptimesket];$Failed)
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,1,
Times/:HoldPattern@Times[args1___,ket_?KetQ,args2___,op_?OperatorQ,args3___]:=(Message[Ket::badoptimesket];$Failed)
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,1,
Times/:HoldPattern@Times[args1___,op_?OperatorQ,args2___,bra_?BraQ,args3___]:=(Message[Ket::badbratimesop];$Failed)
]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,1,
Times/:HoldPattern@Times[args1___,bra_?BraQ,args2___,op_?OperatorQ,args3___]:=(Message[Ket::badbratimesop];$Failed)
]


(* ::Input::Initialization:: *)
Ket::badoptimesket="An operator and a ket may not be multiplied using Times (\[Cross]). The correct form is \!\(\*
StyleBox[\"operator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ket\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"ket\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"operator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)";


(* ::Input::Initialization:: *)
Ket::badbratimesop="A bra and an operator may not be multiplied using Times (\[Cross]). The correct form is bra.\!\(\*
StyleBox[\"operator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)";


(* ::Input::Initialization:: *)
Adjoint[ HoldPattern@Dot[ops___]]:=Dot@@( Adjoint/@ Reverse[{ops}]);


(* ::Input::Initialization:: *)
Adjoint[ HoldPattern@OperatorProduct[ops:Except[_Rule]..,___Rule]]:=OperatorProduct@@( Adjoint/@ Reverse[{ops}]);


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Simplify,Infinity,
Simplify[op_?OperatorQ]/;!FreeQ[op,Operator]&&!MatchQ[op,_Operator]:=
Simplify[Operator[op]]
];


(* ::Input::Initialization:: *)
OperatorPattern=_Operator|
_opI|_opT|_opR|
_ProjectionOperator|_ShiftOperator|
_SpinExchangeOperator|_SpinPermutationOperator|
_UnityOperator|_NullOperator|
HoldPattern@Dot[___,_Ket,_Bra,___]|(
ifunc_InterpolatingFunction[_]/;
(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?OperatorQ]);


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Plus,Infinity,
Plus/:(op:HoldPattern@Plus[_?OperatorQ..])[ket_?KetQ]:=op.ket
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Times,Infinity,
(Times/:HoldPattern@Times[n1___?NumericQ,op_?OperatorQ,more___][ket_?KetQ]:=Times[n1,Times[op,more].ket];
Times/:HoldPattern@Times[more___,op_?OperatorQ,n2___?NumericQ][ket_?KetQ]:=Times[Times[more,op].ket,n2])
];


(* ::Input::Initialization:: *)
Options[OperatorProduct]={Sorted->False,Checked->False};


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
(Dot/:HoldPattern@Dot[ops:(_?OperatorQ|_?NumericQ)..]/;Length[{ops}]>=2:=OperatorProduct[ops,Sorted->False])
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
(Dot/:HoldPattern@Dot[ops:(_?OperatorQ|_?NumericQ)..,ket_?KetQ]/;Length[{ops}]>=2:=OperatorProduct[ops,Sorted->False].ket)
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
(Dot/:HoldPattern@Dot[bra_?BraQ,ops:(_?OperatorQ|_?NumericQ)..]/;Length[{ops}]>=2:=bra.OperatorProduct[ops,Sorted->False])
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Dot,Infinity,
(Dot/:HoldPattern@Dot[bra_?BraQ,ops:(_?OperatorQ|_?NumericQ)..,ket_?KetQ]/;Length[{ops}]>=2:=
(bra.OperatorProduct[ops,Sorted->False].ket))
];


(* ::Input::Initialization:: *)
OperatorProduct/:Format[HoldPattern@OperatorProduct[ops:Except[_Rule]..,opts___Rule]]:=DisplayForm@RowBox[Riffle[ToBoxes/@{ops},AdjustmentBox["\[Bullet]",BoxMargins->{{-0.3,0},{0,0}}]]]


(* ::Input::Initialization:: *)
OperatorProduct[___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
OperatorProduct[op_?OperatorQ,___Rule]:=op;


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[args:Except[_Rule]..,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct])&&Or@@(!MatchQ[#,_?OperatorQ]&/@{args}):=
Module[{ops,notops},(
ops=Cases[{args},_?OperatorQ];
notops=Complement[{args},ops];
(Times@@notops) *OperatorProduct[Sequence@@ops,opts]
)];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[ops1___,
HoldPattern[
Times[n1:Except[_?OperatorQ]..,op_?OperatorQ,n2:Except[_?OperatorQ]...]|Times[n1:Except[_?OperatorQ]...,op_?OperatorQ,n2:Except[_?OperatorQ]..]
],ops2___]:=Times[n1,n2]*OperatorProduct[ops1,op,ops2];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a___,Plus[ops:(_?OperatorQ..)],b___,opts___Rule]:=Simplify[Plus@@(OperatorProduct[a,#,b,Checked->False,Sorted->False]&/@{ops})];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[UnityOperator[___],opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a___,UnityOperator[___],b__,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct]):=OperatorProduct[a,b,opts];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a__,UnityOperator[___],b___,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct]):=OperatorProduct[a,b,opts];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a___,NullOperator[___],b___,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct]):=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a___,OperatorProduct[ops:Except[_Rule]..,___Rule],b___,___Rule]:=OperatorProduct[a,ops,b,Checked->False,Sorted->False];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[a___,NullOperator[___],b___,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct]):=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[ops:Except[_Rule]..,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct])&&MatchQ[{ops},{_?OperatorQ..}]:=OperatorProduct[ops,SimplifyRules[Checked->True,opts]];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[ops:Except[_Rule]..,opts___Rule]/;!(Checked/.{opts}/.Options[OperatorProduct])&&!MatchQ[{ops},{_?OperatorQ..}]:=
(Message[OperatorProduct::inval];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[ops:(_?OperatorQ..),opts___Rule]/;(Checked/.{opts}/.Options[OperatorProduct])&&(!Sorted/.{opts}/.Options[OperatorProduct]):=
Module[{},(
OperatorProduct[
Sequence@@Sort[
{ops},
Module[{spins1,spins2},(
spins1=InvolvedSpins[#1];
spins2=InvolvedSpins[#2];
IntersectingQ[spins1,spins2]||SpinsOrderedQ[{First@spins1,First@spins2}]
)]&
],
SimplifyRules[
Sorted->True,
opts
]
]
)];


(* ::Input::Initialization:: *)
OperatorProduct/:op_OperatorProduct[ket_?KetQ]:=op.ket;


(* ::Input::Initialization:: *)
OperatorProduct/:Dot[op_OperatorProduct,ket_?KetQ]:=
Module[{basis},(
basis=Basis[];BasisKets[basis].MatrixRepresentation[op,basis].VectorRepresentation[ket,basis]
)];


(* ::Input::Initialization:: *)
OperatorProduct/:Dot[bra_?BraQ,op_OperatorProduct]:=
Module[{basis},(
basis=Basis[];VectorRepresentation[bra,basis].MatrixRepresentation[op,basis].BasisBras[basis]
)];


(* ::Input::Initialization:: *)
OperatorProduct/:HoldPattern@Dot[bra_?BraQ,op_OperatorProduct,ket_?KetQ]:=
Module[{basis},(
basis=Basis[];VectorRepresentation[bra,basis].MatrixRepresentation[op,basis].VectorRepresentation[ket,basis]
)];


(* ::Input::Initialization:: *)
HoldPattern@OperatorProduct[ops1:(_?OperatorQ...),Dot[k1_?KetQ,b1_?BraQ],Dot[k2_?KetQ,b2_?BraQ],ops2:(_?OperatorQ...),opts___Rule]:=
OperatorProduct[ops1,Dot[k1,b2]*Dot[b1,k2],ops2,opts];


(* ::Input::Initialization:: *)
OperatorProduct::inval="OperatorProduct may only contain operators.";


(* ::Input::Initialization:: *)
HoldPattern@InvolvedSpins[
HoldPattern[
Times[n1__?NumericQ,op_?OperatorQ,n2___?NumericQ]|Times[n1___?NumericQ,op_?OperatorQ,n2__?NumericQ]
]
]:=InvolvedSpins[op];


(* ::Input::Initialization:: *)
HoldPattern@InvolvedSpins[Plus[ops:(_?OperatorQ..)]]:=Union@Flatten[InvolvedSpins/@{ops}];


(* ::Input::Initialization:: *)
InvolvedSpins[HoldPattern@opI[j:Except[_List],___]]:={j};


(* ::Input::Initialization:: *)
InvolvedSpins[HoldPattern@opI[spins_List,___]]:=spins;


(* ::Input::Initialization:: *)
InvolvedSpins[HoldPattern@opR[j:Except[_List],___]]:={j};


(* ::Input::Initialization:: *)
InvolvedSpins[HoldPattern@opR[spins_List,___]]:=spins;


(* ::Input::Initialization:: *)
InvolvedSpins[UnityOperator[___]]:={};


(* ::Input::Initialization:: *)
InvolvedSpins[NullOperator[___]]:={};


(* ::Input::Initialization:: *)
InvolvedSpins[Exp[op_?OperatorQ]]:=InvolvedSpins[op];


(* ::Input::Initialization:: *)
InvolvedSpins[Power[_,op_?OperatorQ]]:=InvolvedSpins[op];


(* ::Input::Initialization:: *)
InvolvedSpins[HoldPattern@OperatorProduct[ops:Except[_Rule]..,opts___Rule]]:=SortBy[Union@@(InvolvedSpins/@{ops}),Position[First/@SpinSystem[],#]&];


(* ::Input::Initialization:: *)
InvolvedSpins[_]:=First/@SpinSystem[];


(* ::Input::Initialization:: *)
OperatorQ[$Failed]=$Failed;


(* ::Input::Initialization:: *)
OperatorQ[op:OperatorPattern]=True; 


(* ::Input::Initialization:: *)
OperatorQ[notop_]/;FreeQ[notop,OperatorPattern]:=False;


(* ::Input::Initialization:: *)
OperatorQ[failed_]/;!FreeQ[failed,$Failed]:=$Failed; 


(* ::Input::Initialization:: *)
HoldPattern@OperatorQ[Exp[x_]]:=OperatorQ[x];


(* ::Input::Initialization:: *)
HoldPattern@OperatorQ[E^x_]:=OperatorQ[x];


(* ::Input::Initialization:: *)
OperatorQ[HoldPattern@Plus[_?OperatorQ..]]=True;


(* ::Input::Initialization:: *)
OperatorQ[_OperatorProduct]=True;


(* ::Input::Initialization:: *)
OperatorQ[HoldPattern@Dot[ket_?KetQ,bra_?BraQ]]=True;


(* ::Input::Initialization:: *)
OperatorQ[HoldPattern@Dot[ops1___,ket_?KetQ,bra_?BraQ,ops2___]]:=OperatorQ[OperatorProduct[ops1,ops2]];


(* ::Input::Initialization:: *)
OperatorQ[HoldPattern@Times[x___]]:=
Switch[Count[{x},_?OperatorQ],
1,True,
0,False,
_,(Message[OperatorQ::badoptimes];$Failed)
];


(* ::Input::Initialization:: *)
 OperatorQ[notop_]:=False/;!FreeQ[notop,NMR`SpinSuperoperators`Private`SuperoperatorPattern];


(* ::Input::Initialization:: *)
OperatorQ[notop_]:=False;


(* ::Input::Initialization:: *)
OperatorQ::badoptimes="An illegal Times product of operators has been detected.";


(* ::Input::Initialization:: *)
NDiagonalize[op_?OperatorQ,opts___Rule]:=NDiagonalize[op,Basis[],opts];


(* ::Input::Initialization:: *)
NDiagonalize[Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opopts___Rule],basis_,opts___Rule]:=
Operator[{X,evals,Xinv},basis,SimplifyRules[opopts,opts]];


(* ::Input::Initialization:: *)
NDiagonalize[Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},opbasis_,opopts___Rule],basis_,opts___Rule]:=
Operator[
{Chop[BasisTransformationMatrix[basis,opbasis].X],
evals,
Chop[Xinv.BasisTransformationMatrix[opbasis,basis]]},
basis,
SimplifyRules[opopts,opts]
];


(* ::Input::Initialization:: *)
NDiagonalize[Operator[mat_?MatrixQ,basis_,opopts___Rule],basis_,opts___Rule]:=
Module[{ass1,ass2},(
ass1=Assumptions/.{opts}/.Options[NDiagonalize];
ass2=Switch[
ass1,
None|False,False,
{_Rule...},ass1,
Automatic|True,
SimplifyRules[
OrthogonalEigenvectors->
Switch[
OperatorType/.{opopts}/.Options[Operator],
	"Hermitian"|"Unitary"|"AntiHermitian"|"Normal",True,
	_,False
],
Sequence@@Cases[ass1,_Rule]
],
_,None
];
Operator[
NDiagonalize[
mat,
SimplifyRules[
Assumptions->ass2,
opts
]
],
basis,
SimplifyRules[opopts,opts]
]
)];


(* ::Input::Initialization:: *)
NDiagonalize[op_?OperatorQ,basis_,opts___Rule]:=
NDiagonalize[Operator[op,basis,opts],basis,opts];


(* ::Input::Initialization:: *)
ValidOperatorTypes={Undefined,None,"Hermitian","Unitary","AntiHermitian","Normal"};


(* ::Input::Initialization:: *)
Options[OperatorType]={OperatorType->Undefined};


(* ::Input::Initialization:: *)
HoldPattern@OperatorType[Operator[args:Except[_Rule]...,opopts___Rule]]/;MatchQ[OperatorType/.{opopts}/.Options[Operator],Undefined]:=
OperatorType[
Operator[args,
SimplifyRules[
CheckOperatorType->True,
opopts
]
]
]


(* ::Input::Initialization:: *)
HoldPattern@OperatorType[Operator[args:Except[_Rule]...,opopts___Rule]]/;!MatchQ[OperatorType/.{opopts}/.Options[Operator],Undefined]:=OperatorType/.{opopts}/.Options[OperatorType];


(* ::Input::Initialization:: *)
OperatorType[op_?OperatorQ]:=OperatorType[Operator[op]];


(* ::Input::Initialization:: *)
OperatorType[op_]:=(Message[OperatorType::notop];$Failed);


(* ::Input::Initialization:: *)
OperatorType::notop="OperatorType may only be applied to an operator.";


(* ::Input::Initialization:: *)
Options[Operator]={OperatorType->Undefined,CheckOperatorType->Automatic,CheckMatrixDimensions->True,Assumptions->{},Expand->False};


(* ::Input::Initialization:: *)
OperatorTypeCheckDisableThreshold=32;


(* ::Input::Initialization:: *)
Operator/:Format[Operator[mat_?MatrixQ,basis_,opts___Rule]/;!(Expand/.{opts}/.Options[Operator])]:=
Module[{optype,assump},(
optype=ToString[OperatorType/.{opts}/.Options[Operator]]/.str_String:>"\""<>str<>"\"";
assump=(Assumptions/.{opts})/.str_String:>"\""<>str<>"\"";
DisplayForm[RowBox[{
"Operator[<<..>>",
If[!MatchQ[optype,\!\(\*
TagBox["\"\<\\\"Undefined\\\"\>\"",
FullForm]\)],
", OperatorType\[Rule]"<>optype,
" "
],
		If[!MatchQ[assump,Assumptions|{}],
RowBox[{", Assumptions\[Rule]", ToBoxes[assump]}],
" "
],
"]"
}]]
)];


(* ::Input::Initialization:: *)
Operator/:Format[Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule]/;!(Expand/.{opts}/.Options[Operator])]:=
Module[{optype},(
optype=OperatorType/.{opts}/.Options[Operator];
DisplayForm[RowBox[{
"Operator[DiagonalizedForm[<<..",
Dimensions[X],
ToBoxes["..>>], OperatorType\[Rule]"],
If[StringQ[optype],
ToBoxes["\""<>optype<>"\""],optype],
ToBoxes["]"]
}]
]
)];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Expand,Infinity,
Expand[a_]/;!FreeQ[a,_Operator]:=a/.{op_Operator:>Expand[op]}
];


(* ::Input::Initialization:: *)
Operator/:HoldPattern[Expand[Operator[args___,opts___Rule]]]:=Operator[args,Evaluate@SimplifyRules[Expand->True,opts]];


(* ::Input::Initialization:: *)
Operator/:HoldPattern[ExpandAll[Operator[args___,opts___Rule]]]:=Operator[args,Evaluate@SimplifyRules[Expand->True,opts]]


(* ::Input::Initialization:: *)
Operator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Operator[op_,opts___Rule]:=Operator[op,Basis[],opts];


(* ::Input::Initialization:: *)
Operator[args__,opts___Rule]:=
Module[{optype},(Message[Operator::badoptype,optype];Operator[args,SimplifyRules[OperatorType->None,opts]])/;(
optype=OperatorType/.{opts}/.Options[Operator];
!MemberQ[ValidOperatorTypes,optype]
)];


(* ::Input::Initialization:: *)
Operator[num_?NumericQ,basis_,opts___Rule]:=Operator[num*UnityOperator[],basis,opts];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]/;(n1*n2==0):=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern@Operator[mat:{{0..}..},more__,opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
HoldPattern@Operator[{X_?MatrixQ,evals:{0...},Xinv_?MatrixQ},more__,opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]/;MatchQ[OperatorType/.{opts}/.Options[Operator],"Hermitian"]:=
Operator[Which[ListQ[op],Map[Times[n1,#,n2]&,op,{2}],MatrixQ[op],Times[n1,op,n2]],
more,
SimplifyRules[
OperatorType->
Which[
Chop[Im[Times[n1,n2]]]==0,"Hermitian",
Chop[Re[Times[n1,n2]]]==0,"AntiHermitian",
True,"Normal"
],
opts
]
];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]/;MatchQ[OperatorType/.{opts}/.Options[Operator],"AntiHermitian"]:=Operator[Which[ListQ[op],Map[Times[n1,#,n2]&,op,{2}],MatrixQ[op],Times[n1,op,n2]],
more,
SimplifyRules[
OperatorType->
Which[
Chop[Im[Times[n1,n2]]]==0,"AntiHermitian",
Chop[Re[Times[n1,n2]]]==0,"Hermitian",
True,"Normal"
],
opts
]
];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]/;MatchQ[OperatorType/.{opts}/.Options[Operator],"Normal"]:=
Operator[Which[ListQ[op],Map[Times[n1,#,n2]&,op,{2}],MatrixQ[op],Times[n1,op,n2]],more,opts];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]/;MatchQ[OperatorType/.{opts}/.Options[Operator],"Unitary"]:=
Operator[Which[ListQ[op],Map[Times[n1,#,n2]&,op,{2}],MatrixQ[op],Times[n1,op,n2]],more,
SimplifyRules[
OperatorType->
Which[
Chop[Abs[Times[n1,n2]]-1]==0,"Unitary",
True,"Normal"
],
opts
]
];


(* ::Input::Initialization:: *)
Operator/:Times[n1___?NumericQ,Operator[op_,more__,opts___Rule],n2___?NumericQ]:=Operator[Which[ListQ[op],Map[Times[n1,#,n2]&,op,{2}],MatrixQ[op],Times[n1,op,n2]],more,OperatorType->Undefined,opts];


(* ::Input::Initialization:: *)
HoldPattern@Operator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]:=
Operator[
Replace[ifunc,{mat_?MatrixQ:>Times[n1,n2,mat]},{3}][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Operator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],{_?MatrixQ,_List,_?MatrixQ}]:=
Operator[
Replace[ifunc,{X_?MatrixQ,D_List,Xinv_?MatrixQ}:>{X,Times[n1,n2,D],Xinv},{3}][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Operator[Times[n1___?NumericQ,ifunc_InterpolatingFunction[t_],n2___?NumericQ],args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?OperatorQ]:=
Operator[
Replace[ifunc,op_?OperatorQ]:>Times[n1,n2,op][t],
args];


(* ::Input::Initialization:: *)
HoldPattern@Operator[ifunc_InterpolatingFunction[t_],basis_,args___]/;(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?OperatorQ]:=
Operator[
Replace[ifunc,{op_?OperatorQ:>MatrixRepresentation[op,basis,args]},{3}][t],
args];


(* ::Input::Initialization:: *)
Operator[badop_,basis_,opts___Rule]:=(Message[Operator::badop,badop];$Failed)/;(!OperatorQ[badop])&&
(!MatchQ[badop,_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ}])&&
(!MatchQ[badop,(
ifunc_InterpolatingFunction[_]/;
(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ}])
]
);


(* ::Input::Initialization:: *)
Operator/:HoldPattern@ReplaceAll[Operator[a_,more___],rules_]:=Operator[ReplaceEverywhere[a,rules],more];


(* ::Input::Initialization:: *)
Operator[op_?OperatorQ,basis_,opts___Rule]:=
Operator[MatrixRepresentation[op,basis],basis,opts];


(* ::Input::Initialization:: *)
Operator[specs_,basis_,opts___Rule]:=
Operator[
specs,basis,
SimplifyRules[
CheckOperatorType->False,
opts
]
]/;MatchQ[CheckOperatorType/.{opts}/.Options[Operator],Automatic]&&MemberQ[First/@(Assumptions/.{opts}),OperatorType];


(* ::Input::Initialization:: *)
Operator[specs_,basis_,opts___Rule]:=If[MatchQ[specs,_?NumericMatrixQ|{_?NumericMatrixQ,_List,_?NumericMatrixQ}],
Operator[specs,basis,SimplifyRules[CheckOperatorType->True,opts]],Operator[specs,basis,SimplifyRules[CheckOperatorType->True,OperatorType-> None]]]/;(!MemberQ[First/@(Assumptions/.{opts}),OperatorType])&&(MatchQ[{CheckOperatorType,OperatorType}/.{opts}/.Options[Operator],{Automatic,Undefined}]&&(
((BasisDimension[basis]<=OperatorTypeCheckDisableThreshold))
)
); 


(* ::Input::Initialization:: *)
Operator[opmat_?MatrixQ,basis_,opts___Rule]:=(
Operator[
opmat,basis,
SimplifyRules[
OperatorType->Which[
HermitianQ[opmat],"Hermitian",
AntiHermitianQ[opmat],"AntiHermitian",
UnitaryQ[opmat],"Unitary",
NormalQ[opmat],"Normal",
True,None],
opts
]
])/;MatchQ[{CheckOperatorType,OperatorType}/.{opts}/.Options[Operator],{True,Undefined}]&&
NumericMatrixQ[opmat];


(* ::Input::Initialization:: *)
Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule]:=
Module[{orthogX},(
Operator[
{X,evals,Xinv},basis,
SimplifyRules[
OperatorType->Which[
And@@((Chop[Abs[#]-1]==0)&/@evals),"Unitary",
(orthogX=OrthogonalQ[X];
orthogX &&
And@@(Element[#,Reals]&/@evals)),"Hermitian",
orthogX,"Normal",
True,None],
opts
]
]/;(
MatchQ[{CheckOperatorType,OperatorType}/.{opts}/.Options[Operator],{True,Undefined}]&&
MatchQ[{X,evals,Xinv},{_?NumericMatrixQ,{_?NumericQ..},_?NumericMatrixQ}]
)
)];


(* ::Input::Initialization:: *)
Operator[opmat_?MatrixQ,basis_,opts___Rule]/;TrueQ[CheckMatrixDimensions/.{opts}/.Options[Operator]]:=
Module[{n},(
n=BasisDimension[basis];
If[Dimensions[opmat]=={n,n},
Operator[opmat,basis,
SimplifyRules[
CheckMatrixDimensions->False,
opts
]
],
(Message[Operator::baddims];$Failed)
]
)];


(* ::Input::Initialization:: *)
Operator[X\[CapitalLambda]Xinv:{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule]/;TrueQ[CheckMatrixDimensions/.{opts}/.Options[Operator]]:=
Module[{n},(
n=BasisDimension[basis];
If[(Dimensions[X]==Dimensions[Xinv]=={n,n})&&Length[evals]==n,
Operator[X\[CapitalLambda]Xinv,basis,
SimplifyRules[
CheckMatrixDimensions->False,
opts
]
],
(Message[Operator::baddims];$Failed)
]
)];


(* ::Input::Initialization:: *)
Operator/:HoldPattern[Exp[Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule]]]:=Operator[{X,Exp/@evals,Xinv},basis,opts];


(* ::Input::Initialization:: *)
Operator/:HoldPattern[E^(Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule])]:=Operator[{X,Exp/@evals,Xinv},basis,opts]


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Exp,Infinity,
HoldPattern@Exp[Times[n1___?NumericQ,Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule],n2___?NumericQ]]:=Operator[{X,Exp/@(n1*n2*evals),Xinv},basis,opts]
];


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Power,Infinity,
HoldPattern[E^(Times[n1___?NumericQ,Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opts___Rule],n2___?NumericQ])]:=Operator[{X,Exp/@(n1*n2*evals),Xinv},basis,opts]
];


(* ::Input::Initialization:: *)
Operator/:Adjoint[Operator[mat_?MatrixQ,matbasis_,opts___Rule]]:=
Operator[
Switch[OperatorType/.{opts}/.Options[Operator],
"Hermitian",mat,
"AntiHermitian",-mat,
_,ConjugateTranspose[mat]
],
matbasis,opts
];


(* ::Input::Initialization:: *)
Basis[Operator[_?MatrixQ|{_?MatrixQ,_List,_?MatrixQ},basis_,opts___Rule]]:=basis;


(* ::Input::Initialization:: *)
Operator/:op_Operator[ket_?KetQ]:=op.ket;


(* ::Input::Initialization:: *)
Operator/:Dot[op_Operator,ket_?KetQ]:=
Module[{basis},(
basis=Basis[op];BasisKets[basis].MatrixRepresentation[op,basis].VectorRepresentation[ket,basis]
)];


(* ::Input::Initialization:: *)
Operator/:Dot[bra_?BraQ,op_Operator]:=
Module[{basis},(
basis=Basis[op];VectorRepresentation[bra,basis].MatrixRepresentation[op,basis].BasisBras[basis]
)];


(* ::Input::Initialization:: *)
Operator/:HoldPattern@Dot[bra_?BraQ,op_Operator,ket_?KetQ]:=
Module[{basis},(
basis=Basis[op];VectorRepresentation[bra,basis].MatrixRepresentation[op,basis].VectorRepresentation[ket,basis]
)];


(* ::Input::Initialization:: *)
Operator::notherm="The context implies a hermitian operator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Operator::notantuherm="The context implies an antihermitian operator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Operator::notnormal="The context implies a normal operator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Operator::notunitary="The context implies a unitary operator, but a violation is suspected. Continuing anyway.";


(* ::Input::Initialization:: *)
Operator::badoptype="OperatorType `1` not recognized.";


(* ::Input::Initialization:: *)
Operator::incompatspinsys="The Operator expression has been defined using a spin system incompatible with the requested basis.";


(* ::Input::Initialization:: *)
Operator::badop="Operator may not be applied to an expression `1` that is not an operator or a matrix";


(* ::Input::Initialization:: *)
Operator::times="operators must be multiplied by Dot (\".\"), not with Times (\"\[Times]\")";


(* ::Input::Initialization:: *)
Operator::baddims="the Operator definition uses a matrix whose dimensions are inconsistent with the specified basis.";


(* ::Input::Initialization:: *)
Unity:=(Message[Unity::obs];UnityOperator[]);


(* ::Input::Initialization:: *)
UnityOperator/:Format[UnityOperator[]]:= "\[DoubleStruckOne]";


(* ::Input::Initialization:: *)
UnityOperator/:Format[UnityOperator[j:Except[_List]]]:= Subscript["\[DoubleStruckOne]", j]


(* ::Input::Initialization:: *)
UnityOperator/:HoldPattern[Times[a___,_UnityOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
UnityOperator/:HoldPattern@OperatorProduct[a__,UnityOperator[Except[_List]...,___Rule],b___]:=OperatorProduct[a,b];


(* ::Input::Initialization:: *)
UnityOperator/:HoldPattern@OperatorProduct[a___,UnityOperator[Except[_List]...,___Rule],b__]:=OperatorProduct[a,b];


(* ::Input::Initialization:: *)
UnityOperator/:Adjoint[UnityOperator[args___]]:=UnityOperator[args];


(* ::Input::Initialization:: *)
UnityOperator[args___][ket_?KetQ]:=UnityOperator[args].ket;


(* ::Input::Initialization:: *)
UnityOperator[{r_,s_},opts___Rule]:=UnityOperator[{{r,s},Basis[]},opts];


(* ::Input::Initialization:: *)
UnityOperator[{{r_,s_},Undefined},___]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
UnityOperator[{{r_,s_},basis_},opts___Rule]/;!And@@(MemberQ[BasisLabels[basis],#]&/@{r,s}):=(Message[UnityOperator::badlabel,{r,s},basis];$Failed);


(* ::Input::Initialization:: *)
UnityOperator[{{r_,s_},basis_},opts___Rule]:=UnityOperator[{First@Extract[BasisKets[basis],Position[BasisLabels[basis],r]],First@Extract[BasisKets[basis],Position[BasisLabels[basis],s]]},opts];


(* ::Input::Initialization:: *)
UnityOperator[{ketr_?KetQ,kets_?KetQ},opts___Rule]/;Chop[Adjoint[kets].ketr]!=0:=(Message[UnityOperator::notorthog];$Failed);


(* ::Input::Initialization:: *)
UnityOperator[{ketr_?KetQ,kets_?KetQ},opts___Rule]:=ketr.Adjoint[ketr]+kets.Adjoint[kets];


(* ::Input::Initialization:: *)
Unity::obs="Unity is now obsolete and has been replaced by UnityOperator[]";


(* ::Input::Initialization:: *)
UnityOperator::badlabel="One or more of the labels `1` is not a defined basis label for the basis `2`";


(* ::Input::Initialization:: *)
UnityOperator::notorthog="The states are not orthogonal";


(* ::Input::Initialization:: *)
NullOperator/:Format[NullOperator[]]:= "\[DoubleStruckCapitalO]";


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@OperatorProduct[a___?OperatorQ,NullOperator[],b__?OperatorQ,___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@OperatorProduct[a__?OperatorQ,NullOperator[],b___?OperatorQ,___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@Dot[___,NullOperator[],___?OperatorQ,ket_?KetQ]:=0;


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@Dot[bra_?BraQ,___?OperatorQ,NullOperator[],___]:=0;


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern[Times[a___,_NullOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@Times[n1___?NumericQ,NullOperator[],n2___?NumericQ]:=NullOperator[];


(* ::Input::Initialization:: *)
NullOperator/:HoldPattern@Plus[ops2___?OperatorQ,NullOperator[],ops1___?OperatorQ]:=Plus[ops2,ops1];


(* ::Input::Initialization:: *)
NullOperator/:Adjoint[NullOperator[]]:=NullOperator[];


(* ::Input::Initialization:: *)
NullOperator[][arg_]=0;


(* ::Input::Initialization:: *)
SetAttributes[opI,NHoldFirst]


(* ::Input::Initialization:: *)
AngularMomentumOperator[args___]:=opI[args];


(* ::Input::Initialization:: *)
opI[args:(Except[False|True]...),opts___Rule]:=opI[args,False,opts];


(* ::Input::Initialization:: *)
opI[args___,False,opts___Rule]:=(Message[SpinSystem::notready];$Failed)/;MatchQ[SpinSystem/.Options[SpinSystem],Undefined];


(* ::Input::Initialization:: *)
opI[opts___Rule]:=opI[False,opts];


(* ::Input::Initialization:: *)
opI[False,opts___Rule]:=opI[First/@SpinSystem[],False,opts];


(* ::Input::Initialization:: *)
opI[mu_,False,opts___Rule]/;(!ValidSpinQ[mu])&&(!MatchQ[mu,First/@SpinSystem[]]):=opI[First/@SpinSystem[],mu,False,opts];


(* ::Input::Initialization:: *)
opI[spins:{_?ValidSpinQ..},mu___,False,opts___Rule]:=Plus@@(opI[#,mu,False,opts]&/@spins);


(* ::Input::Initialization:: *)
opI[j:Except[_?ValidSpinQ],mu___,False,opts___Rule]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
opI[j_,"\[Alpha]"|"\[Beta]",False,opts___Rule]:=(Message[opI::invalid\[Alpha]\[Beta]];$Failed)/;
!TrueQ[SpinQuantumNumber[j]==1/2];


(* ::Input::Initialization:: *)
opI[j_,label_String,False,opts___Rule]/;!MatchQ[label,"x"|"y"|"z"|"+"|"-"|"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x"|"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y"|"\!\(\*OverscriptBox[\(z\), \(_\)]\)"|"-z"|"\[Alpha]"|"\[Beta]"]:=(Message[opI::badlabel,label];$Failed);


(* ::Input::Initialization:: *)
opI/:HoldPattern[Times[a___,_opI,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
opI/: HoldPattern@Power[op:opI[args___],n_]/;IntegerQ[n]&&(n>0):=Nest[OperatorProduct[#1,op]&,UnityOperator[],n]


(* ::Input::Initialization:: *)
opI/: HoldPattern@Power[op:opI[args___],0]:=UnityOperator[];


(* ::Input::Initialization:: *)
opI/: HoldPattern@Power[op:opI[args___],n_]/;(!IntegerQ[n])||(n<0):=
(Message[opI::badpower];$Failed);


(* ::Input::Initialization:: *)
opI[spins_,"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x",False,opts___Rule]:=-opI[spins,"x",False,opts];


(* ::Input::Initialization:: *)
opI[spins_,"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y",False,opts___Rule]:=-opI[spins,"y",False,opts];


(* ::Input::Initialization:: *)
opI[spins_,"\!\(\*OverscriptBox[\(z\), \(_\)]\)"|"-z",False,opts___Rule]:=-opI[spins,"z",False,opts];


(* ::Input::Initialization:: *)
opI[j_?ValidSpinQ,{\[Theta]:Except[_String],\[Phi]:Except[_String]},False,opts___Rule]:=opI[j,"z",False,opts]Cos[\[Theta]]+opI[j,\[Phi],False,opts]Sin[\[Theta]];


(* ::Input::Initialization:: *)
opI[j_?ValidSpinQ,\[Phi]:Except[_String],False,opts___Rule]:=opI[j,"x",False,opts]Cos[\[Phi]]+opI[j,"y",False,opts]Sin[\[Phi]];


(* ::Input::Initialization:: *)
Adjoint[HoldPattern@Times[n1___Except[_?OperatorQ],opI[args___],n2___Except[_?OperatorQ]]]:=ComplexExpand[Conjugate[n1*n2]]*Adjoint[opI[args]];


(* ::Input::Initialization:: *)
opI/: Adjoint[HoldPattern@opI[spin_,"+",status:(False|True),opts___Rule]]:=opI[spin,"-",False,opts];


(* ::Input::Initialization:: *)
opI/: Adjoint[HoldPattern@opI[spin_,"-",status:(False|True),opts___Rule]]:=opI[spin,"+",False,opts];


(* ::Input::Initialization:: *)
opI/: Adjoint[HoldPattern@opI[spin_,mu:("x"|"y"|"z"|"\[Alpha]"|"\[Beta]"),status:(False|True),opts___Rule]]:=opI[spin,mu,False,opts];


(* ::Input::Initialization:: *)
opI[j_?ValidSpinQ,False,opts___Rule]:=opI[j,True,opts];


(* ::Input::Initialization:: *)
opI[j_?ValidSpinQ,\[Mu]:("x"|"y"|"z"|"+"|"-"|"\[Alpha]"|"\[Beta]"),False,opts___Rule]:=opI[j,\[Mu],True,opts];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"\[Alpha]",True,opts___Rule],Ket[{ket1___,{i_,_?((#==1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=Dot[op1,Ket[{ket1,{i,1/2},ket2},spins]]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"\[Alpha]",True,opts___Rule],Ket[{ket1___,{i_,_?((#==-1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"\[Beta]",True,opts___Rule],Ket[{ket1___,{i_,_?((#==1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"\[Beta]",True,opts___Rule],Ket[{ket1___,{i_,_?((#==-1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=Dot[op1,Ket[{ket1,{i,-1/2},ket2},spins]]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"+",True,opts___Rule],Ket[{ket1___,{i_,_?((#==1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"+",True,opts___Rule],Ket[{ket1___,{i_,_?((#==-1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=Dot[op1,Ket[{ket1,{i,+1/2},ket2},spins]]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"-",True,opts___Rule],Ket[{ket1___,{i_,_?((#==1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=Dot[op1,Ket[{ket1,{i,-1/2},ket2},spins]]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"-",True,opts___Rule],Ket[{ket1___,{i_,_?((#==-1/2)&)},ket2___},spins_?MatrixQ,___Rule]]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"x",True,opts___Rule],Ket[ket___]]:=Dot[op1,(1/2)*(opI[i,"+",opts]+opI[i,"-",opts]),Ket[ket]];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"y",True,opts___Rule],Ket[ket___]]:=Dot[op1,(1/(2I))*(opI[i,"+",opts]-opI[i,"-",opts]),Ket[ket]];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"z",True,opts___Rule],Ket[{ket1___,{i_,m_},ket2___},spins_?MatrixQ,___Rule]]:=m*Dot[op1,Ket[{ket1,{i,m},ket2},spins]];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"+",True,opts___Rule],Ket[{ket1___,{i_,m_},ket2___},spins_?MatrixQ,___Rule]]:=
Module[{Ij},(
Ij=SpinQuantumNumber[i,spins];
If[
-Ij<=m<Ij,
Sqrt[Ij(Ij+1)-m(m+1)]*Dot[op1,Ket[{ket1,{i,m+1},ket2},spins]],
0
]
)];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[op1___,opI[i_,"-",True,opts___Rule],Ket[{ket1___,{i_,m_},ket2___},spins_?MatrixQ,___Rule]]:=
Module[{Ij},(
Ij=SpinQuantumNumber[i,spins];
If[
-Ij<m<=Ij,
Sqrt[Ij(Ij+1)-m(m-1)]*Dot[op1,Ket[{ket1,{i,m-1},ket2},spins]],
0
]
)];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[bra___],opI[i_,"z",True,opts___Rule],op2___]:=Dot[Bra[bra],(1/2)*(opI[i,"\[Alpha]",opts]-opI[i,"\[Beta]",opts]),op2]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"\[Alpha]",True,opts___Rule],op2___]:=Dot[Bra[{bra1,{i,1/2},bra2},spins],op2]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==-1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"\[Alpha]",True,opts___Rule],op2___]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"\[Beta]",True,opts___Rule],op2___]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==-1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"\[Beta]",True,opts___Rule],op2___]:=Dot[Bra[{bra1,{i,-1/2},bra2},spins],op2]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"+",True,opts___Rule],op2___]:=Dot[Bra[{bra1,{i,-1/2},bra2},spins],op2]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==-1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"+",True,opts___Rule],op2___]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"-",True,opts___Rule],op2___]:=0/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,_?((#==-1/2)&)},bra2___},spins_?MatrixQ,___Rule],opI[i_,"-",True,opts___Rule],op2___]:=Dot[Bra[{bra1,{i,+1/2},bra2},spins],op2]/;SpinQuantumNumber[i]==1/2


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[bra___],opI[i_,"x",True,opts___Rule],op2___]:=Dot[Bra[bra],(1/2)*(opI[i,"+",opts]+opI[i,"-",opts]),op2]


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[bra___],opI[i_,"y",True,opts___Rule],op2___]:=Dot[Bra[bra],(1/(2I))*(opI[i,"+",opts]-opI[i,"-",opts]),op2]


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,m_},bra2___},spins_?MatrixQ,___Rule],opI[i_,"z",True,opts___Rule],op2___]:=m*Dot[Bra[{bra1,{i,m},bra2},spins],op2]


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,m_},bra2___},spins_?MatrixQ,___Rule],opI[i_,"+",True,opts___Rule],op2___]:=
Module[{Ij},(
Ij=SpinQuantumNumber[i,spins];
If[
-Ij<m<=Ij,
Sqrt[Ij(Ij+1)-m(m-1)]*Dot[Bra[{bra1,{i,m-1},bra2},spins],op2],
0
]
)];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[Bra[{bra1___,{i_,m_},bra2___},spins_?MatrixQ,___Rule],opI[i_,"-",True,opts___Rule],op2___]:=
Module[{Ij},(
Ij=SpinQuantumNumber[i,spins];
If[
-Ij<=m<Ij,
Sqrt[Ij(Ij+1)-m(m+1)]*Dot[Bra[{bra1,{i,m+1},bra2},spins],op2],
0
]
)];


(* ::Input::Initialization:: *)
opI/:Format[HoldPattern@opI[j_Integer,mu:("x"|"y"|"z"|"+"|"-"|"\[Alpha]"|"\[Beta]"),True,opts___Rule]
]:= 
Switch[mu,
	"x"|"y"|"z",
SubscriptBox["I",RowBox[{j,mu}]]//DisplayForm,
	"+"|"-",
SubsuperscriptBox["I",ToString[j],mu]//DisplayForm,
	"\[Alpha]",
SubsuperscriptBox["I",ToString[j],"\[Alpha]"]//DisplayForm,
	"\[Beta]",
SubsuperscriptBox["I",ToString[j],"\[Beta]"]//DisplayForm
]
	


(* ::Input::Initialization:: *)
opI/:Format[HoldPattern@opI[j_String,mu:("x"|"y"|"z"|"+"|"-"|"\[Alpha]"|"\[Beta]"),True,opts___Rule]/;LowerCaseQ[j]]:= 
Switch[mu,
	"x"|"y"|"z",
SubscriptBox["I",RowBox[{j,mu}]]//DisplayForm,
	"+"|"-",
SubsuperscriptBox["I",ToString[j],mu]//DisplayForm,
	"\[Alpha]",
SubsuperscriptBox["I",ToString[j],"\[Alpha]"]//DisplayForm,
	"\[Beta]",
SubsuperscriptBox["I",ToString[j],"\[Beta]"]//DisplayForm
]
	


(* ::Input::Initialization:: *)
opI/:Format[HoldPattern@opI[j_String,mu:("x"|"y"|"z"|"+"|"-"|"\[Alpha]"|"\[Beta]"),True,opts___Rule]/;UpperCaseQ[j]]:= 
Switch[mu,
	"x"|"y"|"z",
SubscriptBox[ToString[j],mu]//DisplayForm,
	"+"|"-"|"\[Alpha]"|"\[Beta]",
SuperscriptBox[ToString[j],mu]//DisplayForm
]
	


(* ::Input::Initialization:: *)
opI/:Format[HoldPattern@opI[j_Integer,True,opts___Rule]
]:= SubscriptBox[\!\(\*OverscriptBox[\("\<I\>"\), \(\[RightVector]\)]\),RowBox[{j}]]//DisplayForm;


(* ::Input::Initialization:: *)
opI/:Format[HoldPattern@opI[j_String,True,opts___Rule]
]:= \!\(\*OverscriptBox[\(ToString[j]\), \(\[RightVector]\)]\)//DisplayForm;


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[opIjvec:opI[j_,True,optsj___Rule],matrices:(_?MatrixQ..),vec:{x_,y_,z_}]:=Dot[opIjvec,Dot[matrices,vec]];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[vec:{x_,y_,z_},matrices:(_?MatrixQ..),opIkvec:opI[k_,True,optsk___Rule]]:=Dot[Dot[vec,matrices],opIkvec];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[opIjvec:opI[j_,True,optsj___Rule],vec:{_,_,_}]:=
Inner[
OperatorProduct,
opI[j,#,True,optsj]&/@{"x","y","z"},
vec,
Plus
];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[vec:{_,_,_},opIkvec:opI[k_,True,optsk___Rule]]:=
Inner[
OperatorProduct,
vec,
opI[k,#,True,optsk]&/@{"x","y","z"},
Plus
];


(* ::Input::Initialization:: *)
opI/:HoldPattern@Dot[opIjvec:opI[j_,True,optsj___Rule],opIkvec:opI[k_,True,optsk___Rule]]:=
Inner[
OperatorProduct,
opI[j,#,True,optsj]&/@{"x","y","z"},
opI[k,#,True,optsk]&/@{"x","y","z"},
Plus
];


(* ::Input::Initialization:: *)
opI::invalid\[Alpha]\[Beta]="operator indices \[Alpha] and \[Beta] may only be used with spins-1/2";


(* ::Input::Initialization:: *)
opI::badpower="opI cannot be raised to a non-integer or negative power.";


(* ::Input::Initialization:: *)
opI::badlabel="\"`1`\" is an incorrect axis label for opI";


(* ::Input::Initialization:: *)
ValidAxisSpecificationQ[axis_]:=MatchQ[axis,"x"|"y"|"z"|_?NumericQ|_Symbol|{_?NumericQ|_Symbol,_?NumericQ|_Symbol}];


(* ::Input::Initialization:: *)
SetAttributes[opR,NHoldFirst]


(* ::Input::Initialization:: *)
RotationOperator=opR;


(* ::Input::Initialization:: *)
opR/:Format[HoldPattern@opR[j:Except[_List],{\[Beta]_,mu:("x"|"y"|"z")}]]:= 
RowBox[{
SubscriptBox["R",RowBox[{j,mu}]],
"(",ToBoxes[\[Beta]],")"
}]//DisplayForm


(* ::Input::Initialization:: *)
opR[angs_List]:=opR[First/@SpinSystem[],angs];


(* ::Input::Initialization:: *)
opR[spins_List,angs_List]:=Dot@@(opR[#,angs]&/@spins);


(* ::Input::Initialization:: *)
opR[j:Except[_?ValidSpinQ],___]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]_}]/;!MatchQ[\[Beta],Except[_List|_String]]:=
(Message[opR::inv\[Beta]];$Failed);


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]_String}]/;!MatchQ[\[Phi],"x"|"y"|"z"|"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x"|"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y"]:=(Message[opR::inv\[Phi]];$Failed);


(* ::Input::Initialization:: *)
opR[j_,\[CapitalOmega]_]/;!MatchQ[
\[CapitalOmega],
{Except[_List|_String],Except[_List]}|
{Except[_List|_String],Except[_List|_String],Except[_List|_String]}|{Except[_List|_String],{Except[_List|_String],Except[_List|_String]}
}]:=
(Message[opR::invangle];$Failed);


(* ::Input::Initialization:: *)
opR/:HoldPattern[Times[a___,_opR,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x"}]:=opR[j,{\[Beta],\[Pi]}];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y"}]:=opR[j,{\[Beta],3\[Pi]/2}];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,"\!\(\*OverscriptBox[\(z\), \(_\)]\)"|"-z"}]:=opR[j,{-\[Beta],"z"}];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,label_String}]/;!MatchQ[label,"x"|"y"|"z"|"\!\(\*OverscriptBox[\(x\), \(_\)]\)"|"-x"|"\!\(\*OverscriptBox[\(y\), \(_\)]\)"|"-y"|"\!\(\*OverscriptBox[\(z\), \(_\)]\)"|"-z"]:=(Message[opR::badlabel,label];$Failed);


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]:Except[_String]}]:=opR[j,{\[Beta],"x"}]/;TrueQ[Mod[\[Phi],2\[Pi]]==0];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]:Except[_String]}]:=opR[j,{\[Beta],"y"}]/;TrueQ[Mod[\[Phi],2\[Pi]]==\[Pi]/2];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]:Except[_String]}]:=opR[j,{-\[Beta],"x"}]/;TrueQ[Mod[\[Phi],2\[Pi]]==\[Pi]];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]:Except[_String]}]:=opR[j,{-\[Beta],"y"}]/;TrueQ[Mod[\[Phi],2\[Pi]]==3\[Pi]/2];


(* ::Input::Initialization:: *)
opR[j_,{\[Beta]_,\[Phi]:Except[_List|_String]}]:=opR[j,{\[Phi],"z"}].opR[j,{\[Beta],"x"}].opR[j,{-\[Phi],"z"}];


(* ::Input::Initialization:: *)
opR[j_,{\[Alpha]_,\[Beta]_,\[Gamma]_}]:=opR[j,{\[Alpha],"z"}].opR[j,{\[Beta],"y"}].opR[j,{\[Gamma],"z"}]


(* ::Input::Initialization:: *)
opR[j_,{\[Xi]_,{\[Theta]_,\[Phi]_}}]:=opR[j,{\[Phi],"z"}].opR[j,{\[Theta],"y"}].opR[j,{\[Xi],"z"}].opR[j,{-\[Theta],"y"}].opR[j,{-\[Phi],"z"}];


(* ::Input::Initialization:: *)
opR[j_,{0,\[Mu]_String}]:=UnityOperator[]


(* ::Input::Initialization:: *)
opR/:Adjoint[HoldPattern@opR[j:Except[_List],{\[Beta]_,\[Mu]_String}]]:=opR[j,{-\[Beta],\[Mu]}];


(* ::Input::Initialization:: *)
opR/:HoldPattern@OperatorProduct[a___,opR[j_,{\[Beta]1_,\[Mu]_String}],opR[j_,{\[Beta]2_,\[Mu]_String}],b___,opts___Rule
]:=
OperatorProduct[a,opR[j,{\[Beta]1+\[Beta]2,\[Mu]}],b,opts];


(* ::Input::Initialization:: *)
opR/:HoldPattern@OperatorProduct[a___,opI[j_,\[Mu]_String,___],opR[j_,{\[Beta]_,\[Mu]_String}],b___,opts___Rule
]:=
OperatorProduct[a,opR[j,{\[Beta],\[Mu]}],opI[j,\[Mu]],b,opts];


(* ::Input::Initialization:: *)
opR/:op_opR[ket_?KetQ]:=op.ket


(* ::Input::Initialization:: *)
opR/:Dot[op_opR,ket_?KetQ]:=
Module[{basis},(
basis=ZeemanBasis[SpinSystem[ket]];Inner[Times,MatrixRepresentation[op,basis].VectorRepresentation[ket,basis],BasisKets[basis]]
)];


(* ::Input::Initialization:: *)
opR/:Dot[ops__,op_opR,ket_?KetQ]:=
Module[{basis},(
basis=ZeemanBasis[SpinSystem[ket]];Dot[ops,Inner[Times,MatrixRepresentation[op,basis].VectorRepresentation[ket,basis],BasisKets[basis]]]
)];


(* ::Input::Initialization:: *)
opR::inv\[Beta]="invalid flip angle for opR.";


(* ::Input::Initialization:: *)
opR::inv\[Phi]="invalid phase for opR.";


(* ::Input::Initialization:: *)
opR::invangle="invalid angle definition for opR.";


(* ::Input::Initialization:: *)
opR::badlabel="\"`1`\" is an invalid axis label for opR";


(* ::Input::Initialization:: *)
SetAttributes[opT,NHoldFirst];


(* ::Input::Initialization:: *)
Options[opT]={Normalize->False};


(* ::Input::Initialization:: *)
opT[{\[Lambda]_,q_},opts___Rule]:=Plus@@(opT[First[#],{\[Lambda],q},opts]&/@SpinSystem[]);


(* ::Input::Initialization:: *)
opT[j_,{l_,m_},opts___Rule]:=NullOperator[]/;Abs[m]>l;


(* ::Input::Initialization:: *)
opT[args:Except[_Rule]...,opts___Rule]/;(Normalize/.{opts}/.Options[opT]):=
NormalizeOperator[
opT[args,SimplifyRules[Normalize->False,opts]]
];


(* ::Input::Initialization:: *)
opT[j:Except[_List],___]:=(Message[SpinSystem::invspin,j];$Failed)/;!ValidSpinQ[j];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{\[Lambda]_,q_},opts___Rule]:=(opT::ranktoohigh;NullOperator[])/;\[Lambda]>2SpinQuantumNumber[j]


(* ::Input::Initialization:: *)
opT[j:Except[_List],{0,0},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= UnityOperator[];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{1,1},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= -(1/Sqrt[2])*opI[j,"+"];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{1,0},opts___Rule]/;!(Normalize/.{opts}/.Options[opT]) :=  opI[j,"z"];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{1,-1},opts___Rule]/;!(Normalize/.{opts}/.Options[opT]) :=  +(1/Sqrt[2])*opI[j,"-"];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{2,2},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= (1/2)*opI[j,"+"].opI[j,"+"];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{2,1},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= -(1/2)*(opI[j,"+"].opI[j,"z"]+opI[j,"z"].opI[j,"+"]);


(* ::Input::Initialization:: *)
opT[j:Except[_List],{2,0},opts___Rule]/;!(Normalize/.{opts}/.Options[opT]) :=  6^(-1/2)(3 opI[j,"z"].opI[j,"z"]-opI[j].opI[j]);


(* ::Input::Initialization:: *)
opT[j:Except[_List],{2,-1},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= +(1/2)*(opI[j,"-"].opI[j,"z"]+opI[j,"z"].opI[j,"-"]);


(* ::Input::Initialization:: *)
opT[j:Except[_List],{2,-2},opts___Rule] /;!(Normalize/.{opts}/.Options[opT]):= (1/2)*opI[j,"-"].opI[j,"-"];


(* ::Input::Initialization:: *)
ReducedISTOMatrixElement[Ij_,\[Lambda]_]:=(ReducedISTOMatrixElement[Ij,\[Lambda]]=(-1)^\[Lambda]/(Sqrt@Sum[Abs[CG[{Ij},{\[Lambda],0},{Ij,m}]]^2,{m,-Ij,+Ij,1}]));


(* ::Input::Initialization:: *)
ISTOmatel[Ij_,{\[Lambda]_,\[Mu]_}][{m1_,m2_}]:=CG[{Ij,m1},{\[Lambda],\[Mu]},{Ij,m2}]*ReducedISTOMatrixElement[Ij,\[Lambda]];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{\[Lambda]_,\[Mu]_},opts___Rule]/;(\[Mu]>=0)&&(!(Normalize/.{opts}/.Options[opT])):=
Module[{Ij},(
Message[opT::high\[Lambda]]; Off[opT::high\[Lambda]];
Ij=SpinQuantumNumber[j];
Operator[
SparseArray[Band[{1,\[Mu]+1}]:>Table[ISTOmatel[Ij,{\[Lambda],\[Mu]}][{m,m-\[Mu]}],{m,Ij,-Ij+\[Mu],-1}],{2Ij+1,2Ij+1}],
ZeemanBasis[{{j,Ij}}]
]
)];


(* ::Input::Initialization:: *)
opT[j:Except[_List],{\[Lambda]_,\[Mu]_},opts___Rule]/;(\[Mu]<0)&&(!(Normalize/.{opts}/.Options[opT])):=
Module[{Ij},(
Message[opT::high\[Lambda]]; Off[opT::high\[Lambda]];
Ij=SpinQuantumNumber[j];
Operator[
SparseArray[Band[{1-\[Mu],1}]:>Table[ISTOmatel[Ij,{\[Lambda],\[Mu]}][{m+\[Mu],m}],{m,Ij,-Ij-\[Mu],-1}],{2Ij+1,2Ij+1}],
ZeemanBasis[{{j,Ij}}]
]
)];


(* ::Input::Initialization:: *)
opT[{{{j:Except[_List],1},{k:Except[_List],1}},2},{2,0}]:=
((*Print["using explicit rule"];*)-(opI[j,"-"].opI[k,"+"]+opI[j,"+"].opI[k,"-"]-4opI[j,"z"].opI[k,"z"])/(2Sqrt[6])
);


(* ::Input::Initialization:: *)
opT[{intID_,{l_,m_}},opts___Rule]:=opT[intID,{l,m},opts];


(* ::Input::Initialization:: *)
opT[{initID_},{l_,m_},opts___Rule]:=opT[initID,{l,m},opts];


(* ::Input::Initialization:: *)
opT[{},{0,0},OptionsPattern[]]:=(UnityOperator[]/Sqrt[BasisDimension[]])/;!OptionValue[opT,Normalize];


(* ::Input::Initialization:: *)
opT[{},{0},{0,0},OptionsPattern[]]:=(UnityOperator[]/Sqrt[BasisDimension[]])/;!OptionValue[opT,Normalize];


(* ::Input::Initialization:: *)
opT[{{intID1_,l1_},{intID2_,l2_}},{Lam_,M_},opts___Rule]:=opT[{{{intID1,l1},{intID2,l2}},Lam},{Lam,M},opts];


(* ::Input::Initialization:: *)
opT[{{{intID1_,l1_},{intID2_,l2_}},Lam_},{Lam_,M_},opts___Rule]:=Simplify[Sum[CG[{Lam,M},{l1,mu1},{l2,M-mu1}] opT[{intID1,{l1,mu1}},Normalize->False,opts].opT[{intID2,{l2,M-mu1}},Normalize->False,opts],{mu1,-l1,+l1,1}]];


(* ::Input::Initialization:: *)
opT[interactions:{{ID1_,l1_},{_,_}...},
rankhistory:{___,Lam_},{Lam_,M_},opts___Rule]:=
Module[{IDs,ranks},(
{IDs,ranks}=Transpose[interactions];
opT[First[#],{Lam,M},opts]&@(
NestWhile[
{Take[#,2],
Sequence@@Drop[#,2]
}&,
Flatten/@Transpose[{interactions,rankhistory}
],
(Length[#]>2)&
]//.{
{{int1_,lam1_,Lam1_},{int2_,lam2_,Lam2_}}:>{{{int1,lam1},{int2,lam2}},Lam2},
{{int1_,lam1_},{int2_,lam2_,Lam2_},rest___}:>
{{{{int1,lam1},{int2,lam2}},Lam2},rest}
}//.{{args___}}:>{args}
)
)] /;Length[interactions]==Length[rankhistory];


(* ::Input::Initialization:: *)
opT[interactions:{{ID1_,l1_},{_,_}...},{Lam_,M_},opts___Rule]:=
Module[{IDs,ranks,rankhistories},(
{IDs,ranks}=Transpose[interactions];
rankhistories=Select[RankHistories[ranks],(Last[#]==Lam)&];
Switch[
Length[rankhistories],
	0,NullOperator[],
	1,Simplify@opT[interactions,First@rankhistories,{Lam,M},opts],
	_,(
Message[opT::multiple,Length[rankhistories]];(Simplify@opT[interactions,#,{Lam,M},opts])&/@rankhistories
)
]
)];


(* ::Input::Initialization:: *)
opT[interactions:{{ID1_,l1_},{_,_}...},{Lam_,M_},index_Integer,opts___Rule]:=
Module[{IDs,ranks},(
{IDs,ranks}=Transpose[interactions];
rankhistories=Select[RankHistories[ranks],(Last[#]==Lam)&];
opT[interactions,rankhistories[[index]],{Lam,M},opts]
)];


(* ::Input::Initialization:: *)
RankHistories[{l1_}]:={{l1}};


(* ::Input::Initialization:: *)
RankHistories[{l1__,l2_}]:=
Flatten[Table[
Append[#,l12],
{l12,Abs[l2-Last[#]],Abs[l2+Last[#]],1}
]& /@RankHistories[{l1}],1];


(* ::Input::Initialization:: *)
opT[spins:{Except[_List]..},args__,opts___Rule]:=(Message[SpinSystem::invspin,"<undefined>"];$Failed)/;!ValidSpinQ[spins];


(* ::Input::Initialization:: *)
opT[spins:{Except[_List]..},{Lam_,M_},opts___Rule]:=(Message[opT::ranktoohigh, Lam];NullOperator[])/;(Union[spins]==Sort@spins)&&(Lam>2*Plus@@(SpinQuantumNumber/@spins));


(* ::Input::Initialization:: *)
opT[spins:{Except[_List]..},{Lam_,M_},opts___Rule]:=
Module[{histories},(
histories=opThistories[spins,Lam];
Which[
Length[histories]==1,
	Simplify@opT[histories[[1]],{Lam,M},opts],
Length[histories]>1,
	(Message[opT::multiple,Length[histories]];
	(Simplify@opT[#,{Lam,M},opts])&/@histories),
Length[histories]==0,
	(Message[opT::fail];NullOperator[])
]
)]/;((!(Normalize/.{opts}/.Options[opT]))&&
(Union[spins]==Sort@spins)&&(Length[spins]>1));


(* ::Input::Initialization:: *)
opT[spins:{Except[_List]..},{Lam_,M_},index_Integer,opts___Rule]:=
Module[{histories},(
histories=opThistories[spins,Lam];
If[Length[histories]>=index>=1,
opT[histories[[index]],{Lam,M},opts],
(Message[opT::fail];NullOperator[])
]
)]/;((!(Normalize/.{opts}/.Options[opT]))&&
(Union[spins]==Sort@spins)&&(Length[spins]>1));


(* ::Input::Initialization:: *)
\[Lambda]totvals[{\[Lambda]1_,\[Lambda]2_}]:=Range[Abs[\[Lambda]1-\[Lambda]2],Abs[\[Lambda]1+\[Lambda]2],1];


(* ::Input::Initialization:: *)
\[Lambda]totvals[{\[Lambda]1_,\[Lambda]2_,\[Lambda]3__}]:=Union@Flatten[\[Lambda]totvals[{#,\[Lambda]3}]&/@\[Lambda]totvals[{\[Lambda]1,\[Lambda]2}]];


(* ::Input::Initialization:: *)
FeasibleCouplingHistoryQ[history:{{_,_}..},\[CapitalLambda]_]:=
MemberQ[\[Lambda]totvals[Last/@history],\[CapitalLambda]];


(* ::Input::Initialization:: *)
opThistories[spins:{Except[_List]..},\[CapitalLambda]_]:=
Select[
Flatten[#,Length[spins]-1]&@
Outer[List,Sequence@@(
Function[j,Table[{j,\[Lambda]},{\[Lambda],1,2SpinQuantumNumber[j]}]]/@spins),1],
FeasibleCouplingHistoryQ[#,\[CapitalLambda]]&
];


(* ::Input::Initialization:: *)
opT::ranktoohigh="spin system does not support an irreducible spherical tensor operator of rank `1`";


(* ::Input::Initialization:: *)
opT::multiple="There are `1` operators with this specification. A list of all possibilities has been returned. Specify a single operator using the form opT[interactions,{Lam,M},index] where index is an integer.";


(* ::Input::Initialization:: *)
opT::high\[Lambda]="Spherical tensor operators of high rank are calculated using the Wigner-Eckart theorem and provided in the form of Operator. Explicit expressions may be constructed by applying ExpressOperator. This message appears only once.";


(* ::Input::Initialization:: *)
opT::complexop="A complex operator expression has been represented in Operator form. Explicit expressions may be constructed by applying ExpressOperator. This message appears only once.";


(* ::Input::Initialization:: *)
opT::fail="failure in opT routine";


(* ::Input::Initialization:: *)
SetAttributes[SingleTransitionOperator,NHoldFirst]


(* ::Input::Initialization:: *)
SingleTransitionOperator[{r_,s_},\[Mu]_,opts___Rule]:=SingleTransitionOperator[{{r,s},Basis[]},\[Mu],opts];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{{r_,s_},basis_}|{ketr_?KetQ,kets_?KetQ},\[Mu]_,opts___Rule]/;!MatchQ[\[Mu],"x"|"y"|"z"|"+"|"-"|"u"|"E"|"1"]:=(Message[SingleTransitionOperator::bad\[Mu],\[Mu]];$Failed);


(* ::Input::Initialization:: *)
SingleTransitionOperator[{{r_,s_},Undefined},\[Mu]_,opts___Rule]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
SingleTransitionOperator[{{r_,s_},basis_},\[Mu]_,opts___Rule]/;!And@@(MemberQ[BasisLabels[basis],#]&/@{r,s}):=(Message[SingleTransitionOperator::badlabel,{r,s},basis];$Failed);


(* ::Input::Initialization:: *)
SingleTransitionOperator[{{r_,s_},basis_},\[Mu]_,opts___Rule]:=SingleTransitionOperator[{First@Extract[BasisKets[basis],Position[BasisLabels[basis],r]],First@Extract[BasisKets[basis],Position[BasisLabels[basis],s]]},\[Mu],opts];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},\[Mu]_,opts___Rule]/;Chop[Adjoint[kets].ketr]!=0:=(Message[SingleTransitionOperator::notorthog];$Failed);


(* ::Input::Initialization:: *)
SingleTransitionOperator/:HoldPattern[Times[a___,_SingleTransitionOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"+",opts___Rule]:=ketr.Adjoint[kets];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"-",opts___Rule]:=kets.Adjoint[ketr];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"x",opts___Rule]:=Expand[(1/2)(SingleTransitionOperator[{ketr,kets},"+"]+SingleTransitionOperator[{ketr,kets},"-"])];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"y",opts___Rule]:=Expand[(1/(2I))(SingleTransitionOperator[{ketr,kets},"+"]-SingleTransitionOperator[{ketr,kets},"-"])];


(* ::Input::Initialization:: *)
SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"z",opts___Rule]:=Expand[(1/2)(ketr.Adjoint[ketr]-kets.Adjoint[kets])];

SingleTransitionOperator[{ketr_?KetQ,kets_?KetQ},"u"|"E"|"1",opts___Rule]:=Expand[(ketr.Adjoint[ketr]+kets.Adjoint[kets])];


(* ::Input::Initialization:: *)
SingleTransitionOperator::bad\[Mu]="The operator index `1` should be one of {x,y,z,+,-} or {u,E,1} for the Unity Operator";


(* ::Input::Initialization:: *)
SingleTransitionOperator::badlabel="One or more of the labels `1` is not a defined basis label for the basis `2`";


(* ::Input::Initialization:: *)
SingleTransitionOperator::notorthog="The states are not orthogonal";


(* ::Input::Initialization:: *)
SetAttributes[CoherenceOperator,NHoldFirst]


(* ::Input::Initialization:: *)
CoherenceOperator[{r_,s_},opts___Rule]:=CoherenceOperator[{{r,s},Basis[]},opts];


(* ::Input::Initialization:: *)
CoherenceOperator[{{r_,s_},Undefined},___]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
CoherenceOperator[{{r_,s_},basis_},opts___Rule]/;!And@@(MemberQ[BasisLabels[basis],#]&/@{r,s}):=(Message[CoherenceOperator::badlabel,{r,s},basis];$Failed);


(* ::Input::Initialization:: *)
CoherenceOperator[{{r_,s_},basis_},opts___Rule]:=CoherenceOperator[{First@Extract[BasisKets[basis],Position[BasisLabels[basis],r]],First@Extract[BasisKets[basis],Position[BasisLabels[basis],s]]},opts];


(* ::Input::Initialization:: *)
CoherenceOperator[{ketr_?KetQ,kets_?KetQ},opts___Rule]/;Chop[Adjoint[kets].ketr]!=0:=(Message[CoherenceOperator::notorthog];$Failed);


(* ::Input::Initialization:: *)
CoherenceOperator[{ketr_?KetQ,kets_?KetQ},opts___Rule]:=ketr.Adjoint[kets];


(* ::Input::Initialization:: *)
CoherenceOperator/:HoldPattern[Times[a___,_CoherenceOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
CoherenceOperator::badlabel="One or more of the labels `1` is not a defined basis label for the basis `2`";


(* ::Input::Initialization:: *)
CoherenceOperator::notorthog="The states are not orthogonal";


(* ::Input::Initialization:: *)
SetAttributes[PopulationOperator,NHoldFirst]


(* ::Input::Initialization:: *)
PopulationOperator[ketr_?KetQ,opts___Rule]:=ketr.Adjoint[ketr];


(* ::Input::Initialization:: *)
PopulationOperator[r_,opts___Rule]:=PopulationOperator[{r,Basis[]},opts];


(* ::Input::Initialization:: *)
PopulationOperator[{r_,Undefined},___]:=(Message[Basis::unknown];Abort[]);


(* ::Input::Initialization:: *)
PopulationOperator[{r_,basis_},opts___Rule]/;!MemberQ[BasisLabels[basis],r]:=(Message[PopulationOperator::badlabel,r,basis];$Failed);


(* ::Input::Initialization:: *)
PopulationOperator[{r_,basis_},opts___Rule]:=PopulationOperator[First@Extract[BasisKets[basis],Position[BasisLabels[basis],r]],opts];


(* ::Input::Initialization:: *)
PopulationOperator/:HoldPattern[Times[a___,_PopulationOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
PopulationOperator::badlabel="The label `1` is not a defined basis label for the basis `2`";


(* ::Input::Initialization:: *)
SetAttributes[ProjectionOperator,NHoldFirst]


(* ::Input::Initialization:: *)
ProjectionOperator/:HoldPattern[Times[a___,_ProjectionOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
ProjectionOperator[{{_,_}..}]:=(Message[SpinSystem::notready];$Failed)/;MatchQ[SpinSystem[],Undefined];


(* ::Input::Initialization:: *)
ProjectionOperator[{j:Except[_List],mj:Except[_List]}]:=ProjectionOperator[{{j,mj}}];


(* ::Input::Initialization:: *)
ProjectionOperator[spinstates:{{_,_}..}]:=ProjectionOperator[Ket[spinstates]]/;First/@spinstates==First/@SpinSystem[];


(* ::Input::Initialization:: *)
ProjectionOperator[instates:{{_,_}..}]:=
Module[{inspins,outspins,outstates},(
inspins=First/@instates;
outspins=DeleteCases[First/@SpinSystem[],Alternatives@@inspins];
outstates=Flatten[
Outer[List,Sequence@@(Table[{#,mI},{mI,-SpinQuantumNumber[#],+SpinQuantumNumber[#]}]&/@outspins),
1],
Length[outspins]-1];
Plus@@Map[
ProjectionOperator[Sort[Join[#,instates]]]&,
outstates
]
)];


(* ::Input::Initialization:: *)
ProjectionOperator[ket_?KetQ,opts___Rule]:=Dot[ket,Adjoint[ket]]/(Adjoint[ket].ket);


(* ::Input::Initialization:: *)
SetAttributes[ShiftOperator,NHoldFirst]


(* ::Input::Initialization:: *)
ShiftOperator/:HoldPattern[Times[a___,_ShiftOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
ShiftOperator[ket_?KetQ,bra_?BraQ,opts___Rule]:=Dot[ket,bra]/(Sqrt[Adjoint[ket].ket]*Sqrt[bra.Adjoint[bra]]);


(* ::Input::Initialization:: *)
SpinExchangeOperator[args___]:=(Message[SpinExchangeOperator::obs];SpinPermutationOperator[args]);


(* ::Input::Initialization:: *)
SpinExchangeOperator::obs="SpinExchangeOperator has been superseded by SpinPermutationOperator. Proceeding using SpinPermutationOperator.";


(* ::Input::Initialization:: *)
SetAttributes[SpinExchangeOperator,NHoldFirst]


(* ::Input::Initialization:: *)
SpinPermutationOperator/:HoldPattern[Times[a___,_SpinPermutationOperator,b___]]/;Or@@(OperatorQ/@{a,b}):=(Message[Operator::times];$Failed);


(* ::Input::Initialization:: *)
SpinPermutationOperator[perm_]:=SpinPermutationOperator[perm,SpinSystem[]];


(* ::Input::Initialization:: *)
SpinPermutationOperator[perms_?MatrixQ,spinsys_?MatrixQ]:=Apply[Dot,SpinPermutationOperator[#,spinsys]&/@perms];


(* ::Input::Initialization:: *)
SpinPermutationOperator[perm_List,spinsys_?MatrixQ]:=
Module[{validities, invalspins},(
invalspins=Pick[perm,validities,False];
Message[SpinPermutationOperator::invalspins,invalspins];
$Failed
)/;(
validities=ValidSpinQ/@perm;
!And@@validities
)];


(* ::Input::Initialization:: *)
SpinPermutationOperator[perm_List,spinsys_?MatrixQ]:=
Module[{pairs,Ivals, mismatches},(
Message[SpinPermutationOperator::invalpair,mismatches];
$Failed
)/;(
pairs=Partition[perm,2,1];
Ivals=Last/@spinsys;
mismatches=Select[pairs,(Pick[Ivals,First/@spinsys,First[#]]!=Pick[Ivals,First/@spinsys,Last[#]])&];
mismatches!={}
)];


(* ::Input::Initialization:: *)
HoldPattern@Adjoint[SpinPermutationOperator[perm_List,spinsys_]]^:=SpinPermutationOperator[Reverse@perm,spinsys];


(* ::Input::Initialization:: *)
SpinPermutationOperator[perm_List,spinsys_]:=
Module[{zbasis,rules,ket,zkets,permzkets},(
zbasis=ZeemanBasis[spinsys];
zkets=BasisKets[zbasis];
rules=Inner[({#1,M1_}:>{#2,M1})&,perm,RotateLeft[perm],List];
permzkets=
zkets/.HoldPattern@Ket[kets_?MatrixQ,spinsys,opts___Rule]:>Ket[kets/.rules,spinsys,
SimplifyRules[Validity->False,opts]
];
SpinPermutationOperator[perm,spinsys]=
Operator[
SparseArray@Outer[Dot,Adjoint/@zkets,permzkets],
zbasis,
OperatorType->"Unitary",
CheckOperatorType->False
]
)];


(* ::Input::Initialization:: *)
SpinPermutationOperator::invalspins="The following spin labels are invalid for the current SpinSystem: `1`";


(* ::Input::Initialization:: *)
SpinPermutationOperator::invalpair="The following pairs of spins cannot be exchanged since they have different spin quantum numbers:`1`"; 


(* ::Input::Initialization:: *)
Options[MatrixRepresentation]={Method->Automatic};


(* ::Input::Initialization:: *)
MatrixRepresentation[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op_,opts___Rule]:=
Chop@MatrixRepresentation[op,Basis[],opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op_,Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
MatrixRepresentation[op,opts]
);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[num_?((Chop[#]==0)&),basis_,opts___Rule]:=MatrixRepresentation[NullOperator[],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[num_?NumericQ,basis_,opts___Rule]:=MatrixRepresentation[num*UnityOperator[],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:Except[_?OperatorQ|_?KetQ|_?BraQ],basis_,opts___Rule]:=Module[{fixedop},(
MatrixRepresentation[fixedop,basis,opts]
)/;(
fixedop=Chop[op];
MatchQ[fixedop,_?OperatorQ|_?KetQ|_?BraQ]
)];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:Except[_?OperatorQ|_?KetQ|_?BraQ],basis_,opts___Rule]:=(Message[MatrixRepresentation::badop];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Plus[ops___],basis_,opts___Rule]:=
SumMatricesAndMatrixInterpolationFunctions@@Map[
MatrixRepresentation[#,basis,opts]&,
{ops}
];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Times[num1:Except[_?OperatorQ]..,op_?OperatorQ],basis_,opts___Rule]:=
Times[num1,MatrixRepresentation[op,basis,opts]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Times[op_?OperatorQ,num2:Except[_?OperatorQ]..],basis_,opts___Rule]:=
Times[num2,MatrixRepresentation[op,basis,opts]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[num:(_?NumericQ)|(_Symbol)|HoldPattern@Times[(_?NumericQ|_Symbol)..],basis_,opts___Rule]:=
num*MatrixRepresentation[UnityOperator[],basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Adjoint[op_],basis_,opts___Rule]:=
ComplexExpand@Conjugate@Transpose@MatrixRepresentation[op,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[OperatorProduct[op1__,Exp[op_]|Power[E,op_],op2___],basis_,opts___Rule]:=
MatrixRepresentation[OperatorProduct[op1],basis,opts].
MatrixRepresentation[OperatorProduct[Exp[op],op2],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[OperatorProduct[op1___,Exp[op_]|Power[E,op_],op2__],basis_,opts___Rule]:=
MatrixRepresentation[OperatorProduct[op1,Exp[op]],basis,opts].
MatrixRepresentation[OperatorProduct[op2],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Exp[op_?OperatorQ]|Power[E,op_?OperatorQ],basis_,opts___Rule]:=
SparseArray@MatrixExp@MatrixRepresentation[op,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[ket_?KetQ,basis_,opts___Rule]:=SparseArray[List/@VectorRepresentation[ket,basis,opts]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[bra_?BraQ,basis_,opts___Rule]:=SparseArray[{VectorRepresentation[bra,basis,opts]}];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:Operator[specs_,basis1_,opts1__Rule],basis2_,opts2___Rule]:=
Module[{spinsys1,spinsys2,missingspins,missingspinkets,missingspinbras,matrep,kets,bras,ketbraopform,n},(
missingspins=Complement[spinsys2,spinsys1];
missingspinkets=BasisKets[ZeemanBasis[missingspins]];
missingspinbras=BasisBras[ZeemanBasis[missingspins]];
kets=BasisKets[ZeemanBasis[spinsys1]];
bras=BasisBras[ZeemanBasis[spinsys1]];
n=Length[kets];
matrep=MatrixRepresentation[op,ZeemanBasis[spinsys1]];
ketbraopform=Plus@@Flatten@Table[matrep[[r,c]]*kets[[r]].bras[[c]],{r,1,n},{c,1,n}];
MatrixRepresentation[
ketbraopform/.ket_Ket.bra_Bra:>
Inner[ProductKet[ket,#1].ProductBra[bra,#2]&,
missingspinkets,missingspinbras
],
basis2
]
)/;(
spinsys1=SpinSystem[basis1];
spinsys2=SpinSystem[basis2];
UnsameQ[spinsys1,spinsys2]&&SubsetQ[spinsys2,spinsys1]
)];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[specs_,basis1_,opts1__Rule],basis2_,opts2___Rule]/;UnsameQ[basis1,basis2]&&SameQ[SpinSystem@basis2,SpinSystem@basis1]:=
(
SparseArray@MultiplyMatricesAndMatrixInterpolationFunctions[
BasisTransformationMatrix[basis2,basis1],MatrixRepresentation[Operator[specs,basis1,opts1],basis1,opts2],BasisTransformationMatrix[basis1,basis2]
]);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[mat_?MatrixQ,basis_,___Rule],basis_,opts___Rule]:=mat;


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,___Rule],basis_,opts___Rule]:=Chop[X.SparseArray[DiagonalMatrix[evals]].Xinv];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[ifunc_InterpolatingFunction[t_],basis_,___Rule],basis_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?MatrixQ]):=ifunc[t];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[ifunc_InterpolatingFunction[t_],basis_,___Rule],basis_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],{_?MatrixQ,_List,_?MatrixQ}]):=Replace[ifunc,{X_?MatrixQ,D_List,Xinv_?MatrixQ}:>X.DiagonalMatrix[D].Xinv,{3}][t];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[ifunc_InterpolatingFunction[t_],basis_,___Rule],basis_,opts___Rule]/;((Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?OperatorQ]):=Replace[ifunc,op_?OperatorQ:>MatrixRepresentation[op,basis],{3}][t];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Operator[specs_,basis1_,opts1__Rule],basis2_,opts2___Rule]/;!SubsetQ[SpinSystem@basis2,SpinSystem@basis1]:=(Message[Operator::incompatspinsys];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[UnityOperator[Except[_List]...,___Rule],basis_,opts___Rule]:=SparseArray[Band[{1,1}]->Table[1,{BasisDimension[basis]}]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[NullOperator[],basis_,opts___Rule]:=SparseArray[Band[{1,1}]->Table[0,{BasisDimension[basis]}]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op_?OperatorQ,basis_,opts___Rule]:=
Module[{ibasis},(
SparseArray[
Normal[
BasisTransformationMatrix[basis,ibasis].MatrixRepresentation[op,ibasis].BasisTransformationMatrix[ibasis,basis]
]]/.{
HoldPattern[OperatorProduct[___,0,___]]:>0,
HoldPattern[OperatorProduct[a__,1,b___]]:>OperatorProduct[a,b],
HoldPattern[OperatorProduct[a___,1,b__]]:>OperatorProduct[a,b]
}
)/;(
ibasis=ZeemanBasis[SpinSystem[basis]];MatchQ[Method/.{opts}/.Options[MatrixRepresentation],Automatic]&&!MatchQ[basis,ibasis])];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op_?OperatorQ,basis_,opts___Rule]/;MatchQ[Method/.{opts}/.Options[MatrixRepresentation],"Direct"]&&FreeQ[op,_InterpolatingFunction]:=
(
SparseArray[
Outer[(#1.op.#2)&,BasisBras[basis],BasisKets[basis]]/.{
HoldPattern[OperatorProduct[___,0,___]]:>0,
HoldPattern[OperatorProduct[a__,1,b___]]:>OperatorProduct[a,b],
HoldPattern[OperatorProduct[a___,1,b__]]:>OperatorProduct[a,b]
}
]);


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb__,ket_?KetQ,opsc___],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb],basis,opts].MatrixRepresentation[Dot[ket,opsc],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[ket_?KetQ,opsc__],basis_,opts___Rule]:=MatrixRepresentation[ket,basis,opts].MatrixRepresentation[Dot[opsc],basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb___,ket_?KetQ,opsc__],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb,ket],basis,opts].MatrixRepresentation[Dot[opsc],basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb__,ket_?KetQ],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb],basis,opts].MatrixRepresentation[ket,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb__,bra_?BraQ,opsc___],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb],basis,opts].MatrixRepresentation[Dot[bra,opsc],basis,opts];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[bra_?BraQ,opsc__],basis_,opts___Rule]:=MatrixRepresentation[bra,basis,opts].MatrixRepresentation[Dot[opsc],basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb___,bra_?BraQ,opsc__],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb,bra],basis,opts].MatrixRepresentation[Dot[opsc],basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[Dot[opsb__,bra_?BraQ],basis_,opts___Rule]:=MatrixRepresentation[Dot[opsb],basis,opts].MatrixRepresentation[bra,basis,opts]


(* ::Input::Initialization:: *)
MatrixRepresentation[
HoldPattern@OperatorProduct[ops___?OperatorQ,___Rule],
basis_,opts___Rule
]/;!Equal@@(MatchQ[#,_opI|_opR]&/@{ops}):=
Module[{oplists,matreps},(
oplists=SplitBy[{ops},MatchQ[#,_opI|_opR]&];
matreps=Map[MatrixRepresentation[OperatorProduct@@#,basis,opts]&,oplists];
If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]
]
)];


(* ::Input::Initialization:: *)
MatrixRepresentation[
HoldPattern@OperatorProduct[ops___?OperatorQ,___Rule],
basis_,opts___Rule
]/;And@@(!MatchQ[#,_opI|_opR]&/@{ops}):=
Module[{matreps},(
matreps=MatrixRepresentation[#,basis,opts]&/@{ops};
If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]
]
)];


(* ::Input::Initialization:: *)
InvolvedSpin[SingleSpinZeemanBasisMatrixRepresentation[op_,___]]:=InvolvedSpin[op];


(* ::Input::Initialization:: *)
InvolvedSpin[UnityOperator[j_]]:=j


(* ::Input::Initialization:: *)
InvolvedSpin[HoldPattern@(opI|opR)[j_,___]]:=j


(* ::Input::Initialization:: *)
InvolvedSpin[HoldPattern@OperatorProduct[(opI|opR)[j_,___]..,___Rule]]:=j


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:(opI[j_,___]|opR[j_,___]),basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],opts___Rule]:=SparseArray@SingleSpinZeemanBasisMatrixRepresentation[op,basis,opts]/;Length[spins]==1


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:(opI[j_,___]|opR[j_,___]),basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],opts___Rule]:=SparseArray@ConstructMatrixRepresentation[op,basis,opts]/;Length[spins]>1


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[OperatorProduct[ops:(Except[_Rule]..),___Rule],
basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],
opts___Rule]:=
SparseArray@ConstructMatrixRepresentation[
ConstructMatrixRepresentation[#,basis,opts]&/@
Apply[Dot,
Flatten[SplitBy[{ops},{MatchQ[#,(opI|opR)[___]]&,InvolvedSpin}],1],
1
],basis,opts
]


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[mats:{_?MatrixQ...},basis_,opts___Rule]:=If[Length[mats]==1,First@mats,Fold[Dot,First@mats,Drop[mats,1]]
];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[num:Except[_?OperatorQ|_?KetQ|_?BraQ],basis_,opts___Rule]:=num*ConstructMatrixRepresentation[UnityOperator[],basis,opts];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[UnityOperator[___],basis_,opts___Rule]:=SparseArray[{i_,i_}->1,{BasisDimension[basis],BasisDimension[basis]}];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[
opj:(HoldPattern@OperatorProduct[(opI|opR)[j_,___]..,___Rule]|(opI|opR)[j_,___]),
basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],opts___Rule
]/;Length[spins]>1:=
Apply[
KroneckerProduct,
Reverse[
If[#==j,
SingleSpinZeemanBasisMatrixRepresentation[opj,ZeemanBasis[Cases[spins,{j,_}]]],
SingleSpinZeemanBasisMatrixRepresentation[UnityOperator[#],ZeemanBasis[Cases[spins,{#,_}]]]
]&/@(First/@spins)
]
];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[
opj:(HoldPattern@OperatorProduct[(opI|opR)[j_,___]..,___Rule]|(opI|opR)[j_,___]),
basis:ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule
]:=SingleSpinZeemanBasisMatrixRepresentation[opj,basis];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[ket_?KetQ,basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],opts___Rule]:=List/@VectorRepresentation[ket,basis,opts];


(* ::Input::Initialization:: *)
ConstructMatrixRepresentation[bra_?BraQ,basis:ZeemanBasis[spins_?MatrixQ,basisopts___Rule],opts___Rule]:={VectorRepresentation[bra,basis,opts]};


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[
OperatorProduct[ops:(opI|opR|UnityOperator)[j_,___]..,___Rule],basis:ZeemanBasis[{{j_,Ij_}},basisopts___Rule]]:=Dot@@(SingleSpinZeemanBasisMatrixRepresentation[#,basis]&/@{ops});


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opI[j_,"z",more___],ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule]:=
SingleSpinZeemanBasisMatrixRepresentation[opI[j,"z",more],ZeemanBasis[{{j,Ij}},basisopts],opts]=SparseArray[Band[{1,1}]->Table[m,{m,+Ij,-Ij,-1}]];


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opI[j_,"+",more___],ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule]:=
SingleSpinZeemanBasisMatrixRepresentation[opI[j,"+",more],ZeemanBasis[{{j,Ij}},basisopts],opts]=
SparseArray[
Band[{1,2}]->Table[Sqrt[Ij(Ij+1)-m(m+1)],{m,-Ij,Ij-1,1}],
{2Ij+1,2Ij+1}
];


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opI[j_,"-",more___],ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule]:=
SingleSpinZeemanBasisMatrixRepresentation[opI[j,"-",more],ZeemanBasis[{{j,Ij}},basisopts],opts]=
SparseArray[
Band[{2,1}]->Table[Sqrt[Ij(Ij+1)-m(m-1)],{m,-Ij+1,Ij,1}],
{2Ij+1,2Ij+1}
];


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opI[j_,"x",more___],basis_,opts___Rule]:=SingleSpinZeemanBasisMatrixRepresentation[opI[j,"x",more],basis,opts]=(1/2)*(SingleSpinZeemanBasisMatrixRepresentation[opI[j,"+",more],basis,opts]+SingleSpinZeemanBasisMatrixRepresentation[opI[j,"-",more],basis,opts])


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opI[j_,"y",more___],basis_,opts___Rule]:=SingleSpinZeemanBasisMatrixRepresentation[opI[j,"y",more],basis,opts]=(1/(2I))*(SingleSpinZeemanBasisMatrixRepresentation[opI[j,"+",more],basis,opts]-SingleSpinZeemanBasisMatrixRepresentation[opI[j,"-",more],basis,opts])


(* ::Input::Initialization:: *)
SingleSpinZeemanBasisMatrixRepresentation[HoldPattern@opI[j_,"\[Alpha]",more___],ZeemanBasis[{{j_,1/2}},basisopts___Rule],opts___Rule]:=SparseArray[{1,1}->1,{2,2}]


(* ::Input::Initialization:: *)
SingleSpinZeemanBasisMatrixRepresentation[HoldPattern@opI[j_,"\[Beta]",more___],ZeemanBasis[{{j_,1/2}},basisopts___Rule],opts___Rule]:=SparseArray[{2,2}->1,{2,2}]


(* ::Input::Initialization:: *)
SingleSpinZeemanBasisMatrixRepresentation[UnityOperator[j_],ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule]:=SparseArray[Band[{1,1}]->Table[1,{2Ij+1}]];


(* ::Input::Initialization:: *)
HoldPattern@SingleSpinZeemanBasisMatrixRepresentation[opR[j_,{\[Beta]_,\[Mu]:("x"|"y"|"z")},more___],basis:ZeemanBasis[{{j_,Ij_}},basisopts___Rule],opts___Rule]:=
Chop@MatrixExp[-I \[Beta] SingleSpinZeemanBasisMatrixRepresentation[opI[j,\[Mu],more],basis]];


(* ::Input::Initialization:: *)
HoldPattern@MatrixRepresentation[op:(_?OperatorQ|_?KetQ|_?BraQ),basis_,opts___Rule]/;(!MatchQ[op,HoldPattern@Operator[_?VectorQ,___]])&&FreeQ[op,_InterpolatingFunction]:=
MatrixRepresentation[op,basis,Method->"Direct",opts];


(* ::Input::Initialization:: *)
MatrixRepresentation::badop="MatrixRepresentation may only be applied to an operator, a Ket or a Bra.";


(* ::Input::Initialization:: *)
Options[Eigenbasis]={BasisLabels->Automatic};


(* ::Input::Initialization:: *)
Eigenbasis[op_?OperatorQ,opts___Rule]:=Eigenbasis[op,SpinSystem[],opts];


(* ::Input::Initialization:: *)
Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ]:=
Eigenbasis[
op,
Sequence@@Options[Eigenbasis]
];


(* ::Input::Initialization:: *)
CheckBasis[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,basisopts___Rule],opts___Rule]:=NormalQ[MatrixRepresentation[op,ZeemanBasis[spinsys]]];


(* ::Input::Initialization:: *)
SetBasis[
Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,basisopts___Rule],opts___Rule]/;!TrueQ[spinsys==SpinSystem[]]:=
Module[{basis},(
basis=Eigenbasis[op,spinsys,basisopts];
SetSpinSystem[spinsys];
If[!MatchQ[Basis[],basis],SetBasis[basis,opts]]
)];


(* ::Input::Initialization:: *)
DefinedBasisQ[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]]:=True;


(* ::Input::Initialization:: *)
BasisDimension[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]]:=BasisDimension[ZeemanBasis[spinsys]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule],zbasis:ZeemanBasis[spinsys_?MatrixQ,___Rule]},spinsys_]:=
BasisTransformationMatrix[{Eigenbasis[op,spinsys,opts],zbasis},spinsys]=Chop@SparseArray[Normalize/@
Orthogonalize@Eigenvectors@N@MatrixRepresentation[op,zbasis]
];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule],basis:Except[ZeemanBasis[_?MatrixQ,___Rule]]},spinsys_]:=
Chop[SparseArray[BasisTransformationMatrix[Eigenbasis[op,spinsys,opts],ZeemanBasis[spinsys]].BasisTransformationMatrix[ZeemanBasis[spinsys],basis]]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{zbasis:ZeemanBasis[spinsys_?MatrixQ,___Rule],Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]},spinsys_]:=
BasisTransformationMatrix[{zbasis,Eigenbasis[op,spinsys,opts]},spinsys]=Chop@SparseArray@Adjoint[BasisTransformationMatrix[Eigenbasis[op,spinsys,opts],zbasis]];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis:Except[ZeemanBasis[_?MatrixQ,___Rule]],Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]},spinsys_]:=
Chop[SparseArray[BasisTransformationMatrix[basis,ZeemanBasis[spinsys]].BasisTransformationMatrix[ZeemanBasis[spinsys],Eigenbasis[op,spinsys,opts]]]];


(* ::Input::Initialization:: *)
BasisKets[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]]:=
BasisKets[ZeemanBasis[spinsys]].BasisTransformationMatrix[ZeemanBasis[spinsys],Eigenbasis[op,spinsys,opts]];


(* ::Input::Initialization:: *)
BasisBras[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]]:=
BasisTransformationMatrix[Eigenbasis[op,spinsys,opts],ZeemanBasis[spinsys]].BasisBras[ZeemanBasis[spinsys]];


(* ::Input::Initialization:: *)
SpinSystem[Eigenbasis[op_?OperatorQ,spinsys_?MatrixQ,opts___Rule]]^:=spinsys;


(* ::Input::Initialization:: *)
Options[TransformedBasis]={BasisLabels->Automatic};


(* ::Input::Initialization:: *)
TransformedBasis[op_?OperatorQ,opts___Rule]:=TransformedBasis[op,Basis[],opts];


(* ::Input::Initialization:: *)
TransformedBasis[op_?OperatorQ,basis_]:=
TransformedBasis[op,basis,Sequence@@Options[TransformedBasis]];


(* ::Input::Initialization:: *)
TransformedBasis[op2_?OperatorQ,
TransformedBasis[op1_?OperatorQ,basis_,opts1___Rule],
opts2___Rule]:=
TransformedBasis[op2.op1,basis,
Sequence@@SimplifyRules[{opts2,opts1}]
];


(* ::Input::Initialization:: *)
DefinedBasisQ[TransformedBasis[op_,basis_,opts___Rule]]^:=DefinedBasisQ[basis];


(* ::Input::Initialization:: *)
BasisDimension[TransformedBasis[op_,basis_,opts___Rule]]:=BasisDimension[basis];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{TransformedBasis[op_,basis_,opts___Rule],basis_},spinsys_]:=BasisTransformationMatrix[{TransformedBasis[op,basis,opts],basis},spinsys]=
Adjoint@MatrixRepresentation[op,basis,opts];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis_,TransformedBasis[op_,basis_,opts___Rule]},spinsys_]:=
BasisTransformationMatrix[{basis,TransformedBasis[op,basis,opts]},spinsys]=
MatrixRepresentation[op,basis,opts];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{TransformedBasis[op_,basis1_,opts___Rule],basis2_},spinsys_]:=BasisTransformationMatrix[{TransformedBasis[op,basis1,opts],basis1},spinsys].BasisTransformationMatrix[{basis1,basis2},spinsys];


(* ::Input::Initialization:: *)
BasisTransformationMatrix[{basis2_,TransformedBasis[op_,basis1_,opts___Rule]},spinsys_]:=BasisTransformationMatrix[{basis2,basis1},spinsys].BasisTransformationMatrix[{basis1,TransformedBasis[op,basis1,opts]},spinsys];


(* ::Input::Initialization:: *)
BasisKets[TransformedBasis[op_,basis_,opts___Rule]]:=
BasisTransformationMatrix[TransformedBasis[op,basis,opts],basis].BasisKets[basis];


(* ::Input::Initialization:: *)
BasisBras[TransformedBasis[op_,basis_,opts___Rule]]:=
BasisBras[basis].BasisTransformationMatrix[basis,TransformedBasis[op,basis,opts]];


(* ::Input::Initialization:: *)
SpinSystem[TransformedBasis[op_,basis_,opts___Rule]]^:=SpinSystem[basis];


(* ::Input::Initialization:: *)
Commutator[a_,b_]:=Simplify[a.b-b.a];



(* ::Input::Initialization:: *)
CoherenceOrder[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
CoherenceOrder[op_?OperatorQ]:=CoherenceOrder[First/@SpinSystem[],op];


(* ::Input::Initialization:: *)
CoherenceOrder[spin:Except[_List],op_?OperatorQ]:=CoherenceOrder[{spin},op];


(* ::Input::Initialization:: *)
CoherenceOrder[spins:{Except[_List]..},op_?OperatorQ]:=
Module[{invalspins},(
Message[CoherenceOrder::invalspins,invalspins];$Failed
)/;(
invalspins=Complement[spins,First/@SpinSystem[]];
!MatchQ[invalspins,{}]
)];


(* ::Input::Initialization:: *)
CoherenceOrder[spinsets:{_List..},op_?OperatorQ]:=
Module[{invalspins},(
Message[CoherenceOrder::invalspins,invalspins];$Failed
)/;(
invalspins=Complement[Union@@spinsets,First/@SpinSystem[]];
!MatchQ[invalspins,{}]
)];


(* ::Input::Initialization:: *)
CoherenceOrder[spins_List,op_?OperatorQ]:=
Module[{matrep,nonzpos,Mvals,pvals,zbasis},(
zbasis=ZeemanBasis[];
matrep=MatrixRepresentation[op,zbasis];
nonzpos=Position[Chop@N@Normal@matrep,Except[0],{2},Heads->False];
Mvals=MagneticQuantumNumber[#,spins]&/@BasisKets[zbasis];
pvals=Union[(Mvals[[First[#]]]-Mvals[[Last[#]]])&/@nonzpos];
Which[
MatchQ[spins,{Except[List]..}]&&(Length[pvals]==1),
	First[pvals],
True,
	pvals
]
)];


(* ::Input::Initialization:: *)
CoherenceOrder[___]:=Indeterminate;


(* ::Input::Initialization:: *)
CoherenceOrder::invalspins="Spins `1` are not in the current spin system.";


(* ::Input::Initialization:: *)
SpinProductRank[UnityOperator[___]]=0;


(* ::Input::Initialization:: *)
SpinProductRank[HoldPattern@opI[___]]:=1;


(* ::Input::Initialization:: *)
SpinProductRank[op:HoldPattern@OperatorProduct[(opI[___]|UnityOperator[___])..,___Rule]]:=Count[op,HoldPattern@opI[___],2]


(* ::Input::Initialization:: *)
SpinProductRank[Times[Except[_?OperatorQ]..,ops__]]:=SpinProductRank[ops];


(* ::Input::Initialization:: *)
SpinProductRank[Times[ops__,Except[_?OperatorQ]..]]:=SpinProductRank[ops];


(* ::Input::Initialization:: *)
SpinProductRank[HoldPattern@Plus[ops___]]:=
Module[{ranks},(
ranks=SpinProductRank/@{ops};
If[MatchQ[ranks,{(p_)..}],First@ranks,Indeterminate]
)];


(* ::Input::Initialization:: *)
SpinProductRank[___]:=Indeterminate


(* ::Input::Initialization:: *)
OperatorTrace[$Failed,___]:=$Failed;


(* ::Input::Initialization:: *)
OperatorTrace[op_,opts___Rule]:=
OperatorTrace[op,Basis[],opts];


(* ::Input::Initialization:: *)
OperatorTrace[op_,Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
OperatorTrace[op_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
OperatorTrace[op,opts]
);


(* ::Input::Initialization:: *)
HoldPattern@OperatorTrace[Plus[ops___],basis_,opts___Rule]:=
Map[
OperatorTrace[#,basis,opts]&,
Plus[ops]
]


(* ::Input::Initialization:: *)
HoldPattern@OperatorTrace[Times[op_?OperatorQ,num:Except[_?OperatorQ]..],basis_,opts___Rule]:=
Times[num,OperatorTrace[op,basis,opts]];


(* ::Input::Initialization:: *)
HoldPattern@OperatorTrace[Times[num:Except[_?OperatorQ]..,op_?OperatorQ],basis_,opts___Rule]:=
Times[num,OperatorTrace[op,basis,opts]];


(* ::Input::Initialization:: *)
OperatorTrace[(num:Except[_?OperatorQ]),basis_,opts___Rule]:=
num*OperatorTrace[UnityOperator[],basis,opts]


(* ::Input::Initialization:: *)
OperatorTrace[Adjoint[op_],basis_,opts___Rule]:=
ComplexExpand@Conjugate@OperatorTrace[op,basis,opts]


(* ::Input::Initialization:: *)
HoldPattern@OperatorTrace[OperatorProduct[op1___,Exp[op_]|Power[E,op_],op2___,___Rule],basis_,opts___Rule]:=
Tr[MatrixRepresentation[OperatorProduct[op1,Exp[op],op2],basis,opts]];


(* ::Input::Initialization:: *)
OperatorTrace[op_,basis_,opts___Rule]:=
Tr[MatrixRepresentation[op,basis,opts]];


(* ::Input::Initialization:: *)
OperatorNorm[$Failed,___]:=$Failed;


(* ::Input::Initialization:: *)
OperatorNorm[op_,opts___Rule]:=
OperatorNorm[op,Basis[],opts];


(* ::Input::Initialization:: *)
OperatorNorm[op_,Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
OperatorNorm[op_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
OperatorNorm[op,opts]
);


(* ::Input::Initialization:: *)
OperatorNorm[op_,basis_,opts___Rule]:=
Simplify@Norm[Flatten@MatrixRepresentation[op,basis,opts]];


(* ::Input::Initialization:: *)
NormalizeOperator[$Failed,___]:=$Failed;


(* ::Input::Initialization:: *)
NormalizeOperator[op_,opts___Rule]:=NormalizeOperator[op,1,opts];


(* ::Input::Initialization:: *)
NormalizeOperator[op_,basis:Except[(_?NumericQ|_?OperatorQ)],opts___Rule]:=NormalizeOperator[op,1,basis,opts];


(* ::Input::Initialization:: *)
NormalizeOperator[op_,norm:(_?NumericQ|_?OperatorQ),opts___Rule]:=
NormalizeOperator[op,norm,Basis[],opts];


(* ::Input::Initialization:: *)
NormalizeOperator[op_,norm:(_?NumericQ|_?OperatorQ),Undefined,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
NormalizeOperator[op_,norm:(_?NumericQ|_?OperatorQ),Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
NormalizeOperator[op,norm,opts]
);


(* ::Input::Initialization:: *)
NormalizeOperator[ops_List,norm_,basis_,opts___Rule]:=NormalizeOperator[#,norm,basis,opts]&/@ops


(* ::Input::Initialization:: *)
NormalizeOperator[op1_,op2_?OperatorQ,basis_,opts___Rule]:=NormalizeOperator[op1,OperatorNorm[op2,basis],basis,opts];


(* ::Input::Initialization:: *)
NormalizeOperator[op_,norm_?NumericQ,basis_,opts___Rule]:=
Simplify[norm*op/OperatorNorm[op,basis,opts]];


(* ::Input::Initialization:: *)
End[];
EndPackage[];



