(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Rotations`Polar`",
	{	"Global`",
		"SpinDynamica`",
		"General`UserLevel`",
		(*"General`ModifyBuiltIn`",*)
		"General`General3D`",
		"Rotations`Euler`",
		"General`Miscellaneous`"
		}
];


(* ::Input::Initialization:: *)
PolarRotationMatrix::usage =
	"PolarRotationMatrix[{\[Xi],\[Theta],\[Phi]}] gives the 3D rotation matrix for a rotation through xi around the axis with polar angles {\[Theta],\[Phi]}.";
	


(* ::Input::Initialization:: *)
RotatePolar::usage =
	"RotatePolar[obj,{\[Xi],\[Theta],\[Phi]}] rotates the object by \[Xi] around the axis with polar angles (\[Theta],\[Phi]).

RotatePolar[obj,{\[Xi],vec}] rotates the object by xi around the vector vec.

The object obj may be a 3-vector, or contain lines, polygons, and text.
";


(* ::Input::Initialization:: *)
Begin["`Private`"];


PolarRotationMatrix[{\[Xi]_,\[Theta]_,\[Phi]_}]:=EulerRotationMatrix[{\[Phi],\[Theta],\[Xi]}].EulerRotationMatrix[{0,-\[Theta],-\[Phi]}]


RotatePolar[obj_,{\[Xi]_,vec:{_,_,_}},opts___Rule ]:=
RotatePolar[obj,Flatten@{\[Xi],Last@VectorToPolar[vec]},opts]


RotatePolar[vec:{Except[_List],Except[_List],Except[_List]},
	{\[Xi]_, \[Theta]_, \[Phi]_},opts___Rule ]:=
	PolarRotationMatrix[{\[Xi], \[Theta], \[Phi]}].vec


(* ::Input::Initialization:: *)
RotatePolar[obj_List,ang:{_, _, _},opts___]:=
		Map[ 
			RotatePolar[#,ang,opts]&, 
			obj 
		] 


RotatePolar[Graphics3D[obj___],\[CapitalOmega]:{\[Xi]_,\[Theta]_,\[Phi]_}]:=
Graphics3D@GeometricTransformation[Normal@obj,{PolarRotationMatrix[\[CapitalOmega]],{0,0,0}}]


(* ::Input::Initialization:: *)
RotatePolar[obj_,ang:{_, _, _},opts___ ]:=
	obj/; !TrueQ[ Head[obj]==List ]


(* ::Input::Initialization:: *)
End[];
EndPackage[];
