(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Rotations`Quaternion`",{"Global`","SpinDynamica`","Rotations`Polar`","Rotations`Euler`","General`General3D`","General`Miscellaneous`"}];


(* ::Input::Initialization:: *)
PolarToQuaternion::"usage"="PolarToQuaternion[{\[Xi],\[Theta],\[Phi]}] converts a PolarRotation to a unit Quaternion of the form {cos(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(x\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(y\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(z\)]\)sin(\[Xi]/2)} where \!\(\*
StyleBox[\"n\",\nFontWeight->\"Plain\"]\) is the rotation axis.";


(* ::Input::Initialization:: *)
QuaternionToPolar::"usage"="QuaternionToPolar[{q1,q2,q3,q4}] converts a unit Quaternion to polar rotation angles {\[Xi],\[Theta],\[Phi]}. The quaternion is defined {cos(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(x\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(y\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(z\)]\)sin(\[Xi]/2)} where \!\(\*
StyleBox[\"n\",\nFontWeight->\"Plain\"]\) is the rotation axis.";


(* ::Input::Initialization:: *)
QuaternionToEuler::"usage"="QuaternionToEuler[{q1,q2,q3,q4}] converts a unit Quaternion to Euler angles {\[Alpha],\[Beta],\[Gamma]}. The quaternion is defined {cos(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(x\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(y\)]\)sin(\[Xi]/2), \!\(\*SubscriptBox[\(n\), \(z\)]\)sin(\[Xi]/2)} where \!\(\*
StyleBox[\"n\",\nFontWeight->\"Plain\"]\) is the rotation axis.";


(* ::Input::Initialization:: *)
QuaternionProduct::"usage"="QuaternionProduct[q2,q1] calculates products of quaternion representations of rotations.";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
PolarToQuaternion[{\[Xi]_,\[Theta]_,\[Phi]_}]:=
Module[{nvec},(
nvec={Sin[\[Theta]]Cos[\[Phi]],Sin[\[Theta]]Sin[\[Phi]],Cos[\[Theta]]};
Flatten[{Cos[\[Xi]/2],Sin[\[Xi]/2]nvec}]
)];


(* ::Input::Initialization:: *)
QuaternionProduct[q_]:=q


(* ::Input::Initialization:: *)
QuaternionProduct[q2_,q1_]:=
Module[{v1,v2},
v1=q1[[{2,3,4}]];v2=q2[[{2,3,4}]];
Normalize[
Flatten[{q1[[1]] q2[[1]]-v1.v2,v1 q2[[1]]+q1[[1]] v2-v1\[Cross]v2}]
]
];


(* ::Input::Initialization:: *)
QuaternionProduct[qn__,q2_,q1_]:=QuaternionProduct[qn,QuaternionProduct[q2,q1]];


(* ::Input::Initialization:: *)
QuaternionToPolar[{q1_,q2_,q3_,q4_}]:=
Module[{\[Xi],\[Theta],\[Phi],c,s,cth,sth},
c=q1;s=Sqrt[q2^2+q3^2+q4^2];
\[Xi]=2 ArcTan[c,s];
\[Theta]=If[q2==q3==q4==0,
2 ArcCos[q1],
ArcTan[q4,Sqrt[q2^2+q3^2]]
];
\[Phi]=If[q2==q3==0,
0,
ArcTan[q2,q3]
];
{\[Xi],\[Theta],\[Phi]}
];


(* ::Input::Initialization:: *)
QuaternionToEuler[{q1_,q2_,q3_,q4_}]:=AxesToEuler[{ex,ey,ez},RotatePolar[{ex,ey,ez},QuaternionToPolar[{q1,q2,q3,q4}]]]


(* ::Input::Initialization:: *)
End[];
EndPackage[];
