(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["SD`Approximations`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
Temperature::usage="\!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",\nFontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Infinity\",\nFontSlant->\"Italic\"]\) in which case thermalization has no effect.";


(* ::Input::Initialization:: *)
HighTemperatureApproximation::usage="\!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",\nFontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) in which case high-order thermal terms are ignored.";


(* ::Input::Initialization:: *)
HighTemperatureApproximationWarningThreshold::usage="\!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",\nFontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",\nFontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"0.9\",\nFontSlant->\"Italic\"]\). A warning is given if \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) and one of the exponential factors in the Boltzmann distribution is less than this number. The warning may be disabled using \!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"0.\",\nFontSlant->\"Italic\"]\)";


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator::usage="\!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets up a thermal equilibrium density operator under the laboratory frame Hamiltonian \!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)at the specified temperature. The syntax \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)may also be used.
The \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) may include \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"False\",\nFontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\).
";


(* ::Input::Initialization:: *)
ThermalizeSuperoperator::usage=
"\!\(\*
StyleBox[\"ThermalizeSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) corrects the eigenoperators of a superoperator so that a Boltzmann population distribution under the laboratory frame Hamiltonian \!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\) is established at long evolution times. The syntax \!\(\*
StyleBox[\"ThermalizeSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)may also be used. The \!\(\*
StyleBox[\"options\",\nFontSlant->\"Italic\"]\) may include \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"False\",\nFontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"HighTemperatureApproximation\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\).
";


(* ::Input::Initialization:: *)
Secularize::usage=
"\!\(\*
StyleBox[\"Secularize\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"args\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) implements secularization of an operator, meaning the removal of terms that are non-secular with respect to a particular Hamiltonian.
The syntax \!\(\*
StyleBox[\"Secularize\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"H0\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) secularizes the operator \!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\) with respect to the Hamiltonian \!\(\*
StyleBox[\"H0\",\nFontSlant->\"Italic\"]\). This removes all off-diagonal terms in \!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\), when expressed in the eigenbasis of \!\(\*
StyleBox[\"H0\",\nFontSlant->\"Italic\"]\), unless the off-diagonal terms connect degenerate eigenvalues of \!\(\*
StyleBox[\"H0\",\nFontSlant->\"Italic\"]\). The syntax \!\(\*
StyleBox[\"Secularize\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"H0\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"threshold\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) only removes off-diagonal terms if the corresponding eigenvalues differ by more than the numerical \!\(\*
StyleBox[\"threshold\",\nFontSlant->\"Italic\"]\).    
The syntax \!\(\*
StyleBox[\"Secularize\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)secularizes with respect to a Zeeman Hamiltonian in which the sets of spins belong to different isotopic types. If only one list of spins is present, the routine assumes a homonuclear system. 
The syntax \!\(\*
StyleBox[\"Secularize\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) secularizes a superoperator \!\(\*
StyleBox[\"sop\",\nFontSlant->\"Italic\"]\) with respect to a Zeeman Hamiltonian in which the sets of spins \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) belong to different isotopic types. Secularization of a superoperator implies deletion of all matrix elements connecting different sets of coherence orders for the specified spins.
";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Options[ThermalEquilibriumDensityOperator]={HighTemperatureApproximation->True,HighTemperatureApproximationWarningThreshold->0.9,
Temperature->Infinity
};


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator[H\[CapitalTheta]_?OperatorQ,opts___Rule]:=ThermalEquilibriumDensityOperator[H\[CapitalTheta],
Temperature/.{opts}/.Options[ThermalEquilibriumDensityOperator],
opts
];


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator[H\[CapitalTheta]_?OperatorQ,T:Except[_Rule],opts___Rule]:=ThermalEquilibriumDensityOperator[{H\[CapitalTheta],T},opts];


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator[{H\[CapitalTheta]_?OperatorQ,T:Except[_Rule]},opts___Rule]/;!MatchQ[T,(_Symbol|_?NumericQ)]:=(Message[ThermalEquilibriumDensityOperator::badT,T];$Failed);


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator[{H\[CapitalTheta]_?OperatorQ,T:(_Symbol|_?NumericQ)},opts___Rule]:=
Module[{H\[Theta]mat,H\[Theta]evals,H\[Theta]evecs,expfacs,Z,htapprox,htapproxwth,numericH\[Theta]mat,X,Xinv},(
htapprox=HighTemperatureApproximation/.{opts}/.Options[ThermalEquilibriumDensityOperator];
htapproxwth=HighTemperatureApproximationWarningThreshold/.{opts}/.Options[ThermalEquilibriumDensityOperator];
H\[Theta]mat=MatrixRepresentation[H\[CapitalTheta],ZeemanBasis[]];
numericH\[Theta]mat=MatchQ[Normal@Flatten[H\[Theta]mat],{_?NumericQ...}];
{H\[Theta]evals,H\[Theta]evecs}=Eigensystem[H\[Theta]mat];
expfacs=If[htapprox,
(( 1+(-(\[HBar]*#)/(kB*T)))&/@H\[Theta]evals),
(Exp[-(\[HBar]*#)/(kB*T)]&/@H\[Theta]evals)
];
If[numericH\[Theta]mat,expfacs=expfacs/.PhysicalConstantValues];
If[((Or@@((#<htapproxwth)&/@expfacs))&&htapprox),Message[ThermalEquilibriumDensityOperator::highTapproxwarning]
];
Z=Plus@@expfacs;
X=Transpose[Normalize/@H\[Theta]evecs];
Xinv=ConjugateTranspose[X];
Operator[
SparseArray[
X.SparseArray[Band[{1,1}]->expfacs/Z].Xinv
],
ZeemanBasis[]
]
)];


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator::badT="The temperature `1` is invalid.";


(* ::Input::Initialization:: *)
ThermalEquilibriumDensityOperator::highTapproxwarning="The high-temperature approximation may not be valid. Use the option HighTemperatureApproximation\[Rule]False";


(* ::Input::Initialization:: *)
Options[ThermalizeSuperoperator]={HighTemperatureApproximation->True,Temperature->Infinity};


(* ::Input::Initialization:: *)
ThermalizeSuperoperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
ThermalizeSuperoperator[sop_?SuperoperatorQ,H\[CapitalTheta]_?OperatorQ,opts___Rule]:=
ThermalizeSuperoperator[sop,H\[CapitalTheta],
Temperature/.{opts}/.Options[ThermalizeSuperoperator],
opts
];


(* ::Input::Initialization:: *)
ThermalizeSuperoperator[sop_?SuperoperatorQ,H\[CapitalTheta]_?OperatorQ,T:Except[_Rule],opts___Rule]:=ThermalizeSuperoperator[sop,{H\[CapitalTheta],T},opts];


(* ::Input::Initialization:: *)
ThermalizeSuperoperator[sop_?SuperoperatorQ,{H\[CapitalTheta]_?OperatorQ,T:Except[_Rule]},opts___Rule]/;!MatchQ[T,(_Symbol|_?NumericQ)]:=(Message[ThermalizeSuperoperator::badT,T];$Failed);


(* ::Input::Initialization:: *)
ThermalizeSuperoperator[sop_?SuperoperatorQ,{H\[CapitalTheta]_?OperatorQ,T:Except[_Rule]},opts___Rule]:=Module[{n,UnityH,UnityL,\[Rho]eq,\[CapitalTheta],\[CapitalGamma]mat,\[CapitalGamma]\[CapitalTheta]raw,\[CapitalGamma]\[CapitalTheta],BT},
n=BasisDimension[];
UnityH=IdentityMatrix[n,SparseArray];
UnityL=IdentityMatrix[n*n,SparseArray];
\[Rho]eq=MatrixRepresentation[ThermalEquilibriumDensityOperator[H\[CapitalTheta],T,opts],ZeemanBasis[]];
\[CapitalTheta]=
Chop[UnityL-
KroneckerProduct[Flatten[(\[Rho]eq-n^-1 UnityH)],Flatten[UnityH]]];
\[CapitalGamma]mat=N@SuperoperatorMatrixRepresentation[sop,ZeemanKetBraOperatorBasis[]];
\[CapitalGamma]\[CapitalTheta]raw=\[CapitalGamma]mat.\[CapitalTheta];
\[CapitalGamma]\[CapitalTheta]=If[NumericMatrixQ[#/.PhysicalConstantValues],#/.PhysicalConstantValues,#]&@\[CapitalGamma]\[CapitalTheta]raw;
If[OperatorBasis[]=== ZeemanKetBraOperatorBasis[],Superoperator[Simplify[\[CapitalGamma]\[CapitalTheta]],ZeemanKetBraOperatorBasis[],ZeemanBasis[],
SuperoperatorType->None],BT=OperatorBasisTransformationMatrix[OperatorBasis[],ZeemanKetBraOperatorBasis[]];Superoperator[Simplify[BT.\[CapitalGamma]\[CapitalTheta].ConjugateTranspose[BT]],OperatorBasis[],ZeemanBasis[],
SuperoperatorType->None]]
]


(* ::Input::Initialization:: *)
ThermalizeSuperoperator::badT="The temperature `1` is invalid.";


(* ::Input::Initialization:: *)
Secularize[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Secularize[op:Except[_Operator],args___]/;OperatorQ[op]:=
ExpressOperator@Secularize[Operator[op,ZeemanBasis[]],args];


(* ::Input::Initialization:: *)
Secularize[op_Operator]:=Secularize[op,First/@SpinSystem[]];


(* ::Input::Initialization:: *)
Secularize[op_Operator,spin:Except[_List|_?OperatorQ]]:=Secularize[op,{spin}];


(* ::Input::Initialization:: *)
Secularize[op_Operator,spins:{Except[_List]...}]:=Secularize[op,{spins}];


(* ::Input::Initialization:: *)
Secularize[op_Operator,spinsets:{_List..}]:=
Module[{includedspins,missingspins},(
Secularize[op,Append[spinsets,missingspins]]
)/;(
includedspins=Union@@spinsets;
missingspins=Complement[First/@SpinSystem[],includedspins];
!MatchQ[missingspins,{}]
)];


(* ::Input::Initialization:: *)
Secularize[op_Operator,spinsets:{_List..}]:=
Module[{sharedspins},(
Message[Secularize::sharedspins,sharedspins];$Failed)/;(
sharedspins=Switch[spinsets,{_List},{},_,Intersection@@spinsets];
!MatchQ[sharedspins,{}]
)];


(* ::Input::Initialization:: *)
Secularize[op_Operator,spinsets:{_List..}]/;!(And@@(ValidSpinQ/@Flatten[spinsets])):=(Message[Secularize::invalspin];$Failed);


(* ::Input::Initialization:: *)
Secularize[op_Operator,spinsets:{_List..}]:=
Module[{opmatrep},(
opmatrep=MatrixRepresentation[op,ZeemanBasis[]];
Operator[
SparseArray[opmatrep*SecularizationMatrix[spinsets,ZeemanBasis[]]],ZeemanBasis[]
]
)];


(* ::Input::Initialization:: *)
SecularizationMatrix[spinsets:{_List..},zb_ZeemanBasis]:=
SecularizationMatrix[spinsets,zb]=
Module[{Mvals,n},(
Mvals=MagneticQuantumNumber[#,spinsets]&/@BasisKets[zb];
n=BasisDimension[zb];
SparseArray[{{i_,j_}/;Mvals[[i]]==Mvals[[j]]->1},{n,n}]
)];


(* ::Input::Initialization:: *)
Secularize[op_?OperatorQ,H0_?OperatorQ]:=Secularize[op,H0,$ChopThreshold];


(* ::Input::Initialization:: *)
Secularize[op_Operator,H0:Except[_Operator],thresh_?NumericQ]/;OperatorQ[H0]:=
Secularize[op,Operator[H0,Basis[]],thresh];


(* ::Input::Initialization:: *)
Secularize[op_Operator,Operator[H0mat_?MatrixQ,basis_,opts___Rule],thresh_?NumericQ]/;!NumericMatrixQ[H0mat]:=
(Message[Secularize::nonnumH0mat];$Failed);


(* ::Input::Initialization:: *)
Secularize[op_Operator,H0:Operator[H0mat_,basis_,opts___Rule],thresh_?NumericQ]/;!MatchQ[OperatorType[H0],"Hermitian"]:=
(Message[Secularize::nonhermH0];$Failed);


(* ::Input::Initialization:: *)
Secularize[op_Operator,H0:Operator[H0mat_?NumericMatrixQ,basis_,opts___Rule],thresh_?NumericQ]:=
Secularize[op,NDiagonalize[H0],thresh];


(* ::Input::Initialization:: *)
Secularize[op_Operator,H0:Operator[{Xmat_?NumericMatrixQ,evals_List,Xinvmat_?NumericMatrixQ},basis_,opts___Rule],thresh_?NumericQ]:=
Module[{opmatinH0eb,secmat,n},(
opmatinH0eb=Xinvmat.MatrixRepresentation[op,basis].Xmat;
n=Length[evals];
secmat=SparseArray[{{i_,j_}/;Abs[evals[[i]]-evals[[j]]]<=thresh->1},{n,n}];
Operator[
SparseArray[Xmat.(opmatinH0eb*secmat).Xinvmat],
basis,
opts
]
)];


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ]:=Secularize[sop,First/@SpinSystem[]];


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ,spins:{Except[_List]...}]:=Secularize[sop,{spins}];


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ,spinsets:{_List..}]:=
Module[{includedspins,missingspins},(
Secularize[sop,Append[spinsets,missingspins]]
)/;(
includedspins=Union@@spinsets;
missingspins=Complement[First/@SpinSystem[],includedspins];
!MatchQ[missingspins,{}]
)];


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ,spinsets:{_List..}]:=
Module[{sharedspins},(
Message[Secularize::sharedspins,sharedspins];$Failed)/;(
sharedspins=Switch[spinsets,{_List},{},_,Intersection@@spinsets];
!MatchQ[sharedspins,{}]
)];


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ,spinsets:{_List..}]/;!(And@@(ValidSpinQ/@Flatten[spinsets])):=(Message[Secularize::invalspin];$Failed);


(* ::Input::Initialization:: *)
Secularize[sop_?SuperoperatorQ,spinsets:{_List..}]/;!MatchQ[sop,_Superoperator]:=Secularize[Superoperator[sop],spinsets];


(* ::Input::Initialization:: *)
Secularize[sop:HoldPattern@Superoperator[_,opbasis:Except[_ZeemanKetBraOperatorBasis|_ShiftAndZOperatorBasis|_ShiftAndPolarizationOperatorBasis],more___],spinsets:{_List..}]:=
Superoperator[
Secularize[Superoperator[sop,ZeemanKetBraOperatorBasis[]],spinsets],
opbasis,more
];


(* ::Input::Initialization:: *)
Secularize[sop:HoldPattern@Superoperator[_,zsecopbasis:(_ZeemanKetBraOperatorBasis|_ShiftAndZOperatorBasis|_ShiftAndPolarizationOperatorBasis),more___],spinsets:{_List..}]:=
Superoperator[
SparseArray[
SuperoperatorMatrixRepresentation[sop,zsecopbasis]*SecularizationMatrix[spinsets,zsecopbasis]],
zsecopbasis,more
];


(* ::Input::Initialization:: *)
SecularizationMatrix[spinsets:{_List..},zsecopbasis:(_ZeemanKetBraOperatorBasis|_ShiftAndZOperatorBasis|_ShiftAndPolarizationOperatorBasis)]:=
SecularizationMatrix[spinsets,zsecopbasis]=
Module[{pvals,n},(
pvals=CoherenceOrder[spinsets,#]&/@BasisOperators[zsecopbasis];
n=OperatorBasisDimension[zsecopbasis];
SparseArray[{{i_,j_}/;pvals[[i]]==pvals[[j]]->1},{n,n}]
)];


(* ::Input::Initialization:: *)
Secularize::invalspin="One or more of the spins specified in Secularize is not a member of the current SpinSystem";


(* ::Input::Initialization:: *)
Secularize::sharedspins="The spins `1` occur in two or more of the lists of spins used in Secularize. This is illegal."; 


(* ::Input::Initialization:: *)
Secularize::nonnumH0mat="The Hamiltonian used for secularization must have a numeric matrix representation.";


(* ::Input::Initialization:: *)
Secularize::nonhermH0="The Hamiltonian used for secularization must be Hermitian.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];


(* ::Input::Initialization:: *)
$RecursionLimit=1000;



