(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Tensors`CG`",{"Global`","SpinDynamica`","General`Miscellaneous`"}];


(* ::Input::Initialization:: *)
CG::usage = "CG[{j3,m3},{j1,m1},{j2,m2}] generates a Clebsch-Gordan coefficient, ordered as in VMK. CG[{j3},{j1,m1},{j2,m2}] generates CG[{j3,m1+m2},{j1,m1},{j2,m2}]. If m3 != m1+m2, the result 0 is returned.";


(* ::Input::Initialization:: *)
Begin["`Private`"]; 


(* ::Input::Initialization:: *)
CG[{j3_}, {j1_, m1_}, {j2_, m2_}] := 
  CG[{j3, m1 + m2}, {j1, m1}, {j2, m2}];


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; m3 != m1 + m2;


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; Abs[m3] > j3;


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; Abs[m1] > j1;


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; Abs[m2] > j2;


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; j3 > j1 + j2;


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
  0 /; j3 < Abs[j1 - j2];


(* ::Input::Initialization:: *)
CG[{2,0},{1,-1},{1,1}]=1/Sqrt[6];


(* ::Input::Initialization:: *)
CG[{2,0},{1,1},{1,-1}]=1/Sqrt[6];


(* ::Input::Initialization:: *)
CG[{j3_, m3_}, {j1_, m1_}, {j2_, m2_}] := 
CG[{j3, m3}, {j1, m1}, {j2, m2}]=
  ClebschGordan[{j1, m1}, {j2, m2}, {j3, m3}];


(* ::Input::Initialization:: *)
End[]; 
EndPackage[]; 
