(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   2428871,      72314]
NotebookOptionsPosition[   2408631,      71772]
NotebookOutlinePosition[   2409324,      71797]
CellTagsIndexPosition[   2409281,      71794]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Ensemble`Orientations`", "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602722223223877`*^9, 3.460272225390361*^9}, {
  3.6916785501878033`*^9, 3.691678568483028*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Ensemble`OrientationalSampling`\>\"", ",", "\n", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\"\<SpinDynamica`\>\"", ",", 
      "\"\<General`Miscellaneous`\>\""}], "}"}]}], "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448289235920735*^9, {3.4602722330945053`*^9, 3.4602722362516947`*^9}, {
   3.460273697793598*^9, 3.460273720305148*^9}, {3.460291686125058*^9, 
   3.460291701080093*^9}, 3.4602926127581863`*^9, {3.5645982614127493`*^9, 
   3.5645982623847*^9}, {3.564599077305564*^9, 3.5645990822635393`*^9}, {
   3.6916785554330053`*^9, 3.691678560095928*^9}, 3.703838518665182*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["usages", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingScheme", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"OrientationalSamplingScheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)lists all available orientational sampling schemes. \
\!\(\*
StyleBox[\"OrientationalSamplingScheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"name\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)returns the information associated with a particular \
scheme.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
   3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
   3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
   3.460272286215179*^9, 3.460272390193995*^9}, 3.4602724937424803`*^9, {
   3.460278055144457*^9, 3.4602780569269323`*^9}, {3.460278175912383*^9, 
   3.46027824119464*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "::", "usage"}], "=", 
   "\"\<\!\(\*
StyleBox[\"DefineOrientationalSamplingScheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"name\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"specifications\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)or \!\(\*
StyleBox[\"DefineOrientationalSamplingScheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"name\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"info\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"specifications\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)defines an orientational sampling scheme with a \
certain name, and (optional) associated information. \!\(\*
StyleBox[\"specifications\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"may\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"be\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"a\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"set\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"of\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"Euler\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"angles\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"and\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"weights\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"of\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"the\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"form\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"\[Alpha]\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"\[Beta]\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"\[Gamma]\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"w\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"where\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"the\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"weights\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"must\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"sum\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"to\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"1.\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"specifications\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"may\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"also\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"be\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"a\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"function\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"returning\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"a\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"set\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"of\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"Euler\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"angles\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"and\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"weights\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"when\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"evaluated\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"with\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"certain\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"parameters\",
FontSlant->\"Plain\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Plain\"]\)\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602788296373587`*^9, 3.460278870565485*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Orientations", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"Orientations\",
FontSlant->\"Italic\"]\)[name]\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates the orientations for a named orientational \
sampling scheme.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
  3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
  3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
  3.460272286215179*^9, 3.4602724717978888`*^9}, {3.460272506020211*^9, 
  3.4602725317442503`*^9}, {3.460278186792935*^9, 3.460278187165533*^9}, {
  3.464101556982376*^9, 3.464101581958153*^9}, {3.529689499902581*^9, 
  3.5296895033985023`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationsAndWeights", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)name\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates the orientations and weights for a named \
orientational sampling scheme.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
  3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
  3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
  3.460272286215179*^9, 3.4602724717978888`*^9}, {3.460272506020211*^9, 
  3.4602725317442503`*^9}, {3.460278186792935*^9, 3.460278187165533*^9}, {
  3.464101556982376*^9, 3.46410156061558*^9}, {3.529689497343298*^9, 
  3.529689506883696*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationWeights", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"OrientationWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"name\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates the weights for a named orientational \
sampling scheme.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
  3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
  3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
  3.460272286215179*^9, 3.4602724717978888`*^9}, {3.460272506020211*^9, 
  3.4602725317442503`*^9}, {3.460278186792935*^9, 3.460278187165533*^9}, {
  3.464101556982376*^9, 3.46410156061558*^9}, {3.484926862324006*^9, 
  3.484926866035277*^9}, {3.484927044979623*^9, 3.484927088440959*^9}, {
  3.529689476103072*^9, 3.5296895474062777`*^9}, {3.529689623450451*^9, 
  3.5296896268070393`*^9}, {3.529689883286812*^9, 3.5296898955072613`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BetaAnglesAndWeights", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"BetaAnglesAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)name\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates the set of \[Beta] angles and weights for a \
named orientational sampling scheme.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
  3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
  3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
  3.460272286215179*^9, 3.4602724717978888`*^9}, {3.460272506020211*^9, 
  3.4602725317442503`*^9}, {3.460278186792935*^9, 3.460278187165533*^9}, {
  3.464101556982376*^9, 3.46410156061558*^9}, {3.529689497343298*^9, 
  3.529689506883696*^9}, {3.565096579433676*^9, 3.565096594179636*^9}},
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["begin", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602725398987923`*^9, 3.460272540518383*^9}},
 AspectRatioFixed->True],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["code", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602725398987923`*^9, 3.4602725484789124`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["initialize", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, {3.460272722732334*^9, 3.460272743820037*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefinedOrientationalSamplingSchemes", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460272737206304*^9, 3.4602727386853237`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingSchemeInformation", "[", "_", "]"}], ":=", 
   "None"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460277670335085*^9, 3.460277680998599*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Internal routines", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, {3.460274161866753*^9, 3.460274170775972*^9}, {
   3.460274305931553*^9, 3.460274308353593*^9}}],

Cell[CellGroupData[{

Cell["ValidWeightsQ", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, {3.460274161866753*^9, 3.460274170775972*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidWeightsQ", "[", 
    RowBox[{"oss", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
       "..."}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Chop", "@", 
     RowBox[{"N", "[", 
      RowBox[{
       RowBox[{"Plus", "@@", 
        RowBox[{"(", 
         RowBox[{"Last", "/@", "oss"}], ")"}]}], "-", "1"}], "]"}]}], 
    "\[Equal]", "0"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274175162959*^9, 3.460274225294422*^9}, {
  3.460274597105299*^9, 3.4602745993020678`*^9}, {3.4602747303997583`*^9, 
  3.4602747398939323`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["CorrectWeights", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, {3.460274161866753*^9, 3.460274170775972*^9}, {
   3.460293813141621*^9, 3.460293818322217*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrectWeights", "[", 
    RowBox[{"oss", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
       "..."}], "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"euler", ",", "weights", ",", "sum"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"euler", ",", "weights"}], "}"}], "=", 
        RowBox[{"Transpose", "[", "oss", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"sum", "=", 
        RowBox[{"Plus", "@@", "weights"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{"euler", ",", 
          RowBox[{"weights", "/", "sum"}]}], "}"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274175162959*^9, 3.460274225294422*^9}, {
  3.460274597105299*^9, 3.4602745993020678`*^9}, {3.4602747303997583`*^9, 
  3.4602747398939323`*^9}, {3.460293821896873*^9, 3.460293922947812*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["OrientationalSamplingSchemeInformation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, {3.460274161866753*^9, 3.460274170775972*^9}, {
   3.460293813141621*^9, 3.460293818322217*^9}, {3.5650975051086187`*^9, 
   3.565097539338002*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "OrientationalSamplingSchemeInformation", "[", "name_String", "]"}], ":=", 
   
   RowBox[{"OrientationalSamplingSchemeInformation", "[", 
    RowBox[{"name", ",", "OrientationalSamplingScheme"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565097517899962*^9, 3.5650975364711027`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrientationalSamplingSchemeInformation", "[", 
   RowBox[{"name_String", ",", 
    RowBox[{"OrientationsAndWeights", "|", "Orientations"}]}], "]"}], ":=", 
  RowBox[{"OrientationalSamplingSchemeInformation", "[", 
   RowBox[{"name", ",", "OrientationalSamplingScheme"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.565097583046586*^9, 3.5650975935359707`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["DefineOrientationalSamplingScheme", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{3.460272560401037*^9}],

Cell[CellGroupData[{

Cell["handle duplicates", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279217377275*^9, 3.460279224840102*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{"name_String", ",", "info___String", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
         "..."}], "}"}], "|", "_Function"}], ")"}]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOrientationalSamplingScheme", "::", "dup"}], ",", 
       "name"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"DefinedOrientationalSamplingSchemes", "=", 
      RowBox[{"Cases", "[", 
       RowBox[{"DefinedOrientationalSamplingSchemes", ",", 
        RowBox[{"Except", "[", "name", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"DefineOrientationalSamplingScheme", "[", 
      RowBox[{"name", ",", "info", ",", "specs"}], "]"}], ";"}], 
    "\[IndentingNewLine]", ")"}], "/;", 
   RowBox[{"MemberQ", "[", 
    RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602728573027773`*^9, 3.460272934506414*^9}, {
   3.460272989664455*^9, 3.460273042146502*^9}, {3.460274481139575*^9, 
   3.460274481976612*^9}, {3.460276317050761*^9, 3.460276327216551*^9}, {
   3.4602777109347343`*^9, 3.460277836770494*^9}, 3.460278918606798*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["explicit schemes", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279217377275*^9, 3.460279235136798*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name__String", ",", "info_", ",", 
     RowBox[{"oss", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
        "..."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"DefineOrientationalSamplingScheme", "::", "badweights"}], 
        ",", "name"}], "]"}], ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ValidWeightsQ", "[", "oss", "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274246048587*^9, 3.460274315732871*^9}, 
   3.460277845205529*^9, {3.565097271438212*^9, 3.5650972733714237`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name__String", ",", "info_String", ",", 
     RowBox[{"oss", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
        "..."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name", ",", 
     RowBox[{"{", 
      RowBox[{"info", ",", "info"}], "}"}], ",", "oss"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460277920471348*^9, 3.46027796158528*^9}, {
  3.5650973044595137`*^9, 3.565097364751771*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name__String", ",", 
     RowBox[{"{", 
      RowBox[{"geninfo_String", ",", "\[Beta]info_String"}], "}"}], ",", 
     RowBox[{"oss", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
        "..."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"OrientationalSamplingSchemeInformation", "[", 
       RowBox[{"name", ",", "OrientationalSamplingScheme"}], "]"}], "=", 
      "geninfo"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OrientationalSamplingSchemeInformation", "[", 
       RowBox[{"name", ",", "BetaAnglesAndWeights"}], "]"}], "=", 
      "\[Beta]info"}], ";", "\[IndentingNewLine]", 
     RowBox[{"DefineOrientationalSamplingScheme", "[", 
      RowBox[{"name", ",", "oss"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460277920471348*^9, 3.46027796158528*^9}, {
   3.5650973044595137`*^9, 3.5650973209614162`*^9}, {3.565097371114579*^9, 
   3.565097457316291*^9}, 3.565097603733758*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name__String", ",", 
     RowBox[{"oss", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_", ",", "_"}], "}"}], ",", "_"}], "}"}], 
        "..."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"OrientationsAndWeights", "[", "name", "]"}], "=", "oss"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"DefinedOrientationalSamplingSchemes", "=", 
      RowBox[{"Sort", "@", 
       RowBox[{"Append", "[", 
        RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], 
        "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOrientationalSamplingScheme", "::", "def"}], ",", 
       "name", ",", 
       RowBox[{"Length", "[", "oss", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "name"}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460272564738982*^9, 3.460272655513257*^9}, {
   3.4602727521379747`*^9, 3.4602728683451157`*^9}, {3.4602729247637167`*^9, 
   3.460272926427753*^9}, 3.460274329601832*^9, {3.460275057421899*^9, 
   3.460275058438711*^9}, {3.460277853790967*^9, 3.460277885541821*^9}, {
   3.460277969861878*^9, 3.460277976747478*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["functions", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279217377275*^9, 3.460279246681548*^9}}],

Cell["\<\
define a scheme by a function which may operate on a set of parameters. The \
patterns which the function may operate on are specified in the definition.\
\>", "Text",
 CellChangeTimes->{{3.565095100954966*^9, 3.565095129147233*^9}, {
  3.565098133178361*^9, 3.565098140300065*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{"name__String", ",", "info_String", ",", 
    RowBox[{"{", 
     RowBox[{"f_Function", ",", 
      RowBox[{"{", "patterns___", "}"}]}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{"name", ",", 
    RowBox[{"{", 
     RowBox[{"info", ",", "info"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"f", ",", 
      RowBox[{"{", "patterns", "}"}]}], "}"}]}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460277920471348*^9, 3.46027796158528*^9}, {
  3.565095776621875*^9, 3.565095794411044*^9}, {3.565098003743657*^9, 
  3.565098036756757*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name__String", ",", 
     RowBox[{"{", 
      RowBox[{"geninfo_String", ",", "\[Beta]info_String"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"f_Function", ",", 
       RowBox[{"{", "patterns___", "}"}]}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"OrientationalSamplingSchemeInformation", "[", "name", "]"}], 
      "=", "geninfo"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OrientationalSamplingSchemeInformation", "[", 
       RowBox[{"name", ",", "BetaAnglesAndWeights"}], "]"}], "=", 
      "\[Beta]info"}], ";", "\[IndentingNewLine]", 
     RowBox[{"DefineOrientationalSamplingScheme", "[", 
      RowBox[{"name", ",", 
       RowBox[{"{", 
        RowBox[{"f", ",", 
         RowBox[{"{", "patterns", "}"}]}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460277920471348*^9, 3.46027796158528*^9}, {
  3.565095776621875*^9, 3.565095794411044*^9}, {3.5650980566143923`*^9, 
  3.565098107040234*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "[", 
    RowBox[{"name_String", ",", 
     RowBox[{"{", 
      RowBox[{"f_Function", ",", 
       RowBox[{"{", "patterns___", "}"}]}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"OrientationsAndWeights", "[", 
       RowBox[{"name", ",", "pars___"}], "]"}], ":=", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"{", "pars", "}"}], ",", 
          RowBox[{"{", "patterns", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"f", "[", "pars", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"OrientationalSamplingScheme", "::", "badsyntax"}], ",", 
            "name"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "OrientationalSamplingSchemeInformation", "[", "name", "]"}], 
           "]"}], ";", "\[IndentingNewLine]", "$Failed"}], ")"}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BetaAnglesAndWeights", "[", 
       RowBox[{"name", ",", "pars___"}], "]"}], ":=", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"{", "pars", "}"}], ",", 
          RowBox[{"{", "patterns", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"#", "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{
            "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
           "}"}], "&"}], "/@", 
         RowBox[{"OrientationsAndWeights", "[", 
          RowBox[{"name", ",", "pars"}], "]"}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"OrientationalSamplingScheme", "::", "badsyntax"}], ",", 
            "name"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"OrientationalSamplingSchemeInformation", "[", 
            RowBox[{"name", ",", "BetaAnglesAndWeights"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", "$Failed"}], ")"}]}], "\[IndentingNewLine]", 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"DefinedOrientationalSamplingSchemes", "=", 
      RowBox[{"Sort", "@", 
       RowBox[{"Append", "[", 
        RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], 
        "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOrientationalSamplingScheme", "::", "fdef"}], ",", 
       "name"}], "]"}], ";", "\[IndentingNewLine]", "name"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460272564738982*^9, 3.460272655513257*^9}, {
   3.4602727521379747`*^9, 3.4602728683451157`*^9}, {3.4602729247637167`*^9, 
   3.460272926427753*^9}, 3.460274329601832*^9, {3.460275057421899*^9, 
   3.460275058438711*^9}, {3.460276413254879*^9, 3.460276423669497*^9}, {
   3.4602765320785418`*^9, 3.4602765453338547`*^9}, {3.4602767141120358`*^9, 
   3.46027674010326*^9}, {3.460277195830283*^9, 3.460277246680386*^9}, {
   3.565093811363826*^9, 3.565093813546338*^9}, {3.5650938506626673`*^9, 
   3.565093852758791*^9}, {3.565093931999393*^9, 3.565093936239881*^9}, {
   3.565093972823936*^9, 3.565094085090908*^9}, {3.5650942790553713`*^9, 
   3.565094282781167*^9}, 3.5650943585762672`*^9, {3.565094514937725*^9, 
   3.5650945410825977`*^9}, {3.5650948626765127`*^9, 3.565094880633223*^9}, {
   3.5650951462567797`*^9, 3.5650951519033546`*^9}, {3.5650952089637413`*^9, 
   3.565095222517067*^9}, {3.565095468302683*^9, 3.565095469010515*^9}, {
   3.565095669810294*^9, 3.565095672230894*^9}, {3.565095799168005*^9, 
   3.5650958069848423`*^9}, {3.565096392454356*^9, 3.5650964145866623`*^9}, {
   3.565097732250566*^9, 3.565097754067012*^9}, 3.565098305267358*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279217377275*^9, 3.460279246681548*^9}, {
  3.460279284190044*^9, 3.4602792852363*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "::", "def"}], "=", 
   "\"\<OrientationalSamplingScheme `1` with dimension `2` defined.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602726583036003`*^9, 3.460272688546011*^9}, {
  3.460274379786927*^9, 3.460274381008194*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "::", "fdef"}], "=", 
   "\"\<The OrientationalSamplingScheme function `1` has been defined.\>\""}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602726583036003`*^9, 3.460272688546011*^9}, {
  3.460274379786927*^9, 3.460274381008194*^9}, {3.460276751568371*^9, 
  3.460276795281309*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "::", "dup"}], "=", 
   "\"\<OrientationalSamplingScheme `1` is already defined. It is being \
superseded.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602726583036003`*^9, 3.460272688546011*^9}, {
  3.460272907521892*^9, 3.46027290789579*^9}, {3.460272941180785*^9, 
  3.460272982739914*^9}, {3.460274382280788*^9, 3.460274383368477*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOrientationalSamplingScheme", "::", "badweights"}], "=", 
   "\"\<The weights for OrientationalSamplingScheme  `1` do not sum to 1. The \
scheme has not been defined.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602726583036003`*^9, 3.460272688546011*^9}, {
  3.460272907521892*^9, 3.46027290789579*^9}, {3.460272941180785*^9, 
  3.460272982739914*^9}, {3.460274348128643*^9, 3.4602743884250603`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OrientationalSamplingScheme", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{3.460272560401037*^9, 3.4602730858142567`*^9, 
  3.4602731372316647`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingScheme", "[", "]"}], ":=", 
   "DefinedOrientationalSamplingSchemes"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460273376022352*^9, 3.4602733885272923`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingScheme", "[", "name_String", "]"}], ":=", 
   RowBox[{"OrientationalSamplingSchemeInformation", "[", "name", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460273376022352*^9, 3.4602733885272923`*^9}, {
  3.460277630853455*^9, 3.4602776455885077`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingScheme", "::", "undef"}], "=", 
   "\"\<OrientationalSamplingScheme `1` is undefined. The defined schemes are \
given below.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460273142279992*^9, 3.460273168904532*^9}, {
  3.460274390928856*^9, 3.460274393032889*^9}, {3.464101707531176*^9, 
  3.464101742987672*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationalSamplingScheme", "::", "badsyntax"}], "=", 
   "\"\<Incorrect syntax for the OrientationalSamplingScheme `1`\>\""}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.565094331537376*^9, 3.5650943519167643`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Orientations", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{3.460272560401037*^9, 3.4602730858142567`*^9, 
  3.464101675243718*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Orientations", "[", "]"}], ":=", 
   RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4641018709350853`*^9, 3.464101886845029*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Orientations", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}]}],
    ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OrientationalSamplingScheme", "::", "undef"}], ",", "name"}], 
      "]"}], ";", 
     RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602730931965313`*^9, 3.46027312527877*^9}, {
   3.460273176398323*^9, 3.460273200459354*^9}, {3.4602791787229548`*^9, 
   3.460279181623557*^9}, 3.4641016790469847`*^9, 3.4641017315290813`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Orientations", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"MemberQ", "[", 
     RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}], ":=", 
   RowBox[{"First", "/@", 
    RowBox[{"OrientationsAndWeights", "[", 
     RowBox[{"name", ",", "pars"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464101811283513*^9, 3.464101853868391*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["OrientationWeights", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{
  3.460272560401037*^9, 3.4602730858142567`*^9, 3.464101675243718*^9, {
   3.4849269065352697`*^9, 3.484926907701516*^9}, {3.529689901968647*^9, 
   3.5296899035911007`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationWeights", "[", "]"}], ":=", 
   RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4641018709350853`*^9, 3.464101886845029*^9}, 
   3.4849269110425797`*^9, 3.529689922830103*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OrientationWeights", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}]}],
    ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OrientationalSamplingScheme", "::", "undef"}], ",", "name"}], 
      "]"}], ";", 
     RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602730931965313`*^9, 3.46027312527877*^9}, {
   3.460273176398323*^9, 3.460273200459354*^9}, {3.4602791787229548`*^9, 
   3.460279181623557*^9}, 3.4641016790469847`*^9, 3.4641017315290813`*^9, 
   3.4849269123473463`*^9, 3.529689925642941*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OrientationWeights", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"MemberQ", "[", 
     RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}], ":=", 
   RowBox[{"Last", "/@", 
    RowBox[{"OrientationsAndWeights", "[", 
     RowBox[{"name", ",", "pars"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464101811283513*^9, 3.464101853868391*^9}, {
   3.484926916555105*^9, 3.484926919368218*^9}, 3.5296899286861687`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["OrientationsAndWeights", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{3.460272560401037*^9, 3.4602730858142567`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrientationsAndWeights", "[", "]"}], ":=", 
   RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.464101895124037*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OrientationsAndWeights", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}]}],
    ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OrientationalSamplingScheme", "::", "undef"}], ",", "name"}], 
      "]"}], ";", 
     RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602730931965313`*^9, 3.46027312527877*^9}, {
   3.460273176398323*^9, 3.460273200459354*^9}, {3.4602791787229548`*^9, 
   3.460279181623557*^9}, 3.464101733439631*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BetaAnglesAndWeights", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{3.460272560401037*^9, 3.4602730858142567`*^9, 
  3.565096622667554*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BetaAnglesAndWeights", "[", "]"}], ":=", 
   RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.464101895124037*^9, 3.565096624760408*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BetaAnglesAndWeights", "[", 
     RowBox[{"name_String", ",", "pars___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{"DefinedOrientationalSamplingSchemes", ",", "name"}], "]"}]}]}],
    ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OrientationalSamplingScheme", "::", "undef"}], ",", "name"}], 
      "]"}], ";", 
     RowBox[{"OrientationalSamplingScheme", "[", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4602730931965313`*^9, 3.46027312527877*^9}, {
   3.460273176398323*^9, 3.460273200459354*^9}, {3.4602791787229548`*^9, 
   3.460279181623557*^9}, 3.464101733439631*^9, 3.565096629275077*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["precoded schemes", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602725398987923`*^9, 3.4602725484789124`*^9}, {
  3.460273264294984*^9, 3.4602732679571543`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["turn off messages temporarily", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.460274870860118*^9, 3.460274879763316*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{
    RowBox[{"DefineOrientationalSamplingScheme", "::", "\"\<def\>\""}], ",", 
    RowBox[{"DefineOrientationalSamplingScheme", "::", "\"\<fdef\>\""}]}], 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274900547738*^9, 3.460274909342626*^9}, {
  3.4602789658533707`*^9, 3.460278970004386*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["angle stepping", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.46027685134127*^9, 3.460276854403571*^9}}],

Cell[CellGroupData[{

Cell["Step\[Beta]", "Subsection",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{"\"\<Step\[Beta]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Step\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Beta]min\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Beta]max\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of n Sin\[Beta]-weighted \
orientations {\[Alpha],\[Beta],\[Gamma]}, with \[Alpha] and \[Gamma] equal to \
0, and with \[Beta] stepping linearly over the specified range.\>\"", ",", 
      "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"BetaAnglesAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Step\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Beta]min\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Beta]max\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of n suitably weighted \[Beta] \
angles, with \[Beta] stepping linearly over the specified range.\>\""}], 
     "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "\[Beta]range"}], "}"}], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[Delta]\[Beta]", ",", "\[Beta]min", ",", "\[Beta]max", ",", 
             "\[Beta]vals", ",", "weights"}], "}"}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Beta]min", ",", "\[Beta]max"}], "}"}], "=", 
              "\[Beta]range"}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[Delta]\[Beta]", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"\[Beta]max", "-", "\[Beta]min"}], ")"}], "/", 
               "n"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[Beta]vals", "=", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"\[Beta]min", "+", 
                 RowBox[{"\[Delta]\[Beta]", "/", "2"}]}], ",", 
                RowBox[{"\[Beta]max", "-", 
                 RowBox[{"\[Delta]\[Beta]", "/", "2"}]}], ",", 
                "\[Delta]\[Beta]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"weights", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"Sin", "/@", "\[Beta]vals"}], ")"}], "/", 
               RowBox[{"Plus", "@@", 
                RowBox[{"(", 
                 RowBox[{"Sin", "/@", "\[Beta]vals"}], ")"}]}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"N", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "#1", ",", "0"}], "}"}], ",", "#2"}], 
                  "}"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Beta]vals", ",", "weights"}], "}"}]}], "]"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], "]"}], "\[IndentingNewLine]", 
         ")"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"_Integer", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460276900289605*^9, 3.460276991931246*^9}, {
   3.460277105836618*^9, 3.460277141919392*^9}, {3.460278517807992*^9, 
   3.4602785502169*^9}, {3.502932405175446*^9, 3.5029324582366533`*^9}, {
   3.5029326057668333`*^9, 3.502932623156657*^9}, {3.502932758028805*^9, 
   3.502932759373074*^9}, {3.565093751030034*^9, 3.565093754683607*^9}, {
   3.5650937854746647`*^9, 3.565093788874495*^9}, {3.565094122237438*^9, 
   3.565094139413023*^9}, 3.565094456772181*^9, {3.5650952697519484`*^9, 
   3.5650952951500483`*^9}, 3.5650954180377483`*^9, {3.565096053282732*^9, 
   3.565096070832172*^9}, {3.565096497493318*^9, 3.5650964981314793`*^9}, {
   3.5650978054449797`*^9, 3.5650978372737226`*^9}, {3.565098492905604*^9, 
   3.565098497840034*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Step\[Alpha]\[Beta]", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.460277386638401*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Step\[Alpha]\[Beta]\>\"", ",", "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Step\[Alpha]\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\[Alpha]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\[Beta]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of n Sin\[Beta]-weighted \
orientations {\[Alpha],\[Beta],\[Gamma]}, with \[Gamma] equal to 0, with \
\[Alpha] stepping over the range [0,2\[Pi]] in \!\(\*
StyleBox[\"n\[Alpha]\",
FontSlant->\"Italic\"]\) steps, and \!\(\*
StyleBox[\"\[Beta]\",
FontSlant->\"Italic\"]\) stepping over the range [0,\[Pi]] in \!\(\*
StyleBox[\"n\[Beta]\",
FontSlant->\"Italic\"]\) steps. \>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n\[Alpha]", ",", "n\[Beta]"}], "}"}], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[Delta]\[Alpha]", ",", "\[Alpha]min", ",", "\[Alpha]max", ",", 
             "\[Delta]\[Beta]", ",", "\[Beta]min", ",", "\[Beta]max", ",", 
             "\[Alpha]vals", ",", "\[Beta]vals", ",", "\[CapitalOmega]vals", 
             ",", "weights"}], "}"}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Alpha]min", ",", "\[Alpha]max"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"2", "\[Pi]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Beta]min", ",", "\[Beta]max"}], "}"}], "=", 
              RowBox[{"{", 
               RowBox[{"0", ",", "\[Pi]"}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Delta]\[Alpha]", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"\[Alpha]max", "-", "\[Alpha]min"}], ")"}], "/", 
               "n\[Alpha]"}]}], ";", 
             RowBox[{"\[Delta]\[Beta]", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"\[Beta]max", "-", "\[Beta]min"}], ")"}], "/", 
               "n\[Beta]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[Beta]vals", "=", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"\[Beta]min", "+", 
                 RowBox[{"\[Delta]\[Beta]", "/", "2"}]}], ",", 
                RowBox[{"\[Beta]max", "-", 
                 RowBox[{"\[Delta]\[Beta]", "/", "2"}]}], ",", 
                "\[Delta]\[Beta]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[Alpha]vals", "=", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"\[Alpha]min", "+", 
                 RowBox[{"\[Delta]\[Alpha]", "/", "2"}]}], ",", 
                RowBox[{"\[Alpha]max", "-", 
                 RowBox[{"\[Delta]\[Alpha]", "/", "2"}]}], ",", 
                "\[Delta]\[Alpha]"}], "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"\[CapitalOmega]vals", "=", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Outer", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"#1", ",", "#2", ",", "0"}], "}"}], "&"}], ",", 
                  "\[Alpha]vals", ",", "\[Beta]vals"}], "]"}], ",", "1"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"weights", "=", 
              RowBox[{"Module", "[", 
               RowBox[{
                RowBox[{"{", "sin\[Beta]vals", "}"}], ",", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"sin\[Beta]vals", "=", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Sin", "[", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "]"}], "&"}], "/@", 
                    "\[CapitalOmega]vals"}], ")"}]}], ";", 
                  RowBox[{"sin\[Beta]vals", "/", 
                   RowBox[{"Plus", "@@", "sin\[Beta]vals"}]}]}], ")"}]}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"N", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"#1", ",", "#2"}], "}"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[CapitalOmega]vals", ",", "weights"}], "}"}]}], 
               "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}], 
         "\[IndentingNewLine]", ")"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"_Integer", ",", "_Integer"}], "}"}]}], "\[IndentingNewLine]", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460276900289605*^9, 3.460276991931246*^9}, {
   3.460277105836618*^9, 3.460277141919392*^9}, {3.460277388223406*^9, 
   3.460277547392455*^9}, {3.4602785573927517`*^9, 3.46027861908244*^9}, 
   3.460279062959243*^9, {3.5029324847724123`*^9, 3.5029325565497293`*^9}, {
   3.502932631964118*^9, 3.5029326322750063`*^9}, {3.502932751178321*^9, 
   3.5029327527144003`*^9}, {3.5650958649669533`*^9, 
   3.5650958922368183`*^9}, {3.565096091438367*^9, 3.565096102547914*^9}, 
   3.5650965033088827`*^9, {3.565098538538659*^9, 3.565098539277524*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["random schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.46027685134127*^9, 3.460276854403571*^9}, {
  3.460287493274057*^9, 3.460287495856118*^9}}],

Cell[CellGroupData[{

Cell["Random\[Beta]", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460287499786024*^9, 3.460287500696727*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{"\"\<Random\[Beta]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Random\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates a set of n uniformly weighted {\[Alpha],\
\[Beta],\[Gamma]} orientations, with \[Alpha] and \[Gamma] equal to 0, and \
randomly chosen \[Beta] angles in the range [0,\[Pi]]. \>\"", ",", 
      "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"BetaAnglesAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Random\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of n randomly chosen \[Beta] angles \
in the range [0,\[Pi]].\>\""}], "\[IndentingNewLine]", "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", "n", "}"}], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\[Beta]vals", ",", "weights"}], "}"}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Beta]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"ArcCos", "[", 
                 RowBox[{"RandomReal", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}], "]"}], ",", 
                
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"weights", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"1", "/", "n"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"N", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "#1", ",", "0"}], "}"}], ",", "#2"}], 
                  "}"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Beta]vals", ",", "weights"}], "}"}]}], "]"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], "]"}], "\[IndentingNewLine]", 
         ")"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "_Integer", "}"}]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460276900289605*^9, 3.460276991931246*^9}, {
   3.460277105836618*^9, 3.460277141919392*^9}, {3.460278517807992*^9, 
   3.4602785502169*^9}, {3.460287505893591*^9, 3.460287636840165*^9}, {
   3.502932584909726*^9, 3.5029325988663883`*^9}, {3.5029326437324953`*^9, 
   3.502932649267413*^9}, 3.502932737087757*^9, {3.565095918060524*^9, 
   3.565095935064396*^9}, {3.5650960200089397`*^9, 3.5650960382615337`*^9}, {
   3.565096284642659*^9, 3.565096301563589*^9}, 3.5650965083117228`*^9, {
   3.565097854561364*^9, 3.565097886420403*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Random\[Alpha]\[Beta]", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460287499786024*^9, 3.460287500696727*^9}, {
  3.460287649764307*^9, 3.460287650114542*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Random\[Alpha]\[Beta]\>\"", ",", "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Random\[Alpha]\[Beta]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of uniformly weighted {\[Alpha],\
\[Beta],\[Gamma]} orientations, with \[Gamma] equal to 0, while the \[Alpha] \
and \[Beta] angles are chosen randomly in the range [0,2\[Pi]] for \[Alpha] \
and [0,\[Pi]] for \[Beta]. \>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", "n", "}"}], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\[Alpha]vals", ",", "\[Beta]vals", ",", "weights"}], 
            "}"}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Alpha]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"RandomReal", "[", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   RowBox[{"2", "\[Pi]"}]}], "}"}], "]"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Beta]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"ArcCos", "[", 
                 RowBox[{"RandomReal", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}], "]"}], ",", 
                
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"weights", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"1", "/", "n"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"N", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"#1", ",", "#2", ",", "0"}], "}"}], ",", "#3"}], 
                  "}"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\[Alpha]vals", ",", "\[Beta]vals", ",", "weights"}],
                  "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}], 
         "\[IndentingNewLine]", ")"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "_Integer", "}"}]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460276900289605*^9, 3.460276991931246*^9}, {
   3.460277105836618*^9, 3.460277141919392*^9}, {3.460278517807992*^9, 
   3.4602785502169*^9}, {3.460287505893591*^9, 3.4602877631423683`*^9}, 
   3.460287816824122*^9, {3.5029326632358227`*^9, 3.5029326903408833`*^9}, 
   3.502932743220304*^9, {3.565095940787302*^9, 3.5650959546093884`*^9}, {
   3.565096142154168*^9, 3.565096173935252*^9}, {3.565096277228557*^9, 
   3.5650963077246637`*^9}, 3.565096513106503*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Random\[Alpha]\[Beta]\[Gamma]", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460287499786024*^9, 3.460287500696727*^9}, {
  3.460287649764307*^9, 3.460287650114542*^9}, {3.460287783060828*^9, 
  3.4602877833563347`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Random\[Alpha]\[Beta]\[Gamma]\>\"", ",", "\[IndentingNewLine]", 
    "\"\<\!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"Random\[Alpha]\[Beta]\[Gamma]\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a set of uniformly weighted {\[Alpha],\
\[Beta],\[Gamma]} orientations, with \[Alpha] and \[Gamma] randomly chosen in \
the range [0,2\[Pi]], and \[Beta] randomly chosen in the range [0,\[Pi]]. \
\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", "n", "}"}], ",", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\[Alpha]vals", ",", "\[Beta]vals", ",", "\[Gamma]vals", ",", 
             "weights"}], "}"}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Alpha]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"RandomReal", "[", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   RowBox[{"2", "\[Pi]"}]}], "}"}], "]"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Beta]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"ArcCos", "[", 
                 RowBox[{"RandomReal", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], "]"}], "]"}], ",", 
                
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Gamma]vals", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"RandomReal", "[", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", 
                   RowBox[{"2", "\[Pi]"}]}], "}"}], "]"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"weights", "=", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"1", "/", "n"}], ",", 
                RowBox[{"{", "n", "}"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"N", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"#1", ",", "#2", ",", "#3"}], "}"}], ",", "#4"}], 
                  "}"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\[Alpha]vals", ",", "\[Beta]vals", ",", "\[Gamma]vals", ",",
                   "weights"}], "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], "]"}], "\[IndentingNewLine]", ")"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", "_Integer", "}"}]}], "\[IndentingNewLine]", "}"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460276900289605*^9, 3.460276991931246*^9}, {
   3.460277105836618*^9, 3.460277141919392*^9}, {3.460278517807992*^9, 
   3.4602785502169*^9}, {3.460287505893591*^9, 3.4602878508415327`*^9}, {
   3.502932700842765*^9, 3.502932734991953*^9}, {3.5650959698652554`*^9, 
   3.565095984455489*^9}, {3.5650962121979628`*^9, 3.565096268892832*^9}, 
   3.5650965182107058`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}}],

Cell[CellGroupData[{

Cell["ZCW50", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW50\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 50 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW50\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38230076757951`", ",", "2.85779854438147`", ",", 
          "0.879645943005142`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76460153515902`", ",", "2.73887681200913`", ",", 
          "1.75929188601028`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14690230273853`", ",", "2.6466585272489`", ",", 
          "2.63893782901543`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52920307031804`", ",", "2.5680795491667`", ",", 
          "3.51858377202057`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.628318530717959`", ",", "2.49809154479651`", ",", 
          "4.39822971502571`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01061929829747`", ",", "2.43410944181045`", ",", 
          "5.27787565803085`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39292006587698`", ",", "2.37459864572793`", ",", 
          "6.15752160103599`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77522083345649`", ",", "2.31855896145482`", ",", 
          "0.75398223686155`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15752160103599`", ",", "2.26529459242145`", ",", 
          "1.63362817986669`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25663706143592`", ",", "2.21429743558818`", ",", 
          "2.51327412287183`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63893782901543`", ",", "2.16518212679596`", ",", 
          "3.39292006587698`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02123859659494`", ",", "2.11764727749084`", ",", 
          "4.27256600888212`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40353936417444`", ",", "2.07145103919948`", ",", 
          "5.15221195188726`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.502654824574367`", ",", "2.02639500019072`", ",", 
          "6.0318578948924`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88495559215388`", ",", "1.98231317286238`", ",", 
          "0.628318530717959`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26725635973338`", ",", "1.93906422023154`", ",", 
          "1.5079644737231`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64955712731289`", ",", "1.89652581408953`", ",", 
          "2.38761041672824`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0318578948924`", ",", "1.85459043600322`", ",", 
          "3.26725635973338`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13097335529233`", ",", "1.81316217783386`", ",", 
          "4.14690230273853`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51327412287183`", ",", "1.77215424758523`", ",", 
          "5.02654824574367`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89557489045134`", ",", "1.73148697974681`", ",", 
          "5.90619418874881`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27787565803085`", ",", "1.69108620918968`", ",", 
          "0.502654824574367`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.376991118430775`", ",", "1.65088190682856`", ",", 
          "1.38230076757951`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75929188601028`", ",", "1.61080700114889`", ",", 
          "2.26194671058465`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5238934211693`", ",", "1.53078565244091`", ",", 
          "4.02123859659494`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90619418874881`", ",", "1.49071074676124`", ",", 
          "4.90088453960008`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00530964914873`", ",", "1.45050644440011`", ",", 
          "5.78053048260522`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38761041672824`", ",", "1.41010567384299`", ",", 
          "0.376991118430775`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76991118430775`", ",", "1.36943840600457`", ",", 
          "1.25663706143592`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15221195188726`", ",", "1.32843047575593`", ",", 
          "2.13628300444106`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.251327412287183`", ",", "1.28700221758657`", ",", 
          "3.0159289474462`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63362817986669`", ",", "1.24506683950027`", ",", 
          "3.89557489045134`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0159289474462`", ",", "1.20252843335826`", ",", 
          "4.77522083345649`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39822971502571`", ",", "1.15927948072741`", ",", 
          "5.65486677646163`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78053048260522`", ",", "1.11519765339907`", ",", 
          "0.251327412287183`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.879645943005142`", ",", "1.07014161439031`", ",", 
          "1.13097335529233`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26194671058465`", ",", "1.02394537609895`", ",", 
          "2.01061929829747`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64424747816416`", ",", "0.976410526793834`", ",", 
          "2.89026524130261`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02654824574367`", ",", "0.927295218001612`", ",", 
          "3.76991118430775`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.125663706143592`", ",", "0.876298061168341`", ",", 
          "4.64955712731289`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5079644737231`", ",", "0.823033692134976`", ",", 
          "5.52920307031804`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89026524130261`", ",", "0.766994007861867`", ",", 
          "0.125663706143592`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27256600888212`", ",", "0.707483211779343`", ",", 
          "1.00530964914873`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65486677646163`", ",", "0.643501108793284`", ",", 
          "1.88495559215388`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.75398223686155`", ",", "0.573513104423097`", ",", 
          "2.76460153515902`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13628300444106`", ",", "0.494934126340896`", ",", 
          "3.64424747816416`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51858377202057`", ",", "0.402715841580662`", ",", 
          "4.5238934211693`"}], "}"}], ",", "0.02`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90088453960008`", ",", "0.283794109208328`", ",", 
          "5.40353936417444`"}], "}"}], ",", "0.02`"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.502932780256019*^9, 3.502932800408209*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW144", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW144\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 144 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW144\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.00694444444444444`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31256125889249`", ",", "2.97473248036856`", ",", 
          "0.479965544298441`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62512251778497`", ",", "2.90534134760502`", ",", 
          "0.959931088596881`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.654498469497874`", ",", "2.85190565959267`", ",", 
          "1.43989663289532`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96705972839036`", ",", "2.80669649515041`", ",", 
          "1.91986217719376`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27962098728285`", ",", "2.76672354414384`", ",", 
          "2.3998277214922`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30899693899575`", ",", "2.73045479126745`", ",", 
          "2.87979326579064`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62155819788823`", ",", "2.69698103179664`", ",", 
          "3.35975881008908`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93411945678072`", ",", "2.66571040392938`", ",", 
          "3.83972435438752`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96349540849362`", ",", "2.63623214330564`", ",", 
          "4.31968989868597`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27605666738611`", ",", "2.60824740467914`", ",", 
          "4.79965544298441`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.305432619099008`", ",", "2.58153074089797`", ",", 
          "5.27962098728285`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61799387799149`", ",", "2.55590711013264`", ",", 
          "5.75958653158129`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93055513688398`", ",", "2.53123738523663`", ",", 
          "6.23955207587973`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.959931088596881`", ",", "2.50740881276575`", ",", 
          "0.436332312998582`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27249234748937`", ",", "2.48432850034428`", ",", 
          "0.916297857297023`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58505360638185`", ",", "2.46191883468155`", ",", 
          "1.39626340159546`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61442955809475`", ",", "2.44011417383607`", ",", 
          "1.8762289458939`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92699081698724`", ",", "2.41885840577638`", ",", 
          "2.35619449019234`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23955207587973`", ",", "2.39810311117543`", ",", 
          "2.83616003449079`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26892802759263`", ",", "2.37780615719196`", ",", 
          "3.31612557878923`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58148928648512`", ",", "2.357930604792`", ",", 
          "3.79609112308767`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.610865238198015`", ",", "2.33844384820293`", ",", 
          "4.27605666738611`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9234264970905`", ",", "2.3193169289451`", ",", 
          "4.75602221168455`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23598775598299`", ",", "2.30052398302186`", ",", 
          "5.23598775598299`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26536370769589`", ",", "2.28204179098074`", ",", 
          "5.71595330028143`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57792496658838`", ",", "2.26384940837487`", ",", 
          "6.19591884457987`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89048622548086`", ",", "2.24592785973193`", ",", 
          "0.392699081698724`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91986217719376`", ",", "2.22825988317654`", ",", 
          "0.872664625997165`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23242343608625`", ",", "2.21082971581666`", ",", 
          "1.35263017029561`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.261799387799149`", ",", "2.1936229122069`", ",", 
          "1.83259571459405`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57436064669164`", ",", "2.17662618985701`", ",", 
          "2.31256125889249`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88692190558412`", ",", "2.15982729701117`", ",", 
          "2.79252680319093`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.916297857297023`", ",", "2.14321489888772`", ",", 
          "3.27249234748937`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22885911618951`", ",", "2.12677847931544`", ",", 
          "3.75245789178781`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.541420375082`", ",", "2.1105082552851`", ",", 
          "4.23242343608625`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5707963267949`", ",", "2.0943951023932`", ",", 
          "4.71238898038469`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88335758568738`", ",", "2.07843048951828`", ",", 
          "5.19235452468313`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19591884457987`", ",", "2.06260642136034`", ",", 
          "5.67232006898157`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22529479629277`", ",", "2.04691538770669`", ",", 
          "6.15228561328001`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53785605518526`", ",", "2.03135031847622`", ",", 
          "0.349065850398866`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.567232006898157`", ",", "2.01590454374724`", ",", 
          "0.829031394697307`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87979326579064`", ",", "2.00057175809942`", ",", 
          "1.30899693899575`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19235452468313`", ",", "1.98534598870322`", ",", 
          "1.78896248329419`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22173047639603`", ",", "1.97022156667549`", ",", 
          "2.26892802759263`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53429173528852`", ",", "1.95519310129054`", ",", 
          "2.74889357189107`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.846852994181`", ",", "1.94025545669467`", ",", 
          "3.22885911618951`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8762289458939`", ",", "1.92540373082181`", ",", 
          "3.70882466048795`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18879020478639`", ",", "1.91063323624902`", ",", 
          "4.18879020478639`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.218166156499291`", ",", "1.89593948276579`", ",", 
          "4.66875574908483`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53072741539178`", ",", "1.88131816146066`", ",", 
          "5.14872129338327`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84328867428426`", ",", "1.86676513015383`", ",", 
          "5.62868683768171`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.872664625997165`", ",", "1.85227640002574`", ",", 
          "6.10865238198015`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18522588488965`", ",", "1.83784812331035`", ",", 
          "0.305432619099008`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49778714378214`", ",", "1.82347658193698`", ",", 
          "0.785398163397448`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52716309549504`", ",", "1.80915817701867`", ",", 
          "1.26536370769589`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83972435438752`", ",", "1.79488941909627`", ",", 
          "1.74532925199433`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15228561328001`", ",", "1.78066691905763`", ",", 
          "2.22529479629277`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18166156499291`", ",", "1.76648737966014`", ",", 
          "2.70526034059121`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4942228238854`", ",", "1.75234758759198`", ",", 
          "3.18522588488965`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.523598775598299`", ",", "1.73824440601459`", ",", 
          "3.66519142918809`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83616003449079`", ",", "1.72417476753379`", ",", 
          "4.14515697348653`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14872129338327`", ",", "1.71013566755267`", ",", 
          "4.62512251778497`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17809724509617`", ",", "1.69612415796296`", ",", 
          "5.10508806208341`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49065850398866`", ",", "1.68213734113586`", ",", 
          "5.58505360638185`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80321976288115`", ",", "1.66817236417601`", ",", 
          "6.0650191506803`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83259571459405`", ",", "1.65422641340551`", ",", 
          "0.261799387799149`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14515697348653`", ",", "1.64029670904683`", ",", 
          "0.74176493209759`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.174532925199433`", ",", "1.62638050007581`", ",", 
          "1.22173047639603`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48709418409192`", ",", "1.61247505921747`", ",", 
          "1.70169602069447`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79965544298441`", ",", "1.59857767805869`", ",", 
          "2.18166156499291`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.829031394697307`", ",", "1.58468566225319`", ",", 
          "2.66162710929135`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45415391248228`", ",", "1.55690699133661`", ",", 
          "3.62155819788823`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48352986419518`", ",", "1.5430149755311`", ",", 
          "4.10152374218667`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79609112308767`", ",", "1.52911759437232`", ",", 
          "4.58148928648512`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10865238198015`", ",", "1.51521215351398`", ",", 
          "5.06145483078356`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13802833369305`", ",", "1.50129594454297`", ",", 
          "5.541420375082`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45058959258554`", ",", "1.48736624018428`", ",", 
          "6.02138591938044`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.479965544298441`", ",", "1.47342028941378`", ",", 
          "0.218166156499291`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79252680319093`", ",", "1.45945531245393`", ",", 
          "0.698131700797732`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10508806208341`", ",", "1.44546849562683`", ",", 
          "1.17809724509617`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13446401379631`", ",", "1.43145698603713`", ",", 
          "1.65806278939461`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4470252726888`", ",", "1.417417886056`", ",", 
          "2.13802833369305`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75958653158129`", ",", "1.40334824757521`", ",", 
          "2.61799387799149`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78896248329419`", ",", "1.38924506599781`", ",", 
          "3.09795942228993`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10152374218667`", ",", "1.37510527392966`", ",", 
          "3.57792496658838`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.130899693899575`", ",", "1.36092573453216`", ",", 
          "4.05789051088682`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44346095279206`", ",", "1.34670323449353`", ",", 
          "4.53785605518526`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75602221168455`", ",", "1.33243447657112`", ",", 
          "5.0178215994837`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.785398163397448`", ",", "1.31811607165282`", ",", 
          "5.49778714378214`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09795942228993`", ",", "1.30374453027945`", ",", 
          "5.97775268808058`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41052068118242`", ",", "1.28931625356405`", ",", 
          "0.174532925199433`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43989663289532`", ",", "1.27482752343597`", ",", 
          "0.654498469497874`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75245789178781`", ",", "1.26027449212913`", ",", 
          "1.13446401379631`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0650191506803`", ",", "1.24565317082401`", ",", 
          "1.61442955809475`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0943951023932`", ",", "1.23095941734077`", ",", 
          "2.0943951023932`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40695636128568`", ",", "1.21618892276798`", ",", 
          "2.57436064669164`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.436332312998582`", ",", "1.20133719689513`", ",", 
          "3.05432619099008`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74889357189107`", ",", "1.18639955229926`", ",", 
          "3.53429173528852`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06145483078356`", ",", "1.1713710869143`", ",", 
          "4.01425727958696`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09083078249646`", ",", "1.15624666488657`", ",", 
          "4.4942228238854`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40339204138894`", ",", "1.14102089549037`", ",", 
          "4.97418836818384`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71595330028143`", ",", "1.12568810984255`", ",", 
          "5.45415391248228`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74532925199433`", ",", "1.11024233511357`", ",", 
          "5.93411945678072`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05789051088682`", ",", "1.0946772658831`", ",", 
          "0.130899693899575`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0872664625997165`", ",", "1.07898623222945`", ",", 
          "0.610865238198015`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3998277214922`", ",", "1.06316216407152`", ",", 
          "1.09083078249646`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71238898038469`", ",", "1.0471975511966`", ",", 
          "1.5707963267949`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.74176493209759`", ",", "1.03108439830469`", ",", 
          "2.05076187109334`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05432619099008`", ",", "1.01481417427435`", ",", 
          "2.53072741539178`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36688744988256`", ",", "0.998377754702076`", ",", 
          "3.01069295969022`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39626340159546`", ",", "0.981765356578623`", ",", 
          "3.49065850398866`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70882466048795`", ",", "0.964966463732785`", ",", 
          "3.9706240482871`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02138591938044`", ",", "0.947969741382894`", ",", 
          "4.45058959258554`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05076187109334`", ",", "0.930762937773129`", ",", 
          "4.93055513688398`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36332312998582`", ",", "0.913332770413253`", ",", 
          "5.41052068118242`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.392699081698724`", ",", "0.895664793857865`", ",", 
          "5.89048622548086`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70526034059121`", ",", "0.877743245214924`", ",", 
          "0.0872664625997165`"}], "}"}], ",", "0.00694444444444444`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0178215994837`", ",", "0.859550862609055`", ",", 
          "0.567232006898157`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0471975511966`", ",", "0.84106867056793`", ",", 
          "1.0471975511966`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35975881008908`", ",", "0.822275724644695`", ",", 
          "1.52716309549504`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67232006898157`", ",", "0.803148805386866`", ",", 
          "2.00712863979348`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70169602069447`", ",", "0.783662048797798`", ",", 
          "2.48709418409192`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01425727958696`", ",", "0.763786496397832`", ",", 
          "2.96705972839036`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0436332312998582`", ",", "0.743489542414359`", ",", 
          "3.4470252726888`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35619449019234`", ",", "0.722734247813416`", ",", 
          "3.92699081698724`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66875574908483`", ",", "0.701478479753722`", ",", 
          "4.40695636128568`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.698131700797732`", ",", "0.679673818908244`", ",", 
          "4.88692190558412`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01069295969022`", ",", "0.657264153245516`", ",", 
          "5.36688744988256`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32325421858271`", ",", "0.634183840824041`", ",", 
          "5.846852994181`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35263017029561`", ",", "0.610355268353167`", ",", 
          "0.0436332312998582`"}], "}"}], ",", "0.00694444444444444`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66519142918809`", ",", "0.585685543457151`", ",", 
          "0.523598775598299`"}], "}"}], ",", "0.00694444444444444`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97775268808058`", ",", "0.560061912691825`", ",", 
          "1.00356431989674`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00712863979348`", ",", "0.533345248910654`", ",", 
          "1.48352986419518`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31968989868597`", ",", "0.505360510284157`", ",", 
          "1.96349540849362`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.349065850398866`", ",", "0.475882249660417`", ",", 
          "2.44346095279206`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66162710929135`", ",", "0.444611621793151`", ",", 
          "2.9234264970905`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97418836818384`", ",", "0.411137862322348`", ",", 
          "3.40339204138894`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00356431989674`", ",", "0.374869109445956`", ",", 
          "3.88335758568738`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31612557878923`", ",", "0.334896158439379`", ",", 
          "4.36332312998582`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62868683768171`", ",", "0.289686993997119`", ",", 
          "4.84328867428426`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65806278939461`", ",", "0.236251305984771`", ",", 
          "5.32325421858271`"}], "}"}], ",", "0.00694444444444444`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9706240482871`", ",", "0.16686017322123`", ",", 
          "5.80321976288115`"}], "}"}], ",", "0.00694444444444444`"}], 
       "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.502932824998726*^9, 3.502932830215323*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW200", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460292373397011*^9, 3.460292374819386*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW200\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 200 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW200\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48185819633594`", ",", "3.00005318026537`", ",", 
          "0.91106186954104`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96371639267187`", ",", "2.94125781126667`", ",", 
          "1.82212373908208`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16238928182822`", ",", "2.8960271360745`", ",", 
          "2.73318560862312`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64424747816416`", ",", "2.85779854438147`", ",", 
          "3.64424747816416`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1261056745001`", ",", "2.82403222429827`", ",", 
          "4.5553093477052`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32477856365645`", ",", "2.79342663231683`", ",", 
          "5.46637121724624`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80663675999238`", ",", "2.76520917127206`", ",", 
          "0.0942477796076938`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00530964914873`", ",", "2.73887681200913`", ",", 
          "1.00530964914873`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48716784548467`", ",", "2.71408038864492`", ",", 
          "1.91637151868977`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96902604182061`", ",", "2.69056584179353`", ",", 
          "2.82743338823081`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16769893097696`", ",", "2.66814149631773`", ",", 
          "3.73849525777185`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64955712731289`", ",", "2.6466585272489`", ",", 
          "4.64955712731289`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.848230016469244`", ",", "2.6259986473437`", ",", 
          "5.56061899685393`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33008821280518`", ",", "2.60606599927541`", ",", 
          "0.188495559215388`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81194640914112`", ",", "2.58678162060972`", ",", 
          "1.09955742875643`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01061929829747`", ",", "2.5680795491667`", ",", 
          "2.01061929829747`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4924774946334`", ",", "2.54990401116325`", ",", 
          "2.92168116783851`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.691150383789755`", ",", "2.532207345559`", ",", 
          "3.83274303737955`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17300858012569`", ",", "2.51494844194905`", ",", 
          "4.74380490692059`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65486677646163`", ",", "2.49809154479651`", ",", 
          "5.65486677646163`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85353966561798`", ",", "2.48160532420229`", ",", 
          "0.282743338823081`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33539786195391`", ",", "2.46546214402913`", ",", 
          "1.19380520836412`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.534070751110265`", ",", "2.44963747846348`", ",", 
          "2.10486707790516`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0159289474462`", ",", "2.43410944181045`", ",", 
          "3.0159289474462`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49778714378214`", ",", "2.41885840577638`", ",", 
          "3.92699081698724`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69646003293849`", ",", "2.40386668513654`", ",", 
          "4.83805268652828`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17831822927443`", ",", "2.38911827742646`", ",", 
          "5.74911455606932`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.376991118430775`", ",", "2.37459864572793`", ",", 
          "0.376991118430775`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85884931476671`", ",", "2.36029453614107`", ",", 
          "1.28805298797182`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34070751110265`", ",", "2.34619382340565`", ",", 
          "2.19911485751286`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.539380400259`", ",", "2.33228537954253`", ",", 
          "3.1101767270539`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02123859659494`", ",", "2.31855896145482`", ",", 
          "4.02123859659494`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.219911485751286`", ",", "2.30500511424826`", ",", 
          "4.93230046613598`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70176968208722`", ",", "2.29161508766499`", ",", 
          "5.84336233567702`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18362787842316`", ",", "2.27838076352025`", ",", 
          "0.471238898038469`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38230076757951`", ",", "2.26529459242145`", ",", 
          "1.38230076757951`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86415896391545`", ",", "2.25234953835801`", ",", 
          "2.29336263712055`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0628318530717959`", ",", "2.23953902999727`", ",", 
          "3.20442450666159`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54469004940773`", ",", "2.22685691771982`", ",", 
          "4.11548637620263`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02654824574367`", ",", "2.21429743558818`", ",", 
          "5.02654824574367`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22522113490002`", ",", "2.20185516757292`", ",", 
          "5.93761011528471`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70707933123596`", ",", "2.18952501746715`", ",", 
          "0.565486677646163`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18893752757189`", ",", "2.17730218200798`", ",", 
          "1.4765485471872`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38761041672824`", ",", "2.16518212679596`", ",", 
          "2.38761041672824`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86946861306418`", ",", "2.15316056466364`", ",", 
          "3.29867228626928`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06814150222053`", ",", "2.14123343619482`", ",", 
          "4.20973415581032`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54999969855647`", ",", "2.1293968921377`", ",", 
          "5.12079602535136`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0318578948924`", ",", "2.11764727749084`", ",", 
          "6.0318578948924`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23053078404875`", ",", "2.1059811170705`", ",", 
          "0.659734457253856`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71238898038469`", ",", "2.0943951023932`", ",", 
          "1.5707963267949`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.91106186954104`", ",", "2.08288607972904`", ",", 
          "2.48185819633594`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39292006587698`", ",", "2.07145103919948`", ",", 
          "3.39292006587698`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87477826221291`", ",", "2.06008710480901`", ",", 
          "4.30398193541802`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07345115136926`", ",", "2.04879152531385`", ",", 
          "5.21504380495906`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5553093477052`", ",", "2.03756166584219`", ",", 
          "6.1261056745001`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.75398223686155`", ",", "2.02639500019072`", ",", 
          "0.75398223686155`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23584043319749`", ",", "2.01528910373072`", ",", 
          "1.66504410640259`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71769862953342`", ",", "2.00424164686478`", ",", 
          "2.57610597594363`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91637151868977`", ",", "1.99325038898165`", ",", 
          "3.48716784548467`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39822971502571`", ",", "1.98231317286238`", ",", 
          "4.39822971502571`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.596902604182061`", ",", "1.97142791949627`", ",", 
          "5.30929158456675`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.078760800518`", ",", "1.96059262326916`", ",", 
          "6.22035345410779`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56061899685393`", ",", "1.94980534749085`", ",", 
          "0.848230016469244`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75929188601028`", ",", "1.93906422023154`", ",", 
          "1.75929188601028`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24115008234622`", ",", "1.92836743044041`", ",", 
          "2.67035375555132`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.439822971502571`", ",", "1.91771322432206`", ",", 
          "3.58141562509236`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92168116783851`", ",", "1.90709990194888`", ",", 
          "4.4924774946334`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40353936417444`", ",", "1.89652581408953`", ",", 
          "5.40353936417444`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60221225333079`", ",", "1.88598935923562`", ",", 
          "0.0314159265358979`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08407044966673`", ",", "1.87548898081029`", ",", 
          "0.942477796076938`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.282743338823081`", ",", "1.86502316454388`", ",", 
          "1.85353966561798`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76460153515902`", ",", "1.85459043600322`", ",", 
          "2.76460153515902`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24645973149495`", ",", "1.84418935826237`", ",", 
          "3.67566340470006`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4451326206513`", ",", "1.83381852970337`", ",", 
          "4.5867252742411`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92699081698724`", ",", "1.82347658193698`", ",", 
          "5.49778714378214`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.125663706143592`", ",", "1.81316217783386`", ",", 
          "0.125663706143592`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60752190247953`", ",", "1.80287400965761`", ",", 
          "1.03672557568463`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08938009881547`", ",", "1.79261079729169`", ",", 
          "1.94778744522567`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28805298797182`", ",", "1.78237128655299`", ",", 
          "2.85884931476671`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76991118430775`", ",", "1.77215424758523`", ",", 
          "3.76991118430775`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25176938064369`", ",", "1.76195847332596`", ",", 
          "4.68097305384879`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45044226980004`", ",", "1.75178277804144`", ",", 
          "5.59203492338983`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93230046613598`", ",", "1.741625995924`", ",", 
          "0.219911485751286`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13097335529233`", ",", "1.73148697974681`", ",", 
          "1.13097335529233`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61283155162826`", ",", "1.72136459957158`", ",", 
          "2.04203522483337`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0946897479642`", ",", "1.71125774150475`", ",", 
          "2.95309709437441`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29336263712055`", ",", "1.70116530649804`", ",", 
          "3.86415896391545`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77522083345649`", ",", "1.69108620918968`", ",", 
          "4.77522083345649`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.973893722612836`", ",", "1.68101937678264`", ",", 
          "5.68628270299753`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45575191894877`", ",", "1.67096374795646`", ",", 
          "0.314159265358979`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93761011528471`", ",", "1.66091827180949`", ",", 
          "1.22522113490002`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13628300444106`", ",", "1.65088190682856`", ",", 
          "2.13628300444106`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.618141200777`", ",", "1.64085361988295`", ",", 
          "3.0473448739821`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.816814089933346`", ",", "1.63083238524018`", ",", 
          "3.95840674352314`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29867228626928`", ",", "1.62081718360067`", ",", 
          "4.86946861306418`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78053048260522`", ",", "1.61080700114889`", ",", 
          "5.78053048260522`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97920337176157`", ",", "1.60080082861837`", ",", 
          "0.408407044966673`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46106156809751`", ",", "1.59079766036829`", ",", 
          "1.31946891450771`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.659734457253856`", ",", "1.58079649346906`", ",", 
          "2.23053078404875`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62345084992573`", ",", "1.56079616012073`", ",", 
          "4.05265452313083`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82212373908208`", ",", "1.55079499322151`", ",", 
          "4.96371639267187`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30398193541802`", ",", "1.54079182497142`", ",", 
          "5.87477826221291`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.502654824574367`", ",", "1.53078565244091`", ",", 
          "0.502654824574367`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9845130209103`", ",", "1.52077546998913`", ",", 
          "1.41371669411541`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46637121724624`", ",", "1.51076026834962`", ",", 
          "2.32477856365645`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66504410640259`", ",", "1.50073903370685`", ",", 
          "3.23584043319749`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14690230273853`", ",", "1.49071074676124`", ",", 
          "4.14690230273853`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.345575191894877`", ",", "1.4806743817803`", ",", 
          "5.05796417227957`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82743338823081`", ",", "1.47062890563334`", ",", 
          "5.96902604182061`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30929158456675`", ",", "1.46057327680715`", ",", 
          "0.596902604182061`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5079644737231`", ",", "1.45050644440011`", ",", 
          "1.5079644737231`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98982267005904`", ",", "1.44042734709175`", ",", 
          "2.41902634326414`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.188495559215388`", ",", "1.43033491208504`", ",", 
          "3.33008821280518`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67035375555132`", ",", "1.42022805401821`", ",", 
          "4.24115008234622`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15221195188726`", ",", "1.41010567384299`", ",", 
          "5.15221195188726`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35088484104361`", ",", "1.39996665766579`", ",", 
          "6.0632738214283`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83274303737955`", ",", "1.38980987554835`", ",", 
          "0.691150383789755`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0314159265358979`", ",", "1.37963418026384`", ",", 
          "1.60221225333079`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51327412287183`", ",", "1.36943840600457`", ",", 
          "2.51327412287183`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99513231920777`", ",", "1.3592213670368`", ",", 
          "3.42433599241287`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19380520836412`", ",", "1.3489818562981`", ",", 
          "4.33539786195391`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67566340470006`", ",", "1.33871864393218`", ",", 
          "5.24645973149495`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15752160103599`", ",", "1.32843047575593`", ",", 
          "6.15752160103599`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35619449019234`", ",", "1.31811607165282`", ",", 
          "0.785398163397448`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83805268652828`", ",", "1.30777412388643`", ",", 
          "1.69646003293849`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03672557568463`", ",", "1.29740329532742`", ",", 
          "2.60752190247953`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51858377202057`", ",", "1.28700221758657`", ",", 
          "3.51858377202057`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00044196835651`", ",", "1.27656948904591`", ",", 
          "4.42964564156161`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19911485751286`", ",", "1.2661036727795`", ",", 
          "5.34070751110265`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68097305384879`", ",", "1.25560329435417`", ",", 
          "6.25176938064369`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.879645943005142`", ",", "1.24506683950027`", ",", 
          "0.879645943005142`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36150413934108`", ",", "1.23449275164092`", ",", 
          "1.79070781254618`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84336233567702`", ",", "1.22387942926773`", ",", 
          "2.70176968208722`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04203522483337`", ",", "1.21322522314939`", ",", 
          "3.61283155162826`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5238934211693`", ",", "1.20252843335826`", ",", 
          "4.5238934211693`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.722566310325652`", ",", "1.19178730609895`", ",", 
          "5.43495529071034`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20442450666159`", ",", "1.18100003032064`", ",", 
          "0.0628318530717959`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68628270299753`", ",", "1.17016473409352`", ",", 
          "0.973893722612836`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88495559215388`", ",", "1.15927948072741`", ",", 
          "1.88495559215388`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36681378848981`", ",", "1.14834226460814`", ",", 
          "2.79601746169492`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.565486677646163`", ",", "1.13735100672501`", ",", 
          "3.70707933123596`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0473448739821`", ",", "1.12630354985908`", ",", 
          "4.618141200777`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52920307031804`", ",", "1.11519765339907`", ",", 
          "5.52920307031804`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72787595947439`", ",", "1.1040309877476`", ",", 
          "0.15707963267949`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20973415581032`", ",", "1.09280112827594`", ",", 
          "1.06814150222053`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.408407044966673`", ",", "1.08150554878078`", ",", 
          "1.97920337176157`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89026524130261`", ",", "1.07014161439031`", ",", 
          "2.89026524130261`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37212343763855`", ",", "1.05870657386075`", ",", 
          "3.80132711084365`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5707963267949`", ",", "1.0471975511966`", ",", 
          "4.71238898038469`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05265452313083`", ",", "1.0356115365193`", ",", 
          "5.62345084992573`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.251327412287183`", ",", "1.02394537609895`", ",", 
          "0.251327412287183`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73318560862312`", ",", "1.0121957614521`", ",", 
          "1.16238928182822`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21504380495906`", ",", "1.00035921739497`", ",", 
          "2.07345115136926`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41371669411541`", ",", "0.988432088926153`", ",", 
          "2.9845130209103`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89557489045134`", ",", "0.976410526793834`", ",", 
          "3.89557489045134`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0942477796076938`", ",", "0.96429047158181`", ",", 
          "4.80663675999238`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57610597594363`", ",", "0.952067636122646`", ",", 
          "5.71769862953342`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05796417227957`", ",", "0.939737486016875`", ",", 
          "0.345575191894877`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25663706143592`", ",", "0.927295218001612`", ",", 
          "1.25663706143592`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73849525777185`", ",", "0.914735735869974`", ",", 
          "2.16769893097696`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22035345410779`", ",", "0.902053623592525`", ",", 
          "3.078760800518`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41902634326414`", ",", "0.88924311523178`", ",", 
          "3.98982267005904`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90088453960008`", ",", "0.876298061168341`", ",", 
          "4.90088453960008`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09955742875643`", ",", "0.863211890069541`", ",", 
          "5.81194640914112`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58141562509236`", ",", "0.849977565924807`", ",", 
          "0.439822971502571`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0632738214283`", ",", "0.836587539341538`", ",", 
          "1.35088484104361`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26194671058465`", ",", "0.823033692134976`", ",", 
          "2.26194671058465`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74380490692059`", ",", "0.809307274047263`", ",", 
          "3.17300858012569`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.942477796076938`", ",", "0.795398830184144`", ",", 
          "4.08407044966673`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42433599241287`", ",", "0.781298117448725`", ",", 
          "4.99513231920777`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90619418874881`", ",", "0.766994007861867`", ",", 
          "5.90619418874881`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10486707790516`", ",", "0.752474376163337`", ",", 
          "0.534070751110265`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5867252742411`", ",", "0.737725968453249`", ",", 
          "1.4451326206513`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.785398163397448`", ",", "0.722734247813416`", ",", 
          "2.35619449019234`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26725635973338`", ",", "0.707483211779343`", ",", 
          "3.26725635973338`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74911455606932`", ",", "0.691955175126317`", ",", 
          "4.17831822927443`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94778744522567`", ",", "0.676130509560661`", ",", 
          "5.08938009881547`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42964564156161`", ",", "0.659987329387498`", ",", 
          "6.00044196835651`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.628318530717959`", ",", "0.643501108793284`", ",", 
          "0.628318530717959`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1101767270539`", ",", "0.626644211640741`", ",", 
          "1.539380400259`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59203492338983`", ",", "0.609385308030795`", ",", 
          "2.45044226980004`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79070781254618`", ",", "0.591688642426544`", ",", 
          "3.36150413934108`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27256600888212`", ",", "0.573513104423097`", ",", 
          "4.27256600888212`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.471238898038469`", ",", "0.554811032980072`", ",", 
          "5.18362787842316`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95309709437441`", ",", "0.535526654314388`", ",", 
          "6.0946897479642`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43495529071034`", ",", "0.515594006246091`", ",", 
          "0.722566310325652`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63362817986669`", ",", "0.494934126340896`", ",", 
          "1.63362817986669`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11548637620263`", ",", "0.473451157272066`", ",", 
          "2.54469004940773`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.314159265358979`", ",", "0.451026811796262`", ",", 
          "3.45575191894877`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79601746169492`", ",", "0.42751226494487`", ",", 
          "4.36681378848981`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27787565803085`", ",", "0.402715841580662`", ",", 
          "5.27787565803085`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4765485471872`", ",", "0.376383482317728`", ",", 
          "6.18893752757189`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95840674352314`", ",", "0.348166021272961`", ",", 
          "0.816814089933346`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.15707963267949`", ",", "0.317560429291521`", ",", 
          "1.72787595947439`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63893782901543`", ",", "0.283794109208328`", ",", 
          "2.63893782901543`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12079602535136`", ",", "0.245565517515292`", ",", 
          "3.54999969855647`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31946891450771`", ",", "0.20033484232312`", ",", 
          "4.46106156809751`"}], "}"}], ",", "0.005`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80132711084365`", ",", "0.141539473324427`", ",", 
          "5.37212343763855`"}], "}"}], ",", "0.005`"}], "}"}]}], "}"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460292382114345*^9, 3.460292412194936*^9}, {
   3.502932840529814*^9, 3.50293284505982*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW300", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.4537268931515083`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW300\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 300 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW300\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.00333333333333333`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27758101245985`", ",", "3.02605835330556`", ",", 
          "0.774926187885482`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5551620249197`", ",", "2.97811134721865`", ",", 
          "1.54985237577096`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83274303737955`", ",", "2.94125781126667`", ",", 
          "2.32477856365645`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1103240498394`", ",", "2.91013624181117`", ",", 
          "3.09970475154193`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.10471975511966`", ",", "2.88267111158357`", ",", 
          "3.87463093942741`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38230076757951`", ",", "2.85779854438147`", ",", 
          "4.64955712731289`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65988178003936`", ",", "2.83488688122941`", ",", 
          "5.42448331519838`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93746279249921`", ",", "2.81352477154384`", ",", 
          "6.19940950308386`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21504380495906`", ",", "2.79342663231683`", ",", 
          "0.691150383789755`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.20943951023932`", ",", "2.77438463303196`", ",", 
          "1.46607657167524`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48702052269917`", ",", "2.75624195245576`", ",", 
          "2.24100275956072`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76460153515902`", ",", "2.73887681200913`", ",", 
          "3.0159289474462`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04218254761887`", ",", "2.72219241076794`", ",", 
          "3.79085513533168`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31976356007872`", ",", "2.70611029686563`", ",", 
          "4.56578132321717`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.314159265358979`", ",", "2.69056584179353`", ",", 
          "5.34070751110265`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59174027781883`", ",", "2.67550505561096`", ",", 
          "6.11563369898813`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86932129027868`", ",", "2.66088228733725`", ",", 
          "0.607374579694027`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14690230273853`", ",", "2.6466585272489`", ",", 
          "1.38230076757951`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42448331519838`", ",", "2.63280012907942`", ",", 
          "2.15722695546499`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.418879020478639`", ",", "2.61927783178374`", ",", 
          "2.93215314335047`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69646003293849`", ",", "2.60606599927541`", ",", 
          "3.70707933123596`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97404104539834`", ",", "2.59314202157298`", ",", 
          "4.48200551912144`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25162205785819`", ",", "2.58048583735939`", ",", 
          "5.25693170700692`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52920307031804`", ",", "2.5680795491667`", ",", 
          "6.0318578948924`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.523598775598299`", ",", "2.55590711013264`", ",", 
          "0.523598775598299`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80117978805815`", ",", "2.54395406670665`", ",", 
          "1.29852496348378`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.078760800518`", ",", "2.532207345559`", ",", 
          "2.07345115136926`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35634181297785`", ",", "2.52065507575421`", ",", 
          "2.84837733925475`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6339228254377`", ",", "2.50928643931029`", ",", 
          "3.62330352714023`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.628318530717959`", ",", "2.49809154479651`", ",", 
          "4.39822971502571`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90589954317781`", ",", "2.48706131977346`", ",", 
          "5.17315590291119`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18348055563766`", ",", "2.47618741875335`", ",", 
          "5.94808209079667`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46106156809751`", ",", "2.46546214402913`", ",", 
          "0.439822971502571`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73864258055736`", ",", "2.4548783772402`", ",", 
          "1.21474915938805`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.733038285837618`", ",", "2.44442951994756`", ",", 
          "1.98967534727354`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01061929829747`", ",", "2.43410944181045`", ",", 
          "2.76460153515902`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28820031075732`", ",", "2.42391243520919`", ",", 
          "3.5395277230445`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56578132321717`", ",", "2.41383317536083`", ",", 
          "4.31445391092998`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84336233567702`", ",", "2.40386668513654`", ",", 
          "5.08938009881547`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.837758040957278`", ",", "2.39400830392077`", ",", 
          "5.86430628670095`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11533905341713`", ",", "2.38425365995896`", ",", 
          "0.356047167406843`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39292006587698`", ",", "2.37459864572793`", ",", 
          "1.13097335529233`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67050107833683`", ",", "2.36503939593479`", ",", 
          "1.90589954317781`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94808209079667`", ",", "2.35557226780952`", ",", 
          "2.68082573106329`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.942477796076938`", ",", "2.34619382340565`", ",", 
          "3.45575191894877`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22005880853679`", ",", "2.33690081366456`", ",", 
          "4.23067810683425`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49763982099664`", ",", "2.3276901640333`", ",", 
          "5.00560429471974`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77522083345649`", ",", "2.31855896145482`", ",", 
          "5.78053048260522`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05280184591634`", ",", "2.30950444257373`", ",", 
          "0.272271363311115`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0471975511966`", ",", "2.30052398302186`", ",", 
          "1.0471975511966`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32477856365645`", ",", "2.29161508766499`", ",", 
          "1.82212373908208`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6023595761163`", ",", "2.28277538170746`", ",", 
          "2.59704992696756`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87994058857614`", ",", "2.27400260256434`", ",", 
          "3.37197611485304`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15752160103599`", ",", "2.26529459242145`", ",", 
          "4.14690230273853`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15191730631626`", ",", "2.25664929141361`", ",", 
          "4.92182849062401`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42949831877611`", ",", "2.24806473135929`", ",", 
          "5.69675467850949`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70707933123596`", ",", "2.23953902999727`", ",", 
          "0.188495559215388`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98466034369581`", ",", "2.23107038567681`", ",", 
          "0.96342174710087`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26224135615566`", ",", "2.22265707245861`", ",", 
          "1.73834793498635`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25663706143592`", ",", "2.21429743558818`", ",", 
          "2.51327412287183`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53421807389577`", ",", "2.20598988730767`", ",", 
          "3.28820031075732`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81179908635562`", ",", "2.19773290297558`", ",", 
          "4.0631264986428`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08938009881547`", ",", "2.18952501746715`", ",", 
          "4.83805268652828`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0837758040957278`", ",", "2.181364821831`", ",", 
          "5.61297887441376`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36135681655558`", ",", "2.17325096017989`", ",", 
          "0.10471975511966`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63893782901543`", ",", "2.16518212679596`", ",", 
          "0.879645943005142`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91651884147528`", ",", "2.15715706343249`", ",", 
          "1.65457213089062`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19409985393513`", ",", "2.1491745567961`", ",", 
          "2.42949831877611`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.188495559215388`", ",", "2.14123343619482`", ",", 
          "3.20442450666159`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46607657167524`", ",", "2.13333257133875`", ",", 
          "3.97935069454707`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74365758413509`", ",", "2.12547087028142`", ",", 
          "4.75427688243255`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02123859659494`", ",", "2.11764727749084`", ",", 
          "5.52920307031804`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29881960905478`", ",", "2.1098607720404`", ",", 
          "0.020943951023932`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.293215314335047`", ",", "2.10211036591058`", ",", 
          "0.795870138909414`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5707963267949`", ",", "2.0943951023932`", ",", 
          "1.5707963267949`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84837733925475`", ",", "2.0867140545907`", ",", 
          "2.34572251468038`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1259583517146`", ",", "2.07906632400354`", ",", 
          "3.12064870256586`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40353936417444`", ",", "2.07145103919948`", ",", 
          "3.89557489045134`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.397935069454707`", ",", "2.06386735455883`", ",", 
          "4.67050107833683`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67551608191456`", ",", "2.05631444909049`", ",", 
          "5.44542726622231`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95309709437441`", ",", "2.04879152531385`", ",", 
          "6.22035345410779`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23067810683425`", ",", "2.04129780820205`", ",", 
          "0.712094334813687`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5082591192941`", ",", "2.03383254418249`", ",", 
          "1.48702052269917`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.502654824574367`", ",", "2.02639500019072`", ",", 
          "2.26194671058465`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78023583703422`", ",", "2.01898446277433`", ",", 
          "3.03687289847013`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05781684949407`", ",", "2.01160023724342`", ",", 
          "3.81179908635562`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33539786195391`", ",", "2.00424164686478`", ",", 
          "4.5867252742411`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61297887441376`", ",", "1.99690803209694`", ",", 
          "5.36165146212658`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.607374579694027`", ",", "1.9895987498635`", ",", 
          "6.13657765001206`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88495559215388`", ",", "1.98231317286238`", ",", 
          "0.628318530717959`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16253660461372`", ",", "1.97505068890884`", ",", 
          "1.40324471860344`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44011761707357`", ",", "1.96781070030998`", ",", 
          "2.17817090648892`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71769862953342`", ",", "1.96059262326916`", ",", 
          "2.95309709437441`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.712094334813687`", ",", "1.95339588731819`", ",", 
          "3.72802328225989`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98967534727354`", ",", "1.94621993477594`", ",", 
          "4.50294947014537`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26725635973338`", ",", "1.93906422023154`", ",", 
          "5.27787565803085`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54483737219324`", ",", "1.93192821005103`", ",", 
          "6.05280184591634`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82241838465308`", ",", "1.92481138190586`", ",", 
          "0.544542726622231`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.816814089933346`", ",", "1.91771322432206`", ",", 
          "1.31946891450771`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0943951023932`", ",", "1.91063323624902`", ",", 
          "2.0943951023932`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37197611485304`", ",", "1.90357092664657`", ",", 
          "2.86932129027868`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64955712731289`", ",", "1.89652581408953`", ",", 
          "3.64424747816416`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92713813977274`", ",", "1.88949742638857`", ",", 
          "4.41917366604964`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.921533845053006`", ",", "1.88248530022669`", ",", 
          "5.19409985393513`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19911485751286`", ",", "1.87548898081029`", ",", 
          "5.96902604182061`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4766958699727`", ",", "1.86850802153407`", ",", 
          "0.460766922526503`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75427688243255`", ",", "1.8615419836591`", ",", 
          "1.23569311041199`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0318578948924`", ",", "1.85459043600322`", ",", 
          "2.01061929829747`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02625360017267`", ",", "1.84765295464328`", ",", 
          "2.78554548618295`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30383461263251`", ",", "1.8407291226283`", ",", 
          "3.56047167406843`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58141562509236`", ",", "1.83381852970337`", ",", 
          "4.33539786195391`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85899663755221`", ",", "1.8269207720433`", ",", 
          "5.1103240498394`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13657765001206`", ",", "1.82003545199586`", ",", 
          "5.88525023772488`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13097335529233`", ",", "1.81316217783386`", ",", 
          "0.376991118430775`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40855436775217`", ",", "1.8063005635157`", ",", 
          "1.15191730631626`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68613538021202`", ",", "1.79945022845398`", ",", 
          "1.92684349420174`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96371639267187`", ",", "1.79261079729169`", ",", 
          "2.70176968208722`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24129740513172`", ",", "1.78578189968557`", ",", 
          "3.4766958699727`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23569311041199`", ",", "1.77896317009632`", ",", 
          "4.25162205785819`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51327412287183`", ",", "1.77215424758523`", ",", 
          "5.02654824574367`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79085513533168`", ",", "1.76535477561698`", ",", 
          "5.80147443362915`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06843614779153`", ",", "1.75856440186819`", ",", 
          "0.293215314335047`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0628318530717959`", ",", "1.75178277804144`", ",", 
          "1.06814150222053`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34041286553165`", ",", "1.74500955968454`", ",", 
          "1.84306769010601`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61799387799149`", ",", "1.73824440601459`", ",", 
          "2.61799387799149`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89557489045134`", ",", "1.73148697974681`", ",", 
          "3.39292006587698`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17315590291119`", ",", "1.72473694692765`", ",", 
          "4.16784625376246`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.167551608191456`", ",", "1.71799397677208`", ",", 
          "4.94277244164794`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4451326206513`", ",", "1.71125774150475`", ",", 
          "5.71769862953342`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72271363311115`", ",", "1.70452791620484`", ",", 
          "0.20943951023932`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.000294645571`", ",", "1.69780417865435`", ",", 
          "0.984365698124802`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27787565803085`", ",", "1.69108620918968`", ",", 
          "1.75929188601028`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.272271363311115`", ",", "1.6843736905562`", ",", 
          "2.53421807389577`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54985237577096`", ",", "1.67766630776568`", ",", 
          "3.30914426178125`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82743338823081`", ",", "1.67096374795646`", ",", 
          "4.08407044966673`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10501440069066`", ",", "1.66426570025599`", ",", 
          "4.85899663755221`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38259541315051`", ",", "1.65757185564581`", ",", 
          "5.6339228254377`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.376991118430775`", ",", "1.65088190682856`", ",", 
          "0.125663706143592`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65457213089062`", ",", "1.64419554809705`", ",", 
          "0.900589894029074`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93215314335047`", ",", "1.63751247520512`", ",", 
          "1.67551608191456`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20973415581032`", ",", "1.63083238524018`", ",", 
          "2.45044226980004`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48731516827017`", ",", "1.62415497649721`", ",", 
          "3.22536845768552`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.481710873550435`", ",", "1.61747994835422`", ",", 
          "4.000294645571`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75929188601028`", ",", "1.61080700114889`", ",", 
          "4.77522083345649`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03687289847013`", ",", "1.6041358360562`", ",", 
          "5.55014702134197`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31445391092998`", ",", "1.59746615496718`", ",", 
          "0.0418879020478639`"}], "}"}], ",", "0.00333333333333333`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59203492338983`", ",", "1.59079766036829`", ",", 
          "0.816814089933346`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.586430628670095`", ",", "1.58413005522157`", ",", 
          "1.59174027781883`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86401164112994`", ",", "1.57746304284527`", ",", 
          "2.36666646570431`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41917366604964`", ",", "1.56412961074453`", ",", 
          "3.91651884147528`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69675467850949`", ",", "1.55746259836823`", ",", 
          "4.69144502936076`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.691150383789755`", ",", "1.55079499322151`", ",", 
          "5.46637121724624`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9687313962496`", ",", "1.54412649862262`", ",", 
          "6.24129740513172`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24631240870945`", ",", "1.53745681753359`", ",", 
          "0.733038285837618`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5238934211693`", ",", "1.53078565244091`", ",", 
          "1.5079644737231`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80147443362915`", ",", "1.52411270523557`", ",", 
          "2.28289066160858`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.795870138909414`", ",", "1.51743767709259`", ",", 
          "3.05781684949407`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07345115136926`", ",", "1.51076026834962`", ",", 
          "3.83274303737955`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35103216382911`", ",", "1.50408017838467`", ",", 
          "4.60766922526503`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62861317628896`", ",", "1.49739710549275`", ",", 
          "5.38259541315051`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90619418874881`", ",", "1.49071074676124`", ",", 
          "6.15752160103599`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.900589894029074`", ",", "1.48402079794399`", ",", 
          "0.649262481741891`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17817090648892`", ",", "1.4773269533338`", ",", 
          "1.42418866962737`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45575191894877`", ",", "1.47062890563334`", ",", 
          "2.19911485751286`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73333293140862`", ",", "1.46392634582411`", ",", 
          "2.97404104539834`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01091394386847`", ",", "1.45721896303359`", ",", 
          "3.74896723328382`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00530964914873`", ",", "1.45050644440011`", ",", 
          "4.5238934211693`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28289066160858`", ",", "1.44378847493544`", ",", 
          "5.29881960905478`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56047167406843`", ",", "1.43706473738496`", ",", 
          "6.07374579694027`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83805268652828`", ",", "1.43033491208504`", ",", 
          "0.565486677646163`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11563369898813`", ",", "1.42359867681771`", ",", 
          "1.34041286553165`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11002940426839`", ",", "1.41685570666214`", ",", 
          "2.11533905341713`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38761041672824`", ",", "1.41010567384299`", ",", 
          "2.89026524130261`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66519142918809`", ",", "1.40334824757521`", ",", 
          "3.66519142918809`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94277244164794`", ",", "1.39658309390526`", ",", 
          "4.44011761707357`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22035345410779`", ",", "1.38980987554835`", ",", 
          "5.21504380495906`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21474915938805`", ",", "1.3830282517216`", ",", 
          "5.98996999284454`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4923301718479`", ",", "1.37623787797281`", ",", 
          "0.481710873550435`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76991118430775`", ",", "1.36943840600457`", ",", 
          "1.25663706143592`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0474921967676`", ",", "1.36262948349348`", ",", 
          "2.0315632493214`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0418879020478639`", ",", "1.35581075390422`", ",", 
          "2.80648943720688`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31946891450771`", ",", "1.3489818562981`", ",", 
          "3.58141562509236`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59704992696756`", ",", "1.34214242513581`", ",", 
          "4.35634181297785`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87463093942741`", ",", "1.3352920900741`", ",", 
          "5.13126800086333`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15221195188726`", ",", "1.32843047575593`", ",", 
          "5.90619418874881`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.146607657167524`", ",", "1.32155720159393`", ",", 
          "0.397935069454707`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42418866962737`", ",", "1.31467188154649`", ",", 
          "1.17286125734019`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70176968208722`", ",", "1.30777412388643`", ",", 
          "1.94778744522567`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97935069454707`", ",", "1.30086353096149`", ",", 
          "2.72271363311115`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25693170700692`", ",", "1.29393969894652`", ",", 
          "3.49763982099664`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.251327412287183`", ",", "1.28700221758657`", ",", 
          "4.27256600888212`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52890842474703`", ",", "1.2800506699307`", ",", 
          "5.0474921967676`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80648943720688`", ",", "1.27308463205572`", ",", 
          "5.82241838465308`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08407044966673`", ",", "1.2661036727795`", ",", 
          "0.314159265358979`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36165146212658`", ",", "1.2591073533631`", ",", 
          "1.08908545324446`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.356047167406843`", ",", "1.25209522720123`", ",", 
          "1.86401164112994`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63362817986669`", ",", "1.24506683950027`", ",", 
          "2.63893782901543`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91120919232654`", ",", "1.23802172694322`", ",", 
          "3.41386401690091`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18879020478639`", ",", "1.23095941734077`", ",", 
          "4.18879020478639`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46637121724624`", ",", "1.22387942926773`", ",", 
          "4.96371639267187`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.460766922526503`", ",", "1.21678127168394`", ",", 
          "5.73864258055736`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73834793498635`", ",", "1.20966444353876`", ",", 
          "0.230383461263251`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0159289474462`", ",", "1.20252843335826`", ",", 
          "1.00530964914873`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29350995990605`", ",", "1.19537271881386`", ",", 
          "1.78023583703422`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5710909723659`", ",", "1.1881967662716`", ",", 
          "2.5551620249197`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.565486677646163`", ",", "1.18100003032064`", ",", 
          "3.33008821280518`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84306769010601`", ",", "1.17378195327981`", ",", 
          "4.10501440069066`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12064870256586`", ",", "1.16654196468096`", ",", 
          "4.87994058857614`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39822971502571`", ",", "1.15927948072741`", ",", 
          "5.65486677646163`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67581072748556`", ",", "1.1519939037263`", ",", 
          "0.146607657167524`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.670206432765823`", ",", "1.14468462149285`", ",", 
          "0.921533845053006`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94778744522567`", ",", "1.13735100672501`", ",", 
          "1.69646003293849`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22536845768552`", ",", "1.12999241634638`", ",", 
          "2.47138622082397`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50294947014537`", ",", "1.12260819081547`", ",", 
          "3.24631240870945`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78053048260522`", ",", "1.11519765339907`", ",", 
          "4.02123859659494`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.774926187885482`", ",", "1.1077601094073`", ",", 
          "4.79616478448042`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05250720034533`", ",", "1.10029484538774`", ",", 
          "5.5710909723659`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33008821280518`", ",", "1.09280112827594`", ",", 
          "0.0628318530717959`"}], "}"}], ",", "0.00333333333333333`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60766922526503`", ",", "1.08527820449931`", ",", 
          "0.837758040957278`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88525023772488`", ",", "1.07772529903096`", ",", 
          "1.61268422884276`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.879645943005142`", ",", "1.07014161439031`", ",", 
          "2.38761041672824`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15722695546499`", ",", "1.06252632958625`", ",", 
          "3.16253660461372`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43480796792484`", ",", "1.0548785989991`", ",", 
          "3.93746279249921`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71238898038469`", ",", "1.0471975511966`", ",", 
          "4.71238898038469`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98996999284454`", ",", "1.03948228767922`", ",", 
          "5.48731516827017`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.984365698124802`", ",", "1.0317318815494`", ",", 
          "6.26224135615566`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26194671058465`", ",", "1.02394537609895`", ",", 
          "0.75398223686155`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5395277230445`", ",", "1.01612178330837`", ",", 
          "1.52890842474703`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81710873550435`", ",", "1.00826008225104`", ",", 
          "2.30383461263251`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0946897479642`", ",", "1.00035921739497`", ",", 
          "3.078760800518`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08908545324446`", ",", "0.992418096793693`", ",", 
          "3.85368698840348`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36666646570431`", ",", "0.984435590157305`", ",", 
          "4.62861317628896`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64424747816416`", ",", "0.976410526793834`", ",", 
          "5.40353936417444`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92182849062401`", ",", "0.968341693409906`", ",", 
          "6.17846555205993`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19940950308386`", ",", "0.960227831758797`", ",", 
          "0.670206432765823`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19380520836412`", ",", "0.952067636122646`", ",", 
          "1.4451326206513`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47138622082397`", ",", "0.943859750614217`", ",", 
          "2.22005880853679`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74896723328382`", ",", "0.935602766282121`", ",", 
          "2.99498499642227`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02654824574367`", ",", "0.927295218001612`", ",", 
          "3.76991118430775`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.020943951023932`", ",", "0.918935581131187`", ",", 
          "4.54483737219324`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29852496348378`", ",", "0.910522267912985`", ",", 
          "5.31976356007872`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57610597594363`", ",", "0.902053623592525`", ",", 
          "6.0946897479642`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85368698840348`", ",", "0.893527922230502`", ",", 
          "0.586430628670095`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13126800086333`", ",", "0.884943362176186`", ",", 
          "1.36135681655558`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.125663706143592`", ",", "0.876298061168341`", ",", 
          "2.13628300444106`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40324471860344`", ",", "0.86759005102545`", ",", 
          "2.91120919232654`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68082573106329`", ",", "0.858817271882329`", ",", 
          "3.68613538021202`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95840674352314`", ",", "0.849977565924807`", ",", 
          "4.46106156809751`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23598775598299`", ",", "0.84106867056793`", ",", 
          "5.23598775598299`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.230383461263251`", ",", "0.832088211016064`", ",", 
          "6.01091394386847`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5079644737231`", ",", "0.823033692134976`", ",", 
          "0.502654824574367`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78554548618295`", ",", "0.81390248955649`", ",", 
          "1.27758101245985`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0631264986428`", ",", "0.804691839925237`", ",", 
          "2.05250720034533`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34070751110265`", ",", "0.795398830184144`", ",", 
          "2.82743338823081`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.335103216382911`", ",", "0.786020385780271`", ",", 
          "3.6023595761163`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61268422884276`", ",", "0.776553257655002`", ",", 
          "4.37728576400178`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89026524130261`", ",", "0.766994007861867`", ",", 
          "5.15221195188726`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16784625376246`", ",", "0.757338993630836`", ",", 
          "5.92713813977274`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44542726622231`", ",", "0.747584349669021`", ",", 
          "0.418879020478639`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.439822971502571`", ",", "0.737725968453249`", ",", 
          "1.19380520836412`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71740398396242`", ",", "0.727759478228963`", ",", 
          "1.9687313962496`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99498499642227`", ",", "0.717680218380605`", ",", 
          "2.74365758413509`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27256600888212`", ",", "0.707483211779343`", ",", 
          "3.51858377202057`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55014702134197`", ",", "0.697163133642232`", ",", 
          "4.29350995990605`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.544542726622231`", ",", "0.68671427634959`", ",", 
          "5.06843614779153`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82212373908208`", ",", "0.676130509560661`", ",", 
          "5.84336233567702`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09970475154193`", ",", "0.665405234836448`", ",", 
          "0.335103216382911`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37728576400178`", ",", "0.654531333816334`", ",", 
          "1.11002940426839`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65486677646163`", ",", "0.643501108793284`", ",", 
          "1.88495559215388`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.649262481741891`", ",", "0.632306214279507`", ",", 
          "2.65988178003936`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92684349420174`", ",", "0.620937577835587`", ",", 
          "3.43480796792484`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20442450666159`", ",", "0.609385308030795`", ",", 
          "4.20973415581032`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48200551912144`", ",", "0.597638586883139`", ",", 
          "4.98466034369581`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75958653158129`", ",", "0.585685543457151`", ",", 
          "5.75958653158129`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.75398223686155`", ",", "0.573513104423097`", ",", 
          "0.251327412287183`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0315632493214`", ",", "0.561106816230398`", ",", 
          "1.02625360017267`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30914426178125`", ",", "0.548450632016811`", ",", 
          "1.80117978805815`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5867252742411`", ",", "0.535526654314388`", ",", 
          "2.57610597594363`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86430628670095`", ",", "0.522314821806049`", ",", 
          "3.35103216382911`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.85870199198121`", ",", "0.50879252451037`", ",", 
          "4.1259583517146`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13628300444106`", ",", "0.494934126340896`", ",", 
          "4.90088453960008`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41386401690091`", ",", "0.480710366252544`", ",", 
          "5.67581072748556`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69144502936076`", ",", "0.466087597978832`", ",", 
          "0.167551608191456`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96902604182061`", ",", "0.451026811796262`", ",", 
          "0.942477796076938`"}], "}"}], ",", "0.00333333333333333`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.96342174710087`", ",", "0.435482356724161`", ",", 
          "1.71740398396242`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24100275956072`", ",", "0.419400242821853`", ",", 
          "2.4923301718479`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51858377202057`", ",", "0.402715841580662`", ",", 
          "3.26725635973338`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79616478448042`", ",", "0.385350701134031`", ",", 
          "4.04218254761887`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07374579694027`", ",", "0.367208020557837`", ",", 
          "4.81710873550435`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06814150222053`", ",", "0.348166021272961`", ",", 
          "5.59203492338983`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34572251468038`", ",", "0.32806788204595`", ",", 
          "0.0837758040957278`"}], "}"}], ",", "0.00333333333333333`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62330352714023`", ",", "0.306705772360383`", ",", 
          "0.85870199198121`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90088453960008`", ",", "0.283794109208328`", ",", 
          "1.63362817986669`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17846555205993`", ",", "0.258921542006221`", ",", 
          "2.40855436775217`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17286125734019`", ",", "0.231456411778625`", ",", 
          "3.18348055563766`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45044226980004`", ",", "0.20033484232312`", ",", 
          "3.95840674352314`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72802328225989`", ",", "0.163481306371142`", ",", 
          "4.73333293140862`"}], "}"}], ",", "0.00333333333333333`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00560429471974`", ",", "0.115534300284237`", ",", 
          "5.5082591192941`"}], "}"}], ",", "0.00333333333333333`"}], "}"}]}],
      "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.460273662680175*^9, 3.4602736672802677`*^9}, {3.460278683630114*^9, 
   3.460278697049426*^9}, 3.460288008173973*^9, {3.5029328517796307`*^9, 
   3.502932866371854*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW538", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.4537268931515083`*^9}, {
  3.460292425263933*^9, 3.460292425887959*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW538\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 538 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW538\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.00185873605947955`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67444132963592`", ",", "3.05533979657658`", ",", 
          "0.642333070436575`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34888265927184`", ",", "3.01957482199163`", ",", 
          "1.28466614087315`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74013868172818`", ",", "2.99210547938444`", ",", 
          "1.92699921130972`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4145800113641`", ",", "2.96892599454821`", ",", 
          "2.5693322817463`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.80583603382043`", ",", "2.94848527732149`", ",", 
          "3.21166535218287`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48027736345635`", ",", "2.92998808340381`", ",", 
          "3.85399842261945`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15471869309227`", ",", "2.91296214525633`", ",", 
          "4.49633149305602`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54597471554861`", ",", "2.89709984655793`", ",", 
          "5.1386645634926`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22041604518453`", ",", "2.88218757927797`", ",", 
          "5.78099763392917`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61167206764086`", ",", "2.86806986194205`", ",", 
          "0.140145397186162`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28611339727678`", ",", "2.85462935229453`", ",", 
          "0.782478467622737`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.677369419733115`", ",", "2.84177491291885`", ",", 
          "1.42481153805931`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35181074936904`", ",", "2.82943408730053`", ",", 
          "2.06714460849589`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02625207900496`", ",", "2.81754814421319`", ",", 
          "2.70947767893246`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41750810146129`", ",", "2.80606869391094`", ",", 
          "3.35181074936904`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09194943109721`", ",", "2.79495530666154`", ",", 
          "3.99414381980561`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48320545355355`", ",", "2.78417379301317`", ",", 
          "4.63647689024219`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15764678318947`", ",", "2.77369493406194`", ",", 
          "5.27880996067876`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.5489028056458`", ",", "2.76349352567503`", ",", 
          "5.92114303111534`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22334413528172`", ",", "2.75354764671208`", ",", 
          "0.280290794372323`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89778546491764`", ",", "2.74383809024753`", ",", 
          "0.922623864808898`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28904148737398`", ",", "2.73434791550506`", ",", 
          "1.56495693524547`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9634828170099`", ",", "2.72506209059942`", ",", 
          "2.20729000568205`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35473883946623`", ",", "2.71596720456013`", ",", 
          "2.84962307611862`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02918016910215`", ",", "2.70705123289381`", ",", 
          "3.4919561465552`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.420436191558485`", ",", "2.69830334500185`", ",", 
          "4.13428921699177`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09487752119441`", ",", "2.68971374466902`", ",", 
          "4.77662228742835`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76931885083033`", ",", "2.68127353693716`", ",", 
          "5.41895535786492`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16057487328666`", ",", "2.67297461621912`", ",", 
          "6.0612884283015`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83501620292258`", ",", "2.66480957165302`", ",", 
          "0.420436191558485`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22627222537892`", ",", "2.65677160655789`", ",", 
          "1.06276926199506`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90071355501484`", ",", "2.64885446950517`", ",", 
          "1.70510233243163`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.29196957747117`", ",", "2.64105239502268`", ",", 
          "2.34743540286821`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96641090710709`", ",", "2.63336005233536`", ",", 
          "2.98976847330478`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64085223674301`", ",", "2.62577250085075`", ",", 
          "3.63210154374136`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03210825919935`", ",", "2.61828515133541`", ",", 
          "4.27443461417793`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70654958883527`", ",", "2.61089373191784`", ",", 
          "4.91676768461451`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0978056112916`", ",", "2.60359425820429`", ",", 
          "5.55910075505108`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77224694092752`", ",", "2.59638300691549`", ",", 
          "6.20143382548766`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.163502963383855`", ",", "2.58925649255027`", ",", 
          "0.560581588744647`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83794429301978`", ",", "2.58221144666192`", ",", 
          "1.20291465918122`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5123856226557`", ",", "2.57524479939869`", ",", 
          "1.8452477296178`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90364164511203`", ",", "2.56835366301312`", ",", 
          "2.48758080005437`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57808297474795`", ",", "2.56153531708974`", ",", 
          "3.12991387049095`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.969338997204286`", ",", "2.55478719527724`", ",", 
          "3.77224694092752`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64378032684021`", ",", "2.54810687334198`", ",", 
          "4.4145800113641`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0350363492965404`", ",", "2.54149205838561`", ",", 
          "5.05691308180067`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70947767893246`", ",", "2.53494057909113`", ",", 
          "5.69924615223725`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38391900856838`", ",", "2.52845037688`", ",", 
          "0.0583939154942341`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77517503102472`", ",", "2.52201949787841`", ",", 
          "0.700726985930809`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44961636066064`", ",", "2.51564608560414`", ",", 
          "1.34306005636738`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.840872383116971`", ",", "2.50932837429652`", ",", 
          "1.98539312680396`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51531371275289`", ",", "2.50306468282168`", ",", 
          "2.62772619724053`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18975504238881`", ",", "2.49685340909373`", ",", 
          "3.27005926767711`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58101106484515`", ",", "2.49069302495936`", ",", 
          "3.91239233811368`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25545239448107`", ",", "2.48458207149976`", ",", 
          "4.55472540855026`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6467084169374`", ",", "2.47851915470904`", ",", 
          "5.19705847898683`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32114974657332`", ",", "2.47250294151276`", ",", 
          "5.83939154942341`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.712405769029656`", ",", "2.46653215609465`", ",", 
          "0.198539312680396`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38684709866558`", ",", "2.46060557650273`", ",", 
          "0.840872383116971`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0612884283015`", ",", "2.45472203150934`", ",", 
          "1.48320545355355`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45254445075783`", ",", "2.44888039770218`", ",", 
          "2.12553852399012`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12698578039375`", ",", "2.44307959678611`", ",", 
          "2.76787159442669`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51824180285009`", ",", "2.43731859307713`", ",", 
          "3.41020466486327`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19268313248601`", ",", "2.43159639117222`", ",", 
          "4.05253773529985`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.583939154942341`", ",", "2.42591203378014`", ",", 
          "4.69487080573642`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25838048457826`", ",", "2.42026459969984`", ",", 
          "5.33720387617299`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93282181421418`", ",", "2.41465320193439`", ",", 
          "5.97953694660957`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32407783667052`", ",", "2.40907698592941`", ",", 
          "0.338684709866558`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99851916630644`", ",", "2.40353512792625`", ",", 
          "0.981017780303132`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38977518876277`", ",", "2.3980268334208`", ",", 
          "1.62335085073971`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06421651839869`", ",", "2.39255133571981`", ",", 
          "2.26568392117628`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.455472540855026`", ",", "2.38710789458733`", ",", 
          "2.90801699161286`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12991387049095`", ",", "2.38169579497435`", ",", 
          "3.55035006204943`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80435520012687`", ",", "2.37631434582571`", ",", 
          "4.19268313248601`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1956112225832`", ",", "2.37096287895832`", ",", 
          "4.83501620292258`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87005255221912`", ",", "2.36564074800586`", ",", 
          "5.47734927335916`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26130857467546`", ",", "2.36034732742494`", ",", 
          "6.11968234379573`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93574990431138`", ",", "2.35508201155857`", ",", 
          "0.478830107052719`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.327005926767711`", ",", "2.34984421375291`", ",", 
          "1.12116317748929`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00144725640363`", ",", "2.3446333655236`", ",", 
          "1.76349624792587`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67588858603955`", ",", "2.33944891576836`", ",", 
          "2.40582931836244`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06714460849589`", ",", "2.33429033002278`", ",", 
          "3.04816238879902`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74158593813181`", ",", "2.32915708975631`", ",", 
          "3.69049545923559`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13284196058814`", ",", "2.32404869170606`", ",", 
          "4.33282852967217`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80728329022406`", ",", "2.31896464724568`", ",", 
          "4.97516160010874`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.198539312680396`", ",", "2.31390448178734`", ",", 
          "5.61749467054532`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87298064231632`", ",", "2.30886773421452`", ",", 
          "6.25982774098189`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54742197195224`", ",", "2.30385395634383`", ",", 
          "0.618975504238881`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93867799440857`", ",", "2.29886271241399`", ",", 
          "1.26130857467546`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61311932404449`", ",", "2.29389357860033`", ",", 
          "1.90364164511203`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00437534650083`", ",", "2.28894614255323`", ",", 
          "2.54597471554861`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67881667613675`", ",", "2.28402000295923`", ",", 
          "3.18830778598518`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0700726985930809`", ",", "2.27911476912318`", ",", 
          "3.83064085642175`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.744514028229`", ",", "2.27423006057055`", ",", 
          "4.47297392685833`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41895535786492`", ",", "2.2693655066684`", ",", 
          "5.11530699729491`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81021138032126`", ",", "2.2645207462642`", ",", 
          "5.75764006773148`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48465270995718`", ",", "2.25969542734134`", ",", 
          "0.116787830988468`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.875908732413511`", ",", "2.25488920669048`", ",", 
          "0.759120901425043`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55035006204943`", ",", "2.25010174959572`", ",", 
          "1.40145397186162`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22479139168535`", ",", "2.24533272953502`", ",", 
          "2.04378704229819`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61604741414169`", ",", "2.24058182789383`", ",", 
          "2.68612011273477`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29048874377761`", ",", "2.2358487336914`", ",", 
          "3.32845318317134`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68174476623394`", ",", "2.231133143319`", ",", 
          "3.97078625360792`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35618609586986`", ",", "2.22643476028948`", ",", 
          "4.61311932404449`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.747442118326196`", ",", "2.2217532949975`", ",", 
          "5.25545239448107`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42188344796212`", ",", "2.21708846448999`", ",", 
          "5.89778546491764`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09632477759804`", ",", "2.21243999224618`", ",", 
          "0.25693322817463`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48758080005437`", ",", "2.20780760796684`", ",", 
          "0.899266298611205`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16202212969029`", ",", "2.20319104737215`", ",", 
          "1.54159936904778`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55327815214663`", ",", "2.19859005200787`", ",", 
          "2.18393243948435`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22771948178255`", ",", "2.1940043690593`", ",", 
          "2.82626550992093`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.618975504238881`", ",", "2.18943375117279`", ",", 
          "3.4685985803575`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2934168338748`", ",", "2.18487795628425`", ",", 
          "4.11093165079408`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96785816351072`", ",", "2.18033674745442`", ",", 
          "4.75326472123065`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35911418596706`", ",", "2.17580989271067`", ",", 
          "5.39559779166723`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03355551560298`", ",", "2.17129716489479`", ",", 
          "6.0379308621038`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42481153805931`", ",", "2.16679834151673`", ",", 
          "0.397078625360792`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09925286769523`", ",", "2.1623132046138`", ",", 
          "1.03941169579737`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.490508890151566`", ",", "2.15784154061528`", ",", 
          "1.68174476623394`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16495021978749`", ",", "2.15338314021202`", ",", 
          "2.32407783667052`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83939154942341`", ",", "2.1489377982309`", ",", 
          "2.96641090710709`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23064757187974`", ",", "2.14450531351388`", ",", 
          "3.60874397754367`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90508890151566`", ",", "2.14008548880154`", ",", 
          "4.25107704798024`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.296344923972`", ",", "2.13567813062071`", ",", 
          "4.89341011841682`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97078625360792`", ",", "2.1312830491762`", ",", 
          "5.53574318885339`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.362042276064251`", ",", "2.1269000582464`", ",", 
          "6.17807625928996`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03648360570017`", ",", "2.12252897508251`", ",", 
          "0.537224022546953`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71092493533609`", ",", "2.11816962031132`", ",", 
          "1.17955709298353`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10218095779243`", ",", "2.11382181784133`", ",", 
          "1.8218901634201`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77662228742835`", ",", "2.10948539477222`", ",", 
          "2.46422323385668`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16787830988468`", ",", "2.10516018130722`", ",", 
          "3.10655630429325`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8423196395206`", ",", "2.10084601066864`", ",", 
          "3.74888937472983`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.233575661976936`", ",", "2.09654271901612`", ",", 
          "4.3912224451664`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90801699161286`", ",", "2.09225014536762`", ",", 
          "5.03355551560298`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58245832124878`", ",", "2.08796813152312`", ",", 
          "5.67588858603955`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97371434370511`", ",", "2.08369652199066`", ",", 
          "0.0350363492965404`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64815567334103`", ",", "2.07943516391498`", ",", 
          "0.677369419733115`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03941169579737`", ",", "2.07518390700831`", ",", 
          "1.31970249016969`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71385302543329`", ",", "2.07094260348345`", ",", 
          "1.96203556060627`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.105109047889621`", ",", "2.06671110798901`", ",", 
          "2.60436863104284`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77955037752554`", ",", "2.06248927754664`", ",", 
          "3.24670170147941`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45399170716146`", ",", "2.05827697149025`", ",", 
          "3.88903477191599`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8452477296178`", ",", "2.05407405140714`", ",", 
          "4.53136784235256`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51968905925372`", ",", "2.04988038108092`", ",", 
          "5.17370091278914`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.910945081710052`", ",", "2.04569582643621`", ",", 
          "5.81603398322571`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58538641134597`", ",", "2.04152025548498`", ",", 
          "0.175181746482702`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25982774098189`", ",", "2.03735353827459`", ",", 
          "0.817514816919277`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65108376343823`", ",", "2.0331955468373`", ",", 
          "1.45984788735585`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32552509307415`", ",", "2.02904615514134`", ",", 
          "2.10218095779243`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71678111553048`", ",", "2.02490523904339`", ",", 
          "2.744514028229`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3912224451664`", ",", "2.02077267624251`", ",", 
          "3.38684709866558`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.782478467622737`", ",", "2.01664834623533`", ",", 
          "4.02918016910215`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45691979725866`", ",", "2.01253213027263`", ",", 
          "4.67151323953873`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13136112689458`", ",", "2.00842391131707`", ",", 
          "5.3138463099753`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52261714935091`", ",", "2.00432357400218`", ",", 
          "5.95617938041188`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19705847898683`", ",", "2.00023100459255`", ",", 
          "0.315327143668864`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58831450144317`", ",", "1.99614609094501`", ",", 
          "0.957660214105439`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26275583107909`", ",", "1.99206872247103`", ",", 
          "1.59999328454201`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.654011853535422`", ",", "1.98799879010007`", ",", 
          "2.24232635497859`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32845318317134`", ",", "1.98393618624398`", ",", 
          "2.88465942541516`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00289451280726`", ",", "1.97988080476234`", ",", 
          "3.52699249585174`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3941505352636`", ",", "1.97583254092878`", ",", 
          "4.16932556628831`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06859186489952`", ",", "1.97179129139816`", ",", 
          "4.81165863672489`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45984788735585`", ",", "1.96775695417464`", ",", 
          "5.45399170716146`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13428921699177`", ",", "1.96372942858062`", ",", 
          "6.09632477759804`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.525545239448107`", ",", "1.95970861522647`", ",", 
          "0.455472540855026`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19998656908403`", ",", "1.95569441598104`", ",", 
          "1.0978056112916`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87442789871995`", ",", "1.95168673394296`", ",", 
          "1.74013868172818`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26568392117628`", ",", "1.94768547341266`", ",", 
          "2.38247175216475`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9401252508122`", ",", "1.94369053986511`", ",", 
          "3.02480482260132`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33138127326854`", ",", "1.93970183992325`", ",", 
          "3.6671378930379`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00582260290446`", ",", "1.93571928133211`", ",", 
          "4.30947096347447`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.397078625360792`", ",", "1.93174277293349`", ",", 
          "4.95180403391105`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07151995499671`", ",", "1.92777222464139`", ",", 
          "5.59413710434763`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74596128463263`", ",", "1.92380754741795`", ",", 
          "6.2364701747842`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13721730708897`", ",", "1.91984865325`", ",", 
          "0.595617938041188`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81165863672489`", ",", "1.91589545512623`", ",", 
          "1.23795100847776`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20291465918122`", ",", "1.91194786701478`", ",", 
          "1.88028407891434`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87735598881714`", ",", "1.90800580384152`", ",", 
          "2.52261714935091`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.268612011273477`", ",", "1.90406918146873`", ",", 
          "3.16495021978749`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9430533409094`", ",", "1.90013791667432`", ",", 
          "3.80728329022406`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61749467054532`", ",", "1.89621192713153`", ",", 
          "4.44961636066064`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00875069300165`", ",", "1.8922911313891`", ",", 
          "5.09194943109721`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68319202263757`", ",", "1.88837544885189`", ",", 
          "5.73428250153379`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07444804509391`", ",", "1.88446479976193`", ",", 
          "0.0934302647907745`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74888937472983`", ",", "1.8805591051799`", ",", 
          "0.735763335227349`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.140145397186162`", ",", "1.87665828696705`", ",", 
          "1.37809640566392`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81458672682208`", ",", "1.87276226776747`", ",", 
          "2.0204294761005`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.489028056458`", ",", "1.86887097099081`", ",", 
          "2.66276254653707`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88028407891434`", ",", "1.86498432079528`", ",", 
          "3.30509561697365`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55472540855026`", ",", "1.86110224207114`", ",", 
          "3.94742868741022`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.945981431006592`", ",", "1.85722466042444`", ",", 
          "4.5897617578468`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62042276064251`", ",", "1.85335150216116`", ",", 
          "5.23209482828337`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0116787830988468`", ",", "1.84948269427165`", ",", 
          "5.87442789871995`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68612011273477`", ",", "1.84561816441539`", ",", 
          "0.233575661976936`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36056144237069`", ",", "1.84175784090614`", ",", 
          "0.875908732413511`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75181746482702`", ",", "1.83790165269727`", ",", 
          "1.51824180285009`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42625879446294`", ",", "1.83404952936746`", ",", 
          "2.16057487328666`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.817514816919277`", ",", "1.83020140110672`", ",", 
          "2.80290794372324`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4919561465552`", ",", "1.82635719870257`", ",", 
          "3.44524101415981`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16639747619112`", ",", "1.82251685352659`", ",", 
          "4.08757408459639`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55765349864745`", ",", "1.81868029752123`", ",", 
          "4.72990715503296`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23209482828337`", ",", "1.81484746318679`", ",", 
          "5.37224022546953`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62335085073971`", ",", "1.81101828356874`", ",", 
          "6.01457329590611`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29779218037563`", ",", "1.80719269224519`", ",", 
          "0.373721059163098`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.689048202831962`", ",", "1.8033706233147`", ",", 
          "1.01605412959967`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36348953246788`", ",", "1.79955201138421`", ",", 
          "1.65838720003625`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0379308621038`", ",", "1.79573679155723`", ",", 
          "2.30072027047282`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42918688456014`", ",", "1.79192489942227`", ",", 
          "2.9430533409094`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10362821419606`", ",", "1.78811627104141`", ",", 
          "3.58538641134597`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49488423665239`", ",", "1.78431084293915`", ",", 
          "4.22771948178255`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16932556628831`", ",", "1.78050855209135`", ",", 
          "4.87005255221912`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.560581588744647`", ",", "1.77670933591447`", ",", 
          "5.5123856226557`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23502291838057`", ",", "1.77291313225493`", ",", 
          "6.15471869309227`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90946424801649`", ",", "1.7691198793786`", ",", 
          "0.51386645634926`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30072027047282`", ",", "1.76532951596059`", ",", 
          "1.15619952678583`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97516160010874`", ",", "1.76154198107507`", ",", 
          "1.79853259722241`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36641762256508`", ",", "1.75775721418537`", ",", 
          "2.44086566765898`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.040858952201`", ",", "1.75397515513409`", ",", 
          "3.08319873809556`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.432114974657332`", ",", "1.75019574413355`", ",", 
          "3.72553180853213`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10655630429325`", ",", "1.74641892175619`", ",", 
          "4.36786487896871`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78099763392917`", ",", "1.74264462892529`", ",", 
          "5.01019794940528`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17225365638551`", ",", "1.73887280690568`", ",", 
          "5.65253101984186`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84669498602143`", ",", "1.73510339729466`", ",", 
          "0.0116787830988468`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23795100847776`", ",", "1.73133634201306`", ",", 
          "0.654011853535422`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91239233811368`", ",", "1.72757158329639`", ",", 
          "1.296344923972`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.303648360570017`", ",", "1.72380906368609`", ",", 
          "1.93867799440857`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97808969020594`", ",", "1.72004872602098`", ",", 
          "2.58101106484515`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65253101984186`", ",", "1.71629051342873`", ",", 
          "3.22334413528172`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04378704229819`", ",", "1.71253436931751`", ",", 
          "3.8656772057183`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71822837193411`", ",", "1.70878023736768`", ",", 
          "4.50801027615487`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10948439439045`", ",", "1.70502806152366`", ",", 
          "5.15034334659145`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78392572402637`", ",", "1.70127778598583`", ",", 
          "5.79267641702802`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.175181746482702`", ",", "1.69752935520256`", ",", 
          "0.151824180285009`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84962307611862`", ",", "1.69378271386233`", ",", 
          "0.794157250721583`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52406440575454`", ",", "1.69003780688593`", ",", 
          "1.43649032115816`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91532042821088`", ",", "1.68629457941875`", ",", 
          "2.07882339159473`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5897617578468`", ",", "1.68255297682314`", ",", 
          "2.72115646203131`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.981017780303132`", ",", "1.67881294467087`", ",", 
          "3.36348953246788`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65545910993905`", ",", "1.67507442873569`", ",", 
          "4.00582260290446`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0467151323953873`", ",", "1.67133737498584`", ",", 
          "4.64815567334103`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72115646203131`", ",", "1.66760172957684`", ",", 
          "5.29048874377761`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39559779166723`", ",", "1.66386743884412`", ",", 
          "5.93282181421418`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78685381412356`", ",", "1.6601344492959`", ",", 
          "0.29196957747117`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46129514375948`", ",", "1.65640270760601`", ",", 
          "0.934302647907745`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.852551166215817`", ",", "1.65267216060684`", ",", 
          "1.57663571834432`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52699249585174`", ",", "1.64894275528229`", ",", 
          "2.21896878878089`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20143382548766`", ",", "1.64521443876085`", ",", 
          "2.86130185921747`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59268984794399`", ",", "1.64148715830865`", ",", 
          "3.50363492965404`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26713117757991`", ",", "1.63776086132261`", ",", 
          "4.14596800009062`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65838720003625`", ",", "1.63403549532359`", ",", 
          "4.78830107052719`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33282852967217`", ",", "1.63031100794969`", ",", 
          "5.43063414096377`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.724084552128503`", ",", "1.62658734694943`", ",", 
          "6.07296721140034`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39852588176442`", ",", "1.6228644601751`", ",", 
          "0.432114974657332`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07296721140034`", ",", "1.61914229557609`", ",", 
          "1.07444804509391`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46422323385668`", ",", "1.61542080119228`", ",", 
          "1.71678111553048`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1386645634926`", ",", "1.61169992514743`", ",", 
          "2.35911418596706`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52992058594893`", ",", "1.6079796156426`", ",", 
          "3.00144725640363`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20436191558485`", ",", "1.60425982094966`", ",", 
          "3.64378032684021`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.595617938041188`", ",", "1.60054048940474`", ",", 
          "4.28611339727678`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27005926767711`", ",", "1.59682156940174`", ",", 
          "4.92844646771336`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94450059731303`", ",", "1.59310300938588`", ",", 
          "5.57077953814993`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33575661976936`", ",", "1.58938475784725`", ",", 
          "6.21311260858651`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01019794940528`", ",", "1.58566676331432`", ",", 
          "0.572260371843494`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40145397186162`", ",", "1.5819489743476`", ",", 
          "1.21459344228007`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07589530149754`", ",", "1.57823133953315`", ",", 
          "1.85692651271664`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.467151323953873`", ",", "1.57451380747624`", ",", 
          "2.49925958315322`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81603398322571`", ",", "1.56707884611356`", ",", 
          "3.78392572402637`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20729000568205`", ",", "1.56336131405664`", ",", 
          "4.42625879446294`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88173133531797`", ",", "1.5596436792422`", ",", 
          "5.06859186489952`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2729873577743`", ",", "1.55592589027547`", ",", 
          "5.71092493533609`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94742868741022`", ",", "1.55220789574255`", ",", 
          "0.0700726985930809`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.338684709866558`", ",", "1.54848964420391`", ",", 
          "0.712405769029656`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01312603950248`", ",", "1.54477108418805`", ",", 
          "1.35473883946623`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6875673691384`", ",", "1.54105216418506`", ",", 
          "1.99707190990281`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07882339159473`", ",", "1.53733283264013`", ",", 
          "2.63940498033938`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75326472123065`", ",", "1.53361303794719`", ",", 
          "3.28173805077595`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14452074368699`", ",", "1.52989272844237`", ",", 
          "3.92407112121253`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81896207332291`", ",", "1.52617185239751`", ",", 
          "4.5664041916491`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.210218095779243`", ",", "1.5224503580137`", ",", 
          "5.20873726208568`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88465942541516`", ",", "1.5187281934147`", ",", 
          "5.85107033252225`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55910075505108`", ",", "1.51500530664036`", ",", 
          "0.210218095779243`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95035677750742`", ",", "1.5112816456401`", ",", 
          "0.852551166215817`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62479810714334`", ",", "1.5075571582662`", ",", 
          "1.49488423665239`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01605412959967`", ",", "1.50383179226719`", ",", 
          "2.13721730708897`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69049545923559`", ",", "1.50010549528114`", ",", 
          "2.77955037752554`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0817514816919277`", ",", "1.49637821482894`", ",", 
          "3.42188344796212`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75619281132785`", ",", "1.4926498983075`", ",", 
          "4.06421651839869`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43063414096377`", ",", "1.48892049298296`", ",", 
          "4.70654958883527`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8218901634201`", ",", "1.48518994598378`", ",", 
          "5.34888265927184`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49633149305602`", ",", "1.48145820429389`", ",", 
          "5.99121572970842`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.887587515512358`", ",", "1.47772521474567`", ",", 
          "0.350363492965404`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56202884514828`", ",", "1.47399092401295`", ",", 
          "0.992696563401979`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2364701747842`", ",", "1.47025527860395`", ",", 
          "1.63502963383855`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62772619724053`", ",", "1.46651822485411`", ",", 
          "2.27736270427513`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30216752687645`", ",", "1.46277970891892`", ",", 
          "2.9196957747117`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69342354933279`", ",", "1.45903967676666`", ",", 
          "3.56202884514828`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36786487896871`", ",", "1.45529807417104`", ",", 
          "4.20436191558485`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.759120901425043`", ",", "1.45155484670386`", ",", 
          "4.84669498602143`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43356223106096`", ",", "1.44780993972746`", ",", 
          "5.489028056458`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10800356069688`", ",", "1.44406329838723`", ",", 
          "6.13136112689458`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49925958315322`", ",", "1.44031486760397`", ",", 
          "0.490508890151566`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17370091278914`", ",", "1.43656459206613`", ",", 
          "1.13284196058814`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56495693524547`", ",", "1.43281241622211`", ",", 
          "1.77517503102472`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23939826488139`", ",", "1.42905828427228`", ",", 
          "2.41750810146129`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.630654287337728`", ",", "1.42530214016106`", ",", 
          "3.05984117189787`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30509561697365`", ",", "1.42154392756881`", ",", 
          "3.70217424233444`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97953694660957`", ",", "1.4177835899037`", ",", 
          "4.34450731277102`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3707929690659`", ",", "1.41402107029341`", ",", 
          "4.98684038320759`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04523429870182`", ",", "1.41025631157673`", ",", 
          "5.62917345364416`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43649032115816`", ",", "1.40648925629514`", ",", 
          "6.27150652408074`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11093165079408`", ",", "1.40271984668412`", ",", 
          "0.630654287337728`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.502187673250413`", ",", "1.3989480246645`", ",", 
          "1.2729873577743`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17662900288633`", ",", "1.3951737318336`", ",", 
          "1.91532042821088`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85107033252225`", ",", "1.39139690945625`", ",", 
          "2.55765349864745`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24232635497859`", ",", "1.3876174984557`", ",", 
          "3.19998656908403`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91676768461451`", ",", "1.38383543940443`", ",", 
          "3.8423196395206`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30802370707084`", ",", "1.38005067251472`", ",", 
          "4.48465270995718`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98246503670676`", ",", "1.37626313762921`", ",", 
          "5.12698578039375`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.373721059163098`", ",", "1.3724727742112`", ",", 
          "5.76931885083033`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04816238879902`", ",", "1.36867952133487`", ",", 
          "0.128466614087315`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72260371843494`", ",", "1.36488331767532`", ",", 
          "0.77079968452389`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11385974089127`", ",", "1.36108410149845`", ",", 
          "1.41313275496046`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78830107052719`", ",", "1.35728181065065`", ",", 
          "2.05546582539704`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17955709298353`", ",", "1.35347638254838`", ",", 
          "2.69779889583361`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85399842261945`", ",", "1.34966775416752`", ",", 
          "3.34013196627019`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.245254445075783`", ",", "1.34585586203256`", ",", 
          "3.98246503670676`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9196957747117`", ",", "1.34204064220558`", ",", 
          "4.62479810714334`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59413710434763`", ",", "1.33822203027509`", ",", 
          "5.26713117757991`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98539312680396`", ",", "1.3343999613446`", ",", 
          "5.90946424801649`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65983445643988`", ",", "1.33057437002106`", ",", 
          "0.268612011273477`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05109047889621`", ",", "1.326745190403`", ",", 
          "0.910945081710052`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72553180853213`", ",", "1.32291235606856`", ",", 
          "1.55327815214663`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.116787830988468`", ",", "1.3190758000632`", ",", 
          "2.1956112225832`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79122916062439`", ",", "1.31523545488723`", ",", 
          "2.83794429301978`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46567049026031`", ",", "1.31139125248307`", ",", 
          "3.48027736345635`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85692651271664`", ",", "1.30754312422233`", ",", 
          "4.12261043389293`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53136784235256`", ",", "1.30369100089253`", ",", 
          "4.7649435043295`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.922623864808898`", ",", "1.29983481268365`", ",", 
          "5.40727657476608`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59706519444482`", ",", "1.2959744891744`", ",", 
          "6.04960964520265`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27150652408074`", ",", "1.29210995931815`", ",", 
          "0.408757408459639`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66276254653707`", ",", "1.28824115142863`", ",", 
          "1.05109047889621`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33720387617299`", ",", "1.28436799316535`", ",", 
          "1.69342354933279`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72845989862933`", ",", "1.28049041151865`", ",", 
          "2.33575661976936`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40290122826525`", ",", "1.27660833279451`", ",", 
          "2.97808969020594`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.794157250721583`", ",", "1.27272168259899`", ",", 
          "3.62042276064251`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4685985803575`", ",", "1.26883038582232`", ",", 
          "4.26275583107909`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14303990999342`", ",", "1.26493436662275`", ",", 
          "4.90508890151566`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53429593244976`", ",", "1.2610335484099`", ",", 
          "5.54742197195224`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20873726208568`", ",", "1.25712785382787`", ",", 
          "6.18975504238881`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59999328454201`", ",", "1.2532172047379`", ",", 
          "0.5489028056458`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27443461417793`", ",", "1.24930152220069`", ",", 
          "1.19123587608238`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.665690636634268`", ",", "1.24538072645826`", ",", 
          "1.83356894651895`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34013196627019`", ",", "1.24145473691548`", ",", 
          "2.47590201695552`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01457329590611`", ",", "1.23752347212107`", ",", 
          "3.1182350873921`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40582931836244`", ",", "1.23358684974828`", ",", 
          "3.76056815782867`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08027064799836`", ",", "1.22964478657502`", ",", 
          "4.40290122826525`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4715266704547`", ",", "1.22569719846357`", ",", 
          "5.04523429870182`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14596800009062`", ",", "1.22174400033979`", ",", 
          "5.6875673691384`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.537224022546953`", ",", "1.21778510617185`", ",", 
          "0.0467151323953873`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21166535218287`", ",", "1.21382042894841`", ",", 
          "0.689048202831962`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8861066818188`", ",", "1.20984988065631`", ",", 
          "1.33138127326854`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27736270427513`", ",", "1.20587337225769`", ",", 
          "1.97371434370511`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95180403391105`", ",", "1.20189081366654`", ",", 
          "2.61604741414169`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34306005636738`", ",", "1.19790211372469`", ",", 
          "3.25838048457826`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0175013860033`", ",", "1.19390718017714`", ",", 
          "3.90071355501484`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.408757408459639`", ",", "1.18990591964683`", ",", 
          "4.54304662545141`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08319873809556`", ",", "1.18589823760875`", ",", 
          "5.18537969588799`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75764006773148`", ",", "1.18188403836332`", ",", 
          "5.82771276632456`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14889609018781`", ",", "1.17786322500917`", ",", 
          "0.186860529581549`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82333741982373`", ",", "1.17383569941516`", ",", 
          "0.829193600018124`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21459344228007`", ",", "1.16980136219164`", ",", 
          "1.4715266704547`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88903477191599`", ",", "1.16576011266101`", ",", 
          "2.11385974089127`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.280290794372323`", ",", "1.16171184882745`", ",", 
          "2.75619281132785`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95473212400824`", ",", "1.15765646734581`", ",", 
          "3.39852588176442`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62917345364416`", ",", "1.15359386348972`", ",", 
          "4.040858952201`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0204294761005`", ",", "1.14952393111876`", ",", 
          "4.68319202263757`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69487080573642`", ",", "1.14544656264478`", ",", 
          "5.32552509307415`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08612682819275`", ",", "1.14136164899724`", ",", 
          "5.96785816351072`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76056815782867`", ",", "1.13726907958761`", ",", 
          "0.327005926767711`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.151824180285009`", ",", "1.13316874227273`", ",", 
          "0.969338997204286`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82626550992093`", ",", "1.12906052331716`", ",", 
          "1.61167206764086`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50070683955685`", ",", "1.12494430735446`", ",", 
          "2.25400513807743`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89196286201318`", ",", "1.12081997734729`", ",", 
          "2.89633820851401`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5664041916491`", ",", "1.1166874145464`", ",", 
          "3.53867127895058`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.957660214105439`", ",", "1.11254649844846`", ",", 
          "4.18100434938716`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63210154374136`", ",", "1.10839710675249`", ",", 
          "4.82333741982373`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0233575661976936`", ",", "1.1042391153152`", ",", 
          "5.46567049026031`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69779889583361`", ",", "1.10007239810481`", ",", 
          "6.10800356069688`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37224022546953`", ",", "1.09589682715359`", ",", 
          "0.467151323953873`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76349624792587`", ",", "1.09171227250887`", ",", 
          "1.10948439439045`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43793757756179`", ",", "1.08751860218265`", ",", 
          "1.75181746482702`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.829193600018124`", ",", "1.08331568209954`", ",", 
          "2.3941505352636`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50363492965404`", ",", "1.07910337604315`", ",", 
          "3.03648360570017`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17807625928996`", ",", "1.07488154560078`", ",", 
          "3.67881667613675`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5693322817463`", ",", "1.07065005010635`", ",", 
          "4.32114974657332`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24377361138222`", ",", "1.06640874658149`", ",", 
          "4.9634828170099`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63502963383855`", ",", "1.06215748967481`", ",", 
          "5.60581588744647`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30947096347447`", ",", "1.05789613159913`", ",", 
          "6.24814895788305`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.700726985930809`", ",", "1.05362452206668`", ",", 
          "0.607296721140034`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37516831556673`", ",", "1.04934250822217`", ",", 
          "1.24962979157661`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04960964520265`", ",", "1.04504993457367`", ",", 
          "1.89196286201318`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44086566765898`", ",", "1.04074664292115`", ",", 
          "2.53429593244976`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11530699729491`", ",", "1.03643247228257`", ",", 
          "3.17662900288633`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50656301975124`", ",", "1.03210725881757`", ",", 
          "3.81896207332291`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18100434938716`", ",", "1.02777083574846`", ",", 
          "4.46129514375948`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.572260371843494`", ",", "1.02342303327848`", ",", 
          "5.10362821419606`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24670170147941`", ",", "1.01906367850728`", ",", 
          "5.74596128463263`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92114303111534`", ",", "1.01469259534339`", ",", 
          "0.105109047889621`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31239905357167`", ",", "1.01030960441359`", ",", 
          "0.747442118326196`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98684038320759`", ",", "1.00591452296909`", ",", 
          "1.38977518876277`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37809640566392`", ",", "1.00150716478825`", ",", 
          "2.03210825919935`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05253773529985`", ",", "0.997087340075911`", ",", 
          "2.67444132963592`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.443793757756179`", ",", "0.992654855358898`", ",", 
          "3.3167744000725`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1182350873921`", ",", "0.988209513377771`", ",", 
          "3.95910747050907`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79267641702802`", ",", "0.983751112974509`", ",", 
          "4.60144054094565`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18393243948435`", ",", "0.97927944897599`", ",", 
          "5.24377361138222`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85837376912028`", ",", "0.974794312073062`", ",", 
          "5.8861066818188`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24962979157661`", ",", "0.970295488694999`", ",", 
          "0.245254445075783`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92407112121253`", ",", "0.965782760879124`", ",", 
          "0.887587515512358`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.315327143668864`", ",", "0.961255906135373`", ",", 
          "1.52992058594893`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98976847330478`", ",", "0.956714697305546`", ",", 
          "2.17225365638551`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6642098029407`", ",", "0.952158902416998`", ",", 
          "2.81458672682208`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05546582539704`", ",", "0.947588284530492`", ",", 
          "3.45691979725866`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72990715503296`", ",", "0.943002601581927`", ",", 
          "4.09925286769523`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12116317748929`", ",", "0.93840160621764`", ",", 
          "4.74158593813181`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79560450712521`", ",", "0.933785045622949`", ",", 
          "5.38391900856838`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.186860529581549`", ",", "0.92915266134361`", ",", 
          "6.02625207900496`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86130185921747`", ",", "0.924504189099804`", ",", 
          "0.385399842261945`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53574318885339`", ",", "0.919839358592293`", ",", 
          "1.02773291269852`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92699921130972`", ",", "0.915157893300314`", ",", 
          "1.67006598313509`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60144054094565`", ",", "0.91045951027079`", ",", 
          "2.31239905357167`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.992696563401979`", ",", "0.905743919898393`", ",", 
          "2.95473212400824`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6671378930379`", ",", "0.901010825695964`", ",", 
          "3.59706519444482`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0583939154942341`", ",", "0.896259924054776`", ",", 
          "4.23939826488139`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73283524513015`", ",", "0.891490903994077`", ",", 
          "4.88173133531797`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40727657476608`", ",", "0.886703446899318`", ",", 
          "5.52406440575454`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79853259722241`", ",", "0.88189722624845`", ",", 
          "6.16639747619112`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47297392685833`", ",", "0.877071907325596`", ",", 
          "0.525545239448107`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.864229949314664`", ",", "0.872227146921395`", ",", 
          "1.16787830988468`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53867127895058`", ",", "0.867362593019242`", ",", 
          "1.81021138032126`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21311260858651`", ",", "0.862477884466609`", ",", 
          "2.45254445075783`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60436863104284`", ",", "0.857572650630564`", ",", 
          "3.09487752119441`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27880996067876`", ",", "0.852646511036559`", ",", 
          "3.73721059163098`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67006598313509`", ",", "0.847699074989466`", ",", 
          "4.37954366206756`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34450731277102`", ",", "0.842729941175799`", ",", 
          "5.02187673250413`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.735763335227349`", ",", "0.837738697245963`", ",", 
          "5.6642098029407`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41020466486327`", ",", "0.832724919375276`", ",", 
          "0.0233575661976936`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08464599449919`", ",", "0.827688171802454`", ",", 
          "0.665690636634268`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47590201695552`", ",", "0.82262800634411`", ",", 
          "1.30802370707084`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15034334659145`", ",", "0.817543961883733`", ",", 
          "1.95035677750742`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54159936904778`", ",", "0.812435563833481`", ",", 
          "2.59268984794399`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2160406986837`", ",", "0.807302323567017`", ",", 
          "3.23502291838057`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.607296721140034`", ",", "0.80214373782143`", ",", 
          "3.87735598881714`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28173805077595`", ",", "0.796959288066194`", ",", 
          "4.51968905925372`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95617938041188`", ",", "0.791748439836881`", ",", 
          "5.16202212969029`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34743540286821`", ",", "0.78651064203122`", ",", 
          "5.80435520012687`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02187673250413`", ",", "0.781245326164852`", ",", 
          "0.163502963383855`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41313275496046`", ",", "0.77595190558393`", ",", 
          "0.80583603382043`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08757408459639`", ",", "0.77062977463147`", ",", 
          "1.44816910425701`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.478830107052719`", ",", "0.765278307764085`", ",", 
          "2.09050217469358`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15327143668864`", ",", "0.759896858615439`", ",", 
          "2.73283524513015`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82771276632456`", ",", "0.754484759002466`", ",", 
          "3.37516831556673`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21896878878089`", ",", "0.749041317869982`", ",", 
          "4.0175013860033`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89341011841682`", ",", "0.743565820168997`", ",", 
          "4.65983445643988`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28466614087315`", ",", "0.738057525663545`", ",", 
          "5.30216752687645`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95910747050907`", ",", "0.732515667660383`", ",", 
          "5.94450059731303`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.350363492965404`", ",", "0.726939451655403`", ",", 
          "0.303648360570017`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02480482260132`", ",", "0.721328053889951`", ",", 
          "0.945981431006592`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69924615223725`", ",", "0.715680619809658`", ",", 
          "1.58831450144317`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09050217469358`", ",", "0.709996262417575`", ",", 
          "2.23064757187974`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7649435043295`", ",", "0.704274060512659`", ",", 
          "2.87298064231632`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15619952678583`", ",", "0.698513056803678`", ",", 
          "3.51531371275289`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83064085642175`", ",", "0.692712255887611`", ",", 
          "4.15764678318947`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.221896878878089`", ",", "0.686870622080455`", ",", 
          "4.79997985362604`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89633820851401`", ",", "0.680987077087058`", ",", 
          "5.44231292406262`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57077953814993`", ",", "0.675060497495144`", ",", 
          "6.08464599449919`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96203556060627`", ",", "0.669089712077036`", ",", 
          "0.443793757756179`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63647689024219`", ",", "0.663073498880753`", ",", 
          "1.08612682819275`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02773291269852`", ",", "0.657010582090029`", ",", 
          "1.72845989862933`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70217424233444`", ",", "0.650899628630437`", ",", 
          "2.3707929690659`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0934302647907745`", ",", "0.644739244496062`", ",", 
          "3.01312603950248`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76787159442669`", ",", "0.638527970768109`", ",", 
          "3.65545910993905`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44231292406262`", ",", "0.63226427929327`", ",", 
          "4.29779218037563`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83356894651895`", ",", "0.625946567985649`", ",", 
          "4.9401252508122`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50801027615487`", ",", "0.619573155711386`", ",", 
          "5.58245832124878`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.899266298611205`", ",", "0.613142276709796`", ",", 
          "6.22479139168535`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57370762824713`", ",", "0.606652074498664`", ",", 
          "0.583939154942341`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24814895788305`", ",", "0.600100595204187`", ",", 
          "1.22627222537892`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63940498033938`", ",", "0.593485780247815`", ",", 
          "1.86860529581549`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3138463099753`", ",", "0.58680545831255`", ",", 
          "2.51093836625206`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70510233243163`", ",", "0.580057336500052`", ",", 
          "3.15327143668864`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37954366206756`", ",", "0.573238990576677`", ",", 
          "3.79560450712521`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.77079968452389`", ",", "0.566347854191103`", ",", 
          "4.43793757756179`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44524101415981`", ",", "0.559381206927871`", ",", 
          "5.08027064799836`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11968234379573`", ",", "0.552336161039526`", ",", 
          "5.72260371843494`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51093836625206`", ",", "0.5452096466743`", ",", 
          "0.0817514816919277`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18537969588799`", ",", "0.537998395385502`", ",", 
          "0.724084552128503`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57663571834432`", ",", "0.53069892167195`", ",", 
          "1.36641762256508`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25107704798024`", ",", "0.523307502254379`", ",", 
          "2.00875069300165`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.642333070436575`", ",", "0.515820152739047`", ",", 
          "2.65108376343823`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3167744000725`", ",", "0.508232601254438`", ",", 
          "3.2934168338748`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99121572970842`", ",", "0.500540258567118`", ",", 
          "3.93574990431138`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38247175216475`", ",", "0.492738184084626`", ",", 
          "4.57808297474795`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05691308180067`", ",", "0.484821047031908`", ",", 
          "5.22041604518453`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44816910425701`", ",", "0.476783081936769`", ",", 
          "5.8627491156211`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12261043389293`", ",", "0.468618037370673`", ",", 
          "0.221896878878089`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.51386645634926`", ",", "0.460319116652629`", ",", 
          "0.864229949314664`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18830778598518`", ",", "0.451878908920773`", ",", 
          "1.50656301975124`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8627491156211`", ",", "0.443289308587943`", ",", 
          "2.14889609018781`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25400513807743`", ",", "0.434541420695981`", ",", 
          "2.79122916062439`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92844646771336`", ",", "0.42562544902966`", ",", 
          "3.43356223106096`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31970249016969`", ",", "0.416530562990378`", ",", 
          "4.07589530149754`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99414381980561`", ",", "0.40724473808473`", ",", 
          "4.71822837193411`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.385399842261945`", ",", "0.397754563342265`", ",", 
          "5.36056144237069`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05984117189787`", ",", "0.388045006877709`", ",", 
          "6.00289451280726`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73428250153379`", ",", "0.378099127914759`", ",", 
          "0.362042276064251`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12553852399012`", ",", "0.367897719527857`", ",", 
          "1.00437534650083`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79997985362604`", ",", "0.357418860576621`", ",", 
          "1.6467084169374`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19123587608238`", ",", "0.346637346928255`", ",", 
          "2.28904148737398`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8656772057183`", ",", "0.335523959678856`", ",", 
          "2.93137455781055`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.25693322817463`", ",", "0.324044509376599`", ",", 
          "3.57370762824713`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93137455781055`", ",", "0.312158566289263`", ",", 
          "4.2160406986837`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60581588744647`", ",", "0.299817740670947`", ",", 
          "4.85837376912028`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99707190990281`", ",", "0.286963301295268`", ",", 
          "5.50070683955685`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67151323953873`", ",", "0.273522791647743`", ",", 
          "6.14303990999342`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06276926199506`", ",", "0.259405074311824`", ",", 
          "0.502187673250413`"}], "}"}], ",", "0.00185873605947955`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73721059163098`", ",", "0.244492807031865`", ",", 
          "1.14452074368699`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.128466614087315`", ",", "0.228630508333467`", ",", 
          "1.78685381412356`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80290794372324`", ",", "0.211604570185986`", ",", 
          "2.42918688456014`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47734927335916`", ",", "0.193107376268304`", ",", 
          "3.07151995499671`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86860529581549`", ",", "0.172666659041583`", ",", 
          "3.71385302543329`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54304662545141`", ",", "0.149487174205358`", ",", 
          "4.35618609586986`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.934302647907745`", ",", "0.122017831598163`", ",", 
          "4.99851916630644`"}], "}"}], ",", "0.00185873605947955`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60874397754367`", ",", "0.0862528570132178`", ",", 
          "5.64085223674301`"}], "}"}], ",", "0.00185873605947955`"}], 
       "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.460273662680175*^9, 3.4602736672802677`*^9}, {3.460278683630114*^9, 
   3.460278697049426*^9}, 3.460288008173973*^9, {3.460292433727244*^9, 
   3.4602924628338213`*^9}, {3.502932879583336*^9, 3.5029328835921164`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW1154", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.4537268931515083`*^9}, {
  3.460292425263933*^9, 3.460292425887959*^9}, {3.460292474899384*^9, 
  3.460292475401424*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW1154\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 1154 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW1154\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.000866551126516464`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47551405393905`", ",", "3.08270966637346`", ",", 
          "0.582583039747154`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95102810787811`", ",", "3.05830749539262`", ",", 
          "1.16516607949431`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42654216181716`", ",", "3.03957482689826`", ",", 
          "1.74774911924146`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90205621575621`", ",", "3.02377556172199`", ",", 
          "2.33033215898862`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09438496251568`", ",", "3.00985006027238`", ",", 
          "2.91291519873577`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56989901645474`", ",", "2.99725495567043`", ",", 
          "3.49549823848292`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04541307039379`", ",", "2.98566751005344`", ",", 
          "4.07808127823008`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52092712433284`", ",", "2.97487747206915`", ",", 
          "4.66066431797723`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.71325587109231`", ",", "2.96473882142373`", ",", 
          "5.24324735772439`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18876992503136`", ",", "2.95514525665563`", ",", 
          "5.82583039747154`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66428397897042`", ",", "2.94601654001621`", ",", 
          "0.125228130039108`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13979803290947`", ",", "2.93729034345785`", ",", 
          "0.707811169786262`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.332126779668938`", ",", "2.92891710763684`", ",", 
          "1.29039420953342`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80764083360799`", ",", "2.92085665557602`", ",", 
          "1.87297724928057`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28315488754705`", ",", "2.91307588023362`", ",", 
          "2.45556028902772`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7586689414861`", ",", "2.90554711693975`", ",", 
          "3.03814332877488`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23418299542515`", ",", "2.89824696799916`", ",", 
          "3.62072636852203`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42651174218462`", ",", "2.89115543479899`", ",", 
          "4.20330940826919`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90202579612367`", ",", "2.88425526446748`", ",", 
          "4.78589244801634`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37753985006273`", ",", "2.87753144961703`", ",", 
          "5.36847548776349`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85305390400178`", ",", "2.87097083949097`", ",", 
          "5.95105852751065`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04538265076125`", ",", "2.86456183361604`", ",", 
          "0.250456260078216`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5208967047003`", ",", "2.85829413752415`", ",", 
          "0.83303929982537`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99641075863936`", ",", "2.85215856583294`", ",", 
          "1.41562233957252`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47192481257841`", ",", "2.84614688192532`", ",", 
          "1.99820537931968`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.664253559337877`", ",", "2.84025166624304`", ",", 
          "2.58078841906683`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13976761327693`", ",", "2.83446620718985`", ",", 
          "3.16337145881399`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61528166721598`", ",", "2.82878441007465`", ",", 
          "3.74595449856114`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09079572115504`", ",", "2.82320072057737`", ",", 
          "4.32853753830829`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.283124467914505`", ",", "2.81771006000377`", ",", 
          "4.91112057805545`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75863852185356`", ",", "2.8123077701828`", ",", 
          "5.4937036178026`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23415257579261`", ",", "2.80698956630773`", ",", 
          "6.07628665754976`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70966662973167`", ",", "2.80175149636474`", ",", 
          "0.375684390117324`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18518068367072`", ",", "2.79658990605813`", ",", 
          "0.958267429864478`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37750943043019`", ",", "2.7915014083487`", ",", 
          "1.54085046961163`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85302348436924`", ",", "2.78648285688478`", ",", 
          "2.12343350935879`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32853753830829`", ",", "2.78153132273459`", ",", 
          "2.70601654910594`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80405159224735`", ",", "2.77664407393241`", ",", 
          "3.28859958885309`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.996380339006815`", ",", "2.77181855743314`", ",", 
          "3.87118262860025`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47189439294587`", ",", "2.76705238313789`", ",", 
          "4.4537656683474`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94740844688492`", ",", "2.76234330970707`", ",", 
          "5.03634870809456`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42292250082398`", ",", "2.75768923192268`", ",", 
          "5.61893174784171`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.615251247583443`", ",", "2.75308816939772`", ",", 
          "6.20151478758886`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0907653015225`", ",", "2.74853825646155`", ",", 
          "0.500912520156431`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56627935546155`", ",", "2.74403773307469`", ",", 
          "1.08349555990359`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0417934094006`", ",", "2.73958493664794`", ",", 
          "1.66607859965074`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.234122156160071`", ",", "2.73517829465827`", ",", 
          "2.24866163939789`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70963621009912`", ",", "2.73081631796848`", ",", 
          "2.83124467914505`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18515026403818`", ",", "2.72649759477052`", ",", 
          "3.4138277188922`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66066431797723`", ",", "2.72222078508269`", ",", 
          "3.99641075863936`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13617837191629`", ",", "2.71798461574008`", ",", 
          "4.57899379838651`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32850711867575`", ",", "2.71378787582523`", ",", 
          "5.16157683813366`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80402117261481`", ",", "2.70962941249273`", ",", 
          "5.74415987788082`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27953522655386`", ",", "2.70550812714694`", ",", 
          "0.0435576104483854`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75504928049291`", ",", "2.7014229719371`", ",", 
          "0.626140650195539`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.947378027252381`", ",", "2.6973729465381`", ",", 
          "1.20872368994269`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42289208119143`", ",", "2.69335709518909`", ",", 
          "1.79130672968985`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89840613513049`", ",", "2.68937450396503`", ",", 
          "2.373889769437`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37392018906954`", ",", "2.68542429825926`", ",", 
          "2.95647280918416`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.56624893582901`", ",", "2.68150564045738`", ",", 
          "3.53905584893131`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04176298976806`", ",", "2.6776177277851`", ",", 
          "4.12163888867846`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51727704370712`", ",", "2.6737597903143`", ",", 
          "4.70422192842562`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99279109764617`", ",", "2.66993108911341`", ",", 
          "5.28680496817277`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.185119844405638`", ",", "2.66613091452945`", ",", 
          "5.86938800791993`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66063389834469`", ",", "2.66235858459057`", ",", 
          "0.168785740487493`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13614795228374`", ",", "2.65861344351887`", ",", 
          "0.751368780234647`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6116620062228`", ",", "2.65489486034424`", ",", 
          "1.3339518199818`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08717606016185`", ",", "2.65120222761118`", ",", 
          "1.91653485972896`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27950480692132`", ",", "2.64753496017083`", ",", 
          "2.49911789947611`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75501886086037`", ",", "2.64389249405172`", ",", 
          "3.08170093922326`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23053291479943`", ",", "2.6402742854028`", ",", 
          "3.66428397897042`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70604696873848`", ",", "2.63667980950338`", ",", 
          "4.24686701871757`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.898375715497948`", ",", "2.63310855983474`", ",", 
          "4.82945005846473`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.373889769437`", ",", "2.62956004720888`", ",", 
          "5.41203309821188`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84940382337606`", ",", "2.62603379895008`", ",", 
          "5.99461613795903`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32491787731511`", ",", "2.62252935812552`", ",", 
          "0.294013870526601`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.517246624074576`", ",", "2.61904628282129`", ",", 
          "0.876596910273755`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99276067801363`", ",", "2.61558414546063`", ",", 
          "1.45917995002091`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46827473195268`", ",", "2.61214253216147`", ",", 
          "2.04176298976806`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94378878589174`", ",", "2.60872104213041`", ",", 
          "2.62434602951522`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.136117532651204`", ",", "2.60531928709081`", ",", 
          "3.20692906926237`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61163158659026`", ",", "2.60193689074251`", ",", 
          "3.78951210900953`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08714564052931`", ",", "2.59857348825116`", ",", 
          "4.37209514875668`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56265969446836`", ",", "2.59522872576526`", ",", 
          "4.95467818850383`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03817374840742`", ",", "2.59190225995889`", ",", 
          "5.53726122825099`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23050249516689`", ",", "2.58859375759873`", ",", 
          "6.11984426799814`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70601654910594`", ",", "2.58530289513363`", ",", 
          "0.419242000565709`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18153060304499`", ",", "2.5820293583054`", ",", 
          "1.00182504031286`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65704465698405`", ",", "2.57877284177942`", ",", 
          "1.58440808006002`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.849373403743514`", ",", "2.57553304879399`", ",", 
          "2.16699111980717`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32488745768257`", ",", "2.57230969082708`", ",", 
          "2.74957415955433`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80040151162162`", ",", "2.56910248727962`", ",", 
          "3.33215719930148`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27591556556068`", ",", "2.56591116517418`", ",", 
          "3.91474023904863`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.468244312320142`", ",", "2.56273545886832`", ",", 
          "4.49732327879579`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9437583662592`", ",", "2.55957510978148`", ",", 
          "5.07990631854294`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41927242019825`", ",", "2.55642986613496`", ",", 
          "5.66248935829009`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8947864741373`", ",", "2.55329948270394`", ",", 
          "6.24507239803725`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0871152208967707`", ",", "2.5501837205811`", ",", 
          "0.544470130604817`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56262927483582`", ",", "2.54708234695096`", ",", 
          "1.12705317035197`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03814332877488`", ",", "2.54399513487455`", ",", 
          "1.70963621009912`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51365738271393`", ",", "2.54092186308377`", ",", 
          "2.29221924984628`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98917143665299`", ",", "2.53786231578482`", ",", 
          "2.87480228959343`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18150018341245`", ",", "2.53481628247035`", ",", 
          "3.45738532934059`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65701423735151`", ",", "2.53178355773982`", ",", 
          "4.03996836908774`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13252829129056`", ",", "2.52876394112757`", ",", 
          "4.6225514088349`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60804234522961`", ",", "2.52575723693831`", ",", 
          "5.20513444858205`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.800371091989081`", ",", "2.52276325408953`", ",", 
          "5.7877174883292`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27588514592813`", ",", "2.5197818059606`", ",", 
          "0.0871152208967707`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75139919986719`", ",", "2.51681271024807`", ",", 
          "0.669698260643925`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22691325380624`", ",", "2.51385578882699`", ",", 
          "1.25228130039108`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.419242000565709`", ",", "2.51091086761792`", ",", 
          "1.83486434013823`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89475605450476`", ",", "2.50797777645925`", ",", 
          "2.41744737988539`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37027010844382`", ",", "2.50505634898473`", ",", 
          "3.00003041963254`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84578416238287`", ",", "2.50214642250579`", ",", 
          "3.58261345937969`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0381129091423372`", ",", "2.49924783789859`", ",", 
          "4.16519649912685`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51362696308139`", ",", "2.49636043949541`", ",", 
          "4.747779538874`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98914101702044`", ",", "2.49348407498031`", ",", 
          "5.33036257862116`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4646550709595`", ",", "2.49061859528875`", ",", 
          "5.91294561836831`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94016912489855`", ",", "2.48776385451106`", ",", 
          "0.212343350935879`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13249787165802`", ",", "2.48491970979957`", ",", 
          "0.794926390683033`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60801192559707`", ",", "2.48208602127919`", ",", 
          "1.37750943043019`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08352597953613`", ",", "2.47926265196134`", ",", 
          "1.96009247017734`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55904003347518`", ",", "2.47644946766104`", ",", 
          "2.54267550992449`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.751368780234647`", ",", "2.47364633691705`", ",", 
          "3.12525854967165`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2268828341737`", ",", "2.47085313091485`", ",", 
          "3.7078415894188`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70239688811275`", ",", "2.46806972341249`", ",", 
          "4.29042462916596`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17791094205181`", ",", "2.46529599066897`", ",", 
          "4.87300766891311`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.370239688811275`", ",", "2.46253181137526`", ",", 
          "5.45559070866026`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84575374275033`", ",", "2.45977706658769`", ",", 
          "6.03817374840742`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32126779668938`", ",", "2.45703163966367`", ",", 
          "0.337571480974986`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79678185062844`", ",", "2.45429541619961`", ",", 
          "0.920154520722141`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27229590456749`", ",", "2.45156828397106`", ",", 
          "1.50273756046929`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46462465132696`", ",", "2.44885013287477`", ",", 
          "2.08532060021645`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94013870526601`", ",", "2.44614085487279`", ",", 
          "2.6679036399636`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41565275920506`", ",", "2.44344034393846`", ",", 
          "3.25048667971076`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89116681314412`", ",", "2.44074849600409`", ",", 
          "3.83306971945791`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08349555990359`", ",", "2.43806520891053`", ",", 
          "4.41565275920506`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55900961384264`", ",", "2.43539038235823`", ",", 
          "4.99823579895222`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03452366778169`", ",", "2.43272391786005`", ",", 
          "5.58081883869937`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51003772172075`", ",", "2.43006571869549`", ",", 
          "6.16340187844653`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.702366468480214`", ",", "2.42741568986642`", ",", 
          "0.462799611014094`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17788052241927`", ",", "2.42477373805424`", ",", 
          "1.04538265076125`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65339457635832`", ",", "2.42213977157839`", ",", 
          "1.6279656905084`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12890863029737`", ",", "2.41951370035615`", ",", 
          "2.21054873025556`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.321237377056842`", ",", "2.41689543586373`", ",", 
          "2.79313177000271`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7967514309959`", ",", "2.41428489109851`", ",", 
          "3.37571480974986`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27226548493495`", ",", "2.41168198054251`", ",", 
          "3.95829784949702`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.747779538874`", ",", "2.40908662012693`", ",", 
          "4.54088088924417`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22329359281306`", ",", "2.40649872719779`", ",", 
          "5.12346392899133`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41562233957252`", ",", "2.40391822048262`", ",", 
          "5.70604696873848`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89113639351158`", ",", "2.40134502005808`", ",", 
          "0.00544470130604817`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36665044745063`", ",", "2.39877904731867`", ",", 
          "0.588027741053202`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84216450138969`", ",", "2.39622022494624`", ",", 
          "1.17061078080036`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03449324814915`", ",", "2.39366847688047`", ",", 
          "1.75319382054751`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51000730208821`", ",", "2.39112372829019`", ",", 
          "2.33577686029466`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98552135602726`", ",", "2.38858590554553`", ",", 
          "2.91835990004182`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46103540996631`", ",", "2.3860549361909`", ",", 
          "3.50094293978897`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.65336415672578`", ",", "2.3835307489187`", ",", 
          "4.08352597953613`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12887821066483`", ",", "2.3810132735438`", ",", 
          "4.66610901928328`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60439226460389`", ",", "2.37850244097879`", ",", 
          "5.24869205903043`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07990631854294`", ",", "2.37599818320981`", ",", 
          "5.83127509877759`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.272235065302408`", ",", "2.37350043327319`", ",", 
          "0.130672831345156`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74774911924146`", ",", "2.37100912523263`", ",", 
          "0.71325587109231`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22326317318052`", ",", "2.36852419415711`", ",", 
          "1.29583891083946`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69877722711957`", ",", "2.36604557609927`", ",", 
          "1.87842195058662`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17429128105862`", ",", "2.36357320807456`", ",", 
          "2.46100499033377`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36662002781809`", ",", "2.36110702804078`", ",", 
          "3.04358803008093`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84213408175714`", ",", "2.35864697487827`", ",", 
          "3.62617106982808`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3176481356962`", ",", "2.35619298837064`", ",", 
          "4.20875410957523`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79316218963525`", ",", "2.35374500918593`", ",", 
          "4.79133714932239`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.985490936394718`", ",", "2.35130297885837`", ",", 
          "5.37392018906954`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46100499033377`", ",", "2.34886683977054`", ",", 
          "5.9565032288167`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93651904427283`", ",", "2.34643653513606`", ",", 
          "0.255900961384264`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41203309821188`", ",", "2.34401200898265`", ",", 
          "0.838484001131418`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.604361844971347`", ",", "2.34159320613571`", ",", 
          "1.42106704087857`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0798758989104`", ",", "2.3391800722023`", ",", 
          "2.00365008062573`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55538995284945`", ",", "2.33677255355549`", ",", 
          "2.58623312037288`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03090400678851`", ",", "2.33437059731916`", ",", 
          "3.16881616012003`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.223232753547975`", ",", "2.33197415135315`", ",", 
          "3.75139919986719`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69874680748703`", ",", "2.32958316423878`", ",", 
          "4.33398223961434`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17426086142608`", ",", "2.32719758526477`", ",", 
          "4.9165652793615`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64977491536514`", ",", "2.32481736441351`", ",", 
          "5.49914831910865`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12528896930419`", ",", "2.32244245234757`", ",", 
          "6.0817313588558`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31761771606366`", ",", "2.3200728003967`", ",", 
          "0.381129091423372`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79313177000271`", ",", "2.31770836054501`", ",", 
          "0.963712131170526`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26864582394176`", ",", "2.31534908541855`", ",", 
          "1.54629517091768`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74415987788082`", ",", "2.31299492827315`", ",", 
          "2.12887821066483`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.936488624640285`", ",", "2.31064584298257`", ",", 
          "2.71146125041199`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41200267857934`", ",", "2.30830178402688`", ",", 
          "3.29404429015914`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88751673251839`", ",", "2.30596270648124`", ",", 
          "3.8766273299063`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36303078645745`", ",", "2.3036285660048`", ",", 
          "4.45921036965345`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.555359533216913`", ",", "2.30129931882997`", ",", 
          "5.0417934094006`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03087358715597`", ",", "2.29897492175187`", ",", 
          "5.62437644914776`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50638764109502`", ",", "2.29665533211809`", ",", 
          "6.20695948889491`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98190169503407`", ",", "2.29434050781862`", ",", 
          "0.50635722146248`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.174230441793541`", ",", "2.29203040727608`", ",", 
          "1.08894026120963`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6497444957326`", ",", "2.28972498943613`", ",", 
          "1.67152330095679`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12525854967165`", ",", "2.28742421375809`", ",", 
          "2.25410634070394`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6007726036107`", ",", "2.28512804020582`", ",", 
          "2.8366893804511`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07628665754976`", ",", "2.28283642923877`", ",", 
          "3.41927242019825`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26861540430922`", ",", "2.28054934180324`", ",", 
          "4.0018554599454`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74412945824828`", ",", "2.27826673932385`", ",", 
          "4.58443849969256`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21964351218733`", ",", "2.27598858369517`", ",", 
          "5.16702153943971`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69515756612638`", ",", "2.27371483727355`", ",", 
          "5.74960457918687`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.887486312885851`", ",", "2.27144546286916`", ",", 
          "0.0490023117544335`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3630003668249`", ",", "2.26918042373815`", ",", 
          "0.631585351501588`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83851442076396`", ",", "2.26691968357502`", ",", 
          "1.21416839124874`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31402847470301`", ",", "2.26466320650514`", ",", 
          "1.7967514309959`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.50635722146248`", ",", "2.26241095707745`", ",", 
          "2.37933447074305`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98187127540153`", ",", "2.26016290025731`", ",", 
          "2.9619175104902`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45738532934059`", ",", "2.25791900141944`", ",", 
          "3.54450055023736`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93289938327964`", ",", "2.25567922634115`", ",", 
          "4.12708358998451`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.125228130039108`", ",", "2.25344354119558`", ",", 
          "4.70966662973167`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60074218397816`", ",", "2.25121191254513`", ",", 
          "5.29224966947882`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07625623791722`", ",", "2.24898430733508`", ",", 
          "5.87483270922597`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55177029185627`", ",", "2.24676069288724`", ",", 
          "0.174230441793541`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02728434579532`", ",", "2.24454103689382`", ",", 
          "0.756813481540695`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21961309255479`", ",", "2.24232530741139`", ",", 
          "1.33939652128785`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69512714649384`", ",", "2.24011347285497`", ",", 
          "1.921979561035`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1706412004329`", ",", "2.23790550199223`", ",", 
          "2.50456260078216`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64615525437195`", ",", "2.23570136393785`", ",", 
          "3.08714564052931`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.838484001131418`", ",", "2.23350102814792`", ",", 
          "3.66972868027646`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31399805507047`", ",", "2.23130446441455`", ",", 
          "4.25231172002362`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78951210900953`", ",", "2.22911164286049`", ",", 
          "4.83489475977077`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26502616294858`", ",", "2.22692253393393`", ",", 
          "5.41747779951793`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.457354909708046`", ",", "2.22473710840337`", ",", 
          "6.00006083926508`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9328689636471`", ",", "2.22255533735263`", ",", 
          "0.299458571832649`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40838301758615`", ",", "2.22037719217588`", ",", 
          "0.882041611579803`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88389707152521`", ",", "2.21820264457285`", ",", 
          "1.46462465132696`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0762258182846744`", ",", "2.21603166654411`", ",", 
          "2.04720769107411`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55173987222373`", ",", "2.2138642303864`", ",", 
          "2.62979073082127`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02725392616278`", ",", "2.21170030868813`", ",", 
          "3.21237377056842`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50276798010184`", ",", "2.20953987432488`", ",", 
          "3.79495681031557`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97828203404089`", ",", "2.20738290045505`", ",", 
          "4.37753985006273`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17061078080036`", ",", "2.20522936051559`", ",", 
          "4.96012288980988`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64612483473941`", ",", "2.20307922821776`", ",", 
          "5.54270592955704`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12163888867846`", ",", "2.20093247754302`", ",", 
          "6.12528896930419`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59715294261752`", ",", "2.19878908273901`", ",", 
          "0.424686701871757`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.789481689376984`", ",", "2.19664901831552`", ",", 
          "1.00726974161891`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26499574331604`", ",", "2.19451225904067`", ",", 
          "1.58985278136607`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74050979725509`", ",", "2.19237877993701`", ",", 
          "2.17243582111322`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21602385119415`", ",", "2.19024855627783`", ",", 
          "2.75501886086037`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.408352597953613`", ",", "2.18812156358346`", ",", 
          "3.33760190060753`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88386665189267`", ",", "2.18599777761764`", ",", 
          "3.92018494035468`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35938070583172`", ",", "2.18387717438398`", ",", 
          "4.50276798010184`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83489475977077`", ",", "2.18175973012251`", ",", 
          "5.08535101984899`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0272235065302408`", ",", "2.1796454213062`", ",", 
          "5.66793405959614`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50273756046929`", ",", "2.17753422463768`", ",", 
          "6.2505170993433`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97825161440835`", ",", "2.17542611704587`", ",", 
          "0.549914831910865`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4537656683474`", ",", "2.1733210756828`", ",", 
          "1.13249787165802`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92927972228646`", ",", "2.1712190779204`", ",", 
          "1.71508091140517`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12160846904592`", ",", "2.16912010134741`", ",", 
          "2.29766395115233`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59712252298498`", ",", "2.16702412376627`", ",", 
          "2.88024699089948`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07263657692403`", ",", "2.16493112319016`", ",", 
          "3.46283003064664`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54815063086308`", ",", "2.16284107783999`", ",", 
          "4.04541307039379`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.740479377622551`", ",", "2.16075396614156`", ",", 
          "4.62799611014094`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2159934315616`", ",", "2.15866976672264`", ",", 
          "5.2105791498881`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69150748550066`", ",", "2.1565884584102`", ",", 
          "5.79316218963525`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16702153943971`", ",", "2.15451002022766`", ",", 
          "0.0925599222028189`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.359350286199179`", ",", "2.15243443139216`", ",", 
          "0.675142961949973`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83486434013823`", ",", "2.15036167131191`", ",", 
          "1.25772600169713`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31037839407729`", ",", "2.14829171958358`", ",", 
          "1.84030904144428`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78589244801634`", ",", "2.14622455598971`", ",", 
          "2.42289208119143`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26140650195539`", ",", "2.14416016049622`", ",", 
          "3.00547512093859`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45373524871486`", ",", "2.14209851324988`", ",", 
          "3.58805816068574`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92924930265391`", ",", "2.1400395945759`", ",", 
          "4.1706412004329`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40476335659297`", ",", "2.13798338497554`", ",", 
          "4.75322424018005`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88027741053202`", ",", "2.1359298651237`", ",", 
          "5.33580727992721`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07260615729149`", ",", "2.13387901586664`", ",", 
          "5.91839031967436`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54812021123054`", ",", "2.1318308182197`", ",", 
          "0.217788052241927`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0236342651696`", ",", "2.12978525336503`", ",", 
          "0.800371091989081`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49914831910865`", ",", "2.12774230264941`", ",", 
          "1.38295413173623`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.691477065868117`", ",", "2.12570194758205`", ",", 
          "1.96553717148339`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16699111980717`", ",", "2.12366416983248`", ",", 
          "2.54812021123054`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64250517374622`", ",", "2.12162895122845`", ",", 
          "3.1307032509777`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11801922768528`", ",", "2.11959627375383`", ",", 
          "3.71328629072485`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.310347974444746`", ",", "2.11756611954664`", ",", 
          "4.29586933047201`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7858620283838`", ",", "2.11553847089699`", ",", 
          "4.87845237021916`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26137608232285`", ",", "2.11351331024512`", ",", 
          "5.46103540996631`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73689013626191`", ",", "2.11149062017953`", ",", 
          "6.04361844971347`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21240419020096`", ",", "2.10947038343497`", ",", 
          "0.343016182281035`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40473293696043`", ",", "2.10745258289067`", ",", 
          "0.925599222028189`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88024699089948`", ",", "2.10543720156842`", ",", 
          "1.50818226177534`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35576104483854`", ",", "2.10342422263078`", ",", 
          "2.0907653015225`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83127509877759`", ",", "2.10141362937932`", ",", 
          "2.67334834126965`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02360384553706`", ",", "2.0994054052528`", ",", 
          "3.2559313810168`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49911789947611`", ",", "2.09739953382552`", ",", 
          "3.83851442076396`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97463195341516`", ",", "2.09539599880552`", ",", 
          "4.42109746051111`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45014600735422`", ",", "2.09339478403299`", ",", 
          "5.00368050025827`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.642474754113684`", ",", "2.09139587347858`", ",", 
          "5.58626354000542`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11798880805274`", ",", "2.08939925124175`", ",", 
          "6.16884657975258`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59350286199179`", ",", "2.08740490154922`", ",", 
          "0.468244312320142`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06901691593084`", ",", "2.08541280875335`", ",", 
          "1.0508273520673`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.261345662690312`", ",", "2.08342295733061`", ",", 
          "1.63341039181445`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73685971662937`", ",", "2.08143533188005`", ",", 
          "2.2159934315616`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21237377056842`", ",", "2.07944991712178`", ",", 
          "2.79857647130876`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68788782450747`", ",", "2.07746669789549`", ",", 
          "3.38115951105591`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16340187844653`", ",", "2.07548565915901`", ",", 
          "3.96374255080307`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35573062520599`", ",", "2.07350678598685`", ",", 
          "4.54632559055022`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83124467914505`", ",", "2.07153006356877`", ",", 
          "5.12890863029737`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3067587330841`", ",", "2.06955547720843`", ",", 
          "5.71149167004453`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78227278702316`", ",", "2.06758301232197`", ",", 
          "0.0108894026120963`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.974601533782622`", ",", "2.06561265443666`", ",", 
          "0.59347244235925`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45011558772168`", ",", "2.06364438918958`", ",", 
          "1.1760554821064`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92562964166073`", ",", "2.06167820232631`", ",", 
          "1.75863852185356`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40114369559978`", ",", "2.0597140796996`", ",", 
          "2.34122156160071`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.59347244235925`", ",", "2.05775200726813`", ",", 
          "2.92380460134787`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0689864962983`", ",", "2.05579197109522`", ",", 
          "3.50638764109502`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54450055023736`", ",", "2.05383395734761`", ",", 
          "4.08897068084217`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02001460417641`", ",", "2.05187795229422`", ",", 
          "4.67155372058933`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.212343350935879`", ",", "2.04992394230497`", ",", 
          "5.25413676033648`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68785740487493`", ",", "2.04797191384955`", ",", 
          "5.83671980008364`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16337145881399`", ",", "2.04602185349629`", ",", 
          "0.136117532651204`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63888551275304`", ",", "2.04407374791098`", ",", 
          "0.718700572398358`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11439956669209`", ",", "2.04212758385575`", ",", 
          "1.30128361214551`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30672831345156`", ",", "2.04018334818792`", ",", 
          "1.88386665189267`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78224236739061`", ",", "2.03824102785891`", ",", 
          "2.46644969163982`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25775642132967`", ",", "2.03630060991317`", ",", 
          "3.04903273138697`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73327047526872`", ",", "2.03436208148706`", ",", 
          "3.63161577113413`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.925599222028189`", ",", "2.03242542980782`", ",", 
          "4.21419881088128`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40111327596724`", ",", "2.03049064219252`", ",", 
          "4.79678185062844`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8766273299063`", ",", "2.028557706047`", ",", 
          "5.37936489037559`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35214138384535`", ",", "2.02662660886491`", ",", 
          "5.96194793012274`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.544470130604817`", ",", "2.02469733822664`", ",", 
          "0.261345662690312`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01998418454387`", ",", "2.02276988179839`", ",", 
          "0.843928702437466`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49549823848292`", ",", "2.02084422733113`", ",", 
          "1.42651174218462`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97101229242198`", ",", "2.01892036265971`", ",", 
          "2.00909478193177`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.163341039181445`", ",", "2.01699827570184`", ",", 
          "2.59167782167893`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6388550931205`", ",", "2.01507795445721`", ",", 
          "3.17426086142608`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11436914705955`", ",", "2.01315938700651`", ",", 
          "3.75684390117324`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58988320099861`", ",", "2.01124256151056`", ",", 
          "4.33942694092039`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06539725493766`", ",", "2.00932746620942`", ",", 
          "4.92200998066754`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25772600169713`", ",", "2.00741408942144`", ",", 
          "5.5045930204147`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73324005563618`", ",", "2.00550241954245`", ",", 
          "6.08717606016185`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20875410957523`", ",", "2.00359244504485`", ",", 
          "0.38657379272942`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68426816351429`", ",", "2.00168415447677`", ",", 
          "0.969156832476574`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.876596910273755`", ",", "1.99977753646125`", ",", 
          "1.55173987222373`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35211096421281`", ",", "1.99787257969537`", ",", 
          "2.13432291197088`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82762501815186`", ",", "1.99596927294947`", ",", 
          "2.71690595171804`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30313907209092`", ",", "1.9940676050663`", ",", 
          "3.29948899146519`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.495467818850383`", ",", "1.99216756496023`", ",", 
          "3.88207203121234`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97098187278944`", ",", "1.99026914161651`", ",", 
          "4.4646550709595`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44649592672849`", ",", "1.98837232409042`", ",", 
          "5.04723811070665`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92200998066754`", ",", "1.98647710150653`", ",", 
          "5.62982115045381`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.114338727427012`", ",", "1.98458346305797`", ",", 
          "6.21240419020096`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58985278136607`", ",", "1.98269139800562`", ",", 
          "0.511801922768528`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06536683530512`", ",", "1.98080089567743`", ",", 
          "1.09438496251568`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54088088924417`", ",", "1.97891194546766`", ",", 
          "1.67696800226284`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01639494318323`", ",", "1.97702453683614`", ",", 
          "2.25955104200999`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20872368994269`", ",", "1.97513865930761`", ",", 
          "2.84213408175714`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68423774388175`", ",", "1.97325430247097`", ",", 
          "3.4247171215043`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1597517978208`", ",", "1.97137145597859`", ",", 
          "4.00730016125145`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63526585175985`", ",", "1.96949010954565`", ",", 
          "4.58988320099861`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.827594598519322`", ",", "1.96761025294945`", ",", 
          "5.17246624074576`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30310865245838`", ",", "1.96573187602872`", ",", 
          "5.75504928049291`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77862270639743`", ",", "1.963854968683`", ",", 
          "0.0544470130604817`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25413676033648`", ",", "1.96197952087195`", ",", 
          "0.637030052807636`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.44646550709595`", ",", "1.96010552261472`", ",", 
          "1.21961309255479`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.921979561035`", ",", "1.9582329639893`", ",", 
          "1.80219613230194`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39749361497406`", ",", "1.95636183513193`", ",", 
          "2.3847791720491`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87300766891311`", ",", "1.95449212623642`", ",", 
          "2.96736221179625`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.065336415672578`", ",", "1.95262382755359`", ",", 
          "3.54994525154341`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54085046961163`", ",", "1.95075692939062`", ",", 
          "4.13252829129056`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01636452355069`", ",", "1.94889142211049`", ",", 
          "4.71511133103771`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49187857748974`", ",", "1.94702729613134`", ",", 
          "5.29769437078487`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96739263142879`", ",", "1.94516454192593`", ",", 
          "5.88027741053202`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15972137818826`", ",", "1.94330315002104`", ",", 
          "0.17967514309959`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63523543212731`", ",", "1.94144311099688`", ",", 
          "0.762258182846744`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11074948606637`", ",", "1.93958441548658`", ",", 
          "1.3448412225939`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58626354000542`", ",", "1.93772705417557`", ",", 
          "1.92742426234105`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.778592286764888`", ",", "1.93587101780106`", ",", 
          "2.51000730208821`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25410634070394`", ",", "1.93401629715149`", ",", 
          "3.09259034183536`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.729620394643`", ",", "1.93216288306599`", ",", 
          "3.67517338158251`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20513444858205`", ",", "1.93031076643384`", ",", 
          "4.25775642132967`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.397463195341516`", ",", "1.92845993819396`", ",", 
          "4.84033946107682`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87297724928057`", ",", "1.92661038933438`", ",", 
          "5.42292250082398`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34849130321962`", ",", "1.9247621108917`", ",", 
          "6.00550554057113`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82400535715868`", ",", "1.92291509395062`", ",", 
          "0.304903273138697`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0163341039181445`", ",", "1.92106932964342`", ",", 
          "0.887486312885851`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4918481578572`", ",", "1.91922480914947`", ",", 
          "1.47006935263301`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96736221179625`", ",", "1.91738152369472`", ",", 
          "2.05265239238016`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44287626573531`", ",", "1.91553946455122`", ",", 
          "2.63523543212731`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91839031967436`", ",", "1.91369862303665`", ",", 
          "3.21781847187447`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11071906643383`", ",", "1.91185899051384`", ",", 
          "3.80040151162162`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58623312037288`", ",", "1.91002055839028`", ",", 
          "4.38298455136878`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06174717431193`", ",", "1.90818331811769`", ",", 
          "4.96556759111593`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53726122825099`", ",", "1.90634726119153`", ",", 
          "5.54815063086308`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.729589975010455`", ",", "1.90451237915056`", ",", 
          "6.13073367061024`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20510402894951`", ",", "1.90267866357636`", ",", 
          "0.430131403177805`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68061808288856`", ",", "1.90084610609296`", ",", 
          "1.01271444292496`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15613213682762`", ",", "1.89901469836629`", ",", 
          "1.59529748267211`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.348460883587083`", ",", "1.89718443210385`", ",", 
          "2.17788052241927`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82397493752614`", ",", "1.8953552990542`", ",", 
          "2.76046356216642`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29948899146519`", ",", "1.89352729100659`", ",", 
          "3.34304660191358`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77500304540424`", ",", "1.89170039979048`", ",", 
          "3.92562964166073`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2505170993433`", ",", "1.8898746172752`", ",", 
          "4.50821268140788`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44284584610276`", ",", "1.88804993536944`", ",", 
          "5.09079572115504`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91835990004182`", ",", "1.88622634602094`", ",", 
          "5.67337876090219`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39387395398087`", ",", "1.88440384121601`", ",", 
          "6.25596180064935`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86938800791993`", ",", "1.88258241297917`", ",", 
          "0.555359533216913`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06171675467939`", ",", "1.88076205337273`", ",", 
          "1.13794257296407`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53723080861845`", ",", "1.87894275449643`", ",", 
          "1.72052561271122`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0127448625575`", ",", "1.87712450848702`", ",", 
          "2.30310865245838`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48825891649655`", ",", "1.87530730751789`", ",", 
          "2.88569169220553`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.680587663256021`", ",", "1.87349114379868`", ",", 
          "3.46827473195268`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15610171719507`", ",", "1.87167600957492`", ",", 
          "4.05085777169984`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63161577113413`", ",", "1.86986189712767`", ",", 
          "4.63344081144699`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10712982507318`", ",", "1.86804879877308`", ",", 
          "5.21602385119415`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.299458571832649`", ",", "1.86623670686213`", ",", 
          "5.7986068909413`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7749726257717`", ",", "1.86442561378019`", ",", 
          "0.098004623508867`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25048667971076`", ",", "1.86261551194667`", ",", 
          "0.680587663256021`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72600073364981`", ",", "1.86080639381472`", ",", 
          "1.26317070300318`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20151478758886`", ",", "1.85899825187081`", ",", 
          "1.84575374275033`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39384353434833`", ",", "1.85719107863445`", ",", 
          "2.42833678249748`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86935758828738`", ",", "1.85538486665777`", ",", 
          "3.01091982224464`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34487164222644`", ",", "1.85357960852525`", ",", 
          "3.59350286199179`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82038569616549`", ",", "1.85177529685335`", ",", 
          "4.17608590173895`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01271444292496`", ",", "1.84997192429017`", ",", 
          "4.7586689414861`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48822849686401`", ",", "1.84816948351515`", ",", 
          "5.34125198123325`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96374255080307`", ",", "1.84636796723869`", ",", 
          "5.92383502098041`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43925660474212`", ",", "1.8445673682019`", ",", 
          "0.223232753547975`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.631585351501588`", ",", "1.8427676791762`", ",", 
          "0.805815793295129`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10709940544064`", ",", "1.84096889296306`", ",", 
          "1.38839883304228`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58261345937969`", ",", "1.83917100239365`", ",", 
          "1.97098187278944`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05812751331875`", ",", "1.83737400032856`", ",", 
          "2.55356491253659`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.250456260078216`", ",", "1.83557787965745`", ",", 
          "3.13614795228374`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72597031401727`", ",", "1.83378263329879`", ",", 
          "3.7187309920309`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20148436795632`", ",", "1.8319882541995`", ",", 
          "4.30131403177805`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67699842189538`", ",", "1.83019473533472`", ",", 
          "4.88389707152521`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15251247583443`", ",", "1.82840206970744`", ",", 
          "5.46648011127236`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3448412225939`", ",", "1.82661025034826`", ",", 
          "6.04906315101951`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82035527653295`", ",", "1.82481927031507`", ",", 
          "0.348460883587083`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29586933047201`", ",", "1.82302912269275`", ",", 
          "0.931043923334237`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77138338441106`", ",", "1.82123980059293`", ",", 
          "1.51362696308139`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.963712131170526`", ",", "1.81945129715364`", ",", 
          "2.09621000282854`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43922618510958`", ",", "1.81766360553908`", ",", 
          "2.6787930425757`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91474023904863`", ",", "1.81587671893931`", ",", 
          "3.26137608232285`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39025429298769`", ",", "1.81409063057`", ",", 
          "3.84395912207001`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.582583039747154`", ",", "1.81230533367213`", ",", 
          "4.42654216181716`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05809709368621`", ",", "1.81052082151172`", ",", 
          "5.00912520156432`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53361114762526`", ",", "1.80873708737958`", ",", 
          "5.59170824131147`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00912520156432`", ",", "1.80695412459101`", ",", 
          "6.17429128105862`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.201453948323782`", ",", "1.80517192648558`", ",", 
          "0.473689013626191`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67696800226284`", ",", "1.8033904864268`", ",", 
          "1.05627205337334`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15248205620189`", ",", "1.80160979780194`", ",", 
          "1.6388550931205`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62799611014094`", ",", "1.79982985402171`", ",", 
          "2.22143813286765`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10351016408`", ",", "1.79805064852002`", ",", 
          "2.80402117261481`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29583891083946`", ",", "1.79627217475374`", ",", 
          "3.38660421236196`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77135296477852`", ",", "1.79449442620242`", ",", 
          "3.96918725210911`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24686701871757`", ",", "1.79271739636807`", ",", 
          "4.55177029185627`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72238107265663`", ",", "1.7909410787749`", ",", 
          "5.13435333160342`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.914709819416092`", ",", "1.78916546696906`", ",", 
          "5.71693637135058`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39022387335515`", ",", "1.78739055451841`", ",", 
          "0.0163341039181445`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8657379272942`", ",", "1.78561633501228`", ",", 
          "0.598917143665299`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34125198123325`", ",", "1.78384280206122`", ",", 
          "1.18150018341245`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.533580727992721`", ",", "1.78206994929676`", ",", 
          "1.76408322315961`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00909478193177`", ",", "1.7802977703712`", ",", 
          "2.34666626290676`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48460883587083`", ",", "1.77852625895733`", ",", 
          "2.92924930265391`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96012288980988`", ",", "1.77675540874824`", ",", 
          "3.51183234240107`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.152451636569349`", ",", "1.77498521345706`", ",", 
          "4.09441538214822`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6279656905084`", ",", "1.77321566681675`", ",", 
          "4.67699842189538`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10347974444746`", ",", "1.77144676257985`", ",", 
          "5.25958146164253`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57899379838651`", ",", "1.76967849451828`", ",", 
          "5.84216450138969`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05450785232556`", ",", "1.7679108564231`", ",", 
          "0.141562233957252`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24683659908503`", ",", "1.7661438421043`", ",", 
          "0.724145273704406`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72235065302408`", ",", "1.76437744539055`", ",", 
          "1.30672831345156`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19786470696314`", ",", "1.76261166012902`", ",", 
          "1.88931135319871`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67337876090219`", ",", "1.76084648018515`", ",", 
          "2.47189439294587`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.865707507661659`", ",", "1.7590818994424`", ",", 
          "3.05447743269302`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34122156160071`", ",", "1.75731791180209`", ",", 
          "3.63706047244018`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81673561553977`", ",", "1.75555451118315`", ",", 
          "4.21964351218733`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29224966947882`", ",", "1.75379169152193`", ",", 
          "4.80222655193448`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.484578416238287`", ",", "1.75202944677195`", ",", 
          "5.38480959168164`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96009247017734`", ",", "1.75026777090376`", ",", 
          "5.96739263142879`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43560652411639`", ",", "1.74850665790467`", ",", 
          "0.26679036399636`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91112057805545`", ",", "1.74674610177858`", ",", 
          "0.849373403743514`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.103449324814915`", ",", "1.74498609654576`", ",", 
          "1.43195644349067`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57896337875397`", ",", "1.74322663624265`", ",", 
          "2.01453948323782`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05447743269302`", ",", "1.74146771492167`", ",", 
          "2.59712252298498`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52999148663208`", ",", "1.739709326651`", ",", 
          "3.17970556273213`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00550554057113`", ",", "1.73795146551441`", ",", 
          "3.76228860247928`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1978342873306`", ",", "1.73619412561102`", ",", 
          "4.34487164222644`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67334834126965`", ",", "1.73443730105516`", ",", 
          "4.92745468197359`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1488623952087`", ",", "1.73268098597611`", ",", 
          "5.51003772172075`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62437644914776`", ",", "1.73092517451797`", ",", 
          "6.0926207614679`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.816705195907225`", ",", "1.72916986083942`", ",", 
          "0.392018494035468`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29221924984628`", ",", "1.72741503911357`", ",", 
          "0.974601533782622`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76773330378533`", ",", "1.72566070352772`", ",", 
          "1.55718457352978`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24324735772439`", ",", "1.72390684828322`", ",", 
          "2.13976761327693`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.435576104483854`", ",", "1.72215346759525`", ",", 
          "2.72235065302408`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91109015842291`", ",", "1.72040055569265`", ",", 
          "3.30493369277124`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38660421236196`", ",", "1.71864810681775`", ",", 
          "3.88751673251839`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86211826630102`", ",", "1.71689611522612`", ",", 
          "4.47009977226555`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0544470130604817`", ",", "1.71514457518648`", ",", 
          "5.0526828120127`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52996106699954`", ",", "1.71339348098044`", ",", 
          "5.63526585175985`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00547512093859`", ",", "1.71164282690236`", ",", 
          "6.21784889150701`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48098917487764`", ",", "1.70989260725918`", ",", 
          "0.517246624074576`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9565032288167`", ",", "1.70814281637019`", ",", 
          "1.09982966382173`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14883197557616`", ",", "1.7063934485669`", ",", 
          "1.68241270356888`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62434602951522`", ",", "1.70464449819284`", ",", 
          "2.26499574331604`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09986008345427`", ",", "1.7028959596034`", ",", 
          "2.84757878306319`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57537413739332`", ",", "1.70114782716565`", ",", 
          "3.43016182281035`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.767702884152792`", ",", "1.69940009525814`", ",", 
          "4.0127448625575`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24321693809185`", ",", "1.69765275827077`", ",", 
          "4.59532790230465`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7187309920309`", ",", "1.69590581060459`", ",", 
          "5.17791094205181`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19424504596995`", ",", "1.69415924667164`", ",", 
          "5.76049398179896`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.38657379272942`", ",", "1.69241306089476`", ",", 
          "0.0598917143665299`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86208784666847`", ",", "1.69066724770746`", ",", 
          "0.642474754113684`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33760190060753`", ",", "1.6889218015537`", ",", 
          "1.22505779386084`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81311595454658`", ",", "1.68717671688778`", ",", 
          "1.80764083360799`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00544470130604817`", ",", "1.68543198817411`", ",", 
          "2.39022387335515`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4809587552451`", ",", "1.68368760988711`", ",", 
          "2.9728069131023`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95647280918416`", ",", "1.68194357651098`", ",", 
          "3.55538995284945`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43198686312321`", ",", "1.68019988253957`", ",", 
          "4.13797299259661`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90750091706226`", ",", "1.67845652247625`", ",", 
          "4.72055603234376`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09982966382173`", ",", "1.67671349083365`", ",", 
          "5.30313907209092`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57534371776078`", ",", "1.67497078213361`", ",", 
          "5.88572211183807`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05085777169984`", ",", "1.67322839090694`", ",", 
          "0.185119844405638`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52637182563889`", ",", "1.67148631169327`", ",", 
          "0.767702884152792`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.718700572398358`", ",", "1.66974453904094`", ",", 
          "1.35028592389995`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19421462633741`", ",", "1.66800306750677`", ",", 
          "1.9328689636471`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66972868027646`", ",", "1.66626189165596`", ",", 
          "2.51545200339425`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14524273421552`", ",", "1.66452100606189`", ",", 
          "3.09803504314141`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.337571480974986`", ",", "1.662780405306`", ",", 
          "3.68061808288856`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81308553491404`", ",", "1.66104008397758`", ",", 
          "4.26320112263572`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28859958885309`", ",", "1.65930003667369`", ",", 
          "4.84578416238287`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76411364279215`", ",", "1.65756025799891`", ",", 
          "5.42836720213002`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2396276967312`", ",", "1.65582074256528`", ",", 
          "6.01095024187718`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43195644349067`", ",", "1.65408148499207`", ",", 
          "0.310347974444746`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90747049742972`", ",", "1.65234247990568`", ",", 
          "0.8929310141919`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38298455136878`", ",", "1.65060372193944`", ",", 
          "1.47551405393905`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85849860530783`", ",", "1.64886520573349`", ",", 
          "2.05809709368621`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0508273520673`", ",", "1.64712692593463`", ",", 
          "2.64068013343336`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52634140600635`", ",", "1.64538887719613`", ",", 
          "3.22326317318052`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0018554599454`", ",", "1.64365105417762`", ",", 
          "3.80584621292767`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47736951388446`", ",", "1.64191345154493`", ",", 
          "4.38842925267482`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.669698260643925`", ",", "1.64017606396992`", ",", 
          "4.97101229242198`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14521231458298`", ",", "1.63843888613034`", ",", 
          "5.55359533216913`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62072636852203`", ",", "1.63670191270969`", ",", 
          "6.13617837191629`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09624042246109`", ",", "1.63496513839707`", ",", 
          "0.435576104483854`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.288569169220553`", ",", "1.63322855788701`", ",", 
          "1.01815914423101`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76408322315961`", ",", "1.63149216587935`", ",", 
          "1.60074218397816`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23959727709866`", ",", "1.62975595707907`", ",", 
          "2.18332522372532`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71511133103771`", ",", "1.62801992619616`", ",", 
          "2.76590826347247`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19062538497677`", ",", "1.62628406794545`", ",", 
          "3.34849130321962`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38295413173623`", ",", "1.6245483770465`", ",", 
          "3.93107434296678`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85846818567529`", ",", "1.62281284822342`", ",", 
          "4.51365738271393`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33398223961434`", ",", "1.62107747620473`", ",", 
          "5.09624042246109`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8094962935534`", ",", "1.61934225572321`", ",", 
          "5.67882346220824`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00182504031286`", ",", "1.6176071815158`", ",", 
          "6.26140650195539`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47733909425192`", ",", "1.61587224832339`", ",", 
          "0.560804234522961`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95285314819097`", ",", "1.61413745089071`", ",", 
          "1.14338727427012`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42836720213002`", ",", "1.61240278396618`", ",", 
          "1.72597031401727`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.620695948889491`", ",", "1.61066824230176`", ",", 
          "2.30855335376442`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09621000282854`", ",", "1.60893382065284`", ",", 
          "2.89113639351158`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5717240567676`", ",", "1.60719951377803`", ",", 
          "3.47371943325873`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04723811070665`", ",", "1.60546531643908`", ",", 
          "4.05630247300589`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.239566857466119`", ",", "1.6037312234007`", ",", 
          "4.63888551275304`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71508091140517`", ",", "1.60199722943043`", ",", 
          "5.22146855250019`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19059496534423`", ",", "1.60026332929851`", ",", 
          "5.80405159224735`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66610901928328`", ",", "1.5985295177777`", ",", 
          "0.103449324814915`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14162307322233`", ",", "1.59679578964317`", ",", 
          "0.686032364562069`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3339518199818`", ",", "1.59506213967236`", ",", 
          "1.26861540430922`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80946587392085`", ",", "1.59332856264482`", ",", 
          "1.85119844405638`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28497992785991`", ",", "1.59159505334207`", ",", 
          "2.43378148380353`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76049398179896`", ",", "1.58986160654746`", ",", 
          "3.01636452355069`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.952822728558429`", ",", "1.58812821704605`", ",", 
          "3.59894756329784`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42833678249748`", ",", "1.58639487962442`", ",", 
          "4.18153060304499`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90385083643654`", ",", "1.5846615890706`", ",", 
          "4.76411364279215`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37936489037559`", ",", "1.58292834017385`", ",", 
          "5.3466966825393`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.571693637135058`", ",", "1.58119512772458`", ",", 
          "5.92927972228646`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04720769107411`", ",", "1.57946194651417`", ",", 
          "0.228677454854023`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52272174501317`", ",", "1.57772879133486`", ",", 
          "0.811260494601177`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99823579895222`", ",", "1.57599565697958`", ",", 
          "1.39384353434833`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.190564545711686`", ",", "1.57426253824183`", ",", 
          "1.97642657409549`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66607859965074`", ",", "1.57252942991553`", ",", 
          "2.55900961384264`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61710670752885`", ",", "1.56906322367426`", ",", 
          "3.72417569333695`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0926207614679`", ",", "1.56733011534797`", ",", 
          "4.3067587330841`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28494950822737`", ",", "1.56559699661022`", ",", 
          "4.88934177283126`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76046356216642`", ",", "1.56386386225494`", ",", 
          "5.47192481257841`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23597761610548`", ",", "1.56213070707563`", ",", 
          "6.05450785232556`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71149167004453`", ",", "1.56039752586522`", ",", 
          "0.353905584893131`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.903820416803996`", ",", "1.55866431341594`", ",", 
          "0.936488624640285`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37933447074305`", ",", "1.5569310645192`", ",", 
          "1.51907166438744`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8548485246821`", ",", "1.55519777396537`", ",", 
          "2.10165470413459`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33036257862116`", ",", "1.55346443654375`", ",", 
          "2.68423774388175`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.522691325380624`", ",", "1.55173104704233`", ",", 
          "3.2668207836289`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99820537931968`", ",", "1.54999760024773`", ",", 
          "3.84940382337606`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47371943325873`", ",", "1.54826409094497`", ",", 
          "4.43198686312321`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94923348719779`", ",", "1.54653051391743`", ",", 
          "5.01456990287036`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.141562233957252`", ",", "1.54479686394662`", ",", 
          "5.59715294261752`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61707628789631`", ",", "1.5430631358121`", ",", 
          "6.17973598236467`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09259034183536`", ",", "1.54132932429129`", ",", 
          "0.479133714932239`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56810439577441`", ",", "1.53959542415936`", ",", 
          "1.06171675467939`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04361844971347`", ",", "1.5378614301891`", ",", 
          "1.64429979442655`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23594719647293`", ",", "1.53612733715072`", ",", 
          "2.2268828341737`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71146125041199`", ",", "1.53439313981176`", ",", 
          "2.80946587392085`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18697530435104`", ",", "1.53265883293696`", ",", 
          "3.39204891366801`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66248935829009`", ",", "1.53092441128803`", ",", 
          "3.97463195341516`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.854818105049562`", ",", "1.52918986962362`", ",", 
          "4.55721499316232`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33033215898862`", ",", "1.52745520269909`", ",", 
          "5.13979803290947`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80584621292767`", ",", "1.5257204052664`", ",", 
          "5.72238107265663`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28136026686672`", ",", "1.52398547207399`", ",", 
          "0.0217788052241927`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.473689013626191`", ",", "1.52225039786658`", ",", 
          "0.604361844971347`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94920306756524`", ",", "1.52051517738507`", ",", 
          "1.1869448847185`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4247171215043`", ",", "1.51877980536637`", ",", 
          "1.76952792446565`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90023117544335`", ",", "1.51704427654329`", ",", 
          "2.35211096421281`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0925599222028189`", ",", "1.51530858564434`", ",", 
          "2.93469400395996`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56807397614187`", ",", "1.51357272739364`", ",", 
          "3.51727704370712`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04358803008093`", ",", "1.51183669651073`", ",", 
          "4.09986008345427`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51910208401998`", ",", "1.51010048771045`", ",", 
          "4.68244312320143`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99461613795903`", ",", "1.50836409570278`", ",", 
          "5.26502616294858`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1869448847185`", ",", "1.50662751519273`", ",", 
          "5.84760920269573`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66245893865755`", ",", "1.5048907408801`", ",", 
          "0.147006935263301`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13797299259661`", ",", "1.50315376745945`", ",", 
          "0.729589975010455`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61348704653566`", ",", "1.50141658961987`", ",", 
          "1.31217301475761`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.805815793295129`", ",", "1.49967920204486`", ",", 
          "1.89475605450476`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28132984723418`", ",", "1.49794159941217`", ",", 
          "2.47733909425192`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75684390117324`", ",", "1.49620377639366`", ",", 
          "3.05992213399907`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23235795511229`", ",", "1.49446572765516`", ",", 
          "3.64250517374622`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.424686701871757`", ",", "1.4927274478563`", ",", 
          "4.22508821349338`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90020075581081`", ",", "1.49098893165035`", ",", 
          "4.80767125324053`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37571480974986`", ",", "1.48925017368411`", ",", 
          "5.39025429298769`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85122886368892`", ",", "1.48751116859772`", ",", 
          "5.97283733273484`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0435576104483854`", ",", "1.48577191102451`", ",", 
          "0.272235065302408`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51907166438744`", ",", "1.48403239559088`", ",", 
          "0.854818105049562`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99458571832649`", ",", "1.48229261691611`", ",", 
          "1.43740114479672`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47009977226555`", ",", "1.48055256961221`", ",", 
          "2.01998418454387`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9456138262046`", ",", "1.4788122482838`", ",", 
          "2.60256722429102`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13794257296407`", ",", "1.4770716475279`", ",", 
          "3.18515026403818`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61345662690312`", ",", "1.47533076193384`", ",", 
          "3.76773330378533`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08897068084217`", ",", "1.47358958608303`", ",", 
          "4.35031634353249`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56448473478123`", ",", "1.47184811454886`", ",", 
          "4.93289938327964`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.756813481540695`", ",", "1.47010634189652`", ",", 
          "5.51548242302679`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23232753547975`", ",", "1.46836426268286`", ",", 
          "6.09806546277395`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7078415894188`", ",", "1.46662187145618`", ",", 
          "0.397463195341516`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18335564335786`", ",", "1.46487916275614`", ",", 
          "0.98004623508867`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.375684390117324`", ",", "1.46313613111355`", ",", 
          "1.56262927483582`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85119844405638`", ",", "1.46139277105022`", ",", 
          "2.14521231458298`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32671249799543`", ",", "1.45964907707882`", ",", 
          "2.72779535433013`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80222655193448`", ",", "1.45790504370268`", ",", 
          "3.31037839407729`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27774060587354`", ",", "1.45616066541568`", ",", 
          "3.89296143382444`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47006935263301`", ",", "1.45441593670201`", ",", 
          "4.47554447357159`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94558340657206`", ",", "1.45267085203609`", ",", 
          "5.05812751331875`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42109746051111`", ",", "1.45092540588233`", ",", 
          "5.6407105530659`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89661151445017`", ",", "1.44917959269503`", ",", 
          "6.22329359281306`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08894026120963`", ",", "1.44743340691815`", ",", 
          "0.522691325380624`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56445431514869`", ",", "1.4456868429852`", ",", 
          "1.10527436512778`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03996836908774`", ",", "1.44393989531902`", ",", 
          "1.68785740487493`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51548242302679`", ",", "1.44219255833165`", ",", 
          "2.27044044462209`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.707811169786262`", ",", "1.44044482642415`", ",", 
          "2.85302348436924`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18332522372532`", ",", "1.43869669398639`", ",", 
          "3.43560652411639`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65883927766437`", ",", "1.43694815539695`", ",", 
          "4.01818956386355`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13435333160342`", ",", "1.4351992050229`", ",", 
          "4.6007726036107`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.32668207836289`", ",", "1.43344983721961`", ",", 
          "5.18335564335786`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80219613230194`", ",", "1.43170004633061`", ",", 
          "5.76593868310501`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.277710186241`", ",", "1.42994982668743`", ",", 
          "0.065336415672578`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75322424018005`", ",", "1.42819917260936`", ",", 
          "0.647919455419732`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2287382941191`", ",", "1.42644807840332`", ",", 
          "1.23050249516689`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42106704087857`", ",", "1.42469653836367`", ",", 
          "1.81308553491404`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89658109481763`", ",", "1.42294454677205`", ",", 
          "2.39566857466119`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37209514875668`", ",", "1.42119209789714`", ",", 
          "2.97825161440835`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84760920269573`", ",", "1.41943918599455`", ",", 
          "3.5608346541555`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0399379494552`", ",", "1.41768580530658`", ",", 
          "4.14341769390266`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51545200339425`", ",", "1.41593195006208`", ",", 
          "4.72600073364981`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99096605733331`", ",", "1.41417761447623`", ",", 
          "5.30858377339696`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46648011127236`", ",", "1.41242279275037`", ",", 
          "5.89116681314412`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.658808858031828`", ",", "1.41066747907183`", ",", 
          "0.190564545711686`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13432291197088`", ",", "1.40891166761369`", ",", 
          "0.77314758545884`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60983696590994`", ",", "1.40715535253464`", ",", 
          "1.35573062520599`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08535101984899`", ",", "1.40539852797877`", ",", 
          "1.93831366495315`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.277679766608457`", ",", "1.40364118807539`", ",", 
          "2.5208967047003`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75319382054751`", ",", "1.40188332693879`", ",", 
          "3.10347974444746`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22870787448656`", ",", "1.40012493866812`", ",", 
          "3.68606278419461`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70422192842562`", ",", "1.39836601734714`", ",", 
          "4.26864582394176`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17973598236467`", ",", "1.39660655704404`", ",", 
          "4.85122886368892`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37206472912414`", ",", "1.39484655181121`", ",", 
          "5.43381190343607`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84757878306319`", ",", "1.39308599568512`", ",", 
          "6.01639494318323`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32309283700225`", ",", "1.39132488268603`", ",", 
          "0.315792675750794`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7986068909413`", ",", "1.38956320681784`", ",", 
          "0.898375715497948`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.990935637700767`", ",", "1.38780096206787`", ",", 
          "1.4809587552451`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46644969163982`", ",", "1.38603814240664`", ",", 
          "2.06354179499226`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94196374557887`", ",", "1.3842747417877`", ",", 
          "2.64612483473941`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41747779951793`", ",", "1.38251075414739`", ",", 
          "3.22870787448656`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.609806546277395`", ",", "1.38074617340464`", ",", 
          "3.81129091423372`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08532060021645`", ",", "1.37898099346077`", ",", 
          "4.39387395398087`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5608346541555`", ",", "1.37721520819924`", ",", 
          "4.97645699372803`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03634870809456`", ",", "1.3754488114855`", ",", 
          "5.55904003347518`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.228677454854023`", ",", "1.37368179716669`", ",", 
          "6.14162307322233`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70419150879308`", ",", "1.37191415907152`", ",", 
          "0.441020805789902`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17970556273213`", ",", "1.37014589100995`", ",", 
          "1.02360384553706`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65521961667118`", ",", "1.36837698677304`", ",", 
          "1.60618688528421`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13073367061024`", ",", "1.36660744013273`", ",", 
          "2.18876992503136`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32306241736971`", ",", "1.36483724484155`", ",", 
          "2.77135296477852`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79857647130876`", ",", "1.36306639463246`", ",", 
          "3.35393600452567`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27409052524781`", ",", "1.36129488321859`", ",", 
          "3.93651904427283`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74960457918687`", ",", "1.35952270429303`", ",", 
          "4.51910208401998`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.941933325946333`", ",", "1.35774985152858`", ",", 
          "5.10168512376713`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41744737988539`", ",", "1.35597631857751`", ",", 
          "5.68426816351429`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89296143382444`", ",", "1.35420209907138`", ",", 
          "6.26685120326144`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36847548776349`", ",", "1.35242718662073`", ",", 
          "0.56624893582901`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.560804234522961`", ",", "1.35065157481489`", ",", 
          "1.14883197557616`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03631828846201`", ",", "1.34887525722172`", ",", 
          "1.73141501532332`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51183234240107`", ",", "1.34709822738738`", ",", 
          "2.31399805507047`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98734639634012`", ",", "1.34532047883606`", ",", 
          "2.89658109481763`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.17967514309959`", ",", "1.34354200506977`", ",", 
          "3.47916413456478`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65518919703864`", ",", "1.34176279956808`", ",", 
          "4.06174717431193`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1307032509777`", ",", "1.33998285578785`", ",", 
          "4.64433021405909`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60621730491675`", ",", "1.33820216716299`", ",", 
          "5.22691325380624`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0817313588558`", ",", "1.33642072710422`", ",", 
          "5.8094962935534`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27406010561527`", ",", "1.33463852899878`", ",", 
          "0.108894026120963`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74957415955433`", ",", "1.33285556621021`", ",", 
          "0.691477065868117`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22508821349338`", ",", "1.33107183207807`", ",", 
          "1.27406010561527`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70060226743243`", ",", "1.32928731991766`", ",", 
          "1.85664314536243`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.8929310141919`", ",", "1.32750202301979`", ",", 
          "2.43922618510958`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36844506813095`", ",", "1.32571593465048`", ",", 
          "3.02180922485673`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84395912207001`", ",", "1.32392904805072`", ",", 
          "3.60439226460389`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31947317600906`", ",", "1.32214135643616`", ",", 
          "4.18697530435104`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.511801922768528`", ",", "1.32035285299687`", ",", 
          "4.7695583440982`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98731597670758`", ",", "1.31856353089704`", ",", 
          "5.35214138384535`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46283003064664`", ",", "1.31677338327472`", ",", 
          "5.9347244235925`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93834408458569`", ",", "1.31498240324153`", ",", 
          "0.234122156160071`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.130672831345156`", ",", "1.31319058388235`", ",", 
          "0.816705195907225`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60618688528421`", ",", "1.31139791825507`", ",", 
          "1.39928823565438`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08170093922326`", ",", "1.30960439939029`", ",", 
          "1.98187127540153`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55721499316232`", ",", "1.30781002029101`", ",", 
          "2.56445431514869`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03272904710137`", ",", "1.30601477393234`", ",", 
          "3.14703735489584`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22505779386084`", ",", "1.30421865326123`", ",", 
          "3.729620394643`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70057184779989`", ",", "1.30242165119614`", ",", 
          "4.31220343439015`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17608590173895`", ",", "1.30062376062673`", ",", 
          "4.8947864741373`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.651599955678`", ",", "1.29882497441359`", ",", 
          "5.47736951388446`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.843928702437466`", ",", "1.29702528538789`", ",", 
          "6.05995255363161`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31944275637652`", ",", "1.2952246863511`", ",", 
          "0.359350286199179`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79495681031557`", ",", "1.29342317007465`", ",", 
          "0.941933325946333`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27047086425463`", ",", "1.29162072929962`", ",", 
          "1.52451636569349`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.462799611014094`", ",", "1.28981735673645`", ",", 
          "2.10709940544064`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93831366495315`", ",", "1.28801304506455`", ",", 
          "2.68968244518779`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4138277188922`", ",", "1.28620778693203`", ",", 
          "3.27226548493495`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88934177283126`", ",", "1.28440157495535`", ",", 
          "3.8548485246821`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0816705195907225`", ",", "1.28259440171898`", ",", 
          "4.43743156442926`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55718457352978`", ",", "1.28078625977508`", ",", 
          "5.02001460417641`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03269862746883`", ",", "1.27897714164312`", ",", 
          "5.60259764392357`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50821268140788`", ",", "1.27716703980961`", ",", 
          "6.18518068367072`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98372673534694`", ",", "1.27535594672766`", ",", 
          "0.484578416238287`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1760554821064`", ",", "1.27354385481671`", ",", 
          "1.06716145598544`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65156953604546`", ",", "1.27173075646213`", ",", 
          "1.6497444957326`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12708358998451`", ",", "1.26991664401487`", ",", 
          "2.23232753547975`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60259764392357`", ",", "1.26810150979112`", ",", 
          "2.8149105752269`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.794926390683033`", ",", "1.26628534607191`", ",", 
          "3.39749361497406`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27044044462209`", ",", "1.26446814510277`", ",", 
          "3.98007665472121`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74595449856114`", ",", "1.26264989909336`", ",", 
          "4.56265969446836`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22146855250019`", ",", "1.26083060021706`", ",", 
          "5.14524273421552`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.413797299259661`", ",", "1.25901024061063`", ",", 
          "5.72782577396267`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88931135319871`", ",", "1.25718881237378`", ",", 
          "0.0272235065302408`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36482540713777`", ",", "1.25536630756885`", ",", 
          "0.609806546277395`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84033946107682`", ",", "1.25354271822035`", ",", 
          "1.19238958602455`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.032668207836289`", ",", "1.2517180363146`", ",", 
          "1.7749726257717`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50818226177534`", ",", "1.24989225379931`", ",", 
          "2.35755566551886`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9836963157144`", ",", "1.24806536258321`", ",", 
          "2.94013870526601`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45921036965345`", ",", "1.24623735453559`", ",", 
          "3.52272174501317`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9347244235925`", ",", "1.24440822148594`", ",", 
          "4.10530478476032`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12705317035197`", ",", "1.2425779552235`", ",", 
          "4.68788782450747`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60256722429102`", ",", "1.24074654749684`", ",", 
          "5.27047086425463`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07808127823008`", ",", "1.23891399001343`", ",", 
          "5.85305390400178`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55359533216913`", ",", "1.23708027443924`", ",", 
          "0.152451636569349`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.745924078928599`", ",", "1.23524539239826`", ",", 
          "0.735034676316503`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22143813286765`", ",", "1.2334093354721`", ",", 
          "1.31761771606366`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69695218680671`", ",", "1.23157209519951`", ",", 
          "1.90020075581081`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17246624074576`", ",", "1.22973366307595`", ",", 
          "2.48278379555796`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.364794987505227`", ",", "1.22789403055314`", ",", 
          "3.06536683530512`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84030904144428`", ",", "1.22605318903857`", ",", 
          "3.64794987505227`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31582309538333`", ",", "1.22421112989507`", ",", 
          "4.23053291479943`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79133714932239`", ",", "1.22236784444032`", ",", 
          "4.81311595454658`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26685120326144`", ",", "1.22052332394637`", ",", 
          "5.39569899429374`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45917995002091`", ",", "1.21867755963918`", ",", 
          "5.97828203404089`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93469400395996`", ",", "1.2168305426981`", ",", 
          "0.277679766608457`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41020805789902`", ",", "1.21498226425542`", ",", 
          "0.860262806355611`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88572211183807`", ",", "1.21313271539583`", ",", 
          "1.44284584610276`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07805085859754`", ",", "1.21128188715595`", ",", 
          "2.02542888584992`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55356491253659`", ",", "1.20942977052381`", ",", 
          "2.60801192559707`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02907896647564`", ",", "1.2075763564383`", ",", 
          "3.19059496534423`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5045930204147`", ",", "1.20572163578873`", ",", 
          "3.77317800509138`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.696921767174166`", ",", "1.20386559941422`", ",", 
          "4.35576104483854`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17243582111322`", ",", "1.20200823810321`", ",", 
          "4.93834408458569`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64794987505227`", ",", "1.20014954259291`", ",", 
          "5.52092712433284`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12346392899133`", ",", "1.19828950356876`", ",", 
          "6.10351016408`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.315792675750794`", ",", "1.19642811166386`", ",", 
          "0.402907896647564`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79130672968985`", ",", "1.19456535745845`", ",", 
          "0.985490936394718`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2668207836289`", ",", "1.1927012314793`", ",", 
          "1.56807397614187`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74233483756795`", ",", "1.19083572419917`", ",", 
          "2.15065701588903`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21784889150701`", ",", "1.1889688260362`", ",", 
          "2.73324005563618`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41017763826648`", ",", "1.18710052735337`", ",", 
          "3.31582309538333`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88569169220553`", ",", "1.18523081845787`", ",", 
          "3.89840613513049`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36120574614458`", ",", "1.18335968960049`", ",", 
          "4.48098917487764`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83671980008364`", ",", "1.18148713097508`", ",", 
          "5.0635722146248`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0290485468431`", ",", "1.17961313271784`", ",", 
          "5.64615525437195`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50456260078216`", ",", "1.17773768490679`", ",", 
          "6.2287382941191`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98007665472121`", ",", "1.17586077756107`", ",", 
          "0.528136026686672`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45559070866026`", ",", "1.17398240064035`", ",", 
          "1.11071906643383`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.647919455419732`", ",", "1.17210254404414`", ",", 
          "1.69330210618098`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12343350935879`", ",", "1.17022119761121`", ",", 
          "2.27588514592813`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59894756329784`", ",", "1.16833835111883`", ",", 
          "2.85846818567529`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07446161723689`", ",", "1.16645399428218`", ",", 
          "3.44105122542244`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.26679036399636`", ",", "1.16456811675365`", ",", 
          "4.0236342651696`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74230441793541`", ",", "1.16268070812213`", ",", 
          "4.60621730491675`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21781847187447`", ",", "1.16079175791236`", ",", 
          "5.1888003446639`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69333252581352`", ",", "1.15890125558417`", ",", 
          "5.77138338441106`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16884657975258`", ",", "1.15700919053183`", ",", 
          "0.0707811169786262`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36117532651204`", ",", "1.15511555208326`", ",", 
          "0.65336415672578`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8366893804511`", ",", "1.15322032949937`", ",", 
          "1.23594719647293`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31220343439015`", ",", "1.15132351197328`", ",", 
          "1.81853023622009`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7877174883292`", ",", "1.14942508862956`", ",", 
          "2.40111327596724`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.98004623508867`", ",", "1.1475250485235`", ",", 
          "2.9836963157144`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45556028902772`", ",", "1.14562338064032`", ",", 
          "3.56627935546155`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93107434296678`", ",", "1.14372007389442`", ",", 
          "4.1488623952087`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40658839690583`", ",", "1.14181511712854`", ",", 
          "4.73144543495586`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.598917143665299`", ",", "1.13990849911302`", ",", 
          "5.31402847470301`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07443119760435`", ",", "1.13800020854495`", ",", 
          "5.89661151445017`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54994525154341`", ",", "1.13609023404734`", ",", 
          "0.196009247017734`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02545930548246`", ",", "1.13417856416835`", ",", 
          "0.778592286764888`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.217788052241927`", ",", "1.13226518738037`", ",", 
          "1.36117532651204`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69330210618098`", ",", "1.13035009207923`", ",", 
          "1.9437583662592`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16881616012003`", ",", "1.12843326658329`", ",", 
          "2.52634140600635`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64433021405909`", ",", "1.12651469913259`", ",", 
          "3.1089244457535`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11984426799814`", ",", "1.12459437788795`", ",", 
          "3.69150748550066`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31217301475761`", ",", "1.12267229093008`", ",", 
          "4.27409052524781`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78768706869666`", ",", "1.12074842625866`", ",", 
          "4.85667356499497`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26320112263572`", ",", "1.1188227717914`", ",", 
          "5.43925660474212`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73871517657477`", ",", "1.11689531536315`", ",", 
          "6.02183964448927`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.931043923334237`", ",", "1.11496604472488`", ",", 
          "0.321237377056842`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40655797727329`", ",", "1.11303494754279`", ",", 
          "0.903820416803996`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88207203121234`", ",", "1.11110201139728`", ",", 
          "1.48640345655115`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3575860851514`", ",", "1.10916722378197`", ",", 
          "2.0689864962983`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.549914831910865`", ",", "1.10723057210273`", ",", 
          "2.65156953604546`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02542888584992`", ",", "1.10529204367662`", ",", 
          "3.23415257579261`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50094293978897`", ",", "1.10335162573088`", ",", 
          "3.81673561553977`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97645699372803`", ",", "1.10140930540188`", ",", 
          "4.39931865528692`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.168785740487493`", ",", "1.09946506973405`", ",", 
          "4.98190169503407`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64429979442655`", ",", "1.09751890567881`", ",", 
          "5.56448473478123`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1198138483656`", ",", "1.09557080009351`", ",", 
          "6.14706777452838`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59532790230465`", ",", "1.09362073974025`", ",", 
          "0.44646550709595`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07084195624371`", ",", "1.09166871128483`", ",", 
          "1.0290485468431`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26317070300318`", ",", "1.08971470129557`", ",", 
          "1.61163158659026`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73868475694223`", ",", "1.08775869624219`", ",", 
          "2.19421462633741`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21419881088128`", ",", "1.08580068249458`", ",", 
          "2.77679766608457`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68971286482034`", ",", "1.08384064632167`", ",", 
          "3.35938070583172`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.882041611579803`", ",", "1.08187857389019`", ",", 
          "3.94196374557887`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35755566551886`", ",", "1.07991445126349`", ",", 
          "4.52454678532603`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83306971945791`", ",", "1.07794826440021`", ",", 
          "5.10712982507318`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30858377339696`", ",", "1.07597999915314`", ",", 
          "5.68971286482034`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.500912520156431`", ",", "1.07400964126783`", ",", 
          "6.27229590456749`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97642657409549`", ",", "1.07203717638136`", ",", 
          "0.571693637135058`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45194062803454`", ",", "1.07006259002102`", ",", 
          "1.15427667688221`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92745468197359`", ",", "1.06808586760295`", ",", 
          "1.73685971662937`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.11978342873306`", ",", "1.06610699443078`", ",", 
          "2.31944275637652`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59529748267211`", ",", "1.06412595569431`", ",", 
          "2.90202579612367`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07081153661117`", ",", "1.06214273646802`", ",", 
          "3.48460883587083`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54632559055022`", ",", "1.06015732170974`", ",", 
          "4.06719187561798`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02183964448927`", ",", "1.05816969625918`", ",", 
          "4.64977491536514`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21416839124874`", ",", "1.05617984483644`", ",", 
          "5.23235795511229`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68968244518779`", ",", "1.05418775204057`", ",", 
          "5.81494099485944`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16519649912685`", ",", "1.05219340234804`", ",", 
          "0.114338727427012`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6407105530659`", ",", "1.05019678011121`", ",", 
          "0.696921767174166`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.83303929982537`", ",", "1.0481978695568`", ",", 
          "1.27950480692132`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30855335376442`", ",", "1.04619665478427`", ",", 
          "1.86208784666847`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78406740770348`", ",", "1.04419311976428`", ",", 
          "2.44467088641563`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25958146164253`", ",", "1.04218724833699`", ",", 
          "3.02725392616278`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.451910208401998`", ",", "1.04017902421047`", ",", 
          "3.60983696590994`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92742426234105`", ",", "1.03816843095901`", ",", 
          "4.19242000565709`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4029383162801`", ",", "1.03615545202137`", ",", 
          "4.77500304540424`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87845237021916`", ",", "1.03414007069912`", ",", 
          "5.3575860851514`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0707811169786262`", ",", "1.03212227015482`", ",", 
          "5.94016912489855`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54629517091768`", ",", "1.03010203341027`", ",", 
          "0.239566857466119`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02180922485673`", ",", "1.02807934334467`", ",", 
          "0.822149897213274`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49732327879579`", ",", "1.02605418269281`", ",", 
          "1.40473293696043`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97283733273484`", ",", "1.02402653404315`", ",", 
          "1.98731597670758`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16516607949431`", ",", "1.02199637983596`", ",", 
          "2.56989901645474`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64068013343336`", ",", "1.01996370236135`", ",", 
          "3.15248205620189`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11619418737242`", ",", "1.01792848375731`", ",", 
          "3.73506509594904`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59170824131147`", ",", "1.01589070600775`", ",", 
          "4.3176481356962`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.784036988070936`", ",", "1.01385035094039`", ",", 
          "4.90023117544335`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25955104200999`", ",", "1.01180740022476`", ",", 
          "5.48281421519051`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73506509594904`", ",", "1.00976183537009`", ",", 
          "6.06539725493766`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2105791498881`", ",", "1.00771363772315`", ",", 
          "0.364794987505227`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.402907896647564`", ",", "1.0056627884661`", ",", 
          "0.947378027252381`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87842195058662`", ",", "1.00360926861425`", ",", 
          "1.52996106699954`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35393600452567`", ",", "1.00155305901389`", ",", 
          "2.11254410674669`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82945005846473`", ",", "0.999494140339917`", ",", 
          "2.69512714649384`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0217788052241927`", ",", "0.997432493093578`", ",", 
          "3.277710186241`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49729285916325`", ",", "0.995368097600085`", ",", 
          "3.86029322598815`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9728069131023`", ",", "0.993300934006218`", ",", 
          "4.44287626573531`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44832096704135`", ",", "0.991230982277883`", ",", 
          "5.02545930548246`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92383502098041`", ",", "0.989158222197632`", ",", 
          "5.60804234522961`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11616376773987`", ",", "0.98708263336213`", ",", 
          "6.19062538497677`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59167782167893`", ",", "0.985004195179589`", ",", 
          "0.490023117544335`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06719187561798`", ",", "0.982922886867153`", ",", 
          "1.07260615729149`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54270592955704`", ",", "0.980838687448233`", ",", 
          "1.65518919703864`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.735034676316503`", ",", "0.978751575749801`", ",", 
          "2.2377722367858`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21054873025556`", ",", "0.976661530399638`", ",", 
          "2.82035527653295`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68606278419461`", ",", "0.974568529823523`", ",", 
          "3.4029383162801`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16157683813366`", ",", "0.972472552242385`", ",", 
          "3.98552135602726`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.353905584893131`", ",", "0.97037357566939`", ",", 
          "4.56810439577441`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82941963883218`", ",", "0.968271577906994`", ",", 
          "5.15068743552157`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30493369277124`", ",", "0.966166536543924`", ",", 
          "5.73327047526872`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78044774671029`", ",", "0.964058428952114`", ",", 
          "0.032668207836289`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25596180064935`", ",", "0.96194723228359`", ",", 
          "0.615251247583443`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44829054740881`", ",", "0.959832923467285`", ",", 
          "1.1978342873306`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92380460134787`", ",", "0.95771547920581`", ",", 
          "1.78041732707775`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39931865528692`", ",", "0.955594875972155`", ",", 
          "2.3630003668249`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87483270922597`", ",", "0.953471090006332`", ",", 
          "2.94558340657206`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06716145598544`", ",", "0.951344097311961`", ",", 
          "3.52816644631921`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54267550992449`", ",", "0.949213873652785`", ",", 
          "4.11074948606637`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01818956386355`", ",", "0.947080394549127`", ",", 
          "4.69333252581352`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4937036178026`", ",", "0.944943635274272`", ",", 
          "5.27591556556068`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.686032364562069`", ",", "0.942803570850786`", ",", 
          "5.85849860530783`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16154641850112`", ",", "0.940660176046772`", ",", 
          "0.157896337875397`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63706047244018`", ",", "0.938513425372037`", ",", 
          "0.740479377622551`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11257452637923`", ",", "0.936363293074205`", ",", 
          "1.32306241736971`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.304903273138697`", ",", "0.934209753134744`", ",", 
          "1.90564545711686`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78041732707775`", ",", "0.932052779264918`", ",", 
          "2.48822849686401`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2559313810168`", ",", "0.929892344901665`", ",", 
          "3.07081153661117`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73144543495586`", ",", "0.927728423203391`", ",", 
          "3.65339457635832`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20695948889491`", ",", "0.925560987045684`", ",", 
          "4.23597761610548`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39928823565438`", ",", "0.923390009016941`", ",", 
          "4.81856065585263`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87480228959343`", ",", "0.921215461413914`", ",", 
          "5.40114369559978`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35031634353249`", ",", "0.919037316237163`", ",", 
          "5.98372673534694`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82583039747154`", ",", "0.916855545186421`", ",", 
          "0.283124467914505`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01815914423101`", ",", "0.914670119655867`", ",", 
          "0.865707507661659`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49367319817006`", ",", "0.912481010729305`", ",", 
          "1.44829054740881`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96918725210911`", ",", "0.910288189175241`", ",", 
          "2.03087358715597`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44470130604817`", ",", "0.908091625441869`", ",", 
          "2.61345662690312`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.637030052807636`", ",", "0.905891289651943`", ",", 
          "3.19603966665027`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11254410674669`", ",", "0.903687151597562`", ",", 
          "3.77862270639743`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58805816068574`", ",", "0.901479180734826`", ",", 
          "4.36120574614458`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0635722146248`", ",", "0.899267346178405`", ",", 
          "4.94378878589174`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.255900961384264`", ",", "0.897051616695975`", ",", 
          "5.52637182563889`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73141501532332`", ",", "0.894831960702555`", ",", 
          "6.10895486538605`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20692906926237`", ",", "0.892608346254714`", ",", 
          "0.408352597953613`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68244312320143`", ",", "0.890380741044662`", ",", 
          "0.990935637700767`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15795717714048`", ",", "0.888149112394218`", ",", 
          "1.57351867744792`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35028592389995`", ",", "0.885913427248644`", ",", 
          "2.15610171719507`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.825799977839`", ",", "0.883673652170355`", ",", 
          "2.73868475694223`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30131403177805`", ",", "0.881429753332488`", ",", 
          "3.32126779668938`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77682808571711`", ",", "0.879181696512339`", ",", 
          "3.90385083643654`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.969156832476574`", ",", "0.876929447084654`", ",", 
          "4.48643387618369`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44467088641563`", ",", "0.874672970014777`", ",", 
          "5.06901691593084`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92018494035468`", ",", "0.872412229851643`", ",", 
          "5.651599955678`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39569899429374`", ",", "0.87014719072063`", ",", 
          "6.23418299542515`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.588027741053202`", ",", "0.867877816316239`", ",", 
          "0.533580727992721`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06354179499226`", ",", "0.865604069894622`", ",", 
          "1.11616376773987`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53905584893131`", ",", "0.86332591426594`", ",", 
          "1.69874680748703`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01456990287036`", ",", "0.861043311786551`", ",", 
          "2.28132984723418`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.20689864962983`", ",", "0.858756224351027`", ",", 
          "2.86391288698134`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68241270356888`", ",", "0.856464613383977`", ",", 
          "3.44649592672849`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15792675750794`", ",", "0.854168439831707`", ",", 
          "4.02907896647564`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63344081144699`", ",", "0.851867664153664`", ",", 
          "4.6116620062228`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10895486538605`", ",", "0.849562246313711`", ",", 
          "5.19424504596995`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30128361214551`", ",", "0.847252145771174`", ",", 
          "5.77682808571711`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77679766608457`", ",", "0.844937321471706`", ",", 
          "0.0762258182846744`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25231172002362`", ",", "0.842617731837922`", ",", 
          "0.658808858031828`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72782577396267`", ",", "0.840293334759822`", ",", 
          "1.24139189777898`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.920154520722141`", ",", "0.837964087584989`", ",", 
          "1.82397493752614`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39566857466119`", ",", "0.835629947108551`", ",", 
          "2.40655797727329`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87118262860025`", ",", "0.83329086956291`", ",", 
          "2.98914101702044`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3466966825393`", ",", "0.830946810607226`", ",", 
          "3.5717240567676`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.539025429298769`", ",", "0.828597725316639`", ",", 
          "4.15430709651475`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01453948323782`", ",", "0.826243568171243`", ",", 
          "4.73689013626191`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49005353717688`", ",", "0.823884293044786`", ",", 
          "5.31947317600906`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96556759111593`", ",", "0.821519853193097`", ",", 
          "5.90205621575621`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.157896337875397`", ",", "0.819150201242224`", ",", 
          "0.201453948323782`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63341039181445`", ",", "0.816775289176285`", ",", 
          "0.784036988070936`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1089244457535`", ",", "0.814395068325019`", ",", 
          "1.36662002781809`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58443849969256`", ",", "0.812009489351017`", ",", 
          "1.94920306756524`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05995255363161`", ",", "0.809618502236645`", ",", 
          "2.5317861073124`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25228130039108`", ",", "0.807222056270628`", ",", 
          "3.11436914705955`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72779535433013`", ",", "0.804820100034299`", ",", 
          "3.69695218680671`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20330940826919`", ",", "0.802412581387492`", ",", 
          "4.27953522655386`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67882346220824`", ",", "0.799999447454084`", ",", 
          "4.86211826630102`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.871152208967707`", ",", "0.797580644607147`", ",", 
          "5.44470130604817`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34666626290676`", ",", "0.795156118453733`", ",", 
          "6.02728434579532`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82218031684581`", ",", "0.792725813819248`", ",", 
          "0.32668207836289`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29769437078487`", ",", "0.790289674731425`", ",", 
          "0.909265118110044`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.490023117544335`", ",", "0.787847644403867`", ",", 
          "1.4918481578572`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96553717148339`", ",", "0.785399665219158`", ",", 
          "2.07443119760435`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44105122542244`", ",", "0.782945678711522`", ",", 
          "2.65701423735151`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9165652793615`", ",", "0.780485625549014`", ",", 
          "3.23959727709866`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.108894026120963`", ",", "0.778019445515229`", ",", 
          "3.82218031684581`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58440808006002`", ",", "0.775547077490519`", ",", 
          "4.40476335659297`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05992213399907`", ",", "0.773068459432687`", ",", 
          "4.98734639634012`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53543618793812`", ",", "0.77058352835716`", ",", 
          "5.56992943608728`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01095024187718`", ",", "0.768092220316607`", ",", 
          "6.15251247583443`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20327898863665`", ",", "0.765594470379984`", ",", 
          "0.451910208401998`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6787930425757`", ",", "0.763090212611004`", ",", 
          "1.03449324814915`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15430709651475`", ",", "0.760579380045989`", ",", 
          "1.61707628789631`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62982115045381`", ",", "0.758061904671095`", ",", 
          "2.19965932764346`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.822149897213274`", ",", "0.755537717398891`", ",", 
          "2.78224236739061`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29766395115233`", ",", "0.75300674804426`", ",", 
          "3.36482540713777`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77317800509138`", ",", "0.750468925299603`", ",", 
          "3.94740844688492`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24869205903043`", ",", "0.747924176709321`", ",", 
          "4.52999148663208`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.441020805789902`", ",", "0.745372428643551`", ",", 
          "5.11257452637923`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91653485972896`", ",", "0.742813606271121`", ",", 
          "5.69515756612638`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39204891366801`", ",", "0.740247633531712`", ",", 
          "6.27774060587354`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86756296760706`", ",", "0.737674433107176`", ",", 
          "0.577138338441106`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0598917143665299`", ",", "0.735093926391999`", ",", 
          "1.15972137818826`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53540576830558`", ",", "0.732506033462862`", ",", 
          "1.74230441793541`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01091982224464`", ",", "0.729910673047282`", ",", 
          "2.32488745768257`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48643387618369`", ",", "0.727307762491282`", ",", 
          "2.90747049742972`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96194793012274`", ",", "0.724697217726063`", ",", 
          "3.49005353717688`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15427667688221`", ",", "0.722078953233642`", ",", 
          "4.07263657692403`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62979073082127`", ",", "0.719452882011407`", ",", 
          "4.65521961667118`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10530478476032`", ",", "0.716818915535556`", ",", 
          "5.23780265641834`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58081883869937`", ",", "0.714176963723376`", ",", 
          "5.82038569616549`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.77314758545884`", ",", "0.711526934894302`", ",", 
          "0.11978342873306`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24866163939789`", ",", "0.70886873572974`", ",", 
          "0.702366468480214`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72417569333695`", ",", "0.706202271231564`", ",", 
          "1.28494950822737`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.199689747276`", ",", "0.703527444679267`", ",", 
          "1.86753254797452`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.392018494035468`", ",", "0.7008441575857`", ",", 
          "2.45011558772168`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86753254797452`", ",", "0.698152309651334`", ",", 
          "3.03269862746883`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34304660191358`", ",", "0.695451798717`", ",", 
          "3.61528166721598`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81856065585263`", ",", "0.692742520715028`", ",", 
          "4.19786470696314`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0108894026120963`", ",", "0.690024369618735`", ",", 
          "4.78044774671029`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48640345655115`", ",", "0.687297237390182`", ",", 
          "5.36303078645745`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9619175104902`", ",", "0.684561013926126`", ",", 
          "5.9456138262046`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43743156442926`", ",", "0.681815587002099`", ",", 
          "0.245011558772168`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91294561836831`", ",", "0.679060842214532`", ",", 
          "0.827594598519322`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10527436512778`", ",", "0.676296662920826`", ",", 
          "1.41017763826648`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58078841906683`", ",", "0.673522930177306`", ",", 
          "1.99276067801363`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05630247300589`", ",", "0.670739522674941`", ",", 
          "2.57534371776078`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53181652694494`", ",", "0.667946316672745`", ",", 
          "3.15792675750794`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.724145273704406`", ",", "0.665143185928751`", ",", 
          "3.74050979725509`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19965932764346`", ",", "0.662330001628455`", ",", 
          "4.32309283700225`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67517338158251`", ",", "0.659506632310605`", ",", 
          "4.9056758767494`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15068743552157`", ",", "0.656672943790223`", ",", 
          "5.48825891649655`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.343016182281035`", ",", "0.65382879907873`", ",", 
          "6.07084195624371`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81853023622009`", ",", "0.65097405830104`", ",", 
          "0.370239688811275`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29404429015914`", ",", "0.648108578609479`", ",", 
          "0.952822728558429`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7695583440982`", ",", "0.645232214094382`", ",", 
          "1.53540576830558`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24507239803725`", ",", "0.642344815691207`", ",", 
          "2.11798880805274`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43740114479672`", ",", "0.639446231084005`", ",", 
          "2.70057184779989`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91291519873577`", ",", "0.636536304605064`", ",", 
          "3.28315488754705`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38842925267482`", ",", "0.633614877130538`", ",", 
          "3.8657379272942`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86394330661388`", ",", "0.630681785971871`", ",", 
          "4.44832096704135`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05627205337334`", ",", "0.6277368647628`", ",", 
          "5.03090400678851`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5317861073124`", ",", "0.624779943341725`", ",", 
          "5.61348704653566`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00730016125145`", ",", "0.621810847629191`", ",", 
          "6.19607008628282`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48281421519051`", ",", "0.61882939950026`", ",", 
          "0.495467818850383`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.675142961949973`", ",", "0.615835416651485`", ",", 
          "1.07805085859754`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15065701588903`", ",", "0.612828712462223`", ",", 
          "1.66063389834469`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62617106982808`", ",", "0.609809095849974`", ",", 
          "2.24321693809185`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10168512376713`", ",", "0.606776371119442`", ",", 
          "2.825799977839`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.294013870526601`", ",", "0.603730337804973`", ",", 
          "3.40838301758615`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76952792446565`", ",", "0.600670790506019`", ",", 
          "3.99096605733331`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24504197840471`", ",", "0.59759751871524`", ",", 
          "4.57354909708046`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72055603234376`", ",", "0.594510306638836`", ",", 
          "5.15613213682762`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19607008628282`", ",", "0.591408933008692`", ",", 
          "5.73871517657477`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38839883304228`", ",", "0.58829317088585`", ",", 
          "0.0381129091423372`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86391288698134`", ",", "0.585162787454838`", ",", 
          "0.620695948889491`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33942694092039`", ",", "0.582017543808315`", ",", 
          "1.20327898863665`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81494099485944`", ",", "0.578857194721476`", ",", 
          "1.7858620283838`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00726974161891`", ",", "0.575681488415609`", ",", 
          "2.36844506813095`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48278379555796`", ",", "0.572490166310177`", ",", 
          "2.95102810787811`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95829784949702`", ",", "0.569282962762713`", ",", 
          "3.53361114762526`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43381190343607`", ",", "0.566059604795803`", ",", 
          "4.11619418737242`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.626140650195539`", ",", "0.562819811810371`", ",", 
          "4.69877722711957`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10165470413459`", ",", "0.559563295284395`", ",", 
          "5.28136026686672`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57716875807365`", ",", "0.556289758456161`", ",", 
          "5.86394330661388`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0526828120127`", ",", "0.552998895991066`", ",", 
          "0.163341039181445`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.245011558772168`", ",", "0.549690393630908`", ",", 
          "0.745924078928599`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72052561271122`", ",", "0.546363927824537`", ",", 
          "1.32850711867575`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19603966665027`", ",", "0.543019165338631`", ",", 
          "1.91109015842291`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67155372058933`", ",", "0.539655762847286`", ",", 
          "2.49367319817006`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14706777452838`", ",", "0.53627336649898`", ",", 
          "3.07625623791722`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33939652128785`", ",", "0.532871611459381`", ",", 
          "3.65883927766437`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8149105752269`", ",", "0.529450121428325`", ",", 
          "4.24142231741152`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29042462916596`", ",", "0.526008508129161`", ",", 
          "4.82400535715868`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76593868310501`", ",", "0.522546370768502`", ",", 
          "5.40658839690583`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.958267429864478`", ",", "0.519063295464269`", ",", 
          "5.98917143665299`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43378148380353`", ",", "0.515558854639713`", ",", 
          "0.288569169220553`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90929553774258`", ",", "0.512032606380918`", ",", 
          "0.871152208967707`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38480959168164`", ",", "0.508484093755055`", ",", 
          "1.45373524871486`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.577138338441106`", ",", "0.504912844086415`", ",", 
          "2.03631828846201`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05265239238016`", ",", "0.501318368186994`", ",", 
          "2.61890132820917`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52816644631921`", ",", "0.497700159538077`", ",", 
          "3.20148436795632`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00368050025827`", ",", "0.494057693418967`", ",", 
          "3.78406740770348`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.196009247017734`", ",", "0.490390425978618`", ",", 
          "4.36665044745063`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67152330095679`", ",", "0.486697793245548`", ",", 
          "4.94923348719779`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14703735489584`", ",", "0.482979210070921`", ",", 
          "5.53181652694494`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6225514088349`", ",", "0.479234068999218`", ",", 
          "6.11439956669209`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09806546277395`", ",", "0.475461739060347`", ",", 
          "0.413797299259661`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29039420953342`", ",", "0.471661564476384`", ",", 
          "0.996380339006815`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76590826347247`", ",", "0.467832863275489`", ",", 
          "1.57896337875397`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24142231741152`", ",", "0.463974925804692`", ",", 
          "2.16154641850112`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71693637135058`", ",", "0.460087013132412`", ",", 
          "2.74412945824828`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.909265118110044`", ",", "0.456168355330532`", ",", 
          "3.32671249799543`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3847791720491`", ",", "0.452218149624758`", ",", 
          "3.90929553774258`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86029322598815`", ",", "0.448235558400701`", ",", 
          "4.49187857748974`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33580727992721`", ",", "0.44421970705169`", ",", 
          "5.07446161723689`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.528136026686672`", ",", "0.44016968165269`", ",", 
          "5.65704465698405`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00365008062573`", ",", "0.43608452644285`", ",", 
          "6.2396276967312`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47916413456478`", ",", "0.431963241097067`", ",", 
          "0.539025429298769`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95467818850383`", ",", "0.427804777764567`", ",", 
          "1.12160846904592`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.147006935263301`", ",", "0.423608037849717`", ",", 
          "1.70419150879308`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62252098920235`", ",", "0.419371868507103`", ",", 
          "2.28677454854023`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09803504314141`", ",", "0.415095058819274`", ",", 
          "2.86935758828738`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57354909708046`", ",", "0.410776335621311`", ",", 
          "3.45194062803454`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04906315101951`", ",", "0.406414358931519`", ",", 
          "4.03452366778169`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24139189777898`", ",", "0.402007716941849`", ",", 
          "4.61710670752885`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71690595171804`", ",", "0.397554920515104`", ",", 
          "5.199689747276`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19242000565709`", ",", "0.393054397128238`", ",", 
          "5.78227278702316`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66793405959614`", ",", "0.38850448419207`", ",", 
          "0.0816705195907225`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.860262806355611`", ",", "0.383903421667114`", ",", 
          "0.664253559337877`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33577686029466`", ",", "0.379249343882719`", ",", 
          "1.24683659908503`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81129091423372`", ",", "0.374540270451905`", ",", 
          "1.82941963883218`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28680496817277`", ",", "0.369774096156651`", ",", 
          "2.41200267857934`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.479133714932239`", ",", "0.364948579657381`", ",", 
          "2.99458571832649`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95464776887129`", ",", "0.360061330855198`", ",", 
          "3.57716875807365`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43016182281035`", ",", "0.355109796705018`", ",", 
          "4.1597517978208`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9056758767494`", ",", "0.350091245241089`", ",", 
          "4.74233483756795`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.098004623508867`", ",", "0.345002747531667`", ",", 
          "5.32491787731511`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57351867744792`", ",", "0.339841157225054`", ",", 
          "5.90750091706226`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04903273138697`", ",", "0.334603087282059`", ",", 
          "0.20689864962983`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52454678532603`", ",", "0.329284883406993`", ",", 
          "0.789481689376984`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00006083926508`", ",", "0.323882593586023`", ",", 
          "1.37206472912414`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19238958602455`", ",", "0.318391933012423`", ",", 
          "1.95464776887129`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6679036399636`", ",", "0.312808243515148`", ",", 
          "2.53723080861845`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14341769390266`", ",", "0.307126446399939`", ",", 
          "3.1198138483656`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61893174784171`", ",", "0.301340987346755`", ",", 
          "3.70239688811275`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.811260494601177`", ",", "0.295445771664469`", ",", 
          "4.28497992785991`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28677454854023`", ",", "0.289434087756857`", ",", 
          "4.86756296760706`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76228860247928`", ",", "0.283298516065646`", ",", 
          "5.45014600735422`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23780265641834`", ",", "0.277030819973748`", ",", 
          "6.03272904710137`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.430131403177805`", ",", "0.270621814098818`", ",", 
          "0.332126779668938`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90564545711686`", ",", "0.264061203972764`", ",", 
          "0.914709819416092`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38115951105591`", ",", "0.25733738912231`", ",", 
          "1.49729285916325`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85667356499497`", ",", "0.250437218790801`", ",", 
          "2.0798758989104`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0490023117544335`", ",", "0.243345685590629`", ",", 
          "2.66245893865755`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52451636569349`", ",", "0.236045536650048`", ",", 
          "3.24504197840471`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00003041963254`", ",", "0.228516773356173`", ",", 
          "3.82762501815186`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47554447357159`", ",", "0.220735998013771`", ",", 
          "4.41020805789902`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95105852751065`", ",", "0.212675545952952`", ",", 
          "4.99279109764617`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14338727427012`", ",", "0.204302310131946`", ",", 
          "5.57537413739332`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61890132820917`", ",", "0.195576113573585`", ",", 
          "6.15795717714048`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09441538214822`", ",", "0.186447396934159`", ",", 
          "0.457354909708046`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56992943608728`", ",", "0.176853832166059`", ",", 
          "1.0399379494552`"}], "}"}], ",", "0.000866551126516464`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.762258182846744`", ",", "0.166715181520646`", ",", 
          "1.62252098920235`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2377722367858`", ",", "0.155925143536358`", ",", 
          "2.20510402894951`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71328629072485`", ",", "0.144337697919367`", ",", 
          "2.78768706869666`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1888003446639`", ",", "0.13174259331741`", ",", 
          "3.37027010844382`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.381129091423372`", ",", "0.117817091867802`", ",", 
          "3.95285314819097`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85664314536243`", ",", "0.102017826691538`", ",", 
          "4.53543618793812`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33215719930148`", ",", "0.0832851581971765`", ",", 
          "5.11801922768528`"}], "}"}], ",", "0.000866551126516464`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80767125324053`", ",", "0.0588829872163326`", ",", 
          "5.70060226743243`"}], "}"}], ",", "0.000866551126516464`"}], 
       "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.460273662680175*^9, 3.4602736672802677`*^9}, {3.460278683630114*^9, 
   3.460278697049426*^9}, 3.460288008173973*^9, {3.460292433727244*^9, 
   3.460292508704509*^9}, {3.5029328922262774`*^9, 3.502932906302475*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ZCW6044", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.4537268931515083`*^9}, {
  3.460292425263933*^9, 3.460292425887959*^9}, {3.460292474899384*^9, 
  3.460292475401424*^9}, {3.5286226579688053`*^9, 3.528622660409449*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<ZCW6044\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Zaremba-Conroy-Wolfsberg sampling with 6044 orientations. Generate \
orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"ZCW6044\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "3.14159265358979`", ",", "0"}], "}"}], ",", 
        "0.000165453342157512`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93880552579251`", ",", "2.50329381535474`", ",", 
          "1.41278107750779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87761105158502`", ",", "2.22209663192006`", ",", 
          "2.82556215501557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81641657737753`", ",", "1.99251764903603`", ",", 
          "4.23834323252336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47203679599045`", ",", "1.78486974809665`", ",", 
          "5.65112431003114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41084232178296`", ",", "1.58634956801355`", ",", 
          "0.780720080359343`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34964784757547`", ",", "1.3884506450142`", ",", 
          "2.19350115786713`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0052680661884`", ",", "1.18291677494011`", ",", 
          "3.60628223537491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9440735919809`", ",", "0.958050612261936`", ",", 
          "5.0190633128827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88287911777341`", ",", "0.688806308279171`", ",", 
          "0.1486590832109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.538499336386338`", ",", "0.250071330997927`", ",", 
          "1.56144016071869`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47730486217885`", ",", "2.5575053902481`", ",", 
          "2.97422123822647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41611038797136`", ",", "2.26181989818551`", ",", 
          "4.38700231573426`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0717306065842805`", ",", "2.02688147011013`", ",", 
          "5.79978339324204`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01053613237679`", ",", "1.81681795702767`", ",", 
          "0.929379163570243`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9493416581693`", ",", "1.61747111455353`", ",", 
          "2.34216024107803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88814718396181`", ",", "1.41999376446744`", ",", 
          "3.75494131858581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54376740257473`", ",", "1.21629673915074`", ",", 
          "5.1677223960936`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48257292836724`", ",", "0.995586827416165`", ",", 
          "0.2973181664218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42137845415975`", ",", "0.736386805809906`", ",", 
          "1.71009924392959`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07699867277268`", ",", "0.354588210588131`", ",", 
          "3.12288032143737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01580419856519`", ",", "2.6165867436792`", ",", 
          "4.53566139894516`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9546097243577`", ",", "2.30289427329867`", ",", 
          "5.94844247645294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.610229942970618`", ",", "2.06183492686887`", ",", 
          "1.07803824678114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54903546876313`", ",", "1.84902466233752`", ",", 
          "2.49081932428893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48784099455564`", ",", "1.6486379850975`", ",", 
          "3.90360040179671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.143461213168561`", ",", "1.45138634999856`", ",", 
          "5.3163814793045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08226673896107`", ",", "1.24926910784821`", ",", 
          "0.445977249632701`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02107226475358`", ",", "1.03223049979846`", ",", 
          "1.85875832714049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95987779054609`", ",", "0.781589414716343`", ",", 
          "3.27153940464827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61549800915901`", ",", "0.435440519003186`", ",", 
          "4.68432048215606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55430353495152`", ",", "2.68243515823746`", ",", 
          "6.09710155966384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49310906074403`", ",", "2.34554532261691`", ",", 
          "1.22669732999204`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14872927935696`", ",", "2.09745459431735`", ",", 
          "2.63947840749983`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08753480514947`", ",", "1.88153054658287`", ",", 
          "4.05225948500762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02634033094198`", ",", "1.67988083784843`", ",", 
          "5.4650405625154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.681960549554899`", ",", "1.48266108996673`", ",", 
          "0.594636332843601`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62076607534741`", ",", "1.28188310780456`", ",", 
          "2.00741741035139`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55957160113992`", ",", "1.06808848546385`", ",", 
          "3.42019848785917`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.215191819752842`", ",", "0.824819405931783`", ",", 
          "4.83297956536696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15399734554535`", ",", "0.504163057856227`", ",", 
          "6.24576064287474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09280287133786`", ",", "2.75854914374688`", ",", 
          "1.37535641320294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03160839713037`", ",", "2.39005804492899`", ",", 
          "2.78813749071073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68722861574329`", ",", "2.13382815168563`", ",", 
          "4.20091856821852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6260341415358`", ",", "1.9143795077571`", ",", 
          "5.6136996457263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56483966732831`", ",", "1.71123100571269`", ",", 
          "0.743295416054501`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22045988594124`", ",", "1.51384960304945`", ",", 
          "2.15607649356229`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15926541173375`", ",", "1.31418383735487`", ",", 
          "3.56885757107007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09807093752626`", ",", "1.10325269191838`", ",", 
          "4.98163864857786`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.753691156139179`", ",", "0.866386306783384`", ",", 
          "0.111234418906058`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69249668193169`", ",", "0.565214268351697`", ",", 
          "1.52401549641384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6313022077242`", ",", "2.85296944748283`", ",", 
          "2.93679657392163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.286922426337122`", ",", "2.4368019825049`", ",", 
          "4.34957765142942`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22572795212963`", ",", "2.17105713698326`", ",", 
          "5.7623587289372`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16453347792214`", ",", "1.9476193246859`", ",", 
          "0.891954499265401`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10333900371465`", ",", "1.74272078955696`", ",", 
          "2.30473557677319`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75895922232757`", ",", "1.54498273873708`", ",", 
          "3.71751665428097`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69776474812008`", ",", "1.34621297296825`", ",", 
          "5.13029773178876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63657027391259`", ",", "1.13780309541321`", ",", 
          "0.259893502116958`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29219049252552`", ",", "0.906533142189959`", ",", 
          "1.67267457962474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23099601831803`", ",", "0.62087690693059`", ",", 
          "3.08545565713253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16980154411054`", ",", "2.99823510425761`", ",", 
          "4.49823673464032`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.82542176272346`", ",", "2.48627176597504`", ",", 
          "5.9110178121481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76422728851597`", ",", "2.20926060097372`", ",", 
          "1.0406135824763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70303281430848`", ",", "1.98130245898991`", ",", 
          "2.45339465998409`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.358653032921403`", ",", "1.77438377621693`", ",", 
          "3.86617573749187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29745855871391`", ",", "1.57609085848001`", ",", 
          "5.27895681499966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23626408450642`", ",", "1.37800936097865`", ",", 
          "0.408552585327859`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17506961029893`", ",", "1.17181004358613`", ",", 
          "1.82133366283564`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83068982891185`", ",", "0.945455145222503`", ",", 
          "3.23411474034343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76949535470436`", ",", "0.672505379872192`", ",", 
          "4.64689581785122`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70830088049687`", ",", "0.204548088475031`", ",", 
          "6.059676895359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3639210991098`", ",", "2.53915655749673`", ",", 
          "1.1892726656872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30272662490231`", ",", "2.248580052566`", ",", 
          "2.60205374319499`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24153215069482`", ",", "2.01548703496241`", ",", 
          "4.01483482070277`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.89715236930774`", ",", "1.8062551904225`", ",", 
          "5.42761589821056`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83595789510025`", ",", "1.60720410478102`", ",", 
          "0.557211668538759`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77476342089276`", ",", "1.40960952029763`", ",", 
          "1.96999274604654`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.430383639505683`", ",", "1.20533604259243`", ",", 
          "3.38277382355433`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36918916529819`", ",", "0.983312232108946`", ",", 
          "4.79555490106212`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3079946910907`", ",", "0.720981511620697`", ",", 
          "6.2083359785699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24680021688321`", ",", "0.32375462514178`", ",", 
          "1.3379317488981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90242043549614`", ",", "2.59646840655556`", ",", 
          "2.75071282640589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84122596128865`", ",", "2.28918630611052`", ",", 
          "4.16349390391367`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78003148708115`", ",", "2.05023805339538`", ",", 
          "5.57627498142146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43565170569408`", ",", "1.83837229161351`", ",", 
          "0.705870751749659`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37445723148659`", ",", "1.63835266493543`", ",", 
          "2.11865182925744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3132627572791`", ",", "1.44104807602889`", ",", 
          "3.53143290676523`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.968882975892021`", ",", "1.23843716583516`", ",", 
          "4.94421398427302`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90768850168453`", ",", "1.02023760904976`", ",", 
          "0.0738097546012162`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84649402747704`", ",", "0.766917712265334`", ",", 
          "1.486590832109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.502114246089964`", ",", "0.410447327281099`", ",", 
          "2.89937190961679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44091977188247`", ",", "2.6598052068878`", ",", 
          "4.31215298712457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37972529767498`", ",", "2.33128921347431`", ",", 
          "5.72493406463236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0353455162879063`", ",", "2.08562891660018`", ",", 
          "0.854529834960559`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97415104208042`", ",", "1.87077482913415`", ",", 
          "2.26731091246834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91295656787293`", ",", "1.6695670358635`", ",", 
          "3.68009198997613`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85176209366544`", ",", "1.47235813963096`", ",", 
          "5.09287306748392`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50738231227836`", ",", "1.27116418070803`", ",", 
          "0.222468837812116`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44618783807087`", ",", "1.05634388468601`", ",", 
          "1.6352499153199`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38499336386338`", ",", "0.810760081236625`", ",", 
          "3.04803099282769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0406135824763`", ",", "0.482501099738571`", ",", 
          "4.46081207033547`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97941910826881`", ",", "2.7319754175658`", ",", 
          "5.87359314784326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91822463406132`", ",", "2.37515192573746`", ",", 
          "1.00318891817146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.573844852674244`", ",", "2.12174337307181`", ",", 
          "2.41596999567925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51265037846675`", ",", "1.90350557275675`", ",", 
          "3.82875107318703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45145590425926`", ",", "1.70087829653164`", ",", 
          "5.24153215069482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.107076122872187`", ",", "1.50357164816784`", ",", 
          "0.371127921023017`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0458816486647`", ",", "1.30356346246266`", ",", 
          "1.7839089985308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98468717445721`", ",", "1.09172752062633`", ",", 
          "3.19669007603859`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92349270024972`", ",", "0.852845792186184`", ",", 
          "4.60947115354637`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57911291886264`", ",", "0.545762081657332`", ",", 
          "6.02225223105416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51791844465515`", ",", "2.81887981300106`", ",", 
          "1.15184800138236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45672397044766`", ",", "2.42111256594529`", ",", 
          "2.56462907889015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11234418906058`", ",", "2.1586780370976`", ",", 
          "3.97741015639793`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05114971485309`", ",", "1.93661094025225`", ",", 
          "5.39019123390572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9899552406456`", ",", "1.7323183948271`", ",", 
          "0.519787004233917`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.645575459258525`", ",", "1.53471967293628`", ",", 
          "1.9325680817417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58438098505103`", ",", "1.33567774563081`", ",", 
          "3.34534915924949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52318651084354`", ",", "1.12647214322879`", ",", 
          "4.75813023675727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.178806729456467`", ",", "0.893437331781665`", ",", 
          "6.17091131426506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11761225524898`", ",", "0.603019817113882`", ",", 
          "1.30050708459326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05641778104149`", ",", "2.93868009463931`", ",", 
          "2.71328816210105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.995223306834`", ",", "2.46961864590428`", ",", 
          "4.12606923960883`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65084352544692`", ",", "2.19654571061731`", ",", 
          "5.53885031711662`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58964905123943`", ",", "1.97014175032453`", ",", 
          "0.668446087444817`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52845457703194`", ",", "1.76392045646287`", ",", 
          "2.0812271649526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18407479564486`", ",", "1.5658327061483`", ",", 
          "3.49400824246039`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12288032143737`", ",", "1.36754675042714`", ",", 
          "4.90678931996817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06168584722988`", ",", "1.16065105605371`", ",", 
          "0.0363850902963742`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.717306065842805`", ",", "0.932744071531269`", ",", 
          "1.44916616780416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65611159163531`", ",", "0.655863687859381`", ",", 
          "2.86194724531195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59491711742782`", ",", "0.145655447664808`", ",", 
          "4.27472832281973`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.250537336040748`", ",", "2.52128478691253`", ",", 
          "5.68750940032752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18934286183326`", ",", "2.23547984826522`", ",", 
          "0.817105170655717`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12814838762577`", ",", "2.00415413844949`", ",", 
          "2.2298862481635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06695391341828`", ",", "1.79571912460618`", ",", 
          "3.64266732567129`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7225741320312`", ",", "1.59694093323665`", ",", 
          "5.05544840317908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66137965782371`", ",", "1.39920771236716`", ",", 
          "0.185044173507274`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60018518361622`", ",", "1.19432917934735`", ",", 
          "1.59782525101506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25580540222914`", ",", "0.970936469068108`", ",", 
          "3.01060632852285`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19461092802165`", ",", "0.705301275308052`", ",", 
          "4.42338740603063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13341645381416`", ",", "0.289783513771445`", ",", 
          "5.83616848353842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.789036672427086`", ",", "2.57699651449574`", ",", 
          "0.965764253866617`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7278421982196`", ",", "2.27564069128947`", ",", 
          "2.3785453313744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66664772401211`", ",", "2.03871068621469`", ",", 
          "3.79132640888219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.322267942625028`", ",", "1.82775094053902`", ",", 
          "5.20410748638998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26107346841754`", ",", "1.62807449764158`", ",", 
          "0.333703256718175`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19987899421005`", ",", "1.43069583675856`", ",", 
          "1.74648433422596`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13868452000256`", ",", "1.22756457124786`", ",", 
          "3.15926541173375`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79430473861548`", ",", "1.00815576241961`", ",", 
          "4.57204648924153`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73311026440799`", ",", "0.752019142809985`", ",", 
          "5.98482756674932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6719157902005`", ",", "0.383927919931354`", ",", 
          "1.11442333707752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32753600881342`", ",", "2.6381150224784`", ",", 
          "2.5272044145853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26634153460593`", ",", "2.31722390703386`", ",", 
          "3.93998549209309`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20514706039844`", ",", "2.07388183350953`", ",", 
          "5.35276656960088`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.860767279011366`", ",", "1.86005477791912`", ",", 
          "0.482362339929075`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79957280480388`", ",", "1.65926376457397`", ",", 
          "1.89514341743686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73837833059639`", ",", "1.46204469497351`", ",", 
          "3.30792449494465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.393998549209309`", ",", "1.2604096387609`", ",", 
          "4.72070557245243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33280407500182`", ",", "1.04452079274793`", ",", 
          "6.13348664996022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27160960079433`", ",", "0.796510293865028`", ",", 
          "1.26308242028842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21041512658684`", ",", "0.459903574844412`", ",", 
          "2.6758634977962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86603534519976`", ",", "2.70693728976127`", ",", 
          "4.08864457530399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80484087099227`", ",", "2.36047311546885`", ",", 
          "5.50142565281177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74364639678478`", ",", "2.10974767033111`", ",", 
          "0.631021423139975`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3992666153977`", ",", "1.89267234632604`", ",", 
          "2.04380250064776`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33807214119021`", ",", "1.69053959019989`", ",", 
          "3.45658357815555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27687766698272`", ",", "1.49328657595914`", ",", 
          "4.86936465566333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.932497885595647`", ",", "1.29291211548061`", ",", 
          "6.28214573317112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87130341138816`", ",", "1.08013293328104`", ",", 
          "1.41174150349932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81010893718067`", ",", "0.839143193766869`", ",", 
          "2.8245225810071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.465729155793589`", ",", "0.525665739088046`", ",", 
          "4.23730365851489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4045346815861`", ",", "2.78795873365091`", ",", 
          "5.65008473602268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34334020737861`", ",", "2.40569868450153`", ",", 
          "0.779680506350875`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.28214573317112`", ",", "2.14640024584556`", ",", 
          "2.19246158385866`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93776595178404`", ",", "1.92564878406548`", ",", 
          "3.60524266136645`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87657147757655`", ",", "1.7219336029538`", ",", 
          "5.01802373887423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81537700336906`", ",", "1.52445280393732`", ",", 
          "0.147619509202432`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47099722198198`", ",", "1.32511586190333`", ",", 
          "1.56040058671022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40980274777449`", ",", "1.11507973195023`", ",", 
          "2.973181664218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.348608273567`", ",", "0.880202096826646`", ",", 
          "4.38596274172579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00422849217993`", ",", "0.584687070620299`", ",", 
          "5.79874381923358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94303401797244`", ",", "2.89286198367053`", ",", 
          "0.928339589561776`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88183954376495`", ",", "2.45330711781037`", ",", 
          "2.34112066706956`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.53745976237787`", ",", "2.18394659466324`", ",", 
          "3.75390174457735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47626528817038`", ",", "1.95903336612797`", ",", 
          "5.16668282208513`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41507081396289`", ",", "1.75347850428129`", ",", 
          "0.296278592413333`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0706910325758127`", ",", "1.55557403144254`", ",", 
          "1.70905966992112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00949655836832`", ",", "1.35706152955241`", ",", 
          "3.1218407474289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94830208416083`", ",", "1.1494376579515`", ",", 
          "4.53462182493669`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88710760995334`", ",", "0.919912035521906`", ",", 
          "5.94740290244448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54272782856627`", ",", "0.638854001441458`", ",", 
          "1.07699867277268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48153335435877`", ",", "0.0257264430420481`", ",", 
          "2.48977975028046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42033888015128`", ",", "2.50384939429895`", ",", 
          "3.90256082778825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07595909876421`", ",", "2.22251277773623`", ",", 
          "5.31534190529603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01476462455672`", ",", "1.9928803614472`", ",", 
          "0.444937675624233`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95357015034923`", ",", "1.78520839708673`", ",", 
          "1.85771875313202`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.60919036896215`", ",", "1.58668051558346`", ",", 
          "3.2704998306398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54799589475466`", ",", "1.38878711984239`", ",", 
          "4.68328090814759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48680142054717`", ",", "1.18327421021081`", ",", 
          "6.09606198565538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.142421639160093`", ",", "0.958455050572404`", ",", 
          "1.22565775598358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0812271649526`", ",", "0.689326751588645`", ",", 
          "2.63843883349136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02003269074511`", ",", "0.251404991733837`", ",", 
          "4.05121991099915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95883821653762`", ",", "2.55810574227954`", ",", 
          "5.46400098850693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61445843515055`", ",", "2.26224939211707`", ",", 
          "0.593596758835133`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55326396094306`", ",", "2.02725008522757`", ",", 
          "2.00637783634292`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49206948673557`", ",", "1.81715915159886`", ",", 
          "3.4191589138507`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14768970534849`", ",", "1.61780238458031`", ",", 
          "4.83193999135849`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.086495231141`", ",", "1.4203284612756`", ",", 
          "6.24472106886628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02530075693351`", ",", "1.21664956269496`", ",", 
          "1.37431683919448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.680920975546431`", ",", "0.995981146253175`", ",", 
          "2.78709791670226`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61972650133894`", ",", "0.736879374732376`", ",", 
          "4.19987899421005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55853202713145`", ",", "0.355540047854319`", ",", 
          "5.61266007171783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.214152245744374`", ",", "2.61724732536077`", ",", 
          "0.742255842046033`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15295777153688`", ",", "2.30333926466201`", ",", 
          "2.15503691955382`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09176329732939`", ",", "2.06221020872239`", ",", 
          "3.5678179970616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0305688231219`", ",", "1.84936882039477`", ",", 
          "4.98059907456939`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68618904173483`", ",", "1.64896990115717`", ",", 
          "0.11019484489759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62499456752734`", ",", "1.45171962328029`", ",", 
          "1.52297592240538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56380009331985`", ",", "1.2496178679136`", ",", 
          "2.93575699991316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21942031193277`", ",", "1.03261592755914`", ",", 
          "4.34853807742095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15822583772528`", ",", "0.782059068944709`", ",", 
          "5.76131915492873`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09703136351779`", ",", "0.436224351302991`", ",", 
          "0.890914925256933`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.752651582130712`", ",", "2.68318236531199`", ",", 
          "2.30369600276472`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69145710792322`", ",", "2.34600849542183`", ",", 
          "3.7164770802725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63026263371573`", ",", "2.09783741298352`", ",", 
          "5.12925815778029`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.285882852328654`", ",", "1.8818781171276`", ",", 
          "0.258853928108491`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22468837812116`", ",", "1.6802137292167`", ",", 
          "1.67163500561628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16349390391367`", ",", "1.48299328116628`", ",", 
          "3.08441608312406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10229942970618`", ",", "1.28222830451671`", ",", 
          "4.49719716063185`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75791964831911`", ",", "1.06846607244173`", ",", 
          "5.90997823813963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69672517411162`", ",", "0.825269877704677`", ",", 
          "1.03957400846783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63553069990413`", ",", "0.504847634120681`", ",", 
          "2.45235508597562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29115091851705`", ",", "2.75943549926666`", ",", 
          "3.8651361634834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22995644430956`", ",", "2.39054283044627`", ",", 
          "5.27791724099119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16876197010207`", ",", "2.13421950884918`", ",", 
          "0.407513011319391`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.824382188714992`", ",", "1.91473097736279`", ",", 
          "1.82029408882718`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7631877145075`", ",", "1.71156521038287`", ",", 
          "3.23307516633496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70199324030001`", ",", "1.51418104388802`", ",", 
          "4.64585624384275`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.357613458912935`", ",", "1.31452593094834`", ",", 
          "6.05863732135053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29641898470544`", ",", "1.10362334708566`", ",", 
          "1.18823309167873`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23522451049795`", ",", "0.866820490996027`", ",", 
          "2.60101416918652`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17403003629046`", ",", "0.565831795765145`", ",", 
          "4.01379524669431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82965025490339`", ",", "2.85413430733048`", ",", 
          "5.42657632420209`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7684557806959`", ",", "2.43731289345348`", ",", 
          "0.556172094530291`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70726130648841`", ",", "2.17145819952043`", ",", 
          "1.96895317203808`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36288152510133`", ",", "1.94797522524797`", ",", 
          "3.38173424954586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30168705089384`", ",", "1.74305665747785`", ",", 
          "4.79451532705365`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24049257668635`", ",", "1.54531375429193`", ",", 
          "6.20729640456143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.896112795299273`", ",", "1.34655239063391`", ",", 
          "1.33689217488963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83491832109178`", ",", "1.13816761425491`", ",", 
          "2.74967325239742`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77372384688429`", ",", "0.906953340765288`", ",", 
          "4.16245432990521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.429344065497215`", ",", "0.621445494814918`", ",", 
          "5.57523540741299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36814959128972`", ",", "3.00057017995827`", ",", 
          "0.704831177741191`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30695511708224`", ",", "2.48681494980958`", ",", 
          "2.11761225524898`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24576064287474`", ",", "2.20967274591617`", ",", 
          "3.53039333275676`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90138086148767`", ",", "1.98166337712913`", ",", 
          "4.94317441026455`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84018638728018`", ",", "1.77472167284053`", ",", 
          "0.0727701805927484`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77899191307269`", ",", "1.5764217700983`", ",", 
          "1.48555125810053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43461213168561`", ",", "1.37834650264032`", ",", 
          "2.89833233560832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37341765747812`", ",", "1.17216912953666`", ",", 
          "4.31111341311611`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31222318327063`", ",", "0.9458632272012`", ",", 
          "5.72389449062389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.967843401883553`", ",", "0.673036397727635`", ",", 
          "0.853490260952091`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90664892767606`", ",", "0.206170823957271`", ",", 
          "2.26627133845988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84545445346857`", ",", "2.5397407743884`", ",", 
          "3.67905241596766`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.501074672081496`", ",", "2.24900492859294`", ",", 
          "5.09183349347545`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43988019787401`", ",", "2.01585362359132`", ",", 
          "0.221429263803649`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37868572366652`", ",", "1.80659550066785`", ",", 
          "1.63421034131143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0343059422794385`", ",", "1.6075352329022`", ",", 
          "3.04699141881922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97311146807195`", ",", "1.40994476355756`", ",", 
          "4.45977249632701`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91191699386446`", ",", "1.20569032381247`", ",", 
          "5.87255357383479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85072251965697`", ",", "0.983709742473137`", ",", 
          "1.00214934416299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50634273826989`", ",", "0.721482649660386`", ",", 
          "2.41493042167078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4451482640624`", ",", "0.324793185363498`", ",", 
          "3.82771149917856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38395378985491`", ",", "2.5971069127659`", ",", 
          "5.24049257668635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03957400846783`", ",", "2.28962591970506`", ",", 
          "0.370088347014549`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97837953426034`", ",", "2.05061104614384`", ",", 
          "1.78286942452233`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91718506005285`", ",", "1.83871542437532`", ",", 
          "3.19565050203012`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.572805278665776`", ",", "1.63868433189147`", ",", 
          "4.60843157953791`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51161080445829`", ",", "1.44138178046878`", ",", 
          "6.02121265704569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4504163302508`", ",", "1.23878720853938`", ",", 
          "1.15080842737389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.106036548863719`", ",", "1.02062584503194`", ",", 
          "2.56358950488168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04484207465623`", ",", "0.767394460712497`", ",", 
          "3.97637058238946`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98364760044874`", ",", "0.411275838117005`", ",", 
          "5.38915165989725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92245312624125`", ",", "2.66051983527733`", ",", 
          "0.518747430225449`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57807334485417`", ",", "2.33174605306663`", ",", 
          "1.93152850773324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51687887064668`", ",", "2.08600914606773`", ",", 
          "3.34430958524102`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45568439643919`", ",", "1.87112122249649`", ",", 
          "4.75709066274881`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11130461505211`", ",", "1.66989956872534`", ",", 
          "6.16987174025659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05011014084462`", ",", "1.4726906506163`", ",", 
          "1.29946751058479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98891566663713`", ",", "1.27151049990393`", ",", 
          "2.71224858809258`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.644535885250057`", ",", "1.05672395071888`", ",", 
          "4.12502966560036`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58334141104257`", ",", "0.811216524240144`", ",", 
          "5.53781074310815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52214693683508`", ",", "0.48321378176691`", ",", 
          "0.667406513436349`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.177767155448`", ",", "2.7328070988982`", ",", 
          "2.08018759094413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11657268124051`", ",", "2.37562914657571`", ",", 
          "3.49296866845192`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05537820703302`", ",", "2.122131794278`", ",", 
          "4.90574974595971`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99418373282553`", ",", "1.90385570011502`", ",", 
          "0.0353455162879063`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64980395143845`", ",", "1.7012120300723`", ",", 
          "1.44812659379569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58860947723096`", ",", "1.50390330027575`", ",", 
          "2.86090767130348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52741500302347`", ",", "1.30390653072309`", ",", 
          "4.27368874881126`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18303522163639`", ",", "1.09210036883559`", ",", 
          "5.68646982631905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1218407474289`", ",", "0.853285068284725`", ",", 
          "0.816065596647249`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06064627322141`", ",", "0.546399247066566`", ",", 
          "2.22884667415504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.716266491834337`", ",", "2.81992485324546`", ",", 
          "3.64162775166282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65507201762685`", ",", "2.42161427647428`", ",", 
          "5.05440882917061`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59387754341936`", ",", "2.15907575811347`", ",", 
          "0.184004599498807`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.24949776203228`", ",", "1.93696531760605`", ",", 
          "1.59678567700659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18830328782479`", ",", "1.73265367467771`", ",", 
          "3.00956675451438`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1271088136173`", ",", "1.53505079310655`", ",", 
          "4.42234783202216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06591433940981`", ",", "1.33601800035867`", ",", 
          "5.83512890952995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72153455802273`", ",", "1.12683860388544`", ",", 
          "0.96472467985815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66034008381524`", ",", "0.893861917495915`", ",", 
          "2.37750575736594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59914560960775`", ",", "0.603603043722739`", ",", 
          "3.79028683487372`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25476582822068`", ",", "2.94032873015964`", ",", 
          "5.20306791238151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19357135401318`", ",", "2.47015037328279`", ",", 
          "0.332663682709707`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1323768798057`", ",", "2.19695403331312`", ",", 
          "1.74544476021749`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.787997098418618`", ",", "1.97050094508677`", ",", 
          "3.15822583772528`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72680262421113`", ",", "1.7642576425474`", ",", 
          "4.57100691523306`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66560815000364`", ",", "1.5661636166433`", ",", 
          "5.98378799274085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.321228368616561`", ",", "1.36788459995556`", ",", 
          "1.11338376306905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26003389440907`", ",", "1.16101186089581`", ",", 
          "2.52616484057684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19883942020158`", ",", "0.933155964604649`", ",", 
          "3.93894591808462`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13764494599409`", ",", "0.656406105485195`", ",", 
          "5.35172699559241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79326516460701`", ",", "0.147917901352281`", ",", 
          "0.481322765920607`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73207069039952`", ",", "2.52185428080099`", ",", 
          "1.89410384342839`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67087621619203`", ",", "2.23590032363164`", ",", 
          "3.30688492093618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32649643480496`", ",", "2.00451878023314`", ",", 
          "4.71966599844397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26530196059747`", ",", "1.79605859495503`", ",", 
          "6.13244707595175`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20410748638998`", ",", "1.597271954486`", ",", 
          "1.26204284627995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.859727705002898`", ",", "1.39954354115623`", ",", 
          "2.67482392378774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79853323079541`", ",", "1.1946849797384`", ",", 
          "4.08760500129552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73733875658792`", ",", "0.971337311609089`", ",", 
          "5.50038607880331`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.392958975200841`", ",", "0.705811573490424`", ",", 
          "0.629981849131507`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33176450099335`", ",", "0.290939323752083`", ",", 
          "2.04276292663929`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27057002678586`", ",", "2.57761524759756`", ",", 
          "3.45554400414708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20937555257837`", ",", "2.27607519630258`", ",", 
          "4.86832508165486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86499577119129`", ",", "2.03908148022391`", ",", 
          "6.28110615916265`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8038012969838`", ",", "1.82809309560207`", ",", 
          "1.41070192949085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74260682277631`", ",", "1.62840595104224`", ",", 
          "2.82348300699864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39822704138924`", ",", "1.43103000989084`", ",", 
          "4.23626408450642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33703256718175`", ",", "1.22791595253254`", ",", 
          "5.64904516201421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27583809297426`", ",", "1.00854692641836`", ",", 
          "0.778640932342407`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.931458311587179`", ",", "0.752503426095265`", ",", 
          "2.19142200985019`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87026383737969`", ",", "0.384810398029632`", ",", 
          "3.60420308735798`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8090693631722`", ",", "2.63880130320451`", ",", 
          "5.01698416486577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.464689581785122`", ",", "2.3176747543389`", ",", 
          "0.146579935193965`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40349510757763`", ",", "2.07425957740158`", ",", 
          "1.55936101270175`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34230063337014`", ",", "1.86040004552683`", ",", 
          "2.97214209020954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.28110615916265`", ",", "1.65959597531376`", ",", 
          "4.38492316771732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93672637777557`", ",", "1.46237756210775`", ",", 
          "5.79770424522511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87553190356808`", ",", "1.26075713177907`", ",", 
          "0.927300015553308`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81433742936059`", ",", "1.0449034411456`", ",", 
          "2.34008109306109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46995764797352`", ",", "0.796973047228638`", ",", 
          "3.75286217056888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40876317376603`", ",", "0.460648532256896`", ",", 
          "5.16564324807667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34756869955854`", ",", "2.70772377501784`", ",", 
          "0.295239018404865`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00318891817146`", ",", "2.36094321485133`", ",", 
          "1.70802009591265`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94199444396397`", ",", "2.1101332757687`", ",", 
          "3.12080117342044`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88079996975648`", ",", "1.89302118748612`", ",", 
          "4.53358225092822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.536420188369402`", ",", "1.6908728901741`", ",", 
          "5.94636332843601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47522571416191`", ",", "1.4936184748704`", ",", 
          "1.07595909876421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41403123995442`", ",", "1.29325620593077`", ",", 
          "2.48874017627199`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0696514585673449`", ",", "1.08050806464586`", ",", 
          "3.90152125377978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00845698435985`", ",", "0.83958782965608`", ",", 
          "5.31430233128757`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94726251015236`", ",", "0.5263248186135`", ",", 
          "0.443898101615765`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88606803594487`", ",", "2.78891549762838`", ",", 
          "1.85667917912355`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5416882545578`", ",", "2.40619178957952`", ",", 
          "3.26946025663134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48049378035031`", ",", "2.14679476649122`", ",", 
          "4.68224133413912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41929930614282`", ",", "1.92600169983613`", ",", 
          "6.09502241164691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07491952475574`", ",", "1.72226833384865`", ",", 
          "1.22461818197511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01372505054825`", ",", "1.52478406374924`", ",", 
          "2.63739925948289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95253057634076`", ",", "1.32545699806179`", ",", 
          "4.05018033699068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.608150794953683`", ",", "1.11544821386011`", ",", 
          "5.46296141449847`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54695632074619`", ",", "0.880631285981215`", ",", 
          "0.592557184826665`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4857618465387`", ",", "0.585286334841492`", ",", 
          "2.00533826233445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.141382065151625`", ",", "2.89420975894505`", ",", 
          "3.41811933984224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08018759094413`", ",", "2.45382822026735`", ",", 
          "4.83090041735002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01899311673665`", ",", "2.18435126318799`", ",", 
          "6.24368149485781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95779864252916`", ",", "1.95939090588243`", ",", 
          "1.37327726518601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61341886114208`", ",", "1.7538150209065`", ",", 
          "2.78605834269379`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55222438693459`", ",", "1.5559049756415`", ",", 
          "4.19883942020158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4910299127271`", ",", "1.35740012872519`", ",", 
          "5.61162049770937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14665013134002`", ",", "1.14980025241225`", ",", 
          "0.741216268037565`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08545565713253`", ",", "0.920327917607466`", ",", 
          "2.15399734554535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02426118292504`", ",", "0.639408750012669`", ",", 
          "3.56677842305314`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.679881401537963`", ",", "0.0363836881309503`", ",", 
          "4.97955950056092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61868692733047`", ",", "2.50440539008823`", ",", 
          "0.109155270889123`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55749245312298`", ",", "2.2229290557142`", ",", 
          "1.52193634839691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.213112671735906`", ",", "1.99324313294838`", ",", 
          "2.93471742590469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15191819752842`", ",", "1.78554707105197`", ",", 
          "4.34749850341248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09072372332092`", ",", "1.58701146489327`", ",", 
          "5.76027958092027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02952924911344`", ",", "1.38912357383504`", ",", 
          "0.889875351248466`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68514946772636`", ",", "1.18363159334244`", ",", 
          "2.30265642875625`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62395499351887`", ",", "0.958859374022118`", ",", 
          "3.71543750626404`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56276051931138`", ",", "0.689846866472018`", ",", 
          "5.12821858377182`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2183807379243`", ",", "0.252731762988862`", ",", 
          "0.257814354100023`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15718626371681`", ",", "2.55870664076776`", ",", 
          "1.67059543160781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09599178950932`", ",", "2.26267903879978`", ",", 
          "3.08337650911559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.751612008122244`", ",", "2.02761876707815`", ",", 
          "4.49615758662338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69041753391475`", ",", "1.81750037544725`", ",", 
          "5.90893866413117`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62922305970726`", ",", "1.61813365976941`", ",", 
          "1.03853443445937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.284843278320186`", ",", "1.42066314110054`", ",", 
          "2.45131551196715`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2236488041127`", ",", "1.21700234021893`", ",", 
          "3.86409658947494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16245432990521`", ",", "0.996375364393824`", ",", 
          "5.27687766698272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10125985569772`", ",", "0.737371676411063`", ",", 
          "0.406473437310923`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75688007431064`", ",", "0.35648945141866`", ",", 
          "1.81925451481871`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69568560010315`", ",", "2.61790866241616`", ",", 
          "3.23203559232649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63449112589566`", ",", "2.30378443421476`", ",", 
          "4.64481666983428`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29011134450858`", ",", "2.06258556596752`", ",", 
          "6.05759774734207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22891687030109`", ",", "1.84971301233167`", ",", 
          "1.18719351767027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1677223960936`", ",", "1.6493018258469`", ",", 
          "2.59997459517805`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.823342614706524`", ",", "1.4520528832737`", ",", 
          "4.01275567268584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76214814049903`", ",", "1.24996658751647`", ",", 
          "5.42553675019362`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70095366629154`", ",", "1.03300126665925`", ",", 
          "0.555132520521823`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.356573884904467`", ",", "0.782528501224889`", ",", 
          "1.96791359802961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29537941069698`", ",", "0.437006867871217`", ",", 
          "3.38069467553739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23418493648949`", ",", "2.68393070551604`", ",", 
          "4.79347575304518`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.172990462282`", ",", "2.34647187852482`", ",", 
          "6.20625683055297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82861068089492`", ",", "2.09822031695343`", ",", 
          "1.33585260088117`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76741620668743`", ",", "1.88222572651807`", ",", 
          "2.74863367838895`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70622173247994`", ",", "1.6805466327593`", ",", 
          "4.16141475589674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36184195109286`", ",", "1.48332546265199`", ",", 
          "5.57419583340452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30064747688537`", ",", "1.28257346585913`", ",", 
          "0.703791603732723`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23945300267788`", ",", "1.06884358111651`", ",", 
          "2.11657268124051`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.895073221290805`", ",", "0.825720162200005`", ",", 
          "3.52935375874829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83387874708331`", ",", "0.505531363382393`", ",", 
          "4.94213483625608`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77268427287582`", ",", "2.76032381381357`", ",", 
          "0.0717306065842805`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.428304491488747`", ",", "2.39102786783738`", ",", 
          "1.48451168409207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36711001728126`", ",", "2.13461096279248`", ",", 
          "2.89729276159985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30591554307377`", ",", "1.91508249121911`", ",", 
          "4.31007383910764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24472106886628`", ",", "1.71189943088135`", ",", 
          "5.72285491661542`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9003412874792`", ",", "1.51451247850069`", ",", 
          "0.852450686943624`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83914681327171`", ",", "1.31486799387947`", ",", 
          "2.26523176445141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77795233906422`", ",", "1.10399393296677`", ",", 
          "3.67801284195919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43357255767714`", ",", "0.867254515197301`", ",", 
          "5.09079391946698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37237808346965`", ",", "0.566448723323749`", ",", 
          "0.220389689795181`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31118360926216`", ",", "2.85530377496304`", ",", 
          "1.63317076730297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.966803827875085`", ",", "2.43782411181452`", ",", 
          "3.04595184481075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90560935366759`", ",", "2.17185937228846`", ",", 
          "4.45873292231854`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8444148794601`", ",", "1.94833117599494`", ",", 
          "5.87151399982632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.500035098073028`", ",", "1.74339254502661`", ",", 
          "1.00110977015452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43884062386554`", ",", "1.54564476705404`", ",", 
          "2.41389084766231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37764614965805`", ",", "1.34689178202582`", ",", 
          "3.8266719251701`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0332663682709707`", ",", "1.13853207174487`", ",", 
          "5.23945300267788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97207189406348`", ",", "0.907373401261079`", ",", 
          "0.369048773006081`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91087741985599`", ",", "0.622013631590777`", ",", 
          "1.78182985051387`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8496829456485`", ",", "3.0029443114766`", ",", 
          "3.19461092802165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50530316426142`", ",", "2.48735851820902`", ",", 
          "4.60739200552944`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44410869005393`", ",", "2.21008501707164`", ",", 
          "6.02017308303722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38291421584644`", ",", "1.98202435202749`", ",", 
          "1.14976885336542`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03853443445937`", ",", "1.77505959307699`", ",", 
          "2.56254993087321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97733996025188`", ",", "1.5767526823326`", ",", 
          "3.975331008381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91614548604439`", ",", "1.3786836221546`", ",", 
          "5.38811208588878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.571765704657309`", ",", "1.17252816118783`", ",", 
          "0.517707856216981`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51057123044982`", ",", "0.946271189082724`", ",", 
          "1.93048893372477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44937675624233`", ",", "0.673567062109163`", ",", 
          "3.34327001123255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.104996974855251`", ",", "0.20778106520321`", ",", 
          "4.75605108874034`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04380250064776`", ",", "2.54032548861672`", ",", 
          "6.16883216624813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98260802644027`", ",", "2.24942995011488`", ",", 
          "1.29842793657632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92141355223278`", ",", "2.01622027633058`", ",", 
          "2.71120901408411`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5770337708457`", ",", "1.80693583874127`", ",", 
          "4.1239900915919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51583929663821`", ",", "1.6078663650535`", ",", 
          "5.53677116909968`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45464482243072`", ",", "1.41027998858315`", ",", 
          "0.666366939427881`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11026504104365`", ",", "1.20604455706163`", ",", 
          "2.07914801693567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04907056683616`", ",", "0.984107147731071`", ",", 
          "3.49192909444345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98787609262867`", ",", "0.721983502377822`", ",", 
          "4.90471017195124`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.643496311241589`", ",", "0.325828552117754`", ",", 
          "0.0343059422794385`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5823018370341`", ",", "2.59774609295048`", ",", 
          "1.44708701978722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52110736282661`", ",", "2.29006570246716`", ",", 
          "2.85986809729501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.176727581439532`", ",", "2.05098411130285`", ",", 
          "4.2726491748028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11553310723204`", ",", "1.83905858946208`", ",", 
          "5.68543025231058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05433863302455`", ",", "1.63901600632705`", ",", 
          "0.815026022638781`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99314415881706`", ",", "1.44171547041687`", ",", 
          "2.22780710014657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64876437742998`", ",", "1.23913720900392`", ",", 
          "3.64058817765435`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58756990322249`", ",", "1.02101398858915`", ",", 
          "5.05336925516214`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.526375429015`", ",", "0.76787097365187`", ",", 
          "0.182965025490339`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18199564762793`", ",", "0.412102778089925`", ",", 
          "1.59574610299812`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12080117342044`", ",", "2.66123544339631`", ",", 
          "3.00852718050591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05960669921295`", ",", "2.3322030914846`", ",", 
          "4.4213082580137`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.71522691782587`", ",", "2.08638945741424`", ",", 
          "5.83408933552148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65403244361838`", ",", "1.87146765302229`", ",", 
          "0.963685105849682`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59283796941089`", ",", "1.6702321125822`", ",", 
          "2.37646618335747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.248458188023812`", ",", "1.47302315072014`", ",", 
          "3.78924726086525`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18726371381632`", ",", "1.27185678209676`", ",", 
          "5.20202833837304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12606923960883`", ",", "1.0571039351957`", ",", 
          "0.331624108701239`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06487476540134`", ",", "0.811672769478651`", ",", 
          "1.74440518620902`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72049498401426`", ",", "0.483925497100278`", ",", 
          "3.15718626371681`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65930050980677`", ",", "2.73364038005722`", ",", 
          "4.5699673412246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59810603559928`", ",", "2.37610660429997`", ",", 
          "5.98274841873238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25372625421221`", ",", "2.12252030828363`", ",", 
          "1.11234418906058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19253178000472`", ",", "1.90420586988775`", ",", 
          "2.52512526656837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13133730579723`", ",", "1.70154577822197`", ",", 
          "3.93790634407615`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.78695752441015`", ",", "1.50423494501505`", ",", 
          "5.35068742158394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72576305020266`", ",", "1.30424956680701`", ",", 
          "0.480283191912139`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66456857599517`", ",", "1.09247314491594`", ",", 
          "1.89306426941993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.320188794608093`", ",", "0.853724176053495`", ",", 
          "3.30584534692771`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2589943204006`", ",", "0.5470357456218`", ",", 
          "4.7186264244355`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19779984619311`", ",", "2.82097318104864`", ",", 
          "6.13140750194328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13660537198562`", ",", "2.4221162741744`", ",", 
          "1.26100327227148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79222559059855`", ",", "2.15947358467529`", ",", 
          "2.67378434977927`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73103111639105`", ",", "1.93731974312286`", ",", 
          "4.08656542728705`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66983664218357`", ",", "1.7329889728847`", ",", 
          "5.49934650479484`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32545686079649`", ",", "1.53538190935603`", ",", 
          "0.628942275123039`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.264262386589`", ",", "1.33635822739706`", ",", 
          "2.04172335263083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20306791238151`", ",", "1.12720500067999`", ",", 
          "3.45450443013861`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.858688130994431`", ",", "0.894286358391501`", ",", 
          "4.8672855076464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79749365678694`", ",", "0.604185777371697`", ",", 
          "6.28006658515418`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73629918257945`", ",", "2.94199079647681`", ",", 
          "1.40966235548238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.391919401192373`", ",", "2.47068245671699`", ",", 
          "2.82244343299017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33072492698488`", ",", "2.19736247662956`", ",", 
          "4.23522451049795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26953045277739`", ",", "1.97086019436152`", ",", 
          "5.64800558800574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2083359785699`", ",", "1.76459485090746`", ",", 
          "0.77760135833394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86395619718283`", ",", "1.566494526631`", ",", 
          "2.19038243584173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80276172297533`", ",", "1.36822242600162`", ",", 
          "3.60316351334951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74156724876784`", ",", "1.16137260919978`", ",", 
          "5.0159445908573`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39718746738077`", ",", "0.933567732021261`", ",", 
          "0.145540361185497`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33599299317328`", ",", "0.656948141459432`", ",", 
          "1.55832143869328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27479851896579`", ",", "0.15014651274074`", ",", 
          "2.97110251620107`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.930418737578711`", ",", "2.52242422959636`", ",", 
          "4.38388359370885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86922426337122`", ",", "2.23632093771049`", ",", 
          "5.79666467121664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80802978916373`", ",", "2.0048834836072`", ",", 
          "0.92626044154484`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.463650007776654`", ",", "1.79639809171336`", ",", 
          "2.33904151905263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40245553356916`", ",", "1.59760297863713`", ",", 
          "3.75182259656041`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34126105936167`", ",", "1.39987935044133`", ",", 
          "5.1646036740682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.28006658515418`", ",", "1.19504073014317`", ",", 
          "0.294199444396397`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93568680376711`", ",", "0.971738044384179`", ",", 
          "1.70698052190418`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87449232955962`", ",", "0.706321566314296`", ",", 
          "3.11976159941197`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81329785535213`", ",", "0.292090689476146`", ",", 
          "4.53254267691975`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46891807396505`", ",", "2.57823458655427`", ",", 
          "5.94532375442754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40772359975756`", ",", "2.27650986210601`", ",", 
          "1.07491952475574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34652912555007`", ",", "2.03945234378915`", ",", 
          "2.48770060226353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00214934416299`", ",", "1.82843528147244`", ",", 
          "3.90048167977131`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9409548699555`", ",", "1.6287374107791`", ",", 
          "5.3132627572791`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87976039574801`", ",", "1.43136416731349`", ",", 
          "0.442858527607297`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.535380614360934`", ",", "1.22826728974673`", ",", 
          "1.85563960511508`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47418614015344`", ",", "1.00893799403163`", ",", 
          "3.26842068262287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41299166594595`", ",", "0.752987459019289`", ",", 
          "4.68120176013066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.068611884558877`", ",", "0.38569095742675`", ",", 
          "6.09398283763844`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00741741035139`", ",", "2.63948844143628`", ",", 
          "1.22357860796664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9462229361439`", ",", "2.31812578990017`", ",", 
          "2.63635968547443`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88502846193641`", ",", "2.07463739990502`", ",", 
          "4.04914076298221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54064868054933`", ",", "1.86074534866045`", ",", 
          "5.46192184049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47945420634184`", ",", "1.65992819587997`", ",", 
          "0.591517610818197`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41825973213435`", ",", "1.46271041718228`", ",", 
          "2.00429868832598`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07387995074727`", ",", "1.26110458611634`", ",", 
          "3.41707976583377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01268547653978`", ",", "1.04528600457816`", ",", 
          "4.82986084334156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95149100233229`", ",", "0.7974355914469`", ",", 
          "6.24264192084934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.607111220945215`", ",", "0.461392373048888`", ",", 
          "1.37223769117754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54591674673772`", ",", "2.70851159762788`", ",", 
          "2.78501876868533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48472227253023`", ",", "2.36141353744212`", ",", 
          "4.19779984619311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.140342491143158`", ",", "2.110518970223`", ",", 
          "5.6105809237009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07914801693567`", ",", "1.89337006927847`", ",", 
          "0.740176694029097`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01795354272818`", ",", "1.69120620355251`", ",", 
          "2.15295777153688`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95675906852069`", ",", "1.49395036526328`", ",", 
          "3.56573884904467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61237928713361`", ",", "1.29360026265341`", ",", 
          "4.97851992655246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55118481292612`", ",", "1.08088312091333`", ",", 
          "0.108115696880655`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48999033871863`", ",", "0.840032288259087`", ",", 
          "1.52089677438844`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14561055733155`", ",", "0.526983151321592`", ",", 
          "2.93367785189623`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08441608312406`", ",", "2.78987475514813`", ",", 
          "4.34645892940401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02322160891657`", ",", "2.4066851635728`", ",", 
          "5.7592400069118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.678841827529495`", ",", "2.14718938824964`", ",", 
          "0.888835777239998`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.617647353322`", ",", "1.92635466181308`", ",", 
          "2.30161685474778`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55645287911452`", ",", "1.72260308184703`", ",", 
          "3.71439793225557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.212073097727438`", ",", "1.5251153185086`", ",", 
          "5.12717900976336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15087862351995`", ",", "1.32579810508466`", ",", 
          "0.256774780091555`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08968414931246`", ",", "1.11581662929535`", ",", 
          "1.66955585759934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02848967510497`", ",", "0.881060323108856`", ",", 
          "3.08233693510713`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68410989371789`", ",", "0.585885057692261`", ",", 
          "4.49511801261491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6229154195104`", ",", "2.89556476537396`", ",", 
          "5.9078990901227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56172094530291`", ",", "2.4543496534513`", ",", 
          "1.0374948604509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21734116391583`", ",", "2.18475604706689`", ",", 
          "2.45027593795868`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15614668970834`", ",", "1.95974849798173`", ",", 
          "3.86305701546647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09495221550085`", ",", "1.75415155849323`", ",", 
          "5.27583809297426`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.750572434113776`", ",", "1.55623591820938`", ",", 
          "0.405433863302455`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68937795990629`", ",", "1.35773870305578`", ",", 
          "1.81821494081024`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6281834856988`", ",", "1.1501627880124`", ",", 
          "3.23099601831803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.283803704311719`", ",", "0.920743668123404`", ",", 
          "4.64377709582581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22260923010423`", ",", "0.639963085046678`", ",", 
          "6.0565581733336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16141475589674`", ",", "0.044561964617605`", ",", 
          "1.1861539436618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10022028168925`", ",", "2.50496180383452`", ",", 
          "2.59893502116958`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75584050030217`", ",", "2.22334546605218`", ",", 
          "4.01171609867737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69464602609468`", ",", "1.99360596361623`", ",", 
          "5.42449717618516`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63345155188719`", ",", "1.78588577003676`", ",", 
          "0.554092946513355`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28907177050011`", ",", "1.58734241597924`", ",", 
          "1.96687402402114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22787729629262`", ",", "1.3894600070341`", ",", 
          "3.37965510152893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16668282208513`", ",", "1.18398892440343`", ",", 
          "4.79243617903671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.822303040698056`", ",", "0.959263582774924`", ",", 
          "6.2052172565445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76110856649057`", ",", "0.690366653690702`", ",", 
          "1.3348130268727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69991409228308`", ",", "0.254051752742449`", ",", 
          "2.74759410438048`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.355534310895999`", ",", "2.55930808742523`", ",", 
          "4.16037518188827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29433983668851`", ",", "2.26310883847613`", ",", 
          "5.57315625939606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23314536248102`", ",", "2.02798751574827`", ",", 
          "0.702752029724256`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17195088827353`", ",", "1.81784162862014`", ",", 
          "2.11553310723204`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82757110688645`", ",", "1.61846494015744`", ",", 
          "3.52831418473983`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76637663267896`", ",", "1.42099780398233`", ",", 
          "4.94109526224761`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70518215847147`", ",", "1.21735507178453`", ",", 
          "0.0706910325758127`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36080237708439`", ",", "0.996769481976433`", ",", 
          "1.4834721100836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2996079028769`", ",", "0.737863711399597`", ",", 
          "2.89625318759138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23841342866941`", ",", "0.357436440703301`", ",", 
          "4.30903426509917`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.894033647282337`", ",", "2.61857075773287`", ",", 
          "5.72181534260696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83283917307485`", ",", "2.30422978225949`", ",", 
          "0.851411112935156`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77164469886736`", ",", "2.06296099870266`", ",", 
          "2.26419219044294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.42726491748028`", ",", "1.85005723819902`", ",", 
          "3.67697326795073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36607044327279`", ",", "1.64963375920394`", ",", 
          "5.08975434545851`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3048759690653`", ",", "1.4523861300174`", ",", 
          "0.219350115786713`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24368149485781`", ",", "1.25031526671327`", ",", 
          "1.6321311932945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89930171347073`", ",", "1.03338651721711`", ",", 
          "3.04491227080228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83810723926324`", ",", "0.782997711974552`", ",", 
          "4.45769334831007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77691276505575`", ",", "0.437788075788181`", ",", 
          "5.87047442581786`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43253298366867`", ",", "2.68468018444143`", ",", 
          "1.00007019614606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37133850946118`", ",", "2.34693547231222`", ",", 
          "2.41285127365384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31014403525369`", ",", "2.09860330634031`", ",", 
          "3.82563235116163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.965764253866617`", ",", "1.88257337480933`", ",", 
          "5.23841342866941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90456977965913`", ",", "1.68087954851448`", ",", 
          "0.368009198997613`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84337530545164`", ",", "1.48365763446135`", ",", 
          "1.7807902765054`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.49899552406456`", ",", "1.28291859188381`", ",", 
          "3.19357135401318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43780104985707`", ",", "1.06922101159066`", ",", 
          "4.60635243152097`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37660657564958`", ",", "0.826170259742332`", ",", 
          "6.01913350902876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0322267942625028`", ",", "0.506214249095959`", ",", 
          "1.14872927935696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97103232005501`", ",", "2.76121410114053`", ",", 
          "2.56151035686474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90983784584752`", ",", "2.3915131576096`", ",", 
          "3.97429143437253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84864337164003`", ",", "2.13500251364739`", ",", 
          "5.38707251188031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50426359025296`", ",", "1.91543404938625`", ",", 
          "0.516668282208513`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44306911604546`", ",", "1.71223366724772`", ",", 
          "1.9294493597163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38187464183797`", ",", "1.51484390692422`", ",", 
          "3.34223043722408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0374948604509`", ",", "1.31521002619653`", ",", 
          "4.75501151473187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97630038624341`", ",", "1.10436444965143`", ",", 
          "6.16779259223966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91510591203592`", ",", "0.867688379645655`", ",", 
          "1.29738836256786`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.570726130648841`", ",", "0.567065053006306`", ",", 
          "2.71016944007564`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50953165644135`", ",", "2.85647790711609`", ",", 
          "4.12295051758343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44833718223386`", ",", "2.43833563827745`", ",", 
          "5.53573159509121`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.103957400846783`", ",", "2.17226065544291`", ",", 
          "0.665327365419414`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04276292663929`", ",", "1.94868717699316`", ",", 
          "2.0781084429272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9815684524318`", ",", "1.74372845224461`", ",", 
          "3.49088952043498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92037397822431`", ",", "1.54597577705974`", ",", 
          "4.90367059794277`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57599419683724`", ",", "1.34723114718915`", ",", 
          "0.0332663682709707`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51479972262975`", ",", "1.13889646796244`", ",", 
          "1.44604744577876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45360524842226`", ",", "0.907793323887409`", ",", 
          "2.85882852328654`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10922546703518`", ",", "0.622581318513119`", ",", 
          "4.27160960079433`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04803099282769`", ",", "3.00535954074381`", ",", 
          "5.68439067830211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9868365186202`", ",", "2.48790247215228`", ",", 
          "0.813986448630314`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.642456737233121`", ",", "2.21049741462631`", ",", 
          "2.2267675261381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58126226302563`", ",", "1.98238538375884`", ",", 
          "3.63954860364589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52006778881814`", ",", "1.77539753696986`", ",", 
          "5.05232968115367`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.175688007431064`", ",", "1.57708359521915`", ",", 
          "0.181925451481871`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11449353322357`", ",", "1.37902071956418`", ",", 
          "1.59470652898966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05329905901608`", ",", "1.17288713861051`", ",", 
          "3.00748760649744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99210458480859`", ",", "0.946679031040882`", ",", 
          "4.42026868400523`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64772480342152`", ",", "0.674097373870851`", ",", 
          "5.83304976151301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58653032921403`", ",", "0.209379100523278`", ",", 
          "0.962645531841214`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52533585500654`", ",", "2.54091070165441`", ",", 
          "2.375426609349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18095607361946`", ",", "2.24985511735826`", ",", 
          "3.78820768685679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11976159941197`", ",", "2.01658699326317`", ",", 
          "5.20098876436457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05856712520448`", ",", "1.80727620468902`", ",", 
          "0.330584534692771`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.714187343817402`", ",", "1.6081975012714`", ",", 
          "1.74336561220056`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65299286960991`", ",", "1.41061519541504`", ",", 
          "3.15614668970834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59179839540242`", ",", "1.20639874240383`", ",", 
          "4.56892776721613`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.247418614015344`", ",", "0.984504448028789`", ",", 
          "5.98170884472391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18622413980785`", ",", "0.722484070385218`", ",", 
          "1.11130461505211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12502966560036`", ",", "0.326860755783162`", ",", 
          "2.5240856925599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06383519139287`", ",", "2.59838594951002`", ",", 
          "3.93686677006769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7194554100058`", ",", "2.29050565467741`", ",", 
          "5.34964784757547`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65826093579831`", ",", "2.05135724896655`", ",", 
          "0.479243617903671`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59706646159082`", ",", "1.83940178692336`", ",", 
          "1.89202469541146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25268668020374`", ",", "1.63934768827917`", ",", 
          "3.30480577291924`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19149220599625`", ",", "1.4420491459122`", ",", 
          "4.71758685042703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13029773178876`", ",", "1.23948716728691`", ",", 
          "6.13036792793482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.785917950401682`", ",", "1.02140203984579`", ",", 
          "1.25996369826301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72472347619419`", ",", "0.768347251540161`", ",", 
          "2.6727447757708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6635290019867`", ",", "0.412928156663518`", ",", 
          "4.08552585327859`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.319149220599625`", ",", "2.66195203565329`", ",", 
          "5.49830693078637`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25795474639213`", ",", "2.33266032908363`", ",", 
          "0.627902701114572`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19676027218464`", ",", "2.08676985074767`", ",", 
          "2.04068377862236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13556579797715`", ",", "1.8718141207651`", ",", 
          "3.45346485613014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79118601659008`", ",", "1.67056466747197`", ",", 
          "4.86624593363793`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72999154238259`", ",", "1.47335563998032`", ",", 
          "6.27902701114572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6687970681751`", ",", "1.27220302733989`", ",", 
          "1.40862278147391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32441728678802`", ",", "1.05748383822377`", ",", 
          "2.8214038589817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26322281258053`", ",", "0.812128817303829`", ",", 
          "4.23418493648949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20202833837304`", ",", "0.484636250020817`", ",", 
          "5.64696601399727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.857648556985963`", ",", "2.73447527089279`", ",", 
          "0.776561784325472`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79645408277847`", ",", "2.37658429937234`", ",", 
          "2.18934286183326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73525960857098`", ",", "2.12290891521393`", ",", 
          "3.60212393934104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.390879827183905`", ",", "1.90455608213332`", ",", 
          "5.01490501684883`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32968535297642`", ",", "1.70187954101974`", ",", 
          "0.144500787177029`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26849087876892`", ",", "1.50456658242271`", ",", 
          "1.55728186468481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20729640456143`", ",", "1.30459257076383`", ",", 
          "2.9700629421926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86291662317436`", ",", "1.09284584896098`", ",", 
          "4.38284401970039`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80172214896687`", ",", "0.854163115770423`", ",", 
          "5.79562509720817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74052767475938`", ",", "0.547671579669497`", ",", 
          "0.925220867536372`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3961478933723`", ",", "2.82202482879698`", ",", 
          "2.33800194504416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33495341916481`", ",", "2.42261855966606`", ",", 
          "3.75078302255194`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27375894495732`", ",", "2.15987151693014`", ",", 
          "5.16356410005973`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.929379163570243`", ",", "1.93767421686687`", ",", 
          "0.293159870387929`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86818468936275`", ",", "1.73332428948879`", ",", 
          "1.70594094789572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80699021515526`", ",", "1.53571302172117`", ",", 
          "3.1187220254035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.462610433768186`", ",", "1.33669842679209`", ",", 
          "4.53150310291129`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4014159595607`", ",", "1.12757133369497`", ",", 
          "5.94428418041907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34022148535321`", ",", "0.89471065469289`", ",", 
          "1.07387995074727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27902701114572`", ",", "0.604768019506024`", ",", 
          "2.48666102825506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93464722975864`", ",", "2.94366663199243`", ",", 
          "3.89944210576284`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87345275555115`", ",", "2.47121489707406`", ",", 
          "5.31222318327063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81225828134366`", ",", "2.19777104074177`", ",", 
          "0.441818953598829`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46787849995658`", ",", "1.97121949822`", ",", 
          "1.85460003110662`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40668402574909`", ",", "1.76493208158582`", ",", 
          "3.2673811086144`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3454895515416`", ",", "1.56682543614764`", ",", 
          "4.68016218612219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00110977015452`", ",", "1.36856022860875`", ",", 
          "6.09294326362997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93991529594703`", ",", "1.16173330103912`", ",", 
          "1.22253903395817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87872082173954`", ",", "0.933979373965789`", ",", 
          "2.63532011146596`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.534341040352467`", ",", "0.657489796745479`", ",", 
          "4.04810118897374`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47314656614498`", ",", "0.152342767131442`", ",", 
          "5.46088226648153`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41195209193749`", ",", "2.52299463457612`", ",", 
          "0.590478036809729`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0675723105504092`", ",", "2.23674169071364`", ",", 
          "2.00325911431752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00637783634292`", ",", "2.00524824865141`", ",", 
          "3.4160401918253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94518336213543`", ",", "1.7967376149265`", ",", 
          "4.82882126933309`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88398888792794`", ",", "1.59793400572638`", ",", 
          "6.24160234684087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53960910654086`", ",", "1.4002151402637`", ",", 
          "1.37119811716907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47841463233337`", ",", "1.19539643062775`", ",", 
          "2.78397919467686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41722015812588`", ",", "0.972138667547801`", ",", 
          "4.19676027218464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0728403767388`", ",", "0.706831254459593`", ",", 
          "5.60954134969243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01164590253131`", ",", "0.293237663328114`", ",", 
          "0.73913712002063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95045142832382`", ",", "2.57885453338734`", ",", 
          "2.15191819752842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.606071646936747`", ",", "2.27694468896059`", ",", 
          "3.5646992750362`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54487717272926`", ",", "2.0398232770006`", ",", 
          "4.97748035254399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48368269852177`", ",", "1.82877749819853`", ",", 
          "0.107076122872187`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.13930291713469`", ",", "1.62906887688895`", ",", 
          "1.51985720037997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0781084429272`", ",", "1.43169830906602`", ",", 
          "2.93263827788776`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01691396871971`", ",", "1.22861858295036`", ",", 
          "4.34541935539555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95571949451222`", ",", "1.00932896539039`", ",", 
          "5.75820043290333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61133971312514`", ",", "0.753471242083172`", ",", 
          "0.88779620323153`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55014523891765`", ",", "0.386569611261937`", ",", 
          "2.30057728073932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48895076471016`", ",", "2.64017644072175`", ",", 
          "3.7133583582471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14457098332308`", ",", "2.31857701404557`", ",", 
          "5.12613943575489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08337650911559`", ",", "2.07501530112291`", ",", 
          "0.255735206083087`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0221820349081`", ",", "1.86109068737215`", ",", 
          "1.66851628359087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.677802253521028`", ",", "1.66026042631013`", ",", 
          "3.08129736109866`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61660777931354`", ",", "1.46304326023528`", ",", 
          "4.49407843860644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55541330510605`", ",", "1.26145200182754`", ",", 
          "5.90685951611423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.21103352371897`", ",", "1.04566848315813`", ",", 
          "1.03645528644243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14983904951148`", ",", "0.797897926901959`", ",", 
          "2.44923636395022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08864457530399`", ",", "0.462135102636236`", ",", 
          "3.862017441458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0274501010965`", ",", "2.70930076492837`", ",", 
          "5.27479851896579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68307031970942`", ",", "2.36188408366365`", ",", 
          "0.404394289293987`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62187584550193`", ",", "2.11090475381311`", ",", 
          "1.81717536680177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56068137129444`", ",", "1.89371899175975`", ",", 
          "3.22995644430956`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21630158990737`", ",", "1.69153953037375`", ",", 
          "4.64273752181735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15510711569987`", ",", "1.494282247175`", ",", 
          "6.05551859932513`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09391264149239`", ",", "1.29394428569916`", ",", 
          "1.18511436965333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.749532860105308`", ",", "1.08125810218125`", ",", 
          "2.59789544716112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68833838589782`", ",", "0.840476569875481`", ",", 
          "4.0106765246689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62714391169033`", ",", "0.527640740029644`", ",", 
          "5.42345760217669`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.282764130303251`", ",", "2.79083652669822`", ",", 
          "0.553053372504888`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22156965609576`", ",", "2.40717880704209`", ",", 
          "1.96583445001267`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16037518188827`", ",", "2.14758411126012`", ",", 
          "3.37861552752046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09918070768078`", ",", "1.92670767005847`", ",", 
          "4.79139660502825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7548009262937`", ",", "1.72293784698906`", ",", 
          "6.20417768253603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69360645208621`", ",", "1.52544656825199`", ",", 
          "1.33377345286423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63241197787872`", ",", "1.3261391830191`", ",", 
          "2.74655453037202`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28803219649165`", ",", "1.1161849783419`", ",", 
          "4.1593356078798`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22683772228416`", ",", "0.881489208449899`", ",", 
          "5.57211668538759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16564324807667`", ",", "0.586483240851215`", ",", 
          "0.701712455715788`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.821263466689589`", ",", "2.89692712314101`", ",", 
          "2.11449353322357`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7600689924821`", ",", "2.45487141813478`", ",", 
          "3.52727461073136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69887451827461`", ",", "2.18516094646503`", ",", 
          "4.94005568823915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.354494736887531`", ",", "1.96010614249461`", ",", 
          "0.0696514585673449`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29330026268004`", ",", "1.75448811708352`", ",", 
          "1.48243253607513`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23210578847255`", ",", "1.55656685918245`", ",", 
          "2.89521361358292`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17091131426506`", ",", "1.35807725258845`", ",", 
          "4.3079946910907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82653153287798`", ",", "1.15052526482823`", ",", 
          "5.72077576859849`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76533705867049`", ",", "0.921159287266305`", ",", 
          "0.850371538926688`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.704142584463`", ",", "0.640517007636882`", ",", 
          "2.26315261643447`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35976280307593`", ",", "0.0514571440778868`", ",", 
          "3.67593369394226`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29856832886844`", ",", "2.50551863665445`", ",", 
          "5.08871477145005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23737385466095`", ",", "2.22376200894877`", ",", 
          "0.218310541778245`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.892994073273869`", ",", "1.99396885352747`", ",", 
          "1.63109161928603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83179959906638`", ",", "1.78622449408551`", ",", 
          "3.04387269679382`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77060512485889`", ",", "1.58767336887767`", ",", 
          "4.4566537743016`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.426225343471812`", ",", "1.38979641948149`", ",", 
          "5.86943485180939`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36503086926432`", ",", "1.18434620346214`", ",", 
          "0.999030622137588`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30383639505683`", ",", "0.959667676994363`", ",", 
          "2.41181169964537`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24264192084934`", ",", "0.690886114003362`", ",", 
          "3.82459277715316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89826213946226`", ",", "0.255365066195413`", ",", 
          "5.23737385466095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83706766525477`", ",", "2.55991008397307`", ",", 
          "0.366969624989145`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77587319104728`", ",", "2.26353879138916`", ",", 
          "1.77975070249693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43149340966021`", ",", "2.02835633132445`", ",", 
          "3.19253178000472`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37029893545272`", ",", "1.81818291116483`", ",", 
          "4.6053128575125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30910446124523`", ",", "1.61879622578098`", ",", 
          "6.01809393502029`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.96472467985815`", ",", "1.42133244996102`", ",", 
          "1.14768970534849`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90353020565066`", ",", "1.2177077574536`", ",", 
          "2.56047078285627`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84233573144317`", ",", "0.997163499139086`", ",", 
          "3.97325186036406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.497955950056092`", ",", "0.738355480249851`", ",", 
          "5.38603293787185`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4367614758486`", ",", "0.35838103487606`", ",", 
          "0.515628708200046`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37556700164111`", ",", "2.61923361421631`", ",", 
          "1.92840978570783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.031187220254035`", ",", "2.30467530909949`", ",", 
          "3.34119086321562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96999274604654`", ",", "2.0633365070263`", ",", 
          "4.7539719407234`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90879827183905`", ",", "1.85040149804765`", ",", 
          "6.16675301823119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84760379763156`", ",", "1.64996570126553`", ",", 
          "1.29634878855939`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50322401624449`", ",", "1.45271936354996`", ",", 
          "2.70912986606717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.442029542037`", ",", "1.25066390556043`", ",", 
          "4.12191094357496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38083506782951`", ",", "1.03377167935088`", ",", 
          "5.53469202108275`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03645528644243`", ",", "0.783466701610185`", ",", 
          "0.664287791410946`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97526081223494`", ",", "0.438567982072004`", ",", 
          "2.07706886891873`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91406633802745`", ",", "2.68543080772521`", ",", 
          "3.48984994642652`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.569686556640373`", ",", "2.34739927717143`", ",", 
          "4.9026310239343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50849208243288`", ",", "2.09898638125756`", ",", 
          "0.0322267942625028`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44729760822539`", ",", "1.88292106205647`", ",", 
          "1.44500787177029`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.102917826838316`", ",", "1.68121247652048`", ",", 
          "2.85778894927807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04172335263083`", ",", "1.48398979663187`", ",", 
          "4.27057002678586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98052887842333`", ",", "1.28326368264268`", ",", 
          "5.68335110429365`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91933440421584`", ",", "1.06959836396649`", ",", 
          "0.812946874621846`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57495462282877`", ",", "0.826620170655398`", ",", 
          "2.22572795212963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51376014862128`", ",", "0.506896294693147`", ",", 
          "3.63850902963742`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45256567441379`", ",", "2.76210637516012`", ",", 
          "5.0512901071452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10818589302671`", ",", "2.39199870027177`", ",", 
          "0.180885877473403`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04699141881922`", ",", "2.135394161546`", ",", 
          "1.59366695498119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98579694461173`", ",", "1.91578565192442`", ",", 
          "3.00644803248897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.641417163224653`", ",", "1.71256791952158`", ",", 
          "4.41922910999676`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58022268901716`", ",", "1.51517532919537`", ",", 
          "5.83201018750455`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51902821480967`", ",", "1.31555202794773`", ",", 
          "0.961605957832746`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.174648433422596`", ",", "1.1047348972292`", ",", 
          "2.37438703534053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11345395921511`", ",", "0.868122084598941`", ",", 
          "3.78716811284832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05225948500762`", ",", "0.567680786781133`", ",", 
          "5.1999491903561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99106501080013`", ",", "2.85765676169171`", ",", 
          "0.329544960684303`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64668522941305`", ",", "2.43884747353407`", ",", 
          "1.74232603819209`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58549075520556`", ",", "2.17266204913962`", ",", 
          "3.15510711569987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52429628099807`", ",", "1.94904322830906`", ",", 
          "4.56788819320766`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17991649961099`", ",", "1.74406437917319`", ",", 
          "5.98066927071545`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1187220254035`", ",", "1.54630678434539`", ",", 
          "1.11026504104365`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05752755119601`", ",", "1.34757048616907`", ",", 
          "2.52304611855143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.713147769808934`", ",", "1.13926080298686`", ",", 
          "3.93582719605922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65195329560144`", ",", "0.908213108853918`", ",", 
          "5.348608273567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59075882139395`", ",", "0.623148556831359`", ",", 
          "0.478204043895203`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.246379040006877`", ",", "3.00781809380917`", ",", 
          "1.89098512140299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18518456579939`", ",", "2.48844681262218`", ",", 
          "3.30376619891078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1239900915919`", ",", "2.2109099387667`", ",", 
          "4.71654727641856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06279561738441`", ",", "1.98274647239712`", ",", 
          "6.12932835392635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71841583599733`", ",", "1.77573550456269`", ",", 
          "1.25892412425455`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65722136178984`", ",", "1.57741450879419`", ",", 
          "2.67170520176233`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59602688758235`", ",", "1.37935779491169`", ",", 
          "4.08448627927012`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25164710619527`", ",", "1.17324606187552`", ",", 
          "5.4972673567779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19045263198778`", ",", "0.947086753249149`", ",", 
          "0.626863127106104`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12925815778029`", ",", "0.674627333863543`", ",", 
          "2.03964420461389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.784878376393214`", ",", "0.21096520733989`", ",", 
          "3.45242528212168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72368390218572`", ",", "2.54149641498115`", ",", 
          "4.86520635962946`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66248942797823`", ",", "2.25028043055`", ",", 
          "6.27798743713725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.318109646591157`", ",", "2.01695377447215`", ",", 
          "1.40758320746545`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25691517238367`", ",", "1.80761659855738`", ",", 
          "2.82036428497323`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19572069817618`", ",", "1.60852864159234`", ",", 
          "4.23314536248102`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13452622396869`", ",", "1.41095038409384`", ",", 
          "5.6459264399888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79014644258161`", ",", "1.20675287990292`", ",", 
          "0.775522210317004`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72895196837412`", ",", "0.984901643512077`", ",", 
          "2.18830328782479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66775749416663`", ",", "0.722984354292768`", ",", 
          "3.60108436533258`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32337771277955`", ",", "0.327889826263686`", ",", 
          "5.01386544284036`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26218323857206`", ",", "2.59902648485907`", ",", 
          "0.143461213168561`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20098876436457`", ",", "2.29094577661709`", ",", 
          "1.55624229067635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.856608982977495`", ",", "2.05173045922922`", ",", 
          "2.96902336818413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79541450877`", ",", "1.83974501680875`", ",", 
          "4.38180444569192`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73422003456251`", ",", "1.63967937778484`", ",", 
          "5.7945855231997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.389840253175438`", ",", "1.4423828069938`", ",", 
          "0.924181293527904`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32864577896795`", ",", "1.23983708344645`", ",", 
          "2.33696237103569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26745130476046`", ",", "1.02178999892607`", ",", 
          "3.74974344854348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20625683055297`", ",", "0.768823294832741`", ",", 
          "5.16252452605126`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86187704916589`", ",", "0.41375198320819`", ",", 
          "0.292120296379461`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8006825749584`", ",", "2.66266961648929`", ",", 
          "1.70490137388725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73948810075091`", ",", "2.3331177662201`", ",", 
          "3.11768245139503`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39510831936383`", ",", "2.08715032617614`", ",", 
          "4.53046352890282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33391384515634`", ",", "1.87216062577852`", ",", 
          "5.9432446064106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27271937094885`", ",", "1.67089723343252`", ",", 
          "1.0728403767388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.928339589561776`", ",", "1.47368811843465`", ",", 
          "2.48562145424659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86714511535429`", ",", "1.27254923568663`", ",", 
          "3.89840253175438`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80595064114679`", ",", "1.05786365991025`", ",", 
          "5.31118360926216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.461570859759718`", ",", "0.812584668066442`", ",", 
          "0.440779379590362`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40037638555223`", ",", "0.485346044779852`", ",", 
          "1.85356045709815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33918191134474`", ",", "2.73531178135486`", ",", 
          "3.26634153460593`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27798743713725`", ",", "2.37706223225631`", ",", 
          "4.67912261211372`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93360765575017`", ",", "2.12329761519433`", ",", 
          "6.09190368962151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87241318154268`", ",", "1.90490633691016`", ",", 
          "1.2214994599497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81121870733519`", ",", "1.70221331850473`", ",", 
          "2.63428053745749`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46683892594811`", ",", "1.50489821253569`", ",", 
          "4.04706161496528`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40564445174062`", ",", "1.30493554264293`", ",", 
          "5.45984269247306`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34444997753313`", ",", "1.09321848106421`", ",", 
          "0.589438462801262`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00007019614606`", ",", "0.854601887712783`", ",", 
          "2.00221954030905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93887572193857`", ",", "0.548306751542826`", ",", 
          "3.41500061781683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87768124773108`", ",", "2.82307982940772`", ",", 
          "4.82778169532462`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.533301466343999`", ",", "2.42312113357174`", ",", 
          "6.24056277283241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47210699213651`", ",", "2.16026955502537`", ",", 
          "1.3701585431606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41091251792902`", ",", "1.93802873890234`", ",", 
          "2.78293962066839`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0665327365419414`", ",", "1.73365962453071`", ",", 
          "4.19572069817618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00533826233445`", ",", "1.53604413023841`", ",", 
          "5.60850177568396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94414378812696`", ",", "1.33703859858987`", ",", 
          "0.738097546012162`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88294931391947`", ",", "1.12793760301282`", ",", 
          "2.15087862351995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53856953253239`", ",", "0.895134806624066`", ",", 
          "3.56365970102773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4773750583249`", ",", "0.605349771564235`", ",", 
          "4.97644077853552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41618058411741`", ",", "2.94535658951925`", ",", 
          "0.106036548863719`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07180080273034`", ",", "2.47174769522447`", ",", 
          "1.51881762637151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01060632852285`", ",", "2.19817972582526`", ",", 
          "2.93159870387929`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94941185431536`", ",", "1.97157885673349`", ",", 
          "4.34437978138708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.605032072928279`", ",", "1.76526933462527`", ",", 
          "5.75716085889486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54383759872079`", ",", "1.56715634522947`", ",", 
          "0.886756629223062`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4826431245133`", ",", "1.36889800782036`", ",", 
          "2.29953770673085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.138263343126222`", ",", "1.16209393648722`", ",", 
          "3.71231878423863`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07706886891873`", ",", "0.934390890622553`", ",", 
          "5.12509986174642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01587439471124`", ",", "0.658031072302902`", ",", 
          "0.254695632074619`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95467992050375`", ",", "0.154508044409518`", ",", 
          "1.66747670958241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61030013911667`", ",", "2.52356549702342`", ",", 
          "3.08025778709019`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54910566490918`", ",", "2.2371625828534`", ",", 
          "4.49303886459798`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48791119070169`", ",", "2.00561307544564`", ",", 
          "5.90581994210576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14353140931462`", ",", "1.79707716463975`", ",", 
          "1.03541571243396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08233693510713`", ",", "1.59826503579011`", ",", 
          "2.44819678994175`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02114246089964`", ",", "1.4005509106646`", ",", 
          "3.86097786744953`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.67676267951256`", ",", "1.19575208125811`", ",", 
          "5.27375894495732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61556820530507`", ",", "0.972539181254098`", ",", 
          "0.40335471528552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55437373109758`", ",", "0.707340638603896`", ",", 
          "1.81613579279331`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.209993949710502`", ",", "0.294380296677934`", ",", 
          "3.22891687030109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14879947550301`", ",", "2.57947509012917`", ",", 
          "4.64169794780888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08760500129552`", ",", "2.27737967712778`", ",", 
          "6.05447902531666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02641052708803`", ",", "2.04019427994858`", ",", 
          "1.18407479564486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68203074570095`", ",", "1.82911974582878`", ",", 
          "2.59685587315265`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62083627149346`", ",", "1.62940034940857`", ",", 
          "4.00963695066043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55964179728597`", ",", "1.43203243518795`", ",", 
          "5.42241802816822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2152620158989`", ",", "1.2289698322033`", ",", 
          "0.55201379849642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15406754169141`", ",", "1.00971984062539`", ",", 
          "1.96479487600421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09287306748392`", ",", "0.753954775786504`", ",", 
          "3.37757595351199`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.74849328609684`", ",", "0.387446372527002`", ",", 
          "4.79035703101978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68729881188935`", ",", "2.64086530463293`", ",", 
          "6.20313810852756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62610433768186`", ",", "2.31902842710384`", ",", 
          "1.33273387885576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.281724556294783`", ",", "2.07539328115848`", ",", 
          "2.74551495636355`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22053008208729`", ",", "1.86143606171412`", ",", 
          "4.15829603387133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1593356078798`", ",", "1.66059266664181`", ",", 
          "5.57107711137912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09814113367231`", ",", "1.46337609130493`", ",", 
          "0.70067288170732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75376135228524`", ",", "1.26179937896748`", ",", 
          "2.11345395921511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69256687807774`", ",", "1.04605087699787`", ",", 
          "3.52623503672289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63137240387025`", ",", "0.79836005397492`", ",", 
          "4.93901611423068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28699262248318`", ",", "0.462876726392009`", ",", 
          "0.068611884558877`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22579814827569`", ",", "2.71009128432244`", ",", 
          "1.48139296206666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1646036740682`", ",", "2.36235485393956`", ",", 
          "2.89417403957445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.820223892681121`", ",", "2.1112906266583`", ",", 
          "4.30695511708224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75902941847363`", ",", "1.89406795498672`", ",", 
          "5.71973619459002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69783494426614`", ",", "1.69187287067651`", ",", 
          "0.84933196491822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.353455162879063`", ",", "1.49461412064276`", ",", 
          "2.26211304242601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29226068867157`", ",", "1.29428827511862`", ",", 
          "3.67489411993379`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23106621446408`", ",", "1.08163300854731`", ",", 
          "5.08767519744158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16987174025659`", ",", "0.840920674804117`", ",", 
          "0.217270967769777`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82549195886952`", ",", "0.528297587537811`", ",", 
          "1.63005204527756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76429748466203`", ",", "2.79180083304596`", ",", 
          "3.04283312278535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70310301045453`", ",", "2.40767272054994`", ",", 
          "4.45561420029314`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35872322906746`", ",", "2.14797893566217`", ",", 
          "5.86839527780092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29752875485997`", ",", "1.92706072463452`", ",", 
          "0.99799104812912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23633428065248`", ",", "1.72327262931491`", ",", 
          "2.41077212563691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.891954499265401`", ",", "1.52577781301596`", ",", 
          "3.82355320314469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83076002505791`", ",", "1.3264802319122`", ",", 
          "5.23633428065248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76956555085042`", ",", "1.11655326108557`", ",", 
          "0.365930050980677`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.425185769463344`", ",", "0.881917942244134`", ",", 
          "1.77871112848846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36399129525585`", ",", "0.587080885988637`", ",", 
          "3.19149220599625`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30279682104836`", ",", "2.89829695578106`", ",", 
          "4.60427328350403`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24160234684087`", ",", "2.45539351509315`", ",", 
          "6.01705436101182`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8972225654538`", ",", "2.1855659615478`", ",", 
          "1.14665013134002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83602809124631`", ",", "1.9604638394899`", ",", 
          "2.55943120884781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77483361703882`", ",", "1.75482469671944`", ",", 
          "3.97221228635559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43045383565174`", ",", "1.55689779859699`", ",", 
          "5.38499336386338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36925936144425`", ",", "1.35841577736744`", ",", 
          "0.514589134191578`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30806488723676`", ",", "1.15088768293593`", ",", 
          "1.92737021169936`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.963685105849682`", ",", "0.921574775232354`", ",", 
          "3.34015128920715`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90249063164219`", ",", "0.641070518872111`", ",", 
          "4.75293236671494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8412961574347`", ",", "0.057532423376554`", ",", 
          "6.16571344422272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.496916376047624`", ",", "2.5060758896694`", ",", 
          "1.29530921455092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43572190184013`", ",", "2.22417868460298`", ",", 
          "2.70809029205871`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37452742763264`", ",", "1.99433180275897`", ",", 
          "4.12087136956649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0301476462455672`", ",", "1.78656324324265`", ",", 
          "5.53365244707428`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96895317203808`", ",", "1.58800432362481`", ",", 
          "0.663248217402478`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90775869783059`", ",", "1.39013281121914`", ",", 
          "2.07602929491026`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8465642236231`", ",", "1.18470343058686`", ",", 
          "3.48881037241805`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50218444223602`", ",", "0.960071656843668`", ",", 
          "4.90159144992584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44098996802853`", ",", "0.691405248165924`", ",", 
          "0.031187220254035`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37979549382104`", ",", "0.256671805868975`", ",", 
          "1.44396829776182`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03541571243396`", ",", "2.56051263214105`", ",", 
          "2.85674937526961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97422123822647`", ",", "2.26396889778245`", ",", 
          "4.26953045277739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91302676401898`", ",", "2.0287252138933`", ",", 
          "5.68231153028518`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.568646982631905`", ",", "1.81852422312867`", ",", 
          "0.811907300613378`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50745250842441`", ",", "1.61912751667665`", ",", 
          "2.22468837812116`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44625803421692`", ",", "1.42166707907665`", ",", 
          "3.63746945562895`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.101878252829848`", ",", "1.2180603972879`", ",", 
          "5.05025053313674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04068377862236`", ",", "0.99755741601963`", ",", 
          "0.179846303464935`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97948930441487`", ",", "0.738846983511952`", ",", 
          "1.59262738097272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91829483020738`", ",", "0.359323252855065`", ",", 
          "3.00540845848051`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5739150488203`", ",", "2.61989723478997`", ",", 
          "4.41818953598829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51272057461281`", ",", "2.30512101503883`", ",", 
          "5.83097061349608`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45152610040532`", ",", "2.06371209103711`", ",", 
          "0.960566383824278`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10714631901824`", ",", "1.85074579192846`", ",", 
          "2.37334746133206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04595184481075`", ",", "1.65029765206895`", ",", 
          "3.78612853883985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98475737060326`", ",", "1.45305258390995`", ",", 
          "5.19890961634764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.640377589216186`", ",", "1.25101250411432`", ",", 
          "0.328505386675835`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5791831150087`", ",", "1.03415675317851`", ",", 
          "1.74128646418362`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51798864080121`", ",", "0.783935470547101`", ",", 
          "3.15406754169141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.173608859414128`", ",", "0.439346593679375`", ",", 
          "4.56684861919919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11241438520664`", ",", "2.68618258105019`", ",", 
          "5.97962969670698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05121991099915`", ",", "2.34786329349092`", ",", 
          "1.10922546703518`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99002543679166`", ",", "2.09936954181876`", ",", 
          "2.52200654454296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64564565540458`", ",", "1.88326878831464`", ",", 
          "3.93478762205075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58445118119709`", ",", "1.68154541681555`", ",", 
          "5.34756869955854`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5232567069896`", ",", "1.48432194920102`", ",", 
          "0.477164469886736`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17887692560252`", ",", "1.28360873818763`", ",", 
          "1.88994554739452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11768245139503`", ",", "1.06997563834615`", ",", 
          "3.30272662490231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05648797718754`", ",", "0.82706989526212`", ",", 
          "4.71550770241009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.712108195800466`", ",", "0.507577503583108`", ",", 
          "6.12828877991788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65091372159298`", ",", "2.7630006499472`", ",", 
          "1.25788455024608`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58971924738549`", ",", "2.39248449633432`", ",", 
          "2.67066562775386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.245339465998409`", ",", "2.13578590662062`", ",", 
          "4.08344670526165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18414499179092`", ",", "1.91613729889391`", ",", 
          "5.49622778276944`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12295051758343`", ",", "1.71290218774255`", ",", 
          "0.625823553097636`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06175604337594`", ",", "1.51550674535086`", ",", 
          "2.03860463060542`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71737626198886`", ",", "1.31589399918126`", ",", 
          "3.45138570811321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65618178778137`", ",", "1.10510527578957`", ",", 
          "4.86416678562099`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59498731357388`", ",", "0.868555630314419`", ",", 
          "6.27694786312878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2506075321868`", ",", "0.568295926606151`", ",", 
          "1.40654363345698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18941305797931`", ",", "2.85884039779225`", ",", 
          "2.81932471096476`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12821858377182`", ",", "2.43935961827864`", ",", 
          "4.23210578847255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.783838802384746`", ",", "2.17306355353472`", ",", 
          "5.64488686598034`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72264432817726`", ",", "1.94939933000914`", ",", 
          "0.774482636308536`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66144985396977`", ",", "1.74440032585374`", ",", 
          "2.18726371381632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.317070072582689`", ",", "1.5466377889473`", ",", 
          "3.60004479132411`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2558755983752`", ",", "1.34790979901069`", ",", 
          "5.01282586883189`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19468112416771`", ",", "1.13962507689731`", ",", 
          "0.142421639160093`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13348664996022`", ",", "0.9086327563698`", ",", 
          "1.55520271666788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78910686857314`", ",", "0.623715347789404`", ",", 
          "2.96798379417566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72791239436565`", ",", "3.01032240495147`", ",", 
          "4.38076487168345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66671792015816`", ",", "2.48899154060552`", ",", 
          "5.79354594919124`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32233813877108`", ",", "2.21132258967971`", ",", 
          "0.923141719519436`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26114366456359`", ",", "1.98310761801634`", ",", 
          "2.33592279702722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1999491903561`", ",", "1.7760734958991`", ",", 
          "3.74870387453501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.855569408969027`", ",", "1.57774542309395`", ",", 
          "5.16148495204279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79437493476154`", ",", "1.37969484823976`", ",", 
          "0.291080722370993`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73318046055405`", ",", "1.17360493105358`", ",", 
          "1.70386179987878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.38880067916697`", ",", "0.947494355880665`", ",", 
          "3.11664287738657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32760620495948`", ",", "0.675156942934871`", ",", 
          "4.52942395489435`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26641173075199`", ",", "0.212539652754351`", ",", 
          "5.94220503240214`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2052172565445`", ",", "2.54208263008367`", ",", 
          "1.07180080273034`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86083747515742`", ",", "2.25070588991751`", ",", 
          "2.48458188023812`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79964300094993`", ",", "2.0173206200407`", ",", 
          "3.89736295774591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73844852674244`", ",", "1.80795702039268`", ",", 
          "5.31014403525369`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39406874535536`", ",", "1.6088597860528`", ",", 
          "0.439739805581894`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33287427114787`", ",", "1.41128555466017`", ",", 
          "1.85252088308968`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27167979694038`", ",", "1.20710696962266`", ",", 
          "3.26530196059747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.927300015553308`", ",", "0.985298734326458`", ",", 
          "4.67808303810525`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86610554134582`", ",", "0.723484354708651`", ",", 
          "6.09086411561304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80491106713833`", ",", "0.328915792998959`", ",", 
          "1.22045988594124`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.46053128575125`", ",", "2.59966770142615`", ",", 
          "2.63324096344902`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39933681154376`", ",", "2.29138606856815`", ",", 
          "4.04602204095681`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33814233733627`", ",", "2.05210374218525`", ",", 
          "5.45880311846459`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27694786312878`", ",", "1.8400882791679`", ",", 
          "0.588398888792794`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9325680817417`", ",", "1.64001107488106`", ",", 
          "2.00117996630058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87137360753421`", ",", "1.44271645370066`", ",", 
          "3.41396104380837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81017913332672`", ",", "1.24018695754057`", ",", 
          "4.82674212131615`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46579935193965`", ",", "1.022177865954`", ",", 
          "6.23952319882394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40460487773216`", ",", "0.769299103983646`", ",", 
          "1.36911896915214`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34341040352467`", ",", "0.414574267002374`", ",", 
          "2.78190004665992`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.999030622137588`", ",", "2.66338819037807`", ",", 
          "4.19468112416771`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9378361479301`", ",", "2.33357540325129`", ",", 
          "5.60746220167549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87664167372261`", ",", "2.08753088380794`", ",", 
          "0.737057972003694`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.532261892335531`", ",", "1.8725071681162`", ",", 
          "2.14983904951148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47106741812804`", ",", "1.67122981050174`", ",", 
          "3.56262012701927`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40987294392055`", ",", "1.47402058612093`", ",", 
          "4.97540120452705`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0654931625334735`", ",", "1.27289540719026`", ",", 
          "0.104996974855251`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00429868832598`", ",", "1.05824340036212`", ",", 
          "1.51777805236304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94310421411849`", ",", "0.813040322116328`", ",", 
          "2.93055912987082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.881909739911`", ",", "0.486054885598202`", ",", 
          "4.34334020737861`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53752995852393`", ",", "2.73614992149481`", ",", 
          "5.7561212848864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47633548431644`", ",", "2.37754040341675`", ",", 
          "0.885717055214594`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41514101010895`", ",", "2.12368640835049`", ",", 
          "2.29849813272238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07076122872187`", ",", "1.90525663427675`", ",", 
          "3.71127921023017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00956675451438`", ",", "1.70254711071607`", ",", 
          "5.12406028773795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94837228030689`", ",", "1.50522983539095`", ",", 
          "0.253656058066151`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.603992498919811`", ",", "1.30527848249363`", ",", 
          "1.66643713557394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54279802471232`", ",", "1.09359104131899`", ",", 
          "3.07921821308172`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48160355050483`", ",", "0.855040492157186`", ",", 
          "4.49199929058951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.137223769117754`", ",", "0.548941263561763`", ",", 
          "5.90478036809729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07602929491026`", ",", "2.82413821634119`", ",", 
          "1.03437613842549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01483482070277`", ",", "2.42362399651599`", ",", 
          "2.44715721593328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95364034649528`", ",", "2.1606676991086`", ",", 
          "3.85993829344107`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60926056510821`", ",", "1.93838330929357`", ",", 
          "5.27271937094885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54806609090072`", ",", "1.73399497805122`", ",", 
          "0.402315141277052`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48687161669323`", ",", "1.53637523494417`", ",", 
          "1.81509621878484`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14249183530615`", ",", "1.33737874283648`", ",", 
          "3.22787729629262`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08129736109866`", ",", "1.12830380871585`", ",", 
          "4.64065837380041`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02010288689117`", ",", "0.895558814408528`", ",", 
          "6.0534394513082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.675723105504092`", ",", "0.605931034978139`", ",", 
          "1.18303522163639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6145286312966`", ",", "2.94706103715495`", ",", 
          "2.59581629914418`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55333415708911`", ",", "2.47228085204206`", ",", 
          "4.00859737665197`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.208954375702035`", ",", "2.19858853205586`", ",", 
          "5.42137845415975`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14775990149454`", ",", "1.97193826997338`", ",", 
          "0.550974224487952`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08656542728705`", ",", "1.76560661006862`", ",", 
          "1.96375530199574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02537095307956`", ",", "1.56748725391271`", ",", 
          "3.37653637950352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68099117169249`", ",", "1.36923576367985`", ",", 
          "4.78931745701131`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.619796697485`", ",", "1.16245451561741`", ",", 
          "6.2020985345191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55860222327751`", ",", "0.934802282175506`", ",", 
          "1.3316943048473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21422244189043`", ",", "0.658571969087461`", ",", 
          "2.74447538235508`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15302796768294`", ",", "0.15664362922823`", ",", 
          "4.15725645986287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09183349347545`", ",", "2.52413681822719`", ",", 
          "5.57003753737065`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.747453712088372`", ",", "2.23758361434252`", ",", 
          "0.699633307698852`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68625923788088`", ",", "2.00597796406983`", ",", 
          "2.11241438520664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62506476367339`", ",", "1.7974167408985`", ",", 
          "3.52519546271442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.280684982286315`", ",", "1.59859606886466`", ",", 
          "4.93797654022221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21949050807882`", ",", "1.40088666168524`", ",", 
          "0.0675723105504092`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15829603387133`", ",", "1.19610768210019`", ",", 
          "1.4803533880582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09710155966384`", ",", "0.972939585656934`", ",", 
          "2.89313446556598`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75272177827677`", ",", "0.707849719422451`", ",", 
          "4.30591554307377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69152730406928`", ",", "0.295518639908297`", ",", 
          "5.71869662058155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63033282986179`", ",", "2.58009625882306`", ",", 
          "0.848292390909752`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28595304847471`", ",", "2.27781482686965`", ",", 
          "2.26107346841754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22475857426722`", ",", "2.04056535272353`", ",", 
          "3.67385454592532`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16356410005973`", ",", "1.82946202441166`", ",", 
          "5.08663562343311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.819184318672653`", ",", "1.62973182837476`", ",", 
          "0.216231393761309`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75798984446516`", ",", "1.43236654571876`", ",", 
          "1.6290124712691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69679537025767`", ",", "1.22932103756535`", ",", 
          "3.04179354877688`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.352415588870596`", ",", "1.01011061986719`", ",", 
          "4.45457462628467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29122111466311`", ",", "0.754438060627359`", ",", 
          "5.86735570379245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23002664045561`", ",", "0.38832125406863`", ",", 
          "0.996951474120652`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16883216624813`", ",", "2.64155503676594`", ",", 
          "2.40973255162844`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82445238486105`", ",", "2.31948002940454`", ",", 
          "3.82251362913622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76325791065356`", ",", "2.07577134011509`", ",", 
          "5.23529470664401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70206343644607`", ",", "1.8617814717386`", ",", 
          "0.36489047697221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35768365505899`", ",", "1.66092491691255`", ",", 
          "1.77767155448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2964891808515`", ",", "1.46370891042938`", ",", 
          "3.19045263198778`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23529470664401`", ",", "1.2621467175909`", ",", 
          "4.60323370949557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.890914925256933`", ",", "1.04643318620956`", ",", 
          "6.01601478700335`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82972045104944`", ",", "0.798821973045851`", ",", 
          "1.14561055733155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76852597684195`", ",", "0.46361724964697`", ",", 
          "2.55839163483934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.424146195454876`", ",", "2.71088316328025`", ",", 
          "3.97117271234712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36295172124739`", ",", "2.3628258486947`", ",", 
          "5.38395378985491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3017572470399`", ",", "2.11167658887806`", ",", 
          "0.51354956018311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24056277283241`", ",", "1.89441695901615`", ",", 
          "1.9263306376909`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89618299144533`", ",", "1.69220622449945`", ",", 
          "3.33911171519868`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83498851723784`", ",", "1.49494598570375`", ",", 
          "4.75189279270647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77379404303035`", ",", "1.29463223096234`", ",", 
          "6.16467387021425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42941426164327`", ",", "1.08200784010902`", ",", 
          "1.29426964054245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36821978743578`", ",", "0.841364603343114`", ",", 
          "2.70705071805024`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30702531322829`", ",", "0.528953696629224`", ",", 
          "4.11983179555803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.962645531841214`", ",", "2.79276769524324`", ",", 
          "5.53261287306581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90145105763372`", ",", "2.40816690466067`", ",", 
          "0.66220864339401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84025658342623`", ",", "2.14837386159557`", ",", 
          "2.0749897209018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.495876802039157`", ",", "1.92741382560349`", ",", 
          "3.48777079840958`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43468232783167`", ",", "1.72360742886475`", ",", 
          "4.90055187591737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37348785362418`", ",", "1.52610905283711`", ",", 
          "0.0301476462455672`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0291080722370993`", ",", "1.32682125181105`", ",", 
          "1.44292872375335`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96791359802961`", ",", "1.11692147761209`", ",", 
          "2.85570980126114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90671912382212`", ",", "0.88234652473082`", ",", 
          "4.26849087876892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84552464961463`", ",", "0.587677994766546`", ",", 
          "5.68127195627671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50114486822755`", ",", "2.89967439031222`", ",", 
          "0.81086772660491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43995039402006`", ",", "2.45591594510462`", ",", 
          "2.2236488041127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37875591981257`", ",", "2.18597109248091`", ",", 
          "3.63642988162048`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03437613842549`", ",", "1.96082158903648`", ",", 
          "5.04921095912827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.973181664218`", ",", "1.75516129744307`", ",", 
          "0.178806729456467`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91198719001051`", ",", "1.55722873648926`", ",", 
          "1.59158780696425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.567607408623437`", ",", "1.35875427743697`", ",", 
          "3.00436888447204`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50641293441595`", ",", "1.15125004241158`", ",", 
          "4.41714996197983`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44521846020846`", ",", "0.921990132217336`", ",", 
          "5.82993103948761`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.10083867882138`", ",", "0.641623619836655`", ",", 
          "0.95952680981581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03964420461389`", ",", "0.0630253512383922`", ",", 
          "2.3723078873236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9784497304064`", ",", "2.50663356400551`", ",", 
          "3.78508896483138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91725525619891`", ",", "2.22459549321426`", ",", 
          "5.19787004233917`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57287547481183`", ",", "1.99469481138765`", ",", 
          "0.327465812667368`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51168100060434`", ",", "1.78690201755265`", ",", 
          "1.74024689017515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45048652639685`", ",", "1.58833528025696`", ",", 
          "3.15302796768294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10610674500978`", ",", "1.39046918228891`", ",", 
          "4.56580904519073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04491227080228`", ",", "1.18506060584579`", ",", 
          "5.97859012269851`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98371779659479`", ",", "0.96047552248577`", ",", 
          "1.10818589302671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.639338015207718`", ",", "0.691924056931596`", ",", 
          "2.5209669705345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57814354100023`", ",", "0.257972071699299`", ",", 
          "3.93374804804228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51694906679274`", ",", "2.56111573366773`", ",", 
          "5.34652912555007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.17256928540566`", ",", "2.26439915790013`", ",", 
          "0.476124895878268`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11137481119817`", ",", "2.02909416354159`", ",", 
          "1.88890597338605`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05018033699068`", ",", "1.81886556455904`", ",", 
          "3.30168705089384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98898586278319`", ",", "1.61945881288107`", ",", 
          "4.71446812840163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64460608139611`", ",", "1.42200169136923`", ",", 
          "6.12724920590941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58341160718862`", ",", "1.21841299134912`", ",", 
          "1.25684497623761`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52221713298113`", ",", "0.99795123275567`", ",", 
          "2.6696260537454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17783735159406`", ",", "0.739338221734283`", ",", 
          "4.08240713125318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11664287738657`", ",", "0.360263113313274`", ",", 
          "5.49518820876097`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05544840317908`", ",", "2.62056162239559`", ",", 
          "0.624783979089168`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.711068621791998`", ",", "2.30556690038233`", ",", 
          "2.03756505659695`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64987414758451`", ",", "2.06408775083388`", ",", 
          "3.45034613410474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58867967337702`", ",", "1.85109011989235`", ",", 
          "4.86312721161253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.244299891989941`", ",", "1.65062961165145`", ",", 
          "6.27590828912031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18310541778245`", ",", "1.45338579113593`", ",", 
          "1.40550405944851`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12191094357496`", ",", "1.25136106243125`", ",", 
          "2.8182851369563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06071646936747`", ",", "1.03454173881778`", ",", 
          "4.23106621446408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71633668798039`", ",", "0.784404019199442`", ",", 
          "5.64384729197187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6551422137729`", ",", "0.440123917506301`", ",", 
          "0.773443062300068`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59394773956541`", ",", "2.68693551014544`", ",", 
          "2.18622413980785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24956795817834`", ",", "2.34832752166024`", ",", 
          "3.59900521731564`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18837348397085`", ",", "2.09975278813767`", ",", 
          "5.01178629482343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12717900976336`", ",", "1.88361655363902`", ",", 
          "0.141382065151625`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.782799228376279`", ",", "1.68187836943797`", ",", 
          "1.55416314265941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72160475416879`", ",", "1.48465409220627`", ",", 
          "2.9669442201672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6604102799613`", ",", "1.28395375857052`", ",", 
          "4.37972529767498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.316030498574221`", ",", "1.07035283483166`", ",", 
          "5.79250637518277`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25483602436673`", ",", "0.827519433884599`", ",", 
          "0.922102145510968`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19364155015924`", ",", "0.50825787915258`", ",", 
          "2.33488322301875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13244707595175`", ",", "2.76389693974158`", ",", 
          "3.74766430052654`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78806729456467`", ",", "2.39297054630921`", ",", 
          "5.16044537803433`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72687282035718`", ",", "2.13617774900378`", ",", 
          "0.290041148362526`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66567834614969`", ",", "1.91648899035506`", ",", 
          "1.70282222587031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32129856476262`", ",", "1.71323647195028`", ",", 
          "3.1156033033781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26010409055513`", ",", "1.51583815542745`", ",", 
          "4.52838438088588`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19890961634764`", ",", "1.31623593994526`", ",", 
          "5.94116545839367`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.854529834960559`", ",", "1.10547558542186`", ",", 
          "1.07076122872187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79333536075307`", ",", "0.868989017048755`", ",", 
          "2.48354230622965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73214088654558`", ",", "0.568910474428956`", ",", 
          "3.89632338373744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.387761105158502`", ",", "2.86002887575548`", ",", 
          "5.30910446124523`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32656663095101`", ",", "2.43987207320781`", ",", 
          "0.438700231573426`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26537215674352`", ",", "2.17346516878463`", ",", 
          "1.85148130908121`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20417768253603`", ",", "1.94975548215997`", ",", 
          "3.264262386589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85979790114895`", ",", "1.74473629232768`", ",", 
          "4.67704346409678`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79860342694146`", ",", "1.54696879090181`", ",", 
          "6.08982454160457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73740895273397`", ",", "1.34824908575912`", ",", 
          "1.21942031193277`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3930291713469`", ",", "1.13998928977284`", ",", 
          "2.63220138944055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33183469713941`", ",", "0.909052266643815`", ",", 
          "4.04498246694834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27064022293192`", ",", "0.624281692625692`", ",", 
          "5.45776354445613`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.92626044154484`", ",", "3.01287514500855`", ",", 
          "0.587359314784326`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86506596733735`", ",", "2.48953665709306`", ",", 
          "2.00014039229211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80387149312986`", ",", "2.21173536755264`", ",", 
          "3.4129214697999`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.459491711742782`", ",", "1.98346882069062`", ",", 
          "4.82570254730768`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39829723753529`", ",", "1.77641151102271`", ",", 
          "6.23848362481547`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3371027633278`", ",", "1.57807633815468`", ",", 
          "1.36807939514367`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27590828912031`", ",", "1.38003187959099`", ",", 
          "2.78086047265145`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93152850773324`", ",", "1.17396374621532`", ",", 
          "4.19364155015924`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87033403352574`", ",", "0.947901839108234`", ",", 
          "5.60642262766703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80913955931825`", ",", "0.675686201929272`", ",", 
          "0.736018397995226`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46475977793118`", ",", "0.214102694076371`", ",", 
          "2.14879947550301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40356530372369`", ",", "2.54266934845574`", ",", 
          "3.5615805530108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3423708295162`", ",", "2.25113149568871`", ",", 
          "4.97436163051858`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.99799104812912`", ",", "2.0176875300521`", ",", 
          "0.103957400846783`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93679657392163`", ",", "1.80829747024128`", ",", 
          "1.51673847835457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87560209971414`", ",", "1.60919093468923`", ",", 
          "2.92951955586236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.531222318327063`", ",", "1.41162070715459`", ",", 
          "4.34230063337014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47002784411957`", ",", "1.20746101162678`", ",", 
          "5.75508171087793`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40883336991208`", ",", "0.985695720617202`", ",", 
          "0.884677481206126`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0644535885250057`", ",", "0.72398407223904`", ",", 
          "2.29745855871391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00325911431752`", ",", "0.329938684974296`", ",", 
          "3.7102396362217`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94206464011002`", ",", "2.60030960165383`", ",", 
          "5.12302071372948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88087016590253`", ",", "2.2918265308132`", ",", 
          "0.252616484057684`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53649038451546`", ",", "2.05247709792919`", ",", 
          "1.66539756156547`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47529591030797`", ",", "1.84043157405047`", ",", 
          "3.07817863907326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41410143610048`", ",", "1.64034277960485`", ",", 
          "4.49095971658104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0697216547134`", ",", "1.4430500860718`", ",", 
          "5.90374079408883`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00852718050591`", ",", "1.24053678962726`", ",", 
          "1.03333656441703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94733270629842`", ",", "1.02256564105338`", ",", 
          "2.44611764192481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.602952924911343`", ",", "0.769774679445587`", ",", 
          "3.8588987194326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54175845070385`", ",", "0.415395017233793`", ",", 
          "5.27167979694038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48056397649636`", ",", "2.66410776182647`", ",", 
          "0.401275567268584`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.136184195109286`", ",", "2.33403324053548`", ",", 
          "1.81405664477637`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0749897209018`", ",", "2.08791152375152`", ",", 
          "3.22683772228416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01379524669431`", ",", "1.87285374783183`", ",", 
          "4.63961879979194`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95260077248682`", ",", "1.67156239871753`", ",", 
          "6.05239987729973`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60822099109974`", ",", "1.47435304307695`", ",", 
          "1.18199564762793`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54702651689225`", ",", "1.27324154190401`", ",", 
          "2.59477672513571`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48583204268476`", ",", "1.0586230596862`", ",", 
          "4.0075578026435`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14145226129768`", ",", "0.813495779802412`", ",", 
          "5.42033888015128`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08025778709019`", ",", "0.486762776666487`", ",", 
          "0.549934650479484`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0190633128827`", ",", "2.7369897014669`", ",", 
          "1.96271572798727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.674683531495624`", ",", "2.37801881331989`", ",", 
          "3.37549680549506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61348905728813`", ",", "2.12407529480825`", ",", 
          "4.78827788300284`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55229458308064`", ",", "1.90560697429162`", ",", 
          "6.20105896051063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.207914801693567`", ",", "1.7028809176929`", ",", 
          "1.33065473083883`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14672032748608`", ",", "1.50556145102542`", ",", 
          "2.74343580834661`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08552585327859`", ",", "1.30562139036522`", ",", 
          "4.1562168858544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0243313790711`", ",", "1.09396352981853`", ",", 
          "5.56899796336219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67995159768402`", ",", "0.855478929379591`", ",", 
          "0.698593733690384`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61875712347653`", ",", "0.549575118033198`", ",", 
          "2.11137481119817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55756264926904`", ",", "2.82520002361346`", ",", 
          "3.52415588870596`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21318286788196`", ",", "2.42412714912545`", ",", 
          "4.93693696621374`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.15198839367447`", ",", "2.16106594932769`", ",", 
          "0.0665327365419414`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09079391946698`", ",", "1.93873792810497`", ",", 
          "1.47931381404973`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.746414138079905`", ",", "1.73433035009109`", ",", 
          "2.89209489155751`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68521966387241`", ",", "1.53670633587489`", ",", 
          "4.3048759690653`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62402518966492`", ",", "1.33771885957794`", ",", 
          "5.71765704657309`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.279645408277847`", ",", "1.12866995088629`", ",", 
          "0.847252816901284`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21845093407036`", ",", "0.895982678269291`", ",", 
          "2.26003389440907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15725645986287`", ",", "0.606511811172882`", ",", 
          "3.67281497191686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09606198565538`", ",", "2.94878035922525`", ",", 
          "5.08559604942464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7516822042683`", ",", "2.472814368404`", ",", 
          "0.215191819752842`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69048773006081`", ",", "2.19899745960977`", ",", 
          "1.62797289726063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62929325585332`", ",", "1.97229773801112`", ",", 
          "3.04075397476841`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28491347446624`", ",", "1.76594390795873`", ",", 
          "4.4535350522762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22371900025875`", ",", "1.56781816223361`", ",", 
          "5.86631612978399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16252452605126`", ",", "1.36957349623058`", ",", 
          "0.995911900112185`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.818144744664185`", ",", "1.16281503850293`", ",", 
          "2.40869297761997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75695027045669`", ",", "0.935213548808238`", ",", 
          "3.82147405512776`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6957557962492`", ",", "0.659112488051134`", ",", 
          "5.23425513263554`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.351376014862128`", ",", "0.158750719962164`", ",", 
          "0.363850902963742`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29018154065464`", ",", "2.52470859948216`", ",", 
          "1.77663198047153`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22898706644715`", ",", "2.23800478539421`", ",", 
          "3.18941305797931`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16779259223966`", ",", "2.00634291460404`", ",", 
          "4.6021941354871`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82341281085258`", ",", "1.79775634374813`", ",", 
          "6.01497521299488`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76221833664509`", ",", "1.59892710498641`", ",", 
          "1.14457098332308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7010238624376`", ",", "1.40122239336682`", ",", 
          "2.55735206083087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35664408105052`", ",", "1.19646323321983`", ",", 
          "3.97013313833866`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29544960684303`", ",", "0.97333988090989`", ",", 
          "5.38291421584644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23425513263554`", ",", "0.708358497588183`", ",", 
          "0.512509986174642`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.889875351248466`", ",", "0.296652742440983`", ",", 
          "1.92529106368243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82868087704098`", ",", "2.5807180415234`", ",", 
          "3.33807214119021`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76748640283349`", ",", "2.27825013844886`", ",", 
          "4.750853218698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.423106621446408`", ",", "2.04093649541602`", ",", 
          "6.16363429620579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36191214723892`", ",", "1.82980433399568`", ",", 
          "1.29323006653398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30071767303143`", ",", "1.63006331382432`", ",", 
          "2.70601114404177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23952319882394`", ",", "1.43270064069794`", ",", 
          "4.11879222154956`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89514341743686`", ",", "1.22967219909629`", ",", 
          "5.53157329905734`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83394894322937`", ",", "1.01050130324609`", ",", 
          "0.661169069385542`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77275446902188`", ",", "0.754921097102293`", ",", 
          "2.07395014689333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4283746876348`", ",", "0.389194268590647`", ",", 
          "3.48673122440111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36718021342731`", ",", "2.6422456407413`", ",", 
          "4.8995123019089`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30598573921982`", ",", "2.31993182127811`", ",", 
          "0.0291080722370993`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.961605957832746`", ",", "2.07614947809627`", ",", 
          "1.44188914974489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90041148362526`", ",", "1.86212691749788`", ",", 
          "2.85467022725267`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83921700941777`", ",", "1.66125717715994`", ",", 
          "4.26745130476046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.494837228030689`", ",", "1.46404171764679`", ",", 
          "5.68023238226824`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4336427538232`", ",", "1.26249401775251`", ",", 
          "0.809828152596442`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37244827961571`", ",", "1.04681541090519`", ",", 
          "2.22260923010423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0280684982286315`", ",", "0.799283684493792`", ",", 
          "3.63539030761201`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96687402402114`", ",", "0.464356677690035`", ",", 
          "5.0481713851198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90567954981365`", ",", "2.71167640933985`", ",", 
          "0.177767155448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84448507560616`", ",", "2.36329706835512`", ",", 
          "1.59054823295579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50010529421908`", ",", "2.11206264059205`", ",", 
          "3.00332931046357`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43891082001159`", ",", "1.89476600390489`", ",", 
          "4.41611038797136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3777163458041`", ",", "1.69253959188128`", ",", 
          "5.82889146547914`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03333656441703`", ",", "1.49527784239517`", ",", 
          "0.958487235807343`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97214209020954`", ",", "1.29497615328083`", ",", 
          "2.37126831331513`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91094761600205`", ",", "1.08238259696377`", ",", 
          "3.78404939082291`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.566567834614969`", ",", "0.841808355789865`", ",", 
          "5.1968304683307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50537336040748`", ",", "0.529609070070139`", ",", 
          "0.3264262386589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44417888619999`", ",", "2.793737134632`", ",", 
          "1.73920731616669`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.099799104812912`", ",", "2.40866135994042`", ",", 
          "3.15198839367447`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03860463060542`", ",", "2.14876888920032`", ",", 
          "4.56476947118226`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97741015639793`", ",", "1.92776697302773`", ",", 
          "5.97755054869004`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91621568219044`", ",", "1.72394224567878`", ",", 
          "1.10714631901824`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.57183590080336`", ",", "1.52644028775198`", ",", 
          "2.51992739652603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51064142659587`", ",", "1.32716224276269`", ",", 
          "3.93270847403381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44944695238838`", ",", "1.11728962800706`", ",", 
          "5.3454895515416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10506717100131`", ",", "0.882774956148681`", ",", 
          "0.4750853218698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04387269679382`", ",", "0.58827456883875`", ",", 
          "1.88786639937759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98267822258633`", ",", "2.90105955737494`", ",", 
          "3.30064747688537`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.63829844119925`", ",", "2.45643870895025`", ",", 
          "4.71342855439316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57710396699176`", ",", "2.18637633943038`", ",", 
          "6.12620963190094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51590949278427`", ",", "1.96117939120335`", ",", 
          "1.25580540222914`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.171529711397193`", ",", "1.75549791929652`", ",", 
          "2.66858647973693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1103352371897`", ",", "1.55755967289552`", ",", 
          "4.08136755724471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04914076298221`", ",", "1.35909275284123`", ",", 
          "5.4941486347525`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98794628877472`", ",", "1.15161234333121`", ",", 
          "0.6237444050807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64356650738764`", ",", "0.922405358416637`", ",", 
          "2.03652548258849`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58237203318015`", ",", "0.642176311610289`", ",", 
          "3.44930656009627`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52117755897266`", ",", "0.0680770385185272`", ",", 
          "4.86208763760406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17679777758559`", ",", "2.50719166079369`", ",", 
          "6.27486871511184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1156033033781`", ",", "2.22501243498242`", ",", 
          "1.40446448544004`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05440882917061`", ",", "1.99505787949054`", ",", 
          "2.81724556294783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.71002904778353`", ",", "1.78724081705999`", ",", 
          "4.23002664045561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64883457357604`", ",", "1.58866623881041`", ",", 
          "5.6428077179634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58764009936855`", ",", "1.39080553273267`", ",", 
          "0.772403488291601`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.243260317981473`", ",", "1.18541772930707`", ",", 
          "2.18518456579939`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18206584377398`", ",", "0.96087927408329`", ",", 
          "3.59796564330717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12087136956649`", ",", "0.692442541050876`", ",", 
          "5.01074672081496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.059676895359`", ",", "0.259265961127792`", ",", 
          "0.140342491143158`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71529711397193`", ",", "2.56171939030041`", ",", 
          "1.55312356865094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65410263976444`", ",", "2.26482957198689`", ",", 
          "2.96590464615873`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59290816555694`", ",", "2.02946318035615`", ",", 
          "4.37868572366652`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24852838416987`", ",", "1.81920693550336`", ",", 
          "5.7914668011743`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18733390996238`", ",", "1.61979011443086`", ",", 
          "0.921062571502501`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12613943575489`", ",", "1.42233628687876`", ",", 
          "2.33384364901029`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.781759654367811`", ",", "1.21876553969891`", ",", 
          "3.74662472651807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72056518016032`", ",", "0.998344949484578`", ",", 
          "5.15940580402586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65937070595283`", ",", "0.739829195463498`", ",", 
          "0.289001574354058`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.314990924565754`", ",", "0.361200634682901`", ",", 
          "1.70178265186184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25379645035826`", ",", "2.62122677999329`", ",", 
          "3.11456372936963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19260197615077`", ",", "2.30601296543554`", ",", 
          "4.52734480687742`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13140750194328`", ",", "2.06446348651555`", ",", 
          "5.9401258843852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78702772055621`", ",", "1.85143448199028`", ",", 
          "1.0697216547134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72583324634872`", ",", "1.65096158005034`", ",", 
          "2.48250273222119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66463877214123`", ",", "1.45371898526646`", ",", 
          "3.89528380972897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32025899075415`", ",", "1.25170958056747`", ",", 
          "5.30806488723676`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25906451654666`", ",", "1.03492663638626`", ",", 
          "0.437660657564958`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19787004233917`", ",", "0.784872347980185`", ",", 
          "1.85044173507274`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.853490260952091`", ",", "0.440899960388844`", ",", 
          "3.26322281258053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7922957867446`", ",", "2.68768960078684`", ",", 
          "4.67600389008832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73110131253711`", ",", "2.34879196207`", ",", 
          "6.0887849675961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.386721531150034`", ",", "2.10013612032822`", ",", 
          "1.2183807379243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32552705694254`", ",", "1.88396435808487`", ",", 
          "2.63116181543209`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26433258273505`", ",", "1.68221133442602`", ",", 
          "4.04394289293987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20313810852756`", ",", "1.48498622568511`", ",", 
          "5.45672397044766`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85875832714049`", ",", "1.28429874384314`", ",", 
          "0.586319740775858`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.797563852933`", ",", "1.07072995352488`", ",", 
          "1.99910081828364`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73636937872551`", ",", "0.827968786844119`", ",", 
          "3.41188189579143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39198959733843`", ",", "0.508937424766099`", ",", 
          "4.82466297329922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33079512313094`", ",", "2.7647952589507`", ",", 
          "6.237444050807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26960064892345`", ",", "2.39345685071002`", ",", 
          "1.3670398211352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.925220867536372`", ",", "2.13656968882824`", ",", 
          "2.77982089864299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86402639332888`", ",", "1.9168407263683`", ",", 
          "4.19260197615077`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80283191912139`", ",", "1.71357077218441`", ",", 
          "5.60538305365856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.458452137734315`", ",", "1.51616955946187`", ",", 
          "0.734978823986758`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39725766352682`", ",", "1.31657785028785`", ",", 
          "2.14775990149454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33606318931933`", ",", "1.10584582621529`", ",", 
          "3.56054097900233`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27486871511184`", ",", "0.869422245058028`", ",", 
          "4.97332205651012`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93048893372477`", ",", "0.569524432186897`", ",", 
          "0.102917826838316`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86929445951728`", ",", "2.86122225719102`", ",", 
          "1.5156989043461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80809998530979`", ",", "2.44038483902068`", ",", 
          "2.92847998185389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46372020392271`", ",", "2.17386689504605`", ",", 
          "4.34126105936167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40252572971522`", ",", "1.95011168482819`", ",", 
          "5.75404213686946`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34133125550773`", ",", "1.74507227863642`", ",", 
          "0.883637907197659`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.996951474120652`", ",", "1.54729979024525`", ",", 
          "2.29641898470544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93575699991316`", ",", "1.34858834645942`", ",", 
          "3.70920006221323`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87456252570567`", ",", "1.14035344169239`", ",", 
          "5.12198113972102`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.530182744318595`", ",", "0.90947163988428`", ",", 
          "0.251576910049216`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4689882701111`", ",", "0.624847592573221`", ",", 
          "1.664357987557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40779379590361`", ",", "3.01547925486329`", ",", 
          "3.07713906506479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0634140145165379`", ",", "2.49008216307958`", ",", 
          "4.48992014257257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00221954030905`", ",", "2.21214827257313`", ",", 
          "5.90270122008036`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.94102506610156`", ",", "1.98383008049414`", ",", 
          "1.03229699040856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87983059189407`", ",", "1.77674954997716`", ",", 
          "2.44507806791634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53545081050699`", ",", "1.57840725401263`", ",", 
          "3.85785914542413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4742563362995`", ",", "1.38036888900796`", ",", 
          "5.27064022293192`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41306186209201`", ",", "1.1743225074313`", ",", 
          "0.400235993260116`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06868208070493`", ",", "0.948309203104331`", ",", 
          "1.8130170707679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00748760649744`", ",", "0.676215111688002`", ",", 
          "3.22579814827569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94629313228995`", ",", "0.215654579319157`", ",", 
          "4.63857922578347`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.601913350902876`", ",", "2.54325657159828`", ",", 
          "6.05136030329126`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.54071887669539`", ",", "2.25155724809202`", ",", 
          "1.18095607361946`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4795244024879`", ",", "2.01805450458976`", ",", 
          "2.59373715112724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.135144621100818`", ",", "1.80863794814956`", ",", 
          "4.00651822863503`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07395014689333`", ",", "1.60952208753813`", ",", 
          "5.41929930614282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01275567268584`", ",", "1.41195584161769`", ",", 
          "0.548895076471016`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95156119847835`", ",", "1.20781500597891`", ",", 
          "1.9616761539788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60718141709127`", ",", "0.986092602529318`", ",", 
          "3.37445723148659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54598694288378`", ",", "0.724483507488116`", ",", 
          "4.78723830899437`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48479246867629`", ",", "0.330958530730453`", ",", 
          "6.20001938650216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14041268728921`", ",", "2.60095218799887`", ",", 
          "1.32961515683036`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07921821308172`", ",", "2.29226716363555`", ",", 
          "2.74239623433815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01802373887423`", ",", "2.05285052655571`", ",", 
          "4.15517731184593`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.673643957487156`", ",", "1.84077490150619`", ",", 
          "5.56795838935372`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61244948327967`", ",", "1.64067449199324`", ",", 
          "0.697554159681916`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55125500907218`", ",", "1.44338370414619`", ",", 
          "2.1103352371897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.206875227685099`", ",", "1.24088657976444`", ",", 
          "3.52311631469749`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14568075347761`", ",", "1.02295332434782`", ",", 
          "4.93589739220527`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08448627927012`", ",", "0.770250021669952`", ",", 
          "0.0654931625334735`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02329180506263`", ",", "0.416214243000686`", ",", 
          "1.47827424004126`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67891202367555`", ",", "2.66482833537481`", ",", 
          "2.89105531754904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61771754946806`", ",", "2.33449127843185`", ",", 
          "4.30383639505683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55652307526057`", ",", "2.08829224611551`", ",", 
          "5.71661747256462`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21214329387349`", ",", "1.87320036497916`", ",", 
          "0.846213242892816`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.150948819666`", ",", "1.67189499811781`", ",", 
          "2.2589943204006`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08975434545851`", ",", "1.4746854893405`", ",", 
          "3.67177539790839`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.745374564071437`", ",", "1.27358763988108`", ",", 
          "5.08455647541617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68418008986395`", ",", "1.05900263798917`", ",", 
          "0.214152245744374`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62298561565646`", ",", "0.813951041472702`", ",", 
          "1.62693332325216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.278605834269379`", ",", "0.487469722145425`", ",", 
          "3.03971440075995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21741136006189`", ",", "2.73783113152975`", ",", 
          "4.45249547826773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1562168858544`", ",", "2.37849746243334`", ",", 
          "5.86527655577552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09502241164691`", ",", "2.12446427469366`", ",", 
          "0.994872326103717`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75064263025983`", ",", "1.90595735701338`", ",", 
          "2.4076534036115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68944815605234`", ",", "1.70321473947438`", ",", 
          "3.82043448111929`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62825368184485`", ",", "1.50589305947604`", ",", 
          "5.23321555862708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28387390045777`", ",", "1.30596426630697`", ",", 
          "0.362811328955274`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22267942625028`", ",", "1.09433594665594`", ",", 
          "1.77559240646306`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16148495204279`", ",", "0.855917199655298`", ",", 
          "3.18837348397085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.817105170655717`", ",", "0.550208317251038`", ",", 
          "4.60115456147863`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75591069644823`", ",", "2.82626528580932`", ",", 
          "6.01393563898642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69471622224074`", ",", "2.42463059202888`", ",", 
          "1.14353140931462`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.35033644085366`", ",", "2.16146430583078`", ",", 
          "2.5563124868224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28914196664617`", ",", "1.93909259540097`", ",", 
          "3.96909356433019`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22794749243868`", ",", "1.73466574069113`", ",", 
          "5.38187464183797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16675301823119`", ",", "1.53703743306699`", ",", 
          "0.511470412166174`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82237323684411`", ",", "1.33805894886027`", ",", 
          "1.92425148967396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76117876263662`", ",", "1.12903602960625`", ",", 
          "3.33703256718175`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69998428842913`", ",", "0.896406398428888`", ",", 
          "4.74981364468953`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35560450704206`", ",", "0.607092101566992`", ",", 
          "6.16259472219732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29441003283456`", ",", "2.95051495730317`", ",", 
          "1.29219049252552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23321555862708`", ",", "2.47334824519083`", ",", 
          "2.7049715700333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.888835777239998`", ",", "2.19940650866349`", ",", 
          "4.11775264754109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82764130303251`", ",", "1.97265726091826`", ",", 
          "5.53053372504888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76644682882502`", ",", "1.76628122833844`", ",", 
          "0.660129495377074`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.42206704743794`", ",", "1.5681490702284`", ",", 
          "2.07291057288486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.36087257323045`", ",", "1.3699112055159`", ",", 
          "3.48569165039265`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29967809902296`", ",", "1.16317550521692`", ",", 
          "4.89847272790043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23848362481547`", ",", "0.935624690703975`", ",", 
          "0.0280684982286315`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89410384342839`", ",", "0.659652630142139`", ",", 
          "1.44084957573642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8329093692209`", ",", "0.160830436606487`", ",", 
          "2.8536306532442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77171489501341`", ",", "2.52528084208886`", ",", 
          "4.26641173075199`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42733511362634`", ",", "2.23842609622213`", ",", 
          "5.67919280825978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36614063941885`", ",", "2.00670792712843`", ",", 
          "0.808788578587975`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30494616521135`", ",", "1.79809597323407`", ",", 
          "2.22156965609576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.960566383824278`", ",", "1.5992581441917`", ",", 
          "3.63435073360355`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89937190961679`", ",", "1.40155810575051`", ",", 
          "5.04713181111133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8381774354093`", ",", "1.19681873468281`", ",", 
          "0.176727581439532`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.493797654022221`", ",", "0.973740067166269`", ",", 
          "1.58950865894732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43260317981473`", ",", "0.708866973771705`", ",", 
          "3.0022897364551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37140870560724`", ",", "0.297782652762309`", ",", 
          "4.41507081396289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0270289242201637`", ",", "2.58134044029566`", ",", 
          "5.82785189147068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96583445001267`", ",", "2.27868561212871`", ",", 
          "0.957447661798875`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90463997580518`", ",", "2.04130770811673`", ",", 
          "2.37022873930666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84344550159769`", ",", "1.83014667462939`", ",", 
          "3.78300981681445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49906572021062`", ",", "1.63039480579405`", ",", 
          "5.19579089432223`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43787124600313`", ",", "1.43303472016492`", ",", 
          "0.325386664650432`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37667677179564`", ",", "1.23002331685578`", ",", 
          "1.73816774215822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03229699040856`", ",", "1.0108918908922`", ",", 
          "3.150948819666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.97110251620107`", ",", "0.75540388570636`", ",", 
          "4.56372989717379`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90990804199358`", ",", "0.390065428656229`", ",", 
          "5.97651097468158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.565528260606501`", ",", "2.64293712020412`", ",", 
          "1.10610674500978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50433378639901`", ",", "2.3203838030558`", ",", 
          "2.51888782251756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44313931219152`", ",", "2.07652769520569`", ",", 
          "3.93166890002535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0987595308044442`", ",", "1.86247239904429`", ",", 
          "5.34444997753313`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03756505659695`", ",", "1.66158944742156`", ",", 
          "0.474045747861332`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97637058238946`", ",", "1.46437451299528`", ",", 
          "1.88682682536912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91517610818197`", ",", "1.26284127950695`", ",", 
          "3.2996079028769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5707963267949`", ",", "1.0471975511966`", ",", 
          "4.71238898038469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50960185258741`", ",", "0.79974518869675`", ",", 
          "6.12517005789248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44840737837992`", ",", "0.465095015768736`", ",", 
          "1.25476582822068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10402759699284`", ",", "2.71247103010803`", ",", 
          "2.66754690572846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04283312278535`", ",", "2.3637685133481`", ",", 
          "4.08032798323625`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98163864857786`", ",", "2.11244878192012`", ",", 
          "5.49310906074403`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.637258867190782`", ",", "1.89511508970983`", ",", 
          "0.622704831072232`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57606439298329`", ",", "1.6928729728607`", ",", 
          "2.03548590858002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5148699187758`", ",", "1.49560969075418`", ",", 
          "3.4482669860878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.170490137388725`", ",", "1.29532004212455`", ",", 
          "4.86104806359559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10929566318123`", ",", "1.08275727920883`", ",", 
          "6.27382914110338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04810118897374`", ",", "0.842251932441031`", ",", 
          "1.40342491143158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98690671476625`", ",", "0.530263710610074`", ",", 
          "2.81620598893936`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64252693337918`", ",", "2.79470917284991`", ",", 
          "4.22898706644715`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58133245917169`", ",", "2.40915608695717`", ",", 
          "5.64176814395493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5201379849642`", ",", "2.14916401861668`", ",", 
          "0.771363914283133`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17575820357712`", ",", "1.92812016696962`", ",", 
          "2.18414499179092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11456372936963`", ",", "1.72427707979719`", ",", 
          "3.5969260692987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05336925516214`", ",", "1.52677151779713`", ",", 
          "5.00970714680649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.708989473775063`", ",", "1.32750320481413`", ",", 
          "0.13930291713469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64779499956757`", ",", "1.11765771235597`", ",", 
          "1.55208399464248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58660052536008`", ",", "0.883203236735909`", ",", 
          "2.96486507215026`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.242220743973005`", ",", "0.588870609850909`", ",", 
          "4.37764614965805`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.18102626976551`", ",", "2.90245259137819`", ",", 
          "5.79042722716583`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11983179555803`", ",", "2.45696180741394`", ",", 
          "0.920022997494033`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05863732135053`", ",", "2.18678170256255`", ",", 
          "2.33280407500182`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71425753996346`", ",", "1.96153724605955`", ",", 
          "3.7455851525096`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65306306575597`", ",", "1.75583456232193`", ",", 
          "5.15836623001739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59186859154848`", ",", "1.55789060785204`", ",", 
          "0.28796200034559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2474888101614`", ",", "1.35943120362438`", ",", 
          "1.70074307785338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18629433595391`", ",", "1.15197458577071`", ",", 
          "3.11352415536116`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12509986174642`", ",", "0.922820454025247`", ",", 
          "4.52630523286895`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.780720080359343`", ",", "0.642728595268302`", ",", 
          "5.93908631037673`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71952560615185`", ",", "0.0727794241743408`", ",", 
          "1.06868208070493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65833113194436`", ",", "2.50775018116968`", ",", 
          "2.48146315821272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.313951350557286`", ",", "2.22542951010774`", ",", 
          "3.8942442357205`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2527568763498`", ",", "1.99542100714478`", ",", 
          "5.30702531322829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1915624021423`", ",", "1.78757964180921`", ",", 
          "0.43662108355649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13036792793482`", ",", "1.58899719932143`", ",", 
          "1.84940216106428`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78598814654774`", ",", "1.39114186259225`", ",", 
          "3.26218323857206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72479367234025`", ",", "1.18577480103875`", ",", 
          "4.67496431607985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66359919813276`", ",", "0.961282911798551`", ",", 
          "6.08774539358763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31921941674568`", ",", "0.692960701271571`", ",", 
          "1.21734116391583`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25802494253819`", ",", "0.260553569187384`", ",", 
          "2.63012224142362`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1968304683307`", ",", "2.56232360379532`", ",", 
          "4.04290331893141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.852450686943624`", ",", "2.26526014028795`", ",", 
          "5.45568439643919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79125621273613`", ",", "2.02983226442397`", ",", 
          "0.58528016676739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73006173852864`", ",", "1.81954833600907`", ",", 
          "1.99806124427518`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.385681957141566`", ",", "1.62012142136263`", ",", 
          "3.41084232178296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32448748293408`", ",", "1.4226708656452`", ",", 
          "4.82362339929075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26329300872659`", ",", "1.21911804239885`", ",", 
          "6.23640447679853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2020985345191`", ",", "0.998738566343489`", ",", 
          "1.36600024712673`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85771875313202`", ",", "0.740319905244524`", ",", 
          "2.77878132463452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79652427892453`", ",", "0.362135835159735`", ",", 
          "4.1915624021423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73532980471704`", ",", "2.62189271056176`", ",", 
          "5.60434347965009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.39095002332996`", ",", "2.3064592105048`", ",", 
          "0.733939249978291`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32975554912247`", ",", "2.06483929818122`", ",", 
          "2.14672032748608`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26856107491498`", ",", "1.85177887827326`", ",", 
          "3.55950140499386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.924181293527904`", ",", "1.65129355730288`", ",", 
          "4.97228248250165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86298681932041`", ",", "1.45405216634004`", ",", 
          "0.101878252829848`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80179234511292`", ",", "1.25205805857921`", ",", 
          "1.51465933033763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.457412563725847`", ",", "1.03531144600136`", ",", 
          "2.92744040784542`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39621808951836`", ",", "0.785340457301147`", ",", 
          "4.34022148535321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33502361531087`", ",", "0.441674729103846`", ",", 
          "5.75300256286099`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27382914110338`", ",", "2.68844485879762`", ",", 
          "0.882598333189191`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9294493597163`", ",", "2.34925661511188`", ",", 
          "2.29537941069698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86825488550881`", ",", "2.10051953850454`", ",", 
          "3.70816048820476`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80706041130132`", ",", "1.88431220170747`", ",", 
          "5.12094156571255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46268062991424`", ",", "1.68254431181801`", ",", 
          "0.250537336040748`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40148615570675`", ",", "1.48531834967497`", ",", 
          "1.66331841354853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.34029168149926`", ",", "1.28464369405725`", ",", 
          "3.07609949105632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.995911900112185`", ",", "1.07110699452752`", ",", 
          "4.48888056856411`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93471742590469`", ",", "0.82841795446115`", ",", 
          "5.90166164607189`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8735229516972`", ",", "0.509616143766198`", ",", 
          "1.03125741640009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.529143170310127`", ",", "2.76569562215244`", ",", 
          "2.44403849390788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46794869610264`", ",", "2.3939434100519`", ",", 
          "3.85681957141566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40675422189515`", ",", "2.13696172622699`", ",", 
          "5.26960064892345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.06237444050807`", ",", "1.91719250699408`", ",", 
          "0.399196419251648`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00117996630058`", ",", "1.71390508848462`", ",", 
          "1.81197749675943`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93998549209309`", ",", "1.51650095749083`", ",", 
          "3.22475857426722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8787910178856`", ",", "1.31691973025711`", ",", 
          "4.63753965177501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53441123649852`", ",", "1.10621599825898`", ",", 
          "6.05032072928279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47321676229103`", ",", "0.869855314597729`", ",", 
          "1.17991649961099`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41202228808354`", ",", "0.570137801807155`", ",", 
          "2.59269757711878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06764250669647`", ",", "2.86242060501814`", ",", 
          "4.00547865462656`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00644803248897`", ",", "2.44089791641881`", ",", 
          "5.41825973213435`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94525355828148`", ",", "2.17426873247597`", ",", 
          "0.547855502462548`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.600873776894408`", ",", "1.95046793808052`", ",", 
          "1.96063657997033`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53967930268692`", ",", "1.74540828482142`", ",", 
          "3.37341765747812`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47848482847943`", ",", "1.54763078701394`", ",", 
          "4.78619873498591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.134105047092351`", ",", "1.34892758115663`", ",", 
          "6.19897981249369`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07291057288486`", ",", "1.14071753273485`", ",", 
          "1.32857558282189`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.01171609867737`", ",", "0.909890876299081`", ",", 
          "2.74135666032968`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.95052162446988`", ",", "0.625413048859585`", ",", 
          "4.15413773783746`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6061418430828`", ",", "3.01813798528194`", ",", 
          "5.56691881534525`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54494736887531`", ",", "2.49062805956388`", ",", 
          "0.696514585673449`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48375289466782`", ",", "2.21256130492921`", ",", 
          "2.10929566318123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13937311328075`", ",", "1.98419139750121`", ",", 
          "3.52207674068902`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07817863907326`", ",", "1.77708761280614`", ",", 
          "4.93485781819681`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01698416486577`", ",", "1.57873817070403`", ",", 
          "0.0644535885250057`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.672604383478688`", ",", "1.3807058765332`", ",", 
          "1.47723466603279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6114099092712`", ",", "1.17468121477201`", ",", 
          "2.89001574354058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.55021543506371`", ",", "0.9487164480411`", ",", 
          "4.30279682104836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.205835653676631`", ",", "0.676743673049156`", ",", 
          "5.71557789855615`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14464117946914`", ",", "0.217195547662781`", ",", 
          "0.845173668884349`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08344670526165`", ",", "2.54384430101935`", ",", 
          "2.25795474639213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02225223105416`", ",", "2.25198314735634`", ",", 
          "3.67073582389992`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67787244966708`", ",", "2.01842154373717`", ",", 
          "5.08351690140771`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61667797545959`", ",", "1.80897845416394`", ",", 
          "0.213112671735906`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5554835012521`", ",", "1.60985324463595`", ",", 
          "1.62589374924369`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21110371986503`", ",", "1.41229095808999`", ",", 
          "3.03867482675148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14990924565754`", ",", "1.20816895274264`", ",", 
          "4.45145590425926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08871477145005`", ",", "0.986489380207562`", ",", 
          "5.86423698176705`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.744334990062969`", ",", "0.72498266105807`", ",", 
          "0.993832752095249`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68314051585548`", ",", "0.331975358373099`", ",", 
          "2.40661382960303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62194604164799`", ",", "2.60159546293231`", ",", 
          "3.81939490711082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.277566260260912`", ",", "2.29270796731917`", ",", 
          "5.23217598461861`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21637178605342`", ",", "2.05322402815961`", ",", 
          "0.361771754946806`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15517731184593`", ",", "1.84111826158481`", ",", 
          "1.77455283245459`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09398283763844`", ",", "1.64100621208326`", ",", 
          "3.18733390996238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74960305625136`", ",", "1.44371730796279`", ",", 
          "4.60011498747016`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68840858204387`", ",", "1.24123632800998`", ",", 
          "6.01289606497795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62721410783638`", ",", "1.0233409159607`", ",", 
          "1.14249183530615`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28283432644931`", ",", "0.770725131106811`", ",", 
          "2.55527291281393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22163985224182`", ",", "0.417031953313033`", ",", 
          "3.96805399032172`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.16044537803433`", ",", "2.66554991559715`", ",", 
          "5.38083506782951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.816065596647249`", ",", "2.33494951730058`", ",", 
          "0.510430838157706`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75487112243976`", ",", "2.08867305100869`", ",", 
          "1.92321191566549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69367664823227`", ",", "1.87354701961196`", ",", 
          "3.33599299317328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.349296866845192`", ",", "1.6722276087405`", ",", 
          "4.74877407068106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2881023926377`", ",", "1.47501792494933`", ",", 
          "6.16155514818885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22690791843021`", ",", "1.27393370117458`", ",", 
          "1.29115091851705`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16571344422272`", ",", "1.05938213537751`", ",", 
          "2.70393199602483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82133366283564`", ",", "0.814406107474296`", ",", 
          "4.11671307353262`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.76013918862815`", ",", "0.488175726166134`", ",", 
          "5.52949415104041`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69894471442066`", ",", "2.73867422204786`", ",", 
          "0.659089921368607`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35456493303359`", ",", "2.37897635122611`", ",", 
          "2.07187099887639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2933704588261`", ",", "2.124853348133`", ",", 
          "3.48465207638418`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23217598461861`", ",", "1.90630778250068`", ",", 
          "4.89743315389196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.88779620323153`", ",", "1.70354857609969`", ",", 
          "0.0270289242201637`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82660172902404`", ",", "1.50622466077975`", ",", 
          "1.43981000172795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76540725481655`", ",", "1.30630711036807`", ",", 
          "2.85259107923574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.421027473429473`", ",", "1.09470829192418`", ",", 
          "4.26537215674352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35983299922198`", ",", "0.856355303258959`", ",", 
          "5.67815323425131`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29863852501449`", ",", "0.550840863496309`", ",", 
          "0.807749004579507`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.237444050807`", ",", "2.82733403809568`", ",", 
          "2.22053008208729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89306426941993`", ",", "2.42513432585713`", ",", 
          "3.63331115959508`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83186979521243`", ",", "2.16186276876629`", ",", 
          "5.04609223710286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.77067532100494`", ",", "1.93944731124611`", ",", 
          "0.175688007431064`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42629553961787`", ",", "1.73500114989214`", ",", 
          "1.58846908493885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36510106541038`", ",", "1.5373685265569`", ",", 
          "3.00125016244664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30390659120289`", ",", "1.33839901072943`", ",", 
          "4.41403123995442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.95952680981581`", ",", "1.12940204495774`", ",", 
          "5.82681231746221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89833233560832`", ",", "0.896829975109373`", ",", 
          "0.956408087790407`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83713786140083`", ",", "0.607671907572419`", ",", 
          "2.36918916529819`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.492758080013753`", ",", "2.95226525131213`", ",", 
          "3.78197024280598`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.43156360580626`", ",", "2.47388248328649`", ",", 
          "5.19475132031377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.37036913159877`", ",", "2.1998156793939`", ",", 
          "0.324347090641964`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0259893502116958`", ",", "1.97301683876642`", ",", 
          "1.73712816814975`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96479487600421`", ",", "1.76661857125065`", ",", 
          "3.14990924565754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90360040179671`", ",", "1.56847997793331`", ",", 
          "4.56269032316532`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84240592758922`", ",", "1.37024889157912`", ",", 
          "5.97547140067311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49802614620215`", ",", "1.16353591583245`", ",", 
          "1.10506717100131`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43683167199466`", ",", "0.936035708045582`", ",", 
          "2.51784824850909`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37563719778717`", ",", "0.660192396304951`", ",", 
          "3.93062932601688`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03125741640009`", ",", "0.16288382777004`", ",", 
          "5.34341040352467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9700629421926`", ",", "2.52585354735368`", ",", 
          "0.473006173852864`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90886846798511`", ",", "2.2388475470404`", ",", 
          "1.88578725136065`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.564488686598034`", ",", "2.00707300172324`", ",", 
          "3.29856832886844`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50329421239054`", ",", "1.79843562940176`", ",", 
          "4.71134940637622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44209973818305`", ",", "1.59958918651692`", ",", 
          "6.12413048388401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0977199567959764`", ",", "1.40189379887747`", ",", 
          "1.25372625421221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03652548258849`", ",", "1.19717418655486`", ",", 
          "2.66650733171999`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.975331008381`", ",", "0.974140144579097`", ",", 
          "4.07928840922778`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91413653417351`", ",", "0.709375148641331`", ",", 
          "5.49206948673557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56975675278643`", ",", "0.298908418447711`", ",", 
          "0.621665257063765`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50856227857894`", ",", "2.58196345721657`", ",", 
          "2.03444633457155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44736780437145`", ",", "2.27912124817308`", ",", 
          "3.44722741207934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10298802298437`", ",", "2.04167899091649`", ",", 
          "4.86000848958712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04179354877688`", ",", "1.83048904636137`", ",", 
          "6.27278956709491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.98059907456939`", ",", "1.63072630432077`", ",", 
          "1.40238533742311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.636219293182314`", ",", "1.43336878415917`", ",", 
          "2.81516641493089`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57502481897482`", ",", "1.23037439090348`", ",", 
          "4.22794749243868`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51383034476733`", ",", "1.0112823829354`", ",", 
          "5.64072856994646`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.169450563380257`", ",", "0.755886426933111`", ",", 
          "0.770324340274665`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10825608917277`", ",", "0.390934746690069`", ",", 
          "2.18310541778245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04706161496528`", ",", "2.64362947882434`", ",", 
          "3.59588649529024`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98586714075779`", ",", "2.32083597506976`", ",", 
          "5.00866757279802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64148735937071`", ",", "2.0769059915472`", ",", 
          "0.138263343126222`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.58029288516322`", ",", "1.86281791643019`", ",", 
          "1.55104442063401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51909841095573`", ",", "1.661921727735`", ",", 
          "2.96382549814179`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17471862956865`", ",", "1.46470729651299`", ",", 
          "4.37660657564958`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11352415536116`", ",", "1.26318850290883`", ",", 
          "5.78938765315737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05232968115367`", ",", "1.04757960719544`", ",", 
          "0.918983423485565`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.707949899766595`", ",", "0.80020648603171`", ",", 
          "2.33176450099335`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6467554255591`", ",", "0.465832269089673`", ",", 
          "3.74454557850114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58556095135161`", ",", "2.7132670332612`", ",", 
          "5.15732665600892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.241181169964537`", ",", "2.36424018410214`", ",", 
          "0.286922426337122`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17998669575705`", ",", "2.11283501298234`", ",", 
          "1.69970350384491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11879222154956`", ",", "1.89546421648791`", ",", 
          "3.11248458135269`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05759774734207`", ",", "1.69320636747643`", ",", 
          "4.52526565886048`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71321796595499`", ",", "1.49594153081796`", ",", 
          "5.93804673636827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6520234917475`", ",", "1.29566389754394`", ",", 
          "1.06764250669647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.59082901754001`", ",", "1.0831318869413`", ",", 
          "2.48042358420425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24644923615293`", ",", "0.84269533359255`", ",", 
          "3.89320466171204`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18525476194544`", ",", "0.530917620981953`", ",", 
          "5.30598573921982`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12406028773795`", ",", "2.79568383183607`", ",", 
          "0.435581509548022`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.779680506350875`", ",", "2.4096510862807`", ",", 
          "1.84836258705581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71848603214338`", ",", "2.14955924998515`", ",", 
          "3.26114366456359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65729155793589`", ",", "1.92847340749165`", ",", 
          "4.67392474207138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.312911776548818`", ",", "1.72461193126023`", ",", 
          "6.08670581957917`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25171730234133`", ",", "1.52710274300912`", ",", 
          "1.21630158990737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.19052282813384`", ",", "1.32784413801234`", ",", 
          "2.62908266741515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12932835392635`", ",", "1.11802573074419`", ",", 
          "4.04186374492294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78494857253927`", ",", "0.883631366730168`", ",", 
          "5.45464482243072`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72375409833178`", ",", "0.589466119440584`", ",", 
          "0.584240592758922`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66255962412429`", ",", "2.90385363065333`", ",", 
          "1.99702167026671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31817984273721`", ",", "2.45748524128251`", ",", 
          "3.40980274777449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25698536852972`", ",", "2.18718718204406`", ",", 
          "4.82258382528228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19579089432223`", ",", "1.96189515367421`", ",", 
          "6.23536490279007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.851411112935156`", ",", "1.75617122656144`", ",", 
          "1.36496067311827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.79021663872767`", ",", "1.55822154139508`", ",", 
          "2.77774175062605`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72902216452018`", ",", "1.35976962983054`", ",", 
          "4.19052282813384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.384642383133098`", ",", "1.1523367698059`", ",", 
          "5.60330390564162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32344790892561`", ",", "0.923235419237756`", ",", 
          "0.732899675969823`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26225343471812`", ",", "0.64328047188152`", ",", 
          "2.14568075347761`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20105896051063`", ",", "0.0771963674481906`", ",", 
          "3.55846183098539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85667917912355`", ",", "2.50830912627407`", ",", 
          "4.97124290849318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79548470491606`", ",", "2.22584671879086`", ",", 
          "0.10083867882138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73429023070857`", ",", "1.99578419442757`", ",", 
          "1.51361975632917`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38991044932149`", ",", "1.78791849184486`", ",", 
          "2.92640083383695`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.328715975114`", ",", "1.58932816182631`", ",", 
          "4.33918191134474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26752150090651`", ",", "1.39147817190948`", ",", 
          "5.75196298885252`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.923141719519436`", ",", "1.1861318211088`", ",", 
          "0.881558759180723`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86194724531195`", ",", "0.961686435793567`", ",", 
          "2.29433983668851`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.80075277110446`", ",", "0.693478538338803`", ",", 
          "3.70712091419629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.456372989717379`", ",", "0.261834988585015`", ",", 
          "5.11990199170408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39517851550989`", ",", "2.56292837591757`", ",", 
          "0.24949776203228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3339840413024`", ",", "2.26569086304912`", ",", 
          "1.66227883954007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27278956709491`", ",", "2.03020141583213`", ",", 
          "3.07505991704785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92840978570783`", ",", "1.81988976612365`", ",", 
          "4.48784099455564`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86721531150034`", ",", "1.62045273371301`", ",", 
          "5.90062207206342`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80602083729285`", ",", "1.42300542770853`", ",", 
          "1.03021784239162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46164105590577`", ",", "1.21947049951043`", ",", 
          "2.44299891989941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.40044658169828`", ",", "0.9991320834693`", ",", 
          "3.85577999740719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33925210749079`", ",", "0.740810351620572`", ",", 
          "5.26856107491498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.994872326103717`", ",", "0.363068732707355`", ",", 
          "0.39815684524318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93367785189623`", ",", "2.62255941709839`", ",", 
          "1.81093792275097`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87248337768874`", ",", "2.3069056358972`", ",", 
          "3.22371900025875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.528103596301659`", ",", "2.0652151859301`", ",", 
          "4.63650007776654`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46690912209417`", ",", "1.85212330879232`", ",", 
          "6.04928115527432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40571464788668`", ",", "1.65162554344638`", ",", 
          "1.17887692560252`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0613348664996022`", ",", "1.45438533439521`", ",", 
          "2.59165800311031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.00014039229211`", ",", "1.25240649652263`", ",", 
          "4.0044390806181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93894591808462`", ",", "1.03569616778028`", ",", 
          "5.41722015812588`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87775144387713`", ",", "0.785808347572989`", ",", 
          "0.54681592845408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53337166249005`", ",", "0.442448230369646`", ",", 
          "1.95959700596187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47217718828256`", ",", "2.68920129004886`", ",", 
          "3.37237808346965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.41098271407507`", ",", "2.34972148117866`", ",", 
          "4.78515916097744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.066602932688`", ",", "2.10090304278091`", ",", 
          "6.19794023848522`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00540845848051`", ",", "1.88466008456217`", ",", 
          "1.32753600881342`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94421398427302`", ",", "1.68287730165223`", ",", 
          "2.74031708632121`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.59983420288594`", ",", "1.4856504642133`", ",", 
          "4.153098163829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53863972867845`", ",", "1.28498860926459`", ",", 
          "5.56587924133678`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47744525447096`", ",", "1.07148395794114`", ",", 
          "0.695475011664981`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.133065473083883`", ",", "0.828866937055354`", ",", 
          "2.10825608917277`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07187099887639`", ",", "0.510294039473612`", ",", 
          "3.52103716668055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0106765246689`", ",", "2.76659804409793`", ",", 
          "4.93381824418834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94948205046141`", ",", "2.39443022485158`", ",", 
          "0.0634140145165379`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60510226907434`", ",", "2.13735386133323`", ",", 
          "1.47619509202432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54390779486684`", ",", "1.91754433229294`", ",", 
          "2.88897616953211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48271332065935`", ",", "1.71423942089059`", ",", 
          "4.3017572470399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13833353927228`", ",", "1.51683234955106`", ",", 
          "5.71453832454768`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07713906506479`", ",", "1.31726157990108`", ",", 
          "0.844134094875881`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0159445908573`", ",", "1.10658610164189`", ",", 
          "2.25691517238367`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.671564809470221`", ",", "0.870288225922761`", ",", 
          "3.66969624989145`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.61037033526273`", ",", "0.570750585206809`", ",", 
          "5.08247732739924`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54917586105524`", ",", "2.86362398350507`", ",", 
          "0.212073097727438`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.204796079668163`", ",", "2.44141130610621`", ",", 
          "1.62485417523522`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14360160546067`", ",", "2.17467068123168`", ",", 
          "3.03763525274301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08240713125318`", ",", "1.95082424198375`", ",", 
          "4.4504163302508`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02121265704569`", ",", "1.74574431092414`", ",", 
          "5.86319740775858`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67683287565862`", ",", "1.5479617812442`", ",", 
          "0.992793178086781`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61563840145112`", ",", "1.34926678989575`", ",", 
          "2.40557425559457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55444392724364`", ",", "1.14108156297895`", ",", 
          "3.81835533310235`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.21006414585656`", ",", "0.910309976095666`", ",", 
          "5.23113641061014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14886967164907`", ",", "0.625978062707008`", ",", 
          "0.360732180938338`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08767519744158`", ",", "3.02085494464268`", ",", 
          "1.77351325844612`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.743295416054501`", ",", "2.49117434754878`", ",", 
          "3.18629433595391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68210094184701`", ",", "2.21297446480928`", ",", 
          "4.5990754134617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.62090646763952`", ",", "1.98455277178618`", ",", 
          "6.01185649096948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.276526686252444`", ",", "1.77742569955335`", ",", 
          "1.14145226129768`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21533221204495`", ",", "1.57906908826513`", ",", 
          "2.55423333880547`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15413773783746`", ",", "1.38104284220926`", ",", 
          "3.96701441631325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09294326362997`", ",", "1.17503986830785`", ",", 
          "5.37979549382104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7485634822429`", ",", "0.949123574090352`", ",", 
          "0.509391264149238`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68736900803541`", ",", "0.677271886847682`", ",", 
          "1.92217234165702`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62617453382792`", ",", "0.218725829888277`", ",", 
          "3.33495341916481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28179475244084`", ",", "2.54443253823424`", ",", 
          "4.7477344966726`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.22060027823335`", ",", "2.2524091937111`", ",", 
          "6.16051557418038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15940580402586`", ",", "2.01878864757795`", ",", 
          "1.29011134450858`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.815026022638781`", ",", "1.80931898833088`", ",", 
          "2.70289242201637`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75383154843129`", ",", "1.61018440601918`", ",", 
          "4.11567349952415`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6926370742238`", ",", "1.41262605661204`", ",", 
          "5.52845457703194`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.348257292836724`", ",", "1.20852285198147`", ",", 
          "0.658050347360139`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28706281862923`", ",", "0.986886053796431`", ",", 
          "2.07083142486792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22586834442174`", ",", "0.72548153354912`", ",", 
          "3.48361250237571`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16467387021425`", ",", "0.332989195582041`", ",", 
          "4.8963935798835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.82029408882718`", ",", "2.6022394289396`", ",", 
          "0.0259893502116958`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75909961461969`", ",", "2.29314894214875`", ",", 
          "1.43877042771948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6979051404122`", ",", "2.05359760283583`", ",", 
          "2.85155150522727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35352535902512`", ",", "1.84146165433612`", ",", 
          "4.26433258273505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29233088481763`", ",", "1.64133793991195`", ",", 
          "5.67711366024284`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23113641061014`", ",", "1.44405089756055`", ",", 
          "0.806709430571039`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.886756629223062`", ",", "1.24158603442169`", ",", 
          "2.21949050807882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82556215501557`", ",", "1.02372841601524`", ",", 
          "3.63227158558661`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76436768080808`", ",", "0.771200008204926`", ",", 
          "5.0450526630944`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.419987899421005`", ",", "0.417848157093739`", ",", 
          "0.174648433422596`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35879342521351`", ",", "2.66627250710173`", ",", 
          "1.58742951093038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29759895100602`", ",", "2.33540795750279`", ",", 
          "3.00021058843817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23640447679853`", ",", "2.08905393854`", ",", 
          "4.41299166594595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89202469541146`", ",", "1.87389371178409`", ",", 
          "5.82577274345374`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.83083022120397`", ",", "1.67256023062354`", ",", 
          "0.955368513781939`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76963574699648`", ",", "1.47535034994122`", ",", 
          "2.36814959128972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4252559656094`", ",", "1.27427972583763`", ",", 
          "3.78093066879751`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36406149140191`", ",", "1.05976155195758`", ",", 
          "5.1937117463053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30286701719442`", ",", "0.814860978153385`", ",", 
          "0.323307516633496`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.958487235807343`", ",", "0.488880792830425`", ",", 
          "1.73608859414128`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89729276159985`", ",", "2.73951898349314`", ",", 
          "3.14886967164907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83609828739236`", ",", "2.37945548016861`", ",", 
          "4.56165074915685`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.491718506005285`", ",", "2.12524251525274`", ",", 
          "5.97443182666464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4305240317978`", ",", "1.90665825081223`", ",", 
          "1.10402759699284`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3693295575903`", ",", "1.70388242760802`", ",", 
          "2.51680867450062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.024949776203228`", ",", "1.50655625497345`", ",", 
          "3.92958975200841`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96375530199574`", ",", "1.30664992259772`", ",", 
          "5.3423708295162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90256082778825`", ",", "1.09508056571609`", ",", 
          "0.471966599844396`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84136635358076`", ",", "0.856793240464574`", ",", 
          "1.88474767735218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49698657219368`", ",", "0.551472759037254`", ",", 
          "3.29752875485997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43579209798619`", ",", "2.82840631623535`", ",", 
          "4.71030983236775`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3745976237787`", ",", "2.42563835124318`", ",", 
          "6.12309090987554`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.03021784239162`", ",", "2.16226133828287`", ",", 
          "1.25268668020374`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96902336818413`", ",", "1.93980207570498`", ",", 
          "2.66546775771152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90782889397664`", ",", "1.73533657773496`", ",", 
          "4.07824883521931`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.563449112589566`", ",", "1.53769961638103`", ",", 
          "5.4910299127271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50225463838208`", ",", "1.33873904523138`", ",", 
          "0.620625683055297`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44106016417459`", ",", "1.12976799702267`", ",", 
          "2.03340676056308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0966803827875085`", ",", "0.897253408532321`", ",", 
          "3.44618783807087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03548590858002`", ",", "0.60825123059458`", ",", 
          "4.85896891557865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97429143437253`", ",", "2.95403168072134`", ",", 
          "6.27174999308644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91309696016504`", ",", "2.47441708357834`", ",", 
          "1.40134576341464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56871717877796`", ",", "2.2002249719782`", ",", 
          "2.81412684092243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50752270457047`", ",", "1.97337647162731`", ",", 
          "4.22690791843021`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44632823036298`", ",", "1.76695593673828`", ",", 
          "5.639688995938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1019484489759`", ",", "1.56881088538458`", ",", 
          "0.769284766266197`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.04075397476841`", ",", "1.37058655446352`", ",", 
          "2.18206584377398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97955950056092`", ",", "1.1638962704225`", ",", 
          "3.59484692128177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.635179719173846`", ",", "0.936446601015562`", ",", 
          "5.00762799878955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57398524496636`", ",", "0.660731787480328`", ",", 
          "0.137223769117754`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51279077075887`", ",", "0.164911876886167`", ",", 
          "1.55000484662554`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.168410989371789`", ",", "2.52642671658891`", ",", 
          "2.96278592413333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1072165151643`", ",", "2.2392691380636`", ",", 
          "4.37556700164111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04602204095681`", ",", "2.00743813846884`", ",", 
          "5.7883480791489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98482756674932`", ",", "1.7987753122967`", ",", 
          "0.917943849477097`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.64044778536224`", ",", "1.59992023199841`", ",", 
          "2.33072492698488`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57925331115475`", ",", "1.40222947278884`", ",", 
          "3.74350600449267`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51805883694726`", ",", "1.19752958890159`", ",", 
          "5.15628708200046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17367905556018`", ",", "0.97454011330112`", ",", 
          "0.285882852328654`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11248458135269`", ",", "0.709883022863085`", ",", 
          "1.69866392983644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0512901071452`", ",", "0.300030086185513`", ",", 
          "3.11144500734423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.706910325758127`", ",", "2.5825870943741`", ",", 
          "4.52422608485201`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64571585155064`", ",", "2.2795570468465`", ",", 
          "5.9370071623598`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58452137734315`", ",", "2.04205034390622`", ",", 
          "1.066602932688`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.24014159595607`", ",", "1.83083144924024`", ",", 
          "2.47938401019578`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17894712174858`", ",", "1.63105780944131`", ",", 
          "3.89216508770357`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11775264754109`", ",", "1.4337028327201`", ",", 
          "5.30494616521135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0565581733336`", ",", "1.23072542129896`", ",", 
          "0.434541935539554`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71217839194652`", ",", "1.01167277950537`", ",", 
          "1.84732301304734`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.65098391773903`", ",", "0.756368721274606`", ",", 
          "3.26010409055513`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58978944353154`", ",", "0.391802234980504`", ",", 
          "4.67288516806291`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24540966214446`", ",", "2.64432272029702`", ",", 
          "6.0856662455707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18421518793697`", ",", "2.32128833765294`", ",", 
          "1.2152620158989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12302071372948`", ",", "2.07728436722478`", ",", 
          "2.62804309340668`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.778640932342407`", ",", "1.86316346970801`", ",", 
          "4.04082417091447`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71744645813492`", ",", "1.66225401813786`", ",", 
          "5.45360524842226`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65625198392743`", ",", "1.46504006823802`", ",", 
          "0.583201018750455`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.31187220254035`", ",", "1.2635356880127`", ",", 
          "1.99598209625824`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.25067772833286`", ",", "1.04796157901321`", ",", 
          "3.40876317376603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18948325412537`", ",", "0.800667576874639`", ",", 
          "4.82154425127381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12828877991788`", ",", "0.466568442818955`", ",", 
          "6.2343253287816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7839089985308`", ",", "2.7140644265463`", ",", 
          "1.3639210991098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72271452432331`", ",", "2.36471208104696`", ",", 
          "2.77670217661758`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66152005011582`", ",", "2.11322133389893`", ",", 
          "4.18948325412537`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31714026872875`", ",", "1.89581338429615`", ",", 
          "5.60226433163315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25594579452125`", ",", "1.69353977576721`", ",", 
          "0.731860101961355`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19475132031377`", ",", "1.49627336262366`", ",", 
          "2.14464117946914`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.850371538926688`", ",", "1.29600771958938`", ",", 
          "3.55742225697693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7891770647192`", ",", "1.08350642025815`", ",", 
          "4.97020333448471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72798259051171`", ",", "0.843138559539636`", ",", 
          "0.099799104812912`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.383602809124631`", ",", "0.531570803902248`", ",", 
          "1.5125801823207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32240833491714`", ",", "2.79666113383693`", ",", 
          "2.92536125982848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26121386070965`", ",", "2.41014635848265`", ",", 
          "4.33814233733627`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.20001938650216`", ",", "2.14995458344647`", ",", 
          "5.75092341484406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85563960511508`", ",", "1.92882669465632`", ",", 
          "0.880519185172255`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79444513090759`", ",", "1.72494680010814`", ",", 
          "2.29330026268004`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7332506567001`", ",", "1.5274339634245`", ",", 
          "3.70608134018783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38887087531303`", ",", "1.32818504240426`", ",", 
          "5.11886241769561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32767640110553`", ",", "1.11839368325699`", ",", 
          "0.248458188023812`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26648192689805`", ",", "0.884059346368593`", ",", 
          "1.6612392655316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.922102145510968`", ",", "0.590061099237298`", ",", 
          "3.07402034303938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.86090767130348`", ",", "2.9052628176162`", ",", 
          "4.48680142054717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79971319709599`", ",", "2.45800901134563`", ",", 
          "5.89958249805496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.455333415708911`", ",", "2.18759277804189`", ",", 
          "1.02917826838316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39413894150142`", ",", "1.96225311411653`", ",", 
          "2.44195934589094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33294446729393`", ",", "1.75650791205723`", ",", 
          "3.85474042339873`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27174999308644`", ",", "1.5585524735609`", ",", 
          "5.26752150090651`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92737021169936`", ",", "1.36010803150383`", ",", 
          "0.397117271234712`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86617573749187`", ",", "1.15269889551252`", ",", 
          "1.8098983487425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80498126328438`", ",", "0.923650254248363`", ",", 
          "3.22267942625028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.46060148189731`", ",", "0.643831942516334`", ",", 
          "4.63546050375807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39940700768982`", ",", "0.0813743625780888`", ",", 
          "6.04824158126586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33821253348233`", ",", "2.50886849725231`", ",", 
          "1.17783735159406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.993832752095249`", ",", "2.22626406123288`", ",", 
          "2.59061842910184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93263827788776`", ",", "1.99614744141623`", ",", 
          "4.00339950660963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.87144380368027`", ",", "1.78825736721149`", ",", 
          "5.41618058411741`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.527064022293192`", ",", "1.58965912636134`", ",", 
          "0.545776354445613`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4658695480857`", ",", "1.39181446072615`", ",", 
          "1.9585574319534`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40467507387821`", ",", "1.18648878958514`", ",", 
          "3.37133850946118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0602952924911344`", ",", "0.962089846230055`", ",", 
          "4.78411958696897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99910081828364`", ",", "0.693996052995031`", ",", 
          "6.19690066447676`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93790634407615`", ",", "0.263110309780521`", ",", 
          "1.32649643480496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87671186986866`", ",", "2.56353370844129`", ",", 
          "2.73927751231274`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53233208848159`", ",", "2.26612174051673`", ",", 
          "4.15205858982053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4711376142741`", ",", "2.03057063466785`", ",", 
          "5.56483966732831`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40994314006661`", ",", "1.82023122589463`", ",", 
          "0.694435437656513`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06556335867953`", ",", "1.62078405151865`", ",", 
          "2.1072165151643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00436888447204`", ",", "1.42333997310869`", ",", 
          "3.51999759267208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94317441026455`", ",", "1.21982291109513`", ",", 
          "4.93277867017987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.598794628877472`", ",", "0.999525500998677`", ",", 
          "0.06237444050807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53760015466998`", ",", "0.741300535133142`", ",", 
          "1.47515551801586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47640568046249`", ",", "0.363999345061264`", ",", 
          "2.88793659552364`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.132025899075415`", ",", "2.6232269026195`", ",", 
          "4.30071767303143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.07083142486792`", ",", "2.3073522419206`", ",", 
          "5.71349875053921`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00963695066043`", ",", "2.06559114986156`", ",", 
          "0.843094520867413`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94844247645294`", ",", "1.85246777359857`", ",", 
          "2.2558755983752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60406269506587`", ",", "1.65195753851816`", ",", 
          "3.66865667588298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54286822085838`", ",", "1.45471848947047`", ",", 
          "5.08143775339077`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48167374665089`", ",", "1.25275489445382`", ",", 
          "0.21103352371897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13729396526381`", ",", "1.03608080184004`", ",", 
          "1.62381460122676`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07609949105632`", ",", "0.786276019205218`", ",", 
          "3.03659567873454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01490501684883`", ",", "0.443220470846784`", ",", 
          "4.44937675624233`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.670525235461753`", ",", "2.68995890046012`", ",", 
          "5.86215783375011`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60933076125426`", ",", "2.35018656066419`", ",", 
          "0.991753604078313`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54813628704677`", ",", "2.1012866332718`", ",", 
          "2.4045346815861`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.203756505659695`", ",", "1.88500800670436`", ",", 
          "3.81731575909388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14256203145221`", ",", "1.68321030396701`", ",", 
          "5.23009683660167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08136755724471`", ",", "1.48598256933755`", ",", 
          "0.35969260692987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.02017308303722`", ",", "1.28533348951682`", ",", 
          "1.77247368443766`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67579330165015`", ",", "1.07186084386716`", ",", 
          "3.18525476194544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61459882744266`", ",", "0.829315734945586`", ",", 
          "4.59803583945323`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55340435323517`", ",", "0.510971115187469`", ",", 
          "6.01081691696101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20902457184809`", ",", "2.76750253971447`", ",", 
          "1.14041268728921`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1478300976406`", ",", "2.39491729562741`", ",", 
          "2.553193764797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08663562343311`", ",", "2.1377460942804`", ",", 
          "3.96597484230479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.742255842046033`", ",", "1.91789620232546`", ",", 
          "5.37875591981257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68106136783854`", ",", "1.71457376944202`", ",", 
          "0.508351690140771`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61986689363105`", ",", "1.51716373567928`", ",", 
          "1.92113276764856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.275487112243976`", ",", "1.31760339926777`", ",", 
          "3.33391384515634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21429263803649`", ",", "1.10695613645289`", ",", 
          "4.74669492266413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.153098163829`", ",", "0.870720979287446`", ",", 
          "6.15947600017191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09190368962151`", ",", "0.571362784292919`", ",", 
          "1.28907177050011`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74752390823443`", ",", "2.86483245830981`", ",", 
          "2.7018528480079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68632943402694`", ",", "2.44192500878937`", ",", 
          "4.11463392551569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62513495981945`", ",", "2.17507274147073`", ",", 
          "5.52741500302347`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.28075517843237`", ",", "1.95118059660474`", ",", 
          "0.657010773351671`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21956070422488`", ",", "1.74608035698608`", ",", 
          "2.06979185085946`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15836623001739`", ",", "1.54829277297236`", ",", 
          "3.48257292836724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.813986448630314`", ",", "1.34960597272178`", ",", 
          "4.89535400587503`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75279197442282`", ",", "1.14144553250338`", ",", 
          "0.024949776203228`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69159750021533`", ",", "0.910728939481048`", ",", 
          "1.43773085371101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.347217718828256`", ",", "0.626542635332374`", ",", 
          "2.8505119312188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28602324462077`", ",", "3.02363415655279`", ",", 
          "4.26329300872659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22482877041328`", ",", "2.4917210280412`", ",", 
          "5.67607408623437`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16363429620579`", ",", "2.21338775240214`", ",", 
          "0.805669856562571`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81925451481871`", ",", "1.98491420342353`", ",", 
          "2.21845093407036`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75806004061122`", ",", "1.77776381026252`", ",", 
          "3.63123201157814`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69686556640373`", ",", "1.57940000673217`", ",", 
          "5.04401308908593`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35248578501665`", ",", "1.38137978607863`", ",", 
          "0.173608859414128`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29129131080916`", ",", "1.17539846810913`", ",", 
          "1.58638993692191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.23009683660167`", ",", "0.949530581423571`", ",", 
          "2.9991710144297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.885717055214594`", ",", "0.677799753915402`", ",", 
          "4.41195209193749`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8245225810071`", ",", "0.220245648784688`", ",", 
          "5.82473316944527`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76332810679961`", ",", "2.54502128476547`", ",", 
          "0.954328939773471`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.418948325412537`", ",", "2.25283538738621`", ",", 
          "2.36711001728126`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35775385120505`", ",", "2.01915581619581`", ",", 
          "3.77989109478904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29655937699756`", ",", "1.80965955069685`", ",", 
          "5.19267217229683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23536490279007`", ",", "1.61051557172432`", ",", 
          "0.322267942625028`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.89098512140299`", ",", "1.41296113722432`", ",", 
          "1.73504902013281`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8297906471955`", ",", "1.20887670375886`", ",", 
          "3.1478300976406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76859617298801`", ",", "0.98728262344017`", ",", 
          "4.56061117514839`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42421639160093`", ",", "0.725980125559515`", ",", 
          "5.97339225265617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36302191739344`", ",", "0.334000069620198`", ",", 
          "1.10298802298437`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30182744318595`", ",", "2.60288408852073`", ",", 
          "2.51576910049216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.957447661798875`", ",", "2.29359008840962`", ",", 
          "3.92855017799994`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89625318759138`", ",", "2.05397125067943`", ",", 
          "5.34133125550773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83505871338389`", ",", "1.84180507980996`", ",", 
          "0.470927025835929`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.490678931996818`", ",", "1.64166967551636`", ",", 
          "1.88370810334371`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42948445778933`", ",", "1.44438447297841`", ",", 
          "3.2964891808515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36828998358184`", ",", "1.24193569905734`", ",", 
          "4.70927025835929`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0239102021947602`", ",", "1.02411582463443`", ",", 
          "6.12205133586707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96271572798727`", ",", "0.77167465341175`", ",", 
          "1.25164710619527`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90152125377978`", ",", "0.418662863179811`", ",", 
          "2.66442818370306`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.84032677957229`", ",", "2.66699611453128`", ",", 
          "4.07720926121084`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49594699818521`", ",", "2.33586659940057`", ",", 
          "5.48999033871863`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43475252397772`", ",", "2.08943490881857`", ",", 
          "0.619586109046829`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37355804977023`", ",", "1.87424044154941`", ",", 
          "2.03236718655461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02917826838316`", ",", "1.67289286380487`", ",", 
          "3.4451482640624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96798379417566`", ",", "1.47568276435391`", ",", 
          "4.85792934157019`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90678931996817`", ",", "1.27462571392326`", ",", 
          "6.27071041907797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.562409538581098`", ",", "1.06014088783555`", ",", 
          "1.40030618940617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50121506437361`", ",", "0.815315653855258`", ",", 
          "2.81308726691396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.44002059016612`", ",", "0.489584926211088`", ",", 
          "4.22586834442174`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0956408087790407`", ",", "2.74036542644646`", ",", 
          "5.63864942192953`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03444633457155`", ",", "2.37993484973265`", ",", 
          "0.768245192257729`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97325186036406`", ",", "2.12563177617956`", ",", 
          "2.18102626976551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.91205738615657`", ",", "1.90700876200679`", ",", 
          "3.5938073472733`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56767760476949`", ",", "1.70421629403856`", ",", 
          "5.00658842478109`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.506483130562`", ",", "1.50688784209408`", ",", 
          "0.136184195109286`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44528865635451`", ",", "1.30699270304506`", ",", 
          "1.54896527261707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.10090887496744`", ",", "1.09545276812437`", ",", 
          "2.96174635012486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03971440075995`", ",", "0.857231011545496`", ",", 
          "4.37452742763264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97851992655246`", ",", "0.552104006129438`", ",", 
          "5.78730850514043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.634140145165379`", ",", "2.8294821566013`", ",", 
          "0.916904275468629`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57294567095789`", ",", "2.42614266882213`", ",", 
          "2.32968535297642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5117511967504`", ",", "2.16266001452948`", ",", 
          "3.7424664304842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.167371415363321`", ",", "1.94015688884224`", ",", 
          "5.15524750799199`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10617694115583`", ",", "1.73567202426044`", ",", 
          "0.284843278320186`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04498246694834`", ",", "1.53803070257579`", ",", 
          "1.69762435582797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98378799274085`", ",", "1.33907905241203`", ",", 
          "3.11040543333576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63940821135377`", ",", "1.13013388588284`", ",", 
          "4.52318651084354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57821373714628`", ",", "0.89767669891883`", ",", 
          "5.93596758835133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51701926293879`", ",", "0.608830072032401`", ",", 
          "1.06556335867953`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17263948155172`", ",", "2.95581470584333`", ",", 
          "2.47834443618732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11144500734423`", ",", "2.47495204695713`", ",", 
          "3.8911255136951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.05025053313674`", ",", "2.20063438659397`", ",", 
          "5.30390659120289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.705870751749659`", ",", "1.97373615957272`", ",", 
          "0.433502361531087`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64467627754217`", ",", "1.76729332484425`", ",", 
          "1.84628343903887`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58348180333468`", ",", "1.56914179261845`", ",", 
          "3.25906451654666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.239102021947602`", ",", "1.37092419421237`", ",", 
          "4.67184559405444`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17790754774011`", ",", "1.16425656905996`", ",", 
          "6.08462667156223`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11671307353262`", ",", "0.93685736979606`", ",", 
          "1.21422244189043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05551859932513`", ",", "0.661270804605327`", ",", 
          "2.62700351939822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71113881793805`", ",", "0.166915507745656`", ",", 
          "4.039784596906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64994434373056`", ",", "2.5270003511128`", ",", 
          "5.45256567441379`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58874986952307`", ",", "2.23969086950674`", ",", 
          "0.582161444741987`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.244370088136`", ",", "2.00780333744569`", ",", 
          "1.99494252224977`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18317561392851`", ",", "1.7991150219644`", ",", 
          "3.40772359975756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12198113972102`", ",", "1.60025128067256`", ",", 
          "4.82050467726535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.77760135833394`", ",", "1.40256512752573`", ",", 
          "6.23328575477313`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71640688412645`", ",", "1.19788494178859`", ",", 
          "1.36288152510133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65521240991896`", ",", "0.97493997348481`", ",", 
          "2.77566260260912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.310832628531882`", ",", "0.710390597100716`", ",", 
          "4.1884436801169`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24963815432439`", ",", "0.301147701799891`", ",", 
          "5.60122475762469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1884436801169`", ",", "2.58321135386765`", ",", 
          "0.730820527952887`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12724920590941`", ",", "2.27999300841409`", ",", 
          "2.14360160546067`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78286942452233`", ",", "2.04242176717699`", ",", 
          "3.55638268296846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72167495031484`", ",", "1.83117388331466`", ",", 
          "4.96916376047624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.66048047610735`", ",", "1.63138932119247`", ",", 
          "0.0987595308044442`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31610069472028`", ",", "1.43403686588712`", ",", 
          "1.51154060831223`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25490622051279`", ",", "1.23107640810174`", ",", 
          "2.92432168582002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1937117463053`", ",", "1.01206308073154`", ",", 
          "4.3371027633278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.84933196491822`", ",", "0.756850769221418`", ",", 
          "5.74988384083559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78813749071073`", ",", "0.392667905681603`", ",", 
          "0.879479611163787`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72694301650324`", ",", "2.6450168483425`", ",", 
          "2.29226068867157`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.382563235116163`", ",", "2.32174089113919`", ",", 
          "3.70504176617936`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.32136876090867`", ",", "2.07766282234256`", ",", 
          "5.11782284368714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.26017428670118`", ",", "1.86350905893021`", ",", 
          "0.247418614015344`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19897981249369`", ",", "1.66258631866775`", ",", 
          "1.66019969152313`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85460003110662`", ",", "1.46537282820848`", ",", 
          "3.07298076903092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79340555689912`", ",", "1.26388283487306`", ",", 
          "4.4857618465387`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73221108269163`", ",", "1.04834346676121`", ",", 
          "5.89854292404649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38783130130456`", ",", "0.801128461600483`", ",", 
          "1.02813869437469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32663682709707`", ",", "0.467303542082642`", ",", 
          "2.44091977188247`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26544235288958`", ",", "2.71486321778169`", ",", 
          "3.85370084939026`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.921062571502501`", ",", "2.36518420461352`", ",", 
          "5.26648192689805`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85986809729501`", ",", "2.11360774479035`", ",", 
          "0.396077697226245`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79867362308752`", ",", "1.89616259319158`", ",", 
          "1.80885877473403`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.454293841700443`", ",", "1.69387319777179`", ",", 
          "3.22163985224182`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39309936749295`", ",", "1.49660518620845`", ",", 
          "4.6344209297496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33190489328546`", ",", "1.29635150831123`", ",", 
          "6.04720200725739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.27071041907797`", ",", "1.08388087925623`", ",", 
          "1.17679777758559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9263306376909`", ",", "0.843581610576782`", ",", 
          "2.58957885509337`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8651361634834`", ",", "0.532223262071114`", ",", 
          "4.00235993260116`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80394168927591`", ",", "2.79764110141238`", ",", 
          "5.41514101010895`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45956190788884`", ",", "2.41064190413649`", ",", 
          "0.544736780437145`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39836743368135`", ",", "2.15035001914164`", ",", 
          "1.95751785794493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33717295947386`", ",", "1.92918002852624`", ",", 
          "3.37029893545272`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.992793178086781`", ",", "1.72528168638118`", ",", 
          "4.7830800129605`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93159870387929`", ",", "1.52776517907981`", ",", 
          "6.19586109046829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8704042296718`", ",", "1.32852591803681`", ",", 
          "1.32545686079649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.526024448284724`", ",", "1.11876156997952`", ",", 
          "2.73823793830427`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46482997407723`", ",", "0.884487175887793`", ",", 
          "4.15101901581206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40363549986974`", ",", "0.590655550862588`", ",", 
          "5.56380009331985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0592557184826665`", ",", "2.90668029893791`", ",", 
          "0.693395863648045`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99806124427518`", ",", "2.45853311839591`", ",", 
          "2.10617694115583`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93686677006769`", ",", "2.18799849072332`", ",", 
          "3.51895801866362`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8756722958602`", ",", "1.96261112745582`", ",", 
          "4.9317390961714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53129251447312`", ",", "1.7568446188515`", ",", 
          "0.0613348664996022`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.47009804026563`", ",", "1.55888340438576`", ",", 
          "1.47411594400739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40890356605814`", ",", "1.36044640868832`", ",", 
          "2.88689702151517`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06452378467106`", ",", "1.1530609629662`", ",", 
          "4.29967809902296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00332931046357`", ",", "0.92406495925087`", ",", 
          "5.71245917653075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94213483625608`", ",", "0.644383008234724`", ",", 
          "0.842054946858945`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.597755054869004`", ",", "0.0853485079889177`", ",", 
          "2.25483602436673`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53656058066151`", ",", "2.50942829525478`", ",", 
          "3.66761710187452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47536610645402`", ",", "2.22668153763527`", ",", 
          "5.0803981793823`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.130986325066947`", ",", "1.99651074818817`", ",", 
          "0.209993949710502`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06979185085946`", ",", "1.78859626795374`", ",", 
          "1.62277502721829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00859737665197`", ",", "1.58999009296281`", ",", 
          "3.03555610472607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94740290244448`", ",", "1.39215072908402`", ",", 
          "4.44833718223386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6030231210574`", ",", "1.18684570653559`", ",", 
          "5.86111825974165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54182864684991`", ",", "0.962493143269429`", ",", 
          "0.990714030069845`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.48063417264242`", ",", "0.69451324598006`", ",", 
          "2.40349510757763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13625439125534`", ",", "0.264379621062114`", ",", 
          "3.81627618508542`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07505991704785`", ",", "2.56413960314966`", ",", 
          "5.2290572625932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01386544284036`", ",", "2.26655277293768`", ",", 
          "0.358653032921403`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.669485661453285`", ",", "2.03093992101844`", ",", 
          "1.77143411042919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60829118724579`", ",", "1.82057271536955`", ",", 
          "3.18421518793697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5470967130383`", ",", "1.62111537481619`", ",", 
          "4.59699626544476`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.202716931651228`", ",", "1.42367450188561`", ",", 
          "6.00977734295255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14152245744374`", ",", "1.22017527721431`", ",", 
          "1.13937311328075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.08032798323625`", ",", "0.999918819068048`", ",", 
          "2.55215419078853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01913350902876`", ",", "0.741790456322034`", ",", 
          "3.96493526829632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67475372764168`", ",", "0.36492768973291`", ",", 
          "5.3777163458041`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61355925343419`", ",", "2.62389517016042`", ",", 
          "0.507312116132303`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5523647792267`", ",", "2.30779902888361`", ",", 
          "1.92009319364009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20798499783962`", ",", "2.06596719007512`", ",", 
          "3.33287427114787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14679052363213`", ",", "1.85281227274311`", ",", 
          "4.74565534865566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08559604942464`", ",", "1.65228954255552`", ",", 
          "6.15843642616345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.741216268037565`", ",", "1.4550516316043`", ",", 
          "1.28803219649165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.68002179383007`", ",", "1.25310325242884`", ",", 
          "2.70081327399943`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61882731962259`", ",", "1.0364653482975`", ",", 
          "4.11359435150722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.274447538235508`", ",", "0.786743472606197`", ",", 
          "5.526375429015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21325306402802`", ",", "0.443991457138691`", ",", 
          "0.655971199343203`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15205858982053`", ",", "2.69071769599992`", ",", 
          "2.06875227685099`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.09086411561304`", ",", "2.35065185396341`", ",", 
          "3.48153335435877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74648433422596`", ",", "2.10167031009187`", ",", 
          "4.89431443186656`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68528986001847`", ",", "1.88535596818948`", ",", 
          "0.0239102021947602`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62409538581098`", ",", "1.68354331880068`", ",", 
          "1.43669127970255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2797156044239`", ",", "1.48631466508513`", ",", 
          "2.84947235721033`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21852113021641`", ",", "1.28567833486558`", ",", 
          "4.26225343471812`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15732665600892`", ",", "1.07223765240684`", ",", 
          "5.6750345122259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.812946874621846`", ",", "0.829764348449896`", ",", 
          "0.804630282554103`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75175240041436`", ",", "0.511647374185495`", ",", 
          "2.21741136006189`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.69055792620687`", ",", "2.76840912410844`", ",", 
          "3.63019243756967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.346178144819789`", ",", "2.39540462289934`", ",", 
          "5.04297351507746`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2849836706123`", ",", "2.13813842520216`", ",", 
          "0.17256928540566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22378919640481`", ",", "1.9182481171523`", ",", 
          "1.58535036291345`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16259472219732`", ",", "1.71490813417865`", ",", 
          "2.99813144042123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81821494081024`", ",", "1.51749511591219`", ",", 
          "4.41091251792902`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75702046660275`", ",", "1.31794518840514`", ",", 
          "5.8236935954368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69582599239526`", ",", "1.10732610278071`", ",", 
          "0.953289365765004`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35144621100818`", ",", "0.871153574945522`", ",", 
          "2.36607044327279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.29025173680069`", ",", "0.571974400962593`", ",", 
          "3.77885152078057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2290572625932`", ",", "2.86604609652252`", ",", 
          "5.19163259828836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.884677481206126`", ",", "2.44243902517727`", ",", 
          "0.321228368616561`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82348300699864`", ",", "2.17547491335101`", ",", 
          "1.73400944612435`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76228853279115`", ",", "1.95153700201043`", ",", 
          "3.14679052363213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.417908751404069`", ",", "1.74641642304875`", ",", 
          "4.55957160113992`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35671427719658`", ",", "1.54862376223474`", ",", 
          "5.9723526786477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29551980298909`", ",", "1.34994512967965`", ",", 
          "1.1019484489759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2343253287816`", ",", "1.14180944138669`", ",", 
          "2.51472952648369`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88994554739452`", ",", "0.911147766661812`", ",", 
          "3.92751060399148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82875107318703`", ",", "0.627106767947261`", ",", 
          "5.34029168149926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76755659897954`", ",", "3.0264801299801`", ",", 
          "0.469887451827461`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42317681759246`", ",", "2.49226810205214`", ",", 
          "1.88266852933525`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36198234338497`", ",", "2.21380116789694`", ",", 
          "3.29544960684303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.30078786917748`", ",", "1.98527569248781`", ",", 
          "4.70823068435082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.956408087790407`", ",", "1.7781019449774`", ",", 
          "6.1210117618586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89521361358292`", ",", "1.5797309261414`", ",", 
          "1.2506075321868`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83401913937543`", ",", "1.38171670818379`", ",", 
          "2.66338860969459`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.48963935798835`", ",", "1.17575701424608`", ",", 
          "4.07616968720238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42844488378086`", ",", "0.94993747021191`", ",", 
          "5.48895076471016`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36725040957337`", ",", "0.678327275081021`", ",", 
          "0.618546535038361`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0228706281862923`", ",", "0.221755219531102`", ",", 
          "2.03132761254615`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9616761539788`", ",", "2.54561054214292`", ",", 
          "3.44410869005393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.90048167977131`", ",", "2.2532617286121`", ",", 
          "4.85688976756172`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83928720556382`", ",", "2.01952304967457`", ",", 
          "6.26967084506951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49490742417674`", ",", "1.81000014130836`", ",", 
          "1.3992666153977`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43371294996925`", ",", "1.61084674178784`", ",", 
          "2.81204769290549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37251847576176`", ",", "1.41329619996734`", ",", 
          "4.22482877041328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02813869437469`", ",", "1.20923050813817`", ",", 
          "5.63760984792106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9669442201672`", ",", "0.987679089282769`", ",", 
          "0.767205618249261`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90574974595971`", ",", "0.726478437685544`", ",", 
          "2.17998669575705`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.56136996457263`", ",", "0.335008007342329`", ",", 
          "3.59276777326483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.50017549036514`", ",", "2.60352944419032`", ",", 
          "5.00554885077262`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43898101615765`", ",", "2.29403140638784`", ",", 
          "0.135144621100818`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0946012347705729`", ",", "2.05434497178563`", ",", 
          "1.5479256986086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03340676056308`", ",", "1.84214853805619`", ",", 
          "2.96070677611639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97221228635559`", ",", "1.64200141893354`", ",", 
          "4.37348785362418`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9110178121481`", ",", "1.4447180342553`", ",", 
          "5.78626893113196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56663803076103`", ",", "1.24228532197463`", ",", 
          "0.915864701460161`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50544355655354`", ",", "1.02450314194107`", ",", 
          "2.32864577896795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44424908234604`", ",", "0.77214906717344`", ",", 
          "3.74142685647573`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09986930095897`", ",", "0.419476080323511`", ",", 
          "5.15420793398352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03867482675148`", ",", "2.66772074256339`", ",", 
          "0.283803704311719`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97748035254399`", ",", "2.33632544335695`", ",", 
          "1.6965847818195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.633100571156911`", ",", "2.08981596195368`", ",", 
          "3.10936585932729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57190609694942`", ",", "1.87458720896187`", ",", 
          "4.52214693683508`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.51071162274193`", ",", "1.67322550832247`", ",", 
          "5.93492801434286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.166331841354853`", ",", "1.47601516822515`", ",", 
          "1.06452378467106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10513736714736`", ",", "1.27497166548447`", ",", 
          "2.47730486217885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04394289293987`", ",", "1.06052014311746`", ",", 
          "3.89008593968663`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98274841873238`", ",", "0.815770134924299`", ",", 
          "5.30286701719442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63836863734531`", ",", "0.490288130352186`", ",", 
          "0.432462787522619`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57717416313781`", ",", "2.74121356159926`", ",", 
          "1.8452438650304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51597968893033`", ",", "2.38041446039143`", ",", 
          "3.25802494253819`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17159990754325`", ",", "2.12602113104036`", ",", 
          "4.67080602004598`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.11040543333576`", ",", "1.9073593161432`", ",", 
          "6.08358709755376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04921095912827`", ",", "1.70455017543056`", ",", 
          "1.21318286788196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.704831177741191`", ",", "1.50721942217854`", ",", 
          "2.62596394538975`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6436367035337`", ",", "1.30733545175918`", ",", 
          "4.03874502289753`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58244222932621`", ",", "1.09582489924163`", ",", 
          "5.45152610040532`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.238062447939134`", ",", "0.857668616774434`", ",", 
          "0.581121870733519`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17686797373164`", ",", "0.552734607015843`", ",", 
          "1.9939029482413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11567349952415`", ",", "2.83056159619128`", ",", 
          "3.40668402574909`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05447902531666`", ",", "2.42664727923124`", ",", 
          "4.81946510325688`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.71009924392959`", ",", "2.16305879765531`", ",", 
          "6.23224618076466`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6489047697221`", ",", "1.94051175072262`", ",", 
          "1.36184195109286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58771029551461`", ",", "1.73600748950946`", ",", 
          "2.77462302860065`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24333051412753`", ",", "1.53836178517761`", ",", 
          "4.18740410610843`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18213603992004`", ",", "1.33941903231725`", ",", 
          "5.60018518361622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.12094156571255`", ",", "1.13049971161994`", ",", 
          "0.729780953944419`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.776561784325472`", ",", "0.898099846489521`", ",", 
          "2.14256203145221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71536731011798`", ",", "0.609408433278357`", ",", 
          "3.55534310895999`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65417283591049`", ",", "2.95761480924428`", ",", 
          "4.96812418646778`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.309793054523414`", ",", "2.47548737431708`", ",", 
          "0.0977199567959764`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24859858031592`", ",", "2.2010439234191`", ",", 
          "1.51050103430376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18740410610843`", ",", "1.97409590267454`", ",", 
          "2.92328211181155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12620963190094`", ",", "1.76763073561154`", ",", 
          "4.33606318931933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.78182985051387`", ",", "1.56947269967114`", ",", 
          "5.74884426682712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.72063537630638`", ",", "1.37126181086891`", ",", 
          "0.878440037155319`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65944090209889`", ",", "1.16461681181763`", ",", 
          "2.29122111466311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31506112071181`", ",", "0.937268014568859`", ",", 
          "3.70400219217089`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25386664650432`", ",", "0.661809448613328`", ",", 
          "5.11678326967868`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19267217229683`", ",", "0.168895589440062`", ",", 
          "0.246379040006877`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.848292390909752`", ",", "2.52757445224953`", ",", 
          "1.65916011751466`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78709791670226`", ",", "2.24011274158531`", ",", 
          "3.07194119502245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72590344249477`", ",", "2.00816859873435`", ",", 
          "4.48472227253023`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.381523661107695`", ",", "1.7994547584504`", ",", 
          "5.89750335003802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3203291869002`", ",", "1.60058233257574`", ",", 
          "1.02709912036622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25913471269271`", ",", "1.40290076312924`", ",", 
          "2.43988019787401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19794023848522`", ",", "1.19824024528134`", ",", 
          "3.85266127538179`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85356045709815`", ",", "0.975339725282359`", ",", 
          "5.26544235288958`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79236598289066`", ",", "0.710897872015703`", ",", 
          "0.395038123217777`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.73117150868317`", ",", "0.302261310273093`", ",", 
          "1.80781920072556`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38679172729609`", ",", "2.58383623780805`", ",", 
          "3.22060027823335`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3255972530886`", ",", "2.28042913314161`", ",", 
          "4.63338135574113`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26440277888111`", ",", "2.04279326081999`", ",", 
          "6.04616243324892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.920022997494033`", ",", "1.83151634863332`", ",", 
          "1.17575820357712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85882852328654`", ",", "1.63172083961111`", ",", 
          "2.58853928108491`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79763404907905`", ",", "1.43437088369963`", ",", 
          "4.00132035859269`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.453254267691975`", ",", "1.23142735137127`", ",", 
          "5.41410143610048`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39205979348449`", ",", "1.01245328674316`", ",", 
          "0.543697206428677`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.33086531927699`", ",", "0.757332571262637`", ",", 
          "1.95647828393646`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26967084506951`", ",", "0.393531770815201`", ",", 
          "3.36925936144425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92529106368243`", ",", "2.6457118667067`", ",", 
          "4.78204043895203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86409658947494`", ",", "2.32219363586321`", ",", 
          "6.19482151645982`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80290211526745`", ",", "2.07804135700485`", ",", 
          "1.32441728678802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45852233388037`", ",", "1.86385468414929`", ",", 
          "2.73719836429581`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39732785967288`", ",", "1.66291862936231`", ",", 
          "4.14997944180359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33613338546539`", ",", "1.46570557646246`", ",", 
          "5.56276051931138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.991753604078313`", ",", "1.26422994354437`", ",", 
          "0.692356289639577`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.93055912987082`", ",", "1.0487252705506`", ",", 
          "2.10513736714736`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86936465566333`", ",", "0.801589140583181`", ",", 
          "3.51791844465515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.524984874276256`", ",", "0.468037571967176`", ",", 
          "4.93069952216294`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46379040006877`", ",", "2.71566341485807`", ",", 
          "0.0602952924911344`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40259592586128`", ",", "2.36565655523403`", ",", 
          "1.47307636999892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0582161444741987`", ",", "2.11399424577722`", ",", 
          "2.88585744750671`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99702167026671`", ",", "1.89651184323133`", ",", 
          "4.29863852501449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93582719605922`", ",", "1.69420663352892`", ",", 
          "5.71141960252228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87463272185173`", ",", "1.49693700160946`", ",", 
          "0.841015372850477`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.53025294046465`", ",", "1.29669526375978`", ",", 
          "2.25379645035826`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46905846625716`", ",", "1.08425526403224`", ",", 
          "3.66657752786605`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40786399204967`", ",", "0.844024486997766`", ",", 
          "5.07935860537383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06348421066259`", ",", "0.532874998172527`", ",", 
          "0.208954375702035`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0022897364551`", ",", "2.79862375744194`", ",", 
          "1.62173545320982`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94109526224761`", ",", "2.41113772381756`", ",", 
          "3.03451653071761`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.596715480860537`", ",", "2.15074555721189`", ",", 
          "4.44729760822539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53552100665305`", ",", "1.92953340916406`", ",", 
          "5.86007868573318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47432653244556`", ",", "1.72561659011964`", ",", 
          "0.989674456061378`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.129946751058479`", ",", "1.52809639001159`", ",", 
          "2.40245553356916`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06875227685099`", ",", "1.32886676495686`", ",", 
          "3.81523661107695`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0075578026435`", ",", "1.11912939099682`", ",", 
          "5.22801768858474`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94636332843601`", ",", "0.884914855523854`", ",", 
          "0.357613458912935`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60198354704893`", ",", "0.59124947593006`", ",", 
          "1.77039453642072`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.54078907284144`", ",", "2.90810622572488`", ",", 
          "3.18317561392851`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47959459863395`", ",", "2.45905756322887`", ",", 
          "4.59595669143629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13521481724687`", ",", "2.18840432025596`", ",", 
          "6.00873776894408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07402034303938`", ",", "1.96296919376142`", ",", 
          "1.13833353927228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01282586883189`", ",", "1.75718134698648`", ",", 
          "2.55111461678006`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.668446087444817`", ",", "1.55921433390591`", ",", 
          "3.96389569428785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60725161323733`", ",", "1.36078476142806`", ",", 
          "5.37667677179564`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54605713902984`", ",", "1.15342297224249`", ",", 
          "0.506272542123835`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.20167735764276`", ",", "0.924479534438687`", ",", 
          "1.91905361963162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.14048288343527`", ",", "0.644933670094287`", ",", 
          "3.33183469713941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07928840922778`", ",", "0.0891460709142008`", ",", 
          "4.74461577464719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01809393502029`", ",", "2.50998852143676`", ",", 
          "6.15739685215498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67371415363321`", ",", "2.22709914819996`", ",", 
          "1.28699262248318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61251967942572`", ",", "1.9968741148209`", ",", 
          "2.69977369999096`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55132520521823`", ",", "1.78893519411622`", ",", 
          "4.11255477749875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20694542383115`", ",", "1.59032106166702`", ",", 
          "5.52533585500654`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14575094962366`", ",", "1.39248697702486`", ",", 
          "0.654931625334735`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08455647541617`", ",", "1.18720257202791`", ",", 
          "2.06771270284252`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.740176694029097`", ",", "0.9628963270728`", ",", 
          "3.48049378035031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67898221982161`", ",", "0.695030118031053`", ",", 
          "4.89327485785809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61778774561412`", ",", "0.265643008618639`", ",", 
          "0.0228706281862923`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.27340796422704`", ",", "2.56474606183499`", ",", 
          "1.43565170569408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21221349001955`", ",", "2.26698396055945`", ",", 
          "2.84843278320186`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.15101901581206`", ",", "2.03130927497133`", ",", 
          "4.26121386070965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08982454160457`", ",", "1.82091423459601`", ",", 
          "5.67399493821744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74544476021749`", ",", "1.62144670364226`", ",", 
          "0.803590708545635`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68425028601`", ",", "1.42400901407919`", ",", 
          "2.21637178605342`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62305581180251`", ",", "1.22052759792931`", ",", 
          "3.62915286356121`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27867603041544`", ",", "1.00031203781361`", ",", 
          "5.04193394106899`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21748155620795`", ",", "0.742280115725352`", ",", 
          "0.171529711397193`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15628708200046`", ",", "0.36585378401363`", ",", 
          "1.58431078890498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.811907300613378`", ",", "2.62456422277571`", ",", 
          "2.99709186641276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.75071282640589`", ",", "2.30824599709564`", ",", 
          "4.40987294392055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6895183521984`", ",", "2.06634330667043`", ",", 
          "5.82265402142834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.345138570811321`", ",", "1.85315680627712`", ",", 
          "0.952249791756536`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28394409660383`", ",", "1.65262155559578`", ",", 
          "2.36503086926432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22274962239634`", ",", "1.45538476083519`", ",", 
          "3.77781194677211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16155514818885`", ",", "1.25345157050371`", ",", 
          "5.19059302427989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81717536680177`", ",", "1.03684980726929`", ",", 
          "0.320188794608093`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75598089259428`", ",", "0.787210708183143`", ",", 
          "1.73296987211588`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69478641838679`", ",", "0.444761195792378`", ",", 
          "3.14575094962366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.35040663699972`", ",", "2.69147768268637`", ",", 
          "4.55853202713145`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28921216279222`", ",", "2.35111736147237`", ",", 
          "5.97131310463924`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22801768858474`", ",", "2.10205407335595`", ",", 
          "1.10090887496744`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.883637907197659`", ",", "1.88570396907304`", ",", 
          "2.51368995247522`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82244343299017`", ",", "1.6838763461916`", ",", 
          "3.92647102998301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76124895878268`", ",", "1.48664675149347`", ",", 
          "5.33925210749079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.416869177395601`", ",", "1.28602314536246`", ",", 
          "0.468847877818993`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35567470318811`", ",", "1.07261438366129`", ",", 
          "1.88162895532678`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29448022898062`", ",", "0.830212777885532`", ",", 
          "3.29441003283456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23328575477313`", ",", "0.512322819724201`", ",", 
          "4.70719111034235`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88890597338605`", ",", "2.76931781256838`", ",", 
          "6.11997218785014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82771149917856`", ",", "2.39589220718893`", ",", 
          "1.24956795817834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76651702497107`", ",", "2.13853085423239`", ",", 
          "2.66234903568612`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.422137243584`", ",", "1.91860007683416`", ",", 
          "4.07513011319391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.36094276937651`", ",", "1.7152425151402`", ",", 
          "5.48791119070169`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29974829516902`", ",", "1.5178264902865`", ",", 
          "0.617506961029893`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.955368513781939`", ",", "1.31828694736114`", ",", 
          "2.03028803853768`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89417403957445`", ",", "1.10769600071398`", ",", 
          "3.44306911604546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83297956536696`", ",", "0.871586013150148`", ",", 
          "4.85585019355325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.488599783979882`", ",", "0.572585437103065`", ",", 
          "6.26863127106104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42740530977239`", ",", "2.86726496670967`", ",", 
          "1.39822704138924`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3662108355649`", ",", "2.44295335598138`", ",", 
          "2.81100811889702`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0218310541778245`", ",", "2.17587719703066`", ",", 
          "4.22378919640481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.96063657997033`", ",", "1.95189345826784`", ",", 
          "5.63657027391259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89944210576284`", ",", "1.74675250915368`", ",", 
          "0.766166044240793`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83824763155535`", ",", "1.54895474906764`", ",", 
          "2.17894712174858`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49386785016828`", ",", "1.35028426081429`", ",", 
          "3.59172819925636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43267337596079`", ",", "1.14217328970736`", ",", 
          "5.00450927676415`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3714789017533`", ",", "0.911566457844107`", ",", 
          "0.134105047092351`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02709912036622`", ",", "0.627670461757974`", ",", 
          "1.54688612460014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96590464615873`", ",", "3.0293979453902`", ",", 
          "2.95966720210792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90471017195124`", ",", "2.49281557059671`", ",", 
          "4.37244827961571`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.560330390564162`", ",", "2.21421471148324`", ",", 
          "5.78522935712349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49913591635667`", ",", "1.98563723905366`", ",", 
          "0.914825127451694`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43794144214918`", ",", "1.77844010374178`", ",", 
          "2.32760620495948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.093561660762105`", ",", "1.58006184652907`", ",", 
          "3.74038728246727`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03236718655461`", ",", "1.38205360856719`", ",", 
          "5.15316835997505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97117271234712`", ",", "1.17611550678888`", ",", 
          "0.282764130303251`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90997823813963`", ",", "0.950344240626198`", ",", 
          "1.69554520781104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56559845675256`", ",", "0.678854451170151`", ",", 
          "3.10832628531882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50440398254507`", ",", "0.223254750055524`", ",", 
          "4.52110736282661`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44320950833758`", ",", "2.54620031190377`", ",", 
          "5.93388844033439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0988297269505`", ",", "2.2536882176197`", ",", 
          "1.06348421066259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03763525274301`", ",", "2.01989034809819`", ",", 
          "2.47626528817038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97644077853552`", ",", "1.81034076021198`", ",", 
          "3.88904636567817`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.632060997148443`", ",", "1.61117791624624`", ",", 
          "5.30182744318595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.57086652294095`", ",", "1.41363124488156`", ",", 
          "0.431423213514151`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50967204873346`", ",", "1.20958426518272`", ",", 
          "1.84420429102194`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.165292267346386`", ",", "0.988075451467964`", ",", 
          "3.25698536852972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1040977931389`", ",", "0.726976470521549`", ",", 
          "4.66976644603751`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04290331893141`", ",", "0.336013035203532`", ",", 
          "6.08254752354529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98170884472391`", ",", "2.60417549847778`", ",", 
          "1.21214329387349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63732906333684`", ",", "2.29447289637013`", ",", 
          "2.62492437138128`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57613458912935`", ",", "2.05471876624975`", ",", 
          "4.03770544888907`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51494011492186`", ",", "1.84249202912473`", ",", 
          "5.45048652639685`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.17056033353478`", ",", "1.64233317020057`", ",", 
          "0.580082296725051`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10936585932729`", ",", "1.44505158143011`", ",", 
          "1.99286337423284`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0481713851198`", ",", "1.2426349032312`", ",", 
          "3.40564445174062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.703791603732723`", ",", "1.02489036805776`", ",", 
          "4.81842552924841`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64259712952523`", ",", "0.772623249934855`", ",", 
          "6.2312066067562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58140265531774`", ",", "0.420287817193482`", ",", 
          "1.36080237708439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.237022873930666`", ",", "2.66844639591087`", ",", 
          "2.77358345459218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17582839972318`", ",", "2.33678448973598`", ",", 
          "4.18636453209997`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11463392551569`", ",", "2.09019709805478`", ",", 
          "5.59914560960775`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0534394513082`", ",", "1.87493401407543`", ",", 
          "0.728741379935951`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70905966992112`", ",", "1.67355816421429`", ",", 
          "2.14152245744374`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64786519571363`", ",", "1.47634756159264`", ",", 
          "3.55430353495152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58667072150614`", ",", "1.27531758057423`", ",", 
          "4.96708461245931`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24229094011906`", ",", "1.06089931790917`", ",", 
          "0.0966803827875085`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.18109646591157`", ",", "0.816224421703999`", ",", 
          "1.50946146029529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11990199170408`", ",", "0.490990409269328`", ",", 
          "2.92224253780308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.775522210317004`", ",", "2.74206339975516`", ",", 
          "4.33502361531087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71432773610951`", ",", "2.38089431261958`", ",", 
          "5.74780469281865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65313326190202`", ",", "2.12641057996223`", ",", 
          "0.877400463146852`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.308753480514947`", ",", "1.90770991328033`", ",", 
          "2.29018154065464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24755900630746`", ",", "1.70488407182323`", ",", 
          "3.70296261816242`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18636453209997`", ",", "1.50755099526372`", ",", 
          "5.11574369567021`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12517005789248`", ",", "1.30767816878916`", ",", 
          "0.245339465998409`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7807902765054`", ",", "1.09619695916029`", ",", 
          "1.65812054350619`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71959580229791`", ",", "0.858106056423452`", ",", 
          "3.07090162101398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65840132809042`", ",", "0.553364563926967`", ",", 
          "4.48368269852177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31402154670334`", ",", "2.83164467264296`", ",", 
          "5.89646377602955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25282707249585`", ",", "2.42715218310991`", ",", 
          "1.02605954635775`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19163259828836`", ",", "2.16345768780984`", ",", 
          "2.43884062386554`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.847252816901284`", ",", "1.94086666141092`", ",", 
          "3.85162170137332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78605834269379`", ",", "1.73634297352292`", ",", 
          "5.26440277888111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7248638684863`", ",", "1.53869286422288`", ",", 
          "0.393998549209309`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.380484087099227`", ",", "1.3397589849929`", ",", 
          "1.80677962671709`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31928961289174`", ",", "1.13086547431556`", ",", 
          "3.21956070422488`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25809513868425`", ",", "0.898522851464542`", ",", 
          "4.63234178173267`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19690066447676`", ",", "0.609986315718517`", ",", 
          "6.04512285924045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85252088308968`", ",", "2.95943249727943`", ",", 
          "1.17471862956865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79132640888219`", ",", "2.47602306655588`", ",", 
          "2.58749970707644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7301319346747`", ",", "2.20145358263184`", ",", 
          "4.00028078458422`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38575215328762`", ",", "1.97445570100471`", ",", 
          "5.41306186209201`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32455767908013`", ",", "1.76796816908314`", ",", 
          "0.542657632420209`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26336320487264`", ",", "1.5698036065789`", ",", 
          "1.955438709928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.918983423485565`", ",", "1.37159940447635`", ",", 
          "3.36821978743578`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85778894927807`", ",", "1.16497699876823`", ",", 
          "4.78100086494357`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79659447507058`", ",", "0.937678535515388`", ",", 
          "6.19378194245135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.452214693683508`", ",", "0.662347720434051`", ",", 
          "1.32337771277955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.39102021947602`", ",", "0.170852940790448`", ",", 
          "2.73615879028734`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32982574526853`", ",", "2.52814902132932`", ",", 
          "4.14893986779512`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26863127106104`", ",", "2.24053475451527`", ",", 
          "5.56172094530291`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92425148967396`", ",", "2.00853392241548`", ",", 
          "0.691316715631109`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86305701546647`", ",", "1.79979452180027`", ",", 
          "2.1040977931389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80186254125898`", ",", "1.60091338774433`", ",", 
          "3.51687887064668`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4574827598719`", ",", "1.40323637964044`", ",", 
          "4.92965994815447`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39628828566441`", ",", "1.19859549944528`", ",", 
          "0.0592557184826665`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33509381145692`", ",", "0.975739368845688`", ",", 
          "1.47203679599045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.990714030069845`", ",", "0.71140484826727`", ",", 
          "2.88481787349824`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92951955586236`", ",", "0.303370955766915`", ",", 
          "4.29759895100602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86832508165486`", ",", "2.5844617483177`", ",", 
          "5.71038002851381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.523945300267788`", ",", "2.28086542129543`", ",", 
          "0.83997579884201`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4627508260603`", ",", "2.04316482492654`", ",", 
          "2.2527568763498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40155635185281`", ",", "1.83185884524495`", ",", 
          "3.66553795385758`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0571765704657309`", ",", "1.63205236473405`", ",", 
          "5.07831903136537`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99598209625824`", ",", "1.43470488619701`", ",", 
          "0.207914801693567`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93478762205075`", ",", "1.23177825116695`", ",", 
          "1.62069587920135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87359314784326`", ",", "1.01284339766925`", ",", 
          "3.03347695670914`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52921336645618`", ",", "0.75781412788588`", ",", 
          "4.44625803421692`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46801889224869`", ",", "0.394393842272911`", ",", 
          "5.85903911172471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4068244180412`", ",", "2.64640777916133`", ",", 
          "0.98863488205291`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06244463665413`", ",", "2.32264657216056`", ",", 
          "2.4014159595607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00125016244664`", ",", "2.0784199713161`", ",", 
          "3.81419703706848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.94005568823915`", ",", "1.86420034541781`", ",", 
          "5.22697811457627`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.595675906852069`", ",", "1.66325095025916`", ",", 
          "0.356573884904467`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53448143264458`", ",", "1.46603831303802`", ",", 
          "1.76935496241225`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47328695843709`", ",", "1.26457701408104`", ",", 
          "3.18213603992004`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.128907177050011`", ",", "1.04910699049233`", ",", 
          "4.59491711742782`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06771270284252`", ",", "0.80204961419566`", ",", 
          "6.00769819493561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00651822863503`", ",", "0.468770537519812`", ",", 
          "1.13729396526381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94532375442754`", ",", "2.71646502573946`", ",", 
          "2.5500750427716`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.60094397304046`", ",", "2.36612913334192`", ",", 
          "3.96285612027938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53974949883297`", ",", "2.11438083698037`", ",", 
          "5.37563719778717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47855502462548`", ",", "1.89686113447254`", ",", 
          "0.505232968115367`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13417524323841`", ",", "1.6945400830774`", ",", 
          "1.91801404562315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07298076903092`", ",", "1.49726880886383`", ",", 
          "3.33079512313094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01178629482343`", ",", "1.29703898598532`", ",", 
          "4.74357620063872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.667406513436349`", ",", "1.08462957468272`", ",", 
          "6.15635727814651`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60621203922886`", ",", "0.844467189095647`", ",", 
          "1.28595304847471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54501756502137`", ",", "0.533526014874421`", ",", 
          "2.6987341259825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.200637783634292`", ",", "2.79960912513112`", ",", 
          "4.11151520349028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1394433094268`", ",", "2.41163381810304`", ",", 
          "5.52429628099807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07824883521931`", ",", "2.15114119779871`", ",", 
          "0.653892051326267`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01705436101182`", ",", "1.92988683663252`", ",", 
          "2.06667312883405`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67267457962474`", ",", "1.72595151136382`", ",", 
          "3.47945420634184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61148010541725`", ",", "1.52842759625638`", ",", 
          "4.89223528384963`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.55028563120976`", ",", "1.32920758321125`", ",", 
          "0.0218310541778245`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20590584982269`", ",", "1.11949714639382`", ",", 
          "1.43461213168561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1447113756152`", ",", "0.885342385512337`", ",", 
          "2.8473932091934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08351690140771`", ",", "0.591842876045448`", ",", 
          "4.26017428670118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.73913712002063`", ",", "2.90954075370884`", ",", 
          "5.67295536420897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67794264581314`", ",", "2.45958234664298`", ",", 
          "0.802551134537168`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61674817160565`", ",", "2.18881026680771`", ",", 
          "2.21533221204495`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.272368390218572`", ",", "1.9633273131028`", ",", 
          "3.62811328955274`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21117391601108`", ",", "1.75751809650441`", ",", 
          "5.04089436706053`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14997944180359`", ",", "1.55954526215762`", ",", 
          "0.170490137388725`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0887849675961`", ",", "1.36112308976708`", ",", 
          "1.58327121489651`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74440518620902`", ",", "1.15378492341684`", ",", 
          "2.9960522924043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68321071200153`", ",", "0.924893980004832`", ",", 
          "4.40883336991208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62201623779404`", ",", "0.645483929148261`", ",", 
          "5.82161444741987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27763645640697`", ",", "0.0927887349570307`", ",", 
          "0.951210217748068`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21644198219948`", ",", "2.51054917695851`", ",", 
          "2.36399129525585`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15524750799199`", ",", "2.22751689312927`", ",", 
          "3.77677237276364`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.81086772660491`", ",", "1.99723754139201`", ",", 
          "5.18955345027143`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74967325239742`", ",", "1.7892741457436`", ",", 
          "0.319149220599625`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68847877818993`", ",", "1.59065203251026`", ",", 
          "1.73193029810741`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.344098996802853`", ",", "1.39282320459039`", ",", 
          "3.1447113756152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28290452259536`", ",", "1.18755938612977`", ",", 
          "4.55749245312298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.22171004838787`", ",", "0.963299397800984`", ",", 
          "5.97027353063077`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.16051557418038`", ",", "0.695546669882547`", ",", 
          "1.09986930095897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81613579279331`", ",", "0.266900556608764`", ",", 
          "2.51265037846675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75494131858581`", ",", "2.56535308629876`", ",", 
          "3.92543145597454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69374684437832`", ",", "2.26741530363005`", ",", 
          "5.33821253348233`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34936706299125`", ",", "2.0316786966141`", ",", 
          "0.467808303810525`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28817258878376`", ",", "1.82125578362162`", ",", 
          "1.88058938131831`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22697811457627`", ",", "1.62177803803352`", ",", 
          "3.2933704588261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.882598333189191`", ",", "1.42434350972933`", ",", 
          "4.70615153633388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8214038589817`", ",", "1.2208798733014`", ",", 
          "6.11893261384167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.76020938477421`", ",", "1.00070515737132`", ",", 
          "1.24852838416987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.415829603387133`", ",", "0.742769513879512`", ",", 
          "2.66130946167765`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35463512917964`", ",", "0.366777644978498`", ",", 
          "4.07409053918544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29344065497215`", ",", "2.62523406353935`", ",", 
          "5.48687161669323`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23224618076466`", ",", "2.30869314686684`", ",", 
          "0.616467387021425`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88786639937759`", ",", "2.0667194997473`", ",", 
          "2.02924846452921`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8266719251701`", ",", "1.85350137425182`", ",", 
          "3.442029542037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76547745096261`", ",", "1.65295357767629`", ",", 
          "4.85481061954478`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42109766957553`", ",", "1.45571787720159`", ",", 
          "6.26759169705257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35990319536804`", ",", "1.25379984873436`", ",", 
          "1.39718746738077`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29870872116055`", ",", "1.0372341788719`", ",", 
          "2.80996854488855`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.954328939773471`", ",", "0.787677726342139`", ",", 
          "4.22274962239634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89313446556598`", ",", "0.445529693299099`", ",", 
          "5.63553069990413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83193999135849`", ",", "2.6922388665877`", ",", 
          "0.765126470232326`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.487560209971414`", ",", "2.3515830835882`", ",", 
          "2.17790754774011`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42636573576392`", ",", "2.10243792317904`", ",", 
          "3.5906886252479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36517126155643`", ",", "1.88605200941057`", ",", 
          "5.00346970275568`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0207914801693567`", ",", "1.68420938617811`", ",", 
          "0.133065473083883`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95959700596187`", ",", "1.48697882859996`", ",", 
          "1.54584655059167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89840253175438`", ",", "1.286367921059`", ",", 
          "2.95862762809945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83720805754689`", ",", "1.0729910377315`", ",", 
          "4.37140870560724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49282827615981`", ",", "0.830661023568947`", ",", 
          "5.78418978311503`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43163380195232`", ",", "0.512997455039079`", ",", 
          "0.913785553443226`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.37043932774483`", ",", "2.77022862056803`", ",", 
          "2.32656663095101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02605954635775`", ",", "2.39638004901938`", ",", 
          "3.7393477084588`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96486507215026`", ",", "2.13892338150523`", ",", 
          "5.15212878596658`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90367059794277`", ",", "1.91895208143183`", ",", 
          "0.281724556294783`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.559290816555694`", ",", "1.71557691236644`", ",", 
          "1.69450563380257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4980963423482`", ",", "1.5181578588389`", ",", 
          "3.10728671131035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43690186814071`", ",", "1.31862867618366`", ",", 
          "4.52006778881814`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0925220867536372`", ",", "1.1080658303412`", ",", 
          "5.93284886632593`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03132761254615`", ",", "0.872018294153904`", ",", 
          "1.06244463665413`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.97013313833866`", ",", "0.573195894591758`", ",", 
          "2.47522571416191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90893866413117`", ",", "2.86848913895981`", ",", 
          "3.8880067916697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56455888274409`", ",", "2.4434680019157`", ",", 
          "5.30078786917748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5033644085366`", ",", "2.17627959266812`", ",", 
          "0.430383639505683`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44216993432911`", ",", "1.95224996544403`", ",", 
          "1.84316471701347`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09779015294203`", ",", "1.74708861534243`", ",", 
          "3.25594579452125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03659567873454`", ",", "1.54928573350738`", ",", 
          "4.66872687202904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97540120452705`", ",", "1.35062336617059`", ",", 
          "6.08150794953683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.631021423139975`", ",", "1.14253707754375`", ",", 
          "1.21110371986503`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56982694893248`", ",", "0.911985013233655`", ",", 
          "2.62388479737281`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50863247472499`", ",", "0.628233717965578`", ",", 
          "4.0366658748806`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.164252693337918`", ",", "3.03239336159419`", ",", 
          "5.44944695238838`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10305821913043`", ",", "2.49336343469417`", ",", 
          "0.579042722716583`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04186374492294`", ",", "2.21462838335094`", ",", 
          "1.99182380022437`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.98066927071545`", ",", "1.98599884319581`", ",", 
          "3.40460487773216`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63628948932837`", ",", "1.77877828659947`", ",", 
          "4.81738595523994`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57509501512088`", ",", "1.58039276793142`", ",", 
          "6.23016703274773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51390054091339`", ",", "1.38239048727128`", ",", 
          "1.35976280307593`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16952075952631`", ",", "1.17647394580758`", ",", 
          "2.77254388058371`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10832628531882`", ",", "0.950750892836933`", ",", 
          "4.1853249580915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04713181111133`", ",", "0.679381283005323`", ",", 
          "5.59810603559928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.702752029724256`", ",", "0.224744441372287`", ",", 
          "0.727701805927484`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.64155755551677`", ",", "2.54679059559267`", ",", 
          "2.14048288343527`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.58036308130928`", ",", "2.25411485464044`", ",", 
          "3.55326396094306`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.235983299922198`", ",", "2.0202577115507`", ",", 
          "4.96604503845084`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17478882571471`", ",", "1.81068140745428`", ",", 
          "0.0956408087790407`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11359435150722`", ",", "1.61150909513603`", ",", 
          "1.50842188628683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05239987729973`", ",", "1.41396627200742`", ",", 
          "2.92120296379461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70802009591265`", ",", "1.20993797495576`", ",", 
          "4.3339840413024`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64682562170516`", ",", "0.988471710139238`", ",", 
          "5.74676511881018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58563114749767`", ",", "0.727474224659929`", ",", 
          "0.876360889138384`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24125136611059`", ",", "0.337015179267515`", ",", 
          "2.28914196664617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1800568919031`", ",", "2.60482225392738`", ",", 
          "3.70192304415396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11886241769561`", ",", "2.29491455864392`", ",", 
          "5.11470412166174`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.774482636308536`", ",", "2.05509263416729`", ",", 
          "0.244299891989941`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71328816210105`", ",", "1.84283555306554`", ",", 
          "1.65708096949773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65209368789356`", ",", "1.64266492935451`", ",", 
          "3.06986204700551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.307713906506479`", ",", "1.44538511454174`", ",", 
          "4.4826431245133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24651943229899`", ",", "1.24298444288466`", ",", 
          "5.89542420202108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1853249580915`", ",", "1.02527750310689`", ",", 
          "1.02501997234928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12413048388401`", ",", "0.773097202139563`", ",", 
          "2.43780104985707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77975070249693`", ",", "0.421098082375872`", ",", 
          "3.85058212736486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71855622828944`", ",", "2.66917307932213`", ",", 
          "5.26336320487264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65736175408195`", ",", "2.33724373890265`", ",", 
          "0.392958975200841`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31298197269487`", ",", "2.09057831723148`", ",", 
          "1.80574005270863`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25178749848738`", ",", "1.87528085694412`", ",", 
          "3.21852113021641`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.19059302427989`", ",", "1.67389083151831`", ",", 
          "4.6313022077242`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.846213242892816`", ",", "1.47667994449412`", ",", 
          "6.04408328523198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78501876868533`", ",", "1.27566345924544`", ",", 
          "1.17367905556018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72382429447784`", ",", "1.06127841231638`", ",", 
          "2.58646013306797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.379444513090759`", ",", "0.816678514536954`", ",", 
          "3.99924121057576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31825003888327`", ",", "0.491691766949959`", ",", 
          "5.41202228808354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25705556467578`", ",", "2.74291495183161`", ",", 
          "0.541618058411741`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19586109046829`", ",", "2.38137440689315`", ",", 
          "1.95439913591953`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85148130908121`", ",", "2.1268001230725`", ",", 
          "3.36718021342731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.79028683487372`", ",", "1.90806055347712`", ",", 
          "4.7799612909351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72909236066623`", ",", "1.70521798325584`", ",", 
          "6.19274236844289`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38471257927915`", ",", "1.50788256138653`", ",", 
          "1.32233813877108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32351810507166`", ",", "1.30802085418401`", ",", 
          "2.73511921627887`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26232363086417`", ",", "1.09656894797269`", ",", 
          "4.14790029378666`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.917943849477097`", ",", "0.858543330763973`", ",", 
          "5.56068137129444`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85674937526961`", ",", "0.553993879080925`", ",", 
          "0.690277141622642`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79555490106212`", ",", "2.83273142424953`", ",", 
          "2.10305821913043`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.45117511967504`", ",", "2.42765738109969`", ",", 
          "3.51583929663821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38998064546755`", ",", "2.1638566851428`", ",", 
          "4.928620374146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32878617126006`", ",", "1.94122162097201`", ",", 
          "0.0582161444741987`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26759169705257`", ",", "1.73667847634173`", ",", 
          "1.47099722198198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92321191566549`", ",", "1.53902393974801`", ",", 
          "2.88377829948977`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.862017441458`", ",", "1.34009891048479`", ",", 
          "4.29655937699756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.80082296725051`", ",", "1.13123117405119`", ",", 
          "5.70934045450534`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45644318586343`", ",", "0.89894571406357`", ",", 
          "0.838936224833542`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39524871165594`", ",", "0.610563720732581`", ",", 
          "2.25171730234133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33405423744846`", ",", "2.96126830176753`", ",", 
          "3.66449837984911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.989674456061378`", ",", "2.47655912457469`", ",", 
          "5.0772794573569`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92847998185389`", ",", "2.2018633644108`", ",", 
          "0.206875227685099`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8672855076464`", ",", "1.97481555463528`", ",", 
          "1.61965630519288`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.52290572625932`", ",", "1.76830562530204`", ",", 
          "3.03243738270067`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46171125205183`", ",", "1.57013451337795`", ",", 
          "4.44521846020846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.40051677784434`", ",", "1.37193697507788`", ",", 
          "5.85799953771624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.056136996457263`", ",", "1.16533712998441`", ",", 
          "0.987595308044442`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99494252224977`", ",", "0.938088932816716`", ",", 
          "2.40037638555223`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93374804804228`", ",", "0.662885620993576`", ",", 
          "3.81315746306001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87255357383479`", ",", "0.172788334325533`", ",", 
          "5.2259385405678`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52817379244772`", ",", "2.52872405968844`", ",", 
          "0.355534310895999`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46697931824022`", ",", "2.24095690851301`", ",", 
          "1.76831538840379`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40578484403273`", ",", "2.00889930856985`", ",", 
          "3.18109646591157`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06140506264566`", ",", "1.80013431205962`", ",", 
          "4.59387754341936`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.00021058843817`", ",", "1.6012444462147`", ",", 
          "6.00665862092714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93901611423068`", ",", "1.4035719771004`", ",", 
          "1.13625439125534`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.594636332843601`", ",", "1.19895070434576`", ",", 
          "2.54903546876313`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53344185863611`", ",", "0.97613890432644`", ",", 
          "3.96181654627091`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47224738442862`", ",", "0.711911526512396`", ",", 
          "5.3745976237787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.127867603041544`", ",", "0.304476681643494`", ",", 
          "0.504193394106899`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06667312883405`", ",", "2.58508788753064`", ",", 
          "1.91697447161469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00547865462656`", ",", "2.28130187314254`", ",", 
          "3.32975554912247`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94428418041907`", ",", "2.04353645958806`", ",", 
          "4.74253662663026`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.599904399032`", ",", "1.83220137319831`", ",", 
          "6.15531770413804`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53870992482451`", ",", "1.63238389659815`", ",", 
          "1.28491347446624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47751545061702`", ",", "1.43503887341861`", ",", 
          "2.69769455197403`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13313566922994`", ",", "1.23212910754813`", ",", 
          "4.11047562948181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07194119502245`", ",", "1.01323341363861`", ",", 
          "5.5232567069896`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.01074672081496`", ",", "0.758295439577297`", ",", 
          "0.6528524773178`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.666366939427881`", ",", "0.395254131818085`", ",", 
          "2.06563355482559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60517246522039`", ",", "2.6471045895042`", ",", 
          "3.47841463233337`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5439779910129`", ",", "2.32309970036767`", ",", 
          "4.89119570984116`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.199598209625824`", ",", "2.07879866538091`", ",", 
          "0.0207914801693567`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13840373541833`", ",", "1.86454604278836`", ",", 
          "1.43357255767714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07720926121084`", ",", "1.66358328139594`", ",", 
          "2.84635363518493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01601478700335`", ",", "1.46637103797323`", ",", 
          "4.25913471269271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67163500561628`", ",", "1.26492404653742`", ",", 
          "5.6719157902005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.61044053140879`", ",", "1.04948862669721`", ",", 
          "0.8015115605287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5492460572013`", ",", "0.802509882809843`", ",", 
          "2.21429263803649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20486627581422`", ",", "0.469502443749034`", ",", 
          "3.62707371554427`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14367180160673`", ",", "2.7172680584641`", ",", 
          "5.03985479305206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08247732739924`", ",", "2.36660193937189`", ",", 
          "0.169450563380257`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.738097546012162`", ",", "2.11476751852082`", ",", 
          "1.58223164088804`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67690307180467`", ",", "1.89721046697245`", ",", 
          "2.99501271839583`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61570859759718`", ",", "1.694873546456`", ",", 
          "4.40779379590361`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.271328816210105`", ",", "1.49760060800869`", ",", 
          "5.8205748734114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.21013434200261`", ",", "1.29738267503806`", ",", 
          "0.9501706437396`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14893986779512`", ",", "1.08500381130412`", ",", 
          "2.36295172124739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08774539358763`", ",", "0.844909717162774`", ",", 
          "3.77573279875517`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74336561220056`", ",", "0.534176314828816`", ",", 
          "5.18851387626296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68217113799307`", ",", "2.80059722801798`", ",", 
          "0.318109646591157`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.62097666378558`", ",", "2.412130187572`", ",", 
          "1.73089072409894`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2765968823985`", ",", "2.15153694104382`", ",", 
          "3.14367180160673`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21540240819101`", ",", "1.93024031099438`", ",", 
          "4.55645287911452`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15420793398352`", ",", "1.72628645015404`", ",", 
          "5.9692339566223`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.809828152596442`", ",", "1.5287587978507`", ",", 
          "1.0988297269505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74863367838895`", ",", "1.32954837284679`", ",", 
          "2.51161080445829`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68743920418146`", ",", "1.11986483625534`", ",", 
          "3.92439188196607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.343059422794385`", ",", "0.885769766088282`", ",", 
          "5.33717295947386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28186494858689`", ",", "0.59243575280666`", ",", 
          "0.466768729802057`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2206704743794`", ",", "2.9109840434474`", ",", 
          "1.87954980730984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15947600017191`", ",", "2.46010746943965`", ",", 
          "3.29233088481763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81509621878484`", ",", "2.18921633054682`", ",", 
          "4.70511196232541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75390174457735`", ",", "1.96368548554946`", ",", 
          "6.1178930398332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69270727036986`", ",", "1.75785486744755`", ",", 
          "1.2474888101614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34832748898278`", ",", "1.55987618917714`", ",", 
          "2.66026988766919`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28713301477529`", ",", "1.36146139374938`", ",", 
          "4.07305096517697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2259385405678`", ",", "1.1541468165646`", ",", 
          "5.48583204268476`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.881558759180723`", ",", "0.925308296141933`", ",", 
          "0.615427813012958`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.82036428497323`", ",", "0.646033786445549`", ",", 
          "2.02820889052074`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75916981076574`", ",", "0.0962940806167305`", ",", 
          "3.44098996802853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.414790029378666`", ",", "2.51111026298529`", ",", 
          "4.85377104553632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35359555517118`", ",", "2.22793477262596`", ",", 
          "6.2665521230441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29240108096368`", ",", "1.9976010279792`", ",", 
          "1.3961478933723`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2312066067562`", ",", "1.78961312288057`", ",", 
          "2.80892897088009`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88682682536912`", ",", "1.59098300552883`", ",", 
          "4.22171004838787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82563235116163`", ",", "1.39315941182232`", ",", 
          "5.63449112589566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76443787695414`", ",", "1.18791614890878`", ",", 
          "0.764086896223858`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.42005809556706`", ",", "0.963702355614493`", ",", 
          "2.17686797373164`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35886362135957`", ",", "0.696062902266466`", ",", 
          "3.58964905123943`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29766914715208`", ",", "0.268152347227264`", ",", 
          "5.00243012874722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.953289365765004`", ",", "2.56596067835172`", ",", 
          "0.132025899075415`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89209489155751`", ",", "2.26784680239807`", ",", 
          "1.5448069765832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.83090041735002`", ",", "2.0320481860344`", ",", 
          "2.95758805409099`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.486520635962946`", ",", "1.82159736249404`", ",", 
          "4.37036913159877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42532616175546`", ",", "1.62210937802663`", ",", 
          "5.78315020910656`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36413168754797`", ",", "1.42467798887589`", ",", 
          "0.912745979434758`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0197519061608888`", ",", "1.22123210339177`", ",", 
          "2.32552705694254`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9585574319534`", ",", "1.00109817787691`", ",", 
          "3.73830813445033`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89736295774591`", ",", "0.743258651319254`", ",", 
          "5.15108921195812`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83616848353842`", ",", "0.367699289490093`", ",", 
          "0.280684982286315`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49178870215134`", ",", "2.62590469554485`", ",", 
          "1.6934660597941`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.43059422794385`", ",", "2.30914047850817`", ",", 
          "3.10624713730189`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36939975373636`", ",", "2.06709576940568`", ",", 
          "4.51902821480967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02501997234928`", ",", "1.85384597671844`", ",", 
          "5.93180929231746`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96382549814179`", ",", "1.65328560883439`", ",", 
          "1.06140506264566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9026310239343`", ",", "1.45605098074196`", ",", 
          "2.47418614015344`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.558251242547227`", ",", "1.2541480871767`", ",", 
          "3.88696721766123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49705676833974`", ",", "1.03761846322161`", ",", 
          "5.29974829516902`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43586229413225`", ",", "0.788144527488131`", ",", 
          "0.429344065497215`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0914825127451694`", ",", "0.44629695609502`", ",", 
          "1.842125143005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.03028803853768`", ",", "2.69300125382288`", ",", 
          "3.25490622051279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96909356433019`", ",", "2.35204902070914`", ",", 
          "4.66768729802057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9078990901227`", ",", "2.10282185967635`", ",", 
          "6.08046837552836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56351930873562`", ",", "1.88640008925767`", ",", 
          "1.21006414585656`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50232483452813`", ",", "1.6845424387986`", ",", 
          "2.62284522336434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44113036032064`", ",", "1.48731089644202`", ",", 
          "4.03562630087213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09675057893356`", ",", "1.28671266200673`", ",", 
          "5.44840737837992`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03555610472607`", ",", "1.07336761471829`", ",", 
          "0.578003148708116`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97436163051858`", ",", "0.831109085815794`", ",", 
          "1.9907842262159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.629981849131507`", ",", "0.513671283344787`", ",", 
          "3.40356530372369`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56878737492402`", ",", "2.7711415637695`", ",", 
          "4.81634638123147`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50759290071653`", ",", "2.39686814891549`", ",", 
          "6.22912745873926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.16321311932945`", ",", "2.139316007155`", ",", 
          "1.35872322906746`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10201864512196`", ",", "1.91930413100612`", ",", 
          "2.77150430657524`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.04082417091447`", ",", "1.71591132589713`", ",", 
          "4.18428538408303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97962969670698`", ",", "1.51848922160609`", ",", 
          "5.59706646159082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6352499153199`", ",", "1.31897037492057`", ",", 
          "0.726662231919016`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57405544111241`", ",", "1.10843559175074`", ",", 
          "2.1394433094268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51286096690492`", ",", "0.872450418208796`", ",", 
          "3.55222438693459`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16848118551785`", ",", "0.573805775296367`", ",", 
          "4.96500546444237`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10728671131035`", ",", "2.86971868493135`", ",", 
          "0.0946012347705729`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04609223710286`", ",", "2.44398296369673`", ",", 
          "1.50738231227836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.701712455715788`", ",", "2.17668210042213`", ",", 
          "2.92016338978614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6405179815083`", ",", "1.95260652360618`", ",", 
          "4.33294446729393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57932350730081`", ",", "1.74742474165658`", ",", 
          "5.74572554480172`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.23494372591373`", ",", "1.54961671559028`", ",", 
          "0.875321315129916`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17374925170624`", ",", "1.35096244579341`", ",", 
          "2.2881023926377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11255477749875`", ",", "1.14290080497414`", ",", 
          "3.70088347014549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05136030329126`", ",", "0.912403433035749`", ",", 
          "5.11366454765327`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70698052190418`", ",", "0.628796537765926`", ",", 
          "0.243260317981473`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64578604769669`", ",", "3.03547294973907`", ",", 
          "1.65604139548926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5845915734892`", ",", "2.49391169536795`", ",", 
          "3.06882247299704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.24021179210213`", ",", "2.21504218369038`", ",", 
          "4.48160355050483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17901731789464`", ",", "1.98636050498908`", ",", 
          "5.89438462801262`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11782284368714`", ",", "1.7791164935943`", ",", 
          "1.02398039834082`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.773443062300068`", ",", "1.58072369038471`", ",", 
          "2.4367614758486`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71224858809258`", ",", "1.38272734433845`", ",", 
          "3.84954255335639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65105411388509`", ",", "1.17683233137221`", ",", 
          "5.26232363086417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.306674332498011`", ",", "0.951157427014291`", ",", 
          "0.391919401192373`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24547985829052`", ",", "0.679907771406004`", ",", 
          "1.80470047870016`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18428538408303`", ",", "0.226224487899537`", ",", 
          "3.21748155620795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12309090987554`", ",", "2.54738139476168`", ",", 
          "4.63026263371573`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77871112848846`", ",", "2.25454163990628`", ",", 
          "6.04304371122352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71751665428097`", ",", "2.02062514011626`", ",", 
          "1.17263948155172`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65632218007348`", ",", "1.81102208308187`", ",", 
          "2.5854205590595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31194239868641`", ",", "1.6118402784937`", ",", 
          "3.99820163656729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.25074792447892`", ",", "1.41430128138537`", ",", 
          "5.41098271407507`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18955345027143`", ",", "1.21029163752047`", ",", 
          "0.540578484403274`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.845173668884349`", ",", "0.988867865439822`", ",", 
          "1.95335956191106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78397919467686`", ",", "0.727971700691153`", ",", 
          "3.36614063941885`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72278472046937`", ",", "0.338014465214648`", ",", 
          "4.77892171692663`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.378404939082291`", ",", "2.60546971309842`", ",", 
          "6.19170279443442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3172104648748`", ",", "2.29535639349733`", ",", 
          "1.32129856476262`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25601599066731`", ",", "2.05546657563383`", ",", 
          "2.7340796422704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19482151645982`", ",", "1.84317910992859`", ",", 
          "4.14686071977819`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.85044173507274`", ",", "1.64299669643244`", ",", 
          "5.55964179728597`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78924726086525`", ",", "1.44571863362907`", ",", 
          "0.689237567614174`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72805278665776`", ",", "1.24333394099255`", ",", 
          "2.10201864512196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38367300527069`", ",", "1.02566454721067`", ",", 
          "3.51479972262975`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3224785310632`", ",", "0.773570924229852`", ",", 
          "4.92758080013753`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26128405685571`", ",", "0.421906884375415`", ",", 
          "0.0571765704657309`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.916904275468629`", ",", "2.66990079758158`", ",", 
          "1.46995764797352`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85570980126114`", ",", "2.33770319122293`", ",", 
          "2.8827387254813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79451532705365`", ",", "2.09095961959358`", ",", 
          "4.29551980298909`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.450135545666572`", ",", "1.87562773762202`", ",", 
          "5.70830088049687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38894107145908`", ",", "1.67422351027254`", ",", 
          "0.837896650825074`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32774659725159`", ",", "1.4770123169673`", ",", 
          "2.25067772833286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2665521230441`", ",", "1.27600930155097`", ",", 
          "3.66345880584065`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92217234165702`", ",", "1.06165742644465`", ",", 
          "5.07623988334843`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.86097786744953`", ",", "0.817132413764868`", ",", 
          "0.205835653676631`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79978339324204`", ",", "0.492392207353624`", ",", 
          "1.61861673118442`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45540361185497`", ",", "2.7437682288616`", ",", 
          "3.0313978086922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39420913764748`", ",", "2.38185474368961`", ",", 
          "4.44417888619999`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33301466343999`", ",", "2.12718976049869`", ",", 
          "5.85695996370778`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.98863488205291`", ",", "1.90841123679256`", ",", 
          "0.986555734035974`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92744040784542`", ",", "1.70555190976765`", ",", 
          "2.39933681154376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86624593363793`", ",", "1.50821412058385`", ",", 
          "3.81211788905155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.521866152250852`", ",", "1.30836350799274`", ",", 
          "5.22489896655933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.46067167804336`", ",", "1.09694086577103`", ",", 
          "0.354494736887531`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39947720383587`", ",", "0.858980440066783`", ",", 
          "1.76727581439532`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0550974224487952`", ",", "0.554622554683536`", ",", 
          "3.1800568919031`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9939029482413`", ",", "2.83382188997576`", ",", 
          "4.59283796941089`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93270847403381`", ",", "2.42816287384432`", ",", 
          "6.00561904691867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87151399982632`", ",", "2.16425578980422`", ",", 
          "1.13521481724687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52713421843925`", ",", "1.94157662947082`", ",", 
          "2.54799589475466`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46593974423176`", ",", "1.73701399800681`", ",", 
          "3.96077697226245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40474527002427`", ",", "1.5393550117894`", ",", 
          "5.37355804977023`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.06036548863719`", ",", "1.34043880883873`", ",", 
          "0.503153820098432`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9991710144297`", ",", "1.13159681090822`", ",", 
          "1.91593489760622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93797654022221`", ",", "0.899368434505807`", ",", 
          "3.328715975114`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.593596758835133`", ",", "0.611140649693926`", ",", 
          "4.74149705262179`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53240228462764`", ",", "2.96312278181982`", ",", 
          "6.15427813012957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47120781042015`", ",", "2.47709554927817`", ",", 
          "1.28387390045777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.126828029033076`", ",", "2.20227326893493`", ",", 
          "2.69665497796556`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06563355482559`", ",", "1.97517546363838`", ",", 
          "4.10943605547335`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0044390806181`", ",", "1.7686431043113`", ",", 
          "5.52221713298113`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9432446064106`", ",", "1.57046542010454`", ",", 
          "0.651812903309332`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59886482502353`", ",", "1.37227452271666`", ",", 
          "2.06459398081712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53767035081604`", ",", "1.1656972055387`", ",", 
          "3.4773750583249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47647587660855`", ",", "0.938499206653557`", ",", 
          "4.89015613583269`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13209609522147`", ",", "0.663423151214368`", ",", 
          "0.0197519061608888`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.07090162101398`", ",", "0.174702499864041`", ",", 
          "1.43253298366867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00970714680649`", ",", "2.52929956866922`", ",", 
          "2.84531406117646`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.665327365419414`", ",", "2.24137920379541`", ",", 
          "4.25809513868425`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60413289121192`", ",", "2.00926475727833`", ",", 
          "5.67087621619203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54293841700443`", ",", "1.80047412927409`", ",", 
          "0.800471986520232`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.198558635617356`", ",", "1.60157550802325`", ",", 
          "2.21325306402802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13736416140987`", ",", "1.40390755555013`", ",", 
          "3.6260341415358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07616968720238`", ",", "1.19930586004807`", ",", 
          "5.03881521904359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01497521299488`", ",", "0.976538331875985`", ",", 
          "0.168410989371789`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.67059543160781`", ",", "0.712417907405827`", ",", 
          "1.58119206687957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60940095740032`", ",", "0.305578530485413`", ",", 
          "2.99397314438736`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54820648319283`", ",", "2.58571465759267`", ",", 
          "4.40675422189515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20382670180575`", ",", "2.28173848895057`", ",", 
          "5.81953529940293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14263222759826`", ",", "2.04390816489612`", ",", 
          "0.949131069731132`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.08143775339077`", ",", "1.83254393254222`", ",", 
          "2.36191214723892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.737057972003694`", ",", "1.63271543524026`", ",", 
          "3.7746932247467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6758634977962`", ",", "1.43537284540378`", ",", 
          "5.18747430225449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61466902358871`", ",", "1.2324799205741`", ",", 
          "0.317070072582689`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.270289242201637`", ",", "1.01362333477982`", ",", 
          "1.72985115009048`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20909476799415`", ",", "0.758776506821574`", ",", 
          "3.14263222759826`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14790029378666`", ",", "0.396112651087739`", ",", 
          "4.55541330510605`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08670581957917`", ",", "2.64780230155938`", ",", 
          "5.96819438261383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74232603819209`", ",", "2.32355302082183`", ",", 
          "1.09779015294203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.6811315639846`", ",", "2.07917743930405`", ",", 
          "2.51057123044982`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61993708977711`", ",", "1.86489177631358`", ",", 
          "3.9233523079576`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27555730839003`", ",", "1.66391562281031`", ",", 
          "5.33613338546539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21436283418254`", ",", "1.46670375130615`", ",", 
          "0.465729155793589`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15316835997505`", ",", "1.26527104096784`", ",", 
          "1.87851023330138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.808788578587975`", ",", "1.04987017927587`", ",", 
          "3.29129131080916`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74759410438048`", ",", "0.802969946796654`", ",", 
          "4.70407238831695`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68639963017299`", ",", "0.470233295624972`", ",", 
          "6.11685346582473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.342019848785917`", ",", "2.71807252114548`", ",", 
          "1.24644923615293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.28082537457843`", ",", "2.36707497375987`", ",", 
          "2.65923031366072`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21963090037094`", ",", "2.11515429051979`", ",", 
          "4.0720113911685`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15843642616345`", ",", "1.89755984078831`", ",", 
          "5.48479246867629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81405664477637`", ",", "1.69520702370354`", ",", 
          "0.61438823900449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75286217056888`", ",", "1.49793239908115`", ",", 
          "2.02716931651228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69166769636139`", ",", "1.29772633096819`", ",", 
          "3.43995039402006`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34728791497431`", ",", "1.08537797399271`", ",", 
          "4.85273147152785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28609344076682`", ",", "0.845352071490783`", ",", 
          "6.26551254903563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22489896655933`", ",", "0.53482590067196`", ",", 
          "1.39510831936383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.880519185172255`", ",", "2.80158808997979`", ",", 
          "2.80788939687162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81932471096476`", ",", "2.41262683280539`", ",", 
          "4.2206704743794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75813023675727`", ",", "2.15193278708921`", ",", 
          "5.63345155188719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.413750455370198`", ",", "1.93059383231252`", ",", 
          "0.76304732221539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35255598116271`", ",", "1.72662140653064`", ",", 
          "2.17582839972318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29136150695522`", ",", "1.52908999483108`", ",", 
          "3.58860947723096`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.23016703274773`", ",", "1.32988913391026`", ",", 
          "5.00139055473875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88578725136065`", ",", "1.12023246066608`", ",", 
          "0.130986325066947`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82459277715316`", ",", "0.886196997486211`", ",", 
          "1.54376740257473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76339830294567`", ",", "0.593028107803836`", ",", 
          "2.95654848008252`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41901852155859`", ",", "2.91243626053592`", ",", 
          "4.3693295575903`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3578240473511`", ",", "2.46063293242326`", ",", 
          "5.78211063509809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29662957314361`", ",", "2.18962251164184`", ",", 
          "0.91170640542629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.952249791756536`", ",", "1.96404371117101`", ",", 
          "2.32448748293408`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89105531754904`", ",", "1.75819165985821`", ",", 
          "3.73726856044186`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82986084334156`", ",", "1.56020711500072`", ",", 
          "5.15004963794965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.485481061954478`", ",", "1.36179967341892`", ",", 
          "0.279645408277847`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42428658774699`", ",", "1.15450865176107`", ",", 
          "1.69242648578563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3630921135395`", ",", "0.925722483042229`", ",", 
          "3.10520756329342`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.018712332152421`", ",", "0.646583243030746`", ",", 
          "4.51798864080121`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95751785794493`", ",", "0.0996765963481996`", ",", 
          "5.93076971830899`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89632338373744`", ",", "2.51167178068738`", ",", 
          "1.06036548863719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83512890952995`", ",", "2.22835278689318`", ",", 
          "2.47314656614498`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.49074912814287`", ",", "1.99796457466026`", ",", 
          "3.88592764365276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42955465393538`", ",", "1.78995212557186`", ",", 
          "5.29870872116055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36836017972789`", ",", "1.59131398075903`", ",", 
          "0.428304491488747`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02398039834082`", ",", "1.39349559876233`", ",", 
          "1.84108556899653`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96278592413333`", ",", "1.18827286043247`", ",", 
          "3.25386664650432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90159144992584`", ",", "0.964105200673546`", ",", 
          "4.66664772401211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.557211668538759`", ",", "0.696578815912131`", ",", 
          "6.07942880151989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49601719433127`", ",", "0.269398460768562`", ",", 
          "1.20902457184809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43482272012378`", ",", "2.56656883981394`", ",", 
          "2.62180564935588`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0904429387367015`", ",", "2.26827845711266`", ",", 
          "4.03458672686366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02924846452921`", ",", "2.03241774332004`", ",", 
          "5.44736780437145`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96805399032172`", ",", "1.82193897126095`", ",", 
          "0.576963574699648`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90685951611423`", ",", "1.62244072365826`", ",", 
          "1.98974465220743`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56247973472715`", ",", "1.42501245155875`", ",", 
          "3.40252572971522`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.50128526051966`", ",", "1.22158428826156`", ",", 
          "4.81530680722301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.44009078631217`", ",", "1.00149109946588`", ",", 
          "6.22808788473079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0957110049251`", ",", "0.743747528577642`", ",", 
          "1.35768365505899`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03451653071761`", ",", "0.368618734202177`", ",", 
          "2.77046473256678`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97332205651012`", ",", "2.62657612190549`", ",", 
          "4.18324581007456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.628942275123039`", ",", "2.30958799233134`", ",", 
          "5.59602688758235`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56774780091555`", ",", "2.06747211574566`", ",", 
          "0.725622657910548`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50655332670806`", ",", "1.85419061372829`", ",", 
          "2.13840373541833`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.162173545320982`", ",", "1.65361764910743`", ",", 
          "3.55118481292612`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.10097907111349`", ",", "1.45638407149474`", ",", 
          "4.96396589043391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.039784596906`", ",", "1.25449628588659`", ",", 
          "0.093561660762105`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97859012269851`", ",", "1.03800266043452`", ",", 
          "1.50634273826989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63421034131143`", ",", "0.788611112024939`", ",", 
          "2.91912381577768`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57301586710394`", ",", "0.447062990561871`", ",", 
          "4.33190489328546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51182139289645`", ",", "2.69376485056221`", ",", 
          "5.74468597079325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16744161150938`", ",", "2.35251517323454`", ",", 
          "0.874281741121448`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10624713730189`", ",", "2.10320588296324`", ",", 
          "2.28706281862923`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0450526630944`", ",", "1.88674820866998`", ",", 
          "3.69984389613702`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.70067288170732`", ",", "1.68487550409145`", ",", 
          "5.11262497364481`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63947840749983`", ",", "1.48764295505703`", ",", 
          "0.242220743973005`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57828393329234`", ",", "1.28705736825708`", ",", 
          "1.65500182148079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.233904151905263`", ",", "1.07374411472232`", ",", 
          "3.06778289898858`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17270967769777`", ",", "0.831556964940938`", ",", 
          "4.48056397649636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11151520349028`", ",", "0.514344307835342`", ",", 
          "5.89334505400415`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.05032072928279`", ",", "2.7720566580265`", ",", 
          "1.02294082433235`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70594094789572`", ",", "2.39735650740372`", ",", 
          "2.43572190184013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64474647368822`", ",", "2.1397087313163`", ",", 
          "3.84850297934792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58355199948073`", ",", "1.91965622561793`", ",", 
          "5.26128405685571`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23917221809366`", ",", "1.71624575577206`", ",", 
          "0.390879827183905`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17797774388617`", ",", "1.51882057862474`", ",", 
          "1.80366090469169`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11678326967868`", ",", "1.3193120436197`", ",", 
          "3.21644198219948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.772403488291601`", ",", "1.10880528503088`", ",", 
          "4.62922305970726`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71120901408411`", ",", "0.872882385566253`", ",", 
          "6.04200413721505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.65001453987662`", ",", "0.57441508107492`", ",", 
          "1.17159990754325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.305634758489543`", ",", "2.87095367790216`", ",", 
          "2.58438098505103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24444028428205`", ",", "2.44449824204351`", ",", 
          "3.99716206255882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18324581007456`", ",", "2.17708472045173`", ",", 
          "5.40994314006661`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.12205133586707`", ",", "1.95296313282151`", ",", 
          "0.539538910394806`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77767155448`", ",", "1.74776088813772`", ",", 
          "1.95231998790259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7164770802725`", ",", "1.54994769535264`", ",", 
          "3.36510106541038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65528260606502`", ",", "1.35130149972759`", ",", 
          "4.77788214291816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.31090282467794`", ",", "1.14326447207671`", ",", 
          "6.19066322042595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24970835047045`", ",", "0.912821717455255`", ",", 
          "1.32025899075415`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18851387626296`", ",", "0.629358922349696`", ",", 
          "2.73304006826193`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.844134094875881`", ",", "3.03864426337609`", ",", 
          "4.14582114576972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78293962066839`", ",", "2.49446035364563`", ",", 
          "5.55860222327751`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7217451464609`", ",", "2.21545611269222`", ",", 
          "0.688197993605706`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.377365365073824`", ",", "1.98672222450839`", ",", 
          "2.10097907111349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31617089086633`", ",", "1.77945472477014`", ",", 
          "3.51376014862128`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25497641665884`", ",", "1.58105461392517`", ",", 
          "4.92654122612906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19378194245135`", ",", "1.3830641798111`", ",", 
          "0.056136996457263`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84940216106428`", ",", "1.17719066355266`", ",", 
          "1.46891807396505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78820768685679`", ",", "0.951563843328121`", ",", 
          "2.88169915147283`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7270132126493`", ",", "0.680433917188613`", ",", 
          "4.29448022898062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38263343126222`", ",", "0.227695077758219`", ",", 
          "5.70726130648841`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32143895705473`", ",", "2.54797271097039`", ",", 
          "0.836857076816606`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.26024448284724`", ",", "2.25496857364967`", ",", 
          "2.24963815432439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.915864701460161`", ",", "2.02099263387914`", ",", 
          "3.66241923183218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85467022725267`", ",", "1.81136278714139`", ",", 
          "5.07520030933996`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79347575304518`", ",", "1.61217146635575`", ",", 
          "0.204796079668163`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.449095971658104`", ",", "1.41463627305582`", ",", 
          "1.61757715717595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38790149745061`", ",", "1.21064525293996`", ",", 
          "3.03035823468373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32670702324312`", ",", "0.989263917512695`", ",", 
          "4.44313931219152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26551254903563`", ",", "0.728468899203768`", ",", 
          "5.85592038969931`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92113276764856`", ",", "0.339010918349805`", ",", 
          "0.985516160027506`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85993829344107`", ",", "2.60611787856534`", ",", 
          "2.39829723753529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79874381923358`", ",", "2.29579840121919`", ",", 
          "3.81107831504308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4543640378465`", ",", "2.05584059074514`", ",", 
          "5.22385939255086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39316956363901`", ",", "1.84352269976392`", ",", 
          "0.353455162879063`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33197508943152`", ",", "1.64332847147145`", ",", 
          "1.76623624038685`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.987595308044442`", ",", "1.44605213873095`", ",", 
          "3.17901731789464`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92640083383695`", ",", "1.24368339761235`", ",", 
          "4.59179839540242`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86520635962946`", ",", "1.02605150049111`", ",", 
          "6.00457947291021`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.520826578242385`", ",", "0.774044416646729`", ",", 
          "1.13417524323841`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45963210403489`", ",", "0.422714231616518`", ",", 
          "2.54695632074619`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3984376298274`", ",", "2.67062955550998`", ",", 
          "3.95973739825398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0540578484403274`", ",", "2.33816284706378`", ",", 
          "5.37251847576176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99286337423284`", ",", "2.09134100525101`", ",", 
          "0.502114246089964`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93166890002535`", ",", "1.87597465616324`", ",", 
          "1.91489532359775`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.87047442581786`", ",", "1.67455620051498`", ",", 
          "3.32767640110553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52609464443078`", ",", "1.47734467904985`", ",", 
          "4.74045747861332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46490017022329`", ",", "1.27635510754363`", ",", 
          "6.15323855612111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4037056960158`", ",", "1.06203636039935`", ",", 
          "1.28283432644931`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05932591462872`", ",", "0.817586119728559`", ",", 
          "2.69561540395709`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99813144042123`", ",", "0.493091734412251`", ",", 
          "4.10839648146488`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93693696621374`", ",", "2.74462324199535`", ",", 
          "5.52117755897266`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.592557184826665`", ",", "2.38233532348785`", ",", 
          "0.650773329300864`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53136271061918`", ",", "2.12757949236853`", ",", 
          "2.06355440680865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.47016823641168`", ",", "1.90876196328572`", ",", 
          "3.47633548431644`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.125788455024608`", ",", "1.70588585139794`", ",", 
          "4.88911656182422`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06459398081712`", ",", "1.50854567289256`", ",", 
          "0.018712332152421`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00339950660963`", ",", "1.30870613026429`", ",", 
          "1.43149340966021`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94220503240214`", ",", "1.09731271264738`", ",", 
          "2.84427448716799`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59782525101506`", ",", "0.859417384602029`", ",", 
          "4.25705556467578`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53663077680757`", ",", "0.555250592928428`", ",", 
          "5.66983664218357`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47543630260008`", ",", "2.83491610947462`", ",", 
          "0.799432412511764`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.131056521213`", ",", "2.42866866198971`", ",", 
          "2.21221349001955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06986204700551`", ",", "2.16465500194437`", ",", 
          "3.62499456752734`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00866757279802`", ",", "1.94193168697236`", ",", 
          "5.03777564503512`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.664287791410946`", ",", "1.73734953855913`", ",", 
          "0.167371415363321`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60309331720346`", ",", "1.53968608038345`", ",", 
          "1.58015249287111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.54189884299597`", ",", "1.34077868010046`", ",", 
          "2.99293357037889`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.197519061608888`", ",", "1.13196238496792`", ",", 
          "4.40571464788668`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1363245874014`", ",", "0.899791013009989`", ",", 
          "5.81849572539447`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07513011319391`", ",", "0.61171710396964`", ",", 
          "0.948091495722664`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01393563898642`", ",", "2.96499652584145`", ",", 
          "2.36087257323045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66955585759934`", ",", "2.4776323415745`", ",", 
          "3.77365365073824`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60836138339185`", ",", "2.20268329638352`", ",", 
          "5.18643472824602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54716690918436`", ",", "1.97553542808622`", ",", 
          "0.316030498574221`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20278712779728`", ",", "1.76898060615397`", ",", 
          "1.72881157608201`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14159265358979`", ",", "1.5707963267949`", ",", 
          "3.14159265358979`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0803981793823`", ",", "1.37261204743583`", ",", 
          "4.55437373109758`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.736018397995226`", ",", "1.16605722550357`", ",", 
          "5.96715480860537`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67482392378774`", ",", "0.938909357206271`", ",", 
          "1.09675057893356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61362944958025`", ",", "0.66396031201529`", ",", 
          "2.50953165644135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.269249668193169`", ",", "0.176596127748339`", ",", 
          "3.92231273394914`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20805519398568`", ",", "2.52987554962015`", ",", 
          "5.33509381145692`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14686071977819`", ",", "2.2418016405798`", ",", 
          "0.464689581785122`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0856662455707`", ",", "2.00963026862188`", ",", 
          "1.87747065929291`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74128646418362`", ",", "1.80081397348934`", ",", 
          "3.29025173680069`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.68009198997613`", ",", "1.60190657320635`", ",", 
          "4.70303281430848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61889751576864`", ",", "1.40424311503066`", ",", 
          "6.11581389181626`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27451773438156`", ",", "1.19966096661743`", ",", 
          "1.24540966214446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21332326017407`", ",", "0.976937651645421`", ",", 
          "2.65819073965225`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15212878596658`", ",", "0.712923991600084`", ",", 
          "4.07097181716004`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.807749004579507`", ",", "0.30667654411517`", ",", 
          "5.48375289466782`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74655453037202`", ",", "2.58634206066136`", ",", 
          "0.613348664996022`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68536005616453`", ",", "2.28217526898776`", ",", 
          "2.02612974250381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.340980274777449`", ",", "2.04427994094241`", ",", 
          "3.43891082001159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27978580056996`", ",", "1.83288652332551`", ",", 
          "4.85169189751938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21859132636247`", ",", "1.63304698069723`", ",", 
          "6.26447297502717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15739685215498`", ",", "1.43570680219185`", ",", 
          "1.39406874535536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8130170707679`", ",", "1.23283069030408`", ",", 
          "2.80684982286315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75182259656041`", ",", "1.01401316122126`", ",", 
          "4.21963090037094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.69062812235292`", ",", "0.759257330101943`", ",", 
          "5.63241197787872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34624834096584`", ",", "0.396969411594447`", ",", 
          "0.762007748206922`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28505386675835`", ",", "2.64850091917754`", ",", 
          "2.17478882571471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22385939255086`", ",", "2.32400653386123`", ",", 
          "3.58756990322249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.879479611163787`", ",", "2.07955629319044`", ",", 
          "5.00035098073028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8182851369563`", ",", "1.86523754604616`", ",", 
          "0.129946751058479`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75709066274881`", ",", "1.66424797453994`", ",", 
          "1.54272782856627`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.41271088136173`", ",", "1.46703645307481`", ",", 
          "2.95550890607405`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35151640715424`", ",", "1.26561799742655`", ",", 
          "4.36828998358184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.29032193294675`", ",", "1.05025164833878`", ",", 
          "5.78107106108962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22912745873926`", ",", "0.803429806526018`", ",", 
          "0.910666831417822`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88474767735218`", ",", "0.470963098079815`", ",", 
          "2.32344790892561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82355320314469`", ",", "2.71887842197328`", ",", 
          "3.73622898643339`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7623587289372`", ",", "2.36754823694306`", ",", 
          "5.14901006394118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41797894755013`", ",", "2.11554115309868`", ",", 
          "0.278605834269379`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35678447334263`", ",", "1.89790925597745`", ",", 
          "1.69138691177717`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29558999913515`", ",", "1.69554051485884`", ",", 
          "3.10416798928495`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.951210217748068`", ",", "1.49826418211834`", ",", 
          "4.51694906679274`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.89001574354058`", ",", "1.29806995382587`", ",", 
          "5.92973014430052`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82882126933309`", ",", "1.08575206284465`", ",", 
          "1.05932591462872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.484441487946011`", ",", "0.845794252370605`", ",", 
          "2.47210699213651`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42324701373852`", ",", "0.535474775024451`", ",", 
          "3.88488806964429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36205253953103`", ",", "2.80258173523999`", ",", 
          "5.29766914715208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0176727581439532`", ",", "2.41312375438603`", ",", 
          "0.42726491748028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95647828393646`", ",", "2.1523287360771`", ",", 
          "1.84004599498807`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89528380972897`", ",", "1.93094740064984`", ",", 
          "3.25282707249585`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83408933552148`", ",", "1.72695638053397`", ",", 
          "4.66560815000364`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48970955413441`", ",", "1.52942118723404`", ",", 
          "6.07838922751142`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42851507992691`", ",", "1.3302298664484`", ",", 
          "1.20798499783962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36732060571943`", ",", "1.12060001971065`", ",", 
          "2.62076607534741`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02294082433235`", ",", "0.886624079940127`", ",", 
          "4.03354715285519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96174635012486`", ",", "0.5936199426194`", ",", 
          "5.44632823036298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.90055187591737`", ",", "2.91389757583157`", ",", 
          "0.57592400069118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.556172094530291`", ",", "2.46115873640118`", ",", 
          "1.98870507819897`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4949776203228`", ",", "2.19002881026167`", ",", 
          "3.40148615570675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43378314611531`", ",", "1.96440199003713`", ",", 
          "4.81426723321454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0894033647282337`", ",", "1.75852847377869`", ",", 
          "6.22704831072232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02820889052074`", ",", "1.56053803966462`", ",", 
          "1.35664408105052`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96701441631325`", ",", "1.36213792881965`", ",", 
          "2.76942515855831`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90581994210576`", ",", "1.1548704290814`", ",", 
          "4.18220623606609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56144016071869`", ",", "0.926136540897569`", ",", 
          "5.59498731357388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5002456865112`", ",", "0.647132299944162`", ",", 
          "0.72458308390208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43905121230371`", ",", "0.1029483902137`", ",", 
          "2.13736416140987`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09467143091663`", ",", "2.5122337312401`", ",", 
          "3.55014523891765`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03347695670914`", ",", "2.22877093613454`", ",", 
          "4.96292631642544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97228248250165`", ",", "1.99832818151309`", ",", 
          "0.0925220867536372`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.627902701114572`", ",", "1.7902911538622`", ",", 
          "1.50530316426142`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56670822690708`", ",", "1.59164495823715`", ",", 
          "2.91808424176921`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50551375269959`", ",", "1.39383176545208`", ",", 
          "4.33086531927699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.161133971312514`", ",", "1.18862952076828`", ",", 
          "5.74364639678478`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09993949710502`", ",", "0.964507933138062`", ",", 
          "0.87324216711298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03874502289753`", ",", "0.697094411546279`", ",", 
          "2.28602324462077`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97755054869004`", ",", "0.270638975687634`", ",", 
          "3.69880432212855`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63317076730297`", ",", "2.56717757251487`", ",", 
          "5.11158539963634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57197629309548`", ",", "2.26871026802354`", ",", 
          "0.241181169964537`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.51078181888799`", ",", "2.03278736855891`", ",", 
          "1.65396224747232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16640203750091`", ",", "1.8222806099701`", ",", 
          "3.06674332498011`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10520756329342`", ",", "1.62277207496506`", ",", 
          "4.4795244024879`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04401308908593`", ",", "1.42534689781773`", ",", 
          "5.89230547999568`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.699633307698852`", ",", "1.22193642797186`", ",", 
          "1.02190125032388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63843883349136`", ",", "1.0018839222735`", ",", 
          "2.43468232783167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57724435928387`", ",", "0.744236146186078`", ",", 
          "3.84746340533945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.232864577896795`", ",", "0.369535995563293`", ",", 
          "5.26024448284724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1716701036893`", ",", "2.62724834575445`", ",", 
          "0.389840253175438`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.11047562948181`", ",", "2.31003568864885`", ",", 
          "1.80262133068322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04928115527432`", ",", "2.06784853886747`", ",", 
          "3.21540240819101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70490137388725`", ",", "1.85453528533271`", ",", 
          "4.6281834856988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64370689967976`", ",", "1.65394969853276`", ",", 
          "6.04096456320658`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58251242547227`", ",", "1.45671714949834`", ",", 
          "1.17056033353478`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23813264408519`", ",", "1.25484444491981`", ",", 
          "2.58334141104257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1769381698777`", ",", "1.03838677062655`", ",", 
          "3.99612248855035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11574369567021`", ",", "0.789077480355256`", ",", 
          "5.40890356605814`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.771363914283133`", ",", "0.447827803027579`", ",", 
          "0.538499336386338`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.71016944007564`", ",", "2.69452966302792`", ",", 
          "1.95128041389412`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64897496586815`", ",", "2.35298154156485`", ",", 
          "3.36406149140191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.304595184481075`", ",", "2.10358999315527`", ",", 
          "4.7768425689097`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24340071027359`", ",", "1.8870963677032`", ",", 
          "6.18962364641748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18220623606609`", ",", "1.68520858209506`", ",", 
          "1.31921941674568`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1210117618586`", ",", "1.48797500448237`", ",", 
          "2.73200049425347`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77663198047153`", ",", "1.2874020398615`", ",", 
          "4.14478157176125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71543750626404`", ",", "1.07412053784413`", ",", 
          "5.55756264926904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65424303205655`", ",", "0.832004661258452`", ",", 
          "0.687158419597238`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30986325066947`", ",", "0.5150165316843`", ",", 
          "2.09993949710502`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24866877646198`", ",", "2.77297391938762`", ",", 
          "3.51272057461281`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18747430225449`", ",", "2.39784512501215`", ",", 
          "4.9255016521206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.843094520867413`", ",", "2.14010155412391`", ",", 
          "0.0550974224487952`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78190004665992`", ",", "1.92000836532823`", ",", 
          "1.46787849995658`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.72070557245243`", ",", "1.71658020203105`", ",", 
          "2.88065957746437`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.376325791065356`", ",", "1.51915192993154`", ",", 
          "4.29344065497215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31513131685787`", ",", "1.31965368232884`", ",", 
          "5.70622173247994`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25393684265038`", ",", "1.10917491026975`", ",", 
          "0.835817502808138`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19274236844289`", ",", "0.873314196477133`", ",", 
          "2.24859858031592`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84836258705581`", ",", "0.575023813775851`", ",", 
          "3.66137965782371`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78716811284832`", ",", "2.87219419282123`", ",", 
          "5.0741607353315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72597363864083`", ",", "2.44501383767766`", ",", 
          "0.203756505659695`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38159385725375`", ",", "2.17748745291625`", ",", 
          "1.61653758316748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.32039938304626`", ",", "1.95331979315733`", ",", 
          "3.02931866067527`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25920490883877`", ",", "1.74809705482747`", ",", 
          "4.44209973818305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.914825127451694`", ",", "1.55027867283076`", ",", 
          "5.85488081569084`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8536306532442`", ",", "1.35164052801794`", ",", 
          "0.984476586019038`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79243617903671`", ",", "1.14362807892953`", ",", 
          "2.39725766352682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.448056397649636`", ",", "0.913239866696613`", ",", 
          "3.81003874103461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38686192344215`", ",", "0.629920872902416`", ",", 
          "5.2228198185424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32566744923466`", ",", "3.04191605724159`", ",", 
          "0.352415588870596`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26447297502717`", ",", "2.49500941055905`", ",", 
          "1.76519666637838`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.92009319364009`", ",", "2.21587017054756`", ",", 
          "3.17797774388617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8588987194326`", ",", "1.98708400182873`", ",", 
          "4.59075882139395`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79770424522511`", ",", "1.77979298017087`", ",", 
          "6.00353989890174`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45332446383803`", ",", "1.58138553858907`", ",", 
          "1.13313566922994`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39212998963054`", ",", "1.38340099373158`", ",", 
          "2.54591674673772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.33093551542305`", ",", "1.17754894241878`", ",", 
          "3.95869782424551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.986555734035974`", ",", "0.951970141947948`", ",", 
          "5.3714789017533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92536125982848`", ",", "0.680959721166537`", ",", 
          "0.501074672081496`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86416678562099`", ",", "0.22915639305387`", ",", 
          "1.91385574958928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.519787004233917`", ",", "2.54856454578596`", ",", 
          "3.32663682709707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45859253002643`", ",", "2.25539565610358`", ",", 
          "4.73941790460485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39739805581894`", ",", "2.02136019292371`", ",", 
          "6.15219898211264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0530182744318595`", ",", "1.81170351967953`", ",", 
          "1.28179475244084`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.99182380022437`", ",", "1.61250265875872`", ",", 
          "2.69457582994862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.93062932601688`", ",", "1.41497124705915`", ",", 
          "4.10735690745641`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86943485180939`", ",", "1.21099882127728`", ",", 
          "5.5201379849642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52505507042231`", ",", "0.989659866500586`", ",", 
          "0.649733755292396`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46386059621482`", ",", "0.728965820784404`", ",", 
          "2.06251483280018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40266612200733`", ",", "0.340004563609998`", ",", 
          "3.47529591030797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05828634062025`", ",", "2.60676675291783`", ",", 
          "4.88807698781575`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99709186641276`", ",", "2.29624058209901`", ",", 
          "0.0176727581439532`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93589739220527`", ",", "2.05621467959708`", ",", 
          "1.43045383565174`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.591517610818197`", ",", "1.8438663226216`", ",", 
          "2.84323491315952`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.53032313661071`", ",", "1.64366025450864`", ",", 
          "4.25601599066731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46912866240322`", ",", "1.44638562988625`", ",", 
          "5.6687970681751`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.12474888101614`", ",", "1.24403281280149`", ",", 
          "0.798392838503296`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06355440680865`", ",", "1.02643836307001`", ",", 
          "2.21117391601108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00235993260116`", ",", "0.774517679829924`", ",", 
          "3.62395499351887`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.94116545839367`", ",", "0.423520132444311`", ",", 
          "5.03673607102665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59678567700659`", ",", "2.67135935796482`", ",", 
          "0.166331841354853`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5355912027991`", ",", "2.33862270679314`", ",", 
          "1.57911291886264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47439672859161`", ",", "2.09172247431392`", ",", 
          "2.99189399637042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.13001694720454`", ",", "1.87632161262195`", ",", 
          "4.40467507387821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06882247299704`", ",", "1.67488890228365`", ",", 
          "5.817456151386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00762799878955`", ",", "1.47767703077948`", ",", 
          "0.947051921714196`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.663248217402478`", ",", "1.27670087727621`", ",", 
          "2.35983299922198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60205374319499`", ",", "1.06241521428574`", ",", 
          "3.77261407672977`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5408592689875`", ",", "0.818039632767962`", ",", 
          "5.18539515423755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.196479487600421`", ",", "0.493790352030413`", ",", 
          "0.314990924565754`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13528501339293`", ",", "2.74548000250205`", ",", 
          "1.72777200207354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07409053918544`", ",", "2.38281614676822`", ",", 
          "3.14055307958133`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01289606497795`", ",", "2.12796931880998`", ",", 
          "4.55333415708911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66851628359087`", ",", "1.90911273301569`", ",", 
          "5.9661152345969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60732180938338`", ",", "1.70621980818602`", ",", 
          "1.0957110049251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54612733517589`", ",", "1.50887721834954`", ",", 
          "2.50849208243288`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20174755378882`", ",", "1.30904872104758`", ",", 
          "3.92127315994067`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.14055307958133`", ",", "1.09768448869367`", ",", 
          "5.33405423744846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07935860537383`", ",", "0.859854164639225`", ",", 
          "0.463650007776654`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.734978823986758`", ",", "0.555877995997127`", ",", 
          "1.87643108528444`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67378434977927`", ",", "2.83601412310438`", ",", 
          "3.28921216279222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61258987557178`", ",", "2.42917474618397`", ",", 
          "4.70199324030001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.268210094184701`", ",", "2.16505432171381`", ",", 
          "6.1147743178078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20701561997721`", ",", "1.94228679354172`", ",", 
          "1.244370088136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14582114576972`", ",", "1.73768509803966`", ",", 
          "2.65715116564378`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08462667156223`", ",", "1.54001714556655`", ",", 
          "4.06993224315157`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.74024689017515`", ",", "1.34111852431571`", ",", 
          "5.48271332065935`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67905241596766`", ",", "1.13232789631147`", ",", 
          "0.612309090987554`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61785794176017`", ",", "0.90021344979438`", ",", 
          "2.02509016849534`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2734781603731`", ",", "0.61229308492057`", ",", 
          "3.43787124600313`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21228368616561`", ",", "2.96689015372575`", ",", 
          "4.85065232351091`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15108921195812`", ",", "2.47816950237543`", ",", 
          "6.2634334010187`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.806709430571039`", ",", "2.20309344693624`", ",", 
          "1.3930291713469`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74551495636355`", ",", "1.9758954480511`", ",", 
          "2.80581024885468`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68432048215606`", ",", "1.76931813087313`", ",", 
          "4.21859132636247`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.339940700768982`", ",", "1.57112723348525`", ",", 
          "5.63137240387025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27874622656149`", ",", "1.3729495492785`", ",", 
          "0.760968174198454`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.217551752354`", ",", "1.16641718995141`", ",", 
          "2.17374925170624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15635727814651`", ",", "0.939319384654865`", ",", 
          "3.58653032921403`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81197749675943`", ",", "0.664497104311628`", ",", 
          "4.99931140672181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.75078302255194`", ",", "0.178469871769975`", ",", 
          "0.128907177050011`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68958854834445`", ",", "2.53045200389587`", ",", 
          "1.5416882545578`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34520876695738`", ",", "2.24222421908399`", ",", 
          "2.95446933206558`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28401429274989`", ",", "2.00999584268158`", ",", 
          "4.36725040957337`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2228198185424`", ",", "1.80115384475107`", ",", 
          "5.78003148708115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.878440037155319`", ",", "1.6022376418004`", ",", 
          "0.909627257409354`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81724556294783`", ",", "1.40457865558298`", ",", 
          "2.32240833491714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75605108874034`", ",", "1.20001602411897`", ",", 
          "3.73518941242493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.411671307353262`", ",", "0.977336863785571`", ",", 
          "5.14797048993271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.35047683314577`", ",", "0.713429779745474`", ",", 
          "0.277566260260912`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28928235893828`", ",", "0.307770763614028`", ",", 
          "1.6903473377687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22808788473079`", ",", "2.58697009890626`", ",", 
          "3.10312841527648`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88370810334371`", ",", "2.28261221352301`", ",", 
          "4.51590949278427`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82251362913622`", ",", "2.04465178781876`", ",", 
          "5.92869057029206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76131915492873`", ",", "1.83322914559706`", ",", 
          "1.05828634062025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41693937354166`", ",", "1.63337853300594`", ",", 
          "2.47106741812804`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35574489933417`", ",", "1.43604074382214`", ",", 
          "3.88384849563583`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29455042512668`", ",", "1.23318141679723`", ",", 
          "5.29662957314361`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.9501706437396`", ",", "1.01440289309111`", ",", 
          "0.426225343471812`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88897616953211`", ",", "0.759737909900187`", ",", 
          "1.8390064209796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82778169532462`", ",", "0.397824424728191`", ",", 
          "3.25178749848738`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.483401913937543`", ",", "2.64920044623617`", ",", 
          "4.66456857599517`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42220743973005`", ",", "2.32446023982493`", ",", 
          "6.07734965350296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.36101296552256`", ",", "2.07993522714515`", ",", 
          "1.20694542383115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0166331841354853`", ",", "1.86558335203883`", ",", 
          "2.61972650133894`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.955438709928`", ",", "1.6645803366225`", ",", 
          "4.03250757884673`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8942442357205`", ",", "1.46736914331725`", ",", 
          "5.44528865635451`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83304976151301`", ",", "1.26596491596777`", ",", 
          "0.574884426682712`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48866998012594`", ",", "1.05063303399622`", ",", 
          "1.9876655041905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42747550591845`", ",", "0.803889462366867`", ",", 
          "3.40044658169828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36628103171096`", ",", "0.47169185600821`", ",", 
          "4.81322765920607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02190125032388`", ",", "2.71968576921438`", ",", 
          "6.22600873671386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.96070677611639`", ",", "2.36802172935994`", ",", 
          "1.35560450704206`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8995123019089`", ",", "2.11592810637912`", ",", 
          "2.76838558454984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.555132520521823`", ",", "1.89825871259724`", ",", 
          "4.18116666205763`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49393804631433`", ",", "1.69587401996073`", ",", 
          "5.59394773956541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43274357210684`", ",", "1.49859595715735`", ",", 
          "0.723543509893612`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0883637907197659`", ",", "1.2984135436612`", ",", 
          "2.1363245874014`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02716931651228`", ",", "1.08612607795596`", ",", 
          "3.54910566490918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96597484230479`", ",", "0.846236260092462`", ",", 
          "4.96188674241697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90478036809729`", ",", "0.536122940491372`", ",", 
          "0.0914825127451694`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.56040058671022`", ",", "2.80357818837515`", ",", 
          "1.50426359025296`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49920611250273`", ",", "2.41362095289864`", ",", 
          "2.91704466776074`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43801163829524`", ",", "2.15272478814997`", ",", 
          "4.32982574526853`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09363185690816`", ",", "1.93130101606933`", ",", 
          "5.74260682277631`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03243738270067`", ",", "1.72729137220442`", ",", 
          "0.872202593104512`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97124290849318`", ",", "1.5297523750961`", ",", 
          "2.2849836706123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.626863127106104`", ",", "1.33057057050793`", ",", 
          "3.69776474812008`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56566865289861`", ",", "1.12096751347353`", ",", 
          "5.11054582562787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50447417869112`", ",", "0.887051013683517`", ",", 
          "0.24014159595607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.160094397304046`", ",", "0.594211258828113`", ",", 
          "1.65292267346386`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09889992309656`", ",", "2.91536816569026`", ",", 
          "3.06570375097164`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03770544888907`", ",", "2.46168488218379`", ",", 
          "4.47848482847943`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97651097468158`", ",", "2.1904352265755`", ",", 
          "5.89126590598721`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6321311932945`", ",", "1.96476032221759`", ",", 
          "1.02086167631541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.57093671908701`", ",", "1.75886530925134`", ",", 
          "2.4336427538232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50974224487952`", ",", "1.56086896320509`", ",", 
          "3.84642383133098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16536246349244`", ",", "1.36247615999549`", ",", 
          "5.25920490883877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10416798928495`", ",", "1.15523214860071`", ",", 
          "0.38880067916697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04297351507746`", ",", "0.926550469899416`", ",", 
          "1.80158175667476`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.698593733690384`", ",", "0.647680958221848`", ",", 
          "3.21436283418254`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63739925948289`", ",", "0.106119703850723`", ",", 
          "4.62714391169033`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5762047852754`", ",", "2.51279611582387`", ",", 
          "6.03992498919811`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.231825003888327`", ",", "2.22918922055404`", ",", 
          "1.16952075952631`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.17063052968084`", ",", "1.99869184861565`", ",", 
          "2.5823018370341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10943605547335`", ",", "1.79063020779638`", ",", 
          "3.99508291454188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04824158126586`", ",", "1.59197593799951`", ",", 
          "5.40786399204967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70386179987878`", ",", "1.39416791193322`", ",", 
          "0.53745976237787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64266732567129`", ",", "1.18898612998361`", ",", 
          "1.95024083988566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5814728514638`", ",", "0.964910553167663`", ",", 
          "3.36302191739344`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23709307007672`", ",", "0.697609689893067`", ",", 
          "4.77580299490123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17589859586923`", ",", "0.271873968658439`", ",", 
          "6.18858407240901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11470412166174`", ",", "2.56778687829343`", ",", 
          "1.31817984273721`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.770324340274665`", ",", "2.269142235381`", ",", 
          "2.730960920245`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70912986606717`", ",", "2.03315706183905`", ",", 
          "4.14374199775279`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64793539185968`", ",", "1.82262227866923`", ",", 
          "5.55652307526057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.303555610472607`", ",", "1.62310343198371`", ",", 
          "0.68611884558877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24236113626512`", ",", "1.42568132769266`", ",", 
          "2.09889992309656`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18116666205763`", ",", "1.22228852258368`", ",", 
          "3.51168100060434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11997218785014`", ",", "1.00227664643479`", ",", 
          "4.92446207811213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77559240646306`", ",", "0.744724504674304`", ",", 
          "0.0540578484403274`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71439793225557`", ",", "0.37045108982029`", ",", 
          "1.46683892594811`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65320345804808`", ",", "2.62792137024501`", ",", 
          "2.8796200034559`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.308823676661`", ",", "2.310483567774`", ",", 
          "4.29240108096368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24762920245351`", ",", "2.06822503887151`", ",", 
          "5.70518215847147`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18643472824602`", ",", "1.85487999158307`", ",", 
          "0.83477792879967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.842054946858945`", ",", "1.65428175714777`", ",", 
          "2.24755900630746`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.78086047265145`", ",", "1.45705021479119`", ",", 
          "3.66034008381524`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71966599844397`", ",", "1.25519256433213`", ",", 
          "5.07312116132303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.375286217056888`", ",", "1.03877079391344`", ",", 
          "0.202716931651228`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3140917428494`", ",", "0.789543632880655`", ",", 
          "1.61549800915901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25289726864191`", ",", "0.448591399766913`", ",", 
          "3.0282790866668`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19170279443442`", ",", "2.69529569749477`", ",", 
          "4.44106016417459`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84732301304734`", ",", "2.35344812610166`", ",", 
          "5.85384124168237`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78612853883985`", ",", "2.10397419036818`", ",", 
          "0.983437012010571`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72493406463236`", ",", "1.88744456641309`", ",", 
          "2.39621808951836`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.38055428324528`", ",", "1.68554167284783`", ",", 
          "3.80899916702614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31935980903779`", ",", "1.4883070447554`", ",", 
          "5.22178024453393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2581653348303`", ",", "1.28774667687135`", ",", 
          "0.351376014862128`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.913785553443226`", ",", "1.07449688418411`", ",", 
          "1.76415709236991`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85259107923574`", ",", "0.832452175081621`", ",", 
          "3.1769381698777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79139660502825`", ",", "0.515687958044939`", ",", 
          "4.58971924738549`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.447016823641168`", ",", "2.7738933640997`", ",", 
          "6.00250032489327`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38582234943368`", ",", "2.39833400227054`", ",", 
          "1.13209609522147`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32462787522619`", ",", "2.14049447571288`", ",", 
          "2.54487717272926`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.2634334010187`", ",", "1.92036055019802`", ",", 
          "3.95765825023704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91905361963162`", ",", "1.7169146647139`", ",", 
          "5.37043932774483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85785914542413`", ",", "1.51948327556316`", ",", 
          "0.500035098073028`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79666467121664`", ",", "1.31999529109576`", ",", 
          "1.91281617558081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45228488982956`", ",", "1.10954446755539`", ",", 
          "3.3255972530886`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.39109041562207`", ",", "0.873745851191724`", ",", 
          "4.73837833059639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32989594141458`", ",", "0.575631975238071`", ",", 
          "6.15115940810417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.985516160027506`", ",", "2.87344030636253`", ",", 
          "1.28075517843237`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92432168582002`", ",", "2.44552975132333`", ",", 
          "2.69353625594016`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86312721161253`", ",", "2.1778902979753`", ",", 
          "4.10631733344794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.518747430225449`", ",", "1.95367650468101`", ",", 
          "5.51909841095573`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45755295601796`", ",", "1.74843324176748`", ",", 
          "0.648694181283928`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39635848181047`", ",", "1.55060964806096`", ",", 
          "2.06147525879171`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0519787004233917`", ",", "1.35197953070922`", ",", 
          "3.4742563362995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9907842262159`", ",", "1.14399162561059`", ",", 
          "4.88703741380729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92958975200841`", ",", "0.913657880963838`", ",", 
          "0.0166331841354853`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86839527780092`", ",", "0.630482390604502`", ",", 
          "1.42941426164327`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52401549641384`", ",", "3.04529857297306`", ",", 
          "2.84219533915106`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46282102220635`", ",", "2.49555886714424`", ",", 
          "4.25497641665884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.40162654799886`", ",", "2.21628435744786`", ",", 
          "5.66775749416663`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05724676661179`", ",", "1.98744583702519`", ",", 
          "0.797353264494828`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9960522924043`", ",", "1.78013125984041`", ",", 
          "2.21013434200261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93485781819681`", ",", "1.58171646441265`", ",", 
          "3.6229154195104`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.590478036809729`", ",", "1.38373778614224`", ",", 
          "5.03569649701819`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52928356260224`", ",", "1.17790716804033`", ",", 
          "0.165292267346386`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46808908839475`", ",", "0.952376323042977`", ",", 
          "1.57807334485417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.123709307007672`", ",", "0.681485184150147`", ",", 
          "2.99085442236196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06251483280018`", ",", "0.230608610142396`", ",", 
          "4.40363549986974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00132035859269`", ",", "2.54915690078313`", ",", 
          "5.81641657737753`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9401258843852`", ",", "2.25582288750151`", ",", 
          "0.946012347705729`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59574610299812`", ",", "2.02172781733446`", ",", 
          "2.35879342521351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53455162879063`", ",", "1.812044280743`", ",", 
          "3.7715745027213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47335715458314`", ",", "1.6128338557391`", ",", 
          "5.18435558022909`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12897737319607`", ",", "1.41530620343575`", ",", 
          "0.313951350557286`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06778289898858`", ",", "1.21135234259541`", ",", 
          "1.72673242806507`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00658842478109`", ",", "0.990055712545973`", ",", 
          "3.13951350557286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.66220864339401`", ",", "0.729462466017789`", ",", 
          "4.55229458308064`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.60101416918652`", ",", "0.340995425571817`", ",", 
          "5.96507566058843`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53981969497903`", ",", "2.60741633876098`", ",", 
          "1.09467143091663`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.195439913591953`", ",", "2.29668293642702`", ",", 
          "2.50745250842441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13424543938446`", ",", "2.05658884228567`", ",", 
          "3.9202335859322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07305096517697`", ",", "1.84420997855174`", ",", 
          "5.33301466343999`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01185649096948`", ",", "1.64399204558111`", ",", 
          "0.462610433768186`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66747670958241`", ",", "1.44671910713379`", ",", 
          "1.87539151127597`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60628223537491`", ",", "1.24438218661735`", ",", 
          "3.28817258878376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54508776116742`", ",", "1.02682513506897`", ",", 
          "4.70095366629154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.20070797978035`", ",", "0.774990714217904`", ",", 
          "6.11373474379933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13951350557286`", ",", "0.42432459512569`", ",", 
          "1.24333051412753`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07831903136537`", ",", "2.67209020984076`", ",", 
          "2.65611159163531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.733939249978291`", ",", "2.33908277077995`", ",", 
          "4.0688926691431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6727447757708`", ",", "2.09210402689258`", ",", 
          "5.48167374665089`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61155030156331`", ",", "1.87666860705237`", ",", 
          "0.611269516979086`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.267170520176233`", ",", "1.67522161561656`", ",", 
          "2.02405059448687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20597604596874`", ",", "1.47800937219385`", ",", 
          "3.43683167199466`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14478157176125`", ",", "1.27704661080143`", ",", 
          "4.84961274950244`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08358709755376`", ",", "1.06279398820888`", ",", 
          "6.26239382701023`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73920731616669`", ",", "0.818492953222128`", ",", 
          "1.39198959733843`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67801284195919`", ",", "0.494488064085596`", ",", 
          "2.80477067484621`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61681836775171`", ",", "2.74633852177171`", ",", 
          "4.217551752354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27243858636463`", ",", "2.3832972140125`", ",", 
          "5.63033282986179`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21124411215714`", ",", "2.12835923995119`", ",", 
          "0.759928600189986`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.15004963794965`", ",", "1.90946354604166`", ",", 
          "2.17270967769777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.805669856562571`", ",", "1.70655378017119`", ",", 
          "3.58549075520556`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74447538235508`", ",", "1.50920875699164`", ",", 
          "4.99827183271334`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68328090814759`", ",", "1.30939128039148`", ",", 
          "0.127867603041544`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.338901126760514`", ",", "1.09805619400174`", ",", 
          "1.54064868054933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27770665255302`", ",", "0.860290780447254`", ",", 
          "2.95342975805712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21651217834553`", ",", "0.556504766059149`", ",", 
          "4.3662108355649`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15531770413804`", ",", "2.8371159719463`", ",", 
          "5.77899191307269`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.81093792275097`", ",", "2.4296811270774`", ",", 
          "0.908587683400887`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74974344854348`", ",", "2.16545374926335`", ",", 
          "2.32136876090867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68854897433599`", ",", "1.94264194924403`", ",", 
          "3.73414983841646`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34416919294891`", ",", "1.7380206764894`", ",", 
          "5.14693091592424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28297471874142`", ",", "1.54034820737509`", ",", 
          "0.276526686252444`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22178024453393`", ",", "1.34145834153017`", ",", 
          "1.68930776376023`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.877400463146852`", ",", "1.13269334501994`", ",", 
          "3.10208884126802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81620598893936`", ",", "0.900635745076781`", ",", 
          "4.5148699187758`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75501151473187`", ",", "0.612868593901356`", ",", 
          "5.92765099628359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.410631733344794`", ",", "2.96880431926426`", ",", 
          "1.05724676661179`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3494372591373`", ",", "2.47870703259622`", ",", 
          "2.47002784411957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28824278492981`", ",", "2.20350372077308`", ",", 
          "3.88280892162736`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22704831072232`", ",", "1.97625552360539`", ",", 
          "5.29558999913515`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88266852933525`", ",", "1.76965567851191`", ",", 
          "0.425185769463344`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82147405512776`", ",", "1.57145814021184`", ",", 
          "1.83796684697113`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.76027958092027`", ",", "1.37328702828775`", ",", 
          "3.25074792447892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41589979953319`", ",", "1.16677709895451`", ",", 
          "4.6635290019867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3547053253257`", ",", "0.93972928917899`", ",", 
          "6.07631007949449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29351085111821`", ",", "0.665033529015108`", ",", 
          "1.20590584982269`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.949131069731132`", ",", "0.180324351822258`", ",", 
          "2.61868692733047`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88793659552364`", ",", "2.53102893285721`", ",", 
          "4.03146800483826`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82674212131615`", ",", "2.24264693952622`", ",", 
          "5.44424908234604`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.482362339929075`", ",", "2.0103614795386`", ",", 
          "0.573844852674244`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42116786572158`", ",", "1.801493743105`", ",", 
          "1.98662593018203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35997339151409`", ",", "1.60256871384179`", ",", 
          "3.39940700768982`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0155936101270175`", ",", "1.40491417724807`", ",", 
          "4.8121880851976`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95439913591953`", ",", "1.20037103261779`", ",", 
          "6.22496916270539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89320466171204`", ",", "0.977735968446988`", ",", 
          "1.35456493303359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83201018750455`", ",", "0.713935272490104`", ",", 
          "2.76734601054137`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48763040611747`", ",", "0.308861229340261`", ",", 
          "4.18012708804916`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42643593190998`", ",", "2.58759877450887`", ",", 
          "5.59290816555694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36524145770249`", ",", "2.28304932282582`", ",", 
          "0.722503935885144`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.02086167631541`", ",", "2.0450237056171`", ",", 
          "2.13528501339293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95966720210792`", ",", "1.83357179940578`", ",", 
          "3.54806609090072`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89847272790043`", ",", "1.63371009220326`", ",", 
          "4.9608471684085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.554092946513355`", ",", "1.43637467033395`", ",", 
          "0.0904429387367015`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49289847230586`", ",", "1.23353210011268`", ",", 
          "1.50322401624449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43170399809837`", ",", "1.01479253051729`", ",", 
          "2.91600509375227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.087324216711298`", ",", "0.760218246696642`", ",", 
          "4.32878617126006`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02612974250381`", ",", "0.39867770175818`", ",", 
          "5.74156724876784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96493526829632`", ",", "2.64990088663983`", ",", 
          "0.871163019096045`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90374079408883`", ",", "2.32491413905284`", ",", 
          "2.28394409660383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55936101270175`", ",", "2.08031424127341`", ",", 
          "3.69672517411162`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49816653849426`", ",", "1.86592919434435`", ",", 
          "5.1095062516194`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43697206428677`", ",", "1.66491270909567`", ",", 
          "0.239102021947602`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09259228289969`", ",", "1.46770182207148`", ",", 
          "1.65188309945539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0313978086922`", ",", "1.26631179664567`", ",", 
          "3.06466417696317`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.97020333448471`", ",", "1.05101433635831`", ",", 
          "4.47744525447096`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.625823553097636`", ",", "0.804348914687146`", ",", 
          "5.89022633197875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56462907889015`", ",", "0.472419574267662`", ",", 
          "1.01982210230694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50343460468266`", ",", "2.72049457121392`", ",", 
          "2.43260317981473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.159054823295579`", ",", "2.36849545145023`", ",", 
          "3.84538425732252`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09786034908809`", ",", "2.1163151504829`", ",", 
          "5.2581653348303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0366658748806`", ",", "1.89860821070513`", ",", 
          "0.387761105158502`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97547140067311`", ",", "1.69620753904805`", ",", 
          "1.80054218266629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63109161928603`", ",", "1.49892772423528`", ",", 
          "3.21332326017407`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56989714507854`", ",", "1.29875710052426`", ",", 
          "4.62610433768186`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50870267087105`", ",", "1.08650001942251`", ",", 
          "6.03888541518965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16432288948397`", ",", "0.846678094945876`", ",", 
          "1.16848118551785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10312841527648`", ",", "0.536770399662416`", ",", 
          "2.58126226302563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04193394106899`", ",", "2.80457747432228`", ",", 
          "3.99404334053342`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.697554159681916`", ",", "2.41411842892986`", ",", 
          "5.4068244180412`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63635968547443`", ",", "2.15312094345055`", ",", 
          "0.536420188369402`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57516521126694`", ",", "1.93165467863403`", ",", 
          "1.94920126587719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.230785429879859`", ",", "1.72762638158237`", ",", 
          "3.36198234338497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16959095567237`", ",", "1.53008355845377`", ",", 
          "4.77476342089276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10839648146488`", ",", "1.33091124613552`", ",", 
          "6.18754449840055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04720200725739`", ",", "1.12133494203909`", ",", 
          "1.31714026872875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70282222587031`", ",", "0.887477798949354`", ",", 
          "2.72992134623653`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64162775166282`", ",", "0.594802057997123`", ",", 
          "4.14270242374432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.58043327745533`", ",", "2.91684821221751`", ",", 
          "5.5554835012521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23605349606825`", ",", "2.46221137058447`", ",", 
          "0.685079271580302`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17485902186076`", ",", "2.19084176075286`", ",", 
          "2.09786034908809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11366454765327`", ",", "1.96511870778221`", ",", 
          "3.51064142659587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.769284766266197`", ",", "1.75920216631851`", ",", 
          "4.92342250410366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70809029205871`", ",", "1.56119988565837`", ",", 
          "0.0530182744318595`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64689581785122`", ",", "1.36281436699032`", ",", 
          "1.46579935193965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.30251603646414`", ",", "1.15559381039398`", ",", 
          "2.87858042944743`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24132156225665`", ",", "0.926964270238848`", ",", 
          "4.29136150695522`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.18012708804916`", ",", "0.648229218895621`", ",", 
          "5.704142584463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11893261384167`", ",", "0.109199291995607`", ",", 
          "0.833738354791203`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77455283245459`", ",", "2.51335893562422`", ",", 
          "2.24651943229899`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7133583582471`", ",", "2.22960764035614`", ",", 
          "3.65930050980677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65216388403961`", ",", "1.99905557604604`", ",", 
          "5.07208158731456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30778410265253`", ",", "1.79096928741921`", ",", 
          "0.20167735764276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24658962844504`", ",", "1.59230692008241`", ",", 
          "1.61445843515055`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18539515423755`", ",", "1.39450403824736`", ",", 
          "3.02723951265833`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.841015372850477`", ",", "1.18934268814576`", ",", 
          "4.44002059016612`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77982089864299`", ",", "0.965313060921677`", ",", 
          "5.8528016676739`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7186264244355`", ",", "0.698124651674095`", ",", 
          "0.982397438002103`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.37424664304842`", ",", "0.273103514629982`", ",", 
          "2.39517851550989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31305216884093`", ",", "2.56839675899803`", ",", 
          "3.80795959301767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25185769463344`", ",", "2.26957435943589`", ",", 
          "5.22074067052546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.19066322042595`", ",", "2.03352682324859`", ",", 
          "0.35033644085366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84628343903887`", ",", "1.82296397740614`", ",", 
          "1.76311751836145`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78508896483138`", ",", "1.62343479475089`", ",", 
          "3.17589859586923`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72389449062389`", ",", "1.42601574122335`", ",", 
          "4.58867967337702`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37951470923682`", ",", "1.22264057215797`", ",", 
          "6.0014607508848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31832023502933`", ",", "1.00266927208457`", ",", 
          "1.131056521213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25712576082183`", ",", "0.745212604570415`", ",", 
          "2.54383759872079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.912745979434758`", ",", "0.37136403302176`", ",", 
          "3.95661867622857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.85155150522727`", ",", "2.62859519855071`", ",", 
          "5.36939975373636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.79035703101978`", ",", "2.31093163002085`", ",", 
          "0.49899552406456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.445977249632701`", ",", "2.06860161585829`", ",", 
          "1.91177660157235`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38478277542521`", ",", "1.85522473253079`", ",", 
          "3.32455767908013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32358830121772`", ",", "1.65461382498983`", ",", 
          "4.73733875658792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26239382701023`", ",", "1.45738326741168`", ",", 
          "6.1501198340957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91801404562315`", ",", "1.25554064417923`", ",", 
          "1.2797156044239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85681957141566`", ",", "1.03915473041075`", ",", 
          "2.69249668193169`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79562509720817`", ",", "0.790009570001597`", ",", 
          "4.10527775943948`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4512453158211`", ",", "0.449353787002096`", ",", 
          "5.51805883694726`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3900508416136`", ",", "2.69606296029069`", ",", 
          "0.64765460727546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32885636740612`", ",", "2.35391492724765`", ",", 
          "2.06043568478325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.984476586019038`", ",", "2.10435847471789`", ",", 
          "3.47321676229103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92328211181155`", ",", "1.88779280485543`", ",", 
          "4.88599783979882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86208763760406`", ",", "1.6858747763882`", ",", 
          "0.0155936101270175`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.517707856216981`", ",", "1.4886390759135`", ",", 
          "1.4283746876348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45651338200949`", ",", "1.28809127933798`", ",", 
          "2.84115576514259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.395318907802`", ",", "1.07487315384249`", ",", 
          "4.25393684265038`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0509391264149239`", ",", "0.832899506722948`", ",", 
          "5.66671792015816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98974465220743`", ",", "0.516358590050444`", ",", 
          "0.796313690486361`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92855017799994`", ",", "2.77481500861129`", ",", 
          "2.20909476799415`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86735570379245`", ",", "2.39882313971028`", ",", 
          "3.62187584550193`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52297592240538`", ",", "2.14088749621847`", ",", 
          "5.03465692300972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46178144819789`", ",", "1.92071278028839`", ",", 
          "0.164252693337918`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4005869739904`", ",", "1.71724914386047`", ",", 
          "1.5770337708457`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05620719260332`", ",", "1.51981461555627`", ",", 
          "2.98981484835349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99501271839583`", ",", "1.32033686996817`", ",", 
          "4.40259592586128`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93381824418834`", ",", "1.10991395697569`", ",", 
          "5.81537700336906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.589438462801262`", ",", "0.874177349959743`", ",", 
          "0.944972773697261`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52824398859377`", ",", "0.576239567291034`", ",", 
          "2.35775385120505`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46704951438628`", ",", "2.87469209698103`", ",", 
          "3.77053492871283`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.122669732999204`", ",", "2.44604598370725`", ",", 
          "5.18331600622062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06147525879171`", ",", "2.17829325578881`", ",", 
          "0.312911776548818`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.00028078458422`", ",", "1.95403326746002`", ",", 
          "1.7256928540566`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93908631037673`", ",", "1.7487694489994`", ",", 
          "3.13847393156439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59470652898966`", ",", "1.55094062107953`", ",", 
          "4.55125500907218`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53351205478217`", ",", "1.35231850784619`", ",", 
          "5.96403608657996`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47231758057468`", ",", "1.14435511219779`", ",", 
          "1.09363185690816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1279377991876`", ",", "0.914075760460521`", ",", 
          "2.50641293441595`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06674332498011`", ",", "0.631043476631283`", ",", 
          "3.91919401192373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00554885077262`", ",", "3.04880391863276`", ",", 
          "5.33197508943152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.661169069385542`", ",", "2.49610872444153`", ",", 
          "0.461570859759718`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59997459517805`", ",", "2.21669867358496`", ",", 
          "1.8743519372675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53878012097056`", ",", "1.98780773017296`", ",", 
          "3.28713301477529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.194400339583485`", ",", "1.78046956382271`", ",", 
          "4.69991409228308`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13320586537599`", ",", "1.58204739143217`", ",", 
          "6.11269516979086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0720113911685`", ",", "1.38407455708539`", ",", 
          "1.24229094011906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.01081691696101`", ",", "1.178265340487`", ",", 
          "2.65507201762685`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66643713557394`", ",", "0.952782386782087`", ",", 
          "4.06785309513463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60524266136645`", ",", "0.682010306946812`", ",", 
          "5.48063417264242`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54404818715896`", ",", "0.232051899880951`", ",", 
          "0.610229942970618`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19966840577188`", ",", "2.54974977754435`", ",", 
          "2.0230110204784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13847393156439`", ",", "2.25625026807746`", ",", 
          "3.43579209798619`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0772794573569`", ",", "2.02209550719598`", ",", 
          "4.84857317549398`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.732899675969823`", ",", "1.81238507037855`", ",", 
          "6.26135425300176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67170520176233`", ",", "1.61316505733342`", ",", 
          "1.39095002332996`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.61051072755484`", ",", "1.41564114222597`", ",", 
          "2.80373110083775`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.266130946167765`", ",", "1.21170581695728`", ",", 
          "4.21651217834553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20493647196028`", ",", "0.990451455791084`", ",", 
          "5.62929325585332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14374199775279`", ",", "0.729958835486752`", ",", 
          "0.758889026181519`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08254752354529`", ",", "0.34198352845867`", ",", 
          "2.1716701036893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73816774215822`", ",", "2.60806663871537`", ",", 
          "3.58445118119709`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67697326795073`", ",", "2.29712546449415`", ",", 
          "4.99723225870488`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61577879374324`", ",", "2.05696307890707`", ",", 
          "0.126828029033076`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27139901235616`", ",", "1.84455366760448`", ",", 
          "1.53960910654086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.21020453814867`", ",", "1.64432384472597`", ",", 
          "2.95239018404865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14901006394118`", ",", "1.4470525705124`", ",", 
          "4.36517126155643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.804630282554103`", ",", "1.24473151911725`", ",", 
          "5.77795233906422`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74343580834661`", ",", "1.02721181660942`", ",", 
          "0.907548109392419`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68224133413912`", ",", "0.775463520247869`", ",", 
          "2.3203291869002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.337861552752046`", ",", "0.425127627850336`", ",", 
          "3.73311026440799`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27666707854456`", ",", "2.67282211606998`", ",", 
          "5.14589134191578`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21547260433707`", ",", "2.33954303939413`", ",", 
          "0.275487112243976`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15427813012957`", ",", "2.09248566309747`", ",", 
          "1.68826818975176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8098983487425`", ",", "1.87701563950876`", ",", 
          "3.10104926725955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74870387453501`", ",", "1.67555434055178`", ",", 
          "4.51383034476733`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68750940032752`", ",", "1.47834170333064`", ",", 
          "5.92661142227512`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34312961894044`", ",", "1.27739230817198`", ",", 
          "1.05620719260332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28193514473295`", ",", "1.06317268227369`", ",", 
          "2.4689882701111`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.22074067052546`", ",", "0.818946081429235`", ",", 
          "3.88176934761889`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.876360889138384`", ",", "0.495184874428459`", ",", 
          "5.29455042512668`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81516641493089`", ",", "2.74719881131688`", ",", 
          "0.424146195454876`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7539719407234`", ",", "2.38377852570391`", ",", 
          "1.83692727296266`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.409592159336327`", ",", "2.12874925592054`", ",", 
          "3.24970835047045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34839768512884`", ",", "1.90981440242284`", ",", 
          "4.66248942797823`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28720321092135`", ",", "1.70688776739279`", ",", 
          "6.07527050548602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22600873671386`", ",", "1.50954028885574`", ",", 
          "1.20486627581422`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88162895532678`", ",", "1.30973380834485`", ",", 
          "2.617647353322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.82043448111929`", ",", "1.09842782866326`", ",", 
          "4.03042843082979`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7592400069118`", ",", "0.860727232294365`", ",", 
          "5.44320950833758`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41486022552472`", ",", "0.557130905272096`", ",", 
          "0.572805278665776`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35366575131723`", ",", "2.83822169782288`", ",", 
          "1.98558635617356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29247127710974`", ",", "2.43018780532252`", ",", 
          "3.39836743368135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.948091495722664`", ",", "2.1658532847441`", ",", 
          "4.81114851118913`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88689702151517`", ",", "1.94299715414451`", ",", 
          "6.22392958869692`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82570254730768`", ",", "1.73835627394935`", ",", 
          "1.35352535902512`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.481322765920607`", ",", "1.54067926584546`", ",", 
          "2.7663064365329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.42012829171312`", ",", "1.34179813178953`", ",", 
          "4.17908751404069`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35893381750563`", ",", "1.13305873117431`", ",", 
          "5.59186859154848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0145540361185497`", ",", "0.901057899074524`", ",", 
          "0.721464361876676`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95335956191106`", ",", "0.613443632260471`", ",", 
          "2.13424543938446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89216508770357`", ",", "2.97073971279935`", ",", 
          "3.54702651689225`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.83097061349608`", ",", "2.47924493315574`", ",", 
          "4.95980759440003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.486590832109`", ",", "2.2039141180744`", ",", 
          "0.0894033647282337`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42539635790151`", ",", "1.97661565482156`", ",", 
          "1.50218444223602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36420188369402`", ",", "1.76999324911344`", ",", 
          "2.91496551974381`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01982210230694`", ",", "1.57178904701089`", ",", 
          "4.32774659725159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95862762809945`", ",", "1.37362448450666`", ",", 
          "5.74052767475938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89743315389196`", ",", "1.16713695258509`", ",", 
          "0.870123445087577`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.553053372504888`", ",", "0.940139070957949`", ",", 
          "2.28290452259536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4918588982974`", ",", "0.665569587033915`", ",", 
          "3.69568560010315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.43066442408991`", ",", "0.182160156310362`", ",", 
          "5.10846667761093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0862846427028302`", ",", "2.53160633787128`", ",", 
          "0.238062447939134`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02509016849534`", ",", "2.24306980212525`", ",", 
          "1.65084352544692`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96389569428785`", ",", "2.01072717927424`", ",", 
          "3.06362460295471`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90270122008036`", ",", "1.8018336685969`", ",", 
          "4.47640568046249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55832143869328`", ",", "1.60289978936692`", ",", 
          "5.88918675797028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49712696448579`", ",", "1.40524968006687`", ",", 
          "1.01878252829848`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4359324902783`", ",", "1.20072599217887`", ",", 
          "2.43156360580626`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09155270889123`", ",", "0.978134965779955`", ",", 
          "3.84434468331405`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.03035823468373`", ",", "0.714440470479885`", ",", 
          "5.25712576082183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96916376047624`", ",", "0.30994798094683`", ",", 
          "0.386721531150034`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.624783979089168`", ",", "2.58822808966283`", ",", 
          "1.79950260865782`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56358950488168`", ",", "2.28348659716634`", ",", 
          "3.21228368616561`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50239503067419`", ",", "2.0453956944295`", ",", 
          "4.62506476367339`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.158015249287111`", ",", "1.83391448480064`", ",", 
          "6.03784584118118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09682077507962`", ",", "1.63404165832607`", ",", 
          "1.16744161150938`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03562630087213`", ",", "1.43670858176656`", ",", 
          "2.58022268901716`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97443182666464`", ",", "1.23388274030947`", ",", 
          "3.99300376652495`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.63005204527756`", ",", "1.01518207362756`", ",", 
          "5.40578484403273`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56885757107007`", ",", "0.760698340970211`", ",", 
          "0.535380614360934`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50766309686258`", ",", "0.399529253834633`", ",", 
          "1.94816169186872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16328331547551`", ",", "2.65060224432046`", ",", 
          "3.36094276937651`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10208884126802`", ",", "2.32536823188579`", ",", 
          "4.77372384688429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.04089436706053`", ",", "2.08069333568062`", ",", 
          "6.18650492439208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.696514585673449`", ",", "1.86627507301556`", ",", 
          "1.31610069472028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63532011146596`", ",", "1.66524509199715`", ",", 
          "2.72888177222806`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57412563725847`", ",", "1.46803448937551`", ",", 
          "4.14166284973585`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.229745855871391`", ",", "1.26665863951436`", ",", 
          "5.55444392724364`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1685513816639`", ",", "1.05139555553501`", ",", 
          "0.684039697571834`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10735690745641`", ",", "0.804808163853811`", ",", 
          "2.09682077507962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04616243324892`", ",", "0.473146257678928`", ",", 
          "3.50960185258741`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70178265186184`", ",", "2.72130483639631`", ",", 
          "4.92238293009519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.64058817765435`", ",", "2.36896940365494`", ",", 
          "0.0519787004233917`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57939370344686`", ",", "2.11670228553204`", ",", 
          "1.46475977793118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23501392205979`", ",", "1.89895775035859`", ",", 
          "2.87754085543896`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.1738194478523`", ",", "1.69654107215968`", ",", 
          "4.29032193294675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11262497364481`", ",", "1.49925948338922`", ",", 
          "5.70310301045453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.768245192257729`", ",", "1.29910062446506`", ",", 
          "0.832698780782735`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70705071805024`", ",", "1.08687388734004`", ",", 
          "2.24547985829052`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64585624384275`", ",", "0.847119757219667`", ",", 
          "3.65826093579831`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.301476462455672`", ",", "0.537417155112018`", ",", 
          "5.07104201330609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.24028198824818`", ",", "2.80557961838626`", ",", 
          "0.200637783634292`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17908751404069`", ",", "2.41461618306824`", ",", 
          "1.61341886114208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1178930398332`", ",", "2.15351720212183`", ",", 
          "3.02619993864986`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77351325844612`", ",", "1.93200838840707`", ",", 
          "4.43898101615765`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71231878423863`", ",", "1.72796140870824`", ",", 
          "5.85176209366544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65112431003114`", ",", "1.53041473734355`", ",", 
          "0.981357863993635`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30674452864407`", ",", "1.33125189337781`", ",", 
          "2.39413894150142`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24555005443658`", ",", "1.1217023054916`", ",", 
          "3.80692001900921`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18435558022909`", ",", "0.887904435970096`", ",", 
          "5.21970109651699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.83997579884201`", ",", "0.595392341686018`", ",", 
          "0.349296866845192`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77878132463452`", ",", "2.91833790353427`", ",", 
          "1.76207794435298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71758685042703`", ",", "2.46273820241964`", ",", 
          "3.17485902186076`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.373207069039952`", ",", "2.1912484129636`", ",", 
          "4.58764009936855`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31201259483246`", ",", "1.96547714680092`", ",", 
          "6.00042117687634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.25081812062497`", ",", "1.7595390450226`", ",", 
          "1.13001694720454`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18962364641748`", ",", "1.56153080706072`", ",", 
          "2.54279802471232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8452438650304`", ",", "1.36315254984801`", ",", 
          "3.95557910222011`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78404939082291`", ",", "1.15595541453613`", ",", 
          "5.36836017972789`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72285491661542`", ",", "0.927377942106556`", ",", 
          "0.497955950056092`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37847513522835`", ",", "0.648777082993084`", ",", 
          "1.91073702756388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31728066102086`", ",", "0.112194708199592`", ",", 
          "3.32351810507166`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25608618681337`", ",", "2.51392219183182`", ",", 
          "4.73629918257945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.91170640542629`", ",", "2.23002619574569`", ",", 
          "6.14908026008724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8505119312188`", ",", "1.99941936388244`", ",", 
          "1.27867603041544`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78931745701131`", ",", "1.79130839277551`", ",", 
          "2.69145710792322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.444937675624233`", ",", "1.59263790452215`", ",", 
          "4.10423818543101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38374320141674`", ",", "1.39484014443611`", ",", 
          "5.51701926293879`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32254872720925`", ",", "1.18969919532196`", ",", 
          "0.646615033266992`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26135425300176`", ",", "0.965715456559138`", ",", 
          "2.05939611077478`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91697447161469`", ",", "0.69863929760841`", ",", 
          "3.47217718828256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85577999740719`", ",", "0.274327686880126`", ",", 
          "4.88495826579035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7945855231997`", ",", "2.56900721648673`", ",", 
          "0.0145540361185497`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.45020574181263`", ",", "2.27000664043965`", ",", 
          "1.42733511362634`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38901126760514`", ",", "2.03389665287581`", ",", 
          "2.84011619113412`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32781679339765`", ",", "1.82330570622865`", ",", 
          "4.25289726864191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.983437012010571`", ",", "1.62376616330329`", ",", 
          "5.66567834614969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92224253780308`", ",", "1.42635013844959`", ",", 
          "0.795274116477893`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86104806359559`", ",", "1.22299257675563`", ",", 
          "2.20805519398568`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.516668282208513`", ",", "1.0030617993574`", ",", 
          "3.62083627149346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45547380800102`", ",", "0.745700446400861`", ",", 
          "5.03361734900125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39427933379353`", ",", "0.372274841021409`", ",", 
          "0.16321311932945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.049899552406456`", ",", "2.62926983386559`", ",", 
          "1.57599419683724`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98870507819897`", ",", "2.31137987570426`", ",", 
          "2.98877527434502`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92751060399148`", ",", "2.0689782699285`", ",", 
          "4.40155635185281`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86631612978399`", ",", "1.85556950822734`", ",", 
          "5.81433742936059`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52193634839691`", ",", "1.65494590209633`", ",", 
          "0.943933199688793`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.46074187418942`", ",", "1.4577163073982`", ",", 
          "2.35671427719658`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39954739998193`", ",", "1.25588868451675`", ",", 
          "3.76949535470436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05516761859485`", ",", "1.03953858023385`", ",", 
          "5.18227643221215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99397314438736`", ",", "0.790475292117426`", ",", 
          "0.31187220254035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93277867017987`", ",", "0.450114970903424`", ",", 
          "1.72465328004814`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.588398888792794`", ",", "2.69683145779742`", ",", 
          "3.13743435755592`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5272044145853`", ",", "2.35438194540665`", ",", 
          "4.55021543506371`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46600994037781`", ",", "2.1047428463205`", ",", 
          "5.96299651257149`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.121630158990737`", ",", "1.88814108308609`", ",", 
          "1.09259228289969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.06043568478325`", ",", "1.68620789275461`", ",", 
          "2.50537336040748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99924121057576`", ",", "1.48897109799401`", ",", 
          "3.91815443791526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93804673636827`", ",", "1.28843584731267`", ",", 
          "5.33093551542305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59366695498119`", ",", "1.07524934691936`", ",", 
          "0.46053128575125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5324724807737`", ",", "0.833346656494154`", ",", 
          "1.87331236325904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47127800656621`", ",", "0.517028430814081`", ",", 
          "3.28609344076682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12689822517913`", ",", "2.77573886957616`", ",", 
          "4.69887451827461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06570375097164`", ",", "2.39931253786444`", ",", 
          "6.11165559578239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00450927676415`", ",", "2.14128061577618`", ",", 
          "1.24125136611059`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.660129495377074`", ",", "1.92106505566048`", ",", 
          "2.65403244361838`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59893502116958`", ",", "1.7175836395106`", ",", 
          "4.06681352112617`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53774054696209`", ",", "1.52014594994753`", ",", 
          "5.47959459863395`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.193360765575017`", ",", "1.32067841899378`", ",", 
          "0.60919036896215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13216629136753`", ",", "1.11028337861846`", ",", 
          "2.02197144646994`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.07097181716004`", ",", "0.874608693030343`", ",", 
          "3.43475252397772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00977734295255`", ",", "0.576846591754805`", ",", 
          "4.84753360148551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66539756156547`", ",", "2.87594964497115`", ",", 
          "6.26031467899329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60420308735798`", ",", "2.44656253555874`", ",", 
          "1.38991044932149`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54300861315049`", ",", "2.17869632651699`", ",", 
          "2.80269152682928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19862883176341`", ",", "1.95439008156188`", ",", 
          "4.21547260433707`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13743435755592`", ",", "1.74910567656493`", ",", 
          "5.62825368184485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07623988334843`", ",", "1.55127159192277`", ",", 
          "0.757849452173051`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.731860101961355`", ",", "1.35265745947358`", ",", 
          "2.17063052968084`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.67066562775386`", ",", "1.1447185387689`", ",", 
          "3.58341160718862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60947115354637`", ",", "0.914493505389832`", ",", 
          "4.99619268469641`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.265091372159298`", ",", "0.631604132153037`", ",", 
          "0.125788455024608`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20389689795181`", ",", "3.05244658267559`", ",", 
          "1.53856953253239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14270242374432`", ",", "2.49665898349551`", ",", 
          "2.95135061004018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08150794953683`", ",", "2.21711311915111`", ",", 
          "4.36413168754797`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73712816814975`", ",", "1.9881696813473`", ",", 
          "5.77691276505575`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67593369394226`", ",", "1.78080789216173`", ",", 
          "0.906508535383951`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61473921973477`", ",", "1.58237831968388`", ",", 
          "2.31928961289174`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.27035943834769`", ",", "1.38441130660331`", ",", 
          "3.73207069039952`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2091649641402`", ",", "1.17862345982837`", ",", 
          "5.14485176790731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14797048993271`", ",", "0.953188333333838`", ",", 
          "0.274447538235508`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.803590708545635`", ",", "0.682535090360919`", ",", 
          "1.68722861574329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74239623433815`", ",", "0.233486427864913`", ",", 
          "3.10000969325108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68120176013066`", ",", "2.55034317765973`", ",", 
          "4.51279077075887`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.336821978743578`", ",", "2.25667779806594`", ",", 
          "5.92557184826665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27562750453609`", ",", "2.02246326259298`", ",", 
          "1.05516761859485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2144330303286`", ",", "1.81272588863293`", ",", 
          "2.46794869610264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15323855612111`", ",", "1.6134962635782`", ",", 
          "3.88072977361042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80885877473403`", ",", "1.41597606347015`", ",", 
          "5.29351085111821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74766430052654`", ",", "1.21205924442573`", ",", 
          "0.423106621446408`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68646982631905`", ",", "0.9908470963779`", ",", 
          "1.83588769895419`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34209004493197`", ",", "0.730454929772236`", ",", 
          "3.24866877646198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.28089557072448`", ",", "0.342968896147851`", ",", 
          "4.66144985396977`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21970109651699`", ",", "2.60871765541727`", ",", 
          "6.07423093147755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.875321315129916`", ",", "2.29756816659203`", ",", 
          "1.20382670180575`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81412684092243`", ",", "2.05733738955756`", ",", 
          "2.61660777931354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75293236671494`", ",", "1.84489738983001`", ",", 
          "4.02938885682132`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.408552585327859`", ",", "1.64465565198034`", ",", 
          "5.44216993432911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34735811112037`", ",", "1.44738602006087`", ",", 
          "0.571765704657309`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28616363691288`", ",", "1.24508081035847`", ",", 
          "1.98454678216509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22496916270539`", ",", "1.02759840781257`", ",", 
          "3.39732785967288`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.88058938131831`", ",", "0.775936098355761`", ",", 
          "4.81010893718067`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81939490711082`", ",", "0.425929238731724`", ",", 
          "6.22289001468845`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75820043290333`", ",", "2.67355508162262`", ",", 
          "1.35248578501665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41382065151625`", ",", "2.34000351300661`", ",", 
          "2.76526686252444`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35262617730876`", ",", "2.0928673830392`", ",", 
          "4.17804794003222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29143170310127`", ",", "1.87736271004543`", ",", 
          "5.59082901754001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.947051921714196`", ",", "1.67588707712734`", ",", 
          "0.720424787868209`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88585744750671`", ",", "1.47867402422748`", ",", 
          "2.13320586537599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82466297329922`", ",", "1.2777379694405`", ",", 
          "3.54598694288378`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.480283191912139`", ",", "1.06355129658494`", ",", 
          "4.95876802039157`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41908871770465`", ",", "0.819399017726582`", ",", 
          "0.0883637907197659`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35789424349716`", ",", "0.495880786883098`", ",", 
          "1.50114486822755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0135144621100818`", ",", "2.74806088277459`", ",", 
          "2.91392594573534`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95231998790259`", ",", "2.38426008232716`", ",", 
          "4.32670702324312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8911255136951`", ",", "2.12913936684663`", ",", 
          "5.73948810075091`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82993103948761`", ",", "1.91016530221853`", ",", 
          "0.869083871079109`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48555125810053`", ",", "1.70722176989016`", ",", 
          "2.28186494858689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42435678389304`", ",", "1.50987181397869`", ",", 
          "3.69464602609468`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36316230968555`", ",", "1.31007630495647`", ",", 
          "5.10742710360247`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01878252829848`", ",", "1.0987993927698`", ",", 
          "0.237022873930666`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95758805409099`", ",", "0.861163520448181`", ",", 
          "1.64980395143845`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8963935798835`", ",", "0.557756415781747`", ",", 
          "3.06258502894624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.55201379849642`", ",", "2.8393313433167`", ",", 
          "4.47536610645402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.49081932428893`", ",", "2.43069478157409`", ",", 
          "5.88814718396181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42962485008144`", ",", "2.16625292830743`", ",", 
          "1.01774295429001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0852450686943624`", ",", "1.94335240830845`", ",", 
          "2.4305240317978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02405059448687`", ",", "1.73869189046055`", ",", 
          "3.84330510930558`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96285612027938`", ",", "1.54101032101405`", ",", 
          "5.25608618681337`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90166164607189`", ",", "1.3421378951394`", ",", 
          "0.385681957141566`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55728186468481`", ",", "1.13342405485544`", ",", 
          "1.79846303464935`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49608739047732`", ",", "0.90147991200448`", ",", 
          "3.21124411215714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43489291626984`", ",", "0.614018201340265`", ",", 
          "4.62402518966492`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.09051313488276`", ",", "2.97269706414973`", ",", 
          "6.03680626717271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02931866067527`", ",", "2.47978320497646`", ",", 
          "1.16640203750091`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96812418646778`", ",", "2.20432463902093`", ",", 
          "2.5791831150087`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.6237444050807`", ",", "1.97697584177217`", ",", 
          "3.99196419251648`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56254993087321`", ",", "1.77033084272088`", ",", 
          "5.40474527002427`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50135545666572`", ",", "1.57211995391865`", ",", 
          "0.534341040352467`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.156975675278643`", ",", "1.37396191797825`", ",", 
          "1.94712211786025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09578120107115`", ",", "1.16749675091526`", ",", 
          "3.35990319536804`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03458672686366`", ",", "0.940548730170693`", ",", 
          "4.77268427287582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97339225265617`", ",", "0.666105279272714`", ",", 
          "6.18546535038361`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6290124712691`", ",", "0.183977844345517`", ",", 
          "1.31506112071181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5678179970616`", ",", "2.53218422031144`", ",", 
          "2.7278421982196`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50662352285411`", ",", "2.24349280710027`", ",", 
          "4.14062327572738`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16224374146704`", ",", "2.01109294196986`", ",", 
          "5.55340435323517`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10104926725955`", ",", "1.80217362127255`", ",", 
          "0.683000123563367`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03985479305206`", ",", "1.60323086841219`", ",", 
          "2.09578120107115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.695475011664981`", ",", "1.40558516408033`", ",", 
          "3.50856227857894`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63428053745749`", ",", "1.20108090286717`", ",", 
          "4.92134335608672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57308606325`", ",", "0.978533855934483`", ",", 
          "0.0509391264149239`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.228706281862923`", ",", "0.714945374358551`", ",", 
          "1.46372020392271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16751180765543`", ",", "0.311031057398512`", ",", 
          "2.8765012814305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10631733344794`", ",", "2.58885804657395`", ",", 
          "4.28928235893828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04512285924045`", ",", "2.28392403681536`", ",", 
          "5.70206343644607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.70074307785338`", ",", "2.04576775434817`", ",", 
          "0.831659206774267`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63954860364589`", ",", "1.83425720183061`", ",", 
          "2.24444028428205`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.5783541294384`", ",", "1.63437323141125`", ",", 
          "3.65722136178984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23397434805132`", ",", "1.43704247815924`", ",", 
          "5.07000243929762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17277987384383`", ",", "1.23423333744659`", ",", 
          "0.199598209625824`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11158539963634`", ",", "1.01557152254943`", ",", 
          "1.61237928713361`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.767205618249261`", ",", "0.761178193198364`", ",", 
          "3.0251603646414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70601114404177`", ",", "0.400379091990531`", ",", 
          "4.43794144214918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64481666983428`", ",", "2.65130452323761`", ",", 
          "5.85072251965697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.300436888447204`", ",", "2.32582251866549`", ",", 
          "0.980318289985167`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23924241423971`", ",", "2.08107251047233`", ",", 
          "2.39309936749295`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17804794003222`", ",", "1.86662098810532`", ",", 
          "3.80588044500074`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11685346582473`", ",", "1.66557748536465`", ",", 
          "5.21866152250852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77247368443766`", ",", "1.46836714526733`", ",", 
          "0.348257292836724`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.71127921023017`", ",", "1.26700544462792`", ",", 
          "1.76103837034451`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.65008473602268`", ",", "1.05177669163611`", ",", 
          "3.1738194478523`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3057049546356`", ",", "0.805267210232839`", ",", 
          "4.58660052536008`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24451048042811`", ",", "0.473871911026404`", ",", 
          "5.99938160286787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18331600622062`", ",", "2.72211657326628`", ",", 
          "1.12897737319607`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.838936224833542`", ",", "2.36944358641635`", ",", 
          "2.54175845070385`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77774175062605`", ",", "2.11708951164872`", ",", 
          "3.95453952821164`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71654727641856`", ",", "1.89930733161517`", ",", 
          "5.36732060571943`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.372167495031484`", ",", "1.6968746193345`", ",", 
          "0.496916376047624`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.31097302082399`", ",", "1.49959123465625`", ",", 
          "1.90969745355541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2497785466165`", ",", "1.2994441155336`", ",", 
          "3.3224785310632`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18858407240901`", ",", "1.08724768180417`", ",", 
          "4.73525960857098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84420429102194`", ",", "0.847561247201958`", ",", 
          "6.14804068607877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78300981681445`", ",", "0.538063209399472`", ",", 
          "1.27763645640697`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72181534260696`", ",", "2.80658464624746`", ",", 
          "2.69041753391475`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37743556121988`", ",", "2.41511421590425`", ",", 
          "4.10319861142254`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31624108701239`", ",", "2.15391356430702`", ",", 
          "5.51597968893033`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2550466128049`", ",", "1.93236214545163`", ",", 
          "0.645575459258525`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.910666831417822`", ",", "1.72829645362245`", ",", 
          "2.05835653676631`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84947235721033`", ",", "1.53074591180195`", ",", 
          "3.4711376142741`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78827788300284`", ",", "1.33159251228143`", ",", 
          "4.88391869178188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.443898101615765`", ",", "1.12206960391522`", ",", 
          "0.0135144621100818`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38270362740827`", ",", "0.888330924977692`", ",", 
          "1.42629553961787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32150915320078`", ",", "0.595982111446878`", ",", 
          "2.83907661712565`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.26031467899329`", ",", "2.91983743405869`", ",", 
          "4.25185769463344`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91593489760622`", ",", "2.46326537850877`", ",", 
          "5.66463877214123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85474042339873`", ",", "2.19165518337788`", ",", 
          "0.794234542469425`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79354594919124`", ",", "1.96583563934371`", ",", 
          "2.20701561997721`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44916616780416`", ",", "1.75987594540601`", ",", 
          "3.619796697485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38797169359667`", ",", "1.56186172744839`", ",", 
          "5.03257777499278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32677721938918`", ",", "1.36349070861239`", ",", 
          "0.162173545320982`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.982397438002103`", ",", "1.15631696110198`", ",", 
          "1.57495462282877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92120296379461`", ",", "0.927791485692849`", ",", 
          "2.98773570033655`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.86000848958712`", ",", "0.649324551537657`", ",", 
          "4.40051677784434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.515628708200046`", ",", "0.115112523609693`", ",", 
          "5.81329785535213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45443423399255`", ",", "2.51448588564253`", ",", 
          "0.942893625680325`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39323975978506`", ",", "2.23044488692798`", ",", 
          "2.35567470318811`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0488599783979882`", ",", "1.9997832122031`", ",", 
          "3.7684557806959`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9876655041905`", ",", "1.79164752391014`", ",", 
          "5.18123685820368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92647102998301`", ",", "1.59296889135506`", ",", 
          "0.310832628531882`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86527655577552`", ",", "1.39517623054104`", ",", 
          "1.72361370603967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.52089677438844`", ",", "1.19005565157936`", ",", 
          "3.13639478354745`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45970230018095`", ",", "0.966117740238783`", ",", 
          "4.54917586105524`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39850782597346`", ",", "0.699153628412524`", ",", 
          "5.96195693856303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05412804458638`", ",", "0.27554655706727`", ",", 
          "1.09155270889123`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99293357037889`", ",", "2.5696182526272`", ",", 
          "2.50433378639901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9317390961714`", ",", "2.27043907864427`", ",", 
          "3.9171148639068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.587359314784326`", ",", "2.03426655080908`", ",", 
          "5.32989594141458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52616484057684`", ",", "1.82364746518465`", ",", 
          "0.459491711742782`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46497036636935`", ",", "1.6240975376776`", ",", 
          "1.87227278925057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.120590584982269`", ",", "1.42668451941114`", ",", 
          "3.28505386675835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05939611077478`", ",", "1.22334453643749`", ",", 
          "4.69783494426614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99820163656729`", ",", "1.00345422838764`", ",", 
          "6.11061602177393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9370071623598`", ",", "0.746188030690456`", ",", 
          "1.24021179210213`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59262738097272`", ",", "0.373183529481349`", ",", 
          "2.65299286960991`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53143290676523`", ",", "2.6299452794043`", ",", 
          "4.0657739471177`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.47023843255774`", ",", "2.3118283051399`", ",", 
          "5.47855502462548`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12585865117066`", ",", "2.06935500118296`", ",", 
          "0.608150794953683`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06466417696317`", ",", "1.85591431872421`", ",", 
          "2.02093187246147`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00346970275568`", ",", "1.65527798850466`", ",", 
          "3.43371294996925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.659089921368607`", ",", "1.45804933478911`", ",", 
          "4.84649402747704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59789544716112`", ",", "1.25623668540031`", ",", 
          "6.25927510498483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53670097295363`", ",", "1.03992234349792`", ",", 
          "1.38887087531303`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.192321191566549`", ",", "0.790940799626383`", ",", 
          "2.80165195282081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13112671735906`", ",", "0.450874957589868`", ",", 
          "4.2144330303286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06993224315157`", ",", "2.6976011964511`", ",", 
          "5.62721410783638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00873776894408`", ",", "2.3548491809836`", ",", 
          "0.756809878164583`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.664357987557`", ",", "2.1051273052923`", ",", 
          "2.16959095567237`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60316351334951`", ",", "1.88848940116095`", ",", 
          "3.58237203318015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54196903914202`", ",", "1.68654102198549`", ",", 
          "4.99515311068794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19758925775494`", ",", "1.48930311103428`", ",", 
          "0.12474888101614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13639478354745`", ",", "1.28878038084668`", ",", 
          "1.53752995852393`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07520030933996`", ",", "1.07562546351468`", ",", 
          "2.95031103603171`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.730820527952887`", ",", "0.833793624706182`", ",", 
          "4.3630921135395`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6696260537454`", ",", "0.517697483429377`", ",", 
          "5.77587319104728`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60843157953791`", ",", "2.77666496385688`", ",", 
          "0.905468961375483`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.26405179815083`", ",", "2.39980219726776`", ",", 
          "2.31825003888327`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20285732394334`", ",", "2.14167383452174`", ",", 
          "3.73103111639105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14166284973585`", ",", "1.92141737637548`", ",", 
          "5.14381219389884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.08046837552836`", ",", "1.71791815170418`", ",", 
          "0.27340796422704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73608859414128`", ",", "1.52047727877361`", ",", 
          "1.68618904173483`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67489411993379`", ",", "1.32101993822024`", ",", 
          "3.09897011924261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6136996457263`", ",", "1.11065273257136`", ",", 
          "4.5117511967504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26931986433922`", ",", "0.875039880652109`", ",", 
          "5.92453227425818`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20812539013173`", ",", "0.577453050440131`", ",", 
          "1.05412804458638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14693091592424`", ",", "2.87721303252768`", ",", 
          "2.46690912209417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.802551134537168`", ",", "2.44707940760973`", ",", 
          "3.87969019960195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74135666032968`", ",", "2.17909951032036`", ",", 
          "5.29247127710974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.68016218612219`", ",", "1.9547469470542`", ",", 
          "0.42206704743794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.33578240473511`", ",", "1.74944192450577`", ",", 
          "1.83484812494573`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27458793052762`", ",", "1.55160256062698`", ",", 
          "3.24762920245351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21339345632013`", ",", "1.35299638563606`", ",", 
          "4.6604102799613`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15219898211264`", ",", "1.14508190540162`", ",", 
          "6.07319135746908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80781920072556`", ",", "0.914911115954521`", ",", 
          "1.20278712779728`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74662472651807`", ",", "0.632164358335016`", ",", 
          "2.61556820530507`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68543025231058`", ",", "3.05624414560088`", ",", 
          "4.02834928281286`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34105047092351`", ",", "2.49720964535507`", ",", 
          "5.44113036032064`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27985599671601`", ",", "2.21752769433892`", ",", 
          "0.570726130648841`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21866152250852`", ",", "1.98853169062359`", ",", 
          "1.98350720815663`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.874281741121448`", ",", "1.78114624490148`", ",", 
          "3.39628828566441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81308726691396`", ",", "1.58270924920404`", ",", 
          "4.8090693631722`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.75189279270647`", ",", "1.38474803473829`", ",", 
          "6.22185044067998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.407513011319391`", ",", "1.17898152613398`", ",", 
          "1.35144621100818`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3463185371119`", ",", "0.953594162866468`", ",", 
          "2.76422728851597`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28512406290441`", ",", "0.683059535193882`", ",", 
          "4.17700836602376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22392958869692`", ",", "0.234912354651885`", ",", 
          "5.58978944353154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87954980730984`", ",", "2.55093710272721`", ",", 
          "0.719385213859741`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81835533310235`", ",", "2.257105477702`", ",", 
          "2.13216629136753`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75716085889486`", ",", "2.02283108361028`", ",", 
          "3.54494736887531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41278107750779`", ",", "1.81306673555298`", ",", 
          "4.9577284463831`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3515866033003`", ",", "1.61382747450998`", ",", 
          "0.087324216711298`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.29039212909281`", ",", "1.41631096720861`", ",", 
          "1.50010529421908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.946012347705729`", ",", "1.21241262506355`", ",", 
          "2.91288637172687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88481787349824`", ",", "0.99124263444815`", ",", 
          "4.32566744923466`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82362339929075`", ",", "0.730950749453303`", ",", 
          "5.73844852674244`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.479243617903671`", ",", "0.343951552177411`", ",", 
          "0.868044297070641`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41804914369618`", ",", "2.60936939151868`", ",", 
          "2.28082537457843`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35685466948869`", ",", "2.29801104301301`", ",", 
          "3.69360645208621`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.012474888101614`", ",", "2.05771177433356`", ",", 
          "5.106387529594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95128041389412`", ",", "1.84524114527856`", ",", 
          "0.235983299922198`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.89008593968663`", ",", "1.64498746738135`", ",", 
          "1.64876437742998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82889146547914`", ",", "1.44771945581801`", ",", 
          "3.06154545493777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48451168409207`", ",", "1.24543006039821`", ",", 
          "4.47432653244556`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42331720988458`", ",", "1.02798490879944`", ",", 
          "5.88710760995334`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36212273567709`", ",", "0.776408448976269`", ",", 
          "1.01670338028154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01774295429001`", ",", "0.426729435808108`", ",", 
          "2.42948445778933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95654848008252`", ",", "2.67428911150715`", ",", 
          "3.84226553529711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89535400587503`", ",", "2.34046419198931`", ",", 
          "5.2550466128049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.550974224487952`", ",", "2.09324918682858`", ",", 
          "0.384642383133098`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48977975028046`", ",", "1.87770981871674`", ",", 
          "1.79742346064088`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42858527607297`", ",", "1.67621982538131`", ",", 
          "3.21020453814867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0842054946858945`", ",", "1.47900633492204`", ",", 
          "4.62298561565646`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0230110204784`", ",", "1.27808359465959`", ",", 
          "6.03576669316424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96181654627091`", ",", "1.06392983124723`", ",", 
          "1.16536246349244`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.90062207206342`", ",", "0.819851762450601`", ",", 
          "2.57814354100023`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55624229067635`", ",", "0.496575805247293`", ",", 
          "3.99092461850801`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49504781646886`", ",", "2.74892474790819`", ",", 
          "5.4037056960158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43385334226137`", ",", "2.38474188436838`", ",", 
          "0.533301466343999`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08947356087429`", ",", "2.12952957285825`", ",", 
          "1.94608254385178`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0282790866668`", ",", "1.91051624548806`", ",", 
          "3.35886362135957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96708461245931`", ",", "1.70755578770267`", ",", 
          "4.77164469886736`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.622704831072232`", ",", "1.51020333239732`", ",", 
          "6.18442577637514`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56151035686474`", ",", "1.31041877027513`", ",", 
          "1.31402154670334`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.50031588265725`", ",", "1.0991708864128`", ",", 
          "2.72680262421113`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.155936101270175`", ",", "0.861599645175699`", ",", 
          "4.13958370171891`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09474162706268`", ",", "0.558381299722145`", ",", 
          "5.5523647792267`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03354715285519`", ",", "2.8404449517899`", ",", 
          "0.681960549554899`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9723526786477`", ",", "2.43120205648908`", ",", 
          "2.09474162706268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62797289726063`", ",", "2.16665268010498`", ",", 
          "3.50752270457047`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56677842305314`", ",", "1.94370771180121`", ",", 
          "4.92030378207826`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50558394884565`", ",", "1.73902752606406`", ",", 
          "0.049899552406456`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.16120416745857`", ",", "1.54134137291723`", ",", 
          "1.46268062991424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.10000969325108`", ",", "1.34247763162539`", ",", 
          "2.87546170742203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03881521904359`", ",", "1.1337893161441`", ",", 
          "4.28824278492981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.694435437656513`", ",", "0.901901784083056`", ",", 
          "5.7010238624376`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63324096344902`", ",", "0.614592302476997`", ",", 
          "0.830619632765799`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57204648924153`", ",", "2.97467714584414`", ",", 
          "2.24340071027359`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.227666707854456`", ",", "2.48032184898447`", ",", 
          "3.65618178778137`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16647223364696`", ",", "2.20473528379373`", ",", 
          "5.06896286528916`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10527775943948`", ",", "1.97733608452984`", ",", 
          "0.198558635617356`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04408328523198`", ",", "1.77066845937742`", ",", 
          "1.61133971312514`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69970350384491`", ",", "1.57245086097135`", ",", 
          "3.02412079063293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63850902963742`", ",", "1.37429932874554`", ",", 
          "4.43690186814071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57731455542993`", ",", "1.16785649401707`", ",", 
          "5.8496829456485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23293477404285`", ",", "0.940958266995822`", ",", 
          "0.979278715976699`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17174029983536`", ",", "0.666640606632668`", ",", 
          "2.39205979348449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.11054582562787`", ",", "0.18577794774646`", ",", 
          "3.80484087099227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.766166044240793`", ",", "2.53276258155739`", ",", 
          "5.21762194850006`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7049715700333`", ",", "2.24391595467096`", ",", 
          "0.347217718828256`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64377709582581`", ",", "2.01145876770696`", ",", 
          "1.75999879633604`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.299397314438736`", ",", "1.80251360117777`", ",", 
          "3.17277987384383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23820284023125`", ",", "1.603561951014`", ",", 
          "4.58556095135161`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17700836602376`", ",", "1.40592062932935`", ",", 
          "5.9983420288594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11581389181626`", ",", "1.20143576474755`", ",", 
          "1.1279377991876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77143411042919`", ",", "0.978932639060314`", ",", 
          "2.54071887669539`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7102396362217`", ",", "0.715449984767662`", ",", 
          "3.95349995420317`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64904516201421`", ",", "0.31211049698849`", ",", 
          "5.36628103171096`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30466538062713`", ",", "2.58948864746036`", ",", 
          "0.495876802039157`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24347090641964`", ",", "2.2843616420443`", ",", 
          "1.90865787954694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18227643221215`", ",", "2.04613988546542`", ",", 
          "3.32143895705473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.837896650825074`", ",", "1.83459995054473`", ",", 
          "4.73422003456251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77670217661758`", ",", "1.63470481149571`", ",", 
          "6.1470011120703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71550770241009`", ",", "1.43737635955123`", ",", 
          "1.2765968823985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.371127921023017`", ",", "1.234583891583`", ",", 
          "2.68937795990629`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30993344681553`", ",", "1.01596087741023`", ",", 
          "4.10215903741407`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24873897260804`", ",", "0.761657803857145`", ",", 
          "5.51494011492186`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18754449840055`", ",", "0.401227227143331`", ",", 
          "0.644535885250057`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84316471701347`", ",", "2.6520077273787`", ",", 
          "2.05731696275784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78197024280598`", ",", "2.32627699973454`", ",", 
          "3.47009804026563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.72077576859849`", ",", "2.08145176575424`", ",", 
          "4.88287911777341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37639598721141`", ",", "1.86696693966654`", ",", 
          "0.012474888101614`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31520151300392`", ",", "1.66590988923588`", ",", 
          "1.4252559656094`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25400703879643`", ",", "1.46869978978492`", ",", 
          "2.83803704311719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.909627257409354`", ",", "1.26735221204038`", ",", 
          "4.25081812062497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84843278320186`", ",", "1.05215774477122`", ",", 
          "5.66359919813276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78723830899437`", ",", "0.805726054189228`", ",", 
          "0.793194968460957`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.442858527607297`", ",", "0.474596539058509`", ",", 
          "2.20597604596874`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38166405339981`", ",", "2.72292979040998`", ",", 
          "3.61875712347653`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.32046957919232`", ",", "2.36991800017804`", ",", 
          "5.03153820098432`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25927510498483`", ",", "2.11747682895536`", ",", 
          "0.161133971312514`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91489532359775`", ",", "1.89965695453246`", ",", 
          "1.5739150488203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85370084939026`", ",", "1.69720818061138`", ",", 
          "2.98669612632809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79250637518277`", ",", "1.49992297807343`", ",", 
          "4.39947720383587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44812659379569`", ",", "1.29978757377984`", ",", 
          "5.81225828134366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3869321195882`", ",", "1.08762140291036`", ",", 
          "0.941854051671857`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32573764538071`", ",", "0.848002565180173`", ",", 
          "2.35463512917964`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.981357863993635`", ",", "0.538708565069065`", ",", 
          "3.76741620668743`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.92016338978614`", ",", "2.8075925839696`", ",", 
          "5.18019728419521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85896891557865`", ",", "2.41561252803028`", ",", 
          "0.309793054523414`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.514589134191578`", ",", "2.15431003014962`", ",", 
          "1.7225741320312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45339465998409`", ",", "1.93271594983094`", ",", 
          "3.13535520953899`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.3922001857766`", ",", "1.72863151636547`", ",", 
          "4.54813628704677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0478204043895203`", ",", "1.53107708186548`", ",", 
          "5.96091736455456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98662593018203`", ",", "1.33193310289295`", ",", 
          "1.09051313488276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92543145597454`", ",", "1.12243683739399`", ",", 
          "2.50329421239054`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86423698176705`", ",", "0.888757266203581`", ",", 
          "3.91607528989833`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51985720037997`", ",", "0.59657136882432`", ",", 
          "5.32885636740612`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45866272617248`", ",", "2.9213470048051`", ",", 
          "0.458452137734315`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39746825196499`", ",", "2.46379289967439`", ",", 
          "1.8712332152421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05308847057792`", ",", "2.19206207216622`", ",", 
          "3.28401429274989`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99189399637042`", ",", "1.96619418548067`", ",", 
          "4.69679537025767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.93069952216294`", ",", "1.76021286751117`", ",", 
          "6.10957644776546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.586319740775858`", ",", "1.56219264685762`", ",", 
          "1.23917221809366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52512526656837`", ",", "1.36382884332727`", ",", 
          "2.65195329560144`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46393079236088`", ",", "1.15667845016626`", ",", 
          "4.06473437310923`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.119551010973801`", ",", "0.928204901187652`", ",", 
          "5.47751545061702`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05835653676631`", ",", "0.649871625548596`", ",", 
          "0.607111220945215`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99716206255882`", ",", "0.117958497037008`", ",", 
          "2.019892298453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93596758835133`", ",", "2.51505001825742`", ",", 
          "3.43267337596079`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59158780696425`", ",", "2.23086371410874`", ",", 
          "4.84545445346857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.53039333275676`", ",", "2.00014712108641`", ",", 
          "6.25823553097636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46919885854927`", ",", "1.79198668086802`", ",", 
          "1.38783130130456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1248190771622`", ",", "1.59329988061743`", ",", 
          "2.80061237881234`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06362460295471`", ",", "1.39551229660371`", ",", 
          "4.21339345632013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00243012874722`", ",", "1.19041205698505`", ",", 
          "5.62617453382792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.658050347360139`", ",", "0.966519912119058`", ",", 
          "0.755770304156115`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59685587315265`", ",", "0.699667644800424`", ",", 
          "2.1685513816639`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53566139894516`", ",", "0.276760195279987`", ",", 
          "3.58133245917169`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.191281617558081`", ",", "2.57022986929687`", ",", 
          "4.99411353667947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.13008714335059`", ",", "2.27087167430235`", ",", 
          "0.123709307007672`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0688926691431`", ",", "2.03463651713691`", ",", 
          "1.53649038451546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00769819493561`", ",", "1.82398925432202`", ",", 
          "2.94927146202324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66331841354853`", ",", "1.62442891791051`", ",", 
          "4.36205253953103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60212393934104`", ",", "1.42701888414777`", ",", 
          "5.77483361703882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.54092946513355`", ",", "1.22369645126433`", ",", 
          "0.904429387367015`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19654968374648`", ",", "1.00384655930939`", ",", 
          "2.3172104648748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13535520953899`", ",", "0.746675357962386`", ",", 
          "3.72999154238259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.0741607353315`", ",", "0.374090113875323`", ",", 
          "5.14277261989037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.729780953944419`", ",", "2.63062153840232`", ",", 
          "0.272368390218572`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66858647973693`", ",", "2.31227691864421`", ",", 
          "1.68514946772636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60739200552944`", ",", "2.06973180972264`", ",", 
          "3.09793054523414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.263012224142362`", ",", "1.85625916407297`", ",", 
          "4.51071162274193`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.20181774993487`", ",", "1.65561008425225`", ",", 
          "5.92349270024972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.14062327572738`", ",", "1.45838234962279`", ",", 
          "1.05308847057792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07942880151989`", ",", "1.25658464688543`", ",", 
          "2.4658695480857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73504902013281`", ",", "1.04030602031799`", ",", 
          "3.87865062559349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67385454592532`", ",", "0.791406092925606`", ",", 
          "5.29143170310127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61266007171783`", ",", "0.45163375312967`", ",", 
          "0.421027473429473`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26828029033076`", ",", "2.69837218274301`", ",", 
          "1.83380855093726`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20708581612327`", ",", "2.35531663438457`", ",", 
          "3.24658962844504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14589134191578`", ",", "2.10551185174975`", ",", 
          "4.65937070595283`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.8015115605287`", ",", "1.88883775913598`", ",", 
          "6.07215178346062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.74031708632121`", ",", "1.68687416411933`", ",", 
          "1.20174755378882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67912261211372`", ",", "1.48963511507164`", ",", 
          "2.6145286312966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.334742830726642`", ",", "1.28912487999123`", ",", 
          "4.02730970880439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27354835651915`", ",", "1.07600150372824`", ",", 
          "5.44009078631217`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21235388231166`", ",", "0.834240411669196`", ",", 
          "0.569686556640373`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.15115940810417`", ",", "0.518365750970293`", ",", 
          "1.98246763414816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80677962671709`", ",", "2.77759330852853`", ",", 
          "3.39524871165594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7455851525096`", ",", "2.40029211845665`", ",", 
          "4.80802978916373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68439067830211`", ",", "2.14206715259112`", ",", 
          "6.22081086667152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.34001089691504`", ",", "1.92176974249467`", ",", 
          "1.35040663699972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27881642270755`", ",", "1.7182526804811`", ",", 
          "2.7631877145075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21762194850006`", ",", "1.52080860207114`", ",", 
          "4.17596879201529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.87324216711298`", ",", "1.32136142769516`", ",", 
          "5.58874986952307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81204769290549`", ",", "1.11102201892194`", ",", 
          "0.718345639851273`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.750853218698`", ",", "0.875470913073067`", ",", 
          "2.13112671735906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.406473437310923`", ",", "0.578058945148503`", ",", 
          "3.54390779486684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34527896310343`", ",", "2.87848234380927`", ",", 
          "4.95668887237463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28408448889594`", ",", "2.44759660059476`", ",", 
          "0.0862846427028302`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22289001468845`", ",", "2.17950280735974`", ",", 
          "1.49906572021062`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87851023330138`", ",", "1.95510386400465`", ",", 
          "2.9118467977184`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81731575909388`", ",", "1.74977819286365`", ",", 
          "4.32462787522619`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7561212848864`", ",", "1.55193352722845`", ",", 
          "5.73740895273397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41174150349932`", ",", "1.3533352863783`", ",", 
          "0.867004723062173`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.35054702929183`", ",", "1.14544521217357`", ",", 
          "2.27978580056996`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28935255508434`", ",", "0.915328592356916`", ",", 
          "3.69256687807774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.944972773697261`", ",", "0.63272415633748`", ",", 
          "5.10534795558553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88377829948977`", ",", "3.0602182910117`", ",", 
          "0.23494372591373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82258382528228`", ",", "2.49776071107346`", ",", 
          "1.64772480342152`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.478204043895203`", ",", "2.21794239934143`", ",", 
          "3.0605058809293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41700956968771`", ",", "1.98889375807727`", ",", 
          "4.47328695843709`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35581509548022`", ",", "1.78148462208597`", ",", 
          "5.88606803594487`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0114353140931462`", ",", "1.5830401800289`", ",", 
          "1.01566380627307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.95024083988566`", ",", "1.38508474153256`", ",", 
          "2.42844488378086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88904636567817`", ",", "1.17933953947326`", ",", 
          "3.84122596128865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82785189147068`", ",", "0.953999875547899`", ",", 
          "5.25400703879643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4834721100836`", ",", "0.683583642244165`", ",", 
          "0.383602809124631`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42227763587611`", ",", "0.236329835973596`", ",", 
          "1.79638388663242`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36108316166862`", ",", "2.5515315543525`", ",", 
          "3.2091649641402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01670338028154`", ",", "2.2575333072212`", ",", 
          "4.62194604164799`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95550890607405`", ",", "2.02319897033281`", ",", 
          "6.03472711915577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89431443186656`", ",", "1.81340761118553`", ",", 
          "1.16432288948397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.549934650479484`", ",", "1.61415869016529`", ",", 
          "2.57710396699176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48874017627199`", ",", "1.41664585348165`", ",", 
          "3.98988504449954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4275457020645`", ",", "1.21276595893347`", ",", 
          "5.40266612200733`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0831659206774267`", ",", "0.99163807014332`", ",", 
          "0.532261892335531`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02197144646994`", ",", "0.731446295107146`", ",", 
          "1.94504296984332`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.96077697226245`", ",", "0.344931519752864`", ",", 
          "3.3578240473511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89958249805496`", ",", "2.61002184968755`", ",", 
          "4.77060512485889`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55520271666788`", ",", "2.29845409405016`", ",", 
          "6.18338620236667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49400824246039`", ",", "2.05808623333164`", ",", 
          "1.31298197269487`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4328137682529`", ",", "1.84558493400041`", ",", 
          "2.72576305020266`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08843398686582`", ",", "1.64531929096613`", ",", 
          "4.13854412771045`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02723951265833`", ",", "1.44805287782258`", ",", 
          "5.55132520521823`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96604503845084`", ",", "1.24577926929365`", ",", 
          "0.680920975546431`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.621665257063765`", ",", "1.02837131969086`", ",", 
          "2.09370205305422`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.56047078285627`", ",", "0.776880572542834`", ",", 
          "3.506483130562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49927630864878`", ",", "0.427528227043493`", ",", 
          "4.91926420806979`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.154896527261707`", ",", "2.67502421077084`", ",", 
          "0.0488599783979882`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09370205305422`", ",", "2.34092507671515`", ",", 
          "1.46164105590577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03250757884673`", ",", "2.09363107457658`", ",", 
          "2.87442213341356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97131310463924`", ",", "1.8780569655771`", ",", 
          "4.28720321092135`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62693332325216`", ",", "1.67655258535177`", ",", 
          "5.69998428842913`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56573884904467`", ",", "1.47933863545193`", ",", 
          "0.829580058757331`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50454437483718`", ",", "1.27842918388178`", ",", 
          "2.24236113626512`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1601645934501`", ",", "1.06430828636502`", ",", 
          "3.6551422137729`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09897011924261`", ",", "0.820304315936854`", ",", 
          "5.06792329128069`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03777564503512`", ",", "0.497269933292772`", ",", 
          "0.197519061608888`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.693395863648045`", ",", "2.74979041860929`", ",", 
          "1.61030013911667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63220138944055`", ",", "2.38522393231519`", ",", 
          "3.02308121662446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.57100691523306`", ",", "2.12991987408443`", ",", 
          "4.43586229413225`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.226627133845988`", ",", "1.91086723229083`", ",", 
          "5.84864337164003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1654326596385`", ",", "1.70788982086969`", ",", 
          "0.978239141968231`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10423818543101`", ",", "1.51053484414849`", ",", 
          "2.39102021947602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04304371122352`", ",", "1.31076120434955`", ",", 
          "3.8038012969838`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69866392983644`", ",", "1.09954230968357`", ",", 
          "5.21658237449159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63746945562895`", ",", "0.862035606743292`", ",", 
          "0.346178144819789`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57627498142146`", ",", "0.55900555921569`", ",", 
          "1.75895922232757`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23189520003438`", ",", "2.84156256740428`", ",", 
          "3.17174029983536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.17070072582689`", ",", "2.43170963072671`", ",", 
          "4.58452137734315`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1095062516194`", ",", "2.16705254028867`", ",", 
          "5.99730245485093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.765126470232326`", ",", "1.9440630646882`", ",", 
          "1.12689822517913`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70393199602483`", ",", "1.73936318080096`", ",", 
          "2.53967930268692`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64273752181735`", ",", "1.54167242159138`", ",", 
          "3.9524603801947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.298357740430268`", ",", "1.34281734129309`", ",", 
          "5.36524145770249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23716326622278`", ",", "1.13415451512095`", ",", 
          "0.494837228030689`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17596879201529`", ",", "0.902323515526197`", ",", 
          "1.90761830553847`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1147743178078`", ",", "0.615165937000881`", ",", 
          "3.32039938304626`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.77039453642072`", ",", "2.97668077670363`", ",", 
          "4.73318046055405`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70920006221323`", ",", "2.48086086610947`", ",", 
          "6.14596153806183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64800558800574`", ",", "2.20514605257423`", ",", 
          "1.27555730839003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30362580661866`", ",", "1.97769638316729`", ",", 
          "2.68833838589782`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24243133241117`", ",", "1.77100609912628`", ",", 
          "4.1011194634056`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18123685820368`", ",", "1.57278176820521`", ",", 
          "5.51390054091339`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.836857076816606`", ",", "1.37463671685152`", ",", 
          "0.643496311241589`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77566260260912`", ",", "1.16821618196248`", ",", 
          "2.05627738874937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71446812840163`", ",", "0.941367681611588`", ",", 
          "3.46905846625716`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.370088347014549`", ",", "0.667175570011457`", ",", 
          "4.88183954376495`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30889387280706`", ",", "0.187560972868453`", ",", 
          "0.0114353140931462`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24769939859957`", ",", "2.53334142299521`", ",", 
          "1.42421639160093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18650492439208`", ",", "2.24433924505747`", ",", 
          "2.83699746910872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.842125143005`", ",", "2.01182465656712`", ",", 
          "4.2497785466165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.78093066879751`", ",", "1.80285360835841`", ",", 
          "5.66255962412429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71973619459002`", ",", "1.60389303720877`", ",", 
          "0.792155394452489`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37535641320294`", ",", "1.40625607585484`", ",", 
          "2.20493647196028`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31416193899545`", ",", "1.20179057788481`", ",", 
          "3.61771754946806`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25296746478796`", ",", "0.97933131530692`", ",", 
          "5.03049862697585`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.908587683400887`", ",", "0.715954302346617`", ",", 
          "0.160094397304046`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8473932091934`", ",", "0.313186337354438`", ",", 
          "1.57287547481183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78619873498591`", ",", "2.59011989455254`", ",", 
          "2.98565655231962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.441818953598829`", ",", "2.28479941312522`", ",", 
          "4.3984376298274`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.38062447939134`", ",", "2.04651208787371`", ",", 
          "5.81121870733519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31943000518385`", ",", "1.83494273099207`", ",", 
          "0.94081447766339`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25823553097636`", ",", "1.63503639861634`", ",", 
          "2.35359555517118`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91385574958928`", ",", "1.43771022598178`", ",", 
          "3.76637663267896`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85266127538179`", ",", "1.23493440277756`", ",", 
          "5.17915771018675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7914668011743`", ",", "1.01635013833705`", ",", 
          "0.308753480514947`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44708701978722`", ",", "0.76213717342118`", ",", 
          "1.72153455802273`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38589254557973`", ",", "0.402073670096653`", ",", 
          "3.13431563553052`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32469807137224`", ",", "2.65271186075937`", ",", 
          "4.5470967130383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.980318289985167`", ",", "2.32673167543641`", ",", 
          "5.95987779054609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91912381577768`", ",", "2.08183110163222`", ",", 
          "1.08947356087429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85792934157019`", ",", "1.86731292775217`", ",", 
          "2.50225463838208`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.51354956018311`", ",", "1.66624230364857`", ",", 
          "3.91503571588986`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45235508597562`", ",", "1.46903242296625`", ",", 
          "5.32781679339765`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39116061176813`", ",", "1.2676989418057`", ",", 
          "0.457412563725847`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0467808303810525`", ",", "1.05253871504979`", ",", 
          "1.87019364123363`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98558635617356`", ",", "0.806184696087`", ",", 
          "3.28297471874142`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92439188196607`", ",", "0.47532014648806`", ",", 
          "4.6957557962492`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86319740775858`", ",", "2.72374449649605`", ",", 
          "6.10853687375699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51881762637151`", ",", "2.37039264538487`", ",", 
          "1.23813264408519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45762315216401`", ",", "2.11786423757455`", ",", 
          "2.65091372159298`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39642867795652`", ",", "1.9000066191681`", ",", 
          "4.06369479910076`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05204889656945`", ",", "1.69754175602924`", ",", 
          "5.47647587660855`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.99085442236196`", ",", "1.50025471367784`", ",", 
          "0.606071646936747`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92965994815447`", ",", "1.30013099925368`", ",", 
          "2.01885272444453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.58528016676739`", ",", "1.08799505075397`", ",", 
          "3.43163380195232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5240856925599`", ",", "0.848443711441047`", ",", 
          "4.8444148794601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46289121835241`", ",", "0.539353224650192`", ",", 
          "6.25719595696789`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.118511436965333`", ",", "2.80860345800775`", ",", 
          "1.38679172729609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05731696275784`", ",", "2.41611112004067`", ",", 
          "2.79957280480388`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99612248855035`", ",", "2.15470659979336`", ",", 
          "4.21235388231166`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93492801434286`", ",", "1.93306980160832`", ",", 
          "5.62513495981945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.59054823295579`", ",", "1.72896659697776`", ",", 
          "0.754730730147647`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52935375874829`", ",", "1.53140824757061`", ",", 
          "2.16751180765543`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46815928454081`", ",", "1.33227366525892`", ",", 
          "3.58029288516322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12377950315373`", ",", "1.12280400601185`", ",", 
          "4.99307396267101`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06258502894624`", ",", "0.889183459878693`", ",", 
          "0.122669732999204`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00139055473875`", ",", "0.597160115355557`", ",", 
          "1.53545081050699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.657010773351671`", ",", "2.92286682370152`", ",", 
          "2.94823188801478`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59581629914418`", ",", "2.46432076674211`", ",", 
          "4.36101296552256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53462182493669`", ",", "2.19246907949944`", ",", 
          "5.77379404303035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.190242043549614`", ",", "1.96655278528194`", ",", 
          "0.903389813358547`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12904756934212`", ",", "1.76054981138053`", ",", 
          "2.31617089086633`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06785309513463`", ",", "1.56252356532467`", ",", 
          "3.72895196837412`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00665862092714`", ",", "1.36416695403644`", ",", 
          "5.14173304588191`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66227883954007`", ",", "1.15703988180361`", ",", 
          "0.271328816210105`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60108436533258`", ",", "0.928618188780509`", ",", 
          "1.68410989371789`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53988989112509`", ",", "0.650418306041015`", ",", 
          "3.09689097122568`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19551010973801`", ",", "0.120737708947117`", ",", 
          "4.50967204873346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13431563553052`", ",", "2.51561459088279`", ",", 
          "5.92245312624125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07312116132303`", ",", "2.23128267749413`", ",", 
          "1.05204889656945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.728741379935951`", ",", "2.00051109061084`", ",", 
          "2.46482997407723`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66754690572846`", ",", "1.79232586369404`", ",", 
          "3.87761105158502`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60635243152097`", ",", "1.59363087234559`", ",", 
          "5.29039212909281`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.261972650133894`", ",", "1.39584834266565`", ",", 
          "0.419987899421005`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2007781759264`", ",", "1.19076841160604`", ",", 
          "1.83276897692879`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13958370171891`", ",", "0.966921972358118`", ",", 
          "3.24555005443658`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07838922751142`", ",", "0.700181347483586`", ",", 
          "4.65833113194436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73400944612435`", ",", "0.277968670084724`", ",", 
          "6.07111220945215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67281497191686`", ",", "2.57084206838298`", ",", 
          "1.20070797978035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.61162049770937`", ",", "2.27130442766703`", ",", 
          "2.61348905728813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26724071632229`", ",", "2.0350065519479`", ",", 
          "4.02627013479592`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2060462421148`", ",", "1.82433107368871`", ",", 
          "5.43905121230371`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14485176790731`", ",", "1.62476030403873`", ",", 
          "0.568646982631905`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.800471986520232`", ",", "1.42735323269921`", ",", 
          "1.98142806013969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73927751231274`", ",", "1.22404832129685`", ",", 
          "3.39420913764748`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67808303810525`", ",", "1.00423879225656`", ",", 
          "4.80699021515526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.333703256718175`", ",", "0.747162428738216`", ",", 
          "6.21977129266305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27250878251068`", ",", "0.374994609491859`", ",", 
          "1.34936706299125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21131430830319`", ",", "2.63129861411618`", ",", 
          "2.76214814049903`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1501198340957`", ",", "2.31272571653444`", ",", 
          "4.17492921800682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80574005270863`", ",", "2.07010869564865`", ",", 
          "5.58771029551461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74454557850114`", ",", "1.8566040443252`", ",", 
          "0.717306065842805`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68335110429365`", ",", "1.65594218937649`", ",", 
          "2.13008714335059`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33897132290657`", ",", "1.45871535193757`", ",", 
          "3.54286822085838`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27777684869908`", ",", "1.25693256902762`", ",", 
          "4.95564929836616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21658237449159`", ",", "1.04068961080889`", ",", 
          "0.0852450686943624`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.872202593104512`", ",", "0.791871172411134`", ",", 
          "1.49802614620215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.81100811889702`", ",", "0.452391363540928`", ",", 
          "2.91080722370993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74981364468953`", ",", "2.69914442322015`", ",", 
          "4.32358830121772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.405433863302455`", ",", "2.3557843060168`", ",", 
          "5.73636937872551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34423938909496`", ",", "2.10589648580952`", ",", 
          "0.865965149053705`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28304491488747`", ",", "1.88918615706717`", ",", 
          "2.27874622656149`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22185044067998`", ",", "1.68720731919458`", ",", 
          "3.69152730406928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87747065929291`", ",", "1.48996711014341`", ",", 
          "5.10430838157706`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81627618508542`", ",", "1.28946934479747`", ",", 
          "0.233904151905263`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75508171087793`", ",", "1.0763774676597`", ",", 
          "1.64668522941305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.41070192949085`", ",", "0.834687017692592`", ",", 
          "3.05946630692083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34950745528336`", ",", "0.519033236491398`", ",", 
          "4.47224738442862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28831298107587`", ",", "2.77852392088244`", ",", 
          "5.88502846193641`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.943933199688793`", ",", "2.40078230196922`", ",", 
          "1.01462423226461`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8827387254813`", ",", "2.14246057012049`", ",", 
          "2.42740530977239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82154425127381`", ",", "1.92212215407936`", ",", 
          "3.84018638728018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.477164469886736`", ",", "1.71858722588126`", ",", 
          "5.25296746478796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41596999567925`", ",", "1.52113991987678`", ",", 
          "0.382563235116163`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35477552147176`", ",", "1.32170288746614`", ",", 
          "1.79534431262395`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0103957400846783`", ",", "1.11139123775766`", ",", 
          "3.20812539013173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94920126587719`", ",", "0.875901790540677`", ",", 
          "4.62090646763952`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.8880067916697`", ",", "0.578664277672224`", ",", 
          "6.03368754514731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82681231746221`", ",", "2.87975766500478`", ",", 
          "1.16328331547551`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48243253607513`", ",", "2.44811411525099`", ",", 
          "2.57606439298329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42123806186764`", ",", "2.17990621779623`", ",", 
          "3.98884547049108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.36004358766015`", ",", "1.95546083248099`", ",", 
          "5.40162654799886`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01566380627307`", ",", "1.75011448168031`", ",", 
          "0.531222318327063`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95446933206558`", ",", "1.55226449176349`", ",", 
          "1.94400339583485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89327485785809`", ",", "1.35367416174494`", ",", 
          "3.35678447334263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.548895076471016`", ",", "1.14580845916223`", ",", 
          "4.76956555085042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48770060226353`", ",", "0.915745934798929`", ",", 
          "6.18234662835821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42650612805604`", ",", "0.633283527315725`", ",", 
          "1.31194239868641`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0821263466689589`", ",", "3.0643962861416`", ",", 
          "2.72472347619419`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.02093187246147`", ",", "2.49831218170827`", ",", 
          "4.13750455370198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95973739825398`", ",", "2.21835723435204`", ",", 
          "5.55028563120976`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89854292404649`", ",", "1.98925588378389`", ",", 
          "0.679881401537963`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55416314265941`", ",", "1.78182302375926`", ",", 
          "2.09266247904575`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49296866845192`", ",", "1.58337111219472`", ",", 
          "3.50544355655354`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43177419424443`", ",", "1.38542142702836`", ",", 
          "4.91822463406132`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08739441285735`", ",", "1.17969749991559`", ",", 
          "0.0478204043895203`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02619993864986`", ",", "0.95440547154573`", ",", 
          "1.46060148189731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96500546444237`", ",", "0.684107412307288`", ",", 
          "2.87338255940509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.620625683055297`", ",", "0.237739022936468`", ",", 
          "4.28616363691288`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55943120884781`", ",", "2.55212653414921`", ",", 
          "5.69894471442066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49823673464032`", ",", "2.25796128685963`", ",", 
          "0.828540484748863`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.153856953253239`", ",", "2.0235669228456`", ",", 
          "2.24132156225665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09266247904575`", ",", "1.81374851557745`", ",", 
          "3.65410263976444`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03146800483826`", ",", "1.61448991058067`", ",", 
          "5.06688371727222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.97027353063077`", ",", "1.41698072232956`", ",", 
          "0.196479487600421`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62589374924369`", ",", "1.21311924609815`", ",", 
          "1.60926056510821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5646992750362`", ",", "0.992033403604645`", ",", 
          "3.02204164261599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50350480082871`", ",", "0.731941567309096`", ",", 
          "4.43482272012378`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15912501944163`", ",", "0.345908821753726`", ",", 
          "5.84760379763156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09793054523414`", ",", "2.61067503260784`", ",", 
          "0.977199567959764`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03673607102665`", ",", "2.29889731999724`", ",", 
          "2.38998064546755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.692356289639577`", ",", "2.0584607666485`", ",", 
          "3.80276172297533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63116181543209`", ",", "1.84592875604585`", ",", 
          "5.21554280048312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5699673412246`", ",", "1.64565112277184`", ",", 
          "0.345138570811321`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.22558755983752`", ",", "1.44838628611336`", ",", 
          "1.75791964831911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16439308563003`", ",", "1.24612843710188`", ",", 
          "3.17070072582689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10319861142254`", ",", "1.02875764060746`", ",", 
          "4.58348180333468`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04200413721505`", ",", "0.777352469487655`", ",", 
          "5.99626288084246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69762435582797`", ",", "0.428325620328591`", ",", 
          "1.12585865117066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63642988162048`", ",", "2.67576038450012`", ",", 
          "2.53863972867845`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57523540741299`", ",", "2.34138616755808`", ",", 
          "3.95142080618624`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.23085562602592`", ",", "2.09401304639435`", ",", 
          "5.36420188369402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16966115181842`", ",", "1.87840415068096`", ",", 
          "0.493797654022221`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10846667761093`", ",", "1.6768853570768`", ",", 
          "1.90657873153001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.764086896223858`", ",", "1.4796709258548`", ",", 
          "3.31935980903779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70289242201637`", ",", "1.2787747371596`", ",", 
          "4.73214088654558`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64169794780888`", ",", "1.06468666204259`", ",", 
          "6.14492196405336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.2973181664218`", ",", "0.820756678520038`", ",", 
          "1.27451773438156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23612369221431`", ",", "0.497963174765449`", ",", 
          "2.68729881188935`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17492921800682`", ",", "2.75065790689972`", ",", 
          "4.10007988939714`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11373474379933`", ",", "2.38570622665668`", ",", 
          "5.51286096690492`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76935496241225`", ",", "2.13031027065439`", ",", 
          "0.642456737233121`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70816048820476`", ",", "1.91121826268631`", ",", 
          "2.05523781474091`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64696601399727`", ",", "1.70822386943062`", ",", 
          "3.46801889224869`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3025862326102`", ",", "1.51086634926902`", ",", 
          "4.88079996975648`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2413917584027`", ",", "1.31110360722842`", ",", 
          "0.0103957400846783`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.18019728419521`", ",", "1.09991366267331`", ",", 
          "1.42317681759246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.835817502808138`", ",", "0.862471405416711`", ",", 
          "2.83595789510025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77462302860065`", ",", "0.559629196373226`", ",", 
          "4.24873897260804`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71342855439316`", ",", "2.84268423514208`", ",", 
          "5.66152005011582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.369048773006081`", ",", "2.43221750494846`", ",", 
          "0.791115820444021`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30785429879859`", ",", "2.1674525090107`", ",", 
          "2.20389689795181`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2466598245911`", ",", "1.94441846703494`", ",", 
          "3.61667797545959`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18546535038361`", ",", "1.73969885471232`", ",", 
          "5.02945905296738`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84108556899653`", ",", "1.54200346707288`", ",", 
          "0.159054823295579`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77989109478904`", ",", "1.34315702418803`", ",", 
          "1.57183590080336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71869662058155`", ",", "1.13451965186655`", ",", 
          "2.98461697831115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37431683919448`", ",", "0.902745106549389`", ",", 
          "4.39739805581894`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31312236498699`", ",", "0.615739106236117`", ",", 
          "5.81017913332672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2519278907795`", ",", "2.97870882581975`", ",", 
          "0.939774903654922`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.907548109392419`", ",", "2.48140025728484`", ",", 
          "2.35255598116271`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84635363518493`", ",", "2.20555694554421`", ",", 
          "3.76533705867049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78515916097744`", ",", "1.97805673775734`", ",", 
          "5.17811813617828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.440779379590362`", ",", "1.77134376201068`", ",", 
          "0.307713906506479`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37958490538287`", ",", "1.57311267565649`", ",", 
          "1.72049498401426`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31839043117538`", ",", "1.37497408233914`", ",", 
          "3.13327606152205`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25719595696789`", ",", "1.16857581482337`", ",", 
          "4.54605713902984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91281617558081`", ",", "0.941776974195897`", ",", 
          "5.95883821653762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85162170137332`", ",", "0.667710170303299`", ",", 
          "1.08843398686582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.79042722716583`", ",", "0.189327402277663`", ",", 
          "2.50121506437361`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44604744577876`", ",", "2.53392074601737`", ",", 
          "3.91399614188139`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38485297157127`", ",", "2.24476267848042`", ",", 
          "5.32677721938918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32365849736378`", ",", "2.01219060863205`", ",", 
          "0.456372989717379`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.979278715976699`", ",", "1.80319364286036`", ",", 
          "1.86915406722517`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91808424176921`", ",", "1.60422412703289`", ",", 
          "3.28193514473295`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85688976756172`", ",", "1.40659150369766`", ",", 
          "4.69471622224074`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.512509986174642`", ",", "1.20214534234368`", ",", 
          "6.10749729974852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45131551196715`", ",", "0.979729884823508`", ",", 
          "1.23709307007672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.39012103775966`", ",", "0.716458327732665`", ",", 
          "2.64987414758451`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0457412563725847`", ",", "0.314258615494114`", ",", 
          "4.06265522509229`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98454678216509`", ",", "2.59075179009348`", ",", 
          "5.47543630260008`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9233523079576`", ",", "2.28523735033083`", ",", 
          "0.605032072928279`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86215783375011`", ",", "2.04688436166562`", ",", 
          "2.01781315043606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51777805236304`", ",", "1.83528554322172`", ",", 
          "3.43059422794385`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45658357815555`", ",", "1.63536799281005`", ",", 
          "4.84337530545164`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39538910394806`", ",", "1.4380440774901`", ",", 
          "6.25615638295942`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.05100932256098`", ",", "1.23528487108911`", ",", 
          "1.38575215328762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98981484835349`", ",", "1.01673930545679`", ",", 
          "2.79853323079541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.928620374146`", ",", "0.762616302363682`", ",", 
          "4.21131430830319`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.584240592758922`", ",", "0.402918431541934`", ",", 
          "5.62409538581098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52304611855143`", ",", "2.65341692742366`", ",", 
          "0.753691156139179`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46185164434394`", ",", "2.3271865461155`", ",", 
          "2.16647223364696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.117471862956865`", ",", "2.08221051821228`", ",", 
          "3.57925331115475`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05627738874937`", ",", "1.86765895241521`", ",", 
          "4.99203438866254`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99508291454188`", ",", "1.66657472864046`", ",", 
          "0.121630158990737`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93388844033439`", ",", "1.46936504484929`", ",", 
          "1.53441123649852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58950865894732`", ",", "1.26804563397783`", ",", 
          "2.94719231400631`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52831418473983`", ",", "1.05291960258111`", ",", 
          "4.35997339151409`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46711971053234`", ",", "0.806643136289209`", ",", 
          "5.77275446902188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12273992914526`", ",", "0.476042737992644`", ",", 
          "0.90235023935008`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.06154545493777`", ",", "2.72456070027676`", ",", 
          "2.31513131685787`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.00035098073028`", ",", "2.37086752248298`", ",", 
          "3.72791239436565`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.655971199343203`", ",", "2.11825173762909`", ",", 
          "5.14069347187344`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59477672513571`", ",", "1.90035632557982`", ",", 
          "0.270289242201637`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53358225092822`", ",", "1.69787534562701`", ",", 
          "1.68307031970942`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.189202469541146`", ",", "1.50058644150653`", ",", 
          "3.09585139721721`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12800799533366`", ",", "1.30047439200499`", ",", 
          "4.50863247472499`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06681352112617`", ",", "1.08836862543018`", ",", 
          "5.92141355223278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00561904691867`", ",", "0.848884686270621`", ",", 
          "1.05100932256098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6612392655316`", ",", "0.539997190657483`", ",", 
          "2.46379040006877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.60004479132411`", ",", "2.80961729521669`", ",", 
          "3.87657147757655`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53885031711662`", ",", "2.41660999253172`", ",", 
          "5.28935255508434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19447053572954`", ",", "2.15510327338223`", ",", 
          "0.418948325412537`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13327606152205`", ",", "1.93342370084715`", ",", 
          "1.83172940292032`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07208158731456`", ",", "1.7293016954998`", ",", 
          "3.24451048042811`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.727701805927484`", ",", "1.53173940895385`", ",", 
          "4.65729155793589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66650733171999`", ",", "1.33261419942585`", ",", 
          "6.07007263544368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6053128575125`", ",", "1.12317110985262`", ",", 
          "1.19966840577188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.260933076125426`", ",", "0.889609506233452`", ",", 
          "2.61244948327967`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19973860191794`", ",", "0.59774835257044`", ",", 
          "4.02523056078745`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13854412771045`", ",", "2.92439710592701`", ",", 
          "5.43801163829524`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07734965350296`", ",", "2.46484898054064`", ",", 
          "0.567607408623437`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73296987211588`", ",", "2.19287620554869`", ",", 
          "1.98038848613122`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67177539790839`", ",", "1.96691143881778`", ",", 
          "3.39316956363901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6105809237009`", ",", "1.76088677705659`", ",", 
          "4.80595064114679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26620114231382`", ",", "1.56285448288577`", ",", 
          "6.21873171865458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20500666810633`", ",", "1.36450504078365`", ",", 
          "1.34832748898278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14381219389884`", ",", "1.15740125608859`", ",", 
          "2.76110856649057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.799432412511764`", ",", "0.929031348660585`", ",", 
          "4.17388964399835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73823793830427`", ",", "0.650964594025917`", ",", 
          "5.58667072150614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67704346409678`", ",", "0.123454668307852`", ",", 
          "0.716266491834337`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.332663682709707`", ",", "2.51617960473021`", ",", 
          "2.12904756934212`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27146920850222`", ",", "2.23170177729071`", ",", 
          "3.54182864684991`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.21027473429473`", ",", "2.00087512085495`", ",", 
          "4.9546097243577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14908026008724`", ",", "1.79266507243317`", ",", 
          "0.0842054946858945`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80470047870016`", ",", "1.59396186657586`", ",", 
          "1.49698657219368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74350600449267`", ",", "1.39618436876838`", ",", 
          "2.90976764970147`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68231153028518`", ",", "1.19112471550927`", ",", 
          "4.32254872720925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3379317488981`", ",", "0.967323921113823`", ",", 
          "5.73532980471704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27673727469061`", ",", "0.700694737170987`", ",", 
          "0.864925575045238`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21554280048312`", ",", "0.279172048571654`", ",", 
          "2.27770665255302`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.871163019096045`", ",", "2.57145485178264`", ",", 
          "3.69048773006081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80996854488855`", ",", "2.27173733899206`", ",", 
          "5.1032688075686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74877407068106`", ",", "2.03537665533082`", ",", 
          "0.232864577896795`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.404394289293987`", ",", "1.82467292333268`", ",", 
          "1.64564565540458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3431998150865`", ",", "1.62509169609896`", ",", 
          "3.05842673291237`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28200534087901`", ",", "1.42768756510518`", ",", 
          "4.47120781042015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.22081086667152`", ",", "1.22440014659571`", ",", 
          "5.88398888792794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87643108528444`", ",", "1.0046309273628`", ",", 
          "1.01358465825614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81523661107695`", ",", "0.747649243537896`", ",", 
          "2.42636573576392`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75404213686946`", ",", "0.375897031437352`", ",", 
          "3.83914681327171`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40966235548238`", ",", "2.63197650982359`", ",", 
          "5.2519278907795`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34846788127489`", ",", "2.31317469912864`", ",", 
          "0.381523661107695`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.2872734070674`", ",", "2.07048565906227`", ",", 
          "1.79430473861548`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.942893625680325`", ",", "1.85694895953254`", ",", 
          "3.20708581612327`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88169915147283`", ",", "1.65627430391483`", ",", 
          "4.61986689363105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.82050467726535`", ",", "1.45904834177179`", ",", 
          "6.03264797113884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.476124895878268`", ",", "1.25728045188232`", ",", 
          "1.16224374146704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41493042167078`", ",", "1.04107311508526`", ",", 
          "2.57502481897482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35373594746329`", ",", "0.792336038477911`", ",", 
          "3.98780589648261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0093561660762105`", ",", "0.453147794792176`", ",", 
          "5.4005869739904`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94816169186872`", ",", "2.69991792448595`", ",", 
          "0.530182744318595`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88696721766123`", ",", "2.35625219628865`", ",", 
          "1.94296382182638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82577274345374`", ",", "2.10628120758844`", ",", 
          "3.35574489933417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.48139296206666`", ",", "1.88953459501058`", ",", 
          "4.76852597684195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.42019848785917`", ",", "1.68754048724975`", ",", 
          "6.18130705434974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35900401365168`", ",", "1.49029909628691`", ",", 
          "1.31090282467794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01462423226461`", ",", "1.28981377531654`", ",", 
          "2.72368390218572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95342975805712`", ",", "1.07675335540858`", ",", 
          "4.13646497969351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89223528384963`", ",", "0.835133443084993`", ",", 
          "5.5492460572013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.547855502462548`", ",", "0.519699943028038`", ",", 
          "0.678841827529495`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48666102825506`", ",", "2.77945681843006`", ",", 
          "2.09162290503728`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42546655404757`", ",", "2.40127274834527`", ",", 
          "3.50440398254507`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.081086772660491`", ",", "2.1428540872463`", ",", 
          "4.91718506005285`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.019892298453`", ",", "1.92247461119095`", ",", 
          "0.0467808303810525`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95869782424551`", ",", "1.71892178794459`", ",", 
          "1.45956190788884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89750335003802`", ",", "1.52147123222717`", ",", 
          "2.87234298539662`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55312356865094`", ",", "1.32204431758073`", ",", 
          "4.28512406290441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49192909444345`", ",", "1.11176038916582`", ",", 
          "5.6979051404122`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.43073462023596`", ",", "0.876332513301842`", ",", 
          "0.827500910740396`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08635483884889`", ",", "0.579269049794475`", ",", 
          "2.24028198824818`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0251603646414`", ",", "2.88103908440241`", ",", 
          "3.65306306575597`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96396589043391`", ",", "2.44863195231822`", ",", 
          "5.06584414326375`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.619586109046829`", ",", "2.18030974179124`", ",", 
          "0.195439913591953`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55839163483934`", ",", "1.95581785255105`", ",", 
          "1.60822099109974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49719716063185`", ",", "1.75045079099754`", ",", 
          "3.02100206860752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.152817379244772`", ",", "1.55259545426837`", ",", 
          "4.43378314611531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09162290503728`", ",", "1.35401301178058`", ",", 
          "5.8465642236231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.03042843082979`", ",", "1.14617164644502`", ",", 
          "0.976159993951296`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9692339566223`", ",", "0.916163143482054`", ",", 
          "2.38894107145908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62485417523522`", ",", "0.633842472420114`", ",", 
          "3.80172214896687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56365970102773`", ",", "3.06881322941545`", ",", 
          "5.21450322647465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50246522682024`", ",", "2.49886405832149`", ",", 
          "0.344098996802853`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15808544543317`", ",", "2.21877219956455`", ",", 
          "1.75688007431064`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09689097122568`", ",", "1.98961806781909`", ",", 
          "3.16966115181842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03569649701819`", ",", "1.78216144996542`", ",", 
          "4.58244222932621`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.691316715631109`", ",", "1.58370204573775`", ",", 
          "5.995223306834`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.63012224142362`", ",", "1.38575809126786`", ",", 
          "1.1248190771622`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56892776721613`", ",", "1.18005540753025`", ",", 
          "2.53760015466998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.224547985829052`", ",", "0.954810951027246`", ",", 
          "3.95038123217777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16335351162156`", ",", "0.684630846175852`", ",", 
          "5.36316230968555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10215903741407`", ",", "0.239140062211603`", ",", 
          "0.492758080013753`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.04096456320658`", ",", "2.55272204373888`", ",", 
          "1.90553915752154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6965847818195`", ",", "2.25838941685388`", ",", 
          "3.31832023502933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63539030761201`", ",", "2.02393494123382`", ",", 
          "4.73110131253711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57419583340452`", ",", "1.81408944877566`", ",", 
          "6.1438823900449`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22981605201745`", ",", "1.61482113579266`", ",", 
          "1.2734781603731`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16862157780996`", ",", "1.4173155737926`", ",", 
          "2.68625923788088`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10742710360247`", ",", "1.21347248662017`", ",", 
          "4.09904031538867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.76304732221539`", ",", "0.992428634973115`", ",", 
          "5.51182139289645`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7018528480079`", ",", "0.732436566632628`", ",", 
          "0.641417163224653`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.64065837380041`", ",", "0.346883480739879`", ",", 
          "2.05419824073244`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.296278592413333`", ",", "2.61132894297972`", ",", 
          "3.46697931824022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23508411820584`", ",", "2.29934072114876`", ",", 
          "4.87976039574801`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17388964399835`", ",", "2.05883537438096`", ",", 
          "0.0093561660762105`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11269516979086`", ",", "1.84627261146524`", ",", 
          "1.422137243584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76831538840379`", ",", "1.64598296283562`", ",", 
          "2.83491832109178`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70712091419629`", ",", "1.44871968072909`", ",", 
          "4.24769939859957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6459264399888`", ",", "1.24647756387997`", ",", 
          "5.66048047610735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30154665860173`", ",", "1.02914387166967`", ",", 
          "0.790076246435554`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.24035218439424`", ",", "0.777824140241692`", ",", 
          "2.20285732394334`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17915771018675`", ",", "0.429121623481765`", ",", 
          "3.61563840145112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.83477792879967`", ",", "2.67649763782106`", ",", 
          "5.02841947895891`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77358345459218`", ",", "2.34184746489304`", ",", 
          "0.158015249287111`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71238898038469`", ",", "2.0943951023932`", ",", 
          "1.5707963267949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.368009198997613`", ",", "1.87875137408284`", ",", 
          "2.98357740430268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30681472479012`", ",", "1.67721814059451`", ",", 
          "4.39635848181047`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24562025058263`", ",", "1.48000320616823`", ",", 
          "5.80913955931825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18442577637514`", ",", "1.27912025454551`", ",", 
          "0.938735329646454`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.84004599498807`", ",", "1.0650649583841`", ",", 
          "2.35151640715424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77885152078057`", ",", "0.82120885053399`", ",", 
          "3.76429748466203`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71765704657309`", ",", "0.498655533385677`", ",", 
          "5.17707856216981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37327726518601`", ",", "2.75152722493356`", ",", 
          "0.306674332498011`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31208279097852`", ",", "2.38618876788343`", ",", 
          "1.7194554100058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.25088831677103`", ",", "2.1307007626976`", ",", 
          "3.13223648751358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.906508535383951`", ",", "1.91156933673401`", ",", 
          "4.54501756502137`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84531406117646`", ",", "1.70855793342487`", ",", 
          "5.95779864252916`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78411958696897`", ",", "1.51119784779574`", ",", 
          "1.08739441285735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.439739805581894`", ",", "1.3114459789604`", ",", 
          "2.50017549036514`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3785453313744`", ",", "1.10028494547306`", ",", 
          "3.91295656787293`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31735085716691`", ",", "0.862907041461087`", ",", 
          "5.32573764538071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25615638295942`", ",", "0.560252213294129`", ",", 
          "0.455333415708911`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91177660157235`", ",", "2.84381000082748`", ",", 
          "1.8681144932167`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.85058212736486`", ",", "2.43272567981809`", ",", 
          "3.28089557072448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78938765315737`", ",", "2.16785258642352`", ",", 
          "4.69367664823227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44500787177029`", ",", "1.94477391890698`", ",", 
          "6.10645772574005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.3838133975628`", ",", "1.74003454783929`", ",", 
          "1.23605349606825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32261892335531`", ",", "1.54233450939809`", ",", 
          "2.64883457357604`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.978239141968231`", ",", "1.34349668035572`", ",", 
          "4.06161565108383`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91704466776074`", ",", "1.13488472646137`", ",", 
          "5.47439672859161`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85585019355325`", ",", "0.903166557367662`", ",", 
          "0.603992498919811`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.511470412166174`", ",", "0.616311811500936`", ",", 
          "2.0167735764276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.45027593795868`", ",", "2.98076221698331`", ",", 
          "3.42955465393538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38908146375119`", ",", "2.48194002344765`", ",", 
          "4.84233573144317`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0447016823641169`", ",", "2.20596796288582`", ",", 
          "6.25511680895095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98350720815663`", ",", "1.97841714837287`", ",", 
          "1.38471257927915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92231273394914`", ",", "1.77168144807389`", ",", 
          "2.79749365678694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86111825974165`", ",", "1.5734435833614`", ",", 
          "4.21027473429473`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51673847835457`", ",", "1.37531142525135`", ",", 
          "5.62305581180251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45554400414708`", ",", "1.16893539267153`", ",", 
          "0.752651582130712`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39434952993959`", ",", "0.942186144926306`", ",", 
          "2.1654326596385`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04996974855251`", ",", "0.668244408398963`", ",", 
          "3.57821373714628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98877527434502`", ",", "0.191077696286618`", ",", 
          "4.99099481465407`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92758080013753`", ",", "2.5345005520228`", ",", 
          "0.120590584982269`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.583201018750455`", ",", "2.2451862551609`", ",", 
          "1.53337166249005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.52200654454296`", ",", "2.01255662398354`", ",", 
          "2.94615273999784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.46081207033547`", ",", "1.80353370472953`", ",", 
          "4.35893381750563`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.116432288948397`", ",", "1.6045552205228`", ",", 
          "5.77171489501341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05523781474091`", ",", "1.40692691289867`", ",", 
          "0.901310665341612`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99404334053342`", ",", "1.20250005818882`", ",", 
          "2.3140917428494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93284886632593`", ",", "0.980128347759013`", ",", 
          "3.72687282035718`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58846908493885`", ",", "0.716962061560914`", ",", 
          "5.13965389786497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52727461073136`", ",", "0.315327367780473`", ",", 
          "0.269249668193169`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46608013652387`", ",", "2.59138433633875`", ",", 
          "1.68203074570095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12170035513679`", ",", "2.2856754539345`", ",", 
          "3.09481182320874`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0605058809293`", ",", "2.04725670693386`", ",", 
          "4.50759290071653`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99931140672181`", ",", "1.83562838728283`", ",", 
          "5.92037397822431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.654931625334735`", ",", "1.63569959411375`", ",", 
          "1.04996974855251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59373715112724`", ",", "1.43837791411541`", ",", 
          "2.4627508260603`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53254267691975`", ",", "1.23563529657641`", ",", 
          "3.87553190356808`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.188162895532678`", ",", "1.01712837889613`", ",", 
          "5.28831298107587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12696842132519`", ",", "0.763095191156457`", ",", 
          "0.417908751404069`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0657739471177`", ",", "0.403761522060046`", ",", 
          "1.83068982891185`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00457947291021`", ",", "2.65412293144437`", ",", 
          "3.24347090641964`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.66019969152313`", ",", "2.32764161211709`", ",", 
          "4.65625198392743`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59900521731564`", ",", "2.08259001560063`", ",", 
          "6.06903306143521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53781074310815`", ",", "1.86800501370872`", ",", 
          "1.19862883176341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19343096172107`", ",", "1.6669071642493`", ",", 
          "2.6114099092712`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13223648751358`", ",", "1.46969765547199`", ",", 
          "4.02419098677898`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07104201330609`", ",", "1.26839228861064`", ",", 
          "5.43697206428677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.726662231919016`", ",", "1.05330040747428`", ",", 
          "0.566567834614969`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66546775771152`", ",", "0.807101375157941`", ",", 
          "1.97934891212276`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60427328350403`", ",", "0.476764318214988`", ",", 
          "3.39212998963054`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.259893502116958`", ",", "2.72537841058911`", ",", 
          "4.80491106713833`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19869902790947`", ",", "2.37134263191984`", ",", 
          "6.21769214464611`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13750455370198`", ",", "2.11863932924198`", ",", 
          "1.34728791497431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07631007949449`", ",", "1.90070607382536`", ",", 
          "2.7600689924821`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73193029810741`", ",", "1.6982089494436`", ",", 
          "4.17285006998988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.67073582389992`", ",", "1.50091816159655`", ",", 
          "5.58563114749767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60954134969243`", ",", "1.30081775208361`", ",", 
          "0.71522691782587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26516156830535`", ",", "1.08874212703408`", ",", 
          "2.12800799533366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20396709409786`", ",", "0.849325489954247`", ",", 
          "3.54078907284144`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14277261989037`", ",", "0.540640465590921`", ",", 
          "4.95357015034923`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.798392838503296`", ",", "2.81063412285934`", ",", 
          "0.0831659206774267`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73719836429581`", ",", "2.41710914610168`", ",", 
          "1.49594699818521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67600389008832`", ",", "2.15550005106047`", ",", 
          "2.908728075693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.331624108701239`", ",", "1.93377764761088`", ",", 
          "4.32150915320078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.27042963449375`", ",", "1.72963681197211`", ",", 
          "5.73429023070857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20923516028626`", ",", "1.53207056605167`", ",", 
          "0.86388600103677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14804068607877`", ",", "1.33295470544023`", ",", 
          "2.27666707854456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80366090469169`", ",", "1.12353814900003`", ",", 
          "3.68944815605234`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7424664304842`", ",", "0.890035405497776`", ",", 
          "5.10222923356013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68127195627671`", ",", "0.59833608199151`", ",", 
          "0.231825003888327`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33689217488963`", ",", "2.92593807427064`", ",", 
          "1.64460608139611`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27569770068214`", ",", "2.46537754190179`", ",", 
          "3.0573871589039`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21450322647465`", ",", "2.19328345048546`", ",", 
          "4.47016823641168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.870123445087577`", ",", "1.96727014615849`", ",", 
          "5.88294931391947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80892897088009`", ",", "1.76122376458184`", ",", 
          "1.01254508424767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7477344966726`", ",", "1.56318539957717`", ",", 
          "2.42532616175546`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.40335471528552`", ",", "1.36484310361263`", ",", 
          "3.83810723926324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34216024107803`", ",", "1.15776257309565`", ",", 
          "5.25088831677103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.28096576687054`", ",", "0.929444381016664`", ",", 
          "0.380484087099227`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21977129266305`", ",", "0.651510490510209`", ",", 
          "1.79326516460701`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87539151127597`", ",", "0.126113398726503`", ",", 
          "3.2060462421148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81419703706848`", ",", "2.51674506101657`", ",", 
          "4.61882731962259`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75300256286099`", ",", "2.23212101370551`", ",", 
          "6.03160839713037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40862278147391`", ",", "2.0012392118974`", ",", 
          "1.16120416745857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34742830726642`", ",", "1.79300430713037`", ",", 
          "2.57398524496636`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28623383305893`", ",", "1.59429286334455`", ",", 
          "3.98676632247414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.941854051671857`", ",", "1.39652037495337`", ",", 
          "5.39954739998193`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.88065957746437`", ",", "1.1914809687616`", ",", 
          "0.529143170310127`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81946510325688`", ",", "0.967725758543744`", ",", 
          "1.94192424781791`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.4750853218698`", ",", "0.701207814569116`", ",", 
          "3.3547053253257`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41389084766231`", ",", "0.280370396398774`", ",", 
          "4.76748640283349`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35269637345482`", ",", "2.5720682214029`", ",", 
          "6.18026748034127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00831659206774267`", ",", "2.27217040853176`", ",", 
          "1.30986325066947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94712211786025`", ",", "2.0357468273745`", ",", 
          "2.72264432817726`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88592764365276`", ",", "1.82501480330194`", ",", 
          "4.13542540568504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82473316944527`", ",", "1.62542309412793`", ",", 
          "5.54820648319283`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.4803533880582`", ",", "1.42802188140538`", ",", 
          "0.677802253521028`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4191589138507`", ",", "1.22475192722149`", ",", 
          "2.09058333102881`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35796443964321`", ",", "1.00502296476155`", ",", 
          "3.5033644085366`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01358465825614`", ",", "0.74813580287977`", ",", 
          "4.91614548604439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95239018404865`", ",", "0.376797394639093`", ",", 
          "0.0457412563725847`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89119570984116`", ",", "2.63265522882369`", ",", 
          "1.45852233388037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.54681592845408`", ",", "2.31362386674567`", ",", 
          "2.87130341138816`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48562145424659`", ",", "2.07086270006491`", ",", 
          "4.28408448889594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4244269800391`", ",", "1.85729390974666`", ",", 
          "5.69686556640373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0800471986520232`", ",", "1.65660642790469`", ",", 
          "0.826461336731928`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01885272444453`", ",", "1.45938131916377`", ",", 
          "2.23924241423971`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95765825023704`", ",", "1.25762829550492`", ",", 
          "3.6520234917475`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89646377602955`", ",", "1.04145653326157`", ",", 
          "5.06480456925529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55208399464248`", ",", "0.792800691519793`", ",", 
          "0.194400339583485`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.49088952043498`", ",", "0.453903052802951`", ",", 
          "1.60718141709127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4296950462275`", ",", "2.70069269320095`", ",", 
          "3.01996249459906`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08531526484042`", ",", "2.35672030560961`", ",", 
          "4.43274357210684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02412079063293`", ",", "2.10666601720353`", ",", 
          "5.84552464961463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96292631642544`", ",", "1.88988307302232`", ",", 
          "0.975120419942828`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.618546535038361`", ",", "1.68787366832334`", ",", 
          "2.38790149745061`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55735206083087`", ",", "1.49063107353946`", ",", 
          "3.8006825749584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49615758662338`", ",", "1.29015817159952`", ",", 
          "5.21346365246619`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.151777805236304`", ",", "1.07712916707424`", ",", 
          "0.343059422794385`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.09058333102881`", ",", "0.835579688154254`", ",", 
          "1.75584050030217`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02938885682132`", ",", "0.520365873596504`", ",", 
          "3.16862157780996`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96819438261383`", ",", "2.78039201890689`", ",", 
          "4.58140265531774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62381460122676`", ",", "2.4017634581263`", ",", 
          "5.99418373282553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56262012701927`", ",", "2.14324770410522`", ",", 
          "1.12377950315373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50142565281177`", ",", "1.92282711389088`", ",", 
          "2.53656058066151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1570458714247`", ",", "1.71925636671104`", ",", 
          "3.9493416581693`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09585139721721`", ",", "1.52180253915894`", ",", 
          "5.36212273567709`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03465692300972`", ",", "1.32238571808643`", ",", 
          "0.491718506005285`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.690277141622642`", ",", "1.11212947323364`", ",", 
          "1.90449958351307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62908266741515`", ",", "0.876763081602908`", ",", 
          "3.31728066102086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56788819320766`", ",", "0.57987326328938`", ",", 
          "4.73006173852864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.223508411820584`", ",", "2.882326692462`", ",", 
          "6.14284281603643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16231393761309`", ",", "2.44915011253892`", ",", 
          "1.27243858636463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1011194634056`", ",", "2.1807133795065`", ",", 
          "2.68521966387241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03992498919811`", ",", "1.95617492428272`", ",", 
          "4.0980007413802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69554520781104`", ",", "1.75078712085713`", ",", 
          "5.51078181888799`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63435073360355`", ",", "1.55292641477939`", ",", 
          "0.640377589216186`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57315625939606`", ",", "1.3543518365298`", ",", 
          "2.05315866672397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22877647800898`", ",", "1.14653477409925`", ",", 
          "3.46593974423176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16758200380149`", ",", "0.916580218607369`", ",", 
          "4.87872082173954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.106387529594`", ",", "0.634400992796107`", ",", 
          "0.00831659206774267`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.762007748206922`", ",", "3.07351561507127`", ",", 
          "1.42109766957553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.70081327399943`", ",", "2.4994163419795`", ",", 
          "2.83387874708331`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63961879979194`", ",", "2.21918729517316`", ",", 
          "4.2466598245911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.295239018404865`", ",", "1.98998031025859`", ",", 
          "5.65944090209889`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23404454419737`", ",", "1.78249990074856`", ",", 
          "0.789036672427086`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17285006998988`", ",", "1.58403298069427`", ",", 
          "2.20181774993487`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11165559578239`", ",", "1.38609473429327`", ",", 
          "3.61459882744266`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76727581439532`", ",", "1.18041326238644`", ",", 
          "5.02737990495044`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70608134018783`", ",", "0.955216314159413`", ",", 
          "0.156975675278643`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64488686598034`", ",", "0.685153944639548`", ",", 
          "1.56975675278643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.30050708459326`", ",", "0.240533096214848`", ",", 
          "2.98253783029421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23931261038577`", ",", "2.55331808475104`", ",", 
          "4.395318907802`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17811813617828`", ",", "2.25881769744111`", ",", 
          "5.80809998530979`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.833738354791203`", ",", "2.02430302558273`", ",", 
          "0.937695755637986`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77254388058371`", ",", "1.8144304108271`", ",", 
          "2.35047683314577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71134940637622`", ",", "1.61515236583782`", ",", 
          "3.76325791065356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.366969624989145`", ",", "1.41765040791102`", ",", 
          "5.17603898816134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30577515078165`", ",", "1.21382568056206`", ",", 
          "0.305634758489543`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24458067657417`", ",", "0.992823764389477`", ",", 
          "1.71841583599733`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18338620236667`", ",", "0.732931293649374`", ",", 
          "3.13119691350511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8390064209796`", ",", "0.347855518957789`", ",", 
          "4.5439779910129`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77781194677211`", ",", "2.61198358351965`", ",", 
          "5.95675906852069`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71661747256462`", ",", "2.29978429779993`", ",", 
          "1.08635483884889`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37223769117754`", ",", "2.05921005662602`", ",", 
          "2.49913591635667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31104321697005`", ",", "1.84661650030896`", ",", 
          "3.91191699386446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24984874276256`", ",", "1.64631481119463`", ",", 
          "5.32469807137224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.905468961375483`", ",", "1.44905306170851`", ",", 
          "0.454293841700443`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84427448716799`", ",", "1.2468266496849`", ",", 
          "1.86707491920823`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7830800129605`", ",", "1.02953001299775`", ",", 
          "3.27985599671601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.438700231573426`", ",", "0.778295585234671`", ",", 
          "4.6926370742238`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37750575736594`", ",", "0.429916244249945`", ",", 
          "6.10541815173159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31631128315845`", ",", "2.67723597589976`", ",", 
          "1.23501392205979`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25511680895095`", ",", "2.342308969096`", ",", 
          "2.64779499956757`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.91073702756388`", ",", "2.0947772426846`", ",", 
          "4.06057607707536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84954255335639`", ",", "1.87909863583728`", ",", 
          "5.47335715458314`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.7883480791489`", ",", "1.67755093594301`", ",", 
          "0.602952924911343`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44396829776182`", ",", "1.48033547642985`", ",", 
          "2.01573400241913`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38277382355433`", ",", "1.27946573609191`", ",", 
          "3.42851507992691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32157934934684`", ",", "1.06544317549353`", ",", 
          "4.8412961574347`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.977199567959764`", ",", "0.821660832311687`", ",", 
          "6.25407723494249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91600509375227`", ",", "0.499347012848492`", ",", 
          "1.38367300527069`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85481061954478`", ",", "2.75239838499915`", ",", 
          "2.79645408277847`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.510430838157706`", ",", "2.3866715564875`", ",", 
          "4.20923516028626`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44923636395022`", ",", "2.13109135034371`", ",", 
          "5.62201623779404`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38804188974273`", ",", "1.91192045449351`", ",", 
          "0.751612008122244`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.043662108355649`", ",", "1.70889201289186`", ",", 
          "2.16439308563003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98246763414816`", ",", "1.51152933976547`", ",", 
          "3.57717416313781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.92127315994067`", ",", "1.31178831959411`", ",", 
          "4.9899552406456`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.86007868573318`", ",", "1.10065615817378`", ",", 
          "0.119551010973801`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5156989043461`", ",", "0.863342515140933`", ",", 
          "1.53233208848159`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45450443013861`", ",", "0.560874612066398`", ",", 
          "2.94511316598937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39330995593112`", ",", "2.84493991114881`", ",", 
          "4.35789424349716`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04893017454404`", ",", "2.43323415600161`", ",", 
          "5.77067532100494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98773570033655`", ",", "2.1682527726799`", ",", 
          "0.900271091333144`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92654122612906`", ",", "1.94512942036997`", ",", 
          "2.31305216884093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.582161444741987`", ",", "1.74037026022298`", ",", 
          "3.72583324634872`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5209669705345`", ",", "1.54266554860339`", ",", 
          "5.1386143238565`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45977249632701`", ",", "1.34383630984166`", ",", 
          "0.268210094184701`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.11539271493993`", ",", "1.13524973898575`", ",", 
          "1.68099117169249`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05419824073244`", ",", "0.903587868195586`", ",", 
          "3.09377224920027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99300376652495`", ",", "0.61688405410763`", ",", 
          "4.50655332670806`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93180929231746`", ",", "2.98284193362763`", ",", 
          "5.91933440421584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58742951093038`", ",", "2.48248016553866`", ",", 
          "1.04893017454404`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52623503672289`", ",", "2.20637910478156`", ",", 
          "2.46171125205183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4650405625154`", ",", "1.97877761508687`", ",", 
          "3.87449232955962`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.12066078112832`", ",", "1.77201915735921`", ",", 
          "5.2872734070674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05946630692083`", ",", "1.57377449135618`", ",", 
          "0.416869177395601`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99827183271334`", ",", "1.37564874563107`", ",", 
          "1.82965025490339`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.653892051326267`", ",", "1.16929491557867`", ",", 
          "3.24243133241117`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59269757711878`", ",", "0.942595193980027`", ",", 
          "4.65521240991896`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53150310291129`", ",", "0.668778285185795`", ",", 
          "6.06799348742675`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.18712332152421`", ",", "0.192812294364545`", ",", 
          "1.19758925775494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12592884731672`", ",", "2.53508084241691`", ",", 
          "2.61037033526273`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06473437310923`", ",", "2.2456099753205`", ",", 
          "4.02315141277052`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00353989890174`", ",", "2.01292270270351`", ",", 
          "5.4359324902783`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65916011751466`", ",", "1.80387379401185`", ",", 
          "0.565528260606501`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59796564330717`", ",", "1.6048863177149`", ",", 
          "1.97830933811429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53677116909968`", ",", "1.4072623034987`", ",", 
          "3.39109041562207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19239138771261`", ",", "1.20285472548483`", ",", 
          "4.80387149312986`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13119691350511`", ",", "0.980526704262108`", ",", 
          "6.21665257063764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.07000243929762`", ",", "0.717465504464343`", ",", 
          "1.34624834096584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.725622657910548`", ",", "0.316392629976335`", ",", 
          "2.75902941847363`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66442818370306`", ",", "2.5920175355566`", ",", 
          "4.17181049598142`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60323370949557`", ",", "2.2861137242102`", ",", 
          "5.5845915734892`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.258853928108491`", ",", "2.04762912377127`", ",", 
          "0.714187343817402`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.197659453901`", ",", "1.83597126322457`", ",", 
          "2.12696842132519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13646497969351`", ",", "1.63603120256437`", ",", 
          "3.53974949883297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07527050548602`", ",", "1.4387117358969`", ",", 
          "4.95253057634076`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.73089072409894`", ",", "1.23598567929817`", ",", 
          "0.0821263466689589`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66969624989145`", ",", "1.01751735878154`", ",", 
          "1.49490742417674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60850177568396`", ",", "0.763573840269907`", ",", 
          "2.90768850168453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26412199429689`", ",", "0.404602952122895`", ",", 
          "4.32046957919232`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2029275200894`", ",", "2.65482987692331`", ",", 
          "5.7332506567001`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14173304588191`", ",", "2.32809687378738`", ",", 
          "0.862846427028302`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.797353264494828`", ",", "2.08296959390359`", ",", 
          "2.27562750453609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73615879028734`", ",", "1.86835111168578`", ",", 
          "3.68840858204387`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67496431607985`", ",", "1.66723961051284`", ",", 
          "5.10118965955166`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.330584534692771`", ",", "1.47003025487226`", ",", 
          "0.230785429879859`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26939006048528`", ",", "1.26873890575796`", ",", 
          "1.64356650738764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20819558627779`", ",", "1.05368112983827`", ",", 
          "3.05634758489543`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1470011120703`", ",", "0.807559413054317`", ",", 
          "4.46912866240322`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80262133068322`", ",", "0.47748489176332`", ",", 
          "5.881909739911`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74142685647573`", ",", "2.726197636356`", ",", 
          "1.0115055102392`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.68023238226824`", ",", "2.37181797414421`", ",", 
          "2.42428658774699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33585260088117`", ",", "2.11902701253641`", ",", 
          "3.83706766525477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27465812667368`", ",", "1.90105586396254`", ",", 
          "5.24984874276256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21346365246619`", ",", "1.69854256751799`", ",", 
          "0.379444513090759`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.869083871079109`", ",", "1.50124987398494`", ",", 
          "1.79222559059855`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80788939687162`", ",", "1.30116107953932`", ",", 
          "3.20500666810633`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74669492266413`", ",", "1.0891155556606`", ",", 
          "4.61778774561412`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.402315141277052`", ",", "0.849766122776595`", ",", 
          "6.0305688231219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34112066706956`", ",", "0.541283051935959`", ",", 
          "1.1601645934501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27992619286207`", ",", "2.8116539686155`", ",", 
          "2.57294567095789`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21873171865458`", ",", "2.41760858135075`", ",", 
          "3.98572674846567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8743519372675`", ",", "2.15589693297259`", ",", 
          "5.39850782597346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81315746306001`", ",", "1.93413164196301`", ",", 
          "0.528103596301659`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75196298885252`", ",", "1.7299719464352`", ",", 
          "1.94088467380945`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40758320746545`", ",", "1.53240171890056`", ",", 
          "3.35366575131723`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34638873325796`", ",", "1.33329518334851`", ",", 
          "4.76644682882502`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28519425905047`", ",", "1.12390512353769`", ",", 
          "6.1792279063328`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.94081447766339`", ",", "0.890461157901082`", ",", 
          "1.308823676661`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8796200034559`", ",", "0.598923305134049`", ",", 
          "2.72160475416879`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81842552924841`", ",", "2.92748995951342`", ",", 
          "4.13438583167657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.474045747861332`", ",", "2.46590645166052`", ",", 
          "5.54716690918436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41285127365384`", ",", "2.19369081448156`", ",", 
          "0.67676267951256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35165679944635`", ",", "1.96762890737448`", ",", 
          "2.08954375702035`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00727701805927484`", ",", "1.7615607739988`", ",", 
          "3.50232483452813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94608254385178`", ",", "1.56351631543511`", ",", 
          "4.91510591203592`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88488806964429`", ",", "1.36518114256708`", ",", 
          "0.0447016823641169`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8236935954368`", ",", "1.15812383289918`", ",", 
          "1.4574827598719`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47931381404973`", ",", "0.929857286037152`", ",", 
          "2.87026383737969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41811933984224`", ",", "0.65205599649673`", ",", 
          "4.28304491488747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35692486563475`", ",", "0.128717508581243`", ",", 
          "5.69582599239526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01254508424767`", ",", "2.5173109609641`", ",", 
          "0.82542176272346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95135061004018`", ",", "2.23254038694598`", ",", 
          "2.23820284023125`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.89015613583269`", ",", "2.00160336381696`", ",", 
          "3.65098391773903`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.545776354445613`", ",", "1.79334356783067`", ",", 
          "5.06376499524682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48458188023812`", ",", "1.59462386268798`", ",", 
          "0.193360765575017`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42338740603063`", ",", "1.39685636126212`", ",", 
          "1.6061418430828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0790076246435554`", ",", "1.19183717142982`", ",", 
          "3.01892292059059`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01781315043606`", ",", "0.968127484805163`", ",", 
          "4.43170399809837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95661867622857`", ",", "0.701720580381988`", ",", 
          "5.84448507560616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89542420202108`", ",", "0.281563777834312`", ",", 
          "0.97408084593436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55104442063401`", ",", "2.57268217916084`", ",", 
          "2.38686192344215`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48984994642652`", ",", "2.27260363654104`", ",", 
          "3.79964300094993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42865547221903`", ",", "2.03611706816794`", ",", 
          "5.21242407845772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08427569083195`", ",", "1.82535671364453`", ",", 
          "0.342019848785917`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02308121662446`", ",", "1.62575449816234`", ",", 
          "1.7548009262937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.96188674241697`", ",", "1.42835618163951`", ",", 
          "3.16758200380149`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.617506961029893`", ",", "1.22510366323473`", ",", 
          "4.58036308130928`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5563124868224`", ",", "1.00541490458601`", ",", 
          "5.99314415881706`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49511801261491`", ",", "0.74862210728058`", ",", 
          "1.12273992914526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.150738231227836`", ",", "0.377695713848214`", ",", 
          "2.53552100665305`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08954375702035`", ",", "2.63333477443721`", ",", 
          "3.94830208416083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02834928281286`", ",", "2.31407321970519`", ",", 
          "5.36108316166862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96715480860537`", ",", "2.07123981875813`", ",", 
          "0.490678931996818`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62277502721829`", ",", "1.85763889501928`", ",", 
          "1.9034600095046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5615805530108`", ",", "1.65693856138352`", ",", 
          "3.31624108701239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.50038607880331`", ",", "1.45971428415182`", ",", 
          "4.72902216452018`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15600629741623`", ",", "1.25797609995077`", ",", 
          "6.14180324202796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09481182320874`", ",", "1.04183986545213`", ",", 
          "1.27139901235616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03361734900125`", ",", "0.79326513192955`", ",", 
          "2.68418008986395`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.689237567614174`", ",", "0.454657143444354`", ",", 
          "4.09696116737173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62804309340668`", ",", "2.70146873608349`", ",", 
          "5.50974224487952`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56684861919919`", ",", "2.35718863439035`", ",", 
          "0.639338015207718`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.222468837812116`", ",", "2.10705091477201`", ",", 
          "2.0521190927155`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16127436360463`", ",", "1.89023159115855`", ",", 
          "3.46490017022329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.10007988939714`", ",", "1.68820686245386`", ",", 
          "4.87768124773108`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03888541518965`", ",", "1.49096304193834`", ",", 
          "0.00727701805927484`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69450563380257`", ",", "1.29050253369745`", ",", 
          "1.42005809556706`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63331115959508`", ",", "1.07750490275591`", ",", 
          "2.83283917307485`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57211668538759`", ",", "0.836025753207466`", ",", 
          "4.24562025058263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22773690400051`", ",", "0.521031031194204`", ",", 
          "5.65840132809042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16654242979302`", ",", "2.78132954027652`", ",", 
          "0.787997098418618`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10534795558553`", ",", "2.40225443185551`", ",", 
          "2.2007781759264`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.760968174198454`", ",", "2.14364142083412`", ",", 
          "3.61355925343419`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69977369999096`", ",", "1.92317966224067`", ",", 
          "5.02634033094198`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63857922578347`", ",", "1.71959096222056`", ",", 
          "0.155936101270175`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.294199444396397`", ",", "1.52213384070872`", ",", 
          "1.56871717877796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23300497018891`", ",", "1.32272708903075`", ",", 
          "2.98149825628575`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17181049598142`", ",", "1.11249849004821`", ",", 
          "4.39427933379353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.11061602177393`", ",", "0.877193495689664`", ",", 
          "5.80706041130132`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76623624038685`", ",", "0.580476919922067`", ",", 
          "0.936656181629518`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70504176617936`", ",", "2.88362058189049`", ",", 
          "2.3494372591373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64384729197187`", ",", "2.4496685966582`", ",", 
          "3.76221833664509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29946751058479`", ",", "2.18111713110402`", ",", 
          "5.17499941415288`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2382730363773`", ",", "1.956532047744`", ",", 
          "0.304595184481075`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17707856216981`", ",", "1.75112347130089`", ",", 
          "1.71737626198886`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.832698780782735`", ",", "1.55325737333283`", ",", 
          "3.13015733949665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77150430657524`", ",", "1.35469063603715`", ",", 
          "4.54293841700443`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.71030983236775`", ",", "1.14689784220214`", ",", 
          "5.95571949451222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.365930050980677`", ",", "0.916997160375538`", ",", 
          "1.08531526484042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30473557677319`", ",", "0.634959089584286`", ",", 
          "2.4980963423482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2435411025657`", ",", "3.0785673023514`", ",", 
          "3.91087741985599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18234662835821`", ",", "2.49996903375314`", ",", 
          "5.32365849736378`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83796684697113`", ",", "2.21960252137246`", ",", 
          "0.453254267691975`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77677237276364`", ",", "1.99034261117821`", ",", 
          "1.86603534519976`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71557789855615`", ",", "1.78283837615282`", ",", 
          "3.27881642270755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.37119811716907`", ",", "1.58436391710054`", ",", 
          "4.69159750021533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.31000364296158`", ",", "1.38643135614672`", ",", 
          "6.10437857772312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24880916875409`", ",", "1.18077106455331`", ",", 
          "1.23397434805132`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.904429387367015`", ",", "0.955621561108883`", ",", 
          "2.6467554255591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84323491315952`", ",", "0.685676708485171`", ",", 
          "4.05953650306689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78204043895203`", ",", "0.241918263277574`", ",", 
          "5.47231758057468`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.437660657564958`", ",", "2.55391465882325`", ",", 
          "0.601913350902876`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37646618335747`", ",", "2.25924612885897`", ",", 
          "2.01469442841066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31527170914998`", ",", "2.0246711759777`", ",", 
          "3.42747550591845`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25407723494249`", ",", "1.81477140177874`", ",", 
          "4.84025658342623`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90969745355541`", ",", "1.61548360075269`", ",", 
          "6.25303766093402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84850297934792`", ",", "1.41798522472504`", ",", 
          "1.38263343126222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78730850514043`", ",", "1.2141788279863`", ",", 
          "2.79541450877`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44292872375335`", ",", "0.993218791994228`", ",", 
          "4.20819558627779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38173424954586`", ",", "0.733425748929127`", ",", 
          "5.62097666378558`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.32053977533837`", ",", "0.348824958346557`", ",", 
          "0.750572434113776`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.976159993951296`", ",", "2.61263895696057`", ",", 
          "2.16335351162156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91496551974381`", ",", "2.30022805024668`", ",", 
          "3.57613458912935`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85377104553632`", ",", "2.05958481348078`", ",", 
          "4.98891566663713`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.509391264149238`", ",", "1.84696042262745`", ",", 
          "0.118511436965333`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44819678994175`", ",", "1.64664666788604`", ",", 
          "1.53129251447312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38700231573426`", ",", "1.44938642909034`", ",", 
          "2.9440735919809`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0426225343471812`", ",", "1.24717569457364`", ",", 
          "4.35685466948869`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98142806013969`", ",", "1.02991606471173`", ",", 
          "5.76963574699648`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9202335859322`", ",", "0.778766804895091`", ",", 
          "0.899231517324676`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85903911172471`", ",", "0.430709490309546`", ",", 
          "2.31201259483246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51465933033763`", ",", "2.67797540394282`", ",", 
          "3.72479367234025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45346485613014`", ",", "2.34277068054394`", ",", 
          "5.13757474984803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39227038192265`", ",", "2.09515946738024`", ",", 
          "0.267170520176233`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04789060053558`", ",", "1.87944593599889`", ",", 
          "1.67995159768402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98669612632809`", ",", "1.67788374316041`", ",", 
          "3.0927326751918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9255016521206`", ",", "1.48066773667724`", ",", 
          "4.50551375269959`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.581121870733519`", ",", "1.27981118185119`", ",", 
          "5.91829483020738`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51992739652603`", ",", "1.06582131347471`", ",", 
          "1.04789060053558`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45873292231854`", ",", "0.822112624185253`", ",", 
          "2.46067167804336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.114353140931462`", ",", "0.50003761682385`", ",", 
          "3.87345275555115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05315866672397`", ",", "2.75327139952116`", ",", 
          "5.28623383305893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99196419251648`", ",", "2.38715459296243`", ",", 
          "0.415829603387133`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.93076971830899`", ",", "2.13148203372261`", ",", 
          "1.82861068089492`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58638993692191`", ",", "1.91227161602444`", ",", 
          "3.2413917584027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52519546271442`", ",", "1.70922610787103`", ",", 
          "4.65417283591049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46400098850693`", ",", "1.51186082521503`", ",", 
          "6.06695391341828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11962120711986`", ",", "1.31213062917813`", ",", 
          "1.19654968374648`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05842673291237`", ",", "1.10102730086627`", ",", 
          "2.60933076125426`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99723225870488`", ",", "0.863777826720148`", ",", 
          "4.02211183876205`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.6528524773178`", ",", "0.561496394766732`", ",", 
          "5.43489291626984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59165800311031`", ",", "2.8460740136815`", ",", 
          "0.564488686598034`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.53046352890282`", ",", "2.43374293416734`", ",", 
          "1.97726976410582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.186083747515742`", ",", "2.16865306793286`", ",", 
          "3.3900508416136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12488927330825`", ",", "1.94548497148961`", ",", 
          "4.80283191912139`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06369479910076`", ",", "1.74070599190455`", ",", 
          "6.21561299662918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00250032489327`", ",", "1.54299658472513`", ",", 
          "1.34520876695738`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65812054350619`", ",", "1.34417591269129`", ",", 
          "2.75798984446516`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5969260692987`", ",", "1.13561468951996`", ",", 
          "4.17077092197295`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53573159509121`", ",", "0.904009039247277`", ",", 
          "5.58355199948073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19135181370414`", ",", "0.617455835362598`", ",", 
          "0.713147769808934`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.13015733949665`", ",", "2.98494902436156`", ",", 
          "2.12592884731672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06896286528916`", ",", "2.48302068450233`", ",", 
          "3.53870992482451`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.72458308390208`", ",", "2.20679037141429`", ",", 
          "4.95149100233229`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66338860969459`", ",", "1.97913813797239`", ",", 
          "0.081086772660491`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6021941354871`", ",", "1.77235688990994`", ",", 
          "1.49386785016828`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.257814354100023`", ",", "1.57410539967708`", ",", 
          "2.90664892767606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19661987989253`", ",", "1.37598604352117`", ",", 
          "4.31943000518385`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13542540568504`", ",", "1.16965438361641`", ",", 
          "5.73221108269163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07423093147755`", ",", "0.943004121533929`", ",", 
          "0.861806853019834`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72985115009048`", ",", "0.669311801547732`", ",", 
          "2.27458793052762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66865667588298`", ",", "0.194531616434843`", ",", 
          "3.68736900803541`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60746220167549`", ",", "2.53566161861165`", ",", 
          "5.10015008554319`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26308242028842`", ",", "2.24603383918126`", ",", 
          "0.229745855871391`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20188794608093`", ",", "2.01328884487394`", ",", 
          "1.64252693337918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.14069347187344`", ",", "1.80421391075331`", ",", 
          "3.05530801088696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.796313690486361`", ",", "1.60521741864562`", ",", 
          "4.46808908839475`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73511921627887`", ",", "1.40759767553858`", ",", 
          "5.88087016590253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67392474207138`", ",", "1.20320934429622`", ",", 
          "1.01046593623073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.329544960684303`", ",", "0.980924954481197`", ",", 
          "2.42324701373852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26835048647681`", ",", "0.717968657073807`", ",", 
          "3.83602809124631`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20715601226932`", ",", "0.317454437248607`", ",", 
          "5.24880916875409`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14596153806183`", ",", "2.59265139002803`", ",", 
          "0.378404939082291`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80158175667476`", ",", "2.28655216143261`", ",", 
          "1.79118601659008`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.74038728246727`", ",", "2.04800161227081`", ",", 
          "3.20396709409786`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67919280825978`", ",", "1.83631417109616`", ",", 
          "4.61674817160565`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3348130268727`", ",", "1.63636281819884`", ",", 
          "6.02952924911344`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27361855266521`", ",", "1.43904554287373`", ",", 
          "1.15912501944163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21242407845772`", ",", "1.23633601931305`", ",", 
          "2.57190609694942`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.868044297070641`", ",", "1.0179062452393`", ",", 
          "3.98468717445721`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80684982286315`", ",", "0.764052250173041`", ",", 
          "5.39746825196499`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74565534865566`", ",", "0.40544273209498`", ",", 
          "0.527064022293192`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.401275567268584`", ",", "2.65553776799159`", ",", 
          "1.93984509980098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.34008109306109`", ",", "2.32855233147347`", ",", 
          "3.35262617730876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2788866188536`", ",", "2.08334925322767`", ",", 
          "4.76540725481655`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21769214464611`", ",", "1.86869724639953`", ",", 
          "6.17818833232434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87331236325904`", ",", "1.66757206746886`", ",", 
          "1.30778410265253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81211788905155`", ",", "1.47036284308806`", ",", 
          "2.72056518016032`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.75092341484406`", ",", "1.26908548547359`", ",", 
          "4.13334625766811`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40654363345698`", ",", "1.05406176978186`", ",", 
          "5.54612733517589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34534915924949`", ",", "0.8080172503385`", ",", 
          "0.675723105504092`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.284154685042`", ",", "0.478204463211725`", ",", 
          "2.08850418301188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.939774903654922`", ",", "2.72701838658742`", ",", 
          "3.50128526051966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87858042944743`", ",", "2.37229354960615`", ",", 
          "4.91406633802745`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81738595523994`", ",", "2.11941478763579`", ",", 
          "0.043662108355649`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.473006173852864`", ",", "1.90140569604922`", ",", 
          "1.45644318586343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41181169964537`", ",", "1.69887619988913`", ",", 
          "2.86922426337122`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.35061722543788`", ",", "1.50158157870873`", ",", 
          "4.28200534087901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.006237444050807`", ",", "1.3015043744219`", ",", 
          "5.69478641838679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94504296984332`", ",", "1.08948891140454`", ",", 
          "0.824382188714992`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88384849563583`", ",", "0.850206585021645`", ",", 
          "2.23716326622278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82265402142834`", ",", "0.541924952163643`", ",", 
          "3.64994434373056`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47827424004126`", ",", "2.81267686059083`", ",", 
          "5.06272542123835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41707976583377`", ",", "2.41810829888114`", ",", 
          "0.192321191566549`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35588529162628`", ",", "2.15629391926333`", ",", 
          "1.60510226907434`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0115055102392`", ",", "1.93448568396713`", ",", 
          "3.01788334658212`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.95031103603171`", ",", "1.73030709892963`", ",", 
          "4.43066442408991`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88911656182422`", ",", "1.532732867537`", ",", 
          "5.84344550159769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.544736780437145`", ",", "1.33363563319711`", ",", 
          "0.973041271925892`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48354230622965`", ",", "1.1242720335491`", ",", 
          "2.38582234943368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42234783202216`", ",", "0.890886763672284`", ",", 
          "3.79860342694146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0779680506350875`", ",", "0.599510023506125`", ",", 
          "5.21138450444925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0167735764276`", ",", "2.92905300083544`", ",", 
          "0.340980274777449`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95557910222011`", ",", "2.46643571065492`", ",", 
          "1.75376135228524`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89438462801262`", ",", "2.19409829770913`", ",", 
          "3.16654242979302`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.55000484662554`", ",", "1.96798772253622`", ",", 
          "4.57932350730081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48881037241805`", ",", "1.76189780535003`", ",", 
          "5.99210458480859`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42761589821056`", ",", "1.56384723049584`", ",", 
          "1.12170035513679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08323611682348`", ",", "1.36551915769069`", ",", 
          "2.53448143264458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02204164261599`", ",", "1.15848503557345`", ",", 
          "3.94726251015236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9608471684085`", ",", "0.930270063910079`", ",", 
          "5.36004358766015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.616467387021425`", ",", "0.652601112984274`", ",", 
          "0.48963935798835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55527291281393`", ",", "0.131270248638323`", ",", 
          "1.90242043549614`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49407843860644`", ",", "2.51787730580039`", ",", 
          "3.31520151300392`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.149698657219368`", ",", "2.23295989721999`", ",", 
          "4.72798259051171`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08850418301188`", ",", "2.00196757669248`", ",", 
          "6.14076366801949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02730970880439`", ",", "1.7936828545791`", ",", 
          "1.27035943834769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9661152345969`", ",", "1.59495486464249`", ",", 
          "2.68314051585548`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62173545320982`", ",", "1.39719232773605`", ",", 
          "4.09592159336326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.56054097900233`", ",", "1.19219332358065`", ",", 
          "5.50870267087105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49934650479484`", ",", "0.968529100055071`", ",", 
          "0.63829844119925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15496672340776`", ",", "0.702233035311155`", ",", 
          "2.05107951870704`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09377224920027`", ",", "0.282752255797546`", ",", 
          "3.46386059621482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03257777499278`", ",", "2.57329672698364`", ",", 
          "4.87664167372261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.688197993605706`", ",", "2.27303702327537`", ",", 
          "0.006237444050807`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62700351939822`", ",", "2.03648737780023`", ",", 
          "1.41901852155859`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56580904519073`", ",", "1.82569865440854`", ",", 
          "2.83179959906638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.221429263803649`", ",", "1.62608590823893`", ",", 
          "4.24458067657417`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.16023478959616`", ",", "1.42869046584724`", ",", 
          "5.65736175408195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09904031538867`", ",", "1.22545535469589`", ",", 
          "0.78695752441015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03784584118118`", ",", "1.00580674696917`", ",", 
          "2.19973860191794`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6934660597941`", ",", "0.749108157255476`", ",", 
          "3.61251967942572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63227158558661`", ",", "0.378592003642592`", ",", 
          "5.02530075693351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57107711137912`", ",", "2.63401515000669`", ",", 
          "0.154896527261707`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22669732999204`", ",", "2.31452275832767`", ",", 
          "1.56767760476949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16550285578455`", ",", "2.07161701524364`", ",", 
          "2.98045868227728`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10430838157706`", ",", "1.85798391540216`", ",", 
          "4.39323975978506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.759928600189986`", ",", "1.65727070438878`", ",", 
          "5.80602083729285`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.6987341259825`", ",", "1.46004723677424`", ",", 
          "0.93561660762105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63753965177501`", ",", "1.25832386527516`", ",", 
          "2.34839768512884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.293159870387929`", ",", "1.04222311177104`", ",", 
          "3.76117876263662`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23196539618044`", ",", "0.793729360098871`", ",", 
          "5.17395984014441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.17077092197295`", ",", "0.455410072539605`", ",", 
          "0.303555610472607`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10957644776546`", ",", "2.70224605991042`", ",", 
          "1.71633668798039`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76519666637838`", ",", "2.35765718304269`", ",", 
          "3.12911776548818`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70400219217089`", ",", "2.10743590041128`", ",", 
          "4.54189884299597`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6428077179634`", ",", "1.89058014947547`", ",", 
          "5.95467992050375`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29842793657632`", ",", "1.68854006967984`", ",", 
          "1.08427569083195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23723346236883`", ",", "1.49129500152085`", ",", 
          "2.49705676833974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17603898816134`", ",", "1.29084686166134`", ",", 
          "3.90983784584752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.831659206774267`", ",", "1.07788056255269`", ",", 
          "5.32261892335531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.77046473256678`", ",", "0.836471638550959`", ",", 
          "0.452214693683508`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70927025835929`", ",", "0.521695418799823`", ",", 
          "1.86499577119129`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.36489047697221`", ",", "2.78226940073473`", ",", 
          "3.27777684869908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30369600276472`", ",", "2.40274567007784`", ",", 
          "4.69055792620687`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24250152855723`", ",", "2.14403523757016`", ",", 
          "6.10333900371465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18130705434974`", ",", "1.9235322563019`", ",", 
          "1.23293477404285`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83692727296266`", ",", "1.71992557451314`", ",", 
          "2.64571585155064`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77573279875517`", ",", "1.52246513691314`", ",", 
          "4.05849692905842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71453832454768`", ",", "1.32306843046112`", ",", 
          "5.47127800656621`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3701585431606`", ",", "1.11286743969649`", ",", 
          "0.600873776894408`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30896406895311`", ",", "0.877623755807344`", ",", 
          "2.01365485440219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24776959474562`", ",", "0.581080021448739`", ",", 
          "3.42643593190998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.903389813358547`", ",", "2.88492084772082`", ",", 
          "4.83921700941777`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84219533915106`", ",", "2.45018740542387`", ",", 
          "6.25199808692555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.78100086494357`", ",", "2.18152099674612`", ",", 
          "1.38159385725375`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.43662108355649`", ",", "1.95688922300293`", ",", 
          "2.79437493476154`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.375426609349`", ",", "1.75145984237066`", ",", 
          "4.20715601226932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31423213514151`", ",", "1.55358832996498`", ",", 
          "5.61993708977711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25303766093402`", ",", "1.35502941034714`", ",", 
          "0.749532860105308`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90865787954694`", ",", "1.14726085083082`", ",", 
          "2.16231393761309`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84746340533945`", ",", "0.917413968986811`", ",", 
          "3.57509501512088`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78626893113196`", ",", "0.635516763920392`", ",", 
          "4.98787609262867`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44188914974489`", ",", "3.08406023021324`", ",", 
          "0.117471862956865`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.38069467553739`", ",", "2.50052213471768`", ",", 
          "1.53025294046465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3195002013299`", ",", "2.22001787835744`", ",", 
          "2.94303401797244`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.975120419942828`", ",", "1.99070497065387`", ",", 
          "4.35581509548022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91392594573534`", ",", "1.78317687622235`", ",", 
          "5.76859617298801`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85273147152785`", ",", "1.5846948549928`", ",", 
          "0.898191943316208`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.508351690140771`", ",", "1.38676795687035`", ",", 
          "2.31097302082399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44715721593328`", ",", "1.1811288140999`", ",", 
          "3.72375409833178`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38596274172579`", ",", "0.956026692041992`", ",", 
          "5.13653517583957`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0415829603387133`", ",", "0.686199138496641`", ",", 
          "0.266130946167765`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.98038848613122`", ",", "0.243295697808737`", ",", 
          "1.67891202367555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91919401192373`", ",", "2.55451176760116`", ",", 
          "3.09169310118334`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85799953771624`", ",", "2.25967471134566`", ",", 
          "4.50447417869112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51361975632917`", ",", "2.02503939250422`", ",", 
          "5.91725525619891`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45242528212168`", ",", "1.81511242167759`", ",", 
          "1.04685102652711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39123080791419`", ",", "1.61581484057383`", ",", 
          "2.45963210403489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04685102652711`", ",", "1.41832002427488`", ",", 
          "3.87241318154268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98565655231962`", ",", "1.21453192895527`", ",", 
          "5.28519425905047`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92446207811213`", ",", "0.993613717927623`", ",", 
          "0.414790029378666`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.580082296725051`", ",", "0.733919933039854`", ",", 
          "1.82757110688645`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51888782251756`", ",", "0.349791820543833`", ",", 
          "3.24035218439424`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45769334831007`", ",", "2.61329506605198`", ",", 
          "4.65313326190202`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.113313566922994`", ",", "2.30067197878568`", ",", 
          "6.06591433940981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0521190927155`", ",", "2.05995964504249`", ",", 
          "1.19551010973801`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.99092461850801`", ",", "1.84730437847117`", ",", 
          "2.60829118724579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92973014430052`", ",", "1.64697853294704`", ",", 
          "4.02107226475358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58535036291345`", ",", "1.44971978291328`", ",", 
          "5.43385334226137`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52415588870596`", ",", "1.24752469860307`", ",", 
          "0.563449112589566`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46296141449847`", ",", "1.03030202693149`", ",", 
          "1.97623019009735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11858163311139`", ",", "0.779237799650229`", ",", 
          "3.38901126760514`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0573871589039`", ",", "0.431501369267356`", ",", 
          "4.80179234511292`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99619268469641`", ",", "2.67871592719778`", ",", 
          "6.21457342262071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.651812903309332`", ",", "2.34323259961487`", ",", 
          "1.34416919294891`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.59061842910184`", ",", "2.09554177659192`", ",", 
          "2.75695027045669`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52942395489435`", ",", "1.87979327462231`", ",", 
          "4.16973134796448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.185044173507274`", ",", "1.67821656228487`", ",", 
          "5.58251242547227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12384969929978`", ",", "1.48099998694799`", ",", 
          "0.712108195800466`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06265522509229`", ",", "1.28015659187567`", ",", 
          "2.12488927330825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.0014607508848`", ",", "1.06619937243132`", ",", 
          "3.53767035081604`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65708096949773`", ",", "0.822564226485958`", ",", 
          "4.95045142832382`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59588649529024`", ",", "0.500727348956864`", ",", 
          "0.0800471986520232`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53469202108275`", ",", "2.75414628106279`", ",", 
          "1.49282827615981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.19031223969567`", ",", "2.38763787780329`", ",", 
          "2.90560935366759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12911776548818`", ",", "2.1318728129644`", ",", 
          "4.31839043117538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06792329128069`", ",", "1.9126228213865`", ",", 
          "5.73117150868317`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.723543509893612`", ",", "1.70956021840184`", ",", 
          "0.860767279011366`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66234903568612`", ",", "1.51219230418122`", ",", 
          "2.27354835651915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60115456147863`", ",", "1.31247290776101`", ",", 
          "3.68632943402694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.256774780091555`", ",", "1.10139837364122`", ",", 
          "5.09911051153472`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19558030588406`", ",", "0.864212976462014`", ",", 
          "0.228706281862923`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13438583167657`", ",", "0.562117563460626`", ",", 
          "1.64148735937071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07319135746908`", ",", "2.84721235691186`", ",", 
          "3.0542684368785`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72881157608201`", ",", "2.4342520149859`", ",", 
          "4.46704951438628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66761710187452`", ",", "2.16905347233569`", ",", 
          "5.87983059189407`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60642262766703`", ",", "1.94584057233168`", ",", 
          "1.00942636222227`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26204284627995`", ",", "1.74104174292519`", ",", 
          "2.42220743973005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.20084837207246`", ",", "1.54332761779969`", ",", 
          "3.83498851723784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13965389786497`", ",", "1.34451548895004`", ",", 
          "5.24776959474562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.795274116477893`", ",", "1.13597957814415`", ",", 
          "0.377365365073824`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7340796422704`", ",", "0.904430070736395`", ",", 
          "1.79014644258161`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67288516806291`", ",", "0.618027156566377`", ",", 
          "3.2029275200894`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.328505386675835`", ",", "2.98708460918028`", ",", 
          "4.61570859759718`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26731091246834`", ",", "2.48356158128689`", ",", 
          "6.02848967510497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20611643826086`", ",", "2.20720176296724`", ",", 
          "1.15808544543317`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14492196405336`", ",", "1.97949871710258`", ",", 
          "2.57086652294095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.80054218266629`", ",", "1.77269464576943`", ",", 
          "3.98364760044874`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7393477084588`", ",", "1.57443630836033`", ",", 
          "5.39642867795652`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67815323425131`", ",", "1.37632331896453`", ",", 
          "0.526024448284724`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33377345286423`", ",", "1.1700137968563`", ",", 
          "1.93880552579251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27257897865674`", ",", "0.943412927764534`", ",", 
          "3.3515866033003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21138450444925`", ",", "0.669844958365321`", ",", 
          "4.76436768080808`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.867004723062173`", ",", "0.196236064070541`", ",", 
          "6.17714875831587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80581024885468`", ",", "2.53624288202556`", ",", 
          "1.30674452864407`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74461577464719`", ",", "2.24645784696573`", ",", 
          "2.71952560615185`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.400235993260116`", ",", "2.01365505057698`", ",", 
          "4.13230668365964`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33904151905263`", ",", "1.80455405499992`", ",", 
          "5.54508776116742`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27784704484514`", ",", "1.60554852335138`", ",", 
          "0.674683531495624`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21665257063764`", ",", "1.40793302905908`", ",", 
          "2.08746460900341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87227278925057`", ",", "1.20356391468745`", ",", 
          "3.5002456865112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81107831504308`", ",", "0.981323098564419`", ",", 
          "4.91302676401898`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74988384083559`", ",", "0.718471520018055`", ",", 
          "0.0426225343471812`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40550405944851`", ",", "0.318512824182078`", ",", 
          "1.45540361185497`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34430958524102`", ",", "2.59328590204697`", ",", 
          "2.86818468936275`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28311511103353`", ",", "2.28699076587701`", ",", 
          "4.28096576687054`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.938735329646454`", ",", "2.04837417252558`", ",", 
          "5.69374684437832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87754085543896`", ",", "1.83665711094686`", ",", 
          "0.823342614706524`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81634638123147`", ",", "1.6366944410541`", ",", 
          "2.23612369221431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.471966599844396`", ",", "1.43937933508506`", ",", 
          "3.6489047697221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.41077212563691`", ",", "1.23668631667963`", ",", 
          "5.06168584722988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34957765142942`", ",", "1.01829503839546`", ",", 
          "0.191281617558081`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00519787004233917`", ",", "0.764530421333479`", ",", 
          "1.60406269506587`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94400339583485`", ",", "0.406280872234928`", ",", 
          "3.01684377257365`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88280892162736`", ",", "2.65624660880994`", ",", 
          "4.42962485008144`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.82161444741987`", ",", "2.32900798552335`", ",", 
          "5.84240592758922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47723466603279`", ",", "2.08372899367954`", ",", 
          "0.972001697917424`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4160401918253`", ",", "1.86904341790317`", ",", 
          "2.38478277542521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35484571761781`", ",", "1.66790453515514`", ",", 
          "3.797563852933`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.01046593623073`", ",", "1.47069542015727`", ",", 
          "5.21034493044078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94927146202324`", ",", "1.26943202781127`", ",", 
          "0.339940700768982`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88807698781575`", ",", "1.05444232741366`", ",", 
          "1.75272177827677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.543697206428677`", ",", "0.808474887369696`", ",", 
          "3.16550285578455`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48250273222119`", ",", "0.4789230371005`", ",", 
          "4.57828393329234`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4213082580137`", ",", "2.7278406703816`", ",", 
          "5.99106501080013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0769284766266197`", ",", "2.37276935875705`", ",", 
          "1.12066078112832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01573400241913`", ",", "2.11980265466372`", ",", 
          "2.53344185863611`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95453952821164`", ",", "1.90175557014335`", ",", 
          "3.9462229361439`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89334505400415`", ",", "1.699209846596`", ",", 
          "5.35900401365168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54896527261707`", ",", "1.50191327580495`", ",", 
          "0.488599783979882`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48777079840958`", ",", "1.30184763678104`", ",", 
          "1.90138086148767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42657632420209`", ",", "1.08986219436057`", ",", 
          "3.31416193899545`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08219654281501`", ",", "0.8506468769727`", ",", 
          "4.72694301650324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.02100206860752`", ",", "0.542566168730724`", ",", 
          "6.13972409401103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95980759440003`", ",", "2.81370282732611`", ",", 
          "1.26931986433922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.615427813012958`", ",", "2.41860829929702`", ",", 
          "2.68210094184701`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55423333880547`", ",", "2.15669101007772`", ",", 
          "4.0948820193548`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49303886459798`", ",", "1.93483977368688`", ",", 
          "5.50766309686258`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.1486590832109`", ",", "1.73064226949595`", ",", 
          "0.637258867190782`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08746460900341`", ",", "1.53306401199745`", ",", 
          "2.05003994469857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02627013479592`", ",", "1.33397605503241`", ",", 
          "3.46282102220635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96507566058843`", ",", "1.12463887911764`", ",", 
          "4.87560209971414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.62069587920135`", ",", "0.891312223039794`", ",", 
          "0.00519787004233917`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55950140499386`", ",", "0.600096238608641`", ",", 
          "1.41797894755013`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49830693078637`", ",", "2.9306274462499`", ",", 
          "2.83076002505791`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1539271493993`", ",", "2.46696531972625`", ",", 
          "4.2435411025657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0927326751918`", ",", "2.19450590034064`", ",", 
          "5.65632218007348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03153820098432`", ",", "1.96834659171427`", ",", 
          "0.785917950401682`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.687158419597238`", ",", "1.7622348586781`", ",", 
          "2.19869902790947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62596394538975`", ",", "1.56417814479561`", ",", 
          "3.61148010541725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56476947118226`", ",", "1.3658571490271`", ",", 
          "5.02426118292504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.220389689795181`", ",", "1.15884618119267`", ",", 
          "0.153856953253239`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15919521558769`", ",", "0.930682714823098`", ",", 
          "1.56663803076103`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0980007413802`", ",", "0.653145840967612`", ",", 
          "2.97941910826881`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03680626717271`", ",", "0.133774559780626`", ",", 
          "4.3922001857766`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69242648578563`", ",", "2.51844409675843`", ",", 
          "5.80498126328438`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63123201157814`", ",", "2.23337954473588`", ",", 
          "0.934577033612582`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.57003753737065`", ",", "2.00233185060293`", ",", 
          "2.34735811112037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22565775598358`", ",", "1.79402216742073`", ",", 
          "3.76013918862815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16446328177609`", ",", "1.59528586924441`", ",", 
          "5.17292026613594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1032688075686`", ",", "1.39752827441661`", ",", 
          "0.30251603646414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.758889026181519`", ",", "1.19254942528073`", ",", 
          "1.71529711397193`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69769455197403`", ",", "0.968930604450173`", ",", 
          "3.12807819147971`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63650007776654`", ",", "0.70274518005572`", ",", 
          "4.5408592689875`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.292120296379461`", ",", "0.283935891898085`", ",", 
          "5.95364034649528`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.23092582217197`", ",", "2.57391186680866`", ",", 
          "1.08323611682348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16973134796448`", ",", "2.27347056899085`", ",", 
          "2.49601719433127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10853687375699`", ",", "2.03685775636059`", ",", 
          "3.90879827183905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76415709236991`", ",", "1.82604062564206`", ",", 
          "5.32157934934684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70296261816242`", ",", "1.62641732439443`", ",", 
          "0.45117511967504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64176814395493`", ",", "1.42902473406821`", ",", 
          "1.86395619718283`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29738836256786`", ",", "1.22580700166538`", ",", 
          "3.27673727469061`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23619388836037`", ",", "1.00619849204379`", ",", 
          "4.6895183521984`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17499941415288`", ",", "0.74959395331802`", ",", 
          "6.10229942970618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.830619632765799`", ",", "0.379486278429677`", ",", 
          "1.23189520003438`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76942515855831`", ",", "2.63469635889665`", ",", 
          "2.64467627754217`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70823068435082`", ",", "2.3149724829344`", ",", 
          "4.05745735504995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.363850902963742`", ",", "2.07199428962331`", ",", 
          "5.47023843255774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30265642875625`", ",", "1.85832897094711`", ",", 
          "0.59983420288594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24146195454876`", ",", "1.65760285695793`", ",", 
          "2.01261528039373`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.18026748034127`", ",", "1.46038017706932`", ",", 
          "3.42539635790151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83588769895419`", ",", "1.25867159153332`", ",", 
          "4.8381774354093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7746932247467`", ",", "1.04260627233224`", ",", 
          "6.25095851291708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71349875053921`", ",", "0.794193376418367`", ",", 
          "1.38055428324528`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36911896915214`", ",", "0.456161845864582`", ",", 
          "2.79333536075307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30792449494465`", ",", "2.70302467151779`", ",", 
          "4.20611643826086`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24673002073716`", ",", "2.35812595197961`", ",", 
          "5.61889751576864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.90235023935008`", ",", "2.10782097423891`", ",", 
          "0.74849328609684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84115576514259`", ",", "1.89092874802936`", ",", 
          "2.16127436360463`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7799612909351`", ",", "1.68887329003984`", ",", 
          "3.57405544111241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.435581509548022`", ",", "1.49162695232426`", ",", 
          "4.9868365186202`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37438703534053`", ",", "1.29119115554214`", ",", 
          "0.116432288948397`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31319256113304`", ",", "1.07825614656349`", ",", 
          "1.52921336645618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25199808692555`", ",", "0.836917344490301`", ",", 
          "2.94199444396397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90761830553847`", ",", "0.522359039373488`", ",", 
          "4.35477552147176`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84642383133098`", ",", "2.78321161871373`", ",", 
          "5.76755659897954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78522935712349`", ",", "2.40323717333994`", ",", 
          "0.89715236930774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.44084957573642`", ",", "2.14442915445071`", ",", 
          "2.30993344681553`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37965510152893`", ",", "1.92388489613619`", ",", 
          "3.72271452432331`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31846062732144`", ",", "1.72026020362877`", ",", 
          "5.1354956018311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.97408084593436`", ",", "1.52279642780881`", ",", 
          "0.265091372159298`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91288637172687`", ",", "1.32340974242496`", ",", 
          "1.67787244966708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85169189751938`", ",", "1.11323632226535`", ",", 
          "3.09065352717487`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.507312116132303`", ",", "0.878053862200632`", ",", 
          "4.50343460468266`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44611764192481`", ",", "0.581682569616727`", ",", 
          "5.91621568219044`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38492316771732`", ",", "2.88622758739438`", ",", 
          "1.04581145251864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0405433863302455`", ",", "2.45070653958643`", ",", 
          "2.45859253002643`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97934891212276`", ",", "2.18192497659543`", ",", 
          "3.87137360753421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91815443791526`", ",", "1.95724645012765`", ",", 
          "5.284154685042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85695996370778`", ",", "1.7517962341083`", ",", 
          "0.413750455370198`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5125801823207`", ",", "1.55391928471213`", ",", 
          "1.82653153287798`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45138570811321`", ",", "1.35536815950428`", ",", 
          "3.23931261038577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.39019123390572`", ",", "1.14762380006232`", ",", 
          "4.65209368789356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04581145251864`", ",", "0.917830644641027`", ",", 
          "6.06487476540134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98461697831115`", ",", "0.636074016935344`", ",", 
          "1.19447053572954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92342250410366`", ",", "3.09013550951191`", ",", 
          "2.60725161323733`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.579042722716583`", ",", "2.50107564595291`", ",", 
          "4.02003269074511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51784824850909`", ",", "2.22043336632349`", ",", 
          "5.4328137682529`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4566537743016`", ",", "1.99106738876156`", ",", 
          "0.562409538581098`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.112273992914526`", ",", "1.78351540100134`", ",", 
          "1.97519061608888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05107951870704`", ",", "1.58502579440734`", ",", 
          "3.38797169359667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98988504449954`", ",", "1.38710453650627`", ",", 
          "4.80075277110446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92869057029206`", ",", "1.18148651109519`", ",", 
          "6.21353384861224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58431078890498`", ",", "0.95643170712476`", ",", 
          "1.34312961894044`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52311631469749`", ",", "0.686721235455012`", ",", 
          "2.75591069644823`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46192184049`", ",", "0.244665530448778`", ",", 
          "4.16869177395601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11754205910292`", ",", "2.55510941273858`", ",", 
          "5.5814728514638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05634758489543`", ",", "2.26010344513989`", ",", 
          "0.711068621791998`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99515311068794`", ",", "2.0254076752479`", ",", 
          "2.12384969929978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.650773329300864`", ",", "1.8154534705707`", ",", 
          "3.53663077680757`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58957885509337`", ",", "1.61614608533781`", ",", 
          "4.94941185431536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52838438088588`", ",", "1.41865480660073`", ",", 
          "0.0790076246435554`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.184004599498807`", ",", "1.21488498353132`", ",", 
          "1.49178870215134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12281012529132`", ",", "0.994008542329675`", ",", 
          "2.90456977965913`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06161565108383`", ",", "0.734413846547699`", ",", 
          "4.31735085716691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.00042117687634`", ",", "0.350756126891573`", ",", 
          "5.7301319346747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65604139548926`", ",", "2.61395191356015`", ",", 
          "0.859727705002898`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59484692128177`", ",", "2.30111608371431`", ",", 
          "2.27250878251068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53365244707428`", ",", "2.06033455140854`", ",", 
          "3.68528986001847`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1892726656872`", ",", "1.84764836789063`", ",", 
          "5.09807093752626`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12807819147971`", ",", "1.6473104064148`", ",", 
          "0.227666707854456`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06688371727222`", ",", "1.45005312321604`", ",", 
          "1.64044778536224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.722503935885144`", ",", "1.24787366183004`", ",", 
          "3.05322886287003`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66130946167765`", ",", "1.03068789977669`", ",", 
          "4.46600994037781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.60011498747016`", ",", "0.779708569926142`", ",", 
          "5.8787910178856`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.255735206083087`", ",", "0.432291888661421`", ",", 
          "1.0083867882138`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.1945407318756`", ",", "2.67945755095356`", ",", 
          "2.42116786572158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13334625766811`", ",", "2.34369472668783`", ",", 
          "3.83394894322937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07215178346062`", ",", "2.09592417043166`", ",", 
          "5.24673002073716`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72777200207354`", ",", "1.88014065176225`", ",", 
          "0.376325791065356`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66657752786605`", ",", "1.67854939335451`", ",", 
          "1.78910686857314`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60538305365856`", ",", "1.48133222727966`", ",", 
          "3.20188794608093`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.26100327227148`", ",", "1.28050196621764`", ",", 
          "4.61466902358871`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19980879806399`", ",", "1.06657735246688`", ",", 
          "6.0274501010965`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1386143238565`", ",", "0.823015639544224`", ",", 
          "1.1570458714247`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.794234542469425`", ",", "0.501416212868042`", ",", 
          "2.56982694893248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73304006826193`", ",", "2.75502304232786`", ",", 
          "3.98260802644027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67184559405444`", ",", "2.38812141150662`", ",", 
          "5.39538910394806`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.327465812667368`", ",", "2.13226368819941`", ",", 
          "0.524984874276256`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26627133845988`", ",", "1.91297407063944`", ",", 
          "1.93776595178404`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20507686425239`", ",", "1.70989434452377`", ",", 
          "3.35054702929183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1438823900449`", ",", "1.51252377670084`", ",", 
          "4.76332810679961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79950260865782`", ",", "1.31281515539126`", ",", 
          "6.1761091843074`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73830813445033`", ",", "1.1017693765892`", ",", 
          "1.3057049546356`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67711366024284`", ",", "0.864647964629206`", ",", 
          "2.71848603214338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33273387885576`", ",", "0.562738120202449`", ",", 
          "4.13126710965117`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.27153940464827`", ",", "2.84835499026168`", ",", 
          "5.54404818715896`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.21034493044078`", ",", "2.4347613991302`", ",", 
          "0.673643957487156`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.865965149053705`", ",", "2.16945398604199`", ",", 
          "2.08642503499494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80477067484621`", ",", "1.94619622296205`", ",", 
          "3.49920611250273`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74357620063872`", ",", "1.74137751332609`", ",", 
          "4.91198719001051`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.399196419251648`", ",", "1.54365864786341`", ",", 
          "0.0415829603387133`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33800194504416`", ",", "1.3448550386633`", ",", 
          "1.4543640378465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27680747083667`", ",", "1.13634440493838`", ",", 
          "2.86714511535429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21561299662918`", ",", "0.904850962876151`", ",", 
          "4.27992619286207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8712332152421`", ",", "0.618598019013678`", ",", 
          "5.69270727036986`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.81003874103461`", ",", "2.98924988645835`", ",", 
          "0.822303040698056`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74884426682712`", ",", "2.48410285684431`", ",", 
          "2.23508411820584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40446448544004`", ",", "2.207613279624`", ",", 
          "3.64786519571363`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34327001123255`", ",", "1.97985935255068`", ",", 
          "5.06064627322141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28207553702506`", ",", "1.77303242498105`", ",", 
          "0.190242043549614`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.937695755637986`", ",", "1.57476721744215`", ",", 
          "1.6030231210574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.8765012814305`", ",", "1.37666057200398`", ",", 
          "3.01580419856519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81530680722301`", ",", "1.17037315536979`", ",", 
          "4.42858527607297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.470927025835929`", ",", "0.943821612848023`", ",", 
          "5.84136635358076`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40973255162844`", ",", "0.670377756515737`", ",", 
          "0.970962123908957`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34853807742095`", ",", "0.197926021597361`", ",", 
          "2.38374320141674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00415829603387133`", ",", "2.53682463408377`", ",", 
          "3.79652427892453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94296382182638`", ",", "2.2468819988969`", ",", 
          "5.20930535643231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88176934761889`", ",", "2.01402131989482`", ",", 
          "0.338901126760514`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8205748734114`", ",", "1.8048942267977`", ",", 
          "1.7516822042683`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47619509202432`", ",", "1.60587963186862`", ",", 
          "3.16446328177609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41500061781683`", ",", "1.408268364101`", ",", 
          "4.57724435928387`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35380614360934`", ",", "1.20391843672292`", ",", 
          "5.99002543679166`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00942636222227`", ",", "0.981721136659651`", ",", 
          "1.11962120711986`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94823188801478`", ",", "0.718974093923732`", ",", 
          "2.53240228462764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88703741380729`", ",", "0.319567824792814`", ",", 
          "3.94518336213543`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.542657632420209`", ",", "2.5939210739203`", ",", 
          "5.35796443964321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48146315821272`", ",", "2.28742953781937`", ",", 
          "0.487560209971414`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.42026868400523`", ",", "2.04874680462881`", ",", 
          "1.9003412874792`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0758889026181519`", ",", "1.83700008282596`", ",", 
          "3.31312236498699`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01469442841066`", ",", "1.63702607116708`", ",", 
          "4.72590344249477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95349995420317`", ",", "1.43971311257005`", ",", 
          "6.13868452000256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89230547999568`", ",", "1.23703657145647`", ",", 
          "1.26828029033076`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5479256986086`", ",", "1.01868373837587`", ",", 
          "2.68106136783854`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48673122440111`", ",", "0.765008354217456`", ",", 
          "4.09384244534633`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42553675019362`", ",", "0.407117382697001`", ",", 
          "5.50662352285411`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08115696880655`", ",", "2.65695640356898`", ",", 
          "0.636219293182314`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01996249459906`", ",", "2.32946383628596`", ",", 
          "2.0490003706901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95876802039157`", ",", "2.08410881536602`", ",", 
          "3.46178144819789`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.61438823900449`", ",", "1.86938962624991`", ",", 
          "4.87456252570567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.553193764797`", ",", "1.66823701360947`", ",", 
          "0.00415829603387133`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49199929058951`", ",", "1.47102798611782`", ",", 
          "1.41693937354166`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.147619509202432`", ",", "1.26977853282469`", ",", 
          "2.82972045104944`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08642503499494`", ",", "1.05482280284213`", ",", 
          "4.24250152855723`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02523056078745`", ",", "0.808932324506159`", ",", 
          "5.65528260606502`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96403608657996`", ",", "0.479640617936502`", ",", 
          "0.784878376393214`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61965630519288`", ",", "2.72866449692627`", ",", 
          "2.197659453901`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55846183098539`", ",", "2.37324540204963`", ",", 
          "3.61044053140879`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4972673567779`", ",", "2.120190613744`", ",", 
          "5.02322160891657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15288757539083`", ",", "1.90210548630289`", ",", 
          "0.152817379244772`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09169310118334`", ",", "1.69954350767759`", ",", 
          "1.56559845675256`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.03049862697585`", ",", "1.50224496531062`", ",", 
          "2.97837953426034`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.68611884558877`", ",", "1.30219086666644`", ",", 
          "4.39116061176813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62492437138128`", ",", "1.09023540462324`", ",", 
          "5.80394168927591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56372989717379`", ",", "0.851086998912382`", ",", 
          "0.933537459604115`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.219350115786713`", ",", "0.543206704079777`", ",", 
          "2.3463185371119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15815564157922`", ",", "2.81473189780663`", ",", 
          "3.75909961461969`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09696116737173`", ",", "2.41910858320458`", ",", 
          "5.17188069212747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03576669316424`", ",", "2.157088205561`", ",", 
          "0.301476462455672`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.69138691177717`", ",", "1.93519391118596`", ",", 
          "1.71425753996346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.63019243756967`", ",", "1.73097745817476`", ",", 
          "3.12703861747124`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56899796336219`", ",", "1.5333951523184`", ",", 
          "4.53981969497903`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22461818197511`", ",", "1.33431644890078`", ",", 
          "5.95260077248682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16342370776762`", ",", "1.12500566032662`", ",", 
          "1.08219654281501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10222923356013`", ",", "0.89173753623153`", ",", 
          "2.4949776203228`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.757849452173051`", ",", "0.600681951935383`", ",", 
          "3.90775869783059`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69665497796556`", ",", "2.93221355306652`", ",", 
          "5.32053977533837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63546050375807`", ",", "2.46749527971894`", ",", 
          "0.450135545666572`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.291080722370993`", ",", "2.19491362254891`", ",", 
          "1.86291662317436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2298862481635`", ",", "1.96870551497928`", ",", 
          "3.27569770068214`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16869177395601`", ",", "1.76257193402562`", ",", 
          "4.68847877818993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10749729974852`", ",", "1.56450905837064`", ",", 
          "6.10125985569772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76311751836145`", ",", "1.36619511661994`", ",", 
          "1.23085562602592`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70192304415396`", ",", "1.15920726983095`", ",", 
          "2.6436367035337`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.64072856994646`", ",", "0.931095238963488`", ",", 
          "4.05641778104149`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29634878855939`", ",", "0.653690181437513`", ",", 
          "5.46919885854927`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2351543143519`", ",", "0.136233112845982`", ",", 
          "0.598794628877472`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17395984014441`", ",", "2.51901133507667`", ",", 
          "2.01157570638526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.829580058757331`", ",", "2.23379932970238`", ",", 
          "3.42435678389304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76838558454984`", ",", "2.00269618562736`", ",", 
          "4.83713786140083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70719111034235`", ",", "1.79436150640064`", ",", 
          "6.24991893890862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.362811328955274`", ",", "1.59561687653005`", ",", 
          "1.37951470923682`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30161685474778`", ",", "1.39786420134519`", ",", 
          "2.7922957867446`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.24042238054029`", ",", "1.19290547659663`", ",", 
          "4.20507686425239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1792279063328`", ",", "0.969331998146883`", ",", 
          "5.61785794176017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83484812494573`", ",", "0.703257015312345`", ",", 
          "0.747453712088372`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77365365073824`", ",", "0.2851147464737`", ",", 
          "2.16023478959616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71245917653075`", ",", "2.57452760058349`", ",", 
          "3.57301586710394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36807939514367`", ",", "2.27390427394414`", ",", 
          "4.98579694461173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30688492093618`", ",", "2.03722820393837`", ",", 
          "0.11539271493993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24569044672869`", ",", "1.82638262739326`", ",", 
          "1.52817379244772`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.901310665341612`", ",", "1.62674874666557`", ",", 
          "2.9409548699555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.84011619113412`", ",", "1.42935898634207`", ",", 
          "4.35373594746329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77892171692663`", ",", "1.22615860420354`", ",", 
          "5.76651702497107`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.434541935539554`", ",", "1.0065901399424`", ",", 
          "0.896112795299273`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37334746133206`", ",", "0.750079495980195`", ",", 
          "2.30889387280706`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31215298712457`", ",", "0.380378552449268`", ",", 
          "3.72167495031484`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.25095851291708`", ",", "2.63537840449383`", ",", 
          "5.13445602782263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90657873153001`", ",", "2.31542239384746`", ",", 
          "0.26405179815083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84538425732252`", ",", "2.07237164199913`", ",", 
          "1.67683287565862`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78418978311503`", ",", "1.85867406170598`", ",", 
          "3.0896139531664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43981000172795`", ",", "1.65793501912844`", ",", 
          "4.50239503067419`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37861552752046`", ",", "1.46071310507531`", ",", 
          "5.91517610818197`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31742105331297`", ",", "1.25901927878046`", ",", 
          "1.04477187851017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.973041271925892`", ",", "1.04298934724948`", ",", 
          "2.45755295601796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.9118467977184`", ",", "0.794657181277578`", ",", 
          "3.87033403352574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.85065232351091`", ",", "0.456912469148363`", ",", 
          "5.28311511103353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.506272542123835`", ",", "2.70380457780161`", ",", 
          "0.41271088136173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44507806791634`", ",", "2.35859494161524`", ",", 
          "1.82549195886952`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38388359370885`", ",", "2.10820613637268`", ",", 
          "3.2382730363773`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0395038123217777`", ",", "1.89127738687652`", ",", 
          "4.65105411388509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97830933811429`", ",", "1.6892065235724`", ",", 
          "6.06383519139287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9171148639068`", ",", "1.49195889438585`", ",", 
          "1.19343096172107`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85592038969931`", ",", "1.29153541539078`", ",", 
          "2.60621203922886`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51154060831223`", ",", "1.07863165488714`", ",", 
          "4.01899311673665`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.45034613410474`", ",", "0.837362871330305`", ",", 
          "5.43177419424443`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38915165989725`", ",", "0.523021895856928`", ",", 
          "0.56136996457263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04477187851017`", ",", "2.78415621288649`", ",", 
          "1.97415104208042`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98357740430268`", ",", "2.4037289421902`", ",", 
          "3.3869321195882`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92238293009519`", ",", "2.14482317161336`", ",", 
          "4.79971319709599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.578003148708116`", ",", "1.92423758180526`", ",", 
          "6.21249427460377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51680867450062`", ",", "1.72059484960747`", ",", 
          "1.34209004493197`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45561420029314`", ",", "1.52312771343236`", ",", 
          "2.75487112243976`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.111234418906058`", ",", "1.32375102496965`", ",", 
          "4.16765219994755`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.05003994469857`", ",", "1.11360513784152`", ",", 
          "5.58043327745533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98884547049108`", ",", "0.878483815113659`", ",", 
          "0.71002904778353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92765099628359`", ",", "0.582284566164564`", ",", 
          "2.12281012529132`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58327121489651`", ",", "2.88754090084734`", ",", 
          "3.5355912027991`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52207674068902`", ",", "2.45122599989909`", ",", 
          "4.94837228030689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.46088226648153`", ",", "2.18232907081487`", ",", 
          "0.0779680506350875`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11650248509445`", ",", "1.95760372918636`", ",", 
          "1.49074912814287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05530801088696`", ",", "1.7521326465557`", ",", 
          "2.90353020565066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99411353667947`", ",", "1.55425023761055`", ",", 
          "4.31631128315845`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.649733755292396`", ",", "1.35570688355303`", ",", 
          "5.72909236066623`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58853928108491`", ",", "1.14798668997357`", ",", 
          "0.858688130994431`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52734480687742`", ",", "0.918247187537613`", ",", 
          "2.27146920850222`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.182965025490339`", ",", "0.636630849755276`", ",", 
          "3.68425028601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12177055128285`", ",", "3.09703068897219`", ",", 
          "5.09703136351779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.06057607707536`", ",", "2.50162956854312`", ",", 
          "0.226627133845988`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99938160286787`", ",", "2.22084898546639`", ",", 
          "1.63940821135377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65500182148079`", ",", "1.99142986557739`", ",", 
          "3.05218928886156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5938073472733`", ",", "1.78385395053401`", ",", 
          "4.46497036636935`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53261287306581`", ",", "1.58535673538042`", ",", 
          "5.87775144387713`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18823309167873`", ",", "1.38744109509657`", ",", 
          "1.00734721420533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12703861747124`", ",", "1.18184415560807`", ",", 
          "2.42012829171312`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06584414326375`", ",", "0.956836606522898`", ",", 
          "3.8329093692209`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.721464361876676`", ",", "0.687243000138489`", ",", 
          "5.24569044672869`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.66026988766919`", ",", "0.246027888215834`", ",", 
          "0.375286217056888`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.5990754134617`", ",", "2.55570759589753`", ",", 
          "1.78806729456467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.254695632074619`", ",", "2.26053233048094`", ",", 
          "3.20084837207246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19350115786713`", ",", "2.02577602429444`", ",", 
          "4.61362944958025`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13230668365964`", ",", "1.81579454850513`", ",", 
          "6.02641052708803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07111220945215`", ",", "1.61647733508119`", ",", 
          "1.15600629741623`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72673242806507`", ",", "1.41898957174277`", ",", 
          "2.56878737492402`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66553795385758`", ",", "1.21523799177672`", ",", 
          "3.9815684524318`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60434347965009`", ",", "0.99440326534015`", ",", 
          "5.39434952993959`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25996369826301`", ",", "0.734907490016994`", ",", 
          "0.523945300267788`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19876922405552`", ",", "0.351717898441666`", ",", 
          "1.93672637777557`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13757474984803`", ",", "2.6146095022682`", ",", 
          "3.34950745528336`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.793194968460957`", ",", "2.30156036533071`", ",", 
          "4.76228853279115`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.73200049425347`", ",", "2.06070953267646`", ",", 
          "6.17506961029893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.67080602004598`", ",", "1.84799239093639`", ",", 
          "1.30466538062713`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.3264262386589`", ",", "1.64764228832651`", ",", 
          "2.71744645813492`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26523176445141`", ",", "1.45038645003729`", ",", 
          "4.1302275356427`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20403729024392`", ",", "1.24822258431133`", ",", 
          "5.54300861315049`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14284281603643`", ",", "1.03107368336679`", ",", 
          "0.672604383478688`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79846303464935`", ",", "0.780179116147674`", ",", 
          "2.08538546098647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73726856044186`", ",", "0.433081055961908`", ",", 
          "3.49816653849426`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67607408623437`", ",", "2.68020028054091`", ",", 
          "4.91094761600205`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3316943048473`", ",", "2.34415706214289`", ",", 
          "0.0405433863302455`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2704998306398`", ",", "2.09630664901163`", ",", 
          "1.45332446383803`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20930535643231`", ",", "1.88048806747345`", ",", 
          "2.86610554134582`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.864925575045238`", ",", "1.67888223640752`", ",", 
          "4.2788866188536`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80373110083775`", ",", "1.48166445770982`", ",", 
          "5.69166769636139`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74253662663026`", ",", "1.28084730492934`", ",", 
          "0.821263466689589`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.39815684524318`", ",", "1.06695525368477`", ",", 
          "2.23404454419737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33696237103569`", ",", "0.823466863689626`", ",", 
          "3.64682562170516`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2757678968282`", ",", "0.502104212153518`", ",", 
          "5.05960669921295`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21457342262071`", ",", "2.75590169616304`", ",", 
          "0.189202469541146`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.87019364123363`", ",", "2.3886051945705`", ",", 
          "1.60198354704893`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80899916702614`", ",", "2.13265465955816`", ",", 
          "3.01476462455672`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74780469281865`", ",", "1.91332536384306`", ",", 
          "4.4275457020645`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40342491143158`", ",", "1.71022848627631`", ",", 
          "5.84032677957229`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34223043722408`", ",", "1.51285524281069`", ",", 
          "0.969922549900489`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.28103596301659`", ",", "1.31315737211735`", ",", 
          "2.38270362740827`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.936656181629518`", ",", "1.10214030980064`", ",", 
          "3.79548470491606`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87546170742203`", ",", "0.865082791483786`", ",", 
          "5.20826578242385`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81426723321454`", ",", "0.563358067035527`", ",", 
          "0.337861552752046`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.469887451827461`", ",", "2.84950196411365`", ",", 
          "1.75064263025983`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40869297761997`", ",", "2.4352710872755`", ",", 
          "3.16342370776762`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34749850341248`", ",", "2.16985460920561`", ",", 
          "4.5762047852754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0031187220254035`", ",", "1.94655192344662`", ",", 
          "5.98898586278319`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94192424781791`", ",", "1.74171330314847`", ",", 
          "1.11858163311139`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.88072977361042`", ",", "1.54398967495266`", ",", 
          "2.53136271061918`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81953529940293`", ",", "1.34519456187643`", ",", 
          "3.94414378812696`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47515551801586`", ",", "1.13670916998259`", ",", 
          "5.35692486563475`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41396104380837`", ",", "0.905271715879302`", ",", 
          "0.486520635962946`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35276656960088`", ",", "0.619168423993429`", ",", 
          "1.89930171347073`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0083867882138`", ",", "2.99144614084905`", ",", 
          "3.31208279097852`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94719231400631`", ",", "2.48464451213036`", ",", 
          "4.7248638684863`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88599783979882`", ",", "2.20802492156853`", ",", 
          "6.13764494599409`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.541618058411741`", ",", "1.98022004439001`", ",", 
          "1.26724071632229`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.48042358420425`", ",", "1.77337022758817`", ",", 
          "2.68002179383007`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41922910999676`", ",", "1.5750981269588`", ",", 
          "4.09280287133786`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.074849328609684`", ",", "1.37699780268234`", ",", 
          "5.50558394884565`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01365485440219`", ",", "1.17073245922827`", ",", 
          "0.635179719173846`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.9524603801947`", ",", "0.944230176960236`", ",", 
          "2.04796079668163`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89126590598721`", ",", "0.670910196872802`", ",", 
          "3.46074187418942`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54688612460014`", ",", "0.199601857112984`", ",", 
          "4.8735229516972`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48569165039265`", ",", "2.5374068762181`", ",", 
          "0.0031187220254035`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42449717618516`", ",", "2.24730629519829`", ",", 
          "1.41589979953319`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.08011739479808`", ",", "2.0143876529098`", ",", 
          "2.82868087704098`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01892292059059`", ",", "1.80523442619274`", ",", 
          "4.24146195454876`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.9577284463831`", ",", "1.60621074423376`", ",", 
          "5.65424303205655`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.613348664996022`", ",", "1.40860368070509`", ",", 
          "0.783838802384746`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55215419078853`", ",", "1.20427291046693`", ",", 
          "2.19661987989253`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.49095971658104`", ",", "0.982119068914503`", ",", 
          "3.60940095740032`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.146579935193965`", ",", "0.719476379415395`", ",", 
          "5.0221820349081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08538546098647`", ",", "0.320619472541155`", ",", 
          "0.151777805236304`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02419098677898`", ",", "2.59455690796799`", ",", 
          "1.56455888274409`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96299651257149`", ",", "2.2878684775363`", ",", 
          "2.97733996025188`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61861673118442`", ",", "2.04911950867386`", ",", 
          "4.39012103775966`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55742225697693`", ",", "1.83734308678278`", ",", 
          "5.80290211526745`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49622778276944`", ",", "1.63735770857475`", ",", 
          "0.932497885595647`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15184800138236`", ",", "1.44004687536782`", ",", 
          "2.34527896310343`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.09065352717487`", ",", "1.23738678370204`", ",", 
          "3.75806004061122`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02945905296738`", ",", "1.01907234530617`", ",", 
          "5.170841118119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.685079271580302`", ",", "0.765486049289827`", ",", 
          "0.300436888447204`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62388479737281`", ",", "0.407952273532576`", ",", 
          "1.71321796595499`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56269032316532`", ",", "2.65766715648952`", ",", 
          "3.12599904346278`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.218310541778245`", ",", "2.32991988411114`", ",", 
          "4.53878012097056`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15711606757075`", ",", "2.0844887183941`", ",", 
          "5.95156119847835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09592159336326`", ",", "1.86973587149303`", ",", 
          "1.08115696880655`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03472711915577`", ",", "1.66856950286965`", ",", 
          "2.49393804631433`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.6903473377687`", ",", "1.47136054100759`", ",", 
          "3.90671912382212`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62915286356121`", ",", "1.2701250005675`", ",", 
          "5.3195002013299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56795838935372`", ",", "1.05520319617555`", ",", 
          "0.449095971658104`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22357860796664`", ",", "0.809389562105195`", ",", 
          "1.86187704916589`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16238413375915`", ",", "0.480357210193488`", ",", 
          "3.27465812667368`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10118965955166`", ",", "2.72948987549987`", ",", 
          "4.68743920418146`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.756809878164583`", ",", "2.37372167993792`", ",", 
          "6.10022028168925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69561540395709`", ",", "2.12057866500064`", ",", 
          "1.22981605201745`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.6344209297496`", ",", "1.90245544458588`", ",", 
          "2.64259712952523`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.290041148362526`", ",", "1.69987718317292`", ",", 
          "4.05537820703302`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22884667415504`", ",", "1.50257664726274`", ",", 
          "5.46815928454081`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16765219994755`", ",", "1.30253406412771`", ",", 
          "0.597755054869004`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10645772574005`", ",", "1.09060854228694`", ",", 
          "2.01053613237679`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76207794435298`", ",", "0.851526951122636`", ",", 
          "3.42331720988458`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.70088347014549`", ",", "0.543846560639312`", ",", 
          "4.83609828739236`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.639688995938`", ",", "2.81576410147204`", ",", 
          "6.24887936490015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29530921455092`", ",", "2.41960915121197`", ",", 
          "1.37847513522835`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23411474034343`", ",", "2.15748550585872`", ",", 
          "2.79125621273613`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17292026613594`", ",", "1.93554809652816`", ",", 
          "4.20403729024392`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.828540484748863`", ",", "1.73131266500664`", ",", 
          "5.61681836775171`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76734601054137`", ",", "1.53372628853629`", ",", 
          "0.746414138079905`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70615153633388`", ",", "1.33465681484852`", ",", 
          "2.15919521558769`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.361771754946806`", ",", "1.12537237725921`", ",", 
          "3.57197629309548`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.30057728073932`", ",", "0.892162703474909`", ",", 
          "4.98475737060326`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23938280653183`", ",", "0.601267164973068`", ",", 
          "0.114353140931462`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17818833232434`", ",", "2.93381158838658`", ",", 
          "1.52713421843925`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83380855093726`", ",", "2.46802559148063`", ",", 
          "2.93991529594703`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77261407672977`", ",", "2.19532146450707`", ",", 
          "4.35269637345482`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71141960252228`", ",", "1.96906449240197`", ",", 
          "5.76547745096261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.3670398211352`", ",", "1.76290903143519`", ",", 
          "0.895073221290805`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30584534692771`", ",", "1.56483997125719`", ",", 
          "2.30785429879859`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24465087272022`", ",", "1.3665330605128`", ",", 
          "3.72063537630638`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.900271091333144`", ",", "1.1595683015623`", ",", 
          "5.13341645381416`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83907661712565`", ",", "0.931507636518153`", ",", 
          "0.263012224142362`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77788214291816`", ",", "0.654234135380768`", ",", 
          "1.67579330165015`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.433502361531087`", ",", "0.138648342113194`", ",", 
          "3.08857437915793`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.3723078873236`", ",", "2.51957902199902`", ",", 
          "4.50135545666572`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31111341311611`", ",", "2.23421925232871`", ",", 
          "5.91413653417351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24991893890862`", ",", "2.00306058184492`", ",", 
          "1.0437323045017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90553915752154`", ",", "1.79470087156397`", ",", 
          "2.45651338200949`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84434468331405`", ",", "1.59594788653576`", ",", 
          "3.86929445951728`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78315020910656`", ",", "1.39820010856318`", ",", 
          "5.28207553702506`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43877042771948`", ",", "1.19326147759486`", ",", 
          "0.411671307353262`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37757595351199`", ",", "0.969733281301331`", ",", 
          "1.82445238486105`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.3163814793045`", ",", "0.703768541775269`", ",", 
          "3.23723346236883`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.972001697917424`", ",", "0.286288878626757`", ",", 
          "4.65001453987662`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.91080722370993`", ",", "2.57514393026604`", ",", 
          "6.06279561738441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84961274950244`", ",", "2.27433813839249`", ",", 
          "1.19239138771261`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.505232968115367`", ",", "2.03759872062302`", ",", 
          "2.60517246522039`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44403849390788`", ",", "1.82672465971032`", ",", 
          "4.01795354272818`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38284401970039`", ",", "1.6270801750891`", ",", 
          "5.43073462023596`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0384642383133098`", ",", "1.42969322270844`", ",", 
          "0.560330390564162`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97726976410582`", ",", "1.22651016237068`", ",", 
          "1.97311146807195`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91607528989833`", ",", "1.00698169079731`", ",", 
          "3.38589254557973`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85488081569084`", ",", "0.750564785752414`", ",", 
          "4.79867362308752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.51050103430376`", ",", "0.381268839776225`", ",", 
          "6.21145470059531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44930656009627`", ",", "2.6360612902074`", ",", 
          "1.34105047092351`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38811208588878`", ",", "2.31587249138979`", ",", 
          "2.75383154843129`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.0437323045017`", ",", "2.07274907247328`", ",", 
          "4.16661262593908`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98253783029421`", ",", "1.85901918773066`", ",", 
          "5.57939370344686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92134335608672`", ",", "1.6582671909378`", ",", 
          "0.708989473775063`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.576963574699648`", ",", "1.46104602083049`", ",", 
          "2.12177055128285`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51576910049216`", ",", "1.25936692707172`", ",", 
          "3.53455162879063`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45457462628467`", ",", "1.04337233663636`", ",", 
          "4.94733270629842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.11019484489759`", ",", "0.795120775064973`", ",", 
          "0.0769284766266197`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.0490003706901`", ",", "0.457661948073754`", ",", 
          "1.48970955413441`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98780589648261`", ",", "2.70458578571858`", ",", 
          "2.90249063164219`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92661142227512`", ",", "2.3590641523649`", ",", 
          "4.31527170914998`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58223164088804`", ",", "2.10859138693055`", ",", 
          "5.72805278665776`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.52103716668055`", ",", "1.89162606607333`", ",", 
          "0.857648556985963`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45984269247306`", ",", "1.68953977031609`", ",", 
          "2.27042963449375`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11546291108599`", ",", "1.49229082774289`", ",", 
          "3.68321071200153`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0542684368785`", ",", "1.29187964125813`", ",", 
          "5.09599178950932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99307396267101`", ",", "1.07900708762227`", ",", 
          "0.22558755983752`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.648694181283928`", ",", "0.837808219375031`", ",", 
          "1.63836863734531`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58749970707644`", ",", "0.523683991173636`", ",", 
          "3.05114971485309`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52630523286895`", ",", "2.78510320217113`", ",", 
          "4.46393079236088`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.181925451481871`", ",", "2.40422097717873`", ",", 
          "5.87671186986866`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.12073097727438`", ",", "2.14521728919597`", ",", 
          "1.00630764019686`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05953650306689`", ",", "1.92459031337087`", ",", 
          "2.41908871770465`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.9983420288594`", ",", "1.72092951248926`", ",", 
          "3.83186979521243`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65396224747232`", ",", "1.52345899382038`", ",", 
          "5.24465087272022`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59276777326483`", ",", "1.32409227814254`", ",", 
          "0.37424664304842`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53157329905734`", ",", "1.11397388651165`", ",", 
          "1.78702772055621`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18719351767027`", ",", "0.87891361479001`", ",", 
          "3.19980879806399`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12599904346278`", ",", "0.582886012822035`", ",", 
          "4.61258987557178`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06480456925529`", ",", "2.88886089060093`", ",", 
          "6.02537095307956`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.720424787868209`", ",", "2.45174578711778`", ",", 
          "1.15496672340776`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65923031366072`", ",", "2.18273327956768`", ",", 
          "2.56774780091555`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59803583945323`", ",", "1.95796106024735`", ",", 
          "3.98052887842333`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.253656058066151`", ",", "1.75246907975476`", ",", 
          "5.39330995593112`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19246158385866`", ",", "1.55458118869652`", ",", 
          "0.52290572625932`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.13126710965117`", ",", "1.35604558253782`", ",", 
          "1.93568680376711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.07007263544368`", ",", "1.14834952064141`", ",", 
          "3.34846788127489`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.7256928540566`", ",", "0.918663597875588`", ",", 
          "4.76124895878268`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66449837984911`", ",", "0.637187263501562`", ",", 
          "6.17403003629046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60330390564162`", ",", "3.10520896545884`", ",", 
          "1.30362580661866`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25892412425455`", ",", "2.50218390357712`", ",", 
          "2.71640688412645`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19772965004706`", ",", "2.22126473598233`", ",", 
          "4.12918796163423`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13653517583957`", ",", "1.99179240117754`", ",", 
          "5.54196903914202`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.792155394452489`", ",", "1.7841925248646`", ",", 
          "0.671564809470221`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.730960920245`", ",", "1.5856876779483`", ",", 
          "2.08434588697801`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66976644603751`", ",", "1.3877776326833`", ",", 
          "3.49712696448579`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.325386664650432`", ",", "1.18220174770737`", ",", 
          "4.90990804199358`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26419219044294`", ",", "0.957241390401802`", ",", 
          "0.0395038123217777`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20299771623545`", ",", "0.687764433322442`", ",", 
          "1.45228488982956`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14180324202796`", ",", "0.247382894644743`", ",", 
          "2.86506596733735`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79742346064088`", ",", "2.5563063187483`", ",", 
          "4.27784704484514`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73622898643339`", ",", "2.26096136760858`", ",", 
          "5.69062812235292`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.6750345122259`", ",", "2.02614443972968`", ",", 
          "0.820223892681121`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.33065473083883`", ",", "1.816135655528`", ",", 
          "2.23300497018891`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26946025663134`", ",", "1.61680858984055`", ",", 
          "3.64578604769669`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20826578242385`", ",", "1.41932431974114`", ",", 
          "5.05856712520448`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.86388600103677`", ",", "1.21559095375367`", ",", 
          "0.188162895532678`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80269152682928`", ",", "0.994797887098575`", ",", 
          "1.60094397304046`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74149705262179`", ",", "0.73540086401027`", ",", 
          "3.01372505054825`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.397117271234712`", ",", "0.352677155961411`", ",", 
          "4.42650612805604`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33592279702722`", ",", "2.61526783497629`", ",", 
          "5.83928720556382`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27472832281973`", ",", "2.30200482393371`", ",", 
          "0.968882975892021`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21353384861224`", ",", "2.06108458894393`", ",", 
          "2.38166405339981`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86915406722517`", ",", "1.84833644765902`", ",", 
          "3.79444513090759`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80795959301767`", ",", "1.6479741787194`", ",", 
          "5.20722620841538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74676511881018`", ",", "1.45071976341569`", ",", 
          "0.336821978743578`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40238533742311`", ",", "1.24857146610367`", ",", 
          "1.74960305625136`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34119086321562`", ",", "1.03145937782109`", ",", 
          "3.16238413375915`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27999638900813`", ",", "0.780649438738464`", ",", 
          "4.57516521126694`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.93561660762105`", ",", "0.433868878571957`", ",", 
          "5.98794628877472`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87442213341356`", ",", "2.6809441213329`", ",", 
          "1.11754205910292`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81322765920607`", ",", "2.34461960636116`", ",", 
          "2.53032313661071`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.468847877818993`", ",", "2.09668921244419`", ",", 
          "3.94310421411849`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.4076534036115`", ",", "1.88083552181072`", ",", 
          "5.35588529162628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34645892940401`", ",", "1.67921509148205`", ",", 
          "0.485481061954478`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00207914801693567`", ",", "1.48199667827603`", ",", 
          "1.89826213946226`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.94088467380945`", ",", "1.28119260806296`", ",", 
          "3.31104321697005`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87969019960195`", ",", "1.06733307618821`", ",", 
          "4.72382429447784`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.81849572539447`", ",", "0.823917899250897`", ",", 
          "6.13660537198562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47411594400739`", ",", "0.502791350385278`", ",", 
          "1.26620114231382`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4129214697999`", ",", "2.75678225556016`", ",", 
          "2.67898221982161`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35172699559241`", ",", "2.38908922749453`", ",", 
          "4.09176329732939`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00734721420533`", ",", "2.13304572717143`", ",", 
          "5.50454437483718`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94615273999784`", ",", "1.91367670105725`", ",", 
          "0.634140145165379`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88495826579035`", ",", "1.71056264369895`", ",", 
          "2.04692122267316`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.540578484403274`", ",", "1.51318670254756`", ",", 
          "3.45970230018095`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47938401019578`", ",", "1.31349955798772`", ",", 
          "4.87248337768874`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41818953598829`", ",", "1.10251117336588`", ",", 
          "0.00207914801693567`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0738097546012162`", ",", "0.865517457287209`", ",", 
          "1.41486022552472`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01261528039373`", ",", "0.563977405992231`", ",", 
          "2.82764130303251`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95142080618624`", ",", "2.85065332983771`", ",", 
          "4.24042238054029`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.89022633197875`", ",", "2.43578108009937`", ",", 
          "5.65320345804808`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.54584655059167`", ",", "2.1702553419807`", ",", 
          "0.782799228376279`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48465207638418`", ",", "1.9469076738514`", ",", 
          "2.19558030588406`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42345760217669`", ",", "1.74204911243356`", ",", 
          "3.60836138339185`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07907782078961`", ",", "1.54432069910379`", ",", 
          "5.02114246089964`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01788334658212`", ",", "1.34553405863477`", ",", 
          "0.150738231227836`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95668887237463`", ",", "1.13707387335665`", ",", 
          "1.56351930873562`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.612309090987554`", ",", "0.905692329958155`", ",", 
          "2.97630038624341`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.55111461678006`", ",", "0.619738372788804`", ",", 
          "4.38908146375119`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48992014257257`", ",", "2.99367475223751`", ",", 
          "5.80186254125898`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.145540361185497`", ",", "2.4851865481046`", ",", 
          "0.931458311587179`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08434588697801`", ",", "2.20843668898514`", ",", 
          "2.34423938909496`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02315141277052`", ",", "1.98058079269398`", ",", 
          "3.75702046660275`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96195693856303`", ",", "1.77370805363423`", ",", 
          "5.16980154411054`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61757715717595`", ",", "1.5754290369465`", ",", 
          "0.299397314438736`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55638268296846`", ",", "1.37733501104239`", ",", 
          "1.71217839194652`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.49518820876097`", ",", "1.17109170850302`", ",", 
          "3.12495946945431`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.15080842737389`", ",", "0.944638620276672`", ",", 
          "4.53774054696209`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.0896139531664`", ",", "0.671442280307003`", ",", 
          "5.95052162446988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02841947895891`", ",", "0.201263923430155`", ",", 
          "1.08011739479808`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.684039697571834`", ",", "2.53798960986705`", ",", 
          "2.49289847230586`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62284522336434`", ",", "2.24773073609388`", ",", 
          "3.90567954981365`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56165074915685`", ",", "2.01475404970435`", ",", 
          "5.31846062732144`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.217270967769777`", ",", "1.80557465323112`", ",", 
          "0.448056397649636`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15607649356229`", ",", "1.60654186048325`", ",", 
          "1.86083747515742`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.0948820193548`", ",", "1.40893897891208`", ",", 
          "3.27361855266521`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03368754514731`", ",", "1.20462733598374`", ",", 
          "4.68639963017299`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68930776376023`", ",", "0.982516895476322`", ",", 
          "6.09918070768078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62811328955274`", ",", "0.719978377115517`", ",", 
          "1.22877647800898`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56691881534525`", ",", "0.321667800344336`", ",", 
          "2.64155755551677`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.22253903395817`", ",", "2.59519340652323`", ",", 
          "4.05433863302455`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16134455975068`", ",", "2.28830758530507`", ",", 
          "5.46711971053234`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.10015008554319`", ",", "2.0494922847542`", ",", 
          "0.596715480860537`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.755770304156115`", ",", "1.83768612286671`", ",", 
          "2.00949655836832`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69457582994862`", ",", "1.63768935331405`", ",", 
          "3.42227763587611`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63338135574113`", ",", "1.44038062351749`", ",", 
          "4.83505871338389`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.289001574354058`", ",", "1.23773695347478`", ",", 
          "6.24783979089168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.22780710014657`", ",", "1.0194608593118`", ",", 
          "1.37743556121988`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16661262593908`", ",", "0.765963507014079`", ",", 
          "2.79021663872767`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10541815173159`", ",", "0.408785554691595`", ",", 
          "4.20299771623545`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.76103837034451`", ",", "2.65837887182288`", ",", 
          "5.61577879374324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69984389613702`", ",", "2.33037612934965`", ",", 
          "0.745374564071437`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63864942192953`", ",", "2.08486870287091`", ",", 
          "2.15815564157922`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29426964054245`", ",", "1.87008215368586`", ",", 
          "3.57093671908701`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23307516633496`", ",", "1.6689020029735`", ",", 
          "4.98371779659479`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.17188069212747`", ",", "1.47169308486446`", ",", 
          "0.113313566922994`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.827500910740396`", ",", "1.2704714310933`", ",", 
          "1.52609464443078`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.7663064365329`", ",", "1.05558350752206`", ",", 
          "2.93887572193857`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70511196232541`", ",", "0.809846600523163`", ",", 
          "4.35165679944635`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.360732180938338`", ",", "0.481072818312459`", ",", 
          "5.76443787695414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29953770673085`", ",", "2.73031681547279`", ",", 
          "0.894033647282337`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23834323252336`", ",", "2.3741981928773`", ",", 
          "2.30681472479012`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.17714875831587`", ",", "2.12096680855785`", ",", 
          "3.71959580229791`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83276897692879`", ",", "1.90280544505041`", ",", 
          "5.1323768798057`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.7715745027213`", ",", "1.70021087312101`", ",", 
          "0.261972650133894`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.71038002851381`", ",", "1.50290832169832`", ",", 
          "1.67475372764168`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36600024712673`", ",", "1.30287722921448`", ",", 
          "3.08753480514947`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30480577291924`", ",", "1.09098160744595`", ",", 
          "4.50031588265725`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24361129871175`", ",", "0.851966733884734`", ",", 
          "5.91309696016504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.899231517324676`", ",", "0.54448574082389`", ",", 
          "1.04269273049324`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83803704311719`", ",", "2.8167994682263`", ",", 
          "2.45547380800102`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.7768425689097`", ",", "2.42011000392941`", ",", 
          "3.86825488550881`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.432462787522619`", ",", "2.15788291111666`", ",", 
          "5.28103596301659`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37126831331513`", ",", "1.93590232977732`", ",", 
          "0.410631733344794`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.31007383910764`", ",", "1.73164789003223`", ",", 
          "1.82341281085258`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24887936490015`", ",", "1.5340574206876`", ",", 
          "3.23619388836037`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.90449958351307`", ",", "1.33499715292194`", ",", 
          "4.64897496586815`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84330510930558`", ",", "1.12573902999847`", ",", 
          "6.06175604337594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78211063509809`", ",", "0.892587724996853`", ",", 
          "1.19135181370414`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43773085371101`", ",", "0.601851879201391`", ",", 
          "2.60413289121192`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37653637950352`", ",", "2.93542182963252`", ",", 
          "4.01691396871971`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31534190529603`", ",", "2.46855625586216`", ",", 
          "5.4296950462275`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.970962123908957`", ",", "2.19572942638859`", ",", 
          "0.559290816555694`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.90976764970147`", ",", "1.96942352405313`", ",", 
          "1.97207189406348`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84857317549398`", ",", "1.76324615094948`", ",", 
          "3.38485297157127`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.504193394106899`", ",", "1.56517088349149`", ",", 
          "4.79763404907905`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44299891989941`", ",", "1.36687098074926`", ",", 
          "6.21041512658684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38180444569192`", ",", "1.15992927646066`", ",", 
          "1.34001089691504`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.037424664304842`", ",", "0.931919907673627`", ",", 
          "2.75279197442282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97623019009735`", ",", "0.654777703780215`", ",", 
          "4.16557305193061`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91503571588986`", ",", "0.141022473631527`", ",", 
          "5.5783541294384`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.85384124168237`", ",", "2.52014715877487`", ",", 
          "0.707949899766595`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50946146029529`", ",", "2.23463931282451`", ",", 
          "2.12073097727438`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.4482669860878`", ",", "2.00342503933488`", ",", 
          "3.53351205478217`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38707251188031`", ",", "1.79504026295588`", ",", 
          "4.94629313228995`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04269273049324`", ",", "1.59627889929787`", ",", 
          "0.0758889026181519`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98149825628575`", ",", "1.39853599611195`", ",", 
          "1.48866998012594`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.92030378207826`", ",", "1.19361742834183`", ",", 
          "2.90145105763372`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.57592400069118`", ",", "0.97013445406936`", ",", 
          "4.31423213514151`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51472952648369`", ",", "0.704279760136313`", ",", 
          "5.7270132126493`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.4535350522762`", ",", "0.287458346259315`", ",", 
          "0.856608982977495`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.109155270889123`", ",", "2.57576085782465`", ",", 
          "2.26939006048528`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04796079668163`", ",", "2.27477216259377`", ",", 
          "3.68217113799307`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98676632247414`", ",", "2.03796930650413`", ",", 
          "5.09495221550085`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92557184826665`", ",", "1.82706672264145`", ",", 
          "0.224547985829052`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58119206687957`", ",", "1.62741160970178`", ",", 
          "1.63732906333684`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51999759267208`", ",", "1.43002744320692`", ",", 
          "3.05011014084462`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45880311846459`", ",", "1.22686167622701`", ",", 
          "4.46289121835241`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11442333707752`", ",", "1.00737314474061`", ",", 
          "5.8756722958602`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05322886287003`", ",", "0.75104982314352`", ",", 
          "1.0052680661884`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99203438866254`", ",", "0.382157154323135`", ",", 
          "2.41804914369618`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.64765460727546`", ",", "2.63674501946911`", ",", 
          "3.83083022120397`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.58646013306797`", ",", "2.31632277588512`", ",", 
          "5.24361129871175`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52526565886048`", ",", "2.07312658114806`", ",", 
          "0.373207069039952`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.180885877473403`", ",", "1.85936434907308`", ",", 
          "1.78598814654774`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11969140326591`", ",", "1.65859937242351`", ",", 
          "3.19876922405552`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05849692905842`", ",", "1.46137892437309`", ",", 
          "4.61155030156331`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99730245485093`", ",", "1.25971453646219`", ",", 
          "6.0243313790711`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65292267346386`", ",", "1.04375524060627`", ",", 
          "1.1539271493993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.59172819925636`", ",", "0.795584158167959`", ",", 
          "2.56670822690708`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.53053372504888`", ",", "0.458410288277805`", ",", 
          "3.97948930441487`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.1861539436618`", ",", "2.7053683022868`", ",", 
          "5.39227038192265`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12495946945431`", ",", "2.35953358464508`", ",", 
          "0.521866152250852`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06376499524682`", ",", "2.10897672603065`", ",", 
          "1.93464722975864`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.719385213859741`", ",", "1.89197478567619`", ",", 
          "3.34742830726642`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65819073965225`", ",", "1.6898730303095`", ",", 
          "4.76020938477421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59699626544476`", ",", "1.49262275243262`", ",", 
          "6.172990462282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.252616484057684`", ",", "1.29222383319503`", ",", 
          "1.3025862326102`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19142200985019`", ",", "1.07938244486741`", ",", 
          "2.71536731011798`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.1302275356427`", ",", "0.838253388927786`", ",", 
          "4.12814838762577`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06903306143521`", ",", "0.524345328229027`", ",", 
          "5.54092946513355`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72465328004814`", ",", "2.78605260573547`", ",", 
          "0.670525235461753`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66345880584065`", ",", "2.40471327885742`", ",", 
          "2.08330631296954`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60226433163315`", ",", "2.14561150733662`", ",", 
          "3.49608739047732`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25788455024608`", ",", "1.92494309089483`", ",", 
          "4.90886846798511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19669007603859`", ",", "1.7212641923142`", ",", 
          "0.0384642383133098`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.1354956018311`", ",", "1.52379026900948`", ",", 
          "1.4512453158211`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.791115820444021`", ",", "1.32443350199094`", ",", 
          "2.86402639332888`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72992134623653`", ",", "1.11434256836222`", ",", 
          "4.27680747083667`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66872687202904`", ",", "0.879343261472721`", ",", 
          "5.68958854834445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.324347090641964`", ",", "0.58348691131025`", ",", 
          "0.819184318672653`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26315261643447`", ",", "2.89018766185596`", ",", 
          "2.23196539618044`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20195814222698`", ",", "2.45226590200115`", ",", 
          "3.64474647368822`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.14076366801949`", ",", "2.18313760301739`", ",", 
          "5.05752755119601`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79638388663242`", ",", "1.95831844337898`", ",", 
          "0.18712332152421`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73518941242493`", ",", "1.75280553374741`", ",", 
          "1.599904399032`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67399493821744`", ",", "1.55491213800633`", ",", 
          "3.01268547653978`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32961515683036`", ",", "1.35638425650307`", ",", 
          "4.42546655404757`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.26842068262287`", ",", "1.14871229214259`", ",", 
          "5.83824763155535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20722620841538`", ",", "0.919079875853561`", ",", 
          "0.967843401883553`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.862846427028302`", ",", "0.637743259290841`", ",", 
          "2.38062447939134`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80165195282081`", ",", "3.11586621054774`", ",", 
          "3.79340555689912`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.74045747861332`", ",", "2.50273865214834`", ",", 
          "5.20618663440691`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.396077697226245`", ",", "2.22168061806789`", ",", 
          "0.33578240473511`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33488322301875`", ",", "1.99215499563829`", ",", 
          "1.7485634822429`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.27368874881126`", ",", "1.78453112403738`", ",", 
          "3.16134455975068`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21249427460377`", ",", "1.58601862214725`", ",", 
          "4.57412563725847`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.8681144932167`", ",", "1.3881141493085`", ",", 
          "5.98690671476625`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80692001900921`", ",", "1.18255928746183`", ",", 
          "1.11650248509445`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74572554480172`", ",", "0.957646058926557`", ",", 
          "2.52928356260224`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40134576341464`", ",", "0.688285535779421`", ",", 
          "3.94206464011002`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.34015128920715`", ",", "0.248730669919266`", ",", 
          "5.35484571761781`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27895681499966`", ",", "2.55690558296949`", ",", 
          "0.484441487946011`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.934577033612582`", ",", "2.26139055676315`", ",", 
          "1.8972225654538`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87338255940509`", ",", "2.02651292163956`", ",", 
          "3.31000364296158`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.8121880851976`", ",", "1.81647679168646`", ",", 
          "4.72278472046937`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.467808303810525`", ",", "1.61713984965247`", ",", 
          "6.13556579797715`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40661382960303`", ",", "1.41965905063599`", ",", 
          "1.26516156830535`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34541935539555`", ",", "1.21594386952431`", ",", 
          "2.67794264581314`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.00103957400846783`", ",", "0.995192407744232`", ",", 
          "4.09072372332092`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.93984509980098`", ",", "0.735893969088259`", ",", 
          "5.50350480082871`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.87865062559349`", ",", "0.353633919938879`", ",", 
          "0.633100571156911`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.817456151386`", ",", "2.61592691450175`", ",", 
          "2.0458816486647`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.47307636999892`", ",", "2.30244945982292`", ",", 
          "3.45866272617248`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.41188189579143`", ",", "2.06145972030875`", ",", 
          "4.87144380368027`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.35068742158394`", ",", "1.84868053810918`", ",", 
          "0.00103957400846783`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.00630764019686`", ",", "1.64830607763065`", ",", 
          "1.41382065151625`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.94511316598937`", ",", "1.4510530633899`", ",", 
          "2.82660172902404`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.88391869178188`", ",", "1.24892030726376`", ",", 
          "4.23938280653183`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.539538910394806`", ",", "1.03184498325868`", ",", 
          "5.65216388403961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.47834443618732`", ",", "0.781119538120942`", ",", 
          "0.781759654367811`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.41714996197983`", ",", "0.43465536382852`", ",", 
          "2.1945407318756`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0727701805927484`", ",", "2.68168907874538`", ",", 
          "3.60732180938338`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.01157570638526`", ",", "2.34508235972477`", ",", 
          "5.02010288689117`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.95038123217777`", ",", "2.09707186084187`", ",", 
          "0.149698657219368`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.88918675797028`", ",", "1.88118301482889`", ",", 
          "1.56247973472715`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.5448069765832`", ",", "1.67954795861629`", ",", 
          "2.97526081223494`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.48361250237571`", ",", "1.48232888901582`", ",", 
          "4.38804188974273`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.42241802816822`", ",", "1.28153787567067`", ",", 
          "5.80082296725051`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.07803824678114`", ",", "1.06771082008027`", ",", 
          "0.930418737578711`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.01684377257365`", ",", "0.82436874655593`", ",", 
          "2.3431998150865`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.95564929836616`", ",", "0.503477631111391`", ",", 
          "3.75598089259428`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.611269516979086`", ",", "2.75766473365844`", ",", 
          "5.16876197010207`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5500750427716`", ",", "2.38957351077981`", ",", 
          "0.298357740430268`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.48888056856411`", ",", "2.13343689117019`", ",", 
          "1.71113881793805`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.144500787177029`", ",", "1.91402808234193`", ",", 
          "3.12391989544584`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.08330631296954`", ",", "1.71089681683123`", ",", 
          "4.53670097295363`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.02211183876205`", ",", "1.51351815594822`", ",", 
          "5.94948205046141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.96091736455456`", ",", "1.31384171305078`", ",", 
          "1.07907782078961`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.61653758316748`", ",", "1.1028819673751`", ",", 
          "2.4918588982974`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.55534310895999`", ",", "0.865951962300326`", ",", 
          "3.90463997580518`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.4941486347525`", ",", "0.564596139094054`", ",", 
          "5.31742105331297`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.14976885336542`", ",", "2.85180913981835`", ",", 
          "0.447016823641168`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.08857437915793`", ",", "2.43629137828174`", ",", 
          "1.85979790114895`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.02737990495044`", ",", "2.17065618452169`", ",", 
          "3.27257897865674`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.683000123563367`", ",", "1.94726347424244`", ",", 
          "4.68536005616453`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.62180564935588`", ",", "1.74238494122263`", ",", 
          "6.09814113367231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.56061117514839`", ",", "1.54465172035315`", ",", 
          "1.22773690400051`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.216231393761309`", ",", "1.34587352898362`", ",", 
          "2.6405179815083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.15503691955382`", ",", "1.13743851514031`", ",", 
          "4.05329905901608`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.09384244534633`", ",", "0.90611280532457`", ",", 
          "5.46608013652387`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.03264797113884`", ",", "0.620307866677265`", ",", 
          "0.595675906852069`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.68826818975176`", ",", "2.99593720592499`", ",", 
          "2.00845698435985`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.62707371554427`", ",", "2.48572896573041`", ",", 
          "3.42123806186764`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.56587924133678`", ",", "2.20884858205852`", ",", 
          "4.83401913937543`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.2214994599497`", ",", "1.98094159753609`", ",", 
          "6.24680021688321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.16030498574221`", ",", "1.77404590316266`", ",", 
          "1.37639598721141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.09911051153472`", ",", "1.57575994744149`", ",", 
          "2.7891770647192`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.754730730147647`", ",", "1.37767219712692`", ",", 
          "4.20195814222698`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.69353625594016`", ",", "1.17145090326526`", ",", 
          "5.61473921973477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.63234178173267`", ",", "0.945046942972487`", ",", 
          "0.744334990062969`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.28796200034559`", ",", "0.67197400768551`", ",", 
          "2.15711606757075`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.2267675261381`", ",", "0.202912558950479`", ",", 
          "3.56989714507854`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.16557305193061`", ",", "2.53857283647591`", ",", 
          "4.98267822258633`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.10437857772312`", ",", "2.24815532180813`", ",", 
          "0.112273992914526`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.75999879633604`", ",", "2.01512051036101`", ",", 
          "1.52505507042231`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.69880432212855`", ",", "1.80591490795899`", ",", 
          "2.9378361479301`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.63760984792106`", ",", "1.60687298065352`", ",", 
          "4.35061722543788`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.29323006653398`", ",", "1.4092742587627`", ",", 
          "5.76339830294567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.23203559232649`", ",", "1.20498171333754`", ",", 
          "0.892994073273869`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.170841118119`", ",", "0.982914616492196`", ",", 
          "2.30577515078165`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.826461336731928`", ",", "0.720480087644504`", ",", 
          "3.71855622828944`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.76526686252444`", ",", "0.322712840588736`", ",", 
          "5.13133730579723`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.70407238831695`", ",", "2.59583057193246`", ",", 
          "0.260933076125426`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.35969260692987`", ",", "2.28874686140361`", ",", 
          "1.67371415363321`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.29849813272238`", ",", "2.04986513296346`", ",", 
          "3.086495231141`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.23730365851489`", ",", "1.83802919112713`", ",", 
          "4.49927630864878`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.1761091843074`", ",", "1.63802100542195`", ",", 
          "5.91205738615657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.83172940292032`", ",", "1.44071435705815`", ",", 
          "1.04165315648477`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.77053492871283`", ",", "1.23808708083304`", ",", 
          "2.45443423399255`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.70934045450534`", ",", "1.01984928051799`", ",", 
          "3.86721531150034`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.36496067311827`", ",", "0.766440727852329`", ",", 
          "5.27999638900813`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.30376619891078`", ",", "0.409617236023994`", ",", 
          "0.409592159336327`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.24257172470329`", ",", "2.65909155385122`", ",", 
          "1.82237323684411`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.898191943316208`", ",", "2.33083257235317`", ",", 
          "3.2351543143519`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.83699746910872`", ",", "2.08524876890378`", ",", 
          "4.64793539185968`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.77580299490123`", ",", "1.87042847288176`", ",", 
          "6.06071646936747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.431423213514151`", ",", "1.66923451395883`", ",", 
          "1.19031223969567`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.37022873930666`", ",", "1.47202561772629`", ",", 
          "2.60309331720346`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.30903426509917`", ",", "1.27081782445564`", ",", 
          "4.01587439471124`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.24783979089168`", ",", "1.05596373698961`", ",", 
          "5.42865547221903`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.9034600095046`", ",", "0.810303440115479`", ",", 
          "0.558251242547227`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.84226553529711`", ",", "0.481787446701993`", ",", 
          "1.97103232005501`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.78107106108962`", ",", "2.73114532630869`", ",", 
          "3.3838133975628`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.43669127970255`", ",", "2.37467494132446`", ",", 
          "4.79659447507058`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.37549680549506`", ",", "2.12135504454003`", ",", 
          "6.20937555257837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.31430233128757`", ",", "1.90315548775463`", ",", 
          "1.33897132290657`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.969922549900489`", ",", "1.7005445775609`", ",", 
          "2.75175240041436`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.908728075693`", ",", "1.50323998865436`", ",", 
          "4.16453347792214`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.84753360148551`", ",", "1.30322036197628`", ",", 
          "5.57731455542993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.503153820098432`", ",", "1.09135460019441`", ",", 
          "0.706910325758127`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.44195934589094`", ",", "0.852406347479274`", ",", 
          "2.11969140326591`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.38076487168345`", ",", "0.545124247034232`", ",", 
          "3.5324724807737`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.0363850902963742`", ",", "2.81783802844801`", ",", 
          "4.94525355828148`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.97519061608888`", ",", "2.4206111419691`", ",", 
          "0.074849328609684`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.91399614188139`", ",", "2.15828042148085`", ",", 
          "1.48763040611747`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.8528016676739`", ",", "1.93625661099736`", ",", 
          "2.90041148362526`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.50842188628683`", ",", "1.73198313329216`", ",", 
          "4.31319256113304`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.44722741207934`", ",", "1.53438854880878`", ",", 
          "5.72597363864083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.38603293787185`", ",", "1.3353374631673`", ",", 
          "0.855569408969027`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.04165315648477`", ",", "1.12610561862738`", ",", 
          "2.26835048647681`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.98045868227728`", ",", "0.893012601023793`", ",", 
          "3.6811315639846`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.91926420806979`", ",", "0.602436096093067`", ",", 
          "5.09391264149239`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.574884426682712`", ",", "2.93704456511476`", ",", 
          "0.223508411820584`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.51368995247522`", ",", "2.4690872737176`", ",", 
          "1.63628948932837`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.45249547826773`", ",", "2.19613750836729`", ",", 
          "3.04907056683616`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.108115696880655`", ",", "1.96978261000367`", ",", 
          "4.46185164434394`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.04692122267316`", ",", "1.76358329261114`", ",", 
          "5.87463272185173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.98572674846567`", ",", "1.56550179510978`", ",", 
          "1.00422849217993`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.92453227425818`", ",", "1.36720887737287`", ",", 
          "2.41700956968771`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.58015249287111`", ",", "1.16029019459988`", ",", 
          "3.8297906471955`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.51895801866362`", ",", "0.932332052616069`", ",", 
          "5.24257172470329`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.45776354445613`", ",", "0.655320887614755`", ",", 
          "0.372167495031484`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.11338376306905`", ",", "0.143357549332179`", ",", 
          "1.78494857253927`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.05218928886156`", ",", "2.5207157466592`", ",", 
          "3.19772965004706`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.99099481465407`", ",", "2.23505951139983`", ",", 
          "4.61051072755484`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.646615033266992`", ",", "2.00378955817659`", ",", 
          "6.02329180506263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.5854205590595`", ",", "1.79537968062154`", ",", 
          "1.15288757539083`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.52422608485201`", ",", "1.59660991485272`", ",", 
          "2.56566865289861`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.179846303464935`", ",", "1.39887186403283`", ",", 
          "3.9784497304064`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.11865182925744`", ",", "1.1939733289039`", ",", 
          "5.39123080791419`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.05745735504995`", ",", "0.970535516606528`", ",", 
          "0.520826578242385`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.99626288084246`", ",", "0.704790671084898`", ",", 
          "1.93360765575017`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.65188309945539`", ",", "0.288623206106967`", ",", 
          "3.34638873325796`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.5906886252479`", ",", "2.5763783852381`", ",", 
          "4.75916981076574`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.52949415104041`", ",", "2.27520634680641`", ",", 
          "6.17195088827353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.18511436965333`", ",", "2.03833996167142`", ",", 
          "1.30154665860173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.12391989544584`", ",", "1.82740881623492`", ",", 
          "2.71432773610951`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.06272542123835`", ",", "1.62774305054035`", ",", 
          "4.1271088136173`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.718345639851273`", ",", "1.43036164787711`", ",", 
          "5.53988989112509`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.65715116564378`", ",", "1.2272131458327`", ",", 
          "0.669485661453285`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.59595669143629`", ",", "1.00776450190416`", ",", 
          "2.08226673896107`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.251576910049216`", ",", "0.751534608660799`", ",", 
          "3.49504781646886`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.19038243584173`", ",", "0.383043509842913`", ",", 
          "4.90782889397664`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.12918796163423`", ",", "2.63742959573357`", ",", 
          "0.037424664304842`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.06799348742675`", ",", "2.31677324765801`", ",", 
          "1.45020574181263`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.72361370603967`", ",", "2.07350416812594`", ",", 
          "2.86298681932041`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.66241923183218`", ",", "1.85970954578523`", ",", 
          "4.2757678968282`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.60122475762469`", ",", "1.65893156362306`", ",", 
          "5.68854897433599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.25684497623761`", ",", "1.46171181574136`", ",", 
          "0.818144744664185`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.19565050203012`", ",", "1.26006210700692`", ",", 
          "2.23092582217197`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.13445602782263`", ",", "1.04413805927244`", ",", 
          "3.64370689967976`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.790076246435554`", ",", "0.796047330972881`", ",", 
          "5.05648797718754`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.72888177222806`", ",", "0.459157495352331`", ",", 
          "0.186083747515742`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.66768729802057`", ",", "2.70615213458661`", ",", 
          "1.59886482502353`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.323307516633496`", ",", "2.36000323887345`", ",", 
          "3.01164590253131`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.26211304242601`", ",", "2.10936215379133`", ",", 
          "4.4244269800391`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.20091856821852`", ",", "1.89232354574159`", ",", 
          "5.83720805754689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.13972409401103`", ",", "1.69020630359123`", ",", 
          "0.966803827875085`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.79534431262395`", ",", "1.49295466849229`", ",", 
          "2.37958490538287`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.73414983841646`", ",", "1.29256799125227`", ",", 
          "3.79236598289066`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.67295536420897`", ",", "1.07975772672092`", ",", 
          "5.20514706039844`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.32857558282189`", ",", "0.838698380291128`", ",", 
          "0.334742830726642`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.2673811086144`", ",", "0.52500590991059`", ",", 
          "1.74752390823443`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.20618663440691`", ",", "2.78700444300166`", ",", 
          "3.16030498574221`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.861806853019834`", ",", "2.40520584777989`", ",", 
          "4.57308606325`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.80061237881234`", ",", "2.14600582617363`", ",", 
          "5.98586714075779`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.73941790460485`", ",", "1.92529591443905`", ",", 
          "1.11546291108599`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.395038123217777`", ",", "1.72159888912235`", ",", 
          "2.52824398859377`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.33384364901029`", ",", "1.52412153903627`", ",", 
          "3.94102506610156`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.2726491748028`", ",", "1.32477469656212`", ",", 
          "5.35380614360934`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "6.21145470059531`", ",", "1.11471118347966`", ",", 
          "0.483401913937543`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.86707491920823`", ",", "0.879772755404284`", ",", 
          "1.89618299144533`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.80588044500074`", ",", "0.584087263341695`", ",", 
          "3.30896406895311`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.74468597079325`", ",", "2.89152132259187`", ",", 
          "4.7217451464609`"}], "}"}], ",", "0.000165453342157512`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "1.40030618940617`", ",", "2.45278634531062`", ",", 
          "6.13452622396869`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "3.33911171519868`", ",", "2.18354204132786`", ",", 
          "1.26412199429689`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "5.27791724099119`", ",", "1.95867587864968`", ",", 
          "2.67690307180467`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.933537459604115`", ",", "1.75314200857559`", ",", 
          "4.08968414931246`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.87234298539662`", ",", "1.55524308557625`", ",", 
          "5.50246522682024`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.81114851118913`", ",", "1.35672290549315`", ",", 
          "0.632060997148443`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "0.466768729802057`", ",", "1.14907500455377`", ",", 
          "2.04484207465623`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "2.40557425559457`", ",", "0.919496021669735`", ",", 
          "3.45762315216401`"}], "}"}], ",", "0.000165453342157512`"}], "}"}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "4.34437978138708`", ",", "0.638298838235053`", ",", 
          "4.8704042296718`"}], "}"}], ",", "0.000165453342157512`"}], 
       "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.528622530374494*^9, 3.528622584021846*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.4602935238750763`*^9, 3.4602935330496683`*^9}}],

Cell[CellGroupData[{

Cell["REPULSION100", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION100\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 100 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION100\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.069954584`", ",", "0.583707915`", ",", "0"}], "}"}], ",",
          "0.0100666`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.525987816`", ",", "1.510634827`", ",", "0"}], "}"}], ",",
          "0.0099546`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.46959238`", ",", "2.044565952`", ",", "0"}], "}"}], ",", 
         "0.0102281`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.648226829`", ",", "1.705570652`", ",", "0"}], "}"}], ",",
          "0.0101669`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.484505188`", ",", "2.091393136`", ",", "0"}], "}"}], ",",
          "0.0100648`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5147674096`", ",", "2.604362857`", ",", "0"}], "}"}], 
         ",", "0.0097025`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.154868701`", ",", "1.660994943`", ",", "0"}], "}"}], ",",
          "0.0100105`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.706307538`", ",", "0.8362396045`", ",", "0"}], "}"}], 
         ",", "0.0101012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.090729911`", ",", "2.075039401`", ",", "0"}], "}"}], ",",
          "0.0098344`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.622304841`", ",", "2.144468599`", ",", "0"}], "}"}], ",",
          "0.0107378`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.817052527`", ",", "0.70703288`", ",", "0"}], "}"}], ",", 
         "0.0099386`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.288855839`", ",", "2.185117317`", ",", "0"}], "}"}], ",",
          "0.010156`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.179095931`", ",", "1.435062071`", ",", "0"}], "}"}], ",",
          "0.0101396`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.95776482`", ",", "2.824710675`", ",", "0"}], "}"}], ",", 
         "0.0103499`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.278884101`", ",", "2.21370581`", ",", "0"}], "}"}], ",", 
         "0.0103743`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.98508898`", ",", "1.495293383`", ",", "0"}], "}"}], ",", 
         "0.0103172`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.410704971`", ",", "1.384814042`", ",", "0"}], "}"}], ",",
          "0.0100546`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9060353213`", ",", "1.24565894`", ",", "0"}], "}"}], ",",
          "0.0096021`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.206449089`", ",", "0.7753101603`", ",", "0"}], "}"}], 
         ",", "0.0100693`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.964488186`", ",", "0.5562364326`", ",", "0"}], "}"}], 
         ",", "0.0099325`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.198292492`", ",", "2.047724998`", ",", "0"}], "}"}], ",",
          "0.0098168`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.151971454`", ",", "1.270407709`", ",", "0"}], "}"}], ",",
          "0.0101813`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.399468899`", ",", "0.7438244206`", ",", "0"}], "}"}], 
         ",", "0.0101073`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.139847324`", ",", "1.132404525`", ",", "0"}], "}"}], ",",
          "0.0099718`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.331048144`", ",", "2.961020889`", ",", "0"}], "}"}], ",",
          "0.0099804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.560799438`", ",", "0.4863883559`", ",", "0"}], "}"}], 
         ",", "0.0097961`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.473410803`", ",", "0.1066745239`", ",", "0"}], "}"}], 
         ",", "0.0099175`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.718026394`", ",", "2.431505447`", ",", "0"}], "}"}], ",",
          "0.0100289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.537931777`", ",", "1.64518226`", ",", "0"}], "}"}], ",", 
         "0.0099321`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.861527365`", ",", "0.9054070028`", ",", "0"}], "}"}], 
         ",", "0.0097916`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.50804968`", ",", "1.703266817`", ",", "0"}], "}"}], ",", 
         "0.0100784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.517528878`", ",", "1.177748179`", ",", "0"}], "}"}], ",",
          "0.0099772`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2187595684`", ",", "1.83029188`", ",", "0"}], "}"}], ",",
          "0.0096972`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.758946668`", ",", "1.195096752`", ",", "0"}], "}"}], ",",
          "0.0096961`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.53446242`", ",", "1.471696532`", ",", "0"}], "}"}], ",", 
         "0.0098306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.347859513`", ",", "1.829506482`", ",", "0"}], "}"}], ",",
          "0.0102464`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.655060823`", ",", "1.98862815`", ",", "0"}], "}"}], ",", 
         "0.0102102`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.167188937`", ",", "0.9818698773`", ",", "0"}], "}"}], 
         ",", "0.0098975`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.753256895`", ",", "2.570171856`", ",", "0"}], "}"}], ",",
          "0.0098162`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.834234264`", ",", "1.49538065`", ",", "0"}], "}"}], ",", 
         "0.0100828`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4435056162`", ",", "2.128237037`", ",", "0"}], "}"}], 
         ",", "0.010349`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.271284222`", ",", "2.388029296`", ",", "0"}], "}"}], ",",
          "0.0095628`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9998642219`", ",", "0.64002969`", ",", "0"}], "}"}], ",",
          "0.0101851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.484972579`", ",", "1.110971882`", ",", "0"}], "}"}], ",",
          "0.0099962`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.554944889`", ",", "1.712534515`", ",", "0"}], "}"}], ",",
          "0.0100699`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.245292421`", ",", "1.424380656`", ",", "0"}], "}"}], ",",
          "0.0101281`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.793909462`", ",", "1.346242265`", ",", "0"}], "}"}], ",",
          "0.0101817`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.153852561`", ",", "1.467996434`", ",", "0"}], "}"}], ",",
          "0.0100069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2476796742`", ",", "1.078334225`", ",", "0"}], "}"}], 
         ",", "0.0102406`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.133215073`", ",", "2.303974239`", ",", "0"}], "}"}], ",",
          "0.0099453`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.138604292`", ",", "0.7478212246`", ",", "0"}], "}"}], 
         ",", "0.0100382`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.529971015`", ",", "0.79969241`", ",", "0"}], "}"}], ",", 
         "0.0101209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.837567843`", ",", "1.895846447`", ",", "0"}], "}"}], ",",
          "0.0101612`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.846818088`", ",", "2.307936136`", ",", "0"}], "}"}], ",",
          "0.0101642`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.572479539`", ",", "1.030634377`", ",", "0"}], "}"}], ",",
          "0.0101585`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.453657524`", ",", "2.613386209`", ",", "0"}], "}"}], ",",
          "0.0094319`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.357259141`", ",", "1.095752611`", ",", "0"}], "}"}], ",",
          "0.0101789`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6662445354`", ",", "0.9446943642`", ",", "0"}], "}"}], 
         ",", "0.0101354`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.023926404`", ",", "1.657050498`", ",", "0"}], "}"}], ",",
          "0.0096082`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.955255394`", ",", "2.692868503`", ",", "0"}], "}"}], ",",
          "0.0102307`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.019524326`", ",", "1.974752782`", ",", "0"}], "}"}], ",",
          "0.0096715`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.15872203`", ",", "1.833852352`", ",", "0"}], "}"}], ",", 
         "0.0097662`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.268121328`", ",", "2.592704057`", ",", "0"}], "}"}], ",",
          "0.0100939`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.653228227`", ",", "0.43621014`", ",", "0"}], "}"}], ",", 
         "0.010232`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.183344778`", ",", "2.604450123`", ",", "0"}], "}"}], ",",
          "0.0099935`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.140190482`", ",", "0.8934340441`", ",", "0"}], "}"}], 
         ",", "0.0099383`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.377421542`", ",", "0.4293859026`", ",", "0"}], "}"}], 
         ",", "0.0096039`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5467767481`", ",", "1.341477516`", ",", "0"}], "}"}], 
         ",", "0.0100993`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.010689111`", ",", "2.7511625`", ",", "0"}], "}"}], ",", 
         "0.0102088`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.34117875`", ",", "2.485540841`", ",", "0"}], "}"}], ",", 
         "0.0102143`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8497833595`", ",", "2.317360914`", ",", "0"}], "}"}], 
         ",", "0.0096917`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.053635756`", ",", "2.1723066`", ",", "0"}], "}"}], ",", 
         "0.0096741`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3162536605`", ",", "0.6837327345`", ",", "0"}], "}"}], 
         ",", "0.0101463`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9069254392`", ",", "1.602666039`", ",", "0"}], "}"}], 
         ",", "0.0098969`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.843655193`", ",", "1.285871326`", ",", "0"}], "}"}], ",",
          "0.0101668`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.269263488`", ",", "1.71473363`", ",", "0"}], "}"}], ",", 
         "0.0097658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.221032345`", ",", "1.829471575`", ",", "0"}], "}"}], ",",
          "0.0101817`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.561926206`", ",", "0.3351904828`", ",", "0"}], "}"}], 
         ",", "0.0100679`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6586872597`", ",", "2.959886425`", ",", "0"}], "}"}], 
         ",", "0.0100488`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.927758762`", ",", "1.994056124`", ",", "0"}], "}"}], ",",
          "0.0099221`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.669837853`", ",", "2.025122984`", ",", "0"}], "}"}], ",",
          "0.0101128`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.323529623`", ",", "0.3877423466`", ",", "0"}], "}"}], 
         ",", "0.0099822`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.496338521`", ",", "1.331686219`", ",", "0"}], "}"}], ",",
          "0.0096902`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.232549457`", ",", "1.072085946`", ",", "0"}], "}"}], ",",
          "0.010079`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08510225433`", ",", "2.372792571`", ",", "0"}], "}"}], 
         ",", "0.009798`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.482323527`", ",", "0.2568426527`", ",", "0"}], "}"}], 
         ",", "0.0096015`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.731318106`", ",", "1.767843999`", ",", "0"}], "}"}], ",",
          "0.0097788`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.802960024`", ",", "1.412826576`", ",", "0"}], "}"}], ",",
          "0.0095765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.590117122`", ",", "0.7973536688`", ",", "0"}], "}"}], 
         ",", "0.0101736`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1988453617`", ",", "1.45949668`", ",", "0"}], "}"}], ",",
          "0.0100594`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8474795249`", ",", "1.966497375`", ",", "0"}], "}"}], 
         ",", "0.0099938`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.736637512`", ",", "2.359196457`", ",", "0"}], "}"}], ",",
          "0.0101372`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.037731958`", ",", "1.027754583`", ",", "0"}], "}"}], ",",
          "0.0100887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.764832276`", ",", "2.31797178`", ",", "0"}], "}"}], ",", 
         "0.0098422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.356578463`", ",", "1.816172166`", ",", "0"}], "}"}], ",",
          "0.0103256`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.958992459`", ",", "1.74033761`", ",", "0"}], "}"}], ",", 
         "0.009959`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.198843301`", ",", "1.36004782`", ",", "0"}], "}"}], ",", 
         "0.0096376`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.780321043`", ",", "1.096346023`", ",", "0"}], "}"}], ",",
          "0.0099847`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.82227491`", ",", "1.694644891`", ",", "0"}], "}"}], ",", 
         "0.010044`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.937978695`", ",", "1.07613511`", ",", "0"}], "}"}], ",", 
         "0.0100003`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION150", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}, {3.4602935962308397`*^9, 3.460293596717207*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION150\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 150 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION150\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.222586498`", ",", "1.396823478`", ",", "0"}], "}"}], ",",
          "0.006625292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.574620124`", ",", "2.856669713`", ",", "0"}], "}"}], ",",
          "0.006646901`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8922065017`", ",", "1.905182021`", ",", "0"}], "}"}], 
         ",", "0.006605866`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.72490862`", ",", "1.665210908`", ",", "0"}], "}"}], ",", 
         "0.006709654`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.259128553`", ",", "1.356023457`", ",", "0"}], "}"}], ",",
          "0.006656958`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.33663078`", ",", "1.647376383`", ",", "0"}], "}"}], ",", 
         "0.006817529`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.454119295`", ",", "0.3201268777`", ",", "0"}], "}"}], 
         ",", "0.006701957`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.891783668`", ",", "2.496426547`", ",", "0"}], "}"}], ",",
          "0.00677091`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.112793491`", ",", "0.6731833711`", ",", "0"}], "}"}], 
         ",", "0.006671481`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.270260699`", ",", "2.164426282`", ",", "0"}], "}"}], ",",
          "0.006695163`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5772003153`", ",", "2.489867076`", ",", "0"}], "}"}], 
         ",", "0.006794298`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.221137317`", ",", "2.254850952`", ",", "0"}], "}"}], ",",
          "0.006632368`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.09567699483`", ",", "2.719760641`", ",", "0"}], "}"}], 
         ",", "0.006674592`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8851031163`", ",", "2.75360172`", ",", "0"}], "}"}], ",",
          "0.006742349`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.627872877`", ",", "1.521851919`", ",", "0"}], "}"}], ",",
          "0.006779786`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.685689405`", ",", "1.890470553`", ",", "0"}], "}"}], ",",
          "0.006566602`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.714165752`", ",", "0.6249335344`", ",", "0"}], "}"}], 
         ",", "0.006763159`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.096206858`", ",", "1.444348654`", ",", "0"}], "}"}], ",",
          "0.006798063`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.105451911`", ",", "1.071990285`", ",", "0"}], "}"}], ",",
          "0.006684539`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.911471847`", ",", "0.8133592979`", ",", "0"}], "}"}], 
         ",", "0.006627864`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.858298847`", ",", "2.876601739`", ",", "0"}], "}"}], ",",
          "0.006715456`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.470664692`", ",", "0.5066956458`", ",", "0"}], "}"}], 
         ",", "0.006746814`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7985046785`", ",", "2.198813038`", ",", "0"}], "}"}], 
         ",", "0.006696801`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.860992107`", ",", "0.2766102169`", ",", "0"}], "}"}], 
         ",", "0.0066898`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.397159662`", ",", "2.45126521`", ",", "0"}], "}"}], ",", 
         "0.006670153`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.859160218`", ",", "1.937048818`", ",", "0"}], "}"}], ",",
          "0.006784348`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4261855098`", ",", "1.062946338`", ",", "0"}], "}"}], 
         ",", "0.0067351`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.053185679`", ",", "1.158230564`", ",", "0"}], "}"}], ",",
          "0.006337`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.76287009`", ",", "1.14440986`", ",", "0"}], "}"}], ",", 
         "0.006746321`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.90234353`", ",", "2.009602888`", ",", "0"}], "}"}], ",", 
         "0.00673788`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.9439247`", ",", "2.051831042`", ",", "0"}], "}"}], ",", 
         "0.006767825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.865694304`", ",", "1.715862404`", ",", "0"}], "}"}], ",",
          "0.006613855`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.923291967`", ",", "1.397370063`", ",", "0"}], "}"}], ",",
          "0.006621146`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.810866156`", ",", "1.551836152`", ",", "0"}], "}"}], ",",
          "0.006672645`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.284642431`", ",", "1.955930192`", ",", "0"}], "}"}], ",",
          "0.006768816`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.044481461`", ",", "1.299110399`", ",", "0"}], "}"}], ",",
          "0.006785325`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.834533309`", ",", "1.233342466`", ",", "0"}], "}"}], ",",
          "0.006630269`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.48768674`", ",", "0.73925185`", ",", "0"}], "}"}], ",", 
         "0.006341662`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.56799126`", ",", "1.337555622`", ",", "0"}], "}"}], ",", 
         "0.006792726`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.230029238`", ",", "1.466440717`", ",", "0"}], "}"}], ",",
          "0.006650195`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.586550741`", ",", "1.839056697`", ",", "0"}], "}"}], ",",
          "0.00675502`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.950314237`", ",", "1.339722693`", ",", "0"}], "}"}], ",",
          "0.006702306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.574179385`", ",", "2.764805442`", ",", "0"}], "}"}], ",",
          "0.00669671`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.645844908`", ",", "0.7891488236`", ",", "0"}], "}"}], 
         ",", "0.006790154`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.233872269`", ",", "0.4875344439`", ",", "0"}], "}"}], 
         ",", "0.006622022`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.061077247`", ",", "2.428004509`", ",", "0"}], "}"}], ",",
          "0.006792634`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.984939021`", ",", "2.44785824`", ",", "0"}], "}"}], ",", 
         "0.006664098`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.05810928`", ",", "0.886520027`", ",", "0"}], "}"}], ",", 
         "0.006723712`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.080253205`", ",", "0.2777688363`", ",", "0"}], "}"}], 
         ",", "0.006672715`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.403572753`", ",", "0.6907821019`", ",", "0"}], "}"}], 
         ",", "0.006579597`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9465308695`", ",", "0.5856474122`", ",", "0"}], "}"}], 
         ",", "0.006535294`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.859332614`", ",", "1.617891436`", ",", "0"}], "}"}], ",",
          "0.006654216`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7809108172`", ",", "1.079185178`", ",", "0"}], "}"}], 
         ",", "0.006710478`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.060357149`", ",", "0.5792920575`", ",", "0"}], "}"}], 
         ",", "0.006671822`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.008093466`", ",", "1.89738368`", ",", "0"}], "}"}], ",", 
         "0.006693142`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6886301982`", ",", "1.626224039`", ",", "0"}], "}"}], 
         ",", "0.006668305`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.344821008`", ",", "0.8085041585`", ",", "0"}], "}"}], 
         ",", "0.006696857`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.095326148`", ",", "0.9949750136`", ",", "0"}], "}"}], 
         ",", "0.006744657`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07955366065`", ",", "3.02641869`", ",", "0"}], "}"}], 
         ",", "0.006698282`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2675758168`", ",", "1.890064939`", ",", "0"}], "}"}], 
         ",", "0.006608614`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.800755629`", ",", "2.17076619`", ",", "0"}], "}"}], ",", 
         "0.006711441`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.039051026`", ",", "1.756914084`", ",", "0"}], "}"}], ",",
          "0.006792882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.403992591`", ",", "1.060770471`", ",", "0"}], "}"}], ",",
          "0.00669296`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.653788966`", ",", "2.208905718`", ",", "0"}], "}"}], ",",
          "0.006718832`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.144107132`", ",", "0.5272046956`", ",", "0"}], "}"}], 
         ",", "0.00664828`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.055094284`", ",", "0.8684745966`", ",", "0"}], "}"}], 
         ",", "0.006631691`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.461067834`", ",", "0.8872157501`", ",", "0"}], "}"}], 
         ",", "0.006698835`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.145884733`", ",", "1.179809151`", ",", "0"}], "}"}], ",",
          "0.006759685`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.299723141`", ",", "1.470840448`", ",", "0"}], "}"}], ",",
          "0.006655039`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.72205341`", ",", "2.703756547`", ",", "0"}], "}"}], ",", 
         "0.006656016`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.89576589`", ",", "0.5793282033`", ",", "0"}], "}"}], ",",
          "0.006624127`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.487820861`", ",", "1.946877692`", ",", "0"}], "}"}], ",",
          "0.006711423`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.849635992`", ",", "2.363108577`", ",", "0"}], "}"}], ",",
          "0.006680146`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.430989406`", ",", "2.071950762`", ",", "0"}], "}"}], ",",
          "0.006723018`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.632153804`", ",", "1.354275946`", ",", "0"}], "}"}], ",",
          "0.006610697`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08748160934`", ",", "1.082151714`", ",", "0"}], "}"}], 
         ",", "0.006652229`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.764618509`", ",", "1.456188374`", ",", "0"}], "}"}], ",",
          "0.00681905`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.484277598`", ",", "1.304319125`", ",", "0"}], "}"}], ",",
          "0.006758816`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.873859887`", ",", "1.397056462`", ",", "0"}], "}"}], ",",
          "0.006604348`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.497804458`", ",", "1.623097265`", ",", "0"}], "}"}], ",",
          "0.006815704`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5784343503`", ",", "1.9136265`", ",", "0"}], "}"}], ",", 
         "0.006737249`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.746297194`", ",", "0.9427349703`", ",", "0"}], "}"}], 
         ",", "0.00670609`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.312878961`", ",", "1.79084969`", ",", "0"}], "}"}], ",", 
         "0.006627911`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.054916094`", ",", "1.115559113`", ",", "0"}], "}"}], ",",
          "0.006688582`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.515429133`", ",", "2.387078475`", ",", "0"}], "}"}], ",",
          "0.006773457`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1865459741`", ",", "0.7903595236`", ",", "0"}], "}"}], 
         ",", "0.006783252`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.451402908`", ",", "1.094552488`", ",", "0"}], "}"}], ",",
          "0.006561694`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3957693427`", ",", "1.612281215`", ",", "0"}], "}"}], 
         ",", "0.0067047`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4372921917`", ",", "2.197071182`", ",", "0"}], "}"}], 
         ",", "0.006648894`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3696106621`", ",", "0.5067641674`", ",", "0"}], "}"}], 
         ",", "0.006719302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.933493119`", ",", "2.305530217`", ",", "0"}], "}"}], ",",
          "0.006695427`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.731056229`", ",", "0.4552371959`", ",", "0"}], "}"}], 
         ",", "0.006765613`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.767949662`", ",", "1.769762936`", ",", "0"}], "}"}], ",",
          "0.006776258`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.269419067`", ",", "1.338722636`", ",", "0"}], "}"}], ",",
          "0.006599089`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.386328577`", ",", "1.337093179`", ",", "0"}], "}"}], ",",
          "0.006750539`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.524918549`", ",", "1.928196997`", ",", "0"}], "}"}], ",",
          "0.006784198`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.589802019`", ",", "2.109508851`", ",", "0"}], "}"}], ",",
          "0.006684518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8860384208`", ",", "1.355051762`", ",", "0"}], "}"}], 
         ",", "0.006641985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.097957424`", ",", "2.621259913`", ",", "0"}], "}"}], ",",
          "0.006756818`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.481688612`", ",", "2.604420662`", ",", "0"}], "}"}], ",",
          "0.006637241`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.09159000968`", ",", "2.136417116`", ",", "0"}], "}"}], 
         ",", "0.006340348`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.474456421`", ",", "1.635803558`", ",", "0"}], "}"}], ",",
          "0.006631706`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.427763802`", ",", "1.004893545`", ",", "0"}], "}"}], ",",
          "0.006749255`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.026273225`", ",", "2.207051672`", ",", "0"}], "}"}], ",",
          "0.006652159`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.150205889`", ",", "2.094074311`", ",", "0"}], "}"}], ",",
          "0.006691087`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.709678964`", ",", "1.832101507`", ",", "0"}], "}"}], ",",
          "0.00672486`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2487135025`", ",", "1.347590113`", ",", "0"}], "}"}], 
         ",", "0.006792415`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.121041358`", ",", "1.128375974`", ",", "0"}], "}"}], ",",
          "0.006666927`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.228656135`", ",", "1.793930266`", ",", "0"}], "}"}], ",",
          "0.006644224`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.574420764`", ",", "1.359069755`", ",", "0"}], "}"}], ",",
          "0.006744281`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9838388879`", ",", "1.627019159`", ",", "0"}], "}"}], 
         ",", "0.006361322`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08690472566`", ",", "1.646860254`", ",", "0"}], "}"}], 
         ",", "0.00668799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.816012878`", ",", "0.9095829648`", ",", "0"}], "}"}], 
         ",", "0.006636826`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.055996218`", ",", "1.937116258`", ",", "0"}], "}"}], ",",
          "0.006685085`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.959262976`", ",", "2.60807491`", ",", "0"}], "}"}], ",", 
         "0.006473165`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.607794566`", ",", "0.2995900247`", ",", "0"}], "}"}], 
         ",", "0.006619731`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.433481379`", ",", "2.263194429`", ",", "0"}], "}"}], ",",
          "0.006645181`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.526390499`", ",", "2.452588292`", ",", "0"}], "}"}], ",",
          "0.006599867`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.427769264`", ",", "2.377307127`", ",", "0"}], "}"}], ",",
          "0.006416768`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.762802005`", ",", "0.8424481072`", ",", "0"}], "}"}], 
         ",", "0.006583765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.163182568`", ",", "1.632832537`", ",", "0"}], "}"}], ",",
          "0.006728872`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.77528172`", ",", "2.084314971`", ",", "0"}], "}"}], ",", 
         "0.006576466`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.137041655`", ",", "1.60011339`", ",", "0"}], "}"}], ",", 
         "0.006348666`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.088440335`", ",", "0.8227656452`", ",", "0"}], "}"}], 
         ",", "0.006661306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.568053733`", ",", "1.365325486`", ",", "0"}], "}"}], ",",
          "0.006412278`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.73691624`", ",", "1.085731559`", ",", "0"}], "}"}], ",", 
         "0.006649344`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.197324996`", ",", "1.881561433`", ",", "0"}], "}"}], ",",
          "0.006634651`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6203676484`", ",", "0.7994411873`", ",", "0"}], "}"}], 
         ",", "0.006728176`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.372452564`", ",", "1.179138369`", ",", "0"}], "}"}], ",",
          "0.006734156`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.186177551`", ",", "1.901105612`", ",", "0"}], "}"}], ",",
          "0.006631956`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.476554027`", ",", "2.663146698`", ",", "0"}], "}"}], ",",
          "0.006688674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.034099789`", ",", "1.618175436`", ",", "0"}], "}"}], ",",
          "0.006789355`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.696358358`", ",", "1.206466525`", ",", "0"}], "}"}], ",",
          "0.006688507`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.800902839`", ",", "2.379575532`", ",", "0"}], "}"}], ",",
          "0.00635126`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.03720506`", ",", "1.648892795`", ",", "0"}], "}"}], ",", 
         "0.006689712`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.139004845`", ",", "2.586490231`", ",", "0"}], "}"}], ",",
          "0.006634188`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.237846349`", ",", "0.03140795038`", ",", "0"}], "}"}], 
         ",", "0.006462203`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.209973798`", ",", "0.8049437566`", ",", "0"}], "}"}], 
         ",", "0.006787009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.349946342`", ",", "1.899981044`", ",", "0"}], "}"}], ",",
          "0.006704437`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.590478466`", ",", "0.600990654`", ",", "0"}], "}"}], ",",
          "0.006441301`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.583857978`", ",", "2.141760511`", ",", "0"}], "}"}], ",",
          "0.006760948`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.430754493`", ",", "1.634679479`", ",", "0"}], "}"}], ",",
          "0.006659133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.175856888`", ",", "2.15654406`", ",", "0"}], "}"}], ",", 
         "0.00662012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.02377518`", ",", "0.297374207`", ",", "0"}], "}"}], ",", 
         "0.006654808`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.741132232`", ",", "1.080682827`", ",", "0"}], "}"}], ",",
          "0.006691989`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.321623017`", ",", "2.950147505`", ",", "0"}], "}"}], ",",
          "0.006535039`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.09408612721`", ",", "2.427527371`", ",", "0"}], "}"}], 
         ",", "0.006638453`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.556473867`", ",", "1.629828127`", ",", "0"}], "}"}], ",",
          "0.006380591`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.434033068`", ",", "1.029389782`", ",", "0"}], "}"}], ",",
          "0.006552852`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.143866146`", ",", "2.236139522`", ",", "0"}], "}"}], ",",
          "0.006658451`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.4602936022416773`*^9, 3.460293622146411*^9}, 3.4602939406962767`*^9, {
   3.502932930937633*^9, 3.502932947534665*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION168", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}, {3.4602935962308397`*^9, 3.460293596717207*^9}, {
  3.460293631081135*^9, 3.4602936314554462`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION168\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 168 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION168\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.017527153`", ",", "0.926011749`", ",", "0"}], "}"}], ",",
          "0.006044092`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.71047603`", ",", "2.495929076`", ",", "0"}], "}"}], ",", 
         "0.005817486`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.743632599`", ",", "2.471774731`", ",", "0"}], "}"}], ",",
          "0.005725454`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.490880719`", ",", "0.9192474463`", ",", "0"}], "}"}], 
         ",", "0.005922829`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5371822019`", ",", "0.1625336121`", ",", "0"}], "}"}], 
         ",", "0.006005017`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.172792883`", ",", "2.595830151`", ",", "0"}], "}"}], ",",
          "0.00593147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.335640044`", ",", "0.4476994853`", ",", "0"}], "}"}], 
         ",", "0.00600854`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.825716089`", ",", "1.226251857`", ",", "0"}], "}"}], ",",
          "0.005912534`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.896570505`", ",", "2.66019662`", ",", "0"}], "}"}], ",", 
         "0.006019145`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8264315173`", ",", "2.20630975`", ",", "0"}], "}"}], ",",
          "0.005939187`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.793121795`", ",", "2.463653278`", ",", "0"}], "}"}], ",",
          "0.005732195`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.813397694`", ",", "2.962157203`", ",", "0"}], "}"}], ",",
          "0.006028365`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.825200912`", ",", "0.9146352043`", ",", "0"}], "}"}], 
         ",", "0.006048978`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.169770192`", ",", "0.996429955`", ",", "0"}], "}"}], ",",
          "0.005671388`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.48516953`", ",", "1.649166497`", ",", "0"}], "}"}], ",", 
         "0.005895471`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.834614589`", ",", "0.6327219964`", ",", "0"}], "}"}], 
         ",", "0.005984225`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.206706428`", ",", "1.729207419`", ",", "0"}], "}"}], ",",
          "0.005915566`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.151641605`", ",", "0.9987903382`", ",", "0"}], "}"}], 
         ",", "0.005895051`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.757219997`", ",", "2.23104693`", ",", "0"}], "}"}], ",", 
         "0.005762906`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4705121778`", ",", "2.319314112`", ",", "0"}], "}"}], 
         ",", "0.006046104`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.948282193`", ",", "0.6353341434`", ",", "0"}], "}"}], 
         ",", "0.006052974`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.236460243`", ",", "2.526952076`", ",", "0"}], "}"}], ",",
          "0.005903124`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.082305939`", ",", "2.441393575`", ",", "0"}], "}"}], ",",
          "0.005767506`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.669502584`", ",", "2.552513558`", ",", "0"}], "}"}], ",",
          "0.005954144`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.082708037`", ",", "0.4148021408`", ",", "0"}], "}"}], 
         ",", "0.005656131`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.61897415`", ",", "2.205726025`", ",", "0"}], "}"}], ",", 
         "0.005946203`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.964763136`", ",", "2.054684062`", ",", "0"}], "}"}], ",",
          "0.00601036`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08318766304`", ",", "2.336601284`", ",", "0"}], "}"}], 
         ",", "0.006075555`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.394707406`", ",", "1.460716386`", ",", "0"}], "}"}], ",",
          "0.006044313`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.353532976`", ",", "1.222922327`", ",", "0"}], "}"}], ",",
          "0.005919555`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.336635536`", ",", "1.372539001`", ",", "0"}], "}"}], ",",
          "0.0059533`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.48161426`", ",", "2.293769037`", ",", "0"}], "}"}], ",", 
         "0.006117573`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.772285268`", ",", "0.3638673944`", ",", "0"}], "}"}], 
         ",", "0.006054297`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.507769049`", ",", "2.011782543`", ",", "0"}], "}"}], ",",
          "0.005953104`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.479964541`", ",", "0.911987854`", ",", "0"}], "}"}], ",",
          "0.006028037`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07672062475`", ",", "0.7486259959`", ",", "0"}], "}"}], 
         ",", "0.005988963`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.847712429`", ",", "1.990384003`", ",", "0"}], "}"}], ",",
          "0.005999687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.055096318`", ",", "0.4406699623`", ",", "0"}], "}"}], 
         ",", "0.006034258`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.891149669`", ",", "1.489865933`", ",", "0"}], "}"}], ",",
          "0.005993765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.278739238`", ",", "2.209008029`", ",", "0"}], "}"}], ",",
          "0.005912503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9478943556`", ",", "1.689509888`", ",", "0"}], "}"}], 
         ",", "0.005937777`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.615844566`", ",", "0.3522186132`", ",", "0"}], "}"}], 
         ",", "0.006089744`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.2782081`", ",", "1.996903768`", ",", "0"}], "}"}], ",", 
         "0.005911112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.303920072`", ",", "2.467848438`", ",", "0"}], "}"}], ",",
          "0.005887086`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8781934102`", ",", "0.4279662867`", ",", "0"}], "}"}], 
         ",", "0.005952613`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.949353957`", ",", "0.7038094837`", ",", "0"}], "}"}], 
         ",", "0.005722011`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.466904258`", ",", "1.119268689`", ",", "0"}], "}"}], ",",
          "0.006008964`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3601719913`", ",", "1.792519203`", ",", "0"}], "}"}], 
         ",", "0.006028355`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.68109281`", ",", "1.455728549`", ",", "0"}], "}"}], ",", 
         "0.006038387`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.38010297`", ",", "2.263291539`", ",", "0"}], "}"}], ",", 
         "0.006050685`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.980717951`", ",", "1.960435532`", ",", "0"}], "}"}], ",",
          "0.00572719`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.459128153`", ",", "0.6272093216`", ",", "0"}], "}"}], 
         ",", "0.005932472`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4208137005`", ",", "2.603880936`", ",", "0"}], "}"}], 
         ",", "0.005969826`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.0610514078`", ",", "1.792330689`", ",", "0"}], "}"}], 
         ",", "0.006019243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.345667475`", ",", "1.748714231`", ",", "0"}], "}"}], ",",
          "0.006069228`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.874266218`", ",", "3.038202752`", ",", "0"}], "}"}], ",",
          "0.006033507`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.09776369303`", ",", "2.886631605`", ",", "0"}], "}"}], 
         ",", "0.006036482`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.321881369`", ",", "1.475528996`", ",", "0"}], "}"}], ",",
          "0.005674166`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.841781015`", ",", "2.226725879`", ",", "0"}], "}"}], ",",
          "0.006116912`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.272039356`", ",", "1.198556256`", ",", "0"}], "}"}], ",",
          "0.005948623`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.205389281`", ",", "0.9246549301`", ",", "0"}], "}"}], 
         ",", "0.006018825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.586919094`", ",", "1.992821216`", ",", "0"}], "}"}], ",",
          "0.005860892`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.338898408`", ",", "2.524387821`", ",", "0"}], "}"}], ",",
          "0.005955374`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.564899583`", ",", "1.34198258`", ",", "0"}], "}"}], ",", 
         "0.005917009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.06044930411`", ",", "1.312767897`", ",", "0"}], "}"}], 
         ",", "0.005677687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3982940488`", ",", "0.9531637664`", ",", "0"}], "}"}], 
         ",", "0.005994395`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.548547768`", ",", "1.046672102`", ",", "0"}], "}"}], ",",
          "0.006053294`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.482806983`", ",", "2.850631589`", ",", "0"}], "}"}], ",",
          "0.00607432`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8732146316`", ",", "2.480144999`", ",", "0"}], "}"}], 
         ",", "0.005936174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.06182680522`", ",", "1.029828942`", ",", "0"}], "}"}], 
         ",", "0.005930702`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.376077517`", ",", "0.6381763074`", ",", "0"}], "}"}], 
         ",", "0.005990022`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.559422086`", ",", "1.185998735`", ",", "0"}], "}"}], ",",
          "0.005977139`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.054119212`", ",", "1.736922734`", ",", "0"}], "}"}], ",",
          "0.00601228`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.257217156`", ",", "0.8806329267`", ",", "0"}], "}"}], 
         ",", "0.00604234`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.175398459`", ",", "2.574553034`", ",", "0"}], "}"}], ",",
          "0.005976389`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.237397285`", ",", "1.713534048`", ",", "0"}], "}"}], ",",
          "0.006042343`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.709798214`", ",", "1.879539452`", ",", "0"}], "}"}], ",",
          "0.005913561`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.745341984`", ",", "1.737032079`", ",", "0"}], "}"}], ",",
          "0.005999378`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.082761951`", ",", "1.973533146`", ",", "0"}], "}"}], ",",
          "0.005924403`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.629456249`", ",", "1.400191143`", ",", "0"}], "}"}], ",",
          "0.006048262`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.630570537`", ",", "1.71192948`", ",", "0"}], "}"}], ",", 
         "0.005947285`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.140867609`", ",", "0.7186256885`", ",", "0"}], "}"}], 
         ",", "0.005930645`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.134152054`", ",", "0.9451945058`", ",", "0"}], "}"}], 
         ",", "0.00591905`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.843513054`", ",", "0.9478399886`", ",", "0"}], "}"}], 
         ",", "0.005918835`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.811509344`", ",", "0.3488680348`", ",", "0"}], "}"}], 
         ",", "0.00591836`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.540943167`", ",", "1.929270025`", ",", "0"}], "}"}], ",",
          "0.006016988`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.407949681`", ",", "1.943133438`", ",", "0"}], "}"}], ",",
          "0.005930342`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.997805178`", ",", "2.232193559`", ",", "0"}], "}"}], ",",
          "0.006133468`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.243800121`", ",", "0.7312779293`", ",", "0"}], "}"}], 
         ",", "0.005892199`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.139129776`", ",", "1.267984354`", ",", "0"}], "}"}], ",",
          "0.005674799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.26356909`", ",", "1.199018629`", ",", "0"}], "}"}], ",", 
         "0.005926646`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.001801737`", ",", "2.262696068`", ",", "0"}], "}"}], ",",
          "0.005926342`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.031037408`", ",", "1.24344972`", ",", "0"}], "}"}], ",", 
         "0.005899429`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.305342717`", ",", "1.494155725`", ",", "0"}], "}"}], ",",
          "0.005866215`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.562763727`", ",", "2.746989365`", ",", "0"}], "}"}], ",",
          "0.005955875`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.53330956`", ",", "2.45321209`", ",", "0"}], "}"}], ",", 
         "0.005968276`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.452002803`", ",", "0.4755573837`", ",", "0"}], "}"}], 
         ",", "0.005921743`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.772043287`", ",", "1.546596272`", ",", "0"}], "}"}], ",",
          "0.006011898`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.139769666`", ",", "1.723448181`", ",", "0"}], "}"}], ",",
          "0.005944255`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.098730509`", ",", "1.44522898`", ",", "0"}], "}"}], ",", 
         "0.006012327`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.19667905`", ",", "1.486247255`", ",", "0"}], "}"}], ",", 
         "0.00601993`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.767926536`", ",", "1.436435505`", ",", "0"}], "}"}], ",",
          "0.006000205`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.082996496`", ",", "1.990265461`", ",", "0"}], "}"}], ",",
          "0.005931643`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.690000787`", ",", "0.6757152504`", ",", "0"}], "}"}], 
         ",", "0.006021255`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9981394002`", ",", "2.77597143`", ",", "0"}], "}"}], ",",
          "0.006029492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.484688815`", ",", "1.47007533`", ",", "0"}], "}"}], ",", 
         "0.005950188`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1818129902`", ",", "0.4594716788`", ",", "0"}], "}"}], 
         ",", "0.005964741`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.96044089`", ",", "1.164560053`", ",", "0"}], "}"}], ",", 
         "0.00602538`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.205393488`", ",", "2.067773351`", ",", "0"}], "}"}], ",",
          "0.006032517`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.875421198`", ",", "0.9478438807`", ",", "0"}], "}"}], 
         ",", "0.005982511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.276708521`", ",", "2.183791303`", ",", "0"}], "}"}], ",",
          "0.005979643`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.97238273`", ",", "1.488804843`", ",", "0"}], "}"}], ",", 
         "0.005902494`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.965430376`", ",", "1.75556313`", ",", "0"}], "}"}], ",", 
         "0.005919982`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.186296687`", ",", "1.536420758`", ",", "0"}], "}"}], ",",
          "0.005920405`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.930274575`", ",", "2.343751357`", ",", "0"}], "}"}], ",",
          "0.005967188`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.210353914`", ",", "2.018076462`", ",", "0"}], "}"}], ",",
          "0.005971305`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.598086164`", ",", "1.479393155`", ",", "0"}], "}"}], ",",
          "0.006023514`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2165193336`", ",", "1.546506806`", ",", "0"}], "}"}], 
         ",", "0.005944449`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4878870702`", ",", "1.47307597`", ",", "0"}], "}"}], ",",
          "0.005947764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.732815128`", ",", "1.216821982`", ",", "0"}], "}"}], ",",
          "0.006001207`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.244375145`", ",", "1.906251751`", ",", "0"}], "}"}], ",",
          "0.005935635`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.758571448`", ",", "1.699212208`", ",", "0"}], "}"}], ",",
          "0.006011176`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.655301687`", ",", "0.1756858199`", ",", "0"}], "}"}], 
         ",", "0.006003314`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.925732574`", ",", "1.694253448`", ",", "0"}], "}"}], ",",
          "0.005952903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.635040386`", ",", "2.165055019`", ",", "0"}], "}"}], ",",
          "0.006001686`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.6516257`", ",", "1.1758028`", ",", "0"}], "}"}], ",", 
         "0.006035115`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7547249792`", ",", "0.9466865179`", ",", "0"}], "}"}], 
         ",", "0.005933952`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.576178834`", ",", "0.6344494186`", ",", "0"}], "}"}], 
         ",", "0.006045422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.839011178`", ",", "0.8997991028`", ",", "0"}], "}"}], 
         ",", "0.005978134`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.607189714`", ",", "2.778656305`", ",", "0"}], "}"}], ",",
          "0.005997748`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.035841015`", ",", "1.766086767`", ",", "0"}], "}"}], ",",
          "0.005940935`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.945608532`", ",", "0.6790989028`", ",", "0"}], "}"}], 
         ",", "0.005909873`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.13565616`", ",", "1.147201409`", ",", "0"}], "}"}], ",", 
         "0.006016876`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.815256828`", ",", "1.721086349`", ",", "0"}], "}"}], ",",
          "0.005913162`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.213910912`", ",", "1.630498944`", ",", "0"}], "}"}], ",",
          "0.005698082`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.791641651`", ",", "1.949569287`", ",", "0"}], "}"}], ",",
          "0.005751434`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6301150505`", ",", "1.205534816`", ",", "0"}], "}"}], 
         ",", "0.005933631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.381864104`", ",", "1.985699592`", ",", "0"}], "}"}], ",",
          "0.005959533`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.524560748`", ",", "0.7602084546`", ",", "0"}], "}"}], 
         ",", "0.006072184`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7908166951`", ",", "1.928805105`", ",", "0"}], "}"}], 
         ",", "0.005675341`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.502772739`", ",", "0.9514976577`", ",", "0"}], "}"}], 
         ",", "0.005948214`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.190787499`", ",", "2.251041876`", ",", "0"}], "}"}], ",",
          "0.006076796`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.226845085`", ",", "2.717453089`", ",", "0"}], "}"}], ",",
          "0.005990603`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.071706921`", ",", "1.217948767`", ",", "0"}], "}"}], ",",
          "0.005934457`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.780654331`", ",", "1.155485527`", ",", "0"}], "}"}], ",",
          "0.005998351`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9458313415`", ",", "1.192692491`", ",", "0"}], "}"}], 
         ",", "0.006000336`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5164061516`", ",", "2.036564595`", ",", "0"}], "}"}], 
         ",", "0.005900635`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.176271586`", ",", "2.030736173`", ",", "0"}], "}"}], ",",
          "0.005934539`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.029598627`", ",", "1.425421082`", ",", "0"}], "}"}], ",",
          "0.005914009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.79378584`", ",", "2.750923791`", ",", "0"}], "}"}], ",", 
         "0.005971793`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.111867689`", ",", "2.290795834`", ",", "0"}], "}"}], ",",
          "0.006033596`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.050153711`", ",", "1.434657556`", ",", "0"}], "}"}], ",",
          "0.005883431`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.689749486`", ",", "1.99399776`", ",", "0"}], "}"}], ",", 
         "0.005897019`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.634240746`", ",", "0.1618465981`", ",", "0"}], "}"}], 
         ",", "0.005910325`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5110106058`", ",", "0.6821564927`", ",", "0"}], "}"}], 
         ",", "0.005905557`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.054379729`", ",", "0.6536845527`", ",", "0"}], "}"}], 
         ",", "0.00599589`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.852588234`", ",", "1.200687007`", ",", "0"}], "}"}], ",",
          "0.005962181`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.911207717`", ",", "1.457450195`", ",", "0"}], "}"}], ",",
          "0.006066621`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.528237573`", ",", "1.724511366`", ",", "0"}], "}"}], ",",
          "0.006043506`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6328205377`", ",", "1.704710763`", ",", "0"}], "}"}], 
         ",", "0.005907828`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.910784554`", ",", "1.98603864`", ",", "0"}], "}"}], ",", 
         "0.005873159`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.657856333`", ",", "0.876820412`", ",", "0"}], "}"}], ",",
          "0.006015616`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.445555749`", ",", "1.741182699`", ",", "0"}], "}"}], ",",
          "0.005955805`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.519029381`", ",", "1.66910458`", ",", "0"}], "}"}], ",", 
         "0.0058997`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.563039822`", ",", "2.244608924`", ",", "0"}], "}"}], ",",
          "0.005990458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.433137662`", ",", "1.223006068`", ",", "0"}], "}"}], ",",
          "0.005915798`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3320073688`", ",", "1.231080013`", ",", "0"}], "}"}], 
         ",", "0.005858341`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7915254733`", ",", "1.449277079`", ",", "0"}], "}"}], 
         ",", "0.00602798`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.4602936022416773`*^9, 3.4602936567066717`*^9}, 3.4602939476352863`*^9, {
   3.502932951959774*^9, 3.502932959058712*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION232", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}, {3.4602935962308397`*^9, 3.460293596717207*^9}, {
  3.460293631081135*^9, 3.4602936314554462`*^9}, {3.4602936672512913`*^9, 
  3.460293667593327*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION232\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 232 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION232\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.421729308`", ",", "1.132260274`", ",", "0"}], "}"}], ",",
          "0.004081089`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3423617964`", ",", "2.101849107`", ",", "0"}], "}"}], 
         ",", "0.004339872`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.163346909`", ",", "2.214180313`", ",", "0"}], "}"}], ",",
          "0.004274123`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.009006946`", ",", "2.530564384`", ",", "0"}], "}"}], ",",
          "0.004274258`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.360676085`", ",", "2.850943811`", ",", "0"}], "}"}], ",",
          "0.004344168`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.26007721`", ",", "0.3840636813`", ",", "0"}], "}"}], ",",
          "0.004349566`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.955647588`", ",", "0.345019671`", ",", "0"}], "}"}], ",",
          "0.004275969`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.438460741`", ",", "0.7571778824`", ",", "0"}], "}"}], 
         ",", "0.004337812`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.390029914`", ",", "0.1279793392`", ",", "0"}], "}"}], 
         ",", "0.00427794`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.484741436`", ",", "1.746449003`", ",", "0"}], "}"}], ",",
          "0.0043495`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.099358591`", ",", "1.371864414`", ",", "0"}], "}"}], ",",
          "0.004244188`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4697245806`", ",", "1.229379103`", ",", "0"}], "}"}], 
         ",", "0.004325962`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.170329604`", ",", "1.065783231`", ",", "0"}], "}"}], ",",
          "0.004264148`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.917536613`", ",", "1.534093292`", ",", "0"}], "}"}], ",",
          "0.004343116`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.364705815`", ",", "1.426131832`", ",", "0"}], "}"}], ",",
          "0.004251575`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.164847246`", ",", "1.632183082`", ",", "0"}], "}"}], ",",
          "0.004312683`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.191338071`", ",", "0.3709336566`", ",", "0"}], "}"}], 
         ",", "0.004359122`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.949646404`", ",", "1.026108808`", ",", "0"}], "}"}], ",",
          "0.00431302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.74355769`", ",", "1.745451425`", ",", "0"}], "}"}], ",", 
         "0.004228174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.750171188`", ",", "2.786344847`", ",", "0"}], "}"}], ",",
          "0.004135978`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.22379726`", ",", "0.941055632`", ",", "0"}], "}"}], ",", 
         "0.004289184`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.862959695`", ",", "0.6516613844`", ",", "0"}], "}"}], 
         ",", "0.004339347`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6842514812`", ",", "0.992225003`", ",", "0"}], "}"}], 
         ",", "0.004368133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.760000699`", ",", "2.113126569`", ",", "0"}], "}"}], ",",
          "0.004348266`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.559360248`", ",", "0.442127958`", ",", "0"}], "}"}], ",",
          "0.004340885`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.129666741`", ",", "2.32155049`", ",", "0"}], "}"}], ",", 
         "0.004388939`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.127811019`", ",", "2.24379848`", ",", "0"}], "}"}], ",", 
         "0.004310623`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.331048798`", ",", "2.96840358`", ",", "0"}], "}"}], ",", 
         "0.004281896`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4916170831`", ",", "1.880484547`", ",", "0"}], "}"}], 
         ",", "0.004336488`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.294109917`", ",", "2.14621679`", ",", "0"}], "}"}], ",", 
         "0.004270398`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.548489675`", ",", "1.942825841`", ",", "0"}], "}"}], ",",
          "0.00435783`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.462651589`", ",", "0.3254423128`", ",", "0"}], "}"}], 
         ",", "0.004249637`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.22719519`", ",", "1.122941734`", ",", "0"}], "}"}], ",", 
         "0.004381245`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.528442482`", ",", "1.860540129`", ",", "0"}], "}"}], ",",
          "0.004321798`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.395570662`", ",", "2.41950383`", ",", "0"}], "}"}], ",", 
         "0.004319265`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.769049603`", ",", "0.7659699785`", ",", "0"}], "}"}], 
         ",", "0.004307412`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.06615825`", ",", "1.854338642`", ",", "0"}], "}"}], ",", 
         "0.004372238`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.949016034`", ",", "1.123777939`", ",", "0"}], "}"}], ",",
          "0.004329245`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.694388527`", ",", "2.521211985`", ",", "0"}], "}"}], ",",
          "0.004257346`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.816928207`", ",", "2.171862711`", ",", "0"}], "}"}], ",",
          "0.004244763`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2819963204`", ",", "1.42304979`", ",", "0"}], "}"}], ",",
          "0.004357057`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2302135535`", ",", "2.55864558`", ",", "0"}], "}"}], ",",
          "0.004354232`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.133893117`", ",", "0.139914494`", ",", "0"}], "}"}], ",",
          "0.004250305`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3986916173`", ",", "1.005955229`", ",", "0"}], "}"}], 
         ",", "0.004303416`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.338125218`", ",", "2.049899783`", ",", "0"}], "}"}], ",",
          "0.004340808`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7702860032`", ",", "1.889744235`", ",", "0"}], "}"}], 
         ",", "0.004318098`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.355688738`", ",", "1.775780326`", ",", "0"}], "}"}], ",",
          "0.004307467`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.46772177`", ",", "0.6759492467`", ",", "0"}], "}"}], ",",
          "0.004293949`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.484273671`", ",", "2.820558519`", ",", "0"}], "}"}], ",",
          "0.004289014`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.627759588`", ",", "0.9789512505`", ",", "0"}], "}"}], 
         ",", "0.004341188`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.261482785`", ",", "1.17313023`", ",", "0"}], "}"}], ",", 
         "0.004264777`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.220349396`", ",", "2.171866393`", ",", "0"}], "}"}], ",",
          "0.004357168`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.389461556`", ",", "1.148331353`", ",", "0"}], "}"}], ",",
          "0.00417057`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.601448584`", ",", "1.969108719`", ",", "0"}], "}"}], ",",
          "0.004284169`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.53259723`", ",", "1.839989313`", ",", "0"}], "}"}], ",", 
         "0.004301224`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.128506681`", ",", "2.621617897`", ",", "0"}], "}"}], ",",
          "0.004353218`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4864054776`", ",", "0.3300878906`", ",", "0"}], "}"}], 
         ",", "0.004288353`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.792232541`", ",", "1.880699205`", ",", "0"}], "}"}], ",",
          "0.004352899`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.430971725`", ",", "2.2816076`", ",", "0"}], "}"}], ",", 
         "0.004228707`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.257763645`", ",", "1.822463834`", ",", "0"}], "}"}], ",",
          "0.00437167`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.976175985`", ",", "1.237277712`", ",", "0"}], "}"}], ",",
          "0.0043019`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.473958182`", ",", "2.179249834`", ",", "0"}], "}"}], ",",
          "0.004339676`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.135626237`", ",", "0.9546764258`", ",", "0"}], "}"}], 
         ",", "0.004360433`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.712527115`", ",", "2.364567358`", ",", "0"}], "}"}], ",",
          "0.00428604`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1328902245`", ",", "1.627303665`", ",", "0"}], "}"}], 
         ",", "0.004397599`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.496240687`", ",", "3.017612998`", ",", "0"}], "}"}], ",",
          "0.004231225`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.614657349`", ",", "2.748077142`", ",", "0"}], "}"}], ",",
          "0.004286545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.575807114`", ",", "2.571679943`", ",", "0"}], "}"}], ",",
          "0.004331554`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.29346795`", ",", "1.91057179`", ",", "0"}], "}"}], ",", 
         "0.00431981`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6228922672`", ",", "2.090080509`", ",", "0"}], "}"}], 
         ",", "0.004269078`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.797214417`", ",", "1.92715233`", ",", "0"}], "}"}], ",", 
         "0.004366135`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9563213463`", ",", "0.7726034165`", ",", "0"}], "}"}], 
         ",", "0.004275128`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.079600164`", ",", "0.5772012403`", ",", "0"}], "}"}], 
         ",", "0.004368703`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.025665554`", ",", "1.770527775`", ",", "0"}], "}"}], ",",
          "0.004275695`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.70177141`", ",", "1.670057093`", ",", "0"}], "}"}], ",", 
         "0.004405979`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.836065063`", ",", "1.634676355`", ",", "0"}], "}"}], ",",
          "0.004354595`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6562210746`", ",", "2.531410677`", ",", "0"}], "}"}], 
         ",", "0.004277433`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.306517795`", ",", "2.385585294`", ",", "0"}], "}"}], ",",
          "0.004143833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.980765467`", ",", "1.530690633`", ",", "0"}], "}"}], ",",
          "0.004378231`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.277082965`", ",", "2.394617076`", ",", "0"}], "}"}], ",",
          "0.004252511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.879642355`", ",", "0.2171896797`", ",", "0"}], "}"}], 
         ",", "0.004334839`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.767931536`", ",", "1.648170996`", ",", "0"}], "}"}], ",",
          "0.004356377`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.240595077`", ",", "1.660912999`", ",", "0"}], "}"}], ",",
          "0.00440057`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.05839142`", ",", "1.36020729`", ",", "0"}], "}"}], ",", 
         "0.004360578`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.135612972`", ",", "2.757844528`", ",", "0"}], "}"}], ",",
          "0.004362879`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.328357335`", ",", "2.881021314`", ",", "0"}], "}"}], ",",
          "0.004288151`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.087085166`", ",", "2.661032266`", ",", "0"}], "}"}], ",",
          "0.004222218`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.76196559`", ",", "0.8781864463`", ",", "0"}], "}"}], ",",
          "0.004346339`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.293239164`", ",", "1.892172057`", ",", "0"}], "}"}], ",",
          "0.004425584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5252283372`", ",", "1.457694628`", ",", "0"}], "}"}], 
         ",", "0.00427521`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.474196942`", ",", "1.615343622`", ",", "0"}], "}"}], ",",
          "0.004370673`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.906731602`", ",", "1.00972158`", ",", "0"}], "}"}], ",", 
         "0.004337301`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.284826441`", ",", "2.496800553`", ",", "0"}], "}"}], ",",
          "0.00432446`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.508080547`", ",", "2.57999176`", ",", "0"}], "}"}], ",", 
         "0.004319038`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.829422889`", ",", "2.42941847`", ",", "0"}], "}"}], ",", 
         "0.00433454`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.932792178`", ",", "1.293681046`", ",", "0"}], "}"}], ",",
          "0.004272301`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07709702246`", ",", "0.9639405462`", ",", "0"}], "}"}], 
         ",", "0.004290871`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.123093289`", ",", "0.6105151601`", ",", "0"}], "}"}], 
         ",", "0.004380613`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.058432567`", ",", "1.997084235`", ",", "0"}], "}"}], ",",
          "0.004362055`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.702225475`", ",", "0.8890002097`", ",", "0"}], "}"}], 
         ",", "0.004308915`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.772095403`", ",", "1.227114276`", ",", "0"}], "}"}], ",",
          "0.004331717`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3366734193`", ",", "0.5583800111`", ",", "0"}], "}"}], 
         ",", "0.004276152`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.606074274`", ",", "0.5386968161`", ",", "0"}], "}"}], 
         ",", "0.004362245`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.049788823`", ",", "2.376295831`", ",", "0"}], "}"}], ",",
          "0.004274706`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.935792381`", ",", "2.116336788`", ",", "0"}], "}"}], ",",
          "0.004283799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.588188742`", ",", "2.626853222`", ",", "0"}], "}"}], ",",
          "0.00428998`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.19948409`", ",", "1.430514022`", ",", "0"}], "}"}], ",", 
         "0.004354472`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.33547902`", ",", "0.9801904168`", ",", "0"}], "}"}], ",",
          "0.004241159`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8913090185`", ",", "1.683367149`", ",", "0"}], "}"}], 
         ",", "0.004302537`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.959151693`", ",", "1.700942998`", ",", "0"}], "}"}], ",",
          "0.004378493`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.033094654`", ",", "2.031083982`", ",", "0"}], "}"}], ",",
          "0.004306668`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.431820121`", ",", "1.383950872`", ",", "0"}], "}"}], ",",
          "0.00432455`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.099630994`", ",", "2.606931283`", ",", "0"}], "}"}], ",",
          "0.004263447`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.272097973`", ",", "0.627871133`", ",", "0"}], "}"}], ",",
          "0.004352521`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5327100924`", ",", "2.775336253`", ",", "0"}], "}"}], 
         ",", "0.004341122`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.108674225`", ",", "1.509030783`", ",", "0"}], "}"}], ",",
          "0.004354158`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.543160617`", ",", "2.02071697`", ",", "0"}], "}"}], ",", 
         "0.004315482`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.140184295`", ",", "0.8214003614`", ",", "0"}], "}"}], 
         ",", "0.004374365`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.215590024`", ",", "1.367346211`", ",", "0"}], "}"}], ",",
          "0.004313241`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.859726848`", ",", "1.46956086`", ",", "0"}], "}"}], ",", 
         "0.00439417`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.010169492`", ",", "2.26901292`", ",", "0"}], "}"}], ",", 
         "0.004248821`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.101623452`", ",", "2.511373634`", ",", "0"}], "}"}], ",",
          "0.004351005`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.172399172`", ",", "1.581591747`", ",", "0"}], "}"}], ",",
          "0.004351732`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.313175091`", ",", "1.43881048`", ",", "0"}], "}"}], ",", 
         "0.004259225`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2330292582`", ",", "1.86800773`", ",", "0"}], "}"}], ",",
          "0.004381763`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4602005283`", ",", "2.326812221`", ",", "0"}], "}"}], 
         ",", "0.004357306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.961548833`", ",", "0.337437891`", ",", "0"}], "}"}], ",",
          "0.004337933`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.675320936`", ",", "1.455222003`", ",", "0"}], "}"}], ",",
          "0.004376693`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07261093287`", ",", "2.080251373`", ",", "0"}], "}"}], 
         ",", "0.004333903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.068286478`", ",", "2.769146041`", ",", "0"}], "}"}], ",",
          "0.004286484`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.859474885`", ",", "1.395815027`", ",", "0"}], "}"}], ",",
          "0.004267313`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.362227849`", ",", "0.7894434177`", ",", "0"}], "}"}], 
         ",", "0.004365348`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.598722677`", ",", "1.701105907`", ",", "0"}], "}"}], ",",
          "0.004379579`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.021803621`", ",", "2.430599325`", ",", "0"}], "}"}], ",",
          "0.004101896`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.626319499`", ",", "2.076247448`", ",", "0"}], "}"}], ",",
          "0.004255193`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.585598193`", ",", "2.269864641`", ",", "0"}], "}"}], ",",
          "0.004265215`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8242671869`", ",", "0.5386627822`", ",", "0"}], "}"}], 
         ",", "0.004341855`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.842323761`", ",", "2.169772138`", ",", "0"}], "}"}], ",",
          "0.004332915`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.693867948`", ",", "0.1886580494`", ",", "0"}], "}"}], 
         ",", "0.004097063`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.449202205`", ",", "1.276758648`", ",", "0"}], "}"}], ",",
          "0.004359268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.907297778`", ",", "1.557032835`", ",", "0"}], "}"}], ",",
          "0.004358697`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.804430656`", ",", "1.872809968`", ",", "0"}], "}"}], ",",
          "0.004373698`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.218449248`", ",", "0.5650320368`", ",", "0"}], "}"}], 
         ",", "0.004354238`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.066097642`", ",", "0.9066378613`", ",", "0"}], "}"}], 
         ",", "0.00435546`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.461007044`", ",", "1.022284739`", ",", "0"}], "}"}], ",",
          "0.00431856`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.210306519`", ",", "1.160835485`", ",", "0"}], "}"}], ",",
          "0.004316211`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.179546924`", ",", "1.598252607`", ",", "0"}], "}"}], ",",
          "0.004349078`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.032203802`", ",", "2.692175223`", ",", "0"}], "}"}], ",",
          "0.00433174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.5303044`", ",", "1.548502852`", ",", "0"}], "}"}], ",", 
         "0.004308054`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.633482183`", ",", "1.207097287`", ",", "0"}], "}"}], ",",
          "0.004273858`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.906731314`", ",", "2.42977354`", ",", "0"}], "}"}], ",", 
         "0.004364246`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.80458681`", ",", "1.014845116`", ",", "0"}], "}"}], ",", 
         "0.004274754`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.263752628`", ",", "1.319968777`", ",", "0"}], "}"}], ",",
          "0.004260208`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.449805442`", ",", "0.9054088528`", ",", "0"}], "}"}], 
         ",", "0.00425389`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.698036798`", ",", "1.203357762`", ",", "0"}], "}"}], ",",
          "0.004356788`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.670811398`", ",", "0.6498533281`", ",", "0"}], "}"}], 
         ",", "0.00429727`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.305324792`", ",", "1.679588162`", ",", "0"}], "}"}], ",",
          "0.004325937`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.063206313`", ",", "2.000285361`", ",", "0"}], "}"}], ",",
          "0.004383715`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.49898821`", ",", "1.031150436`", ",", "0"}], "}"}], ",", 
         "0.004374259`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.725847302`", ",", "1.408319455`", ",", "0"}], "}"}], ",",
          "0.004302913`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7902491664`", ",", "2.274086348`", ",", "0"}], "}"}], 
         ",", "0.004241588`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.792205672`", ",", "0.9583322274`", ",", "0"}], "}"}], 
         ",", "0.004339709`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.100426157`", ",", "2.028209302`", ",", "0"}], "}"}], ",",
          "0.004266254`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.268365175`", ",", "1.829784949`", ",", "0"}], "}"}], ",",
          "0.004373719`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.004823697`", ",", "0.7651105958`", ",", "0"}], "}"}], 
         ",", "0.004350756`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9684621533`", ",", "1.006068309`", ",", "0"}], "}"}], 
         ",", "0.004323003`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.3781554`", ",", "1.530083799`", ",", "0"}], "}"}], ",", 
         "0.004339387`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.341143843`", ",", "1.957409393`", ",", "0"}], "}"}], ",",
          "0.004349449`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.525298848`", ",", "1.206376448`", ",", "0"}], "}"}], ",",
          "0.004262042`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9450761201`", ",", "2.066117313`", ",", "0"}], "}"}], 
         ",", "0.004342649`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.569122782`", ",", "2.069383609`", ",", "0"}], "}"}], ",",
          "0.004299639`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.80310931`", ",", "2.113683242`", ",", "0"}], "}"}], ",", 
         "0.004216257`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.642321524`", ",", "1.540268529`", ",", "0"}], "}"}], ",",
          "0.004263513`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.26977131`", ",", "1.996942951`", ",", "0"}], "}"}], ",", 
         "0.004323787`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.05506526`", ",", "1.800319952`", ",", "0"}], "}"}], ",", 
         "0.004294181`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.649660364`", ",", "0.4189700045`", ",", "0"}], "}"}], 
         ",", "0.00423964`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.076896658`", ",", "1.573494169`", ",", "0"}], "}"}], ",",
          "0.004252718`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7613808097`", ",", "1.457265993`", ",", "0"}], "}"}], 
         ",", "0.004281678`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.0356001`", ",", "2.243931928`", ",", "0"}], "}"}], ",", 
         "0.004210533`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.532243469`", ",", "0.9406622871`", ",", "0"}], "}"}], 
         ",", "0.004269355`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.587854372`", ",", "2.312316808`", ",", "0"}], "}"}], ",",
          "0.004322011`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.514367632`", ",", "2.195816936`", ",", "0"}], "}"}], ",",
          "0.004346958`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.126050811`", ",", "0.5287061151`", ",", "0"}], "}"}], 
         ",", "0.004375957`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.150119983`", ",", "1.196906763`", ",", "0"}], "}"}], ",",
          "0.004208243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.869041191`", ",", "1.282922017`", ",", "0"}], "}"}], ",",
          "0.004308885`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.614205448`", ",", "1.44082726`", ",", "0"}], "}"}], ",", 
         "0.004373346`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.06442483253`", ",", "3.002328452`", ",", "0"}], "}"}], 
         ",", "0.004326282`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.682454167`", ",", "0.5362361986`", ",", "0"}], "}"}], 
         ",", "0.004309517`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.685821168`", ",", "1.107594687`", ",", "0"}], "}"}], ",",
          "0.004285379`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.387420115`", ",", "0.7172390942`", ",", "0"}], "}"}], 
         ",", "0.004360733`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7234176994`", ",", "1.223109234`", ",", "0"}], "}"}], 
         ",", "0.00435896`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.282570272`", ",", "0.791611169`", ",", "0"}], "}"}], ",",
          "0.004136802`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.710339362`", ",", "0.558375194`", ",", "0"}], "}"}], ",",
          "0.004346799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.377483065`", ",", "2.417891617`", ",", "0"}], "}"}], ",",
          "0.004219989`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.502074328`", ",", "1.282958546`", ",", "0"}], "}"}], ",",
          "0.004338652`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.276057069`", ",", "1.207539012`", ",", "0"}], "}"}], ",",
          "0.004074519`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.960328439`", ",", "1.143444274`", ",", "0"}], "}"}], ",",
          "0.004271801`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.021092452`", ",", "1.764128595`", ",", "0"}], "}"}], ",",
          "0.004392852`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.742873931`", ",", "2.293077154`", ",", "0"}], "}"}], ",",
          "0.004097478`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.627938843`", ",", "1.456394043`", ",", "0"}], "}"}], ",",
          "0.004338576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.237603695`", ",", "0.7007799587`", ",", "0"}], "}"}], 
         ",", "0.004318038`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6164127672`", ",", "0.7604412466`", ",", "0"}], "}"}], 
         ",", "0.004296868`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3777249072`", ",", "1.659320474`", ",", "0"}], "}"}], 
         ",", "0.004362109`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6361253885`", ",", "1.678820043`", ",", "0"}], "}"}], 
         ",", "0.004338702`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.443823928`", ",", "1.643819314`", ",", "0"}], "}"}], ",",
          "0.00432177`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.257342366`", ",", "0.8802757276`", ",", "0"}], "}"}], 
         ",", "0.004345915`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.050298538`", ",", "1.099258908`", ",", "0"}], "}"}], ",",
          "0.004241769`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.07833912`", ",", "0.8518999203`", ",", "0"}], "}"}], ",",
          "0.004333106`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.993488978`", ",", "1.765181569`", ",", "0"}], "}"}], ",",
          "0.004391531`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.712981572`", ",", "1.147577091`", ",", "0"}], "}"}], ",",
          "0.004331142`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.541543752`", ",", "1.333954606`", ",", "0"}], "}"}], ",",
          "0.004229878`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.225983424`", ",", "1.725394904`", ",", "0"}], "}"}], ",",
          "0.004369772`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.080770285`", ",", "1.921622604`", ",", "0"}], "}"}], ",",
          "0.004330532`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.398072523`", ",", "1.532486995`", ",", "0"}], "}"}], ",",
          "0.004347869`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.761817167`", ",", "2.398659485`", ",", "0"}], "}"}], ",",
          "0.004283045`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.03622083542`", ",", "1.386586703`", ",", "0"}], "}"}], 
         ",", "0.004359846`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.542846772`", ",", "1.785969052`", ",", "0"}], "}"}], ",",
          "0.004368242`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.805616545`", ",", "1.894309126`", ",", "0"}], "}"}], ",",
          "0.004363602`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.092578337`", ",", "1.342026963`", ",", "0"}], "}"}], ",",
          "0.00409207`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.150384653`", ",", "0.4507223956`", ",", "0"}], "}"}], 
         ",", "0.004359886`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.802102831`", ",", "0.7653290412`", ",", "0"}], "}"}], 
         ",", "0.004393972`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.310348923`", ",", "2.138695329`", ",", "0"}], "}"}], ",",
          "0.004378785`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.016558941`", ",", "1.267866981`", ",", "0"}], "}"}], ",",
          "0.004330584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.573838924`", ",", "0.7856118615`", ",", "0"}], "}"}], 
         ",", "0.004346773`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.801521976`", ",", "1.335719396`", ",", "0"}], "}"}], ",",
          "0.004359851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.962975876`", ",", "0.7511832872`", ",", "0"}], "}"}], 
         ",", "0.004381702`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2019424659`", ",", "1.188230766`", ",", "0"}], "}"}], 
         ",", "0.004368075`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.86068225`", ",", "1.946440452`", ",", "0"}], "}"}], ",", 
         "0.004079667`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.648242816`", ",", "2.63039446`", ",", "0"}], "}"}], ",", 
         "0.004337751`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9958689363`", ",", "1.468667653`", ",", "0"}], "}"}], 
         ",", "0.00414901`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.100144321`", ",", "2.269756134`", ",", "0"}], "}"}], ",",
          "0.00435441`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.731772389`", ",", "1.692907503`", ",", "0"}], "}"}], ",",
          "0.004359967`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.4602936022416773`*^9, 3.460293693464929*^9}, 3.460293953837633*^9, {
   3.5029329662887278`*^9, 3.502932975732479*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION376", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}, {3.4602935962308397`*^9, 3.460293596717207*^9}, {
  3.460293631081135*^9, 3.4602936314554462`*^9}, {3.4602936672512913`*^9, 
  3.460293667593327*^9}, {3.460293704845626*^9, 3.460293705323667*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION376\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 376 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION376\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.252673339`", ",", "1.844457129`", ",", "0"}], "}"}], ",",
          "0.002577134`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.903952323`", ",", "0.9497891723`", ",", "0"}], "}"}], 
         ",", "0.002590653`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7638474312`", ",", "1.939476379`", ",", "0"}], "}"}], 
         ",", "0.002669948`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.567771261`", ",", "0.7244457507`", ",", "0"}], "}"}], 
         ",", "0.00269369`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.0400813641`", ",", "1.543420523`", ",", "0"}], "}"}], 
         ",", "0.002610887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.126878682`", ",", "1.749315375`", ",", "0"}], "}"}], ",",
          "0.002637329`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.045509923`", ",", "1.732100686`", ",", "0"}], "}"}], ",",
          "0.002660386`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.621832755`", ",", "1.539684698`", ",", "0"}], "}"}], ",",
          "0.002668062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.107291374`", ",", "1.520191866`", ",", "0"}], "}"}], ",",
          "0.002642522`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.130874865`", ",", "0.5608540153`", ",", "0"}], "}"}], 
         ",", "0.002630687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.838771134`", ",", "1.935396533`", ",", "0"}], "}"}], ",",
          "0.002650959`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.638024394`", ",", "1.78229447`", ",", "0"}], "}"}], ",", 
         "0.002703753`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.557049345`", ",", "1.758554205`", ",", "0"}], "}"}], ",",
          "0.002678609`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.894774761`", ",", "0.4086092937`", ",", "0"}], "}"}], 
         ",", "0.00266115`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.139383137`", ",", "1.566211818`", ",", "0"}], "}"}], ",",
          "0.002668884`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.005413085`", ",", "1.20895964`", ",", "0"}], "}"}], ",", 
         "0.002687771`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.214842901`", ",", "2.701445365`", ",", "0"}], "}"}], ",",
          "0.002674457`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.08001091`", ",", "2.490994559`", ",", "0"}], "}"}], ",", 
         "0.002632553`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.431892675`", ",", "0.6354772779`", ",", "0"}], "}"}], 
         ",", "0.00268672`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.010537373`", ",", "1.849908665`", ",", "0"}], "}"}], ",",
          "0.0026947`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4535504049`", ",", "2.155295347`", ",", "0"}], "}"}], 
         ",", "0.002628051`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.627695194`", ",", "2.408549882`", ",", "0"}], "}"}], ",",
          "0.002616504`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.348488233`", ",", "2.708014837`", ",", "0"}], "}"}], ",",
          "0.002656352`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.593156927`", ",", "1.194782645`", ",", "0"}], "}"}], ",",
          "0.002714051`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.140969396`", ",", "1.936478672`", ",", "0"}], "}"}], ",",
          "0.002631056`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.794065974`", ",", "2.653720628`", ",", "0"}], "}"}], ",",
          "0.002637936`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.354288128`", ",", "2.211655781`", ",", "0"}], "}"}], ",",
          "0.002619488`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.227031451`", ",", "1.475051561`", ",", "0"}], "}"}], ",",
          "0.002686281`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.45004279`", ",", "1.065336898`", ",", "0"}], "}"}], ",", 
         "0.002586516`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.89419464`", ",", "1.475160801`", ",", "0"}], "}"}], ",", 
         "0.002659548`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9502880572`", ",", "1.900768136`", ",", "0"}], "}"}], 
         ",", "0.00259448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.886615426`", ",", "2.129528092`", ",", "0"}], "}"}], ",",
          "0.002673265`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.672410993`", ",", "2.050485167`", ",", "0"}], "}"}], ",",
          "0.00268642`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.0780270037`", ",", "0.4558369084`", ",", "0"}], "}"}], 
         ",", "0.002666616`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.826821249`", ",", "3.038348016`", ",", "0"}], "}"}], ",",
          "0.002668414`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.928566762`", ",", "2.702938896`", ",", "0"}], "}"}], ",",
          "0.002566893`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.31801824`", ",", "1.400023818`", ",", "0"}], "}"}], ",", 
         "0.002700291`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.479793193`", ",", "2.863936496`", ",", "0"}], "}"}], ",",
          "0.002672855`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.482966987`", ",", "2.157772825`", ",", "0"}], "}"}], ",",
          "0.002672426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.731168357`", ",", "2.051580291`", ",", "0"}], "}"}], ",",
          "0.002686223`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.222383003`", ",", "2.956393498`", ",", "0"}], "}"}], ",",
          "0.002673881`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.117942448`", ",", "0.6261213706`", ",", "0"}], "}"}], 
         ",", "0.002692867`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.934373996`", ",", "1.983295331`", ",", "0"}], "}"}], ",",
          "0.002697342`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.647218832`", ",", "1.697767861`", ",", "0"}], "}"}], ",",
          "0.002683608`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.158710878`", ",", "0.5206268813`", ",", "0"}], "}"}], 
         ",", "0.00270458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.508970341`", ",", "1.382184459`", ",", "0"}], "}"}], ",",
          "0.002714945`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.650215326`", ",", "1.846328419`", ",", "0"}], "}"}], ",",
          "0.002664884`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.759510977`", ",", "1.856500495`", ",", "0"}], "}"}], ",",
          "0.00266246`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.034263535`", ",", "1.40048352`", ",", "0"}], "}"}], ",", 
         "0.002699864`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.170658058`", ",", "1.652776414`", ",", "0"}], "}"}], ",",
          "0.002664312`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.191875781`", ",", "2.906131314`", ",", "0"}], "}"}], ",",
          "0.002649951`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.414257772`", ",", "1.23596711`", ",", "0"}], "}"}], ",", 
         "0.002702552`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.333608646`", ",", "1.767864088`", ",", "0"}], "}"}], ",",
          "0.002708355`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9300546472`", ",", "1.578669664`", ",", "0"}], "}"}], 
         ",", "0.002679227`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.407646561`", ",", "0.5163686445`", ",", "0"}], "}"}], 
         ",", "0.002639284`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.259091579`", ",", "2.259310269`", ",", "0"}], "}"}], ",",
          "0.002662972`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.253484211`", ",", "2.073554772`", ",", "0"}], "}"}], ",",
          "0.002647302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.065439375`", ",", "1.076669931`", ",", "0"}], "}"}], ",",
          "0.002698799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.430124194`", ",", "1.563934146`", ",", "0"}], "}"}], ",",
          "0.002651141`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.399597163`", ",", "2.623793921`", ",", "0"}], "}"}], ",",
          "0.002683929`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.265863333`", ",", "1.010983749`", ",", "0"}], "}"}], ",",
          "0.002707683`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.560010881`", ",", "1.265679385`", ",", "0"}], "}"}], ",",
          "0.002661837`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.914478901`", ",", "0.8136380619`", ",", "0"}], "}"}], 
         ",", "0.002674511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.444965304`", ",", "0.5445520118`", ",", "0"}], "}"}], 
         ",", "0.002702822`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.55077513`", ",", "2.756844018`", ",", "0"}], "}"}], ",", 
         "0.002610468`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.829723444`", ",", "2.195082763`", ",", "0"}], "}"}], ",",
          "0.002673331`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.057975151`", ",", "1.290442606`", ",", "0"}], "}"}], ",",
          "0.002650259`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.168110976`", ",", "0.8030878957`", ",", "0"}], "}"}], 
         ",", "0.0026559`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.712777273`", ",", "1.645403358`", ",", "0"}], "}"}], ",",
          "0.002676628`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.594481578`", ",", "0.796906655`", ",", "0"}], "}"}], ",",
          "0.002646584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.967723704`", ",", "1.810507456`", ",", "0"}], "}"}], ",",
          "0.002632224`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.563561771`", ",", "2.441044841`", ",", "0"}], "}"}], ",",
          "0.002674742`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.338241815`", ",", "2.161075965`", ",", "0"}], "}"}], ",",
          "0.00271934`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.439087576`", ",", "1.761213127`", ",", "0"}], "}"}], ",",
          "0.002668897`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.770693798`", ",", "0.9999645609`", ",", "0"}], "}"}], 
         ",", "0.00257863`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.409727665`", ",", "0.8951185312`", ",", "0"}], "}"}], 
         ",", "0.002678906`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.791950792`", ",", "2.842962298`", ",", "0"}], "}"}], ",",
          "0.002686486`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.015829996`", ",", "1.594448819`", ",", "0"}], "}"}], ",",
          "0.002675387`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.337315098`", ",", "0.8162200846`", ",", "0"}], "}"}], 
         ",", "0.00265081`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.739540561`", ",", "1.361895111`", ",", "0"}], "}"}], ",",
          "0.002625966`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.959389268`", ",", "2.32294815`", ",", "0"}], "}"}], ",", 
         "0.002665268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.077160028`", ",", "1.781018408`", ",", "0"}], "}"}], ",",
          "0.002635998`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.625460144`", ",", "2.575205212`", ",", "0"}], "}"}], ",",
          "0.002630812`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.054526869`", ",", "2.519481351`", ",", "0"}], "}"}], ",",
          "0.002663857`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.84541911`", ",", "2.383972103`", ",", "0"}], "}"}], ",", 
         "0.002652`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.064581265`", ",", "1.588130291`", ",", "0"}], "}"}], ",",
          "0.002685705`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8235284414`", ",", "1.080732953`", ",", "0"}], "}"}], 
         ",", "0.002659194`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.113796034`", ",", "0.7183764031`", ",", "0"}], "}"}], 
         ",", "0.002718833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5848070012`", ",", "2.658996968`", ",", "0"}], "}"}], 
         ",", "0.002655776`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.255737867`", ",", "0.3300902992`", ",", "0"}], "}"}], 
         ",", "0.002663065`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.485937371`", ",", "2.774927008`", ",", "0"}], "}"}], ",",
          "0.002644292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.935653505`", ",", "0.7036880612`", ",", "0"}], "}"}], 
         ",", "0.002598503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5270170029`", ",", "1.623430518`", ",", "0"}], "}"}], 
         ",", "0.002706236`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.746581299`", ",", "2.386991436`", ",", "0"}], "}"}], ",",
          "0.002672701`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.102842583`", ",", "1.401362713`", ",", "0"}], "}"}], ",",
          "0.002659999`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.598740269`", ",", "0.4654397798`", ",", "0"}], "}"}], 
         ",", "0.002681347`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.095443783`", ",", "3.055349931`", ",", "0"}], "}"}], ",",
          "0.002675139`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.233136526`", ",", "2.455463006`", ",", "0"}], "}"}], ",",
          "0.002621766`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.473735739`", ",", "0.1296701094`", ",", "0"}], "}"}], 
         ",", "0.002641673`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.491096242`", ",", "2.544470731`", ",", "0"}], "}"}], ",",
          "0.002570112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.20257698`", ",", "1.234845648`", ",", "0"}], "}"}], ",", 
         "0.00270209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2213873013`", ",", "2.178810587`", ",", "0"}], "}"}], 
         ",", "0.00266993`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.221175147`", ",", "1.586938284`", ",", "0"}], "}"}], ",",
          "0.002658547`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.520946799`", ",", "2.105841111`", ",", "0"}], "}"}], ",",
          "0.002635804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6194165312`", ",", "2.468776622`", ",", "0"}], "}"}], 
         ",", "0.002666621`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.562451576`", ",", "1.883972675`", ",", "0"}], "}"}], ",",
          "0.002669564`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.662304027`", ",", "1.008441311`", ",", "0"}], "}"}], ",",
          "0.002660718`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.664989974`", ",", "2.250626488`", ",", "0"}], "}"}], ",",
          "0.00265717`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.787804108`", ",", "2.048400737`", ",", "0"}], "}"}], ",",
          "0.002677018`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.426532577`", ",", "0.7028860999`", ",", "0"}], "}"}], 
         ",", "0.002665877`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.039768512`", ",", "0.5820332193`", ",", "0"}], "}"}], 
         ",", "0.002663566`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.501537787`", ",", "1.684988961`", ",", "0"}], "}"}], ",",
          "0.002579503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1108479203`", ",", "2.010740162`", ",", "0"}], "}"}], 
         ",", "0.002689209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.616521134`", ",", "1.618010555`", ",", "0"}], "}"}], ",",
          "0.002778562`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3938865165`", ",", "1.113930285`", ",", "0"}], "}"}], 
         ",", "0.002672639`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8875992164`", ",", "2.358433922`", ",", "0"}], "}"}], 
         ",", "0.002694135`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.297171207`", ",", "1.883621515`", ",", "0"}], "}"}], ",",
          "0.002627235`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.982168476`", ",", "2.133850015`", ",", "0"}], "}"}], ",",
          "0.002710372`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.154528502`", ",", "0.9017191046`", ",", "0"}], "}"}], 
         ",", "0.002694551`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5195340434`", ",", "1.274464064`", ",", "0"}], "}"}], 
         ",", "0.002666332`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.319113792`", ",", "1.50521085`", ",", "0"}], "}"}], ",", 
         "0.002680161`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.349840854`", ",", "2.353280628`", ",", "0"}], "}"}], ",",
          "0.00269593`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1385069732`", ",", "1.3311936`", ",", "0"}], "}"}], ",", 
         "0.002603844`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1755482181`", ",", "1.139924172`", ",", "0"}], "}"}], 
         ",", "0.002673413`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.836654329`", ",", "1.674606346`", ",", "0"}], "}"}], ",",
          "0.002651519`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.51632357`", ",", "1.871151469`", ",", "0"}], "}"}], ",", 
         "0.002641759`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.128260616`", ",", "1.993108043`", ",", "0"}], "}"}], ",",
          "0.002671744`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.687696839`", ",", "0.8254895282`", ",", "0"}], "}"}], 
         ",", "0.002678794`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.395649211`", ",", "1.95834105`", ",", "0"}], "}"}], ",", 
         "0.00258297`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.902882095`", ",", "1.708912084`", ",", "0"}], "}"}], ",",
          "0.002646814`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.379998957`", ",", "0.6744183137`", ",", "0"}], "}"}], 
         ",", "0.002678962`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.968117624`", ",", "1.093701762`", ",", "0"}], "}"}], ",",
          "0.002682621`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.945168403`", ",", "2.467812223`", ",", "0"}], "}"}], ",",
          "0.002615209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.973336639`", ",", "0.755677545`", ",", "0"}], "}"}], ",",
          "0.002691546`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.985441362`", ",", "1.114548533`", ",", "0"}], "}"}], ",",
          "0.002650091`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.721522943`", ",", "2.481660817`", ",", "0"}], "}"}], ",",
          "0.00266254`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4061374537`", ",", "0.5816864572`", ",", "0"}], "}"}], 
         ",", "0.002669802`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.532709472`", ",", "0.2522333429`", ",", "0"}], "}"}], 
         ",", "0.002669217`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.711729508`", ",", "1.412258821`", ",", "0"}], "}"}], ",",
          "0.002661746`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.858228204`", ",", "0.7780611657`", ",", "0"}], "}"}], 
         ",", "0.002604106`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.120427421`", ",", "0.6830196104`", ",", "0"}], "}"}], 
         ",", "0.002672684`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.40317555`", ",", "1.536873217`", ",", "0"}], "}"}], ",", 
         "0.002646903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.329033616`", ",", "1.202568489`", ",", "0"}], "}"}], ",",
          "0.002669165`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.093083051`", ",", "0.5787401495`", ",", "0"}], "}"}], 
         ",", "0.002642021`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.987089537`", ",", "1.250443883`", ",", "0"}], "}"}], ",",
          "0.002666576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.063219822`", ",", "2.138060011`", ",", "0"}], "}"}], ",",
          "0.002669851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07298563761`", ",", "0.84543735`", ",", "0"}], "}"}], 
         ",", "0.002596241`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.685431577`", ",", "2.045236281`", ",", "0"}], "}"}], ",",
          "0.002673892`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.07515906`", ",", "1.130885338`", ",", "0"}], "}"}], ",", 
         "0.002640632`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.48042954`", ",", "1.962963851`", ",", "0"}], "}"}], ",", 
         "0.00267663`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9773854109`", ",", "2.753202615`", ",", "0"}], "}"}], 
         ",", "0.002667303`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.343238222`", ",", "1.551451953`", ",", "0"}], "}"}], ",",
          "0.00267034`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.240734344`", ",", "1.385313363`", ",", "0"}], "}"}], ",",
          "0.002531247`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.155915235`", ",", "0.8845221486`", ",", "0"}], "}"}], 
         ",", "0.002685452`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.267188937`", ",", "1.405883587`", ",", "0"}], "}"}], ",",
          "0.00259861`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3250274481`", ",", "1.298308525`", ",", "0"}], "}"}], 
         ",", "0.002659559`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.125007182`", ",", "2.32757048`", ",", "0"}], "}"}], ",", 
         "0.002658715`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.842295155`", ",", "1.664096846`", ",", "0"}], "}"}], ",",
          "0.002655617`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3006326146`", ",", "2.519605322`", ",", "0"}], "}"}], 
         ",", "0.002673458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.028100263`", ",", "1.411870834`", ",", "0"}], "}"}], ",",
          "0.002672982`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.866602721`", ",", "0.7536216693`", ",", "0"}], "}"}], 
         ",", "0.002631705`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.760728405`", ",", "0.4217172749`", ",", "0"}], "}"}], 
         ",", "0.00261899`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.34162189`", ",", "2.24803984`", ",", "0"}], "}"}], ",", 
         "0.002670504`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.975260219`", ",", "2.395596799`", ",", "0"}], "}"}], ",",
          "0.002609645`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.706876271`", ",", "1.548863664`", ",", "0"}], "}"}], ",",
          "0.002583129`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6073183103`", ",", "1.088825556`", ",", "0"}], "}"}], 
         ",", "0.002678051`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.269473714`", ",", "2.60028767`", ",", "0"}], "}"}], ",", 
         "0.002662567`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.877876623`", ",", "1.080581075`", ",", "0"}], "}"}], ",",
          "0.002580764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.700848854`", ",", "2.58770149`", ",", "0"}], "}"}], ",", 
         "0.002514311`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.377284088`", ",", "0.776839348`", ",", "0"}], "}"}], ",",
          "0.002672048`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.641777418`", ",", "0.7691348538`", ",", "0"}], "}"}], 
         ",", "0.002627375`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.517490882`", ",", "0.3191129985`", ",", "0"}], "}"}], 
         ",", "0.002645268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8384180547`", ",", "0.2330681616`", ",", "0"}], "}"}], 
         ",", "0.002657989`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.58726205`", ",", "1.903298217`", ",", "0"}], "}"}], ",", 
         "0.00266268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.775177392`", ",", "2.586662164`", ",", "0"}], "}"}], ",",
          "0.002675292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6176105692`", ",", "1.438759429`", ",", "0"}], "}"}], 
         ",", "0.002691656`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.281315903`", ",", "2.115688189`", ",", "0"}], "}"}], ",",
          "0.002638093`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.68412291`", ",", "0.5983107882`", ",", "0"}], "}"}], ",",
          "0.002685577`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.53087377`", ",", "1.543565857`", ",", "0"}], "}"}], ",", 
         "0.00265597`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.924166831`", ",", "1.428980087`", ",", "0"}], "}"}], ",",
          "0.002652659`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.940922497`", ",", "1.283147112`", ",", "0"}], "}"}], ",",
          "0.002706912`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.799803264`", ",", "0.4661530784`", ",", "0"}], "}"}], 
         ",", "0.002563693`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8353621926`", ",", "1.74758338`", ",", "0"}], "}"}], ",",
          "0.002655445`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.011666583`", ",", "2.327191324`", ",", "0"}], "}"}], ",",
          "0.002651585`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.622039621`", ",", "0.2467401809`", ",", "0"}], "}"}], 
         ",", "0.002551435`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.416363712`", ",", "1.204377575`", ",", "0"}], "}"}], ",",
          "0.002687191`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.25188459`", ",", "1.659010172`", ",", "0"}], "}"}], ",", 
         "0.002664288`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.371935649`", ",", "0.974038201`", ",", "0"}], "}"}], ",",
          "0.002687352`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.159828255`", ",", "1.894330785`", ",", "0"}], "}"}], ",",
          "0.002634942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.562215825`", ",", "1.078638733`", ",", "0"}], "}"}], ",",
          "0.002648507`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.196242377`", ",", "1.281990639`", ",", "0"}], "}"}], ",",
          "0.002685343`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9223356319`", ",", "1.253961088`", ",", "0"}], "}"}], 
         ",", "0.002653745`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.909009772`", ",", "1.440971529`", ",", "0"}], "}"}], ",",
          "0.002679021`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.182220489`", ",", "1.085574514`", ",", "0"}], "}"}], ",",
          "0.002682597`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.537329987`", ",", "2.054002616`", ",", "0"}], "}"}], ",",
          "0.002656047`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.821310581`", ",", "0.600151552`", ",", "0"}], "}"}], ",",
          "0.00263202`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.372027314`", ",", "1.17480353`", ",", "0"}], "}"}], ",", 
         "0.002679269`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.381202597`", ",", "1.370379732`", ",", "0"}], "}"}], ",",
          "0.002677996`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.898811176`", ",", "2.188917859`", ",", "0"}], "}"}], ",",
          "0.002682255`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.599490944`", ",", "0.8839265375`", ",", "0"}], "}"}], 
         ",", "0.002644088`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.025315537`", ",", "1.60684146`", ",", "0"}], "}"}], ",", 
         "0.002680698`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6637001246`", ",", "2.095434917`", ",", "0"}], "}"}], 
         ",", "0.002545487`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.716691609`", ",", "1.936535866`", ",", "0"}], "}"}], ",",
          "0.002675817`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.768486175`", ",", "2.116085042`", ",", "0"}], "}"}], ",",
          "0.002688247`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.915800551`", ",", "1.459898089`", ",", "0"}], "}"}], ",",
          "0.002686909`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.589532716`", ",", "2.233319`", ",", "0"}], "}"}], ",", 
         "0.002683249`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.429814163`", ",", "1.358559089`", ",", "0"}], "}"}], ",",
          "0.00269618`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.12343334`", ",", "2.116215575`", ",", "0"}], "}"}], ",", 
         "0.002657739`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.760680181`", ",", "1.182156026`", ",", "0"}], "}"}], ",",
          "0.002641417`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.017741916`", ",", "2.155110028`", ",", "0"}], "}"}], ",",
          "0.002691806`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.23752157`", ",", "1.397475027`", ",", "0"}], "}"}], ",", 
         "0.002640049`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.840252316`", ",", "1.336608187`", ",", "0"}], "}"}], ",",
          "0.002687991`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.058559932`", ",", "0.4855389566`", ",", "0"}], "}"}], 
         ",", "0.002667628`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.898160945`", ",", "2.006722153`", ",", "0"}], "}"}], ",",
          "0.002669907`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.233152749`", ",", "1.010479663`", ",", "0"}], "}"}], ",",
          "0.002737479`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.97792408`", ",", "1.01532941`", ",", "0"}], "}"}], ",", 
         "0.002669375`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.590204021`", ",", "1.104642044`", ",", "0"}], "}"}], ",",
          "0.002622855`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.706699923`", ",", "2.248248407`", ",", "0"}], "}"}], ",",
          "0.002678588`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.034423424`", ",", "2.676049376`", ",", "0"}], "}"}], ",",
          "0.002610184`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.19324912`", ",", "0.3740226799`", ",", "0"}], "}"}], ",",
          "0.002704921`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.335030426`", ",", "1.967438997`", ",", "0"}], "}"}], ",",
          "0.002718248`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.266270728`", ",", "2.173077512`", ",", "0"}], "}"}], ",",
          "0.002678852`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.756433464`", ",", "2.44563846`", ",", "0"}], "}"}], ",", 
         "0.002648765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.470570533`", ",", "2.06830997`", ",", "0"}], "}"}], ",", 
         "0.00267177`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.115899749`", ",", "2.181243087`", ",", "0"}], "}"}], ",",
          "0.002657603`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.778418006`", ",", "0.9269214845`", ",", "0"}], "}"}], 
         ",", "0.002622436`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.26335705`", ",", "1.323630251`", ",", "0"}], "}"}], ",", 
         "0.002688995`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.883398269`", ",", "1.273334591`", ",", "0"}], "}"}], ",",
          "0.00260984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.075625901`", ",", "2.889452494`", ",", "0"}], "}"}], ",",
          "0.002648166`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.735715368`", ",", "1.514868246`", ",", "0"}], "}"}], ",",
          "0.002650539`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.487127712`", ",", "1.763219558`", ",", "0"}], "}"}], ",",
          "0.002648345`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.276953994`", ",", "0.7292456505`", ",", "0"}], "}"}], 
         ",", "0.002670766`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.137730153`", ",", "1.242135086`", ",", "0"}], "}"}], ",",
          "0.002619096`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.193010821`", ",", "1.836114473`", ",", "0"}], "}"}], ",",
          "0.002664317`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.656474391`", ",", "0.9075048536`", ",", "0"}], "}"}], 
         ",", "0.002669083`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.144571468`", ",", "2.261358639`", ",", "0"}], "}"}], ",",
          "0.00264398`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.935290058`", ",", "1.997842406`", ",", "0"}], "}"}], ",",
          "0.00268209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.716529765`", ",", "1.379953579`", ",", "0"}], "}"}], ",",
          "0.002763819`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.448548159`", ",", "0.453624948`", ",", "0"}], "}"}], ",",
          "0.002653133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4222827441`", ",", "1.463487358`", ",", "0"}], "}"}], 
         ",", "0.002703848`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.148997946`", ",", "1.000208383`", ",", "0"}], "}"}], ",",
          "0.002720813`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.065325543`", ",", "1.322167612`", ",", "0"}], "}"}], ",",
          "0.002614608`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.576661627`", ",", "1.011778974`", ",", "0"}], "}"}], ",",
          "0.002720956`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.64839411`", ",", "0.1969531106`", ",", "0"}], "}"}], ",",
          "0.002664269`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7223552477`", ",", "1.596896399`", ",", "0"}], "}"}], 
         ",", "0.002682679`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.708261285`", ",", "1.181161101`", ",", "0"}], "}"}], ",",
          "0.002623342`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.571237475`", ",", "2.232736915`", ",", "0"}], "}"}], ",",
          "0.002653706`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.805773154`", ",", "1.746941605`", ",", "0"}], "}"}], ",",
          "0.002640107`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.253793212`", ",", "2.518694365`", ",", "0"}], "}"}], ",",
          "0.002666144`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.106627311`", ",", "0.07288227921`", ",", "0"}], "}"}], 
         ",", "0.002676683`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.104152034`", ",", "1.947921853`", ",", "0"}], "}"}], ",",
          "0.002663325`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.133871274`", ",", "1.69320639`", ",", "0"}], "}"}], ",", 
         "0.002642517`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6503257189`", ",", "2.28317817`", ",", "0"}], "}"}], ",",
          "0.002640335`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.019458239`", ",", "2.589634599`", ",", "0"}], "}"}], ",",
          "0.002666345`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.530771843`", ",", "0.9295821342`", ",", "0"}], "}"}], 
         ",", "0.002537383`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.260036761`", ",", "2.446549156`", ",", "0"}], "}"}], ",",
          "0.002663965`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.140842092`", ",", "1.21157074`", ",", "0"}], "}"}], ",", 
         "0.002791204`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.104461192`", ",", "2.695488783`", ",", "0"}], "}"}], ",",
          "0.002678405`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.391513906`", ",", "1.868234622`", ",", "0"}], "}"}], ",",
          "0.002627697`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.617143187`", ",", "1.704561153`", ",", "0"}], "}"}], ",",
          "0.002742042`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.08401569`", ",", "1.413659343`", ",", "0"}], "}"}], ",", 
         "0.002716362`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.437615749`", ",", "0.8846958438`", ",", "0"}], "}"}], 
         ",", "0.002662333`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.196408549`", ",", "1.689979102`", ",", "0"}], "}"}], ",",
          "0.002677147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.660393109`", ",", "0.7137227968`", ",", "0"}], "}"}], 
         ",", "0.002645882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.449626477`", ",", "1.72158314`", ",", "0"}], "}"}], ",", 
         "0.0026699`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5362722745`", ",", "1.952430841`", ",", "0"}], "}"}], 
         ",", "0.002634034`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08685976598`", ",", "0.6457955074`", ",", "0"}], "}"}], 
         ",", "0.002653699`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.986650848`", ",", "1.658737237`", ",", "0"}], "}"}], ",",
          "0.00266603`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.78527558`", ",", "1.293820568`", ",", "0"}], "}"}], ",", 
         "0.002656647`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.089964985`", ",", "2.780133691`", ",", "0"}], "}"}], ",",
          "0.002687671`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.444801235`", ",", "2.046333604`", ",", "0"}], "}"}], ",",
          "0.002526212`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.803233813`", ",", "2.264864814`", ",", "0"}], "}"}], ",",
          "0.002707789`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.867244374`", ",", "1.802245189`", ",", "0"}], "}"}], ",",
          "0.002665181`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.26216149`", ",", "1.199579892`", ",", "0"}], "}"}], ",", 
         "0.002604803`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.535926568`", ",", "2.344766877`", ",", "0"}], "}"}], ",",
          "0.002698642`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.524370271`", ",", "1.200344311`", ",", "0"}], "}"}], ",",
          "0.002593887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.794457312`", ",", "1.571442849`", ",", "0"}], "}"}], ",",
          "0.002577074`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4833577139`", ",", "0.9249611307`", ",", "0"}], "}"}], 
         ",", "0.002685292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2475677113`", ",", "0.9670444049`", ",", "0"}], "}"}], 
         ",", "0.002644851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3225980894`", ",", "0.7723088747`", ",", "0"}], "}"}], 
         ",", "0.002662253`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7181941907`", ",", "1.257900331`", ",", "0"}], "}"}], 
         ",", "0.002674333`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3324334909`", ",", "2.000104143`", ",", "0"}], "}"}], 
         ",", "0.002657952`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.191106754`", ",", "1.139796448`", ",", "0"}], "}"}], ",",
          "0.002666552`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.520855379`", ",", "1.06834328`", ",", "0"}], "}"}], ",", 
         "0.002682649`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1695053298`", ",", "2.703210713`", ",", "0"}], "}"}], 
         ",", "0.002644688`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.038680432`", ",", "2.05864856`", ",", "0"}], "}"}], ",", 
         "0.00258023`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.809364509`", ",", "0.6213968691`", ",", "0"}], "}"}], 
         ",", "0.002647902`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.553908896`", ",", "1.456278328`", ",", "0"}], "}"}], ",",
          "0.00261469`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.124124072`", ",", "1.469401162`", ",", "0"}], "}"}], ",",
          "0.002669696`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.187748986`", ",", "0.8168256964`", ",", "0"}], "}"}], 
         ",", "0.002722289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.28746688`", ",", "2.967379735`", ",", "0"}], "}"}], ",", 
         "0.002663887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.754665323`", ",", "0.5274267888`", ",", "0"}], "}"}], 
         ",", "0.002642212`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.003690838`", ",", "0.367092344`", ",", "0"}], "}"}], ",",
          "0.002655215`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.843013689`", ",", "2.290607041`", ",", "0"}], "}"}], ",",
          "0.00266861`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.206042314`", ",", "1.55303549`", ",", "0"}], "}"}], ",", 
         "0.002628018`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.839924832`", ",", "1.258254441`", ",", "0"}], "}"}], ",",
          "0.002692178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.281500367`", ",", "2.070638815`", ",", "0"}], "}"}], ",",
          "0.002655158`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.804416989`", ",", "1.151174442`", ",", "0"}], "}"}], ",",
          "0.002671733`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7691763927`", ",", "0.5664948845`", ",", "0"}], "}"}], 
         ",", "0.002681739`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.424839476`", ",", "1.57691512`", ",", "0"}], "}"}], ",", 
         "0.002712429`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.489624999`", ",", "2.350094879`", ",", "0"}], "}"}], ",",
          "0.002643184`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.381939396`", ",", "0.891581796`", ",", "0"}], "}"}], ",",
          "0.00264357`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.149605861`", ",", "1.755820025`", ",", "0"}], "}"}], ",",
          "0.002570292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.346557593`", ",", "1.072386771`", ",", "0"}], "}"}], ",",
          "0.0026483`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.252310512`", ",", "1.724392876`", ",", "0"}], "}"}], ",",
          "0.002672479`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.940790106`", ",", "1.921284952`", ",", "0"}], "}"}], ",",
          "0.002676099`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.833082347`", ",", "1.116050598`", ",", "0"}], "}"}], ",",
          "0.002671622`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.525163096`", ",", "1.411395633`", ",", "0"}], "}"}], ",",
          "0.002687267`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.760657501`", ",", "0.9618457497`", ",", "0"}], "}"}], 
         ",", "0.002633456`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.76132111`", ",", "1.83472451`", ",", "0"}], "}"}], ",", 
         "0.002648162`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.37374415`", ",", "2.547059631`", ",", "0"}], "}"}], ",", 
         "0.002624979`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.772290914`", ",", "1.853894037`", ",", "0"}], "}"}], ",",
          "0.002686644`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4296115911`", ",", "1.800810215`", ",", "0"}], "}"}], 
         ",", "0.002665889`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9788604235`", ",", "0.9163798005`", ",", "0"}], "}"}], 
         ",", "0.002646799`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.608145081`", ",", "1.944051254`", ",", "0"}], "}"}], ",",
          "0.002618194`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.04095099`", ",", "0.936664401`", ",", "0"}], "}"}], ",", 
         "0.002706556`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.918148395`", ",", "2.552796074`", ",", "0"}], "}"}], ",",
          "0.002685237`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.654835719`", ",", "2.784377128`", ",", "0"}], "}"}], ",",
          "0.002689579`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.681580193`", ",", "1.745379587`", ",", "0"}], "}"}], ",",
          "0.002646005`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.093911952`", ",", "2.239683099`", ",", "0"}], "}"}], ",",
          "0.002647554`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.999313029`", ",", "1.798551008`", ",", "0"}], "}"}], ",",
          "0.002675867`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.982898679`", ",", "1.61429248`", ",", "0"}], "}"}], ",", 
         "0.002657827`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.402989673`", ",", "2.527939863`", ",", "0"}], "}"}], ",",
          "0.002688503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.049903116`", ",", "2.867473231`", ",", "0"}], "}"}], ",",
          "0.00266075`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5328110772`", ",", "0.3992030512`", ",", "0"}], "}"}], 
         ",", "0.00266733`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.451362215`", ",", "0.3827567613`", ",", "0"}], "}"}], 
         ",", "0.002667569`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.472738179`", ",", "1.386385065`", ",", "0"}], "}"}], ",",
          "0.002698266`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.799765739`", ",", "1.597411027`", ",", "0"}], "}"}], ",",
          "0.002678587`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.04239975476`", ",", "0.2652453135`", ",", "0"}], "}"}], 
         ",", "0.002669947`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.902093782`", ",", "0.3022085422`", ",", "0"}], "}"}], 
         ",", "0.002677471`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.660012845`", ",", "2.678019503`", ",", "0"}], "}"}], ",",
          "0.002686486`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.951762834`", ",", "1.815497858`", ",", "0"}], "}"}], ",",
          "0.002631674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.67860603`", ",", "1.461197504`", ",", "0"}], "}"}], ",", 
         "0.00268049`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2276074627`", ",", "1.494078372`", ",", "0"}], "}"}], 
         ",", "0.002670069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.813842553`", ",", "0.1522498179`", ",", "0"}], "}"}], 
         ",", "0.002620449`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.167021054`", ",", "2.41972739`", ",", "0"}], "}"}], ",", 
         "0.002667849`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.4024428`", ",", "0.5819695671`", ",", "0"}], "}"}], ",", 
         "0.002677903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.360836063`", ",", "1.89787232`", ",", "0"}], "}"}], ",", 
         "0.002661509`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.612920075`", ",", "2.162109881`", ",", "0"}], "}"}], ",",
          "0.002632837`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8623425743`", ",", "2.155331929`", ",", "0"}], "}"}], 
         ",", "0.002679328`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.131287138`", ",", "0.7687855262`", ",", "0"}], "}"}], 
         ",", "0.002591455`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.726301131`", ",", "0.6454737908`", ",", "0"}], "}"}], 
         ",", "0.002650542`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2315726064`", ",", "1.844172867`", ",", "0"}], "}"}], 
         ",", "0.002661009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1130674729`", ",", "2.351427891`", ",", "0"}], "}"}], 
         ",", "0.002680793`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.360286388`", ",", "1.687725463`", ",", "0"}], "}"}], ",",
          "0.002657616`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.072847738`", ",", "1.837030614`", ",", "0"}], "}"}], ",",
          "0.002690783`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.105841748`", ",", "2.300436753`", ",", "0"}], "}"}], ",",
          "0.002663473`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8895124813`", ",", "0.7451539252`", ",", "0"}], "}"}], 
         ",", "0.002655246`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.615187118`", ",", "1.374977034`", ",", "0"}], "}"}], ",",
          "0.002566724`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.337358486`", ",", "1.251036579`", ",", "0"}], "}"}], ",",
          "0.002572576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.966855551`", ",", "2.525207881`", ",", "0"}], "}"}], ",",
          "0.002614853`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.034613413`", ",", "0.4222807545`", ",", "0"}], "}"}], 
         ",", "0.002689316`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3274883623`", ",", "1.647937174`", ",", "0"}], "}"}], 
         ",", "0.002676574`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.294515497`", ",", "1.064607682`", ",", "0"}], "}"}], ",",
          "0.002702476`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.238556323`", ",", "2.022393621`", ",", "0"}], "}"}], ",",
          "0.002610775`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.748279199`", ",", "1.088077142`", ",", "0"}], "}"}], ",",
          "0.002665282`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.407781989`", ",", "2.280941705`", ",", "0"}], "}"}], ",",
          "0.002667452`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.342658842`", ",", "1.022933774`", ",", "0"}], "}"}], ",",
          "0.002634481`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8188364902`", ",", "1.424232634`", ",", "0"}], "}"}], 
         ",", "0.00268615`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.309996096`", ",", "1.70230364`", ",", "0"}], "}"}], ",", 
         "0.002537474`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.130821005`", ",", "0.9298390641`", ",", "0"}], "}"}], 
         ",", "0.002764551`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7266340619`", ",", "0.9085397466`", ",", "0"}], "}"}], 
         ",", "0.002679576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.499470898`", ",", "2.868648536`", ",", "0"}], "}"}], ",",
          "0.002688722`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.622490509`", ",", "1.240563452`", ",", "0"}], "}"}], ",",
          "0.002669077`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3872133199`", ",", "2.338625727`", ",", "0"}], "}"}], 
         ",", "0.002672941`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.163606604`", ",", "2.004972739`", ",", "0"}], "}"}], ",",
          "0.002704488`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.232440881`", ",", "2.369616386`", ",", "0"}], "}"}], ",",
          "0.002659373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.517856738`", ",", "1.570645897`", ",", "0"}], "}"}], ",",
          "0.002694993`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.637182455`", ",", "1.281654227`", ",", "0"}], "}"}], ",",
          "0.002661152`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.873004624`", ",", "1.52192983`", ",", "0"}], "}"}], ",", 
         "0.002688917`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.041306349`", ",", "1.08889434`", ",", "0"}], "}"}], ",", 
         "0.002589936`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.901665619`", ",", "0.9357963964`", ",", "0"}], "}"}], 
         ",", "0.002690855`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5999792008`", ",", "0.7389953389`", ",", "0"}], "}"}], 
         ",", "0.002677876`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.457772155`", ",", "2.41616355`", ",", "0"}], "}"}], ",", 
         "0.002664089`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.931033514`", ",", "0.884297804`", ",", "0"}], "}"}], ",",
          "0.002677859`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.037361573`", ",", "1.987264454`", ",", "0"}], "}"}], ",",
          "0.002644805`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.4602936022416773`*^9, 3.460293734525642*^9}, 3.460293960827629*^9, {
   3.502932987610074*^9, 3.502932994665797*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["REPULSION700", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.453726891889468*^9, 3.453726907496131*^9}, {
  3.460290365992752*^9, 3.460290366148562*^9}, {3.460293538117641*^9, 
  3.46029353941752*^9}, {3.4602935962308397`*^9, 3.460293596717207*^9}, {
  3.460293631081135*^9, 3.4602936314554462`*^9}, {3.4602936672512913`*^9, 
  3.460293667593327*^9}, {3.460293704845626*^9, 3.460293705323667*^9}, {
  3.4602937466799507`*^9, 3.4602937472139893`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<REPULSION700\>\"", ",", "\[IndentingNewLine]", 
    "\"\<{\[Alpha],\[Beta]} REPULSION sampling with 700 orientations. \
Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"REPULSION700\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.428064495`", ",", "0.6537466864`", ",", "0"}], "}"}], 
         ",", "0.001427588`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.364570892`", ",", "0.256458785`", ",", "0"}], "}"}], ",",
          "0.001438149`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.707227684`", ",", "1.315630098`", ",", "0"}], "}"}], ",",
          "0.001416755`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.557792838`", ",", "1.848753118`", ",", "0"}], "}"}], ",",
          "0.001429027`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.87173303`", ",", "0.9274587492`", ",", "0"}], "}"}], ",",
          "0.001440295`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.684482946`", ",", "1.15699056`", ",", "0"}], "}"}], ",", 
         "0.001423162`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.014878285`", ",", "2.403858472`", ",", "0"}], "}"}], ",",
          "0.001413608`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3131385794`", ",", "1.126855478`", ",", "0"}], "}"}], 
         ",", "0.001431804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3586927898`", ",", "1.707588811`", ",", "0"}], "}"}], 
         ",", "0.001437516`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.922395592`", ",", "1.180422128`", ",", "0"}], "}"}], ",",
          "0.001419873`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.719320075`", ",", "1.784420508`", ",", "0"}], "}"}], ",",
          "0.001432218`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.781734447`", ",", "0.801025859`", ",", "0"}], "}"}], ",",
          "0.001436088`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.123524891`", ",", "2.488491756`", ",", "0"}], "}"}], ",",
          "0.00143285`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.731016556`", ",", "1.502791283`", ",", "0"}], "}"}], ",",
          "0.001435674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.244355441`", ",", "1.051908492`", ",", "0"}], "}"}], ",",
          "0.001415996`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.147591288`", ",", "2.520753854`", ",", "0"}], "}"}], ",",
          "0.001428685`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1738743427`", ",", "1.059960324`", ",", "0"}], "}"}], 
         ",", "0.001435775`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.877496378`", ",", "2.246916686`", ",", "0"}], "}"}], ",",
          "0.001434681`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.937652292`", ",", "1.470570707`", ",", "0"}], "}"}], ",",
          "0.001426752`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.233649958`", ",", "2.269420141`", ",", "0"}], "}"}], ",",
          "0.001440954`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9275166592`", ",", "2.419898292`", ",", "0"}], "}"}], 
         ",", "0.001425354`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.585872873`", ",", "2.626615263`", ",", "0"}], "}"}], ",",
          "0.001457597`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.503325022`", ",", "1.643870243`", ",", "0"}], "}"}], ",",
          "0.001433704`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6048416008`", ",", "1.554322949`", ",", "0"}], "}"}], 
         ",", "0.001437859`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2066519227`", ",", "1.354177283`", ",", "0"}], "}"}], 
         ",", "0.001433996`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.380937325`", ",", "1.024387442`", ",", "0"}], "}"}], ",",
          "0.00143625`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4525502789`", ",", "0.8927337656`", ",", "0"}], "}"}], 
         ",", "0.0014201`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.066380665`", ",", "1.332387789`", ",", "0"}], "}"}], ",",
          "0.001436019`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.03563428262`", ",", "2.633440304`", ",", "0"}], "}"}], 
         ",", "0.001437925`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.979583172`", ",", "0.7005717235`", ",", "0"}], "}"}], 
         ",", "0.001437963`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9180857377`", ",", "0.4496162059`", ",", "0"}], "}"}], 
         ",", "0.001443481`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.172139258`", ",", "0.833813911`", ",", "0"}], "}"}], ",",
          "0.001437761`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.02541932429`", ",", "2.262484185`", ",", "0"}], "}"}], 
         ",", "0.00142105`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.262038732`", ",", "1.248710003`", ",", "0"}], "}"}], ",",
          "0.001430643`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.26441108`", ",", "0.8583523676`", ",", "0"}], "}"}], ",",
          "0.001433241`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.994349391`", ",", "1.841088068`", ",", "0"}], "}"}], ",",
          "0.001444687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7074647966`", ",", "2.902425142`", ",", "0"}], "}"}], 
         ",", "0.001408788`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.651738292`", ",", "0.8918072576`", ",", "0"}], "}"}], 
         ",", "0.001437837`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.557347561`", ",", "2.00750516`", ",", "0"}], "}"}], ",", 
         "0.001438211`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.606374846`", ",", "1.542727872`", ",", "0"}], "}"}], ",",
          "0.001422447`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.75057353`", ",", "2.546946114`", ",", "0"}], "}"}], ",", 
         "0.001387258`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.602818127`", ",", "2.138780117`", ",", "0"}], "}"}], ",",
          "0.001451129`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7370706073`", ",", "1.618393253`", ",", "0"}], "}"}], 
         ",", "0.001437184`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.946114573`", ",", "0.9903746922`", ",", "0"}], "}"}], 
         ",", "0.001430925`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.301728427`", ",", "2.164734053`", ",", "0"}], "}"}], ",",
          "0.001432765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.181879381`", ",", "2.759474683`", ",", "0"}], "}"}], ",",
          "0.001437442`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.251314034`", ",", "1.116775713`", ",", "0"}], "}"}], ",",
          "0.001458094`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.165717205`", ",", "0.1854265024`", ",", "0"}], "}"}], 
         ",", "0.001415673`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.964193312`", ",", "2.246965677`", ",", "0"}], "}"}], ",",
          "0.001458776`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.509212497`", ",", "0.6466557627`", ",", "0"}], "}"}], 
         ",", "0.001437455`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.569682605`", ",", "1.380666057`", ",", "0"}], "}"}], ",",
          "0.001441556`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.62642867`", ",", "1.955510213`", ",", "0"}], "}"}], ",", 
         "0.001405685`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.203144901`", ",", "0.7652229252`", ",", "0"}], "}"}], 
         ",", "0.001413058`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.101873166`", ",", "1.234398512`", ",", "0"}], "}"}], ",",
          "0.001434108`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.055471398`", ",", "1.723851562`", ",", "0"}], "}"}], ",",
          "0.001435422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.203302024`", ",", "0.7126683562`", ",", "0"}], "}"}], 
         ",", "0.001430916`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1831142379`", ",", "2.87386707`", ",", "0"}], "}"}], ",",
          "0.001451489`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.159709529`", ",", "1.995791086`", ",", "0"}], "}"}], ",",
          "0.001431045`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.783442661`", ",", "2.957307073`", ",", "0"}], "}"}], ",",
          "0.00143605`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.194371899`", ",", "1.423425158`", ",", "0"}], "}"}], ",",
          "0.00142675`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.8931243`", ",", "2.106980183`", ",", "0"}], "}"}], ",", 
         "0.001434498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.140669453`", ",", "2.880468254`", ",", "0"}], "}"}], ",",
          "0.001412471`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.672630363`", ",", "0.8643773315`", ",", "0"}], "}"}], 
         ",", "0.001429961`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.364099444`", ",", "0.3321566119`", ",", "0"}], "}"}], 
         ",", "0.001414207`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.960921536`", ",", "1.176350205`", ",", "0"}], "}"}], ",",
          "0.001437369`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.824358947`", ",", "2.83225788`", ",", "0"}], "}"}], ",", 
         "0.001430143`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1490787816`", ",", "0.909383177`", ",", "0"}], "}"}], 
         ",", "0.001432861`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.19047519`", ",", "2.065875637`", ",", "0"}], "}"}], ",", 
         "0.001380358`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.477816677`", ",", "2.125981443`", ",", "0"}], "}"}], ",",
          "0.001435729`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.541833888`", ",", "2.223082818`", ",", "0"}], "}"}], ",",
          "0.001431152`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6294655786`", ",", "2.120723132`", ",", "0"}], "}"}], 
         ",", "0.001419692`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.575450377`", ",", "2.24764667`", ",", "0"}], "}"}], ",", 
         "0.001431132`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.626094885`", ",", "2.045384355`", ",", "0"}], "}"}], ",",
          "0.001437572`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.110971463`", ",", "1.381932905`", ",", "0"}], "}"}], ",",
          "0.001423886`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.000879078`", ",", "1.239789451`", ",", "0"}], "}"}], ",",
          "0.001443024`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7167647486`", ",", "0.3307233126`", ",", "0"}], "}"}], 
         ",", "0.001441457`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4863557881`", ",", "2.06045049`", ",", "0"}], "}"}], ",",
          "0.001429009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.287970399`", ",", "1.841980472`", ",", "0"}], "}"}], ",",
          "0.001438738`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.830550241`", ",", "1.254934039`", ",", "0"}], "}"}], ",",
          "0.001438298`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.322022235`", ",", "0.7329703402`", ",", "0"}], "}"}], 
         ",", "0.001436796`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.778464336`", ",", "1.875708471`", ",", "0"}], "}"}], ",",
          "0.001435741`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.164574067`", ",", "1.59298489`", ",", "0"}], "}"}], ",", 
         "0.00138716`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.566185882`", ",", "1.263868362`", ",", "0"}], "}"}], ",",
          "0.001434695`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4823505367`", ",", "1.630732487`", ",", "0"}], "}"}], 
         ",", "0.001438943`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.890828127`", ",", "1.818290647`", ",", "0"}], "}"}], ",",
          "0.001431905`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.508313915`", ",", "0.6097572857`", ",", "0"}], "}"}], 
         ",", "0.001436977`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.157938325`", ",", "1.290885238`", ",", "0"}], "}"}], ",",
          "0.001423088`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.725193999`", ",", "2.677810326`", ",", "0"}], "}"}], ",",
          "0.00142268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.10270136`", ",", "2.173011486`", ",", "0"}], "}"}], ",", 
         "0.001407587`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.634687769`", ",", "1.626495054`", ",", "0"}], "}"}], ",",
          "0.001430231`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.381910241`", ",", "1.158480739`", ",", "0"}], "}"}], ",",
          "0.001433464`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.69893436`", ",", "0.7232484723`", ",", "0"}], "}"}], ",",
          "0.001433423`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.913423745`", ",", "2.460457912`", ",", "0"}], "}"}], ",",
          "0.0014298`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.56723808`", ",", "0.7574731572`", ",", "0"}], "}"}], ",",
          "0.001432109`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08595786709`", ",", "1.432512459`", ",", "0"}], "}"}], 
         ",", "0.001429254`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.069619822`", ",", "2.108303422`", ",", "0"}], "}"}], ",",
          "0.001432783`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.91338903`", ",", "2.317354684`", ",", "0"}], "}"}], ",", 
         "0.001377217`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.158049851`", ",", "0.6301263079`", ",", "0"}], "}"}], 
         ",", "0.001427948`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.271256113`", ",", "0.8023319063`", ",", "0"}], "}"}], 
         ",", "0.001422509`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.49797948`", ",", "0.9478678964`", ",", "0"}], "}"}], ",",
          "0.00143468`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.309809686`", ",", "0.9785086699`", ",", "0"}], "}"}], 
         ",", "0.001448096`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.030196831`", ",", "2.209159`", ",", "0"}], "}"}], ",", 
         "0.00141832`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.082396094`", ",", "2.831156943`", ",", "0"}], "}"}], ",",
          "0.001375574`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.106771572`", ",", "0.4940988192`", ",", "0"}], "}"}], 
         ",", "0.001430629`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.258420595`", ",", "1.701958832`", ",", "0"}], "}"}], ",",
          "0.001436631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7462430455`", ",", "1.758342567`", ",", "0"}], "}"}], 
         ",", "0.00143483`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.784639084`", ",", "1.237398646`", ",", "0"}], "}"}], ",",
          "0.001434995`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7275142315`", ",", "1.478176102`", ",", "0"}], "}"}], 
         ",", "0.001436299`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.620847779`", ",", "1.598675431`", ",", "0"}], "}"}], ",",
          "0.001414839`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.764146362`", ",", "0.5481736747`", ",", "0"}], "}"}], 
         ",", "0.001429115`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.232995529`", ",", "0.89279658`", ",", "0"}], "}"}], ",", 
         "0.001383447`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3422243866`", ",", "1.419752811`", ",", "0"}], "}"}], 
         ",", "0.001435365`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.59594269`", ",", "1.696967714`", ",", "0"}], "}"}], ",", 
         "0.001418829`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.89366893`", ",", "1.341649082`", ",", "0"}], "}"}], ",", 
         "0.001426183`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.035447663`", ",", "2.788635906`", ",", "0"}], "}"}], ",",
          "0.001431853`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.704546632`", ",", "2.824421735`", ",", "0"}], "}"}], ",",
          "0.001414123`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.668983123`", ",", "1.763044972`", ",", "0"}], "}"}], ",",
          "0.001430003`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.125302369`", ",", "1.658601485`", ",", "0"}], "}"}], ",",
          "0.001456822`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.253431345`", ",", "2.485210695`", ",", "0"}], "}"}], ",",
          "0.001412168`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.169120999`", ",", "1.934289802`", ",", "0"}], "}"}], ",",
          "0.001437292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.614623568`", ",", "1.882729599`", ",", "0"}], "}"}], ",",
          "0.001438001`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.299421391`", ",", "0.6749122069`", ",", "0"}], "}"}], 
         ",", "0.001441089`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.505855662`", ",", "2.154349047`", ",", "0"}], "}"}], ",",
          "0.001434891`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.227222372`", ",", "1.380697892`", ",", "0"}], "}"}], ",",
          "0.001414458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.541613321`", ",", "0.7667853614`", ",", "0"}], "}"}], 
         ",", "0.001423899`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.820056964`", ",", "0.9505130651`", ",", "0"}], "}"}], 
         ",", "0.001398548`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.45225551`", ",", "1.309722961`", ",", "0"}], "}"}], ",", 
         "0.001421982`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.599790468`", ",", "1.448039641`", ",", "0"}], "}"}], ",",
          "0.00141922`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.433462616`", ",", "2.724806649`", ",", "0"}], "}"}], ",",
          "0.001405097`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.000454762`", ",", "0.6151025486`", ",", "0"}], "}"}], 
         ",", "0.001422094`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.368552984`", ",", "1.502764579`", ",", "0"}], "}"}], ",",
          "0.001442012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.92549568`", ",", "2.874076719`", ",", "0"}], "}"}], ",", 
         "0.001433839`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.700457797`", ",", "1.904790683`", ",", "0"}], "}"}], ",",
          "0.001437678`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.741952921`", ",", "0.5853393092`", ",", "0"}], "}"}], 
         ",", "0.001437212`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.213687353`", ",", "2.57128974`", ",", "0"}], "}"}], ",", 
         "0.001422986`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.676766304`", ",", "0.8707546424`", ",", "0"}], "}"}], 
         ",", "0.001432139`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.319088441`", ",", "2.011108811`", ",", "0"}], "}"}], ",",
          "0.001416644`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.067532434`", ",", "2.725169434`", ",", "0"}], "}"}], ",",
          "0.001420074`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.033590476`", ",", "0.5834319087`", ",", "0"}], "}"}], 
         ",", "0.001434918`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.08675063`", ",", "1.732909035`", ",", "0"}], "}"}], ",", 
         "0.001443251`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8409806518`", ",", "0.8129072926`", ",", "0"}], "}"}], 
         ",", "0.001419944`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.469965968`", ",", "1.503184069`", ",", "0"}], "}"}], ",",
          "0.001432235`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3198530879`", ",", "2.589875803`", ",", "0"}], "}"}], 
         ",", "0.00144112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.553575573`", ",", "2.577001417`", ",", "0"}], "}"}], ",",
          "0.001434114`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.669704502`", ",", "0.6810657143`", ",", "0"}], "}"}], 
         ",", "0.001429565`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1022266919`", ",", "1.570274316`", ",", "0"}], "}"}], 
         ",", "0.00142408`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.160996805`", ",", "0.677140591`", ",", "0"}], "}"}], ",",
          "0.001441288`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2731418812`", ",", "2.731725169`", ",", "0"}], "}"}], 
         ",", "0.001449255`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8210529187`", ",", "0.9455750399`", ",", "0"}], "}"}], 
         ",", "0.001447067`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.365205127`", ",", "1.604448072`", ",", "0"}], "}"}], ",",
          "0.001435985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.881920622`", ",", "1.560229318`", ",", "0"}], "}"}], ",",
          "0.00143023`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.339350666`", ",", "1.297260944`", ",", "0"}], "}"}], ",",
          "0.0014051`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.468719593`", ",", "2.017483783`", ",", "0"}], "}"}], ",",
          "0.001438619`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.728385596`", ",", "2.554560166`", ",", "0"}], "}"}], ",",
          "0.00143121`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.278607745`", ",", "2.629419973`", ",", "0"}], "}"}], ",",
          "0.001445665`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.761411937`", ",", "0.5320468673`", ",", "0"}], "}"}], 
         ",", "0.001415102`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.207960448`", ",", "1.365942425`", ",", "0"}], "}"}], ",",
          "0.001432727`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2075327031`", ",", "2.066982822`", ",", "0"}], "}"}], 
         ",", "0.001435224`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.236427396`", ",", "1.757205607`", ",", "0"}], "}"}], ",",
          "0.001429026`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.161667222`", ",", "1.932229266`", ",", "0"}], "}"}], ",",
          "0.001417243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.469690947`", ",", "1.886707239`", ",", "0"}], "}"}], ",",
          "0.001437747`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.839522`", ",", "1.409837298`", ",", "0"}], "}"}], ",", 
         "0.001440455`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.423214706`", ",", "1.073085863`", ",", "0"}], "}"}], ",",
          "0.001436894`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.702031873`", ",", "1.355491166`", ",", "0"}], "}"}], ",",
          "0.00142826`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.557153838`", ",", "0.6086266789`", ",", "0"}], "}"}], 
         ",", "0.001422464`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.504305304`", ",", "0.5656480333`", ",", "0"}], "}"}], 
         ",", "0.001427655`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3439477771`", ",", "2.292388953`", ",", "0"}], "}"}], 
         ",", "0.001433619`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.763310349`", ",", "1.125338089`", ",", "0"}], "}"}], ",",
          "0.001416361`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.285843514`", ",", "0.4152798898`", ",", "0"}], "}"}], 
         ",", "0.001392823`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.081577822`", ",", "0.8248293051`", ",", "0"}], "}"}], 
         ",", "0.001423594`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.58360898`", ",", "1.912360194`", ",", "0"}], "}"}], ",", 
         "0.001438499`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.46860071`", ",", "2.347775511`", ",", "0"}], "}"}], ",", 
         "0.001428747`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.130495867`", ",", "2.208512862`", ",", "0"}], "}"}], ",",
          "0.001440161`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3037817994`", ",", "0.9721062437`", ",", "0"}], "}"}], 
         ",", "0.001434819`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5748184819`", ",", "2.638005387`", ",", "0"}], "}"}], 
         ",", "0.001424691`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.716836324`", ",", "1.367193966`", ",", "0"}], "}"}], ",",
          "0.001440384`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.398290374`", ",", "1.083212665`", ",", "0"}], "}"}], ",",
          "0.001428112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4804448466`", ",", "0.758643924`", ",", "0"}], "}"}], 
         ",", "0.001433785`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.245040142`", ",", "1.510661426`", ",", "0"}], "}"}], ",",
          "0.00140224`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.84895164`", ",", "2.383661505`", ",", "0"}], "}"}], ",", 
         "0.001436364`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.263335391`", ",", "1.723284295`", ",", "0"}], "}"}], ",",
          "0.001435577`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.425650182`", ",", "2.115982295`", ",", "0"}], "}"}], ",",
          "0.0014388`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.109895878`", ",", "1.081354727`", ",", "0"}], "}"}], ",",
          "0.001437874`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.753397394`", ",", "1.747013949`", ",", "0"}], "}"}], ",",
          "0.001424195`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.777734387`", ",", "1.418297293`", ",", "0"}], "}"}], ",",
          "0.001431621`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.05734527`", ",", "1.97163243`", ",", "0"}], "}"}], ",", 
         "0.001435687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.52273975`", ",", "1.711081546`", ",", "0"}], "}"}], ",", 
         "0.001433627`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.747819976`", ",", "0.3419852067`", ",", "0"}], "}"}], 
         ",", "0.001438713`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.305968505`", ",", "1.265366727`", ",", "0"}], "}"}], ",",
          "0.001433251`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.773424497`", ",", "2.225364278`", ",", "0"}], "}"}], ",",
          "0.001428075`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.654786343`", ",", "2.126942002`", ",", "0"}], "}"}], ",",
          "0.001436025`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.741435823`", ",", "0.2481106483`", ",", "0"}], "}"}], 
         ",", "0.001372211`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.111355024`", ",", "1.512202308`", ",", "0"}], "}"}], ",",
          "0.00145588`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.505264231`", ",", "0.3584291753`", ",", "0"}], "}"}], 
         ",", "0.001438893`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9702617972`", ",", "1.021314231`", ",", "0"}], "}"}], 
         ",", "0.001445143`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.090803179`", ",", "1.367876075`", ",", "0"}], "}"}], ",",
          "0.00144874`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.881071335`", ",", "1.993482556`", ",", "0"}], "}"}], ",",
          "0.001434069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.535401538`", ",", "1.167501386`", ",", "0"}], "}"}], ",",
          "0.001418909`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.693997163`", ",", "1.176554147`", ",", "0"}], "}"}], ",",
          "0.001428788`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4766418265`", ",", "0.09975883125`", ",", "0"}], "}"}], 
         ",", "0.001430117`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.744209396`", ",", "1.5337566`", ",", "0"}], "}"}], ",", 
         "0.001418001`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.758721861`", ",", "0.7075183957`", ",", "0"}], "}"}], 
         ",", "0.001419896`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.129565459`", ",", "0.9708881784`", ",", "0"}], "}"}], 
         ",", "0.001431888`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.403494833`", ",", "1.542204203`", ",", "0"}], "}"}], ",",
          "0.001440459`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.77627386`", ",", "2.734518307`", ",", "0"}], "}"}], ",", 
         "0.001421763`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.141086718`", ",", "1.797295436`", ",", "0"}], "}"}], ",",
          "0.001424909`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.61250514`", ",", "2.167239141`", ",", "0"}], "}"}], ",", 
         "0.001441825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.913824045`", ",", "0.3147165141`", ",", "0"}], "}"}], 
         ",", "0.001434525`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1050262698`", ",", "1.710534333`", ",", "0"}], "}"}], 
         ",", "0.00142441`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.584354253`", ",", "0.622244366`", ",", "0"}], "}"}], ",",
          "0.001435804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.756577479`", ",", "0.9649352268`", ",", "0"}], "}"}], 
         ",", "0.001445629`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.807598567`", ",", "1.265738482`", ",", "0"}], "}"}], ",",
          "0.001431009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.334392431`", ",", "0.2387167452`", ",", "0"}], "}"}], 
         ",", "0.00143798`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.075028728`", ",", "1.845163324`", ",", "0"}], "}"}], ",",
          "0.001423014`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.818384388`", ",", "0.9598247457`", ",", "0"}], "}"}], 
         ",", "0.001440375`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.158535271`", ",", "0.8346244419`", ",", "0"}], "}"}], 
         ",", "0.001431992`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.091397996`", ",", "2.343869534`", ",", "0"}], "}"}], ",",
          "0.001438689`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.867849698`", ",", "1.676394646`", ",", "0"}], "}"}], ",",
          "0.001422163`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.115904898`", ",", "1.522275493`", ",", "0"}], "}"}], ",",
          "0.001430802`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.017813179`", ",", "1.586372134`", ",", "0"}], "}"}], ",",
          "0.001433136`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.840359271`", ",", "1.42080109`", ",", "0"}], "}"}], ",", 
         "0.001423081`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.656311193`", ",", "1.214471565`", ",", "0"}], "}"}], ",",
          "0.001425842`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.155403732`", ",", "0.1337255565`", ",", "0"}], "}"}], 
         ",", "0.001414482`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.608362637`", ",", "1.048183348`", ",", "0"}], "}"}], ",",
          "0.001423599`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.263415056`", ",", "1.061969006`", ",", "0"}], "}"}], ",",
          "0.001439124`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.604208194`", ",", "1.486817157`", ",", "0"}], "}"}], ",",
          "0.001401199`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.020779008`", ",", "1.59825835`", ",", "0"}], "}"}], ",", 
         "0.001418896`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.737677309`", ",", "1.933732815`", ",", "0"}], "}"}], ",",
          "0.001431279`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.029205257`", ",", "1.602430088`", ",", "0"}], "}"}], ",",
          "0.001438449`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.319645838`", ",", "2.029324934`", ",", "0"}], "}"}], ",",
          "0.001429129`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.315272645`", ",", "2.851736033`", ",", "0"}], "}"}], ",",
          "0.00142914`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.685389714`", ",", "2.370104956`", ",", "0"}], "}"}], ",",
          "0.001421006`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.456074875`", ",", "0.707156554`", ",", "0"}], "}"}], ",",
          "0.00141979`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.039631679`", ",", "1.081783973`", ",", "0"}], "}"}], ",",
          "0.001422388`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5698351829`", ",", "0.4612739058`", ",", "0"}], "}"}], 
         ",", "0.001429391`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.796638458`", ",", "1.698882393`", ",", "0"}], "}"}], ",",
          "0.001425351`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.53822418`", ",", "1.132794729`", ",", "0"}], "}"}], ",", 
         "0.001436751`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.74734268`", ",", "2.075331464`", ",", "0"}], "}"}], ",", 
         "0.001422909`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.388418766`", ",", "1.764350147`", ",", "0"}], "}"}], ",",
          "0.001435379`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.255539414`", ",", "2.402604313`", ",", "0"}], "}"}], ",",
          "0.001413944`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.774209171`", ",", "2.663855825`", ",", "0"}], "}"}], ",",
          "0.00143206`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.082908253`", ",", "0.3036301827`", ",", "0"}], "}"}], 
         ",", "0.001430899`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.140106489`", ",", "0.988832048`", ",", "0"}], "}"}], ",",
          "0.001408111`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.285694236`", ",", "0.5891899593`", ",", "0"}], "}"}], 
         ",", "0.001438027`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.07579722341`", ",", "1.988050812`", ",", "0"}], "}"}], 
         ",", "0.001428644`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.113937118`", ",", "1.473927569`", ",", "0"}], "}"}], ",",
          "0.001431208`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.03725092`", ",", "2.028607744`", ",", "0"}], "}"}], ",", 
         "0.001422303`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8992575969`", ",", "1.977406904`", ",", "0"}], "}"}], 
         ",", "0.00143991`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.378452228`", ",", "2.949789469`", ",", "0"}], "}"}], ",",
          "0.001417077`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2229772438`", ",", "1.495728162`", ",", "0"}], "}"}], 
         ",", "0.001432766`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.380097935`", ",", "1.649175538`", ",", "0"}], "}"}], ",",
          "0.001433449`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.687408188`", ",", "1.756201013`", ",", "0"}], "}"}], ",",
          "0.001435525`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5835620753`", ",", "0.9731932522`", ",", "0"}], "}"}], 
         ",", "0.001392577`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.02261349808`", ",", "1.006060629`", ",", "0"}], "}"}], 
         ",", "0.001433118`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8546770009`", ",", "2.288687685`", ",", "0"}], "}"}], 
         ",", "0.001421683`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.01848755718`", ",", "0.471599867`", ",", "0"}], "}"}], 
         ",", "0.00143801`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.146771936`", ",", "0.4399650413`", ",", "0"}], "}"}], 
         ",", "0.001425037`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4414306466`", ",", "1.047579045`", ",", "0"}], "}"}], 
         ",", "0.001426077`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.155519761`", ",", "2.171851541`", ",", "0"}], "}"}], ",",
          "0.001417576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.241533427`", ",", "1.877855279`", ",", "0"}], "}"}], ",",
          "0.00141696`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.254328471`", ",", "1.503725505`", ",", "0"}], "}"}], ",",
          "0.001426642`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.205412616`", ",", "2.233639948`", ",", "0"}], "}"}], ",",
          "0.001431667`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7570205235`", ",", "1.897938643`", ",", "0"}], "}"}], 
         ",", "0.00142814`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.590675993`", ",", "1.729809732`", ",", "0"}], "}"}], ",",
          "0.00143982`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.50788685`", ",", "0.7909452037`", ",", "0"}], "}"}], ",",
          "0.001435073`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8452464285`", ",", "1.105851418`", ",", "0"}], "}"}], 
         ",", "0.001414253`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.62694513`", ",", "1.885565777`", ",", "0"}], "}"}], ",", 
         "0.001435725`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.599535694`", ",", "1.000990256`", ",", "0"}], "}"}], ",",
          "0.001436804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4947372257`", ",", "2.210707299`", ",", "0"}], "}"}], 
         ",", "0.001430844`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.809130679`", ",", "1.080799084`", ",", "0"}], "}"}], ",",
          "0.001386055`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.218910905`", ",", "1.355060384`", ",", "0"}], "}"}], ",",
          "0.00143294`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.639311155`", ",", "1.825361464`", ",", "0"}], "}"}], ",",
          "0.001384661`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.091926997`", ",", "2.352596075`", ",", "0"}], "}"}], ",",
          "0.001410639`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.730929823`", ",", "1.289403489`", ",", "0"}], "}"}], ",",
          "0.001431817`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3501987436`", ",", "1.994574068`", ",", "0"}], "}"}], 
         ",", "0.001433611`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.465189499`", ",", "2.716259824`", ",", "0"}], "}"}], ",",
          "0.001434864`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.131401126`", ",", "2.098725055`", ",", "0"}], "}"}], ",",
          "0.001429924`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.051437331`", ",", "0.9423756245`", ",", "0"}], "}"}], 
         ",", "0.001437954`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.684714918`", ",", "2.309597672`", ",", "0"}], "}"}], ",",
          "0.001435144`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.650481314`", ",", "2.87979447`", ",", "0"}], "}"}], ",", 
         "0.001399301`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.411870947`", ",", "2.754854011`", ",", "0"}], "}"}], ",",
          "0.001433658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.126122918`", ",", "2.299067944`", ",", "0"}], "}"}], ",",
          "0.001378147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.98032424`", ",", "0.8083751961`", ",", "0"}], "}"}], ",",
          "0.00143947`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8747990415`", ",", "0.6799813238`", ",", "0"}], "}"}], 
         ",", "0.00137712`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.498975329`", ",", "1.544150298`", ",", "0"}], "}"}], ",",
          "0.001381724`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.976390476`", ",", "1.458410021`", ",", "0"}], "}"}], ",",
          "0.001434749`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.916592582`", ",", "1.699020885`", ",", "0"}], "}"}], ",",
          "0.001435428`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.65805566`", ",", "0.8547956833`", ",", "0"}], "}"}], ",",
          "0.001460151`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.08575259`", ",", "1.030783393`", ",", "0"}], "}"}], ",", 
         "0.001371857`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.223659632`", ",", "1.988786521`", ",", "0"}], "}"}], ",",
          "0.001432656`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.823692607`", ",", "1.546415927`", ",", "0"}], "}"}], ",",
          "0.001429911`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.550240319`", ",", "1.568930657`", ",", "0"}], "}"}], ",",
          "0.001426337`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.927091479`", ",", "1.863319374`", ",", "0"}], "}"}], ",",
          "0.001432053`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9989209761`", ",", "3.02501117`", ",", "0"}], "}"}], ",",
          "0.001384048`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.11602906`", ",", "1.714223139`", ",", "0"}], "}"}], ",", 
         "0.001403324`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.127392917`", ",", "1.659949194`", ",", "0"}], "}"}], ",",
          "0.001432374`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.375018625`", ",", "2.262349009`", ",", "0"}], "}"}], ",",
          "0.001436315`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.373462123`", ",", "0.5485686078`", ",", "0"}], "}"}], 
         ",", "0.00144028`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.897379299`", ",", "1.954201548`", ",", "0"}], "}"}], ",",
          "0.001433441`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.732666208`", ",", "2.045902351`", ",", "0"}], "}"}], ",",
          "0.001447271`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3573210832`", ",", "1.851017455`", ",", "0"}], "}"}], 
         ",", "0.001435849`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.995196696`", ",", "2.600453738`", ",", "0"}], "}"}], ",",
          "0.0014306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1909068887`", ",", "1.209890739`", ",", "0"}], "}"}], 
         ",", "0.001432727`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.62143969`", ",", "2.972209445`", ",", "0"}], "}"}], ",", 
         "0.001432768`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.795394335`", ",", "0.3795607492`", ",", "0"}], "}"}], 
         ",", "0.001435492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4738275704`", ",", "1.487649819`", ",", "0"}], "}"}], 
         ",", "0.001437154`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.10714907`", ",", "1.246351155`", ",", "0"}], "}"}], ",", 
         "0.001399519`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.23106372`", ",", "1.202287788`", ",", "0"}], "}"}], ",", 
         "0.001432504`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.412832484`", ",", "1.169624998`", ",", "0"}], "}"}], ",",
          "0.001428724`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4491586853`", ",", "1.198441134`", ",", "0"}], "}"}], 
         ",", "0.001430611`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.459126024`", ",", "2.523380382`", ",", "0"}], "}"}], ",",
          "0.00144017`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.363588883`", ",", "1.201821191`", ",", "0"}], "}"}], ",",
          "0.001420655`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9759189154`", ",", "1.32368268`", ",", "0"}], "}"}], ",",
          "0.00142924`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.714783416`", ",", "2.400333151`", ",", "0"}], "}"}], ",",
          "0.00143348`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.223713239`", ",", "1.795172522`", ",", "0"}], "}"}], ",",
          "0.001432885`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.889702215`", ",", "2.368135282`", ",", "0"}], "}"}], ",",
          "0.001432698`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.388211298`", ",", "1.529408741`", ",", "0"}], "}"}], ",",
          "0.001378689`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.120178319`", ",", "1.651676752`", ",", "0"}], "}"}], ",",
          "0.001434437`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.869932129`", ",", "1.697901954`", ",", "0"}], "}"}], ",",
          "0.001429461`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.0514231419`", ",", "2.127392803`", ",", "0"}], "}"}], 
         ",", "0.001428774`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7504002627`", ",", "0.5651042586`", ",", "0"}], "}"}], 
         ",", "0.001419097`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.187786273`", ",", "1.109208471`", ",", "0"}], "}"}], ",",
          "0.001422681`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.429105933`", ",", "1.023568359`", ",", "0"}], "}"}], ",",
          "0.001436968`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.146586564`", ",", "1.793612494`", ",", "0"}], "}"}], ",",
          "0.001437288`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.379980718`", ",", "0.4038129893`", ",", "0"}], "}"}], 
         ",", "0.001435498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.486971575`", ",", "1.98306678`", ",", "0"}], "}"}], ",", 
         "0.001422353`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.442201759`", ",", "1.927235722`", ",", "0"}], "}"}], ",",
          "0.001425565`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.62810861`", ",", "2.311773592`", ",", "0"}], "}"}], ",", 
         "0.001436336`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.943346062`", ",", "1.476537028`", ",", "0"}], "}"}], ",",
          "0.001429613`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.897319487`", ",", "2.449203278`", ",", "0"}], "}"}], ",",
          "0.001443836`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.441324382`", ",", "2.759973707`", ",", "0"}], "}"}], ",",
          "0.00142715`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.903016539`", ",", "2.078280059`", ",", "0"}], "}"}], ",",
          "0.001431679`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.461455497`", ",", "2.102303015`", ",", "0"}], "}"}], ",",
          "0.001438945`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.275119112`", ",", "2.604731034`", ",", "0"}], "}"}], ",",
          "0.001435515`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4624366441`", ",", "1.343770862`", ",", "0"}], "}"}], 
         ",", "0.001435124`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.068299392`", ",", "1.224859154`", ",", "0"}], "}"}], ",",
          "0.001439874`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6192034789`", ",", "1.836562394`", ",", "0"}], "}"}], 
         ",", "0.001436505`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.1959759`", ",", "0.6984863168`", ",", "0"}], "}"}], ",", 
         "0.001428157`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.97998178`", ",", "0.9314114312`", ",", "0"}], "}"}], ",",
          "0.001424541`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.049817534`", ",", "0.8713116817`", ",", "0"}], "}"}], 
         ",", "0.001421524`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.347564116`", ",", "2.238996469`", ",", "0"}], "}"}], ",",
          "0.001436587`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.312162451`", ",", "1.63862675`", ",", "0"}], "}"}], ",", 
         "0.001421576`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.361207834`", ",", "1.139458553`", ",", "0"}], "}"}], ",",
          "0.001425053`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.027424105`", ",", "1.882412211`", ",", "0"}], "}"}], ",",
          "0.001436837`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.661903168`", ",", "1.009302544`", ",", "0"}], "}"}], ",",
          "0.001418522`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.517386493`", ",", "1.159323279`", ",", "0"}], "}"}], ",",
          "0.001445514`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.198093665`", ",", "1.744475035`", ",", "0"}], "}"}], ",",
          "0.001431602`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.013319645`", ",", "0.5589909461`", ",", "0"}], "}"}], 
         ",", "0.001428569`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.80739261`", ",", "0.4855273501`", ",", "0"}], "}"}], ",",
          "0.001429664`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.016647997`", ",", "0.4747375851`", ",", "0"}], "}"}], 
         ",", "0.001383787`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.484763436`", ",", "1.267193616`", ",", "0"}], "}"}], ",",
          "0.001429438`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.021075888`", ",", "0.3578851562`", ",", "0"}], "}"}], 
         ",", "0.00142675`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.956907986`", ",", "1.098099765`", ",", "0"}], "}"}], ",",
          "0.001436211`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.912769045`", ",", "2.611945544`", ",", "0"}], "}"}], ",",
          "0.00143527`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.257666246`", ",", "2.436777214`", ",", "0"}], "}"}], ",",
          "0.001428053`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.188441898`", ",", "2.074111252`", ",", "0"}], "}"}], ",",
          "0.001433067`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.54828582`", ",", "1.123981846`", ",", "0"}], "}"}], ",", 
         "0.001431988`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.364489193`", ",", "1.540525668`", ",", "0"}], "}"}], ",",
          "0.001443053`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.990872626`", ",", "2.596187734`", ",", "0"}], "}"}], ",",
          "0.001435535`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.790209224`", ",", "2.175494095`", ",", "0"}], "}"}], ",",
          "0.001425273`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08471866586`", ",", "0.6121842533`", ",", "0"}], "}"}], 
         ",", "0.001437557`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.468964498`", ",", "0.8391020143`", ",", "0"}], "}"}], 
         ",", "0.001434648`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.170331175`", ",", "1.357709532`", ",", "0"}], "}"}], ",",
          "0.001427032`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6128535522`", ",", "1.695393515`", ",", "0"}], "}"}], 
         ",", "0.00143824`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.612550144`", ",", "1.359170827`", ",", "0"}], "}"}], ",",
          "0.001429044`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9402781925`", ",", "2.137548298`", ",", "0"}], "}"}], 
         ",", "0.00145775`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.238765553`", ",", "1.276052855`", ",", "0"}], "}"}], ",",
          "0.001446227`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.400701337`", ",", "0.861731517`", ",", "0"}], "}"}], ",",
          "0.001471158`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.386352715`", ",", "2.243697234`", ",", "0"}], "}"}], ",",
          "0.001430281`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.017545891`", ",", "1.884615148`", ",", "0"}], "}"}], ",",
          "0.001432906`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.972207489`", ",", "1.731241792`", ",", "0"}], "}"}], ",",
          "0.001428598`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.88374285`", ",", "0.4209031312`", ",", "0"}], "}"}], ",",
          "0.001431074`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.032629645`", ",", "0.555365077`", ",", "0"}], "}"}], ",",
          "0.001434531`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.879382877`", ",", "2.506571517`", ",", "0"}], "}"}], ",",
          "0.001426474`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.768450789`", ",", "0.2298244847`", ",", "0"}], "}"}], 
         ",", "0.001437183`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.490720307`", ",", "1.421091496`", ",", "0"}], "}"}], ",",
          "0.001429175`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.311196202`", ",", "1.880204457`", ",", "0"}], "}"}], ",",
          "0.00143179`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.513141356`", ",", "0.9369934131`", ",", "0"}], "}"}], 
         ",", "0.001431611`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.975948559`", ",", "0.9403087881`", ",", "0"}], "}"}], 
         ",", "0.001405611`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.697464661`", ",", "2.596294601`", ",", "0"}], "}"}], ",",
          "0.001431665`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.810485796`", ",", "1.807142269`", ",", "0"}], "}"}], ",",
          "0.00143313`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.28463565`", ",", "1.65125063`", ",", "0"}], "}"}], ",", 
         "0.001438886`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.107358274`", ",", "2.72726444`", ",", "0"}], "}"}], ",", 
         "0.001434653`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.220723482`", ",", "0.4454664413`", ",", "0"}], "}"}], 
         ",", "0.001438009`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.454299421`", ",", "2.664711804`", ",", "0"}], "}"}], ",",
          "0.001429141`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.227777082`", ",", "1.561344723`", ",", "0"}], "}"}], ",",
          "0.001432839`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.894674284`", ",", "0.6758696597`", ",", "0"}], "}"}], 
         ",", "0.001433492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.240460075`", ",", "1.484864465`", ",", "0"}], "}"}], ",",
          "0.001405982`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.950101236`", ",", "2.237988873`", ",", "0"}], "}"}], ",",
          "0.001435289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.660889167`", ",", "1.487306722`", ",", "0"}], "}"}], ",",
          "0.001432263`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.677050592`", ",", "1.034451412`", ",", "0"}], "}"}], ",",
          "0.001436041`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.9804711`", ",", "1.601078924`", ",", "0"}], "}"}], ",", 
         "0.001421118`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.267252581`", ",", "1.480389074`", ",", "0"}], "}"}], ",",
          "0.001454527`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.573570448`", ",", "2.495974943`", ",", "0"}], "}"}], ",",
          "0.001392809`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.000944162`", ",", "0.8842600176`", ",", "0"}], "}"}], 
         ",", "0.001447858`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.601563096`", ",", "0.2934426086`", ",", "0"}], "}"}], 
         ",", "0.001434084`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.024469542`", ",", "0.2115039555`", ",", "0"}], "}"}], 
         ",", "0.001430983`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.691132119`", ",", "1.172083451`", ",", "0"}], "}"}], ",",
          "0.00144356`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.948637647`", ",", "1.054957878`", ",", "0"}], "}"}], ",",
          "0.001435132`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.092912497`", ",", "1.246129132`", ",", "0"}], "}"}], ",",
          "0.001417416`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.258106252`", ",", "1.639130784`", ",", "0"}], "}"}], ",",
          "0.001395068`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.453455746`", ",", "1.4137331`", ",", "0"}], "}"}], ",", 
         "0.001424841`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.564442333`", ",", "0.9220602538`", ",", "0"}], "}"}], 
         ",", "0.001422047`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.187338606`", ",", "0.8633356317`", ",", "0"}], "}"}], 
         ",", "0.001408955`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.755295911`", ",", "2.037019271`", ",", "0"}], "}"}], ",",
          "0.00143276`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.721631371`", ",", "2.003682068`", ",", "0"}], "}"}], ",",
          "0.001436272`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.689860803`", ",", "0.9264735632`", ",", "0"}], "}"}], 
         ",", "0.001430102`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.197305151`", ",", "1.122585495`", ",", "0"}], "}"}], ",",
          "0.001434503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.976938562`", ",", "1.469910833`", ",", "0"}], "}"}], ",",
          "0.001426344`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.604938954`", ",", "1.634778334`", ",", "0"}], "}"}], ",",
          "0.001431853`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.661515277`", ",", "2.450980774`", ",", "0"}], "}"}], ",",
          "0.001446541`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.303764363`", ",", "0.9249181606`", ",", "0"}], "}"}], 
         ",", "0.001438514`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.227775293`", ",", "0.2859396475`", ",", "0"}], "}"}], 
         ",", "0.001426414`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.22774242`", ",", "2.856364472`", ",", "0"}], "}"}], ",", 
         "0.001432173`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.479339843`", ",", "2.369715137`", ",", "0"}], "}"}], ",",
          "0.001416157`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.012335446`", ",", "1.191328778`", ",", "0"}], "}"}], ",",
          "0.001436699`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.08283144`", ",", "1.378507609`", ",", "0"}], "}"}], ",", 
         "0.001383062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.398322384`", ",", "1.744278546`", ",", "0"}], "}"}], ",",
          "0.00143724`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.532936723`", ",", "1.086518877`", ",", "0"}], "}"}], ",",
          "0.001428417`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.923076908`", ",", "0.6841225014`", ",", "0"}], "}"}], 
         ",", "0.001427439`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.633537344`", ",", "1.248637537`", ",", "0"}], "}"}], ",",
          "0.001434897`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.846322991`", ",", "2.188545196`", ",", "0"}], "}"}], ",",
          "0.001416185`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.15828232`", ",", "3.013497791`", ",", "0"}], "}"}], ",", 
         "0.001450961`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6610124048`", ",", "2.26599556`", ",", "0"}], "}"}], ",",
          "0.001423384`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.802142677`", ",", "1.48786322`", ",", "0"}], "}"}], ",", 
         "0.001431937`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.614530752`", ",", "0.749786762`", ",", "0"}], "}"}], ",",
          "0.001434074`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.770343773`", ",", "1.894841172`", ",", "0"}], "}"}], ",",
          "0.001420825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.140912482`", ",", "2.405504597`", ",", "0"}], "}"}], ",",
          "0.001435854`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.759964981`", ",", "2.81223555`", ",", "0"}], "}"}], ",", 
         "0.00143141`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1955525013`", ",", "2.210706409`", ",", "0"}], "}"}], 
         ",", "0.001430735`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.247996468`", ",", "0.5616196563`", ",", "0"}], "}"}], 
         ",", "0.001414728`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.300068332`", ",", "1.634541825`", ",", "0"}], "}"}], ",",
          "0.001423338`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.457258103`", ",", "2.383739521`", ",", "0"}], "}"}], ",",
          "0.001436171`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.34718696`", ",", "2.896679134`", ",", "0"}], "}"}], ",", 
         "0.001418831`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.453146221`", ",", "1.677003818`", ",", "0"}], "}"}], ",",
          "0.001444589`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.390948847`", ",", "2.003451685`", ",", "0"}], "}"}], ",",
          "0.00143575`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.205184099`", ",", "2.043014547`", ",", "0"}], "}"}], ",",
          "0.001413697`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.795760112`", ",", "2.498423832`", ",", "0"}], "}"}], ",",
          "0.001415143`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.485045455`", ",", "1.822759091`", ",", "0"}], "}"}], ",",
          "0.001423815`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.351019179`", ",", "1.360538903`", ",", "0"}], "}"}], ",",
          "0.001418491`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1190919481`", ",", "0.7578273019`", ",", "0"}], "}"}], 
         ",", "0.001433096`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.301706427`", ",", "2.116465122`", ",", "0"}], "}"}], ",",
          "0.00143508`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.648487127`", ",", "0.4821682545`", ",", "0"}], "}"}], 
         ",", "0.001437553`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.387101741`", ",", "1.88938077`", ",", "0"}], "}"}], ",", 
         "0.001374435`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.113624458`", ",", "0.5797492639`", ",", "0"}], "}"}], 
         ",", "0.001439272`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2301467248`", ",", "1.782135139`", ",", "0"}], "}"}], 
         ",", "0.00143343`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.97628478`", ",", "2.972275627`", ",", "0"}], "}"}], ",", 
         "0.001422621`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.295503982`", ",", "0.3794361502`", ",", "0"}], "}"}], 
         ",", "0.001434054`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.043061382`", ",", "2.304949494`", ",", "0"}], "}"}], ",",
          "0.001433972`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6176819532`", ",", "2.77197131`", ",", "0"}], "}"}], ",",
          "0.001421042`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.77599062`", ",", "1.283291922`", ",", "0"}], "}"}], ",", 
         "0.001418083`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.175601494`", ",", "0.3407809993`", ",", "0"}], "}"}], 
         ",", "0.001428469`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.121878182`", ",", "1.160885541`", ",", "0"}], "}"}], ",",
          "0.001412689`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.62830338`", ",", "0.3665291262`", ",", "0"}], "}"}], ",",
          "0.001418268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.396920395`", ",", "0.6998789325`", ",", "0"}], "}"}], 
         ",", "0.001424486`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.884702903`", ",", "1.569403484`", ",", "0"}], "}"}], ",",
          "0.001448582`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.037703867`", ",", "2.442530762`", ",", "0"}], "}"}], ",",
          "0.001434105`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.752211783`", ",", "1.571724336`", ",", "0"}], "}"}], ",",
          "0.001405232`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.08859505`", ",", "1.471501648`", ",", "0"}], "}"}], ",", 
         "0.00142091`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.701290527`", ",", "0.8395329012`", ",", "0"}], "}"}], 
         ",", "0.001378552`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.544331987`", ",", "0.4282485762`", ",", "0"}], "}"}], 
         ",", "0.001432391`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.373859534`", ",", "0.6970282338`", ",", "0"}], "}"}], 
         ",", "0.00143599`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.966985683`", ",", "2.215858901`", ",", "0"}], "}"}], ",",
          "0.001432424`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2961368384`", ",", "0.5260723784`", ",", "0"}], "}"}], 
         ",", "0.001438571`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.106696985`", ",", "1.107729654`", ",", "0"}], "}"}], ",",
          "0.001427236`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.717024514`", ",", "1.446925353`", ",", "0"}], "}"}], ",",
          "0.00138944`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.0445293`", ",", "2.352741478`", ",", "0"}], "}"}], ",", 
         "0.001432571`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.433628911`", ",", "1.881193919`", ",", "0"}], "}"}], ",",
          "0.001439102`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.765310243`", ",", "2.246364638`", ",", "0"}], "}"}], ",",
          "0.001431626`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.288413905`", ",", "1.861603907`", ",", "0"}], "}"}], ",",
          "0.001433831`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.313110872`", ",", "2.152593822`", ",", "0"}], "}"}], ",",
          "0.001419458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.058573694`", ",", "0.7988685797`", ",", "0"}], "}"}], 
         ",", "0.001439547`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.611083395`", ",", "1.30059091`", ",", "0"}], "}"}], ",", 
         "0.001442655`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.550878454`", ",", "2.292862513`", ",", "0"}], "}"}], ",",
          "0.001425236`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.322091498`", ",", "1.379135037`", ",", "0"}], "}"}], ",",
          "0.001418654`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.031568493`", ",", "2.480026805`", ",", "0"}], "}"}], ",",
          "0.001435475`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.145629033`", ",", "2.481833448`", ",", "0"}], "}"}], ",",
          "0.001435471`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.457809173`", ",", "2.242668781`", ",", "0"}], "}"}], ",",
          "0.001439924`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.780225827`", ",", "0.7399411328`", ",", "0"}], "}"}], 
         ",", "0.001433064`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.170622279`", ",", "0.9130939738`", ",", "0"}], "}"}], 
         ",", "0.001413411`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.12468325`", ",", "2.502286717`", ",", "0"}], "}"}], ",", 
         "0.001428135`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.615733257`", ",", "3.019192574`", ",", "0"}], "}"}], ",",
          "0.00143209`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.008722169`", ",", "1.740170041`", ",", "0"}], "}"}], ",",
          "0.001430103`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8780187376`", ",", "2.665138432`", ",", "0"}], "}"}], 
         ",", "0.001431687`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.444082508`", ",", "1.361456702`", ",", "0"}], "}"}], ",",
          "0.001432049`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.802566269`", ",", "2.518677523`", ",", "0"}], "}"}], ",",
          "0.001427804`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.05126721418`", ",", "1.151837772`", ",", "0"}], "}"}], 
         ",", "0.001430666`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.350041506`", ",", "0.8776845071`", ",", "0"}], "}"}], 
         ",", "0.00143614`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6245529305`", ",", "1.977954676`", ",", "0"}], "}"}], 
         ",", "0.001432516`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.150983546`", ",", "2.240916244`", ",", "0"}], "}"}], ",",
          "0.001429659`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.145377251`", ",", "0.9661226092`", ",", "0"}], "}"}], 
         ",", "0.001431267`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.988426895`", ",", "0.7537801975`", ",", "0"}], "}"}], 
         ",", "0.001431056`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5950188529`", ",", "1.412345529`", ",", "0"}], "}"}], 
         ",", "0.001435057`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7886314033`", ",", "2.166359216`", ",", "0"}], "}"}], 
         ",", "0.001383999`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.407939899`", ",", "1.788792279`", ",", "0"}], "}"}], ",",
          "0.001436111`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.003532956`", ",", "1.743240774`", ",", "0"}], "}"}], ",",
          "0.001436537`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.0918485453`", ",", "1.849540802`", ",", "0"}], "}"}], 
         ",", "0.001429737`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8430608923`", ",", "1.258523972`", ",", "0"}], "}"}], 
         ",", "0.001426842`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.043931289`", ",", "1.3756356`", ",", "0"}], "}"}], ",", 
         "0.001439969`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.915440656`", ",", "3.105241826`", ",", "0"}], "}"}], ",",
          "0.001426258`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.705140079`", ",", "2.412830128`", ",", "0"}], "}"}], ",",
          "0.001420935`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.790297625`", ",", "0.6749620536`", ",", "0"}], "}"}], 
         ",", "0.001432214`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.102099466`", ",", "1.114742509`", ",", "0"}], "}"}], ",",
          "0.00138904`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8821701952`", ",", "1.828264802`", ",", "0"}], "}"}], 
         ",", "0.001442729`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7138042862`", ",", "1.190203617`", ",", "0"}], "}"}], 
         ",", "0.001427842`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.17896346`", ",", "1.623551783`", ",", "0"}], "}"}], ",", 
         "0.001426196`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.979295175`", ",", "0.2081094646`", ",", "0"}], "}"}], 
         ",", "0.001431413`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.59551011`", ",", "2.093275543`", ",", "0"}], "}"}], ",", 
         "0.001424643`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.299599545`", ",", "0.564132372`", ",", "0"}], "}"}], ",",
          "0.001442584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.747809487`", ",", "0.161443462`", ",", "0"}], "}"}], ",",
          "0.001433481`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.542864339`", ",", "1.779088842`", ",", "0"}], "}"}], ",",
          "0.001437448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.899723276`", ",", "1.98651412`", ",", "0"}], "}"}], ",", 
         "0.001465744`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.858134018`", ",", "1.169276822`", ",", "0"}], "}"}], ",",
          "0.001429172`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.579376505`", ",", "0.8173886349`", ",", "0"}], "}"}], 
         ",", "0.001434628`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.890620703`", ",", "2.125358517`", ",", "0"}], "}"}], ",",
          "0.001388536`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.825902428`", ",", "2.357899729`", ",", "0"}], "}"}], ",",
          "0.001448423`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9838759587`", ",", "1.463788829`", ",", "0"}], "}"}], 
         ",", "0.001436118`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.728956135`", ",", "2.175997308`", ",", "0"}], "}"}], ",",
          "0.001432664`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.051587822`", ",", "0.7446128731`", ",", "0"}], "}"}], 
         ",", "0.001439414`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.38161988`", ",", "0.8464613347`", ",", "0"}], "}"}], ",",
          "0.001434361`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4879067749`", ",", "1.916523135`", ",", "0"}], "}"}], 
         ",", "0.001435911`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.778030526`", ",", "1.669090792`", ",", "0"}], "}"}], ",",
          "0.001428329`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.67772079`", ",", "0.05340641189`", ",", "0"}], "}"}], 
         ",", "0.001430537`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.937969322`", ",", "1.70832061`", ",", "0"}], "}"}], ",", 
         "0.001447696`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.037245474`", ",", "2.541985295`", ",", "0"}], "}"}], ",",
          "0.001432608`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.203597954`", ",", "2.213029478`", ",", "0"}], "}"}], ",",
          "0.001429654`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.663237995`", ",", "1.499440966`", ",", "0"}], "}"}], ",",
          "0.001429586`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.338617514`", ",", "1.89403017`", ",", "0"}], "}"}], ",", 
         "0.001418805`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.668116365`", ",", "0.6222136832`", ",", "0"}], "}"}], 
         ",", "0.0014301`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.626229344`", ",", "1.056845208`", ",", "0"}], "}"}], ",",
          "0.001450127`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.502115901`", ",", "1.817114592`", ",", "0"}], "}"}], ",",
          "0.001443196`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.861694436`", ",", "1.554114767`", ",", "0"}], "}"}], ",",
          "0.001441265`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.487956167`", ",", "0.8901451107`", ",", "0"}], "}"}], 
         ",", "0.001436199`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.952179863`", ",", "1.837073566`", ",", "0"}], "}"}], ",",
          "0.00143539`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.958749963`", ",", "2.081368646`", ",", "0"}], "}"}], ",",
          "0.001428624`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.256093278`", ",", "2.361002506`", ",", "0"}], "}"}], ",",
          "0.00143662`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.459698335`", ",", "1.021138284`", ",", "0"}], "}"}], ",",
          "0.001431062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.304792929`", ",", "1.324222214`", ",", "0"}], "}"}], ",",
          "0.001431416`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.042415034`", ",", "2.165363401`", ",", "0"}], "}"}], ",",
          "0.001433062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2198800698`", ",", "1.923503597`", ",", "0"}], "}"}], 
         ",", "0.001432997`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.807942153`", ",", "0.8169750966`", ",", "0"}], "}"}], 
         ",", "0.001438299`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.236159183`", ",", "1.435811061`", ",", "0"}], "}"}], ",",
          "0.001434978`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.193747934`", ",", "0.3346489421`", ",", "0"}], "}"}], 
         ",", "0.001432014`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.564394241`", ",", "1.228627459`", ",", "0"}], "}"}], ",",
          "0.001420947`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.864676759`", ",", "0.8637011909`", ",", "0"}], "}"}], 
         ",", "0.001429028`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.497640432`", ",", "0.4626296775`", ",", "0"}], "}"}], 
         ",", "0.001442906`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.455466453`", ",", "2.078050356`", ",", "0"}], "}"}], ",",
          "0.001438146`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.464141463`", ",", "1.647849472`", ",", "0"}], "}"}], ",",
          "0.001420151`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.712476911`", ",", "1.042080717`", ",", "0"}], "}"}], ",",
          "0.001393973`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.229376667`", ",", "1.90751858`", ",", "0"}], "}"}], ",", 
         "0.001423958`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.145753797`", ",", "2.700472239`", ",", "0"}], "}"}], ",",
          "0.001407292`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8698362152`", ",", "1.684905622`", ",", "0"}], "}"}], 
         ",", "0.001441518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.900701595`", ",", "1.965154972`", ",", "0"}], "}"}], ",",
          "0.001432547`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.037577435`", ",", "1.976752772`", ",", "0"}], "}"}], ",",
          "0.001430556`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.914383667`", ",", "0.6114134461`", ",", "0"}], "}"}], 
         ",", "0.001431699`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2319201539`", ",", "1.638817044`", ",", "0"}], "}"}], 
         ",", "0.001433062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.160559487`", ",", "1.223604855`", ",", "0"}], "}"}], ",",
          "0.001436712`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.640695646`", ",", "2.43054049`", ",", "0"}], "}"}], ",", 
         "0.001427836`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.040116436`", ",", "2.025041931`", ",", "0"}], "}"}], ",",
          "0.00143423`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.923743039`", ",", "1.304563454`", ",", "0"}], "}"}], ",",
          "0.001433824`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.043936202`", ",", "2.737872516`", ",", "0"}], "}"}], ",",
          "0.001437903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.344338233`", ",", "2.120670912`", ",", "0"}], "}"}], ",",
          "0.00143873`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.691832048`", ",", "1.805135559`", ",", "0"}], "}"}], ",",
          "0.001432671`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.458725733`", ",", "1.668856813`", ",", "0"}], "}"}], ",",
          "0.001438641`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3270293931`", ",", "1.275754717`", ",", "0"}], "}"}], 
         ",", "0.001433068`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.847527547`", ",", "2.317457169`", ",", "0"}], "}"}], ",",
          "0.001431587`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.967836635`", ",", "1.033067017`", ",", "0"}], "}"}], ",",
          "0.001436237`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.828486554`", ",", "2.121198578`", ",", "0"}], "}"}], ",",
          "0.001433921`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7704731897`", ",", "2.036037872`", ",", "0"}], "}"}], 
         ",", "0.001407911`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.744683287`", ",", "1.64938229`", ",", "0"}], "}"}], ",", 
         "0.001424514`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.334315837`", ",", "1.463307467`", ",", "0"}], "}"}], ",",
          "0.001432975`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3368611295`", ",", "2.442829248`", ",", "0"}], "}"}], 
         ",", "0.001437149`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.847417887`", ",", "0.5785851817`", ",", "0"}], "}"}], 
         ",", "0.001429637`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.240484842`", ",", "0.4734985758`", ",", "0"}], "}"}], 
         ",", "0.001420666`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.977216157`", ",", "1.445917303`", ",", "0"}], "}"}], ",",
          "0.001430109`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.845805867`", ",", "1.415638162`", ",", "0"}], "}"}], ",",
          "0.001464444`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.194212394`", ",", "2.657992077`", ",", "0"}], "}"}], ",",
          "0.00143566`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.579751715`", ",", "1.402668411`", ",", "0"}], "}"}], ",",
          "0.001424724`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8507707097`", ",", "1.402287929`", ",", "0"}], "}"}], 
         ",", "0.001436061`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.282462654`", ",", "2.369247494`", ",", "0"}], "}"}], ",",
          "0.001419988`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.847973217`", ",", "1.94611919`", ",", "0"}], "}"}], ",", 
         "0.001441584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.802432305`", ",", "2.729965895`", ",", "0"}], "}"}], ",",
          "0.00142141`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.277022751`", ",", "2.615689886`", ",", "0"}], "}"}], ",",
          "0.001378535`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.850348933`", ",", "1.212178272`", ",", "0"}], "}"}], ",",
          "0.001419153`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.2266045`", ",", "2.351501631`", ",", "0"}], "}"}], ",", 
         "0.001426227`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.482452577`", ",", "2.621870167`", ",", "0"}], "}"}], ",",
          "0.001428178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.939792379`", ",", "1.232429886`", ",", "0"}], "}"}], ",",
          "0.001431154`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.952014632`", ",", "1.319065447`", ",", "0"}], "}"}], ",",
          "0.001432041`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.763505844`", ",", "2.693369517`", ",", "0"}], "}"}], ",",
          "0.001433572`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.120663869`", ",", "1.002329918`", ",", "0"}], "}"}], ",",
          "0.001422453`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.275899893`", ",", "1.188495446`", ",", "0"}], "}"}], ",",
          "0.001432099`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.130890355`", ",", "1.50119195`", ",", "0"}], "}"}], ",", 
         "0.001412203`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.431067169`", ",", "2.408241116`", ",", "0"}], "}"}], ",",
          "0.001449741`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.882058947`", ",", "1.610254591`", ",", "0"}], "}"}], ",",
          "0.001428852`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.80538426`", ",", "0.4491376541`", ",", "0"}], "}"}], ",",
          "0.001438128`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.994457566`", ",", "1.596798033`", ",", "0"}], "}"}], ",",
          "0.001428065`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.976248424`", ",", "0.4521546477`", ",", "0"}], "}"}], 
         ",", "0.001435276`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.155942603`", ",", "1.611401028`", ",", "0"}], "}"}], ",",
          "0.001431619`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.250318279`", ",", "1.770450963`", ",", "0"}], "}"}], ",",
          "0.001410101`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.700352972`", ",", "1.397533146`", ",", "0"}], "}"}], ",",
          "0.001385141`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.034040394`", ",", "2.086767804`", ",", "0"}], "}"}], ",",
          "0.001427226`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.77237092`", ",", "0.9900878823`", ",", "0"}], "}"}], ",",
          "0.001433876`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.351848847`", ",", "2.503171197`", ",", "0"}], "}"}], ",",
          "0.00141737`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.506355193`", ",", "2.483945296`", ",", "0"}], "}"}], ",",
          "0.001420349`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.993116761`", ",", "0.7400571449`", ",", "0"}], "}"}], 
         ",", "0.001433365`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.97773075`", ",", "0.8926933089`", ",", "0"}], "}"}], ",",
          "0.001435338`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.16249407`", ",", "2.073067406`", ",", "0"}], "}"}], ",", 
         "0.001440584`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5131585651`", ",", "2.358649767`", ",", "0"}], "}"}], 
         ",", "0.001430926`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.41661188`", ",", "1.269292461`", ",", "0"}], "}"}], ",", 
         "0.00142825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.470024471`", ",", "1.961646826`", ",", "0"}], "}"}], ",",
          "0.001431269`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.320549518`", ",", "1.999025792`", ",", "0"}], "}"}], ",",
          "0.001415162`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7180739026`", ",", "1.336149515`", ",", "0"}], "}"}], 
         ",", "0.00143226`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.847200227`", ",", "1.834551408`", ",", "0"}], "}"}], ",",
          "0.001417979`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.502984264`", ",", "2.554269114`", ",", "0"}], "}"}], ",",
          "0.001458138`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.647726722`", ",", "1.675524128`", ",", "0"}], "}"}], ",",
          "0.00143047`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.360676643`", ",", "1.758639063`", ",", "0"}], "}"}], ",",
          "0.001385004`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.494020829`", ",", "1.571808618`", ",", "0"}], "}"}], ",",
          "0.001424961`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.148685436`", ",", "1.864133221`", ",", "0"}], "}"}], ",",
          "0.001434233`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.316730353`", ",", "1.980893357`", ",", "0"}], "}"}], ",",
          "0.001439829`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.516925116`", ",", "0.9813099931`", ",", "0"}], "}"}], 
         ",", "0.001436613`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.735167299`", ",", "2.315407769`", ",", "0"}], "}"}], ",",
          "0.001411445`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.265735899`", ",", "0.6087751017`", ",", "0"}], "}"}], 
         ",", "0.001394412`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.69736927`", ",", "1.117791198`", ",", "0"}], "}"}], ",", 
         "0.001436485`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5772732002`", ",", "1.123362742`", ",", "0"}], "}"}], 
         ",", "0.001421559`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.605647095`", ",", "2.022602991`", ",", "0"}], "}"}], ",",
          "0.001430694`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.523436451`", ",", "2.344611909`", ",", "0"}], "}"}], ",",
          "0.001381822`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5418656883`", ",", "2.499801036`", ",", "0"}], "}"}], 
         ",", "0.001432294`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.55506309`", ",", "1.310361996`", ",", "0"}], "}"}], ",", 
         "0.001430675`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.501743047`", ",", "1.440610036`", ",", "0"}], "}"}], ",",
          "0.00142714`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.620715283`", ",", "2.439723016`", ",", "0"}], "}"}], ",",
          "0.001430154`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.418185722`", ",", "1.401462772`", ",", "0"}], "}"}], ",",
          "0.001433917`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.978211518`", ",", "1.869764124`", ",", "0"}], "}"}], ",",
          "0.001396723`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.06827892095`", ",", "1.293900085`", ",", "0"}], "}"}], 
         ",", "0.00143174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.48097684`", ",", "0.2116272979`", ",", "0"}], "}"}], ",",
          "0.001426458`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.472307292`", ",", "1.289177486`", ",", "0"}], "}"}], ",",
          "0.001380905`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.025222633`", ",", "1.115232859`", ",", "0"}], "}"}], ",",
          "0.001429543`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.525519265`", ",", "1.512231193`", ",", "0"}], "}"}], ",",
          "0.001420662`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.096937489`", ",", "1.85904789`", ",", "0"}], "}"}], ",", 
         "0.00142833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.825712031`", ",", "1.105343841`", ",", "0"}], "}"}], ",",
          "0.001441773`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.450943886`", ",", "2.225491216`", ",", "0"}], "}"}], ",",
          "0.001455708`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6688172379`", ",", "0.7143364895`", ",", "0"}], "}"}], 
         ",", "0.001421011`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.117312426`", ",", "1.810053251`", ",", "0"}], "}"}], ",",
          "0.001431187`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.88262247`", ",", "1.044246112`", ",", "0"}], "}"}], ",", 
         "0.001382723`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9922548656`", ",", "1.603804517`", ",", "0"}], "}"}], 
         ",", "0.001436718`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.303374116`", ",", "1.009781881`", ",", "0"}], "}"}], ",",
          "0.001416114`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.24132753`", ",", "2.127087196`", ",", "0"}], "}"}], ",", 
         "0.001424903`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.881193743`", ",", "0.8309492847`", ",", "0"}], "}"}], 
         ",", "0.001426289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.282983713`", ",", "2.300486024`", ",", "0"}], "}"}], ",",
          "0.001432291`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.348374202`", ",", "0.9406209926`", ",", "0"}], "}"}], 
         ",", "0.001431601`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7801894377`", ",", "2.535233157`", ",", "0"}], "}"}], 
         ",", "0.001430315`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3535028788`", ",", "1.563534029`", ",", "0"}], "}"}], 
         ",", "0.001436723`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.007561969`", ",", "2.632278054`", ",", "0"}], "}"}], ",",
          "0.001426279`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2939975185`", ",", "0.8208332516`", ",", "0"}], "}"}], 
         ",", "0.001428493`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.03130652`", ",", "2.28974237`", ",", "0"}], "}"}], ",", 
         "0.001423693`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9690321603`", ",", "1.179593586`", ",", "0"}], "}"}], 
         ",", "0.001411824`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.999987712`", ",", "1.733742587`", ",", "0"}], "}"}], ",",
          "0.001408992`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.423375485`", ",", "1.222423599`", ",", "0"}], "}"}], ",",
          "0.001436007`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.582808433`", ",", "1.994452418`", ",", "0"}], "}"}], ",",
          "0.001439356`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.743710031`", ",", "1.62269926`", ",", "0"}], "}"}], ",", 
         "0.001431825`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.952669724`", ",", "1.321528054`", ",", "0"}], "}"}], ",",
          "0.001425914`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.864239729`", ",", "1.357001871`", ",", "0"}], "}"}], ",",
          "0.001435666`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.115299975`", ",", "0.6941818287`", ",", "0"}], "}"}], 
         ",", "0.001436994`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.673953279`", ",", "2.179208278`", ",", "0"}], "}"}], ",",
          "0.001434123`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.844484147`", ",", "1.826682941`", ",", "0"}], "}"}], ",",
          "0.001431935`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.192083335`", ",", "1.93609538`", ",", "0"}], "}"}], ",", 
         "0.001440252`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.015582586`", ",", "1.350585866`", ",", "0"}], "}"}], ",",
          "0.001431268`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.35265875`", ",", "1.406903609`", ",", "0"}], "}"}], ",", 
         "0.001432875`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.495955875`", ",", "2.802366132`", ",", "0"}], "}"}], ",",
          "0.001409653`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.280635775`", ",", "2.518403593`", ",", "0"}], "}"}], ",",
          "0.001438267`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.515690985`", ",", "0.5119677618`", ",", "0"}], "}"}], 
         ",", "0.001425781`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.830347407`", ",", "1.744220217`", ",", "0"}], "}"}], ",",
          "0.001433625`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.751246738`", ",", "1.938382599`", ",", "0"}], "}"}], ",",
          "0.0014451`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.080787869`", ",", "1.958330578`", ",", "0"}], "}"}], ",",
          "0.001427433`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4871689021`", ",", "1.773568801`", ",", "0"}], "}"}], 
         ",", "0.001438284`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.34494874`", ",", "1.761983044`", ",", "0"}], "}"}], ",", 
         "0.001413079`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.8602543402`", ",", "1.543407416`", ",", "0"}], "}"}], 
         ",", "0.001440025`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.787945759`", ",", "2.061571498`", ",", "0"}], "}"}], ",",
          "0.001427289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.663794486`", ",", "2.264024543`", ",", "0"}], "}"}], ",",
          "0.001412636`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5857357782`", ",", "1.268426027`", ",", "0"}], "}"}], 
         ",", "0.00143229`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.249248245`", ",", "1.580110852`", ",", "0"}], "}"}], ",",
          "0.001444534`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.221088954`", ",", "0.9763819164`", ",", "0"}], "}"}], 
         ",", "0.001438796`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.777616482`", ",", "1.049161867`", ",", "0"}], "}"}], ",",
          "0.00144037`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.004090894`", ",", "1.9722826`", ",", "0"}], "}"}], ",", 
         "0.001434498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.707939456`", ",", "1.615792817`", ",", "0"}], "}"}], ",",
          "0.001433781`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.510968421`", ",", "0.5029406921`", ",", "0"}], "}"}], 
         ",", "0.00144046`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.263863955`", ",", "1.120617636`", ",", "0"}], "}"}], ",",
          "0.001436935`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"5.321112804`", ",", "0.1112743566`", ",", "0"}], "}"}], 
         ",", "0.001422359`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.02019825`", ",", "2.579628696`", ",", "0"}], "}"}], ",", 
         "0.001419592`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.859375252`", ",", "1.111606466`", ",", "0"}], "}"}], ",",
          "0.0014334`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.356624783`", ",", "0.789078417`", ",", "0"}], "}"}], ",",
          "0.001436203`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1709006158`", ",", "2.357320699`", ",", "0"}], "}"}], 
         ",", "0.001431354`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"3.086266048`", ",", "1.510988204`", ",", "0"}], "}"}], ",",
          "0.001433252`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"6.209368387`", ",", "1.247001814`", ",", "0"}], "}"}], ",",
          "0.001422426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.997312899`", ",", "2.107688664`", ",", "0"}], "}"}], ",",
          "0.001434037`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4.541947421`", ",", "1.766759556`", ",", "0"}], "}"}], ",",
          "0.00143146`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.248982309`", ",", "0.7374030925`", ",", "0"}], "}"}], 
         ",", "0.00138289`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.341709558`", ",", "2.374366719`", ",", "0"}], "}"}], ",",
          "0.001424503`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.859177262`", ",", "0.8141555346`", ",", "0"}], "}"}], 
         ",", "0.001420831`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3475461399`", ",", "2.141597026`", ",", "0"}], "}"}], 
         ",", "0.001433454`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"2.385047924`", ",", "2.475981324`", ",", "0"}], "}"}], ",",
          "0.00143269`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.4602936022416773`*^9, 3.460293773782957*^9}, 3.46029396788678*^9, {
   3.5029330028861313`*^9, 3.5029330096797113`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["POLYTOPE schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.460279343107243*^9, 3.460279344680427*^9}}],

Cell[CellGroupData[{

Cell["POLYTOPE12", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279348184935*^9, 3.4602793510576*^9}, {
  3.4602795018529053`*^9, 3.460279502041996*^9}, {3.46027962649162*^9, 
  3.460279626680447*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<POLYTOPE12\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Orientations derived from half of the vertices of the 24-cell 4D \
polytope. Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"POLYTOPE12\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"1", "/", "12"}]}], "}"}], "&"}], "/@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948968`"}], ",", "0.`", ",", "0.`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.5707963267948966`", ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "1.5707963267948963`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "3.141592653589793`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", "1.5707963267948966`", ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948966`"}], ",", "1.5707963267948966`", 
         ",", "1.5707963267948966`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.5707963267948966`", ",", "0.`", ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "3.141592653589793`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.5707963267948966`", ",", "1.5707963267948966`", ",", 
         "1.5707963267948966`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948968`"}], ",", "1.5707963267948966`", 
         ",", 
         RowBox[{"-", "1.5707963267948966`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", "1.5707963267948966`", ",",
          "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948963`"}], ",", 
         RowBox[{"-", "3.141592653589793`"}], ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.5707963267948966`", ",", 
         RowBox[{"-", "3.141592653589793`"}], ",", "0.`"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
  3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
  3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, {
  3.460279413483419*^9, 3.460279505906567*^9}, {3.460279629425297*^9, 
  3.460279629689054*^9}, {3.50293302684474*^9, 3.502933031991694*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["POLYTOPE60", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460279348184935*^9, 3.4602793510576*^9}, {
  3.4602796438271847`*^9, 3.460279644001395*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<POLYTOPE60\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Orientations derived from half of the vertices of the 600-cell 4D \
polytope. Generate orientations and weights using \!\(\*
StyleBox[\"OrientationsAndWeights\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"POLYTOPE60\",
FontSlant->\"Italic\"]\)\\\"\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"1", "/", "60"}]}], "}"}], "&"}], "/@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.`", ",", "0.`", ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", "0.`", ",", "0.`"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", 
         RowBox[{"-", "3.141592653589793`"}], ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", 
         RowBox[{"-", "3.141592653589793`"}], ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.5707963267948966`", ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "3.141592653589793`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.`", ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "1.5707963267948966`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", "1.5707963267948966`", ",",
          "1.5707963267948966`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948963`"}], ",", "1.5707963267948966`", 
         ",", "0.`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "3.141592653589793`"}], ",", "1.5707963267948966`", ",", 
         RowBox[{"-", "1.5707963267948968`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.5707963267948966`", ",", "1.5707963267948966`", ",", "0.`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5707963267948968`"}], ",", "1.5707963267948966`", 
         ",", 
         RowBox[{"-", "3.141592653589793`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0.`", ",", "1.5707963267948966`", ",", "1.5707963267948966`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.0172219678978518`", ",", "0.6283185307179591`", ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.77672882547631`", ",", "1.0471975511965974`", ",", 
         "2.77672882547631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.1243706856919413`", ",", "1.2566370614359172`", ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.124370685691942`", ",", "0.6283185307179586`", ",", 
         "2.124370685691942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.0172219678978518`", ",", "1.8849555921538759`", ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.77672882547631`", ",", "2.094395102393195`", ",", 
         RowBox[{"-", "2.7767288254763103`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.3648638281134833`", ",", "1.0471975511965974`", ",", 
         RowBox[{"-", "2.77672882547631`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.1243706856919413`", ",", "1.8849555921538759`", ",", 
         "2.1243706856919413`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.1243706856919413`", ",", "2.5132741228718345`", ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.0172219678978518`", ",", "1.2566370614359172`", ",", 
         "2.124370685691942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0.3648638281134833`", ",", "2.094395102393195`", ",", 
         "2.77672882547631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.0172219678978518`", ",", "2.5132741228718345`", ",", 
         "2.124370685691942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.1243706856919418`"}], ",", "0.6283185307179582`", 
         ",", "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.7767288254763103`"}], ",", "1.0471975511965974`", 
         ",", 
         RowBox[{"-", "2.7767288254763103`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.017221967897851`", ",", "1.2566370614359172`", ",", 
         RowBox[{"-", "1.0172219678978518`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.017221967897851`"}], ",", "0.6283185307179586`", ",", 
         RowBox[{"-", "1.017221967897851`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.1243706856919413`", ",", "1.8849555921538759`", ",", 
         RowBox[{"-", "1.0172219678978514`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.7767288254763103`"}], ",", "2.094395102393195`", ",",
          "2.77672882547631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.3648638281134833`"}], ",", "1.0471975511965974`", 
         ",", "2.77672882547631`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.0172219678978518`", ",", "1.8849555921538759`", ",", 
         "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.0172219678978514`"}], ",", "2.5132741228718345`", 
         ",", "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.1243706856919413`", ",", "1.2566370614359172`", ",", 
         "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.36486382811348284`"}], ",", "2.094395102393195`", 
         ",", 
         RowBox[{"-", "2.7767288254763103`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.124370685691942`"}], ",", "2.5132741228718345`", ",", 
         RowBox[{"-", "1.0172219678978518`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.1243706856919413`", ",", "0.6283185307179586`", ",", 
         RowBox[{"-", "1.0172219678978514`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.3648638281134833`"}], ",", "1.0471975511965974`", 
         ",", 
         RowBox[{"-", "0.3648638281134833`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.124370685691942`"}], ",", "1.2566370614359172`", ",",
          "2.124370685691942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "1.017221967897851`", ",", "0.6283185307179586`", ",", 
         "1.017221967897851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.0172219678978518`"}], ",", "1.8849555921538759`", 
         ",", "2.1243706856919413`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.36486382811348284`"}], ",", "2.094395102393195`", 
         ",", "0.3648638281134833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.7767288254763103`"}], ",", "1.0471975511965974`", 
         ",", "0.3648638281134833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.124370685691942`"}], ",", "1.8849555921538759`", ",", 
         RowBox[{"-", "2.124370685691942`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.0172219678978518`", ",", "2.5132741228718345`", ",", 
         RowBox[{"-", "1.0172219678978518`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.017221967897851`"}], ",", "1.2566370614359172`", ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.7767288254763103`"}], ",", "2.094395102393195`", ",", 
         RowBox[{"-", "0.3648638281134833`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.1243706856919413`", ",", "2.5132741228718345`", ",", 
         "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.0172219678978518`"}], ",", "0.6283185307179586`", 
         ",", "2.1243706856919413`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "0.3648638281134833`", ",", "1.0471975511965974`", ",", 
         "0.3648638281134833`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.017221967897851`"}], ",", "1.2566370614359172`", ",",
          "1.017221967897851`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.124370685691942`"}], ",", "0.6283185307179582`", ",", 
         RowBox[{"-", "2.124370685691942`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.1243706856919418`"}], ",", "1.8849555921538759`", 
         ",", "1.0172219678978518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.3648638281134833`", ",", "2.094395102393195`", ",", 
         RowBox[{"-", "0.3648638281134833`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2.77672882547631`", ",", "1.0471975511965974`", ",", 
         RowBox[{"-", "0.36486382811348284`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.0172219678978514`"}], ",", "1.8849555921538759`", 
         ",", 
         RowBox[{"-", "1.0172219678978514`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.1243706856919418`"}], ",", "2.5132741228718345`", 
         ",", "2.124370685691942`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.1243706856919418`"}], ",", "1.2566370614359172`", 
         ",", 
         RowBox[{"-", "1.0172219678978514`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "2.77672882547631`", ",", "2.094395102393195`", ",", 
         "0.36486382811348284`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.0172219678978518`"}], ",", "2.5132741228718345`", 
         ",", 
         RowBox[{"-", "2.1243706856919418`"}]}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
  3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
  3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, {
  3.460279413483419*^9, 3.4602795464881144`*^9}, {3.5029330437861853`*^9, 
  3.502933062825808*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lebedev schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.460279343107243*^9, 3.460279344680427*^9}, {
  3.502933330679803*^9, 3.502933332198575*^9}}],

Cell[CellGroupData[{

Cell["Leboct10", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.5029333572622547`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct10\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 10 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct10\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.0253968254`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.7853981634`", ",", "0"}], "}"}], ",", 
         "0.09029982363`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.7853981634`", ",", "0"}], "}"}], 
         ",", "0.09029982363`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553164381`", ",", "0"}], "}"}], 
         ",", "0.16875`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.249046625`", ",", "1.264518968`", ",", "0"}], "}"}], ",",
          "0.1613866843`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3217497023`", ",", "1.264518968`", ",", "0"}], "}"}], 
         ",", "0.1613866843`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.4405106312`", ",", "0"}], "}"}], 
         ",", "0.1613866843`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.09029982363`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.0253968254`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.0253968254`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.50293368439647*^9}, 3.5029345877170343`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct16", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.5029333597979527`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct16\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 16 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct16\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.023088`"}], "}"}],
        ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553164381`", ",", "0"}], "}"}], 
         ",", "0.0955513`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.161712094`", ",", "1.192215213`", ",", "0"}], "}"}], ",",
          "0.0888844`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4090842327`", ",", "1.192215213`", ",", "0"}], "}"}], 
         ",", "0.0888844`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.5500118815`", ",", "0"}], "}"}], 
         ",", "0.0888844`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2658415703`", ",", "0.8032738256`", ",", "0"}], "}"}], 
         ",", "0.095012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.304954756`", ",", "0.8032738256`", ",", "0"}], "}"}], 
         ",", "0.095012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.3805886`", ",", "0"}], "}"}], ",", 
         "0.095012`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.3835797364`", ",", "0"}], "}"}], 
         ",", "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.18721659`", ",", "0"}], "}"}], ",", 
         "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.3835797364`", ",", "0"}], "}"}], ",", 
         "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.18721659`", ",", "0"}], "}"}], ",", 
         "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3835797364`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.18721659`", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.0472492`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.023088`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.023088`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.5029337023055143`*^9}, 3.502934600929513*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct19", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933368198657*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct19\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 19 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct19\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.00765654099`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553164381`", ",", "0"}], "}"}], 
         ",", "0.0783499001`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.381291967`", ",", "1.384606348`", ",", "0"}], "}"}], ",",
          "0.06569389827`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1895043595`", ",", "1.384606348`", ",", "0"}], "}"}], 
         ",", "0.06569389827`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.2648798939`", ",", "0"}], "}"}], 
         ",", "0.06569389827`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.125356886`", ",", "1.163977531`", ",", "0"}], "}"}], ",",
          "0.07676377069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.445439441`", ",", "1.163977531`", ",", "0"}], "}"}], ",",
          "0.07676377069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.5938901659`", ",", "0"}], "}"}], 
         ",", "0.07676377069`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3031497284`", ",", "0.8087262342`", ",", "0"}], "}"}], 
         ",", "0.07954251913`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.267646598`", ",", "0.8087262342`", ",", "0"}], "}"}], 
         ",", "0.07954251913`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.353124098`", ",", "0"}], "}"}], 
         ",", "0.07954251913`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.4987959016`", ",", "0"}], "}"}], 
         ",", "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.072000425`", ",", "0"}], "}"}], ",",
          "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.4987959016`", ",", "0"}], "}"}], ",", 
         "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.072000425`", ",", "0"}], "}"}], ",", 
         "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4987959016`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.072000425`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.03877998545`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.00765654099`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.00765654099`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.5029337353557367`*^9}, 3.5029346159884*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct22", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933376237849*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct22\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 22 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct22\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.001199262738`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.7853981634`", ",", "0"}], "}"}], ",", 
         "0.02949199887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.7853981634`", ",", "0"}], "}"}], 
         ",", "0.02949199887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553164381`", ",", "0"}], "}"}], 
         ",", "0.05768412288`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.410655387`", ",", "1.412671242`", ",", "0"}], "}"}], ",",
          "0.0605952`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1601405911`", ",", "1.412671242`", ",", "0"}], "}"}], 
         ",", "0.0605952`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.2245750055`", ",", "0"}], "}"}], 
         ",", "0.0605952`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.093415615`", ",", "1.140108409`", ",", "0"}], "}"}], ",",
          "0.0540306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4773807117`", ",", "1.140108409`", ",", "0"}], "}"}], 
         ",", "0.0540306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.6315898794`", ",", "0"}], "}"}], 
         ",", "0.0540306`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4066337904`", ",", "0.8278759867`", ",", "0"}], "}"}], 
         ",", "0.0569308`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.164162536`", ",", "0.8278759867`", ",", "0"}], "}"}], 
         ",", "0.0569308`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.275212601`", ",", "0"}], "}"}], 
         ",", "0.0569308`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1577624055`", ",", "1.104777932`", ",", "0"}], "}"}], 
         ",", "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4710538931`", ",", "1.429976181`", ",", "0"}], "}"}], 
         ",", "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.41303427`", ",", "1.104777932`", ",", "0"}], "}"}], ",", 
         "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.268035807`", ",", "0.4901338325`", ",", "0"}], "}"}], 
         ",", "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.099742434`", ",", "1.429976181`", ",", "0"}], "}"}], ",",
          "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.30276052`", ",", "0.4901338325`", ",", "0"}], "}"}], ",",
          "0.05592869883`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.02949199887`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.001199262738`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.001199262738`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.502933765670228*^9}, 3.502934629620987*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct31", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933383101741*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct31\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 31 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct31\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.003564680894`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.7853981634`", ",", "0"}], "}"}], ",", 
         "0.0228676238`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.7853981634`", ",", "0"}], "}"}], 
         ",", "0.0228676238`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553166181`", ",", "0"}], "}"}], 
         ",", "0.04458706543`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.05125134`", ",", "1.109964495`", ",", "0"}], "}"}], ",", 
         "0.04415017174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5195449866`", ",", "1.109964495`", ",", "0"}], "}"}], 
         ",", "0.04415017174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.6801264219`", ",", "0"}], "}"}], 
         ",", "0.04415017174`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.263835825`", ",", "1.277356664`", ",", "0"}], "}"}], ",",
          "0.04126590169`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3069605019`", ",", "1.277356664`", ",", "0"}], "}"}], 
         ",", "0.04126590169`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.4214197634`", ",", "0"}], "}"}], 
         ",", "0.04126590169`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4377579511`", ",", "0.8348385661`", ",", "0"}], "}"}], 
         ",", "0.04486963266`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.133038376`", ",", "0.8348385661`", ",", "0"}], "}"}], 
         ",", "0.04486963266`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.251185632`", ",", "0"}], "}"}], 
         ",", "0.04486963266`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.439373888`", ",", "1.440494371`", ",", "0"}], "}"}], ",",
          "0.03285421623`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1314224389`", ",", "1.440494371`", ",", "0"}], "}"}], 
         ",", "0.03285421623`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.1848039051`", ",", "0"}], "}"}], 
         ",", "0.03285421623`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.3530595115`", ",", "0"}], "}"}], 
         ",", "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.217736815`", ",", "0"}], "}"}], ",",
          "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.3530595115`", ",", "0"}], "}"}], ",", 
         "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.217736815`", ",", "0"}], "}"}], ",", 
         "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1879869009`", ",", "1.017941891`", ",", "0"}], "}"}], 
         ",", "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5608291557`", ",", "1.411076394`", ",", "0"}], "}"}], 
         ",", "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.382809426`", ",", "1.017941891`", ",", "0"}], "}"}], ",",
          "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.276710249`", ",", "0.5807780341`", ",", "0"}], "}"}], 
         ",", "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.009967171`", ",", "1.411076394`", ",", "0"}], "}"}], ",",
          "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.294086078`", ",", "0.5807780341`", ",", "0"}], "}"}], 
         ",", "0.04424199133`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3530595115`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.217736815`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.02020738426`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.0228676238`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.003564680894`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.003564680894`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.5029337986006804`*^9}, 3.502934644786628*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct37", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933389886154*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct37\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 37 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct37\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "0.110453`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553164381`", ",", "0"}], "}"}], 
         ",", "0.0356022`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2229623213`", ",", "0.7979296274`", ",", "0"}], "}"}], 
         ",", "0.0318113`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.347834006`", ",", "0.7979296274`", ",", "0"}], "}"}], 
         ",", "0.0318113`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.411824757`", ",", "0"}], "}"}], 
         ",", "0.0318113`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5042151489`", ",", "0.8516526071`", ",", "0"}], "}"}], 
         ",", "0.0352112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.066581178`", ",", "0.8516526071`", ",", "0"}], "}"}], 
         ",", "0.0352112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.198789869`", ",", "0"}], "}"}], 
         ",", "0.0352112`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.043975673`", ",", "1.104920826`", ",", "0"}], "}"}], ",",
          "0.0359747`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5268206534`", ",", "1.104920826`", ",", "0"}], "}"}], 
         ",", "0.0359747`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.6883596023`", ",", "0"}], "}"}], 
         ",", "0.0359747`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.30730746`", ",", "1.316006181`", ",", "0"}], "}"}], ",", 
         "0.0403932`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2634888665`", ",", "1.316006181`", ",", "0"}], "}"}], 
         ",", "0.0403932`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.3644561637`", ",", "0"}], "}"}], 
         ",", "0.0403932`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.53036752`", ",", "1.530400681`", ",", "0"}], "}"}], ",", 
         "0.137964`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.04042950492`", ",", "1.530400681`", ",", "0"}], "}"}], 
         ",", "0.137964`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.0571446977`", ",", "0"}], "}"}], 
         ",", "0.137964`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.3624734697`", ",", "0"}], "}"}], 
         ",", "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.208322857`", ",", "0"}], "}"}], ",",
          "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.3624734697`", ",", "0"}], "}"}], ",", 
         "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.208322857`", ",", "0"}], "}"}], ",", 
         "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.6216585649`", ",", "0"}], "}"}], 
         ",", "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.9491379725`", ",", "0"}], "}"}], 
         ",", "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.6216585649`", ",", "0"}], "}"}], ",", 
         "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.9491379725`", ",", "0"}], "}"}], ",", 
         "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.047736858`", ",", "1.341577`", ",", "0"}], "}"}], ",", 
         "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4369658675`", ",", "0.566776476`", ",", "0"}], "}"}], 
         ",", "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5230594689`", ",", "1.341577`", ",", "0"}], "}"}], ",", 
         "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2630891861`", ",", "1.062755416`", ",", "0"}], "}"}], 
         ",", "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.133830459`", ",", "0.566776476`", ",", "0"}], "}"}], ",",
          "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.307707141`", ",", "1.062755416`", ",", "0"}], "}"}], ",",
          "0.0375658`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6216583543`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9491379725`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.0169243`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3624734697`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.208322857`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.0207923`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "0.110453`"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         RowBox[{"-", "0.110453`"}]}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.5029338413648987`*^9}, 3.5029346580618668`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct46", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933397918041*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct46\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 46 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct46\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.001709182346`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553166181`", ",", "0"}], "}"}], 
         ",", "0.02879295428`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1822711466`", ",", "0.793749869`", ",", "0"}], "}"}], 
         ",", "0.02920036646`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.38852518`", ",", "0.793749869`", ",", "0"}], "}"}], ",", 
         "0.02920036646`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.441195152`", ",", "0"}], "}"}], 
         ",", "0.02920036646`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5143287531`", ",", "0.854450641`", ",", "0"}], "}"}], 
         ",", "0.02883858081`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.056467574`", ",", "0.854450641`", ",", "0"}], "}"}], ",",
          "0.02883858081`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.19067388`", ",", "0"}], "}"}], ",",
          "0.02883858081`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.004259022`", ",", "1.078211021`", ",", "0"}], "}"}], ",",
          "0.02861383729`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5665373046`", ",", "1.078211021`", ",", "0"}], "}"}], 
         ",", "0.02861383729`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.7325790393`", ",", "0"}], "}"}], 
         ",", "0.02861383729`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.185820355`", ",", "1.211555061`", ",", "0"}], "}"}], ",",
          "0.02759830739`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3849759717`", ",", "1.211555061`", ",", "0"}], "}"}], 
         ",", "0.02759830739`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.5203532059`", ",", "0"}], "}"}], 
         ",", "0.02759830739`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.34113974`", ",", "1.346967534`", ",", "0"}], "}"}], ",", 
         "0.02487162498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2296565871`", ",", "1.346967534`", ",", "0"}], "}"}], 
         ",", "0.02487162498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.3193033923`", ",", "0"}], "}"}], 
         ",", "0.02487162498`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.474014208`", ",", "1.474464319`", ",", "0"}], "}"}], ",",
          "0.01881681131`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.09678211864`", ",", "1.474464319`", ",", "0"}], "}"}], 
         ",", "0.01881681131`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.1364464143`", ",", "0"}], "}"}], 
         ",", "0.01881681131`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.6088147732`", ",", "0"}], "}"}], 
         ",", "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.9619815536`", ",", "0"}], "}"}], 
         ",", "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.6088147732`", ",", "0"}], "}"}], ",", 
         "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.9619815536`", ",", "0"}], "}"}], ",", 
         "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.2675975821`", ",", "0"}], "}"}], 
         ",", "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.303198745`", ",", "0"}], "}"}], ",",
          "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.2675975821`", ",", "0"}], "}"}], ",", 
         "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.303198745`", ",", "0"}], "}"}], ",", 
         "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.266795092`", ",", "0.9945649533`", ",", "0"}], "}"}], 
         ",", "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.139105867`", ",", "0.64337985`", ",", "0"}], "}"}], ",", 
         "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3040012348`", ",", "0.9945649533`", ",", "0"}], "}"}], 
         ",", "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5978756838`", ",", "1.317079548`", ",", "0"}], "}"}], 
         ",", "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4316904594`", ",", "0.64337985`", ",", "0"}], "}"}], ",",
          "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.972920643`", ",", "1.317079548`", ",", "0"}], "}"}], ",",
          "0.02857232443`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4289862979`", ",", "1.447126475`", ",", "0"}], "}"}], 
         ",", "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1358480881`", ",", "1.145300544`", ",", "0"}], "}"}], 
         ",", "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.141810029`", ",", "1.447126475`", ",", "0"}], "}"}], ",",
          "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2903965644`", ",", "0.4453904379`", ",", "0"}], "}"}], 
         ",", "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.434948239`", ",", "1.145300544`", ",", "0"}], "}"}], ",",
          "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.280399762`", ",", "0.4453904379`", ",", "0"}], "}"}], 
         ",", "0.02713849764`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2675975821`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.303198745`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.01192937985`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6088147732`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9619815536`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.01440328373`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.001709182346`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.001709182346`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.502933870511733*^9}, 3.502934673447411*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Leboct85", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502933336494659*^9, 3.502933406358006*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineOrientationalSamplingScheme", "[", 
   RowBox[{
   "\"\<Leboct85\>\"", ",", "\[IndentingNewLine]", 
    "\"\<Lebedev octant 2-angle scheme with 85 values of {\[Alpha],\[Beta]}. \
Generate orientations and weights using OrientationsAndWeights[\\\"Leboct85\\\
\"]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"CorrectWeights", "@", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", "0.000619024259`"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.9553166181`", ",", "0"}], "}"}], 
         ",", "0.01481903758`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.509694442`", ",", "1.509808184`", ",", "0"}], "}"}], ",",
          "0.007811464931`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.06110188451`", ",", "1.509808184`", ",", "0"}], "}"}], 
         ",", "0.007811464931`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.08630389694`", ",", "0"}], "}"}], 
         ",", "0.007811464931`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.422774504`", ",", "1.424369996`", ",", "0"}], "}"}], ",",
          "0.01107789787`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1480218232`", ",", "1.424369996`", ",", "0"}], "}"}], 
         ",", "0.01107789787`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.2078318704`", ",", "0"}], "}"}], 
         ",", "0.01107789787`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.322700762`", ",", "1.330002454`", ",", "0"}], "}"}], ",",
          "0.01293768518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2480955652`", ",", "1.330002454`", ",", "0"}], "}"}], 
         ",", "0.01293768518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.3439970956`", ",", "0"}], "}"}], 
         ",", "0.01293768518`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.211392852`", ",", "1.232593699`", ",", "0"}], "}"}], ",",
          "0.01399651726`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3594034744`", ",", "1.232593699`", ",", "0"}], "}"}], 
         ",", "0.01399651726`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.4884127924`", ",", "0"}], "}"}], 
         ",", "0.01399651726`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.087264556`", ",", "1.135613518`", ",", "0"}], "}"}], ",",
          "0.01454777422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.483531771`", ",", "1.135613518`", ",", "0"}], "}"}], ",",
          "0.01454777422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.6387579639`", ",", "0"}], "}"}], 
         ",", "0.01454777422`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9468779795`", ",", "1.042060765`", ",", "0"}], "}"}], 
         ",", "0.01477372765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6239183473`", ",", "1.042060765`", ",", "0"}], "}"}], 
         ",", "0.01477372765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "0.794322041`", ",", "0"}], "}"}], 
         ",", "0.01477372765`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5972203051`", ",", "0.8798656413`", ",", "0"}], "}"}], 
         ",", "0.01481623062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9735760217`", ",", "0.8798656413`", ",", "0"}], "}"}], 
         ",", "0.01481623062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.122563213`", ",", "0"}], "}"}], 
         ",", "0.01481623062`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3780299813`", ",", "0.8219769905`", ",", "0"}], "}"}], 
         ",", "0.01487050068`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.192766346`", ",", "0.8219769905`", ",", "0"}], "}"}], 
         ",", "0.01487050068`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.297033453`", ",", "0"}], "}"}], 
         ",", "0.01487050068`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1301938853`", ",", "0.7896477501`", ",", "0"}], "}"}], 
         ",", "0.01497432511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.440602442`", ",", "0.7896477501`", ",", "0"}], "}"}], 
         ",", "0.01497432511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.7853981634`", ",", "1.478474829`", ",", "0"}], "}"}], 
         ",", "0.01497432511`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.397451303`", ",", "0"}], "}"}], ",",
          "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.173345024`", ",", "0"}], "}"}], ",",
          "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.397451303`", ",", "0"}], "}"}], ",", 
         "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.173345024`", ",", "0"}], "}"}], ",", 
         "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.163121775`", ",", "0"}], "}"}], ",",
          "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.4076745515`", ",", "0"}], "}"}], 
         ",", "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.163121775`", ",", "0"}], "}"}], ",", 
         "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.4076745515`", ",", "0"}], "}"}], ",", 
         "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.9126083724`", ",", "0"}], "}"}], 
         ",", "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "0.6581879544`", ",", "0"}], "}"}], 
         ",", "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.9126083724`", ",", "0"}], "}"}], ",", 
         "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0.6581879544`", ",", "0"}], "}"}], ",", 
         "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.283405473`", ",", "0.2939666263`", ",", "0"}], "}"}], 
         ",", "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.485194683`", ",", "1.289223043`", ",", "0"}], "}"}], ",",
          "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2873908535`", ",", "0.2939666263`", ",", "0"}], "}"}], 
         ",", "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.288242362`", ",", "1.488573496`", ",", "0"}], "}"}], ",",
          "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.08560164377`", ",", "1.289223043`", ",", "0"}], "}"}], 
         ",", "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2825539646`", ",", "1.488573496`", ",", "0"}], "}"}], 
         ",", "0.01244170882`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.393881509`", ",", "0.5367406809`", ",", "0"}], "}"}], 
         ",", "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.466459156`", ",", "1.043317527`", ",", "0"}], "}"}], ",",
          "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1769148182`", ",", "0.5367406809`", ",", "0"}], "}"}], 
         ",", "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.040942606`", ",", "1.480682356`", ",", "0"}], "}"}], ",",
          "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1043371706`", ",", "1.043317527`", ",", "0"}], "}"}], 
         ",", "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5298537209`", ",", "1.480682356`", ",", "0"}], "}"}], 
         ",", "0.01441791302`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.276061477`", ",", "0.675617797`", ",", "0"}], "}"}], ",",
          "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.342063666`", ",", "0.9292779329`", ",", "0"}], "}"}], 
         ",", "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2947348501`", ",", "0.675617797`", ",", "0"}], "}"}], 
         ",", "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9165790316`", ",", "1.388117897`", ",", "0"}], "}"}], 
         ",", "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.2287326609`", ",", "0.9292779329`", ",", "0"}], "}"}], 
         ",", "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6542172952`", ",", "1.388117897`", ",", "0"}], "}"}], 
         ",", "0.01479864448`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.144694216`", ",", "0.4294053646`", ",", "0"}], "}"}], 
         ",", "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.383746804`", ",", "1.181968997`", ",", "0"}], "}"}], ",",
          "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4261021107`", ",", "0.4294053646`", ",", "0"}], "}"}], 
         ",", "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.175757269`", ",", "1.397856033`", ",", "0"}], "}"}], ",",
          "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.1870495232`", ",", "1.181968997`", ",", "0"}], "}"}], 
         ",", "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3950390577`", ",", "1.397856033`", ",", "0"}], "}"}], 
         ",", "0.01371123606`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.063689127`", ",", "0.5734255762`", ",", "0"}], "}"}], 
         ",", "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.266874117`", ",", "1.076696557`", ",", "0"}], "}"}], ",",
          "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5071071998`", ",", "0.5734255762`", ",", "0"}], "}"}], 
         ",", "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.056859559`", ",", "1.304177061`", ",", "0"}], "}"}], ",",
          "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.3039222094`", ",", "1.076696557`", ",", "0"}], "}"}], 
         ",", "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5139367676`", ",", "1.304177061`", ",", "0"}], "}"}], 
         ",", "0.01442127147`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.010677515`", ",", "0.7237758896`", ",", "0"}], "}"}], 
         ",", "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.13181579`", ",", "0.975171154`", ",", "0"}], "}"}], ",", 
         "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.5601188121`", ",", "0.7237758896`", ",", "0"}], "}"}], 
         ",", "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9281127498`", ",", "1.211272982`", ",", "0"}], "}"}], 
         ",", "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4389805371`", ",", "0.975171154`", ",", "0"}], "}"}], 
         ",", "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.642683577`", ",", "1.211272982`", ",", "0"}], "}"}], ",",
          "0.01474293178`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.9126083724`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.6581879544`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.007428644784`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.163121775`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.4076745515`", ",", "1.570796327`", ",", "0"}], "}"}], 
         ",", "0.006820615984`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.397451303`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0.173345024`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.00520128674`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1.570796327`", ",", "1.570796327`", ",", "0"}], "}"}], ",",
          "0.000619024259`"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1.570796327`", ",", "0"}], "}"}], ",", 
         "0.000619024259`"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4537268662362223`*^9, 3.453726876115436*^9}, {
   3.453726922982108*^9, 3.45372695045157*^9}, {3.4602736252329893`*^9, 
   3.460273646223029*^9}, {3.460278629639965*^9, 3.460278665026533*^9}, 
   3.4602880164511757`*^9, {3.460290373563407*^9, 3.460290380199666*^9}, 
   3.460291480821212*^9, {3.4602917450603724`*^9, 3.4602917694671087`*^9}, 
   3.4602923441375103`*^9, {3.4602935436303463`*^9, 3.460293569677374*^9}, {
   3.460293930625763*^9, 3.460293931345757*^9}, {3.5029329168781633`*^9, 
   3.5029329225123787`*^9}, {3.5029334306682777`*^9, 3.502933453000367*^9}, {
   3.502933564158338*^9, 3.502933580387601*^9}, {3.502933660572809*^9, 
   3.5029339049104023`*^9}, 3.50293469337074*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["turn on messages again and report defined schemes", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.460273418407672*^9, 3.46027342401437*^9}, {
  3.460273469531209*^9, 3.460273478505211*^9}, {3.460273585679083*^9, 
  3.460273592686363*^9}, {3.460274870860118*^9, 3.460274893923914*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"On", "[", 
   RowBox[{
    RowBox[{"DefineOrientationalSamplingScheme", "::", "\"\<def\>\""}], ",", 
    RowBox[{"DefineOrientationalSamplingScheme", "::", "\"\<fdef\>\""}]}], 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274918312847*^9, 3.460274921303966*^9}, {
  3.4602789787427807`*^9, 3.460278981212384*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Predefined orientational sampling schemes:\>\"", ",", 
    RowBox[{"OrientationalSamplingScheme", "[", "]"}], ",", 
    "\[IndentingNewLine]", "\"\<Execute \!\(\*
StyleBox[\"OrientationalSamplingScheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"scheme\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) for the usage message of a sampling scheme.\>\""}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.460274924701406*^9, 3.460274985534234*^9}, {
  3.4602750200410357`*^9, 3.460275020630542*^9}, {3.502931708274691*^9, 
  3.502931772793044*^9}, {3.502931825000656*^9, 3.5029319131068573`*^9}, {
  3.502934139490284*^9, 3.50293413995817*^9}, {3.502934171800074*^9, 
  3.502934172110187*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{783, 915},
WindowMargins->{{Automatic, 221}, {Automatic, 31}},
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 18, \
2017)",
StyleDefinitions->"mhl-default.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 259, 6, 92, "Title", "ExpressionUUID" -> \
"4182aaaf-6623-4478-b6a9-cfc137351b69",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[829, 30, 807, 17, 91, "Input", "ExpressionUUID" -> \
"1e66050c-84d5-40bb-a66b-e6c9038ed1b9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1661, 51, 127, 4, 67, "Subtitle", "ExpressionUUID" -> \
"3e85ad91-7357-4e40-b647-b670f7c1c7af",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1791, 57, 1218, 33, 112, "Input", "ExpressionUUID" -> \
"000e8598-f002-474c-8bf9-69a76b0142c0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[3012, 92, 5800, 232, 217, "Input", "ExpressionUUID" -> \
"b7039023-a996-4a19-91ed-9d0122261deb",
 InitializationCell->True],
Cell[8815, 326, 862, 19, 91, "Input", "ExpressionUUID" -> \
"065bf211-be25-4a80-af6a-445dd6aa2745",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9680, 347, 983, 23, 91, "Input", "ExpressionUUID" -> \
"335740dd-b197-422f-84c1-bc4e55b49b96",
 InitializationCell->True,
 InitializationGroup->True],
Cell[10666, 372, 1200, 27, 91, "Input", "ExpressionUUID" -> \
"0ea290bb-2f19-4783-b69e-60582151ee33",
 InitializationCell->True,
 InitializationGroup->True],
Cell[11869, 401, 1034, 23, 91, "Input", "ExpressionUUID" -> \
"8874dbb9-a4c0-4a47-b352-59d14bf064d1",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[12940, 429, 194, 5, 67, "Subtitle", "ExpressionUUID" -> \
"f11d36c5-ad0c-46db-a171-71973ddcc22d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13137, 436, 143, 4, 27, "Input", "ExpressionUUID" -> \
"19408ad6-c087-4647-82d4-56c7b7fcfc91",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13317, 445, 195, 5, 56, "Subtitle", "ExpressionUUID" -> \
"2785842d-2db6-4256-a874-a2a2438542c8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[13537, 454, 151, 3, 28, "Subsubtitle", "ExpressionUUID" -> \
"e2090acb-eaa8-48bd-822a-ca740b1a8a6c",
 InitializationCell->True],
Cell[13691, 459, 240, 6, 27, "Input", "ExpressionUUID" -> \
"5939db56-ff74-4be9-9d93-eafc2a6c75a4",
 InitializationCell->True],
Cell[13934, 467, 259, 7, 27, "Input", "ExpressionUUID" -> \
"c3fef85b-d5bf-4374-8054-6cb979a0ef53",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[14230, 479, 208, 4, 28, "Subsubtitle", "ExpressionUUID" -> \
"f31ed5af-393a-4180-9a53-f0d0cdd0e003",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[14463, 487, 153, 3, 34, "Subsection", "ExpressionUUID" -> \
"4caac019-a0fa-4f5c-8b8a-2fee9c9c25f3",
 InitializationCell->True],
Cell[14619, 492, 763, 24, 27, "Input", "ExpressionUUID" -> \
"32ead4bb-31ae-4b8c-b4b2-17bab3f8f5b5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15419, 521, 204, 4, 26, "Subsection", "ExpressionUUID" -> \
"8027d84e-01e0-43ae-95fc-d8a87fffc498",
 InitializationCell->True],
Cell[15626, 527, 1271, 34, 103, "Input", "ExpressionUUID" -> \
"a594e02c-6de3-4dfb-a7e5-dfed6ae983bf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16934, 566, 280, 5, 27, "Subsection", "ExpressionUUID" -> \
"4853eec8-ca25-441c-a452-94af78872ebc",
 InitializationCell->True],
Cell[17217, 573, 343, 9, 43, "Input", "ExpressionUUID" -> \
"707bd864-5832-41d2-a2d9-74ad2c567ac4"],
Cell[17563, 584, 392, 7, 60, "Input", "ExpressionUUID" -> \
"8e7ec7b4-dfb7-422b-a1f8-95f526ec7841"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18004, 597, 125, 2, 28, "Subsubtitle", "ExpressionUUID" -> \
"a3b1cbe9-1ed7-427b-95d0-0aa3d80646c6",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[18154, 603, 135, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"7e9ea453-289d-49b5-9403-5d17abd9f214",
 InitializationCell->True],
Cell[18292, 607, 1514, 37, 120, "Input", "ExpressionUUID" -> \
"44c38533-15d1-4e26-be62-c31cb895985a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19843, 649, 134, 2, 18, "Subsubsection", "ExpressionUUID" -> \
"1694ba7e-c047-485b-8e5c-9362d1a6c889",
 InitializationCell->True],
Cell[19980, 653, 911, 25, 58, "Input", "ExpressionUUID" -> \
"a5aa116d-a9b2-4f52-9047-1caad135482f",
 InitializationCell->True],
Cell[20894, 680, 760, 21, 43, "Input", "ExpressionUUID" -> \
"0d055357-f3cf-49a6-846b-939048d288ba",
 InitializationCell->True],
Cell[21657, 703, 1298, 32, 103, "Input", "ExpressionUUID" -> \
"0f529edd-9848-42e7-a2fe-710e77e59502",
 InitializationCell->True],
Cell[22958, 737, 1455, 36, 118, "Input", "ExpressionUUID" -> \
"d84c873c-0b97-404f-b853-6082640b9b16",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24450, 778, 127, 2, 18, "Subsubsection", "ExpressionUUID" -> \
"9d2949be-7782-412a-ab8a-b0283519b233",
 InitializationCell->True],
Cell[24580, 782, 292, 5, 41, "Text", "ExpressionUUID" -> \
"277dd533-4493-46a8-bdf2-32a15edb1d44"],
Cell[24875, 789, 742, 19, 58, "Input", "ExpressionUUID" -> \
"45094a34-7c36-4f9c-be6e-813a850ff42c",
 InitializationCell->True],
Cell[25620, 810, 1195, 30, 103, "Input", "ExpressionUUID" -> \
"f29fd30c-58d5-48e0-a582-095e9a6afb86",
 InitializationCell->True],
Cell[26818, 842, 4350, 91, 358, "Input", "ExpressionUUID" -> \
"c4b11039-e42d-4eed-8329-f899c760594f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31205, 938, 173, 3, 18, "Subsubsection", "ExpressionUUID" -> \
"7c0db754-54f0-4d7d-8628-e98e07576f76",
 InitializationCell->True],
Cell[31381, 943, 368, 9, 43, "Input", "ExpressionUUID" -> \
"8d45b853-672b-44f9-b8fb-d0f9f20ff220",
 InitializationCell->True],
Cell[31752, 954, 421, 10, 43, "Input", "ExpressionUUID" -> \
"d261a73e-4a2c-43c3-986b-69152c83fcc3",
 InitializationCell->True],
Cell[32176, 966, 477, 10, 58, "Input", "ExpressionUUID" -> \
"d81ebee6-f550-48f0-9b80-5299c7548ef0",
 InitializationCell->True],
Cell[32656, 978, 509, 10, 58, "Input", "ExpressionUUID" -> \
"7fb8d9dd-f1fb-4ae5-a55c-63fb9d1e2075",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33214, 994, 170, 3, 28, "Subsubtitle", "ExpressionUUID" -> \
"60f2a8eb-2548-4ea3-b24d-cf97e2e01ddc",
 InitializationCell->True],
Cell[33387, 999, 276, 7, 27, "Input", "ExpressionUUID" -> \
"548a7ac1-4729-4216-b8e8-411b28fcee86",
 InitializationCell->True],
Cell[33666, 1008, 376, 9, 27, "Input", "ExpressionUUID" -> \
"b848bbae-11fd-4794-b928-4b2f9c579fe3",
 InitializationCell->True],
Cell[34045, 1019, 433, 10, 43, "Input", "ExpressionUUID" -> \
"a5d3bb37-ee67-4f88-b552-b1079e27fd1f",
 InitializationCell->True],
Cell[34481, 1031, 264, 6, 43, "Input", "ExpressionUUID" -> \
"c50fdf7e-b77d-4311-9bef-76ef048dd073"]
}, Closed]],
Cell[CellGroupData[{
Cell[34782, 1042, 153, 3, 28, "Subsubtitle", "ExpressionUUID" -> \
"aff07bad-7e45-4cbc-be18-e1d2763cdc4f",
 InitializationCell->True],
Cell[34938, 1047, 273, 7, 27, "Input", "ExpressionUUID" -> \
"70c5b56d-726c-4e8c-ab4c-8f150865cc11",
 InitializationCell->True],
Cell[35214, 1056, 807, 22, 73, "Input", "ExpressionUUID" -> \
"1bc5146a-e402-41cc-9779-fefb2b5dba98",
 InitializationCell->True],
Cell[36024, 1080, 505, 13, 58, "Input", "ExpressionUUID" -> \
"4cf0a14b-e6d5-4139-8a8c-7233011f539e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36566, 1098, 263, 5, 28, "Subsubtitle", "ExpressionUUID" -> \
"001e4d72-612d-4722-8ff0-a5eb9be33890",
 InitializationCell->True],
Cell[36832, 1105, 329, 8, 27, "Input", "ExpressionUUID" -> \
"74f1551e-64c5-4c3d-8f95-4bd698429056",
 InitializationCell->True],
Cell[37164, 1115, 863, 23, 73, "Input", "ExpressionUUID" -> \
"307e5b81-f0ce-4e18-a725-39e91e988178",
 InitializationCell->True],
Cell[38030, 1140, 584, 14, 58, "Input", "ExpressionUUID" -> \
"fcef90a8-c1fe-4c29-8562-55f6e6c32654",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38651, 1159, 138, 2, 28, "Subsubtitle", "ExpressionUUID" -> \
"b63731b7-b94c-4c67-ae99-6ffac8cffdad",
 InitializationCell->True],
Cell[38792, 1163, 257, 7, 27, "Input", "ExpressionUUID" -> \
"f2dd042c-1f3a-44a4-adc5-2ca889afd75a",
 InitializationCell->True],
Cell[39052, 1172, 791, 22, 73, "Input", "ExpressionUUID" -> \
"9b3abdf0-8eea-4407-9c74-8d0f3da4ced4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39880, 1199, 161, 3, 28, "Subsubtitle", "ExpressionUUID" -> \
"5b55c271-5f81-4dce-9463-f07b08586fe9",
 InitializationCell->True],
Cell[40044, 1204, 277, 7, 27, "Input", "ExpressionUUID" -> \
"edba23bc-9ab8-4600-89b1-fd94345a3341",
 InitializationCell->True],
Cell[40324, 1213, 811, 22, 58, "Input", "ExpressionUUID" -> \
"3d05d187-db01-43d4-ae6e-cbafab64bdeb",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[41184, 1241, 258, 6, 56, "Subtitle", "ExpressionUUID" -> \
"4e2182be-a3d4-41db-9105-cb7033769dbd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[41467, 1251, 284, 4, 70, "Section", "ExpressionUUID" -> \
"54736499-ae38-4e63-b004-40ed5ea5b2d9",
 InitializationCell->True],
Cell[41754, 1257, 408, 10, 43, "Input", "ExpressionUUID" -> \
"ef65a3c1-d79a-43fe-a9aa-5639837b531a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[42199, 1272, 268, 4, 56, "Section", "ExpressionUUID" -> \
"e371e734-4d78-455a-9c4e-8527d181c93e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[42492, 1280, 60, 1, 34, "Subsection", "ExpressionUUID" -> \
"52b4456e-22c9-44f7-84c5-b22861443213",
 InitializationCell->True],
Cell[42555, 1283, 5362, 140, 313, "Input", "ExpressionUUID" -> \
"ec2af34b-12b0-4971-a8b8-6f7df600ae90",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[47954, 1428, 110, 2, 26, "Subsection", "ExpressionUUID" -> \
"14fcd024-2bd2-4f9b-b93e-cedc8e0e4f30",
 InitializationCell->True],
Cell[48067, 1432, 6007, 138, 328, "Input", "ExpressionUUID" -> \
"5939a93b-e7c8-46e0-bc84-4aac8449c7a6",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54123, 1576, 317, 5, 56, "Section", "ExpressionUUID" -> \
"60f1c8e2-534d-49fa-b646-49d0a1a17960",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[54465, 1585, 128, 2, 34, "Subsection", "ExpressionUUID" -> \
"caa365d3-b962-4597-bc2e-8a8a50c004a5",
 InitializationCell->True],
Cell[54596, 1589, 3724, 94, 283, "Input", "ExpressionUUID" -> \
"8285c670-3906-4ed2-b33a-cf0a941834ba",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[58357, 1688, 185, 3, 26, "Subsection", "ExpressionUUID" -> \
"06948136-00ae-4ef8-ba11-aeaecd68c56f",
 InitializationCell->True],
Cell[58545, 1693, 3549, 84, 253, "Input", "ExpressionUUID" -> \
"5ec3e1f2-1dcb-4a32-bec5-74594c42cf2d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[62131, 1782, 244, 4, 26, "Subsection", "ExpressionUUID" -> \
"14207f39-61cb-4b43-a6eb-3a27e525379b",
 InitializationCell->True],
Cell[62378, 1788, 3908, 96, 283, "Input", "ExpressionUUID" -> \
"703b2498-38d1-41e0-ba00-057706ea439c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[66335, 1890, 220, 4, 56, "Section", "ExpressionUUID" -> \
"e575499c-de9c-4955-8780-9209623e96a3",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[66580, 1898, 172, 3, 24, "Subsubsection", "ExpressionUUID" -> \
"e41b9ebc-8c6f-45ab-93f9-5559dd318ffb",
 InitializationCell->True],
Cell[66755, 1903, 11398, 324, 823, "Input", "ExpressionUUID" -> \
"fec0865b-9ac1-4054-b2b1-efeea7fc7201",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[78190, 2232, 124, 2, 18, "Subsubsection", "ExpressionUUID" -> \
"16c28448-4a60-422c-a1f3-98414d75a2ac",
 InitializationCell->True],
Cell[78317, 2236, 33891, 1028, 4378, "Input", "ExpressionUUID" -> \
"da5f10ae-d000-43ae-b68c-5f6374365db9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[112245, 3269, 173, 3, 18, "Subsubsection", "ExpressionUUID" -> \
"11625d26-cb36-4a53-969a-ac35a24c35cd",
 InitializationCell->True],
Cell[112421, 3274, 42577, 1223, 3073, "Input", "ExpressionUUID" -> \
"b11154d5-91b3-4bcd-9ab9-a1d0cc26616d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[155035, 4502, 126, 2, 18, "Subsubsection", "ExpressionUUID" -> \
"c70fb650-cb42-4b12-9eba-7a8cc8404d36",
 InitializationCell->True],
Cell[155164, 4506, 69597, 2120, 9058, "Input", "ExpressionUUID" -> \
"a7aaf635-c52f-4d15-bd10-5a9086da2918",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[224798, 6631, 175, 3, 18, "Subsubsection", "ExpressionUUID" -> \
"212d3fb0-b987-4580-983e-5226a0c914d4",
 InitializationCell->True],
Cell[224976, 6636, 124226, 3786, 16198, "Input", "ExpressionUUID" -> \
"20b47200-19a8-40c6-b2bf-4dba39c00b18",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[349239, 10427, 225, 4, 18, "Subsubsection", "ExpressionUUID" -> \
"1135fe76-a275-44f9-b8c5-6544fe1f90ba",
 InitializationCell->True],
Cell[349467, 10433, 266772, 8098, 34693, "Input", "ExpressionUUID" -> \
"56275688-d322-44c3-85dd-5207a577c1a7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[616276, 18536, 273, 4, 18, "Subsubsection", "ExpressionUUID" -> \
"ce4f9401-41e1-4624-9457-45a7a1b10b9a",
 InitializationCell->True],
Cell[616552, 18542, 1393079, 42324, 181393, "Input", "ExpressionUUID" -> \
"36dbf81c-8551-491d-967a-58e039693199",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2009680, 60872, 276, 4, 56, "Section", "ExpressionUUID" -> \
"ba53806b-6665-49f0-a392-8bebe32f0409",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2009981, 60880, 227, 4, 24, "Subsubsection", "ExpressionUUID" -> \
"c2c5295a-d5a3-4d11-b750-b624986b2e22",
 InitializationCell->True],
Cell[2010211, 60886, 19142, 528, 1588, "Input", "ExpressionUUID" -> \
"d40fbe63-7652-493a-bc91-e33ac9208821",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2029390, 61419, 275, 4, 24, "Subsubsection", "ExpressionUUID" -> \
"4715cfa6-4ea2-4a37-886a-2d8bb5315838",
 InitializationCell->True],
Cell[2029668, 61425, 28426, 778, 2338, "Input", "ExpressionUUID" -> \
"e4ed9c86-664b-41d4-8bd7-020da56eb189",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2058131, 62208, 326, 5, 24, "Subsubsection", "ExpressionUUID" -> \
"737aa513-e7ec-439a-8102-c8c37cf12fec",
 InitializationCell->True],
Cell[2058460, 62215, 31697, 868, 2608, "Input", "ExpressionUUID" -> \
"53e99c02-c9a4-4ef4-92a8-5c25e125e35b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2090194, 63088, 377, 6, 24, "Subsubsection", "ExpressionUUID" -> \
"3c154527-4270-47fd-8b09-b94776ab825f",
 InitializationCell->True],
Cell[2090574, 63096, 43261, 1188, 3568, "Input", "ExpressionUUID" -> \
"fce37eed-70b7-4fc7-a4d5-f60598747dfb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2133872, 64289, 423, 6, 24, "Subsubsection", "ExpressionUUID" -> \
"59af4b67-fe2a-441c-b413-0734ace0fec5",
 InitializationCell->True],
Cell[2134298, 64297, 69333, 1908, 5728, "Input", "ExpressionUUID" -> \
"8e270566-e832-411f-8bea-145357dadef5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2203668, 66210, 476, 7, 24, "Subsubsection", "ExpressionUUID" -> \
"692ff355-2cf9-4a65-9581-7742c4d169e9",
 InitializationCell->True],
Cell[2204147, 66219, 128004, 3528, 10588, "Input", "ExpressionUUID" -> \
"68ddc444-9ba0-4d5a-b55d-6b15b68f8eac",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2332200, 69753, 271, 4, 56, "Section", "ExpressionUUID" -> \
"7914171d-1447-45cd-a646-3db8075baa14",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2332496, 69761, 225, 4, 24, "Subsubsection", "ExpressionUUID" -> \
"cec37d2b-d8fd-448c-a59b-7072c66e182d",
 InitializationCell->True],
Cell[2332724, 69767, 2950, 71, 283, "Input", "ExpressionUUID" -> \
"5f07c614-3e2c-4927-9aef-a65c24264839",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2335711, 69843, 177, 3, 24, "Subsubsection", "ExpressionUUID" -> \
"eb7ace56-d910-44c6-9d78-597feec87faa",
 InitializationCell->True],
Cell[2335891, 69848, 10743, 259, 988, "Input", "ExpressionUUID" -> \
"4f33ada6-b380-4082-b6c5-6120cb3aa02f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2346683, 70113, 319, 5, 56, "Section", "ExpressionUUID" -> \
"2c7793aa-b85c-4481-846d-b5c9f6b04224",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2347027, 70122, 128, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"576db592-d20e-4990-b97b-9c4723636dd0",
 InitializationCell->True],
Cell[2347158, 70126, 3036, 73, 223, "Input", "ExpressionUUID" -> \
"348a3425-75fa-4224-bbf9-cac253d9bcb8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2350231, 70204, 128, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"99fe6718-69bb-4191-bc2d-31b2a6aa2f9c",
 InitializationCell->True],
Cell[2350362, 70208, 4064, 103, 298, "Input", "ExpressionUUID" -> \
"623ac73d-eff5-458a-ae8e-817056edb116",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2354463, 70316, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"be44029b-93fd-401f-9832-21a4475d2268",
 InitializationCell->True],
Cell[2354592, 70320, 4688, 118, 373, "Input", "ExpressionUUID" -> \
"ca1c2c54-2962-4d97-83fb-da9815b4737c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2359317, 70443, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"5a14518d-a02f-430a-b7e3-79d917b5f4a5",
 InitializationCell->True],
Cell[2359446, 70447, 5220, 133, 403, "Input", "ExpressionUUID" -> \
"e46380b9-4ec1-4066-a469-c876c57392eb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2364703, 70585, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"61568683-6adc-41c3-97b0-e848960f9538",
 InitializationCell->True],
Cell[2364832, 70589, 6887, 178, 538, "Input", "ExpressionUUID" -> \
"68d2c105-b1fe-4f92-a07b-599e64d2fda8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2371756, 70772, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"c3af9757-79df-4618-bf74-1abaf126215c",
 InitializationCell->True],
Cell[2371885, 70776, 7868, 208, 598, "Input", "ExpressionUUID" -> \
"0ccc25b2-8358-4091-9453-6b1a9982d4e7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2379790, 70989, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"4bae6cd7-f65f-456f-93c9-4af357c64c16",
 InitializationCell->True],
Cell[2379919, 70993, 9631, 253, 778, "Input", "ExpressionUUID" -> \
"70410412-5a5c-4373-a60e-e10e3adda406",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2389587, 71251, 126, 2, 24, "Subsubsection", "ExpressionUUID" -> \
"5257956e-7308-4d43-9e14-5fa1d5f7e1b4",
 InitializationCell->True],
Cell[2389716, 71255, 16803, 448, 1363, "Input", "ExpressionUUID" -> \
"1365afc2-14d0-4fa7-9603-e93bfc0771c2",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2406568, 71709, 304, 4, 56, "Section", "ExpressionUUID" -> \
"766d7883-fea5-4b82-ab10-c1b4731f3fbd",
 InitializationCell->True],
Cell[2406875, 71715, 407, 10, 43, "Input", "ExpressionUUID" -> \
"87134142-53fd-49ba-af93-11089c9ca714",
 InitializationCell->True],
Cell[2407285, 71727, 906, 21, 88, "Input", "ExpressionUUID" -> \
"dbab00ce-ad54-4115-96b7-684b5f3a53c3",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2408240, 71754, 124, 4, 56, "Subtitle", "ExpressionUUID" -> \
"c8793f2e-ca19-4dd0-b489-fe11fddf39f6",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2408367, 71760, 236, 8, 66, "Input", "ExpressionUUID" -> \
"717cd494-8ece-47bf-85c1-f0f0fb42d7a2",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]]
}
]
*)

