(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    284560,       7933]
NotebookOptionsPosition[    241969,       6820]
NotebookOutlinePosition[    242998,       6854]
CellTagsIndexPosition[    242955,       6851]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["QM`ExtendedLiouville`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.682593348337326*^9, 3.6825995718343973`*^9, {3.696759264340555*^9, 
   3.696759265728269*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"736d94ca-895d-4f01-b81f-472de13b88cf"],

Cell[CellGroupData[{

Cell["BeginPackage", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"47d88bb1-f5ab-4452-be96-6a77251e07a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<QM`ExtendedLiouville`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<QM`Liouville`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\""}], 
     "\[IndentingNewLine]", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6825971242231607`*^9, 3.682597156161066*^9}, {
  3.682599563684887*^9, 3.682599565709125*^9}, {3.682600180412551*^9, 
  3.68260018180884*^9}, {3.6831102443489103`*^9, 3.683110248332019*^9}, {
  3.696759279176655*^9, 3.696759292650285*^9}, {3.713356214205247*^9, 
  3.71335622185893*^9}, {3.71336633518255*^9, 3.713366343634742*^9}, {
  3.7143795359279957`*^9, 3.714379541949563*^9}, {3.714404511053658*^9, 
  3.7144045258776493`*^9}},ExpressionUUID->"02f481c7-5b77-4bfa-9f14-\
495a3959a4fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["exports", "Chapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.714404966865925*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"3b934085-f664-4392-be72-fecb3abbb8ce"],

Cell[CellGroupData[{

Cell["Sites", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"5192a578-6c32-43b4-bcd4-ec0e1e7e3e25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns the\!\(\*
StyleBox[\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\\\ \)]\)site labels for the current \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71334044528137*^9, 3.713340468366626*^9}, {
  3.713340535508748*^9, 
  3.713340590911749*^9}},ExpressionUUID->"bc5b51a2-2df8-4d0e-bc81-\
120bde2801af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSites", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"...\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines the\!\(\*
StyleBox[\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\\\ \)]\)site labels for a system in chemical exchange \
(or other applications of \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)). The syntax \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) is equivalent to \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71334044528137*^9, 3.713340468366626*^9}, {
  3.713340535508748*^9, 3.713340590911749*^9}, {3.713340642327772*^9, 
  3.713340693213029*^9}, {3.7135981239438763`*^9, 
  3.7135981618209753`*^9}},ExpressionUUID->"998006fc-0187-4f98-b448-\
ebecef9c38aa"]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedOperatorBasis", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"4945fe08-1293-42aa-8823-8f37c35b21ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"SetExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) sets the current extended operator basis to the \
basis \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342132807515*^9, 3.713342140637987*^9}, {
  3.7133421738740463`*^9, 
  3.7133422141330347`*^9}},ExpressionUUID->"426e1bc7-ec00-4628-9993-\
172053dc9e00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) refers to an operator basis duplicated several \
times, according to the elements in the list \!\(\*
StyleBox[\"sites\",
FontSlant->\"Italic\"]\).\n\!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns the current extended operator basis.;\n\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69675941838855*^9, 3.696759505762321*^9}, 
   3.713340421984473*^9, {3.71334061122829*^9, 3.7133406129565268`*^9}, {
   3.71334214686436*^9, 3.7133421634310827`*^9}, {3.713342235600861*^9, 
   3.713342259836821*^9}},ExpressionUUID->"7668a179-4629-4f56-aef2-\
7b1e456d1f20"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
SiteDependentOperator and ExtendedOperatorVectorRepresentation\
\>", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.6967595980142813`*^9, 3.6967596001397057`*^9}, {
   3.6967597829668407`*^9, 3.696759789705925*^9}, {3.713365456372308*^9, 
   3.713365476168027*^9}, 3.7133671873108187`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"9aa8ad61-7ebc-4440-aa35-c4c712468ee6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "usage"}], "=", 
   "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opi\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opj\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines an operator which depends on the site \
indices \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\). The set of sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)must be a subset of \!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\). The syntax \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opi\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)defines an operator which applies to just one of the \
sites. The syntax \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) assumes that the operator applies to all sites. \
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696759610347431*^9, 3.696759641360589*^9}, {
  3.696759678767851*^9, 3.6967598417831163`*^9}, {3.713365483967828*^9, 
  3.713365496157132*^9}, {3.713596925675501*^9, 3.7135971068937187`*^9}, {
  3.713602364650424*^9, 
  3.7136023868174562`*^9}},ExpressionUUID->"bfc7e0fa-2c03-41e8-9b16-\
791d73aa91ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "::", "usage"}], "=", 
   "\"\<\!\(\*
StyleBox[\"ExtendedOperatorVectorRepresentation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sdop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) derives the vector representation of a \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) <\!\(\*
StyleBox[\"sdop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\) in the \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\). If \!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)is omitted, the current \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\) is used.\n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696759610347431*^9, 3.696759641360589*^9}, {
  3.696759678767851*^9, 3.6967598417831163`*^9}, {3.713365483967828*^9, 
  3.713365496157132*^9}, {3.713367219185351*^9, 3.713367299407853*^9}, {
  3.713367348747473*^9, 
  3.713367371278051*^9}},ExpressionUUID->"f4ce9aef-3fa0-4539-a463-\
df3b1a7e3f73"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
SiteDependentSuperoperator and ExtendedSuperoperatorMatrixRepresentation\
\>", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.6967595980142813`*^9, 3.6967596001397057`*^9}, {
   3.6967597829668407`*^9, 3.696759789705925*^9}, {3.713365456372308*^9, 
   3.713365476168027*^9}, {3.713367197767157*^9, 3.713367208451824*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"15ddd076-6487-4024-afb7-97d21ce16076"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "usage"}], "=", 
   "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"superopi\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"superopj\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a superoperator which depends on the site \
indices \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\). The set of sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)must be a subset of \!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\). The syntax \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"superopi\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)defines a superoperator which applies to just one of \
the sites. The syntax \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) assumes that the superoperator applies to all sites. \
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696759610347431*^9, 3.696759641360589*^9}, {
   3.696759678767851*^9, 3.6967598417831163`*^9}, {3.713365483967828*^9, 
   3.713365496157132*^9}, {3.713596925675501*^9, 3.7135971068937187`*^9}, {
   3.713602364650424*^9, 3.713602443336028*^9}, 
   3.7137899426666107`*^9},ExpressionUUID->"a644579c-cbf6-45cc-94b8-\
f08f08f219a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "::", "usage"}], "=", 
   "\"\<\!\(\*
StyleBox[\"ExtendedSuperoperatorMatrixRepresentation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sdsop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) derives the matrix representation of a \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) <\!\(\*
StyleBox[\"sdop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\) in the ExtendedOperatorBasis\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\). If \!\(\*
StyleBox[\"<\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"xopb\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)is omitted, the current \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\) is used.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696759610347431*^9, 3.696759641360589*^9}, {
  3.696759678767851*^9, 3.6967598417831163`*^9}, {3.713365483967828*^9, 
  3.713365496157132*^9}, {3.713367219185351*^9, 3.713367336707692*^9}, {
  3.713367383120221*^9, 
  3.713367383374405*^9}},ExpressionUUID->"6f2da5e3-c46c-44f4-bc26-\
5508abe9b72e"]
}, Closed]],

Cell[CellGroupData[{

Cell["KineticExchangeSuperoperator and KineticExchangeMatrix", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.6967595980142813`*^9, 3.6967596001397057`*^9}, {
   3.6967597829668407`*^9, 3.696759789705925*^9}, {3.696759883094853*^9, 
   3.6967598892915373`*^9}, {3.696759972679738*^9, 3.696759973746642*^9}, {
   3.696760132657305*^9, 3.696760139202826*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"2031d95a-6464-4e1c-ae4c-ba75e5ae8e3e"],

Cell[CellGroupData[{

Cell["KineticExchangeMatrix", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.696760539870386*^9, 
  3.6967605528186617`*^9}},ExpressionUUID->"3a3b12cd-45b9-472e-a14a-\
04aa52c1bc43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "usage"}], "=", 
   "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"K\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a kinetic exchange matrix for dynamic \
exchange between the sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\) The argument \!\(\*
StyleBox[\"K\",
FontSlant->\"Italic\"]\) may be be one of the following: (1) A square matrix \
of dimension equal to the number of exchanging sites, with elements given by \
the kinetic rate constants; (2) A list of the form \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"m\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kml\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)in which the rate constant \!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)for the conversion of site \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) into site \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)is specified explicitly, and similarly for the other \
rate constants. If the list contains an element of the form \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)but no element for the opposite transformation \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\), the routine assumes \!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\), i.e. symmetrical rate constants between sites \
\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\). Asymmetrical rate constants between \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)are defined by including elements of both forms \
\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)and\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\) \nIf the sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)are omitted, the sites are taken from the current \
\!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\\\\n\",
FontSlant->\"Italic\"]\)The options may include \!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)may be used to impose detailed balance automatically \
by adjustment of the diagonal elements. The default is \!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\).\nThe output of \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\) has the form \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"matrix\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) where \!\(\*
StyleBox[\"matrix\",
FontSlant->\"Italic\"]\) is the resulting kinetic exchange matrix (as a \
\!\(\*
StyleBox[\"SparseArray\",
FontSlant->\"Italic\"]\) object). \nThe raw kinetic matrix may be extracted \
by applying \!\(\*
StyleBox[\"Expand\",
FontSlant->\"Italic\"]\) to the result.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696760145210371*^9, 3.6967605624694633`*^9}, {
   3.6967606124540462`*^9, 3.696760613376444*^9}, {3.713340617433261*^9, 
   3.713340620095624*^9}, {3.714372581183305*^9, 3.714372587580288*^9}, {
   3.7143806203836823`*^9, 3.714380686435903*^9}, {3.714386804859247*^9, 
   3.714386871650673*^9}, 3.714401597609281*^9, {3.714401713078907*^9, 
   3.714402076731064*^9}, {3.71465019511032*^9, 3.714650300448206*^9}, 
   3.714650338974455*^9},ExpressionUUID->"13759527-3e96-416b-bed5-\
945a8be69ef9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImposeDetailedBalance", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\) is an option value for \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\). If \!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\), detailed kinetic balance is automatically imposed \
by adjusting the diagonal elements of the kinetic exchange matrix.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696760576409285*^9, 
  3.69676068649081*^9}},ExpressionUUID->"983ceb7d-edf4-4758-8be4-\
8e854a6f04d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DetailedBalance", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"DetailedBalance\",
FontSlant->\"Italic\"]\) is an option value for \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\). It is set to \!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) when the \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\) possesses detailed balance.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696760576409285*^9, 3.69676068649081*^9}, {
  3.7143789862639923`*^9, 
  3.7143790253504667`*^9}},ExpressionUUID->"614680e4-ec92-43f9-8192-\
f99826de2079"]
}, Closed]],

Cell[CellGroupData[{

Cell["KineticExchangeSuperoperator", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.696760539870386*^9},ExpressionUUID->"0aba7aa7-3a4e-4773-993b-\
85e81c22375f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"KineticExchangeSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"K\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a kinetic exchange superoperator for dynamic \
exchange between the sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\) The argument \!\(\*
StyleBox[\"K\",
FontSlant->\"Italic\"]\) may be be one of the following: (1) A square matrix \
of dimension equal to the number of exchanging sites, with elements given by \
the kinetic rate constants; (2) A list of the form \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"m\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kml\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)in which the rate constant \!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)for the conversion of site \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) into site \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)is specified explicitly, and similarly for the other \
rate constants. If the list contains an element of the form \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)but no element for the opposite transformation \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\), the routine assumes \!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\), i.e. symmetrical rate constants between sites \
\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\). Asymmetrical rate constants between \!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\) are defined by including elements of both forms \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kji\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)and\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"kij\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\)\nIf the sites \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)are omitted, the sites are taken from the current \
\!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\\\\n\",
FontSlant->\"Italic\"]\)The options may include \!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) may be used to impose detailed balance automatically \
by adjustment of the diagonal elements. The default is \!\(\*
StyleBox[\"ImposeDetailedBalance\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\).\nThe raw kinetic matrix may be extracted by \
applying \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\) to the result.\>\""}], 
  StyleBox[";",
   FontSlant->"Italic"]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.696759610347431*^9, 3.696759641360589*^9}, {
  3.696759678767851*^9, 3.6967597718626137`*^9}, {3.696759893403173*^9, 
  3.69676002207821*^9}, {3.696760052588935*^9, 3.696760125095954*^9}, {
  3.713340614684115*^9, 3.713340615831934*^9}, {3.7144016177211857`*^9, 
  3.714401703227977*^9}, {3.7144020984384737`*^9, 3.714402122449534*^9}, {
  3.714649877295042*^9, 3.714650027330969*^9}, {3.7146500628693666`*^9, 
  3.714650172664751*^9}, {3.714650249815689*^9, 3.714650253231349*^9}, {
  3.7146503143279257`*^9, 
  3.714650334134713*^9}},ExpressionUUID->"9d6a76d0-d8b0-432e-b964-\
598a07550497"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Chapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"53e266ec-e768-4234-a26a-17935c1c3f6f"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"a1cff5f7-5cda-43ed-a604-5ff1849c9620"]
}, Closed]],

Cell[CellGroupData[{

Cell["main", "Chapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.6967593327126913`*^9, 
   3.696759333184248*^9}},ExpressionUUID->"2c985bdc-7ac7-4a88-b115-\
c348f06620d3"],

Cell[CellGroupData[{

Cell["Sites", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"aa63a301-8f93-4d6d-a440-479ccac07db1"],

Cell[CellGroupData[{

Cell["Sites", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713340718612907*^9, 3.713340828602538*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"7284c089-7805-4656-9826-e022c8120e72"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.7133437115181713`*^9, 3.7133437123721457`*^9}, {
  3.713344165935904*^9, 
  3.713344166944221*^9}},ExpressionUUID->"71a24a4f-73b7-4447-b649-\
a58a89784f99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Sites", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sites", "\[Rule]", "Undefined"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713344168690448*^9, 
  3.713344180285089*^9}},ExpressionUUID->"6e16974c-1151-4de6-b68e-\
9c42cf44359a"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.7133437115181713`*^9, 
  3.7133437123721457`*^9}},ExpressionUUID->"5c79e741-4b96-4375-808a-\
1752b702eda9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"Sites", "/.", 
     RowBox[{"{", "opts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "Sites", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713344197752034*^9, 
  3.713344210607593*^9}},ExpressionUUID->"d9217aee-a1a9-4c30-8166-\
35dc3f9ed039"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 
  3.713341363165182*^9}},ExpressionUUID->"26f54bc0-e6d0-46df-8092-\
3b6427fcfb6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "::", "notunq"}], "=", 
   "\"\<All site labels must be unique.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713341214700594*^9, 3.713341233203706*^9}, {
   3.7133636142442217`*^9, 3.713363644033628*^9}, 
   3.713364018141271*^9},ExpressionUUID->"c57e7424-d4d7-4706-8982-\
3227118bb54c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SetSites", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713340718612907*^9, 3.713340828602538*^9, {
   3.713341033257408*^9, 3.713341033720377*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"a6ffc531-788a-41cb-8d90-668fb673ebac"],

Cell[CellGroupData[{

Cell["integer argument", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.713344349986033*^9, 3.7133443512313757`*^9}, {
  3.713344501147669*^9, 3.713344504033897*^9}, {3.713344855149227*^9, 
  3.713344856242691*^9}, {3.713353852978716*^9, 3.713353855305375*^9}, {
  3.713598253218782*^9, 
  3.713598256829023*^9}},ExpressionUUID->"c95929c7-bb05-44e5-9bd7-\
5366824cbb23"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSites", "[", 
     RowBox[{"n_Integer", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"n", ">", "0"}], ")"}]}], ":=", 
   RowBox[{"SetSites", "[", 
    RowBox[{
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", "n"}], "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.713598294945696*^9, 3.7135983210455*^9}, 
   3.713599130627778*^9},ExpressionUUID->"e90e4695-3042-4b54-b8df-\
b9064c6c15fd"]
}, Closed]],

Cell[CellGroupData[{

Cell["not already set", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.713344349986033*^9, 3.7133443512313757`*^9}, {
  3.713344501147669*^9, 3.713344504033897*^9}, {3.713344855149227*^9, 
  3.713344856242691*^9}, {3.713353852978716*^9, 
  3.713353855305375*^9}},ExpressionUUID->"a06326df-8904-46de-82e4-\
01cf61b67519"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSites", "[", 
     RowBox[{"sites_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"DuplicateFreeQ", "[", "sites", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"Sites", ",", 
         RowBox[{"Sites", "\[Rule]", "sites"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SetSites", "::", "setsites"}], ",", "sites"}], "]"}]}], 
      ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Sites", "::", "notunq"}], "]"}], ";", "$Failed"}], ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713353867467661*^9, 3.713353889948462*^9}, {
   3.7133637703444843`*^9, 3.7133638249874353`*^9}, 
   3.713364035017858*^9},ExpressionUUID->"758d7ad7-dcc0-48b7-b3f1-\
d33dce0422d8"]
}, Closed]],

Cell[CellGroupData[{

Cell["no change needed", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.713344349986033*^9, 3.7133443512313757`*^9}, {
  3.713344493596258*^9, 3.713344495245542*^9}, {3.713353913919037*^9, 
  3.713353926768664*^9}},ExpressionUUID->"05ca08c3-fc26-4d03-8edb-\
a96a9107ad83"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSites", "[", 
     RowBox[{"sites_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"sites", ",", 
      RowBox[{"Sites", "[", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"SetSites", "::", "alreadyset"}], ",", "sites"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713343372302328*^9, 3.7133433743534822`*^9}, {
  3.7133434335355577`*^9, 3.713343478070559*^9}, {3.713344359938596*^9, 
  3.713344412351575*^9}, {3.713344467941411*^9, 
  3.713344475611512*^9}},ExpressionUUID->"413700c2-9936-48d2-8b5f-\
208a04b6b246"]
}, Closed]],

Cell[CellGroupData[{

Cell["change sites", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 3.7133413555394583`*^9}, {
  3.713341438418788*^9, 3.7133414443852863`*^9}, {3.713342272259965*^9, 
  3.713342272727852*^9}, {3.713344349986033*^9, 3.7133443512313757`*^9}, {
  3.713344501147669*^9, 3.713344504033897*^9}, {3.713344855149227*^9, 
  3.713344856242691*^9}},ExpressionUUID->"ba642279-4786-46bf-9ebc-\
1896802c44c3"],

Cell[CellGroupData[{

Cell["SpinSystem undefined", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713353944271379*^9, 
  3.71335395502319*^9}},ExpressionUUID->"50430b14-2ae3-4164-bf1f-\
8d8c2255bc43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSites", "[", 
     RowBox[{"sites_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"DuplicateFreeQ", "[", "sites", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"Sites", ",", 
         RowBox[{"Sites", "\[Rule]", "sites"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SetSites", "::", "setsites"}], ",", "sites"}], "]"}]}], 
      ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Sites", "::", "notunq"}], "]"}], ";", "$Failed"}], ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713353467916378*^9, 3.713353551959515*^9}, {
   3.713353588913424*^9, 3.713353595031006*^9}, {3.713363862127446*^9, 
   3.7133638739558573`*^9}, 
   3.713364038791239*^9},ExpressionUUID->"c44260d8-3ff3-4af6-b4eb-\
82595ec99d3c"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem defined \[Rule] SetExtendedOperatorBasis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713353944271379*^9, 
  3.713353975827598*^9}},ExpressionUUID->"4bb1592c-f400-495e-bbb4-\
87c43a8df50a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSites", "[", 
     RowBox[{"sites_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}], ")"}],
      "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"sites", ",", 
         RowBox[{"Sites", "[", 
          RowBox[{"ExtendedOperatorBasis", "[", "]"}], "]"}]}], "]"}]}], 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"DuplicateFreeQ", "[", "sites", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"Sites", ",", 
         RowBox[{"Sites", "\[Rule]", "sites"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SetSites", "::", "setsites"}], ",", "sites"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetExtendedOperatorBasis", "[", "sites", "]"}]}], 
      "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Sites", "::", "notunq"}], "]"}], ";", "$Failed"}], ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713353467916378*^9, 3.713353551959515*^9}, {
   3.713353622345911*^9, 3.7133536426660137`*^9}, {3.7133538165007143`*^9, 
   3.713353823355221*^9}, {3.713353981437923*^9, 3.713353982490859*^9}, {
   3.713354474626767*^9, 3.71335448839189*^9}, 3.7133632289554577`*^9, {
   3.713363261906142*^9, 3.7133632668236647`*^9}, {3.713363472018848*^9, 
   3.713363473949638*^9}, {3.7133639034608583`*^9, 3.713363913240387*^9}, 
   3.713364047665909*^9},ExpressionUUID->"8177958f-b48f-4883-ba38-\
61831890b62d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713341339990663*^9, 
  3.713341363165182*^9}},ExpressionUUID->"ac01db46-bdff-484c-86af-\
74b84153d2ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSites", "::", "alreadyset"}], "=", 
   "\"\<The set of exchanging sites is already set to `1`. No action has been \
taken.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713343487559722*^9, 3.7133435335677357`*^9}, {
  3.713344418417178*^9, 
  3.713344463813856*^9}},ExpressionUUID->"f924cb76-0ada-4941-a62f-\
9a32a28b85dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSites", "::", "setsites"}], "=", 
   "\"\<The set of exchanging sites has been set to `1`\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713341214700594*^9, 
  3.713341233203706*^9}},ExpressionUUID->"2e3b6ec6-c392-4931-b7fd-\
b544503a7551"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedOperatorBasis", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"1ac13836-fb73-4158-a364-12e6a2da5f8d"],

Cell[CellGroupData[{

Cell["SetExtendedOperatorBasis", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 
   3.713342307571553*^9},ExpressionUUID->"a3488b59-77f4-431f-9596-\
02d9a3fb5b88"],

Cell[CellGroupData[{

Cell["preliminaries", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713356673814103*^9, 
  3.7133566789260063`*^9}},ExpressionUUID->"c44973ed-b12e-41be-8b20-\
4005d9ec67d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetExtendedOperatorBasis", "[", "___", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetExtendedOperatorBasis", "::", "undefspinsys"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354651096747*^9, 3.713354694034294*^9}, {
   3.713355879947626*^9, 3.713355884347343*^9}, 3.713356354571582*^9, {
   3.713356757917994*^9, 
   3.7133567748762836`*^9}},ExpressionUUID->"b5ae06c4-394a-4d3f-bb26-\
601d638a3453"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetExtendedOperatorBasis", "[", "___", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetExtendedOperatorBasis", "::", "undefsites"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713355032321929*^9, 3.713355047492175*^9}, {
   3.713355408086358*^9, 3.7133554094830637`*^9}, 3.713355888632628*^9, 
   3.713356357600278*^9, {3.713356762141388*^9, 
   3.713356778657589*^9}},ExpressionUUID->"706bbad1-3524-4760-ba17-\
33a980656ed6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713355032321929*^9, 3.713355047492175*^9}, {
   3.713355408086358*^9, 3.7133554094830637`*^9}, 3.713355888632628*^9, 
   3.713356357600278*^9, {3.713356762141388*^9, 3.713356778657589*^9}, {
   3.713356855808363*^9, 3.713356878560837*^9}, 
   3.713356942165831*^9},ExpressionUUID->"7a557155-03a4-46d4-b7f8-\
86a1392d4875"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{"sites_List", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"OperatorBasis", "[", "]"}], ",", "Undefined"}], "]"}], ",", 
       
       RowBox[{"SetOperatorBasis", "[", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetExtendedOperatorBasis", "[", 
      RowBox[{"sites", ",", 
       RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342981911121*^9, 3.713343042073245*^9}, {
  3.713357557325119*^9, 
  3.7133575707927713`*^9}},ExpressionUUID->"9548d08e-c75c-431e-8307-\
1ed9ed0bab66"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{
     RowBox[{"opb_", "?", "DefinedOperatorBasisQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "opb", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713356986477216*^9, 3.713357014075378*^9}, {
  3.713357053647271*^9, 
  3.7133571010912933`*^9}},ExpressionUUID->"ca672dbc-9e03-4e48-9836-\
2e1f8f481846"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"opb_", "?", "DefinedOperatorBasisQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"DuplicateFreeQ", "[", "sites", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SetExtendedOperatorBasis", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ExtendedOperatorBasis", "[", 
        RowBox[{"sites", ",", "opb", ",", "opts"}], "]"}], ",", 
       "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Sites", "::", "notunq"}], "]"}], ";", "$Failed"}], ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342613068952*^9, 3.713342614228237*^9}, {
   3.713342739552597*^9, 3.713342768994903*^9}, {3.713342871165742*^9, 
   3.713342948467162*^9}, 3.713357750957836*^9, {3.713358903719037*^9, 
   3.7133589425468388`*^9}, {3.7133626213768663`*^9, 3.713362624055808*^9}, {
   3.713364110724299*^9, 
   3.713364144158374*^9}},ExpressionUUID->"a5e403fd-bb9d-4bc8-8d8a-\
af278ce804f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["set", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713342480533085*^9, 3.713342481724399*^9}, {3.713356664647255*^9, 
  3.713356684449361*^9}, {3.713357606712257*^9, 
  3.713357607102783*^9}},ExpressionUUID->"bfcffc5d-0f54-4e24-892c-\
0fb7216613d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetExtendedOperatorBasis", "[", 
     RowBox[{"xopb_ExtendedOperatorBasis", ",", "___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ExtendedOperatorBasis", "/.", 
       RowBox[{"Options", "[", "ExtendedOperatorBasis", "]"}]}], ",", 
      "xopb"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SetExtendedOperatorBasis", "::", "alreadyset"}], ",", "xopb"}],
      "]"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342631803137*^9, 3.7133427083518353`*^9}, 
   3.713342791166911*^9, {3.7133594625581017`*^9, 
   3.713359472796167*^9}},ExpressionUUID->"8ef0b07c-a5d8-4310-943f-\
00da194ce6da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "[", 
    RowBox[{"xopb_ExtendedOperatorBasis", ",", "___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"ExtendedOperatorBasis", ",", 
       RowBox[{"ExtendedOperatorBasis", "\[Rule]", "xopb"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SetExtendedOperatorBasis", "::", "set"}], ",", "xopb"}], 
      "]"}], ";", "\[IndentingNewLine]", "xopb"}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342350719275*^9, 3.713342366029604*^9}, {
  3.713342411514542*^9, 3.713342472892796*^9}, {3.71334257705582*^9, 
  3.713342601724818*^9}, {3.713342800989936*^9, 3.71334284500939*^9}, {
  3.713363050009738*^9, 
  3.7133630543515177`*^9}},ExpressionUUID->"62513e1f-e670-44f4-9533-\
0e3de2725a25"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713342480533085*^9, 
  3.713342481724399*^9}},ExpressionUUID->"2e7c12c6-33e4-4fc4-bcdd-\
442a0c79a7ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "::", "undefspinsys"}], "=", 
   "\"\<The spin system is undefined. Set the spin system using \!\(\*
StyleBox[\"SetSpinSystem\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354704552804*^9, 3.7133547293763943`*^9}, {
   3.713355072381699*^9, 3.7133550726059637`*^9}, {3.713355277709156*^9, 
   3.713355285790887*^9}, 
   3.713356795578163*^9},ExpressionUUID->"36dabcd2-c611-4e30-b6bd-\
141662ac3abf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "::", "undefsites"}], "=", 
   "\"\<The list of exchanging sites is undefined. Set the sites using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354704552804*^9, 3.7133547293763943`*^9}, {
   3.713355064711809*^9, 3.713355088110818*^9}, {3.713355229221672*^9, 
   3.7133552299297953`*^9}, 
   3.713356798002163*^9},ExpressionUUID->"a10bc06b-a3df-4833-b210-\
2f7b9e5bde04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "::", "alreadyset"}], "=", 
   "\"\<The extended operator basis is already set to `1`. No action has been \
taken.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342714241951*^9, 
  3.7133427323989363`*^9}},ExpressionUUID->"3b5244cb-e19a-4c54-9484-\
d62acf2188f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetExtendedOperatorBasis", "::", "set"}], "=", 
   "\"\<The extended operator basis has been set to `1`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713342714241951*^9, 3.7133427323989363`*^9}, {
  3.713342851512616*^9, 
  3.7133428598566837`*^9}},ExpressionUUID->"8e9b47f9-e706-408c-ae0b-\
2776639339c1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedOperatorBasis", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 3.713342307571553*^9, 
   3.713342488452608*^9},ExpressionUUID->"30584102-67ff-406d-97fd-\
d58f7c4ddd08"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713354907321225*^9, 3.713354922503236*^9}, {3.7133571580233717`*^9, 
  3.713357158998501*^9}},ExpressionUUID->"c4ab9870-0648-44df-9c33-\
3c242006cd9c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ExtendedOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"ExtendedOperatorBasis", "\[Rule]", "Undefined"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133571610733347`*^9, 
  3.713357175430972*^9}},ExpressionUUID->"f6e5ef3b-7d19-410b-8a25-\
ca4e863ba5f1"]
}, Closed]],

Cell[CellGroupData[{

Cell["undefined SpinSystem or Sites", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713354626791643*^9, 3.7133546355206347`*^9}, {3.713355028087586*^9, 
  3.713355028837489*^9}, {3.713359708268058*^9, 3.7133597101558647`*^9}, {
  3.7133621883031588`*^9, 
  3.713362202373704*^9}},ExpressionUUID->"b90239a5-0037-496f-ba5a-\
8bcc6c686313"],

Cell[CellGroupData[{

Cell["undefined SpinSystem", "Subsubsection",
 CellChangeTimes->{{3.7133602827929153`*^9, 3.713360315518165*^9}, {
  3.713360393540018*^9, 
  3.713360397886509*^9}},ExpressionUUID->"7d245c3d-88aa-4fb4-a67d-\
721d5c0f65ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedOperatorBasis", "[", "___", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ExtendedOperatorBasis", "::", "undefspinsys"}], "]"}], ";", 
     "Undefined"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354651096747*^9, 3.713354694034294*^9}, {
   3.713355879947626*^9, 3.713355884347343*^9}, 
   3.713356354571582*^9},ExpressionUUID->"c03d1c9d-45fd-41d4-8404-\
d5b69d77d6b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["undefined Sites", "Subsubsection",
 CellChangeTimes->{{3.7133602827929153`*^9, 3.713360315518165*^9}, {
   3.713360393540018*^9, 3.713360397886509*^9}, 
   3.71336046012823*^9},ExpressionUUID->"23ddcdad-fe2f-414f-bcc2-\
09ff52593804"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedOperatorBasis", "[", "___", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ExtendedOperatorBasis", "::", "undefsites"}], "]"}], ";", 
     "Undefined"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713355032321929*^9, 3.713355047492175*^9}, {
   3.713355408086358*^9, 3.7133554094830637`*^9}, 3.713355888632628*^9, 
   3.713356357600278*^9},ExpressionUUID->"a56f8f75-162d-4ada-ac72-\
031df5f65ca8"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["resets", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713354626791643*^9, 3.7133546355206347`*^9}, {3.713355028087586*^9, 
  3.713355028837489*^9}, {3.713359708268058*^9, 3.7133597101558647`*^9}, {
  3.713362171517992*^9, 
  3.713362172317601*^9}},ExpressionUUID->"968057e0-2f68-40c9-8bc3-\
61746e0e3026"],

Cell[CellGroupData[{

Cell["\<\
SpinSystem and Sites are defined, but ExtendedOperatorBasis is undefined\
\>", "Subsubsection",
 CellChangeTimes->{{3.7133602827929153`*^9, 3.713360315518165*^9}, {
   3.713360403572756*^9, 3.713360418232863*^9}, {3.713361712734289*^9, 
   3.713361726038287*^9}, {3.713361821922782*^9, 3.71336184964078*^9}, 
   3.713362130449559*^9, {3.713362229478197*^9, 
   3.713362259706365*^9}},ExpressionUUID->"1fddfe23-a437-4d89-8fa5-\
73c7d31048cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedOperatorBasis", "[", "opts___Rule", "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ExtendedOperatorBasis", "/.", 
        RowBox[{"Options", "[", "ExtendedOperatorBasis", "]"}]}], ",", 
       "Undefined"}], "]"}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SetExtendedOperatorBasis", "[", "opts", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ExtendedOperatorBasis", "[", "opts", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713361733317429*^9, 3.713361819578793*^9}, {
   3.7133618794230328`*^9, 3.7133618925496073`*^9}, {3.713362063741455*^9, 
   3.713362082160425*^9}, {3.7133622741328487`*^9, 3.713362283649315*^9}, {
   3.713362460277341*^9, 3.713362471899701*^9}, 
   3.713362611352627*^9},ExpressionUUID->"54d84323-b14c-4067-af84-\
540b28935315"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
SpinSystem and Sites are defined, but inconsistent with the current \
ExtendedOperatorBasis\
\>", "Subsubsection",
 CellChangeTimes->{{3.7133602827929153`*^9, 3.713360315518165*^9}, {
  3.713360403572756*^9, 3.713360418232863*^9}, {3.71336213803375*^9, 
  3.713362148470903*^9}, {3.7133622966291656`*^9, 
  3.713362317695921*^9}},ExpressionUUID->"07b82152-5497-4a4e-b913-\
7d8dff0d6921"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"xopb", ",", "opb", ",", "spinsys", ",", "sites"}], "}"}], ",", 
     
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"ExtendedOperatorBasis", "::", "inappspinsys"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetExtendedOperatorBasis", "[", "opts", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ExtendedOperatorBasis", "[", "opts", "]"}], ";"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"xopb", "=", 
         RowBox[{"ExtendedOperatorBasis", "/.", 
          RowBox[{"Options", "[", "ExtendedOperatorBasis", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"sites", "=", 
         RowBox[{"Sites", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"spinsys", ",", 
            RowBox[{"SpinSystem", "[", "xopb", "]"}]}], "]"}]}], "||", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites", ",", 
            RowBox[{"Sites", "[", "xopb", "]"}]}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133597290984793`*^9, 3.713359890677438*^9}, {
  3.7133599234594603`*^9, 3.7133600562975397`*^9}, {3.713360094438141*^9, 
  3.713360158488892*^9}, {3.7133601909088993`*^9, 3.713360225978044*^9}, {
  3.71336025624501*^9, 3.713360274978272*^9}, {3.7133603305037537`*^9, 
  3.713360368269124*^9}, {3.7133604209012527`*^9, 3.713360439442144*^9}, {
  3.713360481257717*^9, 3.713360484471752*^9}, {3.713360698403573*^9, 
  3.7133607105050287`*^9}, {3.713361079100664*^9, 3.713361244468549*^9}, {
  3.7133623417917643`*^9, 3.713362395425434*^9}, {3.713362481931945*^9, 
  3.713362491260992*^9}},ExpressionUUID->"ec3b9a2b-408d-4512-ab6a-\
d1863af6578c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["default", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713354907321225*^9, 3.713354922503236*^9}, {3.713357413735585*^9, 
  3.713357415861931*^9}, {3.713359644785062*^9, 
  3.71335964503691*^9}},ExpressionUUID->"c3097278-e784-4791-8d1c-\
ef18374502bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"ExtendedOperatorBasis", "/.", 
     RowBox[{"{", "opts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "ExtendedOperatorBasis", "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713358095905088*^9, 
  3.71335810116958*^9}},ExpressionUUID->"9ea84d26-eba2-49f5-a4c3-\
cbbd4db0bc47"]
}, Closed]],

Cell[CellGroupData[{

Cell["extract information", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
   3.713344841692039*^9, 3.713344845450583*^9}, 
   3.713355148392679*^9},ExpressionUUID->"c88114fa-a829-4e46-a80a-\
761811b27471"],

Cell[CellGroupData[{

Cell["Sites", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
   3.713343215843707*^9, 3.713343218145011*^9}, 
   3.713367979068841*^9},ExpressionUUID->"9c7c23cb-5650-49ee-9ab0-\
d875c230f10d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Sites", "[", 
     RowBox[{
      RowBox[{"ExtendedOperatorBasis", "[", 
       RowBox[{"sites_List", ",", "opb_", ",", "___Rule"}], "]"}], ",", 
      "___Rule"}], "]"}]}], ":=", "sites"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133432198755503`*^9, 3.713343249618391*^9}, {
  3.713355679367976*^9, 
  3.713355681831608*^9}},ExpressionUUID->"c1ed8971-e3c1-4a96-a8b4-\
47498289514f"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
   3.713343215843707*^9, 3.713343218145011*^9}, {3.71334479138233*^9, 
   3.713344793430057*^9}, 
   3.713367981312241*^9},ExpressionUUID->"efd255cf-9f29-4509-a4f9-\
7e4726c7d53d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorBasis", "[", 
     RowBox[{
      RowBox[{"ExtendedOperatorBasis", "[", 
       RowBox[{"sites_List", ",", "opb_", ",", "___Rule"}], "]"}], ",", 
      "___Rule"}], "]"}]}], ":=", "opb"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133432198755503`*^9, 3.713343249618391*^9}, {
   3.713344800977724*^9, 3.713344803515683*^9}, 
   3.713355685920638*^9},ExpressionUUID->"d2a79ebe-9d29-459d-8296-\
b7d7841a5af6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
   3.713343215843707*^9, 3.713343218145011*^9}, {3.71334479138233*^9, 
   3.7133448208271933`*^9}, 
   3.713367983721615*^9},ExpressionUUID->"b89b68c7-84fc-40c6-b5be-\
8a0f4acaa4f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SpinSystem", "[", 
     RowBox[{
      RowBox[{"ExtendedOperatorBasis", "[", 
       RowBox[{"sites_List", ",", "opb_", ",", "___Rule"}], "]"}], ",", 
      "___Rule"}], "]"}]}], ":=", 
   RowBox[{"SpinSystem", "@", "opb"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133432198755503`*^9, 3.713343249618391*^9}, {
   3.713344800977724*^9, 3.713344827900359*^9}, 
   3.713355687704297*^9},ExpressionUUID->"6197566f-1d04-478f-8b2c-\
d8161ac68ed6"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713343215843707*^9, 3.713343218145011*^9}, {3.71334479138233*^9, 
  3.7133448208271933`*^9}, {3.713367983721615*^9, 
  3.713367995101736*^9}},ExpressionUUID->"e1536fa5-9e78-49ef-b76c-\
9af8c2982ef5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"BasisOperators", "[", 
     RowBox[{
      RowBox[{"ExtendedOperatorBasis", "[", 
       RowBox[{"sites_List", ",", "opb_", ",", "___Rule"}], "]"}], ",", 
      "___Rule"}], "]"}]}], ":=", 
   RowBox[{"BasisOperators", "@", "opb"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133432198755503`*^9, 3.713343249618391*^9}, {
   3.713344800977724*^9, 3.713344827900359*^9}, 3.713355687704297*^9, {
   3.713367998317985*^9, 
   3.713368001356926*^9}},ExpressionUUID->"dcb42498-f250-41f0-a421-\
703bb254dfe5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.713342375395035*^9, 3.7133423762529497`*^9}, {
  3.713344841692039*^9, 3.713344845450583*^9}, {3.713354643825767*^9, 
  3.7133546450803556`*^9}},ExpressionUUID->"13810f36-2225-42bf-9d65-\
266770c1814e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "::", "undefspinsys"}], "=", 
   "\"\<The spin system is undefined. Set the spin system using \!\(\*
StyleBox[\"SetSpinSystem\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354704552804*^9, 3.7133547293763943`*^9}, {
  3.713355072381699*^9, 3.7133550726059637`*^9}, {3.713355277709156*^9, 
  3.713355285790887*^9}},ExpressionUUID->"4bd96c9d-6a2f-4248-a7ad-\
662dca570fcd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "::", "undefsites"}], "=", 
   "\"\<The list of exchanging sites is undefined. Set the sites using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713354704552804*^9, 3.7133547293763943`*^9}, {
  3.713355064711809*^9, 3.713355088110818*^9}, {3.713355229221672*^9, 
  3.7133552299297953`*^9}},ExpressionUUID->"110b9f7d-e176-458a-ae06-\
39973d2a615d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "::", "inappspinsys"}], "=", 
   "\"\<The \!\(\*
StyleBox[\"SpinSystem\",
FontSlant->\"Italic\"]\) of the current \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\) is inappropriate.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713360589698464*^9, 3.713360633779599*^9}, {
  3.713364321110037*^9, 
  3.713364322474105*^9}},ExpressionUUID->"4cb72630-d13e-4b2b-9a49-\
2944606e81e7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorBasis", "::", "inappsites"}], "=", 
   "\"\<The \!\(\*
StyleBox[\"Sites\",
FontSlant->\"Italic\"]\) of the current \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\) are inappropriate.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713360589698464*^9, 3.713360660707267*^9}, {
  3.713364326074589*^9, 
  3.713364327493009*^9}},ExpressionUUID->"6048ef14-fd04-4210-8bab-\
957c54939d2f"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SiteDependentOperator", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"7d82f5a2-995d-4151-ba12-a73ecc9d800f"],

Cell[CellGroupData[{

Cell["preparation", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 
  3.713365691073255*^9}},ExpressionUUID->"cfcde4cb-e01e-437d-917d-\
7aae9ec5075f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentOperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 
  3.713599246918935*^9}},ExpressionUUID->"f7e5fec8-227c-41b9-bceb-\
f240d94c3bda"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"{", "op", "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597896225809*^9, 3.7135979073177223`*^9}, {3.7135979528820267`*^9, 
  3.713597960340056*^9}},ExpressionUUID->"6ecfb0c5-c6f2-481e-ba4f-\
b3ce71a208b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"notop", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "|", "_List"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentOperator", "::", "invalarg"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7137901923609257`*^9, 
  3.713790249871603*^9}},ExpressionUUID->"c9a06cd1-5ef5-4cc0-a771-\
6223fc814f2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"op_", "?", "OperatorQ"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"op", ",", 
       RowBox[{"{", 
        RowBox[{"Length", "@", 
         RowBox[{"Sites", "[", "]"}]}], "}"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597942927208*^9, 
  3.7135979457605953`*^9}},ExpressionUUID->"4681e85a-abc1-4a20-843d-\
03bc2a520cc0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"ops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "ops", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365911408746*^9, 
  3.7133659228014727`*^9}},ExpressionUUID->"97eef8ce-d372-4a1b-be78-\
74400ba00051"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{"Undefined", ",", 
     RowBox[{"ops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentOperator", "::", "undefsites"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366426688796*^9, 
  3.7133664521912727`*^9}},ExpressionUUID->"427a07bf-b2d7-4888-9ded-\
b4f17f8dd066"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{"sites", ",", 
     RowBox[{"Table", "[", 
      RowBox[{"op", ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "sites", "]"}], "}"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714047208402121*^9, 
  3.7140472418280354`*^9}},ExpressionUUID->"8db6f256-4cd2-4930-b864-\
665c6f4492c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentOperator", "[", 
     RowBox[{"sites_List", ",", 
      RowBox[{"ops", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], "..."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "ops", "]"}], "\[NotEqual]", 
     RowBox[{"Length", "@", "sites"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentOperator", "::", "badlen"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365698405979*^9, 3.7133657203208103`*^9}, {
  3.713365750926866*^9, 3.7133657938398046`*^9}, {3.713365872460154*^9, 
  3.713365874027438*^9}, {3.7133659278203793`*^9, 
  3.7133659367623177`*^9}},ExpressionUUID->"7759cac5-eea0-4b1a-8616-\
9e3bd98f34ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"ops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"sites", ",", "ops"}], "}"}], "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365850507573*^9, 3.713365902499604*^9}, {
   3.7133659448500023`*^9, 3.71336595346173*^9}, {3.7133665772513657`*^9, 
   3.713366612209258*^9}, 
   3.713366731618658*^9},ExpressionUUID->"ac069b98-8f3e-4a08-b35a-\
6f31011aa11a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", 
       RowBox[{"opi_", "?", "OperatorQ"}]}], "}"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"i", ",", "opi"}], "}"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597733085424*^9, 
  3.713597782991816*^9}},ExpressionUUID->"79c91e2f-0152-4915-b62c-\
5db8e788e828"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentOperator", "[", 
     RowBox[{
      RowBox[{"siteoplist", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"SetSites", "[", 
      RowBox[{"First", "/@", "siteoplist"}], "]"}], ";", 
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{"siteoplist", ",", "opts"}], "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366662857132*^9, 
  3.7133667227576523`*^9}},ExpressionUUID->"f7db352f-3f0d-491f-a9a0-\
03fcad53f8dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "[", 
    RowBox[{
     RowBox[{"siteoplist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "sites", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SiteDependentOperator", "::", "badsites"}], ",", "sites", 
          ",", 
          RowBox[{"Sites", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sites", "=", 
         RowBox[{"First", "/@", "siteoplist"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"!", 
         RowBox[{"ContainsAll", "[", 
          RowBox[{
           RowBox[{"Sites", "[", "]"}], ",", "sites"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597389197915*^9, 
  3.7135976647960043`*^9}},ExpressionUUID->"0e21c38f-94b2-43c4-a0c0-\
a43cd51bec6d"]
}, Closed]],

Cell[CellGroupData[{

Cell["extract information", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}},ExpressionUUID->"ca396d0a-20aa-4b08-8951-\
849e9d2a4112"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "[", 
    RowBox[{"SiteDependentOperator", "[", 
     RowBox[{
      RowBox[{"siteoplist", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", 
   RowBox[{"First", "/@", "siteoplist"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366040495229*^9, 
  3.713366102177732*^9}},ExpressionUUID->"db05a77d-4f9a-4f9d-b6c4-\
f192e3ee0986"]
}, Closed]],

Cell[CellGroupData[{

Cell["manipulations", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}, {3.714045227091044*^9, 
  3.714045229457468*^9}},ExpressionUUID->"d1aa8d7b-325d-48ed-acf3-\
1aba22aa5247"],

Cell[CellGroupData[{

Cell["Times", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.714047440626006*^9, 
  3.714047441537568*^9}},ExpressionUUID->"09b3c64a-5188-4c64-bc98-\
9b49835efaee"],

Cell[CellGroupData[{

Cell["Times of a SiteDependentOperator and a number or symbol", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 3.714046235335973*^9}, {3.7140474437852077`*^9, 
  3.714047444625287*^9}, {3.7140479348266773`*^9, 
  3.714047936802017*^9}},ExpressionUUID->"790db806-4c89-4265-bef8-\
cece571cc0e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Times", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{"n", "*", "ops"}]}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}], ",",
          "\[IndentingNewLine]", "b"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714047449529976*^9, 
  3.714047458741908*^9}, {3.7140479649002247`*^9, 
  3.714047976937201*^9}},ExpressionUUID->"527f8036-bd6f-4d8a-ada3-\
59f4c2549d61"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdop_SiteDependentOperator", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Times", "[", 
    RowBox[{"a", ",", "n", ",", "sdop", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, {
   3.714047468393421*^9, 3.714047476008584*^9}, 
   3.714047982548423*^9},ExpressionUUID->"579b998b-4633-463b-87ce-\
e859c77ecfbb"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Times of a SiteDependentOperator with another SiteDependentOperator, or an \
operator\
\>", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 3.7140462234992037`*^9}, {3.7140474962575417`*^9, 
  3.714047497183114*^9}, {3.71404768721175*^9, 
  3.714047696537166*^9}},ExpressionUUID->"d5089d3a-2333-46b7-b7bc-\
5599adc48bb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "sdop1_SiteDependentOperator", ",", "op_", ",", "b___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"OperatorQ", "[", "op", "]"}], "||", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"op", ",", "_SiteDependentOperator"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentOperator", "::", "badtimes"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.714047502112698*^9, 
  3.714047546294277*^9}, {3.714047632445428*^9, 3.71404765951432*^9}, {
  3.7140478601974173`*^9, 
  3.714047869482478*^9}},ExpressionUUID->"4406fbcf-ea89-403d-92dc-\
276e89993a8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "op_", ",", "sdop1_SiteDependentOperator", ",", "b___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"OperatorQ", "[", "op", "]"}], "||", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"op", ",", "_SiteDependentOperator"}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentOperator", "::", "badtimes"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.714047502112698*^9, 
  3.714047546294277*^9}, {3.714047632445428*^9, 3.714047674902264*^9}, {
  3.714047871668124*^9, 
  3.714047872555891*^9}},ExpressionUUID->"46a0a9f3-f1d2-4481-abba-\
e334432c361f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 
  3.7140452420567083`*^9}},ExpressionUUID->"a509929b-264c-4870-806f-\
cdf74ed3a59b"],

Cell[CellGroupData[{

Cell["Dot of a SiteDependentOperator and a number or symbol", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 3.714046235335973*^9}, {3.714048632367144*^9, 
  3.714048634796672*^9}},ExpressionUUID->"35d79148-0036-49d4-b988-\
da989d48c172"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{"n", "*", "ops"}]}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}], ",",
          "\[IndentingNewLine]", "b"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714048639175606*^9, 
  3.714048648460607*^9}},ExpressionUUID->"f2c1c0b4-cf82-433d-b08f-\
3fbc101a9f67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdop_SiteDependentOperator", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"a", ",", "n", ",", "sdop", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, 
   3.714048653601718*^9},ExpressionUUID->"aa019b4b-2dd0-4d6e-8968-\
f09156c78c55"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot of two SiteDependentOperator objects", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 
  3.7140462234992037`*^9}},ExpressionUUID->"ae2f3cd3-1bfd-44ad-bdc4-\
b057b0d35239"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist1", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist2", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts2___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites1", ",", "ops1", ",", "sites2", ",", "ops2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites1", ",", "ops1"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites2", ",", "ops2"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites1", ",", "sites2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SiteDependentOperator", "::", "incompatsites"}], "]"}], 
           ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Dot", "[", 
          RowBox[{"a", ",", "\[IndentingNewLine]", 
           RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"sites1", ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Dot", ",", "ops1", ",", "ops2", ",", "List"}], 
                 "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
               RowBox[{"opts1", ",", "opts2"}], "\[IndentingNewLine]", 
               "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "b"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 
  3.7140463924371557`*^9}},ExpressionUUID->"4191d928-c144-400f-8adf-\
e5d6e2b08296"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot of a SiteDependentOperator and an operator", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 
  3.7140464507305813`*^9}},ExpressionUUID->"74061128-1028-4253-893e-\
37b2bcf4a317"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Dot", "[", 
                 RowBox[{"op", ",", "#"}], "]"}], "&"}], "/@", "ops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}},ExpressionUUID->"29452348-1289-4e0c-9f72-\
4af575aa97e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", "b___"}],
      "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Dot", "[", 
                 RowBox[{"#", ",", "op"}], "]"}], "&"}], "/@", "ops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.7140465267405653`*^9}},ExpressionUUID->"a1e24618-babf-497e-8df8-\
599c774ec549"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.7143716598211184`*^9, 
  3.7143716606759033`*^9}},ExpressionUUID->"ceb1e770-5dc0-43de-8948-\
78587b406475"],

Cell[CellGroupData[{

Cell["Plus of a SiteDependentOperator and a number or symbol", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.714046235335973*^9}, {3.714048632367144*^9, 
   3.714048634796672*^9}, 
   3.714371665157507*^9},ExpressionUUID->"0c4c41dc-cbca-41de-bd48-\
02cdb44e9f7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "sdop_SiteDependentOperator", ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Plus", "[", 
    RowBox[{"a", ",", 
     RowBox[{"n", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "sdop", ",", "b"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714048639175606*^9, 
  3.714048648460607*^9}, {3.714371678937047*^9, 
  3.714371748289709*^9}},ExpressionUUID->"a383bbc2-86cd-4b2b-aa22-\
877cbde8bb67"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdop_SiteDependentOperator", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{"a", ",", "n", ",", "sdop", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, 
   3.714048653601718*^9, {3.7143717641182547`*^9, 
   3.7143717650554934`*^9}},ExpressionUUID->"93ca6e47-d9b6-4f12-bfa4-\
4af53e354ee6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus of two SiteDependentOperator objects", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.7140462234992037`*^9}, 
   3.714371666598054*^9},ExpressionUUID->"c5554eab-2c07-4710-9e84-\
b43ebfb6200b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist1", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist2", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts2___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites1", ",", "ops1", ",", "sites2", ",", "ops2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites1", ",", "ops1"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites2", ",", "ops2"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites1", ",", "sites2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SiteDependentOperator", "::", "incompatsites"}], "]"}], 
           ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Plus", "[", 
          RowBox[{"a", ",", "\[IndentingNewLine]", 
           RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"sites1", ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Plus", ",", "ops1", ",", "ops2", ",", "List"}], 
                 "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
               RowBox[{"opts1", ",", "opts2"}], "\[IndentingNewLine]", 
               "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "b"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.7143717729582663`*^9, 
  3.714371792913209*^9}},ExpressionUUID->"f9690282-cf65-44f6-91d1-\
16617080f2b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus of a SiteDependentOperator and an operator", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
   3.714046450246076*^9, 3.7140464507305813`*^9}, 
   3.7143716678933487`*^9},ExpressionUUID->"88c76de5-9270-4154-95d3-\
ec5763743a90"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Plus", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Plus", "[", 
                 RowBox[{"op", ",", "#"}], "]"}], "&"}], "/@", "ops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.714371804289817*^9, 
  3.714371833111087*^9}},ExpressionUUID->"85fb4530-88b3-4e71-9f8f-\
17bfffed2c26"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", "b___"}],
      "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Plus", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Plus", "[", 
                 RowBox[{"#", ",", "op"}], "]"}], "&"}], "/@", "ops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.7140465267405653`*^9}, {3.7143718404346943`*^9, 
  3.714371856959326*^9}},ExpressionUUID->"03a61ab1-4cd3-4287-95de-\
43112a7cd008"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exp and Power", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.714048337358479*^9, 
  3.714048340676869*^9}},ExpressionUUID->"481b0c27-7387-4c15-b8c4-\
70491837faf4"],

Cell[CellGroupData[{

Cell["Exp", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 3.7140464507305813`*^9}, {3.714048043143828*^9, 
  3.714048047942593*^9}},ExpressionUUID->"66e9b369-6e19-4882-890d-\
0b71955e5c40"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Exp", "[", 
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{"Exp", "/@", "ops"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 
  3.7140481121727247`*^9}},ExpressionUUID->"7e779bcf-d4e2-423b-8e35-\
e0cd2b17a8ed"]
}, Closed]],

Cell[CellGroupData[{

Cell["Power", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 3.7140464507305813`*^9}, {3.714048043143828*^9, 
  3.714048047942593*^9}, {3.714048130228917*^9, 
  3.714048131107692*^9}},ExpressionUUID->"facaa660-cfbc-4d32-a56d-\
fc554c8475a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "n_"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Power", "[", 
               RowBox[{"#", ",", "n"}], "]"}], "&"}], "/@", "ops"}]}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 
  3.714048172236265*^9}},ExpressionUUID->"8a61f463-1bc3-4916-a27a-\
580401b5d753"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentOperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{"n_", ",", 
      RowBox[{"SiteDependentOperator", "[", 
       RowBox[{
        RowBox[{"siteoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentOperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Power", "[", 
               RowBox[{"n", ",", "#"}], "]"}], "&"}], "/@", "ops"}]}], "}"}], 
          "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 
  3.714048210241592*^9}},ExpressionUUID->"a959c17d-10b7-40cd-8e32-\
2268f0725012"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator and DoubleCommutationSuperoperator", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}, {3.714045227091044*^9, 3.714045229457468*^9}, {
  3.7140500027616262`*^9, 3.714050022391726*^9}, {3.7140508499466543`*^9, 
  3.714050877254944*^9}},ExpressionUUID->"998b5ec4-b044-412a-b639-\
f3b292ef0ced"],

Cell[CellGroupData[{

Cell["CommutationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.7140500447603292`*^9},ExpressionUUID->"efb1cbf2-e7d1-476b-a722-\
b661cf456f36"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts1___Rule"}], "]"}], ",", "opts2___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "@", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"CommutationSuperoperator", "[", 
               RowBox[{"#", ",", "opts1"}], "]"}], "&"}], "/@", "ops"}]}], 
           "}"}]}], ",", "\[IndentingNewLine]", "opts2"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714050033469307*^9, 3.714050180553671*^9}, {
  3.714050707485935*^9, 
  3.714050710162764*^9}},ExpressionUUID->"1b215232-641b-4d05-9db8-\
d1cc6d9e2a46"]
}, Closed]],

Cell[CellGroupData[{

Cell["DoubleCommutationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.7140500447603292`*^9, {3.714050206378996*^9, 
   3.71405020760988*^9}},ExpressionUUID->"1ada6481-34d5-4347-adf2-\
891fa4021c92"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
     "opts2___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "@", 
          RowBox[{"{", 
           RowBox[{"sites", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"DoubleCommutationSuperoperator", "[", 
               RowBox[{"#", ",", "op", ",", "opts1"}], "]"}], "&"}], "/@", 
             "ops"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", "opts2"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714050033469307*^9, 3.714050180553671*^9}, {
   3.7140502112359*^9, 3.7140502639445677`*^9}, 
   3.714050719686797*^9},ExpressionUUID->"1d7bded6-4115-4dfd-bb6f-\
10b1246d570e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opts2___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "ops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "ops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "@", 
          RowBox[{"{", 
           RowBox[{"sites", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"DoubleCommutationSuperoperator", "[", 
               RowBox[{"op", ",", "#", ",", "opts1"}], "]"}], "&"}], "/@", 
             "ops"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", "opts2"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714050033469307*^9, 3.714050180553671*^9}, {
   3.7140502112359*^9, 3.7140502941837883`*^9}, 
   3.7140507223727493`*^9},ExpressionUUID->"ce78853d-d4af-4b0c-9f5b-\
4c13df471f64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist1", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"siteoplist2", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts2___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opts3___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites1", ",", "ops1", ",", "sites2", ",", "ops2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites1", ",", "ops1"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites2", ",", "ops2"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "siteoplist2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites1", ",", "sites2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SiteDependentOperator", "::", "incompatsites"}], "]"}], 
           ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "@", 
            RowBox[{"{", 
             RowBox[{"sites1", ",", "\[IndentingNewLine]", 
              RowBox[{"Inner", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"DoubleCommutationSuperoperator", "[", 
                  RowBox[{"#1", ",", "#2", ",", "opts3"}], "]"}], "&"}], ",", 
                "\[IndentingNewLine]", "ops1", ",", "ops2", ",", 
                "\[IndentingNewLine]", "List"}], "\[IndentingNewLine]", 
               "]"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
           "\[IndentingNewLine]", "opts1", ",", "opts2"}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714050033469307*^9, 3.714050180553671*^9}, {
  3.7140502112359*^9, 3.714050353302347*^9}, {3.714050392483386*^9, 
  3.714050579111541*^9}},ExpressionUUID->"0d7d4101-b902-4c29-bc21-\
d7ed1e6b114a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 3.713342307571553*^9, {
   3.713365678085038*^9, 
   3.713365685361429*^9}},ExpressionUUID->"793c31d9-78b2-43d0-970b-\
e334312724c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "badlen"}], "=", 
   "\"\<The number of sites in SiteDependentOperator must be the same as the \
number of operators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133657994869003`*^9, 
  3.7133658223654947`*^9}},ExpressionUUID->"f15b9eea-4b3a-44d4-a0d5-\
0de531a0540c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "undefsites"}], "=", 
   "\"\<The set of exchanging sites must be defined by using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366464015585*^9, 
  3.7133665175335817`*^9}},ExpressionUUID->"3a500b45-7310-4c15-8946-\
3021f88f9c4c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "badsites"}], "=", 
   "\"\<One or more of the sites `1` is not a member of the current set of \
sites `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597674527896*^9, 
  3.71359769998661*^9}},ExpressionUUID->"b3340e43-be8d-49d0-bd48-\
49df540cb3eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "invalarg"}], "=", 
   "\"\<The first argument of \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) must be an operator or a \!\(\*
StyleBox[\"List\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7137902855694427`*^9, 
  3.713790322874545*^9}},ExpressionUUID->"9335d349-1f81-4486-83d1-\
81e0654dcfb0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "incompatsites"}], "=", 
   "\"\<Two \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) objects may only be combined if they use the same \
set of sites.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714045950730978*^9, 3.7140460133284893`*^9}, {
  3.714050365832617*^9, 
  3.714050381757216*^9}},ExpressionUUID->"59392605-9829-49b0-9dc8-\
2979d17e0429"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentOperator", "::", "badtimes"}], "=", "\"\<\!\(\*
StyleBox[\"Dot\",
FontSlant->\"Italic\"]\) must be used to multiply \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) with another \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) or with an operator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714047557950159*^9, 
  3.714047597169014*^9}},ExpressionUUID->"70e93f0f-e1e0-41bc-97fb-\
be7c52fd907d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedOperatorVectorRepresentation", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9, 
   3.713367411063382*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"762832d1-7812-4a5a-b3d7-ea752a9cbeb2"],

Cell[CellGroupData[{

Cell["preparation", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 
  3.713365691073255*^9}},ExpressionUUID->"bac876d3-7d6d-41f6-8f9c-\
e1b340cd7100"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedOperatorVectorRepresentation", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 3.713599246918935*^9}, 
   3.713599415157359*^9},ExpressionUUID->"78c1b869-ea7f-4501-8807-\
e694f73dd1b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"arg", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{"arg", ",", 
     RowBox[{"ExtendedOperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366008510399*^9, 3.7133660227911253`*^9}, {
  3.713366147661644*^9, 3.7133661862399073`*^9}, {3.71336739309094*^9, 
  3.713367394924539*^9}, {3.7140468428690767`*^9, 
  3.714046863988214*^9}},ExpressionUUID->"e2bab524-e32b-4308-9516-\
08d536b42e96"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"num", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
     "xopb_ExtendedOperatorBasis", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"num", "*", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "xopb", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046722127028*^9, 3.7140467891976843`*^9}, {
  3.714046821789633*^9, 3.714046826020508*^9}, {3.71404688064487*^9, 
  3.714046905954872*^9}, {3.7140496997414227`*^9, 
  3.7140497073600397`*^9}},ExpressionUUID->"278d2085-7511-4912-b731-\
b12bf255e826"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "xopb_ExtendedOperatorBasis", 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SiteDependentOperator", "[", 
      RowBox[{
       RowBox[{"Sites", "[", "xopb", "]"}], ",", "op"}], "]"}], ",", "xopb", 
     ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046722127028*^9, 
  3.7140467891976843`*^9}},ExpressionUUID->"6905778f-c2f7-435e-a6d9-\
f2ac7304f782"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
     RowBox[{
     "sdop_SiteDependentOperator", ",", "xopb_ExtendedOperatorBasis", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ContainsAll", "[", 
      RowBox[{
       RowBox[{"Sites", "[", "xopb", "]"}], ",", 
       RowBox[{"Sites", "[", "sdop", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ExtendedOperatorVectorRepresentation", "::", "incompatsites"}],
       "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71336752136969*^9, 3.713367571423956*^9}, {
  3.713598376050743*^9, 
  3.713598389233322*^9}},ExpressionUUID->"035c4faf-826c-433a-a6e8-\
e6ba6ab3c515"]
}, Closed]],

Cell[CellGroupData[{

Cell["construct", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.7133675773854227`*^9, 3.71336757852641*^9}, {3.713367684818982*^9, 
  3.713367686419546*^9}},ExpressionUUID->"f0caa3fe-e4e8-41d7-bd6f-\
7914ea316c6b"],

Cell["\<\
coding ensures that unique operator matrix representations are calculated \
only once\
\>", "Text",
 CellChangeTimes->{{3.714053213739338*^9, 3.714053236043517*^9}, {
  3.7140534818481913`*^9, 
  3.714053487156118*^9}},ExpressionUUID->"7bc21ce6-c6ec-41f6-9ddd-\
d6ab703ecffb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "[", 
    RowBox[{
    "sdop_SiteDependentOperator", ",", "xopb_ExtendedOperatorBasis", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "sdopsites", ",", "xopbsites", ",", "sdops", ",", "uniqueops", ",", 
       "ops", ",", "uniqueoppos", ",", "uniqueopvecreps", ",", "opbasis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sdopsites", ",", "sdops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", 
         RowBox[{"First", "@", "sdop"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"xopbsites", "=", 
        RowBox[{"Sites", "[", "xopb", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"opbasis", "=", 
        RowBox[{"OperatorBasis", "[", "xopb", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"uniqueops", "=", 
        RowBox[{"First", "/@", 
         RowBox[{"Tally", "[", 
          RowBox[{"Append", "[", 
           RowBox[{"sdops", ",", 
            RowBox[{"NullOperator", "[", "]"}]}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ops", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"site", ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"sdopsites", ",", "site"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Pick", "[", 
               RowBox[{"sdops", ",", "sdopsites", ",", "site"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"NullOperator", "[", "]"}]}], "\[IndentingNewLine]", 
             "]"}]}], "\[IndentingNewLine]", "]"}], "/@", "xopbsites"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"uniqueoppos", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"uniqueops", ",", "#"}], "]"}], "&"}], "/@", "ops"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"uniqueopvecreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"OperatorVectorRepresentation", "[", 
           RowBox[{"#", ",", "opbasis"}], "]"}], "&"}], "/@", "uniqueops"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"Join", "@@", 
        RowBox[{
        "uniqueopvecreps", "\[LeftDoubleBracket]", "uniqueoppos", 
         "\[RightDoubleBracket]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133677000417*^9, 3.713367839557425*^9}, {
   3.713598441988331*^9, 3.713598498889618*^9}, {3.713598529864072*^9, 
   3.713598534948596*^9}, {3.713598998999342*^9, 3.713599072225266*^9}, {
   3.713599322437578*^9, 3.71359936817449*^9}, 3.713599687966447*^9, {
   3.7140512081191053`*^9, 3.7140512083481293`*^9}, {3.7140532517618923`*^9, 
   3.714053273603297*^9}, {3.714053304892004*^9, 3.714053443814055*^9}, {
   3.714053505241185*^9, 3.71405352525261*^9}, {3.714053632463058*^9, 
   3.7140536540537243`*^9}},ExpressionUUID->"d2e33374-0c68-4e03-bf3e-\
d9835a4aa7a3"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.7133675773854227`*^9, 
  3.71336757852641*^9}},ExpressionUUID->"557717cc-5a7f-4dfa-b0ec-\
aa3b9fbc4ea7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedOperatorVectorRepresentation", "::", "incompatsites"}], 
   "=", "\"\<The sites used in the \!\(\*
StyleBox[\"SiteDependentOperator\",
FontSlant->\"Italic\"]\) must all be members of the sites used in the \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713367587280757*^9, 3.713367616892682*^9}, {
  3.713599802457756*^9, 
  3.713599832830647*^9}},ExpressionUUID->"83679d93-5b2c-4181-b870-\
812d7a27080e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SiteDependentSuperoperator", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9, {
   3.713602483117116*^9, 3.7136024841060047`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"edf0d5e8-8a2d-4b8d-a505-3208c548d676"],

Cell[CellGroupData[{

Cell["preparation", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 
  3.713365691073255*^9}},ExpressionUUID->"30804a6b-cee9-4745-b7a8-\
c9d8694a670d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentSuperoperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 3.713599246918935*^9}, 
   3.713602491413802*^9},ExpressionUUID->"5771f432-28a3-4063-be86-\
338e7247b77e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", "sop", "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597896225809*^9, 3.7135979073177223`*^9}, {3.7135979528820267`*^9, 
  3.713597960340056*^9}, {3.7136024927985907`*^9, 
  3.713602507363286*^9}},ExpressionUUID->"d30bf6b2-5867-4442-903e-\
1e85e0d78229"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"notsop", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "SuperoperatorQ"}], "|", "_List"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentSuperoperator", "::", "invalarg"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7137901923609257`*^9, 3.713790249871603*^9}, {
  3.713790389949903*^9, 
  3.7137903996711082`*^9}},ExpressionUUID->"02991e15-b7b1-4542-bb4d-\
6257e319d356"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], "}"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"sop", ",", 
       RowBox[{"{", 
        RowBox[{"Length", "@", 
         RowBox[{"Sites", "[", "]"}]}], "}"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597942927208*^9, 3.7135979457605953`*^9}, {3.713602509534251*^9, 
  3.71360252215769*^9}},ExpressionUUID->"b56f732b-2386-4393-b097-\
8ef0ceda0ca2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"sops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "SuperoperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "sops", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365911408746*^9, 3.7133659228014727`*^9}, {
  3.7136025271314383`*^9, 
  3.7136025445691967`*^9}},ExpressionUUID->"84d4414f-dab9-4674-a760-\
e917e3342d0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{"Undefined", ",", 
     RowBox[{"sops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "SuperoperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentSuperoperator", "::", "undefsites"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366426688796*^9, 3.7133664521912727`*^9}, {
  3.7136025490016203`*^9, 
  3.713602559363144*^9}},ExpressionUUID->"deb49da3-5b68-498c-bbc1-\
3342f7b2d221"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{"sites", ",", 
     RowBox[{"Table", "[", 
      RowBox[{"sop", ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "sites", "]"}], "}"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714047208402121*^9, 3.7140472418280354`*^9}, {
  3.714047272070451*^9, 
  3.71404728312052*^9}},ExpressionUUID->"3bd38e19-cce6-496f-ac3e-\
bf122a52e919"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentSuperoperator", "[", 
     RowBox[{"sites_List", ",", 
      RowBox[{"sops", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "SuperoperatorQ"}], "..."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "sops", "]"}], "\[NotEqual]", 
     RowBox[{"Length", "@", "sites"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentSuperoperator", "::", "badlen"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365698405979*^9, 3.7133657203208103`*^9}, {
  3.713365750926866*^9, 3.7133657938398046`*^9}, {3.713365872460154*^9, 
  3.713365874027438*^9}, {3.7133659278203793`*^9, 3.7133659367623177`*^9}, {
  3.7136025654719877`*^9, 
  3.713602580232291*^9}},ExpressionUUID->"fdf170b9-a00a-44d6-b916-\
49579a449a44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"sops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "SuperoperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"sites", ",", "sops"}], "}"}], "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365850507573*^9, 3.713365902499604*^9}, {
   3.7133659448500023`*^9, 3.71336595346173*^9}, {3.7133665772513657`*^9, 
   3.713366612209258*^9}, 3.713366731618658*^9, {3.713602585216591*^9, 
   3.7136025983204927`*^9}},ExpressionUUID->"fcc06dde-cef8-404b-afe9-\
7555b4882bc0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"i_", ",", 
       RowBox[{"sopi_", "?", "SuperoperatorQ"}]}], "}"}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"i", ",", "sopi"}], "}"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597733085424*^9, 3.713597782991816*^9}, {
  3.713602602788722*^9, 
  3.71360261738972*^9}},ExpressionUUID->"ae324630-26a1-4e25-9979-\
0efdaa89f7a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SiteDependentSuperoperator", "[", 
     RowBox[{
      RowBox[{"sitesoplist", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sites", "[", "]"}], ",", "Undefined"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"SetSites", "[", 
      RowBox[{"First", "/@", "sitesoplist"}], "]"}], ";", 
     RowBox[{"SiteDependentSuperoperator", "[", 
      RowBox[{"sitesoplist", ",", "opts"}], "]"}]}], ")"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.713366662857132*^9, 3.7133667227576523`*^9}, {
  3.713602622274745*^9, 
  3.713602638551426*^9}},ExpressionUUID->"3e49f09e-cb95-4e7c-8db7-\
99d986e9f95c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "[", 
    RowBox[{
     RowBox[{"sitesoplist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "sites", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SiteDependentSuperoperator", "::", "badsites"}], ",", 
          "sites", ",", 
          RowBox[{"Sites", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sites", "=", 
         RowBox[{"First", "/@", "sitesoplist"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"ContainsAll", "[", 
          RowBox[{
           RowBox[{"Sites", "[", "]"}], ",", "sites"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597389197915*^9, 3.7135976647960043`*^9}, {
  3.7136026415802298`*^9, 
  3.7136026575980186`*^9}},ExpressionUUID->"a7e773a2-8615-47ff-92ab-\
69bff14cf260"]
}, Closed]],

Cell[CellGroupData[{

Cell["extract information", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}},ExpressionUUID->"b33ab858-4f04-4a09-acc8-\
05e4c2fbe122"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "[", 
    RowBox[{"SiteDependentSuperoperator", "[", 
     RowBox[{
      RowBox[{"sitesoplist", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", 
   RowBox[{"First", "/@", "sitesoplist"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366040495229*^9, 3.713366102177732*^9}, {
  3.713602668276832*^9, 
  3.713602676273192*^9}},ExpressionUUID->"ec17feee-8c2d-42c4-8175-\
3b63254be7ab"]
}, Closed]],

Cell[CellGroupData[{

Cell["manipulations", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}, {3.714045227091044*^9, 
  3.714045229457468*^9}},ExpressionUUID->"507744a8-80fe-464a-a0f1-\
824e113f0b18"],

Cell[CellGroupData[{

Cell["Times", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.714047440626006*^9, 
  3.714047441537568*^9}},ExpressionUUID->"590fabb9-320e-41c5-bf4e-\
a0774a40a7ab"],

Cell[CellGroupData[{

Cell["Times of a SiteDependentSuperoperator and a number or symbol", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.714046235335973*^9}, {3.7140474437852077`*^9, 
   3.714047444625287*^9}, {3.7140479348266773`*^9, 3.714047936802017*^9}, 
   3.714048443150264*^9},ExpressionUUID->"2eeab1d8-615f-4be9-9898-\
0857a4514bcf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Times", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{"n", "*", "sops"}]}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}], ",",
          "\[IndentingNewLine]", "b"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714047449529976*^9, 
  3.714047458741908*^9}, {3.7140479649002247`*^9, 3.714047976937201*^9}, {
  3.714048444876605*^9, 
  3.714048465576726*^9}},ExpressionUUID->"e79da877-2252-42ff-b5af-\
ec78a49bd9b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdsop_SiteDependentSuperoperator", 
      ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Times", "[", 
    RowBox[{"a", ",", "n", ",", "sdsop", ",", "b"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, {
   3.714047468393421*^9, 3.714047476008584*^9}, 3.714047982548423*^9, {
   3.7140484724202147`*^9, 
   3.71404848456028*^9}},ExpressionUUID->"00dcf87b-87e2-4c43-878f-\
2dc3679ca890"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Times of a SiteDependentSuperoperator with another \
SiteDependentSuperoperator, or a superoperator\
\>", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 3.7140462234992037`*^9}, {3.7140474962575417`*^9, 
  3.714047497183114*^9}, {3.71404768721175*^9, 3.714047696537166*^9}, {
  3.714048492274683*^9, 
  3.7140485008804092`*^9}},ExpressionUUID->"666d0298-3434-4fce-89e3-\
d7df7feb09ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "sdsop_SiteDependentSuperoperator", ",", "sop_", ",", 
       "b___"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"SuperoperatorQ", "[", "sop", "]"}], "||", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"sop", ",", "_SiteDependentSuperoperator"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentSuperoperator", "::", "badtimes"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.714047502112698*^9, 
  3.714047546294277*^9}, {3.714047632445428*^9, 3.71404765951432*^9}, {
  3.7140478601974173`*^9, 3.714047869482478*^9}, {3.714048508678487*^9, 
  3.7140485481376333`*^9}},ExpressionUUID->"77739e5a-6aa3-4b3e-89fe-\
71977244731f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "sop_", ",", "sdsop_SiteDependentSuperoperator", ",", 
       "b___"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"SuperoperatorQ", "[", "sop", "]"}], "||", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"sop", ",", "_SiteDependentSuperoperator"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SiteDependentSuperoperator", "::", "badtimes"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.714047502112698*^9, 
  3.714047546294277*^9}, {3.714047632445428*^9, 3.71404765951432*^9}, {
  3.7140478601974173`*^9, 3.714047869482478*^9}, {3.714048508678487*^9, 
  3.714048564006568*^9}},ExpressionUUID->"3c16f230-5f86-4001-9d43-\
10cf180872fe"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 
  3.7140452420567083`*^9}},ExpressionUUID->"981c6230-01a4-4167-979b-\
e01a537deb67"],

Cell[CellGroupData[{

Cell["Dot of a SiteDependentSuperoperator and a number or symbol", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
  3.714046222980563*^9, 3.714046235335973*^9}, {3.7140486173762217`*^9, 
  3.714048624940585*^9}},ExpressionUUID->"246a53c8-f873-456a-b7d6-\
83adac815fcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{"n", "*", "sops"}]}], "}"}], "]"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}], ",",
          "\[IndentingNewLine]", "b"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714048639175606*^9, 
  3.71404868816424*^9}},ExpressionUUID->"5f2d20ab-3f77-4262-9839-\
6bfc1bccd726"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdsop_SiteDependentSuperoperator", 
      ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"a", ",", "n", ",", "sdsop", ",", "b"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, 
   3.714048653601718*^9, {3.714048694078697*^9, 
   3.714048702955851*^9}},ExpressionUUID->"ca04a883-a5cf-4a5d-a582-\
30655edb4041"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot of two SiteDependentSuperoperator objects", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.7140462234992037`*^9}, 
   3.714048715790783*^9},ExpressionUUID->"649d2624-18ac-4b92-b0eb-\
ec2aa501c737"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist1", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist2", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts2___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites1", ",", "sops1", ",", "sites2", ",", "sops2"}], "}"}], 
     ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites1", ",", "sops1"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites2", ",", "sops2"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites1", ",", "sites2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SiteDependentSuperoperator", "::", "incompatsites"}], 
            "]"}], ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Dot", "[", 
          RowBox[{"a", ",", "\[IndentingNewLine]", 
           RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"sites1", ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Dot", ",", "sops1", ",", "sops2", ",", "List"}], 
                 "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
               RowBox[{"opts1", ",", "opts2"}], "\[IndentingNewLine]", 
               "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "b"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.714048717559134*^9, 
  3.714048748345709*^9}},ExpressionUUID->"9caae01a-de4d-4132-9bfa-\
40f8b03e831f"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot of a SiteDependentSuperoperator and a superoperator", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 3.7140464507305813`*^9}, {3.7140487864978037`*^9, 
  3.714048791221903*^9}},ExpressionUUID->"32efdc7d-804b-4986-95d0-\
a22e07801afd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Dot", "[", 
                 RowBox[{"sop", ",", "#"}], "]"}], "&"}], "/@", "sops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.71404879607557*^9, 
  3.714048840069026*^9}},ExpressionUUID->"a687f5f7-5c74-46bc-91c3-\
c4c6a81ce75c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "\[IndentingNewLine]", 
      "b___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dot", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Dot", "[", 
                 RowBox[{"#", ",", "sop"}], "]"}], "&"}], "/@", "sops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.7140465267405653`*^9}, {3.714048850513835*^9, 
  3.7140488748538237`*^9}},ExpressionUUID->"6acf2309-c0a1-41ef-8fe5-\
255d561f8c8b"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.7143716598211184`*^9, 
  3.7143716606759033`*^9}},ExpressionUUID->"2b4e252c-0ab3-49ba-8c1e-\
a97c5fa3696e"],

Cell[CellGroupData[{

Cell["Plus of a SiteDependentSuperoperator and a number or symbol", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.714046235335973*^9}, {3.714048632367144*^9, 
   3.714048634796672*^9}, 3.714371665157507*^9, 
   3.714371929357121*^9},ExpressionUUID->"994dd49f-21d3-4c4a-9e94-\
06aa843d0c74"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "sdsop_SiteDependentSuperoperator", ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Plus", "[", 
    RowBox[{"a", ",", 
     RowBox[{"n", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "sdsop", ",", "b"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.714048639175606*^9, 
  3.714048648460607*^9}, {3.714371678937047*^9, 3.714371748289709*^9}, {
  3.714371946763548*^9, 
  3.714371958533247*^9}},ExpressionUUID->"e73c520c-b43a-4900-87a4-\
6453843d8e2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
     "a___", ",", "\[IndentingNewLine]", "sdsop_SiteDependentSuperoperator", 
      ",", "\[IndentingNewLine]", 
      RowBox[{"n", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
      "\[IndentingNewLine]", "b___"}], "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{"a", ",", "n", ",", "sdsop", ",", "b"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.714046412665863*^9, 3.714046437757864*^9}, 
   3.714048653601718*^9, {3.7143717641182547`*^9, 3.7143717650554934`*^9}, {
   3.7143719647189703`*^9, 
   3.714371972100215*^9}},ExpressionUUID->"4d9edc47-d1ee-47e0-bc31-\
03cfcef42156"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus of two SiteDependentSuperoperator objects", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.714045769893977*^9}, {
   3.714046222980563*^9, 3.7140462234992037`*^9}, 3.714371666598054*^9, 
   3.7143719306070004`*^9},ExpressionUUID->"d68cdae9-f424-4086-857b-\
dc27c935514f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist1", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist2", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts2___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites1", ",", "sops1", ",", "sites2", ",", "sops2"}], "}"}], 
     ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites1", ",", "sops1"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites2", ",", "sops2"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"sites1", ",", "sites2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SiteDependentSuperoperator", "::", "incompatsites"}], 
            "]"}], ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Plus", "[", 
          RowBox[{"a", ",", "\[IndentingNewLine]", 
           RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"sites1", ",", 
                RowBox[{"Inner", "[", 
                 RowBox[{"Plus", ",", "sops1", ",", "sops2", ",", "List"}], 
                 "]"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
               RowBox[{"opts1", ",", "opts2"}], "\[IndentingNewLine]", 
               "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "b"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046368658684*^9, 3.7140463924371557`*^9}, {3.7143717729582663`*^9, 
  3.714371792913209*^9}, {3.714371981882864*^9, 
  3.7143720183628693`*^9}},ExpressionUUID->"678ad79a-b956-40d0-9ea0-\
192443192d7e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plus of a SiteDependentSuperoperator and a superoperator", \
"Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
   3.714046450246076*^9, 3.7140464507305813`*^9}, 3.7143716678933487`*^9, {
   3.7143719319586697`*^9, 
   3.714371938571673*^9}},ExpressionUUID->"94769633-052c-4f1f-a297-\
6c06dff8a87b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "b___"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Plus", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Plus", "[", 
                 RowBox[{"sop", ",", "#"}], "]"}], "&"}], "/@", "sops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.714371804289817*^9, 3.714371833111087*^9}, {
  3.7143720304147377`*^9, 
  3.7143720656461277`*^9}},ExpressionUUID->"1850edfe-800a-4d28-b19e-\
f5115b29268e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{"a___", ",", "\[IndentingNewLine]", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "\[IndentingNewLine]", 
      "b___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Plus", "[", 
        RowBox[{"a", ",", "\[IndentingNewLine]", 
         RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"sites", ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Plus", "[", 
                 RowBox[{"#", ",", "sop"}], "]"}], "&"}], "/@", "sops"}]}], 
             "}"}], "]"}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "b"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.7140465267405653`*^9}, {3.7143718404346943`*^9, 3.714371856959326*^9}, {
  3.714372078724306*^9, 
  3.714372107846692*^9}},ExpressionUUID->"e18c39fb-8d15-49e3-8aa9-\
a6c5411946ae"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exp and Power", "Subsection",
 CellChangeTimes->{{3.714045241578038*^9, 3.7140452420567083`*^9}, {
  3.714048337358479*^9, 
  3.714048340676869*^9}},ExpressionUUID->"dca4e179-19b2-4599-88e9-\
aea0df7cf599"],

Cell[CellGroupData[{

Cell["Exp", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 3.7140464507305813`*^9}, {3.714048043143828*^9, 
  3.714048047942593*^9}},ExpressionUUID->"bdfa2f53-e709-463a-b34d-\
987fba929bef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Exp", "[", 
     RowBox[{"SiteDependentSuperoperator", "[", 
      RowBox[{
       RowBox[{"sitesoplist", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{"Exp", "/@", "sops"}]}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 3.7140481121727247`*^9}, {
  3.714048900458665*^9, 
  3.7140489169334593`*^9}},ExpressionUUID->"fb2a0323-d5ea-441d-b378-\
c2d5340c7477"]
}, Closed]],

Cell[CellGroupData[{

Cell["Power", "Subsubsection",
 CellChangeTimes->{{3.714045759542561*^9, 3.7140457825943213`*^9}, {
  3.714046450246076*^9, 3.7140464507305813`*^9}, {3.714048043143828*^9, 
  3.714048047942593*^9}, {3.714048130228917*^9, 
  3.714048131107692*^9}},ExpressionUUID->"89d50f0c-3a12-4109-9975-\
26d909f972d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}], ",", "n_"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Power", "[", 
               RowBox[{"#", ",", "n"}], "]"}], "&"}], "/@", "sops"}]}], "}"}],
           "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 3.714048172236265*^9}, {
  3.714048926999391*^9, 
  3.714048944386773*^9}},ExpressionUUID->"b3b501e5-cf11-48c2-adf7-\
1d8efeaea326"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SiteDependentSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{"n_", ",", 
      RowBox[{"SiteDependentSuperoperator", "[", 
       RowBox[{
        RowBox[{"sitesoplist", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
        "opts___Rule"}], "]"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sites", ",", "sops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sites", ",", "sops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "sitesoplist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SiteDependentSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"sites", ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Power", "[", 
               RowBox[{"n", ",", "#"}], "]"}], "&"}], "/@", "sops"}]}], "}"}],
           "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71404570064922*^9, 3.714045737623638*^9}, {
  3.714045833351871*^9, 3.714045936383608*^9}, {3.714046026235114*^9, 
  3.714046148989377*^9}, {3.714046190511115*^9, 3.714046202955853*^9}, {
  3.714046246054199*^9, 3.714046359481154*^9}, {3.7140464793666286`*^9, 
  3.714046504230167*^9}, {3.7140480598317423`*^9, 3.714048172236265*^9}, {
  3.714048926999391*^9, 
  3.71404897362646*^9}},ExpressionUUID->"54e13c78-bae6-40bc-82af-\
3d7c964febc0"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 3.713342307571553*^9, {
   3.713365678085038*^9, 
   3.713365685361429*^9}},ExpressionUUID->"75fd4d3c-412b-4d9a-a546-\
74c45a371253"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "badlen"}], "=", 
   "\"\<The number of sites in \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) must be the same as the number of \
superoperators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133657994869003`*^9, 3.7133658223654947`*^9}, {
  3.713602683543577*^9, 
  3.71360269130149*^9}},ExpressionUUID->"db391e22-39a9-44a5-832a-\
e4e0c248f6cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "undefsites"}], "=", 
   "\"\<The set of exchanging sites must be defined by using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366464015585*^9, 3.7133665175335817`*^9}, 
   3.7136026976288023`*^9},ExpressionUUID->"367c5443-8add-4eb1-8be0-\
162e0e1653a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "badsites"}], "=", 
   "\"\<One or more of the sites `1` is not a member of the current set of \
sites `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597674527896*^9, 3.71359769998661*^9}, 
   3.713602702004992*^9},ExpressionUUID->"22a2af85-6368-4973-b982-\
239ff7664130"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "invalarg"}], "=", 
   "\"\<The first argument of \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) must be a superoperator or a \!\(\*
StyleBox[\"List\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7137902855694427`*^9, 
  3.713790352417934*^9}},ExpressionUUID->"7d3eefb1-1fed-4615-a09b-\
4e5df505fc17"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "incompatsites"}], "=", 
   "\"\<The product of two \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) objects is only defined for the same set of sites.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714045950730978*^9, 3.7140460133284893`*^9}, {
  3.714048769370305*^9, 
  3.714048771066408*^9}},ExpressionUUID->"7ef4db1a-44d4-433c-a65f-\
4b415a4bc413"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SiteDependentSuperoperator", "::", "badtimes"}], "=", "\"\<\!\(\*
StyleBox[\"Dot\",
FontSlant->\"Italic\"]\) must be used to multiply \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) with another \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) or with a superoperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714047557950159*^9, 3.714047597169014*^9}, {
  3.7140485854560347`*^9, 
  3.714048593085968*^9}},ExpressionUUID->"143214d4-19c3-466a-8476-\
6eceb8aa3b44"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedSuperoperatorMatrixRepresentation", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9, 
   3.713367411063382*^9, {3.713602743311842*^9, 3.713602749141251*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ababebdf-6592-4324-a6a7-e8f781dd6954"],

Cell[CellGroupData[{

Cell["preparation", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 
  3.713365691073255*^9}},ExpressionUUID->"f15c49de-67ac-4cc4-9831-\
7927dffd7d6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
    "ExtendedSuperoperatorMatrixRepresentation", "[", "args___", "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 3.713599246918935*^9}, 
   3.713599415157359*^9, 
   3.713602755100174*^9},ExpressionUUID->"7af1ec4e-66e9-4a95-a2ce-\
7dd974faaca9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"arg", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{"arg", ",", 
     RowBox[{"ExtendedOperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366008510399*^9, 3.7133660227911253`*^9}, {
  3.713366147661644*^9, 3.7133661862399073`*^9}, {3.71336739309094*^9, 
  3.713367394924539*^9}, {3.7140468428690767`*^9, 3.714046863988214*^9}, {
  3.7140496879308*^9, 
  3.714049689292491*^9}},ExpressionUUID->"65397f01-e3b4-4914-97db-\
d8e80af7ed6f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}]}], ",", 
     "xopb_ExtendedOperatorBasis", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", "*", 
      RowBox[{"UnitySuperoperator", "[", "]"}]}], ",", "xopb", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046722127028*^9, 3.7140467891976843`*^9}, {
   3.714046821789633*^9, 3.714046826020508*^9}, {3.71404688064487*^9, 
   3.714046905954872*^9}, {3.7140496997414227`*^9, 3.714049734217757*^9}, 
   3.7140541982782583`*^9},ExpressionUUID->"8a3f37b2-db8a-4af4-8d2e-\
9680ffbbf1d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     "xopb_ExtendedOperatorBasis", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
   "ExtendedSuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SiteDependentSuperoperator", "[", 
      RowBox[{
       RowBox[{"Sites", "[", "xopb", "]"}], ",", "sop"}], "]"}], ",", "xopb", 
     ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714046722127028*^9, 3.7140467891976843`*^9}, {
  3.714049785345668*^9, 
  3.714049806383807*^9}},ExpressionUUID->"57ef0dbe-3f4d-4fc4-bb93-\
85c0cbd4dda6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
     RowBox[{
     "sdsop_SiteDependentSuperoperator", ",", "xopb_ExtendedOperatorBasis", 
      ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ContainsAll", "[", 
      RowBox[{
       RowBox[{"Sites", "[", "xopb", "]"}], ",", 
       RowBox[{"Sites", "[", "sdsop", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
      "ExtendedSuperoperatorMatrixRepresentation", "::", "incompatsites"}], 
      "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.71336752136969*^9, 3.713367571423956*^9}, {
  3.713598376050743*^9, 3.713598389233322*^9}, {3.713602779395204*^9, 
  3.713602795076138*^9}},ExpressionUUID->"958ddb1e-9c5f-4658-b5a1-\
b20826d060b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["construct", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.7133675773854227`*^9, 3.71336757852641*^9}, {3.713367684818982*^9, 
  3.713367686419546*^9}},ExpressionUUID->"43a2e0c4-ff28-42a7-8e37-\
f1750492674f"],

Cell["\<\
coding ensures that unique superoperator matrix representations are \
calculated only once\
\>", "Text",
 CellChangeTimes->{{3.714053213739338*^9, 3.714053236043517*^9}, {
  3.7140534818481913`*^9, 3.714053487156118*^9}, {3.714053744478599*^9, 
  3.714053745733827*^9}},ExpressionUUID->"9212af6a-d0a7-48df-b370-\
6a57067c9a5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{
    "sdsop_SiteDependentSuperoperator", ",", "xopb_ExtendedOperatorBasis", 
     ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "sdsopsites", ",", "xopbsites", ",", "sdsops", ",", "uniquesops", ",", 
       "sops", ",", "uniquesoppos", ",", "uniquesopmatreps", ",", 
       "sopmatreps", ",", "opbasis", ",", "nsite", ",", "nL"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"sdsopsites", ",", "sdsops"}], "}"}], "=", 
        RowBox[{"Transpose", "@", 
         RowBox[{"First", "@", "sdsop"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"xopbsites", "=", 
        RowBox[{"Sites", "[", "xopb", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"opbasis", "=", 
        RowBox[{"OperatorBasis", "[", "xopb", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nsite", "=", 
        RowBox[{"Length", "@", "xopbsites"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nL", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"uniquesops", "=", 
        RowBox[{"First", "/@", 
         RowBox[{"Tally", "[", 
          RowBox[{"Append", "[", 
           RowBox[{"sdsops", ",", 
            RowBox[{"NullSuperoperator", "[", "]"}]}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sops", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"site", ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"sdsopsites", ",", "site"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Pick", "[", 
               RowBox[{"sdsops", ",", "sdsopsites", ",", "site"}], "]"}], ",",
               "\[IndentingNewLine]", 
              RowBox[{"NullSuperoperator", "[", "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "/@",
           "xopbsites"}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"uniquesoppos", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"uniquesops", ",", "#"}], "]"}], "&"}], "/@", "sops"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"uniquesopmatreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"#", ",", "opbasis"}], "]"}], "&"}], "/@", 
         "uniquesops"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"sopmatreps", "=", 
        RowBox[{
        "uniquesopmatreps", "\[LeftDoubleBracket]", "uniquesoppos", 
         "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Join", "@@", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ArrayPad", "[", 
           RowBox[{
            RowBox[{
            "sopmatreps", "\[LeftDoubleBracket]", "i", 
             "\[RightDoubleBracket]"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"i", "-", "1"}], ")"}], "*", "nL"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"nsite", "-", "i"}], ")"}], "*", "nL"}]}], "}"}]}], 
             "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "nsite"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133677000417*^9, 3.713367839557425*^9}, {
   3.713598441988331*^9, 3.713598498889618*^9}, {3.713598529864072*^9, 
   3.713598534948596*^9}, {3.713598998999342*^9, 3.713599072225266*^9}, {
   3.713599322437578*^9, 3.71359936817449*^9}, 3.713599687966447*^9, {
   3.7140512081191053`*^9, 3.7140512083481293`*^9}, {3.7140532517618923`*^9, 
   3.714053273603297*^9}, {3.714053304892004*^9, 3.714053443814055*^9}, {
   3.714053505241185*^9, 3.71405352525261*^9}, {3.714053632463058*^9, 
   3.7140536540537243`*^9}, {3.71405375318443*^9, 3.714053931255343*^9}, {
   3.714054023848102*^9, 3.714054075748343*^9}, 
   3.714054488467841*^9},ExpressionUUID->"522da4bd-15f9-406f-9a70-\
d33924a3c424"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.7133675773854227`*^9, 
  3.71336757852641*^9}},ExpressionUUID->"e266ab07-b5b7-47b5-ba91-\
9cb25de495bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "ExtendedSuperoperatorMatrixRepresentation", "::", "incompatsites"}], "=", 
   "\"\<The sites used in the \!\(\*
StyleBox[\"SiteDependentSuperoperator\",
FontSlant->\"Italic\"]\) must all be members of the sites used in the \!\(\*
StyleBox[\"ExtendedOperatorBasis\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713367587280757*^9, 3.713367616892682*^9}, {
  3.713599802457756*^9, 3.713599832830647*^9}, {3.713602847873008*^9, 
  3.713602857098473*^9}},ExpressionUUID->"41cd8898-8e70-4b2a-9329-\
b5f759e343d1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["KineticExchangeMatrix", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9, {
   3.71437263540457*^9, 3.7143726394509907`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"df19243a-3a32-4fb7-aed0-4ba3d2e3cbff"],

Cell[CellGroupData[{

Cell["options", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.714374961475728*^9, 
  3.714374962386895*^9}},ExpressionUUID->"1bc228c6-6b05-4b31-846a-\
f23b3bc3efe3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "KineticExchangeMatrix", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ImposeDetailedBalance", "\[Rule]", "True"}], ",", 
     RowBox[{"DetailedBalance", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714374965992387*^9, 3.71437500083566*^9}, {
  3.7143790460796547`*^9, 3.71437905099658*^9}, {3.7146503984459763`*^9, 
  3.714650400882172*^9}},ExpressionUUID->"421e9afb-fbc5-41d8-b43e-\
e8f142b0c27f"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, 
   3.714375014231001*^9},ExpressionUUID->"38ff3f84-aa8b-4a12-aa5d-\
829a4c4e70ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticExchangeMatrix", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 3.713599246918935*^9}, 
   3.7143726439201727`*^9},ExpressionUUID->"96b8fe3c-d7c8-4425-aba0-\
24597e0260ac"],

Cell[CellGroupData[{

Cell["rule/kval form", "Subsection",
 CellChangeTimes->{{3.714373188101687*^9, 3.714373200327655*^9}, {
  3.714373290554079*^9, 3.714373291289527*^9}, {3.714373342738442*^9, 
  3.714373343121793*^9}, {3.714374208634309*^9, 3.7143742355068207`*^9}, {
  3.714374819684558*^9, 
  3.714374820649907*^9}},ExpressionUUID->"fbecc7ff-acdd-4042-a7d4-\
63400f3d5a19"],

Cell[CellGroupData[{

Cell["checks", "Subsubsection",
 CellChangeTimes->{{3.714650697042523*^9, 
  3.714650697707033*^9}},ExpressionUUID->"32ddd70b-7937-440a-8c02-\
7895813bbab2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites___", ",", 
     RowBox[{"rulekval", ":", 
      RowBox[{"{", 
       RowBox[{"_Rule", ",", "_"}], "}"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites", ",", 
     RowBox[{"{", "rulekval", "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597942927208*^9, 3.7135979457605953`*^9}, {3.7143726791719027`*^9, 
  3.7143727258987703`*^9}, {3.714373235190997*^9, 3.714373267448022*^9}, {
  3.714373347208502*^9, 3.714373348688347*^9}, {3.714374218452917*^9, 
  3.7143742427342653`*^9}, {3.714379686033717*^9, 
  3.7143797154399433`*^9}},ExpressionUUID->"5f393611-8989-4249-80ec-\
4f9898867bfb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "rulekvallist", ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
  3.713597942927208*^9, 3.7135979457605953`*^9}, {3.7143726791719027`*^9, 
  3.7143727258987703`*^9}, {3.714373235190997*^9, 3.714373267448022*^9}, {
  3.714373347208502*^9, 3.714373348688347*^9}, {3.714374218452917*^9, 
  3.7143742427342653`*^9}},ExpressionUUID->"ad6b28ea-8963-4d90-9452-\
5c01290e6948"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"Undefined", ",", 
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"KineticExchangeMatrix", "::", "undefsites"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366426688796*^9, 3.7133664521912727`*^9}, {
   3.7143727347856483`*^9, 3.714372741678388*^9}, 3.71437328020993*^9, {
   3.714373337553033*^9, 3.714373337825365*^9}, {3.714374222302204*^9, 
   3.714374244543881*^9}},ExpressionUUID->"24c456d3-83b9-4632-aa9e-\
a770bab95936"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rules", ",", "kvals"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"KineticExchangeMatrix", "::", "duprules"}], "]"}], ";", 
        "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rules", ",", "kvals"}], "}"}], "=", 
         RowBox[{"Transpose", "@", "rulekvallist"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"DuplicateFreeQ", "[", "rules", "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365698405979*^9, 3.7133657203208103`*^9}, {
  3.713365750926866*^9, 3.7133657938398046`*^9}, {3.713365872460154*^9, 
  3.713365874027438*^9}, {3.7133659278203793`*^9, 3.7133659367623177`*^9}, {
  3.714372789169393*^9, 3.714372829814687*^9}, {3.7143733160902023`*^9, 
  3.714373425348074*^9}, {3.714373490050557*^9, 3.7143735308199463`*^9}, {
  3.714374226700512*^9, 
  3.7143742481258593`*^9}},ExpressionUUID->"b92de30b-ebd1-4c9b-9382-\
3150e86b6f98"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rules", ",", "kvals", ",", "invalrules"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"invalrules", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"rulekvallist", ",", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"ContainsAll", "[", 
              RowBox[{"sites", ",", 
               RowBox[{"List", "@@", 
                RowBox[{"(", 
                 RowBox[{"First", "@", "#"}], ")"}]}]}], "]"}]}], "&"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"KineticExchangeMatrix", "::", "invalspecs"}], ",", 
          "invalrules"}], "]"}], ";", "\[IndentingNewLine]", "$Failed"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rules", ",", "kvals"}], "}"}], "=", 
         RowBox[{"Transpose", "@", "rulekvallist"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"ContainsAll", "[", 
          RowBox[{"sites", ",", 
           RowBox[{"Apply", "[", 
            RowBox[{"Sequence", ",", "rules", ",", "1"}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365698405979*^9, 3.7133657203208103`*^9}, {
   3.713365750926866*^9, 3.7133657938398046`*^9}, {3.713365872460154*^9, 
   3.713365874027438*^9}, {3.7133659278203793`*^9, 3.7133659367623177`*^9}, {
   3.714372789169393*^9, 3.714372829814687*^9}, {3.7143733160902023`*^9, 
   3.714373425348074*^9}, {3.714373490050557*^9, 3.7143736374622917`*^9}, {
   3.714374056755797*^9, 3.714374064465455*^9}, 3.714374113166483*^9, {
   3.714374592412365*^9, 3.714374660629744*^9}, {3.714374735543621*^9, 
   3.714374738602269*^9}},ExpressionUUID->"8131645a-8f7c-482e-870e-\
d27910560e23"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
symmetrize any transformations which do not have a defined partner \
\>", "Subsubsection",
 CellChangeTimes->{{3.714650697042523*^9, 
  3.714650766160734*^9}},ExpressionUUID->"1a40a1c5-bcb5-4cd9-86b5-\
e4ace24c52c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rules", ",", "kvals", ",", "symmrulekvallist"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"KineticExchangeMatrix", "[", 
        RowBox[{"sites", ",", "symmrulekvallist", ",", "opts"}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"rules", ",", "kvals"}], "}"}], "=", 
         RowBox[{"Transpose", "@", "rulekvallist"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"symmrulekvallist", "=", 
         RowBox[{"First", "/@", 
          RowBox[{"GatherBy", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{"rulekvallist", ",", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Reverse", "/@", "rules"}], ",", "kvals"}], "}"}], 
               "]"}]}], "]"}], ",", "First"}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"Sort", "[", 
            RowBox[{"First", "/@", "symmrulekvallist"}], "]"}], ",", 
           RowBox[{"Sort", "[", 
            RowBox[{"First", "/@", "rulekvallist"}], "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714650776768355*^9, 3.714650934428973*^9}, {
  3.7146510011137447`*^9, 3.714651009547729*^9}, {3.7146512179394283`*^9, 
  3.7146512253987923`*^9}, {3.714651402703589*^9, 3.714651406157031*^9}, {
  3.71465154376094*^9, 3.714651550280754*^9}, {3.714651947783732*^9, 
  3.714651967772606*^9}, {3.7146520633949842`*^9, 3.714652065738369*^9}, {
  3.714652100244309*^9, 
  3.714652105308536*^9}},ExpressionUUID->"9936e58a-2f35-408a-979c-\
5f9d7b8a852f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["matrix form", "Subsection",
 CellChangeTimes->{{3.714373188101687*^9, 
  3.714373189845233*^9}},ExpressionUUID->"cc88ef73-be57-4f91-88f5-\
e766692a46a0"],

Cell[CellGroupData[{

Cell["checks", "Subsubsection",
 CellChangeTimes->{{3.714650697042523*^9, 
  3.714650697707033*^9}},ExpressionUUID->"a60cbc77-f720-41ee-9834-\
a958685f2955"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{
     RowBox[{"Kmat", ":", 
      RowBox[{"(", 
       RowBox[{"_SparseArray", "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_Rule", "]"}], "..."}], "}"}], "..."}], 
         "}"}]}], ")"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "Kmat", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
   3.713597942927208*^9, 3.7135979457605953`*^9}, {3.7143726791719027`*^9, 
   3.7143727258987703`*^9}, 
   3.7143801351737556`*^9},ExpressionUUID->"07ec673d-1ea3-4e3b-83c8-\
eb25b3b12338"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"Undefined", ",", 
     RowBox[{"Kmat", ":", 
      RowBox[{"(", 
       RowBox[{"_SparseArray", "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_Rule", "]"}], "..."}], "}"}], "..."}], 
         "}"}]}], ")"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"KineticExchangeMatrix", "::", "undefsites"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366426688796*^9, 3.7133664521912727`*^9}, {
   3.7143727347856483`*^9, 3.714372741678388*^9}, 3.714379441531918*^9, 
   3.7143801392916307`*^9},ExpressionUUID->"8a8c0be6-5f59-4838-ac81-\
692b47cbfd73"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticExchangeMatrix", "[", 
     RowBox[{"sites_List", ",", 
      RowBox[{"Kmat", ":", 
       RowBox[{"(", 
        RowBox[{"_SparseArray", "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_Rule", "]"}], "..."}], "}"}], "..."}], 
          "}"}]}], ")"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Dimensions", "[", "Kmat", "]"}], "\[NotEqual]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Length", "@", "sites"}], ",", 
       RowBox[{"Length", "@", "sites"}]}], "}"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"KineticExchangeMatrix", "::", "baddims"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713365698405979*^9, 3.7133657203208103`*^9}, {
   3.713365750926866*^9, 3.7133657938398046`*^9}, {3.713365872460154*^9, 
   3.713365874027438*^9}, {3.7133659278203793`*^9, 3.7133659367623177`*^9}, {
   3.714372789169393*^9, 3.714372829814687*^9}, {3.714379412084056*^9, 
   3.714379434360552*^9}, 
   3.714380141514718*^9},ExpressionUUID->"2d7f8182-4f98-4a42-ae14-\
f239f1911296"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["convert rule/k form to matrix form", "Section",
 CellChangeTimes->{{3.714375133510252*^9, 3.714375136874604*^9}, {
  3.714376071525765*^9, 
  3.714376086788589*^9}},ExpressionUUID->"44580c89-1238-4e8d-be00-\
6402bc10f9bb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"sites_List", ",", 
     RowBox[{"rulekvallist", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Rule", ",", "_"}], "}"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rules", ",", "kvals", ",", "Kmat", ",", "n", ",", "matpos"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "sites", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"rules", ",", "kvals"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "rulekvallist"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"matpos", "=", 
        RowBox[{
         RowBox[{"Function", "[", 
          RowBox[{"rule", ",", 
           RowBox[{"Reverse", "@", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Position", "[", 
                RowBox[{"sites", ",", "#"}], "]"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{"List", "@@", "rule"}], ")"}]}], "]"}]}]}], "]"}], "/@",
          "rules"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"KineticExchangeMatrix", "[", "\[IndentingNewLine]", 
        RowBox[{"sites", ",", "\[IndentingNewLine]", 
         RowBox[{"ReplacePart", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"_", ",", "_"}], "}"}], "\[Rule]", "0"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "n"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Apply", "[", 
            RowBox[{"Rule", ",", 
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"matpos", ",", "kvals"}], "}"}], "]"}], ",", "1"}], 
            "]"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]",
          "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7143761233977747`*^9, 3.714376191656074*^9}, {
  3.7143763834507713`*^9, 3.714376394573679*^9}, {3.714376482769376*^9, 
  3.71437650290327*^9}, {3.714377407154089*^9, 3.714377464859192*^9}, {
  3.714379641919868*^9, 3.714379659428422*^9}, {3.714651301471266*^9, 
  3.714651302268368*^9}},ExpressionUUID->"e474979d-272c-4c35-a19f-\
4c15698d428b"]
}, Closed]],

Cell[CellGroupData[{

Cell["ImposeDetailedBalance", "Section",
 CellChangeTimes->{{3.714375133510252*^9, 3.714375136874604*^9}, {
   3.714377614584305*^9, 3.714377617215571*^9}, 
   3.7143805258500013`*^9},ExpressionUUID->"3cb05441-ed10-4aa2-b243-\
a5fac65b6fc2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticExchangeMatrix", "[", 
     RowBox[{"sites_List", ",", 
      RowBox[{"Kmat", ":", 
       RowBox[{"(", 
        RowBox[{"_SparseArray", "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_Rule", "]"}], "..."}], "}"}], "..."}], 
          "}"}]}], ")"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ImposeDetailedBalance", ",", "DetailedBalance"}], "}"}], "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "KineticExchangeMatrix", "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False"}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"KineticExchangeMatrix", "[", 
       RowBox[{"sites", ",", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Transpose", "@", 
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Which", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Plus", "@@", 
                RowBox[{"Kmat", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "col"}], "\[RightDoubleBracket]"}]}], 
               "\[Equal]", "0"}], ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"Kmat", "\[LeftDoubleBracket]", 
               RowBox[{"All", ",", "col"}], "\[RightDoubleBracket]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Kmat", "\[LeftDoubleBracket]", 
                RowBox[{"col", ",", "col"}], "\[RightDoubleBracket]"}], 
               "\[Equal]", "0"}], ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"ReplacePart", "[", 
               RowBox[{
                RowBox[{"Kmat", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "col"}], "\[RightDoubleBracket]"}], ",", 
                
                RowBox[{"col", "\[Rule]", 
                 RowBox[{"-", 
                  RowBox[{"Plus", "@@", 
                   RowBox[{"Kmat", "\[LeftDoubleBracket]", 
                    RowBox[{"All", ",", "col"}], 
                    "\[RightDoubleBracket]"}]}]}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Message", "[", 
                 RowBox[{"KineticExchangeMatrix", "::", "detbalerr"}], "]"}], 
                ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"col", ",", "1", ",", 
              RowBox[{"Length", "[", "sites", "]"}]}], "}"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DetailedBalance", "\[Rule]", "True"}], ",", 
          "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714374894570382*^9, 3.714374935673368*^9}, {
   3.714375038389501*^9, 3.714375061132592*^9}, {3.714375093348259*^9, 
   3.71437509974067*^9}, {3.7143751546935377`*^9, 3.7143751832671432`*^9}, {
   3.714375216940669*^9, 3.714375231370875*^9}, {3.7143755357988167`*^9, 
   3.7143757201238728`*^9}, {3.714375890945901*^9, 3.714375944326665*^9}, {
   3.714375990399872*^9, 3.714376007948057*^9}, {3.714376042825037*^9, 
   3.714376045925198*^9}, {3.71437763755863*^9, 3.714377758523061*^9}, {
   3.714378155663677*^9, 3.714378164733062*^9}, {3.714378209278751*^9, 
   3.7143782517304688`*^9}, {3.714378298650794*^9, 3.714378428137228*^9}, {
   3.714378465776053*^9, 3.7143784834588547`*^9}, {3.71437855029627*^9, 
   3.714378565079432*^9}, {3.714378604950325*^9, 3.714378614309486*^9}, {
   3.714378651098132*^9, 3.7143787987993097`*^9}, {3.71437883755709*^9, 
   3.7143789420026207`*^9}, {3.714379073919758*^9, 3.7143790942916317`*^9}, {
   3.714379133115767*^9, 3.714379133947453*^9}, 3.7143794731816196`*^9, {
   3.714380085070445*^9, 3.714380090141075*^9}, {3.7143802554746027`*^9, 
   3.714380259112595*^9}, {3.7143806007278843`*^9, 3.714380606334959*^9}, {
   3.71438090936804*^9, 3.714380912412889*^9}, {3.714651317160614*^9, 
   3.714651322534135*^9}},ExpressionUUID->"19acdd75-c9cd-4c1a-b1f6-\
f1144aa6f091"]
}, Closed]],

Cell[CellGroupData[{

Cell["Expand", "Section",
 CellChangeTimes->{{3.714375133510252*^9, 3.714375136874604*^9}, {
   3.714377614584305*^9, 3.714377617215571*^9}, 3.7143805258500013`*^9, {
   3.714380709747148*^9, 
   3.714380710626171*^9}},ExpressionUUID->"b88cfb64-09a7-4a6e-80d4-\
fffb4b3be6cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KineticExchangeMatrix", "/:", 
   RowBox[{"Expand", "[", 
    RowBox[{"KineticExchangeMatrix", "[", 
     RowBox[{"sites_List", ",", 
      RowBox[{"Kmat", ":", 
       RowBox[{"(", 
        RowBox[{"_SparseArray", "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_Rule", "]"}], "..."}], "}"}], "..."}], 
          "}"}]}], ")"}]}], ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   "Kmat"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714380713729679*^9, 
  3.7143807434569273`*^9}},ExpressionUUID->"5d6fcead-d556-4216-b8b5-\
fe0a8ef4033a"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 3.713342307571553*^9, {
   3.713365678085038*^9, 
   3.713365685361429*^9}},ExpressionUUID->"362a1d54-01d5-4fb7-b6b5-\
17cce6df2ff5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "undefsites"}], "=", 
   "\"\<The set of exchanging sites must be defined by using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366464015585*^9, 3.7133665175335817`*^9}, 
   3.714373663408128*^9},ExpressionUUID->"ef529305-a588-453b-b67c-\
c880ffc0b338"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "baddims"}], "=", 
   "\"\<The kinetic exchange matrix must be a square matrix with dimension \
equal to the number of sites.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7133657994869003`*^9, 3.7133658223654947`*^9}, {
  3.714373692780797*^9, 
  3.714373723381956*^9}},ExpressionUUID->"ac351dcf-74a4-4e12-bb98-\
7919ab1e3754"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "duprules"}], "=", 
   "\"\<The rule defining a kinetic rate constant may only appear \
once.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713597674527896*^9, 3.71359769998661*^9}, {
  3.714373737905369*^9, 
  3.714373767766577*^9}},ExpressionUUID->"f5a97a69-4072-427a-ac9e-\
da4bc9ccd9a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "invalspecs"}], "=", 
   "\"\<The following rate specifications refer to sites that are not members \
of the current set of exchanging sites, as defined by \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\":\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"`1`\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7137902855694427`*^9, 3.713790322874545*^9}, {
  3.7143737779537582`*^9, 3.714373903856525*^9}, {3.71437467247965*^9, 
  3.714374742932905*^9}},ExpressionUUID->"678f7cb2-511a-4d67-9ac9-\
3dc8bb7dbf39"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "::", "detbalerr"}], "=", 
   "\"\<A conflict has been encountered while imposing detailed \
balance.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7143789557347727`*^9, 
  3.714378969335547*^9}},ExpressionUUID->"9e9d6b59-f295-45c7-bc7a-\
f5e1e5387035"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["KineticExchangeSuperoperator", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.696759402463449*^9, 
   3.696759408571555*^9}, {3.696759864700485*^9, 3.696759865283483*^9}, {
   3.713340432932952*^9, 3.713340434581518*^9}, {3.713340532452353*^9, 
   3.713340533474594*^9}, 3.713341456824703*^9, 3.713365645978195*^9, {
   3.71437263540457*^9, 3.7143726394509907`*^9}, {3.714402146753138*^9, 
   3.714402148447698*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"71acda9c-8484-486e-a4be-95aa56821d5b"],

Cell[CellGroupData[{

Cell["options", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.714374961475728*^9, 
  3.714374962386895*^9}},ExpressionUUID->"becaa15d-94da-423b-9ef9-\
c943cfb989d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "KineticExchangeSuperoperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ImposeDetailedBalance", "\[Rule]", "True"}], ",", 
     RowBox[{"DetailedBalance", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714374965992387*^9, 3.71437500083566*^9}, {
   3.7143790460796547`*^9, 3.71437905099658*^9}, 3.714402155280699*^9, {
   3.7144030234530153`*^9, 3.714403063427964*^9}, {3.714403118774106*^9, 
   3.714403119034494*^9}, {3.714650412887197*^9, 
   3.714650414236372*^9}},ExpressionUUID->"35613b65-a58c-4502-ae87-\
c8360e6ef2bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["preparations", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, 
   3.714375014231001*^9},ExpressionUUID->"762c30d4-78f1-428b-a119-\
b17aacca51b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticExchangeSuperoperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713599227805401*^9, 3.713599246918935*^9}, 
   3.7143726439201727`*^9, 
   3.714402167749235*^9},ExpressionUUID->"a9dc4742-2919-476b-ad18-\
06eea0d7f3f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{
     RowBox[{"K", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{
     RowBox[{"Sites", "[", "]"}], ",", "K", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7135971536273518`*^9, 3.7135971964365873`*^9}, {
   3.713597942927208*^9, 3.7135979457605953`*^9}, {3.7143726791719027`*^9, 
   3.7143727258987703`*^9}, 3.7143801351737556`*^9, {3.714402208648994*^9, 
   3.714402209921627*^9}, {3.714402256750226*^9, 
   3.714402266720483*^9}},ExpressionUUID->"284d4561-97a8-4365-b7f7-\
62dabdea1460"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"Undefined", ",", 
     RowBox[{"K", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"KineticExchangeSuperoperator", "::", "undefsites"}], "]"}], 
     ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366426688796*^9, 3.7133664521912727`*^9}, {
   3.7143727347856483`*^9, 3.714372741678388*^9}, 3.714379441531918*^9, 
   3.7143801392916307`*^9, {3.714403210834298*^9, 
   3.71440322329865*^9}},ExpressionUUID->"7761d295-7c08-4029-8089-\
b1a1a7eeec5f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"sites_List", ",", " ", 
     RowBox[{"K", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"False", ",", "sites", ",", " ", "K", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714403131802631*^9, 3.714403137458673*^9}, {
  3.7144031722816687`*^9, 3.714403183810213*^9}, {3.714403268609788*^9, 
  3.714403290227944*^9}},ExpressionUUID->"a3a07a0d-9545-47e9-af63-\
ca282f150d9b"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply KineticExchangeMatrix ", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, 
   3.714375014231001*^9, {3.714402289029552*^9, 
   3.714402298581407*^9}},ExpressionUUID->"47125ed4-989a-4f82-8980-\
8d0474d206b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"False", ",", "sites_List", ",", 
     RowBox[{"K", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_Rule", "|", "_KineticExchangeMatrix"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"False", ",", "sites", ",", "\[IndentingNewLine]", 
     RowBox[{"KineticExchangeMatrix", "[", 
      RowBox[{"sites", ",", "K", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "KineticExchangeSuperoperator", "]"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Options", "[", "KineticExchangeMatrix", "]"}]}], "]"}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7144023045733213`*^9, 3.7144024908659687`*^9}, {
  3.714402633144088*^9, 3.714402645574525*^9}, {3.714403073870091*^9, 
  3.714403096587572*^9}, {3.714403296861848*^9, 3.714403312597103*^9}, {
  3.7144036880417833`*^9, 
  3.714403693199519*^9}},ExpressionUUID->"7c4e13b7-3cec-485d-806b-\
9cf51d42cb69"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"KineticExchangeSuperoperator", "[", 
     RowBox[{"False", ",", "sites1_List", ",", "\[IndentingNewLine]", 
      RowBox[{"KineticExchangeMatrix", "[", 
       RowBox[{"sites2_List", ",", 
        RowBox[{"mat_", "?", "MatrixQ"}], ",", "kxmopts___Rule"}], "]"}], ",",
       "\[IndentingNewLine]", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"sites1", "\[NotEqual]", "sites2"}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"KineticExchangeSuperoperator", "::", "mismatchsites"}], "]"}], 
     ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7144026627011127`*^9, 3.714402777083748*^9}, {
  3.714403331518931*^9, 
  3.714403332212994*^9}},ExpressionUUID->"5a90075d-bd27-426d-b080-\
53f1603d39b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "[", 
    RowBox[{"False", ",", "sites_List", ",", "\[IndentingNewLine]", 
     RowBox[{"KineticExchangeMatrix", "[", 
      RowBox[{"sites_List", ",", 
       RowBox[{"mat_", "?", "MatrixQ"}], ",", "kxmopts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"DetailedBalance", "/.", 
           RowBox[{"{", "kxmopts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "KineticExchangeMatrix", "]"}]}], ")"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{"KineticExchangeSuperoperator", "::", "notdetbal"}], "]"}]}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"KineticExchangeSuperoperator", "[", 
      RowBox[{"True", ",", "sites", ",", "mat", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"(", 
         RowBox[{"SimplifyRules", "@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"kxmopts", ",", "opts"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"DetailedBalance", "\[Rule]", "_"}], "}"}]}], "]"}]}], 
         ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714402816591567*^9, 3.714402871778267*^9}, {
  3.7144029889051523`*^9, 3.714402996218809*^9}, {3.714403344355072*^9, 
  3.714403345016898*^9}, {3.714403380057829*^9, 3.7144034614532537`*^9}, {
  3.714403752831543*^9, 3.71440376579817*^9}, {3.714403810508387*^9, 
  3.7144038312916937`*^9}},ExpressionUUID->"6895eaeb-e968-4735-9368-\
4fff6133bbee"]
}, Closed]],

Cell[CellGroupData[{

Cell["extract information", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, {
  3.713365995759811*^9, 3.713366000574869*^9}, {3.7133660322541113`*^9, 
  3.713366035301646*^9}},ExpressionUUID->"426d2100-f0c5-486a-a29c-\
18514e6cc315"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sites", "[", 
    RowBox[{"KineticExchangeSuperoperator", "[", 
     RowBox[{"True", ",", "sites_List", ",", 
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "]"}], "^:=",
    "sites"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366040495229*^9, 3.713366102177732*^9}, {
  3.713602668276832*^9, 3.713602676273192*^9}, {3.714404145083557*^9, 
  3.714404163212926*^9}, {3.714405086114338*^9, 
  3.714405094916013*^9}},ExpressionUUID->"fbc7f687-a04c-4254-a7d0-\
f2dba2fed51b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeMatrix", "[", 
    RowBox[{"KineticExchangeSuperoperator", "[", 
     RowBox[{"True", ",", "sites_List", ",", 
      RowBox[{"Kmat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "]"}], "^:=",
    "Kmat"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714405044337111*^9, 3.714405063867085*^9}, 
   3.714405099581932*^9},ExpressionUUID->"5c1efb8b-5f22-4eeb-bf94-\
9c903eee127a"]
}, Closed]],

Cell[CellGroupData[{

Cell["ExtendedSuperoperatorMatrixRepresentation", "Section",
 CellChangeTimes->{{3.713365687730176*^9, 3.713365691073255*^9}, 
   3.714375014231001*^9, {3.714402289029552*^9, 3.714402298581407*^9}, 
   3.714404015048193*^9},ExpressionUUID->"ce24e1ba-faf2-44e9-8465-\
39ff1c2c44bb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KineticExchangeSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{"Ksop_KineticExchangeSuperoperator", ",", "\[IndentingNewLine]", 
     RowBox[{"opb_", "?", "DefinedOperatorBasisQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ExtendedSuperoperatorMatrixRepresentation", "[", 
    RowBox[{"Ksop", ",", "\[IndentingNewLine]", 
     RowBox[{"ExtendedOperatorBasis", "[", 
      RowBox[{
       RowBox[{"Sites", "[", "Ksop", "]"}], ",", "Ksop"}], "]"}], ",", 
     "\[IndentingNewLine]", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714404686565329*^9, 3.714404694571163*^9}, {
  3.714404740778989*^9, 
  3.714404879607533*^9}},ExpressionUUID->"d72a33b0-3563-4ecf-b5c7-\
d89eedf7b686"],

Cell[BoxData[
 RowBox[{
  RowBox[{"KineticExchangeSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{
   "ExtendedSuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"KineticExchangeSuperoperator", "[", 
      RowBox[{"True", ",", "sites_List", ",", 
       RowBox[{"Kmat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "xopb_ExtendedOperatorBasis"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "@", 
    RowBox[{"DirectProduct", "[", "\[IndentingNewLine]", 
     RowBox[{"Kmat", ",", "\[IndentingNewLine]", 
      RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UnitySuperoperator", "[", "]"}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"OperatorBasis", "[", "xopb", "]"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714404019224024*^9, 3.714404063892675*^9}, {
  3.714404094236595*^9, 3.7144041126680307`*^9}, {3.714404224327416*^9, 
  3.714404229156528*^9}, {3.714404347956738*^9, 3.714404399449395*^9}, {
  3.7144044383706703`*^9, 
  3.714404441672288*^9}},ExpressionUUID->"9187f310-e7db-475f-bb19-\
927dd4ec9d3c"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.713341472774612*^9, 3.7133414975654507`*^9}, {
   3.713341577012848*^9, 3.713341578711355*^9}, 3.713342307571553*^9, {
   3.713365678085038*^9, 
   3.713365685361429*^9}},ExpressionUUID->"9f59a1b3-64d0-42c3-93eb-\
550c348d058a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "::", "undefsites"}], "=", 
   "\"\<The set of exchanging sites must be defined by using \!\(\*
StyleBox[\"SetSites\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.713366464015585*^9, 3.7133665175335817`*^9}, 
   3.714373663408128*^9, 
   3.714403247089993*^9},ExpressionUUID->"d6bfe10c-70ec-4fd7-8ca9-\
3109983a2b00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "::", "mismatchsites"}], "=", 
   "\"\<The specified sites for \!\(\*
StyleBox[\"KineticExchangeSuperoperator\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"KineticExchangeMatrix\",
FontSlant->\"Italic\"]\) must match.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.714402783427185*^9, 
  3.714402799384324*^9}},ExpressionUUID->"3785c124-b8b8-4419-b9f2-\
3005ef694452"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KineticExchangeSuperoperator", "::", "notdetbal"}], "=", 
   "\"\<The specified kinetic exchange matrix does not display detailed \
balance.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7144028788730583`*^9, 3.714402908187684*^9}, 
   3.7144039452612534`*^9},ExpressionUUID->"3f94020f-20bc-4d01-a1cb-\
ef8ccddc371e"]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["end", "Chapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"1463c533-489b-4008-8c83-abafc966212a"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"414ac8da-6483-429e-ac8c-7797d02f2808"]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{907, 803},
WindowMargins->{{261, Automatic}, {Automatic, 10}},
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 18, \
2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "MHL-StyleSheet.nb"]], 
   Cell[
    StyleData["Section"], FontSize -> 24], 
   Cell[
    StyleData["Subchapter"], FontSize -> 18]}, Visible -> False, 
  FrontEndVersion -> 
  "11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 18, 2017)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"],
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 341, 9, 92, "Title", "ExpressionUUID" -> \
"736d94ca-895d-4f01-b81f-472de13b88cf",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[933, 35, 301, 7, 65, "Chapter", "ExpressionUUID" -> \
"47d88bb1-f5ab-4452-be96-6a77251e07a6",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1237, 44, 1157, 21, 217, "Input", "ExpressionUUID" -> \
"02f481c7-5b77-4bfa-9f14-495a3959a4fa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2431, 70, 252, 7, 54, "Chapter", "ExpressionUUID" -> \
"3b934085-f664-4392-be72-fecb3abbb8ce",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2708, 81, 475, 11, 39, "Subsubtitle", "ExpressionUUID" -> \
"5192a578-6c32-43b4-bcd4-ec0e1e7e3e25",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[3186, 94, 628, 19, 48, "Input", "ExpressionUUID" -> \
"bc5b51a2-2df8-4d0e-bc81-120bde2801af",
 InitializationCell->True],
Cell[3817, 115, 1816, 63, 112, "Input", "ExpressionUUID" -> \
"998006fc-0187-4f98-b448-ebecef9c38aa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5670, 183, 391, 9, 39, "Subsubtitle", "ExpressionUUID" -> \
"4945fe08-1293-42aa-8823-8f37c35b21ac",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[6064, 194, 1016, 33, 91, "Input", "ExpressionUUID" -> \
"426e1bc7-ec00-4628-9993-172053dc9e00",
 InitializationCell->True],
Cell[7083, 229, 1118, 31, 133, "Input", "ExpressionUUID" -> \
"7668a179-4629-4f56-aef2-7b1e456d1f20",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8238, 265, 570, 13, 39, "Subsubtitle", "ExpressionUUID" -> \
"9aa8ad61-7ebc-4440-aa35-c4c712468ee6",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8811, 280, 2971, 106, 154, "Input", "ExpressionUUID" -> \
"bfc7e0fa-2c03-41e8-9b16-791d73aa91ff",
 InitializationCell->True],
Cell[11785, 388, 1771, 57, 133, "Input", "ExpressionUUID" -> \
"f4ce9aef-3fa0-4539-a463-df3b1a7e3f73",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13593, 450, 602, 13, 39, "Subsubtitle", "ExpressionUUID" -> \
"15ddd076-6487-4024-afb7-97d21ce16076",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14198, 465, 3045, 106, 154, "Input", "ExpressionUUID" -> \
"a644579c-cbf6-45cc-94b8-f08f08f219a4",
 InitializationCell->True],
Cell[17246, 573, 1739, 55, 112, "Input", "ExpressionUUID" -> \
"6f2da5e3-c46c-44f4-bc26-5508abe9b72e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19022, 633, 628, 12, 39, "Subsubtitle", "ExpressionUUID" -> \
"2031d95a-6464-4e1c-ae4c-ba75e5ae8e3e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[19675, 649, 195, 4, 39, "Section", "ExpressionUUID" -> \
"3a3b12cd-45b9-472e-a14a-04aa52c1bc43",
 InitializationCell->True],
Cell[19873, 655, 7697, 267, 427, "Input", "ExpressionUUID" -> \
"13759527-3e96-416b-bed5-945a8be69ef9",
 InitializationCell->True],
Cell[27573, 924, 731, 19, 112, "Input", "ExpressionUUID" -> \
"983ceb7d-edf4-4758-8be4-8e854a6f04d8",
 InitializationCell->True],
Cell[28307, 945, 644, 16, 91, "Input", "ExpressionUUID" -> \
"614680e4-ec92-43f9-8192-f99826de2079",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28988, 966, 176, 4, 39, "Section", "ExpressionUUID" -> \
"0aba7aa7-3a4e-4773-993b-85e81c22375f",
 InitializationCell->True],
Cell[29167, 972, 6877, 234, 385, "Input", "ExpressionUUID" -> \
"9d6a76d0-d8b0-432e-b964-598a07550497",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[36105, 1213, 208, 6, 54, "Chapter", "ExpressionUUID" -> \
"53e266ec-e768-4234-a26a-17935c1c3f6f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[36316, 1221, 201, 5, 48, "Input", "ExpressionUUID" -> \
"a1cff5f7-5cda-43ed-a604-5ff1849c9620",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36554, 1231, 279, 7, 54, "Chapter", "ExpressionUUID" -> \
"2c985bdc-7ac7-4a88-b115-c348f06620d3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[36858, 1242, 475, 11, 39, "Subsubtitle", "ExpressionUUID" -> \
"aa63a301-8f93-4d6d-a440-479ccac07db1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[37358, 1257, 515, 11, 39, "Section", "ExpressionUUID" -> \
"7284c089-7805-4656-9826-e022c8120e72",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[37898, 1272, 383, 7, 44, "Subsection", "ExpressionUUID" -> \
"71a24a4f-73b7-4447-b649-a58a89784f99",
 InitializationCell->True],
Cell[38284, 1281, 326, 9, 48, "Input", "ExpressionUUID" -> \
"6e16974c-1151-4de6-b68e-9c42cf44359a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38647, 1295, 334, 6, 44, "Subsection", "ExpressionUUID" -> \
"5c79e741-4b96-4375-808a-1752b702eda9",
 InitializationCell->True],
Cell[38984, 1303, 388, 11, 48, "Input", "ExpressionUUID" -> \
"d9217aee-a1a9-4c30-8166-35dc3f9ed039",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39409, 1319, 183, 4, 44, "Subsection", "ExpressionUUID" -> \
"26f54bc0-e6d0-46df-8092-3b6427fcfb6a",
 InitializationCell->True],
Cell[39595, 1325, 371, 9, 48, "Input", "ExpressionUUID" -> \
"c57e7424-d4d7-4706-8982-3227118bb54c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[40015, 1340, 568, 12, 39, "Section", "ExpressionUUID" -> \
"a6ffc531-788a-41cb-8d90-668fb673ebac",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[40608, 1356, 534, 9, 44, "Subsection", "ExpressionUUID" -> \
"c95929c7-bb05-44e5-9bd7-5366824cbb23",
 InitializationCell->True],
Cell[41145, 1367, 527, 16, 48, "Input", "ExpressionUUID" -> \
"e90e4695-3042-4b54-b8df-b9064c6c15fd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[41709, 1388, 484, 8, 44, "Subsection", "ExpressionUUID" -> \
"a06326df-8904-46de-82e4-01cf61b67519",
 InitializationCell->True],
Cell[42196, 1398, 1189, 33, 154, "Input", "ExpressionUUID" -> \
"758d7ad7-dcc0-48b7-b3f1-d33dce0422d8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[43422, 1436, 436, 7, 44, "Subsection", "ExpressionUUID" -> \
"05ca08c3-fc26-4d03-8edb-a96a9107ad83",
 InitializationCell->True],
Cell[43861, 1445, 682, 18, 70, "Input", "ExpressionUUID" -> \
"413700c2-9936-48d2-8b5f-208a04b6b246",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44580, 1468, 432, 7, 44, "Subsection", "ExpressionUUID" -> \
"ba642279-4786-46bf-9ebc-1896802c44c3",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[45037, 1479, 197, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"50430b14-2ae3-4164-bf1f-8d8c2255bc43",
 InitializationCell->True],
Cell[45237, 1485, 1242, 34, 154, "Input", "ExpressionUUID" -> \
"c44260d8-3ff3-4af6-b4eb-82595ec99d3c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[46516, 1524, 229, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"4bb1592c-f400-495e-bbb4-87c43a8df50a",
 InitializationCell->True],
Cell[46748, 1530, 1938, 49, 217, "Input", "ExpressionUUID" -> \
"8177958f-b48f-4883-ba38-61831890b62d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[48735, 1585, 183, 4, 44, "Subsection", "ExpressionUUID" -> \
"ac01db46-bdff-484c-86af-74b84153d2ab",
 InitializationCell->True],
Cell[48921, 1591, 401, 10, 70, "Input", "ExpressionUUID" -> \
"f924cb76-0ada-4941-a62f-9a32a28b85dc",
 InitializationCell->True],
Cell[49325, 1603, 320, 9, 48, "Input", "ExpressionUUID" -> \
"2e3b6ec6-c392-4931-b7fd-b544503a7551",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[49706, 1619, 513, 11, 39, "Subsubtitle", "ExpressionUUID" -> \
"1ac13836-fb73-4158-a364-12e6a2da5f8d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[50244, 1634, 296, 6, 39, "Section", "ExpressionUUID" -> \
"a3488b59-77f4-431f-9596-02d9a3fb5b88",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[50565, 1644, 241, 5, 44, "Subsection", "ExpressionUUID" -> \
"c44973ed-b12e-41be-8b20-4005d9ec67d1",
 InitializationCell->True],
Cell[50809, 1651, 691, 18, 91, "Input", "ExpressionUUID" -> \
"b5ae06c4-394a-4d3f-bb26-601d638a3453",
 InitializationCell->True],
Cell[51503, 1671, 706, 18, 91, "Input", "ExpressionUUID" -> \
"706bbad1-3524-4760-ba17-33a980656ed6",
 InitializationCell->True],
Cell[52212, 1691, 612, 13, 48, "Input", "ExpressionUUID" -> \
"7a557155-03a4-46d4-b7f8-86a1392d4875",
 InitializationCell->True],
Cell[52827, 1706, 814, 23, 91, "Input", "ExpressionUUID" -> \
"9548d08e-c75c-431e-8307-1ed9ed0bab66",
 InitializationCell->True],
Cell[53644, 1731, 538, 15, 70, "Input", "ExpressionUUID" -> \
"ca672dbc-9e03-4e48-9836-2e1f8f481846",
 InitializationCell->True],
Cell[54185, 1748, 1275, 29, 196, "Input", "ExpressionUUID" -> \
"a5e403fd-bb9d-4bc8-8d8a-af278ce804f9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[55497, 1782, 324, 6, 44, "Subsection", "ExpressionUUID" -> \
"bfcffc5d-0f54-4e24-892c-0fb7216613d5",
 InitializationCell->True],
Cell[55824, 1790, 766, 20, 91, "Input", "ExpressionUUID" -> \
"8ef0b07c-a5d8-4310-943f-00da194ce6da",
 InitializationCell->True],
Cell[56593, 1812, 963, 23, 133, "Input", "ExpressionUUID" -> \
"62513e1f-e670-44f4-9533-0e3de2725a25",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[57593, 1840, 234, 5, 44, "Subsection", "ExpressionUUID" -> \
"2e7c12c6-33e4-4fc4-bcdd-442a0c79a7ec",
 InitializationCell->True],
Cell[57830, 1847, 674, 18, 70, "Input", "ExpressionUUID" -> \
"36dabcd2-c611-4e30-b6bd-141662ac3abf",
 InitializationCell->True],
Cell[58507, 1867, 674, 18, 70, "Input", "ExpressionUUID" -> \
"a10bc06b-a3df-4833-b210-2f7b9e5bde04",
 InitializationCell->True],
Cell[59184, 1887, 368, 9, 70, "Input", "ExpressionUUID" -> \
"3b5244cb-e19a-4c54-9484-d62acf2188f1",
 InitializationCell->True],
Cell[59555, 1898, 385, 10, 48, "Input", "ExpressionUUID" -> \
"8e9b47f9-e706-408c-ae0b-2776639339c1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[59989, 1914, 315, 6, 39, "Section", "ExpressionUUID" -> \
"30584102-67ff-406d-97fd-d58f7c4ddd08",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[60329, 1924, 281, 5, 44, "Subsection", "ExpressionUUID" -> \
"c4ab9870-0648-44df-9c33-3c242006cd9c",
 InitializationCell->True],
Cell[60613, 1931, 363, 10, 48, "Input", "ExpressionUUID" -> \
"f6e5ef3b-7d19-410b-8a25-ca4e863ba5f1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[61013, 1946, 405, 7, 44, "Subsection", "ExpressionUUID" -> \
"b90239a5-0037-496f-ba5a-8bcc6c686313",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[61443, 1957, 222, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"7d245c3d-88aa-4fb4-a67d-721d5c0f65ee"],
Cell[61668, 1963, 635, 17, 91, "Input", "ExpressionUUID" -> \
"c03d1c9d-45fd-41d4-8404-d5b69d77d6b9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[62340, 1985, 240, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"23ddcdad-fe2f-414f-bcc2-09ff52593804"],
Cell[62583, 1991, 652, 17, 91, "Input", "ExpressionUUID" -> \
"a56f8f75-162d-4ada-ac72-031df5f65ca8",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[63284, 2014, 380, 7, 44, "Subsection", "ExpressionUUID" -> \
"968057e0-2f68-40c9-8bc3-61746e0e3026",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[63689, 2025, 451, 8, 35, "Subsubsection", "ExpressionUUID" -> \
"1fddfe23-a437-4d89-8fa5-73c7d31048cd"],
Cell[64143, 2035, 1257, 32, 154, "Input", "ExpressionUUID" -> \
"54d84323-b14c-4067-af84-540b28935315",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[65437, 2072, 397, 8, 35, "Subsubsection", "ExpressionUUID" -> \
"07b82152-5497-4a4e-b913-7d8dff0d6921"],
Cell[65837, 2082, 2286, 51, 280, "Input", "ExpressionUUID" -> \
"ec3b9a2b-408d-4512-ab6a-d1863af6578c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[68172, 2139, 327, 6, 44, "Subsection", "ExpressionUUID" -> \
"c3097278-e784-4791-8d1c-ef18374502bf",
 InitializationCell->True],
Cell[68502, 2147, 438, 12, 70, "Input", "ExpressionUUID" -> \
"9ea84d26-eba2-49f5-a4c3-cbbd4db0bc47",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[68977, 2164, 269, 5, 44, "Subsection", "ExpressionUUID" -> \
"c88114fa-a829-4e46-a80a-761811b27471",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[69271, 2173, 258, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"9c7c23cb-5650-49ee-9ab0-d875c230f10d",
 InitializationCell->True],
Cell[69532, 2180, 491, 13, 48, "Input", "ExpressionUUID" -> \
"c1ed8971-e3c1-4a96-a8b4-47498289514f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[70060, 2198, 315, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"efd255cf-9f29-4509-a4f9-7e4726c7d53d",
 InitializationCell->True],
Cell[70378, 2206, 521, 13, 48, "Input", "ExpressionUUID" -> \
"d2a79ebe-9d29-459d-8296-b7d7841a5af6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[70936, 2224, 314, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"b89b68c7-84fc-40c6-b5be-8a0f4acaa4f2",
 InitializationCell->True],
Cell[71253, 2232, 551, 14, 70, "Input", "ExpressionUUID" -> \
"6197566f-1d04-478f-8b2c-d8161ac68ed6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[71841, 2251, 339, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"e1536fa5-9e78-49ef-b76c-9af8c2982ef5",
 InitializationCell->True],
Cell[72183, 2259, 609, 15, 70, "Input", "ExpressionUUID" -> \
"dcb42498-f250-41f0-a421-703bb254dfe5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[72841, 2280, 282, 5, 44, "Subsection", "ExpressionUUID" -> \
"13810f36-2225-42bf-9d65-266770c1814e",
 InitializationCell->True],
Cell[73126, 2287, 643, 17, 70, "Input", "ExpressionUUID" -> \
"4bd96c9d-6a2f-4248-a7ad-662dca570fcd",
 InitializationCell->True],
Cell[73772, 2306, 643, 17, 70, "Input", "ExpressionUUID" -> \
"110b9f7d-e176-458a-ae06-39973d2a615d",
 InitializationCell->True],
Cell[74418, 2325, 497, 13, 70, "Input", "ExpressionUUID" -> \
"4cb72630-d13e-4b2b-9a49-2944606e81e7",
 InitializationCell->True],
Cell[74918, 2340, 491, 13, 70, "Input", "ExpressionUUID" -> \
"6048ef14-fd04-4210-8bab-957c54939d2f",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[75470, 2360, 535, 11, 39, "Subsubtitle", "ExpressionUUID" -> \
"7d82f5a2-995d-4151-ba12-a73ecc9d800f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[76030, 2375, 156, 3, 39, "Section", "ExpressionUUID" -> \
"cfcde4cb-e01e-437d-917d-7aae9ec5075f"],
Cell[76189, 2380, 431, 13, 48, "Input", "ExpressionUUID" -> \
"f7e5fec8-227c-41b9-bceb-f240d94c3bda",
 InitializationCell->True],
Cell[76623, 2395, 548, 13, 48, "Input", "ExpressionUUID" -> \
"6ecfb0c5-c6f2-481e-ba4f-b3ce71a208b1",
 InitializationCell->True],
Cell[77174, 2410, 625, 18, 91, "Input", "ExpressionUUID" -> \
"c9a06cd1-5ef5-4cc0-a771-6223fc814f2a",
 InitializationCell->True],
Cell[77802, 2430, 664, 19, 70, "Input", "ExpressionUUID" -> \
"4681e85a-abc1-4a20-843d-03bc2a520cc0",
 InitializationCell->True],
Cell[78469, 2451, 552, 17, 70, "Input", "ExpressionUUID" -> \
"97eef8ce-d372-4a1b-be78-74400ba00051",
 InitializationCell->True],
Cell[79024, 2470, 603, 18, 91, "Input", "ExpressionUUID" -> \
"427a07bf-b2d7-4888-9ded-b4f17f8dd066",
 InitializationCell->True],
Cell[79630, 2490, 592, 16, 70, "Input", "ExpressionUUID" -> \
"8db6f256-4cd2-4930-b864-665c6f4492c9",
 InitializationCell->True],
Cell[80225, 2508, 890, 24, 91, "Input", "ExpressionUUID" -> \
"7759cac5-eea0-4b1a-8616-9e3bd98f34ec",
 InitializationCell->True],
Cell[81118, 2534, 776, 21, 70, "Input", "ExpressionUUID" -> \
"ac069b98-8f3e-4a08-b35a-6f31011aa11a",
 InitializationCell->True],
Cell[81897, 2557, 566, 18, 70, "Input", "ExpressionUUID" -> \
"79c91e2f-0152-4915-b62c-5db8e788e828",
 InitializationCell->True],
Cell[82466, 2577, 809, 24, 91, "Input", "ExpressionUUID" -> \
"f7db352f-3f0d-491f-a9a0-03fcad53f8dd",
 InitializationCell->True],
Cell[83278, 2603, 1283, 36, 196, "Input", "ExpressionUUID" -> \
"0e21c38f-94b2-43c4-a0c0-a43cd51bec6d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[84598, 2644, 261, 4, 39, "Section", "ExpressionUUID" -> \
"ca396d0a-20aa-4b08-8951-849e9d2a4112"],
Cell[84862, 2650, 535, 16, 48, "Input", "ExpressionUUID" -> \
"db05a77d-4f9a-4f9d-b6c4-f192e3ee0986",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[85434, 2671, 304, 5, 39, "Section", "ExpressionUUID" -> \
"d1aa8d7b-325d-48ed-acf3-1aba22aa5247"],
Cell[CellGroupData[{
Cell[85763, 2680, 204, 4, 44, "Subsection", "ExpressionUUID" -> \
"09b3c64a-5188-4c64-bc98-9b49835efaee"],
Cell[CellGroupData[{
Cell[85992, 2688, 356, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"790db806-4c89-4265-bef8-cece571cc0e2"],
Cell[86351, 2696, 2071, 50, 364, "Input", "ExpressionUUID" -> \
"527f8036-bd6f-4d8a-ada3-59f4c2549d61",
 InitializationCell->True],
Cell[88425, 2748, 790, 19, 133, "Input", "ExpressionUUID" -> \
"579b998b-4633-463b-87ce-e859c77ecfbb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[89252, 2772, 391, 8, 35, "Subsubsection", "ExpressionUUID" -> \
"d5089d3a-2333-46b7-b7bc-5599adc48bb7"],
Cell[89646, 2782, 1108, 26, 133, "Input", "ExpressionUUID" -> \
"4406fbcf-ea89-403d-92dc-276e89993a8a",
 InitializationCell->True],
Cell[90757, 2810, 1134, 27, 133, "Input", "ExpressionUUID" -> \
"46a0a9f3-f1d2-4481-abba-e334432c361f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[91940, 2843, 153, 3, 44, "Subsection", "ExpressionUUID" -> \
"a509929b-264c-4870-806f-cdf74ed3a59b"],
Cell[CellGroupData[{
Cell[92118, 2850, 299, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"35d79148-0036-49d4-b988-da989d48c172"],
Cell[92420, 2856, 2016, 49, 364, "Input", "ExpressionUUID" -> \
"f2c1c0b4-cf82-433d-b08f-3fbc101a9f67",
 InitializationCell->True],
Cell[94439, 2907, 736, 18, 133, "Input", "ExpressionUUID" -> \
"aa019b4b-2dd0-4d6e-8968-f09156c78c55",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[95212, 2930, 242, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"ae2f3cd3-1bfd-44ad-bdc4-b057b0d35239"],
Cell[95457, 2936, 2987, 72, 427, "Input", "ExpressionUUID" -> \
"4191d928-c144-400f-8adf-e5d6e2b08296",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[98481, 3013, 250, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"74061128-1028-4253-893e-37b2bcf4a317"],
Cell[98734, 3019, 2043, 48, 364, "Input", "ExpressionUUID" -> \
"29452348-1289-4e0c-9f72-4af575aa97e0",
 InitializationCell->True],
Cell[100780, 3069, 2047, 48, 364, "Input", "ExpressionUUID" -> \
"a1e24618-babf-497e-8df8-599c774ec549",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[102876, 3123, 207, 4, 44, "Subsection", "ExpressionUUID" -> \
"ceb1e770-5dc0-43de-8948-78587b406475"],
Cell[CellGroupData[{
Cell[103108, 3131, 328, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"0c4c41dc-cbca-41de-bd48-02cdb44e9f7d"],
Cell[103439, 3138, 1094, 24, 154, "Input", "ExpressionUUID" -> \
"a383bbc2-86cd-4b2b-aa22-877cbde8bb67",
 InitializationCell->True],
Cell[104536, 3164, 791, 19, 133, "Input", "ExpressionUUID" -> \
"93ca6e47-d9b6-4f12-bfa4-4af53e354ee6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[105364, 3188, 267, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"c5554eab-2c07-4710-9e84-b43ebfb6200b"],
Cell[105634, 3194, 3038, 72, 427, "Input", "ExpressionUUID" -> \
"f9690282-cf65-44f6-91d1-16617080f2b9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[108709, 3271, 277, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"88c76de5-9270-4154-95d3-ec5763743a90"],
Cell[108989, 3277, 2095, 49, 364, "Input", "ExpressionUUID" -> \
"85fb4530-88b3-4e71-9f8f-17bfffed2c26",
 InitializationCell->True],
Cell[111087, 3328, 2101, 49, 364, "Input", "ExpressionUUID" -> \
"03a61ab1-4cd3-4287-95de-43112a7cd008",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[113237, 3383, 212, 4, 44, "Subsection", "ExpressionUUID" -> \
"481b0c27-7387-4c15-b8c4-70491837faf4"],
Cell[CellGroupData[{
Cell[113474, 3391, 253, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"66e9b369-6e19-4882-890d-0b71955e5c40"],
Cell[113730, 3397, 1614, 39, 217, "Input", "ExpressionUUID" -> \
"7e779bcf-d4e2-423b-8e35-e0cd2b17a8ed",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[115381, 3441, 304, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"facaa660-cfbc-4d32-a56d-fc554c8475a3"],
Cell[115688, 3448, 1763, 44, 217, "Input", "ExpressionUUID" -> \
"8a61f463-1bc3-4916-a27a-580401b5d753",
 InitializationCell->True],
Cell[117454, 3494, 1759, 43, 217, "Input", "ExpressionUUID" -> \
"a959c17d-10b7-40cd-8e32-2268f0725012",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[119274, 3544, 449, 6, 39, "Section", "ExpressionUUID" -> \
"998b5ec4-b044-412a-b639-f3b292ef0ced"],
Cell[CellGroupData[{
Cell[119748, 3554, 177, 4, 44, "Subsection", "ExpressionUUID" -> \
"efb1cbf2-e7d1-476b-a722-b661cf456f36",
 InitializationCell->True],
Cell[119928, 3560, 1483, 41, 217, "Input", "ExpressionUUID" -> \
"1b215232-641b-4d05-9db8-d1cc6d9e2a46",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[121448, 3606, 232, 5, 44, "Subsection", "ExpressionUUID" -> \
"1ada6481-34d5-4347-adf2-891fa4021c92",
 InitializationCell->True],
Cell[121683, 3613, 1725, 43, 322, "Input", "ExpressionUUID" -> \
"1d7bded6-4115-4dfd-bb6f-10b1246d570e",
 InitializationCell->True],
Cell[123411, 3658, 1722, 42, 322, "Input", "ExpressionUUID" -> \
"ce78853d-d4af-4b0c-9f5b-4c13df471f64",
 InitializationCell->True],
Cell[125136, 3702, 2871, 69, 490, "Input", "ExpressionUUID" -> \
"0d7d4101-b902-4c29-bc21-d7ed1e6b114a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[128056, 3777, 330, 7, 39, "Section", "ExpressionUUID" -> \
"793c31d9-78b2-43d0-970b-e334312724c3",
 InitializationCell->True],
Cell[128389, 3786, 376, 9, 70, "Input", "ExpressionUUID" -> \
"f15b9eea-4b3a-44d4-a0d5-0de531a0540c",
 InitializationCell->True],
Cell[128768, 3797, 395, 10, 70, "Input", "ExpressionUUID" -> \
"3a500b45-7310-4c15-8946-3021f88f9c4c",
 InitializationCell->True],
Cell[129166, 3809, 360, 9, 70, "Input", "ExpressionUUID" -> \
"b3340e43-be8d-49d0-bd48-49df540cb3eb",
 InitializationCell->True],
Cell[129529, 3820, 451, 12, 70, "Input", "ExpressionUUID" -> \
"9335d349-1f81-4486-83d1-81e0654dcfb0",
 InitializationCell->True],
Cell[129983, 3834, 476, 12, 70, "Input", "ExpressionUUID" -> \
"59392605-9829-49b0-9dc8-2979d17e0429",
 InitializationCell->True],
Cell[130462, 3848, 523, 13, 91, "Input", "ExpressionUUID" -> \
"70e93f0f-e1e0-41bc-97fb-be7c52fd907d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[131034, 3867, 576, 12, 39, "Subsubtitle", "ExpressionUUID" -> \
"762832d1-7812-4a5a-b3d7-ea752a9cbeb2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[131635, 3883, 156, 3, 39, "Section", "ExpressionUUID" -> \
"bac876d3-7d6d-41f6-8f9c-e1b340cd7100"],
Cell[131794, 3888, 469, 13, 48, "Input", "ExpressionUUID" -> \
"78c1b869-ea7f-4501-8807-e694f73dd1b3",
 InitializationCell->True],
Cell[132266, 3903, 691, 16, 70, "Input", "ExpressionUUID" -> \
"e2bab524-e32b-4308-9516-08d536b42e96",
 InitializationCell->True],
Cell[132960, 3921, 839, 21, 91, "Input", "ExpressionUUID" -> \
"278d2085-7511-4912-b731-b12bf255e826",
 InitializationCell->True],
Cell[133802, 3944, 698, 16, 112, "Input", "ExpressionUUID" -> \
"6905778f-c2f7-435e-a6d9-f2ac7304f782",
 InitializationCell->True],
Cell[134503, 3962, 837, 23, 112, "Input", "ExpressionUUID" -> \
"035c4faf-826c-433a-a6e8-e6ba6ab3c515",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[135377, 3990, 250, 4, 39, "Section", "ExpressionUUID" -> \
"f0caa3fe-e4e8-41d7-bd6f-7914ea316c6b"],
Cell[135630, 3996, 286, 7, 30, "Text", "ExpressionUUID" -> \
"7bc21ce6-c6ec-41f6-9ddd-d6ab703ecffb"],
Cell[135919, 4005, 3336, 76, 427, "Input", "ExpressionUUID" -> \
"d2e33374-0c68-4e03-bf3e-d9835a4aa7a3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[139292, 4086, 203, 4, 39, "Section", "ExpressionUUID" -> \
"557717cc-5a7f-4dfa-b0ec-aa3b9fbc4ea7"],
Cell[139498, 4092, 555, 13, 91, "Input", "ExpressionUUID" -> \
"83679d93-5b2c-4181-b870-812d7a27080e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[140102, 4111, 592, 12, 39, "Subsubtitle", "ExpressionUUID" -> \
"edf0d5e8-8a2d-4b8d-a505-3208c548d676",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[140719, 4127, 156, 3, 39, "Section", "ExpressionUUID" -> \
"30804a6b-cee9-4745-b7a8-c9d8694a670d"],
Cell[140878, 4132, 459, 13, 48, "Input", "ExpressionUUID" -> \
"5771f432-28a3-4063-be86-338e7247b77e",
 InitializationCell->True],
Cell[141340, 4147, 616, 14, 70, "Input", "ExpressionUUID" -> \
"d30bf6b2-5867-4442-903e-1e85e0d78229",
 InitializationCell->True],
Cell[141959, 4163, 692, 19, 91, "Input", "ExpressionUUID" -> \
"02991e15-b7b1-4542-bb4d-6257e319d356",
 InitializationCell->True],
Cell[142654, 4184, 731, 20, 70, "Input", "ExpressionUUID" -> \
"b56f732b-2386-4393-b097-8ef0ceda0ca2",
 InitializationCell->True],
Cell[143388, 4206, 622, 18, 70, "Input", "ExpressionUUID" -> \
"84d4414f-dab9-4674-a760-e917e3342d0f",
 InitializationCell->True],
Cell[144013, 4226, 670, 19, 91, "Input", "ExpressionUUID" -> \
"deb49da3-5b68-498c-bbc1-3342f7b2d221",
 InitializationCell->True],
Cell[144686, 4247, 657, 17, 70, "Input", "ExpressionUUID" -> \
"3bd38e19-cce6-496f-ac3e-bf122a52e919",
 InitializationCell->True],
Cell[145346, 4266, 958, 25, 91, "Input", "ExpressionUUID" -> \
"fdf170b9-a00a-44d6-b916-49579a449a44",
 InitializationCell->True],
Cell[146307, 4293, 841, 21, 70, "Input", "ExpressionUUID" -> \
"fcc06dde-cef8-404b-afe9-7555b4882bc0",
 InitializationCell->True],
Cell[147151, 4316, 632, 19, 70, "Input", "ExpressionUUID" -> \
"ae324630-26a1-4e25-9979-0efdaa89f7a1",
 InitializationCell->True],
Cell[147786, 4337, 873, 26, 91, "Input", "ExpressionUUID" -> \
"3e49f09e-cb95-4e7c-8db7-99d986e9f95c",
 InitializationCell->True],
Cell[148662, 4365, 1339, 36, 196, "Input", "ExpressionUUID" -> \
"a7e773a2-8615-47ff-92ab-69bff14cf260",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[150038, 4406, 261, 4, 39, "Section", "ExpressionUUID" -> \
"b33ab858-4f04-4a09-acc8-05e4c2fbe122"],
Cell[150302, 4412, 591, 17, 48, "Input", "ExpressionUUID" -> \
"ec17feee-8c2d-42c4-8175-3b63254be7ab",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[150930, 4434, 304, 5, 39, "Section", "ExpressionUUID" -> \
"507744a8-80fe-464a-a0f1-824e113f0b18"],
Cell[CellGroupData[{
Cell[151259, 4443, 204, 4, 44, "Subsection", "ExpressionUUID" -> \
"590fabb9-320e-41c5-bf4e-a0774a40a7ab"],
Cell[CellGroupData[{
Cell[151488, 4451, 386, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"2eeab1d8-615f-4be9-9898-0857a4514bcf"],
Cell[151877, 4459, 2140, 51, 364, "Input", "ExpressionUUID" -> \
"e79da877-2252-42ff-b5af-ec78a49bd9b3",
 InitializationCell->True],
Cell[154020, 4512, 855, 21, 133, "Input", "ExpressionUUID" -> \
"00dcf87b-87e2-4c43-878f-2dc3679ca890",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[154912, 4538, 456, 9, 59, "Subsubsection", "ExpressionUUID" -> \
"666d0298-3434-4fce-89e3-d7df7feb09ef"],
Cell[155371, 4549, 1185, 26, 133, "Input", "ExpressionUUID" -> \
"77739e5a-6aa3-4b3e-89fe-71977244731f",
 InitializationCell->True],
Cell[156559, 4577, 1183, 26, 133, "Input", "ExpressionUUID" -> \
"3c16f230-5f86-4001-9d43-10cf180872fe",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[157791, 4609, 153, 3, 44, "Subsection", "ExpressionUUID" -> \
"981c6230-01a4-4167-979b-e01a537deb67"],
Cell[CellGroupData[{
Cell[157969, 4616, 308, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"246a53c8-f873-456a-b7d6-83adac815fcc"],
Cell[158280, 4623, 2035, 49, 364, "Input", "ExpressionUUID" -> \
"5f2d20ab-3f77-4262-9839-6bfc1bccd726",
 InitializationCell->True],
Cell[160318, 4674, 800, 20, 133, "Input", "ExpressionUUID" -> \
"ca04a883-a5cf-4a5d-a582-30655edb4041",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[161155, 4699, 271, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"649d2624-18ac-4b92-b0eb-ec2aa501c737"],
Cell[161429, 4705, 3075, 73, 427, "Input", "ExpressionUUID" -> \
"9caae01a-de4d-4132-9bfa-40f8b03e831f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[164541, 4783, 309, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"32efdc7d-804b-4986-95d0-a22e07801afd"],
Cell[164853, 4790, 2118, 49, 364, "Input", "ExpressionUUID" -> \
"a687f5f7-5c74-46bc-91c3-c4c6a81ce75c",
 InitializationCell->True],
Cell[166974, 4841, 2126, 49, 364, "Input", "ExpressionUUID" -> \
"6acf2309-c0a1-41ef-8fe5-255d561f8c8b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[169149, 4896, 207, 4, 44, "Subsection", "ExpressionUUID" -> \
"2b4e252c-0ab3-49ba-8c1e-a97c5fa3696e"],
Cell[CellGroupData[{
Cell[169381, 4904, 357, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"994dd49f-21d3-4c4a-9e94-06aa843d0c74"],
Cell[169741, 4912, 1157, 25, 154, "Input", "ExpressionUUID" -> \
"e73c520c-b43a-4900-87a4-6453843d8e2f",
 InitializationCell->True],
Cell[170901, 4939, 857, 21, 133, "Input", "ExpressionUUID" -> \
"4d9edc47-d1ee-47e0-bc31-03cfcef42156",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[171795, 4965, 296, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"d68cdae9-f424-4086-857b-dc27c935514f"],
Cell[172094, 4971, 3131, 74, 427, "Input", "ExpressionUUID" -> \
"678ad79a-b956-40d0-9ea0-192443192d7e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[175262, 5050, 340, 6, 35, "Subsubsection", "ExpressionUUID" -> \
"94769633-052c-4f1f-a297-6c06dff8a87b"],
Cell[175605, 5058, 2175, 50, 364, "Input", "ExpressionUUID" -> \
"1850edfe-800a-4d28-b19e-f5115b29268e",
 InitializationCell->True],
Cell[177783, 5110, 2178, 50, 364, "Input", "ExpressionUUID" -> \
"e18c39fb-8d15-49e3-8aa9-a6c5411946ae",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[180010, 5166, 212, 4, 44, "Subsection", "ExpressionUUID" -> \
"dca4e179-19b2-4599-88e9-aea0df7cf599"],
Cell[CellGroupData[{
Cell[180247, 5174, 253, 4, 35, "Subsubsection", "ExpressionUUID" -> \
"bdfa2f53-e709-463a-b34d-987fba929bef"],
Cell[180503, 5180, 1685, 40, 217, "Input", "ExpressionUUID" -> \
"fb2a0323-d5ea-441d-b378-c2d5340c7477",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[182225, 5225, 304, 5, 35, "Subsubsection", "ExpressionUUID" -> \
"89d50f0c-3a12-4109-9975-26d909f972d1"],
Cell[182532, 5232, 1832, 45, 217, "Input", "ExpressionUUID" -> \
"b3b501e5-cf11-48c2-adf7-1d8efeaea326",
 InitializationCell->True],
Cell[184367, 5279, 1827, 44, 217, "Input", "ExpressionUUID" -> \
"54e13c78-bae6-40bc-82af-3d7c964febc0",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[186255, 5330, 330, 7, 39, "Section", "ExpressionUUID" -> \
"75fd4d3c-412b-4d9a-a546-74c45a371253",
 InitializationCell->True],
Cell[186588, 5339, 485, 12, 91, "Input", "ExpressionUUID" -> \
"db391e22-39a9-44a5-832a-e4e0c248f6cc",
 InitializationCell->True],
Cell[187076, 5353, 425, 10, 70, "Input", "ExpressionUUID" -> \
"367c5443-8add-4eb1-8be0-162e0e1653a9",
 InitializationCell->True],
Cell[187504, 5365, 388, 9, 70, "Input", "ExpressionUUID" -> \
"22a2af85-6368-4973-b982-239ff7664130",
 InitializationCell->True],
Cell[187895, 5376, 465, 12, 70, "Input", "ExpressionUUID" -> \
"7d3eefb1-1fed-4615-a09b-4e5df505fc17",
 InitializationCell->True],
Cell[188363, 5390, 488, 12, 91, "Input", "ExpressionUUID" -> \
"7ef4db1a-44d4-433c-a65f-4b415a4bc413",
 InitializationCell->True],
Cell[188854, 5404, 593, 14, 91, "Input", "ExpressionUUID" -> \
"143214d4-19c3-466a-8476-6eceb8aa3b44",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[189496, 5424, 627, 12, 39, "Subsubtitle", "ExpressionUUID" -> \
"ababebdf-6592-4324-a6a7-e8f781dd6954",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[190148, 5440, 156, 3, 39, "Section", "ExpressionUUID" -> \
"f15c49de-67ac-4cc4-9831-7927dffd7d6b"],
Cell[190307, 5445, 510, 16, 48, "Input", "ExpressionUUID" -> \
"7af1ec4e-66e9-4a95-a2ce-7dd974faaca9",
 InitializationCell->True],
Cell[190820, 5463, 748, 17, 70, "Input", "ExpressionUUID" -> \
"65397f01-e3b4-4914-97db-d8e80af7ed6f",
 InitializationCell->True],
Cell[191571, 5482, 879, 21, 91, "Input", "ExpressionUUID" -> \
"8a3f37b2-db8a-4af4-8d2e-9680ffbbf1d5",
 InitializationCell->True],
Cell[192453, 5505, 777, 19, 133, "Input", "ExpressionUUID" -> \
"57ef0dbe-3f4d-4fc4-bb93-85c0cbd4dda6",
 InitializationCell->True],
Cell[193233, 5526, 907, 24, 112, "Input", "ExpressionUUID" -> \
"958ddb1e-9c5f-4658-b5a1-b20826d060b3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[194177, 5555, 250, 4, 39, "Section", "ExpressionUUID" -> \
"43a2e0c4-ff28-42a7-8e37-f1750492674f"],
Cell[194430, 5561, 337, 7, 30, "Text", "ExpressionUUID" -> \
"9212af6a-d0a7-48df-b370-6a57067c9a5e"],
Cell[194770, 5570, 4667, 106, 574, "Input", "ExpressionUUID" -> \
"522da4bd-15f9-406f-9a70-d33924a3c424",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[199474, 5681, 203, 4, 39, "Section", "ExpressionUUID" -> \
"e266ab07-b5b7-47b5-ba91-9cb25de495bc"],
Cell[199680, 5687, 615, 14, 91, "Input", "ExpressionUUID" -> \
"41cd8898-8e70-4b2a-9329-b5f759e343d1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[200344, 5707, 586, 12, 39, "Subsubtitle", "ExpressionUUID" -> \
"df19243a-3a32-4fb7-aed0-4ba3d2e3cbff",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[200955, 5723, 201, 4, 39, "Section", "ExpressionUUID" -> \
"1bc228c6-6b05-4b31-846a-f23b3bc3efe3"],
Cell[201159, 5729, 529, 13, 48, "Input", "ExpressionUUID" -> \
"421e9afb-fbc5-41d8-b43e-e8f142b0c27f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[201725, 5747, 180, 3, 39, "Section", "ExpressionUUID" -> \
"38ff3f84-aa8b-4a12-aa5d-829a4c4e70ea"],
Cell[201908, 5752, 456, 13, 48, "Input", "ExpressionUUID" -> \
"96b8fe3c-d7c8-4425-aba0-24597e0260ac",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[202389, 5769, 357, 6, 44, "Subsection", "ExpressionUUID" -> \
"fbecc7ff-acdd-4042-a7d4-63400f3d5a19"],
Cell[CellGroupData[{
Cell[202771, 5779, 157, 3, 35, "Subsubsection", "ExpressionUUID" -> \
"32ddd70b-7937-440a-8c02-7895813bbab2"],
Cell[202931, 5784, 840, 18, 70, "Input", "ExpressionUUID" -> \
"5f393611-8989-4249-80ec-4f9898867bfb",
 InitializationCell->True],
Cell[203774, 5804, 845, 21, 70, "Input", "ExpressionUUID" -> \
"ad6b28ea-8963-4d90-9452-5c01290e6948",
 InitializationCell->True],
Cell[204622, 5827, 808, 21, 91, "Input", "ExpressionUUID" -> \
"24c456d3-83b9-4632-aa9e-a770bab95936",
 InitializationCell->True],
Cell[205433, 5850, 1581, 39, 175, "Input", "ExpressionUUID" -> \
"b92de30b-ebd1-4c9b-9382-3150e86b6f98",
 InitializationCell->True],
Cell[207017, 5891, 2346, 56, 217, "Input", "ExpressionUUID" -> \
"8131645a-8f7c-482e-870e-d27910560e23",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[209400, 5952, 226, 5, 29, "Subsubsection", "ExpressionUUID" -> \
"1a40a1c5-bcb5-4cd9-86b5-e4ace24c52c1"],
Cell[209629, 5959, 2280, 55, 217, "Input", "ExpressionUUID" -> \
"9936e58a-2f35-408a-979c-5f9d7b8a852f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[211958, 6020, 159, 3, 36, "Subsection", "ExpressionUUID" -> \
"cc88ef73-be57-4f91-88f5-e766692a46a0"],
Cell[CellGroupData[{
Cell[212142, 6027, 157, 3, 35, "Subsubsection", "ExpressionUUID" -> \
"a60cbc77-f720-41ee-9834-a958685f2955"],
Cell[212302, 6032, 831, 23, 70, "Input", "ExpressionUUID" -> \
"07ec673d-1ea3-4e3b-83c8-eb25b3b12338",
 InitializationCell->True],
Cell[213136, 6057, 847, 23, 91, "Input", "ExpressionUUID" -> \
"8a8c0be6-5f59-4838-ac81-692b47cbfd73",
 InitializationCell->True],
Cell[213986, 6082, 1262, 33, 91, "Input", "ExpressionUUID" -> \
"2d7f8182-4f98-4a42-ae14-f239f1911296",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[215309, 6122, 228, 4, 39, "Section", "ExpressionUUID" -> \
"44580c89-1238-4e8d-be00-6402bc10f9bb"],
Cell[215540, 6128, 2641, 64, 322, "Input", "ExpressionUUID" -> \
"e474979d-272c-4c35-a19f-4c15698d428b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[218218, 6197, 241, 4, 39, "Section", "ExpressionUUID" -> \
"3cb05441-ed10-4aa2-b243-a5fac65b6fc2"],
Cell[218462, 6203, 4737, 98, 490, "Input", "ExpressionUUID" -> \
"19acdd75-c9cd-4c1a-b1f6-f1144aa6f091",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[223236, 6306, 276, 5, 39, "Section", "ExpressionUUID" -> \
"b88cfb64-09a7-4a6e-80d4-fffb4b3be6cc"],
Cell[223515, 6313, 677, 19, 91, "Input", "ExpressionUUID" -> \
"5d6fcead-d556-4216-b8b5-fe0a8ef4033a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[224229, 6337, 330, 7, 39, "Section", "ExpressionUUID" -> \
"362a1d54-01d5-4fb7-b6b5-17cce6df2ff5",
 InitializationCell->True],
Cell[224562, 6346, 418, 10, 70, "Input", "ExpressionUUID" -> \
"ef529305-a588-453b-b67c-c880ffc0b338",
 InitializationCell->True],
Cell[224983, 6358, 433, 10, 91, "Input", "ExpressionUUID" -> \
"ac351dcf-74a4-4e12-bb98-7919ab1e3754",
 InitializationCell->True],
Cell[225419, 6370, 396, 10, 70, "Input", "ExpressionUUID" -> \
"f5a97a69-4072-427a-ac9e-da4bc9ccd9a6",
 InitializationCell->True],
Cell[225818, 6382, 848, 24, 91, "Input", "ExpressionUUID" -> \
"678f7cb2-511a-4d67-9ac9-3dc8bb7dbf39",
 InitializationCell->True],
Cell[226669, 6408, 352, 9, 70, "Input", "ExpressionUUID" -> \
"9e9d6b59-f295-45c7-bc7a-f5e1e5387035",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[227070, 6423, 643, 13, 39, "Subsubtitle", "ExpressionUUID" -> \
"71acda9c-8484-486e-a4be-95aa56821d5b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[227738, 6440, 201, 4, 39, "Section", "ExpressionUUID" -> \
"becaa15d-94da-423b-9ef9-c943cfb989d8"],
Cell[227942, 6446, 660, 15, 48, "Input", "ExpressionUUID" -> \
"35613b65-a58c-4502-ae87-c8360e6ef2bc",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[228639, 6466, 180, 3, 39, "Section", "ExpressionUUID" -> \
"762c30d4-78f1-428b-a119-b17aacca51b0"],
Cell[228822, 6471, 489, 14, 48, "Input", "ExpressionUUID" -> \
"a9dc4742-2919-476b-ad18-06eea0d7f3f6",
 InitializationCell->True],
Cell[229314, 6487, 737, 17, 70, "Input", "ExpressionUUID" -> \
"284d4561-97a8-4365-b7f7-62dabdea1460",
 InitializationCell->True],
Cell[230054, 6506, 709, 17, 91, "Input", "ExpressionUUID" -> \
"7761d295-7c08-4029-8089-b1a1a7eeec5f",
 InitializationCell->True],
Cell[230766, 6525, 620, 14, 70, "Input", "ExpressionUUID" -> \
"a3a07a0d-9545-47e9-af63-ca282f150d9b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[231423, 6544, 246, 4, 39, "Section", "ExpressionUUID" -> \
"47125ed4-989a-4f82-8980-8d0474d206b5"],
Cell[231672, 6550, 1512, 32, 259, "Input", "ExpressionUUID" -> \
"7c4e13b7-3cec-485d-806b-9cf51d42cb69",
 InitializationCell->True],
Cell[233187, 6584, 891, 22, 133, "Input", "ExpressionUUID" -> \
"5a90075d-bd27-426d-b080-53f1603d39b6",
 InitializationCell->True],
Cell[234081, 6608, 1835, 42, 196, "Input", "ExpressionUUID" -> \
"6895eaeb-e968-4735-9368-4fff6133bbee",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[235953, 6655, 261, 4, 39, "Section", "ExpressionUUID" -> \
"426d2100-f0c5-486a-a29c-18514e6cc315"],
Cell[236217, 6661, 568, 13, 48, "Input", "ExpressionUUID" -> \
"fbc7f687-a04c-4254-a7d0-f2dba2fed51b",
 InitializationCell->True],
Cell[236788, 6676, 463, 11, 70, "Input", "ExpressionUUID" -> \
"5c1efb8b-5f22-4eeb-bf94-9c903eee127a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[237288, 6692, 281, 4, 39, "Section", "ExpressionUUID" -> \
"ce24e1ba-faf2-44e9-8465-39ff1c2c44bb"],
Cell[237572, 6698, 875, 17, 175, "Input", "ExpressionUUID" -> \
"d72a33b0-3563-4ecf-b5c7-d89eedf7b686",
 InitializationCell->True],
Cell[238450, 6717, 1317, 26, 280, "Input", "ExpressionUUID" -> \
"9187f310-e7db-475f-bb19-927dd4ec9d3c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[239804, 6748, 330, 7, 39, "Section", "ExpressionUUID" -> \
"9f59a1b3-64d0-42c3-93eb-550c348d058a",
 InitializationCell->True],
Cell[240137, 6757, 451, 11, 70, "Input", "ExpressionUUID" -> \
"d6bfe10c-70ec-4fd7-8ca9-3109983a2b00",
 InitializationCell->True],
Cell[240591, 6770, 477, 12, 70, "Input", "ExpressionUUID" -> \
"3785c124-b8b8-4419-b9f2-3005ef694452",
 InitializationCell->True],
Cell[241071, 6784, 392, 9, 70, "Input", "ExpressionUUID" -> \
"3f94020f-20bc-4d01-a1cb-ef8ccddc371e",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[241524, 6800, 206, 6, 65, "Chapter", "ExpressionUUID" -> \
"1463c533-489b-4008-8c83-abafc966212a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[241733, 6808, 208, 8, 66, "Input", "ExpressionUUID" -> \
"414ac8da-6483-429e-ac8c-7797d02f2808",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]]
}
]
*)

