(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    846944,      22249]
NotebookOptionsPosition[    707515,      19271]
NotebookOutlinePosition[    708188,      19295]
CellTagsIndexPosition[    708145,      19292]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["QM`SpinOperators`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.682593334636269*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"35918fb3-53f5-4673-b85b-9465181d60f4"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"814aaab9-20fa-4186-9406-3f42165dcea1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BeginPackage", "[", 
    RowBox[{"\"\<QM`SpinOperators`\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
       ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
       "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
       "\[IndentingNewLine]", "\"\<Tensors`CG`\>\"", ",", 
       "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
       "\[IndentingNewLine]", "\"\<General`General3D`\>\"", ",", 
       "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\""}], "\n", 
      "}"}]}], "]"}], ";"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.682597046882406*^9, 3.68259708037218*^9}, 
   3.683133906202713*^9, {3.68319193962222*^9, 3.683191940445212*^9}, {
   3.6948466661354303`*^9, 3.694846667277424*^9}, {3.745396848745657*^9, 
   3.745396854130954*^9}},ExpressionUUID->"def87971-b0be-445d-9248-\
dc009f90651e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exports", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e20fac8b-45b8-4c30-ae0e-338baa4107e9"],

Cell[CellGroupData[{

Cell["operators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"e4fc0a99-1811-439f-9bdf-ff35bde29ca2"],

Cell[CellGroupData[{

Cell["Operator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, 
   3.504109824945512*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"23709340-de4b-4255-9074-80c6867acad5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "usage"}], "=", 
   "\"\<Operator[matrep,basis,opts] defines a spin operator that has the \
matrix representation matrep in the specified basis. The current basis is \
assumed if basis is missing. The options may include OperatorType, which may \
be used to define whether the operator is unitary, hermitian, etc. Operator \
may also be called with the format Operator[op,basis,opts], where op is an \
operator expression. The routine will then calculate the matrix \
representation and assign the OperatorType automatically.\nOperator may also \
have the form Operator[{X,evals,Xinv},basis,opts] where X is a matrix whose \
columns are the eigenvectors of the matrix representation of the operator in \
the basis basis, evals are the eigenvalues, and Xinv is the inverse of X. \
This form is generated by applying NDiagonalize to an operator. \n\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
   3.5041098271064587`*^9, 3.5041098609109488`*^9}, {3.5041101770207577`*^9, 
   3.504110189617758*^9}, {3.531829191563922*^9, 3.5318291919915*^9}, {
   3.531829256245398*^9, 3.531829349850441*^9}, 3.5319270345165243`*^9, {
   3.531927158408794*^9, 3.5319271595917683`*^9}, 3.547025716497306*^9, {
   3.586080111366419*^9, 3.58608019735291*^9}, {3.586083819447632*^9, 
   3.586083823366138*^9}, {3.586084049255663*^9, 3.586084154661208*^9}, {
   3.586089010983004*^9, 3.586089011938239*^9}},
 CellLabel->
  "In[1077]:=",ExpressionUUID->"699b49e2-e574-4801-b936-9c2047f11f8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorType", "::", "usage"}], "=", 
   "\"\<CheckOperatorType is an option for Operator, which suppresses \
checking of OperatorType if CheckOperatorType\[Rule]False\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5320048668339653`*^9, 3.5320049044374228`*^9}},
 CellLabel->
  "In[1078]:=",ExpressionUUID->"074c0de3-665b-47d6-96d7-4e0b28b2cdb5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckMatrixDimensions", "::", "usage"}], "=", 
   "\"\<CheckMatrixDimensions is an option for Operator, which causes \
checking of matrix dimensions if True.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5320048668339653`*^9, 3.5320049044374228`*^9}, {
  3.6406036078573093`*^9, 3.6406036326415462`*^9}, {3.640603685230112*^9, 
  3.6406036912795563`*^9}},
 CellLabel->
  "In[1079]:=",ExpressionUUID->"30f4e25b-d150-407d-a7ca-e54082efa33f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "::", "usage"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"NDiagonalize", "::", "usage"}], ")"}], "<>", 
    "\"\<\\n\nThe syntax NDiagonalize[op,basis,opts] causes an operator to be \
converted into diagonalized form in the Hilbert basis (specification of this \
is optional). The option Assumptions may be used with NDiagonalize when it is \
applied to an operator. If Assumptions\[Rule]Automatic, the setting of \
OperatorType determines whether assumptions of the type \
Assumptions\[Rule]{OrthogonalEigenvectors\[Rule]True} are used.\>\""}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860888497282*^9, 3.5860889892873507`*^9}},
 CellLabel->
  "In[1080]:=",ExpressionUUID->"7725e92f-e474-4cfd-a064-796e0962ccb3"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"67f1db72-f5f2-407a-9954-08c1024339ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "::", "usage"}], "=", 
   "\"\<determines whether an expression has the form of a spin \
operator\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}},
 CellLabel->
  "In[1081]:=",ExpressionUUID->"3cb89199-6197-49d7-8f13-7c0a0b2a2061"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorType", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, 
   3.583412489866617*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"cd57c1b7-ffe7-4f6a-971b-656524423325"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorType", "::", "usage"}], "=", 
   "\"\<OperatorType may be applied to an operator to determine its \
type.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531829197100492*^9, 3.5318292531763887`*^9}, {
  3.583412394038204*^9, 3.583412409676866*^9}, {3.583412987098298*^9, 
  3.583412996494864*^9}},
 CellLabel->
  "In[1082]:=",ExpressionUUID->"f7841be7-b409-4904-acc9-e1866f9180cf"]
}, Closed]],

Cell[CellGroupData[{

Cell["AngularMomentumOperator, opI", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502166455101253*^9, 3.502166464106722*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9e1f5069-0c99-4da2-b40f-a24ded533a08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "::", "usage"}], "=", 
   "\"\<opI[spin, \[Mu]] defines an angular momentum operator for the \
indicated spin. If the symbol spin is a List, a sum over the spins in the \
list is implied, and if the symbol spin is absent, a sum over all spins in \
the current spin system is taken. The label \[Mu] may be a phase \[Phi] \
(indicating the phase angle of the spin angular momentum in the xy-plane), or \
may specify the polar angles {\[Theta],\[Phi]} (indicating spin angular \
momentum in an arbitrary direction in 3D space). The label \[Mu] may also \
take the values \\\"x\\\", \\\"y\\\", \\\"z\\\", indicating spin angular \
momentum operators along one of the Cartesian axes. Shift operators are \
indicated by using labels \\\"+\\\",\\\"-\\\", while polarization operators \
for spins-1/2 are indicated by using labels \\\"\[Alpha]\\\", \
\\\"\[Beta]\\\". If the label \[Mu] is absent, a vector of the three \
Cartesian angular momentum components is generated. Hence  opI[i].opI[j] \
defines the dot product of the angular momenta of spins i and j.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164621599744*^9, 3.456164763147931*^9}, {
  3.502165613905551*^9, 3.502166213256482*^9}, {3.502166251440702*^9, 
  3.502166274365844*^9}},
 CellLabel->
  "In[1083]:=",ExpressionUUID->"baaf64bc-9f63-4b2f-8ca8-ca7a98ce9131"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AngularMomentumOperator", "::", "usage"}], "=", 
   "\"\<AngularMomentumOperator is a synonym for opI\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5021663623030853`*^9, 3.502166380020104*^9}},
 CellLabel->
  "In[1084]:=",ExpressionUUID->"3af0992c-f277-47e2-ae41-7774d8bafd3b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidAxisSpecificationQ", "::", "usage"}], "=", 
   "\"\<ValidAxisSpecificationQ[<axis>] returns True if <axis> has the valid \
syntax for specifying the axis of an angular momentum operator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674551844517115*^9, 3.6745519037263002`*^9}},
 CellLabel->
  "In[1085]:=",ExpressionUUID->"2b0c1fef-4aff-4cc5-b48b-b1cee158281a"]
}, Closed]],

Cell[CellGroupData[{

Cell["SingleTransitionOperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4864573505620213`*^9, 3.486457357320607*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"48d67343-8d3c-4d7d-a1ba-34d5c484c586"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "::", "usage"}], "=", 
   "\"\<SingleTransitionOperator[{r,s}, \[Mu]] defines a single transition \
operator within the current basis. Allowed values of \[Mu] are \\\"x\\\", \
\\\"y\\\", \\\"z\\\", \\\"+\\\",\\\"-\\\" or \\\"u\\\", \\\"E\\\", \\\"1\\\" \
for the Unity Operator. The state identifiers {r,s} must be members of the \
BasisLabels for the current basis. The most general form is \
SingleTransitionOperator[{{r,s},basis}, \[Mu]] which constructs a single \
transition operator for kets within any basis. \n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164621599744*^9, 3.456164763147931*^9}, {
  3.4864573626893253`*^9, 3.486457541361269*^9}, {3.502166302180484*^9, 
  3.5021663034092712`*^9}, {3.6659048117235403`*^9, 3.6659048392970047`*^9}},
 CellLabel->
  "In[1086]:=",ExpressionUUID->"c82cfac0-77b9-44a2-b88b-8415b520dfc9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Spherical Tensor Operators opT", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e46c6dc1-a579-4e12-a085-0386966f0032"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<opT[j,{1,\[Mu]}] defines a first-rank spherical tensor operator for \
spin j.\nopT[{1,\[Mu]}] defaults to opT[1,{1,\[Mu]}].\nopT[{j,k},{2,\[Mu]}] \
defines a second-rank spherical tensor operator for spins j and k.\nopT[2,\
\[Mu]] defaults to opT[{1,2},{2,\[Mu]}]\nopT[{{j,\!\(\*SubscriptBox[\(\
\[Lambda]\), \(j\)]\)},{k,\!\(\*SubscriptBox[\(\[Lambda]\), \(k\)]\)}..},{\
\[CapitalLambda],M}] generates a \[CapitalLambda]th rank ISTO by coupling \
together the interactions {{j,\!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\)},{k,\
\!\(\*SubscriptBox[\(\[Lambda]\), \(k\)]\)}..} where j is a symbol \
identifying the interaction and \!\(\*SubscriptBox[\(\[Lambda]\), \(j\)]\) is \
its rank.\nopT[{j,k..},{\[CapitalLambda],M}] defaults to \
opT[{{j,1},{k,1}..},{\[CapitalLambda],M}].\nThe option Normalize->True may be \
set to generate STOs normalized in the current state basis.\nIn cases where \
there are many possible coupling paths to the requested operator, a message \
is issued and a list of all possible operators is returned. A single operator \
may be returned using the form opT[{{j,\!\(\*SubscriptBox[\(\[Lambda]\), \
\(j\)]\)},{k,\!\(\*SubscriptBox[\(\[Lambda]\), \
\(k\)]\)}..},{\[CapitalLambda],M},n], where n is an integer identifying the \
requested operator. \nAn explicit coupling pathway may also be specified. For \
example, a rank-2 operator generated by coupling together the rank-1 operator \
for spin #1 with the rank-1 operator for spin #2, and then coupling the \
resulting rank-1 operator with a rank-2 operator for spin #3, may be \
specified as follows: opT[{{{{1,1},{2,1}},1},{3,2}},{2,M}].\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447339403049444*^9, 3.4473394333381233`*^9}, {
  3.468167290532301*^9, 3.46816736838039*^9}, {3.652866606866288*^9, 
  3.652866643750404*^9}, {3.652866687844325*^9, 3.6528670170985403`*^9}},
 CellLabel->
  "In[1087]:=",ExpressionUUID->"49276133-44e4-4b92-8b58-0b8e992f34ff"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationOperator, opR", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502166468052916*^9, 3.502166471226511*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"720343fe-3731-407e-8604-b5cab3e87b91"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "::", "usage"}], "=", 
   "\"\<opR[spins,angle] is the operator for rotating a single spin or a set \
of spins through the specified angle. If spins is absent, all spins in the \
current SpinSystem are rotated. The following formats for angle may be used: \
1. {\[Beta],\[Phi]} indicates a rotation through \[Beta] about an axis in the \
xy plane with the phase \[Phi]. The phase value may either be numeric, or be \
specified using the text codes \\\"x\\\", \\\"y\\\", \\\"-x\\\" for the \
quadrature phases. A code \\\"z\\\" indicates a rotation about the z-axis. 2. \
The format {\[Xi],{\[Theta],\[Phi]}} indicates a rotation through the angle \
\[Xi] about an axis with polar angles \[Theta] and \[Phi]. 3. The format {\
\[Alpha],\[Beta],\[Gamma]} indicates a rotation through the specified Euler \
angles, using the zyz convention.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164776690061*^9, 3.45616489903903*^9}, {
  3.460365965158004*^9, 3.4603660916347303`*^9}, {3.4603664356024933`*^9, 
  3.4603664509146147`*^9}},
 CellLabel->
  "In[1088]:=",ExpressionUUID->"45044f4c-cf17-4ee1-adb0-54dc3550fafc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotationOperator", "::", "usage"}], "=", 
   "\"\<RotationOperator is a synonym for opR\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4603664635829906`*^9, 3.460366478669361*^9}},
 CellLabel->
  "In[1089]:=",ExpressionUUID->"1500053c-3a33-4c45-9cff-519b4f4e5e13"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnityOperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486462824543583*^9, 3.486462827164761*^9}, 
   3.502166474988965*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"4191c192-aa58-47c8-953c-0c8249850588"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "::", "usage"}], "=", 
   "\"\<UnityOperator[] is the unity operator for the entire spin system. \
UnityOperator[j] is the unity operator for an individual spin. \
UnityOperator[{r,s}] is the single-transition unity operator for the pair of \
states with labels {r,s} in the current basis.;  UnityOperator[{{r,s},basis}] \
is the single-transition unity operator for the pair of states with labels \
{r,s} in the basis basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864638065788383`*^9, 3.486463892049707*^9}, {
   3.486464285444785*^9, 3.486464285831566*^9}, {3.4864644829067163`*^9, 
   3.486464531879726*^9}, 3.4864649317386703`*^9},
 CellLabel->
  "In[1090]:=",ExpressionUUID->"9282779e-9d48-4efb-9020-3c314af413ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullOperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4673011037091427`*^9, 3.467301105715014*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"575dda38-c7d5-43a8-aedb-ed1cbf20f95c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NullOperator", "::", "usage"}], " ", "=", 
   "\"\<NullOperator[] is the null operator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025729752322*^9, 3.547025737416712*^9}},
 CellLabel->
  "In[1091]:=",ExpressionUUID->"aa816bc1-3072-48e2-8668-98c6d6958bc0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Population and Coherence Operators", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"f482c4c4-788d-46b4-9f9c-287e1021767a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "::", "usage"}], "=", 
   "\"\<PopulationOperator[r] is the population operator for the state with \
label r in the current basis.; PopulationOperator[{r,basis}] is the \
population operator for the state with label r in the basis basis.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4864654942198877`*^9, 3.4864655666358843`*^9}, {
  3.486465714126111*^9, 3.486465714437365*^9}},
 CellLabel->
  "In[1092]:=",ExpressionUUID->"45402709-eda3-4105-90fb-4c53f6c95d44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "::", "usage"}], "=", 
   "\"\<CoherenceOperator[{r,s}] is the operator |r><s| for the pair of \
states with labels {r,s} in the current basis.;  \
CoherenceOperator[{{r,s},basis}] is the operator |r><s| for the pair of \
states with labels {r,s} in the basis basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4864655898094273`*^9, 3.486465653012618*^9}, {
  3.486465717340262*^9, 3.486465717709732*^9}},
 CellLabel->
  "In[1093]:=",ExpressionUUID->"6ffdee6b-2b48-43f1-b7c7-ac5c061ed028"]
}, Closed]],

Cell[CellGroupData[{

Cell["Projection and ShiftOperators", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602940768915243`*^9, 3.46029408339401*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"f08d223b-9a99-4c5b-b1b1-9f358d369dec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "::", "usage"}], "=", 
   "\"\<ProjectionOperator[ket] is the operator for projection onto the \
specified ket, i.e. |ket><ket|. The ket is automatically normalized before \
use. The syntax ProjectionOperator[{{j,mj},{k,mk}..}] constructs a projection \
operator onto the states {mj,mk..} of a subset of spins {j,k..}. A sum is \
taken over the spins not included in the set {j,k..}.\>\""}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, 
   3.450614180007576*^9, {3.4556434524258842`*^9, 3.455643462806561*^9}, {
   3.460294104008157*^9, 3.460294140704196*^9}, {3.460294203446073*^9, 
   3.460294213132286*^9}, {3.4606292530234623`*^9, 3.460629397805852*^9}, {
   3.460629433374834*^9, 3.460629444421898*^9}},
 CellLabel->
  "In[1094]:=",ExpressionUUID->"48153dc3-7d63-4213-af8e-0d280901297d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftOperator", "::", "usage"}], "=", 
   "\"\<ShiftOperator[ket,bra] is the operator |ket><bra|. Both ket and bra \
are automatically normalized before use.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
  3.450614150522191*^9, 3.450614177232225*^9}, {3.4554626340113564`*^9, 
  3.4554626529329844`*^9}, {3.4554626967994757`*^9, 3.455462721376337*^9}, {
  3.4554628077931547`*^9, 3.4554628125837307`*^9}, {3.455643414156969*^9, 
  3.455643443863118*^9}, {3.455643580145306*^9, 3.45564359234967*^9}, {
  3.4602941588029737`*^9, 3.460294198483589*^9}},
 CellLabel->
  "In[1095]:=",ExpressionUUID->"02b7ba59-56fb-4aed-9197-cbedd0a674f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinPermutationOperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602940768915243`*^9, 3.46029408339401*^9}, {
   3.502278224749463*^9, 3.5022782278919973`*^9}, 3.5022839007990932`*^9, {
   3.590399059341234*^9, 3.5903990641466827`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"dac7b2f3-410d-417f-a8c7-870f8a8f89be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "::", "usage"}], "=", 
   "\"\<SpinPermutationOperator[{j,k}] is the operator for exchange of spin j \
with spin k. SpinPermutationOperator[{j,k,l,m..}] is the operator for a \
cyclic permutation of the specified spins, with \
j\[Rule]k,k\[Rule]l,l\[Rule]m, etc. \
SpinPermutationOperator[{..{j2,k2..},{j1,k1..}}] is the operator for \
successive spin exchange operations, with the {j1,k1..} permutation preceding \
the {j2,k2..} permutation, and so on (i.e. right to left order of \
application).\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, 
   3.450614180007576*^9, {3.4556434524258842`*^9, 3.455643462806561*^9}, {
   3.460294104008157*^9, 3.460294140704196*^9}, {3.460294203446073*^9, 
   3.460294213132286*^9}, {3.4606292530234623`*^9, 3.460629397805852*^9}, {
   3.460629433374834*^9, 3.460629444421898*^9}, {3.502278232660265*^9, 
   3.5022783011918497`*^9}, {3.50228385319421*^9, 3.50228387899225*^9}, {
   3.59039876671084*^9, 3.5903989013679132`*^9}, {3.590399006040854*^9, 
   3.5903990317477493`*^9}, {3.590399071711555*^9, 3.590399081441976*^9}, {
   3.590399304891294*^9, 3.5903993065983067`*^9}},
 CellLabel->
  "In[1096]:=",ExpressionUUID->"0348e61f-bac5-4e03-99f6-ef5aa13f88ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinExchangeOperator", "::", "usage"}], "=", 
   "\"\<SpinExchangeOperator has been superseded by SpinPermutationOperator\>\
\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, 
   3.450614180007576*^9, {3.4556434524258842`*^9, 3.455643462806561*^9}, {
   3.460294104008157*^9, 3.460294140704196*^9}, {3.460294203446073*^9, 
   3.460294213132286*^9}, {3.4606292530234623`*^9, 3.460629397805852*^9}, {
   3.460629433374834*^9, 3.460629444421898*^9}, {3.502278232660265*^9, 
   3.5022783011918497`*^9}, {3.50228385319421*^9, 3.50228387899225*^9}, {
   3.59039876671084*^9, 3.5903989013679132`*^9}, {3.590399006040854*^9, 
   3.5903990317477493`*^9}, {3.590399093426648*^9, 3.590399117255651*^9}},
 CellLabel->
  "In[1097]:=",ExpressionUUID->"9ed2b616-477d-4d2e-8dde-ec56a1c22773"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["matrix representations", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.68259769518991*^9, 
   3.682597702185166*^9}},ExpressionUUID->"facbabbd-60bf-45ca-9c54-\
d00218d9212d"],

Cell[CellGroupData[{

Cell["MatrixRepresentation", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"43f13a14-b0c4-402c-9ef0-de0da29661a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MatrixRepresentation", "::", "usage"}], " ", "=", 
   "\"\<MatrixRepresentation[op,basis] provides the matrix representation for \
an operator in a given basis. The output is a SparseArray and may be viewed \
by applying MatrixForm or MatrixPlot. The current basis is used if basis is \
omitted.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025606968602*^9, 3.547025615213552*^9}, {
  3.682594281787702*^9, 3.682594297089982*^9}},
 CellLabel->
  "In[1098]:=",ExpressionUUID->"adff62fa-d06a-4bad-a845-d1541f7667ff"]
}, Closed]],

Cell[CellGroupData[{

Cell["ProjectedMatrixRepresentation", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"eea239a0-254b-487f-b7bb-feee03c1d6d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectedMatrixRepresentation", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<ProjectedMatrixRepresentation[op1,op2,Basis->basis] gives the matrix \
representation of op1 in the defined basis, projected onto the eigensystem of \
op2. The coherences between non-degenerate eigenstates of op2 are \
deleted.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.501040733520191*^9, 3.5010407335288877`*^9}, 
   3.547025622690776*^9, 3.547025689500533*^9},
 CellLabel->
  "In[1099]:=",ExpressionUUID->"a03f5a3c-f2aa-4271-b31d-3eac781af7d4"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProjection", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"18eaef38-184b-41c9-b14e-84f3e56c61c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorProjection", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<OperatorProjection[op1,op2,Basis->basis] gives the projection of op1 \
onto op2, using the specified basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.501040733543751*^9, 3.501040733559684*^9}, {
  3.547025691923174*^9, 3.547025704631304*^9}},
 CellLabel->
  "In[1100]:=",ExpressionUUID->"f7cb485e-7da2-44e1-a776-75ad3e3aa058"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["functions of operators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"17e0134e-3f74-41d4-bf4e-455ea361a6fa"],

Cell[CellGroupData[{

Cell["Commutator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"69845155-786e-47fd-85ff-5cbc3c584dd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Commutator", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Commutator[a,b] gives the commutator of two operators.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.501040733676813*^9, 3.501040733710737*^9}, {
  3.547025745177249*^9, 3.547025746620758*^9}},
 CellLabel->
  "In[1101]:=",ExpressionUUID->"dbde64ae-716d-43d9-9d51-5adb6c6e9ba2"]
}, Closed]],

Cell[CellGroupData[{

Cell["CoherenceOrder", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"fc361c54-0656-4f52-babd-8224566ef320"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<CoherenceOrder[op] gives the total coherence order of an operator op. \
CoherenceOrder[spins,op] gives the coherence order summed over the defined \
set of spins. CoherenceOrder[{spins1,spins2...},op] gives a list of coherence \
orders for each of the defined sets of spins. If an operator contains more \
than one coherence order, a list of the contained coherence orders is \
returned.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468164438272955*^9, 3.4681644499749937`*^9}, {
  3.502076781494165*^9, 3.502076799915557*^9}, {3.6305812187803917`*^9, 
  3.6305812873430023`*^9}},
 CellLabel->
  "In[1102]:=",ExpressionUUID->"428669d4-4265-4949-badf-d9f870448d33"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinProductRank", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.468164500786809*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"4c0ce378-fc8d-4238-b6d1-d7540fc4bc0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "::", "usage"}], "=", 
   "\"\<SpinProductRank[op] gives the spin product rank of an operator op. \
For example, \!\(\*SubscriptBox[\(I\), \(1  x\)]\).\!\(\*SubscriptBox[\(I\), \
\(2  y\)]\) has a spin product rank of 2.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429871324201727*^9, 3.429871368663629*^9}, {
  3.468154963801524*^9, 3.468155039700362*^9}, {3.468155341962016*^9, 
  3.468155383649239*^9}, {3.4681567918791122`*^9, 3.468156823736245*^9}, {
  3.468164517581613*^9, 3.468164591952159*^9}},
 CellLabel->
  "In[1103]:=",ExpressionUUID->"9ed9ef87-5fe8-4e47-85f2-a9b69f9b3c9f"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorTrace", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"439ef769-d305-4f58-bf48-cefc2d7909f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrace", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<OperatorTrace[op] gives the trace of an operator matrix \
representation.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
  3.501040733760648*^9, 3.5010407337942266`*^9}, {3.547025752992189*^9, 
  3.54702575340438*^9}},
 CellLabel->
  "In[1104]:=",ExpressionUUID->"28b04e27-0822-45b5-99b9-9f3d660823e6"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorNorm", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"0e67ad03-e7a9-444e-8458-7d36cc7126a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorNorm", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<OperatorTrace[op,basis] gives the norm of an operator in the \
specified basis, i.e. Sqrt[Tr[Adjoint[op].op]]. OperatorNorm[op] uses the \
current basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
   3.434525590977869*^9, 3.434525626453712*^9}, {3.4472271271273623`*^9, 
   3.447227169088076*^9}, {3.4472277095226297`*^9, 3.4472277154567223`*^9}, 
   3.4473432587298737`*^9},
 CellLabel->
  "In[1105]:=",ExpressionUUID->"9b80f9a8-e500-48fc-9d22-a9c5ee89e0a1"]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizeOperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}, {3.447343231667141*^9, 
  3.447343234368677*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"8670d831-d495-4b5d-a505-28e964782933"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<NormalizeOperator[op, norm, basis] scales an operator so that its \
norm is given by norm in the specified basis. If the basis specification is \
omitted, the current basis is used. If norm is omitted, a norm of 1 is \
assumed. The syntax NormalizeOperator[op1, op2, basis], where op2 is also an \
operator, sets the norm of op1 to equal that of op2.\n\>\""}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
  3.434525590977869*^9, 3.434525626453712*^9}, {3.4472271271273623`*^9, 
  3.447227169088076*^9}, {3.4472277095226297`*^9, 3.4472277154567223`*^9}, {
  3.447343237954089*^9, 3.447343296828744*^9}, {3.63285061683628*^9, 
  3.6328507572710047`*^9}},
 CellLabel->
  "In[1106]:=",ExpressionUUID->"d5b6c907-6881-4e58-a699-24840b53d6ba"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}, {3.447343231667141*^9, 
  3.447343234368677*^9}, {3.63056882567334*^9, 3.6305688273014803`*^9}, {
  3.6424074266483727`*^9, 3.6424074290474443`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9e532f2d-79e2-42ac-ab85-e84c3650e554"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorProduct", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<OperatorProduct[op1, op2,..] takes the product of one or more \
operators. Entering operators using the syntax op1.op2.op3.. generates terms \
of this form.  \n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
  3.434525590977869*^9, 3.434525626453712*^9}, {3.4472271271273623`*^9, 
  3.447227169088076*^9}, {3.4472277095226297`*^9, 3.4472277154567223`*^9}, {
  3.447343237954089*^9, 3.447343296828744*^9}, {3.630568838688796*^9, 
  3.63056928668631*^9}, {3.642407432409391*^9, 3.642407512268808*^9}},
 CellLabel->
  "In[1107]:=",ExpressionUUID->"7dae8103-7d44-4ed8-b053-020376bf5156"]
}, Closed]],

Cell[CellGroupData[{

Cell["InvolvedSpins", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}, {3.447343231667141*^9, 
  3.447343234368677*^9}, {3.63056882567334*^9, 3.6305688273014803`*^9}, {
  3.6424074266483727`*^9, 3.6424074290474443`*^9}, {3.6424127955416203`*^9, 
  3.64241279800286*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"39623be0-b292-497f-8aaf-588858da3f74"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<InvolvedSpins[op] returns the set of spins involved in an operator.\>\
\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
  3.434525590977869*^9, 3.434525626453712*^9}, {3.4472271271273623`*^9, 
  3.447227169088076*^9}, {3.4472277095226297`*^9, 3.4472277154567223`*^9}, {
  3.447343237954089*^9, 3.447343296828744*^9}, {3.630568838688796*^9, 
  3.63056928668631*^9}, {3.642407432409391*^9, 3.642407512268808*^9}, {
  3.64241281204743*^9, 3.64241284293003*^9}},
 CellLabel->
  "In[1108]:=",ExpressionUUID->"6d430fbf-ca3e-4523-b970-dd707caeb9a7"]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalTensorIndices", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}, {3.447343231667141*^9, 
  3.447343234368677*^9}, {3.63056882567334*^9, 3.6305688273014803`*^9}, {
  3.6424074266483727`*^9, 3.6424074290474443`*^9}, {3.6424127955416203`*^9, 
  3.64241279800286*^9}, {3.682609476260305*^9, 3.682609480860955*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ed34b9df-269b-4cba-a3d8-f76b8b90b163"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "::", "usage"}], "=", 
   "\"\<SphericalTensorIndices[op] gives the spherical rank \[Lambda] and \
coherence order \[Mu] of an operator op, in the form {\[Lambda],\[Mu]}. If an \
operator contains several different spherical tensor components, a list of \
the results is returned. \nThe syntax SphericalTensorIndices[stopb] returns a \
list of the spherical tensor indices in the basis operators of stopb, in the \
case that stopb is a SphericalTensorOperatorBasis. \n\>\""}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429871324201727*^9, 3.429871368663629*^9}, {
  3.468154963801524*^9, 3.468155039700362*^9}, {3.468155341962016*^9, 
  3.468155383649239*^9}, {3.4681567918791122`*^9, 3.468156823736245*^9}, {
  3.468164517581613*^9, 3.468164591952159*^9}, {3.639286050974004*^9, 
  3.639286141265897*^9}, {3.682609495310561*^9, 3.6826095815823174`*^9}},
 CellLabel->
  "In[1109]:=",ExpressionUUID->"5a242f1f-7dd9-401f-8002-e7c921f127a6"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"8a8ad9fb-d56e-431b-9ea6-d9eceb7ec3cb"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 CellLabel->
  "In[1110]:=",ExpressionUUID->"e5af9493-e0ff-4c8e-aaeb-8744657b5f8f"]
}, Closed]],

Cell[CellGroupData[{

Cell["operators acting on Ket & Bra", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.683187884067408*^9, 
   3.6831878857943583`*^9}, {3.683188019928773*^9, 3.683188023459511*^9}, {
   3.68318809467739*^9, 3.683188099963121*^9}, {3.6831881318685627`*^9, 
   3.683188136338464*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"e5e9e1ee-1826-445e-b19c-3b86fb8fd832"],

Cell[CellGroupData[{

Cell["operators acting on Ket from the left", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, 3.5703431586877737`*^9, {
   3.683188140551353*^9, 3.683188143416724*^9}, {3.683188186551811*^9, 
   3.683188199156988*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"5ae829b1-b574-498f-8be1-8340f10973d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ket", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], "[", 
     RowBox[{"ket", ":", 
      RowBox[{"Ket", "[", "___", "]"}]}], "]"}], "]"}], ":=", 
   RowBox[{"op", ".", "ket"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46064250068598*^9, 3.460642547550437*^9}, {
   3.460642614637635*^9, 3.460642654133204*^9}, 3.570343158688107*^9, {
   3.7054345634352484`*^9, 3.705434569519884*^9}, {3.7054346092930326`*^9, 
   3.7054346119285364`*^9}, {3.7054347687443805`*^9, 3.705434776529208*^9}, {
   3.7054348682355814`*^9, 3.705434871204275*^9}, {3.7262368413989534`*^9, 
   3.7262368437876644`*^9}, {3.726236897007678*^9, 3.726236898012405*^9}, {
   3.745425699907192*^9, 3.745425708854631*^9}, 
   3.7454660422072163`*^9},ExpressionUUID->"343192b4-5884-480d-83f1-\
999c1b289610"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Times", ",", "Infinity", ",", "\[IndentingNewLine]", 
   RowBox[{"Times", "/:", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], "[", 
      RowBox[{"kets", ":", 
       RowBox[{"Times", "[", "___", "]"}]}], "]"}], "]"}], ":=", 
    RowBox[{"op", ".", "kets"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.7262407488905344`*^9, 3.726240763610955*^9}, 3.7262409062095184`*^9, {
   3.7453999115040607`*^9, 3.7453999145014343`*^9}, 3.7454142082062273`*^9, {
   3.745425714972475*^9, 3.745425716472825*^9}, 3.74546603595194*^9, {
   3.745466115062293*^9, 3.745466120449712*^9}, 
   3.745466231019352*^9},ExpressionUUID->"1fb6ee23-ba8e-4d5f-a91e-\
a31a79e65d9b"],

Cell[BoxData["Times"], "Output",
 CellChangeTimes->{{3.744606800364853*^9, 3.744606804061832*^9}, 
   3.744606947535283*^9},
 CellLabel->
  "Out[1112]=",ExpressionUUID->"845475fb-9dc1-4c53-a51e-617173946eac"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Plus", ",", "Infinity", ",", "\[IndentingNewLine]", 
   RowBox[{"Plus", "/:", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], "[", 
      RowBox[{"kets", ":", 
       RowBox[{"Plus", "[", 
        RowBox[{"__", "?", "KetQ"}], "]"}]}], "]"}], "]"}], ":=", 
    RowBox[{"op", ".", "kets"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.745399920006049*^9, 3.745399923699925*^9}, 3.745414222129991*^9, {
   3.745425721675181*^9, 3.745425725561448*^9}, 3.745466048576604*^9, 
   3.7454661287985563`*^9, 
   3.745466232068874*^9},ExpressionUUID->"1fb6ee23-ba8e-4d5f-a91e-\
a31a79e65d9b"],

Cell[BoxData["Plus"], "Output",
 CellChangeTimes->{{3.744606800393396*^9, 3.7446068040935383`*^9}, 
   3.7446069475837727`*^9},
 CellLabel->
  "Out[1113]=",ExpressionUUID->"77d47832-e05b-454a-963f-71254cbffa1d"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"ops_", "?", "OperatorQ"}], ".."}], ",", 
       RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"OperatorProduct", "[", "ops", "]"}], "]"}], ".", "ket"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683119942658057*^9, 3.6831199487299013`*^9}, {
   3.745399927251649*^9, 3.745399931499957*^9}, 3.7454142375999203`*^9, {
   3.745425739560671*^9, 3.745425763902767*^9}, 3.7454660580325947`*^9, 
   3.745466137467413*^9, 
   3.7454662327008047`*^9},ExpressionUUID->"d7a44c4f-dac6-4038-b33c-\
0e1ffdc2ba60"],

Cell[BoxData["Dot"], "Output",
 CellChangeTimes->{{3.7446068004276447`*^9, 3.74460680411513*^9}, 
   3.7446069476326857`*^9},
 CellLabel->
  "Out[1114]=",ExpressionUUID->"1d0253cc-a1f6-41dc-8db0-8231a8c92ebd"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Dot", "/:", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"n1__", ",", 
          RowBox[{"op_", "?", "OperatorQ"}], ",", "n2___"}], "]"}], ",", 
        RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"op", ".", "ket"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.683188727165975*^9, 3.6831889342567873`*^9}, {3.683193719951005*^9, 
   3.683193752126583*^9}, {3.745399935901609*^9, 3.745399939506372*^9}, 
   3.745414245300514*^9, 3.745425775466117*^9, 3.745466071173641*^9, 
   3.745466146450589*^9, 
   3.745466233327005*^9},ExpressionUUID->"6fef2db3-5132-4dc0-989c-\
3ea72bcf9390"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Dot", "/:", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"n1___", ",", 
          RowBox[{"op_", "?", "OperatorQ"}], ",", "n2__"}], "]"}], ",", 
        RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"op", ".", "ket"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.683188727165975*^9, 3.6831889342567873`*^9}, {3.683193719951005*^9, 
   3.683193756312842*^9}, {3.7453999428511047`*^9, 3.745399946951001*^9}, {
   3.745414250049958*^9, 3.745414251519603*^9}, 3.745425804933934*^9, 
   3.745466078376095*^9, 3.745466152068384*^9, 
   3.74546623390373*^9},ExpressionUUID->"c110d304-3ccb-40ee-8290-\
e5f5b0cef1fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Dot", "/:", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", 
        RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "zb", "}"}], ",", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"zb", "=", 
          RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Inner", "[", 
          RowBox[{"Times", ",", 
           RowBox[{
            RowBox[{"MatrixRepresentation", "[", 
             RowBox[{"op", ",", "zb"}], "]"}], ".", 
            RowBox[{"VectorRepresentation", "[", 
             RowBox[{"ket", ",", "zb"}], "]"}]}], ",", 
           RowBox[{"BasisKets", "[", "zb", "]"}], ",", "Plus"}], "]"}]}], 
        "\[IndentingNewLine]", ")"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.683188727165975*^9, 3.6831889342567873`*^9}, {3.683188968184843*^9, 
   3.6831890559920597`*^9}, {3.683189229740656*^9, 3.683189289665215*^9}, {
   3.74539995151558*^9, 3.745399955501605*^9}, 3.745414261105682*^9, 
   3.7454661554984303`*^9, 
   3.745466234605237*^9},ExpressionUUID->"aad4dd4a-bcdf-4a9c-a4e0-\
e46b355579b5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["operators acting on Bra from the right", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, 3.5703431586877737`*^9, {
   3.683188140551353*^9, 3.683188143416724*^9}, {3.683188186551811*^9, 
   3.683188203748307*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"840be988-b4be-48bc-b720-3c69c569ef4b"],

Cell["be very careful to avoid recursion", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.593010609718255*^9, 
  3.593010615669105*^9}},ExpressionUUID->"72fabf25-8728-441e-b5d3-\
d8e6b0503f19"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bra", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{"bra_Bra", ",", 
      RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], "]"}], ":=", 
   RowBox[{"Adjoint", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"Adjoint", "[", "op", "]"}], ",", 
      RowBox[{"Adjoint", "[", "bra", "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593009533435107*^9, 3.593009655731522*^9}, {
  3.5930105490515537`*^9, 3.593010551737074*^9}, {3.593010618951983*^9, 
  3.593010649827118*^9}},
 CellLabel->
  "In[1118]:=",ExpressionUUID->"e50c1f9f-4e0f-4346-b743-4ad998d3bff1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bra", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{"bra_Bra", ",", 
      RowBox[{"op1_", "?", "OperatorQ"}], ",", 
      RowBox[{"ops__", "?", "OperatorQ"}]}], "]"}], "]"}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"bra", ",", "op1"}], "]"}], ",", "ops"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593009533435107*^9, 3.593009655731522*^9}, {
  3.5930105490515537`*^9, 3.593010551737074*^9}, {3.593010618951983*^9, 
  3.593010699682213*^9}},
 CellLabel->
  "In[1119]:=",ExpressionUUID->"59628c42-532c-4cb5-9095-20e940f4baf8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"bra_", "?", "BraQ"}], ",", 
        RowBox[{
         RowBox[{"ops_", "?", "OperatorQ"}], ".."}]}], "]"}]}], ":=", 
     RowBox[{"bra", ".", 
      RowBox[{"Operator", "[", 
       RowBox[{"OperatorProduct", "[", "ops", "]"}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.683119967800722*^9, 3.68311998407873*^9}, {3.74539996491193*^9, 
   3.7453999693529367`*^9}, {3.745414266817943*^9, 3.745414268271078*^9}, {
   3.74546619597643*^9, 3.74546619885081*^9}, 
   3.745466236450688*^9},ExpressionUUID->"3cc79ce1-689d-4c4c-a9eb-\
2ef2182eb782"]
}, Open  ]],

Cell[CellGroupData[{

Cell["trap erroneous Times combinations of Ket, Bra and operators", \
"Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, 3.5703431586877737`*^9, {
   3.683188140551353*^9, 3.683188143416724*^9}, {3.683188186551811*^9, 
   3.683188199156988*^9}, {3.744367397334242*^9, 3.744367409190585*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"a6dd61cd-562f-453f-95c3-04f0038e6a79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Times", ",", "1", ",", "\[IndentingNewLine]", 
   RowBox[{"Times", "/:", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{"args1___", ",", 
       RowBox[{"op_", "?", "OperatorQ"}], ",", "args2___", ",", 
       RowBox[{"ket_", "?", "KetQ"}], ",", "args3___"}], "]"}]}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Ket", "::", "badoptimesket"}], "]"}], ";", "$Failed"}], 
     ")"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.7262407488905344`*^9, 3.726240763610955*^9}, 3.7262409062095184`*^9, {
   3.74436742728922*^9, 3.7443675293765907`*^9}, {3.74436756067942*^9, 
   3.7443675646370773`*^9}, {3.744367821723752*^9, 3.7443678231298513`*^9}, {
   3.7453999809158278`*^9, 3.7453999850573883`*^9}, 
   3.7454142792034063`*^9},ExpressionUUID->"a7d0bfbd-8058-4cde-8719-\
592fa6d40f6d"],

Cell[BoxData["Times"], "Output",
 CellChangeTimes->{{3.744606800562192*^9, 3.7446068041802387`*^9}, 
   3.7446069477113667`*^9},
 CellLabel->
  "Out[1121]=",ExpressionUUID->"379c6c66-8e2a-46ff-aa72-ac457c6d53fb"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Times", ",", "1", ",", "\[IndentingNewLine]", 
   RowBox[{"Times", "/:", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{"args1___", ",", 
       RowBox[{"ket_", "?", "KetQ"}], ",", "args2___", ",", 
       RowBox[{"op_", "?", "OperatorQ"}], ",", "args3___"}], "]"}]}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Ket", "::", "badoptimesket"}], "]"}], ";", "$Failed"}], 
     ")"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.7262407488905344`*^9, 3.726240763610955*^9}, 3.7262409062095184`*^9, {
   3.74436742728922*^9, 3.74436750953013*^9}, {3.7443675402798557`*^9, 
   3.7443675504301567`*^9}, 3.7443678285720873`*^9, {3.745399989501129*^9, 
   3.745399992755364*^9}, 
   3.7454142823032293`*^9},ExpressionUUID->"7e19c299-68cd-4dc7-a557-\
4a1c4a4febe0"],

Cell[BoxData["Times"], "Output",
 CellChangeTimes->{{3.7446068006100197`*^9, 3.744606804209283*^9}, 
   3.744606947749057*^9},
 CellLabel->
  "Out[1122]=",ExpressionUUID->"49deca9f-9113-45e3-ab79-b9c3b6d50e24"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Times", ",", "1", ",", "\[IndentingNewLine]", 
   RowBox[{"Times", "/:", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{"args1___", ",", 
       RowBox[{"op_", "?", "OperatorQ"}], ",", "args2___", ",", 
       RowBox[{"bra_", "?", "BraQ"}], ",", "args3___"}], "]"}]}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Ket", "::", "badbratimesop"}], "]"}], ";", "$Failed"}], 
     ")"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.7262407488905344`*^9, 3.726240763610955*^9}, 3.7262409062095184`*^9, {
   3.74436742728922*^9, 3.7443675293765907`*^9}, {3.7443675761243057`*^9, 
   3.744367606063571*^9}, 3.7443678303793297`*^9, {3.745399996000339*^9, 
   3.745399999795906*^9}, 
   3.745414285174548*^9},ExpressionUUID->"4c611e18-4ee2-4811-bb50-\
244807889aae"],

Cell[BoxData["Times"], "Output",
 CellChangeTimes->{{3.7446068006429*^9, 3.744606804231996*^9}, 
   3.744606947800058*^9},
 CellLabel->
  "Out[1123]=",ExpressionUUID->"8aad571b-c80a-46dc-93d3-f312c8465453"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Times", ",", "1", ",", "\[IndentingNewLine]", 
   RowBox[{"Times", "/:", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{"args1___", ",", 
       RowBox[{"bra_", "?", "BraQ"}], ",", "args2___", ",", 
       RowBox[{"op_", "?", "OperatorQ"}], ",", "args3___"}], "]"}]}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Ket", "::", "badbratimesop"}], "]"}], ";", "$Failed"}], 
     ")"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
   3.7262407488905344`*^9, 3.726240763610955*^9}, 3.7262409062095184`*^9, {
   3.74436742728922*^9, 3.74436750953013*^9}, {3.7443675402798557`*^9, 
   3.7443675504301567`*^9}, {3.744367585624105*^9, 3.744367609677236*^9}, 
   3.74436783207262*^9, {3.745400004603012*^9, 3.7454000078578176`*^9}, 
   3.7454142872596407`*^9},ExpressionUUID->"690e2744-2d30-46ae-b702-\
bcf34860729e"],

Cell[BoxData["Times"], "Output",
 CellChangeTimes->{{3.744606800695713*^9, 3.744606804261016*^9}, 
   3.744606947850021*^9},
 CellLabel->
  "Out[1124]=",ExpressionUUID->"b3bdb64b-1781-4f55-9f4f-bc222d6c1c6b"]
}, Closed]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "badoptimesket"}], "=", 
   "\"\<An operator and a ket may not be multiplied using Times (\[Cross]). \
The correct form is \
\!\(\*StyleBox[\"operator\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"ket\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"]\",FontSlant->\"Italic\"]\) or \!\(\*StyleBox[\"ket\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\".\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
operator\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",FontSlant->\"Italic\"]\
\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744367649871949*^9, 3.744367715084231*^9}, 
   3.744367982922689*^9},
 CellLabel->
  "In[1125]:=",ExpressionUUID->"a3738066-3fb3-4563-9b36-dc38a16935ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "badbratimesop"}], "=", 
   "\"\<A bra and an operator may not be multiplied using Times (\[Cross]). \
The correct form is \
bra.\!\(\*StyleBox[\"operator\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",\
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744367649871949*^9, 3.744367687074419*^9}, {
   3.74436772532856*^9, 3.744367738421988*^9}, {3.7443678550400057`*^9, 
   3.7443678561286182`*^9}, 3.744367920125579*^9, {3.744367957220364*^9, 
   3.74436798522528*^9}},
 CellLabel->
  "In[1126]:=",ExpressionUUID->"f4034fb2-c113-494c-99c2-dcb65f1d3f9e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Operators", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"c92a8808-f963-4c4f-96a8-1a1b1e27b884"],

Cell[CellGroupData[{

Cell["general", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.616692491383861*^9, 3.616692491700788*^9}},
 ExpressionUUID -> "40a59d03-41fb-4993-b2bd-a8107ac9dc4a"],

Cell[CellGroupData[{

Cell["\<\
Adjoint of operators (extension of definitions in General`Matrices`)\
\>", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"efb591da-509e-4af3-8259-63eeecd6101f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", " ", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", "ops___", "]"}]}], "]"}], ":=", 
   RowBox[{"Dot", "@@", 
    RowBox[{"(", " ", 
     RowBox[{"Adjoint", "/@", " ", 
      RowBox[{"Reverse", "[", 
       RowBox[{"{", "ops", "}"}], "]"}]}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[1127]:=",ExpressionUUID->"17117afc-bfe0-4a92-9634-3b75d0465e8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", " ", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "___Rule"}], 
      "]"}]}], "]"}], ":=", 
   RowBox[{"OperatorProduct", "@@", 
    RowBox[{"(", " ", 
     RowBox[{"Adjoint", "/@", " ", 
      RowBox[{"Reverse", "[", 
       RowBox[{"{", "ops", "}"}], "]"}]}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6535758760059843`*^9, 3.653575885271941*^9}, {
  3.653579108312929*^9, 3.6535791308288183`*^9}},
 CellLabel->
  "In[1128]:=",ExpressionUUID->"33ad5e85-35e5-4e86-857c-954567f9ba71"]
}, Closed]],

Cell[CellGroupData[{

Cell["Simplify", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460868924111771*^9, 3.4608689296052017`*^9}, 
   3.616692501948316*^9, {3.639229796505439*^9, 
   3.6392297984958487`*^9}},ExpressionUUID->"e8fef239-4799-441a-86c1-\
c8a48686bcb7"],

Cell[CellGroupData[{

Cell["Simplify any operator expressions which contain Operator", \
"Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6392298036147337`*^9, 
  3.639229811917926*^9}},ExpressionUUID->"647bd12e-9b21-42c4-861b-\
696f07608026"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Simplify", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Simplify", "[", 
       RowBox[{"op_", "?", "OperatorQ"}], "]"}], "/;", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"FreeQ", "[", 
         RowBox[{"op", ",", "Operator"}], "]"}]}], "&&", 
       RowBox[{"!", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"op", ",", "_Operator"}], "]"}]}]}]}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Operator", "[", "op", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120088260642*^9, 3.683120094973115*^9}, {
   3.745400012355927*^9, 
   3.7454000230589857`*^9}},ExpressionUUID->"1335996d-f2d0-452f-81d9-\
fc03a91852df"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["OperatorPattern", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.621392056686445*^9, 3.621392058132978*^9}, {
   3.621392204897406*^9, 3.621392206146144*^9}, 
   3.621509104495373*^9},ExpressionUUID->"2291e2ae-0995-4f54-9a24-\
29edf75022e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorPattern", "=", 
   RowBox[{
   "_Operator", "|", "\[IndentingNewLine]", "_opI", "|", "_opT", "|", "_opR", 
    "|", "\[IndentingNewLine]", "_ProjectionOperator", "|", "_ShiftOperator", 
    "|", "\[IndentingNewLine]", "_SpinExchangeOperator", "|", 
    "_SpinPermutationOperator", "|", "\[IndentingNewLine]", "_UnityOperator", 
    "|", "_NullOperator", "|", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{"___", ",", "_Ket", ",", "_Bra", ",", "___"}], "]"}]}], "|", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "_", "]"}], "/;", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
        ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"ifunc", "[", 
          RowBox[{"ifunc", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
          "]"}], ",", 
         RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692136600374*^9, 3.616692145047408*^9}, {
  3.621392418037315*^9, 3.621392439416339*^9}, {3.621507305473865*^9, 
  3.621507335264859*^9}, {3.642408669767378*^9, 3.642408672294594*^9}},
 CellLabel->
  "In[1130]:=",ExpressionUUID->"1c00abb7-cab1-4329-8758-3e099767bc2f"]
}, Closed]],

Cell[CellGroupData[{

Cell["application of complex operator expressions to Ket", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.621392056686445*^9, 3.621392058132978*^9}, {
   3.621392204897406*^9, 3.621392206146144*^9}, 3.621509104495373*^9, {
   3.6749896543853083`*^9, 3.674989672384776*^9}, {3.674990211169668*^9, 
   3.674990212202464*^9}},ExpressionUUID->"849948ea-e601-43a6-bce1-\
589a7ff2f7e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Plus", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Plus", "/:", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"op", ":", 
        RowBox[{"HoldPattern", "@", 
         RowBox[{"Plus", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], ".."}], "]"}]}]}], ")"}], "[", 
      RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
     RowBox[{"op", ".", "ket"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.683120122867778*^9}, {
   3.7454000300007544`*^9, 3.745400033396667*^9}, 3.7454143172027903`*^9, {
   3.745466293326313*^9, 
   3.745466294876799*^9}},ExpressionUUID->"4d83df99-7de5-4993-8e9e-\
847f7c116ab0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Times", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Times", "/:", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{
         RowBox[{"Times", "[", 
          RowBox[{
           RowBox[{"n1___", "?", "NumericQ"}], ",", 
           RowBox[{"op_", "?", "OperatorQ"}], ",", "more___"}], "]"}], "[", 
         RowBox[{"ket_", "?", "KetQ"}], "]"}]}], ":=", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", 
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"op", ",", "more"}], "]"}], ".", "ket"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Times", "/:", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{
         RowBox[{"Times", "[", 
          RowBox[{"more___", ",", 
           RowBox[{"op_", "?", "OperatorQ"}], ",", 
           RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "[", 
         RowBox[{"ket_", "?", "KetQ"}], "]"}]}], ":=", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"more", ",", "op"}], "]"}], ".", "ket"}], ",", "n2"}], 
        "]"}]}]}], ")"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.68312014544804*^9}, {
   3.745400039101362*^9, 3.745400042047526*^9}, 3.745414330451796*^9, 
   3.745466299478965*^9},ExpressionUUID->"31a58874-1c15-42c4-b746-\
e540458aa192"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.642407603580264*^9, 3.642407604682588*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"cc5bf175-fa96-49b8-bebd-9a432d01ab25"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 
  3.6424077810379*^9}},ExpressionUUID->"e76afe5d-86ed-4c93-9c86-7ad2c842bc6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorProduct", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sorted", "\[Rule]", "False"}], ",", 
     RowBox[{"Checked", "\[Rule]", "False"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407787619081*^9, 3.642407833421001*^9}, {
  3.6424094532700987`*^9, 3.642409480486945*^9}},
 CellLabel->
  "In[1133]:=",ExpressionUUID->"0e549c72-297f-4a3a-a4f6-af84c30d6a32"],

Cell[CellGroupData[{

Cell["input via Dot", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
   3.64240784966448*^9, 3.642407859841761*^9}, {3.642407982345158*^9, 
   3.6424079892499123`*^9}, {3.6424084203445797`*^9, 
   3.6424084212941008`*^9}, {3.642408581970889*^9, 3.642408584783423*^9}, {
   3.653588822909904*^9, 3.6535888316594343`*^9}, 
   3.657103641936303*^9},ExpressionUUID->"2fa06ce8-5595-45b5-9dad-\
c5772fc23bb9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"Dot", "/:", 
      RowBox[{
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Dot", "[", 
         RowBox[{"ops", ":", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"_", "?", "OperatorQ"}], "|", 
             RowBox[{"_", "?", "NumericQ"}]}], ")"}], ".."}]}], "]"}]}], "/;", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "ops", "}"}], "]"}], "\[GreaterEqual]", "2"}]}], ":=", 
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"ops", ",", 
        RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}]}], ")"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.683120165715276*^9}, {
   3.745400048100933*^9, 3.745400051946539*^9}, 3.7454143443280907`*^9, {
   3.745466313004249*^9, 
   3.745466314242095*^9}},ExpressionUUID->"83b697b5-8942-414a-95a5-\
ff470f7b69a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"Dot", "/:", 
      RowBox[{
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Dot", "[", 
         RowBox[{
          RowBox[{"ops", ":", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"_", "?", "OperatorQ"}], "|", 
              RowBox[{"_", "?", "NumericQ"}]}], ")"}], ".."}]}], ",", 
          RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], "/;", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "ops", "}"}], "]"}], "\[GreaterEqual]", "2"}]}], ":=", 
      RowBox[{
       RowBox[{"OperatorProduct", "[", 
        RowBox[{"ops", ",", 
         RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}], ".", "ket"}]}], 
     ")"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.683120181723115*^9}, {
   3.745400056762579*^9, 3.745400061200897*^9}, 3.7454143490174437`*^9, 
   3.7454663192665167`*^9},ExpressionUUID->"d5f4294b-0d5a-4f76-979f-\
2a579efcfe3b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"Dot", "/:", 
      RowBox[{
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Dot", "[", 
         RowBox[{
          RowBox[{"bra_", "?", "BraQ"}], ",", 
          RowBox[{"ops", ":", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"_", "?", "OperatorQ"}], "|", 
              RowBox[{"_", "?", "NumericQ"}]}], ")"}], ".."}]}]}], "]"}]}], "/;", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "ops", "}"}], "]"}], "\[GreaterEqual]", "2"}]}], ":=", 
      RowBox[{"bra", ".", 
       RowBox[{"OperatorProduct", "[", 
        RowBox[{"ops", ",", 
         RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}]}]}], ")"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.683120195322618*^9}, 
   3.7454000696048517`*^9, {3.7454143547006407`*^9, 3.745414356148697*^9}, 
   3.745466321868046*^9},ExpressionUUID->"644ab696-2b26-483d-baba-\
cc78d15febfe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"Dot", "/:", 
      RowBox[{
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Dot", "[", 
         RowBox[{
          RowBox[{"bra_", "?", "BraQ"}], ",", 
          RowBox[{"ops", ":", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"_", "?", "OperatorQ"}], "|", 
              RowBox[{"_", "?", "NumericQ"}]}], ")"}], ".."}]}], ",", 
          RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], "/;", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"{", "ops", "}"}], "]"}], "\[GreaterEqual]", "2"}]}], ":=", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"bra", ".", 
        RowBox[{"OperatorProduct", "[", 
         RowBox[{"ops", ",", 
          RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}], ".", "ket"}], 
       ")"}]}], ")"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683120115363812*^9, 3.683120207657302*^9}, 
   3.7454000732031307`*^9, 3.74541436165201*^9, 
   3.74546632603552*^9},ExpressionUUID->"b1e94fd3-856f-4433-a986-\
365589563700"]
}, Open  ]],

Cell[CellGroupData[{

Cell["output display", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.64240784966448*^9, 3.642407859841761*^9}, {3.642407982345158*^9, 
  3.6424079892499123`*^9}},ExpressionUUID->"b08e71c6-3789-44b6-abad-\
0364a52a09ee"],

Cell[BoxData[
 RowBox[{"OperatorProduct", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}],
      "]"}]}], "]"}], ":=", 
  RowBox[{"DisplayForm", "@", 
   RowBox[{"RowBox", "[", 
    RowBox[{"Riffle", "[", 
     RowBox[{
      RowBox[{"ToBoxes", "/@", 
       RowBox[{"{", "ops", "}"}]}], ",", 
      RowBox[{"AdjustmentBox", "[", 
       RowBox[{"\"\<\[Bullet]\>\"", ",", 
        RowBox[{"BoxMargins", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.3"}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}]}], "]"}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407863599204*^9, 3.642407864500618*^9}, 
   3.6424079556379137`*^9, {3.642407995530745*^9, 3.6424080443446417`*^9}, {
   3.6424082196665497`*^9, 3.6424082335927362`*^9}, {3.6424083173455477`*^9, 
   3.642408319158125*^9}, {3.642409971999744*^9, 3.642409974988761*^9}, {
   3.642410016125616*^9, 3.642410021778664*^9}, {3.6424259038204317`*^9, 
   3.642425906398641*^9}, {3.642427575070469*^9, 3.6424275770178432`*^9}, {
   3.65709689683142*^9, 3.6570968971341887`*^9}, {3.6570976570050173`*^9, 
   3.6570976636688147`*^9}, {3.657727138857581*^9, 3.65772713909781*^9}, {
   3.657727325135398*^9, 3.657727325684414*^9}, 3.6577274513480577`*^9},
 CellLabel->
  "In[1138]:=",ExpressionUUID->"11af9f01-a68f-42ce-bdbc-02d79369c4e4"]
}, Closed]],

Cell[CellGroupData[{

Cell["zero or single arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.6424097081923723`*^9, 3.642409740606626*^9}, {3.642410267272437*^9, 
  3.642410267927145*^9}, {3.642410444278577*^9, 3.6424104495979643`*^9}, {
  3.642428014536284*^9, 3.642428019181917*^9}, {3.653572585148328*^9, 
  3.653572610777544*^9}, {3.653573146846627*^9, 
  3.653573174113491*^9}},ExpressionUUID->"3718b131-165e-4010-ae9f-\
368d6fe8ed3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorProduct", "[", "___Rule", "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.653572535355571*^9, 3.653572557797969*^9}},
 CellLabel->
  "In[1139]:=",ExpressionUUID->"26374c47-f6fd-4aa7-b7b5-2163d74ac7d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorProduct", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "___Rule"}], "]"}], ":=", "op"}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.653572535355571*^9, 3.653572557797969*^9}, {
  3.653573156788829*^9, 3.65357316348361*^9}},
 CellLabel->
  "In[1140]:=",ExpressionUUID->"a6c97a38-4a68-450d-b4a2-03d09cd05c6d"]
}, Closed]],

Cell[CellGroupData[{

Cell["take not-operator factors outside the product", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.6424097081923723`*^9, 3.642409740606626*^9}, {3.642410267272437*^9, 
  3.642410267927145*^9}, {3.642410444278577*^9, 3.6424104495979643`*^9}, {
  3.642428014536284*^9, 3.642428019181917*^9}, {3.65772822951553*^9, 
  3.65772823216847*^9}},ExpressionUUID->"5a09388b-47cc-45b6-8395-\
9ad0f30d8ce0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"args", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Checked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}], "&&", 
     RowBox[{"Or", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"#", ",", 
            RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}], "&"}], "/@", 
        RowBox[{"{", "args", "}"}]}], ")"}]}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops", ",", "notops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ops", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"{", "args", "}"}], ",", 
          RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"notops", "=", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"{", "args", "}"}], ",", "ops"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Times", "@@", "notops"}], ")"}], " ", "\[Times]", 
        RowBox[{"OperatorProduct", "[", 
         RowBox[{
          RowBox[{"Sequence", "@@", "ops"}], ",", "opts"}], "]"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6424078736177187`*^9, 3.642407912392056*^9}, {
   3.642408465126595*^9, 3.642408465715047*^9}, {3.642408547064198*^9, 
   3.642408562164834*^9}, {3.6424093806287107`*^9, 3.642409422137093*^9}, {
   3.642409743291583*^9, 3.6424097470566998`*^9}, {3.642410271067712*^9, 
   3.642410421062729*^9}, {3.6424104688887053`*^9, 3.642410571103561*^9}, {
   3.642410751666319*^9, 3.642410760726427*^9}, {3.6577280252667723`*^9, 
   3.657728070369637*^9}, 3.699276879283709*^9},
 CellLabel->
  "In[1141]:=",ExpressionUUID->"d34f093f-5c17-426f-99b8-ad15fdf82cdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"ops1___", ",", "\[IndentingNewLine]", 
      RowBox[{"HoldPattern", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"n1", ":", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}], ",", 
          RowBox[{"op_", "?", "OperatorQ"}], ",", 
          RowBox[{"n2", ":", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_", "?", "OperatorQ"}], "]"}], "..."}]}]}], "]"}], "|", 
        
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"n1", ":", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_", "?", "OperatorQ"}], "]"}], "..."}]}], ",", 
          RowBox[{"op_", "?", "OperatorQ"}], ",", 
          RowBox[{"n2", ":", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ",", "ops2___"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{"n1", ",", "n2"}], "]"}], "\[Times]", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"ops1", ",", "op", ",", "ops2"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.652868153765564*^9, 3.6528682345416203`*^9}, {
  3.6577280915912447`*^9, 3.657728140476006*^9}, {3.657728170845961*^9, 
  3.657728212658358*^9}},
 CellLabel->
  "In[1142]:=",ExpressionUUID->"11651901-35e2-42e1-a454-04668cb58f09"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle sums", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.6424097081923723`*^9, 3.6424097553863287`*^9}, {3.642431221541044*^9, 
  3.642431227258101*^9}, {3.642431935320258*^9, 3.642431936085956*^9}, {
  3.642432640409025*^9, 3.642432645521409*^9}, {3.642433021720895*^9, 
  3.642433022756447*^9}, {3.652878786855352*^9, 
  3.652878788822047*^9}},ExpressionUUID->"2df68b0c-046a-43dc-ad0b-\
0304b5e2577c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a___", ",", 
      RowBox[{"Plus", "[", 
       RowBox[{"ops", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], ")"}]}], "]"}], ",", 
      "b___", ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Plus", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"OperatorProduct", "[", 
         RowBox[{"a", ",", "#", ",", "b", ",", 
          RowBox[{"Checked", "\[Rule]", "False"}], ",", 
          RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}], "&"}], "/@", 
       RowBox[{"{", "ops", "}"}]}], ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407922092299*^9, 3.6424079336700287`*^9}, {
   3.64240846707758*^9, 3.642408467645212*^9}, {3.642408555829399*^9, 
   3.6424085658277273`*^9}, {3.642409757701359*^9, 3.642409758156438*^9}, 
   3.6424112891433277`*^9, {3.6424113650890293`*^9, 3.642411365324814*^9}, {
   3.642431236906835*^9, 3.642431355952772*^9}, {3.642431943258856*^9, 
   3.642432021350548*^9}, {3.642432701970482*^9, 3.642432705163595*^9}, {
   3.642433025509227*^9, 3.64243302699259*^9}, {3.652865935208968*^9, 
   3.652865938203548*^9}, {3.6577954427397957`*^9, 3.657795447578752*^9}},
 CellLabel->
  "In[1143]:=",ExpressionUUID->"3da5dc73-1109-4d56-a7e0-32ddbcfbef73"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle UnityOperator and NullOperator inside product", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.6424097081923723`*^9, 3.6424097553863287`*^9}, {3.642431308753224*^9, 
  3.642431315930655*^9}, {3.653572619380046*^9, 
  3.653572621952244*^9}},ExpressionUUID->"8e1c9d04-a54f-4f78-9dda-\
01bb23c2a078"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "___", "]"}], ",", "opts___Rule"}], 
     "]"}]}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.653572413930327*^9, 3.6535724257469797`*^9}},
 CellLabel->
  "In[1144]:=",ExpressionUUID->"b776ec88-c145-4134-91c2-c2285336efe6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{"a___", ",", 
       RowBox[{"UnityOperator", "[", "___", "]"}], ",", "b__", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Checked", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", "b", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407922092299*^9, 3.6424079336700287`*^9}, {
   3.64240846707758*^9, 3.642408467645212*^9}, {3.642408555829399*^9, 
   3.6424085658277273`*^9}, {3.642409757701359*^9, 3.642409758156438*^9}, 
   3.6424112891433277`*^9, {3.6424113650890293`*^9, 3.642411365324814*^9}, 
   3.653572394013391*^9},
 CellLabel->
  "In[1145]:=",ExpressionUUID->"4ca28bc9-50d4-4366-9857-292dd9f7c001"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{"a__", ",", 
       RowBox[{"UnityOperator", "[", "___", "]"}], ",", "b___", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Checked", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", "b", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407922092299*^9, 3.6424079336700287`*^9}, {
   3.64240846707758*^9, 3.642408467645212*^9}, {3.642408555829399*^9, 
   3.6424085658277273`*^9}, {3.642409757701359*^9, 3.642409758156438*^9}, 
   3.6424112891433277`*^9, {3.6424113650890293`*^9, 3.642411365324814*^9}, {
   3.653572394013391*^9, 3.653572405427765*^9}},
 CellLabel->
  "In[1146]:=",ExpressionUUID->"705535fe-b9e7-4582-a30f-2d592a6d2b8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{"a___", ",", 
       RowBox[{"NullOperator", "[", "___", "]"}], ",", "b___", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Checked", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407941634304*^9, 3.642407947571169*^9}, {
   3.6424084688862753`*^9, 3.642408469421464*^9}, 3.642408558276486*^9, {
   3.642409761863984*^9, 3.642409762309844*^9}, 3.64241129555688*^9, {
   3.642411368420889*^9, 3.6424113686298637`*^9}},
 CellLabel->
  "In[1147]:=",ExpressionUUID->"af2e4587-c4a6-4d63-8c7f-aa1092f73e66"]
}, Closed]],

Cell[CellGroupData[{

Cell["expand nested OperatorProduct", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.6424097081923723`*^9, 3.6424097553863287`*^9}, {3.642431221541044*^9, 
  3.642431227258101*^9}},ExpressionUUID->"f9969d92-8a73-4e5d-bba5-\
746891b85a71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a___", ",", 
      RowBox[{"OperatorProduct", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "___Rule"}], 
       "]"}], ",", "b___", ",", "___Rule"}], "]"}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", "ops", ",", "b", ",", 
     RowBox[{"Checked", "\[Rule]", "False"}], ",", 
     RowBox[{"Sorted", "\[Rule]", "False"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407922092299*^9, 3.6424079336700287`*^9}, {
   3.64240846707758*^9, 3.642408467645212*^9}, {3.642408555829399*^9, 
   3.6424085658277273`*^9}, {3.642409757701359*^9, 3.642409758156438*^9}, 
   3.6424112891433277`*^9, {3.6424113650890293`*^9, 3.642411365324814*^9}, {
   3.642431236906835*^9, 3.642431355952772*^9}},
 CellLabel->
  "In[1148]:=",ExpressionUUID->"30da3a04-47f0-488f-9a2a-d0e23b0dd28d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{"a___", ",", 
       RowBox[{"NullOperator", "[", "___", "]"}], ",", "b___", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Checked", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642407941634304*^9, 3.642407947571169*^9}, {
   3.6424084688862753`*^9, 3.642408469421464*^9}, 3.642408558276486*^9, {
   3.642409761863984*^9, 3.642409762309844*^9}, 3.64241129555688*^9, {
   3.642411368420889*^9, 3.6424113686298637`*^9}},
 CellLabel->
  "In[1149]:=",ExpressionUUID->"86ab6424-f75d-4df8-8e4e-71c38bc8c0ab"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["validity check", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
   3.6424097081923723`*^9, 3.642409720089624*^9}, {3.642409810965137*^9, 
   3.642409815497567*^9}, {3.642411279983433*^9, 3.642411281725849*^9}, {
   3.642411480341838*^9, 3.6424115294781723`*^9}, {3.6424311931265783`*^9, 
   3.642431206035472*^9}, 
   3.657123164445835*^9},ExpressionUUID->"ca7f95a8-1c6c-4dbc-9672-\
304d888c1176"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Checked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}], "&&", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"{", "ops", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], "]"}]}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"ops", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Checked", "\[Rule]", "True"}], ",", "opts"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642409499516096*^9, 3.6424096820474586`*^9}},
 CellLabel->
  "In[1150]:=",ExpressionUUID->"f77d00ad-0190-45c2-9dc2-008803d3966e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Checked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", "ops", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], "]"}]}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorProduct", "::", "inval"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642409499516096*^9, 3.6424096820474586`*^9}, {
  3.642409827449506*^9, 3.642409844828059*^9}, {3.6424101997039948`*^9, 
  3.6424102195001574`*^9}, {3.6424106300544662`*^9, 3.6424106341930847`*^9}},
 CellLabel->
  "In[1151]:=",ExpressionUUID->"cd775143-4afb-410e-965a-61d325f3c7ae"]
}, Closed]],

Cell[CellGroupData[{

Cell["sort by InvolvedSpins", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
   3.6424097081923723`*^9, 3.6424097553863287`*^9}, {3.6424179763681717`*^9, 
   3.642417983471542*^9}, {3.6424275404497337`*^9, 3.6424275532435293`*^9}, 
   3.65712317374855*^9},ExpressionUUID->"e845ac04-2420-4ffd-a8c3-\
233a710959d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], ")"}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Checked", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"!", "Sorted"}], "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorProduct", "]"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"OperatorProduct", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sequence", "@@", 
         RowBox[{"Sort", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "ops", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"spins1", ",", "spins2"}], "}"}], ",", 
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"spins1", "=", 
                 RowBox[{"InvolvedSpins", "[", "#1", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"spins2", "=", 
                 RowBox[{"InvolvedSpins", "[", "#2", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"IntersectingQ", "[", 
                  RowBox[{"spins1", ",", "spins2"}], "]"}], "||", 
                 RowBox[{"SpinsOrderedQ", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"First", "@", "spins1"}], ",", 
                    RowBox[{"First", "@", "spins2"}]}], "}"}], "]"}]}]}], 
               "\[IndentingNewLine]", ")"}]}], "]"}], "&"}]}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sorted", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
          "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6424266711069937`*^9, 3.642426737501101*^9}, {
   3.642426807947295*^9, 3.642427060261991*^9}, {3.642427133466663*^9, 
   3.642427168345149*^9}, 3.642427395722509*^9, {3.642427444997677*^9, 
   3.642427490233458*^9}, 3.642427624591927*^9, {3.652877318997697*^9, 
   3.65287733314052*^9}, {3.652878447308432*^9, 3.652878473392146*^9}, {
   3.6528785592451773`*^9, 3.652878579764277*^9}, {3.652878705934741*^9, 
   3.652878731501845*^9}, {3.6528794064537287`*^9, 3.652879417456771*^9}, {
   3.6570962633240223`*^9, 3.657096266010251*^9}, 3.6570977301136293`*^9},
 CellLabel->
  "In[1152]:=",ExpressionUUID->"87e4ec5f-b93f-447f-93d9-83a2b66c08c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot combinations with Kets & Bras", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.657108247745591*^9, 
  3.657108288139979*^9}},ExpressionUUID->"54abde07-6883-44b7-8cd2-\
36fdc45ae141"],

Cell[CellGroupData[{

Cell["OperatorProduct.Ket", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
   3.504110447654697*^9, 3.504110452356811*^9}, 
   3.657794576486081*^9},ExpressionUUID->"3df672d2-aa45-4996-ba58-\
b865b3fca88b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorProduct", "/:", 
   RowBox[{"op_OperatorProduct", "[", 
    RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
   RowBox[{"op", ".", "ket"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590659844004518*^9, 3.590659881678423*^9}, {
  3.65710817034925*^9, 3.657108175279454*^9}},
 CellLabel->
  "In[1153]:=",ExpressionUUID->"b958ea90-6abe-49ff-b9f5-cfcdc5788a52"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorProduct", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"op_OperatorProduct", ",", 
     RowBox[{"ket_", "?", "KetQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", 
       RowBox[{
        RowBox[{"BasisKets", "[", "basis", "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"ket", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.6424090632591467`*^9}, {3.657107717190329*^9, 
   3.657107805508966*^9}, {3.657107897583373*^9, 3.6571079054546127`*^9}, {
   3.65710797061954*^9, 3.657107976969018*^9}, {3.657108178616334*^9, 
   3.657108197708095*^9}},
 CellLabel->
  "In[1154]:=",ExpressionUUID->"e8c87a51-255e-4437-8b1e-9411e37ec859"]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra.OperatorProduct", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
  3.504110834267372*^9}, {3.657794585028748*^9, 
  3.657794590909238*^9}},ExpressionUUID->"6e0881c5-ab63-4020-ad02-\
3cfc11224209"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorProduct", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"bra_", "?", "BraQ"}], ",", "op_OperatorProduct"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", 
       RowBox[{
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"bra", ",", "basis"}], "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"BasisBras", "[", "basis", "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.642409113476671*^9}, {3.657108037607176*^9, 
   3.657108047053022*^9}, {3.657108210661888*^9, 3.657108213595491*^9}, 
   3.657121872777618*^9},
 CellLabel->
  "In[1155]:=",ExpressionUUID->"0511a3bc-2f4a-43a6-a07e-d22b2cb012bd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra.OperatorProduct.Ket", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
   3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
   3.504110834267372*^9}, {3.6571080748132973`*^9, 3.657108079785739*^9}, 
   3.6571082793049393`*^9, {3.657121883529797*^9, 
   3.657121903197289*^9}},ExpressionUUID->"25456b50-2d16-43d9-81cf-\
f7d12ac54710"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorProduct", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"bra_", "?", "BraQ"}], ",", "op_OperatorProduct", ",", 
      RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", 
       RowBox[{
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"bra", ",", "basis"}], "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"ket", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.642409113476671*^9}, {3.657108037607176*^9, 
   3.657108047053022*^9}, {3.6571080839943647`*^9, 3.657108108240409*^9}, {
   3.657108218395646*^9, 3.6571082222106247`*^9}, {3.65710887965773*^9, 
   3.657108890206029*^9}, 3.657109499494361*^9, 3.6571218982324247`*^9},
 CellLabel->
  "In[1156]:=",ExpressionUUID->"5968530a-76c1-47a7-abf0-d28b39cef662"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct of consecutive Ket.Bra operators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
   3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
   3.504110834267372*^9}, {3.6571080748132973`*^9, 3.657108079785739*^9}, 
   3.6571082793049393`*^9, {3.657121883529797*^9, 3.657121903197289*^9}, {
   3.65779461777989*^9, 3.65779462196204*^9}, {3.657794674783904*^9, 
   3.657794687831318*^9}, {3.6577947194391937`*^9, 3.657794726158196*^9}, {
   3.6577947583329897`*^9, 3.657794762380398*^9}, {3.657794962398363*^9, 
   3.657794967852644*^9}},ExpressionUUID->"d9841b27-be26-433e-9258-\
5310a89f9d05"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{"ops1", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], "..."}], ")"}]}], ",", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"k1_", "?", "KetQ"}], ",", 
        RowBox[{"b1_", "?", "BraQ"}]}], "]"}], ",", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"k2_", "?", "KetQ"}], ",", 
        RowBox[{"b2_", "?", "BraQ"}]}], "]"}], ",", 
      RowBox[{"ops2", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"ops1", ",", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"k1", ",", "b2"}], "]"}], "*", 
      RowBox[{"Dot", "[", 
       RowBox[{"b1", ",", "k2"}], "]"}]}], ",", "ops2", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.642409113476671*^9}, {3.657108037607176*^9, 
   3.657108047053022*^9}, {3.6571080839943647`*^9, 3.657108108240409*^9}, {
   3.657108218395646*^9, 3.6571082222106247`*^9}, {3.65710887965773*^9, 
   3.657108890206029*^9}, 3.657109499494361*^9, 3.6571218982324247`*^9, {
   3.6577946971290092`*^9, 3.657794774269018*^9}, {3.657794845930331*^9, 
   3.657794954413312*^9}, {3.657795176358747*^9, 3.6577952002850447`*^9}},
 CellLabel->
  "In[1157]:=",ExpressionUUID->"58f0b07f-3d96-4fbb-8d50-790f42339111"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642407780111331*^9, 3.6424077810379*^9}, {
  3.64240784966448*^9, 3.642407859841761*^9}, {3.642407982345158*^9, 
  3.6424079892499123`*^9}, {3.642409781163155*^9, 
  3.642409782265377*^9}},ExpressionUUID->"f1f23358-35d9-41b4-84ed-\
c281ce628f79"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorProduct", "::", "inval"}], "=", 
   "\"\<OperatorProduct may only contain operators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642409788310604*^9, 3.6424098054330263`*^9}},
 CellLabel->
  "In[1158]:=",ExpressionUUID->"9b4c96d7-22f0-43c4-a595-3123fdaf62dc"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["InvolvedSpins", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.642407603580264*^9, 3.642407604682588*^9}, {3.642412729364107*^9, 
  3.6424127393237123`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"d68a38c1-f12b-4e2e-b733-5b0c7c5372a9"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642418233434713*^9, 3.642418255478641*^9}, {
  3.642418314690454*^9, 3.642418330954569*^9}, {3.642431736203846*^9, 
  3.6424317369853783`*^9}},ExpressionUUID->"6087220d-a90b-45de-b64a-\
83f370633b89"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"InvolvedSpins", "[", "\[IndentingNewLine]", 
     RowBox[{"HoldPattern", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1__", "?", "NumericQ"}], ",", 
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "|", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"n2__", "?", "NumericQ"}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", "]"}]}], ":=", 
   RowBox[{"InvolvedSpins", "[", "op", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6424317457895613`*^9, 3.642431788965705*^9}, {
  3.652867496865471*^9, 3.652867500695518*^9}, {3.6528676545019217`*^9, 
  3.652867664946368*^9}, {3.652867743697228*^9, 3.652867753078355*^9}, {
  3.652867810022572*^9, 3.652867812558816*^9}, {3.652867932131483*^9, 
  3.652867968316347*^9}, {3.652868010276966*^9, 3.652868015421628*^9}, {
  3.652868054610998*^9, 3.652868060171376*^9}},
 CellLabel->
  "In[1159]:=",ExpressionUUID->"a0ec8247-ba30-42fc-ae78-4154039100da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"InvolvedSpins", "[", 
     RowBox[{"Plus", "[", 
      RowBox[{"ops", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], ")"}]}], "]"}], "]"}]}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"InvolvedSpins", "/@", 
      RowBox[{"{", "ops", "}"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642431797195566*^9, 3.642431834685134*^9}, {
  3.642432879177127*^9, 3.642432880993919*^9}, {3.65286750543191*^9, 
  3.65286751128706*^9}},
 CellLabel->
  "In[1160]:=",ExpressionUUID->"5fd2392a-39f4-478a-b0ef-12c51bf6d24c"]
}, Closed]],

Cell[CellGroupData[{

Cell["opI, opR, UnityOperator, NullOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642418233434713*^9, 3.642418255478641*^9}, {
  3.642418314690454*^9, 3.642418330954569*^9}, {3.6424321077520113`*^9, 
  3.642432123640675*^9}},ExpressionUUID->"96fd8d0c-050d-4265-8699-\
29868b68036d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{
       RowBox[{"j", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", "___"}], "]"}]}], "]"}],
    ":=", 
   RowBox[{"{", "j", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642412764976428*^9, 3.642412770037573*^9}, {
  3.642412855645096*^9, 3.642412856853611*^9}, {3.6424129057470818`*^9, 
  3.6424129171402473`*^9}, {3.6424129667568407`*^9, 3.642412992520068*^9}},
 CellLabel->
  "In[1161]:=",ExpressionUUID->"0a2b571e-9ae3-4ffd-9bc4-cf952ef3eb50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"spins_List", ",", "___"}], "]"}]}], "]"}], ":=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642412764976428*^9, 3.642412770037573*^9}, {
  3.642412855645096*^9, 3.642412856853611*^9}, {3.6424129057470818`*^9, 
  3.6424129171402473`*^9}, {3.6424129667568407`*^9, 3.6424130057618837`*^9}},
 CellLabel->
  "In[1162]:=",ExpressionUUID->"72d0def5-cbad-409d-98fe-47ceabb84384"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opR", "[", 
      RowBox[{
       RowBox[{"j", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", "___"}], "]"}]}], "]"}],
    ":=", 
   RowBox[{"{", "j", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642412764976428*^9, 3.642412770037573*^9}, {
  3.642412855645096*^9, 3.642412856853611*^9}, {3.6424129057470818`*^9, 
  3.6424129171402473`*^9}, {3.6424129667568407`*^9, 3.642413014261739*^9}},
 CellLabel->
  "In[1163]:=",ExpressionUUID->"70320c00-2181-4add-bc79-edf032cd76c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opR", "[", 
      RowBox[{"spins_List", ",", "___"}], "]"}]}], "]"}], ":=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642412764976428*^9, 3.642412770037573*^9}, {
  3.642412855645096*^9, 3.642412856853611*^9}, {3.6424129057470818`*^9, 
  3.6424129171402473`*^9}, {3.6424129667568407`*^9, 3.642413017119974*^9}},
 CellLabel->
  "In[1164]:=",ExpressionUUID->"c4948e92-32db-471a-b737-546e4f69b5d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"UnityOperator", "[", "___", "]"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609635278153963`*^9, 3.460963538962474*^9}, 
   3.486464374126931*^9, {3.486464772268136*^9, 3.4864647742577267`*^9}, {
   3.6424130232669353`*^9, 3.6424130300890493`*^9}},
 CellLabel->
  "In[1165]:=",ExpressionUUID->"1a4d9393-11a2-4403-9d3d-7355a9872240"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"NullOperator", "[", "___", "]"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609635278153963`*^9, 3.460963538962474*^9}, 
   3.486464374126931*^9, {3.486464772268136*^9, 3.4864647742577267`*^9}, {
   3.6424130232669353`*^9, 3.642413037339364*^9}},
 CellLabel->
  "In[1166]:=",ExpressionUUID->"ed3c05c2-952c-4652-96c0-8568251f998b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exponentials of operators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642418233434713*^9, 3.642418255478641*^9}, {
  3.642418314690454*^9, 3.642418330954569*^9}, {3.6424321077520113`*^9, 
  3.642432123640675*^9}, {3.657122182278048*^9, 
  3.6571221872600613`*^9}},ExpressionUUID->"387044c8-c082-4b6a-8274-\
4e5ae37cd253"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"Exp", "[", 
     RowBox[{"op_", "?", "OperatorQ"}], "]"}], "]"}], ":=", 
   RowBox[{"InvolvedSpins", "[", "op", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6571222128368597`*^9, 3.6571222340522327`*^9}},
 CellLabel->
  "In[1167]:=",ExpressionUUID->"8a7aafb1-a9a2-4e29-843a-c73d147613a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"Power", "[", 
     RowBox[{"_", ",", 
      RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], "]"}], ":=", 
   RowBox[{"InvolvedSpins", "[", "op", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657122241124325*^9, 3.657122261955638*^9}},
 CellLabel->
  "In[1168]:=",ExpressionUUID->"a43134f2-9b85-4730-8eff-1d43c700081d"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642418233434713*^9, 
  3.642418266096583*^9}},ExpressionUUID->"2cf82fdb-4d89-4bc8-bf7a-\
785e1bd0d735"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
       "opts___Rule"}], "]"}]}], "]"}], ":=", 
   RowBox[{"SortBy", "[", 
    RowBox[{
     RowBox[{"Union", "@@", 
      RowBox[{"(", 
       RowBox[{"InvolvedSpins", "/@", 
        RowBox[{"{", "ops", "}"}]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"First", "/@", 
         RowBox[{"SpinSystem", "[", "]"}]}], ",", "#"}], "]"}], "&"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609635278153963`*^9, 3.460963538962474*^9}, 
   3.486464374126931*^9, {3.486464772268136*^9, 3.4864647742577267`*^9}, {
   3.6424130232669353`*^9, 3.6424131634044037`*^9}, {3.642413198364368*^9, 
   3.642413203006864*^9}, 3.642413346725298*^9, {3.642413439200783*^9, 
   3.642413442629237*^9}, {3.64241783364574*^9, 3.6424178463330107`*^9}, {
   3.642417905088345*^9, 3.642417907292894*^9}},
 CellLabel->
  "In[1169]:=",ExpressionUUID->"032b42ed-3df8-4e60-95c7-6fc7b30af47c"]
}, Closed]],

Cell[CellGroupData[{

Cell["default to all spins", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.642418233434713*^9, 3.642418277068747*^9}, {
  3.657122200453113*^9, 
  3.657122202435678*^9}},ExpressionUUID->"fe2c98cb-d212-490e-b517-\
39d596a2cd44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpins", "[", "_", "]"}], ":=", 
   RowBox[{"First", "/@", 
    RowBox[{"SpinSystem", "[", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642413453401362*^9, 3.6424134564442873`*^9}, {
  3.6571221926780367`*^9, 3.657122198580688*^9}},
 CellLabel->
  "In[1170]:=",ExpressionUUID->"de5fef4d-b274-4266-bb70-6f25cf8cb96d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorQ", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}},
 AspectRatioFixed->True,
 ExpressionUUID -> "059f087b-122b-481e-a2d0-f151845f8bfd"],

Cell["\<\
an expression is identified as an operator if it contains somewhere an \
operator pattern, and if it does not contain a superoperator pattern. The \
SuperoperatorPattern is set later in the NMR`SpinSuperoperators package. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6184004059333363`*^9, 
  3.6184004769839363`*^9}},ExpressionUUID->"af692b49-5a56-433e-90e4-\
8f8a8d765918"],

Cell["\<\
the order of coding needs care here to allow evaluation of complex \
expressions in a reasonable amount of time\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.618490426630177*^9, 
  3.6184904615960083`*^9}},ExpressionUUID->"aa0aff2a-17b0-4e44-937d-\
91c98bb713cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", "$Failed", "]"}], "=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}},
 CellLabel->
  "In[1171]:=",ExpressionUUID->"4ebc83f5-2fcc-4eb4-a38a-0f0a528ce3a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorQ", "[", 
     RowBox[{"op", ":", "OperatorPattern"}], "]"}], "=", "True"}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.448291603371173*^9}, 
   3.4482916532125387`*^9, {3.4482919449213467`*^9, 3.448291948948346*^9}, {
   3.4483073628982487`*^9, 3.44830737590583*^9}, {3.46029604233991*^9, 
   3.4602960581072493`*^9}, {3.460713408399292*^9, 3.460713488612462*^9}, {
   3.46730202018169*^9, 3.467302024667384*^9}, 3.486464311886015*^9, {
   3.486464425290256*^9, 3.4864644258236713`*^9}, 3.486710915498262*^9, {
   3.502279336401613*^9, 3.502279343423003*^9}, 3.502283880478002*^9, {
   3.5041098948148813`*^9, 3.504109900828328*^9}, {3.5319271887394047`*^9, 
   3.5319271951755123`*^9}, {3.590399320798667*^9, 3.590399336231336*^9}, {
   3.6166919691090403`*^9, 3.6166920317396297`*^9}, {3.616692151958355*^9, 
   3.616692163211773*^9}, {3.61847632286476*^9, 3.618476326175391*^9}, {
   3.6184766854526577`*^9, 3.618476688404567*^9}},
 CellLabel->
  "In[1172]:=",ExpressionUUID->"8228d128-714b-4089-826d-b9f08fa1d923"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorQ", "[", "notop_", "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"notop", ",", "OperatorPattern"}], "]"}]}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.617537444261169*^9, 3.617537466649164*^9}},
 CellLabel->
  "In[1173]:=",ExpressionUUID->"27fc1392-6fc7-4efc-9fff-fa4124a0cd0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OperatorQ", "[", "failed_", "]"}], "/;", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"failed", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
   ";"}], " "}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}, {
  3.6184010723182907`*^9, 3.618401094932248*^9}, {3.618476315091374*^9, 
  3.618476320153434*^9}, {3.618476679126749*^9, 3.618476682686364*^9}},
 CellLabel->
  "In[1174]:=",ExpressionUUID->"9232a151-6a6f-4f25-b927-d3f63e9d3b40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorQ", "[", 
     RowBox[{"Exp", "[", "x_", "]"}], "]"}]}], ":=", 
   RowBox[{"OperatorQ", "[", "x", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.4482916413145857`*^9}, 
   3.4483076540074883`*^9},
 CellLabel->
  "In[1175]:=",ExpressionUUID->"2558fe22-fe66-4ec2-aa58-ef42f31a1d4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorQ", "[", 
     RowBox[{"E", "^", "x_"}], "]"}]}], ":=", 
   RowBox[{"OperatorQ", "[", "x", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.4482916413145857`*^9}, 
   3.4483076540074883`*^9, {3.4483078876454773`*^9, 3.4483078921151247`*^9}},
 CellLabel->
  "In[1176]:=",ExpressionUUID->"711d6da1-77ff-4a1f-b2e5-acc80c9bbb54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Plus", "[", 
      RowBox[{
       RowBox[{"_", "?", "OperatorQ"}], ".."}], "]"}]}], "]"}], "=", "True"}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692211636157*^9, 3.6166922242134047`*^9}, {
  3.616692264597652*^9, 3.616692265413906*^9}, {3.617536967247057*^9, 
  3.6175369714990673`*^9}, {3.6184911669674664`*^9, 3.618491177716484*^9}, {
  3.618492002359714*^9, 3.618492002901271*^9}},
 CellLabel->
  "In[1177]:=",ExpressionUUID->"63616575-7b2d-4ed2-9f64-64b4414038cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", "_OperatorProduct", "]"}], "=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448346191784813*^9, 3.448346221418975*^9}, {
   3.6166761818254642`*^9, 3.6166761851749783`*^9}, {3.616676258810763*^9, 
   3.6166762617923813`*^9}, {3.616692065277183*^9, 3.616692088382155*^9}, 
   3.616754612346336*^9, {3.617536982073863*^9, 3.617536986395844*^9}, {
   3.6184911911493807`*^9, 3.618491194850061*^9}, {3.618492006412426*^9, 
   3.618492006885447*^9}, 3.642408858067275*^9, 3.642427942568521*^9},
 CellLabel->
  "In[1178]:=",ExpressionUUID->"05799ba7-94cd-4959-bfe4-aee13064f4f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ket_", "?", "KetQ"}], ",", 
       RowBox[{"bra_", "?", "BraQ"}]}], "]"}]}], "]"}], "=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448346191784813*^9, 3.448346221418975*^9}, {
   3.448352415637928*^9, 3.448352457347082*^9}, {3.6175369947541323`*^9, 
   3.6175370003803596`*^9}, {3.618491222935028*^9, 3.618491256057892*^9}, 
   3.61849129836701*^9, 3.642408865217616*^9},
 CellLabel->
  "In[1179]:=",ExpressionUUID->"66c94c58-25b7-4129-b03a-431eeac9a4be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{"ops1___", ",", 
       RowBox[{"ket_", "?", "KetQ"}], ",", 
       RowBox[{"bra_", "?", "BraQ"}], ",", "ops2___"}], "]"}]}], "]"}], ":=", 
   
   RowBox[{"OperatorQ", "[", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"ops1", ",", "ops2"}], "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448346191784813*^9, 3.448346221418975*^9}, {
   3.448352415637928*^9, 3.448352457347082*^9}, {3.6175369947541323`*^9, 
   3.6175370003803596`*^9}, {3.618491222935028*^9, 3.618491231545535*^9}, {
   3.618491268203573*^9, 3.618491281721483*^9}, 3.642408888610545*^9},
 CellLabel->
  "In[1180]:=",ExpressionUUID->"21f50e7e-6992-4010-ba57-991f3ec38bae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", "x___", "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", 
    RowBox[{
     RowBox[{"Count", "[", 
      RowBox[{
       RowBox[{"{", "x", "}"}], ",", 
       RowBox[{"_", "?", "OperatorQ"}]}], "]"}], ",", "\[IndentingNewLine]", 
     "1", ",", "True", ",", "\[IndentingNewLine]", "0", ",", "False", ",", 
     "\[IndentingNewLine]", "_", ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"OperatorQ", "::", "badoptimes"}], "]"}], ";", "$Failed"}], 
      ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692211636157*^9, 3.6166922242134047`*^9}, {
   3.617536951103672*^9, 3.617536956614582*^9}, {3.618491354953199*^9, 
   3.618491384966316*^9}, {3.61849228844678*^9, 3.618492387345748*^9}, 
   3.61849246998508*^9, {3.618492523458539*^9, 3.618492536974676*^9}, {
   3.62150922050622*^9, 3.621509221836413*^9}},
 CellLabel->
  "In[1181]:=",ExpressionUUID->"85b10a75-5dfd-4f5e-acaa-a61ea017ba77"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"OperatorQ", "[", "notop_", "]"}], ":=", 
    RowBox[{"False", "/;", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{
       "notop", ",", "NMR`SpinSuperoperators`Private`SuperoperatorPattern"}], 
       "]"}]}]}]}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.617537444261169*^9, 3.617537466649164*^9}, {
  3.6184005153559933`*^9, 3.618400534618684*^9}, {3.618476329112005*^9, 
  3.61847633275846*^9}, {3.618476690886312*^9, 3.61847671800784*^9}},
 CellLabel->
  "In[1182]:=",ExpressionUUID->"05025a52-d302-4212-8c8e-8d6689cbc99e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "[", "notop_", "]"}], ":=", "False"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.617537444261169*^9, 3.617537466649164*^9}, {
  3.618401044861747*^9, 3.618401049002532*^9}, {3.6184011486415033`*^9, 
  3.618401151581197*^9}, {3.618476340550208*^9, 3.618476343518527*^9}, {
  3.618476700789652*^9, 3.618476705237589*^9}},
 CellLabel->
  "In[1183]:=",ExpressionUUID->"d98c4dec-7024-4364-be52-f1e7ddc4a9ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorQ", "::", "badoptimes"}], "=", 
   "\"\<An illegal Times product of operators has been detected.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.618492403747301*^9, 3.618492436360731*^9}, 
   3.618492540698715*^9},
 CellLabel->
  "In[1184]:=",ExpressionUUID->"aaeb0515-394a-4540-8eff-0ff8139745e4"]
}, Closed]],

Cell[CellGroupData[{

Cell["NDiagonalize applied to operators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460868924111771*^9, 3.4608689296052017`*^9}, {
  3.5860804276808357`*^9, 
  3.586080439135602*^9}},ExpressionUUID->"ff4e62aa-117c-49fd-be1e-\
da3fde17cbd8"],

Cell[CellGroupData[{

Cell["use current Basis[] if missing", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 
  3.5860805202765512`*^9}},ExpressionUUID->"2aa6c1df-3703-4164-a1f6-\
0f49d4acbd3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NDiagonalize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860804424244223`*^9, 3.5860804854713793`*^9}},
 CellLabel->
  "In[1185]:=",ExpressionUUID->"57c3e4e0-82e4-4a26-b479-c7e4d9427244"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to Operator in prediagonalized form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
  3.586080775767825*^9, 3.5860808057898197`*^9}, {3.586082399407514*^9, 
  3.586082408223261*^9}, {3.5860851524986887`*^9, 
  3.586085155159286*^9}},ExpressionUUID->"388c3f4a-562a-44cf-a0bc-\
178ebe6d7814"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
       "opopts___Rule"}], "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", "basis", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opopts", ",", "opts"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080623025322*^9, 3.586080693204924*^9}, {
  3.5860823454200897`*^9, 3.5860823814112043`*^9}},
 CellLabel->
  "In[1186]:=",ExpressionUUID->"01baf43e-bda2-4a89-81b4-ee0024182ade"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
       "opopts___Rule"}], "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"basis", ",", "opbasis"}], "]"}], ".", "X"}], "]"}], ",", 
       "\[IndentingNewLine]", "evals", ",", "\[IndentingNewLine]", 
       RowBox[{"Chop", "[", 
        RowBox[{"Xinv", ".", 
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"opbasis", ",", "basis"}], "]"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", "basis", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opopts", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080496491189*^9, 3.586080507239616*^9}, {
   3.5860805525626087`*^9, 3.586080618077929*^9}, {3.586080719050084*^9, 
   3.5860807894266167`*^9}, {3.586082275344873*^9, 3.58608228887719*^9}, 
   3.586082388633078*^9},
 CellLabel->
  "In[1187]:=",ExpressionUUID->"4bb382d1-6814-4ca2-903d-3ab1baf8428e"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to Operator in non-prediagonalized form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
  3.586080775767825*^9, 3.5860808057898197`*^9}, {3.586082399407514*^9, 
  3.586082422432811*^9}, {3.586085159331418*^9, 
  3.586085160824873*^9}},ExpressionUUID->"733111df-4415-4fe1-a3e6-\
afc8acf09694"],

Cell["\<\
If NDiagonalize is used with Assumptions\[Rule]Automatic, the OperatorType is \
used to determine the assumptions for OrthogonalEigenvectors. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5860829603371773`*^9, 
  3.586082993483173*^9}},ExpressionUUID->"ff1a9134-e265-42fa-81a9-\
2f93838facca"],

Cell["\<\
If NDiagonalize is used with Assumptions\[Rule]{a\[Rule]b..}, or Assumptions\
\[Rule]None or False, these rules supersede any based on the OperatorType.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5860829603371773`*^9, 3.586082993483173*^9}, {
  3.58608341045536*^9, 3.586083433732214*^9}, {3.586083500890614*^9, 
  3.586083505242344*^9}, {3.5860850051935377`*^9, 3.586085013254365*^9}, {
  3.5860887513783007`*^9, 
  3.586088767338917*^9}},ExpressionUUID->"4125cdb2-f5fb-4eb6-9144-\
e5e7f568d74f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"mat_", "?", "MatrixQ"}], ",", "basis_", ",", 
       "opopts___Rule"}], "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass1", ",", "ass2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ass1", "=", 
        RowBox[{
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "NDiagonalize", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ass2", "=", 
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{"ass1", ",", "\[IndentingNewLine]", 
          RowBox[{"None", "|", "False"}], ",", "False", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"_Rule", "..."}], "}"}], ",", "ass1", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Automatic", "|", "True"}], ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
            "OrthogonalEigenvectors", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"OperatorType", "/.", 
                 RowBox[{"{", "opopts", "}"}]}], "/.", 
                RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{
               "\"\<Hermitian\>\"", "|", "\"\<Unitary\>\"", "|", 
                "\"\<AntiHermitian\>\"", "|", "\"\<Normal\>\""}], ",", "True",
                ",", "\[IndentingNewLine]", "\t", "_", ",", "False"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"Cases", "[", 
              RowBox[{"ass1", ",", "_Rule"}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "_", ",",
           "None"}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
          RowBox[{"mat", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Assumptions", "\[Rule]", "ass2"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "basis", 
         ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{"opopts", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080623025322*^9, 3.586080693204924*^9}, {
  3.5860823454200897`*^9, 3.5860823814112043`*^9}, {3.586082428541574*^9, 
  3.586082730213779*^9}, {3.586082765132083*^9, 3.58608281869175*^9}, {
  3.5860828966497297`*^9, 3.586082926435439*^9}, {3.586083007680859*^9, 
  3.586083337228908*^9}, {3.586083440708686*^9, 3.586083575968532*^9}, {
  3.58608363229034*^9, 3.58608363933254*^9}, {3.586083888757841*^9, 
  3.5860839046690493`*^9}, {3.58608460907589*^9, 3.586084617680365*^9}, {
  3.586084736209659*^9, 3.586084755345783*^9}, {3.586084803159905*^9, 
  3.586084804820221*^9}},
 CellLabel->
  "In[1188]:=",ExpressionUUID->"0bbb0f71-9a8b-4ef5-9aca-440d9b0399c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to a general operator expression", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
  3.586080775767825*^9, 3.586080826903056*^9}, {3.58608517312304*^9, 
  3.586085180744526*^9}},ExpressionUUID->"d3576d66-a9ff-48bc-b235-\
9e5df950c68d"],

Cell["convert to Operator form. ", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586334195177527*^9, 
  3.5863341990961533`*^9}},ExpressionUUID->"3e4ba35e-d891-4805-be3b-\
07344d73802a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}], ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860808358429127`*^9, 3.586080885111555*^9}, {
  3.586083599118425*^9, 3.586083628851824*^9}},
 CellLabel->
  "In[1189]:=",ExpressionUUID->"af1e138f-3e49-4110-83c5-e8500f259243"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorType", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
   3.4602943668599854`*^9, 3.4602943676744823`*^9}, {3.502278447248674*^9, 
   3.502278473574972*^9}, 3.502283881676605*^9, 3.5041102136566563`*^9, {
   3.583412336036195*^9, 
   3.5834123367302322`*^9}},ExpressionUUID->"d5664281-2330-4318-a0c4-\
615b79a52038"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 
  3.583413168774453*^9}},ExpressionUUID->"43393e7e-7384-47b6-ab58-\
b8005a156ee9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ValidOperatorTypes", "=", 
   RowBox[{"{", 
    RowBox[{
    "Undefined", ",", "None", ",", "\"\<Hermitian\>\"", ",", 
     "\"\<Unitary\>\"", ",", "\"\<AntiHermitian\>\"", ",", "\"\<Normal\>\""}],
     "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832812183824*^9, 3.531832823276425*^9}, {
  3.5628964682426167`*^9, 3.56289647545964*^9}, {3.586253485464966*^9, 
  3.586253489953916*^9}},
 CellLabel->
  "In[1190]:=",ExpressionUUID->"d77fee1e-4fb3-4692-9368-2c3439b00da1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorType", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"OperatorType", "\[Rule]", "Undefined"}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.583412571973632*^9, 3.583412590342128*^9}, {
  3.586253480981488*^9, 3.586253483040165*^9}},
 CellLabel->
  "In[1191]:=",ExpressionUUID->"f2cba993-a1e8-4a96-81e8-a0835875b71e"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to an Operator with an undetermined type", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.5834132059134827`*^9}, {
  3.583413335297845*^9, 3.583413338630453*^9}, {3.5862535944309597`*^9, 
  3.5862535992612143`*^9}, {3.586253785010515*^9, 
  3.586253787288829*^9}},ExpressionUUID->"9f54f249-d9a0-4a89-8974-\
aae4e7e1b04f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorType", "[", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"args", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
       "opopts___Rule"}], "]"}], "]"}]}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"OperatorType", "/.", 
       RowBox[{"{", "opopts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Operator", "]"}]}], ",", "Undefined"}], 
    "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"OperatorType", "[", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{"args", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CheckOperatorType", "\[Rule]", "True"}], ",", 
       "\[IndentingNewLine]", "opopts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862536190320272`*^9, 3.586253648896201*^9}, 
   3.5862538000015306`*^9},
 CellLabel->
  "In[1192]:=",ExpressionUUID->"1597c015-b340-4390-8249-5762e6652fe6"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to an Operator with a predetermined type", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.5834132059134827`*^9}, {
  3.583413335297845*^9, 3.583413338630453*^9}, {3.5862535944309597`*^9, 
  3.5862535992612143`*^9}},
 ExpressionUUID -> "c91c0eac-8055-4d7a-b437-9792106c084f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorType", "[", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"args", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "opopts___Rule"}], "]"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OperatorType", "/.", 
         RowBox[{"{", "opopts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ",", "Undefined"}], 
      "]"}]}]}], ":=", 
   RowBox[{
    RowBox[{"OperatorType", "/.", 
     RowBox[{"{", "opopts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "OperatorType", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412512271796*^9, 3.583412569063368*^9}, {
   3.58341306746511*^9, 3.5834130844516*^9}, {3.583413439090166*^9, 
   3.5834134671439238`*^9}, 3.5834137983428783`*^9, 3.58341389338378*^9, {
   3.58341449067338*^9, 3.583414497680468*^9}, 3.586253566300415*^9, {
   3.586253669306662*^9, 3.586253695474916*^9}, {3.5862538251089067`*^9, 
   3.586253828330863*^9}},
 CellLabel->
  "In[1193]:=",ExpressionUUID->"94974e8d-3cb8-47c1-b089-967bef380a02"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
general operator: determine the matrix representation and hence the type\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.583413222545339*^9}, {
   3.583414650805183*^9, 3.5834146587227917`*^9}, 3.5862537240870543`*^9},
 ExpressionUUID -> "a28557fb-4f3d-4589-82cb-13e746466fc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorType", "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], ":=", 
   RowBox[{"OperatorType", "[", 
    RowBox[{"Operator", "[", "op", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412597879341*^9, 3.5834126223318644`*^9}, {
  3.583413090127305*^9, 3.583413111299485*^9}, {3.5862537280756607`*^9, 
  3.586253742512249*^9}},
 CellLabel->
  "In[1194]:=",ExpressionUUID->"6f8f015a-8771-42fa-9227-73d05725c034"]
}, Closed]],

Cell[CellGroupData[{

Cell["not an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.5834132310652742`*^9}, {
  3.586253756768663*^9, 
  3.5862537572146873`*^9}},ExpressionUUID->"5015e59c-bf92-439b-a74b-\
de7c018ca3ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorType", "[", "op_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorType", "::", "notop"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.58341263142636*^9, 3.58341265394473*^9}, {
   3.583412730693365*^9, 3.583412733218794*^9}, 3.583412815142377*^9},
 CellLabel->
  "In[1195]:=",ExpressionUUID->"efdeb49d-2f6e-4d91-81ea-f4b57877f659"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorType", "::", "notop"}], "=", 
   "\"\<OperatorType may only be applied to an operator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5834126708346252`*^9, 3.5834126820838127`*^9}, {
  3.583413151453767*^9, 3.583413151761055*^9}},
 CellLabel->
  "In[1196]:=",ExpressionUUID->"979e856f-3d14-4887-8994-4bce4ebc9855"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Operator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
   3.4602943668599854`*^9, 3.4602943676744823`*^9}, {3.502278447248674*^9, 
   3.502278473574972*^9}, 3.502283881676605*^9, 3.5041102136566563`*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"6af83384-24ba-4ccf-b887-aba7fba8a8a8"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829109549362*^9, 
  3.531829110545513*^9}},ExpressionUUID->"d8a7b4f0-7d97-4d2e-80e7-\
cf7b3c0322d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Operator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"CheckMatrixDimensions", "\[Rule]", "True"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"Expand", "\[Rule]", "False"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531829115388056*^9, 3.531829122195447*^9}, {
   3.531829153944689*^9, 3.5318291614527693`*^9}, {3.531829370012969*^9, 
   3.531829371993948*^9}, {3.531829626992532*^9, 3.531829632848418*^9}, {
   3.531829974115911*^9, 3.5318299747154818`*^9}, {3.532004931729095*^9, 
   3.532004935122451*^9}, 3.53200549600051*^9, {3.586253022154179*^9, 
   3.586253028750572*^9}, 3.58625341196922*^9, {3.64060357258549*^9, 
   3.640603581598177*^9}, {3.64060367512394*^9, 3.640603697403325*^9}, {
   3.691402141647896*^9, 3.691402153004957*^9}, {3.6914944786695633`*^9, 
   3.691494478980618*^9}},
 CellLabel->
  "In[1197]:=",ExpressionUUID->"da9df230-9d55-4efd-a193-327fbcad2526"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorTypeCheckDisableThreshold", "=", "32"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586157255893023*^9, 3.5861572572833157`*^9}, {
   3.586163733800481*^9, 3.586163733933466*^9}, {3.586163824422285*^9, 
   3.586163825915391*^9}, 3.586253452263859*^9},
 CellLabel->
  "In[1198]:=",ExpressionUUID->"91f3beb9-5d7b-49bb-bdf2-ca428d9ad2ca"]
}, Closed]],

Cell[CellGroupData[{

Cell["output format", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505845569522201*^9, 3.505845570577057*^9}, {
  3.691494484756959*^9, 
  3.691494485722968*^9}},ExpressionUUID->"2bc5b24c-79d8-4f99-b858-\
8719d4f5b3dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"mat_", "?", "MatrixQ"}], ",", "basis_", ",", "opts___Rule"}], 
      "]"}], "/;", 
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Expand", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ")"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"optype", ",", "assump"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"optype", "=", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Operator", "]"}]}], "]"}], "/.", 
         RowBox[{"str_String", "\[RuleDelayed]", 
          RowBox[{"\"\<\\\"\>\"", "<>", "str", "<>", "\"\<\\\"\>\""}]}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"assump", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "opts", "}"}]}], ")"}], "/.", 
         RowBox[{"str_String", "\[RuleDelayed]", 
          RowBox[{"\"\<\\\"\>\"", "<>", "str", "<>", "\"\<\\\"\>\""}]}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"\"\<Operator[<<..>>\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"MatchQ", "[", 
               RowBox[{"optype", ",", 
                TagBox["\"\<\\\"Undefined\\\"\>\"",
                 FullForm]}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"\"\<, OperatorType\[Rule]\>\"", "<>", "optype"}], ",", 
             "\[IndentingNewLine]", "\"\< \>\""}], "\[IndentingNewLine]", 
            "]"}], ",", "\n", "\t\t", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"MatchQ", "[", 
               RowBox[{"assump", ",", 
                RowBox[{"Assumptions", "|", 
                 RowBox[{"{", "}"}]}]}], "]"}]}], ",", "\[IndentingNewLine]", 
             
             RowBox[{"RowBox", "[", 
              RowBox[{"{", 
               RowBox[{"\"\<, Assumptions\[Rule]\>\"", ",", " ", 
                RowBox[{"ToBoxes", "[", "assump", "]"}]}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", "\"\< \>\""}], "\[IndentingNewLine]", 
            "]"}], ",", "\[IndentingNewLine]", "\"\<]\>\""}], 
          "\[IndentingNewLine]", "}"}], "]"}], "]"}]}], "\[IndentingNewLine]",
       ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.6405081729012947`*^9, 3.6405081856346684`*^9}, {3.640512749296908*^9, 
   3.640512755992692*^9}, {3.6914039960291233`*^9, 3.691403998859639*^9}, {
   3.691404147569351*^9, 3.69140418040114*^9}, {3.691404212630013*^9, 
   3.691404365992893*^9}, 3.691404426936887*^9, {3.691404495308589*^9, 
   3.691404502919059*^9}, {3.691404536983047*^9, 3.6914045372998753`*^9}, {
   3.691404772149878*^9, 3.691404785238291*^9}, {3.691404822556406*^9, 
   3.6914048528203917`*^9}, {3.691404897514749*^9, 3.6914049037447557`*^9}, {
   3.691404967092758*^9, 3.691404969342258*^9}, {3.691405026686242*^9, 
   3.6914050530843277`*^9}, {3.691405170083253*^9, 3.691405194090028*^9}, {
   3.6914052635546637`*^9, 3.691405292323552*^9}, {3.691405412535537*^9, 
   3.691406053035727*^9}, {3.69140608851612*^9, 3.6914061253368883`*^9}, {
   3.691406168630381*^9, 3.691406176267083*^9}, {3.6914062421194153`*^9, 
   3.6914062766808043`*^9}, {3.6914063473075237`*^9, 3.691406467173277*^9}, {
   3.691406545815219*^9, 3.691406557493116*^9}, {3.691406629307239*^9, 
   3.691406669648456*^9}, 3.6914068221469793`*^9, {3.691406875604012*^9, 
   3.691406878562442*^9}, {3.691407057929446*^9, 3.6914071224192963`*^9}, {
   3.691494505197455*^9, 3.691494514212961*^9}, {3.691494764626514*^9, 
   3.691494767170369*^9}, {3.699260767880973*^9, 3.699260770972433*^9}, {
   3.6992616793398*^9, 3.6992616842971497`*^9}},
 CellLabel->
  "In[1199]:=",ExpressionUUID->"8722d74d-897f-4152-89cc-fd6ad69da9d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}], "/;", 
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Expand", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ")"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "optype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"optype", "=", 
        RowBox[{
         RowBox[{"OperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Operator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<Operator[DiagonalizedForm[<<..\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "X", "]"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{
           "ToBoxes", "[", "\"\<..>>], OperatorType\[Rule]\>\"", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "optype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "optype", "<>", "\"\<\\\"\>\""}], 
              "]"}], ",", "optype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.5860818707442207`*^9, 3.5860819891260443`*^9}, {3.586091150097787*^9, 
   3.5860911538293056`*^9}, {3.586091224235527*^9, 3.586091225063562*^9}, 
   3.5860914747156363`*^9, {3.691494521465683*^9, 3.6914945353082123`*^9}, {
   3.691494770256886*^9, 3.6914947727051163`*^9}, {3.699260774338826*^9, 
   3.69926077826263*^9}, {3.69926168667175*^9, 3.6992616900345793`*^9}},
 CellLabel->
  "In[1200]:=",ExpressionUUID->"9a822cf2-b2dc-4c7d-b6f1-4286aecf985a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Expand", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 3.5522104203335*^9}, {
  3.5522104538300877`*^9, 3.552210457491542*^9}, {3.684038007663995*^9, 
  3.6840380089830313`*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"005e43df-25f5-4692-a7bd-71ad47cb39b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Expand", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Expand", "[", "a_", "]"}], "/;", 
      RowBox[{"!", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"a", ",", "_Operator"}], "]"}]}]}], ":=", 
     RowBox[{"a", "/.", 
      RowBox[{"{", 
       RowBox[{"op_Operator", ":>", 
        RowBox[{"Expand", "[", "op", "]"}]}], "}"}]}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6831189892754908`*^9, 3.683119052512022*^9}, {
  3.68311930129748*^9, 3.683119310848708*^9}, {3.684039119191174*^9, 
  3.684039184058563*^9}, {3.691494561010508*^9, 3.691494578656023*^9}, {
  3.745400082403303*^9, 
  3.745400093196261*^9}},ExpressionUUID->"29372d57-16a5-4a2f-a6f3-\
b39e2537557c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Expand", "[", 
     RowBox[{"Operator", "[", 
      RowBox[{"args___", ",", "opts___Rule"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{"args", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"Expand", "\[Rule]", "True"}], ",", "opts"}], "]"}]}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409242047933*^9}, {3.459411835080905*^9, 3.4594118370779*^9}, 
   3.4594277811731243`*^9, {3.459427811773448*^9, 3.459427814043268*^9}, {
   3.543516067337283*^9, 3.54351607152363*^9}, {3.5435161166946297`*^9, 
   3.543516150245316*^9}, {3.543944472977648*^9, 3.5439444878167267`*^9}, {
   3.5522103412226353`*^9, 3.552210366421303*^9}, {3.564575196019809*^9, 
   3.56457526757395*^9}, {3.564575331857535*^9, 3.5645753321442413`*^9}, 
   3.5645753719636707`*^9, {3.616751552311964*^9, 3.6167515604540777`*^9}, {
   3.684037961099319*^9, 3.684038061733614*^9}, {3.684038502504335*^9, 
   3.684038504165616*^9}, {3.6914945894012547`*^9, 3.691494595888957*^9}, {
   3.744606866637566*^9, 3.744606872668762*^9}, 
   3.744607100976372*^9},ExpressionUUID->"d4cda80a-0b2b-4891-a35b-\
debe21baffb7"],

Cell[BoxData[
 RowBox[{"Operator", "/:", 
  RowBox[{"HoldPattern", "[", 
   RowBox[{"ExpandAll", "[", 
    RowBox[{"Operator", "[", 
     RowBox[{"args___", ",", "opts___Rule"}], "]"}], "]"}], "]"}], ":=", 
  RowBox[{"Operator", "[", 
   RowBox[{"args", ",", 
    RowBox[{"Evaluate", "@", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Expand", "\[Rule]", "True"}], ",", "opts"}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.744607105133255*^9},ExpressionUUID->"7747576f-b06e-406a-9ece-\
5674e9110c2b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
  3.5318324474638643`*^9}, {3.531832645834181*^9, 3.53183264655072*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"81a8acd3-fd02-422d-aa7d-7e019d18c6a1"],

Cell[CellGroupData[{

Cell["$Failed", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.621507950856588*^9, 
   3.621507952165382*^9}},ExpressionUUID->"704644c1-b216-48da-949a-\
e277ca584d1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Operator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5863372636394243`*^9, 3.586337294422628*^9}, {
  3.621507677072359*^9, 3.6215076905821753`*^9}},
 CellLabel->
  "In[1203]:=",ExpressionUUID->"061d21a3-b63e-4b93-85ad-ee1d21c61060"]
}, Closed]],

Cell[CellGroupData[{

Cell["missing basis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 
  3.5318294228297462`*^9}},ExpressionUUID->"bf4f1572-7c72-48e8-b3de-\
d128570da5af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504110223867132*^9, 3.504110239329947*^9}, {
  3.531829399398057*^9, 3.531829417365767*^9}},
 CellLabel->
  "In[1204]:=",ExpressionUUID->"dad47f85-14b7-4878-ba77-010a71673d94"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate OperatorType", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
  3.5318324474638643`*^9}},ExpressionUUID->"59036985-295b-4996-99cd-\
b94854506b0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{"args__", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "optype", "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Operator", "::", "badoptype"}], ",", "optype"}], "]"}], 
        ";", 
        RowBox[{"Operator", "[", 
         RowBox[{"args", ",", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"OperatorType", "\[Rule]", "None"}], ",", "opts"}], 
           "]"}]}], "]"}]}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Operator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MemberQ", "[", 
          RowBox[{"ValidOperatorTypes", ",", "optype"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832455811256*^9, 3.531832639106235*^9}, 
   3.531832827425124*^9},
 CellLabel->
  "In[1205]:=",ExpressionUUID->"f3969702-7a3b-460a-b84b-85ca4b6c2e6d"]
}, Closed]],

Cell[CellGroupData[{

Cell["conversion of a number to a multiple of UnityOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9},ExpressionUUID->"9a81d00c-7064-4baf-9369-\
a707c5c1477a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumericQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"num", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "basis", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
  3.531930036870233*^9, 3.531930061317379*^9}},
 CellLabel->
  "In[1206]:=",ExpressionUUID->"70418c31-92c1-4244-a290-343e18e5e939"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a null Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.621391001123641*^9, 
   3.621391020304655*^9}, {3.6392286104191227`*^9, 3.6392286111834993`*^9}, {
   3.6392286721302137`*^9, 
   3.6392286725669413`*^9}},ExpressionUUID->"ffd1d35e-df42-4fd1-95d9-\
54f92720cb7c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"Operator", "[", 
       RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"n1", "*", "n2"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639228633114435*^9, 3.639228661477323*^9}},
 CellLabel->
  "In[1207]:=",ExpressionUUID->"879ad803-6622-48af-a8a0-059e623bd0cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{"mat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ".."}], "}"}], ".."}], "}"}]}], ",", "more__", ",", 
      "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639228697297036*^9, 3.639228752696177*^9}, {
  3.639228872842642*^9, 3.6392288925100393`*^9}},
 CellLabel->
  "In[1208]:=",ExpressionUUID->"97f37c41-641b-4fe2-966c-54a017f6e812"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"X_", "?", "MatrixQ"}], ",", 
        RowBox[{"evals", ":", 
         RowBox[{"{", 
          RowBox[{"0", "..."}], "}"}]}], ",", 
        RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "more__", ",", 
      "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639228697297036*^9, 3.639228752696177*^9}, {
  3.6392288430509872`*^9, 3.639228859598022*^9}},
 CellLabel->
  "In[1209]:=",ExpressionUUID->"b64ed708-7e05-4bfc-8367-ad4477da655b"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a numeric multiple of Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.621391001123641*^9, 
   3.621391020304655*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"b8647cd0-a1b6-4c73-ac42-957a200beeb5"],

Cell["determine switches in OperatorType", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.562896775085047*^9, 3.562896782235318*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"5d6f411a-2591-434b-b44b-d394ffeb03a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"Operator", "[", 
       RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"OperatorType", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
      "\"\<Hermitian\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"ListQ", "[", "op", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "#", ",", "n2"}], "]"}], "&"}], ",", "op", ",", 
         
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"MatrixQ", "[", "op", "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "op", ",", "n2"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OperatorType", "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"Im", "[", 
             RowBox[{"Times", "[", 
              RowBox[{"n1", ",", "n2"}], "]"}], "]"}], "]"}], "\[Equal]", 
           "0"}], ",", "\"\<Hermitian\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"Re", "[", 
             RowBox[{"Times", "[", 
              RowBox[{"n1", ",", "n2"}], "]"}], "]"}], "]"}], "\[Equal]", 
           "0"}], ",", "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", 
          "True", ",", "\"\<Normal\>\""}], "\[IndentingNewLine]", "]"}]}], 
       ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.5628123736951847`*^9, 
   3.5628124081418457`*^9}, {3.562812608318014*^9, 3.562812615708728*^9}, {
   3.562812680581705*^9, 3.5628126996332006`*^9}, 3.562812771235929*^9, {
   3.56289642952281*^9, 3.562896728955058*^9}, {3.562897161561069*^9, 
   3.56289716182546*^9}, 3.562901273449699*^9, {3.58625306579806*^9, 
   3.586253102606102*^9}, {3.709185829165352*^9, 3.709185868062989*^9}, {
   3.709185913790778*^9, 3.709185938210601*^9}, {3.7091862723455524`*^9, 
   3.709186295637225*^9}, {3.744205912017178*^9, 3.744205912238826*^9}},
 Background->RGBColor[1, 1, 0],
 CellLabel->
  "In[1210]:=",ExpressionUUID->"b38b1604-b066-437a-9d72-bbfa58431aad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"Operator", "[", 
       RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"OperatorType", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
      "\"\<AntiHermitian\>\""}], "]"}]}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"ListQ", "[", "op", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "#", ",", "n2"}], "]"}], "&"}], ",", "op", ",", 
         
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"MatrixQ", "[", "op", "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "op", ",", "n2"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OperatorType", "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"Im", "[", 
             RowBox[{"Times", "[", 
              RowBox[{"n1", ",", "n2"}], "]"}], "]"}], "]"}], "\[Equal]", 
           "0"}], ",", "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"Re", "[", 
             RowBox[{"Times", "[", 
              RowBox[{"n1", ",", "n2"}], "]"}], "]"}], "]"}], "\[Equal]", 
           "0"}], ",", "\"\<Hermitian\>\"", ",", "\[IndentingNewLine]", 
          "True", ",", "\"\<Normal\>\""}], "\[IndentingNewLine]", "]"}]}], 
       ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.5628123736951847`*^9, 
   3.5628124081418457`*^9}, {3.562812608318014*^9, 3.562812615708728*^9}, {
   3.562812680581705*^9, 3.5628126996332006`*^9}, 3.562812771235929*^9, {
   3.56289642952281*^9, 3.5628967665177603`*^9}, {3.562897154897883*^9, 
   3.562897156393483*^9}, 3.562901277005725*^9, {3.586253119685417*^9, 
   3.5862531289606247`*^9}, 3.709185970974292*^9, {3.709186289935257*^9, 
   3.7091862929500227`*^9}, {3.709186332660834*^9, 3.709186336846057*^9}, {
   3.74420594971903*^9, 3.744205949910487*^9}},
 Background->RGBColor[1, 1, 0],
 CellLabel->
  "In[1211]:=",ExpressionUUID->"e78bd590-76f7-414a-97ab-8d62520d207e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"Operator", "[", 
       RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"OperatorType", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Operator", "]"}]}], ",", "\"\<Normal\>\""}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"ListQ", "[", "op", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "#", ",", "n2"}], "]"}], "&"}], ",", "op", ",", 
         
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"MatrixQ", "[", "op", "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "op", ",", "n2"}], "]"}]}], "]"}], ",", "more", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.5628123736951847`*^9, 
   3.5628124081418457`*^9}, {3.562812608318014*^9, 3.562812615708728*^9}, {
   3.562812680581705*^9, 3.5628126996332006`*^9}, 3.562812771235929*^9, {
   3.56289642952281*^9, 3.5628967665177603`*^9}, {3.5628968170961227`*^9, 
   3.56289683151512*^9}, {3.586253144000736*^9, 3.5862531503261833`*^9}, 
   3.7091859783108854`*^9, {3.709186307171968*^9, 3.70918630817684*^9}, {
   3.744205965366445*^9, 3.744205965534144*^9}},
 Background->RGBColor[1, 1, 0],
 CellLabel->
  "In[1212]:=",ExpressionUUID->"e2e904db-1378-492e-b699-5dcff472955a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"Operator", "[", 
       RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"OperatorType", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Operator", "]"}]}], ",", "\"\<Unitary\>\""}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"ListQ", "[", "op", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "#", ",", "n2"}], "]"}], "&"}], ",", "op", ",", 
         
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"MatrixQ", "[", "op", "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "op", ",", "n2"}], "]"}]}], "]"}], ",", "more", 
     ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OperatorType", "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{"Times", "[", 
               RowBox[{"n1", ",", "n2"}], "]"}], "]"}], "-", "1"}], "]"}], 
           "\[Equal]", "0"}], ",", "\"\<Unitary\>\"", ",", 
          "\[IndentingNewLine]", "True", ",", "\"\<Normal\>\""}], 
         "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", "opts"}],
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.5628123736951847`*^9, 
   3.5628124081418457`*^9}, {3.562812608318014*^9, 3.562812615708728*^9}, {
   3.562812680581705*^9, 3.5628126996332006`*^9}, 3.562812771235929*^9, {
   3.56289642952281*^9, 3.5628967665177603`*^9}, 3.562896864065795*^9, {
   3.562896906553437*^9, 3.5628969284144773`*^9}, {3.562897150091867*^9, 
   3.562897150337118*^9}, 3.5629012835957603`*^9, {3.5862531684585*^9, 
   3.586253173284863*^9}, 3.70918598458465*^9, {3.709186313610526*^9, 
   3.709186314538394*^9}, {3.744205961950626*^9, 3.744205962141122*^9}},
 Background->RGBColor[1, 1, 0],
 CellLabel->
  "In[1213]:=",ExpressionUUID->"5d7629ce-8be4-4f60-967c-813cd3e40045"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Times", "[", 
    RowBox[{
     RowBox[{"n1___", "?", "NumericQ"}], ",", 
     RowBox[{"Operator", "[", 
      RowBox[{"op_", ",", "more__", ",", "opts___Rule"}], "]"}], ",", 
     RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{"ListQ", "[", "op", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "#", ",", "n2"}], "]"}], "&"}], ",", "op", ",", 
         
         RowBox[{"{", "2", "}"}]}], "]"}], ",", 
       RowBox[{"MatrixQ", "[", "op", "]"}], ",", 
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "op", ",", "n2"}], "]"}]}], "]"}], ",", "more", 
     ",", 
     RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.5628123736951847`*^9, 
   3.5628124081418457`*^9}, {3.562812608318014*^9, 3.562812615708728*^9}, {
   3.562812680581705*^9, 3.5628126996332006`*^9}, 3.562812771235929*^9, {
   3.562896956919169*^9, 3.562896962627599*^9}, {3.5862531914755707`*^9, 
   3.5862531955440903`*^9}, 3.709185989530792*^9, 3.7091863194515324`*^9, {
   3.744205969013015*^9, 3.7442059691893578`*^9}},
 Background->RGBColor[1, 1, 0],
 CellLabel->
  "In[1214]:=",ExpressionUUID->"2e093ef5-5680-4ba3-bfd8-9951fef36f7b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Operator applied to InterpolationFunction forms", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.621391001123641*^9, 
   3.6213910383606586`*^9}, {3.621507372251388*^9, 
   3.621507398884102*^9}},ExpressionUUID->"c731911e-aaf6-4998-8f40-\
3c51311d702f"],

Cell["take numerical multiples into the InterpolatingFunction", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62150738507344*^9, 
  3.621507396501134*^9}},ExpressionUUID->"5adb252a-e140-4d22-921e-\
b69c4e0f146b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"mat_", "?", "MatrixQ"}], "\[RuleDelayed]", 
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "n2", ",", "mat"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}},
 CellLabel->
  "In[1215]:=",ExpressionUUID->"ae76b25c-ce3c-40b9-8c98-2fbb05b0eef3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
         RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"X_", "?", "MatrixQ"}], ",", "D_List", ",", 
           RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{"X", ",", 
           RowBox[{"Times", "[", 
            RowBox[{"n1", ",", "n2", ",", "D"}], "]"}], ",", "Xinv"}], 
          "}"}]}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.6213913702752523`*^9}, {
   3.6213915113800907`*^9, 3.621391520158724*^9}},
 CellLabel->
  "In[1216]:=",ExpressionUUID->"5d2b02ce-e1fd-49be-a983-5181c2372cc8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "n2", ",", "op"}], "]"}], "[", "t", "]"}]}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.6213913702752523`*^9}, {
   3.6213915113800907`*^9, 3.621391520158724*^9}, {3.621506915857224*^9, 
   3.621506998345965*^9}},
 CellLabel->
  "In[1217]:=",ExpressionUUID->"ceeb92e2-6ebd-4338-9e9d-519a5388f514"],

Cell["\<\
if the InterpolationFunction yields a symbolic operator form, convert into a \
matrix representation\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62150738507344*^9, 
  3.621507434612221*^9}},ExpressionUUID->"130ca77a-caa9-44eb-8385-\
d444ed6c7a88"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", "basis_",
        ",", "args___"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"op_", "?", "OperatorQ"}], "\[RuleDelayed]", 
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"op", ",", "basis", ",", "args"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}},
 CellLabel->
  "In[1218]:=",ExpressionUUID->"a590ee31-cfa0-485f-b274-4e86e0c99c9c"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 
   3.531929915726618*^9}},ExpressionUUID->"e0deb55b-57cb-49bf-97e3-\
f8f845406900"],

Cell["\<\
trigger an error if the argument of operator is not another operator, or a \
matrix, or the diagonalized form of a matrix, or an interpolating function \
which yields one of those forms when evaluated\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.620986477572551*^9, 
  3.6209865202902193`*^9}},ExpressionUUID->"84cf41a6-aaf7-4a76-9f0e-\
2764468ed9f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{"badop_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"Operator", "::", "badop"}], ",", "badop"}], "]"}], ";", 
      "$Failed"}], ")"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"OperatorQ", "[", "badop", "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"badop", ",", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], "|", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
            RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}]}], "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"badop", ",", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ifunc_InterpolatingFunction", "[", "_", "]"}], "/;", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
             ")"}], "&&", "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{
              RowBox[{"ifunc", "[", 
               RowBox[{"ifunc", "\[LeftDoubleBracket]", 
                RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
               "]"}], ",", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], "|", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
                 RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}]}], "]"}]}]}], 
          ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.531930063726522*^9, 3.5319300867107153`*^9}, {
   3.533211551299984*^9, 3.533211551961164*^9}, {3.5860810886700573`*^9, 
   3.586081120972989*^9}, {3.620986255566206*^9, 3.620986383304161*^9}, {
   3.620986417720756*^9, 3.620986464331584*^9}, {3.620986936084321*^9, 
   3.620986949987501*^9}, {3.621081570063826*^9, 3.62108159990063*^9}, {
   3.621081737552088*^9, 3.621081750804166*^9}, {3.621081783138163*^9, 
   3.621081905378907*^9}, {3.6210819515398293`*^9, 3.621081999904092*^9}, 
   3.621082281430932*^9, {3.621082365978812*^9, 3.621082388840468*^9}, {
   3.621391827135437*^9, 3.621391834455043*^9}, {3.621391943722733*^9, 
   3.621391961279351*^9}, {3.621507646417613*^9, 3.621507663915113*^9}},
 CellLabel->
  "In[1219]:=",ExpressionUUID->"95f5c9fc-6fd4-4074-9283-f03d24f62cfb"]
}, Closed]],

Cell[CellGroupData[{

Cell["replacement rules must go into SparseArray", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
  3.5318324474638643`*^9}, {3.531832645834181*^9, 3.53183264655072*^9}, {
  3.533117791517394*^9, 3.5331177990902042`*^9}, {3.621508040302136*^9, 
  3.621508040768717*^9}},ExpressionUUID->"e914e2ee-3727-4f4a-8d24-\
a2dc0be4137c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"ReplaceAll", "[", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{"a_", ",", "more___"}], "]"}], ",", "rules_"}], "]"}]}], ":=", 
   
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"ReplaceEverywhere", "[", 
      RowBox[{"a", ",", "rules"}], "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5331178080055847`*^9, {3.533117838541552*^9, 3.533117844829962*^9}, {
   3.533210881919609*^9, 3.533210939261188*^9}, {3.533211008175622*^9, 
   3.533211010803196*^9}, {3.53321114241328*^9, 3.533211166820303*^9}, {
   3.533211240778281*^9, 3.533211256620554*^9}},
 CellLabel->
  "In[1220]:=",ExpressionUUID->"24bceaaa-af00-49f6-b143-aebc497e6a96"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
implement MatrixRepresentation when Operator is applied to another operator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9, {3.5861666878819437`*^9, 3.586166697976619*^9}, 
   3.5862533409655323`*^9, {3.621391637434125*^9, 3.621391639173192*^9}, {
   3.6215077663758087`*^9, 3.621507774382002*^9}, {3.621507914072262*^9, 
   3.621507915843279*^9}},ExpressionUUID->"260f57fe-8ce6-498c-9532-\
0adc1a4d0955"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "basis"}], "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586166711603229*^9, 3.586166778065651*^9}, {
  3.586253330282308*^9, 3.586253373162689*^9}, {3.6210961226526403`*^9, 
  3.621096134288845*^9}, {3.621159881515395*^9, 3.621159882095866*^9}, {
  3.621391654322123*^9, 3.621391695857471*^9}, {3.6213919885530567`*^9, 
  3.6213919983373632`*^9}, {3.6215077475444593`*^9, 3.621507750851935*^9}},
 CellLabel->
  "In[1221]:=",ExpressionUUID->"c17a0aeb-63c7-47de-b7df-728300d0e1d5"]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckOperatorType", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9, {3.586253389898407*^9, 
   3.5862533994474583`*^9}},ExpressionUUID->"7c91d3d1-893f-4c98-97bb-\
7b2383fa1f49"],

Cell[CellGroupData[{

Cell["interpret CheckOperatorType\[Rule]Automatic", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.586164048314577*^9, 3.5861640551272583`*^9}, 3.586166592170229*^9, 
   3.586253403797324*^9},ExpressionUUID->"64e0dbf2-035a-441d-9a69-\
ff945d08570c"],

Cell["Do not check the OperatorType if an Assumption is set for it", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834321822769737`*^9, 3.583432195403837*^9}, {
  3.5834323826668158`*^9, 3.583432392520463*^9}, {3.586166595514784*^9, 
  3.586166603611122*^9}, {3.586253431742683*^9, 3.5862534385669203`*^9}, {
  3.691402176717566*^9, 
  3.6914021916669893`*^9}},ExpressionUUID->"56a2ed10-0f08-4715-aecb-\
8ae9e2311107"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{"specs_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Operator", "[", "\[IndentingNewLine]", 
     RowBox[{"specs", ",", "basis", ",", "\[IndentingNewLine]", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CheckOperatorType", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ",", "Automatic"}], 
      "]"}], "&&", 
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"First", "/@", 
        RowBox[{"(", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}], ")"}]}], ",", "OperatorType"}], 
      "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691402203541898*^9, 3.691402297201036*^9}, 
   3.6914031156093817`*^9, {3.6914034342539377`*^9, 3.691403498653009*^9}, {
   3.691403836860421*^9, 3.6914038717265873`*^9}},
 CellLabel->
  "In[1222]:=",ExpressionUUID->"a43c15cf-8614-41f1-a7f1-927875324b34"],

Cell["\<\
In case of numeric matrices, determine the OperatorType if the dimension is \
not too large\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834321822769737`*^9, 3.583432195403837*^9}, {
  3.5834323826668158`*^9, 3.583432392520463*^9}, {3.586166595514784*^9, 
  3.586166603611122*^9}, {3.586253431742683*^9, 3.5862534385669203`*^9}, {
  3.6914023172092113`*^9, 3.6914023188065042`*^9}, {3.691403523396577*^9, 
  3.691403545276457*^9}},
 ExpressionUUID -> "a7a09fca-83fc-4f15-97de-d4ac19c081cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Operator", "[", 
     RowBox[{"specs_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{"specs", ",", 
         RowBox[{
          RowBox[{"_", "?", "NumericMatrixQ"}], "|", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericMatrixQ"}], ",", "_List", ",", 
            RowBox[{"_", "?", "NumericMatrixQ"}]}], "}"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{"specs", ",", "basis", ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{
           RowBox[{"CheckOperatorType", "\[Rule]", "True"}], ",", "opts"}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"Operator", "[", 
        RowBox[{"specs", ",", "basis", ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{
           RowBox[{"CheckOperatorType", "\[Rule]", "True"}], ",", 
           RowBox[{"OperatorType", "\[Rule]", " ", "None"}]}], "]"}]}], 
        "]"}]}], "]"}], "/;", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"!", 
        RowBox[{"MemberQ", "[", 
         RowBox[{
          RowBox[{"First", "/@", 
           RowBox[{"(", 
            RowBox[{"Assumptions", "/.", 
             RowBox[{"{", "opts", "}"}]}], ")"}]}], ",", "OperatorType"}], 
         "]"}]}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"CheckOperatorType", ",", "OperatorType"}], "}"}], "/.", 
            
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"BasisDimension", "[", "basis", "]"}], "\[LessEqual]", 
            "OperatorTypeCheckDisableThreshold"}], ")"}], ")"}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}]}]}], 
   ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5861574578937807`*^9, 3.586157620363146*^9}, {
   3.5861576609471292`*^9, 3.5861576732160683`*^9}, {3.586157735980118*^9, 
   3.586157796919389*^9}, 3.586161701634321*^9, {3.586163658016881*^9, 
   3.586163663126279*^9}, {3.586163705429098*^9, 3.5861637121137247`*^9}, {
   3.586163845875366*^9, 3.58616384800957*^9}, {3.5861665520804157`*^9, 
   3.586166585400873*^9}, {3.5862527628244333`*^9, 3.586252766933222*^9}, {
   3.5862539298460817`*^9, 3.586253979805077*^9}, {3.6914035955758247`*^9, 
   3.6914036051520987`*^9}, {3.727530595685532*^9, 3.7275306060627036`*^9}, {
   3.7275308168408966`*^9, 3.727530829221984*^9}, {3.727530861230047*^9, 
   3.727530977740227*^9}},
 CellLabel->
  "In[1223]:=",ExpressionUUID->"44474a5b-501f-4d33-a541-2a0b5f04d3fc"]
}, Closed]],

Cell[CellGroupData[{

Cell["check OperatorType for matrix form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.58616368165716*^9, 3.586163683120761*^9}, {3.586164065803493*^9, 
   3.586164072648814*^9}, 
   3.586254014928458*^9},ExpressionUUID->"99f2cff1-c8a2-4931-9e62-\
b949f466680a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"opmat_", "?", "MatrixQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"Operator", "[", "\[IndentingNewLine]", 
      RowBox[{"opmat", ",", "basis", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"OperatorType", "\[Rule]", 
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"HermitianQ", "[", "opmat", "]"}], ",", 
            "\"\<Hermitian\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"AntiHermitianQ", "[", "opmat", "]"}], ",", 
            "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", 
            RowBox[{"UnitaryQ", "[", "opmat", "]"}], ",", "\"\<Unitary\>\"", 
            ",", "\[IndentingNewLine]", 
            RowBox[{"NormalQ", "[", "opmat", "]"}], ",", "\"\<Normal\>\"", 
            ",", "\[IndentingNewLine]", "True", ",", "None"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ")"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"CheckOperatorType", ",", "OperatorType"}], "}"}], "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"NumericMatrixQ", "[", "opmat", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583432407146059*^9, 3.5834325434529133`*^9}, {
   3.58615764580089*^9, 3.586157650688512*^9}, {3.586157827858062*^9, 
   3.586157923065819*^9}, {3.586161532753099*^9, 3.586161533534013*^9}, 
   3.5861639785232773`*^9, {3.586252879973609*^9, 3.586252891324767*^9}, {
   3.5862540226256533`*^9, 3.586254082339354*^9}, 3.586254311149815*^9, {
   3.640600609442565*^9, 3.6406006219085712`*^9}, 3.640603510914906*^9, {
   3.691402665955957*^9, 3.691402671688719*^9}, 3.691403134486833*^9, {
   3.691403314393935*^9, 3.691403325464262*^9}, {3.691403700369157*^9, 
   3.691403700875127*^9}},
 CellLabel->
  "In[1224]:=",ExpressionUUID->"890b05a8-149d-4461-bd50-42e43e2f4068"]
}, Closed]],

Cell[CellGroupData[{

Cell["check OperatorType for diagonalization form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.58616368165716*^9, 3.5861636981218443`*^9}, 3.5861640792958803`*^9, 
   3.5862541109583883`*^9},ExpressionUUID->"211e6015-37ee-4223-b1fc-\
f623b8b36ba3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
       RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "orthogX", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorType", "\[Rule]", 
            RowBox[{"Which", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"And", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{
                    RowBox[{"Abs", "[", "#", "]"}], "-", "1"}], "]"}], 
                    "\[Equal]", "0"}], ")"}], "&"}], "/@", "evals"}], ")"}]}],
               ",", "\"\<Unitary\>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"orthogX", "=", 
                 RowBox[{"OrthogonalQ", "[", "X", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"orthogX", " ", "&&", "\[IndentingNewLine]", 
                 RowBox[{"And", "@@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Element", "[", 
                    RowBox[{"#", ",", "Reals"}], "]"}], "&"}], "/@", 
                    "evals"}], ")"}]}]}]}], ")"}], ",", "\"\<Hermitian\>\"", 
              ",", "\[IndentingNewLine]", "orthogX", ",", "\"\<Normal\>\"", 
              ",", "\[IndentingNewLine]", "True", ",", "None"}], "]"}]}], ",",
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "/;", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"CheckOperatorType", ",", "OperatorType"}], "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericMatrixQ"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}], ",", 
             RowBox[{"_", "?", "NumericMatrixQ"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583432407146059*^9, 3.5834325434529133`*^9}, {
   3.58615764580089*^9, 3.586157650688512*^9}, {3.586157827858062*^9, 
   3.586157923065819*^9}, {3.586157962270501*^9, 3.586158027225636*^9}, {
   3.586158063371315*^9, 3.586158102304427*^9}, {3.586158159024472*^9, 
   3.586158247921908*^9}, {3.58615929745537*^9, 3.58615952248623*^9}, {
   3.586161542261753*^9, 3.586161542857891*^9}, {3.586252902577396*^9, 
   3.586252912082491*^9}, {3.5862541153654747`*^9, 3.586254145204698*^9}, 
   3.586254316755331*^9, {3.691402681473301*^9, 3.691402681752408*^9}, 
   3.691403138697626*^9, {3.69140333034529*^9, 3.691403357014646*^9}},
 CellLabel->
  "In[1225]:=",ExpressionUUID->"af7a2567-2315-4c74-93b3-ba906babe303"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckMatrixDimensions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9, {3.586253389898407*^9, 3.5862533994474583`*^9}, {
   3.64060365526694*^9, 3.64060365619952*^9}, 
   3.6406037165289717`*^9},ExpressionUUID->"33ed425d-9710-48c8-b2fb-\
1b57cdda5d9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{"opmat_", "?", "MatrixQ"}], ",", "basis_", ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"CheckMatrixDimensions", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "opmat", "]"}], "\[Equal]", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Operator", "[", 
          RowBox[{"opmat", ",", "basis", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Operator", "::", "baddims"}], "]"}], ";", "$Failed"}], 
          ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.640603738589243*^9, 3.640603948041686*^9}, {
   3.6406040172336903`*^9, 3.640604017885295*^9}, {3.64060408545747*^9, 
   3.640604125005014*^9}, 3.64060415984767*^9},
 CellLabel->
  "In[1226]:=",ExpressionUUID->"0d657609-e2ca-4fce-a225-9d3bbfb83d3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{"X\[CapitalLambda]Xinv", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}]}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"CheckMatrixDimensions", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Dimensions", "[", "X", "]"}], "\[Equal]", 
            RowBox[{"Dimensions", "[", "Xinv", "]"}], "\[Equal]", 
            RowBox[{"{", 
             RowBox[{"n", ",", "n"}], "}"}]}], ")"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", "evals", "]"}], "\[Equal]", "n"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Operator", "[", 
          RowBox[{
          "X\[CapitalLambda]Xinv", ",", "basis", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Operator", "::", "baddims"}], "]"}], ";", "$Failed"}], 
          ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.640603738589243*^9, 3.640603948041686*^9}, {
   3.640603983045824*^9, 3.6406040638352833`*^9}, {3.640604107431094*^9, 
   3.640604130934952*^9}, 3.6406041626922417`*^9},
 CellLabel->
  "In[1227]:=",ExpressionUUID->"6e44d21a-54f5-4da6-be24-f8c771d7a4cd"]
}, Closed]],

Cell[CellGroupData[{

Cell["exponent of diagonalized Operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 
  3.586081447501163*^9}},ExpressionUUID->"2f73e91a-a769-4b42-b315-\
17bfac7e526f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Exp", "[", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}], "]"}], "]"}], ":=", 
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", 
       RowBox[{"Exp", "/@", "evals"}], ",", "Xinv"}], "}"}], ",", "basis", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.58608138613308*^9, 3.5860813906599197`*^9}, {
   3.586081422343294*^9, 3.5860814755231953`*^9}, 3.586081593814258*^9, 
   3.586081737150496*^9, {3.58947992372125*^9, 3.5894799280787497`*^9}},
 CellLabel->
  "In[1228]:=",ExpressionUUID->"11e0ae45-79c3-4d08-97aa-aa0182e29256"],

Cell[BoxData[
 RowBox[{"Operator", "/:", 
  RowBox[{"HoldPattern", "[", 
   RowBox[{"E", "^", 
    RowBox[{"(", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}], ")"}]}], "]"}], ":=", 
  RowBox[{"Operator", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"X", ",", 
      RowBox[{"Exp", "/@", "evals"}], ",", "Xinv"}], "}"}], ",", "basis", ",",
     "opts"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589263232394032*^9, 3.589263241824751*^9}, {
  3.589479931644844*^9, 3.589479942729679*^9}},
 CellLabel->
  "In[1229]:=",ExpressionUUID->"217ec80e-6184-4292-a795-8c51c83cc4e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Exp", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Exp", "[", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
             RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
           "opts___Rule"}], "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "]"}]}], ":=", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", 
         RowBox[{"Exp", "/@", 
          RowBox[{"(", 
           RowBox[{"n1", "*", "n2", "*", "evals"}], ")"}]}], ",", "Xinv"}], 
        "}"}], ",", "basis", ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.6831202268305807`*^9, 3.683120235672986*^9}, {
   3.745400101013688*^9, 
   3.745400104548231*^9}},ExpressionUUID->"4d0da24c-a53e-4790-a49c-\
de458b205a38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"n1___", "?", "NumericQ"}], ",", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
              RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
            "opts___Rule"}], "]"}], ",", 
          RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ")"}]}], "]"}], ":=", 
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", 
         RowBox[{"Exp", "/@", 
          RowBox[{"(", 
           RowBox[{"n1", "*", "n2", "*", "evals"}], ")"}]}], ",", "Xinv"}], 
        "}"}], ",", "basis", ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.6831202268305807`*^9, 3.6831202517991943`*^9}, {
   3.745400110959186*^9, 
   3.7454001136999617`*^9}},ExpressionUUID->"d18c7d4d-4e3a-4d89-93a4-\
bea91dffe92b"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adjoint of Operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 3.586081447501163*^9}, {
  3.590660286090549*^9, 
  3.59066028905759*^9}},ExpressionUUID->"0019eb55-fe4b-48d3-a62f-\
796d8e7111ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "matbasis_", ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Switch", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OperatorType", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
       "\[IndentingNewLine]", "\"\<Hermitian\>\"", ",", "mat", ",", 
       "\[IndentingNewLine]", "\"\<AntiHermitian\>\"", ",", 
       RowBox[{"-", "mat"}], ",", "\[IndentingNewLine]", "_", ",", 
       RowBox[{"ConjugateTranspose", "[", "mat", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "matbasis", 
     ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590660292634741*^9, 3.590660388453232*^9}, {
  3.590660419024871*^9, 3.590660450761305*^9}, {3.590660488652382*^9, 
  3.590660598158297*^9}},
 CellLabel->
  "In[1232]:=",ExpressionUUID->"9875c765-f649-41b0-9722-1ff780f545a7"]
}, Closed]],

Cell[CellGroupData[{

Cell["request Basis of Operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 3.586081447501163*^9}, {
  3.590660286090549*^9, 3.59066028905759*^9}, {3.640508229044055*^9, 
  3.640508232057681*^9}},ExpressionUUID->"e2a33496-b7da-47e4-9814-\
7e1252b9c079"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Basis", "[", 
    RowBox[{"Operator", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"_", "?", "MatrixQ"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
         RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", "basis"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590660292634741*^9, 3.590660388453232*^9}, {
  3.590660419024871*^9, 3.590660450761305*^9}, {3.590660488652382*^9, 
  3.590660598158297*^9}, {3.64050823530961*^9, 3.640508249506859*^9}, {
  3.640508369111353*^9, 3.640508379008873*^9}, {3.640508422156345*^9, 
  3.640508441192397*^9}, {3.640512619025002*^9, 3.640512623503481*^9}},
 CellLabel->
  "In[1233]:=",ExpressionUUID->"8fdc0468-f226-49bf-be8a-42edc4b65e02"]
}, Closed]],

Cell[CellGroupData[{

Cell["Dot combinations with Kets & Bras", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.657108247745591*^9, 
  3.657108288139979*^9}},ExpressionUUID->"d3e036de-9456-4aa3-9e53-\
d08689b4f0da"],

Cell[CellGroupData[{

Cell["application to Ket", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 
  3.504110452356811*^9}},ExpressionUUID->"4db141f8-d8c7-463b-a589-\
9c0e4613a29d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"op_Operator", "[", 
    RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
   RowBox[{"op", ".", "ket"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590659844004518*^9, 3.590659881678423*^9}},
 CellLabel->
  "In[1234]:=",ExpressionUUID->"e1808fad-4c33-4184-837b-9c16664c68fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"ket_", "?", "KetQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "op", "]"}]}], ";", 
       RowBox[{
        RowBox[{"BasisKets", "[", "basis", "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"ket", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.6424090632591467`*^9}, {3.657107717190329*^9, 
   3.657107805508966*^9}, {3.657107897583373*^9, 3.6571079054546127`*^9}, {
   3.65710797061954*^9, 3.657107976969018*^9}},
 CellLabel->
  "In[1235]:=",ExpressionUUID->"2c4c814d-ffe8-472e-9ad9-c60d3e45d296"]
}, Closed]],

Cell[CellGroupData[{

Cell["application to Bra", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
  3.504110834267372*^9}},ExpressionUUID->"0b05ca94-17ff-49b0-b753-\
df98c4ad70b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"bra_", "?", "BraQ"}], ",", "op_Operator"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "op", "]"}]}], ";", 
       RowBox[{
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"bra", ",", "basis"}], "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"BasisBras", "[", "basis", "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.642409113476671*^9}, {3.657108037607176*^9, 
   3.657108047053022*^9}},
 CellLabel->
  "In[1236]:=",ExpressionUUID->"84269624-8f0b-44e9-8b18-571c5072dad2"]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra.Operator.Ket", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
  3.504110834267372*^9}, {3.6571080748132973`*^9, 
  3.657108079785739*^9}},ExpressionUUID->"f115914b-02b9-42e9-b3ea-\
91e8758781a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Operator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"bra_", "?", "BraQ"}], ",", "op_Operator", ",", 
      RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "op", "]"}]}], ";", 
       RowBox[{
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"bra", ",", "basis"}], "]"}], ".", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "basis"}], "]"}], ".", 
        RowBox[{"VectorRepresentation", "[", 
         RowBox[{"ket", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.50411045530746*^9, 3.504110492160247*^9}, {3.50411056437462*^9, 
   3.5041106119283133`*^9}, {3.504110643558683*^9, 3.50411065280678*^9}, 
   3.5318344433669643`*^9, {3.531842834120273*^9, 3.53184283705475*^9}, 
   3.590663337272875*^9, {3.642408953344984*^9, 3.642408969484885*^9}, {
   3.642409005932312*^9, 3.642409113476671*^9}, {3.657108037607176*^9, 
   3.657108047053022*^9}, {3.6571080839943647`*^9, 3.657108108240409*^9}, {
   3.657108511880226*^9, 3.657108514757413*^9}, {3.657108810868898*^9, 
   3.657108813176647*^9}, 3.657109502164403*^9},
 CellLabel->
  "In[1237]:=",ExpressionUUID->"47a35e6e-4968-41da-a712-05f19190a5bb"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
  3.504110834267372*^9}, {3.531830571404662*^9, 
  3.531830572473724*^9}},ExpressionUUID->"eeaba5b6-accd-4661-8c92-\
e4aaf9317d3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "notherm"}], "=", 
   "\"\<The context implies a hermitian operator, but a violation is \
suspected. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307398380117`*^9, 3.53183074822178*^9}, {3.531834533054112*^9, 
   3.531834545385674*^9}, {3.531835095406083*^9, 3.531835098773775*^9}, {
   3.531927533229911*^9, 3.5319275884203176`*^9}, 3.531934915968739*^9, 
   3.531935049092112*^9},
 CellLabel->
  "In[1238]:=",ExpressionUUID->"62c95133-0c6d-49a6-aa55-670ee96ff0cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "notantuherm"}], "=", 
   "\"\<The context implies an antihermitian operator, but a violation is \
suspected. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307398380117`*^9, 3.53183074822178*^9}, {3.531834533054112*^9, 
   3.531834545385674*^9}, {3.531835095406083*^9, 3.531835098773775*^9}, {
   3.531927533229911*^9, 3.5319275884203176`*^9}, 3.531934915968739*^9, 
   3.531935049092112*^9, {3.5628983489506817`*^9, 3.562898354252693*^9}},
 CellLabel->
  "In[1239]:=",ExpressionUUID->"b6b4f08a-71bf-4d4b-8eb2-ff0aab3adeab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "notnormal"}], "=", 
   "\"\<The context implies a normal operator, but a violation is suspected. \
Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307398380117`*^9, 3.53183074822178*^9}, {3.531834533054112*^9, 
   3.531834545385674*^9}, {3.531835095406083*^9, 3.531835098773775*^9}, {
   3.531927533229911*^9, 3.5319275884203176`*^9}, 3.531934915968739*^9, 
   3.531935049092112*^9, {3.5628983489506817`*^9, 3.562898354252693*^9}, {
   3.562898513425477*^9, 3.562898517928636*^9}},
 CellLabel->
  "In[1240]:=",ExpressionUUID->"da89c852-cb16-4f7d-842c-84018495c23d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "notunitary"}], "=", 
   "\"\<The context implies a unitary operator, but a violation is suspected. \
Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307326901083`*^9, 3.5318307746200542`*^9}, {3.5318345630127573`*^9, 
   3.5318345686976852`*^9}, {3.5318351024806843`*^9, 3.531835106977257*^9}, {
   3.531927569259997*^9, 3.531927610292252*^9}, {3.531934906399351*^9, 
   3.53193490769016*^9}, 3.53193505223974*^9},
 CellLabel->
  "In[1241]:=",ExpressionUUID->"5d748a82-a976-46b6-b88b-abddf5eaf1ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "badoptype"}], "=", 
   "\"\<OperatorType `1` not recognized.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832786290778*^9, 3.531832798008423*^9}},
 CellLabel->
  "In[1242]:=",ExpressionUUID->"db3e3bac-639c-4d7d-8491-3c6bc386af96"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "incompatspinsys"}], "=", 
   "\"\<The Operator expression has been defined using a spin system \
incompatible with the requested basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832786290778*^9, 3.531832798008423*^9}, {
  3.531842777961989*^9, 3.5318428134810133`*^9}},
 CellLabel->
  "In[1243]:=",ExpressionUUID->"b941e5d6-b7c1-4867-9785-f4ae93e4d4bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "badop"}], "=", 
   "\"\<Operator may not be applied to an expression `1` that is not an \
operator or a matrix\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929801671324*^9, 3.531929825407236*^9}, {
  3.531930099517685*^9, 3.5319301114820127`*^9}, {3.53321156177232*^9, 
  3.53321156748619*^9}},
 CellLabel->
  "In[1244]:=",ExpressionUUID->"89d59424-49b6-46fa-b208-e16660eb0b12"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "times"}], "=", 
   "\"\<operators must be multiplied by Dot (\\\".\\\"), not with Times (\\\"\
\[Times]\\\")\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589481063735985*^9, 3.5894811013561783`*^9}, {
   3.589482193124737*^9, 3.5894822074096127`*^9}, 3.589823569505417*^9},
 CellLabel->
  "In[1245]:=",ExpressionUUID->"7f34446a-7244-4ff1-b425-69bfa3bdd63e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "baddims"}], "=", 
   "\"\<the Operator definition uses a matrix whose dimensions are \
inconsistent with the specified basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6406042189571877`*^9, 3.640604256668478*^9}},
 CellLabel->
  "In[1246]:=",ExpressionUUID->"a1d8f259-cf41-44f1-a224-71c9d488aa7f"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UnityOperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430589699087968*^9, 3.4305897030287237`*^9}, 
   3.4308939637907667`*^9, {3.486462857617523*^9, 3.486462860470825*^9}, 
   3.5020734063584757`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"2f43b35e-7951-4414-b312-1602e3bc1469"],

Cell[CellGroupData[{

Cell["Unity is now obsolete", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, {
  3.486462869169406*^9, 
  3.486462872175338*^9}},ExpressionUUID->"6a3aa03b-e0fd-494e-9370-\
4c8dc55b6614"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unity", ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Unity", "::", "obs"}], "]"}], ";", 
     RowBox[{"UnityOperator", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486462875762068*^9, 3.4864628802343693`*^9}, {
  3.486463751225013*^9, 3.486463765687429*^9}},
 CellLabel->
  "In[1247]:=",ExpressionUUID->"09b40d90-654c-4879-9e70-a4b94305dc31"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.48646398234688*^9, 3.486464003426928*^9}, 
   3.6749899303864183`*^9},ExpressionUUID->"3392daef-bc07-4d6d-8cce-\
8c828add2f09"],

Cell[CellGroupData[{

Cell["Display", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f5709b00-60b2-4e78-9b55-07bb11886b0e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnityOperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"UnityOperator", "[", "]"}], "]"}], ":=", " ", 
   "\"\<\[DoubleStruckOne]\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430589375877718*^9, 3.430623981159732*^9, {3.430624334592304*^9, 
   3.43062436178749*^9}, 3.4306245052321672`*^9, 3.430624615967164*^9, 
   3.43062482206208*^9, {3.430625199519032*^9, 3.430625200643235*^9}, 
   3.430625731110174*^9, {3.4864639660616093`*^9, 3.486463969137081*^9}},
 CellLabel->
  "In[1248]:=",ExpressionUUID->"c8d30fbd-eec0-44b9-bd9a-9fb1b7e9b971"],

Cell[BoxData[
 RowBox[{"UnityOperator", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{"UnityOperator", "[", 
    RowBox[{"j", ":", 
     RowBox[{"Except", "[", "_List", "]"}]}], "]"}], "]"}], ":=", " ", 
  SubscriptBox["\"\<\[DoubleStruckOne]\>\"", "j"]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464620130969*^9, 3.48646464751112*^9}},
 CellLabel->
  "In[1249]:=",ExpressionUUID->"06f67972-224f-4ccf-9967-5f9f9a505770"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"77276012-402f-4e57-bf6a-\
414fc63bf727"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnityOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_UnityOperator", ",", "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9},
 CellLabel->
  "In[1250]:=",ExpressionUUID->"26891596-8ac3-485c-b194-815058a27721"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, {
   3.4864645816243343`*^9, 3.486464583941022*^9}, 
   3.642409181622555*^9},ExpressionUUID->"8dbb53b5-a1e5-47e0-81e4-\
2f8005a2d25f"],

Cell["exclude single-transition versions of UnityOperator", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.48646458803738*^9, 
  3.486464598677651*^9}},ExpressionUUID->"9bc5f928-240b-4f41-b51f-\
855984eddd0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnityOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a__", ",", 
      RowBox[{"UnityOperator", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], "..."}], ",", "___Rule"}], 
       "]"}], ",", "b___"}], "]"}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.486463928365264*^9, 3.4864639352664137`*^9}, {3.486464555312443*^9, 
   3.486464573622748*^9}, {3.486464748835661*^9, 3.4864647492494307`*^9}, {
   3.642409153978647*^9, 3.6424091693291817`*^9}},
 CellLabel->
  "In[1251]:=",ExpressionUUID->"3bd25f01-1a1c-4a82-9778-09a737fab310"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnityOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a___", ",", 
      RowBox[{"UnityOperator", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], "..."}], ",", "___Rule"}], 
       "]"}], ",", "b__"}], "]"}]}], ":=", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, {3.430624975271617*^9, 3.430624986620377*^9}, 
   3.43062572990934*^9, {3.486463929443879*^9, 3.486463939036036*^9}, 
   3.486464578026835*^9, {3.486464753810903*^9, 3.486464754330947*^9}, {
   3.6424091626433487`*^9, 3.642409170937975*^9}},
 CellLabel->
  "In[1252]:=",ExpressionUUID->"08c00bf0-a84f-4f3b-9519-da557d1c7d35"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, {
  3.4351664823354053`*^9, 
  3.435166483636772*^9}},ExpressionUUID->"da3c11a1-0d71-41e2-a612-\
939711954aef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnityOperator", "/:", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"UnityOperator", "[", "args___", "]"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "args", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.435166493134728*^9, 3.435166500704298*^9}, {3.486463945411045*^9, 
   3.4864639617717323`*^9}, {3.486464603715104*^9, 3.486464608232465*^9}},
 CellLabel->
  "In[1253]:=",ExpressionUUID->"976db209-c73e-4117-ae60-e85bf75e1657"]
}, Closed]],

Cell[CellGroupData[{

Cell["application to Ket", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, {
  3.4351664823354053`*^9, 3.435166483636772*^9}, {3.674989309533351*^9, 
  3.674989312693956*^9}},ExpressionUUID->"b592a641-d4e8-401a-bed0-\
dc25268724ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UnityOperator", "[", "args___", "]"}], "[", 
    RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"UnityOperator", "[", "args", "]"}], ".", "ket"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.435166493134728*^9, 3.435166500704298*^9}, {3.486463945411045*^9, 
   3.4864639617717323`*^9}, {3.486464603715104*^9, 3.486464608232465*^9}, {
   3.67498931741987*^9, 3.674989336521821*^9}},
 CellLabel->
  "In[1254]:=",ExpressionUUID->"a60154cb-86c5-43fc-baf8-e48ad059ce7f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Single transition forms of UnityOperator[]", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486462888018524*^9, 3.486462889200481*^9}, {
  3.486464013684915*^9, 
  3.4864640243503437`*^9}},ExpressionUUID->"c54c0f06-c31e-4474-bc5a-\
dceb20225fa9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464047804242*^9, 3.486464057160667*^9}},
 CellLabel->
  "In[1255]:=",ExpressionUUID->"63ea7aec-ca09-444c-bd24-e917c13e2cf0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "Undefined"}], "}"}], ",", 
     "___"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864581080575*^9, 3.4864581357385263`*^9}, 
   3.486464069323421*^9, {3.486465793296628*^9, 3.486465793775117*^9}, 
   3.5470252053093443`*^9},
 CellLabel->
  "In[1256]:=",ExpressionUUID->"2c64a238-c3db-460f-a9db-b0fce4061dab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UnityOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "#"}], "]"}], 
         "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"r", ",", "s"}], "}"}]}], ")"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"UnityOperator", "::", "badlabel"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", "basis"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864578777348146`*^9, 3.486457986075219*^9}, {
  3.486464082653549*^9, 3.4864640903806868`*^9}},
 CellLabel->
  "In[1257]:=",ExpressionUUID->"913b1972-7402-4286-b5e5-9e25a84e6d61"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "r"}], "]"}]}], 
         "]"}]}], ",", 
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "s"}], "]"}]}], 
         "]"}]}]}], "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458168133155*^9, 3.486458215600869*^9}, {
  3.4864641327608213`*^9, 3.486464147192917*^9}},
 CellLabel->
  "In[1258]:=",ExpressionUUID->"78c030ea-13e7-40e7-b81e-7028088b2f10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UnityOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ketr_", "?", "KetQ"}], ",", 
        RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "opts___Rule"}], "]"}], 
    "/;", 
    RowBox[{
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"Adjoint", "[", "kets", "]"}], ".", "ketr"}], "]"}], 
     "\[NotEqual]", "0"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"UnityOperator", "::", "notorthog"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458362520542*^9, 3.486458408210157*^9}, {
  3.486464161337483*^9, 3.486464173905595*^9}},
 CellLabel->
  "In[1259]:=",ExpressionUUID->"855d228b-9f0e-4f4f-b42e-861a02aa8eb3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ketr", ".", 
     RowBox[{"Adjoint", "[", "ketr", "]"}]}], "+", 
    RowBox[{"kets", ".", 
     RowBox[{"Adjoint", "[", "kets", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464205507256*^9, 3.486464227107047*^9}},
 CellLabel->
  "In[1260]:=",ExpressionUUID->"d04a037e-0b2c-423b-9569-436fb5be3a1a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486462888018524*^9, 
  3.486462889200481*^9}},ExpressionUUID->"4beb40f5-343f-47ac-b400-\
c67350e8a1d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Unity", "::", "obs"}], "=", 
   "\"\<Unity is now obsolete and has been replaced by UnityOperator[]\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486463772841002*^9, 3.4864637876340857`*^9}},
 CellLabel->
  "In[1261]:=",ExpressionUUID->"83b2f0cb-aa99-40ab-91cf-e49bc36cc1ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "::", "badlabel"}], "=", 
   "\"\<One or more of the labels `1` is not a defined basis label for the \
basis `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457989154126*^9, 3.486457989775527*^9}, {
   3.486458025355111*^9, 3.486458070293103*^9}, 3.486464108565113*^9},
 CellLabel->
  "In[1262]:=",ExpressionUUID->"41edcbec-7054-4b63-897c-8cc4cc05a23b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnityOperator", "::", "notorthog"}], "=", 
   "\"\<The states are not orthogonal\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458413218872*^9, 3.486458427650567*^9}, 
   3.486464185641329*^9},
 CellLabel->
  "In[1263]:=",ExpressionUUID->"6397b802-db33-438c-b7d6-79133384b6f3"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NullOperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430589699087968*^9, 3.4305897030287237`*^9}, 
   3.4308939637907667`*^9, {3.467301161006875*^9, 3.4673011650196123`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9bd6cc37-e12e-460e-8c06-89edae40e99d"],

Cell[CellGroupData[{

Cell["Display", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"0fea0919-64c8-4c8a-9d30-33ec3de75c57"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"NullOperator", "[", "]"}], "]"}], ":=", " ", 
   "\"\<\[DoubleStruckCapitalO]\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430589375877718*^9, 3.430623981159732*^9, {3.430624334592304*^9, 
   3.43062436178749*^9}, 3.4306245052321672`*^9, 3.430624615967164*^9, 
   3.43062482206208*^9, {3.430625199519032*^9, 3.430625200643235*^9}, 
   3.430625731110174*^9, {3.467301215791778*^9, 3.467301223295285*^9}, 
   3.4673015595817747`*^9, 3.4867109707498703`*^9, 3.683112846727192*^9},
 CellLabel->
  "In[1264]:=",ExpressionUUID->"1adc760d-b8b5-40a8-8555-a8225194525d"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorProduct", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, 
   3.502518632736298*^9, 
   3.642409184869728*^9},ExpressionUUID->"d795d240-f66e-4eb7-8eec-\
a1c18160a61f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{"a___", "?", "OperatorQ"}], ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", 
      RowBox[{"b__", "?", "OperatorQ"}], ",", "___Rule"}], "]"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.467301177185025*^9, 3.46730118251158*^9}, {3.4867109395914707`*^9, 
   3.486710942204783*^9}, {3.5470295314972963`*^9, 3.547029567392624*^9}, 
   3.5470297539680643`*^9, 3.642409189271118*^9, {3.657820273361392*^9, 
   3.6578202755669603`*^9}},
 CellLabel->
  "In[1265]:=",ExpressionUUID->"e2d12d7d-e7ad-4c30-90e8-423a3085e51d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{"a__", "?", "OperatorQ"}], ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", 
      RowBox[{"b___", "?", "OperatorQ"}], ",", "___Rule"}], "]"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.467301177185025*^9, 3.46730118251158*^9}, {3.4867109395914707`*^9, 
   3.486710942204783*^9}, {3.5470295314972963`*^9, 3.547029567392624*^9}, {
   3.5470297539680643`*^9, 3.547029762858471*^9}, 3.6424091933286057`*^9, {
   3.657820280070816*^9, 3.657820283038574*^9}},
 CellLabel->
  "In[1266]:=",ExpressionUUID->"76723978-7a89-4549-9d79-a5acf3c00562"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"___", ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", 
      RowBox[{"___", "?", "OperatorQ"}], ",", 
      RowBox[{"ket_", "?", "KetQ"}]}], "]"}]}], ":=", "0"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, {3.430624975271617*^9, 3.430624986620377*^9}, 
   3.43062572990934*^9, {3.467301198159111*^9, 3.4673012033434134`*^9}, {
   3.486710944812854*^9, 3.486710948916993*^9}, {3.547029591218546*^9, 
   3.547029617002877*^9}, {3.547029668298635*^9, 3.5470296719668503`*^9}, 
   3.6424091987940063`*^9},
 CellLabel->
  "In[1267]:=",ExpressionUUID->"81f3ded2-1cef-4a68-90c4-a660154c29dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"bra_", "?", "BraQ"}], ",", 
      RowBox[{"___", "?", "OperatorQ"}], ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", "___"}], "]"}]}], ":=", "0"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, {3.430624975271617*^9, 3.430624986620377*^9}, 
   3.43062572990934*^9, {3.467301198159111*^9, 3.4673012033434134`*^9}, {
   3.486710944812854*^9, 3.486710948916993*^9}, {3.547029591218546*^9, 
   3.547029614948352*^9}, {3.547029680597093*^9, 3.547029681252383*^9}},
 CellLabel->
  "In[1268]:=",ExpressionUUID->"6a5ce626-4198-4926-97d5-56d84f8602b5"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"4d1b5007-d43f-4aa3-8198-\
22765a3ad989"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_NullOperator", ",", "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.58982362297097*^9, 
   3.589823626593506*^9}},
 CellLabel->
  "In[1269]:=",ExpressionUUID->"c07e11d9-f58a-4ed5-b862-c5d4c9006137"]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 
  3.502517902137464*^9}},ExpressionUUID->"ea1642af-ee68-4606-be90-\
7124c623aef4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}]}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502517846493984*^9, 3.502517946749755*^9}, {
  3.5025182946360073`*^9, 3.502518308832777*^9}, {3.50251856987676*^9, 
  3.502518574124433*^9}},
 CellLabel->
  "In[1270]:=",ExpressionUUID->"45406d79-64fe-42c6-a355-02d507c689a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{
      RowBox[{"ops2___", "?", "OperatorQ"}], ",", 
      RowBox[{"NullOperator", "[", "]"}], ",", 
      RowBox[{"ops1___", "?", "OperatorQ"}]}], "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{"ops2", ",", "ops1"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.44834857702761*^9, 3.448348662101181*^9, {3.502517772676806*^9, 
   3.502517830708547*^9}, {3.5025179380946283`*^9, 3.502518003325676*^9}, {
   3.5025183202283688`*^9, 3.502518342019199*^9}, {3.502518390396392*^9, 
   3.502518405233592*^9}, {3.502518575801775*^9, 3.502518600657631*^9}},
 CellLabel->
  "In[1271]:=",ExpressionUUID->"255db904-7159-4e67-bb02-546fa8926e58"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430590431834999*^9, 3.430590432744722*^9}, {
  3.4351664823354053`*^9, 
  3.435166483636772*^9}},ExpressionUUID->"98b2b0e8-83df-44e7-b19f-\
84e0b7a3996d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullOperator", "/:", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"NullOperator", "[", "]"}], "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4305895472061453`*^9, 3.430589575462131*^9}, {
   3.430589630383107*^9, 3.4305896305554533`*^9}, {3.43062364349953*^9, 
   3.430623645883935*^9}, 3.4306243232165127`*^9, {3.430624911469036*^9, 
   3.4306249119161243`*^9}, 3.430624975271617*^9, 3.430625729239991*^9, {
   3.435166493134728*^9, 3.435166500704298*^9}, {3.467301208142264*^9, 
   3.467301211238462*^9}, {3.4867109663900757`*^9, 3.486710967189098*^9}},
 CellLabel->
  "In[1272]:=",ExpressionUUID->"07cf9756-adaa-43e6-85cb-70966bb68a06"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to Ket", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.467301899217997*^9, 
  3.467301902888443*^9}},ExpressionUUID->"ab3aa976-40de-44c0-9b6c-\
0214f1b882b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NullOperator", "[", "]"}], "[", "arg_", "]"}], "=", "0"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.467301905631123*^9, 3.4673019263644457`*^9}, 
   3.483527751067397*^9, 3.486710973181487*^9},
 CellLabel->
  "In[1273]:=",ExpressionUUID->"fe20c4c6-ee88-4ced-99a1-28fc921daba1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["AngularMomentumOperator opI", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.5020733405509357`*^9, 
  3.502166506573838*^9},ExpressionUUID->"56c1633f-f858-434b-8e79-\
33a9fc8d0279"],

Cell["\<\
the ordering of the definitions below is very important. Implied spins must \
be distinguished from direction labels. This is particularly tricky since a \
missing label is also interpreted as a vector operator, eg opI[] and opI[1]. \
\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502163382130404*^9, 3.5021634116569242`*^9}, {
  3.502163512024004*^9, 3.50216354316641*^9}, {3.502165328269174*^9, 
  3.502165337593328*^9}},ExpressionUUID->"20421ff3-39d5-49f2-8244-\
2365c723596f"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.699270357269496*^9, 3.69927035822479*^9}},
 ExpressionUUID -> "a5920329-bb5f-4aa4-ad4d-eb75b3ae6a0e"],

Cell[CellGroupData[{

Cell["Attributes", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"fbc95cb4-5f02-43fd-8f20-\
eea5f0c0ce05"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"opI", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617681579221*^9}},
 CellLabel->
  "In[1274]:=",ExpressionUUID->"58ece623-43e9-4aa8-86c7-57d09bd4d2a2"]
}, Closed]],

Cell[CellGroupData[{

Cell["AngularMomentumOperator synonym", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 
  3.502166415362692*^9}},ExpressionUUID->"a04c11d6-795c-494b-8753-\
195afda768d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AngularMomentumOperator", "[", "args___", "]"}], ":=", 
   RowBox[{"opI", "[", "args", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460366514151391*^9, 3.460366523288849*^9}, {
  3.502166421311537*^9, 3.502166423956436*^9}},
 CellLabel->
  "In[1275]:=",ExpressionUUID->"f5055182-f5af-4e27-aac1-5c268efabd87"]
}, Closed]],

Cell[CellGroupData[{

Cell["initialize status", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 3.530617646155493*^9}, {3.699267715686228*^9, 
  3.6992677168667717`*^9}, {3.69926778084743*^9, 3.699267789205304*^9}, {
  3.6992680340772657`*^9, 
  3.699268036438817*^9}},ExpressionUUID->"df5a9ec9-7d04-4fd6-adb3-\
92a11fbedcb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"args", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"False", "|", "True"}], "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"args", ",", "False", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699267811509124*^9, 3.699267818220957*^9}, {
   3.699267954381999*^9, 3.6992679808081913`*^9}, {3.699269192710556*^9, 
   3.699269200775495*^9}, {3.699269540869182*^9, 3.699269544489962*^9}, 
   3.699269909210881*^9},
 CellLabel->
  "In[1276]:=",ExpressionUUID->"e41ab838-eebb-47e1-bcef-6703178a229c"]
}, Closed]],

Cell[CellGroupData[{

Cell["check spin system is ready", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.699269429706056*^9},ExpressionUUID->"be1692cc-d329-4696-8f62-\
f6b49521caab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"args___", ",", "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
     ")"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"SpinSystem", "/.", 
       RowBox[{"Options", "[", "SpinSystem", "]"}]}], ",", "Undefined"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439554471001298*^9, 3.439554471718799*^9}, 
   3.448355874989354*^9, 3.456164514297298*^9, {3.5470264333152847`*^9, 
   3.547026434660329*^9}, {3.6914019195982313`*^9, 3.691401920940836*^9}, {
   3.699268525238393*^9, 3.6992685264402018`*^9}, {3.6992692353158712`*^9, 
   3.699269235617619*^9}, {3.69927014814187*^9, 3.6992701554910097`*^9}},
 CellLabel->
  "In[1277]:=",ExpressionUUID->"538cd8c8-d789-44e8-9c83-410b9a0df2c6"]
}, Closed]],

Cell[CellGroupData[{

Cell["implied spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4684242869247513`*^9, 3.468424310761614*^9}, {
   3.468424378308647*^9, 3.468424383036625*^9}, 3.5021588716072493`*^9, {
   3.502161812179627*^9, 3.50216184435401*^9}, {3.5021618907129297`*^9, 
   3.502161894480302*^9}},ExpressionUUID->"f6980172-e179-4713-a319-\
5ea1d6a822f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"False", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699269282362583*^9, 3.6992692883122797`*^9}},
 CellLabel->
  "In[1278]:=",ExpressionUUID->"7e262461-ff9b-4182-bb99-435842743bb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "False", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502162233823415*^9, 3.5021622459746923`*^9}, {
  3.699269099761487*^9, 3.699269135434532*^9}, {3.6992691670825233`*^9, 
  3.699269168306926*^9}, {3.699269301567274*^9, 3.699269302982708*^9}},
 CellLabel->
  "In[1279]:=",ExpressionUUID->"538ca08d-b29f-4d09-8008-c3182882de1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opI", "[", 
     RowBox[{"mu_", ",", "False", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"ValidSpinQ", "[", "mu", "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"mu", ",", 
         RowBox[{"First", "/@", 
          RowBox[{"SpinSystem", "[", "]"}]}]}], "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "mu", ",", "False", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502161848364582*^9, 3.502161869603681*^9}, {
  3.5021619001780987`*^9, 3.502161921010748*^9}, {3.5021625982263613`*^9, 
  3.5021626217678013`*^9}, {3.502162707164502*^9, 3.502162710993862*^9}, {
  3.502162801377337*^9, 3.502162810548748*^9}, {3.502162885326062*^9, 
  3.502162932381219*^9}, {3.699269364106723*^9, 3.699269391094461*^9}},
 CellLabel->
  "In[1280]:=",ExpressionUUID->"c061535d-8411-49a8-8cd2-6511fe02614f"]
}, Closed]],

Cell[CellGroupData[{

Cell["implied sum", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4684242869247513`*^9, 3.468424310761614*^9}, {
   3.468424378308647*^9, 3.468424383036625*^9}, 3.5021588716072493`*^9, {
   3.502161812179627*^9, 3.50216184435401*^9}, {3.5021618907129297`*^9, 
   3.502161894480302*^9}, {3.502161953241521*^9, 3.5021619573921757`*^9}, {
   3.699270274548443*^9, 
   3.6992702791809683`*^9}},ExpressionUUID->"b0b2566a-c520-4ed2-add4-\
a8c922a7b51b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "ValidSpinQ"}], ".."}], "}"}]}], ",", "mu___", ",", 
     "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"#", ",", "mu", ",", "False", ",", "opts"}], "]"}], "&"}], "/@",
       "spins"}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50216197014004*^9, 3.502161978604334*^9}, {
  3.699270292177606*^9, 3.6992703052040653`*^9}},
 CellLabel->
  "In[1281]:=",ExpressionUUID->"792d487c-8f65-4e60-b5f1-0c5b47efe5c4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["checks", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.6992703637843943`*^9, 
  3.6992705232783213`*^9},ExpressionUUID->"40f68575-fbba-4b9c-9263-\
284d31c4ce2a"],

Cell[CellGroupData[{

Cell["validity of spin index", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50215950434489*^9, 
  3.502159523559431*^9}},ExpressionUUID->"942791b4-3cd5-41dc-a856-\
7046727dc981"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"j", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "ValidSpinQ"}], "]"}]}], ",", "mu___", ",", "False", 
     ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "::", "invspin"}], ",", "j"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4561640273806973`*^9, 3.4561640327281857`*^9}, {
   3.4561641780831337`*^9, 3.456164182274557*^9}, {3.456164339963925*^9, 
   3.456164341582505*^9}, {3.4561643853066063`*^9, 3.456164385506579*^9}, {
   3.5021596591763573`*^9, 3.50215966972503*^9}, 3.502162019268936*^9, {
   3.502162371018466*^9, 3.502162372335829*^9}, 3.502162477986485*^9, {
   3.502163436413474*^9, 3.502163437626649*^9}, {3.503104812201808*^9, 
   3.50310481356706*^9}, {3.5304654754385853`*^9, 3.530465478990641*^9}, {
   3.699270378162712*^9, 3.699270431160201*^9}},
 CellLabel->
  "In[1282]:=",ExpressionUUID->"138975ba-1cf1-4bbb-ac4d-5c447b97e922"]
}, Closed]],

Cell[CellGroupData[{

Cell["validity of label", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50215950434489*^9, 
  3.502159520398851*^9}},ExpressionUUID->"fd875d5d-3815-4ed2-a281-\
060107fa5d27"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], ",", "False", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"opI", "::", "invalid\[Alpha]\[Beta]"}], "]"}], ";", 
      "$Failed"}], ")"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"SpinQuantumNumber", "[", "j", "]"}], "==", 
       RowBox[{"1", "/", "2"}]}], "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164048468923*^9, 3.456164054304545*^9}, {
  3.456164350091269*^9, 3.456164351506548*^9}, {3.456164383003541*^9, 
  3.4561643832272177`*^9}, {3.502158801180915*^9, 3.502158834993284*^9}, {
  3.662919787415085*^9, 3.662919788725576*^9}, {3.699270463079467*^9, 
  3.6992704724371443`*^9}},
 CellLabel->
  "In[1283]:=",ExpressionUUID->"d8f7609f-b1b8-44c4-85fc-f6f4e8fa9a15"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opI", "[", 
     RowBox[{"j_", ",", "label_String", ",", "False", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"label", ",", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
        "|", "\"\<-\>\"", "|", "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", 
        "|", "\"\<-x\>\"", "|", "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"",
         "|", "\"\<-y\>\"", "|", 
        "\"\<\!\(\*OverscriptBox[\(z\), \(_\)]\)\>\"", "|", "\"\<-z\>\"", 
        "|", "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}]}], "]"}]}]}], ":=", 
   
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"opI", "::", "badlabel"}], ",", "label"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164048468923*^9, 3.456164054304545*^9}, {
   3.456164350091269*^9, 3.456164351506548*^9}, {3.456164383003541*^9, 
   3.4561643832272177`*^9}, {3.502158801180915*^9, 3.502158834993284*^9}, {
   3.662919787415085*^9, 3.6629199105414658`*^9}, {3.662920058473267*^9, 
   3.662920066873633*^9}, {3.662920481997321*^9, 3.662920484475556*^9}, 
   3.66292099047094*^9, {3.662922289621072*^9, 3.66292229767435*^9}, {
   3.699270505121118*^9, 3.69927051197042*^9}},
 CellLabel->
  "In[1284]:=",ExpressionUUID->"e00f6759-5a7b-47b7-8c1d-69fb454de862"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.699270692964303*^9},ExpressionUUID->"a436b159-fcad-47b4-ad5d-\
7c21c7f0803a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_opI", ",", "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, 3.589823595193626*^9},
 CellLabel->
  "In[1285]:=",ExpressionUUID->"605ca23a-ec9f-446c-b9e5-e0b0cd7726f9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["powers", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4607136282603827`*^9, 3.46071363575774*^9}, {
  3.4684245870224648`*^9, 3.468424588419835*^9}, {3.502158309581141*^9, 
  3.502158326256208*^9}, {3.5894814100354357`*^9, 3.589481415008752*^9}, {
  3.589481533549403*^9, 
  3.589481534468933*^9}},ExpressionUUID->"e17a34c5-7479-45d9-9234-\
768a1e2aa3e2"],

Cell[BoxData[
 RowBox[{"opI", "/:", " ", 
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"opI", "[", "args___", "]"}]}], ",", "n_"}], "]"}]}], "/;", 
   RowBox[{
    RowBox[{"IntegerQ", "[", "n", "]"}], "&&", 
    RowBox[{"(", 
     RowBox[{"n", ">", "0"}], ")"}]}]}], ":=", 
  RowBox[{"Nest", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"OperatorProduct", "[", 
      RowBox[{"#1", ",", "op"}], "]"}], "&"}], ",", 
    RowBox[{"UnityOperator", "[", "]"}], ",", "n"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502711466489697*^9, 3.502711535643238*^9}, {
  3.502711676597328*^9, 3.502711680436694*^9}, {3.502711750550703*^9, 
  3.502711752683069*^9}, {3.642409238171273*^9, 3.642409243544887*^9}, {
  3.699271009803091*^9, 3.69927103098518*^9}, {3.699271090905374*^9, 
  3.699271095842402*^9}},
 CellLabel->
  "In[1286]:=",ExpressionUUID->"ab9b6589-91ff-4cbb-a829-d7d6811ae90f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", " ", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Power", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"opI", "[", "args___", "]"}]}], ",", "0"}], "]"}]}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699271112157181*^9, 3.6992711431492243`*^9}, 
   3.699271245381649*^9},
 CellLabel->
  "In[1287]:=",ExpressionUUID->"ce14ff4c-6488-45c8-91da-58224bdb5574"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", " ", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Power", "[", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"opI", "[", "args___", "]"}]}], ",", "n_"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"IntegerQ", "[", "n", "]"}]}], ")"}], "||", 
     RowBox[{"(", 
      RowBox[{"n", "<", "0"}], ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"opI", "::", "badpower"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502711466489697*^9, 3.502711535643238*^9}, {
  3.502711676597328*^9, 3.502711680436694*^9}, {3.502711750550703*^9, 
  3.502711752683069*^9}, {3.597232683405572*^9, 3.5972327435622797`*^9}, {
  3.5972327793633947`*^9, 3.597232779824843*^9}, {3.597232816993671*^9, 
  3.597232821431538*^9}, {3.597232975572646*^9, 3.597233000028913*^9}, {
  3.699271156719037*^9, 3.699271204327565*^9}},
 CellLabel->
  "In[1288]:=",ExpressionUUID->"48b31dc4-2041-4f11-aecc-dd1c0b4ee339"]
}, Closed]],

Cell[CellGroupData[{

Cell["axes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.50215900522687*^9, 3.5021590085852222`*^9}, {
  3.6629196548797483`*^9, 3.6629196571657143`*^9}, {3.662920045362455*^9, 
  3.6629200459914227`*^9}, {3.699271402669608*^9, 
  3.699271402881024*^9}},ExpressionUUID->"f86b23c2-8977-44aa-939e-\
18747bc5461d"],

Cell[CellGroupData[{

Cell["negative axes", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.50215900522687*^9, 3.5021590085852222`*^9}, {
  3.6629196548797483`*^9, 3.6629196571657143`*^9}, {3.662920045362455*^9, 
  3.6629200459914227`*^9}, {3.699271402669608*^9, 
  3.69927141798988*^9}},ExpressionUUID->"6e88bad7-7dfa-42e8-a928-\
41ed03685554"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"spins_", ",", 
     RowBox[{
     "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", "|", "\"\<-x\>\""}], ",", 
     "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"opI", "[", 
     RowBox[{"spins", ",", "\"\<x\>\"", ",", "False", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512936577705*^9, 3.4395129427974052`*^9}, {
   3.456165060103366*^9, 3.456165063250568*^9}, 3.456165763546665*^9, {
   3.4561659513781023`*^9, 3.456165954645322*^9}, {3.460806933044715*^9, 
   3.460806941884218*^9}, 3.502163905397196*^9, 3.5021639917459307`*^9, {
   3.662919671863435*^9, 3.662919689869205*^9}, {3.662919725992034*^9, 
   3.662919732767543*^9}, {3.6629199978888063`*^9, 3.6629200009513063`*^9}, {
   3.699271299742177*^9, 3.69927132009261*^9}},
 CellLabel->
  "In[1289]:=",ExpressionUUID->"d56a2eed-4f88-4894-ac66-c7828bbd7af6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"spins_", ",", 
     RowBox[{
     "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"", "|", "\"\<-y\>\""}], ",", 
     "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"opI", "[", 
     RowBox[{"spins", ",", "\"\<y\>\"", ",", "False", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512936577705*^9, 3.4395129427974052`*^9}, {
   3.456165060103366*^9, 3.456165063250568*^9}, 3.456165763546665*^9, {
   3.4561659513781023`*^9, 3.456165954645322*^9}, {3.460806933044715*^9, 
   3.460806941884218*^9}, 3.502163905397196*^9, 3.5021639917459307`*^9, {
   3.662919671863435*^9, 3.662919747711115*^9}, {3.6629200065376*^9, 
   3.6629200108566103`*^9}, {3.6992713278469267`*^9, 3.6992713429782457`*^9}},
 
 CellLabel->
  "In[1290]:=",ExpressionUUID->"ea6c7332-d3fa-412b-9335-33b43285b3b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{"spins_", ",", 
     RowBox[{
     "\"\<\!\(\*OverscriptBox[\(z\), \(_\)]\)\>\"", "|", "\"\<-z\>\""}], ",", 
     "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"-", 
    RowBox[{"opI", "[", 
     RowBox[{"spins", ",", "\"\<z\>\"", ",", "False", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512936577705*^9, 3.4395129427974052`*^9}, {
   3.456165060103366*^9, 3.456165063250568*^9}, 3.456165763546665*^9, {
   3.4561659513781023`*^9, 3.456165954645322*^9}, {3.460806933044715*^9, 
   3.460806941884218*^9}, 3.502163905397196*^9, 3.5021639917459307`*^9, {
   3.662919671863435*^9, 3.662919747711115*^9}, {3.662919990571494*^9, 
   3.6629200134470243`*^9}, {3.699271334381809*^9, 3.699271347184966*^9}},
 CellLabel->
  "In[1291]:=",ExpressionUUID->"4ef3779b-cb62-4351-af52-4e59fe7fe355"]
}, Closed]],

Cell[CellGroupData[{

Cell["phase and polar angles", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.50215900522687*^9, 
  3.5021590085852222`*^9}},ExpressionUUID->"e602bbd2-92ac-4419-8ba6-\
eb937cb0f4a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"j_", "?", "ValidSpinQ"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Theta]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}], ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}]}], "}"}], ",", "False", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<z\>\"", ",", "False", ",", "opts"}], "]"}], 
     RowBox[{"Cos", "[", "\[Theta]", "]"}]}], "+", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\[Phi]", ",", "False", ",", "opts"}], "]"}], 
     RowBox[{"Sin", "[", "\[Theta]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50215901131614*^9, 3.502159100316667*^9}, {
  3.502162103547814*^9, 3.502162109702606*^9}, {3.699271441235553*^9, 
  3.699271475041272*^9}},
 CellLabel->
  "In[1292]:=",ExpressionUUID->"9fbe0ad4-f643-4149-afb6-90ad961836f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"j_", "?", "ValidSpinQ"}], ",", 
     RowBox[{"\[Phi]", ":", 
      RowBox[{"Except", "[", "_String", "]"}]}], ",", "False", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<x\>\"", ",", "False", ",", "opts"}], "]"}], 
     RowBox[{"Cos", "[", "\[Phi]", "]"}]}], "+", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<y\>\"", ",", "False", ",", "opts"}], "]"}], 
     RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50215901131614*^9, 3.5021590511885347`*^9}, {
  3.502162091001498*^9, 3.5021620964011183`*^9}, {3.699271485280096*^9, 
  3.699271504167891*^9}},
 CellLabel->
  "In[1293]:=",ExpressionUUID->"d811101d-c572-4cca-87ef-adbed98a9a23"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.699272839259281*^9, 
  3.6992728404156647`*^9}},ExpressionUUID->"0539169d-aad8-4faa-b797-\
52c5e80482ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"n1___Except", "[", 
        RowBox[{"_", "?", "OperatorQ"}], "]"}], ",", 
       RowBox[{"opI", "[", "args___", "]"}], ",", 
       RowBox[{"n2___Except", "[", 
        RowBox[{"_", "?", "OperatorQ"}], "]"}]}], "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ComplexExpand", "[", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"n1", "*", "n2"}], "]"}], "]"}], "*", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"opI", "[", "args", "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448290584384383*^9, 3.448290586384947*^9}, {
  3.449298157739973*^9, 3.449298160715259*^9}, {3.657821210717964*^9, 
  3.657821220779956*^9}},
 CellLabel->
  "In[1294]:=",ExpressionUUID->"68df593b-56d9-4454-b080-9ae7104a7cad"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", " ", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"spin_", ",", "\"\<+\>\"", ",", 
       RowBox[{"status", ":", 
        RowBox[{"(", 
         RowBox[{"False", "|", "True"}], ")"}]}], ",", "opts___Rule"}], 
      "]"}]}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"spin", ",", "\"\<-\>\"", ",", "False", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.699272678191156*^9, 3.699272726542203*^9}},
 CellLabel->
  "In[1295]:=",ExpressionUUID->"09b8d2bd-99b4-4646-84b4-e1042dc49370"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", " ", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"spin_", ",", "\"\<-\>\"", ",", 
       RowBox[{"status", ":", 
        RowBox[{"(", 
         RowBox[{"False", "|", "True"}], ")"}]}], ",", "opts___Rule"}], 
      "]"}]}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"spin", ",", "\"\<+\>\"", ",", "False", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.699272734543068*^9, 3.699272752462543*^9}},
 CellLabel->
  "In[1296]:=",ExpressionUUID->"a1df7375-7bee-45f9-9eb3-89ba040d4da6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", " ", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"spin_", ",", 
       RowBox[{"mu", ":", 
        RowBox[{"(", 
         RowBox[{
         "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", 
          "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], ")"}]}], ",", 
       RowBox[{"status", ":", 
        RowBox[{"(", 
         RowBox[{"False", "|", "True"}], ")"}]}], ",", "opts___Rule"}], 
      "]"}]}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"spin", ",", "mu", ",", "False", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.69927276143027*^9, 3.699272775975398*^9}},
 CellLabel->
  "In[1297]:=",ExpressionUUID->"a3912553-d809-4dd6-8bed-ca4b49fc032c"]
}, Closed]],

Cell[CellGroupData[{

Cell["set status flag to True", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.50215900522687*^9, 3.5021590085852222`*^9}, {
  3.6629196548797483`*^9, 3.6629196571657143`*^9}, {3.662920045362455*^9, 
  3.6629200459914227`*^9}, {3.699271402669608*^9, 3.699271402881024*^9}, {
  3.699271576011826*^9, 3.6992715797672443`*^9}, {3.6992716637296143`*^9, 
  3.699271667181202*^9}, {3.699271787414198*^9, 3.699271788356759*^9}, {
  3.69927262775589*^9, 
  3.6992726291826763`*^9}},ExpressionUUID->"7cc16f22-4745-4f43-a875-\
944cf23e5d60"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"j_", "?", "ValidSpinQ"}], ",", "False", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"j", ",", "True", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992715859082203`*^9, 3.699271653332882*^9}, {
  3.6992717912845793`*^9, 3.6992717948935833`*^9}},
 CellLabel->
  "In[1298]:=",ExpressionUUID->"7c2d6562-a3ae-4067-975c-1ed6d385ee5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "[", 
    RowBox[{
     RowBox[{"j_", "?", "ValidSpinQ"}], ",", 
     RowBox[{"\[Mu]", ":", 
      RowBox[{"(", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
        "|", "\"\<-\>\"", "|", "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], 
       ")"}]}], ",", "False", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"opI", "[", 
    RowBox[{"j", ",", "\[Mu]", ",", "True", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992715859082203`*^9, 3.699271653332882*^9}, 
   3.699271870352688*^9},
 CellLabel->
  "In[1299]:=",ExpressionUUID->"42b86408-4640-42e6-acd3-f7e58d33b511"]
}, Closed]],

Cell[CellGroupData[{

Cell["operation on Kets", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
  3.4608663310611763`*^9, 
  3.460866333810494*^9}},ExpressionUUID->"dd1356f3-c973-4698-8c21-\
c7904a7999d8"],

Cell[CellGroupData[{

Cell["operation on Kets (spin-1/2 specific)", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"485d49fa-d58d-43ce-aef2-15fd3edfa720"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{
      "i_", ",", "\"\<\[Alpha]\>\"", ",", "True", ",", "opts___Rule"}], "]"}],
      ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"1", "/", "2"}]}], "}"}], ",", "ket2"}], "}"}], ",", 
       "spins"}], "]"}]}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307486187*^9, {3.547024228246677*^9, 3.547024231533257*^9}, {
   3.6992728918647118`*^9, 3.69927289810728*^9}},
 CellLabel->
  "In[1300]:=",ExpressionUUID->"716f70bf-697a-4980-a3d7-ff458735b49f"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{
      "i_", ",", "\"\<\[Alpha]\>\"", ",", "True", ",", "opts___Rule"}], "]"}],
      ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307535472*^9, {3.547024241133391*^9, 3.547024241653331*^9}, {
   3.699272922906207*^9, 3.699272925671029*^9}},
 CellLabel->
  "In[1301]:=",ExpressionUUID->"feee4306-2e9a-49f2-b890-89dc33387847"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<\[Beta]\>\"", ",", "True", ",", "opts___Rule"}],
       "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273075867558`*^9, {3.5470242504691477`*^9, 3.547024250909039*^9}, 
   3.699272935348962*^9},
 CellLabel->
  "In[1302]:=",ExpressionUUID->"7e5d1770-16fe-45c4-a5a5-b27a6511aaf6"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<\[Beta]\>\"", ",", "True", ",", "opts___Rule"}],
       "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", "ket2"}], "}"}], 
       ",", "spins"}], "]"}]}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273076373167`*^9, {3.547024253557445*^9, 3.547024253937397*^9}, 
   3.699272941401428*^9},
 CellLabel->
  "In[1303]:=",ExpressionUUID->"e11f6d8a-eab1-49f9-beac-d02b9467c300"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307687673*^9, {3.5470242573169107`*^9, 3.547024257780735*^9}, 
   3.69927294655405*^9},
 CellLabel->
  "In[1304]:=",ExpressionUUID->"fcae40fb-fefd-4dcb-bf94-f6676d1ca953"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"+", "1"}], "/", "2"}]}], "}"}], ",", "ket2"}], "}"}], 
       ",", "spins"}], "]"}]}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.43352730773706*^9, {3.5470242624852247`*^9, 3.547024262932014*^9}, 
   3.69927295056919*^9},
 CellLabel->
  "In[1305]:=",ExpressionUUID->"d2150b8a-d18d-47a8-8466-332db45fa891"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", "ket2"}], "}"}], 
       ",", "spins"}], "]"}]}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307787722*^9, {3.547024265200719*^9, 3.547024265557498*^9}, 
   3.699272955429394*^9},
 CellLabel->
  "In[1306]:=",ExpressionUUID->"ecbb18a8-c672-4013-8b3e-2bd8d63ef376"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1___", ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "ket2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], "]"}]}],
   ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307837788*^9, {3.547024270004465*^9, 3.547024270380431*^9}, 
   3.699272959557969*^9},
 CellLabel->
  "In[1307]:=",ExpressionUUID->"4410f579-5139-4961-a862-e1da3734ebc3"]
}, Closed]],

Cell[CellGroupData[{

Cell["operation on Kets (general)", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 ExpressionUUID -> "3806c6bd-c5e2-46b3-8107-ee5eab612a1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<x\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", 
      RowBox[{"Ket", "[", "ket___", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", "2"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<+\>\"", ",", "opts"}], "]"}], "+", 
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<-\>\"", ",", "opts"}], "]"}]}], ")"}]}], ",", 
     
     RowBox[{"Ket", "[", "ket", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307888513*^9, {3.5470267801607*^9, 3.547026788429927*^9}, 
   3.5470269067740297`*^9, {3.699272973261779*^9, 3.699273012151043*^9}},
 CellLabel->
  "In[1308]:=",ExpressionUUID->"78525f5b-5183-44ee-8b3f-5636b370d3d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<y\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", 
      RowBox[{"Ket", "[", "ket___", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"op1", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{"2", "I"}], ")"}]}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<+\>\"", ",", "opts"}], "]"}], "-", 
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<-\>\"", ",", "opts"}], "]"}]}], ")"}]}], ",", 
     
     RowBox[{"Ket", "[", "ket", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307938159*^9, 3.547026904928213*^9, {3.699273021658746*^9, 
   3.699273036642723*^9}},
 CellLabel->
  "In[1309]:=",ExpressionUUID->"b98b8ef2-e2f2-4fdf-b334-e961933656e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<z\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", 
      RowBox[{"Ket", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ket1___", ",", 
          RowBox[{"{", 
           RowBox[{"i_", ",", "m_"}], "}"}], ",", "ket2___"}], "}"}], ",", 
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], 
     "]"}]}], ":=", 
   RowBox[{"m", "*", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1", ",", 
      RowBox[{"Ket", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ket1", ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "m"}], "}"}], ",", "ket2"}], "}"}], ",", 
        "spins"}], "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273079885073`*^9, {3.547024293234293*^9, 3.547024293587071*^9}, 
   3.547026902126171*^9, {3.69927308289323*^9, 3.6992730832634783`*^9}},
 CellLabel->
  "In[1310]:=",ExpressionUUID->"e8888444-46a6-4924-84b3-daee974c2ed6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", 
      RowBox[{"Ket", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ket1___", ",", 
          RowBox[{"{", 
           RowBox[{"i_", ",", "m_"}], "}"}], ",", "ket2___"}], "}"}], ",", 
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", 
         RowBox[{"i", ",", "spins"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "Ij"}], "<=", "m", "<", "Ij"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"Ij", 
             RowBox[{"(", 
              RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
            RowBox[{"m", 
             RowBox[{"(", 
              RowBox[{"m", "+", "1"}], ")"}]}]}], "]"}], "*", 
          RowBox[{"Dot", "[", 
           RowBox[{"op1", ",", 
            RowBox[{"Ket", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ket1", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"m", "+", "1"}]}], "}"}], ",", "ket2"}], "}"}], ",",
               "spins"}], "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", "0"}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308039178*^9, {3.547024297104949*^9, 3.54702430811207*^9}, {
   3.5470269719748507`*^9, 3.547027009846133*^9}, {3.547027047415106*^9, 
   3.54702714096826*^9}, {3.699273088215138*^9, 3.699273089147571*^9}},
 CellLabel->
  "In[1311]:=",ExpressionUUID->"f641658e-67fb-4fb8-91fb-5db03439be5c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{"op1___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", 
      RowBox[{"Ket", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ket1___", ",", 
          RowBox[{"{", 
           RowBox[{"i_", ",", "m_"}], "}"}], ",", "ket2___"}], "}"}], ",", 
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", 
         RowBox[{"i", ",", "spins"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "Ij"}], "<", "m", "<=", "Ij"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"Ij", 
             RowBox[{"(", 
              RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
            RowBox[{"m", 
             RowBox[{"(", 
              RowBox[{"m", "-", "1"}], ")"}]}]}], "]"}], "*", 
          RowBox[{"Dot", "[", 
           RowBox[{"op1", ",", 
            RowBox[{"Ket", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ket1", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"m", "-", "1"}]}], "}"}], ",", "ket2"}], "}"}], ",",
               "spins"}], "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", "0"}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308039178*^9, {3.547024297104949*^9, 3.54702430811207*^9}, {
   3.5470269719748507`*^9, 3.547027009846133*^9}, {3.547027047415106*^9, 
   3.547027159281517*^9}, {3.6992730982162027`*^9, 3.699273098597712*^9}},
 CellLabel->
  "In[1312]:=",ExpressionUUID->"c24d17b6-6c65-4afa-8400-ad6f81094e82"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["operation on Bras", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
  3.4608663310611763`*^9, 3.460866344321548*^9}},
 ExpressionUUID -> "dcffb335-e8de-4c9d-a434-287a6e7df1e7"],

Cell[CellGroupData[{

Cell["operation on Bras (spin-1/2 specific):", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"191f74c6-5d94-441f-9001-3f3d3319cc45"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", "bra___", "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<z\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", "bra", "]"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", "2"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<\[Alpha]\>\"", ",", "opts"}], "]"}], "-", 
        RowBox[{"opI", "[", 
         RowBox[{"i", ",", "\"\<\[Beta]\>\"", ",", "opts"}], "]"}]}], ")"}]}],
      ",", "op2"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308239731*^9, {3.6992732884776278`*^9, 3.699273298569083*^9}},
 CellLabel->
  "In[1313]:=",ExpressionUUID->"41ac6a06-9530-465c-9381-8d302cf9be3b"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{
      "i_", ",", "\"\<\[Alpha]\>\"", ",", "True", ",", "opts___Rule"}], "]"}],
      ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{"1", "/", "2"}]}], "}"}], ",", "bra2"}], "}"}], ",", 
       "spins"}], "]"}], ",", "op2"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308290515*^9, {3.547024341873694*^9, 3.547024342327448*^9}, {
   3.699273314219146*^9, 3.699273314544325*^9}},
 CellLabel->
  "In[1314]:=",ExpressionUUID->"f9303495-b73e-455f-a662-74bb31951618"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{
      "i_", ",", "\"\<\[Alpha]\>\"", ",", "True", ",", "opts___Rule"}], "]"}],
      ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273083396606`*^9, {3.547024347696697*^9, 3.547024348103386*^9}, {
   3.699273321587726*^9, 3.6992733219917727`*^9}},
 CellLabel->
  "In[1315]:=",ExpressionUUID->"958639bf-2ab7-4309-b643-a0a48de13eae"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<\[Beta]\>\"", ",", "True", ",", "opts___Rule"}],
       "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308390848*^9, {3.547024351768525*^9, 3.547024352215045*^9}, {
   3.699273327617133*^9, 3.6992733280555477`*^9}},
 CellLabel->
  "In[1316]:=",ExpressionUUID->"ee3c602c-9c73-4224-a235-c31e8e0215b2"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<\[Beta]\>\"", ",", "True", ",", "opts___Rule"}],
       "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", "bra2"}], "}"}], 
       ",", "spins"}], "]"}], ",", "op2"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308440041*^9, {3.5470243547931004`*^9, 3.547024355183319*^9}, {
   3.6992733344356813`*^9, 3.699273334795793*^9}},
 CellLabel->
  "In[1317]:=",ExpressionUUID->"b087ea28-4bbf-47e1-bb8a-041421fc71d7"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", "bra2"}], "}"}], 
       ",", "spins"}], "]"}], ",", "op2"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308490961*^9, {3.547024359968995*^9, 3.547024360496345*^9}, {
   3.6992733404656477`*^9, 3.6992733408811083`*^9}},
 CellLabel->
  "In[1318]:=",ExpressionUUID->"dd6ad5e3-45a4-4da4-a1df-439bf6e529f5"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308541143*^9, {3.547024363528096*^9, 3.547024363932391*^9}, {
   3.699273362358589*^9, 3.699273362807479*^9}},
 CellLabel->
  "In[1319]:=",ExpressionUUID->"d9efbd17-ecc7-4da7-876d-e451180694a1"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{"1", "/", "2"}]}], ")"}], "&"}], ")"}]}]}], "}"}], 
         ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"0", "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308591988*^9, {3.547024367543638*^9, 3.5470243679210987`*^9}, {
   3.699273366711217*^9, 3.699273367082552*^9}},
 CellLabel->
  "In[1320]:=",ExpressionUUID->"b41f7545-0b83-4c09-af9a-57f2fb3e3169"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "\[Equal]", 
                RowBox[{
                 RowBox[{"-", "1"}], "/", "2"}]}], ")"}], "&"}], ")"}]}]}], 
          "}"}], ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
            RowBox[{"+", "1"}], "/", "2"}]}], "}"}], ",", "bra2"}], "}"}], 
       ",", "spins"}], "]"}], ",", "op2"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"SpinQuantumNumber", "[", "i", "]"}], "==", 
    RowBox[{"1", "/", "2"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308641141*^9, {3.547024372048614*^9, 3.547024372427473*^9}, {
   3.699273371132791*^9, 3.6992733715262938`*^9}},
 CellLabel->
  "In[1321]:=",ExpressionUUID->"135a4e6e-3e42-42c2-a2c4-52075d804b32"]
}, Closed]],

Cell[CellGroupData[{

Cell["operation on Bras (general)", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"0e27024e-2000-473e-8661-a2737daf4721"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", "bra___", "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<x\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"Dot", "[", 
   RowBox[{
    RowBox[{"Bra", "[", "bra", "]"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", "2"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"i", ",", "\"\<+\>\"", ",", "opts"}], "]"}], "+", 
       RowBox[{"opI", "[", 
        RowBox[{"i", ",", "\"\<-\>\"", ",", "opts"}], "]"}]}], ")"}]}], ",", 
    "op2"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273086928177`*^9, {3.699273379637548*^9, 3.699273388525*^9}},
 CellLabel->
  "In[1322]:=",ExpressionUUID->"e7d695e2-3bd0-4532-9a20-5d8f380b2129"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", "bra___", "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<y\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"Dot", "[", 
   RowBox[{
    RowBox[{"Bra", "[", "bra", "]"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"2", "I"}], ")"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"i", ",", "\"\<+\>\"", ",", "opts"}], "]"}], "-", 
       RowBox[{"opI", "[", 
        RowBox[{"i", ",", "\"\<-\>\"", ",", "opts"}], "]"}]}], ")"}]}], ",", 
    "op2"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308741768*^9, {3.6992733929252167`*^9, 3.699273401654057*^9}},
 CellLabel->
  "In[1323]:=",ExpressionUUID->"fc19f191-74a3-42a2-aca2-ee6258e12d0d"],

Cell[BoxData[
 RowBox[{"opI", "/:", 
  RowBox[{"HoldPattern", "@", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1___", ",", 
         RowBox[{"{", 
          RowBox[{"i_", ",", "m_"}], "}"}], ",", "bra2___"}], "}"}], ",", 
       RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"i_", ",", "\"\<z\>\"", ",", "True", ",", "opts___Rule"}], 
      "]"}], ",", "op2___"}], "]"}]}], ":=", 
  RowBox[{"m", "*", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"bra1", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "m"}], "}"}], ",", "bra2"}], "}"}], ",", 
       "spins"}], "]"}], ",", "op2"}], "]"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273087921047`*^9, {3.547024379816009*^9, 3.5470243802244997`*^9}, {
   3.699273409710556*^9, 3.699273410148251*^9}},
 CellLabel->
  "In[1324]:=",ExpressionUUID->"18dccc43-9e4b-4ede-86d9-7084cd35926f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"Bra", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"bra1___", ",", 
          RowBox[{"{", 
           RowBox[{"i_", ",", "m_"}], "}"}], ",", "bra2___"}], "}"}], ",", 
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<+\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", "op2___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", 
         RowBox[{"i", ",", "spins"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "Ij"}], "<", "m", "<=", "Ij"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"Ij", 
             RowBox[{"(", 
              RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
            RowBox[{"m", 
             RowBox[{"(", 
              RowBox[{"m", "-", "1"}], ")"}]}]}], "]"}], "*", 
          RowBox[{"Dot", "[", 
           RowBox[{
            RowBox[{"Bra", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"bra1", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"m", "-", "1"}]}], "}"}], ",", "bra2"}], "}"}], ",",
               "spins"}], "]"}], ",", "op2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308842485*^9, {3.547024382829867*^9, 3.547024383257391*^9}, {
   3.547027306510538*^9, 3.547027322510572*^9}, {3.6992734163032417`*^9, 
   3.699273416696031*^9}},
 CellLabel->
  "In[1325]:=",ExpressionUUID->"0a69bb39-4947-435b-9f1f-45a3221fde26"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"Bra", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"bra1___", ",", 
          RowBox[{"{", 
           RowBox[{"i_", ",", "m_"}], "}"}], ",", "bra2___"}], "}"}], ",", 
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], ",", 
      RowBox[{"opI", "[", 
       RowBox[{"i_", ",", "\"\<-\>\"", ",", "True", ",", "opts___Rule"}], 
       "]"}], ",", "op2___"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", 
         RowBox[{"i", ",", "spins"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "Ij"}], "<=", "m", "<", "Ij"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{
            RowBox[{"Ij", 
             RowBox[{"(", 
              RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
            RowBox[{"m", 
             RowBox[{"(", 
              RowBox[{"m", "+", "1"}], ")"}]}]}], "]"}], "*", 
          RowBox[{"Dot", "[", 
           RowBox[{
            RowBox[{"Bra", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"bra1", ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", 
                  RowBox[{"m", "+", "1"}]}], "}"}], ",", "bra2"}], "}"}], ",",
               "spins"}], "]"}], ",", "op2"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "0"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527308842485*^9, {3.547024382829867*^9, 3.547024383257391*^9}, {
   3.547027306510538*^9, 3.5470273514433804`*^9}, {3.699273422558403*^9, 
   3.699273422950914*^9}},
 CellLabel->
  "In[1326]:=",ExpressionUUID->"9e4dcd06-688b-42bb-835c-1421954049e0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["output formats", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.5470241432453613`*^9, 3.547024148267552*^9}, 
   3.699272614998249*^9},ExpressionUUID->"b1978ade-fd29-4275-9f2b-\
766e6f609eed"],

Cell[BoxData[{
 RowBox[{"opI", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"opI", "[", 
     RowBox[{"j_Integer", ",", 
      RowBox[{"mu", ":", 
       RowBox[{"(", 
        RowBox[{
        "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
         "|", "\"\<-\>\"", "|", "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], 
        ")"}]}], ",", "True", ",", "opts___Rule"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}], ":=", " ", "\[IndentingNewLine]", 
  RowBox[{"Switch", "[", 
   RowBox[{"mu", ",", "\n", "\t", 
    RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"j", ",", "mu"}], "}"}], "]"}]}], "]"}], "//", 
     "DisplayForm"}], ",", "\n", "\t", 
    RowBox[{"\"\<+\>\"", "|", "\"\<-\>\""}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "mu"}], "]"}], "//", 
     "DisplayForm"}], ",", "\[IndentingNewLine]", "\t", "\"\<\[Alpha]\>\"", 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "\"\<\[Alpha]\>\""}], "]"}], 
     "//", "DisplayForm"}], ",", "\[IndentingNewLine]", "\t", 
    "\"\<\[Beta]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "\"\<\[Beta]\>\""}], "]"}], "//",
      "DisplayForm"}]}], "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{"\t"}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4335808568440027`*^9, 3.433580858137589*^9}, {
   3.456477602719366*^9, 3.456477620333963*^9}, {3.4564911842331247`*^9, 
   3.456491185659129*^9}, {3.4564963009560423`*^9, 3.456496302443788*^9}, 
   3.468424567049313*^9, 3.468424842675206*^9, {3.4684249302525787`*^9, 
   3.468424951452064*^9}, {3.468425036424312*^9, 3.468425038691141*^9}, {
   3.502077887190446*^9, 3.502077893066463*^9}, {3.502078065029108*^9, 
   3.502078067481276*^9}, {3.699268057660348*^9, 3.699268071315612*^9}, {
   3.699269208101274*^9, 3.699269208381425*^9}},
 CellLabel->
  "In[1327]:=",ExpressionUUID->"b6624477-01b0-439c-8de9-80d5321150ad"],

Cell[BoxData[{
 RowBox[{"opI", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_String", ",", 
       RowBox[{"mu", ":", 
        RowBox[{"(", 
         RowBox[{
         "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
          "|", "\"\<-\>\"", "|", "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}],
          ")"}]}], ",", "True", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"LowerCaseQ", "[", "j", "]"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Switch", "[", 
   RowBox[{"mu", ",", "\n", "\t", 
    RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"RowBox", "[", 
        RowBox[{"{", 
         RowBox[{"j", ",", "mu"}], "}"}], "]"}]}], "]"}], "//", 
     "DisplayForm"}], ",", "\n", "\t", 
    RowBox[{"\"\<+\>\"", "|", "\"\<-\>\""}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "mu"}], "]"}], "//", 
     "DisplayForm"}], ",", "\[IndentingNewLine]", "\t", "\"\<\[Alpha]\>\"", 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "\"\<\[Alpha]\>\""}], "]"}], 
     "//", "DisplayForm"}], ",", "\[IndentingNewLine]", "\t", 
    "\"\<\[Beta]\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubsuperscriptBox", "[", 
      RowBox[{"\"\<I\>\"", ",", 
       RowBox[{"ToString", "[", "j", "]"}], ",", "\"\<\[Beta]\>\""}], "]"}], "//",
      "DisplayForm"}]}], "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{"\t"}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4335808568440027`*^9, 3.433580858137589*^9}, {
   3.456477602719366*^9, 3.456477620333963*^9}, {3.4564911842331247`*^9, 
   3.456491185659129*^9}, {3.4564963009560423`*^9, 3.456496302443788*^9}, 
   3.468424567049313*^9, 3.468424842675206*^9, {3.4684249302525787`*^9, 
   3.468424951452064*^9}, {3.468425036424312*^9, 3.468425038691141*^9}, {
   3.46842524480124*^9, 3.46842525426556*^9}, 3.50207790155013*^9, 
   3.502078079212924*^9, {3.6992681045166397`*^9, 3.699268108532137*^9}, {
   3.699269213940033*^9, 3.699269214276493*^9}},
 CellLabel->
  "In[1328]:=",ExpressionUUID->"80ecd276-3196-4f64-8795-26f57b870085"],

Cell[BoxData[{
 RowBox[{"opI", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_String", ",", 
       RowBox[{"mu", ":", 
        RowBox[{"(", 
         RowBox[{
         "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
          "|", "\"\<-\>\"", "|", "\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}],
          ")"}]}], ",", "True", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"UpperCaseQ", "[", "j", "]"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{"Switch", "[", 
   RowBox[{"mu", ",", "\n", "\t", 
    RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SubscriptBox", "[", 
      RowBox[{
       RowBox[{"ToString", "[", "j", "]"}], ",", "mu"}], "]"}], "//", 
     "DisplayForm"}], ",", "\n", "\t", 
    RowBox[{
    "\"\<+\>\"", "|", "\"\<-\>\"", "|", "\"\<\[Alpha]\>\"", "|", 
     "\"\<\[Beta]\>\""}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SuperscriptBox", "[", 
      RowBox[{
       RowBox[{"ToString", "[", "j", "]"}], ",", "mu"}], "]"}], "//", 
     "DisplayForm"}]}], "\[IndentingNewLine]", "]"}]}], "\n", 
 RowBox[{"\t"}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4335808568440027`*^9, 3.433580888370934*^9}, {
   3.4335809477801323`*^9, 3.433580986192453*^9}, {3.4564776648563347`*^9, 
   3.4564776674581757`*^9}, 3.4564911895318537`*^9, {3.4564963056871*^9, 
   3.456496306961708*^9}, 3.4684245700223503`*^9, 3.468424844782661*^9, {
   3.468425079295343*^9, 3.4684250841449413`*^9}, {3.468425208340721*^9, 
   3.468425221181637*^9}, {3.6992681325294237`*^9, 3.699268146669572*^9}, {
   3.699269219294959*^9, 3.6992692196200533`*^9}},
 CellLabel->
  "In[1329]:=",ExpressionUUID->"b3b4c174-4ad2-4768-8fc9-4133d4e263ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_Integer", ",", "True", ",", "opts___Rule"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"SubscriptBox", "[", 
     RowBox[{
      OverscriptBox["\"\<I\>\"", "\[RightVector]"], ",", 
      RowBox[{"RowBox", "[", 
       RowBox[{"{", "j", "}"}], "]"}]}], "]"}], "//", "DisplayForm"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699272296067498*^9, 3.699272338827731*^9}, {
  3.6992724364714413`*^9, 3.69927246045336*^9}},
 CellLabel->
  "In[1330]:=",ExpressionUUID->"c07fed2d-8640-4648-af13-2a37c55142c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_String", ",", "True", ",", "opts___Rule"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", " ", 
   RowBox[{
    OverscriptBox[
     RowBox[{"ToString", "[", "j", "]"}], "\[RightVector]"], "//", 
    "DisplayForm"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699272296067498*^9, 3.699272378128211*^9}, 
   3.699272582081135*^9},
 CellLabel->
  "In[1331]:=",ExpressionUUID->"6f047cdb-bfeb-4cbc-bb1e-512c39c3ce62"]
}, Closed]],

Cell[CellGroupData[{

Cell["Angular momentum vector operator and dot products", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4607136282603827`*^9, 3.46071363575774*^9}, {
  3.4684245870224648`*^9, 3.468424588419835*^9}, {3.502158309581141*^9, 
  3.502158326256208*^9}, {3.5894814100354357`*^9, 
  3.589481415008752*^9}},ExpressionUUID->"bd091f29-5556-4ac5-a78d-\
a3ee4362a680"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"opIjvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"j_", ",", "True", ",", "optsj___Rule"}], "]"}]}], ",", 
      RowBox[{"matrices", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ".."}], ")"}]}], ",", 
      RowBox[{"vec", ":", 
       RowBox[{"{", 
        RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}]}]}], "]"}]}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"opIjvec", ",", 
     RowBox[{"Dot", "[", 
      RowBox[{"matrices", ",", "vec"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992754547749367`*^9, 3.699275471683392*^9}},
 CellLabel->
  "In[1332]:=",ExpressionUUID->"aea92cca-6c76-4505-94db-2a9d96f9e852"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"vec", ":", 
       RowBox[{"{", 
        RowBox[{"x_", ",", "y_", ",", "z_"}], "}"}]}], ",", 
      RowBox[{"matrices", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ".."}], ")"}]}], ",", 
      RowBox[{"opIkvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"k_", ",", "True", ",", "optsk___Rule"}], "]"}]}]}], "]"}]}], 
   ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"vec", ",", "matrices"}], "]"}], ",", "opIkvec"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992754547749367`*^9, 3.6992755356517067`*^9}},
 CellLabel->
  "In[1333]:=",ExpressionUUID->"4141c12d-d6cd-4aa4-be72-06eac18d0833"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"opIjvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"j_", ",", "True", ",", "optsj___Rule"}], "]"}]}], ",", 
      RowBox[{"vec", ":", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}]}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Inner", "[", "\[IndentingNewLine]", 
    RowBox[{"OperatorProduct", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "#", ",", "True", ",", "optsj"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}], "}"}]}], 
     ",", "\[IndentingNewLine]", "vec", ",", "\[IndentingNewLine]", "Plus"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992754547749367`*^9, 3.699275471683392*^9}, {
  3.6992755530565968`*^9, 3.6992755705270367`*^9}, {3.69927560428736*^9, 
  3.6992756716213913`*^9}, {3.6992758430422*^9, 3.6992758815943003`*^9}},
 CellLabel->
  "In[1334]:=",ExpressionUUID->"7eef77de-c912-4ca2-837d-fde6fd6a369b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"vec", ":", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", 
      RowBox[{"opIkvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"k_", ",", "True", ",", "optsk___Rule"}], "]"}]}]}], "]"}]}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"Inner", "[", "\[IndentingNewLine]", 
    RowBox[{
    "OperatorProduct", ",", "\[IndentingNewLine]", "vec", ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"k", ",", "#", ",", "True", ",", "optsk"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}], "}"}]}], 
     ",", "\[IndentingNewLine]", "Plus"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992754547749367`*^9, 3.699275471683392*^9}, {
   3.6992755530565968`*^9, 3.6992755705270367`*^9}, {3.69927560428736*^9, 
   3.6992756716213913`*^9}, {3.6992758430422*^9, 3.699275933502631*^9}, 
   3.699275978697029*^9},
 CellLabel->
  "In[1335]:=",ExpressionUUID->"091b40a7-5ae1-40ed-b0a2-3e4228bc3a55"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opI", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"opIjvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"j_", ",", "True", ",", "optsj___Rule"}], "]"}]}], ",", 
      RowBox[{"opIkvec", ":", 
       RowBox[{"opI", "[", 
        RowBox[{"k_", ",", "True", ",", "optsk___Rule"}], "]"}]}]}], "]"}]}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"Inner", "[", "\[IndentingNewLine]", 
    RowBox[{"OperatorProduct", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "#", ",", "True", ",", "optsj"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}], "}"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"k", ",", "#", ",", "True", ",", "optsk"}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<z\>\""}], "}"}]}], 
     ",", "\[IndentingNewLine]", "Plus"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6992754547749367`*^9, 3.699275471683392*^9}, {
   3.6992755530565968`*^9, 3.6992755705270367`*^9}, {3.69927560428736*^9, 
   3.6992756716213913`*^9}, {3.6992758430422*^9, 3.699275933502631*^9}, 
   3.699275978697029*^9, {3.69927706227203*^9, 3.699277075756857*^9}},
 CellLabel->
  "In[1336]:=",ExpressionUUID->"83c8df10-f8ea-4e6d-be4c-4b149b39bff0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"2a794473-6f35-4f9c-8e62-de185816581a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "::", "invalid\[Alpha]\[Beta]"}], "=", 
   "\"\<operator indices \[Alpha] and \[Beta] may only be used with spins-1/2\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[1337]:=",ExpressionUUID->"298df51e-8e0f-4be0-a753-6af31e63adbf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "::", "badpower"}], "=", 
   "\"\<opI cannot be raised to a non-integer or negative power.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5972330210607233`*^9, 3.5972330349196978`*^9}, {
  3.699271213184494*^9, 3.699271219031328*^9}},
 CellLabel->
  "In[1338]:=",ExpressionUUID->"da8a20ed-6dba-493c-afea-a3d822283129"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opI", "::", "badlabel"}], "=", 
   "\"\<\\\"`1`\\\" is an incorrect axis label for opI\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.662919928086499*^9, 3.662919961093837*^9}, {
  3.6629210012467537`*^9, 3.662921004947628*^9}},
 CellLabel->
  "In[1339]:=",ExpressionUUID->"b8a5f664-7bcb-406c-a9e1-4d73f43d0642"]
}, Closed]],

Cell[CellGroupData[{

Cell["ValidAxisSpecificationQ", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6673285972638597`*^9, 3.667328616232379*^9}, {
   3.6740248144387293`*^9, 3.674024816388267*^9}, {3.674027274358006*^9, 
   3.6740272765475273`*^9}, 
   3.674551815177718*^9},ExpressionUUID->"1bf02b67-0b7c-486f-8d6d-\
4f7b3cf4822c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidAxisSpecificationQ", "[", "axis_", "]"}], ":=", 
   RowBox[{"MatchQ", "[", 
    RowBox[{"axis", ",", 
     RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", 
      RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol", "|", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ",", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}]}], "}"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674027278614753*^9, 3.674027294188737*^9}, {
  3.681038524091634*^9, 3.68103853618571*^9}, {3.681038646471231*^9, 
  3.6810386711077757`*^9}},
 CellLabel->
  "In[1340]:=",ExpressionUUID->"71f50736-0cc5-437b-bc06-815fe5885c6a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationOperator opR", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.5020733423954887`*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"2a156b34-5f44-4f89-a254-eaf93cb163ce"],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"8e64d32a-483e-4b04-aedf-\
ca368db0af2b"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"opR", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617694750091*^9}},
 CellLabel->
  "In[1341]:=",ExpressionUUID->"bd8cd283-7c82-47c6-baab-d71aff37d472"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationOperator synonym", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}},ExpressionUUID->"bf2c388b-9c6e-4588-988d-\
deef6f0ca996"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotationOperator", "=", "opR"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460366514151391*^9, 3.460366523288849*^9}, {
  3.5924039699545*^9, 3.5924039735589113`*^9}},
 CellLabel->
  "In[1342]:=",ExpressionUUID->"91358ce8-ea98-498a-8302-abedcb4552cb"]
}, Closed]],

Cell[CellGroupData[{

Cell["Display", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"800e34d1-9f84-4f6e-ab31-074e546edebe"],

Cell[BoxData[
 RowBox[{"opR", "/:", 
  RowBox[{"Format", "[", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"opR", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", 
        RowBox[{"mu", ":", 
         RowBox[{"(", 
          RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\""}], 
          ")"}]}]}], "}"}]}], "]"}]}], "]"}], ":=", " ", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"RowBox", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SubscriptBox", "[", 
       RowBox[{"\"\<R\>\"", ",", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", 
          RowBox[{"j", ",", "mu"}], "}"}], "]"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\"\<(\>\"", ",", 
      RowBox[{"ToBoxes", "[", "\[Beta]", "]"}], ",", "\"\<)\>\""}], 
     "\[IndentingNewLine]", "}"}], "]"}], "//", "DisplayForm"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4335808568440027`*^9, 3.433580858137589*^9}, {
   3.456477602719366*^9, 3.456477620333963*^9}, {3.4564911842331247`*^9, 
   3.456491185659129*^9}, {3.4564963009560423`*^9, 3.456496302443788*^9}, {
   3.460807536761445*^9, 3.460807608152637*^9}, {3.460807869683996*^9, 
   3.460807979594675*^9}, {3.460808126336792*^9, 3.460808128768067*^9}, {
   3.460808207831951*^9, 3.460808209804885*^9}, 3.502077943297967*^9, 
   3.5020780872889633`*^9},
 CellLabel->
  "In[1343]:=",ExpressionUUID->"f4e3bb20-fa69-4bd2-aa58-dd2ac0bb5400"]
}, Closed]],

Cell[CellGroupData[{

Cell["product over spins", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 
  3.456165702536334*^9}},ExpressionUUID->"c6db0b0b-81c5-4055-a72e-\
95f323b7b801"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", "angs_List", "]"}], ":=", 
   RowBox[{"opR", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "angs"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456165717077775*^9, 3.4561657526796293`*^9}, {
  3.460632479052486*^9, 3.460632488274268*^9}, {3.460632519572681*^9, 
  3.460632523074102*^9}},
 CellLabel->
  "In[1344]:=",ExpressionUUID->"7b6e8e2b-658a-41c6-8f27-4fe95bfc4449"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"spins_List", ",", "angs_List"}], "]"}], ":=", 
   RowBox[{"Dot", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"opR", "[", 
        RowBox[{"#", ",", "angs"}], "]"}], "&"}], "/@", "spins"}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456165787042172*^9, 3.456165813336997*^9}, {
  3.460632492370968*^9, 3.460632524354501*^9}, {3.460806855886519*^9, 
  3.460806910836108*^9}},
 CellLabel->
  "In[1345]:=",ExpressionUUID->"24771b03-42d7-43ca-bb25-2b52aca9b2dd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Check Validity", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"9bdd1fd7-4805-4813-9d79-a0044568f363"],

Cell[CellGroupData[{

Cell["validity of spin index", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50215950434489*^9, 
  3.502159523559431*^9}},ExpressionUUID->"233582d9-eb36-473a-b712-\
32addde4c9d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{
     RowBox[{"j", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "ValidSpinQ"}], "]"}]}], ",", "___"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "::", "invspin"}], ",", "j"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4561640273806973`*^9, 3.4561640327281857`*^9}, {
   3.4561641780831337`*^9, 3.456164182274557*^9}, {3.456164339963925*^9, 
   3.456164341582505*^9}, {3.4561643853066063`*^9, 3.456164385506579*^9}, {
   3.5021596591763573`*^9, 3.50215966972503*^9}, 3.502162019268936*^9, {
   3.502162371018466*^9, 3.502162372335829*^9}, 3.502162477986485*^9, {
   3.502163436413474*^9, 3.502163437626649*^9}, {3.5021636315233173`*^9, 
   3.50216363219528*^9}, {3.503104828817175*^9, 3.503104830182611*^9}, {
   3.530465410273785*^9, 3.53046541138367*^9}, {3.5304654842371483`*^9, 
   3.530465484877143*^9}},
 CellLabel->
  "In[1346]:=",ExpressionUUID->"b692c63d-4711-448a-9746-3bc90005a2af"]
}, Closed]],

Cell[CellGroupData[{

Cell["validity of angle definition", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50215950434489*^9, 3.502159520398851*^9}, {
  3.502163618138534*^9, 3.502163621264894*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"588a6d20-820b-4d97-9dee-f58836a9a203"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"\[Beta]", ",", 
       RowBox[{"Except", "[", 
        RowBox[{"_List", "|", "_String"}], "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"opR", "::", "inv\[Beta]"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7225643615505247`*^9, 3.722564399443634*^9}, {
  3.722564430449308*^9, 3.722564444897505*^9}, {3.7225644890797367`*^9, 
  3.722564493025182*^9}},
 CellLabel->
  "In[1347]:=",ExpressionUUID->"b63bf9ca-895e-49a0-9a38-f42085cac2b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_String"}], "}"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", 
        "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", "|", "\"\<-x\>\"", 
        "|", "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"", "|", 
        "\"\<-y\>\""}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"opR", "::", "inv\[Phi]"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7225643615505247`*^9, 3.722564399443634*^9}, {
  3.722564430449308*^9, 3.722564481230769*^9}},
 CellLabel->
  "In[1348]:=",ExpressionUUID->"9163c31a-eca3-44a7-8693-f0bdba4cbde2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j_", ",", "\[CapitalOmega]_"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
      RowBox[{"\[CapitalOmega]", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "|", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}]}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_List", "|", "_String"}], "]"}], ",", 
            RowBox[{"Except", "[", 
             RowBox[{"_List", "|", "_String"}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "}"}]}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"opR", "::", "invangle"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608076480440073`*^9, 3.460807769642179*^9}, 
   3.50216369487983*^9, {3.502163725016018*^9, 3.5021638614740963`*^9}, {
   3.502163940039324*^9, 3.502163946453445*^9}, 3.5021639879762*^9, {
   3.722564169591838*^9, 3.722564173804405*^9}, {3.722564221795383*^9, 
   3.722564261347114*^9}, {3.722564546673751*^9, 3.722564573727085*^9}},
 CellLabel->
  "In[1349]:=",ExpressionUUID->"ced0be3c-483d-4563-b2bc-aa88bac609b6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.589823682333912*^9},ExpressionUUID->"81610bed-c5d8-4c19-9ef2-\
66f43c7fe0ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_opR", ",", "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9},
 CellLabel->
  "In[1350]:=",ExpressionUUID->"7eee579a-3124-446d-b4e5-8c273f2c8f63"]
}, Closed]],

Cell[CellGroupData[{

Cell["resolve into quadrature rotations", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866429414462*^9, 
  3.460866434587739*^9}},ExpressionUUID->"eaf6ea80-8610-4583-aac6-\
a8941f01c72f"],

Cell[CellGroupData[{

Cell["interpret text codes for negative axes", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4606325084993877`*^9, 3.460632512208582*^9}, {
  3.4608034101226254`*^9, 
  3.460803432454179*^9}},ExpressionUUID->"d28f1bf5-8391-4f5d-92ee-\
f8f713e411c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{
       "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", "|", "\"\<-x\>\""}]}], 
      "}"}]}], "]"}], ":=", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]", ",", "\[Pi]"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512936577705*^9, 3.4395129427974052`*^9}, {
   3.456165060103366*^9, 3.456165063250568*^9}, 3.456165763546665*^9, {
   3.4561659513781023`*^9, 3.456165954645322*^9}, {3.460806933044715*^9, 
   3.460806941884218*^9}, 3.502163905397196*^9, 3.5021639917459307`*^9},
 CellLabel->
  "In[1351]:=",ExpressionUUID->"9bdc62f4-6523-4834-a8cb-71cf594d412c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{
       "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"", "|", "\"\<-y\>\""}]}], 
      "}"}]}], "]"}], ":=", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]", ",", 
       RowBox[{"3", 
        RowBox[{"\[Pi]", "/", "2"}]}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512953574418*^9, 3.439512957104061*^9}, {
   3.456165067923259*^9, 3.456165071402966*^9}, 3.45616576501118*^9, {
   3.4561659587837267`*^9, 3.456165960999797*^9}, {3.460806947463855*^9, 
   3.4608069524077044`*^9}, 3.502163907308115*^9, 3.5021639950017843`*^9},
 CellLabel->
  "In[1352]:=",ExpressionUUID->"a10433e5-fe57-4f9c-bb0c-da61afd5836e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{
       "\"\<\!\(\*OverscriptBox[\(z\), \(_\)]\)\>\"", "|", "\"\<-z\>\""}]}], 
      "}"}]}], "]"}], ":=", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Beta]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439512953574418*^9, 3.439512957104061*^9}, {
   3.456165067923259*^9, 3.456165071402966*^9}, 3.45616576501118*^9, {
   3.4561659587837267`*^9, 3.456165960999797*^9}, {3.460806947463855*^9, 
   3.4608069524077044`*^9}, {3.4608668270278463`*^9, 3.460866835984929*^9}, 
   3.502163910060081*^9, 3.502163998225932*^9, {3.585661340545395*^9, 
   3.5856613427317*^9}},
 CellLabel->
  "In[1353]:=",ExpressionUUID->"c0cd9463-9e5b-483a-87d9-eaa8791cb1f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "label_String"}], "}"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"label", ",", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", 
        "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", "|", "\"\<-x\>\"", 
        "|", "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"", "|", "\"\<-y\>\"",
         "|", "\"\<\!\(\*OverscriptBox[\(z\), \(_\)]\)\>\"", "|", 
        "\"\<-z\>\""}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"opR", "::", "badlabel"}], ",", "label"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456164048468923*^9, 3.456164054304545*^9}, {
  3.456164350091269*^9, 3.456164351506548*^9}, {3.456164383003541*^9, 
  3.4561643832272177`*^9}, {3.502158801180915*^9, 3.502158834993284*^9}, {
  3.662919787415085*^9, 3.6629199105414658`*^9}, {3.662920058473267*^9, 
  3.662920066873633*^9}, {3.662920259134297*^9, 3.662920278582609*^9}},
 CellLabel->
  "In[1354]:=",ExpressionUUID->"c5459c0e-6293-4ff2-9461-4237646d9f38"]
}, Closed]],

Cell[CellGroupData[{

Cell["interpret numeric quadrature rotations", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4606325084993877`*^9, 3.460632512208582*^9}, {
  3.4608034101226254`*^9, 3.460803465218252*^9}, {3.5021640868622293`*^9, 
  3.502164133059847*^9}},ExpressionUUID->"67fd1893-c8e0-4327-a8e9-\
083b19bd4f7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<x\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"\[Phi]", ",", 
        RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", "0"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608034679837847`*^9, 3.460803529912565*^9}, {
   3.4608065262094707`*^9, 3.46080652904951*^9}, {3.460806573346319*^9, 
   3.460806587316154*^9}, {3.460806954728104*^9, 3.460806963431918*^9}, {
   3.460807300411663*^9, 3.460807304377366*^9}, {3.460807411611622*^9, 
   3.460807417754855*^9}, 3.5021640044843683`*^9},
 CellLabel->
  "In[1355]:=",ExpressionUUID->"3698e9c6-f28d-4d04-830e-c8b1e4b68758"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"\[Phi]", ",", 
        RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", 
      RowBox[{"\[Pi]", "/", "2"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608034679837847`*^9, 3.460803529912565*^9}, {
   3.4608065262094707`*^9, 3.460806555923216*^9}, {3.460806600717136*^9, 
   3.46080660612265*^9}, {3.460806955952118*^9, 3.460806965128167*^9}, {
   3.460807327172913*^9, 3.460807331787784*^9}, 3.460807423976399*^9, 
   3.502164007916539*^9},
 CellLabel->
  "In[1356]:=",ExpressionUUID->"64915363-13a7-4859-8374-b9a4a3e9ba8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Beta]"}], ",", "\"\<x\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"\[Phi]", ",", 
        RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", "\[Pi]"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608034679837847`*^9, 3.460803529912565*^9}, {
   3.4608065262094707`*^9, 3.460806555923216*^9}, {3.460806600717136*^9, 
   3.460806637562936*^9}, {3.460806956960137*^9, 3.460806966936211*^9}, {
   3.4608073285656443`*^9, 3.46080733378551*^9}, 3.4608074265537157`*^9, 
   3.502164012668396*^9},
 CellLabel->
  "In[1357]:=",ExpressionUUID->"177112da-00ad-41a2-bb39-334fec6004c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Beta]"}], ",", "\"\<y\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"Mod", "[", 
       RowBox[{"\[Phi]", ",", 
        RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", 
      RowBox[{"3", 
       RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608034679837847`*^9, 3.460803529912565*^9}, {
   3.4608065262094707`*^9, 3.460806555923216*^9}, {3.460806600717136*^9, 
   3.46080660612265*^9}, {3.4608066494925013`*^9, 3.460806653330035*^9}, {
   3.460806957976507*^9, 3.460806968728208*^9}, {3.4608073296533957`*^9, 
   3.4608073359776907`*^9}, 3.460807430387413*^9, 3.502164015692566*^9},
 CellLabel->
  "In[1358]:=",ExpressionUUID->"5ef297e4-aa54-4304-8acd-1a38990b2b6e"]
}, Closed]],

Cell[CellGroupData[{

Cell["interpret non-quadrature numeric codes", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4606325084993877`*^9, 3.460632512208582*^9}, {
  3.4608034101226254`*^9, 3.460803465218252*^9}, {3.46080697885872*^9, 
  3.460806979538604*^9}},ExpressionUUID->"0d87d982-1a11-4146-b3fd-\
53c81d1d46cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]_", ",", 
       RowBox[{"\[Phi]", ":", 
        RowBox[{"Except", "[", 
         RowBox[{"_List", "|", "_String"}], "]"}]}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Phi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<x\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Phi]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.4561651592964973`*^9}, 3.456165779005065*^9, {3.460806753701984*^9, 
   3.4608067573550243`*^9}, {3.460806995049152*^9, 3.460807007446332*^9}, {
   3.46080707430779*^9, 3.460807074555139*^9}, {3.460807438470347*^9, 
   3.460807441347269*^9}, 3.502164175946445*^9},
 CellLabel->
  "In[1359]:=",ExpressionUUID->"0e195f7b-ac9c-43fb-a6dd-31d56fa44e18"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "[", 
   RowBox[{"j_", ",", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]_", ",", "\[Beta]_", ",", "\[Gamma]_"}], "}"}]}], "]"}],
   ":=", 
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"\[Beta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{"\[Gamma]", ",", "\"\<z\>\""}], "}"}]}], "]"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.456165239506689*^9}, 3.456165780902337*^9, {3.46036575462481*^9, 
   3.460365783970495*^9}, {3.460806760861075*^9, 3.460806764258862*^9}, {
   3.460807017577052*^9, 3.460807046503889*^9}, 3.50216417833706*^9},
 CellLabel->
  "In[1360]:=",ExpressionUUID->"e830f217-d505-4ddd-bede-d3dbed3b1834"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Xi]_", ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]_", ",", "\[Phi]_"}], "}"}]}], "}"}]}], "]"}], ":=", 
   
   RowBox[{
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Phi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Theta]"}], ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"opR", "[", 
     RowBox[{"j", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Phi]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.456165239506689*^9}, 3.456165780902337*^9, {3.460806767110857*^9, 
   3.460806770148316*^9}, {3.460807022732131*^9, 3.460807053947661*^9}, 
   3.502164180226245*^9},
 CellLabel->
  "In[1361]:=",ExpressionUUID->"7211b5b8-3e43-4f7a-848a-7443798f31c4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["resolve zero rotations", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866429414462*^9, 3.460866434587739*^9}, {
  3.460866849726668*^9, 
  3.460866850363793*^9}},ExpressionUUID->"49c70de3-8b5d-4bdd-be06-\
718adc46f99c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "[", 
   RowBox[{"j_", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "\[Mu]_String"}], "}"}]}], "]"}], ":=", 
  RowBox[{"UnityOperator", "[", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460866852300704*^9, 3.460866867823077*^9}, 
   3.486464344420867*^9},
 CellLabel->
  "In[1362]:=",ExpressionUUID->"8041af2f-29f7-4910-8103-08ac21f65c18"]
}, Closed]],

Cell[CellGroupData[{

Cell["adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4606325084993877`*^9, 3.460632512208582*^9}, {
  3.4608034101226254`*^9, 3.460803465218252*^9}, {3.46080697885872*^9, 
  3.460806979538604*^9}, {3.4608083895284643`*^9, 
  3.4608083907166452`*^9}},ExpressionUUID->"fa7a6a52-1ab8-42f1-8493-\
92d3addac709"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opR", "[", 
      RowBox[{
       RowBox[{"j", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]_", ",", "\[Mu]_String"}], "}"}]}], "]"}]}], "]"}], ":=", 
   RowBox[{"opR", "[", 
    RowBox[{"j", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Beta]"}], ",", "\[Mu]"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.4561651592964973`*^9}, 3.456165779005065*^9, {3.460806753701984*^9, 
   3.4608067573550243`*^9}, {3.460806995049152*^9, 3.460807007446332*^9}, {
   3.46080707430779*^9, 3.460807074555139*^9}, {3.460807438470347*^9, 
   3.460807441347269*^9}, {3.460808396132412*^9, 3.460808443379002*^9}, {
   3.460808480934082*^9, 3.460808483729392*^9}},
 CellLabel->
  "In[1363]:=",ExpressionUUID->"b64a54cc-f886-4149-92aa-aac992e62544"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of OperatorProduct", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460866455661858*^9, 3.4608664596113577`*^9}, 
   3.657098522878578*^9},ExpressionUUID->"02628067-a316-4337-8b72-\
84c2321af3e7"],

Cell[CellGroupData[{

Cell["resolution of rotations about identical axes", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4608651423749332`*^9, 3.460865147716234*^9}, {
  3.460866503861841*^9, 
  3.460866519403687*^9}},ExpressionUUID->"55db3eda-98f4-4bc7-818a-\
49c85e7e2542"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a___", ",", 
      RowBox[{"opR", "[", 
       RowBox[{"j_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Beta]1_", ",", "\[Mu]_String"}], "}"}]}], "]"}], ",", 
      RowBox[{"opR", "[", 
       RowBox[{"j_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Beta]2_", ",", "\[Mu]_String"}], "}"}]}], "]"}], ",", 
      "b___", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", 
     RowBox[{"opR", "[", 
      RowBox[{"j", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Beta]1", "+", "\[Beta]2"}], ",", "\[Mu]"}], "}"}]}], 
      "]"}], ",", "b", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460866527564065*^9, 3.460866592455248*^9}, {
  3.642432175441354*^9, 3.642432254703882*^9}},
 CellLabel->
  "In[1364]:=",ExpressionUUID->"29c1f22a-9d5e-4d52-866e-c8af2a221327"]
}, Closed]],

Cell[CellGroupData[{

Cell["commutation with angular momentum operators on same axis", \
"Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4608651423749332`*^9, 3.460865147716234*^9}, {
  3.460866503861841*^9, 3.460866519403687*^9}, {3.460866719205146*^9, 
  3.460866731946619*^9}, {3.642432314954376*^9, 
  3.64243231517903*^9}},ExpressionUUID->"3aea172b-217f-4d47-8b2c-\
4b4a3bf7fd4f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{"a___", ",", 
      RowBox[{"opI", "[", 
       RowBox[{"j_", ",", "\[Mu]_String", ",", "___"}], "]"}], ",", 
      RowBox[{"opR", "[", 
       RowBox[{"j_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Beta]_", ",", "\[Mu]_String"}], "}"}]}], "]"}], ",", 
      "b___", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"OperatorProduct", "[", 
    RowBox[{"a", ",", 
     RowBox[{"opR", "[", 
      RowBox[{"j", ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "\[Mu]"}], "}"}]}], "]"}], ",", 
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\[Mu]"}], "]"}], ",", "b", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460866527564065*^9, 3.460866592455248*^9}, {
  3.642432175441354*^9, 3.642432303286537*^9}, {3.699277421011368*^9, 
  3.699277447167529*^9}},
 CellLabel->
  "In[1365]:=",ExpressionUUID->"a50a3c57-e06c-4c1f-90c9-15ea89de516e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["application to Ket", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460866455661858*^9, 3.4608664596113577`*^9}, {
  3.5924036522482557`*^9, 
  3.592403655884108*^9}},ExpressionUUID->"a60ad838-f5e8-49d2-a4b0-\
91419d2a36f7"],

Cell[BoxData[
 RowBox[{"opR", "/:", 
  RowBox[{"op_opR", "[", 
   RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
  RowBox[{"op", ".", "ket"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674989874202983*^9, 3.674989882179213*^9}},
 CellLabel->
  "In[1366]:=",ExpressionUUID->"140c26d4-6af4-4ae5-9d66-21528f986888"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"op_opR", ",", 
     RowBox[{"ket_", "?", "KetQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"SpinSystem", "[", "ket", "]"}], "]"}]}], ";", 
       RowBox[{"Inner", "[", 
        RowBox[{"Times", ",", 
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"op", ",", "basis"}], "]"}], ".", 
          RowBox[{"VectorRepresentation", "[", 
           RowBox[{"ket", ",", "basis"}], "]"}]}], ",", 
         RowBox[{"BasisKets", "[", "basis", "]"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.592403659837183*^9, 3.5924036695103903`*^9}, {
  3.592403717357657*^9, 3.592403747980558*^9}, {3.592403787072394*^9, 
  3.592403819809999*^9}, {3.592403879423382*^9, 3.592403894684475*^9}, {
  3.657354962857868*^9, 3.65735501961137*^9}, {3.657355076020653*^9, 
  3.657355088925887*^9}},
 CellLabel->
  "In[1367]:=",ExpressionUUID->"50021e8d-5966-49ca-b4d5-2c44d9150e8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opR", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"ops__", ",", "op_opR", ",", 
     RowBox[{"ket_", "?", "KetQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"SpinSystem", "[", "ket", "]"}], "]"}]}], ";", 
       RowBox[{"Dot", "[", 
        RowBox[{"ops", ",", 
         RowBox[{"Inner", "[", 
          RowBox[{"Times", ",", 
           RowBox[{
            RowBox[{"MatrixRepresentation", "[", 
             RowBox[{"op", ",", "basis"}], "]"}], ".", 
            RowBox[{"VectorRepresentation", "[", 
             RowBox[{"ket", ",", "basis"}], "]"}]}], ",", 
           RowBox[{"BasisKets", "[", "basis", "]"}]}], "]"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.592403659837183*^9, 3.5924036695103903`*^9}, {
  3.592403717357657*^9, 3.592403747980558*^9}, {3.592403787072394*^9, 
  3.592403819809999*^9}, {3.592403879423382*^9, 3.592403894684475*^9}, {
  3.592403929252486*^9, 3.592403945871636*^9}, {3.657355030988318*^9, 
  3.65735505506299*^9}, {3.65735509201825*^9, 3.6573550944923773`*^9}},
 CellLabel->
  "In[1368]:=",ExpressionUUID->"bcacad7e-f75e-4598-b525-abefbac9ddc3"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4608077840611353`*^9, 3.46080778691401*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"7fe1874f-53a1-42f3-9f0f-50a04370db4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "::", "inv\[Beta]"}], "=", 
   "\"\<invalid flip angle for opR.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
  3.502163713419979*^9, 3.502163719130096*^9}, {3.722564316497818*^9, 
  3.722564341683692*^9}, {3.7225652634180117`*^9, 3.722565270528062*^9}},
 CellLabel->
  "In[1369]:=",ExpressionUUID->"a820f01f-68bc-4c7d-8eec-dbe54d5059db"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "::", "inv\[Phi]"}], "=", 
   "\"\<invalid phase for opR.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
   3.502163713419979*^9, 3.502163719130096*^9}, {3.722564316497818*^9, 
   3.722564345335289*^9}, 3.722565275315414*^9},
 CellLabel->
  "In[1370]:=",ExpressionUUID->"76a260e3-49b1-485d-b093-b4e25f52b429"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "::", "invangle"}], "=", 
   "\"\<invalid angle definition for opR.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
   3.502163713419979*^9, 3.502163719130096*^9}, 3.7225652788141317`*^9},
 CellLabel->
  "In[1371]:=",ExpressionUUID->"ee70b165-41f4-4d2d-9a48-495f63961eca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opR", "::", "badlabel"}], "=", 
   "\"\<\\\"`1`\\\" is an invalid axis label for opR\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.662919928086499*^9, 3.662919961093837*^9}, {
  3.6629201285249453`*^9, 3.662920138259309*^9}, {3.662921016150951*^9, 
  3.662921017549446*^9}, {3.722565283315024*^9, 3.722565284412266*^9}},
 CellLabel->
  "In[1372]:=",ExpressionUUID->"1be65187-c678-4912-8305-cb21a650cda2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Spherical Tensor Operator opT", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.502073345531642*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"3fc569ca-409f-4d70-b0bc-36d399ae0ab9"],

Cell["\<\
code should allow definitions for arbitrary numbers of spins-1/2, or for \
single arbitrary spins.\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"16874396-c290-4f08-801f-0522253f35ba"],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"0e0788c5-4ddb-433c-becd-\
6a3b23a412f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"opT", ",", "NHoldFirst"}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617705680099*^9}, 
   3.744607596009159*^9},ExpressionUUID->"3b56be72-534b-426f-8330-\
80fdc335e8d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["General Definitions", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"29bfebf5-0b69-46d2-bf71-007eb0c020fc"],

Cell[CellGroupData[{

Cell["default options", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"e0403e59-f798-40bd-afb6-a64fb1e1b680"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "opT", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Normalize", "\[Rule]", "False"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447339657043318*^9, 3.447339661836679*^9}, {
   3.44734085113862*^9, 3.447340852806437*^9}, {3.447353043795908*^9, 
   3.447353062560718*^9}, 3.447390447068005*^9, 3.4681674340618763`*^9},
 CellLabel->"In[5]:=",ExpressionUUID->"939a6635-dd73-4df2-8f95-b7bfd06ab958"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implied sum over spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.640697630031262*^9, 3.640697646681181*^9}, {
  3.640697737723083*^9, 
  3.640697738317442*^9}},ExpressionUUID->"9f954cc2-66c4-4174-b092-\
a19a4b1eace3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Lambda]_", ",", "q_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Plus", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"opT", "[", 
        RowBox[{
         RowBox[{"First", "[", "#", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Lambda]", ",", "q"}], "}"}], ",", "opts"}], "]"}], "&"}],
       "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.64069764929079*^9, 3.640697724862482*^9}},
 CellLabel->"In[6]:=",ExpressionUUID->"ca91b066-5db2-4eaa-a819-bfbc80991647"]
}, Open  ]],

Cell[CellGroupData[{

Cell["return NullOperator if component > rank", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434353551974715*^9, 3.434353561732541*^9}, {
   3.547532387781258*^9, 3.547532393217634*^9}, 
   3.640697747466084*^9},ExpressionUUID->"ca784d36-96a3-4499-8c13-\
829b595e0542"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{"j_", ",", 
     RowBox[{"{", 
      RowBox[{"l_", ",", "m_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"NullOperator", "[", "]"}], "/;", 
    RowBox[{
     RowBox[{"Abs", "[", "m", "]"}], ">", "l"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343535640081663`*^9, 3.434353622585389*^9}, {
   3.467301345262966*^9, 3.467301347252172*^9}, 3.486710977973501*^9},
 CellLabel->"In[7]:=",ExpressionUUID->"ba3956b1-59e1-41e4-8f97-c4cf9bca871a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Normalize\[Rule]True", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447339775049552*^9, 3.44733979370369*^9}, 
   3.4473530691177*^9, 3.447390448773562*^9, 
   3.74460331267715*^9},ExpressionUUID->"de8fbaf7-7be5-4799-bd51-\
0b3092e48efd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"args", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NormalizeOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"opT", "[", 
     RowBox[{"args", ",", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
     "]"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4473431414340057`*^9, 3.4473431504030037`*^9}, 
   3.447343194285544*^9, {3.447343470509906*^9, 3.447343513706942*^9}, {
   3.44735307225264*^9, 3.447353074876433*^9}, {3.447353838961138*^9, 
   3.447353912562401*^9}, {3.447354677525845*^9, 3.447354679432637*^9}, {
   3.4473547438067007`*^9, 3.447354755789291*^9}, {3.447354838419389*^9, 
   3.447354842270113*^9}, {3.447354955920665*^9, 3.447354972601948*^9}, {
   3.4473550917009983`*^9, 3.447355095488125*^9}, {3.447355180934724*^9, 
   3.447355218413438*^9}, 3.4473553514512033`*^9, {3.447355460175951*^9, 
   3.447355549724358*^9}, {3.447390087824482*^9, 3.447390089568207*^9}, {
   3.4473902859601297`*^9, 3.4473903081537046`*^9}, {3.447390376016378*^9, 
   3.447390379549776*^9}, {3.447390453039782*^9, 3.447390454456162*^9}, {
   3.468167615914021*^9, 3.468167625730731*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"d3fbacff-343c-4950-83f1-29076b01cec7"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ISTOs for single spins ", "Subsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"7f25094e-e83c-404c-9228-7a3bd5d9bd89"],

Cell[CellGroupData[{

Cell["Check Validity", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"81d7f7c5-6a55-43b3-8529-42bebbcbfcdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"j", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", "___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"SpinSystem", "::", "invspin"}], ",", "j"}], "]"}], ";", 
      "$Failed"}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ValidSpinQ", "[", "j", "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456163686359743*^9, 3.456163694531169*^9}, 
   3.4561637741039133`*^9, 3.4561643985248823`*^9, {3.5031048415299788`*^9, 
   3.503104842902841*^9}, {3.530465489117921*^9, 3.530465489407185*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"81f0c039-7f33-45c3-a9ac-df39b24961aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"opT", "[", 
   RowBox[{
    RowBox[{"j", ":", 
     RowBox[{"Except", "[", "_List", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Lambda]_", ",", "q_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"opT", "::", "ranktoohigh"}], ";", 
     RowBox[{"NullOperator", "[", "]"}]}], ")"}], "/;", 
   RowBox[{"\[Lambda]", ">", 
    RowBox[{"2", 
     RowBox[{"SpinQuantumNumber", "[", "j", "]"}]}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639216610023213*^9, 3.639216693497613*^9}},
 CellLabel->"In[10]:=",ExpressionUUID->"fc181ff2-3e42-41b5-bbfa-caa3df638d2d"]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 0 for single spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6392916187348347`*^9, 
  3.639291621292622*^9}},ExpressionUUID->"3852f8dd-cf10-4a67-98e1-\
d4296e466d63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}, {
   3.6392916247414227`*^9, 3.639291634263685*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"2193e1e5-edde-4071-b1eb-23011c1cdbbc"]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 1 for single spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6392916541030273`*^9, 
  3.6392916550105247`*^9}},ExpressionUUID->"bca47b81-b5e8-458c-8e15-\
ea6a98b31d19"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"1", "/", 
       RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], "*", 
    RowBox[{"opI", "[", 
     RowBox[{"j", ",", "\"\<+\>\""}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"dae5f359-b2bc-438f-ac59-b4606c6dfa84"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], " ", ":=", "  ", 
   RowBox[{"opI", "[", 
    RowBox[{"j", ",", "\"\<z\>\""}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4473403789362926`*^9, 3.4473531024304447`*^9, {3.447390123516161*^9, 
   3.4473901249979153`*^9}, 3.447390430103053*^9, 3.468167482605332*^9},
 CellLabel->"In[13]:=",ExpressionUUID->"e580b62e-a0c6-4bc6-912b-bcc814baf78b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], " ", ":=", "  ", 
   RowBox[{
    RowBox[{"+", 
     RowBox[{"(", 
      RowBox[{"1", "/", 
       RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], "*", 
    RowBox[{"opI", "[", 
     RowBox[{"j", ",", "\"\<-\>\""}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4473403853522377`*^9, 3.447340402826272*^9}, 
   3.447353105990075*^9, {3.447390129783061*^9, 3.4473901315821877`*^9}, 
   3.447390430743415*^9, 3.468167487309264*^9},
 CellLabel->"In[14]:=",ExpressionUUID->"814100d9-3902-4c57-8690-91ffd0438f10"]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 2 for single spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.639206198826811*^9, 3.6392061993885603`*^9}, {
  3.639291657106167*^9, 
  3.639291657986854*^9}},ExpressionUUID->"40fdbc7f-28f5-4c8b-bfa3-\
94705a6f042f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "2"}], ")"}], "*", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<+\>\""}], "]"}], ".", 
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<+\>\""}], "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}, {
   3.63920641536751*^9, 3.63920644016473*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"a5a988c6-f264-47de-9c5f-f844cc4fd46c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"1", "/", "2"}], ")"}]}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<+\>\""}], "]"}], ".", 
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<z\>\""}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ".", 
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<+\>\""}], "]"}]}]}], ")"}]}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}, {
   3.63920641536751*^9, 3.6392064722844763`*^9}},
 CellLabel->"In[16]:=",ExpressionUUID->"709f8971-07ea-4c18-9b26-9e65f5d67e35"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], " ", ":=", "  ", 
   RowBox[{
    RowBox[{"6", "^", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "/", "2"}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ".", 
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<z\>\""}], "]"}]}]}], "-", 
      RowBox[{
       RowBox[{"opI", "[", "j", "]"}], ".", 
       RowBox[{"opI", "[", "j", "]"}]}]}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4473403789362926`*^9, 3.4473531024304447`*^9, {3.447390123516161*^9, 
   3.4473901249979153`*^9}, 3.447390430103053*^9, 3.468167482605332*^9, 
   3.639206204969638*^9, {3.6392063976209106`*^9, 3.6392064065583687`*^9}},
 CellLabel->"In[17]:=",ExpressionUUID->"cccd9c94-a5fb-4ef4-bfd7-37c4c974c155"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "1"}]}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{
    RowBox[{"+", 
     RowBox[{"(", 
      RowBox[{"1", "/", "2"}], ")"}]}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<-\>\""}], "]"}], ".", 
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<z\>\""}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ".", 
       RowBox[{"opI", "[", 
        RowBox[{"j", ",", "\"\<-\>\""}], "]"}]}]}], ")"}]}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}, {
   3.63920641536751*^9, 3.6392064936277847`*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"8755516b-58ee-4158-ae9e-db4c54973f6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "2"}]}], "}"}], ",", "opts___Rule"}], "]"}], " ", "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}]}], ":=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "2"}], ")"}], "*", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<-\>\""}], "]"}], ".", 
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<-\>\""}], "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340264625153*^9, 3.447340353951291*^9}, 
   3.44735310012815*^9, {3.4473901130851192`*^9, 3.447390116046155*^9}, 
   3.447390429376505*^9, {3.468167458660882*^9, 3.468167473633902*^9}, {
   3.63920641536751*^9, 3.63920644016473*^9}, {3.6392065012555437`*^9, 
   3.639206513641766*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"4f590706-e609-481c-ba36-d65cff7aac61"]
}, Closed]],

Cell[CellGroupData[{

Cell["higher-rank ISTOs for single spins ", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.639291664126954*^9, 
  3.639291668074421*^9}},ExpressionUUID->"b051ec61-0356-48c4-bd08-\
866cf7ecc510"],

Cell["\<\
express using the matrix representations, calculated using the Wigner-Eckart \
theorem\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639206526152133*^9, 
  3.6392065430500174`*^9}},ExpressionUUID->"2fead082-dc65-4f12-9fef-\
7944ab512b0d"],

Cell["\<\
sign switch for odd \[Lambda] introduced to be consistent with C. W. Chung \
and S. Wimperis, \[OpenCurlyDoubleQuote]Measurement Of Spin-5/2 Relaxation In \
Biological And Macromolecular Systems Using Multiple-Quantum NMR Techniques,\
\[CloseCurlyDoubleQuote] Mol. Phys. 76, 47-81 (1992).\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6406966198369703`*^9, 3.64069663563205*^9}, 
   3.640696744665086*^9},ExpressionUUID->"1aa95fd0-be27-43b9-98e3-\
6c2047119b07"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReducedISTOMatrixElement", "[", 
    RowBox[{"Ij_", ",", "\[Lambda]_"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"ReducedISTOMatrixElement", "[", 
      RowBox[{"Ij", ",", "\[Lambda]"}], "]"}], "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], "^", "\[Lambda]"}], "/", 
      RowBox[{"(", 
       RowBox[{"Sqrt", "@", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Abs", "[", 
            RowBox[{"CG", "[", 
             RowBox[{
              RowBox[{"{", "Ij", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"\[Lambda]", ",", "0"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Ij", ",", "m"}], "}"}]}], "]"}], "]"}], "^", "2"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"m", ",", 
            RowBox[{"-", "Ij"}], ",", 
            RowBox[{"+", "Ij"}], ",", "1"}], "}"}]}], "]"}]}], ")"}]}]}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639206575959935*^9, 3.6392065960549297`*^9}, {
  3.639206631457951*^9, 3.639206638815833*^9}, {3.6406966075308437`*^9, 
  3.640696612017765*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"39d932d4-6531-4f57-9dc8-e46854775a99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ISTOmatel", "[", 
     RowBox[{"Ij_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]_", ",", "\[Mu]_"}], "}"}]}], "]"}], "[", 
    RowBox[{"{", 
     RowBox[{"m1_", ",", "m2_"}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"CG", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Ij", ",", "m1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Ij", ",", "m2"}], "}"}]}], "]"}], "*", 
    RowBox[{"ReducedISTOMatrixElement", "[", 
     RowBox[{"Ij", ",", "\[Lambda]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.639207053077323*^9, 3.744607378918035*^9},
 CellLabel->"In[21]:=",ExpressionUUID->"7805295e-a303-4375-a70a-e41ebff87307"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]_", ",", "\[Mu]_"}], "}"}], ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[Mu]", "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Normalize", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"opT", "::", "high\[Lambda]"}], "]"}], ";", " ", 
       RowBox[{"Off", "[", 
        RowBox[{"opT", "::", "high\[Lambda]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", "j", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Band", "[", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"\[Mu]", "+", "1"}]}], "}"}], "]"}], ":>", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ISTOmatel", "[", 
                RowBox[{"Ij", ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}]}], "]"}], "[", 
               RowBox[{"{", 
                RowBox[{"m", ",", 
                 RowBox[{"m", "-", "\[Mu]"}]}], "}"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", "Ij", ",", 
                RowBox[{
                 RowBox[{"-", "Ij"}], "+", "\[Mu]"}], ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}], ",", 
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"j", ",", "Ij"}], "}"}], "}"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6392067603796043`*^9, 3.639206909486391*^9}, {
  3.6392069807911053`*^9, 3.639206981105088*^9}, {3.6392072635425863`*^9, 
  3.639207286683216*^9}, {3.639207715698501*^9, 3.639207733740568*^9}, {
  3.744607947695203*^9, 
  3.744607948493141*^9}},ExpressionUUID->"9617287e-a0e5-437e-811c-\
2ac0342fda89"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"opT", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"\[Lambda]_", ",", "\[Mu]_"}], "}"}], ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[Mu]", "<", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Normalize", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "Ij", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"opT", "::", "high\[Lambda]"}], "]"}], ";", " ", 
       RowBox[{"Off", "[", 
        RowBox[{"opT", "::", "high\[Lambda]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ij", "=", 
        RowBox[{"SpinQuantumNumber", "[", "j", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Band", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "-", "\[Mu]"}], ",", "1"}], "}"}], "]"}], ":>", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ISTOmatel", "[", 
                RowBox[{"Ij", ",", 
                 RowBox[{"{", 
                  RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}]}], "]"}], "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"m", "+", "\[Mu]"}], ",", "m"}], "}"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", "Ij", ",", 
                RowBox[{
                 RowBox[{"-", "Ij"}], "-", "\[Mu]"}], ",", 
                RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}], ",", 
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"j", ",", "Ij"}], "}"}], "}"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6392067603796043`*^9, 3.639206909486391*^9}, {
   3.6392069807911053`*^9, 3.639207010821413*^9}, 3.6392072912656193`*^9, {
   3.6392077556119556`*^9, 3.639207758377797*^9}, {3.744607955935817*^9, 
   3.744607956576817*^9}},ExpressionUUID->"f4ec824d-9e33-44ae-a562-\
78b269d6348e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["explicit definitions for pairs of spins", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7446064011456757`*^9, 3.7446064104961576`*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"d4f1206b-50fe-4519-ac0d-d49c2c133a5a"],

Cell[CellGroupData[{

Cell["construct {2,0} component from two rank 1\[CloseCurlyQuote]s.", \
"Subsubsection",
 CellChangeTimes->{{3.744608569708902*^9, 
  3.74460860127162*^9}},ExpressionUUID->"65cc71e6-af9f-49e4-954a-\
5700580a1254"],

Cell["\<\
This was taking too long to execute, for unknown reasons. However this \
problem remains unsolved (v3.2.1b3)\
\>", "Text",
 CellChangeTimes->{{3.744606414496183*^9, 3.744606433851099*^9}, {
  3.7446077901525917`*^9, 3.744607793651504*^9}, {3.7446084539148827`*^9, 
  3.744608487724353*^9}},ExpressionUUID->"bce51ad2-d871-4288-95b1-\
7cca6fe2039a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"j", ":", 
            RowBox[{"Except", "[", "_List", "]"}]}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"k", ":", 
            RowBox[{"Except", "[", "_List", "]"}]}], ",", "1"}], "}"}]}], 
        "}"}], ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "0"}], "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", "\"\<using explicit rule\>\"", "]"}], ";"}], 
     "*)"}], 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"opI", "[", 
          RowBox[{"j", ",", "\"\<-\>\""}], "]"}], ".", 
         RowBox[{"opI", "[", 
          RowBox[{"k", ",", "\"\<+\>\""}], "]"}]}], "+", 
        RowBox[{
         RowBox[{"opI", "[", 
          RowBox[{"j", ",", "\"\<+\>\""}], "]"}], ".", 
         RowBox[{"opI", "[", 
          RowBox[{"k", ",", "\"\<-\>\""}], "]"}]}], "-", 
        RowBox[{"4", 
         RowBox[{
          RowBox[{"opI", "[", 
           RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ".", 
          RowBox[{"opI", "[", 
           RowBox[{"k", ",", "\"\<z\>\""}], "]"}]}]}]}], ")"}]}], "/", 
     RowBox[{"(", 
      RowBox[{"2", 
       RowBox[{"Sqrt", "[", "6", "]"}]}], ")"}]}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744606445208921*^9, 3.744606569439147*^9}, {
  3.7446077482182417`*^9, 3.744607771508979*^9}, {3.744608141523405*^9, 
  3.744608153972114*^9}, {3.744608434365234*^9, 
  3.744608445463284*^9}},ExpressionUUID->"732c04a6-ee3b-46e8-9009-\
8d91446b6819"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["composition procedure for several coupled interactions", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"ce4edd31-f6d5-4147-956c-34f38d3ff62a"],

Cell[CellGroupData[{

Cell["single interaction op ", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"38f6e72f-5d0b-4f16-a45b-2ec4f1690171"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"intID_", ",", 
       RowBox[{"{", 
        RowBox[{"l_", ",", "m_"}], "}"}]}], "}"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"opT", "[", 
    RowBox[{"intID", ",", 
     RowBox[{"{", 
      RowBox[{"l", ",", "m"}], "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343519017552547`*^9, 3.434351903095664*^9}},
 CellLabel->"In[25]:=",ExpressionUUID->"220a63f6-dee2-4756-a441-6cee876bc8e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", "initID_", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"l_", ",", "m_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"opT", "[", 
    RowBox[{"initID", ",", 
     RowBox[{"{", 
      RowBox[{"l", ",", "m"}], "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434171853022121*^9, 3.434171884702097*^9}, 
   3.434171938457052*^9, {3.43435185838836*^9, 3.434351906013348*^9}, 
   3.74460757575595*^9},ExpressionUUID->"d75c6d74-e50d-4d08-866d-\
b14df6523e50"]
}, Closed]],

Cell[CellGroupData[{

Cell["Empty interaction list of rank 0 \[Rule] unity operator", \
"Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434353838632328*^9, 3.4343538521804113`*^9}, {
   3.434353894662813*^9, 3.434353911916463*^9}, {3.434353987929242*^9, 
   3.434354001067998*^9}, 
   3.44733996051054*^9},ExpressionUUID->"d096b117-c010-4ccb-81c8-\
77207ad00fdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"BasisDimension", "[", "]"}], "]"}]}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"OptionValue", "[", 
      RowBox[{"opT", ",", "Normalize"}], "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343539211808043`*^9, 3.434353951334034*^9}, {
   3.434354021578392*^9, 3.434354034230131*^9}, {3.447353245420926*^9, 
   3.447353272548627*^9}, 3.4473904326255627`*^9, 3.486464352446607*^9},
 CellLabel->"In[27]:=",ExpressionUUID->"56aeff15-98ae-4ff6-9a94-15ba9de96325"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "0", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"BasisDimension", "[", "]"}], "]"}]}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"OptionValue", "[", 
      RowBox[{"opT", ",", "Normalize"}], "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343539211808043`*^9, 3.434353951334034*^9}, {
   3.434354021578392*^9, 3.434354034230131*^9}, {3.434482640948845*^9, 
   3.434482642944499*^9}, {3.447353280322775*^9, 3.447353304793129*^9}, 
   3.4473904339531918`*^9, 3.486464353542934*^9},
 CellLabel->"In[28]:=",ExpressionUUID->"2362bf6f-0464-4786-867b-21bf81084f7f"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
combine 2 ops to get a new one, of a given rank. In general, this form \
requires specification of the entire construction history\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"92c5c87b-1b41-4fba-ba47-88802ac464ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"intID1_", ",", "l1_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"intID2_", ",", "l2_"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"intID1", ",", "l1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"intID2", ",", "l2"}], "}"}]}], "}"}], ",", "Lam"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.7446075718415327`*^9},ExpressionUUID->"98f14ecf-0942-4800-af09-\
021f0dc861d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"intID1_", ",", "l1_"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"intID2_", ",", "l2_"}], "}"}]}], "}"}], ",", "Lam_"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"CG", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Lam", ",", "M"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"l1", ",", "mu1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"l2", ",", 
           RowBox[{"M", "-", "mu1"}]}], "}"}]}], "]"}], " ", 
       RowBox[{
        RowBox[{"opT", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"intID1", ",", 
            RowBox[{"{", 
             RowBox[{"l1", ",", "mu1"}], "}"}]}], "}"}], ",", 
          RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}], 
        ".", 
        RowBox[{"opT", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"intID2", ",", 
            RowBox[{"{", 
             RowBox[{"l2", ",", 
              RowBox[{"M", "-", "mu1"}]}], "}"}]}], "}"}], ",", 
          RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}]}],
       ",", 
      RowBox[{"{", 
       RowBox[{"mu1", ",", 
        RowBox[{"-", "l1"}], ",", 
        RowBox[{"+", "l1"}], ",", "1"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434482863856345*^9, 3.434482869443671*^9}, {
  3.434516289474863*^9, 3.4345162917202806`*^9}, {3.447354181489654*^9, 
  3.447354194006715*^9}, {3.447390435844118*^9, 3.447390436554862*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"e2538ae3-9d48-4998-be26-d871bf688649"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
specify operator from a set of interactions, ranks, and rank histories. \
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"cf32e34f-22a3-4f32-8c24-89137d0d81c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"interactions", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ID1_", ",", "l1_"}], "}"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], "..."}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"rankhistory", ":", 
      RowBox[{"{", 
       RowBox[{"___", ",", "Lam_"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"IDs", ",", "ranks"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"IDs", ",", "ranks"}], "}"}], "=", 
         RowBox[{"Transpose", "[", "interactions", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"opT", "[", 
           RowBox[{
            RowBox[{"First", "[", "#", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}], "&"}], 
         "@", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"NestWhile", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Take", "[", 
                  RowBox[{"#", ",", "2"}], "]"}], ",", "\[IndentingNewLine]", 
                 
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"Drop", "[", 
                   RowBox[{"#", ",", "2"}], "]"}]}]}], "\[IndentingNewLine]", 
                "}"}], "&"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Flatten", "/@", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{"interactions", ",", "rankhistory"}], "}"}], 
                "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Length", "[", "#", "]"}], ">", "2"}], ")"}], 
               "&"}]}], "\[IndentingNewLine]", "]"}], "//.", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"int1_", ",", "lam1_", ",", "Lam1_"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"int2_", ",", "lam2_", ",", "Lam2_"}], "}"}]}], 
                "}"}], "\[RuleDelayed]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"int1", ",", "lam1"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"int2", ",", "lam2"}], "}"}]}], "}"}], ",", 
                 "Lam2"}], "}"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"int1_", ",", "lam1_"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"int2_", ",", "lam2_", ",", "Lam2_"}], "}"}], ",", 
                 "rest___"}], "}"}], "\[RuleDelayed]", "\[IndentingNewLine]", 
               
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"int1", ",", "lam1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"int2", ",", "lam2"}], "}"}]}], "}"}], ",", 
                   "Lam2"}], "}"}], ",", "rest"}], "}"}]}]}], 
             "\[IndentingNewLine]", "}"}]}], "//.", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", "args___", "}"}], "}"}], "\[RuleDelayed]", 
            RowBox[{"{", "args", "}"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}], "]"}], " ", "/;", 
    RowBox[{
     RowBox[{"Length", "[", "interactions", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "rankhistory", "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4344825761888933`*^9, 3.4344825770982122`*^9}},
 CellLabel->"In[31]:=",ExpressionUUID->"65394201-6ec6-418c-8609-c26167966a90"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Returns a single result if there is only one way of getting the desired rank. \
Otherwise return a list of all operators, and a message\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343519417000837`*^9, 
  3.434351958391111*^9}},ExpressionUUID->"488cc195-46fe-4565-a4ce-\
660e11d9ae4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"interactions", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ID1_", ",", "l1_"}], "}"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], "..."}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"IDs", ",", "ranks", ",", "rankhistories"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IDs", ",", "ranks"}], "}"}], "=", 
        RowBox[{"Transpose", "[", "interactions", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rankhistories", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"RankHistories", "[", "ranks", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Last", "[", "#", "]"}], "\[Equal]", "Lam"}], ")"}], 
           "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Length", "[", "rankhistories", "]"}], ",", 
         "\[IndentingNewLine]", "\t", "0", ",", 
         RowBox[{"NullOperator", "[", "]"}], ",", "\[IndentingNewLine]", "\t",
          "1", ",", 
         RowBox[{"Simplify", "@", 
          RowBox[{"opT", "[", 
           RowBox[{"interactions", ",", 
            RowBox[{"First", "@", "rankhistories"}], ",", 
            RowBox[{"{", 
             RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "\t", "_", ",", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"opT", "::", "multiple"}], ",", 
             RowBox[{"Length", "[", "rankhistories", "]"}]}], "]"}], ";", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Simplify", "@", 
               RowBox[{"opT", "[", 
                RowBox[{"interactions", ",", "#", ",", 
                 RowBox[{"{", 
                  RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], 
              ")"}], "&"}], "/@", "rankhistories"}]}], "\[IndentingNewLine]", 
          ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434352061435503*^9, 3.434352095046597*^9}, {
  3.547532469778674*^9, 3.547532475459003*^9}, {3.639227116735002*^9, 
  3.639227116923709*^9}, {3.639227358588689*^9, 3.639227398009153*^9}, {
  3.639229948282481*^9, 3.6392299539842978`*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"788f109b-72f1-4b23-ad2e-8a46cb9f2e2e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Specify the history number. ", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"c844b8fd-f8c0-4af7-af90-22fe27c82200"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"interactions", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ID1_", ",", "l1_"}], "}"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], "..."}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "index_Integer", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"IDs", ",", "ranks"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IDs", ",", "ranks"}], "}"}], "=", 
        RowBox[{"Transpose", "[", "interactions", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rankhistories", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"RankHistories", "[", "ranks", "]"}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Last", "[", "#", "]"}], "\[Equal]", "Lam"}], ")"}], 
           "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"opT", "[", 
        RowBox[{"interactions", ",", 
         RowBox[{
         "rankhistories", "\[LeftDoubleBracket]", "index", 
          "\[RightDoubleBracket]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4345262451666327`*^9, 3.4345262509477453`*^9}},
 CellLabel->"In[33]:=",ExpressionUUID->"dca81de6-cf49-4790-96dc-b5f2e476e8a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
compute all possible rank histories deriving from a given sequence of coupled \
ranks\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"826f7906-d654-4e21-b4d4-b85d89d8523d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RankHistories", "[", 
    RowBox[{"{", "l1_", "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"{", "l1", "}"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.744607563255315*^9},ExpressionUUID->"21a67af1-becb-4698-a920-\
97961a6e757f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RankHistories", "[", 
    RowBox[{"{", 
     RowBox[{"l1__", ",", "l2_"}], "}"}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Append", "[", 
          RowBox[{"#", ",", "l12"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"l12", ",", 
           RowBox[{"Abs", "[", 
            RowBox[{"l2", "-", 
             RowBox[{"Last", "[", "#", "]"}]}], "]"}], ",", 
           RowBox[{"Abs", "[", 
            RowBox[{"l2", "+", 
             RowBox[{"Last", "[", "#", "]"}]}], "]"}], ",", "1"}], "}"}]}], 
        "\[IndentingNewLine]", "]"}], "&"}], " ", "/@", 
      RowBox[{"RankHistories", "[", 
       RowBox[{"{", "l1", "}"}], "]"}]}], ",", "1"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.744607560711228*^9},ExpressionUUID->"7081805e-b071-478b-bc5e-\
666fe9716608"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["routines for a list of spins", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f067e993-b365-436c-b926-a31e0b6322c5"],

Cell[CellGroupData[{

Cell["\<\
check that when a list of spins is specified they are all valid\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"9d92a1ef-43ae-4b27-9c68-20aaeb519da1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", "args__",
      ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"SpinSystem", "::", "invspin"}], ",", "\"\<<undefined>\>\""}],
        "]"}], ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ValidSpinQ", "[", "spins", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456163724688251*^9, 3.456163746165844*^9}, 
   3.4561643993434677`*^9, {3.503104849106204*^9, 3.5031048502874947`*^9}, {
   3.530465515856299*^9, 3.530465522785119*^9}, {3.682577671672282*^9, 
   3.682577703332459*^9}},
 CellLabel->"In[36]:=",ExpressionUUID->"27fde190-0af8-4d02-9f74-2d1a96bde17e"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
compose IST ops for a set of different spins (use all available ranks from 1 \
upwards for each spin)\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.639216930066469*^9, 
  3.639216939604437*^9}},ExpressionUUID->"7d9dea5a-8f31-4a52-ac67-\
8a8608bf6bfd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"opT", "::", "ranktoohigh"}], ",", " ", "Lam"}], "]"}], ";", 
      RowBox[{"NullOperator", "[", "]"}]}], ")"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Union", "[", "spins", "]"}], "\[Equal]", 
       RowBox[{"Sort", "@", "spins"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"Lam", ">", 
       RowBox[{"2", "*", 
        RowBox[{"Plus", "@@", 
         RowBox[{"(", 
          RowBox[{"SpinQuantumNumber", "/@", "spins"}], ")"}]}]}]}], 
      ")"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.467301380985623*^9, 3.467301382973514*^9}, {
   3.467560359649908*^9, 3.467560360855567*^9}, 3.4867109837842197`*^9, {
   3.639216435794561*^9, 3.639216465503833*^9}, 3.639216530153208*^9},
 CellLabel->"In[37]:=",ExpressionUUID->"ffe6b6a4-ca41-4d16-929f-708ff9aff86e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "histories", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"histories", "=", 
         RowBox[{"opThistories", "[", 
          RowBox[{"spins", ",", "Lam"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "histories", "]"}], "==", "1"}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"Simplify", "@", 
           RowBox[{"opT", "[", 
            RowBox[{
             RowBox[{
             "histories", "\[LeftDoubleBracket]", "1", 
              "\[RightDoubleBracket]"}], ",", 
             RowBox[{"{", 
              RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Length", "[", "histories", "]"}], ">", "1"}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"opT", "::", "multiple"}], ",", 
              RowBox[{"Length", "[", "histories", "]"}]}], "]"}], ";", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Simplify", "@", 
                RowBox[{"opT", "[", 
                 RowBox[{"#", ",", 
                  RowBox[{"{", 
                   RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}]}], 
               ")"}], "&"}], "/@", "histories"}]}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Length", "[", "histories", "]"}], "\[Equal]", "0"}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"opT", "::", "fail"}], "]"}], ";", 
            RowBox[{"NullOperator", "[", "]"}]}], ")"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"!", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Normalize", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Union", "[", "spins", "]"}], "==", 
        RowBox[{"Sort", "@", "spins"}]}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "spins", "]"}], ">", "1"}], ")"}]}], ")"}]}]}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447340434892107*^9, 3.447340437481763*^9}, 
   3.447340540786072*^9, 3.447353125736577*^9, 3.447390437577736*^9, 
   3.467560370364647*^9, {3.468167679107463*^9, 3.46816771617842*^9}, 
   3.6392163783698997`*^9, {3.639218605398267*^9, 3.639218729219755*^9}, {
   3.639218854004891*^9, 3.6392188661511993`*^9}, {3.639219460547584*^9, 
   3.639219737975462*^9}, {3.639219803735952*^9, 3.639219829207219*^9}, {
   3.6392198874045897`*^9, 3.639219956339305*^9}, {3.639220086792411*^9, 
   3.639220139938135*^9}, {3.639220210467311*^9, 3.6392202544135838`*^9}, {
   3.6392204968978252`*^9, 3.639220502289631*^9}, {3.639222296486985*^9, 
   3.639222306920742*^9}, {3.639222346129079*^9, 3.639222421160742*^9}, {
   3.639227585638557*^9, 3.63922760230973*^9}, {3.639229975009009*^9, 
   3.639229986330311*^9}, {3.6392943437449493`*^9, 3.6392943506890078`*^9}, 
   3.639294398979665*^9},
 CellLabel->"In[38]:=",ExpressionUUID->"f18ca330-8ae4-4ac3-84fc-c0162d4f614d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"Lam_", ",", "M_"}], "}"}], ",", "index_Integer", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "histories", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"histories", "=", 
         RowBox[{"opThistories", "[", 
          RowBox[{"spins", ",", "Lam"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "histories", "]"}], "\[GreaterEqual]", 
           "index", "\[GreaterEqual]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{"opT", "[", 
           RowBox[{
            RowBox[{
            "histories", "\[LeftDoubleBracket]", "index", 
             "\[RightDoubleBracket]"}], ",", 
            RowBox[{"{", 
             RowBox[{"Lam", ",", "M"}], "}"}], ",", "opts"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"opT", "::", "fail"}], "]"}], ";", 
            RowBox[{"NullOperator", "[", "]"}]}], ")"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"!", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Normalize", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "opT", "]"}]}], ")"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Union", "[", "spins", "]"}], "==", 
        RowBox[{"Sort", "@", "spins"}]}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "spins", "]"}], ">", "1"}], ")"}]}], ")"}]}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639220193972814*^9, 3.6392202045613823`*^9}, {
   3.639220292182535*^9, 3.6392204104704742`*^9}, 3.639222314494927*^9, 
   3.639222395622978*^9},
 CellLabel->"In[39]:=",ExpressionUUID->"936f76b5-db82-4ccd-aa10-45a3a3283cb2"]
}, Closed]],

Cell[CellGroupData[{

Cell["subroutines", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.639222192668228*^9, 
  3.639222194670224*^9}},ExpressionUUID->"e4e7c53c-1591-4795-81a8-\
ea222cba03ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Lambda]totvals", "[", 
    RowBox[{"{", 
     RowBox[{"\[Lambda]1_", ",", "\[Lambda]2_"}], "}"}], "]"}], ":=", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"Abs", "[", 
      RowBox[{"\[Lambda]1", "-", "\[Lambda]2"}], "]"}], ",", 
     RowBox[{"Abs", "[", 
      RowBox[{"\[Lambda]1", "+", "\[Lambda]2"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639221852098197*^9, 3.639221912842806*^9}, 
   3.744607537615706*^9},ExpressionUUID->"617166fb-2002-4dfc-a282-\
150ad1694863"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Lambda]totvals", "[", 
    RowBox[{"{", 
     RowBox[{"\[Lambda]1_", ",", "\[Lambda]2_", ",", "\[Lambda]3__"}], "}"}], 
    "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Lambda]totvals", "[", 
        RowBox[{"{", 
         RowBox[{"#", ",", "\[Lambda]3"}], "}"}], "]"}], "&"}], "/@", 
      RowBox[{"\[Lambda]totvals", "[", 
       RowBox[{"{", 
        RowBox[{"\[Lambda]1", ",", "\[Lambda]2"}], "}"}], "]"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639221930495722*^9, 3.6392220014304028`*^9}, 
   3.7446075400104847`*^9},ExpressionUUID->"373dc7f9-2811-4ecb-bf10-\
1f81d13ebf1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FeasibleCouplingHistoryQ", "[", 
    RowBox[{
     RowBox[{"history", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "\[CapitalLambda]_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"MemberQ", "[", 
    RowBox[{
     RowBox[{"\[Lambda]totvals", "[", 
      RowBox[{"Last", "/@", "history"}], "]"}], ",", "\[CapitalLambda]"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.744607543013835*^9},ExpressionUUID->"5f41fd92-0de3-4c1a-8039-\
06ccb50be5ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opThistories", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "\[CapitalLambda]_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Select", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"Length", "[", "spins", "]"}], "-", "1"}]}], "]"}], "&"}], 
      "@", "\[IndentingNewLine]", 
      RowBox[{"Outer", "[", 
       RowBox[{"List", ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"j", ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"j", ",", "\[Lambda]"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"\[Lambda]", ",", "1", ",", 
                 RowBox[{"2", 
                  RowBox[{"SpinQuantumNumber", "[", "j", "]"}]}]}], "}"}]}], 
              "]"}]}], "]"}], "/@", "spins"}], ")"}]}], ",", "1"}], "]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FeasibleCouplingHistoryQ", "[", 
       RowBox[{"#", ",", "\[CapitalLambda]"}], "]"}], "&"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.63922061840737*^9, 3.6392206621565647`*^9}, {
   3.63922222917739*^9, 3.639222278454455*^9}, 3.639293375120987*^9},
 CellLabel->"In[43]:=",ExpressionUUID->"fa6d25a3-5ff4-4b90-b79a-ece04457efb7"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"d66a530f-898e-4898-9d82-6ab1a5d68045"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "ranktoohigh"}], "=", 
   "\"\<spin system does not support an irreducible spherical tensor operator \
of rank `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.639216512702271*^9, 3.639216520597973*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"1a4aed3f-6f25-4c47-997c-810022e24337"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "multiple"}], "=", 
   "\"\<There are `1` operators with this specification. A list of all \
possibilities has been returned. Specify a single operator using the form \
opT[interactions,{Lam,M},index] where index is an integer.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4343520160713997`*^9, 3.4343520325614977`*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"4b39c936-302b-4a29-b47b-6d4474e7e950"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "high\[Lambda]"}], "=", 
   "\"\<Spherical tensor operators of high rank are calculated using the \
Wigner-Eckart theorem and provided in the form of Operator. Explicit \
expressions may be constructed by applying ExpressOperator. This message \
appears only once.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639207090259028*^9, 3.639207238766346*^9}, {
  3.6392074171911573`*^9, 3.639207419530198*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"47aaa4e8-b066-478c-82bd-cf3061049c0a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "complexop"}], "=", 
   "\"\<A complex operator expression has been represented in Operator form. \
Explicit expressions may be constructed by applying ExpressOperator. This \
message appears only once.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639207090259028*^9, 3.639207238766346*^9}, {
  3.6392074171911573`*^9, 3.639207419530198*^9}, {3.639227234412112*^9, 
  3.639227308192625*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"7eade852-82e4-459d-9dec-2b232b9b6ca9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opT", "::", "fail"}], "=", "\"\<failure in opT routine\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639219755907196*^9, 3.639219762938037*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"170e24b9-3750-4534-a832-f74ff0fc6144"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SingleTransitionOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486457584647542*^9, 
  3.486457598679077*^9}},ExpressionUUID->"93122e05-014e-4055-b8c9-\
57e22a9a9c9e"],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"5868d62d-f33a-42cb-8ea3-\
52d3f163ef2a"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"SingleTransitionOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}},
 CellLabel->
  "In[1418]:=",ExpressionUUID->"8fc35d09-0284-4ef1-b610-dadde3d7a862"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486458228557621*^9, 
  3.486458229236062*^9}},ExpressionUUID->"b1293595-4b40-49c2-86e3-\
bebe8144e363"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s_"}], "}"}], ",", "\[Mu]_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "\[Mu]", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457613663702*^9, 3.486457717864826*^9}},
 CellLabel->
  "In[1419]:=",ExpressionUUID->"73c438d1-04a2-46ba-99a6-f5f0c69d09b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleTransitionOperator", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ketr_", "?", "KetQ"}], ",", 
         RowBox[{"kets_", "?", "KetQ"}]}], "}"}]}], ",", "\[Mu]_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"\[Mu]", ",", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", "\"\<+\>\"", 
        "|", "\"\<-\>\"", "|", "\"\<u\>\"", "|", "\"\<E\>\"", "|", 
        "\"\<1\>\""}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SingleTransitionOperator", "::", "bad\[Mu]"}], ",", "\[Mu]"}],
       "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457735235538*^9, 3.4864578286257153`*^9}, {
  3.486457997666958*^9, 3.4864579984990177`*^9}, {3.486458304685857*^9, 
  3.486458313232531*^9}, {3.66590337971178*^9, 3.6659033831021204`*^9}, {
  3.665903526183692*^9, 3.6659035367406516`*^9}},
 CellLabel->
  "In[1420]:=",ExpressionUUID->"597ab303-47a5-48c2-b126-dd38f6622803"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "Undefined"}], "}"}], ",", 
     "\[Mu]_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864581080575*^9, 3.4864581357385263`*^9}, {
   3.502024667193741*^9, 3.5020246718949957`*^9}, 3.547025206239642*^9},
 CellLabel->
  "In[1421]:=",ExpressionUUID->"022f76c3-8132-4e8f-a745-b2651daaf027"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleTransitionOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
      "\[Mu]_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "#"}], "]"}], 
         "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"r", ",", "s"}], "}"}]}], ")"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SingleTransitionOperator", "::", "badlabel"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", "basis"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864578777348146`*^9, 3.486457986075219*^9}},
 CellLabel->
  "In[1422]:=",ExpressionUUID->"b73b4d6f-5ffc-4856-bd25-be86afa92251"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
     "\[Mu]_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "r"}], "]"}]}], 
         "]"}]}], ",", 
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "s"}], "]"}]}], 
         "]"}]}]}], "}"}], ",", "\[Mu]", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458168133155*^9, 3.486458215600869*^9}},
 CellLabel->
  "In[1423]:=",ExpressionUUID->"127bd0cb-eb6b-454e-8421-1cd13eb73455"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleTransitionOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ketr_", "?", "KetQ"}], ",", 
        RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\[Mu]_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"Adjoint", "[", "kets", "]"}], ".", "ketr"}], "]"}], 
     "\[NotEqual]", "0"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SingleTransitionOperator", "::", "notorthog"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458362520542*^9, 3.486458408210157*^9}},
 CellLabel->
  "In[1424]:=",ExpressionUUID->"c203877b-d722-4b25-8982-e2c8783017fb"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.589823682333912*^9},ExpressionUUID->"5f0812e8-6e9b-4ef3-a06c-\
290a046584ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingleTransitionOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_SingleTransitionOperator", ",", "b___"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.589823701361717*^9}},
 CellLabel->
  "In[1425]:=",ExpressionUUID->"00c36a58-bda7-48f4-8f4e-da63b46450c1"]
}, Closed]],

Cell[CellGroupData[{

Cell["specific forms", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486458228557621*^9, 3.486458229236062*^9}, {
  3.486458262367688*^9, 
  3.486458264902143*^9}},ExpressionUUID->"40811aaa-54fc-44f4-900a-\
5b1c616cede9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\"\<+\>\"", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ketr", ".", 
    RowBox[{"Adjoint", "[", "kets", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864582720174217`*^9, 3.4864582882102003`*^9}, {
  3.4864583265819674`*^9, 3.486458330948009*^9}, {3.4864584408532343`*^9, 
  3.4864584536436243`*^9}, {3.486458488149802*^9, 3.486458500526759*^9}, {
  3.486538073606089*^9, 3.486538075756178*^9}, {3.665906286807167*^9, 
  3.6659062904878983`*^9}, {3.665906400868185*^9, 3.6659064100055375`*^9}, {
  3.665906493785637*^9, 3.6659065054062862`*^9}},
 CellLabel->
  "In[1426]:=",ExpressionUUID->"dd20763f-f1c5-40cc-8899-0184fde50afd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\"\<-\>\"", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"kets", ".", 
    RowBox[{"Adjoint", "[", "ketr", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864582720174217`*^9, 3.4864582882102003`*^9}, {
  3.4864583265819674`*^9, 3.486458330948009*^9}, {3.4864584408532343`*^9, 
  3.4864584536436243`*^9}, {3.486458488149802*^9, 3.486458512903339*^9}, {
  3.4865380793728533`*^9, 3.486538081452368*^9}, {3.6659062921685677`*^9, 
  3.665906294688639*^9}, {3.665906411376224*^9, 3.6659064130169907`*^9}},
 CellLabel->
  "In[1427]:=",ExpressionUUID->"8567420c-4c67-4628-be2a-22dca8449a74"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\"\<x\>\"", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Expand", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", "2"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"SingleTransitionOperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ketr", ",", "kets"}], "}"}], ",", "\"\<+\>\""}], "]"}], 
       "+", 
       RowBox[{"SingleTransitionOperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ketr", ",", "kets"}], "}"}], ",", "\"\<-\>\""}], "]"}]}], 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864582720174217`*^9, 3.4864582882102003`*^9}, {
  3.4864583265819674`*^9, 3.486458330948009*^9}, {3.4864584408532343`*^9, 
  3.4864584536436243`*^9}, {3.486458488149802*^9, 3.4864585491149597`*^9}, {
  3.502024807543927*^9, 3.502024812053206*^9}, {3.6659062963689284`*^9, 
  3.665906299418189*^9}, {3.6659064149569936`*^9, 3.6659064207294936`*^9}, {
  3.665906612114173*^9, 3.6659066153928823`*^9}},
 CellLabel->
  "In[1428]:=",ExpressionUUID->"19363803-ec67-44be-b06e-d9d4f8a28dbd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\"\<y\>\"", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Expand", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"2", "I"}], ")"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"SingleTransitionOperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ketr", ",", "kets"}], "}"}], ",", "\"\<+\>\""}], "]"}], 
       "-", 
       RowBox[{"SingleTransitionOperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ketr", ",", "kets"}], "}"}], ",", "\"\<-\>\""}], "]"}]}], 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864582720174217`*^9, 3.4864582882102003`*^9}, {
  3.4864583265819674`*^9, 3.486458330948009*^9}, {3.4864584408532343`*^9, 
  3.4864584536436243`*^9}, {3.486458488149802*^9, 3.486458567710582*^9}, {
  3.502024815039837*^9, 3.502024818909461*^9}, {3.665906302888731*^9, 
  3.6659063076621995`*^9}, {3.665906513445469*^9, 3.665906515565564*^9}},
 CellLabel->
  "In[1429]:=",ExpressionUUID->"0cda541e-25ab-4752-aeee-0e64a000e05d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleTransitionOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ketr_", "?", "KetQ"}], ",", 
        RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "\"\<z\>\"", ",", 
      "opts___Rule"}], "]"}], ":=", 
    RowBox[{"Expand", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", "2"}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"ketr", ".", 
         RowBox[{"Adjoint", "[", "ketr", "]"}]}], "-", 
        RowBox[{"kets", ".", 
         RowBox[{"Adjoint", "[", "kets", "]"}]}]}], ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", 
     RowBox[{"\"\<u\>\"", "|", "\"\<E\>\"", "|", "\"\<1\>\""}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Expand", "[", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ketr", ".", 
       RowBox[{"Adjoint", "[", "ketr", "]"}]}], "+", 
      RowBox[{"kets", ".", 
       RowBox[{"Adjoint", "[", "kets", "]"}]}]}], ")"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864582720174217`*^9, 3.4864582882102003`*^9}, {
   3.4864583265819674`*^9, 3.486458330948009*^9}, {3.4864584408532343`*^9, 
   3.4864584536436243`*^9}, {3.486458488149802*^9, 3.486458606117312*^9}, {
   3.502024822695187*^9, 3.502024826388636*^9}, {3.6659042762411213`*^9, 
   3.665904306154126*^9}, {3.6659045993664007`*^9, 3.6659046020660725`*^9}, {
   3.6659056866710205`*^9, 3.665905687448807*^9}, {3.6659063111400976`*^9, 
   3.665906318669297*^9}, {3.665906517167037*^9, 3.6659065225465307`*^9}, 
   3.665906603906463*^9},
 CellLabel->
  "In[1430]:=",ExpressionUUID->"f0e76096-5707-4db6-91bc-7e6115faba8b"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486458228557621*^9, 
  3.486458236708486*^9}},ExpressionUUID->"aa16a399-befa-447f-8169-\
69e477832e1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "::", "bad\[Mu]"}], "=", 
   "\"\<The operator index `1` should be one of {x,y,z,+,-} or {u,E,1} for \
the Unity Operator\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457833817073*^9, 3.486457857345542*^9}, {
  3.486458009172353*^9, 3.4864580214421988`*^9}, {3.6659035489957843`*^9, 
  3.6659035611463633`*^9}, {3.6659046233765955`*^9, 3.6659046264759307`*^9}},
 CellLabel->
  "In[1432]:=",ExpressionUUID->"67ccf0b6-3318-40f3-88cd-237bc63a85e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "::", "badlabel"}], "=", 
   "\"\<One or more of the labels `1` is not a defined basis label for the \
basis `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457989154126*^9, 3.486457989775527*^9}, {
  3.486458025355111*^9, 3.486458070293103*^9}},
 CellLabel->
  "In[1433]:=",ExpressionUUID->"e559d01d-c8a8-4e11-baaa-27d020b6e22b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleTransitionOperator", "::", "notorthog"}], "=", 
   "\"\<The states are not orthogonal\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458413218872*^9, 3.486458427650567*^9}},
 CellLabel->
  "In[1434]:=",ExpressionUUID->"dab561ca-6f67-404b-be4d-10b7cd642f5e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CoherenceOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.486465773286051*^9},ExpressionUUID->"5d83c3ae-5b25-4d13-8334-\
41e4378cd514"],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"9075d829-5fd6-41da-8027-\
b611d75fd7a4"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"CoherenceOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}, 
   3.5306179294911947`*^9},
 CellLabel->
  "In[1435]:=",ExpressionUUID->"ae769bf8-a048-47e2-8637-774b93deddd2"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486462888018524*^9, 3.486462889200481*^9}, {
  3.486464013684915*^9, 3.4864640243503437`*^9}, {3.4864657640526867`*^9, 
  3.486465764819149*^9}},ExpressionUUID->"8e2e140b-3d6c-4333-a021-\
5f6907c0ca3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "s_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464047804242*^9, 3.486464057160667*^9}, {
  3.486465775105833*^9, 3.486465776858345*^9}},
 CellLabel->
  "In[1436]:=",ExpressionUUID->"108c7ef5-cc18-4cfa-8725-6ed1decd2cdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "Undefined"}], "}"}], ",", 
     "___"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864581080575*^9, 3.4864581357385263`*^9}, 
   3.486464069323421*^9, {3.486465803034388*^9, 3.486465807474059*^9}, 
   3.5470252071150312`*^9},
 CellLabel->
  "In[1437]:=",ExpressionUUID->"d542feb4-5d10-472e-877d-b9d14dc25a15"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CoherenceOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "#"}], "]"}], 
         "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{"r", ",", "s"}], "}"}]}], ")"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"CoherenceOperator", "::", "badlabel"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "s"}], "}"}], ",", "basis"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864578777348146`*^9, 3.486457986075219*^9}, {
  3.486464082653549*^9, 3.4864640903806868`*^9}, {3.486465810611767*^9, 
  3.4864658122759523`*^9}},
 CellLabel->
  "In[1438]:=",ExpressionUUID->"a5d9b503-c388-468f-843d-314769034540"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r_", ",", "s_"}], "}"}], ",", "basis_"}], "}"}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "r"}], "]"}]}], 
         "]"}]}], ",", 
       RowBox[{"First", "@", 
        RowBox[{"Extract", "[", 
         RowBox[{
          RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "s"}], "]"}]}], 
         "]"}]}]}], "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458168133155*^9, 3.486458215600869*^9}, {
  3.4864641327608213`*^9, 3.486464147192917*^9}, {3.486465836910774*^9, 
  3.4864658384782877`*^9}},
 CellLabel->
  "In[1439]:=",ExpressionUUID->"7de432ff-418c-43f6-84d1-e2d315b20b93"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CoherenceOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ketr_", "?", "KetQ"}], ",", 
        RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "opts___Rule"}], "]"}], 
    "/;", 
    RowBox[{
     RowBox[{"Chop", "[", 
      RowBox[{
       RowBox[{"Adjoint", "[", "kets", "]"}], ".", "ketr"}], "]"}], 
     "\[NotEqual]", "0"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CoherenceOperator", "::", "notorthog"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458362520542*^9, 3.486458408210157*^9}, {
  3.486464161337483*^9, 3.486464173905595*^9}, {3.486465843109974*^9, 
  3.486465844485181*^9}},
 CellLabel->
  "In[1440]:=",ExpressionUUID->"603c7428-873c-40df-bd0c-87f37cfd2537"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ketr_", "?", "KetQ"}], ",", 
       RowBox[{"kets_", "?", "KetQ"}]}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ketr", ".", 
    RowBox[{"Adjoint", "[", "kets", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464205507256*^9, 3.486464227107047*^9}, {
  3.486465859175702*^9, 3.486465870717471*^9}},
 CellLabel->
  "In[1441]:=",ExpressionUUID->"0f075ab6-3b72-43b5-8187-be7a88ada1f0"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.589823682333912*^9},ExpressionUUID->"42f96726-3520-4a6a-a38b-\
1bbca7fb14f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CoherenceOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_CoherenceOperator", ",", "b___"}], "]"}], "]"}], 
    "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.589823720824284*^9}},
 CellLabel->
  "In[1442]:=",ExpressionUUID->"a39f42e8-c902-43db-91a7-20c118eab2a7"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"0de48c80-96db-4114-b39c-44a60ca1f1be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "::", "badlabel"}], "=", 
   "\"\<One or more of the labels `1` is not a defined basis label for the \
basis `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457989154126*^9, 3.486457989775527*^9}, {
   3.486458025355111*^9, 3.486458070293103*^9}, 3.486464108565113*^9, 
   3.486465830235613*^9},
 CellLabel->
  "In[1443]:=",ExpressionUUID->"7af0635c-3133-47f7-acea-cbf8e574a1d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOperator", "::", "notorthog"}], "=", 
   "\"\<The states are not orthogonal\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458413218872*^9, 3.486458427650567*^9}, 
   3.486464185641329*^9, 3.48646585382099*^9},
 CellLabel->
  "In[1444]:=",ExpressionUUID->"b9ad6637-52fe-475e-8972-3d6b560348fa"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PopulationOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.486465773286051*^9, {3.4864658886201067`*^9, 
   3.486465890122692*^9}},ExpressionUUID->"8c61fc88-4524-45dc-8d34-\
c29da5551ef3"],

Cell[CellGroupData[{

Cell["Attributes", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 
  3.530617646155493*^9}},ExpressionUUID->"cf0dcf53-55c0-40ff-bef3-\
7bfdb9b35f94"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"PopulationOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}, {
  3.5306179294911947`*^9, 3.530617946457387*^9}},
 CellLabel->
  "In[1445]:=",ExpressionUUID->"1a629984-887b-47c7-af61-4dd6f7c6a8bc"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486462888018524*^9, 3.486462889200481*^9}, {
  3.486464013684915*^9, 3.4864640243503437`*^9}, {3.4864657640526867`*^9, 
  3.486465764819149*^9}},ExpressionUUID->"f88394c3-6a0c-4150-8e30-\
173ddb64eb61"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "[", 
    RowBox[{
     RowBox[{"ketr_", "?", "KetQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ketr", ".", 
    RowBox[{"Adjoint", "[", "ketr", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464205507256*^9, 3.486464227107047*^9}, {
  3.486465859175702*^9, 3.486465870717471*^9}, {3.4864659978070583`*^9, 
  3.4864660082618103`*^9}},
 CellLabel->
  "In[1446]:=",ExpressionUUID->"5c87de4d-c86f-47b5-a459-bf5490913c0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "[", 
    RowBox[{"r_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"PopulationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486464047804242*^9, 3.486464057160667*^9}, {
  3.486465775105833*^9, 3.486465776858345*^9}, {3.486465893448969*^9, 
  3.4864659034472227`*^9}},
 CellLabel->
  "In[1447]:=",ExpressionUUID->"fc614027-ce3d-48df-a0f8-760b6e2abd24"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "Undefined"}], "}"}], ",", "___"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864581080575*^9, 3.4864581357385263`*^9}, 
   3.486464069323421*^9, {3.486465803034388*^9, 3.486465807474059*^9}, {
   3.486465906721078*^9, 3.486465909613587*^9}, 3.547025208089794*^9},
 CellLabel->
  "In[1448]:=",ExpressionUUID->"8c619b07-fc68-4a63-92f9-56bf95fe2001"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PopulationOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r_", ",", "basis_"}], "}"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "r"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"PopulationOperator", "::", "badlabel"}], ",", "r", ",", 
       "basis"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4864578777348146`*^9, 3.486457986075219*^9}, {
  3.486464082653549*^9, 3.4864640903806868`*^9}, {3.486465810611767*^9, 
  3.4864658122759523`*^9}, {3.486465914659379*^9, 3.486465936225624*^9}},
 CellLabel->
  "In[1449]:=",ExpressionUUID->"27c76c02-9231-48e2-886a-300eaae3f376"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r_", ",", "basis_"}], "}"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"PopulationOperator", "[", 
    RowBox[{
     RowBox[{"First", "@", 
      RowBox[{"Extract", "[", 
       RowBox[{
        RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "r"}], "]"}]}], 
       "]"}]}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486458168133155*^9, 3.486458215600869*^9}, {
  3.4864641327608213`*^9, 3.486464147192917*^9}, {3.486465836910774*^9, 
  3.4864658384782877`*^9}, {3.486465961958846*^9, 3.486465991788776*^9}},
 CellLabel->
  "In[1450]:=",ExpressionUUID->"5809c947-56c2-4586-823d-459c59edb8b5"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.589823682333912*^9},ExpressionUUID->"5ec60c06-6051-477c-a37f-\
20ae8b4d6622"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PopulationOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_PopulationOperator", ",", "b___"}], "]"}], "]"}],
     "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.589823742748765*^9}},
 CellLabel->
  "In[1451]:=",ExpressionUUID->"57154140-4b49-4fa7-ba87-61deb0f70b04"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"5d8c3536-b8e1-4f33-8734-1692b47308a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PopulationOperator", "::", "badlabel"}], "=", 
   "\"\<The label `1` is not a defined basis label for the basis `2`\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486457989154126*^9, 3.486457989775527*^9}, {
   3.486458025355111*^9, 3.486458070293103*^9}, 3.486464108565113*^9, 
   3.486465830235613*^9, {3.486465943419486*^9, 3.486465949227344*^9}},
 CellLabel->
  "In[1452]:=",ExpressionUUID->"feb2059d-4a49-4b3f-abfe-5940d8e6e308"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ProjectionOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 
  3.460294279933426*^9}},ExpressionUUID->"b54cafc7-3e3f-451c-b531-\
b740b8abee25"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ProjectionOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}, {
  3.5306179294911947`*^9, 3.5306179657846327`*^9}},
 CellLabel->
  "In[1453]:=",ExpressionUUID->"11cc3b3a-3cfb-43da-baf3-b8b1b46f0643"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProjectionOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_ProjectionOperator", ",", "b___"}], "]"}], "]"}],
     "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.589823772601287*^9}},
 CellLabel->
  "In[1454]:=",ExpressionUUID->"00c88135-4cb0-4f15-bda7-3d2b19c1fc2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
     ")"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460627837887372*^9, 3.460627909069378*^9}, 
   3.547228612383363*^9},
 CellLabel->
  "In[1455]:=",ExpressionUUID->"7d80d333-c686-4466-b939-964ecac81c65"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"mj", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], "]"}], ":=", 
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"j", ",", "mj"}], "}"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460630752874873*^9, 3.460630785578513*^9}},
 CellLabel->
  "In[1456]:=",ExpressionUUID->"7e92a6bb-7846-40dd-80fb-22b0073e03f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{"spinstates", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ProjectionOperator", "[", 
     RowBox[{"Ket", "[", "spinstates", "]"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"First", "/@", "spinstates"}], "\[Equal]", 
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460627648721221*^9, 3.460627708211342*^9}, {
  3.460627948625187*^9, 3.460627959661669*^9}},
 CellLabel->
  "In[1457]:=",ExpressionUUID->"412a959d-7a81-45fb-88e7-1a1ca09ea772"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{"instates", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"inspins", ",", "outspins", ",", "outstates"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"inspins", "=", 
        RowBox[{"First", "/@", "instates"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"outspins", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"First", "/@", 
           RowBox[{"SpinSystem", "[", "]"}]}], ",", 
          RowBox[{"Alternatives", "@@", "inspins"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"outstates", "=", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"#", ",", "mI"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"mI", ",", 
                    RowBox[{"-", 
                    RowBox[{"SpinQuantumNumber", "[", "#", "]"}]}], ",", 
                    RowBox[{"+", 
                    RowBox[{"SpinQuantumNumber", "[", "#", "]"}]}]}], "}"}]}],
                  "]"}], "&"}], "/@", "outspins"}], ")"}]}], ",", 
            "\[IndentingNewLine]", "1"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Length", "[", "outspins", "]"}], "-", "1"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"ProjectionOperator", "[", 
            RowBox[{"Sort", "[", 
             RowBox[{"Join", "[", 
              RowBox[{"#", ",", "instates"}], "]"}], "]"}], "]"}], "&"}], ",",
           "\[IndentingNewLine]", "outstates"}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460627965535417*^9, 3.4606279723235292`*^9}, {
  3.4606280029844646`*^9, 3.460628106223816*^9}, {3.4606281509778357`*^9, 
  3.460628240743596*^9}, {3.4606284243598824`*^9, 3.460628459703854*^9}, {
  3.460628548419304*^9, 3.460628552071896*^9}, {3.460628583295827*^9, 
  3.460628678894541*^9}, {3.46062895305837*^9, 3.460628957359849*^9}, {
  3.46062913245147*^9, 3.460629133067309*^9}},
 CellLabel->
  "In[1458]:=",ExpressionUUID->"f71f540a-98b4-4cae-ae04-80410a0d7217"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionOperator", "[", 
    RowBox[{
     RowBox[{"ket_", "?", "KetQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Dot", "[", 
     RowBox[{"ket", ",", 
      RowBox[{"Adjoint", "[", "ket", "]"}]}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Adjoint", "[", "ket", "]"}], ".", "ket"}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4607105770898523`*^9, 3.460710605097621*^9}},
 CellLabel->
  "In[1459]:=",ExpressionUUID->"49426a36-d102-4f94-a949-030deb1eff95"]
}, Closed]],

Cell[CellGroupData[{

Cell["ShiftOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
  3.4602943668599854`*^9, 
  3.4602943676744823`*^9}},ExpressionUUID->"ff2a3ceb-cd54-4cd5-9936-\
6951af86e4ba"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ShiftOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}, {
  3.5306179294911947`*^9, 3.530617975329504*^9}},
 CellLabel->
  "In[1460]:=",ExpressionUUID->"b999da16-43d1-44f9-afc4-e3abbbde5263"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_ShiftOperator", ",", "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.5898237920176153`*^9}},
 CellLabel->
  "In[1461]:=",ExpressionUUID->"3adeca4e-6a52-45b6-a02f-346d62d4e444"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftOperator", "[", 
    RowBox[{
     RowBox[{"ket_", "?", "KetQ"}], ",", 
     RowBox[{"bra_", "?", "BraQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Dot", "[", 
     RowBox[{"ket", ",", "bra"}], "]"}], "/", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"Adjoint", "[", "ket", "]"}], ".", "ket"}], "]"}], "\[Times]", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"bra", ".", 
        RowBox[{"Adjoint", "[", "bra", "]"}]}], "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4607105770898523`*^9, 3.460710605097621*^9}, {
  3.460710680055278*^9, 3.460710707874959*^9}},
 CellLabel->
  "In[1462]:=",ExpressionUUID->"4518a57d-7402-4811-8a26-a803c773a5b5"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinPermutationOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
   3.4602943668599854`*^9, 3.4602943676744823`*^9}, {3.502278447248674*^9, 
   3.502278473574972*^9}, 3.502283881676605*^9, 
   3.5903993459490767`*^9},ExpressionUUID->"5c0f2498-3256-447d-b488-\
550a1b98b7bc"],

Cell[CellGroupData[{

Cell["SpinExchangeOperator synonym", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, 
   3.590399137944243*^9, {3.590575585637651*^9, 
   3.5905755872170773`*^9}},ExpressionUUID->"745a1cb6-9908-4947-b60a-\
3d337db4df3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinExchangeOperator", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinExchangeOperator", "::", "obs"}], "]"}], ";", 
     RowBox[{"SpinPermutationOperator", "[", "args", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590399143371416*^9, 3.5903991926096497`*^9}},
 CellLabel->
  "In[1463]:=",ExpressionUUID->"c121a034-622c-4572-a2a4-4e3aa31a5a60"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinExchangeOperator", "::", "obs"}], "=", 
   "\"\<SpinExchangeOperator has been superseded by SpinPermutationOperator. \
Proceeding using SpinPermutationOperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.59039919798625*^9, 3.590399242407599*^9}, {
  3.590399500345972*^9, 3.590399516503839*^9}},
 CellLabel->
  "In[1464]:=",ExpressionUUID->"645bf660-accc-4113-85ff-eefc685bc79a"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 
  3.502408712547282*^9}},ExpressionUUID->"df9f8d07-e333-4ad6-8e13-\
9c55520e4306"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"SpinExchangeOperator", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617722696877*^9}, {
  3.5306179294911947`*^9, 3.530617989767469*^9}},
 CellLabel->
  "In[1465]:=",ExpressionUUID->"053dc660-3a9d-488d-a13b-b9bd124e7ada"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinPermutationOperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_SpinPermutationOperator", ",", "b___"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"OperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "times"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.5894821767088213`*^9, 
   3.589482183695197*^9}, 3.5898236572551527`*^9, {3.589823698760758*^9, 
   3.58982381362477*^9}, {3.590399261239688*^9, 3.590399262376772*^9}},
 CellLabel->
  "In[1466]:=",ExpressionUUID->"bf7ba6f7-16d5-4066-a15e-acf1a7e099c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "[", "perm_", "]"}], ":=", 
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{"perm", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4607105770898523`*^9, 3.460710605097621*^9}, {
  3.460710680055278*^9, 3.460710707874959*^9}, {3.502278457077628*^9, 
  3.502278485577228*^9}, {3.502283882500239*^9, 3.502283883502369*^9}, {
  3.5903992635340643`*^9, 3.590399264308302*^9}},
 CellLabel->
  "In[1467]:=",ExpressionUUID->"f6211038-7525-4878-be0e-e85eba5abd27"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{
     RowBox[{"perms_", "?", "MatrixQ"}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Dot", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"SpinPermutationOperator", "[", 
        RowBox[{"#", ",", "spinsys"}], "]"}], "&"}], "/@", "perms"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278511035905*^9, 3.502278593232182*^9}, {
  3.502283884323756*^9, 3.502283885258939*^9}, {3.590399265138239*^9, 
  3.590399266064665*^9}},
 CellLabel->
  "In[1468]:=",ExpressionUUID->"42502ac1-4e7a-439a-b0be-25f14ad8f799"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{"perm_List", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"validities", ",", " ", "invalspins"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"invalspins", "=", 
         RowBox[{"Pick", "[", 
          RowBox[{"perm", ",", "validities", ",", "False"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SpinPermutationOperator", "::", "invalspins"}], ",", 
          "invalspins"}], "]"}], ";", "\[IndentingNewLine]", "$Failed"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"validities", "=", 
         RowBox[{"ValidSpinQ", "/@", "perm"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"And", "@@", "validities"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278604968542*^9, 3.502278651447812*^9}, 
   3.502278692527524*^9, 3.502283886219783*^9, {3.50310486342553*^9, 
   3.503104864719036*^9}, {3.530465539028083*^9, 3.530465559467154*^9}, {
   3.590396116206925*^9, 3.590396320175807*^9}, {3.590396408832531*^9, 
   3.590396409403775*^9}, {3.590396641863819*^9, 3.590396655836434*^9}, 
   3.590396705519658*^9, {3.590399266935803*^9, 3.590399267918857*^9}},
 CellLabel->
  "In[1469]:=",ExpressionUUID->"01e46fe6-7493-4646-9af2-9727ad77450b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{"perm_List", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pairs", ",", "Ivals", ",", " ", "mismatches"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SpinPermutationOperator", "::", "invalpair"}], ",", 
          "mismatches"}], "]"}], ";", "\[IndentingNewLine]", "$Failed"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"pairs", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{"perm", ",", "2", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Ivals", "=", 
         RowBox[{"Last", "/@", "spinsys"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"mismatches", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"pairs", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Pick", "[", 
               RowBox[{"Ivals", ",", 
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"First", "[", "#", "]"}]}], "]"}], "!=", 
              RowBox[{"Pick", "[", 
               RowBox[{"Ivals", ",", 
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"Last", "[", "#", "]"}]}], "]"}]}], ")"}], "&"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"mismatches", "\[NotEqual]", 
         RowBox[{"{", "}"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278604968542*^9, 3.502278651447812*^9}, 
   3.502278692527524*^9, 3.502283886219783*^9, {3.50310486342553*^9, 
   3.503104864719036*^9}, {3.530465539028083*^9, 3.530465559467154*^9}, {
   3.590396116206925*^9, 3.590396320175807*^9}, {3.590396408832531*^9, 
   3.590396409403775*^9}, {3.590396641863819*^9, 3.590396655836434*^9}, 
   3.590396705519658*^9, {3.590396764540927*^9, 3.590396938226714*^9}, {
   3.590396970953225*^9, 3.590397179646167*^9}, {3.590399268865038*^9, 
   3.590399269879184*^9}},
 CellLabel->
  "In[1470]:=",ExpressionUUID->"0bd9dbd0-1f2c-45f9-816a-34f151bf890b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 
  3.5024087258989964`*^9}},ExpressionUUID->"af46eea4-cfdb-489b-b9e0-\
bcb8909e339b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"SpinPermutationOperator", "[", 
      RowBox[{"perm_List", ",", "spinsys_"}], "]"}], "]"}]}], "^:=", 
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{
     RowBox[{"Reverse", "@", "perm"}], ",", "spinsys"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5022815732978573`*^9, 3.502281592621255*^9}, {
  3.5022832588102617`*^9, 3.502283261112084*^9}, {3.5022838909951973`*^9, 
  3.5022838919906483`*^9}, {3.590398592422618*^9, 3.590398605797724*^9}, {
  3.590399271271235*^9, 3.590399272424129*^9}},
 CellLabel->
  "In[1471]:=",ExpressionUUID->"60564423-b687-421f-a124-fd0269f291bc"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert to Operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.590574945189547*^9, 
  3.590574948531828*^9}},ExpressionUUID->"1ef98f9f-99c0-4fac-8b43-\
598493e8a217"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "[", 
    RowBox[{"perm_List", ",", "spinsys_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "zbasis", ",", "rules", ",", "ket", ",", "zkets", ",", "permzkets"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zkets", "=", 
        RowBox[{"BasisKets", "[", "zbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rules", "=", 
        RowBox[{"Inner", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#1", ",", "M1_"}], "}"}], ":>", 
             RowBox[{"{", 
              RowBox[{"#2", ",", "M1"}], "}"}]}], ")"}], "&"}], ",", "perm", 
          ",", 
          RowBox[{"RotateLeft", "[", "perm", "]"}], ",", "List"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"permzkets", "=", "\[IndentingNewLine]", 
        RowBox[{"zkets", "/.", 
         RowBox[{
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Ket", "[", 
            RowBox[{
             RowBox[{"kets_", "?", "MatrixQ"}], ",", "spinsys", ",", 
             "opts___Rule"}], "]"}]}], "\[RuleDelayed]", 
          RowBox[{"Ket", "[", 
           RowBox[{
            RowBox[{"kets", "/.", "rules"}], ",", "spinsys", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"Validity", "\[Rule]", "False"}], ",", "opts"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SpinPermutationOperator", "[", 
         RowBox[{"perm", ",", "spinsys"}], "]"}], "=", "\[IndentingNewLine]", 
        
        RowBox[{"Operator", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SparseArray", "@", 
           RowBox[{"Outer", "[", 
            RowBox[{"Dot", ",", 
             RowBox[{"Adjoint", "/@", "zkets"}], ",", "permzkets"}], "]"}]}], 
          ",", "\[IndentingNewLine]", "zbasis", ",", "\[IndentingNewLine]", 
          RowBox[{"OperatorType", "\[Rule]", "\"\<Unitary\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, {3.467301670664372*^9, 3.467301680927438*^9}, 
   3.4867109901112967`*^9, {3.502278953376333*^9, 3.5022790543074923`*^9}, {
   3.502279110072763*^9, 3.50227914240761*^9}, 3.502280602507122*^9, 
   3.5022838930614634`*^9, {3.502408693946967*^9, 3.502408698422359*^9}, {
   3.590397945525166*^9, 3.590397950896776*^9}, {3.590399289107698*^9, 
   3.590399290233266*^9}, {3.590574954593061*^9, 3.590575041460827*^9}, {
   3.590575091348982*^9, 3.590575114270739*^9}, {3.5905751455890417`*^9, 
   3.590575282808385*^9}, {3.590659645301021*^9, 3.5906596664988413`*^9}, {
   3.695468218623068*^9, 3.695468231588722*^9}, {3.695468299031793*^9, 
   3.695468326933331*^9}},
 CellLabel->
  "In[1472]:=",ExpressionUUID->"902372e1-6616-467a-9435-74be789a13b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 
  3.502408751851077*^9}},ExpressionUUID->"f57885a8-fb99-4101-bdf6-\
a3512cc67607"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationOperator", "::", "invalspins"}], "=", 
   "\"\<The following spin labels are invalid for the current SpinSystem: `1`\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590396662353932*^9, 3.5903967020013847`*^9}, 
   3.590399295990817*^9},
 CellLabel->
  "In[1473]:=",ExpressionUUID->"efc8bb07-19b2-4831-9e9f-0b6d8a6a37ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SpinPermutationOperator", "::", "invalpair"}], "=", 
    "\"\<The following pairs of spins cannot be exchanged since they have \
different spin quantum numbers:`1`\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590397191816387*^9, 3.590397215564597*^9}, 
   3.5903992970023727`*^9},
 CellLabel->
  "In[1474]:=",ExpressionUUID->"15b04056-b3d9-4354-afe1-0172c298e53c"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MatrixRepresentation", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"b83aff3f-4699-4fd5-935f-220656dff023"],

Cell[CellGroupData[{

Cell["preliminaries", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439430709439631*^9, 3.439430711749446*^9}, 
   3.439430890807631*^9, {3.486540039077656*^9, 
   3.4865400409472847`*^9}},ExpressionUUID->"ecf7a0d9-e0a7-45fc-8995-\
e6d40373123b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MatrixRepresentation", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Method", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439428413360384*^9, 3.439428435600795*^9}, 
   3.439430465209126*^9},
 CellLabel->
  "In[1475]:=",ExpressionUUID->"4f892663-471e-4f31-aaa3-8bfa52e8e255"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"2e0169a7-6efb-4b9d-a4c7-69bd550c8b63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342549538795*^9, {3.621243820894185*^9, 3.62124383739154*^9}},
 CellLabel->
  "In[1476]:=",ExpressionUUID->"f48f5a38-ed78-40e2-8e28-281dffbc0862"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including trap for unknown basis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"3aa1f64a-1782-407d-83cc-6a01262e8bf9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Chop", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op", ",", 
      RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.456162880747242*^9, 3.570342545684395*^9, {3.7283935534378896`*^9, 
   3.7283935815558143`*^9}, {3.7283936960280495`*^9, 3.728393696736931*^9}},
 CellLabel->
  "In[1477]:=",ExpressionUUID->"6f2e38af-c9f2-40a7-92f4-1dc00c7a5518"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, {3.4483554535025663`*^9, 
   3.44835545691912*^9}, 3.448355832793025*^9, 3.456162357211536*^9, 
   3.456164410473714*^9, 3.547025208892107*^9, 3.547228614563073*^9, 
   3.570342543757238*^9},
 CellLabel->
  "In[1478]:=",ExpressionUUID->"f83e6eea-f65f-4955-aa69-807aaa8b0698"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355565082233*^9, 3.448355569143277*^9}, {
   3.4483563131008673`*^9, 3.448356319849319*^9}, 3.4483570255919523`*^9, 
   3.456162358055647*^9, 3.5470252097896852`*^9, 3.570342539962592*^9},
 CellLabel->
  "In[1479]:=",ExpressionUUID->"36e6fee0-dc49-419d-892d-5091f28b35be"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a single number", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.5320070316467867`*^9, 
   3.532007035881529*^9}},ExpressionUUID->"96c377fe-4472-48c0-b509-\
1482b3307817"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"num_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Chop", "[", "#", "]"}], "\[Equal]", "0"}], ")"}], "&"}], 
        ")"}]}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "]"}], ",", "basis", ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531930036870233*^9, 3.531930061317379*^9}, {3.5319303206047087`*^9, 
   3.5319303229174423`*^9}, {3.532006991999352*^9, 3.532007019860983*^9}, 
   3.570342537404563*^9},
 CellLabel->
  "In[1480]:=",ExpressionUUID->"ea6d6c99-0129-42e2-bc04-3d3254a6cd0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"num_", "?", "NumericQ"}], ",", "basis_", ",", "opts___Rule"}], 
     "]"}]}], ":=", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "basis", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531930036870233*^9, 3.531930061317379*^9}, {3.5319303206047087`*^9, 
   3.5319303229174423`*^9}, 3.570342535868545*^9},
 CellLabel->
  "In[1481]:=",ExpressionUUID->"6adecdcf-fba7-48bd-af6e-4753c546b920"]
}, Closed]],

Cell[CellGroupData[{

Cell["fix or trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.6267782290119667`*^9, 
   3.6267782413631763`*^9}, 
   3.626778309724236*^9},ExpressionUUID->"2bb8bd01-fdad-4596-8c6b-\
8b280bbe6193"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Except", "[", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], "|", 
         RowBox[{"_", "?", "KetQ"}], "|", 
         RowBox[{"_", "?", "BraQ"}]}], "]"}]}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "fixedop", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"fixedop", ",", "basis", ",", "opts"}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fixedop", "=", 
         RowBox[{"Chop", "[", "op", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"fixedop", ",", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "KetQ"}], "|", 
           RowBox[{"_", "?", "BraQ"}]}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626777618316545*^9, 3.626777675617124*^9}},
 CellLabel->
  "In[1482]:=",ExpressionUUID->"d549d72e-b5d8-49ef-923f-8fae781e4831"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Except", "[", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], "|", 
         RowBox[{"_", "?", "KetQ"}], "|", 
         RowBox[{"_", "?", "BraQ"}]}], "]"}]}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"MatrixRepresentation", "::", "badop"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.531930063726522*^9, 3.5319300867107153`*^9}, {
   3.53193033230785*^9, 3.531930374757971*^9}, {3.532171820635771*^9, 
   3.532171832215679*^9}, 3.5703425336772327`*^9},
 CellLabel->
  "In[1483]:=",ExpressionUUID->"b9f5f1bc-2780-4f15-b11d-3baced6b45eb"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["sums, numerical factors, adjoints and exponentials", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.4394307789742527`*^9, 
  3.439430797443653*^9}},ExpressionUUID->"1ffdee26-fe2f-412d-870d-\
aa7160a24dbc"],

Cell[CellGroupData[{

Cell["handling of sums", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"ef2814ec-5276-4e6d-81f7-b06dd8d49cdc"],

Cell["\<\
The routine SumMatricesAndMatrixInterpolationFunctions is used to handle the \
case where one operator matrix representation has the form of an \
interpolating function\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621161068215061*^9, 3.6211610994125967`*^9}, {
   3.621250535725168*^9, 3.621250551419323*^9}, 
   3.691501289710081*^9},ExpressionUUID->"bb18a887-8933-48fb-9a80-\
449c883260f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Plus", "[", "ops___", "]"}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "@@", 
    RowBox[{"Map", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", "ops", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435162521066451*^9, 3.4351625410894117`*^9}, {
   3.457268929158388*^9, 3.457268950582767*^9}, {3.457269325947131*^9, 
   3.4572693274866133`*^9}, {3.457271988580717*^9, 3.457271998424197*^9}, 
   3.621097273077519*^9, 3.621097308924534*^9, {3.621160532674529*^9, 
   3.621160543413169*^9}, {3.621161103904339*^9, 3.621161126831756*^9}, {
   3.621161220076885*^9, 3.6211612206970387`*^9}, {3.621161483521628*^9, 
   3.621161484973493*^9}, {3.621250380950592*^9, 3.621250383459323*^9}, 
   3.6215339505114098`*^9},
 CellLabel->
  "In[1484]:=",ExpressionUUID->"27643a5c-0da8-4e2e-b307-9514f5ec0bf9"]
}, Closed]],

Cell[CellGroupData[{

Cell["numerical factors", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.435162488247097*^9},ExpressionUUID->"f778c11c-c91d-420c-9356-\
c059d2a6431f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"num1", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}], ",", 
        RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num1", ",", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435162429133709*^9, 3.435162467849051*^9}, {
   3.448291159826447*^9, 3.448291163083337*^9}, {3.448292282946432*^9, 
   3.448292287759934*^9}, {3.44829318107003*^9, 3.448293184857436*^9}, {
   3.4482932409215183`*^9, 3.448293250975316*^9}, {3.448308249969927*^9, 
   3.4483082541593313`*^9}, {3.448345390344214*^9, 3.448345416971203*^9}, {
   3.4483456543308277`*^9, 3.448345685330309*^9}, {3.448345872714571*^9, 
   3.4483458915487843`*^9}, {3.448345957560493*^9, 3.448345960820505*^9}, {
   3.621096371905439*^9, 3.621096389468316*^9}, 3.6211604738721857`*^9},
 CellLabel->
  "In[1485]:=",ExpressionUUID->"94c818a7-8500-4988-bf53-b7058f444add"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", 
        RowBox[{"num2", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}]}], "]"}], ",", 
      "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num2", ",", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435162429133709*^9, 3.435162467849051*^9}, {
   3.448291159826447*^9, 3.448291163083337*^9}, {3.448292282946432*^9, 
   3.448292287759934*^9}, {3.44829318107003*^9, 3.448293184857436*^9}, {
   3.4482932409215183`*^9, 3.448293250975316*^9}, {3.448308249969927*^9, 
   3.4483082541593313`*^9}, {3.448345390344214*^9, 3.448345416971203*^9}, {
   3.4483456543308277`*^9, 3.448345685330309*^9}, {3.4483458966122923`*^9, 
   3.4483459105719337`*^9}, {3.448345963948235*^9, 3.448345965955408*^9}, 
   3.621096417874219*^9, 3.621160479866994*^9},
 CellLabel->
  "In[1486]:=",ExpressionUUID->"93e7dfe4-ff24-4f5f-bd7b-faea4fe27ab4"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numbers or undefined symbols", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.590660757363489*^9, 
  3.590660761344716*^9}},ExpressionUUID->"14b97574-e835-47c1-929a-\
8216ed99cdf5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
       RowBox[{"(", "_Symbol", ")"}], "|", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}], ".."}], 
         "]"}]}]}]}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"num", "*", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4306244102313747`*^9, 3.430624410598246*^9}, 
   3.43062573684107*^9, {3.448292314130822*^9, 3.448292315616091*^9}, {
   3.448308265798131*^9, 3.448308274998784*^9}, {3.448348733671179*^9, 
   3.448348734623678*^9}, 3.486464357877039*^9, 3.570342515869124*^9, {
   3.62118887747099*^9, 3.621188884278967*^9}, {3.691501127774189*^9, 
   3.6915011671251574`*^9}},
 CellLabel->
  "In[1487]:=",ExpressionUUID->"ac8248cc-f765-4b3b-9525-9742c26c00e3"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoints", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"bbdfea23-c1f6-49de-a5f2-c2c4095eb428"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Adjoint", "[", "op_", "]"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"ComplexExpand", "@", 
   RowBox[{"Conjugate", "@", 
    RowBox[{"Transpose", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342512821164*^9, {3.657821227221385*^9, 3.657821228003837*^9}},
 CellLabel->
  "In[1488]:=",ExpressionUUID->"ef397f42-06a8-4fc3-b49d-1b0d061841d9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exponentials", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f4027349-fe0b-4fed-947e-b50cdaee3155"],

Cell["\<\
take products of matrix reps if the exponential is sandwiched between other \
operators\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"25f5d63c-38be-4055-9c4c-23566899e045"],

Cell["\<\
rotation operators are left untouched since they will be handled later as \
single-spin operators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4865388128718*^9, 
  3.486538854344865*^9}},ExpressionUUID->"6150085d-0597-4807-b3d5-\
089ba253e092"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"op1__", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "op_", "]"}], "|", 
         RowBox[{"Power", "[", 
          RowBox[{"E", ",", "op_"}], "]"}]}], ",", "op2___"}], "]"}], ",", 
      "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", "op1", "]"}], ",", "basis", ",", 
      "opts"}], "]"}], ".", "\[IndentingNewLine]", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "op", "]"}], ",", "op2"}], "]"}], ",", "basis", 
      ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309348659200373`*^9, 3.4309348916732283`*^9}, 
   3.5703425094464283`*^9, {3.5892630963648033`*^9, 3.589263106744664*^9}, {
   3.653576098828381*^9, 3.653576112001895*^9}},
 CellLabel->
  "In[1489]:=",ExpressionUUID->"34447b4e-cf2e-4448-bccf-5eb79dbd3192"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"op1___", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "op_", "]"}], "|", 
         RowBox[{"Power", "[", 
          RowBox[{"E", ",", "op_"}], "]"}]}], ",", "op2__"}], "]"}], ",", 
      "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"op1", ",", 
        RowBox[{"Exp", "[", "op", "]"}]}], "]"}], ",", "basis", ",", "opts"}],
      "]"}], ".", "\[IndentingNewLine]", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", "op2", "]"}], ",", "basis", ",", 
      "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309348659200373`*^9, 3.430934930172267*^9}, 
   3.570342507532776*^9, 3.589263115699554*^9, {3.6535761152578*^9, 
   3.653576118935589*^9}},
 CellLabel->
  "In[1490]:=",ExpressionUUID->"428bdb9c-a290-429e-a52a-0eccd42e68fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"op_", "?", "OperatorQ"}], "]"}], "|", 
      RowBox[{"Power", "[", 
       RowBox[{"E", ",", 
        RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"SparseArray", "@", 
   RowBox[{"MatrixExp", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309336300783*^9, 3.430933651985939*^9}, {
   3.431074888691966*^9, 3.431074891671363*^9}, {3.43516155451896*^9, 
   3.435161557777286*^9}, 3.448292333047392*^9, 3.5703425060449*^9, 
   3.589263118698123*^9, {3.6211605746182833`*^9, 3.62116058433862*^9}},
 CellLabel->
  "In[1491]:=",ExpressionUUID->"9f9acd9e-df83-4827-8d87-c460fd4f6de6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MatrixRepresentation of kets and bras", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439430709439631*^9, 3.439430711749446*^9}, 
   3.439430890807631*^9, {3.486539878332902*^9, 3.486539892179594*^9}},
 ExpressionUUID -> "155eea5c-0390-45fa-b974-c108ca14c229"],

Cell["\<\
use VectorRepresentation but ensure that the row and column indexing is \
adjusted so as to generate a matrix with one row or column\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4865398969652576`*^9, 
  3.4865399463713837`*^9}},ExpressionUUID->"d02647a4-a5a3-42bd-b9e0-\
44d4c0d62c6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"ket_", "?", "KetQ"}], ",", "basis_", ",", "opts___Rule"}], 
     "]"}]}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"List", "/@", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{"ket", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539560106056*^9, 3.486539587801239*^9}, {
   3.486542963789695*^9, 3.4865429686517982`*^9}, 3.5703425301083403`*^9},
 CellLabel->
  "In[1492]:=",ExpressionUUID->"58fd592d-2cdf-416f-b5f1-caa87cb21b0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"bra_", "?", "BraQ"}], ",", "basis_", ",", "opts___Rule"}], 
     "]"}]}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"{", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{"bra", ",", "basis", ",", "opts"}], "]"}], "}"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539560106056*^9, 3.486539587801239*^9}, {
   3.486539618736835*^9, 3.486539649056177*^9}, {3.486542971209691*^9, 
   3.4865429766911707`*^9}, 3.570342528370811*^9},
 CellLabel->
  "In[1493]:=",ExpressionUUID->"13d66ae9-afa7-4c5d-9c75-b67699bd0b0f"]
}, Closed]],

Cell[CellGroupData[{

Cell["MatrixRepresentation of Operator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 
  3.531834283424567*^9}},ExpressionUUID->"0cd28183-e439-4a8d-9f44-\
6733564b6c4b"],

Cell[CellGroupData[{

Cell["\<\
The defined spin system is a subset of the requested spin system\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843194031289*^9}, {
  3.621508979183887*^9, 3.621508986475823*^9}, {3.6215097838063307`*^9, 
  3.6215097886571198`*^9}, {3.639224817799529*^9, 3.6392248499754467`*^9}, {
  3.6392257400257063`*^9, 3.6392257557856703`*^9}, {3.6392258687330227`*^9, 
  3.639225871262183*^9}, {3.63922595975065*^9, 3.6392259655997334`*^9}},
 ExpressionUUID -> "7c171bb7-d2cb-4494-bebe-d933a9505ede"],

Cell["\<\
In this case the basis must be expanded to take in the \
\[OpenCurlyDoubleQuote]missing\[CloseCurlyDoubleQuote] spins\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639224859426517*^9, 
  3.639224875941658*^9}},ExpressionUUID->"5ad2cda1-8e3b-4762-b4c0-\
8ef0f4ac2d54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Operator", "[", 
        RowBox[{"specs_", ",", "basis1_", ",", "opts1__Rule"}], "]"}]}], ",", 
      "basis2_", ",", "opts2___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "spinsys1", ",", "spinsys2", ",", "missingspins", ",", 
       "missingspinkets", ",", "missingspinbras", ",", "matrep", ",", "kets", 
       ",", "bras", ",", "ketbraopform", ",", "n"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"missingspins", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{"spinsys2", ",", "spinsys1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"missingspinkets", "=", 
         RowBox[{"BasisKets", "[", 
          RowBox[{"ZeemanBasis", "[", "missingspins", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"missingspinbras", "=", 
         RowBox[{"BasisBras", "[", 
          RowBox[{"ZeemanBasis", "[", "missingspins", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"kets", "=", 
         RowBox[{"BasisKets", "[", 
          RowBox[{"ZeemanBasis", "[", "spinsys1", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bras", "=", 
         RowBox[{"BasisBras", "[", 
          RowBox[{"ZeemanBasis", "[", "spinsys1", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"n", "=", 
         RowBox[{"Length", "[", "kets", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"matrep", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op", ",", 
           RowBox[{"ZeemanBasis", "[", "spinsys1", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ketbraopform", "=", 
         RowBox[{"Plus", "@@", 
          RowBox[{"Flatten", "@", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"matrep", "\[LeftDoubleBracket]", 
               RowBox[{"r", ",", "c"}], "\[RightDoubleBracket]"}], "*", 
              RowBox[{
               RowBox[{
               "kets", "\[LeftDoubleBracket]", "r", "\[RightDoubleBracket]"}],
                ".", 
               RowBox[{
               "bras", "\[LeftDoubleBracket]", "c", 
                "\[RightDoubleBracket]"}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"r", ",", "1", ",", "n"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"c", ",", "1", ",", "n"}], "}"}]}], "]"}]}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ketbraopform", "/.", 
           RowBox[{
            RowBox[{"ket_Ket", ".", "bra_Bra"}], "\[RuleDelayed]", 
            "\[IndentingNewLine]", 
            RowBox[{"Inner", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"ProductKet", "[", 
                 RowBox[{"ket", ",", "#1"}], "]"}], ".", 
                RowBox[{"ProductBra", "[", 
                 RowBox[{"bra", ",", "#2"}], "]"}]}], "&"}], ",", 
              "\[IndentingNewLine]", "missingspinkets", ",", 
              "missingspinbras"}], "\[IndentingNewLine]", "]"}]}]}], ",", 
          "\[IndentingNewLine]", "basis2"}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys1", "=", 
         RowBox[{"SpinSystem", "[", "basis1", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"spinsys2", "=", 
         RowBox[{"SpinSystem", "[", "basis2", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"UnsameQ", "[", 
          RowBox[{"spinsys1", ",", "spinsys2"}], "]"}], "&&", 
         RowBox[{"SubsetQ", "[", 
          RowBox[{"spinsys2", ",", "spinsys1"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639224892042947*^9, 3.63922489278508*^9}, {
   3.639224955305794*^9, 3.639225021357777*^9}, {3.639225079998189*^9, 
   3.639225082847047*^9}, {3.639225126743487*^9, 3.639225167615251*^9}, {
   3.6392252316811457`*^9, 3.639225323121561*^9}, {3.639225356896758*^9, 
   3.639225512121873*^9}, {3.6392255557422333`*^9, 3.639225651699898*^9}, {
   3.639226374843457*^9, 3.639226377474347*^9}, {3.639226474074218*^9, 
   3.639226508501474*^9}, {3.639226816207103*^9, 3.639226826938204*^9}, {
   3.640513462691205*^9, 3.6405134746007843`*^9}, {3.6405227404185343`*^9, 
   3.64052275028041*^9}, 3.64052279048422*^9, {3.6405988526243057`*^9, 
   3.640598855513526*^9}, {3.640599297879385*^9, 3.6405993077004223`*^9}, 
   3.640599492267661*^9},
 CellLabel->
  "In[1494]:=",ExpressionUUID->"dcf7aff2-8318-4c43-8768-50408c02b8b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The defined spin system is the same as the requested spin system, but the \
bases are different\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843194031289*^9}, {
  3.621508979183887*^9, 3.621508986475823*^9}, {3.6215097838063307`*^9, 
  3.6215097886571198`*^9}, {3.6392257978426867`*^9, 3.639225801643319*^9}, {
  3.639225892717971*^9, 3.6392258981062117`*^9}, {3.639225974907588*^9, 
  3.6392259891915817`*^9}},ExpressionUUID->"0778c902-45d4-4009-8439-\
41e85e03d80f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{"specs_", ",", "basis1_", ",", "opts1__Rule"}], "]"}], ",", 
       "basis2_", ",", "opts2___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"UnsameQ", "[", 
      RowBox[{"basis1", ",", "basis2"}], "]"}], "&&", 
     RowBox[{"SameQ", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "@", "basis2"}], ",", 
       RowBox[{"SpinSystem", "@", "basis1"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"SparseArray", "@", 
     RowBox[{
     "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"BasisTransformationMatrix", "[", 
        RowBox[{"basis2", ",", "basis1"}], "]"}], ",", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"specs", ",", "basis1", ",", "opts1"}], "]"}], ",", 
         "basis1", ",", "opts2"}], "]"}], ",", 
       RowBox[{"BasisTransformationMatrix", "[", 
        RowBox[{"basis1", ",", "basis2"}], "]"}]}], "\[IndentingNewLine]", 
      "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110055828319*^9}, 
   3.504111124170664*^9, {3.5318344228690863`*^9, 3.531834430734833*^9}, {
   3.531842698422821*^9, 3.53184273404837*^9}, {3.586082170721868*^9, 
   3.586082174638335*^9}, 3.586085270228579*^9, {3.586089361231307*^9, 
   3.586089435303177*^9}, {3.621099391065466*^9, 3.6210994051441097`*^9}, {
   3.621509381872937*^9, 3.621509387606966*^9}, {3.621509444939704*^9, 
   3.6215094463175097`*^9}, {3.621509519580372*^9, 3.621509534481842*^9}, {
   3.6215095926468287`*^9, 3.621509611031708*^9}, {3.6215097688000927`*^9, 
   3.621509822151291*^9}, 3.621533104179182*^9, {3.621533360484828*^9, 
   3.6215334192082767`*^9}, 3.6215339865402718`*^9, {3.621613046610197*^9, 
   3.621613046782701*^9}, {3.6216131427903357`*^9, 3.6216131465735607`*^9}, {
   3.639226148637867*^9, 3.639226173387039*^9}, {3.63922676290099*^9, 
   3.639226778885779*^9}, {3.640513077034152*^9, 3.640513084328158*^9}, {
   3.64051338801509*^9, 3.640513394886663*^9}, 3.640513508172976*^9, {
   3.6405138517340117`*^9, 3.640513856269465*^9}, 3.640522886405764*^9, {
   3.6405988631972237`*^9, 3.64059887100522*^9}, {3.640599238509242*^9, 
   3.640599264237873*^9}, 3.640599474163527*^9},
 CellLabel->
  "In[1495]:=",ExpressionUUID->"db24369b-140d-471b-ab28-89aa6a75d082"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The defined and requested bases are the same, and Operator contains matrix or \
diagonalized form of matrix\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843170966979*^9}, {
   3.586082203382558*^9, 3.586082211491289*^9}, {3.586085306411397*^9, 
   3.5860853151283493`*^9}, 3.621508593168619*^9, {3.621508936075535*^9, 
   3.621508943632052*^9}, {3.639225923814859*^9, 
   3.63922592660426*^9}},ExpressionUUID->"48595ea0-e133-4fb6-83a4-\
54812ccc2be6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"mat_", "?", "MatrixQ"}], ",", "basis_", ",", "___Rule"}], 
       "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "mat"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.531834408986793*^9, 3.531834427835287*^9}, 3.6215080980726843`*^9, 
   3.6215082092404327`*^9},
 CellLabel->
  "In[1496]:=",ExpressionUUID->"cb73098b-773f-4158-ae4f-2e6ebc35271f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
          RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
        "___Rule"}], "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"Chop", "[", 
    RowBox[{"X", ".", 
     RowBox[{"SparseArray", "[", 
      RowBox[{"DiagonalMatrix", "[", "evals", "]"}], "]"}], ".", "Xinv"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080347016385*^9, 3.586080380785246*^9}, {
   3.586081224280334*^9, 3.586081237044495*^9}, {3.5860821270456133`*^9, 
   3.586082130882392*^9}, 3.621508103507956*^9, 3.621508211039052*^9},
 CellLabel->
  "In[1497]:=",ExpressionUUID->"4aa5faa2-ca9a-475e-866e-42e5f19795b5"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The defined and requested bases are the same, and Operator contains a valid \
Interpolation function\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6215085961902237`*^9, 3.621508633525794*^9}, {
   3.621508951564271*^9, 3.621508960765566*^9}, {3.62150969345966*^9, 
   3.6215096997678137`*^9}, {3.621509893236871*^9, 3.621509897899819*^9}, 
   3.639225937431302*^9},ExpressionUUID->"2e3640f8-9534-4593-853b-\
c93e30578139"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "basis_", ",", "___Rule"}], "]"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{"ifunc", "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.6215083052768173`*^9, 3.621508327201395*^9}},
 CellLabel->
  "In[1498]:=",ExpressionUUID->"003400e2-73ed-41ee-845e-41f22861cd3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "basis_", ",", "___Rule"}], "]"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
          RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "D_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"X", ".", 
        RowBox[{"DiagonalMatrix", "[", "D", "]"}], ".", "Xinv"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.621508308187889*^9, 3.6215083852569523`*^9}},
 CellLabel->
  "In[1499]:=",ExpressionUUID->"6693c423-523e-495c-845b-e0f7fc04debc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "basis_", ",", "___Rule"}], "]"}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], "\[RuleDelayed]", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"op", ",", "basis"}], "]"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.621508308187889*^9, 3.6215083852569523`*^9}, {
   3.62150971047964*^9, 3.621509732630121*^9}},
 CellLabel->
  "In[1500]:=",ExpressionUUID->"ced40c01-d638-4241-afe4-ac4d0c4f0d80"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The requested spin system is incompatible with the defined spin system\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843194031289*^9}, {
  3.621508979183887*^9, 3.621508986475823*^9}, {3.6215097838063307`*^9, 
  3.6215097886571198`*^9}, {3.6392257978426867`*^9, 3.639225801643319*^9}, {
  3.639225892717971*^9, 3.6392258981062117`*^9}, {3.639225974907588*^9, 
  3.639226027297216*^9}},ExpressionUUID->"487b461a-978b-4581-aff8-\
a521b12e48c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{"specs_", ",", "basis1_", ",", "opts1__Rule"}], "]"}], ",", 
       "basis2_", ",", "opts2___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"SubsetQ", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "@", "basis2"}], ",", 
       RowBox[{"SpinSystem", "@", "basis1"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Operator", "::", "incompatspinsys"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639226053265109*^9, 3.6392261111043787`*^9}},
 CellLabel->
  "In[1501]:=",ExpressionUUID->"cde47d10-8091-4f85-b8a5-d15647fb3c62"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["UnityOperator and NullOperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.4351384795051394`*^9}, {
   3.435138543651462*^9, 3.435138548992515*^9}, 3.486464370061146*^9, {
   3.590660826847549*^9, 
   3.5906608309106207`*^9}},ExpressionUUID->"cd7a5c6b-1e23-400c-b6bd-\
cf9721be4355"],

Cell[CellGroupData[{

Cell["UnityOperator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.4351384795051394`*^9}, {
   3.435138543651462*^9, 3.435138548992515*^9}, 3.486464370061146*^9, {
   3.590660841293887*^9, 
   3.590660841549809*^9}},ExpressionUUID->"5bc3591c-1480-4ded-a32c-\
e20df6d47a4f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], "..."}], ",", "___Rule"}], 
       "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"Band", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"BasisDimension", "[", "basis", "]"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, 3.570342500151928*^9},
 CellLabel->
  "In[1502]:=",ExpressionUUID->"55f35c3d-218f-4782-a778-f991facdf9df"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullOperator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.4351384795051394`*^9}, {
  3.435138543651462*^9, 3.435138548992515*^9}, {3.4673016636830072`*^9, 
  3.467301665497198*^9}, {3.5022789264849358`*^9, 3.502278926657989*^9}, {
  3.590660845382221*^9, 
  3.59066084558169*^9}},ExpressionUUID->"f89730e1-5cb7-4ca0-88be-\
dcb16b40fc82"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"NullOperator", "[", "]"}], ",", "basis_", ",", "opts___Rule"}],
      "]"}]}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"Band", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", 
        RowBox[{"BasisDimension", "[", "basis", "]"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, {3.467301670664372*^9, 3.467301680927438*^9}, 
   3.4867109901112967`*^9, 3.57034249785322*^9},
 CellLabel->
  "In[1503]:=",ExpressionUUID->"8074fbc4-cb15-4b1d-9363-786d41dd0ee0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["general basis handling", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.439430846871876*^9, 3.439430853436007*^9}, {3.621160600719136*^9, 
  3.6211606037772503`*^9}},ExpressionUUID->"89a393c1-eb67-4623-ae5c-\
1d24c2253dce"],

Cell[CellGroupData[{

Cell["Method\[Rule]Automatic", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
   3.4351385782893333`*^9, 3.435138578864519*^9}, {3.439428354758057*^9, 
   3.4394283669204197`*^9}, {3.439428555610299*^9, 3.439428558911394*^9}, 
   3.621160635572764*^9},ExpressionUUID->"fb9f9f5c-cd16-4501-80fa-\
d7a45c1e1233"],

Cell["transform to Zeeman basis if necessary", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621095747149461*^9, 
  3.621095756003067*^9}},ExpressionUUID->"e5a70a46-7945-4d0c-af22-\
767c95023599"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "basis_", ",", "opts___Rule"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "ibasis", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
         RowBox[{"Normal", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"BasisTransformationMatrix", "[", 
            RowBox[{"basis", ",", "ibasis"}], "]"}], ".", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{"op", ",", "ibasis"}], "]"}], ".", 
           RowBox[{"BasisTransformationMatrix", "[", 
            RowBox[{"ibasis", ",", "basis"}], "]"}]}], "\[IndentingNewLine]", 
          "]"}], "]"}], "/.", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"HoldPattern", "[", 
            RowBox[{"OperatorProduct", "[", 
             RowBox[{"___", ",", "0", ",", "___"}], "]"}], "]"}], 
           "\[RuleDelayed]", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"HoldPattern", "[", 
            RowBox[{"OperatorProduct", "[", 
             RowBox[{"a__", ",", "1", ",", "b___"}], "]"}], "]"}], 
           "\[RuleDelayed]", 
           RowBox[{"OperatorProduct", "[", 
            RowBox[{"a", ",", "b"}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"HoldPattern", "[", 
            RowBox[{"OperatorProduct", "[", 
             RowBox[{"a___", ",", "1", ",", "b__"}], "]"}], "]"}], 
           "\[RuleDelayed]", 
           RowBox[{"OperatorProduct", "[", 
            RowBox[{"a", ",", "b"}], "]"}]}]}], "\[IndentingNewLine]", 
         "}"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ibasis", "=", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "MatrixRepresentation", "]"}]}], ",", 
           "Automatic"}], "]"}], "&&", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"basis", ",", "ibasis"}], "]"}]}]}]}], ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.43942856466698*^9, 
   3.439428567090693*^9}, {3.439428623967114*^9, 3.439428759095665*^9}, {
   3.439431131396223*^9, 3.439431173168355*^9}, {3.439431445213122*^9, 
   3.439431456928738*^9}, {3.43943187158153*^9, 3.439431877213736*^9}, {
   3.439432093540332*^9, 3.4394321138643637`*^9}, {3.439437400501769*^9, 
   3.4394374118579683`*^9}, 3.456162358923707*^9, {3.486459764896386*^9, 
   3.486459768093398*^9}, 3.4864623403541594`*^9, {3.486462466647861*^9, 
   3.4864624758083563`*^9}, {3.502074179307684*^9, 3.502074190944688*^9}, {
   3.506620218329302*^9, 3.5066202200571823`*^9}, 3.5703425203939447`*^9, {
   3.6210950596439133`*^9, 3.621095068533766*^9}, {3.621160623817945*^9, 
   3.621160624594399*^9}, {3.640508876477365*^9, 3.640508928098033*^9}, {
   3.6405130900496073`*^9, 3.640513093651978*^9}, 3.640513862879959*^9, {
   3.640598044684451*^9, 3.640598050758018*^9}, {3.6405990575752783`*^9, 
   3.640599063424855*^9}, {3.64059947935013*^9, 3.6405994803972073`*^9}, {
   3.653576137631901*^9, 3.653576141031999*^9}},
 CellLabel->
  "In[1504]:=",ExpressionUUID->"31ef056d-9552-4449-bfe7-c4f695e67576"]
}, Closed]],

Cell[CellGroupData[{

Cell["Method\[Rule]\[CloseCurlyDoubleQuote]Direct\[CloseCurlyDoubleQuote]", \
"Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
   3.4351385782893333`*^9, 3.435138578864519*^9}, {3.439428354758057*^9, 
   3.4394283669204197`*^9}, {3.558598448127152*^9, 3.5585984504291277`*^9}, 
   3.621160639050058*^9},ExpressionUUID->"77af8294-8378-4061-ba0d-\
d844a6211b40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", "basis_", ",", "opts___Rule"}],
       "]"}]}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Method", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "MatrixRepresentation", "]"}]}], ",", 
       "\"\<Direct\>\""}], "]"}], "&&", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"op", ",", "_InterpolatingFunction"}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Outer", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#1", ".", "op", ".", "#2"}], ")"}], "&"}], ",", 
        RowBox[{"BasisBras", "[", "basis", "]"}], ",", 
        RowBox[{"BasisKets", "[", "basis", "]"}]}], "]"}], "/.", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"OperatorProduct", "[", 
           RowBox[{"___", ",", "0", ",", "___"}], "]"}], "]"}], 
         "\[RuleDelayed]", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"OperatorProduct", "[", 
           RowBox[{"a__", ",", "1", ",", "b___"}], "]"}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"OperatorProduct", "[", 
          RowBox[{"a", ",", "b"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"OperatorProduct", "[", 
           RowBox[{"a___", ",", "1", ",", "b__"}], "]"}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"OperatorProduct", "[", 
          RowBox[{"a", ",", "b"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
     "\[IndentingNewLine]", "]"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.486459338635685*^9, 
   3.4864593515076313`*^9}, {3.486462454566292*^9, 3.486462460181611*^9}, {
   3.506620213554995*^9, 3.5066202153830347`*^9}, 3.5470255664172277`*^9, 
   3.570342524455571*^9, {3.6210950076449003`*^9, 3.621095020177567*^9}, {
   3.6210976189964848`*^9, 3.621097626514097*^9}, {3.6210996900024557`*^9, 
   3.621099691739862*^9}, {3.640513102305498*^9, 3.640513107637488*^9}, {
   3.6405138755829678`*^9, 3.6405138781424093`*^9}, {3.640598942953957*^9, 
   3.640598953169457*^9}, 3.640599048722093*^9, 3.6405994865166397`*^9, {
   3.6535761420812883`*^9, 3.653576144486804*^9}},
 CellLabel->
  "In[1505]:=",ExpressionUUID->"c85cd253-3f84-49cf-8e3a-4e1a7bae8593"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["separate explicit kets and bras inside operator products", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.4394307789742527`*^9, 3.439430797443653*^9}, {3.486538887778455*^9, 
  3.486538903832775*^9}, {3.486540062486143*^9, 
  3.4865400678191147`*^9}},ExpressionUUID->"f3b113d0-4528-4350-bb96-\
660441a1eb65"],

Cell[CellGroupData[{

Cell["involving Kets", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486539437760599*^9, 
  3.486539440988429*^9}},ExpressionUUID->"14e5b23b-7cae-4cb7-a5c5-\
87dcb6eb88d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"opsb__", ",", 
        RowBox[{"ket_", "?", "KetQ"}], ",", "opsc___"}], "]"}], ",", "basis_",
       ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", "opsb", "]"}], ",", "basis", ",", "opts"}], "]"}], 
    ".", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"ket", ",", "opsc"}], "]"}], ",", "basis", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539350260148*^9, 3.486539404317428*^9}},
 CellLabel->
  "In[1506]:=",ExpressionUUID->"96ee6e74-7fce-4282-b4f7-c4d22c3779df"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ket_", "?", "KetQ"}], ",", "opsc__"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{"ket", ",", "basis", ",", "opts"}], "]"}], ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsc", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539480698698*^9, 3.4865395160265102`*^9}},
 CellLabel->
  "In[1507]:=",ExpressionUUID->"fd8517f0-75bc-4aa8-9dd2-e5db3b98d178"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb___", ",", 
       RowBox[{"ket_", "?", "KetQ"}], ",", "opsc__"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb", ",", "ket"}], "]"}], ",", "basis", ",", "opts"}], "]"}],
    ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsc", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4865394169332848`*^9, 3.48653943318661*^9}},
 CellLabel->
  "In[1508]:=",ExpressionUUID->"ab184707-465b-410d-8f8d-9d840c182999"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb__", ",", 
       RowBox[{"ket_", "?", "KetQ"}]}], "]"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsb", "]"}], ",", "basis", ",", "opts"}], "]"}], 
   ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{"ket", ",", "basis", ",", "opts"}], "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4865394169332848`*^9, 3.48653943318661*^9}, {
  3.486539535955665*^9, 3.486539551209058*^9}},
 CellLabel->
  "In[1509]:=",ExpressionUUID->"02b4f0eb-3c1f-4724-b810-59e071a5fa15"]
}, Closed]],

Cell[CellGroupData[{

Cell["involving Bras", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486539437760599*^9, 
  3.4865394478070993`*^9}},ExpressionUUID->"2ef5848b-f093-4aec-861e-\
014d29f8af83"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"opsb__", ",", 
        RowBox[{"bra_", "?", "BraQ"}], ",", "opsc___"}], "]"}], ",", "basis_",
       ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", "opsb", "]"}], ",", "basis", ",", "opts"}], "]"}], 
    ".", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"bra", ",", "opsc"}], "]"}], ",", "basis", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539350260148*^9, 3.486539404317428*^9}, {
  3.486539612970848*^9, 3.486539634689982*^9}},
 CellLabel->
  "In[1510]:=",ExpressionUUID->"5f1c5b96-0318-4ff0-a52b-1ee4b45d5f04"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"bra_", "?", "BraQ"}], ",", "opsc__"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{"bra", ",", "basis", ",", "opts"}], "]"}], ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsc", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486539480698698*^9, 3.4865395160265102`*^9}, {
  3.486539614369699*^9, 3.486539635337564*^9}},
 CellLabel->
  "In[1511]:=",ExpressionUUID->"d2483d51-e664-45f1-9038-4aa7c1f27700"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb___", ",", 
       RowBox[{"bra_", "?", "BraQ"}], ",", "opsc__"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb", ",", "bra"}], "]"}], ",", "basis", ",", "opts"}], "]"}],
    ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsc", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4865394169332848`*^9, 3.48653943318661*^9}, {
  3.486539615665945*^9, 3.486539636113367*^9}},
 CellLabel->
  "In[1512]:=",ExpressionUUID->"afb84d97-275b-42c6-bdb0-8c2131641d91"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{"opsb__", ",", 
       RowBox[{"bra_", "?", "BraQ"}]}], "]"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Dot", "[", "opsb", "]"}], ",", "basis", ",", "opts"}], "]"}], 
   ".", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{"bra", ",", "basis", ",", "opts"}], "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4865394169332848`*^9, 3.48653943318661*^9}, {
  3.486539535955665*^9, 3.486539551209058*^9}, {3.486539616801544*^9, 
  3.486539637105584*^9}},
 CellLabel->
  "In[1513]:=",ExpressionUUID->"b7eee129-763e-4623-a794-6ed623c487f1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["dot products of operators other than opI or opR", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.4394307789742527`*^9, 3.439430797443653*^9}, {3.460869646465704*^9, 
  3.460869659479926*^9}, {3.46096210305252*^9, 3.460962117708271*^9}, {
  3.486537235197806*^9, 3.486537238946967*^9}, {3.590661032117333*^9, 
  3.590661079048753*^9}, {3.6210958199472723`*^9, 
  3.62109582078239*^9}},ExpressionUUID->"87991234-59ca-4816-892b-\
75fd75b92c2d"],

Cell[CellGroupData[{

Cell["split into (opI | opR).. runs, and others", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5906619964611177`*^9, 3.590662051700254*^9}, {
  3.590662669680895*^9, 
  3.5906626891028843`*^9}},ExpressionUUID->"702c3491-f175-485e-a8d4-\
ab46d9cd33d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"HoldPattern", "@", 
       RowBox[{"OperatorProduct", "[", 
        RowBox[{
         RowBox[{"ops___", "?", "OperatorQ"}], ",", "___Rule"}], "]"}]}], ",",
       "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"Equal", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"_opI", "|", "_opR"}]}], "]"}], "&"}], "/@", 
        RowBox[{"{", "ops", "}"}]}], ")"}]}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"oplists", ",", "matreps"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"oplists", "=", 
        RowBox[{"SplitBy", "[", 
         RowBox[{
          RowBox[{"{", "ops", "}"}], ",", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"#", ",", 
             RowBox[{"_opI", "|", "_opR"}]}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"matreps", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"OperatorProduct", "@@", "#"}], ",", "basis", ",", 
             "opts"}], "]"}], "&"}], ",", "oplists"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
         RowBox[{"First", "@", "matreps"}], ",", 
         RowBox[{"Fold", "[", 
          RowBox[{"Dot", ",", 
           RowBox[{"First", "@", "matreps"}], ",", 
           RowBox[{"Drop", "[", 
            RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590661474117791*^9, 3.590661557230248*^9}, {
   3.590661685314303*^9, 3.59066179393051*^9}, {3.5906618610189342`*^9, 
   3.59066197914988*^9}, {3.5906623557647448`*^9, 3.590662357458332*^9}, {
   3.590662394220529*^9, 3.5906623958731422`*^9}, {3.642515094205669*^9, 
   3.642515136713717*^9}, {3.642515373839942*^9, 3.642515391042481*^9}, {
   3.6535761890522127`*^9, 3.653576205555564*^9}, 3.6578202000119762`*^9},
 CellLabel->
  "In[1514]:=",ExpressionUUID->"3cc10dce-bf38-4324-8b4d-9ebe0a4e467a"]
}, Closed]],

Cell[CellGroupData[{

Cell["runs of operators that are not (opI | opR)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5906619964611177`*^9, 3.590662051700254*^9}, {
  3.590662669680895*^9, 
  3.590662712504506*^9}},ExpressionUUID->"c508ec7b-36c8-4751-81cf-\
6a2689533153"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"HoldPattern", "@", 
       RowBox[{"OperatorProduct", "[", 
        RowBox[{
         RowBox[{"ops___", "?", "OperatorQ"}], ",", "___Rule"}], "]"}]}], ",",
       "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"And", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"_opI", "|", "_opR"}]}], "]"}]}], "&"}], "/@", 
       RowBox[{"{", "ops", "}"}]}], ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "matreps", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], "/@", 
         RowBox[{"{", "ops", "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
         RowBox[{"First", "@", "matreps"}], ",", 
         RowBox[{"Fold", "[", 
          RowBox[{"Dot", ",", 
           RowBox[{"First", "@", "matreps"}], ",", 
           RowBox[{"Drop", "[", 
            RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590662740178796*^9, 3.590662800872746*^9}, {
   3.642515212318089*^9, 3.642515239598328*^9}, 3.6425154028147993`*^9, 
   3.653576212373085*^9, 3.657820204237152*^9},
 CellLabel->
  "In[1515]:=",ExpressionUUID->"7f996789-2ea9-4552-afad-1a6347e0fe71"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["products of opI or opR operators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
   3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
   3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
   3.4394307789742527`*^9, 3.439430797443653*^9}, {3.460869646465704*^9, 
   3.460869659479926*^9}, {3.46096210305252*^9, 3.460962117708271*^9}, {
   3.486537235197806*^9, 3.486537238946967*^9}, {3.590661032117333*^9, 
   3.590661055842147*^9}, 
   3.590662949740123*^9},ExpressionUUID->"37c9f83d-a8ae-4dfc-aa81-\
bbb5ec8c892a"],

Cell[CellGroupData[{

Cell["InvolvedSpin routine", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609621213078403`*^9, 3.46096212834722*^9}, {
  3.460962493569273*^9, 3.460962504951665*^9}, {3.460974805610753*^9, 
  3.460974809222735*^9}},ExpressionUUID->"38fa1e55-fc0d-4109-a97e-\
69367e7d3043"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InvolvedSpin", "[", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{"op_", ",", "___"}], "]"}], "]"}], ":=", 
   RowBox[{"InvolvedSpin", "[", "op", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46096366646996*^9, 3.460963684875922*^9}, {
  3.460974976891987*^9, 3.4609749947275476`*^9}},
 CellLabel->
  "In[1516]:=",ExpressionUUID->"d4330b20-128a-4e02-98e5-9955ee34a4ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InvolvedSpin", "[", 
   RowBox[{"UnityOperator", "[", "j_", "]"}], "]"}], ":=", "j"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609635278153963`*^9, 3.460963538962474*^9}, 
   3.486464374126931*^9, {3.486464772268136*^9, 3.4864647742577267`*^9}},
 CellLabel->
  "In[1517]:=",ExpressionUUID->"a844a10d-4020-42fe-a75e-2665af9ce209"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InvolvedSpin", "[", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"opI", "|", "opR"}], ")"}], "[", 
     RowBox[{"j_", ",", "___"}], "]"}]}], "]"}], ":=", "j"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460963543547649*^9, 3.460963565869629*^9}, {
  3.4609793596599007`*^9, 3.460979363999764*^9}},
 CellLabel->
  "In[1518]:=",ExpressionUUID->"8e507a24-38df-4e97-82f1-22631f196d70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"InvolvedSpin", "[", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorProduct", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"opI", "|", "opR"}], ")"}], "[", 
        RowBox[{"j_", ",", "___"}], "]"}], ".."}], ",", "___Rule"}], "]"}]}], 
   "]"}], ":=", "j"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460963557420755*^9, 3.460963590570395*^9}, {
   3.4609793708361998`*^9, 3.460979372898035*^9}, 3.653576231012637*^9, {
   3.6535821938681793`*^9, 3.6535821959451733`*^9}},
 CellLabel->
  "In[1519]:=",ExpressionUUID->"95963a5f-125b-4199-907e-7fb993751d45"]
}, Closed]],

Cell[CellGroupData[{

Cell["resolve into SingleSpinZeemanBasisMatrixRepresentations", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609621213078403`*^9, 3.46096212834722*^9}, {
   3.460974825910364*^9, 3.460974826094788*^9}, {3.460980817707539*^9, 
   3.4609808184408712`*^9}, 
   3.461001421895071*^9},ExpressionUUID->"5b856f28-c89d-4bd7-824f-\
0b956a9e6ea4"],

Cell[CellGroupData[{

Cell["handle isolated single spin operators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460981776191489*^9, 3.4609817888858347`*^9}, {
  3.460981892486781*^9, 3.460981912564918*^9}, {3.460981988736367*^9, 
  3.4609819960329437`*^9}, {3.460998616654252*^9, 
  3.460998621439971*^9}},ExpressionUUID->"f46259d5-8ed7-462c-a3c0-\
634ef6b4287d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"op", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j_", ",", "___"}], "]"}], "|", 
        RowBox[{"opR", "[", 
         RowBox[{"j_", ",", "___"}], "]"}]}], ")"}]}], ",", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"SparseArray", "@", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "spins", "]"}], "==", "1"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460962135385776*^9, 3.46096221992598*^9}, {
   3.4609622585906153`*^9, 3.460962262700898*^9}, {3.460962430453403*^9, 
   3.4609624328289537`*^9}, {3.460974400910296*^9, 3.460974415110408*^9}, {
   3.4609748519357433`*^9, 3.4609748530364923`*^9}, 3.4609820016715193`*^9, {
   3.460984506499442*^9, 3.460984515009171*^9}, {3.4609985209246407`*^9, 
   3.460998536458137*^9}, 3.4609985882416563`*^9, {3.46099867760235*^9, 
   3.460998680694942*^9}, {3.460998918316831*^9, 3.460998941110688*^9}, {
   3.464347295046872*^9, 3.464347309113153*^9}, {3.4865331891759863`*^9, 
   3.48653319419718*^9}, {3.4865355215900707`*^9, 3.4865355262829313`*^9}},
 CellLabel->
  "In[1520]:=",ExpressionUUID->"3f947ff7-3c00-4be0-b139-e98107e2ffde"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"op", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j_", ",", "___"}], "]"}], "|", 
        RowBox[{"opR", "[", 
         RowBox[{"j_", ",", "___"}], "]"}]}], ")"}]}], ",", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"SparseArray", "@", 
    RowBox[{"ConstructMatrixRepresentation", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "spins", "]"}], ">", "1"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609985740373783`*^9, 3.460998574210305*^9}, 
   3.460998683951647*^9, 3.464347324039856*^9, 3.4865332055674677`*^9, 
   3.486535531245397*^9},
 CellLabel->
  "In[1521]:=",ExpressionUUID->"af9921ff-bf51-4eae-92d0-2e189501828f"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
separate into runs of single-spin operators, sorted according to which spin, \
and others \
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460981776191489*^9, 3.460981808212927*^9}, {
  3.460981947171629*^9, 
  3.460981954337288*^9}},ExpressionUUID->"c8b5463f-c231-452e-a9dd-\
729b3014c28b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ")"}]}], ",", 
       "___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}]}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SparseArray", "@", 
   RowBox[{"ConstructMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ConstructMatrixRepresentation", "[", 
        RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], "/@", 
      "\[IndentingNewLine]", 
      RowBox[{"Apply", "[", 
       RowBox[{"Dot", ",", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"SplitBy", "[", 
           RowBox[{
            RowBox[{"{", "ops", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"MatchQ", "[", 
                RowBox[{"#", ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"opI", "|", "opR"}], ")"}], "[", "___", "]"}]}], 
                "]"}], "&"}], ",", "InvolvedSpin"}], "}"}]}], "]"}], ",", 
          "1"}], "]"}], ",", "\[IndentingNewLine]", "1"}], 
       "\[IndentingNewLine]", "]"}]}], ",", "basis", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460980838983837*^9, 3.460980963162862*^9}, {
   3.460980994335906*^9, 3.460981082877716*^9}, {3.460981157712461*^9, 
   3.460981171152842*^9}, {3.460981307550296*^9, 3.460981332289487*^9}, 
   3.460981378334772*^9, 3.460981414547214*^9, {3.460981486062622*^9, 
   3.460981487914345*^9}, {3.460981523029851*^9, 3.460981524583028*^9}, 
   3.460981562688962*^9, 3.4609816178928823`*^9, {3.460981650021131*^9, 
   3.460981691580125*^9}, {3.460981762028296*^9, 3.460981766120178*^9}, 
   3.4609819669032907`*^9, {3.460982010281828*^9, 3.460982013309773*^9}, {
   3.460982045396834*^9, 3.460982193842752*^9}, {3.4609824728612423`*^9, 
   3.4609824740458813`*^9}, {3.460982524008773*^9, 3.4609825294381647`*^9}, {
   3.460982694575532*^9, 3.460982729058172*^9}, {3.4609827916111803`*^9, 
   3.460982794997753*^9}, {3.460982834593438*^9, 3.460982838590824*^9}, {
   3.460982891813332*^9, 3.4609828940878077`*^9}, {3.460982952324479*^9, 
   3.4609829588819847`*^9}, {3.460983570982435*^9, 3.4609835717679653`*^9}, {
   3.460984192873103*^9, 3.4609842030832157`*^9}, 3.486533208352909*^9, 
   3.486535534063286*^9, {3.653575703522193*^9, 3.653575706712159*^9}, {
   3.6535776569255466`*^9, 3.6535776914461737`*^9}, {3.653577750573745*^9, 
   3.653577780713562*^9}, 3.653581970917247*^9, 3.6535820026868668`*^9},
 CellLabel->
  "In[1522]:=",ExpressionUUID->"23f15388-8fa4-42eb-a893-729a6e8d03b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["clean up if only matrices are left", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460981776191489*^9, 3.4609817888858347`*^9}, {
  3.460981892486781*^9, 3.460981912564918*^9}, {3.460981988736367*^9, 
  3.4609819960329437`*^9}, {3.4609840670327272`*^9, 3.460984076926674*^9}, {
  3.460984128612275*^9, 
  3.4609841297532578`*^9}},ExpressionUUID->"28001573-8db0-492d-aaac-\
0546b8e7a412"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"mats", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "MatrixQ"}], "..."}], "}"}]}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "mats", "]"}], "\[Equal]", "1"}], ",", 
     RowBox[{"First", "@", "mats"}], ",", 
     RowBox[{"Fold", "[", 
      RowBox[{"Dot", ",", 
       RowBox[{"First", "@", "mats"}], ",", 
       RowBox[{"Drop", "[", 
        RowBox[{"mats", ",", "1"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460984084152931*^9, 3.460984116144209*^9}, 
   3.460984150415491*^9, {3.460984255901744*^9, 3.4609842583765097`*^9}, {
   3.461000206594565*^9, 3.461000208696475*^9}, {3.642515286458663*^9, 
   3.642515303768702*^9}, {3.642515424378874*^9, 3.6425154335806227`*^9}},
 CellLabel->
  "In[1523]:=",ExpressionUUID->"1c94710f-e96f-4bc5-979d-7967de7c66e4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ConstructMatrixRepresentation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609621213078403`*^9, 3.46096212834722*^9}, {
   3.460962493569273*^9, 3.460962504951665*^9}, 
   3.460983079880149*^9},ExpressionUUID->"6ec755da-af7f-48c2-8a0c-\
7240bd0c9539"],

Cell[CellGroupData[{

Cell["not an operator, or a ket, or a bra \[Rule] interpret as a number", \
"Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609830829985647`*^9, 3.460983098508914*^9}, {
   3.4610015105360126`*^9, 3.461001515606124*^9}, 3.461001826432135*^9, {
   3.461003521546376*^9, 3.461003533063559*^9}, {3.4610363268929853`*^9, 
   3.461036331173377*^9}},ExpressionUUID->"cc13e4c5-9544-4c5c-a59b-\
8370507f8bf0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "|", 
        RowBox[{"_", "?", "KetQ"}], "|", 
        RowBox[{"_", "?", "BraQ"}]}], "]"}]}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"num", "\[Times]", 
    RowBox[{"ConstructMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461003537409491*^9, 3.461003581225576*^9}, {
   3.4610036621431913`*^9, 3.461003672188841*^9}, {3.461036334110464*^9, 
   3.4610363445536633`*^9}, {3.4610365524132833`*^9, 3.461036553666215*^9}, {
   3.486464393342422*^9, 3.486464394180337*^9}, 3.486464444666751*^9},
 CellLabel->
  "In[1524]:=",ExpressionUUID->"5dc89a4a-96c0-4984-9970-4a350b9fb987"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnityOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609830829985647`*^9, 3.460983098508914*^9}, {
   3.4610015105360126`*^9, 3.461001515606124*^9}, 3.461001826432135*^9, {
   3.461003521546376*^9, 3.461003533063559*^9}, {3.4610363268929853`*^9, 
   3.461036331173377*^9}, {3.653576883661025*^9, 
   3.653576897683465*^9}},ExpressionUUID->"b53576c4-9f05-4a76-b676-\
b3b30be4b936"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "___", "]"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i_", ",", "i_"}], "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"BasisDimension", "[", "basis", "]"}], ",", 
       RowBox[{"BasisDimension", "[", "basis", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.653576904418559*^9, 3.653577003448242*^9}},
 CellLabel->
  "In[1525]:=",ExpressionUUID->"a021bbd8-26fc-4853-880d-947e5ace6f10"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
single spin operator, or product of spin operators, all for the same spin, \
embedded in a larger system\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609830829985647`*^9, 3.460983098508914*^9}, {
   3.4610015105360126`*^9, 3.461001515606124*^9}, 
   3.461001826432135*^9},ExpressionUUID->"4aa56199-cd11-42bd-a549-\
3855705c8d5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ConstructMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opj", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"HoldPattern", "@", 
          RowBox[{"OperatorProduct", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"opI", "|", "opR"}], ")"}], "[", 
              RowBox[{"j_", ",", "___"}], "]"}], ".."}], ",", "___Rule"}], 
           "]"}]}], "|", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"opI", "|", "opR"}], ")"}], "[", 
          RowBox[{"j_", ",", "___"}], "]"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"basis", ":", 
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{
         RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
        "]"}]}], ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "spins", "]"}], ">", "1"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Apply", "[", "\[IndentingNewLine]", 
    RowBox[{"KroneckerProduct", ",", "\[IndentingNewLine]", 
     RowBox[{"Reverse", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"#", "\[Equal]", "j"}], ",", "\[IndentingNewLine]", 
          RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
           RowBox[{"opj", ",", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"Cases", "[", 
              RowBox[{"spins", ",", 
               RowBox[{"{", 
                RowBox[{"j", ",", "_"}], "}"}]}], "]"}], "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"UnityOperator", "[", "#", "]"}], ",", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"Cases", "[", 
              RowBox[{"spins", ",", 
               RowBox[{"{", 
                RowBox[{"#", ",", "_"}], "}"}]}], "]"}], "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], "&"}], "/@", 
       RowBox[{"(", 
        RowBox[{"First", "/@", "spins"}], ")"}]}], "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460983119629469*^9, 3.460983277238564*^9}, {
   3.460983319686677*^9, 3.460983478698606*^9}, {3.460983685855218*^9, 
   3.460983729796311*^9}, {3.460984442530295*^9, 3.46098445268655*^9}, 
   3.4609844861566563`*^9, {3.460998983619369*^9, 3.460998984469757*^9}, 
   3.460999474928316*^9, {3.461000113596483*^9, 3.461000118123766*^9}, {
   3.4610019127902527`*^9, 3.461001915240004*^9}, {3.4610022246713867`*^9, 
   3.461002362380479*^9}, {3.467559442719762*^9, 3.467559447312551*^9}, 
   3.4676312655859823`*^9, 3.486464794038184*^9, 3.4865332151548243`*^9, {
   3.535370754862035*^9, 3.5353707843163033`*^9}, {3.653575804134553*^9, 
   3.6535758068440237`*^9}, {3.653578364225754*^9, 3.653578364575683*^9}, {
   3.6535860755436153`*^9, 3.653586194299568*^9}, {3.653586310988091*^9, 
   3.653586313706417*^9}, {3.653586926867552*^9, 3.653586928555976*^9}, {
   3.653586961602364*^9, 3.6535869962583857`*^9}},
 CellLabel->
  "In[1526]:=",ExpressionUUID->"31c4deec-d0da-4e95-9cb6-4a6fa8411ebe"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
single spin operator, or product of spin operators, all for the same spin, \
already in the system of that spin\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4610016113579283`*^9, 
  3.461001672173852*^9}},ExpressionUUID->"d04601f8-b133-47a9-bd73-\
8fd9195ccf00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"opj", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"HoldPattern", "@", 
         RowBox[{"OperatorProduct", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"opI", "|", "opR"}], ")"}], "[", 
             RowBox[{"j_", ",", "___"}], "]"}], ".."}], ",", "___Rule"}], 
          "]"}]}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"opI", "|", "opR"}], ")"}], "[", 
         RowBox[{"j_", ",", "___"}], "]"}]}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "basisopts___Rule"}],
        "]"}]}], ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{"opj", ",", "basis"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461001637912237*^9, 3.461001646180674*^9}, {
   3.4610016785957747`*^9, 3.461001700676812*^9}, 3.486533234303687*^9, 
   3.653576261258625*^9, {3.653578345742619*^9, 3.653578347750238*^9}},
 CellLabel->
  "In[1527]:=",ExpressionUUID->"22a7c948-9fd1-4e2b-ae64-1fda27251fd8"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle kets", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609830829985647`*^9, 3.460983098508914*^9}, {
  3.4610003281467*^9, 
  3.461000329670574*^9}},ExpressionUUID->"b91e273c-a47b-45d3-b2c1-\
70d4d10d616f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"ket_", "?", "KetQ"}], ",", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"List", "/@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{"ket", ",", "basis", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461000335796135*^9, 3.4610003910597973`*^9}, 
   3.4610004514204903`*^9, 3.486533242718173*^9},
 CellLabel->
  "In[1528]:=",ExpressionUUID->"47d23764-2669-47b9-a851-72b4946ff4f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle bras", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609830829985647`*^9, 3.460983098508914*^9}, {
  3.4610003281467*^9, 3.461000329670574*^9}, {3.461000435223184*^9, 
  3.4610004357890663`*^9}},ExpressionUUID->"b3400ac3-6b9e-44d9-a900-\
5247b793573d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstructMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"bra_", "?", "BraQ"}], ",", 
     RowBox[{"basis", ":", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"spins_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{"bra", ",", "basis", ",", "opts"}], "]"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461000335796135*^9, 3.4610003910597973`*^9}, {
   3.461000437688189*^9, 3.461000449088706*^9}, 3.486533248422098*^9},
 CellLabel->
  "In[1529]:=",ExpressionUUID->"d4323c7d-3093-4945-8dce-da6c43c5b69d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SingleSpinZeemanBasisMatrixRepresentation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609621213078403`*^9, 3.46096212834722*^9}, {
   3.460962493569273*^9, 3.460962504951665*^9}, 
   3.460963749227968*^9},ExpressionUUID->"2f2f3f0c-871e-491c-8c99-\
be245c5ad59b"],

Cell[CellGroupData[{

Cell["\<\
products of operators for the same spin: take the product of the matrix \
representations\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460999603835312*^9, 
  3.4609996592010393`*^9}},ExpressionUUID->"f413e51e-22de-491c-9676-\
cf38a24e9904"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
    "SingleSpinZeemanBasisMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"opI", "|", "opR", "|", "UnityOperator"}], ")"}], "[", 
           RowBox[{"j_", ",", "___"}], "]"}], ".."}]}], ",", "___Rule"}], 
       "]"}], ",", 
      RowBox[{"basis", ":", 
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", 
         "basisopts___Rule"}], "]"}]}]}], "]"}]}], ":=", 
   RowBox[{"Dot", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
        RowBox[{"#", ",", "basis"}], "]"}], "&"}], "/@", 
      RowBox[{"{", "ops", "}"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4609641501303053`*^9, 3.460964241770522*^9}, {
   3.460964280355654*^9, 3.4609643322962217`*^9}, {3.46096436369382*^9, 
   3.460964363898572*^9}, {3.460969270478471*^9, 3.460969273671318*^9}, {
   3.460969333778327*^9, 3.460969337279026*^9}, {3.460969665542145*^9, 
   3.460969670763308*^9}, 3.460998995421089*^9, {3.4609993455666313`*^9, 
   3.460999347777752*^9}, {3.460999669658223*^9, 3.46099979789113*^9}, 
   3.48646482834411*^9, 3.486533255959322*^9, 3.653576266012505*^9, {
   3.653578388448297*^9, 3.653578391147986*^9}, {3.6535786273629932`*^9, 
   3.6535786634893084`*^9}},
 CellLabel->
  "In[1530]:=",ExpressionUUID->"2ac31aba-ca99-4f5a-b400-6f4f05544994"]
}, Closed]],

Cell[CellGroupData[{

Cell["Iz", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4609999245906*^9, 
  3.4609999248933163`*^9}},ExpressionUUID->"63103e0d-3833-4432-a3dd-\
7da719ee30f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j_", ",", "\"\<z\>\"", ",", "more___"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "basisopts___Rule"}],
        "]"}], ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<z\>\"", ",", "more"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j", ",", "Ij"}], "}"}], "}"}], ",", "basisopts"}], "]"}], 
      ",", "opts"}], "]"}], "=", 
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{"Band", "[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
      RowBox[{"Table", "[", 
       RowBox[{"m", ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"+", "Ij"}], ",", 
          RowBox[{"-", "Ij"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, 3.435131595881124*^9, {3.435134088984499*^9, 
   3.435134141694338*^9}, 3.435138769764427*^9, {3.4351619443647833`*^9, 
   3.43516194852244*^9}, 3.46099885264258*^9, 3.486533265199443*^9, {
   3.639207901094017*^9, 3.63920792644978*^9}, {3.699277526753392*^9, 
   3.6992775311165037`*^9}, {3.6992775643279333`*^9, 3.699277576015728*^9}},
 CellLabel->
  "In[1531]:=",ExpressionUUID->"6a374e8c-47f2-4329-8ae5-16da8c69483f"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SuperscriptBox["I", "+"], 
  TraditionalForm]],ExpressionUUID->"c46cab5b-e406-466d-b87c-4ff71da31883"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
  3.4351306060634737`*^9, 3.435130606412087*^9}, {3.435131062185657*^9, 
  3.4351310635699863`*^9}, {3.435133996502914*^9, 
  3.4351340012353888`*^9}},ExpressionUUID->"2892a124-b2d9-44ad-ab2c-\
3d88ec1955c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j_", ",", "\"\<+\>\"", ",", "more___"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "basisopts___Rule"}],
        "]"}], ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<+\>\"", ",", "more"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j", ",", "Ij"}], "}"}], "}"}], ",", "basisopts"}], "]"}], 
      ",", "opts"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Band", "[", 
        RowBox[{"{", 
         RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"Ij", 
            RowBox[{"(", 
             RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
           RowBox[{"m", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{"-", "Ij"}], ",", 
           RowBox[{"Ij", "-", "1"}], ",", "1"}], "}"}]}], "]"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "Ij"}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"2", "Ij"}], "+", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, {3.435131078516583*^9, 3.4351310791155167`*^9}, {
   3.4351311213772497`*^9, 3.435131220748982*^9}, {3.4351313286601458`*^9, 
   3.4351313418981657`*^9}, {3.435131389648312*^9, 3.4351314821672087`*^9}, {
   3.4351315796336117`*^9, 3.435131583116847*^9}, 3.4351387707089357`*^9, 
   3.435161955275054*^9, 3.4609988545104837`*^9, 3.486533272256428*^9, {
   3.639207942046525*^9, 3.639207953622284*^9}, {3.699277587818359*^9, 
   3.6992775974590693`*^9}},
 CellLabel->
  "In[1532]:=",ExpressionUUID->"b7bec108-ac58-4e18-aa3d-63adffa16606"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SuperscriptBox["I", "-"], 
  TraditionalForm]],ExpressionUUID->"0c42d086-e0b8-48a2-a45f-3554f9c99527"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
   3.4351306060634737`*^9, 3.435130606412087*^9}, {3.435131062185657*^9, 
   3.4351310635699863`*^9}, 3.435131515403674*^9, {3.435134006515868*^9, 
   3.435134011910555*^9}},ExpressionUUID->"c185cc7e-6c9c-49e3-a36d-\
1fab29aa963f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j_", ",", "\"\<-\>\"", ",", "more___"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "basisopts___Rule"}],
        "]"}], ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<-\>\"", ",", "more"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j", ",", "Ij"}], "}"}], "}"}], ",", "basisopts"}], "]"}], 
      ",", "opts"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Band", "[", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}], "]"}], "\[Rule]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{
           RowBox[{"Ij", 
            RowBox[{"(", 
             RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
           RowBox[{"m", 
            RowBox[{"(", 
             RowBox[{"m", "-", "1"}], ")"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"m", ",", 
           RowBox[{
            RowBox[{"-", "Ij"}], "+", "1"}], ",", "Ij", ",", "1"}], "}"}]}], 
        "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "Ij"}], "+", "1"}], ",", 
        RowBox[{
         RowBox[{"2", "Ij"}], "+", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, {3.435131078516583*^9, 3.4351310791155167`*^9}, {
   3.4351311213772497`*^9, 3.435131220748982*^9}, {3.4351313286601458`*^9, 
   3.4351313418981657`*^9}, {3.435131389648312*^9, 3.4351314821672087`*^9}, {
   3.435131519445095*^9, 3.435131548557042*^9}, 3.4351315873131113`*^9, 
   3.435138771675494*^9, 3.435161957253631*^9, 3.4609988573665533`*^9, 
   3.4865332782724743`*^9, {3.6392079649180393`*^9, 3.639207974231962*^9}, {
   3.699277606066992*^9, 3.6992776109363737`*^9}},
 CellLabel->
  "In[1533]:=",ExpressionUUID->"42fd3747-fdf4-4df1-aeb5-64bbfd757f92"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SubscriptBox["I", "x"], 
  TraditionalForm]],ExpressionUUID->"1216582e-7b0c-4e2b-bc01-8bbb52e3decc"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
  3.4351306060634737`*^9, 3.435130606412087*^9}, {3.435131062185657*^9, 
  3.4351310635699863`*^9}, {3.435131622395339*^9, 3.435131623248733*^9}, {
  3.435134018006019*^9, 
  3.435134022288416*^9}},ExpressionUUID->"0e9c5cb6-d09e-435c-aeb3-\
2721d84d6a2d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j_", ",", "\"\<x\>\"", ",", "more___"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<x\>\"", ",", "more"}], "]"}], ",", "basis", ",", 
     "opts"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "2"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<+\>\"", ",", "more"}], "]"}], ",", "basis", 
        ",", "opts"}], "]"}], "+", 
      RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<-\>\"", ",", "more"}], "]"}], ",", "basis", 
        ",", "opts"}], "]"}]}], ")"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4351316327651052`*^9, 3.435131684516362*^9}, 
   3.435131750080632*^9, {3.435138772627469*^9, 3.435138775123855*^9}, 
   3.435161959573965*^9, 3.460998859681778*^9, {3.6211607363910007`*^9, 
   3.6211607374373713`*^9}, {3.639207998537141*^9, 3.6392080331662903`*^9}, {
   3.699277617587077*^9, 3.6992776383643637`*^9}},
 CellLabel->
  "In[1534]:=",ExpressionUUID->"1377d2f9-d9f0-40e7-8f05-085dd86e536a"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SubscriptBox["I", "y"], 
  TraditionalForm]],ExpressionUUID->"42594492-5218-43b1-a9c2-fa9125ab5ac7"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
  3.4351306060634737`*^9, 3.435130606412087*^9}, {3.435131062185657*^9, 
  3.4351310635699863`*^9}, {3.435131622395339*^9, 3.435131623248733*^9}, {
  3.4351316949686403`*^9, 3.43513169622467*^9}, {3.435134026300144*^9, 
  3.435134030312467*^9}},ExpressionUUID->"8af20e1f-d5fe-45ac-84bf-\
f872abec191a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j_", ",", "\"\<y\>\"", ",", "more___"}], "]"}], ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", 
  RowBox[{
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"opI", "[", 
      RowBox[{"j", ",", "\"\<y\>\"", ",", "more"}], "]"}], ",", "basis", ",", 
     "opts"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"2", "I"}], ")"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<+\>\"", ",", "more"}], "]"}], ",", "basis", 
        ",", "opts"}], "]"}], "-", 
      RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\"\<-\>\"", ",", "more"}], "]"}], ",", "basis", 
        ",", "opts"}], "]"}]}], ")"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4351316327651052`*^9, 3.435131708179921*^9}, 
   3.435131752279018*^9, {3.4351387762524977`*^9, 3.43513877845829*^9}, 
   3.435161965126295*^9, 3.460998861539665*^9, {3.621160740970128*^9, 
   3.6211607423089*^9}, {3.63920804181607*^9, 3.639208051379281*^9}, {
   3.69927764368748*^9, 3.699277660571739*^9}, 3.7016319755928097`*^9, 
   3.701632133039462*^9},
 CellLabel->
  "In[1535]:=",ExpressionUUID->"c82914f4-603f-41e6-be09-f4936b16ef9c"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SuperscriptBox["I", "\[Alpha]"], 
  TraditionalForm]],ExpressionUUID->"fed218af-cd55-4590-bab6-8d1024181842"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
  3.4351306060634737`*^9, 3.435130606412087*^9}, {3.4351318129312267`*^9, 
  3.435131815018404*^9}, {3.435133977651616*^9, 
  3.435133985843789*^9}},ExpressionUUID->"96771d5c-7cd4-4737-a0b8-\
183debe6969a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_", ",", "\"\<\[Alpha]\>\"", ",", "more___"}], "]"}]}], ",", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"j_", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "}"}], ",", "basisopts___Rule"}], 
     "]"}], ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, 3.435131595881124*^9, {3.435131822465625*^9, 
   3.4351318295085707`*^9}, {3.435131867147069*^9, 3.43513187506391*^9}, 
   3.4351387800437326`*^9, 3.435161967885898*^9, 3.4395545511054163`*^9, {
   3.439554593986903*^9, 3.439554596735279*^9}, 3.460998867199654*^9, 
   3.486533291022978*^9, {3.699277665995579*^9, 3.6992776677719593`*^9}},
 CellLabel->
  "In[1536]:=",ExpressionUUID->"1a1a8567-0faa-48c4-a983-1f829969d2d8"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SuperscriptBox["I", "\[Beta]"], 
  TraditionalForm]],ExpressionUUID->"f5ecd27a-c051-465b-b90b-6d0aba8013c5"]], \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130312449391*^9, 3.4351303133414288`*^9}, {
  3.4351306060634737`*^9, 3.435130606412087*^9}, {3.4351318129312267`*^9, 
  3.435131815018404*^9}, {3.435131896929522*^9, 3.435131898463295*^9}, {
  3.435133955415051*^9, 
  3.4351339709597197`*^9}},ExpressionUUID->"5bd0f522-0474-46bc-bfe6-\
237611571565"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", 
      RowBox[{"j_", ",", "\"\<\[Beta]\>\"", ",", "more___"}], "]"}]}], ",", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"j_", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "}"}], ",", "basisopts___Rule"}], 
     "]"}], ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], "\[Rule]", "1"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, 3.435131595881124*^9, {3.435131822465625*^9, 
   3.4351318295085707`*^9}, {3.435131867147069*^9, 3.435131892544264*^9}, 
   3.435138781302493*^9, {3.435161971973296*^9, 3.435161974849506*^9}, 
   3.439554556039484*^9, {3.439554599671884*^9, 3.439554601847651*^9}, 
   3.4609988698011017`*^9, 3.486533297470587*^9, {3.699277675221636*^9, 
   3.6992776770442343`*^9}},
 CellLabel->
  "In[1537]:=",ExpressionUUID->"cb8de8d6-f43e-43e0-9cae-807ec8b77870"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "j_", "]"}], ",", 
     RowBox[{"ZeemanBasis", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "basisopts___Rule"}], 
      "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"Band", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", "Ij"}], "+", "1"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, 3.435131595881124*^9, {3.435131822465625*^9, 
   3.4351318295085707`*^9}, {3.435131867147069*^9, 3.435131892544264*^9}, 
   3.435138781302493*^9, {3.435161971973296*^9, 3.435161974849506*^9}, 
   3.439554556039484*^9, {3.439554599671884*^9, 3.439554601847651*^9}, 
   3.4609988698011017`*^9, {3.460999176452159*^9, 3.460999223395248*^9}, 
   3.48646484061094*^9, 3.486533303713161*^9},
 CellLabel->
  "In[1538]:=",ExpressionUUID->"4a977c6a-62dc-4b60-bffb-fb50cf61089e"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationOperators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.460999936918376*^9, 
  3.4609999402783947`*^9}},ExpressionUUID->"ae4bb82c-1be6-4a55-80e7-\
ae93f4ed0020"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"opR", "[", 
       RowBox[{"j_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Beta]_", ",", 
          RowBox[{"\[Mu]", ":", 
           RowBox[{"(", 
            RowBox[{"\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\""}], 
            ")"}]}]}], "}"}], ",", "more___"}], "]"}], ",", 
      RowBox[{"basis", ":", 
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", 
         "basisopts___Rule"}], "]"}]}], ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Chop", "@", 
    RowBox[{"MatrixExp", "[", 
     RowBox[{
      RowBox[{"-", "I"}], " ", "\[Beta]", " ", 
      RowBox[{"SingleSpinZeemanBasisMatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"opI", "[", 
         RowBox[{"j", ",", "\[Mu]", ",", "more"}], "]"}], ",", "basis"}], 
       "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460999958149407*^9, 3.461000043397923*^9}, 
   3.48653331155195*^9, 3.5123979096440477`*^9, {3.6992776849757223`*^9, 
   3.6992776922537622`*^9}},
 CellLabel->
  "In[1539]:=",ExpressionUUID->"f09657ca-0586-4d2a-a88f-39ff832cde59"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["any other operators \[Rule] switch to direct method", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439556134936461*^9, 3.4395561699887114`*^9}, {
   3.439556231249998*^9, 3.439556232460958*^9}, 3.460869867383815*^9, 
   3.4610005801119423`*^9},ExpressionUUID->"55ae675a-6563-4861-8648-\
ba5fd49d86d7"],

Cell["this applies in particular to ket.bra products", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43955623492141*^9, 
  3.4395562449886713`*^9}},ExpressionUUID->"0583159b-3fe9-4d3b-b8e8-\
835b6c162bc5"],

Cell["\<\
The code for an Operator in vector form is handled in NMR`Superoperators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.589264454852438*^9, 
  3.58926447360354*^9}},ExpressionUUID->"efa20ae4-8cce-4d42-bed9-\
f6497b7209c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], "|", 
          RowBox[{"_", "?", "KetQ"}], "|", 
          RowBox[{"_", "?", "BraQ"}]}], ")"}]}], ",", "basis_", ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"op", ",", 
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"_", "?", "VectorQ"}], ",", "___"}], "]"}]}]}], "]"}]}], 
      ")"}], "&&", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"op", ",", "_InterpolatingFunction"}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"MatrixRepresentation", "[", 
    RowBox[{"op", ",", "basis", ",", 
     RowBox[{"Method", "\[Rule]", "\"\<Direct\>\""}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435130608958325*^9, 
   3.435130647573503*^9}, {3.4351307401070004`*^9, 3.43513075268579*^9}, {
   3.435130788949546*^9, 3.435130789461412*^9}, {3.435130911482246*^9, 
   3.435130915757616*^9}, 3.435131595881124*^9, {3.435134088984499*^9, 
   3.435134141694338*^9}, 3.435138769764427*^9, {3.4351619443647833`*^9, 
   3.43516194852244*^9}, {3.439556178754064*^9, 3.4395562088227787`*^9}, {
   3.532171443507222*^9, 3.5321714453270903`*^9}, {3.532171776887066*^9, 
   3.5321717922148237`*^9}, 3.547025568815786*^9, 3.570342495581332*^9, {
   3.5892644188135757`*^9, 3.5892644460511637`*^9}, 3.593262382965952*^9, {
   3.6210953642367287`*^9, 3.621095377160246*^9}},
 CellLabel->
  "In[1540]:=",ExpressionUUID->"c05ea92a-de6a-4e34-99fd-66d4f6b226db"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439556134936461*^9, 3.4395561699887114`*^9}, {
   3.439556231249998*^9, 3.439556232460958*^9}, 3.460869867383815*^9, 
   3.4610005801119423`*^9, {3.531930388871133*^9, 
   3.531930390059944*^9}},ExpressionUUID->"3417a560-bd1e-46d9-b912-\
ffddb4c9a2db"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MatrixRepresentation", "::", "badop"}], "=", 
   "\"\<MatrixRepresentation may only be applied to an operator, a Ket or a \
Bra.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5319303977523413`*^9, 3.5319304432399893`*^9}, {
  3.531930893004917*^9, 3.5319308936026573`*^9}},
 CellLabel->
  "In[1541]:=",ExpressionUUID->"fc0bbacb-3502-47e6-a22a-400de18808ae"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigenbasis, TransformedBasis", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.683187884067408*^9, 
   3.6831878857943583`*^9}, {3.683188019928773*^9, 
   3.683188023459511*^9}},ExpressionUUID->"f4cd0790-3ba5-43bc-bcdb-\
a4e377d9d77e"],

Cell[CellGroupData[{

Cell["Eigenbasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 3.429682520655286*^9}, {
  3.5020163674684753`*^9, 
  3.502016371474929*^9}},ExpressionUUID->"0ef35f97-3490-4cdf-9a81-\
27c7fb9bc13b"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 
  3.439436494484573*^9}},ExpressionUUID->"fa74540f-4545-4ce0-b716-\
13a046a12c1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Eigenbasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"BasisLabels", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.501043345831255*^9, 3.501043359724909*^9}, 
   3.502016378967168*^9},
 CellLabel->
  "In[1542]:=",ExpressionUUID->"c7888b55-bbcd-48ca-be09-694227ee6dd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Eigenbasis", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Eigenbasis", "[", 
    RowBox[{"op", ",", 
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.502017445098415*^9, 3.502017470560584*^9}},
 CellLabel->
  "In[1543]:=",ExpressionUUID->"3a307b1d-f115-40c6-935e-26e30a6383bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Eigenbasis", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Eigenbasis", "[", "\[IndentingNewLine]", 
    RowBox[{"op", ",", "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Options", "[", "Eigenbasis", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501044223437993*^9, 3.501044384788707*^9}, {
  3.501044431270719*^9, 3.501044451332543*^9}, {3.501044504691627*^9, 
  3.501044515897071*^9}, {3.50104524010634*^9, 3.501045251679199*^9}, {
  3.501045445540399*^9, 3.501045448315486*^9}, {3.501045523382839*^9, 
  3.501045524738613*^9}, {3.50201834027234*^9, 3.502018417195421*^9}},
 CellLabel->
  "In[1544]:=",ExpressionUUID->"575a513c-e70d-484f-b0bb-33b6ef430d39"]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckBasis", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}, 
   3.501044929734041*^9, {3.683187966936311*^9, 
   3.683187968624135*^9}},ExpressionUUID->"d775fc62-96ff-4e07-bcdc-\
47c069a28f99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", 
    RowBox[{
     RowBox[{"Eigenbasis", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", 
       RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], "]"}],
      ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NormalQ", "[", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op", ",", 
      RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505118535351678*^9, 3.5051186201666937`*^9}, {
   3.505118754329114*^9, 3.505118801929175*^9}, 3.50511957416164*^9, {
   3.505119672159563*^9, 3.505119675383176*^9}, 3.6239477607999697`*^9},
 CellLabel->
  "In[1545]:=",ExpressionUUID->"209e2e49-8c05-4dd5-a182-d5a8fe2642c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["SetBasis", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}, 
   3.501044929734041*^9, {3.683187966936311*^9, 
   3.683187996068712*^9}},ExpressionUUID->"06b52349-f3e0-42d3-8287-\
c19a62cf5cc8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Eigenbasis", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", 
        RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"spinsys", "\[Equal]", 
       RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"Eigenbasis", "[", 
         RowBox[{"op", ",", "spinsys", ",", "basisopts"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetSpinSystem", "[", "spinsys", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"Basis", "[", "]"}], ",", "basis"}], "]"}]}], ",", 
         RowBox[{"SetBasis", "[", 
          RowBox[{"basis", ",", "opts"}], "]"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4389384684309607`*^9, 3.438938497044159*^9}, {
   3.4389386952167397`*^9, 3.438938749348257*^9}, {3.4389390563027353`*^9, 
   3.438939095598721*^9}, {3.43894000325774*^9, 3.4389400469656353`*^9}, {
   3.438940587240964*^9, 3.4389405974938917`*^9}, {3.438940751946364*^9, 
   3.438940754710593*^9}, {3.438940884781701*^9, 3.438940893896954*^9}, {
   3.438940939923792*^9, 3.438940943313365*^9}, {3.438940990182252*^9, 
   3.438941046158743*^9}, 3.438941110170247*^9, {3.438941437764842*^9, 
   3.438941446599493*^9}, {3.456203689417553*^9, 3.456203730440482*^9}, 
   3.456203824338887*^9, {3.456204229722039*^9, 3.456204249296723*^9}, {
   3.5010419522614517`*^9, 3.5010419653381042`*^9}, 3.501042328649622*^9, {
   3.505019416830983*^9, 3.505019460242467*^9}, {3.517848912172868*^9, 
   3.517848963675869*^9}, 3.61847236198503*^9},
 CellLabel->
  "In[1546]:=",ExpressionUUID->"a8377792-0ee6-4585-aa69-f0a73eb5f07f"]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedBasisQ", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}, 
   3.501044929734041*^9},ExpressionUUID->"5ebf437d-146a-4b44-9f52-\
6a75e2ad2619"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "[", 
    RowBox[{"Eigenbasis", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429810906571207*^9, 3.4298109624411077`*^9}, {
   3.438853086487935*^9, 3.4388531040278177`*^9}, 3.501043981041954*^9, {
   3.502016460266349*^9, 3.502016475016206*^9}, {3.502017506761675*^9, 
   3.5020175187617826`*^9}},
 CellLabel->
  "In[1547]:=",ExpressionUUID->"c16ca1d8-b7eb-4bea-b7f4-056f441a68f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 ExpressionUUID -> "aa9132b8-abb8-4df2-9760-9a951658edf7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "[", 
    RowBox[{"Eigenbasis", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", 
   RowBox[{"BasisDimension", "[", 
    RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429682561209777*^9, 3.429682583824851*^9}, 
   3.429684938095209*^9, {3.501043276599259*^9, 3.5010432795488777`*^9}, {
   3.5020164834354*^9, 3.502016494906588*^9}, {3.502017526986478*^9, 
   3.5020175289285517`*^9}, {3.502020236344823*^9, 3.502020240605795*^9}},
 CellLabel->
  "In[1548]:=",ExpressionUUID->"b40ea3e9-6e0b-4bd7-8c61-abeef70575c3"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisTransformationMatrix", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.5020165444152327`*^9},ExpressionUUID->"c80bc9ca-ba23-47f9-a057-\
937a29663e15"],

Cell["v2.7.b1: includes Orthogonalize", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.582973185327833*^9, 3.5829732049411716`*^9}, {
  3.582973272230451*^9, 
  3.582973277026065*^9}},ExpressionUUID->"e67d5e30-75d6-46b8-a1bf-\
f14ac090870c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Eigenbasis", "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
       ",", 
       RowBox[{"zbasis", ":", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{
          RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}]}], 
      "}"}], ",", "spinsys_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Eigenbasis", "[", 
         RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}], ",", "zbasis"}], 
       "}"}], ",", "spinsys"}], "]"}], "=", 
    RowBox[{"Chop", "@", 
     RowBox[{"SparseArray", "[", 
      RowBox[{"Normalize", "/@", "\[IndentingNewLine]", 
       RowBox[{"Orthogonalize", "@", 
        RowBox[{"Eigenvectors", "@", 
         RowBox[{"N", "@", 
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"op", ",", "zbasis"}], "]"}]}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020165497833652`*^9, 3.502016636018854*^9}, {
   3.502017083977468*^9, 3.502017094927087*^9}, 3.502017146699551*^9, {
   3.502017188884183*^9, 3.502017191865692*^9}, {3.502017545759768*^9, 
   3.502017554020623*^9}, {3.502017981481275*^9, 3.5020179909816103`*^9}, {
   3.502019570564384*^9, 3.502019629097189*^9}, {3.502020583085847*^9, 
   3.502020586212227*^9}, {3.5020206610947*^9, 3.502020663895142*^9}, {
   3.547531145414885*^9, 3.547531153939283*^9}, {3.582973159566574*^9, 
   3.5829731798673487`*^9}, {3.58297323310385*^9, 3.5829732526964273`*^9}, {
   3.623947041680978*^9, 3.6239470605207043`*^9}, {3.718347735030795*^9, 
   3.7183477397416935`*^9}, {3.7183477781797476`*^9, 3.718347795882516*^9}, {
   3.718520821376486*^9, 3.718520822814131*^9}, {3.728393605661373*^9, 
   3.728393606217183*^9}},
 CellLabel->
  "In[1549]:=",ExpressionUUID->"c1b6eba8-c8ba-46aa-9249-26cecd93134f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Eigenbasis", "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
       ",", 
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{
           RowBox[{"_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], "]"}]}]}], 
      "}"}], ",", "spinsys_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{"BasisTransformationMatrix", "[", 
       RowBox[{
        RowBox[{"Eigenbasis", "[", 
         RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}], ",", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], ".", 
      RowBox[{"BasisTransformationMatrix", "[", 
       RowBox[{
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", "basis"}], "]"}]}],
      "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020196778157253`*^9, 3.50201978506532*^9}, 
   3.502020113252646*^9, 3.50202337439907*^9, {3.547531189919853*^9, 
   3.5475311936940317`*^9}, {3.623947069097095*^9, 3.623947081432778*^9}, {
   3.728393659455161*^9, 3.728393666706458*^9}},
 CellLabel->
  "In[1550]:=",ExpressionUUID->"96bad9ce-598e-488d-9f8d-d9d9adf8b049"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"zbasis", ":", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{
          RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}]}], 
       ",", 
       RowBox[{"Eigenbasis", "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}]}], 
      "}"}], ",", "spinsys_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"zbasis", ",", 
        RowBox[{"Eigenbasis", "[", 
         RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}]}], "}"}], ",", 
      "spinsys"}], "]"}], "=", 
    RowBox[{"Chop", "@", 
     RowBox[{"SparseArray", "@", 
      RowBox[{"Adjoint", "[", 
       RowBox[{"BasisTransformationMatrix", "[", 
        RowBox[{
         RowBox[{"Eigenbasis", "[", 
          RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}], ",", "zbasis"}],
         "]"}], "]"}]}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020165497833652`*^9, 3.502016636018854*^9}, {
   3.502017083977468*^9, 3.502017094927087*^9}, {3.5020171279089937`*^9, 
   3.502017198233862*^9}, {3.502017567638732*^9, 3.502017586924367*^9}, 
   3.502017697867029*^9, {3.502019645852705*^9, 3.502019658744987*^9}, {
   3.5020206683746843`*^9, 3.5020206707194033`*^9}, {3.5475311810969353`*^9, 
   3.547531181927483*^9}, {3.623947111614448*^9, 3.62394713702411*^9}, {
   3.7283936710068245`*^9, 3.728393671893382*^9}},
 CellLabel->
  "In[1551]:=",ExpressionUUID->"5409d378-2153-4e81-a8fc-bb30416b6b3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{
           RowBox[{"_", "?", "MatrixQ"}], ",", "___Rule"}], "]"}], "]"}]}], 
       ",", 
       RowBox[{"Eigenbasis", "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", 
         RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}]}], 
      "}"}], ",", "spinsys_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{"BasisTransformationMatrix", "[", 
       RowBox[{"basis", ",", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], ".", 
      RowBox[{"BasisTransformationMatrix", "[", 
       RowBox[{
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
        RowBox[{"Eigenbasis", "[", 
         RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}]}], "]"}]}], "]"}],
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020196778157253`*^9, 3.50201978506532*^9}, {
   3.502020057222918*^9, 3.5020200834849367`*^9}, 3.5020201256048717`*^9, 
   3.502023385059682*^9, {3.547531197431728*^9, 3.547531201670452*^9}, {
   3.623947141099617*^9, 3.623947148073906*^9}, {3.7283936740126004`*^9, 
   3.7283936774171023`*^9}},
 CellLabel->
  "In[1552]:=",ExpressionUUID->"d162e9a6-a90f-44d9-b3e6-d911d2b7302d"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"a230bd5a-5508-4e05-9b75-af2de21b0560"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"Eigenbasis", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisKets", "[", 
     RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], "]"}], ".", 
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
      RowBox[{"Eigenbasis", "[", 
       RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429682606965963*^9, 3.429682693401084*^9}, {
   3.4296829388012667`*^9, 3.429682987125638*^9}, {3.4296836305388117`*^9, 
   3.429683672680526*^9}, {3.429685436650669*^9, 3.429685437302162*^9}, {
   3.429685481057397*^9, 3.429685486415897*^9}, {3.439437804972974*^9, 
   3.439437824182774*^9}, {3.50104130959269*^9, 3.501041325270698*^9}, {
   3.5010432892457867`*^9, 3.5010433086535892`*^9}, 3.501045601136455*^9, {
   3.5020165039007998`*^9, 3.502016514984851*^9}, {3.5020172206997957`*^9, 
   3.502017240170003*^9}, {3.502017597599135*^9, 3.502017605595933*^9}, {
   3.502018214881247*^9, 3.5020182267811747`*^9}, {3.6239477748471193`*^9, 
   3.6239477771262407`*^9}},
 CellLabel->
  "In[1553]:=",ExpressionUUID->"d2e51c9c-c12f-4a75-8652-0a6699f3a699"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"fbdae515-64d2-4db3-b314-974214e9f755"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", 
    RowBox[{"Eigenbasis", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"Eigenbasis", "[", 
       RowBox[{"op", ",", "spinsys", ",", "opts"}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], ".", 
    RowBox[{"BasisBras", "[", 
     RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], "]"}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296837804177017`*^9, 3.4296838218469677`*^9}, {
   3.429685439711335*^9, 3.429685440287122*^9}, {3.429685491399211*^9, 
   3.429685503728818*^9}, {3.439437840101775*^9, 3.439437857935*^9}, {
   3.5010413357609043`*^9, 3.501041353032669*^9}, {3.50104332500014*^9, 
   3.501043334333499*^9}, 3.501045607881752*^9, {3.5020172566426573`*^9, 
   3.502017276336644*^9}, {3.502017611902952*^9, 3.5020176186119757`*^9}, {
   3.502018241746413*^9, 3.502018245230214*^9}, {3.623947786453567*^9, 
   3.623947789662653*^9}},
 CellLabel->
  "In[1554]:=",ExpressionUUID->"5ce65d84-b3ff-4294-a3cb-f6413c1ef91d"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"5cade890-f720-4d74-8959-\
5bbc84acfb06"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"Eigenbasis", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], "^:=", "spinsys"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}, {
  3.482571334646247*^9, 3.48257138911128*^9}, {3.502017288323278*^9, 
  3.5020173054797573`*^9}, {3.50201763140621*^9, 3.5020176443074713`*^9}},
 CellLabel->
  "In[1555]:=",ExpressionUUID->"b0445d53-5685-4021-a301-f004360fb396"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformedBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 
  3.429682520655286*^9}},ExpressionUUID->"b328f40e-db7d-4e79-87e7-\
0fc94a6d826d"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 
  3.439436494484573*^9}},ExpressionUUID->"beb7d2fd-3563-4ca3-94b4-\
500517361f47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TransformedBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"BasisLabels", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.501043345831255*^9, 3.501043359724909*^9}},
 CellLabel->
  "In[1556]:=",ExpressionUUID->"9cb58a7f-5471-41c1-857a-dc1ab1690483"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformedBasis", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformedBasis", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394365036958723`*^9, 3.4394365193261213`*^9}, 
   3.456162875754142*^9, {3.501043241047721*^9, 3.5010432630528193`*^9}, {
   3.5010452568799953`*^9, 3.5010452657569532`*^9}, {3.501045312590337*^9, 
   3.5010453147259903`*^9}, {3.501045404861643*^9, 3.5010454095014057`*^9}, {
   3.5020687106626663`*^9, 3.502068713318201*^9}, {3.502068787251823*^9, 
   3.5020688030276937`*^9}, {3.502070540437068*^9, 3.502070543738676*^9}},
 CellLabel->
  "In[1557]:=",ExpressionUUID->"f8d82e41-c205-4156-ab51-ff5adaeb251e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformedBasis", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "basis_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformedBasis", "[", 
    RowBox[{"op", ",", "basis", ",", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Options", "[", "TransformedBasis", "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501044223437993*^9, 3.501044384788707*^9}, {
  3.501044431270719*^9, 3.501044451332543*^9}, {3.501044504691627*^9, 
  3.501044515897071*^9}, {3.50104524010634*^9, 3.501045251679199*^9}, {
  3.501045445540399*^9, 3.501045448315486*^9}, {3.501045523382839*^9, 
  3.501045524738613*^9}, {3.502068747556726*^9, 3.502068826908206*^9}, {
  3.5020705491870203`*^9, 3.502070561714641*^9}},
 CellLabel->
  "In[1558]:=",ExpressionUUID->"34d15f9b-ea64-40bc-877b-8d561174c2c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformedBasis", "[", 
    RowBox[{
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TransformedBasis", "[", 
      RowBox[{
       RowBox[{"op1_", "?", "OperatorQ"}], ",", "basis_", ",", 
       "opts1___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformedBasis", "[", 
    RowBox[{
     RowBox[{"op2", ".", "op1"}], ",", "basis", ",", "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{"{", 
        RowBox[{"opts2", ",", "opts1"}], "}"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50207131656629*^9, 3.5020714022946177`*^9}},
 CellLabel->
  "In[1559]:=",ExpressionUUID->"caccec8d-5f6f-4728-bdb6-2f5bf9a6191e"]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedBasisQ", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}, 
   3.501044929734041*^9},ExpressionUUID->"15bcde6d-7423-457b-a734-\
a86347378e18"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "[", 
    RowBox[{"TransformedBasis", "[", 
     RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], "^:=", 
   
   RowBox[{"DefinedBasisQ", "[", "basis", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429810906571207*^9, 3.4298109624411077`*^9}, {
   3.438853086487935*^9, 3.4388531040278177`*^9}, 3.501043981041954*^9, {
   3.502070570557356*^9, 3.5020705746106*^9}},
 CellLabel->
  "In[1560]:=",ExpressionUUID->"e7300878-ab24-4190-b723-074dc714cb3d"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"788da9d7-7f49-4881-bd3c-58cdeef6162f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "[", 
    RowBox[{"TransformedBasis", "[", 
     RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429682561209777*^9, 3.429682583824851*^9}, 
   3.429684938095209*^9, {3.501043276599259*^9, 3.5010432795488777`*^9}, 
   3.502070582588526*^9},
 CellLabel->
  "In[1561]:=",ExpressionUUID->"9b334a9a-8e6c-4118-bb60-316e55cd2587"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisTransformationMatrix", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502068915876031*^9, 
  3.502068921677644*^9}},ExpressionUUID->"3f0b2e73-b10e-4f27-9491-\
b1f499410592"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"TransformedBasis", "[", 
        RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], ",", 
       "basis_"}], "}"}], ",", "spinsys_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"TransformedBasis", "[", 
         RowBox[{"op", ",", "basis", ",", "opts"}], "]"}], ",", "basis"}], 
       "}"}], ",", "spinsys"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"Adjoint", "@", 
     RowBox[{"MatrixRepresentation", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394360374879417`*^9, 3.4394360826072187`*^9}, {
   3.439436117367297*^9, 3.439436129790681*^9}, {3.439436205115407*^9, 
   3.439436208135047*^9}, 3.439436371235312*^9, {3.4394380117995453`*^9, 
   3.439438013535521*^9}, {3.501045644357445*^9, 3.501045664041532*^9}, {
   3.5010458704205637`*^9, 3.501045873617652*^9}, {3.501046473145796*^9, 
   3.501046511599329*^9}, {3.502068952282995*^9, 3.5020689739514923`*^9}, {
   3.5020705912450247`*^9, 3.502070606107032*^9}, {3.623946868238597*^9, 
   3.6239468889956903`*^9}},
 CellLabel->
  "In[1562]:=",ExpressionUUID->"de954bb2-7750-470f-b69b-716e5b147ee8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis_", ",", 
       RowBox[{"TransformedBasis", "[", 
        RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "}"}], 
     ",", "spinsys_"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"basis", ",", 
        RowBox[{"TransformedBasis", "[", 
         RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "}"}], ",", 
      "spinsys"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394360374879417`*^9, 3.4394360826072187`*^9}, {
   3.439436117367297*^9, 3.4394361619271507`*^9}, 3.439436212494954*^9, {
   3.439436373535125*^9, 3.4394363751830807`*^9}, 3.439438009242848*^9, {
   3.5010456686256*^9, 3.501045679361281*^9}, {3.501045876409897*^9, 
   3.501045888097414*^9}, {3.501046526345317*^9, 3.501046556982932*^9}, {
   3.502068984736373*^9, 3.5020690002394238`*^9}, {3.502070634867096*^9, 
   3.502070646282777*^9}, {3.623946897446521*^9, 3.623946919412284*^9}},
 CellLabel->
  "In[1563]:=",ExpressionUUID->"b147989d-092e-4160-a3f4-665208f5450c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"TransformedBasis", "[", 
        RowBox[{"op_", ",", "basis1_", ",", "opts___Rule"}], "]"}], ",", 
       "basis2_"}], "}"}], ",", "spinsys_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"TransformedBasis", "[", 
         RowBox[{"op", ",", "basis1", ",", "opts"}], "]"}], ",", "basis1"}], 
       "}"}], ",", "spinsys"}], "]"}], ".", 
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"basis1", ",", "basis2"}], "}"}], ",", "spinsys"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394360374879417`*^9, 3.4394360826072187`*^9}, {
   3.439436117367297*^9, 3.439436129790681*^9}, {3.439436205115407*^9, 
   3.439436208135047*^9}, 3.439436371235312*^9, {3.4394380117995453`*^9, 
   3.439438013535521*^9}, {3.501045644357445*^9, 3.501045664041532*^9}, {
   3.5010458704205637`*^9, 3.501045873617652*^9}, {3.501046473145796*^9, 
   3.501046511599329*^9}, {3.502068952282995*^9, 3.5020689739514923`*^9}, {
   3.502069167996904*^9, 3.502069236853887*^9}, {3.502070614819004*^9, 
   3.502070626778565*^9}, {3.62394692911756*^9, 3.623946985266644*^9}},
 CellLabel->
  "In[1564]:=",ExpressionUUID->"936ab876-9463-4ece-b30f-e440ed726b10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis2_", ",", 
       RowBox[{"TransformedBasis", "[", 
        RowBox[{"op_", ",", "basis1_", ",", "opts___Rule"}], "]"}]}], "}"}], 
     ",", "spinsys_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"basis2", ",", "basis1"}], "}"}], ",", "spinsys"}], "]"}], ".", 
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"basis1", ",", 
        RowBox[{"TransformedBasis", "[", 
         RowBox[{"op", ",", "basis1", ",", "opts"}], "]"}]}], "}"}], ",", 
      "spinsys"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394360374879417`*^9, 3.4394360826072187`*^9}, {
   3.439436117367297*^9, 3.439436129790681*^9}, {3.439436205115407*^9, 
   3.439436208135047*^9}, 3.439436371235312*^9, {3.4394380117995453`*^9, 
   3.439438013535521*^9}, {3.501045644357445*^9, 3.501045664041532*^9}, {
   3.5010458704205637`*^9, 3.501045873617652*^9}, {3.501046473145796*^9, 
   3.501046511599329*^9}, {3.502068952282995*^9, 3.5020689739514923`*^9}, {
   3.502069167996904*^9, 3.50206929777732*^9}, {3.5020706671065817`*^9, 
   3.502070686538596*^9}, {3.623946953701106*^9, 3.623947004773155*^9}},
 CellLabel->
  "In[1565]:=",ExpressionUUID->"c7f383ac-aa19-421d-aba4-ff94a74347cd"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"7d1bf19b-1b5c-415f-b118-2e3ce76e1826"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"TransformedBasis", "[", 
     RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"TransformedBasis", "[", 
       RowBox[{"op", ",", "basis", ",", "opts"}], "]"}], ",", "basis"}], 
     "]"}], ".", 
    RowBox[{"BasisKets", "[", "basis", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429682606965963*^9, 3.429682693401084*^9}, {
   3.4296829388012667`*^9, 3.429682987125638*^9}, {3.4296836305388117`*^9, 
   3.429683672680526*^9}, {3.429685436650669*^9, 3.429685437302162*^9}, {
   3.429685481057397*^9, 3.429685486415897*^9}, {3.439437804972974*^9, 
   3.439437824182774*^9}, {3.50104130959269*^9, 3.501041325270698*^9}, {
   3.5010432892457867`*^9, 3.5010433086535892`*^9}, 3.501045601136455*^9, {
   3.50207075131767*^9, 3.502070777009927*^9}, {3.502070819226054*^9, 
   3.502070835817986*^9}, {3.502071114501257*^9, 3.50207111516232*^9}},
 CellLabel->
  "In[1566]:=",ExpressionUUID->"80b0a572-50f4-4f70-8a94-61137a2a6ab6"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"662173a0-8d9f-4734-b375-da5c101f2389"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", 
    RowBox[{"TransformedBasis", "[", 
     RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisBras", "[", "basis", "]"}], ".", 
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{"basis", ",", 
      RowBox[{"TransformedBasis", "[", 
       RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296837804177017`*^9, 3.4296838218469677`*^9}, {
   3.429685439711335*^9, 3.429685440287122*^9}, {3.429685491399211*^9, 
   3.429685503728818*^9}, {3.439437840101775*^9, 3.439437857935*^9}, {
   3.5010413357609043`*^9, 3.501041353032669*^9}, {3.50104332500014*^9, 
   3.501043334333499*^9}, 3.501045607881752*^9, {3.502070781474103*^9, 
   3.502070791921955*^9}, {3.5020708427537947`*^9, 3.502070855114654*^9}},
 CellLabel->
  "In[1567]:=",ExpressionUUID->"2cd00959-b2d0-4db3-98f5-179826e6d214"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"48867fa6-d2a0-4b18-a62f-\
633b71f8ab40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"TransformedBasis", "[", 
     RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], "^:=", 
   
   RowBox[{"SpinSystem", "[", "basis", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}, {
  3.482571334646247*^9, 3.48257138911128*^9}, {3.502068864622397*^9, 
  3.502068867203372*^9}, {3.502070862763466*^9, 3.502070869873168*^9}},
 CellLabel->
  "In[1568]:=",ExpressionUUID->"89976b68-7400-442c-a635-3c9b866d7a19"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["functions of operators", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"6a08c362-12d4-4327-9920-f6d7e8f77d7d"],

Cell[CellGroupData[{

Cell["Commutator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"d1a52934-de4c-41e9-a8ec-d24079136ee4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Commutator", "[", 
     RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
    RowBox[{"Simplify", "[", 
     RowBox[{
      RowBox[{"a", ".", "b"}], "-", 
      RowBox[{"b", ".", "a"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.657795669858753*^9, 3.657795674426064*^9}},
 CellLabel->
  "In[1569]:=",ExpressionUUID->"ce846045-db2a-48a9-b5cb-40cb7b64a837"]
}, Closed]],

Cell[CellGroupData[{

Cell["CoherenceOrder", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"5c6d00df-e547-4096-b102-fc9e53ccf5e5"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"9abded02-072f-4b05-9c9c-970f6040e1c3"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f7d372bb-eb02-4640-9fa4-facdb4055980"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CoherenceOrder", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342549538795*^9, {3.621243820894185*^9, 3.62124383739154*^9}, 
   3.6305694259241333`*^9, 3.630581965935542*^9},
 CellLabel->
  "In[1570]:=",ExpressionUUID->"5f72eaa5-cdc3-4231-8fc6-dfca91648c82"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["consolidate format", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.630582017873025*^9, 3.6305820184552593`*^9}, {
  3.6305822010036707`*^9, 3.630582203983336*^9}, {3.630582550243239*^9, 
  3.6305825575036182`*^9}, {3.630583823688793*^9, 3.6305838257908773`*^9}, {
  3.630584709124983*^9, 
  3.630584711627997*^9}},ExpressionUUID->"a5630dc6-ad5c-4fb7-9512-\
fd0ba7706a06"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], ":=", 
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "op"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502076184078609*^9, 3.5020762093098297`*^9}},
 CellLabel->
  "In[1571]:=",ExpressionUUID->"8b8bce6e-6292-4d82-8bf1-c216d19d5d8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{
     RowBox[{"spin", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", 
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{
     RowBox[{"{", "spin", "}"}], ",", "op"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502076243462682*^9, 3.5020762644297323`*^9}},
 CellLabel->
  "In[1572]:=",ExpressionUUID->"4305ccad-29a6-4485-b7b0-e5ea1514db7c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalspins", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"CoherenceOrder", "::", "invalspins"}], ",", "invalspins"}],
          "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"invalspins", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{"spins", ",", 
           RowBox[{"First", "/@", 
            RowBox[{"SpinSystem", "[", "]"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"invalspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50207687085999*^9, 3.502076922882938*^9}, {
  3.5304655773202953`*^9, 3.530465583508635*^9}, {3.6305822830536757`*^9, 
  3.630582431020896*^9}, {3.630582805995248*^9, 3.630582809654026*^9}},
 CellLabel->
  "In[1573]:=",ExpressionUUID->"d65747af-a12a-49b6-9391-f377c837a2d3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalspins", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"CoherenceOrder", "::", "invalspins"}], ",", "invalspins"}],
          "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"invalspins", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"Union", "@@", "spinsets"}], ",", 
           RowBox[{"First", "/@", 
            RowBox[{"SpinSystem", "[", "]"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"invalspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50207687085999*^9, 3.502076922882938*^9}, {
  3.5304655773202953`*^9, 3.530465583508635*^9}, {3.6305822830536757`*^9, 
  3.630582431020896*^9}, {3.630582805995248*^9, 3.630582809654026*^9}, {
  3.630583763214027*^9, 3.63058378843981*^9}},
 CellLabel->
  "In[1574]:=",ExpressionUUID->"81229648-0643-48ba-822f-24269df6f3a2"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle list of spins, or multiple lists of spins", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.630582017873025*^9, 3.6305820184552593`*^9}, {
  3.6305822010036707`*^9, 3.630582203983336*^9}, {3.630582550243239*^9, 
  3.6305825575036182`*^9}, {3.630583823688793*^9, 
  3.630583844782449*^9}},ExpressionUUID->"8b3790cc-814b-43dc-9343-\
393f080c7bab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", 
    RowBox[{"spins_List", ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "matrep", ",", "nonzpos", ",", "Mvals", ",", "pvals", ",", "zbasis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", "zbasis"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nonzpos", "=", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"Chop", "@", 
           RowBox[{"N", "@", 
            RowBox[{"Normal", "@", "matrep"}]}]}], ",", 
          RowBox[{"Except", "[", "0", "]"}], ",", 
          RowBox[{"{", "2", "}"}], ",", 
          RowBox[{"Heads", "\[Rule]", "False"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Mvals", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MagneticQuantumNumber", "[", 
           RowBox[{"#", ",", "spins"}], "]"}], "&"}], "/@", 
         RowBox[{"BasisKets", "[", "zbasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pvals", "=", 
        RowBox[{"Union", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Mvals", "\[LeftDoubleBracket]", 
              RowBox[{"First", "[", "#", "]"}], "\[RightDoubleBracket]"}], 
             "-", 
             RowBox[{"Mvals", "\[LeftDoubleBracket]", 
              RowBox[{"Last", "[", "#", "]"}], "\[RightDoubleBracket]"}]}], 
            ")"}], "&"}], "/@", "nonzpos"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"spins", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Except", "[", "List", "]"}], ".."}], "}"}]}], "]"}], "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Length", "[", "pvals", "]"}], "\[Equal]", "1"}], ")"}]}],
          ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"First", "[", "pvals", "]"}], ",", "\[IndentingNewLine]", 
         "True", ",", "\[IndentingNewLine]", "\t", "pvals"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020753018746443`*^9, 3.5020754836833887`*^9}, {
   3.502076266868636*^9, 3.502076269665908*^9}, {3.502076588258809*^9, 
   3.502076631689501*^9}, {3.502077002407042*^9, 3.502077016753995*^9}, {
   3.502158032055262*^9, 3.502158054074847*^9}, {3.5695243451248207`*^9, 
   3.5695243511073217`*^9}, {3.569524394085362*^9, 3.569524396414955*^9}, 
   3.630582602873966*^9, {3.630583853188426*^9, 3.630583981722268*^9}, {
   3.630584040715686*^9, 3.6305840757478857`*^9}, {3.63058413653296*^9, 
   3.630584235429957*^9}, {3.630584274780004*^9, 3.6305842773489647`*^9}, {
   3.630584572743091*^9, 3.630584575661831*^9}, {3.674817900275506*^9, 
   3.6748179202908363`*^9}},
 CellLabel->
  "In[1575]:=",ExpressionUUID->"fb3700c1-e027-4dab-93b1-a1a8a5fa0b74"]
}, Closed]],

Cell[CellGroupData[{

Cell["indeterminate result", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.630582017873025*^9, 3.6305820184552593`*^9}, {
  3.6305822010036707`*^9, 3.630582203983336*^9}, {3.630582550243239*^9, 
  3.6305825709655237`*^9}, {3.630582652443338*^9, 
  3.630582655368773*^9}},ExpressionUUID->"ace6ddf4-380f-4317-986b-\
5aaecdba4def"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "[", "___", "]"}], ":=", "Indeterminate"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468165715385852*^9, 3.468165721521245*^9}},
 CellLabel->
  "In[1576]:=",ExpressionUUID->"d3bab8c5-db72-48e4-b524-3cf539efa213"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.630582017873025*^9, 3.6305820184552593`*^9}, {
  3.6305822010036707`*^9, 
  3.630582232151135*^9}},ExpressionUUID->"627de39a-072f-4df8-becf-\
46eacde7ba52"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrder", "::", "invalspins"}], "=", 
   "\"\<Spins `1` are not in the current spin system.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.630582237031275*^9, 3.630582256396531*^9}, {
  3.630582402550928*^9, 3.630582408268423*^9}},
 CellLabel->
  "In[1577]:=",ExpressionUUID->"2daadf0b-6fbe-44b1-90b3-97a113c16804"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinProductRank", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.468164621609147*^9},ExpressionUUID->"287a3dc6-de43-4fc3-861f-\
6b03115543b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "[", 
    RowBox[{"UnityOperator", "[", "___", "]"}], "]"}], "=", "0"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430624155759776*^9, {3.430624420942111*^9, 3.430624422622768*^9}, 
   3.431096429857432*^9, {3.4681648858258677`*^9, 3.468164888761169*^9}, 
   3.486464870387121*^9},
 CellLabel->
  "In[1578]:=",ExpressionUUID->"0afacb54-efcc-4928-ad5f-2bade1cca75d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", "___", "]"}]}], "]"}], ":=", "1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468165285552507*^9, 3.468165293903864*^9}, {
  3.468165454500239*^9, 3.468165456841514*^9}},
 CellLabel->
  "In[1579]:=",ExpressionUUID->"b2be5f14-9ed9-48cc-b37d-7c9bbcd84a55"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinProductRank", "[", 
   RowBox[{"op", ":", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorProduct", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"opI", "[", "___", "]"}], "|", 
          RowBox[{"UnityOperator", "[", "___", "]"}]}], ")"}], ".."}], ",", 
       "___Rule"}], "]"}]}]}], "]"}], ":=", 
  RowBox[{"Count", "[", 
   RowBox[{"op", ",", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"opI", "[", "___", "]"}]}], ",", "2"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430623726013825*^9, 3.4306237481807737`*^9}, {
   3.430624434774506*^9, 3.430624436965776*^9}, {3.43109643641107*^9, 
   3.431096438474723*^9}, {3.468164893412301*^9, 3.468164921179325*^9}, {
   3.468165092975376*^9, 3.468165099676835*^9}, 3.4864648744547977`*^9, {
   3.5029494272604523`*^9, 3.5029494297618093`*^9}, 3.653576328956416*^9, {
   3.653578408260207*^9, 3.653578410467936*^9}},
 CellLabel->
  "In[1580]:=",ExpressionUUID->"d8247d2b-4dbe-4d63-9987-3062dfe22944"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "[", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], ",", "ops__"}], "]"}],
     "]"}], ":=", 
   RowBox[{"SpinProductRank", "[", "ops", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450287094130068*^9, 3.450287113206749*^9}, {
  3.46816493622121*^9, 3.468164939293079*^9}},
 CellLabel->
  "In[1581]:=",ExpressionUUID->"cf6fec06-d847-4516-ba29-3682b5c03358"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "[", 
    RowBox[{"Times", "[", 
     RowBox[{"ops__", ",", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}], "]"}], "]"}], ":=", 
   
   RowBox[{"SpinProductRank", "[", "ops", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450287094130068*^9, 3.45028714101527*^9}, {
  3.468164941541746*^9, 3.468164943181649*^9}},
 CellLabel->
  "In[1582]:=",ExpressionUUID->"03775031-7471-42cd-a6b1-70e27c793e12"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinProductRank", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Plus", "[", "ops___", "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "ranks", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ranks", "=", 
        RowBox[{"SpinProductRank", "/@", 
         RowBox[{"{", "ops", "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ranks", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"(", "p_", ")"}], ".."}], "}"}]}], "]"}], ",", 
         RowBox[{"First", "@", "ranks"}], ",", "Indeterminate"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4561644248848743`*^9, {3.46816495918442*^9, 3.4681649964079113`*^9}},
 CellLabel->
  "In[1583]:=",ExpressionUUID->"3890832f-3322-43c8-81ae-8dba131ba1b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinProductRank", "[", "___", "]"}], ":=", 
  "Indeterminate"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46816500681625*^9, 3.468165011582945*^9}},
 CellLabel->
  "In[1584]:=",ExpressionUUID->"d5184964-de00-469d-8f6b-0540800d9724"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorTrace", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4309345971014214`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"72aff6d8-568d-4bd5-a8bc-2cc00af92072"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"352453c4-9034-4611-a246-e34ff318cd96"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"7232c035-1164-47ed-8846-b45702ec7f7e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrace", "[", 
    RowBox[{"$Failed", ",", "___"}], "]"}], ":=", "$Failed"}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4309346000159607`*^9},
 CellLabel->
  "In[1585]:=",ExpressionUUID->"5927491f-bd49-4a0d-bb77-298e98ca323c"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including trap for unknown basis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"15ef8ef3-af8b-42d8-a8b0-e11cc381fd05"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrace", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"OperatorTrace", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934604567534*^9, 3.430934606353218*^9}, 
   3.4561628824517183`*^9},
 CellLabel->
  "In[1586]:=",ExpressionUUID->"11117a04-a151-4376-82f0-e8b469b79444"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorTrace", "[", 
     RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, {3.4483554535025663`*^9, 
   3.44835545691912*^9}, 3.448355832793025*^9, 3.449234673297071*^9, 
   3.456162363062896*^9, 3.45616442959832*^9, 3.5470252125678587`*^9, 
   3.547228617589218*^9},
 CellLabel->
  "In[1587]:=",ExpressionUUID->"bb9314bc-9f49-413e-ad72-962f81bd768c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrace", "[", 
    RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorTrace", "[", 
      RowBox[{"op", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355565082233*^9, 3.448355569143277*^9}, {
   3.4483563131008673`*^9, 3.448356319849319*^9}, 3.4483570255919523`*^9, {
   3.4492346877629223`*^9, 3.449234693323227*^9}, 3.456162363812964*^9, 
   3.547025213455586*^9},
 CellLabel->
  "In[1588]:=",ExpressionUUID->"5d412982-cfc6-43c7-8f68-1c02eb5acaee"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of sums", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"07a166b1-bf1b-4423-9efd-5a9c4bb29792"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"OperatorTrace", "[", 
    RowBox[{
     RowBox[{"Plus", "[", "ops___", "]"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Map", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"OperatorTrace", "[", 
      RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Plus", "[", "ops", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309346166573553`*^9, 3.430934620968994*^9}, {
  3.4572690088422813`*^9, 3.457269030814022*^9}, {3.457269389994355*^9, 
  3.4572693920218*^9}, {3.457272045410842*^9, 3.457272062182747*^9}},
 CellLabel->
  "In[1589]:=",ExpressionUUID->"e42ce3cb-2f05-4d77-a0e5-a028a5f5041d"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numerical factors", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"3b824620-d77f-44ea-8c3f-0c51513ebdf9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorTrace", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", 
        RowBox[{"num", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}]}], "]"}], ",", 
      "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num", ",", 
     RowBox[{"OperatorTrace", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934627744981*^9, 3.4309346292734756`*^9}, {
  3.450287261991955*^9, 3.450287272895875*^9}, {3.450288087203948*^9, 
  3.450288102847741*^9}, {3.450288566766692*^9, 3.4502885804856567`*^9}},
 CellLabel->
  "In[1590]:=",ExpressionUUID->"2d002509-768c-494e-b948-11197ab5a464"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorTrace", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"num", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}], ",", 
        RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num", ",", 
     RowBox[{"OperatorTrace", "[", 
      RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934630970409*^9, 3.430934632298184*^9}, 
   3.450287287490323*^9, {3.450288127593993*^9, 3.4502881362896347`*^9}, {
   3.450288588766942*^9, 3.4502885927923183`*^9}},
 CellLabel->
  "In[1591]:=",ExpressionUUID->"9863a587-f246-4d03-940f-837286562fe5"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numbers", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"8003b0d3-b709-4b33-a410-5cfb375e4b63"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorTrace", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"num", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "OperatorQ"}], "]"}]}], ")"}], ",", "basis_", ",", 
    "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"num", "*", 
   RowBox[{"OperatorTrace", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4306244102313747`*^9, 3.430624410598246*^9}, 
   3.43062573684107*^9, {3.43093466387379*^9, 3.430934665544272*^9}, 
   3.450287593097205*^9, {3.4864648810768747`*^9, 3.486464883664898*^9}},
 CellLabel->
  "In[1592]:=",ExpressionUUID->"c9aba393-3408-40c0-9c7e-c81015df1e42"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoints", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"8bd85de3-de16-49c0-9bc3-5a4fc7c93155"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorTrace", "[", 
   RowBox[{
    RowBox[{"Adjoint", "[", "op_", "]"}], ",", "basis_", ",", "opts___Rule"}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"ComplexExpand", "@", 
   RowBox[{"Conjugate", "@", 
    RowBox[{"OperatorTrace", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934672681232*^9, 3.430934679296774*^9}, {
  3.6578212332671347`*^9, 3.657821234307185*^9}},
 CellLabel->
  "In[1593]:=",ExpressionUUID->"2a07d9a3-dabc-4d2b-a888-1c8748ae5ea7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exponentials", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"b1e3e1b6-511d-4150-a35f-0709ed8606ee"],

Cell["\<\
take trace of matrix representation if the operator involves an exponential. \
\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309354985913258`*^9, 
  3.430935513374749*^9}},ExpressionUUID->"cc2cba6e-1670-4c7d-9efe-\
e71e541b96f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorTrace", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"op1___", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "op_", "]"}], "|", 
         RowBox[{"Power", "[", 
          RowBox[{"E", ",", "op_"}], "]"}]}], ",", "op2___", ",", "___Rule"}],
        "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Tr", "[", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "[", 
       RowBox[{"op1", ",", 
        RowBox[{"Exp", "[", "op", "]"}], ",", "op2"}], "]"}], ",", "basis", 
      ",", "opts"}], "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430935077995646*^9, 3.430935080977302*^9}, {
  3.430935261472908*^9, 3.4309352934118958`*^9}, {3.43093532575212*^9, 
  3.430935364571073*^9}, {3.4309354153862133`*^9, 3.4309354206899433`*^9}, {
  3.4309354667056503`*^9, 3.430935486442051*^9}, {3.430935790381373*^9, 
  3.430935792968996*^9}, {3.589263141803864*^9, 3.589263153110173*^9}, {
  3.653576340400301*^9, 3.653576344980423*^9}, {3.653577897067574*^9, 
  3.653577899438188*^9}, {3.653578423181171*^9, 3.653578442706129*^9}},
 CellLabel->
  "In[1594]:=",ExpressionUUID->"16e7369f-ca72-48ea-a318-9ac147a0ba92"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculation", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 
  3.430934777473254*^9}},ExpressionUUID->"018275cb-88b2-4314-93a5-\
c306e27c9eab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrace", "[", 
    RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Tr", "[", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{"op", ",", "basis", ",", "opts"}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430894116448557*^9, 3.4308941895080547`*^9}, {
  3.435166008995514*^9, 3.435166041150243*^9}, {3.435166265362713*^9, 
  3.435166269087001*^9}, {3.4492348589555283`*^9, 3.449234863141408*^9}, {
  3.449296677767466*^9, 3.449296678321805*^9}},
 CellLabel->
  "In[1595]:=",ExpressionUUID->"76deb6c4-ed89-4a10-81fe-c0b8ed65f193"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorNorm", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4309345971014214`*^9, {3.434525691272585*^9, 3.434525691907489*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"b7e40b49-c5e9-4955-ac71-bfd6226e9a3c"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"1a25e441-f8ed-4ffa-bfc6-c87065ab77fb"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"c8bae37f-040d-468b-b610-9bf3e28db67f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorNorm", "[", 
    RowBox[{"$Failed", ",", "___"}], "]"}], ":=", "$Failed"}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4309346000159607`*^9, 3.434525706474409*^9},
 CellLabel->
  "In[1596]:=",ExpressionUUID->"c797102f-51ee-4451-bc9b-e871d5c75720"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including trap for unknown basis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"36776456-58fa-458f-9cfe-ea9c6047f91d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorNorm", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"OperatorNorm", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934604567534*^9, 3.430934606353218*^9}, {
   3.4492347349721813`*^9, 3.449234735860375*^9}, 3.4561628832055492`*^9},
 CellLabel->
  "In[1597]:=",ExpressionUUID->"a2b40f80-0df8-4205-894b-8dcd583d6565"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorNorm", "[", 
     RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, {3.4483554535025663`*^9, 
   3.44835545691912*^9}, 3.448355832793025*^9, 3.449234673297071*^9, 
   3.449234737316523*^9, 3.456162364717552*^9, 3.456164435897998*^9, 
   3.547025214312825*^9, 3.547228618542598*^9},
 CellLabel->
  "In[1598]:=",ExpressionUUID->"2ca8b11e-9975-4c1d-9fdb-a163d4bdad44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorNorm", "[", 
    RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorNorm", "[", 
      RowBox[{"op", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355565082233*^9, 3.448355569143277*^9}, {
   3.4483563131008673`*^9, 3.448356319849319*^9}, 3.4483570255919523`*^9, {
   3.4492346877629223`*^9, 3.449234693323227*^9}, {3.449234739038102*^9, 
   3.44923474019773*^9}, 3.4561623655358353`*^9, 3.5470252151712637`*^9},
 CellLabel->
  "In[1599]:=",ExpressionUUID->"06fd8dc8-3992-4695-b08d-cbddd29f9c01"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculation", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 
  3.430934777473254*^9}},ExpressionUUID->"5c81ce49-dd07-4b84-8f76-\
16ff1945bffe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorNorm", "[", 
    RowBox[{"op_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Simplify", "@", 
    RowBox[{"Norm", "[", 
     RowBox[{"Flatten", "@", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430894116448557*^9, 3.4308941895080547`*^9}, {
  3.4345257489869623`*^9, 3.4345257726375027`*^9}, {3.434526702757102*^9, 
  3.434526705490097*^9}, {3.4345324452908916`*^9, 3.4345324635528173`*^9}, {
  3.434538886514656*^9, 3.434538894677602*^9}, {3.435255296345886*^9, 
  3.435255348458941*^9}, {3.43529760342517*^9, 3.4352976463479557`*^9}, {
  3.50207400841538*^9, 3.502074039227703*^9}, {3.50232302151635*^9, 
  3.502323023322983*^9}},
 CellLabel->
  "In[1600]:=",ExpressionUUID->"79c491cf-4e15-4822-b895-923db893a723"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizeOperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4309345971014214`*^9, {3.434525691272585*^9, 3.434525691907489*^9}, {
   3.4473433197389593`*^9, 3.447343322592136*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ff5d0f06-3d02-4957-b227-dbfd429958b5"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"471c53b9-3544-410f-a713-3114a53101a8"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"308cf48c-2e40-497e-8a66-8bbe6446a5ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"$Failed", ",", "___"}], "]"}], ":=", "$Failed"}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4309346000159607`*^9, 3.434525706474409*^9, 
  3.447343335182396*^9},
 CellLabel->
  "In[1601]:=",ExpressionUUID->"120e45cc-2cf9-453a-901d-3973daeaa24b"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle missing normalization constant", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.632851474125276*^9, 3.6328514814803457`*^9}, {
  3.632851575115148*^9, 
  3.632851579741653*^9}},ExpressionUUID->"c21405f6-673f-49cd-b58e-\
ef9186e24906"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op", ",", "1", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6328511964814253`*^9, 3.632851215505845*^9}},
 CellLabel->
  "In[1602]:=",ExpressionUUID->"bd168369-5fb3-44bb-8000-7b30a45d637d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op_", ",", 
     RowBox[{"basis", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", 
         RowBox[{"_", "?", "OperatorQ"}]}], ")"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op", ",", "1", ",", "basis", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6328511964814253`*^9, 3.632851215505845*^9}, {
  3.632851405093947*^9, 3.632851424395698*^9}},
 CellLabel->
  "In[1603]:=",ExpressionUUID->"fcb3e886-cd87-4ffe-99f1-95e5dd744cc2"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including trap for unknown basis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"6abea261-7db1-4fa1-a8ef-b608b437fd63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op_", ",", 
     RowBox[{"norm", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", 
        RowBox[{"_", "?", "OperatorQ"}]}], ")"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op", ",", "norm", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430934604567534*^9, 3.430934606353218*^9}, {
   3.4345257140359783`*^9, 3.434525715489937*^9}, {3.447343339631858*^9, 
   3.447343342135014*^9}, 3.45616288393046*^9, {3.6328507915428133`*^9, 
   3.632850832636855*^9}, {3.632851151869484*^9, 3.63285115565164*^9}, {
   3.632851226731501*^9, 3.632851230687498*^9}},
 CellLabel->
  "In[1604]:=",ExpressionUUID->"59fc16a2-f210-45c3-ae4b-d509de3bb1de"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NormalizeOperator", "[", 
     RowBox[{"op_", ",", 
      RowBox[{"norm", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], "|", 
         RowBox[{"_", "?", "OperatorQ"}]}], ")"}]}], ",", "Undefined", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, {3.4483554535025663`*^9, 
   3.44835545691912*^9}, 3.448355832793025*^9, 3.449234673297071*^9, 
   3.449234737316523*^9, 3.449234770830921*^9, 3.4561623663672533`*^9, 
   3.456164440826911*^9, 3.5470252160233383`*^9, 3.5472286196371317`*^9, {
   3.632850861358856*^9, 3.6328508635242977`*^9}, {3.63285124974771*^9, 
   3.6328512503172483`*^9}},
 CellLabel->
  "In[1605]:=",ExpressionUUID->"f488ea0f-5820-4f55-b132-17ee7e329b2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op_", ",", 
     RowBox[{"norm", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", 
        RowBox[{"_", "?", "OperatorQ"}]}], ")"}]}], ",", "Undefined", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"NormalizeOperator", "[", 
      RowBox[{"op", ",", "norm", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355565082233*^9, 3.448355569143277*^9}, {
   3.4483563131008673`*^9, 3.448356319849319*^9}, 3.4483570255919523`*^9, {
   3.4492346877629223`*^9, 3.449234693323227*^9}, {3.449234739038102*^9, 
   3.44923474019773*^9}, {3.449234773175702*^9, 3.449234774703637*^9}, 
   3.4561623671462173`*^9, 3.5470252169070873`*^9, {3.632850883362134*^9, 
   3.632850896802455*^9}, {3.632851268968701*^9, 3.632851271736631*^9}},
 CellLabel->
  "In[1606]:=",ExpressionUUID->"7e17de50-417e-408f-ab86-be1217b8b0b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["normalize a list of operators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.632850918162068*^9, 3.632850926951736*^9}, {
  3.6328510410475187`*^9, 
  3.632851047228566*^9}},ExpressionUUID->"d0e5f146-200d-4d4c-97a3-\
593bcde269e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NormalizeOperator", "[", 
   RowBox[{"ops_List", ",", "norm_", ",", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"NormalizeOperator", "[", 
     RowBox[{"#", ",", "norm", ",", "basis", ",", "opts"}], "]"}], "&"}], "/@",
    "ops"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447343385484488*^9, 3.447343427315632*^9}, {
   3.632851012946959*^9, 3.632851024896228*^9}, 3.632851057444499*^9},
 CellLabel->
  "In[1607]:=",ExpressionUUID->"96e0e639-8249-4815-a6a0-93cac9e4c56f"]
}, Closed]],

Cell[CellGroupData[{

Cell["specify norm as an operator", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.632850918162068*^9, 3.632850926951736*^9}, {
  3.63285149609203*^9, 
  3.632851496296714*^9}},ExpressionUUID->"31b89cc6-e4e1-4b20-90f7-\
cdb5a3c301af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op1_", ",", 
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"OperatorNorm", "[", 
      RowBox[{"op2", ",", "basis"}], "]"}], ",", "basis", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.632850935875434*^9, 3.6328510066471853`*^9}, {
  3.6328515009607143`*^9, 3.6328515042852583`*^9}},
 CellLabel->
  "In[1608]:=",ExpressionUUID->"983e2ae9-7bfd-4ff9-bbc4-8451801481f7"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculation", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 
  3.430934777473254*^9}},ExpressionUUID->"090fbddc-c3bd-4ae2-aad0-\
325151318a95"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizeOperator", "[", 
    RowBox[{"op_", ",", 
     RowBox[{"norm_", "?", "NumericQ"}], ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", 
    RowBox[{"norm", "*", 
     RowBox[{"op", "/", 
      RowBox[{"OperatorNorm", "[", 
       RowBox[{"op", ",", "basis", ",", "opts"}], "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430894116448557*^9, 3.4308941895080547`*^9}, {
   3.4345257489869623`*^9, 3.4345257726375027`*^9}, {3.434526702757102*^9, 
   3.434526705490097*^9}, {3.4345324452908916`*^9, 3.4345324635528173`*^9}, {
   3.434538886514656*^9, 3.434538894677602*^9}, {3.435255296345886*^9, 
   3.435255348458941*^9}, {3.43529760342517*^9, 3.4352976463479557`*^9}, {
   3.4473433538900003`*^9, 3.447343378226942*^9}, 3.4473434448311577`*^9, {
   3.5020740539814*^9, 3.502074056338345*^9}, {3.502322995141645*^9, 
   3.5023229996828213`*^9}, {3.5023273559198093`*^9, 3.502327360269156*^9}, {
   3.632851083188777*^9, 3.632851099740534*^9}},
 CellLabel->
  "In[1609]:=",ExpressionUUID->"e34adf1d-e83b-4835-9aa6-f9b0407e9f9f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalTensorIndices", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.468164621609147*^9, 
  3.639289894726838*^9},ExpressionUUID->"3f75bc36-ff31-457c-abc2-\
14383404548c"],

Cell["coding is deferred to QM`Liouville", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639290007515585*^9, 3.639290022712317*^9}, {
  3.682608871731956*^9, 3.6826088768062553`*^9}, {3.6826093049953136`*^9, 
  3.682609306978828*^9}},ExpressionUUID->"92b7c289-0a61-44dd-b1d3-\
8062237183c3"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"b72e8530-e5cc-46f2-a2a6-4d4d204203b6"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 CellLabel->
  "In[1610]:=",ExpressionUUID->"f2ef6fbb-66d8-4bab-abbe-7b6e79ced98b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"5abe5007-3a88-4a79-8ede-19a85d70d475"],

Cell[CellGroupData[{

Cell["170323 changes incorporated into v3.0.0b9", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 
   3.699267264970158*^9}},ExpressionUUID->"ab8cdb57-fa69-45ee-9e14-\
43b68e633238"],

Cell["\<\
MHL: minor changes to Operator (debugging of 170323-MHL-300b9-Operator)\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 
  3.6992675263453903`*^9}},ExpressionUUID->"aa022b01-215c-4300-bf0f-\
14db0ff11b55"],

Cell["MHL: significant changes to opI ", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699278756259956*^9, 
  3.699278768364066*^9}},ExpressionUUID->"676c2392-ab7f-4016-a61e-\
32755dce377f"],

Cell["MHL: minor bug fix in OperatorProduct ", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699278756259956*^9, 
  3.699278787512001*^9}},ExpressionUUID->"32611b51-bb4a-4f88-be96-\
5260114a7421"]
}, Open  ]],

Cell[CellGroupData[{

Cell["170323 changes incorporated into v3.0.0b16 [CB]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.7092914569364176`*^9, 
   3.7092914602989526`*^9}},ExpressionUUID->"313f94f6-47ba-4111-aae6-\
ec56e68f54f4"],

Cell["\<\
Adjusted the pattern for numerical scaling of an operator object in case the \
operator is diagonalized. (highlighted in green) Now only the eigenvalues are \
scaled by the numerical factor, not the eigenvectors.\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.709291466201131*^9, 
  3.709291510995338*^9}},ExpressionUUID->"1f505d67-2809-4640-a5b8-\
f4db70f8c743"]
}, Open  ]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 715},
WindowMargins->{{73, Automatic}, {Automatic, 26}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 296, 8, 114, "Title",ExpressionUUID->"35918fb3-53f5-4673-b85b-9465181d60f4",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[888, 34, 341, 8, 57, "Subsubtitle",ExpressionUUID->"814aaab9-20fa-4186-9406-3f42165dcea1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1232, 44, 1148, 23, 278, "Input",ExpressionUUID->"def87971-b0be-445d-9248-dc009f90651e",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2417, 72, 214, 6, 41, "Subsubtitle",ExpressionUUID->"e20fac8b-45b8-4c30-ae0e-338baa4107e9",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2656, 82, 166, 4, 36, "Section",ExpressionUUID->"e4fc0a99-1811-439f-9bdf-ff35bde29ca2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2847, 90, 306, 8, 54, "Subsection",ExpressionUUID->"23709340-de4b-4255-9074-80c6867acad5",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[3156, 100, 1661, 28, 341, "Input",ExpressionUUID->"699b49e2-e574-4801-b936-9c2047f11f8f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[4820, 130, 428, 10, 89, "Input",ExpressionUUID->"074c0de3-665b-47d6-96d7-4e0b28b2cdb5",
 InitializationCell->True],
Cell[5251, 142, 514, 11, 89, "Input",ExpressionUUID->"30f4e25b-d150-407d-a7ca-e54082efa33f",
 InitializationCell->True],
Cell[5768, 155, 815, 17, 173, "Input",ExpressionUUID->"7725e92f-e474-4cfd-a064-796e0962ccb3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6620, 177, 281, 7, 54, "Subsection",ExpressionUUID->"67f1db72-f5f2-407a-9954-08c1024339ba",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[6904, 186, 411, 11, 68, "Input",ExpressionUUID->"3cb89199-6197-49d7-8f13-7c0a0b2a2061",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7352, 202, 310, 8, 54, "Subsection",ExpressionUUID->"cd57c1b7-ffe7-4f6a-971b-656524423325",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7665, 212, 462, 11, 68, "Input",ExpressionUUID->"f7841be7-b409-4904-acc9-e1866f9180cf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8164, 228, 300, 7, 54, "Subsection",ExpressionUUID->"9e1f5069-0c99-4da2-b40f-a24ded533a08",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8467, 237, 1462, 26, 362, "Input",ExpressionUUID->"baaf64bc-9f63-4b2f-8ca8-ca7a98ce9131",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9932, 265, 352, 8, 46, "Input",ExpressionUUID->"3af0992c-f277-47e2-ae41-7774d8bafd3b",
 InitializationCell->True],
Cell[10287, 275, 445, 10, 89, "Input",ExpressionUUID->"2b0c1fef-4aff-4cc5-b48b-b1cee158281a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10769, 290, 298, 7, 54, "Subsection",ExpressionUUID->"48d67343-8d3c-4d7d-a1ba-34d5c484c586",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[11070, 299, 999, 18, 215, "Input",ExpressionUUID->"c82cfac0-77b9-44a2-b88b-8415b520dfc9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12106, 322, 236, 6, 54, "Subsection",ExpressionUUID->"e46c6dc1-a579-4e12-a085-0386966f0032",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[12345, 330, 2129, 34, 496, "Input",ExpressionUUID->"49276133-44e4-4b92-8b58-0b8e992f34ff",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14511, 369, 293, 7, 54, "Subsection",ExpressionUUID->"720343fe-3731-407e-8604-b5cab3e87b91",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14807, 378, 1247, 22, 278, "Input",ExpressionUUID->"45044f4c-cf17-4ee1-adb0-54dc3550fafc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[16057, 402, 338, 8, 46, "Input",ExpressionUUID->"1500053c-3a33-4c45-9cff-519b4f4e5e13",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16432, 415, 311, 8, 54, "Subsection",ExpressionUUID->"4191c192-aa58-47c8-953c-0c8249850588",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[16746, 425, 818, 15, 173, "Input",ExpressionUUID->"9282779e-9d48-4efb-9020-3c314af413ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17601, 445, 286, 7, 54, "Subsection",ExpressionUUID->"575dda38-c7d5-43a8-aedb-ed1cbf20f95c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17890, 454, 336, 8, 46, "Input",ExpressionUUID->"aa816bc1-3072-48e2-8668-98c6d6958bc0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[18263, 467, 240, 6, 54, "Subsection",ExpressionUUID->"f482c4c4-788d-46b4-9f9c-287e1021767a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[18506, 475, 616, 14, 110, "Input",ExpressionUUID->"45402709-eda3-4105-90fb-4c53f6c95d44",
 InitializationCell->True,
 InitializationGroup->True],
Cell[19125, 491, 639, 14, 131, "Input",ExpressionUUID->"6ffdee6b-2b48-43f1-b7c7-ac5c061ed028",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19801, 510, 302, 7, 54, "Subsection",ExpressionUUID->"f08d223b-9a99-4c5b-b1b1-9f358d369dec",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[20106, 519, 980, 19, 173, "Input",ExpressionUUID->"48153dc3-7d63-4213-af8e-0d280901297d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[21089, 540, 807, 16, 89, "Input",ExpressionUUID->"02b7ba59-56fb-4aed-9197-cbedd0a674f6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21933, 561, 424, 9, 54, "Subsection",ExpressionUUID->"dac7b2f3-410d-417f-a8c7-870f8a8f89be",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[22360, 572, 1394, 25, 194, "Input",ExpressionUUID->"0348e61f-bac5-4e03-99f6-ef5aa13f88ac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[23757, 599, 942, 18, 68, "Input",ExpressionUUID->"9ed2b616-477d-4d2e-8dde-ec56a1c22773",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[24748, 623, 272, 7, 36, "Section",ExpressionUUID->"facbabbd-60bf-45ca-9c54-d00218d9212d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[25045, 634, 226, 6, 54, "Subsection",ExpressionUUID->"43f13a14-b0c4-402c-9ef0-de0da29661a3",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[25274, 642, 593, 12, 131, "Input",ExpressionUUID->"adff62fa-d06a-4bad-a845-d1541f7667ff",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25904, 659, 235, 6, 54, "Subsection",ExpressionUUID->"eea239a0-254b-487f-b7bb-feee03c1d6d5",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[26142, 667, 669, 15, 131, "Input",ExpressionUUID->"a03f5a3c-f2aa-4271-b31d-3eac781af7d4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[26848, 687, 224, 6, 54, "Subsection",ExpressionUUID->"18eaef38-184b-41c9-b14e-84f3e56c61c3",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[27075, 695, 533, 12, 89, "Input",ExpressionUUID->"f7cb485e-7da2-44e1-a776-75ad3e3aa058",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[27657, 713, 179, 4, 36, "Section",ExpressionUUID->"17e0134e-3f74-41d4-bf4e-455ea361a6fa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[27861, 721, 216, 6, 54, "Subsection",ExpressionUUID->"69845155-786e-47fd-85ff-5cbc3c584dd9",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[28080, 729, 475, 12, 68, "Input",ExpressionUUID->"dbde64ae-716d-43d9-9d51-5adb6c6e9ba2",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28592, 746, 220, 6, 54, "Subsection",ExpressionUUID->"fc361c54-0656-4f52-babd-8224566ef320",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[28815, 754, 866, 17, 194, "Input",ExpressionUUID->"428669d4-4265-4949-badf-d9f870448d33",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29718, 776, 263, 7, 54, "Subsection",ExpressionUUID->"4c0ce378-fc8d-4238-b6d1-d7540fc4bc0f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29984, 785, 735, 15, 91, "Input",ExpressionUUID->"9ed9ef87-5fe8-4e47-85f2-a9b69f9b3c9f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[30756, 805, 287, 7, 54, "Subsection",ExpressionUUID->"439ef769-d305-4f58-bf48-cefc2d7909f0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[31046, 814, 544, 13, 68, "Input",ExpressionUUID->"28b04e27-0822-45b5-99b9-9f3d660823e6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31627, 832, 337, 8, 54, "Subsection",ExpressionUUID->"0e67ad03-e7a9-444e-8458-7d36cc7126a1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[31967, 842, 704, 15, 110, "Input",ExpressionUUID->"9b80f9a8-e500-48fc-9d22-a9c5ee89e0a1",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32708, 862, 391, 9, 54, "Subsection",ExpressionUUID->"8670d831-d495-4b5d-a505-28e964782933",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[33102, 873, 979, 19, 194, "Input",ExpressionUUID->"d5b6c907-6881-4e58-a699-24840b53d6ba",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34118, 897, 489, 10, 54, "Subsection",ExpressionUUID->"9e532f2d-79e2-42ac-ab85-e84c3650e554",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[34610, 909, 827, 16, 131, "Input",ExpressionUUID->"7dae8103-7d44-4ed8-b053-020376bf5156",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35474, 930, 537, 11, 54, "Subsection",ExpressionUUID->"39623be0-b292-497f-8aaf-588858da3f74",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[36014, 943, 781, 16, 68, "Input",ExpressionUUID->"6d430fbf-ca3e-4523-b970-dd707caeb9a7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36832, 964, 592, 11, 54, "Subsection",ExpressionUUID->"ed34b9df-269b-4cba-a3d8-f76b8b90b163",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[37427, 977, 1089, 20, 215, "Input",ExpressionUUID->"5a242f1f-7dd9-401f-8002-e7c921f127a6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[38577, 1004, 212, 6, 41, "Subsubtitle",ExpressionUUID->"8a8ad9fb-d56e-431b-9ea6-d9eceb7ec3cb",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[38792, 1012, 227, 6, 46, "Input",ExpressionUUID->"e5af9493-e0ff-4c8e-aaeb-8744657b5f8f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39056, 1023, 492, 10, 57, "Subsubtitle",ExpressionUUID->"e5e9e1ee-1826-445e-b19c-3b86fb8fd832",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[39573, 1037, 476, 9, 61, "Subsubsection",ExpressionUUID->"5ae829b1-b574-498f-8be1-8340f10973d2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[40052, 1048, 882, 18, 46, "Input",ExpressionUUID->"343192b4-5884-480d-83f1-999c1b289610",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[40959, 1070, 867, 17, 89, "Input",ExpressionUUID->"1fb6ee23-ba8e-4d5f-a91e-a31a79e65d9b",
 InitializationCell->True],
Cell[41829, 1089, 208, 4, 34, "Output",ExpressionUUID->"845475fb-9dc1-4c53-a51e-617173946eac"]
}, Closed]],
Cell[CellGroupData[{
Cell[42074, 1098, 792, 17, 85, "Input",ExpressionUUID->"1fb6ee23-ba8e-4d5f-a91e-a31a79e65d9b",
 InitializationCell->True],
Cell[42869, 1117, 211, 4, 34, "Output",ExpressionUUID->"77d47832-e05b-454a-963f-71254cbffa1d"]
}, Closed]],
Cell[CellGroupData[{
Cell[43117, 1126, 857, 20, 106, "Input",ExpressionUUID->"d7a44c4f-dac6-4038-b33c-0e1ffdc2ba60",
 InitializationCell->True],
Cell[43977, 1148, 209, 4, 34, "Output",ExpressionUUID->"1d0253cc-a1f6-41dc-8db0-8231a8c92ebd"]
}, Closed]],
Cell[44201, 1155, 1013, 23, 106, "Input",ExpressionUUID->"6fef2db3-5132-4dc0-989c-3ea72bcf9390",
 InitializationCell->True],
Cell[45217, 1180, 1038, 23, 110, "Input",ExpressionUUID->"c110d304-3ccb-40ee-8290-e5f5b0cef1fe",
 InitializationCell->True],
Cell[46258, 1205, 1511, 34, 194, "Input",ExpressionUUID->"aad4dd4a-bcdf-4a9c-a4e0-e46b355579b5",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[47806, 1244, 477, 9, 61, "Subsubsection",ExpressionUUID->"840be988-b4be-48bc-b720-3c69c569ef4b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[48286, 1255, 203, 4, 35, "Text",ExpressionUUID->"72fabf25-8728-441e-b5d3-d8e6b0503f19",
 InitializationCell->True],
Cell[48492, 1261, 665, 17, 68, "Input",ExpressionUUID->"e50c1f9f-4e0f-4346-b743-4ad998d3bff1",
 InitializationCell->True],
Cell[49160, 1280, 673, 18, 68, "Input",ExpressionUUID->"59628c42-532c-4cb5-9095-20e940f4baf8",
 InitializationCell->True],
Cell[49836, 1300, 902, 21, 110, "Input",ExpressionUUID->"3cc79ce1-689d-4c4c-a9eb-2ef2182eb782",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[50775, 1326, 542, 10, 61, "Subsubsection",ExpressionUUID->"a6dd61cd-562f-453f-95c3-04f0038e6a79",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[51342, 1340, 1025, 21, 110, "Input",ExpressionUUID->"a7d0bfbd-8058-4cde-8719-592fa6d40f6d",
 InitializationCell->True],
Cell[52370, 1363, 212, 4, 34, "Output",ExpressionUUID->"379c6c66-8e2a-46ff-aa72-ac457c6d53fb"]
}, Closed]],
Cell[CellGroupData[{
Cell[52619, 1372, 997, 21, 106, "Input",ExpressionUUID->"7e19c299-68cd-4dc7-a557-4a1c4a4febe0",
 InitializationCell->True],
Cell[53619, 1395, 210, 4, 34, "Output",ExpressionUUID->"49deca9f-9113-45e3-ab79-b9c3b6d50e24"]
}, Closed]],
Cell[CellGroupData[{
Cell[53866, 1404, 996, 21, 106, "Input",ExpressionUUID->"4c611e18-4ee2-4811-bb50-244807889aae",
 InitializationCell->True],
Cell[54865, 1427, 206, 4, 34, "Output",ExpressionUUID->"8aad571b-c80a-46dc-93d3-f312c8465453"]
}, Closed]],
Cell[CellGroupData[{
Cell[55108, 1436, 1042, 21, 106, "Input",ExpressionUUID->"690e2744-2d30-46ae-b702-bcf34860729e",
 InitializationCell->True],
Cell[56153, 1459, 208, 4, 34, "Output",ExpressionUUID->"b3bdb64b-1781-4f55-9f4f-bc222d6c1c6b"]
}, Closed]],
Cell[56376, 1466, 804, 16, 85, "Input",ExpressionUUID->"a3738066-3fb3-4563-9b36-dc38a16935ab",
 InitializationCell->True],
Cell[57183, 1484, 663, 14, 89, "Input",ExpressionUUID->"f4034fb2-c113-494c-99c2-dcb65f1d3f9e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[57895, 1504, 202, 5, 57, "Subsubtitle",ExpressionUUID->"c92a8808-f963-4c4f-96a8-1a1b1e27b884",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[58122, 1513, 256, 6, 36, "Section",ExpressionUUID->"40a59d03-41fb-4993-b2bd-a8107ac9dc4a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[58403, 1523, 236, 6, 54, "Subsection",ExpressionUUID->"efb591da-509e-4af3-8259-63eeecd6101f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[58642, 1531, 508, 15, 46, "Input",ExpressionUUID->"17117afc-bfe0-4a92-9634-3b75d0465e8b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[59153, 1548, 785, 22, 68, "Input",ExpressionUUID->"33ad5e85-35e5-4e86-857c-954567f9ba71",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[59975, 1575, 313, 7, 38, "Subsection",ExpressionUUID->"e8fef239-4799-441a-86c1-c8a48686bcb7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[60313, 1586, 238, 5, 45, "Subsubsection",ExpressionUUID->"647bd12e-9b21-42c4-861b-696f07608026",
 InitializationCell->True],
Cell[60554, 1593, 939, 24, 110, "Input",ExpressionUUID->"1335996d-f2d0-452f-81d9-fc03a91852df",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[61542, 1623, 263, 5, 54, "Subsection",ExpressionUUID->"2291e2ae-0995-4f54-9a24-29edf75022e5",
 InitializationCell->True],
Cell[61808, 1630, 1522, 34, 215, "Input",ExpressionUUID->"1c00abb7-cab1-4329-8758-3e099767bc2f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[63367, 1669, 396, 6, 38, "Subsection",ExpressionUUID->"849948ea-e601-43a6-bce1-589a7ff2f7e8",
 InitializationCell->True],
Cell[63766, 1677, 805, 20, 89, "Input",ExpressionUUID->"4d83df99-7de5-4993-8e9e-847f7c116ab0",
 InitializationCell->True],
Cell[64574, 1699, 1521, 38, 152, "Input",ExpressionUUID->"31a58874-1c15-42c4-b746-e540458aa192",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[66144, 1743, 333, 8, 36, "Section",ExpressionUUID->"cc5bf175-fa96-49b8-bebd-9a432d01ab25",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[66502, 1755, 178, 3, 54, "Subsection",ExpressionUUID->"e76afe5d-86ed-4c93-9c86-7ad2c842bc6d",
 InitializationCell->True],
Cell[66683, 1760, 476, 12, 46, "Input",ExpressionUUID->"0e549c72-297f-4a3a-a4f6-af84c30d6a32",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[67184, 1776, 465, 8, 45, "Subsubsection",ExpressionUUID->"2fa06ce8-5595-45b5-9dad-c5772fc23bb9",
 InitializationCell->True],
Cell[67652, 1786, 1077, 27, 110, "Input",ExpressionUUID->"83b697b5-8942-414a-95a5-ff470f7b69a9",
 InitializationCell->True],
Cell[68732, 1815, 1158, 29, 110, "Input",ExpressionUUID->"d5f4294b-0d5a-4f76-979f-2a579efcfe3b",
 InitializationCell->True],
Cell[69893, 1846, 1156, 29, 110, "Input",ExpressionUUID->"644ab696-2b26-483d-baba-cc78d15febfe",
 InitializationCell->True],
Cell[71052, 1877, 1252, 32, 152, "Input",ExpressionUUID->"b1e94fd3-856f-4433-a986-365589563700",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[72341, 1914, 286, 5, 45, "Subsubsection",ExpressionUUID->"b08e71c6-3789-44b6-abad-0364a52a09ee",
 InitializationCell->True],
Cell[72630, 1921, 1654, 38, 131, "Input",ExpressionUUID->"11af9f01-a68f-42ce-bdbc-02d79369c4e4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[74321, 1964, 492, 8, 37, "Subsubsection",ExpressionUUID->"3718b131-165e-4010-ae9f-368d6fe8ed3c",
 InitializationCell->True],
Cell[74816, 1974, 330, 8, 46, "Input",ExpressionUUID->"26374c47-f6fd-4aa7-b7b5-2163d74ac7d3",
 InitializationCell->True],
Cell[75149, 1984, 407, 11, 46, "Input",ExpressionUUID->"a6c97a38-4a68-450d-b4a2-03d09cd05c6d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[75593, 2000, 462, 7, 37, "Subsubsection",ExpressionUUID->"5a09388b-47cc-45b6-8395-9ad0f30d8ce0",
 InitializationCell->True],
Cell[76058, 2009, 2292, 61, 194, "Input",ExpressionUUID->"d34f093f-5c17-426f-99b8-ad15fdf82cdf",
 InitializationCell->True],
Cell[78353, 2072, 1629, 42, 173, "Input",ExpressionUUID->"11651901-35e2-42e1-a454-04668cb58f09",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[80019, 2119, 479, 8, 37, "Subsubsection",ExpressionUUID->"2df68b0c-046a-43dc-ad0b-0304b5e2577c",
 InitializationCell->True],
Cell[80501, 2129, 1442, 32, 89, "Input",ExpressionUUID->"3da5dc73-1109-4d56-a7e0-32ddbcfbef73",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[81980, 2166, 376, 6, 37, "Subsubsection",ExpressionUUID->"8e1c9d04-a54f-4f78-9dda-01bb23c2a078",
 InitializationCell->True],
Cell[82359, 2174, 449, 12, 46, "Input",ExpressionUUID->"b776ec88-c145-4134-91c2-c2285336efe6",
 InitializationCell->True],
Cell[82811, 2188, 993, 24, 68, "Input",ExpressionUUID->"4ca28bc9-50d4-4366-9857-292dd9f7c001",
 InitializationCell->True],
Cell[83807, 2214, 1017, 24, 68, "Input",ExpressionUUID->"705535fe-b9e7-4582-a30f-2d592a6d2b8d",
 InitializationCell->True],
Cell[84827, 2240, 893, 22, 68, "Input",ExpressionUUID->"af2e4587-c4a6-4d63-8c7f-aa1092f73e66",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[85757, 2267, 304, 5, 37, "Subsubsection",ExpressionUUID->"f9969d92-8a73-4e5d-bba5-746891b85a71",
 InitializationCell->True],
Cell[86064, 2274, 1029, 23, 68, "Input",ExpressionUUID->"30da3a04-47f0-488f-9a2a-d0e23b0dd28d",
 InitializationCell->True],
Cell[87096, 2299, 893, 22, 68, "Input",ExpressionUUID->"86ab6424-f75d-4df8-8e4e-71c38bc8c0ab",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[88038, 2327, 462, 8, 54, "Subsection",ExpressionUUID->"ca7f95a8-1c6c-4dbc-9672-304d888c1176",
 InitializationCell->True],
Cell[88503, 2337, 1097, 33, 110, "Input",ExpressionUUID->"f77d00ad-0190-45c2-9dc2-008803d3966e",
 InitializationCell->True],
Cell[89603, 2372, 1255, 36, 131, "Input",ExpressionUUID->"cd775143-4afb-410e-965a-61d325f3c7ae",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[90895, 2413, 372, 6, 38, "Subsection",ExpressionUUID->"e845ac04-2420-4ffd-a8c3-233a710959d5",
 InitializationCell->True],
Cell[91270, 2421, 3167, 73, 446, "Input",ExpressionUUID->"87e4ec5f-b93f-447f-93d9-83a2b66c08c5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[94474, 2499, 303, 5, 38, "Subsection",ExpressionUUID->"54abde07-6883-44b7-8cd2-36fdc45ae141",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[94802, 2508, 270, 5, 45, "Subsubsection",ExpressionUUID->"3df672d2-aa45-4996-ba58-b865b3fca88b",
 InitializationCell->True],
Cell[95075, 2515, 422, 10, 46, "Input",ExpressionUUID->"b958ea90-6abe-49ff-b9f5-cfcdc5788a52",
 InitializationCell->True],
Cell[95500, 2527, 1847, 37, 152, "Input",ExpressionUUID->"e8c87a51-255e-4437-8b1e-9411e37ec859",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[97384, 2569, 341, 6, 45, "Subsubsection",ExpressionUUID->"6e0881c5-ab63-4020-ad02-3cfc11224209",
 InitializationCell->True],
Cell[97728, 2577, 1774, 37, 152, "Input",ExpressionUUID->"0511a3bc-2f4a-43a6-a07e-d22b2cb012bd",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[99539, 2619, 424, 7, 45, "Subsubsection",ExpressionUUID->"25456b50-2d16-43d9-81cf-f7d12ac54710",
 InitializationCell->True],
Cell[99966, 2628, 2016, 40, 152, "Input",ExpressionUUID->"5968530a-76c1-47a7-abf0-d28b39cef662",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[102019, 2673, 693, 10, 45, "Subsubsection",ExpressionUUID->"d9841b27-be26-433e-9258-5310a89f9d05",
 InitializationCell->True],
Cell[102715, 2685, 2303, 50, 89, "Input",ExpressionUUID->"58f0b07f-3d96-4fbb-8d50-790f42339111",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[105067, 2741, 326, 6, 38, "Subsection",ExpressionUUID->"f1f23358-35d9-41b4-84ed-c281ce628f79",
 InitializationCell->True],
Cell[105396, 2749, 343, 8, 46, "Input",ExpressionUUID->"9b4c96d7-22f0-43c4-a595-3123fdaf62dc",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[105788, 2763, 382, 9, 36, "Section",ExpressionUUID->"d68a38c1-f12b-4e2e-b733-5b0c7c5372a9",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[106195, 2776, 282, 5, 45, "Subsubsection",ExpressionUUID->"6087220d-a90b-45de-b64a-83f370633b89",
 InitializationCell->True],
Cell[106480, 2783, 1265, 27, 152, "Input",ExpressionUUID->"a0ec8247-ba30-42fc-ae78-4154039100da",
 InitializationCell->True],
Cell[107748, 2812, 703, 19, 68, "Input",ExpressionUUID->"5fd2392a-39f4-478a-b0ef-12c51bf6d24c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[108488, 2836, 312, 5, 45, "Subsubsection",ExpressionUUID->"96fd8d0c-050d-4265-8699-29868b68036d",
 InitializationCell->True],
Cell[108803, 2843, 632, 16, 46, "Input",ExpressionUUID->"0a2b571e-9ae3-4ffd-9bc4-cf952ef3eb50",
 InitializationCell->True],
Cell[109438, 2861, 551, 13, 46, "Input",ExpressionUUID->"72d0def5-cbad-409d-98fe-47ceabb84384",
 InitializationCell->True],
Cell[109992, 2876, 632, 16, 46, "Input",ExpressionUUID->"70320c00-2181-4add-bc79-edf032cd76c6",
 InitializationCell->True],
Cell[110627, 2894, 549, 13, 46, "Input",ExpressionUUID->"c4948e92-32db-471a-b737-546e4f69b5d8",
 InitializationCell->True],
Cell[111179, 2909, 479, 11, 46, "Input",ExpressionUUID->"1a4d9393-11a2-4403-9d3d-7355a9872240",
 InitializationCell->True],
Cell[111661, 2922, 476, 11, 46, "Input",ExpressionUUID->"ed3c05c2-952c-4652-96c0-8568251f998b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[112174, 2938, 351, 6, 45, "Subsubsection",ExpressionUUID->"387044c8-c082-4b6a-8274-4e5ae37cd253",
 InitializationCell->True],
Cell[112528, 2946, 400, 10, 46, "Input",ExpressionUUID->"8a7aafb1-a9a2-4e29-843a-c73d147613a8",
 InitializationCell->True],
Cell[112931, 2958, 425, 11, 46, "Input",ExpressionUUID->"a43134f2-9b85-4730-8eff-1d43c700081d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[113393, 2974, 193, 4, 45, "Subsubsection",ExpressionUUID->"2cf82fdb-4d89-4bc8-bf7a-785e1bd0d735",
 InitializationCell->True],
Cell[113589, 2980, 1214, 31, 68, "Input",ExpressionUUID->"032b42ed-3df8-4e60-95c7-6fc7b30af47c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[114840, 3016, 247, 5, 45, "Subsubsection",ExpressionUUID->"fe2c98cb-d212-490e-b517-39d596a2cd44",
 InitializationCell->True],
Cell[115090, 3023, 402, 10, 46, "Input",ExpressionUUID->"de5fef4d-b274-4266-bb70-6f25cf8cb96d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[115541, 3039, 279, 7, 36, "Section",ExpressionUUID->"059f087b-122b-481e-a2d0-f151845f8bfd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[115823, 3048, 403, 8, 81, "Text",ExpressionUUID->"af692b49-5a56-433e-90e4-8f8a8d765918",
 InitializationCell->True],
Cell[116229, 3058, 290, 7, 58, "Text",ExpressionUUID->"aa0aff2a-17b0-4e44-937d-91c98bb713cd",
 InitializationCell->True],
Cell[116522, 3067, 324, 9, 46, "Input",ExpressionUUID->"4ebc83f5-2fcc-4eb4-a38a-0f0a528ce3a3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[116849, 3078, 1170, 22, 46, "Input",ExpressionUUID->"8228d128-714b-4089-826d-b9f08fa1d923",
 InitializationCell->True,
 InitializationGroup->True],
Cell[118022, 3102, 398, 11, 46, "Input",ExpressionUUID->"27fc1392-6fc7-4efc-9fff-fa4124a0cd0d",
 InitializationCell->True],
Cell[118423, 3115, 615, 16, 46, "Input",ExpressionUUID->"9232a151-6a6f-4f25-b927-d3f63e9d3b40",
 InitializationCell->True,
 InitializationGroup->True],
Cell[119041, 3133, 446, 12, 46, "Input",ExpressionUUID->"2558fe22-fe66-4ec2-aa58-ef42f31a1d4a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[119490, 3147, 489, 12, 46, "Input",ExpressionUUID->"711d6da1-77ff-4a1f-b2e5-acc80c9bbb54",
 InitializationCell->True,
 InitializationGroup->True],
Cell[119982, 3161, 614, 15, 46, "Input",ExpressionUUID->"63616575-7b2d-4ed2-9f64-64b4414038cd",
 InitializationCell->True],
Cell[120599, 3178, 700, 14, 46, "Input",ExpressionUUID->"05799ba7-94cd-4959-bfe4-aee13064f4f9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[121302, 3194, 675, 17, 46, "Input",ExpressionUUID->"66c94c58-25b7-4129-b03a-431eeac9a4be",
 InitializationCell->True,
 InitializationGroup->True],
Cell[121980, 3213, 844, 20, 68, "Input",ExpressionUUID->"21f50e7e-6992-4010-ba57-991f3ec38bae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[122827, 3235, 1147, 27, 152, "Input",ExpressionUUID->"85b10a75-5dfd-4f5e-acaa-a61ea017ba77",
 InitializationCell->True],
Cell[123977, 3264, 636, 16, 68, "Input",ExpressionUUID->"05025a52-d302-4212-8c8e-8d6689cbc99e",
 InitializationCell->True],
Cell[124616, 3282, 488, 11, 46, "Input",ExpressionUUID->"d98c4dec-7024-4364-be52-f1e7ddc4a9ed",
 InitializationCell->True],
Cell[125107, 3295, 382, 10, 46, "Input",ExpressionUUID->"aaeb0515-394a-4540-8eff-0ff8139745e4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[125526, 3310, 311, 7, 36, "Section",ExpressionUUID->"ff4e62aa-117c-49fd-be1e-da3fde17cbd8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[125862, 3321, 210, 4, 45, "Subsubsection",ExpressionUUID->"2aa6c1df-3703-4164-a1f6-0f49d4acbd3e",
 InitializationCell->True],
Cell[126075, 3327, 469, 12, 46, "Input",ExpressionUUID->"57c3e4e0-82e4-4a26-b479-c7e4d9427244",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[126581, 3344, 367, 6, 45, "Subsubsection",ExpressionUUID->"388c3f4a-562a-44cf-a0bc-178ebe6d7814",
 InitializationCell->True],
Cell[126951, 3352, 891, 23, 89, "Input",ExpressionUUID->"01baf43e-bda2-4a89-81b4-ee0024182ade",
 InitializationCell->True],
Cell[127845, 3377, 1502, 36, 215, "Input",ExpressionUUID->"4bb382d1-6814-4ca2-903d-3ab1baf8428e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[129384, 3418, 369, 6, 45, "Subsubsection",ExpressionUUID->"733111df-4415-4fe1-a3e6-afc8acf09694",
 InitializationCell->True],
Cell[129756, 3426, 321, 7, 58, "Text",ExpressionUUID->"ff1a9134-e265-42fa-81a9-2f93838facca",
 InitializationCell->True],
Cell[130080, 3435, 527, 10, 58, "Text",ExpressionUUID->"4125cdb2-f5fb-4eb6-9144-e5e7f568d74f",
 InitializationCell->True],
Cell[130610, 3447, 3677, 77, 677, "Input",ExpressionUUID->"0bbb0f71-9a8b-4ef5-9aca-440d9b0399c5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[134324, 3529, 310, 5, 45, "Subsubsection",ExpressionUUID->"d3576d66-a9ff-48bc-b235-9e5df950c68d",
 InitializationCell->True],
Cell[134637, 3536, 197, 4, 35, "Text",ExpressionUUID->"3e4ba35e-d891-4805-be3b-07344d73802a",
 InitializationCell->True],
Cell[134837, 3542, 621, 16, 68, "Input",ExpressionUUID->"af1e138f-3e49-4110-83c5-e8500f259243",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[135507, 3564, 442, 9, 36, "Section",ExpressionUUID->"d5664281-2330-4318-a0c4-615b79a52038",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[135974, 3577, 184, 4, 54, "Subsection",ExpressionUUID->"43393e7e-7384-47b6-ab58-b8005a156ee9",
 InitializationCell->True],
Cell[136161, 3583, 539, 13, 68, "Input",ExpressionUUID->"d77fee1e-4fb3-4692-9368-2c3439b00da1",
 InitializationCell->True],
Cell[136703, 3598, 415, 11, 46, "Input",ExpressionUUID->"f2cba993-a1e8-4a96-81e8-a0835875b71e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[137155, 3614, 373, 6, 54, "Subsection",ExpressionUUID->"9f54f249-d9a0-4a89-8974-aae4e7e1b04f",
 InitializationCell->True],
Cell[137531, 3622, 1186, 30, 236, "Input",ExpressionUUID->"1597c015-b340-4390-8249-5762e6652fe6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[138754, 3657, 326, 5, 54, "Subsection",ExpressionUUID->"c91c0eac-8055-4d7a-b437-9792106c084f",
 InitializationCell->True],
Cell[139083, 3664, 1246, 32, 89, "Input",ExpressionUUID->"94974e8d-3cb8-47c1-b089-967bef380a02",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[140366, 3701, 332, 6, 54, "Subsection",ExpressionUUID->"a28557fb-4f3d-4589-82cb-13e746466fc7",
 InitializationCell->True],
Cell[140701, 3709, 500, 12, 46, "Input",ExpressionUUID->"6f8f015a-8771-42fa-9227-73d05725c034",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[141238, 3726, 245, 5, 54, "Subsection",ExpressionUUID->"5015e59c-bf92-439b-a74b-de7c018ca3ee",
 InitializationCell->True],
Cell[141486, 3733, 497, 13, 46, "Input",ExpressionUUID->"efdeb49d-2f6e-4d91-81ea-f4b57877f659",
 InitializationCell->True],
Cell[141986, 3748, 399, 10, 46, "Input",ExpressionUUID->"979e856f-3d14-4887-8994-4bce4ebc9855",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[142434, 3764, 415, 8, 44, "Section",ExpressionUUID->"6af83384-24ba-4ccf-b887-aba7fba8a8a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[142874, 3776, 231, 5, 54, "Subsection",ExpressionUUID->"d8a7b4f0-7d97-4d2e-80e7-cf7b3c0322d5",
 InitializationCell->True],
Cell[143108, 3783, 1170, 23, 68, "Input",ExpressionUUID->"da9df230-9d55-4efd-a193-327fbcad2526",
 InitializationCell->True],
Cell[144281, 3808, 401, 8, 46, "Input",ExpressionUUID->"91f3beb9-5d7b-49bb-bdf2-ca428d9ad2ca",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[144719, 3821, 237, 5, 38, "Subsection",ExpressionUUID->"2bc5b24c-79d8-4f99-b858-8719d4f5b3dc",
 InitializationCell->True],
Cell[144959, 3828, 5738, 111, 446, "Input",ExpressionUUID->"8722d74d-897f-4152-89cc-fd6ad69da9d5",
 InitializationCell->True],
Cell[150700, 3941, 3855, 78, 341, "Input",ExpressionUUID->"9a822cf2-b2dc-4c7d-b6f1-4286aecf985a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[154592, 4024, 313, 6, 54, "Subsection",ExpressionUUID->"005e43df-25f5-4692-a7bd-71ad47cb39b6",
 InitializationCell->True],
Cell[154908, 4032, 862, 21, 89, "Input",ExpressionUUID->"29372d57-16a5-4a2f-a6f3-b39e2537557c",
 InitializationCell->True],
Cell[155773, 4055, 1894, 35, 68, "Input",ExpressionUUID->"d4cda80a-0b2b-4891-a35b-debe21baffb7",
 InitializationCell->True],
Cell[157670, 4092, 564, 16, 68, "Input",ExpressionUUID->"7747576f-b06e-406a-9ece-5674e9110c2b",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[158271, 4113, 357, 6, 70, "Subsection",ExpressionUUID->"81a8acd3-fd02-422d-aa7d-7e019d18c6a1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[158653, 4123, 504, 8, 45, "Subsubsection",ExpressionUUID->"704644c1-b216-48da-949a-e277ca584d1f",
 InitializationCell->True],
Cell[159160, 4133, 495, 14, 46, "Input",ExpressionUUID->"061d21a3-b63e-4b93-85ad-ee1d21c61060",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[159692, 4152, 242, 5, 37, "Subsubsection",ExpressionUUID->"bf4f1572-7c72-48e8-b3de-d128570da5af",
 InitializationCell->True],
Cell[159937, 4159, 472, 12, 46, "Input",ExpressionUUID->"dad47f85-14b7-4878-ba77-010a71673d94",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[160446, 4176, 301, 5, 37, "Subsubsection",ExpressionUUID->"59036985-295b-4996-99cd-b94854506b0d",
 InitializationCell->True],
Cell[160750, 4183, 1350, 38, 152, "Input",ExpressionUUID->"f3969702-7a3b-460a-b84b-85ca4b6c2e6d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[162137, 4226, 476, 7, 37, "Subsubsection",ExpressionUUID->"9a81d00c-7064-4baf-9369-a707c5c1477a",
 InitializationCell->True],
Cell[162616, 4235, 578, 16, 68, "Input",ExpressionUUID->"70418c31-92c1-4244-a290-343e18e5e939",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[163231, 4256, 697, 11, 37, "Subsubsection",ExpressionUUID->"ffd1d35e-df42-4fd1-95d9-54f92720cb7c",
 InitializationCell->True],
Cell[163931, 4269, 650, 17, 68, "Input",ExpressionUUID->"879ad803-6622-48af-a8a0-059e623bd0cc",
 InitializationCell->True],
Cell[164584, 4288, 599, 17, 46, "Input",ExpressionUUID->"97f37c41-641b-4fe2-966c-54a017f6e812",
 InitializationCell->True],
Cell[165186, 4307, 691, 19, 68, "Input",ExpressionUUID->"b64ed708-7e05-4bfc-8367-ad4477da655b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[165914, 4331, 637, 10, 53, "Subsubsection",ExpressionUUID->"b8647cd0-a1b6-4c73-ac42-957a200beeb5",
 InitializationCell->True],
Cell[166554, 4343, 233, 4, 51, "Text",ExpressionUUID->"5d6f411a-2591-434b-b44b-d394ffeb03a1",
 InitializationCell->True],
Cell[166790, 4349, 2972, 66, 362, "Input",ExpressionUUID->"b38b1604-b066-437a-9d72-bbfa58431aad",
 InitializationCell->True],
Cell[169765, 4417, 2934, 66, 362, "Input",ExpressionUUID->"e78bd590-76f7-414a-97ab-8d62520d207e",
 InitializationCell->True],
Cell[172702, 4485, 1908, 45, 131, "Input",ExpressionUUID->"e2e904db-1378-492e-b699-5dcff472955a",
 InitializationCell->True],
Cell[174613, 4532, 2717, 62, 320, "Input",ExpressionUUID->"5d7629ce-8be4-4f60-967c-813cd3e40045",
 InitializationCell->True],
Cell[177333, 4596, 1621, 38, 110, "Input",ExpressionUUID->"2e093ef5-5680-4ba3-bfd8-9951fef36f7b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[178991, 4639, 666, 10, 37, "Subsubsection",ExpressionUUID->"c731911e-aaf6-4998-8f40-3c51311d702f",
 InitializationCell->True],
Cell[179660, 4651, 223, 4, 35, "Text",ExpressionUUID->"5adb252a-e140-4d22-921e-b69c4e0f146b",
 InitializationCell->True],
Cell[179886, 4657, 1923, 47, 152, "Input",ExpressionUUID->"ae76b25c-ce3c-40b9-8c98-2fbb05b0eef3",
 InitializationCell->True],
Cell[181812, 4706, 2206, 55, 173, "Input",ExpressionUUID->"5d2b02ce-e1fd-49be-a983-5181c2372cc8",
 InitializationCell->True],
Cell[184021, 4763, 1898, 46, 152, "Input",ExpressionUUID->"ceeb92e2-6ebd-4338-9e9d-519a5388f514",
 InitializationCell->True],
Cell[185922, 4811, 276, 7, 35, "Text",ExpressionUUID->"130ca77a-caa9-44eb-8385-d444ed6c7a88",
 InitializationCell->True],
Cell[186201, 4820, 1853, 44, 173, "Input",ExpressionUUID->"a590ee31-cfa0-485f-b274-4e86e0c99c9c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[188091, 4869, 479, 8, 37, "Subsubsection",ExpressionUUID->"e0deb55b-57cb-49bf-97e3-f8f845406900",
 InitializationCell->True],
Cell[188573, 4879, 379, 8, 58, "Text",ExpressionUUID->"84cf41a6-aaf7-4a76-9f0e-2764468ed9f7",
 InitializationCell->True],
Cell[188955, 4889, 2961, 69, 236, "Input",ExpressionUUID->"95f5c9fc-6fd4-4074-9283-f03d24f62cfb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[191953, 4963, 462, 7, 37, "Subsubsection",ExpressionUUID->"e914e2ee-3727-4f4a-8d24-a2dc0be4137c",
 InitializationCell->True],
Cell[192418, 4972, 812, 21, 68, "Input",ExpressionUUID->"24bceaaa-af00-49f6-b143-aebc497e6a96",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[193279, 4999, 854, 14, 38, "Subsection",ExpressionUUID->"260f57fe-8ce6-498c-9532-0adc1a4d0955",
 InitializationCell->True],
Cell[194136, 5015, 856, 19, 68, "Input",ExpressionUUID->"c17a0aeb-63c7-47de-b7df-728300d0e1d5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[195029, 5039, 616, 10, 38, "Subsection",ExpressionUUID->"7c91d3d1-893f-4c98-97bb-7b2383fa1f49",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[195670, 5053, 320, 5, 45, "Subsubsection",ExpressionUUID->"64e0dbf2-035a-441d-9a69-ff945d08570c",
 InitializationCell->True],
Cell[195993, 5060, 430, 7, 35, "Text",ExpressionUUID->"56a2ed10-0f08-4715-aecb-8ae9e2311107",
 InitializationCell->True],
Cell[196426, 5069, 1358, 34, 215, "Input",ExpressionUUID->"a43c15cf-8614-41f1-a7f1-927875324b34",
 InitializationCell->True],
Cell[197787, 5105, 519, 10, 35, "Text",ExpressionUUID->"a7a09fca-83fc-4f15-97de-d4ac19c081cb",
 InitializationCell->True],
Cell[198309, 5117, 3047, 74, 278, "Input",ExpressionUUID->"44474a5b-501f-4d33-a541-2a0b5f04d3fc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[201393, 5196, 336, 6, 45, "Subsubsection",ExpressionUUID->"99f2cff1-c8a2-4931-9e62-b949f466680a",
 InitializationCell->True],
Cell[201732, 5204, 2401, 50, 341, "Input",ExpressionUUID->"890b05a8-149d-4461-bd50-42e43e2f4068",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[204170, 5259, 323, 5, 45, "Subsubsection",ExpressionUUID->"211e6015-37ee-4223-b1fc-f623b8b36ba3",
 InitializationCell->True],
Cell[204496, 5266, 3997, 90, 467, "Input",ExpressionUUID->"af7a2567-2315-4c74-93b3-ba906babe303",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[208542, 5362, 692, 11, 38, "Subsection",ExpressionUUID->"33ed425d-9710-48c8-b2fb-1b57cdda5d9a",
 InitializationCell->True],
Cell[209237, 5375, 1876, 46, 320, "Input",ExpressionUUID->"0d657609-e2ca-4fce-a225-9d3bbfb83d3e",
 InitializationCell->True],
Cell[211116, 5423, 2297, 57, 320, "Input",ExpressionUUID->"6e44d21a-54f5-4da6-be24-f8c771d7a4cd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[213450, 5485, 352, 6, 38, "Subsection",ExpressionUUID->"2f73e91a-a769-4b42-b315-17bfac7e526f",
 InitializationCell->True],
Cell[213805, 5493, 918, 23, 110, "Input",ExpressionUUID->"11e0ae45-79c3-4d08-97aa-aa0182e29256",
 InitializationCell->True],
Cell[214726, 5518, 811, 22, 110, "Input",ExpressionUUID->"217ec80e-6184-4292-a795-8c51c83cc4e6",
 InitializationCell->True],
Cell[215540, 5542, 1275, 32, 152, "Input",ExpressionUUID->"4d0da24c-a53e-4790-a49c-de458b205a38",
 InitializationCell->True],
Cell[216818, 5576, 1318, 33, 152, "Input",ExpressionUUID->"d18c7d4d-4e3a-4d89-93a4-bea91dffe92b",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[218173, 5614, 386, 7, 54, "Subsection",ExpressionUUID->"0019eb55-fe4b-48d3-a62f-796d8e7111ec",
 InitializationCell->True],
Cell[218562, 5623, 1202, 27, 215, "Input",ExpressionUUID->"9875c765-f649-41b0-9722-1ff780f545a7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[219801, 5655, 438, 7, 38, "Subsection",ExpressionUUID->"e2a33496-b7da-47e4-9814-7e1252b9c079",
 InitializationCell->True],
Cell[220242, 5664, 868, 20, 68, "Input",ExpressionUUID->"8fdc0468-f226-49bf-be8a-42edc4b65e02",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[221147, 5689, 303, 5, 38, "Subsection",ExpressionUUID->"d3e036de-9456-4aa3-9e53-d08689b4f0da",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[221475, 5698, 245, 5, 45, "Subsubsection",ExpressionUUID->"4db141f8-d8c7-463b-a589-9c0e4613a29d",
 InitializationCell->True],
Cell[221723, 5705, 360, 9, 46, "Input",ExpressionUUID->"e1808fad-4c33-4184-837b-9c16664c68fc",
 InitializationCell->True],
Cell[222086, 5716, 1789, 36, 152, "Input",ExpressionUUID->"2c4c814d-ffe8-472e-9ad9-c60d3e45d296",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[223912, 5757, 291, 5, 45, "Subsubsection",ExpressionUUID->"0b05ca94-17ff-49b0-b753-df98c4ad70b8",
 InitializationCell->True],
Cell[224206, 5764, 1694, 36, 462, "Input",ExpressionUUID->"84269624-8f0b-44e9-8b18-571c5072dad2",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[225937, 5805, 340, 6, 37, "Subsubsection",ExpressionUUID->"f115914b-02b9-42e9-b3ea-91e8758781a6",
 InitializationCell->True],
Cell[226280, 5813, 1983, 40, 544, "Input",ExpressionUUID->"47a35e6e-4968-41da-a712-05f19190a5bb",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[228312, 5859, 327, 6, 38, "Subsection",ExpressionUUID->"eeaba5b6-accd-4661-8c92-e4aaf9317d3c",
 InitializationCell->True],
Cell[228642, 5867, 634, 13, 109, "Input",ExpressionUUID->"62c95133-0c6d-49a6-aa55-670ee96ff0cf",
 InitializationCell->True],
Cell[229279, 5882, 691, 13, 109, "Input",ExpressionUUID->"b6b4f08a-71bf-4d4b-8eb2-ff0aab3adeab",
 InitializationCell->True],
Cell[229973, 5897, 731, 14, 109, "Input",ExpressionUUID->"da89c852-cb16-4f7d-842c-84018495c23d",
 InitializationCell->True],
Cell[230707, 5913, 664, 13, 109, "Input",ExpressionUUID->"5d748a82-a976-46b6-b88b-abddf5eaf1ba",
 InitializationCell->True],
Cell[231374, 5928, 327, 8, 109, "Input",ExpressionUUID->"db3e3bac-639c-4d7d-8491-3c6bc386af96",
 InitializationCell->True],
Cell[231704, 5938, 453, 10, 183, "Input",ExpressionUUID->"b941e5d6-b7c1-4867-9785-f4ae93e4d4bd",
 InitializationCell->True],
Cell[232160, 5950, 475, 11, 109, "Input",ExpressionUUID->"89d59424-49b6-46fa-b208-e16660eb0b12",
 InitializationCell->True],
Cell[232638, 5963, 451, 10, 109, "Input",ExpressionUUID->"7f34446a-7244-4ff1-b425-69bfa3bdd63e",
 InitializationCell->True],
Cell[233092, 5975, 394, 9, 109, "Input",ExpressionUUID->"a1d8f259-cf41-44f1-a224-71c9d488aa7f",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[233535, 5990, 386, 9, 36, "Section",ExpressionUUID->"2f43b35e-7951-4414-b312-1602e3bc1469",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[233946, 6003, 298, 7, 43, "Subsection",ExpressionUUID->"6a3aa03b-e0fd-494e-9370-4c8dc55b6614",
 InitializationCell->True,
 InitializationGroup->True],
Cell[234247, 6012, 458, 12, 126, "Input",ExpressionUUID->"09b40d90-654c-4879-9e70-a4b94305dc31",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[234742, 6029, 206, 4, 35, "Subsection",ExpressionUUID->"3392daef-bc07-4d6d-8cce-8c828add2f09",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[234973, 6037, 170, 4, 35, "Subsubsection",ExpressionUUID->"f5709b00-60b2-4e78-9b55-07bb11886b0e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[235146, 6043, 667, 15, 28, "Input",ExpressionUUID->"c8d30fbd-eec0-44b9-bd9a-9fb1b7e9b971",
 InitializationCell->True,
 InitializationGroup->True],
Cell[235816, 6060, 440, 10, 32, "Input",ExpressionUUID->"06f67972-224f-4ccf-9967-5f9f9a505770",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[236293, 6075, 375, 8, 29, "Subsubsection",ExpressionUUID->"77276012-402f-4e57-bf6a-414fc63bf727",
 InitializationCell->True,
 InitializationGroup->True],
Cell[236671, 6085, 974, 24, 199, "Input",ExpressionUUID->"26891596-8ac3-485c-b194-815058a27721",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[237682, 6114, 321, 7, 29, "Subsubsection",ExpressionUUID->"8dbb53b5-a1e5-47e0-81e4-2f8005a2d25f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[238006, 6123, 219, 4, 30, "Text",ExpressionUUID->"9bc5f928-240b-4f41-b51f-855984eddd0b",
 InitializationCell->True],
Cell[238228, 6129, 1064, 23, 63, "Input",ExpressionUUID->"3bd25f01-1a1c-4a82-9778-09a737fab310",
 InitializationCell->True,
 InitializationGroup->True],
Cell[239295, 6154, 1059, 23, 63, "Input",ExpressionUUID->"08c00bf0-a84f-4f3b-9519-da557d1c7d35",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[240391, 6182, 289, 7, 29, "Subsubsection",ExpressionUUID->"da3c11a1-0d71-41e2-a612-939711954aef",
 InitializationCell->True,
 InitializationGroup->True],
Cell[240683, 6191, 794, 15, 28, "Input",ExpressionUUID->"976db209-c73e-4117-ae60-e85bf75e1657",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[241514, 6211, 346, 7, 45, "Subsubsection",ExpressionUUID->"b592a641-d4e8-401a-bed0-dc25268724ce",
 InitializationCell->True,
 InitializationGroup->True],
Cell[241863, 6220, 875, 19, 28, "Input",ExpressionUUID->"a60154cb-86c5-43fc-baf8-e48ad059ce7f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[242787, 6245, 321, 7, 35, "Subsection",ExpressionUUID->"c54c0f06-c31e-4474-bc5a-dceb20225fa9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[243111, 6254, 590, 18, 126, "Input",ExpressionUUID->"63ea7aec-ca09-444c-bd24-e917c13e2cf0",
 InitializationCell->True],
Cell[243704, 6274, 693, 20, 213, "Input",ExpressionUUID->"2c64a238-c3db-460f-a9db-b0fce4061dab",
 InitializationCell->True],
Cell[244400, 6296, 1094, 34, 383, "Input",ExpressionUUID->"913b1972-7402-4286-b5e5-9e25a84e6d61",
 InitializationCell->True],
Cell[245497, 6332, 1191, 34, 296, "Input",ExpressionUUID->"78c030ea-13e7-40e7-b81e-7028088b2f10",
 InitializationCell->True],
Cell[246691, 6368, 821, 25, 296, "Input",ExpressionUUID->"855d228b-9f0e-4f4f-b42e-861a02aa8eb3",
 InitializationCell->True],
Cell[247515, 6395, 604, 17, 213, "Input",ExpressionUUID->"d04a037e-0b2c-423b-9569-436fb5be3a1a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[248156, 6417, 236, 6, 35, "Subsection",ExpressionUUID->"4beb40f5-343f-47ac-b400-c67350e8a1d4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[248395, 6425, 353, 9, 126, "Input",ExpressionUUID->"83b2f0cb-aa99-40ab-91cf-e49bc36cc1ba",
 InitializationCell->True],
Cell[248751, 6436, 449, 10, 126, "Input",ExpressionUUID->"41edcbec-7054-4b63-897c-8cc4cc05a23b",
 InitializationCell->True],
Cell[249203, 6448, 355, 9, 126, "Input",ExpressionUUID->"6397b802-db33-438c-b7d6-79133384b6f3",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[249607, 6463, 359, 8, 36, "Section",ExpressionUUID->"9bd6cc37-e12e-460e-8c06-89edae40e99d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[249991, 6475, 167, 4, 44, "Subsection",ExpressionUUID->"0fea0919-64c8-4c8a-9d30-33ec3de75c57",
 InitializationCell->True,
 InitializationGroup->True],
Cell[250161, 6481, 742, 16, 48, "Input",ExpressionUUID->"1adc760d-b8b5-40a8-8555-a8225194525d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[250940, 6502, 292, 7, 36, "Subsection",ExpressionUUID->"d795d240-f66e-4eb7-8eec-a1c18160a61f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[251235, 6511, 1047, 21, 296, "Input",ExpressionUUID->"e2d12d7d-e7ad-4c30-90e8-423a3085e51d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[252285, 6534, 1071, 21, 296, "Input",ExpressionUUID->"76723978-7a89-4549-9d79-a5acf3c00562",
 InitializationCell->True,
 InitializationGroup->True],
Cell[253359, 6557, 991, 20, 126, "Input",ExpressionUUID->"81f3ded2-1cef-4a68-90c4-a660154c29dd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[254353, 6579, 964, 20, 126, "Input",ExpressionUUID->"6a5ce626-4198-4926-97d5-56d84f8602b5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[255354, 6604, 372, 8, 36, "Subsection",ExpressionUUID->"4d1b5007-d43f-4aa3-8198-22765a3ad989",
 InitializationCell->True,
 InitializationGroup->True],
Cell[255729, 6614, 1021, 25, 199, "Input",ExpressionUUID->"c07e11d9-f58a-4ed5-b862-c5d4c9006137",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[256787, 6644, 250, 5, 36, "Subsection",ExpressionUUID->"ea1642af-ee68-4606-be90-7124c623aef4",
 InitializationCell->True],
Cell[257040, 6651, 619, 15, 126, "Input",ExpressionUUID->"45406d79-64fe-42c6-a355-02d507c689a4",
 InitializationCell->True],
Cell[257662, 6668, 852, 20, 126, "Input",ExpressionUUID->"255db904-7159-4e67-bb02-546fa8926e58",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[258551, 6693, 286, 7, 36, "Subsection",ExpressionUUID->"98b2b0e8-83df-44e7-b19f-84e0b7a3996d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[258840, 6702, 772, 15, 126, "Input",ExpressionUUID->"07cf9756-adaa-43e6-85cb-70966bb68a06",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[259649, 6722, 240, 6, 36, "Subsection",ExpressionUUID->"ab3aa976-40de-44c0-9b6c-0214f1b882b1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[259892, 6730, 365, 10, 126, "Input",ExpressionUUID->"fe20c4c6-ee88-4ced-99a1-28fc921daba1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[260306, 6746, 252, 6, 36, "Section",ExpressionUUID->"56c1633f-f858-434b-8e79-33a9fc8d0279",
 InitializationCell->True,
 InitializationGroup->True],
Cell[260561, 6754, 508, 10, 81, "Text",ExpressionUUID->"20421ff3-39d5-49f2-8244-2365c723596f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[261094, 6768, 233, 5, 54, "Subsection",ExpressionUUID->"a5920329-bb5f-4aa4-ad4d-eb75b3ae6a0e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[261352, 6777, 434, 9, 35, "Subsubsection",ExpressionUUID->"fbc95cb4-5f02-43fd-8f20-eea5f0c0ce05",
 InitializationCell->True,
 InitializationGroup->True],
Cell[261789, 6788, 277, 6, 48, "Input",ExpressionUUID->"58ece623-43e9-4aa8-86c7-57d09bd4d2a2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[262103, 6799, 406, 8, 29, "Subsubsection",ExpressionUUID->"a04c11d6-795c-494b-8753-195afda768d8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[262512, 6809, 385, 9, 48, "Input",ExpressionUUID->"f5055182-f5af-4e27-aac1-5c268efabd87",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[262934, 6823, 588, 11, 29, "Subsubsection",ExpressionUUID->"df5a9ec9-7d04-4fd6-adb3-92a11fbedcb1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[263525, 6836, 724, 19, 50, "Input",ExpressionUUID->"e41ab838-eebb-47e1-bcef-6703178a229c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[264286, 6860, 233, 6, 29, "Subsubsection",ExpressionUUID->"be1692cc-d329-4696-8f62-f6b49521caab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[264522, 6868, 989, 24, 70, "Input",ExpressionUUID->"538cd8c8-d789-44e8-9c83-410b9a0df2c6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[265548, 6897, 418, 8, 29, "Subsubsection",ExpressionUUID->"f6980172-e179-4713-a319-5ea1d6a822f3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[265969, 6907, 351, 9, 48, "Input",ExpressionUUID->"7e262461-ff9b-4182-bb99-435842743bb1",
 InitializationCell->True],
Cell[266323, 6918, 608, 15, 48, "Input",ExpressionUUID->"538ca08d-b29f-4d09-8008-c3182882de1f",
 InitializationCell->True],
Cell[266934, 6935, 1113, 28, 91, "Input",ExpressionUUID->"c061535d-8411-49a8-8cd2-6511fe02614f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[268084, 6968, 520, 10, 29, "Subsubsection",ExpressionUUID->"b0b2566a-c520-4ed2-add4-a8c922a7b51b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[268607, 6980, 719, 21, 70, "Input",ExpressionUUID->"792d487c-8f65-4e60-b5f1-0c5b47efe5c4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[269375, 7007, 236, 6, 38, "Subsection",ExpressionUUID->"40f68575-fbba-4b9c-9263-284d31c4ce2a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[269636, 7017, 199, 4, 35, "Subsubsection",ExpressionUUID->"942791b4-3cd5-41dc-a856-7046727dc981",
 InitializationCell->True],
Cell[269838, 7023, 1163, 27, 91, "Input",ExpressionUUID->"138975ba-1cf1-4bbb-ac4d-5c447b97e922",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[271038, 7055, 194, 4, 29, "Subsubsection",ExpressionUUID->"fd875d5d-3815-4ed2-a281-060107fa5d27",
 InitializationCell->True],
Cell[271235, 7061, 1033, 26, 70, "Input",ExpressionUUID->"d8f7609f-b1b8-44c4-85fc-f6f4e8fa9a15",
 InitializationCell->True,
 InitializationGroup->True],
Cell[272271, 7089, 1494, 34, 116, "Input",ExpressionUUID->"e00f6759-5a7b-47b7-8c1d-69fb454de862",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[273802, 7128, 373, 8, 29, "Subsubsection",ExpressionUUID->"a436b159-fcad-47b4-ad5d-7c21c7f0803a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[274178, 7138, 904, 23, 91, "Input",ExpressionUUID->"605ca23a-ec9f-446c-b9e5-e0b0cd7726f9",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[275131, 7167, 432, 9, 38, "Subsection",ExpressionUUID->"e17a34c5-7479-45d9-9234-768a1e2aa3e2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[275566, 7178, 983, 25, 70, "Input",ExpressionUUID->"ab9b6589-91ff-4cbb-a829-d7d6811ae90f",
 InitializationCell->True],
Cell[276552, 7205, 490, 13, 48, "Input",ExpressionUUID->"ce14ff4c-6488-45c8-91da-58224bdb5574",
 InitializationCell->True],
Cell[277045, 7220, 1120, 28, 91, "Input",ExpressionUUID->"48b31dc4-2041-4f11-aecc-dd1c0b4ee339",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[278202, 7253, 383, 8, 38, "Subsection",ExpressionUUID->"f86b23c2-8977-44aa-939e-18747bc5461d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[278610, 7265, 394, 8, 35, "Subsubsection",ExpressionUUID->"6e88bad7-7dfa-42e8-a928-41ed03685554",
 InitializationCell->True,
 InitializationGroup->True],
Cell[279007, 7275, 1000, 22, 51, "Input",ExpressionUUID->"d56a2eed-4f88-4894-ac66-c7828bbd7af6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[280010, 7299, 953, 22, 51, "Input",ExpressionUUID->"ea6c7332-d3fa-412b-9335-33b43285b3b2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[280966, 7323, 949, 21, 51, "Input",ExpressionUUID->"4ef3779b-cb62-4351-af52-4e59fe7fe355",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[281952, 7349, 254, 6, 29, "Subsubsection",ExpressionUUID->"e602bbd2-92ac-4419-8ba6-eb937cb0f4a9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[282209, 7357, 1016, 27, 70, "Input",ExpressionUUID->"9fbe0ad4-f643-4149-afb6-90ad961836f4",
 InitializationCell->True],
Cell[283228, 7386, 882, 23, 70, "Input",ExpressionUUID->"d811101d-c572-4cca-87ef-adbed98a9a23",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[284159, 7415, 237, 6, 38, "Subsection",ExpressionUUID->"0539169d-aad8-4faa-b797-52c5e80482ca",
 InitializationCell->True,
 InitializationGroup->True],
Cell[284399, 7423, 920, 24, 91, "Input",ExpressionUUID->"68df593b-56d9-4454-b080-9ae7104a7cad",
 InitializationCell->True,
 InitializationGroup->True],
Cell[285322, 7449, 691, 19, 70, "Input",ExpressionUUID->"09b8d2bd-99b4-4646-84b4-e1042dc49370",
 InitializationCell->True,
 InitializationGroup->True],
Cell[286016, 7470, 691, 19, 70, "Input",ExpressionUUID->"a1df7375-7bee-45f9-9eb3-89ba040d4da6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[286710, 7491, 867, 24, 92, "Input",ExpressionUUID->"a3912553-d809-4dd6-8bed-ca4b49fc032c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[287614, 7520, 600, 11, 38, "Subsection",ExpressionUUID->"7cc16f22-4745-4f43-a875-944cf23e5d60",
 InitializationCell->True,
 InitializationGroup->True],
Cell[288217, 7533, 493, 13, 48, "Input",ExpressionUUID->"7c2d6562-a3ae-4067-975c-1ed6d385ee5a",
 InitializationCell->True],
Cell[288713, 7548, 717, 19, 70, "Input",ExpressionUUID->"42b86408-4640-42e6-acd3-f7e58d33b511",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[289467, 7572, 296, 7, 38, "Subsection",ExpressionUUID->"dd1356f3-c973-4698-8c21-c7904a7999d8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[289788, 7583, 200, 4, 34, "Subsubsection",ExpressionUUID->"485d49fa-d58d-43ce-aef2-15fd3edfa720",
 InitializationCell->True,
 InitializationGroup->True],
Cell[289991, 7589, 1464, 44, 85, "Input",ExpressionUUID->"716f70bf-697a-4980-a3d7-ff458735b49f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[291458, 7635, 1201, 35, 85, "Input",ExpressionUUID->"feee4306-2e9a-49f2-b890-89dc33387847",
 InitializationCell->True,
 InitializationGroup->True],
Cell[292662, 7672, 1140, 33, 85, "Input",ExpressionUUID->"7e5d1770-16fe-45c4-a5a5-b27a6511aaf6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[293805, 7707, 1496, 45, 85, "Input",ExpressionUUID->"e11f6d8a-eab1-49f9-beac-d02b9467c300",
 InitializationCell->True,
 InitializationGroup->True],
Cell[295304, 7754, 1131, 33, 85, "Input",ExpressionUUID->"fcae40fb-fefd-4dcb-bf94-f6676d1ca953",
 InitializationCell->True,
 InitializationGroup->True],
Cell[296438, 7789, 1488, 45, 85, "Input",ExpressionUUID->"d2150b8a-d18d-47a8-8466-332db45fa891",
 InitializationCell->True,
 InitializationGroup->True],
Cell[297929, 7836, 1454, 44, 85, "Input",ExpressionUUID->"ecbb18a8-c672-4013-8b3e-2bd8d63ef376",
 InitializationCell->True,
 InitializationGroup->True],
Cell[299386, 7882, 1164, 34, 85, "Input",ExpressionUUID->"4410f579-5139-4961-a862-e1da3734ebc3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[300587, 7921, 191, 4, 28, "Subsubsection",ExpressionUUID->"3806c6bd-c5e2-46b3-8107-ee5eab612a1a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[300781, 7927, 1060, 29, 66, "Input",ExpressionUUID->"78525f5b-5183-44ee-8b3f-5636b370d3d8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[301844, 7958, 1068, 31, 66, "Input",ExpressionUUID->"b98b8ef2-e2f2-4fdf-b334-e961933656e6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[302915, 7991, 1172, 33, 85, "Input",ExpressionUUID->"e8888444-46a6-4924-84b3-daee974c2ed6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[304090, 8026, 2211, 58, 218, "Input",ExpressionUUID->"f641658e-67fb-4fb8-91fb-5db03439be5c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[306304, 8086, 2214, 58, 218, "Input",ExpressionUUID->"c24d17b6-6c65-4afa-8400-ad6f81094e82",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[308567, 8150, 295, 6, 38, "Subsection",ExpressionUUID->"dcffb335-e8de-4c9d-a434-287a6e7df1e7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[308887, 8160, 176, 3, 35, "Subsubsection",ExpressionUUID->"191f74c6-5d94-441f-9001-3f3d3319cc45",
 InitializationCell->True,
 InitializationGroup->True],
Cell[309066, 8165, 1098, 31, 91, "Input",ExpressionUUID->"41ac6a06-9530-465c-9381-8d302cf9be3b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[310167, 8198, 1460, 43, 133, "Input",ExpressionUUID->"f9303495-b73e-455f-a662-74bb31951618",
 InitializationCell->True,
 InitializationGroup->True],
Cell[311630, 8243, 1202, 34, 112, "Input",ExpressionUUID->"958639bf-2ab7-4309-b643-a0a48de13eae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[312835, 8279, 1159, 32, 112, "Input",ExpressionUUID->"ee3c602c-9c73-4224-a235-c31e8e0215b2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[313997, 8313, 1519, 44, 133, "Input",ExpressionUUID->"b087ea28-4bbf-47e1-bb8a-041421fc71d7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[315519, 8359, 1479, 43, 133, "Input",ExpressionUUID->"dd6ad5e3-45a4-4da4-a1df-439bf6e529f5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[317001, 8404, 1185, 33, 112, "Input",ExpressionUUID->"d9efbd17-ecc7-4da7-876d-e451180694a1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[318189, 8439, 1153, 32, 112, "Input",ExpressionUUID->"b41f7545-0b83-4c09-af9a-57f2fb3e3169",
 InitializationCell->True,
 InitializationGroup->True],
Cell[319345, 8473, 1511, 44, 133, "Input",ExpressionUUID->"135a4e6e-3e42-42c2-a2c4-52075d804b32",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[320893, 8522, 190, 4, 29, "Subsubsection",ExpressionUUID->"0e27024e-2000-473e-8661-a2737daf4721",
 InitializationCell->True,
 InitializationGroup->True],
Cell[321086, 8528, 949, 27, 70, "Input",ExpressionUUID->"e7d695e2-3bd0-4532-9a20-5d8f380b2129",
 InitializationCell->True,
 InitializationGroup->True],
Cell[322038, 8557, 1004, 29, 70, "Input",ExpressionUUID->"fc19f191-74a3-42a2-aca2-ee6258e12d0d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[323045, 8588, 1104, 31, 91, "Input",ExpressionUUID->"18dccc43-9e4b-4ede-86d9-7084cd35926f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[324152, 8621, 2164, 57, 238, "Input",ExpressionUUID->"0a69bb39-4947-435b-9f1f-45a3221fde26",
 InitializationCell->True,
 InitializationGroup->True],
Cell[326319, 8680, 2164, 57, 238, "Input",ExpressionUUID->"9e4dcd06-688b-42bb-835c-1421954049e0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[328532, 8743, 267, 6, 38, "Subsection",ExpressionUUID->"b1978ade-fd29-4275-9f2b-766e6f609eed",
 InitializationCell->True,
 InitializationGroup->True],
Cell[328802, 8751, 2504, 55, 343, "Input",ExpressionUUID->"b6624477-01b0-439c-8de9-80d5321150ad",
 InitializationCell->True,
 InitializationGroup->True],
Cell[331309, 8808, 2549, 57, 343, "Input",ExpressionUUID->"80ecd276-3196-4f64-8795-26f57b870085",
 InitializationCell->True,
 InitializationGroup->True],
Cell[333861, 8867, 1900, 44, 259, "Input",ExpressionUUID->"b3b4c174-4ad2-4768-8fc9-4133d4e263ac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[335764, 8913, 719, 19, 77, "Input",ExpressionUUID->"c07fed2d-8640-4648-af13-2a37c55142c3",
 InitializationCell->True],
Cell[336486, 8934, 592, 16, 74, "Input",ExpressionUUID->"6f047cdb-bfeb-4cbc-bb1e-512c39c3ce62",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[337115, 8955, 426, 8, 38, "Subsection",ExpressionUUID->"bd091f29-5556-4ac5-a78d-a3ee4362a680",
 InitializationCell->True,
 InitializationGroup->True],
Cell[337544, 8965, 837, 23, 70, "Input",ExpressionUUID->"aea92cca-6c76-4505-94db-2a9d96f9e852",
 InitializationCell->True],
Cell[338384, 8990, 846, 25, 70, "Input",ExpressionUUID->"4141c12d-d6cd-4aa4-be72-06eac18d0833",
 InitializationCell->True],
Cell[339233, 9017, 1198, 28, 175, "Input",ExpressionUUID->"7eef77de-c912-4ca2-837d-fde6fd6a369b",
 InitializationCell->True],
Cell[340434, 9047, 1233, 31, 175, "Input",ExpressionUUID->"091b40a7-5ae1-40ed-b0a2-3e4228bc3a55",
 InitializationCell->True],
Cell[341670, 9080, 1526, 36, 196, "Input",ExpressionUUID->"83c8df10-f8ea-4e6d-be4c-4b149b39bff0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[343233, 9121, 168, 4, 38, "Subsection",ExpressionUUID->"2a794473-6f35-4f9c-8e62-de185816581a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[343404, 9127, 336, 9, 48, "Input",ExpressionUUID->"298df51e-8e0f-4be0-a753-6af31e63adbf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[343743, 9138, 401, 10, 48, "Input",ExpressionUUID->"da8a20ed-6dba-493c-afea-a3d822283129",
 InitializationCell->True],
Cell[344147, 9150, 388, 10, 48, "Input",ExpressionUUID->"b8a5f664-7bcb-406c-a9e1-4d73f43d0642",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[344572, 9165, 327, 6, 38, "Subsection",ExpressionUUID->"1bf02b67-0b7c-486f-8d6d-4f7b3cf4822c",
 InitializationCell->True],
Cell[344902, 9173, 795, 20, 92, "Input",ExpressionUUID->"71f50736-0cc5-437b-bc06-815fe5885c6a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[345746, 9199, 299, 8, 44, "Section",ExpressionUUID->"2a156b34-5f44-4f89-a254-eaf93cb163ce",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[346070, 9211, 431, 9, 54, "Subsection",ExpressionUUID->"8e64d32a-483e-4b04-aedf-ca368db0af2b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[346504, 9222, 277, 6, 126, "Input",ExpressionUUID->"bd8cd283-7c82-47c6-baab-d71aff37d472",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[346818, 9233, 347, 7, 38, "Subsection",ExpressionUUID->"bf2c388b-9c6e-4588-988d-deef6f0ca996",
 InitializationCell->True,
 InitializationGroup->True],
Cell[347168, 9242, 310, 7, 126, "Input",ExpressionUUID->"91358ce8-ea98-498a-8302-abedcb4552cb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[347515, 9254, 167, 4, 38, "Subsection",ExpressionUUID->"800e34d1-9f84-4f6e-ab31-074e546edebe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[347685, 9260, 1575, 38, 422, "Input",ExpressionUUID->"f4e3bb20-fa69-4bd2-aa58-dd2ac0bb5400",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[349297, 9303, 246, 6, 38, "Subsection",ExpressionUUID->"c6db0b0b-81c5-4055-a72e-95f323b7b801",
 InitializationCell->True,
 InitializationGroup->True],
Cell[349546, 9311, 513, 14, 126, "Input",ExpressionUUID->"7b6e8e2b-658a-41c6-8f27-4fe95bfc4449",
 InitializationCell->True],
Cell[350062, 9327, 591, 17, 126, "Input",ExpressionUUID->"24771b03-42d7-43ca-bb25-2b52aca9b2dd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[350690, 9349, 206, 5, 54, "Subsection",ExpressionUUID->"9bdd1fd7-4805-4813-9d79-a0044568f363",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[350921, 9358, 199, 4, 35, "Subsubsection",ExpressionUUID->"233582d9-eb36-473a-b712-32addde4c9d0",
 InitializationCell->True],
Cell[351123, 9364, 1172, 27, 70, "Input",ExpressionUUID->"b692c63d-4711-448a-9746-3bc90005a2af",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[352332, 9396, 284, 5, 45, "Subsubsection",ExpressionUUID->"588a6d20-820b-4d97-9dee-f58836a9a203",
 InitializationCell->True],
Cell[352619, 9403, 826, 24, 91, "Input",ExpressionUUID->"b63bf9ca-895e-49a0-9a38-f42085cac2b5",
 InitializationCell->True],
Cell[353448, 9429, 914, 25, 93, "Input",ExpressionUUID->"9163c31a-eca3-44a7-8693-f0bdba4cbde2",
 InitializationCell->True],
Cell[354365, 9456, 1924, 48, 196, "Input",ExpressionUUID->"ced0be3c-483d-4563-b2bc-aa88bac609b6",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[356338, 9510, 370, 8, 38, "Subsection",ExpressionUUID->"81610bed-c5d8-4c19-9ef2-66f43c7fe0ed",
 InitializationCell->True,
 InitializationGroup->True],
Cell[356711, 9520, 958, 24, 213, "Input",ExpressionUUID->"7eee579a-3124-446d-b4e5-8c273f2c8f63",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[357706, 9549, 261, 6, 38, "Subsection",ExpressionUUID->"eaf6ea80-8610-4583-aac6-a8941f01c72f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[357992, 9559, 322, 7, 35, "Subsubsection",ExpressionUUID->"d28f1bf5-8391-4f5d-92ee-f8f713e411c1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[358317, 9568, 825, 21, 51, "Input",ExpressionUUID->"9bdc62f4-6523-4834-a8cb-71cf594d412c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[359145, 9591, 876, 23, 51, "Input",ExpressionUUID->"a10433e5-fe57-4f9c-bb0c-da61afd5836e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[360024, 9616, 952, 25, 51, "Input",ExpressionUUID->"c0cd9463-9e5b-483a-87d9-eaa8791cb1f9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[360979, 9643, 1295, 31, 114, "Input",ExpressionUUID->"c5459c0e-6293-4ff2-9461-4237646d9f38",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[362311, 9679, 370, 7, 29, "Subsubsection",ExpressionUUID->"67fd1893-c8e0-4327-a8e9-083b19bd4f7f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[362684, 9688, 1030, 27, 126, "Input",ExpressionUUID->"3698e9c6-f28d-4d04-830e-c8b1e4b68758",
 InitializationCell->True],
Cell[363717, 9717, 1032, 27, 126, "Input",ExpressionUUID->"64915363-13a7-4859-8374-b9a4a3e9ba8d",
 InitializationCell->True],
Cell[364752, 9746, 1036, 28, 126, "Input",ExpressionUUID->"177112da-00ad-41a2-bb39-334fec6004c2",
 InitializationCell->True],
Cell[365791, 9776, 1131, 29, 126, "Input",ExpressionUUID->"5ef297e4-aa54-4304-8acd-1a38990b2b6e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[366959, 9810, 367, 7, 29, "Subsubsection",ExpressionUUID->"0d87d982-1a11-4146-b3fd-53c81d1d46cc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[367329, 9819, 1312, 35, 70, "Input",ExpressionUUID->"0e195f7b-ac9c-43fb-a6dd-31d56fa44e18",
 InitializationCell->True,
 InitializationGroup->True],
Cell[368644, 9856, 1116, 29, 48, "Input",ExpressionUUID->"e830f217-d505-4ddd-bede-d3dbed3b1834",
 InitializationCell->True,
 InitializationGroup->True],
Cell[369763, 9887, 1472, 43, 70, "Input",ExpressionUUID->"7211b5b8-3e43-4f7a-848a-7443798f31c4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[371284, 9936, 299, 7, 38, "Subsection",ExpressionUUID->"49c70de3-8b5d-4bdd-be06-718adc46f99c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[371586, 9945, 405, 11, 42, "Input",ExpressionUUID->"8041af2f-29f7-4910-8103-08ac21f65c18",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[372028, 9961, 386, 8, 38, "Subsection",ExpressionUUID->"fa7a6a52-1ab8-42f1-8493-92d3addac709",
 InitializationCell->True,
 InitializationGroup->True],
Cell[372417, 9971, 1151, 28, 126, "Input",ExpressionUUID->"b64a54cc-f886-4149-92aa-aac992e62544",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[373605, 10004, 227, 4, 38, "Subsection",ExpressionUUID->"02628067-a316-4337-8b72-84c2321af3e7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[373857, 10012, 273, 5, 34, "Subsubsection",ExpressionUUID->"55db3eda-98f4-4bc7-818a-49c85e7e2542",
 InitializationCell->True],
Cell[374133, 10019, 1059, 28, 383, "Input",ExpressionUUID->"29c1f22a-9d5e-4d52-866e-c8af2a221327",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[375229, 10052, 381, 7, 28, "Subsubsection",ExpressionUUID->"3aea172b-217f-4d47-8b2c-4b4a3bf7fd4f",
 InitializationCell->True],
Cell[375613, 10061, 1084, 28, 104, "Input",ExpressionUUID->"a50a3c57-e06c-4c1f-90c9-15ea89de516e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[376746, 10095, 246, 5, 38, "Subsection",ExpressionUUID->"a60ad838-f5e8-49d2-a4b0-91419d2a36f7",
 InitializationCell->True],
Cell[376995, 10102, 329, 8, 28, "Input",ExpressionUUID->"140c26d4-6af4-4ae5-9d66-21528f986888",
 InitializationCell->True],
Cell[377327, 10112, 1276, 30, 114, "Input",ExpressionUUID->"50021e8d-5966-49ca-b4d5-2c44d9150e8e",
 InitializationCell->True],
Cell[378606, 10144, 1419, 32, 114, "Input",ExpressionUUID->"bcacad7e-f75e-4598-b525-abefbac9ddc3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[380062, 10181, 214, 4, 54, "Subsection",ExpressionUUID->"7fe1874f-53a1-42f3-9f0f-50a04370db4b",
 InitializationCell->True],
Cell[380279, 10187, 463, 10, 48, "Input",ExpressionUUID->"a820f01f-68bc-4c7d-8eec-dbe54d5059db",
 InitializationCell->True],
Cell[380745, 10199, 433, 10, 48, "Input",ExpressionUUID->"76a260e3-49b1-485d-b093-b4e25f52b429",
 InitializationCell->True],
Cell[381181, 10211, 395, 9, 48, "Input",ExpressionUUID->"ee70b165-41f4-4d2d-9a48-495f63961eca",
 InitializationCell->True],
Cell[381579, 10222, 479, 10, 48, "Input",ExpressionUUID->"1be65187-c678-4912-8305-cb21a650cda2",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[382107, 10238, 306, 8, 44, "Section",ExpressionUUID->"3fc569ca-409f-4d70-b0bc-36d399ae0ab9",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[382416, 10248, 235, 6, 35, "Text",ExpressionUUID->"16874396-c290-4f08-801f-0522253f35ba",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[382676, 10258, 431, 9, 54, "Subsection",ExpressionUUID->"0e0788c5-4ddb-433c-becd-6a3b23a412f3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[383110, 10269, 295, 7, 46, "Input",ExpressionUUID->"3b56be72-534b-426f-8330-80fdc335e8d1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[383442, 10281, 179, 4, 38, "Subsection",ExpressionUUID->"29bfebf5-0b69-46d2-bf71-007eb0c020fc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[383646, 10289, 178, 4, 45, "Subsubsection",ExpressionUUID->"e0403e59-f798-40bd-afb6-a64fb1e1b680",
 InitializationCell->True,
 InitializationGroup->True],
Cell[383827, 10295, 540, 12, 46, "Input",ExpressionUUID->"939a6635-dd73-4df2-8f95-b7bfd06ab958",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[384404, 10312, 302, 7, 45, "Subsubsection",ExpressionUUID->"9f954cc2-66c4-4174-b092-a19a4b1eace3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[384709, 10321, 697, 20, 46, "Input",ExpressionUUID->"ca91b066-5db2-4eaa-a819-bfbc80991647",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[385443, 10346, 343, 7, 45, "Subsubsection",ExpressionUUID->"ca784d36-96a3-4499-8c13-829b595e0542",
 InitializationCell->True,
 InitializationGroup->True],
Cell[385789, 10355, 592, 15, 46, "Input",ExpressionUUID->"ba3956b1-59e1-41e4-8f97-c4cf9bca871a",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[386418, 10375, 318, 7, 45, "Subsubsection",ExpressionUUID->"de8fbaf7-7be5-4799-bd51-0b3092e48efd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[386739, 10384, 1722, 37, 110, "Input",ExpressionUUID->"d3fbacff-343c-4950-83f1-29076b01cec7",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[388510, 10427, 158, 3, 38, "Subsection",ExpressionUUID->"7f25094e-e83c-404c-9228-7a3bd5d9bd89",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[388693, 10434, 177, 4, 45, "Subsubsection",ExpressionUUID->"81d7f7c5-6a55-43b3-8529-42bebbcbfcdf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[388873, 10440, 827, 22, 68, "Input",ExpressionUUID->"81f0c039-7f33-45c3-a9ac-df39b24961aa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[389703, 10464, 670, 18, 68, "Input",ExpressionUUID->"fc181ff2-3e42-41b5-bbfa-caa3df638d2d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[390410, 10487, 256, 6, 37, "Subsubsection",ExpressionUUID->"3852f8dd-cf10-4a67-98e1-d4296e466d63",
 InitializationCell->True,
 InitializationGroup->True],
Cell[390669, 10495, 947, 24, 68, "Input",ExpressionUUID->"2193e1e5-edde-4071-b1eb-23011c1cdbbc",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[391653, 10524, 258, 6, 37, "Subsubsection",ExpressionUUID->"bca47b81-b5e8-458c-8e15-ea6a98b31d19",
 InitializationCell->True,
 InitializationGroup->True],
Cell[391914, 10532, 1058, 29, 68, "Input",ExpressionUUID->"dae5f359-b2bc-438f-ac59-b4606c6dfa84",
 InitializationCell->True,
 InitializationGroup->True],
Cell[392975, 10563, 880, 24, 68, "Input",ExpressionUUID->"e580b62e-a0c6-4bc6-912b-bcc814baf78b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[393858, 10589, 1062, 30, 68, "Input",ExpressionUUID->"814100d9-3902-4c57-8690-91ffd0438f10",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[394957, 10624, 305, 7, 37, "Subsubsection",ExpressionUUID->"40fdbc7f-28f5-4c8b-bfa3-94705a6f042f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[395265, 10633, 1143, 31, 68, "Input",ExpressionUUID->"a5a988c6-f264-47de-9c5f-f844cc4fd46c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[396411, 10666, 1402, 40, 89, "Input",ExpressionUUID->"709f8971-07ea-4c18-9b26-9e65f5d67e35",
 InitializationCell->True,
 InitializationGroup->True],
Cell[397816, 10708, 1363, 39, 89, "Input",ExpressionUUID->"cccd9c94-a5fb-4ef4-bfd7-37c4c974c155",
 InitializationCell->True,
 InitializationGroup->True],
Cell[399182, 10749, 1426, 41, 89, "Input",ExpressionUUID->"8755516b-58ee-4158-ae9e-db4c54973f6a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[400611, 10792, 1219, 33, 68, "Input",ExpressionUUID->"4f590706-e609-481c-ba36-d65cff7aac61",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[401867, 10830, 266, 6, 37, "Subsubsection",ExpressionUUID->"b051ec61-0356-48c4-bd08-866cf7ecc510",
 InitializationCell->True,
 InitializationGroup->True],
Cell[402136, 10838, 265, 7, 35, "Text",ExpressionUUID->"2fead082-dc65-4f12-9fef-7944ab512b0d",
 InitializationCell->True],
Cell[402404, 10847, 489, 9, 81, "Text",ExpressionUUID->"1aa95fd0-be27-43b9-98e3-6c2047119b07",
 InitializationCell->True],
Cell[402896, 10858, 1303, 36, 89, "Input",ExpressionUUID->"39d932d4-6531-4f57-9dc8-e46854775a99",
 InitializationCell->True],
Cell[404202, 10896, 817, 23, 68, "Input",ExpressionUUID->"7805295e-a303-4375-a70a-e41ebff87307",
 InitializationCell->True],
Cell[405022, 10921, 2890, 78, 257, "Input",ExpressionUUID->"9617287e-a0e5-437e-811c-2ac0342fda89",
 InitializationCell->True],
Cell[407915, 11001, 2854, 77, 257, "Input",ExpressionUUID->"f4ec824d-9e33-44ae-a562-78b269d6348e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[410818, 11084, 301, 6, 54, "Subsection",ExpressionUUID->"d4f1206b-50fe-4519-ac0d-d49c2c133a5a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[411144, 11094, 213, 4, 45, "Subsubsection",ExpressionUUID->"65cc71e6-af9f-49e4-954a-5700580a1254"],
Cell[411360, 11100, 357, 7, 58, "Text",ExpressionUUID->"bce51ad2-d871-4288-95b1-7cca6fe2039a"],
Cell[411720, 11109, 1838, 54, 131, "Input",ExpressionUUID->"732c04a6-ee3b-46e8-9009-8d91446b6819",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[413607, 11169, 214, 4, 38, "Subsection",ExpressionUUID->"ce4edd31-f6d5-4147-956c-34f38d3ff62a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[413846, 11177, 185, 4, 45, "Subsubsection",ExpressionUUID->"38f6e72f-5d0b-4f16-a45b-2ec4f1690171",
 InitializationCell->True,
 InitializationGroup->True],
Cell[414034, 11183, 611, 19, 46, "Input",ExpressionUUID->"220a63f6-dee2-4756-a441-6cee876bc8e5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[414648, 11204, 634, 18, 46, "Input",ExpressionUUID->"d75c6d74-e50d-4d08-866d-b14df6523e50",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[415319, 11227, 412, 9, 37, "Subsubsection",ExpressionUUID->"d096b117-c010-4ccb-81c8-77207ad00fdb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[415734, 11238, 884, 23, 68, "Input",ExpressionUUID->"56aeff15-98ae-4ff6-9a94-15ba9de96325",
 InitializationCell->True,
 InitializationGroup->True],
Cell[416621, 11263, 970, 25, 68, "Input",ExpressionUUID->"2362bf6f-0464-4786-867b-21bf81084f7f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[417628, 11293, 301, 7, 63, "Subsubsection",ExpressionUUID->"92c5c87b-1b41-4fba-ba47-88802ac464ed",
 InitializationCell->True,
 InitializationGroup->True],
Cell[417932, 11302, 947, 32, 68, "Input",ExpressionUUID->"98f14ecf-0942-4800-af09-021f0dc861d1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[418882, 11336, 1988, 58, 131, "Input",ExpressionUUID->"e2538ae3-9d48-4998-be26-d871bf688649",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[420907, 11399, 243, 6, 37, "Subsubsection",ExpressionUUID->"cf32e34f-22a3-4f32-8c24-89137d0d81c0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[421153, 11407, 4578, 117, 446, "Input",ExpressionUUID->"65394201-6ec6-418c-8609-c26167966a90",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[425768, 11529, 376, 9, 63, "Subsubsection",ExpressionUUID->"488cc195-46fe-4565-a4ce-660e11d9ae4e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[426147, 11540, 2945, 73, 320, "Input",ExpressionUUID->"788f109b-72f1-4b23-ad2e-8a46cb9f2e2e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[429129, 11618, 191, 4, 37, "Subsubsection",ExpressionUUID->"c844b8fd-f8c0-4af7-af90-22fe27c82200",
 InitializationCell->True,
 InitializationGroup->True],
Cell[429323, 11624, 1745, 48, 173, "Input",ExpressionUUID->"dca81de6-cf49-4790-96dc-b5f2e476e8a0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[431105, 11677, 256, 7, 37, "Subsubsection",ExpressionUUID->"826f7906-d654-4e21-b4d4-b85d89d8523d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[431364, 11686, 368, 12, 46, "Input",ExpressionUUID->"21a67af1-becb-4698-a920-97961a6e757f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[431735, 11700, 1093, 32, 131, "Input",ExpressionUUID->"7081805e-b071-478b-bc5e-666fe9716608",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[432877, 11738, 188, 4, 38, "Subsection",ExpressionUUID->"f067e993-b365-436c-b926-a31e0b6322c5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[433090, 11746, 234, 6, 45, "Subsubsection",ExpressionUUID->"9d92a1ef-43ae-4b27-9c68-20aaeb519da1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[433327, 11754, 938, 25, 89, "Input",ExpressionUUID->"27fde190-0af8-4d02-9f74-2d1a96bde17e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[434302, 11784, 340, 9, 63, "Subsubsection",ExpressionUUID->"7d9dea5a-8f31-4a52-ac67-8a8608bf6bfd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[434645, 11795, 1267, 35, 110, "Input",ExpressionUUID->"ffe6b6a4-ca41-4d16-929f-708ff9aff86e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[435915, 11832, 4075, 100, 320, "Input",ExpressionUUID->"f18ca330-8ae4-4ac3-84fc-c0162d4f614d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[439993, 11934, 2346, 64, 215, "Input",ExpressionUUID->"936f76b5-db82-4ccd-aa10-45a3a3283cb2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[442376, 12003, 189, 4, 37, "Subsubsection",ExpressionUUID->"e4e7c53c-1591-4795-81a8-ea222cba03ea",
 InitializationCell->True],
Cell[442568, 12009, 586, 16, 46, "Input",ExpressionUUID->"617166fb-2002-4dfc-a282-150ad1694863",
 InitializationCell->True],
Cell[443157, 12027, 743, 21, 68, "Input",ExpressionUUID->"373dc7f9-2811-4ecb-bf10-1f81d13ebf1e",
 InitializationCell->True],
Cell[443903, 12050, 624, 19, 68, "Input",ExpressionUUID->"5f41fd92-0de3-4c1a-8039-06ccb50be5ac",
 InitializationCell->True],
Cell[444530, 12071, 1663, 43, 173, "Input",ExpressionUUID->"fa6d25a3-5ff4-4b90-b79a-ece04457efb7",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[446242, 12120, 168, 4, 38, "Subsection",ExpressionUUID->"d66a530f-898e-4898-9d82-6ab1a5d68045",
 InitializationCell->True,
 InitializationGroup->True],
Cell[446413, 12126, 398, 9, 89, "Input",ExpressionUUID->"1a4aed3f-6f25-4c47-997c-810022e24337",
 InitializationCell->True,
 InitializationGroup->True],
Cell[446814, 12137, 543, 12, 110, "Input",ExpressionUUID->"4b39c936-302b-4a29-b47b-6d4474e7e950",
 InitializationCell->True,
 InitializationGroup->True],
Cell[447360, 12151, 571, 11, 131, "Input",ExpressionUUID->"47aaa4e8-b066-478c-82bd-cf3061049c0a",
 InitializationCell->True],
Cell[447934, 12164, 558, 11, 110, "Input",ExpressionUUID->"7eade852-82e4-459d-9dec-2b232b9b6ca9",
 InitializationCell->True],
Cell[448495, 12177, 301, 7, 46, "Input",ExpressionUUID->"170e24b9-3750-4534-a832-f74ff0fc6144",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[448845, 12190, 249, 6, 36, "Section",ExpressionUUID->"93122e05-014e-4055-b8c9-57e22a9a9c9e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[449119, 12200, 431, 9, 44, "Subsection",ExpressionUUID->"5868d62d-f33a-42cb-8ea3-52d3f163ef2a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[449553, 12211, 298, 6, 109, "Input",ExpressionUUID->"8fc35d09-0284-4ef1-b610-dadde3d7a862",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[449888, 12222, 182, 4, 36, "Subsection",ExpressionUUID->"b1293595-4b40-49c2-86e3-bebe8144e363",
 InitializationCell->True],
Cell[450073, 12228, 648, 19, 39, "Input",ExpressionUUID->"73c438d1-04a2-46ba-99a6-f5f0c69d09b2",
 InitializationCell->True],
Cell[450724, 12249, 1318, 35, 89, "Input",ExpressionUUID->"597ab303-47a5-48c2-b126-dd38f6622803",
 InitializationCell->True],
Cell[452045, 12286, 701, 19, 39, "Input",ExpressionUUID->"022f76c3-8132-4e8f-a745-b2651daaf027",
 InitializationCell->True],
Cell[452749, 12307, 1080, 33, 89, "Input",ExpressionUUID->"b73b4d6f-5ffc-4856-bd25-be86afa92251",
 InitializationCell->True],
Cell[453832, 12342, 1194, 34, 89, "Input",ExpressionUUID->"127bd0cb-eb6b-454e-8421-1cd13eb73455",
 InitializationCell->True],
Cell[455029, 12378, 812, 24, 89, "Input",ExpressionUUID->"c203877b-d722-4b25-8982-e2c8783017fb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[455878, 12407, 370, 8, 36, "Subsection",ExpressionUUID->"5f0812e8-6e9b-4ef3-a06c-290a046584ea",
 InitializationCell->True,
 InitializationGroup->True],
Cell[456251, 12417, 1056, 26, 256, "Input",ExpressionUUID->"00c36a58-bda7-48f4-8f4e-da63b46450c1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[457344, 12448, 238, 5, 36, "Subsection",ExpressionUUID->"40811aaa-54fc-44f4-900a-5b1c616cede9",
 InitializationCell->True],
Cell[457585, 12455, 898, 20, 39, "Input",ExpressionUUID->"dd20763f-f1c5-40cc-8899-0184fde50afd",
 InitializationCell->True],
Cell[458486, 12477, 849, 19, 39, "Input",ExpressionUUID->"8567420c-4c67-4628-be2a-22dca8449a74",
 InitializationCell->True],
Cell[459338, 12498, 1331, 34, 65, "Input",ExpressionUUID->"19363803-ec67-44be-b06e-d9d4f8a28dbd",
 InitializationCell->True],
Cell[460672, 12534, 1326, 35, 65, "Input",ExpressionUUID->"0cda541e-25ab-4752-aeee-0e64a000e05d",
 InitializationCell->True],
Cell[462001, 12571, 1919, 50, 114, "Input",ExpressionUUID->"f0e76096-5707-4db6-91bc-7e6115faba8b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[463957, 12626, 183, 4, 36, "Subsection",ExpressionUUID->"aa16a399-befa-447f-8169-69e477832e1d",
 InitializationCell->True],
Cell[464143, 12632, 551, 11, 109, "Input",ExpressionUUID->"67ccf0b6-3318-40f3-88cd-237bc63a85e4",
 InitializationCell->True],
Cell[464697, 12645, 437, 10, 109, "Input",ExpressionUUID->"e559d01d-c8a8-4e11-baaa-27d020b6e22b",
 InitializationCell->True],
Cell[465137, 12657, 340, 8, 109, "Input",ExpressionUUID->"dab561ca-6f67-404b-be4d-10b7cd642f5e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[465526, 12671, 218, 6, 36, "Section",ExpressionUUID->"5d83c3ae-5b25-4d13-8334-41e4378cd514",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[465769, 12681, 431, 9, 44, "Subsection",ExpressionUUID->"9075d829-5fd6-41da-8027-b611d75fd7a4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[466203, 12692, 319, 7, 126, "Input",ExpressionUUID->"ae769bf8-a048-47e2-8637-774b93deddd2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[466559, 12704, 334, 7, 36, "Subsection",ExpressionUUID->"8e2e140b-3d6c-4333-a021-5f6907c0ca3d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[466896, 12713, 647, 19, 213, "Input",ExpressionUUID->"108c7ef5-cc18-4cfa-8725-6ed1decd2cdf",
 InitializationCell->True],
Cell[467546, 12734, 697, 20, 213, "Input",ExpressionUUID->"d542feb4-5d10-472e-877d-b9d14dc25a15",
 InitializationCell->True],
Cell[468246, 12756, 1153, 35, 383, "Input",ExpressionUUID->"a5d9b503-c388-468f-843d-314769034540",
 InitializationCell->True],
Cell[469402, 12793, 1250, 35, 383, "Input",ExpressionUUID->"7de432ff-418c-43f6-84d1-e2d315b20b93",
 InitializationCell->True],
Cell[470655, 12830, 879, 26, 296, "Input",ExpressionUUID->"603c7428-873c-40df-bd0c-87f37cfd2537",
 InitializationCell->True],
Cell[471537, 12858, 563, 15, 126, "Input",ExpressionUUID->"0f075ab6-3b72-43b5-8187-be7a88ada1f0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[472137, 12878, 370, 8, 36, "Subsection",ExpressionUUID->"42f96726-3520-4a6a-a38b-1bbca7fb14f1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[472510, 12888, 1041, 26, 213, "Input",ExpressionUUID->"a39f42e8-c902-43db-91a7-20c118eab2a7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[473588, 12919, 143, 3, 36, "Subsection",ExpressionUUID->"0de48c80-96db-4114-b39c-44a60ca1f1be",
 InitializationCell->True,
 InitializationGroup->True],
Cell[473734, 12924, 479, 11, 126, "Input",ExpressionUUID->"7af0635c-3133-47f7-acea-cbf8e574a1d1",
 InitializationCell->True],
Cell[474216, 12937, 380, 9, 126, "Input",ExpressionUUID->"b9ad6637-52fe-475e-8972-3d6b560348fa",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[474645, 12952, 271, 7, 36, "Section",ExpressionUUID->"8c61fc88-4524-45dc-8d34-c29da5551ef3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[474941, 12963, 431, 9, 44, "Subsection",ExpressionUUID->"cf0dcf53-55c0-40ff-bef3-7bfdb9b35f94",
 InitializationCell->True,
 InitializationGroup->True],
Cell[475375, 12974, 343, 7, 28, "Input",ExpressionUUID->"1a629984-887b-47c7-af61-4dd6f7c6a8bc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[475755, 12986, 334, 7, 36, "Subsection",ExpressionUUID->"f88394c3-6a0c-4150-8e30-173ddb64eb61",
 InitializationCell->True,
 InitializationGroup->True],
Cell[476092, 12995, 527, 13, 28, "Input",ExpressionUUID->"5c87de4d-c86f-47b5-a459-bf5490913c0d",
 InitializationCell->True],
Cell[476622, 13010, 589, 16, 28, "Input",ExpressionUUID->"fc614027-ce3d-48df-a0f8-760b6e2abd24",
 InitializationCell->True],
Cell[477214, 13028, 678, 17, 46, "Input",ExpressionUUID->"8c619b07-fc68-4a63-92f9-56bf95fe2001",
 InitializationCell->True],
Cell[477895, 13047, 889, 23, 63, "Input",ExpressionUUID->"27c76c02-9231-48e2-886a-300eaae3f376",
 InitializationCell->True],
Cell[478787, 13072, 878, 22, 63, "Input",ExpressionUUID->"5809c947-56c2-4586-823d-459c59edb8b5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[479702, 13099, 370, 8, 36, "Subsection",ExpressionUUID->"5ec60c06-6051-477c-a37f-20ae8b4d6622",
 InitializationCell->True,
 InitializationGroup->True],
Cell[480075, 13109, 1043, 26, 213, "Input",ExpressionUUID->"57154140-4b49-4fa7-ba87-61deb0f70b04",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[481155, 13140, 143, 3, 36, "Subsection",ExpressionUUID->"5d8c3536-b8e1-4f33-8734-1692b47308a3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[481301, 13145, 511, 11, 126, "Input",ExpressionUUID->"feb2059d-4a49-4b3f-abfe-5940d8e6e308",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[481861, 13162, 245, 6, 36, "Section",ExpressionUUID->"b54cafc7-3e3f-451c-b531-b740b8abee25",
 InitializationCell->True,
 InitializationGroup->True],
Cell[482109, 13170, 345, 7, 48, "Input",ExpressionUUID->"11cc3b3a-3cfb-43da-baf3-b8b1b46f0643",
 InitializationCell->True],
Cell[482457, 13179, 1043, 26, 91, "Input",ExpressionUUID->"00c88135-4cb0-4f15-bda7-3d2b19c1fc2b",
 InitializationCell->True],
Cell[483503, 13207, 698, 22, 70, "Input",ExpressionUUID->"7d80d333-c686-4466-b939-964ecac81c65",
 InitializationCell->True],
Cell[484204, 13231, 606, 17, 70, "Input",ExpressionUUID->"7e92a6bb-7846-40dd-80fb-22b0073e03f5",
 InitializationCell->True],
Cell[484813, 13250, 733, 20, 70, "Input",ExpressionUUID->"412a959d-7a81-45fb-88e7-1a1ca09ea772",
 InitializationCell->True],
Cell[485549, 13272, 2827, 67, 364, "Input",ExpressionUUID->"f71f540a-98b4-4cae-ae04-80410a0d7217",
 InitializationCell->True],
Cell[488379, 13341, 580, 17, 70, "Input",ExpressionUUID->"49426a36-d102-4f94-a949-030deb1eff95",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[488996, 13363, 293, 7, 36, "Section",ExpressionUUID->"ff2a3ceb-cd54-4cd5-9936-6951af86e4ba",
 InitializationCell->True,
 InitializationGroup->True],
Cell[489292, 13372, 338, 7, 126, "Input",ExpressionUUID->"b999da16-43d1-44f9-afc4-e3abbbde5263",
 InitializationCell->True],
Cell[489633, 13381, 1030, 25, 296, "Input",ExpressionUUID->"3adeca4e-6a52-45b6-a02f-346d62d4e444",
 InitializationCell->True],
Cell[490666, 13408, 807, 23, 213, "Input",ExpressionUUID->"4518a57d-7402-4811-8a26-a803c773a5b5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[491510, 13436, 401, 8, 36, "Section",ExpressionUUID->"5c0f2498-3256-447d-b488-550a1b98b7bc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[491936, 13448, 278, 5, 44, "Subsection",ExpressionUUID->"745a1cb6-9908-4947-b60a-3d337db4df3e",
 InitializationCell->True],
Cell[492217, 13455, 495, 13, 126, "Input",ExpressionUUID->"c121a034-622c-4572-a2a4-4e3aa31a5a60",
 InitializationCell->True],
Cell[492715, 13470, 461, 10, 199, "Input",ExpressionUUID->"645bf660-accc-4113-85ff-eefc685bc79a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[493213, 13485, 182, 4, 36, "Subsection",ExpressionUUID->"df9f8d07-e333-4ad6-8e13-9c55520e4306",
 InitializationCell->True],
Cell[493398, 13491, 345, 7, 48, "Input",ExpressionUUID->"053dc660-3a9d-488d-a13b-b9bd124e7ada",
 InitializationCell->True],
Cell[493746, 13500, 1099, 26, 112, "Input",ExpressionUUID->"bf7ba6f7-16d5-4066-a15e-acf1a7e099c7",
 InitializationCell->True],
Cell[494848, 13528, 611, 13, 70, "Input",ExpressionUUID->"f6211038-7525-4878-be0e-e85eba5abd27",
 InitializationCell->True],
Cell[495462, 13543, 703, 19, 70, "Input",ExpressionUUID->"42502ac1-4e7a-439a-b0be-25f14ad8f799",
 InitializationCell->True],
Cell[496168, 13564, 1663, 38, 217, "Input",ExpressionUUID->"01e46fe6-7493-4646-9af2-9727ad77450b",
 InitializationCell->True],
Cell[497834, 13604, 2377, 55, 280, "Input",ExpressionUUID->"0bd9dbd0-1f2c-45f9-816a-34f151bf890b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[500248, 13664, 184, 4, 36, "Subsection",ExpressionUUID->"af46eea4-cfdb-489b-b9e0-bcb8909e339b",
 InitializationCell->True],
Cell[500435, 13670, 732, 17, 126, "Input",ExpressionUUID->"60564423-b687-421f-a124-fd0269f291bc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[501204, 13692, 243, 5, 36, "Subsection",ExpressionUUID->"1ef98f9f-99c0-4fac-8b43-598493e8a217",
 InitializationCell->True],
Cell[501450, 13699, 3685, 83, 406, "Input",ExpressionUUID->"902372e1-6616-467a-9435-74be789a13b3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[505172, 13787, 183, 4, 44, "Subsection",ExpressionUUID->"f57885a8-fb99-4101-bdf6-a3512cc67607",
 InitializationCell->True],
Cell[505358, 13793, 410, 10, 126, "Input",ExpressionUUID->"efc8bb07-19b2-4831-9e9f-0b6d8a6a37ff",
 InitializationCell->True],
Cell[505771, 13805, 460, 11, 199, "Input",ExpressionUUID->"15b04056-b3d9-4354-afe1-0172c298e53c",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[506292, 13823, 227, 6, 41, "Subsubtitle",ExpressionUUID->"b83aff3f-4699-4fd5-935f-220656dff023",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[506544, 13833, 313, 7, 36, "Section",ExpressionUUID->"ecf7a0d9-e0a7-45fc-8995-e6d40373123b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[506860, 13842, 420, 11, 46, "Input",ExpressionUUID->"4f892663-471e-4f31-aaa3-8bfa52e8e255",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[507305, 13857, 175, 4, 45, "Subsubsection",ExpressionUUID->"2e0169a7-6efb-4b9d-a4c7-69bd550c8b63",
 InitializationCell->True,
 InitializationGroup->True],
Cell[507483, 13863, 506, 15, 126, "Input",ExpressionUUID->"f48f5a38-ed78-40e2-8e28-281dffbc0862",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[508026, 13883, 245, 6, 37, "Subsubsection",ExpressionUUID->"3aa1f64a-1782-407d-83cc-6a01262e8bf9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[508274, 13891, 696, 18, 68, "Input",ExpressionUUID->"6f2e38af-c9f2-40a7-92f4-1dc00c7a5518",
 InitializationCell->True,
 InitializationGroup->True],
Cell[508973, 13911, 910, 22, 89, "Input",ExpressionUUID->"f83e6eea-f65f-4955-aa69-807aaa8b0698",
 InitializationCell->True],
Cell[509886, 13935, 1377, 31, 173, "Input",ExpressionUUID->"36e6fee0-dc49-419d-892d-5091f28b35be",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[511300, 13971, 497, 8, 45, "Subsubsection",ExpressionUUID->"96c377fe-4472-48c0-b509-1482b3307817",
 InitializationCell->True],
Cell[511800, 13981, 884, 23, 213, "Input",ExpressionUUID->"ea6d6c99-0129-42e2-bc04-3d3254a6cd0b",
 InitializationCell->True],
Cell[512687, 14006, 717, 18, 213, "Input",ExpressionUUID->"6adecdcf-fba7-48bd-af6e-4753c546b920",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[513441, 14029, 562, 9, 37, "Subsubsection",ExpressionUUID->"2bb8bd01-fdad-4596-8c6b-8b280bbe6193",
 InitializationCell->True],
Cell[514006, 14040, 1330, 35, 632, "Input",ExpressionUUID->"d549d72e-b5d8-49ef-923f-8fae781e4831",
 InitializationCell->True],
Cell[515339, 14077, 1019, 25, 303, "Input",ExpressionUUID->"b9f5f1bc-2780-4f15-b11d-3baced6b45eb",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[516407, 14108, 474, 9, 39, "Section",ExpressionUUID->"1ffdee26-fe2f-412d-870d-aa7160a24dbc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[516906, 14121, 179, 4, 35, "Subsubsection",ExpressionUUID->"ef2814ec-5276-4e6d-81f7-b06dd8d49cdc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[517088, 14127, 420, 9, 49, "Text",ExpressionUUID->"bb18a887-8933-48fb-9a80-449c883260f6",
 InitializationCell->True],
Cell[517511, 14138, 1324, 29, 133, "Input",ExpressionUUID->"27643a5c-0da8-4e2e-b307-9514f5ec0bf9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[518872, 14172, 224, 6, 29, "Subsubsection",ExpressionUUID->"f778c11c-c91d-420c-9356-c059d2a6431f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[519099, 14180, 1382, 31, 91, "Input",ExpressionUUID->"94c818a7-8500-4988-bf53-b7058f444add",
 InitializationCell->True,
 InitializationGroup->True],
Cell[520484, 14213, 1358, 31, 91, "Input",ExpressionUUID->"93e7dfe4-ff24-4f5f-bd7b-faea4fe27ab4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[521879, 14249, 271, 6, 29, "Subsubsection",ExpressionUUID->"14b97574-e835-47c1-929a-8216ed99cdf5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[522153, 14257, 1297, 33, 112, "Input",ExpressionUUID->"ac8248cc-f765-4b3b-9525-9742c26c00e3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[523487, 14295, 171, 4, 29, "Subsubsection",ExpressionUUID->"bbdfea23-c1f6-49de-a5f2-c2c4095eb428",
 InitializationCell->True,
 InitializationGroup->True],
Cell[523661, 14301, 699, 18, 213, "Input",ExpressionUUID->"ef397f42-06a8-4fc3-b49d-1b0d061841d9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[524397, 14324, 175, 4, 29, "Subsubsection",ExpressionUUID->"f4027349-fe0b-4fed-947e-b50cdaee3155",
 InitializationCell->True,
 InitializationGroup->True],
Cell[524575, 14330, 224, 6, 141, "Text",ExpressionUUID->"25f5d63c-38be-4055-9c4c-23566899e045",
 InitializationCell->True,
 InitializationGroup->True],
Cell[524802, 14338, 272, 7, 141, "Text",ExpressionUUID->"6150085d-0597-4807-b3d5-089ba253e092",
 InitializationCell->True],
Cell[525077, 14347, 1206, 30, 384, "Input",ExpressionUUID->"34447b4e-cf2e-4448-bccf-5eb79dbd3192",
 InitializationCell->True,
 InitializationGroup->True],
Cell[526286, 14379, 1173, 30, 384, "Input",ExpressionUUID->"428bdb9c-a290-429e-a52a-0eccd42e68fe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[527462, 14411, 1011, 24, 303, "Input",ExpressionUUID->"9f9acd9e-df83-4827-8d87-c460fd4f6de6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[528522, 14441, 333, 6, 39, "Section",ExpressionUUID->"155eea5c-0390-45fa-b974-c108ca14c229",
 InitializationCell->True,
 InitializationGroup->True],
Cell[528858, 14449, 313, 7, 228, "Text",ExpressionUUID->"d02647a4-a5a3-42bd-b9e0-44d4c0d62c6c",
 InitializationCell->True],
Cell[529174, 14458, 661, 17, 213, "Input",ExpressionUUID->"58fd592d-2cdf-416f-b5f1-caa87cb21b0c",
 InitializationCell->True],
Cell[529838, 14477, 705, 18, 213, "Input",ExpressionUUID->"13d66ae9-afa7-4c5d-9c75-b67699bd0b0f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[530580, 14500, 253, 5, 39, "Section",ExpressionUUID->"0cd28183-e439-4a8d-9f44-6733564b6c4b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[530858, 14509, 549, 9, 39, "Subsubsection",ExpressionUUID->"7c171bb7-d2cb-4494-bebe-d933a9505ede",
 InitializationCell->True],
Cell[531410, 14520, 294, 7, 30, "Text",ExpressionUUID->"5ad2cda1-8e3b-4762-b4c0-8ef0f4ac2d54",
 InitializationCell->True],
Cell[531707, 14529, 4999, 113, 484, "Input",ExpressionUUID->"dcf7aff2-8318-4c43-8768-50408c02b8b9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[536743, 14647, 529, 10, 61, "Subsubsection",ExpressionUUID->"0778c902-45d4-4009-8439-41e85e03d80f",
 InitializationCell->True],
Cell[537275, 14659, 2995, 59, 180, "Input",ExpressionUUID->"db24369b-140d-471b-ab28-89aa6a75d082",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[540307, 14723, 512, 10, 61, "Subsubsection",ExpressionUUID->"48595ea0-e133-4fb6-83a4-54812ccc2be6",
 InitializationCell->True],
Cell[540822, 14735, 1009, 22, 66, "Input",ExpressionUUID->"cb73098b-773f-4158-ae4f-2e6ebc35271f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[541834, 14759, 944, 23, 66, "Input",ExpressionUUID->"4aa5faa2-ca9a-475e-866e-42e5f19795b5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[542815, 14787, 458, 9, 61, "Subsubsection",ExpressionUUID->"2e3640f8-9534-4593-853b-c93e30578139",
 InitializationCell->True],
Cell[543276, 14798, 1656, 37, 85, "Input",ExpressionUUID->"003400e2-73ed-41ee-845e-41f22861cd3d",
 InitializationCell->True],
Cell[544935, 14837, 2144, 50, 104, "Input",ExpressionUUID->"6693c423-523e-495c-845b-e0f7fc04debc",
 InitializationCell->True],
Cell[547082, 14889, 1970, 45, 104, "Input",ExpressionUUID->"ced40c01-d638-4241-afe4-ac4d0c4f0d80",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[549089, 14939, 502, 9, 33, "Subsubsection",ExpressionUUID->"487b461a-978b-4581-aff8-a521b12e48c8",
 InitializationCell->True],
Cell[549594, 14950, 833, 23, 383, "Input",ExpressionUUID->"cde47d10-8091-4f85-b8a5-d15647fb3c62",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[550476, 14979, 382, 8, 39, "Section",ExpressionUUID->"cd7a5c6b-1e23-400c-b6bd-cf9721be4355",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[550883, 14991, 366, 8, 44, "Subsection",ExpressionUUID->"5bc3591c-1480-4ded-a32c-e20df6d47a4f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[551252, 15001, 1205, 30, 91, "Input",ExpressionUUID->"55f35c3d-218f-4782-a778-f991facdf9df",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[552494, 15036, 438, 9, 44, "Subsection",ExpressionUUID->"f89730e1-5cb7-4ca0-88be-dcb16b40fc82",
 InitializationCell->True,
 InitializationGroup->True],
Cell[552935, 15047, 1094, 27, 213, "Input",ExpressionUUID->"8074fbc4-cb15-4b1d-9363-786d41dd0ee0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[554078, 15080, 492, 9, 39, "Section",ExpressionUUID->"89a393c1-eb67-4623-ae5c-1d24c2253dce",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[554595, 15093, 423, 8, 208, "Subsection",ExpressionUUID->"fb9f9f5c-cd16-4501-80fa-d7a45c1e1233",
 InitializationCell->True,
 InitializationGroup->True],
Cell[555021, 15103, 207, 4, 141, "Text",ExpressionUUID->"e5a70a46-7945-4d0c-af22-767c95023599",
 InitializationCell->True],
Cell[555231, 15109, 3846, 82, 1284, "Input",ExpressionUUID->"31ef056d-9552-4449-bfe7-c4f695e67576",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[559114, 15196, 472, 9, 164, "Subsection",ExpressionUUID->"77af8294-8378-4061-ba0d-d844a6211b40",
 InitializationCell->True,
 InitializationGroup->True],
Cell[559589, 15207, 2839, 65, 954, "Input",ExpressionUUID->"c85cd253-3f84-49cf-8e3a-4e1a7bae8593",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[562477, 15278, 577, 10, 39, "Section",ExpressionUUID->"f3b113d0-4528-4350-bb96-660441a1eb65",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[563079, 15292, 192, 4, 163, "Subsubsection",ExpressionUUID->"14e5b23b-7cae-4cb7-a5c5-87dcb6eb88d4",
 InitializationCell->True],
Cell[563274, 15298, 827, 23, 296, "Input",ExpressionUUID->"96ee6e74-7fce-4282-b4f7-c4d22c3779df",
 InitializationCell->True],
Cell[564104, 15323, 711, 19, 213, "Input",ExpressionUUID->"fd8517f0-75bc-4aa8-9dd2-e5db3b98d178",
 InitializationCell->True],
Cell[564818, 15344, 793, 22, 296, "Input",ExpressionUUID->"ab184707-465b-410d-8f8d-9d840c182999",
 InitializationCell->True],
Cell[565614, 15368, 758, 20, 213, "Input",ExpressionUUID->"02b4f0eb-3c1f-4724-b810-59e071a5fa15",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[566409, 15393, 194, 4, 163, "Subsubsection",ExpressionUUID->"2ef5848b-f093-4aec-861e-014d29f8af83",
 InitializationCell->True],
Cell[566606, 15399, 876, 24, 296, "Input",ExpressionUUID->"5f1c5b96-0318-4ff0-a52b-1ee4b45d5f04",
 InitializationCell->True],
Cell[567485, 15425, 760, 20, 213, "Input",ExpressionUUID->"d2483d51-e664-45f1-9038-4aa7c1f27700",
 InitializationCell->True],
Cell[568248, 15447, 842, 23, 296, "Input",ExpressionUUID->"afb84d97-275b-42c6-bdb0-8c2131641d91",
 InitializationCell->True],
Cell[569093, 15472, 807, 21, 213, "Input",ExpressionUUID->"b7eee129-763e-4623-a794-6ed623c487f1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[569949, 15499, 710, 12, 39, "Section",ExpressionUUID->"87991234-59ca-4816-892b-75fd75b92c2d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[570684, 15515, 269, 5, 43, "Subsection",ExpressionUUID->"702c3491-f175-485e-a8d4-ab46d9cd33d4",
 InitializationCell->True],
Cell[570956, 15522, 2590, 65, 220, "Input",ExpressionUUID->"3cc10dce-bf38-4324-8b4d-9ebe0a4e467a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[573583, 15592, 268, 5, 43, "Subsection",ExpressionUUID->"c508ec7b-36c8-4751-81cf-6a2689533153",
 InitializationCell->True],
Cell[573854, 15599, 1901, 49, 200, "Input",ExpressionUUID->"7f996789-2ea9-4552-afad-1a6347e0fe71",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[575804, 15654, 677, 12, 39, "Section",ExpressionUUID->"37c9f83d-a8ae-4dfc-aa81-bbb5ec8c892a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[576506, 15670, 291, 5, 43, "Subsection",ExpressionUUID->"38fa1e55-fc0d-4109-a97e-69367e7d3043",
 InitializationCell->True],
Cell[576800, 15677, 476, 11, 46, "Input",ExpressionUUID->"d4330b20-128a-4e02-98e5-9955ee34a4ce",
 InitializationCell->True],
Cell[577279, 15690, 384, 8, 46, "Input",ExpressionUUID->"a844a10d-4020-42fe-a75e-2665af9ce209",
 InitializationCell->True],
Cell[577666, 15700, 467, 12, 48, "Input",ExpressionUUID->"8e507a24-38df-4e97-82f1-22631f196d70",
 InitializationCell->True],
Cell[578136, 15714, 659, 17, 48, "Input",ExpressionUUID->"95963a5f-125b-4199-907e-7fb993751d45",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[578832, 15736, 356, 6, 35, "Subsection",ExpressionUUID->"5b856f28-c89d-4bd7-824f-0b956a9e6ea4",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[579213, 15746, 363, 6, 34, "Subsubsection",ExpressionUUID->"f46259d5-8ed7-462c-a3c0-634ef6b4287d",
 InitializationCell->True],
Cell[579579, 15754, 1571, 34, 86, "Input",ExpressionUUID->"3f947ff7-3c00-4be0-b139-e98107e2ffde",
 InitializationCell->True],
Cell[581153, 15790, 1059, 28, 86, "Input",ExpressionUUID->"af9921ff-bf51-4eae-92d0-2e189501828f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[582249, 15823, 325, 8, 57, "Subsubsection",ExpressionUUID->"c8b5463f-c231-452e-a9dd-729b3014c28b",
 InitializationCell->True],
Cell[582577, 15833, 3110, 65, 219, "Input",ExpressionUUID->"23f15388-8fa4-42eb-a893-729a6e8d03b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[585724, 15903, 413, 7, 34, "Subsubsection",ExpressionUUID->"28001573-8db0-492d-aaac-0546b8e7a412",
 InitializationCell->True],
Cell[586140, 15912, 1071, 27, 296, "Input",ExpressionUUID->"1c94710f-e96f-4bc5-979d-7967de7c66e4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[587260, 15945, 278, 5, 43, "Subsection",ExpressionUUID->"6ec755da-af7f-48c2-8a0c-7240bd0c9539",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[587563, 15954, 420, 7, 34, "Subsubsection",ExpressionUUID->"cc13e4c5-9544-4c5c-a59b-8370507f8bf0",
 InitializationCell->True],
Cell[587986, 15963, 965, 23, 303, "Input",ExpressionUUID->"5dc89a4a-96c0-4984-9970-4a350b9fb987",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[588988, 15991, 416, 7, 28, "Subsubsection",ExpressionUUID->"b53576c4-9f05-4a76-b676-b3b30be4b936",
 InitializationCell->True],
Cell[589407, 16000, 712, 20, 213, "Input",ExpressionUUID->"a021bbd8-26fc-4853-880d-947e5ace6f10",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[590156, 16025, 367, 8, 51, "Subsubsection",ExpressionUUID->"4aa56199-cd11-42bd-a549-3855705c8d5e",
 InitializationCell->True],
Cell[590526, 16035, 3344, 74, 315, "Input",ExpressionUUID->"31c4deec-d0da-4e95-9cb6-4a6fa8411ebe",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[593907, 16114, 299, 7, 57, "Subsubsection",ExpressionUUID->"d04601f8-b133-47a9-bd73-8fd9195ccf00",
 InitializationCell->True],
Cell[594209, 16123, 1411, 36, 125, "Input",ExpressionUUID->"22a7c948-9fd1-4e2b-ae64-1fda27251fd8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[595657, 16164, 238, 5, 34, "Subsubsection",ExpressionUUID->"b91e273c-a47b-45d3-b2c1-70d4d10d616f",
 InitializationCell->True],
Cell[595898, 16171, 716, 18, 296, "Input",ExpressionUUID->"47d23764-2669-47b9-a851-72b4946ff4f6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[596651, 16194, 286, 5, 28, "Subsubsection",ExpressionUUID->"b3400ac3-6b9e-44d9-a900-5247b793573d",
 InitializationCell->True],
Cell[596940, 16201, 737, 19, 296, "Input",ExpressionUUID->"d4323c7d-3093-4945-8dce-da6c43c5b69d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[597726, 16226, 290, 5, 43, "Subsection",ExpressionUUID->"2f2f3f0c-871e-491c-8c99-be245c5ad59b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[598041, 16235, 277, 7, 57, "Subsubsection",ExpressionUUID->"f413e51e-22de-491c-9676-cf38a24e9904",
 InitializationCell->True],
Cell[598321, 16244, 1711, 41, 105, "Input",ExpressionUUID->"2ac31aba-ca99-4f5a-b400-6f4f05544994",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[600069, 16290, 180, 4, 34, "Subsubsection",ExpressionUUID->"63103e0d-3833-4432-a3dd-7da719ee30f5",
 InitializationCell->True],
Cell[600252, 16296, 2082, 49, 123, "Input",ExpressionUUID->"6a374e8c-47f2-4329-8ae5-16da8c69483f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[602371, 16350, 496, 11, 34, "Subsubsection",ExpressionUUID->"2892a124-b2d9-44ad-ab2c-3d88ec1955c1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[602870, 16363, 2741, 67, 180, "Input",ExpressionUUID->"b7bec108-ac58-4e18-aa3d-63adffa16606",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[605648, 16435, 519, 11, 34, "Subsubsection",ExpressionUUID->"c185cc7e-6c9c-49e3-a36d-1fab29aa963f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[606170, 16448, 2768, 67, 180, "Input",ExpressionUUID->"42fd3747-fdf4-4df1-aeb5-64bbfd757f92",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[608975, 16520, 541, 12, 34, "Subsubsection",ExpressionUUID->"0e9c5cb6-d09e-435c-aeb3-2721d84d6a2d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[609519, 16534, 1547, 37, 104, "Input",ExpressionUUID->"1377d2f9-d9f0-40e7-8f05-085dd86e536a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[611103, 16576, 588, 12, 38, "Subsubsection",ExpressionUUID->"8af20e1f-d5fe-45ac-84bf-f872abec191a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[611694, 16590, 1636, 40, 104, "Input",ExpressionUUID->"c82914f4-603f-41e6-be09-f4936b16ef9c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[613367, 16635, 501, 11, 34, "Subsubsection",ExpressionUUID->"96771d5c-7cd4-4737-a0b8-183debe6969a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[613871, 16648, 1479, 33, 66, "Input",ExpressionUUID->"1a1a8567-0faa-48c4-a983-1f829969d2d8",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[615387, 16686, 551, 12, 34, "Subsubsection",ExpressionUUID->"5bd0f522-0474-46bc-bfe6-237611571565",
 InitializationCell->True,
 InitializationGroup->True],
Cell[615941, 16700, 1505, 34, 66, "Input",ExpressionUUID->"cb8de8d6-f43e-43e0-9cae-807ec8b77870",
 InitializationCell->True,
 InitializationGroup->True],
Cell[617449, 16736, 1550, 36, 85, "Input",ExpressionUUID->"4a977c6a-62dc-4b60-bffb-fb50cf61089e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[619036, 16777, 197, 4, 34, "Subsubsection",ExpressionUUID->"ae4bb82c-1be6-4a55-80e7-ae93f4ed0020",
 InitializationCell->True],
Cell[619236, 16783, 1365, 36, 105, "Input",ExpressionUUID->"f09657ca-0586-4d2a-a88f-39ff832cde59",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[620662, 16826, 350, 6, 39, "Section",ExpressionUUID->"55ae675a-6563-4861-8648-ba5fd49d86d7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[621015, 16834, 244, 5, 141, "Text",ExpressionUUID->"0583159b-3fe9-4d3b-b8e8-835b6c162bc5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[621262, 16841, 248, 6, 141, "Text",ExpressionUUID->"efa20ae4-8cce-4d42-bed9-f6497b7209c4",
 InitializationCell->True],
Cell[621513, 16849, 1934, 45, 384, "Input",ExpressionUUID->"c05ea92a-de6a-4e34-99fd-66d4f6b226db",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[623484, 16899, 357, 7, 39, "Section",ExpressionUUID->"3417a560-bd1e-46d9-b912-ffddb4c9a2db",
 InitializationCell->True,
 InitializationGroup->True],
Cell[623844, 16908, 432, 10, 213, "Input",ExpressionUUID->"fc0bbacb-3502-47e6-a22a-400de18808ae",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[624325, 16924, 357, 8, 41, "Subsubtitle",ExpressionUUID->"f4cd0790-3ba5-43bc-bcdb-a4e377d9d77e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[624707, 16936, 291, 7, 54, "Subsection",ExpressionUUID->"0ef35f97-3490-4cdf-9a81-27c7fb9bc13b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[625023, 16947, 213, 5, 45, "Subsubsection",ExpressionUUID->"fa74540f-4545-4ce0-b716-13a046a12c1a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[625239, 16954, 389, 11, 48, "Input",ExpressionUUID->"c7888b55-bbcd-48ca-be09-694227ee6dd2",
 InitializationCell->True],
Cell[625631, 16967, 468, 13, 48, "Input",ExpressionUUID->"3a307b1d-f115-40c6-935e-26e30a6383bc",
 InitializationCell->True],
Cell[626102, 16982, 915, 20, 133, "Input",ExpressionUUID->"575a513c-e70d-484f-b0bb-33b6ef430d39",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[627054, 17007, 289, 6, 37, "Subsubsection",ExpressionUUID->"d775fc62-96ff-4e07-bcdc-47c069a28f99",
 InitializationCell->True,
 InitializationGroup->True],
Cell[627346, 17015, 804, 20, 70, "Input",ExpressionUUID->"209e2e49-8c05-4dd5-a182-d5a8fe2642c8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[628187, 17040, 287, 6, 37, "Subsubsection",ExpressionUUID->"06b52349-f3e0-42d3-8287-c19a62cf5cc8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[628477, 17048, 2254, 51, 196, "Input",ExpressionUUID->"a8377792-0ee6-4585-aa69-f0a73eb5f07f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[630768, 17104, 242, 5, 37, "Subsubsection",ExpressionUUID->"5ebf437d-146a-4b44-9f52-6a75e2ad2619",
 InitializationCell->True,
 InitializationGroup->True],
Cell[631013, 17111, 662, 16, 48, "Input",ExpressionUUID->"c16ca1d8-b7eb-4bea-b7f4-056f441a68f9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[631712, 17132, 153, 3, 37, "Subsubsection",ExpressionUUID->"aa9132b8-abb8-4df2-9760-9a951658edf7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[631868, 17137, 815, 19, 213, "Input",ExpressionUUID->"b40ea3e9-6e0b-4bd7-8c61-abeef70575c3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[632720, 17161, 209, 5, 37, "Subsubsection",ExpressionUUID->"c80bc9ca-ba23-47f9-a057-937a29663e15",
 InitializationCell->True,
 InitializationGroup->True],
Cell[632932, 17168, 251, 5, 35, "Text",ExpressionUUID->"e67d5e30-75d6-46b8-a1bf-f14ac090870c",
 InitializationCell->True],
Cell[633186, 17175, 2151, 48, 173, "Input",ExpressionUUID->"c1b6eba8-c8ba-46aa-9249-26cecd93134f",
 InitializationCell->True],
Cell[635340, 17225, 1451, 36, 173, "Input",ExpressionUUID->"96bad9ce-598e-488d-9f8d-d9d9adf8b049",
 InitializationCell->True],
Cell[636794, 17263, 1744, 42, 104, "Input",ExpressionUUID->"5409d378-2153-4e81-a8fc-bb30416b6b3a",
 InitializationCell->True],
Cell[638541, 17307, 1507, 37, 104, "Input",ExpressionUUID->"d162e9a6-a90f-44d9-b3e6-d911d2b7302d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[640085, 17349, 147, 3, 37, "Subsubsection",ExpressionUUID->"a230bd5a-5508-4e05-9b75-af2de21b0560",
 InitializationCell->True,
 InitializationGroup->True],
Cell[640235, 17354, 1456, 31, 296, "Input",ExpressionUUID->"d2e51c9c-c12f-4a75-8652-0a6699f3a699",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[641728, 17390, 147, 3, 37, "Subsubsection",ExpressionUUID->"fbdae515-64d2-4db3-b314-974214e9f755",
 InitializationCell->True,
 InitializationGroup->True],
Cell[641878, 17395, 1298, 29, 296, "Input",ExpressionUUID->"5ce65d84-b3ff-4294-a3cb-f6413c1ef91d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[643213, 17429, 243, 6, 37, "Subsubsection",ExpressionUUID->"5cade890-f720-4d74-8959-5bbc84acfb06",
 InitializationCell->True,
 InitializationGroup->True],
Cell[643459, 17437, 605, 14, 126, "Input",ExpressionUUID->"b0445d53-5685-4021-a301-f004360fb396",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[644113, 17457, 246, 6, 38, "Subsection",ExpressionUUID->"b328f40e-db7d-4e79-87e7-0fc94a6d826d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[644384, 17467, 213, 5, 45, "Subsubsection",ExpressionUUID->"beb7d2fd-3563-4ca3-94b4-500517361f47",
 InitializationCell->True,
 InitializationGroup->True],
Cell[644600, 17474, 369, 10, 48, "Input",ExpressionUUID->"9cb58a7f-5471-41c1-857a-dc1ab1690483",
 InitializationCell->True],
Cell[644972, 17486, 883, 18, 48, "Input",ExpressionUUID->"f8d82e41-c205-4156-ab51-ff5adaeb251e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[645858, 17506, 894, 20, 70, "Input",ExpressionUUID->"34d15f9b-ea64-40bc-877b-8d561174c2c3",
 InitializationCell->True],
Cell[646755, 17528, 900, 22, 154, "Input",ExpressionUUID->"caccec8d-5f6f-4728-bdb6-2f5bf9a6191e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[647692, 17555, 242, 5, 37, "Subsubsection",ExpressionUUID->"15bcde6d-7423-457b-a734-a86347378e18",
 InitializationCell->True,
 InitializationGroup->True],
Cell[647937, 17562, 586, 14, 126, "Input",ExpressionUUID->"e7300878-ab24-4190-b723-074dc714cb3d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[648560, 17581, 152, 3, 37, "Subsubsection",ExpressionUUID->"788da9d7-7f49-4881-bd3c-58cdeef6162f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[648715, 17586, 584, 14, 126, "Input",ExpressionUUID->"9b334a9a-8e6c-4118-bb60-316e55cd2587",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[649336, 17605, 203, 4, 37, "Subsubsection",ExpressionUUID->"3f0b2e73-b10e-4f27-9491-b1f499410592",
 InitializationCell->True],
Cell[649542, 17611, 1431, 33, 296, "Input",ExpressionUUID->"de954bb2-7750-470f-b69b-716e5b147ee8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[650976, 17646, 1382, 30, 383, "Input",ExpressionUUID->"b147989d-092e-4160-a3f4-665208f5450c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[652361, 17678, 1479, 34, 383, "Input",ExpressionUUID->"936ab876-9463-4ece-b30f-e440ed726b10",
 InitializationCell->True,
 InitializationGroup->True],
Cell[653843, 17714, 1475, 33, 296, "Input",ExpressionUUID->"c7f383ac-aa19-421d-aba4-ff94a74347cd",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[655355, 17752, 147, 3, 37, "Subsubsection",ExpressionUUID->"7d1bf19b-1b5c-415f-b118-2e3ce76e1826",
 InitializationCell->True,
 InitializationGroup->True],
Cell[655505, 17757, 1199, 25, 296, "Input",ExpressionUUID->"80b0a572-50f4-4f70-8a94-61137a2a6ab6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[656741, 17787, 147, 3, 37, "Subsubsection",ExpressionUUID->"662173a0-8d9f-4734-b375-da5c101f2389",
 InitializationCell->True,
 InitializationGroup->True],
Cell[656891, 17792, 1049, 23, 296, "Input",ExpressionUUID->"2cd00959-b2d0-4db3-98f5-179826e6d214",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[657977, 17820, 243, 6, 37, "Subsubsection",ExpressionUUID->"48867fa6-d2a0-4b18-a62f-633b71f8ab40",
 InitializationCell->True,
 InitializationGroup->True],
Cell[658223, 17828, 573, 13, 126, "Input",ExpressionUUID->"89976b68-7400-442c-a635-3c9b866d7a19",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[658857, 17848, 183, 4, 41, "Subsubtitle",ExpressionUUID->"6a08c362-12d4-4327-9920-f6d7e8f77d7d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[659065, 17856, 167, 4, 33, "Section",ExpressionUUID->"d1a52934-de4c-41e9-a8ec-d24079136ee4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[659235, 17862, 522, 16, 213, "Input",ExpressionUUID->"ce846045-db2a-48a9-b5cb-40cb7b64a837",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[659794, 17883, 171, 4, 33, "Section",ExpressionUUID->"5c6d00df-e547-4096-b102-fc9e53ccf5e5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[659990, 17891, 167, 4, 44, "Subsection",ExpressionUUID->"9abded02-072f-4b05-9c9c-970f6040e1c3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[660182, 17899, 175, 4, 35, "Subsubsection",ExpressionUUID->"f7d372bb-eb02-4640-9fa4-facdb4055980",
 InitializationCell->True,
 InitializationGroup->True],
Cell[660360, 17905, 550, 16, 126, "Input",ExpressionUUID->"5f72eaa5-cdc3-4231-8fc6-dfca91648c82",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[660959, 17927, 447, 9, 36, "Subsection",ExpressionUUID->"a5630dc6-ad5c-4fb7-9512-fd0ba7706a06",
 InitializationCell->True,
 InitializationGroup->True],
Cell[661409, 17938, 462, 13, 48, "Input",ExpressionUUID->"8b8bce6e-6292-4d82-8bf1-c216d19d5d8e",
 InitializationCell->True],
Cell[661874, 17953, 517, 14, 48, "Input",ExpressionUUID->"4305ccad-29a6-4485-b7b0-e5ea1514db7c",
 InitializationCell->True],
Cell[662394, 17969, 1482, 39, 175, "Input",ExpressionUUID->"d65747af-a12a-49b6-9391-f377c837a2d3",
 InitializationCell->True],
Cell[663879, 18010, 1534, 40, 175, "Input",ExpressionUUID->"81229648-0643-48ba-822f-24269df6f3a2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[665450, 18055, 426, 8, 44, "Subsection",ExpressionUUID->"8b3790cc-814b-43dc-9343-393f080c7bab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[665879, 18065, 3346, 78, 250, "Input",ExpressionUUID->"fb3700c1-e027-4dab-93b1-a1a8a5fa0b74",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[669262, 18148, 398, 8, 36, "Subsection",ExpressionUUID->"ace6ddf4-380f-4317-986b-5aaecdba4def",
 InitializationCell->True,
 InitializationGroup->True],
Cell[669663, 18158, 304, 8, 126, "Input",ExpressionUUID->"d3bab8c5-db72-48e4-b524-3cf539efa213",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[670004, 18171, 289, 7, 36, "Subsection",ExpressionUUID->"627de39a-072f-4df8-becf-46eacde7ba52",
 InitializationCell->True,
 InitializationGroup->True],
Cell[670296, 18180, 398, 10, 126, "Input",ExpressionUUID->"2daadf0b-6fbe-44b1-90b3-97a113c16804",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[670743, 18196, 216, 6, 33, "Section",ExpressionUUID->"287a3dc6-de43-4fc3-861f-6b03115543b6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[670962, 18204, 512, 14, 48, "Input",ExpressionUUID->"0afacb54-efcc-4928-ad5f-2bade1cca75d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[671477, 18220, 407, 10, 48, "Input",ExpressionUUID->"b2be5f14-9ed9-48cc-b37d-7c9bbcd84a55",
 InitializationCell->True],
Cell[671887, 18232, 1125, 27, 91, "Input",ExpressionUUID->"d8247d2b-4dbe-4d63-9987-3062dfe22944",
 InitializationCell->True,
 InitializationGroup->True],
Cell[673015, 18261, 601, 17, 48, "Input",ExpressionUUID->"cf6fec06-d847-4516-ba29-3682b5c03358",
 InitializationCell->True,
 InitializationGroup->True],
Cell[673619, 18280, 600, 17, 48, "Input",ExpressionUUID->"03775031-7471-42cd-a6b1-70e27c793e12",
 InitializationCell->True,
 InitializationGroup->True],
Cell[674222, 18299, 1090, 30, 133, "Input",ExpressionUUID->"3890832f-3322-43c8-81ae-8dba131ba1b3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[675315, 18331, 285, 7, 48, "Input",ExpressionUUID->"d5184964-de00-469d-8f6b-0540800d9724",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[675637, 18343, 260, 7, 33, "Section",ExpressionUUID->"72aff6d8-568d-4bd5-a8bc-2cc00af92072",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[675922, 18354, 167, 4, 208, "Subsection",ExpressionUUID->"352453c4-9034-4611-a246-e34ff318cd96",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[676114, 18362, 175, 4, 163, "Subsubsection",ExpressionUUID->"7232c035-1164-47ed-8846-b45702ec7f7e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[676292, 18368, 333, 10, 126, "Input",ExpressionUUID->"5927491f-bd49-4a0d-bb77-298e98ca323c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[676662, 18383, 245, 6, 135, "Subsubsection",ExpressionUUID->"15ef8ef3-af8b-42d8-a8b0-e11cc381fd05",
 InitializationCell->True,
 InitializationGroup->True],
Cell[676910, 18391, 537, 14, 213, "Input",ExpressionUUID->"11117a04-a151-4376-82f0-e8b469b79444",
 InitializationCell->True,
 InitializationGroup->True],
Cell[677450, 18407, 867, 21, 296, "Input",ExpressionUUID->"bb9314bc-9f49-413e-ad72-962f81bd768c",
 InitializationCell->True],
Cell[678320, 18430, 1355, 31, 629, "Input",ExpressionUUID->"5d412982-cfc6-43c7-8f68-1c02eb5acaee",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[679712, 18466, 179, 4, 135, "Subsubsection",ExpressionUUID->"07a166b1-bf1b-4423-9efd-5a9c4bb29792",
 InitializationCell->True,
 InitializationGroup->True],
Cell[679894, 18472, 892, 22, 462, "Input",ExpressionUUID->"e42ce3cb-2f05-4d77-a0e5-a028a5f5041d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[680823, 18499, 192, 4, 135, "Subsubsection",ExpressionUUID->"3b824620-d77f-44ea-8c3f-0c51513ebdf9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[681018, 18505, 995, 26, 296, "Input",ExpressionUUID->"2d002509-768c-494e-b948-11197ab5a464",
 InitializationCell->True,
 InitializationGroup->True],
Cell[682016, 18533, 973, 26, 296, "Input",ExpressionUUID->"9863a587-f246-4d03-940f-837286562fe5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[683026, 18564, 182, 4, 135, "Subsubsection",ExpressionUUID->"8003b0d3-b709-4b33-a410-5cfb375e4b63",
 InitializationCell->True,
 InitializationGroup->True],
Cell[683211, 18570, 820, 21, 213, "Input",ExpressionUUID->"c9aba393-3408-40c0-9c7e-c81015df1e42",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[684068, 18596, 171, 4, 135, "Subsubsection",ExpressionUUID->"8bd85de3-de16-49c0-9bc3-5a4fc7c93155",
 InitializationCell->True,
 InitializationGroup->True],
Cell[684242, 18602, 638, 16, 213, "Input",ExpressionUUID->"2a07d9a3-dabc-4d2b-a888-1c8748ae5ea7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[684917, 18623, 175, 4, 163, "Subsubsection",ExpressionUUID->"b1e3e1b6-511d-4150-a35f-0709ed8606ee",
 InitializationCell->True,
 InitializationGroup->True],
Cell[685095, 18629, 286, 8, 141, "Text",ExpressionUUID->"cc2cba6e-1670-4c7d-9efe-e71e541b96f4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[685384, 18639, 1378, 31, 303, "Input",ExpressionUUID->"16e7369f-ca72-48ea-a318-9ac147a0ba92",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[686811, 18676, 246, 6, 208, "Subsection",ExpressionUUID->"018275cb-88b2-4314-93a5-c306e27c9eab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[687060, 18684, 716, 17, 213, "Input",ExpressionUUID->"76deb6c4-ed89-4a10-81fe-c0b8ed65f193",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[687825, 18707, 308, 8, 33, "Section",ExpressionUUID->"b7e40b49-c5e9-4955-ac71-bfd6226e9a3c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[688158, 18719, 167, 4, 208, "Subsection",ExpressionUUID->"1a25e441-f8ed-4ffa-bfc6-c87065ab77fb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[688350, 18727, 175, 4, 163, "Subsubsection",ExpressionUUID->"c8bae37f-040d-468b-b610-9bf3e28db67f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[688528, 18733, 354, 10, 126, "Input",ExpressionUUID->"c797102f-51ee-4451-bc9b-e871d5c75720",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[688919, 18748, 245, 6, 163, "Subsubsection",ExpressionUUID->"36776456-58fa-458f-9cfe-ea9c6047f91d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[689167, 18756, 583, 14, 213, "Input",ExpressionUUID->"a2b40f80-0df8-4205-894b-8dcd583d6565",
 InitializationCell->True,
 InitializationGroup->True],
Cell[689753, 18772, 887, 21, 296, "Input",ExpressionUUID->"2ca8b11e-9975-4c1d-9fdb-a163d4bdad44",
 InitializationCell->True],
Cell[690643, 18795, 1402, 31, 629, "Input",ExpressionUUID->"06fd8dc8-3992-4695-b08d-cbddd29f9c01",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[692094, 18832, 246, 6, 164, "Subsection",ExpressionUUID->"5c81ce49-dd07-4b84-8f76-16ff1945bffe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[692343, 18840, 983, 22, 213, "Input",ExpressionUUID->"79c491cf-4e15-4822-b895-923db893a723",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[693375, 18868, 365, 9, 33, "Section",ExpressionUUID->"ff5d0f06-3d02-4957-b227-dbfd429958b5",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[693765, 18881, 167, 4, 44, "Subsection",ExpressionUUID->"471c53b9-3544-410f-a713-3114a53101a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[693957, 18889, 175, 4, 35, "Subsubsection",ExpressionUUID->"308cf48c-2e40-497e-8a66-8bbe6446a5ad",
 InitializationCell->True,
 InitializationGroup->True],
Cell[694135, 18895, 384, 11, 48, "Input",ExpressionUUID->"120e45cc-2cf9-453a-901d-3973daeaa24b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[694556, 18911, 319, 7, 35, "Subsubsection",ExpressionUUID->"c21405f6-673f-49cd-b58e-ef9186e24906",
 InitializationCell->True,
 InitializationGroup->True],
Cell[694878, 18920, 413, 10, 48, "Input",ExpressionUUID->"bd168369-5fb3-44bb-8000-7b30a45d637d",
 InitializationCell->True],
Cell[695294, 18932, 694, 19, 70, "Input",ExpressionUUID->"fcb3e886-cd87-4ffe-99f1-95e5dd744cc2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[696025, 18956, 245, 6, 35, "Subsubsection",ExpressionUUID->"6abea261-7db1-4fa1-a8ef-b608b437fd63",
 InitializationCell->True,
 InitializationGroup->True],
Cell[696273, 18964, 972, 23, 68, "Input",ExpressionUUID->"59fc16a2-f210-45c3-ae4b-d509de3bb1de",
 InitializationCell->True,
 InitializationGroup->True],
Cell[697248, 18989, 1202, 29, 89, "Input",ExpressionUUID->"f488ea0f-5820-4f55-b132-17ee7e329b2a",
 InitializationCell->True],
Cell[698453, 19020, 1742, 38, 173, "Input",ExpressionUUID->"7e17de50-417e-408f-ab86-be1217b8b0b9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[700232, 19063, 311, 7, 45, "Subsubsection",ExpressionUUID->"d0e5f146-200d-4d4c-97a3-593bcde269e1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[700546, 19072, 596, 15, 68, "Input",ExpressionUUID->"96e0e639-8249-4815-a6a0-93cac9e4c56f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[701179, 19092, 306, 7, 45, "Subsubsection",ExpressionUUID->"31b89cc6-e4e1-4b20-90f7-cdb5a3c301af",
 InitializationCell->True,
 InitializationGroup->True],
Cell[701488, 19101, 629, 16, 68, "Input",ExpressionUUID->"983e2ae9-7bfd-4ff9-bbc4-8451801481f7",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[702166, 19123, 246, 6, 54, "Subsection",ExpressionUUID->"090fbddc-c3bd-4ae2-aad0-325151318a95",
 InitializationCell->True,
 InitializationGroup->True],
Cell[702415, 19131, 1205, 25, 68, "Input",ExpressionUUID->"e34adf1d-e83b-4835-9aa6-f9b0407e9f9f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[703669, 19162, 245, 6, 36, "Section",ExpressionUUID->"3f75bc36-ff31-457c-abc2-14383404548c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[703917, 19170, 302, 5, 35, "Text",ExpressionUUID->"92b7c289-0a61-44dd-b1d3-8062237183c3",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[704268, 19181, 210, 6, 41, "Subsubtitle",ExpressionUUID->"b72e8530-e5cc-46f2-a2a6-4d4d204203b6",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[704481, 19189, 234, 9, 64, "Input",ExpressionUUID->"f2ef6fbb-66d8-4bab-abbe-7b6e79ced98b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[704764, 19204, 293, 7, 98, "Title",ExpressionUUID->"5abe5007-3a88-4a79-8ede-19a85d70d475",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[705082, 19215, 314, 5, 49, "Subsection",ExpressionUUID->"ab8cdb57-fa69-45ee-9e14-43b68e633238"],
Cell[705399, 19222, 368, 7, 30, "Text",ExpressionUUID->"aa022b01-215c-4300-bf0f-14db0ff11b55"],
Cell[705770, 19231, 370, 6, 30, "Text",ExpressionUUID->"676c2392-ab7f-4016-a61e-32755dce377f"],
Cell[706143, 19239, 376, 6, 30, "Text",ExpressionUUID->"32611b51-bb4a-4f88-be96-5260114a7421"]
}, Open  ]],
Cell[CellGroupData[{
Cell[706556, 19250, 370, 5, 49, "Subsection",ExpressionUUID->"313f94f6-47ba-4111-aae6-ec56e68f54f4"],
Cell[706929, 19257, 558, 10, 49, "Text",ExpressionUUID->"1f505d67-2809-4640-a5b8-f4db70f8c743"]
}, Open  ]]
}, Closed]]
}
]
*)

