(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     37587,       1069]
NotebookOptionsPosition[     29827,        872]
NotebookOutlinePosition[     30633,        900]
CellTagsIndexPosition[     30590,        897]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Rotations`Euler`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b745ce2a-1fe6-42d2-890e-438fcf792a2c"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.745396823681964*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"8040bea5-8296-470d-a8fb-d0555d535c43"],

Cell["\<\
BeginPackage[\"Rotations`Euler`\",
\t{\t\"Global`\",
\t\t\"SpinDynamica`\",
\t\t\"General`UserLevel`\",
\t\t(*\"General`ModifyBuiltIn`\",*)
\t\t\"General`General3D`\",
\t\t\"General`Miscellaneous`\"
\t}
];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409325389558922*^9, 3.409325396588274*^9}, 
   3.409325469700136*^9, {3.409824191487431*^9, 3.409824192759548*^9}, {
   3.409826189414057*^9, 3.409826200311788*^9}, {3.448289218186234*^9, 
   3.44828921872768*^9}, {3.5150837616760387`*^9, 3.515083764416788*^9}, {
   3.564598248450143*^9, 3.564598250245574*^9}, {3.5645990676004333`*^9, 
   3.564599069577197*^9}, {3.7453967895218067`*^9, 3.745396808724902*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"3bb3f0fc-da18-40a6-96ff-2d55f32e7214"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exports", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"5798c8be-0e09-4cef-aa27-d44fd39975de"],

Cell[CellGroupData[{

Cell["AxesToEuler", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  False,ExpressionUUID->"7bf8439f-f070-4093-9813-6c82af603e59"],

Cell["\<\
AxesToEuler::usage = 
\t\"AxesToEuler[system2,system1,opts] gives the Euler angles \
\[CapitalOmega]21={\[Alpha]21,\[Beta]21,\[Gamma]21} by which each axis of \
system2 may be rotated around the system1 axes in order to be brought into \
coincide with the corresponding axis of system1:
\t\te\[Micro]1=Rz1(\[Alpha]21)Ry1(\[Beta]21)Rz1(\[Gamma]21).e\[Micro]2, where \
\[Mu]\[Element]{x,y,z}.
The same result is generated by rotating around the system2 axes:
\t\te\[Micro]1=Rz2(\[Alpha]21)Ry2(\[Beta]21)Rz2(\[Gamma]21).e\[Micro]2, where \
\[Mu]\[Element]{x,y,z}.
The same result is also generated by using \\\"moving axes\\\", where the \
axes follow the Euler rotations, but in this case the angles are applied in \
reverse order:
\t\te\[Micro]1=Rz2'(\[Gamma]21)Ry2'(\[Beta]21)Rz2(\[Alpha]21).e\[Micro]2, 
where the primed axes of system1 follow the rotation.  

In a typical application, system2 is the principal axis system P of an \
anisotropic interaction, and system1 is a reference axis system such as a \
molecular frame M, or the laboratory frame L. The routine AxesToEuler[P,M] \
then generates the Euler angles \[CapitalOmega]PM which would be used in \
spherical tensor realisations of the spin Hamiltonian. 

Each of system1 and system2 may have the form {Z} or {X,Z} or {X,Y,Z}. Here \
Z,X and Y are 3-vectors. If only Z is specified, the two remaining axes are \
constructed. If X and Z is specified, the z-axis of the constructed system is \
equal to Z and the x-axis is in the XZ plane. If all three axes are \
specified, they must be a right-handed orthogonal set.
If system1 is missing, the system {ex,ey,ez} is assumed.

AxesToEuler also accepts axis definitions containing symbolic angles; in this \
case the symbolic result assumes that all angles are in the first quadrant \
(i.e. greater than 0 and less than \[Pi]/2).
\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409668303694035*^9, 3.409668508820278*^9}, {
   3.409812645318563*^9, 3.409812995932979*^9}, 3.409813082155493*^9, {
   3.502955889240649*^9, 3.50295590149749*^9}, {3.673944867633757*^9, 
   3.673944901802813*^9}, {3.6739483993910933`*^9, 3.673948403866509*^9}, {
   3.673957937071974*^9, 3.673958057851832*^9}, {3.673961208610326*^9, 
   3.6739613100294228`*^9}, {3.673961605480727*^9, 3.6739616828795*^9}, {
   3.673963427090214*^9, 3.673963457395441*^9}, {3.6739634875591297`*^9, 
   3.673963509146616*^9}, {3.6739635499866543`*^9, 3.673963551615808*^9}, {
   3.690699740606904*^9, 3.690699814012726*^9}, {3.69069995095348*^9, 
   3.690700076211907*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"353cb85f-7a61-4386-9d74-8c1cec77ab12"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotateEuler", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e68bced3-bad7-43ef-964c-02dd855722e4"],

Cell["\<\
RotateEuler::usage =
\t\"RotateEuler[obj,{\[Alpha],\[Beta],\[Gamma]},axes] rotates the vector \
according to the Euler angles {\[Alpha],\[Beta],\[Gamma]} around the \
specified axes.

axes may have the form {z}, {x,z} or {x,y,z} (see routine AxisSystem).

If axes are missing, the system {ex,ey,ez} is assumed.
\t\t
For example, RotateEuler[obj,{\[Alpha],\[Beta],\[Gamma]},{vx,vy,vz}] rotates \
obj by the angle \[Gamma] about the axis vz, followed by a rotation by the \
angle \[Beta] about vy, followed by a rotation through the angle \[Alpha] \
about vz.

The same rotations may be performed in the order \
\[Alpha]\[Rule]\[Beta]\[Rule]\[Gamma] about the axes vz\[Rule]vy'\[Rule]vz'' \
where the axes {vx,vy',vz''} are simultaneously rotated together with the \
object.

If the Euler angles relating two axis systems sys1 and sys2 are deduced using \
{\[Alpha]12,\[Beta]12,\[Gamma]12}=AxesToEuler[sys1,sys2], then the axis \
system sys1 may be superimposed on the axis system sys2 using the rotation \
RotateEuler[sys1,{\[Alpha]12,\[Beta]12,\[Gamma]12},sys1].

The object obj may be a 3-vector, an axis system, or contain lines, polygons, \
and text.
\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409668587378058*^9, 3.409668701859187*^9}, {
  3.409823473540504*^9, 3.409823474061829*^9}, {3.6739387789763308`*^9, 
  3.6739389100449743`*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["EulerRotationMatrix", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"5993a611-34be-44c6-83ba-1fcd4c101308"],

Cell["\<\
EulerRotationMatrix::usage =
\t\"EulerRotationMatrix[{\[Alpha],\[Beta],\[Gamma]}] gives the 3D rotation \
matrix for the rotation product Rz(\[Alpha])Ry(\[Beta])Rz(\[Gamma]). See VMK \
p30.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409667384511806*^9, 3.409667395434939*^9}, {
  3.4096674488168173`*^9, 3.409667451848913*^9}, {3.409812292284875*^9, 
  3.4098123476467133`*^9}},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"04872833-2fc8-4e3d-bd80-1980fe237287"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"eb7fce41-2665-49cc-8d8f-ba79b76ae5e2"],

Cell[CellGroupData[{

Cell["AxesToEuler", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  False,ExpressionUUID->"70817959-7225-418d-a45d-664ed50b7a68"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.673952041368244*^9}, {
   3.673952097845681*^9, 3.673952101713579*^9}, {3.673952218289184*^9, 
   3.673952219546897*^9}, 3.673954987231556*^9, {3.690654373441318*^9, 
   3.6906543742959414`*^9}},ExpressionUUID->"32717943-5c8c-4651-8291-\
9aa2f93617fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxesToEuler", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"AxesToEuler", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ex", ",", "ey", ",", "ez"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.673962413866481*^9, 
  3.673962439338464*^9}},ExpressionUUID->"215a8b32-ae62-4126-8e65-\
8e633c7494de"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxesToEuler", "[", 
    RowBox[{
     RowBox[{"system2", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\n", "\t", 
   RowBox[{"AxesToEuler", "[", 
    RowBox[{"system2", ",", 
     RowBox[{"{", 
      RowBox[{"ex", ",", "ey", ",", "ez"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6906542941556177`*^9, 
  3.6906542941566477`*^9}},ExpressionUUID->"6070ef18-0a89-4fef-a09a-\
588bd90c3f9c"]
}, Closed]],

Cell[CellGroupData[{

Cell["numeric arguments", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.673952041368244*^9}, {
   3.673952097845681*^9, 3.673952101713579*^9}, {3.673952218289184*^9, 
   3.673952219546897*^9}, 
   3.673954987231556*^9},ExpressionUUID->"e5a1878b-a355-4f83-b287-\
8e6e94778249"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"AxesToEuler", "[", 
     RowBox[{
      RowBox[{"system2", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      RowBox[{"system1", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"And", "@@", 
     RowBox[{"(", 
      RowBox[{"NumericQ", "/@", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"system1", ",", "system2"}], "}"}], "]"}]}], ")"}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ex1", ",", "ey1", ",", "ez1", ",", "ex2", ",", "ey2", ",", "ez2", ",", 
       "Rzz"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ex1", ",", "ey1", ",", "ez1"}], "}"}], "=", 
        RowBox[{"AxisSystem", "@@", "system1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ex2", ",", "ey2", ",", "ez2"}], "}"}], "=", 
        RowBox[{"AxisSystem", "@@", "system2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Rzz", "=", 
        RowBox[{"ez2", ".", "ez1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"RoundAngles", "/@", "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Chop", "@", 
            RowBox[{"N", "@", 
             RowBox[{"(", 
              RowBox[{"Rzz", "-", "1"}], ")"}]}]}], "==", "0"}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ArcTan", "[", 
             RowBox[{
              RowBox[{"ex2", ".", "ex1"}], ",", 
              RowBox[{"-", 
               RowBox[{"ex2", ".", "ey1"}]}]}], "]"}], ",", "0", ",", "0"}], 
           "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Chop", "@", 
            RowBox[{"N", "@", 
             RowBox[{"(", 
              RowBox[{"Rzz", "+", "1"}], ")"}]}]}], "==", "0"}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ArcTan", "[", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"ex2", ".", "ex1"}]}], ",", 
              RowBox[{"-", 
               RowBox[{"ex2", ".", "ey1"}]}]}], "]"}], ",", "\[Pi]", ",", 
            "0"}], "}"}], ",", "\[IndentingNewLine]", "True", ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ArcTan", "[", 
             RowBox[{
              RowBox[{"ex2", ".", "ez1"}], ",", 
              RowBox[{"ey2", ".", "ez1"}]}], "]"}], ",", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{"ArcCos", "[", "Rzz", "]"}], ",", "\[IndentingNewLine]", 
            "\t", 
            RowBox[{"ArcTan", "[", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"ez2", ".", "ex1"}]}], ",", 
              RowBox[{"ez2", ".", "ey1"}]}], "]"}]}], "\[IndentingNewLine]", 
           "\t", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQPeX0+fKt6S8deyLkF4DoySsebAbRCgnij0G07uKW
FyA6qJbxJYiOOvPjHYhO2hT1HkS3b7W33AakVS6ucQbRDy8uXAmiM9adXQWi
Ve/82QCi3efKbALRP8/UHwLRXWetj4Poln0HzoLoOT94z4Ho+o3nPmwH0kob
v3wF0Qu0bVV2AOlPdZ1g2j9jxVwQ7SCxEUybqqserot/7Xjo1uTzIDrpxe/W
eiAdFtTUBaKF0q49BNHZ/OHvQbRBvnRMA5AumB4Lph87lyWB6CPrvqeC6HUl
aR8bgTRn3oXvIPoBY+VfEP2wuh5MF9hnVjUBafd136tB9I1rHuHNQPrTZLFo
EP340Ne8NiC9fJJePogOtPvL3A6kT5RPZQXRrL8j1xXXv3as4fbdBqIBr8nS
qA==
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["symbolic arguments", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.673952041368244*^9}, {
  3.673952097845681*^9, 3.673952110094962*^9}}],

Cell["assumes all symbolic angles are in the first quadrant", "Text",
 CellChangeTimes->{{3.673953165690827*^9, 3.673953176535475*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxesToEuler", "[", 
    RowBox[{
     RowBox[{"system2", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     RowBox[{"system1", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ex1", ",", "ey1", ",", "ez1", ",", "ex2", ",", "ey2", ",", "ez2", ",", 
       "Rzz", ",", "symbols", ",", "assumptions"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ex1", ",", "ey1", ",", "ez1"}], "}"}], "=", 
        RowBox[{"AxisSystem", "@@", "system1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ex2", ",", "ey2", ",", "ez2"}], "}"}], "=", 
        RowBox[{"AxisSystem", "@@", "system2"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"symbols", "=", 
        RowBox[{"Union", "@", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ex1", ",", "ey1", ",", "ez1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"ex2", ",", "ey2", ",", "ez2"}], "}"}]}], "}"}], "]"}],
            ",", "_Symbol", ",", "Infinity"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"assumptions", "=", 
        RowBox[{"And", "@@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"0", "<", "#", "<", 
              RowBox[{"\[Pi]", "/", "2"}]}], ")"}], "&"}], "/@", "symbols"}], 
          ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Rzz", "=", 
        RowBox[{"ez2", ".", "ez1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Refine", "@", 
        RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", 
                RowBox[{"(", 
                 RowBox[{"Rzz", "-", "1"}], ")"}]}]}], "==", "0"}], "]"}], 
            ",", "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ArcTan", "[", 
               RowBox[{
                RowBox[{"ex2", ".", "ex1"}], ",", 
                RowBox[{"-", 
                 RowBox[{"ex2", ".", "ey1"}]}]}], "]"}], ",", "0", ",", "0"}],
              "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"TrueQ", "[", 
             RowBox[{
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", 
                RowBox[{"(", 
                 RowBox[{"Rzz", "+", "1"}], ")"}]}]}], "==", "0"}], "]"}], 
            ",", "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ArcTan", "[", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"ex2", ".", "ex1"}]}], ",", 
                RowBox[{"-", 
                 RowBox[{"ex2", ".", "ey1"}]}]}], "]"}], ",", "\[Pi]", ",", 
              "0"}], "}"}], ",", "\[IndentingNewLine]", "True", ",", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ArcTan", "[", 
               RowBox[{
                RowBox[{"ex2", ".", "ez1"}], ",", 
                RowBox[{"ey2", ".", "ez1"}]}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"ArcCos", "[", "Rzz", "]"}], ",", "\[IndentingNewLine]",
               "\t", 
              RowBox[{"ArcTan", "[", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"ez2", ".", "ex1"}]}], ",", 
                RowBox[{"ez2", ".", "ey1"}]}], "]"}]}], "\[IndentingNewLine]",
              "\t", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", "assumptions"}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409816510493601*^9, 3.409816832979559*^9}, {
   3.409816991020578*^9, 3.409817368730484*^9}, {3.409817412144919*^9, 
   3.409817416046548*^9}, {3.4098174637749453`*^9, 3.4098174668342752`*^9}, {
   3.409818057990909*^9, 3.40981814140053*^9}, {3.40981895705687*^9, 
   3.40981896642754*^9}, {3.409819015901873*^9, 3.409819024894199*^9}, {
   3.409819155993771*^9, 3.40981919386884*^9}, {3.4098192460232563`*^9, 
   3.409819248436598*^9}, {3.409821574459167*^9, 3.4098216156466227`*^9}, {
   3.4098219859115753`*^9, 3.4098219882967463`*^9}, {3.409822957262733*^9, 
   3.40982295753421*^9}, {3.673945625161036*^9, 3.673945724620454*^9}, {
   3.673947183872117*^9, 3.673947220072551*^9}, {3.6739479186999598`*^9, 
   3.673948026720632*^9}, {3.6739488968573227`*^9, 3.673948898924736*^9}, {
   3.673948947695787*^9, 3.6739489757400837`*^9}, {3.673952139201743*^9, 
   3.673952276856201*^9}, 3.673952310034102*^9, {3.673952501915359*^9, 
   3.673952519970545*^9}, {3.673952570215308*^9, 3.673952576670102*^9}, 
   3.6739530625332727`*^9, {3.673953139276568*^9, 3.673953147343182*^9}, {
   3.673953193494513*^9, 3.673953209739333*^9}, {3.673953417312565*^9, 
   3.673953418020555*^9}, {3.673953457070797*^9, 3.673953518191113*^9}, 
   3.6739535562848387`*^9, 3.673953632482005*^9, 3.673953857936195*^9, {
   3.673954339756391*^9, 3.673954358708853*^9}, 3.6739544653048067`*^9, 
   3.6739547441195917`*^9, {3.6739550449789343`*^9, 3.6739551132430477`*^9}, {
   3.673961342891214*^9, 3.673961344565559*^9}, {3.673961854156826*^9, 
   3.673961889724411*^9}, 3.673961943344432*^9, 3.673961976274846*^9, {
   3.673962350149242*^9, 3.673962383695997*^9}, {3.6907002344501534`*^9, 
   3.6907003070136127`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["invalid input", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.673952041368244*^9}, {
  3.673952097845681*^9, 3.6739521225261097`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxesToEuler", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"AxesToEuler", "::", "input"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6906543135794077`*^9, 3.690654313580439*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.673952041368244*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxesToEuler", "::", "input"}], "=", "\n", "\t", 
   "\"\<input did not consist of a proper axis system specification.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690654325454077*^9, 3.690654325455071*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["RoundAngles", "Subsubsection",
 CellChangeTimes->{{3.6739520219962263`*^9, 3.6739520270917063`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RoundAngles", "[", 
    RowBox[{"ang_", "?", "NumericQ"}], "]"}], ":=", " ", 
   RowBox[{"N", "[", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{"ang", "+", "Pi"}], ",", 
       RowBox[{"2", "Pi"}]}], "]"}], "-", "Pi"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"RoundAngles", "[", "ang_", "]"}], ":=", " ", "ang"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690654335411067*^9, 3.690654335412122*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EulerRotationMatrix (VMK p30)", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EulerRotationMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "g_"}], "}"}], "]"}], ":=", "\n", "\t", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Cos", "[", "a", "]"}], 
         RowBox[{"Cos", "[", "b", "]"}], 
         RowBox[{"Cos", "[", "g", "]"}]}], "-", 
        RowBox[{
         RowBox[{"Sin", "[", "a", "]"}], 
         RowBox[{"Sin", "[", "g", "]"}]}]}], ",", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Cos", "[", "a", "]"}]}], 
         RowBox[{"Cos", "[", "b", "]"}], 
         RowBox[{"Sin", "[", "g", "]"}]}], "-", 
        RowBox[{
         RowBox[{"Sin", "[", "a", "]"}], 
         RowBox[{"Cos", "[", "g", "]"}]}]}], ",", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{"Cos", "[", "a", "]"}], 
        RowBox[{"Sin", "[", "b", "]"}]}]}], "}"}], ",", "\n", "\t\t", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Sin", "[", "a", "]"}], 
         RowBox[{"Cos", "[", "b", "]"}], 
         RowBox[{"Cos", "[", "g", "]"}]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", "a", "]"}], 
         RowBox[{"Sin", "[", "g", "]"}]}]}], ",", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Sin", "[", "a", "]"}]}], 
         RowBox[{"Cos", "[", "b", "]"}], 
         RowBox[{"Sin", "[", "g", "]"}]}], "+", 
        RowBox[{
         RowBox[{"Cos", "[", "a", "]"}], 
         RowBox[{"Cos", "[", "g", "]"}]}]}], ",", "\n", "\t\t\t", 
       RowBox[{
        RowBox[{"Sin", "[", "a", "]"}], 
        RowBox[{"Sin", "[", "b", "]"}]}]}], "}"}], ",", "\n", "\t\t", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Sin", "[", "b", "]"}]}], 
        RowBox[{"Cos", "[", "g", "]"}]}], ",", " ", 
       RowBox[{
        RowBox[{"Sin", "[", "b", "]"}], 
        RowBox[{"Sin", "[", "g", "]"}]}], ",", " ", 
       RowBox[{"Cos", "[", "b", "]"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],

Cell[CellGroupData[{

Cell["RotateEuler", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["rotate vectors", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4098239328365393`*^9, 3.409823939240077*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["rotations of ordinary vector", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotateEuler", "[", 
   RowBox[{
    RowBox[{"vec", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Except", "[", "_List", "]"}], ",", 
       RowBox[{"Except", "[", "_List", "]"}], ",", 
       RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], ",", "\n", "\t", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]_", ",", " ", "\[Beta]_", ",", " ", "\[Gamma]_"}], 
     "}"}], ",", "opts___Rule"}], " ", "]"}], ":=", "\n", "\t", 
  RowBox[{
   RowBox[{"EulerRotationMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]"}], "}"}], "]"}], ".",
    "vec"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.409823353165832*^9, 3.409823364811503*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rotations of ordinary vector around arbitrary system", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotateEuler", "[", 
   RowBox[{
    RowBox[{"vec", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Except", "[", "_List", "]"}], ",", 
       RowBox[{"Except", "[", "_List", "]"}], ",", 
       RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], ",", 
    RowBox[{"\[CapitalOmega]", ":", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]_", ",", "\[Beta]_", ",", "\[Gamma]_"}], "}"}]}], ",", 
    "axes_", ",", "opts___Rule"}], " ", "]"}], ":=", "\n", "\t", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "\[CapitalOmega]FE", "}"}], ",", 
    RowBox[{"(", "\n", "\t\t", 
     RowBox[{
      RowBox[{"\[CapitalOmega]FE", " ", "=", " ", 
       RowBox[{"AxesToEuler", "[", 
        RowBox[{"AxisSystem", "@@", "axes"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\t", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"RotateEuler", "[", 
          RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", "vec", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Reverse", "[", "\[CapitalOmega]FE", "]"}]}], ",", 
          "\[CapitalOmega]", ",", "\[CapitalOmega]FE"}], "}"}]}], "]"}]}], 
     "\n", "\t", ")"}]}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.4098235450418873`*^9, 3.409823858299131*^9}, {
  3.673940447828677*^9, 3.673940448142976*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["go into lists that are not vectors", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409823987671809*^9, 3.409823994076367*^9}},
 AspectRatioFixed->True],

Cell["\<\
RotateEuler[obj_List,ang:{_, _, _},opts___]:=
\t\tMap[ 
\t\t\tRotateEuler[#,ang,opts]&, 
\t\t\tobj 
\t\t] \
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Graphics3D", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.40982596546175*^9, 3.409825965940111*^9}, 
   3.673956435913225*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotateEuler", "[", 
   RowBox[{
    RowBox[{"Graphics3D", "[", "obj___", "]"}], ",", 
    RowBox[{"\[CapitalOmega]", ":", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]_", ",", "\[Beta]_", ",", "\[Gamma]_"}], "}"}]}]}], 
   "]"}], ":=", 
  RowBox[{"Graphics3D", "@", 
   RowBox[{"GeometricTransformation", "[", 
    RowBox[{
     RowBox[{"Normal", "@", "obj"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"EulerRotationMatrix", "[", "\[CapitalOmega]", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
    "]"}]}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.409824992423657*^9, 3.40982510579807*^9}, {
  3.4098251615081587`*^9, 3.409825170724739*^9}, {3.4098255305650673`*^9, 
  3.409825546319705*^9}, {3.40982967914592*^9, 3.409829685290476*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["if object not known, and not a list, do nothing", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell["\<\
RotateEuler[obj_,ang:{_, _, _},opts___ ]:=
\tobj/; !TrueQ[ Head[obj]==List ];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.673956448093709*^9},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"89229d4b-59ab-4512-8b3f-ace383596ee2"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{824, 1180},
WindowMargins->{{Automatic, 148}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 253, 7, 114, "Title",ExpressionUUID->"b745ce2a-1fe6-42d2-890e-438fcf792a2c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[700, 26, 344, 9, 57, "Subsubtitle",ExpressionUUID->"8040bea5-8296-470d-a8fb-d0555d535c43",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1047, 37, 828, 21, 190, "Input",ExpressionUUID->"3bb3f0fc-da18-40a6-96ff-2d55f32e7214",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1912, 63, 214, 6, 41, "Subsubtitle",ExpressionUUID->"5798c8be-0e09-4cef-aa27-d44fd39975de",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2151, 73, 215, 6, 36, "Section",ExpressionUUID->"7bf8439f-f070-4093-9813-6c82af603e59",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2369, 81, 2712, 49, 532, "Input",ExpressionUUID->"353cb85f-7a61-4386-9d74-8c1cec77ab12",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5118, 135, 214, 6, 36, "Section",ExpressionUUID->"e68bced3-bad7-43ef-964c-02dd855722e4",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5335, 143, 1455, 35, 374, "Input",ExpressionUUID->"bae752b9-6a58-4ff8-b805-4e53c5e99bb7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6827, 183, 222, 6, 36, "Section",ExpressionUUID->"5993a611-34be-44c6-83ba-1fcd4c101308",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7052, 191, 493, 13, 74, "Input",ExpressionUUID->"25a17e04-f472-407b-8143-27c986099371",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7594, 210, 211, 6, 41, "Subsubtitle",ExpressionUUID->"04872833-2fc8-4e3d-bd80-1980fe237287",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7808, 218, 201, 5, 46, "Input",ExpressionUUID->"eb7fce41-2665-49cc-8d8f-ba79b76ae5e2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[8034, 227, 194, 5, 36, "Section",ExpressionUUID->"70817959-7225-418d-a45d-664ed50b7a68",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[8253, 236, 331, 5, 45, "Subsubsection",ExpressionUUID->"32717943-5c8c-4651-8291-9aa2f93617fb"],
Cell[8587, 243, 406, 12, 46, "Input",ExpressionUUID->"215a8b32-ae62-4126-8e65-8e633c7494de",
 InitializationCell->True],
Cell[8996, 257, 621, 19, 68, "Input",ExpressionUUID->"6070ef18-0a89-4fef-a09a-588bd90c3f9c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9654, 281, 293, 5, 45, "Subsubsection",ExpressionUUID->"e5a1878b-a355-4f83-b287-8e6e94778249"],
Cell[9950, 288, 3890, 102, 427, "Input",ExpressionUUID->"5551a3a7-4210-4e88-b5d4-76fbea76413a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13877, 395, 160, 2, 35, "Subsubsection",ExpressionUUID->"b0452560-f741-4307-9d5b-b9fdecd8d96c"],
Cell[14040, 399, 135, 1, 30, "Text",ExpressionUUID->"77056c4a-3f47-4b62-bb5f-d5f642e3662d"],
Cell[14178, 402, 6074, 135, 511, "Input",ExpressionUUID->"8718f56f-e338-4778-a1d3-2f68158e4800",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20289, 542, 157, 2, 35, "Subsubsection",ExpressionUUID->"381b3251-dae0-4698-b8a1-d2253fe8c0c4"],
Cell[20449, 546, 347, 10, 48, "Input",ExpressionUUID->"46345bed-f673-4a86-99c6-18221ba3a7d5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20833, 561, 101, 1, 29, "Subsubsection",ExpressionUUID->"c478b5c2-1416-4535-8368-5e5462f10a02"],
Cell[20937, 564, 285, 7, 70, "Input",ExpressionUUID->"a8b335e9-d0a6-425f-b5df-2388fe3bfe16",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21259, 576, 106, 1, 29, "Subsubsection",ExpressionUUID->"6c0c014f-1802-4179-ab22-81bf937f3d38"],
Cell[21368, 579, 516, 16, 70, "Input",ExpressionUUID->"8dc366f1-2f8b-4ed2-89fe-59056a0dec64",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[21933, 601, 174, 5, 34, "Section",ExpressionUUID->"b1185bd6-4198-4ee8-ba54-a8535f31f991",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[22110, 608, 2177, 64, 196, "Input",ExpressionUUID->"163997e6-fd63-48ec-bdb3-7068ef1ee39b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24324, 677, 156, 5, 34, "Section",ExpressionUUID->"ebdc37b0-667a-468e-80d6-d970407eb9b8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[24505, 686, 209, 5, 44, "Subsection",ExpressionUUID->"7f390fb4-aa87-48d7-a631-f9f62f028430",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[24739, 695, 158, 4, 35, "Subsubsection",ExpressionUUID->"01deb66d-f566-43a2-8e34-e17b6ac59420",
 InitializationCell->True,
 InitializationGroup->True],
Cell[24900, 701, 728, 19, 63, "Input",ExpressionUUID->"71d92afa-5c88-4ec8-bad4-cf96ffc3da0f",
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25665, 725, 182, 4, 35, "Subsubsection",ExpressionUUID->"c8853937-b470-4ce2-8a14-40ebaf474a5c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[25850, 731, 1381, 36, 114, "Input",ExpressionUUID->"7012dbd8-43bb-4c0e-8312-1337633f0572",
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[27280, 773, 227, 5, 36, "Subsection",ExpressionUUID->"ff99eb63-12e9-4c6e-b350-8078eb4ca3e1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[27510, 780, 236, 10, 120, "Input",ExpressionUUID->"82b3e675-e693-4695-996c-1a1ae15d3f58",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[27783, 795, 249, 7, 44, "Subsection",ExpressionUUID->"ce4cd8d9-ed5c-4c3e-870a-073a22fd778e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[28035, 804, 856, 22, 63, "Input",ExpressionUUID->"098a7df6-1e9e-46ba-8bc1-abffa8a0403d",
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28928, 831, 195, 5, 36, "Subsection",ExpressionUUID->"1938eee5-46be-4301-ae17-e31d03ef6059",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29126, 838, 249, 8, 44, "Input",ExpressionUUID->"fbb2db33-750d-4610-83d4-4e40907a305b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[29436, 853, 210, 6, 41, "Subsubtitle",ExpressionUUID->"89229d4b-59ab-4512-8b3f-ace383596ee2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29649, 861, 150, 7, 66, "Input",ExpressionUUID->"cf88f740-38ed-4139-962e-511169d28a5a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]]
}
]
*)

