(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     45437,       1292]
NotebookOptionsPosition[     35913,       1065]
NotebookOutlinePosition[     36607,       1090]
CellTagsIndexPosition[     36564,       1087]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Rotations`Wigner`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"d7b35860-4eb0-4d39-90e9-85eccf6fc2aa"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.529575691235586*^9, 3.529575757786647*^9}, 
   3.7453967171351347`*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"9b17d772-003a-4f37-a106-cfd85003f641"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Rotations`Wigner`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", 
      "\"\<General`UserLevel`\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\""}], "}"}]}], 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448289235920735*^9, {3.564598298531558*^9, 3.564598298935996*^9}, {
   3.564599109280499*^9, 3.56459910986864*^9}, {3.6831207996273613`*^9, 
   3.683120800049851*^9}, {3.745396692421427*^9, 3.74539670664576*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"af327257-dedc-44c9-990a-50469010a3e4"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
unprotect WignerD, disable messages, and set up modified syntax\
\>", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.529575691235586*^9, 3.529575757786647*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"dfb62da9-97b6-4501-a546-0648ad20cc16"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"ModifyBuiltIn", "[", 
    RowBox[{"WignerD", ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Off", "[", 
        RowBox[{"WignerD", "::", "list"}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"Off", "[", 
        RowBox[{"WignerD", "::", "argbu"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SyntaxInformation", "[", "WignerD", "]"}], "=", 
        RowBox[{"{", 
         RowBox[{"\"\<ArgumentsPattern\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"_", ",", "_.", ",", "_.", ",", "_."}], "}"}]}], "}"}]}], 
       ";"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], 
   ";"}], "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120651213448*^9, 3.6831206639028473`*^9}, {
   3.745399101867208*^9, 
   3.74539910487644*^9}},ExpressionUUID->"91bffa4f-ced9-437d-b5e9-\
66fcb35bfcac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"WignerD", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Unprotect", "[", "WignerD", "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"Off", "[", 
       RowBox[{"WignerD", "::", "list"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Off", "[", 
       RowBox[{"WignerD", "::", "argbu"}], "]"}], ";", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"SyntaxInformation", "[", "WignerD", "]"}], "=", 
       RowBox[{"{", 
        RowBox[{"\"\<ArgumentsPattern\>\"", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_.", ",", "_.", ",", "_."}], "}"}]}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Protect", "[", "WignerD", "]"}], ";"}], "\[IndentingNewLine]", 
     ")"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.745399139412189*^9, 3.745399162918167*^9}, {
  3.745399231370899*^9, 
  3.7453992755115843`*^9}},ExpressionUUID->"09d602bb-92f0-4f87-a023-\
8cc8eba5994e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", "WignerD", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68312094204571*^9, 3.683120947724325*^9}, {
  3.745399114469565*^9, 3.745399117469513*^9}, {3.7453992411014633`*^9, 
  3.745399243313006*^9}},ExpressionUUID->"c42ca934-6f10-4629-825c-\
67b0a4b543ac"]
}, Open  ]],

Cell[CellGroupData[{

Cell["usages", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"02759cf3-1bc9-43c3-a123-b67d7e06047f"],

Cell[CellGroupData[{

Cell["Wignerd", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4525316744726467`*^9, 3.452531683156207*^9}, 
   3.5295119960465183`*^9},
 AspectRatioFixed->
  False,ExpressionUUID->"c5689da5-ee1e-4eb5-88a4-c5da92912d25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Wignerd", "::", "usage"}], "=", "\n", "\t", 
   "\"\<Wignerd[J][\[Beta]] is the reduced Wigner matrix (J integral or \
half-integral). Wignerd[J,{m2,m1}][\[Beta]] is the reduced Wigner function \
(element of the reduced Wigner matrix). Wignerd[J,{m}][\[Beta]] is the mth \
row of the reduced Wigner matrix; Wignerd[J,{{m}}][\[Beta]] is the mth column \
of the reduced Wigner matrix. In all cases the row and column indices run \
from +J to -J in descending order.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832515467456*^9, 3.409832517709145*^9}, {
  3.409832624398933*^9, 3.4098326272321873`*^9}, {3.45253374798892*^9, 
  3.4525337738038597`*^9}, {3.452533933068924*^9, 3.452533933841942*^9}, {
  3.4992978494593143`*^9, 3.4992979004021387`*^9}, {3.499298021542108*^9, 
  3.499298071435951*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["WignerD", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4525316744726467`*^9, 3.452531683156207*^9}, 
   3.529512959705841*^9, 3.529572762463851*^9},
 AspectRatioFixed->
  False,ExpressionUUID->"be905b80-325d-4836-9a3f-54dcc8171806"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WignerD", "::", "usage"}], "=", "\n", 
   "\"\<WignerD is a built-in function in Mathematica 2.0 but has been given \
enhanced functionality in SpinDynamica, in order to maintain compatibility \
with previous code. The SpinDynamica definitions are as follows:\n\
WignerD[J][{\[Alpha],\[Beta],\[Gamma]}] is the three-angle Wigner matrix for \
integral or half-integral J. WignerD[J]{{\[Alpha]2,\[Beta]2,\[Gamma]2},{\
\[Alpha]1,\[Beta]1,\[Gamma]1}..}] is the Wigner matrix for the overall \
rotation corresponding to the specified sequence of Euler rotations. \
WignerD[J,{m2,m1}][{\[Alpha],\[Beta],\[Gamma]}] is a three-angle Wigner \
function (Wigner matrix element). WignerD[J,{m}][{\[Alpha],\[Beta],\[Gamma]}] \
is the mth row of the Wigner matrix; WignerD[J,{{m}}][{\[Alpha],\[Beta],\
\[Gamma]}] is the mth column of the Wigner matrix. In all cases the row and \
column indices run from +J to -J in descending order.\>\""}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409832521789256*^9, 3.4098325385822887`*^9}, {
  3.409832629812295*^9, 3.409832641336506*^9}, {3.452531687883738*^9, 
  3.4525317445624733`*^9}, {3.45253180949253*^9, 3.452531949856708*^9}, {
  3.452533778472732*^9, 3.452533847335246*^9}, {3.4992973298875113`*^9, 
  3.4992974197349253`*^9}, {3.499298087824766*^9, 3.49929809370401*^9}, {
  3.5295129603902693`*^9, 3.5295129653471403`*^9}, {3.529572762511054*^9, 
  3.529572762640836*^9}, {3.529572823395638*^9, 3.529572882259727*^9}, {
  3.683120882368236*^9, 3.6831208854131927`*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["TensorElement", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"4f1af5bc-052c-4e43-b175-4642d80375cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TensorElement", "::", "usage"}], "=", "\n", "\t", 
   "\"\<TensorElement[\[Lambda], \[Mu]][tensor] accesses the component \[Mu] \
of the rank \[Lambda] tensor (written as a list of length \
2\[Lambda]+1).\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.452533892899385*^9, 3.452533919617176*^9}},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["private", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"46a19044-a07b-44db-a676-613c018e11c7"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"13df7f68-e70e-4453-aaab-da77e5eb8da3"],

Cell[CellGroupData[{

Cell["WignerD", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.529572971417101*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"bc4ea417-a084-4e73-9211-53fbc7c0833a"],

Cell[CellGroupData[{

Cell["on first call to WignerD, provide modification warning", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.529573037349324*^9}, {
  3.5622155858931932`*^9, 3.562215624155168*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FirstCallToWignerD", "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.562215643089527*^9, 3.56221565098831*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"WignerD", "[", "args___", "]"}], "/;", 
    RowBox[{
     RowBox[{"TrueQ", "[", "FirstCallToWignerD", "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelID", "\[Equal]", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"WignerD", "::", "mod"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
       RowBox[{"Button", "[", 
        RowBox[{"\"\<For ?WignerD click <here>\>\"", ",", 
         RowBox[{"Print", "[", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"WignerD", "::", "usage"}], ",", "\"\<Usage\>\""}], "]"}],
           "]"}]}], "]"}], "//", "DisplayForm"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"FirstCallToWignerD", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"WignerD", "[", "args", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5622156269808826`*^9, 3.562215694565308*^9}, {
   3.5622159603105497`*^9, 3.562215966600997*^9}, {3.562216280773066*^9, 
   3.562216296481703*^9}, 3.562216464070169*^9, {3.562216497854785*^9, 
   3.5622166082129183`*^9}, {3.5622170737384243`*^9, 3.562217075616379*^9}, 
   3.562217641252487*^9, {3.562217754295807*^9, 3.5622177631965647`*^9}, {
   3.639308313350889*^9, 3.639308336134595*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["individual elements", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.529573037349324*^9}}],

Cell["check validity and pass down to built-in routine, if valid.", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.52957511982174*^9, 3.5295751357480793`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]_Integer", ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]2_Integer", ",", "\[Mu]1_Integer"}], "}"}]}], "]"}], 
     "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Beta]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Gamma]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], "]"}]}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Abs", "[", "\[Mu]2", "]"}], ">", "\[Lambda]"}], ")"}], "||", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Abs", "[", "\[Mu]1", "]"}], ">", "\[Lambda]"}], ")"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295749294280987`*^9, 3.529574985415111*^9}, {
  3.529690719489356*^9, 3.529690733712611*^9}, {3.562216323113096*^9, 
  3.5622163255500183`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]_", ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]2_", ",", "\[Mu]1_"}], "}"}]}], "]"}], "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Beta]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Gamma]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], "]"}]}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Lambda]"}], "]"}], "&&", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Mu]2"}], "]"}], "&&", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Mu]1"}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Abs", "[", "\[Mu]2", "]"}], ">", "\[Lambda]"}], ")"}], "||", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Abs", "[", "\[Mu]1", "]"}], ">", "\[Lambda]"}], ")"}]}], 
      ")"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295749294280987`*^9, 3.529575086548819*^9}, {
   3.529690737920681*^9, 3.529690743354352*^9}, 3.5622163293922863`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]_", ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]2_", ",", "\[Mu]1_"}], "}"}]}], "]"}], "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Alpha]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Beta]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"\[Gamma]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], "]"}]}], ":=", 
   RowBox[{"TrigExpand", "@", 
    RowBox[{"WignerD", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", 
        RowBox[{"-", "\[Mu]2"}], ",", 
        RowBox[{"-", "\[Mu]1"}]}], "}"}], ",", "\[Alpha]", ",", "\[Beta]", 
      ",", "\[Gamma]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.5295730093588753`*^9, {3.529573255278314*^9, 3.529573264904253*^9}, {
   3.529574696139097*^9, 3.529574712474267*^9}, {3.52957475637899*^9, 
   3.529574876590457*^9}, 3.529575110148321*^9, {3.529690752084607*^9, 
   3.5296907571833553`*^9}, {3.5555683777648287`*^9, 3.555568380138014*^9}, 
   3.562216331302353*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["entire matrices", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.529573049869513*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{
    RowBox[{"WignerD", "[", "\[Lambda]_", "]"}], "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[Alpha]", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"\[Beta]", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", 
      RowBox[{"\[Gamma]", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], "]"}]}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]", ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]2", ",", "\[Mu]1"}], "}"}]}], "]"}], "[", 
     RowBox[{"{", 
      RowBox[{"\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]"}], "}"}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]2", ",", 
      RowBox[{"+", "\[Lambda]"}], ",", 
      RowBox[{"-", "\[Lambda]"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]1", ",", 
      RowBox[{"+", "\[Lambda]"}], ",", 
      RowBox[{"-", "\[Lambda]"}], ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.529514583320595*^9, {3.529514620628251*^9, 3.529514677930996*^9}, {
   3.529515581813315*^9, 3.529515592703499*^9}, {3.529515705348496*^9, 
   3.529515717084909*^9}, {3.529573009385006*^9, 3.529573009402092*^9}, {
   3.5296907817341137`*^9, 3.5296907866525307`*^9}, 3.5622163363417587`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["rows", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.5295730583800287`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]_", ",", 
       RowBox[{"{", "\[Mu]2_", "}"}]}], "]"}], "[", "\[CapitalOmega]_", 
     "]"}]}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"WignerD", "[", 
       RowBox[{"\[Lambda]", ",", 
        RowBox[{"{", 
         RowBox[{"\[Mu]2", ",", "\[Mu]1"}], "}"}]}], "]"}], "[", 
      "\[CapitalOmega]", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]1", ",", 
       RowBox[{"+", "\[Lambda]"}], ",", 
       RowBox[{"-", "\[Lambda]"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.529514583320595*^9, {3.529514620628251*^9, 3.529514677930996*^9}, {
   3.529514925759665*^9, 3.529514955043928*^9}, {3.529515792121743*^9, 
   3.529515806274529*^9}, {3.5295730094347343`*^9, 3.529573009451449*^9}, {
   3.5296904614829597`*^9, 3.5296904704114017`*^9}, 3.5622163412402554`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["columns", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.5295730659973087`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"\[Lambda]_", ",", 
       RowBox[{"{", 
        RowBox[{"{", "\[Mu]1_", "}"}], "}"}]}], "]"}], "[", 
     "\[CapitalOmega]_", "]"}]}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"WignerD", "[", 
       RowBox[{"\[Lambda]", ",", 
        RowBox[{"{", 
         RowBox[{"\[Mu]2", ",", "\[Mu]1"}], "}"}]}], "]"}], "[", 
      "\[CapitalOmega]", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Mu]2", ",", 
       RowBox[{"+", "\[Lambda]"}], ",", 
       RowBox[{"-", "\[Lambda]"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.529514583320595*^9, {3.529514620628251*^9, 3.529514677930996*^9}, {
   3.529514925759665*^9, 3.529514955043928*^9}, {3.529515158842244*^9, 
   3.5295151633898783`*^9}, {3.5295158164751883`*^9, 3.529515826887542*^9}, {
   3.52957300948532*^9, 3.529573009501993*^9}, {3.5296904799389544`*^9, 
   3.5296904869617577`*^9}, 3.562216344779524*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Sequences of rotations", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.452532784859907*^9, 3.4525327878384857`*^9}},
 AspectRatioFixed->False],

Cell[CellGroupData[{

Cell["full matrices", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4525830360766153`*^9, 3.4525830380989113`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", "J_", "]"}], "[", 
     RowBox[{"rot", ":", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"WignerD", "[", "J", "]"}], "[", 
    RowBox[{"First", "@", "rot"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.45253295886545*^9, 3.452532987963956*^9}, {
   3.5295129331575336`*^9, 3.529512933882955*^9}, {3.529572763551174*^9, 
   3.529572763584916*^9}, 3.562216350881804*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", "J_", "]"}], "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rots", ":", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}]}], ",", 
       RowBox[{"rot1", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}]}], "}"}], "]"}]}], 
   ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"WignerD", "[", "J", "]"}], "[", 
     RowBox[{"{", "rots", "}"}], "]"}], ".", 
    RowBox[{
     RowBox[{"WignerD", "[", "J", "]"}], "[", "rot1", "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452532790802318*^9, 3.452532936133346*^9}, {
   3.452582967436108*^9, 3.452582992115775*^9}, {3.452583388453917*^9, 
   3.452583391099354*^9}, {3.529512934507188*^9, 3.5295129357872972`*^9}, {
   3.529572763635172*^9, 3.5295727637019033`*^9}, 3.562216352215746*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["individual elements", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4525830360766153`*^9, 3.4525830491314793`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"J_", ",", 
       RowBox[{"{", 
        RowBox[{"m2_", ",", "m1_"}], "}"}]}], "]"}], "[", 
     RowBox[{"rot", ":", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"WignerD", "[", 
     RowBox[{"J", ",", 
      RowBox[{"{", 
       RowBox[{"m2", ",", "m1"}], "}"}]}], "]"}], "[", 
    RowBox[{"First", "@", "rot"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452533028599869*^9, 3.452533065608467*^9}, {
   3.5295129364400263`*^9, 3.529512937089006*^9}, {3.529572763753487*^9, 
   3.529572763785736*^9}, 3.562216356038436*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"WignerD", "[", 
      RowBox[{"J_", ",", 
       RowBox[{"{", 
        RowBox[{"m2_", ",", "m1_"}], "}"}]}], "]"}], "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rots", ":", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}]}], ",", 
       RowBox[{"rot1", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}]}], "}"}], "]"}]}], 
   ":=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"WignerD", "[", 
        RowBox[{"J", ",", 
         RowBox[{"{", 
          RowBox[{"m2", ",", "m21"}], "}"}]}], "]"}], "[", 
       RowBox[{"{", "rots", "}"}], "]"}], "*", 
      RowBox[{
       RowBox[{"WignerD", "[", 
        RowBox[{"J", ",", 
         RowBox[{"{", 
          RowBox[{"m21", ",", "m1"}], "}"}]}], "]"}], "[", "rot1", "]"}]}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"m21", ",", 
       RowBox[{"-", "J"}], ",", 
       RowBox[{"+", "J"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452532790802318*^9, 3.452532936133346*^9}, 
   3.4525330849158773`*^9, {3.4525331868596563`*^9, 3.452533280486114*^9}, {
   3.452533312548173*^9, 3.452533314194175*^9}, {3.452533354058302*^9, 
   3.452533380030621*^9}, {3.529512937734795*^9, 3.529512939234397*^9}, {
   3.529572763836052*^9, 3.529572763902782*^9}, 3.5622163574400187`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.529573037349324*^9}, {
  3.529574034108387*^9, 3.529574035377289*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"WignerD", "::", "mod"}], "=", 
   "\"\<The built-in function WignerD has been given extra functionality in \
SpinDynamica. Execute ?WignerD for more information.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295740401348743`*^9, 3.529574059455131*^9}, {
  3.529574238721696*^9, 3.5295742559048567`*^9}, {3.562217822631591*^9, 
  3.5622178370993433`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["reprotect WignerD", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 3.529573037349324*^9}, {
  3.529574034108387*^9, 3.529574035377289*^9}, {3.5622157192632637`*^9, 
  3.562215724850532*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", "WignerD", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.529572736984694*^9, 3.529572741989908*^9}, {
  3.529574064808269*^9, 3.529574072658497*^9}, {3.562215735697034*^9, 
  3.562215738119396*^9}, {3.5622161777020884`*^9, 3.562216183066987*^9}, {
  3.562216483134582*^9, 3.562216486536777*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Wignerd", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.529572971417101*^9, 3.529572976777708*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"16578866-0cb7-4318-a32d-e00b018f6c80"],

Cell[CellGroupData[{

Cell["individual elements", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 
  3.529573037349324*^9}},ExpressionUUID->"cbdd42b5-1c05-4c01-826a-\
cfff3bb31778"],

Cell["check validity and pass down to built-in routine, if valid.", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.52957511982174*^9, 3.5295751357480793`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Wignerd", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]2_Integer", ",", "\[Mu]1_Integer"}], "}"}]}], "]"}], "[",
     "\[Beta]_", "]"}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Abs", "[", "\[Mu]2", "]"}], ">", "\[Lambda]"}], ")"}], "||", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Abs", "[", "\[Mu]1", "]"}], ">", "\[Lambda]"}], ")"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295749294280987`*^9, 3.529574985415111*^9}, {
  3.5295752208253927`*^9, 3.529575227890217*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Wignerd", "[", 
     RowBox[{"\[Lambda]_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]2_", ",", "\[Mu]1_"}], "}"}]}], "]"}], "[", "\[Beta]_", 
    "]"}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Lambda]"}], "]"}], "&&", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Mu]2"}], "]"}], "&&", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Mu]1"}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Abs", "[", "\[Mu]2", "]"}], ">", "\[Lambda]"}], ")"}], "||", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Abs", "[", "\[Mu]1", "]"}], ">", "\[Lambda]"}], ")"}]}], 
      ")"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295749294280987`*^9, 3.529575086548819*^9}, {
  3.529575236202409*^9, 3.529575244233571*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Wignerd", "[", 
     RowBox[{"\[Lambda]_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Mu]2_", ",", "\[Mu]1_"}], "}"}]}], "]"}], "[", "\[Beta]_", 
    "]"}], ":=", 
   RowBox[{"TrigExpand", "@", 
    RowBox[{"WignerD", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]", ",", 
        RowBox[{"-", "\[Mu]2"}], ",", 
        RowBox[{"-", "\[Mu]1"}]}], "}"}], ",", "0", ",", "\[Beta]", ",", 
      "0"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.5295730093588753`*^9, {3.529573255278314*^9, 3.529573264904253*^9}, {
   3.529574696139097*^9, 3.529574712474267*^9}, {3.52957475637899*^9, 
   3.529574876590457*^9}, 3.529575110148321*^9, {3.529575257614148*^9, 
   3.529575274676412*^9}, 3.555568419709279*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["entire matrices", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.529573033712277*^9, 
  3.529573049869513*^9}},ExpressionUUID->"e06f6540-1504-4d8c-96bc-\
0dfff3cfbf03"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{
    RowBox[{"Wignerd", "[", "\[Lambda]_", "]"}], "[", 
    RowBox[{"\[Beta]", ":", 
     RowBox[{"Except", "[", "_List", "]"}]}], "]"}]}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Wignerd", "[", 
      RowBox[{"\[Lambda]", ",", 
       RowBox[{"{", 
        RowBox[{"\[Mu]2", ",", "\[Mu]1"}], "}"}]}], "]"}], "[", "\[Beta]", 
     "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]2", ",", 
      RowBox[{"+", "\[Lambda]"}], ",", 
      RowBox[{"-", "\[Lambda]"}], ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Mu]1", ",", 
      RowBox[{"+", "\[Lambda]"}], ",", 
      RowBox[{"-", "\[Lambda]"}], ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5295141567094297`*^9, 3.5295142421928053`*^9}, 
   3.529514583320595*^9, {3.529514620628251*^9, 3.529514677930996*^9}, {
   3.529515581813315*^9, 3.529515592703499*^9}, {3.529515705348496*^9, 
   3.529515717084909*^9}, {3.529573009385006*^9, 3.529573009402092*^9}, {
   3.5296907817341137`*^9, 3.5296907866525307`*^9}, 3.5622163363417587`*^9, {
   3.696158309301284*^9, 3.6961583458874817`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rows", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.499297506798057*^9, 3.499297510156529*^9}, 
   3.499297653628441*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"4e51864b-66cf-43cf-914c-7a3879cf11dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Wignerd", "[", 
      RowBox[{"J_", ",", 
       RowBox[{"{", 
        RowBox[{"m2_", "?", "NumericQ"}], "}"}]}], "]"}], "[", "\[Beta]_", 
     "]"}], "/;", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "J"}], "\[LessEqual]", "m2", "<=", "J"}], ")"}]}], ":=", 
   " ", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Wignerd", "[", 
       RowBox[{"J", ",", 
        RowBox[{"{", 
         RowBox[{"m2", ",", "m1"}], "}"}]}], "]"}], "[", "\[Beta]", "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"m1", ",", 
       RowBox[{"+", "J"}], ",", 
       RowBox[{"-", "J"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499297523010046*^9, 3.4992975394551573`*^9}, {
   3.499297574086376*^9, 3.499297702719761*^9}, 3.4992981146292543`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["columns", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.499297506798057*^9, 3.499297510156529*^9}, 
   3.499297653628441*^9, {3.4992977162137823`*^9, 3.4992977205081587`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"16a89feb-4a5d-4eca-984b-35bd193000fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Wignerd", "[", 
      RowBox[{"J_", ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"m1_", "?", "NumericQ"}], "}"}], "}"}]}], "]"}], "[", 
     "\[Beta]_", "]"}], "/;", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "J"}], "\[LessEqual]", "m1", "<=", "J"}], ")"}]}], ":=", 
   " ", "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Wignerd", "[", 
       RowBox[{"J", ",", 
        RowBox[{"{", 
         RowBox[{"m2", ",", "m1"}], "}"}]}], "]"}], "[", "\[Beta]", "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"m2", ",", 
       RowBox[{"+", "J"}], ",", 
       RowBox[{"-", "J"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499297523010046*^9, 3.4992975394551573`*^9}, {
   3.499297574086376*^9, 3.499297702719761*^9}, {3.4992977530983477`*^9, 
   3.4992977640150146`*^9}, 3.4992981297082376`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TensorElement", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.452581612069401*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"7afa124a-a9f0-49db-960b-aa6c66628656"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TensorElement", "[", 
     RowBox[{"\[Lambda]_", ",", " ", "\[Mu]_"}], "]"}], "[", "tensor_List", 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"tensor", "\[LeftDoubleBracket]", " ", 
     RowBox[{"\[Lambda]", "+", "1", "-", "\[Mu]"}], "\[RightDoubleBracket]"}],
     " ", "/;", 
    RowBox[{
     RowBox[{"(", " ", 
      RowBox[{
       RowBox[{"Dimensions", "[", "tensor", "]"}], "==", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"2", "\[Lambda]"}], "+", "1"}], "}"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[Lambda]"}], "\[LessEqual]", "\[Mu]", "\[LessEqual]", 
       "\[Lambda]"}], ")"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4525325108273*^9, 3.452532526746496*^9}, {
  3.452533691841256*^9, 3.452533696235951*^9}, {3.4525816166046343`*^9, 
  3.452581617193759*^9}, {3.452581678832108*^9, 3.452581738137591*^9}},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"1aa2d988-4b95-425d-8a2e-e2b12f3abb13"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"3d624d8f-65f5-450d-9089-7c2d95c42872"]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 751},
WindowMargins->{{Automatic, 251}, {Automatic, 4}},
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 254, 7, 114, "Title",ExpressionUUID->"d7b35860-4eb0-4d39-90e9-85eccf6fc2aa",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[846, 33, 349, 9, 57, "Subsubtitle",ExpressionUUID->"9b17d772-003a-4f37-a106-cfd85003f641",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1198, 44, 922, 21, 152, "Input",ExpressionUUID->"af327257-dedc-44c9-990a-50469010a3e4",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2157, 70, 344, 9, 41, "Subsubtitle",ExpressionUUID->"dfb62da9-97b6-4501-a546-0648ad20cc16",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2504, 81, 1050, 25, 173, "Input",ExpressionUUID->"91bffa4f-ced9-437d-b5e9-66fcb35bfcac",
 InitializationCell->True],
Cell[3557, 108, 1111, 26, 194, "Input",ExpressionUUID->"09d602bb-92f0-4f87-a023-8cc8eba5994e",
 InitializationCell->True],
Cell[4671, 136, 335, 7, 46, "Input",ExpressionUUID->"c42ca934-6f10-4629-825c-67b0a4b543ac",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5043, 148, 213, 6, 41, "Subsubtitle",ExpressionUUID->"02759cf3-1bc9-43c3-a123-b67d7e06047f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[5281, 158, 310, 8, 54, "Subsection",ExpressionUUID->"c5689da5-ee1e-4eb5-88a4-c5da92912d25",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5594, 168, 955, 18, 133, "Input",ExpressionUUID->"eb754342-a395-4459-9a1f-0e82c539c8ea",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6586, 191, 330, 8, 38, "Subsection",ExpressionUUID->"be905b80-325d-4836-9a3f-54dcc8171806",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[6919, 201, 1657, 28, 280, "Input",ExpressionUUID->"ab2cbbb2-2cbd-46d8-acff-d48033a4c105",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8613, 234, 219, 6, 38, "Subsection",ExpressionUUID->"4f1af5bc-052c-4e43-b175-4642d80375cc",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8835, 242, 447, 11, 73, "Input",ExpressionUUID->"800da210-c256-4bd2-84ba-ea0f2bc9ad14",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[9331, 259, 214, 6, 41, "Subsubtitle",ExpressionUUID->"46a19044-a07b-44db-a676-613c018e11c7",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[9548, 267, 201, 5, 46, "Input",ExpressionUUID->"13df7f68-e70e-4453-aaab-da77e5eb8da3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[9774, 276, 252, 7, 36, "Section",ExpressionUUID->"bc4ea417-a084-4e73-9211-53fbc7c0833a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[10051, 287, 220, 3, 44, "Subsection",ExpressionUUID->"fd4c6204-3702-4cb5-9893-b0b6bc46862a",
 InitializationCell->True],
Cell[10274, 292, 179, 4, 48, "Input",ExpressionUUID->"c6546801-14ed-4e10-8a74-51d059f63b48",
 InitializationCell->True],
Cell[10456, 298, 1454, 33, 196, "Input",ExpressionUUID->"d7285159-d25f-4093-9f4c-91e02774750e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11947, 336, 134, 2, 36, "Subsection",ExpressionUUID->"bfe91202-3fc2-4c48-a47b-d287d0ef76d6",
 InitializationCell->True],
Cell[12084, 340, 169, 2, 30, "Text",ExpressionUUID->"2b8cd875-46bc-48a0-aeed-d3091988ba9b",
 InitializationCell->True],
Cell[12256, 344, 1048, 30, 91, "Input",ExpressionUUID->"8da15580-8177-4576-8701-f65b3af57070",
 InitializationCell->True],
Cell[13307, 376, 1285, 36, 91, "Input",ExpressionUUID->"c1b3a087-3e6a-493c-ad0c-f68df53feacd",
 InitializationCell->True],
Cell[14595, 414, 1261, 31, 91, "Input",ExpressionUUID->"bb1dc990-1de3-43da-befb-e07e4797d302",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15893, 450, 130, 2, 36, "Subsection",ExpressionUUID->"c32c9980-3b23-4c44-a3dc-1a6d76e300b8",
 InitializationCell->True],
Cell[16026, 454, 1477, 38, 43, "Input",ExpressionUUID->"f6ac63f3-7a08-48b3-a911-ac0bad78b7a0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17540, 497, 121, 2, 36, "Subsection",ExpressionUUID->"525c79bb-c78e-4de4-af2f-26f1e2b955f5",
 InitializationCell->True],
Cell[17664, 501, 1071, 27, 27, "Input",ExpressionUUID->"485e1710-fc4f-4d2f-8c37-087379f12cad",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[18772, 533, 124, 2, 36, "Subsection",ExpressionUUID->"fd3d7427-0e08-45f8-a85a-eb626098501e",
 InitializationCell->True],
Cell[18899, 537, 1149, 29, 27, "Input",ExpressionUUID->"81ca3079-6fbf-4254-ab42-c6d95f3207b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20085, 571, 239, 6, 36, "Subsection",ExpressionUUID->"3bdaa3df-4278-4d92-a43c-031b19300084",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[20349, 581, 135, 2, 24, "Subsubsection",ExpressionUUID->"f199d187-b8b9-4c54-ba21-9c845d49e42b",
 InitializationCell->True],
Cell[20487, 585, 736, 19, 43, "Input",ExpressionUUID->"80907f0e-ed07-48a3-abc0-1b0cd30c6de3",
 InitializationCell->True],
Cell[21226, 606, 1235, 33, 58, "Input",ExpressionUUID->"6284e9e4-16d9-4b73-95c1-39fc1d6db5af",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22498, 644, 141, 2, 24, "Subsubsection",ExpressionUUID->"5cb3d850-8b5b-401b-9162-800c1dd81980",
 InitializationCell->True],
Cell[22642, 648, 908, 25, 58, "Input",ExpressionUUID->"376f5bbc-d7a7-447b-bfec-16ebdd0faf3f",
 InitializationCell->True],
Cell[23553, 675, 1765, 49, 73, "Input",ExpressionUUID->"c0a7cd4b-fc5c-440b-a351-3d5c58e0d16c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[25367, 730, 172, 3, 36, "Subsection",ExpressionUUID->"6565b3ec-356f-4d5d-b542-9afaebeff685",
 InitializationCell->True],
Cell[25542, 735, 430, 9, 91, "Input",ExpressionUUID->"d6907fd8-1de7-4dec-9801-8b41f3fdd650",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[26009, 749, 232, 4, 36, "Subsection",ExpressionUUID->"61cab245-8211-44da-8725-298d83301dca",
 InitializationCell->True],
Cell[26244, 755, 372, 7, 48, "Input",ExpressionUUID->"f5b3e69e-e84d-44dc-86cc-8d3511abbe60",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[26665, 768, 276, 7, 36, "Section",ExpressionUUID->"16578866-0cb7-4318-a32d-e00b018f6c80",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[26966, 779, 194, 4, 54, "Subsection",ExpressionUUID->"cbdd42b5-1c05-4c01-826a-cfff3bb31778",
 InitializationCell->True],
Cell[27163, 785, 169, 2, 26, "Text",ExpressionUUID->"52ef14d4-7851-4728-9031-f637733fa31e",
 InitializationCell->True],
Cell[27335, 789, 670, 20, 27, "Input",ExpressionUUID->"85ba67e1-1a24-4782-8d42-f2d82aee2fe0",
 InitializationCell->True],
Cell[28008, 811, 937, 28, 43, "Input",ExpressionUUID->"f80499db-8929-4fa4-8ef3-c180ff9c47f1",
 InitializationCell->True],
Cell[28948, 841, 870, 22, 27, "Input",ExpressionUUID->"36bcc4b7-ecec-434d-8679-58833d174c40",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29855, 868, 190, 4, 38, "Subsection",ExpressionUUID->"e06f6540-1504-4d8c-96bc-0dfff3cfbf03",
 InitializationCell->True],
Cell[30048, 874, 1236, 31, 70, "Input",ExpressionUUID->"7c7b81bb-42b3-4d36-aa50-9e0bedf8e8e5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31321, 910, 302, 8, 38, "Subsection",ExpressionUUID->"4e51864b-66cf-43cf-914c-7a3879cf11dd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[31626, 920, 940, 29, 43, "Input",ExpressionUUID->"b462620d-782b-4678-bded-e8e13084782c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32603, 954, 355, 8, 38, "Subsection",ExpressionUUID->"16a89feb-4a5d-4eca-984b-35bd193000fe",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[32961, 964, 1024, 31, 43, "Input",ExpressionUUID->"7b5b901d-8142-4e58-9fa9-36c2401a2527",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[34034, 1001, 258, 7, 36, "Section",ExpressionUUID->"7afa124a-a9f0-49db-960b-aa6c66628656",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[34295, 1010, 1034, 28, 43, "Input",ExpressionUUID->"5f6ba552-27b3-48b7-872f-4c50f2340d96",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[35378, 1044, 210, 6, 41, "Subsubtitle",ExpressionUUID->"1aa2d988-4b95-425d-8a2e-e2b12f3abb13",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[35591, 1052, 294, 9, 68, "Input",ExpressionUUID->"3d624d8f-65f5-450d-9089-7c2d95c42872",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]]
}
]
*)

