(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    269182,       6457]
NotebookOptionsPosition[    227898,       5618]
NotebookOutlinePosition[    228572,       5642]
CellTagsIndexPosition[    228529,       5639]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["SD`Generators`", "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526855795508213`*^9, 3.452685580972721*^9}, 
   3.682593449496829*^9, {3.683108316372006*^9, 3.683108316618305*^9}, 
   3.683108496382702*^9, {3.6922554416781282`*^9, 3.692255444208493*^9}, 
   3.692255852252016*^9, {3.6922562625941143`*^9, 3.692256262872828*^9}},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"38ec49b7-ed69-466f-b150-d80036486419"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"30a9fa10-c6e7-4998-8d83-9c9397d96e6c"],

Cell["\<\
an evolution generator is a Hamiltonian, a Liouvillian superoperator, or \
time-dependent functions of these, which may be used in event specifications\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.614934233307365*^9, 
  3.614934285396604*^9}},ExpressionUUID->"a6af7e63-ce3c-4f39-979c-\
0dbf2ae71560"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SD`Generators`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Liouville`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Interactions`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Hamiltonians`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Relaxation`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Rotations`Wigner`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Units`\>\"", ",", "\[IndentingNewLine]", 
      "\"\<General`PhysicalConstants`\>\""}], "}"}]}], "]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.682597329576949*^9, 3.682597339617495*^9}, {
   3.682611681453899*^9, 3.682611690204586*^9}, 3.682611819113118*^9, {
   3.6826128177214537`*^9, 3.682612818096237*^9}, {3.6831083938005047`*^9, 
   3.68310839584037*^9}, {3.683108457078102*^9, 3.683108458420087*^9}, {
   3.683108860481447*^9, 3.683108865855433*^9}, 3.6831102927632017`*^9, 
   3.683111933228162*^9, {3.684039407787024*^9, 3.684039436010972*^9}, 
   3.692255452268602*^9, {3.692255655883006*^9, 3.692255662836767*^9}, {
   3.692255856645701*^9, 3.692255862065686*^9}, {3.692256268365213*^9, 
   3.692256295466831*^9}, 3.701151248314557*^9, 
   3.745396648999199*^9},ExpressionUUID->"2a0cfb71-7c3e-48a2-b936-\
16b39a48ecbe"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exports", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"7306be35-c257-46e2-9967-b53246823ba2"],

Cell[CellGroupData[{

Cell["general Generator routines", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, {
   3.683111495474196*^9, 3.68311150110506*^9}, 3.709374435821837*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"fd5448bc-bc6f-4f87-b391-b74ce6725227"],

Cell[CellGroupData[{

Cell["CombineGenerators", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.709373134932724*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"1292e437-587c-4c22-b35b-5539394a0c44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "::", "usage"}], "=", 
   "\"\<CombineGenerators[a, b, ..] combines Hamiltonians, Liouvillians, \
time-dependent Hamiltonian functions, and so on, to generate a single \
evolution generator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.7093731203980503`*^9, 
  3.70937312379723*^9}},ExpressionUUID->"8be3a0be-f0d6-4d75-95bd-\
087513a07a29"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineEvolutionGenerators", "::", "usage"}], "=", 
   "\"\<CombineEvolutionGenerators has been replaced by \
CombineGenerators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.709372957034082*^9, 
  3.7093729929549017`*^9}},ExpressionUUID->"fbeb5388-4155-4381-b36c-\
8ba0ea77f220"]
}, Closed]],

Cell[CellGroupData[{

Cell["ValidGeneratorQ", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.709373514235545*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"8248f5ba-a0f9-4d24-a837-95cb5b45ce59"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "::", "usage"}], "=", 
   "\"\<ValidGeneratorQ[gen] returns True if gen is a valid generator.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.7093735100705214`*^9, 
  3.7093735186308813`*^9}},ExpressionUUID->"26cb4d53-7ec7-4051-ba11-\
3cc21952d38f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidEvolutionGeneratorQ", "::", "usage"}], "=", 
   "\"\<ValidEvolutionGeneratorQ has been replaced by ValidGeneratorQ.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.709373526575885*^9, 
  3.709373534494391*^9}, {3.709373692224031*^9, 
  3.709373706209518*^9}},ExpressionUUID->"ce21d8cd-928f-4290-b99c-\
2a07a85afcc8"]
}, Closed]],

Cell[CellGroupData[{

Cell["StandardizeGenerator", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, 3.709373870573638*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"eca65a95-90df-4f73-a4bf-3951ca3852d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "::", "usage"}], "=", 
   "\"\<StandardizeGenerator[gen] puts the generator gen in a standard \
form.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.683111592754137*^9, 
  3.6831116131015587`*^9}, {3.709373867331374*^9, 
  3.709373876016612*^9}},ExpressionUUID->"9db45127-24e2-47d5-8223-\
491193aaa7e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEvolutionGenerator", "::", "usage"}], "=", 
   "\"\<StandardizeEvolutionGenerator has been replaced by \
StandardizeGenerator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.709373526575885*^9, 
  3.709373534494391*^9}, {3.709373692224031*^9, 3.709373706209518*^9}, {
  3.709373886133482*^9, 
  3.709373891025732*^9}},ExpressionUUID->"8f8864db-5298-44f5-b8a9-\
37dde45aea16"]
}, Closed]],

Cell[CellGroupData[{

Cell["GeneratorMatchQ", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.684041182122356*^9, 
   3.6840411849221087`*^9}, 3.709374273571061*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"df94a186-075a-47c4-82f2-0974c28b9be0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "::", "usage"}], "=", 
   "\"\<GeneratorMatchQ[gen1,gen2..] returns True if the generators \
match.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.683111592754137*^9, 
  3.6831116131015587`*^9}, {3.6840411904789867`*^9, 3.684041221496711*^9}, {
  3.709374159745768*^9, 
  3.70937416600124*^9}},ExpressionUUID->"a84e0154-3494-4b25-bd6e-\
777d060b9baf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EvolutionGeneratorMatchQ", "::", "usage"}], "=", 
   "\"\<EvolutionGeneratorMatchQ has been replaced by GeneratorMatchQ.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504187819883255*^9, 3.504187859882494*^9}, {
  3.683111515972722*^9, 3.683111533879826*^9}, {3.709373526575885*^9, 
  3.709373534494391*^9}, {3.709373692224031*^9, 3.709373706209518*^9}, {
  3.709373886133482*^9, 3.709373891025732*^9}, {3.709374177736116*^9, 
  3.709374183147559*^9}},ExpressionUUID->"a79e395a-4caa-491b-a9b3-\
d707796e338f"]
}, Closed]],

Cell[CellGroupData[{

Cell["generator patterns", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.683112162928205*^9, 
   3.683112166094643*^9}, 3.7093743295571404`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"a20e23a5-505d-4968-be31-17c24d2ad63e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NonStandardNullGeneratorPattern", "::", "usage"}], "=", 
   "\"\<NonStandardNullGeneratorPattern is a pattern variable used internally \
by SpinDynamica.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.709374353230575*^9, 
  3.709374354455929*^9}},ExpressionUUID->"94284109-717e-4714-aa8d-\
8e4faa014533"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NullGeneratorPattern", "::", "usage"}], "=", 
   "\"\<NullGeneratorPattern is a pattern variable used internally by \
SpinDynamica.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.683112215216002*^9, 3.70057791338209*^9, {3.7093743554107027`*^9, 
   3.709374356198601*^9}},ExpressionUUID->"6c114871-709b-4294-ba83-\
1a3f326e11df"]
}, Closed]],

Cell[CellGroupData[{

Cell["HeldGeneratorSymbol", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.683112162928205*^9, 
   3.683112166094643*^9}, {3.683112988068356*^9, 3.683112990258404*^9}, {
   3.6831159259577847`*^9, 3.683115927101554*^9}, 3.683117236040044*^9, 
   3.709374358634234*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"0c92db75-19c5-471f-9d95-0b59dcc35951"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HeldGeneratorSymbol", "::", "usage"}], "=", 
   "\"\<HeldGeneratorSymbol is used internally by SpinDynamica.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.709374359843274*^9, 
  3.709374360642297*^9}},ExpressionUUID->"5173ccdf-75cb-413a-897f-\
bce9dcbcc684"]
}, Closed]],

Cell[CellGroupData[{

Cell["logical variables", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.683112162928205*^9, 
   3.683112166094643*^9}, {3.683112988068356*^9, 3.683112990258404*^9}, {
   3.6831130225694437`*^9, 3.683113025182558*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"c71a3e99-c7f3-44d8-bc2a-6ffc51393895"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImplementMatrixRepresentation", "::", "usage"}], "=", 
   "\"\<ImplementMatrixRepresentation is used internally by \
SpinDynamica.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.683113041817815*^9, 
  3.683113043008443*^9}},ExpressionUUID->"2e732484-5cfb-4e7f-8b72-\
d79a5783b71c"]
}, Closed]],

Cell[CellGroupData[{

Cell["properties of generators", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.683112162928205*^9, 
   3.683112166094643*^9}, {3.683112988068356*^9, 3.683112990258404*^9}, {
   3.6831130225694437`*^9, 3.683113025182558*^9}, {3.6831130675755663`*^9, 
   3.6831130723413258`*^9}, {3.744359260449225*^9, 3.744359261784699*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"bb3cc793-51a7-4fd2-821e-f7aec6b9b419"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PermittedTimeShift", "::", "usage"}], "=", 
   "\"\<PermittedTimeShift is a property of an evolution generator, used \
internally by SpinDynamica.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.683113041817815*^9, 
  3.683113043008443*^9}, {3.683113084005629*^9, 
  3.6831130943890667`*^9}},ExpressionUUID->"931097af-ec87-46c8-a399-\
a467d537dfd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HilbertSpaceCompatibility", "::", "usage"}], "=", 
   "\"\<HilbertSpaceCompatibility is a property of an evolution generator, \
used internally by SpinDynamica.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.683113041817815*^9, 
  3.683113043008443*^9}, {3.683113084005629*^9, 
  3.6831131086954737`*^9}},ExpressionUUID->"4c03497e-284e-47c5-9fbe-\
607d7c12da65"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommonPeriod", "::", "usage"}], "=", 
   "\"\<CommonPeriod calculates the common period of several periodic or \
aperiodic evolution generators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.683113041817815*^9, 
  3.683113043008443*^9}, {3.683113084005629*^9, 3.6831131086954737`*^9}, {
  3.68311734961304*^9, 
  3.6831173812422857`*^9}},ExpressionUUID->"3236618d-cc13-485a-8685-\
7a60ce84f243"]
}, Closed]],

Cell[CellGroupData[{

Cell["LocalGeneratorSymbols", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.456331097882916*^9, 3.4563311002463293`*^9}, {
   3.4628565351716223`*^9, 3.4628565364182262`*^9}, 3.506862467979437*^9, 
   3.6831115144836063`*^9, 3.683111570952672*^9, {3.683112162928205*^9, 
   3.683112166094643*^9}, {3.683112988068356*^9, 3.683112990258404*^9}, {
   3.6831130225694437`*^9, 3.683113025182558*^9}, {3.6831130675755663`*^9, 
   3.6831130723413258`*^9}, {3.744359264551354*^9, 3.744359275287579*^9}, 
   3.744359343733714*^9, {3.744359398891054*^9, 3.744359400186235*^9}},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"332b2685-e277-4a26-96bc-50974a0d9065"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"LocalGeneratorSymbols\",FontSlant->\"Italic\"]\) \
extracts the symbols which define local variables from a generator object. It \
is used internally by \
\!\(\*StyleBox[\"SpinDynamica\",FontSlant->\"Italic\"]\).\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683112176358989*^9, 3.683112194414838*^9}, {
  3.683112994573976*^9, 3.683113006055282*^9}, {3.683113041817815*^9, 
  3.683113043008443*^9}, {3.683113084005629*^9, 3.6831130943890667`*^9}, {
  3.7443592858887367`*^9, 3.7443593598997183`*^9}, {3.744359403887294*^9, 
  3.744359404946109*^9}},ExpressionUUID->"a39973ea-1b1c-4ce2-b1a5-\
23fc8ea69f75"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["PeriodicFunction, ShapeFunction", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.464689355678136*^9, 3.464689360101637*^9}, 
   3.506862496155789*^9, {3.5068637961702957`*^9, 3.5068637993188467`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"5c2c1668-6310-4833-a1ec-cd8a981d8b1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PeriodicFunction", "::", "usage"}], "=", 
   "\"\<PeriodicFunction[t,T,expression] defines a periodic Hamiltonian or \
Liouvillian with period T. The term expression is a function of the time \
variable t. A periodic function which has been defined through \
func=PeriodicFunction[t,T,expression] may be applied using the syntax func[t] \
to generate the expression as a function of time. The period argument T \
determines when derived propagators may be reused.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507025311416098*^9, 3.507025418491522*^9}, {
  3.5070255948990803`*^9, 
  3.507025623996673*^9}},ExpressionUUID->"f2fed372-f799-4502-97bc-\
968857da43a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "::", "usage"}], "=", 
   "\"\<ShapeFunction[t,{\[Tau],x},T,expression] defines a time-dependent \
Hamiltonian or Liouvillian which depends on an absolute time variable t and \
also a relative time variable \[Tau] which is taken relative to the event in \
which the ShapeFunction is used. The variable x is used to specify the time \
origin of the relative time variable \[Tau]. For example x=0 specifies that \
the time origin is the start of the event; x=1 indicates a time origin at the \
end of the event, and x=1/2 indicates a time origin at the middle of the \
event.  The period argument T determines when derived propagators may be \
reused. A ShapeFunction defined through \
func=ShapeFunction[t,{\[Tau],x},T,expression] may be evaluated at any time \
during an event that starts at time point ta and ends at time point tb using \
the syntax func[t,ta,tb]. A ShapeFunction may employ multiple relative time \
variables by using the syntax \
ShapeFunction[t,{{\[Tau]1,x1},{\[Tau]2,x2}..},T,expression].\n\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507025311416098*^9, 3.507025678778759*^9}, {
  3.534738944779448*^9, 3.534739006674241*^9}, {3.5645749697009287`*^9, 
  3.564574975191656*^9}},ExpressionUUID->"adb6e8f7-2ffd-477e-8ffe-\
66b645c38388"]
}, Closed]],

Cell[CellGroupData[{

Cell["Liouvillian", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.464689355678136*^9, 3.464689360101637*^9}, 
   3.506862496155789*^9, {3.5068637961702957`*^9, 3.5068637993188467`*^9}, {
   3.533252958368477*^9, 3.533252963309762*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"59a09975-4466-4538-9501-40342117fafc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "::", "usage"}], "=", 
   "\"\<Liouvillian[generators..] converts an evolution generator, or a list \
of evolution generators, into a Liouvillian superoperator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5332529758254223`*^9, 
  3.5332530238063097`*^9}},ExpressionUUID->"14311ac8-3bf6-4a92-b92c-\
aafc8243ebe8"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"1d342b44-e897-4d46-8909-faf781514c11"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Chronology", "=", "\"\<LeftToRight\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545050393596538*^9, 3.5450503995208893`*^9}, {
  3.545050732985859*^9, 
  3.545050735366548*^9}},ExpressionUUID->"4aed02c3-c234-4079-82b7-\
ed68cb233eee"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"abe39a15-45a6-4fa4-8c75-de1d4857df45"]
}, Closed]],

Cell[CellGroupData[{

Cell["Generators", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.452690506563347*^9}, {
   3.4526906425151577`*^9, 3.452690675101125*^9}, {3.452712675169849*^9, 
   3.452712685532673*^9}, {3.452770736612377*^9, 3.452770745914432*^9}, {
   3.4528340628299294`*^9, 3.4528340639240847`*^9}, 3.4975736975953903`*^9, {
   3.5028403677196217`*^9, 3.502840372078033*^9}, {3.504204304171247*^9, 
   3.5042043103134203`*^9}, 3.5069309517835827`*^9, {3.5414885345095863`*^9, 
   3.54148853944915*^9}, 3.68326558292737*^9, 3.7093743626727962`*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"e068a320-8c3a-4644-823e-e00151631ab1"],

Cell[CellGroupData[{

Cell["PeriodicFunction & ShapeFunction", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, {
  3.7093732093867397`*^9, 
  3.709373216428121*^9}},ExpressionUUID->"9d66437b-f231-42ac-86d7-\
73b245222eb0"],

Cell[CellGroupData[{

Cell["PeriodicFunction", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
  3.504199220904224*^9, 
  3.5041992236306562`*^9}},ExpressionUUID->"e61be5fd-7c40-4e5d-8379-\
96efe6e57a84"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"PeriodicFunction", ",", "HoldAll"}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504199227092238*^9, 
  3.504199240073296*^9}},ExpressionUUID->"a12e3bda-7cb7-4aa8-97fa-\
2c9cc31e6683"],

Cell[CellGroupData[{

Cell["trap inappropriate use", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.50693188645398*^9, 3.506931894156698*^9}, {3.566374020243813*^9, 
  3.5663740247546*^9}},ExpressionUUID->"e289e9db-fe6a-4fe0-9659-a3a86f61c0af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PeriodicFunction", "[", 
     RowBox[{"t_", ",", "T_", ",", "contents_"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"t", ",", 
       RowBox[{"_Symbol", "|", "_Pattern", "|", "_Blank", "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"_Symbol", "|", "_Pattern", "|", "_Blank"}], ")"}], ".."}],
          "}"}]}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"PeriodicFunction", "::", "badt"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5075545239348497`*^9, 3.507554638141971*^9}, {
   3.507554767492694*^9, 3.507554853168043*^9}, {3.507555039813613*^9, 
   3.507555069413374*^9}, {3.5075551719982443`*^9, 3.5075551871246443`*^9}, {
   3.507555282916841*^9, 3.507555287130623*^9}, {3.507555665843354*^9, 
   3.507555670322597*^9}, {3.507555778092084*^9, 3.5075557790575314`*^9}, {
   3.5075561008388433`*^9, 3.507556110044714*^9}, {3.50755618677217*^9, 
   3.50755621834764*^9}, 3.5075564126426153`*^9, {3.507556476660172*^9, 
   3.507556478001525*^9}, 3.508608466789276*^9, 3.508608978194723*^9, {
   3.5086732074094343`*^9, 3.508673212040709*^9}, 3.5086824119608173`*^9, 
   3.508696183449746*^9, {3.50921999996063*^9, 3.509220018628044*^9}, {
   3.509457517579721*^9, 3.5094575181209583`*^9}, {3.566374032328417*^9, 
   3.566374071901155*^9}, 3.566374190475278*^9, {3.5663742569028482`*^9, 
   3.566374293630329*^9}, {3.566374334604311*^9, 3.566374337345353*^9}, {
   3.566374484268982*^9, 3.566374496663252*^9}, {3.56637463700739*^9, 
   3.566374639714649*^9}, {3.566375454139336*^9, 3.5663754703304167`*^9}, {
   3.566375871449383*^9, 3.5663758726702347`*^9}, {3.566376393162073*^9, 
   3.566376398056388*^9}, {3.566376532487135*^9, 3.566376534231326*^9}, {
   3.5663768700836*^9, 
   3.5663768727020903`*^9}},ExpressionUUID->"9f6f0ce2-6b73-45cb-a71c-\
e51fb449b182"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert to ShapeFunction on applying Expand", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.50693188645398*^9, 
  3.506931894156698*^9}},ExpressionUUID->"d3170edf-f1a5-48a9-926e-\
39d1273f3086"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PeriodicFunction", "/:", 
   RowBox[{"Expand", "[", 
    RowBox[{"PeriodicFunction", "[", 
     RowBox[{"t_", ",", "T_", ",", "contents_"}], "]"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[Tau]", "}"}], ",", 
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t", ",", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"{", 
         RowBox[{"\[Tau]", ",", "None"}], "}"}]}], ",", 
       RowBox[{"Evaluate", "@", "T"}], ",", "contents"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506930488424309*^9, 3.506930553928825*^9}, {
   3.5069566906425467`*^9, 3.5069566912153683`*^9}, {3.5110929535008574`*^9, 
   3.511092964098634*^9}, {3.566374419251061*^9, 3.5663744217377357`*^9}, 
   3.566374731502812*^9},ExpressionUUID->"69082505-521d-4123-ae36-\
60403ba6055b"]
}, Closed]],

Cell[CellGroupData[{

Cell["evaluation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
   3.50693188645398*^9, 3.506931921366165*^9}, 
   3.5069322532353783`*^9},ExpressionUUID->"e6b9c4f2-702f-40a6-8e83-\
b428ad25b1a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PeriodicFunction", "[", 
     RowBox[{"t_", ",", "T_", ",", "contents_"}], "]"}], "[", "tval_", "]"}], 
   ":=", 
   RowBox[{"contents", "/.", 
    RowBox[{"{", 
     RowBox[{"t", "\[Rule]", "tval"}], "}"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930742230118*^9, 3.506930744148284*^9}, {
   3.517831402342718*^9, 3.517831455631732*^9}, 3.517833610476132*^9, {
   3.5178336696292677`*^9, 3.5178336972773523`*^9}, 3.566374428729261*^9, 
   3.56637473781945*^9},ExpressionUUID->"96d3e1d8-a162-4af3-ab83-\
479b4ac3f7a4"]
}, Closed]],

Cell[CellGroupData[{

Cell["message", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
   3.50693188645398*^9, 3.506931921366165*^9}, 3.5069322532353783`*^9, {
   3.5663740827959127`*^9, 
   3.566374083953804*^9}},ExpressionUUID->"f013bfa2-4d78-4d6d-a731-\
df6b9e3bd978"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PeriodicFunction", "::", "badt"}], "=", 
   "\"\<The time variable of PeriodicFunction cannot have an assigned value\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566374090614211*^9, 
  3.566374116512569*^9}},ExpressionUUID->"e5bc0baf-da56-46a6-a3b0-\
95d7e40621fe"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ShapeFunction", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.504199220904224*^9, 3.5041992236306562`*^9}, 
   3.506930695417718*^9},ExpressionUUID->"5fa33677-be4c-43de-aa65-\
1e08986fd622"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ShapeFunction", ",", "HoldAll"}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504199227092238*^9, 3.504199240073296*^9}, {
  3.506930399465431*^9, 
  3.5069304016240883`*^9}},ExpressionUUID->"df2f3f66-3122-46c9-85be-\
b828394241d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShapeFunction", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Expand", "\[Rule]", "False"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.684037938621368*^9, 
  3.6840379509215927`*^9}},ExpressionUUID->"1f01cee1-dd7d-4150-b239-\
fcfc6bdf5518"],

Cell[CellGroupData[{

Cell["output format (*disabled *)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 3.5522104203335*^9}, {
   3.5522104538300877`*^9, 3.552210457491542*^9}, {3.691238291378065*^9, 
   3.691238294334557*^9}, 3.691494468709367*^9, {3.6992061781439037`*^9, 
   3.699206182429234*^9}, 
   3.703138504966125*^9},ExpressionUUID->"fe626a31-d8f8-4ee5-97e7-\
d0124056d658"],

Cell["abbreviate unless Expand is applied", "Text",
 CellChangeTimes->{{3.684039624335204*^9, 
  3.6840396302626457`*^9}},ExpressionUUID->"b00edc83-1fdb-48d8-9344-\
8350b1e510ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "arg_", 
        ",", "opts___Rule"}], "]"}], "/;", 
      RowBox[{"!", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Expand", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "ShapeFunction", "]"}]}], ")"}]}]}], "]"}], ":=",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RowBox", "[", 
      RowBox[{
      "{", "\[IndentingNewLine]", "\"\<ShapeFunction[<<..>>]\>\"", 
       "\[IndentingNewLine]", "}"}], "]"}], "//", "DisplayForm"}]}], ";"}], 
  " "}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409242047933*^9}, {3.459411835080905*^9, 3.4594118370779*^9}, 
   3.4594277811731243`*^9, {3.459427811773448*^9, 3.459427814043268*^9}, {
   3.543516067337283*^9, 3.54351607152363*^9}, {3.5435161166946297`*^9, 
   3.543516150245316*^9}, {3.543944472977648*^9, 3.5439444878167267`*^9}, {
   3.5522103412226353`*^9, 3.552210366421303*^9}, {3.564575196019809*^9, 
   3.56457526757395*^9}, {3.564575331857535*^9, 3.5645753321442413`*^9}, 
   3.5645753719636707`*^9, {3.616751552311964*^9, 3.6167515604540777`*^9}, {
   3.684037961099319*^9, 3.6840379967438803`*^9}, {3.684038319532517*^9, 
   3.6840383256214447`*^9}, {3.684038578653755*^9, 3.684038584867961*^9}, {
   3.6840386857529707`*^9, 3.684038688486998*^9}, {3.691238297284779*^9, 
   3.691238300410071*^9}, {3.691493119594133*^9, 3.691493121463402*^9}, {
   3.6992061734480343`*^9, 3.6992061762138367`*^9}, {3.703138475686338*^9, 
   3.703138521052926*^9}, {3.7031385596051292`*^9, 
   3.703138564681919*^9}},ExpressionUUID->"c8a8b9d2-5e09-456d-8f7d-\
3a2e14e9fb25"]
}, Closed]],

Cell[CellGroupData[{

Cell["Expand", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 3.5522104203335*^9}, {
  3.5522104538300877`*^9, 3.552210457491542*^9}, {3.684038007663995*^9, 
  3.6840380089830313`*^9}},ExpressionUUID->"bdfd73da-ad57-4211-bfde-\
241b846cd364"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"UserLevelDependentDefinition", "[", 
    RowBox[{"Expand", ",", "Infinity", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Expand", "[", "a_", "]"}], "/;", 
       RowBox[{"!", 
        RowBox[{"FreeQ", "[", 
         RowBox[{"a", ",", "_ShapeFunction"}], "]"}]}]}], ":=", 
      RowBox[{"a", "/.", 
       RowBox[{"{", 
        RowBox[{"shf_ShapeFunction", ":>", 
         RowBox[{"Expand", "[", "shf", "]"}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6831189892754908`*^9, 3.683119052512022*^9}, {
  3.68311930129748*^9, 3.683119310848708*^9}, {3.684039119191174*^9, 
  3.684039184058563*^9}, {3.745400372460938*^9, 3.745400376194792*^9}, {
  3.745412970570641*^9, 
  3.745412972819092*^9}},ExpressionUUID->"e809c4b3-b11a-4941-abfd-\
a37cb40bc08b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShapeFunction", "/:", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Expand", "|", "ExpandAll"}], ")"}], "[", 
    RowBox[{"ShapeFunction", "[", 
     RowBox[{"args___", ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"args", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"Expand", "\[Rule]", "True"}], ",", "opts"}], "]"}]}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409242047933*^9}, {3.459411835080905*^9, 3.4594118370779*^9}, 
   3.4594277811731243`*^9, {3.459427811773448*^9, 3.459427814043268*^9}, {
   3.543516067337283*^9, 3.54351607152363*^9}, {3.5435161166946297`*^9, 
   3.543516150245316*^9}, {3.543944472977648*^9, 3.5439444878167267`*^9}, {
   3.5522103412226353`*^9, 3.552210366421303*^9}, {3.564575196019809*^9, 
   3.56457526757395*^9}, {3.564575331857535*^9, 3.5645753321442413`*^9}, 
   3.5645753719636707`*^9, {3.616751552311964*^9, 3.6167515604540777`*^9}, {
   3.684037961099319*^9, 3.684038061733614*^9}, {3.684038502504335*^9, 
   3.684038504165616*^9}},ExpressionUUID->"31899959-5665-467f-9a9b-\
a65d3e426d59"]
}, Open  ]],

Cell[CellGroupData[{

Cell["convert to standard form", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.50695353613904*^9, 
  3.5069535395058613`*^9}},ExpressionUUID->"a8d07b17-d8c4-40b7-bfbc-\
b2aac1bf456a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Tau]_", ",", "x_"}], "}"}], ",", "contents_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Tau]", ",", "x"}], "}"}], ",", "All", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"StandardizeGenerator", "@", "contents"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506930618910836*^9, 3.506930647751574*^9}, {
   3.6260965078487673`*^9, 3.626096521085248*^9}, {3.684038077574936*^9, 
   3.6840380781101*^9}, {3.684038354299807*^9, 3.68403835598694*^9}, 
   3.70937402989824*^9},ExpressionUUID->"eca3c481-aab9-4564-8c7a-\
7b25984a4ea8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"{", 
      RowBox[{"\[Tau]_", ",", "x_"}], "}"}], ",", "contents_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", 
     RowBox[{"{", 
      RowBox[{"\[Tau]", ",", "x"}], "}"}], ",", "None", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"StandardizeGenerator", "@", "contents"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506930618910836*^9, 3.506930671409079*^9}, 
   3.62609652585454*^9, {3.684038080693771*^9, 3.68403808101378*^9}, 
   3.6840383600132093`*^9, 
   3.7093740305280037`*^9},ExpressionUUID->"53be78b9-a857-49cc-b091-\
d29d8452d3c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Tau]_", ",", "x_"}], "}"}], ",", "T_", ",", "contents_", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "t", "}"}], ",", 
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t", ",", 
       RowBox[{"{", 
        RowBox[{"\[Tau]", ",", "x"}], "}"}], ",", "T", ",", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"StandardizeGenerator", "@", "contents"}]}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930407443104*^9, 3.5069304671252737`*^9}, {
   3.506930571179804*^9, 3.506930592355472*^9}, {3.506931606194165*^9, 
   3.506931609711033*^9}, 3.626096531652355*^9, {3.684038083382039*^9, 
   3.6840380837497253`*^9}, 3.684038362099909*^9, 
   3.709374031439666*^9},ExpressionUUID->"2186c33c-a395-4a32-9d47-\
7f12b6c3147f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Tau]", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"x", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "T_", ",", 
     "contents_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\[Tau]", ",", "x"}], "}"}], "}"}], ",", "T", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"StandardizeGenerator", "@", "contents"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930407443104*^9, 3.5069304671252737`*^9}, {
   3.506930571179804*^9, 3.506930592355472*^9}, {3.506931606194165*^9, 
   3.506931609711033*^9}, {3.507008926943633*^9, 3.5070089570713177`*^9}, 
   3.626096537993648*^9, {3.6840380864537363`*^9, 3.684038086829507*^9}, 
   3.68403836516495*^9, 
   3.7093740322495613`*^9},ExpressionUUID->"34a01913-7936-4009-9e32-\
e8cd8551a41e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t_", ",", 
     RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
     RowBox[{"num_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Function", "[", 
    RowBox[{"Evaluate", "@", 
     RowBox[{"StandardizeGenerator", "@", "num"}]}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930407443104*^9, 3.5069304671252737`*^9}, {
   3.506930571179804*^9, 3.506930592355472*^9}, {3.506931606194165*^9, 
   3.506931609711033*^9}, {3.507008926943633*^9, 3.5070089570713177`*^9}, {
   3.507116274528141*^9, 3.507116317018528*^9}, {3.626096548230194*^9, 
   3.626096552719174*^9}, {3.6840380903415203`*^9, 3.684038090709613*^9}, 
   3.6840383715887537`*^9, 
   3.709374033059205*^9},ExpressionUUID->"580e3e1d-b526-4758-8adf-\
f062373ca632"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap inappropriate use", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.50693188645398*^9, 3.506931894156698*^9}, {3.566374020243813*^9, 
  3.5663740247546*^9}},ExpressionUUID->"64e7c3fc-2a80-40b4-99b7-cf53fa72a197"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShapeFunction", "[", 
     RowBox[{"t_", ",", 
      RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "___"}], 
     "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"t", ",", 
       RowBox[{"_Symbol", "|", "_Pattern", "|", "_Blank"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ShapeFunction", "::", "badt"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5075545239348497`*^9, 3.507554638141971*^9}, {
   3.507554767492694*^9, 3.507554853168043*^9}, {3.507555039813613*^9, 
   3.507555069413374*^9}, {3.5075551719982443`*^9, 3.5075551871246443`*^9}, {
   3.507555282916841*^9, 3.507555287130623*^9}, {3.507555665843354*^9, 
   3.507555670322597*^9}, {3.507555778092084*^9, 3.5075557790575314`*^9}, {
   3.5075561008388433`*^9, 3.507556110044714*^9}, {3.50755618677217*^9, 
   3.50755621834764*^9}, 3.5075564126426153`*^9, {3.507556476660172*^9, 
   3.507556478001525*^9}, 3.508608466789276*^9, 3.508608978194723*^9, {
   3.5086732074094343`*^9, 3.508673212040709*^9}, 3.5086824119608173`*^9, 
   3.508696183449746*^9, {3.50921999996063*^9, 3.509220018628044*^9}, {
   3.509457517579721*^9, 3.5094575181209583`*^9}, {3.566374032328417*^9, 
   3.566374071901155*^9}, 3.566374190475278*^9, {3.5663742569028482`*^9, 
   3.566374293630329*^9}, {3.566374334604311*^9, 3.566374337345353*^9}, {
   3.566374484268982*^9, 3.566374496663252*^9}, {3.56637463700739*^9, 
   3.566374639714649*^9}, {3.5663747836215353`*^9, 3.566374796643243*^9}, {
   3.566374856375227*^9, 3.566374927777843*^9}, {3.566375692838381*^9, 
   3.566375697102054*^9}, {3.566375802029262*^9, 3.566375806121472*^9}, {
   3.566375841218577*^9, 3.566375842391308*^9}, {3.566376412118945*^9, 
   3.5663764128726873`*^9}, {3.5663765383659077`*^9, 
   3.566376542182917*^9}},ExpressionUUID->"807b10c3-18af-4be4-b0cc-\
0beb7a9e00c2"]
}, Closed]],

Cell[CellGroupData[{

Cell["evaluation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.506931632830904*^9, 3.506931692337262*^9}, {3.506931962538313*^9, 
  3.5069319677370243`*^9}},ExpressionUUID->"6484407e-38ad-4937-8bc9-\
14b46f2b704a"],

Cell[CellGroupData[{

Cell["\<\
evaluation at a particular time, specifying only the absolute time variable\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.506931632830904*^9, 3.506931692337262*^9}, {3.506931975370141*^9, 
  3.5069320040755253`*^9}, {3.506932979662952*^9, 3.506932987493863*^9}, {
  3.507009491093948*^9, 3.507009493650817*^9}, {3.54028173014839*^9, 
  3.540281748585319*^9}},ExpressionUUID->"3f83ce51-54e2-4252-b7bc-\
d214780154f7"],

Cell["\<\
Evaluation is only possible if the local time variable \[Tau] is not used\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5402816027763977`*^9, 3.540281710143366*^9}, {
  3.540281757851692*^9, 
  3.5402818031004543`*^9}},ExpressionUUID->"f5a57328-b9c4-428a-a726-\
ad4416c136a6"],

Cell["\<\
great care is needed to prevent premature evaluation in the case that the \
variable t is already defined\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.540282234336176*^9, 
  3.54028225175124*^9}},ExpressionUUID->"324b41f2-1da9-4439-8f41-\
0c20add38d38"],

Cell["\<\
very complex syntax is needed to allow the time arguments to be replaced \
inside SparseArrays. This does not work by default.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.532184693682878*^9, 
  3.5321847272124043`*^9}},ExpressionUUID->"4fbc646e-b810-4c0b-953d-\
18161fe7e704"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t_", ",", 
       RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "contents_",
        ",", "opts___Rule"}], "]"}], "[", "tval_", "]"}], "/;", 
    RowBox[{"And", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{"contents", ",", 
          RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
       "\[Tau]xpairs"}], ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ReleaseHold", "@", 
    RowBox[{"ReplaceEverywhere", "[", 
     RowBox[{
      RowBox[{"Hold", "[", "contents", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tval"}], "}"}]}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5069329982675467`*^9, 3.506933004635075*^9}, {
   3.506933037211898*^9, 3.506933054644249*^9}, {3.507008982370013*^9, 
   3.507008985120027*^9}, {3.517831477834001*^9, 3.51783147977621*^9}, 
   3.517833570664475*^9, {3.540281812731991*^9, 3.5402818698127813`*^9}, {
   3.540281918241907*^9, 3.5402820134949293`*^9}, {3.540282194949348*^9, 
   3.540282228420083*^9}, {3.5402918748198633`*^9, 3.5402919100891867`*^9}, {
   3.540292094832196*^9, 3.5402921448322887`*^9}, {3.540293890135141*^9, 
   3.540293954220471*^9}, {3.684038102621418*^9, 
   3.6840381029570827`*^9}},ExpressionUUID->"f21046b1-1978-4f9f-be07-\
e403ad18305f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t_", ",", 
       RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "contents_",
        ",", "opts___Rule"}], "]"}], "[", "\[Tau]val_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"contents", ",", 
           RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
        "\[Tau]xpairs"}], ")"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ShapeFunction", "::", "misst"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5069329982675467`*^9, 3.506933004635075*^9}, {
   3.506933037211898*^9, 3.5069330829822407`*^9}, {3.5069333243270607`*^9, 
   3.506933327740507*^9}, {3.507008993555223*^9, 3.5070089970167847`*^9}, 
   3.517831487467579*^9, 3.5178335694320097`*^9, {3.5402818855445013`*^9, 
   3.540281901496408*^9}, {3.684038105221252*^9, 
   3.684038105501008*^9}},ExpressionUUID->"8b2a2009-027f-4a95-afd5-\
24adbe007244"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
evaluation at a particular time, specifying the centre point of the event\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.506931632830904*^9, 3.506931692337262*^9}, {3.506931975370141*^9, 
  3.5069320040755253`*^9}},ExpressionUUID->"825e41d7-6043-4940-8cd3-\
ee5425b64422"],

Cell["\<\
The ShapeFunction is evaluated at a general time tval, specifying also the \
centre point of the event. Evaluation only works if the relative time \
variable \[Tau] is referenced to the same centre point, i.e. using \
{{\[Tau],1/2}..} shape specifications.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5402816027763977`*^9, 
  3.540281710143366*^9}},ExpressionUUID->"0ce8f30a-b935-4aaf-8f46-\
9167a27a2834"],

Cell["\<\
very complex syntax is needed to allow the time arguments to be replaced \
inside SparseArrays. This does not work by default.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.532184693682878*^9, 
  3.5321847272124043`*^9}},ExpressionUUID->"1bf51336-16de-4acc-988e-\
72275d5a1f7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t_", ",", 
       RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "contents_",
        ",", "opts___Rule"}], "]"}], "[", 
     RowBox[{"tval_", ",", "t0_"}], "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"And", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{"Last", "[", "#", "]"}], "-", 
             RowBox[{"(", 
              RowBox[{"1", "/", "2"}], ")"}]}], "]"}], "\[Equal]", "0"}], 
          ")"}], "&"}], "/@", "\[Tau]xpairs"}], ")"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "rules", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"rules", "=", 
        RowBox[{"Sequence", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tval"}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "\[Rule]", 
                RowBox[{"tval", "-", "t0"}]}], ")"}], "&"}], "/@", 
             "\[Tau]xpairs"}], ")"}]}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ReleaseHold", "@", 
        RowBox[{"ReplaceEverywhere", "[", 
         RowBox[{
          RowBox[{"Hold", "[", "contents", "]"}], ",", "rules"}], "]"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930742230118*^9, 3.506930744148284*^9}, {
   3.506931507050561*^9, 3.5069315374672956`*^9}, {3.5069316997511263`*^9, 
   3.5069318038269777`*^9}, {3.506931845661731*^9, 3.5069318645344687`*^9}, 
   3.5069320101521273`*^9, {3.506932099725894*^9, 3.5069321318632717`*^9}, {
   3.5069328924624662`*^9, 3.5069328929394693`*^9}, {3.506953685338222*^9, 
   3.506953688270644*^9}, {3.507009027426553*^9, 3.5070091464922857`*^9}, {
   3.507009188294114*^9, 3.507009217464267*^9}, {3.507009253233199*^9, 
   3.5070092958040524`*^9}, 3.517831493141285*^9, 3.517833567745825*^9, {
   3.532184538219088*^9, 3.532184688218285*^9}, {3.5321847361561537`*^9, 
   3.532184737693151*^9}, {3.533114984975058*^9, 3.5331149888284883`*^9}, 
   3.5402291351002607`*^9, {3.540292150854204*^9, 3.5402921619560347`*^9}, {
   3.540293969156003*^9, 3.5402939747657967`*^9}, {3.5402940112478027`*^9, 
   3.5402940156900253`*^9}, {3.6840381108210707`*^9, 
   3.684038111101058*^9}},ExpressionUUID->"bbff4e3c-febf-4419-a16b-\
c3221b3aeb0e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t_", ",", 
       RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "contents_",
        ",", "opts___Rule"}], "]"}], "[", 
     RowBox[{"tval_", ",", "t0_"}], "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"Or", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{"Last", "[", "#", "]"}], "-", 
             RowBox[{"(", 
              RowBox[{"1", "/", "2"}], ")"}]}], "]"}], "!=", "0"}], ")"}], 
         "&"}], "/@", "\[Tau]xpairs"}], ")"}]}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ShapeFunction", "::", "misstatb"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930742230118*^9, 3.506930744148284*^9}, {
   3.506931507050561*^9, 3.5069315374672956`*^9}, {3.5069316997511263`*^9, 
   3.5069318038269777`*^9}, {3.506931845661731*^9, 3.5069318645344687`*^9}, 
   3.5069320101521273`*^9, {3.506932099725894*^9, 3.5069322141150846`*^9}, 
   3.506933267435383*^9, 3.506953694652575*^9, {3.507009312474353*^9, 
   3.5070093286136103`*^9}, 3.517831495885322*^9, {3.517833543285873*^9, 
   3.5178335630160847`*^9}, {3.684038113964986*^9, 
   3.684038114332609*^9}},ExpressionUUID->"04800707-3bb2-41a0-a3e7-\
86a2cb243730"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
evaluation at a particular time, specifying the start and end point of the \
event\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.506931632830904*^9, 3.506931692337262*^9}, {3.506931975370141*^9, 
  3.506931983202251*^9}},ExpressionUUID->"b20a5a5c-6e88-4d3a-bf4a-\
bdbe6909278d"],

Cell["\<\
The ShapeFunction is evaluated at a general time tval, specifying also the \
start and end point of the event\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5402816027763977`*^9, 
  3.540281634514284*^9}},ExpressionUUID->"ee05f9ec-1cd4-4f18-b01b-\
df4a811f2c07"],

Cell["\<\
The very complex syntax is needed to allow the time arguments to be replaced \
inside SparseArrays. This does not work by default.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.532184693682878*^9, 3.5321847272124043`*^9}, {
  3.5321848998406982`*^9, 
  3.532184900335153*^9}},ExpressionUUID->"4bf68d80-73ab-4871-8a59-\
62af35f8aeae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShapeFunction", "[", 
     RowBox[{"t_", ",", 
      RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "contents_", 
      ",", "opts___Rule"}], "]"}], "[", 
    RowBox[{"tval_", ",", "ta_", ",", "tb_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "rules"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"rules", "=", 
        RowBox[{"Sequence", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tval"}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "\[Rule]", 
                RowBox[{"tval", "-", 
                 RowBox[{"(", 
                  RowBox[{"ta", "+", 
                   RowBox[{
                    RowBox[{"Last", "[", "#", "]"}], "\[Times]", 
                    RowBox[{"(", 
                    RowBox[{"tb", "-", "ta"}], ")"}]}]}], ")"}]}]}], ")"}], 
              "&"}], "/@", "\[Tau]xpairs"}], ")"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ReleaseHold", "@", 
        RowBox[{"ReplaceEverywhere", "[", 
         RowBox[{
          RowBox[{"Hold", "[", "contents", "]"}], ",", "rules"}], "]"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504201025112627*^9, 3.504201075179572*^9}, {
   3.504201169821226*^9, 3.504201182794263*^9}, {3.50423985162332*^9, 
   3.504239861766817*^9}, {3.506930742230118*^9, 3.506930744148284*^9}, {
   3.506931507050561*^9, 3.5069315374672956`*^9}, {3.5069316997511263`*^9, 
   3.5069318038269777`*^9}, {3.506931845661731*^9, 3.5069318645344687`*^9}, 
   3.5069320101521273`*^9, {3.506932099725894*^9, 3.5069321318632717`*^9}, {
   3.5069328924624662`*^9, 3.5069328929394693`*^9}, {3.506953685338222*^9, 
   3.506953688270644*^9}, {3.507009027426553*^9, 3.5070091464922857`*^9}, {
   3.507009188294114*^9, 3.507009217464267*^9}, {3.507009253233199*^9, 
   3.5070092958040524`*^9}, {3.5070093742983313`*^9, 3.507009419358293*^9}, 
   3.517831501453579*^9, {3.5178335386484947`*^9, 3.5178335398776197`*^9}, {
   3.532184744621098*^9, 3.53218480091206*^9}, {3.53311499773149*^9, 
   3.533115019514008*^9}, {3.540228224193377*^9, 3.540228231156487*^9}, {
   3.540228283533586*^9, 3.540228286658445*^9}, {3.540228387906115*^9, 
   3.54022851093314*^9}, 3.540228554054072*^9, 3.5402285888943243`*^9, {
   3.540228637844919*^9, 3.540228641208686*^9}, {3.540228672586156*^9, 
   3.5402287389835453`*^9}, {3.540228853198716*^9, 3.540228873053362*^9}, {
   3.5402289155093527`*^9, 3.5402289199597073`*^9}, {3.540228967220731*^9, 
   3.54022898179263*^9}, {3.540229053655293*^9, 3.540229085729595*^9}, 
   3.540294026256939*^9, {3.684038119068774*^9, 
   3.684038119436657*^9}},ExpressionUUID->"a76ceaf8-92ac-4b7c-b194-\
5389ea8c5b5c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506931571737793*^9, 3.506931575121702*^9}, {
  3.506931632830904*^9, 3.506931692337262*^9}, {3.506931962538313*^9, 
  3.5069319677370243`*^9}, {3.506932065008614*^9, 
  3.50693206618292*^9}},ExpressionUUID->"e1c238ca-3cab-4837-b79a-\
c5b53d4a7074"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "::", "misstatb"}], "=", 
   "\"\<missing start and end time points.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506932184441595*^9, 3.506932194417285*^9}, {
  3.506933252583117*^9, 
  3.506933288153191*^9}},ExpressionUUID->"6fdcdc2b-2c99-482a-b0b4-\
95faad34de04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "::", "misst"}], "=", 
   "\"\<missing time variable.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506933091151156*^9, 3.506933091565569*^9}, {
  3.506933239143153*^9, 
  3.506933248759602*^9}},ExpressionUUID->"0fe8db40-219e-4fe1-8e60-\
6c6ef884f511"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShapeFunction", "::", "badt"}], "=", 
   "\"\<The time variable of ShapeFunction cannot have an assigned \
value\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566374090614211*^9, 3.566374116512569*^9}, {
   3.5663748083134747`*^9, 3.566374813073741*^9}, 3.566374931032783*^9, 
   3.566375796770851*^9},ExpressionUUID->"a526bd17-e580-4caf-b03c-\
79d941268bbf"]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ValidGeneratorQ", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, 
   3.709373676715207*^9},ExpressionUUID->"afaf2222-d756-425f-b858-\
7685b14ccd44"],

Cell[CellGroupData[{

Cell["ValidEvolutionGeneratorQ (obsolete)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, {
  3.709373592713914*^9, 
  3.70937359468182*^9}},ExpressionUUID->"c5d7f6a4-8250-400d-ab42-\
e888dffd13fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidEvolutionGeneratorQ", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"ValidEvolutionGeneratorQ", "::", "usage"}], "]"}], ";", 
     RowBox[{"ValidGeneratorQ", "[", "args", "]"}]}], ")"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.709373270765923*^9, 3.7093733190299263`*^9}, {
  3.7093733836744223`*^9, 3.709373385889963*^9}, {3.7093736332296247`*^9, 
  3.709373638145521*^9}},ExpressionUUID->"9ddf25be-31eb-49dd-8072-\
d2793ac107bf"]
}, Closed]],

Cell[CellGroupData[{

Cell["ValidGeneratorQ", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, 
   3.709373603772938*^9},ExpressionUUID->"b62cac26-f160-43e3-9e5c-\
3cb238c7526e"],

Cell["\<\
detects valid evolution generators: either None, or a number, or an operator, \
a superoperator, or functions that generate these things.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.464254455300824*^9, 3.464254462970779*^9}, {
  3.464255788391189*^9, 
  3.464255819881482*^9}},ExpressionUUID->"0868d41f-8a3f-4a45-a37b-\
118d54f10ab8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", 
    RowBox[{"Hold", "[", "symb_", "]"}], "]"}], ":=", 
   RowBox[{"ValidGeneratorQ", "[", "symb", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543245797140259*^9, 3.543245813797145*^9}, {
   3.657390270395356*^9, 3.65739027289705*^9}, 3.657390311379116*^9, {
   3.7093736830548286`*^9, 
   3.7093736838651037`*^9}},ExpressionUUID->"56e33ef9-1c77-4306-8b2c-\
7bae854b905a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "None", "]"}], "=", "True"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46425452114913*^9, 3.464254528476398*^9}, 
   3.709373684517522*^9},ExpressionUUID->"bf6cd454-7248-4262-9aa8-\
7977cc5dd439"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", 
    RowBox[{"num_", "?", "NumericQ"}], "]"}], ":=", "True"}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455331184765587*^9, 3.455331198410469*^9}, {
   3.464254550126306*^9, 3.464254574588421*^9}, {3.464254661530888*^9, 
   3.4642546662134438`*^9}, 
   3.7093736851034813`*^9},ExpressionUUID->"4a4041d5-15f2-46d9-819a-\
1742b4f16c9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], ":=", "True"}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455331184765587*^9, 3.455331198410469*^9}, {
   3.464254550126306*^9, 3.464254574588421*^9}, 
   3.709373685665238*^9},ExpressionUUID->"f756d9c5-7881-4177-bd45-\
c9e2feb30817"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", 
    RowBox[{"sop_", "?", "SuperoperatorQ"}], "]"}], ":=", "True"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455331184765587*^9, 3.455331198410469*^9}, 
   3.464254550126306*^9, 
   3.7093736862050323`*^9},ExpressionUUID->"66cdeb8d-2e26-4c5c-a3ea-\
619f40db7335"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "_PrecalculatedPropagator", "]"}], ":=", 
   "True"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455331184765587*^9, 3.455331198410469*^9}, 
   3.464254550126306*^9, {3.53891915582618*^9, 3.538919165593247*^9}, 
   3.7093736867350283`*^9},ExpressionUUID->"c646b112-3d73-4cef-8a40-\
ecba772067ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Function", "[", 
      RowBox[{"___", ",", "arg_"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", 
    RowBox[{"arg", ",", "\[IndentingNewLine]", 
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FreeQ", "[", 
          RowBox[{
           RowBox[{"{", "#", "}"}], ",", "$Failed"}], "]"}]}], "&"}], ")"}]}],
      ",", "$Failed", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"_", "?", "NumericQ"}], "|", 
      RowBox[{"_", "?", "OperatorQ"}], "|", 
      RowBox[{"_", "?", "SuperoperatorQ"}]}], ",", "True", ",", 
     "\[IndentingNewLine]", "_", ",", "False"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6915947743265676`*^9, 3.691594886762341*^9}, {
   3.691595037570442*^9, 3.6915950531466208`*^9}, 3.691595174407744*^9, {
   3.691595213108901*^9, 3.691595225477192*^9}, 
   3.709373687217805*^9},ExpressionUUID->"6ff26674-506b-4c6f-9b76-\
3670801d0f77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"PeriodicFunction", "[", 
      RowBox[{"___", ",", "arg_"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", 
    RowBox[{"arg", ",", "\[IndentingNewLine]", 
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FreeQ", "[", 
          RowBox[{
           RowBox[{"{", "#", "}"}], ",", "$Failed"}], "]"}]}], "&"}], ")"}]}],
      ",", "$Failed", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"_", "?", "NumericQ"}], "|", 
      RowBox[{"_", "?", "OperatorQ"}], "|", 
      RowBox[{"_", "?", "SuperoperatorQ"}]}], ",", "True", ",", 
     "\[IndentingNewLine]", "_", ",", "False"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6915947743265676`*^9, 3.6915949006897078`*^9}, 
   3.6915950698218813`*^9, 3.691595177008197*^9, {3.691595217005199*^9, 
   3.69159522821977*^9}, 
   3.70937368776898*^9},ExpressionUUID->"2e846193-a958-4a42-969a-\
3770650f22f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"___", ",", "arg_"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", 
    RowBox[{"arg", ",", "\[IndentingNewLine]", 
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"FreeQ", "[", 
          RowBox[{
           RowBox[{"{", "#", "}"}], ",", "$Failed"}], "]"}]}], "&"}], ")"}]}],
      ",", "$Failed", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"_", "?", "NumericQ"}], "|", 
      RowBox[{"_", "?", "OperatorQ"}], "|", 
      RowBox[{"_", "?", "SuperoperatorQ"}]}], ",", "True", ",", 
     "\[IndentingNewLine]", "_", ",", "False"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6915947743265676`*^9, 3.69159491125071*^9}, 
   3.6915950748121157`*^9, 3.6915951797836323`*^9, {3.691595221853209*^9, 
   3.691595230683074*^9}, 
   3.709373688331504*^9},ExpressionUUID->"dc51e52a-181c-48bf-894e-\
6e456bee25fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "evgen_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "chopevgen", "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"ValidGeneratorQ", "[", "chopevgen", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"chopevgen", "=", 
         RowBox[{"Chop", "[", "evgen", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"chopevgen", ",", "evgen"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.65738970275974*^9, 3.657389876168043*^9}, {
  3.6573899446168633`*^9, 3.657389971534856*^9}, {3.6573903155541477`*^9, 
  3.657390319951705*^9}, {3.6573903603683853`*^9, 3.657390379117989*^9}, {
  3.6573928582863092`*^9, 3.6573929000289907`*^9}, {3.709373688882701*^9, 
  3.7093736894339952`*^9}},ExpressionUUID->"4f1bb0e5-c2f8-4495-841f-\
546e34bbe10c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidGeneratorQ", "[", "_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464254590759153*^9, 3.464254595835739*^9}, 
   3.7093736905477047`*^9},ExpressionUUID->"875fa0dd-6575-407f-80d0-\
ffbf27dbfe76"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["StandardizeGenerator", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.508398843293336*^9, 3.5083988479639072`*^9}, 
   3.7093739511586637`*^9},ExpressionUUID->"6a4f88da-39b8-4784-848c-\
c895735705bc"],

Cell[CellGroupData[{

Cell["StandardizeEvolutionGenerator (obsolete)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, {
   3.709373592713914*^9, 3.70937359468182*^9}, 
   3.709373927779601*^9},ExpressionUUID->"488ca411-d4f8-41b5-b247-\
a2568c39a3e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEvolutionGenerator", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"StandardizeEvolutionGenerator", "::", "usage"}], "]"}], ";", 
     RowBox[{"StandardizeGenerator", "[", "args", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.709373270765923*^9, 3.7093733190299263`*^9}, {
  3.7093733836744223`*^9, 3.709373385889963*^9}, {3.7093736332296247`*^9, 
  3.709373638145521*^9}, {3.709373933542059*^9, 
  3.709373944991089*^9}},ExpressionUUID->"8de60b59-2252-414b-b8fc-\
d477c1a5c23c"]
}, Closed]],

Cell[CellGroupData[{

Cell["StandardizeGenerator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.508398843293336*^9, 3.5083988479639072`*^9}, 
   3.7093739751958733`*^9},ExpressionUUID->"6f68d99a-aeed-47c8-988e-\
88b63605fed9"],

Cell["\<\
This routine ensures that all ShapeFunctions and similar evolution generators \
in the event lists are put into a standard form. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.583415884292903*^9, 
  3.583415923931601*^9}},ExpressionUUID->"116f1c06-ef2e-496a-bd52-\
e8955b936be1"],

Cell["\<\
From v2.7.1b2, this routine does not implement matrix representations of \
Operators and Superoperators or check the types of operators/superoperators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.583415928139522*^9, 
  3.583415974018056*^9}},ExpressionUUID->"d5d5266e-7647-4b95-a64a-\
d67d98b9e3a3"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 3.508398911891033*^9}, {3.532254255161021*^9, 
  3.532254256261918*^9}},ExpressionUUID->"a176fccf-3576-45b3-9a75-\
af9548b32b77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "StandardizeGenerator", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532254260355729*^9, 3.532254294716791*^9}, {
   3.532255401919065*^9, 3.532255414447204*^9}, {3.532255470854548*^9, 
   3.5322554721183643`*^9}, {3.532256251722691*^9, 3.532256258249805*^9}, {
   3.533342689069645*^9, 3.5333427095860786`*^9}, {3.542211706586104*^9, 
   3.5422117072954493`*^9}, {3.54295537439185*^9, 3.5429553780622053`*^9}, {
   3.583229911555759*^9, 3.583229912161995*^9}, {3.5834155943768263`*^9, 
   3.5834155988938923`*^9}, {3.583415993216466*^9, 3.583415994626659*^9}, 
   3.7093739770246077`*^9},ExpressionUUID->"09f14559-0633-426e-93c0-\
56b75a0b45c0"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap $Failed", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
  3.508400048530612*^9, 3.508400049817347*^9}, {3.5084010002390127`*^9, 
  3.508401006853374*^9}, {3.5323489993550386`*^9, 3.532349002964409*^9}, {
  3.633439053002577*^9, 3.633439055576214*^9}, {3.69159365207099*^9, 
  3.691593654186797*^9}},ExpressionUUID->"90369acf-1a67-4993-a7aa-\
a5765c64b921"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeGenerator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691593661773364*^9, 3.69159368157213*^9}, 
   3.7093739779672527`*^9},ExpressionUUID->"7eaff18b-3f84-406d-b7ad-\
a37fa8570183"]
}, Closed]],

Cell[CellGroupData[{

Cell["held generators", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 3.508398911891033*^9}, {3.533308412243518*^9, 
  3.5333084128243303`*^9}},ExpressionUUID->"48d2b904-e6d4-47a0-9e08-\
8118359ea8d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"Hold", "[", "args___", "]"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", "args", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5333084169196777`*^9, 3.533308429211875*^9}, {
  3.7093739786984787`*^9, 
  3.709373979418538*^9}},ExpressionUUID->"58e4064a-efe1-4bce-ab57-\
e83251c2a648"]
}, Closed]],

Cell[CellGroupData[{

Cell["null generators", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 
  3.508398911891033*^9}},ExpressionUUID->"25365391-9bde-420f-89d1-\
dd448f8d56cd"],

Cell["v6.1.b3: a change in treatment of None", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5661562260813637`*^9, 
  3.566156237503063*^9}},ExpressionUUID->"2aa52fb6-f684-4614-87b7-\
1213f52ac76f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NonStandardNullGeneratorPattern", "=", 
   RowBox[{"None", "|", "0", "|", 
    RowBox[{"n_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"_", "?", "NumericQ"}]}], "]"}], "&&", 
         RowBox[{
          RowBox[{"Chop", "[", "#", "]"}], "\[Equal]", "0"}]}], ")"}], "&"}], 
      ")"}]}], "|", 
    RowBox[{"NullSuperoperator", "[", "]"}], "|", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Function", "[", 
      RowBox[{"___", ",", 
       RowBox[{"0", "|", 
        RowBox[{"n_", "?", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"#", ",", 
               RowBox[{"_", "?", "NumericQ"}]}], "]"}], "&&", 
             RowBox[{
              RowBox[{"Chop", "[", "#", "]"}], "\[Equal]", "0"}]}], ")"}], 
           "&"}], ")"}]}], "|", "None", "|", 
        RowBox[{"NullOperator", "[", "]"}], "|", 
        RowBox[{"NullSuperoperator", "[", "]"}]}]}], "]"}]}], "|", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"___", ",", 
       RowBox[{"0", "|", 
        RowBox[{"n_", "?", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"#", ",", 
               RowBox[{"_", "?", "NumericQ"}]}], "]"}], "&&", 
             RowBox[{
              RowBox[{"Chop", "[", "#", "]"}], "\[Equal]", "0"}]}], ")"}], 
           "&"}], ")"}]}], "|", "None", "|", 
        RowBox[{"NullOperator", "[", "]"}], "|", 
        RowBox[{"NullSuperoperator", "[", "]"}]}]}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.592993409808173*^9, 3.59299342452101*^9}, {
   3.592993473978195*^9, 3.592993476234131*^9}, {3.592995762140287*^9, 
   3.592995777481196*^9}, {3.592996408837503*^9, 3.592996413850794*^9}, {
   3.61840366716669*^9, 3.618403668897683*^9}, {3.61840372039112*^9, 
   3.618403750596229*^9}, 
   3.709374380656316*^9},ExpressionUUID->"c8d42778-ce17-4dd2-849d-\
bd29174b8e93"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullGeneratorPattern", "=", 
   RowBox[{
    RowBox[{"NullOperator", "[", "]"}], "|", 
    "NonStandardNullGeneratorPattern"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.592995910417893*^9, 3.5929959197620497`*^9}, {
  3.592996417743132*^9, 3.59299642211057*^9}, {3.709374383187278*^9, 
  3.709374384481091*^9}},ExpressionUUID->"1b9becc3-ce86-4f7b-81a0-\
9b54fc88a23a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"NonStandardNullGeneratorPattern", ",", "opts___Rule"}], "]"}], 
   "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5661561878646708`*^9, 3.566156211662228*^9}, {
   3.592993440472179*^9, 3.5929934430447817`*^9}, 3.592993483553626*^9, {
   3.592995781174468*^9, 3.592995781797174*^9}, 3.5929964267369823`*^9, 
   3.7093739804648*^9, 
   3.7093743860338*^9},ExpressionUUID->"83adf376-babe-4b16-8f7c-6c950b100edf"]
}, Closed]],

Cell[CellGroupData[{

Cell["clean up by chopping", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 3.508398911891033*^9}, {3.508399264154567*^9, 
  3.508399269345091*^9}, {3.6260965836130342`*^9, 3.626096588370967*^9}, {
  3.6260966254983263`*^9, 3.626096633767386*^9}, {3.6260969609245367`*^9, 
  3.626096969891028*^9}, {3.65771172463587*^9, 
  3.657711737615137*^9}},ExpressionUUID->"b2e0882d-f933-49e0-bf8e-\
a14a11c2a819"],

Cell["\<\
sometimes necessary when an EnsembleAverage generates a 0. term\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62609700735631*^9, 3.626097027044447*^9}, {
  3.6577117476902*^9, 
  3.6577117640464277`*^9}},ExpressionUUID->"f4cf7a22-ba74-4552-8af1-\
05db9a198786"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", "evgen_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "chopevgen", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"StandardizeGenerator", "[", "chopevgen", "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"chopevgen", "=", 
         RowBox[{"Chop", "[", "evgen", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"chopevgen", ",", "evgen"}], "]"}]}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626096600744947*^9, 3.6260966014116488`*^9}, {
  3.626096712702096*^9, 3.626096873015769*^9}, {3.626096914079709*^9, 
  3.6260969240121307`*^9}, {3.6573937194710617`*^9, 3.657393813947933*^9}, {
  3.657711623721169*^9, 3.657711668383*^9}, {3.709373981499984*^9, 
  3.709373982366046*^9}},ExpressionUUID->"6f09c1ab-3e95-42dd-82e4-\
97aeab417b18"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization of functions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 3.508398911891033*^9}, {3.508399264154567*^9, 
  3.508399269345091*^9}},ExpressionUUID->"0cb21085-cb9d-447c-94b7-\
0f7c626d9836"],

Cell[CellGroupData[{

Cell["convert raw Function into simple form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50694410533797*^9, 3.506944119156746*^9}, 
   3.506944367602734*^9, {3.507009796367963*^9, 3.507009835479603*^9}, {
   3.507021001423954*^9, 3.507021016213599*^9}, 
   3.507022818123693*^9},ExpressionUUID->"63c7f274-f545-42df-b70c-\
8c8f27dc8fcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", "args_", "]"}]}], ",", "opts___Rule"}], "]"}], 
   ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"args", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944804967346*^9, 3.506944817798531*^9}, 
   3.506954773120839*^9, {3.507020973952664*^9, 3.507020976557521*^9}, 
   3.50839905573031*^9, {3.532254318406602*^9, 3.53225434265073*^9}, {
   3.709373983277348*^9, 
   3.709373984098564*^9}},ExpressionUUID->"6d905549-60bc-44b4-b3af-\
c4dc022d36e6"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert single Function into ShapeFunction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50694410533797*^9, 3.506944119156746*^9}, 
   3.506944367602734*^9, {3.507009796367963*^9, 3.507009835479603*^9}, {
   3.507021001423954*^9, 3.5070210019011393`*^9}, 
   3.507022821409315*^9},ExpressionUUID->"5e3eadcb-41df-4f8f-81eb-\
d875e2f70ef7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{"t_", ",", "args_"}], "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]", ",", "x"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", "x"}], "}"}], ",", "None", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
              "}"}]}], "\[IndentingNewLine]", "]"}]}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opts"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.5069442354361477`*^9}, {
   3.5069443721649237`*^9, 3.506944381485186*^9}, {3.506954613239623*^9, 
   3.506954616212503*^9}, 3.5083990869867773`*^9, {3.53225435504667*^9, 
   3.5322543825679197`*^9}, {3.532451230314282*^9, 3.5324512330476503`*^9}, {
   3.532451326646263*^9, 3.532451348717703*^9}, 3.532451533154914*^9, {
   3.5402262041885443`*^9, 3.5402262505120707`*^9}, {3.540226611601486*^9, 
   3.540226616125284*^9}, {3.5402294770370817`*^9, 3.54022948289834*^9}, {
   3.540285682005887*^9, 3.5402856918111057`*^9}, {3.54029403897328*^9, 
   3.540294073996585*^9}, {3.540294373650237*^9, 3.540294373913258*^9}, {
   3.709373985101327*^9, 
   3.709373986078885*^9}},ExpressionUUID->"605caa8a-87be-498a-8b70-\
bb6eb0275e80"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"t_", ",", "t0_"}], "}"}], ",", "args_"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", 
           RowBox[{"1", "/", "2"}]}], "}"}], ",", "None", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
               ",", 
               RowBox[{
                RowBox[{"HoldPattern", "[", "t0", "]"}], "\[Rule]", 
                RowBox[{"tloc", "-", "\[Tau]"}]}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", "opts"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.506944313401552*^9}, {
   3.506944387134081*^9, 3.5069443942542458`*^9}, 3.506954621391386*^9, {
   3.507033464279119*^9, 3.5070334647641172`*^9}, {3.507033543625066*^9, 
   3.507033547009104*^9}, 3.5083990895871468`*^9, {3.532254389357172*^9, 
   3.5322544036401567`*^9}, {3.532451358298019*^9, 3.532451402204401*^9}, {
   3.5324514375868*^9, 3.5324514585616693`*^9}, 3.532451525091765*^9, {
   3.5402262654676437`*^9, 3.54022629835896*^9}, {3.540226664440824*^9, 
   3.540226667427739*^9}, {3.5402294898697968`*^9, 3.540229507914228*^9}, {
   3.540285697761936*^9, 3.540285702732592*^9}, {3.540294091835894*^9, 
   3.540294104575296*^9}, {3.540294381046303*^9, 3.540294381463935*^9}, {
   3.709373987878833*^9, 
   3.709373988925215*^9}},ExpressionUUID->"82c0ce0b-bb68-4c0e-909e-\
6d6626d34d74"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"t_", ",", "ta_", ",", "tb_"}], "}"}], ",", "args_"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", "0"}], "}"}], ",", "None", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
               ",", 
               RowBox[{
                RowBox[{"HoldPattern", "[", "ta", "]"}], "\[Rule]", 
                RowBox[{"tloc", "-", "\[Tau]"}]}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", "opts"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.506944350764113*^9}, {
   3.506944397766821*^9, 3.506944405038794*^9}, 3.5069546233598433`*^9, {
   3.50703356781046*^9, 3.507033571690481*^9}, 3.508399091626124*^9, {
   3.5322544167193623`*^9, 3.532254427664542*^9}, {3.532451464447311*^9, 
   3.5324515296377163`*^9}, {3.540226307247253*^9, 3.54022633217383*^9}, {
   3.540226670262128*^9, 3.540226673315962*^9}, {3.540229513980403*^9, 
   3.540229521129871*^9}, {3.540285710303608*^9, 3.540285715877694*^9}, {
   3.540294115642996*^9, 3.540294129446471*^9}, {3.5402943903959913`*^9, 
   3.540294390688568*^9}, {3.709373989667542*^9, 
   3.709373990410391*^9}},ExpressionUUID->"4db0ddd9-d800-409b-899d-\
e935620ba4c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert single PeriodicFunction into ShapeFunction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50694410533797*^9, 3.506944119156746*^9}, {
  3.507009804183221*^9, 3.507009831759407*^9}, {3.507022811915203*^9, 
  3.507022812928665*^9}},ExpressionUUID->"bbc3439e-6e6b-49fb-bc1f-\
1ea26e7d3c0e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"PeriodicFunction", "[", 
      RowBox[{"t_", ",", "T_", ",", "args_"}], "]"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]", ",", "x"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", "x"}], "}"}], ",", "T", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
              "}"}]}], "\[IndentingNewLine]", "]"}]}]}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opts"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.5069442354361477`*^9}, 
   3.5083991141066513`*^9, {3.508400159352354*^9, 3.508400160880088*^9}, {
   3.53225444244812*^9, 3.532254450932259*^9}, {3.532255271357601*^9, 
   3.532255295766633*^9}, {3.534473451293961*^9, 3.5344734542640133`*^9}, {
   3.5402263405120077`*^9, 3.54022636051633*^9}, {3.540226677412696*^9, 
   3.5402266821778708`*^9}, {3.540229524875119*^9, 3.5402295271290503`*^9}, {
   3.540285732072873*^9, 3.540285737630026*^9}, {3.540294140259995*^9, 
   3.540294160698804*^9}, {3.540294397299857*^9, 3.540294397528495*^9}, {
   3.70937399140026*^9, 
   3.709373992075244*^9}},ExpressionUUID->"dc2ff83e-c935-46ec-b6a5-\
7d09048c4b52"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"PeriodicFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"t_", ",", "t0_"}], "}"}], ",", "T_", ",", "args_"}], "]"}], 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", 
           RowBox[{"1", "/", "2"}]}], "}"}], ",", "T", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
               ",", 
               RowBox[{"\[Tau]", "\[Rule]", 
                RowBox[{"tloc", "-", "t0"}]}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.506944313401552*^9}, 
   3.508399116922851*^9, {3.508399747495578*^9, 3.508399747863741*^9}, 
   3.50840016647043*^9, {3.5322544592248507`*^9, 3.532254472509227*^9}, {
   3.5322552471825647`*^9, 3.53225526455263*^9}, {3.532255300012772*^9, 
   3.532255302380321*^9}, {3.540226365133442*^9, 3.540226385908032*^9}, {
   3.5402295323311872`*^9, 3.54022953400108*^9}, {3.5402857437797403`*^9, 
   3.5402857498711042`*^9}, {3.540294169319882*^9, 3.5402941832835283`*^9}, {
   3.540294403268878*^9, 3.540294403553308*^9}, {3.7093739927392063`*^9, 
   3.709373993492956*^9}},ExpressionUUID->"a9a3a9c7-c525-4347-a671-\
f8786562bdbe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"PeriodicFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"t_", ",", "ta_", ",", "tb_"}], "}"}], ",", "T_", ",", 
       "args_"}], "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tloc", ",", "\[Tau]"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", 
         RowBox[{"{", 
          RowBox[{"\[Tau]", ",", "0"}], "}"}], ",", "T", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"ReleaseHold", "@", 
           RowBox[{"ReplaceEverywhere", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Hold", "[", "args", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", "tloc"}], 
               ",", 
               RowBox[{"\[Tau]", "\[Rule]", 
                RowBox[{"t", "-", "ta"}]}]}], "}"}]}], "\[IndentingNewLine]", 
            "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944138686933*^9, 3.506944350764113*^9}, 
   3.508399119186882*^9, 3.508400168656336*^9, {3.532254462143463*^9, 
   3.532254480382701*^9}, {3.53225520297713*^9, 3.53225524034921*^9}, {
   3.532255304572817*^9, 3.532255306860813*^9}, {3.540226394204583*^9, 
   3.540226408683648*^9}, {3.54022954675489*^9, 3.540229548545368*^9}, {
   3.540285756845365*^9, 3.540285761264093*^9}, {3.54029418945089*^9, 
   3.540294202027111*^9}, {3.540294408612715*^9, 3.5402944089298477`*^9}, {
   3.709373994347857*^9, 
   3.709373995146564*^9}},ExpressionUUID->"75188b11-a620-4c95-93fd-\
76e37b8cd6c2"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle null-valued functions", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.50694410533797*^9, 3.506944119156746*^9}, {
  3.507009804183221*^9, 3.507009831759407*^9}, {3.507022811915203*^9, 
  3.507022812928665*^9}, {3.508397340334896*^9, 3.5083973565250063`*^9}, {
  3.531994329813455*^9, 3.531994333420295*^9}, {3.532254038136079*^9, 
  3.532254039018289*^9}},ExpressionUUID->"047e9893-3b91-4d4c-acdc-\
4d7ff9eed2c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"t", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        "NonStandardNullGeneratorPattern", ",", "___Rule"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.508397369336054*^9, 3.5083974260788527`*^9}, {
   3.508397531189459*^9, 3.5083975548739643`*^9}, {3.508397683036355*^9, 
   3.508397686993635*^9}, {3.50839914276122*^9, 3.5083991466709633`*^9}, 
   3.532254496416738*^9, {3.592996504112196*^9, 3.5929965128402853`*^9}, 
   3.7093739961925697`*^9, 
   3.709374387642563*^9},ExpressionUUID->"b2aea9b9-a86c-4328-98f8-\
aa7cde6313ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"PeriodicFunction", "[", 
       RowBox[{
        RowBox[{"t", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"T", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        "NonStandardNullGeneratorPattern", ",", "___Rule"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.508397369336054*^9, 3.508397440711286*^9}, {
   3.508397534475789*^9, 3.508397557402225*^9}, 3.508397693341362*^9, {
   3.508399150369411*^9, 3.5083991537831984`*^9}, 3.532254501502755*^9, {
   3.592996519790841*^9, 3.5929965251168947`*^9}, 3.709373996856668*^9, 
   3.7093743888349*^9},ExpressionUUID->"997ab8e3-7195-44e9-b826-d659ccd33d5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{
        RowBox[{"t", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", 
        RowBox[{"T", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        "NonStandardNullGeneratorPattern", ",", "___Rule"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.508397369336054*^9, 3.508397475264181*^9}, {
   3.5083975374196053`*^9, 3.508397560754838*^9}, 3.5083976952202053`*^9, {
   3.5083991580418453`*^9, 3.5083991613033657`*^9}, 3.53225450502348*^9, {
   3.592996531686689*^9, 3.592996536326378*^9}, 3.7093739974863443`*^9, 
   3.7093743908377*^9},ExpressionUUID->"a74e8b45-febb-44f2-8e00-0501d391f8b4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization of ShapeFunction", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938352040963*^9, 3.463938359758416*^9}, {3.46394094117033*^9, 
  3.4639409417208157`*^9}, {3.504199373221072*^9, 3.504199424075447*^9}, {
  3.5069309736242332`*^9, 3.506930976086213*^9}, {3.506945016642775*^9, 
  3.506945020272025*^9}, {3.50840010384359*^9, 
  3.508400107312964*^9}},ExpressionUUID->"d7ca61b3-10c0-4116-8351-\
38cd6ebc6f64"],

Cell[CellGroupData[{

Cell["trap $Failed", "Subsubsection",
 CellChangeTimes->{{3.6915939192731524`*^9, 
  3.69159392487508*^9}},ExpressionUUID->"f08e2051-e33b-4aaa-b54b-\
4deb7614b346"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeGenerator", "[", 
     RowBox[{
      RowBox[{"HoldPattern", "@", 
       RowBox[{"ShapeFunction", "[", "args___", "]"}]}], ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], "=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691593947715639*^9, 3.691594002279999*^9}, 
   3.7093739982063913`*^9},ExpressionUUID->"2b11dacf-a2a8-432e-ad9d-\
484627269086"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization", "Subsubsection",
 CellChangeTimes->{{3.6915939192731524`*^9, 
  3.691593935026013*^9}},ExpressionUUID->"fee4fbb2-37a9-47ba-a970-\
4439c958229c"],

Cell["\<\
replace all \[Tau] variables by local variables. This is important for the \
superposition of different shape functions\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5070109656675673`*^9, 
  3.50701101873324*^9}},ExpressionUUID->"5351bd80-73db-4764-a8ca-\
58f7a65bb4ee"],

Cell["\<\
standardize the operator or superoperator expressions inside the ShapeFunction\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.531994436831575*^9, 
  3.531994453501894*^9}},ExpressionUUID->"49e54a8d-83c9-451b-9e9c-\
4532f75fc1cd"],

Cell["\<\
do not check the OperatorType or SuperoperatorType since this is difficult to \
do for time-dependent expressions\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.53225506963398*^9, 
  3.532255098949807*^9}},ExpressionUUID->"e4b64e13-1151-48ad-b496-\
b10839f25a67"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "expr_"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Tau]vars", ",", "\[Tau]loc", ",", "\[Tau]locvars", ",", "tloc"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Tau]vars", "=", 
        RowBox[{"First", "/@", "\[Tau]xpairs"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Tau]locvars", "=", 
        RowBox[{"Array", "[", 
         RowBox[{"\[Tau]loc", ",", 
          RowBox[{"Length", "[", "\[Tau]vars", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"tloc", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"\[Tau]locvars", ",", 
             RowBox[{"Last", "/@", "\[Tau]xpairs"}]}], "}"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "T", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ReleaseHold", "@", 
             RowBox[{"ReplaceEverywhere", "[", 
              RowBox[{
               RowBox[{"Hold", "[", "expr", "]"}], ",", 
               RowBox[{"Join", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"MapThread", "[", 
                  RowBox[{"Rule", ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Tau]vars", ",", "\[Tau]locvars"}], "}"}]}], 
                  "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"HoldPattern", "[", "t", "]"}], "\[Rule]", 
                   "tloc"}], "}"}]}], "]"}]}], "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Evaluate", "@", 
             RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}], ",", 
               "\[IndentingNewLine]", "opts"}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506955309176689*^9, 3.5069553292635307`*^9}, {
   3.5070099037691917`*^9, 3.5070099078882504`*^9}, {3.507011040978593*^9, 
   3.507011224817183*^9}, {3.507011348121941*^9, 3.507011359575656*^9}, 
   3.507011443752904*^9, {3.5084001166099167`*^9, 3.508400131041061*^9}, {
   3.531994403220195*^9, 3.531994411239462*^9}, {3.532254523020123*^9, 
   3.5322545361691113`*^9}, {3.5322550346191998`*^9, 3.5322550648268347`*^9}, 
   3.532255380075059*^9, {3.5322556651370173`*^9, 3.532255667381682*^9}, {
   3.532256266125556*^9, 3.5322562687381153`*^9}, {3.532256931215542*^9, 
   3.532256937476162*^9}, {3.5402260093045797`*^9, 3.540226101401647*^9}, {
   3.540229431578682*^9, 3.540229442751321*^9}, {3.540285504530113*^9, 
   3.540285526869268*^9}, 3.540291716069211*^9, {3.5402942271506567`*^9, 
   3.54029425115689*^9}, 3.621573341360086*^9, {3.70937399894943*^9, 
   3.709373999646894*^9}},ExpressionUUID->"4a67e4b5-4e26-4c3e-a863-\
294063664ad0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization of a CommutationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938352040963*^9, 3.463938359758416*^9}, {3.46394094117033*^9, 
  3.4639409417208157`*^9}, {3.504199373221072*^9, 3.504199424075447*^9}, {
  3.5069309736242332`*^9, 3.506930976086213*^9}, {3.506945016642775*^9, 
  3.506945020272025*^9}, {3.50840010384359*^9, 3.508400107312964*^9}, {
  3.7260699992081394`*^9, 
  3.7260700028358717`*^9}},ExpressionUUID->"76fb608c-d115-4404-af8d-\
87ad4ee14f86"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StandardizeGenerator", "[", 
   RowBox[{"BackgroundGenerator", "\[Rule]", " ", "SO_"}], "]"}], ":=", 
  RowBox[{"BackgroundGenerator", "\[Rule]", " ", 
   RowBox[{"StandardizeGenerator", "[", "SO", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.703182336657569*^9, 3.7031823487965527`*^9}, {3.703189725302677*^9, 
   3.703189772532707*^9}, {3.7031928049853754`*^9, 3.703192811497009*^9}, {
   3.709375123414399*^9, 3.709375123416963*^9}, {3.726070077226637*^9, 
   3.7260700884395466`*^9}},ExpressionUUID->"f09541ce-a1ac-42fe-8e08-\
9053131407f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"ShapeFunction", "[", 
     RowBox[{"t_", ",", 
      RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
      RowBox[{"op_", "?", "SuperoperatorQ"}]}], "]"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
     RowBox[{"StandardizeGenerator", "[", "op", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.703182336657569*^9, 3.7031823487965527`*^9}, {3.703189725302677*^9, 
   3.703189772532707*^9}, {3.7031928049853754`*^9, 3.7031928471353397`*^9}, {
   3.7260700852614465`*^9, 
   3.7260700934219503`*^9}},ExpressionUUID->"5d233f72-1246-4526-9def-\
a45594a0462f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"SO", ":", 
     RowBox[{"{", "___", "}"}]}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "/@", "SO"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.703182336657569*^9, 3.7031823487965527`*^9}, {3.703189725302677*^9, 
   3.7031897268237653`*^9}, {3.7031928808873367`*^9, 3.703192903255248*^9}, 
   3.7031942381355295`*^9, 3.70323499321094*^9, 3.7169831993599777`*^9, 
   3.716983937919221*^9, {3.716984015446655*^9, 3.7169840219430265`*^9}, {
   3.716984104990776*^9, 3.716984107927944*^9}, {3.7185321421436357`*^9, 
   3.7185321469376507`*^9}, {3.718532183510648*^9, 3.7185321959575105`*^9}, {
   3.726070100238839*^9, 
   3.726070102432335*^9}},ExpressionUUID->"96d5f75d-7e62-46bd-aa28-\
776d5bcc57bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StandardizeGenerator", "[", "SO_", "]"}], ":=", 
  RowBox[{"SO", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", "Op___", "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"CommutationSuperoperator", "[", 
      RowBox[{"Total", "[", 
       RowBox[{"StandardizeGenerator", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"List", "@@", 
            RowBox[{"ExpandAll", "[", 
             RowBox[{"Op", "+", "\"\<dummy\>\""}], "]"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{"\"\<dummy\>\"", "\[Rule]", " ", "Nothing"}], "}"}]}], 
          ")"}], ",", "\"\<2\>\""}], "]"}], "]"}], "]"}]}], 
    "}"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.703182336657569*^9, 3.7031823487965527`*^9}, {3.703189725302677*^9, 
   3.7031897268237653`*^9}, {3.7031928808873367`*^9, 3.703192903255248*^9}, 
   3.7031942381355295`*^9, 3.70323499321094*^9, 3.7169831993599777`*^9, 
   3.716983937919221*^9, {3.716984015446655*^9, 3.7169840219430265`*^9}, {
   3.716984104990776*^9, 3.716984107927944*^9}, {3.7185321421436357`*^9, 
   3.7185321469376507`*^9}, {3.7191700240550823`*^9, 
   3.7191700292141657`*^9}, {3.719170134432644*^9, 3.7191701368635473`*^9}, {
   3.726070104890891*^9, 
   3.7260701117261624`*^9}},ExpressionUUID->"e94b7327-ba99-408f-8534-\
cf897465fd3b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"StandardizeGenerator", "[", 
   RowBox[{
    RowBox[{"SO", ":", 
     RowBox[{"{", "___", "}"}]}], ",", "\"\<2\>\""}], "]"}], ":=", 
  RowBox[{
   RowBox[{"1.", "*", "SO"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[Alpha]_", "?", "NumericQ"}], " ", "Op_"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"N", "[", "\[Alpha]", "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Complex", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"I", "*", " ", 
             RowBox[{"Sign", "[", "b", "]"}], 
             RowBox[{"Abs", "[", "b", "]"}]}]}], ",", 
           RowBox[{"a_", "\[RuleDelayed]", " ", 
            RowBox[{
             RowBox[{"-", "I"}], "*", 
             RowBox[{"Sign", "[", "a", "]"}], 
             RowBox[{"Abs", "[", "a", "]"}]}]}]}], "}"}]}], ")"}], "Op"}]}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Alpha]_", "?", "NumericQ"}], " ", "Op_"}], "\[RuleDelayed]",
       " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"N", "[", "\[Alpha]", "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Complex", "[", 
            RowBox[{"a_", ",", "0"}], "]"}], "\[RuleDelayed]", " ", 
           RowBox[{
            RowBox[{"-", "I"}], "*", "a"}]}], "}"}]}], ")"}], "Op"}]}]}], 
    "}"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.703182336657569*^9, 3.7031823487965527`*^9}, {3.703189725302677*^9, 
   3.7031897268237653`*^9}, {3.7031928808873367`*^9, 3.703192903255248*^9}, 
   3.7031942381355295`*^9, 3.70323499321094*^9, 3.7169831993599777`*^9, 
   3.716983937919221*^9, {3.716984015446655*^9, 3.7169840219430265`*^9}, {
   3.716984104990776*^9, 3.716984107927944*^9}, 3.7183480006021967`*^9, {
   3.7185321495111465`*^9, 3.718532150628132*^9}, 
   3.7260701161567574`*^9},ExpressionUUID->"ec6dbf7d-de2d-4965-a236-\
049664803774"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
interpret any non-zero numeric item as a multiple of UnityOperator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938352040963*^9, 3.463938359758416*^9}, {3.508399781318812*^9, 
  3.508399783116282*^9}, {3.531994467071958*^9, 
  3.531994473933662*^9}},ExpressionUUID->"aa1fe830-0ecf-450a-ba4f-\
b76ac95d8b27"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeGenerator", "[", 
     RowBox[{
      RowBox[{"n1_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"n1", ",", 
      RowBox[{"Except", "[", "0", "]"}]}], "]"}]}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"n1", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506944969000277*^9, 3.506944976912945*^9}, {
  3.5083993550297194`*^9, 3.508399424113429*^9}, {3.532254549289118*^9, 
  3.532254576782695*^9}, {3.7093740005127707`*^9, 
  3.7093740012213507`*^9}},ExpressionUUID->"980bb3e3-2213-40a1-8804-\
ce53b39a4ab2"]
}, Closed]],

Cell[CellGroupData[{

Cell["anything else: leave unchanged", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
  3.508400048530612*^9, 3.508400049817347*^9}, {3.5084010002390127`*^9, 
  3.508401006853374*^9}, {3.5323489993550386`*^9, 3.532349002964409*^9}, {
  3.633439053002577*^9, 
  3.633439055576214*^9}},ExpressionUUID->"35a2e3be-4872-4552-bbc6-\
307bddef3d24"],

Cell[CellGroupData[{

Cell["already valid ", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.532349009952408*^9, 
  3.532349026580626*^9}},ExpressionUUID->"33302059-995f-4a21-b0cb-\
f81a2b94dd30"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"evgen_", "?", "ValidGeneratorQ"}], ",", "opts___Rule"}], "]"}], 
   ":=", "evgen"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532349015352654*^9, 3.5323490528332987`*^9}, 
   3.7093736632683477`*^9, 
   3.709374001963986*^9},ExpressionUUID->"e969e084-89c3-4f1b-912a-\
af5a18c3f750"]
}, Closed]],

Cell[CellGroupData[{

Cell["condense iterative form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.532349009952408*^9, 3.532349026580626*^9}, {
  3.63343927867738*^9, 3.633439282400383*^9}, {3.633439354024007*^9, 
  3.633439358308021*^9}},ExpressionUUID->"321ae3e7-e1e7-40a6-bf74-\
c851652e1a43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"evgen_", ",", "opts1___Rule"}], "]"}], ",", "opts2___Rule"}], 
    "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"evgen", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts1", ",", "opts2"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.633439269564678*^9, 3.6334393436492767`*^9}, {
  3.709374002740206*^9, 
  3.709374004753995*^9}},ExpressionUUID->"dd495673-06ae-4925-9ad7-\
e4db207e773d"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["GeneratorMatchQ", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.508398843293336*^9, 3.5083988479639072`*^9}, {3.684041243496799*^9, 
   3.684041253575989*^9}, 3.684213220792552*^9, 
   3.709374227966708*^9},ExpressionUUID->"ba31fed9-3108-46f1-8119-\
126694e70edf"],

Cell[CellGroupData[{

Cell["EvolutionGeneratorMatchQ (obsolete)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.4642544492834797`*^9}, {
   3.709373592713914*^9, 3.70937359468182*^9}, 3.709373927779601*^9, 
   3.709374216988031*^9},ExpressionUUID->"8d561996-b5d0-4dec-a400-\
80894e7a677d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EvolutionGeneratorMatchQ", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"EvolutionGeneratorMatchQ", "::", "usage"}], "]"}], ";", 
     RowBox[{"GeneratorMatchQ", "[", "args", "]"}]}], ")"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.709373270765923*^9, 3.7093733190299263`*^9}, {
  3.7093733836744223`*^9, 3.709373385889963*^9}, {3.7093736332296247`*^9, 
  3.709373638145521*^9}, {3.709373933542059*^9, 3.709373944991089*^9}, {
  3.709374220310252*^9, 
  3.709374231468768*^9}},ExpressionUUID->"809233b1-5c5e-45f6-b186-\
41460e1b0f60"]
}, Closed]],

Cell[CellGroupData[{

Cell["GeneratorMatchQ", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.508398843293336*^9, 3.5083988479639072`*^9}, {3.684041243496799*^9, 
   3.684041253575989*^9}, 3.684213220792552*^9, 
   3.709374249341674*^9},ExpressionUUID->"455a8bc9-db44-4696-9dcd-\
4d4f5949a48a"],

Cell[CellGroupData[{

Cell["single generator", "Subsubsection",
 CellChangeTimes->{{3.6842124437528048`*^9, 3.6842124464403963`*^9}, {
  3.684212763696478*^9, 3.6842127675003223`*^9}, {3.722571170089398*^9, 
  3.722571172214184*^9}},ExpressionUUID->"e2a080c5-9617-47a5-9584-\
4c19a55b8ead"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", "a_", "]"}], "=", "True"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.507031499248253*^9, 3.507031501990851*^9}, 
   3.709374256161634*^9},ExpressionUUID->"ec2ce135-3d58-4a30-b04b-\
391557ecb08d"]
}, Closed]],

Cell[CellGroupData[{

Cell["pair of generators", "Subsubsection",
 CellChangeTimes->{{3.6842124437528048`*^9, 
  3.6842124464403963`*^9}},ExpressionUUID->"cebff9ba-41ee-4bb2-b8e4-\
28c4e2eb201c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "a_", "]"}], ",", 
     RowBox[{"Hold", "[", "a_", "]"}]}], "]"}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.542967635001453*^9, 3.542967653324092*^9}, 
   3.709374256757738*^9},ExpressionUUID->"fbf77740-8a00-4761-b4cd-\
48e88775e585"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "a_", "]"}], ",", "b_"}], "]"}], ":=", 
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"ReleaseHold", "[", "a", "]"}], ",", "b"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.542967635001453*^9, 3.5429676981081448`*^9}, {
  3.691498689319016*^9, 3.6914987023889027`*^9}, {3.70937425734272*^9, 
  3.7093742580304317`*^9}},ExpressionUUID->"48af35cb-c232-4986-af88-\
7b246e74ce9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"Hold", "[", "b_", "]"}]}], "]"}], ":=", 
   RowBox[{"ReleaseHold", "@", 
    RowBox[{"GeneratorMatchQ", "[", 
     RowBox[{"a", ",", 
      RowBox[{"ReleaseHold", "[", "b", "]"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.542967635001453*^9, 3.5429676981081448`*^9}, {
  3.6914987092400913`*^9, 3.691498725676758*^9}, {3.709374258850247*^9, 
  3.70937425940163*^9}},ExpressionUUID->"dc9e007f-6ee9-4b82-a744-\
1e3d3d3b2df9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"op2_", "?", "OperatorQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"op1", ",", "op2"}], "]"}], "||", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"N", "@", 
       RowBox[{"MatrixRepresentation", "[", "op1", "]"}]}], ",", 
      RowBox[{"N", "@", 
       RowBox[{"MatrixRepresentation", "[", "op2", "]"}]}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533343101131043*^9, 3.5333431579118156`*^9}, 
   3.70937425998672*^9, {3.722571119418601*^9, 
   3.722571122256041*^9}},ExpressionUUID->"31ae7bd6-0dc9-410a-9f0f-\
8e48e585585d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"sop1_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"sop2_", "?", "SuperoperatorQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{"sop1", ",", "sop2"}], "]"}], "||", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"N", "@", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", "sop1", "]"}]}], ",", 
      RowBox[{"N", "@", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", "sop2", "]"}]}]}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533343101131043*^9, 3.533343190300683*^9}, 
   3.709374260650546*^9, {3.722571128306632*^9, 
   3.7225711314006987`*^9}},ExpressionUUID->"3f4ca7d3-5eb8-4909-9a22-\
f3d0932f9b8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"b", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{"a", ",", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"b", ",", 
       RowBox[{"ImplementMatrixRepresentation", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50703110878379*^9, 3.507031198079307*^9}, {
   3.507031231442971*^9, 3.50703139159643*^9}, 3.507031431831585*^9, {
   3.514820173847541*^9, 3.514820200684319*^9}, {3.5148202306845617`*^9, 
   3.514820273302642*^9}, {3.5415316535436077`*^9, 3.541531657542234*^9}, 
   3.541531699866929*^9, {3.542965671863542*^9, 3.5429656722728786`*^9}, 
   3.70937401750064*^9, {3.70937426132556*^9, 
   3.70937426203424*^9}},ExpressionUUID->"b5e29e75-4ebb-4439-b08e-\
e5fbd39da160"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}], ",", "b_"}], 
    "]"}], ":=", 
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"a", ",", 
       RowBox[{"ImplementMatrixRepresentation", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "b"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50703110878379*^9, 3.507031198079307*^9}, {
   3.507031231442971*^9, 3.50703139159643*^9}, 3.507031431831585*^9, {
   3.514820173847541*^9, 3.514820200684319*^9}, {3.5148202306845617`*^9, 
   3.514820299478973*^9}, {3.5415316641528797`*^9, 3.541531695716958*^9}, {
   3.542965667112846*^9, 3.5429656675280457`*^9}, 3.70937401827675*^9, {
   3.709374264869342*^9, 
   3.709374265915497*^9}},ExpressionUUID->"aff7b846-13e7-4a24-a214-\
48a09aff498a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"Except", "[", "_ShapeFunction", "]"}], ",", "_ShapeFunction"}], 
    "]"}], ":=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50703110878379*^9, 3.507031198079307*^9}, {
   3.507031231442971*^9, 3.50703139159643*^9}, 3.507031431831585*^9, {
   3.514820173847541*^9, 3.514820200684319*^9}, {3.5148202306845617`*^9, 
   3.514820273302642*^9}, {3.514820327630885*^9, 3.514820351228098*^9}, 
   3.709374267692977*^9},ExpressionUUID->"0d519d13-ba4b-4e52-bc61-\
89e9a978650c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{"_ShapeFunction", ",", 
     RowBox[{"Except", "[", "_ShapeFunction", "]"}]}], "]"}], ":=", "False"}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50703110878379*^9, 3.507031198079307*^9}, {
   3.507031231442971*^9, 3.50703139159643*^9}, 3.507031431831585*^9, {
   3.514820173847541*^9, 3.514820200684319*^9}, {3.5148202306845617`*^9, 
   3.514820273302642*^9}, {3.514820327630885*^9, 3.514820369612277*^9}, 
   3.709374268705513*^9},ExpressionUUID->"6682e2c2-5312-4263-9813-\
070cafe41607"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{"Except", "[", "_ShapeFunction", "]"}]}], ",", 
     RowBox[{"b", ":", 
      RowBox[{"Except", "[", "_ShapeFunction", "]"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"a", ",", 
       RowBox[{"ImplementMatrixRepresentation", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "]"}], ",", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"b", ",", 
       RowBox[{"ImplementMatrixRepresentation", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
       RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507031409821474*^9, 3.507031427492168*^9}, {
   3.508346398352631*^9, 3.508346401902051*^9}, {3.508400293007062*^9, 
   3.508400297685481*^9}, {3.508400374087039*^9, 3.5084003970485973`*^9}, {
   3.508400428126655*^9, 3.508400465707438*^9}, {3.5148203890241337`*^9, 
   3.5148203961733*^9}, {3.541531669752698*^9, 3.541531684447068*^9}, {
   3.542965639834182*^9, 3.542965655897401*^9}, {3.7093740192444773`*^9, 
   3.709374019885828*^9}, 
   3.7093742693133593`*^9},ExpressionUUID->"c7aac64c-cda0-4c70-8cfe-\
bc6c44e31295"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"shfunc1", ":", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t1_", ",", 
        RowBox[{"\[Tau]xpairs1_", "?", "MatrixQ"}], ",", "T1_", ",", 
        "func1_"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"shfunc2", ":", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t2_", ",", 
        RowBox[{"\[Tau]xpairs2_", "?", "MatrixQ"}], ",", "T2_", ",", 
        "func2_"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"t", ",", "ta", ",", "tb"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"shfunc1", "[", 
         RowBox[{"t", ",", "ta", ",", "tb"}], "]"}], "\[Equal]", 
        RowBox[{"shfunc2", "[", 
         RowBox[{"t", ",", "ta", ",", "tb"}], "]"}]}], "]"}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50703110878379*^9, 3.507031198079307*^9}, {
   3.507031231442971*^9, 3.50703139159643*^9}, 3.507031431831585*^9, {
   3.543759505548015*^9, 3.543759510542338*^9}, 
   3.709374270089457*^9},ExpressionUUID->"1a1526fd-633b-41bb-a3cf-\
2b76ce86b7b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["more than 2 generators", "Subsubsection",
 CellChangeTimes->{{3.6842124437528048`*^9, 3.6842124464403963`*^9}, {
  3.684212763696478*^9, 
  3.6842127675003223`*^9}},ExpressionUUID->"33cffb78-0b9d-4541-97b1-\
a61e19f6a540"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"GeneratorMatchQ", "[", 
    RowBox[{"evgen1_", ",", "evgen2_", ",", "evgens__", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"GeneratorMatchQ", "[", 
     RowBox[{"evgen1", ",", "evgen2", ",", "opts"}], "]"}], "&&", 
    RowBox[{"GeneratorMatchQ", "[", 
     RowBox[{"evgen2", ",", 
      RowBox[{"Sequence", "@@", 
       RowBox[{"Rest", "[", 
        RowBox[{"{", "evgens", "}"}], "]"}]}], ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68421298661464*^9, 3.684213047854246*^9}, {
   3.684213081868082*^9, 3.684213126167235*^9}, 3.6842131583271093`*^9, {
   3.709374250178932*^9, 
   3.709374251357877*^9}},ExpressionUUID->"f4fcb87a-1306-4331-9daa-\
ff43dbf6e998"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["HeldGeneratorSymbol", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.508398843293336*^9, 3.5083988479639072`*^9}, {3.543246724333819*^9, 
   3.543246733141095*^9}, {3.543246913219122*^9, 3.543246918042636*^9}, 
   3.543246985053939*^9, {3.54324738207482*^9, 3.5432473831928596`*^9}, 
   3.709374397953896*^9},ExpressionUUID->"b9c57d2d-255f-4935-a97c-\
f06da3811b5f"],

Cell["\<\
sets up a new symbol for an evolution generator, surrounds it with Hold, and \
sets up its attributes such as PermittedTimeShift and \
HilbertSpaceCompatibility. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.54341069100591*^9, 3.54341073445292*^9}, {
   3.6831145522741632`*^9, 3.683114570542581*^9}, 
   3.6831182737655087`*^9},ExpressionUUID->"fae4c329-131a-4168-b63f-\
654e53bee063"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "HeldGeneratorSymbol", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ImplementMatrixRepresentation", "\[Rule]", "True"}], ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
     RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543246857513399*^9, 3.543246870396718*^9}, 
   3.543246922618161*^9, {3.543246957423635*^9, 3.5432469810870857`*^9}, 
   3.543247388550126*^9, 
   3.709374399185149*^9},ExpressionUUID->"d0b762be-4d63-40a2-b64a-\
18213a1491e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HeldGeneratorSymbol", "[", 
    RowBox[{
     RowBox[{"gen_", "?", "ValidGeneratorQ"}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"evgensymbol", ",", "evgen", ",", "standevgen"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"standevgen", "=", "\[IndentingNewLine]", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"gen", ",", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", 
            RowBox[{"opts", ",", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"Options", "[", "HeldGeneratorSymbol", "]"}]}]}], 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evgensymbol", "=", "standevgen"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"PermittedTimeShift", "[", 
         RowBox[{"Hold", "@", "evgensymbol"}], "]"}], "=", 
        RowBox[{"PermittedTimeShift", "[", "standevgen", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"HilbertSpaceCompatibility", "[", 
         RowBox[{"Hold", "@", "evgensymbol"}], "]"}], "=", 
        RowBox[{"HilbertSpaceCompatibility", "[", "standevgen", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Hold", "@", "evgensymbol"}]}], "\[IndentingNewLine]", ")"}]}],
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5432467388944397`*^9, 3.543246850668799*^9}, {
   3.543246887627508*^9, 3.543246888246229*^9}, 3.5432469265296907`*^9, {
   3.54324699154503*^9, 3.54324718063665*^9}, 3.5432473902568407`*^9, 
   3.5432532371130953`*^9, 3.621573348910717*^9, {3.68311448517244*^9, 
   3.683114545688879*^9}, {3.6831145844887333`*^9, 3.683114591894514*^9}, {
   3.683115981110024*^9, 3.683116007902747*^9}, {3.683116081179006*^9, 
   3.683116086380492*^9}, {3.683116135104958*^9, 3.6831161952230597`*^9}, {
   3.68311632362638*^9, 3.683116326864333*^9}, {3.6831164072378387`*^9, 
   3.683116440866971*^9}, 3.6831166138526917`*^9, {3.6831166510860643`*^9, 
   3.683116653619582*^9}, {3.6831167005874*^9, 3.683116701898994*^9}, {
   3.6831168747343273`*^9, 3.683116877723827*^9}, {3.683116915622925*^9, 
   3.683116926898509*^9}, {3.683117031023945*^9, 3.683117053552169*^9}, {
   3.68311709451956*^9, 3.683117096934167*^9}, {3.683117202563175*^9, 
   3.683117221591791*^9}, 3.709373665269702*^9, 3.709374006486862*^9, {
   3.709374400580377*^9, 
   3.709374402402961*^9}},ExpressionUUID->"dee5a0ec-6393-4933-816c-\
05947a868e5b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HeldGeneratorSymbol", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"gen_", "?", 
       RowBox[{"(", 
        RowBox[{"!", 
         RowBox[{"ValidGeneratorQ", "[", "#", "]"}]}], ")"}]}], "&"}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"HeldGeneratorSymbol", "::", "inval"}], "]"}], ";", "$Failed"}],
     ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543247192604333*^9, 3.543247218829769*^9}, {
   3.5432473925712023`*^9, 3.5432473941330347`*^9}, 3.709373665943544*^9, {
   3.709374403640263*^9, 
   3.709374404495281*^9}},ExpressionUUID->"58d1ed23-0128-497c-8a1d-\
e18d4cc68680"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HeldGeneratorSymbol", "::", "inval"}], "=", 
   "\"\<invalid evolution generator\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543247223735732*^9, 3.543247231832698*^9}, 
   3.5432473954687643`*^9, 
   3.709374406621654*^9},ExpressionUUID->"449d0b7f-2e1d-4815-860d-\
9b505558343b"]
}, Closed]],

Cell[CellGroupData[{

Cell["CombineGenerators", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, 
   3.709373377106283*^9},ExpressionUUID->"4afd8284-4c7c-43f3-a1ca-\
eebc623eb5f0"],

Cell[CellGroupData[{

Cell["CombineEvolutionGenerators (obsolete)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
  3.7093733899059353`*^9, 
  3.709373391863537*^9}},ExpressionUUID->"74db04de-d616-4fa3-94b1-\
452e92f2eee2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineEvolutionGenerators", "[", "args___", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CombineEvolutionGenerators", "::", "usage"}], "]"}], ";", 
     RowBox[{"CombineGenerators", "[", "args", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.709373270765923*^9, 3.7093733190299263`*^9}, {
  3.7093733836744223`*^9, 
  3.709373385889963*^9}},ExpressionUUID->"a8cd8e6b-2f6d-47b3-95db-\
a00453699f65"]
}, Closed]],

Cell[CellGroupData[{

Cell["CombineGenerators", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, 
   3.7093732673364067`*^9},ExpressionUUID->"62f88dd7-bf33-4900-b85c-\
e3174810f066"],

Cell["combines two or more simultaneous  generators. ", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.463937542609378*^9, 3.4639375441918373`*^9}, {
   3.4639382506381483`*^9, 3.4639382930056334`*^9}, {3.4641870286868668`*^9, 
   3.464187052364394*^9}, 3.5041991960732613`*^9, 
   3.709374544264303*^9},ExpressionUUID->"c596eddc-3802-43dd-acc8-\
548d364ada14"],

Cell["\<\
from v2.7.1b2, this routine does not execute checks for the operator or \
superoperator types, or implement matrix representations.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834160859895144`*^9, 
  3.583416136894947*^9}},ExpressionUUID->"4c80ab79-e0d4-45dc-a70b-\
6765a86df821"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.502841406228046*^9, 3.502841408570457*^9}, {
  3.5083989086049013`*^9, 3.508398911891033*^9}, {3.532254255161021*^9, 
  3.532254256261918*^9}},ExpressionUUID->"7cc836c8-de14-454c-b564-\
cddc69a18fe9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CombineGenerators", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"GeneratorsStandardized", "\[Rule]", "False"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532254260355729*^9, 3.532254294716791*^9}, {
   3.532255401919065*^9, 3.532255414447204*^9}, {3.532255470854548*^9, 
   3.5322554721183643`*^9}, {3.532256251722691*^9, 3.532256258249805*^9}, {
   3.532256402729265*^9, 3.5322564120662203`*^9}, {3.533342851716193*^9, 
   3.53334285217698*^9}, {3.583230610583447*^9, 3.583230614236039*^9}, {
   3.583416141884274*^9, 3.5834161430400343`*^9}, {3.6573916916484118`*^9, 
   3.657391707806835*^9}, 3.709373337530116*^9, 
   3.709374417950671*^9},ExpressionUUID->"a76eab54-c362-47a4-951b-\
5067905d97dd"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle lists", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}},ExpressionUUID->"f0333a17-ea66-4250-ad2f-\
24539c90de0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"gens_List", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"Sequence", "@@", "gens"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464242134125128*^9, 3.464242148573697*^9}, {
  3.5322564183941307`*^9, 3.5322564323520117`*^9}, {3.533309117793785*^9, 
  3.533309123406521*^9}, {3.709373339621717*^9, 
  3.709373340396769*^9}},ExpressionUUID->"59fc5d84-9660-4987-a923-\
d0e7e5dd97a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["release any Holds", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.5083995191083317`*^9, 3.508399525738559*^9}, {
  3.5083998802002974`*^9, 3.508399884950369*^9}, {3.5084019508175364`*^9, 
  3.508401952150619*^9}, {3.543411193705261*^9, 
  3.543411197391251*^9}},ExpressionUUID->"2ebf58b1-3e46-4e06-a619-\
9506ea68a253"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"_Hold", "|", "_Rule"}], "]"}], "..."}]}], ",", "b_Hold", ",", 
     RowBox[{"c", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"_Hold", "|", "Rule"}], "]"}], "..."}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"a", ",", 
     RowBox[{"ReleaseHold", "[", "b", "]"}], ",", "c", ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543411201634066*^9, 3.5434112571544657`*^9}, {
  3.709373341140665*^9, 
  3.709373341780696*^9}},ExpressionUUID->"1d17791b-3e34-489f-a052-\
ebac496ed886"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize all generators before combining", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
   3.463938352040963*^9, 3.463938359758416*^9}, {3.46394094117033*^9, 
   3.4639409417208157`*^9}, {3.504199373221072*^9, 3.504199374939377*^9}, {
   3.614935214306891*^9, 3.6149352188626757`*^9}, {3.6573911735068703`*^9, 
   3.657391183168251*^9}, 3.657391338365759*^9, {3.657391612883976*^9, 
   3.6573916156088676`*^9}, {3.657391722102569*^9, 
   3.657391722692628*^9}},ExpressionUUID->"b3f8a426-6afc-4ca0-8360-\
c5af9a25ab56"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CombineGenerators", "[", 
     RowBox[{
      RowBox[{"items", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"GeneratorsStandardized", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CombineGenerators", "]"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Sequence", "@@", 
      RowBox[{"(", 
       RowBox[{"StandardizeGenerator", "/@", 
        RowBox[{"{", "items", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"GeneratorsStandardized", "\[Rule]", "True"}], ",", 
       "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657391190217457*^9, 3.6573913248941517`*^9}, 
   3.657391510023929*^9, {3.657391554902264*^9, 3.657391557618647*^9}, {
   3.657391731629621*^9, 3.6573918813832617`*^9}, 3.6573920043009577`*^9, {
   3.657392301682756*^9, 3.65739231020782*^9}, {3.657392351920512*^9, 
   3.657392365853841*^9}, {3.6573925271139936`*^9, 3.657392542039278*^9}, {
   3.657392611431658*^9, 3.657392615524313*^9}, {3.657392661838147*^9, 
   3.657392666387714*^9}, {3.70937334257953*^9, 3.709373343996892*^9}, 
   3.7093740082085648`*^9, {3.709374421460663*^9, 
   3.7093744233282623`*^9}},ExpressionUUID->"56197a76-414e-45fb-9210-\
594fba0f8e35"]
}, Closed]],

Cell[CellGroupData[{

Cell["series of items", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.5083995191083317`*^9, 3.508399525738559*^9}, {
  3.5083998802002974`*^9, 3.508399884950369*^9}, {3.5084019508175364`*^9, 
  3.508401952150619*^9}},ExpressionUUID->"f15553db-0aff-4ba4-ad22-\
ce9c90ea36e2"],

Cell[CellGroupData[{

Cell["single item", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938302824304*^9, 3.4639383097658863`*^9}, {3.464242127652639*^9, 
  3.464242129353895*^9}, {3.5083995191083317`*^9, 
  3.508399525738559*^9}},ExpressionUUID->"30196bc0-1953-447a-9e96-\
0d186ac1f514"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"a", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.508399532789516*^9, 3.508399548372658*^9}, {
   3.532256446782496*^9, 3.532256451286585*^9}, {3.532257705949683*^9, 
   3.532257706901095*^9}, {3.533342868396042*^9, 3.5333429379730253`*^9}, {
   3.533343365521986*^9, 3.533343367246084*^9}, {3.6215733589959183`*^9, 
   3.621573370247436*^9}, {3.7093733446495028`*^9, 3.709373345335787*^9}, 
   3.709374009062941*^9},ExpressionUUID->"2b805b70-0139-4d27-beb1-\
a1965274f3fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["more than 2; iterate", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
   3.463938302824304*^9, 3.4639383097658863`*^9}, {3.508399642972734*^9, 
   3.508399646769885*^9}, 3.532257625368371*^9, {3.532257721833359*^9, 
   3.532257724164687*^9}, {3.532257799072147*^9, 
   3.532257800969503*^9}},ExpressionUUID->"5f989953-d785-4c3c-ace7-\
c8a089d62fc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"b", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"c", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"CombineGenerators", "[", 
      RowBox[{"a", ",", "b", ",", "opts"}], "]"}], ",", "c", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.463938313346043*^9, 3.463938335297559*^9}, {
  3.532256464272752*^9, 3.53225649530285*^9}, {3.5322579988391857`*^9, 
  3.532258006682349*^9}, {3.70937334601073*^9, 
  3.709373347361024*^9}},ExpressionUUID->"12fe1c8d-bc4a-4671-958d-\
8786908c921a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["null  generators", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
   3.463938352040963*^9, 3.463938359758416*^9}, {3.46394094117033*^9, 
   3.4639409417208157`*^9}, {3.504199373221072*^9, 3.504199374939377*^9}, {
   3.614935214306891*^9, 3.6149352188626757`*^9}, 
   3.709374546334921*^9},ExpressionUUID->"0218a2bc-b554-4511-98c5-\
6e94795736f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"NullGeneratorPattern", ",", "item2_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"item2", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.46393657167481*^9}, {
   3.463936910749728*^9, 3.463936919408667*^9}, {3.463938365479178*^9, 
   3.4639383825924177`*^9}, {3.463940945206534*^9, 3.463940950517356*^9}, {
   3.506854695646798*^9, 3.50685469690868*^9}, {3.506944897508277*^9, 
   3.506944897962401*^9}, {3.508397573372473*^9, 3.5083975754818163`*^9}, {
   3.508399824965234*^9, 3.508399829131207*^9}, 3.508401190760631*^9, {
   3.532256506099572*^9, 3.532256512413378*^9}, 3.533342943864534*^9, 
   3.533343378132359*^9, {3.566156332633252*^9, 3.566156339023499*^9}, {
   3.592995892096383*^9, 3.592995896162217*^9}, 3.592995928365118*^9, {
   3.7093733480468407`*^9, 3.709373348688448*^9}, 3.7093740100640087`*^9, 
   3.709374424936921*^9},ExpressionUUID->"a5a57f27-77bd-4640-ba3b-\
2bfd3b3af52a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"item1_", ",", "NullGeneratorPattern", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{"item1", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.46393657167481*^9}, {
   3.463936910749728*^9, 3.463936919408667*^9}, {3.463938365479178*^9, 
   3.463938409248927*^9}, {3.4639409554896708`*^9, 3.463940960411633*^9}, 
   3.506854701733552*^9, {3.506944900594565*^9, 3.506944901018799*^9}, 
   3.508397580980955*^9, 3.508399834171818*^9, 3.508401188720744*^9, {
   3.5322565175356073`*^9, 3.5322565276036797`*^9}, 3.53334294642148*^9, 
   3.533343383105257*^9, 3.566156348208654*^9, 3.592995940995852*^9, {
   3.709373349284635*^9, 3.7093733498470497`*^9}, 3.7093740108177967`*^9, 
   3.709374426489484*^9},ExpressionUUID->"51a3edd4-eb03-415e-b578-\
edfe58437d4f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
    "NullGeneratorPattern", ",", "NullGeneratorPattern", ",", "opts___Rule"}],
     "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.46393657167481*^9}, {
   3.463936910749728*^9, 3.463936919408667*^9}, {3.463938365479178*^9, 
   3.463938409248927*^9}, {3.4639409554896708`*^9, 3.463940970517229*^9}, {
   3.4640224171679897`*^9, 3.464022417760338*^9}, {3.506944904956574*^9, 
   3.506944906132861*^9}, {3.5083975832597933`*^9, 3.5083975850120783`*^9}, {
   3.508401184234228*^9, 3.508401186640792*^9}, {3.5322565304692917`*^9, 
   3.532256533221346*^9}, {3.56615635773384*^9, 3.566156366633507*^9}, {
   3.592995947938998*^9, 3.59299595478398*^9}, {3.592996553596262*^9, 
   3.5929965569388866`*^9}, 3.709373350398148*^9, {3.7093744273108673`*^9, 
   3.7093744281431437`*^9}},ExpressionUUID->"ebe8d5db-db52-4147-aac4-\
0e4ce3753a0a"]
}, Closed]],

Cell[CellGroupData[{

Cell["first item is an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 
  3.463937226482794*^9}},ExpressionUUID->"bd17763c-dd64-4fda-aaf0-\
78c9ab4fca01"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"op1", "+", "op2"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936578066745*^9}, {
   3.463936914833342*^9, 3.463936953792446*^9}, {3.463936985563065*^9, 
   3.463936988122158*^9}, {3.463937130590988*^9, 3.463937151099656*^9}, {
   3.506854739646203*^9, 3.506854743941679*^9}, 3.508400004518415*^9, {
   3.532256538304933*^9, 3.532256544324985*^9}, 3.533342962907021*^9, 
   3.5333433893132677`*^9, {3.5832294894210653`*^9, 3.583229532388379*^9}, {
   3.583229639157815*^9, 3.583229643762178*^9}, {3.583229714113393*^9, 
   3.583229725567163*^9}, {3.6334383151740007`*^9, 3.6334383206658783`*^9}, {
   3.709373351017005*^9, 3.709373351647134*^9}, 
   3.7093740115154133`*^9},ExpressionUUID->"e798342a-a537-4f48-8d8c-\
236895016830"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"sop2_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "I"}], " ", 
       RowBox[{"CommutationSuperoperator", "[", "op1", "]"}]}], "+", "sop2"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936655622734*^9}, {
   3.463936857772149*^9, 3.463936875229766*^9}, {3.463936955704879*^9, 
   3.463936994304681*^9}, {3.463937132425304*^9, 3.463937182555723*^9}, {
   3.506854786267845*^9, 3.5068547907445583`*^9}, 3.5084000069417953`*^9, {
   3.532256550132656*^9, 3.532256554245578*^9}, 3.533342968460309*^9, 
   3.533343395081559*^9, {3.58322954145468*^9, 3.583229565726264*^9}, {
   3.58322964869178*^9, 3.583229668339841*^9}, {3.709373352254736*^9, 
   3.7093733528844767`*^9}, 
   3.70937401222414*^9},ExpressionUUID->"80d966b1-cdb1-4e11-bbaf-\
2a3f5463228b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"f", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"op1", ",", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"f", ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53225849655939*^9, 3.532258580276205*^9}, 
   3.5322588049627943`*^9, 3.533342993928*^9, 3.533343400602284*^9, {
   3.583229676084268*^9, 3.5832296822768087`*^9}, {3.709373353525837*^9, 
   3.7093733548534937`*^9}, 
   3.7093740129667807`*^9},ExpressionUUID->"d91d796a-a4bb-45bf-ad40-\
2172757b5d29"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "args2_"}],
        "]"}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"CombineGenerators", "[", 
       RowBox[{"op1", ",", "args2", ",", "opts"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936655622734*^9}, {
   3.463936697878892*^9, 3.463936760111334*^9}, {3.46393707018235*^9, 
   3.463937094823306*^9}, 3.463937134730629*^9, {3.463937191889331*^9, 
   3.463937192238921*^9}, {3.4639390400877333`*^9, 3.463939041804306*^9}, {
   3.5069445479185333`*^9, 3.506944595203825*^9}, {3.507009855399066*^9, 
   3.507009869934512*^9}, {3.5075480669721193`*^9, 3.507548070409182*^9}, {
   3.5322563770783854`*^9, 3.53225637770826*^9}, {3.5322565599492483`*^9, 
   3.532256574943956*^9}, {3.5322578553622313`*^9, 3.5322578591577787`*^9}, {
   3.5832296881773*^9, 3.583229690104136*^9}, {3.5834161925339327`*^9, 
   3.5834161956713657`*^9}, {3.7093733554833107`*^9, 
   3.709373356091014*^9}},ExpressionUUID->"045cc237-d54a-4d9b-9d3b-\
b2d8789846a8"]
}, Closed]],

Cell[CellGroupData[{

Cell["first item is a superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 
  3.463937244569468*^9}},ExpressionUUID->"d868c1a4-f2d0-4e47-96e2-\
b5548f634ba8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"sop1_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"sop1", "-", 
      RowBox[{"I", " ", 
       RowBox[{"CommutationSuperoperator", "[", "op2", "]"}]}]}], ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936578066745*^9}, {
   3.463936914833342*^9, 3.463936953792446*^9}, {3.463936985563065*^9, 
   3.463936988122158*^9}, {3.463937130590988*^9, 3.463937151099656*^9}, 
   3.4639372598785667`*^9, {3.4639372994044027`*^9, 3.4639373068524323`*^9}, {
   3.463938458547104*^9, 3.4639384620983343`*^9}, {3.506854796644506*^9, 
   3.506854800017603*^9}, 3.5084000276453753`*^9, {3.532256592841206*^9, 
   3.5322565980373373`*^9}, 3.533343002903083*^9, 3.53334340582563*^9, {
   3.709373356664596*^9, 3.709373357260895*^9}, 
   3.709374013765252*^9},ExpressionUUID->"aac8ddbb-d2b9-43f8-92d7-\
c725aab10eb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"sop1_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"sop2_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"StandardizeGenerator", "[", 
    RowBox[{
     RowBox[{"sop1", "+", "sop2"}], ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936655622734*^9}, {
   3.463936857772149*^9, 3.463936875229766*^9}, {3.463936955704879*^9, 
   3.463936994304681*^9}, {3.463937132425304*^9, 3.463937182555723*^9}, 
   3.4639372617201138`*^9, {3.463937311491149*^9, 3.463937316012135*^9}, {
   3.506854803391398*^9, 3.506854806729271*^9}, 3.5084000297493477`*^9, {
   3.5322566039970827`*^9, 3.5322566080368958`*^9}, 3.533343008054996*^9, 
   3.5333434105853033`*^9, {3.7093733578459187`*^9, 3.7093733584760323`*^9}, 
   3.7093740144516993`*^9},ExpressionUUID->"5dbc6d1f-64f2-47b4-a2fd-\
3fc6a9e0e166"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"sop1_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"f", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CombineGenerators", "[", 
    RowBox[{"sop1", ",", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"f", ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53225849655939*^9, 3.532258580276205*^9}, {
   3.53225862090416*^9, 3.532258625192617*^9}, 3.532258809981133*^9, 
   3.5333430128955727`*^9, 3.533343415153598*^9, {3.709373359038497*^9, 
   3.709373360197144*^9}, 
   3.709374015149191*^9},ExpressionUUID->"ead5675c-4600-4d11-ade5-\
d98a84049ea1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", 
    RowBox[{
     RowBox[{"sop1_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "args2_"}],
        "]"}]}], ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"CombineGenerators", "[", 
       RowBox[{"sop1", ",", "args2", ",", "opts"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936655622734*^9}, {
   3.463936697878892*^9, 3.463936760111334*^9}, {3.46393707018235*^9, 
   3.463937094823306*^9}, 3.463937134730629*^9, {3.463937191889331*^9, 
   3.463937192238921*^9}, {3.4639390400877333`*^9, 3.463939041804306*^9}, {
   3.5069445479185333`*^9, 3.506944627534453*^9}, {3.507009881744506*^9, 
   3.5070098871673098`*^9}, {3.5075480845017157`*^9, 3.507548086931699*^9}, {
   3.53225662016966*^9, 3.5322566413352747`*^9}, 3.5834162061467447`*^9, {
   3.709373360771172*^9, 
   3.7093733613574457`*^9}},ExpressionUUID->"9b4d6620-9cc4-48e8-b091-\
87f91a85b023"]
}, Closed]],

Cell[CellGroupData[{

Cell["first item is a Function, PeriodicFunction, or ShapeFunction", \
"Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937218209276*^9}, {
  3.463938352040963*^9, 3.463938359758416*^9}, {3.46394094117033*^9, 
  3.4639409417208157`*^9}, {3.504199373221072*^9, 3.504199424075447*^9}, {
  3.5069309736242332`*^9, 3.506930976086213*^9}, {3.506945016642775*^9, 
  3.506945020272025*^9}, {3.532259521665481*^9, 
  3.532259528311763*^9}},ExpressionUUID->"f61349f3-ad8f-4779-8ca8-\
2de4a0ae679b"],

Cell[CellGroupData[{

Cell["\<\
convert first item into a ShapeFunction if Function or PeriodicFunction\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
   3.4639373421810904`*^9, 3.46393734528118*^9}, {3.463937573208128*^9, 
   3.463937573934071*^9}, {3.463937646448535*^9, 3.4639376525980453`*^9}, 
   3.463939188225892*^9, {3.5041994711066847`*^9, 3.5041994720581083`*^9}, {
   3.504201337673904*^9, 3.5042013501612587`*^9}, {3.504203695664426*^9, 
   3.504203698717742*^9}, {3.506931312653845*^9, 3.506931327155121*^9}, 
   3.506944677323612*^9, {3.506945024288744*^9, 3.5069450303443832`*^9}, {
   3.532258847251193*^9, 3.532258859072096*^9}, {3.532258949930942*^9, 
   3.5322589542796087`*^9}, {3.5322595425063334`*^9, 
   3.532259543159711*^9}},ExpressionUUID->"d6635338-96d0-4a4e-a152-\
22436b4fd6a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"evgen1", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}], ",", 
     "\[IndentingNewLine]", "evgen2_", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"evgen1", ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "evgen2", ",",
      "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532258876688821*^9, 3.532258919487206*^9}, {
   3.532259550135668*^9, 3.532259596661145*^9}, {3.532259639794557*^9, 
   3.5322596512765417`*^9}, 3.533343017536232*^9, 3.5333434194580297`*^9, 
   3.534473306522449*^9, {3.7093733619860497`*^9, 3.709373363178528*^9}, 
   3.709374015925583*^9},ExpressionUUID->"858b88f3-7d1c-4cb3-9d16-\
31430f90f2bf"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
convert second item into a ShapeFunction if Function or PeriodicFunction\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
   3.4639373421810904`*^9, 3.46393734528118*^9}, {3.463937573208128*^9, 
   3.463937573934071*^9}, {3.463937646448535*^9, 3.4639376525980453`*^9}, 
   3.463939188225892*^9, {3.5041994711066847`*^9, 3.5041994720581083`*^9}, {
   3.504201337673904*^9, 3.5042013501612587`*^9}, {3.504203695664426*^9, 
   3.504203698717742*^9}, {3.506931312653845*^9, 3.506931327155121*^9}, 
   3.506944677323612*^9, {3.506945024288744*^9, 3.5069450303443832`*^9}, {
   3.532258847251193*^9, 3.532258859072096*^9}, {3.532258949930942*^9, 
   3.5322589542796087`*^9}},ExpressionUUID->"3045e968-cdf3-4fb0-aded-\
3528abde4d3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"evgen1", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"t_", ",", 
         RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "expr_"}],
         "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evgen2", ":", 
      RowBox[{"(", 
       RowBox[{"_Function", "|", "_PeriodicFunction"}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{"evgen1", ",", "\[IndentingNewLine]", 
     RowBox[{"StandardizeGenerator", "[", 
      RowBox[{"evgen2", ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "CombineGenerators", "]"}]}]}], "]"}]}], 
      "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532258876688821*^9, 3.532258919487206*^9}, {
   3.532259604747074*^9, 3.5322596337107267`*^9}, 3.533343022098646*^9, 
   3.533343423348093*^9, {3.709373363729889*^9, 3.709373364854764*^9}, 
   3.7093740166469193`*^9},ExpressionUUID->"7bf283e0-390d-4de0-a66f-\
4acc4730d07b"]
}, Closed]],

Cell[CellGroupData[{

Cell["second item is not a ShapeFunction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
   3.4639373421810904`*^9, 3.46393734528118*^9}, {3.463937573208128*^9, 
   3.463937573934071*^9}, {3.463937646448535*^9, 3.4639376525980453`*^9}, 
   3.463939188225892*^9, {3.5041994711066847`*^9, 3.5041994720581083`*^9}, {
   3.504201337673904*^9, 3.5042013501612587`*^9}, {3.504203695664426*^9, 
   3.504203698717742*^9}, {3.506931312653845*^9, 3.506931327155121*^9}, 
   3.506944677323612*^9, {3.506945024288744*^9, 
   3.5069450303443832`*^9}},ExpressionUUID->"232a422b-c88c-47ec-8dbf-\
11080e0c4e0d"],

Cell["inherit the period setting", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.504201563264485*^9, 3.504201572862896*^9}, {
   3.504239945618297*^9, 3.504239952938178*^9}, 
   3.5069447002475033`*^9},ExpressionUUID->"18064fb3-4b76-4fac-afc6-\
de24feccbc46"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"ShapeFunction", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", "expr_"}], 
       "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evgen", ":", 
      RowBox[{"Except", "[", "_ShapeFunction", "]"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"ShapeFunction", "[", "\[IndentingNewLine]", 
    RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"CombineGenerators", "[", 
       RowBox[{"expr", ",", "evgen", ",", "opts"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936578066745*^9}, {
   3.463936914833342*^9, 3.463936953792446*^9}, {3.463936985563065*^9, 
   3.463936988122158*^9}, {3.463937130590988*^9, 3.463937151099656*^9}, 
   3.4639372598785667`*^9, {3.4639372994044027`*^9, 3.4639373068524323`*^9}, 
   3.463937415272983*^9, {3.463937451698657*^9, 3.4639374552610292`*^9}, {
   3.463937593472951*^9, 3.4639375967765503`*^9}, {3.46393767393372*^9, 
   3.463937698780528*^9}, 3.463937789922017*^9, {3.4639379081883717`*^9, 
   3.463937909968121*^9}, {3.46393857531149*^9, 3.463938583892812*^9}, 
   3.463939104072486*^9, {3.463939643366129*^9, 3.463939664228777*^9}, 
   3.4652788737417192`*^9, {3.467027929951952*^9, 3.467027941088352*^9}, {
   3.4670280263711147`*^9, 3.4670280379395933`*^9}, {3.504199477783592*^9, 
   3.50419958365666*^9}, 3.504199614225547*^9, {3.5042006141926928`*^9, 
   3.504200635764789*^9}, {3.504201281787569*^9, 3.504201321565105*^9}, {
   3.504201357940625*^9, 3.504201359268556*^9}, {3.504201400237218*^9, 
   3.504201424612159*^9}, {3.5042014915173473`*^9, 3.504201497236085*^9}, {
   3.504201536445484*^9, 3.504201556796795*^9}, {3.50420175265313*^9, 
   3.504201808452422*^9}, {3.504203685389052*^9, 3.504203687545733*^9}, {
   3.504239887204062*^9, 3.5042399373589487`*^9}, 3.506931333860982*^9, {
   3.506931375485717*^9, 3.506931424726625*^9}, {3.506931469761125*^9, 
   3.506931471497314*^9}, {3.5069323342157917`*^9, 3.506932351805118*^9}, {
   3.506932398271875*^9, 3.506932412144348*^9}, 3.5069446861184196`*^9, {
   3.507009929956025*^9, 3.507009939700242*^9}, {3.507011531571732*^9, 
   3.5070115324171352`*^9}, 3.5070115836427937`*^9, {3.50701234293165*^9, 
   3.507012355995255*^9}, {3.5070124915802603`*^9, 3.50701250507334*^9}, {
   3.532256663035391*^9, 3.532256683174411*^9}, {3.5834162293683558`*^9, 
   3.583416229910474*^9}, {3.70937336540586*^9, 
   3.709373366013603*^9}},ExpressionUUID->"1334daa2-4921-4f37-8cd8-\
7d1d83834a10"]
}, Closed]],

Cell[CellGroupData[{

Cell["second item is also a ShapeFunction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.4639371998523197`*^9, 3.463937244569468*^9}, {
   3.4639373421810904`*^9, 3.46393734528118*^9}, {3.463937573208128*^9, 
   3.463937573934071*^9}, {3.463937646448535*^9, 3.4639376525980453`*^9}, 
   3.463939188225892*^9, {3.5041994711066847`*^9, 3.5041994720581083`*^9}, {
   3.504201337673904*^9, 3.5042013501612587`*^9}, {3.504201881473979*^9, 
   3.504201882456152*^9}, {3.5042037080634317`*^9, 3.504203710413435*^9}, {
   3.506932428711206*^9, 3.50693243238877*^9}, {3.5069369930233097`*^9, 
   3.506936994579946*^9}, {3.5069447150727654`*^9, 3.506944722750545*^9}, {
   3.507010014356152*^9, 
   3.50701001752999*^9}},ExpressionUUID->"f3b1461b-2b43-4a71-94c5-\
b5c1c55e8d5a"],

Cell["\<\
great care is taken below to make sure the \[Tau] variables of the two \
different shape functions do not interfere, even if they were defined using \
the same name.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.507011783708209*^9, 
  3.507011838406197*^9}},ExpressionUUID->"aa3ede50-c658-4847-9d70-\
273a3ad81346"],

Cell["\<\
even more care is needed to protect the time arguments in the case that they \
are defined outside the function\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.540293488245371*^9, 
  3.540293516933378*^9}},ExpressionUUID->"3a3a8a1e-ac7c-4f8a-badb-\
398d498e16d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"func1", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"t1_", ",", 
         RowBox[{"\[Tau]xpairs1_", "?", "MatrixQ"}], ",", "T1_", ",", 
         "args1_"}], "]"}]}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"func2", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"t2_", ",", 
         RowBox[{"\[Tau]xpairs2_", "?", "MatrixQ"}], ",", "T2_", ",", 
         "args2_"}], "]"}]}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "t3", ",", "\[Tau]vars1", ",", "\[Tau]loc1", ",", "\[Tau]locvars1", ",",
        "\[Tau]vars2", ",", "\[Tau]loc2", ",", "\[Tau]locvars2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Tau]vars1", "=", 
        RowBox[{"First", "/@", "\[Tau]xpairs1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Tau]locvars1", "=", 
        RowBox[{"Array", "[", 
         RowBox[{"\[Tau]loc1", ",", 
          RowBox[{"Length", "[", "\[Tau]vars1", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Tau]vars2", "=", 
        RowBox[{"First", "/@", "\[Tau]xpairs2"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Tau]locvars2", "=", 
        RowBox[{"Array", "[", 
         RowBox[{"\[Tau]loc2", ",", 
          RowBox[{"Length", "[", "\[Tau]vars2", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ShapeFunction", "[", 
        RowBox[{"t3", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Join", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"\[Tau]locvars1", ",", 
               RowBox[{"Last", "/@", "\[Tau]xpairs1"}]}], "}"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"\[Tau]locvars2", ",", 
               RowBox[{"Last", "/@", "\[Tau]xpairs2"}]}], "}"}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"CommonPeriod", "[", 
           RowBox[{"T1", ",", "T2"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", "\[IndentingNewLine]", 
          RowBox[{"CombineGenerators", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ReleaseHold", "@", 
             RowBox[{"ReplaceEverywhere", "[", 
              RowBox[{
               RowBox[{"Hold", "[", "args1", "]"}], ",", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"HoldPattern", "[", "t1", "]"}], "\[Rule]", "t3"}],
                   "}"}], ",", 
                 RowBox[{"MapThread", "[", 
                  RowBox[{"Rule", ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Tau]vars1", ",", "\[Tau]locvars1"}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"ReleaseHold", "@", 
             RowBox[{"ReplaceEverywhere", "[", 
              RowBox[{
               RowBox[{"Hold", "[", "args2", "]"}], ",", 
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"HoldPattern", "[", "t2", "]"}], "\[Rule]", "t3"}],
                   "}"}], ",", 
                 RowBox[{"MapThread", "[", 
                  RowBox[{"Rule", ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Tau]vars2", ",", "\[Tau]locvars2"}], "}"}]}], 
                  "]"}]}], "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4639365113891973`*^9, 3.463936578066745*^9}, {
   3.463936914833342*^9, 3.463936953792446*^9}, {3.463936985563065*^9, 
   3.463936988122158*^9}, {3.463937130590988*^9, 3.463937151099656*^9}, 
   3.4639372598785667`*^9, {3.4639372994044027`*^9, 3.4639373068524323`*^9}, 
   3.463937415272983*^9, {3.463937451698657*^9, 3.4639374552610292`*^9}, {
   3.463937593472951*^9, 3.4639375967765503`*^9}, {3.46393767393372*^9, 
   3.463937698780528*^9}, 3.463937789922017*^9, {3.4639379081883717`*^9, 
   3.463937909968121*^9}, {3.46393857531149*^9, 3.463938583892812*^9}, 
   3.463939104072486*^9, {3.463939643366129*^9, 3.463939664228777*^9}, 
   3.4652788737417192`*^9, {3.467027929951952*^9, 3.467027941088352*^9}, {
   3.4670280263711147`*^9, 3.4670280379395933`*^9}, {3.504199477783592*^9, 
   3.50419958365666*^9}, 3.504199614225547*^9, {3.5042006141926928`*^9, 
   3.504200635764789*^9}, {3.504201281787569*^9, 3.504201321565105*^9}, {
   3.504201357940625*^9, 3.504201359268556*^9}, {3.504201400237218*^9, 
   3.504201424612159*^9}, {3.5042014915173473`*^9, 3.504201497236085*^9}, {
   3.504201536445484*^9, 3.504201556796795*^9}, {3.50420175265313*^9, 
   3.504201808452422*^9}, {3.504201894078673*^9, 3.504201918317596*^9}, {
   3.504201953917357*^9, 3.504202069801239*^9}, {3.504202123866045*^9, 
   3.504202193961114*^9}, {3.504202346232583*^9, 3.5042023753734083`*^9}, {
   3.504202578387496*^9, 3.504202583351956*^9}, {3.50420262122573*^9, 
   3.504202642729014*^9}, {3.504202692698765*^9, 3.504202818111247*^9}, {
   3.5042034774519167`*^9, 3.504203484945303*^9}, {3.5042035902673063`*^9, 
   3.504203598375865*^9}, {3.5042037186562138`*^9, 3.504203753186803*^9}, {
   3.504203828213319*^9, 3.504203835354411*^9}, {3.504239970410256*^9, 
   3.504240010677515*^9}, {3.504262701470277*^9, 3.5042627679924097`*^9}, {
   3.506937012483886*^9, 3.506937045858844*^9}, {3.506937235598493*^9, 
   3.506937237173914*^9}, {3.5069450442801447`*^9, 3.506945136532338*^9}, {
   3.506954390517263*^9, 3.506954391286414*^9}, {3.506955527000441*^9, 
   3.506955604971396*^9}, {3.506955860580855*^9, 3.5069558620426893`*^9}, {
   3.5069560520967617`*^9, 3.5069560548860197`*^9}, {3.507009951536129*^9, 
   3.507009960182809*^9}, {3.507010037162204*^9, 3.5070100503006573`*^9}, {
   3.5070100845571213`*^9, 3.507010115008466*^9}, {3.507011592657159*^9, 
   3.507011770174214*^9}, {3.507012269990962*^9, 3.507012273556403*^9}, {
   3.507012324936792*^9, 3.507012326056669*^9}, {3.507012510234543*^9, 
   3.507012513314567*^9}, {3.532256700402646*^9, 3.532256724079947*^9}, {
   3.532259322775621*^9, 3.532259341901168*^9}, {3.540293382053977*^9, 
   3.540293479243558*^9}, {3.540293677832986*^9, 3.540293701294869*^9}, {
   3.5402937335143003`*^9, 3.5402937633468037`*^9}, 3.58341624897451*^9, {
   3.7093733665879517`*^9, 
   3.709373367161644*^9}},ExpressionUUID->"1e6da69c-a779-477d-b418-\
8bc379cc2ee8"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CommonPeriod", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464960392986411*^9, 3.4649603952229023`*^9}, 
   3.4649606985178003`*^9, 3.5031057515835857`*^9, {3.5068630444608307`*^9, 
   3.5068630490583477`*^9}, {3.541487798118299*^9, 
   3.541487799577826*^9}},ExpressionUUID->"a5b96742-f7a6-4ff8-8c1c-\
99ac9e45ea23"],

Cell[CellGroupData[{

Cell["CommonPeriod of 2 arguments ", "Subsubsection",
 CellChangeTimes->{{3.684037813415338*^9, 
  3.684037855887433*^9}},ExpressionUUID->"880ea7e5-be1e-4be4-9c36-\
d06b89349bfa"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommonPeriod", "[", 
   RowBox[{"a_", ",", "opts___Rule"}], "]"}], ":=", "a"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46496140784865*^9, 
  3.464961415263068*^9}},ExpressionUUID->"7507b9c5-dd1c-46a6-9556-\
78ec461e269a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommonPeriod", "[", 
   RowBox[{"a_", ",", "All", ",", "opts___Rule"}], "]"}], ":=", 
  "a"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4995569524825974`*^9, 
  3.4995569767975283`*^9}},ExpressionUUID->"6121c0bd-bbce-4dce-ace5-\
191cd686c80b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommonPeriod", "[", 
   RowBox[{"All", ",", "a_", ",", "opts___Rule"}], "]"}], ":=", 
  "a"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4995569524825974`*^9, 
  3.4995569852079887`*^9}},ExpressionUUID->"8ac99037-25e7-44d3-8b00-\
bc3ac12bda12"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommonPeriod", "[", 
   RowBox[{"a_", ",", "None", ",", "opts___Rule"}], "]"}], ":=", 
  "None"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4995569524825974`*^9, 3.4995569767975283`*^9}, {
  3.541487848303212*^9, 
  3.54148785294905*^9}},ExpressionUUID->"84854ca8-0045-4c6f-ab8f-\
846a52350296"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommonPeriod", "[", 
   RowBox[{"None", ",", "a_", ",", "opts___Rule"}], "]"}], ":=", 
  "None"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4995569524825974`*^9, 3.4995569852079887`*^9}, {
  3.541487855565208*^9, 
  3.541487859236755*^9}},ExpressionUUID->"bf95d1d0-d790-41be-a6d5-\
3d934a74d659"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommonPeriod", "[", 
    RowBox[{"a_", ",", "a_", ",", "opts___Rule"}], "]"}], ":=", "a"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683435789667863*^9, 3.683435804107771*^9}, {
  3.6834602159026737`*^9, 
  3.6834602207501917`*^9}},ExpressionUUID->"56d0c38f-19ff-4f72-bac5-\
7803dd74ed17"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommonPeriod", "[", 
    RowBox[{
     RowBox[{"a_", "?", "NumericQ"}], ",", 
     RowBox[{"b_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "ratio", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ratio", "=", 
        RowBox[{"Rationalize", "[", 
         RowBox[{"a", "/", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Denominator", "[", "ratio", "]"}], "*", "a"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464960798345739*^9, 3.464960815774789*^9}, {
   3.46496086022684*^9, 3.4649608916489677`*^9}, 3.465759210248823*^9, 
   3.5001712804543037`*^9, {3.500171485909644*^9, 3.500171511566657*^9}, 
   3.500171889017235*^9, {3.5414878221136723`*^9, 3.541487828894677*^9}, 
   3.541488439555821*^9, {3.6834357581550627`*^9, 3.683435778769293*^9}, {
   3.683436118839644*^9, 
   3.683436125989003*^9}},ExpressionUUID->"c59f3a98-120a-4b0c-aff5-\
0f44cac3eff8"]
}, Closed]],

Cell[CellGroupData[{

Cell["CommonPeriod of 3 or more arguments ", "Subsubsection",
 CellChangeTimes->{{3.684037813415338*^9, 
  3.684037834611751*^9}},ExpressionUUID->"e4f65956-4e62-4e5b-a447-\
6f280a7b0032"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommonPeriod", "[", 
    RowBox[{"a_", ",", "b_", ",", "c__", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CommonPeriod", "[", 
    RowBox[{
     RowBox[{"CommonPeriod", "[", 
      RowBox[{"a", ",", "b", ",", "opts"}], "]"}], ",", "c", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4649609030909433`*^9, 
  3.464960943947576*^9}},ExpressionUUID->"a9d35034-06c7-40df-b7e3-\
90323d6c2d38"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"CommonPeriod", "[", 
     RowBox[{"a_", ",", 
      RowBox[{"CommonPeriod", "[", 
       RowBox[{"b_", ",", "c_", ",", "opts1___Rule"}], "]"}], ",", 
      "opts2___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "union", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"CommonPeriod", "[", 
        RowBox[{
         RowBox[{"Sequence", "@@", "union"}], ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{"opts1", ",", "opts2"}], "]"}]}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"union", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "c"}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Length", "[", "union", "]"}], "<", "3"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.684036903392913*^9, 3.684036935085291*^9}, {
   3.684037051572667*^9, 3.684037209045109*^9}, 3.684037314951889*^9, 
   3.68403737391311*^9, 3.684037465135208*^9, {3.6840375541366*^9, 
   3.684037560967695*^9}},ExpressionUUID->"31aa68cf-3a6d-4e32-8645-\
c2a87680dcb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"CommonPeriod", "[", 
     RowBox[{
      RowBox[{"CommonPeriod", "[", 
       RowBox[{"a_", ",", "b_", ",", "opts1___Rule"}], "]"}], ",", "c_", ",", 
      "opts2___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "union", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"CommonPeriod", "[", 
        RowBox[{
         RowBox[{"Sequence", "@@", "union"}], ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{"opts1", ",", "opts2"}], "]"}]}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"union", "=", 
         RowBox[{"Union", "[", 
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "c"}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Length", "[", "union", "]"}], "<", "3"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.684036903392913*^9, 3.684036935085291*^9}, {
   3.684037051572667*^9, 3.684037209045109*^9}, 3.6840373063398037`*^9, 
   3.684037470884027*^9, {3.684037563295185*^9, 
   3.6840375634396553`*^9}},ExpressionUUID->"abd5590d-feee-48ee-a49f-\
649b3dd7db14"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["LocalGeneratorSymbols", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.464960392986411*^9, 3.4649603952229023`*^9}, 
   3.4649606985178003`*^9, 3.5031057515835857`*^9, {3.5068630444608307`*^9, 
   3.5068630490583477`*^9}, {3.541487798118299*^9, 3.541487799577826*^9}, 
   3.744359471793991*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"c8d3b317-8f81-475b-9369-2bb0f4429fc3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LocalGeneratorSymbols", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"TargetFunctions", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"_Function", ",", "_PeriodicFunction", ",", "_ShapeFunction"}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744364113066441*^9, 3.744364158291339*^9}, {
  3.744364343447055*^9, 
  3.744364347877442*^9}},ExpressionUUID->"1a0c1786-59a3-48fe-ba07-\
69433e324b49"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", "opts___Rule", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744359531094018*^9, 
  3.744359540536264*^9}},ExpressionUUID->"a5280d02-9def-45b7-b733-\
dfc6c848e12b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", 
    RowBox[{"arg_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "targetpattern", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"targetpattern", "=", 
         RowBox[{"Alternatives", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TargetFunctions", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "LocalGeneratorSymbols", "]"}]}], 
           ")"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Union", "@", 
         RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
          RowBox[{"LocalGeneratorSymbols", "/@", 
           RowBox[{"Cases", "[", 
            RowBox[{
             RowBox[{"{", "arg", "}"}], ",", "targetpattern", ",", 
             "Infinity"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"targetpattern", "=", 
         RowBox[{"Alternatives", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"TargetFunctions", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "LocalGeneratorSymbols", "]"}]}], 
           ")"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"arg", ",", "targetpattern"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744364175634219*^9, 3.744364181922255*^9}, {
   3.744364231639442*^9, 3.744364414917633*^9}, {3.744364449235063*^9, 
   3.744364485559182*^9}, {3.744364539584992*^9, 3.744364592640481*^9}, 
   3.744364653802588*^9, {3.744364705310848*^9, 3.744364716157022*^9}, {
   3.7443647732674227`*^9, 3.744364776363819*^9}, {3.7443648945688887`*^9, 
   3.7443648964174223`*^9}},ExpressionUUID->"98815beb-d780-4b4d-912b-\
6a83347e4562"],

Cell[CellGroupData[{

Cell["Function", "Subsubsection",
 CellChangeTimes->{{3.744359587522524*^9, 
  3.7443595887865467`*^9}},ExpressionUUID->"b5861257-3248-43c3-900b-\
e6c5bc46db03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{"arg_", ",", "___Rule"}], "]"}]}], ",", "___Rule"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744365605401985*^9, 3.744365621911873*^9}, {
  3.744365709507515*^9, 
  3.7443657125195227`*^9}},ExpressionUUID->"38981cee-53e4-4e88-be66-\
c3d8a36f6ca3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Function", "[", 
       RowBox[{"t_", ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "___Rule"}], 
       "]"}]}], ",", "___Rule"}], "]"}], ":=", 
   RowBox[{"{", "t", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744359603947008*^9, 3.7443596175405903`*^9}, {
   3.7443655713110867`*^9, 3.744365591494627*^9}, {3.7443656479511642`*^9, 
   3.744365668047241*^9}, 
   3.744365719053499*^9},ExpressionUUID->"112d77a4-3c1a-425c-bbd2-\
da46eb8af17e"]
}, Closed]],

Cell[CellGroupData[{

Cell["PeriodicFunction", "Subsubsection",
 CellChangeTimes->{{3.744359587522524*^9, 3.7443595887865467`*^9}, 
   3.7443596274951553`*^9},ExpressionUUID->"bba70708-711c-4be4-a038-\
192d381d8062"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", 
    RowBox[{"f_PeriodicFunction", ",", "___Rule"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"First", "[", "f", "]"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744359603947008*^9, 
  3.744359635986149*^9}},ExpressionUUID->"0fe74863-40bf-4c25-bd16-\
f1415b863eac"]
}, Closed]],

Cell[CellGroupData[{

Cell["ShapeFunction", "Subsubsection",
 CellChangeTimes->{{3.744359587522524*^9, 3.7443595887865467`*^9}, {
  3.7443596274951553`*^9, 
  3.7443596450310793`*^9}},ExpressionUUID->"b024aee2-fece-4207-bd65-\
cf07e04aa902"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LocalGeneratorSymbols", "[", 
    RowBox[{"f_ShapeFunction", ",", "___Rule"}], "]"}], ":=", 
   RowBox[{"Union", "@", 
    RowBox[{"Flatten", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
           ",", 
          RowBox[{"First", "/@", 
           RowBox[{"(", 
            RowBox[{
            "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            ")"}]}]}], "}"}], "&"}], "@", "f"}], ")"}]}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.744359603947008*^9, 3.744359663889153*^9}, {
  3.744360075028043*^9, 3.744360075727654*^9}, {3.744365133995081*^9, 
  3.744365141840148*^9}},ExpressionUUID->"3a1a9508-da52-4ee6-aa39-\
7132a0041863"]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Liouvillian", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.452690506563347*^9}, {
   3.4526906425151577`*^9, 3.452690675101125*^9}, {3.452712675169849*^9, 
   3.452712685532673*^9}, {3.452770736612377*^9, 3.452770745914432*^9}, {
   3.4528340628299294`*^9, 3.4528340639240847`*^9}, 3.4975736975953903`*^9, {
   3.5028403677196217`*^9, 3.502840372078033*^9}, {3.504204304171247*^9, 
   3.5042043103134203`*^9}, 3.5069309517835827`*^9, {3.5414885345095863`*^9, 
   3.54148853944915*^9}, {3.683203928618372*^9, 3.683203935665477*^9}, {
   3.683265594615818*^9, 
   3.6832655968422203`*^9}},ExpressionUUID->"d59c4d09-cc91-4074-b652-\
8e4a8fb1ad24"],

Cell[CellGroupData[{

Cell["Liouvillian", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.464254428323444*^9, 3.464254438246352*^9}, {
   3.507031074380574*^9, 3.50703107730711*^9}, 3.507031441485198*^9, {
   3.533253041844676*^9, 
   3.5332530442174063`*^9}},ExpressionUUID->"293cabd8-5570-407b-8a7f-\
12f0efbd1562"],

Cell["\<\
This routine is encountered as the last step before implementing the spin \
dynamical evolution, on each element\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834163093707323`*^9, 3.5834163572940617`*^9}, {
  3.5834275655572863`*^9, 
  3.5834275730478086`*^9}},ExpressionUUID->"e7e7b93f-decd-4171-8a96-\
97cffccf49b9"],

Cell["\<\
From v2.7.1b2, the default mode is to execute checks on the OperatorType, the \
SuperoperatorType, and to implement matrix representations\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834163093707323`*^9, 
  3.583416405616156*^9}},ExpressionUUID->"b028b3f5-e252-4efd-8c20-\
98bb8eb1a1cf"],

Cell[CellGroupData[{

Cell["defaults", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533253108749117*^9, 3.533253119802393*^9}, {
  3.533254059952816*^9, 3.533254062854424*^9}, {3.533343258935652*^9, 
  3.533343260164566*^9}},ExpressionUUID->"e6c0d16c-09e8-4df2-9d93-\
430d4765d55a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Liouvillian", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
     RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533343263544568*^9, 3.533343282223749*^9}, {
  3.534470506950108*^9, 3.534470514169778*^9}, {3.583416410820362*^9, 
  3.5834164167701273`*^9}, {3.5834172352856207`*^9, 3.583417235834888*^9}, {
  3.586348691513878*^9, 3.586348693181777*^9}, {3.586352260458829*^9, 
  3.586352264078623*^9}},ExpressionUUID->"43fe9950-3b78-454e-b1f6-\
2f1ef32bb03d"]
}, Closed]],

Cell[CellGroupData[{

Cell["combine a list or sequence of  generators", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533253108749117*^9, 3.533253119802393*^9}, {
   3.533254059952816*^9, 3.533254062854424*^9}, 
   3.7093745522946167`*^9},ExpressionUUID->"f455285e-9553-4b55-9b8e-\
606262091ffd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"b", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Liouvillian", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.533253047951907*^9, 3.5332531011957684`*^9}, {
   3.5332536827089863`*^9, 3.5332536936342497`*^9}, 3.533253901453558*^9, {
   3.53325396381811*^9, 3.5332539738575363`*^9}, {3.5333435094406567`*^9, 
   3.533343515428508*^9}, {3.533344342841524*^9, 
   3.533344349818799*^9}},ExpressionUUID->"1d7cf2a9-c9a8-44ee-ac68-\
512a8b952908"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{"evgens_List", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Liouvillian", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CombineGenerators", "[", 
      RowBox[{"evgens", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "Liouvillian", "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"opts", ",", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "Liouvillian", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533253047951907*^9, 3.5332531011957684`*^9}, 
   3.533253898835456*^9, {3.5332539860375443`*^9, 3.533254044339113*^9}, {
   3.533343289212997*^9, 3.533343345716999*^9}, {3.5334334291028*^9, 
   3.5334334614402227`*^9}, 
   3.709373367712503*^9},ExpressionUUID->"e735cdf1-7660-40ac-99e7-\
b6b120dbdd17"]
}, Closed]],

Cell[CellGroupData[{

Cell["Liouvillian for single arguments", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533253108749117*^9, 3.533253119802393*^9}, {
  3.5332532209493103`*^9, 3.5332532246403008`*^9}, {3.533253294309989*^9, 
  3.533253299634845*^9}, {3.5332533886183023`*^9, 3.533253393343154*^9}, {
  3.583417102676712*^9, 
  3.583417107105632*^9}},ExpressionUUID->"8cde06c6-9063-49b2-80df-\
41af9e999d41"],

Cell[CellGroupData[{

Cell["null events", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.58341649466994*^9, 
  3.5834164980278273`*^9}},ExpressionUUID->"6a54134e-9165-4b71-ac94-\
6f2a86b9c971"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{"NullGeneratorPattern", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{"NullSuperoperator", "[", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5332533995750437`*^9, 3.533253415733109*^9}, 
   3.533253614632825*^9, {3.533343539782901*^9, 3.5333435707478657`*^9}, {
   3.583410470901663*^9, 3.583410501890184*^9}, {3.5929959630576057`*^9, 
   3.592995977347069*^9}, 
   3.709374433644568*^9},ExpressionUUID->"6c144e68-d537-4fd2-a84f-\
7306ba656cc4"]
}, Closed]],

Cell[CellGroupData[{

Cell["shape functions", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.58341649466994*^9, 
  3.583416507371193*^9}},ExpressionUUID->"098faae6-6377-4a37-b822-\
4e1dd22289a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{
     RowBox[{"ShapeFunction", "[", 
      RowBox[{"t_", ",", 
       RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
       RowBox[{"evgen_", "?", "ValidGeneratorQ"}]}], "]"}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ShapeFunction", "[", 
    RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"Liouvillian", "[", 
       RowBox[{"evgen", ",", 
        RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}], ",", "opts"}],
        "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533253461166628*^9, 3.5332535315752697`*^9}, {
   3.5332535694213552`*^9, 3.53325359102393*^9}, {3.533343577260009*^9, 
   3.5333435857905397`*^9}, {3.583416448511413*^9, 3.583416449648879*^9}, 
   3.709373667372306*^9},ExpressionUUID->"0efd8cfc-7fb1-4f4b-bbfe-\
396552041def"]
}, Closed]],

Cell[CellGroupData[{

Cell["operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.58341649466994*^9, 
  3.5834165186588373`*^9}},ExpressionUUID->"7b38be7d-52d0-494a-8187-\
9bfe9564497f"],

Cell["\<\
Hermitian operators are converted to CommutationSuperoperators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.583420231986434*^9, 3.5834202636103163`*^9}, {
  3.586348664662888*^9, 
  3.5863486654753513`*^9}},ExpressionUUID->"59e691b4-e11f-4964-af85-\
657569c2b973"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Liouvillian", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"op", ",", "_Operator"}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Liouvillian", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"op", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Liouvillian", "]"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Options", "[", "Operator", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]",
       "]"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583416538380761*^9, 3.58341656170991*^9}, {
  3.5834166067447643`*^9, 3.5834166848832684`*^9}, {3.618481056363311*^9, 
  3.618481119207583*^9}},ExpressionUUID->"f2982558-e092-4859-a079-\
c9a0acfb9e1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Liouvillian", "[", 
     RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"CheckOperatorType", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Liouvillian", "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"OperatorType", "[", "op", "]"}], ",", "\"\<Hermitian\>\""}], 
       "]"}]}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Liouvillian", "::", "notherm"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Liouvillian", "[", 
      RowBox[{"op", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5834165770894814`*^9, 3.583416585575935*^9}, {
  3.583416693141233*^9, 
  3.583416808784371*^9}},ExpressionUUID->"9785af4c-c4cc-4e12-8402-\
385562a08a6c"],

Cell["\<\
Diagonalized Hermitian Operators are handled separately, since the syntax \
below also multiplies the eigenvectors with -I. \
\>", "Text",
 CellChangeTimes->{{3.702779323299447*^9, 
  3.7027793576098404`*^9}},ExpressionUUID->"cb4a9635-2a50-4393-9ff5-\
c23242a66631"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{
     RowBox[{"O", ":", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
          RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "basis_", ",", 
        "opopts___Rule"}], "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", 
         RowBox[{
          RowBox[{"-", "I"}], "*", "evals"}], ",", "Xinv"}], "}"}], ",", 
       "basis", ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{
         RowBox[{"OperatorType", "\[Rule]", "\"\<AntiHermitian\>\""}], ",", 
         "opopts"}], "]"}]}], "]"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"OperatorType", "\[Rule]", "\"\<AntiHermitian\>\""}], 
       "}"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583416891110242*^9, 3.583416918502946*^9}, {
  3.583416979164467*^9, 3.5834170031085243`*^9}, {3.58342030672007*^9, 
  3.583420324578837*^9}, {3.583420606507799*^9, 3.583420611698975*^9}, {
  3.5834276595894823`*^9, 3.583427664889503*^9}, {3.5863504560531282`*^9, 
  3.586350482614327*^9}, {3.586351694892619*^9, 3.5863517016023693`*^9}, {
  3.681125484866974*^9, 3.681125487549016*^9}, {3.702778549797307*^9, 
  3.702778565005114*^9}, {3.7027787528168774`*^9, 3.7027787610797243`*^9}, {
  3.7027788034718637`*^9, 3.702778858637084*^9}, {3.7027789389752026`*^9, 
  3.7027789481637354`*^9}, {3.7027789791737823`*^9, 3.7027790846117754`*^9}, {
  3.702779193206955*^9, 
  3.7027792120764*^9}},ExpressionUUID->"d51943c1-f621-4e60-a254-2540ab5be643"],

Cell["\<\
Convert the final operator into a CommutationSuperoperator, diagonalize the \
operator, and flag up the assumed OperatorType for a subsequent NDiagonalize \
routine.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586351765290638*^9, 3.586351804872655*^9}, {
  3.586352255081066*^9, 3.586352256316391*^9}, {3.58635239955364*^9, 
  3.58635240323244*^9}, {3.6811254775110083`*^9, 
  3.681125481671279*^9}},ExpressionUUID->"b679c558-a062-400e-be8c-\
0fe6a0fb0145"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "I"}], " ", "op"}], ",", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"OperatorType", "\[Rule]", "\"\<AntiHermitian\>\""}], 
       "}"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583416891110242*^9, 3.583416918502946*^9}, {
  3.583416979164467*^9, 3.5834170031085243`*^9}, {3.58342030672007*^9, 
  3.583420324578837*^9}, {3.583420606507799*^9, 3.583420611698975*^9}, {
  3.5834276595894823`*^9, 3.583427664889503*^9}, {3.5863504560531282`*^9, 
  3.586350482614327*^9}, {3.586351694892619*^9, 3.5863517016023693`*^9}, {
  3.681125484866974*^9, 3.681125487549016*^9}, {3.702778549797307*^9, 
  3.702778565005114*^9}, {3.7027789241856856`*^9, 
  3.702778929264299*^9}},ExpressionUUID->"26573131-3800-4a4a-96c5-\
ad2b13a40699"]
}, Closed]],

Cell[CellGroupData[{

Cell["superoperators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.58341649466994*^9, 3.583416526163431*^9}, 
   3.5863523647714453`*^9},ExpressionUUID->"1c98101d-d786-4bcd-bc89-\
cc4c383c1075"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", 
    RowBox[{"sop", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{"opts", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"Options", "[", "Liouvillian", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533253634739333*^9, 3.53325364038431*^9}, {
   3.533343600867491*^9, 3.5333436037476807`*^9}, {3.533343811959293*^9, 
   3.533343820249073*^9}, {3.583417023935882*^9, 3.583417041328821*^9}, {
   3.583420269463434*^9, 3.583420286420455*^9}, 
   3.583420328315476*^9},ExpressionUUID->"2484d2f2-986c-4667-a614-\
6c1696e7721a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["invalid arguments", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533253108749117*^9, 3.533253119802393*^9}, {
   3.5332532209493103`*^9, 3.5332532246403008`*^9}, 
   3.533343714656344*^9},ExpressionUUID->"0fec04c4-7b4d-42f2-a1ab-\
24fe8bc1f951"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "[", 
    RowBox[{
     RowBox[{"evgen", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "ValidGeneratorQ"}], "]"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"Liouvillian", "::", "inval"}], ",", "evgen"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533253047951907*^9, 3.5332531011957684`*^9}, {
   3.5332532419811153`*^9, 3.533253276892959*^9}, {3.533343519696961*^9, 
   3.5333435230370398`*^9}, 
   3.709373668058601*^9},ExpressionUUID->"130f0d78-f8a2-4f72-b857-\
b7b16734722e"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533253108749117*^9, 3.533253119802393*^9}, {
  3.5332531963632927`*^9, 
  3.53325319752803*^9}},ExpressionUUID->"e144ad35-9508-40cf-a040-\
533afb22ece2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "::", "inval"}], "=", 
   "\"\<Invalid generator: `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533253200983136*^9, 3.533253214516604*^9}, {
  3.709374555506442*^9, 
  3.70937455863203*^9}},ExpressionUUID->"722eb8c8-1392-4a73-899a-\
eb2eab212849"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Liouvillian", "::", "notherm"}], "=", 
   "\"\<A non-Hermitian operator has been detected during the construction of \
the Liouvillian. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583416821447529*^9, 
  3.583416856501992*^9}},ExpressionUUID->"c953eca0-a567-4caa-8265-\
f1ad1161f1f5"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"c265738f-c029-481a-a80d-3eb92212b45a"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.51238794480797*^9, 3.512387952205147*^9}, 
   3.513231730353488*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"d04ec502-10b7-49d7-9b0a-e3f0d66c6616"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"aa7b63b5-7fee-4d6a-9600-461f51179090"],

Cell[CellGroupData[{

Cell["170414 changes incorporated into v3.0.0b12", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700484912077015*^9, 3.700484926388489*^9}, {3.7011629765259542`*^9, 
   3.7011629828840637`*^9}, 
   3.701163224353978*^9},ExpressionUUID->"4cd5f303-ef55-48f6-9782-\
d720f0de0a4b"],

Cell["\<\
PhenomenologicalRelaxationSuperoperator moved to Interactions`Relaxation\
\>", "Text",
 CellChangeTimes->{{3.701162956562275*^9, 3.70116296595816*^9}, {
  3.7011632268225317`*^9, 
  3.701163235312304*^9}},ExpressionUUID->"a7ac2b64-2f47-41c3-9e9d-\
d13c208954dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell["170503 changes incorporated into v3.0.0b12", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700484912077015*^9, 3.700484926388489*^9}, {3.7011629765259542`*^9, 
   3.7011629828840637`*^9}, 3.701163224353978*^9, {3.7027793700596924`*^9, 
   3.7027793727395973`*^9}},ExpressionUUID->"5e737d69-5789-4493-92cd-\
285ae3d5bb41"],

Cell["\<\
Liouvillian is now able to handle pre-diagonalized Hermitian operators. This \
was necessary to fix a bug where the peaks positions in the spectra jumped \
from \[CapitalOmega] \[Implies] -\[CapitalOmega]. (indicated by light orange).\
\>", "Text",
 CellChangeTimes->{{3.701162956562275*^9, 3.70116296595816*^9}, {
   3.7011632268225317`*^9, 3.701163235312304*^9}, {3.7027793810394974`*^9, 
   3.7027794621111374`*^9}, 3.7027971333412685`*^9, {3.7028165211240253`*^9, 
   3.7028165258756313`*^9}},ExpressionUUID->"79a399d5-2e19-4d7c-b5df-\
3933a2138bbb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["170503 changes incorporated into v3.0.0b14 [MHL]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700484912077015*^9, 3.700484926388489*^9}, {3.7011629765259542`*^9, 
   3.7011629828840637`*^9}, 3.701163224353978*^9, {3.7027793700596924`*^9, 
   3.7027793727395973`*^9}, {3.703138588660783*^9, 
   3.703138595411237*^9}},ExpressionUUID->"e5fe09d3-5ca2-4a7c-a03d-\
7d67fb8fb94f"],

Cell["minor change to ShapeFunction", "Text",
 CellChangeTimes->{{3.701162956562275*^9, 3.70116296595816*^9}, {
   3.7011632268225317`*^9, 3.701163235312304*^9}, {3.7027793810394974`*^9, 
   3.7027794621111374`*^9}, 3.7027971333412685`*^9, {3.7028165211240253`*^9, 
   3.7028165258756313`*^9}, {3.7031386066992283`*^9, 
   3.7031386172901983`*^9}},ExpressionUUID->"a60dedf8-b1af-4ce3-b706-\
a3ce10a64286"]
}, Open  ]],

Cell[CellGroupData[{

Cell["170718 changes in v3.0.0b18", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}},ExpressionUUID->"f9e89763-9fcc-4062-a66d-\
01dfa53cdcf9"],

Cell["\<\
Numerous name changes from EvolutionGenerator (and similar) to Generator (and \
similar)\
\>", "Text",
 CellChangeTimes->{{3.709386922996626*^9, 
  3.709386992335451*^9}},ExpressionUUID->"a90e8781-f6df-4b3a-8358-\
f782eb1a6550"]
}, Open  ]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 751},
WindowMargins->{{Automatic, 154}, {Automatic, 20}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 514, 10, 114, "Title",ExpressionUUID->"38ec49b7-ed69-466f-b150-d80036486419",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1106, 36, 341, 8, 57, "Subsubtitle",ExpressionUUID->"30a9fa10-c6e7-4998-8d83-9c9397d96e6c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1450, 46, 328, 7, 58, "Text",ExpressionUUID->"a6af7e63-ce3c-4f39-979c-0dbf2ae71560",
 InitializationCell->True],
Cell[1781, 55, 1907, 34, 362, "Input",ExpressionUUID->"2a0cfb71-7c3e-48a2-b936-16b39a48ecbe",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3725, 94, 310, 8, 57, "Subsubtitle",ExpressionUUID->"7306be35-c257-46e2-9967-b53246823ba2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[4060, 106, 814, 14, 36, "Section",ExpressionUUID->"fd5448bc-bc6f-4f87-b391-b74ce6725227",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[4899, 124, 766, 14, 45, "Subsubsection",ExpressionUUID->"1292e437-587c-4c22-b35b-5539394a0c44",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5668, 140, 485, 11, 112, "Input",ExpressionUUID->"8be3a0be-f0d6-4d75-95bd-087513a07a29",
 InitializationCell->True],
Cell[6156, 153, 355, 9, 70, "Input",ExpressionUUID->"fbeb5388-4155-4381-b36c-8ba0ea77f220",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6548, 167, 788, 14, 37, "Subsubsection",ExpressionUUID->"8248f5ba-a0f9-4d24-a837-95cb5b45ce59",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7339, 183, 438, 10, 70, "Input",ExpressionUUID->"26cb4d53-7ec7-4051-ba11-3cc21952d38f",
 InitializationCell->True],
Cell[7780, 195, 492, 11, 70, "Input",ExpressionUUID->"ce21d8cd-928f-4290-b99c-2a07a85afcc8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8309, 211, 815, 14, 37, "Subsubsection",ExpressionUUID->"eca65a95-90df-4f73-a4bf-3951ca3852d1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[9127, 227, 495, 11, 70, "Input",ExpressionUUID->"9db45127-24e2-47d5-8223-491193aaa7e0",
 InitializationCell->True],
Cell[9625, 240, 555, 12, 70, "Input",ExpressionUUID->"8f8864db-5298-44f5-b8a9-37dde45aea16",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10217, 257, 862, 15, 37, "Subsubsection",ExpressionUUID->"df94a186-075a-47c4-82f2-0974c28b9be0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[11082, 274, 538, 12, 70, "Input",ExpressionUUID->"a84e0154-3494-4b25-bd6e-777d060b9baf",
 InitializationCell->True],
Cell[11623, 288, 587, 12, 70, "Input",ExpressionUUID->"a79e395a-4caa-491b-a9b3-d707796e338f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12247, 305, 865, 15, 37, "Subsubsection",ExpressionUUID->"a20e23a5-505d-4968-be31-17c24d2ad63e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13115, 322, 427, 10, 91, "Input",ExpressionUUID->"94284109-717e-4714-aa8d-8e4faa014533",
 InitializationCell->True],
Cell[13545, 334, 405, 10, 70, "Input",ExpressionUUID->"6c114871-709b-4294-ba83-1a3f326e11df",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13987, 349, 988, 17, 37, "Subsubsection",ExpressionUUID->"0c92db75-19c5-471f-9d95-0b59dcc35951",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14978, 368, 431, 10, 70, "Input",ExpressionUUID->"5173ccdf-75cb-413a-897f-bce9dcbcc684",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15446, 383, 938, 16, 37, "Subsubsection",ExpressionUUID->"c71a3e99-c7f3-44d8-bc2a-6ffc51393895",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[16387, 401, 450, 10, 68, "Input",ExpressionUUID->"2e732484-5cfb-4e7f-8b72-d79a5783b71c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16874, 416, 1045, 17, 37, "Subsubsection",ExpressionUUID->"bb3cc793-51a7-4fd2-821e-f7aec6b9b419",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17922, 435, 517, 11, 89, "Input",ExpressionUUID->"931097af-ec87-46c8-a399-a467d537dfd9",
 InitializationCell->True],
Cell[18442, 448, 531, 11, 89, "Input",ExpressionUUID->"4c03497e-284e-47c5-9fbe-607d7c12da65",
 InitializationCell->True],
Cell[18976, 461, 565, 12, 89, "Input",ExpressionUUID->"3236618d-cc13-485a-8685-7a60ce84f243",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19578, 478, 1146, 19, 53, "Subsubsection",ExpressionUUID->"332b2685-e277-4a26-96bc-50974a0d9065",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[20727, 499, 757, 15, 89, "Input",ExpressionUUID->"a39973ea-1b1c-4ce2-b1a5-23fc8ea69f75",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[21533, 520, 746, 13, 36, "Section",ExpressionUUID->"5c2c1668-6310-4833-a1ec-cd8a981d8b1c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[22282, 535, 739, 14, 154, "Input",ExpressionUUID->"f2fed372-f799-4502-97bc-968857da43a2",
 InitializationCell->True],
Cell[23024, 551, 1353, 23, 301, "Input",ExpressionUUID->"adb6e8f7-2ffd-477e-8ffe-66b645c38388",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24414, 579, 776, 14, 36, "Section",ExpressionUUID->"59a09975-4466-4538-9501-40342117fafc",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[25193, 595, 406, 10, 89, "Input",ExpressionUUID->"14311ac8-3bf6-4a92-b92c-aafc8243ebe8",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[25648, 611, 187, 5, 41, "Subsubtitle",ExpressionUUID->"1d342b44-e897-4d46-8909-faf781514c11",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[25838, 618, 299, 7, 48, "Input",ExpressionUUID->"4aed02c3-c234-4079-82b7-ed68cb233eee",
 InitializationCell->True],
Cell[26140, 627, 201, 5, 48, "Input",ExpressionUUID->"abe39a15-45a6-4fa4-8c75-de1d4857df45",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[26378, 637, 663, 10, 69, "Subtitle",ExpressionUUID->"e068a320-8c3a-4644-823e-e00151631ab1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[27066, 651, 260, 5, 65, "Subchapter",ExpressionUUID->"9d66437b-f231-42ac-86d7-73b245222eb0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[27351, 660, 239, 5, 36, "Section",ExpressionUUID->"e61be5fd-7c40-4e5d-8379-96efe6e57a84",
 InitializationCell->True],
Cell[27593, 667, 282, 7, 46, "Input",ExpressionUUID->"a12e3bda-7cb7-4aa8-97fa-2c9cc31e6683",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[27900, 678, 287, 4, 54, "Subsection",ExpressionUUID->"e289e9db-fe6a-4fe0-9659-a3a86f61c0af",
 InitializationCell->True],
Cell[28190, 684, 2037, 40, 112, "Input",ExpressionUUID->"9f6f0ce2-6b73-45cb-a71c-e51fb449b182",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[30264, 729, 266, 5, 38, "Subsection",ExpressionUUID->"d3170edf-f1a5-48a9-926e-39d1273f3086",
 InitializationCell->True],
Cell[30533, 736, 876, 21, 70, "Input",ExpressionUUID->"69082505-521d-4123-ae36-60403ba6055b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31446, 762, 259, 5, 38, "Subsection",ExpressionUUID->"e6b9c4f2-702f-40a6-8e83-b428ad25b1a2",
 InitializationCell->True],
Cell[31708, 769, 756, 17, 48, "Input",ExpressionUUID->"96d3e1d8-a162-4af3-ab83-479b4ac3f7a4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32501, 791, 308, 6, 38, "Subsection",ExpressionUUID->"f013bfa2-4d78-4d6d-a731-df6b9e3bd978",
 InitializationCell->True],
Cell[32812, 799, 343, 9, 48, "Input",ExpressionUUID->"e5bc0baf-da56-46a6-a3b0-95d7e40621fe",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[33204, 814, 260, 5, 36, "Section",ExpressionUUID->"5fa33677-be4c-43de-aa65-1e08986fd622",
 InitializationCell->True],
Cell[33467, 821, 330, 8, 46, "Input",ExpressionUUID->"df2f3f66-3122-46c9-85be-b828394241d4",
 InitializationCell->True],
Cell[33800, 831, 333, 9, 46, "Input",ExpressionUUID->"1f01cee1-dd7d-4150-b239-fcfc6bdf5518",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[34158, 844, 401, 7, 54, "Subsection",ExpressionUUID->"fe626a31-d8f8-4ee5-97e7-d0124056d658",
 InitializationCell->True],
Cell[34562, 853, 179, 3, 30, "Text",ExpressionUUID->"b00edc83-1fdb-48d8-9344-8350b1e510ad"],
Cell[34744, 858, 2407, 47, 133, "Input",ExpressionUUID->"c8a8b9d2-5e09-456d-8f7d-3a2e14e9fb25",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37188, 910, 280, 5, 38, "Subsection",ExpressionUUID->"bdfd73da-ad57-4211-bfde-241b846cd364",
 InitializationCell->True],
Cell[37471, 917, 912, 22, 89, "Input",ExpressionUUID->"e809c4b3-b11a-4941-abfd-a37cb40bc08b",
 InitializationCell->True],
Cell[38386, 941, 1802, 34, 68, "Input",ExpressionUUID->"31899959-5665-467f-9a9b-a65d3e426d59",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[40225, 980, 249, 5, 54, "Subsection",ExpressionUUID->"a8d07b17-d8c4-40b7-bfbc-b2aac1bf456a",
 InitializationCell->True],
Cell[40477, 987, 773, 20, 70, "Input",ExpressionUUID->"eca3c481-aab9-4564-8c7a-7b25984a4ea8",
 InitializationCell->True],
Cell[41253, 1009, 751, 20, 70, "Input",ExpressionUUID->"53be78b9-a857-49cc-b091-d29d8452d3c5",
 InitializationCell->True],
Cell[42007, 1031, 1090, 26, 70, "Input",ExpressionUUID->"2186c33c-a395-4a32-9d47-7f12b6c3147f",
 InitializationCell->True],
Cell[43100, 1059, 1223, 29, 91, "Input",ExpressionUUID->"34a01913-7936-4009-9e32-e8cd8551a41e",
 InitializationCell->True],
Cell[44326, 1090, 1020, 21, 70, "Input",ExpressionUUID->"580e3e1d-b526-4758-8adf-f062373ca632",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[45383, 1116, 287, 4, 38, "Subsection",ExpressionUUID->"64e7c3fc-2a80-40b4-99b7-cf53fa72a197",
 InitializationCell->True],
Cell[45673, 1122, 2018, 38, 91, "Input",ExpressionUUID->"807b10c3-18af-4be4-b0cc-0beb7a9e00c2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[47728, 1165, 282, 5, 38, "Subsection",ExpressionUUID->"6484407e-38ad-4937-8bc9-14b46f2b704a",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[48035, 1174, 501, 9, 35, "Subsubsection",ExpressionUUID->"3f83ce51-54e2-4252-b7bc-d214780154f7",
 InitializationCell->True],
Cell[48539, 1185, 303, 7, 30, "Text",ExpressionUUID->"f5a57328-b9c4-428a-a726-ad4416c136a6",
 InitializationCell->True],
Cell[48845, 1194, 281, 7, 30, "Text",ExpressionUUID->"324b41f2-1da9-4439-8f41-0c20add38d38",
 InitializationCell->True],
Cell[49129, 1203, 305, 7, 30, "Text",ExpressionUUID->"4fbc646e-b810-4c0b-953d-18161fe7e704",
 InitializationCell->True],
Cell[49437, 1212, 1502, 35, 91, "Input",ExpressionUUID->"f21046b1-1978-4f9f-be07-e403ad18305f",
 InitializationCell->True],
Cell[50942, 1249, 1170, 30, 91, "Input",ExpressionUUID->"8b2a2009-027f-4a95-afd5-24adbe007244",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[52149, 1284, 356, 7, 35, "Subsubsection",ExpressionUUID->"825e41d7-6043-4940-8cd3-ee5425b64422",
 InitializationCell->True],
Cell[52508, 1293, 435, 9, 68, "Text",ExpressionUUID->"0ce8f30a-b935-4aaf-8f46-9167a27a2834",
 InitializationCell->True],
Cell[52946, 1304, 305, 7, 30, "Text",ExpressionUUID->"1bf51336-16de-4acc-988e-72275d5a1f7f",
 InitializationCell->True],
Cell[53254, 1313, 2893, 65, 154, "Input",ExpressionUUID->"bbff4e3c-febf-4419-a16b-c3221b3aeb0e",
 InitializationCell->True],
Cell[56150, 1380, 1645, 39, 91, "Input",ExpressionUUID->"04800707-3bb2-41a0-a3e7-86a2cb243730",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[57832, 1424, 363, 8, 29, "Subsubsection",ExpressionUUID->"b20a5a5c-6e88-4d3a-bf4a-bdbe6909278d",
 InitializationCell->True],
Cell[58198, 1434, 288, 7, 30, "Text",ExpressionUUID->"ee05f9ec-1cd4-4f18-b01b-df4a811f2c07",
 InitializationCell->True],
Cell[58489, 1443, 360, 8, 30, "Text",ExpressionUUID->"4bf68d80-73ab-4871-8a59-62af35f8aeae",
 InitializationCell->True],
Cell[58852, 1453, 3120, 64, 154, "Input",ExpressionUUID->"a76ceaf8-92ac-4b7c-b194-5389ea8c5b5c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[62021, 1523, 328, 6, 38, "Subsection",ExpressionUUID->"e1c238ca-3cab-4837-b79a-c5b53d4a7074",
 InitializationCell->True],
Cell[62352, 1531, 358, 9, 48, "Input",ExpressionUUID->"6fdcdc2b-2c99-482a-b0b4-95faad34de04",
 InitializationCell->True],
Cell[62713, 1542, 343, 9, 48, "Input",ExpressionUUID->"0fe8db40-219e-4fe1-8e60-6c6ef884f511",
 InitializationCell->True],
Cell[63059, 1553, 434, 10, 48, "Input",ExpressionUUID->"a526bd17-e580-4caf-b03c-79d941268bbf",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[63554, 1570, 215, 4, 65, "Subchapter",ExpressionUUID->"afaf2222-d756-425f-b858-7685b14ccd44",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[63794, 1578, 257, 5, 34, "Section",ExpressionUUID->"c5d7f6a4-8250-400d-ab42-e888dffd13fd",
 InitializationCell->True],
Cell[64054, 1585, 571, 14, 70, "Input",ExpressionUUID->"9ddf25be-31eb-49dd-8072-d2793ac107bf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[64662, 1604, 212, 4, 34, "Section",ExpressionUUID->"b62cac26-f160-43e3-9e5c-3cb238c7526e",
 InitializationCell->True],
Cell[64877, 1610, 363, 8, 49, "Text",ExpressionUUID->"0868d41f-8a3f-4a45-a37b-118d54f10ab8",
 InitializationCell->True],
Cell[65243, 1620, 473, 11, 48, "Input",ExpressionUUID->"56e33ef9-1c77-4306-8b2c-7bae854b905a",
 InitializationCell->True],
Cell[65719, 1633, 319, 9, 48, "Input",ExpressionUUID->"bf6cd454-7248-4262-9aa8-7977cc5dd439",
 InitializationCell->True],
Cell[66041, 1644, 456, 12, 48, "Input",ExpressionUUID->"4a4041d5-15f2-46d9-819a-1742b4f16c9d",
 InitializationCell->True],
Cell[66500, 1658, 402, 11, 48, "Input",ExpressionUUID->"f756d9c5-7881-4177-bd45-c9e2feb30817",
 InitializationCell->True],
Cell[66905, 1671, 387, 11, 48, "Input",ExpressionUUID->"66cdeb8d-2e26-4c5c-a3ea-619f40db7335",
 InitializationCell->True],
Cell[67295, 1684, 415, 10, 48, "Input",ExpressionUUID->"c646b112-3d73-4cef-8a40-ecba772067ae",
 InitializationCell->True],
Cell[67713, 1696, 1126, 28, 154, "Input",ExpressionUUID->"6ff26674-506b-4c6f-9b76-3670801d0f77",
 InitializationCell->True],
Cell[68842, 1726, 1110, 28, 154, "Input",ExpressionUUID->"2e846193-a958-4a42-969a-3770650f22f3",
 InitializationCell->True],
Cell[69955, 1756, 1108, 28, 154, "Input",ExpressionUUID->"dc51e52a-181c-48bf-894e-6e456bee25fb",
 InitializationCell->True],
Cell[71066, 1786, 1039, 24, 112, "Input",ExpressionUUID->"4f1bb0e5-c2f8-4495-841f-546e34bbe10c",
 InitializationCell->True],
Cell[72108, 1812, 321, 9, 48, "Input",ExpressionUUID->"875fa0dd-6575-407f-80d0-ffbf27dbfe76",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[72478, 1827, 272, 5, 49, "Subchapter",ExpressionUUID->"6a4f88da-39b8-4784-848c-c895735705bc",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[72775, 1836, 286, 5, 36, "Section",ExpressionUUID->"488ca411-d4f8-41b5-b247-a2568c39a3e8",
 InitializationCell->True],
Cell[73064, 1843, 636, 15, 91, "Input",ExpressionUUID->"8de60b59-2252-414b-b8fc-d477c1a5c23c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[73737, 1863, 269, 5, 36, "Section",ExpressionUUID->"6f68d99a-aeed-47c8-988e-88b63605fed9",
 InitializationCell->True],
Cell[74009, 1870, 306, 7, 49, "Text",ExpressionUUID->"116f1c06-ef2e-496a-bd52-e8955b936be1",
 InitializationCell->True],
Cell[74318, 1879, 327, 7, 49, "Text",ExpressionUUID->"d5d5266e-7647-4b95-a64a-d67d98b9e3a3",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[74670, 1890, 427, 7, 43, "Subsection",ExpressionUUID->"a176fccf-3576-45b3-9a75-af9548b32b77",
 InitializationCell->True],
Cell[75100, 1899, 767, 14, 48, "Input",ExpressionUUID->"09f14559-0633-426e-93c0-56b75a0b45c0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[75904, 1918, 431, 7, 35, "Subsection",ExpressionUUID->"90369acf-1a67-4993-a7aa-a5765c64b921",
 InitializationCell->True],
Cell[76338, 1927, 454, 13, 48, "Input",ExpressionUUID->"7eaff18b-3f84-406d-b7ad-a37fa8570183",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[76829, 1945, 437, 7, 35, "Subsection",ExpressionUUID->"48d2b904-e6d4-47a0-9e08-8118359ea8d1",
 InitializationCell->True],
Cell[77269, 1954, 412, 10, 46, "Input",ExpressionUUID->"58e4064a-efe1-4bce-ab57-e83251c2a648",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[77718, 1969, 389, 7, 35, "Subsection",ExpressionUUID->"25365391-9bde-420f-89d1-dd448f8d56cd",
 InitializationCell->True],
Cell[78110, 1978, 209, 4, 30, "Text",ExpressionUUID->"2aa52fb6-f684-4614-87b7-1213f52ac76f",
 InitializationCell->True],
Cell[78322, 1984, 2193, 58, 175, "Input",ExpressionUUID->"c8d42778-ce17-4dd2-849d-bd29174b8e93",
 InitializationCell->True],
Cell[80518, 2044, 430, 10, 50, "Input",ExpressionUUID->"1b9becc3-ce86-4f7b-81a0-9b54fc88a23a",
 InitializationCell->True],
Cell[80951, 2056, 565, 12, 48, "Input",ExpressionUUID->"83adf376-babe-4b16-8f7c-6c950b100edf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[81553, 2073, 638, 10, 35, "Subsection",ExpressionUUID->"b2e0882d-f933-49e0-bf8e-a14a11c2a819",
 InitializationCell->True],
Cell[82194, 2085, 288, 7, 30, "Text",ExpressionUUID->"f4cf7a22-ba74-4552-8af1-05db9a198786",
 InitializationCell->True],
Cell[82485, 2094, 1096, 26, 154, "Input",ExpressionUUID->"6f09c1ab-3e95-42dd-82e4-97aeab417b18",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[83618, 2125, 448, 7, 35, "Subsection",ExpressionUUID->"0cb21085-cb9d-447c-94b7-0f7c626d9836",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[84091, 2136, 359, 6, 34, "Subsubsection",ExpressionUUID->"63c7f274-f545-42df-b70c-8c8f27dc8fcc",
 InitializationCell->True],
Cell[84453, 2144, 659, 16, 70, "Input",ExpressionUUID->"6d905549-60bc-44b4-b3af-c4dc022d36e6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[85149, 2165, 366, 6, 28, "Subsubsection",ExpressionUUID->"5e3eadcb-41df-4f8f-81eb-d875e2f70ef7",
 InitializationCell->True],
Cell[85518, 2173, 2081, 45, 280, "Input",ExpressionUUID->"605caa8a-87be-498a-8b70-bb6eb0275e80",
 InitializationCell->True],
Cell[87602, 2220, 2334, 51, 238, "Input",ExpressionUUID->"82c0ce0b-bb68-4c0e-909e-6d6626d34d74",
 InitializationCell->True],
Cell[89939, 2273, 2222, 49, 238, "Input",ExpressionUUID->"4db0ddd9-d800-409b-899d-e935620ba4c8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[92198, 2327, 322, 5, 28, "Subsubsection",ExpressionUUID->"bbc3439e-6e6b-49fb-bc1f-1ea26e7d3c0e",
 InitializationCell->True],
Cell[92523, 2334, 1936, 43, 259, "Input",ExpressionUUID->"dc2ff83e-c935-46ec-b6a5-7d09048c4b52",
 InitializationCell->True],
Cell[94462, 2379, 2142, 47, 259, "Input",ExpressionUUID->"a9a3a9c7-c525-4347-a671-f8786562bdbe",
 InitializationCell->True],
Cell[96607, 2428, 2043, 47, 238, "Input",ExpressionUUID->"75188b11-a620-4c95-93fd-76e37b8cd6c2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[98687, 2480, 446, 7, 28, "Subsubsection",ExpressionUUID->"047e9893-3b91-4d4c-acdc-4d7ff9eed2c3",
 InitializationCell->True],
Cell[99136, 2489, 852, 20, 91, "Input",ExpressionUUID->"b2aea9b9-a86c-4328-98f8-aa7cde6313ba",
 InitializationCell->True],
Cell[99991, 2511, 906, 20, 91, "Input",ExpressionUUID->"997ab8e3-7195-44e9-b826-d659ccd33d5d",
 InitializationCell->True],
Cell[100900, 2533, 965, 21, 112, "Input",ExpressionUUID->"a74e8b45-febb-44f2-8e00-0501d391f8b4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[101914, 2560, 499, 8, 35, "Subsection",ExpressionUUID->"d7ca61b3-10c0-4116-8351-38cd6ebc6f64",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[102438, 2572, 164, 3, 34, "Subsubsection",ExpressionUUID->"f08e2051-e33b-4aaa-b54b-4deb7614b346"],
Cell[102605, 2577, 578, 17, 70, "Input",ExpressionUUID->"2b11dacf-a2a8-432e-ad9d-484627269086",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[103220, 2599, 168, 3, 28, "Subsubsection",ExpressionUUID->"fee4fbb2-37a9-47ba-a970-4439c958229c"],
Cell[103391, 2604, 297, 7, 49, "Text",ExpressionUUID->"5351bd80-73db-4764-a8ca-58f7a65bb4ee",
 InitializationCell->True],
Cell[103691, 2613, 255, 6, 30, "Text",ExpressionUUID->"49e54a8d-83c9-451b-9e9c-4532f75fc1cd",
 InitializationCell->True],
Cell[103949, 2621, 289, 7, 49, "Text",ExpressionUUID->"e4b64e13-1151-48ad-b496-b10839f25a67",
 InitializationCell->True],
Cell[104241, 2630, 3584, 75, 351, "Input",ExpressionUUID->"4a67e4b5-4e26-4c3e-a863-294063664ad0",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[107874, 2711, 565, 9, 35, "Subsection",ExpressionUUID->"76fb608c-d115-4404-af8d-87ad4ee14f86",
 InitializationCell->True],
Cell[108442, 2722, 3071, 45, 66, "Input",ExpressionUUID->"f09541ce-a1ac-42fe-8e08-9053131407f5",
 InitializationCell->True],
Cell[111516, 2769, 3220, 51, 66, "Input",ExpressionUUID->"5d233f72-1246-4526-9def-a45594a0462f",
 InitializationCell->True],
Cell[114739, 2822, 3286, 50, 46, "Input",ExpressionUUID->"96d5f75d-7e62-46bd-aa28-776d5bcc57bf",
 InitializationCell->True],
Cell[118028, 2874, 3857, 65, 142, "Input",ExpressionUUID->"e94b7327-ba99-408f-8534-cf897465fd3b",
 InitializationCell->True],
Cell[121888, 2941, 4521, 88, 123, "Input",ExpressionUUID->"ec6dbf7d-de2d-4965-a236-049664803774",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[126446, 3034, 395, 8, 35, "Subsection",ExpressionUUID->"aa1fe830-0ecf-450a-ba4f-b76ac95d8b27",
 InitializationCell->True],
Cell[126844, 3044, 768, 20, 66, "Input",ExpressionUUID->"980bb3e3-2213-40a1-8804-ce53b39a4ab2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[127649, 3069, 404, 7, 35, "Subsection",ExpressionUUID->"35a2e3be-4872-4552-bbc6-307bddef3d24",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[128078, 3080, 192, 4, 34, "Subsubsection",ExpressionUUID->"33302059-995f-4a21-b0cb-f81a2b94dd30",
 InitializationCell->True],
Cell[128273, 3086, 410, 11, 48, "Input",ExpressionUUID->"e969e084-89c3-4f1b-912a-af5a18c3f750",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[128720, 3102, 295, 5, 28, "Subsubsection",ExpressionUUID->"321ae3e7-e1e7-40a6-bf74-c851652e1a43",
 InitializationCell->True],
Cell[129018, 3109, 660, 17, 112, "Input",ExpressionUUID->"dd495673-06ae-4925-9ad7-e4db207e773d",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[129751, 3134, 337, 6, 49, "Subchapter",ExpressionUUID->"ba31fed9-3108-46f1-8119-126694e70edf",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[130113, 3144, 303, 5, 36, "Section",ExpressionUUID->"8d561996-b5d0-4dec-a400-80894e7a677d",
 InitializationCell->True],
Cell[130419, 3151, 669, 16, 70, "Input",ExpressionUUID->"809233b1-5c5e-45f6-b186-41460e1b0f60",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[131125, 3172, 334, 6, 36, "Section",ExpressionUUID->"455a8bc9-db44-4696-9dcd-4d4f5949a48a",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[131484, 3182, 268, 4, 45, "Subsubsection",ExpressionUUID->"e2a080c5-9617-47a5-9584-4c19a55b8ead"],
Cell[131755, 3188, 292, 8, 48, "Input",ExpressionUUID->"ec2ce135-3d58-4a30-b04b-391557ecb08d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[132084, 3201, 173, 3, 37, "Subsubsection",ExpressionUUID->"cebff9ba-41ee-4bb2-b8e4-28c4e2eb201c"],
Cell[132260, 3206, 388, 11, 46, "Input",ExpressionUUID->"fbf77740-8a00-4761-b4cd-48e88775e585",
 InitializationCell->True],
Cell[132651, 3219, 537, 14, 46, "Input",ExpressionUUID->"48af35cb-c232-4986-af88-7b246e74ce9b",
 InitializationCell->True],
Cell[133191, 3235, 569, 14, 46, "Input",ExpressionUUID->"dc9e007f-6ee9-4b82-a744-1e3d3d3b2df9",
 InitializationCell->True],
Cell[133763, 3251, 753, 21, 89, "Input",ExpressionUUID->"31ae7bd6-0dc9-410a-9f0f-8e48e585585d",
 InitializationCell->True],
Cell[134519, 3274, 799, 21, 89, "Input",ExpressionUUID->"3f4ca7d3-5eb8-4909-9a22-f3d0932f9b8b",
 InitializationCell->True],
Cell[135321, 3297, 1131, 24, 110, "Input",ExpressionUUID->"b5e29e75-4ebb-4439-b08e-e5fbd39da160",
 InitializationCell->True],
Cell[136455, 3323, 1143, 26, 131, "Input",ExpressionUUID->"aff7b846-13e7-4a24-a214-48a09aff498a",
 InitializationCell->True],
Cell[137601, 3351, 601, 13, 46, "Input",ExpressionUUID->"0d519d13-ba4b-4e52-bc61-89e9a978650c",
 InitializationCell->True],
Cell[138205, 3366, 599, 13, 46, "Input",ExpressionUUID->"6682e2c2-5312-4263-9813-070cafe41607",
 InitializationCell->True],
Cell[138807, 3381, 1551, 32, 173, "Input",ExpressionUUID->"c7aac64c-cda0-4c70-8cfe-bc6c44e31295",
 InitializationCell->True],
Cell[140361, 3415, 1319, 32, 152, "Input",ExpressionUUID->"1a1526fd-633b-41bb-a3cf-2b76ce86b7b2",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[141717, 3452, 228, 4, 45, "Subsubsection",ExpressionUUID->"33cffb78-0b9d-4541-97b1-a61e19f6a540"],
Cell[141948, 3458, 804, 20, 91, "Input",ExpressionUUID->"f4fcb87a-1306-4331-9daa-ff43dbf6e998",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[142813, 3485, 438, 7, 49, "Subchapter",ExpressionUUID->"b9c57d2d-255f-4935-a97c-f06da3811b5f",
 InitializationCell->True],
Cell[143254, 3494, 414, 9, 49, "Text",ExpressionUUID->"fae4c329-131a-4168-b63f-654e53bee063",
 InitializationCell->True],
Cell[143671, 3505, 630, 15, 91, "Input",ExpressionUUID->"d0b762be-4d63-40a2-b64a-18213a1491e5",
 InitializationCell->True],
Cell[144304, 3522, 2650, 53, 280, "Input",ExpressionUUID->"dee5a0ec-6393-4933-816c-05947a868e5b",
 InitializationCell->True],
Cell[146957, 3577, 758, 21, 91, "Input",ExpressionUUID->"58d1ed23-0128-497c-8a1d-e18d4cc68680",
 InitializationCell->True],
Cell[147718, 3600, 356, 9, 48, "Input",ExpressionUUID->"449d0b7f-2e1d-4815-860d-9b505558343b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[148111, 3614, 215, 4, 49, "Subchapter",ExpressionUUID->"4afd8284-4c7c-43f3-a1ca-eebc623eb5f0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[148351, 3622, 260, 5, 34, "Section",ExpressionUUID->"74db04de-d616-4fa3-94b1-452e92f2eee2",
 InitializationCell->True],
Cell[148614, 3629, 530, 14, 70, "Input",ExpressionUUID->"a8cd8e6b-2f6d-47b3-95db-a00453699f65",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[149181, 3648, 214, 4, 34, "Section",ExpressionUUID->"62f88dd7-bf33-4900-b85c-e3174810f066",
 InitializationCell->True],
Cell[149398, 3654, 371, 6, 30, "Text",ExpressionUUID->"c596eddc-3802-43dd-acc8-548d364ada14",
 InitializationCell->True],
Cell[149772, 3662, 310, 7, 49, "Text",ExpressionUUID->"4c80ab79-e0d4-45dc-a70b-6765a86df821",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[150107, 3673, 427, 7, 44, "Subsection",ExpressionUUID->"7cc836c8-de14-454c-b564-cddc69a18fe9",
 InitializationCell->True],
Cell[150537, 3682, 798, 16, 48, "Input",ExpressionUUID->"a76eab54-c362-47a4-951b-5067905d97dd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[151372, 3703, 286, 5, 44, "Subsection",ExpressionUUID->"f0333a17-ea66-4250-ad2f-24539c90de0c",
 InitializationCell->True],
Cell[151661, 3710, 595, 15, 70, "Input",ExpressionUUID->"59fc5d84-9660-4987-a923-d0e7e5dd97a0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[152293, 3730, 490, 8, 44, "Subsection",ExpressionUUID->"2ebf58b1-3e46-4e06-a619-9506ea68a253",
 InitializationCell->True],
Cell[152786, 3740, 769, 22, 70, "Input",ExpressionUUID->"1d17791b-3e34-489f-a052-ebac496ed886",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[153592, 3767, 592, 9, 44, "Subsection",ExpressionUUID->"b3f8a426-6afc-4ca0-8360-c5af9a25ab56",
 InitializationCell->True],
Cell[154187, 3778, 1683, 38, 217, "Input",ExpressionUUID->"56197a76-414e-45fb-9210-594fba0f8e35",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[155907, 3821, 439, 7, 44, "Subsection",ExpressionUUID->"f15553db-0aff-4ba4-ad22-ce9c90ea36e2",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[156371, 3832, 339, 6, 35, "Subsubsection",ExpressionUUID->"30196bc0-1953-447a-9e96-0d186ac1f514",
 InitializationCell->True],
Cell[156713, 3840, 978, 21, 91, "Input",ExpressionUUID->"2b805b70-0139-4d27-beb1-a1965274f3fa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[157728, 3866, 421, 7, 35, "Subsubsection",ExpressionUUID->"5f989953-d785-4c3c-ace7-c8a089d62fc7",
 InitializationCell->True],
Cell[158152, 3875, 895, 24, 70, "Input",ExpressionUUID->"12fe1c8d-bc4a-4671-958d-8786908c921a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[159096, 3905, 415, 7, 44, "Subsection",ExpressionUUID->"0218a2bc-b554-4511-98c5-6e94795736f5",
 InitializationCell->True],
Cell[159514, 3914, 1295, 26, 91, "Input",ExpressionUUID->"a5a57f27-77bd-4640-ba3b-2bfd3b3af52a",
 InitializationCell->True],
Cell[160812, 3942, 1147, 24, 91, "Input",ExpressionUUID->"51a3edd4-eb03-415e-b578-edfe58437d4f",
 InitializationCell->True],
Cell[161962, 3968, 1041, 20, 70, "Input",ExpressionUUID->"ebe8d5db-db52-4147-aac4-0e4ce3753a0a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[163040, 3993, 202, 4, 44, "Subsection",ExpressionUUID->"bd17763c-dd64-4fda-aaf0-78c9ab4fca01",
 InitializationCell->True],
Cell[163245, 3999, 1322, 27, 112, "Input",ExpressionUUID->"e798342a-a537-4f48-8d8c-236895016830",
 InitializationCell->True],
Cell[164570, 4028, 1338, 30, 112, "Input",ExpressionUUID->"80d966b1-cdb1-4e11-bbaf-2a3f5463228b",
 InitializationCell->True],
Cell[165911, 4060, 1058, 26, 154, "Input",ExpressionUUID->"d91d796a-a4bb-45bf-ad40-2172757b5d29",
 InitializationCell->True],
Cell[166972, 4088, 1564, 31, 154, "Input",ExpressionUUID->"045cc237-d54a-4d9b-9d3b-b2d8789846a8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[168573, 4124, 206, 4, 44, "Subsection",ExpressionUUID->"d868c1a4-f2d0-4e47-96e2-b5548f634ba8",
 InitializationCell->True],
Cell[168782, 4130, 1293, 28, 91, "Input",ExpressionUUID->"aac8ddbb-d2b9-43f8-92d7-c725aab10eb7",
 InitializationCell->True],
Cell[170078, 4160, 1172, 25, 91, "Input",ExpressionUUID->"5dbc6d1f-64f2-47b4-a2fd-3fc6a9e0e166",
 InitializationCell->True],
Cell[171253, 4187, 1011, 25, 112, "Input",ExpressionUUID->"ead5675c-4600-4d11-ade5-d98a84049ea1",
 InitializationCell->True],
Cell[172267, 4214, 1347, 28, 112, "Input",ExpressionUUID->"9b4d6620-9cc4-48e8-b091-87f91a85b023",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[173651, 4247, 530, 9, 44, "Subsection",ExpressionUUID->"f61349f3-ad8f-4779-8ca8-2de4a0ae679b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[174206, 4260, 857, 14, 35, "Subsubsection",ExpressionUUID->"d6635338-96d0-4a4e-a152-22436b4fd6a6",
 InitializationCell->True],
Cell[175066, 4276, 1277, 28, 280, "Input",ExpressionUUID->"858b88f3-7d1c-4cb3-9d16-31430f90f2bf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[176380, 4309, 806, 13, 35, "Subsubsection",ExpressionUUID->"3045e968-cdf3-4fb0-aded-3528abde4d3d",
 InitializationCell->True],
Cell[177189, 4324, 1389, 31, 259, "Input",ExpressionUUID->"7bf283e0-390d-4de0-a66f-4acc4730d07b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[178615, 4360, 662, 10, 35, "Subsubsection",ExpressionUUID->"232a422b-c88c-47ec-8dbf-11080e0c4e0d",
 InitializationCell->True],
Cell[179280, 4372, 270, 5, 30, "Text",ExpressionUUID->"18064fb3-4b76-4fac-afc6-de24feccbc46",
 InitializationCell->True],
Cell[179553, 4379, 2878, 49, 217, "Input",ExpressionUUID->"1334daa2-4921-4f37-8cd8-7d1d83834a10",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[182468, 4433, 789, 12, 35, "Subsubsection",ExpressionUUID->"f3b1461b-2b43-4a71-94c5-b5c1c55e8d5a",
 InitializationCell->True],
Cell[183260, 4447, 342, 8, 49, "Text",ExpressionUUID->"aa3ede50-c658-4847-9d70-273a3ad81346",
 InitializationCell->True],
Cell[183605, 4457, 288, 7, 49, "Text",ExpressionUUID->"3a3a8a1e-ac7c-4f8a-badb-398d498e16d7",
 InitializationCell->True],
Cell[183896, 4466, 7118, 137, 574, "Input",ExpressionUUID->"1e6da69c-a779-477d-b418-8bc379cc2ee8",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[191087, 4611, 342, 6, 49, "Subchapter",ExpressionUUID->"a5b96742-f7a6-4ff8-8c1c-99ac9e45ea23",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[191454, 4621, 179, 3, 45, "Subsubsection",ExpressionUUID->"880ea7e5-be1e-4be4-9c36-d06b89349bfa"],
Cell[191636, 4626, 301, 8, 48, "Input",ExpressionUUID->"7507b9c5-dd1c-46a6-9556-78ec461e269a",
 InitializationCell->True],
Cell[191940, 4636, 296, 8, 48, "Input",ExpressionUUID->"6121c0bd-bbce-4dce-ace5-191cd686c80b",
 InitializationCell->True],
Cell[192239, 4646, 296, 8, 48, "Input",ExpressionUUID->"8ac99037-25e7-44d3-8b00-bc3ac12bda12",
 InitializationCell->True],
Cell[192538, 4656, 348, 9, 48, "Input",ExpressionUUID->"84854ca8-0045-4c6f-ab8f-846a52350296",
 InitializationCell->True],
Cell[192889, 4667, 349, 9, 48, "Input",ExpressionUUID->"bf95d1d0-d790-41be-a6d5-3d934a74d659",
 InitializationCell->True],
Cell[193241, 4678, 364, 10, 48, "Input",ExpressionUUID->"56d0c38f-19ff-4f72-bac5-7803dd74ed17",
 InitializationCell->True],
Cell[193608, 4690, 1172, 28, 133, "Input",ExpressionUUID->"c59f3a98-120a-4b0c-aff5-0f44cac3eff8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[194817, 4723, 187, 3, 37, "Subsubsection",ExpressionUUID->"e4f65956-4e62-4e5b-a447-6f280a7b0032"],
Cell[195007, 4728, 539, 15, 70, "Input",ExpressionUUID->"a9d35034-06c7-40df-b7e3-90323d6c2d38",
 InitializationCell->True],
Cell[195549, 4745, 1429, 36, 175, "Input",ExpressionUUID->"31aa68cf-3a6d-4e32-8645-c2a87680dcb7",
 InitializationCell->True],
Cell[196981, 4783, 1414, 36, 175, "Input",ExpressionUUID->"abd5590d-feee-48ee-a49f-649b3dd7db14",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[198444, 4825, 406, 7, 65, "Subchapter",ExpressionUUID->"c8d3b317-8f81-475b-9369-2bb0f4429fc3",
 InitializationCell->True],
Cell[198853, 4834, 500, 13, 68, "Input",ExpressionUUID->"1a0c1786-59a3-48fe-ba07-69433e324b49",
 InitializationCell->True],
Cell[199356, 4849, 298, 8, 46, "Input",ExpressionUUID->"a5280d02-9def-45b7-b733-dfc6c848e12b",
 InitializationCell->True],
Cell[199657, 4859, 2120, 50, 299, "Input",ExpressionUUID->"98815beb-d780-4b4d-912b-6a83347e4562",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[201802, 4913, 161, 3, 45, "Subsubsection",ExpressionUUID->"b5861257-3248-43c3-900b-e6c5bc46db03"],
Cell[201966, 4918, 483, 13, 46, "Input",ExpressionUUID->"38981cee-53e4-4e88-be66-c3d8a36f6ca3",
 InitializationCell->True],
Cell[202452, 4933, 685, 18, 68, "Input",ExpressionUUID->"112d77a4-3c1a-425c-bbd2-da46eb8af17e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[203174, 4956, 194, 3, 37, "Subsubsection",ExpressionUUID->"bba70708-711c-4be4-a038-192d381d8062"],
Cell[203371, 4961, 376, 10, 46, "Input",ExpressionUUID->"0fe74863-40bf-4c25-bd16-f1415b863eac",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[203784, 4976, 219, 4, 37, "Subsubsection",ExpressionUUID->"b024aee2-fece-4207-bd65-cf07e04aa902"],
Cell[204006, 4982, 863, 24, 68, "Input",ExpressionUUID->"3a1a9508-da52-4ee6-aa39-7132a0041863",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[204930, 5013, 688, 11, 69, "Subtitle",ExpressionUUID->"d59c4d09-cc91-4074-b652-8e4a8fb1ad24",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[205643, 5028, 307, 6, 34, "Section",ExpressionUUID->"293cabd8-5570-407b-8a7f-12f0efbd1562",
 InitializationCell->True],
Cell[205953, 5036, 346, 8, 49, "Text",ExpressionUUID->"e7e7b93f-decd-4171-8a96-97cffccf49b9",
 InitializationCell->True],
Cell[206302, 5046, 317, 7, 49, "Text",ExpressionUUID->"b028b3f5-e252-4efd-8c20-98bb8eb1a1cf",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[206644, 5057, 278, 5, 44, "Subsection",ExpressionUUID->"e6c0d16c-09e8-4df2-9d93-430d4765d55a",
 InitializationCell->True],
Cell[206925, 5064, 669, 15, 48, "Input",ExpressionUUID->"43fe9950-3b78-454e-b1f6-2f1ef32bb03d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[207631, 5084, 291, 5, 36, "Subsection",ExpressionUUID->"f455285e-9553-4b55-9b8e-606262091ffd",
 InitializationCell->True],
Cell[207925, 5091, 752, 20, 48, "Input",ExpressionUUID->"1d7cf2a9-c9a8-44ee-ac68-512a8b952908",
 InitializationCell->True],
Cell[208680, 5113, 1127, 26, 175, "Input",ExpressionUUID->"e735cdf1-7660-40ac-99e7-b6b120dbdd17",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[209844, 5144, 406, 7, 60, "Subsection",ExpressionUUID->"8cde06c6-9063-49b2-80df-41af9e999d41",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[210275, 5155, 190, 4, 35, "Subsubsection",ExpressionUUID->"6a54134e-9165-4b71-ac94-6f2a86b9c971",
 InitializationCell->True],
Cell[210468, 5161, 597, 13, 70, "Input",ExpressionUUID->"6c144e68-d537-4fd2-a84f-7306ba656cc4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[211102, 5179, 192, 4, 35, "Subsubsection",ExpressionUUID->"098faae6-6377-4a37-b822-4e1dd22289a4",
 InitializationCell->True],
Cell[211297, 5185, 945, 22, 91, "Input",ExpressionUUID->"0efd8cfc-7fb1-4f4b-bbfe-396552041def",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[212279, 5212, 187, 4, 51, "Subsubsection",ExpressionUUID->"7b38be7d-52d0-494a-8187-9bfe9564497f",
 InitializationCell->True],
Cell[212469, 5218, 292, 7, 30, "Text",ExpressionUUID->"59e691b4-e11f-4964-af85-657569c2b973",
 InitializationCell->True],
Cell[212764, 5227, 1282, 31, 237, "Input",ExpressionUUID->"f2982558-e092-4859-a079-c9a0acfb9e1d",
 InitializationCell->True],
Cell[214049, 5260, 1261, 33, 199, "Input",ExpressionUUID->"9785af4c-c4cc-4e12-8402-385562a08a6c",
 InitializationCell->True],
Cell[215313, 5295, 276, 6, 46, "Text",ExpressionUUID->"cb4a9635-2a50-4393-9ff5-c23242a66631"],
Cell[215592, 5303, 1842, 42, 85, "Input",ExpressionUUID->"d51943c1-f621-4e60-a254-2540ab5be643",
 InitializationCell->True],
Cell[217437, 5347, 486, 10, 49, "Text",ExpressionUUID->"b679c558-a062-400e-be8c-0fe6a0fb0145",
 InitializationCell->True],
Cell[217926, 5359, 1041, 23, 66, "Input",ExpressionUUID->"26573131-3800-4a4a-96c5-ad2b13a40699",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[219004, 5387, 216, 4, 29, "Subsubsection",ExpressionUUID->"1c98101d-d786-4bcd-bc89-cc4c383c1075",
 InitializationCell->True],
Cell[219223, 5393, 936, 21, 175, "Input",ExpressionUUID->"2484d2f2-986c-4667-a614-6c1696e7721a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[220208, 5420, 269, 5, 44, "Subsection",ExpressionUUID->"0fec04c4-7b4d-42f2-a1ab-24fe8bc1f951",
 InitializationCell->True],
Cell[220480, 5427, 710, 20, 91, "Input",ExpressionUUID->"130f0d78-f8a2-4f72-b857-b7b16734722e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[221227, 5452, 233, 5, 44, "Subsection",ExpressionUUID->"e144ad35-9508-40cf-a040-533afb22ece2",
 InitializationCell->True],
Cell[221463, 5459, 340, 9, 48, "Input",ExpressionUUID->"722eb8c8-1392-4a73-899a-eb2eab212849",
 InitializationCell->True],
Cell[221806, 5470, 379, 9, 91, "Input",ExpressionUUID->"c953eca0-a567-4caa-8265-f1ad1161f1f5",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[222246, 5486, 182, 5, 69, "Subtitle",ExpressionUUID->"c265738f-c029-481a-a80d-3eb92212b45a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[222431, 5493, 299, 10, 66, "Input",ExpressionUUID->"d04ec502-10b7-49d7-9b0a-e3f0d66c6616",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[222779, 5509, 293, 7, 98, "Title",ExpressionUUID->"aa7b63b5-7fee-4d6a-9600-461f51179090",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[223097, 5520, 765, 11, 44, "Subsection",ExpressionUUID->"4cd5f303-ef55-48f6-9782-d720f0de0a4b"],
Cell[223865, 5533, 272, 6, 30, "Text",ExpressionUUID->"a7ac2b64-2f47-41c3-9e9d-d13c208954dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224174, 5544, 815, 11, 44, "Subsection",ExpressionUUID->"5e737d69-5789-4493-92cd-285ae3d5bb41"],
Cell[224992, 5557, 564, 9, 49, "Text",ExpressionUUID->"79a399d5-2e19-4d7c-b5df-3933a2138bbb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[225593, 5571, 871, 12, 44, "Subsection",ExpressionUUID->"e5fe09d3-5ca2-4a7c-a03d-7d67fb8fb94f"],
Cell[226467, 5585, 405, 6, 30, "Text",ExpressionUUID->"a60dedf8-b1af-4ce3-b706-a3ce10a64286"]
}, Open  ]],
Cell[CellGroupData[{
Cell[226909, 5596, 720, 10, 44, "Subsection",ExpressionUUID->"f9e89763-9fcc-4062-a66d-01dfa53cdcf9"],
Cell[227632, 5608, 238, 6, 30, "Text",ExpressionUUID->"a90e8781-f6df-4b3a-8358-f782eb1a6550"]
}, Open  ]]
}, Closed]]
}
]
*)

