(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    970037,      20016]
NotebookOptionsPosition[    895274,      18459]
NotebookOutlinePosition[    895922,      18482]
CellTagsIndexPosition[    895879,      18479]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["SD`Propagation`", "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526855795508213`*^9, 3.452685580972721*^9}, 
   3.682593449496829*^9, {3.683108316372006*^9, 3.683108316618305*^9}, 
   3.683127120390606*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"bf3a620b-f62c-4048-b649-25e49b3360a5"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"7dac5cf1-874d-49c2-ae9f-b25f3c5bf696"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SD`Propagation`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Liouville`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Generators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Approximations`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Propagation`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Events`Events`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Events`PulseSequence`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Interactions`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Hamiltonians`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Relaxation`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Signals`Signal`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Rotations`Wigner`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Units`\>\"", ",", "\[IndentingNewLine]", 
      "\"\<General`PhysicalConstants`\>\""}], "}"}]}], "]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.682597329576949*^9, 3.682597339617495*^9}, {
   3.682611681453899*^9, 3.682611690204586*^9}, 3.682611819113118*^9, {
   3.6826128177214537`*^9, 3.682612818096237*^9}, {3.6831083938005047`*^9, 
   3.68310839584037*^9}, {3.6831085086560926`*^9, 3.6831085164343147`*^9}, {
   3.683108873583951*^9, 3.683108875708552*^9}, 3.683110348855392*^9, {
   3.683118370146529*^9, 3.6831183724079723`*^9}, 3.6831271224781923`*^9, {
   3.691833203213181*^9, 3.691833204218501*^9}, {3.6922557607119102`*^9, 
   3.692255761924559*^9}, {3.6922559312896748`*^9, 3.692255932008264*^9}, {
   3.6922562144063663`*^9, 3.692256236205782*^9}, 3.701151229331143*^9, 
   3.745396628941558*^9},ExpressionUUID->"d9e72523-4043-4aac-a82f-\
3158f09ddff1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exports", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"8e405309-f4bc-4a66-a562-8cd548666539"],

Cell[CellGroupData[{

Cell["Continuous", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.456220934933506*^9, 3.456220936481489*^9}, 3.464689211845237*^9, 
   3.5343980945029583`*^9, {3.683108638431039*^9, 3.6831086409993153`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"b92c66c0-1a67-4cca-914f-7d9a73bef855"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Continuous", "::", "usage"}], "=", 
   "\"\<The option Continuous\[Rule]True may be used in NPropagate or \
NPropagationOperator to provide an interpolation function which may be \
evaluated at any time point within the propagation interval.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4562209413359537`*^9, 3.456220985070497*^9}, {
  3.667379326282254*^9, 
  3.6673793317818785`*^9}},ExpressionUUID->"7d9892be-e8bc-4948-9f50-\
8f1523d17f4c"]
}, Closed]],

Cell[CellGroupData[{

Cell["NPropagate", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.456220934933506*^9, 3.456220936481489*^9}, 3.464689211845237*^9, 
   3.5343980945029583`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"63139686-36d0-4edb-8ab9-49fd6ed01c4e"],

Cell[CellGroupData[{

Cell["NPropagate", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.46460935815442*^9, 3.464609359960815*^9}, 
   3.464689219410399*^9},ExpressionUUID->"dc5d97c4-c58c-4361-bdb0-\
7ecac169c676"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "usage"}], "=", 
   "\"\<NPropagate[EventsAndTimings, opts][\[Rho]ini] propagates an initial \
density operator \[Rho]ini under a consecutive sequence of events, returning \
the final density operator. If \[Rho]ini is a vector representation, the \
output is also a vector representation. If \[Rho]ini is a symbolic operator, \
the output is also a symbolic operator. If opts contains \
Continuous\[Rule]True, the output is a OperatorTrajectoryFunction which may \
be evaluated at any time point within the timing range of the propagation. \
The options InitialTimePoint\[Rule]tini or FinalTimePoint\[Rule]tfin may be \
given to specify the time origin of the event sequence. \n\n\tThe item \
EventsAndTimings is a list of events. The possible formats for each event \
are:\n(i) a single superoperator, assumed to act instantaneously;\n(ii) have \
the form {Hop,\[Tau]} where Hop is a time-independent Hamiltonian operator, \
acting over the interval \[Tau];\n(iii) have the form {Lsop,\[Tau]}, where \
Lsop is a time-independent Liouvillian superoperator, acting over the \
interval \[Tau];\n(iv) the form {Function[t,f[t]],\[Tau]} where f[t] is an \
operator or superoperator expression dependent on the time variable t. The \
time-dependent operator or superoperator acts over the interval \[Tau];\n(v) \
the form {PeriodicFunction[t,T,f[t]],\[Tau]} where f[t] is a periodic \
operator or superoperator expression with period T.  The periodic \
time-dependent operator or superoperator acts over the interval \[Tau];\n(vi) \
the form {ShapeFunction[..],\[Tau]} where the ShapeFunction object allows \
specification of a time-dependent Hamiltonian or Liouvillian dependent on \
either a global or local time variable, or both. \n\n\tThe call to NPropagate \
may include options for the NDSolve routine, used in cases (iv) and (v). The \
operator basis used in the calculation may be specified if desired using the \
OperatorBasis option.\n\t\n\tThe option BackgroundGenerator\[Rule]background \
may be used in NPropagate. The term background may be an operator, a \
superoperator, an operator function, and so on (the format is the same as any \
of the individual events). When this option is used, the term background is \
combined with all of the items in the sequence of events. \n\n\tThe two \
options UseMatrixExpWhenPossible, UseHilbertSpaceWhenPossible and \
UseDiagonalizationWhenPossible may be used to control the propagation \
strategy. These options take the values True or False.\n\n\tThe output of \
NPropagate is an operator, for the case Continuous\[Rule]False, or an \
OperatorTrajectoryFunction, for the case Continuous\[Rule]True.\n\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454564453889566*^9, 3.454564462185505*^9}, {3.4545790125806227`*^9, 
   3.454579027052902*^9}, {3.456220866951434*^9, 3.4562209149583797`*^9}, {
   3.458986087735921*^9, 3.458986208776279*^9}, {3.462784666703601*^9, 
   3.462784694444194*^9}, {3.462784828974102*^9, 3.4627848488522387`*^9}, {
   3.462795919245276*^9, 3.462795946756052*^9}, 3.462795978332906*^9, {
   3.463940602716009*^9, 3.463940716402767*^9}, {3.464609463370574*^9, 
   3.464609507886243*^9}, {3.464678795448881*^9, 3.464678802950691*^9}, {
   3.464689108027082*^9, 3.46468917993178*^9}, 3.497572586157694*^9, {
   3.500274397282778*^9, 3.50027440201153*^9}, {3.505135146804241*^9, 
   3.505135777556478*^9}, {3.5343983187486677`*^9, 3.5343983262095737`*^9}, {
   3.682613576480135*^9, 3.682613621927682*^9}, {3.682613660149828*^9, 
   3.682613703099373*^9}, {3.682613770878339*^9, 3.6826137943134604`*^9}, {
   3.682613825462884*^9, 3.682613917630434*^9}, 
   3.709375285052001*^9},ExpressionUUID->"0a847c49-46b0-4d68-a06d-\
c8f50cad5d7a"]
}, Closed]],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.464694546680662*^9, {3.4646946418417063`*^9, 
   3.4646946426638117`*^9}},ExpressionUUID->"0894c9d4-0ecd-4655-ac1e-\
423a6ab0052e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UseMatrixExpWhenPossible", "::", "usage"}], "=", 
   "\"\<UseMatrixExpWhenPossible is an option for NPropagate and associated \
routines. When set to True, propagation will use the matrix exponential to \
calculate the propagator under a time-independent event, rather than using a \
numerical solution of the time-dependent Schr\[ODoubleDot]dinger \
equation.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464694550960771*^9, 3.464694635393559*^9}, {
  3.534398238074813*^9, 
  3.5343982420886593`*^9}},ExpressionUUID->"09dbb707-c51c-4088-95e5-\
5d0e447f98fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UseDiagonalizationWhenPossible", "::", "usage"}], "=", 
   "\"\<UseDiagonalizationWhenPossible is an option for NPropagate and \
associated routines.  When set to True, propagation will diagonalize the \
Liouvillian or Hamiltonian for a time-independent event, rather than using a \
numerical solution of the time-dependent Schr\[ODoubleDot]dinger \
equation.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464694550960771*^9, 3.464694635393559*^9}, {
   3.500274312856977*^9, 3.500274365941203*^9}, 
   3.534398264485651*^9},ExpressionUUID->"8e5e272a-9819-4c9d-9939-\
73413a7c575c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UseHilbertSpaceWhenPossible", "::", "usage"}], "=", 
   "\"\<UseHilbertSpaceWhenPossible is an option for NPropagate and \
associated routines.  When set to True, propagation under Hamiltonian events \
will be calculated in Hilbert space, rather than in Liouville space, whenever \
possible.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464694550960771*^9, 3.4646946750267963`*^9}, {
  3.534398274061007*^9, 
  3.5343982862769833`*^9}},ExpressionUUID->"ce30e2cc-7f82-4508-8438-\
7839fcddaab4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NPropagationOperator", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, 3.5343099885162373`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"fa0b721f-0a31-4216-bc37-bab5f5b368dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "usage"}], "=", 
   "\"\<NPropagationOperator[events, opts] generates the unitary Operator for \
propagation under the specified events. The options opts may include a \
specification for Basis and options to be passed into NDSolve.\n\nThe output \
of NPropagate is an operator, for the case Continuous\[Rule]False, or an \
OperatorTrajectoryFunction, for the case Continuous\[Rule]True.\n\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534309991630437*^9, 3.534310111415*^9}, {
  3.534390129169463*^9, 3.534390135625058*^9}, {3.6831086915836973`*^9, 
  3.6831087107221823`*^9}},ExpressionUUID->"3045a187-a396-4858-9005-\
4cd515dd04ec"]
}, Closed]],

Cell[CellGroupData[{

Cell["NPropagationSuperoperator", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, 3.5343099885162373`*^9, {3.534390075689144*^9, 
   3.534390076566008*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"a2f87fc4-7320-42a8-9ee5-cdc5be0a9e89"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "::", "usage"}], "=", 
   "\"\<NPropagationSuperoperator[EventSpecifications, opts] generates the \
Superoperator for propagation under the specified EventSpecifications. The \
options opts may include a specification for OperatorBasis, Basis and options \
to be passed into NDSolve.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534309991630437*^9, 3.534310111415*^9}, {
  3.53439007990703*^9, 3.534390097459442*^9}, {3.5343901380735407`*^9, 
  3.53439014055229*^9}},ExpressionUUID->"46fbc635-b596-4b93-91b1-\
0a0e86d300e9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adiabatic routines & related", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.68259769518991*^9, 3.682597702185166*^9}, {
   3.719572750127195*^9, 3.7195727598988004`*^9}, {3.7197804262332306`*^9, 
   3.7197804280528574`*^9}, {3.719781100799389*^9, 
   3.7197811139087496`*^9}},ExpressionUUID->"5446cf15-570d-42c0-a92f-\
e1e5eef24e0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "usage"}], "=", 
   "\"\<Correlated Eigensystem allows the calculation of the correlated \
eigenvalues and eigenvectors of a parameter-dependent Hamiltonian, H(x)= \!\(\
\*SubscriptBox[\(H\), \(0\)]\) + \!\(\*SubscriptBox[\(H\), \(1\)]\)(x). \n\t\
The syntax of CorrelatedEigensystems is given by: CorrelatedEigensystems[\!\(\
\*SubscriptBox[\(H\), \(1\)]\)(x), range, opts].\n\tThe range specifications \
could be of the type {x, \!\(\*SubscriptBox[\(x\), \(a\)]\), \
\!\(\*SubscriptBox[\(x\), \(b\)]\), \[Delta]x} or {x, {\!\(\*SubscriptBox[\(x\
\), \(1\)]\), \!\(\*SubscriptBox[\(x\), \(2\)]\), ..., \!\(\*SubscriptBox[\(x\
\), \(N\)]\)}}.\n\tCorrelatedEigensystems returns a two-element list: \
{correvals,correvecs}. \n\tThe correlated eigenvalues take the \
form:{{{\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \
\(1\)]\)}, {\!\(\*SubscriptBox[\(x\), \(2\)]\), \
\!\(\*SubscriptBox[\(\[Lambda]\), \(1\)]\)}, ...}, \
{{\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \
\(2\)]\)}, {\!\(\*SubscriptBox[\(x\), \(2\)]\), \
\!\(\*SubscriptBox[\(\[Lambda]\), \(2\)]\)}, ...} ...} and may readily be \
plotted using ListPlot. The correlated eigenvectors take the form: \
{{\!\(\*SubscriptBox[\(x\), \(1\)]\), {\!\(\*SubscriptBox[\(v\), \(1\)]\), \!\
\(\*SubscriptBox[\(v\), \(2\)]\),..., \!\(\*SubscriptBox[\(v\), \(N\)]\)}}, {\
\!\(\*SubscriptBox[\(x\), \(2\)]\), {\!\(\*SubscriptBox[\(v\), \(1\)]\), \!\(\
\*SubscriptBox[\(v\), \(2\)]\),..., \!\(\*SubscriptBox[\(v\), \(N\)]\)}}, \
...}.\n\tThe options include {BackgroundGenerator, Basis} to specify a \
constant Hamiltonian acting in the background and to define a starting Basis \
if desired.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025606968602*^9, 3.547025615213552*^9}, {
   3.682594281787702*^9, 3.682594297089982*^9}, 3.7195728001256533`*^9, {
   3.7195729459640474`*^9, 3.7195729594490128`*^9}, {3.719572991416896*^9, 
   3.7195729920978804`*^9}, {3.728128613908592*^9, 3.72812861900669*^9}, {
   3.7281286559035177`*^9, 3.7281286999232287`*^9}, {3.728128738546852*^9, 
   3.7281287809293585`*^9}},ExpressionUUID->"f67e4129-c4f2-41d2-b182-\
30d69dad2d76"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReturnKets", "::", "usage"}], "=", 
   "\"\<Internal SpinDynamica option for CorrelatedEigensystems\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7195826449452324`*^9, 
  3.719582660231018*^9}},ExpressionUUID->"19c7dac9-3b46-464d-af23-\
177955839a3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AdiabaticPropagation", "::", "usage"}], "=", 
   "\"\<Internal SpinDynamica function responsible for adiabatic propagation.\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7195826449452324`*^9, 3.719582660231018*^9}, {
  3.7197804609839926`*^9, 3.7197804905029135`*^9}, {3.719849424724634*^9, 
  3.7198494273350563`*^9}, {3.7276842542451773`*^9, 
  3.727684261148493*^9}},ExpressionUUID->"98c6e395-765f-496d-a1a6-\
5179c973b417"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"dynamicphase", "::", "usage"}], "=", 
   "\"\<Internal SpinDynamica function responsible for calculation of dynamic \
phase factors during an adiabatic process.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7195826449452324`*^9, 3.719582660231018*^9}, {
  3.7197804609839926`*^9, 3.719780472784279*^9}, {3.727684264084313*^9, 
  3.727684281603811*^9}},ExpressionUUID->"14076868-3c8b-4a10-ab1e-\
dcaea1f5e204"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"geometricphase", "::", "usage"}], "=", 
   "\"\<Internal SpinDynamica function responsible for calculation of \
geometric phase factors during an adiabatic process.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7195826449452324`*^9, 3.719582660231018*^9}, {
  3.7197804609839926`*^9, 3.719780483073064*^9}, {3.727684285692627*^9, 
  3.7276842927724457`*^9}},ExpressionUUID->"d267a713-376b-471c-899f-\
7bff90a08f5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"phasesmoothing", "::", "usage"}], "=", 
   "\"\<Internal SpinDynamica function related to the calculation of \
geometric phase factors during an adiabatic process.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7195826449452324`*^9, 3.719582660231018*^9}, {
  3.7197804609839926`*^9, 3.7197804905029135`*^9}, {3.727684297140004*^9, 
  3.7276843328357663`*^9}},ExpressionUUID->"e3150222-1aeb-4cfc-bf2e-\
b32d3945275d"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorTrajectoryFunction", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, 3.62115644410917*^9, 
   3.682613406660345*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"29983912-ed1e-4746-a941-7ea1c6f51938"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrajectoryFunction", "::", "usage"}], "=", 
   "\"\<OperatorTrajectoryFunction[timerange,trajectory] is a function which \
provides an operator when evaluated at any time point within timerange. It is \
provided as the output of a NPropagate or NPropagationOperator evaluation \
with option Continuous\[Rule]True.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.6666934535413065`*^9, 3.666693491356688*^9}, {
   3.6667284802070847`*^9, 3.66672849207652*^9}, {3.682613437603443*^9, 
   3.682613440034628*^9}, {3.68261356596343*^9, 
   3.682613571194448*^9}},ExpressionUUID->"bfa8cba6-0a2f-4dde-89ad-\
cc5b0ea81cb6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Precalculate", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, 3.459343594526519*^9, 3.464355592030745*^9, {
   3.4657938594682913`*^9, 3.465793863040501*^9}, {3.4862762746096687`*^9, 
   3.486276276798992*^9}, {3.506862563071916*^9, 3.506862565053204*^9}, 
   3.684774710035553*^9, 3.6848634359500637`*^9, 3.684946401152316*^9, {
   3.691431315417358*^9, 3.691431320641889*^9}, 3.691431405654745*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"29190c90-35ce-4aae-a109-b8c752d7d19b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "::", "usage"}], "=", 
   "\"\<Precalculate[events, options] calculates the propagator for a set of \
events and stores it as a PrecalculatedEvent object for future use. The \
output is a PrecalculatedEvent object. This may save calculation time in some \
cases. The options may contain a rule of the form \
BackgroundGenerator\[Rule]<backgen>. This uses the specified background \
generator <backgen> when calculating the propagator for the event. A \
PrecalculatedEvent may only be used in a context for which the \
BackgroundGenerator is the same as that applying when the PrecalculatedEvent \
was constructed. \nThe option Precalculate\[Rule]True or \
Precalculate\[Rule]False is also used as an option for some propagation \
routines to indicate whether an attempt is made to detect and precalculate \
common events, in order to reduce computation time.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.464355600866314*^9, 
   3.464355636120579*^9}, 3.4644483879205227`*^9, {3.4644486678901577`*^9, 
   3.4644486765381327`*^9}, {3.4657938823545322`*^9, 3.465793909630354*^9}, {
   3.504268443715642*^9, 3.504268550449213*^9}, {3.508338888517846*^9, 
   3.508338911117831*^9}, {3.6848635007557163`*^9, 3.6848635890770493`*^9}, {
   3.684946401158679*^9, 3.684946401164785*^9}, {3.6914313246708803`*^9, 
   3.69143149864843*^9}, {3.6914315954624567`*^9, 3.691431599727109*^9}, {
   3.6916008234060173`*^9, 3.691600887279217*^9}, {3.719746889021346*^9, 
   3.7197470454726954`*^9}},ExpressionUUID->"4bdbf4cc-6281-4da5-8e40-\
f85ad5dbfb98"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["start", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"167172aa-ef9e-4ee7-87fa-b682dbc3b960"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Chronology", "=", "\"\<LeftToRight\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545050393596538*^9, 3.5450503995208893`*^9}, {
  3.545050732985859*^9, 
  3.545050735366548*^9}},ExpressionUUID->"f2a84ac0-d682-4d0d-8f34-\
aa5ee3e15b4d"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"7c2f35cd-af2a-4e34-b551-77232af03d56"]
}, Closed]],

Cell[CellGroupData[{

Cell["local routines", "Subtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.533046062439581*^9, 3.533046079306073*^9}, 
   3.533046828844969*^9, {3.703182299106623*^9, 
   3.7031823008979936`*^9}},ExpressionUUID->"fdc13a1e-a256-4b2f-b075-\
318e6b6d3029"],

Cell[CellGroupData[{

Cell["SortVectorSpaceCompatibility", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.6914381546757927`*^9}, {3.6965797671349716`*^9, 
   3.6965797806868815`*^9}, {3.6966060571434784`*^9, 3.6966060587828045`*^9}, 
   3.6968826366089125`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"52c21289-8b9e-461b-8585-ec3ee64f6060"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SortVectorSpaceCompatibility", "[", 
    RowBox[{
     RowBox[{"ev", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{"st_", ",", "chars_", ",", 
        RowBox[{"events", ":", 
         RowBox[{"{", 
          RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
       "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"eventsig", ",", "splitevents"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"splitevents", "=", 
       RowBox[{"SplitBy", "[", 
        RowBox[{"events", ",", 
         RowBox[{
          RowBox[{"HilbertSpaceCompatibility", "[", 
           RowBox[{"#", ",", "opts"}], "]"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"eventsig", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"HilbertSpaceCompatibility", "[", "#", "]"}], "&"}], "/@", 
         "splitevents"}], ")"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SortVectorSpaceCompatibility", "[", 
       RowBox[{"(", 
        RowBox[{"Transpose", "@", 
         RowBox[{"{", 
          RowBox[{"eventsig", ",", "splitevents"}], "}"}]}], ")"}], "]"}]}]}],
     "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SortVectorSpaceCompatibility", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"A", ":", 
       RowBox[{"{", "__", "}"}]}], ",", 
      RowBox[{"B", ":", 
       RowBox[{
        RowBox[{"{", "__", "}"}], ".."}]}]}], "}"}], "]"}], ":=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"SortVectorSpaceCompatibility", "[", "A", "]"}], ",", 
     RowBox[{"SortVectorSpaceCompatibility", "[", 
      RowBox[{"{", "B", "}"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SortVectorSpaceCompatibility", "[", 
    RowBox[{"{", 
     RowBox[{"stat_", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"{", "__", "}"}]}]}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"stat", ",", "#"}], "}"}], "&"}], "/@", "ev"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SortVectorSpaceCompatibility", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"stat_", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"{", "__", "}"}]}]}], "}"}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"stat", ",", "#"}], "}"}], "&"}], "/@", "ev"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 
   3.6968827235302553`*^9}},ExpressionUUID->"60639b1b-9973-4dee-adfd-\
9b090eb5301e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Propagator to Liouville Propagator", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.6914381546757927`*^9}, {3.6965797671349716`*^9, 
   3.6965797806868815`*^9}, {3.6966060571434784`*^9, 3.6966060587828045`*^9}, 
   3.6968826366089125`*^9, {3.697374327521062*^9, 3.697374337474808*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"e2e17385-b827-4620-a56d-74e8e2500958"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HilbPropToLiouvProp", "[", 
     RowBox[{
      RowBox[{"k_.", "*", 
       RowBox[{"A", ":", 
        RowBox[{"(", 
         RowBox[{
         "_Operator", "|", "_RotationOperator", "|", "_OperatorProduct"}], 
         ")"}]}]}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Ufw", ",", "Ubw"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Ufw", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{
          RowBox[{"k", "*", "A"}], ",", 
          RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ubw", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"UnitaryMatrixQ", "[", "Ufw", "]"}], "\[Equal]", "True"}], 
          ",", 
          RowBox[{"ConjugateTranspose", "@", "Ufw"}], ",", 
          RowBox[{"Inverse", "@", "Ufw"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"Ufw", ",", 
           RowBox[{"Transpose", "@", "Ubw"}]}], "]"}], ",", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}], ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}], "}"}], 
              ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", 
            RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HilbPropToLiouvProp", "[", 
    RowBox[{
     RowBox[{"A", ":", 
      RowBox[{"(", "_Superoperator", ")"}]}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "A"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, 
   3.693308349530686*^9, 3.6933083939910517`*^9, 3.6933084418658133`*^9, {
   3.6933087914399843`*^9, 3.693308825593412*^9}, {3.6933088584039307`*^9, 
   3.6933088636940084`*^9}, 3.693427694839072*^9, {3.696579650303874*^9, 
   3.696579651761428*^9}, {3.6965797048879905`*^9, 3.6965797052497606`*^9}, {
   3.6966060651587453`*^9, 3.696606065523715*^9}, {3.696606140957198*^9, 
   3.6966061504484587`*^9}, {3.696606200684936*^9, 3.696606237433606*^9}, 
   3.6966065415769625`*^9, {3.696606577658834*^9, 3.696606635558392*^9}, {
   3.6966209595039062`*^9, 3.6966210060940623`*^9}, {3.6966211581556225`*^9, 
   3.6966211586195188`*^9}, {3.6968814767282186`*^9, 
   3.6968814787849417`*^9}, {3.696882653624383*^9, 3.696882656612401*^9}, {
   3.6968827012911525`*^9, 3.6968827235302553`*^9}, {3.697374419099446*^9, 
   3.6973744206470194`*^9}, {3.6973746516113825`*^9, 3.697374663318343*^9}, {
   3.6973749355521793`*^9, 3.697374942990905*^9}, 3.703179668530675*^9, {
   3.7173194132467237`*^9, 3.717319417942607*^9}, {3.717319584133606*^9, 
   3.717319588163542*^9}, 3.7173197898424473`*^9, {3.717319877953902*^9, 
   3.717319886400354*^9}, {3.7173209380730906`*^9, 3.7173209401577244`*^9}, {
   3.7276850264875164`*^9, 
   3.727685038712928*^9}},ExpressionUUID->"9e4366d5-0ebb-4d88-9cd8-\
f8aaddf6e222"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NPropagate", "Subtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.533046062439581*^9, 3.533046079306073*^9}, 
   3.533046828844969*^9},ExpressionUUID->"c1815b2c-29b7-408a-a717-\
0a6ef3d0e4e3"],

Cell[CellGroupData[{

Cell["defaults", "Subsubtitle",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, 
   3.691438143429953*^9, {3.6966224624557595`*^9, 3.696622471389017*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"c0a32326-c503-4d0c-82f0-38b1269fa45e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "NPropagate", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Continuous", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseDiagonalizationWhenPossible", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpandRepeatedEvents", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PropagatorCalculationProcedure", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"AccuracyGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxStepSize", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxSteps", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.464861472784998*^9, 3.464861483441214*^9}, 
   3.4648615286770973`*^9, 3.4648730173172703`*^9, {3.4648740845965853`*^9, 
   3.4648740923300657`*^9}, {3.4649389788207808`*^9, 3.464938979305622*^9}, {
   3.4649391032323914`*^9, 3.464939139949542*^9}, 3.464939369751892*^9, 
   3.464944210485517*^9, {3.4649599887789917`*^9, 3.4649600189799023`*^9}, 
   3.464960163436203*^9, 3.4657307199008007`*^9, 3.465730770944022*^9, 
   3.465730801958722*^9, 3.465758498775585*^9, {3.4658145173278418`*^9, 
   3.465814524082449*^9}, {3.465814815775647*^9, 3.4658148334715242`*^9}, {
   3.4671972295728273`*^9, 3.467197233800462*^9}, {3.483952009583354*^9, 
   3.483952017548534*^9}, 3.497572538901269*^9, 3.4977586268463993`*^9, 
   3.499708694963387*^9, {3.499708744009026*^9, 3.499708746574301*^9}, {
   3.5030306306149883`*^9, 3.5030306375558147`*^9}, {3.5031117611042624`*^9, 
   3.5031117718455048`*^9}, 3.5044586933744907`*^9, 3.5080058974835157`*^9, {
   3.5080900784786158`*^9, 3.508090085815353*^9}, {3.5085107895701847`*^9, 
   3.508510791240788*^9}, {3.514454503646961*^9, 3.514454513964549*^9}, 
   3.514799185545196*^9, 3.515077830908255*^9, {3.532450992407064*^9, 
   3.532450997113079*^9}, {3.534310144544961*^9, 3.534310156553754*^9}, {
   3.534318337268446*^9, 3.5343183381724863`*^9}, {3.534318394765707*^9, 
   3.534318400204275*^9}, 3.534390194788438*^9, 3.5343987235487423`*^9, {
   3.5391119298439703`*^9, 3.539111941473713*^9}, 3.5434107948803387`*^9, 
   3.545050431601803*^9, {3.626027537094718*^9, 3.626027537828526*^9}, {
   3.6666080915983996`*^9, 3.666608100338314*^9}, {3.6666294836870165`*^9, 
   3.666629503697832*^9}, {3.666630097375392*^9, 3.6666301011973734`*^9}, {
   3.6667106182751527`*^9, 3.666710619416752*^9}, {3.666718489321924*^9, 
   3.6667184894698944`*^9}, {3.666719340623826*^9, 3.666719340804014*^9}, {
   3.691062928160233*^9, 3.691062929463285*^9}, {3.691407200821684*^9, 
   3.691407210567979*^9}, 3.6914099617053413`*^9, {3.691657453428626*^9, 
   3.691657484932658*^9}, 3.691677874187484*^9, 3.6931375723158894`*^9, 
   3.693137614274547*^9, {3.6933816079809875`*^9, 3.6933816083532696`*^9}, 
   3.696622471389017*^9, {3.6971979496301937`*^9, 3.6971979504710627`*^9}, {
   3.699563440185772*^9, 3.6995634448855457`*^9}, {3.7027964615483227`*^9, 
   3.702796468791917*^9}, {3.7027965663282375`*^9, 3.702796569730682*^9}, 
   3.709375004938279*^9, {3.711713663754356*^9, 
   3.711713695520192*^9}},ExpressionUUID->"b7e2690c-c35a-4d3d-87ed-\
4d97a2833dee"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations and checks", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.6914381546757927`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"46255cfa-1b2a-4206-89aa-37f2a7c07fb2"],

Cell["\<\
if successful, syntax is reduced to NPropagate[\[Rho], \
<checked>,<continuous>,<hilbertcompat>,...]
where <checked>=True|False, <continuous>=True|False, \
<hilbertcompat>=True|False|MixedHilbertSpaceCompatibility\
\>", "Text",
 CellChangeTimes->{{3.709369441543318*^9, 3.709369517200858*^9}, {
  3.709369554563127*^9, 
  3.709369607129817*^9}},ExpressionUUID->"a0a4c2b2-3d5d-4205-8a74-\
39a2b1065844"],

Cell[CellGroupData[{

Cell["checks and flags (1)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
  3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
  3.69149747441208*^9, 3.691497480706093*^9}, {3.6916575446580963`*^9, 
  3.691657548177092*^9}, {3.691657685513603*^9, 
  3.691657686488957*^9}},ExpressionUUID->"6190351d-e9d5-4308-8a11-\
babbae9c49de"],

Cell[CellGroupData[{

Cell["Check flags", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
   3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
   3.69149747441208*^9, 3.691497480706093*^9}, 
   3.691657555306875*^9},ExpressionUUID->"1382264d-cc14-46e1-a1cc-\
d714e5234297"],

Cell["\<\
Check flag: {<initial density operator>,<backgprepared>,<EventList \
imp>,<hilbcompat>,<no $Failed>,<num ready>,}\
\>", "Text",
 CellChangeTimes->{{3.691397731982896*^9, 3.691397800026311*^9}, {
  3.6913988035046587`*^9, 3.691398811659533*^9}, {3.691398882694293*^9, 
  3.691398915950233*^9}, {3.691398972356401*^9, 3.6913989778118773`*^9}, {
  3.6914010940803823`*^9, 3.691401102107382*^9}, {3.6914013217045193`*^9, 
  3.6914013257071877`*^9}, {3.6932059806476965`*^9, 
  3.6932059899963913`*^9}},ExpressionUUID->"0ef07663-58fe-412d-9031-\
8aec36bb6527"],

Cell[CellGroupData[{

Cell["insert Check flag", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
  3.6913976561529617`*^9}},ExpressionUUID->"413f1454-423b-4ea2-9b13-\
83ca036c709e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{
      RowBox[{"arg1", ":", 
       RowBox[{"Except", "[", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], "]"}]}], ",", 
      "args2___", ",", "opts___Rule"}], "]"}], "[", "\[Rho]_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"False", ",", "arg1", ",", "args2", ",", "opts"}], "]"}], "[", 
    "\[Rho]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691399842191819*^9, 3.691399848731359*^9}, {
   3.6931376303974285`*^9, 3.6931376385406156`*^9}, {3.6932073416442957`*^9, 
   3.693207349604109*^9}, {3.6932076736948133`*^9, 3.6932076798325667`*^9}, {
   3.6932161142346673`*^9, 
   3.6932161162722254`*^9}},ExpressionUUID->"edfb6f92-9c6b-47b7-acb0-\
7575c39c717e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckFlagDimension", "[", "NPropagate", "]"}], "=", "6"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691397808855783*^9, 3.6913978253090563`*^9}, 
   3.6913988177479887`*^9, 3.691398890847995*^9, 3.691399514439227*^9, 
   3.6931376434171963`*^9, {3.6932059954192576`*^9, 
   3.6932059955470667`*^9}},ExpressionUUID->"316d6f36-0234-4326-bf21-\
237b73a468c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"False", ",", "args___"}], "]"}], "[", "\[Rho]_", "]"}], ":=", 
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{"False", ",", 
        RowBox[{"{", 
         RowBox[{"CheckFlagDimension", "[", "NPropagate", "]"}], "}"}]}], 
       "]"}], ",", "args"}], "]"}], "[", "\[Rho]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691397668275591*^9, 3.6913976883929033`*^9}, {
   3.691397829269376*^9, 3.691397846124062*^9}, {3.6913978855650187`*^9, 
   3.6913978886256647`*^9}, {3.693137645906863*^9, 3.6931376527573595`*^9}, {
   3.693143236838086*^9, 3.6931432566494293`*^9}, {3.693207356434635*^9, 
   3.6932073622036295`*^9}, {3.6932077049928875`*^9, 
   3.6932077141711416`*^9}, {3.693212392106392*^9, 3.6932124302860537`*^9}, 
   3.693216071191767*^9, {3.693216109241558*^9, 3.693216112261692*^9}, {
   3.693216181742053*^9, 3.6932161835117207`*^9}, {3.693216411607438*^9, 
   3.693216416554904*^9}, {3.693218873502994*^9, 3.6932188757127657`*^9}, {
   3.69324622797025*^9, 
   3.693246234050655*^9}},ExpressionUUID->"432458cd-9cbe-4c59-8a77-\
2e961fef4168"]
}, Closed]],

Cell[CellGroupData[{

Cell["set True when all Checks done", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
   3.6913976561529617`*^9}, {3.691397715286193*^9, 3.69139772499686*^9}, 
   3.6932160588792686`*^9, 3.693247469271291*^9, 
   3.693247982674473*^9},ExpressionUUID->"c991a84e-0352-453b-85a7-\
026a1f882aba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "args___"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "True", ",", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.6913978952429934`*^9, 3.691397912831829*^9}, {
   3.693137661545639*^9, 3.6931376679351864`*^9}, {3.693143145990821*^9, 
   3.6931431644968567`*^9}, {3.6932073688644238`*^9, 
   3.6932073716338606`*^9}, {3.6932160333893757`*^9, 3.693216061431509*^9}, {
   3.6932161719034853`*^9, 3.693216192081308*^9}, {3.693218881152645*^9, 
   3.6932188812623587`*^9}, {3.6932191648327103`*^9, 3.693219173250311*^9}, {
   3.6932281293198814`*^9, 3.6932281632109237`*^9}, 3.6932282104942894`*^9, {
   3.6932462823653917`*^9, 3.6932462973361692`*^9}, {3.6932480020691876`*^9, 
   3.6932480553021917`*^9}, 3.6932493491352654`*^9, {3.6966031651352186`*^9, 
   3.696603165302663*^9}, {3.696603751637987*^9, 
   3.69660377443657*^9}},ExpressionUUID->"30426835-0209-47d2-bbfe-\
8a3270e32122"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate density operator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, 3.691398002329606*^9, {3.691497471948711*^9, 
   3.6914974724974318`*^9}, 3.691657580714264*^9, {3.6932073897830095`*^9, 
   3.6932073944128933`*^9}},ExpressionUUID->"48800c07-fd44-41e3-bcf3-\
3d2eb2099d64"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"NPropagate", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"False", ",", "morestatus___"}], "}"}], ",", 
       RowBox[{"arg1", ":", 
        RowBox[{"Except", "[", 
         RowBox[{"_", "?", "BooleanQ"}], "]"}]}], ",", 
       RowBox[{"args2", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
       "opts___Rule"}], "]"}], "[", "\[Rho]_", "]"}], ":=", 
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"OperatorQ", "[", "\[Rho]", "]"}], ",", "morestatus"}], "}"}],
       ",", "arg1", ",", "args2", ",", "opts"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"{", 
      RowBox[{"False", ",", "morestatus___"}], "}"}], ",", "events_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{"NPropagate", "::", "bad\[Rho]"}], "]"}]}], ";", "$Failed", 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.6931377326242733`*^9, 3.6931377459235396`*^9}, {3.693142985343305*^9, 
   3.693142996224156*^9}, {3.6931430451222057`*^9, 3.693143050500942*^9}, {
   3.6931431732994237`*^9, 3.693143204508617*^9}, {3.693207398824581*^9, 
   3.693207508383531*^9}, {3.6932160808418937`*^9, 3.6932160900025377`*^9}, {
   3.693216139943252*^9, 3.6932161650719624`*^9}, {3.6932161969533987`*^9, 
   3.693216199192914*^9}, {3.6932162673170443`*^9, 3.6932162860655613`*^9}, {
   3.693216483765131*^9, 3.6932164847143536`*^9}, {3.69321657821985*^9, 
   3.6932165972856617`*^9}, {3.693216641732929*^9, 3.69321664293328*^9}, {
   3.6932170872632265`*^9, 3.693217105351363*^9}, {3.6932171503516717`*^9, 
   3.69321717238286*^9}, {3.6932173412091846`*^9, 3.693217349601082*^9}, {
   3.693218336037411*^9, 3.693218341661393*^9}, {3.6932183729958353`*^9, 
   3.6932183776061316`*^9}, {3.6932184078482385`*^9, 
   3.6932184410977645`*^9}, {3.6932184785170813`*^9, 
   3.6932184787167377`*^9}, {3.69321852904755*^9, 3.693218529187454*^9}, {
   3.693218889742585*^9, 3.6932188907526016`*^9}, {3.6932244093785615`*^9, 
   3.693224418136738*^9}, {3.693246311467702*^9, 3.693246383523141*^9}, {
   3.6933418016778345`*^9, 3.69334180557745*^9}, {3.7260003781962495`*^9, 
   3.726000427942357*^9}},ExpressionUUID->"ce1b05ad-8aa1-458c-824d-\
9423deafc0d8"]
}, Closed]],

Cell[CellGroupData[{

Cell["first $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
   3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
   3.691399163725749*^9}, {3.691497397390768*^9, 3.691497407780759*^9}, 
   3.691657569755228*^9, {3.6916576752432823`*^9, 
   3.6916576761930723`*^9}},ExpressionUUID->"22c75821-bfcb-4579-ad6a-\
5fcae5c0b12a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{
      RowBox[{"arg1", ":", 
       RowBox[{"Except", "[", "True", "]"}]}], ",", "args___"}], "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"arg1", ",", "args"}], "}"}], ",", "$Failed"}], "]"}]}]}], ":=",
    "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691497412246861*^9, 3.691497459675514*^9}, {
  3.691497709668282*^9, 3.6914977223609943`*^9}, {3.693137697996378*^9, 
  3.69313769986411*^9}},ExpressionUUID->"f0efea6c-088d-4181-b946-\
afbdb6cb2315"]
}, Closed]],

Cell[CellGroupData[{

Cell["Continuous flag", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, 3.691398002329606*^9, {3.691497471948711*^9, 
   3.6914974724974318`*^9}, 
   3.691657580714264*^9},ExpressionUUID->"c114905f-aca5-4102-b6a7-\
6382921167d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "events_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "status", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Continuous", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ",", 
     "\[IndentingNewLine]", "events", ",", "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", 
        RowBox[{"Except", "[", 
         RowBox[{"Continuous", "\[Rule]", "_"}], "]"}]}], "]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 3.691399618106271*^9}, {
   3.693217195632522*^9, 3.6932172261697598`*^9}, {3.6932173714696*^9, 
   3.693217453377734*^9}, {3.693218485787515*^9, 3.6932184974865165`*^9}, {
   3.6932189177316885`*^9, 3.6932189207920494`*^9}, {3.6932463967964783`*^9, 
   3.6932463995036125`*^9}, 
   3.6973754391827583`*^9},ExpressionUUID->"953b254d-97d1-42c5-9ea6-\
88a4ba2cd4f1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398090064618*^9, 
  3.691398091836032*^9}},ExpressionUUID->"c793c2c1-d434-4a65-b369-\
b004756f28af"],

Cell[CellGroupData[{

Cell["null events", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.534310488228697*^9, 3.534310494353874*^9}, 
   3.666609425618058*^9, {3.6666094862480707`*^9, 3.6666095206815586`*^9}, 
   3.6667259458527355`*^9, {3.6667260072685785`*^9, 3.666726008209152*^9}, {
   3.6909706174328337`*^9, 3.690970624838993*^9}, 
   3.6932070335498962`*^9},ExpressionUUID->"aa64a854-6967-4355-a1e3-\
8b1b119e9beb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", "}"}], "|", 
       RowBox[{"UnityOperator", "[", "]"}], "|", 
       RowBox[{"UnitySuperoperator", "[", "]"}]}], ")"}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[Rho]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.454590588656004*^9, 3.454590593806896*^9}, {
   3.455106101697146*^9, 3.455106141078717*^9}, {3.456322977275065*^9, 
   3.456322994774282*^9}, 3.486711144793584*^9, {3.534310512299883*^9, 
   3.534310525515341*^9}, {3.534312019783698*^9, 3.534312030883206*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610614376049*^9, 3.6666106257460995`*^9}, {3.6666124794088817`*^9, 
   3.6666124817218175`*^9}, {3.690970542786141*^9, 3.690970554393107*^9}, {
   3.691391268201935*^9, 3.691391275439385*^9}, 3.691391890857008*^9, 
   3.69139835562991*^9, {3.691400727058011*^9, 3.691400733294271*^9}, {
   3.691401154426983*^9, 3.6914011578324823`*^9}, {3.6931377968848495`*^9, 
   3.6931377987244816`*^9}, {3.693138509907256*^9, 3.693138518808689*^9}, 
   3.6932070335498962`*^9, {3.6932179315621204`*^9, 3.6932179468220663`*^9}, {
   3.693218558884259*^9, 3.6932185631340313`*^9}, 
   3.7031793092290497`*^9},ExpressionUUID->"1c3003c6-0ad9-4031-92e0-\
2f903b47d537"]
}, Closed]],

Cell[CellGroupData[{

Cell["basis specifications", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.626084834821652*^9, {3.666718322230075*^9, 3.666718347498945*^9}, {
   3.6673838939925632`*^9, 3.667383894962243*^9}, 3.683129928127585*^9, {
   3.690983020249568*^9, 3.690983027553432*^9}, 
   3.691399175339323*^9},ExpressionUUID->"8610f7ce-cf52-44b8-90ef-\
ef255d1d892b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "status", ",", "cont", ",", "events", ",", 
     RowBox[{
      RowBox[{"OperatorBasis", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Basis", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.454563825254508*^9, 
   3.454563826638453*^9}, {3.454563905455122*^9, 3.4545639089804993`*^9}, 
   3.456205058769329*^9, 3.456323032056343*^9, {3.50242936511091*^9, 
   3.502429366084257*^9}, 3.503127186296899*^9, {3.515077856481803*^9, 
   3.515077860272526*^9}, {3.53431026989006*^9, 3.534310284553986*^9}, {
   3.6667184627270803`*^9, 3.6667184640569763`*^9}, 3.666718497847576*^9, {
   3.690970098289364*^9, 3.690970102351604*^9}, {3.691391216100874*^9, 
   3.691391216722046*^9}, {3.6913981502320547`*^9, 3.6913982230367193`*^9}, {
   3.6913999880307903`*^9, 3.691399994566819*^9}, 3.6914011732840977`*^9, {
   3.6932180101808476`*^9, 3.6932180527830753`*^9}, {3.6932181048788233`*^9, 
   3.6932181721444807`*^9}, {3.6932185979348354`*^9, 
   3.6932186072950974`*^9}, {3.6932464213147106`*^9, 3.693246424675731*^9}, {
   3.6972216599975386`*^9, 
   3.6972216700708632`*^9}},ExpressionUUID->"d6ad31f5-4623-45be-af16-\
7b4a6d038fe1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "SpinSystemUnknown"}], ")"}]}], 
   ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.454563828806386*^9, 
   3.4545639120761642`*^9, {3.455376344213114*^9, 3.455376346057372*^9}, 
   3.456205401485495*^9, 3.456323034576393*^9, 3.503127188744994*^9, {
   3.534310289761839*^9, 3.53431029312015*^9}, {3.69097010587998*^9, 
   3.690970113621426*^9}, {3.6913912187146597`*^9, 3.691391219137439*^9}, 
   3.691398160499175*^9, {3.6913981947847347`*^9, 3.6913982156721153`*^9}, 
   3.691399998823793*^9, 3.691401176516121*^9, 3.6932180309499993`*^9, {
   3.693218064580797*^9, 3.6932180654605856`*^9}, {3.6932186098647337`*^9, 
   3.693218614903245*^9}, {3.697221674987775*^9, 
   3.6972216771973534`*^9}},ExpressionUUID->"8f11ff12-c5b1-403e-9f86-\
0e4150a2d15e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"NPropagate", "::", "undefopbasis"}], ",", "opbasis"}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"NPropagate", "[", 
      RowBox[{"\[Rho]", ",", "status", ",", "cont", ",", "events", ",", 
       RowBox[{"OperatorBasis", "[", "]"}], ",", "basis", ",", "opts"}], 
      "]"}]}], "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 3.69140117874692*^9, {3.6932180346731744`*^9, 
   3.693218040149607*^9}, {3.693218071460653*^9, 3.693218076431404*^9}, {
   3.6932186172237916`*^9, 3.6932186209454308`*^9}, {3.697221397487401*^9, 
   3.6972214022863655`*^9}, {3.6972216788965273`*^9, 3.697221680157203*^9}, {
   3.6992789248778954`*^9, 3.69927899444897*^9}, {3.699279056111178*^9, 
   3.699279056953815*^9}, {3.6995418963197594`*^9, 
   3.699541917687686*^9}},ExpressionUUID->"d8afc2dc-d936-44f7-bb9c-\
3d8bf9d90750"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedBasisQ", "[", "basis", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"NPropagate", "::", "undefbasis"}], ",", "basis"}], "]"}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"NPropagate", "[", 
      RowBox[{
      "\[Rho]", ",", "status", ",", "cont", ",", "events", ",", "opbasis", 
       ",", 
       RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 3.69140117874692*^9, {3.6932180346731744`*^9, 
   3.693218040149607*^9}, {3.693218071460653*^9, 3.693218076431404*^9}, {
   3.6932186172237916`*^9, 3.6932186209454308`*^9}, {3.697221397487401*^9, 
   3.6972214022863655`*^9}, {3.6972216788965273`*^9, 3.697221680157203*^9}, {
   3.6992789248778954`*^9, 3.69927899444897*^9}, {3.699279056111178*^9, 
   3.699279056953815*^9}},ExpressionUUID->"85607683-3f11-4901-a758-\
f7b73e823cc3"]
}, Closed]],

Cell[CellGroupData[{

Cell["set up BackgroundGenerator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.502839560490985*^9, 3.502839565176372*^9}, {
   3.532438161776326*^9, 3.5324381640431232`*^9}, {3.54341082791413*^9, 
   3.5434108337521667`*^9}, 
   3.7093750049559803`*^9},ExpressionUUID->"7181f34c-bf40-4609-a74c-\
10a12b3c14c1"],

Cell["pre-diagonalization has been disabled in v3.0", "Text",
 CellChangeTimes->{{3.692847813601705*^9, 
  3.692847825065948*^9}},ExpressionUUID->"82437aa7-c7e1-46ac-8f56-\
9a48f4466fdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"evbackg", ",", "evbackgstd"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"evbackg", "=", 
        RowBox[{
         RowBox[{"BackgroundGenerator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "NPropagate", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evbackg", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"evbackg", ",", 
            RowBox[{"_", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"_", "?", "MatrixQ"}], ",", 
                RowBox[{"_", "?", "VectorQ"}], ",", 
                RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "___"}], "]"}]}],
            "]"}], ",", 
          RowBox[{"NDiagonalize", "[", "evbackg", "]"}], ",", "evbackg"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"evbackgstd", "=", 
        RowBox[{"StandardizeGenerator", "[", "evbackg", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"NPropagate", "[", 
        RowBox[{"\[Rho]", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "morestatus"}], "}"}], ",", 
         "cont", ",", "events", ",", " ", "opbasis", ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackgstd", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", 
                RowBox[{"_Hold", "|", "NullGeneratorPattern"}], "]"}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"HeldGeneratorSymbol", "[", "evbackgstd", "]"}], ",", 
               "\[IndentingNewLine]", "\t", "_", ",", "evbackgstd"}], 
              "\[IndentingNewLine]", "]"}]}], ",", 
            RowBox[{"Parallel", "\[Rule]", " ", "False"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532438192185872*^9, 3.5324382545397863`*^9}, 
   3.532438313835868*^9, {3.53243836363794*^9, 3.532438409477851*^9}, 
   3.5324387823958063`*^9, {3.532438880178722*^9, 3.532438905904896*^9}, {
   3.53245092012462*^9, 3.532450926913773*^9}, 3.532450974693555*^9, {
   3.534310358636334*^9, 3.534310377276428*^9}, {3.5415318154112253`*^9, 
   3.5415318229703093`*^9}, {3.5429556978232927`*^9, 3.54295570744648*^9}, {
   3.5429558819873734`*^9, 3.5429558971675463`*^9}, {3.543245145020617*^9, 
   3.5432453060311317`*^9}, {3.543245346853058*^9, 3.5432453525063343`*^9}, {
   3.543245479879105*^9, 3.543245520589139*^9}, 3.543246579112441*^9, {
   3.5432534136180353`*^9, 3.543253437074998*^9}, {3.543410809935897*^9, 
   3.543410821876163*^9}, 3.543413455222966*^9, {3.543688097626602*^9, 
   3.543688213677889*^9}, {3.543688244548811*^9, 3.5436882461085052`*^9}, 
   3.543688279487761*^9, {3.5436883690107183`*^9, 3.5436883713530617`*^9}, {
   3.587550653940123*^9, 3.587550753557995*^9}, 3.621348805395721*^9, {
   3.621349557910268*^9, 3.6213495591884527`*^9}, 3.6215735466916323`*^9, {
   3.666610461408619*^9, 3.666610470998974*^9}, {3.666611655832932*^9, 
   3.666611656195207*^9}, {3.6666118305700426`*^9, 3.6666118834112663`*^9}, {
   3.666611978240513*^9, 3.666611978710616*^9}, {3.666612010000487*^9, 
   3.6666120341297517`*^9}, {3.666612294967608*^9, 3.6666123051444035`*^9}, {
   3.6666138238609586`*^9, 3.6666138779917064`*^9}, {3.6666139233812385`*^9, 
   3.6666139237815084`*^9}, {3.6666896749038057`*^9, 3.66668967550323*^9}, {
   3.666693281747729*^9, 3.666693283856164*^9}, {3.666885921177236*^9, 
   3.6668859469104295`*^9}, {3.6668859853376894`*^9, 
   3.6668859903166633`*^9}, {3.690970230302383*^9, 3.690970235113655*^9}, {
   3.691391246795205*^9, 3.6913912541212473`*^9}, {3.691398256877244*^9, 
   3.691398330210616*^9}, 3.691399757405748*^9, 3.691399918318404*^9, {
   3.691400367152504*^9, 3.6914004798234*^9}, {3.691400515447125*^9, 
   3.6914006507508717`*^9}, 3.691400835355508*^9, {3.691401205441142*^9, 
   3.6914012101536007`*^9}, {3.692847595235621*^9, 3.692847795035656*^9}, {
   3.6931386122823567`*^9, 3.6931386195616693`*^9}, {3.6931434063287554`*^9, 
   3.6931434185296326`*^9}, {3.6932182004693165`*^9, 
   3.6932182220179873`*^9}, {3.6932182544729815`*^9, 3.693218266290186*^9}, {
   3.693218635291336*^9, 3.693218654356661*^9}, {3.693218942333746*^9, 
   3.693218946201056*^9}, {3.693246433086727*^9, 3.693246433275249*^9}, {
   3.697221685888938*^9, 3.697221687079325*^9}, {3.699279171932808*^9, 
   3.699279173314439*^9}, {3.7092305477085247`*^9, 3.709230550885765*^9}, {
   3.7092305920166335`*^9, 3.7092305923868675`*^9}, {3.7092307270095*^9, 
   3.7092307309903183`*^9}, {3.7092307932594137`*^9, 
   3.7092307972192264`*^9}, {3.7092308415391564`*^9, 3.709230841728317*^9}, {
   3.7092314176406484`*^9, 3.7092314244815197`*^9}, {3.709231822940691*^9, 
   3.7092318230998335`*^9}, {3.7092320566946087`*^9, 
   3.7092320588971863`*^9}, {3.7092323226504917`*^9, 3.709232322821614*^9}, 
   3.709374072389906*^9, {3.7093745042489033`*^9, 3.709374504252166*^9}, {
   3.709375004964574*^9, 3.709375004967614*^9}, {3.7260005089432545`*^9, 
   3.7260005304085445`*^9}, {3.7260006125155835`*^9, 3.726000625100251*^9}, {
   3.726000667637682*^9, 3.7260007034161777`*^9}, {3.726000741989118*^9, 
   3.7260007489585047`*^9}, {3.726000781485282*^9, 3.7260008093456926`*^9}, {
   3.7260008583271437`*^9, 3.7260008735976133`*^9}, {3.7260009157066383`*^9, 
   3.72600092197361*^9}, {3.726000986674895*^9, 3.726001010762832*^9}, {
   3.7260010451561985`*^9, 3.7260010467346563`*^9}, {3.7260010848122053`*^9, 
   3.726001085624716*^9}, {3.7260011976569552`*^9, 3.7260012052174406`*^9}, 
   3.7260012890133085`*^9, {3.7260013413623843`*^9, 3.72600138114463*^9}, {
   3.7260014754173236`*^9, 3.726001484685815*^9}, {3.7260015154938526`*^9, 
   3.726001526639063*^9}, {3.7260015635047903`*^9, 3.7260016012023587`*^9}, 
   3.7260016371091747`*^9, {3.726001680939842*^9, 3.7260018219545584`*^9}, {
   3.726001861299657*^9, 3.726001890760929*^9}, {3.7260019284256215`*^9, 
   3.7260019585499644`*^9}, {3.7260019960570574`*^9, 
   3.7260020407755384`*^9}, {3.7260020954365697`*^9, 
   3.7260021053887224`*^9}, {3.726002161113927*^9, 3.7260021808208237`*^9}, {
   3.726002272872569*^9, 3.726002450438057*^9}, {3.726002522726588*^9, 
   3.726002609056625*^9}, {3.726002671165163*^9, 3.726002700522812*^9}, {
   3.726002752546426*^9, 3.726002793130031*^9}, {3.726003056956149*^9, 
   3.726003075882818*^9}, {3.7260034199931445`*^9, 3.7260034201338644`*^9}, {
   3.7260065846721926`*^9, 3.7260065894225655`*^9}, {3.7260067107799654`*^9, 
   3.726006744487873*^9}, {3.726006805277993*^9, 3.726006821142231*^9}, {
   3.72600687708593*^9, 3.7260069217666016`*^9}, {3.726006981376877*^9, 
   3.726006984065795*^9}, {3.7260070383072653`*^9, 3.726007038484415*^9}, {
   3.7260070710945168`*^9, 3.7260071377945385`*^9}, 3.7260071684652653`*^9, {
   3.726007217302908*^9, 3.7260072275542088`*^9}, {3.7260073741531663`*^9, 
   3.726007392561223*^9}, {3.7260074253204613`*^9, 3.72600747812892*^9}, {
   3.7260075433492117`*^9, 3.7260075681748204`*^9}, {3.72600759898965*^9, 
   3.72600759952503*^9}, {3.7260080266140275`*^9, 3.7260081133062477`*^9}, {
   3.7260081443123217`*^9, 3.7260081607960353`*^9}, {3.7260082008551135`*^9, 
   3.72600820325284*^9}, {3.7260082415932374`*^9, 3.726008244342181*^9}, {
   3.7260558842335215`*^9, 3.7260558886791897`*^9}, {3.7260560533120975`*^9, 
   3.7260560594014297`*^9}, {3.7260561054914837`*^9, 
   3.7260561116154733`*^9}, {3.7260561507706394`*^9, 
   3.7260562195887938`*^9}, {3.726056265787572*^9, 3.7260562663721647`*^9}, {
   3.726056302193242*^9, 3.726056308082815*^9}, {3.726056351162122*^9, 
   3.7260563903690705`*^9}, {3.726056441600032*^9, 3.7260564861715236`*^9}, {
   3.726056535487567*^9, 3.7260565861162004`*^9}, {3.7260568759275627`*^9, 
   3.726056886522981*^9}, {3.7260569327375765`*^9, 3.7260569347323384`*^9}, {
   3.726057008163947*^9, 3.7260570218006525`*^9}, {3.726057069104508*^9, 
   3.7260570762418184`*^9}},ExpressionUUID->"fd219492-03e7-4a0f-b39f-\
f68a3a620269"]
}, Closed]],

Cell[CellGroupData[{

Cell["events", "Subsection",
 CellChangeTimes->{{3.6909706502058496`*^9, 3.690970654973537*^9}, {
  3.692847920047133*^9, 
  3.692847920924678*^9}},ExpressionUUID->"f31e3de4-d5b2-4126-a947-\
9aa021e8ccf3"],

Cell[CellGroupData[{

Cell["PulseSequence elements", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 
  3.692847937764781*^9}},ExpressionUUID->"056ca3bf-ff2c-49ea-a76f-\
c12424e5c147"],

Cell["take options into PulseSequence", "Text",
 CellChangeTimes->{{3.6928479733079147`*^9, 
  3.692847979394462*^9}},ExpressionUUID->"f305da1a-27a4-4e98-aa44-\
33bfb694c21c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
        "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_PulseSequence", "]"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"PulseSequenceQ", "[", "events", "]"}]}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "status", ",", "cont", ",", 
     RowBox[{"PulseSequence", "[", 
      RowBox[{"events", ",", "opts"}], "]"}], ",", "more", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6928420888951273`*^9, 3.692842152566959*^9}, {
  3.6931386358761196`*^9, 3.693138637378024*^9}, {3.6932187080353775`*^9, 
  3.693218727114354*^9}, {3.703927792671649*^9, 3.7039278101553345`*^9}, {
  3.7039279104923716`*^9, 3.7039279120284376`*^9}, {3.709231284273389*^9, 
  3.7092312920429077`*^9}, {3.7092328676518445`*^9, 3.7092328738312035`*^9}, {
  3.726000542273193*^9, 
  3.7260005770326824`*^9}},ExpressionUUID->"2a631f5d-f877-48b3-b87e-\
d5c5179375d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if not a ready EventList, apply EventList again, including the default \
arguments\
\>", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 3.69284796656359*^9}, {
  3.7093725269406424`*^9, 3.709372552847652*^9}, {3.7093726541022243`*^9, 
  3.709372726573536*^9}},ExpressionUUID->"9b18e6e3-5a30-43fc-873b-\
53f4b79175af"],

Cell["\<\
This will include defaults for the time points which are needed to set up \
EventList correctly\
\>", "Text",
 CellChangeTimes->{{3.709372731242961*^9, 
  3.709372755509067*^9}},ExpressionUUID->"5c9c9ff7-7684-4fe5-84f2-\
a83412b670d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
       "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"EventList", "[", 
        RowBox[{
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "_"}], "}"}]}], ",", "___"}], "]"}], "]"}]}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "False", ",", "morestatus"}], "}"}], 
     ",", "cont", ",", "\[IndentingNewLine]", 
     RowBox[{"EventList", "[", 
      RowBox[{"events", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Chronology", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Chronology", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "NPropagate", "]"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ImplementBackgroundGenerator", "\[Rule]", "True"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ExpandRepeatedEvents", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{"cont", ",", "True", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ExpandRepeatedEvents", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "NPropagate", "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"Options", "[", "EventList", "]"}], ",", 
              RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "more", ",", 
     "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.459403611419217*^9, 3.4594036438443937`*^9}, {
   3.459403725781039*^9, 3.4594037309083157`*^9}, {3.459408711958606*^9, 
   3.459408714467761*^9}, 3.464328075904245*^9, {3.464695379520875*^9, 
   3.4646954137997932`*^9}, {3.465814860620288*^9, 3.465814888174513*^9}, {
   3.503027085072076*^9, 3.5030270997206917`*^9}, {3.503032349105281*^9, 
   3.503032395582123*^9}, 3.503127150743004*^9, {3.508090439583303*^9, 
   3.508090480358121*^9}, {3.5144545315614767`*^9, 3.514454565048649*^9}, {
   3.514454646972604*^9, 3.514454651506188*^9}, {3.514457068494399*^9, 
   3.5144570685635567`*^9}, 3.514809519181155*^9, {3.51482124543471*^9, 
   3.514821246122735*^9}, 3.514868524715065*^9, 3.514868851948365*^9, {
   3.51499222248971*^9, 3.514992268629366*^9}, {3.5166039514155493`*^9, 
   3.516603959381312*^9}, {3.534310528631629*^9, 3.5343105347156677`*^9}, {
   3.534313503516695*^9, 3.534313504737646*^9}, {3.534398740916671*^9, 
   3.5343987424438763`*^9}, {3.666608230514469*^9, 3.6666082721519346`*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610523629199*^9, 3.6666105417587404`*^9}, {3.6666106725464892`*^9, 
   3.666610675199015*^9}, {3.6666107148817043`*^9, 3.666610746276681*^9}, 
   3.6666108584956484`*^9, {3.6666111925323596`*^9, 3.666611210048849*^9}, {
   3.6666114768762207`*^9, 3.666611489595416*^9}, 3.666611550828224*^9, {
   3.666611593307498*^9, 3.66661160099645*^9}, {3.6666120971877337`*^9, 
   3.666612102246954*^9}, {3.6666122010387964`*^9, 3.6666122437883954`*^9}, {
   3.6666123632294493`*^9, 3.6666123793642483`*^9}, {3.666612440702112*^9, 
   3.6666124426883163`*^9}, {3.6666124731744547`*^9, 3.666612473612363*^9}, {
   3.6666125333332634`*^9, 3.666612536223451*^9}, {3.666612709052069*^9, 
   3.6666127193908396`*^9}, {3.666612777710683*^9, 3.666612832219817*^9}, {
   3.6666131867833357`*^9, 3.666613193435583*^9}, {3.666613270475043*^9, 
   3.666613272794323*^9}, {3.6666133044160204`*^9, 3.6666133612706065`*^9}, {
   3.666613455162436*^9, 3.6666134605722203`*^9}, {3.6666134978714647`*^9, 
   3.6666135321811514`*^9}, {3.666613934341844*^9, 3.6666139581006413`*^9}, {
   3.6666140578060856`*^9, 3.6666140665488667`*^9}, {3.66661414327384*^9, 
   3.6666141777386513`*^9}, 3.666616803057581*^9, {3.6666923663684254`*^9, 
   3.666692367698021*^9}, {3.6666932935574894`*^9, 3.666693295693761*^9}, {
   3.666885907975423*^9, 3.6668859087386875`*^9}, {3.6909705937939262`*^9, 
   3.6909706003113003`*^9}, 3.690991239770699*^9, {3.690991353090613*^9, 
   3.690991356255272*^9}, 3.6909914094528303`*^9, {3.6910569028349113`*^9, 
   3.691056905865327*^9}, {3.691061927890615*^9, 3.691061967047638*^9}, {
   3.6910622639040728`*^9, 3.6910622647984858`*^9}, 3.691062443418497*^9, {
   3.691390855426762*^9, 3.691390862991173*^9}, {3.691391279696642*^9, 
   3.691391288737391*^9}, {3.691392534425685*^9, 3.691392536260234*^9}, 
   3.69139259633524*^9, {3.6913926640237103`*^9, 3.6913926863196707`*^9}, 
   3.691398377149314*^9, {3.69139852474798*^9, 3.6913985462121067`*^9}, {
   3.691399250852113*^9, 3.6913992545687447`*^9}, {3.69139933578225*^9, 
   3.69139939440676*^9}, 3.691399775915741*^9, 3.691400863467993*^9, {
   3.6914012174093437`*^9, 3.691401221432158*^9}, {3.691434081729492*^9, 
   3.691434082401731*^9}, {3.6931386435569887`*^9, 3.693138655225885*^9}, {
   3.6931434693798428`*^9, 3.693143481649212*^9}, {3.6932187399437375`*^9, 
   3.6932187582535143`*^9}, {3.6932189727307453`*^9, 3.693218979950859*^9}, {
   3.6932464506858306`*^9, 3.6932464532543383`*^9}, {3.6993017786309633`*^9, 
   3.699301790511565*^9}, {3.6993018501582947`*^9, 3.699301873319332*^9}, {
   3.699301904473237*^9, 3.6993019075793066`*^9}, {3.7039275101251497`*^9, 
   3.7039275182952485`*^9}, {3.703927554987914*^9, 3.703927580988537*^9}, {
   3.703927634493862*^9, 3.703927636431205*^9}, {3.703927677672524*^9, 
   3.7039276783556232`*^9}, {3.7039279025923944`*^9, 3.703927905970233*^9}, {
   3.709230621026206*^9, 3.709230633036743*^9}, {3.7092306689542418`*^9, 
   3.709230674293062*^9}, {3.7092308447274494`*^9, 3.709230855987421*^9}, {
   3.7092310404007215`*^9, 3.709231040835035*^9}, {3.7092311355685186`*^9, 
   3.7092311369344606`*^9}, 3.7092312190881*^9, {3.7092318275609827`*^9, 
   3.709231832348372*^9}, {3.70937268082038*^9, 3.709372687009734*^9}, 
   3.709375004973831*^9, {3.726000583503009*^9, 3.726000591113908*^9}, {
   3.7260006773896*^9, 3.726000679811921*^9}, {3.7260026368301954`*^9, 
   3.726002643783083*^9}, {3.7260027427236958`*^9, 
   3.726002744692812*^9}},ExpressionUUID->"9f1c71a1-c1fd-427d-b54c-\
a329efa7bede"]
}, Closed]],

Cell[CellGroupData[{

Cell["set status flag when EventList is ready", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 3.69284796656359*^9}, {
  3.7093725269406424`*^9, 
  3.7093725719354877`*^9}},ExpressionUUID->"9f7536f1-c11e-4b2a-beb4-\
969a56eb4694"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
       "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "morestatus"}], "}"}], 
     ",", "cont", ",", "eventlist", ",", "more", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691433960623218*^9, 3.691434043219462*^9}, 
   3.691434462983884*^9, {3.6931386633858905`*^9, 3.6931386649671974`*^9}, {
   3.693218764172455*^9, 
   3.6932187861026716`*^9}},ExpressionUUID->"2ab1323d-db38-4997-aa8b-\
fecad18f3fe6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Check Hilbert Space Compatibility", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021943915395*^9, 3.5030219527295847`*^9}, {3.5343107110699883`*^9, 
   3.534310721386609*^9}, {3.534311142574582*^9, 3.534311148387733*^9}, 
   3.691398613270062*^9, {3.691399197382773*^9, 3.691399198241972*^9}, {
   3.693139441253035*^9, 3.6931394625026717`*^9}, {3.693219004251093*^9, 
   3.6932190112708397`*^9}, {3.6932236744413195`*^9, 3.693223679741178*^9}, {
   3.693246487334468*^9, 
   3.6932464927600718`*^9}},ExpressionUUID->"79cd438a-ba28-4869-8781-\
8a7142eb48df"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "False", ",", "morestatus___"}],
        "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "\[IndentingNewLine]", 
     "eventlist_EventList", ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", 
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "morestatus"}], 
      "}"}], ",", "cont", ",", 
     RowBox[{"HilbertSpaceCompatibility", "[", "eventlist", "]"}], ",", 
     "\[IndentingNewLine]", "eventlist", ",", "opbasis", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5343107726442204`*^9, 3.534310858333661*^9}, 
   3.534398755298703*^9, {3.547010792472026*^9, 3.547010798433242*^9}, {
   3.6666083382466908`*^9, 3.666608345685981*^9}, 3.6666112844174905`*^9, {
   3.690970704100424*^9, 3.690970705217493*^9}, {3.69105871483134*^9, 
   3.6910587482283907`*^9}, {3.691391298488624*^9, 3.6913913084717407`*^9}, {
   3.691398564618116*^9, 3.691398598461609*^9}, 3.691399267796332*^9, 
   3.691401227878825*^9, {3.693138675476312*^9, 3.6931386778261657`*^9}, {
   3.6931435806164284`*^9, 3.6931435903674*^9}, {3.693218806465129*^9, 
   3.693218810313361*^9}, {3.6932255502764683`*^9, 3.6932255540834885`*^9}, {
   3.693225796800521*^9, 3.693225822719429*^9}, {3.693225891446307*^9, 
   3.693225892405689*^9}, {3.6932262702079563`*^9, 3.693226293701394*^9}, {
   3.6932277863501425`*^9, 3.693227790442277*^9}, {3.6932278562415743`*^9, 
   3.6932278593903155`*^9}, {3.693227911760259*^9, 3.693227911930402*^9}, 
   3.693227968141594*^9, {3.693246468243907*^9, 3.693246472973357*^9}, {
   3.693380345588259*^9, 3.693380358199763*^9}, {3.693380389602949*^9, 
   3.6933803925870023`*^9}, {3.6966030621304655`*^9, 
   3.6966030666795197`*^9}, {3.696603604974193*^9, 3.6966036178002467`*^9}, {
   3.696621012228425*^9, 3.696621016154338*^9}, {3.696621560150669*^9, 
   3.696621562121773*^9}, {3.696881640577177*^9, 3.696881642222329*^9}, {
   3.697221715907516*^9, 3.6972217196152954`*^9}, {3.726000470089994*^9, 
   3.726000502250461*^9}},ExpressionUUID->"18667810-77fd-4119-aa5b-\
406fa85709de"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["checks and flags (2)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 3.691497398413538*^9}, {
  3.691657597551735*^9, 3.691657603767311*^9}, {3.691657691899529*^9, 
  3.691657693890112*^9}},ExpressionUUID->"75587671-d635-4064-9b00-\
7610a5222cfc"],

Cell[CellGroupData[{

Cell["second $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 
  3.691497398413538*^9}},ExpressionUUID->"c2ab4c9c-1ccc-4f39-8d98-\
4fb7b5efbae6"],

Cell["continuously check until all other checks are complete", "Text",
 CellChangeTimes->{{3.6914010562716417`*^9, 3.69140107024336*^9}, {
  3.691401438463211*^9, 
  3.69140145401991*^9}},ExpressionUUID->"ff7f57af-e3e1-4f35-a384-\
963fe0f70049"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "_", ",", "False", ",", 
         "morecheckflags__"}], "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.6913980379475822`*^9}, {3.691400270965768*^9, 
   3.691400273000134*^9}, {3.691401246783072*^9, 3.691401261628582*^9}, {
   3.691401417817514*^9, 3.691401422629837*^9}, 3.69313874338719*^9, {
   3.6932190381431646`*^9, 3.693219039341155*^9}, {3.6932190741310797`*^9, 
   3.6932190743412695`*^9}},ExpressionUUID->"c076bf29-3db5-4b76-b277-\
e5f416320724"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
         "morecheckflags__"}], "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", 
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
       "morecheckflags"}], "}"}], ",", "args"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.69139807543729*^9}, {3.6914002796355658`*^9, 
   3.691400279931965*^9}, {3.691401268582445*^9, 3.691401282439878*^9}, {
   3.693138744577215*^9, 3.693138747541669*^9}, {3.6932190440132093`*^9, 
   3.6932190796812553`*^9}, {3.6932263912781534`*^9, 
   3.6932264171349516`*^9}, {3.6932278974405203`*^9, 
   3.6932278998594103`*^9}, {3.6966030837539296`*^9, 
   3.6966030911104484`*^9}},ExpressionUUID->"cc12261e-c94b-4d5d-9d5d-\
263519b68f98"]
}, Closed]],

Cell[CellGroupData[{

Cell["numerical readiness", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, {3.5394494601995707`*^9, 
   3.5394494644933357`*^9}, {3.542280127397629*^9, 3.54228013347538*^9}, {
   3.690970751308037*^9, 3.6909707810962467`*^9}, {3.690972007962603*^9, 
   3.690972024212504*^9}, {3.690984027065432*^9, 3.690984032191633*^9}, {
   3.6913923990506144`*^9, 3.691392406888403*^9}, {3.691392787395994*^9, 
   3.691392787833499*^9}, {3.691398995211268*^9, 3.6913989968344173`*^9}, {
   3.691657722452734*^9, 
   3.6916577265050573`*^9}},ExpressionUUID->"bcd357f9-8361-41e5-a490-\
daaf17e9e6d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
        "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "Hstat_", ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}]}], "]"}], ",", "___"}], "]"}]}], ",",
      "more___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "suspsymbols", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagate", "::", "argnotready"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ReportSuspectSymbols", "[", 
        RowBox[{"{", 
         RowBox[{"eventlist", ",", "more"}], "}"}], "]"}], ";", 
       "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970789202134*^9, 3.69097091718412*^9}, {
   3.690972053068953*^9, 3.690972055162653*^9}, {3.690972123020767*^9, 
   3.690972168897552*^9}, {3.690972307524001*^9, 3.69097248383584*^9}, {
   3.690972885909957*^9, 3.690972900088601*^9}, {3.6913913136476803`*^9, 
   3.69139131586931*^9}, {3.691392464889511*^9, 3.691392478241403*^9}, {
   3.691398668621318*^9, 3.691398668953146*^9}, {3.691399027639586*^9, 
   3.691399033058919*^9}, 3.691399294307775*^9, {3.6931387575499496`*^9, 
   3.6931387620096197`*^9}, {3.693219096890652*^9, 3.6932191053705297`*^9}, {
   3.6932264611813793`*^9, 3.693226463344865*^9}, {3.693226499053999*^9, 
   3.6932265052784524`*^9}, 3.6932277529677277`*^9, {3.6966030986103835`*^9, 
   3.6966030991368065`*^9}, {3.696603132216728*^9, 3.6966031330709987`*^9}, {
   3.6968816632360754`*^9, 3.696881671023815*^9}, {3.744105897165174*^9, 
   3.7441059174932337`*^9}, {3.744106381068411*^9, 3.744106391879908*^9}, 
   3.744106423573621*^9, {3.7441068603403597`*^9, 3.7441068687658567`*^9}, {
   3.7441071481008244`*^9, 3.744107148694725*^9}, {3.744199813258683*^9, 
   3.74419981770851*^9}},ExpressionUUID->"26207624-79c0-4322-8f34-\
1dd06aedece7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", 
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
        "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "Hstat_", ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", 
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", "True",
        ",", "morestatus"}], "}"}], ",", "cont", ",", "Hstat", ",", 
     "eventlist", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690971008414692*^9, 3.69097105616591*^9}, {
   3.690971441454911*^9, 3.690971451563552*^9}, 3.690984599299467*^9, 
   3.690991134304167*^9, {3.691056935670138*^9, 3.6910569360141907`*^9}, {
   3.6913913573417473`*^9, 3.691391361657955*^9}, {3.691398734108169*^9, 
   3.691398746800288*^9}, {3.691399060789405*^9, 3.6913990802973003`*^9}, {
   3.6913993038376427`*^9, 3.6913993181942053`*^9}, {3.693138765379632*^9, 
   3.6931387667309465`*^9}, {3.6931437170186887`*^9, 
   3.6931437288850346`*^9}, {3.6932191119702616`*^9, 3.6932191230426226`*^9}, 
   3.6932192014812975`*^9, {3.693226471971272*^9, 3.693226472470581*^9}, 
   3.6932280083757095`*^9, {3.6932280437099676`*^9, 3.6932280441888065`*^9}, {
   3.693228268118327*^9, 3.693228278308496*^9}, {3.693246516860475*^9, 
   3.693246519001771*^9}, {3.696603108088608*^9, 3.6966031298083286`*^9}, {
   3.696603668693535*^9, 3.6966037133672724`*^9}, {3.6968816756763024`*^9, 
   3.6968816913336325`*^9}},ExpressionUUID->"b7f3ecd7-3d4f-4303-be63-\
6fcabfec4004"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Continuous \[Rule] False", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"7fb48f6c-36ce-4204-a2c2-e27b6567a8c2"],

Cell[CellGroupData[{

Cell["\<\
full HilbertSpaceCompatibility, generate PropagationOperator and apply\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, 3.6933104109539137`*^9, {3.693388151990442*^9, 
   3.693388161329486*^9}},ExpressionUUID->"f5f1d4a6-7716-4d1a-8abe-\
756b70d842ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "True", ",", 
      RowBox[{"EventList", "[", 
       RowBox[{"st_", ",", "chars_", ",", 
        RowBox[{"events", ":", 
         RowBox[{"{", 
          RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
       "]"}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"zbmatreps", ",", "\[Rho]matrep", ",", "Ufw", ",", "Ubw"}], 
       "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Rho]matrep", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"\[Rho]", ",", "basis"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"zbmatreps", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"NPropagate", "[", 
              RowBox[{
              "True", ",", "False", ",", "True", ",", "#", ",", "opbasis", 
               ",", "basis", ",", "opts"}], "]"}], ",", "basis"}], "]"}], 
           "&"}], "/@", "events"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Ufw", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "zbmatreps", "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"First", "@", "zbmatreps"}], ",", 
           RowBox[{"Fold", "[", 
            RowBox[{"Dot", ",", 
             RowBox[{"First", "@", "zbmatreps"}], ",", 
             RowBox[{"Drop", "[", 
              RowBox[{"zbmatreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"Ubw", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"UnitaryMatrixQ", "[", "Ufw", "]"}], "\[Equal]", "True"}],
            ",", 
           RowBox[{"ConjugateTranspose", "@", "Ufw"}], ",", 
           RowBox[{"SparseArray", "@", 
            RowBox[{"Inverse", "@", "Ufw"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"Chop", "@", 
           RowBox[{"Dot", "[", 
            RowBox[{"Ufw", ",", "\[Rho]matrep", ",", "Ubw"}], "]"}]}], ",", 
          "basis", ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.534311007807122*^9, {3.534311071430175*^9, 3.534311103043881*^9}, {
   3.534311161325684*^9, 3.534311162592239*^9}, 3.5343112035758257`*^9, 
   3.5343181098498573`*^9, {3.5343188669035254`*^9, 3.534318867680813*^9}, 
   3.534398763917116*^9, {3.539449684776085*^9, 3.539449707703122*^9}, 
   3.539449776135705*^9, {3.542266586702509*^9, 3.542266587087212*^9}, 
   3.542282400817648*^9, 3.542282816552648*^9, 3.5422830970682573`*^9, 
   3.542283430931848*^9, {3.626027588356846*^9, 3.6260276198866873`*^9}, {
   3.642514521629387*^9, 3.642514572366727*^9}, {3.6425146195639467`*^9, 
   3.64251462038365*^9}, {3.642515539979156*^9, 3.642515554774953*^9}, {
   3.6666083784669704`*^9, 3.666608387648285*^9}, 3.6666112917429123`*^9, {
   3.6666313866011186`*^9, 3.666631391711933*^9}, {3.6666315192473907`*^9, 
   3.6666315685180807`*^9}, {3.6666932577165184`*^9, 3.666693258016091*^9}, {
   3.666789522111123*^9, 3.666789526380568*^9}, {3.6667896066878667`*^9, 
   3.666789622969426*^9}, {3.666789784816805*^9, 3.666789816266426*^9}, {
   3.666793582521138*^9, 3.666793582596608*^9}, {3.690971730169973*^9, 
   3.690971732322891*^9}, {3.690984086403597*^9, 3.6909841073924303`*^9}, 
   3.69098455989948*^9, {3.690986491425609*^9, 3.6909864988935633`*^9}, {
   3.690986614222039*^9, 3.6909866507617903`*^9}, 3.690986749472444*^9, {
   3.691057297029677*^9, 3.691057305434599*^9}, {3.691057356891182*^9, 
   3.691057394042478*^9}, {3.6910574321858263`*^9, 3.691057473541171*^9}, {
   3.69105751083149*^9, 3.69105753339581*^9}, {3.691391374901676*^9, 
   3.691391410268654*^9}, {3.691402366524681*^9, 3.691402413850623*^9}, {
   3.691407240616992*^9, 3.691407242097354*^9}, {3.693138777747897*^9, 
   3.693138786487462*^9}, {3.6931437635341215`*^9, 3.693143803055565*^9}, {
   3.693144380150019*^9, 3.693144381808704*^9}, {3.6932194898944845`*^9, 
   3.693219491044304*^9}, {3.693219533726365*^9, 3.6932195383237867`*^9}, {
   3.6932195686150684`*^9, 3.693219569337386*^9}, {3.6932197221603003`*^9, 
   3.6932197223404293`*^9}, {3.693220084965603*^9, 3.6932200867152295`*^9}, {
   3.6932202138975754`*^9, 3.6932202213929577`*^9}, 3.693220252393058*^9, {
   3.693220288012597*^9, 3.693220321623582*^9}, {3.693220422303293*^9, 
   3.6932204330736623`*^9}, {3.6932204647130504`*^9, 3.693220490968276*^9}, {
   3.6932205342522154`*^9, 3.693220564040348*^9}, {3.6932205991422453`*^9, 
   3.693220600042329*^9}, {3.6932207370302687`*^9, 3.6932207414287167`*^9}, {
   3.693221511992772*^9, 3.6932216307848854`*^9}, {3.6932216840213156`*^9, 
   3.6932216980483437`*^9}, {3.693221743532666*^9, 3.693221791952119*^9}, 
   3.693221822163003*^9, {3.693221855761532*^9, 3.6932219185501237`*^9}, {
   3.6932219571877165`*^9, 3.6932220261982183`*^9}, {3.6932230685557847`*^9, 
   3.6932230694719915`*^9}, {3.693223115521494*^9, 3.6932231475560293`*^9}, {
   3.6932232076245174`*^9, 3.6932232154938283`*^9}, {3.693223248690349*^9, 
   3.693223266451729*^9}, {3.6932233680680323`*^9, 3.6932233737076793`*^9}, {
   3.6932234311989098`*^9, 3.6932234598890095`*^9}, {3.693223697190358*^9, 
   3.6932237050499043`*^9}, {3.693223938321887*^9, 3.6932239495005245`*^9}, {
   3.6932323881800632`*^9, 3.693232543279377*^9}, {3.6932432869164248`*^9, 
   3.6932432905251656`*^9}, {3.6932466590003424`*^9, 3.693246659500764*^9}, {
   3.693246830655216*^9, 3.693246834224542*^9}, 3.693246978418086*^9, {
   3.693249426813252*^9, 3.6932494500341873`*^9}, 3.693309943209716*^9, {
   3.6933100449324455`*^9, 3.6933100504288044`*^9}, {3.6933101140016747`*^9, 
   3.693310127447793*^9}, {3.6933101787857723`*^9, 3.6933101939648066`*^9}, {
   3.693310241086396*^9, 3.693310242916855*^9}, {3.693310327812502*^9, 
   3.6933103947140355`*^9}, 3.6933369329811296`*^9, {3.6933370044370728`*^9, 
   3.6933370067569942`*^9}, {3.69333716521671*^9, 3.6933371696854615`*^9}, {
   3.693337219567198*^9, 3.693337252103665*^9}, 3.693337300026037*^9, {
   3.6933373849365015`*^9, 3.6933375445880966`*^9}, {3.6933377971402073`*^9, 
   3.69333779923055*^9}, {3.6933379495621257`*^9, 3.693337952480448*^9}, {
   3.693338169087184*^9, 3.6933381791272516`*^9}, {3.693338295293475*^9, 
   3.6933383150319376`*^9}, 3.6933387139067345`*^9, 3.6933387617434053`*^9, {
   3.6933388472583437`*^9, 3.6933388521405163`*^9}, {3.693338899242052*^9, 
   3.6933389031301684`*^9}, {3.6933389947585335`*^9, 3.693339049100334*^9}, {
   3.693339390840852*^9, 3.6933393924454064`*^9}, {3.6933399496705403`*^9, 
   3.693340003292617*^9}, {3.693340059267577*^9, 3.6933402258054314`*^9}, {
   3.6933402623307023`*^9, 3.6933404038813972`*^9}, {3.6933404461922197`*^9, 
   3.693340486690564*^9}, {3.693340517588385*^9, 3.693340521177644*^9}, {
   3.6933405544511337`*^9, 3.6933405998266573`*^9}, {3.693340632426347*^9, 
   3.693340646636235*^9}, {3.693340695275526*^9, 3.6933407659643817`*^9}, {
   3.693340889851172*^9, 3.6933409169685297`*^9}, {3.6933409804834957`*^9, 
   3.6933409824995723`*^9}, {3.6933410130212917`*^9, 
   3.6933410258022876`*^9}, {3.693341077457157*^9, 3.6933411015835886`*^9}, {
   3.6933411928312817`*^9, 3.6933412302273407`*^9}, {3.6933414004280167`*^9, 
   3.693341401082328*^9}, {3.693341476713584*^9, 3.693341481421189*^9}, {
   3.6933415148016496`*^9, 3.693341575804724*^9}, {3.6933416069331584`*^9, 
   3.6933416616282787`*^9}, {3.693341694049718*^9, 3.69334171546452*^9}, {
   3.6933417654169645`*^9, 3.69334177536936*^9}, {3.693380649068019*^9, 
   3.693380650507416*^9}, {3.6933807691033773`*^9, 3.693380772758052*^9}, {
   3.693381732685268*^9, 3.6933817329141254`*^9}, 3.693385099218036*^9, {
   3.693386440995353*^9, 3.6933864445356817`*^9}, {3.6933865521319933`*^9, 
   3.6933865591016965`*^9}, {3.693386836370534*^9, 3.693386839832724*^9}, {
   3.693387005116068*^9, 3.693387005386838*^9}, {3.693387187147277*^9, 
   3.6933871964560375`*^9}, 3.6933873523261395`*^9, {3.696603191401033*^9, 
   3.6966031953414927`*^9}, {3.6966060937687826`*^9, 3.696606103635041*^9}, {
   3.6966205749302225`*^9, 3.6966205750870647`*^9}, {3.696621035188586*^9, 
   3.6966210540411415`*^9}, {3.696621138507593*^9, 3.6966211455442944`*^9}, {
   3.696621454445451*^9, 3.6966214545762157`*^9}, {3.6968816832454877`*^9, 
   3.69688168423392*^9}, {3.6968820830532675`*^9, 3.6968820918217745`*^9}, {
   3.6968821246741533`*^9, 3.696882188009968*^9}, {3.6968833276113386`*^9, 
   3.696883330423558*^9}, {3.696883364262005*^9, 3.696883365162294*^9}, {
   3.696883542201275*^9, 3.696883542450181*^9}, {3.6968838826103735`*^9, 
   3.696883885553363*^9}, {3.6968841755793858`*^9, 3.6968841757603025`*^9}, {
   3.6969324406251893`*^9, 3.6969324422996445`*^9}, {3.6969325233670945`*^9, 
   3.6969325367617292`*^9}, {3.6969329630957155`*^9, 3.696932988127495*^9}, {
   3.697198495789516*^9, 3.697198497591795*^9}, {3.69719854214876*^9, 
   3.697198545766779*^9}, {3.69719866413474*^9, 3.697198664295519*^9}, {
   3.697200835959013*^9, 3.697200845605452*^9}, {3.6972008775092683`*^9, 
   3.697200882803462*^9}, {3.697201363213025*^9, 3.6972013681847343`*^9}, {
   3.6972015698598795`*^9, 3.6972015700161533`*^9}, {3.697201659478828*^9, 
   3.6972016596507215`*^9}, {3.697201781317859*^9, 3.6972017836483097`*^9}, {
   3.6972021284405727`*^9, 3.697202129846916*^9}, {3.697202250654421*^9, 
   3.697202281802515*^9}, {3.697202361384138*^9, 3.6972023615716715`*^9}, {
   3.697202400724818*^9, 3.697202461697452*^9}, {3.697202514403194*^9, 
   3.697202517575396*^9}, 3.6972025907984157`*^9, {3.6972026396389375`*^9, 
   3.6972026408109293`*^9}, {3.697221723871825*^9, 3.6972217492554493`*^9}, {
   3.6972240085776644`*^9, 3.6972240134980907`*^9}, {3.697224108261017*^9, 
   3.6972241084803696`*^9}, {3.697224563050012*^9, 3.6972245651935415`*^9}, {
   3.697224702841267*^9, 3.697224710381406*^9}, {3.697224743300565*^9, 
   3.697224743480036*^9}, {3.6973570110860767`*^9, 3.69735701311752*^9}, {
   3.699563419351965*^9, 3.6995634296125236`*^9}, {3.699563467351736*^9, 
   3.699563467723301*^9}, {3.6996201509976273`*^9, 3.699620192825482*^9}, 
   3.6996202522373343`*^9, {3.701631528757095*^9, 3.7016315530483427`*^9}, {
   3.701632321193411*^9, 3.701632322472348*^9}, {3.702796593400728*^9, 
   3.7027965987685575`*^9}, {3.702796687897191*^9, 3.702796699091112*^9}, {
   3.7038552554188814`*^9, 3.7038552572659035`*^9}, {3.7038553145841527`*^9, 
   3.703855315190899*^9}, {3.709231843867552*^9, 3.7092318463523464`*^9}, {
   3.709232019656294*^9, 3.709232051586994*^9}, {3.7092323165201387`*^9, 
   3.7092323182403603`*^9}, {3.7095504005052834`*^9, 3.709550447986131*^9}, {
   3.7095505417072067`*^9, 3.7095505454423347`*^9}, {3.7095506072265987`*^9, 
   3.70955061219479*^9}, {3.7095508636916704`*^9, 3.7095508638399353`*^9}, {
   3.713550140619502*^9, 3.713550263769644*^9}, {3.7135503483957415`*^9, 
   3.713550360176124*^9}, {3.7135504011371765`*^9, 3.713550401286909*^9}, {
   3.7135507328192263`*^9, 3.7135507391292934`*^9}, {3.7135507721398697`*^9, 
   3.7135508245287876`*^9}, {3.7135508600286922`*^9, 
   3.7135508601342897`*^9}, {3.713550891575722*^9, 
   3.713550892284582*^9}},ExpressionUUID->"e9bf9ff3-32fc-4942-8800-\
380d4d57cea2"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
mixed HilbertSpaceCompatibility, divide EventList and use sequential \
propagation\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, {3.6932283901866817`*^9, 3.693228410856851*^9}, {
   3.693228841865108*^9, 3.693228846954238*^9}, {3.693247335008274*^9, 
   3.6932473351668015`*^9}, {3.6932488727596197`*^9, 
   3.6932488898382635`*^9}},ExpressionUUID->"d7fbcb19-8c27-4e00-900a-\
506630443421"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", 
      RowBox[{"(", 
       RowBox[{"MixedHilbertSpaceCompatibility", "|", "False"}], ")"}], ",", 
      RowBox[{"ev", ":", 
       RowBox[{"EventList", "[", 
        RowBox[{"st_", ",", "chars_", ",", 
         RowBox[{"events", ":", 
          RowBox[{"{", 
           RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
        "]"}]}], ",", "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", 
      "opts___Rule"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]final", ",", "sortedevents", ",", "zbmatreps"}], "}"}], 
      ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sortedevents", "=", 
         RowBox[{"Reverse", "[", 
          RowBox[{"SortVectorSpaceCompatibility", "[", "ev", "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"\[Rho]final", "=", 
         RowBox[{"Fold", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"NPropagate", "[", 
             RowBox[{
             "#1", ",", "#2", ",", "opbasis", ",", "basis", ",", "opts"}], 
             "]"}], "&"}], ",", "\[Rho]", ",", "sortedevents"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", 
        RowBox[{"event", ":", "_Event"}]}], "}"}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Rho]mat", ",", "Ufw", ",", "Ubw"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Rho]mat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"\[Rho]", ",", "basis"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Ufw", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"NPropagate", "[", 
            RowBox[{
            "True", ",", "False", ",", "True", ",", "event", ",", "opbasis", 
             ",", "basis", ",", "opts"}], "]"}], ",", "basis"}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"Ubw", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"UnitaryMatrixQ", "[", "Ufw", "]"}], "\[Equal]", "True"}],
            ",", 
           RowBox[{"ConjugateTranspose", "@", "Ufw"}], ",", 
           RowBox[{"Inverse", "@", "Ufw"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"SparseArray", "@", 
           RowBox[{"Chop", "@", 
            RowBox[{"N", "@", 
             RowBox[{"Dot", "[", 
              RowBox[{"Ufw", ",", "\[Rho]mat", ",", "Ubw"}], "]"}]}]}]}], ",",
           "basis", ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NPropagate", "[", 
   RowBox[{"\[Rho]_", ",", 
    RowBox[{"{", 
     RowBox[{"False", ",", 
      RowBox[{"event", ":", "_Event"}]}], "}"}], ",", "opbasis_", ",", 
    "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"NPropagate", "[", 
   RowBox[{
   "\[Rho]", ",", "True", ",", "False", ",", "False", ",", "event", ",", 
    "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.534311007807122*^9, {3.534311071430175*^9, 3.534311103043881*^9}, {
   3.534311161325684*^9, 3.534311162592239*^9}, 3.5343112035758257`*^9, 
   3.5343181098498573`*^9, {3.5343188669035254`*^9, 3.534318867680813*^9}, 
   3.534398763917116*^9, {3.539449684776085*^9, 3.539449707703122*^9}, 
   3.539449776135705*^9, {3.542266586702509*^9, 3.542266587087212*^9}, 
   3.542282400817648*^9, 3.542282816552648*^9, 3.5422830970682573`*^9, 
   3.542283430931848*^9, {3.626027588356846*^9, 3.6260276198866873`*^9}, {
   3.642514521629387*^9, 3.642514572366727*^9}, {3.6425146195639467`*^9, 
   3.64251462038365*^9}, {3.642515539979156*^9, 3.642515554774953*^9}, {
   3.6666083784669704`*^9, 3.666608387648285*^9}, 3.6666112917429123`*^9, {
   3.6666313866011186`*^9, 3.666631391711933*^9}, {3.6666315192473907`*^9, 
   3.6666315685180807`*^9}, {3.6666932577165184`*^9, 3.666693258016091*^9}, {
   3.666789522111123*^9, 3.666789526380568*^9}, {3.6667896066878667`*^9, 
   3.666789622969426*^9}, {3.666789784816805*^9, 3.666789816266426*^9}, {
   3.666793582521138*^9, 3.666793582596608*^9}, {3.690971730169973*^9, 
   3.690971732322891*^9}, {3.690984086403597*^9, 3.6909841073924303`*^9}, 
   3.69098455989948*^9, {3.690986491425609*^9, 3.6909864988935633`*^9}, {
   3.690986614222039*^9, 3.6909866507617903`*^9}, 3.690986749472444*^9, {
   3.691057297029677*^9, 3.691057305434599*^9}, {3.691057356891182*^9, 
   3.691057394042478*^9}, {3.6910574321858263`*^9, 3.691057473541171*^9}, {
   3.69105751083149*^9, 3.69105753339581*^9}, {3.691391374901676*^9, 
   3.691391410268654*^9}, {3.691402366524681*^9, 3.691402413850623*^9}, {
   3.691407240616992*^9, 3.691407242097354*^9}, {3.693138777747897*^9, 
   3.693138786487462*^9}, {3.6931437635341215`*^9, 3.693143803055565*^9}, {
   3.693144380150019*^9, 3.693144381808704*^9}, {3.6932194898944845`*^9, 
   3.693219491044304*^9}, {3.693219533726365*^9, 3.6932195383237867`*^9}, {
   3.6932195686150684`*^9, 3.693219569337386*^9}, {3.6932197221603003`*^9, 
   3.6932197223404293`*^9}, {3.693220084965603*^9, 3.6932200867152295`*^9}, {
   3.6932202138975754`*^9, 3.6932202213929577`*^9}, 3.693220252393058*^9, {
   3.693220288012597*^9, 3.693220321623582*^9}, {3.693220422303293*^9, 
   3.6932204330736623`*^9}, {3.6932204647130504`*^9, 3.693220490968276*^9}, {
   3.6932205342522154`*^9, 3.693220564040348*^9}, {3.6932205991422453`*^9, 
   3.693220600042329*^9}, {3.6932207370302687`*^9, 3.6932207414287167`*^9}, {
   3.693221511992772*^9, 3.6932216307848854`*^9}, {3.6932216840213156`*^9, 
   3.6932216980483437`*^9}, {3.693221743532666*^9, 3.693221791952119*^9}, 
   3.693221822163003*^9, {3.693221855761532*^9, 3.6932219185501237`*^9}, {
   3.6932219571877165`*^9, 3.6932220261982183`*^9}, {3.6932230685557847`*^9, 
   3.6932230694719915`*^9}, {3.693223115521494*^9, 3.6932231475560293`*^9}, {
   3.6932232076245174`*^9, 3.6932232154938283`*^9}, {3.693223248690349*^9, 
   3.693223266451729*^9}, {3.6932233680680323`*^9, 3.6932233737076793`*^9}, {
   3.6932234311989098`*^9, 3.6932234598890095`*^9}, {3.693223697190358*^9, 
   3.6932237050499043`*^9}, {3.693223938321887*^9, 3.6932239495005245`*^9}, {
   3.6932284401685653`*^9, 3.6932284674578447`*^9}, {3.6932285480371017`*^9, 
   3.693228548329379*^9}, {3.693228899670059*^9, 3.6932289016780443`*^9}, {
   3.6932289397964964`*^9, 3.693229022045003*^9}, {3.6932290558666925`*^9, 
   3.693229101733514*^9}, {3.693229179673418*^9, 3.693229223571943*^9}, {
   3.693229471481344*^9, 3.693229501331216*^9}, 3.6932295414395847`*^9, 
   3.693229603519432*^9, {3.6932299045348787`*^9, 3.6932299683514214`*^9}, {
   3.6932300596568794`*^9, 3.6932302398001194`*^9}, {3.693230273745476*^9, 
   3.693230300412089*^9}, {3.6932303699112167`*^9, 3.6932303973759017`*^9}, {
   3.6932304352242384`*^9, 3.693230467935282*^9}, {3.693230546424656*^9, 
   3.6932305794234657`*^9}, {3.6932306152767177`*^9, 
   3.6932306485901146`*^9}, {3.6932307881115522`*^9, 
   3.6932308411998067`*^9}, {3.6932311285655184`*^9, 3.693231154632929*^9}, {
   3.69323120056271*^9, 3.693231201191868*^9}, {3.693231258555181*^9, 
   3.693231277065838*^9}, {3.6932313157733526`*^9, 3.6932313226027126`*^9}, {
   3.6932314077738223`*^9, 3.6932314318635864`*^9}, {3.6932314802668295`*^9, 
   3.693231482104393*^9}, {3.6932315181833425`*^9, 3.693231521472569*^9}, {
   3.6932317311512995`*^9, 3.6932317612698965`*^9}, {3.6932318058168726`*^9, 
   3.6932318349340167`*^9}, {3.69323186834151*^9, 3.693231915327364*^9}, {
   3.693231956844167*^9, 3.6932319664593296`*^9}, {3.6932320280977745`*^9, 
   3.693232085989026*^9}, {3.693232145252331*^9, 3.6932321465475526`*^9}, {
   3.6932325552572975`*^9, 3.6932326292876987`*^9}, {3.6932326726459417`*^9, 
   3.693232730505689*^9}, {3.693232771940531*^9, 3.693232772765792*^9}, {
   3.6932328235274887`*^9, 3.6932328902842417`*^9}, {3.6932329883014345`*^9, 
   3.6932330238608932`*^9}, {3.693233062761312*^9, 3.6932330834240355`*^9}, {
   3.693233174263198*^9, 3.6932331823205338`*^9}, {3.6932408167038107`*^9, 
   3.6932408696102285`*^9}, {3.6932409286687155`*^9, 
   3.6932409950850706`*^9}, {3.6932410771642823`*^9, 3.6932412283873405`*^9}, 
   3.6932412615859523`*^9, {3.6932413149514933`*^9, 3.693241330434665*^9}, {
   3.693241385709304*^9, 3.693241391194946*^9}, {3.693241422006688*^9, 
   3.6932414238684635`*^9}, {3.6932414584344234`*^9, 3.693241503734548*^9}, {
   3.6932415753484273`*^9, 3.693241580506605*^9}, {3.6932416390699873`*^9, 
   3.6932416584407406`*^9}, {3.6932416962683654`*^9, 
   3.6932416986442165`*^9}, {3.6932417341137643`*^9, 
   3.6932418192528725`*^9}, {3.6932418649633374`*^9, 
   3.6932419509771233`*^9}, {3.6932419871501403`*^9, 3.693242091305685*^9}, {
   3.6932421380150843`*^9, 3.6932422400465918`*^9}, {3.6932423316019588`*^9, 
   3.6932424229500947`*^9}, {3.693242479427306*^9, 3.693242558078874*^9}, {
   3.6932427294461613`*^9, 3.6932427986019697`*^9}, {3.6932428616400027`*^9, 
   3.693242897734096*^9}, {3.693242941133786*^9, 3.6932429721333723`*^9}, {
   3.6932432283214197`*^9, 3.6932432393807955`*^9}, {3.6932471152883725`*^9, 
   3.6932471176651754`*^9}, {3.693247296262161*^9, 3.693247303407444*^9}, {
   3.6932486816314588`*^9, 3.693248682201329*^9}, {3.6932491938331413`*^9, 
   3.693249198352952*^9}, 3.693249231094245*^9, {3.693249261096758*^9, 
   3.693249317497177*^9}, {3.693307258644993*^9, 3.6933072786597214`*^9}, {
   3.693307321669752*^9, 3.693307397868376*^9}, {3.6933074360637236`*^9, 
   3.693307449059535*^9}, {3.6933074822575397`*^9, 3.6933074847284193`*^9}, {
   3.6933075191722565`*^9, 3.6933075278808947`*^9}, 3.693307612029354*^9, 
   3.69330766251857*^9, {3.6933079297190924`*^9, 3.6933079336684265`*^9}, {
   3.6933084925788374`*^9, 3.693308683187855*^9}, {3.6933087132191334`*^9, 
   3.6933087139904327`*^9}, {3.693308752742201*^9, 3.6933087579704022`*^9}, {
   3.69330883628811*^9, 3.6933088369445763`*^9}, {3.693308877274045*^9, 
   3.6933088791965694`*^9}, {3.693308911352963*^9, 3.6933089249943886`*^9}, {
   3.6933090357299976`*^9, 3.6933090470601454`*^9}, {3.6933090851598387`*^9, 
   3.693309093382635*^9}, 3.6933091306467476`*^9, {3.6933092165616713`*^9, 
   3.6933092218734074`*^9}, {3.6933093369076977`*^9, 3.6933093423712807`*^9}, 
   3.693309404562646*^9, {3.693340044928319*^9, 3.693340056147597*^9}, {
   3.693340884209857*^9, 3.69334088780313*^9}, {3.6933873471524897`*^9, 
   3.693387347958007*^9}, 3.693387970504204*^9, 3.693388003213356*^9, {
   3.6933880680067835`*^9, 3.693388073664672*^9}, 3.693388189473796*^9, {
   3.69338829181905*^9, 3.6933883016062717`*^9}, {3.6935089252802134`*^9, 
   3.6935089314092813`*^9}, {3.6966032625019617`*^9, 
   3.6966032689330797`*^9}, {3.696882609350678*^9, 3.696882611374606*^9}, {
   3.696882770534679*^9, 3.6968827936373034`*^9}, {3.696882834952182*^9, 
   3.6968828377244897`*^9}, {3.6968829691300364`*^9, 3.696883000840495*^9}, {
   3.6968830309284725`*^9, 3.696883131027583*^9}, {3.6968836156580725`*^9, 
   3.6968836857040253`*^9}, {3.696883727652186*^9, 3.6968837334156427`*^9}, {
   3.696883805177271*^9, 3.6968838130825915`*^9}, {3.69688386284879*^9, 
   3.6968838642942357`*^9}, {3.6968839127905397`*^9, 3.696883938230563*^9}, {
   3.6968840004090595`*^9, 3.6968840160581474`*^9}, {3.6968840624204087`*^9, 
   3.69688408635063*^9}, {3.6968841272167463`*^9, 3.6968841274365864`*^9}, {
   3.696884193028548*^9, 3.696884193817407*^9}, {3.6969247775778966`*^9, 
   3.696924808822349*^9}, {3.696924952412675*^9, 3.6969251209135513`*^9}, {
   3.6969251641083417`*^9, 3.6969252106119037`*^9}, {3.696925580175105*^9, 
   3.6969255869619465`*^9}, {3.6969257231016603`*^9, 
   3.6969257759820538`*^9}, {3.6969346118051047`*^9, 
   3.6969346303342896`*^9}, {3.697124302485197*^9, 3.6971243082086024`*^9}, {
   3.6971245082256155`*^9, 3.6971245083749685`*^9}, {3.6971351455466957`*^9, 
   3.6971351458435416`*^9}, {3.697135234082259*^9, 3.6971352914585123`*^9}, {
   3.6972076202049866`*^9, 3.6972076246728687`*^9}, {3.6972076756804266`*^9, 
   3.697207675855866*^9}, {3.697221760178912*^9, 3.6972218195758953`*^9}, {
   3.6973561076904645`*^9, 3.69735611264593*^9}, {3.697356165513048*^9, 
   3.697356175082064*^9}, {3.697356206508566*^9, 3.6973562069461126`*^9}, {
   3.6973562699363627`*^9, 3.6973563114237413`*^9}, {3.697356351508413*^9, 
   3.6973563516803303`*^9}, {3.7016314787496195`*^9, 3.701631512518572*^9}, {
   3.70279655399358*^9, 3.702796559985023*^9}, {3.702796706370015*^9, 
   3.702796709291735*^9}, {3.7191686897743883`*^9, 3.719168696006291*^9}, {
   3.7191687417444143`*^9, 3.719168741883191*^9}, {3.725090063360634*^9, 
   3.7250900758908167`*^9}, {3.7250932723727627`*^9, 
   3.7250932733495607`*^9}, {3.725093572992968*^9, 3.725093575841405*^9}, {
   3.725094403076085*^9, 3.7250944121795826`*^9}, {3.7256198918923445`*^9, 
   3.7256198948121367`*^9}, {3.725999983498001*^9, 3.725999985373406*^9}, {
   3.726000016650855*^9, 3.7260000167915397`*^9}, {3.7260024940411167`*^9, 
   3.7260024982109156`*^9}, {3.7260034262633076`*^9, 
   3.7260034264508657`*^9}, {3.727685436518223*^9, 3.727685438002741*^9}, {
   3.7276896219099164`*^9, 
   3.7276896388849416`*^9}},ExpressionUUID->"205ada6e-6980-4287-be59-\
bead543eee16"]
}, Closed]],

Cell[CellGroupData[{

Cell["single events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, 3.6933104109539137`*^9, {3.6933800383321157`*^9, 
   3.693380041428832*^9}},ExpressionUUID->"7d6412c7-2b24-4ae7-84ff-\
94dabc33ad4f"],

Cell[CellGroupData[{

Cell["Null events", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.484301088331937*^9, 3.484301110963764*^9}, {
  3.503024812706325*^9, 3.503024827850071*^9}, {3.503024870705112*^9, 
  3.50302490230342*^9}, {3.5343114395338573`*^9, 3.5343114437467546`*^9}, {
  3.690987153294479*^9, 
  3.690987154241378*^9}},ExpressionUUID->"2435203d-c747-439e-9819-\
255b8abb4fd7"],

Cell[CellGroupData[{

Cell["Hilbert Space Compatible", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.6909877968302298`*^9}, {
  3.697133254540925*^9, 
  3.6971332582798243`*^9}},ExpressionUUID->"01cc3631-1102-4b3c-a96d-\
23d90ac817d8"],

Cell[CellGroupData[{

Cell["PropagatorCalculationProcedure\[Rule]None", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 
  3.6909877968302298`*^9}},ExpressionUUID->"d028d108-39d3-4d79-9aa4-\
32d49f09141b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "True", ",", "None", ",", "__"}], "}"}], 
       ",", "_", ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909877338744802`*^9, 3.690987773088852*^9}, {3.69098818773563*^9, 
   3.690988188404853*^9}, {3.691391398210943*^9, 3.691391404612554*^9}, {
   3.6913921720231457`*^9, 3.6913921732998238`*^9}, 3.691592933541375*^9, 
   3.693508735497898*^9, {3.6968817438080845`*^9, 3.696881752031869*^9}, {
   3.6968831751835217`*^9, 3.696883176613861*^9}, 
   3.6972218280012293`*^9},ExpressionUUID->"1e39cc99-df91-43b1-99c5-\
490668cc7059"]
}, Closed]],

Cell[CellGroupData[{

Cell["IntegrateEvolutionOverTime and zero duration", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.690987811069519*^9}, {
   3.6909878417596493`*^9, 3.6909878568756104`*^9}, 
   3.6909881982470407`*^9},ExpressionUUID->"cb2252c3-3a0e-44c4-b520-\
eb4a6012b032"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "True", ",", 
          "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", "___Rule"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "T", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, 3.6909882038151903`*^9, {
   3.69139143082561*^9, 3.691391447414576*^9}, {3.6913921772296677`*^9, 
   3.691392178620309*^9}, 3.6915929420290537`*^9, 3.693508749277835*^9, 
   3.6968831822734*^9, {3.697133284348361*^9, 3.6971332911219344`*^9}, 
   3.697221836127984*^9},ExpressionUUID->"b8c21d41-3fa6-47a9-a1eb-\
7b9656e4c8ba"]
}, Closed]],

Cell[CellGroupData[{

Cell["null evolution ShapeFunction", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, 3.455106406967524*^9, {3.455357656096076*^9, 
   3.4553576616132*^9}, {3.4648512522160473`*^9, 3.464851261206229*^9}, {
   3.5030249613369837`*^9, 3.50302496731923*^9}, 
   3.691592680852573*^9},ExpressionUUID->"30b62a36-8920-4246-920c-\
adc434441b56"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "_", ",", 
         "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"___", ",", " ", "NullGeneratorPattern"}], "]"}], ",", 
         "_"}], "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.690988217743535*^9, 3.690988232558065*^9}, {
   3.6913914533940067`*^9, 3.6913914576505404`*^9}, {3.691392182613861*^9, 
   3.691392187794449*^9}, {3.691592947520401*^9, 3.691592948519438*^9}, 
   3.693508776306068*^9, 3.6968831861752806`*^9, {3.697133304001382*^9, 
   3.69713330780962*^9}, 3.69722183983255*^9, 
   3.709374504259461*^9},ExpressionUUID->"c214f1f2-2922-44f1-8f22-\
9f36e3969b79"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Space Incompatible", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.6909877968302298`*^9}, {
  3.697133254540925*^9, 
  3.697133271196262*^9}},ExpressionUUID->"4b8759f6-081e-4320-b6d3-\
7e9893a0e087"],

Cell[CellGroupData[{

Cell["PropagatorCalculationProcedure\[Rule]None", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 
  3.6909877968302298`*^9}},ExpressionUUID->"4d9d0a07-e6ca-451b-b434-\
668e0f818ded"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "True", ",", "None", ",", "__"}], "}"}], 
       ",", "_", ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",",
      "opts___Rule"}], "]"}], ":=", "\[Rho]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909877338744802`*^9, 3.690987773088852*^9}, {3.69098818773563*^9, 
   3.690988188404853*^9}, {3.691391398210943*^9, 3.691391404612554*^9}, {
   3.6913921720231457`*^9, 3.6913921732998238`*^9}, 3.691592933541375*^9, 
   3.693508735497898*^9, {3.6968817438080845`*^9, 3.696881752031869*^9}, {
   3.6968831751835217`*^9, 3.696883176613861*^9}, {3.6971333315615516`*^9, 
   3.6971333417193904`*^9}, {3.7276854476284485`*^9, 
   3.727685453360511*^9}},ExpressionUUID->"bd1a542a-b27b-4cc3-aa07-\
2d260f6ba708"]
}, Closed]],

Cell[CellGroupData[{

Cell["IntegrateEvolutionOverTime and zero duration", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.690987811069519*^9}, {
   3.6909878417596493`*^9, 3.6909878568756104`*^9}, 
   3.6909881982470407`*^9},ExpressionUUID->"a41ff099-9888-434f-a95a-\
d84d3ed232f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "True", ",", 
          "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", "___Rule"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "T", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   "\[Rho]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, 3.6909882038151903`*^9, {
   3.69139143082561*^9, 3.691391447414576*^9}, {3.6913921772296677`*^9, 
   3.691392178620309*^9}, 3.6915929420290537`*^9, 3.693508749277835*^9, 
   3.6968831822734*^9, {3.697133284348361*^9, 3.6971332911219344`*^9}, {
   3.6971333477320204`*^9, 3.697133353338958*^9}, {3.7276854723740273`*^9, 
   3.7276854777339134`*^9}},ExpressionUUID->"11d1f04a-c2dd-44f2-9772-\
3d5b8d36cecf"]
}, Closed]],

Cell[CellGroupData[{

Cell["null evolution ShapeFunction", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, 3.455106406967524*^9, {3.455357656096076*^9, 
   3.4553576616132*^9}, {3.4648512522160473`*^9, 3.464851261206229*^9}, {
   3.5030249613369837`*^9, 3.50302496731923*^9}, 
   3.691592680852573*^9},ExpressionUUID->"5dfa5dea-d65a-4f82-8e04-\
a993b35ab3f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "_", ",", 
         "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"___", ",", " ", "NullGeneratorPattern"}], "]"}], ",", 
         "_"}], "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[Rho]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.690988217743535*^9, 3.690988232558065*^9}, {
   3.6913914533940067`*^9, 3.6913914576505404`*^9}, {3.691392182613861*^9, 
   3.691392187794449*^9}, {3.691592947520401*^9, 3.691592948519438*^9}, 
   3.693508776306068*^9, 3.6968831861752806`*^9, {3.697133304001382*^9, 
   3.69713330780962*^9}, {3.6971333579173813`*^9, 3.697133363258504*^9}, 
   3.709374504266143*^9, {3.727685482705133*^9, 
   3.727685486096064*^9}},ExpressionUUID->"e8c088f7-a6f8-4f72-944c-\
c77e7ee5d626"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, {3.503307845369619*^9, 3.503307854191724*^9}, {
   3.534311745984529*^9, 
   3.5343117488862343`*^9}},ExpressionUUID->"3f088792-33e4-4869-9ab1-\
65a31826b530"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"UnitySuperoperator", "[", "___", "]"}], ",", "___"}], "}"}],
        ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[Rho]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.69098807785886*^9, 3.690988095648629*^9}, {
   3.6909897721602793`*^9, 3.690989792302166*^9}, {3.691391464041877*^9, 
   3.6913914715224752`*^9}, {3.691392194912504*^9, 3.691392199306883*^9}, 
   3.691592953910719*^9, 3.6935087843668847`*^9, 3.696883189574538*^9, {
   3.6971329164420443`*^9, 3.6971329169296412`*^9}, {3.6971333707690086`*^9, 
   3.6971333789883056`*^9}, {3.7276855091705103`*^9, 
   3.7276855139559236`*^9}},ExpressionUUID->"4808bb79-b96e-4275-8880-\
3f64323be40d"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Space Compatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969353615783634`*^9, 
  3.696935366182064*^9}},ExpressionUUID->"fc75f5fc-252c-43fb-9fc9-\
6b7da17869a9"],

Cell[CellGroupData[{

Cell["Time-independent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, 
   3.696935388529559*^9},ExpressionUUID->"d974bfbf-e254-4996-9074-\
5caf1ce4b938"],

Cell[CellGroupData[{

Cell["Time-independent commutation superoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, 3.534312208835496*^9, 
   3.534312835224263*^9},ExpressionUUID->"5459f693-ab76-452c-9d5d-\
ba06dd20563d"],

Cell["evolve under the associated Hamiltonian", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534312697186016*^9, 
  3.5343127063854103`*^9}},ExpressionUUID->"bebb893d-f95c-47c9-b837-\
3836e30708c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"CommutationSuperoperator", "[", 
          RowBox[{"op_", ",", "___Rule"}], "]"}], ",", "\[Tau]_"}], "}"}], 
       ",", "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"op", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Complex", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}], ",", "\[Tau]"}], 
        "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503025687858303*^9, 3.503025722245736*^9}, {
   3.5031120589480553`*^9, 3.503112110693466*^9}, {3.5031133894727087`*^9, 
   3.5031133896856327`*^9}, 3.503115153550331*^9, {3.5111775809053907`*^9, 
   3.511177584763298*^9}, {3.534312215814622*^9, 3.534312266563973*^9}, 
   3.534312530792787*^9, {3.534312732855695*^9, 3.534312766231317*^9}, {
   3.666608484435109*^9, 3.6666084865346394`*^9}, 3.6666113039965553`*^9, {
   3.6668022157789855`*^9, 3.6668022260903473`*^9}, {3.66681292825787*^9, 
   3.6668129299977474`*^9}, {3.6909844672795877`*^9, 3.690984470085635*^9}, {
   3.690988499468053*^9, 3.6909885262845984`*^9}, {3.690988567156177*^9, 
   3.690988628579484*^9}, {3.691059604153894*^9, 3.691059606048283*^9}, {
   3.69139149389701*^9, 3.6913915067973127`*^9}, 3.691593112043873*^9, {
   3.691593300179624*^9, 3.6915933169049597`*^9}, {3.693381417317855*^9, 
   3.6933814329141536`*^9}, {3.6933829559152966`*^9, 3.693382971133459*^9}, {
   3.693383027939308*^9, 3.6933830312123985`*^9}, {3.6933831896179075`*^9, 
   3.693383190745489*^9}, {3.6933833146777134`*^9, 3.693383328747326*^9}, {
   3.6933860087115674`*^9, 3.69338601783076*^9}, 3.6968832013531284`*^9, {
   3.696883500728565*^9, 3.6968835015693426`*^9}, 3.6972045449279823`*^9, {
   3.6972218646575537`*^9, 
   3.6972218760472646`*^9}},ExpressionUUID->"dd491252-4aa6-4fb4-8fd9-\
b7ffe4a4a71b"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent Hamiltonian", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9},ExpressionUUID->"fd7d50bc-6b80-4dea-b0ff-\
0d8943368ea4"],

Cell["\<\
if the Operator is diagonalized, use it in that form

something seems to be wrong with the syntax below, but I \
don\[CloseCurlyQuote]t know what.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586361647781171*^9, 3.586361658171316*^9}, {
  3.7038563143290715`*^9, 
  3.703856326594284*^9}},ExpressionUUID->"12bc6659-7bc5-469c-886b-\
4b9d916dbdf2"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop", ":", 
           RowBox[{"HoldPattern", "@", 
            RowBox[{"Operator", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
                RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "basis1_", ",", 
              "opts1___Rule"}], "]"}]}]}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis2_", ",", 
      "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Hop", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"basis1", "==", "basis2"}], ",", "Hop", ",", 
           RowBox[{"NDiagonalize", "[", 
            RowBox[{"Hop", ",", "basis2", ",", "opts1"}], "]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
         RowBox[{"First", "@", "Hop"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Operator", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SparseArray", "@", 
           RowBox[{"Chop", "[", 
            RowBox[{"X", ".", 
             RowBox[{"DiagonalMatrix", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "I"}], "*", "\[Tau]", "*", "#"}], "]"}], "&"}],
                "/@", "evals"}], "]"}], ".", "Xinv"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "basis2", ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "Operator", "]"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}], "*)"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.6969340584226933`*^9, 3.6969340890085173`*^9}, {3.696934132463603*^9, 
   3.6969342158795223`*^9}, {3.6969342605506945`*^9, 3.696934268799816*^9}, {
   3.696934583327876*^9, 3.6969345998461065`*^9}, {3.696934803789753*^9, 
   3.6969348048215237`*^9}, 3.697221885306079*^9, {3.7038553504783278`*^9, 
   3.7038553758033504`*^9}, {3.703855904285013*^9, 3.7038559075194974`*^9}, {
   3.70385598109638*^9, 3.7038559891000166`*^9}, {3.703856196955616*^9, 
   3.7038562017229004`*^9}, {3.703856242834649*^9, 3.7038562460326276`*^9}, {
   3.703856330156459*^9, 
   3.703856333672433*^9}},ExpressionUUID->"f53a34bc-b6e8-459a-92f4-\
3f87b75e74d4"],

Cell["otherwise use the MatrixExp:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586362011529046*^9, 
  3.5863620187422867`*^9}},ExpressionUUID->"4b56cb4e-45c2-4bfb-a6e3-\
d62f1ff1f381"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UseMatrixExpWhenPossible", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "matrep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matrep", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "I"}], " ", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{"Hop", ",", "basis"}], "]"}], "\[Times]", " ", "\[Tau]"}],
           ")"}], "/.", 
         RowBox[{"{", 
          RowBox[{"evopts", ",", "opts"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "@", 
           RowBox[{"N", "@", 
            RowBox[{"MatrixExp", "[", 
             RowBox[{"N", "@", "matrep"}], "]"}]}]}]}], ",", 
         "\[IndentingNewLine]", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.5875487453814287`*^9, 3.587548750271266*^9}, {3.587549184401637*^9, 
   3.5875491956715727`*^9}, 3.587551497715831*^9, {3.621156110832801*^9, 
   3.621156112012767*^9}, {3.6666084939054546`*^9, 3.6666084967445064`*^9}, 
   3.6666113063004503`*^9, {3.6667890644872985`*^9, 3.666789069959587*^9}, {
   3.6667895516308956`*^9, 3.666789551789101*^9}, {3.6668023258856225`*^9, 
   3.6668023270445833`*^9}, {3.666802579260866*^9, 3.666802589794033*^9}, {
   3.6668026320214353`*^9, 3.6668026333398294`*^9}, {3.666812942318075*^9, 
   3.666812966599028*^9}, {3.6669445156443725`*^9, 3.666944519985222*^9}, {
   3.6669447336397448`*^9, 3.666944733882427*^9}, {3.6909844811186533`*^9, 
   3.690984482885489*^9}, {3.6909888249242573`*^9, 3.690988889452402*^9}, {
   3.691057877346417*^9, 3.691057893722179*^9}, {3.691391533479982*^9, 
   3.691391536261326*^9}, 3.691402517815181*^9, {3.6914072617781076`*^9, 
   3.691407262861771*^9}, 3.6914957755793858`*^9, {3.6928466113575172`*^9, 
   3.692846613347499*^9}, 3.692846884837802*^9, 3.6928469164398937`*^9, 
   3.6928480548434057`*^9, {3.6933812111299906`*^9, 3.693381262908482*^9}, {
   3.693381623640545*^9, 3.6933816282797704`*^9}, {3.6933828070818806`*^9, 
   3.6933828334146423`*^9}, {3.6933830041297774`*^9, 3.693383011642889*^9}, {
   3.693383074640422*^9, 3.6933831074704456`*^9}, {3.693383359557277*^9, 
   3.6933833598260345`*^9}, {3.696882017424264*^9, 3.6968820318392253`*^9}, {
   3.6968823692589045`*^9, 3.696882370099125*^9}, 3.6968832079560885`*^9, {
   3.6972018757715635`*^9, 3.6972018945605974`*^9}, 3.6972218903183365`*^9, {
   3.7038553816281304`*^9, 3.703855383439928*^9}, {3.703855444930548*^9, 
   3.7038554453748646`*^9}, {3.7038554963651*^9, 3.703855502251737*^9}, {
   3.7038555361333213`*^9, 3.7038555489167504`*^9}, {3.7038556540049148`*^9, 
   3.7038556546581254`*^9}, {3.7038558220041637`*^9, 
   3.7038558237845263`*^9}, {3.7038558783843946`*^9, 3.703855878594385*^9}, {
   3.70385591157232*^9, 3.7038559152189035`*^9}, {3.7038561998817205`*^9, 
   3.7038562000535946`*^9}, {3.709131952724874*^9, 3.7091319546031866`*^9}, {
   3.7091320086015387`*^9, 3.7091320121620717`*^9}, {3.709132043491785*^9, 
   3.709132074628265*^9}, {3.709132117152463*^9, 3.709132124058366*^9}, {
   3.7091321595788355`*^9, 3.709132159868308*^9}, {3.70913219706627*^9, 
   3.7091322318476253`*^9}, {3.7091328559081635`*^9, 
   3.7091328561783547`*^9}},ExpressionUUID->"2355ef2a-078f-4502-9e42-\
e59a44dd5da7"],

Cell["\<\
if not using the MatrixExp, convert into a function for explicit integration\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.503112000557836*^9, 
  3.503112017213619*^9}},ExpressionUUID->"349440da-2970-4c31-9bdb-\
1f9b106c3f6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "T_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"!", "UseMatrixExpWhenPossible"}], "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"StandardizeGenerator", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"t", ",", 
             RowBox[{"Evaluate", "[", "Hop", "]"}]}], "]"}], ",", 
           RowBox[{"Basis", "\[Rule]", "basis"}]}], "]"}], ",", "\[Tau]"}], 
        "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503111914458187*^9, 3.503111933778318*^9}, {3.5031119773263063`*^9, 
   3.503111996098827*^9}, {3.5031120333747587`*^9, 3.503112043315461*^9}, {
   3.503112188293264*^9, 3.5031121940051394`*^9}, {3.5031123829707193`*^9, 
   3.503112387544818*^9}, {3.5031132367593727`*^9, 3.50311323700453*^9}, 
   3.503114828230123*^9, {3.507022907785177*^9, 3.507022910006372*^9}, 
   3.508400570646513*^9, {3.534312162544573*^9, 3.5343121937375183`*^9}, 
   3.5422810910117064`*^9, {3.542955740285832*^9, 3.542955765226015*^9}, {
   3.6667890510363503`*^9, 3.6667890725573006`*^9}, {3.666789542428689*^9, 
   3.6667895448189096`*^9}, {3.66680233177588*^9, 3.6668023373175964`*^9}, {
   3.666812953427063*^9, 3.66681296102861*^9}, {3.6669445762091246`*^9, 
   3.666944586328432*^9}, {3.666944717785367*^9, 3.666944727511091*^9}, {
   3.6909844872225027`*^9, 3.690984489124609*^9}, {3.6909889157805653`*^9, 
   3.690988979396927*^9}, {3.691391543102109*^9, 3.691391557834894*^9}, 
   3.6914957863472767`*^9, {3.6933812768284287`*^9, 3.6933813162945614`*^9}, 
   3.69688320995852*^9, 3.6969349947924323`*^9, {3.697375630053156*^9, 
   3.697375642865082*^9}, 
   3.7093740724235477`*^9},ExpressionUUID->"76fc43b3-03d3-4471-b899-\
ba03c98725c1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 3.534312862341494*^9}, {3.6933866240201435`*^9, 
   3.6933866247715487`*^9}, {3.6969353906319375`*^9, 
   3.6969353918422594`*^9}},ExpressionUUID->"ba5dc159-810c-4006-9689-\
2465114e9920"],

Cell[CellGroupData[{

Cell["Time-dependent commutation superoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, {3.503025797624085*^9, 3.50302579778263*^9}, {
   3.534312817477545*^9, 
   3.5343128456219187`*^9}},ExpressionUUID->"a14e7cbc-640b-4a1c-91dc-\
c91d89415244"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",",
          "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Lfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"t_", ",", 
              RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
              RowBox[{"CommutationSuperoperator", "[", 
               RowBox[{"op_", ",", "___Rule"}], "]"}]}], "]"}]}], ",", 
           "\[Tau]_"}], "}"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
        "]"}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], 
    "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
           RowBox[{"op", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Complex", "[", 
               RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}]}], "]"}], ",", 
         "\[Tau]"}], "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", 
     "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503025752698345*^9, 3.5030257583747396`*^9}, {3.5030258334600573`*^9, 
   3.503025850747231*^9}, {3.503025881421885*^9, 3.5030259696222754`*^9}, {
   3.5030260590423822`*^9, 3.503026096992079*^9}, {3.503112232053441*^9, 
   3.503112277937085*^9}, {3.503112319384701*^9, 3.503112366768518*^9}, {
   3.503112422322407*^9, 3.5031124994636602`*^9}, 3.5031125532271223`*^9, {
   3.503112586208776*^9, 3.503112592640542*^9}, {3.503112630090947*^9, 
   3.503112631440538*^9}, {3.503113245678843*^9, 3.5031132459237843`*^9}, {
   3.503113459055827*^9, 3.503113464669381*^9}, {3.503113634395102*^9, 
   3.5031136611266193`*^9}, {3.503113703737402*^9, 3.503113773767356*^9}, {
   3.503113849430991*^9, 3.503113871961054*^9}, {3.503114849311439*^9, 
   3.503114854894581*^9}, {3.507023031173218*^9, 3.507023164828182*^9}, 
   3.534312327172946*^9, {3.534312400901217*^9, 3.534312453718451*^9}, 
   3.5343125212115097`*^9, 3.5422811141952744`*^9, {3.6666085082554593`*^9, 
   3.666608508685293*^9}, 3.6666113088259196`*^9, {3.690984497229733*^9, 
   3.690984499235046*^9}, {3.6910598688327503`*^9, 3.691059899950292*^9}, {
   3.6910599781356916`*^9, 3.6910599861831207`*^9}, {3.691060166591395*^9, 
   3.6910601742377863`*^9}, {3.6910602190608683`*^9, 3.691060221294345*^9}, {
   3.6913915667347593`*^9, 3.691391580922913*^9}, {3.6933853040788345`*^9, 
   3.693385310626051*^9}, {3.693385354138092*^9, 3.6933853613666973`*^9}, {
   3.693385412569092*^9, 3.6933854169390364`*^9}, {3.6933854968520393`*^9, 
   3.6933855012919426`*^9}, {3.693385558824297*^9, 3.6933855629348564`*^9}, {
   3.693385622816536*^9, 3.6933856376915445`*^9}, 3.693385872062977*^9, {
   3.693385910092436*^9, 3.693385922529768*^9}, 3.6968832201693444`*^9, {
   3.6968854982813473`*^9, 3.696885499157544*^9}, {3.69720265844427*^9, 
   3.6972027223442307`*^9}, {3.697202873529948*^9, 3.697202904072912*^9}, {
   3.6972030789184875`*^9, 3.697203091526406*^9}, {3.697204464811043*^9, 
   3.697204483244026*^9}, {3.697204526645398*^9, 3.697204527772366*^9}, {
   3.6972219051695614`*^9, 3.697221911227345*^9}, 
   3.709375004982854*^9},ExpressionUUID->"545e1219-95df-4ab7-a161-\
f9e91edad951"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent Hamiltonian", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 
   3.534312862341494*^9}},ExpressionUUID->"4fb893d9-a47f-45b3-a471-\
921a4438efdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"True", ",", "False", ",", "True", ",", 
     RowBox[{"ev", ":", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"{", 
              RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}], 
           ",", "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hfunc", ":", 
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"args__", ",", 
             RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "\[Tau]_"}], 
         "}"}], ",", "evopts___Rule"}], "]"}]}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}], "&&", 
    RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Hmatfunc", ",", "NDSolveopts", ",", "n", ",", "u", ",", "uvec", ",", 
      "uvecplain", ",", "uvecflat", ",", "umat", ",", "h", ",", "hvec", ",", 
      "hmat", ",", "t$", ",", "sol"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Hmatfunc", "=", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"tinternal", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
          RowBox[{"Normal", "@", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Hfunc", "[", 
               RowBox[{"tinternal", ",", "ta", ",", "tb"}], "]"}], "/.", 
              RowBox[{"{", 
               RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "basis"}], 
            "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"NDSolveopts", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"SimplifyRules", "[", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}], "]"}], ",", 
          RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"n", "=", 
       RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvec", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvecflat", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"uvecplain", "=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", 
            RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sol", "=", 
       RowBox[{"NDSolveValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"uvecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
            "\[Equal]", 
            RowBox[{
             RowBox[{"-", "I"}], " ", 
             RowBox[{"(", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Hmatfunc", "[", "t$", "]"}], ".", 
                RowBox[{"uvec", "[", "t$", "]"}]}], "]"}], ")"}]}]}], ",", 
           RowBox[{
            RowBox[{"uvecflat", "[", "ta", "]"}], "\[Equal]", 
            RowBox[{"Flatten", "[", 
             RowBox[{"IdentityMatrix", "[", "n", "]"}], "]"}]}]}], "}"}], ",",
          "uvecplain", ",", 
         RowBox[{"{", 
          RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"SparseArray", "[", 
         RowBox[{"Chop", "[", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Through", "[", 
              RowBox[{"#", "[", "tb", "]"}], "]"}], "&"}], "/@", "sol"}], 
           "]"}], "]"}], "]"}], ",", "basis", ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Options", "[", "Operator", "]"}]}], "\[IndentingNewLine]",
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ")"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.697140444116701*^9, 3.697140462292384*^9}, {3.6971405445462027`*^9, 
   3.697140544696862*^9}, {3.6971973737271624`*^9, 3.69719737390374*^9}, {
   3.697202021615039*^9, 3.6972020238340225`*^9}, {3.6972020570557203`*^9, 
   3.697202117681389*^9}, 3.697221917698621*^9, {3.6972248144891415`*^9, 
   3.697224840340124*^9}, {3.6972252791707563`*^9, 3.6972252793196115`*^9}, {
   3.6972255681826324`*^9, 3.697225577806399*^9}, {3.697226097137842*^9, 
   3.697226097303132*^9}, {3.699598661977907*^9, 3.69959867816735*^9}, {
   3.6996202579265976`*^9, 3.6996204249872246`*^9}, {3.6996204713364134`*^9, 
   3.69962051748325*^9}, {3.703925859591716*^9, 3.703925861438901*^9}, {
   3.7039259939064507`*^9, 3.7039259989330034`*^9}, {3.703926086278864*^9, 
   3.703926106327973*^9}, {3.7039261891539297`*^9, 3.703926191958609*^9}, {
   3.7039262531248555`*^9, 3.703926256383687*^9}, {3.703926345533207*^9, 
   3.703926370429733*^9}, {3.7053158198477182`*^9, 3.7053158224803786`*^9}, {
   3.7053158803022966`*^9, 3.7053158807291527`*^9}, {3.705315914179579*^9, 
   3.705315969108007*^9}, {3.7053160595880737`*^9, 3.705316059838215*^9}, 
   3.709375004992173*^9, {3.7106739228386073`*^9, 3.7106739267452507`*^9}, {
   3.7106740213468337`*^9, 3.7106740274773254`*^9}, {3.7106740881347055`*^9, 
   3.710674088603511*^9}, {3.710674216157911*^9, 3.7106742180331125`*^9}, {
   3.7106742832009473`*^9, 3.7106742988385363`*^9}, {3.710674599298673*^9, 
   3.7106745994549446`*^9}, {3.711713117442273*^9, 3.7117131229985*^9}, {
   3.7117132250453386`*^9, 3.711713226972962*^9}, {3.711713263346472*^9, 
   3.7117132661855965`*^9}, {3.711713310377756*^9, 3.711713325094843*^9}, {
   3.7117133667494164`*^9, 3.7117133669981146`*^9}, {3.711713712623698*^9, 
   3.711713716111786*^9}, {3.711713793424709*^9, 3.7117137936109395`*^9}, {
   3.7135496861821995`*^9, 3.713549689212953*^9}, {3.713549723213705*^9, 
   3.713549728022324*^9}, {3.7135498095071917`*^9, 3.713549858227291*^9}, {
   3.713549906927622*^9, 3.7135499251427593`*^9}, {3.713549975705491*^9, 
   3.713550009759675*^9}, {3.713550040459305*^9, 3.713550042069358*^9}, {
   3.713550093607289*^9, 3.71355011724572*^9}, {3.71355028220842*^9, 
   3.7135503316328273`*^9}, {3.7135506327797384`*^9, 3.713550636164564*^9}, {
   3.7135506694696245`*^9, 3.713550680954528*^9}, {3.713550729227113*^9, 
   3.713550729269661*^9}, {3.713550864210149*^9, 
   3.713550864350229*^9}},ExpressionUUID->"67fd8e74-abd2-410c-ae72-\
0c5aec5d8faf"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 
   3.534312831293592*^9},ExpressionUUID->"148a4ff4-ca57-4769-bd9a-\
11a0336aecba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NPropagate", "[", "\[IndentingNewLine]", 
   RowBox[{"True", ",", "False", ",", "True", ",", "\[IndentingNewLine]", 
    RowBox[{"Event", "[", 
     RowBox[{
      RowBox[{"True", "|", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
        "__"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RotationSuperoperator", "[", "args___", "]"}], ",", "___"}], 
       "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", 
    "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"RotationOperator", "[", "args", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 
   3.7016323285116053`*^9}},ExpressionUUID->"474d3882-f81e-41fd-816d-\
2d37c676dd82"]
}, Closed]],

Cell[CellGroupData[{

Cell["Product of RotationSuperoperators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 3.534312831293592*^9, {
   3.7095504893925085`*^9, 
   3.7095504933768435`*^9}},ExpressionUUID->"be669a25-7196-4433-b989-\
8bb5c636bc38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NPropagate", "[", "\[IndentingNewLine]", 
   RowBox[{"True", ",", "False", ",", "True", ",", "\[IndentingNewLine]", 
    RowBox[{"Event", "[", 
     RowBox[{
      RowBox[{"True", "|", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
        "__"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"R", ":", 
         RowBox[{"Dot", "[", 
          RowBox[{
           RowBox[{"RotationSuperoperator", "[", "___", "]"}], ",", 
           RowBox[{
            RowBox[{"RotationSuperoperator", "[", "___", "]"}], ".."}]}], 
          "]"}]}], ",", "___"}], "}"}], ",", "___Rule"}], "]"}], ",", 
    "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", 
  RowBox[{"R", "/.", 
   RowBox[{"{", 
    RowBox[{"RotationSuperoperator", "\[Rule]", " ", "RotationOperator"}], 
    "}"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.7095504992671413`*^9, 3.709550524745584*^9}, {3.7095508211544123`*^9, 
   3.7095508321612806`*^9}},ExpressionUUID->"734b9550-3557-4a62-9a31-\
931ead3b5aad"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Repeat", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.690984518900131*^9, 3.690984520602982*^9}, 
   3.692848521296042*^9},ExpressionUUID->"b809145a-26ed-41a5-9a00-\
eeee8f24535e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"NPropagate", "[", 
      RowBox[{"True", ",", "False", ",", "True", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", 
         RowBox[{
          RowBox[{"st", ":", 
           RowBox[{"(", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
          ",", 
          RowBox[{"Repeat", "[", 
           RowBox[{
            RowBox[{"EventList", "[", 
             RowBox[{"st_", ",", "chars_", ",", 
              RowBox[{"events", ":", 
               RowBox[{"{", 
                RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}],
              "]"}], ",", "n_Integer", ",", "evtropts___Rule"}], "]"}], ",", 
          "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", "opbasis_", 
       ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "RepeatPropagator"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zbmatreps", ",", "singleprop"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbmatreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"NPropagate", "[", 
             RowBox[{
             "True", ",", "False", ",", "True", ",", "#", ",", "opbasis", ",",
               "basis", ",", "opts"}], "]"}], ",", "basis"}], "]"}], "&"}], "/@",
          "events"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"singleprop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "zbmatreps", "]"}], "\[Equal]", "1"}], ",", 
          
          RowBox[{"First", "@", "zbmatreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "zbmatreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"zbmatreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"MatrixPower", "[", 
          RowBox[{"singleprop", ",", "n"}], "]"}], ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, 3.542281134468389*^9, {3.5645684544067097`*^9, 
   3.5645685012249613`*^9}, {3.586362122636345*^9, 3.5863624728699913`*^9}, {
   3.586363380330854*^9, 3.586363385359961*^9}, {3.587576139268099*^9, 
   3.5875761417981577`*^9}, {3.5875762341269007`*^9, 
   3.5875763853272038`*^9}, {3.5875766585438547`*^9, 3.5875766813166533`*^9}, 
   {3.666608549421843*^9, 3.6666085497823753`*^9}, 3.6666113141219406`*^9, {
   3.683186587217523*^9, 3.6831865919508047`*^9}, 3.683187098958549*^9, {
   3.690984514860692*^9, 3.690984524039979*^9}, {3.691060687197613*^9, 
   3.691060753746748*^9}, {3.691060866239098*^9, 3.691060959114229*^9}, {
   3.691061045218045*^9, 3.691061064384056*^9}, {3.691391609964263*^9, 
   3.691391622649879*^9}, {3.691402547637679*^9, 3.691402548638754*^9}, {
   3.691407274584907*^9, 3.691407275830823*^9}, {3.691677015180834*^9, 
   3.6916770182838287`*^9}, 3.692848522364584*^9, {3.6933866763541565`*^9, 
   3.6933867082645226`*^9}, {3.6933868450700207`*^9, 3.693386847092952*^9}, {
   3.693386913362214*^9, 3.6933869171302466`*^9}, 3.6933869501801786`*^9, {
   3.6933869849993935`*^9, 3.6933869860494027`*^9}, {3.693387077668935*^9, 
   3.693387127937803*^9}, {3.693387174769182*^9, 3.6933871750875225`*^9}, {
   3.6933872765581036`*^9, 3.693387278983719*^9}, {3.693387310775377*^9, 
   3.693387310935706*^9}, {3.69338736901866*^9, 3.6933873913619175`*^9}, {
   3.6933874420014267`*^9, 3.693387458514313*^9}, {3.693387506983118*^9, 
   3.6933875252716055`*^9}, {3.693387566221203*^9, 3.693387589900855*^9}, {
   3.69338765801058*^9, 3.6933876744000473`*^9}, {3.693387704621563*^9, 
   3.693387769228965*^9}, {3.6933878697279177`*^9, 3.6933879023280563`*^9}, 
   3.696883229545755*^9, {3.696935508361205*^9, 3.696935539441184*^9}, {
   3.6969355907212625`*^9, 3.6969355921023006`*^9}, {3.697121899484744*^9, 
   3.6971219121194067`*^9}, {3.6972019075241003`*^9, 
   3.6972019120496492`*^9}, {3.697202032163021*^9, 3.6972020325693116`*^9}, 
   3.6972219334082985`*^9, {3.6972226636274443`*^9, 3.6972226655421596`*^9}, {
   3.6972227417276506`*^9, 3.6972227745590734`*^9}, {3.6972247564884944`*^9, 
   3.697224758892543*^9}, {3.697224806031073*^9, 3.6972248061704335`*^9}, 
   3.709375005000893*^9},ExpressionUUID->"2f79c20b-5156-4b05-a453-\
fb7cd4f22fea"]
}, Closed]],

Cell[CellGroupData[{

Cell["PrecalculatedEvent", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.538677605389827*^9, 
   3.538677607531299*^9}},ExpressionUUID->"340b5a45-0a0a-414f-b153-\
3d32b2de58c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "True", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",", 
         RowBox[{"PrecalculatedEvent", "[", 
          RowBox[{
          "precalch_", ",", "op_Operator", ",", "precalevopts___Rule"}], 
          "]"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "UsePrecalculatedPropagator"}], "]"}]}], ":=", "op"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, {3.53867763931421*^9, 3.5386776481776333`*^9}, {
   3.538677692924055*^9, 3.538677702585209*^9}, {3.5391124476711493`*^9, 
   3.539112453900564*^9}, {3.6666085615139894`*^9, 3.666608567772622*^9}, 
   3.6666113169912148`*^9, {3.690984529675124*^9, 3.690984531611169*^9}, {
   3.691391630156105*^9, 3.691391637265486*^9}, {3.6914382516732264`*^9, 
   3.691438340756529*^9}, 3.693508805406706*^9, 3.6968832344556627`*^9, {
   3.6969356333015823`*^9, 3.6969356425896783`*^9}, 
   3.6972219442177625`*^9},ExpressionUUID->"d1bb09ee-f728-4084-823c-\
ddf940516f44"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hilbert Space Incompatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969354317516556`*^9, 
  3.6969354377385855`*^9}},ExpressionUUID->"d0326c21-5978-4428-a4fc-\
458617595383"],

Cell[CellGroupData[{

Cell["Instantaneous Transformation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 3.69693544787114*^9, {3.69712426496584*^9, 
   3.6971242706544685`*^9}},ExpressionUUID->"81dc5a31-3727-4dbf-ade9-\
e56a543bcf69"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"InstaOp_", ",", "___"}], "}"}], ",", "___Rule"}], "]"}], ",",
      "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"InstaOp", "[", "\[Rho]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.696933441959618*^9, 3.696933496599775*^9}, {3.6969336005520544`*^9, 
   3.6969336021370754`*^9}, {3.696933768414254*^9, 3.6969337700656276`*^9}, {
   3.6969338194073725`*^9, 3.6969338265665736`*^9}, {3.6969338979505153`*^9, 
   3.6969339067827215`*^9}, {3.6969343081750884`*^9, 
   3.6969343371754217`*^9}, {3.69693437996661*^9, 3.6969343918608027`*^9}, {
   3.6969344369818544`*^9, 3.696934471013612*^9}, {3.6969345411996994`*^9, 
   3.6969345417349706`*^9}, {3.696934579056014*^9, 3.6969345915662336`*^9}, {
   3.6969347182855387`*^9, 3.6969347437181387`*^9}, {3.696934791247017*^9, 
   3.696934795084534*^9}, {3.696934914567275*^9, 3.6969349147324734`*^9}, {
   3.6971243951148825`*^9, 3.6971244639941216`*^9}, {3.727685523722473*^9, 
   3.727685537281563*^9}},ExpressionUUID->"bc38ddc9-dee9-49dd-8b34-\
82a3821156e9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 
   3.69693544787114*^9},ExpressionUUID->"36bd9b5b-f2fc-4fc2-9ae7-\
7dd87e56208b"],

Cell["\<\
if the Operator is diagonalized, use it in that form. 

Note:If the Hamiltonian gets diagonalized any information on \
HilbertSpaceCompatibility is lost.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586361647781171*^9, 3.586361658171316*^9}, {
  3.6969346428762445`*^9, 3.6969346614276605`*^9}, {3.727684731926833*^9, 
  3.7276847382405896`*^9}},ExpressionUUID->"6b4e69a6-b486-42b9-ba36-\
01ca1509dcf7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Lsop", ":", 
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Superoperator", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis1_", ",", 
             "basis1_", ",", "___Rule"}], "]"}]}]}], ",", "\[Tau]_"}], "}"}], 
       ",", "evopts___Rule"}], "]"}], ",", "opbasis2_", ",", "basis2_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]vec", ",", "X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
     
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Lsop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"opbasis1", "===", "opbasis2"}], ",", "Lsop", ",", 
          RowBox[{"NDiagonalize", "[", 
           RowBox[{"Lsop", ",", "opbasis2"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Rho]vec", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"OperatorVectorRepresentation", "[", 
           RowBox[{"\[Rho]", ",", "opbasis2", ",", "basis2"}], "]"}], 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}]}], "=", 
         RowBox[{"First", "@", "Lsop"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Chop", "[", 
              RowBox[{"Dot", "[", 
               RowBox[{"#2", ",", "#1"}], "]"}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Rho]vec", ",", "Xinv", ",", 
              RowBox[{"SparseArray", "[", 
               RowBox[{"DiagonalMatrix", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Exp", "[", 
                   RowBox[{"\[Tau]", "*", "#"}], "]"}], "&"}], "/@", 
                 "evals"}], "]"}], "]"}], ",", "X"}], "}"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", "opbasis2", ",", "basis2", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.696933441959618*^9, 3.696933496599775*^9}, {3.6969336005520544`*^9, 
   3.6969336021370754`*^9}, {3.696933768414254*^9, 3.6969337700656276`*^9}, {
   3.6969338194073725`*^9, 3.6969338265665736`*^9}, {3.6969338979505153`*^9, 
   3.6969339067827215`*^9}, {3.6969343081750884`*^9, 
   3.6969343371754217`*^9}, {3.69693437996661*^9, 3.6969343918608027`*^9}, {
   3.6969344369818544`*^9, 3.696934471013612*^9}, {3.6969345411996994`*^9, 
   3.6969345417349706`*^9}, {3.696934579056014*^9, 3.6969345915662336`*^9}, {
   3.6969347182855387`*^9, 3.6969347437181387`*^9}, {3.696934791247017*^9, 
   3.696934795084534*^9}, {3.696934914567275*^9, 3.6969349147324734`*^9}, {
   3.697207563773006*^9, 3.697207565738205*^9}, {3.697375705246257*^9, 
   3.697375705408688*^9}, {3.7259690879816613`*^9, 3.725969120350587*^9}, {
   3.7259691802814174`*^9, 3.7259691847737246`*^9}, {3.7259692337570777`*^9, 
   3.7259692343229012`*^9}, {3.7259693066369944`*^9, 
   3.7259693070764847`*^9}, {3.725969339976066*^9, 3.7259693450174437`*^9}, {
   3.7259700981669383`*^9, 3.725970118348423*^9}, {3.727685557983881*^9, 
   3.7276856793495054`*^9}, {3.7276867655728407`*^9, 
   3.7276868184465914`*^9}, {3.7276868846162167`*^9, 
   3.7276869449751625`*^9}},ExpressionUUID->"f540cdcd-77ee-4555-8d34-\
03ee1d2adcc4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Lsop_", "?", "SuperoperatorQ"}], ",", "\[Tau]_"}], "}"}], 
        ",", "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UseMatrixExpWhenPossible", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagate", "]"}]}], ")"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]vec", ",", "matrep"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matrep", "=", 
        RowBox[{"SuperoperatorMatrixRepresentation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"StandardizeGenerator", "[", "Lsop", "]"}], "\[Times]", 
            " ", "\[Tau]"}], "/.", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "opbasis"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Rho]vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "@", 
           RowBox[{"MatrixExp", "[", 
            RowBox[{
             RowBox[{"SparseArray", "@", 
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", "matrep"}]}]}], ",", "\[Rho]vec"}], 
            "]"}]}]}], ",", "opbasis", ",", "basis", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452690531068695*^9, 3.452690599728272*^9}, {
   3.452713481624045*^9, 3.452713486519453*^9}, {3.4527140041197157`*^9, 
   3.452714025416692*^9}, {3.4527140867578707`*^9, 3.452714099086936*^9}, {
   3.452714132023095*^9, 3.452714170502606*^9}, {3.452827494265431*^9, 
   3.452827499986635*^9}, {3.452827946311603*^9, 3.452827963017808*^9}, 
   3.4528280197802*^9, {3.452834425940219*^9, 3.452834429248974*^9}, {
   3.45296862907323*^9, 3.452968698911127*^9}, {3.452968996703251*^9, 
   3.452969016852367*^9}, {3.452970229607943*^9, 3.452970232824254*^9}, {
   3.454565577792158*^9, 3.454565600318421*^9}, 3.454565641800033*^9, {
   3.454577368550002*^9, 3.454577370845316*^9}, {3.454578554194628*^9, 
   3.454578556002204*^9}, {3.455275348251018*^9, 3.455275352394432*^9}, {
   3.455361518545755*^9, 3.45536152261629*^9}, {3.45536281612714*^9, 
   3.4553628203417187`*^9}, 3.455366472829061*^9, {3.45536961860872*^9, 
   3.455369629323238*^9}, {3.455369740504629*^9, 3.455369787310898*^9}, 
   3.456221604466387*^9, 3.456322845966786*^9, {3.4589940597643414`*^9, 
   3.4589940633240633`*^9}, 3.458994113231534*^9, {3.459338412973414*^9, 
   3.4593384203475533`*^9}, 3.462784366060383*^9, 3.4627845100182743`*^9, {
   3.464327358280571*^9, 3.464327363245153*^9}, 3.464458072781571*^9, {
   3.464610652673967*^9, 3.4646107047530823`*^9}, {3.464678912105274*^9, 
   3.464678942165515*^9}, {3.4646950329855013`*^9, 3.4646951269304113`*^9}, 
   3.4677204030792828`*^9, {3.500263382317464*^9, 3.5002634169959717`*^9}, 
   3.500263477936509*^9, 3.500263613435347*^9, {3.500264852949397*^9, 
   3.5002648583546143`*^9}, {3.500264891975165*^9, 3.500264925811551*^9}, {
   3.500265256299799*^9, 3.5002652596084213`*^9}, {3.500266263584918*^9, 
   3.500266449360496*^9}, {3.500266482204661*^9, 3.500266498800531*^9}, {
   3.50026660199973*^9, 3.500266618843708*^9}, {3.5002733799245367`*^9, 
   3.500273383047964*^9}, {3.500274045908242*^9, 3.500274046896537*^9}, {
   3.500274245833909*^9, 3.500274249255313*^9}, {3.5002749581101847`*^9, 
   3.5002751164358273`*^9}, {3.500275391980563*^9, 3.5002753945173264`*^9}, {
   3.50316912017247*^9, 3.503169135318965*^9}, 3.504458413538725*^9, {
   3.510334215541009*^9, 3.510334230946742*^9}, 3.511623355269967*^9, {
   3.511623717178936*^9, 3.5116238191868877`*^9}, {3.532003693782765*^9, 
   3.532003702255629*^9}, {3.534398607196209*^9, 3.534398607600121*^9}, 
   3.621573524540504*^9, {3.6969246067334986`*^9, 3.69692464688102*^9}, {
   3.696924714000514*^9, 3.6969247538575783`*^9}, {3.6969248378795223`*^9, 
   3.696924849107593*^9}, {3.6969249276967306`*^9, 3.6969249300645447`*^9}, {
   3.696925070044421*^9, 3.696925072852312*^9}, {3.6969253869162226`*^9, 
   3.696925396176249*^9}, {3.696925492925914*^9, 3.6969255564238443`*^9}, {
   3.696925681571023*^9, 3.6969256916631308`*^9}, {3.6969257826323223`*^9, 
   3.696925782892612*^9}, {3.696933737166244*^9, 3.696933751560065*^9}, {
   3.696933805070039*^9, 3.696933807294442*^9}, 3.6969338915818906`*^9, {
   3.6969342927494116`*^9, 3.696934295615456*^9}, 3.6969350138828397`*^9, {
   3.6972069409593325`*^9, 3.697206944044568*^9}, {3.6972071900934896`*^9, 
   3.69720719172182*^9}, {3.6972072547413025`*^9, 3.697207254905746*^9}, {
   3.7020587953339205`*^9, 3.702058798656002*^9}, {3.7020589756743217`*^9, 
   3.7020590132759733`*^9}, {3.7020591128772287`*^9, 
   3.7020591601738358`*^9}, {3.7020592508055267`*^9, 3.702059257717101*^9}, {
   3.7027962785107155`*^9, 3.702796296162589*^9}, {3.7031824139499087`*^9, 
   3.7031824191396194`*^9}, 3.72607034795735*^9, {3.727686957345049*^9, 
   3.7276870211053066`*^9}, {3.727689367121029*^9, 
   3.7276893992564406`*^9}},ExpressionUUID->"671fcc6d-2302-4c17-b8a5-\
809b64789e1a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 3.534312862341494*^9}, {3.6933866240201435`*^9, 
   3.6933866247715487`*^9}, {3.6969244138622255`*^9, 3.6969244145023837`*^9}, 
   3.696935449737483*^9},ExpressionUUID->"468b1bac-5a18-4068-8ca1-\
bee7c0757e89"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"True", ",", "False", ",", "False", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
         RowBox[{"ch", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}],
             ",", "__"}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Lfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"t_", ",", 
              RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
              RowBox[{"op_", "?", "SuperoperatorQ"}]}], "]"}]}], ",", 
           "\[Tau]_"}], "}"}], ",", "evopts___Rule"}], "]"}]}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "nL", ",", "uvec", ",", "uvecflat", ",", "u", ",", "uvecplain", ",", 
       "NDSolveopts", ",", "sol", ",", "Uini", ",", "Lmatfunc"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"nL", "=", 
       RowBox[{
        RowBox[{"BasisDimension", " ", "[", "basis", "]"}], "^", "2"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"NDSolveopts", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"SimplifyRules", "[", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}], "]"}], ",", 
          RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lmatfunc", "=", 
       RowBox[{"Function", "[", 
        RowBox[{"t$", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"N", "[", 
           RowBox[{"SuperoperatorMatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"StandardizeGenerator", "[", 
              RowBox[{
               RowBox[{"Lfunc", "[", 
                RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"evopts", ",", "opts"}], "}"}]}], "]"}], ",", 
             "opbasis"}], "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvec", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvecflat", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"uvecplain", "=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", 
            RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Uini", "=", 
       RowBox[{"IdentityMatrix", "[", 
        RowBox[{
         RowBox[{"BasisDimension", "[", "]"}], "*", 
         RowBox[{"BasisDimension", "[", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sol", "=", 
       RowBox[{"NDSolveValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"uvecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
            "\[Equal]", 
            RowBox[{"(", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"Lmatfunc", "[", "t$", "]"}], ".", 
               RowBox[{"uvec", "[", "t$", "]"}]}], "]"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"uvecflat", "[", "ta", "]"}], "\[Equal]", 
            RowBox[{"Flatten", "[", "Uini", "]"}]}]}], "}"}], ",", 
         "uvecplain", ",", 
         RowBox[{"{", 
          RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"SparseArray", "[", 
         RowBox[{"Chop", "[", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Through", "[", 
              RowBox[{"#", "[", "tb", "]"}], "]"}], "&"}], "/@", "sol"}], 
           "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", "opbasis", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Options", "[", "Operator", "]"}]}], "\[IndentingNewLine]",
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.6969350964470854`*^9, 3.6969351569122*^9}, {3.6969352610516367`*^9, 
   3.6969353304596157`*^9}, {3.6972067590789723`*^9, 3.697206768375683*^9}, {
   3.697206854799367*^9, 3.6972068660663095`*^9}, {3.697206987497017*^9, 
   3.697206991999007*^9}, {3.6972071229179573`*^9, 3.69720713689812*^9}, {
   3.697207261562437*^9, 3.697207264211484*^9}, {3.6995987074071684`*^9, 
   3.6995987096449537`*^9}, {3.7020592627126703`*^9, 3.7020592927821164`*^9}, 
   3.7027963064458084`*^9, {3.703182439188919*^9, 3.7031824437697334`*^9}, 
   3.709375005011485*^9, {3.713606239042779*^9, 3.7136064297876887`*^9}, 
   3.713606546802104*^9, {3.7136066000971527`*^9, 3.71360660021144*^9}, {
   3.7172439374191437`*^9, 3.7172439445057535`*^9}, 3.717243976974216*^9, {
   3.71852183271072*^9, 3.718521832976372*^9}, 
   3.726070347975874*^9},ExpressionUUID->"b680dcca-b375-4880-ab81-\
201fc98d63ac"]
}, Closed]],

Cell[CellGroupData[{

Cell["adiabatic Hamiltonian", "Subsubsection",
 CellChangeTimes->{{3.7243985082780867`*^9, 
  3.7243985117386236`*^9}},ExpressionUUID->"17870f18-71f2-44fe-95e9-\
69a31b0c1618"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorPattern", "=", 
   RowBox[{
   "_Operator", "|", "\[IndentingNewLine]", "_opI", "|", "_opT", "|", "_opR", 
    "|", "\[IndentingNewLine]", "_ProjectionOperator", "|", "_ShiftOperator", 
    "|", "\[IndentingNewLine]", "_SpinExchangeOperator", "|", 
    "_SpinPermutationOperator", "|", "\[IndentingNewLine]", "_UnityOperator", 
    "|", "_NullOperator", "|", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{"___", ",", "_Ket", ",", "_Bra", ",", "___"}], "]"}]}], "|", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "_", "]"}], "/;", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
        ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"ifunc", "[", 
          RowBox[{"ifunc", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
          "]"}], ",", 
         RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692136600374*^9, 3.616692145047408*^9}, {
  3.621392418037315*^9, 3.621392439416339*^9}, {3.621507305473865*^9, 
  3.621507335264859*^9}, {3.642408669767378*^9, 
  3.642408672294594*^9}},ExpressionUUID->"1c00abb7-cab1-4329-8758-\
3e099767bc2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
     RowBox[{"ev", ":", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"{", 
              RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}], 
           ",", "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hfunc", ":", 
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"args__", ",", 
             RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "\[Tau]_"}], 
         "}"}], ",", "evopts___Rule"}], "]"}]}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], "/;", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}], "&&", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"PropagationMethod", "/.", 
          RowBox[{"{", "evopts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Event", "]"}]}], ")"}], ",", "Adiabatic"}], 
      "]"}]}], ")"}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "Hlist", ",", "Ht", ",", "\[Lambda]$", ",", "tloc", ",", "parametergrid",
       ",", "timegrid", ",", "evals", ",", "evecs", ",", "H\[Lambda]", ",", 
      "adiabaticparts", ",", "nonadiabaticparts", ",", "adiabaticfactor", ",",
       "adiabaticparameter", ",", "spinsys"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"spinsys", "=", 
       RowBox[{"SpinSystem", "[", "basis", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"timegrid", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", "_Integer", "}"}]}], "]"}], ",", 
            RowBox[{"ta", "+", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"tb", "-", "ta"}], ")"}], "/", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
              "*", 
              RowBox[{"Range", "[", 
               RowBox[{"0", ",", 
                RowBox[{
                "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}],
                "]"}]}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], "]"}], ",", 
            "#", ",", "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", "None"}], "]"}], ",", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Message", "[", 
               RowBox[{"NPropagate", "::", "noevsampling"}], "]"}], ";", 
              RowBox[{"Abort", "[", "]"}]}], ")"}]}], "]"}], "&"}], "@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"EventSampling", "/.", 
            RowBox[{"{", "evopts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Event", "]"}]}], ")"}]}], 
        "\[IndentingNewLine]", ")"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Ht", "=", 
       RowBox[{"Hfunc", "[", 
        RowBox[{"tloc", ",", "ta", ",", "tb"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Hlist", "=", 
       RowBox[{"Rest", "[", 
        RowBox[{"List", "@@", 
         RowBox[{"(", 
          RowBox[{"\"\<dummy\>\"", "+", 
           RowBox[{"ExpandAll", "[", "Ht", "]"}]}], ")"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"adiabaticparts", "=", 
       RowBox[{"Total", "@", 
        RowBox[{"Select", "[", 
         RowBox[{"Hlist", ",", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"FreeQ", "[", 
             RowBox[{"#", ",", "tloc"}], "]"}]}], "&"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"adiabaticparts", "=", 
       RowBox[{"Together", "[", 
        RowBox[{"Collect", "[", 
         RowBox[{"adiabaticparts", ",", "tloc"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"nonadiabaticparts", "=", 
       RowBox[{"Expand", "[", 
        RowBox[{
         RowBox[{"Total", "@", 
          RowBox[{"Select", "[", 
           RowBox[{"Hlist", ",", 
            RowBox[{
             RowBox[{"FreeQ", "[", 
              RowBox[{"#", ",", "tloc"}], "]"}], "&"}]}], "]"}]}], ",", 
         "OperatorPattern"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"adiabaticfactor", "=", 
       RowBox[{
        RowBox[{"First", "[", 
         RowBox[{"Rest", "[", 
          RowBox[{"List", "@@", 
           RowBox[{"(", 
            RowBox[{"\"\<dummy\>\"", "+", "adiabaticparts"}], ")"}]}], "]"}], 
         "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"k_.", "tloc", "*", 
           RowBox[{"_", "?", "OperatorQ"}]}], "\[RuleDelayed]", " ", 
          RowBox[{"k", " ", "tloc"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"adiabaticparameter", "=", 
       RowBox[{"First", "@", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"Flatten", "@", 
           RowBox[{"{", "adiabaticfactor", "}"}]}], ",", 
          RowBox[{"tloc", "*", "___"}], ",", "\[Infinity]"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"H\[Lambda]", "=", 
       RowBox[{"nonadiabaticparts", "+", 
        RowBox[{"(", 
         RowBox[{"adiabaticparts", "/.", 
          RowBox[{"{", 
           RowBox[{"adiabaticparameter", "\[Rule]", " ", "\[Lambda]$"}], 
           "}"}]}], ")"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"parametergrid", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"adiabaticparameter", "/.", 
           RowBox[{"{", 
            RowBox[{"tloc", "\[Rule]", " ", "#"}], "}"}]}], "&"}], ",", 
         "timegrid"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"evals", ",", "evecs"}], "}"}], "=", 
       RowBox[{"CorrelatedEigensystems", "[", 
        RowBox[{"H\[Lambda]", ",", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "\[Lambda]$", "}"}], ",", 
           RowBox[{"{", "parametergrid", "}"}]}], "]"}], ",", 
         RowBox[{"ReturnKets", "\[Rule]", " ", "False"}], ",", 
         RowBox[{"Basis", "\[Rule]", " ", 
          RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<1\>\"", ",", "\"\<4\>\""}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"AdiabaticPropagation", "[", 
       RowBox[{"\[Rho]", ",", 
        RowBox[{"Transpose", "[", "evals", "]"}], ",", "evecs", ",", 
        "parametergrid", ",", "timegrid", ",", "spinsys", ",", "evopts"}], 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.697140444116701*^9, 3.697140462292384*^9}, {3.6971405445462027`*^9, 
   3.697140544696862*^9}, {3.6971973737271624`*^9, 3.69719737390374*^9}, {
   3.697202021615039*^9, 3.6972020238340225`*^9}, {3.6972020570557203`*^9, 
   3.697202117681389*^9}, 3.697221917698621*^9, {3.6972248144891415`*^9, 
   3.697224840340124*^9}, {3.6972252791707563`*^9, 3.6972252793196115`*^9}, {
   3.6972255681826324`*^9, 3.697225577806399*^9}, {3.697226097137842*^9, 
   3.697226097303132*^9}, {3.699598661977907*^9, 3.69959867816735*^9}, {
   3.6996202579265976`*^9, 3.6996204249872246`*^9}, {3.6996204713364134`*^9, 
   3.69962051748325*^9}, {3.703925859591716*^9, 3.703925861438901*^9}, {
   3.7039259939064507`*^9, 3.7039259989330034`*^9}, {3.703926086278864*^9, 
   3.703926106327973*^9}, {3.7039261891539297`*^9, 3.703926191958609*^9}, {
   3.7039262531248555`*^9, 3.703926256383687*^9}, {3.703926345533207*^9, 
   3.703926370429733*^9}, {3.7053158198477182`*^9, 3.7053158224803786`*^9}, {
   3.7053158803022966`*^9, 3.7053158807291527`*^9}, {3.705315914179579*^9, 
   3.705315969108007*^9}, {3.7053160595880737`*^9, 3.705316059838215*^9}, 
   3.709375004992173*^9, {3.7106739228386073`*^9, 3.7106739267452507`*^9}, {
   3.7106740213468337`*^9, 3.7106740274773254`*^9}, {3.7106740881347055`*^9, 
   3.710674088603511*^9}, {3.710674216157911*^9, 3.7106742180331125`*^9}, {
   3.7106742832009473`*^9, 3.7106742988385363`*^9}, {3.710674599298673*^9, 
   3.7106745994549446`*^9}, {3.711713117442273*^9, 3.7117131229985*^9}, {
   3.7117132250453386`*^9, 3.711713226972962*^9}, {3.711713263346472*^9, 
   3.7117132661855965`*^9}, {3.711713310377756*^9, 3.711713325094843*^9}, {
   3.7117133667494164`*^9, 3.7117133669981146`*^9}, {3.711713712623698*^9, 
   3.711713716111786*^9}, {3.711713793424709*^9, 3.7117137936109395`*^9}, {
   3.7135496861821995`*^9, 3.713549689212953*^9}, {3.713549723213705*^9, 
   3.713549728022324*^9}, {3.7135498095071917`*^9, 3.713549858227291*^9}, {
   3.713549906927622*^9, 3.7135499251427593`*^9}, {3.713549975705491*^9, 
   3.713550009759675*^9}, {3.713550040459305*^9, 3.713550042069358*^9}, {
   3.713550093607289*^9, 3.71355011724572*^9}, {3.71355028220842*^9, 
   3.7135503316328273`*^9}, {3.7135506327797384`*^9, 3.713550636164564*^9}, {
   3.7135506694696245`*^9, 3.713550680954528*^9}, {3.713550729227113*^9, 
   3.713550729269661*^9}, {3.713550864210149*^9, 3.713550864350229*^9}, {
   3.719834178564801*^9, 3.7198342182956*^9}, {3.7198342591298513`*^9, 
   3.71983426212228*^9}, {3.7198344379183517`*^9, 3.719834438060452*^9}, {
   3.71983474692365*^9, 3.7198347552705545`*^9}, {3.7198349162362857`*^9, 
   3.7198349259361916`*^9}, {3.719835902168785*^9, 3.719835912635595*^9}, {
   3.719837363260993*^9, 3.719837401120681*^9}, {3.7198380338012857`*^9, 
   3.719838096233674*^9}, {3.7198381596906877`*^9, 3.7198382066327815`*^9}, {
   3.719838285229844*^9, 3.7198383505686855`*^9}, {3.71984725699461*^9, 
   3.71984726353093*^9}, {3.719847854401662*^9, 3.7198478959343123`*^9}, {
   3.7198480627173634`*^9, 3.719848110175911*^9}, {3.719848201511845*^9, 
   3.7198482214810925`*^9}, {3.7198484961249895`*^9, 3.71984853676762*^9}, {
   3.719848567174324*^9, 3.719848629626157*^9}, {3.7198486663330307`*^9, 
   3.719848725875139*^9}, {3.719848758744769*^9, 3.71984877274129*^9}, {
   3.719848803690339*^9, 3.7198488259367437`*^9}, {3.7198491927012024`*^9, 
   3.7198492146911564`*^9}, {3.719849277875124*^9, 3.719849312401941*^9}, {
   3.7198497432412825`*^9, 3.7198498397839737`*^9}, {3.7198498794429045`*^9, 
   3.7198499558225155`*^9}, {3.7198502326199183`*^9, 
   3.7198502513597665`*^9}, {3.7198503138783607`*^9, 
   3.7198503307746916`*^9}, {3.719853735703474*^9, 3.719853742525676*^9}, {
   3.7198539881110106`*^9, 3.719854014566058*^9}, {3.7198540534898005`*^9, 
   3.719854053670066*^9}, {3.7198541058205786`*^9, 3.7198541241257505`*^9}, {
   3.7198541672478137`*^9, 3.71985429144635*^9}, {3.7198543282115936`*^9, 
   3.7198543286457424`*^9}, {3.719854594872501*^9, 3.719854619873102*^9}, {
   3.719854730311737*^9, 3.719854731151331*^9}, {3.719865154123453*^9, 
   3.7198651572025647`*^9}, {3.719865213861537*^9, 3.7198652164709315`*^9}, {
   3.7198656690022197`*^9, 3.719865671147853*^9}, {3.719866736847063*^9, 
   3.7198667393664227`*^9}, {3.7198667969439144`*^9, 3.719866797764003*^9}, {
   3.7198670417045527`*^9, 3.719867052642288*^9}, {3.7198672416095734`*^9, 
   3.719867283742024*^9}, {3.7198674972585707`*^9, 3.7198674984677835`*^9}, 
   3.719867540865278*^9, {3.7198675749843464`*^9, 3.719867576355006*^9}, {
   3.7198676098786497`*^9, 3.7198676139043217`*^9}, {3.719868619055661*^9, 
   3.7198686363638*^9}, {3.7198690154847946`*^9, 3.7198690263729734`*^9}, {
   3.719869323600565*^9, 3.7198693279141006`*^9}, {3.719869434674337*^9, 
   3.719869537840701*^9}, {3.7198696018936567`*^9, 3.71986960587788*^9}, {
   3.7198701066188717`*^9, 3.7198701514741697`*^9}, {3.719870286129503*^9, 
   3.7198703194895906`*^9}, {3.724398628876827*^9, 3.724398629560452*^9}, {
   3.724400430678675*^9, 3.724400449251073*^9}, {3.7244006402745037`*^9, 
   3.72440064387794*^9}, {3.7244007755874023`*^9, 3.7244009511819057`*^9}, {
   3.724403233864699*^9, 3.724403267952813*^9}, {3.7244033304332495`*^9, 
   3.7244033750344334`*^9}, {3.724403758181954*^9, 3.7244038687014894`*^9}, {
   3.724403899255374*^9, 3.7244039947224436`*^9}, {3.7244093995103855`*^9, 
   3.7244094358043556`*^9}, {3.724409519650666*^9, 3.7244095308350005`*^9}, {
   3.7244095818622427`*^9, 3.724409614165449*^9}, 3.724409669466276*^9, {
   3.7244098201238985`*^9, 3.724409838970103*^9}, {3.724409962407166*^9, 
   3.724409962552285*^9}, {3.7250936643418293`*^9, 3.72509366690555*^9}, {
   3.725095101039919*^9, 3.7250951037606707`*^9}, {3.725619867896392*^9, 
   3.725619877433547*^9}, 3.7256485157835855`*^9, {3.7256498110968676`*^9, 
   3.725649876462432*^9}, {3.727552658728596*^9, 3.7275527245322914`*^9}, {
   3.7276167363521705`*^9, 3.727616738800909*^9}, {3.727616771932748*^9, 
   3.72761696771062*^9}, {3.727617015635168*^9, 3.727617021392274*^9}, {
   3.7276175448829956`*^9, 3.727617605463215*^9}, {3.727617796710438*^9, 
   3.7276178912470407`*^9}, {3.7276179314838457`*^9, 
   3.7276179614511023`*^9}, {3.7276180355675526`*^9, 
   3.7276180420561256`*^9}, {3.727618784707301*^9, 3.7276188295245733`*^9}, {
   3.7276188627012653`*^9, 3.7276188898277316`*^9}, {3.727618919973568*^9, 
   3.72761893164487*^9}, {3.7276189825499997`*^9, 3.727618986382707*^9}, {
   3.727619016997532*^9, 3.727619020435952*^9}, {3.7276191385743914`*^9, 
   3.727619232394865*^9}, {3.727619384056959*^9, 3.7276193863806133`*^9}, {
   3.7276194165623884`*^9, 3.727619416700507*^9}, {3.7276902748746223`*^9, 
   3.7276902757569666`*^9}, {3.7276906545906506`*^9, 
   3.7276906550619583`*^9}, {3.727691007514344*^9, 3.727691028241584*^9}, {
   3.727692235678416*^9, 3.72769224278785*^9}, {3.7276922904307227`*^9, 
   3.727692327148497*^9}, {3.7276924065886045`*^9, 3.72769241018244*^9}, {
   3.727692453276389*^9, 3.7276924595037813`*^9}, {3.7276925300276804`*^9, 
   3.727692532188744*^9}, {3.727692595450969*^9, 3.727692595810934*^9}, {
   3.72769263803528*^9, 3.727692688418024*^9}, 3.727692802806999*^9, {
   3.727694735596356*^9, 3.727694736729344*^9}, {3.7276949429736385`*^9, 
   3.7276949609203854`*^9}, {3.727696645693947*^9, 3.7276966500275116`*^9}, {
   3.7276966924833903`*^9, 3.727696717577179*^9}, {3.727696763197436*^9, 
   3.727696836212234*^9}, {3.7276968830734615`*^9, 3.7276968860833945`*^9}, {
   3.7276983711382647`*^9, 3.7276985439179783`*^9}, {3.7276999933311157`*^9, 
   3.727699996366204*^9}, {3.727700520467766*^9, 3.7277005206212997`*^9}, {
   3.7282165799175577`*^9, 3.728216581319909*^9}, {3.728216650594902*^9, 
   3.7282166656115665`*^9}, 3.7282166982524586`*^9, {3.728216747693061*^9, 
   3.7282167546810875`*^9}, {3.7282168666021605`*^9, 
   3.7282168697505417`*^9}, {3.728291129298119*^9, 3.728291164307745*^9}, {
   3.7282951212500887`*^9, 3.7282951280305433`*^9}, {3.728295264912354*^9, 
   3.7282952660167403`*^9}, {3.728304040067649*^9, 3.728304058850691*^9}, {
   3.7283041435391045`*^9, 3.728304196075467*^9}, {3.7283042867861423`*^9, 
   3.7283043210728955`*^9}, {3.728304709763626*^9, 3.72830471386293*^9}, {
   3.728304767763787*^9, 3.7283047703835526`*^9}, {3.7283048024796543`*^9, 
   3.728304861273641*^9}, {3.728305335980427*^9, 3.7283053864957933`*^9}, {
   3.72830543002634*^9, 3.7283054327493124`*^9}, {3.7283054743889294`*^9, 
   3.7283055448790026`*^9}, {3.72830557554852*^9, 3.728305599161726*^9}, {
   3.7283056385581627`*^9, 3.728305641373632*^9}, {3.728305844306919*^9, 
   3.7283058568127265`*^9}, {3.728306162251176*^9, 
   3.7283061914255147`*^9}},ExpressionUUID->"67fd8e74-abd2-410c-ae72-\
0c5aec5d8faf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"AdiabaticPropagation", "[", 
   RowBox[{
   "\[Rho]_", ",", "evals_", ",", "evecs_", ",", "parametergrid_", ",", 
    "timegrid_", ",", "spinsys_", ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\[Rho]mat", ",", "\[Rho]ini", ",", "coherencestatus", ",", "vini", ",", 
      "vfinal", ",", "nnzoffdiag", ",", "adiabaticstate", ",", "dim", ",", 
      "len", ",", "\[Phi]evecs", ",", "evalfuncs", ",", "evecfuncs", ",", 
      "dynamic\[Phi]", ",", "geometric\[Phi]", ",", "\[Phi]mat"}], "}"}], ",",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]mat", "=", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{"\[Rho]", ",", " ", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"DisableBuiltInModifications", "[", "Dot", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"coherencestatus", "=", 
      RowBox[{
       RowBox[{"DeleteCoherences", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Event", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"vini", "=", 
      RowBox[{"First", "[", "evecs", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"vfinal", "=", 
      RowBox[{"Last", "[", "evecs", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Rho]ini", "=", 
      RowBox[{"Chop", "[", 
       RowBox[{"vini", ".", "\[Rho]mat", ".", 
        RowBox[{"ConjugateTranspose", "[", "vini", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"dim", "=", 
      RowBox[{"Length", "[", "vfinal", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"coherencestatus", ",", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"adiabaticstate", "=", 
          RowBox[{"SparseArray", "@", 
           RowBox[{"Fold", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Chop", "[", 
               RowBox[{"Dot", "[", 
                RowBox[{"#2", ",", "#1"}], "]"}], "]"}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Flatten", "[", "\[Rho]ini", "]"}], ",", 
               RowBox[{"DiagonalMatrix", "[", 
                RowBox[{"Flatten", "@", 
                 RowBox[{"IdentityMatrix", "[", 
                  RowBox[{"dim", ",", "SparseArray"}], "]"}]}], "]"}], ",", 
               RowBox[{"ConjugateTranspose", "[", 
                RowBox[{"KroneckerProduct", "[", 
                 RowBox[{
                  RowBox[{"Conjugate", "[", "vfinal", "]"}], ",", "vfinal"}], 
                 "]"}], "]"}]}], "}"}]}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ReenableBuiltInModifications", "[", "Dot", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"ArrayReshape", "[", 
            RowBox[{"adiabaticstate", ",", 
             RowBox[{"{", 
              RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], ",", 
           RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
           RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
           RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}]}], "]"}]}], 
        "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"nnzoffdiag", "=", 
          RowBox[{"Union", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"SparseArray", "[", 
              RowBox[{"Chop", "@", 
               RowBox[{"UpperTriangularize", "[", 
                RowBox[{"\[Rho]ini", ",", "1"}], "]"}]}], "]"}], "[", 
             "\"\<NonzeroPositions\>\"", "]"}], ")"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"nnzoffdiag", "\[Equal]", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"adiabaticstate", "=", 
              RowBox[{"SparseArray", "@", 
               RowBox[{"Fold", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Chop", "[", 
                   RowBox[{"Dot", "[", 
                    RowBox[{"#2", ",", "#1"}], "]"}], "]"}], "&"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Flatten", "[", "\[Rho]ini", "]"}], ",", 
                   RowBox[{"DiagonalMatrix", "[", 
                    RowBox[{"Flatten", "@", 
                    RowBox[{"IdentityMatrix", "[", 
                    RowBox[{"dim", ",", "SparseArray"}], "]"}]}], "]"}], ",", 
                   
                   RowBox[{"ConjugateTranspose", "[", 
                    RowBox[{"KroneckerProduct", "[", 
                    RowBox[{
                    RowBox[{"Conjugate", "[", "vfinal", "]"}], ",", 
                    "vfinal"}], "]"}], "]"}]}], "}"}]}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"ReenableBuiltInModifications", "[", "Dot", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Operator", "[", 
              RowBox[{
               RowBox[{"ArrayReshape", "[", 
                RowBox[{"adiabaticstate", ",", 
                 RowBox[{"{", 
                  RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], ",", 
               RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
               RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
               RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}]}], 
              "]"}]}], "\[IndentingNewLine]", ")"}], "\[IndentingNewLine]", 
           ",", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\[Phi]evecs", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"phasesmoothing", "[", 
                 RowBox[{
                  RowBox[{"SparseArray", "/@", "#"}], ",", "0"}], "]"}], 
                "&"}], "/@", 
               RowBox[{"Transpose", "[", "evecs", "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"vini", "=", 
              RowBox[{"SparseArray", "[", 
               RowBox[{"Chop", "[", 
                RowBox[{"\[Phi]evecs", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"vfinal", "=", 
              RowBox[{"SparseArray", "[", 
               RowBox[{"Chop", "[", 
                RowBox[{"\[Phi]evecs", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", 
                  RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"evalfuncs", "=", 
              RowBox[{
               RowBox[{
                RowBox[{"Interpolation", "[", 
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"timegrid", ",", "#"}], "}"}], "]"}], "]"}], "&"}],
                "/@", 
               RowBox[{"(", 
                RowBox[{
                "evals", "\[LeftDoubleBracket]", "nnzoffdiag", 
                 "\[RightDoubleBracket]"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"len", "=", 
              RowBox[{"Length", "[", "nnzoffdiag", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"dynamic\[Phi]", "=", 
              RowBox[{"dynamicphase", "[", 
               RowBox[{"evalfuncs", ",", "len", ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"First", "[", "timegrid", "]"}], ",", 
                  RowBox[{"Last", "[", "timegrid", "]"}]}], "}"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"\[Phi]mat", "=", 
              RowBox[{"Chop", "@", 
               RowBox[{"SparseArray", "[", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{"Thread", "[", 
                   RowBox[{"nnzoffdiag", "\[Rule]", "dynamic\[Phi]"}], "]"}], 
                  ",", 
                  RowBox[{"Thread", "[", 
                   RowBox[{
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "dim", "]"}], ",", "nnzoffdiag"}], 
                    "]"}], "\[Rule]", " ", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"1", ",", 
                    RowBox[{"dim", "-", "len"}]}], "]"}]}], "]"}]}], "]"}], 
                "]"}]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Union", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Internal`RealValuedNumericQ", "[", 
                    RowBox[{"Chop", "@", "#"}], "]"}], "&"}], "/@", 
                  RowBox[{"Flatten", "@", 
                   RowBox[{"Normal", "[", "\[Phi]evecs", "]"}]}]}], "]"}], 
                "\[Equal]", 
                RowBox[{"{", "True", "}"}]}], ",", 
               RowBox[{"(", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"adiabaticstate", "=", 
                  RowBox[{"SparseArray", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"#", ".", "\[Rho]mat", ".", 
                    RowBox[{"ConjugateTranspose", "[", "#", "]"}]}], "&"}], 
                    "@", 
                    RowBox[{"(", 
                    RowBox[{"Chop", "[", 
                    RowBox[{
                    RowBox[{"Transpose", "[", "vfinal", "]"}], ".", 
                    RowBox[{"DiagonalMatrix", "[", "\[Phi]mat", "]"}], ".", 
                    RowBox[{"Conjugate", "[", "vini", "]"}]}], "]"}], ")"}]}],
                    "]"}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"ReenableBuiltInModifications", "[", "Dot", "]"}], 
                 ";", "\[IndentingNewLine]", 
                 RowBox[{"Operator", "[", 
                  RowBox[{"adiabaticstate", ",", 
                   RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
                   RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                   RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}]}], 
                  "]"}]}], "\[IndentingNewLine]", ")"}], ",", 
               RowBox[{"(", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"evecfuncs", "=", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Interpolation", "[", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{"{", 
                    RowBox[{"parametergrid", ",", "#"}], "}"}], "]"}], "]"}], 
                    "&"}], "/@", "\[Phi]evecs"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"geometric\[Phi]", "=", 
                  RowBox[{"geometricphase", "[", 
                   RowBox[{"evecfuncs", ",", "len", ",", "parametergrid"}], 
                   "]"}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"\[Phi]mat", "=", 
                  RowBox[{"Chop", "@", 
                   RowBox[{"SparseArray", "[", 
                    RowBox[{
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{
                    RowBox[{"Outer", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"#1", ",", "#2"}], "}"}], "&"}], ",", 
                    "nnzoffdiag", ",", "nnzoffdiag"}], "]"}], ",", "1"}], 
                    "]"}], "\[Rule]", " ", 
                    RowBox[{"Flatten", "[", 
                    RowBox[{"Outer", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"#1", "*", 
                    RowBox[{"Conjugate", "[", "#2", "]"}]}], "&"}], ",", 
                    RowBox[{"geometric\[Phi]", "*", "dynamic\[Phi]"}], ",", 
                    RowBox[{"geometric\[Phi]", "*", "dynamic\[Phi]"}]}], 
                    "]"}], "]"}]}], "]"}], ",", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"Transpose", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"#", ",", "#"}], "}"}], "&"}], "@", 
                    RowBox[{"Complement", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", "dim", "]"}], ",", "nnzoffdiag"}], 
                    "]"}]}], ")"}], "]"}], "\[Rule]", " ", 
                    RowBox[{"ConstantArray", "[", 
                    RowBox[{"1", ",", 
                    RowBox[{"dim", "-", "len"}]}], "]"}]}], "]"}]}], "]"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"adiabaticstate", "=", 
                  RowBox[{"SparseArray", "@", 
                   RowBox[{"ArrayReshape", "[", 
                    RowBox[{
                    RowBox[{"Fold", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{"Dot", "[", 
                    RowBox[{"#2", ",", "#1"}], "]"}], "]"}], "&"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Flatten", "[", "\[Rho]mat", "]"}], ",", 
                    RowBox[{"KroneckerProduct", "[", 
                    RowBox[{
                    RowBox[{"Conjugate", "[", "vini", "]"}], ",", "vini"}], 
                    "]"}], ",", 
                    RowBox[{"DiagonalMatrix", "@", 
                    RowBox[{"Flatten", "[", "\[Phi]mat", "]"}]}], ",", 
                    RowBox[{"ConjugateTranspose", "[", 
                    RowBox[{"KroneckerProduct", "[", 
                    RowBox[{
                    RowBox[{"Conjugate", "[", "vfinal", "]"}], ",", 
                    "vfinal"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}]}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"ReenableBuiltInModifications", "[", "Dot", "]"}], 
                 ";", "\[IndentingNewLine]", 
                 RowBox[{"Operator", "[", 
                  RowBox[{"adiabaticstate", ",", 
                   RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
                   RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                   RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}]}], 
                  "]"}]}], "\[IndentingNewLine]", ")"}]}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.719509949881374*^9, 3.719509955360538*^9}, {3.7195099911585712`*^9, 
   3.719510015858719*^9}, {3.719510081278159*^9, 3.719510123245468*^9}, {
   3.7195101582771163`*^9, 3.7195101743030853`*^9}, {3.7195728309788957`*^9, 
   3.71957283207837*^9}, {3.7195806730673275`*^9, 3.7195807016100216`*^9}, {
   3.7195808162981496`*^9, 3.719580913885115*^9}, {3.719580993830267*^9, 
   3.7195809966487484`*^9}, {3.7195810323424673`*^9, 
   3.7195810617786107`*^9}, {3.7195813593589625`*^9, 
   3.7195813613492365`*^9}, {3.7195814497819195`*^9, 
   3.7195815461095095`*^9}, {3.719581613984631*^9, 3.7195816626140347`*^9}, {
   3.719581724777997*^9, 3.7195817296840253`*^9}, {3.7195818819558363`*^9, 
   3.719581882124288*^9}, {3.7195823274581537`*^9, 3.7195823460665197`*^9}, {
   3.719582409446633*^9, 3.7195824134053535`*^9}, {3.7195824792340565`*^9, 
   3.7195824822812386`*^9}, {3.7195828635895777`*^9, 
   3.7195828924139986`*^9}, {3.7195829269566307`*^9, 
   3.7195829532947245`*^9}, {3.71958299115474*^9, 3.7195829917954297`*^9}, {
   3.719650296848384*^9, 3.719650308133438*^9}, {3.7196504225780315`*^9, 
   3.719650424620702*^9}, {3.719652319312585*^9, 3.7196524461663632`*^9}, {
   3.7196524978605967`*^9, 3.719652508809775*^9}, {3.7196525395284863`*^9, 
   3.719652547897547*^9}, {3.7196528468155484`*^9, 3.719652847299777*^9}, {
   3.7196532595132093`*^9, 3.7196532674214735`*^9}, {3.719653362110983*^9, 
   3.719653378419673*^9}, {3.719654054944502*^9, 3.7196540566830025`*^9}, {
   3.719660855119031*^9, 3.7196609163387403`*^9}, 3.719661039517068*^9, {
   3.719661258620204*^9, 3.719661260732663*^9}, {3.7196612911457825`*^9, 
   3.719661296996229*^9}, {3.7196613406830535`*^9, 3.7196613408428507`*^9}, {
   3.7196614001790295`*^9, 3.7196614100815372`*^9}, {3.7196614745975285`*^9, 
   3.7196616224789314`*^9}, 3.7196616730674644`*^9, {3.719662253183296*^9, 
   3.719662260991962*^9}, {3.7196626236919546`*^9, 3.719662626240038*^9}, {
   3.7196640986100135`*^9, 3.7196640987899456`*^9}, {3.7196653083995004`*^9, 
   3.7196653270673437`*^9}, {3.7197361232513204`*^9, 3.719736131731452*^9}, {
   3.719736165278569*^9, 3.7197361683107443`*^9}, {3.7197541213838997`*^9, 
   3.719754122263048*^9}, {3.7197553768166027`*^9, 3.719755404745654*^9}, {
   3.719755469835614*^9, 3.7197555131743255`*^9}, {3.719756775607588*^9, 
   3.7197567929579597`*^9}, {3.7197574964274406`*^9, 
   3.7197575136375628`*^9}, {3.719849412895503*^9, 3.719849415075869*^9}, 
   3.7198497350087547`*^9, {3.719849802627084*^9, 3.7198498724042935`*^9}, {
   3.7198499091852665`*^9, 3.71984991094554*^9}, {3.719849964135952*^9, 
   3.719850024375903*^9}, {3.719850076041487*^9, 3.7198501131781673`*^9}, {
   3.7198503333992615`*^9, 3.719850373410698*^9}, {3.7198504351991343`*^9, 
   3.719850467914399*^9}, {3.719850535535207*^9, 3.7198505835630226`*^9}, {
   3.719850620668212*^9, 3.7198506244186845`*^9}, {3.7198539791170464`*^9, 
   3.7198539809908905`*^9}, {3.719854269327776*^9, 3.7198542884192467`*^9}, {
   3.7198543220229406`*^9, 3.719854402037223*^9}, {3.719854433177989*^9, 
   3.7198545301553464`*^9}, {3.719854589935975*^9, 3.719854590105302*^9}, {
   3.719854705134689*^9, 3.7198547195256615`*^9}, {3.719854797306077*^9, 
   3.719854808633321*^9}, {3.719854841183943*^9, 3.7198548753019934`*^9}, {
   3.719857100062153*^9, 3.7198571015885577`*^9}, {3.7198632833626337`*^9, 
   3.7198634093923235`*^9}, {3.719864952877826*^9, 3.719865048988531*^9}, {
   3.7198651216653557`*^9, 3.7198651244155855`*^9}, {3.7198651639858837`*^9, 
   3.7198651686853933`*^9}, {3.719865219154601*^9, 3.7198652382823625`*^9}, {
   3.719865286151684*^9, 3.7198652968406925`*^9}, {3.7198656754793634`*^9, 
   3.7198656783896074`*^9}, {3.7198658468563027`*^9, 3.719865848184952*^9}, {
   3.719865879599521*^9, 3.7198658811047196`*^9}, {3.719865928977817*^9, 
   3.719865930822669*^9}, {3.7198659624324164`*^9, 3.719865964160949*^9}, {
   3.7198662158790236`*^9, 3.7198662212336826`*^9}, {3.71986629788312*^9, 
   3.719866302612194*^9}, {3.719866751420399*^9, 3.719866767847307*^9}, {
   3.7198668010572467`*^9, 3.71986680407716*^9}, 3.7198668772461185`*^9, {
   3.719866912419749*^9, 3.7198669512723083`*^9}, {3.7198670006160674`*^9, 
   3.719867006271598*^9}, {3.7198671841526933`*^9, 3.7198671898856*^9}, {
   3.719867634226836*^9, 3.7198676367270055`*^9}, {3.71986768433274*^9, 
   3.7198676989615884`*^9}, {3.7198678491186857`*^9, 3.719867895797181*^9}, {
   3.7198679276394434`*^9, 3.71986798213573*^9}, {3.7198681329697065`*^9, 
   3.71986813623975*^9}, {3.719868205270544*^9, 3.7198682076892986`*^9}, {
   3.71986847697985*^9, 3.719868533217661*^9}, {3.719868575622864*^9, 
   3.719868582459591*^9}, {3.719868886978547*^9, 3.719868937941128*^9}, {
   3.7198689999937105`*^9, 3.719869009316838*^9}, {3.719870590112663*^9, 
   3.7198705974799423`*^9}, {3.7244010199334164`*^9, 
   3.7244010704234023`*^9}, {3.724401823661557*^9, 3.7244018288036685`*^9}, {
   3.7244093401710606`*^9, 3.7244093932742825`*^9}, 3.7244099280633774`*^9, {
   3.7244105444314685`*^9, 3.7244105463085685`*^9}, {3.724410684068492*^9, 
   3.7244107093649344`*^9}, {3.7244120854248667`*^9, 
   3.7244120855650244`*^9}, {3.7250921152956724`*^9, 3.725092133119255*^9}, {
   3.7250921883763275`*^9, 3.7250922621927547`*^9}, {3.7250929939839354`*^9, 
   3.7250930237134376`*^9}, {3.7250933677173767`*^9, 3.725093405780649*^9}, {
   3.7250934677644277`*^9, 3.725093474798849*^9}, {3.725093670191753*^9, 
   3.7250936824660716`*^9}, {3.7250937924526234`*^9, 3.725093804961076*^9}, {
   3.725093840257736*^9, 3.7250938987948437`*^9}, {3.7250939388065586`*^9, 
   3.7250939670592403`*^9}, {3.725094003537917*^9, 3.725094153122783*^9}, {
   3.7250942301682224`*^9, 3.725094264056585*^9}, {3.7250943213753557`*^9, 
   3.7250943915528173`*^9}, {3.7250944710583444`*^9, 
   3.7250944881567526`*^9}, {3.72509636742293*^9, 3.7250963677549734`*^9}, {
   3.725651022944096*^9, 3.7256510682213335`*^9}, {3.727684356763255*^9, 
   3.7276843838972683`*^9}, {3.72768443851217*^9, 3.7276844466848526`*^9}, {
   3.7276903223829193`*^9, 3.7276903235955987`*^9}, {3.727690651182001*^9, 
   3.7276906521009846`*^9}, {3.7276906942281713`*^9, 
   3.7276907025170135`*^9}, {3.7276908124530573`*^9, 
   3.7276908339482803`*^9}, {3.727690976790086*^9, 3.727690978109798*^9}, {
   3.727691042245057*^9, 3.7276910616094055`*^9}, {3.7276912499814444`*^9, 
   3.7276912948752327`*^9}, {3.7276913294402227`*^9, 3.727691331400116*^9}, {
   3.727691361709403*^9, 3.727691414457391*^9}, {3.727691458559002*^9, 
   3.727691475148548*^9}, {3.7276916773423033`*^9, 3.727691727769785*^9}, {
   3.7276917659039717`*^9, 3.727691768832173*^9}, {3.7276918094003277`*^9, 
   3.727691829184857*^9}, {3.7276919596959577`*^9, 3.72769200838623*^9}, {
   3.7276920748755836`*^9, 3.7276920906753187`*^9}, {3.7276925729245443`*^9, 
   3.7276925923552494`*^9}, {3.7276947407025995`*^9, 
   3.7276947415545697`*^9}, {3.7276948203348155`*^9, 
   3.7276948225248775`*^9}, {3.7276949371284904`*^9, 
   3.7276949650454345`*^9}, {3.727695065860903*^9, 3.727695070627157*^9}, {
   3.7276951083252172`*^9, 3.72769515288236*^9}, {3.7276952127561636`*^9, 
   3.727695263674076*^9}, {3.727695318404736*^9, 3.7276953203992634`*^9}, {
   3.727695350555456*^9, 3.7276954096732283`*^9}, {3.7276954893148947`*^9, 
   3.727695500442851*^9}, {3.7276955374263177`*^9, 3.727695587010742*^9}, {
   3.727695632802051*^9, 3.7276956690238304`*^9}, {3.7276958266935053`*^9, 
   3.727695881730651*^9}, {3.7276959318731723`*^9, 3.7276960116002054`*^9}, {
   3.7276961014998417`*^9, 3.7276961874989524`*^9}, {3.727696253310564*^9, 
   3.727696254859567*^9}, {3.7276962941024046`*^9, 3.7276963234865694`*^9}, {
   3.7276986271523094`*^9, 3.7276986772944055`*^9}, {3.7276987974279613`*^9, 
   3.7276988555243998`*^9}, {3.7276990349787927`*^9, 3.72769903784057*^9}, {
   3.727699076873084*^9, 3.727699078728146*^9}, {3.7276993351912966`*^9, 
   3.7276993355686874`*^9}, {3.7276994433900356`*^9, 3.727699515712261*^9}, {
   3.727699845635069*^9, 3.727699845957946*^9}, {3.727700203546064*^9, 
   3.727700207826151*^9}, {3.7277002809375763`*^9, 3.727700320667672*^9}, {
   3.72770041402392*^9, 3.7277005096534233`*^9}, {3.7277006869997535`*^9, 
   3.7277006936249313`*^9}, {3.7277072278163443`*^9, 
   3.7277072306973534`*^9}, {3.7281249327269382`*^9, 3.7281249591274843`*^9}, 
   3.72812615035713*^9, {3.7281261973045006`*^9, 3.7281261973080106`*^9}, {
   3.728291188587981*^9, 3.7282911908379865`*^9}, {3.7282949938668747`*^9, 
   3.728295012075678*^9}, {3.728295045521916*^9, 
   3.728295119176612*^9}},ExpressionUUID->"2cce5ccf-76fb-485a-a54e-\
8aa92c489832"],

Cell[BoxData[
 RowBox[{
  RowBox[{"phasesmoothing", "[", 
   RowBox[{"set_", ",", "X_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"len", ",", "\[Delta]\[Phi]"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"FoldList", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Exp", "[", 
         RowBox[{
          RowBox[{"-", "I"}], "*", 
          RowBox[{"Arg", "[", 
           RowBox[{"Chop", "[", 
            RowBox[{
             RowBox[{"Conjugate", "[", "#1", "]"}], ".", "#2"}], "]"}], 
           "]"}]}], "]"}], "*", "#2"}], "&"}], ",", 
      RowBox[{"First", "[", "set", "]"}], ",", 
      RowBox[{"Rest", "[", "set", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.719509949881374*^9, 3.719509955360538*^9}, {3.7195099911585712`*^9, 
   3.719510015858719*^9}, {3.719510081278159*^9, 3.719510123245468*^9}, {
   3.7195101582771163`*^9, 3.7195101743030853`*^9}, {3.7195728309788957`*^9, 
   3.71957283207837*^9}, {3.7195806730673275`*^9, 3.7195807016100216`*^9}, {
   3.7195808162981496`*^9, 3.719580913885115*^9}, {3.719580993830267*^9, 
   3.7195809966487484`*^9}, {3.7195810323424673`*^9, 
   3.7195810617786107`*^9}, {3.7195813593589625`*^9, 
   3.7195813613492365`*^9}, {3.7195814497819195`*^9, 
   3.7195815461095095`*^9}, {3.719581613984631*^9, 3.7195816626140347`*^9}, {
   3.719581724777997*^9, 3.7195817296840253`*^9}, {3.7195818819558363`*^9, 
   3.719581882124288*^9}, {3.7195823274581537`*^9, 3.7195823460665197`*^9}, {
   3.719582409446633*^9, 3.7195824134053535`*^9}, {3.7195824792340565`*^9, 
   3.7195824822812386`*^9}, {3.7195828635895777`*^9, 
   3.7195828924139986`*^9}, {3.7195829269566307`*^9, 
   3.7195829532947245`*^9}, {3.71958299115474*^9, 3.7195829917954297`*^9}, {
   3.719650296848384*^9, 3.719650308133438*^9}, {3.7196504225780315`*^9, 
   3.719650424620702*^9}, {3.719652319312585*^9, 3.7196524461663632`*^9}, {
   3.7196524978605967`*^9, 3.719652508809775*^9}, {3.7196525395284863`*^9, 
   3.719652547897547*^9}, {3.7196528468155484`*^9, 3.719652847299777*^9}, {
   3.7196532595132093`*^9, 3.7196532674214735`*^9}, {3.719653362110983*^9, 
   3.719653378419673*^9}, {3.719654054944502*^9, 3.7196540566830025`*^9}, {
   3.719660855119031*^9, 3.7196609163387403`*^9}, 3.719661039517068*^9, {
   3.719661258620204*^9, 3.719661260732663*^9}, {3.7196612911457825`*^9, 
   3.719661296996229*^9}, {3.7196613406830535`*^9, 3.7196613408428507`*^9}, {
   3.7196614001790295`*^9, 3.7196614100815372`*^9}, {3.7196614745975285`*^9, 
   3.7196616224789314`*^9}, 3.7196616730674644`*^9, {3.719662253183296*^9, 
   3.719662260991962*^9}, {3.7196626236919546`*^9, 3.719662626240038*^9}, {
   3.7196640986100135`*^9, 3.7196640987899456`*^9}, {3.7196653083995004`*^9, 
   3.7196653270673437`*^9}, {3.7197361232513204`*^9, 3.719736131731452*^9}, {
   3.719736165278569*^9, 3.7197361683107443`*^9}, {3.7197541213838997`*^9, 
   3.719754122263048*^9}, {3.7197553768166027`*^9, 3.719755404745654*^9}, {
   3.719755469835614*^9, 3.7197555131743255`*^9}, {3.719756775607588*^9, 
   3.7197567929579597`*^9}, {3.7197574964274406`*^9, 
   3.7197575136375628`*^9}, {3.719868404457266*^9, 
   3.719868422104998*^9}},ExpressionUUID->"19acfb9c-ea92-4218-82fd-\
38b47fabe8ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{"dynamicphase", "[", 
   RowBox[{"funcs_", ",", "len_", ",", 
    RowBox[{"{", 
     RowBox[{"ta_", ",", "tb_"}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\[Phi]", ",", "\[Phi]dyn", ",", "\[Phi]dynplain", ",", "\[Phi]dynini", 
      ",", "sol"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Phi]dyn", "[", "t$_", "]"}], ":=", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"Array", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"\[Phi]", "[", "#", "]"}], "[", "t$", "]"}], "&"}], ",", 
         "len"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Phi]dynplain", "=", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"Array", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Phi]", "[", "#", "]"}], "&"}], ",", "len"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Phi]dynini", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", "len"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sol", "=", 
      RowBox[{"Through", "[", 
       RowBox[{
        RowBox[{"NDSolveValue", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{"\[Phi]dyn", "[", "t$", "]"}], ",", "t$"}], "]"}], 
             "\[Equal]", 
             RowBox[{"Through", "[", 
              RowBox[{"funcs", "[", "t$", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"\[Phi]dyn", "[", "ta", "]"}], "\[Equal]", 
             "\[Phi]dynini"}]}], "}"}], ",", "\[Phi]dynplain", ",", 
          RowBox[{"{", 
           RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}]}], "]"}], "[", "tb", 
        "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "I"}], "*", 
       RowBox[{"Re", "@", 
        RowBox[{"Chop", "[", "sol", "]"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.719509949881374*^9, 3.719509955360538*^9}, {3.7195099911585712`*^9, 
   3.719510015858719*^9}, {3.719510081278159*^9, 3.719510123245468*^9}, {
   3.7195101582771163`*^9, 3.7195101743030853`*^9}, {3.7195728309788957`*^9, 
   3.71957283207837*^9}, {3.7195806730673275`*^9, 3.7195807016100216`*^9}, {
   3.7195808162981496`*^9, 3.719580913885115*^9}, {3.719580993830267*^9, 
   3.7195809966487484`*^9}, {3.7195810323424673`*^9, 
   3.7195810617786107`*^9}, {3.7195813593589625`*^9, 
   3.7195813613492365`*^9}, {3.7195814497819195`*^9, 
   3.7195815461095095`*^9}, {3.719581613984631*^9, 3.7195816626140347`*^9}, {
   3.719581724777997*^9, 3.7195817296840253`*^9}, {3.7195818819558363`*^9, 
   3.719581882124288*^9}, {3.7195823274581537`*^9, 3.7195823460665197`*^9}, {
   3.719582409446633*^9, 3.7195824134053535`*^9}, {3.7195824792340565`*^9, 
   3.7195824822812386`*^9}, {3.7195828635895777`*^9, 
   3.7195828924139986`*^9}, {3.7195829269566307`*^9, 
   3.7195829532947245`*^9}, {3.71958299115474*^9, 3.7195829917954297`*^9}, {
   3.719650296848384*^9, 3.719650308133438*^9}, {3.7196504225780315`*^9, 
   3.719650424620702*^9}, {3.719652319312585*^9, 3.7196524461663632`*^9}, {
   3.7196524978605967`*^9, 3.719652508809775*^9}, {3.7196525395284863`*^9, 
   3.719652547897547*^9}, {3.7196528468155484`*^9, 3.719652847299777*^9}, {
   3.7196532595132093`*^9, 3.7196532674214735`*^9}, {3.719653362110983*^9, 
   3.719653378419673*^9}, {3.719654054944502*^9, 3.7196540566830025`*^9}, {
   3.719660855119031*^9, 3.7196609163387403`*^9}, 3.719661039517068*^9, {
   3.719661258620204*^9, 3.719661260732663*^9}, {3.7196612911457825`*^9, 
   3.719661296996229*^9}, {3.7196613406830535`*^9, 3.7196613408428507`*^9}, {
   3.7196614001790295`*^9, 3.7196614100815372`*^9}, {3.7196614745975285`*^9, 
   3.7196616224789314`*^9}, 3.7196616730674644`*^9, {3.719662253183296*^9, 
   3.719662260991962*^9}, {3.7196626236919546`*^9, 3.719662626240038*^9}, {
   3.7196640986100135`*^9, 3.7196640987899456`*^9}, {3.7196653083995004`*^9, 
   3.7196653270673437`*^9}, {3.719677149328948*^9, 3.7196772681782894`*^9}, {
   3.719677298977812*^9, 3.7196773064080453`*^9}, {3.719677379158373*^9, 
   3.719677412126779*^9}, {3.7196774889061594`*^9, 3.7196774968762045`*^9}, {
   3.719749728512291*^9, 3.7197497324436016`*^9}, 3.7197499105714655`*^9, {
   3.7197566245908966`*^9, 3.7197566253319597`*^9}, {3.719756934476138*^9, 
   3.7197569472056074`*^9}, {3.719757392672373*^9, 3.719757441148217*^9}, {
   3.7197575170283084`*^9, 3.7197575171776314`*^9}, 3.719830215686408*^9, {
   3.7198501414091578`*^9, 3.719850168907319*^9}, {3.719850477404865*^9, 
   3.719850518636217*^9}, {3.7198638446770105`*^9, 3.71986385259356*^9}, {
   3.7198638849782605`*^9, 3.719863885117324*^9}, {3.7198650288650026`*^9, 
   3.719865055162945*^9}, {3.7198659751871552`*^9, 3.7198659817570167`*^9}, {
   3.719870534789034*^9, 
   3.719870548087632*^9}},ExpressionUUID->"40d68d5f-fc66-4132-b2b0-\
a75308cb373b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"geometricphase", "[", 
   RowBox[{"funcs_", ",", "len_", ",", "\[Lambda]vals_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\[Lambda]a", ",", "\[Lambda]b", ",", "scalarfuncs", ",", "\[Phi]", ",", 
      "\[Phi]geo", ",", "\[Phi]geoplain", ",", "\[Phi]geoini", ",", "sol"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Lambda]a", ",", "\[Lambda]b"}], "}"}], "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"First", "[", "\[Lambda]vals", "]"}], ",", 
        RowBox[{"Last", "[", "\[Lambda]vals", "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"scalarfuncs", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Interpolation", "[", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]vals", ",", 
            RowBox[{"Chop", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Im", "[", 
                RowBox[{
                 RowBox[{"Conjugate", "[", 
                  RowBox[{
                   RowBox[{
                   "funcs", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}], "[", "#", "]"}], "]"}], ".", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                   "funcs", "\[LeftDoubleBracket]", "j", 
                    "\[RightDoubleBracket]"}], "'"}], "[", "#", "]"}]}], 
                "]"}], "&"}], "/@", "\[Lambda]vals"}], "]"}]}], "}"}], "]"}], 
         "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Range", "[", "len", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\[Phi]geo", "[", "\[Lambda]$_", "]"}], ":=", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"Array", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"\[Phi]", "[", "#", "]"}], "[", "\[Lambda]$", "]"}], "&"}],
          ",", "len"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Phi]geoplain", "=", 
      RowBox[{"Evaluate", "[", 
       RowBox[{"Array", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Phi]", "[", "#", "]"}], "&"}], ",", "len"}], "]"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"\[Phi]geoini", "=", 
      RowBox[{"ConstantArray", "[", 
       RowBox[{"0", ",", "len"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sol", "=", 
      RowBox[{"Through", "[", 
       RowBox[{
        RowBox[{"NDSolveValue", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{"\[Phi]geo", "[", "\[Lambda]$", "]"}], ",", 
               "\[Lambda]$"}], "]"}], "\[Equal]", 
             RowBox[{"Through", "[", 
              RowBox[{"scalarfuncs", "[", "\[Lambda]$", "]"}], "]"}]}], ",", 
            RowBox[{
             RowBox[{"\[Phi]geo", "[", "\[Lambda]a", "]"}], "\[Equal]", 
             "\[Phi]geoini"}]}], "}"}], ",", "\[Phi]geoplain", ",", 
          RowBox[{"{", 
           RowBox[{"\[Lambda]$", ",", "\[Lambda]a", ",", "\[Lambda]b"}], 
           "}"}]}], "]"}], "[", "\[Lambda]b", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "I"}], "*", 
       RowBox[{"Re", "@", 
        RowBox[{"Chop", "[", "sol", "]"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.719509949881374*^9, 3.719509955360538*^9}, {3.7195099911585712`*^9, 
   3.719510015858719*^9}, {3.719510081278159*^9, 3.719510123245468*^9}, {
   3.7195101582771163`*^9, 3.7195101743030853`*^9}, {3.7195728309788957`*^9, 
   3.71957283207837*^9}, {3.7195806730673275`*^9, 3.7195807016100216`*^9}, {
   3.7195808162981496`*^9, 3.719580913885115*^9}, {3.719580993830267*^9, 
   3.7195809966487484`*^9}, {3.7195810323424673`*^9, 
   3.7195810617786107`*^9}, {3.7195813593589625`*^9, 
   3.7195813613492365`*^9}, {3.7195814497819195`*^9, 
   3.7195815461095095`*^9}, {3.719581613984631*^9, 3.7195816626140347`*^9}, {
   3.719581724777997*^9, 3.7195817296840253`*^9}, {3.7195818819558363`*^9, 
   3.719581882124288*^9}, {3.7195823274581537`*^9, 3.7195823460665197`*^9}, {
   3.719582409446633*^9, 3.7195824134053535`*^9}, {3.7195824792340565`*^9, 
   3.7195824822812386`*^9}, {3.7195828635895777`*^9, 
   3.7195828924139986`*^9}, {3.7195829269566307`*^9, 
   3.7195829532947245`*^9}, {3.71958299115474*^9, 3.7195829917954297`*^9}, {
   3.719650296848384*^9, 3.719650308133438*^9}, {3.7196504225780315`*^9, 
   3.719650424620702*^9}, {3.719652319312585*^9, 3.7196524461663632`*^9}, {
   3.7196524978605967`*^9, 3.719652508809775*^9}, {3.7196525395284863`*^9, 
   3.719652547897547*^9}, {3.7196528468155484`*^9, 3.719652847299777*^9}, {
   3.7196532595132093`*^9, 3.7196532674214735`*^9}, {3.719653362110983*^9, 
   3.719653378419673*^9}, {3.719654054944502*^9, 3.7196540566830025`*^9}, {
   3.719660855119031*^9, 3.7196609163387403`*^9}, 3.719661039517068*^9, {
   3.719661258620204*^9, 3.719661260732663*^9}, {3.7196612911457825`*^9, 
   3.719661296996229*^9}, {3.7196613406830535`*^9, 3.7196613408428507`*^9}, {
   3.7196614001790295`*^9, 3.7196614100815372`*^9}, {3.7196614745975285`*^9, 
   3.7196616224789314`*^9}, 3.7196616730674644`*^9, {3.719662253183296*^9, 
   3.719662260991962*^9}, {3.7196626236919546`*^9, 3.719662626240038*^9}, {
   3.7196640986100135`*^9, 3.7196640987899456`*^9}, {3.7196653083995004`*^9, 
   3.7196653270673437`*^9}, {3.719677149328948*^9, 3.7196772681782894`*^9}, {
   3.719677298977812*^9, 3.7196773064080453`*^9}, {3.719677379158373*^9, 
   3.719677412126779*^9}, {3.7196774889061594`*^9, 3.7196774968762045`*^9}, {
   3.719733883095891*^9, 3.71973388633563*^9}, {3.719734052591037*^9, 
   3.719734068089182*^9}, {3.719734118547476*^9, 3.7197342130258865`*^9}, {
   3.7197342431968117`*^9, 3.719734243785476*^9}, {3.719734277565549*^9, 
   3.719734384834944*^9}, {3.719734422835949*^9, 3.719734544204365*^9}, {
   3.719734583522422*^9, 3.71973461476042*^9}, {3.7197348016510906`*^9, 
   3.7197348598679047`*^9}, {3.719734890337513*^9, 3.719734890777832*^9}, {
   3.7197349569856105`*^9, 3.719735043752411*^9}, {3.7197350790583563`*^9, 
   3.7197350805889425`*^9}, {3.7197351163181715`*^9, 
   3.7197351185810537`*^9}, {3.7197356525072055`*^9, 
   3.7197356549625697`*^9}, {3.7197358038649626`*^9, 3.719735823089506*^9}, {
   3.719736188262532*^9, 3.7197361884220934`*^9}, {3.7197452529482155`*^9, 
   3.7197453197858715`*^9}, {3.7197454232613516`*^9, 3.7197454265244474`*^9}, 
   3.719745526461796*^9, {3.7197458492099175`*^9, 3.7197458493798437`*^9}, {
   3.719756949806178*^9, 3.719756951995332*^9}, {3.7198506007928305`*^9, 
   3.719850650062683*^9}, {3.7198705260785027`*^9, 
   3.7198705431580057`*^9}},ExpressionUUID->"c94abc34-391a-4973-8ab2-\
7db0ea546d92"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Repeat", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.690984518900131*^9, 3.690984520602982*^9}, 
   3.692848521296042*^9},ExpressionUUID->"0a0776b9-2c43-4909-a966-\
48d02cba8f6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"NPropagate", "[", 
      RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", 
         RowBox[{
          RowBox[{"st", ":", 
           RowBox[{"(", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
          ",", 
          RowBox[{"Repeat", "[", 
           RowBox[{
            RowBox[{"EventList", "[", 
             RowBox[{"st_", ",", "chars_", ",", 
              RowBox[{"events", ":", 
               RowBox[{"{", 
                RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}],
              "]"}], ",", "n_Integer", ",", "evtropts___Rule"}], "]"}], ",", 
          "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", "opbasis_", 
       ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "RepeatPropagator"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matreps", ",", "singleprop", ",", "\[Rho]vec"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"matreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"NPropagationSuperoperator", "[", 
             RowBox[{"True", ",", 
              RowBox[{"HilbertSpaceCompatibility", "[", "#", "]"}], ",", "#", 
              ",", "opts"}], "]"}], ",", "opbasis", ",", "basis", ",", 
            "opts"}], "]"}], "&"}], "/@", "events"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"singleprop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
          RowBox[{"First", "@", "matreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "matreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"SparseArray", "[", 
          RowBox[{"Chop", "[", 
           RowBox[{"MatrixPower", "[", 
            RowBox[{"singleprop", ",", "n", ",", "\[Rho]vec"}], "]"}], "]"}], 
          "]"}], ",", "opbasis", ",", "basis", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"{", "opts", "}"}], ",", 
            RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, 3.542281134468389*^9, {3.5645684544067097`*^9, 
   3.5645685012249613`*^9}, {3.586362122636345*^9, 3.5863624728699913`*^9}, {
   3.586363380330854*^9, 3.586363385359961*^9}, {3.587576139268099*^9, 
   3.5875761417981577`*^9}, {3.5875762341269007`*^9, 
   3.5875763853272038`*^9}, {3.5875766585438547`*^9, 3.5875766813166533`*^9}, 
   {3.666608549421843*^9, 3.6666085497823753`*^9}, 3.6666113141219406`*^9, {
   3.683186587217523*^9, 3.6831865919508047`*^9}, 3.683187098958549*^9, {
   3.690984514860692*^9, 3.690984524039979*^9}, {3.691060687197613*^9, 
   3.691060753746748*^9}, {3.691060866239098*^9, 3.691060959114229*^9}, {
   3.691061045218045*^9, 3.691061064384056*^9}, {3.691391609964263*^9, 
   3.691391622649879*^9}, {3.691402547637679*^9, 3.691402548638754*^9}, {
   3.691407274584907*^9, 3.691407275830823*^9}, {3.691677015180834*^9, 
   3.6916770182838287`*^9}, 3.692848522364584*^9, {3.6933866763541565`*^9, 
   3.6933867082645226`*^9}, {3.6933868450700207`*^9, 3.693386847092952*^9}, {
   3.693386913362214*^9, 3.6933869171302466`*^9}, 3.6933869501801786`*^9, {
   3.6933869849993935`*^9, 3.6933869860494027`*^9}, {3.693387077668935*^9, 
   3.693387127937803*^9}, {3.693387174769182*^9, 3.6933871750875225`*^9}, {
   3.6933872765581036`*^9, 3.693387278983719*^9}, {3.693387310775377*^9, 
   3.693387310935706*^9}, {3.69338736901866*^9, 3.6933873913619175`*^9}, {
   3.6933874420014267`*^9, 3.693387458514313*^9}, {3.693387506983118*^9, 
   3.6933875252716055`*^9}, {3.693387566221203*^9, 3.693387589900855*^9}, {
   3.69338765801058*^9, 3.6933876744000473`*^9}, {3.693387704621563*^9, 
   3.693387769228965*^9}, {3.6933878697279177`*^9, 3.6933879023280563`*^9}, 
   3.696883229545755*^9, {3.696935508361205*^9, 3.696935539441184*^9}, {
   3.6969355907212625`*^9, 3.6969355921023006`*^9}, 3.696935626987486*^9, {
   3.6971219546765747`*^9, 3.6971219972779465`*^9}, {3.697122057334345*^9, 
   3.6971221043812933`*^9}, {3.6971222640022707`*^9, 3.697122266045313*^9}, {
   3.69712231414377*^9, 3.6971223385518646`*^9}, {3.6972074923892856`*^9, 
   3.6972075040342135`*^9}, {3.697207593696545*^9, 3.6972075938740163`*^9}, {
   3.697207683509207*^9, 3.6972077124401274`*^9}, {3.697207765534234*^9, 
   3.6972077702628*^9}, {3.697207809233376*^9, 3.697207819352271*^9}, {
   3.697207864120222*^9, 3.6972078672054477`*^9}, {3.697207922179553*^9, 
   3.697207922358023*^9}, {3.6972079993486495`*^9, 3.6972080817937393`*^9}, {
   3.697216534304596*^9, 3.697216555244016*^9}, {3.6972165948937855`*^9, 
   3.697216609861122*^9}, 3.6972167120452003`*^9, {3.6972167754825554`*^9, 
   3.6972167757726974`*^9}, {3.697220481684008*^9, 3.6972205348928595`*^9}, {
   3.697220592708762*^9, 3.6972206367410507`*^9}, {3.6972206937692347`*^9, 
   3.697220749762186*^9}, {3.69722081204152*^9, 3.6972208161102834`*^9}, {
   3.697220859439926*^9, 3.697220880750022*^9}, {3.697220928365718*^9, 
   3.69722093002945*^9}, 3.697221106216623*^9, {3.6972211421311398`*^9, 
   3.697221245817256*^9}, {3.697222224671383*^9, 3.6972223486002407`*^9}, {
   3.697357921839645*^9, 3.697357951506971*^9}, {3.6973743658206773`*^9, 
   3.6973743796533346`*^9}, {3.6973744757036176`*^9, 3.697374475863866*^9}, {
   3.697374678021274*^9, 3.6973746796265526`*^9}, {3.70317984038273*^9, 
   3.703179848902236*^9}, 3.7093750050203238`*^9, 3.7276850449915886`*^9, {
   3.727689440201186*^9, 3.7276894427442636`*^9}, {3.7276895254966197`*^9, 
   3.7276895810499687`*^9}, {3.7276897861390505`*^9, 
   3.7276897936685925`*^9}, {3.727689831348973*^9, 3.727689921685891*^9}, {
   3.727689981713855*^9, 3.7276900173470683`*^9}, {3.7276901212165613`*^9, 
   3.7276901667361436`*^9}},ExpressionUUID->"b57ef8de-1008-43a0-8efc-\
a3b7f41b89e3"]
}, Closed]],

Cell[CellGroupData[{

Cell["PrecalculatedEvent", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.538677605389827*^9, 
   3.538677607531299*^9}},ExpressionUUID->"b3071ea1-789c-4c71-923e-\
620ed9e0e5a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", "False", ",", "False", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",", 
         RowBox[{"PrecalculatedEvent", "[", 
          RowBox[{
          "precalch_", ",", "Sop_Superoperator", ",", "precalevopts___Rule"}],
           "]"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "UsePrecalculatedPropagator"}], "]"}]}], ":=", 
   RowBox[{"Sop", "[", "\[Rho]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, {3.53867763931421*^9, 3.5386776481776333`*^9}, {
   3.538677692924055*^9, 3.538677702585209*^9}, {3.5391124476711493`*^9, 
   3.539112453900564*^9}, {3.6666085615139894`*^9, 3.666608567772622*^9}, 
   3.6666113169912148`*^9, {3.690984529675124*^9, 3.690984531611169*^9}, {
   3.691391630156105*^9, 3.691391637265486*^9}, {3.6914382516732264`*^9, 
   3.691438340756529*^9}, 3.693508805406706*^9, 3.6968832344556627`*^9, {
   3.6969356333015823`*^9, 3.6969356425896783`*^9}, {3.6971338444630327`*^9, 
   3.6971338603609204`*^9}, 3.697221965437863*^9, {3.727689477822816*^9, 
   3.7276894835357757`*^9}},ExpressionUUID->"33b9fdd3-6438-4803-8892-\
86d56b2cbd53"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Continuous \[Rule] True", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438180169045*^9}, {3.7027960952705607`*^9, 
   3.7027960962707167`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"4e5ad67f-06d2-43aa-8432-3447e46c7934"],

Cell[CellGroupData[{

Cell["initialize", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666288750390873`*^9, 3.666628880639269*^9}, 
   3.666693196673871*^9, {3.666803836772476*^9, 3.666803838839712*^9}, {
   3.667383454902224*^9, 3.667383459131519*^9}, {3.69165785131144*^9, 
   3.691657858134141*^9}, {3.691658440975215*^9, 
   3.691658442710451*^9}},ExpressionUUID->"ef94cf9d-853a-4c5b-aefc-\
37316c247b87"],

Cell["\<\
Hstat is necessary here to match the general pattern, but is dropped after \
that.\
\>", "Text",
 CellChangeTimes->{{3.697375931991683*^9, 
  3.6973759530875063`*^9}},ExpressionUUID->"06fcf184-b97a-4157-bc38-\
691fca90e4ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{
    "\[Rho]_", ",", "True", ",", "True", ",", "Hstat_", ",", 
     "eventlist_EventList", ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "1"}], "}"}], ",", "eventlist", ",", "opbasis", 
     ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691657873391885*^9, 3.691657945141138*^9}, 
   3.6932473501356564`*^9, {3.6932477081105165`*^9, 3.6932478259904437`*^9}, {
   3.693247871298764*^9, 3.6932478795273285`*^9}, {3.6932480652338195`*^9, 
   3.6932480944726706`*^9}, {3.693249092010026*^9, 3.693249093831031*^9}, {
   3.6966032813681307`*^9, 3.696603293277754*^9}, {3.6966033571766157`*^9, 
   3.696603359634142*^9}, {3.6966037890454044`*^9, 3.6966038227339325`*^9}, {
   3.6968849361852465`*^9, 3.696884941012079*^9}, {3.696885086905469*^9, 
   3.6968851012228007`*^9}, {3.6972219842649083`*^9, 
   3.6972219886736155`*^9}, {3.6973758264552374`*^9, 
   3.6973758345857286`*^9}, {3.6993029544596477`*^9, 
   3.6993029563320603`*^9}},ExpressionUUID->"a7449119-ba0e-4577-b3be-\
46bfaa1949c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 1: calculate OperatorTrajectory", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666288750390873`*^9, 3.666628880639269*^9}, 
   3.666693196673871*^9, {3.666803836772476*^9, 3.666803838839712*^9}, {
   3.667383454902224*^9, 3.667383459131519*^9}, {3.691657926509634*^9, 
   3.691657933930669*^9}},ExpressionUUID->"6238e591-eb97-4da5-86b6-\
79a3f26195c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "\[IndentingNewLine]", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "1"}], "}"}], ",", "eventlist_EventList", ",", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opfunc", ",", "timeinterval"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"timeinterval", "=", 
        RowBox[{"TotalEventTimeInterval", "[", "eventlist", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opfunc", "=", "\[IndentingNewLine]", 
        RowBox[{"NPropagate", "[", 
         RowBox[{"\[Rho]", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
          "eventlist", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"OperatorTrajectoryFunction", "[", 
        RowBox[{
         RowBox[{"{", "timeinterval", "}"}], ",", "opfunc", ",", "opbasis", 
         ",", "basis", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
            RowBox[{"Options", "[", "OperatorTrajectoryFunction", "]"}]}], 
           "]"}]}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6666289124528093`*^9, 3.6666289293314714`*^9}, {
   3.6666292438056517`*^9, 3.6666292624053235`*^9}, {3.6666293573302946`*^9, 
   3.666629359782241*^9}, {3.666629601829337*^9, 3.666629602149353*^9}, {
   3.6666296531241007`*^9, 3.666629655556298*^9}, {3.666630077968399*^9, 
   3.6666300879777575`*^9}, {3.6666301950069337`*^9, 
   3.6666301977666435`*^9}, {3.6666459433926744`*^9, 
   3.6666459439326925`*^9}, {3.6666460114447546`*^9, 
   3.6666460116123705`*^9}, {3.6666811521421547`*^9, 
   3.6666811572916994`*^9}, {3.666692297016621*^9, 3.6666922971971903`*^9}, {
   3.6666929882398653`*^9, 3.666692993651271*^9}, {3.6666931167997785`*^9, 
   3.666693116988055*^9}, 3.666693189725669*^9, {3.6666932426762137`*^9, 
   3.666693243276569*^9}, 3.6666936087329016`*^9, {3.666693639028225*^9, 
   3.66669364016801*^9}, {3.6666937043912306`*^9, 3.6666937394108896`*^9}, {
   3.666693823881803*^9, 3.666693824070124*^9}, {3.6666949232305417`*^9, 
   3.6666949412856855`*^9}, {3.6666950019161067`*^9, 
   3.6666950021266456`*^9}, {3.666695089054925*^9, 3.666695089926364*^9}, {
   3.6667035276535788`*^9, 3.6667035281540465`*^9}, {3.6667038351896296`*^9, 
   3.6667038785504613`*^9}, {3.6667039284267206`*^9, 
   3.6667039337841587`*^9}, {3.666704312916829*^9, 3.6667043130577583`*^9}, {
   3.6667087441505656`*^9, 3.6667087442788424`*^9}, {3.666708938725809*^9, 
   3.666708953894667*^9}, {3.666709030054926*^9, 3.666709059933845*^9}, {
   3.6667093015052814`*^9, 3.6667093118553276`*^9}, {3.666709502365758*^9, 
   3.6667095025116253`*^9}, {3.666719203049678*^9, 3.6667192396081176`*^9}, {
   3.6667198475894976`*^9, 3.666719860536139*^9}, {3.6667199235734324`*^9, 
   3.6667199246344485`*^9}, {3.6667200942126427`*^9, 3.666720129011141*^9}, {
   3.666721798347973*^9, 3.6667218080989833`*^9}, {3.66672184756015*^9, 
   3.6667218480273895`*^9}, {3.6667283766686797`*^9, 3.666728380395379*^9}, {
   3.666800356113885*^9, 3.6668003834452796`*^9}, 3.66681310643476*^9, {
   3.6668140907749553`*^9, 3.666814102848647*^9}, {3.666942704632001*^9, 
   3.6669427113728776`*^9}, {3.6669427636372285`*^9, 3.666942769565648*^9}, {
   3.6669428093466635`*^9, 3.6669428367765174`*^9}, {3.6669428996543555`*^9, 
   3.666942899962555*^9}, 3.683128236236635*^9, {3.691657824154235*^9, 
   3.691657829032033*^9}, {3.69165793886899*^9, 3.691657990292151*^9}, {
   3.6932483229512577`*^9, 3.693248397936204*^9}, {3.693292625077243*^9, 
   3.6932926266244745`*^9}, {3.6932938446274385`*^9, 3.693293845232869*^9}, {
   3.693293913233835*^9, 3.693293914984972*^9}, {3.6932943714666023`*^9, 
   3.69329437980556*^9}, 3.693294480894786*^9, {3.6932945297140865`*^9, 
   3.693294534923193*^9}, {3.693294742318863*^9, 3.693294742579048*^9}, {
   3.6932949333440137`*^9, 3.6932949335633163`*^9}, {3.6932973658570046`*^9, 
   3.693297395238681*^9}, {3.6932976328991203`*^9, 3.693297633034944*^9}, {
   3.693304400964014*^9, 3.693304402915163*^9}, 3.6933053029643865`*^9, {
   3.693399638854353*^9, 3.6933996401631813`*^9}, {3.6933997275707493`*^9, 
   3.6933997284388075`*^9}, {3.693399939659914*^9, 3.6933999433088846`*^9}, {
   3.693483414362792*^9, 3.693483414562932*^9}, {3.693483447822536*^9, 
   3.693483448983907*^9}, 3.693489442885016*^9, {3.693489649169012*^9, 
   3.6934896498289185`*^9}, {3.69688510430507*^9, 3.6968851090865364`*^9}, {
   3.697222006075952*^9, 3.6972220338568325`*^9}, {3.6995624116499987`*^9, 
   3.699562415063651*^9}, {3.699562465952611*^9, 3.699562479201227*^9}, {
   3.6995625194003296`*^9, 3.6995625229627423`*^9}, {3.69956294143906*^9, 
   3.6995629415986605`*^9}, {3.703852579466625*^9, 3.703852586510926*^9}, {
   3.7038531083348236`*^9, 3.7038531085935807`*^9}, {3.7038531404492593`*^9, 
   3.7038531412183266`*^9}, {3.7038534327568617`*^9, 3.703853437328896*^9}, {
   3.7039273395781293`*^9, 3.703927343828555*^9}, {3.7039273863326645`*^9, 
   3.7039273864576774`*^9}, {3.7185216873523207`*^9, 
   3.7185216920715466`*^9}, {3.7185217258249235`*^9, 
   3.7185217259655933`*^9}},ExpressionUUID->"b95e161f-25ba-457c-87e3-\
d0e0a17af9e7"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 2: check validity", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
  3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
  3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
  3.691658005034162*^9, 3.691658021226699*^9}, {3.691658167424262*^9, 
  3.691658170470058*^9}},ExpressionUUID->"c0679214-6fd4-4ec8-84ef-\
973b6989886d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
     "eventlist_EventList", ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"EventDuration", "[", "eventlist", "]"}], "]"}], 
      "\[LessEqual]", "0"}], ",", "\[IndentingNewLine]", "\t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagate", "::", "contzerodur"}], "]"}], ";", "$Failed"}], 
      ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"eventlist", ",", "_PrecalculatedEvent"}], "]"}]}], ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagate", "::", "contnoprecalev"}], "]"}], ";", 
       "$Failed"}], ")"}], ",", "\[IndentingNewLine]", "True", ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"NPropagate", "[", 
      RowBox[{"\[Rho]", ",", "True", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "3"}], "}"}], ",", "eventlist", ",", "opbasis", 
       ",", "basis", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.666629744736624*^9, {3.6666301081295195`*^9, 3.666630110147475*^9}, {
   3.666719864843292*^9, 3.6667198683249097`*^9}, {3.6667960819581037`*^9, 
   3.6667961397766275`*^9}, {3.666796202467792*^9, 3.6667962168053846`*^9}, 
   3.6667962487459445`*^9, {3.6667963398436794`*^9, 3.6667964114394565`*^9}, 
   3.6667964698199835`*^9, 3.6667965171376295`*^9, 3.666813114423455*^9, {
   3.666813208791678*^9, 3.666813210100481*^9}, 3.680955504975294*^9, 
   3.683130101632099*^9, {3.691658026629362*^9, 3.691658043380471*^9}, {
   3.691658098249446*^9, 3.691658109125815*^9}, {3.691660780309319*^9, 
   3.691660890334828*^9}, 3.691660940720689*^9, 3.69166127724006*^9, {
   3.6932484062586846`*^9, 3.693248500135603*^9}, {3.696885111964465*^9, 
   3.6968851161890116`*^9}},ExpressionUUID->"15245736-e1d8-4960-a248-\
94309b6f81d3"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 3: compile piecewise function", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
   3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
   3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
   3.691658005034162*^9, 3.691658021226699*^9}, {3.691658174487835*^9, 
   3.691658177509932*^9}, 3.6932488215201626`*^9, 3.6932489846674333`*^9, {
   3.6932496931493073`*^9, 3.6932497062095685`*^9}, 
   3.6933979993944654`*^9},ExpressionUUID->"5f202b00-e1b0-44da-8384-\
b6b6cba90cde"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{"st_", ",", "ch_", ",", 
        RowBox[{"events", ":", 
         RowBox[{"{", 
          RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
       "]"}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "sortedevents", ",", "zbasis", ",", "funcsLtoR", ",", 
       "timeintervalsLtoR", ",", "intervals", ",", "funcs", ",", 
       "lasttimepoint"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"timeintervalsLtoR", "=", 
        RowBox[{"Reverse", "[", 
         RowBox[{"Reverse", "/@", 
          RowBox[{"EventTimeIntervals", "[", "eventlist", "]"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"sortedevents", "=", 
        RowBox[{"Reverse", "[", 
         RowBox[{"SortVectorSpaceCompatibility", "[", "eventlist", "]"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"funcsLtoR", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{"#", ",", "1"}], "]"}], "&"}], "@", 
         RowBox[{"FoldList", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"NPropagate", "[", 
             RowBox[{
              RowBox[{"#1", "[", 
               RowBox[{"InitialTimePoint", "[", 
                RowBox[{
                "#2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                "]"}], "]"}], ",", "True", ",", 
              RowBox[{"{", 
               RowBox[{"True", ",", "4"}], "}"}], ",", "#2", ",", "opbasis", 
              ",", "basis", ",", "opts"}], "]"}], "&"}], ",", 
           RowBox[{"Function", "[", "\[Rho]", "]"}], ",", "sortedevents"}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"intervals", ",", "funcs"}], "}"}], "=", 
        RowBox[{"Transpose", "@", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"_", ",", "_"}], "}"}], ",", 
             RowBox[{"_InterpolatingFunction", "|", "_Function"}]}], "}"}]}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], ",", 
           "$Failed"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"intervals", ",", "funcs"}], "}"}], "=", 
            RowBox[{"Transpose", "@", 
             RowBox[{"Cases", "[", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], ",", 
                 RowBox[{"_InterpolatingFunction", "|", "_Function"}]}], 
                "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Function", "[", 
            RowBox[{"t", ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"Chop", "[", "\[IndentingNewLine]", 
               RowBox[{"N", "@", 
                RowBox[{"Piecewise", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"MapThread", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#1", "[", "t", "]"}], ",", "#2"}], "}"}], "&"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"funcs", ",", "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[LessEqual]", "t", "<", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ")"}], "&"}], "/@", 
                    RowBox[{"Most", "[", "intervals", "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[LessEqual]", "t", 
                    "\[LessEqual]", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ")"}], "&"}], "/@", 
                    RowBox[{"{", 
                    RowBox[{"Last", "[", "intervals", "]"}], "}"}]}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                    "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
                  "\[IndentingNewLine]", "Undefined"}], "\[IndentingNewLine]",
                  "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], ",",
          "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6666297502136602`*^9, 3.666629762206499*^9}, 
   3.6666301154323025`*^9, {3.6666306873822627`*^9, 3.666630687682001*^9}, {
   3.6666307866107593`*^9, 3.66663079279292*^9}, {3.666630843780203*^9, 
   3.666630844020713*^9}, {3.666630916708933*^9, 3.666630919120039*^9}, {
   3.6666311432042704`*^9, 3.666631151387723*^9}, {3.666631194845915*^9, 
   3.666631260375851*^9}, {3.6666313078444843`*^9, 3.66663130814419*^9}, {
   3.6666316440971613`*^9, 3.66663164714981*^9}, {3.666631685906866*^9, 
   3.6666317063276596`*^9}, {3.6666318092453957`*^9, 
   3.6666318743053207`*^9}, {3.6666323379974546`*^9, 
   3.6666323429334383`*^9}, {3.6666324066462307`*^9, 3.666632419005351*^9}, {
   3.6666329090573635`*^9, 3.666632924316862*^9}, {3.6666331527560043`*^9, 
   3.6666331538359985`*^9}, {3.6666331876992054`*^9, 3.666633213014859*^9}, {
   3.6666334002897773`*^9, 3.6666334207420053`*^9}, {3.666633470570064*^9, 
   3.666633496461276*^9}, {3.6666335698744698`*^9, 3.6666335711691236`*^9}, {
   3.6666336082938085`*^9, 3.666633610584656*^9}, {3.6666336474035316`*^9, 
   3.666633648853919*^9}, {3.6666337640920506`*^9, 3.6666337863434873`*^9}, 
   3.6666338266528225`*^9, {3.666633864768216*^9, 3.666633894174612*^9}, {
   3.6666339550907216`*^9, 3.666634002601797*^9}, {3.666634056725222*^9, 
   3.666634082208129*^9}, {3.666634234471589*^9, 3.666634264661652*^9}, {
   3.666634303760488*^9, 3.666634304059883*^9}, {3.6666343930796723`*^9, 
   3.666634406696066*^9}, 3.666634732536618*^9, {3.6666349124651394`*^9, 
   3.666634918059038*^9}, {3.6666350120575967`*^9, 3.6666350575230107`*^9}, {
   3.6666351634282427`*^9, 3.666635163706266*^9}, 3.666641497151764*^9, {
   3.666641528612031*^9, 3.666641528771546*^9}, {3.666641600690502*^9, 
   3.666641610880871*^9}, {3.666646046099635*^9, 3.6666460519639072`*^9}, {
   3.666646132627212*^9, 3.666646142117659*^9}, {3.6666461804649515`*^9, 
   3.6666461832745895`*^9}, {3.666646367012099*^9, 3.666646367292903*^9}, {
   3.6666464896676903`*^9, 3.666646495210701*^9}, {3.666681243473317*^9, 
   3.666681246002558*^9}, {3.666683458464487*^9, 3.6666834586648655`*^9}, {
   3.6666899599071507`*^9, 3.666689998154758*^9}, {3.666690029725212*^9, 
   3.6666901232130527`*^9}, {3.6666911204782267`*^9, 
   3.6666911652676067`*^9}, {3.6666912712148905`*^9, 3.666691280435643*^9}, {
   3.666691312281521*^9, 3.66669135377402*^9}, {3.6666922390214353`*^9, 
   3.6666922391908555`*^9}, {3.6666926001927814`*^9, 3.66669261034723*^9}, {
   3.6666927463793964`*^9, 3.66669274649982*^9}, {3.6666928191138*^9, 
   3.6666928303956785`*^9}, {3.6666928943771887`*^9, 3.666692901644882*^9}, 
   3.6666931245928907`*^9, {3.6666932354693403`*^9, 3.666693235821501*^9}, {
   3.6667037303362713`*^9, 3.6667037550475225`*^9}, {3.6667038029405155`*^9, 
   3.6667038302836957`*^9}, {3.6667198753676014`*^9, 3.666719884328268*^9}, {
   3.6667201408115273`*^9, 3.6667202099028015`*^9}, {3.6667883300899277`*^9, 
   3.666788337162409*^9}, {3.666788391621787*^9, 3.666788391890574*^9}, {
   3.666800395363905*^9, 3.6668003992375727`*^9}, {3.6668004451832857`*^9, 
   3.6668004907759867`*^9}, {3.6668007392162457`*^9, 3.666800739375801*^9}, {
   3.666804028705383*^9, 3.66680403374667*^9}, {3.6668042146419635`*^9, 
   3.6668042322921553`*^9}, 3.666804392942712*^9, {3.6668046236405773`*^9, 
   3.6668046257368383`*^9}, 3.666804685595687*^9, {3.6668047244912605`*^9, 
   3.6668047245578365`*^9}, 3.6668131247854843`*^9, {3.6668131896547537`*^9, 
   3.6668132053539004`*^9}, {3.6668858002682323`*^9, 3.666885832038566*^9}, {
   3.666940253975088*^9, 3.666940257069915*^9}, {3.6669404200870056`*^9, 
   3.666940425043862*^9}, {3.666940467335926*^9, 3.6669404894563*^9}, {
   3.666940586126114*^9, 3.6669405862729187`*^9}, {3.6669407841839733`*^9, 
   3.6669408300767136`*^9}, 3.6669408671527057`*^9, {3.666940908358775*^9, 
   3.6669409086476607`*^9}, {3.6669409566742315`*^9, 
   3.6669409574069242`*^9}, {3.666941025688573*^9, 3.666941028634165*^9}, {
   3.6669411184704137`*^9, 3.6669411187779417`*^9}, {3.6669411837657557`*^9, 
   3.666941186010166*^9}, {3.6669413958424406`*^9, 3.6669413996540647`*^9}, {
   3.6669422803251777`*^9, 3.6669422961727724`*^9}, {3.6669423444236383`*^9, 
   3.6669423532933025`*^9}, {3.6669424714940634`*^9, 
   3.6669424723145404`*^9}, {3.6669425856937494`*^9, 
   3.6669425892873583`*^9}, {3.6669426482662687`*^9, 
   3.6669426484335876`*^9}, {3.6669426940879927`*^9, 
   3.6669426942573824`*^9}, {3.666942930113154*^9, 3.666942971136715*^9}, {
   3.6669430357304573`*^9, 3.666943035855397*^9}, {3.6669430894963465`*^9, 
   3.666943090286268*^9}, {3.666943296213332*^9, 3.666943296349323*^9}, {
   3.6669438166344247`*^9, 3.666943827142829*^9}, {3.6673864921126614`*^9, 
   3.667386498574226*^9}, {3.6673865660841103`*^9, 3.6673865673952584`*^9}, {
   3.667386629554121*^9, 3.667386650063718*^9}, 3.683128152149973*^9, {
   3.691658136960492*^9, 3.691658145006069*^9}, {3.691658321577507*^9, 
   3.691658344527866*^9}, 3.691658375601693*^9, {3.6916613494179296`*^9, 
   3.691661394249073*^9}, 3.691662459585555*^9, {3.6916627834488573`*^9, 
   3.691662802325425*^9}, {3.691664150696534*^9, 3.6916641978946047`*^9}, 
   3.691664590843608*^9, {3.693248653402819*^9, 3.6932486651795373`*^9}, {
   3.6932496297000213`*^9, 3.693249638723774*^9}, {3.6932497098935385`*^9, 
   3.693249714431167*^9}, {3.6932511557103963`*^9, 3.693251162357591*^9}, {
   3.693292477810203*^9, 3.6932924866295757`*^9}, {3.693292580726635*^9, 
   3.693292581115122*^9}, {3.6932926719132876`*^9, 3.693292688150759*^9}, {
   3.6932936923883286`*^9, 3.693293724620632*^9}, {3.693293778987049*^9, 
   3.6932937842464695`*^9}, {3.6932941629887047`*^9, 
   3.6932941907288184`*^9}, {3.6932943577356434`*^9, 3.693294365092149*^9}, {
   3.6932944091753755`*^9, 3.6932944132852974`*^9}, {3.6932948176683407`*^9, 
   3.6932948544184537`*^9}, {3.6932965477590857`*^9, 
   3.6932965551275043`*^9}, {3.6933043969655237`*^9, 3.693304398156664*^9}, {
   3.693304436671807*^9, 3.693304456706944*^9}, {3.6933046054461317`*^9, 
   3.6933046057983828`*^9}, {3.693304641708366*^9, 3.693304647678598*^9}, {
   3.6933046877803483`*^9, 3.6933047010321674`*^9}, {3.693304782429082*^9, 
   3.6933048108781195`*^9}, {3.6933049079589825`*^9, 3.693305092901889*^9}, 
   3.6933051488027215`*^9, {3.6933052658510804`*^9, 3.693305282308544*^9}, {
   3.6933984418509307`*^9, 3.6933984434060106`*^9}, {3.6933989700867586`*^9, 
   3.6933989902437468`*^9}, {3.6933990577214956`*^9, 
   3.6933991004702415`*^9}, {3.693399180512864*^9, 3.6933993192486534`*^9}, {
   3.693399404533346*^9, 3.6933994295031137`*^9}, {3.693399482602707*^9, 
   3.6933994871323504`*^9}, {3.693399535401161*^9, 3.693399537431387*^9}, {
   3.693399573693158*^9, 3.6933996015966387`*^9}, {3.693399691869194*^9, 
   3.6933997468801317`*^9}, {3.6933998207881737`*^9, 
   3.6933998245867915`*^9}, {3.6933998618290834`*^9, 
   3.6933998665393724`*^9}, {3.693399999082177*^9, 3.6934000026104317`*^9}, {
   3.693400090137207*^9, 3.69340009416402*^9}, {3.6934005416015186`*^9, 
   3.693400545039236*^9}, {3.6934012395738444`*^9, 3.6934014292592297`*^9}, {
   3.6934014597822886`*^9, 3.6934014627683334`*^9}, {3.693401501097573*^9, 
   3.6934015027702303`*^9}, {3.6934830218573627`*^9, 
   3.6934830890706453`*^9}, {3.693483123175831*^9, 3.693483129616599*^9}, {
   3.693483203526212*^9, 3.6934832070663795`*^9}, {3.693483245119057*^9, 
   3.6934834424595585`*^9}, {3.6934890864709144`*^9, 3.693489149873952*^9}, {
   3.693489189347685*^9, 3.693489257516224*^9}, {3.6934893564641137`*^9, 
   3.69348935896041*^9}, 3.693489406289384*^9, {3.6934894654795084`*^9, 
   3.6934894794909773`*^9}, {3.6934895115801625`*^9, 3.693489641955839*^9}, {
   3.6935089569997053`*^9, 3.6935090358737774`*^9}, {3.6966033731730943`*^9, 
   3.696603380051401*^9}, {3.696622318993799*^9, 3.696622346208601*^9}, {
   3.696622423800705*^9, 3.696622424343419*^9}, {3.6967004749265375`*^9, 
   3.696700476172056*^9}, {3.696882689216704*^9, 3.6968826911790905`*^9}, {
   3.6968845738309517`*^9, 3.696884575340779*^9}, {3.696885148661909*^9, 
   3.696885158566451*^9}, {3.6968852204864883`*^9, 3.696885226087034*^9}, {
   3.6968854426613846`*^9, 3.6968854460257235`*^9}, {3.696885588414051*^9, 
   3.696885588763567*^9}, {3.6968856204700527`*^9, 3.696885624344691*^9}, {
   3.6968857082319565`*^9, 3.6968857084722567`*^9}, {3.6969364815616274`*^9, 
   3.696936485776268*^9}, {3.696936631439217*^9, 3.69693665003047*^9}, {
   3.6972220546589885`*^9, 3.6972220618352365`*^9}, {3.697356332655384*^9, 
   3.697356339550438*^9}, {3.699562578670539*^9, 3.699562589552853*^9}, {
   3.6995626348099813`*^9, 3.699562683660983*^9}, {3.6995627263491497`*^9, 
   3.699562731109634*^9}, {3.6995628189889574`*^9, 3.699562819297388*^9}, {
   3.7027988321868896`*^9, 3.702798833962926*^9}, {3.7027988696485834`*^9, 
   3.702798869935855*^9}, {3.7027991466858187`*^9, 3.7027993041789603`*^9}, {
   3.702808372686165*^9, 3.702808374585665*^9}, {3.702808417027059*^9, 
   3.7028084172145767`*^9}, {3.7038523331383142`*^9, 3.703852353147253*^9}, {
   3.7038523902759924`*^9, 3.7038523940449266`*^9}, {3.703852476872697*^9, 
   3.703852485262585*^9}, {3.7038525622486687`*^9, 3.7038525637956667`*^9}, {
   3.7038530747131286`*^9, 3.7038530750252666`*^9}, {3.70385312456374*^9, 
   3.703853134383421*^9}, {3.7038531683662677`*^9, 3.7038532239870214`*^9}, {
   3.7038534292260275`*^9, 3.703853430583728*^9}, 
   3.703853465766982*^9},ExpressionUUID->"5f85f0a0-63e4-4c39-b0d2-\
e5c9bf0042c2"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 4: individual Events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
   3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
   3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
   3.691658005034162*^9, 3.691658021226699*^9}, {3.691658174487835*^9, 
   3.691658177509932*^9}, {3.691661526670512*^9, 3.6916615334355717`*^9}, 
   3.6932488232509737`*^9, 
   3.6932489853463516`*^9},ExpressionUUID->"5529bbcf-9b3e-46d0-a51d-\
8b7c593dc6aa"],

Cell[CellGroupData[{

Cell["stage 4: Hilbert Space Compatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969353615783634`*^9, 3.696935366182064*^9}, {
  3.6969359631606503`*^9, 
  3.6969359646654696`*^9}},ExpressionUUID->"4931c974-07e9-4a2d-8200-\
13939822e90c"],

Cell[CellGroupData[{

Cell["Time-independent commutation superoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, 3.534312208835496*^9, 
   3.534312835224263*^9},ExpressionUUID->"784e7e49-67fa-4179-8ea7-\
533bc95c7511"],

Cell["evolve under the associated Hamiltonian", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534312697186016*^9, 
  3.5343127063854103`*^9}},ExpressionUUID->"bce93194-2a90-4f17-8527-\
40a43472b799"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"True", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"CommutationSuperoperator", "[", 
              RowBox[{"op_", ",", "___Rule"}], "]"}], ",", "\[Tau]_"}], "}"}],
            ",", "evopts___Rule"}], "]"}]}]}], "}"}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", 
       RowBox[{"Event", "[", 
        RowBox[{"st", ",", "ch", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"op", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Complex", "[", 
               RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}], ",", "\[Tau]"}], 
          "}"}], ",", "evopts"}], "]"}]}], "}"}], ",", "opbasis", ",", 
     "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503025687858303*^9, 3.503025722245736*^9}, {
   3.5031120589480553`*^9, 3.503112110693466*^9}, {3.5031133894727087`*^9, 
   3.5031133896856327`*^9}, 3.503115153550331*^9, {3.5111775809053907`*^9, 
   3.511177584763298*^9}, {3.534312215814622*^9, 3.534312266563973*^9}, 
   3.534312530792787*^9, {3.534312732855695*^9, 3.534312766231317*^9}, {
   3.666608484435109*^9, 3.6666084865346394`*^9}, 3.6666113039965553`*^9, {
   3.6668022157789855`*^9, 3.6668022260903473`*^9}, {3.66681292825787*^9, 
   3.6668129299977474`*^9}, {3.6909844672795877`*^9, 3.690984470085635*^9}, {
   3.690988499468053*^9, 3.6909885262845984`*^9}, {3.690988567156177*^9, 
   3.690988628579484*^9}, {3.691059604153894*^9, 3.691059606048283*^9}, {
   3.69139149389701*^9, 3.6913915067973127`*^9}, 3.691593112043873*^9, {
   3.691593300179624*^9, 3.6915933169049597`*^9}, {3.693381417317855*^9, 
   3.6933814329141536`*^9}, {3.6933829559152966`*^9, 3.693382971133459*^9}, {
   3.693383027939308*^9, 3.6933830312123985`*^9}, {3.6933831896179075`*^9, 
   3.693383190745489*^9}, {3.6933833146777134`*^9, 3.693383328747326*^9}, {
   3.6933860087115674`*^9, 3.69338601783076*^9}, {3.6966218386615553`*^9, 
   3.6966219359789457`*^9}, {3.6968852366464787`*^9, 
   3.6968852555365686`*^9}, {3.6968857628898306`*^9, 3.696885777869505*^9}, {
   3.696936659404662*^9, 3.696936661234907*^9}, 3.6972045570572124`*^9, {
   3.69722209690981*^9, 
   3.697222100040848*^9}},ExpressionUUID->"d16434b6-209c-454e-b985-\
74cc3b200b05"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent Hamiltonian", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9},ExpressionUUID->"3564adea-cd3f-41a3-95a2-\
bf9c257465aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"True", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",",
            "evopts___Rule"}], "]"}]}]}], "}"}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tb", ",", "ta", ",", "\[Rho]matrep", ",", "t", ",", "evals", ",", 
       "evecs", ",", "X", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tb", ",", "ta"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FinalTimePoint", "[", "ev", "]"}], ",", 
          RowBox[{"InitialTimePoint", "[", "ev", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
              RowBox[{"First", "@", 
               RowBox[{"NDiagonalize", "[", 
                RowBox[{"Hop", ",", "basis", ",", "opts"}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"SparseArray", "@", 
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", 
                RowBox[{"ExpToTrig", "@", 
                 RowBox[{"Normal", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Dot", "[", 
                    RowBox[{"#", ",", "\[Rho]matrep", ",", 
                    RowBox[{"ConjugateTranspose", "@", "#"}]}], "]"}], "&"}], 
                   "@", "\[IndentingNewLine]", 
                   RowBox[{"(", 
                    RowBox[{
                    "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
                    "\[IndentingNewLine]", 
                    RowBox[{"X", ",", "\[IndentingNewLine]", 
                    RowBox[{"DiagonalMatrix", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", "I"}], "*", "#", "\[Times]", 
                    RowBox[{"(", 
                    RowBox[{"t", "-", "ta"}], ")"}]}], "]"}], "&"}], "/@", 
                    "evals"}], "]"}], ",", "\[IndentingNewLine]", "Xinv"}], 
                    "\[IndentingNewLine]", "]"}], ")"}]}], 
                  "\[IndentingNewLine]", "]"}]}]}]}]}]}], ",", 
            "\[IndentingNewLine]", "basis", ",", 
            RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503025687858303*^9, 3.503025722245736*^9}, {
   3.5031120589480553`*^9, 3.503112110693466*^9}, {3.5031133894727087`*^9, 
   3.5031133896856327`*^9}, 3.503115153550331*^9, {3.5111775809053907`*^9, 
   3.511177584763298*^9}, {3.534312215814622*^9, 3.534312266563973*^9}, 
   3.534312530792787*^9, {3.534312732855695*^9, 3.534312766231317*^9}, {
   3.666608484435109*^9, 3.6666084865346394`*^9}, 3.6666113039965553`*^9, {
   3.6668022157789855`*^9, 3.6668022260903473`*^9}, {3.66681292825787*^9, 
   3.6668129299977474`*^9}, {3.6909844672795877`*^9, 3.690984470085635*^9}, {
   3.690988499468053*^9, 3.6909885262845984`*^9}, {3.690988567156177*^9, 
   3.690988628579484*^9}, {3.691059604153894*^9, 3.691059606048283*^9}, {
   3.69139149389701*^9, 3.6913915067973127`*^9}, 3.691593112043873*^9, {
   3.691593300179624*^9, 3.6915933169049597`*^9}, {3.693381417317855*^9, 
   3.6933814329141536`*^9}, {3.6933829559152966`*^9, 3.693382971133459*^9}, {
   3.693383027939308*^9, 3.6933830312123985`*^9}, {3.6933831896179075`*^9, 
   3.693383190745489*^9}, {3.6933833146777134`*^9, 3.693383328747326*^9}, {
   3.6933860087115674`*^9, 3.69338601783076*^9}, {3.6966218386615553`*^9, 
   3.6966219359789457`*^9}, {3.6968852366464787`*^9, 
   3.6968852555365686`*^9}, {3.6968857628898306`*^9, 3.696885777869505*^9}, {
   3.696936659404662*^9, 3.696936661234907*^9}, 3.6972045570572124`*^9, {
   3.69722209690981*^9, 3.697222100040848*^9}, 
   3.6995635888684464`*^9},ExpressionUUID->"f4ba4b7c-181a-488e-9970-\
b7d0bebc45ed"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent commutation superoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, {3.503025797624085*^9, 3.50302579778263*^9}, {
   3.534312817477545*^9, 
   3.5343128456219187`*^9}},ExpressionUUID->"0e8a7e88-2918-4eef-9f66-\
28d436d398ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"(", 
             RowBox[{"True", "|", 
              RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ShapeFunction", "[", 
              RowBox[{"t_", ",", 
               RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
               RowBox[{"CommutationSuperoperator", "[", 
                RowBox[{"op_", ",", "___Rule"}], "]"}]}], "]"}], ",", 
             "\[Tau]_"}], "}"}], ",", "\[IndentingNewLine]", 
           "evopts___Rule"}], "]"}]}]}], "}"}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", 
       RowBox[{"Event", "[", 
        RowBox[{"st", ",", "ch", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
             RowBox[{"op", "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Complex", "[", 
                 RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
                RowBox[{"(", 
                 RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}]}], "]"}], ",", 
           "\[Tau]"}], "}"}], ",", "evopts"}], "]"}]}], "}"}], ",", "opbasis",
      ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503025752698345*^9, 3.5030257583747396`*^9}, {3.5030258334600573`*^9, 
   3.503025850747231*^9}, {3.503025881421885*^9, 3.5030259696222754`*^9}, {
   3.5030260590423822`*^9, 3.503026096992079*^9}, {3.503112232053441*^9, 
   3.503112277937085*^9}, {3.503112319384701*^9, 3.503112366768518*^9}, {
   3.503112422322407*^9, 3.5031124994636602`*^9}, 3.5031125532271223`*^9, {
   3.503112586208776*^9, 3.503112592640542*^9}, {3.503112630090947*^9, 
   3.503112631440538*^9}, {3.503113245678843*^9, 3.5031132459237843`*^9}, {
   3.503113459055827*^9, 3.503113464669381*^9}, {3.503113634395102*^9, 
   3.5031136611266193`*^9}, {3.503113703737402*^9, 3.503113773767356*^9}, {
   3.503113849430991*^9, 3.503113871961054*^9}, {3.503114849311439*^9, 
   3.503114854894581*^9}, {3.507023031173218*^9, 3.507023164828182*^9}, 
   3.534312327172946*^9, {3.534312400901217*^9, 3.534312453718451*^9}, 
   3.5343125212115097`*^9, 3.5422811141952744`*^9, {3.6666085082554593`*^9, 
   3.666608508685293*^9}, 3.6666113088259196`*^9, {3.690984497229733*^9, 
   3.690984499235046*^9}, {3.6910598688327503`*^9, 3.691059899950292*^9}, {
   3.6910599781356916`*^9, 3.6910599861831207`*^9}, {3.691060166591395*^9, 
   3.6910601742377863`*^9}, {3.6910602190608683`*^9, 3.691060221294345*^9}, {
   3.6913915667347593`*^9, 3.691391580922913*^9}, {3.6933853040788345`*^9, 
   3.693385310626051*^9}, {3.693385354138092*^9, 3.6933853613666973`*^9}, {
   3.693385412569092*^9, 3.6933854169390364`*^9}, {3.6933854968520393`*^9, 
   3.6933855012919426`*^9}, {3.693385558824297*^9, 3.6933855629348564`*^9}, {
   3.693385622816536*^9, 3.6933856376915445`*^9}, 3.693385872062977*^9, {
   3.693385910092436*^9, 3.693385922529768*^9}, {3.6966221230361905`*^9, 
   3.6966221248548837`*^9}, {3.696885344895429*^9, 3.6968853525362697`*^9}, {
   3.696921369008077*^9, 3.696921400192291*^9}, {3.6969214368650165`*^9, 
   3.696921457144212*^9}, {3.6969214906166525`*^9, 3.69692153214866*^9}, {
   3.6969366761960616`*^9, 3.6969366772599087`*^9}, {3.6972045636717978`*^9, 
   3.6972045669013643`*^9}, {3.697222131344691*^9, 3.697222132661545*^9}, 
   3.7093750050285673`*^9},ExpressionUUID->"f2f35a81-d3d3-4ab0-a1b6-\
a2e682a0cf5a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent Hamiltonian", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 
   3.534312862341494*^9}},ExpressionUUID->"b19948e8-953e-49a0-8720-\
2d54c8bf4a9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Hfunc", ":", 
              RowBox[{"ShapeFunction", "[", 
               RowBox[{"args__", ",", 
                RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", 
             "\[Tau]_"}], "}"}], ",", "evopts___Rule"}], "]"}]}]}], "}"}], 
      ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "dim", ",", "tb", ",", "ta", ",", "Hmatfunc", ",", "NDSolveopts", ",", 
       "\[Rho]vec", ",", "\[Rho]vecflat", ",", "\[Rho]vecplain", ",", 
       "\[Rho]ini", ",", "\[Rho]$", ",", "sol"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"dim", "=", 
        RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tb", ",", "ta"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FinalTimePoint", "[", "ev", "]"}], ",", 
          RowBox[{"InitialTimePoint", "[", "ev", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Hmatfunc", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"t$", ",", 
          RowBox[{"Evaluate", "[", 
           RowBox[{"N", "@", 
            RowBox[{"Normal", "@", 
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Hfunc", "[", 
                 RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", 
               RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}]}], "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"NDSolveopts", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}], ",", 
           RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Rho]vec", "[", "t$_", "]"}], ":=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[Rho]$", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Rho]vecflat", "[", "t$_", "]"}], ":=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Array", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"\[Rho]$", "[", 
               RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], "]"}], "]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"\[Rho]vecplain", "=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Rho]$", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Rho]ini", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sol", "=", 
        RowBox[{"NDSolveValue", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{"\[Rho]vecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
             "\[Equal]", 
             RowBox[{
              RowBox[{"-", "I"}], " ", 
              RowBox[{"Flatten", "@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Hmatfunc", "[", "t$", "]"}], ".", 
                  RowBox[{"\[Rho]vec", "[", "t$", "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"\[Rho]vec", "[", "t$", "]"}], ".", 
                  RowBox[{"Hmatfunc", "[", "t$", "]"}]}]}], ")"}]}]}]}], ",", 
            
            RowBox[{
             RowBox[{"\[Rho]vecflat", "[", "ta", "]"}], "\[Equal]", 
             RowBox[{"Flatten", "[", 
              RowBox[{"Normal", "@", "\[Rho]ini"}], "]"}]}]}], "}"}], ",", 
          RowBox[{"Flatten", "@", "\[Rho]vecplain"}], ",", 
          RowBox[{"{", 
           RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"SparseArray", "[", 
             RowBox[{"Chop", "[", 
              RowBox[{"N", "[", 
               RowBox[{"Through", "[", 
                RowBox[{"sol", "[", "t", "]"}], "]"}], "]"}], "]"}], "]"}], 
            ",", 
            RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}], ",", 
            RowBox[{"ZeemanBasis", "[", "]"}], ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], ",", 
                 RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Options", "[", "Operator", "]"}]}], 
              "\[IndentingNewLine]", "]"}]}]}], "]"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, 3.6966221394876537`*^9, {3.696885281085475*^9, 
   3.696885289575986*^9}, {3.696921546697188*^9, 3.6969216613938866`*^9}, {
   3.696922451888819*^9, 3.6969224946802297`*^9}, {3.6969237667744427`*^9, 
   3.696923785498838*^9}, {3.6969238497848206`*^9, 3.6969239068877935`*^9}, {
   3.6969365932664013`*^9, 3.6969366117790885`*^9}, {3.6969366822427845`*^9, 
   3.696936683285204*^9}, {3.6995620376014614`*^9, 3.6995620394570827`*^9}, {
   3.699562849503457*^9, 3.699562854618267*^9}, {3.6995628865625505`*^9, 
   3.6995628955589466`*^9}, {3.699562945721106*^9, 3.699562951687703*^9}, {
   3.6995629937554646`*^9, 3.6995630212913046`*^9}, {3.699563057685789*^9, 
   3.699563057955803*^9}, {3.6995630967521296`*^9, 3.699563105655617*^9}, {
   3.699565688929887*^9, 3.6995657091452785`*^9}, {3.6995658543621273`*^9, 
   3.6995658600544243`*^9}, {3.699565951594552*^9, 3.699565952596486*^9}, {
   3.699566311241868*^9, 3.6995663569619274`*^9}, {3.699566429003641*^9, 
   3.6995664652526736`*^9}, {3.699566496133576*^9, 3.699566502362253*^9}, {
   3.699597823502025*^9, 3.6995978423966885`*^9}, {3.6995978725665293`*^9, 
   3.6995979630328145`*^9}, {3.699598026647207*^9, 3.6995980512620697`*^9}, {
   3.6995981150975633`*^9, 3.699598147459225*^9}, 3.6995987598694906`*^9, {
   3.6996206993309956`*^9, 3.6996207151486893`*^9}, {3.6996208629655995`*^9, 
   3.699620863734161*^9}, {3.702796648154621*^9, 3.702796653389145*^9}, {
   3.7027967398666844`*^9, 3.702796740371354*^9}, {3.702798905432438*^9, 
   3.7027989088153486`*^9}, {3.702799068773681*^9, 3.7027990935343432`*^9}, {
   3.7027991344284945`*^9, 3.7027991346452093`*^9}, {3.7038517821228876`*^9, 
   3.7038517918489003`*^9}, {3.7038518328946505`*^9, 
   3.7038518330646925`*^9}, {3.7038520796401787`*^9, 
   3.7038520824310875`*^9}, {3.703852133122978*^9, 3.7038521472829375`*^9}, {
   3.703852245982636*^9, 3.7038522769860764`*^9}, {3.703852939654843*^9, 
   3.7038529452814646`*^9}, {3.7038535815943956`*^9, 3.703853589912806*^9}, {
   3.7136066744353027`*^9, 3.7136069413736115`*^9}, {3.7136069744606237`*^9, 
   3.713607004195817*^9}, {3.7136070881254883`*^9, 3.7136071069770823`*^9}, {
   3.7136072031477814`*^9, 3.7136072095794067`*^9}, {3.713607256667694*^9, 
   3.713607366966508*^9}, 3.7136074598258147`*^9, {3.7136076224128895`*^9, 
   3.713607622575199*^9}, {3.7136080715005875`*^9, 
   3.713608071683218*^9}},ExpressionUUID->"f44c31e6-af82-4208-a86b-\
e11023279a46"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.666787806623809*^9, 3.6667878240530386`*^9}, {
   3.666795792768396*^9, 3.6667957947412214`*^9}, {3.6673829561962423`*^9, 
   3.667382957205306*^9}, {3.667387445429882*^9, 3.6673874490404735`*^9}, {
   3.6916600993640423`*^9, 3.69166010733225*^9}, {3.691665188673538*^9, 
   3.691665192101946*^9}, 3.693248916446367*^9, {3.6932489610767508`*^9, 
   3.693248988688242*^9}, 
   3.6969359904078283`*^9},ExpressionUUID->"35029a82-7c3a-41e1-9b83-\
2291420124b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", 
         RowBox[{
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
           "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
            "__"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RotationSuperoperator", "[", "args___", "]"}], ",", 
            "___"}], "}"}], ",", "___Rule"}], "]"}]}]}], "}"}], ",", 
     "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Ufw", ",", "\[Rho]matrep"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ufw", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{
          RowBox[{"RotationOperator", "[", "args", "]"}], ",", "basis"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Dot", "[", 
             RowBox[{"Ufw", ",", "\[Rho]matrep", ",", 
              RowBox[{"ConjugateTranspose", "@", "Ufw"}]}], "]"}], ",", 
            "basis", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], ",", 
                 RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
               RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.666787885874828*^9, 3.666787893632843*^9}, {
   3.666787953221898*^9, 3.666787955221856*^9}, {3.66678808589962*^9, 
   3.666788085969693*^9}, {3.6667881184473877`*^9, 3.666788121139324*^9}, {
   3.6667882623518276`*^9, 3.666788262470888*^9}, {3.666788306681405*^9, 
   3.6667883179186735`*^9}, {3.666789085817876*^9, 3.666789085998213*^9}, {
   3.666791910031025*^9, 3.6667919199611993`*^9}, {3.6667947083022747`*^9, 
   3.6667947128842*^9}, {3.6667947803806906`*^9, 3.666794868870147*^9}, {
   3.666794986228097*^9, 3.66679500951676*^9}, {3.6667950834870596`*^9, 
   3.6667951208272*^9}, {3.666795277979823*^9, 3.6667953152888575`*^9}, 
   3.666795379287572*^9, {3.666795423038396*^9, 3.666795432327444*^9}, {
   3.6667954734988775`*^9, 3.666795500685788*^9}, {3.6667955331361437`*^9, 
   3.6667955345381613`*^9}, {3.666795567733016*^9, 3.6667955716972017`*^9}, {
   3.666795624545231*^9, 3.6667956383362155`*^9}, {3.6668001839112515`*^9, 
   3.6668001863190117`*^9}, {3.6668002979354877`*^9, 3.666800301557413*^9}, {
   3.6668003348350573`*^9, 3.666800334985257*^9}, 3.6668028970047054`*^9, {
   3.6668040445399933`*^9, 3.666804048485133*^9}, {3.666804136245371*^9, 
   3.6668041427032843`*^9}, {3.666813046746394*^9, 3.666813049084942*^9}, {
   3.666813364438802*^9, 3.6668133714384174`*^9}, {3.667386968462659*^9, 
   3.667386975360824*^9}, {3.69166498811832*^9, 3.691665049980772*^9}, {
   3.691665081555109*^9, 3.69166512437912*^9}, {3.691665159063904*^9, 
   3.691665217039282*^9}, {3.691665325989184*^9, 3.691665374876573*^9}, {
   3.6916654299658537`*^9, 3.69166548166293*^9}, {3.691667410135995*^9, 
   3.691667416934401*^9}, {3.691667533147132*^9, 3.6916675395937223`*^9}, {
   3.6933980920509925`*^9, 3.6933981308594623`*^9}, {3.693398180504257*^9, 
   3.693398198797963*^9}, {3.693398236689994*^9, 3.693398247537618*^9}, {
   3.6933983086460514`*^9, 3.6933983194259896`*^9}, {3.6933983500248384`*^9, 
   3.693398375365693*^9}, {3.6933984227453947`*^9, 3.69339842453848*^9}, {
   3.693398583079672*^9, 3.693398594488446*^9}, {3.69339864338472*^9, 
   3.6933986864133835`*^9}, 3.6966223727521057`*^9, {3.696885362123309*^9, 
   3.69688538205624*^9}, {3.6969240070222473`*^9, 3.696924048942631*^9}, {
   3.696924122169998*^9, 3.696924149401697*^9}, {3.6969242425297775`*^9, 
   3.696924291419544*^9}, {3.6969366895472407`*^9, 3.6969366909873056`*^9}, {
   3.6971248909582567`*^9, 
   3.6971248916278105`*^9}},ExpressionUUID->"7dfc2576-91ee-44bd-ad96-\
083fc8866f70"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 4: Hilbert Space Incompatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969353615783634`*^9, 3.696935366182064*^9}, {
  3.6969359631606503`*^9, 3.6969359646654696`*^9}, {3.696936014953191*^9, 
  3.6969360168494353`*^9}},ExpressionUUID->"8c91debc-792b-4f54-bca1-\
e1001c134fcc"],

Cell[CellGroupData[{

Cell["Instantaneous Transformation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 3.69693544787114*^9, {3.69712426496584*^9, 
   3.6971242706544685`*^9}},ExpressionUUID->"4be63b27-9a3e-4e06-aad4-\
e2a9b26c13ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "[", 
    RowBox[{"\[Rho]_", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"False", ",", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
           "__"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"InstaOp_", ",", "___"}], "}"}], ",", "___Rule"}], "]"}]}], 
      "}"}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Ufw", ",", "\[Rho]vec"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "opbasis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ufw", "=", 
        RowBox[{"SuperoperatorMatrixRepresentation", "[", 
         RowBox[{"InstaOp", ",", "opbasis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Dot", "[", 
             RowBox[{"Ufw", ",", "\[Rho]vec"}], "]"}], ",", "opbasis", ",", 
            "basis", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"Join", "[", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], ",", 
                 RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
               RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.696933441959618*^9, 3.696933496599775*^9}, {3.6969336005520544`*^9, 
   3.6969336021370754`*^9}, {3.696933768414254*^9, 3.6969337700656276`*^9}, {
   3.6969338194073725`*^9, 3.6969338265665736`*^9}, {3.6969338979505153`*^9, 
   3.6969339067827215`*^9}, {3.6969343081750884`*^9, 
   3.6969343371754217`*^9}, {3.69693437996661*^9, 3.6969343918608027`*^9}, {
   3.6969344369818544`*^9, 3.696934471013612*^9}, {3.6969345411996994`*^9, 
   3.6969345417349706`*^9}, {3.696934579056014*^9, 3.6969345915662336`*^9}, {
   3.6969347182855387`*^9, 3.6969347437181387`*^9}, {3.696934791247017*^9, 
   3.696934795084534*^9}, {3.696934914567275*^9, 3.6969349147324734`*^9}, {
   3.6971243951148825`*^9, 3.6971244639941216`*^9}, {3.6971247674071865`*^9, 
   3.6971248751284895`*^9}},ExpressionUUID->"9ca80652-8f3a-4083-b438-\
130c5c04cc72"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 
   3.69693544787114*^9},ExpressionUUID->"8fdf4f49-9648-4c16-83aa-\
28e08e19faa2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"False", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"(", 
             RowBox[{"True", "|", 
              RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
           RowBox[{"ch", ":", 
            RowBox[{"{", 
             RowBox[{
             "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
              "__"}], "}"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Lsop_", "?", "SuperoperatorQ"}], ",", "\[Tau]_"}], 
            "}"}], ",", "evopts___Rule"}], "]"}]}]}], "}"}], ",", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]vec", ",", "ta", ",", "tb", ",", "t", ",", "evals", ",", "X", 
       ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]", ",", "opbasis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tb", ",", "ta"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FinalTimePoint", "[", "ev", "]"}], ",", 
          RowBox[{"InitialTimePoint", "[", "ev", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
              RowBox[{"First", "@", 
               RowBox[{"NDiagonalize", "[", 
                RowBox[{
                 RowBox[{"StandardizeGenerator", "[", "Lsop", "]"}], ",", 
                 "opbasis", ",", "opts"}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"SparseArray", "@", 
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", 
                RowBox[{"ExpToTrig", "@", 
                 RowBox[{"Normal", "[", 
                  RowBox[{"Dot", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
                    RowBox[{"X", ",", 
                    RowBox[{"DiagonalMatrix", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Exp", "[", 
                    RowBox[{"#", "\[Times]", 
                    RowBox[{"(", 
                    RowBox[{"t", "-", "ta"}], ")"}]}], "]"}], "&"}], "/@", 
                    "evals"}], "]"}], ",", "Xinv"}], "]"}], ")"}], ",", 
                    "\[Rho]vec"}], "]"}], "]"}]}]}]}]}]}], ",", "opbasis", 
            ",", "basis", ",", 
            RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}]}]}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452690531068695*^9, 3.452690599728272*^9}, {
   3.452713481624045*^9, 3.452713486519453*^9}, {3.4527140041197157`*^9, 
   3.452714025416692*^9}, {3.4527140867578707`*^9, 3.452714099086936*^9}, {
   3.452714132023095*^9, 3.452714170502606*^9}, {3.452827494265431*^9, 
   3.452827499986635*^9}, {3.452827946311603*^9, 3.452827963017808*^9}, 
   3.4528280197802*^9, {3.452834425940219*^9, 3.452834429248974*^9}, {
   3.45296862907323*^9, 3.452968698911127*^9}, {3.452968996703251*^9, 
   3.452969016852367*^9}, {3.452970229607943*^9, 3.452970232824254*^9}, {
   3.454565577792158*^9, 3.454565600318421*^9}, 3.454565641800033*^9, {
   3.454577368550002*^9, 3.454577370845316*^9}, {3.454578554194628*^9, 
   3.454578556002204*^9}, {3.455275348251018*^9, 3.455275352394432*^9}, {
   3.455361518545755*^9, 3.45536152261629*^9}, {3.45536281612714*^9, 
   3.4553628203417187`*^9}, 3.455366472829061*^9, {3.45536961860872*^9, 
   3.455369629323238*^9}, {3.455369740504629*^9, 3.455369787310898*^9}, 
   3.456221604466387*^9, 3.456322845966786*^9, {3.4589940597643414`*^9, 
   3.4589940633240633`*^9}, 3.458994113231534*^9, {3.459338412973414*^9, 
   3.4593384203475533`*^9}, 3.462784366060383*^9, 3.4627845100182743`*^9, {
   3.464327358280571*^9, 3.464327363245153*^9}, 3.464458072781571*^9, {
   3.464610652673967*^9, 3.4646107047530823`*^9}, {3.464678912105274*^9, 
   3.464678942165515*^9}, {3.4646950329855013`*^9, 3.4646951269304113`*^9}, 
   3.4677204030792828`*^9, {3.500263382317464*^9, 3.5002634169959717`*^9}, 
   3.500263477936509*^9, 3.500263613435347*^9, {3.500264852949397*^9, 
   3.5002648583546143`*^9}, {3.500264891975165*^9, 3.500264925811551*^9}, {
   3.500265256299799*^9, 3.5002652596084213`*^9}, {3.500266263584918*^9, 
   3.500266449360496*^9}, {3.500266482204661*^9, 3.500266498800531*^9}, {
   3.50026660199973*^9, 3.500266618843708*^9}, {3.5002733799245367`*^9, 
   3.500273383047964*^9}, {3.500274045908242*^9, 3.500274046896537*^9}, {
   3.500274245833909*^9, 3.500274249255313*^9}, {3.5002749581101847`*^9, 
   3.5002751164358273`*^9}, {3.500275391980563*^9, 3.5002753945173264`*^9}, {
   3.50316912017247*^9, 3.503169135318965*^9}, 3.504458413538725*^9, {
   3.510334215541009*^9, 3.510334230946742*^9}, 3.511623355269967*^9, {
   3.511623717178936*^9, 3.5116238191868877`*^9}, {3.532003693782765*^9, 
   3.532003702255629*^9}, {3.534398607196209*^9, 3.534398607600121*^9}, 
   3.621573524540504*^9, {3.6969246067334986`*^9, 3.69692464688102*^9}, {
   3.696924714000514*^9, 3.6969247538575783`*^9}, {3.6969248378795223`*^9, 
   3.696924849107593*^9}, {3.6969249276967306`*^9, 3.6969249300645447`*^9}, {
   3.696925070044421*^9, 3.696925072852312*^9}, {3.6969253869162226`*^9, 
   3.696925396176249*^9}, {3.696925492925914*^9, 3.6969255564238443`*^9}, {
   3.696925681571023*^9, 3.6969256916631308`*^9}, {3.6969257826323223`*^9, 
   3.696925782892612*^9}, {3.696933737166244*^9, 3.696933751560065*^9}, {
   3.696933805070039*^9, 3.696933807294442*^9}, 3.6969338915818906`*^9, {
   3.6969342927494116`*^9, 3.696934295615456*^9}, 3.6969350138828397`*^9, {
   3.696936821581041*^9, 3.696936990105368*^9}, {3.696937022409182*^9, 
   3.696937024665634*^9}, {3.6969371307460794`*^9, 3.696937173564478*^9}, {
   3.696937241960271*^9, 3.6969373118190713`*^9}, {3.6969373518880453`*^9, 
   3.696937390891151*^9}, {3.702767964664397*^9, 3.7027679797561235`*^9}, {
   3.7027681533815885`*^9, 3.702768154611442*^9}, {3.702768193410017*^9, 
   3.702768193699254*^9}, {3.702768297030631*^9, 3.7027683289163017`*^9}, {
   3.702769408657545*^9, 3.7027694092870207`*^9}, {3.702769480382537*^9, 
   3.7027694821768446`*^9}, {3.702769626261812*^9, 3.7027696473107796`*^9}, {
   3.7027699792710185`*^9, 3.7027699933900566`*^9}, {3.7027700292910595`*^9, 
   3.7027700318528814`*^9}, 3.7027701866029043`*^9, {3.7027702229717607`*^9, 
   3.7027702264362545`*^9}, 3.7027703251343975`*^9, {3.702770445217804*^9, 
   3.702770448570165*^9}, 3.702771238191002*^9, {3.7027713527824745`*^9, 
   3.7027713530126376`*^9}, 3.70277172285926*^9, {3.7031824627596865`*^9, 
   3.7031824643757105`*^9}, {3.7038521848060417`*^9, 3.703852191221966*^9}, {
   3.7185216049689875`*^9, 3.71852160804746*^9}, {3.7185223576411495`*^9, 
   3.718522358063035*^9}, 
   3.7260703480588408`*^9},ExpressionUUID->"91037dc8-0edd-4e2b-9826-\
0889d36152b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 3.534312862341494*^9}, {3.6933866240201435`*^9, 
   3.6933866247715487`*^9}, {3.6969244138622255`*^9, 3.6969244145023837`*^9}, 
   3.696935449737483*^9},ExpressionUUID->"97441659-826f-4cd5-afd2-\
dbccf267f7a6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagate", "[", 
     RowBox[{"\[Rho]_", ",", "True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"False", ",", 
        RowBox[{"ev", ":", 
         RowBox[{"Event", "[", 
          RowBox[{
           RowBox[{"st", ":", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ".."}], "}"}]}]}], ",", 
           RowBox[{"ch", ":", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"_", ",", 
                RowBox[{"{", 
                 RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], 
               "}"}], ",", "__"}], "}"}]}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Lfunc", ":", 
              RowBox[{"ShapeFunction", "[", 
               RowBox[{"t_", ",", 
                RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
                RowBox[{"op_", "?", "SuperoperatorQ"}]}], "]"}]}], ",", 
             "\[Tau]_"}], "}"}], ",", "evopts___Rule"}], "]"}]}]}], "}"}], 
      ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "dim", ",", "NDSolveopts", ",", "\[Rho]vecflat", ",", "\[Rho]vecplain", 
       ",", "\[Rho]ini", ",", "\[Rho]$", ",", "t$", ",", "sol", ",", 
       "Lmatfunc"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dim", "=", 
       RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lmatfunc", "=", 
       RowBox[{"Function", "[", 
        RowBox[{"t$", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"N", "[", 
           RowBox[{"SuperoperatorMatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"StandardizeGenerator", "[", 
              RowBox[{
               RowBox[{"Lfunc", "[", 
                RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"evopts", ",", "opts"}], "}"}]}], "]"}], ",", 
             "opbasis"}], "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"NDSolveopts", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"evopts", ",", "opts"}], "}"}], ",", 
          RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Rho]vecflat", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[Rho]$", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Rho]vecplain", "=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Rho]$", "[", 
            RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"dim", ",", "dim"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Rho]ini", "=", 
       RowBox[{"OperatorVectorRepresentation", "[", 
        RowBox[{"\[Rho]", ",", "opbasis"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sol", "=", 
       RowBox[{"NDSolveValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"\[Rho]vecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
            "\[Equal]", 
            RowBox[{"Flatten", "@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Lmatfunc", "[", "t$", "]"}], ".", 
               RowBox[{"\[Rho]vecflat", "[", "t$", "]"}]}], ")"}]}]}], ",", 
           RowBox[{
            RowBox[{"\[Rho]vecflat", "[", "ta", "]"}], "\[Equal]", 
            RowBox[{"Flatten", "[", 
             RowBox[{"Normal", "@", "\[Rho]ini"}], "]"}]}]}], "}"}], ",", 
         RowBox[{"Flatten", "@", "\[Rho]vecplain"}], ",", 
         RowBox[{"{", 
          RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Function", "[", 
       RowBox[{"t$", ",", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{"Chop", "[", 
             RowBox[{"N", "[", 
              RowBox[{"Through", "[", 
               RowBox[{"sol", "[", "t$", "]"}], "]"}], "]"}], "]"}], "]"}], 
           ",", "opbasis", ",", "basis", ",", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "opts", "}"}], ",", 
                RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Options", "[", "Operator", "]"}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.6969350964470854`*^9, 3.6969351569122*^9}, {3.6969352610516367`*^9, 
   3.6969353304596157`*^9}, {3.696936073009776*^9, 3.6969361205916877`*^9}, {
   3.696936162074154*^9, 3.696936267601714*^9}, {3.696936331085576*^9, 
   3.6969363330413513`*^9}, {3.6969363824551306`*^9, 
   3.6969363837169285`*^9}, {3.696936439964308*^9, 3.6969364504605727`*^9}, {
   3.696936550005021*^9, 3.696936553056692*^9}, {3.696936714076373*^9, 
   3.696936714364853*^9}, 3.6995987764979973`*^9, {3.7027685981371117`*^9, 
   3.702768632377475*^9}, {3.7027687041834965`*^9, 3.702768721166602*^9}, {
   3.702768811295656*^9, 3.7027688138585033`*^9}, {3.7027688881412888`*^9, 
   3.7027689424108725`*^9}, {3.702768995294469*^9, 3.7027690307216587`*^9}, {
   3.702769295002737*^9, 3.702769295241908*^9}, 3.702771251512473*^9, 
   3.7027717289265985`*^9, {3.7031824760412865`*^9, 3.70318247885927*^9}, {
   3.703852200352148*^9, 3.7038522006301446`*^9}, {3.7038522367321754`*^9, 
   3.703852236997621*^9}, {3.703852281606597*^9, 3.703852313076951*^9}, {
   3.703852415403941*^9, 3.7038524177781115`*^9}, {3.703852459981311*^9, 
   3.7038524724804497`*^9}, {3.703852594322953*^9, 3.703852596385667*^9}, {
   3.7038526331692505`*^9, 3.703852633341111*^9}, {3.703852822105101*^9, 
   3.703852851655331*^9}, {3.703853244814845*^9, 3.7038533198242464`*^9}, {
   3.703853350428982*^9, 3.7038534159636526`*^9}, 3.709375005038031*^9, {
   3.7136075163264604`*^9, 3.7136077290709085`*^9}, {3.7136080897338486`*^9, 
   3.713608099431774*^9}, {3.717244008015396*^9, 3.717244028834529*^9}, {
   3.7185217393575697`*^9, 3.718521739607587*^9}, 
   3.726070348087862*^9},ExpressionUUID->"bba6906b-5651-4056-9a83-\
5b8e7d2cf002"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}, {3.691438204642272*^9, 
   3.691438206264173*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"2a54b33a-ac40-45f3-930f-ff75e059ace2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "argnotready"}], "=", 
   "\"\<The argument of NPropagate is not ready for numerical \
computation.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970956327927*^9, 3.690970982532607*^9}, {
   3.6931387233045216`*^9, 3.6931387244543376`*^9}, 
   3.693139391195811*^9},ExpressionUUID->"22eb598b-3d2d-494b-9c3f-\
5e0bb419d677"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "undefbasis"}], "=", 
   "\"\<The Basis `1` is not defined. Calculation will proceed using the \
default Basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699279011312561*^9, 3.699279045062563*^9}, {
  3.6995419443564897`*^9, 
  3.6995419466075935`*^9}},ExpressionUUID->"99de70a4-1236-4628-a3fa-\
f791b45c5a47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "undefopbasis"}], "=", 
   "\"\<The OperatorBasis `1` is not defined. Calculation will proceed using \
the default OperatorBasis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699279011312561*^9, 3.699279045062563*^9}, {
  3.699541931948484*^9, 
  3.6995419423670645`*^9}},ExpressionUUID->"86d330d2-69c2-4b19-941a-\
7d1464fcd7ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "nonnumeric"}], "=", 
   "\"\<A non-numeric matrix was detected. The requested context does not \
permit operators with symbolic coefficients.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.564566928824712*^9, 3.564567010835693*^9}, {
   3.564567659350672*^9, 3.564567691693466*^9}, {3.6916605072775373`*^9, 
   3.6916605087220984`*^9}, 
   3.693138731057287*^9},ExpressionUUID->"7a39b230-cc70-46ad-9134-\
690b703abdf2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "contzerodur"}], "=", 
   "\"\<NPropagate with the option setting Continuous\[Rule]True requires an \
event duration greater than 0.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6667964983863006`*^9, 3.6667965295270796`*^9}, {
   3.691658063131671*^9, 3.6916580824664927`*^9}, {3.6916604551596203`*^9, 
   3.6916604885728703`*^9}, {3.691660711405195*^9, 3.691660714379344*^9}, 
   3.693138733154928*^9, 
   3.693228094625712*^9},ExpressionUUID->"9b3ad3b4-47ab-497f-bb84-\
173e1e027369"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "contnoprecalev"}], "=", 
   "\"\<Precalculated events are not allowed for NPropagate with the option \
setting Continuous\[Rule]True.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6667964983863006`*^9, 3.6667965295270796`*^9}, {
   3.691658063131671*^9, 3.6916580824664927`*^9}, {3.6916604551596203`*^9, 
   3.6916604885728703`*^9}, {3.6916606683675957`*^9, 3.691660705555365*^9}, 
   3.693138734657937*^9, {3.693228104480215*^9, 
   3.6932281047419024`*^9}},ExpressionUUID->"ac1aaf62-19a0-4270-87fa-\
6e158750a81b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "bad\[Rho]"}], "=", 
   "\"\<NPropagate was applied to an expression that is not an \
operator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532002951575089*^9, 
  3.532002996979631*^9}},ExpressionUUID->"de72a473-34e8-48dd-9b9d-\
43d63928c16f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagate", "::", "noevsampling"}], "=", 
   "\"\<For adiabatic proapgation schemes a valid EventSampling has to be \
provided.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532002951575089*^9, 3.532002996979631*^9}, {
  3.728216602380104*^9, 
  3.728216631711322*^9}},ExpressionUUID->"de72a473-34e8-48dd-9b9d-\
43d63928c16f"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["NPropagationOperator", "Subtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.454563770112988*^9, 3.454563772575369*^9}, {
   3.464689435410881*^9, 3.4646894465365963`*^9}, 3.464695493032454*^9, {
   3.467197660626375*^9, 3.4671976663433237`*^9}, 3.467199003852363*^9, 
   3.534310132957168*^9, 
   3.697197930669449*^9},ExpressionUUID->"94acbc0b-bfbe-403c-bcca-\
debef34159b1"],

Cell[CellGroupData[{

Cell["defaults", "Subsubtitle",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.691438143429953*^9, 3.6966224906200085`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"7ae52724-825a-4a65-999c-1b34c608b141"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "NPropagationOperator", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Continuous", "\[Rule]", " ", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpandRepeatedEvents", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PropagatorCalculationProcedure", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"AccuracyGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxStepSize", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxSteps", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"OperatorType", "\[Rule]", "\"\<Unitary\>\""}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.464861472784998*^9, 3.464861483441214*^9}, 
   3.4648615286770973`*^9, 3.4648730173172703`*^9, {3.4648740845965853`*^9, 
   3.4648740923300657`*^9}, {3.4649389788207808`*^9, 3.464938979305622*^9}, {
   3.4649391032323914`*^9, 3.464939139949542*^9}, 3.464939369751892*^9, 
   3.464944210485517*^9, {3.4649599887789917`*^9, 3.4649600189799023`*^9}, 
   3.464960163436203*^9, 3.4657307199008007`*^9, 3.465730770944022*^9, 
   3.465730801958722*^9, 3.465758498775585*^9, {3.4658145173278418`*^9, 
   3.465814524082449*^9}, {3.465814815775647*^9, 3.4658148334715242`*^9}, {
   3.4671972295728273`*^9, 3.467197233800462*^9}, {3.483952009583354*^9, 
   3.483952017548534*^9}, 3.497572538901269*^9, 3.4977586268463993`*^9, 
   3.499708694963387*^9, {3.499708744009026*^9, 3.499708746574301*^9}, {
   3.5030306306149883`*^9, 3.5030306375558147`*^9}, {3.5031117611042624`*^9, 
   3.5031117718455048`*^9}, 3.5044586933744907`*^9, 3.5080058974835157`*^9, {
   3.5080900784786158`*^9, 3.508090085815353*^9}, {3.5085107895701847`*^9, 
   3.508510791240788*^9}, {3.514454503646961*^9, 3.514454513964549*^9}, 
   3.514799185545196*^9, 3.515077830908255*^9, {3.532450992407064*^9, 
   3.532450997113079*^9}, {3.534310144544961*^9, 3.534310156553754*^9}, {
   3.534318337268446*^9, 3.5343183381724863`*^9}, {3.534318394765707*^9, 
   3.534318400204275*^9}, 3.534390194788438*^9, 3.5343987235487423`*^9, {
   3.5391119298439703`*^9, 3.539111941473713*^9}, 3.5434107948803387`*^9, 
   3.545050431601803*^9, {3.626027537094718*^9, 3.626027537828526*^9}, {
   3.6666080915983996`*^9, 3.666608100338314*^9}, {3.6666294836870165`*^9, 
   3.666629503697832*^9}, {3.666630097375392*^9, 3.6666301011973734`*^9}, {
   3.6667106182751527`*^9, 3.666710619416752*^9}, {3.666718489321924*^9, 
   3.6667184894698944`*^9}, {3.666719340623826*^9, 3.666719340804014*^9}, {
   3.691062928160233*^9, 3.691062929463285*^9}, {3.691407200821684*^9, 
   3.691407210567979*^9}, 3.6914099617053413`*^9, {3.691657453428626*^9, 
   3.691657484932658*^9}, 3.691677874187484*^9, 3.6966224906200085`*^9, {
   3.70279651560727*^9, 3.702796517655593*^9}, {3.703839151396835*^9, 
   3.703839154645957*^9}, 3.709375005045957*^9, {3.71302478911478*^9, 
   3.713024789930865*^9}},ExpressionUUID->"f717cc8b-5731-4910-9f7b-\
d940b725c85a"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations and checks", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.6914381546757927`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"f7fa0de2-0dc4-47e7-9216-0f74052bae45"],

Cell[CellGroupData[{

Cell["checks and flags (1)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
  3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
  3.69149747441208*^9, 3.691497480706093*^9}, {3.6916575446580963`*^9, 
  3.691657548177092*^9}, {3.691657685513603*^9, 
  3.691657686488957*^9}},ExpressionUUID->"0a123986-cdab-46ef-b300-\
1cd7efa64244"],

Cell[CellGroupData[{

Cell["Check flags", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
   3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
   3.69149747441208*^9, 3.691497480706093*^9}, 
   3.691657555306875*^9},ExpressionUUID->"64a0096a-62c4-4dfe-a73d-\
d3b1683d6607"],

Cell["\<\
Check flag: {<backgprepared>,<EventList imp>,<hilbcompat>,<no $Failed>,<num \
ready>,}\
\>", "Text",
 CellChangeTimes->{{3.691397731982896*^9, 3.691397800026311*^9}, {
  3.6913988035046587`*^9, 3.691398811659533*^9}, {3.691398882694293*^9, 
  3.691398915950233*^9}, {3.691398972356401*^9, 3.6913989778118773`*^9}, {
  3.6914010940803823`*^9, 3.691401102107382*^9}, {3.6914013217045193`*^9, 
  3.6914013257071877`*^9}},ExpressionUUID->"de1433af-dd80-4d78-b6fc-\
56d78468b370"],

Cell[CellGroupData[{

Cell["insert Check flag", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
  3.6913976561529617`*^9}},ExpressionUUID->"3f7cdd2f-8158-424f-a000-\
17ea88e93dea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"arg1", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], "]"}]}], ",", 
     "args2___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"False", ",", "arg1", ",", "args2", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691399842191819*^9, 
   3.691399848731359*^9}},ExpressionUUID->"285d8a40-c18a-46c7-93a0-\
ca4c807e226a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckFlagDimension", "[", "NPropagationOperator", "]"}], "=", 
   "5"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691397808855783*^9, 3.6913978253090563`*^9}, 
   3.6913988177479887`*^9, 3.691398890847995*^9, 
   3.691399514439227*^9},ExpressionUUID->"8f90799d-9586-4bd2-9efc-\
3e1f2fd6f6a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"False", ",", "args___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"False", ",", 
       RowBox[{"{", 
        RowBox[{"CheckFlagDimension", "[", "NPropagationOperator", "]"}], 
        "}"}]}], "]"}], ",", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691397668275591*^9, 3.6913976883929033`*^9}, {
   3.691397829269376*^9, 3.691397846124062*^9}, {3.6913978855650187`*^9, 
   3.6913978886256647`*^9}},ExpressionUUID->"08f2949f-5863-45aa-a582-\
c661b49580ee"]
}, Closed]],

Cell[CellGroupData[{

Cell["set True when all checks done", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
  3.6913976561529617`*^9}, {3.691397715286193*^9, 
  3.69139772499686*^9}},ExpressionUUID->"a0a62de0-d7c6-4ed9-bbec-\
c5737b5e3a48"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "args___"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"True", ",", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.6913978952429934`*^9, 
   3.691397912831829*^9}},ExpressionUUID->"b7a1d103-b035-400e-9ff4-\
93150978c34e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["first $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
   3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
   3.691399163725749*^9}, {3.691497397390768*^9, 3.691497407780759*^9}, 
   3.691657569755228*^9, {3.6916576752432823`*^9, 
   3.6916576761930723`*^9}},ExpressionUUID->"1333aaa1-e0ee-4474-a9b1-\
9eb1ae50c7e4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"arg1", ":", 
       RowBox[{"Except", "[", "True", "]"}]}], ",", "args___"}], "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"arg1", ",", "args"}], "}"}], ",", "$Failed"}], "]"}]}]}], ":=",
    "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691497412246861*^9, 3.691497459675514*^9}, {
  3.691497709668282*^9, 
  3.6914977223609943`*^9}},ExpressionUUID->"2ee30382-0cc5-43cf-bbd7-\
77f006aed778"]
}, Closed]],

Cell[CellGroupData[{

Cell["Continuous flag", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, 3.691398002329606*^9, {3.691497471948711*^9, 
   3.6914974724974318`*^9}, 
   3.691657580714264*^9},ExpressionUUID->"312965f7-544f-420a-bb49-\
0f67bdcc49a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"False", "|", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"arg1", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "BooleanQ"}], "]"}]}], ",", 
     RowBox[{"args2", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"False", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Continuous", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], ",", 
     "\[IndentingNewLine]", "arg1", ",", "args2", ",", "\[IndentingNewLine]", 
     
     RowBox[{"Sequence", "@@", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"{", "opts", "}"}], ",", 
        RowBox[{"Except", "[", 
         RowBox[{"Continuous", "\[Rule]", "_"}], "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691391020328478*^9, 3.691391058653607*^9}, {
   3.691391133229455*^9, 3.691391135476047*^9}, {3.6913916921842403`*^9, 
   3.691391724653511*^9}, 3.691391949140339*^9, 3.691391981059813*^9, {
   3.691392013113418*^9, 3.69139203268049*^9}, {3.69139210003302*^9, 
   3.691392111229601*^9}, {3.691399591866624*^9, 
   3.691399618106271*^9}},ExpressionUUID->"d3f1afd2-9d40-41d9-b66e-\
e67220be009d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398090064618*^9, 
  3.691398091836032*^9}},ExpressionUUID->"50765f18-39a8-47e8-b017-\
ae15ef9230d7"],

Cell[CellGroupData[{

Cell["null events", "Subsection",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.534310488228697*^9, 3.534310494353874*^9}, 
   3.666609425618058*^9, {3.6666094862480707`*^9, 3.6666095206815586`*^9}, 
   3.6667259458527355`*^9, {3.6667260072685785`*^9, 3.666726008209152*^9}, {
   3.6909706174328337`*^9, 
   3.690970624838993*^9}},ExpressionUUID->"8f854eaa-060a-468f-beff-\
cd754e2e2d2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", "}"}], "|", 
       RowBox[{"UnityOperator", "[", "]"}]}], ")"}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.454590588656004*^9, 3.454590593806896*^9}, {
   3.455106101697146*^9, 3.455106141078717*^9}, {3.456322977275065*^9, 
   3.456322994774282*^9}, 3.486711144793584*^9, {3.534310512299883*^9, 
   3.534310525515341*^9}, {3.534312019783698*^9, 3.534312030883206*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610614376049*^9, 3.6666106257460995`*^9}, {3.6666124794088817`*^9, 
   3.6666124817218175`*^9}, {3.690970542786141*^9, 3.690970554393107*^9}, {
   3.691391268201935*^9, 3.691391275439385*^9}, 3.691391890857008*^9, 
   3.69139835562991*^9, {3.691400727058011*^9, 3.691400733294271*^9}, {
   3.691401154426983*^9, 3.6914011578324823`*^9}, {3.7031793222989902`*^9, 
   3.7031793258356423`*^9}},ExpressionUUID->"55ad17c1-2927-46a1-83bc-\
3f362dc5d1f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["basis specifications", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.626084834821652*^9, {3.666718322230075*^9, 3.666718347498945*^9}, {
   3.6673838939925632`*^9, 3.667383894962243*^9}, 3.683129928127585*^9, {
   3.690983020249568*^9, 3.690983027553432*^9}, 
   3.691399175339323*^9},ExpressionUUID->"b6cbd283-2b5f-472c-b4d3-\
7688f3319c3e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"status", ",", "cont", ",", "events", ",", 
     RowBox[{
      RowBox[{"Basis", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.454563825254508*^9, 
   3.454563826638453*^9}, {3.454563905455122*^9, 3.4545639089804993`*^9}, 
   3.456205058769329*^9, 3.456323032056343*^9, {3.50242936511091*^9, 
   3.502429366084257*^9}, 3.503127186296899*^9, {3.515077856481803*^9, 
   3.515077860272526*^9}, {3.53431026989006*^9, 3.534310284553986*^9}, {
   3.6667184627270803`*^9, 3.6667184640569763`*^9}, 3.666718497847576*^9, {
   3.690970098289364*^9, 3.690970102351604*^9}, {3.691391216100874*^9, 
   3.691391216722046*^9}, {3.6913981502320547`*^9, 3.6913982230367193`*^9}, {
   3.6913999880307903`*^9, 3.691399994566819*^9}, 
   3.6914011732840977`*^9},ExpressionUUID->"fad9a06f-051d-4e88-a142-\
e30b5553d251"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "SpinSystemUnknown"}], ")"}]}], 
   ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.454563828806386*^9, 
   3.4545639120761642`*^9, {3.455376344213114*^9, 3.455376346057372*^9}, 
   3.456205401485495*^9, 3.456323034576393*^9, 3.503127188744994*^9, {
   3.534310289761839*^9, 3.53431029312015*^9}, {3.69097010587998*^9, 
   3.690970113621426*^9}, {3.6913912187146597`*^9, 3.691391219137439*^9}, 
   3.691398160499175*^9, {3.6913981947847347`*^9, 3.6913982156721153`*^9}, 
   3.691399998823793*^9, 
   3.691401176516121*^9},ExpressionUUID->"8a505442-9e01-451b-b28e-\
853c8489ce90"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "BasisUnknown", 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"NPropagationOperator", "[", 
      RowBox[{"status", ",", "cont", ",", "events", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 
   3.69140117874692*^9},ExpressionUUID->"21be2647-50fa-4f24-a085-\
bd73e32017b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedBasisQ", "[", "basis", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"NPropagationOperator", "::", "undefbasis"}], ",", "basis"}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"NPropagationOperator", "[", 
      RowBox[{"status", ",", "cont", ",", "events", ",", 
       RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 3.69140117874692*^9, {3.6932180346731744`*^9, 
   3.693218040149607*^9}, {3.693218071460653*^9, 3.693218076431404*^9}, {
   3.6932186172237916`*^9, 3.6932186209454308`*^9}, {3.697221397487401*^9, 
   3.6972214022863655`*^9}, {3.6972216788965273`*^9, 3.697221680157203*^9}, {
   3.6992789248778954`*^9, 3.69927899444897*^9}, {3.699279056111178*^9, 
   3.699279056953815*^9}, {3.69927968458012*^9, 3.6992797408182793`*^9}, {
   3.699279925412359*^9, 
   3.699279981649849*^9}},ExpressionUUID->"727a5e3b-2cb9-4a6c-8328-\
7aa248bb7751"]
}, Closed]],

Cell[CellGroupData[{

Cell["set up BackgroundGenerator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.502839560490985*^9, 3.502839565176372*^9}, {
   3.532438161776326*^9, 3.5324381640431232`*^9}, {3.54341082791413*^9, 
   3.5434108337521667`*^9}, 
   3.709375005057172*^9},ExpressionUUID->"6bd78f07-0ab9-49eb-8373-\
0ecb0348e7f6"],

Cell["pre-diagonalization has been disabled in v3.0", "Text",
 CellChangeTimes->{{3.692847813601705*^9, 
  3.692847825065948*^9}},ExpressionUUID->"9f08c1e7-8117-40de-8b18-\
c501f538a16a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"False", ",", "morestatus___"}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "events_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "evbackg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"evbackg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"NPropagationOperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"True", ",", "morestatus"}], "}"}], ",", "cont", ",", 
         "events", ",", " ", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", 
                RowBox[{"_Hold", "|", "NullGeneratorPattern"}], "]"}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"HeldGeneratorSymbol", "[", "evbackg", "]"}], ",", 
               "\[IndentingNewLine]", "\t", "_", ",", "evbackg"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532438192185872*^9, 3.5324382545397863`*^9}, 
   3.532438313835868*^9, {3.53243836363794*^9, 3.532438409477851*^9}, 
   3.5324387823958063`*^9, {3.532438880178722*^9, 3.532438905904896*^9}, {
   3.53245092012462*^9, 3.532450926913773*^9}, 3.532450974693555*^9, {
   3.534310358636334*^9, 3.534310377276428*^9}, {3.5415318154112253`*^9, 
   3.5415318229703093`*^9}, {3.5429556978232927`*^9, 3.54295570744648*^9}, {
   3.5429558819873734`*^9, 3.5429558971675463`*^9}, {3.543245145020617*^9, 
   3.5432453060311317`*^9}, {3.543245346853058*^9, 3.5432453525063343`*^9}, {
   3.543245479879105*^9, 3.543245520589139*^9}, 3.543246579112441*^9, {
   3.5432534136180353`*^9, 3.543253437074998*^9}, {3.543410809935897*^9, 
   3.543410821876163*^9}, 3.543413455222966*^9, {3.543688097626602*^9, 
   3.543688213677889*^9}, {3.543688244548811*^9, 3.5436882461085052`*^9}, 
   3.543688279487761*^9, {3.5436883690107183`*^9, 3.5436883713530617`*^9}, {
   3.587550653940123*^9, 3.587550753557995*^9}, 3.621348805395721*^9, {
   3.621349557910268*^9, 3.6213495591884527`*^9}, 3.6215735466916323`*^9, {
   3.666610461408619*^9, 3.666610470998974*^9}, {3.666611655832932*^9, 
   3.666611656195207*^9}, {3.6666118305700426`*^9, 3.6666118834112663`*^9}, {
   3.666611978240513*^9, 3.666611978710616*^9}, {3.666612010000487*^9, 
   3.6666120341297517`*^9}, {3.666612294967608*^9, 3.6666123051444035`*^9}, {
   3.6666138238609586`*^9, 3.6666138779917064`*^9}, {3.6666139233812385`*^9, 
   3.6666139237815084`*^9}, {3.6666896749038057`*^9, 3.66668967550323*^9}, {
   3.666693281747729*^9, 3.666693283856164*^9}, {3.666885921177236*^9, 
   3.6668859469104295`*^9}, {3.6668859853376894`*^9, 
   3.6668859903166633`*^9}, {3.690970230302383*^9, 3.690970235113655*^9}, {
   3.691391246795205*^9, 3.6913912541212473`*^9}, {3.691398256877244*^9, 
   3.691398330210616*^9}, 3.691399757405748*^9, 3.691399918318404*^9, {
   3.691400367152504*^9, 3.6914004798234*^9}, {3.691400515447125*^9, 
   3.6914006507508717`*^9}, 3.691400835355508*^9, {3.691401205441142*^9, 
   3.6914012101536007`*^9}, {3.692847595235621*^9, 3.692847795035656*^9}, 
   3.7093740724868717`*^9, {3.709374504273954*^9, 3.709374504276712*^9}, {
   3.709375005067644*^9, 
   3.709375005071349*^9}},ExpressionUUID->"be4deb83-32cf-4b56-b970-\
cdb5ca6179d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["events", "Subsection",
 CellChangeTimes->{{3.6909706502058496`*^9, 3.690970654973537*^9}, {
  3.692847920047133*^9, 
  3.692847920924678*^9}},ExpressionUUID->"46188a5a-9d1f-48f4-a1ff-\
87de418c0e70"],

Cell[CellGroupData[{

Cell["PulseSequence elements", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 
  3.692847937764781*^9}},ExpressionUUID->"0f9918c5-6c6f-468f-9e22-\
60f39b46b9ba"],

Cell["take options into PulseSequence", "Text",
 CellChangeTimes->{{3.6928479733079147`*^9, 
  3.692847979394462*^9}},ExpressionUUID->"e9ce6780-0f06-4588-bc20-\
afed53181c25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_PulseSequence", "]"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"PulseSequenceQ", "[", "events", "]"}]}], ":=", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"status", ",", "cont", ",", 
     RowBox[{"PulseSequence", "[", 
      RowBox[{"events", ",", "opts"}], "]"}], ",", "more", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6928420888951273`*^9, 
  3.692842152566959*^9}},ExpressionUUID->"a45333b1-8198-4297-8ae5-\
2c0554bde34c"]
}, Closed]],

Cell[CellGroupData[{

Cell["after decoding of PulseSequence", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 
  3.69284796656359*^9}},ExpressionUUID->"984f8220-c979-404e-8841-\
f8ca333ec593"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", "_EventList", "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "morestatus"}], "}"}], ",", "cont", 
     ",", "\[IndentingNewLine]", 
     RowBox[{"EventList", "[", 
      RowBox[{"events", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Chronology", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Chronology", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"ImplementBackgroundGenerator", "\[Rule]", "True"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ExpandRepeatedEvents", "\[Rule]", 
          RowBox[{"If", "[", 
           RowBox[{"cont", ",", "True", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ExpandRepeatedEvents", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "NPropagationOperator", "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"Options", "[", "EventList", "]"}], ",", 
              RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "more", ",", 
     "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.459403611419217*^9, 3.4594036438443937`*^9}, {
   3.459403725781039*^9, 3.4594037309083157`*^9}, {3.459408711958606*^9, 
   3.459408714467761*^9}, 3.464328075904245*^9, {3.464695379520875*^9, 
   3.4646954137997932`*^9}, {3.465814860620288*^9, 3.465814888174513*^9}, {
   3.503027085072076*^9, 3.5030270997206917`*^9}, {3.503032349105281*^9, 
   3.503032395582123*^9}, 3.503127150743004*^9, {3.508090439583303*^9, 
   3.508090480358121*^9}, {3.5144545315614767`*^9, 3.514454565048649*^9}, {
   3.514454646972604*^9, 3.514454651506188*^9}, {3.514457068494399*^9, 
   3.5144570685635567`*^9}, 3.514809519181155*^9, {3.51482124543471*^9, 
   3.514821246122735*^9}, 3.514868524715065*^9, 3.514868851948365*^9, {
   3.51499222248971*^9, 3.514992268629366*^9}, {3.5166039514155493`*^9, 
   3.516603959381312*^9}, {3.534310528631629*^9, 3.5343105347156677`*^9}, {
   3.534313503516695*^9, 3.534313504737646*^9}, {3.534398740916671*^9, 
   3.5343987424438763`*^9}, {3.666608230514469*^9, 3.6666082721519346`*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610523629199*^9, 3.6666105417587404`*^9}, {3.6666106725464892`*^9, 
   3.666610675199015*^9}, {3.6666107148817043`*^9, 3.666610746276681*^9}, 
   3.6666108584956484`*^9, {3.6666111925323596`*^9, 3.666611210048849*^9}, {
   3.6666114768762207`*^9, 3.666611489595416*^9}, 3.666611550828224*^9, {
   3.666611593307498*^9, 3.66661160099645*^9}, {3.6666120971877337`*^9, 
   3.666612102246954*^9}, {3.6666122010387964`*^9, 3.6666122437883954`*^9}, {
   3.6666123632294493`*^9, 3.6666123793642483`*^9}, {3.666612440702112*^9, 
   3.6666124426883163`*^9}, {3.6666124731744547`*^9, 3.666612473612363*^9}, {
   3.6666125333332634`*^9, 3.666612536223451*^9}, {3.666612709052069*^9, 
   3.6666127193908396`*^9}, {3.666612777710683*^9, 3.666612832219817*^9}, {
   3.6666131867833357`*^9, 3.666613193435583*^9}, {3.666613270475043*^9, 
   3.666613272794323*^9}, {3.6666133044160204`*^9, 3.6666133612706065`*^9}, {
   3.666613455162436*^9, 3.6666134605722203`*^9}, {3.6666134978714647`*^9, 
   3.6666135321811514`*^9}, {3.666613934341844*^9, 3.6666139581006413`*^9}, {
   3.6666140578060856`*^9, 3.6666140665488667`*^9}, {3.66661414327384*^9, 
   3.6666141777386513`*^9}, 3.666616803057581*^9, {3.6666923663684254`*^9, 
   3.666692367698021*^9}, {3.6666932935574894`*^9, 3.666693295693761*^9}, {
   3.666885907975423*^9, 3.6668859087386875`*^9}, {3.6909705937939262`*^9, 
   3.6909706003113003`*^9}, 3.690991239770699*^9, {3.690991353090613*^9, 
   3.690991356255272*^9}, 3.6909914094528303`*^9, {3.6910569028349113`*^9, 
   3.691056905865327*^9}, {3.691061927890615*^9, 3.691061967047638*^9}, {
   3.6910622639040728`*^9, 3.6910622647984858`*^9}, 3.691062443418497*^9, {
   3.691390855426762*^9, 3.691390862991173*^9}, {3.691391279696642*^9, 
   3.691391288737391*^9}, {3.691392534425685*^9, 3.691392536260234*^9}, 
   3.69139259633524*^9, {3.6913926640237103`*^9, 3.6913926863196707`*^9}, 
   3.691398377149314*^9, {3.69139852474798*^9, 3.6913985462121067`*^9}, {
   3.691399250852113*^9, 3.6913992545687447`*^9}, {3.69139933578225*^9, 
   3.69139939440676*^9}, 3.691399775915741*^9, 3.691400863467993*^9, {
   3.6914012174093437`*^9, 3.691401221432158*^9}, {3.691434081729492*^9, 
   3.691434082401731*^9}, 
   3.7093750050812263`*^9},ExpressionUUID->"760b888b-af5e-41e1-b3d9-\
4cc152a8811e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "morestatus"}], "}"}], ",", "cont", 
     ",", "eventlist", ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691433960623218*^9, 3.691434043219462*^9}, 
   3.691434462983884*^9},ExpressionUUID->"f2b71e02-d9e5-4d0e-a5f6-\
6f558dc9b501"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["trap Hilbert Space incompatibility", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021943915395*^9, 3.5030219527295847`*^9}, {3.5343107110699883`*^9, 
   3.534310721386609*^9}, {3.534311142574582*^9, 3.534311148387733*^9}, 
   3.691398613270062*^9, {3.691399197382773*^9, 
   3.691399198241972*^9}},ExpressionUUID->"9923f3a0-4779-451a-93c0-\
4a28471c8f27"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
        "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "\[IndentingNewLine]", 
      "eventlist_EventList", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{"HilbertSpaceCompatibility", "[", 
        RowBox[{"eventlist", ",", "opts"}], "]"}], "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NPropagationOperator", "::", "hilbincompat"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5343107726442204`*^9, 3.534310858333661*^9}, 
   3.534398755298703*^9, {3.547010792472026*^9, 3.547010798433242*^9}, {
   3.6666083382466908`*^9, 3.666608345685981*^9}, 3.6666112844174905`*^9, {
   3.690970704100424*^9, 3.690970705217493*^9}, {3.69105871483134*^9, 
   3.6910587482283907`*^9}, {3.691391298488624*^9, 3.6913913084717407`*^9}, {
   3.691398564618116*^9, 3.691398598461609*^9}, 3.691399267796332*^9, 
   3.691401227878825*^9},ExpressionUUID->"5b080d7e-b5d4-4442-8cdd-\
197e16ea94b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
        "}"}]}], ",", 
      RowBox[{"cont_", "?", "BooleanQ"}], ",", "\[IndentingNewLine]", 
      "eventlist_EventList", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"HilbertSpaceCompatibility", "[", 
       RowBox[{"eventlist", ",", "opts"}], "]"}], "]"}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "morestatus"}], "}"}], 
     ",", "cont", ",", "\[IndentingNewLine]", "eventlist", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5343107726442204`*^9, 3.534310858333661*^9}, 
   3.534398755298703*^9, {3.547010792472026*^9, 3.547010798433242*^9}, {
   3.6666083382466908`*^9, 3.666608345685981*^9}, 3.6666112844174905`*^9, {
   3.690970704100424*^9, 3.690970705217493*^9}, {3.69105871483134*^9, 
   3.6910587482283907`*^9}, {3.691391298488624*^9, 3.6913913084717407`*^9}, {
   3.691398564618116*^9, 3.691398598461609*^9}, {3.6913986302927647`*^9, 
   3.691398679019043*^9}, {3.691399275319232*^9, 3.6913992792787037`*^9}, {
   3.691401232077981*^9, 
   3.691401235345401*^9}},ExpressionUUID->"4cddf580-d8d9-44e3-b960-\
2733864f45bf"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["checks and flags (2)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 3.691497398413538*^9}, {
  3.691657597551735*^9, 3.691657603767311*^9}, {3.691657691899529*^9, 
  3.691657693890112*^9}},ExpressionUUID->"b478de86-28af-4223-aa79-\
2dc2542bca04"],

Cell[CellGroupData[{

Cell["second $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 
  3.691497398413538*^9}},ExpressionUUID->"caa590e1-a549-44ff-b9b1-\
58cac4fc9988"],

Cell["continuously check until all other checks are complete", "Text",
 CellChangeTimes->{{3.6914010562716417`*^9, 3.69140107024336*^9}, {
  3.691401438463211*^9, 
  3.69140145401991*^9}},ExpressionUUID->"d27ee4a2-54ad-4506-a384-\
7c9d0f7a1e40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "False", ",", "morecheckflags__"}], 
        "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.6913980379475822`*^9}, {3.691400270965768*^9, 
   3.691400273000134*^9}, {3.691401246783072*^9, 3.691401261628582*^9}, {
   3.691401417817514*^9, 
   3.691401422629837*^9}},ExpressionUUID->"1d3837d9-6cd5-46fc-8118-\
c00419878b83"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "False", ",", 
         "morecheckflags__"}], "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}], ":=", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "morecheckflags"}], 
      "}"}], ",", "args"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.69139807543729*^9}, {3.6914002796355658`*^9, 
   3.691400279931965*^9}, {3.691401268582445*^9, 
   3.691401282439878*^9}},ExpressionUUID->"b37e18ad-aebc-4944-a93b-\
6bedf98b659e"]
}, Closed]],

Cell[CellGroupData[{

Cell["numerical readiness", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, {3.5394494601995707`*^9, 
   3.5394494644933357`*^9}, {3.542280127397629*^9, 3.54228013347538*^9}, {
   3.690970751308037*^9, 3.6909707810962467`*^9}, {3.690972007962603*^9, 
   3.690972024212504*^9}, {3.690984027065432*^9, 3.690984032191633*^9}, {
   3.6913923990506144`*^9, 3.691392406888403*^9}, {3.691392787395994*^9, 
   3.691392787833499*^9}, {3.691398995211268*^9, 3.6913989968344173`*^9}, {
   3.691657722452734*^9, 
   3.6916577265050573`*^9}},ExpressionUUID->"9d35b706-c567-4a11-b81e-\
9f76e3c0511e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
        "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}]}], "]"}], ",", "___"}], "]"}]}], ",",
      "more___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "suspsymbols", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagationOperator", "::", "argnotready"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ReportSuspectSymbols", "[", 
        RowBox[{"{", 
         RowBox[{"eventlist", ",", "more"}], "}"}], "]"}], ";", 
       "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970789202134*^9, 3.69097091718412*^9}, {
   3.690972053068953*^9, 3.690972055162653*^9}, {3.690972123020767*^9, 
   3.690972168897552*^9}, {3.690972307524001*^9, 3.69097248383584*^9}, {
   3.690972885909957*^9, 3.690972900088601*^9}, {3.6913913136476803`*^9, 
   3.69139131586931*^9}, {3.691392464889511*^9, 3.691392478241403*^9}, {
   3.691398668621318*^9, 3.691398668953146*^9}, {3.691399027639586*^9, 
   3.691399033058919*^9}, 
   3.691399294307775*^9},ExpressionUUID->"70d21797-dc56-425e-a6af-\
c9c394391ee4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
        "morestatus___"}], "}"}]}], ",", 
     RowBox[{"cont_", "?", "BooleanQ"}], ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
       "morestatus"}], "}"}], ",", "cont", ",", "eventlist", ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690971008414692*^9, 3.69097105616591*^9}, {
   3.690971441454911*^9, 3.690971451563552*^9}, 3.690984599299467*^9, 
   3.690991134304167*^9, {3.691056935670138*^9, 3.6910569360141907`*^9}, {
   3.6913913573417473`*^9, 3.691391361657955*^9}, {3.691398734108169*^9, 
   3.691398746800288*^9}, {3.691399060789405*^9, 3.6913990802973003`*^9}, {
   3.6913993038376427`*^9, 
   3.6913993181942053`*^9}},ExpressionUUID->"ca5848f8-f2a5-4411-a522-\
545abe191509"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Continuous \[Rule] False", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"254923df-e731-40b2-b4c8-9bba3fc82e59"],

Cell[CellGroupData[{

Cell["compose propagator for EventList", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}},ExpressionUUID->"76484171-2659-4443-9db2-\
d994384cff23"],

Cell["\<\
generate propagator in the Zeeman basis. This avoids multiple unnecessary \
basis transformations. \
\>", "Text",
 CellChangeTimes->{{3.691057269564514*^9, 3.691057292161083*^9}, {
  3.691057336291565*^9, 3.69105735297647*^9}, {3.691057497310364*^9, 
  3.69105750680392*^9}},ExpressionUUID->"4711ce1d-1775-4a66-a752-\
076257191420"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"EventList", "[", 
      RowBox[{"st_", ",", "chars_", ",", 
       RowBox[{"events", ":", 
        RowBox[{"{", 
         RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], "]"}],
      ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zbmatreps", ",", "zbasis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zbmatreps", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"NPropagationOperator", "[", 
             RowBox[{
             "True", ",", "False", ",", "#", ",", "zbasis", ",", "opts"}], 
             "]"}], ",", "zbasis"}], "]"}], "&"}], "/@", "events"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "zbmatreps", "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"First", "@", "zbmatreps"}], ",", 
           RowBox[{"Fold", "[", 
            RowBox[{"Dot", ",", 
             RowBox[{"First", "@", "zbmatreps"}], ",", 
             RowBox[{"Drop", "[", 
              RowBox[{"zbmatreps", ",", "1"}], "]"}]}], "]"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "zbasis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.534311007807122*^9, {3.534311071430175*^9, 3.534311103043881*^9}, {
   3.534311161325684*^9, 3.534311162592239*^9}, 3.5343112035758257`*^9, 
   3.5343181098498573`*^9, {3.5343188669035254`*^9, 3.534318867680813*^9}, 
   3.534398763917116*^9, {3.539449684776085*^9, 3.539449707703122*^9}, 
   3.539449776135705*^9, {3.542266586702509*^9, 3.542266587087212*^9}, 
   3.542282400817648*^9, 3.542282816552648*^9, 3.5422830970682573`*^9, 
   3.542283430931848*^9, {3.626027588356846*^9, 3.6260276198866873`*^9}, {
   3.642514521629387*^9, 3.642514572366727*^9}, {3.6425146195639467`*^9, 
   3.64251462038365*^9}, {3.642515539979156*^9, 3.642515554774953*^9}, {
   3.6666083784669704`*^9, 3.666608387648285*^9}, 3.6666112917429123`*^9, {
   3.6666313866011186`*^9, 3.666631391711933*^9}, {3.6666315192473907`*^9, 
   3.6666315685180807`*^9}, {3.6666932577165184`*^9, 3.666693258016091*^9}, {
   3.666789522111123*^9, 3.666789526380568*^9}, {3.6667896066878667`*^9, 
   3.666789622969426*^9}, {3.666789784816805*^9, 3.666789816266426*^9}, {
   3.666793582521138*^9, 3.666793582596608*^9}, {3.690971730169973*^9, 
   3.690971732322891*^9}, {3.690984086403597*^9, 3.6909841073924303`*^9}, 
   3.69098455989948*^9, {3.690986491425609*^9, 3.6909864988935633`*^9}, {
   3.690986614222039*^9, 3.6909866507617903`*^9}, 3.690986749472444*^9, {
   3.691057297029677*^9, 3.691057305434599*^9}, {3.691057356891182*^9, 
   3.691057394042478*^9}, {3.6910574321858263`*^9, 3.691057473541171*^9}, {
   3.69105751083149*^9, 3.69105753339581*^9}, {3.691391374901676*^9, 
   3.691391410268654*^9}, {3.691402366524681*^9, 3.691402413850623*^9}, {
   3.691407240616992*^9, 3.691407242097354*^9}, {3.7284667834422817`*^9, 
   3.7284667933201604`*^9}, {3.728466826710038*^9, 3.728466833471223*^9}, {
   3.728466877987506*^9, 3.7284668920781193`*^9}, {3.72846741768495*^9, 
   3.7284674249552765`*^9}, {3.728467463142763*^9, 3.728467525130724*^9}, {
   3.728467972316101*^9, 
   3.728467982817518*^9}},ExpressionUUID->"92425591-44aa-4a55-91a5-\
a262d9b85221"]
}, Open  ]],

Cell[CellGroupData[{

Cell["single events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.455105945796645*^9, 3.455105956524001*^9}, {
   3.455106372676097*^9, 3.455106380003372*^9}, {3.503115517984421*^9, 
   3.503115520925441*^9}, {3.534312824576314*^9, 3.53431282696943*^9}, 
   3.534317079264015*^9, 
   3.534387196885672*^9},ExpressionUUID->"67054de3-d034-429f-8938-\
a8035f93fdf3"],

Cell["\<\
generate propagators in the ZeemanBasis to save unnecessary transformations. \
They will be basis-independent anyway. \
\>", "Text",
 CellChangeTimes->{{3.691057636816265*^9, 
  3.691057656870406*^9}},ExpressionUUID->"90011e48-77a2-479b-8a87-\
4f04234b37b0"],

Cell[CellGroupData[{

Cell["Null events", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.484301088331937*^9, 3.484301110963764*^9}, {
  3.503024812706325*^9, 3.503024827850071*^9}, {3.503024870705112*^9, 
  3.50302490230342*^9}, {3.5343114395338573`*^9, 3.5343114437467546`*^9}, {
  3.690987153294479*^9, 
  3.690987154241378*^9}},ExpressionUUID->"90104e3a-2ce4-4f38-8fe5-\
741df3504546"],

Cell[CellGroupData[{

Cell["PropagatorCalculationProcedure\[Rule]None", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 
  3.6909877968302298`*^9}},ExpressionUUID->"564eaf6b-9abc-4e42-8b51-\
dbbf61cff079"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "True", ",", "None", ",", "__"}], "}"}], 
       ",", "\[IndentingNewLine]", "_", ",", "___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "basis_", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909877338744802`*^9, 3.690987773088852*^9}, {3.69098818773563*^9, 
   3.690988188404853*^9}, {3.691391398210943*^9, 3.691391404612554*^9}, {
   3.6913921720231457`*^9, 3.6913921732998238`*^9}, 
   3.691592933541375*^9},ExpressionUUID->"db04cdce-cf77-4e71-b033-\
cb8395c27c31"]
}, Closed]],

Cell[CellGroupData[{

Cell["IntegrateEvolutionOverTime and zero duration", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.690987811069519*^9}, {
   3.6909878417596493`*^9, 3.6909878568756104`*^9}, 
   3.6909881982470407`*^9},ExpressionUUID->"eaf2b11d-2c0b-45f5-94f9-\
6d630f23be99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
        
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "True", ",", 
          "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", "___Rule"}], "]"}], ",", 
      "\[IndentingNewLine]", "basis_", ",", "\[IndentingNewLine]", 
      "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "T", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, 3.6909882038151903`*^9, {
   3.69139143082561*^9, 3.691391447414576*^9}, {3.6913921772296677`*^9, 
   3.691392178620309*^9}, 
   3.6915929420290537`*^9},ExpressionUUID->"ab3e54b4-9189-4301-abb7-\
26670af9915b"]
}, Closed]],

Cell[CellGroupData[{

Cell["null evolution ShapeFunction", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, 3.455106406967524*^9, {3.455357656096076*^9, 
   3.4553576616132*^9}, {3.4648512522160473`*^9, 3.464851261206229*^9}, {
   3.5030249613369837`*^9, 3.50302496731923*^9}, 
   3.691592680852573*^9},ExpressionUUID->"8798b992-a42a-4bfc-a587-\
982dce1b434f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "_", ",", 
         "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"___", ",", " ", "NullGeneratorPattern"}], "]"}], ",", 
         "_"}], "}"}], ",", "___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
     "basis_", ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.690988217743535*^9, 3.690988232558065*^9}, {
   3.6913914533940067`*^9, 3.6913914576505404`*^9}, {3.691392182613861*^9, 
   3.691392187794449*^9}, {3.691592947520401*^9, 3.691592948519438*^9}, 
   3.709374504283842*^9},ExpressionUUID->"1c2c5689-2d2b-497a-b9fb-\
4fc49b0399ab"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, {3.503307845369619*^9, 3.503307854191724*^9}, {
   3.534311745984529*^9, 
   3.5343117488862343`*^9}},ExpressionUUID->"eb162830-5f18-4e97-b31a-\
65279adb2b1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"UnitySuperoperator", "[", "___", "]"}], ",", "___"}], "}"}],
        ",", "___Rule"}], "]"}], ",", "\[IndentingNewLine]", "basis_", ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.69098807785886*^9, 3.690988095648629*^9}, {
   3.6909897721602793`*^9, 3.690989792302166*^9}, {3.691391464041877*^9, 
   3.6913914715224752`*^9}, {3.691392194912504*^9, 3.691392199306883*^9}, 
   3.691592953910719*^9},ExpressionUUID->"c25048a9-8818-4b9f-8e15-\
128b4e2f9566"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Product of RotationSuperoperators", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 3.534312831293592*^9, {
   3.7095504893925085`*^9, 
   3.7095504933768435`*^9}},ExpressionUUID->"be669a25-7196-4433-b989-\
8bb5c636bc38"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
   RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
    RowBox[{"Event", "[", 
     RowBox[{
      RowBox[{"True", "|", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
        "__"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"R", ":", 
         RowBox[{"Dot", "[", 
          RowBox[{
           RowBox[{"RotationSuperoperator", "[", "___", "]"}], ",", 
           RowBox[{
            RowBox[{"RotationSuperoperator", "[", "___", "]"}], ".."}]}], 
          "]"}]}], ",", "___"}], "}"}], ",", "___Rule"}], "]"}], ",", 
    "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{"R", "/.", 
   RowBox[{"{", 
    RowBox[{"RotationSuperoperator", "\[Rule]", " ", "RotationOperator"}], 
    "}"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.7095504992671413`*^9, 3.709550524745584*^9}, {3.7095508211544123`*^9, 
   3.7095508321612806`*^9}, {3.728467799417349*^9, 
   3.728467809556778*^9}},ExpressionUUID->"734b9550-3557-4a62-9a31-\
931ead3b5aad"]
}, Open  ]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 
   3.534312831293592*^9},ExpressionUUID->"cf78a53d-6d55-4aa9-bbbb-\
fae716b94ae7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"RotationSuperoperator", "[", "args___", "]"}], ",", "___"}],
         "}"}], ",", "___Rule"}], "]"}], ",", "\[IndentingNewLine]", "basis_",
      ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"RotationOperator", "[", "args", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, {3.728467739678376*^9, 3.728467744924554*^9}, {
   3.7284678379226956`*^9, 3.728467875762597*^9}, {3.7284679429028907`*^9, 
   3.7284679492324433`*^9}},ExpressionUUID->"6ccad821-84c5-4d90-b635-\
2d52298b43f0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Time-independent Hamiltonian", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9},ExpressionUUID->"b5db813f-d984-4df5-a0cf-\
df507bc1b2de"],

Cell[CellGroupData[{

Cell["Time-independent commutation superoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, 3.534312208835496*^9, 
   3.534312835224263*^9},ExpressionUUID->"7b26618d-e2c1-48e1-8907-\
f35b8a30da27"],

Cell["evolve under the associated Hamiltonian", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534312697186016*^9, 
  3.5343127063854103`*^9}},ExpressionUUID->"f9b5e0fe-374a-4d63-b892-\
ade2f74765a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"CommutationSuperoperator", "[", 
          RowBox[{"minusIop_", ",", "___Rule"}], "]"}], ",", "\[Tau]_"}], 
        "}"}], ",", "evopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"minusIop", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Complex", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}], ",", "\[Tau]"}], 
        "}"}], ",", "evopts"}], "]"}], ",", "basis", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503025687858303*^9, 3.503025722245736*^9}, {
   3.5031120589480553`*^9, 3.503112110693466*^9}, {3.5031133894727087`*^9, 
   3.5031133896856327`*^9}, 3.503115153550331*^9, {3.5111775809053907`*^9, 
   3.511177584763298*^9}, {3.534312215814622*^9, 3.534312266563973*^9}, 
   3.534312530792787*^9, {3.534312732855695*^9, 3.534312766231317*^9}, {
   3.666608484435109*^9, 3.6666084865346394`*^9}, 3.6666113039965553`*^9, {
   3.6668022157789855`*^9, 3.6668022260903473`*^9}, {3.66681292825787*^9, 
   3.6668129299977474`*^9}, {3.6909844672795877`*^9, 3.690984470085635*^9}, {
   3.690988499468053*^9, 3.6909885262845984`*^9}, {3.690988567156177*^9, 
   3.690988628579484*^9}, {3.691059604153894*^9, 3.691059606048283*^9}, {
   3.69139149389701*^9, 3.6913915067973127`*^9}, 3.691593112043873*^9, {
   3.691593300179624*^9, 3.6915933169049597`*^9}, 
   3.697205300812402*^9},ExpressionUUID->"5baac135-2109-4f7d-8e09-\
4e737fa7dc3e"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent Hamiltonian", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9},ExpressionUUID->"2f20d931-0425-47da-9d93-\
3c8e4eae6b1f"],

Cell["if the Operator is diagonalized, use it in that form", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586361647781171*^9, 
  3.586361658171316*^9}},ExpressionUUID->"6ee8e422-a63a-46c4-b959-\
c0c08921bd04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Hop", ":", 
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "basis1_", ",", 
             "___Rule"}], "]"}]}]}], ",", "\[Tau]_"}], "}"}], ",", 
       "evopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "basis_", ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
        RowBox[{"First", "@", 
         RowBox[{"NDiagonalize", "[", 
          RowBox[{"Hop", ",", "basis"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "[", 
           RowBox[{"X", ".", 
            RowBox[{"DiagonalMatrix", "[", 
             RowBox[{"Exp", "[", 
              RowBox[{
               RowBox[{"-", "I"}], "*", "\[Tau]", "*", "evals"}], "]"}], 
             "]"}], ".", "Xinv"}], "]"}]}], ",", "\[IndentingNewLine]", 
         "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6995637863739443`*^9, 3.6995637866311684`*^9}, {
   3.699563819359129*^9, 3.699563822312069*^9}, {3.6995639100283985`*^9, 
   3.6995639134810038`*^9}, {3.699563951972223*^9, 3.6995639549306326`*^9}, {
   3.728466979395077*^9, 3.72846705703021*^9}, {3.728467087746894*^9, 
   3.7284670879269066`*^9}, {3.7284671473742356`*^9, 3.728467171323807*^9}, {
   3.7284672264536676`*^9, 3.7284672897552023`*^9}, {3.728467330991682*^9, 
   3.7284673960291677`*^9}},ExpressionUUID->"a542dc30-fc41-48de-9ed6-\
412ebf6b6a26"],

Cell["otherwise use the MatrixExp:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586362011529046*^9, 
  3.5863620187422867`*^9}},ExpressionUUID->"521ad118-e593-4413-ab61-\
5cb63b8b436d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "basis_", ",", 
      "\[IndentingNewLine]", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UseMatrixExpWhenPossible", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matrep", ",", "zbasis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "I"}], " ", "Hop", "\[Times]", " ", "\[Tau]"}], "/.", 
            RowBox[{"{", 
             RowBox[{"evopts", ",", "opts"}], "}"}]}], ")"}], ",", "zbasis"}],
          "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"N", "@", 
           RowBox[{"Chop", "@", 
            RowBox[{"MatrixExp", "[", 
             RowBox[{"N", "@", "matrep"}], "]"}]}]}]}], ",", 
         "\[IndentingNewLine]", "zbasis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.5875487453814287`*^9, 3.587548750271266*^9}, {3.587549184401637*^9, 
   3.5875491956715727`*^9}, 3.587551497715831*^9, {3.621156110832801*^9, 
   3.621156112012767*^9}, {3.6666084939054546`*^9, 3.6666084967445064`*^9}, 
   3.6666113063004503`*^9, {3.6667890644872985`*^9, 3.666789069959587*^9}, {
   3.6667895516308956`*^9, 3.666789551789101*^9}, {3.6668023258856225`*^9, 
   3.6668023270445833`*^9}, {3.666802579260866*^9, 3.666802589794033*^9}, {
   3.6668026320214353`*^9, 3.6668026333398294`*^9}, {3.666812942318075*^9, 
   3.666812966599028*^9}, {3.6669445156443725`*^9, 3.666944519985222*^9}, {
   3.6669447336397448`*^9, 3.666944733882427*^9}, {3.6909844811186533`*^9, 
   3.690984482885489*^9}, {3.6909888249242573`*^9, 3.690988889452402*^9}, {
   3.691057877346417*^9, 3.691057893722179*^9}, {3.691391533479982*^9, 
   3.691391536261326*^9}, 3.691402517815181*^9, {3.6914072617781076`*^9, 
   3.691407262861771*^9}, 3.6914957755793858`*^9, {3.6928466113575172`*^9, 
   3.692846613347499*^9}, 3.692846884837802*^9, 3.6928469164398937`*^9, 
   3.6928480548434057`*^9, {3.728466931819523*^9, 3.7284669543797865`*^9}, {
   3.7284669866172624`*^9, 3.728466986805249*^9}, {3.72846763557213*^9, 
   3.728467663820156*^9}},ExpressionUUID->"c56dbc6b-1695-46d3-a9bb-\
4c583261b0c7"],

Cell["\<\
if not using the MatrixExp, convert into a function for explicit integration\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.503112000557836*^9, 
  3.503112017213619*^9}},ExpressionUUID->"128a39cc-a4d2-489a-83d6-\
e9ced3e587b1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "T_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"!", "UseMatrixExpWhenPossible"}], "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", "\[IndentingNewLine]", 
      RowBox[{"st", ",", "ch", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"StandardizeGenerator", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"t", ",", 
             RowBox[{"Evaluate", "[", "Hop", "]"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Basis", "\[Rule]", "basis"}]}], "\[IndentingNewLine]", 
          "]"}], ",", "\[IndentingNewLine]", "\[Tau]"}], "}"}], ",", 
       "\[IndentingNewLine]", "evopts"}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "basis", ",", "\[IndentingNewLine]", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503111914458187*^9, 3.503111933778318*^9}, {3.5031119773263063`*^9, 
   3.503111996098827*^9}, {3.5031120333747587`*^9, 3.503112043315461*^9}, {
   3.503112188293264*^9, 3.5031121940051394`*^9}, {3.5031123829707193`*^9, 
   3.503112387544818*^9}, {3.5031132367593727`*^9, 3.50311323700453*^9}, 
   3.503114828230123*^9, {3.507022907785177*^9, 3.507022910006372*^9}, 
   3.508400570646513*^9, {3.534312162544573*^9, 3.5343121937375183`*^9}, 
   3.5422810910117064`*^9, {3.542955740285832*^9, 3.542955765226015*^9}, {
   3.6667890510363503`*^9, 3.6667890725573006`*^9}, {3.666789542428689*^9, 
   3.6667895448189096`*^9}, {3.66680233177588*^9, 3.6668023373175964`*^9}, {
   3.666812953427063*^9, 3.66681296102861*^9}, {3.6669445762091246`*^9, 
   3.666944586328432*^9}, {3.666944717785367*^9, 3.666944727511091*^9}, {
   3.6909844872225027`*^9, 3.690984489124609*^9}, {3.6909889157805653`*^9, 
   3.690988979396927*^9}, {3.691391543102109*^9, 3.691391557834894*^9}, 
   3.6914957863472767`*^9, 
   3.7093740725165586`*^9},ExpressionUUID->"90eb0585-4919-47e4-b7cb-\
99c53cc3dbb5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Time-dependent Hamiltonian", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 
   3.534312862341494*^9}},ExpressionUUID->"b14e5037-52b5-4ec7-bc97-\
5363fdfecab0"],

Cell[CellGroupData[{

Cell["Time-dependent commutation superoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, {3.503025797624085*^9, 3.50302579778263*^9}, {
   3.534312817477545*^9, 
   3.5343128456219187`*^9}},ExpressionUUID->"0901d5cd-e9b7-474c-8df8-\
d709863d576b"],

Cell["evolve under the associated time-dependent Hamiltonian", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.503112404451489*^9, 3.50311240925805*^9}, {
  3.534312799489729*^9, 
  3.5343128035324*^9}},ExpressionUUID->"4da2e967-98f7-4ace-bdf8-fb98e720097c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",",
          "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"t_", ",", 
             RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
             RowBox[{"CommutationSuperoperator", "[", 
              RowBox[{"op_", ",", "___Rule"}], "]"}]}], "]"}], ",", 
           "\[Tau]_"}], "}"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
        "]"}]}], ",", "\[IndentingNewLine]", "basis_", ",", 
      "\[IndentingNewLine]", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
     RowBox[{"Event", "[", "\[IndentingNewLine]", 
      RowBox[{"st", ",", "ch", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
           RowBox[{"op", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Complex", "[", 
               RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}]}], "]"}], ",", 
         "\[Tau]"}], "}"}], ",", "evopts"}], "]"}], ",", 
     "\[IndentingNewLine]", "basis", ",", "\[IndentingNewLine]", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503025752698345*^9, 3.5030257583747396`*^9}, {3.5030258334600573`*^9, 
   3.503025850747231*^9}, {3.503025881421885*^9, 3.5030259696222754`*^9}, {
   3.5030260590423822`*^9, 3.503026096992079*^9}, {3.503112232053441*^9, 
   3.503112277937085*^9}, {3.503112319384701*^9, 3.503112366768518*^9}, {
   3.503112422322407*^9, 3.5031124994636602`*^9}, 3.5031125532271223`*^9, {
   3.503112586208776*^9, 3.503112592640542*^9}, {3.503112630090947*^9, 
   3.503112631440538*^9}, {3.503113245678843*^9, 3.5031132459237843`*^9}, {
   3.503113459055827*^9, 3.503113464669381*^9}, {3.503113634395102*^9, 
   3.5031136611266193`*^9}, {3.503113703737402*^9, 3.503113773767356*^9}, {
   3.503113849430991*^9, 3.503113871961054*^9}, {3.503114849311439*^9, 
   3.503114854894581*^9}, {3.507023031173218*^9, 3.507023164828182*^9}, 
   3.534312327172946*^9, {3.534312400901217*^9, 3.534312453718451*^9}, 
   3.5343125212115097`*^9, 3.5422811141952744`*^9, {3.6666085082554593`*^9, 
   3.666608508685293*^9}, 3.6666113088259196`*^9, {3.690984497229733*^9, 
   3.690984499235046*^9}, {3.6910598688327503`*^9, 3.691059899950292*^9}, {
   3.6910599781356916`*^9, 3.6910599861831207`*^9}, {3.691060166591395*^9, 
   3.6910601742377863`*^9}, {3.6910602190608683`*^9, 3.691060221294345*^9}, {
   3.6913915667347593`*^9, 3.691391580922913*^9}, 3.697205325928746*^9, 
   3.7093750050903893`*^9},ExpressionUUID->"f5c639fe-83e4-4086-96c4-\
056927be67fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent Hamiltonian", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 
   3.534312862341494*^9}},ExpressionUUID->"1845626c-5b46-492b-82d0-\
a90a53b56b8d"],

Cell["new coding (SDv3) solves directly for U", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534312467914893*^9, 3.5343124847541857`*^9}, {
  3.691395907100765*^9, 
  3.691395923731641*^9}},ExpressionUUID->"d4cb4266-035d-421f-902a-\
3d9e18f1f780"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ch", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}],
             ",", "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Hfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"t_", ",", 
              RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
              RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "\[Tau]_"}], 
          "}"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
        "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", "basis_", 
      ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "n", ",", "u", ",", "uvec", ",", "umat", ",", "h", ",", "hvec", ",", 
       "hmat", ",", "t$", ",", "maineqns", ",", "initialconds", ",", 
       "Hmatfunc", ",", "NDSolveopts"}], "}"}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"NDSolveopts", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"SimplifyRules", "[", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"evopts", ",", "opts"}], "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            "]"}], ",", 
           RowBox[{"Options", "[", "NDSolveValue", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Hmatfunc", "=", "\[IndentingNewLine]", 
        RowBox[{"Function", "[", 
         RowBox[{"t$", ",", "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
           RowBox[{"Normal", "@", 
            RowBox[{"MatrixRepresentation", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Hfunc", "[", 
                RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "basis"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"n", "=", 
        RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"uvec", "[", "t$_", "]"}], "=", 
        RowBox[{"Through", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"Array", "[", 
            RowBox[{"u", ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}], "[", "t$", 
          "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"hmat", "[", "t$_", "]"}], "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Through", "[", 
           RowBox[{
            RowBox[{"Flatten", "[", 
             RowBox[{"Array", "[", 
              RowBox[{"h", ",", 
               RowBox[{"{", 
                RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}], "[", "t$", 
            "]"}], "]"}], ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"umat", "[", "t$_", "]"}], "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"uvec", "[", "t$", "]"}], ",", "n"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"maineqns", "=", 
        RowBox[{"Inner", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#1", "\[Equal]", "#2"}], ")"}], "&"}], ",", 
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"uvec", "[", "t$", "]"}], ",", "t$"}], "]"}], ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"-", "I"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"hmat", "[", "t$", "]"}], ".", 
              RowBox[{"umat", "[", "t$", "]"}]}], ")"}]}], "]"}], ",", 
          "List"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"initialconds", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"umat", "[", "ta", "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", 
               RowBox[{"r_", ",", "r_"}], "]"}], "[", "_", "]"}], 
             "\[RuleDelayed]", 
             RowBox[{
              RowBox[{
               RowBox[{"u", "[", 
                RowBox[{"r", ",", "r"}], "]"}], "[", "ta", "]"}], "\[Equal]", 
              "1"}]}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", 
               RowBox[{"r_", ",", "s_"}], "]"}], "[", "_", "]"}], 
             "\[RuleDelayed]", 
             RowBox[{
              RowBox[{
               RowBox[{"u", "[", 
                RowBox[{"r", ",", "s"}], "]"}], "[", "ta", "]"}], "\[Equal]", 
              "0"}]}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Partition", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"NDSolveValue", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Join", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"maineqns", "/.", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"h", "[", 
                    RowBox[{"r_", ",", "s_"}], "]"}], "[", "t$_", "]"}], 
                  "\[RuleDelayed]", 
                  RowBox[{
                   RowBox[{"Hmatfunc", "[", "t$", "]"}], 
                   "\[LeftDoubleBracket]", 
                   RowBox[{"r", ",", "s"}], "\[RightDoubleBracket]"}]}]}], 
                ",", "\[IndentingNewLine]", "initialconds"}], 
               "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"uvec", "[", "t$", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", 
              "NDSolveopts"}], "\[IndentingNewLine]", "]"}], "/.", 
            RowBox[{"t$", "\[Rule]", "tb"}]}], ",", "\[IndentingNewLine]", 
           "n"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.6965301772962933`*^9, 3.696530180930071*^9}, {3.6965302456665397`*^9, 
   3.6965302462366176`*^9}, {3.6965302863378963`*^9, 3.696530286516847*^9}, {
   3.7038391697608905`*^9, 3.7038391872636127`*^9}, {3.703839234334403*^9, 
   3.703839234718218*^9}, 3.709375005103487*^9, {3.7130260073612957`*^9, 
   3.713026011096119*^9}, {3.7130261210947456`*^9, 3.7130261249725447`*^9}, {
   3.713026405853484*^9, 3.713026431824382*^9}, {3.713026471973709*^9, 
   3.713026487581007*^9}, {3.713026531890134*^9, 
   3.7130265320296593`*^9}},ExpressionUUID->"1f200501-a797-4a2a-8176-\
6e67a7221652"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Repeat", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.690984518900131*^9, 3.690984520602982*^9}, 
   3.692848521296042*^9},ExpressionUUID->"68464f96-2d44-468c-a6d0-\
ae69202fef1a"],

Cell["compute the MatrixPower, using the ZeemanBasis", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586362082931669*^9, 3.586362110560563*^9}, {
  3.691060844886135*^9, 3.691060848597477*^9}, {3.691060889955954*^9, 
  3.691060895195961*^9}},ExpressionUUID->"761a2103-e188-45a8-b062-\
5419d40f1887"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
      RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"st", ":", 
           RowBox[{"(", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Repeat", "[", 
           RowBox[{
           "evlist_EventList", ",", "n_Integer", ",", "evtropts___Rule"}], 
           "]"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
         "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", "basis_",
        ",", "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", 
      "]"}]}], "/;", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "RepeatPropagator"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "zbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatrixPower", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"NPropagationOperator", "[", 
              RowBox[{
              "True", ",", "False", ",", "evlist", ",", "zbasis", ",", 
               "opts"}], "]"}], ",", "zbasis"}], "]"}], ",", 
           "\[IndentingNewLine]", "n"}], "\[IndentingNewLine]", "]"}], ",", 
         "\[IndentingNewLine]", "zbasis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, 3.542281134468389*^9, {3.5645684544067097`*^9, 
   3.5645685012249613`*^9}, {3.586362122636345*^9, 3.5863624728699913`*^9}, {
   3.586363380330854*^9, 3.586363385359961*^9}, {3.587576139268099*^9, 
   3.5875761417981577`*^9}, {3.5875762341269007`*^9, 
   3.5875763853272038`*^9}, {3.5875766585438547`*^9, 3.5875766813166533`*^9}, 
   {3.666608549421843*^9, 3.6666085497823753`*^9}, 3.6666113141219406`*^9, {
   3.683186587217523*^9, 3.6831865919508047`*^9}, 3.683187098958549*^9, {
   3.690984514860692*^9, 3.690984524039979*^9}, {3.691060687197613*^9, 
   3.691060753746748*^9}, {3.691060866239098*^9, 3.691060959114229*^9}, {
   3.691061045218045*^9, 3.691061064384056*^9}, {3.691391609964263*^9, 
   3.691391622649879*^9}, {3.691402547637679*^9, 3.691402548638754*^9}, {
   3.691407274584907*^9, 3.691407275830823*^9}, {3.691677015180834*^9, 
   3.6916770182838287`*^9}, 3.692848522364584*^9, 3.70937500511231*^9, {
   3.7284675721040993`*^9, 
   3.728467613179577*^9}},ExpressionUUID->"0e956e70-7b47-47b4-a185-\
3634db5e4f53"]
}, Open  ]],

Cell[CellGroupData[{

Cell["PrecalculatedEvent", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.538677605389827*^9, 
   3.538677607531299*^9}},ExpressionUUID->"ae6ec5a0-ae63-433b-8d61-\
4ba1d93eb72a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
     RowBox[{"True", ",", "False", ",", "\[IndentingNewLine]", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",",
          "\[IndentingNewLine]", 
         RowBox[{"PrecalculatedEvent", "[", 
          RowBox[{
          "precalch_", ",", "op_Operator", ",", "precalevopts___Rule"}], 
          "]"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
        "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", "basis_", 
      ",", "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "UsePrecalculatedPropagator"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   "op"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, {3.53867763931421*^9, 3.5386776481776333`*^9}, {
   3.538677692924055*^9, 3.538677702585209*^9}, {3.5391124476711493`*^9, 
   3.539112453900564*^9}, {3.6666085615139894`*^9, 3.666608567772622*^9}, 
   3.6666113169912148`*^9, {3.690984529675124*^9, 3.690984531611169*^9}, {
   3.691391630156105*^9, 3.691391637265486*^9}, {3.6914382516732264`*^9, 
   3.691438340756529*^9}},ExpressionUUID->"1a6eed37-acbd-4a07-9d25-\
7621755abb73"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["multiply propagators for more than one EventList", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021943915395*^9, 3.5030219527295847`*^9}, {3.503027210880397*^9, 
   3.503027221606976*^9}, {3.503027292489621*^9, 3.503027312343033*^9}, {
   3.5343107306937113`*^9, 3.5343107460664673`*^9}, {3.5343376340763063`*^9, 
   3.534337637508718*^9}, {3.6831300454358*^9, 
   3.6831300488566217`*^9}},ExpressionUUID->"95214c48-b2ce-49bf-b313-\
bae0ee31cbbc"],

Cell["I am not sure when this functionality is used", "Text",
 CellChangeTimes->{{3.691401671569675*^9, 3.691401675938533*^9}, {
  3.691401733080574*^9, 
  3.691401735647024*^9}},ExpressionUUID->"db057a4d-51b6-40b8-a105-\
f2b4c5994857"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "False", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"eventlists", ":", 
      RowBox[{"{", 
       RowBox[{"_EventList", ".."}], "}"}]}], ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Apply", "[", 
      RowBox[{"Dot", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"NPropagationOperator", "[", 
            RowBox[{
            "status", ",", "False", ",", "#", ",", "basis", ",", "opts"}], 
            "]"}], ",", "\[IndentingNewLine]", "basis"}], 
          "\[IndentingNewLine]", "]"}], "&"}], "/@", "eventlists"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "basis", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"FilterRules", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "opts", "}"}], ",", 
          RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], ",", 
        RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.503027229930895*^9, 3.5030272753538237`*^9}, 
   3.503127223681653*^9, 3.5080904868656073`*^9, {3.5110948035085783`*^9, 
   3.511094809538148*^9}, {3.514809621759454*^9, 3.51480962494986*^9}, {
   3.534310559824835*^9, 3.534310663949286*^9}, {3.534318131391774*^9, 
   3.534318135798539*^9}, {3.534318863384739*^9, 3.534318864274518*^9}, 
   3.534398748573251*^9, {3.6666082839680557`*^9, 3.6666082903471823`*^9}, {
   3.666608348179677*^9, 3.6666083506979966`*^9}, 3.6666112788008957`*^9, {
   3.666789177828559*^9, 3.6667892232783976`*^9}, {3.690970668510743*^9, 
   3.690970696802676*^9}, {3.6913913215118723`*^9, 3.691391331292815*^9}, 
   3.691391797295349*^9, {3.6914017107560663`*^9, 
   3.691401716949312*^9}},ExpressionUUID->"916f8afc-f973-41a4-a3a1-\
24bed725d26b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Continuous \[Rule] True", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438180169045*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9d8cbefe-3193-492f-95f4-55a2b865bf25"],

Cell["This code is adapted from Christian Bengs\[CloseCurlyQuote]", "Text",
 CellChangeTimes->{{3.683129971989072*^9, 3.683129981251539*^9}, {
   3.691657497964322*^9, 3.691657503760005*^9}, 
   3.6916615495172787`*^9},ExpressionUUID->"7cfb3568-1d5e-46f9-9931-\
0c1fc9152798"],

Cell[CellGroupData[{

Cell["initialize", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666288750390873`*^9, 3.666628880639269*^9}, 
   3.666693196673871*^9, {3.666803836772476*^9, 3.666803838839712*^9}, {
   3.667383454902224*^9, 3.667383459131519*^9}, {3.69165785131144*^9, 
   3.691657858134141*^9}, {3.691658440975215*^9, 
   3.691658442710451*^9}},ExpressionUUID->"c96012b0-6b36-40a4-9397-\
9a9563f42dc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{
    "True", ",", "True", ",", "eventlist_EventList", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "1"}], "}"}], ",", "eventlist", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691657873391885*^9, 
  3.691657945141138*^9}},ExpressionUUID->"84dfd794-c084-4d2b-90e1-\
df0629fe93b0"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 1: calculate OperatorTrajectory", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666288750390873`*^9, 3.666628880639269*^9}, 
   3.666693196673871*^9, {3.666803836772476*^9, 3.666803838839712*^9}, {
   3.667383454902224*^9, 3.667383459131519*^9}, {3.691657926509634*^9, 
   3.691657933930669*^9}},ExpressionUUID->"e6c85e2a-998c-42e7-8313-\
9c85c8828f51"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "1"}], "}"}], ",", "eventlist_EventList", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opfunc", ",", "timeinterval", ",", "opbasis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"opbasis", "=", 
        RowBox[{
         RowBox[{"OperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "NPropagationOperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"timeinterval", "=", 
        RowBox[{"TotalEventTimeInterval", "[", "eventlist", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opfunc", "=", "\[IndentingNewLine]", 
        RowBox[{"NPropagationOperator", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
          "eventlist", ",", "opbasis", ",", "basis", ",", "opts"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"OperatorTrajectoryFunction", "[", 
        RowBox[{
         RowBox[{"{", "timeinterval", "}"}], ",", "opfunc", ",", "opbasis", 
         ",", "basis", ",", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}], 
            ",", 
            RowBox[{"Options", "[", "OperatorTrajectoryFunction", "]"}]}], 
           "]"}]}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6666289124528093`*^9, 3.6666289293314714`*^9}, {
   3.6666292438056517`*^9, 3.6666292624053235`*^9}, {3.6666293573302946`*^9, 
   3.666629359782241*^9}, {3.666629601829337*^9, 3.666629602149353*^9}, {
   3.6666296531241007`*^9, 3.666629655556298*^9}, {3.666630077968399*^9, 
   3.6666300879777575`*^9}, {3.6666301950069337`*^9, 
   3.6666301977666435`*^9}, {3.6666459433926744`*^9, 
   3.6666459439326925`*^9}, {3.6666460114447546`*^9, 
   3.6666460116123705`*^9}, {3.6666811521421547`*^9, 
   3.6666811572916994`*^9}, {3.666692297016621*^9, 3.6666922971971903`*^9}, {
   3.6666929882398653`*^9, 3.666692993651271*^9}, {3.6666931167997785`*^9, 
   3.666693116988055*^9}, 3.666693189725669*^9, {3.6666932426762137`*^9, 
   3.666693243276569*^9}, 3.6666936087329016`*^9, {3.666693639028225*^9, 
   3.66669364016801*^9}, {3.6666937043912306`*^9, 3.6666937394108896`*^9}, {
   3.666693823881803*^9, 3.666693824070124*^9}, {3.6666949232305417`*^9, 
   3.6666949412856855`*^9}, {3.6666950019161067`*^9, 
   3.6666950021266456`*^9}, {3.666695089054925*^9, 3.666695089926364*^9}, {
   3.6667035276535788`*^9, 3.6667035281540465`*^9}, {3.6667038351896296`*^9, 
   3.6667038785504613`*^9}, {3.6667039284267206`*^9, 
   3.6667039337841587`*^9}, {3.666704312916829*^9, 3.6667043130577583`*^9}, {
   3.6667087441505656`*^9, 3.6667087442788424`*^9}, {3.666708938725809*^9, 
   3.666708953894667*^9}, {3.666709030054926*^9, 3.666709059933845*^9}, {
   3.6667093015052814`*^9, 3.6667093118553276`*^9}, {3.666709502365758*^9, 
   3.6667095025116253`*^9}, {3.666719203049678*^9, 3.6667192396081176`*^9}, {
   3.6667198475894976`*^9, 3.666719860536139*^9}, {3.6667199235734324`*^9, 
   3.6667199246344485`*^9}, {3.6667200942126427`*^9, 3.666720129011141*^9}, {
   3.666721798347973*^9, 3.6667218080989833`*^9}, {3.66672184756015*^9, 
   3.6667218480273895`*^9}, {3.6667283766686797`*^9, 3.666728380395379*^9}, {
   3.666800356113885*^9, 3.6668003834452796`*^9}, 3.66681310643476*^9, {
   3.6668140907749553`*^9, 3.666814102848647*^9}, {3.666942704632001*^9, 
   3.6669427113728776`*^9}, {3.6669427636372285`*^9, 3.666942769565648*^9}, {
   3.6669428093466635`*^9, 3.6669428367765174`*^9}, {3.6669428996543555`*^9, 
   3.666942899962555*^9}, 3.683128236236635*^9, {3.691657824154235*^9, 
   3.691657829032033*^9}, {3.69165793886899*^9, 3.691657990292151*^9}, {
   3.713024818030466*^9, 3.7130248199730916`*^9}, {3.7130248968715043`*^9, 
   3.7130248969595666`*^9}, {3.7132713027260733`*^9, 3.713271322158067*^9}, {
   3.713271367768744*^9, 3.713271378235326*^9}, {3.7132715358449516`*^9, 
   3.7132715520577497`*^9}, {3.7132716214062*^9, 3.713271627188526*^9}, {
   3.713271663949704*^9, 3.7132716694152217`*^9}, {3.7132718298871875`*^9, 
   3.713271879063548*^9}, {3.713273451847956*^9, 3.713273455470559*^9}, {
   3.713554133476846*^9, 3.7135541336749873`*^9}, {3.713605938212428*^9, 
   3.7136059508840537`*^9}},ExpressionUUID->"666d159e-cf7e-4c31-9869-\
866948cab83e"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 2: check validity", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
  3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
  3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
  3.691658005034162*^9, 3.691658021226699*^9}, {3.691658167424262*^9, 
  3.691658170470058*^9}},ExpressionUUID->"661ef741-6423-4eaa-ba05-\
c752e5f34844"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
     "eventlist_EventList", ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"EventDuration", "[", "eventlist", "]"}], "]"}], 
      "\[LessEqual]", "0"}], ",", "\[IndentingNewLine]", "\t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagationOperator", "::", "contzerodur"}], "]"}], ";", 
       "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{"HilbertSpaceCompatibility", "[", 
        RowBox[{"eventlist", ",", "opts"}], "]"}], "]"}]}], ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagationOperator", "::", "hilbincompat"}], "]"}], ";", 
       "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"eventlist", ",", "_PrecalculatedEvent"}], "]"}]}], ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagationOperator", "::", "contnoprecalev"}], "]"}], ";", 
       "$Failed"}], ")"}], ",", "\[IndentingNewLine]", "True", ",", 
     "\[IndentingNewLine]", "\t", 
     RowBox[{"NPropagationOperator", "[", 
      RowBox[{"True", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "3"}], "}"}], ",", "eventlist", ",", "opbasis", 
       ",", "basis", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.666629744736624*^9, {3.6666301081295195`*^9, 3.666630110147475*^9}, {
   3.666719864843292*^9, 3.6667198683249097`*^9}, {3.6667960819581037`*^9, 
   3.6667961397766275`*^9}, {3.666796202467792*^9, 3.6667962168053846`*^9}, 
   3.6667962487459445`*^9, {3.6667963398436794`*^9, 3.6667964114394565`*^9}, 
   3.6667964698199835`*^9, 3.6667965171376295`*^9, 3.666813114423455*^9, {
   3.666813208791678*^9, 3.666813210100481*^9}, 3.680955504975294*^9, 
   3.683130101632099*^9, {3.691658026629362*^9, 3.691658043380471*^9}, {
   3.691658098249446*^9, 3.691658109125815*^9}, {3.691660780309319*^9, 
   3.691660890334828*^9}, 3.691660940720689*^9, 
   3.69166127724006*^9},ExpressionUUID->"6df968dc-7387-42d1-bbf9-\
de7e5b8fe673"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 3: compile piecewise function ", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
  3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
  3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
  3.691658005034162*^9, 3.691658021226699*^9}, {3.691658174487835*^9, 
  3.691658177509932*^9}},ExpressionUUID->"baf6e6ea-1dd3-4893-bab8-\
728952764808"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{"True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"eventlist", ":", 
       RowBox[{"EventList", "[", 
        RowBox[{"st_", ",", "ch_", ",", 
         RowBox[{"events", ":", 
          RowBox[{"{", 
           RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
        "]"}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "funcsLtoR", ",", "timeintervalsLtoR", ",", "intervals", ",", "funcs", 
       ",", "lasttimepoint", ",", "InitialPropagator"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"timeintervalsLtoR", "=", 
        RowBox[{"Reverse", "[", 
         RowBox[{"Reverse", "/@", 
          RowBox[{"EventTimeIntervals", "[", "eventlist", "]"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"funcsLtoR", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{"#", ",", "1"}], "]"}], "&"}], "@", "\[IndentingNewLine]", 
         
         RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"NPropagationOperator", "[", 
             RowBox[{"True", ",", 
              RowBox[{"{", 
               RowBox[{"True", ",", "4"}], "}"}], ",", 
              RowBox[{"#1", "[", 
               RowBox[{"InitialTimePoint", "[", "#2", "]"}], "]"}], ",", "#2",
               ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], "&"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"Function", "[", 
            RowBox[{"UnityOperator", "[", "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Reverse", "@", "events"}]}], "\[IndentingNewLine]", 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"intervals", ",", "funcs"}], "}"}], "=", 
        RowBox[{"Transpose", "@", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"_", ",", "_"}], "}"}], ",", 
             RowBox[{"_InterpolatingFunction", "|", "_Function"}]}], "}"}]}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], ",", 
           "$Failed"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"intervals", ",", "funcs"}], "}"}], "=", 
            RowBox[{"Transpose", "@", 
             RowBox[{"Cases", "[", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{"timeintervalsLtoR", ",", "funcsLtoR"}], "}"}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], ",", 
                 RowBox[{"_InterpolatingFunction", "|", "_Function"}]}], 
                "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Function", "[", 
            RowBox[{"t", ",", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"Chop", "[", "\[IndentingNewLine]", 
               RowBox[{"N", "@", 
                RowBox[{"Piecewise", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"MapThread", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#1", "[", "t", "]"}], ",", "#2"}], "}"}], "&"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"funcs", ",", "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[LessEqual]", "t", "<", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ")"}], "&"}], "/@", 
                    RowBox[{"Most", "[", "intervals", "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "\[LessEqual]", "t", 
                    "\[LessEqual]", 
                    RowBox[{
                    "#", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}]}], ")"}], "&"}], "/@", 
                    RowBox[{"{", 
                    RowBox[{"Last", "[", "intervals", "]"}], "}"}]}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                    "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
                  "\[IndentingNewLine]", "Undefined"}], "\[IndentingNewLine]",
                  "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], ",",
          "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6666297502136602`*^9, 3.666629762206499*^9}, 
   3.6666301154323025`*^9, {3.6666306873822627`*^9, 3.666630687682001*^9}, {
   3.6666307866107593`*^9, 3.66663079279292*^9}, {3.666630843780203*^9, 
   3.666630844020713*^9}, {3.666630916708933*^9, 3.666630919120039*^9}, {
   3.6666311432042704`*^9, 3.666631151387723*^9}, {3.666631194845915*^9, 
   3.666631260375851*^9}, {3.6666313078444843`*^9, 3.66663130814419*^9}, {
   3.6666316440971613`*^9, 3.66663164714981*^9}, {3.666631685906866*^9, 
   3.6666317063276596`*^9}, {3.6666318092453957`*^9, 
   3.6666318743053207`*^9}, {3.6666323379974546`*^9, 
   3.6666323429334383`*^9}, {3.6666324066462307`*^9, 3.666632419005351*^9}, {
   3.6666329090573635`*^9, 3.666632924316862*^9}, {3.6666331527560043`*^9, 
   3.6666331538359985`*^9}, {3.6666331876992054`*^9, 3.666633213014859*^9}, {
   3.6666334002897773`*^9, 3.6666334207420053`*^9}, {3.666633470570064*^9, 
   3.666633496461276*^9}, {3.6666335698744698`*^9, 3.6666335711691236`*^9}, {
   3.6666336082938085`*^9, 3.666633610584656*^9}, {3.6666336474035316`*^9, 
   3.666633648853919*^9}, {3.6666337640920506`*^9, 3.6666337863434873`*^9}, 
   3.6666338266528225`*^9, {3.666633864768216*^9, 3.666633894174612*^9}, {
   3.6666339550907216`*^9, 3.666634002601797*^9}, {3.666634056725222*^9, 
   3.666634082208129*^9}, {3.666634234471589*^9, 3.666634264661652*^9}, {
   3.666634303760488*^9, 3.666634304059883*^9}, {3.6666343930796723`*^9, 
   3.666634406696066*^9}, 3.666634732536618*^9, {3.6666349124651394`*^9, 
   3.666634918059038*^9}, {3.6666350120575967`*^9, 3.6666350575230107`*^9}, {
   3.6666351634282427`*^9, 3.666635163706266*^9}, 3.666641497151764*^9, {
   3.666641528612031*^9, 3.666641528771546*^9}, {3.666641600690502*^9, 
   3.666641610880871*^9}, {3.666646046099635*^9, 3.6666460519639072`*^9}, {
   3.666646132627212*^9, 3.666646142117659*^9}, {3.6666461804649515`*^9, 
   3.6666461832745895`*^9}, {3.666646367012099*^9, 3.666646367292903*^9}, {
   3.6666464896676903`*^9, 3.666646495210701*^9}, {3.666681243473317*^9, 
   3.666681246002558*^9}, {3.666683458464487*^9, 3.6666834586648655`*^9}, {
   3.6666899599071507`*^9, 3.666689998154758*^9}, {3.666690029725212*^9, 
   3.6666901232130527`*^9}, {3.6666911204782267`*^9, 
   3.6666911652676067`*^9}, {3.6666912712148905`*^9, 3.666691280435643*^9}, {
   3.666691312281521*^9, 3.66669135377402*^9}, {3.6666922390214353`*^9, 
   3.6666922391908555`*^9}, {3.6666926001927814`*^9, 3.66669261034723*^9}, {
   3.6666927463793964`*^9, 3.66669274649982*^9}, {3.6666928191138*^9, 
   3.6666928303956785`*^9}, {3.6666928943771887`*^9, 3.666692901644882*^9}, 
   3.6666931245928907`*^9, {3.6666932354693403`*^9, 3.666693235821501*^9}, {
   3.6667037303362713`*^9, 3.6667037550475225`*^9}, {3.6667038029405155`*^9, 
   3.6667038302836957`*^9}, {3.6667198753676014`*^9, 3.666719884328268*^9}, {
   3.6667201408115273`*^9, 3.6667202099028015`*^9}, {3.6667883300899277`*^9, 
   3.666788337162409*^9}, {3.666788391621787*^9, 3.666788391890574*^9}, {
   3.666800395363905*^9, 3.6668003992375727`*^9}, {3.6668004451832857`*^9, 
   3.6668004907759867`*^9}, {3.6668007392162457`*^9, 3.666800739375801*^9}, {
   3.666804028705383*^9, 3.66680403374667*^9}, {3.6668042146419635`*^9, 
   3.6668042322921553`*^9}, 3.666804392942712*^9, {3.6668046236405773`*^9, 
   3.6668046257368383`*^9}, 3.666804685595687*^9, {3.6668047244912605`*^9, 
   3.6668047245578365`*^9}, 3.6668131247854843`*^9, {3.6668131896547537`*^9, 
   3.6668132053539004`*^9}, {3.6668858002682323`*^9, 3.666885832038566*^9}, {
   3.666940253975088*^9, 3.666940257069915*^9}, {3.6669404200870056`*^9, 
   3.666940425043862*^9}, {3.666940467335926*^9, 3.6669404894563*^9}, {
   3.666940586126114*^9, 3.6669405862729187`*^9}, {3.6669407841839733`*^9, 
   3.6669408300767136`*^9}, 3.6669408671527057`*^9, {3.666940908358775*^9, 
   3.6669409086476607`*^9}, {3.6669409566742315`*^9, 
   3.6669409574069242`*^9}, {3.666941025688573*^9, 3.666941028634165*^9}, {
   3.6669411184704137`*^9, 3.6669411187779417`*^9}, {3.6669411837657557`*^9, 
   3.666941186010166*^9}, {3.6669413958424406`*^9, 3.6669413996540647`*^9}, {
   3.6669422803251777`*^9, 3.6669422961727724`*^9}, {3.6669423444236383`*^9, 
   3.6669423532933025`*^9}, {3.6669424714940634`*^9, 
   3.6669424723145404`*^9}, {3.6669425856937494`*^9, 
   3.6669425892873583`*^9}, {3.6669426482662687`*^9, 
   3.6669426484335876`*^9}, {3.6669426940879927`*^9, 
   3.6669426942573824`*^9}, {3.666942930113154*^9, 3.666942971136715*^9}, {
   3.6669430357304573`*^9, 3.666943035855397*^9}, {3.6669430894963465`*^9, 
   3.666943090286268*^9}, {3.666943296213332*^9, 3.666943296349323*^9}, {
   3.6669438166344247`*^9, 3.666943827142829*^9}, {3.6673864921126614`*^9, 
   3.667386498574226*^9}, {3.6673865660841103`*^9, 3.6673865673952584`*^9}, {
   3.667386629554121*^9, 3.667386650063718*^9}, 3.683128152149973*^9, {
   3.691658136960492*^9, 3.691658145006069*^9}, {3.691658321577507*^9, 
   3.691658344527866*^9}, 3.691658375601693*^9, {3.6916613494179296`*^9, 
   3.691661394249073*^9}, 3.691662459585555*^9, {3.6916627834488573`*^9, 
   3.691662802325425*^9}, {3.691664150696534*^9, 3.6916641978946047`*^9}, 
   3.691664590843608*^9, {3.7132716768740215`*^9, 3.7132716923084*^9}, {
   3.7132717265267415`*^9, 3.713271775731049*^9}, {3.7132719406785774`*^9, 
   3.7132719415804615`*^9}, {3.713605955013011*^9, 
   3.7136059706575637`*^9}},ExpressionUUID->"761938c6-52c0-4444-a0d3-\
dfb99340348a"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 4: individual Events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6666296938453727`*^9, 3.666629729565936*^9}, {
  3.666728560499016*^9, 3.6667285608367743`*^9}, {3.667382468477577*^9, 
  3.6673824703263254`*^9}, {3.683130252147015*^9, 3.6831302549602118`*^9}, {
  3.691658005034162*^9, 3.691658021226699*^9}, {3.691658174487835*^9, 
  3.691658177509932*^9}, {3.691661526670512*^9, 
  3.6916615334355717`*^9}},ExpressionUUID->"365c781d-15a6-46dc-9d90-\
294f3dfcbdae"],

Cell[CellGroupData[{

Cell["stage 4: time independent event", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6668028503845963`*^9, 3.6668028603640347`*^9}, 
   3.691660112805435*^9},ExpressionUUID->"2ef8cae9-2bfc-4b0d-b27e-\
ed0c4828e184"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{"True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", "InitialPropagator_", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
         "evopts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tb", ",", "ta", ",", "Umatini", ",", "t", ",", "evals", ",", "evecs", 
       ",", "X", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tb", ",", "ta"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FinalTimePoint", "[", "ev", "]"}], ",", 
          RowBox[{"InitialTimePoint", "[", "ev", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Umatini", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"InitialPropagator", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
              RowBox[{"First", "@", 
               RowBox[{"NDiagonalize", "[", 
                RowBox[{"Hop", ",", "basis", ",", "opts"}], "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"SparseArray", "@", 
              RowBox[{"Chop", "@", 
               RowBox[{"N", "@", 
                RowBox[{"ExpToTrig", "@", 
                 RowBox[{"Normal", "[", "\[IndentingNewLine]", 
                  RowBox[{
                  "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
                   "\[IndentingNewLine]", 
                   RowBox[{"X", ",", "\[IndentingNewLine]", 
                    RowBox[{"DiagonalMatrix", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", "I"}], "*", "#", "\[Times]", 
                    RowBox[{"(", 
                    RowBox[{"t", "-", "ta"}], ")"}]}], "]"}], "&"}], "/@", 
                    "evals"}], "]"}], ",", "\[IndentingNewLine]", "Xinv", ",",
                     "\[IndentingNewLine]", "Umatini"}], 
                   "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
                  "]"}]}]}]}]}]}], ",", "\[IndentingNewLine]", "basis", ",", 
            RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6668096706752014`*^9, 3.6668097482363963`*^9}, {
   3.6668098393035917`*^9, 3.6668098444647646`*^9}, {3.666809922966113*^9, 
   3.6668099245365863`*^9}, {3.666810014673797*^9, 3.6668100190626945`*^9}, {
   3.6668101835600076`*^9, 3.666810221960625*^9}, {3.6668106554021378`*^9, 
   3.6668106636503572`*^9}, {3.6668108288210583`*^9, 
   3.6668108519888477`*^9}, {3.6668109596583295`*^9, 
   3.6668109604702473`*^9}, {3.6668110201602015`*^9, 3.666811033340513*^9}, {
   3.666811101119089*^9, 3.666811106839177*^9}, {3.6668111399584303`*^9, 
   3.666811140476263*^9}, {3.666811200687905*^9, 3.6668112016040087`*^9}, {
   3.666811275053439*^9, 3.666811276055363*^9}, {3.6668115776903577`*^9, 
   3.666811595148634*^9}, {3.6668116879885945`*^9, 3.6668117582851367`*^9}, {
   3.6668117983151426`*^9, 3.666811826823993*^9}, {3.6668118836980257`*^9, 
   3.6668118989420342`*^9}, {3.66681192959365*^9, 3.666811948872954*^9}, {
   3.666811983802644*^9, 3.666811996302373*^9}, {3.666812036009921*^9, 
   3.666812055439661*^9}, {3.6668120931473875`*^9, 3.666812097490468*^9}, {
   3.666812160445622*^9, 3.6668121605270853`*^9}, {3.6668121940175*^9, 
   3.666812203037937*^9}, {3.666812817032443*^9, 3.6668128295108337`*^9}, {
   3.666812865619753*^9, 3.6668128658000793`*^9}, {3.6668134105297775`*^9, 
   3.666813412517226*^9}, {3.666813498368389*^9, 3.6668135436237946`*^9}, {
   3.6668176126522284`*^9, 3.666817624362171*^9}, {3.6668858459981375`*^9, 
   3.666885850486342*^9}, {3.6668858869071226`*^9, 3.666885887076375*^9}, {
   3.666886191333212*^9, 3.666886198792856*^9}, {3.666886248864395*^9, 
   3.6668862567431984`*^9}, {3.6668863984558706`*^9, 3.666886428064548*^9}, {
   3.6668867062027235`*^9, 3.6668867198535905`*^9}, {3.66688682484492*^9, 
   3.6668868251143436`*^9}, {3.666943847420846*^9, 3.666943858470733*^9}, {
   3.6669440296672373`*^9, 3.6669440485676107`*^9}, {3.666944190725351*^9, 
   3.666944197224905*^9}, {3.691660122933939*^9, 3.691660224057448*^9}, {
   3.6916603085581627`*^9, 3.6916603091387377`*^9}, 3.6916620032515297`*^9, {
   3.691662331180921*^9, 3.691662335354856*^9}, {3.6916624123297033`*^9, 
   3.6916624224020452`*^9}, {3.691662525240026*^9, 
   3.691662525940324*^9}},ExpressionUUID->"9fa174c3-93bc-45a6-82e4-\
1e6769eb7b15"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 4: time-dependent Event", "Subsection",
 CellChangeTimes->{{3.691658481310473*^9, 3.691658494412518*^9}, 
   3.691660026526553*^9, 
   3.6916600859105463`*^9},ExpressionUUID->"3b0ade06-e5df-4296-b065-\
5c33e37e1036"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{"True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", "InitialPropagator_", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Hfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"args__", ",", 
              RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "\[Tau]_"}], 
          "}"}], ",", "evopts___Rule"}], "\[IndentingNewLine]", "]"}]}], ",", 
      "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "IntegrateEvolutionOverTime"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tb", ",", "ta", ",", "Hmatfunc", ",", "NDSolveopts", ",", "n", ",", 
       "u", ",", "uvec", ",", "uvecplain", ",", "uvecflat", ",", "umat", ",", 
       "h", ",", "hvec", ",", "hmat", ",", "t$", ",", "sol", ",", "Ufunc"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tb", ",", "ta"}], "}"}], "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"FinalTimePoint", "[", "ev", "]"}], ",", 
          RowBox[{"InitialTimePoint", "[", "ev", "]"}]}], "}"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Hmatfunc", "=", "\[IndentingNewLine]", 
        RowBox[{"Function", "[", 
         RowBox[{"tinternal", ",", "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
           RowBox[{"Normal", "@", 
            RowBox[{"MatrixRepresentation", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Hfunc", "[", 
                RowBox[{"tinternal", ",", "ta", ",", "tb"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "basis"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"NDSolveopts", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"SimplifyRules", "[", 
            RowBox[{"{", 
             RowBox[{"evopts", ",", "opts"}], "}"}], "]"}], ",", 
           RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"n", "=", 
        RowBox[{"BasisDimension", "[", 
         RowBox[{"Basis", "[", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"uvec", "[", "t$_", "]"}], ":=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"uvecflat", "[", "t$_", "]"}], ":=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{"Array", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"u", "[", 
               RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"uvecplain", "=", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"sol", "=", 
        RowBox[{"NDSolveValue", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"D", "[", 
              RowBox[{
               RowBox[{"uvecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
             "\[Equal]", 
             RowBox[{
              RowBox[{"-", "I"}], " ", 
              RowBox[{"(", 
               RowBox[{"Flatten", "[", 
                RowBox[{
                 RowBox[{"Hmatfunc", "[", "t$", "]"}], ".", 
                 RowBox[{"uvec", "[", "t$", "]"}]}], "]"}], ")"}]}]}], ",", 
            RowBox[{
             RowBox[{"uvecflat", "[", "ta", "]"}], "\[Equal]", 
             RowBox[{"Flatten", "[", 
              RowBox[{"Normal", "@", 
               RowBox[{"MatrixRepresentation", "[", 
                RowBox[{"InitialPropagator", ",", "basis"}], "]"}]}], 
              "]"}]}]}], "}"}], ",", "uvecplain", ",", 
          RowBox[{"{", 
           RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Ufunc", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"t", ",", 
          RowBox[{"Evaluate", "[", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"SparseArray", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Through", "[", 
                 RowBox[{"#", "[", "t", "]"}], "]"}], "&"}], "/@", "sol"}], 
              "]"}], ",", "basis", ",", 
             RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}]}], "]"}], 
           "]"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.666597909203027*^9, 3.6665979096254625`*^9}, {
   3.666599020274578*^9, 3.6665990277257147`*^9}, {3.66659909864276*^9, 
   3.6665991029022307`*^9}, 3.666599304373186*^9, {3.666599657858473*^9, 
   3.666599661391754*^9}, {3.666599733359562*^9, 3.6665998066580896`*^9}, {
   3.666599919426893*^9, 3.6665999956667557`*^9}, {3.666600087985359*^9, 
   3.6666000932295485`*^9}, 3.666600199232848*^9, {3.6666002374834476`*^9, 
   3.666600238372015*^9}, {3.666602885014431*^9, 3.6666028921526947`*^9}, {
   3.6666030978183575`*^9, 3.666603104431195*^9}, {3.6666031483481483`*^9, 
   3.6666031521385517`*^9}, 3.6666031928197823`*^9, {3.666603291013114*^9, 
   3.6666033541668987`*^9}, {3.666603404566019*^9, 3.6666034047458496`*^9}, {
   3.666603518164161*^9, 3.666603523743327*^9}, {3.6666036280010657`*^9, 
   3.666603639663065*^9}, {3.6666036701020555`*^9, 3.6666036708609133`*^9}, 
   3.666603701582719*^9, 3.66660405709531*^9, 3.666604179553322*^9, {
   3.6666047323180723`*^9, 3.6666047344159827`*^9}, 3.6666047654457426`*^9, {
   3.6666307209929295`*^9, 3.6666307234549313`*^9}, {3.6666320271470013`*^9, 
   3.6666320404149427`*^9}, {3.666632244020178*^9, 3.6666322712072153`*^9}, {
   3.666632849574505*^9, 3.6666328514291325`*^9}, {3.666632902225979*^9, 
   3.6666329041295214`*^9}, {3.6666329692480526`*^9, 
   3.6666329811116285`*^9}, {3.6666330148184633`*^9, 
   3.6666330156152077`*^9}, {3.666633103359518*^9, 3.6666331086368313`*^9}, 
   3.666633361403631*^9, {3.6666337194906845`*^9, 3.6666337481554875`*^9}, {
   3.666634119131753*^9, 3.6666341212303305`*^9}, 3.666634447557305*^9, 
   3.6666345211608334`*^9, {3.666634636953926*^9, 3.6666346828123055`*^9}, {
   3.666634798161745*^9, 3.666634882206352*^9}, 3.6666349266864944`*^9, 
   3.666634960975607*^9, {3.666641463271764*^9, 3.666641479991851*^9}, {
   3.6666415750910425`*^9, 3.6666415769152155`*^9}, {3.666641632834253*^9, 
   3.6666416330230045`*^9}, {3.6666416905087967`*^9, 
   3.6666417255237637`*^9}, {3.6666418628705425`*^9, 
   3.6666418661509333`*^9}, {3.6666420157789583`*^9, 
   3.6666420487583017`*^9}, {3.666642078839394*^9, 3.666642106085676*^9}, {
   3.6666422669194384`*^9, 3.666642270737256*^9}, {3.6666423175364456`*^9, 
   3.6666423202262464`*^9}, {3.6666423597679224`*^9, 
   3.6666423750767307`*^9}, {3.6666424548245025`*^9, 
   3.6666424645625134`*^9}, {3.6666425180976105`*^9, 3.666642598604713*^9}, {
   3.6666426343937335`*^9, 3.666642674189205*^9}, {3.666642708428*^9, 
   3.6666427589625254`*^9}, {3.6666429218879037`*^9, 
   3.6666429220665054`*^9}, {3.6666429716676583`*^9, 
   3.6666429720153055`*^9}, {3.6666430064649124`*^9, 3.666643034906424*^9}, {
   3.6666430656067777`*^9, 3.6666430711353955`*^9}, {3.6666431020941267`*^9, 
   3.6666431052728767`*^9}, {3.6666431378842316`*^9, 
   3.6666431447943935`*^9}, {3.6666435445536213`*^9, 
   3.6666436030594535`*^9}, {3.66664380003722*^9, 3.666643800218074*^9}, 
   3.6666438334167433`*^9, {3.6666438841174545`*^9, 3.6666439340141864`*^9}, {
   3.666643972763268*^9, 3.6666440107391696`*^9}, {3.6666440709218907`*^9, 
   3.6666440810654635`*^9}, {3.6666441127348814`*^9, 
   3.6666442593856163`*^9}, {3.666644300451782*^9, 3.6666443092817245`*^9}, {
   3.666644339721407*^9, 3.6666443406833344`*^9}, {3.666644374345644*^9, 
   3.6666443760461187`*^9}, {3.6666444656320286`*^9, 3.666644524211071*^9}, {
   3.6666447155283723`*^9, 3.6666447206169376`*^9}, {3.6666447576778083`*^9, 
   3.666644760020559*^9}, {3.6666449958019323`*^9, 3.6666450012030334`*^9}, {
   3.666645046580956*^9, 3.6666450660325837`*^9}, {3.666645096410139*^9, 
   3.666645097299687*^9}, {3.6666451471667666`*^9, 3.66664515882862*^9}, {
   3.6666452008510075`*^9, 3.666645259728883*^9}, {3.6666453126881666`*^9, 
   3.6666453142379913`*^9}, {3.6666453759264026`*^9, 
   3.6666453763879848`*^9}, {3.666645441448452*^9, 3.6666454420048113`*^9}, {
   3.666645565289109*^9, 3.6666455782319837`*^9}, {3.666645616331167*^9, 
   3.6666456275721264`*^9}, {3.666645663937138*^9, 3.6666456760203114`*^9}, {
   3.666645708734269*^9, 3.66664571411864*^9}, {3.66664575314882*^9, 
   3.6666457904356256`*^9}, {3.6666458242256365`*^9, 
   3.6666458418076487`*^9}, {3.6666458931759014`*^9, 3.66664592718591*^9}, {
   3.666646323450733*^9, 3.6666463321108866`*^9}, {3.666646411270471*^9, 
   3.6666464155292053`*^9}, {3.6666464663981075`*^9, 3.666646484128149*^9}, {
   3.6666813957155733`*^9, 3.666681424353899*^9}, {3.6666814608215494`*^9, 
   3.666681469491598*^9}, {3.6666816112492976`*^9, 3.666681616160986*^9}, {
   3.6666816497773104`*^9, 3.666681650108333*^9}, {3.6666834444148703`*^9, 
   3.666683444773012*^9}, {3.66669016377993*^9, 3.666690172060922*^9}, {
   3.6666908731557693`*^9, 3.66669089908415*^9}, {3.666690929511822*^9, 
   3.6666910078679886`*^9}, 3.666691051628936*^9, {3.6666910943343625`*^9, 
   3.666691108997552*^9}, {3.666691177988179*^9, 3.6666912060036497`*^9}, {
   3.666691239770779*^9, 3.666691244434476*^9}, {3.6666913791112084`*^9, 
   3.6666913924499807`*^9}, {3.6666914245011234`*^9, 3.666691428508274*^9}, {
   3.666691577705449*^9, 3.666691580137813*^9}, {3.666691681266681*^9, 
   3.6666917117258615`*^9}, {3.6666917657448473`*^9, 
   3.6666917697068014`*^9}, {3.666691870204399*^9, 3.6666918823928037`*^9}, {
   3.6666919195826015`*^9, 3.6666919616323233`*^9}, {3.6666919965815105`*^9, 
   3.6666920054693036`*^9}, {3.6666920434020925`*^9, 
   3.6666920444780254`*^9}, {3.66669207940158*^9, 3.6666921022808495`*^9}, 
   3.6666921343485365`*^9, {3.666692174809317*^9, 3.666692174991188*^9}, {
   3.6666932234068365`*^9, 3.666693229148839*^9}, {3.6667040361464324`*^9, 
   3.6667040382179575`*^9}, 3.6667041590146356`*^9, {3.6667194628038025`*^9, 
   3.66671947974584*^9}, {3.6667196009767284`*^9, 3.6667196208566413`*^9}, {
   3.6667196717362533`*^9, 3.6667196770928326`*^9}, {3.666719896955762*^9, 
   3.6667199110871954`*^9}, {3.6667202331783047`*^9, 3.66672024143148*^9}, {
   3.6667202996772137`*^9, 3.6667204560241966`*^9}, {3.6667205065718403`*^9, 
   3.666720544762698*^9}, {3.66672059029108*^9, 3.6667205910111885`*^9}, {
   3.6667206576026897`*^9, 3.666720675659787*^9}, {3.666720716307582*^9, 
   3.666720727309433*^9}, {3.666720773429446*^9, 3.666720787828712*^9}, {
   3.666720818378682*^9, 3.666720821447302*^9}, 3.666720919276641*^9, 
   3.6667209940147405`*^9, {3.6667210261318054`*^9, 3.6667210310418677`*^9}, {
   3.6667210635915546`*^9, 3.6667210641904135`*^9}, {3.6667211769479847`*^9, 
   3.666721198559025*^9}, {3.6667212312899065`*^9, 3.6667212346401806`*^9}, {
   3.6667214798449264`*^9, 3.666721486495676*^9}, {3.666721525428608*^9, 
   3.6667215258350697`*^9}, {3.666724735600957*^9, 3.6667247381918583`*^9}, {
   3.666788395277556*^9, 3.6667883979396935`*^9}, {3.6667884298188667`*^9, 
   3.6667884381790643`*^9}, {3.6667884733777695`*^9, 3.666788473707493*^9}, {
   3.666804013508936*^9, 3.6668040365914383`*^9}, {3.666885744709885*^9, 
   3.6668857494711075`*^9}, {3.6668858346290736`*^9, 
   3.6668858348192387`*^9}, {3.6669398551805663`*^9, 3.666939858350196*^9}, {
   3.691658409110989*^9, 3.691658414860751*^9}, {3.691658562463215*^9, 
   3.6916586652601233`*^9}, {3.691659955639051*^9, 3.691659974802783*^9}, {
   3.6916601340680113`*^9, 3.6916601393065023`*^9}, {3.691660282805608*^9, 
   3.691660283308435*^9}, 3.6916627098171387`*^9, {3.7132714156131687`*^9, 
   3.7132714472288074`*^9}, {3.7132721290205765`*^9, 
   3.7132721351899586`*^9}, {3.7135275631697874`*^9, 3.7135276760111713`*^9}, 
   3.7135277384294767`*^9, {3.7135312117607117`*^9, 3.7135312145006866`*^9}, {
   3.713531274821681*^9, 3.7135312989908743`*^9}, {3.713531357713472*^9, 
   3.7135313779648457`*^9}, {3.7136147875590954`*^9, 
   3.713614810547907*^9}},ExpressionUUID->"4d1bfe6e-8753-4e36-9acc-\
d7baa39abb3e"]
}, Closed]],

Cell[CellGroupData[{

Cell["stage 4: RotationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.666787806623809*^9, 3.6667878240530386`*^9}, {
  3.666795792768396*^9, 3.6667957947412214`*^9}, {3.6673829561962423`*^9, 
  3.667382957205306*^9}, {3.667387445429882*^9, 3.6673874490404735`*^9}, {
  3.6916600993640423`*^9, 3.69166010733225*^9}, {3.691665188673538*^9, 
  3.691665192101946*^9}},ExpressionUUID->"7b35a443-6bf4-4f48-acb4-\
1b6e56c68358"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{"True", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "4"}], "}"}], ",", "InitialPropagator_", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ".."}], "}"}]}]}], ",", "ch_", ",", "evspec_", 
         ",", "evopts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "InstantaneousTransformation"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matrep", ",", "Umatini"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Umatini", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"InitialPropagator", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"NPropagationOperator", "[", 
           RowBox[{"evspec", ",", 
            RowBox[{"Continuous", "\[Rule]", "False"}]}], "]"}], ",", 
          "basis"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", "\[IndentingNewLine]", 
        RowBox[{"Operator", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Dot", "[", 
           RowBox[{"matrep", ",", "Umatini"}], "]"}], ",", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}],
              ",", 
             RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.666787885874828*^9, 3.666787893632843*^9}, {
   3.666787953221898*^9, 3.666787955221856*^9}, {3.66678808589962*^9, 
   3.666788085969693*^9}, {3.6667881184473877`*^9, 3.666788121139324*^9}, {
   3.6667882623518276`*^9, 3.666788262470888*^9}, {3.666788306681405*^9, 
   3.6667883179186735`*^9}, {3.666789085817876*^9, 3.666789085998213*^9}, {
   3.666791910031025*^9, 3.6667919199611993`*^9}, {3.6667947083022747`*^9, 
   3.6667947128842*^9}, {3.6667947803806906`*^9, 3.666794868870147*^9}, {
   3.666794986228097*^9, 3.66679500951676*^9}, {3.6667950834870596`*^9, 
   3.6667951208272*^9}, {3.666795277979823*^9, 3.6667953152888575`*^9}, 
   3.666795379287572*^9, {3.666795423038396*^9, 3.666795432327444*^9}, {
   3.6667954734988775`*^9, 3.666795500685788*^9}, {3.6667955331361437`*^9, 
   3.6667955345381613`*^9}, {3.666795567733016*^9, 3.6667955716972017`*^9}, {
   3.666795624545231*^9, 3.6667956383362155`*^9}, {3.6668001839112515`*^9, 
   3.6668001863190117`*^9}, {3.6668002979354877`*^9, 3.666800301557413*^9}, {
   3.6668003348350573`*^9, 3.666800334985257*^9}, 3.6668028970047054`*^9, {
   3.6668040445399933`*^9, 3.666804048485133*^9}, {3.666804136245371*^9, 
   3.6668041427032843`*^9}, {3.666813046746394*^9, 3.666813049084942*^9}, {
   3.666813364438802*^9, 3.6668133714384174`*^9}, {3.667386968462659*^9, 
   3.667386975360824*^9}, {3.69166498811832*^9, 3.691665049980772*^9}, {
   3.691665081555109*^9, 3.69166512437912*^9}, {3.691665159063904*^9, 
   3.691665217039282*^9}, {3.691665325989184*^9, 3.691665374876573*^9}, {
   3.6916654299658537`*^9, 3.69166548166293*^9}, {3.691667410135995*^9, 
   3.691667416934401*^9}, {3.691667533147132*^9, 
   3.6916675395937223`*^9}},ExpressionUUID->"cbf4724d-f611-4cc1-ace4-\
48e98f0ee9c7"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}, {3.691438204642272*^9, 
   3.691438206264173*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"2c86ca25-06cf-4921-bde2-60e7d5a37cb0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "argnotready"}], "=", 
   "\"\<The argument of NPropagationOperator is not ready for numerical \
computation.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970956327927*^9, 
  3.690970982532607*^9}},ExpressionUUID->"ac40bb1e-1c4a-4a79-a3fb-\
9db2dbddbfb9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "undefbasis"}], "=", 
   "\"\<The basis `1` is not defined. Calculation will proceed using the \
default basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699279011312561*^9, 3.699279045062563*^9}, 
   3.699279770025062*^9, 
   3.6992800105897217`*^9},ExpressionUUID->"4965b36b-4a9e-4f2d-a857-\
8ff981f8d24f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "hilbincompat"}], "=", 
   "\"\<Cannot calculate the propagation operator of a \
Hilbert-space-incompatible event.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534310875430174*^9, 
  3.534310904071266*^9}},ExpressionUUID->"6a168efe-bb73-4b11-8d1c-\
cd937e0f46b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "nonnumeric"}], "=", 
   "\"\<A non-numeric matrix was detected. The requested context does not \
permit operators with symbolic coefficients.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.564566928824712*^9, 3.564567010835693*^9}, {
  3.564567659350672*^9, 3.564567691693466*^9}, {3.6916605072775373`*^9, 
  3.6916605087220984`*^9}},ExpressionUUID->"d1dfe1b8-f416-4798-adbe-\
564661810e43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "contzerodur"}], "=", 
   "\"\<NPropagationOperator with the option setting Continuous\[Rule]True \
requires an event duration greater than 0.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6667964983863006`*^9, 3.6667965295270796`*^9}, {
  3.691658063131671*^9, 3.6916580824664927`*^9}, {3.6916604551596203`*^9, 
  3.6916604885728703`*^9}, {3.691660711405195*^9, 
  3.691660714379344*^9}},ExpressionUUID->"ccf85bb5-94fc-4ab8-9a4d-\
e2f609dffcb4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationOperator", "::", "contnoprecalev"}], "=", 
   "\"\<Precalculated events are not allowed for NPropagationOperator with \
the option setting Continuous\[Rule]True.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6667964983863006`*^9, 3.6667965295270796`*^9}, {
  3.691658063131671*^9, 3.6916580824664927`*^9}, {3.6916604551596203`*^9, 
  3.6916604885728703`*^9}, {3.6916606683675957`*^9, 
  3.691660705555365*^9}},ExpressionUUID->"f91f7d86-82d6-4d11-88c9-\
b72eb9cf77bd"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NPropagationSuperoperator", "Subtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.454563770112988*^9, 3.454563772575369*^9}, {
   3.464689435410881*^9, 3.4646894465365963`*^9}, 3.464695493032454*^9, {
   3.467197660626375*^9, 3.4671976663433237`*^9}, 3.467199003852363*^9, 
   3.534310132957168*^9, {3.53439006044907*^9, 
   3.5343900613742123`*^9}},ExpressionUUID->"a3fce764-8237-4806-828e-\
c5c96368fe82"],

Cell[CellGroupData[{

Cell["defaults", "Subsubtitle",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.691438143429953*^9, 3.6966225010069475`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"2f35ec36-9719-4528-97db-f9c7465a420a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpandRepeatedEvents", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PropagatorCalculationProcedure", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Assumptions", "\[Rule]", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"AccuracyGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxStepSize", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxSteps", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 CellChangeTimes->{{3.464861472784998*^9, 3.464861483441214*^9}, 
   3.4648615286770973`*^9, 3.4648730173172703`*^9, {3.4648740845965853`*^9, 
   3.4648740923300657`*^9}, {3.4649389788207808`*^9, 3.464938979305622*^9}, {
   3.4649391032323914`*^9, 3.464939139949542*^9}, 3.464939369751892*^9, 
   3.464944210485517*^9, {3.4649599887789917`*^9, 3.4649600189799023`*^9}, 
   3.464960163436203*^9, 3.4657307199008007`*^9, 3.465730770944022*^9, 
   3.465730801958722*^9, 3.465758498775585*^9, {3.4658145173278418`*^9, 
   3.465814524082449*^9}, {3.465814815775647*^9, 3.4658148334715242`*^9}, {
   3.4671972295728273`*^9, 3.467197233800462*^9}, {3.483952009583354*^9, 
   3.483952017548534*^9}, 3.497572538901269*^9, 3.4977586268463993`*^9, 
   3.499708694963387*^9, {3.499708744009026*^9, 3.499708746574301*^9}, {
   3.5030306306149883`*^9, 3.5030306375558147`*^9}, {3.5031117611042624`*^9, 
   3.5031117718455048`*^9}, 3.5044586933744907`*^9, 3.5080058974835157`*^9, {
   3.5080900784786158`*^9, 3.508090085815353*^9}, {3.5085107895701847`*^9, 
   3.508510791240788*^9}, {3.514454503646961*^9, 3.514454513964549*^9}, 
   3.514799185545196*^9, 3.515077830908255*^9, {3.532450992407064*^9, 
   3.532450997113079*^9}, {3.534310144544961*^9, 3.534310156553754*^9}, {
   3.534318337268446*^9, 3.5343183381724863`*^9}, {3.534318394765707*^9, 
   3.534318400204275*^9}, 3.534390172495941*^9, {3.534390210487609*^9, 
   3.534390228763915*^9}, {3.5343949942967863`*^9, 3.534394996011629*^9}, 
   3.534398805965023*^9, 3.53448908482698*^9, 3.534489511831917*^9, {
   3.539112640931725*^9, 3.5391126451852627`*^9}, 3.543413343851183*^9, 
   3.543498901758533*^9, 3.5450504435487547`*^9, {3.626027625586714*^9, 
   3.626027626343341*^9}, {3.691409971735857*^9, 3.691410001998239*^9}, 
   3.6966225010069475`*^9, {3.6973783730176973`*^9, 3.6973783746325684`*^9}, {
   3.702796815938467*^9, 3.7027968168121037`*^9}, 3.709375005120387*^9, {
   3.713628542515011*^9, 
   3.7136285438355355`*^9}},ExpressionUUID->"1c368a99-6708-4ac9-a5f7-\
887bd816843f"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations and checks", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.6914381546757927`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"81292e76-2d50-433b-aa5e-e8962f889656"],

Cell[CellGroupData[{

Cell["checks and flags (1)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
  3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
  3.69149747441208*^9, 3.691497480706093*^9}, {3.6916575446580963`*^9, 
  3.691657548177092*^9}, {3.691657685513603*^9, 
  3.691657686488957*^9}},ExpressionUUID->"a48d7fc8-ed06-427b-b4dc-\
01d920af613e"],

Cell[CellGroupData[{

Cell["Check flags", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.6909699970772877`*^9, 3.690970006253284*^9}, {3.690971580479559*^9, 
   3.690971585368348*^9}, {3.6913976989290667`*^9, 3.691397701966687*^9}, {
   3.69149747441208*^9, 3.691497480706093*^9}, 
   3.691657555306875*^9},ExpressionUUID->"7420656a-896d-423e-b871-\
e855f12aef30"],

Cell["\<\
Check flag: {<backgprepared>,<EventList imp>,<hilbcompat>,<no $Failed>,<num \
ready>,}\
\>", "Text",
 CellChangeTimes->{{3.691397731982896*^9, 3.691397800026311*^9}, {
  3.6913988035046587`*^9, 3.691398811659533*^9}, {3.691398882694293*^9, 
  3.691398915950233*^9}, {3.691398972356401*^9, 3.6913989778118773`*^9}, {
  3.6914010940803823`*^9, 3.691401102107382*^9}, {3.6914013217045193`*^9, 
  3.6914013257071877`*^9}},ExpressionUUID->"100fcd17-e5e6-4abb-8e5a-\
cc157f821817"],

Cell[CellGroupData[{

Cell["insert Check flag", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
  3.6913976561529617`*^9}},ExpressionUUID->"e821ef8a-a1e9-431e-b9d3-\
a0bdb51aa1bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"arg1", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], "]"}]}], ",", 
     "args2___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"False", ",", "arg1", ",", "args2", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691399842191819*^9, 3.691399848731359*^9}, {
   3.6965329301238585`*^9, 3.6965329399978404`*^9}, {3.6965891604313583`*^9, 
   3.6965891703034096`*^9}, {3.6965892011993213`*^9, 3.696589201929448*^9}, {
   3.696589239058485*^9, 3.696589239753933*^9}, {3.696589275265458*^9, 
   3.6965892777419643`*^9}, {3.69658931465895*^9, 
   3.6965893165293427`*^9}},ExpressionUUID->"dbf136e4-ba5c-454c-88a2-\
ff3242fffef3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckFlagDimension", "[", "NPropagationSuperoperator", "]"}], "=",
    "5"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691397808855783*^9, 3.6913978253090563`*^9}, 
   3.6913988177479887`*^9, 3.691398890847995*^9, 3.691399514439227*^9, 
   3.696578361714695*^9},ExpressionUUID->"5625a0e9-c8a1-42ad-bc8f-\
397b012004f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"False", ",", "args___"}], "]"}], ":=", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"False", ",", 
       RowBox[{"{", 
        RowBox[{"CheckFlagDimension", "[", "NPropagationSuperoperator", "]"}],
         "}"}]}], "]"}], ",", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.691397668275591*^9, 3.6913976883929033`*^9}, {
   3.691397829269376*^9, 3.691397846124062*^9}, {3.6913978855650187`*^9, 
   3.6913978886256647`*^9}, {3.696533090493082*^9, 3.696533095120173*^9}, {
   3.696578397195157*^9, 3.696578433316948*^9}, {3.6965789186652355`*^9, 
   3.696578927592934*^9}, {3.6965791121298923`*^9, 3.696579112258142*^9}, {
   3.697134824388818*^9, 
   3.697134830967803*^9}},ExpressionUUID->"29ce9761-01bc-4b49-8866-\
390b0b9f1136"]
}, Closed]],

Cell[CellGroupData[{

Cell["set True when all checks done", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397655506816*^9, 
  3.6913976561529617`*^9}, {3.691397715286193*^9, 
  3.69139772499686*^9}},ExpressionUUID->"8933fe16-69b5-4c1e-b79b-\
b1e07f21d746"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "args___"}], "]"}], ":=", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909700189102297`*^9, 3.690970048287532*^9}, {
   3.6909713815776052`*^9, 3.690971396015292*^9}, {3.690971482108838*^9, 
   3.690971487994781*^9}, {3.6909717606336803`*^9, 3.690971766952878*^9}, {
   3.6909718116330748`*^9, 3.6909718190678377`*^9}, {3.6909719007621517`*^9, 
   3.690971915513582*^9}, {3.690971955406323*^9, 3.690971957485443*^9}, 
   3.691391143215111*^9, {3.6913978952429934`*^9, 3.691397912831829*^9}, {
   3.6965331004113517`*^9, 3.6965331022616673`*^9}, {3.696580777839266*^9, 
   3.6965807910302896`*^9}, {3.6965878709942217`*^9, 
   3.6965878741853943`*^9}, {3.6965898018682694`*^9, 
   3.6965898062516303`*^9}, {3.697125834058738*^9, 3.697125858217819*^9}, {
   3.6971348360706606`*^9, 
   3.697134839008173*^9}},ExpressionUUID->"e7abe4ab-31b2-468d-8a0b-\
326458ff4e05"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["first $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
   3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
   3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
   3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
   3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
   3.691399163725749*^9}, {3.691497397390768*^9, 3.691497407780759*^9}, 
   3.691657569755228*^9, {3.6916576752432823`*^9, 
   3.6916576761930723`*^9}},ExpressionUUID->"ec50548b-d260-439c-a822-\
e3a8981f95a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"arg1", ":", 
       RowBox[{"Except", "[", "True", "]"}]}], ",", "args___"}], "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"arg1", ",", "args"}], "}"}], ",", "$Failed"}], "]"}]}]}], ":=",
    "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691497412246861*^9, 3.691497459675514*^9}, {
   3.691497709668282*^9, 3.6914977223609943`*^9}, 
   3.696533113141767*^9},ExpressionUUID->"595d716c-b96e-4456-8a47-\
cead2d84b129"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398090064618*^9, 
  3.691398091836032*^9}},ExpressionUUID->"6ba7d8e6-3d08-4dca-b845-\
3ffdbdb83267"],

Cell[CellGroupData[{

Cell["null events", "Subsection",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.534310488228697*^9, 3.534310494353874*^9}, 
   3.666609425618058*^9, {3.6666094862480707`*^9, 3.6666095206815586`*^9}, 
   3.6667259458527355`*^9, {3.6667260072685785`*^9, 3.666726008209152*^9}, {
   3.6909706174328337`*^9, 
   3.690970624838993*^9}},ExpressionUUID->"f04fef30-fe17-4bdf-9d9a-\
7f22e9e8aee5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", "}"}], "|", 
       RowBox[{"UnityOperator", "[", "]"}], "|", 
       RowBox[{"UnitySuperoperator", "[", "]"}]}], ")"}], ",", "opbasis_", 
     ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnitySuperoperator", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.454590588656004*^9, 3.454590593806896*^9}, {
   3.455106101697146*^9, 3.455106141078717*^9}, {3.456322977275065*^9, 
   3.456322994774282*^9}, 3.486711144793584*^9, {3.534310512299883*^9, 
   3.534310525515341*^9}, {3.534312019783698*^9, 3.534312030883206*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610614376049*^9, 3.6666106257460995`*^9}, {3.6666124794088817`*^9, 
   3.6666124817218175`*^9}, {3.690970542786141*^9, 3.690970554393107*^9}, {
   3.691391268201935*^9, 3.691391275439385*^9}, 3.691391890857008*^9, 
   3.69139835562991*^9, {3.691400727058011*^9, 3.691400733294271*^9}, {
   3.691401154426983*^9, 3.6914011578324823`*^9}, {3.6965331768359575`*^9, 
   3.696533185184111*^9}, 3.6965790927462444`*^9, {3.6965917627752485`*^9, 
   3.6965917688840466`*^9}, {3.7031791959441347`*^9, 
   3.703179202870571*^9}},ExpressionUUID->"8deb804a-b527-42fc-ad7b-\
abb27ca73a0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["basis specifications", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.626084834821652*^9, {3.666718322230075*^9, 3.666718347498945*^9}, {
   3.6673838939925632`*^9, 3.667383894962243*^9}, 3.683129928127585*^9, {
   3.690983020249568*^9, 3.690983027553432*^9}, 
   3.691399175339323*^9},ExpressionUUID->"16a3b201-b2ad-442a-9ea7-\
66add30ec7df"],

Cell["OperatorBasisUnknown has to be included", "Text",
 CellChangeTimes->{{3.6966225527629647`*^9, 
  3.696622558922426*^9}},ExpressionUUID->"f9722871-913f-415b-9a97-\
bdfa518e3559"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "events_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"status", ",", "events", ",", 
     RowBox[{
      RowBox[{"OperatorBasis", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], ",", 
     RowBox[{
      RowBox[{"Basis", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.454563825254508*^9, 
   3.454563826638453*^9}, {3.454563905455122*^9, 3.4545639089804993`*^9}, 
   3.456205058769329*^9, 3.456323032056343*^9, {3.50242936511091*^9, 
   3.502429366084257*^9}, 3.503127186296899*^9, {3.515077856481803*^9, 
   3.515077860272526*^9}, {3.53431026989006*^9, 3.534310284553986*^9}, {
   3.6667184627270803`*^9, 3.6667184640569763`*^9}, 3.666718497847576*^9, {
   3.690970098289364*^9, 3.690970102351604*^9}, {3.691391216100874*^9, 
   3.691391216722046*^9}, {3.6913981502320547`*^9, 3.6913982230367193`*^9}, {
   3.6913999880307903`*^9, 3.691399994566819*^9}, 3.6914011732840977`*^9, {
   3.696533241745593*^9, 3.6965332481962776`*^9}, {3.696578840618726*^9, 
   3.696578852364008*^9}, {3.6965791169387608`*^9, 3.696579119338958*^9}, {
   3.6965791994018965`*^9, 3.6965792054243755`*^9}, {3.696591540372505*^9, 
   3.696591545423648*^9}},ExpressionUUID->"52916939-8bc6-4dc0-8dc3-\
11d1b5124302"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "events_", ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "SpinSystemUnknown"}], ")"}]}], 
   ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.454563828806386*^9, 
   3.4545639120761642`*^9, {3.455376344213114*^9, 3.455376346057372*^9}, 
   3.456205401485495*^9, 3.456323034576393*^9, 3.503127188744994*^9, {
   3.534310289761839*^9, 3.53431029312015*^9}, {3.69097010587998*^9, 
   3.690970113621426*^9}, {3.6913912187146597`*^9, 3.691391219137439*^9}, 
   3.691398160499175*^9, {3.6913981947847347`*^9, 3.6913982156721153`*^9}, 
   3.691399998823793*^9, 3.691401176516121*^9, 3.6965791212963157`*^9, 
   3.696579311849164*^9, {3.6965915514367175`*^9, 
   3.696591554172104*^9}},ExpressionUUID->"ca9d005d-cc20-40f9-9989-\
f1893a129fcd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "events_", ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"NPropagationSuperoperator", "::", "undefopbasis"}], ",", 
       "opbasis"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"NPropagationSuperoperator", "[", 
      RowBox[{"status", ",", "events", ",", 
       RowBox[{"OperatorBasis", "[", "]"}], ",", 
       RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 3.69140117874692*^9, {3.6932180346731744`*^9, 
   3.693218040149607*^9}, {3.693218071460653*^9, 3.693218076431404*^9}, {
   3.6932186172237916`*^9, 3.6932186209454308`*^9}, {3.697221397487401*^9, 
   3.6972214022863655`*^9}, {3.6972216788965273`*^9, 3.697221680157203*^9}, {
   3.6992789248778954`*^9, 3.69927899444897*^9}, {3.699279056111178*^9, 
   3.699279056953815*^9}, {3.69927968458012*^9, 3.6992797408182793`*^9}, {
   3.699542248923665*^9, 
   3.6995422665154543`*^9}},ExpressionUUID->"1a7619d0-b0e7-4348-8f77-\
e50209d553f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "BooleanQ"}], ".."}], "}"}]}], ",", "events_", ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedBasisQ", "[", "basis", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"NPropagationSuperoperator", "::", "undefbasis"}], ",", 
       "basis"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"NPropagationSuperoperator", "[", 
      RowBox[{"status", ",", "events", ",", "opbasis", ",", 
       RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, 
   3.4562054023903513`*^9, 3.45632303720231*^9, 3.503127191130403*^9, {
   3.534310299443619*^9, 3.534310315255479*^9}, {3.6667217195680304`*^9, 
   3.666721719970059*^9}, {3.666721793230621*^9, 3.666721793508319*^9}, {
   3.666721891988159*^9, 3.6667219168669786`*^9}, {3.690970117760724*^9, 
   3.690970118934688*^9}, {3.691391221072915*^9, 3.691391221489339*^9}, 
   3.6913981627375402`*^9, {3.691398203193144*^9, 3.691398231862686*^9}, 
   3.691400001916046*^9, 3.69140117874692*^9, {3.6932180346731744`*^9, 
   3.693218040149607*^9}, {3.693218071460653*^9, 3.693218076431404*^9}, {
   3.6932186172237916`*^9, 3.6932186209454308`*^9}, {3.697221397487401*^9, 
   3.6972214022863655`*^9}, {3.6972216788965273`*^9, 3.697221680157203*^9}, {
   3.6992789248778954`*^9, 3.69927899444897*^9}, {3.699279056111178*^9, 
   3.699279056953815*^9}, {3.69927968458012*^9, 
   3.6992797408182793`*^9}},ExpressionUUID->"782172be-e475-4a87-9891-\
aa85b87fdaad"]
}, Closed]],

Cell[CellGroupData[{

Cell["set up BackgroundGenerator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.502839560490985*^9, 3.502839565176372*^9}, {
   3.532438161776326*^9, 3.5324381640431232`*^9}, {3.54341082791413*^9, 
   3.5434108337521667`*^9}, 
   3.709375005131629*^9},ExpressionUUID->"7c323de9-f405-41e3-a28d-\
536f476d7e42"],

Cell["pre-diagonalization has been disabled in v3.0", "Text",
 CellChangeTimes->{{3.692847813601705*^9, 
  3.692847825065948*^9}},ExpressionUUID->"78b6b7f4-6e43-40fd-af60-\
85fef6276ac9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"False", ",", "morestatus___"}], "}"}]}], ",", "events_", ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "evbackg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"evbackg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"NPropagationSuperoperator", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"True", ",", "morestatus"}], "}"}], ",", "events", ",", 
         "opbasis", ",", " ", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", 
                RowBox[{"_Hold", "|", "NullGeneratorPattern"}], "]"}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"HeldGeneratorSymbol", "[", "evbackg", "]"}], ",", 
               "\[IndentingNewLine]", "\t", "_", ",", "evbackg"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532438192185872*^9, 3.5324382545397863`*^9}, 
   3.532438313835868*^9, {3.53243836363794*^9, 3.532438409477851*^9}, 
   3.5324387823958063`*^9, {3.532438880178722*^9, 3.532438905904896*^9}, {
   3.53245092012462*^9, 3.532450926913773*^9}, 3.532450974693555*^9, {
   3.534310358636334*^9, 3.534310377276428*^9}, {3.5415318154112253`*^9, 
   3.5415318229703093`*^9}, {3.5429556978232927`*^9, 3.54295570744648*^9}, {
   3.5429558819873734`*^9, 3.5429558971675463`*^9}, {3.543245145020617*^9, 
   3.5432453060311317`*^9}, {3.543245346853058*^9, 3.5432453525063343`*^9}, {
   3.543245479879105*^9, 3.543245520589139*^9}, 3.543246579112441*^9, {
   3.5432534136180353`*^9, 3.543253437074998*^9}, {3.543410809935897*^9, 
   3.543410821876163*^9}, 3.543413455222966*^9, {3.543688097626602*^9, 
   3.543688213677889*^9}, {3.543688244548811*^9, 3.5436882461085052`*^9}, 
   3.543688279487761*^9, {3.5436883690107183`*^9, 3.5436883713530617`*^9}, {
   3.587550653940123*^9, 3.587550753557995*^9}, 3.621348805395721*^9, {
   3.621349557910268*^9, 3.6213495591884527`*^9}, 3.6215735466916323`*^9, {
   3.666610461408619*^9, 3.666610470998974*^9}, {3.666611655832932*^9, 
   3.666611656195207*^9}, {3.6666118305700426`*^9, 3.6666118834112663`*^9}, {
   3.666611978240513*^9, 3.666611978710616*^9}, {3.666612010000487*^9, 
   3.6666120341297517`*^9}, {3.666612294967608*^9, 3.6666123051444035`*^9}, {
   3.6666138238609586`*^9, 3.6666138779917064`*^9}, {3.6666139233812385`*^9, 
   3.6666139237815084`*^9}, {3.6666896749038057`*^9, 3.66668967550323*^9}, {
   3.666693281747729*^9, 3.666693283856164*^9}, {3.666885921177236*^9, 
   3.6668859469104295`*^9}, {3.6668859853376894`*^9, 
   3.6668859903166633`*^9}, {3.690970230302383*^9, 3.690970235113655*^9}, {
   3.691391246795205*^9, 3.6913912541212473`*^9}, {3.691398256877244*^9, 
   3.691398330210616*^9}, 3.691399757405748*^9, 3.691399918318404*^9, {
   3.691400367152504*^9, 3.6914004798234*^9}, {3.691400515447125*^9, 
   3.6914006507508717`*^9}, 3.691400835355508*^9, {3.691401205441142*^9, 
   3.6914012101536007`*^9}, {3.692847595235621*^9, 3.692847795035656*^9}, {
   3.696533328355219*^9, 3.696533337553755*^9}, {3.696578661618582*^9, 
   3.696578670301655*^9}, 3.696578767172595*^9, {3.69657913153757*^9, 
   3.6965791336736236`*^9}, {3.6965915958761053`*^9, 
   3.6965915994859734`*^9}, {3.697134844611623*^9, 3.697134844771927*^9}, {
   3.7031788529250965`*^9, 3.7031788730362945`*^9}, 3.70937407255947*^9, {
   3.70937450429111*^9, 3.7093745042940187`*^9}, {3.709375005141705*^9, 
   3.70937500514441*^9}},ExpressionUUID->"0a33dd7f-8bc4-45e8-a47b-\
2b99410f75ab"]
}, Closed]],

Cell[CellGroupData[{

Cell["events", "Subsection",
 CellChangeTimes->{{3.6909706502058496`*^9, 3.690970654973537*^9}, {
  3.692847920047133*^9, 
  3.692847920924678*^9}},ExpressionUUID->"b3961c33-17a3-4ef7-af13-\
46dda12bebff"],

Cell[CellGroupData[{

Cell["PulseSequence elements", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 
  3.692847937764781*^9}},ExpressionUUID->"5d8e466c-457c-4450-bea7-\
83118095d7d3"],

Cell["take options into PulseSequence", "Text",
 CellChangeTimes->{{3.6928479733079147`*^9, 
  3.692847979394462*^9}},ExpressionUUID->"cac74b53-7bf4-4c65-b0eb-\
4a4c7fa8cd50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_PulseSequence", "]"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"PulseSequenceQ", "[", "events", "]"}]}], ":=", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"status", ",", 
     RowBox[{"PulseSequence", "[", 
      RowBox[{"events", ",", "opts"}], "]"}], ",", "more", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6928420888951273`*^9, 3.692842152566959*^9}, {
  3.696533357032424*^9, 3.6965333639384413`*^9}, {3.6965791649610305`*^9, 
  3.69657917025681*^9}},ExpressionUUID->"f5a8aa6b-340b-4bb5-b929-\
8185018c9b97"]
}, Closed]],

Cell[CellGroupData[{

Cell["after decoding of PulseSequence", "Subsubsection",
 CellChangeTimes->{{3.692847923683056*^9, 
  3.69284796656359*^9}},ExpressionUUID->"336f8eee-d56e-4e84-9763-\
badc7c571660"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", "_EventList", "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NPropagationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "morestatus"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EventList", "[", 
      RowBox[{"events", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Chronology", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Chronology", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
           ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"ImplementBackgroundGenerator", "\[Rule]", "True"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"Options", "[", "EventList", "]"}], ",", 
              RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "more", ",", 
     "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True,
 CellChangeTimes->{{3.459403611419217*^9, 3.4594036438443937`*^9}, {
   3.459403725781039*^9, 3.4594037309083157`*^9}, {3.459408711958606*^9, 
   3.459408714467761*^9}, 3.464328075904245*^9, {3.464695379520875*^9, 
   3.4646954137997932`*^9}, {3.465814860620288*^9, 3.465814888174513*^9}, {
   3.503027085072076*^9, 3.5030270997206917`*^9}, {3.503032349105281*^9, 
   3.503032395582123*^9}, 3.503127150743004*^9, {3.508090439583303*^9, 
   3.508090480358121*^9}, {3.5144545315614767`*^9, 3.514454565048649*^9}, {
   3.514454646972604*^9, 3.514454651506188*^9}, {3.514457068494399*^9, 
   3.5144570685635567`*^9}, 3.514809519181155*^9, {3.51482124543471*^9, 
   3.514821246122735*^9}, 3.514868524715065*^9, 3.514868851948365*^9, {
   3.51499222248971*^9, 3.514992268629366*^9}, {3.5166039514155493`*^9, 
   3.516603959381312*^9}, {3.534310528631629*^9, 3.5343105347156677`*^9}, {
   3.534313503516695*^9, 3.534313504737646*^9}, {3.534398740916671*^9, 
   3.5343987424438763`*^9}, {3.666608230514469*^9, 3.6666082721519346`*^9}, 
   3.666609425618058*^9, 3.6666094862480707`*^9, 3.6666095206815586`*^9, {
   3.666610523629199*^9, 3.6666105417587404`*^9}, {3.6666106725464892`*^9, 
   3.666610675199015*^9}, {3.6666107148817043`*^9, 3.666610746276681*^9}, 
   3.6666108584956484`*^9, {3.6666111925323596`*^9, 3.666611210048849*^9}, {
   3.6666114768762207`*^9, 3.666611489595416*^9}, 3.666611550828224*^9, {
   3.666611593307498*^9, 3.66661160099645*^9}, {3.6666120971877337`*^9, 
   3.666612102246954*^9}, {3.6666122010387964`*^9, 3.6666122437883954`*^9}, {
   3.6666123632294493`*^9, 3.6666123793642483`*^9}, {3.666612440702112*^9, 
   3.6666124426883163`*^9}, {3.6666124731744547`*^9, 3.666612473612363*^9}, {
   3.6666125333332634`*^9, 3.666612536223451*^9}, {3.666612709052069*^9, 
   3.6666127193908396`*^9}, {3.666612777710683*^9, 3.666612832219817*^9}, {
   3.6666131867833357`*^9, 3.666613193435583*^9}, {3.666613270475043*^9, 
   3.666613272794323*^9}, {3.6666133044160204`*^9, 3.6666133612706065`*^9}, {
   3.666613455162436*^9, 3.6666134605722203`*^9}, {3.6666134978714647`*^9, 
   3.6666135321811514`*^9}, {3.666613934341844*^9, 3.6666139581006413`*^9}, {
   3.6666140578060856`*^9, 3.6666140665488667`*^9}, {3.66661414327384*^9, 
   3.6666141777386513`*^9}, 3.666616803057581*^9, {3.6666923663684254`*^9, 
   3.666692367698021*^9}, {3.6666932935574894`*^9, 3.666693295693761*^9}, {
   3.666885907975423*^9, 3.6668859087386875`*^9}, {3.6909705937939262`*^9, 
   3.6909706003113003`*^9}, 3.690991239770699*^9, {3.690991353090613*^9, 
   3.690991356255272*^9}, 3.6909914094528303`*^9, {3.6910569028349113`*^9, 
   3.691056905865327*^9}, {3.691061927890615*^9, 3.691061967047638*^9}, {
   3.6910622639040728`*^9, 3.6910622647984858`*^9}, 3.691062443418497*^9, {
   3.691390855426762*^9, 3.691390862991173*^9}, {3.691391279696642*^9, 
   3.691391288737391*^9}, {3.691392534425685*^9, 3.691392536260234*^9}, 
   3.69139259633524*^9, {3.6913926640237103`*^9, 3.6913926863196707`*^9}, 
   3.691398377149314*^9, {3.69139852474798*^9, 3.6913985462121067`*^9}, {
   3.691399250852113*^9, 3.6913992545687447`*^9}, {3.69139933578225*^9, 
   3.69139939440676*^9}, 3.691399775915741*^9, 3.691400863467993*^9, {
   3.6914012174093437`*^9, 3.691401221432158*^9}, {3.691434081729492*^9, 
   3.691434082401731*^9}, {3.696533382844352*^9, 3.696533397294668*^9}, {
   3.696579366960112*^9, 3.696579383744445*^9}, {3.7031789659431605`*^9, 
   3.703179011722354*^9}, {3.7031791015006847`*^9, 3.7031791133216934`*^9}, 
   3.709375005153611*^9},ExpressionUUID->"2228ee64-c620-46ac-a52c-\
b97f503cc63b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False", ",", "morestatus___"}], "}"}]}], ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "morestatus"}], "}"}], ",", 
     "eventlist", ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691433960623218*^9, 3.691434043219462*^9}, 
   3.691434462983884*^9, {3.6965334055796466`*^9, 3.696533409767164*^9}, {
   3.696579175824464*^9, 
   3.6965791773366337`*^9}},ExpressionUUID->"38b7489c-2e91-4836-be05-\
a72f4034822c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Check Hilbert Space Compatibility", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021943915395*^9, 3.5030219527295847`*^9}, {3.5343107110699883`*^9, 
   3.534310721386609*^9}, {3.534311142574582*^9, 3.534311148387733*^9}, 
   3.691398613270062*^9, {3.691399197382773*^9, 3.691399198241972*^9}, {
   3.696533460281196*^9, 
   3.6965334761614847`*^9}},ExpressionUUID->"8d69614d-8c25-45a1-a6e8-\
d1879fb63984"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"True", ",", "True", ",", "False", ",", "morestatus___"}], 
       "}"}]}], ",", "\[IndentingNewLine]", "eventlist_EventList", ",", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "morestatus"}], "}"}], 
     ",", 
     RowBox[{"HilbertSpaceCompatibility", "[", "eventlist", "]"}], ",", 
     "eventlist", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5343107726442204`*^9, 3.534310858333661*^9}, 
   3.534398755298703*^9, {3.547010792472026*^9, 3.547010798433242*^9}, {
   3.6666083382466908`*^9, 3.666608345685981*^9}, 3.6666112844174905`*^9, {
   3.690970704100424*^9, 3.690970705217493*^9}, {3.69105871483134*^9, 
   3.6910587482283907`*^9}, {3.691391298488624*^9, 3.6913913084717407`*^9}, {
   3.691398564618116*^9, 3.691398598461609*^9}, 3.691399267796332*^9, 
   3.691401227878825*^9, {3.693138675476312*^9, 3.6931386778261657`*^9}, {
   3.6931435806164284`*^9, 3.6931435903674*^9}, {3.693218806465129*^9, 
   3.693218810313361*^9}, {3.6932255502764683`*^9, 3.6932255540834885`*^9}, {
   3.693225796800521*^9, 3.693225822719429*^9}, {3.693225891446307*^9, 
   3.693225892405689*^9}, {3.6932262702079563`*^9, 3.693226293701394*^9}, {
   3.6932277863501425`*^9, 3.693227790442277*^9}, {3.6932278562415743`*^9, 
   3.6932278593903155`*^9}, {3.693227911760259*^9, 3.693227911930402*^9}, 
   3.693227968141594*^9, {3.693246468243907*^9, 3.693246472973357*^9}, {
   3.693380345588259*^9, 3.693380358199763*^9}, {3.693380389602949*^9, 
   3.6933803925870023`*^9}, {3.6965334997519083`*^9, 
   3.6965335241415715`*^9}, {3.696579185568568*^9, 3.6965791877683673`*^9}, {
   3.6965792388263097`*^9, 3.696579285673463*^9}, {3.6965876895936165`*^9, 
   3.696587735329126*^9}, {3.6965878292414694`*^9, 3.696587830657576*^9}, {
   3.696587914528324*^9, 3.696587918777523*^9}, {3.696587956385619*^9, 
   3.6965879565703773`*^9}, {3.696588118968223*^9, 3.696588123489058*^9}, {
   3.6965884610418115`*^9, 3.6965885267933874`*^9}, {3.696588868996842*^9, 
   3.6965888692126155`*^9}, {3.696589027288679*^9, 3.6965890277389574`*^9}, {
   3.6965891167874823`*^9, 3.696589117873621*^9}, {3.6965893732475214`*^9, 
   3.696589389739814*^9}, {3.696589560163613*^9, 3.6965895930403347`*^9}, {
   3.6965896361993217`*^9, 3.6965896363835196`*^9}, {3.6965896727558336`*^9, 
   3.69658969183899*^9}, {3.6965917926433706`*^9, 3.696591796740224*^9}, {
   3.6971348499970875`*^9, 3.697134851174241*^9}, {3.7031789204557076`*^9, 
   3.7031789518339634`*^9}},ExpressionUUID->"a089cae8-360c-4ebc-ab6e-\
b7a3dedaed71"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["checks and flags (2)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 3.691497398413538*^9}, {
  3.691657597551735*^9, 3.691657603767311*^9}, {3.691657691899529*^9, 
  3.691657693890112*^9}},ExpressionUUID->"377e4bc9-8e54-4ae8-90c7-\
ceb1e025bbc9"],

Cell[CellGroupData[{

Cell["second $Failed trap", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.464803049543367*^9, 
  3.4648030550288467`*^9}, {3.690970011853907*^9, 3.690970014812726*^9}, {
  3.691391736611186*^9, 3.691391742392497*^9}, {3.691397650076635*^9, 
  3.691397651816944*^9}, {3.691397964873701*^9, 3.691397965627779*^9}, {
  3.691398100306512*^9, 3.691398118762822*^9}, {3.6913991630623693`*^9, 
  3.691399163725749*^9}, {3.691497397390768*^9, 
  3.691497398413538*^9}},ExpressionUUID->"d5762b11-1182-445c-9fe0-\
3ac265e3fab0"],

Cell["continuously check until all other checks are complete", "Text",
 CellChangeTimes->{{3.6914010562716417`*^9, 3.69140107024336*^9}, {
  3.691401438463211*^9, 
  3.69140145401991*^9}},ExpressionUUID->"4096d934-d6f2-449e-9e54-\
942e615de98f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "False", ",", "morecheckflags__"}], 
        "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.6913980379475822`*^9}, {3.691400270965768*^9, 
   3.691400273000134*^9}, {3.691401246783072*^9, 3.691401261628582*^9}, {
   3.691401417817514*^9, 3.691401422629837*^9}, 3.6965335496178827`*^9, {
   3.696588165401782*^9, 3.696588178344281*^9}, {3.69658834562568*^9, 
   3.6965883579126277`*^9}, {3.6965884331922874`*^9, 
   3.6965884523750353`*^9}, {3.696588968637068*^9, 3.696588977947567*^9}, {
   3.696589772013522*^9, 3.696589774198237*^9}, {3.696591186307317*^9, 
   3.696591187387296*^9}, {3.697126233523782*^9, 
   3.697126233599498*^9}},ExpressionUUID->"70f17115-c7d4-4b5f-a24c-\
2e0c2fb8df3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"checkflags", ":", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "False", ",", 
         "morecheckflags__"}], "}"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "morecheckflags"}], 
      "}"}], ",", "args"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464803057571782*^9, 3.4648031010639467`*^9}, {
   3.502449865294104*^9, 3.502449866587307*^9}, {3.534310246954466*^9, 
   3.534310254849784*^9}, {3.6909700566826353`*^9, 3.690970089359042*^9}, 
   3.691390960130845*^9, {3.6913911977886477`*^9, 3.6913911991229887`*^9}, {
   3.6913980115241528`*^9, 3.69139807543729*^9}, {3.6914002796355658`*^9, 
   3.691400279931965*^9}, {3.691401268582445*^9, 3.691401282439878*^9}, {
   3.6965335538707075`*^9, 3.696533555514943*^9}, {3.696534426446714*^9, 
   3.6965344395893807`*^9}, {3.696587995833851*^9, 3.6965880087068424`*^9}, {
   3.6965883051147766`*^9, 3.6965883138270683`*^9}, {3.6965883480081472`*^9, 
   3.6965883590163617`*^9}, 3.6965889665969677`*^9, {3.696589003701603*^9, 
   3.696589048501618*^9}, {3.696589096500479*^9, 3.696589123014288*^9}, {
   3.696589395493626*^9, 3.6965894024477577`*^9}, {3.6965897293910255`*^9, 
   3.696589732466403*^9}, {3.696589791397208*^9, 3.6965897953469114`*^9}, {
   3.696591175571375*^9, 3.6965911810351615`*^9}, {3.697126236301614*^9, 
   3.697126238170768*^9}},ExpressionUUID->"d9790879-a7ec-4438-a4ea-\
ec92aba7a797"]
}, Closed]],

Cell[CellGroupData[{

Cell["numerical readiness", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, {3.5394494601995707`*^9, 
   3.5394494644933357`*^9}, {3.542280127397629*^9, 3.54228013347538*^9}, {
   3.690970751308037*^9, 3.6909707810962467`*^9}, {3.690972007962603*^9, 
   3.690972024212504*^9}, {3.690984027065432*^9, 3.690984032191633*^9}, {
   3.6913923990506144`*^9, 3.691392406888403*^9}, {3.691392787395994*^9, 
   3.691392787833499*^9}, {3.691398995211268*^9, 3.6913989968344173`*^9}, {
   3.691657722452734*^9, 
   3.6916577265050573`*^9}},ExpressionUUID->"ffa01b71-4cac-4078-b946-\
809d32a19547"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
        "morestatus___"}], "}"}]}], ",", "Hstat_", ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}]}], "]"}], ",", "___"}], "]"}]}], ",",
      "more___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "suspsymbols", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"NPropagationSuperoperator", "::", "argnotready"}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"ReportSuspectSymbols", "[", 
        RowBox[{"{", 
         RowBox[{"eventlist", ",", "more"}], "}"}], "]"}], ";", 
       "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970789202134*^9, 3.69097091718412*^9}, {
   3.690972053068953*^9, 3.690972055162653*^9}, {3.690972123020767*^9, 
   3.690972168897552*^9}, {3.690972307524001*^9, 3.69097248383584*^9}, {
   3.690972885909957*^9, 3.690972900088601*^9}, {3.6913913136476803`*^9, 
   3.69139131586931*^9}, {3.691392464889511*^9, 3.691392478241403*^9}, {
   3.691398668621318*^9, 3.691398668953146*^9}, {3.691399027639586*^9, 
   3.691399033058919*^9}, 3.691399294307775*^9, {3.6965335647969723`*^9, 
   3.6965335688431387`*^9}, 3.6965344771174006`*^9, 3.6965785941091757`*^9, 
   3.696579411225395*^9, {3.6965894269912667`*^9, 3.6965894275064745`*^9}, {
   3.6965897350800266`*^9, 3.696589735594533*^9}, {3.6965898345974984`*^9, 
   3.69658983701728*^9}, 
   3.697126246133619*^9},ExpressionUUID->"95e5298f-e828-443d-89cd-\
02c13a76bcdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
       "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
        "morestatus___"}], "}"}]}], ",", "Hstat_", ",", 
     RowBox[{"eventlist", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
       "morestatus"}], "}"}], ",", "Hstat", ",", "eventlist", ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690971008414692*^9, 3.69097105616591*^9}, {
   3.690971441454911*^9, 3.690971451563552*^9}, 3.690984599299467*^9, 
   3.690991134304167*^9, {3.691056935670138*^9, 3.6910569360141907`*^9}, {
   3.6913913573417473`*^9, 3.691391361657955*^9}, {3.691398734108169*^9, 
   3.691398746800288*^9}, {3.691399060789405*^9, 3.6913990802973003`*^9}, {
   3.6913993038376427`*^9, 3.6913993181942053`*^9}, {3.6965335765797462`*^9, 
   3.696533580756402*^9}, {3.6965344924850626`*^9, 3.696534495652774*^9}, {
   3.696578246246193*^9, 3.696578263271678*^9}, {3.696579417793808*^9, 
   3.696579420585672*^9}, {3.696580677431375*^9, 3.6965806925345135`*^9}, {
   3.6965807262982836`*^9, 3.6965807264566984`*^9}, {3.6965894323028307`*^9, 
   3.696589432857791*^9}, {3.696589739457032*^9, 3.696589742874037*^9}, {
   3.6965898427491293`*^9, 3.696589846002371*^9}, {3.6971348557888384`*^9, 
   3.6971348579924192`*^9}},ExpressionUUID->"77c14ee7-14bb-44c6-aec0-\
451621991e8c"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Propagation", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}, {3.6965870717063246`*^9, 
   3.6965870728260136`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"2e360c57-f5b6-4b56-b847-516bc108ff4f"],

Cell[CellGroupData[{

Cell["full HilbertSpaceCompatibility, generate overall propagator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, 3.6933104109539137`*^9, {3.693388151990442*^9, 
   3.693388161329486*^9}, {3.696622700510083*^9, 
   3.6966227367055993`*^9}},ExpressionUUID->"926eec7d-a371-459f-9597-\
764280ab773c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"EventList", "[", 
      RowBox[{"st_", ",", "chars_", ",", 
       RowBox[{"events", ":", 
        RowBox[{"{", 
         RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], "]"}],
      ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Hfunc", ",", "matreps", ",", "Ufw", ",", "Ubw"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matreps", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"NPropagationSuperoperator", "[", 
             RowBox[{
             "True", ",", "True", ",", "#", ",", "opbasis", ",", "basis", ",",
               "opts"}], "]"}], ",", "basis"}], "]"}], "&"}], "/@", 
         "events"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Ufw", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
          RowBox[{"First", "@", "matreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "matreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Ubw", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"UnitaryMatrixQ", "[", "Ufw", "]"}], "\[Equal]", "True"}], 
          ",", 
          RowBox[{"ConjugateTranspose", "@", "Ufw"}], ",", 
          RowBox[{"Inverse", "@", "Ufw"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"Ufw", ",", 
           RowBox[{"Transpose", "@", "Ubw"}]}], "]"}], ",", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}], ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}], "}"}], 
              ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", 
            RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}]}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.534311007807122*^9, {3.534311071430175*^9, 3.534311103043881*^9}, {
   3.534311161325684*^9, 3.534311162592239*^9}, 3.5343112035758257`*^9, 
   3.5343181098498573`*^9, {3.5343188669035254`*^9, 3.534318867680813*^9}, 
   3.534398763917116*^9, {3.539449684776085*^9, 3.539449707703122*^9}, 
   3.539449776135705*^9, {3.542266586702509*^9, 3.542266587087212*^9}, 
   3.542282400817648*^9, 3.542282816552648*^9, 3.5422830970682573`*^9, 
   3.542283430931848*^9, {3.626027588356846*^9, 3.6260276198866873`*^9}, {
   3.642514521629387*^9, 3.642514572366727*^9}, {3.6425146195639467`*^9, 
   3.64251462038365*^9}, {3.642515539979156*^9, 3.642515554774953*^9}, {
   3.6666083784669704`*^9, 3.666608387648285*^9}, 3.6666112917429123`*^9, {
   3.6666313866011186`*^9, 3.666631391711933*^9}, {3.6666315192473907`*^9, 
   3.6666315685180807`*^9}, {3.6666932577165184`*^9, 3.666693258016091*^9}, {
   3.666789522111123*^9, 3.666789526380568*^9}, {3.6667896066878667`*^9, 
   3.666789622969426*^9}, {3.666789784816805*^9, 3.666789816266426*^9}, {
   3.666793582521138*^9, 3.666793582596608*^9}, {3.690971730169973*^9, 
   3.690971732322891*^9}, {3.690984086403597*^9, 3.6909841073924303`*^9}, 
   3.69098455989948*^9, {3.690986491425609*^9, 3.6909864988935633`*^9}, {
   3.690986614222039*^9, 3.6909866507617903`*^9}, 3.690986749472444*^9, {
   3.691057297029677*^9, 3.691057305434599*^9}, {3.691057356891182*^9, 
   3.691057394042478*^9}, {3.6910574321858263`*^9, 3.691057473541171*^9}, {
   3.69105751083149*^9, 3.69105753339581*^9}, {3.691391374901676*^9, 
   3.691391410268654*^9}, {3.691402366524681*^9, 3.691402413850623*^9}, {
   3.691407240616992*^9, 3.691407242097354*^9}, {3.693138777747897*^9, 
   3.693138786487462*^9}, {3.6931437635341215`*^9, 3.693143803055565*^9}, {
   3.693144380150019*^9, 3.693144381808704*^9}, {3.6932194898944845`*^9, 
   3.693219491044304*^9}, {3.693219533726365*^9, 3.6932195383237867`*^9}, {
   3.6932195686150684`*^9, 3.693219569337386*^9}, {3.6932197221603003`*^9, 
   3.6932197223404293`*^9}, {3.693220084965603*^9, 3.6932200867152295`*^9}, {
   3.6932202138975754`*^9, 3.6932202213929577`*^9}, 3.693220252393058*^9, {
   3.693220288012597*^9, 3.693220321623582*^9}, {3.693220422303293*^9, 
   3.6932204330736623`*^9}, {3.6932204647130504`*^9, 3.693220490968276*^9}, {
   3.6932205342522154`*^9, 3.693220564040348*^9}, {3.6932205991422453`*^9, 
   3.693220600042329*^9}, {3.6932207370302687`*^9, 3.6932207414287167`*^9}, {
   3.693221511992772*^9, 3.6932216307848854`*^9}, {3.6932216840213156`*^9, 
   3.6932216980483437`*^9}, {3.693221743532666*^9, 3.693221791952119*^9}, 
   3.693221822163003*^9, {3.693221855761532*^9, 3.6932219185501237`*^9}, {
   3.6932219571877165`*^9, 3.6932220261982183`*^9}, {3.6932230685557847`*^9, 
   3.6932230694719915`*^9}, {3.693223115521494*^9, 3.6932231475560293`*^9}, {
   3.6932232076245174`*^9, 3.6932232154938283`*^9}, {3.693223248690349*^9, 
   3.693223266451729*^9}, {3.6932233680680323`*^9, 3.6932233737076793`*^9}, {
   3.6932234311989098`*^9, 3.6932234598890095`*^9}, {3.693223697190358*^9, 
   3.6932237050499043`*^9}, {3.693223938321887*^9, 3.6932239495005245`*^9}, {
   3.6932323881800632`*^9, 3.693232543279377*^9}, {3.6932432869164248`*^9, 
   3.6932432905251656`*^9}, {3.6932466590003424`*^9, 3.693246659500764*^9}, {
   3.693246830655216*^9, 3.693246834224542*^9}, 3.693246978418086*^9, {
   3.693249426813252*^9, 3.6932494500341873`*^9}, 3.693309943209716*^9, {
   3.6933100449324455`*^9, 3.6933100504288044`*^9}, {3.6933101140016747`*^9, 
   3.693310127447793*^9}, {3.6933101787857723`*^9, 3.6933101939648066`*^9}, {
   3.693310241086396*^9, 3.693310242916855*^9}, {3.693310327812502*^9, 
   3.6933103947140355`*^9}, 3.6933369329811296`*^9, {3.6933370044370728`*^9, 
   3.6933370067569942`*^9}, {3.69333716521671*^9, 3.6933371696854615`*^9}, {
   3.693337219567198*^9, 3.693337252103665*^9}, 3.693337300026037*^9, {
   3.6933373849365015`*^9, 3.6933375445880966`*^9}, {3.6933377971402073`*^9, 
   3.69333779923055*^9}, {3.6933379495621257`*^9, 3.693337952480448*^9}, {
   3.693338169087184*^9, 3.6933381791272516`*^9}, {3.693338295293475*^9, 
   3.6933383150319376`*^9}, 3.6933387139067345`*^9, 3.6933387617434053`*^9, {
   3.6933388472583437`*^9, 3.6933388521405163`*^9}, {3.693338899242052*^9, 
   3.6933389031301684`*^9}, {3.6933389947585335`*^9, 3.693339049100334*^9}, {
   3.693339390840852*^9, 3.6933393924454064`*^9}, {3.6933399496705403`*^9, 
   3.693340003292617*^9}, {3.693340059267577*^9, 3.6933402258054314`*^9}, {
   3.6933402623307023`*^9, 3.6933404038813972`*^9}, {3.6933404461922197`*^9, 
   3.693340486690564*^9}, {3.693340517588385*^9, 3.693340521177644*^9}, {
   3.6933405544511337`*^9, 3.6933405998266573`*^9}, {3.693340632426347*^9, 
   3.693340646636235*^9}, {3.693340695275526*^9, 3.6933407659643817`*^9}, {
   3.693340889851172*^9, 3.6933409169685297`*^9}, {3.6933409804834957`*^9, 
   3.6933409824995723`*^9}, {3.6933410130212917`*^9, 
   3.6933410258022876`*^9}, {3.693341077457157*^9, 3.6933411015835886`*^9}, {
   3.6933411928312817`*^9, 3.6933412302273407`*^9}, {3.6933414004280167`*^9, 
   3.693341401082328*^9}, {3.693341476713584*^9, 3.693341481421189*^9}, {
   3.6933415148016496`*^9, 3.693341575804724*^9}, {3.6933416069331584`*^9, 
   3.6933416616282787`*^9}, {3.693341694049718*^9, 3.69334171546452*^9}, {
   3.6933417654169645`*^9, 3.69334177536936*^9}, {3.693380649068019*^9, 
   3.693380650507416*^9}, {3.6933807691033773`*^9, 3.693380772758052*^9}, {
   3.693381732685268*^9, 3.6933817329141254`*^9}, 3.693385099218036*^9, {
   3.693386440995353*^9, 3.6933864445356817`*^9}, {3.6933865521319933`*^9, 
   3.6933865591016965`*^9}, {3.693386836370534*^9, 3.693386839832724*^9}, {
   3.693387005116068*^9, 3.693387005386838*^9}, {3.693387187147277*^9, 
   3.6933871964560375`*^9}, 3.6933873523261395`*^9, 3.696579839696048*^9, {
   3.696579898753912*^9, 3.696579926433397*^9}, {3.6965799583363357`*^9, 
   3.696579967031518*^9}, {3.6965803004002175`*^9, 3.696580320283009*^9}, {
   3.696580466823662*^9, 3.6965805064489794`*^9}, {3.6965806164302497`*^9, 
   3.696580622505397*^9}, 3.6965808630376635`*^9, {3.6965809121020637`*^9, 
   3.696580939478824*^9}, {3.696581011661665*^9, 3.6965810427352514`*^9}, {
   3.6965811615169663`*^9, 3.6965811708447323`*^9}, {3.6965814274487486`*^9, 
   3.696581451988933*^9}, 3.6965871352130213`*^9, {3.6965898637370195`*^9, 
   3.696589864273616*^9}, {3.6965898987541914`*^9, 3.696589905346138*^9}, {
   3.6965899359133224`*^9, 3.6965899520322137`*^9}, {3.6965916297493563`*^9, 
   3.6965916669809875`*^9}, {3.6966227566928835`*^9, 3.69662276452529*^9}, {
   3.6966228468071632`*^9, 3.6966228475591936`*^9}, {3.696622912343554*^9, 
   3.6966229208216753`*^9}, 3.69662315544604*^9, {3.696623201903197*^9, 
   3.696623202700054*^9}, {3.697126647092085*^9, 3.6971266533221416`*^9}, {
   3.6971267263380136`*^9, 3.697126763568459*^9}, {3.6971268163597593`*^9, 
   3.6971268231240306`*^9}, {3.6971275009036226`*^9, 
   3.6971275037402363`*^9}, {3.697127556265283*^9, 3.697127587347711*^9}, {
   3.6971276414043674`*^9, 3.6971276512381487`*^9}, {3.697127704625629*^9, 
   3.697127704917152*^9}, {3.6971280896189923`*^9, 3.6971280923730516`*^9}, {
   3.6971282008784666`*^9, 3.697128201096331*^9}, {3.6971328562960987`*^9, 
   3.697132861613205*^9}, {3.697134811369095*^9, 3.697134811532379*^9}, {
   3.6972051810492845`*^9, 3.697205183194006*^9}, {3.697205259833458*^9, 
   3.6972052600268955`*^9}, {3.6973580570297055`*^9, 
   3.6973580589674425`*^9}, {3.697358091670616*^9, 3.6973580932801976`*^9}, {
   3.6973770870264807`*^9, 3.69737708887107*^9}, {3.6973771246825657`*^9, 
   3.697377145400911*^9}, {3.6973772197104874`*^9, 3.6973772386536913`*^9}, {
   3.6973774890086646`*^9, 3.6973775185183706`*^9}, {3.6973776446250553`*^9, 
   3.6973776447813206`*^9}, {3.7027968238901653`*^9, 
   3.7027968738420277`*^9}, {3.703178786685834*^9, 3.703178789088288*^9}, {
   3.703178890596125*^9, 3.7031788914055166`*^9}, {3.703179221619629*^9, 
   3.7031792218285694`*^9}},ExpressionUUID->"57a1dd1f-cf31-4618-9619-\
054603bab545"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
mixed HilbertSpaceCompatibility, divide EventList and use sequential \
propagation\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, {3.6932283901866817`*^9, 3.693228410856851*^9}, {
   3.693228841865108*^9, 3.693228846954238*^9}, {3.693247335008274*^9, 
   3.6932473351668015`*^9}, {3.6932488727596197`*^9, 
   3.6932488898382635`*^9}},ExpressionUUID->"6e1b672c-9843-4540-9706-\
66a87f4fd88a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", 
     RowBox[{"(", 
      RowBox[{"False", "|", "MixedHilbertSpaceCompatibility"}], ")"}], ",", 
     RowBox[{"ev", ":", 
      RowBox[{"EventList", "[", 
       RowBox[{"st_", ",", "chars_", ",", 
        RowBox[{"events", ":", 
         RowBox[{"{", 
          RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}], 
       "]"}]}], ",", "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"U", ",", "Umatreps", ",", "sortedevents"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sortedevents", "=", 
        RowBox[{"SortVectorSpaceCompatibility", "[", "ev", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Umatreps", "=", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"SuperoperatorMatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"HilbPropToLiouvProp", "[", 
              RowBox[{
               RowBox[{"NPropagationSuperoperator", "[", 
                RowBox[{"True", ",", 
                 RowBox[{"Sequence", "@@", "#"}], ",", "opbasis", ",", 
                 "basis", ",", "opts"}], "]"}], ",", "basis", ",", "opts"}], 
              "]"}], ",", "opbasis"}], "]"}], "&"}], "/@", "sortedevents"}], 
         ")"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"U", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "Umatreps", "]"}], "\[Equal]", "1"}], ",", 
          RowBox[{"First", "@", "Umatreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "Umatreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"Umatreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", 
        RowBox[{"U", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}], "}"}], 
              ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", 
            RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}]}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.534311007807122*^9, {3.534311071430175*^9, 3.534311103043881*^9}, {
   3.534311161325684*^9, 3.534311162592239*^9}, 3.5343112035758257`*^9, 
   3.5343181098498573`*^9, {3.5343188669035254`*^9, 3.534318867680813*^9}, 
   3.534398763917116*^9, {3.539449684776085*^9, 3.539449707703122*^9}, 
   3.539449776135705*^9, {3.542266586702509*^9, 3.542266587087212*^9}, 
   3.542282400817648*^9, 3.542282816552648*^9, 3.5422830970682573`*^9, 
   3.542283430931848*^9, {3.626027588356846*^9, 3.6260276198866873`*^9}, {
   3.642514521629387*^9, 3.642514572366727*^9}, {3.6425146195639467`*^9, 
   3.64251462038365*^9}, {3.642515539979156*^9, 3.642515554774953*^9}, {
   3.6666083784669704`*^9, 3.666608387648285*^9}, 3.6666112917429123`*^9, {
   3.6666313866011186`*^9, 3.666631391711933*^9}, {3.6666315192473907`*^9, 
   3.6666315685180807`*^9}, {3.6666932577165184`*^9, 3.666693258016091*^9}, {
   3.666789522111123*^9, 3.666789526380568*^9}, {3.6667896066878667`*^9, 
   3.666789622969426*^9}, {3.666789784816805*^9, 3.666789816266426*^9}, {
   3.666793582521138*^9, 3.666793582596608*^9}, {3.690971730169973*^9, 
   3.690971732322891*^9}, {3.690984086403597*^9, 3.6909841073924303`*^9}, 
   3.69098455989948*^9, {3.690986491425609*^9, 3.6909864988935633`*^9}, {
   3.690986614222039*^9, 3.6909866507617903`*^9}, 3.690986749472444*^9, {
   3.691057297029677*^9, 3.691057305434599*^9}, {3.691057356891182*^9, 
   3.691057394042478*^9}, {3.6910574321858263`*^9, 3.691057473541171*^9}, {
   3.69105751083149*^9, 3.69105753339581*^9}, {3.691391374901676*^9, 
   3.691391410268654*^9}, {3.691402366524681*^9, 3.691402413850623*^9}, {
   3.691407240616992*^9, 3.691407242097354*^9}, {3.693138777747897*^9, 
   3.693138786487462*^9}, {3.6931437635341215`*^9, 3.693143803055565*^9}, {
   3.693144380150019*^9, 3.693144381808704*^9}, {3.6932194898944845`*^9, 
   3.693219491044304*^9}, {3.693219533726365*^9, 3.6932195383237867`*^9}, {
   3.6932195686150684`*^9, 3.693219569337386*^9}, {3.6932197221603003`*^9, 
   3.6932197223404293`*^9}, {3.693220084965603*^9, 3.6932200867152295`*^9}, {
   3.6932202138975754`*^9, 3.6932202213929577`*^9}, 3.693220252393058*^9, {
   3.693220288012597*^9, 3.693220321623582*^9}, {3.693220422303293*^9, 
   3.6932204330736623`*^9}, {3.6932204647130504`*^9, 3.693220490968276*^9}, {
   3.6932205342522154`*^9, 3.693220564040348*^9}, {3.6932205991422453`*^9, 
   3.693220600042329*^9}, {3.6932207370302687`*^9, 3.6932207414287167`*^9}, {
   3.693221511992772*^9, 3.6932216307848854`*^9}, {3.6932216840213156`*^9, 
   3.6932216980483437`*^9}, {3.693221743532666*^9, 3.693221791952119*^9}, 
   3.693221822163003*^9, {3.693221855761532*^9, 3.6932219185501237`*^9}, {
   3.6932219571877165`*^9, 3.6932220261982183`*^9}, {3.6932230685557847`*^9, 
   3.6932230694719915`*^9}, {3.693223115521494*^9, 3.6932231475560293`*^9}, {
   3.6932232076245174`*^9, 3.6932232154938283`*^9}, {3.693223248690349*^9, 
   3.693223266451729*^9}, {3.6932233680680323`*^9, 3.6932233737076793`*^9}, {
   3.6932234311989098`*^9, 3.6932234598890095`*^9}, {3.693223697190358*^9, 
   3.6932237050499043`*^9}, {3.693223938321887*^9, 3.6932239495005245`*^9}, {
   3.6932284401685653`*^9, 3.6932284674578447`*^9}, {3.6932285480371017`*^9, 
   3.693228548329379*^9}, {3.693228899670059*^9, 3.6932289016780443`*^9}, {
   3.6932289397964964`*^9, 3.693229022045003*^9}, {3.6932290558666925`*^9, 
   3.693229101733514*^9}, {3.693229179673418*^9, 3.693229223571943*^9}, {
   3.693229471481344*^9, 3.693229501331216*^9}, 3.6932295414395847`*^9, 
   3.693229603519432*^9, {3.6932299045348787`*^9, 3.6932299683514214`*^9}, {
   3.6932300596568794`*^9, 3.6932302398001194`*^9}, {3.693230273745476*^9, 
   3.693230300412089*^9}, {3.6932303699112167`*^9, 3.6932303973759017`*^9}, {
   3.6932304352242384`*^9, 3.693230467935282*^9}, {3.693230546424656*^9, 
   3.6932305794234657`*^9}, {3.6932306152767177`*^9, 
   3.6932306485901146`*^9}, {3.6932307881115522`*^9, 
   3.6932308411998067`*^9}, {3.6932311285655184`*^9, 3.693231154632929*^9}, {
   3.69323120056271*^9, 3.693231201191868*^9}, {3.693231258555181*^9, 
   3.693231277065838*^9}, {3.6932313157733526`*^9, 3.6932313226027126`*^9}, {
   3.6932314077738223`*^9, 3.6932314318635864`*^9}, {3.6932314802668295`*^9, 
   3.693231482104393*^9}, {3.6932315181833425`*^9, 3.693231521472569*^9}, {
   3.6932317311512995`*^9, 3.6932317612698965`*^9}, {3.6932318058168726`*^9, 
   3.6932318349340167`*^9}, {3.69323186834151*^9, 3.693231915327364*^9}, {
   3.693231956844167*^9, 3.6932319664593296`*^9}, {3.6932320280977745`*^9, 
   3.693232085989026*^9}, {3.693232145252331*^9, 3.6932321465475526`*^9}, {
   3.6932325552572975`*^9, 3.6932326292876987`*^9}, {3.6932326726459417`*^9, 
   3.693232730505689*^9}, {3.693232771940531*^9, 3.693232772765792*^9}, {
   3.6932328235274887`*^9, 3.6932328902842417`*^9}, {3.6932329883014345`*^9, 
   3.6932330238608932`*^9}, {3.693233062761312*^9, 3.6932330834240355`*^9}, {
   3.693233174263198*^9, 3.6932331823205338`*^9}, {3.6932408167038107`*^9, 
   3.6932408696102285`*^9}, {3.6932409286687155`*^9, 
   3.6932409950850706`*^9}, {3.6932410771642823`*^9, 3.6932412283873405`*^9}, 
   3.6932412615859523`*^9, {3.6932413149514933`*^9, 3.693241330434665*^9}, {
   3.693241385709304*^9, 3.693241391194946*^9}, {3.693241422006688*^9, 
   3.6932414238684635`*^9}, {3.6932414584344234`*^9, 3.693241503734548*^9}, {
   3.6932415753484273`*^9, 3.693241580506605*^9}, {3.6932416390699873`*^9, 
   3.6932416584407406`*^9}, {3.6932416962683654`*^9, 
   3.6932416986442165`*^9}, {3.6932417341137643`*^9, 
   3.6932418192528725`*^9}, {3.6932418649633374`*^9, 
   3.6932419509771233`*^9}, {3.6932419871501403`*^9, 3.693242091305685*^9}, {
   3.6932421380150843`*^9, 3.6932422400465918`*^9}, {3.6932423316019588`*^9, 
   3.6932424229500947`*^9}, {3.693242479427306*^9, 3.693242558078874*^9}, {
   3.6932427294461613`*^9, 3.6932427986019697`*^9}, {3.6932428616400027`*^9, 
   3.693242897734096*^9}, {3.693242941133786*^9, 3.6932429721333723`*^9}, {
   3.6932432283214197`*^9, 3.6932432393807955`*^9}, {3.6932471152883725`*^9, 
   3.6932471176651754`*^9}, {3.693247296262161*^9, 3.693247303407444*^9}, {
   3.6932486816314588`*^9, 3.693248682201329*^9}, {3.6932491938331413`*^9, 
   3.693249198352952*^9}, 3.693249231094245*^9, {3.693249261096758*^9, 
   3.693249317497177*^9}, {3.693307258644993*^9, 3.6933072786597214`*^9}, {
   3.693307321669752*^9, 3.693307397868376*^9}, {3.6933074360637236`*^9, 
   3.693307449059535*^9}, {3.6933074822575397`*^9, 3.6933074847284193`*^9}, {
   3.6933075191722565`*^9, 3.6933075278808947`*^9}, 3.693307612029354*^9, 
   3.69330766251857*^9, {3.6933079297190924`*^9, 3.6933079336684265`*^9}, {
   3.6933084925788374`*^9, 3.693308683187855*^9}, {3.6933087132191334`*^9, 
   3.6933087139904327`*^9}, {3.693308752742201*^9, 3.6933087579704022`*^9}, {
   3.69330883628811*^9, 3.6933088369445763`*^9}, {3.693308877274045*^9, 
   3.6933088791965694`*^9}, {3.693308911352963*^9, 3.6933089249943886`*^9}, {
   3.6933090357299976`*^9, 3.6933090470601454`*^9}, {3.6933090851598387`*^9, 
   3.693309093382635*^9}, 3.6933091306467476`*^9, {3.6933092165616713`*^9, 
   3.6933092218734074`*^9}, {3.6933093369076977`*^9, 3.6933093423712807`*^9}, 
   3.693309404562646*^9, {3.693340044928319*^9, 3.693340056147597*^9}, {
   3.693340884209857*^9, 3.69334088780313*^9}, {3.6933873471524897`*^9, 
   3.693387347958007*^9}, 3.693387970504204*^9, 3.693388003213356*^9, {
   3.6933880680067835`*^9, 3.693388073664672*^9}, 3.693388189473796*^9, {
   3.69338829181905*^9, 3.6933883016062717`*^9}, {3.6935089252802134`*^9, 
   3.6935089314092813`*^9}, {3.696587141442648*^9, 3.6965872105966053`*^9}, {
   3.696587241205818*^9, 3.6965872493639326`*^9}, {3.696587301507114*^9, 
   3.6965873378907733`*^9}, {3.6965873771167936`*^9, 
   3.6965873772747154`*^9}, {3.6965874497478275`*^9, 3.696587536650136*^9}, 
   3.696589485862713*^9, {3.6965898702649555`*^9, 3.6965900116819663`*^9}, {
   3.6965900652557125`*^9, 3.696590108308824*^9}, {3.6965901732729897`*^9, 
   3.6965901787008696`*^9}, {3.6965902114079866`*^9, 3.696590221263935*^9}, {
   3.6965902907498827`*^9, 3.6965903346549063`*^9}, {3.6965904268459096`*^9, 
   3.6965904677888117`*^9}, {3.696590572862187*^9, 3.696590599872574*^9}, {
   3.6965906350692434`*^9, 3.696590637215974*^9}, {3.6965907148524823`*^9, 
   3.6965907229491434`*^9}, {3.696590810233395*^9, 3.6965908193968906`*^9}, {
   3.6965908553316813`*^9, 3.696590895541874*^9}, {3.696590937687642*^9, 
   3.696591156123627*^9}, {3.696591205007334*^9, 3.696591214296796*^9}, {
   3.696591680219474*^9, 3.696591741287763*^9}, {3.696591838810894*^9, 
   3.6965918397945848`*^9}, {3.6966226277133293`*^9, 3.69662263050066*^9}, 
   3.697131622994314*^9, {3.697131674470471*^9, 3.6971316878780584`*^9}, {
   3.697131727456727*^9, 3.6971317305366793`*^9}, {3.697131764627741*^9, 
   3.697131770204872*^9}, {3.697131822574301*^9, 3.6971318833458443`*^9}, {
   3.6971321006611404`*^9, 3.697132101529627*^9}, {3.697132243050335*^9, 
   3.6971322824984765`*^9}, {3.6971323847514915`*^9, 3.697132471774995*^9}, {
   3.6971325365182304`*^9, 3.697132537239662*^9}, {3.6971325773327103`*^9, 
   3.697132653034096*^9}, {3.6971327654906006`*^9, 3.6971327686233015`*^9}, {
   3.6971328005204525`*^9, 3.697132835070753*^9}, {3.6971339168671427`*^9, 
   3.6971339801796722`*^9}, {3.697134029598672*^9, 3.697134035500824*^9}, {
   3.6971340661671696`*^9, 3.6971340664964256`*^9}, {3.6971341385483494`*^9, 
   3.69713414826234*^9}, {3.6971345307351747`*^9, 3.6971345700578814`*^9}, {
   3.6971347171393323`*^9, 3.6971347172208605`*^9}, {3.697134800545063*^9, 
   3.697134807754693*^9}, {3.6971351245474324`*^9, 3.69713513176494*^9}, {
   3.6971351809990845`*^9, 3.697135183152027*^9}, {3.697135304310585*^9, 
   3.6971353101090565`*^9}, {3.697358077247367*^9, 3.697358084357429*^9}, {
   3.697374444806697*^9, 3.697374455586979*^9}, {3.697374686716332*^9, 
   3.697374689993975*^9}, {3.6973785652763233`*^9, 3.697378566912347*^9}, {
   3.6973786780054646`*^9, 3.6973786856735487`*^9}, {3.697378744832818*^9, 
   3.6973787450372057`*^9}, {3.6973789840083714`*^9, 
   3.6973789841916313`*^9}, {3.6973794412796717`*^9, 3.697379477738718*^9}, {
   3.6973795213048086`*^9, 3.697379551575588*^9}, {3.697379606796483*^9, 
   3.697379606968408*^9}, {3.702796887115181*^9, 3.7027969222752266`*^9}, {
   3.7031788959550843`*^9, 3.7031788990754557`*^9}, {3.7031792246596885`*^9, 
   3.703179224820463*^9}, {3.7031794378626823`*^9, 3.703179439747754*^9}, {
   3.703179513230788*^9, 3.703179515945416*^9}, {3.7031795473304014`*^9, 
   3.7031796329610596`*^9}, {3.7031798645109406`*^9, 3.703179905392044*^9}, {
   3.703192602863736*^9, 3.7031926103050284`*^9}, {3.703235451601223*^9, 
   3.7032354518566656`*^9}, {3.7032357004971356`*^9, 3.703235704377487*^9}, {
   3.7032357343908195`*^9, 3.7032357346965837`*^9}, {3.7173191505804567`*^9, 
   3.7173191541198587`*^9}, {3.717319291553172*^9, 3.7173193140062428`*^9}, {
   3.71731944223809*^9, 3.717319442373639*^9}, {3.717321244144311*^9, 
   3.717321245740609*^9}, 
   3.7276850450016174`*^9},ExpressionUUID->"5ea9938f-fbe5-420d-9e8e-\
806569524e08"]
}, Closed]],

Cell[CellGroupData[{

Cell["single events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.483952108490081*^9, 3.4839521288740788`*^9}, {
   3.483952406270108*^9, 3.4839524095229387`*^9}, {3.4839569129551992`*^9, 
   3.483956916752225*^9}, 3.4839581694443293`*^9, {3.483958287050076*^9, 
   3.483958296122057*^9}, {3.503014193362117*^9, 3.503014208040145*^9}, {
   3.503017348661886*^9, 3.503017358771223*^9}, {3.503017401611362*^9, 
   3.503017408091107*^9}, 3.503017704801118*^9, 3.503017736962488*^9, {
   3.503021992734912*^9, 3.503022040150311*^9}, {3.5030225099555397`*^9, 
   3.503022516534483*^9}, {3.503023127639436*^9, 3.5030231524180927`*^9}, {
   3.534337658582926*^9, 3.5343376593222733`*^9}, 3.5422854943250723`*^9, {
   3.690984142060781*^9, 3.690984173758835*^9}, {3.690984316705727*^9, 
   3.690984320486455*^9}, {3.693143967649914*^9, 3.6931439727397156`*^9}, {
   3.6932194101862392`*^9, 3.693219476233447*^9}, {3.6932236496721983`*^9, 
   3.693223658970979*^9}, 3.6933104109539137`*^9, {3.6933800383321157`*^9, 
   3.693380041428832*^9}},ExpressionUUID->"a17ff792-f729-42ac-9a6e-\
9cc335e0efb0"],

Cell[CellGroupData[{

Cell["Null events", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.484301088331937*^9, 3.484301110963764*^9}, {
  3.503024812706325*^9, 3.503024827850071*^9}, {3.503024870705112*^9, 
  3.50302490230342*^9}, {3.5343114395338573`*^9, 3.5343114437467546`*^9}, {
  3.690987153294479*^9, 
  3.690987154241378*^9}},ExpressionUUID->"f6cbb278-8e36-4a63-b74f-\
d5b765f87767"],

Cell[CellGroupData[{

Cell["Hilbert Space Compatible", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.6909877968302298`*^9}, {
  3.6971329434073677`*^9, 
  3.6971329471077814`*^9}},ExpressionUUID->"3a5273f8-2a09-4f9f-b833-\
c6d18b2d7ce2"],

Cell[CellGroupData[{

Cell["PropagatorCalculationProcedure\[Rule]None", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 
  3.6909877968302298`*^9}},ExpressionUUID->"9fd6292e-6bb1-4fe9-9e32-\
a4801997f1dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "True", ",", "None", ",", "__"}], "}"}], 
       ",", "_", ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909877338744802`*^9, 3.690987773088852*^9}, {3.69098818773563*^9, 
   3.690988188404853*^9}, {3.691391398210943*^9, 3.691391404612554*^9}, {
   3.6913921720231457`*^9, 3.6913921732998238`*^9}, 3.691592933541375*^9, 
   3.693508735497898*^9, {3.6968817438080845`*^9, 3.696881752031869*^9}, {
   3.6968831751835217`*^9, 3.696883176613861*^9}, {3.697132987309889*^9, 
   3.6971330060302067`*^9}},ExpressionUUID->"904e07ef-1b3f-4677-8599-\
959b77116422"]
}, Closed]],

Cell[CellGroupData[{

Cell["IntegrateEvolutionOverTime and zero duration", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.690987811069519*^9}, {
   3.6909878417596493`*^9, 3.6909878568756104`*^9}, 
   3.6909881982470407`*^9},ExpressionUUID->"8f6e01e3-911a-472a-92f7-\
eb9af523ea21"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "True", ",", 
          "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", "___Rule"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "T", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, 3.6909882038151903`*^9, {
   3.69139143082561*^9, 3.691391447414576*^9}, {3.6913921772296677`*^9, 
   3.691392178620309*^9}, 3.6915929420290537`*^9, 3.693508749277835*^9, 
   3.6968831822734*^9, {3.6971330107673144`*^9, 
   3.697133026779771*^9}},ExpressionUUID->"dedeb958-d714-4b71-a9b6-\
34b8baa6516b"]
}, Closed]],

Cell[CellGroupData[{

Cell["null evolution ShapeFunction", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, 3.455106406967524*^9, {3.455357656096076*^9, 
   3.4553576616132*^9}, {3.4648512522160473`*^9, 3.464851261206229*^9}, {
   3.5030249613369837`*^9, 3.50302496731923*^9}, 
   3.691592680852573*^9},ExpressionUUID->"bbc4a888-4a4f-4e68-9ddd-\
77a6f339b46b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "_", ",", 
         "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"___", ",", " ", "NullGeneratorPattern"}], "]"}], ",", 
         "_"}], "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.690988217743535*^9, 3.690988232558065*^9}, {
   3.6913914533940067`*^9, 3.6913914576505404`*^9}, {3.691392182613861*^9, 
   3.691392187794449*^9}, {3.691592947520401*^9, 3.691592948519438*^9}, 
   3.693508776306068*^9, 3.6968831861752806`*^9, {3.697133033110467*^9, 
   3.697133067268717*^9}, 
   3.7093745043012877`*^9},ExpressionUUID->"e4b57f79-b5ce-4981-b2fd-\
9b02027d16dc"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnityOperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, {3.503307845369619*^9, 3.503307854191724*^9}, {
   3.534311745984529*^9, 3.5343117488862343`*^9}, 
   3.7031786478975153`*^9},ExpressionUUID->"1a079955-f343-47b1-a193-\
2e8501850801"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"UnityOperator", "[", "___", "]"}], ",", "___"}], "}"}], ",",
        "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"UnityOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.69098807785886*^9, 3.690988095648629*^9}, {
   3.6909897721602793`*^9, 3.690989792302166*^9}, {3.691391464041877*^9, 
   3.6913914715224752`*^9}, {3.691392194912504*^9, 3.691392199306883*^9}, 
   3.691592953910719*^9, 3.6935087843668847`*^9, 3.696883189574538*^9, {
   3.6971329164420443`*^9, 3.6971329169296412`*^9}, {3.6971331480177727`*^9, 
   3.69713316934637*^9}, {3.703178658219407*^9, 3.7031786782487717`*^9}, {
   3.703178729048337*^9, 
   3.703178759799472*^9}},ExpressionUUID->"07c6ab14-cfe7-4584-a230-\
c57887e11898"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Space Incompatible", "Subsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.6909877968302298`*^9}, {
  3.6971329434073677`*^9, 3.6971329471077814`*^9}, {3.6971330764651785`*^9, 
  3.6971330773441133`*^9}},ExpressionUUID->"2636ce11-4143-43db-9f5b-\
e9486f0fa80d"],

Cell[CellGroupData[{

Cell["PropagatorCalculationProcedure\[Rule]None", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 
  3.6909877968302298`*^9}},ExpressionUUID->"fb4c5abd-7700-4593-bbcb-\
665f99c1ac17"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "True", ",", "None", ",", "__"}], "}"}], 
       ",", "_", ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "opbasis", ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909877338744802`*^9, 3.690987773088852*^9}, {3.69098818773563*^9, 
   3.690988188404853*^9}, {3.691391398210943*^9, 3.691391404612554*^9}, {
   3.6913921720231457`*^9, 3.6913921732998238`*^9}, 3.691592933541375*^9, 
   3.693508735497898*^9, {3.6968817438080845`*^9, 3.696881752031869*^9}, {
   3.6968831751835217`*^9, 3.696883176613861*^9}, {3.697132987309889*^9, 
   3.6971330060302067`*^9}, {3.69713310032652*^9, 3.6971331156893106`*^9}, 
   3.6971331804186707`*^9},ExpressionUUID->"037fb091-64b6-49d2-a0d8-\
e63c49dcdfd0"]
}, Closed]],

Cell[CellGroupData[{

Cell["IntegrateEvolutionOverTime and zero duration", "Subsubsubsection",
 CellChangeTimes->{{3.6909877848244123`*^9, 3.690987811069519*^9}, {
   3.6909878417596493`*^9, 3.6909878568756104`*^9}, 
   3.6909881982470407`*^9},ExpressionUUID->"3d0f0f47-592c-4e26-b6af-\
7a74691bf3be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "False", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "True", ",", 
          "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", "___Rule"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "T", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "opbasis", ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, 3.6909882038151903`*^9, {
   3.69139143082561*^9, 3.691391447414576*^9}, {3.6913921772296677`*^9, 
   3.691392178620309*^9}, 3.6915929420290537`*^9, 3.693508749277835*^9, 
   3.6968831822734*^9, {3.6971330107673144`*^9, 3.697133026779771*^9}, {
   3.697133105651463*^9, 3.697133129531793*^9}, 
   3.6971331770434823`*^9},ExpressionUUID->"4752cf4d-a71f-41c1-a250-\
ddef1968a073"]
}, Closed]],

Cell[CellGroupData[{

Cell["null evolution ShapeFunction", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, 3.455106406967524*^9, {3.455357656096076*^9, 
   3.4553576616132*^9}, {3.4648512522160473`*^9, 3.464851261206229*^9}, {
   3.5030249613369837`*^9, 3.50302496731923*^9}, 
   3.691592680852573*^9},ExpressionUUID->"f747c90c-4e23-43cf-ae36-\
3e38125a69c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"T_", ",", "__"}], "}"}], ",", "_", ",", "_", ",", 
         "IntegrateEvolutionOverTime", ",", "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"___", ",", " ", "NullGeneratorPattern"}], "]"}], ",", 
         "_"}], "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "opbasis", ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.690988217743535*^9, 3.690988232558065*^9}, {
   3.6913914533940067`*^9, 3.6913914576505404`*^9}, {3.691392182613861*^9, 
   3.691392187794449*^9}, {3.691592947520401*^9, 3.691592948519438*^9}, 
   3.693508776306068*^9, 3.6968831861752806`*^9, {3.697133033110467*^9, 
   3.697133067268717*^9}, {3.697133133688675*^9, 3.6971331390126753`*^9}, 
   3.697133173409294*^9, 
   3.709374504309163*^9},ExpressionUUID->"c130997e-4240-4c34-8a0b-\
bb84d4c06c41"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, {3.503307845369619*^9, 3.503307854191724*^9}, {
   3.534311745984529*^9, 
   3.5343117488862343`*^9}},ExpressionUUID->"54bca038-8dcd-4cd5-ad6b-\
2f38357832e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "False", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"UnitySuperoperator", "[", "___", "]"}], ",", "___"}], "}"}],
        ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "opbasis", ",", 
     RowBox[{"CheckOperatorType", "\[Rule]", " ", "False"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6909871627809896`*^9, 3.6909872150375967`*^9}, {
   3.690987249734277*^9, 3.690987307121702*^9}, {3.690987386231593*^9, 
   3.690987526518074*^9}, {3.690987572253145*^9, 3.690987615501337*^9}, {
   3.6909878662233267`*^9, 3.690987884629332*^9}, {3.690987942490218*^9, 
   3.690987972363987*^9}, {3.69098807785886*^9, 3.690988095648629*^9}, {
   3.6909897721602793`*^9, 3.690989792302166*^9}, {3.691391464041877*^9, 
   3.6913914715224752`*^9}, {3.691392194912504*^9, 3.691392199306883*^9}, 
   3.691592953910719*^9, 3.6935087843668847`*^9, 3.696883189574538*^9, {
   3.6971329164420443`*^9, 3.6971329169296412`*^9}, {3.6971331480177727`*^9, 
   3.69713316934637*^9}},ExpressionUUID->"44f60a4a-2f88-46a0-b816-\
6e3a95d44b71"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Space Compatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969353615783634`*^9, 
  3.696935366182064*^9}},ExpressionUUID->"49481dc1-6661-4109-812a-\
4a82fc4dfe88"],

Cell[CellGroupData[{

Cell["Time-independent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, 
   3.696935388529559*^9},ExpressionUUID->"81c6655a-5b31-460f-8e67-\
13761594aabe"],

Cell[CellGroupData[{

Cell["Time-independent commutation superoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, 3.534312208835496*^9, 
   3.534312835224263*^9},ExpressionUUID->"5ba9e445-633c-4305-96eb-\
2c852f007df7"],

Cell["evolve under the associated Hamiltonian", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534312697186016*^9, 
  3.5343127063854103`*^9}},ExpressionUUID->"f973ebcc-fe2b-47ff-8546-\
251290655f6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"CommutationSuperoperator", "[", 
          RowBox[{"op_", ",", "___Rule"}], "]"}], ",", "\[Tau]_"}], "}"}], 
       ",", "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"op", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Complex", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}], ",", "\[Tau]"}], 
        "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503025687858303*^9, 3.503025722245736*^9}, {
   3.5031120589480553`*^9, 3.503112110693466*^9}, {3.5031133894727087`*^9, 
   3.5031133896856327`*^9}, 3.503115153550331*^9, {3.5111775809053907`*^9, 
   3.511177584763298*^9}, {3.534312215814622*^9, 3.534312266563973*^9}, 
   3.534312530792787*^9, {3.534312732855695*^9, 3.534312766231317*^9}, {
   3.666608484435109*^9, 3.6666084865346394`*^9}, 3.6666113039965553`*^9, {
   3.6668022157789855`*^9, 3.6668022260903473`*^9}, {3.66681292825787*^9, 
   3.6668129299977474`*^9}, {3.6909844672795877`*^9, 3.690984470085635*^9}, {
   3.690988499468053*^9, 3.6909885262845984`*^9}, {3.690988567156177*^9, 
   3.690988628579484*^9}, {3.691059604153894*^9, 3.691059606048283*^9}, {
   3.69139149389701*^9, 3.6913915067973127`*^9}, 3.691593112043873*^9, {
   3.691593300179624*^9, 3.6915933169049597`*^9}, {3.693381417317855*^9, 
   3.6933814329141536`*^9}, {3.6933829559152966`*^9, 3.693382971133459*^9}, {
   3.693383027939308*^9, 3.6933830312123985`*^9}, {3.6933831896179075`*^9, 
   3.693383190745489*^9}, {3.6933833146777134`*^9, 3.693383328747326*^9}, {
   3.6933860087115674`*^9, 3.69338601783076*^9}, 3.6968832013531284`*^9, {
   3.696883500728565*^9, 3.6968835015693426`*^9}, 3.697126429213069*^9, {
   3.6971266674813757`*^9, 3.6971266741715665`*^9}, 
   3.6972045727669635`*^9},ExpressionUUID->"dab3a0b6-0ff0-43d6-8eb6-\
03d6d26c6df7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent Hamiltonian", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9},ExpressionUUID->"853ebb36-d966-4484-a46f-\
c6b67eb37ebd"],

Cell["if the Operator is diagonalized, use it in that form", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586361647781171*^9, 
  3.586361658171316*^9}},ExpressionUUID->"417851fe-4590-4f9d-a755-\
8c72ad00f9f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Hop", ":", 
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "basis1_", ",", 
             "___Rule"}], "]"}]}]}], ",", "\[Tau]_"}], "}"}], ",", 
       "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis2_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Hop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"basis1", "\[Equal]", "basis2"}], ",", "Hop", ",", 
          RowBox[{"NDiagonalize", "[", 
           RowBox[{"Hop", ",", "basis2"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
        RowBox[{"First", "@", "Hop"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "@", 
           RowBox[{"N", "[", 
            RowBox[{"X", ".", 
             RowBox[{"DiagonalMatrix", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Exp", "[", 
                 RowBox[{
                  RowBox[{"-", "I"}], "*", "\[Tau]", "*", "#"}], "]"}], "&"}],
                "/@", "evals"}], "]"}], ".", "Xinv"}], "]"}]}]}], ",", 
         "basis2", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.6966229502616234`*^9, 3.6966229815824847`*^9}, {3.6971265602278156`*^9, 
   3.6971266075423555`*^9}, {3.6971273859424343`*^9, 
   3.6971274105201883`*^9}},ExpressionUUID->"243212bf-afe3-49bc-9cb5-\
bac7ac0b871c"],

Cell["otherwise use the MatrixExp:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586362011529046*^9, 
  3.5863620187422867`*^9}},ExpressionUUID->"ad3a05fd-8988-44e5-b70a-\
53ed08bad520"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UseMatrixExpWhenPossible", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], ")"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "matrep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "I"}], " ", "Hop", "\[Times]", " ", "\[Tau]"}], "/.", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "basis"}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "@", 
           RowBox[{"N", "@", 
            RowBox[{"MatrixExp", "[", 
             RowBox[{"N", "@", "matrep"}], "]"}]}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.5875487453814287`*^9, 3.587548750271266*^9}, {3.587549184401637*^9, 
   3.5875491956715727`*^9}, 3.587551497715831*^9, {3.621156110832801*^9, 
   3.621156112012767*^9}, {3.6666084939054546`*^9, 3.6666084967445064`*^9}, 
   3.6666113063004503`*^9, {3.6667890644872985`*^9, 3.666789069959587*^9}, {
   3.6667895516308956`*^9, 3.666789551789101*^9}, {3.6668023258856225`*^9, 
   3.6668023270445833`*^9}, {3.666802579260866*^9, 3.666802589794033*^9}, {
   3.6668026320214353`*^9, 3.6668026333398294`*^9}, {3.666812942318075*^9, 
   3.666812966599028*^9}, {3.6669445156443725`*^9, 3.666944519985222*^9}, {
   3.6669447336397448`*^9, 3.666944733882427*^9}, {3.6909844811186533`*^9, 
   3.690984482885489*^9}, {3.6909888249242573`*^9, 3.690988889452402*^9}, {
   3.691057877346417*^9, 3.691057893722179*^9}, {3.691391533479982*^9, 
   3.691391536261326*^9}, 3.691402517815181*^9, {3.6914072617781076`*^9, 
   3.691407262861771*^9}, 3.6914957755793858`*^9, {3.6928466113575172`*^9, 
   3.692846613347499*^9}, 3.692846884837802*^9, 3.6928469164398937`*^9, 
   3.6928480548434057`*^9, {3.6933812111299906`*^9, 3.693381262908482*^9}, {
   3.693381623640545*^9, 3.6933816282797704`*^9}, {3.6933828070818806`*^9, 
   3.6933828334146423`*^9}, {3.6933830041297774`*^9, 3.693383011642889*^9}, {
   3.693383074640422*^9, 3.6933831074704456`*^9}, {3.693383359557277*^9, 
   3.6933833598260345`*^9}, {3.6966230000151606`*^9, 3.696623007347565*^9}, {
   3.697126778038513*^9, 3.6971268080062804`*^9}, {3.697127523617649*^9, 
   3.6971275255213113`*^9}, {3.697127628177831*^9, 3.697127628574583*^9}, {
   3.70323592984933*^9, 3.7032359373512187`*^9}, {3.703235981008243*^9, 
   3.703235981256705*^9}},ExpressionUUID->"b3548611-0544-4438-809e-\
7e46ea9f123c"],

Cell["\<\
if not using the MatrixExp, convert into a function for explicit integration\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.503112000557836*^9, 
  3.503112017213619*^9}},ExpressionUUID->"e800efb7-5360-4ace-b483-\
f9403350dee8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "T_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hop_", "?", "OperatorQ"}], ",", "\[Tau]_"}], "}"}], ",", 
        "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"!", "UseMatrixExpWhenPossible"}], "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], ")"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"StandardizeGenerator", "[", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"t", ",", 
             RowBox[{"Evaluate", "[", "Hop", "]"}]}], "]"}], ",", 
           RowBox[{"Basis", "\[Rule]", "basis"}]}], "]"}], ",", "\[Tau]"}], 
        "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", "basis", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503111914458187*^9, 3.503111933778318*^9}, {3.5031119773263063`*^9, 
   3.503111996098827*^9}, {3.5031120333747587`*^9, 3.503112043315461*^9}, {
   3.503112188293264*^9, 3.5031121940051394`*^9}, {3.5031123829707193`*^9, 
   3.503112387544818*^9}, {3.5031132367593727`*^9, 3.50311323700453*^9}, 
   3.503114828230123*^9, {3.507022907785177*^9, 3.507022910006372*^9}, 
   3.508400570646513*^9, {3.534312162544573*^9, 3.5343121937375183`*^9}, 
   3.5422810910117064`*^9, {3.542955740285832*^9, 3.542955765226015*^9}, {
   3.6667890510363503`*^9, 3.6667890725573006`*^9}, {3.666789542428689*^9, 
   3.6667895448189096`*^9}, {3.66680233177588*^9, 3.6668023373175964`*^9}, {
   3.666812953427063*^9, 3.66681296102861*^9}, {3.6669445762091246`*^9, 
   3.666944586328432*^9}, {3.666944717785367*^9, 3.666944727511091*^9}, {
   3.6909844872225027`*^9, 3.690984489124609*^9}, {3.6909889157805653`*^9, 
   3.690988979396927*^9}, {3.691391543102109*^9, 3.691391557834894*^9}, 
   3.6914957863472767`*^9, {3.6933812768284287`*^9, 3.6933813162945614`*^9}, {
   3.696623035708105*^9, 3.69662304644503*^9}, 3.6966231071106377`*^9, {
   3.6971268435366964`*^9, 3.697126848696512*^9}, 
   3.709374072595256*^9},ExpressionUUID->"a4941bc0-51ed-4d4b-94f1-\
989041b81c1b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Time-dependent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 3.534312862341494*^9}, {3.6933866240201435`*^9, 
   3.6933866247715487`*^9}, {3.6969353906319375`*^9, 
   3.6969353918422594`*^9}},ExpressionUUID->"9a76ffff-d4b7-40cd-a50c-\
af9d54adcef5"],

Cell[CellGroupData[{

Cell["Time-dependent commutation superoperator", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503025674084093*^9, 
   3.503025681306308*^9}, {3.503025797624085*^9, 3.50302579778263*^9}, {
   3.534312817477545*^9, 
   3.5343128456219187`*^9}},ExpressionUUID->"c95cf2ca-d51a-4a90-9f52-\
c95eff97041c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"t_", ",", 
             RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
             RowBox[{"CommutationSuperoperator", "[", 
              RowBox[{"op_", ",", "___Rule"}], "]"}]}], "]"}], ",", 
           "\[Tau]_"}], "}"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], 
        "]"}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], 
    "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"Event", "[", 
      RowBox[{"st", ",", "ch", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"t", ",", "\[Tau]xpairs", ",", "T", ",", 
           RowBox[{"op", "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Complex", "[", 
               RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"a", "-", "b"}], ")"}]}], "}"}]}]}], "]"}], ",", 
         "\[Tau]"}], "}"}], ",", "evopts"}], "]"}], ",", "opbasis", ",", 
     "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695733914894*^9}, 3.4646961401428833`*^9, 3.503018587543092*^9, {
   3.5030189307860823`*^9, 3.503018933222066*^9}, 3.503020924477734*^9, {
   3.503025752698345*^9, 3.5030257583747396`*^9}, {3.5030258334600573`*^9, 
   3.503025850747231*^9}, {3.503025881421885*^9, 3.5030259696222754`*^9}, {
   3.5030260590423822`*^9, 3.503026096992079*^9}, {3.503112232053441*^9, 
   3.503112277937085*^9}, {3.503112319384701*^9, 3.503112366768518*^9}, {
   3.503112422322407*^9, 3.5031124994636602`*^9}, 3.5031125532271223`*^9, {
   3.503112586208776*^9, 3.503112592640542*^9}, {3.503112630090947*^9, 
   3.503112631440538*^9}, {3.503113245678843*^9, 3.5031132459237843`*^9}, {
   3.503113459055827*^9, 3.503113464669381*^9}, {3.503113634395102*^9, 
   3.5031136611266193`*^9}, {3.503113703737402*^9, 3.503113773767356*^9}, {
   3.503113849430991*^9, 3.503113871961054*^9}, {3.503114849311439*^9, 
   3.503114854894581*^9}, {3.507023031173218*^9, 3.507023164828182*^9}, 
   3.534312327172946*^9, {3.534312400901217*^9, 3.534312453718451*^9}, 
   3.5343125212115097`*^9, 3.5422811141952744`*^9, {3.6666085082554593`*^9, 
   3.666608508685293*^9}, 3.6666113088259196`*^9, {3.690984497229733*^9, 
   3.690984499235046*^9}, {3.6910598688327503`*^9, 3.691059899950292*^9}, {
   3.6910599781356916`*^9, 3.6910599861831207`*^9}, {3.691060166591395*^9, 
   3.6910601742377863`*^9}, {3.6910602190608683`*^9, 3.691060221294345*^9}, {
   3.6913915667347593`*^9, 3.691391580922913*^9}, {3.6933853040788345`*^9, 
   3.693385310626051*^9}, {3.693385354138092*^9, 3.6933853613666973`*^9}, {
   3.693385412569092*^9, 3.6933854169390364`*^9}, {3.6933854968520393`*^9, 
   3.6933855012919426`*^9}, {3.693385558824297*^9, 3.6933855629348564`*^9}, {
   3.693385622816536*^9, 3.6933856376915445`*^9}, 3.693385872062977*^9, {
   3.693385910092436*^9, 3.693385922529768*^9}, 3.6968832201693444`*^9, {
   3.6968854982813473`*^9, 3.696885499157544*^9}, {3.6971269061239815`*^9, 
   3.6971269563004365`*^9}, 3.6972045775125704`*^9, {3.697377194416654*^9, 
   3.6973772001537685`*^9}, 
   3.7093750051603947`*^9},ExpressionUUID->"dd29f633-53e6-4fa0-8c0a-\
e6ab6c74e7b8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent Hamiltonian", "Subsubsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 
   3.534312862341494*^9}},ExpressionUUID->"baefdb70-69cd-47ac-9eca-\
17145ec37b14"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
         RowBox[{"ch", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}],
             ",", "__"}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Hfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"t_", ",", 
              RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
              RowBox[{"op_", "?", "OperatorQ"}]}], "]"}]}], ",", "\[Tau]_"}], 
          "}"}], ",", "evopts___Rule"}], "]"}]}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "n", ",", "NDSolveopts", ",", "u", ",", "uvec", ",", "uvecflat", ",", 
       "sol", ",", "uvecplain", ",", "Uini", ",", "Ufunc", ",", "Hmatfunc", 
       ",", "U"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NDSolveopts", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"SimplifyRules", "[", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}], "]"}], ",", 
          RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"n", "=", 
       RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Hmatfunc", "=", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"t$", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
          RowBox[{"Normal", "@", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Hfunc", "[", 
               RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
              RowBox[{"{", 
               RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "basis"}], 
            "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvec", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvecflat", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"uvecplain", "=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", 
            RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Uini", "=", 
       RowBox[{"IdentityMatrix", "[", 
        RowBox[{"BasisDimension", "[", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sol", "=", 
       RowBox[{"NDSolveValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"uvecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
            "\[Equal]", 
            RowBox[{
             RowBox[{"-", "I"}], " ", 
             RowBox[{"(", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{"Hmatfunc", "[", "t$", "]"}], ".", 
                RowBox[{"uvec", "[", "t$", "]"}]}], "]"}], ")"}]}]}], ",", 
           RowBox[{
            RowBox[{"uvecflat", "[", "ta", "]"}], "\[Equal]", 
            RowBox[{"Flatten", "[", "Uini", "]"}]}]}], "}"}], ",", 
         "uvecplain", ",", 
         RowBox[{"{", 
          RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"SparseArray", "[", 
         RowBox[{"Chop", "[", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Through", "[", 
              RowBox[{"#", "[", "tb", "]"}], "]"}], "&"}], "/@", "sol"}], 
           "]"}], "]"}], "]"}], ",", "basis", ",", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Options", "[", "Operator", "]"}]}], "\[IndentingNewLine]",
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.697126997569395*^9, 3.6971270346686144`*^9}, 3.6995987858184185`*^9, 
   3.709375005167679*^9, {3.713607830770892*^9, 3.7136078312831*^9}, {
   3.713607883010407*^9, 3.713607982185095*^9}, {3.71362907502555*^9, 
   3.713629076034191*^9}, {3.7172440727686605`*^9, 
   3.717244086204342*^9}},ExpressionUUID->"4cd35e77-23b9-431a-9c28-\
bf396b1f034f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 
   3.534312831293592*^9},ExpressionUUID->"e7170884-ad16-40f5-ac7c-\
28cf4dcfefcf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NPropagationSuperoperator", "[", 
   RowBox[{"True", ",", "True", ",", 
    RowBox[{"Event", "[", 
     RowBox[{
      RowBox[{"True", "|", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
       "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
        "__"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"RotationSuperoperator", "[", "args___", "]"}], ",", "___"}], 
       "}"}], ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
    "opts___Rule"}], "]"}], ":=", 
  RowBox[{"RotationOperator", "[", "args", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, {3.697127090749832*^9, 3.6971271011871133`*^9}, {
   3.697377603214733*^9, 3.697377641147216*^9}, {3.717319779114278*^9, 
   3.7173197813206224`*^9}, {3.7173200109689417`*^9, 
   3.7173200143694334`*^9}, {3.717320200695881*^9, 3.7173202089187336`*^9}, {
   3.7173209497372503`*^9, 
   3.7173209521928062`*^9}},ExpressionUUID->"99cdf1f7-acb9-45f4-b867-\
079d43815bd6"]
}, Closed]],

Cell[CellGroupData[{

Cell["Product of RotationSuperoperators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, {3.503020847616892*^9, 
   3.503020850758997*^9}, 3.503307862411919*^9, {3.5033079587533073`*^9, 
   3.503307958991561*^9}, 3.5343118044638023`*^9, 3.534312831293592*^9, {
   3.7095504893925085`*^9, 
   3.7095504933768435`*^9}},ExpressionUUID->"1f28ffcd-a6b2-4135-8a76-\
e03e5d2caa70"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NPropagationSuperoperator", "[", 
   RowBox[{"True", ",", "True", ",", 
    RowBox[{"Event", "[", 
     RowBox[{
      RowBox[{"True", "|", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
        "__"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"R", ":", 
         RowBox[{"Dot", "[", 
          RowBox[{
           RowBox[{"RotationSuperoperator", "[", "___", "]"}], ",", 
           RowBox[{
            RowBox[{"RotationSuperoperator", "[", "___", "]"}], ".."}]}], 
          "]"}]}], ",", "___"}], "}"}], ",", "___Rule"}], "]"}], ",", 
    "opbasis_", ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", 
  RowBox[{"R", "/.", 
   RowBox[{"{", 
    RowBox[{"RotationSuperoperator", "\[Rule]", " ", "RotationOperator"}], 
    "}"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, {3.503020885105047*^9, 
   3.503020899142147*^9}, {3.5030209478811502`*^9, 3.503021004761517*^9}, 
   3.503021378034782*^9, 3.503021762916622*^9, {3.503112892076689*^9, 
   3.5031129066813517`*^9}, {3.503113265844778*^9, 3.503113266034143*^9}, {
   3.534311915799788*^9, 3.534311965011478*^9}, 3.5343125396913967`*^9, 
   3.534312652213155*^9, {3.534318251634251*^9, 3.534318251965012*^9}, 
   3.534318499159993*^9, 3.534387837165782*^9, 3.534406136851204*^9, {
   3.5645675566035547`*^9, 3.564567639094993*^9}, {3.621156097467063*^9, 
   3.621156098714506*^9}, {3.6666084538408504`*^9, 3.6666084595260925`*^9}, 
   3.666611298841812*^9, {3.666788296710573*^9, 3.6667882967801237`*^9}, {
   3.6667890207104635`*^9, 3.666789023380282*^9}, {3.6667895309491863`*^9, 
   3.6667895311793585`*^9}, {3.6667895996177998`*^9, 
   3.6667896004764214`*^9}, {3.6909844444728394`*^9, 3.690984449812413*^9}, {
   3.690988319495322*^9, 3.6909883430272703`*^9}, {3.690988374763534*^9, 
   3.6909883832924643`*^9}, {3.690989783361497*^9, 3.690989796366737*^9}, {
   3.691057671105008*^9, 3.691057708910184*^9}, {3.691391477512455*^9, 
   3.691391482280105*^9}, {3.691402459697444*^9, 3.6914024650558863`*^9}, 
   3.6915929632788277`*^9, 3.6933846907445*^9, {3.6933849609200373`*^9, 
   3.693384967099888*^9}, {3.6968819013724737`*^9, 3.6968819040748105`*^9}, 
   3.6968831940411644`*^9, 3.6972219274184446`*^9, {3.701630867726658*^9, 
   3.701630873087463*^9}, {3.701632327423862*^9, 3.7016323285116053`*^9}, {
   3.7095504992671413`*^9, 3.709550524745584*^9}, {3.7095508211544123`*^9, 
   3.7095508321612806`*^9}, 
   3.7173200590908637`*^9},ExpressionUUID->"fce35cfe-66e0-4521-a8ee-\
b0edbcacc772"]
}, Closed]],

Cell[CellGroupData[{

Cell["Repeat", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.690984518900131*^9, 3.690984520602982*^9}, 
   3.692848521296042*^9},ExpressionUUID->"adb5873e-e7f0-4d5e-b385-\
45a49a7b2280"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"NPropagationSuperoperator", "[", 
      RowBox[{"True", ",", "True", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", 
         RowBox[{
          RowBox[{"st", ":", 
           RowBox[{"(", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
          ",", 
          RowBox[{"Repeat", "[", 
           RowBox[{
            RowBox[{"EventList", "[", 
             RowBox[{"st_", ",", "chars_", ",", 
              RowBox[{"events", ":", 
               RowBox[{"{", 
                RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}],
              "]"}], ",", "n_Integer", ",", "evtropts___Rule"}], "]"}], ",", 
          "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", "opbasis_", 
       ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "RepeatPropagator"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zbmatreps", ",", "singleprop"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbmatreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"NPropagationSuperoperator", "[", 
             RowBox[{
             "True", ",", "True", ",", "#", ",", "opbasis", ",", "basis", ",",
               "opts"}], "]"}], ",", "basis"}], "]"}], "&"}], "/@", 
         "events"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"singleprop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "zbmatreps", "]"}], "\[Equal]", "1"}], ",", 
          
          RowBox[{"First", "@", "zbmatreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "zbmatreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"zbmatreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"MatrixPower", "[", 
          RowBox[{"singleprop", ",", "n"}], "]"}], ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, 3.542281134468389*^9, {3.5645684544067097`*^9, 
   3.5645685012249613`*^9}, {3.586362122636345*^9, 3.5863624728699913`*^9}, {
   3.586363380330854*^9, 3.586363385359961*^9}, {3.587576139268099*^9, 
   3.5875761417981577`*^9}, {3.5875762341269007`*^9, 
   3.5875763853272038`*^9}, {3.5875766585438547`*^9, 3.5875766813166533`*^9}, 
   {3.666608549421843*^9, 3.6666085497823753`*^9}, 3.6666113141219406`*^9, {
   3.683186587217523*^9, 3.6831865919508047`*^9}, 3.683187098958549*^9, {
   3.690984514860692*^9, 3.690984524039979*^9}, {3.691060687197613*^9, 
   3.691060753746748*^9}, {3.691060866239098*^9, 3.691060959114229*^9}, {
   3.691061045218045*^9, 3.691061064384056*^9}, {3.691391609964263*^9, 
   3.691391622649879*^9}, {3.691402547637679*^9, 3.691402548638754*^9}, {
   3.691407274584907*^9, 3.691407275830823*^9}, {3.691677015180834*^9, 
   3.6916770182838287`*^9}, 3.692848522364584*^9, {3.6933866763541565`*^9, 
   3.6933867082645226`*^9}, {3.6933868450700207`*^9, 3.693386847092952*^9}, {
   3.693386913362214*^9, 3.6933869171302466`*^9}, 3.6933869501801786`*^9, {
   3.6933869849993935`*^9, 3.6933869860494027`*^9}, {3.693387077668935*^9, 
   3.693387127937803*^9}, {3.693387174769182*^9, 3.6933871750875225`*^9}, {
   3.6933872765581036`*^9, 3.693387278983719*^9}, {3.693387310775377*^9, 
   3.693387310935706*^9}, {3.69338736901866*^9, 3.6933873913619175`*^9}, {
   3.6933874420014267`*^9, 3.693387458514313*^9}, {3.693387506983118*^9, 
   3.6933875252716055`*^9}, {3.693387566221203*^9, 3.693387589900855*^9}, {
   3.69338765801058*^9, 3.6933876744000473`*^9}, {3.693387704621563*^9, 
   3.693387769228965*^9}, {3.6933878697279177`*^9, 3.6933879023280563`*^9}, 
   3.696883229545755*^9, {3.696935508361205*^9, 3.696935539441184*^9}, {
   3.6969355907212625`*^9, 3.6969355921023006`*^9}, {3.697121899484744*^9, 
   3.6971219121194067`*^9}, {3.697127826516127*^9, 3.697127873093648*^9}, 
   3.709375005174613*^9},ExpressionUUID->"165e4a7f-0d40-4a2c-9545-\
6135d9e9cb51"]
}, Closed]],

Cell[CellGroupData[{

Cell["PrecalculatedEvent", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.538677605389827*^9, 
   3.538677607531299*^9}},ExpressionUUID->"97fccdc3-157a-439d-80b2-\
8704d16608d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "True", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",", 
         RowBox[{"PrecalculatedEvent", "[", 
          RowBox[{
          "precalch_", ",", "op_Operator", ",", "precalevopts___Rule"}], 
          "]"}], ",", "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "UsePrecalculatedPropagator"}], "]"}]}], ":=", "op"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, {3.53867763931421*^9, 3.5386776481776333`*^9}, {
   3.538677692924055*^9, 3.538677702585209*^9}, {3.5391124476711493`*^9, 
   3.539112453900564*^9}, {3.6666085615139894`*^9, 3.666608567772622*^9}, 
   3.6666113169912148`*^9, {3.690984529675124*^9, 3.690984531611169*^9}, {
   3.691391630156105*^9, 3.691391637265486*^9}, {3.6914382516732264`*^9, 
   3.691438340756529*^9}, 3.693508805406706*^9, 3.6968832344556627`*^9, {
   3.6969356333015823`*^9, 3.6969356425896783`*^9}, {3.6971278899807234`*^9, 
   3.697127894353434*^9}, {3.697128047941599*^9, 3.697128054191354*^9}, {
   3.6971281913296747`*^9, 3.697128193995653*^9}, {3.697133724543481*^9, 
   3.697133727230652*^9}},ExpressionUUID->"49fad421-7b5c-4d39-9014-\
55a6d96ad51c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Hilbert Space Incompatible", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6969354317516556`*^9, 
  3.6969354377385855`*^9}},ExpressionUUID->"c4fa3813-65b4-48e2-abd2-\
47e2808bc321"],

Cell[CellGroupData[{

Cell["Instantaneous Transformation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 3.69693544787114*^9, {3.69712426496584*^9, 
   3.6971242706544685`*^9}},ExpressionUUID->"38cbc6ce-9ec7-48e7-852d-\
828fccc3a559"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"True", "|", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
        "_", ",", "_", ",", "_", ",", "InstantaneousTransformation", ",", 
         "__"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"InstaOp_", ",", "___"}], "}"}], ",", "___Rule"}], "]"}], ",",
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{"InstaOp", ",", "opbasis", ",", 
     RowBox[{"CheckOperatorBasis", "\[Rule]", " ", "False"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.696933441959618*^9, 3.696933496599775*^9}, {3.6969336005520544`*^9, 
   3.6969336021370754`*^9}, {3.696933768414254*^9, 3.6969337700656276`*^9}, {
   3.6969338194073725`*^9, 3.6969338265665736`*^9}, {3.6969338979505153`*^9, 
   3.6969339067827215`*^9}, {3.6969343081750884`*^9, 
   3.6969343371754217`*^9}, {3.69693437996661*^9, 3.6969343918608027`*^9}, {
   3.6969344369818544`*^9, 3.696934471013612*^9}, {3.6969345411996994`*^9, 
   3.6969345417349706`*^9}, {3.696934579056014*^9, 3.6969345915662336`*^9}, {
   3.6969347182855387`*^9, 3.6969347437181387`*^9}, {3.696934791247017*^9, 
   3.696934795084534*^9}, {3.696934914567275*^9, 3.6969349147324734`*^9}, {
   3.6971243951148825`*^9, 3.6971244639941216`*^9}, {3.6971336934110994`*^9, 
   3.69713371399419*^9}},ExpressionUUID->"c747221b-2183-49ca-8833-\
a2d580decc53"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-independent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.455552020081628*^9, 3.455552020279099*^9}, 3.534312077669235*^9, 
   3.5343128392517233`*^9, {3.6933813806930246`*^9, 3.693381405632555*^9}, {
   3.6933846522543497`*^9, 3.693384656114546*^9}, {3.696924411003746*^9, 
   3.6969244124433546`*^9}, 
   3.69693544787114*^9},ExpressionUUID->"4f3fb50a-cb01-4846-ae18-\
e8b8db00ea59"],

Cell["\<\
if the Operator is diagonalized, use it in that form. If the Hamiltonian gets \
diagonalized any information on HilbertSpaceCompatibility is lost.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586361647781171*^9, 3.586361658171316*^9}, {
  3.6969346428762445`*^9, 
  3.6969346614276605`*^9}},ExpressionUUID->"9746e053-748e-414b-a512-\
e86f71dc4b3f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "[", 
    RowBox[{"True", ",", "False", ",", 
     RowBox[{"Event", "[", 
      RowBox[{
       RowBox[{"st", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
       RowBox[{"ch", ":", 
        RowBox[{"{", 
         RowBox[{
         "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
          "__"}], "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Lsop", ":", 
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Superoperator", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis1_", ",", 
             "basis1_", ",", "___Rule"}], "]"}]}]}], ",", "\[Tau]_"}], "}"}], 
       ",", "evopts___Rule"}], "]"}], ",", "opbasis2_", ",", "basis2_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Lsop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"opbasis1", "===", "opbasis2"}], ",", "Lsop", ",", 
          RowBox[{"NDiagonalize", "[", 
           RowBox[{
            RowBox[{"StandardizeGenerator", "[", "Lsop", "]"}], ",", 
            "opbasis2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
        RowBox[{"First", "@", "Lsop"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "[", 
           RowBox[{"X", ".", 
            RowBox[{"DiagonalMatrix", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Exp", "[", 
                RowBox[{"\[Tau]", "*", "#"}], "]"}], "&"}], "/@", "evals"}], 
             "]"}], ".", "Xinv"}], "]"}]}], ",", "\[IndentingNewLine]", 
         "opbasis2", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4551117634657373`*^9, 3.455112012075117*^9}, {
   3.455112164482581*^9, 3.455112260631955*^9}, {3.455113182600039*^9, 
   3.455113188980443*^9}, 3.455113437173794*^9, 3.455113849674779*^9, {
   3.455114444629632*^9, 3.455114448009263*^9}, {3.4551145070602617`*^9, 
   3.4551145302337847`*^9}, {3.455370221440715*^9, 3.4553702300594463`*^9}, {
   3.4554605673110933`*^9, 3.455460567580195*^9}, {3.455552023911994*^9, 
   3.455552093841964*^9}, 3.4555555529302177`*^9, {3.455597232849123*^9, 
   3.455597233853826*^9}, {3.459234704851592*^9, 3.4592347051769667`*^9}, {
   3.459337222814728*^9, 3.459337230051939*^9}, {3.459337383811098*^9, 
   3.459337384494768*^9}, 3.459439922273789*^9, {3.464327739930594*^9, 
   3.4643277476748857`*^9}, 3.464458073719438*^9, {3.464695597646894*^9, 
   3.464695662585019*^9}, {3.4648492511085043`*^9, 3.464849252484563*^9}, {
   3.4652851712566643`*^9, 3.465285171477564*^9}, 3.467720489074432*^9, {
   3.50301844924866*^9, 3.503018522405575*^9}, 3.5030209223908443`*^9, 
   3.5030221057571087`*^9, {3.503111783930485*^9, 3.5031118896645947`*^9}, {
   3.503113232376391*^9, 3.50311323264462*^9}, 3.503115159166007*^9, {
   3.511177562007619*^9, 3.511177565635845*^9}, {3.534312083807715*^9, 
   3.534312116057868*^9}, {3.5343121466937847`*^9, 3.534312149178388*^9}, 
   3.534312535904501*^9, {3.534318522377142*^9, 3.5343185234822607`*^9}, 
   3.5422810838844547`*^9, {3.564567833673963*^9, 3.564567867573759*^9}, {
   3.5645697865006847`*^9, 3.564569787362529*^9}, {3.564577047213009*^9, 
   3.564577051608374*^9}, {3.564577088875805*^9, 3.564577093078429*^9}, {
   3.564577213918848*^9, 3.564577221028534*^9}, {3.5645772554423637`*^9, 
   3.5645772741271057`*^9}, {3.5645773467671347`*^9, 
   3.5645773493885612`*^9}, {3.564577387660431*^9, 3.5645773935790854`*^9}, {
   3.586361669646913*^9, 3.586361955926073*^9}, {3.5863638239721327`*^9, 
   3.586363826219451*^9}, {3.586691308704438*^9, 3.58669131294207*^9}, {
   3.587548673118249*^9, 3.5875486774852448`*^9}, 3.587551490962307*^9, {
   3.666789076336963*^9, 3.6667890802192554`*^9}, {3.666789556279532*^9, 
   3.6667895564303293`*^9}, {3.666802201418946*^9, 3.666802206480029*^9}, {
   3.6668129357873645`*^9, 3.6668129361959114`*^9}, 3.6668129711680174`*^9, {
   3.6669445925576544`*^9, 3.6669445951386194`*^9}, {3.6669447109318132`*^9, 
   3.6669447113322935`*^9}, {3.6909844750225554`*^9, 3.690984476988277*^9}, {
   3.690988657226067*^9, 3.690988743522512*^9}, 3.690988811619916*^9, {
   3.691057820565187*^9, 3.691057861480302*^9}, {3.691391512656638*^9, 
   3.691391517271626*^9}, 3.691402501378737*^9, {3.69140725250563*^9, 
   3.691407254048586*^9}, 3.691495779065825*^9, {3.6928466053804626`*^9, 
   3.692846607811161*^9}, {3.692846871259223*^9, 3.692846922744742*^9}, 
   3.692848045715362*^9, {3.6933804579186125`*^9, 3.6933804780490828`*^9}, 
   3.6933805645807233`*^9, {3.6933806883748784`*^9, 3.6933807056757064`*^9}, 
   3.6933808487513633`*^9, {3.693380881333231*^9, 3.6933808842226624`*^9}, {
   3.693381003091476*^9, 3.693381006211204*^9}, {3.6933811137406*^9, 
   3.693381114520999*^9}, {3.693381165396096*^9, 3.693381172356368*^9}, {
   3.693381630700369*^9, 3.6933816366603*^9}, {3.6933817908497305`*^9, 
   3.6933818165664377`*^9}, 3.6933818862049847`*^9, {3.6933821328151407`*^9, 
   3.6933821483129263`*^9}, {3.693382215064184*^9, 3.693382220372837*^9}, {
   3.6933828040022697`*^9, 3.693382804240941*^9}, {3.693383884806611*^9, 
   3.693383930039185*^9}, {3.693384030360767*^9, 3.6933840306977515`*^9}, {
   3.693384241751237*^9, 3.6933842470014014`*^9}, {3.693384301850707*^9, 
   3.6933843053950176`*^9}, {3.6933843391829557`*^9, 
   3.6933843629823527`*^9}, {3.693384483061057*^9, 3.6933845426143627`*^9}, {
   3.696881961052439*^9, 3.696881965217164*^9}, 3.696883206536855*^9, {
   3.6968834050207925`*^9, 3.6968834068763824`*^9}, {3.6968834489716554`*^9, 
   3.696883451231428*^9}, {3.696883483871314*^9, 3.69688348423173*^9}, {
   3.696933441959618*^9, 3.696933496599775*^9}, {3.6969336005520544`*^9, 
   3.6969336021370754`*^9}, {3.696933768414254*^9, 3.6969337700656276`*^9}, {
   3.6969338194073725`*^9, 3.6969338265665736`*^9}, {3.6969338979505153`*^9, 
   3.6969339067827215`*^9}, {3.6969343081750884`*^9, 
   3.6969343371754217`*^9}, {3.69693437996661*^9, 3.6969343918608027`*^9}, {
   3.6969344369818544`*^9, 3.696934471013612*^9}, {3.6969345411996994`*^9, 
   3.6969345417349706`*^9}, {3.696934579056014*^9, 3.6969345915662336`*^9}, {
   3.6969347182855387`*^9, 3.6969347437181387`*^9}, {3.696934791247017*^9, 
   3.696934795084534*^9}, {3.696934914567275*^9, 3.6969349147324734`*^9}, {
   3.6971336498676844`*^9, 3.697133665968496*^9}, {3.702796406414686*^9, 
   3.702796412726344*^9}, 3.7031825109729548`*^9, 
   3.726070348304959*^9},ExpressionUUID->"4bda44a9-f831-479c-b1db-\
0b8e012e302c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "False", ",", 
      RowBox[{"Event", "[", 
       RowBox[{
        RowBox[{"st", ":", 
         RowBox[{"(", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
        RowBox[{"ch", ":", 
         RowBox[{"{", 
          RowBox[{
          "_", ",", "_", ",", "_", ",", "IntegrateEvolutionOverTime", ",", 
           "__"}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Lsop_", "?", "SuperoperatorQ"}], ",", "\[Tau]_"}], "}"}], 
        ",", "evopts___Rule"}], "]"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"UseMatrixExpWhenPossible", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], ")"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "matrep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matrep", "=", 
        RowBox[{"SuperoperatorMatrixRepresentation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"StandardizeGenerator", "[", "Lsop", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}]}], ",", "opbasis"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "@", 
          RowBox[{"Chop", "@", 
           RowBox[{"N", "@", 
            RowBox[{"MatrixExp", "[", 
             RowBox[{"\[Tau]", " ", "\[Times]", 
              RowBox[{"N", "@", "matrep"}]}], "]"}]}]}]}], ",", 
         "\[IndentingNewLine]", "opbasis", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452690531068695*^9, 3.452690599728272*^9}, {
   3.452713481624045*^9, 3.452713486519453*^9}, {3.4527140041197157`*^9, 
   3.452714025416692*^9}, {3.4527140867578707`*^9, 3.452714099086936*^9}, {
   3.452714132023095*^9, 3.452714170502606*^9}, {3.452827494265431*^9, 
   3.452827499986635*^9}, {3.452827946311603*^9, 3.452827963017808*^9}, 
   3.4528280197802*^9, {3.452834425940219*^9, 3.452834429248974*^9}, {
   3.45296862907323*^9, 3.452968698911127*^9}, {3.452968996703251*^9, 
   3.452969016852367*^9}, {3.452970229607943*^9, 3.452970232824254*^9}, {
   3.454565577792158*^9, 3.454565600318421*^9}, 3.454565641800033*^9, {
   3.454577368550002*^9, 3.454577370845316*^9}, {3.454578554194628*^9, 
   3.454578556002204*^9}, {3.455275348251018*^9, 3.455275352394432*^9}, {
   3.455361518545755*^9, 3.45536152261629*^9}, {3.45536281612714*^9, 
   3.4553628203417187`*^9}, 3.455366472829061*^9, {3.45536961860872*^9, 
   3.455369629323238*^9}, {3.455369740504629*^9, 3.455369787310898*^9}, 
   3.456221604466387*^9, 3.456322845966786*^9, {3.4589940597643414`*^9, 
   3.4589940633240633`*^9}, 3.458994113231534*^9, {3.459338412973414*^9, 
   3.4593384203475533`*^9}, 3.462784366060383*^9, 3.4627845100182743`*^9, {
   3.464327358280571*^9, 3.464327363245153*^9}, 3.464458072781571*^9, {
   3.464610652673967*^9, 3.4646107047530823`*^9}, {3.464678912105274*^9, 
   3.464678942165515*^9}, {3.4646950329855013`*^9, 3.4646951269304113`*^9}, 
   3.4677204030792828`*^9, {3.500263382317464*^9, 3.5002634169959717`*^9}, 
   3.500263477936509*^9, 3.500263613435347*^9, {3.500264852949397*^9, 
   3.5002648583546143`*^9}, {3.500264891975165*^9, 3.500264925811551*^9}, {
   3.500265256299799*^9, 3.5002652596084213`*^9}, {3.500266263584918*^9, 
   3.500266449360496*^9}, {3.500266482204661*^9, 3.500266498800531*^9}, {
   3.50026660199973*^9, 3.500266618843708*^9}, {3.5002733799245367`*^9, 
   3.500273383047964*^9}, {3.500274045908242*^9, 3.500274046896537*^9}, {
   3.500274245833909*^9, 3.500274249255313*^9}, {3.5002749581101847`*^9, 
   3.5002751164358273`*^9}, {3.500275391980563*^9, 3.5002753945173264`*^9}, {
   3.50316912017247*^9, 3.503169135318965*^9}, 3.504458413538725*^9, {
   3.510334215541009*^9, 3.510334230946742*^9}, 3.511623355269967*^9, {
   3.511623717178936*^9, 3.5116238191868877`*^9}, {3.532003693782765*^9, 
   3.532003702255629*^9}, {3.534398607196209*^9, 3.534398607600121*^9}, 
   3.621573524540504*^9, {3.6969246067334986`*^9, 3.69692464688102*^9}, {
   3.696924714000514*^9, 3.6969247538575783`*^9}, {3.6969248378795223`*^9, 
   3.696924849107593*^9}, {3.6969249276967306`*^9, 3.6969249300645447`*^9}, {
   3.696925070044421*^9, 3.696925072852312*^9}, {3.6969253869162226`*^9, 
   3.696925396176249*^9}, {3.696925492925914*^9, 3.6969255564238443`*^9}, {
   3.696925681571023*^9, 3.6969256916631308`*^9}, {3.6969257826323223`*^9, 
   3.696925782892612*^9}, {3.696933737166244*^9, 3.696933751560065*^9}, {
   3.696933805070039*^9, 3.696933807294442*^9}, 3.6969338915818906`*^9, {
   3.6969342927494116`*^9, 3.696934295615456*^9}, 3.6969350138828397`*^9, {
   3.6971336705186462`*^9, 3.6971336755431647`*^9}, {3.6971341132779255`*^9, 
   3.6971341302781353`*^9}, {3.697134276329816*^9, 3.697134278632923*^9}, {
   3.697134863581616*^9, 3.6971348637309704`*^9}, 3.6972070169743958`*^9, {
   3.702796380006322*^9, 3.702796384445751*^9}, {3.7031817116594343`*^9, 
   3.7031817165737257`*^9}, 3.703182518363917*^9, {3.7032358363814487`*^9, 
   3.703235838880539*^9}, {3.7032360015920305`*^9, 3.703236001768604*^9}, {
   3.713628908322339*^9, 3.7136289406139145`*^9}, {3.7136290531962843`*^9, 
   3.7136290564134684`*^9}, 
   3.726070348328341*^9},ExpressionUUID->"6d3a1b59-29e5-49f4-9e37-\
51209a3a0b20"]
}, Closed]],

Cell[CellGroupData[{

Cell["Time-dependent generators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4551117194323263`*^9, 3.455111790891016*^9}, {3.455111895292593*^9, 
   3.455111903493291*^9}, {3.4551121162730083`*^9, 3.455112125757937*^9}, {
   3.455112270985013*^9, 3.455112273867683*^9}, {3.455113298380747*^9, 
   3.4551133088825207`*^9}, {3.4551133697186728`*^9, 
   3.4551133710658817`*^9}, {3.455113933851789*^9, 3.455113950719378*^9}, {
   3.4551140091862907`*^9, 3.455114030261853*^9}, 3.455114413559901*^9, {
   3.534312858973914*^9, 3.534312862341494*^9}, {3.6933866240201435`*^9, 
   3.6933866247715487`*^9}, {3.6969244138622255`*^9, 3.6969244145023837`*^9}, 
   3.696935449737483*^9},ExpressionUUID->"91025dbb-0f96-4171-86da-\
f6bde3d00978"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "False", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", 
         RowBox[{"ch", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "moretch___"}], "}"}],
             ",", "__"}], "}"}]}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Lfunc", ":", 
            RowBox[{"ShapeFunction", "[", 
             RowBox[{"t_", ",", 
              RowBox[{"\[Tau]xpairs_", "?", "MatrixQ"}], ",", "T_", ",", 
              RowBox[{"op_", "?", "SuperoperatorQ"}]}], "]"}]}], ",", 
           "\[Tau]_"}], "}"}], ",", "evopts___Rule"}], "]"}]}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "IntegrateEvolutionOverTime"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "nL", ",", "u", ",", "uvecflat", ",", "uvec", ",", "uvecplain", ",", 
       "NDSolveopts", ",", "Uini", ",", "Lmatfunc", ",", "sol"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NDSolveopts", "=", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"SimplifyRules", "[", 
           RowBox[{"{", 
            RowBox[{"evopts", ",", "opts"}], "}"}], "]"}], ",", 
          RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"nL", "=", 
       RowBox[{
        RowBox[{"BasisDimension", "[", "]"}], "^", "2"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lmatfunc", "=", 
       RowBox[{"Function", "[", 
        RowBox[{"t$", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"N", "[", 
           RowBox[{"SuperoperatorMatrixRepresentation", "[", 
            RowBox[{
             RowBox[{"StandardizeGenerator", "[", 
              RowBox[{
               RowBox[{"Lfunc", "[", 
                RowBox[{"t$", ",", "ta", ",", "tb"}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"evopts", ",", "opts"}], "}"}]}], "]"}], ",", 
             "opbasis"}], "]"}], "]"}]}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvec", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"u", "[", 
             RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"uvecflat", "[", "t$_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "[", "t$", "]"}], "&"}], ",", 
           
           RowBox[{"{", 
            RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"uvecplain", "=", 
       RowBox[{"Evaluate", "[", 
        RowBox[{"Array", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"u", "[", 
            RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"nL", ",", "nL"}], "}"}]}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Uini", "=", 
       RowBox[{"IdentityMatrix", "[", "nL", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"sol", "=", 
       RowBox[{"NDSolveValue", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"D", "[", 
             RowBox[{
              RowBox[{"uvecflat", "[", "t$", "]"}], ",", "t$"}], "]"}], 
            "\[Equal]", 
            RowBox[{"(", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"Lmatfunc", "[", "t$", "]"}], ".", 
               RowBox[{"uvec", "[", "t$", "]"}]}], "]"}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"uvecflat", "[", "ta", "]"}], "\[Equal]", 
            RowBox[{"Flatten", "[", "Uini", "]"}]}]}], "}"}], ",", 
         "uvecplain", ",", 
         RowBox[{"{", 
          RowBox[{"t$", ",", "ta", ",", "tb"}], "}"}], ",", "NDSolveopts"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"SparseArray", "[", 
         RowBox[{"Chop", "[", 
          RowBox[{"N", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Through", "[", 
              RowBox[{"#", "[", "tb", "]"}], "]"}], "&"}], "/@", "sol"}], 
           "]"}], "]"}], "]"}], ",", "\[IndentingNewLine]", "opbasis", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Options", "[", "Operator", "]"}]}], "\[IndentingNewLine]",
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6913959469730577`*^9, 3.6913962476038113`*^9}, {
   3.691396284376388*^9, 3.6913963092851677`*^9}, {3.691396339815465*^9, 
   3.691396356869803*^9}, {3.691396406343808*^9, 3.691396506956386*^9}, {
   3.69139655129698*^9, 3.691396562606008*^9}, {3.691396593764143*^9, 
   3.691396671982791*^9}, {3.691396703040707*^9, 3.6913967317970543`*^9}, 
   3.691396864337449*^9, {3.691397097146983*^9, 3.691397140106963*^9}, 
   3.6914025366525993`*^9, {3.6914072678168497`*^9, 3.691407269113871*^9}, {
   3.693309875324957*^9, 3.6933098957883596`*^9}, {3.6933394837038393`*^9, 
   3.6933394838249617`*^9}, {3.693385072498694*^9, 3.6933850827314463`*^9}, {
   3.693385206244475*^9, 3.693385217479323*^9}, {3.6965282224787335`*^9, 
   3.6965282662567067`*^9}, 3.696528454637494*^9, {3.6965285722286644`*^9, 
   3.696528748300064*^9}, {3.696528795406311*^9, 3.696528831295979*^9}, {
   3.696528867588725*^9, 3.696528905977974*^9}, {3.696528945484466*^9, 
   3.696528981108117*^9}, {3.696529017451874*^9, 3.696529018002976*^9}, {
   3.6965290801007442`*^9, 3.6965291485879154`*^9}, {3.6965291830864496`*^9, 
   3.6965291847979803`*^9}, {3.69652931423707*^9, 3.6965293373340464`*^9}, {
   3.696529407423711*^9, 3.6965294104641285`*^9}, {3.6965294908625865`*^9, 
   3.696529496862352*^9}, {3.696529527602765*^9, 3.6965296093608255`*^9}, {
   3.6965296716404543`*^9, 3.6965296846996794`*^9}, {3.696529778725444*^9, 
   3.6965298163885956`*^9}, {3.6965298495647783`*^9, 3.6965299387760572`*^9}, 
   3.696529971055963*^9, {3.696882259234954*^9, 3.6968822704829464`*^9}, {
   3.696882328414509*^9, 3.6968823809600124`*^9}, 3.6968832242713957`*^9, {
   3.6969350964470854`*^9, 3.6969351569122*^9}, {3.6969352610516367`*^9, 
   3.6969353304596157`*^9}, {3.6971336100760403`*^9, 3.697133629426148*^9}, {
   3.6972070284348183`*^9, 3.697207032876653*^9}, {3.6973792837547855`*^9, 
   3.697379346615943*^9}, {3.6973795690882397`*^9, 3.697379574015607*^9}, 
   3.6995987894091253`*^9, 3.7027964270730767`*^9, {3.70318040551046*^9, 
   3.703180405635106*^9}, {3.703182523711108*^9, 3.7031825275604463`*^9}, {
   3.703192739828046*^9, 3.7031927488414564`*^9}, {3.703235457241384*^9, 
   3.7032354574413047`*^9}, {3.703235609328981*^9, 3.7032356130315475`*^9}, {
   3.703235863421362*^9, 3.7032358636815577`*^9}, 3.7093750051823893`*^9, {
   3.7136081378631363`*^9, 3.7136083161431084`*^9}, {3.713628764279513*^9, 
   3.713628765814438*^9}, {3.7136288234033337`*^9, 3.713628823584593*^9}, {
   3.7136290627052565`*^9, 3.713629063623855*^9}, 3.717244112531931*^9, 
   3.7260703483573694`*^9},ExpressionUUID->"660afc13-c337-46a8-8cf3-\
f2e0d00e50fd"]
}, Closed]],

Cell[CellGroupData[{

Cell["Repeat", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.690984518900131*^9, 3.690984520602982*^9}, 
   3.692848521296042*^9},ExpressionUUID->"12ae27ab-4906-4bc1-b33a-\
5c141a0f466d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"NPropagationSuperoperator", "[", 
      RowBox[{"True", ",", "False", ",", 
       RowBox[{"ev", ":", 
        RowBox[{"Event", "[", 
         RowBox[{
          RowBox[{"st", ":", 
           RowBox[{"(", 
            RowBox[{"True", "|", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", 
          ",", 
          RowBox[{"Repeat", "[", 
           RowBox[{
            RowBox[{"EventList", "[", 
             RowBox[{"st_", ",", "chars_", ",", 
              RowBox[{"events", ":", 
               RowBox[{"{", 
                RowBox[{"_Event", ".."}], "}"}]}], ",", "evlistopts___Rule"}],
              "]"}], ",", "n_Integer", ",", "evtropts___Rule"}], "]"}], ",", 
          "\[IndentingNewLine]", "evopts___Rule"}], "]"}]}], ",", "opbasis_", 
       ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
       "RepeatPropagator"}], "]"}], "&&", 
     RowBox[{"BackgroundGeneratorImplemented", "[", "ev", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matreps", ",", "singleprop"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"HilbPropToLiouvProp", "[", 
             RowBox[{
              RowBox[{"NPropagationSuperoperator", "[", 
               RowBox[{"True", ",", 
                RowBox[{"HilbertSpaceCompatibility", "[", "#", "]"}], ",", 
                "#", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], ",", 
              "basis", ",", "opts"}], "]"}], ",", "opbasis"}], "]"}], "&"}], "/@",
          "events"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"singleprop", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
          RowBox[{"First", "@", "matreps"}], ",", 
          RowBox[{"Fold", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"First", "@", "matreps"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"MatrixPower", "[", 
          RowBox[{"singleprop", ",", "n"}], "]"}], ",", "opbasis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "[", "NPropagationSuperoperator", "]"}]}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Operator", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, 3.542281134468389*^9, {3.5645684544067097`*^9, 
   3.5645685012249613`*^9}, {3.586362122636345*^9, 3.5863624728699913`*^9}, {
   3.586363380330854*^9, 3.586363385359961*^9}, {3.587576139268099*^9, 
   3.5875761417981577`*^9}, {3.5875762341269007`*^9, 
   3.5875763853272038`*^9}, {3.5875766585438547`*^9, 3.5875766813166533`*^9}, 
   {3.666608549421843*^9, 3.6666085497823753`*^9}, 3.6666113141219406`*^9, {
   3.683186587217523*^9, 3.6831865919508047`*^9}, 3.683187098958549*^9, {
   3.690984514860692*^9, 3.690984524039979*^9}, {3.691060687197613*^9, 
   3.691060753746748*^9}, {3.691060866239098*^9, 3.691060959114229*^9}, {
   3.691061045218045*^9, 3.691061064384056*^9}, {3.691391609964263*^9, 
   3.691391622649879*^9}, {3.691402547637679*^9, 3.691402548638754*^9}, {
   3.691407274584907*^9, 3.691407275830823*^9}, {3.691677015180834*^9, 
   3.6916770182838287`*^9}, 3.692848522364584*^9, {3.6933866763541565`*^9, 
   3.6933867082645226`*^9}, {3.6933868450700207`*^9, 3.693386847092952*^9}, {
   3.693386913362214*^9, 3.6933869171302466`*^9}, 3.6933869501801786`*^9, {
   3.6933869849993935`*^9, 3.6933869860494027`*^9}, {3.693387077668935*^9, 
   3.693387127937803*^9}, {3.693387174769182*^9, 3.6933871750875225`*^9}, {
   3.6933872765581036`*^9, 3.693387278983719*^9}, {3.693387310775377*^9, 
   3.693387310935706*^9}, {3.69338736901866*^9, 3.6933873913619175`*^9}, {
   3.6933874420014267`*^9, 3.693387458514313*^9}, {3.693387506983118*^9, 
   3.6933875252716055`*^9}, {3.693387566221203*^9, 3.693387589900855*^9}, {
   3.69338765801058*^9, 3.6933876744000473`*^9}, {3.693387704621563*^9, 
   3.693387769228965*^9}, {3.6933878697279177`*^9, 3.6933879023280563`*^9}, 
   3.696883229545755*^9, {3.696935508361205*^9, 3.696935539441184*^9}, {
   3.6969355907212625`*^9, 3.6969355921023006`*^9}, 3.696935626987486*^9, {
   3.6971219546765747`*^9, 3.6971219972779465`*^9}, {3.697122057334345*^9, 
   3.6971221043812933`*^9}, {3.6971222640022707`*^9, 3.697122266045313*^9}, {
   3.69712231414377*^9, 3.6971223385518646`*^9}, {3.6971335302482977`*^9, 
   3.697133532799811*^9}, {3.6971335863148165`*^9, 3.697133599335179*^9}, {
   3.6973785875294952`*^9, 3.6973786283102674`*^9}, {3.6973787598133593`*^9, 
   3.69737876531866*^9}, {3.6973788807060595`*^9, 3.6973789265726194`*^9}, {
   3.697378965478139*^9, 3.697378973608014*^9}, {3.697379391022703*^9, 
   3.6973794150671616`*^9}, 3.70937500519263*^9, 
   3.727685045008634*^9},ExpressionUUID->"79d7d651-7632-4b81-8b0d-\
d4cd3edeed26"]
}, Closed]],

Cell[CellGroupData[{

Cell["PrecalculatedEvent", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.45269052869058*^9}, {
   3.452690699690032*^9, 3.452690702333061*^9}, {3.452713068305441*^9, 
   3.4527130702528467`*^9}, {3.4527139622297993`*^9, 3.452713981267869*^9}, {
   3.4527140497410927`*^9, 3.452714054276637*^9}, {3.45283440178271*^9, 
   3.452834407892775*^9}, {3.452968600275196*^9, 3.4529686111443644`*^9}, {
   3.454588455387019*^9, 3.454588495826373*^9}, {3.454588555860837*^9, 
   3.45458855715418*^9}, {3.455357363823204*^9, 3.4553573677387447`*^9}, {
   3.455374196718395*^9, 3.4553742048796453`*^9}, {3.455636959839705*^9, 
   3.455636984316229*^9}, 3.4593436124681177`*^9, 3.4620405945145082`*^9, {
   3.464327520124794*^9, 3.464327525306554*^9}, {3.464679921713643*^9, 
   3.464679926608239*^9}, {3.464686660967266*^9, 3.464686662997506*^9}, 
   3.4646869741176558`*^9, {3.46484807856289*^9, 3.464848078727105*^9}, 
   3.465794195785986*^9, {3.503032579221649*^9, 3.503032583915187*^9}, 
   3.534313250875791*^9, {3.538677605389827*^9, 
   3.538677607531299*^9}},ExpressionUUID->"620b5637-2f8f-486b-a58b-\
6413a667cd77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{"True", ",", "False", ",", 
      RowBox[{"ev", ":", 
       RowBox[{"Event", "[", 
        RowBox[{
         RowBox[{"st", ":", 
          RowBox[{"(", 
           RowBox[{"True", "|", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True"}], "}"}]}], ")"}]}], ",", "ch_", ",", 
         RowBox[{"PrecalculatedEvent", "[", 
          RowBox[{
          "precalch_", ",", "Sop_Superoperator", ",", "precalevopts___Rule"}],
           "]"}], ",", "evopts___Rule"}], "]"}]}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"PropagatorCalculationProcedure", "[", "ev", "]"}], ",", 
      "UsePrecalculatedPropagator"}], "]"}]}], ":=", "Sop"}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.455374216071945*^9, 3.455374467216679*^9}, {
   3.4553752687932158`*^9, 3.455375292363693*^9}, {3.455599836272678*^9, 
   3.45559983788535*^9}, {3.455636993079664*^9, 3.4556370066005373`*^9}, {
   3.4556374498641167`*^9, 3.455637477626522*^9}, {3.455638413615127*^9, 
   3.455638475869164*^9}, {3.4556385102262707`*^9, 3.455638598119067*^9}, {
   3.455638711231593*^9, 3.4556387282010183`*^9}, {3.455638812726475*^9, 
   3.4556388625374393`*^9}, {3.4562067844728394`*^9, 3.45620679602707*^9}, 
   3.456322868001956*^9, 3.45934361414783*^9, {3.459400254688121*^9, 
   3.459400260787877*^9}, 3.462040594515614*^9, 3.464458073207357*^9, 
   3.464612298109365*^9, {3.464684545996374*^9, 3.4646845593867197`*^9}, {
   3.464686669935626*^9, 3.464686717956523*^9}, 3.464848376728797*^9, {
   3.4648484576806*^9, 3.464848485240982*^9}, {3.4648485522337027`*^9, 
   3.464848556433449*^9}, {3.464848601166883*^9, 3.46484860791045*^9}, {
   3.464848912924808*^9, 3.464848915201737*^9}, {3.464850806012557*^9, 
   3.464850808335164*^9}, {3.465804694641583*^9, 3.4658047214656677`*^9}, {
   3.4658058536390953`*^9, 3.465805860555348*^9}, 3.467720465954836*^9, 
   3.503032607124055*^9, {3.503032658744452*^9, 3.503032736893384*^9}, {
   3.5031129777551117`*^9, 3.5031129792637243`*^9}, {3.5031130117500772`*^9, 
   3.503113027595149*^9}, {3.5031132707340183`*^9, 3.503113270915576*^9}, 
   3.503115341424158*^9, 3.5031317325750732`*^9, {3.511177616227927*^9, 
   3.511177621617278*^9}, {3.514817764696088*^9, 3.514817768261125*^9}, {
   3.5343132650934143`*^9, 3.534313359352159*^9}, {3.5343183185531073`*^9, 
   3.534318319430724*^9}, {3.53867763931421*^9, 3.5386776481776333`*^9}, {
   3.538677692924055*^9, 3.538677702585209*^9}, {3.5391124476711493`*^9, 
   3.539112453900564*^9}, {3.6666085615139894`*^9, 3.666608567772622*^9}, 
   3.6666113169912148`*^9, {3.690984529675124*^9, 3.690984531611169*^9}, {
   3.691391630156105*^9, 3.691391637265486*^9}, {3.6914382516732264`*^9, 
   3.691438340756529*^9}, 3.693508805406706*^9, 3.6968832344556627`*^9, {
   3.6969356333015823`*^9, 3.6969356612990036`*^9}, {3.697133465348744*^9, 
   3.6971335055883617`*^9}},ExpressionUUID->"e12c7588-d3aa-4d43-8aa4-\
c41d15de2263"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.691438143429953*^9, 3.691438169706457*^9}, {3.691438204642272*^9, 
   3.691438206264173*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"15f5551d-b619-4214-863b-c77baaa343cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "::", "argnotready"}], "=", 
   "\"\<The argument of NPropagationSuperoperator is not ready for numerical \
computation.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.690970956327927*^9, 3.690970982532607*^9}, {
  3.699279425374975*^9, 
  3.699279433654043*^9}},ExpressionUUID->"d37dfaee-007a-4eb2-be74-\
7ea22bf591f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "::", "undefopbasis"}], "=", 
   "\"\<The OperatorBasis `1` is not defined. Calculation will proceed using \
the default OperatorBasis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699279011312561*^9, 3.699279045062563*^9}, 
   3.699279770025062*^9, {3.6995422790563173`*^9, 
   3.6995422916652603`*^9}},ExpressionUUID->"7528459c-a4f8-431c-a0ab-\
56527c831421"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NPropagationSuperoperator", "::", "undefbasis"}], "=", 
   "\"\<The basis `1` is not defined. Calculation will proceed using the \
default basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699279011312561*^9, 3.699279045062563*^9}, 
   3.699279770025062*^9},ExpressionUUID->"aaaa615a-95a6-4d68-9ecc-\
fbdcee1982e0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CorrelatedEigensystems", "Subtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.683187884067408*^9, 
   3.6831878857943583`*^9}, {3.683188019928773*^9, 3.683188023459511*^9}, {
   3.719572630210499*^9, 
   3.719572635695844*^9}},ExpressionUUID->"4f06c22f-4d6d-433c-b933-\
118cdd69ac60"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 3.429682520655286*^9}, {
  3.719572669470293*^9, 3.719572670935732*^9}, {3.7195730600123863`*^9, 
  3.719573060676344*^9}, {3.7195778200801463`*^9, 
  3.7195778203601136`*^9}},ExpressionUUID->"b26fef1e-d98e-4091-8e8f-\
d56636d5df1b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CorrelatedEigensystems", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"BackgroundGenerator", "\[RuleDelayed]", " ", 
      RowBox[{"NullOperator", "[", "]"}]}], ",", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"Basis", "[", "]"}]}], ",", 
     RowBox[{"ReturnKets", "\[Rule]", " ", "True"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.714138281735142*^9, 3.7141383010706367`*^9}, {
   3.719573076086837*^9, 3.719573077043707*^9}, 3.7195734951459517`*^9, {
   3.7195735712443542`*^9, 3.719573572187645*^9}, {3.7195824200935307`*^9, 
   3.7195824354466114`*^9}},ExpressionUUID->"ab5a20e7-99c3-4176-bc04-\
b60423b258d5"]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138689898519278`*^9, 3.713868990161875*^9}, {
  3.7138739771972947`*^9, 
  3.713873977667835*^9}},ExpressionUUID->"81c8fdb7-f691-4fee-8b93-\
a0245d500047"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "[", "args___", "]"}], ":=", 
   RowBox[{"CorrelatedEigensystems", "[", 
    RowBox[{"args", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\<0\>\""}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7138668871376066`*^9, 3.713866915637638*^9}, {
  3.7138701036770034`*^9, 3.7138701305278416`*^9}, {3.7139512087565413`*^9, 
  3.713951208873928*^9}, {3.713953053642806*^9, 3.713953053644782*^9}, {
  3.719577825505417*^9, 3.719577844488182*^9}, {3.719578744607854*^9, 
  3.7195787478032975`*^9}},ExpressionUUID->"41e81a89-3184-4e75-9f1d-\
3cee6ff21e4e"]
}, Closed]],

Cell[CellGroupData[{

Cell["check stages", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713866699117593*^9, 3.713866699877462*^9}, {
  3.7138668698299246`*^9, 
  3.7138668716976643`*^9}},ExpressionUUID->"60556e4e-afc7-43f9-a5ea-\
9e1b2ea63532"],

Cell[CellGroupData[{

Cell["check if all arguments are present", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.713872169677835*^9, 3.713872174099929*^9}, {3.7138737759087667`*^9, 
  3.7138737803607044`*^9}},ExpressionUUID->"a143283c-df62-4863-b692-\
5005167d71f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"args___", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<0\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"{", "args", "}"}], ",", 
      RowBox[{"{", " ", 
       RowBox[{"_", ",", 
        RowBox[{"_", "?", "ListQ"}], ",", "___Rule"}], "}"}]}], "]"}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"args", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<1\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "badargs"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.713867045520012*^9}, 
   3.7138693200573506`*^9, {3.7138701035525684`*^9, 3.7138701305548553`*^9}, {
   3.713872194544854*^9, 3.713872239204858*^9}, {3.713873785588684*^9, 
   3.7138738092591934`*^9}, {3.7138739370978136`*^9, 
   3.7138739479631433`*^9}, {3.7138744716083016`*^9, 
   3.7138744736986856`*^9}, {3.7139509561162095`*^9, 3.713950969397527*^9}, {
   3.7139512050328093`*^9, 3.713951226036504*^9}, {3.7139530536583557`*^9, 
   3.7139530536623397`*^9}, {3.719574024890112*^9, 3.719574025537583*^9}, {
   3.7196538173446946`*^9, 3.719653818306963*^9}, {3.7198511934662714`*^9, 
   3.719851227384512*^9}, {3.719863995854498*^9, 3.7198640146734266`*^9}, 
   3.719864168340037*^9, {3.7250946672676983`*^9, 
   3.7250946685692005`*^9}},ExpressionUUID->"ca8ba07e-e00c-429f-981d-\
9fcbf03faa35"]
}, Closed]],

Cell[CellGroupData[{

Cell["check Hamiltonian", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 
  3.7138668809750795`*^9}},ExpressionUUID->"2716f51e-467a-49a8-9f63-\
ecc95f13c506"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", "\[Lambda]specs_", ",", "more___", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<1\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"OperatorQ", "[", "adH", "]"}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"adH", ",", "\[Lambda]specs", ",", "more", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<2\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "HnoOp"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.713867045520012*^9}, 
   3.7138693200573506`*^9, {3.7138701035525684`*^9, 3.7138701305548553`*^9}, {
   3.713875058804775*^9, 3.7138750694347754`*^9}, {3.713953053670869*^9, 
   3.713953053670869*^9}, {3.7196538298313465`*^9, 3.719653861263899*^9}, {
   3.7250946762193103`*^9, 
   3.7250946811754704`*^9}},ExpressionUUID->"bbee6f40-a618-4c2a-9071-\
c081ec6e1642"]
}, Closed]],

Cell[CellGroupData[{

Cell["check parameter specification structure ", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.7138670514138145`*^9, 3.7138670537728615`*^9}, {3.7138674864137077`*^9, 
  3.713867488890153*^9}, {3.7138676220897083`*^9, 
  3.713867633697348*^9}},ExpressionUUID->"aa7a75da-fc07-45d6-83f5-\
e01cdaa45d97"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "more___"}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<2\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{"specs", ",", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_List"}], "}"}]}], "]"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", "more", "]"}], ">", "0"}]}], ")"}], "\[Or]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"specs", ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_", ",", "_"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"adH", ",", "specs", ",", "opts", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<3\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "specstruc"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQfauirGrx6teOQZJvGkH0kVt57SA6afNSMO0moDcV
RLvEmILpuECteSD64Zely0D0zTWO20E0S/qUvSD6G8/pQyD63my2wyB62feH
x0F09/3TJ0F09iLhcyD6wKve8yB6nmDXZbC9Rt9ugGgT5zPvQHTfmqcfQfTG
rRv+g+gY3yKGJUC65vdpHRCtkSWmC6KNJs3YB6J5mLX3g+h757e9B9EXdP99
ANElVp+UlgLpJuEgNRB9qT0gCkQ7ey+NAdEha2Ykg+iK4pVZIDr6ztk2EG0x
v7UHRO9Z5zwRRDNXFkwF0atvpMwE0Ttb+GeD6Ji85AnLQeEg9R5MHyrfuvgs
Ei0Qv8B27bbXjrEMJ+1A9KzL5x7zHnzteDZ+6RMQDQD4vuAu
  
  "],ExpressionUUID->"0383ab99-014b-4355-86a5-bed46c43ee3f"]
}, Closed]],

Cell[CellGroupData[{

Cell["check parameter assignment", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.7138670514138145`*^9, 3.7138670537728615`*^9}, {3.7138674864137077`*^9, 
  3.713867488890153*^9}},ExpressionUUID->"d52be742-1256-462c-a3b9-\
a730c367ff09"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "more___"}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<3\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{"UnassignedSymbols", "[", 
       RowBox[{"par", ",", "opts"}], "]"}], "]"}], "\[Equal]", "1"}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"adH", ",", "specs", ",", "opts", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<4\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "parAssigned"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.7138670611861424`*^9}, {
   3.7138671940523496`*^9, 3.713867244637575*^9}, {3.713867286345332*^9, 
   3.7138672882065268`*^9}, {3.7138673270614805`*^9, 3.713867342371038*^9}, {
   3.7138673766135764`*^9, 3.713867388434906*^9}, {3.7138674203146505`*^9, 
   3.713867463693697*^9}, {3.7138676886372356`*^9, 3.7138676902499046`*^9}, {
   3.7138680815569143`*^9, 3.713868087606097*^9}, {3.713868406116719*^9, 
   3.7138684062771373`*^9}, 3.7138693200359297`*^9, {3.713869710632704*^9, 
   3.713869715374318*^9}, {3.713870103576657*^9, 3.7138701305673876`*^9}, {
   3.7138750818316355`*^9, 3.7138750844412994`*^9}, {3.713953053691286*^9, 
   3.71395305369532*^9}, {3.71958150392356*^9, 3.7195815043847837`*^9}, {
   3.7196538853683615`*^9, 3.719653892186249*^9}, {3.7250946988524847`*^9, 
   3.725094727807981*^9}},ExpressionUUID->"43b8e68e-2bbd-42cc-a619-\
855c9310cbc6"]
}, Closed]],

Cell[CellGroupData[{

Cell["check if parameters numeric", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.7138670514138145`*^9, 3.7138670537728615`*^9}, {3.7138674864137077`*^9, 
  3.713867499393965*^9}, {3.713867699793987*^9, 
  3.7138677050626087`*^9}},ExpressionUUID->"9bffc3b4-259d-48ca-b03a-\
67e87986cf03"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", 
       RowBox[{"vals_", "?", "ListQ"}]}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<4\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"VectorQ", "[", 
     RowBox[{"vals", ",", "NumericQ"}], "]"}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"adH", ",", "specs", ",", "opts", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<5\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "numpar"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.7138670611861424`*^9}, {
   3.7138671940523496`*^9, 3.713867244637575*^9}, {3.713867286345332*^9, 
   3.7138672882065268`*^9}, {3.7138673270614805`*^9, 3.713867342371038*^9}, {
   3.7138673766135764`*^9, 3.713867388434906*^9}, {3.7138674203146505`*^9, 
   3.713867463693697*^9}, {3.7138675070936947`*^9, 3.7138675398024874`*^9}, {
   3.713867790404396*^9, 3.7138677987920237`*^9}, {3.7138678649615736`*^9, 
   3.7138678835013733`*^9}, {3.713867974900448*^9, 3.713867977066356*^9}, {
   3.713868067277007*^9, 3.7138680909960203`*^9}, {3.7138682590079126`*^9, 
   3.7138682593597555`*^9}, {3.713868315453885*^9, 3.713868317346445*^9}, {
   3.7138685879367523`*^9, 3.7138685897823253`*^9}, 3.7138693200379486`*^9, {
   3.7138697202554035`*^9, 3.713869724325155*^9}, {3.713870103576657*^9, 
   3.7138701305673876`*^9}, {3.713875087504052*^9, 3.7138750893214865`*^9}, {
   3.7139530537008123`*^9, 3.7139530537008123`*^9}, {3.7196538990883436`*^9, 
   3.719653907825555*^9}, {3.7250947397839375`*^9, 
   3.7250947470792685`*^9}},ExpressionUUID->"9142e795-d083-4170-80f6-\
43b62f13690d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "xa_", ",", "xb_", ",", "\[Delta]x_"}], "}"}]}], 
    ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<4\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"VectorQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xa", ",", "xb", ",", "\[Delta]x"}], "}"}], ",", "NumericQ"}], 
     "]"}], ",", 
    RowBox[{"CorrelatedEigensystems", "[", 
     RowBox[{"adH", ",", 
      RowBox[{"{", 
       RowBox[{"par", ",", "xa", ",", "xb", ",", "\[Delta]x"}], "}"}], ",", 
      "opts", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<1\>\"", ",", "\"\<5\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CorrelatedEigensystems", "::", "numpar"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.7138670611861424`*^9}, {
   3.7138671940523496`*^9, 3.713867244637575*^9}, {3.713867286345332*^9, 
   3.7138672882065268`*^9}, {3.7138673270614805`*^9, 3.713867342371038*^9}, {
   3.7138673766135764`*^9, 3.713867388434906*^9}, {3.7138674203146505`*^9, 
   3.713867463693697*^9}, {3.7138675070936947`*^9, 3.7138675398024874`*^9}, {
   3.713867790404396*^9, 3.7138677987920237`*^9}, {3.7138678649615736`*^9, 
   3.7138678835013733`*^9}, {3.713867974900448*^9, 3.713867977066356*^9}, {
   3.713868067277007*^9, 3.7138680909960203`*^9}, {3.7138681700411797`*^9, 
   3.713868194092532*^9}, {3.7138683294055405`*^9, 3.713868330795204*^9}, {
   3.713868427916749*^9, 3.7138684346463704`*^9}, {3.7138685848325067`*^9, 
   3.7138685866535945`*^9}, {3.713869035530818*^9, 3.7138690576305637`*^9}, 
   3.7138693200379486`*^9, {3.713869727503996*^9, 3.713869730304426*^9}, {
   3.7138701036008525`*^9, 3.7138701305925035`*^9}, {3.713875091727909*^9, 
   3.7138750934468307`*^9}, {3.7139530537008123`*^9, 
   3.7139530537008123`*^9}, {3.71412862606218*^9, 3.7141286296935406`*^9}, {
   3.719653912428502*^9, 3.71965391918322*^9}, {3.725094751112553*^9, 
   3.725094755278752*^9}, {3.725094801526161*^9, 
   3.7250948034932494`*^9}},ExpressionUUID->"892497b2-42f1-405f-8c3b-\
2e77d85af5fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["adjust \[Delta]x if necessary", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.7138670514138145`*^9, 3.7138670537728615`*^9}, {3.7138674864137077`*^9, 
  3.713867499393965*^9}, {3.713867699793987*^9, 3.7138677050626087`*^9}, {
  3.714128562718525*^9, 
  3.7141285688840876`*^9}},ExpressionUUID->"3cbb778f-4db9-4b37-871a-\
e844d7a2a3d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", 
       RowBox[{"vals_", "?", "ListQ"}]}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<5\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH", ",", "specs", ",", "opts", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<6\>\""}], "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.714128583288164*^9, 3.7141286092684946`*^9}, {
  3.7198513156510243`*^9, 3.719851321524721*^9}, {3.7250948107174673`*^9, 
  3.725094815401873*^9}},ExpressionUUID->"6bc597a1-e0b9-4dcc-900f-\
44e91124335f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "xa_", ",", "xb_", ",", "\[Delta]x_"}], "}"}]}], 
    ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<5\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"new\[Delta]x", ",", "Napprox", ",", "NapproxIP"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Napprox", "=", 
      RowBox[{"N", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"xb", "-", "xa"}], ")"}], "/", "\[Delta]x"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"NapproxIP", "=", 
      RowBox[{"N", "[", 
       RowBox[{"IntegerPart", "[", "Napprox", "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"NapproxIP", "\[Equal]", "Napprox"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"CorrelatedEigensystems", "[", 
        RowBox[{"adH", ",", 
         RowBox[{"{", 
          RowBox[{"par", ",", 
           RowBox[{"Range", "[", 
            RowBox[{"xa", ",", "xb", ",", "\[Delta]x"}], "]"}]}], "}"}], ",", 
         "opts", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<1\>\"", ",", "\"\<6\>\""}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"new\[Delta]x", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"xb", "-", "xa"}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"NapproxIP", "+", "1"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"CorrelatedEigensystems", "::", "\[Delta]xadj"}], ",", 
          RowBox[{"new\[Delta]x", "//", "EngineeringForm"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CorrelatedEigensystems", "[", 
         RowBox[{"adH", ",", 
          RowBox[{"{", 
           RowBox[{"par", ",", 
            RowBox[{"Range", "[", 
             RowBox[{"xa", ",", "xb", ",", "new\[Delta]x"}], "]"}]}], "}"}], 
          ",", "opts", ",", 
          RowBox[{"{", 
           RowBox[{"\"\<1\>\"", ",", "\"\<6\>\""}], "}"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7141286375179834`*^9, 3.7141289035060825`*^9}, {
   3.7141375765983343`*^9, 3.714137591681924*^9}, {3.714138666298357*^9, 
   3.7141386687783113`*^9}, {3.7196539261010036`*^9, 3.719653944079467*^9}, 
   3.719851345934099*^9, {3.7250948188872232`*^9, 
   3.7250948320778084`*^9}},ExpressionUUID->"46e6deef-827c-4b8b-abb0-\
5484bb63eab7"]
}, Closed]],

Cell[CellGroupData[{

Cell["check if Hamiltonian numeric after parameter replacement", \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138668756874237`*^9, 3.7138668809750795`*^9}, {
  3.7138670514138145`*^9, 3.7138670537728615`*^9}, {3.7138674864137077`*^9, 
  3.713867499393965*^9}, {3.713867699793987*^9, 3.7138677050626087`*^9}, {
  3.713868572295231*^9, 
  3.7138685795537977`*^9}},ExpressionUUID->"8e318481-0b2b-4bce-bb57-\
43a439a4ddd5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adH_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "vals_"}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\<6\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"basis", ",", "adHmat", ",", "adHmatnum"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"basis", "=", 
      RowBox[{
       RowBox[{"Basis", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CorrelatedEigensystems", "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"adHmat", "=", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{"adH", ",", "basis"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"adHmatnum", "=", 
      RowBox[{"ReplaceEverywhere", "[", 
       RowBox[{"adHmat", ",", 
        RowBox[{"{", 
         RowBox[{"par", "\[Rule]", " ", 
          RowBox[{"First", "[", "vals", "]"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MatrixQ", "[", 
        RowBox[{"adHmatnum", ",", "NumericQ"}], "]"}], ",", 
       RowBox[{"CorrelatedEigensystems", "[", 
        RowBox[{"adHmat", ",", "specs", ",", "opts", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<2\>\"", ",", "\"\<1\>\""}], "}"}]}], "]"}], ",", 
       RowBox[{"Message", "[", 
        RowBox[{"CorrelatedEigensystems", "::", "HnonNum"}], "]"}], ",", 
       RowBox[{"Abort", "[", "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138667077022524`*^9, 3.713866767378091*^9}, {
   3.713866811464205*^9, 3.7138668131781473`*^9}, {3.7138669214394865`*^9, 
   3.713866921667513*^9}, {3.7138669933224325`*^9, 3.7138670611861424`*^9}, {
   3.7138671940523496`*^9, 3.713867244637575*^9}, {3.713867286345332*^9, 
   3.7138672882065268`*^9}, {3.7138673270614805`*^9, 3.713867342371038*^9}, {
   3.7138673766135764`*^9, 3.713867388434906*^9}, {3.7138674203146505`*^9, 
   3.713867463693697*^9}, {3.7138675070936947`*^9, 3.7138675398024874`*^9}, {
   3.713867790404396*^9, 3.7138677987920237`*^9}, {3.7138678649615736`*^9, 
   3.7138678835013733`*^9}, {3.713867974900448*^9, 3.713867977066356*^9}, {
   3.713868067277007*^9, 3.7138680909960203`*^9}, {3.7138682590079126`*^9, 
   3.7138682593597555`*^9}, {3.713868315453885*^9, 3.713868317346445*^9}, {
   3.7138685926136374`*^9, 3.7138687477027187`*^9}, {3.7138687847925024`*^9, 
   3.713868877448469*^9}, {3.7138689333417964`*^9, 3.7138689407013397`*^9}, {
   3.7138690628310275`*^9, 3.7138690762297792`*^9}, 3.7138693200573506`*^9, {
   3.71386973530303*^9, 3.7138697862304583`*^9}, {3.71387010361141*^9, 
   3.713870130603108*^9}, {3.713875051782359*^9, 3.7138750518917413`*^9}, {
   3.7138751005410433`*^9, 3.713875111198367*^9}, {3.7139530537202597`*^9, 
   3.7139530537202597`*^9}, {3.71412890924612*^9, 3.7141289093324623`*^9}, {
   3.7196539570669208`*^9, 3.7196539627316265`*^9}, {3.719747760407255*^9, 
   3.7197477645496273`*^9}, 3.7197479817397327`*^9, {3.719748233700775*^9, 
   3.7197482338610535`*^9}, {3.72509483953531*^9, 3.725094853027172*^9}, {
   3.7276928799533553`*^9, 3.7276929239847*^9}, {3.7276949184790163`*^9, 
   3.7276949186322985`*^9}},ExpressionUUID->"bfcb1ae4-69a5-47cf-862d-\
be40b3cc9189"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.5010430768785763`*^9, 
  3.50104307806927*^9}},ExpressionUUID->"9a783011-6200-4236-a91e-\
14f3be5117c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "badargs"}], "=", 
   "\"\<The argument structure of the input is not correct.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713866770255113*^9, 3.7138668204777255`*^9}, {
   3.713870103616424*^9, 3.713870130607605*^9}, 3.7138721852943964`*^9, {
   3.7138722441808863`*^9, 3.7138722579269104`*^9}, {3.7138738193464127`*^9, 
   3.713873832379049*^9}, 3.7139512508861165`*^9, 
   3.7139530537202597`*^9},ExpressionUUID->"0736af0d-0895-4fae-80b4-\
c74c5bb3a4d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "HnoOp"}], "=", 
   "\"\<The specified Hamiltonian is not a valid Operator object.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713866770255113*^9, 3.7138668204777255`*^9}, {
   3.713870103616424*^9, 3.713870130607605*^9}, 
   3.713953053738867*^9},ExpressionUUID->"5abdee30-aee4-41a5-b206-\
f86d3d68a7d6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "specstruc"}], "=", 
   "\"\<The parameter specifications should be either of the form \
{x,\!\(\*SubscriptBox[\(x\), \(a\)]\),\!\(\*SubscriptBox[\(x\), \(b\)]\),\
\[Delta]x} or {x,{\!\(\*SubscriptBox[\(x\), \(1\)]\), \
\!\(\*SubscriptBox[\(x\), \(2\)]\), ..., \!\(\*SubscriptBox[\(x\), \(N\)]\)}}\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713867227535875*^9, 3.7138672386615095`*^9}, {
   3.7138676695230713`*^9, 3.7138676833831234`*^9}, {3.713870103616424*^9, 
   3.713870130607605*^9}, 3.713953053744913*^9, {3.7282269195143433`*^9, 
   3.7282269670968466`*^9}},ExpressionUUID->"e4947290-311f-4a84-9b18-\
5e18514c1449"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "parAssigned"}], "=", 
   "\"\<The parameter should be an unassigned symbol.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713867227535875*^9, 3.7138672386615095`*^9}, {
   3.7138701036349235`*^9, 3.7138701306267633`*^9}, 
   3.713953053750908*^9},ExpressionUUID->"56d758be-eea2-4a9b-9a4c-\
b6c029894462"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "numpar"}], "=", 
   "\"\<The parameter speficiations should all have numeric values.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138678885698595`*^9, 3.7138678992323813`*^9}, {
   3.71386875266254*^9, 3.7138687535907726`*^9}, {3.71387010364147*^9, 
   3.7138701306337814`*^9}, 
   3.7139530537559414`*^9},ExpressionUUID->"706c655c-735a-4283-9e31-\
707be0710fdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "HnonNum"}], "=", 
   "\"\<The Hamiltonian is not numeric after parameter replacement.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138687577416506`*^9, 3.7138687783124285`*^9}, {
   3.7138701036479588`*^9, 3.713870130638795*^9}, 
   3.713953053763461*^9},ExpressionUUID->"127299b4-6008-4ff9-ab23-\
112d2c2b8696"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "\[Delta]xadj"}], "=", 
   "\"\<The parameter stepsize (\[Delta]x) has been adjusted to `1`, so that \
the output starts with H(\!\(\*SubscriptBox[\(x\), \(a\)]\)) and ends with H(\
\!\(\*SubscriptBox[\(x\), \(b\)]\)).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7141254569958487`*^9, 3.7141254677469316`*^9}, {
   3.7141255053288107`*^9, 3.7141255625918016`*^9}, {3.7141280982407894`*^9, 
   3.714128114016346*^9}, {3.714128920445962*^9, 3.714128959171668*^9}, {
   3.7141290096536894`*^9, 3.7141290354734516`*^9}, {3.714137561880584*^9, 
   3.714137565199709*^9}, 
   3.7141376549044237`*^9},ExpressionUUID->"477c582a-5024-49c1-ac7f-\
651c98db57fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CorrelatedEigensystems", "::", "ambcorr"}], "=", 
   "\"\<Ambiguous correlation encountered. Assignment attempted using \
OptimalBipartiteGraphMatching Algorithm.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7141254569958487`*^9, 3.7141254677469316`*^9}, {
   3.7141255053288107`*^9, 3.7141255625918016`*^9}, {3.7141280982407894`*^9, 
   3.714128114016346*^9}, {3.7143280451200314`*^9, 3.7143280455284557`*^9}, {
   3.7195770910932302`*^9, 3.719577124190507*^9}, 
   3.728295728088181*^9},ExpressionUUID->"29d1df05-026d-4432-8609-\
a58b32761d45"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["calculations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138666941074963`*^9, 3.7138666943777304`*^9}, {
  3.71386900794005*^9, 
  3.713869009139606*^9}},ExpressionUUID->"5526c54c-fee8-43b2-870a-\
29f2a7efef17"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CorrelatedEigensystems", "[", 
   RowBox[{"adHmat_", ",", 
    RowBox[{"specs", ":", 
     RowBox[{"{", 
      RowBox[{"par_", ",", "vals_"}], "}"}]}], ",", "opts___Rule", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<2\>\"", ",", "\"\<1\>\""}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "sol", ",", "\[Phi]", ",", "dummykets", ",", "ketrules", ",", "dim", ",",
       "len", ",", "range", ",", "basis", ",", "Hmat", ",", "Hgrid", ",", 
      "eigensystems", ",", "correlations", ",", "evals", ",", "evecs", ",", 
      "ambstatus", ",", "auxfunc", ",", "correlatedevals", ",", 
      "correlatedevecs", ",", "temp"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"DisableBuiltInModifications", "[", "Dot", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"len", "=", 
      RowBox[{"Length", "[", "vals", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"range", "=", 
      RowBox[{"Range", "[", 
       RowBox[{"len", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"basis", "=", 
      RowBox[{
       RowBox[{"Basis", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CorrelatedEigensystems", "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"dim", "=", 
      RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"dummykets", "=", 
      RowBox[{"Array", "[", 
       RowBox[{"\[Phi]", ",", "dim"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ketrules", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{"dummykets", "\[Rule]", " ", 
        RowBox[{"BasisKets", "[", "basis", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Hmat", "=", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"BackgroundGenerator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "CorrelatedEigensystems", "]"}]}], ",", 
        "basis"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Hgrid", "=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Chop", "@", 
          RowBox[{"N", "@", 
           RowBox[{"ReplaceEverywhere", "[", 
            RowBox[{
             RowBox[{"adHmat", "+", "Hmat"}], ",", 
             RowBox[{"{", 
              RowBox[{"par", "\[Rule]", " ", "#"}], "}"}]}], "]"}]}]}], "&"}],
         "/@", "vals"}], ")"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"eigensystems", "=", 
      RowBox[{"Chop", "[", 
       RowBox[{"Eigensystem", "/@", "Hgrid"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"evals", "=", 
      RowBox[{"eigensystems", "\[LeftDoubleBracket]", 
       RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"evecs", "=", 
      RowBox[{"SparseArray", "/@", 
       RowBox[{"(", 
        RowBox[{"eigensystems", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], ")"}]}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"ambstatus", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"correlatedevals", "=", 
      RowBox[{"{", 
       RowBox[{"First", "[", "evals", "]"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"correlatedevecs", "=", 
      RowBox[{"{", 
       RowBox[{"First", "[", "evecs", "]"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"auxfunc", "=", 
      RowBox[{"Function", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"overlap", ",", "pos"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{"#", ",", 
               RowBox[{"Max", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
            "overlap"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"DuplicateFreeQ", "[", "temp", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"correlatedevals", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"correlatedevals", " ", ",", 
               RowBox[{
                RowBox[{"evals", "\[LeftDoubleBracket]", 
                 RowBox[{"pos", "+", "1"}], "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "temp", "\[RightDoubleBracket]"}]}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"correlatedevecs", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"correlatedevecs", " ", ",", 
               RowBox[{
                RowBox[{"evecs", "\[LeftDoubleBracket]", 
                 RowBox[{"pos", "+", "1"}], "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "temp", "\[RightDoubleBracket]"}]}], 
              "]"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ambstatus", "=", "True"}], ";", "\[IndentingNewLine]", 
            RowBox[{"temp", "=", 
             RowBox[{"OptimalBipartiteGraphMatching", "[", 
              RowBox[{"1", "-", "overlap"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"correlatedevals", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"correlatedevals", " ", ",", 
               RowBox[{
                RowBox[{"evals", "\[LeftDoubleBracket]", 
                 RowBox[{"pos", "+", "1"}], "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "temp", "\[RightDoubleBracket]"}]}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"correlatedevecs", "=", 
             RowBox[{"Append", "[", 
              RowBox[{"correlatedevecs", " ", ",", 
               RowBox[{
                RowBox[{"evecs", "\[LeftDoubleBracket]", 
                 RowBox[{"pos", "+", "1"}], "\[RightDoubleBracket]"}], 
                "\[LeftDoubleBracket]", "temp", "\[RightDoubleBracket]"}]}], 
              "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"auxfunc", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"Chop", "@", 
            RowBox[{"Normal", "[", 
             RowBox[{
              RowBox[{
              "correlatedevecs", "\[LeftDoubleBracket]", "#", 
               "\[RightDoubleBracket]"}], ".", 
              RowBox[{"ConjugateTranspose", "[", 
               RowBox[{"evecs", "\[LeftDoubleBracket]", 
                RowBox[{"#", "+", "1"}], "\[RightDoubleBracket]"}], "]"}]}], 
             "]"}]}], "]"}], ",", "#"}], "]"}], "&"}], ",", "range"}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"ambstatus", ",", 
       RowBox[{"Message", "[", 
        RowBox[{"CorrelatedEigensystems", "::", "ambcorr"}], "]"}]}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"sol", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Evaluate", "@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"ReturnKets", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "CorrelatedEigensystems", "]"}]}], ")"}]}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"vals", ",", 
                RowBox[{"correlatedevals", "\[LeftDoubleBracket]", 
                 RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}]}], 
               "}"}], "]"}], "&"}], ",", 
            RowBox[{"Range", "[", "dim", "]"}]}], "]"}], ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"vals", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"Conjugate", "[", "#1", "]"}], ".", "dummykets"}], 
                  "&"}], ",", "correlatedevecs"}], "]"}], ")"}], "/.", 
              "ketrules"}]}], "}"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"correlatedevals", ",", "correlatedevecs"}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ReenableBuiltInModifications", "[", "Dot", "]"}], ";", 
     "\[IndentingNewLine]", "sol"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7138689449642863`*^9, 3.713868951051857*^9}, {
   3.7138690913566003`*^9, 3.7138690917704086`*^9}, {3.7138691325569797`*^9, 
   3.713869151724925*^9}, {3.7138691870094194`*^9, 3.713869190973448*^9}, {
   3.7138695199967003`*^9, 3.7138695510764265`*^9}, {3.7138696373130894`*^9, 
   3.7138696400647755`*^9}, {3.7138697461848936`*^9, 
   3.7138697495444365`*^9}, {3.713869803591839*^9, 3.7138698097431817`*^9}, {
   3.713870022073698*^9, 3.7138700237112317`*^9}, {3.7138701036550055`*^9, 
   3.713870130648321*^9}, {3.7138751178227663`*^9, 3.7138751356961946`*^9}, {
   3.713875168491078*^9, 3.713875222021907*^9}, {3.713875261271072*^9, 
   3.7138753444112225`*^9}, {3.71395305377048*^9, 3.713953053772004*^9}, {
   3.7143174911739626`*^9, 3.714317607749283*^9}, {3.71431764080655*^9, 
   3.7143176433158846`*^9}, {3.714317751197351*^9, 3.7143177946622734`*^9}, {
   3.714317833784295*^9, 3.714317839251507*^9}, {3.714317956379562*^9, 
   3.7143179599470363`*^9}, {3.71431805022433*^9, 3.7143180710041137`*^9}, {
   3.714318115621702*^9, 3.7143182256756973`*^9}, {3.714318261315722*^9, 
   3.714318342744346*^9}, {3.714318404722028*^9, 3.7143184527200737`*^9}, {
   3.714318484124186*^9, 3.7143184886151915`*^9}, {3.71432124316866*^9, 
   3.7143212435331225`*^9}, {3.7143216376508927`*^9, 3.714321637800624*^9}, {
   3.714322046789319*^9, 3.7143221003778853`*^9}, {3.7143221420394974`*^9, 
   3.714322142174684*^9}, {3.7181832535522833`*^9, 3.7181832543961167`*^9}, {
   3.7195748255734744`*^9, 3.719574892439227*^9}, {3.719574981746532*^9, 
   3.71957506645341*^9}, {3.719575323811062*^9, 3.7195754004063296`*^9}, {
   3.7195754331001587`*^9, 3.7195754341398745`*^9}, {3.7195754706100397`*^9, 
   3.7195754761802397`*^9}, {3.719575527031195*^9, 3.7195755661392794`*^9}, {
   3.719575601972458*^9, 3.719575607433831*^9}, {3.7195757244432335`*^9, 
   3.719575724503354*^9}, {3.7195759256084433`*^9, 3.719575962348645*^9}, {
   3.719576310974166*^9, 3.71957634821937*^9}, {3.719576562600943*^9, 
   3.7195765633248277`*^9}, {3.7195767011287937`*^9, 
   3.7195767196888065`*^9}, {3.7195767640756264`*^9, 
   3.7195767643458424`*^9}, {3.71957681825387*^9, 3.719576821601844*^9}, {
   3.7195768683616643`*^9, 3.7195768722948856`*^9}, {3.7195770288868484`*^9, 
   3.7195770785281057`*^9}, {3.7195771439979734`*^9, 3.719577174268908*^9}, {
   3.7195773535252123`*^9, 3.719577381676146*^9}, {3.719577854410352*^9, 
   3.71957787729694*^9}, {3.719577911012652*^9, 3.719577946728696*^9}, 
   3.7195779886046658`*^9, {3.719578080234256*^9, 3.7195781025898514`*^9}, {
   3.7195781576206427`*^9, 3.7195782122155514`*^9}, {3.7195782948398094`*^9, 
   3.7195782962676353`*^9}, {3.7195783268908653`*^9, 3.719578349488865*^9}, {
   3.7195784539550667`*^9, 3.719578469854248*^9}, 3.7195785221059465`*^9, {
   3.7195785845375867`*^9, 3.719578654079129*^9}, {3.7195786843805695`*^9, 
   3.719578733713917*^9}, {3.7195787714721155`*^9, 3.7195788536521635`*^9}, {
   3.7195789260352736`*^9, 3.7195789819677114`*^9}, {3.7195792632892494`*^9, 
   3.719579330800378*^9}, {3.7195793649841185`*^9, 3.7195795851643887`*^9}, 
   3.7195797309663315`*^9, {3.7195817766907587`*^9, 3.7195818022222157`*^9}, {
   3.7195818329688435`*^9, 3.7195819244435835`*^9}, {3.719581988968813*^9, 
   3.719581992724783*^9}, {3.7195820637816324`*^9, 3.719582081397415*^9}, {
   3.719582202008475*^9, 3.7195822021548643`*^9}, {3.7195824482526293`*^9, 
   3.7195824705254793`*^9}, {3.719582519796461*^9, 3.7195825225467744`*^9}, {
   3.719582581622821*^9, 3.719582583091688*^9}, {3.719582694647946*^9, 
   3.7195826949917884`*^9}, {3.719582742535342*^9, 3.719582774450904*^9}, {
   3.7195828224396944`*^9, 3.719582825893916*^9}, {3.7196539736880765`*^9, 
   3.719653975257983*^9}, {3.7196617151316485`*^9, 3.7196617320147104`*^9}, {
   3.719747678899577*^9, 3.7197476838440514`*^9}, 3.7197480975153313`*^9, {
   3.71974815371527*^9, 3.7197481563106723`*^9}, {3.7197482296157904`*^9, 
   3.7197482299545336`*^9}, {3.719748311718691*^9, 3.719748317842381*^9}, {
   3.719748383817691*^9, 3.719748389361127*^9}, 3.7197484348018985`*^9, {
   3.7197484904171143`*^9, 3.71974853262652*^9}, {3.719748594431611*^9, 
   3.7197486275397453`*^9}, {3.7197489764660387`*^9, 
   3.7197489856261044`*^9}, {3.7197611982217493`*^9, 3.719761200110873*^9}, {
   3.7197765727038217`*^9, 3.7197766214848194`*^9}, {3.719776656912195*^9, 
   3.7197766768631287`*^9}, {3.719776735228258*^9, 3.7197767513807354`*^9}, {
   3.7197768863583155`*^9, 3.7197768928824396`*^9}, {3.719777263680977*^9, 
   3.7197773153068056`*^9}, {3.7197773477303705`*^9, 
   3.7197773479600363`*^9}, {3.719864842308408*^9, 3.719864925193077*^9}, {
   3.719868704302226*^9, 3.7198687582016125`*^9}, {3.7198688063562927`*^9, 
   3.71986881011462*^9}, {3.719869370275712*^9, 3.7198693705653086`*^9}, {
   3.7198697894030266`*^9, 3.7198698083922997`*^9}, {3.7198698687460136`*^9, 
   3.7198698730802803`*^9}, {3.719869920320397*^9, 3.719869925060585*^9}, {
   3.7198699640224714`*^9, 3.719869990776428*^9}, {3.7198700237268534`*^9, 
   3.7198700384956493`*^9}, {3.719870072017098*^9, 3.719870074615739*^9}, {
   3.7250948644347353`*^9, 3.7250948662035627`*^9}, 3.726067790765766*^9, {
   3.727692724506754*^9, 3.727692731515534*^9}, {3.727692780640673*^9, 
   3.7276927807706175`*^9}, {3.728124968733054*^9, 3.728124981470071*^9}, 
   3.7281261503380938`*^9, 3.72812619728741*^9, {3.7282951608810215`*^9, 
   3.7282953138050947`*^9}, {3.7282953707298117`*^9, 3.728295372573429*^9}, {
   3.728295414335573*^9, 3.7282954145658674`*^9}, {3.728295446813178*^9, 
   3.728295582416808*^9}, {3.728295657209582*^9, 
   3.7282956924649496`*^9}},ExpressionUUID->"97f41005-d54a-4c63-96ef-\
12890977ef78"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Precalculate", "Subtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.6839784568941393`*^9, 3.6839784594924717`*^9}, {3.683981558381579*^9, 
   3.683981559470546*^9}, {3.683995601394485*^9, 3.683995601780772*^9}, {
   3.684862236116166*^9, 3.6848622381161547`*^9}, 3.684946401348587*^9, {
   3.691431250085331*^9, 3.691431252226363*^9}, 
   3.691431527895235*^9},ExpressionUUID->"8cdb6f09-8c84-4222-9bea-\
279d114c9325"],

Cell[CellGroupData[{

Cell["Precalculate[events, options] generates a PrecalculatedEvent", \
"Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, 
   3.683973033466785*^9, {3.683973490977272*^9, 3.683973492079618*^9}, {
   3.691431693576489*^9, 3.691431695509953*^9}, {3.691434724078803*^9, 
   3.691434727438229*^9}, {3.691680596763915*^9, 
   3.691680611496066*^9}},ExpressionUUID->"e9aa3f7b-5ea6-47a5-a69f-\
1f4d7b215e93"],

Cell[CellGroupData[{

Cell["defaults", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
  3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
  3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
  3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
  3.68339391248285*^9}, {3.6914317305118713`*^9, 
  3.691431731750986*^9}},ExpressionUUID->"dd42dd87-04bf-4397-a1de-\
d458ca86c986"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Precalculate", "]"}], "=", "\[IndentingNewLine]", 
   
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"FinalTimePoint", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "Undefined"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PropagatorCalculationProcedure", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpandRepeatedEvents", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Verbose", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464974402231822*^9, 3.464974415442891*^9}, {
   3.465625036909164*^9, 3.465625042590254*^9}, 3.465625080470196*^9, {
   3.465657740406492*^9, 3.4656577834309607`*^9}, 3.465730076429566*^9, {
   3.4657347387759457`*^9, 3.4657347467634783`*^9}, 3.465790322619904*^9, {
   3.465793549521761*^9, 3.465793551122835*^9}, {3.4657936477659388`*^9, 
   3.4657936619337597`*^9}, {3.465793985441434*^9, 3.465793990842483*^9}, {
   3.5031013631921043`*^9, 3.503101363566592*^9}, 3.504268593601696*^9, {
   3.508308162779997*^9, 3.508308165079607*^9}, 3.508313228283949*^9, {
   3.508313438227887*^9, 3.508313443113968*^9}, 3.508313625229313*^9, {
   3.508313672882084*^9, 3.508313676320614*^9}, 3.508339025662491*^9, {
   3.514456471826111*^9, 3.514456482775215*^9}, 3.5147992176760683`*^9, 
   3.54505051714954*^9, {3.683783044841251*^9, 3.683783049590928*^9}, {
   3.684862419791086*^9, 3.684862420068823*^9}, 3.684946401360272*^9, {
   3.6894131747321653`*^9, 3.689413184986969*^9}, 3.691431616733445*^9, 
   3.69143165427637*^9, 3.691431964842559*^9, {3.691433222291628*^9, 
   3.691433243720422*^9}, {3.6914333708071632`*^9, 3.6914333808119793`*^9}, 
   3.691433411446697*^9, 3.691433578811616*^9, 
   3.709375005200746*^9},ExpressionUUID->"39bdfc6f-4066-46ef-8ec5-\
0d59f3d53253"]
}, Closed]],

Cell[CellGroupData[{

Cell["$Failed", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
  3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
  3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
  3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
  3.68339391248285*^9}},ExpressionUUID->"0017f5fa-96b9-48a3-bb52-\
1aa73f3c1623"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precalculate", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.464974402231822*^9, 3.464974415442891*^9}, {
   3.465625036909164*^9, 3.465625042590254*^9}, 3.465625080470196*^9, {
   3.465657740406492*^9, 3.4656577834309607`*^9}, 3.465730076429566*^9, {
   3.4657347387759457`*^9, 3.4657347467634783`*^9}, 3.465790322619904*^9, {
   3.465793549521761*^9, 3.465793551122835*^9}, {3.4657936477659388`*^9, 
   3.4657936619337597`*^9}, {3.465793985441434*^9, 3.465793990842483*^9}, {
   3.5031013631921043`*^9, 3.503101363566592*^9}, 3.504268593601696*^9, {
   3.508308162779997*^9, 3.508308165079607*^9}, 3.508313228283949*^9, {
   3.508313438227887*^9, 3.508313443113968*^9}, 3.508313625229313*^9, {
   3.508313672882084*^9, 3.508313676320614*^9}, 3.508339025662491*^9, {
   3.514456471826111*^9, 3.514456482775215*^9}, 3.5147992176760683`*^9, 
   3.54505051714954*^9, {3.68339391660454*^9, 3.6833939388108063`*^9}, 
   3.684946401404299*^9, 
   3.691431738026054*^9},ExpressionUUID->"9b0c0325-4ced-41f9-87f6-\
35630f3f7bfc"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply EventList", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
  3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
  3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
  3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
  3.68339391248285*^9}, {3.691431919907403*^9, 
  3.691431923395002*^9}},ExpressionUUID->"3d1d498d-b670-43b7-b3ee-\
7ea9f8abbeb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "[", 
    RowBox[{
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", "_EventList", "]"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Precalculate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EventList", "[", 
      RowBox[{"events", ",", "\[IndentingNewLine]", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{"opts", ",", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"Options", "[", "Precalculate", "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6914319453949757`*^9, 3.6914320231357107`*^9}, {
  3.6914321333455677`*^9, 3.6914321550852613`*^9}, {3.69143298374037*^9, 
  3.691432991748345*^9}},ExpressionUUID->"f8375f85-a2b1-4fdd-a3d6-\
799d306fe9e9"]
}, Closed]],

Cell[CellGroupData[{

Cell["traps", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
  3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
  3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
  3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
  3.68339391248285*^9}, {3.691431919907403*^9, 3.691431923395002*^9}, {
  3.691432096228117*^9, 3.6914321203273363`*^9}, {3.691432432267425*^9, 
  3.6914324329199953`*^9}},ExpressionUUID->"3c7d6824-0e32-42d4-8dcf-\
15b81d4fe70b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precalculate", "[", 
     RowBox[{
      RowBox[{"evlist", ":", 
       RowBox[{"EventList", "[", 
        RowBox[{
         RowBox[{"False", "|", 
          RowBox[{"{", 
           RowBox[{"False", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"BackgroundGenerator", "[", "evlist", "]"}], ",", "Undefined"}],
      "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Precalculate", "::", "nobackg"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432143031672*^9, 3.691432191630548*^9}, {
   3.691432240461733*^9, 3.6914322547094603`*^9}, {3.691432394475116*^9, 
   3.691432416144552*^9}, 
   3.709375005209002*^9},ExpressionUUID->"bd5f0fab-94e1-4e35-bf75-\
530fbb2073b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precalculate", "[", 
     RowBox[{
      RowBox[{"evlist", ":", 
       RowBox[{"EventList", "[", 
        RowBox[{
         RowBox[{"False", "|", 
          RowBox[{"{", 
           RowBox[{"False", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"InitialTimePoint", "[", "evlist", "]"}], ",", "Undefined"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Precalculate", "::", "nota"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432143031672*^9, 3.691432191630548*^9}, {
  3.691432240461733*^9, 3.6914322547094603`*^9}, {3.6914324238925734`*^9, 
  3.6914324465681543`*^9}},ExpressionUUID->"a7f47872-f453-4c53-bc26-\
fab704c8d844"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Precalculate", "[", 
     RowBox[{
      RowBox[{"evlist", ":", 
       RowBox[{"EventList", "[", 
        RowBox[{
         RowBox[{"False", "|", 
          RowBox[{"{", 
           RowBox[{"False", ",", "_"}], "}"}]}], ",", "___"}], "]"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"FinalTimePoint", "[", "evlist", "]"}], ",", "Undefined"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Precalculate", "::", "notb"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432143031672*^9, 3.691432191630548*^9}, {
  3.691432240461733*^9, 3.6914322547094603`*^9}, {3.6914324238925734`*^9, 
  3.691432480397068*^9}},ExpressionUUID->"53807d1a-6b86-4bad-bb97-\
b43803b94367"]
}, Closed]],

Cell[CellGroupData[{

Cell["generate PrecalculatedEvent", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
   3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
   3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
   3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
   3.68339391248285*^9}, {3.691431919907403*^9, 3.691431937620658*^9}, 
   3.691434890176415*^9, 
   3.691436758386771*^9},ExpressionUUID->"4d7e7400-c15d-4684-a714-\
a3adae7b6908"],

Cell["\<\
store the propagation operator or superoperator, depending on Hilbert space \
compatibility\
\>", "Text",
 CellChangeTimes->{{3.691432807293647*^9, 
  3.6914328267129507`*^9}},ExpressionUUID->"7781963e-c381-4d84-8a53-\
6b9d79594ee1"],

Cell["\<\
set the initial and final time points to the {tb0,ta0} values. These values \
will be superseded when Event is applied.\
\>", "Text",
 CellChangeTimes->{{3.719061196957265*^9, 3.719061209321518*^9}, {
  3.719062138940092*^9, 3.719062149390786*^9}, {3.719063136556591*^9, 
  3.719063154982291*^9}, {3.7197464347790728`*^9, 
  3.719746457010997*^9}},ExpressionUUID->"bf321be0-13a8-434c-9aed-\
d7ff68f007a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "[", 
    RowBox[{
     RowBox[{"evlist", ":", 
      RowBox[{"EventList", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "__"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"dur_", ",", 
            RowBox[{"{", 
             RowBox[{"tb_", ",", "ta_"}], "}"}], ",", "pts_", ",", 
            RowBox[{"{", 
             RowBox[{"tb0_", ",", "ta0_"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "morech___"}], "}"}], ",", 
        "\[IndentingNewLine]", "more___"}], "]"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"PrecalculatedEvent", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"dur", ",", 
            RowBox[{"{", 
             RowBox[{"tb0", ",", "ta0"}], "}"}], ",", "pts", ",", 
            RowBox[{"{", 
             RowBox[{"tb0", ",", "ta0"}], "}"}]}], "}"}], ",", "morech"}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"HilbertSpaceCompatibility", "[", "evlist", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"NPropagationOperator", "[", 
           RowBox[{"evlist", ",", "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"Continuous", "\[Rule]", "False"}], ",", "opts"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"NPropagationSuperoperator", "[", 
           RowBox[{"evlist", ",", "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"Continuous", "\[Rule]", "False"}], ",", "opts"}], 
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", 
           RowBox[{"Options", "[", "PrecalculatedEvent", "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691431820882051*^9, 3.691431899884632*^9}, {
   3.69143262281854*^9, 3.6914326401637707`*^9}, {3.6914326718603487`*^9, 
   3.691432772330728*^9}, {3.691433263935442*^9, 3.691433279859022*^9}, {
   3.691433718965464*^9, 3.6914337472419567`*^9}, {3.691434532687138*^9, 
   3.691434541820785*^9}, {3.691434878960463*^9, 3.691434884552269*^9}, {
   3.6914367583929977`*^9, 3.6914367583954897`*^9}, {3.719061057960218*^9, 
   3.71906112476502*^9}, {3.71906115484906*^9, 3.719061184864592*^9}, {
   3.7190612277057543`*^9, 3.719061271940922*^9}, 
   3.719062155853258*^9},ExpressionUUID->"4e9fa042-08c0-4f5e-b6f6-\
204cbf667a50"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.459362895307612*^9, 3.4593628998113203`*^9}, {
  3.459365281739501*^9, 3.4593652848141613`*^9}, {3.464332329647097*^9, 
  3.464332333435628*^9}, {3.464348405558358*^9, 3.464348434155554*^9}, {
  3.464974399057695*^9, 3.464974400864071*^9}, {3.683393911051723*^9, 
  3.68339391248285*^9}, {3.691431919907403*^9, 3.691431937620658*^9}, {
  3.691432198637536*^9, 
  3.691432200308017*^9}},ExpressionUUID->"9cf7b9a0-cef2-434d-8d2b-\
b3bfe30510a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "::", "nobackg"}], "=", 
   "\"\<Precalculate requires a defined BackgroundGenerator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432204589841*^9, 3.691432233049296*^9}, 
   3.709375005216845*^9},ExpressionUUID->"cca2518d-662a-43bf-a139-\
ca4907a378aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "::", "nota"}], "=", 
   "\"\<Precalculate requires a defined InitialTimePoint.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432204589841*^9, 3.691432233049296*^9}, {
  3.691432459487481*^9, 
  3.691432465375051*^9}},ExpressionUUID->"0c97358a-03b7-4187-aed6-\
d4c4335691ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Precalculate", "::", "nota"}], "=", 
   "\"\<Precalculate requires a defined FinalTimePoint.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691432204589841*^9, 3.691432233049296*^9}, {
  3.691432459487481*^9, 
  3.691432489870363*^9}},ExpressionUUID->"8ba08249-d98f-4e9c-9d9c-\
b87ccce8d692"]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["OperatorTrajectoryFunction", "Subtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.454563770112988*^9, 3.454563772575369*^9}, {
   3.464689435410881*^9, 3.4646894465365963`*^9}, 3.464695493032454*^9, {
   3.467197660626375*^9, 3.4671976663433237`*^9}, 3.467199003852363*^9, 
   3.534310132957168*^9, 
   3.682614033951371*^9},ExpressionUUID->"78740f93-057b-48f6-929a-\
373e4d144efc"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 
  3.5522104203335*^9}},ExpressionUUID->"a0f0d240-caec-43ef-b3f5-3ad5bd9ceb0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorTrajectoryFunction", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543516038135828*^9, 3.543516051669629*^9}, 
   3.5439444652876253`*^9},ExpressionUUID->"c1ec5107-ba5f-4c05-8790-\
2f60286049b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorTrajectoryFunction", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62115646423569*^9, 
  3.621156479212297*^9}},ExpressionUUID->"1cd638a6-5e8c-45fc-908c-\
b46203cfabeb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrajectoryFunction", "[", 
    RowBox[{
     RowBox[{"range", ":", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}]}], ",", "opfunc_", 
     ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"OperatorTrajectoryFunction", "[", 
    RowBox[{"range", ",", "opfunc", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.552210473743086*^9, 
  3.55221050309166*^9}},ExpressionUUID->"0d5f6b51-542f-4294-9861-\
3315d7eac16a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrajectoryFunction", "[", 
    RowBox[{
     RowBox[{"range", ":", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}]}], ",", "opfunc_", 
     ",", "opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"OperatorTrajectoryFunction", "[", 
    RowBox[{"range", ",", "opfunc", ",", "opbasis", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.552210473743086*^9, 
  3.552210519066506*^9}},ExpressionUUID->"b27fa360-d178-4dec-93ea-\
e07104151611"]
}, Closed]],

Cell[CellGroupData[{

Cell["output format", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 3.5522104203335*^9}, {
  3.5522104538300877`*^9, 
  3.552210457491542*^9}},ExpressionUUID->"ac483312-41b3-400b-8e75-\
7a3edd224857"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Format", "[", 
    RowBox[{"OperatorTrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"range", ":", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tb_", "?", "NumericQ"}], ",", 
          RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}]}], ",", "opfunc_", 
      ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "\"\<OperatorTrajectoryFunction[\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"ToBoxes", "[", 
        RowBox[{"EngineeringForm", "@", 
         RowBox[{"Chop", "[", 
          RowBox[{"N", "@", 
           RowBox[{"(", 
            RowBox[{"Reverse", "/@", "range"}], ")"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ToBoxes", "[", "\"\<, <>]\>\"", "]"}]}], 
      "\[IndentingNewLine]", "}"}], "]"}], "//", "DisplayForm"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409242047933*^9}, {3.459411835080905*^9, 3.4594118370779*^9}, 
   3.4594277811731243`*^9, {3.459427811773448*^9, 3.459427814043268*^9}, {
   3.543516067337283*^9, 3.54351607152363*^9}, {3.5435161166946297`*^9, 
   3.543516150245316*^9}, {3.543944472977648*^9, 3.5439444878167267`*^9}, {
   3.5522103412226353`*^9, 
   3.552210366421303*^9}},ExpressionUUID->"fa6eaed4-2529-4a65-8438-\
0c34a0cffcc5"]
}, Closed]],

Cell[CellGroupData[{

Cell["evaluation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 
  3.552210428788885*^9}},ExpressionUUID->"30bca2e1-d69d-449e-a5fb-\
65e64a571316"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OperatorTrajectoryFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tb_", "?", "NumericQ"}], ",", 
          RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", 
       RowBox[{"opfunc", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}], ",", "opbasis_", ",", 
       "basis_", ",", "opts___Rule"}], "]"}], "[", 
     RowBox[{"t_", "?", "NumericQ"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "@", 
        RowBox[{"N", "[", 
         RowBox[{"t", "-", "ta"}], "]"}]}], "<", "0"}], ")"}], "||", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "@", 
        RowBox[{"N", "[", 
         RowBox[{"t", "-", "tb"}], "]"}]}], ">", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OperatorTrajectoryFunction", "::", "outofrange"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"EngineeringForm", "[", 
        RowBox[{"N", "@", "t"}], "]"}], ",", 
       RowBox[{"EngineeringForm", "[", 
        RowBox[{"N", "@", "ta"}], "]"}], ",", 
       RowBox[{"EngineeringForm", "[", 
        RowBox[{"N", "@", "tb"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", "0"}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4565066387991533`*^9, 3.456506747185598*^9}, {
   3.456506813471656*^9, 3.456506813658473*^9}, {3.45650693381577*^9, 
   3.456506980806471*^9}, {3.456507328570256*^9, 3.456507331247641*^9}, {
   3.456509806117323*^9, 3.456509811617663*^9}, 3.456510222793585*^9, {
   3.4993691505641317`*^9, 3.4993692011470013`*^9}, {3.49936951840275*^9, 
   3.499369565536343*^9}, {3.543516080164503*^9, 3.5435160846385593`*^9}, {
   3.5522103586300898`*^9, 3.5522103710065393`*^9}, {3.6667042811452107`*^9, 
   3.6667042903857985`*^9}, {3.666704360784102*^9, 3.6667043643664956`*^9}, 
   3.6667086119420652`*^9, {3.666709766824952*^9, 
   3.6667097696109695`*^9}},ExpressionUUID->"98a3c2a7-2273-447d-b6a0-\
505c6ba1c0a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorTrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", 
      RowBox[{"opfunc", ":", 
       RowBox[{"Except", "[", "_String", "]"}]}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "[", 
    RowBox[{"t_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Chop", "@", 
    RowBox[{"ExpressOperator", "[", 
     RowBox[{
      RowBox[{"opfunc", "[", "t", "]"}], ",", "opbasis"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506791728052*^9, 3.4565068210568933`*^9}, 
   3.456506986746358*^9, {3.456507336137793*^9, 3.4565073382651787`*^9}, {
   3.543516095537819*^9, 3.543516099532412*^9}, {3.5522103868057547`*^9, 
   3.552210402771743*^9}, {3.55221056510702*^9, 3.5522105659273443`*^9}, 
   3.552210701556672*^9, {3.6667043970232925`*^9, 3.666704424363316*^9}, 
   3.6667086185616913`*^9, {3.6667097740209446`*^9, 3.66670977611242*^9}, {
   3.6669399134130354`*^9, 
   3.666939914192689*^9}},ExpressionUUID->"32e5d9a8-cd1f-42dc-9825-\
787b168d6475"]
}, Closed]],

Cell[CellGroupData[{

Cell["time points", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 3.552210428788885*^9}, {
  3.691664043619298*^9, 
  3.691664049194872*^9}},ExpressionUUID->"3b118f54-e4ce-4b1b-917b-\
c51e6ec31168"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InitialTimePoint", "[", 
    RowBox[{"OperatorTrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", "___"}], 
     "]"}], "]"}], ":=", "ta"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4565066387991533`*^9, 3.456506747185598*^9}, {
   3.456506813471656*^9, 3.456506813658473*^9}, {3.45650693381577*^9, 
   3.456506980806471*^9}, {3.456507328570256*^9, 3.456507331247641*^9}, {
   3.456509806117323*^9, 3.456509811617663*^9}, 3.456510222793585*^9, {
   3.4993691505641317`*^9, 3.4993692011470013`*^9}, {3.49936951840275*^9, 
   3.499369565536343*^9}, {3.543516080164503*^9, 3.5435160846385593`*^9}, {
   3.5522103586300898`*^9, 3.5522103710065393`*^9}, {3.6667042811452107`*^9, 
   3.6667042903857985`*^9}, {3.666704360784102*^9, 3.6667043643664956`*^9}, 
   3.6667086119420652`*^9, {3.666709766824952*^9, 3.6667097696109695`*^9}, {
   3.6916640518929234`*^9, 
   3.691664076537393*^9}},ExpressionUUID->"59db6a45-614f-41de-ace9-\
8a172cf3a3ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FinalTimePoint", "[", 
    RowBox[{"OperatorTrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", "___"}], 
     "]"}], "]"}], ":=", "tb"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4565066387991533`*^9, 3.456506747185598*^9}, {
   3.456506813471656*^9, 3.456506813658473*^9}, {3.45650693381577*^9, 
   3.456506980806471*^9}, {3.456507328570256*^9, 3.456507331247641*^9}, {
   3.456509806117323*^9, 3.456509811617663*^9}, 3.456510222793585*^9, {
   3.4993691505641317`*^9, 3.4993692011470013`*^9}, {3.49936951840275*^9, 
   3.499369565536343*^9}, {3.543516080164503*^9, 3.5435160846385593`*^9}, {
   3.5522103586300898`*^9, 3.5522103710065393`*^9}, {3.6667042811452107`*^9, 
   3.6667042903857985`*^9}, {3.666704360784102*^9, 3.6667043643664956`*^9}, 
   3.6667086119420652`*^9, {3.666709766824952*^9, 3.6667097696109695`*^9}, {
   3.6916640518929234`*^9, 
   3.691664089257607*^9}},ExpressionUUID->"dc5f8d1c-d25d-4d20-a7c3-\
334e5325b0f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5522104160865507`*^9, 
  3.552210439028839*^9}},ExpressionUUID->"b9380ab8-e561-40e3-90eb-\
ced03324461a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorTrajectoryFunction", "::", "outofrange"}], "=", 
   "\"\<time point `1` does not lie in the interval between `2` and \
`3`\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506726342424*^9, 3.456506769186385*^9}, 
   3.456506871325568*^9},ExpressionUUID->"6a1dc70e-adc6-44bf-8ef3-\
94adc3fdc884"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e59275d0-8471-43d8-b169-537e89f47377"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.51238794480797*^9, 3.512387952205147*^9}, 
   3.513231730353488*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"f18e4652-4cf6-4a46-b76f-f6c78278cffd"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"fec762f1-6cb2-4821-8258-72d0dc0afb6f"],

Cell[CellGroupData[{

Cell["170323 changes incorporated into v3.0.0b9", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 
   3.699267264970158*^9}},ExpressionUUID->"134eae83-15c0-4f75-9734-\
e48e9a9319b4"],

Cell["MHL: minor changes in NPropagate (undefined Basis message)", "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 
  3.699279350177552*^9}},ExpressionUUID->"ee8e0438-76a0-41e2-ad86-\
2a942bebe077"]
}, Closed]],

Cell[CellGroupData[{

Cell["170326 changes incorporated into v3.0.0b10_CB", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699623566119301*^9, 
   3.6996235662155848`*^9}, {3.699684590730136*^9, 3.699684591301826*^9}, {
   3.699685734918288*^9, 
   3.699685761319357*^9}},ExpressionUUID->"f1de883d-467a-4c62-86d5-\
7db27d64ffff"],

Cell["\<\
CB: 1) minor changes in NPropagate/NPropagationSuperoperator (undefined \
OperatorBasis message)
       2) NDSolveOptions were not respected in \
NPropagate/NPropagationSuperoperator, this has been corrected.
       
Comment: currently the default options for NDSolve seem like an overkill. For \
example if one simulates a single spin 1/2 with a single event : {Function[t, \
opI[\[OpenCurlyDoubleQuote]x\[CloseCurlyDoubleQuote]] ],1}. This takes ~ 4 s, \
even though the event is \[OpenCurlyDoubleQuote]time-independent\
\[CloseCurlyDoubleQuote] in its nature. Do you think it would be more \
user-friendly to set the DefaultOptions for time-step/etc to Automatic? \
\>", "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 3.699279350177552*^9}, {
  3.6995424688031*^9, 3.6995424844515934`*^9}, {3.6995984046620865`*^9, 
  3.6995984239983478`*^9}, {3.699598820867962*^9, 3.699598871148675*^9}, {
  3.6996233900871863`*^9, 
  3.6996235568005548`*^9}},ExpressionUUID->"6b2e90d1-4e0e-48b9-900b-\
78b00f8fe19b"]
}, Closed]],

Cell[CellGroupData[{

Cell["170327 changes incorporated into v3.0.0b10_CB", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685724137114*^9}, 
   3.699685764030684*^9},ExpressionUUID->"c9d1db5e-9bf1-4007-a918-\
924c8f990a77"],

Cell["\<\
CB: OperatorTrajectoryFunctions in MatrixForm, are now flattened after \
calculation in Hilbert-Space to allow for OperatorAmplitude[ifunc \[Rule] \
Qobs]. 
Comment: This is was found to be necessary for ConvertOperatorTrajectory to \
work.\
\>", "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 3.699279350177552*^9}, {
  3.6995424688031*^9, 3.6995424844515934`*^9}, {3.6995984046620865`*^9, 
  3.699598550064138*^9}, {3.699598892528802*^9, 3.699598997536524*^9}, {
  3.699623385232276*^9, 
  3.699623385735639*^9}},ExpressionUUID->"722228d1-9a52-46f7-a5f4-\
eecd116295fe"]
}, Closed]],

Cell["170328 packaged transferred from v3.0.0b10_CB to v3.0.0b11", \
"Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}},ExpressionUUID->"8f66e857-d7f2-4248-ac85-\
2c4e426945c3"],

Cell[CellGroupData[{

Cell["170425 changes incorporated into v3.0.0b12_CB", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.70270947116273*^9, 
   3.702709489427574*^9}},ExpressionUUID->"de6addfa-f84a-4632-b3f8-\
db79d1555bcf"],

Cell["\<\
-included a (hopefully) robust method of accepting a CommutationSuperoperator \
with with any prefactor (I, -I, ...)
-adjusted default options for NDSolve in NPropagate/NPropagationOperator
-possibility of using a different operatorbasis/basis than the ZeemanBasis \
included in NPropagate/NPropagationSuperoperator\
\>", "Text",
 CellChangeTimes->{{3.702709495691413*^9, 3.702709568271593*^9}, {
  3.7027967730249376`*^9, 3.7027967995688276`*^9}, {3.7027969405123563`*^9, 
  3.702796970152482*^9}},ExpressionUUID->"066a6164-c310-4561-8181-\
edd6ca842885"]
}, Closed]],

Cell[CellGroupData[{

Cell["170718 changes in v3.0.0b18", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}},ExpressionUUID->"30b4974b-9a05-442f-bd5e-\
1e18a95455ac"],

Cell["\<\
Numerous name changes from EvolutionGenerator (and similar) to Generator (and \
similar)\
\>", "Text",
 CellChangeTimes->{{3.709386922996626*^9, 
  3.709386992335451*^9}},ExpressionUUID->"2baa4259-71e3-4224-922b-\
933530f6be12"],

Cell["fixes to NPropagate applied to EventList", "Text",
 CellChangeTimes->{{3.709387023719429*^9, 
  3.709387030318277*^9}},ExpressionUUID->"4ea540ce-45c7-406b-8961-\
6063b049155b"]
}, Closed]],

Cell[CellGroupData[{

Cell["170905 changes in v3.0.1b1 [CB]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}, {3.7136061689455657`*^9, 
   3.713606177290352*^9}},ExpressionUUID->"30b4974b-9a05-442f-bd5e-\
1e18a95455ac"],

Cell["Recoding of NDSolve for time-dependent events.", "Text",
 CellChangeTimes->{{3.709386922996626*^9, 3.709386992335451*^9}, {
  3.713606186458056*^9, 3.713606190618826*^9}, {3.7136083373820543`*^9, 
  3.7136083393653436`*^9}},ExpressionUUID->"2baa4259-71e3-4224-922b-\
933530f6be12"]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
WindowSize->{829, 854},
WindowMargins->{{Automatic, 247}, {Automatic, 0}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 393, 9, 114, "Title",ExpressionUUID->"bf3a620b-f62c-4048-b649-25e49b3360a5",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[985, 35, 341, 8, 57, "Subsubtitle",ExpressionUUID->"7dac5cf1-874d-49c2-ae9f-b25f3c5bf696",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1329, 45, 2323, 40, 488, "Input",ExpressionUUID->"d9e72523-4043-4aac-a82f-3158f09ddff1",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3689, 90, 278, 7, 41, "Subsubtitle",ExpressionUUID->"8e405309-f4bc-4a66-a562-8cd548666539",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[3992, 101, 431, 9, 36, "Section",ExpressionUUID->"b92c66c0-1a67-4cca-914f-7d9a73bef855",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[4426, 112, 547, 13, 1656, "Input",ExpressionUUID->"7d9892be-e8bc-4948-9f50-8f1523d17f4c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5010, 130, 383, 9, 36, "Section",ExpressionUUID->"63139686-36d0-4edb-8ab9-49fd6ed01c4e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[5418, 143, 207, 4, 49, "Subsection",ExpressionUUID->"dc5d97c4-c58c-4361-bdb0-7ecac169c676",
 InitializationCell->True],
Cell[5628, 149, 4844, 70, 560, "Input",ExpressionUUID->"0a847c49-46b0-4d68-a06d-c8f50cad5d7a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10509, 224, 212, 5, 41, "Subsection",ExpressionUUID->"0894c9d4-0ecd-4655-ac1e-423a6ab0052e",
 InitializationCell->True],
Cell[10724, 231, 661, 14, 85, "Input",ExpressionUUID->"09dbb707-c51c-4088-95e5-5d0e447f98fa",
 InitializationCell->True],
Cell[11388, 247, 682, 14, 85, "Input",ExpressionUUID->"8e5e272a-9819-4c9d-9939-73413a7c575c",
 InitializationCell->True],
Cell[12073, 263, 594, 13, 85, "Input",ExpressionUUID->"ce30e2cc-7f82-4508-8438-7839fcddaab4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[12716, 282, 419, 9, 36, "Section",ExpressionUUID->"fa0b721f-0a31-4216-bc37-bab5f5b368dd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13138, 293, 742, 14, 4001, "Input",ExpressionUUID->"3045a187-a396-4858-9005-4cd515dd04ec",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13917, 312, 474, 10, 36, "Section",ExpressionUUID->"a2f87fc4-7320-42a8-9ee5-cdc5be0a9e89",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14394, 324, 628, 12, 85, "Input",ExpressionUUID->"46fbc635-b596-4b93-91b1-0a0e86d300e9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15059, 341, 432, 9, 36, "Section",ExpressionUUID->"5446cf15-570d-42c0-a92f-e1e5eef24e0d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[15494, 352, 2276, 35, 320, "Input",ExpressionUUID->"f67e4129-c4f2-41d2-b182-30d69dad2d76",
 InitializationCell->True],
Cell[17773, 389, 329, 9, 46, "Input",ExpressionUUID->"19c7dac9-3b46-464d-af23-177955839a3f",
 InitializationCell->True],
Cell[18105, 400, 504, 11, 68, "Input",ExpressionUUID->"98c6e395-765f-496d-a1a6-5179c973b417",
 InitializationCell->True],
Cell[18612, 413, 484, 10, 89, "Input",ExpressionUUID->"14076868-3c8b-4a10-ab1e-dcaea1f5e204",
 InitializationCell->True],
Cell[19099, 425, 490, 10, 89, "Input",ExpressionUUID->"d267a713-376b-471c-899f-7bff90a08f5e",
 InitializationCell->True],
Cell[19592, 437, 491, 10, 89, "Input",ExpressionUUID->"e3150222-1aeb-4cfc-bf2e-b32d3945275d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20120, 452, 1061, 18, 36, "Section",ExpressionUUID->"29983912-ed1e-4746-a941-7ea1c6f51938",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[21184, 472, 2549, 39, 835958, "Input",ExpressionUUID->"bfa8cba6-0a2f-4dde-89ad-cc5b0ea81cb6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[23770, 516, 1090, 18, 36, "Section",ExpressionUUID->"29190c90-35ce-4aae-a109-b8c752d7d19b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[24863, 536, 3430, 51, 301, "Input",ExpressionUUID->"4bdbf4cc-6281-4da5-8e40-f85ad5dbfb98",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28342, 593, 184, 5, 69, "Subtitle",ExpressionUUID->"167172aa-ef9e-4ee7-87fa-b682dbc3b960",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[28529, 600, 299, 7, 344534, "Input",ExpressionUUID->"f2a84ac0-d682-4d0d-8f34-aa5ee3e15b4d",
 InitializationCell->True],
Cell[28831, 609, 201, 5, 344534, "Input",ExpressionUUID->"7c2f35cd-af2a-4e34-b551-77232af03d56",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29069, 619, 433, 8, 69, "Subtitle",ExpressionUUID->"fdc13a1e-a256-4b2f-b075-318e6b6d3029",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[29527, 631, 483, 10, 44, "Subsubtitle",ExpressionUUID->"52c21289-8b9e-461b-8585-ec3ee64f6060",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[30013, 643, 4950, 112, 237, "Input",ExpressionUUID->"60639b1b-9973-4dee-adfd-9b090eb5301e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35000, 760, 543, 10, 44, "Subsubtitle",ExpressionUUID->"e2e17385-b827-4620-a56d-74e8e2500958",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[35546, 772, 5043, 100, 219, "Input",ExpressionUUID->"9e4366d5-0ebb-4d88-9cd8-f8aaddf6e222",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[40638, 878, 377, 7, 69, "Subtitle",ExpressionUUID->"c1815b2c-29b7-408a-a717-0a6ef3d0e4e3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[41040, 889, 408, 9, 41, "Subsubtitle",ExpressionUUID->"c0a32326-c503-4d0c-82f0-38b1269fa45e",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True],
Cell[41451, 900, 4319, 72, 404, "Input",ExpressionUUID->"b7e2690c-c35a-4d3d-87ed-4d97a2833dee",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[45807, 977, 346, 8, 41, "Subsubtitle",ExpressionUUID->"46255cfa-1b2a-4206-89aa-37f2a7c07fb2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[46156, 987, 412, 9, 81, "Text",ExpressionUUID->"a0a4c2b2-3d5d-4205-8a74-39a2b1065844"],
Cell[CellGroupData[{
Cell[46593, 1000, 513, 9, 36, "Section",ExpressionUUID->"6190351d-e9d5-4308-8a11-babbae9c49de",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[47131, 1013, 436, 8, 43, "Subsection",ExpressionUUID->"1382264d-cc14-46e1-a1cc-d714e5234297",
 InitializationCell->True,
 InitializationGroup->True],
Cell[47570, 1023, 565, 10, 49, "Text",ExpressionUUID->"0ef07663-58fe-412d-9031-8aec36bb6527"],
Cell[CellGroupData[{
Cell[48160, 1037, 468, 8, 34, "Subsubsection",ExpressionUUID->"413f1454-423b-4ea2-9b13-83ca036c709e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[48631, 1047, 1337, 30, 67, "Input",ExpressionUUID->"edfb6f92-9c6b-47b7-acb0-7575c39c717e",
 InitializationCell->True],
Cell[49971, 1079, 431, 10, 46, "Input",ExpressionUUID->"316d6f36-0234-4326-bf21-237b73a468c0",
 InitializationCell->True],
Cell[50405, 1091, 1607, 31, 66, "Input",ExpressionUUID->"432458cd-9cbe-4c59-8a77-2e961fef4168",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[52049, 1127, 605, 10, 28, "Subsubsection",ExpressionUUID->"c991a84e-0352-453b-85a7-026a1f882aba",
 InitializationCell->True,
 InitializationGroup->True],
Cell[52657, 1139, 1486, 26, 48, "Input",ExpressionUUID->"30426835-0209-47d2-bbfe-8a3270e32122",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54192, 1171, 630, 10, 35, "Subsection",ExpressionUUID->"48800c07-fd44-41e3-bcf3-3d2eb2099d64",
 InitializationCell->True,
 InitializationGroup->True],
Cell[54825, 1183, 2814, 57, 123, "Input",ExpressionUUID->"ce1b05ad-8aa1-458c-824d-9423deafc0d8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[57676, 1245, 742, 12, 35, "Subsection",ExpressionUUID->"22c75821-bfcb-4579-ad6a-5fcae5c0b12a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[58421, 1259, 650, 19, 346643, "Input",ExpressionUUID->"f0efea6c-088d-4181-b946-afbdb6cb2315",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[59108, 1283, 565, 10, 35, "Subsection",ExpressionUUID->"c114905f-aca5-4102-b6a7-6382921167d1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[59676, 1295, 1569, 35, 133, "Input",ExpressionUUID->"953b254d-97d1-42c5-9ea6-88a4ba2cd4f1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61294, 1336, 553, 10, 36, "Section",ExpressionUUID->"c793c2c1-d434-4a65-b369-b004756f28af",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[61872, 1350, 415, 7, 43, "Subsection",ExpressionUUID->"aa64a854-6967-4355-a1e3-8b1b119e9beb",
 InitializationCell->True],
Cell[62290, 1359, 1586, 32, 71, "Input",ExpressionUUID->"1c3003c6-0ad9-4031-92e0-2f903b47d537",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[63913, 1396, 444, 8, 35, "Subsection",ExpressionUUID->"8610f7ce-cf52-44b8-90ef-ef255d1d892b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[64360, 1406, 1871, 40, 85, "Input",ExpressionUUID->"d6ad31f5-4623-45be-af16-7b4a6d038fe1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[66234, 1448, 1718, 37, 85, "Input",ExpressionUUID->"8f11ff12-c5b1-403e-9f86-0e4150a2d15e",
 InitializationCell->True],
Cell[67955, 1487, 2456, 47, 142, "Input",ExpressionUUID->"d8afc2dc-d936-44f7-bb9c-3d8bf9d90750",
 InitializationCell->True],
Cell[70414, 1536, 2397, 48, 142, "Input",ExpressionUUID->"85607683-3f11-4901-a758-f7b73e823cc3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[72848, 1589, 578, 10, 35, "Subsection",ExpressionUUID->"7181f34c-bf40-4609-a74c-10a12b3c14c1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[73429, 1601, 187, 3, 30, "Text",ExpressionUUID->"82437aa7-c7e1-46ac-8f56-9a48f4466fdb"],
Cell[73619, 1606, 8894, 149, 371, "Input",ExpressionUUID->"fd219492-03e7-4a0f-b39f-f68a3a620269",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[82550, 1760, 205, 4, 35, "Subsection",ExpressionUUID->"f31e3de4-d5b2-4126-a947-9aa021e8ccf3"],
Cell[CellGroupData[{
Cell[82780, 1768, 173, 3, 34, "Subsubsection",ExpressionUUID->"056ca3bf-ff2c-49ea-a76f-c12424e5c147"],
Cell[82956, 1773, 175, 3, 30, "Text",ExpressionUUID->"f305da1a-27a4-4e98-aa44-33bfb694c21c"],
Cell[83134, 1778, 1373, 32, 104, "Input",ExpressionUUID->"2a631f5d-f877-48b3-b87e-d5c5179375d6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[84544, 1815, 339, 7, 28, "Subsubsection",ExpressionUUID->"9b18e6e3-5a30-43fc-873b-53f4b79175af"],
Cell[84886, 1824, 245, 6, 30, "Text",ExpressionUUID->"5c9c9ff7-7684-4fe5-84f2-a83412b670d4"],
Cell[85134, 1832, 7371, 129, 390, "Input",ExpressionUUID->"9f1c71a1-c1fd-427d-b54c-a329efa7bede",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[92542, 1966, 242, 4, 28, "Subsubsection",ExpressionUUID->"9f7536f1-c11e-4b2a-beb4-969a56eb4694"],
Cell[92787, 1972, 1220, 32, 86, "Input",ExpressionUUID->"2ab1323d-db38-4997-aa8b-fecad18f3fe6",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[94056, 2010, 1005, 15, 35, "Subsection",ExpressionUUID->"79cd438a-ba28-4869-8781-8a7142eb48df",
 InitializationCell->True],
Cell[95064, 2027, 2393, 44, 123, "Input",ExpressionUUID->"18667810-77fd-4119-aa5b-406fa85709de",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[97506, 2077, 753, 12, 36, "Section",ExpressionUUID->"75587671-d635-4064-9b00-7610a5222cfc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[98284, 2093, 660, 11, 54, "Subsection",ExpressionUUID->"c2ab4c9c-1ccc-4f39-8d98-4fb7b5efbae6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[98947, 2106, 245, 4, 54, "Text",ExpressionUUID->"ff7f57af-e3e1-4f35-a384-963fe0f70049"],
Cell[99195, 2112, 1208, 27, 104, "Input",ExpressionUUID->"c076bf29-3db5-4b76-b277-e5f416320724",
 InitializationCell->True],
Cell[100406, 2141, 1492, 33, 104, "Input",ExpressionUUID->"cc12261e-c94b-4d5d-9d5d-263519b68f98",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[101935, 2179, 1216, 18, 38, "Subsection",ExpressionUUID->"bcd357f9-8361-41e5-a490-daaf17e9e6d0",
 InitializationCell->True],
Cell[103154, 2199, 2405, 49, 194, "Input",ExpressionUUID->"26207624-79c0-4322-8f34-1dd06aedece7",
 InitializationCell->True],
Cell[105562, 2250, 1956, 40, 110, "Input",ExpressionUUID->"b7f3ecd7-3d4f-4303-be63-6fcabfec4004",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[107579, 2297, 345, 8, 41, "Subsubtitle",ExpressionUUID->"7fb48f6c-36ce-4204-a2c2-e27b6567a8c2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[107949, 2309, 1169, 18, 36, "Section",ExpressionUUID->"f5f1d4a6-7716-4d1a-8abe-756b70d842ff",
 InitializationCell->True],
Cell[109121, 2329, 11796, 191, 275, "Input",ExpressionUUID->"e9bf9ff3-32fc-4942-8800-380d4d57cea2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[120954, 2525, 1311, 21, 36, "Section",ExpressionUUID->"d7fbcb19-8c27-4e00-900a-506630443421",
 InitializationCell->True],
Cell[122268, 2548, 14019, 239, 409, "Input",ExpressionUUID->"205ada6e-6980-4287-be59-bead543eee16",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[136324, 2792, 1106, 16, 36, "Section",ExpressionUUID->"7d6412c7-2b24-4ae7-84ff-94dabc33ad4f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[137455, 2812, 382, 7, 54, "Subsection",ExpressionUUID->"2435203d-c747-439e-9819-255b8abb4fd7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[137862, 2823, 230, 4, 39, "Subsubsection",ExpressionUUID->"01cc3631-1102-4b3c-a96d-23d90ac817d8"],
Cell[CellGroupData[{
Cell[138117, 2831, 199, 3, 244, "Subsubsubsection",ExpressionUUID->"d028d108-39d3-4d79-9aa4-32d49f09141b"],
Cell[138319, 2836, 1218, 25, 632, "Input",ExpressionUUID->"1e39cc99-df91-43b1-99c5-490668cc7059",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[139574, 2866, 279, 4, 244, "Subsubsubsection",ExpressionUUID->"cb2252c3-3a0e-44c4-b520-eb4a6012b032"],
Cell[139856, 2872, 1471, 33, 822, "Input",ExpressionUUID->"b8c21d41-3fa6-47a9-a1eb-7b9656e4c8ba",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[141364, 2910, 502, 8, 244, "Subsubsubsection",ExpressionUUID->"30b62a36-8920-4246-920c-adc434441b56",
 InitializationCell->True],
Cell[141869, 2920, 1540, 33, 1009, "Input",ExpressionUUID->"c214f1f2-2922-44f1-8f22-9f36e3969b79",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[143458, 2959, 230, 4, 33, "Subsubsection",ExpressionUUID->"4b8759f6-081e-4320-b6d3-7e9893a0e087"],
Cell[CellGroupData[{
Cell[143713, 2967, 199, 3, 28, "Subsubsubsection",ExpressionUUID->"4d9d0a07-e6ca-451b-b434-668e0f818ded"],
Cell[143915, 2972, 1282, 25, 86, "Input",ExpressionUUID->"bd1a542a-b27b-4cc3-aa07-2d260f6ba708",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[145234, 3002, 279, 4, 22, "Subsubsubsection",ExpressionUUID->"a41ff099-9888-434f-a95a-d84d3ed232f2"],
Cell[145516, 3008, 1541, 34, 86, "Input",ExpressionUUID->"11d1f04a-c2dd-44f2-9772-3d5b8d36cecf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[147094, 3047, 502, 8, 22, "Subsubsubsection",ExpressionUUID->"5dfa5dea-d65a-4f82-8e04-a993b35ab3f9",
 InitializationCell->True],
Cell[147599, 3057, 1605, 34, 105, "Input",ExpressionUUID->"e8c088f7-a6f8-4f72-944c-c77e7ee5d626",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[149241, 3096, 849, 14, 22, "Subsubsubsection",ExpressionUUID->"3f088792-33e4-4869-9ab1-65a31826b530",
 InitializationCell->True],
Cell[150093, 3112, 1510, 31, 86, "Input",ExpressionUUID->"4808bb79-b96e-4275-8880-3f64323be40d",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[151664, 3150, 201, 4, 38, "Subsection",ExpressionUUID->"fc75f5fc-252c-43fb-9fc9-6b7da17869a9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[151890, 3158, 879, 14, 45, "Subsubsection",ExpressionUUID->"d974bfbf-e254-4996-9074-5caf1ce4b938",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[152794, 3176, 819, 13, 28, "Subsubsubsection",ExpressionUUID->"5459f693-ab76-452c-9d5d-ba06dd20563d",
 InitializationCell->True],
Cell[153616, 3191, 210, 4, 109, "Text",ExpressionUUID->"bebb893d-f95c-47c9-b837-3836e30708c2",
 InitializationCell->True],
Cell[153829, 3197, 3859, 73, 318, "Input",ExpressionUUID->"dd491252-4aa6-4fb4-8fd9-b7ffe4a4a71b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[157725, 3275, 757, 12, 22, "Subsubsubsection",ExpressionUUID->"fd7d50bc-6b80-4dea-b0ff-0d8943368ea4",
 InitializationCell->True],
Cell[158485, 3289, 374, 10, 114, "Text",ExpressionUUID->"12bc6659-7bc5-469c-886b-4b9d916dbdf2",
 InitializationCell->True],
Cell[158862, 3301, 7543, 137, 504, "Input",ExpressionUUID->"f53a34bc-b6e8-459a-92f4-3f87b75e74d4",
 InitializationCell->True],
Cell[166408, 3440, 199, 4, 65, "Text",ExpressionUUID->"4b56cb4e-45c2-4bfb-a6e3-d62f1ff1f381",
 InitializationCell->True],
Cell[166610, 3446, 6730, 124, 654, "Input",ExpressionUUID->"2355ef2a-078f-4502-9e42-e59a44dd5da7",
 InitializationCell->True],
Cell[173343, 3572, 253, 6, 84, "Text",ExpressionUUID->"349440da-2970-4c31-9bdb-1f9b106c3f6d",
 InitializationCell->True],
Cell[173599, 3580, 3823, 76, 356, "Input",ExpressionUUID->"76fc43b3-03d3-4471-b899-ba03c98725c1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[177471, 3662, 809, 13, 37, "Subsubsection",ExpressionUUID->"ba5dc159-810c-4006-9689-2465114e9920",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[178305, 3679, 870, 14, 28, "Subsubsubsection",ExpressionUUID->"a14e7cbc-640b-4a1c-91dc-c91d89415244",
 InitializationCell->True],
Cell[179178, 3695, 5128, 94, 1028, "Input",ExpressionUUID->"545e1219-95df-4ab7-a161-f9e91edad951",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[184343, 3794, 709, 12, 22, "Subsubsubsection",ExpressionUUID->"4fb893d9-a47f-45b3-a471-921a4438efdf",
 InitializationCell->True],
Cell[185055, 3808, 9910, 208, 442, "Input",ExpressionUUID->"67fd8e74-abd2-410c-ae72-0c5aec5d8faf",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[195014, 4022, 871, 14, 37, "Subsubsection",ExpressionUUID->"148a4ff4-ca57-4769-bd9a-11a0336aecba",
 InitializationCell->True],
Cell[195888, 4038, 3402, 56, 143, "Input",ExpressionUUID->"474d3882-f81e-41fd-816d-2d37c676dd82",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[199327, 4099, 937, 15, 37, "Subsubsection",ExpressionUUID->"be669a25-7196-4433-b989-8bb5c636bc38",
 InitializationCell->True],
Cell[200267, 4116, 3773, 66, 173, "Input",ExpressionUUID->"734b9550-3557-4a62-9a31-931ead3b5aad",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[204077, 4187, 1165, 17, 45, "Subsubsection",ExpressionUUID->"b809145a-26ed-41a5-9a00-eeee8f24535e",
 InitializationCell->True],
Cell[205245, 4206, 7049, 134, 409, "Input",ExpressionUUID->"2f79c20b-5156-4b05-a453-fb7cd4f22fea",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[212331, 4345, 1155, 17, 37, "Subsubsection",ExpressionUUID->"340b5a45-0a0a-414f-b153-3d32b2de58c7",
 InitializationCell->True],
Cell[213489, 4364, 3131, 55, 124, "Input",ExpressionUUID->"d1bb09ee-f728-4084-823c-ddf940516f44",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[216669, 4425, 205, 4, 54, "Subsection",ExpressionUUID->"d0326c21-5978-4428-a4fc-458617595383",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[216899, 4433, 978, 15, 34, "Subsubsection",ExpressionUUID->"81dc5a31-3727-4dbf-ade9-e56a543bcf69",
 InitializationCell->True],
Cell[217880, 4450, 5540, 86, 105, "Input",ExpressionUUID->"bc38ddc9-dee9-49dd-8b34-82a3821156e9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[223457, 4541, 930, 15, 28, "Subsubsection",ExpressionUUID->"36bd9b5b-f2fc-4fc2-9ae7-7dd87e56208b",
 InitializationCell->True],
Cell[224390, 4558, 431, 10, 68, "Text",ExpressionUUID->"6b4e69a6-b486-42b9-ba36-01ca1509dcf7",
 InitializationCell->True],
Cell[224824, 4570, 8438, 153, 314, "Input",ExpressionUUID->"f540cdcd-77ee-4555-8d34-03ee1d2adcc4",
 InitializationCell->True],
Cell[233265, 4725, 6235, 118, 238, "Input",ExpressionUUID->"671fcc6d-2302-4c17-b8a5-809b64789e1a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[239537, 4848, 831, 13, 28, "Subsubsection",ExpressionUUID->"468b1bac-5a18-4068-8ca1-bee7c0757e89",
 InitializationCell->True],
Cell[240371, 4863, 8552, 194, 542, "Input",ExpressionUUID->"b680dcca-b375-4880-ab81-201fc98d63ac",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[248960, 5062, 176, 3, 37, "Subsubsection",ExpressionUUID->"17870f18-71f2-44fe-95e9-69a31b0c1618"],
Cell[249139, 5067, 1498, 34, 215, "Input",ExpressionUUID->"1c00abb7-cab1-4329-8758-3e099767bc2f",
 InitializationCell->True],
Cell[250640, 5103, 17875, 331, 719, "Input",ExpressionUUID->"67fd8e74-abd2-410c-ae72-0c5aec5d8faf",
 InitializationCell->True],
Cell[268518, 5436, 26447, 484, 1538, "Input",ExpressionUUID->"2cce5ccf-76fb-485a-a54e-8aa92c489832",
 InitializationCell->True],
Cell[294968, 5922, 5824, 95, 89, "Input",ExpressionUUID->"19acfb9c-ea92-4218-82fd-38b47fabe8ca",
 InitializationCell->True],
Cell[300795, 6019, 7590, 135, 215, "Input",ExpressionUUID->"40d68d5f-fc66-4132-b2b0-a75308cb373b",
 InitializationCell->True],
Cell[308388, 6156, 9494, 177, 383, "Input",ExpressionUUID->"c94abc34-391a-4973-8ab2-7db0ea546d92",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[317919, 6338, 1165, 17, 45, "Subsubsection",ExpressionUUID->"0a0776b9-2c43-4909-a966-48d02cba8f6e",
 InitializationCell->True],
Cell[319087, 6357, 8604, 154, 352, "Input",ExpressionUUID->"b57ef8de-1008-43a0-8efc-a3b7f41b89e3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[327728, 6516, 1155, 17, 37, "Subsubsection",ExpressionUUID->"b3071ea1-789c-4c71-923e-620ed9e0e5a3",
 InitializationCell->True],
Cell[328886, 6535, 3289, 57, 124, "Input",ExpressionUUID->"33b9fdd3-6438-4803-8892-86d56b2cbd53",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[332248, 6600, 398, 9, 41, "Subsubtitle",ExpressionUUID->"4e5ad67f-06d2-43aa-8432-3447e46c7934",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[332671, 6613, 402, 7, 39, "Section",ExpressionUUID->"ef94cf9d-853a-4c5b-aefc-37316c247b87",
 InitializationCell->True],
Cell[333076, 6622, 234, 6, 30, "Text",ExpressionUUID->"06fcf184-b97a-4157-bc38-691fca90e4ed"],
Cell[333313, 6630, 1269, 25, 66, "Input",ExpressionUUID->"a7449119-ba0e-4577-b3be-46bfaa1949c8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[334619, 6660, 380, 6, 39, "Section",ExpressionUUID->"6238e591-eb97-4da5-86b6-79a3f26195c7",
 InitializationCell->True],
Cell[335002, 6668, 5695, 96, 199, "Input",ExpressionUUID->"b95e161f-25ba-457c-87e3-d0e0a17af9e7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[340734, 6769, 442, 7, 39, "Section",ExpressionUUID->"c0679214-6fd4-4ec8-84ef-973b6989886d",
 InitializationCell->True],
Cell[341179, 6778, 2282, 49, 226, "Input",ExpressionUUID->"15245736-e1d8-4960-a248-94309b6f81d3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[343498, 6832, 588, 9, 39, "Section",ExpressionUUID->"5f202b00-e1b0-44da-8384-b6b6cba90cde",
 InitializationCell->True],
Cell[344089, 6843, 15588, 274, 826, "Input",ExpressionUUID->"5f85f0a0-63e4-4c39-b0d2-e5c9bf0042c2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[359714, 7122, 553, 9, 39, "Section",ExpressionUUID->"5529bbcf-9b3e-46d0-a51d-8b7c593dc6aa",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[360292, 7135, 263, 5, 49, "Subsection",ExpressionUUID->"4931c974-07e9-4a2d-8200-13939822e90c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[360580, 7144, 816, 13, 39, "Subsubsection",ExpressionUUID->"784e7e49-67fa-4179-8ea7-533bc95c7511",
 InitializationCell->True],
Cell[361399, 7159, 210, 4, 126, "Text",ExpressionUUID->"bce93194-2a90-4f17-8527-40a43472b799",
 InitializationCell->True],
Cell[361612, 7165, 4288, 83, 666, "Input",ExpressionUUID->"d16434b6-209c-454e-b985-74cc3b200b05",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[365937, 7253, 754, 12, 33, "Subsubsection",ExpressionUUID->"3564adea-cd3f-41a3-95a2-bf9c257465aa",
 InitializationCell->True],
Cell[366694, 7267, 6330, 127, 2265, "Input",ExpressionUUID->"f4ba4b7c-181a-488e-9970-b7d0bebc45ed",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[373061, 7399, 867, 14, 33, "Subsubsection",ExpressionUUID->"0e8a7e88-2918-4eef-9f66-28d436d398ab",
 InitializationCell->True],
Cell[373931, 7415, 5413, 101, 842, "Input",ExpressionUUID->"f2f35a81-d3d3-4ab0-a1b6-a2e682a0cf5a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[379381, 7521, 706, 12, 33, "Subsubsection",ExpressionUUID->"b19948e8-953e-49a0-8720-2d54c8bf4a9a",
 InitializationCell->True],
Cell[380090, 7535, 10488, 220, 390, "Input",ExpressionUUID->"f44c31e6-af82-4208-a86b-e11023279a46",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[390615, 7760, 553, 9, 33, "Subsubsection",ExpressionUUID->"35029a82-7c3a-41e1-9b83-2291420124b7",
 InitializationCell->True],
Cell[391171, 7771, 4885, 95, 2734, "Input",ExpressionUUID->"7dfc2576-91ee-44bd-ad96-083fc8866f70",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[396105, 7872, 313, 5, 41, "Subsection",ExpressionUUID->"8c91debc-792b-4f54-bca1-e1001c134fcc",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[396443, 7881, 978, 15, 39, "Subsubsection",ExpressionUUID->"4be63b27-9a3e-4e06-aad4-e2a9b26c13ec",
 InitializationCell->True],
Cell[397424, 7898, 6918, 120, 2351, "Input",ExpressionUUID->"9ca80652-8f3a-4083-b438-130c5c04cc72",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[404379, 8023, 930, 15, 33, "Subsubsection",ExpressionUUID->"8fdf4f49-9648-4c16-83aa-28e08e19faa2",
 InitializationCell->True],
Cell[405312, 8040, 7934, 151, 219, "Input",ExpressionUUID->"91037dc8-0edd-4e2b-9826-0889d36152b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[413283, 8196, 831, 13, 33, "Subsubsection",ExpressionUUID->"97441659-826f-4cd5-afd2-dbccf267f7a6",
 InitializationCell->True],
Cell[414117, 8211, 9081, 193, 352, "Input",ExpressionUUID->"bba6906b-5651-4056-9a83-5b8e7d2cf002",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[423271, 8412, 379, 9, 41, "Subsubtitle",ExpressionUUID->"2a54b33a-ac40-45f3-930f-ff75e059ace2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[423653, 8423, 420, 10, 46, "Input",ExpressionUUID->"22eb598b-3d2d-494b-9c3f-5e0bb419d677",
 InitializationCell->True],
Cell[424076, 8435, 408, 10, 66, "Input",ExpressionUUID->"99de70a4-1236-4628-a3fa-f791b45c5a47",
 InitializationCell->True],
Cell[424487, 8447, 424, 10, 85, "Input",ExpressionUUID->"86d330d2-69c2-4b19-941a-7d1464fcd7ea",
 InitializationCell->True],
Cell[424914, 8459, 513, 11, 85, "Input",ExpressionUUID->"7a39b230-cc70-46ad-9134-690b703abdf2",
 InitializationCell->True],
Cell[425430, 8472, 581, 12, 85, "Input",ExpressionUUID->"9b3ad3b4-47ab-497f-bb84-173e1e027369",
 InitializationCell->True],
Cell[426014, 8486, 611, 12, 66, "Input",ExpressionUUID->"ac1aaf62-19a0-4270-87fa-6e158750a81b",
 InitializationCell->True],
Cell[426628, 8500, 339, 9, 46, "Input",ExpressionUUID->"de72a473-34e8-48dd-9b9d-43d63928c16f",
 InitializationCell->True],
Cell[426970, 8511, 402, 10, 66, "Input",ExpressionUUID->"de72a473-34e8-48dd-9b9d-43d63928c16f",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[427421, 8527, 489, 9, 69, "Subtitle",ExpressionUUID->"94acbc0b-bfbe-403c-bcca-debef34159b1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[427935, 8540, 380, 8, 41, "Subsubtitle",ExpressionUUID->"7ae52724-825a-4a65-999c-1b34c608b141",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True],
Cell[428318, 8550, 4180, 72, 370, "Input",ExpressionUUID->"f717cc8b-5731-4910-9f7b-d940b725c85a",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[432535, 8627, 346, 8, 41, "Subsubtitle",ExpressionUUID->"f7fa0de2-0dc4-47e7-9216-0f74052bae45",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[432906, 8639, 513, 9, 67, "Section",ExpressionUUID->"0a123986-cdab-46ef-b300-1cd7efa64244",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[433444, 8652, 436, 8, 394, "Subsection",ExpressionUUID->"64a0096a-62c4-4dfe-a73d-d3b1683d6607",
 InitializationCell->True,
 InitializationGroup->True],
Cell[433883, 8662, 485, 9, 273, "Text",ExpressionUUID->"de1433af-dd80-4d78-b6fc-56d78468b370"],
Cell[CellGroupData[{
Cell[434393, 8675, 468, 8, 312, "Subsubsection",ExpressionUUID->"3f7cdd2f-8158-424f-a000-17ea88e93dea",
 InitializationCell->True,
 InitializationGroup->True],
Cell[434864, 8685, 1060, 24, 632, "Input",ExpressionUUID->"285d8a40-c18a-46c7-93a0-ca4c807e226a",
 InitializationCell->True],
Cell[435927, 8711, 364, 9, 419, "Input",ExpressionUUID->"8f90799d-9586-4bd2-9efc-3e1f2fd6f6a1",
 InitializationCell->True],
Cell[436294, 8722, 1055, 21, 622, "Input",ExpressionUUID->"08f2949f-5863-45aa-a582-c661b49580ee",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[437386, 8748, 528, 9, 312, "Subsubsection",ExpressionUUID->"a0a62de0-d7c6-4ed9-bbec-c5737b5e3a48",
 InitializationCell->True,
 InitializationGroup->True],
Cell[437917, 8759, 837, 18, 622, "Input",ExpressionUUID->"b7a1d103-b035-400e-9ff4-93150978c34e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[438803, 8783, 742, 12, 394, "Subsection",ExpressionUUID->"1333aaa1-e0ee-4474-a9b1-9eb1ae50c7e4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[439548, 8797, 615, 19, 647, "Input",ExpressionUUID->"2ee30382-0cc5-43cf-bbd7-77f006aed778",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[440200, 8821, 565, 10, 394, "Subsection",ExpressionUUID->"312965f7-544f-420a-bb49-0f67bdcc49a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[440768, 8833, 1552, 38, 1589, "Input",ExpressionUUID->"d3f1afd2-9d40-41d9-b66e-e67220be009d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[442369, 8877, 553, 10, 67, "Section",ExpressionUUID->"50765f18-39a8-47e8-b017-ae15ef9230d7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[442947, 8891, 444, 8, 90, "Subsection",ExpressionUUID->"8f854eaa-060a-468f-beff-cd754e2e2d2e",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[443394, 8901, 1420, 30, 163, "Input",ExpressionUUID->"55ad17c1-2927-46a1-83bc-3f362dc5d1f4",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[444851, 8936, 444, 8, 67, "Subsection",ExpressionUUID->"b6cbd283-2b5f-472c-b4d3-7688f3319c3e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[445298, 8946, 1453, 32, 817, "Input",ExpressionUUID->"fad9a06f-051d-4e88-a142-e30b5553d251",
 InitializationCell->True,
 InitializationGroup->True],
Cell[446754, 8980, 1519, 35, 870, "Input",ExpressionUUID->"8a505442-9e01-451b-b28e-853c8489ce90",
 InitializationCell->True],
Cell[448276, 9017, 2143, 43, 1774, "Input",ExpressionUUID->"21be2647-50fa-4f24-a085-bd73e32017b4",
 InitializationCell->True],
Cell[450422, 9062, 2450, 48, 1384, "Input",ExpressionUUID->"727a5e3b-2cb9-4a6c-8328-7aa248bb7751",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[452909, 9115, 576, 10, 67, "Subsection",ExpressionUUID->"6bd78f07-0ab9-49eb-8373-0ecb0348e7f6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[453488, 9127, 187, 3, 273, "Text",ExpressionUUID->"9f08c1e7-8117-40de-8b18-c501f538a16a"],
Cell[453678, 9132, 4219, 75, 3493, "Input",ExpressionUUID->"be4deb83-32cf-4b56-b970-cdb5ca6179d1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[457934, 9212, 205, 4, 67, "Subsection",ExpressionUUID->"46188a5a-9d1f-48f4-a1ff-87de418c0e70"],
Cell[CellGroupData[{
Cell[458164, 9220, 173, 3, 312, "Subsubsection",ExpressionUUID->"0f9918c5-6c6f-468f-9e22-60f39b46b9ba"],
Cell[458340, 9225, 175, 3, 273, "Text",ExpressionUUID->"e9ce6780-0f06-4588-bc20-afed53181c25"],
Cell[458518, 9230, 985, 26, 1009, "Input",ExpressionUUID->"a45333b1-8198-4297-8ae5-2c0554bde34c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[459540, 9261, 181, 3, 244, "Subsubsection",ExpressionUUID->"984f8220-c979-404e-8841-f8ca333ec593"],
Cell[459724, 9266, 5984, 106, 3866, "Input",ExpressionUUID->"760b888b-af5e-41e1-b3d9-4cc152a8811e",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[465711, 9374, 1066, 28, 822, "Input",ExpressionUUID->"f2b71e02-d9e5-4d0e-a5f6-6f558dc9b501",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[466826, 9408, 802, 12, 67, "Subsection",ExpressionUUID->"9923f3a0-4779-451a-93c0-4a28471c8f27",
 InitializationCell->True],
Cell[467631, 9422, 1348, 31, 1240, "Input",ExpressionUUID->"5b080d7e-b5d4-4442-8cdd-197e16ea94b7",
 InitializationCell->True],
Cell[468982, 9455, 1521, 33, 1190, "Input",ExpressionUUID->"4cddf580-d8d9-44e3-b960-2733864f45bf",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[470552, 9494, 753, 12, 67, "Section",ExpressionUUID->"b478de86-28af-4223-aa79-2dc2542bca04",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[471330, 9510, 660, 11, 394, "Subsection",ExpressionUUID->"caa590e1-a549-44ff-b9b1-58cac4fc9988",
 InitializationCell->True,
 InitializationGroup->True],
Cell[471993, 9523, 245, 4, 273, "Text",ExpressionUUID->"d27ee4a2-54ad-4506-a384-7c9d0f7a1e40"],
Cell[472241, 9529, 1068, 26, 647, "Input",ExpressionUUID->"1d3837d9-6cd5-46fc-8118-c00419878b83",
 InitializationCell->True],
Cell[473312, 9557, 1192, 29, 839, "Input",ExpressionUUID->"b37e18ad-aebc-4944-a93b-6bedf98b659e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[474541, 9591, 1216, 18, 312, "Subsection",ExpressionUUID->"9d35b706-c567-4a11-b81e-9f76e3c0511e",
 InitializationCell->True],
Cell[475760, 9611, 1726, 41, 1819, "Input",ExpressionUUID->"70d21797-dc56-425e-a6af-c9c394391ee4",
 InitializationCell->True],
Cell[477489, 9654, 1331, 33, 822, "Input",ExpressionUUID->"ca5848f8-f2a5-4411-a522-545abe191509",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[478881, 9694, 345, 8, 41, "Subsubtitle",ExpressionUUID->"254923df-e731-40b2-b4c8-9bba3fc82e59",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[479251, 9706, 897, 13, 36, "Section",ExpressionUUID->"76484171-2659-4443-9db2-d994384cff23",
 InitializationCell->True],
Cell[480151, 9721, 342, 7, 35, "Text",ExpressionUUID->"4711ce1d-1775-4a66-a752-076257191420"],
Cell[480496, 9730, 4432, 86, 425, "Input",ExpressionUUID->"92425591-44aa-4a55-91a5-a262d9b85221",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[484965, 9821, 379, 7, 36, "Section",ExpressionUUID->"67054de3-d034-429f-8938-a8035f93fdf3",
 InitializationCell->True],
Cell[485347, 9830, 268, 6, 58, "Text",ExpressionUUID->"90011e48-77a2-479b-8a87-4f04234b37b0"],
Cell[CellGroupData[{
Cell[485640, 9840, 382, 7, 54, "Subsection",ExpressionUUID->"90104e3a-2ce4-4f38-8fe5-741df3504546",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[486047, 9851, 196, 3, 45, "Subsubsection",ExpressionUUID->"564eaf6b-9abc-4e42-8b51-dbbf61cff079"],
Cell[486246, 9856, 1215, 24, 1781, "Input",ExpressionUUID->"db04cdce-cf77-4e71-b033-cb8395c27c31",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[487498, 9885, 276, 4, 37, "Subsubsection",ExpressionUUID->"eaf2b11d-2c0b-45f5-94f9-6d630f23be99"],
Cell[487777, 9891, 1489, 34, 1781, "Input",ExpressionUUID->"ab3e54b4-9189-4301-abb7-26670af9915b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[489303, 9930, 499, 8, 37, "Subsubsection",ExpressionUUID->"8798b992-a42a-4bfc-a587-982dce1b434f",
 InitializationCell->True],
Cell[489805, 9940, 1574, 33, 1781, "Input",ExpressionUUID->"1c2c5689-2d2b-497a-b9fb-4fc49b0399ab",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[491416, 9978, 846, 14, 37, "Subsubsection",ExpressionUUID->"eb162830-5f18-4e97-b31a-65279adb2b1d",
 InitializationCell->True],
Cell[492265, 9994, 1457, 29, 1781, "Input",ExpressionUUID->"c25048a9-8818-4b9f-8e15-128b4e2f9566",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[493771, 10029, 934, 15, 54, "Subsection",ExpressionUUID->"be669a25-7196-4433-b989-8bb5c636bc38",
 InitializationCell->True],
Cell[494708, 10046, 3799, 66, 173, "Input",ExpressionUUID->"734b9550-3557-4a62-9a31-931ead3b5aad",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[498544, 10117, 868, 14, 54, "Subsection",ExpressionUUID->"cf78a53d-6d55-4aa9-bbbb-fae716b94ae7",
 InitializationCell->True],
Cell[499415, 10133, 3293, 55, 152, "Input",ExpressionUUID->"6ccad821-84c5-4d90-b635-2d52298b43f0",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[502745, 10193, 751, 12, 54, "Subsection",ExpressionUUID->"b5db813f-d984-4df5-a0cf-df507bc1b2de",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[503521, 10209, 816, 13, 45, "Subsubsection",ExpressionUUID->"7b26618d-e2c1-48e1-8907-f35b8a30da27",
 InitializationCell->True],
Cell[504340, 10224, 210, 4, 87, "Text",ExpressionUUID->"f9b5e0fe-374a-4d63-b892-ade2f74765a8",
 InitializationCell->True],
Cell[504553, 10230, 3564, 68, 669, "Input",ExpressionUUID->"5baac135-2109-4f7d-8e09-4e737fa7dc3e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[508154, 10303, 754, 12, 37, "Subsubsection",ExpressionUUID->"2f20d931-0425-47da-9d93-3c8e4eae6b1f",
 InitializationCell->True],
Cell[508911, 10317, 221, 4, 35, "Text",ExpressionUUID->"6ee8e422-a63a-46c4-b959-c0c08921bd04",
 InitializationCell->True],
Cell[509135, 10323, 6026, 114, 425, "Input",ExpressionUUID->"a542dc30-fc41-48de-9ed6-412ebf6b6a26",
 InitializationCell->True],
Cell[515164, 10439, 199, 4, 35, "Text",ExpressionUUID->"521ad118-e593-4413-ab61-5cb63b8b436d",
 InitializationCell->True],
Cell[515366, 10445, 5899, 113, 446, "Input",ExpressionUUID->"c56dbc6b-1695-46d3-a9bb-4c583261b0c7",
 InitializationCell->True],
Cell[521268, 10560, 253, 6, 35, "Text",ExpressionUUID->"128a39cc-a4d2-489a-83d6-e9ced3e587b1",
 InitializationCell->True],
Cell[521524, 10568, 4072, 78, 446, "Input",ExpressionUUID->"90eb0585-4919-47e4-b7cb-99c53cc3dbb5",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[525645, 10652, 703, 12, 54, "Subsection",ExpressionUUID->"b14e5037-52b5-4ec7-bc97-5363fdfecab0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[526373, 10668, 867, 14, 39, "Subsubsection",ExpressionUUID->"0901d5cd-e9b7-474c-8df8-d709863d576b",
 InitializationCell->True],
Cell[527243, 10684, 267, 4, 87, "Text",ExpressionUUID->"4da2e967-98f7-4ace-bdf8-fb98e720097c",
 InitializationCell->True],
Cell[527513, 10690, 4558, 84, 1132, "Input",ExpressionUUID->"f5c639fe-83e4-4086-96c4-056927be67fa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[532108, 10779, 706, 12, 33, "Subsubsection",ExpressionUUID->"1845626c-5b46-492b-82d0-a90a53b56b8d",
 InitializationCell->True],
Cell[532817, 10793, 259, 5, 30, "Text",ExpressionUUID->"d4cb4266-035d-421f-902a-3d9e18f1f780",
 InitializationCell->True],
Cell[533079, 10800, 8817, 204, 870, "Input",ExpressionUUID->"1f200501-a797-4a2a-8176-6e67a7221652",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[541945, 11010, 1162, 17, 38, "Subsection",ExpressionUUID->"68464f96-2d44-468c-a6d0-ae69202fef1a",
 InitializationCell->True],
Cell[543110, 11029, 310, 5, 35, "Text",ExpressionUUID->"761a2103-e188-45a8-b062-5419d40f1887",
 InitializationCell->True],
Cell[543423, 11036, 5366, 101, 593, "Input",ExpressionUUID->"0e956e70-7b47-47b4-a185-3634db5e4f53",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[548826, 11142, 1152, 17, 54, "Subsection",ExpressionUUID->"ae6ec5a0-ae63-433b-8d61-4ba1d93eb72a",
 InitializationCell->True],
Cell[549981, 11161, 3219, 57, 2351, "Input",ExpressionUUID->"1a6eed37-acbd-4a07-9d25-7621755abb73",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[553249, 11224, 891, 13, 36, "Section",ExpressionUUID->"95214c48-b2ce-49bf-b313-bae0ee31cbbc",
 InitializationCell->True],
Cell[554143, 11239, 236, 4, 273, "Text",ExpressionUUID->"db057a4d-51b6-40b8-a105-f2b4c5994857"],
Cell[554382, 11245, 2286, 50, 2531, "Input",ExpressionUUID->"916f8afc-f973-41a4-a3a1-24bed725d26b",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[556717, 11301, 344, 8, 41, "Subsubtitle",ExpressionUUID->"9d8cbefe-3193-492f-95f4-55a2b865bf25",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[557064, 11311, 276, 4, 30, "Text",ExpressionUUID->"7cfb3568-1d5e-46f9-9931-0c1fc9152798"],
Cell[CellGroupData[{
Cell[557365, 11319, 402, 7, 33, "Section",ExpressionUUID->"c96012b0-6b36-40a4-9397-9a9563f42dc7",
 InitializationCell->True],
Cell[557770, 11328, 557, 15, 46, "Input",ExpressionUUID->"84dfd794-c084-4d2b-90e1-df0629fe93b0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[558364, 11348, 380, 6, 33, "Section",ExpressionUUID->"e6c85e2a-998c-42e7-8313-9c85c8828f51",
 InitializationCell->True],
Cell[558747, 11356, 4878, 87, 237, "Input",ExpressionUUID->"666d159e-cf7e-4c31-9869-866948cab83e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[563662, 11448, 442, 7, 33, "Section",ExpressionUUID->"661ef741-6423-4eaa-ba05-c752e5f34844",
 InitializationCell->True],
Cell[564107, 11457, 2590, 58, 256, "Input",ExpressionUUID->"6df968dc-7387-42d1-bbf9-de7e5b8fe673",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[566734, 11520, 455, 7, 33, "Section",ExpressionUUID->"baf6e6ea-1dd3-4893-bab8-728952764808",
 InitializationCell->True],
Cell[567192, 11529, 11497, 218, 671, "Input",ExpressionUUID->"761938c6-52c0-4444-a0d3-dfb99340348a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[578726, 11752, 496, 8, 33, "Section",ExpressionUUID->"365c781d-15a6-46dc-9d90-294f3dfcbdae",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[579247, 11764, 233, 4, 43, "Subsection",ExpressionUUID->"2ef8cae9-2bfc-4b0d-b27e-ed0c4828e184",
 InitializationCell->True],
Cell[579483, 11770, 5757, 115, 4630, "Input",ExpressionUUID->"9fa174c3-93bc-45a6-82e4-1e6769eb7b15",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[585277, 11890, 228, 4, 35, "Subsection",ExpressionUUID->"3b0ade06-e5df-4296-b065-5c33e37e1036"],
Cell[585508, 11896, 13731, 261, 447, "Input",ExpressionUUID->"4d1bfe6e-8753-4e36-9acc-d7baa39abb3e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[599276, 12162, 453, 7, 35, "Subsection",ExpressionUUID->"7b35a443-6bf4-4f48-acb4-1b6e56c68358",
 InitializationCell->True],
Cell[599732, 12171, 3958, 79, 3112, "Input",ExpressionUUID->"cbf4724d-f611-4cc1-ace4-48e98f0ee9c7",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[603751, 12257, 379, 9, 41, "Subsubtitle",ExpressionUUID->"2c86ca25-06cf-4921-bde2-60e7d5a37cb0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[604133, 12268, 363, 9, 669, "Input",ExpressionUUID->"ac40bb1e-1c4a-4a79-a3fb-9db2dbddbfb9",
 InitializationCell->True],
Cell[604499, 12279, 416, 10, 669, "Input",ExpressionUUID->"4965b36b-4a9e-4f2d-a857-8ff981f8d24f",
 InitializationCell->True],
Cell[604918, 12291, 368, 9, 878, "Input",ExpressionUUID->"6a168efe-bb73-4b11-8d1c-cd937e0f46b6",
 InitializationCell->True],
Cell[605289, 12302, 495, 10, 878, "Input",ExpressionUUID->"d1dfe1b8-f416-4798-adbe-564661810e43",
 InitializationCell->True],
Cell[605787, 12314, 550, 11, 878, "Input",ExpressionUUID->"ccf85bb5-94fc-4ab8-9a4d-e2f609dffcb4",
 InitializationCell->True],
Cell[606340, 12327, 554, 11, 878, "Input",ExpressionUUID->"f91f7d86-82d6-4d11-88c9-b72eb9cf77bd",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[606943, 12344, 519, 9, 69, "Subtitle",ExpressionUUID->"a3fce764-8237-4806-828e-c5c96368fe82",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[607487, 12357, 380, 8, 44, "Subsubtitle",ExpressionUUID->"2f35ec36-9719-4528-97db-f9c7465a420a",
 Evaluatable->False,
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True,
 InitializationGroup->True],
Cell[607870, 12367, 3862, 67, 370, "Input",ExpressionUUID->"1c368a99-6708-4ac9-a5f7-887bd816843f",
 CellGroupingRules->{"GroupTogetherGrouping", 10000.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[611769, 12439, 346, 8, 44, "Subsubtitle",ExpressionUUID->"81292e76-2d50-433b-aa5e-e8962f889656",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[612140, 12451, 513, 9, 67, "Section",ExpressionUUID->"a48d7fc8-ed06-427b-b4dc-01d920af613e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[612678, 12464, 436, 8, 394, "Subsection",ExpressionUUID->"7420656a-896d-423e-b871-e855f12aef30",
 InitializationCell->True,
 InitializationGroup->True],
Cell[613117, 12474, 485, 9, 273, "Text",ExpressionUUID->"100fcd17-e5e6-4abb-8e5a-cc157f821817"],
Cell[CellGroupData[{
Cell[613627, 12487, 468, 8, 312, "Subsubsection",ExpressionUUID->"e821ef8a-a1e9-431e-b9d3-a0bdb51aa1bc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[614098, 12497, 1375, 28, 822, "Input",ExpressionUUID->"dbf136e4-ba5c-454c-88a2-ff3242fffef3",
 InitializationCell->True],
Cell[615476, 12527, 391, 9, 419, "Input",ExpressionUUID->"5625a0e9-c8a1-42ad-bc8f-397b012004f4",
 InitializationCell->True],
Cell[615870, 12538, 1297, 25, 817, "Input",ExpressionUUID->"29ce9761-01bc-4b49-8866-390b0b9f1136",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[617204, 12568, 528, 9, 312, "Subsubsection",ExpressionUUID->"8933fe16-69b5-4c1e-b79b-b1e07f21d746",
 InitializationCell->True,
 InitializationGroup->True],
Cell[617735, 12579, 1132, 22, 419, "Input",ExpressionUUID->"e7abe4ab-31b2-468d-8a0b-326458ff4e05",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[618916, 12607, 742, 12, 394, "Subsection",ExpressionUUID->"ec50548b-d260-439c-a822-e3a8981f95a4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[619661, 12621, 644, 19, 647, "Input",ExpressionUUID->"595d716c-b96e-4456-8a47-cead2d84b129",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[620354, 12646, 553, 10, 67, "Section",ExpressionUUID->"6ba7d8e6-3d08-4dca-b845-3ffdbdb83267",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[620932, 12660, 444, 8, 90, "Subsection",ExpressionUUID->"f04fef30-fe17-4bdf-9d9a-7f22e9e8aee5",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[621379, 12670, 1583, 32, 211, "Input",ExpressionUUID->"8deb804a-b527-42fc-ad7b-abb27ca73a0d",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[622999, 12707, 444, 8, 67, "Subsection",ExpressionUUID->"16a3b201-b2ad-442a-9ea7-66add30ec7df",
 InitializationCell->True,
 InitializationGroup->True],
Cell[623446, 12717, 183, 3, 273, "Text",ExpressionUUID->"f9722871-913f-415b-9a97-bdfa518e3559"],
Cell[623632, 12722, 1807, 38, 1009, "Input",ExpressionUUID->"52916939-8bc6-4dc0-8dc3-11d1b5124302",
 InitializationCell->True,
 InitializationGroup->True],
Cell[625442, 12762, 1591, 35, 870, "Input",ExpressionUUID->"ca9d005d-cc20-40f9-9989-f1893a129fcd",
 InitializationCell->True],
Cell[627036, 12799, 2488, 48, 1384, "Input",ExpressionUUID->"1a7619d0-b0e7-4348-8f77-e50209d553f8",
 InitializationCell->True],
Cell[629527, 12849, 2388, 46, 1384, "Input",ExpressionUUID->"782172be-e475-4a87-9891-aa85b87fdaad",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[631952, 12900, 576, 10, 67, "Subsection",ExpressionUUID->"7c323de9-f405-41e3-a28d-536f476d7e42",
 InitializationCell->True,
 InitializationGroup->True],
Cell[632531, 12912, 187, 3, 54, "Text",ExpressionUUID->"78b6b7f4-6e43-40fd-af60-85fef6276ac9"],
Cell[632721, 12917, 4532, 79, 924, "Input",ExpressionUUID->"0a33dd7f-8bc4-45e8-a47b-2b99410f75ab",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[637290, 13001, 205, 4, 67, "Subsection",ExpressionUUID->"b3961c33-17a3-4ef7-af13-46dda12bebff"],
Cell[CellGroupData[{
Cell[637520, 13009, 173, 3, 67, "Subsubsection",ExpressionUUID->"5d8e466c-457c-4450-bea7-83118095d7d3"],
Cell[637696, 13014, 175, 3, 54, "Text",ExpressionUUID->"cac74b53-7bf4-4c65-b0eb-4a4c7fa8cd50"],
Cell[637874, 13019, 1032, 26, 257, "Input",ExpressionUUID->"f5a8aa6b-340b-4bb5-b929-8185018c9b97",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[638943, 13050, 181, 3, 48, "Subsubsection",ExpressionUUID->"336f8eee-d56e-4e84-9763-badc7c571660"],
Cell[639127, 13055, 5699, 99, 817, "Input",ExpressionUUID->"2228ee64-c620-46ac-a52c-b97f503cc63b",
 CellGroupingRules->{GroupTogetherGrouping, 10001.},
 InitializationCell->True],
Cell[644829, 13156, 1120, 29, 211, "Input",ExpressionUUID->"38b7489c-2e91-4836-be05-a72f4034822c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[645998, 13191, 853, 13, 67, "Subsection",ExpressionUUID->"8d69614d-8c25-45a1-a6e8-d1879fb63984",
 InitializationCell->True],
Cell[646854, 13206, 2902, 49, 257, "Input",ExpressionUUID->"a089cae8-360c-4ebc-ab6e-b7a3dedaed71",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[649805, 13261, 753, 12, 67, "Section",ExpressionUUID->"377e4bc9-8e54-4ae8-90c7-ceb1e025bbc9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[650583, 13277, 660, 11, 404, "Subsection",ExpressionUUID->"d5762b11-1182-445c-9fe0-3ac265e3fab0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[651246, 13290, 245, 4, 7839, "Text",ExpressionUUID->"4096d934-d6f2-449e-9e54-942e615de98f"],
Cell[651494, 13296, 1444, 31, 12216, "Input",ExpressionUUID->"70f17115-c7d4-4b5f-a24c-2e0c2fb8df3d",
 InitializationCell->True],
Cell[652941, 13329, 1859, 38, 17672, "Input",ExpressionUUID->"d9790879-a7ec-4438-a4ea-ec92aba7a797",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[654837, 13372, 1216, 18, 312, "Subsection",ExpressionUUID->"ffa01b71-4cac-4078-b946-809d32a19547",
 InitializationCell->True],
Cell[656056, 13392, 2007, 44, 2849, "Input",ExpressionUUID->"95e5298f-e828-443d-89cd-02c13a76bcdd",
 InitializationCell->True],
Cell[658066, 13438, 1835, 38, 1275, "Input",ExpressionUUID->"77c14ee7-14bb-44c6-aec0-451621991e8c",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[659962, 13483, 386, 9, 44, "Subsubtitle",ExpressionUUID->"2e360c57-f5b6-4b56-b847-516bc108ff4f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[660373, 13496, 1202, 17, 39, "Section",ExpressionUUID->"926eec7d-a371-459f-9597-764280ab773c",
 InitializationCell->True],
Cell[661578, 13515, 10848, 178, 180, "Input",ExpressionUUID->"57a1dd1f-cf31-4618-9619-054603bab545",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[672463, 13698, 1311, 21, 39, "Section",ExpressionUUID->"6e1b672c-9843-4540-9706-66a87f4fd88a",
 InitializationCell->True],
Cell[673777, 13721, 13855, 217, 276, "Input",ExpressionUUID->"5ea9938f-fbe5-420d-9e8e-806569524e08",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[687669, 13943, 1106, 16, 39, "Section",ExpressionUUID->"a17ff792-f729-42ac-9a6e-9cc335e0efb0",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[688800, 13963, 382, 7, 49, "Subsection",ExpressionUUID->"f6cbb278-8e36-4a63-b74f-d5b765f87767",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[689207, 13974, 232, 4, 39, "Subsubsection",ExpressionUUID->"3a5273f8-2a09-4f9f-b833-c6d18b2d7ce2"],
Cell[CellGroupData[{
Cell[689464, 13982, 199, 3, 48, "Subsubsubsection",ExpressionUUID->"9fd6292e-6bb1-4fe9-9e32-a4801997f1dd"],
Cell[689666, 13987, 1243, 25, 18055, "Input",ExpressionUUID->"904e07ef-1b3f-4677-8599-959b77116422",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[690946, 14017, 279, 4, 37, "Subsubsubsection",ExpressionUUID->"8f6e01e3-911a-472a-92f7-eb9af523ea21"],
Cell[691228, 14023, 1450, 33, 211, "Input",ExpressionUUID->"dedeb958-d714-4b71-a9b6-34b8baa6516b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[692715, 14061, 502, 8, 37, "Subsubsubsection",ExpressionUUID->"bbc4a888-4a4f-4e68-9ddd-77a6f339b46b",
 InitializationCell->True],
Cell[693220, 14071, 1546, 33, 260, "Input",ExpressionUUID->"e4b57f79-b5ce-4981-b2fd-9b02027d16dc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[694803, 14109, 868, 14, 37, "Subsubsubsection",ExpressionUUID->"1a079955-f343-47b1-a193-2e8501850801",
 InitializationCell->True],
Cell[695674, 14125, 1565, 33, 260, "Input",ExpressionUUID->"07c6ab14-cfe7-4584-a230-c57887e11898",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[697288, 14164, 284, 4, 33, "Subsubsection",ExpressionUUID->"2636ce11-4143-43db-9f5b-e9486f0fa80d"],
Cell[CellGroupData[{
Cell[697597, 14172, 199, 3, 48, "Subsubsubsection",ExpressionUUID->"fb4c5abd-7700-4593-bbcb-665f99c1ac17"],
Cell[697799, 14177, 1468, 30, 18055, "Input",ExpressionUUID->"037fb091-64b6-49d2-a0d8-e63c49dcdfd0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[699304, 14212, 279, 4, 37, "Subsubsubsection",ExpressionUUID->"3d0f0f47-592c-4e26-b6af-7a74691bf3be"],
Cell[699586, 14218, 1674, 38, 23210, "Input",ExpressionUUID->"4752cf4d-a71f-41c1-a250-ddef1968a073",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[701297, 14261, 502, 8, 37, "Subsubsubsection",ExpressionUUID->"f747c90c-4e23-43cf-ae36-3e38125a69c9",
 InitializationCell->True],
Cell[701802, 14271, 1768, 38, 23210, "Input",ExpressionUUID->"c130997e-4240-4c34-8a0b-bb84d4c06c41",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[703607, 14314, 849, 14, 37, "Subsubsubsection",ExpressionUUID->"54bca038-8dcd-4cd5-ad6b-2f38357832e0",
 InitializationCell->True],
Cell[704459, 14330, 1632, 35, 23210, "Input",ExpressionUUID->"44f60a4a-2f88-46a0-b816-6e3a95d44b71",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[706152, 14372, 201, 4, 41, "Subsection",ExpressionUUID->"49481dc1-6661-4109-812a-4a82fc4dfe88",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[706378, 14380, 879, 14, 39, "Subsubsection",ExpressionUUID->"81c6655a-5b31-460f-8e67-13761594aabe",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[707282, 14398, 819, 13, 28, "Subsubsubsection",ExpressionUUID->"5ba9e445-633c-4305-96eb-2c852f007df7",
 InitializationCell->True],
Cell[708104, 14413, 210, 4, 30, "Text",ExpressionUUID->"f973ebcc-fe2b-47ff-8546-251290655f6c",
 InitializationCell->True],
Cell[708317, 14419, 3883, 73, 143, "Input",ExpressionUUID->"dab3a0b6-0ff0-43d6-8eb6-03d6d26c6df7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[712237, 14497, 757, 12, 22, "Subsubsubsection",ExpressionUUID->"853ebb36-d966-4484-a46f-c6b67eb37ebd",
 InitializationCell->True],
Cell[712997, 14511, 221, 4, 30, "Text",ExpressionUUID->"417851fe-4590-4f9d-a755-8c72ad00f9f9",
 InitializationCell->True],
Cell[713221, 14517, 6799, 128, 343, "Input",ExpressionUUID->"243212bf-afe3-49bc-9cb5-bac7ac0b871c",
 InitializationCell->True],
Cell[720023, 14647, 199, 4, 30, "Text",ExpressionUUID->"ad3a05fd-8988-44e5-b70a-53ed08bad520",
 InitializationCell->True],
Cell[720225, 14653, 5942, 112, 301, "Input",ExpressionUUID->"b3548611-0544-4438-809e-7e46ea9f123c",
 InitializationCell->True],
Cell[726170, 14767, 253, 6, 30, "Text",ExpressionUUID->"e800efb7-5360-4ace-b483-f9403350dee8",
 InitializationCell->True],
Cell[726426, 14775, 3864, 76, 175, "Input",ExpressionUUID->"a4941bc0-51ed-4d4b-94f1-989041b81c1b",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[730339, 14857, 809, 13, 39, "Subsubsection",ExpressionUUID->"9a76ffff-d4b7-40cd-a50c-af9d54adcef5",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[731173, 14874, 870, 14, 28, "Subsubsubsection",ExpressionUUID->"c95cf2ca-d51a-4a90-9f52-c95eff97041c",
 InitializationCell->True],
Cell[732046, 14890, 4868, 90, 238, "Input",ExpressionUUID->"dd29f633-53e6-4fa0-8c0a-e6ab6c74e7b8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[736951, 14985, 709, 12, 22, "Subsubsubsection",ExpressionUUID->"baefdb70-69cd-47ac-9eca-17145ec37b14",
 InitializationCell->True],
Cell[737663, 14999, 7989, 184, 492, "Input",ExpressionUUID->"4cd35e77-23b9-431a-9c28-bf396b1f034f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[745701, 15189, 871, 14, 33, "Subsubsection",ExpressionUUID->"e7170884-ad16-40f5-ac7c-28cf4dcfefcf",
 InitializationCell->True],
Cell[746575, 15205, 3472, 59, 67, "Input",ExpressionUUID->"99cdf1f7-acb9-45f4-b867-079d43815bd6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[750084, 15269, 937, 15, 33, "Subsubsection",ExpressionUUID->"1f28ffcd-a6b2-4135-8a76-e03e5d2caa70",
 InitializationCell->True],
Cell[751024, 15286, 3756, 67, 105, "Input",ExpressionUUID->"fce35cfe-66e0-4521-a8ee-b0edbcacc772",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[754817, 15358, 1165, 17, 33, "Subsubsection",ExpressionUUID->"adb5873e-e7f0-4d5e-b385-45a49a7b2280",
 InitializationCell->True],
Cell[755985, 15377, 6779, 130, 295, "Input",ExpressionUUID->"165e4a7f-0d40-4a2c-9545-6135d9e9cb51",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[762801, 15512, 1155, 17, 33, "Subsubsection",ExpressionUUID->"97fccdc3-157a-439d-80b2-8704d16608d0",
 InitializationCell->True],
Cell[763959, 15531, 3304, 57, 23309, "Input",ExpressionUUID->"49fad421-7b5c-4d39-9014-55a6d96ad51c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[767312, 15594, 205, 4, 41, "Subsection",ExpressionUUID->"c4fa3813-65b4-48e2-abd2-47e2808bc321",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[767542, 15602, 978, 15, 39, "Subsubsection",ExpressionUUID->"38cbc6ce-9ec7-48e7-852d-828fccc3a559",
 InitializationCell->True],
Cell[768523, 15619, 5607, 88, 105, "Input",ExpressionUUID->"c747221b-2183-49ca-8833-a2d580decc53",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[774167, 15712, 930, 15, 33, "Subsubsection",ExpressionUUID->"4f3fb50a-cb01-4846-ae18-e8b8db00ea59",
 InitializationCell->True],
Cell[775100, 15729, 376, 8, 30, "Text",ExpressionUUID->"9746e053-748e-414b-a512-e86f71dc4b3f",
 InitializationCell->True],
Cell[775479, 15739, 7741, 139, 295, "Input",ExpressionUUID->"4bda44a9-f831-479c-b1db-0b8e012e302c",
 InitializationCell->True],
Cell[783223, 15880, 6224, 115, 276, "Input",ExpressionUUID->"6d3a1b59-29e5-49f4-9e37-51209a3a0b20",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[789484, 16000, 831, 13, 33, "Subsubsection",ExpressionUUID->"91025dbb-0f96-4171-86da-f6bde3d00978",
 InitializationCell->True],
Cell[790318, 16015, 8547, 192, 423, "Input",ExpressionUUID->"660afc13-c337-46a8-8cf3-f2e0d00e50fd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[798902, 16212, 1165, 17, 33, "Subsubsection",ExpressionUUID->"12ae27ab-4906-4bc1-b33a-5c141a0f466d",
 InitializationCell->True],
Cell[800070, 16231, 7463, 139, 295, "Input",ExpressionUUID->"79d7d651-7632-4b81-8b0d-d4cd3edeed26",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[807570, 16375, 1155, 17, 33, "Subsubsection",ExpressionUUID->"620b5637-2f8f-486b-a58b-6413a667cd77",
 InitializationCell->True],
Cell[808728, 16394, 3143, 56, 23309, "Input",ExpressionUUID->"e12c7588-d3aa-4d43-8aa4-c41d15de2263",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[811944, 16458, 379, 9, 44, "Subsubtitle",ExpressionUUID->"15f5551d-b619-4214-863b-c77baaa343cb",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[812326, 16469, 422, 10, 419, "Input",ExpressionUUID->"d37dfaee-007a-4eb2-be74-7ea22bf591f0",
 InitializationCell->True],
Cell[812751, 16481, 465, 10, 419, "Input",ExpressionUUID->"7528459c-a4f8-431c-a0ab-56527c831421",
 InitializationCell->True],
Cell[813219, 16493, 393, 9, 419, "Input",ExpressionUUID->"aaaa615a-95a6-4d68-9ecc-fbdcee1982e0",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[813661, 16508, 398, 9, 69, "Subtitle",ExpressionUUID->"4f06c22f-4d6d-433c-b933-118cdd69ac60",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[814084, 16521, 387, 8, 54, "Subsection",ExpressionUUID->"b26fef1e-d98e-4091-8e8f-d56636d5df1b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[814474, 16531, 768, 18, 66, "Input",ExpressionUUID->"ab5a20e7-99c3-4176-bc04-b60423b258d5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[815279, 16554, 261, 6, 38, "Subsection",ExpressionUUID->"81c8fdb7-f691-4fee-8b93-a0245d500047",
 InitializationCell->True,
 InitializationGroup->True],
Cell[815543, 16562, 676, 15, 46, "Input",ExpressionUUID->"41e81a89-3184-4e75-9f1d-3cee6ff21e4e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[816256, 16582, 268, 6, 38, "Subsection",ExpressionUUID->"60556e4e-afc7-43f9-a5ea-9e1b2ea63532",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[816549, 16592, 343, 6, 39, "Subsubsection",ExpressionUUID->"a143283c-df62-4863-b692-5005167d71f5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[816895, 16600, 1809, 38, 104, "Input",ExpressionUUID->"ca8ba07e-e00c-429f-981d-9fcbf03faa35",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[818741, 16643, 227, 5, 33, "Subsubsection",ExpressionUUID->"2716f51e-467a-49a8-9f63-ecc95f13c506",
 InitializationCell->True,
 InitializationGroup->True],
Cell[818971, 16650, 1285, 27, 104, "Input",ExpressionUUID->"bbee6f40-a618-4c2a-9071-c081ec6e1642",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[820293, 16682, 402, 7, 33, "Subsubsection",ExpressionUUID->"aa7a75da-fc07-45d6-83f5-e01cdaa45d97",
 InitializationCell->True,
 InitializationGroup->True],
Cell[820698, 16691, 1707, 43, 123, "Input",ExpressionUUID->"0383ab99-014b-4355-86a5-bed46c43ee3f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[822442, 16739, 337, 6, 33, "Subsubsection",ExpressionUUID->"d52be742-1256-462c-a3b9-a730c367ff09",
 InitializationCell->True,
 InitializationGroup->True],
Cell[822782, 16747, 1974, 39, 123, "Input",ExpressionUUID->"43b8e68e-2bbd-42cc-a619-855c9310cbc6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[824793, 16791, 389, 7, 33, "Subsubsection",ExpressionUUID->"9bffc3b4-259d-48ca-b03a-67e87986cf03",
 InitializationCell->True,
 InitializationGroup->True],
Cell[825185, 16800, 2136, 41, 104, "Input",ExpressionUUID->"9142e795-d083-4170-80f6-43b62f13690d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[827324, 16843, 2502, 50, 123, "Input",ExpressionUUID->"892497b2-42f1-405f-8c3b-2e77d85af5fa",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[829863, 16898, 442, 8, 33, "Subsubsection",ExpressionUUID->"3cbb778f-4db9-4b37-871a-e844d7a2a3d1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[830308, 16908, 795, 19, 66, "Input",ExpressionUUID->"6bc597a1-e0b9-4dcc-900f-44e91124335f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[831106, 16929, 2752, 71, 237, "Input",ExpressionUUID->"46e6deef-827c-4b8b-abb0-5484bb63eab7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[833895, 17005, 471, 9, 33, "Subsubsection",ExpressionUUID->"8e318481-0b2b-4bce-bb57-43a439a4ddd5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[834369, 17016, 3422, 67, 161, "Input",ExpressionUUID->"bfcb1ae4-69a5-47cf-862d-be40b3cc9189",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[837828, 17088, 215, 5, 33, "Subsubsection",ExpressionUUID->"9a783011-6200-4236-a91e-14f3be5117c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[838046, 17095, 596, 13, 46, "Input",ExpressionUUID->"0736af0d-0895-4fae-80b4-c74c5bb3a4d6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[838645, 17110, 444, 11, 46, "Input",ExpressionUUID->"5abdee30-aee4-41a5-b206-f86d3d68a7d6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[839092, 17123, 762, 15, 85, "Input",ExpressionUUID->"e4947290-311f-4a84-9b18-5e18514c1449",
 InitializationCell->True,
 InitializationGroup->True],
Cell[839857, 17140, 441, 11, 46, "Input",ExpressionUUID->"56d758be-eea2-4a9b-9a4c-b6c029894462",
 InitializationCell->True,
 InitializationGroup->True],
Cell[840301, 17153, 503, 12, 46, "Input",ExpressionUUID->"706c655c-735a-4283-9e31-707be0710fdb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[840807, 17167, 452, 11, 46, "Input",ExpressionUUID->"127299b4-6008-4ff9-ab23-112d2c2b8696",
 InitializationCell->True,
 InitializationGroup->True],
Cell[841262, 17180, 787, 15, 85, "Input",ExpressionUUID->"477c582a-5024-49c1-ac7f-651c98db57fc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[842052, 17197, 650, 13, 85, "Input",ExpressionUUID->"29d1df05-026d-4432-8609-a58b32761d45",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[842751, 17216, 267, 6, 38, "Subsection",ExpressionUUID->"5526c54c-fee8-43b2-870a-29f2a7efef17",
 InitializationCell->True,
 InitializationGroup->True],
Cell[843021, 17224, 14391, 285, 908, "Input",ExpressionUUID->"97f41005-d54a-4c63-96ef-12890977ef78",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[857461, 17515, 848, 13, 69, "Subtitle",ExpressionUUID->"8cdb6f09-8c84-4222-9bea-279d114c9325",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[858334, 17532, 823, 13, 41, "Subsubtitle",ExpressionUUID->"e9aa3f7b-5ea6-47a5-a69f-1f4d7b215e93",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[859182, 17549, 473, 8, 39, "Section",ExpressionUUID->"dd42dd87-04bf-4397-a1de-d458ca86c986",
 InitializationCell->True],
Cell[859658, 17559, 2096, 38, 5656, "Input",ExpressionUUID->"39bdfc6f-4066-46ef-8ec5-0d59f3d53253",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[861791, 17602, 421, 7, 39, "Section",ExpressionUUID->"0017f5fa-96b9-48a3-bb52-1aa73f3c1623",
 InitializationCell->True],
Cell[862215, 17611, 1304, 26, 347692, "Input",ExpressionUUID->"9b0c0325-4ced-41f9-87f6-35630f3f7bfc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[863556, 17642, 478, 8, 39, "Section",ExpressionUUID->"3d1d498d-b670-43b7-b3ee-7ea9f8abbeb2",
 InitializationCell->True],
Cell[864037, 17652, 1012, 23, 1787094, "Input",ExpressionUUID->"f8375f85-a2b1-4fdd-a3d6-799d306fe9e9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[865086, 17680, 567, 9, 39, "Section",ExpressionUUID->"3c7d6824-0e32-42d4-8dcf-15b81d4fe70b",
 InitializationCell->True],
Cell[865656, 17691, 955, 27, 2324, "Input",ExpressionUUID->"bd5f0fab-94e1-4e35-bf75-530fbb2073b3",
 InitializationCell->True],
Cell[866614, 17720, 925, 26, 2324, "Input",ExpressionUUID->"a7f47872-f453-4c53-bc26-fab704c8d844",
 InitializationCell->True],
Cell[867542, 17748, 921, 26, 2324, "Input",ExpressionUUID->"53807d1a-6b86-4bad-bb97-b43803b94367",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[868500, 17779, 543, 9, 47, "Section",ExpressionUUID->"4d7e7400-c15d-4684-a714-a3adae7b6908",
 InitializationCell->True],
Cell[869046, 17790, 243, 6, 30, "Text",ExpressionUUID->"7781963e-c381-4d84-8a53-6b9d79594ee1"],
Cell[869292, 17798, 415, 8, 65, "Text",ExpressionUUID->"bf321be0-13a8-434c-9aed-d7ff68f007a7"],
Cell[869710, 17808, 3181, 73, 409, "Input",ExpressionUUID->"4e9fa042-08c0-4f5e-b6f6-204cbf667a50",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[872928, 17886, 520, 9, 39, "Section",ExpressionUUID->"9cf7b9a0-cef2-434d-8d2b-b3bfe30510a7",
 InitializationCell->True],
Cell[873451, 17897, 351, 9, 347692, "Input",ExpressionUUID->"cca2518d-662a-43bf-a139-ca4907a378aa",
 InitializationCell->True],
Cell[873805, 17908, 371, 10, 347692, "Input",ExpressionUUID->"0c97358a-03b7-4187-aed6-d4c4335691ac",
 InitializationCell->True],
Cell[874179, 17920, 369, 10, 347692, "Input",ExpressionUUID->"8ba08249-d98f-4e9c-9d9c-b87ccce8d692",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[874609, 17937, 495, 9, 69, "Subtitle",ExpressionUUID->"78740f93-057b-48f6-929a-373e4d144efc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[875129, 17950, 180, 3, 44, "Subsection",ExpressionUUID->"a0f0d240-caec-43ef-b3f5-3ad5bd9ceb0d",
 InitializationCell->True],
Cell[875312, 17955, 324, 8, 347692, "Input",ExpressionUUID->"c1ec5107-ba5f-4c05-8790-2f60286049b3",
 InitializationCell->True],
Cell[875639, 17965, 435, 13, 347692, "Input",ExpressionUUID->"1cd638a6-5e8c-45fc-908c-b46203cfabeb",
 InitializationCell->True],
Cell[876077, 17980, 675, 19, 521716, "Input",ExpressionUUID->"0d5f6b51-542f-4294-9861-3315d7eac16a",
 InitializationCell->True],
Cell[876755, 18001, 698, 18, 521716, "Input",ExpressionUUID->"b27fa360-d178-4dec-93ea-e07104151611",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[877490, 18024, 239, 5, 36, "Subsection",ExpressionUUID->"ac483312-41b3-400b-8e75-7a3edd224857",
 InitializationCell->True],
Cell[877732, 18031, 2099, 45, 1474418, "Input",ExpressionUUID->"fa6eaed4-2529-4a65-8438-0c34a0cffcc5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[879868, 18081, 187, 4, 36, "Subsection",ExpressionUUID->"30bca2e1-d69d-449e-a5fb-65e64a571316",
 InitializationCell->True],
Cell[880058, 18087, 2232, 53, 1474418, "Input",ExpressionUUID->"98a3c2a7-2273-447d-b6a0-505c6ba1c0a8",
 InitializationCell->True],
Cell[882293, 18142, 1256, 30, 521716, "Input",ExpressionUUID->"32e5d9a8-cd1f-42dc-9825-787b168d6475",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[883586, 18177, 237, 5, 36, "Subsection",ExpressionUUID->"3b118f54-e4ce-4b1b-917b-c51e6ec31168",
 InitializationCell->True],
Cell[883826, 18184, 1197, 25, 347692, "Input",ExpressionUUID->"59db6a45-614f-41de-ace9-8a172cf3a3ff",
 InitializationCell->True],
Cell[885026, 18211, 1195, 25, 347692, "Input",ExpressionUUID->"dc5f8d1c-d25d-4d20-a7c3-334e5325b0f9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[886258, 18241, 185, 4, 36, "Subsection",ExpressionUUID->"b9380ab8-e561-40e3-90eb-ced03324461a",
 InitializationCell->True],
Cell[886446, 18247, 403, 10, 521716, "Input",ExpressionUUID->"6a1dc70e-adc6-44bf-8ef3-94adc3fdc884",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[886898, 18263, 182, 5, 69, "Subtitle",ExpressionUUID->"e59275d0-8471-43d8-b169-537e89f47377",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[887083, 18270, 299, 10, 489461, "Input",ExpressionUUID->"f18e4652-4cf6-4a46-b76f-f6c78278cffd",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[887431, 18286, 293, 7, 98, "Title",ExpressionUUID->"fec762f1-6cb2-4821-8258-72d0dc0afb6f",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[887749, 18297, 314, 5, 44, "Subsection",ExpressionUUID->"134eae83-15c0-4f75-9734-e48e9a9319b4"],
Cell[888066, 18304, 202, 3, 54, "Text",ExpressionUUID->"ee8e0438-76a0-41e2-ad86-2a942bebe077"]
}, Closed]],
Cell[CellGroupData[{
Cell[888305, 18312, 542, 8, 36, "Subsection",ExpressionUUID->"f1de883d-467a-4c62-86d5-7db27d64ffff"],
Cell[888850, 18322, 1020, 18, 682, "Text",ExpressionUUID->"6b2e90d1-4e0e-48b9-900b-78b00f8fe19b"]
}, Closed]],
Cell[CellGroupData[{
Cell[889907, 18345, 614, 9, 36, "Subsection",ExpressionUUID->"c9d1db5e-9bf1-4007-a918-924c8f990a77"],
Cell[890524, 18356, 587, 12, 273, "Text",ExpressionUUID->"722228d1-9a52-46f7-a5f4-eecd116295fe"]
}, Closed]],
Cell[891126, 18371, 603, 9, 36, "Subsection",ExpressionUUID->"8f66e857-d7f2-4248-ac85-2c4e426945c3"],
Cell[CellGroupData[{
Cell[891754, 18384, 637, 9, 36, "Subsection",ExpressionUUID->"de6addfa-f84a-4632-b3f8-db79d1555bcf"],
Cell[892394, 18395, 566, 10, 106, "Text",ExpressionUUID->"066a6164-c310-4561-8181-edd6ca842885"]
}, Closed]],
Cell[CellGroupData[{
Cell[892997, 18410, 720, 10, 36, "Subsection",ExpressionUUID->"30b4974b-9a05-442f-bd5e-1e18a95455ac"],
Cell[893720, 18422, 238, 6, 30, "Text",ExpressionUUID->"2baa4259-71e3-4224-922b-933530f6be12"],
Cell[893961, 18430, 182, 3, 30, "Text",ExpressionUUID->"4ea540ce-45c7-406b-8961-6063b049155b"]
}, Closed]],
Cell[CellGroupData[{
Cell[894180, 18438, 776, 11, 36, "Subsection",ExpressionUUID->"30b4974b-9a05-442f-bd5e-1e18a95455ac"],
Cell[894959, 18451, 287, 4, 30, "Text",ExpressionUUID->"2baa4259-71e3-4224-922b-933530f6be12"]
}, Closed]]
}, Closed]]
}
]
*)

