(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Simulations`Simulations`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"SD`Approximations`",
"SD`Propagation`",
"Events`Events`",
"Events`PulseSequence`",
"Interactions`Interactions`",
"Interactions`Hamiltonians`",
"Interactions`Relaxation`",
"Simulations`Polarization`",
"Signals`Signal`",
"General`Matrices`",
"General`Miscellaneous`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
Trajectory::usage="Trajectory[\[Rho]ini\[Rule]operator, events] generates a trajectory function for the expectation value of operator, when the initial density operator \[Rho]ini is propagated under the specified events.  Trajectory[\[Rho]ini\[Rule]{op1,op2..}, events] generates a set of trajectory functions for several different operators. 
The option NormalizationFactor is used to control the vertical scale of the trajectories. If NormalizationFactor\[Rule]number, the trajectories are divided by number. If NormalizationFactor\[Rule]operator, the trajectories are divided by the normalized LiouvilleBracket of \[Rho]ini and the reference operator. This syntax is useful when handling thermal equilibrium density operators. NormalizationFactor\[Rule]False disables the normalization. The option EnsembleAverage may be used to average the trajectories over a set of values for any parameter. In this case, the option InterpolationPoints specifies the number of points used for interpolation when combining the ensemble trajectories.
The output of Trajectory is one or more TrajectoryFunction objects.
";


(* ::Input::Initialization:: *)
TimePrecisionForPiecewiseInterpolation::usage="A small time shift which is used to handle time discontinuities when evaluating Piecewise interpolation of trajectories";


(* ::Input::Initialization:: *)
TrajectoryFunction::usage="TrajectoryFunction[timerange,trajectory] is a function which provides the value of an observable when evaluated at any time point within timerange. It is provided as the output of a Trajectory routine. A trajectory function trajfun may be plotted using syntax of the form Plot[trajfun[t],{t,tmin,tmax}]
";


(* ::Input::Initialization:: *)
TransformationAmplitude::usage="TransformationAmplitude[\[Rho]ini\[Rule]obs,events] generates the amplitude for transformation of an initial density operator \[Rho]ini into an observable obs. TransformationAmplitude[\[Rho]ini\[Rule]{op1,op2..}, events] generates a list of transformation amplitudes. The option BackgroundGenerator specifies the background generator for the calculation. The option EnsembleAverage may be used to specify a weighted average over an arbitrary variable involved in the event specifications or in the option BackgroundGenerator. See the usage message for EnsembleAverage.";


(* ::Input::Initialization:: *)
MaximumTransformationAmplitude::usage = "MaximumTransformationAmplitude has been superseded by TransformationAmplitudeBounds.";


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds::usage="TransformationAmplitudeBounds[\[Rho]ini\[Rule]obs] generates the bounds {min,max} on the possible amplitude for transformation of an initial density operator \[Rho]ini into an observable obs. MaximumTransformationAmplitude[\[Rho]ini\[Rule]{op1,op2..}] generates a set of transformation amplitude bounds.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::usage="TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p,pmin,pmax,dp},opts] generates a table of TransformationAmplitude values, varying the parameter p from pmin to pmax in steps of dp. The events or any of the option values may depend on p. The observable obs may be a list of operators, in which case several tables are calculated simultaneously. The syntax TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p,pmin,pmax,{np}},opts] may also be used, indicating the number of values np sampled between pmin and pmax.
The option BackgroundGenerator specifies the background evolution generator for the calculation. This may also depend on p.
The option EnsembleAverage may be used to specify a weighted average over an arbitrary variable involved in the event specifications or in any of the option values, including BackgroundGenerator. See the usage message for EnsembleAverage.
The option TableCoordinates specifies the point coordinates which are included in the output table. TableCoordinates\[Rule]<expr(p)> implements x-coordinates which are given by <expr(p)>, where <expr(p)> is an expression that depends on p, and p is the incremented parameter.
The output of TransformationAmplitudeTable with a single incremented parameter may be plotted directly using the ListPlot routine of Mathematica. 
TransformationAmplitudeTable may also employ several iterators, using syntax of the form TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p1,p1min,p1max,dp1},{p2,p2min,p2max,dp2}..,opts]. The coordinates may then be specified using TableCoordinates\[Rule]{<expr(p1)>,<expr(p2)>..}. The output of TransformationAmplitudeTable with two iterators may be plotted directly using the ListContourPlot and ListDensityPlot routines.
";


(* ::Input::Initialization:: *)
TableCoordinates::usage="TableCoordinates is an option for TransformationAmplitudeTable and specifies the coordinates of the output are calculated for each point in the table. The value of TableCoordinates may be a function of the iterators for TransformationAmplitudeTable."; 


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::usage="\!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rho]ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"obs\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"events\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) numerically optimizes a \!\(\*
StyleBox[\"TransformationAmplitude\",\nFontSlant->\"Italic\"]\) quantity with respect to parameters \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\), starting from initial parameter values \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\). 
The option rules \!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\) may include \!\(\*
StyleBox[\"BackgroundGenerator\",\nFontSlant->\"Italic\"]\) and any of the other usual option specifications for \!\(\*
StyleBox[\"TransformationAmplitude\",\nFontSlant->\"Italic\"]\). The values specified in \!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\) may depend on the parameters \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\\\\n\",\nFontSlant->\"Italic\"]\)The option rules \!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\) may include the directive \!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\) which constrains all parameters \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)to positive values. The syntax \!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)may be used to constrain only a subset of parameters to positive values. This is frequently required for pulse sequence delays, etc., which cannot take negative values. 
More general constraints may be implemented by using \!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rho]ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"obs\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"events\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1ini\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1min\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1max\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)subjects the parameter \!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\) to the constraint \!\(\*
StyleBox[\"p1min\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[NonBreakingSpace]\",\nFontSize->4,\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[LessEqual]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[NonBreakingSpace]\",\nFontSize->4,\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[NonBreakingSpace]\",\nFontSize->4,\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[LessEqual]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[NonBreakingSpace]\",\nFontSize->4,\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1max\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)If the maximum value \!\(\*
StyleBox[\"p1max\",\nFontSlant->\"Italic\"]\) is omitted, there is no upper constraint. Any of the parameters \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) may be constrained in this way.\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\) 
Constrained optimization is often computationally more intensive than unconstrained optimization.
\!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\) deploys the \!\(\*
StyleBox[\"Mathematica\",\nFontSlant->\"Italic\"]\) routine \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)to find a local minimum of the negative transformation amplitude, starting from a specified point. The rules specified in \!\(\*
StyleBox[\"opts\",\nFontSlant->\"Italic\"]\) may include specifications for \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\), including a value for the \!\(\*
StyleBox[\"Method\",\nFontSlant->\"Italic\"]\) option (see the documentation for \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\")\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\\\\n\",\nFontSlant->\"Italic\"]\)The output of \!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\) has the form \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"maxval\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"rules\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) where \!\(\*
StyleBox[\"maxval\",\nFontSlant->\"Italic\"]\) is the optimized value of the \!\(\*
StyleBox[\"TransformationAmplitude\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"rules\",\nFontSlant->\"Italic\"]\) specify the values of the optimized parameters. ";


(* ::Input::Initialization:: *)
ConstrainPositive::usage="\!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\). If \!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"or\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"All\",\nFontSlant->\"Italic\"]\), all variable parameters of \!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"are\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"constrained\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"to\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"positive\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\"values\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Plain\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Plain\"]\)This is frequently required for pulse sequence delays, etc., which cannot take negative values. The syntax \!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)may be used to constrain only a subset of parameters to positive values.";


(* ::Input::Initialization:: *)
Signal1D::usage="Signal1D[timing, options] simulates a 1D magnetic resonance signal. The parameter timing specifies the digitization of the sampled signal. There are several possible syntaxes for timing: (1) If timing has the form {tmin,tmax,\[Delta]t}, then the signal is sampled between time points tmin and tmax, with increments (dwell time) \[Delta]t. If tmin is omitted, the value 0 is used. (2) The parameter timing may also have the syntax {tmin,tmax,{nsample}}, where nsample is the number of sampling points in the interval [tmin,tmax]. The number of sampling points nsample may be an even integer or may  be specified using strings \"1k\", \"2k\" etc. If tmin is omitted, the value 0 is used. (3) timing may have the syntax {tmin,{\[Omega]SW,nsample}}, where \[Omega]SW is the spectral bandwidth in rad\[NonBreakingSpace]\!\(\*SuperscriptBox[\(s\), \(-1\)]\). The number of sampling points nsample may be an even integer, or may be specified using strings \"1k\", \"2k\" etc. If tmin is omitted, the value 0 is used. In practice, the timing syntax {{\[Omega]SW,nsample}} is often the most convenient.
Signal1D[timing, evgen, options] applies an evolution generator evgen throughout the signal evolution, where evgen is an operator or a superoperator, or a time-dependent function of an operator or a superoperator. If evgen is absent, the default None is used, in which case the option BackgroundGenerator may be used to specify the Hamiltonian or Liouvillian under which the signal evolves.  
	Signal1D[timing, events, options] performs the specified list of events while the signal is detected (padding out the remaining acquisition time with None). The events argument may have the form Repeat[events,n] in which case a repetition of the events is performed at the beginning of the acquisition interval. The syntax Repeat[events] fills the entire signal acquisition interval with the appropriate number of repetitions. 
The available options include InitialDensityOperator, Observable, Preparation, BackgroundGenerator, NormalizationFactor, SignalCalculationMethod, MatchSamplingToPeriod, ReportSignalCalculationMethod, LineBroadening, EnsembleAverage, CarouselAverage, DigitalFrequencyResolution, ZeroFill, and ForceEvenNumberOfPoints. The option BackgroundGenerator may be of the form {prepbackg,detbackg} (in case of default \"LeftToRight\" chronology), indicating different values of BackgroundGenerator during the Preparation sequence and the signal detection. ";


(* ::Input::Initialization:: *)
SignalCalculationMethod::usage="SignalCalculationMethod is an option for Signal1D. The default is SignalCalculationMethod\[Rule]Automatic, in which case the most appropriate method is chosen automatically. The currently available choices are:

SignalCalculationMethod\[Rule]\"Direct\", which uses an explicit calculation of the spin evolution during the acquisition interval. Although the direct method is fully general, it is usually not the most efficient method for time-independent or periodic problems. 

SignalCalculationMethod\[Rule]\"Diagonalization\", which diagonalizes a time-independent Liouvillian or Hamiltonian. This is only appropriate for time-independent evolution generators.

SignalCalculationMethod\[Rule]\"COMPUTE\" which assumes a periodic time-dependent Liouvillian or Hamiltonian.";


(* ::Input::Initialization:: *)
ReportSignalCalculationMethod::usage=
"ReportSignalCalculationMethod is an option for Signal1D. If True, the chosen SignalCalculationMethod is reported.";


(* ::Input::Initialization:: *)
MatchSamplingToPeriod::usage="MatchSamplingToPeriod is an option for Signal1D. If set to True (default), and the events during signal detection are periodic, Signal1D will adjust the sampling interval to match the next highest even subdivisor of the period.";


(* ::Input::Initialization:: *)
InitialDensityOperator::usage="InitialDensityOperator is an option for Signal1D, indicating the initial density operator upon which the Preparation is applied, before data acquisition. The default is opI[\"z\"].";


(* ::Input::Initialization:: *)
Preparation::usage="Preparation is an option for Signal1D, defining the set of events applied to the initial density operator before signal acquisition. The default is RotationSuperoperator[{\[Pi]/2,\"x\"}], corresponding to a strong non-selective 90\[Degree] pulse with phase 0.";


(* ::Input::Initialization:: *)
Observable::usage="Observable is an option for Signal1D. The option value may be an operator, or a list of spins in the current spin system. 
If Observable is an operator, then this operator is used as the observable quantity operator during signal detection. If Observable\[Rule]{j,k..} is used, where the list {j,k..} defines spins in the current spin system, then the Observable is set to the operator for quadrature detection signal of that set of spins. The default value of Observable is -(I/2)opI[\"-\"], representing quadrature detection of all spins. 
";


(* ::Input::Initialization:: *)
ObservableOperator::usage="ObservableOperator has been superseded by Observable (version 2.4).";


(* ::Input::Initialization:: *)
CarouselAverage::usage="CarouselAverage is an option for Signal1D. CarouselAverage\[Rule]True may be used with the SignalCalculationMethod\[Rule]\"COMPUTE\" option, in which case a fast implementation of the carousel average is used (i.e. \"\[Gamma]-COMPUTE\"). This if often used for computing the NMR spectra of rotating powders, where use of the carousel average allows a rapid estimate of the average over the \[Gamma]MR Euler angle. This option must be used with care since it is only valid if the density operator at the start of signal acquisition is independent of the \[Gamma]MR Euler angle.
 ";


(* ::Input::Initialization:: *)
ForceEvenNumberOfPoints::usage="ForceEvenNumberOfPoints is an option for Signal1D. The default is ForceEvenNumberOfPoints\[Rule]True, in which case the last acquisition point is dropped if the requested number of acquired points is odd. An even number of sampling points is usually required by the fast Fourier transform.";


(* ::Input::Initialization:: *)
SignalGeneratorPeriod::usage="SignalGeneratorPeriod is an option for Signal1D. It is used internally by algorithms which exploit periodicity during acquisition of the signal.";


(* ::Input::Initialization:: *)
EnsembleAverage::usage="EnsembleAverage is an option for high-level SpinDynamica routines including Signal1D, Trajectory, TransformationAmplitude and TransformationAmplitudeTable. The default is EnsembleAverage\[Rule]False, in which case no ensemble averaging is done. A general setting is EnsembleAverage\[Rule]{var,samplingscheme}, which implements an ensemble average of the variable  var, using the scheme samplingscheme, which takes the form {{val1,weight1},{val2,weight2}...}. In this case, the signal is calculated for all the defined values of the variable var, and the results superposed using the values of weight. The averaged variable var may appear in any of the other arguments, including option specifications such as BackgroundGenerator. 
The additional option setting Parallel\[Rule]True will attempt to distribute computation of the EnsembleAverage over the available kernels.
";


(* ::Input::Initialization:: *)
MaxBatchSize::usage="MaxBatchSize is an option associated with EnsembleAverage which causes the ensemble average to be divided into batches of dimension not larger than MaxBatchSize. The results of each batch are combined first before the overall combination is generated. This procedure conserves memory for large ensemble averages.";


(* ::Input::Initialization:: *)
Parallel::usage="Parallel is an option for high-level SpinDynamica routines including Signal1D, Trajectory, TransformationAmplitude and TransformationAmplitudeTable. If True, then the members of EnsembleAverage are computed in parallel using the available kernels. If Parallel\[Rule]<integer>, then the specified number of kernels is used.";


(* ::Input::Initialization:: *)
Normalization::usage="Normalization has been superseded by NormalizationFactor.";


(* ::Input::Initialization:: *)
NormalizationFactor::usage="NormalizationFactor is an option for Trajectory, Signal1D, TransformationAmplitude and other simulation routines which provides the normalization factor for the calculation. NormalizationFactor\[Rule]None or NormalizationFactor\[Rule]False does not normalize. NormalizationFactor\[Rule]n divides the result of the calculation by n).";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[None|False]=False;


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[expr_]/;!FreeQ[expr,$Failed]:=$Failed;


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{var:Except[_List],vals_List}]:=StandardizeEnsembleAverage[{{var},vals}];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars:{___,_List,___},vals_}]:=StandardizeEnsembleAverage[{Flatten@vars,vals}];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_,vals_}]/;!MatchQ[vars,{(_Symbol|_Symbol[_Integer])..}]:=
(Message[EnsembleAverage::badvar];$Failed);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{Except[_List]..}}]/;Length[vars]>1:=
(Message[EnsembleAverage::toomanyvars];$Failed);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{Except[_List]..}}]/;(Length[vars]==1):=
Module[{nvals,weights},(
nvals=Length[vals];
weights=Table[1/nvals,{nvals}];
StandardizeEnsembleAverage[{vars,Transpose[{List/@vals,weights}]}]
)];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{_List..}}]/;!Equal@@(Length/@vals):=(Message[EnsembleAverage::inconslengths];$Failed);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{{Except[_List]..}..}}]/;(Length[vars]==1):=
(Message[EnsembleAverage::ambig,Length@First@vals];
StandardizeEnsembleAverage[{vars,List/@vals}]);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{{Except[_List]..}..}}]/;(Length[vars]==Length@First[vals]):=
(Message[EnsembleAverage::ambig,1];
StandardizeEnsembleAverage[{vars,Map[List,vals,1]}]);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{_List..}}]:=
Module[{nvar,valdim,nvals,weights},(
nvals=Length[vals];
weights=Table[1/nvals,{nvals}];
StandardizeEnsembleAverage[{vars,MapThread[Join[{#1},{#2}]&,{vals,weights}]}]
)/;(
nvar=Length[vars];
valdim=Length[vals[[1]]];
(nvar==valdim)&&
!MatchQ[First@vals,{_List,Except[_List]}]
)];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,vals:{_List..}}]:=
Module[{nvar,valdim,nvals,weights},(
nvals=Length[vals];
weights=Table[1/nvals,{nvals}];
StandardizeEnsembleAverage[{vars,MapThread[Join[#1,{#2}]&,{vals,weights}]}]
)/;(
nvar=Length[vars];
valdim=Length[vals[[1,1]]];
(nvar==valdim)&&
!MatchQ[First@vals,{_List,Except[_List]}]
)];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,valws:{{_,Except[_List]}..}}]:=
Module[{vals,weights},(
{vals,weights}=Transpose@valws;
StandardizeEnsembleAverage[{vars,Transpose[{List/@vals,weights}]}]
)]/;MatchQ[valws[[1,1]],Except[_List]]||
(MatchQ[valws[[1,1]],{Except[_List]..}]&&Length[valws[[1,1]]]!=Length[vars]);


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,valws:{{_List,Except[_List]}..}}]/;(Length[vars]!=Length[valws[[1,1]]])&&(Length[vars]==Length@Flatten[valws[[1,1]]]):=
Module[{vals,weights},(
{vals,weights}=Transpose@valws;{vars,Transpose[{Flatten/@vals,weights}]}
)];


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[{vars_List,valws:{{_List,Except[_List]}..}}]/;Length[vars]==Length[valws[[1,1]]]:={vars,valws};


(* ::Input::Initialization:: *)
StandardizeEnsembleAverage[expr_]:=(Message[EnsembleAverage::badspec];$Failed);


(* ::Input::Initialization:: *)
EnsembleWeights[expr_]/;!FreeQ[expr,$Failed]:=$Failed;


(* ::Input::Initialization:: *)
EnsembleWeights[{vars_,valws_}]/;!MatchQ[{vars,valws},{_List,{{_List,Except[_List]}..}}]||
Length[vars]!=Length[valws[[1,1]]]:=EnsembleWeights@StandardizeEnsembleAverage[{vars,valws}];


(* ::Input::Initialization:: *)
EnsembleWeights[{vars_,valws_}]:=Last/@valws;


(* ::Input::Initialization:: *)
MultidimensionalEnsembleVariables[expr_]/;!FreeQ[expr,$Failed]:=$Failed;


(* ::Input::Initialization:: *)
MultidimensionalEnsembleVariables[{vars_,valws_}]/;!MatchQ[{vars,valws},{_List,{{_List,Except[_List]}..}}]||
Length[vars]!=Length[valws[[1,1]]]:=MultidimensionalEnsembleVariables@StandardizeEnsembleAverage[{vars,valws}];


(* ::Input::Initialization:: *)
MultidimensionalEnsembleVariables[{vars_,valws_}]:=Cases[Transpose[{vars,Map[If[MatchQ[#,_List],Length[#],0]&,valws[[1,1]]]}],{_,Except[0]}];


(* ::Input::Initialization:: *)
SetAttributes[ExpandMultidimensionalEnsembleVariables,HoldFirst];


(* ::Input::Initialization:: *)
ExpandMultidimensionalEnsembleVariables[exprs__]/;!FreeQ[Hold@{exprs},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
ExpandMultidimensionalEnsembleVariables[expr_]/;MatchQ[ReleaseHold[expr],{_,{{_,Except[_List]}..}}]:=
Module[{vars,valws},(
{vars,valws}=expr;
StandardizeEnsembleAverage[
{ExpandMultidimensionalEnsembleVariables[Evaluate@vars,{vars,valws}],valws}
])];


(* ::Input::Initialization:: *)
ExpandMultidimensionalEnsembleVariables[expr_,None|False]:=expr;


(* ::Input::Initialization:: *)
ExpandMultidimensionalEnsembleVariables[expr_,{vars_,valws_}]/;!MatchQ[{vars,valws},{_List,{{_List,Except[_List]}..}}]||
Length[vars]!=Length[valws[[1,1]]]:=ExpandMultidimensionalEnsembleVariables[expr,StandardizeEnsembleAverage[{vars,valws}]];


(* ::Input::Initialization:: *)
ExpandMultidimensionalEnsembleVariables[expr_,{vars_,valws_}]:=
Module[{multidensvar},(
multidensvar=MultidimensionalEnsembleVariables[{vars,valws}];
SetAttributes[Evaluate[First[#]],NHoldFirst]&/@multidensvar;
ReleaseHold[
Hold[expr]/.(Rule[First[#],Array[First[#],Last[#]]]&/@multidensvar)
]
)];


(* ::Input::Initialization:: *)
EnsembleVariablesSubstitutionRules[expr_]/;!FreeQ[expr,$Failed]:=$Failed;


(* ::Input::Initialization:: *)
EnsembleVariablesSubstitutionRules[{vars_,valws_}]/;!MatchQ[{vars,valws},{_List,{{_List,Except[_List]}..}}]||
Length[vars]!=Length[valws[[1,1]]]:=EnsembleVariablesSubstitutionRules@StandardizeEnsembleAverage[{vars,valws}];


(* ::Input::Initialization:: *)
EnsembleVariablesSubstitutionRules[{vars_,valws_}]/;!MatchQ[MultidimensionalEnsembleVariables[{vars,valws}],{}]:=
EnsembleVariablesSubstitutionRules@
StandardizeEnsembleAverage[
MapAt[Flatten,
ReleaseHold@ExpandMultidimensionalEnsembleVariables[Evaluate@{vars,valws},{vars,valws}],
1]
];


(* ::Input::Initialization:: *)
EnsembleVariablesSubstitutionRules[{vars_,valws_}]/;MatchQ[MultidimensionalEnsembleVariables[{vars,valws}],{}]:=
Module[{vals,nvar},(
vals=First/@valws;
nvar=Length[vars];
Transpose@Map[
(Function[val,First[#]->val]/@Last[#])&,
Table[{vars[[i]],Part[#,i]&/@vals},{i,1,nvar}]
]
)];


(* ::Input::Initialization:: *)
EnsembleVariablesFreeQ[expr_,(None|False)]:=True;


(* ::Input::Initialization:: *)
EnsembleVariablesFreeQ[expr_,{vars_,valws_}]/;!MatchQ[{vars,valws},{_List,{{_List,Except[_List]}..}}]||
Length[vars]!=Length[valws[[1,1]]]:=EnsembleVariablesFreeQ[expr,StandardizeEnsembleAverage[{vars,valws}]];


(* ::Input::Initialization:: *)
EnsembleVariablesFreeQ[expr_,{vars_,valws_}]:=
And@@(FreeQ[expr,#]&/@vars);


(* ::Input::Initialization:: *)
EnsembleAverage::badvar="One or more ensemble average variables already has an assigned value.";


(* ::Input::Initialization:: *)
EnsembleAverage::toomanyvars="The number of ensemble average variables exceeds the dimension of the ensemble average values.";


(* ::Input::Initialization:: *)
EnsembleAverage::inconslengths="The ensemble average values have inconsistent lengths.";


(* ::Input::Initialization:: *)
EnsembleAverage::ambig="The syntax is ambiguous. Equally weighted values of dimension `1` have been assumed."; 


(* ::Input::Initialization:: *)
EnsembleAverage::badspec="Cannot interpret EnsembleAverage specification.";


(* ::Input::Initialization:: *)
Parallel::toomany="The number of requested kernels is too high. Calculation is proceeding with `1` kernels";


(* ::Input::Initialization:: *)
Parallel::inval="The value of Parallel is invalid.";


(* ::Input::Initialization:: *)
Options[PrepareParallel]={Parallel->True};


(* ::Input::Initialization:: *)
PrepareParallel[opts___Rule]:=PrepareParallel[OperatorBasis[],opts];


(* ::Input::Initialization:: *)
PrepareParallel[opbasis_,opts___Rule]:=PrepareParallel[opbasis,ZeemanBasis[],opts];


(* ::Input::Initialization:: *)
PrepareParallel[opbasis_,basis_,opts___Rule]/;!MatchQ[Parallel/.{opts}/.Options[PrepareParallel],True|All|_?IntegerQ]||
TrueQ[(Parallel/.{opts}/.Options[PrepareParallel])<0]:=
(Message[Parallel::inval];$Failed);


(* ::Input::Initialization:: *)
PrepareParallel[opbasis_,basis_,opts___Rule]:=
Module[{parallel,nkernelsrunning,nkernelsrequested,path,chronology,stufftodistribute,ul},(
parallel=Parallel/.{opts}/.Options[PrepareParallel];
Which[
MatchQ[parallel,True|All]&&TrueQ[$ProcessorCount>$KernelCount],
	LaunchKernels[$ProcessorCount-$KernelCount],
IntegerQ[parallel]&&TrueQ[parallel>$ProcessorCount]&&TrueQ[parallel>$KernelCount],
	(Message[PrepareParallel::nonparkernels];
	LaunchKernels[parallel-$KernelCount]),
IntegerQ[parallel]&&TrueQ[parallel>$KernelCount],
	LaunchKernels[parallel-$KernelCount],
IntegerQ[parallel]&&TrueQ[parallel<$KernelCount],
	(Message[PrepareParallel::relaunch];
	CloseKernels[];
	LaunchKernels[parallel]),
True,
	Null
];
If[
$KernelID==0,
(path=$Path;
chronology=$Chronology;
DistributeDefinitions[path,chronology];
ul=UserLevel[];
ParallelEvaluate[$Path=path];
ParallelEvaluate[$Chronology=chronology];
DistributeDefinitions[SpinSystem[],Basis[],ZeemanKetBraOperatorBasis[]];
)
];
ParallelNeeds["SpinDynamica`"];
ParallelEvaluate[Quiet@SetUserLevel[ul]];
ParallelEvaluate[Quiet@SetSpinSystem[SpinSystem[basis]]];
	ParallelEvaluate[Quiet@If[basis===Basis[],Nothing,SetBasis[basis]]];
	ParallelEvaluate[Quiet@If[opbasis===OperatorBasis[],Nothing,SetOperatorBasis[opbasis]]];
	stufftodistribute={SpinSystem[],Basis[],OperatorBasis[],$RecursionLimit,$IterationLimit,$ChopThreshold,$Chronology};
	DistributeDefinitions[stufftodistribute];
ParallelEvaluate[stufftodistribute];
DistributeDefinitions["Global`","General`PhysicalConstants`"];
)]; 


(* ::Input::Initialization:: *)
PrepareParallel::relaunch="Closing and relaunching kernels since the requested number of parallel kernels is less than those already running.";


(* ::Input::Initialization:: *)
PrepareParallel::nonparkernels="The number of requested kernels is more than the number of processors, so the kernels will not all run in parallel. Proceeding anyway.";


(* ::Input::Initialization:: *)
Normalization:=(Message[Normalization::usage];$Failed);


(* ::Input::Initialization:: *)
NormalizationFactor::zero="NormalizationFactor cannot be zero. Continuing without normalization.";  


(* ::Input::Initialization:: *)
NormalizationFactor::bad="Inappropriate value for NormalizationFactor.";  


(* ::Input::Initialization:: *)
SingleStatusPattern=True|False|{(True|False)...};
StatusListPattern=SingleStatusPattern|{SingleStatusPattern..}|{({SingleStatusPattern..}|SingleStatusPattern)..};
GeneralStatusListPattern=SingleStatusPattern|StatusListPattern|{StatusListPattern...};


(* ::Input::Initialization:: *)
MaximumTransformationAmplitude[args___]:=
(Message[MaximumTransformationAmplitude::usage];$Failed);


(* ::Input::Initialization:: *)
Options[TransformationAmplitudeBounds]={NormalizationFactor->None};


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[\[Rho]ini_->ops_,more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeBounds[Evaluate@ops,more,opts][\[Rho]ini];


(* ::Input::Initialization:: *)
HoldPattern@TransformationAmplitudeBounds[ops_,more:Except[_Rule]...,opts___Rule][\[Rho]ini_?OperatorQ]/;MatchQ[NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds],None|False]:=
TransformationAmplitudeBounds[ops,more,
Evaluate@SimplifyRules[
NormalizationFactor->1,
opts]
][\[Rho]ini];


(* ::Input::Initialization:: *)
HoldPattern@TransformationAmplitudeBounds[ops_,more:Except[_Rule]...,opts___Rule][\[Rho]ini_?OperatorQ]/;(Chop[NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds]]==0):=
(Message[NormalizationFactor::zero];
TransformationAmplitudeBounds[ops,more,
Evaluate@SimplifyRules[
NormalizationFactor->1,
opts]
][\[Rho]ini]);


(* ::Input::Initialization:: *)
HoldPattern@TransformationAmplitudeBounds[ops_,more:Except[_Rule]...,opts___Rule][\[Rho]ini_?OperatorQ]/;!MatchQ[NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds],_?NumericQ|None|False]:=
(Message[NormalizationFactor::badnorm];$Failed);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},opts___Rule]:=
TransformationAmplitudeBounds[ops,DefaultOperatorBasis[],opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},opbasis_,opts___Rule]:=
TransformationAmplitudeBounds[ops,opbasis,ZeemanBasis[],opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},opbasis_,basis_,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},opbasis_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
TransformationAmplitudeBounds[ops,opbasis,opts]
);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},Undefined,basis_,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[ZeemanKetBraOperatorBasis[],CheckOperatorBasis->False];
TransformationAmplitudeBounds[ops,opts]
);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:(_?OperatorQ)|{_?OperatorQ..},opbasis_,basis_,opts___Rule]/;(First@opbasis!=First@basis):=
Module[{defaultopbasis},(
defaultopbasis=ZeemanKetBraOperatorBasis[First@basis,Sorted->True];
Message[OperatorBasis::default];
SetOperatorBasis[defaultopbasis,CheckOperatorBasis->False];
TransformationAmplitudeBounds[ops,defaultopbasis,basis,opts]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[op_?OperatorQ,opbasis_,basis_,opts___Rule][\[Rho]ini_?OperatorQ]/;!HermitianQ[MatrixRepresentation[op,basis]]:=(Message[TransformationAmplitudeBounds::nonherm];$Failed);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[op_?OperatorQ,opbasis_,basis_,opts___Rule][\[Rho]ini_?OperatorQ]/;!HermitianQ[MatrixRepresentation[\[Rho]ini,basis]]:=(Message[TransformationAmplitudeBounds::nonherm];$Failed);


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[op_?OperatorQ,opbasis_,basis_,opts___Rule][\[Rho]ini_?OperatorQ]/;NumericQ[NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds]]:=
Module[{norm,\[CapitalLambda]\[Rho],\[CapitalLambda]op},(
norm=NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds];
\[CapitalLambda]\[Rho]=SortBy[Eigenvalues[MatrixRepresentation[\[Rho]ini,basis]],N];
\[CapitalLambda]op=SortBy[Eigenvalues[MatrixRepresentation[op,basis]],N];
{\[CapitalLambda]\[Rho].Reverse[\[CapitalLambda]op]/(norm*\[CapitalLambda]op.\[CapitalLambda]op),\[CapitalLambda]\[Rho].\[CapitalLambda]op/(norm*\[CapitalLambda]op.\[CapitalLambda]op)}
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds[ops:{_?OperatorQ..},opbasis_,basis_,opts___Rule][\[Rho]ini_?OperatorQ]/;NumericQ[NormalizationFactor/.{opts}/.Options[TransformationAmplitudeBounds]]:=
(TransformationAmplitudeBounds[#,opts][\[Rho]ini])&/@ops;


(* ::Input::Initialization:: *)
TransformationAmplitudeBounds::nonherm="TransformationAmplitudeBounds has only been implemented for Hermitian operators.";


(* ::Input::Initialization:: *)
Options[Trajectory]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
NormalizationFactor->None,
UseMatrixExpWhenPossible->True,
UseHilbertSpaceWhenPossible->True,
UseDiagonalizationWhenPossible->False,
InitialTimePoint->0,
BackgroundGenerator->None,
EnsembleAverage->None,
InterpolationPoints->500,
AccuracyGoal->10, 
PrecisionGoal->10,
MaxSteps->Automatic,
MaxStepSize->Automatic,
InterpolationStepSize-> 10.^-6,
Chronology:>$Chronology,
Parallel->True,
MaxBatchSize->128,
EnsembleVariableDimension->Undefined,
EnsembleSetUp->False,
ParallelSetUp->False,
EnsembleAverageStandardized->False,
PolarizationLevelOperatorsChecked->False,
MinimumRecommendedUserLevel->2
};


(* ::Input::Initialization:: *)
SetAttributes[Trajectory,HoldAll]


(* ::Input::Initialization:: *)
Trajectory[args1___,args2:Except[_Rule]..,opts___Rule]:=
Module[{ul,rul},(
Message[UserLevel::toolow,ul,rul];
Trajectory[args1,args2,MinimumRecommendedUserLevel->0,opts]
)/;(
ul=UserLevel[];
rul=MinimumRecommendedUserLevel/.{opts}/.Options[Trajectory];
TrueQ[ul<rul]
)];


(* ::Input::Initialization:: *)
Trajectory[\[Rho]ini_->ops_,more:(Except[_Rule]...),opts___Rule]:=
Trajectory[ops,more,opts][\[Rho]ini];


(* ::Input::Initialization:: *)
Trajectory[ops:Except[_Rule],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]/;!(PolarizationLevelOperatorsChecked/.{opts}/.Options[Trajectory])&&(FreeQ[Hold@ops,PolarizationLevelOperator|SingletPolarizationLevelOperator]||
(Chop[Tr@MatrixRepresentation[\[Rho]ini]-1]==0)
):=
Trajectory[
ops,more,
Evaluate@SimplifyRules[
PolarizationLevelOperatorsChecked->True,opts]
][\[Rho]ini];


(* ::Input::Initialization:: *)
Trajectory[ops:Except[_Rule],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]/;!(PolarizationLevelOperatorsChecked/.{opts}/.Options[Trajectory])&&!FreeQ[Hold@ops,PolarizationLevelOperator]&&
(Chop[Tr@MatrixRepresentation[\[Rho]ini]-1]!=0):=
(Message[PolarizationLevelOperator::inval\[Rho]];
Trajectory[
ops,more,
Evaluate@SimplifyRules[
PolarizationLevelOperatorsChecked->True,opts]
][\[Rho]ini]
);


(* ::Input::Initialization:: *)
Trajectory[ops:Except[_Rule],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]/;!(PolarizationLevelOperatorsChecked/.{opts}/.Options[Trajectory])&&!FreeQ[Hold@ops,SingletPolarizationLevelOperator]&&
(Chop[Tr@MatrixRepresentation[\[Rho]ini]-1]!=0):=
(Message[SingletPolarizationLevelOperator::inval\[Rho]];
Trajectory[
ops,more,
Evaluate@SimplifyRules[
PolarizationLevelOperatorsChecked->True,opts]
][\[Rho]ini]
);


(* ::Input::Initialization:: *)
Trajectory[args:(Except[_Rule]...),opts___Rule]/;FreeQ[{opts},EnsembleAverage]:=Trajectory[args,opts,EnsembleAverage->(EnsembleAverage/.Options[Trajectory])];


(* ::Input::Initialization:: *)
Trajectory[ops_,more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule][\[Rho]ini_]/;!(EnsembleAverageStandardized/.{opts1,opts2}/.Options[Trajectory]):=
Module[{standensav,modmore,modopts,mod\[Rho]ini,modops},(
standensav=StandardizeEnsembleAverage[ensav];
{modmore,modopts,mod\[Rho]ini,modops}=
ExpandMultidimensionalEnsembleVariables[
{{more},{opts1,opts2},\[Rho]ini,ops},
standensav
];
Trajectory[
Evaluate@ReleaseHold@modops,
Evaluate[Sequence@@ReleaseHold@modmore],
Evaluate@SimplifyRules[
EnsembleAverage->standensav,
EnsembleAverageStandardized->True,
Sequence@@ReleaseHold@modopts
]
][mod\[Rho]ini]
)];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,more:Except[_Rule]...,opts___Rule]/;MatchQ[NormalizationFactor/.{opts}/.Options[Trajectory],None|False]:=
Trajectory[ops,events,more,
Evaluate@SimplifyRules[
NormalizationFactor->1,
opts]
];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,more:Except[_Rule]...,opts___Rule]/;(Chop[NormalizationFactor/.{opts}/.Options[Trajectory]]==0):=
(Message[NormalizationFactor::zero];
Trajectory[ops,events,more,
Evaluate@SimplifyRules[
NormalizationFactor->1,
opts]
]);


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,more:Except[_Rule]...,opts___Rule][\[Rho]ini_?OperatorQ]/;!MatchQ[NormalizationFactor/.{opts}/.Options[Trajectory],_?NumericQ|None|False]:=
(Message[NormalizationFactor::bad];$Failed);


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opts___Rule]:=
Trajectory[ops,events,Evaluate[OperatorBasis/.{opts}/.Options[Trajectory]],opts];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opbasis_,opts___Rule]:=
Trajectory[ops,events,opbasis,Evaluate[Basis/.{opts}/.Options[Trajectory]],opts];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opbasis_,basis_,opts___Rule]/;(SpinSystem[]==Undefined):=(Message[SpinSystem::notready];Abort[]);


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opbasis_,Undefined,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
Trajectory[ops,events,opbasis,opts]
);


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,Undefined,basis_,opts___Rule]:=
(
Message[OperatorBasis::unknown];
Message[OperatorBasis::default];
SetOperatorBasis[OperatorBasis/.{opts}/.Options[Trajectory],CheckOperatorBasis->False];
Trajectory[ops,events,opts]
);


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opbasis_,basis_,opts___Rule]/;(First@opbasis!=First@basis):=
Module[{defaultopbasis},(
SetSpinSystem[First@basis];
defaultopbasis=OperatorBasis/.{opts}/.Options[Trajectory];
Message[OperatorBasis::default];
SetOperatorBasis[defaultopbasis,CheckOperatorBasis->False];
Trajectory[ops,events,Evaluate@defaultopbasis,basis,opts]
)];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops_,events_,opbasis_,basis_,opts___Rule]:=
Module[{ensav,backg},(
Trajectory[ops,events,opbasis,basis,
Evaluate@SimplifyRules[
BackgroundGenerator->
Evaluate[
Which[
MatchQ[#,_?OperatorQ],
	NDiagonalize[#,basis],
MatchQ[#,_?SuperoperatorQ],
	NDiagonalize[#,opbasis,basis],
True,#
]&@ backg
],
EnsembleAverage->ensav,
BackgroundGeneratorPrepared->True,
opts
]
]
)/;(
(!BackgroundGeneratorPrepared/.{opts}/.Options[Trajectory])&&
(
ensav=StandardizeEnsembleAverage[EnsembleAverage/.{opts}/.Options[Trajectory]];
backg=StandardizeGenerator[BackgroundGenerator/.{opts}/.Options[Trajectory]];
EnsembleVariablesFreeQ[backg,ensav]
)
)];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:(_?OperatorQ|{_?OperatorQ..}),events:Except[_EventList|Event[___]],more:(Except[_Rule]..),opts___Rule][\[Rho]ini_]/;(
MatchQ[({Parallel,ParallelSetUp,EnsembleAverage}/.{opts}/.Options[Trajectory]),{True|All|_?NumericQ,False,Except[None|False]}]):=Module[{opbasis,basis},(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Trajectory];
PrepareParallel[opbasis,basis,opts];
Trajectory[ops,events,more,
Evaluate@SimplifyRules[
ParallelSetUp->True,
Parallel->True,
opts
]
][\[Rho]ini]
)];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events:Except[_EventList|Event[___]],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]:=Module[{ensav,var,vals,weights,nens,maxbatchsize,valwbatches,nbatch,opbasis,basis,ib,temp,traj},
(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Trajectory];
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
var=First[ensav];
valwbatches=Partition[Last[ensav],maxbatchsize,maxbatchsize,{1,1},{}];
nbatch=Length[valwbatches];
If[nbatch==1,
PrintTemporary["ensemble averaging using 1 batch .."],
PrintTemporary["ensemble averaging using "<>ToString[nbatch]<>" batches.."]
];
CombineTrajectoryFunctions[
Monitor[
Table[
(
temp=PrintTemporary["computing batch "<>ToString[ib]<>" of "<>ToString[nbatch]<>".."];
traj=Trajectory[ops,
events,more,
Evaluate@SimplifyRules[
EnsembleAverage->{var,valwbatches[[ib]]},
OperatorBasis->opbasis,
Basis->basis,
opts
]
][\[Rho]ini];
NotebookDelete[temp];
traj
),
{ib,1,nbatch}
],
ProgressIndicator[ib,{1,nbatch+1}]
],
Table[1,{nbatch}],
Sequence@@FilterRules[Join[{opts},Options[Trajectory]],
Options[CombineTrajectoryFunctions]
]
]
)/;(
{ensav,maxbatchsize}={EnsembleAverage,MaxBatchSize}/.{opts}/.Options[Trajectory];
MatchQ[EnsembleAverage/.{opts}/.Options[Trajectory],{_,{{_,_}...}}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize<nens
)
)
];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events:Except[_EventList|Event[___]],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]/;(MatchQ[EnsembleAverage/.{opts}/.Options[Trajectory],{_,{{_,_}...}}]):=Module[{ensav,var,vals,weights,nens,message,i,temp,opbasis,basis,vardim,varsubrules,maxbatchsize},(
temp=PrintTemporary["setting up batch.."];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Trajectory];
nens=Length[Last[ensav]];
varsubrules=EnsembleVariablesSubstitutionRules[ensav];
weights=EnsembleWeights[ensav];
NotebookDelete[temp];
CombineTrajectoryFunctions[
Monitor[
Table[
Trajectory[
ops,
ReleaseHold[Hold[events]/.varsubrules[[i]]],
more,
Evaluate@SimplifyRules[
EnsembleAverage->False,
OperatorBasis->opbasis,
Basis->basis,
ReleaseHold[Hold[opts]/.varsubrules[[i]]]
]
][ReleaseHold[Hold[\[Rho]ini]/.varsubrules[[i]]]],
{i,1,nens}
],
ProgressIndicator[i,{1,nens+1}]
],
weights,
Sequence@@FilterRules[
Join[{Parallel->False,opts},Options[Trajectory]],
Options[CombineTrajectoryFunctions]
]
]
)/;(
!TrueQ[Parallel/.{opts}/.Options[Trajectory]]&&
(
{ensav,maxbatchsize}={EnsembleAverage,MaxBatchSize}/.{opts}/.Options[Trajectory];
MatchQ[EnsembleAverage/.{opts}/.Options[Trajectory],{_,{{_,_}...}}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize>=nens
)
)
)
];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events:Except[_EventList|Event[___]],more:(Except[_Rule]...),opts___Rule][\[Rho]ini_]/;(MatchQ[EnsembleAverage/.{opts}/.Options[Trajectory],{_,{{_,_}...}}]):=Module[{ensav,var,vals,weights,nens,message,i,temp,opbasis,basis,vardim,varsubrules,maxbatchsize,eventslist},(
temp=PrintTemporary["setting up batch.."];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitude];
nens=Length[Last[ensav]];
varsubrules=EnsembleVariablesSubstitutionRules[ensav];
weights=EnsembleWeights[ensav];
SetSharedVariable[opbasis,basis];
eventslist=ReleaseHold[Hold[events]/.#]&/@varsubrules;
DistributeDefinitions[varsubrules,eventslist];
NotebookDelete[temp];
CombineTrajectoryFunctions[
Parallelize[
Table[
(
Trajectory[
ops,
Evaluate[eventslist[[i]]],
more,
Evaluate@SimplifyRules[
EnsembleAverage->False,
OperatorBasis->opbasis,
Basis->basis,
ReleaseHold[Hold[opts]/.varsubrules[[i]]]
]
][ReleaseHold[Hold[\[Rho]ini]/.varsubrules[[i]]]]
),
{i,1,nens}
],
Method->"CoarsestGrained",
DistributedContexts->"Global`"
],
weights,
Sequence@@FilterRules[
Join[{Parallel->False,opts},Options[Trajectory]],
Options[CombineTrajectoryFunctions]
]
]
)/;(
TrueQ[Parallel/.{opts}/.Options[Trajectory]]&&
TrueQ[ParallelSetUp/.{opts}/.Options[Trajectory]]&&
(
{ensav,maxbatchsize}={EnsembleAverage,MaxBatchSize}/.{opts}/.Options[Trajectory];
MatchQ[EnsembleAverage/.{opts}/.Options[Trajectory],{_,{{_,_}...}}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize>=nens
)
)
)
];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:Except[_Rule],events_,opbasis:Except[_Rule],basis:Except[_Rule],opts___Rule][\[Rho]ini_?((MatchQ[#,Except[_Operator]]&&OperatorQ[#])&)]:=
Trajectory[ops,events,opbasis,basis,opts][
Operator[\[Rho]ini,opbasis,basis,
Sequence@@FilterRules[{CheckOperatorType->False,opts},
Options[Operator]]
]
];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[op_?OperatorQ,events_,opbasis:Except[_Rule],basis:Except[_Rule],opts___Rule][\[Rho]ini_Operator]/;
MatchQ[{EnsembleAverage,NormalizationFactor}/.{opts}/.Options[Trajectory],{None|False,_?NumericQ}]:=
First@Trajectory[{op},events,opbasis,basis,opts][\[Rho]ini];


(* ::Input::Initialization:: *)
HoldPattern@Trajectory[ops:{_?OperatorQ..},events_,opbasis_,basis_,opts___Rule][\[Rho]ini_Operator]/;MatchQ[{EnsembleAverage,NormalizationFactor}/.{opts}/.Options[Trajectory],{None|False,_?NumericQ}]:=
Module[{\[Rho]func,\[Rho]funclist,\[Rho]funct,tfin,tini,norm,opnormsqlist,conjgopvecs,tval,t,backg,tintervals,ninterps,\[Rho]intervalfuncs,interppoints,maxstepsize},(
{norm,interppoints,maxstepsize}=ReleaseHold[{NormalizationFactor,InterpolationPoints,MaxStepSize}/.{opts}/.Options[Trajectory]];
backg=Which[
MatchQ[#,NullOperator[]],#,
MatchQ[#,_?OperatorQ],NDiagonalize[#,basis],
MatchQ[#,_?SuperoperatorQ],NDiagonalize[#,opbasis,basis],
True,#
]&@ ReleaseHold[BackgroundGenerator/.{opts}/.Options[Trajectory]];
opnormsqlist=(OperatorNorm[#]^2)&/@ops;
\[Rho]func=
NPropagate[events,OperatorBasis->opbasis,Basis-> basis,Continuous->True,BackgroundGenerator-> backg,Sequence@@FilterRules[
Join[{opts},CurrentOptionsToPassDown[Trajectory,NPropagate],CurrentOptionsToPassDown[Trajectory,NDSolve]],
Join[Options[Trajectory],Options[NPropagate],Options[NDSolve]]]
][\[Rho]ini];
If[!FreeQ[\[Rho]func,$Failed],
(Message[Trajectory::failed];Table[$Failed,{Length[ops]}]),
ConvertOperatorTrajectoryFunctionToTrajectoryFunction[
\[Rho]func,#,opts]&/@ops
]
)];


(* ::Input::Initialization:: *)
HoldPattern@ConvertOperatorTrajectoryFunctionToTrajectoryFunction[
OperatorTrajectoryFunction[timing_,Function[t_,arg_],more___],
obsop_?OperatorQ,
opts___Rule
]:=
Module[{norm},(
norm=NormalizationFactor/.{opts}/.{NormalizationFactor->1};
TrajectoryFunction[timing,
Function[t,Evaluate[arg/.
{op_Operator:>
(If[FreeQ[#,Cosh|Sinh],#,TrigToExp[#]]&@ExpToTrig[OperatorAmplitude[op->obsop]/norm])
}
]
]
]
)];


(* ::Input::Initialization:: *)
Options[TrajectoryFunction]={};


(* ::Input::Initialization:: *)
Format[TrajectoryFunction[range:{{tb_?NumericQ,ta_?NumericQ}},opfunc_,opts___Rule]]:=
RowBox[{
"TrajectoryFunction[",
ToBoxes[EngineeringForm@Chop[
N@(Reverse/@range)
]
],
ToBoxes[", <>]"]
}]//DisplayForm;


(* ::Input::Initialization:: *)
TrajectoryFunction[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
TrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},func:Except[_String],opts___Rule][t_?NumericQ]/;(TrueQ[Chop@N[t-ta]<0]||TrueQ[Chop@N[t-tb]>0]):=(Message[TrajectoryFunction::outofrange,N@t,N@ta,N@tb];0);


(* ::Input::Initialization:: *)
TrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},func:Except[_String],opts___Rule][t_?NumericQ]:=Chop[N@func[t]];


(* ::Input::Initialization:: *)
TrajectoryFunction::outofrange="time point `1` does not lie in the interval between `2` and `3`";


(* ::Input::Initialization:: *)
Options[CombineTrajectoryFunctions]={InterpolationPoints->100,AccuracyGoal->11,PrecisionGoal->11,InterpolationPrecision->11,InterpolationOrder->3};


(* ::Input::Initialization:: *)
CombineTrajectoryFunctions[tfuncset:{{_TrajectoryFunction..}..},weights_List,opts___Rule]:=
CombineTrajectoryFunctions[#,weights,opts]&/@Transpose[tfuncset];


(* ::Input::Initialization:: *)
CombineTrajectoryFunctions[tfuncs:{TrajectoryFunction[interval_,__]..},opts___Rule]:=CombineTrajectoryFunctions[tfuncs,Table[1/Length[tfuncs],{Length[tfuncs]}]];


(* ::Input::Initialization:: *)
CombineTrajectoryFunctions[
tfuncs:{TrajectoryFunction[interval_,__]..},
weights_List,opts___Rule]/;(Length[tfuncs]==Length[weights]):=
Module[{tintervals,nintervals,pwtfuncs,pwtfunc,ninterps,maxstepsize,interppoints,tinterps,combtfuncs,tfin,tini,t},(
PrintTemporary["combining trajectory functions.."];
{maxstepsize,interppoints}={InterpolationStepSize,InterpolationPoints}/.{opts}/.Join[Options[Trajectory],Options[NDSolve]];
tintervals=Partition[Sort@Union@Flatten[{First[#],Last[#]}&/@Cases[tfuncs,_Inequality|_Greater|_GreaterEqual|_LessEqual,Infinity]],
2,1];
{tfin,tini}={Max[#],Min[#]}&@Flatten[tintervals];
nintervals=Length[tintervals];
pwtfuncs=
Transpose@Map[
Function[tfunc,
Function[t,Evaluate@Assuming[(First[#]<t<Last[#]),Refine[tfunc[[2]][t]]]]&/@tintervals
],
tfuncs
];
pwtfunc=
Map[
Function[Evaluate[t],Evaluate[#]]&,
Map[
Dot[weights,#]&,
Map[#[t]&,pwtfuncs,{2}]
]
];
ninterps=Min[Max[interppoints,3],Ceiling[Abs[First[#]-Last[#]]/maxstepsize]]&/@tintervals;
tinterps=MapThread[Range[Min[#1],Max[#1],Abs[First[#1]-Last[#1]]/#2]&,{tintervals,ninterps}];
combtfuncs=
MapThread[
Interpolation[
Transpose[{#2,Map[#1,#2]}],
Sequence@@Join[
CurrentOptionsToPassDown[Trajectory,Interpolation],
CurrentOptionsToPassDown[NPropagate,Interpolation]
]
]&,{pwtfunc,tinterps}
];
TrajectoryFunction[{{tfin,tini}},
Function[t,
Evaluate@Piecewise[Transpose[
{Through[combtfuncs[t]],
Join[
(First[#]<=t<Last[#])&/@Most[tintervals],
(First[#]<=t<=Last[#])&/@{Last[tintervals]}
]
}
]]
]
]
)];


(* ::Input::Initialization:: *)
Trajectory::badensvar="The variable used in the EnsembleAverage may not have an assigned value.";


(* ::Input::Initialization:: *)
Trajectory::incompattraj="The domains of the trajectory functions do not match.";


(* ::Input::Initialization:: *)
Trajectory::cantinterpret="A problem has been encountered in interpreting the Trajectory function.";


(* ::Input::Initialization:: *)
Trajectory::failed="Trajectory has encountered a $Failed condition.";


(* ::Input::Initialization:: *)
Options[TransformationAmplitude]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
NormalizationFactor->None,
UseMatrixExpWhenPossible->True,
UseHilbertSpaceWhenPossible->True,
InitialTimePoint->0,
BackgroundGenerator->None,
EnsembleAverage->False,
Chronology:>$Chronology,
Parallel->True,
MaxBatchSize->128,
MinimumRecommendedUserLevel->1
};


(* ::Input::Initialization:: *)
SetAttributes[TransformationAmplitude,HoldAll]


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@GeneralStatusListPattern,args___]/;!FreeQ[Hold@{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate[Except[GeneralStatusListPattern]],
Except[_Rule]..,_Rule,___,Except[_Rule],___
]:=(Message[TransformationAmplitude::badsyntax];$Failed);


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate[arg:Except[GeneralStatusListPattern]],moreA___,BackgroundGenerator-> backg_,moreB___]:=TransformationAmplitude[False,arg,moreA,BackgroundGenerator-> Hold[backg],moreB];


(* ::Input::Initialization:: *)
StatusDimension[TransformationAmplitude]=11;


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate[arg:Except[GeneralStatusListPattern]],more___]:=TransformationAmplitude[False,arg,more];


(* ::Input::Initialization:: *)
TransformationAmplitude[False,items___,opts___Rule]:=TransformationAmplitude[Evaluate@Table[False,{StatusDimension[TransformationAmplitude]}],items,opts];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"Chronology"]=1;StatusDimension[TransformationAmplitude,"Chronology"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitude[{chronst:False,morest___},more___]:=TransformationAmplitude[Evaluate@{Table[False,{StatusDimension[TransformationAmplitude,"Chronology"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[{chronst:{True..},morest___},more___]:=TransformationAmplitude[{True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"InputRule"]=2;StatusPatternPrefix[TransformationAmplitude,"InputRule"]=Repeated[_,{StatusPosition[TransformationAmplitude,"InputRule"]-1}];StatusDimension[TransformationAmplitude,"InputRule"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"InputRule"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"EnsembleAverage"]=3;StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"]=Repeated[_,{StatusPosition[TransformationAmplitude,"EnsembleAverage"]-1}];StatusDimension[TransformationAmplitude,"EnsembleAverage"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"EnsembleAverage"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"NormalizationFactor"]=4;StatusPatternPrefix[TransformationAmplitude,"NormalizationFactor"]=Repeated[_,{StatusPosition[TransformationAmplitude,"NormalizationFactor"]-1}];StatusDimension[TransformationAmplitude,"NormalizationFactor"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"NormalizationFactor"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"NormalizationFactor"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"NormalizationFactor"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"BackgroundGenerator"]=5;StatusPatternPrefix[TransformationAmplitude,"BackgroundGenerator"]=Repeated[_,{StatusPosition[TransformationAmplitude,"BackgroundGenerator"]-1}];StatusDimension[TransformationAmplitude,"BackgroundGenerator"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"BackgroundGenerator"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"BackgroundGenerator"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"BackgroundGenerator"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"InitialDensityOperator"]=6;StatusPatternPrefix[TransformationAmplitude,"InitialDensityOperator"]=Repeated[_,{StatusPosition[TransformationAmplitude,"InitialDensityOperator"]-1}];StatusDimension[TransformationAmplitude,"InitialDensityOperator"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"InitialDensityOperator"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"InitialDensityOperator"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"InitialDensityOperator"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"Observables"]=7;StatusPatternPrefix[TransformationAmplitude,"Observables"]=Repeated[_,{StatusPosition[TransformationAmplitude,"Observables"]-1}];StatusDimension[TransformationAmplitude,"Observables"]=4;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"Observables"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"Observables"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"Observables"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"Events"]=8;StatusPatternPrefix[TransformationAmplitude,"Events"]=Repeated[_,{StatusPosition[TransformationAmplitude,"Events"]-1}];StatusDimension[TransformationAmplitude,"Events"]=4;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"Events"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"Events"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"Events"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"Precalculation"]=9;StatusPatternPrefix[TransformationAmplitude,"Precalculation"]=Repeated[_,{StatusPosition[TransformationAmplitude,"Precalculation"]-1}];StatusDimension[TransformationAmplitude,"Precalculation"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"Precalculation"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"Precalculation"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"Precalculation"],
{True..},morest___},more___]:=
TransformationAmplitude[
Evaluate@{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"UserLevel"]=10;StatusPatternPrefix[TransformationAmplitude,"UserLevel"]=Repeated[_,{StatusPosition[TransformationAmplitude,"UserLevel"]-1}];StatusDimension[TransformationAmplitude,"UserLevel"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"UserLevel"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"UserLevel"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"UserLevel"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitude,"Ready"]=11;StatusPatternPrefix[TransformationAmplitude,"Ready"]=Repeated[_,{StatusPosition[TransformationAmplitude,"Ready"]-1}];StatusDimension[TransformationAmplitude,"Ready"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitude,"Ready"],
False,morest___},more___]:=TransformationAmplitude[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitude,"Ready"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitude,"Ready"],
{True..},morest___},more___]:=
TransformationAmplitude[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[{True..},more___]:=TransformationAmplitude[True,more];


(* ::Input::Initialization:: *)
TransformationAmplitude[{locst:{False,checked_,morelocst___},morest___},items___,opts___Rule]:=TransformationAmplitude[{{True,False,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[{locst:{True,False,morelocst___},morest___},items:(Except[_Rule]...),opts___Rule]:=
If[
MatchQ[Chronology/.{opts}/.Options[TransformationAmplitude],"RightToLeft"|"LeftToRight"],
TransformationAmplitude[{{True,True,morelocst},morest},items,opts],
(Message[TransformationAmplitude::invalchron];$Failed)
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{locst:{True,True,False},
morest1:Repeated[_,{StatusPosition[TransformationAmplitude,"Events"]-StatusPosition[TransformationAmplitude,"Chronology"]-1}],
evst:True,
morest2___},
more:(Except[_Rule]...),opts___Rule]:=TransformationAmplitude[{{True,True,True},morest1,evst,morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],locst:{False,morelocst___},
morest___},
items___,opts___Rule]:=
TransformationAmplitude[
{prefix,{True,morelocst},morest},items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
locst:{True,False,morelocst___},
morest___},
\[Rho]ini_->obs_,
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitude[{prefix,{True,True,morelocst},morest},\[Rho]ini,Hold[obs],items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
locst:{True,False,morelocst___},
morest___},
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitude[{prefix,{True,True,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
locst:{True,True,False,morelocst___},
morest___},
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitude[{prefix,{True,True,True,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]:=
TransformationAmplitude[
{prefix,{True,morelocst},morest},
items,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],locst:{True,False,_,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]/;MatchQ[ReleaseHold@ensav,None|False]:=
TransformationAmplitude[{prefix,{True,True,True,morelocst},morest},more,
Evaluate@SimplifyRules[EnsembleAverage->False,opts1,opts2
]
];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],locst:{True,False,_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;MatchQ[EnsembleAverage/.{opts}/.Options[TransformationAmplitude],None|False]:=
TransformationAmplitude[{prefix,{True,True,True,morelocst},morest},more,
Evaluate@SimplifyRules[EnsembleAverage->False,opts
]
];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
TransformationAmplitude[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[EnsembleAverage->StandardizeEnsembleAverage[ensav],opts1,opts2
]
];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],locst:{True,True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
Module[{modmore,modopts},(
{modmore,modopts}=
ExpandMultidimensionalEnsembleVariables[
{{more},{opts1,opts2}},
ensav
];
TransformationAmplitude[{prefix,{True,True,True,morelocst},morest},
Evaluate[Sequence@@ReleaseHold@modmore],
Evaluate@SimplifyRules[
EnsembleAverage->ExpandMultidimensionalEnsembleVariables@ensav,
Sequence@@ReleaseHold@modopts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitude,"NormalizationFactor"],
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]:=
TransformationAmplitude[
{prefix,
{True,morelocst},
morest},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Module[{normfac},(
normfac=NormalizationFactor/.{opts}/.Options[TransformationAmplitude];
Switch[
normfac,
False|None,TransformationAmplitude[{prefix,True,morest},more,Evaluate@SimplifyRules[NormalizationFactor->1,opts]],
_?NumericQ,TransformationAmplitude[{prefix,True,morest},more,Evaluate@SimplifyRules[NormalizationFactor->normfac,opts]],
_,(Message[TransformationAmplitude::badnormfac];$Failed)
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"EnsembleAverage"],
ensavst:True,
morest2:Repeated[_,{StatusPosition[TransformationAmplitude,"BackgroundGenerator"]-StatusPosition[TransformationAmplitude,"EnsembleAverage"]-1}],
locst:{False,morelocst___},
morest3___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitude[{prefix,ensavst,morest2,
{True,morelocst},morest3},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"BackgroundGenerator"],
locst:{True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule]:=
Module[{backg},(
backg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[TransformationAmplitude]])];
TransformationAmplitude[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->StandardizeGenerator[backg],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"BackgroundGenerator"],
locst:{True,True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule
]:=
Module[{backg,ensav,diagfunc,opbasis,basis},(
backg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[TransformationAmplitude]])];
ensav=EnsembleAverage/.{opts}/.Options[TransformationAmplitude];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitude];
diagfunc=Function[backg,
If[
FreeQ[{more},_PrecalculatedEvent]&&
Length[UnassignedSymbols[backg]]==0,
	Switch[backg,
	NullOperator[],backg,
	_?OperatorQ,NDiagonalize[backg,basis],
	_?SuperoperatorQ,NDiagonalize[backg,opbasis,basis],
	_,backg
	],
backg
]
];
TransformationAmplitude[
{prefix,{True,True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->diagfunc[backg],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
inputrulest:True,morest1:Repeated[_,{StatusPosition[TransformationAmplitude,"InitialDensityOperator"]-StatusPosition[TransformationAmplitude,"InputRule"]-1}],
locst:{False,morelocst___},
morest2___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitude[{prefix,True,morest1,{True,morelocst},morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:Repeated[_,{StatusPosition[TransformationAmplitude,"InitialDensityOperator"]-1}],
locst:{True,False,morelocst___},
morest___},
\[Rho]0_,more___,opts___Rule]:=
Module[{\[Rho]0vec,opbasis,basis},(
{opbasis,basis}=
{OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitude];
TransformationAmplitude[
{prefix,{True,True,morelocst},morest},
Evaluate@Operator[\[Rho]0,ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]],
more,opts
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
inputrulest:True,morest1:Repeated[_,{StatusPosition[TransformationAmplitude,"Observables"]-StatusPosition[TransformationAmplitude,"InputRule"]-1}],
locst:{False,morelocst___},
morest2___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitude[{prefix,True,morest1,{True,morelocst},morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"Observables"],locst:{True,False,morelocst___},morest___},
\[Rho]0_,obs_,more___,opts___Rule]:=
Module[{},(
If[Chop[Tr@MatrixRepresentation[\[Rho]0,ZeemanBasis[]]-1]!=0,
(If[
!FreeQ[obs,PolarizationLevelOperator],
	Message[PolarizationLevelOperator::inval\[Rho]]
];
If[!FreeQ[obs,SingletPolarizationLevelOperator],
	Message[SingletPolarizationLevelOperator::inval\[Rho]]
])
];
TransformationAmplitude[
Evaluate@{prefix,{True,True,morelocst},morest},
\[Rho]0,ReleaseHold@obs,more,opts
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"Observables"],
locst:{True,True,False,morelocst___},
morest___},
\[Rho]0_,obs_,more___,opts___Rule]:=
TransformationAmplitude[
Evaluate@{prefix,{True,True,True,morelocst},morest},
\[Rho]0,
Evaluate@If[MatchQ[obs,_List],obs,{obs}],
more,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"Observables"],
locst:{True,True,True,False,morelocst___},
morest___},
\[Rho]0_,obs_List,more___,opts___Rule]:=
TransformationAmplitude[
Evaluate@{prefix,{True,True,True,True,morelocst},morest},
\[Rho]0,
Evaluate[
Operator[#,ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]]&/@obs
],
more,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitude,"InputRule"],
True,
morest2:Repeated[_,{StatusPosition[TransformationAmplitude,"Events"]-StatusPosition[TransformationAmplitude,"InputRule"]-1}],
eventsst:{False,moreeventsst___},
morest3___
},
items___,opts___Rule]:=TransformationAmplitude[
{morest1,True,morest2,
{True,moreeventsst},
morest3},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitude,"Events"],
eventsst:{True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
event_,
more___,
opts___Rule]/;(MatchQ[ReleaseHold[event],(_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_?PulseSequenceQ|_EventList)]):=
TransformationAmplitude[
{morest1,
{True,True,moreeventsst},
morest2},
\[Rho]ini,ops,event,more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitude,"Events"],
eventsst:{True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
notevent:Except[_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_?PulseSequenceQ|_EventList],
more___,
opts___Rule]:=TransformationAmplitude[
{morest1,
{True,True,moreeventsst},
morest2},
\[Rho]ini,ops,None,notevent,more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitude,"Events"],
eventsst:{True,True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
event_,
more___,
opts___Rule]:=
TransformationAmplitude[
{morest1,
{True,True,True,moreeventsst},
morest2},
\[Rho]ini,ops,
Evaluate@If[PulseSequenceQ[event],PulseSequence[event],event],
more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitude,"Events"],
eventsst:{True,True,True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,event_,more___,
opts___Rule]:=
If[
MatchQ[event,(_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_PulseSequence|_EventList)],
TransformationAmplitude[
{morest1,
{True,True,True,moreeventsst},
morest2},
\[Rho]ini,ops,event,more,
opts
],
(Message[TransformationAmplitude::invalevent];$Failed)
];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitude,"Precalculation"],
locst:{False,morelocst___},
morest___
},
more___,
opts___Rule]:=
TransformationAmplitude[
Evaluate@{prefix,True,morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"UserLevel"],locst:{False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitude[Evaluate@{prefix,{True,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"UserLevel"],{True,False,morelocst___},morest___},
more___,opts___Rule]:=
Module[{minrul,ul},(
minrul=MinimumRecommendedUserLevel/.{opts}/.Options[TransformationAmplitude];
ul=UserLevel[];
If[ul<minrul,
Message[UserLevel::toolow,ul,minrul]
];
TransformationAmplitude[
Evaluate@{prefix,{True,True,morelocst},morest},
more,opts]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"Ready"],locst:{False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitude[Evaluate@{prefix,{True,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitude,"Ready"],{True,False,morelocst___},morest___},
more___,opts___Rule]:=
Module[{ensavvars,suspectsymbols},(
ensavvars=UnassignedSymbols[EnsembleAverage/.{opts}/.Options[TransformationAmplitude]];
suspectsymbols=UnassignedSymbols[{more,opts},PermittedSymbols->ensavvars];
If[
Length[suspectsymbols]==0,
TransformationAmplitude[
Evaluate@{prefix,{True,True,morelocst},morest},
more,opts],
(
Message[TransformationAmplitude::suspsymbs,suspectsymbols];
$Failed
)
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,Evaluate@(more1:Except[GeneralStatusListPattern]),more2:Except[_Rule]...,opts___Rule]/;MatchQ[EnsembleAverage/.{opts}/.Options[TransformationAmplitude],None|False]:=
TransformationAmplitude[True,True,False,more1,more2,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,Evaluate@(more1:Except[GeneralStatusListPattern]),more2___,opts___Rule]:=
TransformationAmplitude[True,{True,False,False},more1,more2,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,{True,False,False},
more___,opts___Rule]:=
Module[{opbasis,basis},(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitude];
If[MatchQ[Parallel/.{opts}/.Options[TransformationAmplitude],True|All|_?NumericQ],
PrepareParallel[opbasis,basis,opts]
];
TransformationAmplitude[
True,{True,True,False},
more,opts]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[
True,{True,True,False},
\[Rho]ini_,obs_,events_,
opts___Rule
]:=Module[{ensav,weights,rules,nens,vars,vals,maxbatchsize,nbatch,opbasis,basis,ib,temp,rulesandweights,rulesandweightsbatches,amplitudes,batchresult,parallel},
(
{opbasis,basis,ensav,maxbatchsize}={OperatorBasis,Basis,EnsembleAverage,MaxBatchSize}/.{opts}/.Options[TransformationAmplitude];
parallel=MatchQ[Parallel/.{opts}/.Options[TransformationAmplitude],True|All|_?NumericQ];
nens=Length[Last[ensav]];
vars=First[ensav];
vals=First/@Last[ensav];
weights=Last/@Last[ensav];
rules=Map[Apply[Rule],Transpose[{vars,#}]&/@vals,{2}];
rulesandweights=Transpose[{rules,weights}];
rulesandweightsbatches=Partition[rulesandweights,maxbatchsize,maxbatchsize,{1,1},{}];
nbatch=Length[rulesandweightsbatches];
If[nbatch==1,
PrintTemporary["computing using 1 batch .."],
PrintTemporary["computing using "<>ToString[nbatch]<>" batches.."]
];
Apply[Plus,
Monitor[
Table[(
temp=PrintTemporary[If[parallel,"parallel computing batch ","computing batch "]<>ToString[ib]<>" of "<>ToString[nbatch]<>".."];
{rules,weights}=Transpose[rulesandweightsbatches[[ib]]];
amplitudes=If[parallel,ParallelMap,Map][
Function[rule,
TransformationAmplitude[
True,True,False,
Evaluate@\[Rho]ini,
Evaluate@obs,
Evaluate[events/.rule],
Evaluate[Sequence@@SimplifyRules[
FilterRules[
{EnsembleAverage->None,opts}/.rule,
Join[Options[NPropagate],Options[NDSolve],Options[TransformationAmplitude]]
]]
]]
],
rules
];
batchresult=Plus@@MapThread[Times,{amplitudes,weights}];
NotebookDelete[temp];
batchresult
),
{ib,1,nbatch}
],
ProgressIndicator[ib,{1,nbatch+1}]
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,True,False,more___]:=TransformationAmplitude[True,True,{True,False},more];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,True,{True,False},\[Rho]ini_,ops:{_},events_,opts___Rule]:=
If[!FreeQ[#,$Failed],$Failed,First[#]]&@
TransformationAmplitude[True,True,True,\[Rho]ini,ops,events,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,True,{True,False},\[Rho]ini_,ops:{_,__},events_,opts___Rule]:=
TransformationAmplitude[True,True,True,\[Rho]ini,ops,events,opts];


(* ::Input::Initialization:: *)
TransformationAmplitude[True,True,True,\[Rho]ini_,ops_List,events_,opts___Rule]:=
Module[{\[Rho]vecfinal,norm,opnormsqlist,opbasis,basis,optstopassdown},(
{norm,opbasis,basis}={NormalizationFactor,OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitude];
optstopassdown=Sequence@@CurrentOptionsToPassDown[TransformationAmplitude,NPropagate];
opnormsqlist=(OperatorNorm[#]^2)&/@ops;
\[Rho]vecfinal=
NPropagate[events,OperatorBasis-> opbasis,Basis-> basis,
Sequence@@FilterRules[{SimplifyRules[Continuous->False,opts,optstopassdown]},Join[Options[NPropagate],Options[NDSolve]]
],opts][\[Rho]ini];
If[!FreeQ[\[Rho]vecfinal,$Failed],
$Failed,
MapThread[
Chop@N[(Conjugate[OperatorVectorRepresentation[#1,opbasis,basis]].OperatorVectorRepresentation[\[Rho]vecfinal,opbasis,basis])/(norm*#2)]&,
{ops,opnormsqlist}
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitude::invalchron="Invalid value for Chronology.";


(* ::Input::Initialization:: *)
TransformationAmplitude::invalevent="Invalid event specification encountered.";


(* ::Input::Initialization:: *)
TransformationAmplitude::badnormfac="The normalization factor must be None, False, or numeric.";


(* ::Input::Initialization:: *)
TransformationAmplitude::suspsymbs="The following symbols do not have numerical values: `1`.";


(* ::Input::Initialization:: *)
TransformationAmplitude::badsyntax="There is a syntax error in TransformationAmplitude. A common error is to place one or more option rules of the form a\[Rule]b before one of the other arguments.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::inapplims="The limits of the iterator and its increment must be integers.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::badensvar="The variable used in the EnsembleAverage may not have an assigned value.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::nprecalnotfound="Cannot find a value of the iterator specifying the timing of all precalculation symbols. The timing will be determined using the iterator `1` = `2`.";


(* ::Input::Initialization:: *)
Options[TransformationAmplitudeTable]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
NormalizationFactor->None,
UseMatrixExpWhenPossible->True,
UseHilbertSpaceWhenPossible->True,
InitialTimePoint->0,
BackgroundGenerator->None,
EnsembleAverage->False,
TableCoordinates->Automatic,
Chronology:>$Chronology,
Parallel->True,
MaxBatchSize->128,
TableVariables->Undefined,
MinimumRecommendedUserLevel->1
};


(* ::Input::Initialization:: *)
SetAttributes[TransformationAmplitudeTable,HoldAll]


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@GeneralStatusListPattern,args___]/;!FreeQ[Hold@{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate[Except[GeneralStatusListPattern]],
Except[_Rule]..,_Rule,___,Except[_Rule],___
]:=(Message[TransformationAmplitudeTable::badsyntax];$Failed);


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate[arg:Except[GeneralStatusListPattern]],moreA___,BackgroundGenerator-> backg_,moreB___]:=TransformationAmplitudeTable[False,arg,moreA,BackgroundGenerator-> Hold[backg],moreB];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate[arg:Except[GeneralStatusListPattern]],moreA___,TableCoordinates-> tabcoord_,moreB___]:=TransformationAmplitudeTable[False,arg,moreA,TableCoordinates-> Hold[tabcoord],moreB];


(* ::Input::Initialization:: *)
StatusDimension[TransformationAmplitudeTable]=13;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate[arg:Except[GeneralStatusListPattern]],more___]:=TransformationAmplitudeTable[False,arg,more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[False,items___,opts___Rule]:=TransformationAmplitudeTable[Evaluate@Table[False,{StatusDimension[TransformationAmplitudeTable]}],items,opts];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Chronology"]=1;StatusDimension[TransformationAmplitudeTable,"Chronology"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[{chronst:False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{Table[False,{StatusDimension[TransformationAmplitudeTable,"Chronology"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[{chronst:{True..},morest___},more___]:=TransformationAmplitudeTable[{True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"InputRule"]=2;StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"InputRule"]-1}];StatusDimension[TransformationAmplitudeTable,"InputRule"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"InputRule"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Iterators"]=3;StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Iterators"]-1}];StatusDimension[TransformationAmplitudeTable,"Iterators"]=6;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"Iterators"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"TableCoordinates"]=4;StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"TableCoordinates"]-1}];StatusDimension[TransformationAmplitudeTable,"TableCoordinates"]=4;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"TableCoordinates"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"EnsembleAverage"]=5;StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"EnsembleAverage"]-1}];StatusDimension[TransformationAmplitudeTable,"EnsembleAverage"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"EnsembleAverage"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"NormalizationFactor"]=6;StatusPatternPrefix[TransformationAmplitudeTable,"NormalizationFactor"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"NormalizationFactor"]-1}];StatusDimension[TransformationAmplitudeTable,"NormalizationFactor"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"NormalizationFactor"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"NormalizationFactor"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"NormalizationFactor"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"BackgroundGenerator"]=7;StatusPatternPrefix[TransformationAmplitudeTable,"BackgroundGenerator"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"BackgroundGenerator"]-1}];StatusDimension[TransformationAmplitudeTable,"BackgroundGenerator"]=3;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"BackgroundGenerator"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"BackgroundGenerator"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"BackgroundGenerator"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"InitialDensityOperator"]=8;StatusPatternPrefix[TransformationAmplitudeTable,"InitialDensityOperator"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"InitialDensityOperator"]-1}];StatusDimension[TransformationAmplitudeTable,"InitialDensityOperator"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"InitialDensityOperator"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"InitialDensityOperator"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"InitialDensityOperator"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Observables"]=9;StatusPatternPrefix[TransformationAmplitudeTable,"Observables"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Observables"]-1}];StatusDimension[TransformationAmplitudeTable,"Observables"]=4;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Observables"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"Observables"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Observables"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Events"]=10;StatusPatternPrefix[TransformationAmplitudeTable,"Events"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Events"]-1}];StatusDimension[TransformationAmplitudeTable,"Events"]=4;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"Events"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Precalculation"]=11;StatusPatternPrefix[TransformationAmplitudeTable,"Precalculation"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Precalculation"]-1}];StatusDimension[TransformationAmplitudeTable,"Precalculation"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Precalculation"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"Precalculation"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Precalculation"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[
Evaluate@{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"UserLevel"]=12;StatusPatternPrefix[TransformationAmplitudeTable,"UserLevel"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"UserLevel"]-1}];StatusDimension[TransformationAmplitudeTable,"UserLevel"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"UserLevel"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"UserLevel"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"UserLevel"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[TransformationAmplitudeTable,"Ready"]=13;StatusPatternPrefix[TransformationAmplitudeTable,"Ready"]=Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Ready"]-1}];StatusDimension[TransformationAmplitudeTable,"Ready"]=2;


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Ready"],
False,morest___},more___]:=TransformationAmplitudeTable[Evaluate@{firstst,Table[False,{StatusDimension[TransformationAmplitudeTable,"Ready"]}],morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{firstst:StatusPatternPrefix[TransformationAmplitudeTable,"Ready"],
{True..},morest___},more___]:=
TransformationAmplitudeTable[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[{True..},more___]:=TransformationAmplitudeTable[True,more];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[{locst:{False,checked_,morelocst___},morest___},items___,opts___Rule]:=TransformationAmplitudeTable[{{True,False,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[{locst:{True,False,morelocst___},morest___},items:(Except[_Rule]...),opts___Rule]:=
If[
MatchQ[Chronology/.{opts}/.Options[TransformationAmplitudeTable],"RightToLeft"|"LeftToRight"],
TransformationAmplitudeTable[{{True,True,morelocst},morest},items,opts],
(Message[TransformationAmplitudeTable::invalchron];$Failed)
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{locst:{True,True,False},
morest1:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Events"]-StatusPosition[TransformationAmplitudeTable,"Chronology"]-1}],
evst:True,
morest2___},
more:(Except[_Rule]...),opts___Rule]:=TransformationAmplitudeTable[{{True,True,True},morest1,evst,morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],locst:{False,morelocst___},
morest___},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{prefix,{True,morelocst},morest},items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
locst:{True,False,morelocst___},
morest___},
\[Rho]ini_->obs_,
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitudeTable[{prefix,{True,True,morelocst},morest},\[Rho]ini,Hold[obs],items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
locst:{True,False,morelocst___},
morest___},
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitudeTable[{prefix,{True,True,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
locst:{True,True,False,morelocst___},
morest___},
items:(Except[_Rule]...),
opts___Rule
]:=
TransformationAmplitudeTable[{prefix,{True,True,True,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
True,
morest1:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Iterators"]-StatusPosition[TransformationAmplitudeTable,"InputRule"]-1}],
locst:{False,morelocst___},
morest2:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Events"]-StatusPosition[TransformationAmplitudeTable,"Iterators"]-1}],
True,
morest3___},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{prefix,True,morest1,
{True,morelocst},
morest2, True,morest3},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,False,morelocst___},
morest___},
\[Rho]ini_,obs_,events_,
iterspecs:{Except[_List]..,Except[_List]|{_Integer}}..,
opts___Rule
]:=
TransformationAmplitudeTable[
{prefix,{True,True,morelocst},morest},
\[Rho]ini,obs,events,
{iterspecs},
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,False,morelocst___},
morest___},
\[Rho]ini_,obs_,events_,
iterlists:{{Except[_List]..,Except[_List]|{_Integer}}..},
opts___Rule
]:=
TransformationAmplitudeTable[
{prefix,{True,True,morelocst},morest},
\[Rho]ini,obs,events,
iterlists,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,True,False,morelocst___},
morest___},
\[Rho]ini_,obs_,events_,
iterlists:{{Except[_List]..,Except[_List]|{_Integer}}..},
opts___Rule
]:=
Module[{tabvars},(
tabvars=First/@iterlists;
TransformationAmplitudeTable[
{prefix,{True,True,True,morelocst},morest},
\[Rho]ini,obs,events,
iterlists,
Evaluate@SimplifyRules[
TableVariables->tabvars,
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,True,True,False,morelocst___},
morest___},
items___,
opts___Rule
]:=
Module[{tabvars},(
tabvars=TableVariables/.{opts}/.Options[TransformationAmplitudeTable];
If[!MatchQ[tabvars,{_Symbol..}],
(Message[TransformationAmplitudeTable::invaltabvars];$Failed),
TransformationAmplitudeTable[
{prefix,{True,True,True,True,morelocst},morest},
items,opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,True,True,True,False,morelocst___},
morest___},
\[Rho]ini_,obs_,events_,
iterlists:{{Except[_List]..,Except[_List]|{_Integer}}..},
opts___Rule
]:=
TransformationAmplitudeTable[
{prefix,{True,True,True,True,True,morelocst},morest},
\[Rho]ini,obs,events,
Evaluate[
Map[(#//.{
{v_Symbol,vmax:Except[_List]}:>{v,0,vmax},{v_Symbol,vmin:Except[_List],vmax:Except[_List]}:>{v,vmin,vmax,1},
{v_Symbol,vmin:Except[_List],vmax:Except[_List],{nv_}}:>
(If[(!IntegerQ[nv])||(nv<1),Message[TransformationAmplitudeTable::badnumincr]];
{v,vmin,vmax,(vmax-vmin)/Max[nv-1,1]}),
{v_Symbol,vmax:Except[_List],{nv_}}:>
(If[(!IntegerQ[nv])||(nv<1),Message[TransformationAmplitudeTable::badnumincr]];
{v,0,vmax,vmax/Max[nv-1,1]})
})&,
iterlists
]
],
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
locst:{True,True,True,True,True,False,morelocst___},
morest___},
\[Rho]ini_,obs_,events_,
iterlists:{{Except[_List]..}..},
opts___Rule
]:=
If[!MatchQ[iterlists,{{_Symbol,_?NumericQ,_?NumericQ,_?NumericQ}..}],
(Message[TransformationAmplitudeTable::invaliter];$Failed),
TransformationAmplitudeTable[{prefix,{True,True,True,True,True,True,morelocst},morest},\[Rho]ini,obs,events,iterlists,opts]
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]/;MatchQ[ReleaseHold[TableCoordinates/.{opts}/.Options[TransformationAmplitudeTable]],None]:=
TransformationAmplitudeTable[
{prefix,True,morest},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
True,
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{prefix,True,
{True,morelocst},
morest},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
locst:{True,False,morelocst___},
morest___
},
items__,opts___Rule]:=
Module[{tabcoordfuncs,tabcoords,tabvars},(
{tabcoordfuncs,tabvars}=ReleaseHold[{TableCoordinates,TableVariables}/.{opts}/.Options[TransformationAmplitudeTable]];
TransformationAmplitudeTable[
{prefix,
{True,True,morelocst},
morest},
items,
Evaluate@SimplifyRules[
TableCoordinates->
Switch[
{tabcoordfuncs,tabvars},
	{Automatic,_},tabvars,
	{Except[_List],{_}},{tabcoordfuncs},
	_,tabcoordfuncs
],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
locst:{True,True,False,morelocst___},
morest___
},
\[Rho]ini_,obs_,events_,
iterlists:{{Except[_List]..}..},
opts___Rule]:=
Module[{tabcoordfuncs,tabcoords,tabvars},(
{tabcoordfuncs,tabvars}={TableCoordinates,TableVariables}/.{opts}/.Options[TransformationAmplitudeTable];
TransformationAmplitudeTable[
{prefix,{True,True,True,morelocst},morest},
\[Rho]ini,obs,events,
iterlists,
Evaluate@SimplifyRules[
TableCoordinates->
SortBy[
Flatten[Table[Evaluate@tabcoordfuncs,Evaluate[Sequence@@iterlists]],Length[tabvars]-1],
N
],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"TableCoordinates"],
locst:{True,True,True,False,morelocst___},
morest___
},
items___,
opts___Rule]:=
Module[{tabcoords,tabvars},(
{tabcoords,tabvars}={TableCoordinates,TableVariables}/.{opts}/.Options[TransformationAmplitudeTable];
If[
MatchQ[tabcoords,{{Repeated[_,{Length[tabvars]}]}..}],
TransformationAmplitudeTable[
{prefix,{True,True,True,True,morelocst},morest},
items,opts
],
(
If[Length[tabvars]==1,
Message[TransformationAmplitudeTable::invaltabcoords1],
Message[TransformationAmplitudeTable::invaltabcoordsn,Length[tabvars]]
];
$Failed
)
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{prefix,{True,morelocst},morest},
items,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;MatchQ[EnsembleAverage/.{opts}/.Options[TransformationAmplitudeTable],False|None]:=
Module[{dummyensvar},(
TransformationAmplitudeTable[
{prefix,{True,False,morelocst},morest},more,
Evaluate@SimplifyRules[
EnsembleAverage->{dummyensvar,{{{1},1}}},
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
TransformationAmplitudeTable[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[EnsembleAverage->StandardizeEnsembleAverage[ensav],opts1,opts2
]
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"EnsembleAverage"],locst:{True,True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
Module[{modmore,modopts},(
{modmore,modopts}=
ExpandMultidimensionalEnsembleVariables[
{{more},{opts1,opts2}},
ensav
];
TransformationAmplitudeTable[{prefix,{True,True,True,morelocst},morest},
Evaluate[Sequence@@ReleaseHold@modmore],
Evaluate@SimplifyRules[
EnsembleAverage->ExpandMultidimensionalEnsembleVariables@ensav,
Sequence@@ReleaseHold@modopts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"NormalizationFactor"],
locst:{False,morelocst___},
morest___
},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{prefix,
{True,morelocst},
morest},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Module[{normfac},(
normfac=NormalizationFactor/.{opts}/.Options[TransformationAmplitudeTable];
Switch[
normfac,
False|None,TransformationAmplitudeTable[{prefix,True,morest},more,Evaluate@SimplifyRules[NormalizationFactor->1,opts]],
_?NumericQ,TransformationAmplitudeTable[{prefix,True,morest},more,Evaluate@SimplifyRules[NormalizationFactor->normfac,opts]],
_,(Message[TransformationAmplitudeTable::badnormfac];$Failed)
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Iterators"],
iterst:True,morest1:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"EnsembleAverage"]-StatusPosition[TransformationAmplitudeTable,"Iterators"]-1}],ensavst:True,
morest2:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"BackgroundGenerator"]-StatusPosition[TransformationAmplitudeTable,"EnsembleAverage"]-1}],
locst:{False,morelocst___},
morest3___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeTable[{prefix,True,morest1,True,morest2,
{True,morelocst},morest3},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"BackgroundGenerator"],
locst:{True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule]:=
Module[{backg},(
backg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[TransformationAmplitudeTable]])];
TransformationAmplitudeTable[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->StandardizeGenerator[backg],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"BackgroundGenerator"],
locst:{True,True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule
]:=
Module[{backg,ensav,diagfunc,opbasis,basis,tabvars},(
backg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[TransformationAmplitudeTable]])];
ensav=EnsembleAverage/.{opts}/.Options[TransformationAmplitudeTable];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitudeTable];
tabvars=TableVariables/.{opts}/.Options[TransformationAmplitudeTable];
diagfunc=Function[backg,
If[
FreeQ[{more},_PrecalculatedEvent]&&Length[UnassignedSymbols[backg]]==0,
	Switch[backg,
	NullOperator[],backg,
	_?OperatorQ,NDiagonalize[backg,basis],
	_?SuperoperatorQ,NDiagonalize[backg,opbasis,basis],
	_,backg
	],
backg
]
];
TransformationAmplitudeTable[
{prefix,{True,True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->diagfunc[backg],
opts
]
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
inputrulest:True,morest1:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"InitialDensityOperator"]-StatusPosition[TransformationAmplitudeTable,"InputRule"]-1}],
locst:{False,morelocst___},
morest2___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeTable[{prefix,True,morest1,{True,morelocst},morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"InitialDensityOperator"]-1}],
locst:{True,False,morelocst___},
morest___},
\[Rho]0_,more___,opts___Rule]:=
Module[{\[Rho]0vec,opbasis,basis},(
{opbasis,basis}=
{OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitudeTable];
TransformationAmplitudeTable[
{prefix,{True,True,morelocst},morest},
Evaluate@Operator[\[Rho]0,ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]],
more,opts
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
inputrulest:True,morest1:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Observables"]-StatusPosition[TransformationAmplitudeTable,"InputRule"]-1}],
locst:{False,morelocst___},
morest2___},
more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeTable[{prefix,True,morest1,{True,morelocst},morest2},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Observables"],locst:{True,False,morelocst___},morest___},
\[Rho]0_,obs_,more___,opts___Rule]:=
Module[{},(
If[Chop[Tr@MatrixRepresentation[\[Rho]0,ZeemanBasis[]]-1]!=0,
(If[
!FreeQ[obs,PolarizationLevelOperator],
	Message[PolarizationLevelOperator::inval\[Rho]]
];
If[!FreeQ[obs,SingletPolarizationLevelOperator],
	Message[SingletPolarizationLevelOperator::inval\[Rho]]
])
];
TransformationAmplitudeTable[
Evaluate@{prefix,{True,True,morelocst},morest},
\[Rho]0,ReleaseHold@obs,more,opts
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Observables"],
locst:{True,True,False,morelocst___},
morest___},
\[Rho]0_,obs_,more___,opts___Rule]:=
TransformationAmplitudeTable[
Evaluate@{prefix,{True,True,True,morelocst},morest},
\[Rho]0,
Evaluate@If[MatchQ[obs,_List],obs,{obs}],
more,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Observables"],
locst:{True,True,True,False,morelocst___},
morest___},
\[Rho]0_,obs_List,more___,opts___Rule]:=
TransformationAmplitudeTable[
Evaluate@{prefix,{True,True,True,True,morelocst},morest},
\[Rho]0,
Evaluate[
Operator[#,ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]]&/@obs
],
more,opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitudeTable,"InputRule"],
True,
morest2:Repeated[_,{StatusPosition[TransformationAmplitudeTable,"Events"]-StatusPosition[TransformationAmplitudeTable,"InputRule"]-1}],
eventsst:{False,moreeventsst___},
morest3___
},
items___,opts___Rule]:=
TransformationAmplitudeTable[
{morest1,True,morest2,
{True,moreeventsst},
morest3},
items,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
eventsst:{True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
notevent:Except[_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_?PulseSequenceQ],
more___,
opts___Rule]:=
TransformationAmplitudeTable[
{morest1,
{True,True,moreeventsst},
morest2},
\[Rho]ini,ops,None,notevent,more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
eventsst:{True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
event:(_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_?PulseSequenceQ),
more___,
opts___Rule]:=
TransformationAmplitudeTable[
{morest1,
{True,True,moreeventsst},
morest2},
\[Rho]ini,ops,event,more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
eventsst:{True,True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,
event_,
more___,
opts___Rule]:=
TransformationAmplitudeTable[
{morest1,
{True,True,True,moreeventsst},
morest2},
\[Rho]ini,ops,
Evaluate@If[PulseSequenceQ[event],PulseSequence[event],event],
more,
opts
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
morest1:StatusPatternPrefix[TransformationAmplitudeTable,"Events"],
eventsst:{True,True,True,False,moreeventsst___},
morest2___
},
\[Rho]ini_,ops_,event_,more___,
opts___Rule]:=
If[
MatchQ[event,(_?ValidEventSpecificationQ|{_?ValidEventSpecificationQ..}|_PulseSequence|_EventList)],
TransformationAmplitudeTable[
{morest1,
{True,True,True,True,moreeventsst},
morest2},
\[Rho]ini,ops,event,more,
opts
],
(Message[TransformationAmplitudeTable::invalevent];$Failed)
];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{
prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Precalculation"],
locst:{False,morelocst___},
morest___
},
more___,
opts___Rule]:=
TransformationAmplitudeTable[
Evaluate@{prefix,True,morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"UserLevel"],locst:{False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeTable[Evaluate@{prefix,{True,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"UserLevel"],{True,False,morelocst___},morest___},
more___,opts___Rule]:=
Module[{minrul,ul},(
minrul=MinimumRecommendedUserLevel/.{opts}/.Options[TransformationAmplitudeTable];
ul=UserLevel[];
If[ul<minrul,
Message[UserLevel::toolow,ul,minrul]
];
TransformationAmplitudeTable[
Evaluate@{prefix,{True,True,morelocst},morest},
more,opts]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Ready"],locst:{False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
TransformationAmplitudeTable[Evaluate@{prefix,{True,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
Evaluate@{prefix:StatusPatternPrefix[TransformationAmplitudeTable,"Ready"],{True,False,morelocst___},morest___},
more___,opts___Rule]:=
Module[{ensavvars,tabvars,suspectsymbols},(
ensavvars=UnassignedSymbols[EnsembleAverage/.{opts}/.Options[TransformationAmplitudeTable]];
tabvars=TableVariables/.{opts}/.Options[TransformationAmplitudeTable];
suspectsymbols=UnassignedSymbols[{more,opts},PermittedSymbols->Join[ensavvars,tabvars]];
If[
Length[suspectsymbols]==0,
TransformationAmplitudeTable[
Evaluate@{prefix,{True,True,morelocst},morest},
more,opts],
(Message[TransformationAmplitudeTable::suspsymbs,suspectsymbols];$Failed)
]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[True,Evaluate@(more1:Except[GeneralStatusListPattern]),more2___,opts___Rule]:=
TransformationAmplitudeTable[True,{True,False,False},more1,more2,opts];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[True,{True,False,False},
more___,opts___Rule]:=
Module[{opbasis,basis},(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[TransformationAmplitudeTable];
If[MatchQ[Parallel/.{opts}/.Options[TransformationAmplitudeTable],True|All|_?NumericQ],
PrepareParallel[opbasis,basis,opts]
];
TransformationAmplitudeTable[
True,{True,True,False},
more,opts]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable[
True,{True,True,False},
\[Rho]ini_,obs_,events_,iterlists_,
opts___Rule
]:=Module[{ensav,weights,rules,nens,nvar,vars,maxbatchsize,nbatch,opbasis,basis,ib,temp,tabvars,itervals,rulesandweights,rulesandweightsbatches,coords,amplitudes,batchresult,parallel,optstopassdown},
(
{opbasis,basis,ensav,maxbatchsize,tabvars}={OperatorBasis,Basis,EnsembleAverage,MaxBatchSize,TableVariables}/.{opts}/.Options[TransformationAmplitudeTable];
optstopassdown=Sequence@@CurrentOptionsToPassDown[TransformationAmplitudeTable,TransformationAmplitude];
parallel=MatchQ[Parallel/.{opts}/.Options[TransformationAmplitudeTable],True|All|_?NumericQ];
nens=Length[Last[ensav]];
nvar=Map[Function[iter,Length[Range@@iter[[2;;]]]],iterlists];
vars=Join[tabvars,First[ensav]];
itervals=Flatten[Table[tabvars,Evaluate[Sequence@@iterlists]],Length[tabvars]-1];
rulesandweights=
Flatten[
Outer[
{Map[Apply[Rule],
Transpose[{vars,Join[#1,First[#2]]}]
],
Last[#2]
}&,
itervals,Last[ensav],1
],
1
];
rulesandweightsbatches=Partition[rulesandweights,maxbatchsize,maxbatchsize,{1,1},{}];
nbatch=Length[rulesandweightsbatches];
If[nbatch==1,
PrintTemporary["computing using 1 batch .."],
PrintTemporary["computing using "<>ToString[nbatch]<>" batches.."]
];
CombineAndSort[
Monitor[
Table[(
temp=PrintTemporary[
If[parallel,"parallel computing batch ","computing batch "]<>ToString[ib]<>" of "<>ToString[nbatch]<>".."
];
{rules,weights}=Transpose[rulesandweightsbatches[[ib]]];
If[parallel,DistributeDefinitions[optstopassdown]];
amplitudes=If[parallel,ParallelMap,Map][
Function[rule,
TransformationAmplitude[True,True,True,
Evaluate[\[Rho]ini],Evaluate[obs],
Evaluate[events/.rule],
Evaluate[
Sequence@@SimplifyRules[
FilterRules[
{EnsembleAverage->None,opts,optstopassdown}/.rule,
Join[{Options[TransformationAmplitude],Options[NPropagate],Options[NDSolve]}
]
]
]]
]
],
rules
];
coords=(tabvars/.#)&/@rules;
batchresult=MapThread[Join[#1,Times[#2,{#3}]]&,{coords,weights,amplitudes}];
NotebookDelete[temp];
batchresult
),
{ib,1,nbatch}
],
ProgressIndicator[ib,{1,nbatch+1}]
],
opts
]
)];


(* ::Input::Initialization:: *)
CombineAndSort[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
CombineAndSort[data:{{_List..}..}..,opts___Rule]:=CombineAndSort[Join@@data,opts];


(* ::Input::Initialization:: *)
CombineAndSort[data:{{Except[_List]..,_List}..},opts___Rule]:=
Module[{decimateddata,tabcoords,vals,output},(
tabcoords=TableCoordinates/.{opts}/.Options[TransformationAmplitudeTable];
decimateddata=
SortBy[data,N[First[#]]&]//.{a___,{vars:Except[_List]..,val1_},{vars:Except[_List]..,val2_},b___}:>{a,{vars,val1+val2},b};
vals=Transpose[Last/@decimateddata];
output=Map[
Function[vals,
MapThread[Append,{tabcoords,vals}]
],
vals
];
If[Length[output]==1,First@output,output]
)];


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invalchron="Invalid value for Chronology.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invaltabcoords1="TableCoordinates should be a single expression when a single iterator is used.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invaltabcoordsn="TableCoordinates must be a list of length `1`, when `1` iterators are used.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invalevent="Invalid event specification encountered.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invaltabvars="One or more table variables has an assigned value. Each table variable must be a symbol.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::invaliter="The iteration specifications cannot be interpreted.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::badnormfac="The normalization factor must be None, False, or numeric.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::suspsymbs="The following symbols do not have numerical values: `1`.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::badnumincr="The number of increments of each variable must be an integer greater or equal to 1.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::badsyntax="There is a syntax error in TransformationAmplitudeTable. A common error is to place one or more option rules of the form a\[Rule]b before one of the parameter incrementation specifications {p,pmin,pmax,dp}.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::inapplims="The limits of the iterator and its increment must be integers.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::badensvar="The variable used in the EnsembleAverage may not have an assigned value.";


(* ::Input::Initialization:: *)
TransformationAmplitudeTable::nprecalnotfound="Cannot find a value of the iterator specifying the timing of all precalculation symbols. The timing will be determined using the iterator `1` = `2`.";


(* ::Input::Initialization:: *)
Options[MaximizeTransformationAmplitude]={Method->Automatic,ConstrainPositive->Automatic};


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[\[Rho]ini_->obs_List,more___]:=
(MaximizeTransformationAmplitude::multobs;$Failed);


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{v:Except[_List],vini:Except[_List]},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{{v,vini}},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{v:Except[_List],vini:Except[_List],vconstr_},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{{v,vini,vconstr}},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,vars_List,more:Except[(_Rule|_RuleDelayed)]...,
opts___Rule
]:=Module[{constrpos},(
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,vars,more,
SimplifyRules[ConstrainPositive->All,opts]
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
MatchQ[constrpos,True]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,varspecs:{{Except[_List],Except[_List]}..},more:Except[(_Rule|_RuleDelayed)]...,
opts___Rule
]:=Module[{constrpos,vars,varinivals},(
{vars,varinivals}=Transpose[varspecs];
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,varspecs,more,
SimplifyRules[ConstrainPositive->vars,opts]
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
MatchQ[constrpos,All]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,varspecs:{{Except[_List],Except[_List]}..},more:Except[(_Rule|_RuleDelayed)]...,opts___Rule]:=
Module[{constrpos},(
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,varspecs,more,
SimplifyRules[ConstrainPositive->{constrpos},opts]
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
!MatchQ[constrpos,_List|All|False|True|Automatic]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,varspecs:{{Except[_List],Except[_List]}..},more:Except[(_Rule|_RuleDelayed)]...,
opts___Rule
]:=Module[{constrpos,constrposvars},(
constrposvars=constrpos;
If[
!SubsetQ[First/@varspecs,constrposvars],
(Message[
MaximizeTransformationAmplitude::badconstrvar,constrposvars];
$Failed
),
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
varspecs/.(({#1,inival_}:>{#1,inival,{0}})&/@constrposvars),
more,
SimplifyRules[ConstrainPositive->Automatic,opts]
]
])/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
MatchQ[constrpos,{_Symbol..}]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,varspecs:{___,{Except[_List],Except[_List],_},___},more:Except[(_Rule|_RuleDelayed)]...,
opts___Rule
]:=Module[{constrpos,constrposvars},(
Message[MaximizeTransformationAmplitude::constrposconf,constrpos];
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
varspecs,
more,
SimplifyRules[ConstrainPositive->Automatic,opts]
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
!MatchQ[constrpos,Automatic]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,varspecs:{{Except[_List],Except[_List]}..},
more:Except[(_Rule|_RuleDelayed)]...,
opts___Rule
]:=Module[{constrpos,constrposvars},(
constrposvars=constrpos;
MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
varspecs,more,
SimplifyRules[ConstrainPositive->False,opts]
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
MatchQ[constrpos,Automatic]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{va___,{vb:Except[_List],vbini:Except[_List],vbmin:Except[_List]},vc___},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{va,{vb,vbini,{vbmin}},vc},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{va___,{vb:Except[_List],vbini:Except[_List],{vbmin:Except[_List]}},vc___},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{va,{vb,vbini,{vbmin,Infinity}},vc},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{va___,{vb:Except[_List],vbini:Except[_List]},vc___,vd:{Except[_List],Except[_List],{Except[_List],Except[_List]}},ve___},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{va,{vb,vbini,{-Infinity,Infinity}},vc,vd,ve},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,events_,
{va___,vb:{Except[_List],Except[_List],{Except[_List],Except[_List]}},vc___,{vd:Except[_List],vdini:Except[_List]},ve___},more___
]:=MaximizeTransformationAmplitude[
\[Rho]ini->obs,events,
{va,vb,vc,{vd,vdini,{-Infinity,Infinity}},ve},more
];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,
events_,
varspecs:{{_,_}..},
opts:(_Rule|_RuleDelayed)...
]:=
Module[{negta,minval,varrules,vars,varinivals,nvar,method,constrpos},(
{vars,varinivals}=Transpose[varspecs];
nvar=Length[vars];
negta[Repeated[_?NumericQ,{nvar}]]:=
-TransformationAmplitude[\[Rho]ini->obs,
events,
Evaluate[Sequence@@FilterRules[{opts},Options[TransformationAmplitude]]]
];
Message[MaximizeTransformationAmplitude::unconstr];
method=
Method/.{opts}/.Options[MaximizeTransformationAmplitude]/.{Automatic->"InteriorPoint"};
If[!MatchQ[method,Automatic],Message[MaximizeTransformationAmplitude::meth,method]];
Check[
({minval,varrules}=
FindMinimum[
negta[Sequence@@vars],
varspecs,
Evaluate[Sequence@@FilterRules [
Join[
{Method->method,opts},
Options[MaximizeTransformationAmplitude]
],
Options[FindMinimum]
]
]
];
{-minval,varrules}),
(Message[MaximizeTransformationAmplitude::fail];
$Failed),
{Event::negdur,Delay::negdur,Pulse::inval\[Beta],Pulse::inval\[Phi],Pulse::neg\[Tau],ShapedPulse::invaldur,FindMinimum::nrnum}
]
)/;(
constrpos=ConstrainPositive/.{opts}/.Options[MaximizeTransformationAmplitude];
MatchQ[constrpos,False]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude[
\[Rho]ini_->obs_,
events_,
varspecs:{{_,_,{_,_}}..},
opts:(_Rule|_RuleDelayed)...
]:=
Module[{negta,minval,varrules,vars,varinivals,nvar,method,varbounds,varminvals,varmaxvals,constraints},(
{vars,varinivals,varbounds}=Transpose[varspecs];
{varminvals,varmaxvals}=Transpose[varbounds];
constraints=And@@MapThread[(#1<=#2<=#3)&,{varminvals,vars,varmaxvals}];
Message[MaximizeTransformationAmplitude::constr,constraints];nvar=Length[vars];
negta[vars:Repeated[_?NumericQ,{nvar}]]:=
Module[{varvals,reflvarvals},(
varvals={vars};
reflvarvals=MapThread[
Which[
#1>#2,#1+Abs[#2-#1],
#2>#3,#3-Abs[#2-#3],
True,#2]&,
{varminvals,varvals,varmaxvals}
];
-TransformationAmplitude[\[Rho]ini->obs,
events,
Evaluate[Sequence@@FilterRules[{opts},Options[TransformationAmplitude]]]
]/.MapThread[(#1->#2)&,{{vars},reflvarvals}]
)];
method=
Method/.{opts}/.Options[MaximizeTransformationAmplitude];
If[!MatchQ[method,Automatic],Message[MaximizeTransformationAmplitude::meth,method]];
Check[
({minval,varrules}=
FindMinimum[
{negta[Sequence@@vars],constraints},
Transpose[{vars,varinivals}],
Evaluate[Sequence@@FilterRules [
Join[
{Method->method,opts},
Options[MaximizeTransformationAmplitude]
],
Options[FindMinimum]
]
]
];
{-minval,varrules}),
(Message[MaximizeTransformationAmplitude::fail];
$Failed),
{Event::negdur,Delay::negdur,Pulse::inval\[Beta],Pulse::inval\[Phi],Pulse::neg\[Tau],ShapedPulse::invaldur,FindMinimum::nrnum}
]
)];


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::fail="An event duration, or pulse flip angle, has transgressed into an unphysical region, causing \!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\) to fail. Try again with a different starting point, or incorporate constraints on the parameters (see usage message for \!\(\*
StyleBox[\"MaximizeTransformationAmplitude\",\nFontSlant->\"Italic\"]\)).";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::multobs="Only a single target observable may be specified.";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::constr="Deploying \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\) with constraints `1`.";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::unconstr="Deploying \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\) without constraints.";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::meth="Executing \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\) using \!\(\*
StyleBox[\"Method\",\nFontSlant->\"Italic\"]\) \[Rule] \"`1`\". See the usage message for \!\(\*
StyleBox[\"FindMinimum\",\nFontSlant->\"Italic\"]\) for other possible values of \!\(\*
StyleBox[\"Method\",\nFontSlant->\"Italic\"]\). ";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::constrposconf="Explicit constraints take precedence. The directive \!\(\*
StyleBox[\"ConstrainPositive\",\nFontSlant->\"Italic\"]\)\[Rule]`1` has been ignored.";


(* ::Input::Initialization:: *)
MaximizeTransformationAmplitude::badconstrvar="One or more of the constrained variables `1` are inappropriate.";


(* ::Input::Initialization:: *)
Options[Signal1D]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
InitialDensityOperator:>opI["z"],
Preparation:>RotationSuperoperator[{\[Pi]/2,"x"}],
Observable->All,
NormalizationFactor->None,
BackgroundGenerator->None,
LineBroadening->Automatic,
SignalCalculationMethod->Automatic,
UseHilbertSpaceWhenPossible->True,
EnsembleAverage->False,
CarouselAverage->False,
ForceEvenNumberOfPoints->True,
DigitalFrequencyResolution->Automatic,
ZeroFill->True,
MatchSamplingToPeriod->True,
ReportSignalCalculationMethod->True,
Chronology:>$Chronology,
Parallel->True,
MaxBatchSize->128,
Assumptions->None,
SignalGeneratorPeriod->None,
PeriodicDetectionEventSpecificationList->None,
WarnAboutMissingPreparationBackground->True,
EnsembleVariableDimension->Undefined,
EnsembleSetUp->False,
ParallelSetUp->False,
MinimumRecommendedUserLevel->Automatic
};


(* ::Input::Initialization:: *)
SetAttributes[Signal1D,HoldRest]


(* ::Input::Initialization:: *)
SingleStatusPattern=True|False|{(True|False)...};
StatusListPattern=SingleStatusPattern|{SingleStatusPattern..}|{({SingleStatusPattern..}|SingleStatusPattern)..};
GeneralStatusListPattern=SingleStatusPattern|StatusListPattern|{StatusListPattern...};


(* ::Input::Initialization:: *)
Signal1D[
arg:Except[GeneralStatusListPattern],moreA___,BackgroundGenerator-> evbg_,moreB___]:=Signal1D[False,arg,moreA,BackgroundGenerator-> Hold[evbg],moreB];

Signal1D[arg:Except[GeneralStatusListPattern],more___]:=Signal1D[False,arg,more];


(* ::Input::Initialization:: *)
Signal1D[GeneralStatusListPattern,args___]/;!FreeQ[Hold@{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
StatusDimension[Signal1D]=13;


(* ::Input::Initialization:: *)
Signal1D[False,timing:Except[_Rule],opts___Rule]:=Signal1D[Table[False,{StatusDimension[Signal1D]}],timing,opts];


(* ::Input::Initialization:: *)
Signal1D[False,timing:Except[_Rule],evgen:Except[_Rule],opts___Rule]:=Signal1D[Table[False,{StatusDimension[Signal1D]}],timing,Hold[evgen],opts];


(* ::Input::Initialization:: *)
Signal1D[False,timing:Except[_Rule],evgen:Except[_Rule],more:(Except[_Rule]..),opts___Rule]:=Signal1D[Table[False,{StatusDimension[Signal1D]}],timing,Hold[evgen],more,opts];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"Chronology"]=1;StatusDimension[Signal1D,"Chronology"]=3;


(* ::Input::Initialization:: *)
Signal1D[{chronst:False,morest___},more___]:=Signal1D[Evaluate@{Table[False,{StatusDimension[Signal1D,"Chronology"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[{chronst:{True..},morest___},more___]:=Signal1D[{True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"Sampling"]=2;StatusPatternPrefix[Signal1D,"Sampling"]=Repeated[_,{StatusPosition[Signal1D,"Sampling"]-1}];StatusDimension[Signal1D,"Sampling"]=4;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"Sampling"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"Sampling"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"Sampling"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"AcquisitionEvents"]=3;StatusPatternPrefix[Signal1D,"AcquisitionEvents"]=Repeated[_,{StatusPosition[Signal1D,"AcquisitionEvents"]-1}];StatusDimension[Signal1D,"AcquisitionEvents"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"AcquisitionEvents"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"AcquisitionEvents"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"AcquisitionEvents"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"Preparation"]=4;StatusPatternPrefix[Signal1D,"Preparation"]=Repeated[_,{StatusPosition[Signal1D,"Preparation"]-1}];StatusDimension[Signal1D,"Preparation"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"Preparation"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"Preparation"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"Preparation"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"EnsembleAverage"]=5;StatusPatternPrefix[Signal1D,"EnsembleAverage"]=Repeated[_,{StatusPosition[Signal1D,"EnsembleAverage"]-1}];StatusDimension[Signal1D,"EnsembleAverage"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"EnsembleAverage"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"EnsembleAverage"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"EnsembleAverage"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"NormalizationFactor"]=6;StatusPatternPrefix[Signal1D,"NormalizationFactor"]=Repeated[_,{StatusPosition[Signal1D,"NormalizationFactor"]-1}];StatusDimension[Signal1D,"NormalizationFactor"]=2;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"NormalizationFactor"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"NormalizationFactor"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"NormalizationFactor"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"Observable"]=7;StatusPatternPrefix[Signal1D,"Observable"]=Repeated[_,{StatusPosition[Signal1D,"Observable"]-1}];StatusDimension[Signal1D,"Observable"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"Observable"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"Observable"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"Observable"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"BackgroundGenerator"]=8;StatusPatternPrefix[Signal1D,"BackgroundGenerator"]=Repeated[_,{StatusPosition[Signal1D,"BackgroundGenerator"]-1}];StatusDimension[Signal1D,"BackgroundGenerator"]=5;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"BackgroundGenerator"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"SignalCalculation"]=9;StatusPatternPrefix[Signal1D,"SignalCalculation"]=Repeated[_,{StatusPosition[Signal1D,"SignalCalculation"]-1}];StatusDimension[Signal1D,"SignalCalculation"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"SignalCalculation"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"SignalCalculation"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"SignalCalculation"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"SignalCalculation"],
{True,False,False},morest___},more___]:=Signal1D[{firstst,{True,{{False,False,False,False},{False,False},{False,False},{False,False,False}},False},morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"SignalCalculation"],
{True,{subcat1___,{True..},subcat2___},False},morest___},more___]:=Signal1D[{firstst,{True,{subcat1,True,subcat2},False},morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"SignalCalculation"],
{True,{True..},False},morest___},more___]:=Signal1D[{firstst,{True,True,False},morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"InitialDensityOperator"]=10;StatusPatternPrefix[Signal1D,"InitialDensityOperator"]=Repeated[_,{StatusPosition[Signal1D,"InitialDensityOperator"]-1}];StatusDimension[Signal1D,"InitialDensityOperator"]=3;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"InitialDensityOperator"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"InitialDensityOperator"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"InitialDensityOperator"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"LineBroadening"]=11;StatusPatternPrefix[Signal1D,"LineBroadening"]=Repeated[_,{StatusPosition[Signal1D,"LineBroadening"]-1}];StatusDimension[Signal1D,"LineBroadening"]=2;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"LineBroadening"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"LineBroadening"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"LineBroadening"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"UserLevel"]=12;StatusPatternPrefix[Signal1D,"UserLevel"]=Repeated[_,{StatusPosition[Signal1D,"UserLevel"]-1}];StatusDimension[Signal1D,"UserLevel"]=2;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"UserLevel"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"UserLevel"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"UserLevel"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
StatusPosition[Signal1D,"Ready"]=13;StatusPatternPrefix[Signal1D,"Ready"]=Repeated[_,{StatusPosition[Signal1D,"Ready"]-1}];StatusDimension[Signal1D,"Ready"]=2;


(* ::Input::Initialization:: *)
Signal1D[
Evaluate@{
firstst:StatusPatternPrefix[Signal1D,"Ready"],
False,morest___},more___]:=Signal1D[Evaluate@{firstst,Table[False,{StatusDimension[Signal1D,"Ready"]}],morest},more];


(* ::Input::Initialization:: *)
Signal1D[Evaluate@{firstst:StatusPatternPrefix[Signal1D,"Ready"],
{True..},morest___},more___]:=
Signal1D[{firstst,True,morest},more];


(* ::Input::Initialization:: *)
Signal1D[{True..},more___]:=Signal1D[True,more];


(* ::Input::Initialization:: *)
Signal1D[{chronst:{False,checked_,morechronst___},morest___},items:(Except[_Rule]...),opts___Rule]:=Signal1D[{{True,False,morechronst},morest},items,opts];


(* ::Input::Initialization:: *)
Signal1D[{chronst:{True,False,morechronst___},morest___},items:(Except[_Rule]...),opts___Rule]:=
If[
MatchQ[Chronology/.{opts}/.Options[Signal1D],"RightToLeft"|"LeftToRight"],
Signal1D[{{True,True,morechronst},morest},items,opts],
(Message[Signal1D::invalchron];$Failed)
];


(* ::Input::Initialization:: *)
Signal1D[{chronst:{True,True,False},sampst_,acqevst:True,prepst:True,ensavst_,normfacst_,obsst_,evbackgst:True,morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{{True,True,True},sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{False,done_,moresampst___},morest___},items:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,moresampst},morest},items,opts];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},times:({_?NumericQ,_?NumericQ}|{_List}),more___]:=
Signal1D[stat,Evaluate@Prepend[times,0],more];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},{\[Omega]SW_,k_String},more___]:=
Signal1D[stat,Evaluate@{{\[Omega]SW,k}},more];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},{times__,{\[Omega]SW___,k_String}},more___]:=
Module[{n},(
n=StringToNumberOfPoints[k];
Signal1D[stat,Evaluate@{times,{\[Omega]SW,n}},more]
)];


(* ::Input::Initialization:: *)
StringToNumberOfPoints[k_String]:=Switch[k,
"1k"|"1K",1024,
"2k"|"2K",2048,
"4k"|"4K",2^12,
"8k"|"8K",2^13,
"16k"|"16K",2^14,
"32k"|"32K",2^15,
"64k"|"64K",2^16,
"128k"|"128K",2^17,
"256k"|"256K",2^18,
"512k"|"512K",2^19,
_,(Message[Signal1D::unreck,k];1024)
];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},{tmin_,{\[Omega]spec_,n_Integer}},more___]/;n>1:=
Module[{\[Delta]t},(
\[Delta]t=2\[Pi]/\[Omega]spec;
Signal1D[stat,Evaluate@{tmin,tmin+(n-1)*\[Delta]t,{n}},more]
)];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},{tmin_,{\[Omega]spec_,n_Integer}},more___]/;n>1:=
Module[{\[Delta]t},(
\[Delta]t=2\[Pi]/\[Omega]spec;
Signal1D[stat,Evaluate@{tmin,tmin+(n-1)*\[Delta]t,{n}},more]
)];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},
{tmin_,tmax_,{n_Integer}},more___]/;n>1:=Signal1D[stat,Evaluate@{tmin,tmax,(tmax-tmin)/(n-1)},more];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},
times:{tmin_?NumericQ,tmax_?NumericQ,\[Delta]t_?NumericQ},more___]:=Signal1D[{prefix,{True,True,moresampst},morest},times,more];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"Sampling"],sampst:{True,False,moresampst___},morest___},
times:Except[{tmin_?NumericQ,tmax_?NumericQ,\[Delta]t_?NumericQ}],more___]:=
(Message[Signal1D::badtimes,times];$Failed);


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,False,moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,{True,True,{False,False},moresampst},morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{False,moresubcatst___},moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,
{True,True,
If[MatchSamplingToPeriod/.{opts}/.Options[Signal1D],
{True,moresubcatst},
True],
moresampst},
morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{True,False,moresubcatst___},moresampst___},acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,sigcalcst:True,morest___},
timing:{tmin_,tmax_,\[Delta]t_},
acqevents_,opts___Rule]/;MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],"Direct"]:=
Signal1D[
{prefix,{True,True,{True,True,moresubcatst},moresampst},acqevst,prepst,ensavst,normfacst,obsst,evbackgst,sigcalcst,morest},
timing,acqevents,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{True,False,moresubcatst___},moresampst___},acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,sigcalcst:True,morest___},
timing:{tmin_,tmax_,\[Delta]t_},
acqevents_,opts___Rule]/;MatchQ[SignalGeneratorPeriod/.{opts}/.Options[Signal1D],None|False|SignalGeneratorPeriod]:=
Signal1D[
{prefix,{True,True,{True,True,moresubcatst},moresampst},acqevst,prepst,ensavst,normfacst,obsst,evbackgst,sigcalcst,morest},
timing,acqevents,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{True,False,moresubcatst___},moresampst___},acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,sigcalcst:True,morest___},
timing:{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]/;
(
Module[{T,nsub,nsup},(
T=SignalGeneratorPeriod/.{opts}/.Options[Signal1D];
{nsub,nsup}={Round[T/\[Delta]t],Round[\[Delta]t/T]};
(EvenQ[nsub]&&(Chop@N[nsub-(T/\[Delta]t)]==0))
||(Chop@N[nsup-(\[Delta]t/T)]==0)
)]
):=
Signal1D[
{prefix,{True,True,{True,True,moresubcatst},moresampst},acqevst,prepst,ensavst,normfacst,obsst,evbackgst,sigcalcst,morest},
timing,acqevents,opts
];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{True,False,moresubcatst___},moresampst___},acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,sigcalcst:True,morest___},
timing:{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]:=
Module[{T,nsub,nsup,new\[Delta]t,newT},(
T=SignalGeneratorPeriod/.{opts}/.Options[Signal1D];
nsub=2Max[1,Round@Abs[T/(2\[Delta]t)]];
nsup=Max[1,Round@Abs[\[Delta]t/T]];
{new\[Delta]t,newT}=
Which[
nsub>1,
	(
	Message[Signal1D::new\[Delta]t,N[T/nsub]//EngineeringForm];
	{T/nsub,T}
	),
nsup>1,
	(
	Message[Signal1D::new\[Delta]t,N[T*nsup]//EngineeringForm];
	{\[Delta]t,T*nsup}
	),
True,
	{\[Delta]t,T}
];
Signal1D[
{prefix,{True,True,{True,True,moresubcatst},moresampst},acqevst,prepst,ensavst,normfacst,obsst,evbackgst,sigcalcst,morest},
Evaluate@{tmin,tmax,new\[Delta]t},
acqevents,
Evaluate@SimplifyRules[SignalGeneratorPeriod->newT,opts]
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,{True..},moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,{True,True,True,moresampst},morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,True,False,moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,{True,True,True,{False,False},moresampst},morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,True,{False,moresubcatst___},moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,
{True,True,True,
If[ForceEvenNumberOfPoints/.{opts}/.Options[Signal1D],
{True,moresubcatst},
True],
moresampst},
morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,True,{True,False,moresubcatst___},moresampst___},morest___},
timing:{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]:=
Module[{n,modtmax},(
n=Round[Abs[tmax-tmin]/\[Delta]t];
modtmax=If[EvenQ[n],(Message[Signal1D::droplast];tmax),tmax-\[Delta]t];
Signal1D[
{prefix,{True,True,True,{True,True,moresubcatst},moresampst},morest},
Evaluate@{tmin,modtmax,\[Delta]t},
acqevents,opts
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Sampling"],
sampst:{True,True,True,{True..},moresampst___},morest___},
items:(Except[_Rule]...),opts___Rule]:=
Signal1D[
{prefix,{True,True,True,True,moresampst},morest},
items,opts];


(* ::Input::Initialization:: *)
Signal1D[{chronst_,samplingst:True|{True,True,___},acqevst:{False,_,morelocst___},prepst_,ensavst:True,morest___},items:(Except[_Rule]...),opts___Rule]:=Signal1D[{chronst,samplingst,{True,False,morelocst},prepst,ensavst,morest},items,opts];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"AcquisitionEvents"],locst:{True,False,morelocst___},morest___},timing_List,opts___Rule]:=
Signal1D[status,timing,None,opts];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"AcquisitionEvents"],locst:{True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},evgen_?ValidGeneratorQ,opts___Rule]:=
Module[{backg},(
backg=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
Signal1D[
status,
{tmin,tmax,\[Delta]t},
Evaluate@{{None,tmax-tmin}},
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[
backg,
Except[_List],
	CombineGenerators[evgen,backg],
_List,
	CombineGenerators[evgen,#]&/@backg,
_,
	$Failed
],
opts
]
])
];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"AcquisitionEvents"],acqevst:{True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},events:Except[_Rule],opts___Rule]/;MatchQ[ReleaseHold[events],HoldPattern@Repeat[_,___Rule]]:=
Signal1D[status,{tmin,tmax,\[Delta]t},
Evaluate@Repeat[First@ReleaseHold[events],Automatic],opts];


(* ::Input::Initialization:: *)
Signal1D[status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},events:Except[_Rule],opts___Rule]/;
MatchQ[ReleaseHold[events],HoldPattern@Repeat[_,Automatic,___Rule]]&&
(EvenQ[Length[Range[tmin,tmax,\[Delta]t]]]||!TrueQ[ForceEvenNumberOfPoints/.{opts}/.Options[Signal1D]]):=
Module[{repev,repevdur},(
repev=First@ReleaseHold[events];
repevdur=EventDuration[repev];
If[Chop[repevdur]==0,
(Message[Signal1D::zerorepeldur];$Failed),
Signal1D[
status,
{tmin,tmax,\[Delta]t},
Evaluate@Repeat[repev,Ceiling[Abs[(tmax-tmin)/repevdur]]],opts]
]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},events:Except[_Rule],opts___Rule]/;
MatchQ[ReleaseHold[events],HoldPattern@Repeat[_,Automatic,___Rule]]&&
OddQ[Length[Range[tmin,tmax,\[Delta]t]]]&&TrueQ[ForceEvenNumberOfPoints/.{opts}/.Options[Signal1D]]:=
Module[{repev,repevdur},(
repev=First@ReleaseHold[events];
repevdur=EventDuration[repev];
If[Chop[repevdur]==0,
(Message[Signal1D::zerorepeldur];$Failed),
Signal1D[
status,
Evaluate@{tmin,tmax+\[Delta]t,\[Delta]t},
Evaluate@Repeat[repev,Ceiling[Abs[(\[Delta]t+tmax-tmin)/repevdur]]],opts]
]
)];


(* ::Input::Initialization:: *)
Signal1D[
status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,False,morelocst___},morest___},
{tmin_,tmax_,\[Delta]t_},
events:Except[_Rule],
opts___Rule]/;MatchQ[ReleaseHold[events],Except[_EventSpecifications]]:=
Module[{chron},(
chron=Chronology/.{opts}/.Options[Signal1D];
Signal1D[
status,
{tmin,tmax,\[Delta]t},
Evaluate@EventSpecifications[ReleaseHold[events],
SimplifyRules[
Chronology->chron,
Sequence@@FilterRules[{opts},Options[EventSpecifications]]
]
],
opts
]
)];


(* ::Input::Initialization:: *)
Signal1D[
status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,False,morelocst___},morest___},
{tmin_,tmax_,\[Delta]t_},
events:HoldPattern@EventSpecifications[True,evspecs_List,evspecopts___Rule],
opts___Rule]:=
Module[{dur},(
Signal1D[
status,
{tmin,tmax,\[Delta]t},
Evaluate@EventSpecifications[True,
Join[{{None,(tmax-tmin)-dur}},evspecs]//.{c___List,{b_,\[Tau]2_?NumericQ},{b_,\[Tau]1_?NumericQ},a___List}:>{c,{b,\[Tau]2+\[Tau]1},a},
evspecopts
],
opts
]
)/;(
dur=EventDuration[Evaluate@events];
dur<(tmax-tmin)
)];


(* ::Input::Initialization:: *)
Signal1D[status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},evspecs_EventSpecifications,opts___Rule]/;
EventDuration[evspecs]>=(tmax-tmin):=
Signal1D[{chronst,samplingst,{True,True,morelocst},morest},{tmin,tmax,\[Delta]t},Evaluate@evspecs,opts];


(* ::Input::Initialization:: *)
Signal1D[status:{chronst_,samplingst:True|{True,True,___},acqevst:{True,True,False,morelocst___},morest___},{tmin_,tmax_,\[Delta]t_},evspecs:Except[_Rule],opts___Rule]:=
Signal1D[{chronst,samplingst,{True,True,True,morelocst},morest},{tmin,tmax,\[Delta]t},Evaluate@EventSpecifications[evspecs],opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"Preparation"],locst:{False,done_,morelocst___},morest___},items:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},items,opts];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Preparation"],locst:{True,False,morelocst___},morest___},sampling_List,more___,opts___Rule]:=
Module[{prep,standprep},(
standprep=Switch[#,
_?ValidEventSpecificationQ|_PulseSequence,
	StandardizeEventSpecification[#],
_?PulseSequenceQ,
StandardizeEventSpecification@PulseSequence[#,opts],
{_?ValidEventSpecificationQ...},
	StandardizeEventSpecification/@#,
_,$Failed]&@prep;
Signal1D[{prefix,{True,True,morelocst},morest},sampling,more,
Evaluate@SimplifyRules[
Preparation->
EventSpecifications[
standprep,
Sequence@@FilterRules[
SimplifyRules[{Chronology->(Chronology/.{opts}/.Options[Signal1D]),opts}],
Options[EventSpecifications]
]
],
opts
]
]
)/;(
prep=Preparation/.{opts}/.Options[Signal1D];
MatchQ[prep,_?ValidEventSpecificationQ|_PulseSequence|_?PulseSequenceQ|{_?ValidEventSpecificationQ...}]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Preparation"],locst:{True,True,False,morelocst___},morest___},sampling_List,more___,opts___Rule]:=
Module[{prep},(
prep=Preparation/.{opts}/.Options[Signal1D];
If[
MatchQ[prep,EventSpecifications[True,___]],
Signal1D[{prefix,{True,True,True,morelocst},morest},sampling,more,opts],
(Message[Signal1D::invalprep,prep];$Failed)
]
)];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"EnsembleAverage"],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"EnsembleAverage"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;MatchQ[EnsembleAverage/.{opts}/.Options[Signal1D],False|None]:=Signal1D[{prefix,True,morest},more,Evaluate@SimplifyRules[EnsembleAverage->False,opts]];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"EnsembleAverage"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
Signal1D[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[EnsembleAverage->StandardizeEnsembleAverage[ensav],opts1,opts2
]
];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"EnsembleAverage"],locst:{True,True,False,morelocst___},morest___},more:(Except[_Rule]...),opts1___Rule,EnsembleAverage->ensav_,opts2___Rule]:=
Module[{modmore,modopts},(
{modmore,modopts}=
ExpandMultidimensionalEnsembleVariables[
{{more},{opts1,opts2}},
ensav
];
Signal1D[{prefix,{True,True,True,morelocst},morest},
Evaluate[Sequence@@ReleaseHold@modmore],
Evaluate@SimplifyRules[
EnsembleAverage->ExpandMultidimensionalEnsembleVariables@ensav,
Sequence@@ReleaseHold@modopts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"NormalizationFactor"],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule]/;!MatchQ[NormalizationFactor/.{opts}/.Options[Signal1D],_?NumericQ|None|False]:=
(Message[NormalizationFactor::bad];$Failed);


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule]/;MatchQ[NormalizationFactor/.{opts}/.Options[Signal1D],None|False]:=
Signal1D[
{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[NormalizationFactor->1,opts]
];


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;(Chop[NormalizationFactor/.{opts}/.Options[Signal1D]]==0):=
(Message[NormalizationFactor::zero];
Signal1D[stat,more,
Evaluate@SimplifyRules[NormalizationFactor->1,opts]
]);


(* ::Input::Initialization:: *)
Signal1D[stat:{prefix:StatusPatternPrefix[Signal1D,"NormalizationFactor"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;NumericQ[NormalizationFactor/.{opts}/.Options[Signal1D]]:=
Signal1D[{prefix,{True,True,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]/;!MatchQ[ObservableOperator/.{opts},ObservableOperator]:=
(Message[Signal1D::obsopobsol];$Failed);


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]/;MatchQ[Observable/.{opts}/.Options[Signal1D],All]:=
Signal1D[status,args,
Evaluate@SimplifyRules[
Observable->(First/@SpinSystem[]),
opts
]
];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Module[{obsspin},(
Signal1D[status,args,
Evaluate@SimplifyRules[
Observable->{obsspin},
opts
]
]
)/;(
obsspin=Observable/.{opts}/.Options[Signal1D];
MatchQ[obsspin,Except[_List]]&&ValidSpinQ[obsspin,SpinSystem[]]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Module[{obsspins},(
Signal1D[
{prefix,{True,True,morelocst},morest},
args,
Evaluate@SimplifyRules[
Observable->(-(1/2)I opI[obsspins,"-"]),
opts
]
]
)/;(
obsspins=Observable/.{opts}/.Options[Signal1D];
MatchQ[obsspins,_List]&&ValidSpinQ[obsspins,SpinSystem[]]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Module[{obs},(
Message[Signal1D::obspollevel];
Signal1D[
{prefix,{True,True,morelocst},morest},
args,
Evaluate@SimplifyRules[
Observable->(obs/.PolarizationLevel->PolarizationLevelOperator),
opts
]
]
)/;(
obs=Observable/.{opts}/.Options[Signal1D];
MatchQ[obs,_PolarizationLevel]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Module[{obs},(
Message[Signal1D::obssingpollevel];
Signal1D[
{prefix,{True,True,morelocst},morest},
args,
Evaluate@SimplifyRules[
Observable->(obs/.SingletPolarizationLevel->SingletPolarizationLevelOperator),
opts
]
]
)/;(
obs=Observable/.{opts}/.Options[Signal1D];
MatchQ[obs,_SingletPolarizationLevel]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Signal1D[
{prefix,{True,True,morelocst},morest},args,opts
];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"Observable"],locst:{True,True,False,morelocst___},morest___},args:Except[_Rule]...,opts___Rule]:=
Module[{obs},(
obs=Observable/.{opts}/.Options[Signal1D];
If[OperatorQ[obs],
Signal1D[{prefix,{True,True,True,morelocst},morest},args,opts],
(Message[Signal1D::invalobs,obs];$Failed)
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chron_,samp_,acqev_,prep_,ensav:True,normfac_,obs_,
evbst:{False,nextevbst_,moreevbst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Signal1D[{chron,samp,acqev,prep,ensav,normfac,obs,
{True,False,moreevbst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],locst:{True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Module[{evbackg},(
evbackg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]])];
Signal1D[{prefix,{True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[evbackg,
Except[_List],StandardizeGenerator[evbackg],
_List,StandardizeGenerator/@evbackg,
_,$Failed
],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[{chronst_,sampst:True|{True,True,___},acqevst_,prepst:True,ensavst:True,normfacst_,obsst_,locst:{True,True,False,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Module[{evbackg,ensav,diagfunc,opbasis,basis},(
evbackg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]])];
ensav=EnsembleAverage/.{opts}/.Options[Signal1D];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
diagfunc=Function[backg,
If[
Length[UnassignedSymbols[backg]]==0,
	Switch[backg,
	NullOperator[],backg,
	_?OperatorQ,NDiagonalize[backg,basis],
	_?SuperoperatorQ,NDiagonalize[backg,opbasis,basis],
	_,backg
	],
backg
]
];
Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,
{True,True,True,morelocst},morest},more,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[evbackg,
Except[_List],diagfunc[evbackg],
_List,diagfunc/@evbackg,
_,$Failed
],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],evbackgst:{True,True,True,False,morelocst___},morest___},timing_List,events:Except[_Rule],opts___Rule]:=
Module[{evbackg},(
Signal1D[
status,
timing,events,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[evbackg,
Except[_List],{evbackg,evbackg},
{_,_},evbackg,
_,$Failed],
opts
]
]
)/;(
evbackg=StandardizeGenerator[(ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]])];
MatchQ[evbackg,Except[_List]]
)];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],evbackgst:{True,True,True,False,morelocst___},morest___},timing_List,events:Except[_Rule],opts___Rule]/;MatchQ[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]],{_,_}]:=
Signal1D[
{prefix,{True,True,True,True,morelocst},morest},
timing,events,opts
];


(* ::Input::Initialization:: *)
Signal1D[status:{prefix:StatusPatternPrefix[Signal1D,"BackgroundGenerator"],evbackgst:{True,True,True,True,False},morest___},timing_List,events:Except[_Rule],opts___Rule]:=
Module[{backg,chron},(
backg=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
chron=Chronology/.{opts}/.Options[Signal1D];
Signal1D[
{prefix,{True,True,True,True,True},morest},
timing,events,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[{backg,chron},
{Except[_List],_},backg,
{{_,_},"LeftToRight"},Reverse@backg,
{{_,_},"RightToLeft"},backg,
_,$Failed],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst_,ensavst:True,normfacst_,obsst_,evbackgst:True,
locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,
locst:{True,{{False..},moresubcatst__},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{{True,False,False,False},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[_,{StatusPosition[Signal1D,"SignalCalculation"]-1}],locst:{True,{{True,False,False,False},sgenperst:True,moresubcatst__},morelocst___},morest___},
timing:{tmin_,tmax_,\[Delta]t_},
HoldPattern@EventSpecifications[True,events_,evopts___Rule],opts___Rule]:=
Module[{evbackg,detbackg,period,Nspace,Nsubdiv,Nperiods,carav},(
detbackg=First@evbackg;
{period,carav}={SignalGeneratorPeriod,CarouselAverage}/.{opts}/.Options[Signal1D];
Nspace=BasisDimension[Basis[]];
If[NumericQ[period],(
Nsubdiv=Max[Round[period/\[Delta]t],1];
Nperiods=Max[Round[Abs[tmax-tmin]/period],1];
)];
Signal1D[
{prefix,{True,{{True,True,False,False},sgenperst,moresubcatst},morelocst},morest},
timing,
EventSpecifications[events,evopts],
Evaluate@SimplifyRules[
Sequence@@
Which[
MatchQ[
{detbackg,period,events},
{None|_?OperatorQ|_?SuperoperatorQ|ShapeFunction[_,_,All,___],Except[_?NumericQ],
SingleTimeIndependentEventPattern
}
],
	{SignalCalculationMethod->"Diagonalization"},
(MatchQ[
{detbackg,period,events},
{Except[_Function|ShapeFunction[_,_,None,___]],_,
{SingleTimeIndependentEventPattern|
{_PeriodicFunction,_?NumericQ}|{{_Repeat}}}
}|{
Except[_Function|ShapeFunction[_,_,None,___]],_?NumericQ,
{SingleTimeIndependentEventPattern|
{Except[_Function],_?NumericQ}|{_Repeat}}
}
]
),
	{
	SignalCalculationMethod->"COMPUTE",
	MatchSamplingToPeriod->True
	},
True,
	{SignalCalculationMethod->"Direct"}
],
opts
]
]
)/;(
MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],Automatic]&&(
evbackg=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
MatchQ[evbackg,{_,_}]
)
)
];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[_,{StatusPosition[Signal1D,"SignalCalculation"]-1}],locst:{True,{{True,False,False,False},moresubcatst__},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;!MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],Automatic]:=Signal1D[{prefix,{True,{{True,True,False,False},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
ImplementedSignalCalculationSignalCalculationMethods={"Direct","Diagonalization","COMPUTE"};


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[_,{StatusPosition[Signal1D,"SignalCalculation"]-1}],locst:{True,{{True,True,False,False},moresubcatst__},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=
If[
MemberQ[ImplementedSignalCalculationSignalCalculationMethods,SignalCalculationMethod/.{opts}/.Options[Signal1D]],
Signal1D[{prefix,{True,{{True,True,True,False},moresubcatst},morelocst},morest},more,opts],
(Message[Signal1D::unrecogmethod];$Failed)
];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[_,{StatusPosition[Signal1D,"SignalCalculation"]-1}],locst:{True,{{True,True,True,False},moresubcatst__},morelocst___},morest___},timing_List,evs:Except[_Rule],opts___Rule]:=
Module[{repscm},(
repscm=ReportSignalCalculationMethod/.{opts}/.Options[Signal1D];
If[repscm,
Message[Signal1D::reportscm,SignalCalculationMethod/.{opts}/.Options[Signal1D]]
];
Signal1D[{prefix,{True,{{True,True,True,True},moresubcatst},morelocst},morest},timing,evs,opts
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{False,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,False},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:HoldPattern@EventSpecifications[True,{{Repeat[repev_,nrep_,___Rule],___Rule},___Rule},___Rule],
opts___Rule
]/;
MatchQ[First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]],(None|_?OperatorQ|_?SuperoperatorQ)]:=
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,
Evaluate@SimplifyRules[
SignalGeneratorPeriod->EventDuration[Evaluate@repev],
opts]
];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:Except[_Rule],
opts___Rule
]:=
Module[{detbackg},(
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,
Evaluate@SimplifyRules[SignalGeneratorPeriod->detbackg[[2]],opts]
])/;(
detbackg=First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]];
MatchQ[detbackg,PeriodicFunction[_,_?NumericQ,___]]&&
MatchQ[evspecs,EventSpecifications[True,SingleTimeIndependentEventPattern,___Rule]]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:Except[_Rule],
opts___Rule
]:=
Module[{detbackg},(
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,
Evaluate@SimplifyRules[SignalGeneratorPeriod->detbackg[[3]],opts]
])/;(
detbackg=First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]];
MatchQ[detbackg,ShapeFunction[_,_,_?NumericQ,___]]&&
MatchQ[evspecs,EventSpecifications[True,SingleTimeIndependentEventPattern,___Rule]]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:HoldPattern@EventSpecifications[True,{{Repeat[repev_,nrep_,___Rule],___Rule},___Rule},___Rule],
opts___Rule
]:=
Module[{detbackg},(
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,
Evaluate@SimplifyRules[SignalGeneratorPeriod->CommonPeriod[EventDuration[Evaluate@repev],detbackg[[2]]],opts]
])/;(
detbackg=First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]];
MatchQ[detbackg,PeriodicFunction[_,_?NumericQ,___]]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:HoldPattern@EventSpecifications[True,{{Repeat[repev_,nrep_,___Rule],___Rule},___Rule},___Rule],
opts___Rule
]:=
Module[{detbackg},(
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,
Evaluate@SimplifyRules[SignalGeneratorPeriod->CommonPeriod[EventDuration[Evaluate@repev],detbackg[[3]]],opts]
])/;(
detbackg=First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]];
MatchQ[detbackg,ShapeFunction[_,_,_?NumericQ,___]]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:Except[_Rule],
opts___Rule
]/;!MatchQ[First[ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]],PeriodicFunction[_,_?NumericQ,___]|ShapeFunction[_,_,_?NumericQ,___]]&&!MatchQ[evspecs,HoldPattern@EventSpecifications[True,{{Repeat[repev_,nrep_,___Rule],___Rule},___Rule},___Rule]]:=
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,opts
];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st_,{True,False},moresubcatst___},morelocst___},morest___},
timing:{_,_,_},
evspecs:Except[_Rule],
opts___Rule
]/;!MatchQ[SignalGeneratorPeriod/.{opts}/.Options[Signal1D],None|False]:=
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,{True,True},moresubcatst},morelocst},morest},timing,evspecs,opts
];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st:True,subcat2st:True,{False,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,{True,False},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st:True,subcat2st:True,{True,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;!MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],"COMPUTE"]:=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,{True,True},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st:True,subcat2st:True,{True,False},moresubcatst___},morelocst___},morest___},
timing_List,evspecs_EventSpecifications,opts___Rule]/;MatchQ[evspecs,EventSpecifications[True,{{NullGeneratorPattern|NonStandardNullGeneratorPattern|_?OperatorQ|_?SuperoperatorQ,\[Tau]_}},evopts___Rule]]:=
Module[{period,evgen},(
period=SignalGeneratorPeriod/.{opts}/.Options[Signal1D];
evgen=evspecs[[2,1,1]];
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,{True,True},moresubcatst},morelocst},morest},
timing,evspecs,
Evaluate@SimplifyRules[
PeriodicDetectionEvents->EventSpecifications[{{evgen,period}}],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst:True,ensavst:True,normfacst:True,obsst:True,evbackgst:True,locst:{True,{subcat1st:True,subcat2st:True,{True,False},moresubcatst___},morelocst___},morest___},timing_List,evspecs_EventSpecifications,opts___Rule]/;MatchQ[evspecs,EventSpecifications[True,{{_Repeat}},evopts___Rule]]:=Module[{period,repev,nrepdet,evopts,repevopts},(
period=SignalGeneratorPeriod/.{opts}/.Options[Signal1D];
repev=evspecs[[2,1,1,1]];
evopts=Sequence@@Cases[evspecs,_Rule];
repevopts=Sequence@@Cases[evspecs[[2,1,1]],_Rule];
nrepdet=Max[Ceiling[period/EventDuration[repev]],1];
Signal1D[
{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,{True,True},moresubcatst},morelocst},morest},
timing,evspecs,
Evaluate@SimplifyRules[
PeriodicDetectionEvents->
EventSpecifications[
{Repeat[repev,nrepdet,repevopts]},
ExpandRepeatedEvents->True,
evopts
]
],
opts
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst_,sampst_,acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,locst:{True,{subcat1st:True,subcat2st:True,subcat3st:True,{False,False,False},moresubcatst___},morelocst___},morest___},
more:(Except[_Rule]...),opts___Rule]:=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,subcat3st,{True,False,False},moresubcatst},morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{chronst_,sampst_,acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,locst:{True,{subcat1st:True,subcat2st:True,subcat3st:True,{True,False,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;!(CarouselAverage/.{opts}/.Options[Signal1D]):=Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,subcat3st,{True,True,True},moresubcatst},morelocst},morest},more,
opts
];


(* ::Input::Initialization:: *)
Signal1D[
{chronst_,sampst_,acqevst_,prepst_,ensavst_,normfacst_,obsst_,evbackgst_,locst:{True,{subcat1st:True,subcat2st:True,subcat3st:True,{True,False,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;(CarouselAverage/.{opts}/.Options[Signal1D]):=
Module[{scm},(
scm=SignalCalculationMethod/.{opts}/.Options[Signal1D];
If[
MatchQ[scm,"COMPUTE"],
Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,subcat3st,{True,True,False}},morelocst},morest},more,opts],
(Message[Signal1D::nocarav];$Failed)
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst_,sampst_,acqevst_,prepst:True,ensavst_,normfacst_,obsst_,evbackgst_,locst:{True,{subcat1st:True,subcat2st:True,subcat3st:True,{True,True,False},moresubcatst___},morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]/;(CarouselAverage/.{opts}/.Options[Signal1D]):=
Module[{prep},(
prep=Preparation/.{opts}/.Options[Signal1D];
If[
!TrueQ[Chop@EventDuration[prep]==0],
Message[Signal1D::caravwarn]
];
Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{True,{subcat1st,subcat2st,subcat3st,{True,True,True}},morelocst},morest},more,opts]
)];


(* ::Input::Initialization:: *)
Signal1D[
{chronst:True,sampst:True|{True,True,___},acqevst:True,prepst_,ensavst:True,normfacst_,obsst_,evbackgst:True,
locst:{subcats:True..,False},morest___},more:(Except[_Rule]...),opts___Rule]:=
Signal1D[{chronst,sampst,acqevst,prepst,ensavst,normfacst,obsst,evbackgst,{subcats,True},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:StatusPatternPrefix[Signal1D,"InitialDensityOperator"],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:Repeated[_,{StatusPosition[Signal1D,"InitialDensityOperator"]-1}],locst:{True,False,morelocst___},morest___},
timing_List,events_,opts___Rule]:=
Module[{\[Rho]0,\[Rho]0vec,opbasis,basis},(
{\[Rho]0,opbasis,basis}=
{InitialDensityOperator,OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
Signal1D[{prefix,{True,True,morelocst},morest},
timing,events,
Evaluate@SimplifyRules[
InitialDensityOperator->
Operator[InitialDensityOperator/.{opts}/.Options[Signal1D],ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:Repeated[_,{StatusPosition[Signal1D,"InitialDensityOperator"]-1}],locst:{True,True,False},morest___},
timing_List,events_,opts___Rule]:=
Signal1D[{prefix,{True,True,True},morest},
timing,events,opts];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[True,{StatusPosition[Signal1D,"LineBroadening"]-1}],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"LineBroadening"],{True,False},morest___},
timing:{tmin_,tmax_,\[Delta]t_},events_,opts___Rule]:=
Module[{lb,fwhh},(
lb=If[
MatchQ[LineBroadening/.{opts}/.Options[Signal1D],Automatic],
	(fwhh=N[4 Log[10]/(Abs[tmax-tmin])];
	Message[Signal1D::autolb,EngineeringForm@N[fwhh/(2\[Pi])]];
	{"Lorentzian",fwhh}),
LineBroadening/.{opts}/.Options[Signal1D]
];
Signal1D[
{prefix,{True,True},morest},
{tmin,tmax,\[Delta]t},
events,
Evaluate@SimplifyRules[LineBroadening->lb,opts]
]
)];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[True,{StatusPosition[Signal1D,"UserLevel"]-1}],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"UserLevel"],{True,False},morest___},
timing:{tmin_,tmax_,\[Delta]t_},events_,opts___Rule]:=
Module[{scm,minrul,ul},(
{scm,minrul}={SignalCalculationMethod,MinimumRecommendedUserLevel}/.{opts}/.Options[Signal1D];
minrul=Switch[{minrul,scm},
	{Automatic,"Diagonalization"|"COMPUTE"},1,
	{Automatic,"Direct"},2,
	_,1];
ul=UserLevel[];
If[ul<minrul,
Message[UserLevel::toolow,ul,minrul]
];
Signal1D[
{prefix,{True,True},morest},
timing,events,opts]
)];


(* ::Input::Initialization:: *)
Signal1D[{prefix:Repeated[True,{StatusPosition[Signal1D,"Ready"]-1}],locst:{False,nextlocst_,morelocst___},morest___},more:(Except[_Rule]...),opts___Rule]:=Signal1D[{prefix,{True,False,morelocst},morest},more,opts];


(* ::Input::Initialization:: *)
Signal1D[
{prefix:StatusPatternPrefix[Signal1D,"Ready"],{True,False},morest___},
timing:{tmin_,tmax_,\[Delta]t_},events_,opts___Rule]:=
Module[{ensavvars,suspectsymbols},(
ensavvars=UnassignedSymbols[EnsembleAverage/.{opts}/.Options[Signal1D]];
suspectsymbols=UnassignedSymbols[{timing,events,opts},PermittedSymbols->ensavvars];
If[
Length[suspectsymbols]==0,
Signal1D[
{prefix,{True,True},morest},
timing,events,opts],
(Message[Signal1D::suspsymbs,suspectsymbols];$Failed)
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]:=Module[{ensav,prep,backg,prepbackg,detbackg,\[Rho]ini,var,vals,weights},
(
Signal1D[True,timing,acqevents,
Evaluate@SimplifyRules[
BackgroundGenerator->{detbackg,NullOperator[]},
opts
]
]
)/;(
{prep,backg}={Preparation,BackgroundGenerator}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[backg];
!MatchQ[ReleaseHold@prepbackg,NullGeneratorPattern]&&(Chop[EventDuration[prep]]==0)
)
];


(* ::Input::Initialization:: *)
Signal1D[True,timing:{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]:=Module[{ensav,prep,backg,prepbackg,detbackg,\[Rho]ini,var,vals,weights,\[Rho]afterprep,temp},(
(*temp=PrintTemporary["implementing preparation.."];*)
\[Rho]afterprep=NPropagate[
prep,
SimplifyRules[
InitialTimePoint->Automatic,
FinalTimePoint->tmin,
BackgroundGenerator->prepbackg,
Continuous->False,
Sequence@@FilterRules[{opts},Options[NPropagate]],
Sequence@@CurrentOptionsToPassDown[Signal1D,NPropagate]
]
][Operator@\[Rho]ini];
(*NotebookDelete[temp];*)
Signal1D[True,timing,acqevents,
Evaluate@SimplifyRules[
InitialDensityOperator->\[Rho]afterprep,
Preparation->None,
opts
]
]
)/;(
(
{ensav,prep,backg,\[Rho]ini}={EnsembleAverage,Preparation,BackgroundGenerator,InitialDensityOperator}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[backg];
(!MatchQ[prep,None|EventSpecifications@UnitySuperoperator[]])&&
((MatchQ[ensav,{_,_}]&&
EnsembleVariablesFreeQ[{prep,\[Rho]ini},ensav]&&
((Chop[EventDuration[prep]]==0)||EnsembleVariablesFreeQ[prepbackg,ensav]))||MatchQ[ensav,False|None])
)
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]/;MatchQ[{Parallel,ParallelSetUp,EnsembleAverage}/.{opts}/.Options[Signal1D],{True|All|_?NumericQ,False,Except[None|False]}]:=
Module[{opbasis,basis},(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
PrepareParallel[opbasis,basis,opts];
Signal1D[True,timing,acqevents,
Evaluate@SimplifyRules[
ParallelSetUp->True,
Parallel->True,
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]:=Module[{ensav,prep,backg,prepbackg,detbackg,\[Rho]ini,var,vals,weights,nens,maxbatchsize,valwbatches,nbatch,lb,opbasis,basis,ib,temp,sig},
(
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
var=First[ensav];
valwbatches=Partition[Last[ensav],maxbatchsize,maxbatchsize,{1,1},{}];
nbatch=Length[valwbatches];
If[nbatch==1,
PrintTemporary["ensemble averaging using 1 batch .."],
PrintTemporary["ensemble averaging using "<>ToString[nbatch]<>" batches.."]
];
CombineData[
Monitor[
Table[
(
temp=PrintTemporary["computing batch "<>ToString[ib]<>" of "<>ToString[nbatch]<>".."];
sig=Signal1D[True,timing,acqevents,
Evaluate@SimplifyRules[
EnsembleAverage->{var,valwbatches[[ib]]},
OperatorBasis->opbasis,
Basis->basis,
opts
]
];
NotebookDelete[temp];
sig
),
{ib,1,nbatch}
],
ProgressIndicator[ib,{1,nbatch+1}]
],
Table[1,{nbatch}],
Sequence@@FilterRules[{opts},Options[Signal]]
]
)/;(
(
{ensav,prep,backg,\[Rho]ini,maxbatchsize}={EnsembleAverage,Preparation,BackgroundGenerator,InitialDensityOperator,MaxBatchSize}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[backg];
MatchQ[EnsembleAverage/.{opts}/.Options[Signal1D],{_,{{_,_}...}}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize<nens&&
(
MatchQ[prep,None|UnitySuperoperator[]]||
!EnsembleVariablesFreeQ[{prep,\[Rho]ini},ensav]||((Chop[EventDuration[prep]]!=0)&&
!EnsembleVariablesFreeQ[prepbackg,ensav])
)
)
)
)
];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]:=Module[{ensav,prep,backg,prepbackg,detbackg,\[Rho]ini,var,vals,weights,nens,maxbatchsize,valwbatches,nbatch,opbasis,basis,i,vardim,varsubrules,temp,sig},
(
temp=PrintTemporary["setting up batch.."];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
nens=Length[Last[ensav]];
varsubrules=EnsembleVariablesSubstitutionRules[ensav];
weights=EnsembleWeights[ensav];
NotebookDelete[temp];
CombineData[
Monitor[
Table[
Signal1D[
True,timing,
Evaluate@ReleaseHold[Hold[acqevents]/.varsubrules[[i]]],
Evaluate@SimplifyRules[
EnsembleAverage->False,
OperatorBasis->opbasis,
Basis->basis,
ReleaseHold[Hold[opts]/.varsubrules[[i]]],
WarnAboutMissingPreparationBackground->False
]
],
{i,1,nens}
],
ProgressIndicator[i,{1,nens+1}]
],
weights,
Sequence@@FilterRules[{opts},Options[Signal]],
Parallel->False
]
)/;(
!TrueQ[Parallel/.{opts}/.Options[Signal1D]]&&
(
{ensav,prep,backg,\[Rho]ini,maxbatchsize}={EnsembleAverage,Preparation,BackgroundGenerator,InitialDensityOperator,MaxBatchSize}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[backg];
MatchQ[ensav,{_,_}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize>=nens&&
(
MatchQ[prep,None|EventSpecifications@UnitySuperoperator[]]||
(
!EnsembleVariablesFreeQ[{prep,\[Rho]ini},ensav]||
((Chop[EventDuration[prep]]!=0)&&!EnsembleVariablesFreeQ[prepbackg,ensav])
)
)
)
)
)
];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]:=Module[{ensav,prep,backg,prepbackg,detbackg,\[Rho]ini,var,vals,weights,nens,maxbatchsize,valwbatches,nbatch,opbasis,basis,i,vardim,varsubrules,pvar,pvardim,pvarsubrules,temp,sig,acqeventlists},
(temp=PrintTemporary["setting up batch.."];
{opbasis,basis}={OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
nens=Length[Last[ensav]];
varsubrules=EnsembleVariablesSubstitutionRules[ensav];
weights=EnsembleWeights[ensav];
SetSharedVariable[opbasis,basis];
acqeventlists=ReleaseHold[Hold[acqevents]/.#]&/@varsubrules;
DistributeDefinitions[varsubrules,acqeventlists];
NotebookDelete[temp];
CombineData[
Parallelize[
Table[
Signal1D[
True,timing,
Evaluate[acqeventlists[[i]]],
Evaluate@SimplifyRules[
EnsembleAverage->False,
OperatorBasis->opbasis,
Basis->basis,
ReleaseHold[(Hold[opts]/.varsubrules[[i]])],
WarnAboutMissingPreparationBackground->False
]
],
{i,1,nens}
],
Method->"CoarsestGrained",
DistributedContexts->"Global`"
],
weights,
Sequence@@FilterRules[{opts},Options[Signal]],
Parallel->True
]
)/;(
TrueQ[Parallel/.{opts}/.Options[Signal1D]]&&
TrueQ[ParallelSetUp/.{opts}/.Options[Signal1D]]&&
(
{ensav,prep,backg,\[Rho]ini,maxbatchsize}={EnsembleAverage,Preparation,BackgroundGenerator,InitialDensityOperator,MaxBatchSize}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[backg];
MatchQ[ensav,{_,_}]&&
(
nens=Length[Last[ensav]];
maxbatchsize=Min[Max[maxbatchsize,1],nens];
maxbatchsize>=nens&&
(
MatchQ[prep,None|EventSpecifications@UnitySuperoperator[]]||
(
!EnsembleVariablesFreeQ[{prep,\[Rho]ini},ensav]||
((Chop[EventDuration[prep]]!=0)&&!EnsembleVariablesFreeQ[prepbackg,ensav])
)
)
)
)
)
];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]/;MatchQ[InitialDensityOperator/.{opts}/.Options[Signal1D],Except[_Operator]]:=
Module[{\[Rho]0,\[Rho]0vec,opbasis,basis},(
Signal1D[
True,timing,acqevents,
Evaluate@SimplifyRules[
InitialDensityOperator->Operator[\[Rho]0,ZeemanBasis[],
Sequence@@FilterRules[{CheckOperatorType->False,opts},Options[Operator]]
],
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing:{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]/;!MatchQ[Preparation/.{opts}/.Options[Signal1D],None|EventSpecifications@UnitySuperoperator[]]:=
Module[{\[Rho]ini,prepseq,Qobs,tvals,prepbackg,detbackg,traj,norm,\[Rho]afterprep,opbasis,basis},(
{\[Rho]ini,opbasis,basis}={InitialDensityOperator,OperatorBasis,Basis}/.{opts}/.Options[Signal1D];
prepseq=Preparation/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
\[Rho]afterprep=
NPropagate[
prepseq,
SimplifyRules[
InitialTimePoint->Automatic,
FinalTimePoint->tmin,
BackgroundGenerator->prepbackg,
Continuous->False,
OperatorBasis->opbasis,
Basis->basis,
Sequence@@FilterRules[{opts},Options[NPropagate]],
Sequence@@CurrentOptionsToPassDown[Signal1D,NPropagate]
]
][\[Rho]ini];
Signal1D[
True,timing,acqevents,
Evaluate@SimplifyRules[
InitialDensityOperator->\[Rho]afterprep,
Preparation->None,
OperatorBasis->opbasis,
Basis->basis,
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]/;(MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],"Direct"]&&MatchQ[EnsembleAverage/.{opts}/.Options[Signal1D],False|None]&&
MatchQ[Preparation/.{opts}/.Options[Signal1D],None|EventSpecifications@UnitySuperoperator[]]&&
MatchQ[InitialDensityOperator/.{opts}/.Options[Signal1D],_Operator]
):=Signal1DCore["Direct",timing,acqevents,opts];


(* ::Input::Initialization:: *)
Signal1DCore["Direct",{tmin_?NumericQ,tmax_?NumericQ,\[Delta]t_?NumericQ},events_EventSpecifications,opts___Rule]:=
Module[{\[Rho]ini,Qobs,tvals,prepbackg,detbackg,traj,norm,opbasis,basis},(
{\[Rho]ini,opbasis,basis,Qobs}={InitialDensityOperator,OperatorBasis,Basis,Observable}/.{opts}/.Options[Signal1D];
{detbackg,prepbackg}=Which[
MatchQ[#,_?OperatorQ],NDiagonalize[#,basis],
MatchQ[#,_?SuperoperatorQ],NDiagonalize[#,opbasis,basis],
True,#
]&@
(ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]);
tvals=Range[tmin,tmax,\[Delta]t];
traj=
Trajectory[
Qobs,
events,
Evaluate@SimplifyRules[
BackgroundGenerator->detbackg,
InitialTimePoint->tmin,
opts,
NormalizationFactor->norm*OperatorNorm[Qobs]^2,
Sequence@@CurrentOptionsToPassDown[Signal1D,Trajectory]
]
][\[Rho]ini];
Signal[
{tmin,tmax,\[Delta]t},traj/@tvals,
SimplifyRules[
Sequence@@FilterRules[
Join[{opts},Options@Signal1D],
Options[Signal]
]
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]/;
(
MatchQ[acqevents,EventSpecifications[True,{{evgen_,T_}},___Rule]]&&MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],"Diagonalization"]&&
MatchQ[EnsembleAverage/.{opts}/.Options[Signal1D],False|None]&&
MatchQ[Preparation/.{opts}/.Options[Signal1D],None|EventSpecifications@UnitySuperoperator[]]&&
MatchQ[InitialDensityOperator/.{opts}/.Options[Signal1D],_Operator]
):=Signal1DCore["Diagonalization",timing,acqevents,opts];


(* ::Input::Initialization:: *)
HoldPattern@Signal1DCore["Diagonalization",{tmin_?NumericQ,tmax_?NumericQ,\[Delta]t_?NumericQ},acqevents:EventSpecifications[True,{{evgen_,T_}},___Rule],opts___Rule]:=
Module[{\[Rho]0,Qobs,prepbackg,detbackg,opbasis,basis,norm,tvals,X,evals,Xinv,Qobsvec,QobsadjX,Xinv\[Rho],\[Rho]0vec,avals,\[Omega]vals,\[Lambda]vals,blub},
(
{\[Rho]0,Qobs,{detbackg,prepbackg},opbasis,basis,norm}=ReleaseHold[{InitialDensityOperator,Observable,BackgroundGenerator,OperatorBasis,Basis,NormalizationFactor}/.{opts}/.Options[Signal1D]];
opbasis=OperatorBasis/.{opts}/.Options[Signal1D];
basis=Basis/.{opts}/.Options[Signal1D];
norm=NormalizationFactor/.{opts}/.Options[Signal1D];
tvals=Range[tmin,tmax,\[Delta]t];
{X,evals,Xinv}=NDiagonalize[
SuperoperatorMatrixRepresentation[
Liouvillian[evgen,detbackg],
opbasis,basis,opts
]];
\[Rho]0vec=OperatorVectorRepresentation[\[Rho]0,opbasis,basis];
Qobsvec=OperatorVectorRepresentation[Qobs,opbasis,basis];
QobsadjX=Conjugate[Qobsvec].X;
Xinv\[Rho]=Xinv.\[Rho]0vec;
avals=Chop@MapThread[Times,{QobsadjX,Xinv\[Rho]}]/(norm*Norm[Qobsvec]^2);
\[Omega]vals=Im[evals];
\[Lambda]vals=-Re[evals];
Signal[{tmin,tmax,\[Delta]t},
{"Lorentzian",Transpose[{avals,\[Omega]vals,\[Lambda]vals}]},
SimplifyRules[
Sequence@@FilterRules[
Join[{opts},Options@Signal1D],
Options[Signal]
]
]
]
)];


(* ::Input::Initialization:: *)
Signal1D[True,timing_,acqevents_,opts___Rule]/;(MatchQ[SignalCalculationMethod/.{opts}/.Options[Signal1D],"COMPUTE"]&&
MatchQ[SignalGeneratorPeriod/.{opts}/.Options[Signal1D],_?NumericQ]&&
MatchQ[EnsembleAverage/.{opts}/.Options[Signal1D],False|None]&&
MatchQ[Preparation/.{opts}/.Options[Signal1D],None|EventSpecifications@UnitySuperoperator[]]&&
MatchQ[InitialDensityOperator/.{opts}/.Options[Signal1D],_Operator]
):=
Signal1DCore["COMPUTE",timing,acqevents,
Evaluate@SimplifyRules[
BackgroundGenerator->HeldGeneratorSymbol[First@ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]]
],
opts
]
];


(* ::Input::Initialization:: *)
Signal1DCore["COMPUTE",{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]/;(
(UseHilbertSpaceWhenPossible/.{opts}/.Options[Signal1D])&&
HilbertSpaceCompatibility[
PeriodicDetectionEvents/.{opts}/.Options[Signal1D],
opts
]
):=Module[{\[Rho]0,\[Rho]0mat,Qobs,Qadjmat,opbasis,basis,T,n,nH,dividedevents,Ajset,An,evals,evecs,X,Xinv,norm,carav,perdetevents,prepbackg,detbackg,\[Omega]rvec,AjXset,QadjTjset,rspairs,\[Delta]rsk,\[Epsilon]rsk,Ers,arsk,\[Rho]0Tjset,\[Omega]rs,\[Omega]rsk,expmi\[Omega]j\[Tau]rs,normCOMPUTE},(
{\[Rho]0,Qobs,opbasis,basis,T,norm,carav,perdetevents}=ReleaseHold[{InitialDensityOperator,Observable,OperatorBasis,Basis,SignalGeneratorPeriod,NormalizationFactor,CarouselAverage,PeriodicDetectionEvents}/.{opts}/.Options[Signal1D]];
nH=BasisDimension[basis];
normCOMPUTE=norm*Log[2,nH];
detbackg=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
n=Max[1,Round[T/\[Delta]t]];
Qadjmat=ConjugateTranspose@MatrixRepresentation[Qobs,basis];
\[Rho]0mat=MatrixRepresentation[\[Rho]0,basis];
dividedevents=DivideEventSpecifications[perdetevents,n,IncludeRepetitionNumbers->True];
Ajset=DividedEventPropagators[{Operator,T,n},
dividedevents,
opbasis,basis,
InitialTimePoint->tmin,
BackgroundGenerator->detbackg,opts];
An=Last@Ajset;
{X,evals,Xinv}=NDiagonalize[An,Assumptions->{OrthogonalEigenvectors->True}];
\[Omega]rvec=(-I T)^-1 Log/@evals;
AjXset=Chop[(#.X)&/@Most[Ajset]];
QadjTjset=Chop[ConjugateTranspose[#].Qadjmat.#]&/@AjXset;
rspairs=Union[Flatten[(First/@Most@ArrayRules[#])&/@QadjTjset,1]];
(*Print[rspairs];*)
\[Omega]rs=Chop[(\[Omega]rvec[[First[#]]]-\[Omega]rvec[[Last[#]]])&/@rspairs]; 
expmi\[Omega]j\[Tau]rs=Table[Exp[-I # j \[Delta]t],{j,0,n-1}]&/@\[Omega]rs;
\[Delta]rsk=n^-1*(Chop[RotateRight[Fourier[#,FourierParameters->{1,-1}],Floor[n/2]-1]&/@(Outer[Extract[#2,#1]&,rspairs,QadjTjset,1]*expmi\[Omega]j\[Tau]rs)]);
If[
carav,
(
\[Rho]0Tjset=Chop@Transpose[(ConjugateTranspose[#].\[Rho]0mat.#)&/@AjXset,{3,1,2}];
\[Epsilon]rsk=(RotateRight[Fourier[#,FourierParameters->{1,-1}],Floor[n/2]-1]&/@Chop[Extract[\[Rho]0Tjset,rspairs]*expmi\[Omega]j\[Tau]rs]);
arsk=Chop[\[Delta]rsk*Conjugate[\[Epsilon]rsk]/(normCOMPUTE*Norm[N@Qadjmat]^2)]
),
(
Ers=Chop@Extract[ConjugateTranspose[X].\[Rho]0mat.X,rspairs];
arsk=Chop[\[Delta]rsk*Conjugate[Ers]/(normCOMPUTE*Norm[N@Qadjmat]^2)]
)
];
\[Omega]rsk=Plus[#,
If[EvenQ[n],Range[-n/2+1,n/2],Range[-(n-1)/2,+(n-1)/2]]*2\[Pi]/T
]&/@\[Omega]rs;
Signal[{tmin,tmax,\[Delta]t},{"Lorentzian",Transpose[{Flatten[arsk],Flatten[\[Omega]rsk],Table[0,{Length@Flatten[\[Omega]rsk]}]}]
},
SimplifyRules[
Sequence@@FilterRules[
Join[{opts},Options@Signal1D],
Options[Signal]
]
]
]
)]


(* ::Input::Initialization:: *)
Signal1DCore["COMPUTE",{tmin_,tmax_,\[Delta]t_},acqevents_,opts___Rule]/;(
(!UseHilbertSpaceWhenPossible/.{opts}/.Options[Signal1D])||
!HilbertSpaceCompatibility[
PeriodicDetectionEvents/.{opts}/.Options[Signal1D],
opts
]
):=
Module[{\[Rho]0,\[Rho]0vec,Qobs,Qobsvec,opbasis,basis,T,n,ns,Ajset,Ajinvset,An,evals,rekets,lebras,X,Xinv,zsset,Excs0,Excsj,Detsj,\[Epsilon]sk,\[Epsilon]smk,\[Delta]sk,ask,kvals,zsk,zvals,avals,\[Omega]vals,\[Lambda]vals,norm,carav,perdetevents,assumeorthogevecs,prepbackg,detbackg,divpereventlists,normCOMPUTE,dividedevents},(
{\[Rho]0,Qobs,opbasis,basis,T,norm,carav,perdetevents}=ReleaseHold[{InitialDensityOperator,Observable,OperatorBasis,Basis,SignalGeneratorPeriod,NormalizationFactor,CarouselAverage,PeriodicDetectionEvents}/.{opts}/.Options[Signal1D]];
normCOMPUTE=norm*Log[2,BasisDimension[basis]];
detbackg=ReleaseHold[BackgroundGenerator/.{opts}/.Options[Signal1D]];
ns=OperatorBasisDimension[opbasis];
n=Max[1,Round[T/\[Delta]t]];
Qobsvec=OperatorVectorRepresentation[Qobs,opbasis,basis];
\[Rho]0vec=OperatorVectorRepresentation[\[Rho]0,opbasis,basis];
dividedevents=DivideEventSpecifications[perdetevents,n,IncludeRepetitionNumbers->True];
Ajset=DividedEventPropagators[{Superoperator,T,n},
dividedevents,
opbasis,basis,
InitialTimePoint->tmin,
BackgroundGenerator->detbackg,opts];
An=Last@Ajset;
{X,evals,Xinv}=First@NDiagonalize[
Superoperator[An,opbasis,basis],
opbasis,basis,
Sequence@@FilterRules[{Assumptions->None,opts},Options[NDiagonalize]]
];
rekets=Transpose[X];
lebras=Xinv;
zsset=(Log/@evals)/T;
Detsj=MapThread[
Times,
{Outer[(Dot[Conjugate@Qobsvec,#2,#1])&,rekets,Most@Ajset,1],
Outer[Exp[-#1*#2 \[Delta]t]&,zsset,Range[0,n-1]]}
];
\[Delta]sk=n^-1*(RotateRight[Fourier[#,FourierParameters->{1,-1}],Floor[n/2]-1]&/@Detsj);
If[
carav,
(
Ajinvset=Inverse/@Ajset;
Excsj=Chop@MapThread[
Times,
{Outer[(Dot[#1,#2,\[Rho]0vec])&,lebras,Ajinvset,1],
Outer[Exp[+#1*#2 \[Delta]t]&,zsset,Range[0,n-1]]}
];
\[Epsilon]sk=n^-1*(RotateRight[Fourier[#,FourierParameters->{1,-1}],Floor[n/2]-1]&/@Excsj);
\[Epsilon]smk=RotateLeft[Reverse[#],1]&/@\[Epsilon]sk;
ask=Chop@MapThread[Times,{\[Epsilon]smk,\[Delta]sk}];
),
(
Excs0=Dot[#1,\[Rho]0vec]&/@lebras;
ask=Chop@MapThread[Times,{Excs0,\[Delta]sk}];
)
];
zsk=Outer[Plus,zsset,I If[EvenQ[n],Range[-n/2+1,n/2],Range[-(n-1)/2,+(n-1)/2]]*2\[Pi]/T];
avals=Chop@N@Flatten@ask/(normCOMPUTE*Norm[Qobsvec]^2);
zvals=Flatten@zsk;
\[Omega]vals=Im/@zvals;
\[Lambda]vals=-Re/@zvals;
Signal[{tmin,tmax,\[Delta]t},{"Lorentzian",Transpose[{avals,\[Omega]vals,\[Lambda]vals}]},
SimplifyRules[
Sequence@@FilterRules[
Join[{opts},Options@Signal1D],
Options[Signal]
]
]
]
)];


(* ::Input::Initialization:: *)
Options[DividedEventPropagators]={
BackgroundGenerator->None,
InitialTimePoint->0,
Method->Automatic,
AccuracyGoal->Automatic,
PrecisionGoal->Automatic,
MaxStepSize->Automatic,
MaxSteps->Automatic};


(* ::Input::Initialization:: *)
DividedEventPropagators[
{type_,T_,n_},
divevent:{{_Integer,_EventSpecifications}..},opbasis_,basis_,opts___Rule]:=
Module[{dim,evbackg,standevbackg,nreps,evspeclists,evlists,props,Sjset},(
{nreps,evspeclists}=Transpose[divevent];
evlists=EventList[#,opts]&/@evspeclists;
props=Switch[type,
Superoperator,
	NPropagationSuperoperator[#,opbasis,basis,opts]&/@evlists,
Operator,
	NPropagationOperator[#,basis,opts]&/@evlists
];
Sjset=Switch[type,
Superoperator,dim=BasisDimension[basis]^2;SuperoperatorMatrixRepresentation[#,opbasis]&/@Flatten@MapThread[Table[#2,{#1}]&,{nreps,props}],
Operator,dim=BasisDimension[basis];MatrixRepresentation[#,basis]&/@Flatten@MapThread[Table[#2,{#1}]&,{nreps,props}]];
FoldList[
Dot[#2,#1]&,
SparseArray@DiagonalMatrix[Table[1,{dim}]],
Reverse@Sjset]
)/;(
evbackg=BackgroundGenerator/.{opts}/.Options[DividedEventPropagators];
standevbackg=StandardizeGenerator[evbackg];
MatchQ[standevbackg,_?OperatorQ|_?SuperoperatorQ|NullGeneratorPattern]
)
];


(* ::Input::Initialization:: *)
DividedEventPropagators[
{type_,T_,n_},
divevent:{{_Integer,_EventSpecifications}..},more:Except[_Rule]...,opts___Rule]:=
Module[{evbackg,standevbackg},(
DividedEventPropagators[
{type,T,n},divevent/.{nrep:Except[1],evspeclist_EventSpecifications}:>Sequence@@Table[{1,evspeclist},{nrep}],
more,
opts
]
)/;(
!MatchQ[First/@divevent,{1..}]&&(
evbackg=BackgroundGenerator/.{opts}/.Options[DividedEventPropagators];
standevbackg=StandardizeGenerator[evbackg];
!MatchQ[standevbackg,_?OperatorQ|_?SuperoperatorQ|NullGeneratorPattern]
)
)];


(* ::Input::Initialization:: *)
DividedEventPropagators[
{Operator,T_,n_},
divevent:{{1,EventSpecifications[True,{{None,_}},evopts___Rule]}..},opbasis_,basis_,opts___Rule]:=
Module[{tinivals,tini,evspeclist,UonePeriod,\[Tau]list},(
tini=InitialTimePoint/.{opts}/.Options[DividedEventPropagators];
evspeclist=Last[divevent[[1]]]/.{EventSpecifications[bool_,{{a_,\[Delta]t_}},opts$___Rule]:>EventSpecifications[bool,{{a,Length[divevent]*\[Delta]t}},opts$]};
UonePeriod=DividedEventPropagators[
Operator,
evspeclist,
opbasis,basis,InitialTimePoint->tini,opts
];
\[Tau]list=#*(T/n)&/@Range[0,n];
MatrixRepresentation[UonePeriod[#],basis]&/@\[Tau]list
)];


(* ::Input::Initialization:: *)
DividedEventPropagators[
{type_,T_,n_},
divevent:{{1,_EventSpecifications}..},more:Except[_Rule]...,opbasis_,basis_,opts___Rule]:=
Module[{dim,tinivals,tini,evspeclists,props,Sjset},(
tini=InitialTimePoint/.{opts}/.Options[DividedEventPropagators];
evspeclists=Last/@divevent;
tinivals=Reverse@Drop[FoldList[Plus,tini,EventDuration/@Reverse[evspeclists]],-1];
props=DividedEventPropagators[
type,
MapThread[
{1,EventList[#1,InitialTimePoint->#2,opts]}&,
{evspeclists,tinivals}
],
more,opts
];
Sjset=Switch[type,
Superoperator,dim=BasisDimension[basis]^2;SuperoperatorMatrixRepresentation[#,opbasis]&/@props,
Operator,dim=BasisDimension[basis];MatrixRepresentation[#,basis]&/@props];
FoldList[
Dot[#2,#1]&,
SparseArray@DiagonalMatrix[Table[1,{dim}]],
Reverse@Sjset]
)];


(* ::Input::Initialization:: *)
DividedEventPropagators[Superoperator,diveventlists:{{1,_EventList}..},opbasis_,basis_,opts___Rule]:=
NPropagationSuperoperator[Last[#],opbasis,basis,opts]&/@diveventlists


(* ::Input::Initialization:: *)
DividedEventPropagators[Operator,diveventlists:{{1,_EventList}..},opbasis_,basis_,opts___Rule]:=
NPropagationOperator[Last[#],basis,opts]&/@diveventlists


(* ::Input::Initialization:: *)
DividedEventPropagators[Operator,evspec:_EventSpecifications,opbasis_,basis_,sigopts___Rule]:=
NPropagationOperator[evspec,basis,Continuous-> True,Sequence@@FilterRules[{sigopts},Options[NPropagationOperator]]]


(* ::Input::Initialization:: *)
signal1D[args___,rule:Except[_Rule],opts___Rule]/;MatchQ[Evaluate[rule],_Rule]:=signal1D[args,Evaluate[rule],opts];


(* ::Input::Initialization:: *)
Signal1D::unreck="Unrecognized number of points: `1`. Proceeding using 1k points.";


(* ::Input::Initialization:: *)
Signal1D::unrecogmethod="Unrecognized SignalCalculationMethod for Signal1D.";


(* ::Input::Initialization:: *)
Signal1D::noadj\[Delta]t="Period must have a numeric value. Evaluation will proceed without adjusting the sampling interval \[Delta]t";


(* ::Input::Initialization:: *)
Signal1D::nonumperiod="Period must have a numeric value. Evaluation will proceed using SignalCalculationMethod\[Rule]\"Direct\"";


(* ::Input::Initialization:: *)
Signal1D::new\[Delta]t="Sampling interval has been adjusted to `1` s for compatibility with the periodicity of the specified events and/or the BackgroundGenerator.";


(* ::Input::Initialization:: *)
Signal1D::badtimes="The timing specification `1` is inappropriate.";


(* ::Input::Initialization:: *)
Signal1D::zerorepeldur="The repeating element may not have zero duration.";


(* ::Input::Initialization:: *)
Signal1D::nocarav="CarouselAverage\[Rule]True requires SignalCalculationMethod\[Rule]\"COMPUTE\".";


(* ::Input::Initialization:: *)
Signal1D::caravwarn=
"The preparation sequence has finite duration. CarouselAverage\[Rule]True may not be appropriate in this case. Evaluation is proceeding anyway.";


(* ::Input::Initialization:: *)
Signal1D::paderr="Error in padding of events to fill acquisition time.";


(* ::Input::Initialization:: *)
Signal1D::reportscm="Using SignalCalculationMethod \[Rule] `1`";


(* ::Input::Initialization:: *)
Signal1D::diverr="Incorrect construction of repeated elements: `1` should be equal to Round[`2` divided by `3`] = `4`.";


(* ::Input::Initialization:: *)
Signal1D::nullprepbackg="A value for BackgroundGenerator is probably intended when the preparation sequence has a finite duration. Calculation will proceed anyway using BackgroundGenerator\[Rule]None.";


(* ::Input::Initialization:: *)
Signal1D::badnorm="invalid normalization factor.";


(* ::Input::Initialization:: *)
Signal1D::zeronorm="The normalization factor cannot be zero. Proceeding without normalization.";


(* ::Input::Initialization:: *)
Signal1D::badensvar="The variable used in the EnsembleAverage may not have an assigned value."


(* ::Input::Initialization:: *)
Signal1D::obsopobsol=
"ObservableOperator has been superseded by Observable.";


(* ::Input::Initialization:: *)
Signal1D::invalobs="The observable `1` is invalid.";


(* ::Input::Initialization:: *)
Signal1D::invalchron="Invalid setting for Chronology.";


(* ::Input::Initialization:: *)
Signal1D::autolb="Using LineBroadening \[Rule] 2\[Pi] \[Times] `1` rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\).";


(* ::Input::Initialization:: *)
Signal1D::parallel="Parallel computation invoked by Signal1D";


(* ::Input::Initialization:: *)
Signal1D::badchron="unknown setting for Chronology";


(* ::Input::Initialization:: *)
Signal1D::droplast="the last sampling point has been dropped in order to get an even number of points.";


(* ::Input::Initialization:: *)
Signal1D::invalprep="The Preparation sequence `1` is invalid.";


(* ::Input::Initialization:: *)
Signal1D::obspollevel="PolarizationLevel is not a valid observable for Signal1D. Proceeding using PolarizationLevelOperator.";


(* ::Input::Initialization:: *)
Signal1D::obssingpollevel="SingletPolarizationLevel is not a valid observable for Signal1D. Proceeding using SingletPolarizationLevelOperator.";


(* ::Input::Initialization:: *)
Signal1D::suspsymbs="The following symbols do not have numerical values: `1`.";


(* ::Input::Initialization:: *)
Signal1D::oddnCOMPUTE="The COMPUTE algorithm cannot be performed with an odd number of subdivisions of the period.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



