(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    127439,       3204]
NotebookOptionsPosition[    108937,       2830]
NotebookOutlinePosition[    109629,       2855]
CellTagsIndexPosition[    109586,       2852]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Tensors`IST`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 CellChangeTimes->{{3.6831337478032913`*^9, 3.68313374903926*^9}, {
  3.683191841417224*^9, 3.683191841638739*^9}, {3.694846677651587*^9, 
  3.6948466786508627`*^9}, {3.694846778126329*^9, 3.694846778461564*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"8d22a252-f40b-48cc-94a2-6e4ca9a15b0d"],

Cell["routines for IrreducibleSphericalTensors", "Text",
 CellChangeTimes->{{3.683191859143014*^9, 3.683191923508997*^9}, {
  3.694846782331779*^9, 
  3.6948467894866343`*^9}},ExpressionUUID->"29e430b1-a18f-4be4-8791-\
ef3492677cc8"],

Cell[CellGroupData[{

Cell["package", "Chapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 AspectRatioFixed->
  True,ExpressionUUID->"3c9fc702-e573-4f20-b4e2-4ec3d85e3f7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Tensors`IST`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\"\<SpinDynamica`\>\"", ",", 
      "\"\<General`Matrices`\>\"", ",", "\"\<General`Miscellaneous`\>\""}], 
     "}"}]}], "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.448289252530191*^9, {3.564598317433119*^9, 3.5645983179157877`*^9}, {
   3.5645991217093687`*^9, 3.564599125511232*^9}, 3.564599182058362*^9, 
   3.683133761557899*^9, {3.683134303455505*^9, 3.683134313851451*^9}, 
   3.683191847251527*^9, 3.694846684392652*^9, 3.694846798727048*^9, {
   3.694937883710519*^9, 3.694937888139844*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"b53fce19-0b49-416d-9903-76e301c7b6b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["exports", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.5645976645027018`*^9, 3.5645976646736937`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"e4da2adf-1596-4460-a825-55e2b4c3dfc0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant-\
>\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
elements\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\
\) is an irreducible spherical tensor of rank \[Lambda] with 2\[Lambda]+1 \
elements given by the list \!\(\*StyleBox[\"elements\",FontSlant->\"Italic\"]\
\), arranged with the \!\(\*StyleBox[\"m\",FontSlant->\"Italic\"]\)-value in \
descending order from \
\!\(\*StyleBox[\"m\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"=\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\"+\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[Lambda]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"to\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"m\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"=\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"-\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\".\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)The element with index \
\!\(\*StyleBox[\"m\",FontSlant->\"Italic\"]\) may be accessed using the \
syntax \!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant-\
>\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
elements\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"m\",FontSlant-\
>\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"or\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\)\
\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"m\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\"\
,FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"elements\",FontSlant->\"Italic\"]\)\
\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\).\n\n\
\!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"elements\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"eulerangles\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)generates a spherical tensor in a reference frame \
whose orientation is specified by \
\!\(\*StyleBox[\"eulerangles\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",\
FontSlant->\"Italic\"]\) The argument \
\!\(\*StyleBox[\"eulerangles\",FontSlant->\"Italic\"]\) may be an Euler angle \
triplet of the form {\[Alpha],\[Beta],\[Gamma]}, or a set of Euler angles for \
consecutive transformations, of the form {{\[Alpha]1,\[Beta]1,\[Gamma]1},{\
\[Alpha]2,\[Beta]2,\[Gamma]2}..}, where the transformation through \
{\[Alpha]1,\[Beta]1,\[Gamma]1} is applied first. For example, if  \
\!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"elements\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\" \",FontSlant->\"Italic\"]\)specifies a spherical tensor in its \
principal axis frame, then \
\!\(\*StyleBox[\"SphericalTensor\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"elements\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"\[CapitalOmega]PL\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)specifies the same spherical tensor in the lab \
frame, where \!\(\*StyleBox[\"\[CapitalOmega]PL\",FontSlant->\"Italic\"]\) \
represents the Euler angles which align the principal axis frame P with the \
lab frame L (these angles may in turn be derived through \
\!\(\*StyleBox[\"AxesToEuler\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"Paxes\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"Laxes\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\"\
,FontSlant->\"Italic\"]\) where \
\!\(\*StyleBox[\"Paxes\",FontSlant->\"Italic\"]\) and \
\!\(\*StyleBox[\"Laxes\",FontSlant->\"Italic\"]\) are sets of 3-dimensional \
axes).\n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694846871950903*^9, 3.694847057407888*^9}, {
  3.694864279865396*^9, 3.694864299928835*^9}, {3.694935676805183*^9, 
  3.694936078329644*^9}, {3.6949368641825943`*^9, 3.6949369218380547`*^9}, {
  3.694936952149021*^9, 3.694937009962043*^9}, {3.694937048166938*^9, 
  3.694937100324933*^9}},ExpressionUUID->"0b682b60-16cb-45a2-b402-\
235ea2658322"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianTensor", "::", "usage"}], "=", "\"\<?\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694846871950903*^9, 3.694847057407888*^9}, {
  3.694864279865396*^9, 3.694864299928835*^9}, {3.694935676805183*^9, 
  3.694936078329644*^9}, {3.6949368641825943`*^9, 3.6949369218380547`*^9}, {
  3.694936952149021*^9, 3.694937009962043*^9}, {3.694937048166938*^9, 
  3.694937100324933*^9}, {3.7048004692595463`*^9, 
  3.7048004849127674`*^9}},ExpressionUUID->"a51b0f68-762e-4f97-ab89-\
6f8cfaa3e594"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalToCartesian", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"SphericalToCartesian\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"spheric\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\) converts a \
spherical tensor vector with rank \[Lambda] \[LessEqual] 2 into cartesian \
tensor form. For rank \[Lambda]=0, the argument \
\!\(\*StyleBox[\"spheric\",FontSlant->\"Italic\"]\) should be a vector of \
length 1. For rank \
\!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"=\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"1\",FontSlant->\"Italic\"]\), the \
argument \!\(\*StyleBox[\"spheric\",FontSlant->\"Italic\"]\) should be a \
vector of length 3. For rank \!\(\*StyleBox[\"\[Lambda]\",FontSlant->\"Italic\
\"]\)\!\(\*StyleBox[\"=\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"2\",\
FontSlant->\"Italic\"]\), the argument \!\(\*StyleBox[\"spheric\",FontSlant->\
\"Italic\"]\) should be a vector of length 5.\nThe output of \
\!\(\*StyleBox[\"SphericalToCartesian\",FontSlant->\"Italic\"]\) is a 3\
\[Times]3 matrix.\n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694846871950903*^9, 3.694847057407888*^9}, {
  3.694864279865396*^9, 3.694864299928835*^9}, {3.694935676805183*^9, 
  3.694936078329644*^9}, {3.6949368641825943`*^9, 3.6949369218380547`*^9}, {
  3.694936952149021*^9, 3.694937009962043*^9}, {3.694937048166938*^9, 
  3.694937100324933*^9}, {3.7048004692595463`*^9, 3.7048004849127674`*^9}, {
  3.704800576638641*^9, 3.7048005796694956`*^9}, {3.71199951998263*^9, 
  3.711999524786352*^9}, {3.7119998894692216`*^9, 3.7119999899427633`*^9}, {
  3.712000100155405*^9, 
  3.712000173592486*^9}},ExpressionUUID->"f697b0f8-0845-45ca-bf4d-\
5cdba0312d0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"CartesianToSpherical\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Lambda]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) converts a scalar, cartesian vector or 3\[Times]3 \
matrix into spherical tensor form. For rank \!\(\*
StyleBox[\"\[Lambda]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"0\",
FontSlant->\"Italic\"]\), the argument \!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\) may be a number (scalar), or a 3\[Times]3 matrix. \
For rank \!\(\*
StyleBox[\"\[Lambda]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\), the argument \!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\) may be a 3-element Cartesian vector, or a 3\[Times]3 \
matrix. For rank \!\(\*
StyleBox[\"\[Lambda]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\), the argument \!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\) must be a 3\[Times]3 matrix.\nThe output of \!\(\*
StyleBox[\"CartesianToSpherical\",
FontSlant->\"Italic\"]\) is a \!\(\*
StyleBox[\"SphericalTensor\",
FontSlant->\"Italic\"]\) object. \nThe syntax \!\(\*
StyleBox[\"CartesianToSpherical\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Lambda]1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Lambda]2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)generates a list of \!\(\*
StyleBox[\"SphericalTensor\",
FontSlant->\"Italic\"]\) objects. \nThe syntax \!\(\*
StyleBox[\"CartesianToSpherical\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a list of all \!\(\*
StyleBox[\"SphericalTensor\",
FontSlant->\"Italic\"]\) objects compatible with the argument \!\(\*
StyleBox[\"cart\",
FontSlant->\"Italic\"]\). \n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694846871950903*^9, 3.694847057407888*^9}, {
  3.694864279865396*^9, 3.694864299928835*^9}, {3.694864661148262*^9, 
  3.694865048490993*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}], " "}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.564599182146406*^9},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalTensor", "Chapter",
 CellChangeTimes->{3.694847104593647*^9},
 Background->RGBColor[0.87, 0.94, 1]],

Cell[CellGroupData[{

Cell["defaults", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694847291445221*^9, 
  3.6948472925355377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SphericalTensor", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847295585408*^9, 3.694847311267318*^9}, 
   3.694863565640894*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["traps", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}}],

Cell[CellGroupData[{

Cell["$Failed", "Subsubsection",
 CellChangeTimes->{{3.69487682762547*^9, 3.6948768463258543`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847163675085*^9, 3.6948472020961018`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["check rank", "Subsubsection",
 CellChangeTimes->{{3.69487682762547*^9, 3.6948768568979063`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]_", "?", "NumericQ"}], ",", "elements_List", ",", 
      "more___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Lambda]"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensor", "::", "bad\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847221660755*^9, 3.694847261228849*^9}, {
  3.694847319679426*^9, 3.694847333194714*^9}, {3.694847384112795*^9, 
  3.694847414588456*^9}, {3.6948474581945343`*^9, 3.694847471671331*^9}, {
  3.694936194869618*^9, 3.694936197232234*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"IntegerQ", "[", 
          RowBox[{"2", "#"}], "]"}], "&"}], ")"}]}], ",", "elements_List", 
      ",", "more___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"\[Lambda]", "<", "0"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensor", "::", "bad\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847221660755*^9, 3.694847261228849*^9}, {
   3.694847319679426*^9, 3.694847333194714*^9}, {3.694847384112795*^9, 
   3.694847414588456*^9}, 3.6948643909326277`*^9, 3.694877483523223*^9, {
   3.694936202746687*^9, 3.6949362040392513`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["check # elements", "Subsubsection",
 CellChangeTimes->{{3.69487682762547*^9, 3.694876891829691*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"IntegerQ", "[", 
          RowBox[{"2", "#"}], "]"}], "&"}], ")"}]}], ",", "elements_List", 
      ",", "more___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "elements", "]"}], "\[NotEqual]", 
     RowBox[{
      RowBox[{"2", "\[Lambda]"}], "+", "1"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensor", "::", "badellen"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847221660755*^9, 3.694847261228849*^9}, {
   3.694847319679426*^9, 3.694847333194714*^9}, 3.694864383847031*^9, {
   3.6949362084381037`*^9, 3.694936209146858*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
check symmetry of elements (* disabled for rank-1. See note *)\
\>", "Subsubsection",
 CellChangeTimes->{{3.69487682762547*^9, 3.694876831315098*^9}, {
  3.6948783979359903`*^9, 3.694878405066288*^9}}],

Cell["\<\
The symmetry relation below comes from P.P. Man, Cartesian and Spherical \
Tensors in NMR Hamiltonians, Concepts Magn. Reson. 42 (2013) 197\[Dash]244. \
doi:10.1002/cmr.a.21289, 
equation 285. \
\>", "Text",
 CellChangeTimes->{{3.694876783030108*^9, 3.694876817771783*^9}}],

Cell[TextData[{
 StyleBox["The symmetry check has been disabled for rank-1",
  Background->RGBColor[1, 1, 0]],
 ", since the standard rank-1 spherical representation of vectors does not \
follow the same rule. I do not understand the reason for this contradiction. \
"
}], "Text",
 CellChangeTimes->{{3.694878278153974*^9, 3.69487832944377*^9}, {
  3.694878393547284*^9, 3.694878395391267*^9}, {3.6949362236362333`*^9, 
  3.694936224626318*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]_Integer", "|", 
       RowBox[{"{", 
        RowBox[{"\[Lambda]_Integer", ",", "_"}], "}"}]}], ",", 
      "elements_List", ",", "more___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"IntegerQ", "[", 
      RowBox[{"2", "\[Lambda]"}], "]"}], "&&", 
     StyleBox[
      RowBox[{"(", 
       RowBox[{"\[Lambda]", "\[NotEqual]", "1"}], ")"}],
      Background->RGBColor[1, 1, 0]], "&&", 
     RowBox[{"(", 
      RowBox[{"elements", "\[NotEqual]", 
       RowBox[{"Reverse", "@", 
        RowBox[{"Conjugate", "@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"-", "1"}], ")"}], 
              RowBox[{"\[Lambda]", "-", "m"}]], ",", 
             RowBox[{"{", 
              RowBox[{"m", ",", "\[Lambda]", ",", 
               RowBox[{"-", "\[Lambda]"}], ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "]"}], "*", "elements"}], 
          ")"}]}]}]}], ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensor", "::", "badsymm"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694862863381682*^9, 3.6948629734300747`*^9}, {
   3.694863011085185*^9, 3.694863123248958*^9}, 3.694864551920632*^9, {
   3.694865202304017*^9, 3.6948652118199263`*^9}, {3.694876719313078*^9, 
   3.6948767608229113`*^9}, {3.694878340941185*^9, 3.6948783475448*^9}, {
   3.694936214873671*^9, 3.694936215458468*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["extract element", "Subchapter",
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694863182908792*^9, 
  3.694863184325282*^9}, {3.694863537335545*^9, 3.694863540798173*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "elements_", ",", 
      "more___", ",", "opts___Rule"}], "]"}], "[", "m_", "]"}], ":=", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Lambda]", ",", "m"}], "}"}], ",", "elements", ",", "more", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694863365105386*^9, 3.6948634102742777`*^9}, {
  3.6949362533153954`*^9, 3.694936262968068*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Lambda]_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"IntegerQ", "[", 
           RowBox[{"2", "#"}], "]"}], "&"}], ")"}]}], ",", "m_"}], "}"}], ",",
      "elements_List", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"Range", "[", 
        RowBox[{
         RowBox[{"-", "\[Lambda]"}], ",", 
         RowBox[{"+", "\[Lambda]"}], ",", 
         RowBox[{"+", "1"}]}], "]"}], ",", "m"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"elements", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"+", "\[Lambda]"}], "-", "m", "+", "1"}], 
      "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SphericalTensor", "::", "badm"}], ",", "m", ",", 
         "\[Lambda]"}], "]"}], ";", "$Failed"}], ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948631927191057`*^9, 3.694863225962493*^9}, {
  3.694863424055388*^9, 3.6948634572720346`*^9}, {3.6948634925588284`*^9, 
  3.694863525374709*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["frame transformations", "Subchapter",
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
   3.694847170292542*^9, 3.694847171022867*^9}, {3.694863182908792*^9, 
   3.694863184325282*^9}, {3.694863537335545*^9, 3.694863540798173*^9}, {
   3.6948787972929583`*^9, 3.694878801386777*^9}, {3.6949361092118797`*^9, 
   3.6949361118425703`*^9}, 3.694936433611291*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "[", 
    RowBox[{
     RowBox[{"\[Lambda]", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", "\[IndentingNewLine]", 
     "elements_List", ",", 
     RowBox[{"\[CapitalOmega]", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_List", "]"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}]}], 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{"\[Lambda]", ",", "\[IndentingNewLine]", 
     RowBox[{"elements", ".", 
      RowBox[{
       RowBox[{"WignerD", "[", "\[Lambda]", "]"}], "[", "\[CapitalOmega]", 
       "]"}]}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694936122531218*^9, 3.6949361731003933`*^9}, {
  3.6949362807549543`*^9, 3.694936408333603*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Lambda]_", ",", "\[Mu]_"}], "}"}], ",", 
     "\[IndentingNewLine]", "elements_List", ",", 
     RowBox[{"\[CapitalOmega]", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_List", "]"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}], ",", 
         RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}], ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}]}], 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"elements", ".", 
      RowBox[{
       RowBox[{"WignerD", "[", "\[Lambda]", "]"}], "[", "\[CapitalOmega]", 
       "]"}]}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694936441745532*^9, 3.6949364696679497`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subchapter",
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
   3.694847170292542*^9, 3.694847171022867*^9}, {3.694863182908792*^9, 
   3.694863184325282*^9}, {3.694863537335545*^9, 3.694863540798173*^9}, {
   3.6948787972929583`*^9, 3.694878801386777*^9}, {3.6949361092118797`*^9, 
   3.6949361118425703`*^9}, 3.694936433611291*^9, {3.6949372759158363`*^9, 
   3.694937277129857*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalTensor", "/:", 
   RowBox[{"Adjoint", "@", 
    RowBox[{"SphericalTensor", "[", 
     RowBox[{
      RowBox[{"\[Lambda]", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "\[IndentingNewLine]", 
      "elements_List", ",", "opts___Rule"}], "]"}]}], ":=", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{"\[Lambda]", ",", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], "m"], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"+", "\[Lambda]"}], ",", 
          RowBox[{"-", "\[Lambda]"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], "*", 
      RowBox[{"Reverse", "[", "elements", "]"}]}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69493728649124*^9, 3.694937394391388*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["scalar product", "Subchapter",
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
   3.694847170292542*^9, 3.694847171022867*^9}, {3.694863182908792*^9, 
   3.694863184325282*^9}, {3.694863537335545*^9, 3.694863540798173*^9}, {
   3.6948787972929583`*^9, 3.694878801386777*^9}, {3.6949361092118797`*^9, 
   3.6949361118425703`*^9}, 3.694936433611291*^9, {3.6949372759158363`*^9, 
   3.694937277129857*^9}, {3.694937406463509*^9, 3.694937414719837*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalTensor", "/:", 
   RowBox[{
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"st1", ":", 
       RowBox[{"SphericalTensor", "[", 
        RowBox[{"\[Lambda]1_", ",", "els1_", ",", "___Rule"}], "]"}]}], ",", 
      RowBox[{"st2", ":", 
       RowBox[{"SphericalTensor", "[", 
        RowBox[{"\[Lambda]2_", ",", "els2_", ",", "___Rule"}], "]"}]}]}], 
     "]"}], "/;", 
    RowBox[{"\[Lambda]1", "\[NotEqual]", "\[Lambda]2"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensor", "::", "incomp\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694937426916226*^9, 3.694937541533494*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalTensor", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"st1", ":", 
      RowBox[{"SphericalTensor", "[", 
       RowBox[{"\[Lambda]_", ",", "els1_", ",", "___Rule"}], "]"}]}], ",", 
     RowBox[{"st2", ":", 
      RowBox[{"SphericalTensor", "[", 
       RowBox[{"\[Lambda]_", ",", "els2_", ",", "___Rule"}], "]"}]}]}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"-", "1"}], ")"}], "m"], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"+", "\[Lambda]"}], ",", 
          RowBox[{"-", "\[Lambda]"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], "*", "els1"}], ")"}], ".", 
    "els2"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694937426916226*^9, 3.694937541533494*^9}, {
  3.6949375950960407`*^9, 3.6949376643627653`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "badellen"}], "=", 
   "\"\<The length of the element list is inappropriate for the rank.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847339426977*^9, 3.694847367506645*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "bad\[Lambda]"}], "=", 
   "\"\<The rank must be zero, a positive integer or half-integer.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69484742099016*^9, 3.694847441926334*^9}, {
  3.69487749668574*^9, 3.694877498675242*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "badsymm"}], "=", 
   "\"\<The list of elements does not have the correct symmetry.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69484742099016*^9, 3.694847441926334*^9}, {
  3.69486313375804*^9, 3.694863147053739*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "badm"}], "=", 
   "\"\<The index `1` is not appropriate for rank `2`\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.694863315773362*^9, 3.694863335584402*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensor", "::", "incomp\[Lambda]"}], "=", 
   "\"\<The dot product may only be taken between spherical tensors of the \
same rank\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694937553616102*^9, 3.6949375763632793`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CartesianToSpherical", "Chapter",
 CellChangeTimes->{
  3.694847104593647*^9, {3.6948646502230864`*^9, 3.6948646537546043`*^9}},
 Background->RGBColor[0.87, 0.94, 1]],

Cell[CellGroupData[{

Cell["defaults", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694847291445221*^9, 
  3.6948472925355377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CartesianToSpherical", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847295585408*^9, 3.694847311267318*^9}, 
   3.694863565640894*^9, 3.694865075526873*^9, 3.704035921157008*^9, 
   3.7040374839424944`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["traps", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}}],

Cell[CellGroupData[{

Cell["$Failed", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874430215425*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847163675085*^9, 3.6948472020961018`*^9}, 
   3.694865089117298*^9, 3.704035929161955*^9, {3.704037485687749*^9, 
   3.704037486659871*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874437876246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{
      RowBox[{"\[Lambda]_", "?", "NumericQ"}], ",", "cart_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"IntegerQ", "[", "\[Lambda]", "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "bad\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", "cart_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{"0", "\[LessEqual]", "\[Lambda]", "\[LessEqual]", "2"}], 
      ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "bad\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.694874369689939*^9, 3.694874412473507*^9}, {3.704035932630324*^9, 
  3.704035933853367*^9}, {3.704037500260314*^9, 3.704037501890391*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["argument", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874446763506*^9}}],

Cell[CellGroupData[{

Cell["scalar argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"scalar", ":", 
       RowBox[{"Except", "[", 
        RowBox[{"_List", "|", "_SparseArray"}], "]"}]}], ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"\[Lambda]", "\[NotEqual]", "0"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt0"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875202607733*^9, 3.6948752033265867`*^9}, {3.70403593537851*^9, 
   3.704035936219087*^9}, {3.7040362078927417`*^9, 3.704036210323699*^9}, 
   3.7040365037688932`*^9, {3.704037508482342*^9, 3.704037510694373*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"scalar", ":", 
       RowBox[{"Except", "[", 
        RowBox[{"_List", "|", "_SparseArray"}], "]"}]}], ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"scalar", "\[NotEqual]", 
     RowBox[{"Conjugate", "[", "scalar", "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "scalnotreal"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
   3.694874783235075*^9, 3.694874799321718*^9}, {3.69487486011861*^9, 
   3.694874912769203*^9}, {3.6948752113615093`*^9, 3.694875221057879*^9}, {
   3.7040359373073053`*^9, 3.7040359385463705`*^9}, 3.7040362128370595`*^9, 
   3.704036505968887*^9, {3.704037512069519*^9, 3.704037516554502*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["vector argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"vec_", "?", "VectorQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"\[Lambda]", ">", "1"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt1"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, 
   3.6948776506229773`*^9, {3.7040359399562645`*^9, 3.7040359413050365`*^9}, {
   3.7040369213606267`*^9, 3.7040369229997115`*^9}, {3.704037524420045*^9, 
   3.7040375263336463`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"vec_", "?", "VectorQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "vec", "]"}], "\[NotEqual]", "3"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "badveclen"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
   3.694874783235075*^9, 3.694874799321718*^9}, 3.6948753322221413`*^9, {
   3.7040359421088*^9, 3.704035943026334*^9}, {3.704036927073919*^9, 
   3.7040369324417067`*^9}, {3.704037119819738*^9, 3.704037130665933*^9}, {
   3.7040371648944774`*^9, 3.704037166413825*^9}, {3.7040372345951834`*^9, 
   3.7040372882727647`*^9}, 3.7040375272807517`*^9, 3.7040375707707124`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"vec_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"vec", "\[NotEqual]", 
     RowBox[{"Conjugate", "[", "vec", "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "vecnotreal"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
  3.694874783235075*^9, 3.694874799321718*^9}, {3.69487486011861*^9, 
  3.694874912769203*^9}, {3.704035944006243*^9, 3.704035944803234*^9}, {
  3.7040369787496777`*^9, 3.7040369805275593`*^9}, {3.704037531692712*^9, 
  3.704037533633625*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["matrix argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}, {3.69487492722574*^9, 3.694874928192198*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"\[Lambda]", ">", "2"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt2"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
  3.694874931085805*^9, 3.694874940185174*^9}, {3.7040359460001745`*^9, 
  3.7040359469436903`*^9}, {3.7040375420434427`*^9, 3.7040375439960794`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Dimensions", "[", "mat", "]"}], "\[NotEqual]", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "badmatdim"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
   3.694874783235075*^9, 3.694874799321718*^9}, {3.694874962643815*^9, 
   3.69487497904346*^9}, 3.694875025104281*^9, {3.7040359480638947`*^9, 
   3.704035948841545*^9}, {3.7040375451751366`*^9, 3.7040375492615557`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "[", 
     RowBox[{"\[Lambda]_Integer", ",", 
      RowBox[{"mat_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"mat", "\[NotEqual]", 
     RowBox[{"Conjugate", "[", "mat", "]"}]}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CartesianToSpherical", "::", "matnotreal"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.6948747070499067`*^9, 3.694874743723311*^9}, {
  3.694874783235075*^9, 3.694874799321718*^9}, {3.69487486011861*^9, 
  3.694874912769203*^9}, {3.6948750382552547`*^9, 3.6948750889371357`*^9}, {
  3.704035950301995*^9, 3.7040359515923185`*^9}, {3.7040375505812187`*^9, 
  3.7040375628893747`*^9}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["several ranks", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694875117972661*^9, 
  3.6948751286253347`*^9}, {3.694877711720023*^9, 3.6948777139802732`*^9}}],

Cell[CellGroupData[{

Cell["general", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.694877770603216*^9, 3.6948777714121313`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"\[Lambda]vals_List", ",", "args_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"CartesianToSpherical", "[", 
      RowBox[{"#", ",", "args", ",", "opts"}], "]"}], "&"}], "/@", 
    "\[Lambda]vals"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948777222053547`*^9, 3.69487774771994*^9}, {
  3.704035952491681*^9, 3.7040359534524856`*^9}, {3.7040367413146544`*^9, 
  3.704036755100837*^9}, {3.7040375766326265`*^9, 3.7040375782288527`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["determine set of ranks Automatically", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.694877770603216*^9, 3.6948778004938183`*^9}}],

Cell[CellGroupData[{

Cell["scalar argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"scalar", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_List", "|", "_SparseArray"}], "]"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", "scalar", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
   3.69487784687862*^9}, 3.7040357818173137`*^9, {3.70403595449743*^9, 
   3.704035955400519*^9}, {3.704036037257383*^9, 3.704036039872386*^9}, {
   3.7040376569642487`*^9, 3.7040376592672987`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["vector argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"vec_", "?", "VectorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", "vec", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
  3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
  3.694877867871709*^9}, {3.704035956113541*^9, 3.7040359568324795`*^9}, {
  3.704037384461561*^9, 3.7040373861302357`*^9}, {3.704037660702447*^9, 
  3.704037661771861*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["matrix argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}, {3.69487492722574*^9, 3.694874928192198*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "2"}], "}"}], ",", "mat", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
  3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
  3.694877889349968*^9}, {3.7040359582005615`*^9, 3.7040359589762683`*^9}, {
  3.7040376633333244`*^9, 3.7040376653219023`*^9}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["construct spherical tensors", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694875117972661*^9, 
  3.6948751286253347`*^9}}],

Cell[CellGroupData[{

Cell["scalar argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"0", ",", 
     RowBox[{"scalar", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_List", "|", "_SparseArray"}], "]"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", "scalar", "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, 3.704035814070304*^9, 
   3.7040359597258816`*^9, {3.704036813185894*^9, 3.7040368157016354`*^9}, 
   3.7040375819536037`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["vector argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694875294071239*^9, 
  3.694875294925514*^9}}],

Cell["\<\
rank 1 taken from P.P. Man, Cartesian and Spherical Tensors in NMR \
Hamiltonians, Concepts Magn. Reson. 42 (2013) 197\[Dash]244. \
doi:10.1002/cmr.a.21289, 
equations 230 \
\>", "Text",
 CellChangeTimes->{{3.694876117436804*^9, 3.6948761544603863`*^9}, {
  3.694876239648608*^9, 3.694876257624543*^9}, {3.6948765499956827`*^9, 
  3.694876578614056*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"0", ",", 
     RowBox[{"vec_", "?", "VectorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Plus", "@@", "vec"}], "/", "3"}], "}"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875361425413*^9}, 
   3.704035960995228*^9, {3.7040368938712482`*^9, 3.704036897160741*^9}, 
   3.704037583988392*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"1", ",", 
     RowBox[{"vec_", "?", "VectorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y", ",", "z"}], "}"}], "=", "vec"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SphericalTensor", "[", 
       RowBox[{"1", ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], 
           RowBox[{"(", 
            RowBox[{"x", "+", 
             RowBox[{"I", " ", "y"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
          "z", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"+", 
            RowBox[{"(", 
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], 
           RowBox[{"(", 
            RowBox[{"x", "-", 
             RowBox[{"I", " ", "y"}]}], ")"}]}]}], "\[IndentingNewLine]", 
         "}"}], ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
       "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948756972992496`*^9, 
   3.694875767140066*^9}, 3.7040359617680106`*^9, {3.7040374218925753`*^9, 
   3.7040374480921483`*^9}, 3.7040375871725626`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["matrix argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694875294071239*^9, 
  3.694875294925514*^9}, {3.694875508038213*^9, 3.694875510433641*^9}}],

Cell["\<\
taken from P.P. Man, Cartesian and Spherical Tensors in NMR Hamiltonians, \
Concepts Magn. Reson. 42 (2013) 197\[Dash]244. doi:10.1002/cmr.a.21289, 
equations. 276-281. 
Reported to be the same as Mehring.\
\>", "Text",
 CellChangeTimes->{{3.694876117436804*^9, 3.6948761544603863`*^9}, {
   3.694876239648608*^9, 3.694876257624543*^9}, {3.6948765499956827`*^9, 
   3.6948765530311728`*^9}, 3.694876633269155*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"0", ",", 
     RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"SphericalTensor", "[", 
    RowBox[{"0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"1", "/", 
          RowBox[{"Sqrt", "[", "3", "]"}]}], ")"}]}], 
       RowBox[{"Plus", "@@", 
        RowBox[{"Diagonal", "[", "mat", "]"}]}]}], "}"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875361425413*^9}, {
   3.694875513493911*^9, 3.694875529266637*^9}, {3.69487588163378*^9, 
   3.6948758979364643`*^9}, 3.7040359624839325`*^9, {3.704036263321969*^9, 
   3.7040362848265505`*^9}, {3.704036550556081*^9, 3.7040365700546937`*^9}, {
   3.7040366135796995`*^9, 3.7040366232245765`*^9}, {3.7040366588896465`*^9, 
   3.7040366751249666`*^9}, {3.7040367867825346`*^9, 3.70403680089252*^9}, {
   3.7040372947959013`*^9, 3.7040372985771785`*^9}, 3.7040375965711756`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CartesianToSpherical", "[", 
   RowBox[{"1", ",", "\[IndentingNewLine]", 
    RowBox[{"mat_", "?", "MatrixQ"}], ",", "\[IndentingNewLine]", 
    "opts___Rule"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "xx", ",", "xy", ",", "xz", ",", "yx", ",", "yy", ",", "yz", ",", "zx", 
      ",", "zy", ",", "zz"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "xx", ",", "xy", ",", "xz", ",", "yx", ",", "yy", ",", "yz", ",", "zx",
         ",", "zy", ",", "zz"}], "}"}], "=", 
      RowBox[{"Flatten", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"SphericalTensor", "[", 
      RowBox[{"1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"1", "/", "2"}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{"zx", "-", "xz", "+", 
            RowBox[{"I", 
             RowBox[{"(", 
              RowBox[{"zy", "-", "yz"}], ")"}]}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"1", "/", 
             RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], "I", 
          RowBox[{"(", 
           RowBox[{"xy", "-", "yx"}], ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{"1", "/", "2"}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{"zx", "-", "xz", "-", 
            RowBox[{"I", 
             RowBox[{"(", 
              RowBox[{"zy", "-", "yz"}], ")"}]}]}], ")"}]}]}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", "opts"}], 
      "\[IndentingNewLine]", "]"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948755380109177`*^9, 
   3.694875630383266*^9}, {3.694875777583501*^9, 3.694875819399304*^9}, {
   3.6948759695775557`*^9, 3.694876018818296*^9}, {3.694876096207678*^9, 
   3.694876110776445*^9}, {3.694876276031968*^9, 3.6948763032108507`*^9}, 
   3.7040359641853514`*^9, {3.7040361013305993`*^9, 3.7040361086497135`*^9}, {
   3.704036332144337*^9, 3.7040363754579535`*^9}, {3.7040364145696692`*^9, 
   3.7040364219579773`*^9}, 3.704037597450823*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "[", 
    RowBox[{"2", ",", "\[IndentingNewLine]", 
     RowBox[{"mat_", "?", "MatrixQ"}], ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "xx", ",", "xy", ",", "xz", ",", "yx", ",", "yy", ",", "yz", ",", "zx", 
       ",", "zy", ",", "zz"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "xx", ",", "xy", ",", "xz", ",", "yx", ",", "yy", ",", "yz", ",", 
         "zx", ",", "zy", ",", "zz"}], "}"}], "=", 
       RowBox[{"Flatten", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SphericalTensor", "[", 
       RowBox[{"2", ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", "2"}], ")"}], 
           RowBox[{"(", 
            RowBox[{"xx", "-", "yy", "+", 
             RowBox[{"I", 
              RowBox[{"(", 
               RowBox[{"xy", "+", "yx"}], ")"}]}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"1", "/", "2"}], ")"}]}], 
           RowBox[{"(", 
            RowBox[{"xz", "+", "zx", "+", 
             RowBox[{"I", 
              RowBox[{"(", 
               RowBox[{"yz", "+", "zy"}], ")"}]}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", 
             RowBox[{"Sqrt", "[", "6", "]"}]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"3", "zz"}], "-", 
             RowBox[{"(", 
              RowBox[{"xx", "+", "yy", "+", "zz"}], ")"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"+", 
            RowBox[{"(", 
             RowBox[{"1", "/", "2"}], ")"}]}], 
           RowBox[{"(", 
            RowBox[{"xz", "+", "zx", "-", 
             RowBox[{"I", 
              RowBox[{"(", 
               RowBox[{"yz", "+", "zy"}], ")"}]}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", "2"}], ")"}], 
           RowBox[{"(", 
            RowBox[{"xx", "-", "yy", "-", 
             RowBox[{"I", 
              RowBox[{"(", 
               RowBox[{"xy", "+", "yx"}], ")"}]}]}], ")"}]}]}], 
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", "opts"}], 
       "\[IndentingNewLine]", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948755380109177`*^9, 
   3.694875630383266*^9}, {3.694875777583501*^9, 3.694875819399304*^9}, {
   3.6948759695775557`*^9, 3.694876018818296*^9}, {3.694876096207678*^9, 
   3.694876110776445*^9}, {3.694876276031968*^9, 3.694876456968416*^9}, 
   3.704035965327898*^9, {3.7040364531185007`*^9, 3.7040364659077234`*^9}, 
   3.7040375986344957`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "::", "bad\[Lambda]"}], "=", 
   "\"\<The rank \[Lambda] must be an integer \[LessEqual] 2\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69487433475809*^9, 3.694874356953579*^9}, 
   3.70403596664032*^9, 3.704037603111315*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt0"}], "=", 
   "\"\<The rank \[Lambda] must be zero for a scalar argument.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69487462586734*^9, 3.6948746741413813`*^9}, 
   3.694874734759284*^9, 3.7040359672733707`*^9, 3.7040376038216534`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt1"}], "=", 
   "\"\<The rank \[Lambda] cannot be greater than 1 for a vector \
argument.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69487462586734*^9, 3.6948746741413813`*^9}, {
   3.694874734759284*^9, 3.6948747655824614`*^9}, 3.704035967973673*^9, 
   3.704037604873031*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianToSpherical", "::", "\[Lambda]gt2"}], "=", 
   "\"\<The rank \[Lambda] cannot be greater than 2 for a matrix \
argument.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69487462586734*^9, 3.6948746741413813`*^9}, {
   3.694874734759284*^9, 3.6948747655824614`*^9}, {3.694874949073648*^9, 
   3.6948749528641853`*^9}, 3.704035969250592*^9, 3.704037605651243*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "::", "badveclen"}], "=", 
    "\"\<The Cartesian vector must have 3 elements.\>\""}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874809054022*^9, 3.694874832374934*^9}, 
   3.7040359703601475`*^9, {3.7040376068002152`*^9, 3.704037608197854*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "::", "badmatdim"}], "=", 
    "\"\<The Cartesian matrix must be 3\[Times]3.\>\""}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874809054022*^9, 3.694874832374934*^9}, {
   3.694874993536138*^9, 3.6948750069214*^9}, 3.7040359710672035`*^9, 
   3.704037609459805*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "::", "scalnotreal"}], "=", 
    "\"\<The scalar must be real.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874809054022*^9, 3.694874832374934*^9}, {
   3.6948748848025217`*^9, 3.694874891494377*^9}, {3.6948752399807568`*^9, 
   3.694875270625558*^9}, 3.704035971770857*^9, 3.704037610520316*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "::", "vecnotreal"}], "=", 
    "\"\<The Cartesian vector must have real elements.\>\""}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874809054022*^9, 3.694874832374934*^9}, {
   3.6948748848025217`*^9, 3.694874891494377*^9}, {3.6948752399807568`*^9, 
   3.694875240575954*^9}, 3.7040359727464075`*^9, 3.704037611600918*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianToSpherical", "::", "matnotreal"}], "=", 
    "\"\<The Cartesian matrix must have real elements.\>\""}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694875074750461*^9, 3.694875078989812*^9}, 
   3.704035974190638*^9, 3.7040376124202986`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalToCartesian", "Chapter",
 CellChangeTimes->{
  3.694847104593647*^9, {3.6948646502230864`*^9, 3.6948646537546043`*^9}, {
   3.7047934507837925`*^9, 3.7047934533435297`*^9}},
 Background->RGBColor[0.87, 0.94, 1]],

Cell[CellGroupData[{

Cell["defaults", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694847291445221*^9, 
  3.6948472925355377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SphericalToCartesian", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847295585408*^9, 3.694847311267318*^9}, 
   3.694863565640894*^9, 3.694865075526873*^9, 3.704035921157008*^9, 
   3.7040374839424944`*^9, {3.704793463934126*^9, 3.7047934662984257`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["traps", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}}],

Cell[CellGroupData[{

Cell["$Failed", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874430215425*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694847163675085*^9, 3.6948472020961018`*^9}, 
   3.694865089117298*^9, 3.704035929161955*^9, {3.704037485687749*^9, 
   3.704037486659871*^9}, 3.704793478654439*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["sort out argument", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.694877770603216*^9, 3.6948778004938183`*^9}, {
   3.704794662431075*^9, 3.704794664611044*^9}}],

Cell[CellGroupData[{

Cell["list of arguments", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.7047946696615915`*^9, 
  3.704794670150857*^9}, {3.704794705431879*^9, 3.704794707240195*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalToCartesian", "[", 
    RowBox[{
     RowBox[{"args", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "___", "}"}], ".."}], "}"}]}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"SphericalToCartesian", "[", 
      RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", "args"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
   3.69487784687862*^9}, 3.7040357818173137`*^9, {3.70403595449743*^9, 
   3.704035955400519*^9}, {3.704036037257383*^9, 3.704036039872386*^9}, {
   3.7040376569642487`*^9, 3.7040376592672987`*^9}, {3.704793976789963*^9, 
   3.7047939767924643`*^9}, {3.7047947160330353`*^9, 3.704794737329321*^9}, {
   3.704797000722822*^9, 3.7047970028128505`*^9}, {3.704797117589943*^9, 
   3.704797119158188*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 0 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.7047946696615915`*^9, 
  3.704794670150857*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{"vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vec", "]"}], "\[Equal]", "1"}], ")"}]}], ":=", 
   RowBox[{"SphericalToCartesian", "[", 
    RowBox[{
     RowBox[{"{", "0", "}"}], ",", "vec", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
   3.69487784687862*^9}, 3.7040357818173137`*^9, {3.70403595449743*^9, 
   3.704035955400519*^9}, {3.704036037257383*^9, 3.704036039872386*^9}, {
   3.7040376569642487`*^9, 3.7040376592672987`*^9}, {3.704793976789963*^9, 
   3.7047939767924643`*^9}, {3.7047947475223055`*^9, 3.704794756021964*^9}, {
   3.7047947862910156`*^9, 3.704794794302329*^9}, 3.7047955150752487`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 1 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}, {3.7047946719316473`*^9, 3.7047946723307223`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{"vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vec", "]"}], "\[Equal]", "3"}], ")"}]}], ":=", 
   RowBox[{"SphericalToCartesian", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", "vec", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
   3.694877867871709*^9}, {3.704035956113541*^9, 3.7040359568324795`*^9}, {
   3.704037384461561*^9, 3.7040373861302357`*^9}, {3.704037660702447*^9, 
   3.704037661771861*^9}, {3.704793976800471*^9, 3.7047939768024716`*^9}, {
   3.70479480002267*^9, 3.704794803129311*^9}, 3.7047955175448823`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 2 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694874688901908*^9, 
  3.6948746898009787`*^9}, {3.69487492722574*^9, 3.694874928192198*^9}, {
  3.7047946738208933`*^9, 3.704794674860611*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{"vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vec", "]"}], "\[Equal]", "5"}], ")"}]}], ":=", 
   RowBox[{"SphericalToCartesian", "[", 
    RowBox[{
     RowBox[{"{", "2", "}"}], ",", "vec", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
  3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
  3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
  3.694875202607733*^9, 3.6948752033265867`*^9}, {3.694877808934082*^9, 
  3.694877889349968*^9}, {3.7040359582005615`*^9, 3.7040359589762683`*^9}, {
  3.7040376633333244`*^9, 3.7040376653219023`*^9}, {3.704793976807976*^9, 
  3.704793976809477*^9}, {3.7047948087314196`*^9, 3.704794816390177*^9}, {
  3.7047955199237866`*^9, 3.7047955289641175`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["rank", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874437876246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{"vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", 
       RowBox[{"Union", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "vec", "]"}], "\[Equal]", "#"}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{"1", ",", "3", ",", "5"}], "}"}]}], "]"}], "]"}], 
      "\[NotEqual]", " ", "2"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "bad\[Lambda]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}, {3.7047934929541063`*^9, 3.7047935100642242`*^9}, {
  3.704794861439391*^9, 3.704794886704449*^9}, {3.7047949491123505`*^9, 
  3.704794950007805*^9}, {3.704795122969279*^9, 3.704795159656887*^9}, {
  3.70479760861598*^9, 3.7047976093121247`*^9}, {3.7048001385250173`*^9, 
  3.7048001392853003`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["numeric or non-numeric", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874437876246*^9}, {
  3.7047983739647694`*^9, 3.7047983870421124`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalToCartesian", "[", 
    RowBox[{"\[Lambda]_", ",", "vec_", ",", "opts___Rule"}], "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"(", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Union", "[", 
         RowBox[{"NumericQ", "/@", "vec"}], "]"}], "\[Equal]", 
        RowBox[{"{", "True", "}"}]}], ",", "True", ",", "False"}], "]"}], 
     ")"}]}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"suspsymbols", ",", "pos", ",", "symbols"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"suspsymbols", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{"vec", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Times", "\[Rule]", " ", "List"}], ",", 
          RowBox[{"Plus", "\[Rule]", " ", "List"}]}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"pos", "=", 
      RowBox[{"Flatten", "@", 
       RowBox[{"Position", "[", 
        RowBox[{
         RowBox[{"Flatten", "[", 
          RowBox[{"NumericQ", "/@", "suspsymbols"}], "]"}], ",", "False", ",",
          "1"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"symbols", "=", 
      RowBox[{"DeleteDuplicates", "[", 
       RowBox[{
       "suspsymbols", "\[LeftDoubleBracket]", "pos", 
        "\[RightDoubleBracket]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
     "Print", "[", 
      "\"\<Proceeding with non-numeric evaluation by assuming following \
variables to be real:\>\"", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "symbols", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SphericalToCartesian", "[", 
      RowBox[{"\[Lambda]", ",", "vec", ",", "symbols", ",", "opts"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
   3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
   3.7040374979047346`*^9}, {3.7047934929541063`*^9, 
   3.7047935100642242`*^9}, {3.704794861439391*^9, 3.704794886704449*^9}, {
   3.7047949491123505`*^9, 3.704794950007805*^9}, {3.704795122969279*^9, 
   3.704795159656887*^9}, {3.70479760861598*^9, 3.7047976093121247`*^9}, {
   3.7047981314862766`*^9, 3.7047981328261123`*^9}, {3.704798163216778*^9, 
   3.704798169125827*^9}, {3.704798216854945*^9, 3.7047982254854803`*^9}, {
   3.704798408874193*^9, 3.7047984998610144`*^9}, {3.704798577882124*^9, 
   3.7047986442816143`*^9}, {3.704798729361001*^9, 3.704798733378904*^9}, {
   3.704799004788348*^9, 3.704799006768032*^9}, 3.70479904494837*^9, {
   3.7047990802663016`*^9, 3.7047991345171876`*^9}, {3.7047991727530475`*^9, 
   3.70479917744575*^9}, {3.711999716527564*^9, 3.711999733538796*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["symmetry properties", "Section",
 CellChangeTimes->{{3.69487442893291*^9, 3.694874437876246*^9}, {
  3.7047974999215684`*^9, 3.7047975020307903`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Conjugate", "[", "vec", "]"}], ",", "vec"}], "]"}]}]}], ":=", 
   
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}, {3.7047934929541063`*^9, 3.7047935100642242`*^9}, {
  3.704794861439391*^9, 3.704794886704449*^9}, {3.7047949491123505`*^9, 
  3.704794950007805*^9}, {3.704795122969279*^9, 3.704795159656887*^9}, {
  3.704797659395218*^9, 3.704797679962817*^9}, {3.7047979620974655`*^9, 
  3.704797962607649*^9}, {3.7047993912940364`*^9, 3.7047993983275304`*^9}, {
  3.7047995011878586`*^9, 3.7047995033415194`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "^", 
             RowBox[{"(", 
              RowBox[{"#", "-", "2"}], ")"}]}], "&"}], ",", "3"}], "]"}], 
         ")"}], "*", 
        RowBox[{"Conjugate", "[", "vec", "]"}]}], ",", " ", 
       RowBox[{"Reverse", "[", "vec", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}, {3.7047934929541063`*^9, 3.7047935100642242`*^9}, {
  3.704794861439391*^9, 3.704794886704449*^9}, {3.7047949491123505`*^9, 
  3.704794950007805*^9}, {3.704795122969279*^9, 3.704795159656887*^9}, {
  3.704797659395218*^9, 3.704797710041584*^9}, {3.7047979485181117`*^9, 
  3.7047979669777093`*^9}, {3.7047993568140244`*^9, 3.704799386853549*^9}, {
  3.7047994819425297`*^9, 3.704799483492571*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "vec_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Array", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"-", "1"}], ")"}], "^", 
             RowBox[{"(", 
              RowBox[{"#", "-", "3"}], ")"}]}], "&"}], ",", "5"}], "]"}], 
         ")"}], "*", 
        RowBox[{"Conjugate", "[", "vec", "]"}]}], ",", " ", 
       RowBox[{"Reverse", "[", "vec", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}, {3.7047934929541063`*^9, 3.7047935100642242`*^9}, {
  3.704794861439391*^9, 3.704794886704449*^9}, {3.7047949491123505`*^9, 
  3.704794950007805*^9}, {3.704795122969279*^9, 3.704795159656887*^9}, {
  3.704797659395218*^9, 3.704797710041584*^9}, {3.7047979485181117`*^9, 
  3.7047979766177945`*^9}, {3.704799410194129*^9, 3.7047994165831003`*^9}, {
  3.7047994692778287`*^9, 3.704799486430708*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "0", "}"}], ",", "vec_", ",", "symbols_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Assuming", "[", 
        RowBox[{
         RowBox[{"symbols", " ", "\[Element]", "Reals"}], ",", 
         RowBox[{"Simplify", "@", 
          RowBox[{"Conjugate", "[", "vec", "]"}]}]}], "]"}], ",", " ", 
       "vec"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
  3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
  3.7040374979047346`*^9}, {3.7047934929541063`*^9, 3.7047935100642242`*^9}, {
  3.704794861439391*^9, 3.704794886704449*^9}, {3.7047949491123505`*^9, 
  3.704794950007805*^9}, {3.704795122969279*^9, 3.704795159656887*^9}, {
  3.704797659395218*^9, 3.704797679962817*^9}, {3.7047979620974655`*^9, 
  3.704797962607649*^9}, {3.704798752879492*^9, 3.704798787579569*^9}, {
  3.704799399784384*^9, 3.7047994050631447`*^9}, {3.704799508377228*^9, 
  3.704799510142229*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "1", "}"}], ",", "vec_", ",", "symbols_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Assuming", "[", 
        RowBox[{
         RowBox[{"symbols", " ", "\[Element]", "Reals"}], ",", 
         RowBox[{"Simplify", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Array", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"#", "-", "2"}], ")"}]}], "&"}], ",", "3"}], "]"}], 
            ")"}], "*", 
           RowBox[{"Conjugate", "[", "vec", "]"}]}], "]"}]}], "]"}], ",", " ", 
       RowBox[{"Reverse", "[", "vec", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
   3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
   3.7040374979047346`*^9}, {3.7047934929541063`*^9, 
   3.7047935100642242`*^9}, {3.704794861439391*^9, 3.704794886704449*^9}, {
   3.7047949491123505`*^9, 3.704794950007805*^9}, {3.704795122969279*^9, 
   3.704795159656887*^9}, {3.704797659395218*^9, 3.704797710041584*^9}, {
   3.7047979485181117`*^9, 3.7047979669777093`*^9}, 3.7047987635817423`*^9, {
   3.7047988189951005`*^9, 3.704798843280505*^9}, {3.704799421614273*^9, 
   3.7047994303890085`*^9}, {3.704799497270171*^9, 3.7047994994715085`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "[", 
     RowBox[{
      RowBox[{"{", "2", "}"}], ",", "vec_", ",", "symbols_", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Assuming", "[", 
        RowBox[{
         RowBox[{"symbols", " ", "\[Element]", "Reals"}], ",", 
         RowBox[{"Simplify", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Array", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"#", "-", "3"}], ")"}]}], "&"}], ",", "5"}], "]"}], 
            ")"}], "*", 
           RowBox[{"Conjugate", "[", "vec", "]"}]}], "]"}]}], "]"}], ",", " ", 
       RowBox[{"Reverse", "[", "vec", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalToCartesian", "::", "badsymm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6948742226388693`*^9, 3.694874329617723*^9}, {
   3.704035930426381*^9, 3.704035931444807*^9}, {3.7040374960144863`*^9, 
   3.7040374979047346`*^9}, {3.7047934929541063`*^9, 
   3.7047935100642242`*^9}, {3.704794861439391*^9, 3.704794886704449*^9}, {
   3.7047949491123505`*^9, 3.704794950007805*^9}, {3.704795122969279*^9, 
   3.704795159656887*^9}, {3.704797659395218*^9, 3.704797710041584*^9}, {
   3.7047979485181117`*^9, 3.7047979766177945`*^9}, 3.7047987649209285`*^9, {
   3.7047988542008033`*^9, 3.704798858579011*^9}, {3.7047994315300126`*^9, 
   3.704799439882805*^9}, {3.704799506187661*^9, 3.7047995121806345`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["construct cartesian tensors", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}, {
  3.694847170292542*^9, 3.694847171022867*^9}, {3.694875117972661*^9, 
  3.6948751286253347`*^9}, {3.704800287411061*^9, 3.7048002888011236`*^9}, {
  3.7048004362392025`*^9, 3.704800439969365*^9}}],

Cell[CellGroupData[{

Cell["rank 0 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694875294071239*^9, 
  3.694875294925514*^9}, {3.694875508038213*^9, 3.694875510433641*^9}, {
  3.704795211695173*^9, 3.7047952168653126`*^9}, {3.7047968223555737`*^9, 
  3.7047968494452333`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalToCartesian", "[", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", "vec_", ",", "symb___", ",", 
    "opts___Rule"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"BT", ",", "array", ",", "iso", ",", "id", ",", "diag"}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          FractionBox["1", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          FractionBox["\[ImaginaryI]", 
           SqrtBox["2"]], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", 
            SqrtBox["2"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
           ",", 
          SqrtBox[
           FractionBox["2", "3"]], ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"array", "=", 
      RowBox[{"Chop", "@", 
       RowBox[{"SparseArray", "[", 
        RowBox[{"Simplify", "@", 
         RowBox[{"ArrayReshape", "[", 
          RowBox[{
           RowBox[{"BT", ".", 
            RowBox[{"Join", "[", 
             RowBox[{"vec", ",", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0", ",", "8"}], "]"}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"diag", "=", 
      RowBox[{"Diagonal", "[", "array", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"id", "=", 
      RowBox[{"SparseArray", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i_", ",", "i_"}], "}"}], "\[RuleDelayed]", " ", "1"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"iso", "=", 
      RowBox[{
       RowBox[{"1", "/", "3"}], "*", 
       RowBox[{"Total", "[", "diag", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Normal", "@", 
      RowBox[{"Simplify", "[", 
       RowBox[{"Chop", "[", 
        RowBox[{"iso", "*", "id"}], "]"}], "]"}]}]}]}], "\[IndentingNewLine]",
    "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948755380109177`*^9, 
   3.694875630383266*^9}, {3.694875777583501*^9, 3.694875819399304*^9}, {
   3.6948759695775557`*^9, 3.694876018818296*^9}, {3.694876096207678*^9, 
   3.694876110776445*^9}, {3.694876276031968*^9, 3.694876456968416*^9}, 
   3.704035965327898*^9, {3.7040364531185007`*^9, 3.7040364659077234`*^9}, 
   3.7040375986344957`*^9, 3.7047939768575106`*^9, {3.7047952606704893`*^9, 
   3.704795271632124*^9}, {3.7047954519783907`*^9, 3.704795463830639*^9}, {
   3.704795547468233*^9, 3.70479557708139*^9}, {3.7047956144313545`*^9, 
   3.704795615180146*^9}, {3.7047956524397573`*^9, 3.704795667780449*^9}, {
   3.7047963975021396`*^9, 3.7047963977715673`*^9}, 3.704796454081702*^9, {
   3.7047964849059706`*^9, 3.704796600420703*^9}, {3.7047967343959613`*^9, 
   3.7047967558325086`*^9}, {3.7047967976005645`*^9, 3.704796860400483*^9}, {
   3.7047968967517138`*^9, 3.7047969072428246`*^9}, {3.704797124409805*^9, 
   3.7047971292927785`*^9}, {3.7047971822924256`*^9, 
   3.7047971831429567`*^9}, {3.704798933801493*^9, 3.704798935868892*^9}, {
   3.7120000481145554`*^9, 3.7120000492916136`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 1 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694875294071239*^9, 
  3.694875294925514*^9}, {3.694875508038213*^9, 3.694875510433641*^9}, {
  3.704795211695173*^9, 3.7047952168653126`*^9}, {3.7047968223555737`*^9, 
  3.7047968226253242`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalToCartesian", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", "vec_", ",", "symb___", ",", 
    "opts___Rule"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"BT", ",", "array", ",", "upper", ",", "lower"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          FractionBox["1", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          FractionBox["\[ImaginaryI]", 
           SqrtBox["2"]], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", 
            SqrtBox["2"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
           ",", 
          SqrtBox[
           FractionBox["2", "3"]], ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"array", "=", 
      RowBox[{"Chop", "@", 
       RowBox[{"SparseArray", "[", 
        RowBox[{"Simplify", "@", 
         RowBox[{"ArrayReshape", "[", 
          RowBox[{
           RowBox[{"BT", ".", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0", ",", "1"}], "]"}], ",", "vec", ",", 
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0", ",", "5"}], "]"}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"upper", "=", 
      RowBox[{"UpperTriangularize", "[", 
       RowBox[{"array", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"lower", "=", 
      RowBox[{"LowerTriangularize", "[", 
       RowBox[{"array", ",", 
        RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Normal", "@", 
      RowBox[{"Simplify", "[", 
       RowBox[{
        RowBox[{"1", "/", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"upper", "-", 
          RowBox[{"Transpose", "[", "lower", "]"}], "+", "lower", "-", 
          RowBox[{"Transpose", "[", "upper", "]"}]}], ")"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948755380109177`*^9, 
   3.694875630383266*^9}, {3.694875777583501*^9, 3.694875819399304*^9}, {
   3.6948759695775557`*^9, 3.694876018818296*^9}, {3.694876096207678*^9, 
   3.694876110776445*^9}, {3.694876276031968*^9, 3.694876456968416*^9}, 
   3.704035965327898*^9, {3.7040364531185007`*^9, 3.7040364659077234`*^9}, 
   3.7040375986344957`*^9, 3.7047939768575106`*^9, {3.7047952606704893`*^9, 
   3.704795271632124*^9}, {3.7047954519783907`*^9, 3.704795463830639*^9}, {
   3.704795547468233*^9, 3.70479557708139*^9}, {3.7047956144313545`*^9, 
   3.704795615180146*^9}, {3.7047956524397573`*^9, 3.704795667780449*^9}, {
   3.7047963975021396`*^9, 3.7047963977715673`*^9}, 3.704796454081702*^9, {
   3.7047964849059706`*^9, 3.704796600420703*^9}, {3.7047967343959613`*^9, 
   3.7047967558325086`*^9}, {3.7047967976005645`*^9, 
   3.7047968417809515`*^9}, {3.704796884410116*^9, 3.7047969182405972`*^9}, {
   3.704797131962944*^9, 3.7047971392077827`*^9}, {3.7047971791983643`*^9, 
   3.704797180062948*^9}, 3.7047989408852835`*^9, {3.712000054790039*^9, 
   3.7120000567513933`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["rank 2 argument", "Subsection",
 CellChangeTimes->{{3.6948745568804626`*^9, 3.694874558387946*^9}, {
  3.694874617982026*^9, 3.6948746191388702`*^9}, {3.694875294071239*^9, 
  3.694875294925514*^9}, {3.694875508038213*^9, 3.694875510433641*^9}, {
  3.704795211695173*^9, 3.7047952168653126`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalToCartesian", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", "vec_", ",", "symb___", ",", 
    "opts___Rule"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "BT", ",", "array", ",", "iso", ",", "id", ",", "diag", ",", "upper", 
      ",", "lower"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          FractionBox["1", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          FractionBox["\[ImaginaryI]", 
           SqrtBox["2"]], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", 
            SqrtBox["2"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", "0", ",", "0", 
          ",", 
          FractionBox["\[ImaginaryI]", "2"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["6"]]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["1", "2"]}], ",", "0", ",", 
          FractionBox["1", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0", ",", 
          FractionBox["\[ImaginaryI]", "2"], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", 
            SqrtBox["3"]]}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0",
           ",", 
          SqrtBox[
           FractionBox["2", "3"]], ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"array", "=", 
      RowBox[{"Chop", "@", 
       RowBox[{"SparseArray", "[", 
        RowBox[{"Simplify", "@", 
         RowBox[{"ArrayReshape", "[", 
          RowBox[{
           RowBox[{"BT", ".", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"ConstantArray", "[", 
               RowBox[{"0", ",", "4"}], "]"}], ",", "vec"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"diag", "=", 
      RowBox[{"Diagonal", "[", "array", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"upper", "=", 
      RowBox[{"UpperTriangularize", "[", 
       RowBox[{"array", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"lower", "=", 
      RowBox[{"LowerTriangularize", "[", 
       RowBox[{"array", ",", 
        RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"id", "=", 
      RowBox[{"SparseArray", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i_", ",", "i_"}], "}"}], "\[RuleDelayed]", " ", "1"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"iso", "=", 
      RowBox[{
       RowBox[{"1", "/", "3"}], "*", 
       RowBox[{"Total", "[", "diag", "]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Normal", "@", 
      RowBox[{"Simplify", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"1", "/", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{"upper", "+", 
           RowBox[{"Transpose", "[", "lower", "]"}], "+", "lower", "+", 
           RowBox[{"Transpose", "[", "upper", "]"}]}], ")"}]}], "+", 
        RowBox[{"DiagonalMatrix", "[", "diag", "]"}], "-", 
        RowBox[{"iso", "*", "id"}]}], "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874456338451*^9, 3.694874477771564*^9}, {
   3.694874538533444*^9, 3.6948745444379587`*^9}, {3.69487457726796*^9, 
   3.694874641796769*^9}, {3.694874727648898*^9, 3.69487472908704*^9}, {
   3.694875144039489*^9, 3.694875185382517*^9}, {3.694875297884471*^9, 
   3.694875318742291*^9}, {3.694875357456036*^9, 3.694875380743692*^9}, {
   3.694875491648039*^9, 3.6948755002299423`*^9}, {3.6948755380109177`*^9, 
   3.694875630383266*^9}, {3.694875777583501*^9, 3.694875819399304*^9}, {
   3.6948759695775557`*^9, 3.694876018818296*^9}, {3.694876096207678*^9, 
   3.694876110776445*^9}, {3.694876276031968*^9, 3.694876456968416*^9}, 
   3.704035965327898*^9, {3.7040364531185007`*^9, 3.7040364659077234`*^9}, 
   3.7040375986344957`*^9, 3.7047939768575106`*^9, {3.7047952606704893`*^9, 
   3.704795271632124*^9}, {3.7047954519783907`*^9, 3.704795463830639*^9}, {
   3.704795547468233*^9, 3.70479557708139*^9}, {3.7047956144313545`*^9, 
   3.704795615180146*^9}, {3.7047956524397573`*^9, 3.704795667780449*^9}, {
   3.7047963975021396`*^9, 3.7047963977715673`*^9}, 3.704796454081702*^9, {
   3.7047964849059706`*^9, 3.704796600420703*^9}, {3.7047967343959613`*^9, 
   3.7047967558325086`*^9}, {3.7047967976005645`*^9, 
   3.7047967984522967`*^9}, {3.704797142524166*^9, 3.7047971767896967`*^9}, 
   3.7047989438706827`*^9, {3.712000061770186*^9, 3.7120000634714975`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.69484711244881*^9, 3.6948471256732597`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalToCartesian", "::", "bad\[Lambda]"}], "=", 
   "\"\<The number of Spherical Tensor components must match 2\[Lambda] +1 \
with \[Lambda] \[LessEqual] 2\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69487433475809*^9, 3.694874356953579*^9}, 
   3.70403596664032*^9, 3.704037603111315*^9, 3.7047939768640156`*^9, {
   3.7048001578045273`*^9, 3.704800182052932*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "::", "vecnn"}], "=", 
    "\"\<The Spherical Tensor components are non-numeric.\>\""}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694874809054022*^9, 3.694874832374934*^9}, 
   3.7040359703601475`*^9, {3.7040376068002152`*^9, 3.704037608197854*^9}, 
   3.704793976891035*^9, {3.7047981911254663`*^9, 3.7047982097550907`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalToCartesian", "::", "badsymm"}], "=", 
    "\"\<The Spherical Tensor components do not meet the correct symmetry \
properties (\!\(\*SubscriptBox[\(T\), \
\(\[Lambda]\[Mu]\)]\)\!\(\*SuperscriptBox[\()\), \(\[Dagger]\)]\) = \
(-1\!\(\*SuperscriptBox[\()\), \(\[Mu]\)]\)\!\(\*SubscriptBox[\(T\), \(\
\[Lambda] - \[Mu]\)]\).\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694875074750461*^9, 3.694875078989812*^9}, 
   3.704035974190638*^9, 3.7040376124202986`*^9, 3.704793976917553*^9, {
   3.704797754841172*^9, 3.704797809511524*^9}, {3.7047978444523935`*^9, 
   3.704797861399272*^9}, {3.7047980271926036`*^9, 3.704798027981861*^9}, {
   3.7119994649466343`*^9, 3.7119994659695597`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"End", "[", "]"}], ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"EndPackage", "[", "]"}], ";"}], " "}]}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.56459918257414*^9},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"13fc5de7-8a44-4f3b-98ec-cdf6515005bf"],

Cell[CellGroupData[{

Cell["170517 changes incorporated into v3.0.0b15 [CB]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.704038062070075*^9, 
   3.7040380856887045`*^9}},ExpressionUUID->"79db947a-e0f6-43e9-910d-\
dcacf65de291"],

Cell["\<\
CartesianToSpherical has been adjusted to handle SparseArray vector and \
matrix inputs.\
\>", "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 3.699279350177552*^9}, {
  3.704038090768295*^9, 
  3.7040381060581875`*^9}},ExpressionUUID->"4a42b1ce-0b77-4cef-b7cb-\
4edd34263bf2"]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 715},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 398, 8, 98, "Title",ExpressionUUID->"8d22a252-f40b-48cc-94a2-6e4ca9a15b0d",
 Evaluatable->False,
 InitializationCell->True],
Cell[968, 32, 233, 4, 35, "Text",ExpressionUUID->"29e430b1-a18f-4be4-8791-ef3492677cc8"],
Cell[CellGroupData[{
Cell[1226, 40, 182, 5, 69, "Chapter",ExpressionUUID->"3c9fc702-e573-4f20-b4e2-4ec3d85e3f7b",
 Evaluatable->False,
 InitializationCell->True],
Cell[1411, 47, 797, 18, 68, "Input",ExpressionUUID->"b53fce19-0b49-416d-9903-76e301c7b6b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2245, 70, 255, 6, 69, "Chapter",ExpressionUUID->"e4da2adf-1596-4460-a825-55e2b4c3dfc0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2503, 78, 5561, 83, 467, "Input",ExpressionUUID->"0b682b60-16cb-45a2-b402-235ea2658322",
 InitializationCell->True],
Cell[8067, 163, 570, 12, 46, "Input",ExpressionUUID->"a51b0f68-762e-4f97-ab89-6f8cfaa3e594",
 InitializationCell->True],
Cell[8640, 177, 1833, 30, 194, "Input",ExpressionUUID->"f697b0f8-0845-45ca-bf4d-5cdba0312d0d",
 InitializationCell->True],
Cell[10476, 209, 2748, 86, 256, "Input",ExpressionUUID->"fc33e156-84b1-41d4-ae71-6f857c606e46",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13261, 300, 125, 4, 64, "Chapter",ExpressionUUID->"0d369885-adaa-4e20-bd1d-a88c4db02335",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13389, 306, 230, 7, 48, "Input",ExpressionUUID->"01303811-6eed-479d-8561-c0bef7f5c835",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13656, 318, 114, 2, 69, "Chapter",ExpressionUUID->"1fa1da48-9815-411c-8f9e-2f69d378c435"],
Cell[CellGroupData[{
Cell[13795, 324, 224, 4, 61, "Subchapter",ExpressionUUID->"91447aa8-40d2-4e41-840c-fe606a81bb45",
 InitializationCell->True],
Cell[14022, 330, 254, 7, 48, "Input",ExpressionUUID->"2fcfb6ae-8dae-479e-8f31-3f40c703934d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14313, 342, 170, 3, 45, "Subchapter",ExpressionUUID->"cf820474-836d-464e-bc0d-704019e334cf",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[14508, 349, 99, 1, 35, "Subsubsection",ExpressionUUID->"a469d3b4-72b9-4e28-b31c-6260c5d62a6b"],
Cell[14610, 352, 367, 11, 48, "Input",ExpressionUUID->"db5737f4-334d-4e92-a874-a7c529c48445",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15014, 368, 102, 1, 29, "Subsubsection",ExpressionUUID->"44ab13a8-fb1b-48cf-bf19-cfebddb271ca"],
Cell[15119, 371, 788, 20, 91, "Input",ExpressionUUID->"587a7d89-e174-4aac-8097-1c140f9ff258",
 InitializationCell->True],
Cell[15910, 393, 849, 22, 91, "Input",ExpressionUUID->"a55dfe63-0f09-4071-b6af-e776a166deaa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16796, 420, 106, 1, 29, "Subsubsection",ExpressionUUID->"7943071b-9f9a-40a7-a843-e9d875e950b7"],
Cell[16905, 423, 871, 24, 91, "Input",ExpressionUUID->"6f677b76-c819-4d25-aaa1-d92911fae5fb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17813, 452, 211, 4, 29, "Subsubsection",ExpressionUUID->"644a08f8-b2eb-49a8-8d26-f4c6705822e2"],
Cell[18027, 458, 283, 6, 68, "Text",ExpressionUUID->"dd46f8fa-d118-4872-9869-1231282a995c"],
Cell[18313, 466, 445, 9, 49, "Text",ExpressionUUID->"f57e2034-d9c8-4019-a8de-fef5f4698306"],
Cell[18761, 477, 1703, 44, 135, "Input",ExpressionUUID->"19cc43e6-fee2-4f62-9ade-696520da8866",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[20513, 527, 248, 3, 45, "Subchapter",ExpressionUUID->"432e9df3-17d8-4445-b3c7-9e757cdd07b9"],
Cell[20764, 532, 610, 16, 70, "Input",ExpressionUUID->"1c096f09-1b15-4d33-8c1b-42edb18cfc4a",
 InitializationCell->True],
Cell[21377, 550, 1344, 38, 133, "Input",ExpressionUUID->"afc4ef7c-c4ee-4c8c-9d58-661830b84c37",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22758, 593, 384, 5, 45, "Subchapter",ExpressionUUID->"4f2c71a2-e223-4a07-937f-a8d24a1613fa"],
Cell[23145, 600, 1334, 33, 181, "Input",ExpressionUUID->"17ea79bf-70ed-4391-bac8-c90672e2510f",
 InitializationCell->True],
Cell[24482, 635, 1338, 35, 181, "Input",ExpressionUUID->"6a2650d5-6b82-47a6-ae49-261e4cb97610",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25857, 675, 422, 6, 45, "Subchapter",ExpressionUUID->"c76bf4c3-438b-41d7-8cd6-57061d394359"],
Cell[26282, 683, 910, 25, 85, "Input",ExpressionUUID->"05f8eb2c-0076-4e76-8338-029d0287a7b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[27229, 713, 475, 6, 45, "Subchapter",ExpressionUUID->"c01dae24-ea54-41f8-afe9-bc0d922320c1"],
Cell[27707, 721, 779, 21, 123, "Input",ExpressionUUID->"26f57662-4176-4f06-862e-3f7bf4ea1de3",
 InitializationCell->True],
Cell[28489, 744, 993, 28, 85, "Input",ExpressionUUID->"c8f8a2e7-b773-4a16-9a9e-5d249a0d35d6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29519, 777, 124, 2, 45, "Subchapter",ExpressionUUID->"4abc8a53-d43f-4d7f-9928-bbead1b2018b",
 InitializationCell->True],
Cell[29646, 781, 281, 7, 46, "Input",ExpressionUUID->"f249a79a-5199-4128-9ac6-293706a5aa4b",
 InitializationCell->True],
Cell[29930, 790, 329, 8, 46, "Input",ExpressionUUID->"b3f24cde-7c96-444e-9abd-78276f91b3fd",
 InitializationCell->True],
Cell[30262, 800, 322, 8, 46, "Input",ExpressionUUID->"ca9d23e9-1677-4b77-918c-11ac6007c70d",
 InitializationCell->True],
Cell[30587, 810, 260, 7, 46, "Input",ExpressionUUID->"8f993b10-0b65-419c-b549-3111eb415978",
 InitializationCell->True],
Cell[30850, 819, 304, 7, 66, "Input",ExpressionUUID->"2d344d8e-90cf-417b-8f09-4ea1717ec9fb",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[31203, 832, 172, 3, 69, "Chapter",ExpressionUUID->"4cf7b73a-225e-43a5-aea9-8861b617fccc"],
Cell[CellGroupData[{
Cell[31400, 839, 224, 4, 61, "Subchapter",ExpressionUUID->"58d7d5c2-c2a8-483b-af90-d980079f6a72",
 InitializationCell->True],
Cell[31627, 845, 331, 8, 51, "Input",ExpressionUUID->"63b63acf-aa83-47a0-9060-ff4d25958349",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31995, 858, 170, 3, 45, "Subchapter",ExpressionUUID->"f8cfaf8c-7232-4947-b89d-a58ecb76c759",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[32190, 865, 91, 1, 69, "Section",ExpressionUUID->"e9d10921-9290-4dac-af2b-54cff6a2aa2f"],
Cell[32284, 868, 470, 13, 51, "Input",ExpressionUUID->"288c84dd-345d-44f4-b813-66ea403727e2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32791, 886, 88, 1, 69, "Section",ExpressionUUID->"67977f4e-8df9-44cc-8933-85b29a713afb"],
Cell[32882, 889, 661, 18, 51, "Input",ExpressionUUID->"a01b6ba5-f312-48a5-9ea0-060ca6426e48",
 InitializationCell->True],
Cell[33546, 909, 723, 18, 51, "Input",ExpressionUUID->"dbe507dc-644b-4a78-b8d6-438b14aa117a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34306, 932, 92, 1, 69, "Section",ExpressionUUID->"c4e976f7-dd7c-4da3-8d4f-854898600420"],
Cell[CellGroupData[{
Cell[34423, 937, 156, 2, 47, "Subsection",ExpressionUUID->"e13bc736-8843-4104-8619-cd888b081b06"],
Cell[34582, 941, 985, 22, 75, "Input",ExpressionUUID->"533807ac-f07e-49b8-8df7-38aec3062f0c",
 InitializationCell->True],
Cell[35570, 965, 1102, 24, 75, "Input",ExpressionUUID->"aef82bb6-07ad-4491-8c40-4138b041d2db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36709, 994, 207, 3, 47, "Subsection",ExpressionUUID->"71e9c2a0-c543-4189-b086-f151f427e21c"],
Cell[36919, 999, 855, 19, 51, "Input",ExpressionUUID->"d308831f-a2f5-4a77-9af1-b5e88042289a",
 InitializationCell->True],
Cell[37777, 1020, 1082, 22, 51, "Input",ExpressionUUID->"58aa64cb-4f91-423a-8a6d-f089c758a6df",
 InitializationCell->True],
Cell[38862, 1044, 958, 21, 74, "Input",ExpressionUUID->"487e6895-ccb9-4cbc-8e1f-e5fb817bc111",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39857, 1070, 252, 3, 47, "Subsection",ExpressionUUID->"27183501-e20e-4ce0-aa44-69f58426fb4a"],
Cell[40112, 1075, 821, 18, 51, "Input",ExpressionUUID->"af1a3c30-8622-4827-8f6b-4214e6cecf84",
 InitializationCell->True],
Cell[40936, 1095, 1011, 22, 96, "Input",ExpressionUUID->"93f16818-8207-4296-bd28-74f5925001dc",
 InitializationCell->True],
Cell[41950, 1119, 991, 22, 96, "Input",ExpressionUUID->"32a34351-9417-462d-92ca-a395fba571c1",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[43002, 1148, 277, 4, 45, "Subchapter",ExpressionUUID->"323b2971-b36c-4b94-9814-9448828e7169",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[43304, 1156, 119, 2, 69, "Section",ExpressionUUID->"bab796d1-8e9f-4736-a058-75f5026ced25"],
Cell[43426, 1160, 583, 13, 51, "Input",ExpressionUUID->"d4d14e6e-2ddf-4230-a717-088c88feaf86",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44046, 1178, 148, 2, 69, "Section",ExpressionUUID->"d1f68639-0651-4c2b-a8a2-24f0bc27b0f7"],
Cell[CellGroupData[{
Cell[44219, 1184, 156, 2, 47, "Subsection",ExpressionUUID->"60d03150-fbef-498e-be9c-c752da4f22ee"],
Cell[44378, 1188, 900, 20, 53, "Input",ExpressionUUID->"a1b5bb2d-0af1-448b-b59e-77ffb03f14bd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[45315, 1213, 207, 3, 47, "Subsection",ExpressionUUID->"82ff1196-2c2a-4ad9-84c4-04c022204474"],
Cell[45525, 1218, 815, 18, 51, "Input",ExpressionUUID->"57241894-b80b-4f36-974a-c471aa2ba4c4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[46377, 1241, 252, 3, 47, "Subsection",ExpressionUUID->"c2756027-a9f2-4258-aca9-e7e86bf4f1a9"],
Cell[46632, 1246, 782, 17, 51, "Input",ExpressionUUID->"c195499a-f8f8-4c60-a931-a5a0695561cc",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[47475, 1270, 243, 4, 45, "Subchapter",ExpressionUUID->"6fd3529b-468b-4322-8bfc-2993f0c96ff9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[47743, 1278, 156, 2, 43, "Subsection",ExpressionUUID->"ebdb20ac-2069-42d4-adcb-3384f96b7801"],
Cell[47902, 1282, 804, 18, 67, "Input",ExpressionUUID->"623c3df9-1dbb-4baa-94f0-4827a3b401d4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48743, 1305, 205, 3, 35, "Subsection",ExpressionUUID->"2dab2ac8-7636-4bc3-86b3-16e6b2d1f0db"],
Cell[48951, 1310, 364, 8, 53, "Text",ExpressionUUID->"845d35b5-8ad6-4a2a-a4b2-d791ee0c192d"],
Cell[49318, 1320, 854, 19, 51, "Input",ExpressionUUID->"d9d1f001-a34a-4989-b47c-e21b93bd74cc",
 InitializationCell->True],
Cell[50175, 1341, 1931, 46, 228, "Input",ExpressionUUID->"c0d12818-7413-4664-8a79-b5e1d9960dd6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[52143, 1392, 251, 3, 35, "Subsection",ExpressionUUID->"4a045e89-a87c-430f-b3f9-dc6fe16373ae"],
Cell[52397, 1397, 423, 8, 87, "Text",ExpressionUUID->"81aefa69-981f-42d7-8ba1-cf0b46d7085f"],
Cell[52823, 1407, 1369, 28, 66, "Input",ExpressionUUID->"a04071e4-b95b-4096-8127-eb433ea3ceaa",
 InitializationCell->True],
Cell[54195, 1437, 2729, 63, 237, "Input",ExpressionUUID->"3c69fbf5-9e5f-4f2e-b4d2-302859c2b19d",
 InitializationCell->True],
Cell[56927, 1502, 3406, 84, 275, "Input",ExpressionUUID->"eef1a14c-44da-476d-b5fa-c37b69031f9b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[60382, 1592, 124, 2, 45, "Subchapter",ExpressionUUID->"57146715-5adb-4fc2-af15-d0e13c6e3d11",
 InitializationCell->True],
Cell[60509, 1596, 327, 8, 51, "Input",ExpressionUUID->"fd2b804f-0f0a-423d-85b6-665a85e84f51",
 InitializationCell->True],
Cell[60839, 1606, 358, 8, 51, "Input",ExpressionUUID->"71432d6c-108a-4c84-855a-2b4796a813c8",
 InitializationCell->True],
Cell[61200, 1616, 395, 9, 51, "Input",ExpressionUUID->"63a8788c-efad-457d-bb49-bfe86100805c",
 InitializationCell->True],
Cell[61598, 1627, 443, 9, 51, "Input",ExpressionUUID->"0fb53c54-7bde-4794-8f4e-00f27a78029e",
 InitializationCell->True],
Cell[62044, 1638, 365, 9, 51, "Input",ExpressionUUID->"4e47f619-da1e-4ca5-8ba6-83f9af5ef92d",
 InitializationCell->True],
Cell[62412, 1649, 385, 10, 51, "Input",ExpressionUUID->"411d6244-f56f-4c99-a798-096a4f2ca63b",
 InitializationCell->True],
Cell[62800, 1661, 418, 9, 51, "Input",ExpressionUUID->"bf10193a-cbb2-4900-8e53-8bf16eacf8db",
 InitializationCell->True],
Cell[63221, 1672, 443, 10, 51, "Input",ExpressionUUID->"7cd0d9db-6d7a-4ef8-892e-91f47fe596d0",
 InitializationCell->True],
Cell[63667, 1684, 343, 9, 51, "Input",ExpressionUUID->"96d57fd8-c173-42b3-8425-55a3075530a5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[64059, 1699, 226, 4, 80, "Chapter",ExpressionUUID->"2f797a49-f85a-4188-9a7a-11a32e9065d9"],
Cell[CellGroupData[{
Cell[64310, 1707, 224, 4, 61, "Subchapter",ExpressionUUID->"38b4ea03-d903-41e7-bdb3-4ccc0b9b574c",
 InitializationCell->True],
Cell[64537, 1713, 379, 8, 46, "Input",ExpressionUUID->"1e2f292d-9fa5-4b6c-9b5e-d818283c8c36",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[64953, 1726, 170, 3, 45, "Subchapter",ExpressionUUID->"73a757f8-9ac9-4552-b8ea-dab51a3c1c35",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[65148, 1733, 91, 1, 33, "Section",ExpressionUUID->"96be8227-36a4-4a82-9857-7471bc133121"],
Cell[65242, 1736, 492, 13, 49, "Input",ExpressionUUID->"59eb1ffb-4b09-4015-9316-494cbdc04134",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[65771, 1754, 179, 3, 33, "Section",ExpressionUUID->"d9806f39-6e5e-49a0-81bb-2291ae06939e"],
Cell[CellGroupData[{
Cell[65975, 1761, 255, 3, 43, "Subsection",ExpressionUUID->"0a00da84-36c5-41a1-9f2a-88e8b0985dc9"],
Cell[66233, 1766, 1113, 25, 46, "Input",ExpressionUUID->"7469d6bb-d711-4afc-83f8-f1ff6543c7e0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[67383, 1796, 207, 3, 35, "Subsection",ExpressionUUID->"ea578fe6-489c-4240-9c0f-f1ee9613dcbc"],
Cell[67593, 1801, 1084, 22, 66, "Input",ExpressionUUID->"386a39e1-b7ad-482f-b783-2ea2f9f1a0f7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[68714, 1828, 257, 3, 35, "Subsection",ExpressionUUID->"dd920380-d61c-4654-b762-a285b1bc58a1"],
Cell[68974, 1833, 1007, 21, 46, "Input",ExpressionUUID->"749e1733-588a-4f5c-ad59-d7a5ebbd47cf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[70018, 1859, 303, 4, 35, "Subsection",ExpressionUUID->"c54469a3-aee6-4562-8437-e0ed571eff45"],
Cell[70324, 1865, 985, 21, 46, "Input",ExpressionUUID->"1fafed5e-a931-4a3e-99f8-b1f152b938e2",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[71358, 1892, 88, 1, 33, "Section",ExpressionUUID->"d106517a-8335-48b0-a3e8-5eccb86e5be6"],
Cell[71449, 1895, 1188, 29, 49, "Input",ExpressionUUID->"4743ecd2-c71b-420b-ba2f-046fb63c74e8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[72674, 1929, 159, 2, 33, "Section",ExpressionUUID->"2c8555c6-ca10-469a-9ee4-cca6a7ccc5b3"],
Cell[72836, 1933, 2783, 61, 218, "Input",ExpressionUUID->"01e7ea53-5de5-43f3-b137-3c3fdf727690",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[75656, 1999, 156, 2, 33, "Section",ExpressionUUID->"fabb9d79-ecaf-4fb2-b167-7fb629eb342d"],
Cell[75815, 2003, 1097, 25, 49, "Input",ExpressionUUID->"b08c221e-b4fa-4b0d-a37f-f6cdd3431623",
 InitializationCell->True],
Cell[76915, 2030, 1466, 36, 71, "Input",ExpressionUUID->"b0aef413-d0fb-4fdc-ac0a-5871c8f499e8",
 InitializationCell->True],
Cell[78384, 2068, 1466, 36, 71, "Input",ExpressionUUID->"5c9800af-ab84-4756-be68-296dc03f4666",
 InitializationCell->True],
Cell[79853, 2106, 1336, 31, 71, "Input",ExpressionUUID->"655f153d-253c-44fe-8d35-cd6174935344",
 InitializationCell->True],
Cell[81192, 2139, 1774, 42, 90, "Input",ExpressionUUID->"b106bff8-15a0-4cfa-8f9b-4e4d03283965",
 InitializationCell->True],
Cell[82969, 2183, 1774, 42, 90, "Input",ExpressionUUID->"e27890be-e68d-4288-8de3-b48a0480fbf0",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[84792, 2231, 342, 5, 45, "Subchapter",ExpressionUUID->"2320ecbd-b248-4737-9e51-64a54d97050c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[85159, 2240, 355, 5, 43, "Subsection",ExpressionUUID->"47af7710-95c0-4bd9-bf02-2f9060fe72b7"],
Cell[85517, 2247, 6268, 148, 484, "Input",ExpressionUUID->"2039fdf9-6260-494f-ac6d-a4e7cec52fac",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[91822, 2400, 355, 5, 35, "Subsection",ExpressionUUID->"4731de70-ba6a-4809-9fb6-1fda6a2d044a"],
Cell[92180, 2407, 6250, 146, 503, "Input",ExpressionUUID->"245735b9-a513-4437-8ec8-c598cb9b3dbf",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[98467, 2558, 302, 4, 35, "Subsection",ExpressionUUID->"7e818a33-9fc7-4eef-80cf-4901396a2956"],
Cell[98772, 2564, 6784, 161, 560, "Input",ExpressionUUID->"d51b8b74-8249-497f-8fa9-84da06ccf567",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[105605, 2731, 124, 2, 61, "Subchapter",ExpressionUUID->"295f97f2-1e70-47ab-ba69-86a11cedaefc",
 InitializationCell->True],
Cell[105732, 2735, 446, 9, 66, "Input",ExpressionUUID->"9a49ff6c-dca5-4b01-b5d3-49c63e903de3",
 InitializationCell->True],
Cell[106181, 2746, 443, 10, 46, "Input",ExpressionUUID->"4079bce3-f459-4e86-82f7-51f07436c067",
 InitializationCell->True],
Cell[106627, 2758, 791, 15, 86, "Input",ExpressionUUID->"d3d1eba2-7bd5-4a55-a6ad-6df626a4256c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[107467, 2779, 123, 4, 64, "Chapter",ExpressionUUID->"9b108a66-cf92-470c-896b-347abf090eec",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[107593, 2785, 287, 10, 66, "Input",ExpressionUUID->"dabd877a-3290-43dd-adeb-ee5e88c6429b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[107929, 2801, 293, 7, 72, "Title",ExpressionUUID->"13fc5de7-8a44-4f3b-98ec-cdf6515005bf",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[108247, 2812, 368, 5, 54, "Subsection",ExpressionUUID->"79db947a-e0f6-43e9-910d-dcacf65de291"],
Cell[108618, 2819, 291, 7, 35, "Text",ExpressionUUID->"4a42b1ce-0b77-4cef-b7cb-4edd34263bf2"]
}, Closed]]
}, Closed]]
}
]
*)

